# This file does a complete set of plots for the following parameters.  It is
# included by gnuplot files in the directories for the different values of tau.

# $0 = tau
# $1 = Delta_p
# $2 = plot number (starts at zero, needed for position)

set label 1 "tau = $0 T_R, Delta_p = $1:" at screen 0.08,0.995-$2*0.17 left font "Helvetica,14"

# Graph displaying the evolution of |c_1|^2:
set xrange [0:5]
set yrange [-0.1:1.1]
set xtics nomirror autofreq
set ytics nomirror (0, 1)
set size 0.65,0.11
set origin 0.045,0.88-$2*0.17
plot "dp$1.snapshot.rcrd" using ($$1/16.):3 notitle with lines linetype 2

# Graph displaying the averaged discrete power spectrum of |c_1|^2:
set xrange [0:4]
set yrange [0:200000]
set xtics nomirror autofreq
set ytics nomirror autofreq
set size 0.4,0.18
set origin 0.645,0.85-$2*0.17
plot "dp$1.powr" using ($$1*16/(2*pi)):2 notitle with lines linetype 1
