# Works with Gnuplot 3.8j or similar

reset
set terminal postscript landscape
set output "ir.ps"

set xrange [0:3000]
set yrange [-3:4]

set multiplot

set title "Intermediate Regime: AKS Guess"
set size 1.0,0.4
set origin 0.0,0.45
plot \
"ir_aks.rcrd" using 1:2 every 25 title "|c_1_tilde|^2" with lines linetype 0, \
"ir_aks.rcrd" using 1:3 every 25 title "|c_1|^2" with lines linetype 2, \
"ir_aks.rcrd" using 1:4 every 25 title "g_1" with lines linetype 1

set title "Intermediate Regime: Minimum Deviation x-Rot Guess"
set size 1.0,0.4
set origin 0.0,0.0
plot \
"ir_min-dev.rcrd" using 1:2 every 25 title "|c_1_tilde|^2" with lines linetype 0, \
"ir_min-dev.rcrd" using 1:3 every 25 title "|c_1|^2" with lines linetype 2, \
"ir_min-dev.rcrd" using 1:4 every 25 title "g_1" with lines linetype 1

unset multiplot
set output
