# See ir.gnuplot for documentation

reset
set terminal postscript landscape
set output "qjr.ps"

set xrange [0:3000]
set yrange [-3:4]

set multiplot

set title "Quantum Jump Regime: AKS Guess"
set size 1.0,0.4
set origin 0.0,0.45
plot \
"qjr_aks.rcrd" using 1:2 every 25 title "|c_1_tilde|^2" with lines linetype 0, \
"qjr_aks.rcrd" using 1:3 every 25 title "|c_1|^2" with lines linetype 2, \
"qjr_aks.rcrd" using 1:4 every 25 title "g_1" with lines linetype 1

set title "Quantum Jump Regime: Minimum Deviation x-Rot Guess"
set size 1.0,0.4
set origin 0.0,0.0
plot \
"qjr_min-dev.rcrd" using 1:2 every 25 title "|c_1_tilde|^2" with lines linetype 0, \
"qjr_min-dev.rcrd" using 1:3 every 25 title "|c_1|^2" with lines linetype 2, \
"qjr_min-dev.rcrd" using 1:4 every 25 title "g_1" with lines linetype 1

unset multiplot
set output
