#include <uniform-tracking_min-dev-proj-guess.hpp>
#include <../test-suite/suite.hpp>
#include <iostream>
#include <cassert>
using namespace std;

/** Tests of different parameter combinations. This also involves interactive
    graphical tests where the user has to visually compare results and say
    whether they are roughly similar. */
static void test1() {
    ostringstream some_stream;

    // Some projective tracking:
    ofstream meas_stream1("test1-1.meas");
    assert(meas_stream1);
    params_tp params1("test1-1.in");
    uniform_tracking_tp ut1(params1, some_stream, meas_stream1);
    ut1.track();

    // Some projective tracking with more recording points so that one sees what
    // happens in between measurements and before tracking starts:
    ofstream meas_stream2("test1-2.meas");
    assert(meas_stream2);
    params_tp params2("test1-2.in");
    uniform_tracking_tp ut2(params2, some_stream, meas_stream2);
    ut2.track();
    
    vector<string> gnuplot_files;
    gnuplot_files.push_back("test1-1.gnuplot");
    gnuplot_files.push_back("test1-2.gnuplot");
    cout << "\n";
    assert_graphical_outputs_roughly_similar(gnuplot_files);
    cout << "\n";
}

int main() {
    vector<test_tp> tests;
    tests.push_back(test1);
    return run_tests(tests, "uniform-tracking_min-dev-proj-guess");
}
