TEMPLATE = app
CONFIG -= qt
#CONFIG += warn_on debug
CONFIG += warn_on release
INIPARSER_DIR = ../3rdparty/iniparser-2.14/src
GMP_DIR = ../3rdparty/gmp-4.1.2
INCLUDEPATH += $${INIPARSER_DIR} $${GMP_DIR}
SOURCES = \
h2.cpp                \
main.cpp              uniform-tracking_const-guess.cpp \
measurement.cpp       uniform-tracking_guess.cpp \
misc.cpp              frequency-tracking.cpp \
mt19937.cpp           uniform-tracking_min-dev-xrot-guess.cpp \
params.cpp            uniform-tracking_min-dev-nser-guess.cpp \
trasim.cpp            uniform-tracking_nser-guess.cpp \
uniform-tracking.cpp  uniform-tracking_aks-guess.cpp \
tracking.cpp          uniform-tracking_min-dev-proj-guess.cpp \
$${INIPARSER_DIR}/iniparser.c $${INIPARSER_DIR}/dictionary.c $${INIPARSER_DIR}/strlib.c
HEADERS = \
h2.hpp                uniform-tracking_const-guess.hpp \
measurement.hpp       uniform-tracking_guess.hpp \
misc.hpp              frequency-tracking.hpp \
mt19937.hpp           uniform-tracking_min-dev-xrot-guess.hpp \
params.hpp            uniform-tracking_min-dev-nser-guess.hpp \
trasim.hpp            uniform-tracking_nser-guess.hpp \
uniform-tracking.hpp  uniform-tracking_aks-guess.hpp \
uniform-tracking_min-dev-proj-guess.hpp mpf.hpp
DESTDIR = ../bin
TARGET = trasim

# Note that, below, some libraries are specified by their full path name in
# order to avoid conflicts with system widely installed libraries.
LIBS += $${GMP_DIR}/.libs/libgmpxx.a $${GMP_DIR}/.libs/libgmp.a -static

linux-g++ {
    QMAKE_CXXFLAGS = 
    QMAKE_CXXFLAGS_RELEASE = -mcpu=pentium4 -march=pentium4 -O3
}

linux-icc {
    QMAKE_CXXFLAGS = 
    QMAKE_CXXFLAGS_DEBUG = -tpp6 -g
#    QMAKE_CXXFLAGS_DEBUG = -O2 -tpp7 -g
#    QMAKE_CXXFLAGS_RELEASE = -O3 -tpp6
    QMAKE_CXXFLAGS_RELEASE = -O3 -tpp7
}
