#include "params.hpp"
#include <iniparser.h>
#include <stdexcept>
#include <string>

using namespace std;

params_tp::
params_tp(const std::string &file_name) 
    : ini_dict(0)
{
    ini_dict = iniparser_load(const_cast<char *>(file_name.c_str()));
    if (ini_dict == 0)
        throw open_file_error_tp(file_name);
}

params_tp::
~params_tp() {
    if (ini_dict != 0)
        iniparser_freedict(ini_dict);
}

template<> string params_tp::
get<string>(const string &key) const {
    char *s = iniparser_getstr(ini_dict, const_cast<char *>(key.c_str()));
    if (s == 0)
        throw get_key_error_tp(key);
    return s;
}

template<> bool params_tp::
get<bool>(const string &key) const {
	string s = get<string>(key);
    switch (s[0]) {
    case 'y': case 'Y': case 't': case 'T': case '1':
        return true;
    case 'n': case 'N': case 'f': case 'F': case '0':
        return false;
    default:
        throw convert_error_tp(s);
    }
}
