#include "uniform-tracking_min-dev-proj-guess.hpp"
#include <stdexcept>

using namespace std;

const string uniform_tracking_tp::min_dev_proj_guess_tp::
sec_name() const { return "minimum-deviation-projective-guess"; }

uniform_tracking_tp::min_dev_proj_guess_tp::
min_dev_proj_guess_tp(params_tp &params, const measurement_tp &meas) : 
    meas_mb(meas), one_mb(0,1)
{
    (void) params;
}

/** Called after a measurement with result \p m. Updates the current guess as follows:
        g_1(m) = <1|M_m|1>
    Also see the description of this class. */
void uniform_tracking_tp::min_dev_proj_guess_tp::
new_outcome(int outcome) {
    guess_mb = real(meas_mb.M()[outcome].expectation_value(one_mb));
}
