#ifndef SUITE_HPP
#define SUITE_HPP

/** \file

    Miscellaneous helper functions, etc. for implementing tests. Note that no
    fancy error handling is done here: Usually assertions are used.

    \author Felix E. Klee (felix.klee@inka.de)
    \date 2003 */

#include <vector>
#include <string>
using namespace std;

/// Needed for the vector of tests passed to \p run_tests().
typedef void (* test_tp)();

int run_tests(const vector<test_tp> &, const string &);

bool query_y_n();

void assert_graphical_outputs_roughly_similar(const vector<string> &);

string getln(string, unsigned int);

void string_to_file(string, const string &);

#endif
