#include <params.hpp>
#include <tracking.hpp>
#include <uniform-tracking.hpp>
#include <../test-suite/suite.hpp>
#include <iostream>
#include <exception>
#include <cassert>
using namespace std;

/** Tests some error messages. Note that uniform_tracking_tp is used to test
    tracking_tp because tracking_tp might be (depending on the current
    implementation) abstract. */
static void test1() {
    // Non orthogonal E_state_0 and E_state_1:
    params_tp params1("test1-1.in");
    try {
        uniform_tracking_tp ut(params1, cout, cout);
        assert(false);
    } catch (const tracking_tp::E_state_j_orthonormality_error_tp &e) {
        assert(true);
    }

    // Non normalized E_state_0:
    params_tp params2("test1-2.in");
    try {
        uniform_tracking_tp ut(params2, cout, cout);
        assert(false);
    } catch (const tracking_tp::E_state_j_orthonormality_error_tp &e) {
        assert(true);
    }

    // Non normalized E_state_1:
    params_tp params3("test1-3.in");
    try {
        uniform_tracking_tp ut(params3, cout, cout);
        assert(false);
    } catch (const tracking_tp::E_state_j_orthonormality_error_tp &e) {
        assert(true);
    }

    // Non normalized psi_init:
    params_tp params4("test1-4.in");
    try {
        uniform_tracking_tp ut(params4, cout, cout);
        assert(false);
    } catch (const tracking_tp::psi_init_normalization_error_tp &e) {
        assert(true);
    }
}

int main() {
    vector<test_tp> tests;
    tests.push_back(test1);
    return run_tests(tests, "tracking");
}
