# Intermediate regime (see Physical Review A 63 052102)

set xrange [0:2250]
set yrange [-2.5:3.5]

set multiplot

set title "test2-1 (Intermediate Regime): Output"
set size 1.0,0.33
set origin 0.0,0.66
plot \
"test2-1.rcrd" using 1:2 every 25 title "|c_1_tilde|^2" with lines, \
"test2-1.rcrd" using 1:3 every 25 title "|c_1|^2" with lines, \
"test2-1.rcrd" using 1:4 every 25 title "g_1" with lines


# Data created previously with trasim and that looked correct when I last looked
# at it. Note that it might look different from the data above when a different
# compiler, computer, etc. is used.

set title "test2-1 (Intermediate Regime): Expected Output"
set size 1.0,0.33
set origin 0.0,0.33
plot \
"test2-1.rcrd-expected" using 1:2 every 25 title "|c_1_tilde|^2" with lines, \
"test2-1.rcrd-expected" using 1:3 every 25 title "|c_1|^2" with lines, \
"test2-1.rcrd-expected" using 1:4 every 25 title "g_1" with lines


# test2-1.cfm_out and test2-1.cfm_out3 is the original data used for Physical
# Review A 63 052102 (I found it in Arturs data in the directory as files
# Our_Papers/Paper1_Figures/INTERMEDIATE/cfm_out*) Note that this data is likely
# to be different from the data in test2-1.rcrd because the programs are very
# different. Also note that the undisturbed curve |c_1_tilde|^2 looks different,
# this might be due to at least two reasons: 1. numerical inaccuracies => U is
# different in both programs, 2. psi_1_tilde is normalized in trasim but maybe
# not in the program that was used to create cfm_out3, 3. use of different
# pseudo random number generators. An indication that reason 2 is correct can be
# seen when looking at the rabi regime where the curves created by Trasim have
# much less phase drift than those generated with that other program.  # But the
# differences certainly need to be tested (maybe in fourier space).

set title "test2-1 (Intermediate Regime): Original Output from PRA 63 052102 (QQQ: check differences with above in Fourier, etc.)"
set xrange [0:300]
set size 1.0,0.33
set origin 0.0,0.0
plot \
"test2-1.cfm_out3" using 4 title "|c_1_tilde|^2" with lines, \
"test2-1.cfm_out" using 4 title "|c_1|^2" with lines, \
"test2-1.cfm_out" using 3 title "g_1" with lines
