(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     92228,       2163]*)
(*NotebookOutlinePosition[     92915,       2188]*)
(*  CellTagsIndexPosition[     92871,       2184]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[{
    RowBox[{
      RowBox[{"facts", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["\[Beta]2", "0"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["\[Beta]2", "1"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", "0"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", "1"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{"const", "\[Element]", "Reals"}], ",", 
            RowBox[{"N", "\[Element]", "Integers"}], ",", 
            RowBox[{"Np", "\[Element]", "Integers"}], ",", 
            RowBox[{"\[Theta]", "\[Element]", "Reals"}], ",", 
            RowBox[{"\[CurlyPhi]", "\[Element]", "Reals"}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"cmplxVars", "=", 
        RowBox[{"{", 
          SubscriptBox["\[Beta]", "i_"], "}"}]}], ";"}]}], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"pNp", "=", 
        RowBox[{"const", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SubscriptBox["\[Alpha]", "0"], 
                SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "+", 
              RowBox[{
                SubscriptBox["\[Alpha]", "1"], 
                SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}]}]}], 
      ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{
        FractionBox["1", "pNp"], 
        RowBox[{"(", 
          RowBox[{
            RowBox[{
              SubscriptBox["\[Alpha]", "0"], 
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  SubscriptBox["\[Beta]", "0"], "]"}], "2"], 
              SuperscriptBox[
                RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "+", 
            RowBox[{"2", 
              SqrtBox[
                RowBox[{
                  SubscriptBox["\[Alpha]", "0"], 
                  SubscriptBox["\[Alpha]", "1"]}]], 
              RowBox[{"Re", "[", 
                RowBox[{
                  SubscriptBox["\[Beta]", "0"], 
                  RowBox[{"Conjugate", "[", 
                    SubscriptBox["\[Beta]", "1"], "]"}], 
                  SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                      RowBox[{"-", "\[ImaginaryI]"}], " ", "\[CurlyPhi]"}]]}],
                 "]"}]}], "+", 
            RowBox[{
              SubscriptBox["\[Alpha]", "1"], 
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  SubscriptBox["\[Beta]", "1"], "]"}], "2"], 
              SuperscriptBox[
                RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "/.", 
        RowBox[{
          RowBox[{"Abs", "[", 
            SubscriptBox["\[Beta]", "i_"], "]"}], "\[Rule]", 
          SubscriptBox["\[Beta]2", "i"]}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{"c12P", "=", "%"}]}], "Input"],

Cell[BoxData[
    FractionBox[
      RowBox[{
        RowBox[{"2", " ", 
          RowBox[{"Re", "[", 
            RowBox[{
              SuperscriptBox["\[ExponentialE]", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], " ", "\[CurlyPhi]"}]], " ", 
              
              RowBox[{"Conjugate", "[", 
                SubscriptBox["\[Beta]", "1"], "]"}], " ", 
              SubscriptBox["\[Beta]", "0"]}], "]"}], " ", 
          SqrtBox[
            RowBox[{
              SubscriptBox["\[Alpha]", "0"], " ", 
              SubscriptBox["\[Alpha]", "1"]}]]}], "+", 
        RowBox[{
          SuperscriptBox[
            RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
          SubscriptBox["\[Alpha]", "0"], " ", 
          SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
        RowBox[{
          SuperscriptBox[
            RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
          SubscriptBox["\[Alpha]", "1"], " ", 
          SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], 
      RowBox[{"const", " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{
              SuperscriptBox[
                RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
              SubscriptBox["\[Alpha]", "0"]}], "+", 
            RowBox[{
              SuperscriptBox[
                RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
              SubscriptBox["\[Alpha]", "1"]}]}], ")"}]}]]], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{"ComplexExpand", "[", 
        RowBox[{"c12P", ",", "cmplxVars"}], "]"}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"c12P", "=", 
        RowBox[{
          RowBox[{"Simplify", "[", 
            RowBox[{"%", ",", "facts"}], "]"}], "/.", 
          RowBox[{
            RowBox[{"Arg", "[", 
              SubscriptBox["\[Alpha]", "i_"], "]"}], "\[Rule]", "0"}]}]}], 
      ";"}]}], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"vNpPPre", "=", 
        RowBox[{"Integrate", "[", 
          RowBox[{
            RowBox[{"pNp", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{"gNpP", "-", "c12P"}], ")"}], "2"]}], ",", 
            RowBox[{"{", 
              RowBox[{"\[CurlyPhi]", ",", "0", ",", 
                RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"vNpPPre", "/.", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              RowBox[{"Arg", "[", 
                SubscriptBox["\[Alpha]", "i_"], "]"}], "\[Rule]", "0"}], ",", 
            
            RowBox[{
              RowBox[{"Arg", "[", 
                RowBox[{
                  SubscriptBox["\[Alpha]", "i_"], 
                  SubscriptBox["\[Alpha]", "j_"]}], "]"}], "\[Rule]", "0"}]}],
           "}"}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{"vNpPPre", "=", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"%", ",", "facts"}], "]"}], "/.", 
        RowBox[{
          RowBox[{"Abs", "[", 
            SubscriptBox["\[Beta]", "i_"], "]"}], "\[Rule]", 
          SubscriptBox["\[Beta]2", "i"]}]}]}]}], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"(", 
        RowBox[{"\[Pi]", " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{"2", " ", 
                SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], "4"], " ", 
                SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "const"}], " ", "gNpP"}], "+", 
                      SubsuperscriptBox["\[Beta]2", "0", "2"]}], ")"}], 
                  "2"]}], "+", 
              RowBox[{"2", " ", 
                SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "4"], " ", 
                SubsuperscriptBox["\[Alpha]", "1", "2"], " ", 
                SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "const"}], " ", "gNpP"}], "+", 
                      SubsuperscriptBox["\[Beta]2", "1", "2"]}], ")"}], 
                  "2"]}], "+", 
              RowBox[{
                SubscriptBox["\[Alpha]", "0"], " ", 
                SubscriptBox["\[Alpha]", "1"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"4", " ", 
                      SubsuperscriptBox["\[Beta]2", "0", "2"], " ", 
                      SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                    RowBox[{
                      SuperscriptBox[
                        RowBox[{"Sin", "[", 
                          RowBox[{"2", " ", "\[Theta]"}], "]"}], "2"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"const", " ", "gNpP"}], "-", 
                          SubsuperscriptBox["\[Beta]2", "0", "2"]}], ")"}], 
                      " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"const", " ", "gNpP"}], "-", 
                          SubsuperscriptBox["\[Beta]2", "1", "2"]}], 
                        ")"}]}]}], ")"}]}]}], ")"}]}], ")"}], "/", 
      RowBox[{"(", 
        RowBox[{"const", " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
                SubscriptBox["\[Alpha]", "0"]}], "+", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
                SubscriptBox["\[Alpha]", "1"]}]}], ")"}]}], ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"Integrate", "[", 
        RowBox[{"vNpPPre", ",", 
          RowBox[{"{", 
            RowBox[{"\[Theta]", ",", "0", ",", 
              RowBox[{"\[Pi]", "/", "2"}]}], "}"}], ",", 
          RowBox[{"Assumptions", "\[Rule]", "facts"}]}], "]"}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{"vNpP", "=", 
      RowBox[{"Simplify", "[", 
        RowBox[{"%", ",", "facts"}], "]"}]}]}], "Input"],

Cell[BoxData[
    RowBox[{
      FractionBox["1", 
        RowBox[{"2", " ", "const", " ", 
          SuperscriptBox[
            RowBox[{"(", 
              RowBox[{
                SqrtBox[
                  SubscriptBox["\[Alpha]", "0"]], "+", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", "1"]]}], ")"}], "2"]}]], 
      RowBox[{"(", 
        RowBox[{
          SuperscriptBox["\[Pi]", "2"], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "const"}], " ", "gNpP"}], "+", 
                      SubsuperscriptBox["\[Beta]2", "0", "2"]}], ")"}], 
                  "2"]}], "+", 
              RowBox[{
                SubsuperscriptBox["\[Alpha]", "1", "2"], " ", 
                SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "const"}], " ", "gNpP"}], "+", 
                      SubsuperscriptBox["\[Beta]2", "1", "2"]}], ")"}], 
                  "2"]}], "+", 
              RowBox[{"2", " ", 
                SubscriptBox["\[Alpha]", "0"], " ", 
                SubscriptBox["\[Alpha]", "1"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"const", " ", "gNpP", " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"const", " ", "gNpP"}], "-", 
                          SubsuperscriptBox["\[Beta]2", "1", "2"]}], ")"}]}], 
                    "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Beta]2", "0", "2"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            RowBox[{"-", "const"}], " ", "gNpP"}], "+", 
                          RowBox[{"5", " ", 
                            SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], 
                        ")"}]}]}], ")"}]}], "+", 
              RowBox[{"2", " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["const", "2"], " ", 
                      SuperscriptBox["gNpP", "2"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SqrtBox[
                            RowBox[{
                              SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                              SubscriptBox["\[Alpha]", "1"]}]], "+", 
                          SqrtBox[
                            RowBox[{
                              SubscriptBox["\[Alpha]", "0"], " ", 
                              SubsuperscriptBox["\[Alpha]", "1", "3"]}]]}], 
                        ")"}]}], "+", 
                    RowBox[{
                      SqrtBox[
                        RowBox[{
                          SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                          SubscriptBox["\[Alpha]", "1"]}]], " ", 
                      SubsuperscriptBox["\[Beta]2", "0", "4"]}], "-", 
                    RowBox[{"2", " ", "const", " ", "gNpP", " ", 
                      SqrtBox[
                        RowBox[{
                          SubscriptBox["\[Alpha]", "0"], " ", 
                          SubsuperscriptBox["\[Alpha]", "1", "3"]}]], " ", 
                      SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                    RowBox[{
                      SqrtBox[
                        RowBox[{
                          SubscriptBox["\[Alpha]", "0"], " ", 
                          SubsuperscriptBox["\[Alpha]", "1", "3"]}]], " ", 
                      SubsuperscriptBox["\[Beta]2", "1", "4"]}], "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Beta]2", "0", "2"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            RowBox[{"-", "2"}], " ", "const", " ", "gNpP", 
                            " ", 
                            SqrtBox[
                              RowBox[{
                                SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                                
                                SubscriptBox["\[Alpha]", "1"]}]]}], "+", 
                          RowBox[{"2", " ", 
                            RowBox[{"(", 
                              RowBox[{
                                SqrtBox[
                                  RowBox[{
                                    SubsuperscriptBox["\[Alpha]", "0", "3"], 
                                    " ", 
                                    SubscriptBox["\[Alpha]", "1"]}]], "+", 
                                SqrtBox[
                                  RowBox[{
                                    SubscriptBox["\[Alpha]", "0"], " ", 
                                    
                                    SubsuperscriptBox["\[Alpha]", "1", 
                                      "3"]}]]}], ")"}], " ", 
                            SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], 
                        ")"}]}]}], ")"}]}]}], ")"}]}], ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{
        SubscriptBox["\[PartialD]", "gNpP"], "vNpP"}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{"dvNpP", "=", 
      RowBox[{"FullSimplify", "[", 
        RowBox[{"%", ",", "facts"}], "]"}]}]}], "Input"],

Cell[BoxData[
    RowBox[{
      FractionBox["1", 
        SuperscriptBox[
          RowBox[{"(", 
            RowBox[{
              SqrtBox[
                SubscriptBox["\[Alpha]", "0"]], "+", 
              SqrtBox[
                SubscriptBox["\[Alpha]", "1"]]}], ")"}], "2"]], 
      RowBox[{"(", 
        RowBox[{
          SuperscriptBox["\[Pi]", "2"], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{"2", " ", 
                SqrtBox[
                  RowBox[{
                    SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                    SubscriptBox["\[Alpha]", "1"]}]], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"const", " ", "gNpP"}], "-", 
                    SubsuperscriptBox["\[Beta]2", "0", "2"]}], ")"}]}], "+", 
              RowBox[{"2", " ", 
                SqrtBox[
                  RowBox[{
                    SubscriptBox["\[Alpha]", "0"], " ", 
                    SubsuperscriptBox["\[Alpha]", "1", "3"]}]], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"const", " ", "gNpP"}], "-", 
                    SubsuperscriptBox["\[Beta]2", "1", "2"]}], ")"}]}], "+", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    SubscriptBox["\[Alpha]", "0"], "+", 
                    SubscriptBox["\[Alpha]", "1"]}], ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SubscriptBox["\[Alpha]", "0"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"const", " ", "gNpP"}], "-", 
                          SubsuperscriptBox["\[Beta]2", "0", "2"]}], ")"}]}], 
                    "+", 
                    RowBox[{
                      SubscriptBox["\[Alpha]", "1"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"const", " ", "gNpP"}], "-", 
                          SubsuperscriptBox["\[Beta]2", "1", "2"]}], 
                        ")"}]}]}], ")"}]}]}], ")"}]}], ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"Solve", "[", 
        RowBox[{
          RowBox[{"dvNpP", "\[Equal]", "0"}], ",", "gNpP"}], "]"}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{"FullSimplify", "[", 
      RowBox[{"%", ",", "facts"}], "]"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"gNpPBest", "=", 
        RowBox[{"gNpP", "/.", 
          RowBox[{"First", "[", "%", "]"}]}]}], ";"}]}], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"{", 
        RowBox[{"gNpP", "\[Rule]", 
          FractionBox[
            RowBox[{
              RowBox[{"2", " ", 
                SqrtBox[
                  RowBox[{
                    SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                    SubscriptBox["\[Alpha]", "1"]}]], " ", 
                SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
              RowBox[{
                SubscriptBox["\[Alpha]", "0"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    SubscriptBox["\[Alpha]", "0"], "+", 
                    SubscriptBox["\[Alpha]", "1"]}], ")"}], " ", 
                SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
              RowBox[{"2", " ", 
                SqrtBox[
                  RowBox[{
                    SubscriptBox["\[Alpha]", "0"], " ", 
                    SubsuperscriptBox["\[Alpha]", "1", "3"]}]], " ", 
                SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
              RowBox[{
                SubscriptBox["\[Alpha]", "1"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    SubscriptBox["\[Alpha]", "0"], "+", 
                    SubscriptBox["\[Alpha]", "1"]}], ")"}], " ", 
                SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], 
            RowBox[{"const", " ", 
              RowBox[{"(", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"(", 
                      RowBox[{
                        SubscriptBox["\[Alpha]", "0"], "+", 
                        SubscriptBox["\[Alpha]", "1"]}], ")"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                      RowBox[{
                        SqrtBox[
                          RowBox[{
                            SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                            SubscriptBox["\[Alpha]", "1"]}]], "+", 
                        SqrtBox[
                          RowBox[{
                            SubscriptBox["\[Alpha]", "0"], " ", 
                            SubsuperscriptBox["\[Alpha]", "1", "3"]}]]}], 
                      ")"}]}]}], ")"}]}]]}], "}"}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"vNpP", "/.", 
        RowBox[{"gNpP", "\[Rule]", "gNpPBest"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"Simplify", "[", 
        RowBox[{"%", ",", "facts"}], "]"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{"vNpPBest", "=", "%"}]}], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"(", 
        RowBox[{
          SuperscriptBox["\[Pi]", "2"], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{"8", " ", 
                SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                SubscriptBox["\[Alpha]", "1"], " ", 
                SubsuperscriptBox["\[Beta]2", "0", "2"], " ", 
                SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
              RowBox[{"8", " ", 
                SubscriptBox["\[Alpha]", "0"], " ", 
                SubsuperscriptBox["\[Alpha]", "1", "3"], " ", 
                SubsuperscriptBox["\[Beta]2", "0", "2"], " ", 
                SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
              RowBox[{"2", " ", 
                RowBox[{"(", 
                  RowBox[{
                    SqrtBox[
                      RowBox[{
                        SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                        SubscriptBox["\[Alpha]", "1"]}]], "+", 
                    SqrtBox[
                      RowBox[{
                        SubscriptBox["\[Alpha]", "0"], " ", 
                        SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], ")"}], 
                " ", 
                SubsuperscriptBox["\[Beta]2", "0", "2"], " ", 
                SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
              RowBox[{"2", " ", 
                SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                SubsuperscriptBox["\[Alpha]", "1", "2"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    SubsuperscriptBox["\[Beta]2", "0", "4"], "+", 
                    RowBox[{"6", " ", 
                      SubsuperscriptBox["\[Beta]2", "0", "2"], " ", 
                      SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                    SubsuperscriptBox["\[Beta]2", "1", "4"]}], ")"}]}], "+", 
              RowBox[{
                SubsuperscriptBox["\[Alpha]", "0", 
                  RowBox[{"5", "/", "2"}]], " ", 
                SubsuperscriptBox["\[Alpha]", "1", 
                  RowBox[{"3", "/", "2"}]], " ", 
                RowBox[{"(", 
                  RowBox[{
                    SubsuperscriptBox["\[Beta]2", "0", "4"], "+", 
                    RowBox[{"12", " ", 
                      SubsuperscriptBox["\[Beta]2", "0", "2"], " ", 
                      SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                    SubsuperscriptBox["\[Beta]2", "1", "4"]}], ")"}]}], "+", 
              RowBox[{
                SubsuperscriptBox["\[Alpha]", "0", 
                  RowBox[{"3", "/", "2"}]], " ", 
                SubsuperscriptBox["\[Alpha]", "1", 
                  RowBox[{"5", "/", "2"}]], " ", 
                RowBox[{"(", 
                  RowBox[{
                    SubsuperscriptBox["\[Beta]2", "0", "4"], "+", 
                    RowBox[{"12", " ", 
                      SubsuperscriptBox["\[Beta]2", "0", "2"], " ", 
                      SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                    SubsuperscriptBox["\[Beta]2", "1", "4"]}], ")"}]}]}], 
            ")"}]}], ")"}], "/", 
      RowBox[{"(", 
        RowBox[{"const", " ", 
          SuperscriptBox[
            RowBox[{"(", 
              RowBox[{
                SqrtBox[
                  SubscriptBox["\[Alpha]", "0"]], "+", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", "1"]]}], ")"}], "2"], " ", 
          RowBox[{"(", 
            RowBox[{
              SubsuperscriptBox["\[Alpha]", "0", "2"], "+", 
              RowBox[{"2", " ", 
                SubscriptBox["\[Alpha]", "0"], " ", 
                SubscriptBox["\[Alpha]", "1"]}], "+", 
              SubsuperscriptBox["\[Alpha]", "1", "2"], "+", 
              RowBox[{"2", " ", 
                RowBox[{"(", 
                  RowBox[{
                    SqrtBox[
                      RowBox[{
                        SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                        SubscriptBox["\[Alpha]", "1"]}]], "+", 
                    SqrtBox[
                      RowBox[{
                        SubscriptBox["\[Alpha]", "0"], " ", 
                        SubsuperscriptBox["\[Alpha]", "1", "3"]}]]}], 
                  ")"}]}]}], ")"}]}], ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"gradvNpPBest", "=", 
      RowBox[{"Simplify", "[", 
        RowBox[{
          RowBox[{"{", 
            RowBox[{
              RowBox[{
                SubscriptBox["\[PartialD]", 
                  SubscriptBox["\[Beta]2", "0"]], "vNpPBest"}], ",", 
              RowBox[{
                SubscriptBox["\[PartialD]", 
                  SubscriptBox["\[Beta]2", "1"]], "vNpPBest"}]}], "}"}], ",", 
          "facts"}], "]"}]}]], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{
          RowBox[{"(", 
            RowBox[{"4", " ", 
              SuperscriptBox["\[Pi]", "2"], " ", 
              SubscriptBox["\[Beta]2", "0"], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"4", " ", 
                    SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                    SubscriptBox["\[Alpha]", "1"], " ", 
                    SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                  RowBox[{"4", " ", 
                    SubscriptBox["\[Alpha]", "0"], " ", 
                    SubsuperscriptBox["\[Alpha]", "1", "3"], " ", 
                    SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        SqrtBox[
                          RowBox[{
                            SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                            SubscriptBox["\[Alpha]", "1"]}]], "+", 
                        SqrtBox[
                          RowBox[{
                            SubscriptBox["\[Alpha]", "0"], " ", 
                            SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], 
                      ")"}], " ", 
                    SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                  RowBox[{"2", " ", 
                    SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                    SubsuperscriptBox["\[Alpha]", "1", "2"], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        SubsuperscriptBox["\[Beta]2", "0", "2"], "+", 
                        RowBox[{"3", " ", 
                          SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], 
                      ")"}]}], "+", 
                  RowBox[{
                    SubsuperscriptBox["\[Alpha]", "0", 
                      RowBox[{"5", "/", "2"}]], " ", 
                    SubsuperscriptBox["\[Alpha]", "1", 
                      RowBox[{"3", "/", "2"}]], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        SubsuperscriptBox["\[Beta]2", "0", "2"], "+", 
                        RowBox[{"6", " ", 
                          SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], 
                      ")"}]}], "+", 
                  RowBox[{
                    SubsuperscriptBox["\[Alpha]", "0", 
                      RowBox[{"3", "/", "2"}]], " ", 
                    SubsuperscriptBox["\[Alpha]", "1", 
                      RowBox[{"5", "/", "2"}]], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        SubsuperscriptBox["\[Beta]2", "0", "2"], "+", 
                        RowBox[{"6", " ", 
                          SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], 
                      ")"}]}]}], ")"}]}], ")"}], "/", 
          RowBox[{"(", 
            RowBox[{"const", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    SqrtBox[
                      SubscriptBox["\[Alpha]", "0"]], "+", 
                    SqrtBox[
                      SubscriptBox["\[Alpha]", "1"]]}], ")"}], "2"], " ", 
              RowBox[{"(", 
                RowBox[{
                  SubsuperscriptBox["\[Alpha]", "0", "2"], "+", 
                  RowBox[{"2", " ", 
                    SubscriptBox["\[Alpha]", "0"], " ", 
                    SubscriptBox["\[Alpha]", "1"]}], "+", 
                  SubsuperscriptBox["\[Alpha]", "1", "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                      RowBox[{
                        SqrtBox[
                          RowBox[{
                            SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                            SubscriptBox["\[Alpha]", "1"]}]], "+", 
                        SqrtBox[
                          RowBox[{
                            SubscriptBox["\[Alpha]", "0"], " ", 
                            SubsuperscriptBox["\[Alpha]", "1", "3"]}]]}], 
                      ")"}]}]}], ")"}]}], ")"}]}], ",", 
        RowBox[{
          RowBox[{"(", 
            RowBox[{"4", " ", 
              SuperscriptBox["\[Pi]", "2"], " ", 
              SubscriptBox["\[Beta]2", "1"], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"4", " ", 
                    SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                    SubscriptBox["\[Alpha]", "1"], " ", 
                    SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                  RowBox[{"4", " ", 
                    SubscriptBox["\[Alpha]", "0"], " ", 
                    SubsuperscriptBox["\[Alpha]", "1", "3"], " ", 
                    SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        SqrtBox[
                          RowBox[{
                            SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                            SubscriptBox["\[Alpha]", "1"]}]], "+", 
                        SqrtBox[
                          RowBox[{
                            SubscriptBox["\[Alpha]", "0"], " ", 
                            SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], 
                      ")"}], " ", 
                    SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                  RowBox[{"2", " ", 
                    SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                    SubsuperscriptBox["\[Alpha]", "1", "2"], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"3", " ", 
                          SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                        SubsuperscriptBox["\[Beta]2", "1", "2"]}], ")"}]}], 
                  "+", 
                  RowBox[{
                    SubsuperscriptBox["\[Alpha]", "0", 
                      RowBox[{"5", "/", "2"}]], " ", 
                    SubsuperscriptBox["\[Alpha]", "1", 
                      RowBox[{"3", "/", "2"}]], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"6", " ", 
                          SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                        SubsuperscriptBox["\[Beta]2", "1", "2"]}], ")"}]}], 
                  "+", 
                  RowBox[{
                    SubsuperscriptBox["\[Alpha]", "0", 
                      RowBox[{"3", "/", "2"}]], " ", 
                    SubsuperscriptBox["\[Alpha]", "1", 
                      RowBox[{"5", "/", "2"}]], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"6", " ", 
                          SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                        SubsuperscriptBox["\[Beta]2", "1", "2"]}], ")"}]}]}], 
                ")"}]}], ")"}], "/", 
          RowBox[{"(", 
            RowBox[{"const", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    SqrtBox[
                      SubscriptBox["\[Alpha]", "0"]], "+", 
                    SqrtBox[
                      SubscriptBox["\[Alpha]", "1"]]}], ")"}], "2"], " ", 
              RowBox[{"(", 
                RowBox[{
                  SubsuperscriptBox["\[Alpha]", "0", "2"], "+", 
                  RowBox[{"2", " ", 
                    SubscriptBox["\[Alpha]", "0"], " ", 
                    SubscriptBox["\[Alpha]", "1"]}], "+", 
                  SubsuperscriptBox["\[Alpha]", "1", "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                      RowBox[{
                        SqrtBox[
                          RowBox[{
                            SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                            SubscriptBox["\[Alpha]", "1"]}]], "+", 
                        SqrtBox[
                          RowBox[{
                            SubscriptBox["\[Alpha]", "0"], " ", 
                            SubsuperscriptBox["\[Alpha]", "1", "3"]}]]}], 
                      ")"}]}]}], ")"}]}], ")"}]}]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{
          RowBox[{"#", "\[Equal]", "0"}], "&"}], "/@", "gradvNpPBest"}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "/.", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["\[Beta]2", "0"], "\[Rule]", "1"}], ",", 
            RowBox[{
              SubscriptBox["\[Beta]2", "1"], "\[Rule]", "0"}]}], "}"}]}], "//",
       
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{
          FractionBox[
            SuperscriptBox[
              RowBox[{"(", 
                RowBox[{
                  SubscriptBox["\[Alpha]", "0"], " ", 
                  SubscriptBox["\[Alpha]", "1"]}], ")"}], 
              RowBox[{"3", "/", "2"}]], 
            RowBox[{"const", " ", 
              RowBox[{"(", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"(", 
                      RowBox[{
                        SubscriptBox["\[Alpha]", "0"], "+", 
                        SubscriptBox["\[Alpha]", "1"]}], ")"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                      RowBox[{
                        SqrtBox[
                          RowBox[{
                            SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                            SubscriptBox["\[Alpha]", "1"]}]], "+", 
                        SqrtBox[
                          RowBox[{
                            SubscriptBox["\[Alpha]", "0"], " ", 
                            SubsuperscriptBox["\[Alpha]", "1", "3"]}]]}], 
                      ")"}]}]}], ")"}]}]], "==", "0"}], ",", "True"}], 
      "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"#", "\[Equal]", "0"}], "&"}], "/@", 
      "gradvNpPBest"}], "\[IndentingNewLine]", 
    RowBox[{"Solve", "[", 
      RowBox[{"%", ",", 
        RowBox[{"{", 
          RowBox[{
            SubscriptBox["\[Beta]2", "0"], ",", 
            SubscriptBox["\[Beta]2", "1"]}], "}"}]}], "]"}]}], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{
          RowBox[{
            RowBox[{"(", 
              RowBox[{"4", " ", 
                SuperscriptBox["\[Pi]", "2"], " ", 
                SubscriptBox["\[Beta]2", "0"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"4", " ", 
                      SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                      SubscriptBox["\[Alpha]", "1"], " ", 
                      SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                    RowBox[{"4", " ", 
                      SubscriptBox["\[Alpha]", "0"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "3"], " ", 
                      SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                    RowBox[{
                      RowBox[{"(", 
                        RowBox[{
                          SqrtBox[
                            RowBox[{
                              SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                              SubscriptBox["\[Alpha]", "1"]}]], "+", 
                          SqrtBox[
                            RowBox[{
                              SubscriptBox["\[Alpha]", "0"], " ", 
                              SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], 
                        ")"}], " ", 
                      SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "2"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SubsuperscriptBox["\[Beta]2", "0", "2"], "+", 
                          RowBox[{"3", " ", 
                            SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], 
                        ")"}]}], "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", 
                        RowBox[{"5", "/", "2"}]], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", 
                        RowBox[{"3", "/", "2"}]], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SubsuperscriptBox["\[Beta]2", "0", "2"], "+", 
                          RowBox[{"6", " ", 
                            SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], 
                        ")"}]}], "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", 
                        RowBox[{"3", "/", "2"}]], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", 
                        RowBox[{"5", "/", "2"}]], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SubsuperscriptBox["\[Beta]2", "0", "2"], "+", 
                          RowBox[{"6", " ", 
                            SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], 
                        ")"}]}]}], ")"}]}], ")"}], "/", 
            RowBox[{"(", 
              RowBox[{"const", " ", 
                SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                      SqrtBox[
                        SubscriptBox["\[Alpha]", "0"]], "+", 
                      SqrtBox[
                        SubscriptBox["\[Alpha]", "1"]]}], ")"}], "2"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    SubsuperscriptBox["\[Alpha]", "0", "2"], "+", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Alpha]", "0"], " ", 
                      SubscriptBox["\[Alpha]", "1"]}], "+", 
                    SubsuperscriptBox["\[Alpha]", "1", "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SqrtBox[
                            RowBox[{
                              SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                              SubscriptBox["\[Alpha]", "1"]}]], "+", 
                          SqrtBox[
                            RowBox[{
                              SubscriptBox["\[Alpha]", "0"], " ", 
                              SubsuperscriptBox["\[Alpha]", "1", "3"]}]]}], 
                        ")"}]}]}], ")"}]}], ")"}]}], "==", "0"}], ",", 
        RowBox[{
          RowBox[{
            RowBox[{"(", 
              RowBox[{"4", " ", 
                SuperscriptBox["\[Pi]", "2"], " ", 
                SubscriptBox["\[Beta]2", "1"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"4", " ", 
                      SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                      SubscriptBox["\[Alpha]", "1"], " ", 
                      SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                    RowBox[{"4", " ", 
                      SubscriptBox["\[Alpha]", "0"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "3"], " ", 
                      SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                    RowBox[{
                      RowBox[{"(", 
                        RowBox[{
                          SqrtBox[
                            RowBox[{
                              SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                              SubscriptBox["\[Alpha]", "1"]}]], "+", 
                          SqrtBox[
                            RowBox[{
                              SubscriptBox["\[Alpha]", "0"], " ", 
                              SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], 
                        ")"}], " ", 
                      SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "2"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"3", " ", 
                            SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                          SubsuperscriptBox["\[Beta]2", "1", "2"]}], ")"}]}], 
                    "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", 
                        RowBox[{"5", "/", "2"}]], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", 
                        RowBox[{"3", "/", "2"}]], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"6", " ", 
                            SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                          SubsuperscriptBox["\[Beta]2", "1", "2"]}], ")"}]}], 
                    "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", 
                        RowBox[{"3", "/", "2"}]], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", 
                        RowBox[{"5", "/", "2"}]], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"6", " ", 
                            SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                          SubsuperscriptBox["\[Beta]2", "1", "2"]}], 
                        ")"}]}]}], ")"}]}], ")"}], "/", 
            RowBox[{"(", 
              RowBox[{"const", " ", 
                SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                      SqrtBox[
                        SubscriptBox["\[Alpha]", "0"]], "+", 
                      SqrtBox[
                        SubscriptBox["\[Alpha]", "1"]]}], ")"}], "2"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    SubsuperscriptBox["\[Alpha]", "0", "2"], "+", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Alpha]", "0"], " ", 
                      SubscriptBox["\[Alpha]", "1"]}], "+", 
                    SubsuperscriptBox["\[Alpha]", "1", "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SqrtBox[
                            RowBox[{
                              SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                              SubscriptBox["\[Alpha]", "1"]}]], "+", 
                          SqrtBox[
                            RowBox[{
                              SubscriptBox["\[Alpha]", "0"], " ", 
                              SubsuperscriptBox["\[Alpha]", "1", "3"]}]]}], 
                        ")"}]}]}], ")"}]}], ")"}]}], "==", "0"}]}], 
      "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{"FullSimplify", "[", 
      RowBox[{
        RowBox[{"(", 
          RowBox[{"4", " ", 
            SuperscriptBox["\[Pi]", "2"], " ", 
            SubscriptBox["\[Beta]2", "0"], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{"4", " ", 
                  SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                  SubscriptBox["\[Alpha]", "1"], " ", 
                  SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                RowBox[{"4", " ", 
                  SubscriptBox["\[Alpha]", "0"], " ", 
                  SubsuperscriptBox["\[Alpha]", "1", "3"], " ", 
                  SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      SqrtBox[
                        RowBox[{
                          SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                          SubscriptBox["\[Alpha]", "1"]}]], "+", 
                      SqrtBox[
                        RowBox[{
                          SubscriptBox["\[Alpha]", "0"], " ", 
                          SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], ")"}],
                   " ", 
                  SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                RowBox[{"2", " ", 
                  SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                  SubsuperscriptBox["\[Alpha]", "1", "2"], " ", 
                  RowBox[{"(", 
                    RowBox[{
                      SubsuperscriptBox["\[Beta]2", "0", "2"], "+", 
                      RowBox[{"3", " ", 
                        SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], ")"}]}], 
                "+", 
                RowBox[{
                  SubsuperscriptBox["\[Alpha]", "0", 
                    RowBox[{"5", "/", "2"}]], " ", 
                  SubsuperscriptBox["\[Alpha]", "1", 
                    RowBox[{"3", "/", "2"}]], " ", 
                  RowBox[{"(", 
                    RowBox[{
                      SubsuperscriptBox["\[Beta]2", "0", "2"], "+", 
                      RowBox[{"6", " ", 
                        SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], ")"}]}], 
                "+", 
                RowBox[{
                  SubsuperscriptBox["\[Alpha]", "0", 
                    RowBox[{"3", "/", "2"}]], " ", 
                  SubsuperscriptBox["\[Alpha]", "1", 
                    RowBox[{"5", "/", "2"}]], " ", 
                  RowBox[{"(", 
                    RowBox[{
                      SubsuperscriptBox["\[Beta]2", "0", "2"], "+", 
                      RowBox[{"6", " ", 
                        SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], 
                    ")"}]}]}], ")"}]}], ")"}], ",", "facts"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"(", 
      RowBox[{"4", " ", 
        SuperscriptBox["\[Pi]", "2"], " ", 
        SubscriptBox["\[Beta]2", "1"], " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{"4", " ", 
              SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
              SubscriptBox["\[Alpha]", "1"], " ", 
              SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
            RowBox[{"4", " ", 
              SubscriptBox["\[Alpha]", "0"], " ", 
              SubsuperscriptBox["\[Alpha]", "1", "3"], " ", 
              SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{
                  SqrtBox[
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                      SubscriptBox["\[Alpha]", "1"]}]], "+", 
                  SqrtBox[
                    RowBox[{
                      SubscriptBox["\[Alpha]", "0"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], ")"}], 
              " ", 
              SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
            RowBox[{"2", " ", 
              SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
              SubsuperscriptBox["\[Alpha]", "1", "2"], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"3", " ", 
                    SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                  SubsuperscriptBox["\[Beta]2", "1", "2"]}], ")"}]}], "+", 
            RowBox[{
              SubsuperscriptBox["\[Alpha]", "0", 
                RowBox[{"5", "/", "2"}]], " ", 
              SubsuperscriptBox["\[Alpha]", "1", 
                RowBox[{"3", "/", "2"}]], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"6", " ", 
                    SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                  SubsuperscriptBox["\[Beta]2", "1", "2"]}], ")"}]}], "+", 
            RowBox[{
              SubsuperscriptBox["\[Alpha]", "0", 
                RowBox[{"3", "/", "2"}]], " ", 
              SubsuperscriptBox["\[Alpha]", "1", 
                RowBox[{"5", "/", "2"}]], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"6", " ", 
                    SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                  SubsuperscriptBox["\[Beta]2", "1", "2"]}], ")"}]}]}], 
          ")"}]}], ")"}]], "Input"],

Cell[BoxData["$Aborted"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Solve", "[", 
      RowBox[{
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              RowBox[{
                SubscriptBox["\[Beta]2", "0"], 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"4", " ", 
                      SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                      SubscriptBox["\[Alpha]", "1"], " ", 
                      SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                    RowBox[{"4", " ", 
                      SubscriptBox["\[Alpha]", "0"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "3"], " ", 
                      SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                    RowBox[{
                      RowBox[{"(", 
                        RowBox[{
                          SqrtBox[
                            RowBox[{
                              SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                              SubscriptBox["\[Alpha]", "1"]}]], "+", 
                          SqrtBox[
                            RowBox[{
                              SubscriptBox["\[Alpha]", "0"], " ", 
                              SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], 
                        ")"}], " ", 
                      SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "2"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SubsuperscriptBox["\[Beta]2", "0", "2"], "+", 
                          RowBox[{"3", " ", 
                            SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], 
                        ")"}]}], "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", 
                        RowBox[{"5", "/", "2"}]], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", 
                        RowBox[{"3", "/", "2"}]], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SubsuperscriptBox["\[Beta]2", "0", "2"], "+", 
                          RowBox[{"6", " ", 
                            SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], 
                        ")"}]}], "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", 
                        RowBox[{"3", "/", "2"}]], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", 
                        RowBox[{"5", "/", "2"}]], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SubsuperscriptBox["\[Beta]2", "0", "2"], "+", 
                          RowBox[{"6", " ", 
                            SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], 
                        ")"}]}]}], ")"}]}], "\[Equal]", "0"}], ",", 
            "\[IndentingNewLine]", " ", 
            RowBox[{
              RowBox[{
                SubscriptBox["\[Beta]2", "1"], 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"4", " ", 
                      SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                      SubscriptBox["\[Alpha]", "1"], " ", 
                      SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                    RowBox[{"4", " ", 
                      SubscriptBox["\[Alpha]", "0"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "3"], " ", 
                      SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                    RowBox[{
                      RowBox[{"(", 
                        RowBox[{
                          SqrtBox[
                            RowBox[{
                              SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                              SubscriptBox["\[Alpha]", "1"]}]], "+", 
                          SqrtBox[
                            RowBox[{
                              SubscriptBox["\[Alpha]", "0"], " ", 
                              SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], 
                        ")"}], " ", 
                      SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "2"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"3", " ", 
                            SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                          SubsuperscriptBox["\[Beta]2", "1", "2"]}], ")"}]}], 
                    "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", 
                        RowBox[{"5", "/", "2"}]], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", 
                        RowBox[{"3", "/", "2"}]], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"6", " ", 
                            SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                          SubsuperscriptBox["\[Beta]2", "1", "2"]}], ")"}]}], 
                    "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", 
                        RowBox[{"3", "/", "2"}]], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", 
                        RowBox[{"5", "/", "2"}]], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"6", " ", 
                            SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                          SubsuperscriptBox["\[Beta]2", "1", "2"]}], 
                        ")"}]}]}], ")"}]}], "\[Equal]", "0"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
          RowBox[{
            SubscriptBox["\[Beta]2", "0"], ",", 
            SubscriptBox["\[Beta]2", "1"]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData["$Aborted"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Solve", "[", "\[IndentingNewLine]", 
      RowBox[{
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              RowBox[{
                SubscriptBox["\[Beta]2", "0"], 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"4", " ", 
                      SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                      SubscriptBox["\[Alpha]", "1"], " ", 
                      SuperscriptBox[
                        SubscriptBox["\[Beta]2", "1"], "2"]}], "+", 
                    RowBox[{"4", " ", 
                      SubscriptBox["\[Alpha]", "0"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "3"], " ", 
                      SuperscriptBox[
                        SubscriptBox["\[Beta]2", "1"], "2"]}], "+", 
                    RowBox[{
                      RowBox[{"(", 
                        RowBox[{
                          SqrtBox[
                            RowBox[{
                              SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                              SubscriptBox["\[Alpha]", "1"]}]], "+", 
                          SqrtBox[
                            RowBox[{
                              SubscriptBox["\[Alpha]", "0"], " ", 
                              SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], 
                        ")"}], " ", 
                      SuperscriptBox[
                        SubscriptBox["\[Beta]2", "1"], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "2"], 
                      RowBox[{"(", 
                        RowBox[{
                          SuperscriptBox[
                            SubscriptBox["\[Beta]2", "0"], "2"], "+", 
                          RowBox[{"3", " ", 
                            SuperscriptBox[
                              SubscriptBox["\[Beta]2", "1"], "2"]}]}], 
                        ")"}]}], "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", 
                        RowBox[{"5", "/", "2"}]], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", 
                        RowBox[{"3", "/", "2"}]], 
                      RowBox[{"(", 
                        RowBox[{
                          SuperscriptBox[
                            SubscriptBox["\[Beta]2", "0"], "2"], "+", 
                          RowBox[{"6", " ", 
                            SuperscriptBox[
                              SubscriptBox["\[Beta]2", "1"], "2"]}]}], 
                        ")"}]}], "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", 
                        RowBox[{"3", "/", "2"}]], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", 
                        RowBox[{"5", "/", "2"}]], 
                      RowBox[{"(", 
                        RowBox[{
                          SuperscriptBox[
                            SubscriptBox["\[Beta]2", "0"], "2"], "+", 
                          RowBox[{"6", " ", 
                            SuperscriptBox[
                              SubscriptBox["\[Beta]2", "1"], "2"]}]}], 
                        ")"}]}]}], ")"}]}], "\[Equal]", "0"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
              RowBox[{
                SubscriptBox["\[Beta]2", "1"], 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"4", " ", 
                      SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                      SubscriptBox["\[Alpha]", "1"], " ", 
                      SuperscriptBox[
                        SubscriptBox["\[Beta]2", "0"], "2"]}], "+", 
                    RowBox[{"4", " ", 
                      SubscriptBox["\[Alpha]", "0"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "3"], " ", 
                      SuperscriptBox[
                        SubscriptBox["\[Beta]2", "0"], "2"]}], "+", 
                    RowBox[{
                      RowBox[{"(", 
                        RowBox[{
                          SqrtBox[
                            RowBox[{
                              SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                              SubscriptBox["\[Alpha]", "1"]}]], "+", 
                          SqrtBox[
                            RowBox[{
                              SubscriptBox["\[Alpha]", "0"], " ", 
                              SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], 
                        ")"}], " ", 
                      SuperscriptBox[
                        SubscriptBox["\[Beta]2", "0"], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "2"], 
                      RowBox[{"(", 
                        RowBox[{
                          SuperscriptBox[
                            SubscriptBox["\[Beta]2", "1"], "2"], "+", 
                          RowBox[{"3", " ", 
                            SuperscriptBox[
                              SubscriptBox["\[Beta]2", "0"], "2"]}]}], 
                        ")"}]}], "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", 
                        RowBox[{"5", "/", "2"}]], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", 
                        RowBox[{"3", "/", "2"}]], 
                      RowBox[{"(", 
                        RowBox[{
                          SuperscriptBox[
                            SubscriptBox["\[Beta]2", "1"], "2"], "+", 
                          RowBox[{"6", " ", 
                            SuperscriptBox[
                              SubscriptBox["\[Beta]2", "0"], "2"]}]}], 
                        ")"}]}], "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", 
                        RowBox[{"3", "/", "2"}]], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", 
                        RowBox[{"5", "/", "2"}]], 
                      RowBox[{"(", 
                        RowBox[{
                          SuperscriptBox[
                            SubscriptBox["\[Beta]2", "1"], "2"], "+", 
                          RowBox[{"6", " ", 
                            SuperscriptBox[
                              SubscriptBox["\[Beta]2", "0"], "2"]}]}], 
                        ")"}]}]}], ")"}]}], "\[Equal]", "0"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
          RowBox[{
            SubscriptBox["\[Beta]2", "0"], ",", 
            SubscriptBox["\[Beta]2", "1"]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData["$Aborted"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Solve", "[", "\[IndentingNewLine]", 
      RowBox[{
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              RowBox[{
                SubscriptBox["\[Beta]2", "0"], 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"4", " ", 
                      SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                      SubscriptBox["\[Alpha]", "1"], " ", 
                      SuperscriptBox[
                        SubscriptBox["\[Beta]2", "1"], "2"]}], "+", 
                    RowBox[{"4", " ", 
                      SubscriptBox["\[Alpha]", "0"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "3"], " ", 
                      SuperscriptBox[
                        SubscriptBox["\[Beta]2", "1"], "2"]}], "+", 
                    RowBox[{
                      RowBox[{"(", 
                        RowBox[{
                          SqrtBox[
                            RowBox[{
                              SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                              SubscriptBox["\[Alpha]", "1"]}]], "+", 
                          SqrtBox[
                            RowBox[{
                              SubscriptBox["\[Alpha]", "0"], " ", 
                              SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], 
                        ")"}], " ", 
                      SuperscriptBox[
                        SubscriptBox["\[Beta]2", "1"], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "2"], 
                      RowBox[{"(", 
                        RowBox[{
                          SuperscriptBox[
                            SubscriptBox["\[Beta]2", "0"], "2"], "+", 
                          RowBox[{"3", " ", 
                            SuperscriptBox[
                              SubscriptBox["\[Beta]2", "1"], "2"]}]}], 
                        ")"}]}], "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", 
                        RowBox[{"5", "/", "2"}]], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", 
                        RowBox[{"3", "/", "2"}]], 
                      RowBox[{"(", 
                        RowBox[{
                          SuperscriptBox[
                            SubscriptBox["\[Beta]2", "0"], "2"], "+", 
                          RowBox[{"6", " ", 
                            SuperscriptBox[
                              SubscriptBox["\[Beta]2", "1"], "2"]}]}], 
                        ")"}]}], "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", 
                        RowBox[{"3", "/", "2"}]], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", 
                        RowBox[{"5", "/", "2"}]], 
                      RowBox[{"(", 
                        RowBox[{
                          SuperscriptBox[
                            SubscriptBox["\[Beta]2", "0"], "2"], "+", 
                          RowBox[{"6", " ", 
                            SuperscriptBox[
                              SubscriptBox["\[Beta]2", "1"], "2"]}]}], 
                        ")"}]}]}], ")"}]}], "\[Equal]", "0"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
              RowBox[{
                SubscriptBox["\[Beta]2", "1"], 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"4", " ", 
                      SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                      SubscriptBox["\[Alpha]", "1"], " ", 
                      SuperscriptBox[
                        SubscriptBox["\[Beta]2", "0"], "2"]}], "+", 
                    RowBox[{"4", " ", 
                      SubscriptBox["\[Alpha]", "0"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "3"], " ", 
                      SuperscriptBox[
                        SubscriptBox["\[Beta]2", "0"], "2"]}], "+", 
                    RowBox[{
                      RowBox[{"(", 
                        RowBox[{
                          SqrtBox[
                            RowBox[{
                              SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                              SubscriptBox["\[Alpha]", "1"]}]], "+", 
                          SqrtBox[
                            RowBox[{
                              SubscriptBox["\[Alpha]", "0"], " ", 
                              SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], 
                        ")"}], " ", 
                      SuperscriptBox[
                        SubscriptBox["\[Beta]2", "0"], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "2"], 
                      RowBox[{"(", 
                        RowBox[{
                          SuperscriptBox[
                            SubscriptBox["\[Beta]2", "1"], "2"], "+", 
                          RowBox[{"3", " ", 
                            SuperscriptBox[
                              SubscriptBox["\[Beta]2", "0"], "2"]}]}], 
                        ")"}]}], "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", 
                        RowBox[{"5", "/", "2"}]], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", 
                        RowBox[{"3", "/", "2"}]], 
                      RowBox[{"(", 
                        RowBox[{
                          SuperscriptBox[
                            SubscriptBox["\[Beta]2", "1"], "2"], "+", 
                          RowBox[{"6", " ", 
                            SuperscriptBox[
                              SubscriptBox["\[Beta]2", "0"], "2"]}]}], 
                        ")"}]}], "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", 
                        RowBox[{"3", "/", "2"}]], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", 
                        RowBox[{"5", "/", "2"}]], 
                      RowBox[{"(", 
                        RowBox[{
                          SuperscriptBox[
                            SubscriptBox["\[Beta]2", "1"], "2"], "+", 
                          RowBox[{"6", " ", 
                            SuperscriptBox[
                              SubscriptBox["\[Beta]2", "0"], "2"]}]}], 
                        ")"}]}]}], ")"}]}], "\[Equal]", "0"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
          RowBox[{
            SubscriptBox["\[Beta]2", "0"], ",", 
            SubscriptBox["\[Beta]2", "1"]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData["$Aborted"], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{"6", "\[LeftRightArrow]", "i"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Solve", "[", 
      RowBox[{
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              RowBox[{"(", 
                RowBox[{"4", " ", 
                  SuperscriptBox["\[Pi]", "2"], " ", 
                  SubscriptBox["\[Beta]2", "0"], " ", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"4", " ", 
                        SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                        SubscriptBox["\[Alpha]", "1"], " ", 
                        SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                      RowBox[{"4", " ", 
                        SubscriptBox["\[Alpha]", "0"], " ", 
                        SubsuperscriptBox["\[Alpha]", "1", "3"], " ", 
                        SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                      RowBox[{
                        RowBox[{"(", 
                          RowBox[{
                            SqrtBox[
                              RowBox[{
                                SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                                
                                SubscriptBox["\[Alpha]", "1"]}]], "+", 
                            SqrtBox[
                              RowBox[{
                                SubscriptBox["\[Alpha]", "0"], " ", 
                                SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], 
                          ")"}], " ", 
                        SubsuperscriptBox["\[Beta]2", "1", "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                        SubsuperscriptBox["\[Alpha]", "1", "2"], " ", 
                        RowBox[{"(", 
                          RowBox[{
                            SubsuperscriptBox["\[Beta]2", "0", "2"], "+", 
                            RowBox[{"3", " ", 
                              SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], 
                          ")"}]}], "+", 
                      RowBox[{
                        SubsuperscriptBox["\[Alpha]", "0", 
                          RowBox[{"5", "/", "2"}]], " ", 
                        SubsuperscriptBox["\[Alpha]", "1", 
                          RowBox[{"3", "/", "2"}]], " ", 
                        RowBox[{"(", 
                          RowBox[{
                            SubsuperscriptBox["\[Beta]2", "0", "2"], "+", 
                            RowBox[{"6", " ", 
                              SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], 
                          ")"}]}], "+", 
                      RowBox[{
                        SubsuperscriptBox["\[Alpha]", "0", 
                          RowBox[{"3", "/", "2"}]], " ", 
                        SubsuperscriptBox["\[Alpha]", "1", 
                          RowBox[{"5", "/", "2"}]], " ", 
                        RowBox[{"(", 
                          RowBox[{
                            SubsuperscriptBox["\[Beta]2", "0", "2"], "+", 
                            RowBox[{"6", " ", 
                              SubsuperscriptBox["\[Beta]2", "1", "2"]}]}], 
                          ")"}]}]}], ")"}]}], ")"}], "==", "0"}], ",", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"4", " ", 
                  SuperscriptBox["\[Pi]", "2"], " ", 
                  SubscriptBox["\[Beta]2", "1"], " ", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"4", " ", 
                        SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                        SubscriptBox["\[Alpha]", "1"], " ", 
                        SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                      RowBox[{"4", " ", 
                        SubscriptBox["\[Alpha]", "0"], " ", 
                        SubsuperscriptBox["\[Alpha]", "1", "3"], " ", 
                        SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                      RowBox[{
                        RowBox[{"(", 
                          RowBox[{
                            SqrtBox[
                              RowBox[{
                                SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                                
                                SubscriptBox["\[Alpha]", "1"]}]], "+", 
                            SqrtBox[
                              RowBox[{
                                SubscriptBox["\[Alpha]", "0"], " ", 
                                SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], 
                          ")"}], " ", 
                        SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                        SubsuperscriptBox["\[Alpha]", "1", "2"], " ", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"3", " ", 
                              SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                            
                            SubsuperscriptBox["\[Beta]2", "1", "2"]}], 
                          ")"}]}], "+", 
                      RowBox[{
                        SubsuperscriptBox["\[Alpha]", "0", 
                          RowBox[{"5", "/", "2"}]], " ", 
                        SubsuperscriptBox["\[Alpha]", "1", 
                          RowBox[{"3", "/", "2"}]], " ", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"6", " ", 
                              SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                            
                            SubsuperscriptBox["\[Beta]2", "1", "2"]}], 
                          ")"}]}], "+", 
                      RowBox[{
                        SubsuperscriptBox["\[Alpha]", "0", 
                          RowBox[{"3", "/", "2"}]], " ", 
                        SubsuperscriptBox["\[Alpha]", "1", 
                          RowBox[{"5", "/", "2"}]], " ", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"6", " ", 
                              SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                            
                            SubsuperscriptBox["\[Beta]2", "1", "2"]}], 
                          ")"}]}]}], ")"}]}], ")"}], "==", "0"}]}], "}"}], 
        ",", 
        RowBox[{"{", 
          RowBox[{
            SubscriptBox["\[Beta]2", "0"], ",", 
            SubscriptBox["\[Beta]2", "1"]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData["$Aborted"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"Simplify", "[", 
        RowBox[{"Solve", "[", 
          RowBox[{
            RowBox[{"%", "\[Equal]", "0"}], ",", 
            SubscriptBox["\[Beta]2", "0"]}], "]"}], "]"}], 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
        RowBox[{
          RowBox[{
            RowBox[{
              RowBox[{"Simplify", "[", 
                RowBox[{"%", ",", "facts"}], "]"}], "\[IndentingNewLine]", 
              SubscriptBox["\[Beta]2Best", "1"]}], "=", 
            RowBox[{
              SubscriptBox["\[Beta]2", "1"], "/.", 
              RowBox[{"First", "[", "%", "]"}]}]}], ";"}], "*)"}]}]], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"{", 
          RowBox[{
            SubscriptBox["\[Beta]2", "0"], "\[Rule]", "0"}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{
            SubscriptBox["\[Beta]2", "0"], "\[Rule]", 
            RowBox[{"-", 
              FractionBox[
                SqrtBox[
                  RowBox[{
                    RowBox[{"-", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"4", " ", 
                            SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                            SubscriptBox["\[Alpha]", "1"]}], "+", 
                          RowBox[{"6", " ", 
                            SubsuperscriptBox["\[Alpha]", "0", 
                              RowBox[{"5", "/", "2"}]], " ", 
                            SubsuperscriptBox["\[Alpha]", "1", 
                              RowBox[{"3", "/", "2"}]]}], "+", 
                          RowBox[{"6", " ", 
                            SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                            SubsuperscriptBox["\[Alpha]", "1", "2"]}], "+", 
                          RowBox[{"6", " ", 
                            SubsuperscriptBox["\[Alpha]", "0", 
                              RowBox[{"3", "/", "2"}]], " ", 
                            SubsuperscriptBox["\[Alpha]", "1", 
                              RowBox[{"5", "/", "2"}]]}], "+", 
                          RowBox[{"4", " ", 
                            SubscriptBox["\[Alpha]", "0"], " ", 
                            SubsuperscriptBox["\[Alpha]", "1", "3"]}], "+", 
                          SqrtBox[
                            RowBox[{
                              SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                              SubscriptBox["\[Alpha]", "1"]}]], "+", 
                          SqrtBox[
                            RowBox[{
                              SubscriptBox["\[Alpha]", "0"], " ", 
                              SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], 
                        ")"}]}], " ", 
                    SubsuperscriptBox["\[Beta]2", "1", "2"]}]], 
                SqrtBox[
                  RowBox[{
                    SubsuperscriptBox["\[Alpha]", "0", 
                      RowBox[{"3", "/", "2"}]], " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          SqrtBox[
                            SubscriptBox["\[Alpha]", "0"]], "+", 
                          SqrtBox[
                            SubscriptBox["\[Alpha]", "1"]]}], ")"}], "2"], 
                    " ", 
                    SubsuperscriptBox["\[Alpha]", "1", 
                      RowBox[{"3", "/", "2"}]]}]]]}]}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{
            SubscriptBox["\[Beta]2", "0"], "\[Rule]", 
            FractionBox[
              SqrtBox[
                RowBox[{
                  RowBox[{"-", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"4", " ", 
                          SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                          SubscriptBox["\[Alpha]", "1"]}], "+", 
                        RowBox[{"6", " ", 
                          SubsuperscriptBox["\[Alpha]", "0", 
                            RowBox[{"5", "/", "2"}]], " ", 
                          SubsuperscriptBox["\[Alpha]", "1", 
                            RowBox[{"3", "/", "2"}]]}], "+", 
                        RowBox[{"6", " ", 
                          SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
                          SubsuperscriptBox["\[Alpha]", "1", "2"]}], "+", 
                        RowBox[{"6", " ", 
                          SubsuperscriptBox["\[Alpha]", "0", 
                            RowBox[{"3", "/", "2"}]], " ", 
                          SubsuperscriptBox["\[Alpha]", "1", 
                            RowBox[{"5", "/", "2"}]]}], "+", 
                        RowBox[{"4", " ", 
                          SubscriptBox["\[Alpha]", "0"], " ", 
                          SubsuperscriptBox["\[Alpha]", "1", "3"]}], "+", 
                        SqrtBox[
                          RowBox[{
                            SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                            SubscriptBox["\[Alpha]", "1"]}]], "+", 
                        SqrtBox[
                          RowBox[{
                            SubscriptBox["\[Alpha]", "0"], " ", 
                            SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], 
                      ")"}]}], " ", 
                  SubsuperscriptBox["\[Beta]2", "1", "2"]}]], 
              SqrtBox[
                RowBox[{
                  SubsuperscriptBox["\[Alpha]", "0", 
                    RowBox[{"3", "/", "2"}]], " ", 
                  SuperscriptBox[
                    RowBox[{"(", 
                      RowBox[{
                        SqrtBox[
                          SubscriptBox["\[Alpha]", "0"]], "+", 
                        SqrtBox[
                          SubscriptBox["\[Alpha]", "1"]]}], ")"}], "2"], " ", 
                  
                  SubsuperscriptBox["\[Alpha]", "1", 
                    RowBox[{"3", "/", "2"}]]}]]]}], "}"}]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"xyz", "=", 
      FractionBox[
        RowBox[{"8", " ", 
          SuperscriptBox["\[Pi]", "2"], " ", 
          RowBox[{"(", 
            RowBox[{
              SqrtBox[
                RowBox[{
                  SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                  SubscriptBox["\[Alpha]", "1"]}]], "+", 
              SqrtBox[
                RowBox[{
                  SubscriptBox["\[Alpha]", "0"], " ", 
                  SubsuperscriptBox["\[Alpha]", "1", "7"]}]], "+", 
              RowBox[{"2", " ", 
                SubscriptBox["\[Alpha]", "0"], " ", 
                SubscriptBox["\[Alpha]", "1"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"2", " ", 
                      SubsuperscriptBox["\[Alpha]", "0", "2"]}], "+", 
                    RowBox[{"3", " ", 
                      SubscriptBox["\[Alpha]", "0"], " ", 
                      SubscriptBox["\[Alpha]", "1"]}], "+", 
                    RowBox[{"2", " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "2"]}], "+", 
                    RowBox[{"3", " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SqrtBox[
                            RowBox[{
                              SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                              SubscriptBox["\[Alpha]", "1"]}]], "+", 
                          SqrtBox[
                            RowBox[{
                              SubscriptBox["\[Alpha]", "0"], " ", 
                              SubsuperscriptBox["\[Alpha]", "1", "3"]}]]}], 
                        ")"}]}]}], ")"}]}]}], ")"}], " ", 
          SubscriptBox["\[Beta]2", "0"], " ", 
          SubscriptBox["\[Beta]2", "1"]}], 
        RowBox[{"const", " ", 
          SuperscriptBox[
            RowBox[{"(", 
              RowBox[{
                SqrtBox[
                  SubscriptBox["\[Alpha]", "0"]], "+", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", "1"]]}], ")"}], "2"], " ", 
          RowBox[{"(", 
            RowBox[{
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    SubscriptBox["\[Alpha]", "0"], "+", 
                    SubscriptBox["\[Alpha]", "1"]}], ")"}], "2"], "+", 
              RowBox[{"2", " ", 
                RowBox[{"(", 
                  RowBox[{
                    SqrtBox[
                      RowBox[{
                        SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                        SubscriptBox["\[Alpha]", "1"]}]], "+", 
                    SqrtBox[
                      RowBox[{
                        SubscriptBox["\[Alpha]", "0"], " ", 
                        SubsuperscriptBox["\[Alpha]", "1", "3"]}]]}], 
                  ")"}]}]}], ")"}]}]]}]], "Input"],

Cell[BoxData[
    FractionBox[
      RowBox[{"8", " ", 
        SuperscriptBox["\[Pi]", "2"], " ", 
        RowBox[{"(", 
          RowBox[{
            SqrtBox[
              RowBox[{
                SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                SubscriptBox["\[Alpha]", "1"]}]], "+", 
            SqrtBox[
              RowBox[{
                SubscriptBox["\[Alpha]", "0"], " ", 
                SubsuperscriptBox["\[Alpha]", "1", "7"]}]], "+", 
            RowBox[{"2", " ", 
              SubscriptBox["\[Alpha]", "0"], " ", 
              SubscriptBox["\[Alpha]", "1"], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"2", " ", 
                    SubsuperscriptBox["\[Alpha]", "0", "2"]}], "+", 
                  RowBox[{"3", " ", 
                    SubscriptBox["\[Alpha]", "0"], " ", 
                    SubscriptBox["\[Alpha]", "1"]}], "+", 
                  RowBox[{"2", " ", 
                    SubsuperscriptBox["\[Alpha]", "1", "2"]}], "+", 
                  RowBox[{"3", " ", 
                    RowBox[{"(", 
                      RowBox[{
                        SqrtBox[
                          RowBox[{
                            SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                            SubscriptBox["\[Alpha]", "1"]}]], "+", 
                        SqrtBox[
                          RowBox[{
                            SubscriptBox["\[Alpha]", "0"], " ", 
                            SubsuperscriptBox["\[Alpha]", "1", "3"]}]]}], 
                      ")"}]}]}], ")"}]}]}], ")"}], " ", 
        SubscriptBox["\[Beta]2", "0"], " ", 
        SubscriptBox["\[Beta]2", "1"]}], 
      RowBox[{"const", " ", 
        SuperscriptBox[
          RowBox[{"(", 
            RowBox[{
              SqrtBox[
                SubscriptBox["\[Alpha]", "0"]], "+", 
              SqrtBox[
                SubscriptBox["\[Alpha]", "1"]]}], ")"}], "2"], " ", 
        RowBox[{"(", 
          RowBox[{
            SuperscriptBox[
              RowBox[{"(", 
                RowBox[{
                  SubscriptBox["\[Alpha]", "0"], "+", 
                  SubscriptBox["\[Alpha]", "1"]}], ")"}], "2"], "+", 
            RowBox[{"2", " ", 
              RowBox[{"(", 
                RowBox[{
                  SqrtBox[
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
                      SubscriptBox["\[Alpha]", "1"]}]], "+", 
                  SqrtBox[
                    RowBox[{
                      SubscriptBox["\[Alpha]", "0"], " ", 
                      SubsuperscriptBox["\[Alpha]", "1", "3"]}]]}], ")"}]}]}],
           ")"}]}]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Solve", "[", 
      RowBox[{
        RowBox[{"xyz", "\[Equal]", "0"}], ",", 
        SubscriptBox["\[Beta]2", "1"]}], "]"}]], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"{", 
        RowBox[{
          SubscriptBox["\[Beta]2", "1"], "\[Rule]", "0"}], "}"}], 
      "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      SubscriptBox["\[Beta]2Best", "1"], "/.", 
      RowBox[{
        SubscriptBox["\[Beta]2", "0"], "\[Rule]", "0"}]}]], "Input"],

Cell[BoxData[
    FractionBox[
      RowBox[{
        SuperscriptBox[
          RowBox[{"Im", "[", 
            SubscriptBox["\[Beta]", "0"], "]"}], "2"], " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{"2", " ", 
              SubsuperscriptBox["\[Alpha]", "0", "3"], " ", 
              SubscriptBox["\[Alpha]", "1"]}], "+", 
            RowBox[{"3", " ", 
              SubsuperscriptBox["\[Alpha]", "0", 
                RowBox[{"5", "/", "2"}]], " ", 
              SubsuperscriptBox["\[Alpha]", "1", 
                RowBox[{"3", "/", "2"}]]}], "+", 
            RowBox[{"4", " ", 
              SubsuperscriptBox["\[Alpha]", "0", "2"], " ", 
              SubsuperscriptBox["\[Alpha]", "1", "2"]}], "+", 
            RowBox[{"3", " ", 
              SubsuperscriptBox["\[Alpha]", "0", 
                RowBox[{"3", "/", "2"}]], " ", 
              SubsuperscriptBox["\[Alpha]", "1", 
                RowBox[{"5", "/", "2"}]]}], "+", 
            RowBox[{"2", " ", 
              SubscriptBox["\[Alpha]", "0"], " ", 
              SubsuperscriptBox["\[Alpha]", "1", "3"]}], "+", 
            SqrtBox[
              RowBox[{
                SubsuperscriptBox["\[Alpha]", "0", "7"], " ", 
                SubscriptBox["\[Alpha]", "1"]}]], "+", 
            SqrtBox[
              RowBox[{
                SubscriptBox["\[Alpha]", "0"], " ", 
                SubsuperscriptBox["\[Alpha]", "1", "7"]}]]}], ")"}]}], 
      RowBox[{
        SqrtBox[
          RowBox[{
            SubscriptBox["\[Alpha]", "0"], " ", 
            SubsuperscriptBox["\[Alpha]", "1", "7"]}]], "+", 
        RowBox[{
          SubscriptBox["\[Alpha]", "0"], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{"2", " ", 
                SubsuperscriptBox["\[Alpha]", "1", "3"]}], "+", 
              SqrtBox[
                RowBox[{
                  SubscriptBox["\[Alpha]", "0"], " ", 
                  SubsuperscriptBox["\[Alpha]", "1", "5"]}]]}], 
            ")"}]}]}]]], "Output"]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
WindowToolbars->"EditBar",
WindowSize->{1025, 740},
WindowMargins->{{-4, Automatic}, {Automatic, 0}},
Magnification->1.25
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 976, 22, 74, "Input"],
Cell[2696, 73, 503, 14, 53, "Input"],

Cell[CellGroupData[{
Cell[3224, 91, 1599, 41, 121, "Input"],
Cell[4826, 134, 1447, 37, 76, "Output"]
}, Open  ]],
Cell[6288, 174, 454, 13, 74, "Input"],
Cell[6745, 189, 425, 11, 53, "Input"],

Cell[CellGroupData[{
Cell[7195, 204, 813, 22, 75, "Input"],
Cell[8011, 228, 2654, 61, 80, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10702, 294, 440, 11, 73, "Input"],
Cell[11145, 307, 5351, 116, 173, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[16533, 428, 255, 7, 74, "Input"],
Cell[16791, 437, 2174, 53, 114, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19002, 495, 421, 11, 94, "Input"],
Cell[19426, 508, 2239, 51, 96, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[21702, 564, 312, 8, 94, "Input"],
Cell[22017, 574, 4277, 93, 132, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[26331, 672, 466, 12, 54, "Input"],
Cell[26800, 686, 8248, 176, 204, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[35085, 867, 568, 17, 73, "Input"],
Cell[35656, 886, 1263, 31, 88, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[36956, 922, 358, 10, 73, "Input"],
Cell[37317, 934, 8669, 179, 204, "Output"]
}, Open  ]],
Cell[46001, 1116, 2794, 60, 136, "Input"],

Cell[CellGroupData[{
Cell[48820, 1180, 2458, 56, 94, "Input"],
Cell[51281, 1238, 35, 0, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[51353, 1243, 6105, 124, 244, "Input"],
Cell[57461, 1369, 35, 0, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[57533, 1374, 6809, 142, 244, "Input"],
Cell[64345, 1518, 35, 0, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[64417, 1523, 6809, 142, 244, "Input"],
Cell[71229, 1667, 35, 0, 52, "Output"]
}, Open  ]],
Cell[71279, 1670, 68, 1, 35, "Input"],

Cell[CellGroupData[{
Cell[71372, 1675, 6622, 132, 219, "Input"],
Cell[77997, 1809, 35, 0, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[78069, 1814, 651, 17, 94, "Input"],
Cell[78723, 1833, 5333, 110, 206, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[84093, 1948, 2857, 67, 119, "Input"],
Cell[86953, 2017, 2693, 66, 100, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[89683, 2088, 161, 4, 52, "Input"],
Cell[89847, 2094, 159, 5, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[90043, 2104, 158, 4, 52, "Input"],
Cell[90204, 2110, 2008, 50, 100, "Output"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

