(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     15561,        479]*)
(*NotebookOutlinePosition[     16220,        503]*)
(*  CellTagsIndexPosition[     16176,        499]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    RowBox[{
      RowBox[{"facts", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["p", "0"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["p", "0"], "\[LessEqual]", "1"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[LessEqual]", "1"}], ",", 
            RowBox[{"\[Theta]", "\[GreaterEqual]", "0"}], ",", 
            RowBox[{"\[Theta]", "\[LessEqual]", 
              RowBox[{"\[Pi]", "/", "2"}]}], ",", 
            RowBox[{"\[CurlyPhi]", "\[GreaterEqual]", "0"}], ",", 
            RowBox[{"\[CurlyPhi]", "\[LessEqual]", 
              RowBox[{"2", "\[Pi]"}]}], ",", 
            RowBox[{
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", "0"], "]"}], "2"], "+", 
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", "1"], "]"}], "2"]}], "\[Equal]", 
              "1"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]m", "0"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]m", "0"], "\[LessEqual]", "1"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]m", "1"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]m", "1"], "\[LessEqual]", "1"}]}], 
          "}"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{"dvmpgmp", "\[Congruent]", 
          RowBox[{
            RowBox[{"\[PartialD]", 
              SubsuperscriptBox["v", "m", "\[Prime]"]}], "/", 
            RowBox[{"\[PartialD]", 
              SubsuperscriptBox["g", "m", "\[Prime]"]}]}]}], 
        TraditionalForm]]],
  " and the ",
  Cell[BoxData[
      FormBox[
        RowBox[{"gmpbest", "=", 
          SubsuperscriptBox["g", "m", "\[Prime]"]}], TraditionalForm]]],
  ", where ",
  Cell[BoxData[
      FormBox["gmpbest", TraditionalForm]]],
  " solves ",
  Cell[BoxData[
      FormBox[
        RowBox[{"dvmpgmp", "\[Equal]", "0"}], TraditionalForm]]],
  ":"
}], "Subsection"],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{"dvmpgmp1", "\[Congruent]", 
          RowBox[{
            FractionBox["1", "\[Pi]"], "gmp", 
            RowBox[{
              SubsuperscriptBox["\[Integral]", "0", 
                RowBox[{"\[Pi]", "/", "2"}]], 
              RowBox[{"d", " ", "\[Theta]", " ", 
                RowBox[{"sin", "(", 
                  RowBox[{"2", "\[Theta]"}], ")"}], 
                RowBox[{
                  SubsuperscriptBox["\[Integral]", "0", 
                    RowBox[{"2", "\[Pi]"}]], 
                  RowBox[{"d", " ", 
                    RowBox[{"\[CurlyPhi]", "(", 
                      RowBox[{
                        RowBox[{
                          SubsuperscriptBox["\[Alpha]", "0", "m"], 
                          SuperscriptBox["cos", "2"], "\[Theta]"}], "+", 
                        RowBox[{
                          SubsuperscriptBox["\[Alpha]", "1", "m"], 
                          SuperscriptBox["sin", "2"], "\[Theta]"}]}], 
                      ")"}]}]}]}]}]}], "\[Congruent]", 
          RowBox[{
            SubsuperscriptBox["\[Integral]", "0", 
              RowBox[{"\[Pi]", "/", "2"}]], 
            RowBox[{"d", " ", "\[Theta]", " ", 
              RowBox[{
                SubsuperscriptBox["\[Integral]", "0", 
                  RowBox[{"2", "\[Pi]"}]], 
                RowBox[{"d", " ", "\[CurlyPhi]", " ", "integrand"}]}]}]}]}], 
        TraditionalForm]]],
  ":"
}], "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"integrand", "=", 
        RowBox[{
          FractionBox["1", "\[Pi]"], "gmp", " ", 
          RowBox[{"Sin", "[", 
            RowBox[{"2", "\[Theta]"}], "]"}], 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SubscriptBox["\[Alpha]m", "0"], 
                SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "+", 
              RowBox[{
                SubscriptBox["\[Alpha]m", "1"], 
                SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}]}]}], 
      ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp1", "=", 
        RowBox[{"Integrate", "[", 
          RowBox[{"integrand", ",", 
            RowBox[{"{", 
              RowBox[{"\[CurlyPhi]", ",", "0", ",", 
                RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}]}], ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp2", "=", 
        RowBox[{"2", " ", "gmp", " ", 
          RowBox[{"Sin", "[", 
            RowBox[{"2", " ", "\[Theta]"}], "]"}], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
                SubscriptBox["\[Alpha]m", "0"]}], "+", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
                SubscriptBox["\[Alpha]m", "1"]}]}], ")"}]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp2", "-", "tmp1"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts"}], "]"}], "&"}]}]], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp3", "=", 
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp2", ",", 
            RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "0", ",", 
                RowBox[{"\[Pi]", "/", "2"}]}], "}"}]}], "]"}]}], 
      ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"dvmpgmp1", "=", 
        RowBox[{"gmp", 
          RowBox[{"(", 
            RowBox[{
              SubscriptBox["\[Alpha]m", "0"], "+", 
              SubscriptBox["\[Alpha]m", "1"]}], ")"}]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"dvmpgmp1", "-", "tmp3"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts"}], "]"}], "&"}]}]], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{"dvmpgmp2", "=", 
          RowBox[{
            RowBox[{
              FractionBox["1", "\[Pi]"], 
              RowBox[{
                SubsuperscriptBox["\[Integral]", "0", 
                  RowBox[{"\[Pi]", "/", "2"}]], 
                RowBox[{"d", " ", "\[Theta]", " ", 
                  RowBox[{"sin", "(", 
                    RowBox[{"2", "\[Theta]"}], ")"}], 
                  RowBox[{
                    SubsuperscriptBox["\[Integral]", "0", 
                      RowBox[{"2", "\[Pi]"}]], 
                    SuperscriptBox[
                      RowBox[{"\[LeftBracketingBar]", 
                        RowBox[{
                          RowBox[{
                            SqrtBox[
                              SubsuperscriptBox["\[Alpha]", "0", "m"]], 
                            SubscriptBox["\[Beta]", "0"], "sin", " ", 
                            "\[Theta]"}], "+", 
                          RowBox[{
                            SqrtBox[
                              SubsuperscriptBox["\[Alpha]", "1", "m"]], 
                            SubscriptBox["\[Beta]", "1"], 
                            SuperscriptBox["\[ExponentialE]", 
                              RowBox[{"i", " ", "\[CurlyPhi]"}]], "sin", " ", 
                            "\[Theta]"}]}], "\[RightBracketingBar]"}], 
                      "2"]}]}]}]}], "\[Congruent]", 
            RowBox[{
              SubsuperscriptBox["\[Integral]", "0", 
                RowBox[{"\[Pi]", "/", "2"}]], 
              RowBox[{"d", " ", "\[Theta]", " ", 
                RowBox[{
                  SubsuperscriptBox["\[Integral]", "0", 
                    RowBox[{"2", "\[Pi]"}]], 
                  RowBox[{
                  "d", " ", "\[CurlyPhi]", " ", "integrand"}]}]}]}]}]}], 
        TraditionalForm]]],
  ":"
}], "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"integrand", "=", 
        RowBox[{
          FractionBox["1", "\[Pi]"], 
          RowBox[{"Sin", "[", 
            RowBox[{"2", "\[Theta]"}], "]"}], 
          SuperscriptBox[
            RowBox[{"Abs", "[", 
              RowBox[{
                RowBox[{
                  SqrtBox[
                    SubscriptBox["\[Alpha]m", "0"]], 
                  SubscriptBox["\[Beta]", "0"], 
                  RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
                RowBox[{
                  SqrtBox[
                    SubscriptBox["\[Alpha]m", "1"]], 
                  SubscriptBox["\[Beta]", "1"], 
                  SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"I", " ", "\[CurlyPhi]"}]], 
                  RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], "]"}], "2"]}]}], 
      ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp1", "=", 
        RowBox[{"Integrate", "[", 
          RowBox[{"integrand", ",", 
            RowBox[{"{", 
              RowBox[{"\[CurlyPhi]", ",", "0", ",", 
                RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}]}], ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp2", "=", 
        RowBox[{"2", " ", 
          RowBox[{"Sin", "[", 
            RowBox[{"2", " ", "\[Theta]"}], "]"}], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", "0"], "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
                SubscriptBox["\[Alpha]m", "0"]}], "+", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", "1"], "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
                SubscriptBox["\[Alpha]m", "1"]}]}], ")"}]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp1", "-", "tmp2"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts"}], "]"}], "&"}]}]], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp3", "=", 
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp2", ",", 
            RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "0", ",", 
                RowBox[{"\[Pi]", "/", "2"}]}], "}"}]}], "]"}]}], 
      ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"dvmpgmp2", "=", 
        RowBox[{
          RowBox[{
            SubscriptBox["\[Alpha]m", "0"], 
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                SubscriptBox["\[Beta]", "0"], "]"}], "2"]}], "+", 
          RowBox[{
            SubscriptBox["\[Alpha]m", "1"], 
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                SubscriptBox["\[Beta]", "1"], "]"}], "2"]}]}]}], 
      ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"dvmpgmp2", "-", "tmp3"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts"}], "]"}], "&"}]}]], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox["gmpbest", TraditionalForm]]],
  ":"
}], "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"dvmpgmp", "=", 
        RowBox[{
          SubsuperscriptBox["\[Sum]", 
            RowBox[{"j", "=", "0"}], "1"], 
          RowBox[{
            RowBox[{"(", 
              RowBox[{"gmp", "-", 
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", "j"], "]"}], "2"]}], ")"}], 
            SubscriptBox["\[Alpha]m", "j"]}]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"dvmpgmp", "-", 
        RowBox[{"(", 
          RowBox[{"dvmpgmp1", "-", "dvmpgmp2"}], ")"}]}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts"}], "]"}], "&"}]}]], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp1", "=", 
        RowBox[{"gmp", "/.", 
          RowBox[{"Solve", "[", 
            RowBox[{
              RowBox[{"dvmpgmp", "\[Equal]", "0"}], ",", "gmp"}], "]"}]}]}], 
      ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"gmpbest", "=", 
        FractionBox[
          RowBox[{
            RowBox[{
              SubscriptBox["\[Alpha]m", "0"], 
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  SubscriptBox["\[Beta]", "0"], "]"}], "2"]}], "+", 
            RowBox[{
              SubscriptBox["\[Alpha]m", "1"], 
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  SubscriptBox["\[Beta]", "1"], "]"}], "2"]}]}], 
          RowBox[{
            SubscriptBox["\[Alpha]m", "0"], "+", 
            SubscriptBox["\[Alpha]m", "1"]}]]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{
          RowBox[{"(", 
            RowBox[{"gmpbest", "-", "#"}], ")"}], "&"}], "/@", "tmp1"}], "//",
       
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts"}], "]"}], "&"}]}]], "Input"],

Cell[BoxData[
    RowBox[{"{", "0", "}"}]], "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
Evaluator->"psi 3",
WindowSize->{1025, 740},
WindowMargins->{{-4, Automatic}, {Automatic, 0}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 1566, 36, 29, "Input"],

Cell[CellGroupData[{
Cell[3308, 89, 696, 23, 45, "Subsection"],

Cell[CellGroupData[{
Cell[4029, 116, 1484, 35, 46, "Subsubsection"],
Cell[5516, 153, 630, 17, 44, "Input"],
Cell[6149, 172, 282, 7, 27, "Input"],
Cell[6434, 181, 610, 15, 29, "Input"],

Cell[CellGroupData[{
Cell[7069, 200, 188, 5, 27, "Input"],
Cell[7260, 207, 28, 0, 27, "Output"]
}, Open  ]],
Cell[7303, 210, 286, 8, 27, "Input"],
Cell[7592, 220, 255, 7, 27, "Input"],

Cell[CellGroupData[{
Cell[7872, 231, 192, 5, 27, "Input"],
Cell[8067, 238, 28, 0, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[8144, 244, 1883, 43, 50, "Subsubsection"],
Cell[10030, 289, 861, 22, 44, "Input"],
Cell[10894, 313, 282, 7, 27, "Input"],
Cell[11179, 322, 878, 21, 29, "Input"],

Cell[CellGroupData[{
Cell[12082, 347, 188, 5, 27, "Input"],
Cell[12273, 354, 28, 0, 27, "Output"]
}, Open  ]],
Cell[12316, 357, 286, 8, 27, "Input"],
Cell[12605, 367, 485, 14, 29, "Input"],

Cell[CellGroupData[{
Cell[13115, 385, 192, 5, 27, "Input"],
Cell[13310, 392, 28, 0, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[13387, 398, 103, 4, 42, "Subsubsection"],
Cell[13493, 404, 448, 12, 37, "Input"],

Cell[CellGroupData[{
Cell[13966, 420, 262, 7, 27, "Input"],
Cell[14231, 429, 28, 0, 27, "Output"]
}, Open  ]],
Cell[14274, 432, 239, 7, 27, "Input"],
Cell[14516, 441, 637, 17, 48, "Input"],

Cell[CellGroupData[{
Cell[15178, 462, 287, 9, 27, "Input"],
Cell[15468, 473, 53, 1, 27, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

