(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     92423,       2304]*)
(*NotebookOutlinePosition[     93082,       2328]*)
(*  CellTagsIndexPosition[     93038,       2324]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[{
    RowBox[{
      RowBox[{"facts1", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"\[Theta]", "\[GreaterEqual]", "0"}], ",", 
            RowBox[{"\[Theta]", "\[LessEqual]", 
              RowBox[{"\[Pi]", "/", "2"}]}], ",", 
            RowBox[{"\[CurlyPhi]", "\[GreaterEqual]", "0"}], ",", 
            RowBox[{"\[CurlyPhi]", "\[LessEqual]", 
              RowBox[{"2", "\[Pi]"}]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "0"}]], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "0"}]], "\[LessEqual]", "1"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "1"}]], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "1"}]], "\[LessEqual]", "1"}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"facts2", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["\[Beta]2", "0"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["\[Beta]2", "0"], "\[LessEqual]", "1"}]}], "}"}]}],
       ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"facts3", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["p", "0"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["p", "0"], "\[LessEqual]", "1"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[LessEqual]", "1"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[GreaterEqual]", 
              SubscriptBox["p", "0"]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"substs1", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              RowBox[{"Abs", "[", 
                SubscriptBox["\[Beta]", "0"], "]"}], "\[Rule]", 
              SqrtBox[
                SubscriptBox["\[Beta]2", "0"]]}], ",", 
            RowBox[{
              RowBox[{"Abs", "[", 
                SubscriptBox["\[Beta]", "1"], "]"}], "\[Rule]", 
              SqrtBox[
                RowBox[{"1", "-", 
                  SubscriptBox["\[Beta]2", "0"]}]]}], ",", 
            RowBox[{
              RowBox[{"Abs", "[", 
                RowBox[{
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                  SubscriptBox["\[Beta]", "0"]}], "]"}], "\[Rule]", 
              RowBox[{
                SqrtBox[
                  SubscriptBox["\[Beta]2", "0"]], 
                RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], ",", 
            RowBox[{
              RowBox[{"Abs", "[", 
                RowBox[{
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                  SubscriptBox["\[Beta]", "1"]}], "]"}], "\[Rule]", 
              RowBox[{
                SqrtBox[
                  RowBox[{"1", "-", 
                    SubscriptBox["\[Beta]2", "0"]}]], 
                RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"substs2", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"0", ",", "0"}]], "\[Rule]", 
              SubscriptBox["p", "0"]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"0", ",", "1"}]], "\[Rule]", 
              SubscriptBox["p", "1"]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"1", ",", "0"}]], "\[Rule]", 
              RowBox[{"1", "-", 
                SubscriptBox["p", "0"]}]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"1", ",", "1"}]], "\[Rule]", 
              RowBox[{"1", "-", 
                SubscriptBox["p", "1"]}]}]}], "}"}]}], ";"}]}], "Input"],

Cell[TextData[{
  "Note that ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{
            SubscriptBox["\[Alpha]", 
              RowBox[{"0", ",", "j"}]], "=", 
            SubscriptBox["\[Alpha]", 
              RowBox[{"+", 
                RowBox[{",", "j"}]}]]}], ",", 
          RowBox[{
            SubscriptBox["\[Alpha]", 
              RowBox[{"1", ",", "j"}]], "=", 
            SubscriptBox["\[Alpha]", 
              RowBox[{"-", 
                RowBox[{",", "j"}]}]]}]}], TraditionalForm]]],
  "."
}], "Text"],

Cell[CellGroupData[{

Cell[TextData[{
  "Finding ",
  Cell[BoxData[
      FormBox[
        RowBox[{"spm", "=", 
          RowBox[{
            SubsuperscriptBox["s", "m", "\[Prime]"], "=", 
            RowBox[{
              RowBox[{"\[Integral]", 
                RowBox[{
                  RowBox[{"\[DifferentialD]", 
                    RowBox[{"\[Psi]\[CurlyRho]", "[", 
                      RowBox[{"m", "|", "\[Psi]"}], "]"}]}], 
                  RowBox[{"(", 
                    RowBox[{
                      SuperscriptBox[
                        RowBox[{"\[LeftBracketingBar]", 
                          SubsuperscriptBox["c", 
                            RowBox[{"m", ",", "1"}], "\[Prime]"], 
                          "\[RightBracketingBar]"}], "4"], "-", 
                      RowBox[{"2", 
                        SuperscriptBox[
                          RowBox[{"\[LeftBracketingBar]", 
                            SubsuperscriptBox["c", 
                              RowBox[{"m", ",", "1"}], "\[Prime]"], 
                            "\[RightBracketingBar]"}], "2"], 
                        SuperscriptBox[
                          RowBox[{"\[LeftBracketingBar]", 
                            SubscriptBox["c", "1"], "\[RightBracketingBar]"}],
                           "2"]}], "+", 
                      SuperscriptBox[
                        RowBox[{"\[LeftBracketingBar]", 
                          SubscriptBox["c", "1"], "\[RightBracketingBar]"}], 
                        "4"]}], ")"}]}]}], "=", 
              RowBox[{"spm1", "+", "spm2", "+", "spm3"}]}]}]}], 
        TraditionalForm]]],
  ":"
}], "Subsection"],

Cell[BoxData[{
    RowBox[{
      RowBox[{"pm\[Psi]", "=", 
        RowBox[{
          RowBox[{
            SubscriptBox["\[Alpha]", 
              RowBox[{"m", ",", "0"}]], 
            SuperscriptBox[
              RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "+", 
          RowBox[{
            SubscriptBox["\[Alpha]", 
              RowBox[{"m", ",", "1"}]], 
            SuperscriptBox[
              RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"cm12p", "=", 
        RowBox[{
          FractionBox["1", "pm\[Psi]"], 
          SuperscriptBox[
            RowBox[{"Abs", "[", 
              RowBox[{
                RowBox[{
                  SqrtBox[
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "0"}]]], 
                  SubscriptBox["\[Beta]", "0"], 
                  RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
                RowBox[{
                  SqrtBox[
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "1"}]]], 
                  SubscriptBox["\[Beta]", "1"], 
                  SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"I", " ", "\[CurlyPhi]"}]], 
                  RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], "]"}], "2"]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"c12", "=", 
        SuperscriptBox[
          RowBox[{"Abs", "[", 
            RowBox[{
              RowBox[{
                SubscriptBox["\[Beta]", "0"], 
                RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
              RowBox[{
                SubscriptBox["\[Beta]", "1"], 
                SuperscriptBox["\[ExponentialE]", 
                  RowBox[{"I", " ", "\[CurlyPhi]"}]], 
                RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], "]"}], "2"]}], 
      ";"}]}], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"integrand", "=", 
        RowBox[{
          FractionBox["1", 
            RowBox[{"2", "\[Pi]"}]], 
          RowBox[{"Sin", "[", 
            RowBox[{"2", "\[Theta]"}], "]"}], "pm\[Psi]", 
          SuperscriptBox[
            RowBox[{"(", 
              RowBox[{"cm12p", "-", "c12"}], ")"}], "2"]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"integrand1", "=", 
        RowBox[{
          FractionBox["1", 
            RowBox[{"2", "\[Pi]"}]], 
          RowBox[{"Sin", "[", 
            RowBox[{"2", "\[Theta]"}], "]"}], "pm\[Psi]", " ", 
          SuperscriptBox["cm12p", "2"]}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"integrand2", "=", 
        RowBox[{
          RowBox[{"-", 
            FractionBox["1", "\[Pi]"]}], 
          RowBox[{"Sin", "[", 
            RowBox[{"2", "\[Theta]"}], "]"}], "pm\[Psi]", " ", "cm12p", " ", 
          "c12"}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"integrand3", "=", 
        RowBox[{
          FractionBox["1", 
            RowBox[{"2", "\[Pi]"}]], 
          RowBox[{"Sin", "[", 
            RowBox[{"2", "\[Theta]"}], "]"}], "pm\[Psi]", " ", 
          SuperscriptBox["c12", "2"]}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
      "integrand1", "+", "integrand2", "+", "integrand3", "-", "integrand"}], 
      "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{"spm1", "=", 
          RowBox[{
            RowBox[{"\[Integral]", 
              RowBox[{
                RowBox[{"\[DifferentialD]", "\[Psi]"}], " ", 
                RowBox[{"\[CurlyRho]", "[", "\[Psi]", "]"}], 
                RowBox[{"p", "[", 
                  RowBox[{"m", "|", "\[Psi]"}], "]"}], 
                SuperscriptBox[
                  RowBox[{"\[LeftBracketingBar]", 
                    SubsuperscriptBox["c", 
                      RowBox[{"m", ",", ".1"}], "\[Prime]"], 
                    "\[RightBracketingBar]"}], "4"]}]}], "=", 
            RowBox[{
              RowBox[{
                FractionBox["1", 
                  RowBox[{"2", "\[Pi]"}]], 
                RowBox[{
                  SubsuperscriptBox["\[Integral]", "0", 
                    RowBox[{"\[Pi]", "/", "2"}]], 
                  RowBox[{
                    RowBox[{"\[DifferentialD]", "\[Theta]"}], " ", 
                    RowBox[{"Sin", "[", 
                      RowBox[{"2", "\[Theta]"}], "]"}], 
                    RowBox[{
                      SubsuperscriptBox["\[Integral]", "0", 
                        RowBox[{"2", "\[Pi]"}]], 
                      RowBox[{
                        RowBox[{"\[DifferentialD]", "\[CurlyPhi]"}], " ", 
                        RowBox[{"p", "[", 
                          RowBox[{"m", "|", "\[Psi]"}], "]"}], 
                        SuperscriptBox[
                          RowBox[{"\[LeftBracketingBar]", 
                            SubsuperscriptBox["c", 
                              RowBox[{"m", ",", ".1"}], "\[Prime]"], 
                            "\[RightBracketingBar]"}], "4"]}]}]}]}]}], "=", 
              RowBox[{
                SubsuperscriptBox["\[Integral]", "0", 
                  RowBox[{"\[Pi]", "/", "2"}]], 
                RowBox[{
                  RowBox[{"\[DifferentialD]", "\[Theta]"}], 
                  RowBox[{
                    SubsuperscriptBox["\[Integral]", "0", 
                      RowBox[{"2", "\[Pi]"}]], 
                    RowBox[{
                      RowBox[{"\[DifferentialD]", "\[CurlyPhi]"}], " ", 
                      "integrand1"}]}]}]}]}]}]}], TraditionalForm]]],
  ":"
}], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp1substs", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "1"], "\[Rule]", " ", 
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SubscriptBox["\[Beta]", "0"], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "2"], "\[Rule]", 
              RowBox[{
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SubscriptBox["\[Beta]", "1"], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "3"], "\[Rule]", 
              RowBox[{
                RowBox[{"Sin", "[", 
                  RowBox[{"2", " ", "\[Theta]"}], "]"}], "/", 
                RowBox[{"(", 
                  RowBox[{"2", " ", "\[Pi]", " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{
                          SuperscriptBox[
                            RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], 
                          SubscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "0"}]]}], "+", 
                        RowBox[{
                          SuperscriptBox[
                            RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
                          
                          SubscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "1"}]]}]}], ")"}]}], 
                  ")"}]}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp1", "=", 
        RowBox[{
          SubscriptBox["c", 
            RowBox[{"3", " "}]], 
          SuperscriptBox[
            RowBox[{"Abs", "[", 
              RowBox[{
                SubscriptBox["c", "1"], "+", 
                RowBox[{
                  SubscriptBox["c", "2"], 
                  SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], " ", 
              "]"}], "4"]}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"tmp1", "-", "integrand1"}], "/.", "tmp1substs"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp1", ",", 
            RowBox[{"{", 
              RowBox[{"\[CurlyPhi]", ",", "0", ",", 
                RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "//", 
        RowBox[{
          RowBox[{"FullSimplify", "[", 
            RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "/.", "tmp1substs"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "//", 
        RowBox[{
          RowBox[{"FullSimplify", "[", 
            RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp2", "=", 
        RowBox[{"%", "/.", "substs1"}]}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp3", "=", 
        FractionBox[
          RowBox[{
            RowBox[{"Sin", "[", 
              RowBox[{"2", " ", "\[Theta]"}], "]"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Theta]", "]"}], "4"], " ", 
                  SubsuperscriptBox["\[Beta]2", "0", "2"], " ", 
                  SubsuperscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}], "2"]}], "+", 
                RowBox[{"4", " ", 
                  SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
                  SuperscriptBox[
                    RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
                  RowBox[{"(", 
                    RowBox[{"1", "-", 
                      SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                  SubscriptBox["\[Beta]2", "0"], " ", 
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]], " ", 
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]}], "+", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Sin", "[", "\[Theta]", "]"}], "4"], " ", 
                  SuperscriptBox[
                    RowBox[{"(", 
                      RowBox[{"1", "-", 
                        SubscriptBox["\[Beta]2", "0"]}], ")"}], "2"], " ", 
                  SubsuperscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}], "2"]}]}], ")"}]}], 
          RowBox[{
            RowBox[{
              SuperscriptBox[
                RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "0"}]]}], "+", 
            RowBox[{
              SuperscriptBox[
                RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "1"}]]}]}]]}], ";"}], "\[IndentingNewLine]",
   
    RowBox[{
      RowBox[{"tmp3", "-", "tmp2"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp4substs", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "1"], "\[Rule]", 
              RowBox[{
                SubsuperscriptBox["\[Beta]2", "0", "2"], " ", 
                SubsuperscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}], "2"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "2"], "\[Rule]", 
              RowBox[{"4", " ", 
                RowBox[{"(", 
                  RowBox[{"1", "-", 
                    SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                SubscriptBox["\[Beta]2", "0"], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}]], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "3"], "\[Rule]", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{"1", "-", 
                      SubscriptBox["\[Beta]2", "0"]}], ")"}], "2"], " ", 
                SubsuperscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}], "2"]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp4", "=", 
        FractionBox[
          RowBox[{
            RowBox[{"Sin", "[", 
              RowBox[{"2", " ", "\[Theta]"}], "]"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{
                  SubscriptBox["c", "1"], 
                  SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Theta]", "]"}], "4"]}], "+", 
                RowBox[{
                  SubscriptBox["c", "2"], 
                  SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
                  SuperscriptBox[
                    RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "+", 
                RowBox[{
                  SubscriptBox["c", "3"], 
                  SuperscriptBox[
                    RowBox[{"Sin", "[", "\[Theta]", "]"}], "4"]}]}], ")"}]}], 
          
          RowBox[{
            RowBox[{
              SuperscriptBox[
                RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "0"}]]}], "+", 
            RowBox[{
              SuperscriptBox[
                RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "1"}]]}]}]]}], ";"}], "\[IndentingNewLine]",
   
    RowBox[{
      RowBox[{
        RowBox[{"tmp4", "-", "tmp3"}], "/.", "tmp4substs"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp4", ",", 
            RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "0", ",", 
                RowBox[{"\[Pi]", "/", "2"}]}], "}"}]}], "]"}], "//", 
        RowBox[{
          RowBox[{"FullSimplify", "[", 
            RowBox[{"#", ",", 
              RowBox[{"Join", "[", 
                RowBox[{"facts1", ",", "facts2"}], "]"}]}], "]"}], "&"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp5", "=", 
        RowBox[{"%", "/.", "tmp4substs"}]}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"spm1", "=", 
        RowBox[{
          FractionBox["1", 
            RowBox[{"2", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "0"}]], "-", 
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "1"}]]}], ")"}], "3"]}]], 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SubsuperscriptBox["\[Beta]2", "0", "2"], " ", 
                SubsuperscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}], "4"]}], "-", 
              RowBox[{"4", " ", 
                SubscriptBox["\[Beta]2", "0"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}], "-", "1"}], ")"}], " ",
                 
                SubsuperscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}], "3"], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}]]}], "+", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Log", "[", 
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "0"}]], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                      RowBox[{"Log", "[", 
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "1"}]], "]"}]}], "+", 
                    RowBox[{"6", " ", 
                      SubscriptBox["\[Beta]2", "0"], " ", 
                      RowBox[{"(", 
                        RowBox[{"1", "-", 
                          RowBox[{"2", " ", 
                            RowBox[{"Log", "[", 
                              SubscriptBox["\[Alpha]", 
                                RowBox[{"m", ",", "0"}]], "]"}]}], "+", 
                          RowBox[{"2", " ", 
                            RowBox[{"Log", "[", 
                              SubscriptBox["\[Alpha]", 
                                RowBox[{"m", ",", "1"}]], "]"}]}], "+", 
                          RowBox[{"2", " ", 
                            RowBox[{"Log", "[", 
                              FractionBox[
                                SubscriptBox["\[Alpha]", 
                                  RowBox[{"m", ",", "0"}]], 
                                SubscriptBox["\[Alpha]", 
                                  RowBox[{"m", ",", "1"}]]], "]"}], " ", 
                            SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}]}], 
                  ")"}], " ", 
                SubsuperscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}], "2"], " ", 
                SubsuperscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}], "2"]}], "+", 
              RowBox[{"4", " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}]], " ", 
                SubsuperscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}], "3"]}], "-", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      SubscriptBox["\[Beta]2", "0"]}], ")"}], "2"], " ", 
                SubsuperscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}], "4"]}]}], ")"}]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"spm1", "-", "tmp5"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", 
              RowBox[{"facts1", ",", "facts2"}], "]"}]}], "]"}], 
        "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{"spm2", "=", 
          RowBox[{
            RowBox[{"\[Integral]", 
              RowBox[{
                RowBox[{"\[DifferentialD]", "\[Psi]"}], " ", 
                RowBox[{"\[CurlyRho]", "[", "\[Psi]", "]"}], 
                RowBox[{"p", "[", 
                  RowBox[{"m", "|", "\[Psi]"}], "]"}], "2", 
                SuperscriptBox[
                  RowBox[{"\[LeftBracketingBar]", 
                    SubsuperscriptBox["c", 
                      RowBox[{"m", ",", ".1"}], "\[Prime]"], 
                    "\[RightBracketingBar]"}], "2"], 
                SuperscriptBox[
                  RowBox[{"\[LeftBracketingBar]", 
                    SubscriptBox["c", "1"], "\[RightBracketingBar]"}], 
                  "2"]}]}], "=", 
            RowBox[{
              RowBox[{
                RowBox[{"-", 
                  FractionBox["1", "\[Pi]"]}], 
                RowBox[{
                  SubsuperscriptBox["\[Integral]", "0", 
                    RowBox[{"\[Pi]", "/", "2"}]], 
                  RowBox[{
                    RowBox[{"\[DifferentialD]", "\[Theta]"}], " ", 
                    RowBox[{"Sin", "[", 
                      RowBox[{"2", "\[Theta]"}], "]"}], 
                    RowBox[{
                      SubsuperscriptBox["\[Integral]", "0", 
                        RowBox[{"2", "\[Pi]"}]], 
                      RowBox[{
                        RowBox[{"\[DifferentialD]", "\[CurlyPhi]"}], " ", 
                        RowBox[{"p", "[", 
                          RowBox[{"m", "|", "\[Psi]"}], "]"}], 
                        SuperscriptBox[
                          RowBox[{"\[LeftBracketingBar]", 
                            SubsuperscriptBox["c", 
                              RowBox[{"m", ",", ".1"}], "\[Prime]"], 
                            "\[RightBracketingBar]"}], "2"], 
                        SuperscriptBox[
                          RowBox[{"\[LeftBracketingBar]", 
                            SubscriptBox["c", "1"], "\[RightBracketingBar]"}],
                           "2"]}]}]}]}]}], "=", 
              RowBox[{
                SubsuperscriptBox["\[Integral]", "0", 
                  RowBox[{"\[Pi]", "/", "2"}]], 
                RowBox[{
                  RowBox[{"\[DifferentialD]", "\[Theta]"}], 
                  RowBox[{
                    SubsuperscriptBox["\[Integral]", "0", 
                      RowBox[{"2", "\[Pi]"}]], 
                    RowBox[{
                      RowBox[{"\[DifferentialD]", "\[CurlyPhi]"}], " ", 
                      "integrand2"}]}]}]}]}]}]}], TraditionalForm]]],
  ":"
}], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp1substs", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "1"], "\[Rule]", 
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SubscriptBox["\[Beta]", "0"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "2"], "\[Rule]", " ", 
              RowBox[{
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SubscriptBox["\[Beta]", "1"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "3"], "\[Rule]", 
              RowBox[{
                SubscriptBox["\[Beta]", "0"], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]], 
                RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "4"], "\[Rule]", 
              RowBox[{
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SubscriptBox["\[Beta]", "1"], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "5"], "\[Rule]", 
              RowBox[{
                RowBox[{"-", " ", 
                  RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "\[Theta]"}], "]"}]}], "/", 
                "\[Pi]"}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp1", "=", 
        RowBox[{
          SubscriptBox["c", "5"], 
          SuperscriptBox[
            RowBox[{"Abs", "[", 
              RowBox[{
                SubscriptBox["c", "1"], "+", 
                RowBox[{
                  SubscriptBox["c", "2"], 
                  SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], "]"}],
             "2"], " ", 
          SuperscriptBox[
            RowBox[{"Abs", "[", 
              RowBox[{
                SubscriptBox["c", "3"], "+", 
                RowBox[{
                  SubscriptBox["c", "4"], 
                  SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], "]"}],
             "2"]}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"tmp1", "-", "integrand2"}], "/.", "tmp1substs"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp1", ",", 
            RowBox[{"{", 
              RowBox[{"\[CurlyPhi]", ",", "0", ",", 
                RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "//", 
        RowBox[{
          RowBox[{"FullSimplify", "[", 
            RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "/.", "tmp1substs"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "//", 
        RowBox[{
          RowBox[{"FullSimplify", "[", 
            RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp2", "=", 
        RowBox[{"%", "/.", "substs1"}]}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp3", "=", 
        RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"Sin", "[", 
            RowBox[{"2", " ", "\[Theta]"}], "]"}], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                RowBox[{"-", "2"}], " ", 
                SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                SubscriptBox["\[Beta]2", "0"], " ", 
                SqrtBox[
                  RowBox[{
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "0"}]], " ", 
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "1"}]]}]]}], "+", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], "+", 
                    RowBox[{
                      RowBox[{"Cos", "[", 
                        RowBox[{"2", " ", "\[Theta]"}], "]"}], " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox[
                        RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
                      SubscriptBox["\[Beta]2", "0"], " ", 
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "0"}]]}], "-", 
                    RowBox[{
                      SuperscriptBox[
                        RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "1"}]]}]}], ")"}]}]}], ")"}]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp3", "-", "tmp2"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", 
              RowBox[{"facts1", ",", "facts2"}], "]"}]}], "]"}], 
        "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp4substs", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "1"], "\[Rule]", 
              RowBox[{
                RowBox[{"-", "2"}], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                SubscriptBox["\[Beta]2", "0"], " ", 
                SqrtBox[
                  RowBox[{
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "0"}]], " ", 
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "1"}]]}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "2"], "\[Rule]", 
              SubscriptBox["\[Beta]2", "0"]}], ",", 
            RowBox[{
              SubscriptBox["c", "3"], "\[Rule]", 
              RowBox[{
                SubscriptBox["\[Beta]2", "0"], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "4"], "\[Rule]", " ", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}]]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp4", "=", 
        RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"Sin", "[", 
            RowBox[{"2", " ", "\[Theta]"}], "]"}], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SubscriptBox["c", "1"], 
                SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "+", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], "+", 
                    RowBox[{
                      SubscriptBox["c", "2"], 
                      RowBox[{"Cos", "[", 
                        RowBox[{"2", " ", "\[Theta]"}], "]"}]}]}], ")"}], " ",
                 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SubscriptBox["c", "3"], 
                      SuperscriptBox[
                        RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "-", 
                    RowBox[{
                      SubscriptBox["c", "4"], 
                      SuperscriptBox[
                        RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], 
                  ")"}]}]}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"tmp4", "-", "tmp3"}], "/.", "tmp4substs"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp4", ",", 
            RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "0", ",", 
                RowBox[{"\[Pi]", "/", "2"}]}], "}"}]}], "]"}], "//", 
        RowBox[{
          RowBox[{"FullSimplify", "[", 
            RowBox[{"#", ",", 
              RowBox[{"Join", "[", 
                RowBox[{"facts1", ",", "facts2"}], "]"}]}], "]"}], "&"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp5", "=", 
        RowBox[{"%", "/.", "tmp4substs"}]}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"spm2", "=", 
        RowBox[{
          FractionBox["1", "3"], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                RowBox[{"-", 
                  SubscriptBox["\[Beta]2", "0"]}], " ", 
                RowBox[{"(", 
                  RowBox[{"1", "+", 
                    SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}]]}], "-", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "2"}], "+", 
                    SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}]]}], "+", 
              RowBox[{"2", " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                SubscriptBox["\[Beta]2", "0"], " ", 
                SqrtBox[
                  RowBox[{
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "0"}]], " ", 
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "1"}]]}]]}]}], ")"}]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"spm2", "-", "tmp5"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", 
              RowBox[{"facts1", ",", "facts2"}], "]"}]}], "]"}], 
        "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{"spm3", "=", 
          RowBox[{
            RowBox[{"\[Integral]", 
              RowBox[{
                RowBox[{"\[DifferentialD]", "\[Psi]"}], " ", 
                RowBox[{"\[CurlyRho]", "[", "\[Psi]", "]"}], 
                RowBox[{"p", "[", 
                  RowBox[{"m", "|", "\[Psi]"}], "]"}], 
                SuperscriptBox[
                  RowBox[{"\[LeftBracketingBar]", 
                    SubscriptBox["c", "1"], "\[RightBracketingBar]"}], 
                  "4"]}]}], "=", 
            RowBox[{
              RowBox[{
                FractionBox["1", 
                  RowBox[{"2", "\[Pi]"}]], 
                RowBox[{
                  SubsuperscriptBox["\[Integral]", "0", 
                    RowBox[{"\[Pi]", "/", "2"}]], 
                  RowBox[{
                    RowBox[{"\[DifferentialD]", "\[Theta]"}], " ", 
                    RowBox[{"Sin", "[", 
                      RowBox[{"2", "\[Theta]"}], "]"}], 
                    RowBox[{
                      SubsuperscriptBox["\[Integral]", "0", 
                        RowBox[{"2", "\[Pi]"}]], 
                      RowBox[{
                        RowBox[{"\[DifferentialD]", "\[CurlyPhi]"}], " ", 
                        RowBox[{"p", "[", 
                          RowBox[{"m", "|", "\[Psi]"}], "]"}], 
                        SuperscriptBox[
                          RowBox[{"\[LeftBracketingBar]", 
                            SubscriptBox["c", "1"], "\[RightBracketingBar]"}],
                           "4"]}]}]}]}]}], "=", 
              RowBox[{
                SubsuperscriptBox["\[Integral]", "0", 
                  RowBox[{"\[Pi]", "/", "2"}]], 
                RowBox[{
                  RowBox[{"\[DifferentialD]", "\[Theta]"}], 
                  RowBox[{
                    SubsuperscriptBox["\[Integral]", "0", 
                      RowBox[{"2", "\[Pi]"}]], 
                    RowBox[{
                      RowBox[{"\[DifferentialD]", "\[CurlyPhi]"}], " ", 
                      "integrand3"}]}]}]}]}]}]}], TraditionalForm]]],
  ":"
}], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp1substs", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "1"], "\[Rule]", " ", 
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SubscriptBox["\[Beta]", "0"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "2"], "\[Rule]", 
              RowBox[{
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SubscriptBox["\[Beta]", "1"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "3"], "\[Rule]", 
              RowBox[{
                RowBox[{"Sin", "[", 
                  RowBox[{"2", " ", "\[Theta]"}], "]"}], " ", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        SuperscriptBox[
                          RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "0"}]]}], "+", 
                      RowBox[{
                        SuperscriptBox[
                          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "1"}]]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"2", "\[Pi]"}], ")"}]}]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp1", "=", 
        RowBox[{
          SubscriptBox["c", "3"], 
          SuperscriptBox[
            RowBox[{"Abs", "[", 
              RowBox[{
                SubscriptBox["c", "1"], "+", 
                RowBox[{
                  SubscriptBox["c", "2"], 
                  SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], " ", 
              "]"}], "4"]}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"tmp1", "-", "integrand3"}], "/.", "tmp1substs"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp1", ",", 
            RowBox[{"{", 
              RowBox[{"\[CurlyPhi]", ",", "0", ",", 
                RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "//", 
        RowBox[{
          RowBox[{"FullSimplify", "[", 
            RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "/.", "tmp1substs"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "//", 
        RowBox[{
          RowBox[{"FullSimplify", "[", 
            RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp2", "=", 
        RowBox[{"%", "/.", "substs1"}]}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp3", "=", 
        RowBox[{
          RowBox[{"Sin", "[", 
            RowBox[{"2", " ", "\[Theta]"}], "]"}], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "4"], " ", 
                SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{"1", "-", 
                      SubscriptBox["\[Beta]2", "0"]}], ")"}], "2"]}], "+", 
              RowBox[{"4", " ", 
                SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
                RowBox[{"(", 
                  RowBox[{"1", "-", 
                    SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                SubscriptBox["\[Beta]2", "0"]}], "+", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], "4"], " ", 
                SubsuperscriptBox["\[Beta]2", "0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}]]}], "+", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}]]}]}], ")"}]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp3", "-", "tmp2"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp4substs", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "1"], "\[Rule]", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{"1", "-", 
                    SubscriptBox["\[Beta]2", "0"]}], ")"}], "2"]}], ",", 
            RowBox[{
              SubscriptBox["c", "2"], "\[Rule]", 
              RowBox[{"4", 
                RowBox[{"(", 
                  RowBox[{"1", "-", 
                    SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                SubscriptBox["\[Beta]2", "0"]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp4", "=", 
        RowBox[{
          RowBox[{"Sin", "[", 
            RowBox[{"2", " ", "\[Theta]"}], "]"}], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SubscriptBox["c", "1"], 
                SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "4"]}], "+", 
              RowBox[{
                SubscriptBox["c", "2"], 
                SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "+", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], "4"], " ", 
                SubsuperscriptBox["\[Beta]2", "0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}]]}], "+", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}]]}]}], ")"}]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"tmp4", "-", "tmp3"}], "/.", "tmp4substs"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp4", ",", 
            RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "0", ",", 
                RowBox[{"\[Pi]", "/", "2"}]}], "}"}]}], "]"}], "//", 
        RowBox[{
          RowBox[{"FullSimplify", "[", 
            RowBox[{"#", ",", 
              RowBox[{"Join", "[", 
                RowBox[{"facts1", ",", "facts2"}], "]"}]}], "]"}], "&"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp5", "=", 
        RowBox[{"%", "/.", "tmp4substs"}]}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"spm3", "=", 
        RowBox[{
          FractionBox["1", "12"], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                RowBox[{"(", 
                  RowBox[{"1", "+", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}]]}], "+", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{"3", "-", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}]]}]}], ")"}]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"spm3", "-", "tmp5"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", 
              RowBox[{"facts1", ",", "facts2"}], "]"}]}], "]"}], 
        "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        SubscriptBox["sp", "m"], TraditionalForm]]],
  ":"
}], "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        SubscriptBox["sp", "m_"], "=", 
        RowBox[{
          FractionBox["1", "12"], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}]], 
                RowBox[{"(", 
                  RowBox[{"1", "+", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "+", 
              RowBox[{
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}]], 
                RowBox[{"(", 
                  RowBox[{"3", "-", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "+", 
              RowBox[{
                FractionBox["6", 
                  SuperscriptBox[
                    RowBox[{"(", 
                      RowBox[{
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "0"}]], "-", 
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "1"}]]}], ")"}], "3"]], 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "0"}], "4"], 
                      SubsuperscriptBox["\[Beta]2", "0", "2"]}], "-", 
                    RowBox[{"4", " ", 
                      SubsuperscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "0"}], "3"], " ", 
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "1"}]], 
                      SubscriptBox["\[Beta]2", "0"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"2", " ", 
                            SubscriptBox["\[Beta]2", "0"]}], "-", "1"}], 
                        ")"}]}], "+", 
                    RowBox[{"4", " ", 
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "0"}]], " ", 
                      SubsuperscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "1"}], "3"], 
                      RowBox[{"(", 
                        RowBox[{
                          SubscriptBox["\[Beta]2", "0"], "-", "1"}], ")"}], 
                      " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"2", " ", 
                            SubscriptBox["\[Beta]2", "0"]}], "-", "1"}], 
                        ")"}]}], "-", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "1"}], "4"], 
                      SuperscriptBox[
                        RowBox[{"(", 
                          RowBox[{
                            SubscriptBox["\[Beta]2", "0"], "-", "1"}], ")"}], 
                        "2"]}], " ", "+", 
                    RowBox[{
                      SubsuperscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "0"}], "2"], " ", 
                      SubsuperscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "1"}], "2"], 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"2", " ", 
                            RowBox[{"Log", "[", 
                              FractionBox[
                                SubscriptBox["\[Alpha]", 
                                  RowBox[{"m", ",", "0"}]], 
                                SubscriptBox["\[Alpha]", 
                                  RowBox[{"m", ",", "1"}]]], "]"}]}], "+", 
                          RowBox[{"6", " ", 
                            SubscriptBox["\[Beta]2", "0"], " ", 
                            RowBox[{"(", 
                              RowBox[{"1", "+", 
                                RowBox[{"2", " ", 
                                  RowBox[{"Log", "[", 
                                    FractionBox[
                                      SubscriptBox["\[Alpha]", 
                                        RowBox[{"m", ",", "0"}]], 
                                      SubscriptBox["\[Alpha]", 
                                        RowBox[{"m", ",", "1"}]]], "]"}], " ",
                                   
                                  RowBox[{"(", 
                                    RowBox[{
                                      SubscriptBox["\[Beta]2", "0"], "-", 
                                      "1"}], ")"}]}]}], ")"}]}], "-", "3"}], 
                        ")"}]}]}], ")"}]}], "+", 
              RowBox[{"4", " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"2", "  ", 
                      SqrtBox[
                        RowBox[{
                          SubscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "0"}]], " ", 
                          SubscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "1"}]]}]], 
                      SubscriptBox["\[Beta]2", "0"], 
                      RowBox[{"(", 
                        RowBox[{
                          SubscriptBox["\[Beta]2", "0"], "-", "1"}], ")"}]}], 
                    "-", 
                    RowBox[{
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "0"}]], 
                      SubscriptBox["\[Beta]2", "0"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SubscriptBox["\[Beta]2", "0"], "+", "1"}], ")"}]}], 
                    "-", 
                    RowBox[{
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "1"}]], 
                      RowBox[{"(", 
                        RowBox[{
                          SubscriptBox["\[Beta]2", "0"], "-", "2"}], ")"}], 
                      " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SubscriptBox["\[Beta]2", "0"], "-", "1"}], 
                        ")"}]}]}], ")"}]}]}], ")"}]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        SubscriptBox["sp", "m"], "-", 
        RowBox[{"(", 
          RowBox[{"spm1", "+", "spm2", "+", "spm3"}], ")"}]}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", 
              RowBox[{"facts1", ",", "facts2"}], "]"}]}], "]"}], 
        "&"}]}]], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{"sptotal", "\[Congruent]", 
            SuperscriptBox["s", "\[Prime]"]}], "=", 
          RowBox[{
            RowBox[{
              SubsuperscriptBox["s", "0", "\[Prime]"], "+", 
              SubsuperscriptBox["s", "1", "\[Prime]"]}], "\[Congruent]", 
            RowBox[{
              SubscriptBox["sp", "0"], "+", 
              SubscriptBox["sp", "1"]}], "\[Congruent]", 
            RowBox[{"sp0", "+", "sp1"}]}]}], TraditionalForm]]],
  ":"
}], "Subsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"sp0", "=", 
        RowBox[{
          FractionBox["1", "12"], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SubscriptBox["p", "1"], " ", 
                RowBox[{"(", 
                  RowBox[{"3", "-", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "+", 
              RowBox[{
                SubscriptBox["p", "0"], " ", 
                RowBox[{"(", 
                  RowBox[{"1", "+", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "+", 
              RowBox[{"4", " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      RowBox[{"-", 
                        SubscriptBox["p", "1"]}], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "2"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}]}], "+", 
                    RowBox[{
                      SubscriptBox["\[Beta]2", "0"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"2", " ", 
                            SqrtBox[
                              RowBox[{
                                SubscriptBox["p", "0"], " ", 
                                SubscriptBox["p", "1"]}]], " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}]}], "-",
                           
                          RowBox[{
                            SubscriptBox["p", "0"], " ", 
                            RowBox[{"(", 
                              RowBox[{"1", "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}]}]}], 
                        ")"}]}]}], ")"}]}], "+", 
              RowBox[{
                FractionBox["1", 
                  SuperscriptBox[
                    RowBox[{"(", 
                      RowBox[{
                        SubscriptBox["p", "0"], "-", 
                        SubscriptBox["p", "1"]}], ")"}], "3"]], 
                RowBox[{"(", 
                  RowBox[{"6", " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{
                          RowBox[{"-", 
                            SubsuperscriptBox["p", "1", "4"]}], " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}], 
                            "2"]}], "+", 
                        RowBox[{"4", " ", 
                          SubsuperscriptBox["p", "0", "3"], " ", 
                          SubscriptBox["p", "1"], " ", 
                          RowBox[{"(", 
                            RowBox[{"1", "-", 
                              RowBox[{"2", " ", 
                                SubscriptBox["\[Beta]2", "0"]}]}], ")"}], " ",
                           
                          SubscriptBox["\[Beta]2", "0"]}], "+", 
                        RowBox[{
                          SubsuperscriptBox["p", "0", "4"], " ", 
                          SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                        RowBox[{"4", " ", 
                          SubscriptBox["p", "0"], " ", 
                          SubsuperscriptBox["p", "1", "3"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              RowBox[{"2", " ", 
                                SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], 
                        "+", 
                        RowBox[{
                          SubsuperscriptBox["p", "0", "2"], " ", 
                          SubsuperscriptBox["p", "1", "2"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "3"}], "+", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  SubscriptBox["p", "0"], "]"}]}], "-", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  SubscriptBox["p", "1"], "]"}]}], "+", 
                              RowBox[{"6", " ", 
                                SubscriptBox["\[Beta]2", "0"], " ", 
                                RowBox[{"(", 
                                  RowBox[{"1", "-", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"Log", "[", 
                                        SubscriptBox["p", "0"], "]"}]}], "+", 
                                    
                                    RowBox[{"2", " ", 
                                      RowBox[{"Log", "[", 
                                        SubscriptBox["p", "1"], "]"}]}], "+", 
                                    
                                    RowBox[{"2", " ", 
                                      RowBox[{"Log", "[", 
                                        FractionBox[
                                        SubscriptBox["p", "0"], 
                                        SubscriptBox["p", "1"]], "]"}], " ", 
                                      SubscriptBox["\[Beta]2", "0"]}]}], 
                                  ")"}]}]}], ")"}]}]}], ")"}]}], ")"}]}]}], 
            ")"}]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"sp0", "-", 
          SubscriptBox["sp", "0"]}], "/.", "substs2"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", 
              RowBox[{"facts1", ",", "facts2", ",", "facts3"}], "]"}]}], 
          "]"}], "&"}]}]], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{
      RowBox[{"sp1", "=", 
        RowBox[{
          FractionBox["1", "12"], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SubscriptBox["p", "1"]}], ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "-", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SubscriptBox["p", "0"]}], ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{"1", "+", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "+", 
              RowBox[{"4", " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "2"}], "+", 
                    RowBox[{
                      SubscriptBox["p", "1"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "2"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}]}], "+", 
                    RowBox[{
                      SubscriptBox["\[Beta]2", "0"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"2", " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SqrtBox[
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "0"]}], ")"}], " ", 
                                    
                                    RowBox[{"(", 
                                      RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "1"]}], ")"}]}]]}], 
                              ")"}], " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}]}], "+",
                           
                          RowBox[{
                            SubscriptBox["p", "0"], " ", 
                            RowBox[{"(", 
                              RowBox[{"1", "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}]}]}], 
                        ")"}]}]}], ")"}]}], "+", 
              RowBox[{
                FractionBox["1", 
                  SuperscriptBox[
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"-", 
                          SubscriptBox["p", "0"]}], "+", 
                        SubscriptBox["p", "1"]}], ")"}], "3"]], 
                RowBox[{"(", 
                  RowBox[{"6", " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", "1"}], "+", 
                                  SubscriptBox["p", "1"]}], ")"}], "4"]}], 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}], 
                            "2"]}], "+", 
                        RowBox[{
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["p", "0"]}], ")"}], "4"], " ", 
                          SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                        RowBox[{"4", " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["p", "0"]}], ")"}], " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["p", "1"]}], ")"}], "3"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              RowBox[{"2", " ", 
                                SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], 
                        "-", 
                        RowBox[{"4", " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["p", "0"]}], ")"}], "3"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["p", "1"]}], ")"}], " ", 
                          SubscriptBox["\[Beta]2", "0"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              RowBox[{"2", " ", 
                                SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], 
                        "+", 
                        RowBox[{
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["p", "0"]}], ")"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["p", "1"]}], ")"}], "2"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "3"}], "+", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  RowBox[{"1", "-", 
                                    SubscriptBox["p", "0"]}], "]"}]}], "-", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  RowBox[{"1", "-", 
                                    SubscriptBox["p", "1"]}], "]"}]}], "+", 
                              RowBox[{
                                SubscriptBox["\[Beta]2", "0"], " ", 
                                RowBox[{"(", 
                                  RowBox[{"6", "+", 
                                    RowBox[{"Log", "[", 
                                      FractionBox["1", 
                                        SuperscriptBox[
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "0"]}], ")"}], 
                                        "12"]], "]"}], "+", 
                                    RowBox[{"Log", "[", 
                                      SuperscriptBox[
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "1"]}], ")"}], 
                                        "12"], "]"}], "+", 
                                    RowBox[{"12", " ", 
                                      RowBox[{"Log", "[", 
                                        FractionBox[
                                        RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "0"]}], 
                                        RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "1"]}]], "]"}], " ",
                                       
                                      SubscriptBox["\[Beta]2", "0"]}]}], 
                                  ")"}]}]}], ")"}]}]}], ")"}]}], ")"}]}]}], 
            ")"}]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"sp1", "-", 
          SubscriptBox["sp", "1"]}], "/.", "substs2"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", 
              RowBox[{"facts1", ",", "facts2", ",", "facts3"}], "]"}]}], 
          "]"}], "&"}]}]], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{
      RowBox[{"sptotal", "=", 
        RowBox[{
          FractionBox["1", "12"], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SubscriptBox["p", "1"], " ", 
                RowBox[{"(", 
                  RowBox[{"3", "-", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "+", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SubscriptBox["p", "1"]}], ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "-", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SubscriptBox["p", "0"]}], ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{"1", "+", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "+", 
              RowBox[{
                SubscriptBox["p", "0"], " ", 
                RowBox[{"(", 
                  RowBox[{"1", "+", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "+", 
              RowBox[{"4", " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      RowBox[{"-", 
                        SubscriptBox["p", "1"]}], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "2"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}]}], "+", 
                    RowBox[{
                      SubscriptBox["\[Beta]2", "0"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"2", " ", 
                            SqrtBox[
                              RowBox[{
                                SubscriptBox["p", "0"], " ", 
                                SubscriptBox["p", "1"]}]], " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}]}], "-",
                           
                          RowBox[{
                            SubscriptBox["p", "0"], " ", 
                            RowBox[{"(", 
                              RowBox[{"1", "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}]}]}], 
                        ")"}]}]}], ")"}]}], "+", 
              RowBox[{"4", " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "2"}], "+", 
                    RowBox[{
                      SubscriptBox["p", "1"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "2"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}]}], "+", 
                    RowBox[{
                      SubscriptBox["\[Beta]2", "0"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"2", " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SqrtBox[
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "0"]}], ")"}], " ", 
                                    
                                    RowBox[{"(", 
                                      RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "1"]}], ")"}]}]]}], 
                              ")"}], " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}]}], "+",
                           
                          RowBox[{
                            SubscriptBox["p", "0"], " ", 
                            RowBox[{"(", 
                              RowBox[{"1", "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}]}]}], 
                        ")"}]}]}], ")"}]}], "+", 
              RowBox[{
                FractionBox["1", 
                  SuperscriptBox[
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"-", 
                          SubscriptBox["p", "0"]}], "+", 
                        SubscriptBox["p", "1"]}], ")"}], "3"]], 
                RowBox[{"(", 
                  RowBox[{"6", " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", "1"}], "+", 
                                  SubscriptBox["p", "1"]}], ")"}], "4"]}], 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}], 
                            "2"]}], "+", 
                        RowBox[{
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["p", "0"]}], ")"}], "4"], " ", 
                          SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                        RowBox[{"4", " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["p", "0"]}], ")"}], " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["p", "1"]}], ")"}], "3"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              RowBox[{"2", " ", 
                                SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], 
                        "-", 
                        RowBox[{"4", " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["p", "0"]}], ")"}], "3"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["p", "1"]}], ")"}], " ", 
                          SubscriptBox["\[Beta]2", "0"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              RowBox[{"2", " ", 
                                SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], 
                        "+", 
                        RowBox[{
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["p", "0"]}], ")"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["p", "1"]}], ")"}], "2"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "3"}], "+", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  RowBox[{"1", "-", 
                                    SubscriptBox["p", "0"]}], "]"}]}], "-", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  RowBox[{"1", "-", 
                                    SubscriptBox["p", "1"]}], "]"}]}], "+", 
                              RowBox[{
                                SubscriptBox["\[Beta]2", "0"], " ", 
                                RowBox[{"(", 
                                  RowBox[{"6", "+", 
                                    RowBox[{"Log", "[", 
                                      FractionBox["1", 
                                        SuperscriptBox[
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "0"]}], ")"}], 
                                        "12"]], "]"}], "+", 
                                    RowBox[{"Log", "[", 
                                      SuperscriptBox[
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "1"]}], ")"}], 
                                        "12"], "]"}], "+", 
                                    RowBox[{"12", " ", 
                                      RowBox[{"Log", "[", 
                                        FractionBox[
                                        RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "0"]}], 
                                        RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "1"]}]], "]"}], " ",
                                       
                                      SubscriptBox["\[Beta]2", "0"]}]}], 
                                  ")"}]}]}], ")"}]}]}], ")"}]}], ")"}]}], "+",
               
              RowBox[{
                FractionBox["1", 
                  SuperscriptBox[
                    RowBox[{"(", 
                      RowBox[{
                        SubscriptBox["p", "0"], "-", 
                        SubscriptBox["p", "1"]}], ")"}], "3"]], 
                RowBox[{"(", 
                  RowBox[{"6", " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{
                          RowBox[{"-", 
                            SubsuperscriptBox["p", "1", "4"]}], " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}], 
                            "2"]}], "+", 
                        RowBox[{"4", " ", 
                          SubsuperscriptBox["p", "0", "3"], " ", 
                          SubscriptBox["p", "1"], " ", 
                          RowBox[{"(", 
                            RowBox[{"1", "-", 
                              RowBox[{"2", " ", 
                                SubscriptBox["\[Beta]2", "0"]}]}], ")"}], " ",
                           
                          SubscriptBox["\[Beta]2", "0"]}], "+", 
                        RowBox[{
                          SubsuperscriptBox["p", "0", "4"], " ", 
                          SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                        RowBox[{"4", " ", 
                          SubscriptBox["p", "0"], " ", 
                          SubsuperscriptBox["p", "1", "3"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              RowBox[{"2", " ", 
                                SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], 
                        "+", 
                        RowBox[{
                          SubsuperscriptBox["p", "0", "2"], " ", 
                          SubsuperscriptBox["p", "1", "2"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "3"}], "+", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  SubscriptBox["p", "0"], "]"}]}], "-", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  SubscriptBox["p", "1"], "]"}]}], "+", 
                              RowBox[{"6", " ", 
                                SubscriptBox["\[Beta]2", "0"], " ", 
                                RowBox[{"(", 
                                  RowBox[{"1", "-", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"Log", "[", 
                                        SubscriptBox["p", "0"], "]"}]}], "+", 
                                    
                                    RowBox[{"2", " ", 
                                      RowBox[{"Log", "[", 
                                        SubscriptBox["p", "1"], "]"}]}], "+", 
                                    
                                    RowBox[{"2", " ", 
                                      RowBox[{"Log", "[", 
                                        FractionBox[
                                        SubscriptBox["p", "0"], 
                                        SubscriptBox["p", "1"]], "]"}], " ", 
                                      SubscriptBox["\[Beta]2", "0"]}]}], 
                                  ")"}]}]}], ")"}]}]}], ")"}]}], ")"}]}]}], 
            ")"}]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"sptotal", "-", 
        RowBox[{"(", 
          RowBox[{"sp0", "+", "sp1"}], ")"}]}], "//", 
      RowBox[{
        RowBox[{"Simplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", 
              RowBox[{"facts1", ",", "facts2", ",", "facts3"}], "]"}]}], 
          "]"}], "&"}]}]], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
Evaluator->"Local",
WindowSize->{1025, 740},
WindowMargins->{{-4, Automatic}, {Automatic, 0}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 4122, 105, 103, "Input"],
Cell[5842, 156, 545, 18, 32, "Text"],

Cell[CellGroupData[{
Cell[6412, 178, 1629, 37, 46, "Subsection"],
Cell[8044, 217, 1889, 50, 87, "Input"],
Cell[9936, 269, 363, 10, 44, "Input"],

Cell[CellGroupData[{
Cell[10324, 283, 1143, 31, 134, "Input"],
Cell[11470, 316, 28, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11535, 321, 2266, 51, 46, "Subsubsection"],

Cell[CellGroupData[{
Cell[13826, 376, 2480, 61, 78, "Input"],
Cell[16309, 439, 28, 0, 27, "Output"]
}, Open  ]],
Cell[16352, 442, 784, 22, 75, "Input"],

Cell[CellGroupData[{
Cell[17161, 468, 2246, 53, 68, "Input"],
Cell[19410, 523, 28, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19475, 528, 2815, 72, 89, "Input"],
Cell[22293, 602, 28, 0, 27, "Output"]
}, Open  ]],
Cell[22336, 605, 597, 16, 43, "Input"],

Cell[CellGroupData[{
Cell[22958, 625, 4252, 97, 156, "Input"],
Cell[27213, 724, 28, 0, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[27290, 730, 2663, 59, 46, "Subsubsection"],

Cell[CellGroupData[{
Cell[29978, 793, 2546, 65, 78, "Input"],
Cell[32527, 860, 28, 0, 27, "Output"]
}, Open  ]],
Cell[32570, 863, 784, 22, 75, "Input"],

Cell[CellGroupData[{
Cell[33379, 889, 2515, 60, 55, "Input"],
Cell[35897, 951, 28, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[35962, 956, 3115, 79, 72, "Input"],
Cell[39080, 1037, 28, 0, 27, "Output"]
}, Open  ]],
Cell[39123, 1040, 597, 16, 43, "Input"],

Cell[CellGroupData[{
Cell[39745, 1060, 1772, 46, 62, "Input"],
Cell[41520, 1108, 28, 0, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[41597, 1114, 2132, 49, 46, "Subsubsection"],

Cell[CellGroupData[{
Cell[43754, 1167, 2176, 54, 70, "Input"],
Cell[45933, 1223, 28, 0, 27, "Output"]
}, Open  ]],
Cell[45976, 1226, 784, 22, 75, "Input"],

Cell[CellGroupData[{
Cell[46785, 1252, 1832, 45, 45, "Input"],
Cell[48620, 1299, 28, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[48685, 1304, 2241, 58, 63, "Input"],
Cell[50929, 1364, 28, 0, 27, "Output"]
}, Open  ]],
Cell[50972, 1367, 597, 16, 43, "Input"],

Cell[CellGroupData[{
Cell[51594, 1387, 1055, 29, 62, "Input"],
Cell[52652, 1418, 28, 0, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[52729, 1424, 126, 5, 43, "Subsubsection"],
Cell[52858, 1431, 6163, 134, 212, "Input"],

Cell[CellGroupData[{
Cell[59046, 1569, 381, 11, 29, "Input"],
Cell[59430, 1582, 28, 0, 27, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[59519, 1589, 550, 15, 46, "Subsection"],
Cell[60072, 1606, 6192, 129, 175, "Input"],

Cell[CellGroupData[{
Cell[66289, 1739, 359, 10, 29, "Input"],
Cell[66651, 1751, 28, 0, 27, "Output"]
}, Open  ]],
Cell[66694, 1754, 9420, 194, 179, "Input"],

Cell[CellGroupData[{
Cell[76139, 1952, 359, 10, 29, "Input"],
Cell[76501, 1964, 28, 0, 27, "Output"]
}, Open  ]],
Cell[76544, 1967, 15439, 317, 351, "Input"],

Cell[CellGroupData[{
Cell[92008, 2288, 356, 10, 27, "Input"],
Cell[92367, 2300, 28, 0, 27, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

