(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     89498,       2306]*)
(*NotebookOutlinePosition[     90157,       2330]*)
(*  CellTagsIndexPosition[     90113,       2326]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[{
    RowBox[{
      RowBox[{"facts1", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"\[Theta]", "\[GreaterEqual]", "0"}], ",", 
            RowBox[{"\[Theta]", "\[LessEqual]", 
              RowBox[{"\[Pi]", "/", "2"}]}], ",", 
            RowBox[{"\[CurlyPhi]", "\[GreaterEqual]", "0"}], ",", 
            RowBox[{"\[CurlyPhi]", "\[LessEqual]", 
              RowBox[{"2", "\[Pi]"}]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "0"}]], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "0"}]], "\[LessEqual]", "1"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "1"}]], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "1"}]], "\[LessEqual]", "1"}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"facts2", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["\[Beta]2", "0"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["\[Beta]2", "0"], "\[LessEqual]", "1"}]}], "}"}]}],
       ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"facts3", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["p", "0"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["p", "0"], "\[LessEqual]", "1"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[LessEqual]", "1"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[GreaterEqual]", 
              SubscriptBox["p", "0"]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"substs1", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              RowBox[{"Abs", "[", 
                SubscriptBox["\[Beta]", "0"], "]"}], "\[Rule]", 
              SqrtBox[
                SubscriptBox["\[Beta]2", "0"]]}], ",", 
            RowBox[{
              RowBox[{"Abs", "[", 
                SubscriptBox["\[Beta]", "1"], "]"}], "\[Rule]", 
              SqrtBox[
                RowBox[{"1", "-", 
                  SubscriptBox["\[Beta]2", "0"]}]]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"substs2", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"0", ",", "0"}]], "\[Rule]", 
              SubscriptBox["p", "0"]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"0", ",", "1"}]], "\[Rule]", 
              SubscriptBox["p", "1"]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"1", ",", "0"}]], "\[Rule]", 
              RowBox[{"1", "-", 
                SubscriptBox["p", "0"]}]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"1", ",", "1"}]], "\[Rule]", 
              RowBox[{"1", "-", 
                SubscriptBox["p", "1"]}]}]}], "}"}]}], ";"}]}], "Input"],

Cell[TextData[{
  "Note that ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{
            SubscriptBox["\[Alpha]", 
              RowBox[{"0", ",", "j"}]], "=", 
            SubscriptBox["\[Alpha]", 
              RowBox[{"+", 
                RowBox[{",", "j"}]}]]}], ",", 
          RowBox[{
            SubscriptBox["\[Alpha]", 
              RowBox[{"1", ",", "j"}]], "=", 
            SubscriptBox["\[Alpha]", 
              RowBox[{"-", 
                RowBox[{",", "j"}]}]]}]}], TraditionalForm]]],
  "."
}], "Text"],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{"vmp", "\[Congruent]", 
            SubsuperscriptBox["v", "m", "\[Prime]"]}], "=", 
          RowBox[{
            RowBox[{"\[Integral]", 
              RowBox[{"d", " ", "\[Psi]", " ", 
                RowBox[{"\[CurlyRho]", "(", "\[Psi]", ")"}], 
                RowBox[{"p", "(", 
                  RowBox[{"m", "|", "\[Psi]"}], ")"}], 
                SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                      SubsuperscriptBox["g", "m", "\[Prime]"], "-", 
                      SuperscriptBox[
                        RowBox[{"\[LeftBracketingBar]", 
                          SubsuperscriptBox["c", 
                            RowBox[{"m", ",", "1"}], "\[Prime]"], 
                          "\[RightBracketingBar]"}], "2"]}], ")"}], "2"]}]}], 
            "=", 
            RowBox[{
              RowBox[{
                FractionBox["1", 
                  RowBox[{"2", "\[Pi]"}]], 
                RowBox[{
                  SubsuperscriptBox["\[Integral]", "0", 
                    RowBox[{"\[Pi]", "/", "2"}]], 
                  RowBox[{"d", " ", "\[Theta]", " ", "sin", " ", "\[Theta]", 
                    RowBox[{
                      SubsuperscriptBox["\[Integral]", "0", 
                        RowBox[{"2", "\[Pi]"}]], 
                      RowBox[{"d", " ", "\[CurlyPhi]", " ", 
                        RowBox[{"p", "(", 
                          RowBox[{"m", "|", "\[Psi]"}], ")"}], 
                        SuperscriptBox[
                          RowBox[{"(", 
                            RowBox[{
                              SubsuperscriptBox["g", "m", "\[Prime]"], "-", 
                              SuperscriptBox[
                                RowBox[{"\[LeftBracketingBar]", 
                                  SubscriptBox["c", 
                                    RowBox[{"m", ",", "1"}]], 
                                  "\[RightBracketingBar]"}], "2"]}], ")"}], 
                          "2"]}]}]}]}]}], "\[Congruent]", 
              RowBox[{
                SubsuperscriptBox["\[Integral]", "0", 
                  RowBox[{"\[Pi]", "/", "2"}]], 
                RowBox[{"d", " ", "\[Theta]", 
                  RowBox[{
                    SubsuperscriptBox["\[Integral]", "0", 
                      RowBox[{"2", "\[Pi]"}]], 
                    RowBox[{
                    "d", " ", "\[CurlyPhi]", " ", "integrand"}]}]}]}]}]}]}], 
        TraditionalForm]]],
  ":"
}], "Subsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"pm\[Psi]", "=", 
        RowBox[{
          RowBox[{
            SubscriptBox["\[Alpha]", 
              RowBox[{"m", ",", "0"}]], 
            SuperscriptBox[
              RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "+", 
          RowBox[{
            SubscriptBox["\[Alpha]", 
              RowBox[{"m", ",", "1"}]], 
            SuperscriptBox[
              RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}]}], 
      ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"gmp", "=", 
        FractionBox[
          RowBox[{
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "0"}]], 
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  SubscriptBox["\[Beta]", "0"], "]"}], "2"]}], "+", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "1"}]], 
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  SubscriptBox["\[Beta]", "1"], "]"}], "2"]}]}], 
          RowBox[{
            SubscriptBox["\[Alpha]", 
              RowBox[{"m", ",", "0"}]], "+", 
            SubscriptBox["\[Alpha]", 
              RowBox[{"m", ",", "1"}]]}]]}], ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"cm12p", "=", 
        RowBox[{
          FractionBox["1", "pm\[Psi]"], 
          SuperscriptBox[
            RowBox[{"Abs", "[", 
              RowBox[{
                RowBox[{
                  SqrtBox[
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "0"}]]], 
                  SubscriptBox["\[Beta]", "0"], 
                  RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
                RowBox[{
                  SqrtBox[
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "1"}]]], 
                  SubscriptBox["\[Beta]", "1"], 
                  SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"I", " ", "\[CurlyPhi]"}]], 
                  RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], "]"}], "2"]}]}], 
      ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"integrand", "=", 
        RowBox[{
          FractionBox["1", 
            RowBox[{"2", "\[Pi]"}]], 
          RowBox[{"Sin", "[", 
            RowBox[{"2", "\[Theta]"}], "]"}], "pm\[Psi]", 
          SuperscriptBox[
            RowBox[{"(", 
              RowBox[{"gmp", "-", "cm12p"}], ")"}], "2"]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp1substs", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "1"], "\[Rule]", 
              RowBox[{
                RowBox[{"Sin", "[", 
                  RowBox[{"2", "\[Theta]"}], "]"}], 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        SuperscriptBox[
                          RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], 
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "0"}]]}], "+", 
                      RowBox[{
                        SuperscriptBox[
                          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "1"}]]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"2", "\[Pi]"}], ")"}]}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "2"], "\[Rule]", 
              FractionBox[
                RowBox[{
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Abs", "[", 
                        SubscriptBox["\[Beta]", "0"], "]"}], "2"], " ", 
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "0"}]]}], "+", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Abs", "[", 
                        SubscriptBox["\[Beta]", "1"], "]"}], "2"], " ", 
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "1"}]]}]}], 
                RowBox[{
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]], "+", 
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]}]]}], ",", 
            RowBox[{
              SubscriptBox["c", "3"], "\[Rule]", 
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]], " ", 
                SubscriptBox["\[Beta]", "0"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "4"], "\[Rule]", 
              RowBox[{
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]], " ", 
                SubscriptBox["\[Beta]", "1"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "5"], "\[Rule]", 
              RowBox[{"1", "/", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox[
                        RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "0"}]]}], "+", 
                    RowBox[{
                      SuperscriptBox[
                        RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "1"}]]}]}], ")"}]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp1", "=", 
        RowBox[{
          SubscriptBox["c", "1"], " ", 
          SuperscriptBox[
            RowBox[{"(", 
              RowBox[{
                SubscriptBox["c", "2"], "-", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Abs", "[", 
                      RowBox[{
                        SubscriptBox["c", "3"], "+", 
                        RowBox[{
                          SubscriptBox["c", "4"], 
                          SuperscriptBox["\[ExponentialE]", 
                            RowBox[{
                            "\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], " ", 
                      "]"}], "2"], 
                  SubscriptBox["c", "5"]}]}], ")"}], "2"]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"tmp1", "-", "integrand"}], "/.", "tmp1substs"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp1", ",", 
            RowBox[{"{", 
              RowBox[{"\[CurlyPhi]", ",", "0", ",", 
                RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "//", 
        RowBox[{
          RowBox[{"FullSimplify", "[", 
            RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "/.", "tmp1substs"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "//", 
        RowBox[{
          RowBox[{"FullSimplify", "[", 
            RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp2", "=", 
        RowBox[{"%", "/.", "substs1"}]}], ";"}]}], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp3", "=", 
        RowBox[{
          FractionBox["1", 
            RowBox[{"4", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "0"}]], "+", 
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "1"}]]}], ")"}], "2"], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "0"}]]}], "+", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "1"}]]}]}], ")"}]}]], 
          RowBox[{"(", " ", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "0"}]], " ", 
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "1"}]], " ", 
              RowBox[{"Sin", "[", 
                RowBox[{"2", " ", "\[Theta]"}], "]"}], 
              RowBox[{"(", " ", 
                RowBox[{
                  RowBox[{
                    SubsuperscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "0"}], "2"], 
                    SubscriptBox["\[Beta]2", "0"], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        SubscriptBox["\[Beta]2", "0"], "-", "1"}], ")"}], 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"Cos", "[", 
                          RowBox[{"4", " ", "\[Theta]"}], "]"}], "-", "1"}], 
                      ")"}]}], "+", 
                  RowBox[{"2", "  ", 
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "0"}]], " ", 
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "1"}]], 
                    RowBox[{"(", 
                      RowBox[{"1", "+", 
                        RowBox[{"Cos", "[", 
                          RowBox[{"4", " ", "\[Theta]"}], "]"}], "+", 
                        RowBox[{
                          SubscriptBox["\[Beta]2", "0"], 
                          RowBox[{"(", 
                            RowBox[{
                              SubscriptBox["\[Beta]2", "0"], "-", "1"}], 
                            ")"}], 
                          RowBox[{"(", 
                            RowBox[{"3", "+", 
                              RowBox[{"5", " ", 
                                RowBox[{"Cos", "[", 
                                  RowBox[{"4", " ", "\[Theta]"}], "]"}]}]}], 
                            ")"}]}]}], ")"}]}], "+", "  ", 
                  RowBox[{
                    SubsuperscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "1"}], "2"], 
                    SubscriptBox["\[Beta]2", "0"], 
                    RowBox[{"(", 
                      RowBox[{
                        SubscriptBox["\[Beta]2", "0"], "-", "1"}], ")"}], 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"Cos", "[", 
                          RowBox[{"4", " ", "\[Theta]"}], "]"}], "-", "1"}], 
                      ")"}]}]}], ")"}]}], ")"}]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp3", "-", "tmp2"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", 
              RowBox[{"facts1", ",", "facts2"}], "]"}]}], "]"}], 
        "&"}]}]], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp4substs", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "1"], "\[Rule]", 
              RowBox[{"4", " ", 
                SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "0"}]], "+", 
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "1"}]]}], ")"}], "2"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "2"], "\[Rule]", " ", 
              RowBox[{
                SubscriptBox["c", "1"], 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "3"], "\[Rule]", " ", 
              RowBox[{
                SubscriptBox["c", "1"], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "4"], "\[Rule]", " ", 
              RowBox[{
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}]], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "5"], "\[Rule]", 
              RowBox[{
                SubsuperscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}], "2"], 
                SubscriptBox["\[Beta]2", "0"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    SubscriptBox["\[Beta]2", "0"], "-", "1"}], ")"}]}]}], ",",
             
            RowBox[{
              SubscriptBox["c", "6"], "\[Rule]", 
              RowBox[{"2", "  ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}]], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "7"], "\[Rule]", " ", 
              RowBox[{
                SubscriptBox["\[Beta]2", "0"], 
                RowBox[{"(", 
                  RowBox[{
                    SubscriptBox["\[Beta]2", "0"], "-", "1"}], ")"}]}]}], ",",
             
            RowBox[{
              SubscriptBox["c", "8"], "\[Rule]", 
              RowBox[{
                SubsuperscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}], "2"], 
                SubscriptBox["\[Beta]2", "0"], 
                RowBox[{"(", 
                  RowBox[{
                    SubscriptBox["\[Beta]2", "0"], "-", "1"}], ")"}]}]}], ",",
             
            RowBox[{
              SubscriptBox["c", "9"], "\[Rule]", 
              RowBox[{
                SubscriptBox["c", "5"], "+", 
                SubscriptBox["c", "6"], "+", 
                RowBox[{"5", " ", 
                  SubscriptBox["c", "6"], 
                  SubscriptBox["c", "7"]}], "+", 
                SubscriptBox["c", "8"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "10"], "\[Rule]", 
              RowBox[{
                RowBox[{"-", 
                  SubscriptBox["c", "5"]}], "+", 
                SubscriptBox["c", "6"], "+", 
                RowBox[{"3", 
                  SubscriptBox["c", "6"], 
                  SubscriptBox["c", "7"]}], "-", 
                SubscriptBox["c", "8"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "11"], "\[Rule]", 
              RowBox[{
                SubscriptBox["c", "4"], 
                SubscriptBox["c", "9"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "12"], "\[Rule]", 
              RowBox[{
                SubscriptBox["c", "10"], 
                RowBox[{
                  SubscriptBox["c", "4"], "/", 
                  SubscriptBox["c", "11"]}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "13"], "\[Rule]", 
              RowBox[{
                SubscriptBox["c", "2"], "/", 
                SubscriptBox["c", "11"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "14"], "\[Rule]", " ", 
              RowBox[{
                SubscriptBox["c", "3"], "/", 
                SubscriptBox["c", "11"]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp4", "=", 
        RowBox[{
          FractionBox["1", 
            RowBox[{
              RowBox[{
                SubscriptBox["c", "13"], 
                SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "+", 
              RowBox[{
                SubscriptBox["c", "14"], 
                SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}]], 
          RowBox[{"Sin", "[", 
            RowBox[{"2", " ", "\[Theta]"}], "]"}], 
          RowBox[{"(", 
            RowBox[{
              RowBox[{"Cos", "[", 
                RowBox[{"4", " ", "\[Theta]"}], "]"}], "+", 
              SubscriptBox["c", "12"]}], ")"}]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"tmp4", "-", "tmp3"}], "//.", "tmp4substs"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp4", ",", 
            RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "0", ",", 
                RowBox[{"\[Pi]", "/", "2"}]}], "}"}]}], "]"}], "//", 
        "FullSimplify"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp5", "=", 
        RowBox[{"%", "//.", "tmp4substs"}]}], ";"}]}], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        SubscriptBox["vp", "m_"], "=", 
        RowBox[{
          FractionBox[
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "0"}]], " ", 
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "1"}]]}], 
            RowBox[{
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "0"}]], "-", 
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "1"}]]}], ")"}], "3"], " ", 
              RowBox[{"(", 
                RowBox[{
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]], "+", 
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]}], ")"}]}]], 
          RowBox[{
            SubsuperscriptBox["\[Sum]", 
              RowBox[{"j", "=", "0"}], "1"], 
            RowBox[{"(", 
              RowBox[{
                RowBox[{
                  SubsuperscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "j"}], "2"], " ", 
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", 
                      RowBox[{"1", "-", "j"}]}]], 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"Log", "[", 
                        FractionBox[
                          SubscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "0"}]], 
                          SubscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "1"}]]], "]"}], "-", 
                      RowBox[{"2", 
                        SuperscriptBox[
                          RowBox[{"(", 
                            RowBox[{"-", "1"}], ")"}], "j"]}], "+", 
                      RowBox[{"3", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"2", " ", 
                              RowBox[{"Log", "[", 
                                FractionBox[
                                  SubscriptBox["\[Alpha]", 
                                    RowBox[{"m", ",", "0"}]], 
                                  SubscriptBox["\[Alpha]", 
                                    RowBox[{"m", ",", "1"}]]], "]"}]}], "-", 
                            RowBox[{"3", 
                              SuperscriptBox[
                                RowBox[{"(", 
                                  RowBox[{"-", "1"}], ")"}], "j"]}]}], ")"}], 
                        "  ", 
                        SubscriptBox["\[Beta]2", "0"], 
                        RowBox[{"(", 
                          RowBox[{
                            SubscriptBox["\[Beta]2", "0"], "-", "1"}], 
                          ")"}]}]}], ")"}]}], "-", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"(", 
                      RowBox[{"-", "1"}], ")"}], "j"], 
                  SubsuperscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "j"}], "3"], 
                  SubscriptBox["\[Beta]2", "0"], 
                  RowBox[{"(", 
                    RowBox[{
                      SubscriptBox["\[Beta]2", "0"], "-", "1"}], ")"}]}]}], 
              ")"}]}]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        SubscriptBox["vp", "m"], "-", "tmp5"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", 
              RowBox[{"facts1", ",", "facts2"}], "]"}]}], "]"}], 
        "&"}]}]], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{"vptotal", "\[Congruent]", 
            SuperscriptBox["v", "\[Prime]"]}], "=", 
          RowBox[{
            RowBox[{
              SubsuperscriptBox["v", "0", "\[Prime]"], "+", 
              SubsuperscriptBox["v", "1", "\[Prime]"]}], "\[Congruent]", 
            RowBox[{
              SubscriptBox["vp", "0"], "+", 
              SubscriptBox["vp", "1"]}], "\[Congruent]", 
            RowBox[{"vp0", "+", "vp1"}]}]}], TraditionalForm]]],
  ":"
}], "Subsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"vp0", "=", 
        RowBox[{
          FractionBox["1", 
            RowBox[{
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    SubscriptBox["p", "0"], "-", 
                    SubscriptBox["p", "1"]}], ")"}], "3"], " ", 
              RowBox[{"(", 
                RowBox[{
                  SubscriptBox["p", "0"], "+", 
                  SubscriptBox["p", "1"]}], ")"}]}]], 
          RowBox[{"(", 
            RowBox[{
              SubscriptBox["p", "0"], " ", 
              SubscriptBox["p", "1"], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{
                    RowBox[{"-", 
                      SubsuperscriptBox["p", "0", "3"]}], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                    SubscriptBox["\[Beta]2", "0"]}], "+", 
                  RowBox[{
                    SubsuperscriptBox["p", "1", "3"], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                    SubscriptBox["\[Beta]2", "0"]}], "+", 
                  RowBox[{
                    SubsuperscriptBox["p", "0", "2"], " ", 
                    SubscriptBox["p", "1"], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"-", "2"}], "+", 
                        RowBox[{"Log", "[", 
                          SubscriptBox["p", "0"], "]"}], "-", 
                        RowBox[{"Log", "[", 
                          SubscriptBox["p", "1"], "]"}], "+", 
                        RowBox[{"3", " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "3"}], "+", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  SubscriptBox["p", "0"], "]"}]}], "-", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  SubscriptBox["p", "1"], "]"}]}]}], ")"}], 
                          " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                          SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "+", 
                  RowBox[{
                    SubscriptBox["p", "0"], " ", 
                    SubsuperscriptBox["p", "1", "2"], " ", 
                    RowBox[{"(", 
                      RowBox[{"2", "+", 
                        RowBox[{"Log", "[", 
                          SubscriptBox["p", "0"], "]"}], "-", 
                        RowBox[{"Log", "[", 
                          SubscriptBox["p", "1"], "]"}], "+", 
                        RowBox[{"3", " ", 
                          RowBox[{"(", 
                            RowBox[{"3", "+", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  SubscriptBox["p", "0"], "]"}]}], "-", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  SubscriptBox["p", "1"], "]"}]}]}], ")"}], 
                          " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                          SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}]}], 
                ")"}]}], ")"}]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"vp0", "-", 
          SubscriptBox["vp", "0"]}], "/.", "substs2"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", 
              RowBox[{"facts1", ",", "facts2", ",", "facts3"}], "]"}]}], 
          "]"}], "&"}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"-", 
        SubscriptBox["vp", "0"]}], "+", 
      RowBox[{
        FractionBox["1", 
          RowBox[{
            SuperscriptBox[
              RowBox[{"(", 
                RowBox[{
                  SubscriptBox["p", "0"], "-", 
                  SubscriptBox["p", "1"]}], ")"}], "3"], " ", 
            RowBox[{"(", 
              RowBox[{
                SubscriptBox["p", "0"], "+", 
                SubscriptBox["p", "1"]}], ")"}]}]], 
        RowBox[{"(", 
          RowBox[{
            SubscriptBox["p", "0"], " ", 
            SubscriptBox["p", "1"], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{
                  RowBox[{"-", 
                    SubsuperscriptBox["p", "0", "3"]}], " ", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                  SubscriptBox["\[Beta]2", "0"]}], "+", 
                RowBox[{
                  SubsuperscriptBox["p", "1", "3"], " ", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                  SubscriptBox["\[Beta]2", "0"]}], "+", 
                RowBox[{
                  SubsuperscriptBox["p", "0", "2"], " ", 
                  SubscriptBox["p", "1"], " ", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", "2"}], "+", 
                      RowBox[{"Log", "[", 
                        SubscriptBox["p", "0"], "]"}], "-", 
                      RowBox[{"Log", "[", 
                        SubscriptBox["p", "1"], "]"}], "+", 
                      RowBox[{"3", " ", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", "3"}], "+", 
                            RowBox[{"2", " ", 
                              RowBox[{"Log", "[", 
                                SubscriptBox["p", "0"], "]"}]}], "-", 
                            RowBox[{"2", " ", 
                              RowBox[{"Log", "[", 
                                SubscriptBox["p", "1"], "]"}]}]}], ")"}], " ",
                         
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", "1"}], "+", 
                            SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                        SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "+", 
                RowBox[{
                  SubscriptBox["p", "0"], " ", 
                  SubsuperscriptBox["p", "1", "2"], " ", 
                  RowBox[{"(", 
                    RowBox[{"2", "+", 
                      RowBox[{"Log", "[", 
                        SubscriptBox["p", "0"], "]"}], "-", 
                      RowBox[{"Log", "[", 
                        SubscriptBox["p", "1"], "]"}], "+", 
                      RowBox[{"3", " ", 
                        RowBox[{"(", 
                          RowBox[{"3", "+", 
                            RowBox[{"2", " ", 
                              RowBox[{"Log", "[", 
                                SubscriptBox["p", "0"], "]"}]}], "-", 
                            RowBox[{"2", " ", 
                              RowBox[{"Log", "[", 
                                SubscriptBox["p", "1"], "]"}]}]}], ")"}], " ",
                         
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", "1"}], "+", 
                            SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                        SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}]}], ")"}]}],
           ")"}]}]}]], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{
      RowBox[{"vp1", "=", 
        RowBox[{
          RowBox[{"-", 
            FractionBox["1", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SubscriptBox["p", "0"]}], "+", 
                      SubscriptBox["p", "1"]}], ")"}], "3"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "2"}], "+", 
                    SubscriptBox["p", "0"], "+", 
                    SubscriptBox["p", "1"]}], ")"}]}]]}], 
          RowBox[{"(", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"1", "-", 
                  SubscriptBox["p", "0"]}], ")"}], " ", 
              RowBox[{"(", 
                RowBox[{"1", "-", 
                  SubscriptBox["p", "1"]}], ")"}], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["p", "0"]}], ")"}], "3"], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                    SubscriptBox["\[Beta]2", "0"]}], "-", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["p", "1"]}], ")"}], "3"], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                    SubscriptBox["\[Beta]2", "0"]}], "+", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["p", "0"]}], ")"}], "2"], " ", 
                    RowBox[{"(", 
                      RowBox[{"1", "-", 
                        SubscriptBox["p", "1"]}], ")"}], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"-", "2"}], "+", 
                        RowBox[{"Log", "[", 
                          RowBox[{"1", "-", 
                            SubscriptBox["p", "0"]}], "]"}], "-", 
                        RowBox[{"Log", "[", 
                          RowBox[{"1", "-", 
                            SubscriptBox["p", "1"]}], "]"}], "+", 
                        RowBox[{"3", " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "3"}], "+", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  RowBox[{"1", "-", 
                                    SubscriptBox["p", "0"]}], "]"}]}], "-", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  RowBox[{"1", "-", 
                                    SubscriptBox["p", "1"]}], "]"}]}]}], 
                            ")"}], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                          SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "+", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{"1", "-", 
                        SubscriptBox["p", "0"]}], ")"}], " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["p", "1"]}], ")"}], "2"], " ", 
                    RowBox[{"(", 
                      RowBox[{"2", "+", 
                        RowBox[{"Log", "[", 
                          RowBox[{"1", "-", 
                            SubscriptBox["p", "0"]}], "]"}], "-", 
                        RowBox[{"Log", "[", 
                          RowBox[{"1", "-", 
                            SubscriptBox["p", "1"]}], "]"}], "+", 
                        RowBox[{"3", " ", 
                          RowBox[{"(", 
                            RowBox[{"3", "+", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  RowBox[{"1", "-", 
                                    SubscriptBox["p", "0"]}], "]"}]}], "-", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  RowBox[{"1", "-", 
                                    SubscriptBox["p", "1"]}], "]"}]}]}], 
                            ")"}], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                          SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}]}], 
                ")"}]}], ")"}]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"vp1", "-", 
          SubscriptBox["vp", "1"]}], "/.", "substs2"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", 
              RowBox[{"facts1", ",", "facts2", ",", "facts3"}], "]"}]}], 
          "]"}], "&"}]}]], "Input"],

Cell[BoxData["$Aborted"], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{
      RowBox[{"vptotal", "=", 
        RowBox[{"vp0", "+", "vp1"}]}], ";"}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{
          SuperscriptBox[
            RowBox[{"\[LeftBracketingBar]", 
              SubscriptBox["\[Beta]", "0"], "\[RightBracketingBar]"}], "2"], 
          "\[Congruent]", "\[Beta]20min"}], TraditionalForm]]],
  " which minimizes ",
  Cell[BoxData[
      FormBox["vptotal", TraditionalForm]]],
  ":"
}], "Subsection"],

Cell[CellGroupData[{

Cell[TextData[{
  "Local extremum at ",
  Cell[BoxData[
      FormBox["\[Beta]20local", TraditionalForm]]],
  " with value ",
  Cell[BoxData[
      FormBox[
        SubscriptBox["vptotalext", "local"], TraditionalForm]]],
  ":"
}], "Subsubsection"],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        SubscriptBox["\[PartialD]", 
          SubscriptBox["\[Beta]2", "0"]], "vptotal"}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"Solve", "[", 
        RowBox[{
          RowBox[{"%", "\[Equal]", "0"}], ",", 
          SubscriptBox["\[Beta]2", "0"]}], "]"}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp1", "=", 
        RowBox[{
          SubscriptBox["\[Beta]2", "0"], "/.", "%"}]}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"\[Beta]20local", "=", 
        RowBox[{"1", "/", "2"}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp1", "-", 
        RowBox[{"{", "\[Beta]20local", "}"}]}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", 
              RowBox[{"facts1", ",", "facts2", ",", "facts3"}], "]"}]}], 
          "]"}], "&"}]}]}], "Input"],

Cell[BoxData[
    RowBox[{"{", "0", "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp2", "=", 
        RowBox[{"vptotal", "/.", 
          RowBox[{
            SubscriptBox["\[Beta]2", "0"], "\[Rule]", "\[Beta]20local"}]}]}], 
      ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{
        SubscriptBox["vptotalext", "local"], "=", 
        RowBox[{
          FractionBox["1", 
            RowBox[{"4", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    SubscriptBox["p", "0"], "-", 
                    SubscriptBox["p", "1"]}], ")"}], "3"]}]], 
          RowBox[{"(", 
            RowBox[{
              SubsuperscriptBox["p", "0", "3"], "-", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SubscriptBox["p", "1"]}], ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"2", " ", 
                      RowBox[{"Log", "[", 
                        FractionBox[
                          RowBox[{
                            RowBox[{"-", "1"}], "+", 
                            SubscriptBox["p", "0"]}], 
                          RowBox[{
                            RowBox[{"-", "1"}], "+", 
                            SubscriptBox["p", "1"]}]], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                      RowBox[{"(", 
                        RowBox[{"1", "+", 
                          RowBox[{"Log", "[", 
                            FractionBox[
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["p", "0"]}], 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["p", "1"]}]], "]"}]}], ")"}], 
                      " ", 
                      SubscriptBox["p", "1"]}], "+", 
                    SubsuperscriptBox["p", "1", "2"]}], ")"}]}], "+", 
              RowBox[{
                SubsuperscriptBox["p", "0", "2"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Log", "[", 
                        RowBox[{"1", "-", 
                          SubscriptBox["p", "0"]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                      RowBox[{"Log", "[", 
                        RowBox[{"1", "-", 
                          SubscriptBox["p", "1"]}], "]"}]}], "+", 
                    RowBox[{
                      SubscriptBox["p", "1"], " ", 
                      RowBox[{"(", 
                        RowBox[{"3", "-", 
                          RowBox[{"4", " ", 
                            RowBox[{"Log", "[", 
                              RowBox[{"1", "-", 
                                SubscriptBox["p", "0"]}], "]"}]}], "+", 
                          RowBox[{"4", " ", 
                            RowBox[{"Log", "[", 
                              RowBox[{"1", "-", 
                                SubscriptBox["p", "1"]}], "]"}]}], "+", 
                          RowBox[{"2", " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"Log", "[", 
                                  RowBox[{"1", "-", 
                                    SubscriptBox["p", "0"]}], "]"}], "-", 
                                RowBox[{"Log", "[", 
                                  RowBox[{
                                    SubscriptBox["p", "0"], " ", 
                                    RowBox[{"(", 
                                      RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        FractionBox["1", 
                                        SubscriptBox["p", "1"]]}], ")"}]}], 
                                  "]"}]}], ")"}], " ", 
                            SubscriptBox["p", "1"]}]}], ")"}]}]}], ")"}]}], 
              "+", 
              RowBox[{
                SubscriptBox["p", "0"], " ", 
                RowBox[{"(", 
                  RowBox[{"2", "-", 
                    RowBox[{"4", " ", 
                      RowBox[{"Log", "[", 
                        RowBox[{"1", "-", 
                          SubscriptBox["p", "0"]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                      RowBox[{"Log", "[", 
                        RowBox[{"1", "-", 
                          SubscriptBox["p", "1"]}], "]"}]}], "+", 
                    RowBox[{
                      SubscriptBox["p", "1"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"Log", "[", 
                            FractionBox[
                              SuperscriptBox[
                                RowBox[{"(", 
                                  RowBox[{
                                    RowBox[{"-", "1"}], "+", 
                                    SubscriptBox["p", "0"]}], ")"}], "8"], 
                              SuperscriptBox[
                                RowBox[{"(", 
                                  RowBox[{
                                    RowBox[{"-", "1"}], "+", 
                                    SubscriptBox["p", "1"]}], ")"}], "8"]], 
                            "]"}], "+", 
                          RowBox[{
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "3"}], "-", 
                                RowBox[{"4", " ", 
                                  RowBox[{"Log", "[", 
                                    RowBox[{"1", "-", 
                                      SubscriptBox["p", "0"]}], "]"}]}], "+", 
                                
                                RowBox[{"4", " ", 
                                  RowBox[{"Log", "[", 
                                    RowBox[{"1", "-", 
                                      SubscriptBox["p", "1"]}], "]"}]}]}], 
                              ")"}], " ", 
                            SubscriptBox["p", "1"]}]}], ")"}]}]}], ")"}]}]}], 
            ")"}]}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        SubscriptBox["vptotalext", "local"], "-", "tmp2"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", 
              RowBox[{"facts1", ",", "facts2", ",", "facts3"}], "]"}]}], 
          "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "Values ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          SubscriptBox["vptotalext", "0"], ",", 
          SubscriptBox["vptotalext", "1"]}], TraditionalForm]]],
  " of boundaries at ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          SubscriptBox["\[Beta]2", "0"], "=", "0"}], TraditionalForm]]],
  " and ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          SubscriptBox["\[Beta]2", "0"], "=", "1"}], TraditionalForm]]],
  " respectively:"
}], "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp1", "=", 
        RowBox[{"vptotal", "/.", 
          RowBox[{"{", 
            RowBox[{
              SubscriptBox["\[Beta]2", "0"], "\[Rule]", "0"}], "}"}]}]}], 
      ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{
        SubscriptBox["vptotalext", "0"], "=", 
        RowBox[{
          FractionBox["1", 
            SuperscriptBox[
              RowBox[{"(", 
                RowBox[{
                  SubscriptBox["p", "0"], "-", 
                  SubscriptBox["p", "1"]}], ")"}], "3"]], 
          RowBox[{"(", 
            RowBox[{
              RowBox[{"-", 
                FractionBox[
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["p", "0"]}], ")"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["p", "1"]}], ")"}], "2"], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{
                          RowBox[{"-", "2"}], " ", 
                          RowBox[{"Log", "[", 
                            RowBox[{"1", "-", 
                              SubscriptBox["p", "0"]}], "]"}]}], "+", 
                        RowBox[{"2", " ", 
                          RowBox[{"Log", "[", 
                            RowBox[{"1", "-", 
                              SubscriptBox["p", "1"]}], "]"}]}], "+", 
                        RowBox[{
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "2"}], "+", 
                              RowBox[{"Log", "[", 
                                RowBox[{"1", "-", 
                                  SubscriptBox["p", "0"]}], "]"}], "-", 
                              RowBox[{"Log", "[", 
                                RowBox[{"1", "-", 
                                  SubscriptBox["p", "1"]}], "]"}]}], ")"}], 
                          " ", 
                          SubscriptBox["p", "0"]}], "+", 
                        RowBox[{
                          RowBox[{"(", 
                            RowBox[{"2", "+", 
                              RowBox[{"Log", "[", 
                                FractionBox[
                                  RowBox[{
                                    RowBox[{"-", "1"}], "+", 
                                    SubscriptBox["p", "0"]}], 
                                  RowBox[{
                                    RowBox[{"-", "1"}], "+", 
                                    SubscriptBox["p", "1"]}]], "]"}]}], ")"}],
                           " ", 
                          SubscriptBox["p", "1"]}]}], ")"}]}], 
                  RowBox[{
                    RowBox[{"-", "2"}], "+", 
                    SubscriptBox["p", "0"], "+", 
                    SubscriptBox["p", "1"]}]]}], "+", 
              FractionBox[
                RowBox[{
                  SubsuperscriptBox["p", "0", "2"], " ", 
                  SubsuperscriptBox["p", "1", "2"], " ", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", "2"}], "+", 
                            RowBox[{"Log", "[", 
                              SubscriptBox["p", "0"], "]"}], "-", 
                            RowBox[{"Log", "[", 
                              SubscriptBox["p", "1"], "]"}]}], ")"}], " ", 
                        SubscriptBox["p", "0"]}], "+", 
                      RowBox[{
                        RowBox[{"(", 
                          RowBox[{"2", "+", 
                            RowBox[{"Log", "[", 
                              SubscriptBox["p", "0"], "]"}], "-", 
                            RowBox[{"Log", "[", 
                              SubscriptBox["p", "1"], "]"}]}], ")"}], " ", 
                        SubscriptBox["p", "1"]}]}], ")"}]}], 
                RowBox[{
                  SubscriptBox["p", "0"], "+", 
                  SubscriptBox["p", "1"]}]]}], ")"}]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        SubscriptBox["vptotalext", "0"], "-", "tmp1"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", 
              RowBox[{"facts1", ",", "facts2", ",", "facts3"}], "]"}]}], 
          "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp2", "=", 
        RowBox[{"vptotal", "/.", 
          RowBox[{"{", 
            RowBox[{
              SubscriptBox["\[Beta]2", "0"], "\[Rule]", "1"}], "}"}]}]}], 
      ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{
        SubscriptBox["vptotalext", "1"], "=", 
        RowBox[{
          FractionBox["1", 
            SuperscriptBox[
              RowBox[{"(", 
                RowBox[{
                  SubscriptBox["p", "0"], "-", 
                  SubscriptBox["p", "1"]}], ")"}], "3"]], 
          RowBox[{"(", 
            RowBox[{
              RowBox[{"-", 
                FractionBox[
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["p", "0"]}], ")"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["p", "1"]}], ")"}], "2"], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{
                          RowBox[{"-", "2"}], " ", 
                          RowBox[{"Log", "[", 
                            RowBox[{"1", "-", 
                              SubscriptBox["p", "0"]}], "]"}]}], "+", 
                        RowBox[{"2", " ", 
                          RowBox[{"Log", "[", 
                            RowBox[{"1", "-", 
                              SubscriptBox["p", "1"]}], "]"}]}], "+", 
                        RowBox[{
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "2"}], "+", 
                              RowBox[{"Log", "[", 
                                RowBox[{"1", "-", 
                                  SubscriptBox["p", "0"]}], "]"}], "-", 
                              RowBox[{"Log", "[", 
                                RowBox[{"1", "-", 
                                  SubscriptBox["p", "1"]}], "]"}]}], ")"}], 
                          " ", 
                          SubscriptBox["p", "0"]}], "+", 
                        RowBox[{
                          RowBox[{"(", 
                            RowBox[{"2", "+", 
                              RowBox[{"Log", "[", 
                                FractionBox[
                                  RowBox[{
                                    RowBox[{"-", "1"}], "+", 
                                    SubscriptBox["p", "0"]}], 
                                  RowBox[{
                                    RowBox[{"-", "1"}], "+", 
                                    SubscriptBox["p", "1"]}]], "]"}]}], ")"}],
                           " ", 
                          SubscriptBox["p", "1"]}]}], ")"}]}], 
                  RowBox[{
                    RowBox[{"-", "2"}], "+", 
                    SubscriptBox["p", "0"], "+", 
                    SubscriptBox["p", "1"]}]]}], "+", 
              FractionBox[
                RowBox[{
                  SubsuperscriptBox["p", "0", "2"], " ", 
                  SubsuperscriptBox["p", "1", "2"], " ", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", "2"}], "+", 
                            RowBox[{"Log", "[", 
                              SubscriptBox["p", "0"], "]"}], "-", 
                            RowBox[{"Log", "[", 
                              SubscriptBox["p", "1"], "]"}]}], ")"}], " ", 
                        SubscriptBox["p", "0"]}], "+", 
                      RowBox[{
                        RowBox[{"(", 
                          RowBox[{"2", "+", 
                            RowBox[{"Log", "[", 
                              SubscriptBox["p", "0"], "]"}], "-", 
                            RowBox[{"Log", "[", 
                              SubscriptBox["p", "1"], "]"}]}], ")"}], " ", 
                        SubscriptBox["p", "1"]}]}], ")"}]}], 
                RowBox[{
                  SubscriptBox["p", "0"], "+", 
                  SubscriptBox["p", "1"]}]]}], ")"}]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        SubscriptBox["vptotalext", "1"], "-", "tmp2"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", 
              RowBox[{"facts1", ",", "facts2", ",", "facts3"}], "]"}]}], 
          "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Global minimum:", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"vptotal", "/.", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["p", "0"], "\[Rule]", "0.3"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[Rule]", "0.6"}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{"Plot", "[", 
      RowBox[{"%", ",", 
        RowBox[{"{", 
          RowBox[{
            SubscriptBox["\[Beta]2", "0"], ",", "0", ",", "1"}], "}"}]}], 
      "]"}]}], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 -9.98382 137.16 [
[.21429 .01639 -9 -9 ]
[.21429 .01639 9 0 ]
[.40476 .01639 -9 -9 ]
[.40476 .01639 9 0 ]
[.59524 .01639 -9 -9 ]
[.59524 .01639 9 0 ]
[.78571 .01639 -9 -9 ]
[.78571 .01639 9 0 ]
[.97619 .01639 -3 -9 ]
[.97619 .01639 3 0 ]
[.01131 .16605 -30 -4.5 ]
[.01131 .16605 0 4.5 ]
[.01131 .30321 -30 -4.5 ]
[.01131 .30321 0 4.5 ]
[.01131 .44037 -30 -4.5 ]
[.01131 .44037 0 4.5 ]
[.01131 .57753 -30 -4.5 ]
[.01131 .57753 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .02889 m
.21429 .03514 L
s
[(0.2)] .21429 .01639 0 1 Mshowa
.40476 .02889 m
.40476 .03514 L
s
[(0.4)] .40476 .01639 0 1 Mshowa
.59524 .02889 m
.59524 .03514 L
s
[(0.6)] .59524 .01639 0 1 Mshowa
.78571 .02889 m
.78571 .03514 L
s
[(0.8)] .78571 .01639 0 1 Mshowa
.97619 .02889 m
.97619 .03514 L
s
[(1)] .97619 .01639 0 1 Mshowa
.125 Mabswid
.07143 .02889 m
.07143 .03264 L
s
.11905 .02889 m
.11905 .03264 L
s
.16667 .02889 m
.16667 .03264 L
s
.2619 .02889 m
.2619 .03264 L
s
.30952 .02889 m
.30952 .03264 L
s
.35714 .02889 m
.35714 .03264 L
s
.45238 .02889 m
.45238 .03264 L
s
.5 .02889 m
.5 .03264 L
s
.54762 .02889 m
.54762 .03264 L
s
.64286 .02889 m
.64286 .03264 L
s
.69048 .02889 m
.69048 .03264 L
s
.7381 .02889 m
.7381 .03264 L
s
.83333 .02889 m
.83333 .03264 L
s
.88095 .02889 m
.88095 .03264 L
s
.92857 .02889 m
.92857 .03264 L
s
.25 Mabswid
0 .02889 m
1 .02889 L
s
.02381 .16605 m
.03006 .16605 L
s
[(0.074)] .01131 .16605 1 0 Mshowa
.02381 .30321 m
.03006 .30321 L
s
[(0.075)] .01131 .30321 1 0 Mshowa
.02381 .44037 m
.03006 .44037 L
s
[(0.076)] .01131 .44037 1 0 Mshowa
.02381 .57753 m
.03006 .57753 L
s
[(0.077)] .01131 .57753 1 0 Mshowa
.125 Mabswid
.02381 .05632 m
.02756 .05632 L
s
.02381 .08375 m
.02756 .08375 L
s
.02381 .11118 m
.02756 .11118 L
s
.02381 .13862 m
.02756 .13862 L
s
.02381 .19348 m
.02756 .19348 L
s
.02381 .22091 m
.02756 .22091 L
s
.02381 .24834 m
.02756 .24834 L
s
.02381 .27578 m
.02756 .27578 L
s
.02381 .33064 m
.02756 .33064 L
s
.02381 .35807 m
.02756 .35807 L
s
.02381 .3855 m
.02756 .3855 L
s
.02381 .41294 m
.02756 .41294 L
s
.02381 .4678 m
.02756 .4678 L
s
.02381 .49523 m
.02756 .49523 L
s
.02381 .52267 m
.02756 .52267 L
s
.02381 .5501 m
.02756 .5501 L
s
.02381 .00146 m
.02756 .00146 L
s
.02381 .60496 m
.02756 .60496 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .01472 m
.06244 .10635 L
.10458 .19746 L
.14415 .27463 L
.18221 .34117 L
.22272 .40374 L
.26171 .45593 L
.30316 .50274 L
.34309 .53941 L
.3815 .56687 L
.40095 .57785 L
.42237 .58767 L
.44268 .59479 L
.45178 .59728 L
.46172 .59952 L
.4671 .60051 L
.4721 .6013 L
.47727 .60198 L
.48196 .60248 L
.48658 .60285 L
.4887 .60299 L
.49093 .60311 L
.49332 .6032 L
.49438 .60324 L
.49552 .60327 L
.49675 .60329 L
.49789 .60331 L
.49859 .60331 L
.49925 .60332 L
.50049 .60332 L
.50163 .60331 L
.50286 .6033 L
.50401 .60328 L
.50508 .60325 L
.50754 .60317 L
.51014 .60305 L
.51268 .6029 L
.51504 .60273 L
.5204 .60224 L
.5293 .60109 L
.53882 .59941 L
.54906 .59707 L
.56016 .59392 L
.58032 .58658 L
.60019 .57726 L
.62123 .56517 L
.65912 .5376 L
.69946 .50005 L
.73829 .45593 L
.77956 .40045 L
Mistroke
.81932 .33864 L
.85757 .27144 L
.89827 .19159 L
.93745 .1066 L
.97619 .01472 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40n007h00Ooooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo001;ool20004ool00`00oooo
o`02ool4000Sool20004ool00`00ooooo`04ool00`00ooooo`0Qool20004ool00`00ooooo`03ool2
000Tool20004ool00`00ooooo`03ool2000Xool40006ool004[oo`04003ooooo0008ool00`00oooo
o`0Sool01000ooooo`002_oo00<00?ooool08?oo00@00?ooool000Soo`04003ooooo000Rool01000
ooooo`002?oo00@00?ooool002Woo`03003ooooo00Goo`00B_oo00@00?ooool000Woo`03003ooooo
02;oo`04003ooooo0007ool5000Qool01000ooooo`002?oo00@00?ooool002;oo`04003ooooo0008
ool01000ooooo`00:Ooo00<00?ooool01Ooo000Qool2000Wool01000ooooo`002_oo00<00?ooool0
8Ooo00@00?ooool000Ooo`04003ooooo000Rool01000ooooo`002?oo0`008ooo00@00?ooool000Wo
o`8002[oo`03003ooooo00Goo`008Ooo00<00?ooool09_oo00@00?ooool000_oo`03003ooooo023o
o`04003ooooo0008ool00`00ool0000Rool01000ooooo`002?oo00<00?ooool08ooo00@00?ooool0
00Soo`04003ooooo000Yool00`00ooooo`05ool0027oo`03003ooooo02Koo`04003ooooo0008ool0
1000ooooo`008_oo00@00?ooool000Woo`8002;oo`04003ooooo0008ool00`00ooooo`0Sool01000
ooooo`002?oo00@00?ooool002Ooo`<000Ooo`008Ooo00<00?ooool09ooo0P002_oo0P009?oo0P00
2ooo00<00?ooool08Ooo0P002_oo0`008ooo0P002_oo0P00:_oo00<00?ooool01Ooo000Qool00`00
ooooo`3dool00`00ooooo`05ool0027oo`03003ooooo0?Coo`03003ooooo00Goo`008Ooo0P00m?oo
00<00?ooool01_oo000Qool2003dool00`00ooooo`06ool001_oool000H000008Ooo00<00?oo0000
2Ooo00<00?ooool02_oo00<00?ooool02Ooo00<00?ooool02Ooo00<00?ooool02_oo00<00?ooool0
2Ooo00<00?ooool02Ooo00<00?ooool02_oo00<00?ooool02Ooo00<00?ooool02_oo00<00?ooool0
2Ooo00<00?ooool02Ooo00<00?ooool02_oo00<00?ooool02Ooo00<00?ooool02Ooo00<00?ooool0
2_oo00<00?ooool02Ooo00<00?ooool02_oo00<00?ooool02Ooo00<00?ooool01ooo00<00?oo0000
1ooo000Qool00`00ool0003bool00`00ooooo`07ool0027oo`04003ooooo003`ool00`00ooooo`08
ool0027oo`04003ooooo003`ool00`00ooooo`08ool0027oo`05003oooooool0003^ool00`00oooo
o`09ool0027oo`05003oooooool0003^ool00`00ooooo`09ool0027oo`8000?oo`03003ooooo0>[o
o`03003ooooo00[oo`008Ooo00<00?ooool00_oo00<00?ooool0j_oo00<00?ooool02_oo000Qool0
0`00ooooo`02ool00`00ooooo`3Zool00`00ooooo`0:ool0027oo`03003ooooo00?oo`03003ooooo
0>Soo`03003ooooo00_oo`008Ooo00<00?ooool00ooo00<00?ooool0j?oo00<00?ooool02ooo000Q
ool00`00ooooo`04ool00`00ooooo`3Vool00`00ooooo`0<ool0027oo`03003ooooo00Coo`03003o
oooo0>Koo`03003ooooo00coo`008Ooo0P001Ooo00<00?ooool0i_oo00<00?ooool03?oo000Qool0
0`00ooooo`05ool00`00ooooo`3Tool00`00ooooo`0=ool0027oo`03003ooooo00Goo`03003ooooo
0>Coo`03003ooooo00goo`008Ooo00<00?ooool01_oo00<00?ooool0h_oo00<00?ooool03_oo000Q
ool00`00ooooo`06ool00`00ooooo`3Rool00`00ooooo`0>ool0027oo`03003ooooo00Ooo`03003o
oooo0>3oo`03003ooooo00ooo`008Ooo00<00?ooool01ooo00<00?ooool0h?oo00<00?ooool03ooo
000Qool20008ool00`00ooooo`3Pool00`00ooooo`0?ool0027oo`03003ooooo00Soo`03003ooooo
0=koo`03003ooooo013oo`008Ooo00<00?ooool02?oo00<00?ooool0g_oo00<00?ooool04?oo000Q
ool00`00ooooo`09ool00`00ooooo`3Lool00`00ooooo`0Aool0027oo`03003ooooo00Woo`03003o
oooo0=coo`03003ooooo017oo`008Ooo00<00?ooool02_oo00<00?ooool0f_oo00<00?ooool04_oo
000Qool00`00ooooo`0:ool00`00ooooo`3Jool00`00ooooo`0Bool0027oo`8000coo`03003ooooo
0=Soo`03003ooooo01?oo`008Ooo00<00?ooool02ooo00<00?ooool0f?oo00<00?ooool04ooo000Q
ool00`00ooooo`0<ool00`00ooooo`3Fool00`00ooooo`0Dool0027oo`03003ooooo00coo`03003o
oooo0=Koo`03003ooooo01Coo`008Ooo00<00?ooool03Ooo00<00?ooool0eOoo00<00?ooool05?oo
0002ool20004ool00`00ooooo`03ool20004ool00`00ooooo`04ool00`00ooooo`03ool00`00oooo
o`0=ool00`00ooooo`3Dool00`00ooooo`0Eool00005ool00?ooool00008ool01000ooooo`000ooo
00<00?ooool01?oo00<00?ooool00ooo00<00?ooool03_oo00<00?ooool0dooo00<00?ooool05Ooo
00001Ooo003ooooo00002?oo00@00?ooool000Coo`03003ooooo00D000Coo`8000ooo`03003ooooo
0=;oo`03003ooooo01Koo`0000Goo`00ooooo`0000Soo`04003ooooo0004ool01000ooooo`000_oo
00<00?ooool00ooo00<00?ooool03ooo00<00?ooool0dOoo00<00?ooool05_oo00001Ooo003ooooo
00002?oo00@00?ooool000Goo`06003ooooo003oo`001Ooo00<00?ooool03ooo00<00?ooool0d?oo
00<00?ooool05ooo00001Ooo003ooooo00002?oo00@00?ooool000;oo`04003ooooo0003ool20005
ool00`00ooooo`0@ool00`00ooooo`3?ool00`00ooooo`0Gool000;oo`8000[oo`8000?oo`@000Co
o`03003ooooo00?oo`03003ooooo013oo`03003ooooo0<koo`03003ooooo01Soo`008Ooo00<00?oo
ool04Ooo00<00?ooool0cOoo00<00?ooool06?oo000Qool00`00ooooo`0Aool00`00ooooo`3<ool0
0`00ooooo`0Iool0027oo`8001?oo`03003ooooo0<_oo`03003ooooo01Woo`008Ooo00<00?ooool0
4_oo00<00?ooool0b_oo00<00?ooool06_oo000Qool00`00ooooo`0Bool00`00ooooo`3:ool00`00
ooooo`0Jool0027oo`03003ooooo01?oo`03003ooooo0<Soo`03003ooooo01_oo`008Ooo00<00?oo
ool04ooo00<00?ooool0b?oo00<00?ooool06ooo000Qool00`00ooooo`0Dool00`00ooooo`36ool0
0`00ooooo`0Lool0027oo`03003ooooo01Coo`03003ooooo0<Koo`03003ooooo01coo`008Ooo0P00
5_oo00<00?ooool0a?oo00<00?ooool07Ooo000Qool00`00ooooo`0Eool00`00ooooo`34ool00`00
ooooo`0Mool0027oo`03003ooooo01Koo`03003ooooo0<;oo`03003ooooo01koo`008Ooo00<00?oo
ool05_oo00<00?ooool0`_oo00<00?ooool07_oo000Qool00`00ooooo`0Gool00`00ooooo`30ool0
0`00ooooo`0Oool0027oo`03003ooooo01Ooo`03003ooooo0<3oo`03003ooooo01ooo`008Ooo00<0
0?ooool06?oo00<00?ooool0__oo00<00?ooool08?oo000Qool00`00ooooo`0Hool00`00ooooo`2n
ool00`00ooooo`0Pool0027oo`8001[oo`03003ooooo0;coo`03003ooooo027oo`008Ooo00<00?oo
ool06Ooo00<00?ooool0_?oo00<00?ooool08Ooo000Qool00`00ooooo`0Jool00`00ooooo`2jool0
0`00ooooo`0Rool0027oo`03003ooooo01[oo`03003ooooo0;[oo`03003ooooo02;oo`008Ooo00<0
0?ooool06ooo00<00?ooool0^?oo00<00?ooool08ooo000Qool00`00ooooo`0Kool00`00ooooo`2h
ool00`00ooooo`0Sool0027oo`03003ooooo01coo`03003ooooo0;Koo`03003ooooo02Coo`008Ooo
0P007_oo00<00?ooool0]?oo00<00?ooool09Ooo000Qool00`00ooooo`0Mool00`00ooooo`2dool0
0`00ooooo`0Uool0027oo`03003ooooo01koo`03003ooooo0;;oo`03003ooooo02Koo`008Ooo00<0
0?ooool07_oo00<00?ooool0/_oo00<00?ooool09_oo000Qool00`00ooooo`0Oool00`00ooooo`2`
ool00`00ooooo`0Wool000;oo`8000Coo`03003ooooo00?oo`8000Coo`03003ooooo00;oo`<000Go
o`03003ooooo01ooo`03003ooooo0;3oo`03003ooooo02Ooo`0000Goo`00ooooo`0000Soo`04003o
oooo0003ool00`00ooooo`05ool00`00ooooo`02ool00`00ooooo`0Pool00`00ooooo`2^ool00`00
ooooo`0Xool00005ool00?ooool00008ool01000ooooo`001?oo00<00?ooool01?oo00<00?ooool0
0_oo0P008Ooo00<00?ooool0[_oo00<00?ooool0:?oo00001Ooo003ooooo00002?oo00@00?ooool0
00Coo`04003oooooool30005ool00`00ooooo`0Qool00`00ooooo`2/ool00`00ooooo`0Yool00005
ool00?ooool00008ool01000ooooo`001Ooo00@00?ooool000Ooo`03003ooooo02;oo`03003ooooo
0:_oo`03003ooooo02Woo`0000Goo`00ooooo`0000Soo`04003ooooo0002ool01000ooooo`000_oo
00<00?ooool01Ooo00<00?ooool08_oo00<00?ooool0Z_oo00<00?ooool0:_oo0002ool2000:ool2
0003ool40002ool40004ool00`00ooooo`0Sool00`00ooooo`2Yool00`00ooooo`0Zool0027oo`03
003ooooo02?oo`03003ooooo0:Soo`03003ooooo02_oo`008Ooo00<00?ooool09?oo00<00?ooool0
Yooo00<00?ooool0:ooo000Qool2000Uool00`00ooooo`2Vool00`00ooooo`0/ool0027oo`03003o
oooo02Goo`03003ooooo0:Goo`03003ooooo02coo`008Ooo00<00?ooool09Ooo00<00?ooool0Y?oo
00<00?ooool0;Ooo000Qool00`00ooooo`0Vool00`00ooooo`2Rool00`00ooooo`0^ool0027oo`03
003ooooo02Ooo`03003ooooo0:7oo`03003ooooo02koo`008Ooo00<00?ooool09ooo00<00?ooool0
X?oo00<00?ooool0;ooo000Qool00`00ooooo`0Xool00`00ooooo`2Nool00`00ooooo`0`ool0027o
o`8002Woo`03003ooooo09koo`03003ooooo033oo`008Ooo00<00?ooool0:Ooo00<00?ooool0W?oo
00<00?ooool0<Ooo000Qool00`00ooooo`0Zool00`00ooooo`2Jool00`00ooooo`0bool0027oo`03
003ooooo02[oo`03003ooooo09[oo`03003ooooo03;oo`008Ooo00<00?ooool0:ooo00<00?ooool0
V?oo00<00?ooool0<ooo000Qool00`00ooooo`0/ool00`00ooooo`2Fool00`00ooooo`0dool0027o
o`03003ooooo02coo`03003ooooo09Goo`03003ooooo03Goo`008Ooo0P00;_oo00<00?ooool0U?oo
00<00?ooool0=Ooo000Qool00`00ooooo`0]ool00`00ooooo`2Cool00`00ooooo`0fool0027oo`03
003ooooo02koo`03003ooooo097oo`03003ooooo03Ooo`008Ooo00<00?ooool0;ooo00<00?ooool0
T?oo00<00?ooool0=ooo000Qool00`00ooooo`0_ool00`00ooooo`2?ool00`00ooooo`0hool0027o
o`03003ooooo033oo`03003ooooo08goo`03003ooooo03Woo`008Ooo00<00?ooool0<Ooo00<00?oo
ool0S?oo00<00?ooool0>Ooo000Qool2000cool00`00ooooo`2:ool00`00ooooo`0jool0027oo`03
003ooooo03;oo`03003ooooo08Woo`03003ooooo03_oo`008Ooo00<00?ooool0<ooo00<00?ooool0
Qooo00<00?ooool0??oo000Qool00`00ooooo`0dool00`00ooooo`26ool00`00ooooo`0lool0027o
o`03003ooooo03Goo`03003ooooo08Coo`03003ooooo03goo`008Ooo00<00?ooool0=Ooo00<00?oo
ool0Pooo00<00?ooool0?_oo0002ool20004ool00`00ooooo`03ool20004ool00`00ooooo`03ool2
0005ool00`00ooooo`0fool00`00ooooo`21ool00`00ooooo`0oool00005ool00?ooool00008ool0
1000ooooo`000ooo00<00?ooool00_oo00@00?ooool000Coo`03003ooooo03Ooo`03003ooooo083o
o`03003ooooo03ooo`0000Goo`00ooooo`0000Soo`04003ooooo0004ool01@00oooooooo00000_oo
00<00?ooool00_oo0P00>Ooo00<00?ooool0O_oo00<00?ooool0@?oo00001Ooo003ooooo00002?oo
00@00?ooool000Coo`04003oooooool30005ool00`00ooooo`0iool00`00ooooo`1lool00`00oooo
o`11ool00005ool00?ooool00008ool01000ooooo`001Ooo00@00?ooool000Ooo`03003ooooo03Wo
o`03003ooooo07_oo`03003ooooo04;oo`0000Goo`00ooooo`0000Soo`04003ooooo0002ool01000
ooooo`000_oo00<00?ooool01Ooo00<00?ooool0>_oo00<00?ooool0N_oo00<00?ooool0@_oo0002
ool2000:ool20003ool40003ool30004ool00`00ooooo`0kool00`00ooooo`1hool00`00ooooo`13
ool0027oo`03003ooooo03coo`03003ooooo07Koo`03003ooooo04Coo`008Ooo00<00?ooool0?Ooo
00<00?ooool0M?oo00<00?ooool0AOoo000Qool2000nool00`00ooooo`1cool00`00ooooo`16ool0
027oo`03003ooooo03koo`03003ooooo077oo`03003ooooo04Ooo`008Ooo00<00?ooool0?ooo00<0
0?ooool0Kooo00<00?ooool0B?oo000Qool00`00ooooo`10ool00`00ooooo`1^ool00`00ooooo`18
ool0027oo`03003ooooo047oo`03003ooooo06coo`03003ooooo04Woo`008Ooo00<00?ooool0@_oo
00<00?ooool0J_oo00<00?ooool0B_oo000Qool00`00ooooo`12ool00`00ooooo`1Yool00`00oooo
o`1;ool0027oo`8004Coo`03003ooooo06Ooo`03003ooooo04coo`008Ooo00<00?ooool0A?oo00<0
0?ooool0IOoo00<00?ooool0COoo000Qool00`00ooooo`15ool00`00ooooo`1Sool00`00ooooo`1>
ool0027oo`03003ooooo04Koo`03003ooooo067oo`03003ooooo04ooo`008Ooo00<00?ooool0Aooo
0P00H?oo00<00?ooool0D?oo000Qool00`00ooooo`19ool00`00ooooo`1Lool00`00ooooo`1Aool0
027oo`03003ooooo04[oo`03003ooooo05[oo`03003ooooo05;oo`008Ooo0P00C?oo00<00?ooool0
F?oo00<00?ooool0Dooo000Qool00`00ooooo`1<ool00`00ooooo`1Fool00`00ooooo`1Dool0027o
o`03003ooooo04goo`8005Goo`03003ooooo05Goo`008Ooo00<00?ooool0Cooo00<00?ooool0DOoo
00<00?ooool0E_oo000Qool00`00ooooo`1@ool00`00ooooo`1?ool00`00ooooo`1Gool0027oo`03
003ooooo057oo`8004goo`8005[oo`008Ooo00<00?ooool0Dooo00<00?ooool0BOoo00<00?ooool0
F_oo000Qool2001Eool00`00ooooo`16ool2001Mool0027oo`03003ooooo05Goo`8004Goo`03003o
oooo05goo`008Ooo00<00?ooool0Eooo00<00?ooool0@Ooo00<00?ooool0G_oo000Qool00`00oooo
o`1Hool2000oool2001Qool0027oo`03003ooooo05[oo`03003ooooo03_oo`03003ooooo067oo`00
0_oo0P001?oo00<00?ooool00ooo0P001?oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool0
Fooo0P00>Ooo0P00I?oo00001Ooo003ooooo00002?oo00@00?ooool000?oo`03003ooooo00?oo`03
003ooooo00Coo`03003ooooo05goo`8003Goo`8006Koo`0000Goo`00ooooo`0000Soo`04003ooooo
0004ool00`00ooooo`03ool00`00ooooo`03ool2001Pool00`00ooooo`0`ool2001Xool00005ool0
0?ooool00008ool01000ooooo`001?oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool0H?oo
0P00;_oo0P00J_oo00001Ooo003ooooo00002?oo00@00?ooool000Goo`03003ooooo00?oo`03003o
oooo00;oo`03003ooooo06;oo`8002[oo`8006coo`0000Goo`00ooooo`0000Soo`04003ooooo0002
ool01000ooooo`000_oo00@00?ooool000Coo`03003ooooo06Coo`8002Goo`<006koo`000_oo0P00
2_oo0P000ooo10000_oo10001?oo00<00?ooool0I_oo0`007_oo1000LOoo000Qool00`00ooooo`1Y
ool5000Fool3001eool0027oo`03003ooooo06koo`@000goo`D007Soo`008Ooo0P00Looo3@00OOoo
000Qool00`00ooooo`3lool0027oo`03003ooooo0?coo`008Ooo00<00?ooool0o?oo000Qool00`00
ooooo`3lool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.134313, 0.0724947, \
0.00403944, 2.80481*^-5}}],

Cell[BoxData[
    TagBox[
      RowBox[{"\[SkeletonIndicator]", "Graphics", "\[SkeletonIndicator]"}],
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"{", 
        RowBox[{
          SubscriptBox["vptotalext", "local"], ",", 
          SubscriptBox["vptotalext", "0"]}], "}"}], "/.", 
      RowBox[{"{", 
        RowBox[{
          RowBox[{
            SubscriptBox["p", "0"], "\[Rule]", "0.3"}], ",", 
          RowBox[{
            SubscriptBox["p", "1"], "\[Rule]", "0.6"}]}], "}"}]}]], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"0.07718802918001146`", ",", "0.0728966689127033`"}], 
      "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        SubscriptBox["vptotalext", "local"], "\[LessEqual]", 
        SubscriptBox["vptotalext", "0"]}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", 
              RowBox[{"facts1", ",", "facts2", ",", "facts3"}], "]"}]}], 
          "]"}], "&"}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        FractionBox["1", 
          RowBox[{"4", " ", 
            SuperscriptBox[
              RowBox[{"(", 
                RowBox[{
                  SubscriptBox["p", "0"], "-", 
                  SubscriptBox["p", "1"]}], ")"}], "3"]}]], 
        RowBox[{"(", 
          RowBox[{
            SubsuperscriptBox["p", "0", "3"], "-", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  SubscriptBox["p", "1"]}], ")"}], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"2", " ", 
                    RowBox[{"Log", "[", 
                      FractionBox[
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["p", "0"]}], 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["p", "1"]}]], "]"}]}], "-", 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                      RowBox[{"1", "+", 
                        RowBox[{"Log", "[", 
                          FractionBox[
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["p", "0"]}], 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["p", "1"]}]], "]"}]}], ")"}], " ", 
                    
                    SubscriptBox["p", "1"]}], "+", 
                  SubsuperscriptBox["p", "1", "2"]}], ")"}]}], "+", 
            RowBox[{
              SubsuperscriptBox["p", "0", "2"], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"-", "3"}], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Log", "[", 
                      RowBox[{"1", "-", 
                        SubscriptBox["p", "0"]}], "]"}]}], "-", 
                  RowBox[{"2", " ", 
                    RowBox[{"Log", "[", 
                      RowBox[{"1", "-", 
                        SubscriptBox["p", "1"]}], "]"}]}], "+", 
                  RowBox[{
                    SubscriptBox["p", "1"], " ", 
                    RowBox[{"(", 
                      RowBox[{"3", "-", 
                        RowBox[{"4", " ", 
                          RowBox[{"Log", "[", 
                            RowBox[{"1", "-", 
                              SubscriptBox["p", "0"]}], "]"}]}], "+", 
                        RowBox[{"4", " ", 
                          RowBox[{"Log", "[", 
                            RowBox[{"1", "-", 
                              SubscriptBox["p", "1"]}], "]"}]}], "+", 
                        RowBox[{"2", " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"Log", "[", 
                                RowBox[{"1", "-", 
                                  SubscriptBox["p", "0"]}], "]"}], "-", 
                              RowBox[{"Log", "[", 
                                RowBox[{
                                  SubscriptBox["p", "0"], " ", 
                                  RowBox[{"(", 
                                    RowBox[{
                                      RowBox[{"-", "1"}], "+", 
                                      FractionBox["1", 
                                        SubscriptBox["p", "1"]]}], ")"}]}], 
                                "]"}]}], ")"}], " ", 
                          SubscriptBox["p", "1"]}]}], ")"}]}]}], ")"}]}], "+",
             
            RowBox[{
              SubscriptBox["p", "0"], " ", 
              RowBox[{"(", 
                RowBox[{"2", "-", 
                  RowBox[{"4", " ", 
                    RowBox[{"Log", "[", 
                      RowBox[{"1", "-", 
                        SubscriptBox["p", "0"]}], "]"}]}], "+", 
                  RowBox[{"4", " ", 
                    RowBox[{"Log", "[", 
                      RowBox[{"1", "-", 
                        SubscriptBox["p", "1"]}], "]"}]}], "+", 
                  RowBox[{
                    SubscriptBox["p", "1"], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"Log", "[", 
                          FractionBox[
                            SuperscriptBox[
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", "1"}], "+", 
                                  SubscriptBox["p", "0"]}], ")"}], "8"], 
                            SuperscriptBox[
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", "1"}], "+", 
                                  SubscriptBox["p", "1"]}], ")"}], "8"]], 
                          "]"}], "+", 
                        RowBox[{
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "3"}], "-", 
                              RowBox[{"4", " ", 
                                RowBox[{"Log", "[", 
                                  RowBox[{"1", "-", 
                                    SubscriptBox["p", "0"]}], "]"}]}], "+", 
                              RowBox[{"4", " ", 
                                RowBox[{"Log", "[", 
                                  RowBox[{"1", "-", 
                                    SubscriptBox["p", "1"]}], "]"}]}]}], 
                            ")"}], " ", 
                          SubscriptBox["p", "1"]}]}], ")"}]}]}], ")"}]}], "-",
             
            RowBox[{"4", " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"-", 
                    FractionBox[
                      RowBox[{
                        SuperscriptBox[
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["p", "0"]}], ")"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["p", "1"]}], ")"}], "2"], " ", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{
                              RowBox[{"-", "2"}], " ", 
                              RowBox[{"Log", "[", 
                                RowBox[{"1", "-", 
                                  SubscriptBox["p", "0"]}], "]"}]}], "+", 
                            RowBox[{"2", " ", 
                              RowBox[{"Log", "[", 
                                RowBox[{"1", "-", 
                                  SubscriptBox["p", "1"]}], "]"}]}], "+", 
                            RowBox[{
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", "2"}], "+", 
                                  RowBox[{"Log", "[", 
                                    RowBox[{"1", "-", 
                                      SubscriptBox["p", "0"]}], "]"}], "-", 
                                  RowBox[{"Log", "[", 
                                    RowBox[{"1", "-", 
                                      SubscriptBox["p", "1"]}], "]"}]}], 
                                ")"}], " ", 
                              SubscriptBox["p", "0"]}], "+", 
                            RowBox[{
                              RowBox[{"(", 
                                RowBox[{"2", "+", 
                                  RowBox[{"Log", "[", 
                                    FractionBox[
                                      RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "0"]}], 
                                      RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "1"]}]], "]"}]}], 
                                ")"}], " ", 
                              SubscriptBox["p", "1"]}]}], ")"}]}], 
                      RowBox[{
                        RowBox[{"-", "2"}], "+", 
                        SubscriptBox["p", "0"], "+", 
                        SubscriptBox["p", "1"]}]]}], "+", 
                  FractionBox[
                    RowBox[{
                      SubsuperscriptBox["p", "0", "2"], " ", 
                      SubsuperscriptBox["p", "1", "2"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "2"}], "+", 
                                RowBox[{"Log", "[", 
                                  FractionBox[
                                    SubscriptBox["p", "0"], 
                                    SubscriptBox["p", "1"]], "]"}]}], ")"}], 
                            " ", 
                            SubscriptBox["p", "0"]}], "+", 
                          RowBox[{
                            RowBox[{"(", 
                              RowBox[{"2", "+", 
                                RowBox[{"Log", "[", 
                                  FractionBox[
                                    SubscriptBox["p", "0"], 
                                    SubscriptBox["p", "1"]], "]"}]}], ")"}], 
                            " ", 
                            SubscriptBox["p", "1"]}]}], ")"}]}], 
                    RowBox[{
                      SubscriptBox["p", "0"], "+", 
                      SubscriptBox["p", "1"]}]]}], ")"}]}]}], ")"}]}], 
      "\[LessEqual]", "0"}]], "Output"]
}, Open  ]],

Cell[BoxData[""], "Input"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
Evaluator->"Local",
WindowSize->{1025, 740},
WindowMargins->{{-4, Automatic}, {Automatic, 0}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 3327, 86, 103, "Input"],
Cell[5047, 137, 545, 18, 32, "Text"],

Cell[CellGroupData[{
Cell[5617, 159, 2558, 57, 50, "Subsection"],
Cell[8178, 218, 483, 14, 29, "Input"],
Cell[8664, 234, 773, 21, 49, "Input"],
Cell[9440, 257, 866, 22, 47, "Input"],
Cell[10309, 281, 363, 10, 44, "Input"],

Cell[CellGroupData[{
Cell[10697, 295, 4287, 104, 121, "Input"],
Cell[14987, 401, 28, 0, 27, "Output"]
}, Open  ]],
Cell[15030, 404, 784, 22, 75, "Input"],
Cell[15817, 428, 3508, 79, 87, "Input"],

Cell[CellGroupData[{
Cell[19350, 511, 279, 8, 27, "Input"],
Cell[19632, 521, 28, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19697, 526, 5276, 137, 122, "Input"],
Cell[24976, 665, 28, 0, 27, "Output"]
}, Open  ]],
Cell[25019, 668, 417, 11, 43, "Input"],
Cell[25439, 681, 3355, 78, 46, "Input"],

Cell[CellGroupData[{
Cell[28819, 763, 305, 9, 29, "Input"],
Cell[29127, 774, 28, 0, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[29204, 780, 550, 15, 46, "Subsection"],
Cell[29757, 797, 3957, 86, 104, "Input"],

Cell[CellGroupData[{
Cell[33739, 887, 359, 10, 29, "Input"],
Cell[34101, 899, 3813, 87, 87, "Output"]
}, Open  ]],
Cell[37929, 989, 5481, 120, 138, "Input"],

Cell[CellGroupData[{
Cell[43435, 1113, 359, 10, 29, "Input"],
Cell[43797, 1125, 35, 0, 27, "Output"]
}, Open  ]],
Cell[43847, 1128, 113, 3, 27, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[43997, 1136, 384, 12, 45, "Subsection"],

Cell[CellGroupData[{
Cell[44406, 1152, 248, 9, 43, "Subsubsection"],
Cell[44657, 1163, 499, 15, 62, "Input"],

Cell[CellGroupData[{
Cell[45181, 1182, 454, 12, 43, "Input"],
Cell[45638, 1196, 53, 1, 27, "Output"]
}, Open  ]],
Cell[45706, 1200, 209, 6, 28, "Input"],

Cell[CellGroupData[{
Cell[45940, 1210, 6426, 140, 215, "Input"],
Cell[52369, 1352, 28, 0, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[52446, 1358, 507, 18, 43, "Subsubsection"],
Cell[52956, 1378, 231, 7, 28, "Input"],

Cell[CellGroupData[{
Cell[53212, 1389, 4471, 101, 172, "Input"],
Cell[57686, 1492, 28, 0, 27, "Output"]
}, Open  ]],
Cell[57729, 1495, 231, 7, 28, "Input"],

Cell[CellGroupData[{
Cell[57985, 1506, 4471, 101, 172, "Input"],
Cell[62459, 1609, 28, 0, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[62536, 1615, 40, 0, 42, "Subsubsection"],

Cell[CellGroupData[{
Cell[62601, 1619, 504, 15, 44, "Input"],
Cell[63108, 1636, 15247, 406, 186, 3754, 260, "GraphicsData", "PostScript", \
"Graphics"],
Cell[78358, 2044, 149, 4, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[78544, 2053, 389, 11, 29, "Input"],
Cell[78936, 2066, 124, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[79097, 2074, 379, 10, 29, "Input"],
Cell[79479, 2086, 9950, 213, 275, "Output"]
}, Open  ]],
Cell[89444, 2302, 26, 0, 27, "Input"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

