(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     34993,        816]*)
(*NotebookOutlinePosition[     35652,        840]*)
(*  CellTagsIndexPosition[     35608,        836]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[{
    RowBox[{
      RowBox[{"facts1", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"\[Theta]", "\[GreaterEqual]", "0"}], ",", 
            RowBox[{"\[Theta]", "\[LessEqual]", 
              RowBox[{"\[Pi]", "/", "2"}]}], ",", 
            RowBox[{"\[CurlyPhi]", "\[GreaterEqual]", "0"}], ",", 
            RowBox[{"\[CurlyPhi]", "\[LessEqual]", 
              RowBox[{"2", "\[Pi]"}]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "0"}]], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "0"}]], "\[LessEqual]", "1"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "1"}]], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "1"}]], "\[LessEqual]", "1"}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"facts2", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["\[Beta]2", "0"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["\[Beta]2", "0"], "\[LessEqual]", "1"}]}], "}"}]}],
       ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"facts3", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["p", "0"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["p", "0"], "\[LessEqual]", "1"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[LessEqual]", "1"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[GreaterEqual]", 
              SubscriptBox["p", "0"]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"substs1", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              RowBox[{"Abs", "[", 
                SubscriptBox["\[Beta]", "0"], "]"}], "\[Rule]", 
              SqrtBox[
                SubscriptBox["\[Beta]2", "0"]]}], ",", 
            RowBox[{
              RowBox[{"Abs", "[", 
                SubscriptBox["\[Beta]", "1"], "]"}], "\[Rule]", 
              SqrtBox[
                RowBox[{"1", "-", 
                  SubscriptBox["\[Beta]2", "0"]}]]}], ",", 
            RowBox[{
              RowBox[{"Abs", "[", 
                RowBox[{
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                  SubscriptBox["\[Beta]", "0"]}], "]"}], "\[Rule]", 
              RowBox[{
                SqrtBox[
                  SubscriptBox["\[Beta]2", "0"]], 
                RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], ",", 
            RowBox[{
              RowBox[{"Abs", "[", 
                RowBox[{
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                  SubscriptBox["\[Beta]", "1"]}], "]"}], "\[Rule]", 
              RowBox[{
                SqrtBox[
                  RowBox[{"1", "-", 
                    SubscriptBox["\[Beta]2", "0"]}]], 
                RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"substs2", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"0", ",", "0"}]], "\[Rule]", 
              SubscriptBox["p", "0"]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"0", ",", "1"}]], "\[Rule]", 
              SubscriptBox["p", "1"]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"1", ",", "0"}]], "\[Rule]", 
              RowBox[{"1", "-", 
                SubscriptBox["p", "0"]}]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"1", ",", "1"}]], "\[Rule]", 
              RowBox[{"1", "-", 
                SubscriptBox["p", "1"]}]}]}], "}"}]}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[TextData[{
  "The parameters ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          SubscriptBox["p", "0"], ",", 
          SubscriptBox["p", "1"], ",", 
          SubscriptBox["\[Beta]2", "0"]}], TraditionalForm]]],
  " that minimize the deviation for a given disturbance"
}], "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"vptotal", "=", 
        RowBox[{
          RowBox[{
            RowBox[{"-", 
              FractionBox["1", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"-", 
                          SubscriptBox["p", "0"]}], "+", 
                        SubscriptBox["p", "1"]}], ")"}], "3"], " ", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", "2"}], "+", 
                      SubscriptBox["p", "0"], "+", 
                      SubscriptBox["p", "1"]}], ")"}]}]]}], 
            RowBox[{"(", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{"1", "-", 
                    SubscriptBox["p", "0"]}], ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{"1", "-", 
                    SubscriptBox["p", "1"]}], ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox[
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", "1"}], "+", 
                            SubscriptBox["p", "0"]}], ")"}], "3"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                      SubscriptBox["\[Beta]2", "0"]}], "-", 
                    RowBox[{
                      SuperscriptBox[
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", "1"}], "+", 
                            SubscriptBox["p", "1"]}], ")"}], "3"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                      SubscriptBox["\[Beta]2", "0"]}], "+", 
                    RowBox[{
                      SuperscriptBox[
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", "1"}], "+", 
                            SubscriptBox["p", "0"]}], ")"}], "2"], " ", 
                      RowBox[{"(", 
                        RowBox[{"1", "-", 
                          SubscriptBox["p", "1"]}], ")"}], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "2"}], "+", 
                          RowBox[{"Log", "[", 
                            RowBox[{"1", "-", 
                              SubscriptBox["p", "0"]}], "]"}], "-", 
                          RowBox[{"Log", "[", 
                            RowBox[{"1", "-", 
                              SubscriptBox["p", "1"]}], "]"}], "+", 
                          RowBox[{"3", " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "3"}], "+", 
                                RowBox[{"2", " ", 
                                  RowBox[{"Log", "[", 
                                    RowBox[{"1", "-", 
                                      SubscriptBox["p", "0"]}], "]"}]}], "-", 
                                
                                RowBox[{"2", " ", 
                                  RowBox[{"Log", "[", 
                                    RowBox[{"1", "-", 
                                      SubscriptBox["p", "1"]}], "]"}]}]}], 
                              ")"}], " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                            SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "+", 
                    RowBox[{
                      RowBox[{"(", 
                        RowBox[{"1", "-", 
                          SubscriptBox["p", "0"]}], ")"}], " ", 
                      SuperscriptBox[
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", "1"}], "+", 
                            SubscriptBox["p", "1"]}], ")"}], "2"], " ", 
                      RowBox[{"(", 
                        RowBox[{"2", "+", 
                          RowBox[{"Log", "[", 
                            RowBox[{"1", "-", 
                              SubscriptBox["p", "0"]}], "]"}], "-", 
                          RowBox[{"Log", "[", 
                            RowBox[{"1", "-", 
                              SubscriptBox["p", "1"]}], "]"}], "+", 
                          RowBox[{"3", " ", 
                            RowBox[{"(", 
                              RowBox[{"3", "+", 
                                RowBox[{"2", " ", 
                                  RowBox[{"Log", "[", 
                                    RowBox[{"1", "-", 
                                      SubscriptBox["p", "0"]}], "]"}]}], "-", 
                                
                                RowBox[{"2", " ", 
                                  RowBox[{"Log", "[", 
                                    RowBox[{"1", "-", 
                                      SubscriptBox["p", "1"]}], "]"}]}]}], 
                              ")"}], " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                            SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}]}], 
                  ")"}]}], ")"}]}], "+", 
          FractionBox["1", 
            RowBox[{
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    SubscriptBox["p", "0"], "-", 
                    SubscriptBox["p", "1"]}], ")"}], "3"], " ", 
              RowBox[{"(", 
                RowBox[{
                  SubscriptBox["p", "0"], "+", 
                  SubscriptBox["p", "1"]}], ")"}]}]], 
          RowBox[{"(", 
            RowBox[{
              SubscriptBox["p", "0"], " ", 
              SubscriptBox["p", "1"], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{
                    RowBox[{"-", 
                      SubsuperscriptBox["p", "0", "3"]}], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                    SubscriptBox["\[Beta]2", "0"]}], "+", 
                  RowBox[{
                    SubsuperscriptBox["p", "1", "3"], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                    SubscriptBox["\[Beta]2", "0"]}], "+", 
                  RowBox[{
                    SubsuperscriptBox["p", "0", "2"], " ", 
                    SubscriptBox["p", "1"], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"-", "2"}], "+", 
                        RowBox[{"Log", "[", 
                          SubscriptBox["p", "0"], "]"}], "-", 
                        RowBox[{"Log", "[", 
                          SubscriptBox["p", "1"], "]"}], "+", 
                        RowBox[{"3", " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "3"}], "+", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  SubscriptBox["p", "0"], "]"}]}], "-", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  SubscriptBox["p", "1"], "]"}]}]}], ")"}], 
                          " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                          SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "+", 
                  RowBox[{
                    SubscriptBox["p", "0"], " ", 
                    SubsuperscriptBox["p", "1", "2"], " ", 
                    RowBox[{"(", 
                      RowBox[{"2", "+", 
                        RowBox[{"Log", "[", 
                          SubscriptBox["p", "0"], "]"}], "-", 
                        RowBox[{"Log", "[", 
                          SubscriptBox["p", "1"], "]"}], "+", 
                        RowBox[{"3", " ", 
                          RowBox[{"(", 
                            RowBox[{"3", "+", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  SubscriptBox["p", "0"], "]"}]}], "-", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  SubscriptBox["p", "1"], "]"}]}]}], ")"}], 
                          " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                          SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}]}], 
                ")"}]}], ")"}]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"stotal", "=", 
        RowBox[{
          FractionBox["1", "12"], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SubscriptBox["p", "1"], " ", 
                RowBox[{"(", 
                  RowBox[{"3", "-", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "+", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SubscriptBox["p", "1"]}], ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "-", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SubscriptBox["p", "0"]}], ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{"1", "+", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "+", 
              RowBox[{
                SubscriptBox["p", "0"], " ", 
                RowBox[{"(", 
                  RowBox[{"1", "+", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], "+", 
              RowBox[{"4", " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      RowBox[{"-", 
                        SubscriptBox["p", "1"]}], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "2"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}]}], "+", 
                    RowBox[{
                      SubscriptBox["\[Beta]2", "0"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"2", " ", 
                            SqrtBox[
                              RowBox[{
                                SubscriptBox["p", "0"], " ", 
                                SubscriptBox["p", "1"]}]], " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}]}], "-",
                           
                          RowBox[{
                            SubscriptBox["p", "0"], " ", 
                            RowBox[{"(", 
                              RowBox[{"1", "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}]}]}], 
                        ")"}]}]}], ")"}]}], "+", 
              RowBox[{"4", " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "2"}], "+", 
                    RowBox[{
                      SubscriptBox["p", "1"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "2"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}]}], "+", 
                    RowBox[{
                      SubscriptBox["\[Beta]2", "0"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"2", " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SqrtBox[
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "0"]}], ")"}], " ", 
                                    
                                    RowBox[{"(", 
                                      RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "1"]}], ")"}]}]]}], 
                              ")"}], " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}]}], "+",
                           
                          RowBox[{
                            SubscriptBox["p", "0"], " ", 
                            RowBox[{"(", 
                              RowBox[{"1", "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}]}]}], 
                        ")"}]}]}], ")"}]}], "+", 
              RowBox[{
                FractionBox["1", 
                  SuperscriptBox[
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"-", 
                          SubscriptBox["p", "0"]}], "+", 
                        SubscriptBox["p", "1"]}], ")"}], "3"]], 
                RowBox[{"(", 
                  RowBox[{"6", " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", "1"}], "+", 
                                  SubscriptBox["p", "1"]}], ")"}], "4"]}], 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}], 
                            "2"]}], "+", 
                        RowBox[{
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["p", "0"]}], ")"}], "4"], " ", 
                          SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                        RowBox[{"4", " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["p", "0"]}], ")"}], " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["p", "1"]}], ")"}], "3"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              RowBox[{"2", " ", 
                                SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], 
                        "-", 
                        RowBox[{"4", " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["p", "0"]}], ")"}], "3"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["p", "1"]}], ")"}], " ", 
                          SubscriptBox["\[Beta]2", "0"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              RowBox[{"2", " ", 
                                SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], 
                        "+", 
                        RowBox[{
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["p", "0"]}], ")"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["p", "1"]}], ")"}], "2"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "3"}], "+", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  RowBox[{"1", "-", 
                                    SubscriptBox["p", "0"]}], "]"}]}], "-", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  RowBox[{"1", "-", 
                                    SubscriptBox["p", "1"]}], "]"}]}], "+", 
                              RowBox[{
                                SubscriptBox["\[Beta]2", "0"], " ", 
                                RowBox[{"(", 
                                  RowBox[{"6", "+", 
                                    RowBox[{"Log", "[", 
                                      FractionBox["1", 
                                        SuperscriptBox[
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "0"]}], ")"}], 
                                        "12"]], "]"}], "+", 
                                    RowBox[{"Log", "[", 
                                      SuperscriptBox[
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "1"]}], ")"}], 
                                        "12"], "]"}], "+", 
                                    RowBox[{"12", " ", 
                                      RowBox[{"Log", "[", 
                                        FractionBox[
                                        RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "0"]}], 
                                        RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["p", "1"]}]], "]"}], " ",
                                       
                                      SubscriptBox["\[Beta]2", "0"]}]}], 
                                  ")"}]}]}], ")"}]}]}], ")"}]}], ")"}]}], "+",
               
              RowBox[{
                FractionBox["1", 
                  SuperscriptBox[
                    RowBox[{"(", 
                      RowBox[{
                        SubscriptBox["p", "0"], "-", 
                        SubscriptBox["p", "1"]}], ")"}], "3"]], 
                RowBox[{"(", 
                  RowBox[{"6", " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{
                          RowBox[{"-", 
                            SubsuperscriptBox["p", "1", "4"]}], " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}], 
                            "2"]}], "+", 
                        RowBox[{"4", " ", 
                          SubsuperscriptBox["p", "0", "3"], " ", 
                          SubscriptBox["p", "1"], " ", 
                          RowBox[{"(", 
                            RowBox[{"1", "-", 
                              RowBox[{"2", " ", 
                                SubscriptBox["\[Beta]2", "0"]}]}], ")"}], " ",
                           
                          SubscriptBox["\[Beta]2", "0"]}], "+", 
                        RowBox[{
                          SubsuperscriptBox["p", "0", "4"], " ", 
                          SubsuperscriptBox["\[Beta]2", "0", "2"]}], "+", 
                        RowBox[{"4", " ", 
                          SubscriptBox["p", "0"], " ", 
                          SubsuperscriptBox["p", "1", "3"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              RowBox[{"2", " ", 
                                SubscriptBox["\[Beta]2", "0"]}]}], ")"}]}], 
                        "+", 
                        RowBox[{
                          SubsuperscriptBox["p", "0", "2"], " ", 
                          SubsuperscriptBox["p", "1", "2"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "3"}], "+", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  SubscriptBox["p", "0"], "]"}]}], "-", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  SubscriptBox["p", "1"], "]"}]}], "+", 
                              RowBox[{"6", " ", 
                                SubscriptBox["\[Beta]2", "0"], " ", 
                                RowBox[{"(", 
                                  RowBox[{"1", "-", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"Log", "[", 
                                        SubscriptBox["p", "0"], "]"}]}], "+", 
                                    
                                    RowBox[{"2", " ", 
                                      RowBox[{"Log", "[", 
                                        SubscriptBox["p", "1"], "]"}]}], "+", 
                                    
                                    RowBox[{"2", " ", 
                                      RowBox[{"Log", "[", 
                                        FractionBox[
                                        SubscriptBox["p", "0"], 
                                        SubscriptBox["p", "1"]], "]"}], " ", 
                                      SubscriptBox["\[Beta]2", "0"]}]}], 
                                  ")"}]}]}], ")"}]}]}], ")"}]}], ")"}]}]}], 
            ")"}]}]}], ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"General", "::", "\<\"spell1\"\>"}], 
      RowBox[{
      ":", " "}], "\<\"Possible spelling error: new symbol name \
\\\"\\!\\(stotal\\)\\\" is similar to existing symbol \
\\\"\\!\\(sptotal\\)\\\".\"\>"}]], "Message"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{"Solve", "[", 
        RowBox[{
          RowBox[{"stotal", "\[Equal]", "0.00000001"}], ",", 
          SubscriptBox["\[Beta]2", "0"]}], "]"}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        SubscriptBox["\[Beta]2", "0"], "/.", 
        RowBox[{"Last", "[", "%", "]"}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"\[Beta]20sol", "=", "%"}], ";"}]}], "Input"],

Cell[BoxData[{
    RowBox[{
      RowBox[{"vptotal", "/.", 
        RowBox[{
          SubscriptBox["\[Beta]2", "0"], "\[Rule]", "\[Beta]20sol"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"vptotalW0\[Beta]20", "=", "%"}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Plot3D", "[", 
      RowBox[{
        RowBox[{"Re", "[", "vptotalW0\[Beta]20", "]"}], ",", 
        RowBox[{"{", 
          RowBox[{
            SubscriptBox["p", "0"], ",", "0", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{
            SubscriptBox["p", "1"], ",", "0", ",", "1"}], "}"}], ",", 
        RowBox[{"PlotPoints", "\[Rule]", 
          RowBox[{"{", 
            RowBox[{"20", ",", "20"}], "}"}]}]}], "]"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"Power", "::", "\<\"infy\"\>"}], 
      RowBox[{
      ":", " "}], "\<\"Infinite expression \\!\\(1\\/0.`\\^3\\) \
encountered.\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{"Power", "::", "\<\"infy\"\>"}], 
      RowBox[{
      ":", " "}], "\<\"Infinite expression \\!\\(1\\/0.`\\^3\\) \
encountered.\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{"\[Infinity]", "::", "\<\"indet\"\>"}], 
      RowBox[{
      ":", " "}], "\<\"Indeterminate expression \\!\\(0.`\\\\ \
\\*InterpretationBox[\\\"ComplexInfinity\\\", DirectedInfinity[]]\\) \
encountered.\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{"Power", "::", "\<\"infy\"\>"}], 
      RowBox[{
      ":", " "}], "\<\"Infinite expression \\!\\(1\\/0.`\\^3\\) \
encountered.\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{"General", "::", "\<\"stop\"\>"}], 
      RowBox[{
      ":", " "}], "\<\"Further output of \\!\\(Power :: \\\"infy\\\"\\) will \
be suppressed during this calculation.\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{"\[Infinity]", "::", "\<\"indet\"\>"}], 
      RowBox[{
      ":", " "}], "\<\"Indeterminate expression \\!\\(0.`\\\\ \
\\*InterpretationBox[\\\"ComplexInfinity\\\", DirectedInfinity[]]\\) \
encountered.\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{"\[Infinity]", "::", "\<\"indet\"\>"}], 
      RowBox[{
      ":", " "}], "\<\"Indeterminate expression \\!\\(0.`\\\\ \
\\*InterpretationBox[\\\"ComplexInfinity\\\", DirectedInfinity[]]\\) \
encountered.\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{"General", "::", "\<\"stop\"\>"}], 
      RowBox[{
      ":", " "}], "\<\"Further output of \\!\\(\[Infinity] :: \
\\\"indet\\\"\\) will be suppressed during this calculation.\"\>"}]], \
"Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{"Plot3D", "::", "\<\"plnc\"\>"}], 
      RowBox[{
      ":", " "}], "\<\"\\!\\(Re[vptotalW0\[Beta]20]\\) is neither a \
machine-size real number at \\!\\({p\\_0, p\\_1}\\)=\\!\\({0.`, 0.`}\\) nor a \
list of a real number and a valid color directive.\"\>"}]], "Message"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
Evaluator->"psi 3",
WindowSize->{1025, 740},
WindowMargins->{{-4, Automatic}, {Automatic, 0}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 4122, 105, 103, "Input"],

Cell[CellGroupData[{
Cell[5864, 158, 305, 9, 43, "Subsubsection"],
Cell[6172, 169, 9678, 206, 180, "Input"],

Cell[CellGroupData[{
Cell[15875, 379, 15438, 317, 322, "Input"],
Cell[31316, 698, 261, 6, 23, "Message"]
}, Open  ]],
Cell[31592, 707, 444, 12, 59, "Input"],
Cell[32039, 721, 265, 7, 43, "Input"],

Cell[CellGroupData[{
Cell[32329, 732, 475, 12, 27, "Input"],
Cell[32807, 746, 188, 5, 36, "Message"],
Cell[32998, 753, 188, 5, 36, "Message"],
Cell[33189, 760, 264, 6, 23, "Message"],
Cell[33456, 768, 188, 5, 36, "Message"],
Cell[33647, 775, 229, 5, 23, "Message"],
Cell[33879, 782, 264, 6, 23, "Message"],
Cell[34146, 790, 264, 6, 23, "Message"],
Cell[34413, 798, 238, 6, 23, "Message"],
Cell[34654, 806, 311, 6, 39, "Message"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

