(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     18378,        487]*)
(*NotebookOutlinePosition[     19017,        510]*)
(*  CellTagsIndexPosition[     18973,        506]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[{
    RowBox[{
      RowBox[{"substs1", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"0", ",", "0"}]], "\[Rule]", 
              SubscriptBox["p", "0"]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"0", ",", "1"}]], "\[Rule]", 
              SubscriptBox["p", "1"]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"1", ",", "0"}]], "\[Rule]", 
              RowBox[{"1", "-", 
                SubscriptBox["p", "0"]}]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"1", ",", "1"}]], "\[Rule]", 
              RowBox[{"1", "-", 
                SubscriptBox["p", "1"]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"substs2", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["p", "0"], "\[Rule]", 
              RowBox[{"pq", "-", 
                RowBox[{
                  FractionBox["1", "2"], "\[CapitalDelta]p"}]}]}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[Rule]", 
              RowBox[{"pq", "+", 
                RowBox[{
                  FractionBox["1", "2"], "\[CapitalDelta]p"}]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"substs3", "=", 
        RowBox[{"{", 
          RowBox[{
            SubscriptBox["\[Beta]2", "0"], "\[Rule]", 
            FractionBox["1", "2"]}], "}"}]}], ";"}]}], "Input"],

Cell["According to 0303111934 the disturbance is", "Text"],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        FractionBox["1", "12"], 
        RowBox[{
          SubsuperscriptBox["\[Sum]", 
            RowBox[{"m", "=", "0"}], "1"], 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                RowBox[{"(", 
                  RowBox[{"1", "+", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}]]}], "+", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{"3", "-", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]2", "0"]}]}], ")"}], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}]]}], "+", 
              RowBox[{
                FractionBox["1", 
                  SuperscriptBox[
                    RowBox[{"(", 
                      RowBox[{
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "0"}]], "-", 
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "1"}]]}], ")"}], "3"]], 
                RowBox[{"(", 
                  RowBox[{"6", " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{
                          SubsuperscriptBox["\[Beta]2", "0", "2"], " ", 
                          SubsuperscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "0"}], "4"]}], "-", 
                        RowBox[{"4", " ", 
                          SubscriptBox["\[Beta]2", "0"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              RowBox[{"2", " ", 
                                SubscriptBox["\[Beta]2", "0"]}]}], ")"}], " ",
                           
                          SubsuperscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "0"}], "3"], " ", 
                          SubscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "1"}]]}], "+", 
                        RowBox[{
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "3"}], "+", 
                              RowBox[{"2", " ", 
                                RowBox[{"Log", "[", 
                                  FractionBox[
                                    SubscriptBox["\[Alpha]", 
                                      RowBox[{"m", ",", "0"}]], 
                                    SubscriptBox["\[Alpha]", 
                                      RowBox[{"m", ",", "1"}]]], "]"}]}], "+",
                               
                              RowBox[{"6", " ", 
                                RowBox[{"(", 
                                  RowBox[{"1", "+", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"Log", "[", 
                                        FractionBox[
                                        SubscriptBox["\[Alpha]", 
                                        RowBox[{"m", ",", "0"}]], 
                                        SubscriptBox["\[Alpha]", 
                                        RowBox[{"m", ",", "1"}]]], "]"}], " ",
                                       
                                      RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", "1"}], "+", 
                                        SubscriptBox["\[Beta]2", "0"]}], 
                                        ")"}]}]}], ")"}], " ", 
                                SubscriptBox["\[Beta]2", "0"]}]}], ")"}], " ",
                           
                          SubsuperscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "0"}], "2"], " ", 
                          SubsuperscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "1"}], "2"]}], "+", 
                        RowBox[{"4", " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", "1"}], "+", 
                              RowBox[{"2", " ", 
                                SubscriptBox["\[Beta]2", "0"]}]}], ")"}], " ",
                           
                          SubscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "0"}]], " ", 
                          SubsuperscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "1"}], "3"]}], "-", 
                        RowBox[{
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", "1"}], "+", 
                                SubscriptBox["\[Beta]2", "0"]}], ")"}], "2"], 
                          " ", 
                          SubsuperscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "1"}], "4"]}]}], ")"}]}], 
                  ")"}]}], "+", 
              RowBox[{"4", " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      RowBox[{"-", 
                        SubscriptBox["\[Beta]2", "0"]}], " ", 
                      RowBox[{"(", 
                        RowBox[{"1", "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "0"}]]}], "-", 
                    RowBox[{
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "2"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "1"}]]}], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                      SubscriptBox["\[Beta]2", "0"], " ", 
                      SqrtBox[
                        RowBox[{
                          SubscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "0"}]], " ", 
                          SubscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "1"}]]}]]}]}], ")"}]}]}], 
            ")"}]}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{
          RowBox[{"%", "/.", "substs1"}], "/.", "substs2"}], "/.", 
        "substs3"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"s", "=", "%"}], ";"}]}], "Input"],

Cell[TextData[{
  "According to 0303122046 the deviation is (",
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{"0", "\[Congruent]", "+"}], ",", 
          RowBox[{"1", "\[Congruent]", "-"}]}], TraditionalForm]]],
  ")"
}], "Text"],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        SubsuperscriptBox["\[Sum]", 
          RowBox[{"m", "=", "0"}], "1"], 
        RowBox[{
          FractionBox[
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "0"}]], " ", 
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "1"}]]}], 
            RowBox[{
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "0"}]], "-", 
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "1"}]]}], ")"}], "3"], " ", 
              RowBox[{"(", 
                RowBox[{
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]], "+", 
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]}], ")"}]}]], 
          RowBox[{
            SubsuperscriptBox["\[Sum]", 
              RowBox[{"j", "=", "0"}], "1"], 
            RowBox[{"(", 
              RowBox[{
                RowBox[{
                  SubsuperscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "j"}], "2"], " ", 
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", 
                      RowBox[{"1", "-", "j"}]}]], 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"Log", "[", 
                        FractionBox[
                          SubscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "0"}]], 
                          SubscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "1"}]]], "]"}], "-", 
                      RowBox[{"2", 
                        SuperscriptBox[
                          RowBox[{"(", 
                            RowBox[{"-", "1"}], ")"}], "j"]}], "+", 
                      RowBox[{"3", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"2", " ", 
                              RowBox[{"Log", "[", 
                                FractionBox[
                                  SubscriptBox["\[Alpha]", 
                                    RowBox[{"m", ",", "0"}]], 
                                  SubscriptBox["\[Alpha]", 
                                    RowBox[{"m", ",", "1"}]]], "]"}]}], "-", 
                            RowBox[{"3", 
                              SuperscriptBox[
                                RowBox[{"(", 
                                  RowBox[{"-", "1"}], ")"}], "j"]}]}], ")"}], 
                        "  ", 
                        SubscriptBox["\[Beta]2", "0"], 
                        RowBox[{"(", 
                          RowBox[{
                            SubscriptBox["\[Beta]2", "0"], "-", "1"}], 
                          ")"}]}]}], ")"}]}], "-", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"(", 
                      RowBox[{"-", "1"}], ")"}], "j"], 
                  SubsuperscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "j"}], "3"], 
                  SubscriptBox["\[Beta]2", "0"], 
                  RowBox[{"(", 
                    RowBox[{
                      SubscriptBox["\[Beta]2", "0"], "-", "1"}], ")"}]}]}], 
              ")"}]}]}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{
          RowBox[{"%", "/.", "substs1"}], "/.", "substs2"}], "/.", 
        "substs3"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"v", "=", "%"}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{
            SubscriptBox["s", 
              RowBox[{"1", ",", 
                RowBox[{"1", "/", "2"}]}]], "\[Congruent]", "s112"}], ",", 
          RowBox[{
            SubscriptBox["v", 
              RowBox[{"1", ",", 
                RowBox[{"1", "/", "2"}]}]], "\[Congruent]", "v112"}]}], 
        TraditionalForm]]],
  " for ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{"\[CapitalDelta]p", "=", "1"}], ",", 
          RowBox[{
            OverscriptBox["p", "_"], "=", 
            RowBox[{"1", "/", "2"}]}]}], TraditionalForm]]]
}], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp2", "=", 
        RowBox[{"Limit", "[", 
          RowBox[{
            RowBox[{"Limit", "[", 
              RowBox[{"s", ",", 
                RowBox[{"\[CapitalDelta]p", "\[Rule]", "1"}]}], "]"}], ",", 
            RowBox[{"pq", "\[Rule]", 
              RowBox[{"1", "/", "2"}]}]}], "]"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"s112", "=", 
        RowBox[{"1", "/", "12"}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"s112", "-", "tmp2"}], "//", "Simplify"}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp1", "=", 
        RowBox[{"Limit", "[", 
          RowBox[{
            RowBox[{"Limit", "[", 
              RowBox[{"v", ",", 
                RowBox[{"\[CapitalDelta]p", "\[Rule]", "1"}]}], "]"}], ",", 
            RowBox[{"pq", "\[Rule]", 
              RowBox[{"1", "/", "2"}]}]}], "]"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"v112", "=", "0"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"v112", "-", "tmp1"}], "//", "Simplify"}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{
            SubscriptBox["s", 
              RowBox[{"1", ",", 
                RowBox[{"1", "/", "2"}]}]], "\[Congruent]", "s012"}], ",", 
          RowBox[{
            SubscriptBox["v", 
              RowBox[{"1", ",", 
                RowBox[{"1", "/", "2"}]}]], "\[Congruent]", "v012"}]}], 
        TraditionalForm]]],
  " for ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{"\[CapitalDelta]p", "=", "0"}], ",", 
          RowBox[{
            OverscriptBox["p", "_"], "=", 
            RowBox[{"1", "/", "2"}]}]}], TraditionalForm]]]
}], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp2", "=", 
        RowBox[{"Limit", "[", 
          RowBox[{
            RowBox[{"Limit", "[", 
              RowBox[{"s", ",", 
                RowBox[{"\[CapitalDelta]p", "\[Rule]", "0"}]}], "]"}], ",", 
            RowBox[{"pq", "\[Rule]", 
              RowBox[{"1", "/", "2"}]}]}], "]"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"s112", "=", "0"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"s112", "-", "tmp2"}], "//", "Simplify"}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp1", "=", 
        RowBox[{"Limit", "[", 
          RowBox[{
            RowBox[{"Limit", "[", 
              RowBox[{"v", ",", 
                RowBox[{"\[CapitalDelta]p", "\[Rule]", "0"}]}], "]"}], ",", 
            RowBox[{"pq", "\[Rule]", 
              RowBox[{"1", "/", "2"}]}]}], "]"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"v112", "=", 
        RowBox[{"1", "/", "12"}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"v112", "-", "tmp1"}], "//", "Simplify"}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
WindowSize->{1025, 740},
WindowMargins->{{-4, Automatic}, {Automatic, 0}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 1598, 44, 98, "Input"],
Cell[3318, 95, 58, 0, 32, "Text"],
Cell[3379, 97, 7222, 152, 191, "Input"],
Cell[10604, 251, 249, 8, 32, "Text"],
Cell[10856, 261, 3636, 86, 80, "Input"],

Cell[CellGroupData[{
Cell[14517, 351, 664, 21, 42, "Subsubsection"],

Cell[CellGroupData[{
Cell[15206, 376, 567, 15, 59, "Input"],
Cell[15776, 393, 28, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15841, 398, 537, 14, 59, "Input"],
Cell[16381, 414, 28, 0, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[16458, 420, 664, 21, 42, "Subsubsection"],

Cell[CellGroupData[{
Cell[17147, 445, 537, 14, 59, "Input"],
Cell[17687, 461, 28, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[17752, 466, 567, 15, 59, "Input"],
Cell[18322, 483, 28, 0, 27, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

