(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     78908,       1957]*)
(*NotebookOutlinePosition[     79565,       1981]*)
(*  CellTagsIndexPosition[     79521,       1977]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[{
    RowBox[{
      RowBox[{"facts1", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"\[Theta]", "\[GreaterEqual]", "0"}], ",", 
            RowBox[{"\[Theta]", "\[LessEqual]", 
              RowBox[{"\[Pi]", "/", "2"}]}], ",", 
            RowBox[{"\[CurlyPhi]", "\[GreaterEqual]", "0"}], ",", 
            RowBox[{"\[CurlyPhi]", "\[LessEqual]", 
              RowBox[{"2", "\[Pi]"}]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "0"}]], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "0"}]], "\[LessEqual]", "1"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "1"}]], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"m", ",", "1"}]], "\[LessEqual]", "1"}], ",", 
            RowBox[{
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", "0"], "]"}], "2"], "+", 
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", "1"], "]"}], "2"]}], "\[Equal]", 
              "1"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"facts2", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["\[Beta]2", "0"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["\[Beta]2", "0"], "\[LessEqual]", "1"}]}], "}"}]}],
       ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"facts3", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["p", "0"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["p", "0"], "\[LessEqual]", "1"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[LessEqual]", "1"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[GreaterEqual]", 
              SubscriptBox["p", "0"]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"substs1", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["b", 
                RowBox[{"j_", ",", "k_"}]], "\[Rule]", 
              RowBox[{
                SqrtBox[
                  SubscriptBox["\[Alpha]p", 
                    RowBox[{"mp", ",", "j"}]]], 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "k"}]]], 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"j", ",", "k"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["b2", 
                RowBox[{"j_", ",", "k_"}]], "\[Rule]", 
              RowBox[{
                SubscriptBox["\[Beta]p", "j"], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]p", 
                    RowBox[{"mp", ",", "j"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"j", ",", "k"}]]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"substs2", "=", 
        RowBox[{"{", 
          RowBox[{
            SubscriptBox["\[Beta]2", "0"], "\[Rule]", 
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                SubscriptBox["\[Beta]", "0"], "]"}], "2"]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"substsQQQ", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              RowBox[{"Abs", "[", 
                SubscriptBox["\[Beta]", "0"], "]"}], "\[Rule]", 
              SqrtBox[
                SubscriptBox["\[Beta]2", "0"]]}], ",", 
            RowBox[{
              RowBox[{"Abs", "[", 
                SubscriptBox["\[Beta]", "1"], "]"}], "\[Rule]", 
              SqrtBox[
                RowBox[{"1", "-", 
                  SubscriptBox["\[Beta]2", "0"]}]]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"substsQQQ", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"0", ",", "0"}]], "\[Rule]", 
              SubscriptBox["p", "0"]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"0", ",", "1"}]], "\[Rule]", 
              SubscriptBox["p", "1"]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"1", ",", "0"}]], "\[Rule]", 
              RowBox[{"1", "-", 
                SubscriptBox["p", "0"]}]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"1", ",", "1"}]], "\[Rule]", 
              RowBox[{"1", "-", 
                SubscriptBox["p", "1"]}]}]}], "}"}]}], ";"}]}], "Input"],

Cell[TextData[{
  "Note that ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{
            SubscriptBox["\[Alpha]", 
              RowBox[{"0", ",", "j"}]], "=", 
            SubscriptBox["\[Alpha]", 
              RowBox[{"+", 
                RowBox[{",", "j"}]}]]}], ",", 
          RowBox[{
            SubscriptBox["\[Alpha]", 
              RowBox[{"1", ",", "j"}]], "=", 
            SubscriptBox["\[Alpha]", 
              RowBox[{"-", 
                RowBox[{",", "j"}]}]]}]}], TraditionalForm]]],
  "."
}], "Text"],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{
            RowBox[{"p", "(", 
              RowBox[{"M", "|", "\[Psi]"}], ")"}], "\[Congruent]", 
            "pM\[Psi]"}], ",", 
          RowBox[{
            SubsuperscriptBox["g", "M", "\[DoublePrime]"], "\[Congruent]", 
            "gMpp"}], ",", 
          RowBox[{
            SuperscriptBox[
              RowBox[{"\[LeftBracketingBar]", 
                SubsuperscriptBox["c", "1", "\[DoublePrime]"], 
                "\[RightBracketingBar]"}], "2"], "\[Congruent]", "c12pp"}], 
          ",", 
          RowBox[{"A", "\[Congruent]", "a"}], ",", 
          RowBox[{
            SuperscriptBox[
              RowBox[{"\[LeftBracketingBar]", 
                SubscriptBox["c", "1"], "\[RightBracketingBar]"}], "2"], 
            "\[Congruent]", "c12"}]}], TraditionalForm]]],
  ":"
}], "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"pM\[Psi]", "=", 
        SuperscriptBox[
          RowBox[{"Abs", "[", 
            RowBox[{
              SubsuperscriptBox["\[Sum]", 
                RowBox[{"j", "=", "0"}], "1"], 
              RowBox[{
                SqrtBox[
                  SubscriptBox["\[Alpha]p", 
                    RowBox[{"mp", ",", "j"}]]], 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SqrtBox[
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "0"}]]], 
                      SubscriptBox["\[Gamma]", 
                        RowBox[{"j", ",", "0"}]], 
                      RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
                    RowBox[{
                      SqrtBox[
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "1"}]]], 
                      SubscriptBox["\[Gamma]", 
                        RowBox[{"j", ",", "1"}]], 
                      RowBox[{"Exp", "[", 
                        RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}], "]"}], 
                      
                      RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ")"}]}]}], 
            "]"}], "2"]}], ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"a", "=", 
        SuperscriptBox[
          RowBox[{"Abs", "[", 
            RowBox[{
              SubsuperscriptBox["\[Sum]", 
                RowBox[{"j", "=", "0"}], "1"], 
              RowBox[{
                SqrtBox[
                  SubscriptBox["\[Alpha]p", 
                    RowBox[{"mp", ",", "j"}]]], 
                SubscriptBox["\[Beta]p", "j"], 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SqrtBox[
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "0"}]]], 
                      SubscriptBox["\[Gamma]", 
                        RowBox[{"j", ",", "0"}]], 
                      RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
                    RowBox[{
                      SqrtBox[
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "1"}]]], 
                      SubscriptBox["\[Gamma]", 
                        RowBox[{"j", ",", "1"}]], 
                      RowBox[{"Exp", "[", 
                        RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}], "]"}], 
                      
                      RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ")"}]}]}], 
            "]"}], "2"]}], ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"c12pp", "=", 
        RowBox[{
          FractionBox["1", "pM\[Psi]"], 
          SuperscriptBox["a", "2"]}]}], ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"c12", "=", 
        SuperscriptBox[
          RowBox[{"Abs", "[", 
            RowBox[{
              RowBox[{
                SubscriptBox["\[Beta]", "0"], 
                RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
              RowBox[{
                SubscriptBox["\[Beta]", "1"], 
                RowBox[{"Exp", "[", 
                  RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}], "]"}], 
                RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], "]"}], "2"]}], 
      ";"}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{"sM1", "\[Congruent]", 
          SubscriptBox[
            SubscriptBox["s", "M"], "1"]}], TraditionalForm]]],
  ":"
}], "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"sM1", "=", 
        RowBox[{
          FractionBox["\[Pi]", "4"], 
          RowBox[{
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                RowBox[{
                  SubsuperscriptBox["\[Sum]", 
                    RowBox[{"j", "=", "0"}], "1"], 
                  RowBox[{
                    SubscriptBox["\[Beta]p", "j"], 
                    SubscriptBox["b", 
                      RowBox[{"j", ",", "0"}]]}]}], "]"}], "4"], "/", 
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                RowBox[{
                  SubsuperscriptBox["\[Sum]", 
                    RowBox[{"j", "=", "0"}], "1"], 
                  SubscriptBox["b", 
                    RowBox[{"j", ",", "0"}]]}], "]"}], "2"]}]}]}], 
      ";"}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{"sM2", "\[Congruent]", 
          SubscriptBox[
            SubscriptBox["s", "M"], "2"]}], TraditionalForm]]],
  ":"
}], "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"integrand", "=", 
        RowBox[{
          RowBox[{"-", 
            FractionBox["1", "\[Pi]"]}], 
          RowBox[{"Sin", "[", 
            RowBox[{"2", "\[Theta]"}], "]"}], "a", " ", "c12"}]}], 
      ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp1substs", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "1"], "\[Rule]", 
              RowBox[{
                RowBox[{"-", 
                  FractionBox["1", "\[Pi]"]}], 
                RowBox[{"Sin", "[", 
                  RowBox[{"2", " ", "\[Theta]"}], "]"}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "2"], "\[Rule]", 
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SubscriptBox["\[Beta]", "0"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "3"], "\[Rule]", " ", 
              RowBox[{
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SubscriptBox["\[Beta]", "1"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "4"], "\[Rule]", 
              RowBox[{
                SubscriptBox["\[Beta]p", "0"], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]p", 
                    RowBox[{"mp", ",", "0"}]]]}]}], " ", ",", 
            RowBox[{
              SubscriptBox["c", "5"], "\[Rule]", 
              RowBox[{
                SubscriptBox["\[Beta]p", "1"], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]p", 
                    RowBox[{"mp", ",", "1"}]]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "6"], "\[Rule]", 
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"0", ",", "0"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "7"], "\[Rule]", " ", 
              RowBox[{
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"0", ",", "1"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "8"], "\[Rule]", 
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"1", ",", "0"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "9"], "\[Rule]", 
              RowBox[{
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"1", ",", "1"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "10"], "\[Rule]", 
              RowBox[{
                RowBox[{
                  SubscriptBox["c", "4"], 
                  SubscriptBox["c", "6"]}], "+", 
                RowBox[{
                  SubscriptBox["c", "5"], " ", 
                  SubscriptBox["c", "8"]}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "11"], "\[Rule]", 
              RowBox[{
                RowBox[{
                  SubscriptBox["c", "4"], 
                  SubscriptBox["c", "7"]}], "+", 
                RowBox[{
                  SubscriptBox["c", "5"], " ", 
                  SubscriptBox["c", "9"]}]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp1", "=", 
        RowBox[{
          SubscriptBox["c", "1"], 
          RowBox[{"(", 
            RowBox[{
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  RowBox[{
                    SubscriptBox["c", "2"], "+", 
                    RowBox[{
                      SubscriptBox["c", "3"], 
                      SuperscriptBox["\[ExponentialE]", 
                        RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], 
                  "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  RowBox[{
                    SubscriptBox["c", "10"], "+", 
                    RowBox[{
                      SubscriptBox["c", "11"], 
                      SuperscriptBox["\[ExponentialE]", 
                        RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], 
                  "]"}], "2"]}], " ", ")"}]}]}], ";"}], "\[IndentingNewLine]",
   
    RowBox[{
      RowBox[{
        RowBox[{"tmp1", "-", "integrand"}], "//.", "tmp1substs"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp1", ",", 
            RowBox[{"{", 
              RowBox[{"\[CurlyPhi]", ",", "0", ",", 
                RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "//", 
        "FullSimplify"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "//.", "tmp1substs"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp2", "=", "%"}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp3substs", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "1"], "\[Rule]", 
              RowBox[{"-", "2"}]}], ",", 
            RowBox[{
              SubscriptBox["c", "2"], "\[Rule]", 
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  SubscriptBox["\[Beta]", "0"], "]"}], "2"]}], ",", 
            RowBox[{
              SubscriptBox["c", "3"], "\[Rule]", 
              SuperscriptBox[
                RowBox[{"Abs", "[", " ", 
                  SubscriptBox["\[Beta]", "1"], "]"}], "2"]}], ",", 
            RowBox[{
              SubscriptBox["c", "4"], "\[Rule]", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    RowBox[{
                      SubsuperscriptBox["\[Sum]", 
                        RowBox[{"j", "=", "0"}], "1"], 
                      RowBox[{
                        SubscriptBox["\[Beta]p", "j"], " ", 
                        SqrtBox[
                          SubscriptBox["\[Alpha]p", 
                            RowBox[{"mp", ",", "j"}]]], " ", 
                        SubscriptBox["\[Gamma]", 
                          RowBox[{"j", ",", "0"}]]}]}], "]"}], "2"], " ", 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "0"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "5"], "\[Rule]", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    RowBox[{
                      SubsuperscriptBox["\[Sum]", 
                        RowBox[{"j", "=", "0"}], "1"], 
                      RowBox[{
                        SubscriptBox["\[Beta]p", "j"], " ", 
                        SqrtBox[
                          SubscriptBox["\[Alpha]p", 
                            RowBox[{"mp", ",", "j"}]]], " ", 
                        SubscriptBox["\[Gamma]", 
                          RowBox[{"j", ",", "1"}]]}]}], "]"}], "2"], 
                SubscriptBox["\[Alpha]", 
                  RowBox[{"m", ",", "1"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "6"], "\[Rule]", 
              RowBox[{
                SqrtBox[
                  RowBox[{
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "0"}]], " ", 
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "1"}]]}]], 
                RowBox[{
                  SubsuperscriptBox["\[Sum]", 
                    RowBox[{"j", "=", "0"}], "1"], 
                  RowBox[{
                    RowBox[{"Conjugate", "[", 
                      SubscriptBox["\[Beta]", "j"], "]"}], " ", 
                    RowBox[{"Conjugate", "[", 
                      RowBox[{
                        SubsuperscriptBox["\[Sum]", 
                          RowBox[{"k", "=", "0"}], "1"], 
                        RowBox[{
                          SubscriptBox["\[Beta]p", "k"], " ", 
                          SqrtBox[
                            SubscriptBox["\[Alpha]p", 
                              RowBox[{"mp", ",", "k"}]]], " ", 
                          SubscriptBox["\[Gamma]", 
                            RowBox[{"k", ",", 
                              RowBox[{"1", "-", "j"}]}]]}]}], "]"}], " ", 
                    SubscriptBox["\[Beta]", 
                      RowBox[{"1", "-", "j"}]], 
                    RowBox[{"(", 
                      RowBox[{
                        SubsuperscriptBox["\[Sum]", 
                          RowBox[{"k", "=", "0"}], "1"], 
                        RowBox[{
                          SubscriptBox["\[Beta]p", "k"], " ", 
                          SqrtBox[
                            SubscriptBox["\[Alpha]p", 
                              RowBox[{"mp", ",", "k"}]]], " ", 
                          SubscriptBox["\[Gamma]", 
                            RowBox[{"k", ",", "j"}]]}]}], ")"}]}]}]}]}]}], 
          "}"}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp3", "=", 
        RowBox[{
          SubscriptBox["c", "1"], 
          RowBox[{"Sin", "[", 
            RowBox[{"2", " ", "\[Theta]"}], "]"}], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SubscriptBox["c", "2"], 
                      SuperscriptBox[
                        RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "+", 
                    RowBox[{
                      SubscriptBox["c", "3"], 
                      SuperscriptBox[
                        RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], 
                  ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SubscriptBox["c", "4"], 
                      SuperscriptBox[
                        RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], " ", 
                    "+", 
                    RowBox[{
                      SubscriptBox["c", "5"], " ", 
                      SuperscriptBox[
                        RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], " ", 
                  ")"}]}], "+", " ", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
                SubscriptBox["c", "6"]}]}], " ", ")"}]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"tmp3", "-", "tmp2"}], "//.", "tmp3substs"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp3", ",", 
            RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "0", ",", 
                RowBox[{"\[Pi]", "/", "2"}]}], "}"}]}], "]"}], "//", 
        "FullSimplify"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "//.", "tmp3substs"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp4", "=", "%"}], ";"}]}], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"sM2", "=", 
        RowBox[{
          RowBox[{"-", 
            FractionBox["1", "3"]}], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SubsuperscriptBox["\[Sum]", 
                  RowBox[{"j", "=", "0"}], "1"], " ", 
                RowBox[{
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "j"}]], 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Abs", "[", 
                            SubscriptBox["\[Beta]", "j"], "]"}], "2"]}], "+", 
                      
                      SuperscriptBox[
                        RowBox[{"Abs", "[", 
                          SubscriptBox["\[Beta]", 
                            RowBox[{"1", "-", "j"}]], "]"}], "2"]}], ")"}], 
                  SuperscriptBox[
                    RowBox[{"Abs", "[", 
                      RowBox[{
                        SubscriptBox["b2", 
                          RowBox[{"0", ",", "j"}]], "+", 
                        SubscriptBox["b2", 
                          RowBox[{"1", ",", "j"}]]}], "]"}], "2"]}]}], "+", 
              RowBox[{
                SqrtBox[
                  RowBox[{
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "0"}]], " ", 
                    SubscriptBox["\[Alpha]", 
                      RowBox[{"m", ",", "1"}]]}]], " ", 
                RowBox[{
                  SubsuperscriptBox["\[Sum]", 
                    RowBox[{"j", "=", "0"}], "1"], 
                  RowBox[{
                    RowBox[{"Conjugate", "[", 
                      SubscriptBox["\[Beta]", "j"], "]"}], " ", 
                    RowBox[{"Conjugate", "[", 
                      RowBox[{
                        SubscriptBox["b2", 
                          RowBox[{"0", ",", 
                            RowBox[{"1", "-", "j"}]}]], "+", 
                        SubscriptBox["b2", 
                          RowBox[{"1", ",", 
                            RowBox[{"1", "-", "j"}]}]]}], "]"}], " ", 
                    SubscriptBox["\[Beta]", 
                      RowBox[{"1", "-", "j"}]], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        SubscriptBox["b2", 
                          RowBox[{"0", ",", "j"}]], "+", 
                        SubscriptBox["b2", 
                          RowBox[{"1", ",", "j"}]]}], ")"}]}]}]}]}], 
            ")"}]}]}], ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"sM2", "-", "tmp4"}], "//.", "substs1"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{"sM3", "\[Congruent]", 
          SubscriptBox["s", 
            RowBox[{"M", ",", "3"}]]}], TraditionalForm]]],
  ":"
}], "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"integrand", "=", 
        RowBox[{
          FractionBox["1", 
            RowBox[{"4", "\[Pi]"}]], " ", 
          RowBox[{"Sin", "[", 
            RowBox[{"2", "\[Theta]"}], "]"}], "pM\[Psi]", " ", 
          SuperscriptBox["c12", "2"]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp1substs", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "1"], "\[Rule]", 
              RowBox[{
                FractionBox["1", 
                  RowBox[{"4", " ", "\[Pi]"}]], 
                RowBox[{"Sin", "[", 
                  RowBox[{"2", " ", "\[Theta]"}], "]"}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "2"], "\[Rule]", 
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SubscriptBox["\[Beta]", "0"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "3"], "\[Rule]", " ", 
              RowBox[{
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SubscriptBox["\[Beta]", "1"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "4"], "\[Rule]", 
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"0", ",", "0"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "5"], "\[Rule]", 
              RowBox[{
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"0", ",", "1"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "6"], "\[Rule]", 
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"1", ",", "0"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "7"], "\[Rule]", 
              RowBox[{
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"1", ",", "1"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "8"], "\[Rule]", 
              SqrtBox[
                SubscriptBox["\[Alpha]p", 
                  RowBox[{"mp", ",", "0"}]]]}], " ", ",", 
            RowBox[{
              SubscriptBox["c", "9"], "\[Rule]", 
              SqrtBox[
                SubscriptBox["\[Alpha]p", 
                  RowBox[{"mp", ",", "1"}]]]}], ",", 
            RowBox[{
              SubscriptBox["c", "10"], "\[Rule]", 
              RowBox[{
                RowBox[{
                  SubscriptBox["c", "8"], 
                  SubscriptBox["c", "4"]}], "+", 
                RowBox[{
                  SubscriptBox["c", "9"], " ", 
                  SubscriptBox["c", "6"]}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "11"], "\[Rule]", 
              RowBox[{
                RowBox[{
                  SubscriptBox["c", "8"], 
                  SubscriptBox["c", "5"]}], "+", 
                RowBox[{
                  SubscriptBox["c", "9"], 
                  SubscriptBox["c", "7"]}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "12"], "\[Rule]", 
              RowBox[{
                SubsuperscriptBox["c", "2", "2"], " ", 
                SubscriptBox["c", "10"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "13"], "\[Rule]", 
              RowBox[{
                RowBox[{"2", "  ", 
                  SubscriptBox["c", "2"], " ", 
                  SubscriptBox["c", "3"], " ", 
                  SubscriptBox["c", "10"]}], "+", 
                RowBox[{
                  SubsuperscriptBox["c", "2", "2"], " ", 
                  SubscriptBox["c", "11"]}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "14"], "\[Rule]", 
              RowBox[{
                RowBox[{"2", " ", 
                  SubscriptBox["c", "2"], " ", 
                  SubscriptBox["c", "3"], " ", 
                  SubscriptBox["c", "11"]}], "+", " ", 
                RowBox[{
                  SubsuperscriptBox["c", "3", "2"], " ", 
                  SubscriptBox["c", "10"]}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "15"], "\[Rule]", 
              RowBox[{
                SubsuperscriptBox["c", "3", "2"], " ", 
                SubscriptBox["c", "11"]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp1", "=", 
        RowBox[{
          SubscriptBox["c", "1"], 
          SuperscriptBox[
            RowBox[{"Abs", "[", 
              RowBox[{
                SubscriptBox["c", "12"], "+", 
                RowBox[{
                  SubscriptBox["c", "13"], 
                  SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}], " ", 
                "+", 
                RowBox[{
                  SubscriptBox["c", "14"], 
                  SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                    "2", " ", "\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}], "+", 
                RowBox[{
                  SubscriptBox["c", "15"], 
                  SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                    "3", " ", "\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], " ",
               "]"}], "2"]}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"tmp1", "-", "integrand"}], "//.", "tmp1substs"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp1", ",", 
            RowBox[{"{", 
              RowBox[{"\[CurlyPhi]", ",", "0", ",", 
                RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "//", 
        "FullSimplify"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "//.", "tmp1substs"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp2", "=", "%"}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp3substs", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "1"], "\[Rule]", 
              RowBox[{"1", "/", "2"}]}], ",", 
            RowBox[{
              SubscriptBox["c", "2"], "\[Rule]", " ", 
              RowBox[{
                SubsuperscriptBox["\[Beta]", "0", "2"], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SqrtBox[
                        SubscriptBox["\[Alpha]p", 
                          RowBox[{"mp", ",", "0"}]]], " ", 
                      SubscriptBox["\[Gamma]", 
                        RowBox[{"0", ",", "0"}]]}], "+", 
                    RowBox[{
                      SqrtBox[
                        SubscriptBox["\[Alpha]p", 
                          RowBox[{"mp", ",", "1"}]]], " ", 
                      SubscriptBox["\[Gamma]", 
                        RowBox[{"1", ",", "0"}]]}]}], ")"}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "3"], "\[Rule]", 
              RowBox[{
                SubsuperscriptBox["\[Beta]", "1", "2"], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SqrtBox[
                        SubscriptBox["\[Alpha]p", 
                          RowBox[{"mp", ",", "0"}]]], " ", 
                      SubscriptBox["\[Gamma]", 
                        RowBox[{"0", ",", "1"}]]}], "+", 
                    RowBox[{
                      SqrtBox[
                        SubscriptBox["\[Alpha]p", 
                          RowBox[{"mp", ",", "1"}]]], " ", 
                      SubscriptBox["\[Gamma]", 
                        RowBox[{"1", ",", "1"}]]}]}], ")"}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "4"], "\[Rule]", 
              RowBox[{
                SubscriptBox["\[Beta]", "0"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]", "1"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SqrtBox[
                              RowBox[{
                                SubscriptBox["\[Alpha]", 
                                  RowBox[{"m", ",", "0"}]], " ", 
                                SubscriptBox["\[Alpha]p", 
                                  RowBox[{"mp", ",", "0"}]]}]], " ", 
                            SubscriptBox["\[Gamma]", 
                              RowBox[{"0", ",", "0"}]]}], "+", 
                          RowBox[{
                            SqrtBox[
                              RowBox[{
                                SubscriptBox["\[Alpha]", 
                                  RowBox[{"m", ",", "0"}]], " ", 
                                SubscriptBox["\[Alpha]p", 
                                  RowBox[{"mp", ",", "1"}]]}]], " ", 
                            SubscriptBox["\[Gamma]", 
                              RowBox[{"1", ",", "0"}]]}]}], ")"}]}], "+", 
                    RowBox[{
                      SubscriptBox["\[Beta]", "0"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SqrtBox[
                              RowBox[{
                                SubscriptBox["\[Alpha]", 
                                  RowBox[{"m", ",", "1"}]], " ", 
                                SubscriptBox["\[Alpha]p", 
                                  RowBox[{"mp", ",", "0"}]]}]], " ", 
                            SubscriptBox["\[Gamma]", 
                              RowBox[{"0", ",", "1"}]]}], "+", 
                          RowBox[{
                            SqrtBox[
                              RowBox[{
                                SubscriptBox["\[Alpha]", 
                                  RowBox[{"m", ",", "1"}]], " ", 
                                SubscriptBox["\[Alpha]p", 
                                  RowBox[{"mp", ",", "1"}]]}]], " ", 
                            SubscriptBox["\[Gamma]", 
                              RowBox[{"1", ",", "1"}]]}]}], ")"}]}]}], 
                  ")"}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "5"], "\[Rule]", 
              RowBox[{
                SubscriptBox["\[Beta]", "1"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SubscriptBox["\[Beta]", "1"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SqrtBox[
                              RowBox[{
                                SubscriptBox["\[Alpha]", 
                                  RowBox[{"m", ",", "0"}]], " ", 
                                SubscriptBox["\[Alpha]p", 
                                  RowBox[{"mp", ",", "0"}]]}]], " ", 
                            SubscriptBox["\[Gamma]", 
                              RowBox[{"0", ",", "0"}]]}], "+", 
                          RowBox[{
                            SqrtBox[
                              RowBox[{
                                SubscriptBox["\[Alpha]", 
                                  RowBox[{"m", ",", "0"}]], " ", 
                                SubscriptBox["\[Alpha]p", 
                                  RowBox[{"mp", ",", "1"}]]}]], " ", 
                            SubscriptBox["\[Gamma]", 
                              RowBox[{"1", ",", "0"}]]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]", "0"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SqrtBox[
                              RowBox[{
                                SubscriptBox["\[Alpha]", 
                                  RowBox[{"m", ",", "1"}]], " ", 
                                SubscriptBox["\[Alpha]p", 
                                  RowBox[{"mp", ",", "0"}]]}]], " ", 
                            SubscriptBox["\[Gamma]", 
                              RowBox[{"0", ",", "1"}]]}], "+", 
                          RowBox[{
                            SqrtBox[
                              RowBox[{
                                SubscriptBox["\[Alpha]", 
                                  RowBox[{"m", ",", "1"}]], " ", 
                                SubscriptBox["\[Alpha]p", 
                                  RowBox[{"mp", ",", "1"}]]}]], " ", 
                            SubscriptBox["\[Gamma]", 
                              RowBox[{"1", ",", "1"}]]}]}], ")"}]}]}], 
                  ")"}]}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp3", "=", 
        RowBox[{
          SubscriptBox["c", "1"], 
          RowBox[{"(", 
            RowBox[{
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  RowBox[{
                    SubscriptBox["c", "2"], 
                    SuperscriptBox[
                      RowBox[{"Cos", "[", "\[Theta]", "]"}], "3"]}], "]"}], 
                "2"], "+", 
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  RowBox[{
                    SubscriptBox["c", "3"], 
                    SuperscriptBox[
                      RowBox[{"Sin", "[", "\[Theta]", "]"}], "3"]}], "]"}], 
                "2"], "+", 
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  RowBox[{
                    SubscriptBox["c", "4"], 
                    SuperscriptBox[
                      RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
                    RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "]"}], "2"], "+",
               
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  RowBox[{
                    SubscriptBox["c", "5"], 
                    RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                    SuperscriptBox[
                      RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "]"}], 
                "2"]}], ")"}], " ", 
          RowBox[{"Sin", "[", 
            RowBox[{"2", " ", "\[Theta]"}], "]"}]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"tmp3", "-", "tmp2"}], "//.", "tmp3substs"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp3", ",", 
            RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "0", ",", 
                RowBox[{"\[Pi]", "/", "2"}]}], "}"}]}], "]"}], "//", 
        "FullSimplify"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "//.", "tmp3substs"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp4", "=", "%"}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"sM3", "=", 
        RowBox[{
          FractionBox["1", "24"], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{"3", " ", 
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    RowBox[{
                      SubsuperscriptBox["\[Beta]", "0", "2"], " ", 
                      SqrtBox[
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "0"}]]], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SqrtBox[
                              SubscriptBox["\[Alpha]p", 
                                RowBox[{"mp", ",", "0"}]]], " ", 
                            SubscriptBox["\[Gamma]", 
                              RowBox[{"0", ",", "0"}]]}], "+", 
                          RowBox[{
                            SqrtBox[
                              SubscriptBox["\[Alpha]p", 
                                RowBox[{"mp", ",", "1"}]]], " ", 
                            SubscriptBox["\[Gamma]", 
                              RowBox[{"1", ",", "0"}]]}]}], ")"}]}], "]"}], 
                  "2"]}], "+", 
              RowBox[{"3", " ", 
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    RowBox[{
                      SubsuperscriptBox["\[Beta]", "1", "2"], " ", 
                      SqrtBox[
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "1"}]]], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SqrtBox[
                              SubscriptBox["\[Alpha]p", 
                                RowBox[{"mp", ",", "0"}]]], " ", 
                            SubscriptBox["\[Gamma]", 
                              RowBox[{"0", ",", "1"}]]}], "+", 
                          RowBox[{
                            SqrtBox[
                              SubscriptBox["\[Alpha]p", 
                                RowBox[{"mp", ",", "1"}]]], " ", 
                            SubscriptBox["\[Gamma]", 
                              RowBox[{"1", ",", "1"}]]}]}], ")"}]}], "]"}], 
                  "2"]}], "+", 
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  RowBox[{
                    SubscriptBox["\[Beta]", "0"], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", 
                          SubscriptBox["\[Beta]", "1"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{
                                SqrtBox[
                                  RowBox[{
                                    SubscriptBox["\[Alpha]", 
                                      RowBox[{"m", ",", "0"}]], " ", 
                                    SubscriptBox["\[Alpha]p", 
                                      RowBox[{"mp", ",", "0"}]]}]], " ", 
                                SubscriptBox["\[Gamma]", 
                                  RowBox[{"0", ",", "0"}]]}], "+", 
                              RowBox[{
                                SqrtBox[
                                  RowBox[{
                                    SubscriptBox["\[Alpha]", 
                                      RowBox[{"m", ",", "0"}]], " ", 
                                    SubscriptBox["\[Alpha]p", 
                                      RowBox[{"mp", ",", "1"}]]}]], " ", 
                                SubscriptBox["\[Gamma]", 
                                  RowBox[{"1", ",", "0"}]]}]}], ")"}]}], "+", 
                        
                        RowBox[{
                          SubscriptBox["\[Beta]", "0"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{
                                SqrtBox[
                                  RowBox[{
                                    SubscriptBox["\[Alpha]", 
                                      RowBox[{"m", ",", "1"}]], " ", 
                                    SubscriptBox["\[Alpha]p", 
                                      RowBox[{"mp", ",", "0"}]]}]], " ", 
                                SubscriptBox["\[Gamma]", 
                                  RowBox[{"0", ",", "1"}]]}], "+", 
                              RowBox[{
                                SqrtBox[
                                  RowBox[{
                                    SubscriptBox["\[Alpha]", 
                                      RowBox[{"m", ",", "1"}]], " ", 
                                    SubscriptBox["\[Alpha]p", 
                                      RowBox[{"mp", ",", "1"}]]}]], " ", 
                                SubscriptBox["\[Gamma]", 
                                  RowBox[{"1", ",", "1"}]]}]}], ")"}]}]}], 
                      ")"}]}], "]"}], "2"], "+", 
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  RowBox[{
                    SubscriptBox["\[Beta]", "1"], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{
                          SubscriptBox["\[Beta]", "1"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{
                                SqrtBox[
                                  RowBox[{
                                    SubscriptBox["\[Alpha]", 
                                      RowBox[{"m", ",", "0"}]], " ", 
                                    SubscriptBox["\[Alpha]p", 
                                      RowBox[{"mp", ",", "0"}]]}]], " ", 
                                SubscriptBox["\[Gamma]", 
                                  RowBox[{"0", ",", "0"}]]}], "+", 
                              RowBox[{
                                SqrtBox[
                                  RowBox[{
                                    SubscriptBox["\[Alpha]", 
                                      RowBox[{"m", ",", "0"}]], " ", 
                                    SubscriptBox["\[Alpha]p", 
                                      RowBox[{"mp", ",", "1"}]]}]], " ", 
                                SubscriptBox["\[Gamma]", 
                                  RowBox[{"1", ",", "0"}]]}]}], ")"}]}], "+", 
                        
                        RowBox[{"2", " ", 
                          SubscriptBox["\[Beta]", "0"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{
                                SqrtBox[
                                  RowBox[{
                                    SubscriptBox["\[Alpha]", 
                                      RowBox[{"m", ",", "1"}]], " ", 
                                    SubscriptBox["\[Alpha]p", 
                                      RowBox[{"mp", ",", "0"}]]}]], " ", 
                                SubscriptBox["\[Gamma]", 
                                  RowBox[{"0", ",", "1"}]]}], "+", 
                              RowBox[{
                                SqrtBox[
                                  RowBox[{
                                    SubscriptBox["\[Alpha]", 
                                      RowBox[{"m", ",", "1"}]], " ", 
                                    SubscriptBox["\[Alpha]p", 
                                      RowBox[{"mp", ",", "1"}]]}]], " ", 
                                SubscriptBox["\[Gamma]", 
                                  RowBox[{"1", ",", "1"}]]}]}], ")"}]}]}], 
                      ")"}]}], "]"}], "2"]}], ")"}]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"sM3", "-", "tmp4"}], "//.", "substs1"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{
      RowBox[{"sM3", "=", 
        RowBox[{
          FractionBox["1", "24"], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{"3", 
                RowBox[{
                  SubsuperscriptBox["\[Sum]", 
                    RowBox[{"j", "=", "0"}], "1"], " ", 
                  SuperscriptBox[
                    RowBox[{"Abs", "[", 
                      RowBox[{
                        SubsuperscriptBox["\[Beta]", "j", "2"], " ", 
                        RowBox[{"(", " ", 
                          RowBox[{
                            SubscriptBox["b", 
                              RowBox[{"0", ",", "j"}]], "+", 
                            SubscriptBox["b", 
                              RowBox[{"1", ",", "j"}]]}], ")"}]}], "]"}], 
                    "2"]}]}], "+", 
              RowBox[{
                SubsuperscriptBox["\[Sum]", 
                  RowBox[{"j", "=", "0"}], "1"], 
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    RowBox[{
                      SubscriptBox["\[Beta]", "j"], 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SubscriptBox["\[Beta]", "j"], 
                            RowBox[{"(", 
                              RowBox[{
                                SubscriptBox["b", 
                                  RowBox[{"0", ",", 
                                    RowBox[{"1", "-", "j"}]}]], "+", 
                                SubscriptBox["b", 
                                  RowBox[{"1", ",", 
                                    RowBox[{"1", "-", "j"}]}]]}], ")"}]}], 
                          "+", 
                          RowBox[{"2", 
                            SubscriptBox["\[Beta]", 
                              RowBox[{"1", "-", "j"}]], 
                            RowBox[{"(", 
                              RowBox[{
                                SubscriptBox["b", 
                                  RowBox[{"0", ",", "j"}]], "+", 
                                SubscriptBox["b", 
                                  RowBox[{"1", ",", "j"}]]}], ")"}]}]}], 
                        ")"}]}], "]"}], "2"]}]}], ")"}]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"sM3", "-", "tmp4"}], "//.", "substs1"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{"sM", "\[Congruent]", 
            SubscriptBox["s", "M"]}], "=", 
          RowBox[{
            RowBox[{
              SubscriptBox[
                SubscriptBox["s", "M"], "1"], "+", 
              SubscriptBox[
                SubscriptBox["s", "M"], "2"], "+", 
              SubscriptBox[
                SubscriptBox["s", "M"], "3"]}], "=", 
            RowBox[{"sM1", "+", "sM2", "+", "sM3"}]}]}], TraditionalForm]]],
  ":"
}], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"sM1", "+", "sM2", "+", "sM3"}], "//", 
      RowBox[{
        RowBox[{"Simplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      FractionBox["1", "24"], " ", 
      RowBox[{"(", 
        RowBox[{
          FractionBox[
            RowBox[{"6", " ", "\[Pi]", " ", 
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  RowBox[{
                    RowBox[{
                      SubscriptBox["\[Beta]p", "0"], " ", 
                      SubscriptBox["b", 
                        RowBox[{"0", ",", "0"}]]}], "+", 
                    RowBox[{
                      SubscriptBox["\[Beta]p", "1"], " ", 
                      SubscriptBox["b", 
                        RowBox[{"1", ",", "0"}]]}]}], "]"}], "4"]}], 
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                RowBox[{
                  SubscriptBox["b", 
                    RowBox[{"0", ",", "0"}]], "+", 
                  SubscriptBox["b", 
                    RowBox[{"1", ",", "0"}]]}], "]"}], "2"]], "+", 
          RowBox[{"3", " ", 
            RowBox[{"(", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    RowBox[{
                      SubsuperscriptBox["\[Beta]", "0", "2"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SubscriptBox["b", 
                            RowBox[{"0", ",", "0"}]], "+", 
                          SubscriptBox["b", 
                            RowBox[{"1", ",", "0"}]]}], ")"}]}], "]"}], "2"], 
                "+", 
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    RowBox[{
                      SubsuperscriptBox["\[Beta]", "1", "2"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SubscriptBox["b", 
                            RowBox[{"0", ",", "1"}]], "+", 
                          SubscriptBox["b", 
                            RowBox[{"1", ",", "1"}]]}], ")"}]}], "]"}], 
                  "2"]}], ")"}]}], "+", 
          SuperscriptBox[
            RowBox[{"Abs", "[", 
              RowBox[{
                SubscriptBox["\[Beta]", "0"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]", "1"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SubscriptBox["b", 
                            RowBox[{"0", ",", "0"}]], "+", 
                          SubscriptBox["b", 
                            RowBox[{"1", ",", "0"}]]}], ")"}]}], "+", 
                    RowBox[{
                      SubscriptBox["\[Beta]", "0"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SubscriptBox["b", 
                            RowBox[{"0", ",", "1"}]], "+", 
                          SubscriptBox["b", 
                            RowBox[{"1", ",", "1"}]]}], ")"}]}]}], ")"}]}], 
              "]"}], "2"], "+", 
          SuperscriptBox[
            RowBox[{"Abs", "[", 
              RowBox[{
                SubscriptBox["\[Beta]", "1"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SubscriptBox["\[Beta]", "1"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SubscriptBox["b", 
                            RowBox[{"0", ",", "0"}]], "+", 
                          SubscriptBox["b", 
                            RowBox[{"1", ",", "0"}]]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                      SubscriptBox["\[Beta]", "0"], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          SubscriptBox["b", 
                            RowBox[{"0", ",", "1"}]], "+", 
                          SubscriptBox["b", 
                            RowBox[{"1", ",", "1"}]]}], ")"}]}]}], ")"}]}], 
              "]"}], "2"], "+", 
          RowBox[{"8", " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{
                  RowBox[{"-", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Abs", "[", 
                              SubscriptBox["\[Beta]", "0"], "]"}], "2"]}], 
                        "+", 
                        SuperscriptBox[
                          RowBox[{"Abs", "[", 
                            SubscriptBox["\[Beta]", "1"], "]"}], "2"]}], 
                      ")"}]}], " ", 
                  SuperscriptBox[
                    RowBox[{"Abs", "[", 
                      RowBox[{
                        SubscriptBox["b2", 
                          RowBox[{"0", ",", "0"}]], "+", 
                        SubscriptBox["b2", 
                          RowBox[{"1", ",", "0"}]]}], "]"}], "2"], " ", 
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]}], "-", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      SuperscriptBox[
                        RowBox[{"Abs", "[", 
                          SubscriptBox["\[Beta]", "0"], "]"}], "2"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Abs", "[", 
                            SubscriptBox["\[Beta]", "1"], "]"}], "2"]}]}], 
                    ")"}], " ", 
                  SuperscriptBox[
                    RowBox[{"Abs", "[", 
                      RowBox[{
                        SubscriptBox["b2", 
                          RowBox[{"0", ",", "1"}]], "+", 
                        SubscriptBox["b2", 
                          RowBox[{"1", ",", "1"}]]}], "]"}], "2"], " ", 
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]}], "-", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"Conjugate", "[", 
                          SubscriptBox["\[Beta]", "0"], "]"}], " ", 
                        RowBox[{"Conjugate", "[", 
                          RowBox[{
                            SubscriptBox["b2", 
                              RowBox[{"0", ",", "1"}]], "+", 
                            SubscriptBox["b2", 
                              RowBox[{"1", ",", "1"}]]}], "]"}], " ", 
                        SubscriptBox["\[Beta]", "1"], " ", 
                        RowBox[{"(", 
                          RowBox[{
                            SubscriptBox["b2", 
                              RowBox[{"0", ",", "0"}]], "+", 
                            SubscriptBox["b2", 
                              RowBox[{"1", ",", "0"}]]}], ")"}]}], "+", 
                      RowBox[{
                        RowBox[{"Conjugate", "[", 
                          SubscriptBox["\[Beta]", "1"], "]"}], " ", 
                        RowBox[{"Conjugate", "[", 
                          RowBox[{
                            SubscriptBox["b2", 
                              RowBox[{"0", ",", "0"}]], "+", 
                            SubscriptBox["b2", 
                              RowBox[{"1", ",", "0"}]]}], "]"}], " ", 
                        SubscriptBox["\[Beta]", "0"], " ", 
                        RowBox[{"(", 
                          RowBox[{
                            SubscriptBox["b2", 
                              RowBox[{"0", ",", "1"}]], "+", 
                            SubscriptBox["b2", 
                              RowBox[{"1", ",", "1"}]]}], ")"}]}]}], ")"}], 
                  " ", 
                  SqrtBox[
                    RowBox[{
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "0"}]], " ", 
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "1"}]]}]]}]}], ")"}]}]}], 
        ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"sM", "=", 
        RowBox[{
          FractionBox["1", "24"], " ", 
          RowBox[{"(", 
            RowBox[{
              FractionBox[
                RowBox[{"6", " ", "\[Pi]", " ", 
                  SuperscriptBox[
                    RowBox[{"Abs", "[", 
                      RowBox[{
                        RowBox[{
                          SubscriptBox["\[Beta]p", "0"], " ", 
                          SubscriptBox["b", 
                            RowBox[{"0", ",", "0"}]]}], "+", 
                        RowBox[{
                          SubscriptBox["\[Beta]p", "1"], " ", 
                          SubscriptBox["b", 
                            RowBox[{"1", ",", "0"}]]}]}], "]"}], "4"]}], 
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    RowBox[{
                      SubscriptBox["b", 
                        RowBox[{"0", ",", "0"}]], "+", 
                      SubscriptBox["b", 
                        RowBox[{"1", ",", "0"}]]}], "]"}], "2"]], "+", 
              RowBox[{"3", " ", 
                RowBox[{"(", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Abs", "[", 
                        RowBox[{
                          SubsuperscriptBox["\[Beta]", "0", "2"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              SubscriptBox["b", 
                                RowBox[{"0", ",", "0"}]], "+", 
                              SubscriptBox["b", 
                                RowBox[{"1", ",", "0"}]]}], ")"}]}], "]"}], 
                      "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Abs", "[", 
                        RowBox[{
                          SubsuperscriptBox["\[Beta]", "1", "2"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              SubscriptBox["b", 
                                RowBox[{"0", ",", "1"}]], "+", 
                              SubscriptBox["b", 
                                RowBox[{"1", ",", "1"}]]}], ")"}]}], "]"}], 
                      "2"]}], ")"}]}], "+", 
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  RowBox[{
                    SubscriptBox["\[Beta]", "0"], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", 
                          SubscriptBox["\[Beta]", "1"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              SubscriptBox["b", 
                                RowBox[{"0", ",", "0"}]], "+", 
                              SubscriptBox["b", 
                                RowBox[{"1", ",", "0"}]]}], ")"}]}], "+", 
                        RowBox[{
                          SubscriptBox["\[Beta]", "0"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              SubscriptBox["b", 
                                RowBox[{"0", ",", "1"}]], "+", 
                              SubscriptBox["b", 
                                RowBox[{"1", ",", "1"}]]}], ")"}]}]}], 
                      ")"}]}], "]"}], "2"], "+", 
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  RowBox[{
                    SubscriptBox["\[Beta]", "1"], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{
                          SubscriptBox["\[Beta]", "1"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              SubscriptBox["b", 
                                RowBox[{"0", ",", "0"}]], "+", 
                              SubscriptBox["b", 
                                RowBox[{"1", ",", "0"}]]}], ")"}]}], "+", 
                        RowBox[{"2", " ", 
                          SubscriptBox["\[Beta]", "0"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              SubscriptBox["b", 
                                RowBox[{"0", ",", "1"}]], "+", 
                              SubscriptBox["b", 
                                RowBox[{"1", ",", "1"}]]}], ")"}]}]}], 
                      ")"}]}], "]"}], "2"], "+", 
              RowBox[{"8", " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      RowBox[{"-", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Abs", "[", 
                                  SubscriptBox["\[Beta]", "0"], "]"}], "2"]}],
                             "+", 
                            SuperscriptBox[
                              RowBox[{"Abs", "[", 
                                SubscriptBox["\[Beta]", "1"], "]"}], "2"]}], 
                          ")"}]}], " ", 
                      SuperscriptBox[
                        RowBox[{"Abs", "[", 
                          RowBox[{
                            SubscriptBox["b2", 
                              RowBox[{"0", ",", "0"}]], "+", 
                            SubscriptBox["b2", 
                              RowBox[{"1", ",", "0"}]]}], "]"}], "2"], " ", 
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "0"}]]}], "-", 
                    RowBox[{
                      RowBox[{"(", 
                        RowBox[{
                          SuperscriptBox[
                            RowBox[{"Abs", "[", 
                              SubscriptBox["\[Beta]", "0"], "]"}], "2"], "+", 
                          
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Abs", "[", 
                                SubscriptBox["\[Beta]", "1"], "]"}], "2"]}]}],
                         ")"}], " ", 
                      SuperscriptBox[
                        RowBox[{"Abs", "[", 
                          RowBox[{
                            SubscriptBox["b2", 
                              RowBox[{"0", ",", "1"}]], "+", 
                            SubscriptBox["b2", 
                              RowBox[{"1", ",", "1"}]]}], "]"}], "2"], " ", 
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "1"}]]}], "-", 
                    RowBox[{"2", 
                      SqrtBox[
                        RowBox[{
                          SubscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "0"}]], " ", 
                          SubscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "1"}]]}]], 
                      RowBox[{"Re", "[", 
                        RowBox[{
                          RowBox[{"Conjugate", "[", 
                            SubscriptBox["\[Beta]", "0"], "]"}], 
                          SubscriptBox["\[Beta]", "1"], " ", 
                          RowBox[{"Conjugate", "[", 
                            RowBox[{
                              SubscriptBox["b2", 
                                RowBox[{"0", ",", "1"}]], "+", 
                              SubscriptBox["b2", 
                                RowBox[{"1", ",", "1"}]]}], "]"}], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              SubscriptBox["b2", 
                                RowBox[{"0", ",", "0"}]], "+", 
                              SubscriptBox["b2", 
                                RowBox[{"1", ",", "0"}]]}], ")"}]}], 
                        "]"}]}]}], ")"}]}]}], ")"}]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"sM", "-", 
          RowBox[{"(", 
            RowBox[{"sM1", "+", "sM2", "+", "sM3"}], ")"}]}], "//.", 
        "substs2"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"sM", "=", 
        RowBox[{
          FractionBox["1", "24"], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{"6", " ", "\[Pi]", 
                FractionBox[
                  RowBox[{" ", 
                    SuperscriptBox[
                      RowBox[{"Abs", "[", 
                        RowBox[{
                          RowBox[{
                            SubscriptBox["\[Beta]p", "0"], " ", 
                            SubscriptBox["b", 
                              RowBox[{"0", ",", "0"}]]}], "+", 
                          RowBox[{
                            SubscriptBox["\[Beta]p", "1"], " ", 
                            SubscriptBox["b", 
                              RowBox[{"1", ",", "0"}]]}]}], "]"}], "4"]}], 
                  SuperscriptBox[
                    RowBox[{"Abs", "[", 
                      RowBox[{
                        SubscriptBox["b", 
                          RowBox[{"0", ",", "0"}]], "+", 
                        SubscriptBox["b", 
                          RowBox[{"1", ",", "0"}]]}], "]"}], "2"]]}], "+", 
              RowBox[{"3", " ", 
                RowBox[{
                  SubsuperscriptBox["\[Sum]", 
                    RowBox[{"j", "=", "0"}], "1"], 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Abs", "[", 
                        SubsuperscriptBox["\[Beta]", "j", "2"], " ", "]"}], 
                      "2"], 
                    SuperscriptBox[
                      RowBox[{"Abs", "[", 
                        RowBox[{"(", 
                          RowBox[{
                            SubscriptBox["b", 
                              RowBox[{"0", ",", "j"}]], "+", 
                            SubscriptBox["b", 
                              RowBox[{"1", ",", "j"}]]}], ")"}], "]"}], 
                      "2"]}]}]}], "+", 
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  RowBox[{
                    SubscriptBox["\[Beta]", "0"], 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", 
                          SubscriptBox["\[Beta]", "1"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              SubscriptBox["b", 
                                RowBox[{"0", ",", "0"}]], "+", 
                              SubscriptBox["b", 
                                RowBox[{"1", ",", "0"}]]}], ")"}]}], "+", 
                        RowBox[{
                          SubscriptBox["\[Beta]", "0"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              SubscriptBox["b", 
                                RowBox[{"0", ",", "1"}]], "+", 
                              SubscriptBox["b", 
                                RowBox[{"1", ",", "1"}]]}], ")"}]}]}], 
                      ")"}]}], "]"}], "2"], "+", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", "1"], "]"}], "2"], 
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{
                          SubscriptBox["\[Beta]", "1"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              SubscriptBox["b", 
                                RowBox[{"0", ",", "0"}]], "+", 
                              SubscriptBox["b", 
                                RowBox[{"1", ",", "0"}]]}], ")"}]}], "+", 
                        RowBox[{"2", " ", 
                          SubscriptBox["\[Beta]", "0"], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              SubscriptBox["b", 
                                RowBox[{"0", ",", "1"}]], "+", 
                              SubscriptBox["b", 
                                RowBox[{"1", ",", "1"}]]}], ")"}]}]}], ")"}], 
                    "]"}], "2"]}], "+", 
              RowBox[{"8", " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      RowBox[{"-", 
                        RowBox[{"(", 
                          RowBox[{"1", "+", " ", 
                            SubscriptBox["\[Beta]2", "0"]}], ")"}]}], " ", 
                      SuperscriptBox[
                        RowBox[{"Abs", "[", 
                          RowBox[{
                            SubscriptBox["b2", 
                              RowBox[{"0", ",", "0"}]], "+", 
                            SubscriptBox["b2", 
                              RowBox[{"1", ",", "0"}]]}], "]"}], "2"], " ", 
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "0"}]]}], "-", 
                    RowBox[{
                      RowBox[{"(", 
                        RowBox[{"2", "-", 
                          SubscriptBox["\[Beta]2", "0"]}], ")"}], " ", 
                      SuperscriptBox[
                        RowBox[{"Abs", "[", 
                          RowBox[{
                            SubscriptBox["b2", 
                              RowBox[{"0", ",", "1"}]], "+", 
                            SubscriptBox["b2", 
                              RowBox[{"1", ",", "1"}]]}], "]"}], "2"], " ", 
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "1"}]]}], "-", 
                    RowBox[{"2", 
                      SqrtBox[
                        RowBox[{
                          SubscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "0"}]], " ", 
                          SubscriptBox["\[Alpha]", 
                            RowBox[{"m", ",", "1"}]]}]], 
                      RowBox[{"Re", "[", 
                        RowBox[{
                          RowBox[{"Conjugate", "[", 
                            SubscriptBox["\[Beta]", "0"], "]"}], 
                          SubscriptBox["\[Beta]", "1"], " ", 
                          RowBox[{"Conjugate", "[", 
                            RowBox[{
                              SubscriptBox["b2", 
                                RowBox[{"0", ",", "1"}]], "+", 
                              SubscriptBox["b2", 
                                RowBox[{"1", ",", "1"}]]}], "]"}], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              SubscriptBox["b2", 
                                RowBox[{"0", ",", "0"}]], "+", 
                              SubscriptBox["b2", 
                                RowBox[{"1", ",", "0"}]]}], ")"}]}], 
                        "]"}]}]}], ")"}]}]}], ")"}]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"sM", "-", 
          RowBox[{"(", 
            RowBox[{"sM1", "+", "sM2", "+", "sM3"}], ")"}]}], "//.", 
        "substs2"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
Evaluator->"psi",
WindowSize->{1025, 740},
WindowMargins->{{-4, Automatic}, {Automatic, 0}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 4995, 130, 152, "Input"],
Cell[6715, 181, 545, 18, 32, "Text"],

Cell[CellGroupData[{
Cell[7285, 203, 893, 24, 42, "Subsubsection"],
Cell[8181, 229, 1285, 31, 42, "Input"],
Cell[9469, 262, 1326, 32, 42, "Input"],
Cell[10798, 296, 170, 5, 47, "Input"],
Cell[10971, 303, 540, 14, 29, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11548, 322, 201, 7, 42, "Subsubsection"],
Cell[11752, 331, 818, 22, 40, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12607, 358, 201, 7, 42, "Subsubsection"],
Cell[12811, 367, 264, 8, 44, "Input"],

Cell[CellGroupData[{
Cell[13100, 379, 4770, 121, 114, "Input"],
Cell[17873, 502, 28, 0, 27, "Output"]
}, Open  ]],
Cell[17916, 505, 461, 12, 59, "Input"],

Cell[CellGroupData[{
Cell[18402, 521, 5837, 137, 106, "Input"],
Cell[24242, 660, 28, 0, 27, "Output"]
}, Open  ]],
Cell[24285, 663, 463, 12, 59, "Input"],
Cell[24751, 677, 2602, 61, 94, "Input"],
Cell[27356, 740, 225, 6, 27, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[27618, 751, 202, 7, 42, "Subsubsection"],
Cell[27823, 760, 301, 8, 44, "Input"],

Cell[CellGroupData[{
Cell[28149, 772, 5833, 146, 138, "Input"],
Cell[33985, 920, 28, 0, 27, "Output"]
}, Open  ]],
Cell[34028, 923, 461, 12, 59, "Input"],

Cell[CellGroupData[{
Cell[34514, 939, 8815, 196, 128, "Input"],
Cell[43332, 1137, 28, 0, 27, "Output"]
}, Open  ]],
Cell[43375, 1140, 463, 12, 59, "Input"],

Cell[CellGroupData[{
Cell[43863, 1156, 8046, 163, 141, "Input"],
Cell[51912, 1321, 28, 0, 27, "Output"]
}, Open  ]],
Cell[51955, 1324, 2285, 51, 44, "Input"],

Cell[CellGroupData[{
Cell[54265, 1379, 225, 6, 27, "Input"],
Cell[54493, 1387, 28, 0, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[54570, 1393, 534, 16, 42, "Subsubsection"],

Cell[CellGroupData[{
Cell[55129, 1413, 195, 5, 27, "Input"],
Cell[55327, 1420, 8028, 183, 138, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[63392, 1608, 8193, 178, 176, "Input"],
Cell[71588, 1788, 28, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[71653, 1793, 7196, 158, 176, "Input"],
Cell[78852, 1953, 28, 0, 27, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

