(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   1508922,      30077]*)
(*NotebookOutlinePosition[   1509579,      30101]*)
(*  CellTagsIndexPosition[   1509535,      30097]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[{
    RowBox[{
      RowBox[{"facts1", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"\[Theta]", "\[GreaterEqual]", "0"}], ",", 
            RowBox[{"\[Theta]", "\[LessEqual]", 
              RowBox[{"\[Pi]", "/", "2"}]}], ",", 
            RowBox[{"\[CurlyPhi]", "\[GreaterEqual]", "0"}], ",", 
            RowBox[{"\[CurlyPhi]", "\[LessEqual]", 
              RowBox[{"2", "\[Pi]"}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"facts2", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", 
                      RowBox[{"0", ",", "0"}]], "]"}], "2"], "+", 
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", 
                      RowBox[{"0", ",", "1"}]], "]"}], "2"]}], "\[Equal]", 
              "1"}], ",", 
            RowBox[{
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", 
                      RowBox[{"1", ",", "0"}]], "]"}], "2"], "+", 
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", 
                      RowBox[{"1", ",", "1"}]], "]"}], "2"]}], "\[Equal]", 
              "1"}], ",", 
            RowBox[{
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", 
                      RowBox[{"0", ",", "0"}]], "]"}], "2"], "+", 
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", 
                      RowBox[{"1", ",", "0"}]], "]"}], "2"]}], "\[Equal]", 
              "1"}], ",", 
            RowBox[{
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", 
                      RowBox[{"0", ",", "1"}]], "]"}], "2"], "+", 
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", 
                      RowBox[{"1", ",", "1"}]], "]"}], "2"]}], "\[Equal]", 
              "1"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"facts3", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["p", "0"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["p", "0"], "\[LessEqual]", "1"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[GreaterEqual]", "0"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[LessEqual]", "1"}], ",", 
            RowBox[{
              SubscriptBox["p", "1"], "\[GreaterEqual]", 
              SubscriptBox["p", "0"]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"substs1", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              RowBox[{"Abs", "[", 
                SubscriptBox["\[Beta]", "0"], "]"}], "\[Rule]", 
              SqrtBox[
                SubscriptBox["\[Beta]2", "0"]]}], ",", 
            RowBox[{
              RowBox[{"Abs", "[", 
                SubscriptBox["\[Beta]", "1"], "]"}], "\[Rule]", 
              SqrtBox[
                RowBox[{"1", "-", 
                  SubscriptBox["\[Beta]2", "0"]}]]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"substs2", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"0", ",", "0"}]], "\[Rule]", 
              SubscriptBox["p", "0"]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"0", ",", "1"}]], "\[Rule]", 
              SubscriptBox["p", "1"]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"1", ",", "0"}]], "\[Rule]", 
              RowBox[{"1", "-", 
                SubscriptBox["p", "0"]}]}], ",", 
            RowBox[{
              SubscriptBox["\[Alpha]", 
                RowBox[{"1", ",", "1"}]], "\[Rule]", 
              RowBox[{"1", "-", 
                SubscriptBox["p", "1"]}]}]}], "}"}]}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"1", "+", "1"}]], "Input"],

Cell[BoxData["2"], "Output"]
}, Open  ]],

Cell[TextData[{
  "Note that ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{
            SubscriptBox["\[Alpha]", 
              RowBox[{"0", ",", "j"}]], "=", 
            SubscriptBox["\[Alpha]", 
              RowBox[{"+", 
                RowBox[{",", "j"}]}]]}], ",", 
          RowBox[{
            SubscriptBox["\[Alpha]", 
              RowBox[{"1", ",", "j"}]], "=", 
            SubscriptBox["\[Alpha]", 
              RowBox[{"-", 
                RowBox[{",", "j"}]}]]}]}], TraditionalForm]]],
  "."
}], "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{"integrand", "=", 
        RowBox[{
          RowBox[{"Sin", "[", 
            RowBox[{"2", "\[Theta]"}], "]"}], 
          SuperscriptBox[
            RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
          RowBox[{
            RowBox[{"Abs", "[", 
              RowBox[{
                RowBox[{
                  SubscriptBox["\[Beta]", 
                    RowBox[{"1", ",", "0"}]], 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"Conjugate", "[", 
                          SubscriptBox["\[Beta]", 
                            RowBox[{"0", ",", "0"}]], "]"}], 
                        RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
                      RowBox[{
                        RowBox[{"Conjugate", "[", 
                          SubscriptBox["\[Beta]", 
                            RowBox[{"1", ",", "0"}]], "]"}], 
                        RowBox[{"Exp", "[", 
                          RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}], 
                        RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ")"}]}], 
                "+", 
                RowBox[{
                  RowBox[{"Exp", "[", 
                    RowBox[{"I", " ", "\[Chi]"}], "]"}], 
                  SubscriptBox["\[Beta]", 
                    RowBox[{"1", ",", "1"}]], 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"Conjugate", "[", 
                          SubscriptBox["\[Beta]", 
                            RowBox[{"0", ",", "1"}]], "]"}], 
                        RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
                      RowBox[{
                        RowBox[{"Conjugate", "[", 
                          SubscriptBox["\[Beta]", 
                            RowBox[{"1", ",", "1"}]], "]"}], 
                        RowBox[{"Exp", "[", 
                          RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}], 
                        RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ")"}]}]}], 
              "]"}], "^", "2"}]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp1substs", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "1"], "\[Rule]", 
              RowBox[{
                RowBox[{"Sin", "[", 
                  RowBox[{"2", "\[Theta]"}], "]"}], 
                SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "2"], "\[Rule]", 
              RowBox[{
                RowBox[{"Conjugate", "[", 
                  SubscriptBox["\[Beta]", 
                    RowBox[{"0", ",", "0"}]], "]"}], 
                RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "3"], "\[Rule]", 
              RowBox[{
                RowBox[{"Conjugate", "[", 
                  SubscriptBox["\[Beta]", 
                    RowBox[{"1", ",", "0"}]], "]"}], 
                RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "4"], "\[Rule]", 
              RowBox[{
                RowBox[{"Conjugate", "[", 
                  SubscriptBox["\[Beta]", 
                    RowBox[{"0", ",", "1"}]], "]"}], 
                RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "5"], "\[Rule]", 
              RowBox[{
                RowBox[{"Conjugate", "[", 
                  SubscriptBox["\[Beta]", 
                    RowBox[{"1", ",", "1"}]], "]"}], 
                RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "6"], "\[Rule]", 
              RowBox[{
                RowBox[{
                  SubscriptBox["\[Beta]", 
                    RowBox[{"1", ",", "0"}]], 
                  SubscriptBox["c", "2"]}], "+", 
                RowBox[{
                  RowBox[{"Exp", "[", 
                    RowBox[{"I", " ", "\[Chi]"}], "]"}], 
                  SubscriptBox["\[Beta]", 
                    RowBox[{"1", ",", "1"}]], 
                  SubscriptBox["c", "4"]}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "7"], "\[Rule]", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{
                    RowBox[{"Exp", "[", 
                      RowBox[{"I", " ", "\[Chi]"}], "]"}], 
                    SubscriptBox["\[Beta]", 
                      RowBox[{"1", ",", "1"}]], 
                    SubscriptBox["c", "5"]}], "+", 
                  RowBox[{
                    SubscriptBox["\[Beta]", 
                      RowBox[{"1", ",", "0"}]], 
                    SubscriptBox["c", "3"]}]}], ")"}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp1", "=", 
        RowBox[{
          SubscriptBox["c", "1"], 
          RowBox[{
            RowBox[{"Abs", "[", 
              RowBox[{
                SubscriptBox["c", "6"], "+", 
                RowBox[{
                  SubscriptBox["c", "7"], 
                  RowBox[{"Exp", "[", 
                    RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}]}], "]"}], "^", 
            "2"}]}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"tmp1", "-", "integrand"}], "//.", "tmp1substs"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp1", ",", 
            RowBox[{"{", 
              RowBox[{"\[CurlyPhi]", ",", "0", ",", 
                RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "//", 
        "FullSimplify"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp2", "=", 
        RowBox[{"%", "//.", "tmp1substs"}]}], ";"}]}], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp3", "=", 
        RowBox[{"4", " ", "\[Pi]", " ", 
          RowBox[{"(", 
            RowBox[{
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        SuperscriptBox[
                          RowBox[{"Abs", "[", 
                            SubscriptBox["\[Beta]", 
                              RowBox[{"1", ",", "0"}]], "]"}], "2"], "+", 
                        RowBox[{
                          SuperscriptBox["\[ExponentialE]", 
                            RowBox[{"\[ImaginaryI]", " ", "\[Chi]"}]], " ", 
                          SuperscriptBox[
                            RowBox[{"Abs", "[", 
                              SubscriptBox["\[Beta]", 
                                RowBox[{"1", ",", "1"}]], "]"}], "2"]}]}], 
                      ")"}], " ", 
                    RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "]"}], "2"], "+",
               
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  RowBox[{
                    RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{
                          RowBox[{"Conjugate", "[", 
                            SubscriptBox["\[Beta]", 
                              RowBox[{"0", ",", "0"}]], "]"}], " ", 
                          SubscriptBox["\[Beta]", 
                            RowBox[{"1", ",", "0"}]]}], "+", 
                        RowBox[{
                          SuperscriptBox["\[ExponentialE]", 
                            RowBox[{"\[ImaginaryI]", " ", "\[Chi]"}]], " ", 
                          RowBox[{"Conjugate", "[", 
                            SubscriptBox["\[Beta]", 
                              RowBox[{"0", ",", "1"}]], "]"}], " ", 
                          SubscriptBox["\[Beta]", 
                            RowBox[{"1", ",", "1"}]]}]}], ")"}]}], "]"}], 
                "2"]}], ")"}], " ", 
          RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
          SuperscriptBox[
            RowBox[{"Sin", "[", "\[Theta]", "]"}], "3"]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp3", "-", "tmp2"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp4", "=", 
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp3", ",", 
            RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "0", ",", 
                RowBox[{"\[Pi]", "/", "2"}]}], "}"}]}], "]"}]}], 
      ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp3", "=", 
        SuperscriptBox[
          RowBox[{"Abs", "[", 
            RowBox[{
              SuperscriptBox[
                RowBox[{"Abs", "[", "b", "]"}], "2"], " ", 
              RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "]"}], "2"]}], " ", 
      ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"integrand", "=", 
      RowBox[{
        RowBox[{"Abs", "[", 
          RowBox[{
            RowBox[{
              RowBox[{"Abs", "[", "b", "]"}], "^", "2"}], " ", 
            RowBox[{"Sin", "[", "x", "]"}]}], "]"}], "^", "2"}]}]], "Input"],

Cell[BoxData[
    SuperscriptBox[
      RowBox[{"Abs", "[", 
        RowBox[{
          SuperscriptBox[
            RowBox[{"Abs", "[", "b", "]"}], "2"], " ", 
          RowBox[{"Sin", "[", "x", "]"}]}], "]"}], "2"]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"Integrate", "[", 
        RowBox[{"integrand", ",", 
          RowBox[{"{", 
            RowBox[{"x", ",", "0", ",", "Pi"}], "}"}]}], "]"}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{"%", "\[Equal]", 
      RowBox[{"Pi", " ", "*", " ", 
        RowBox[{
          RowBox[{"b", "^", "4"}], "/", "2"}]}]}]}], "Input"],

Cell[BoxData["True"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"integrand2", "=", 
        RowBox[{
          RowBox[{
            RowBox[{"Abs", "[", "b", "]"}], "^", "4"}], " ", 
          SuperscriptBox[
            RowBox[{"Sin", "[", "x", "]"}], "2"]}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"integrand2", "-", "integrand"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"x", "\[GreaterEqual]", "0"}], ",", 
                RowBox[{
                  RowBox[{"Sin", "[", "x", "]"}], "\[GreaterEqual]", "0"}]}], 
              "}"}]}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"Abs", "[", 
        RowBox[{"Cos", "[", "x", "]"}], "]"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"x", "\[GreaterEqual]", "0"}]}], "]"}], "&"}]}]], "Input"],

Cell[BoxData[
    RowBox[{"Abs", "[", 
      RowBox[{"Cos", "[", "x", "]"}], "]"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Integrate", "[", 
      RowBox[{
        RowBox[{
          RowBox[{
            RowBox[{"Abs", "[", "b", "]"}], "^", "4"}], " ", 
          RowBox[{
            RowBox[{"Sin", "[", "x", "]"}], "^", "2"}]}], ",", 
        RowBox[{"{", 
          RowBox[{"x", ",", "0", ",", "Pi"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
    RowBox[{
      FractionBox["1", "2"], " ", "\[Pi]", " ", 
      SuperscriptBox[
        RowBox[{"Abs", "[", "b", "]"}], "4"]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"Plot", "[", 
        RowBox[{
          RowBox[{
            RowBox[{"Abs", "[", 
              RowBox[{"1", "+", 
                RowBox[{"2", "I"}]}], "]"}], 
            RowBox[{"Sin", "[", "x", "]"}]}], ",", 
          RowBox[{"{", 
            RowBox[{"x", ",", "0", ",", "\[Pi]"}], "}"}]}], "]"}], 
      ";"}]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.303152 0.0147151 0.263232 [
[.17539 .00222 -9 -9 ]
[.17539 .00222 9 0 ]
[.32696 .00222 -3 -9 ]
[.32696 .00222 3 0 ]
[.47854 .00222 -9 -9 ]
[.47854 .00222 9 0 ]
[.63011 .00222 -3 -9 ]
[.63011 .00222 3 0 ]
[.78169 .00222 -9 -9 ]
[.78169 .00222 9 0 ]
[.93327 .00222 -3 -9 ]
[.93327 .00222 3 0 ]
[.01131 .14633 -18 -4.5 ]
[.01131 .14633 0 4.5 ]
[.01131 .27795 -6 -4.5 ]
[.01131 .27795 0 4.5 ]
[.01131 .40956 -18 -4.5 ]
[.01131 .40956 0 4.5 ]
[.01131 .54118 -6 -4.5 ]
[.01131 .54118 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.17539 .01472 m
.17539 .02097 L
s
[(0.5)] .17539 .00222 0 1 Mshowa
.32696 .01472 m
.32696 .02097 L
s
[(1)] .32696 .00222 0 1 Mshowa
.47854 .01472 m
.47854 .02097 L
s
[(1.5)] .47854 .00222 0 1 Mshowa
.63011 .01472 m
.63011 .02097 L
s
[(2)] .63011 .00222 0 1 Mshowa
.78169 .01472 m
.78169 .02097 L
s
[(2.5)] .78169 .00222 0 1 Mshowa
.93327 .01472 m
.93327 .02097 L
s
[(3)] .93327 .00222 0 1 Mshowa
.125 Mabswid
.05412 .01472 m
.05412 .01847 L
s
.08444 .01472 m
.08444 .01847 L
s
.11476 .01472 m
.11476 .01847 L
s
.14507 .01472 m
.14507 .01847 L
s
.2057 .01472 m
.2057 .01847 L
s
.23602 .01472 m
.23602 .01847 L
s
.26633 .01472 m
.26633 .01847 L
s
.29665 .01472 m
.29665 .01847 L
s
.35728 .01472 m
.35728 .01847 L
s
.38759 .01472 m
.38759 .01847 L
s
.41791 .01472 m
.41791 .01847 L
s
.44822 .01472 m
.44822 .01847 L
s
.50885 .01472 m
.50885 .01847 L
s
.53917 .01472 m
.53917 .01847 L
s
.56948 .01472 m
.56948 .01847 L
s
.5998 .01472 m
.5998 .01847 L
s
.66043 .01472 m
.66043 .01847 L
s
.69074 .01472 m
.69074 .01847 L
s
.72106 .01472 m
.72106 .01847 L
s
.75138 .01472 m
.75138 .01847 L
s
.81201 .01472 m
.81201 .01847 L
s
.84232 .01472 m
.84232 .01847 L
s
.87264 .01472 m
.87264 .01847 L
s
.90295 .01472 m
.90295 .01847 L
s
.96358 .01472 m
.96358 .01847 L
s
.9939 .01472 m
.9939 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .14633 m
.03006 .14633 L
s
[(0.5)] .01131 .14633 1 0 Mshowa
.02381 .27795 m
.03006 .27795 L
s
[(1)] .01131 .27795 1 0 Mshowa
.02381 .40956 m
.03006 .40956 L
s
[(1.5)] .01131 .40956 1 0 Mshowa
.02381 .54118 m
.03006 .54118 L
s
[(2)] .01131 .54118 1 0 Mshowa
.125 Mabswid
.02381 .04104 m
.02756 .04104 L
s
.02381 .06736 m
.02756 .06736 L
s
.02381 .09368 m
.02756 .09368 L
s
.02381 .12001 m
.02756 .12001 L
s
.02381 .17265 m
.02756 .17265 L
s
.02381 .19898 m
.02756 .19898 L
s
.02381 .2253 m
.02756 .2253 L
s
.02381 .25162 m
.02756 .25162 L
s
.02381 .30427 m
.02756 .30427 L
s
.02381 .33059 m
.02756 .33059 L
s
.02381 .35692 m
.02756 .35692 L
s
.02381 .38324 m
.02756 .38324 L
s
.02381 .43589 m
.02756 .43589 L
s
.02381 .46221 m
.02756 .46221 L
s
.02381 .48853 m
.02756 .48853 L
s
.02381 .51486 m
.02756 .51486 L
s
.02381 .5675 m
.02756 .5675 L
s
.02381 .59383 m
.02756 .59383 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .01472 m
.06244 .08953 L
.10458 .16969 L
.14415 .24228 L
.18221 .30846 L
.22272 .3738 L
.26171 .43065 L
.30316 .48353 L
.34309 .52621 L
.3815 .55892 L
.40095 .57218 L
.42237 .58412 L
.44268 .59283 L
.45178 .59589 L
.46172 .59863 L
.4671 .59986 L
.4721 .60083 L
.47727 .60167 L
.48196 .60228 L
.48658 .60274 L
.4887 .60291 L
.49093 .60306 L
.49332 .60318 L
.49438 .60322 L
.49552 .60326 L
.49675 .60329 L
.49789 .60331 L
.49859 .60331 L
.49925 .60332 L
.50049 .60332 L
.50163 .60331 L
.50286 .60329 L
.50401 .60327 L
.50508 .60324 L
.50754 .60314 L
.51014 .60299 L
.51268 .6028 L
.51504 .6026 L
.5204 .60199 L
.5293 .60057 L
.53882 .5985 L
.54906 .59563 L
.56016 .59177 L
.58032 .58278 L
.62123 .55688 L
.66064 .5226 L
.69852 .48155 L
.73886 .42986 L
.77769 .37317 L
.81897 .30648 L
Mistroke
.85873 .23712 L
.89697 .16678 L
.93767 .08931 L
.97619 .01472 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40n007h00Ooooo8Ooo003ooolQ
ool003Ooo`8000Coo`03003ooooo00;oo`<0023oo`@0023oo`@000?oo`03003ooooo00;oo`<0023o
o`@001ooo`@000?oo`03003ooooo00;oo`<0027oo`8001?oo`00=_oo00@00?ooool000_oo`03003o
oooo01ooo`03003ooooo027oo`03003ooooo00[oo`03003ooooo01goo`03003ooooo023oo`03003o
oooo00coo`03003ooooo01goo`04003ooooo000Bool003Koo`04003ooooo000;ool00`00ooooo`0O
ool00`00ooooo`0Qool00`00ooooo`0:ool00`00ooooo`0Nool00`00ooooo`0Pool00`00ooooo`0;
ool00`00ooooo`0Pool00`00ooooo`0@ool003Koo`04003ooooo0008ool3000Rool00`00ooooo`0Q
ool00`00ooooo`07ool3000Rool00`00ooooo`0Pool00`00ooooo`07ool3000Qool2000Cool003Ko
o`04003ooooo0008ool00`00ooooo`0Rool00`00ooooo`0Qool00`00ooooo`07ool00`00ooooo`0S
ool00`00ooooo`0Pool00`00ooooo`06ool00`00ooooo`0Sool00`00ooooo`0@ool003Koo`04003o
oooo0008ool00`00ooooo`0Pool3000Qool30009ool00`00ooooo`0Pool01000ooooo`007ooo00@0
0?ooool000Soo`03003ooooo023oo`04003ooooo000Bool001Goo`03003ooooo01ooo`8000Woo`@0
027oo`03003ooooo027oo`03003ooooo00Ooo`@0023oo`80027oo`8000Woo`@0023oo`8001?oo`00
5Ooo00<00?ooool0oooo2Ooo000Eool00`00ooooo`3oool9ool001Goo`03003ooooo0?ooo`Woo`00
3_ooo`004`00000Eool00`00ooooo`05ool00`00ooooo`05ool00`00ooooo`06ool00`00ooooo`05
ool00`00ooooo`05ool00`00ooooo`05ool00`00ooooo`06ool00`00ooooo`05ool00`00ooooo`05
ool00`00ooooo`05ool00`00ooooo`06ool00`00ooooo`05ool00`00ooooo`05ool00`00ooooo`05
ool00`00ooooo`06ool00`00ooooo`05ool00`00ooooo`05ool00`00ooooo`05ool00`00ooooo`06
ool00`00ooooo`05ool00`00ooooo`05ool00`00ooooo`05ool00`00ooooo`06ool00`00ooooo`05
ool00`00ooooo`05ool00`00ooooo`05ool00`00ooooo`06ool00`00ooooo`05ool00`00ooooo`05
ool00`00ooooo`05ool00`00ooooo`06ool01000ooooo`001?oo0@000Ooo0Ooo000Eool2000Wool0
0`00ooooo`0Vool00`00ooooo`0Wool00`00ooooo`0Vool00`00ooooo`0Vool00`00ooooo`0Vool0
0`00ooooo`08ool00`00ooooo`06ool001Goo`800?ooo`7oo`03003ooooo00Koo`005Ooo00<00?oo
0000o_oo00<00?ooool01ooo000Eool00`00ool0003nool00`00ooooo`07ool001Goo`04003ooooo
003lool00`00ooooo`08ool001Goo`800003ool00?oo0?_oo`03003ooooo00Soo`005Ooo00D00?oo
ooooo`000?[oo`03003ooooo00Woo`005Ooo00D00?ooooooo`000?[oo`03003ooooo00Woo`005Ooo
00<00?ooool00_oo00<00?ooool0m_oo00<00?ooool02_oo000Eool00`00ooooo`02ool00`00oooo
o`3fool00`00ooooo`0:ool001Goo`03003ooooo00?oo`03003ooooo0?Coo`03003ooooo00_oo`00
5Ooo00<00?ooool00ooo00<00?ooool0m?oo00<00?ooool02ooo000Eool20005ool00`00ooooo`3b
ool00`00ooooo`0<ool001Goo`03003ooooo00Coo`03003ooooo0?;oo`03003ooooo00coo`005Ooo
00<00?ooool01Ooo00<00?ooool0l?oo00<00?ooool03Ooo000Eool00`00ooooo`05ool00`00oooo
o`3`ool00`00ooooo`0=ool001Goo`03003ooooo00Koo`03003ooooo0>koo`03003ooooo00koo`00
5Ooo00<00?ooool01_oo00<00?ooool0k_oo00<00?ooool03_oo000Eool00`00ooooo`07ool00`00
ooooo`3/ool00`00ooooo`0?ool001Goo`03003ooooo00Ooo`03003ooooo0>_oo`03003ooooo013o
o`005Ooo0P002Ooo00<00?ooool0j_oo00<00?ooool04?oo000Eool00`00ooooo`08ool00`00oooo
o`3Yool00`00ooooo`0Aool001Goo`03003ooooo00Woo`03003ooooo0>Soo`03003ooooo017oo`00
5Ooo00<00?ooool02Ooo00<00?ooool0iooo00<00?ooool04_oo000Eool00`00ooooo`0:ool00`00
ooooo`3Vool00`00ooooo`0Bool001Goo`03003ooooo00[oo`03003ooooo0>Goo`03003ooooo01?o
o`005Ooo00<00?ooool02ooo00<00?ooool0i?oo00<00?ooool04ooo000Eool2000=ool00`00oooo
o`3Rool00`00ooooo`0Dool001Goo`03003ooooo00coo`03003ooooo0>;oo`03003ooooo01Coo`00
5Ooo00<00?ooool03Ooo00<00?ooool0h?oo00<00?ooool05Ooo000Eool00`00ooooo`0=ool00`00
ooooo`3Oool00`00ooooo`0Fool001Goo`03003ooooo00koo`03003ooooo0=koo`03003ooooo01Ko
o`000_oo0P001?oo00<00?ooool00_oo0`001Ooo00<00?ooool03_oo00<00?ooool0gOoo00<00?oo
ool05ooo00001Ooo003ooooo00002ooo00<00?ooool00_oo00<00?ooool03ooo00<00?ooool0g?oo
00<00?ooool05ooo00001Ooo003ooooo00002ooo00<00?ooool00_oo0`004?oo00<00?ooool0f_oo
00<00?ooool06?oo00001Ooo003ooooo00002?oo0`001Ooo00<00?ooool04?oo00<00?ooool0f_oo
00<00?ooool06?oo00001Ooo003ooooo00002?oo00<00?ooool01Ooo00<00?ooool04Ooo00<00?oo
ool0f?oo00<00?ooool06Ooo00001Ooo003ooooo00002?oo00<00?ooool01Ooo00<00?ooool04Ooo
00<00?ooool0f?oo00<00?ooool06Ooo0002ool20009ool40004ool00`00ooooo`0Bool00`00oooo
o`3Fool00`00ooooo`0Jool001Goo`03003ooooo01;oo`03003ooooo0=Koo`03003ooooo01[oo`00
5Ooo00<00?ooool04ooo00<00?ooool0e?oo00<00?ooool06ooo000Eool2000Eool00`00ooooo`3B
ool00`00ooooo`0Lool001Goo`03003ooooo01Coo`03003ooooo0=;oo`03003ooooo01coo`005Ooo
00<00?ooool05Ooo00<00?ooool0d?oo00<00?ooool07Ooo000Eool00`00ooooo`0Eool00`00oooo
o`3@ool00`00ooooo`0Mool001Goo`03003ooooo01Koo`03003ooooo0<koo`03003ooooo01koo`00
5Ooo00<00?ooool05_oo00<00?ooool0c_oo00<00?ooool07_oo000Eool00`00ooooo`0Gool00`00
ooooo`3<ool00`00ooooo`0Oool001Goo`8001Soo`03003ooooo0<coo`03003ooooo01ooo`005Ooo
00<00?ooool06?oo00<00?ooool0b_oo00<00?ooool08?oo000Eool00`00ooooo`0Hool00`00oooo
o`3:ool00`00ooooo`0Pool001Goo`03003ooooo01Woo`03003ooooo0<Soo`03003ooooo027oo`00
5Ooo00<00?ooool06_oo00<00?ooool0aooo00<00?ooool08Ooo000Eool00`00ooooo`0Jool00`00
ooooo`36ool00`00ooooo`0Rool001Goo`03003ooooo01_oo`03003ooooo0<Goo`03003ooooo02;o
o`005Ooo0P007?oo00<00?ooool0a?oo00<00?ooool08ooo000Eool00`00ooooo`0Lool00`00oooo
o`33ool00`00ooooo`0Sool001Goo`03003ooooo01coo`03003ooooo0<;oo`03003ooooo02Coo`00
5Ooo00<00?ooool07Ooo00<00?ooool0`Ooo00<00?ooool09?oo000Eool00`00ooooo`0Mool00`00
ooooo`30ool00`00ooooo`0Uool001Goo`03003ooooo01koo`03003ooooo0;koo`03003ooooo02Ko
o`005Ooo00<00?ooool07ooo00<00?ooool0_Ooo00<00?ooool09_oo000Eool00`00ooooo`0Oool0
0`00ooooo`2lool00`00ooooo`0Wool001Goo`80027oo`03003ooooo0;_oo`03003ooooo02Ooo`00
5Ooo00<00?ooool08?oo00<00?ooool0^_oo00<00?ooool0:?oo000Eool00`00ooooo`0Qool00`00
ooooo`2iool00`00ooooo`0Xool001Goo`03003ooooo027oo`03003ooooo0;Soo`03003ooooo02Wo
o`005Ooo00<00?ooool08_oo00<00?ooool0]_oo00<00?ooool0:_oo000=ool40004ool00`00oooo
o`0Rool00`00ooooo`2fool00`00ooooo`0Zool000ooo`03003ooooo00?oo`03003ooooo02?oo`03
003ooooo0;Coo`03003ooooo02_oo`003ooo00<00?ooool00ooo0`009?oo00<00?ooool0/ooo00<0
0?ooool0:ooo000?ool00`00ooooo`03ool00`00ooooo`0Tool00`00ooooo`2bool00`00ooooo`0/
ool000ooo`03003ooooo00?oo`03003ooooo02Goo`03003ooooo0;3oo`03003ooooo02goo`003Ooo
0`001Ooo00<00?ooool09Ooo00<00?ooool0/?oo00<00?ooool0;Ooo000?ool00`00ooooo`03ool0
0`00ooooo`0Vool00`00ooooo`2^ool00`00ooooo`0^ool001Goo`03003ooooo02Koo`03003ooooo
0:koo`03003ooooo02koo`005Ooo00<00?ooool09ooo00<00?ooool0[?oo00<00?ooool0;ooo000E
ool2000Xool00`00ooooo`2/ool00`00ooooo`0_ool001Goo`03003ooooo02Soo`03003ooooo0:[o
o`03003ooooo033oo`005Ooo00<00?ooool0:Ooo00<00?ooool0Z?oo00<00?ooool0<Ooo000Eool0
0`00ooooo`0Yool00`00ooooo`2Xool00`00ooooo`0aool001Goo`03003ooooo02[oo`03003ooooo
0:Koo`03003ooooo03;oo`005Ooo00<00?ooool0:_oo00<00?ooool0Y_oo00<00?ooool0<_oo000E
ool00`00ooooo`0[ool00`00ooooo`2Tool00`00ooooo`0cool001Goo`8002goo`03003ooooo0:;o
o`03003ooooo03Coo`005Ooo00<00?ooool0;?oo00<00?ooool0X_oo00<00?ooool0=?oo000Eool0
0`00ooooo`0]ool00`00ooooo`2Pool00`00ooooo`0eool001Goo`03003ooooo02goo`03003ooooo
0:3oo`03003ooooo03Goo`005Ooo00<00?ooool0;_oo00<00?ooool0W_oo00<00?ooool0=_oo000E
ool00`00ooooo`0_ool00`00ooooo`2Lool00`00ooooo`0gool001Goo`03003ooooo02ooo`03003o
oooo09coo`03003ooooo03Ooo`005Ooo0P00<Ooo00<00?ooool0V_oo00<00?ooool0>?oo000Eool0
0`00ooooo`0aool00`00ooooo`2Hool00`00ooooo`0iool001Goo`03003ooooo037oo`03003ooooo
09Soo`03003ooooo03Woo`005Ooo00<00?ooool0<_oo00<00?ooool0U_oo00<00?ooool0>_oo000E
ool00`00ooooo`0bool00`00ooooo`2Fool00`00ooooo`0jool001Goo`03003ooooo03?oo`03003o
oooo09Coo`03003ooooo03_oo`005Ooo00<00?ooool0=?oo00<00?ooool0T_oo00<00?ooool0??oo
000Eool2000eool00`00ooooo`2Bool00`00ooooo`0lool001Goo`03003ooooo03Goo`03003ooooo
093oo`03003ooooo03goo`005Ooo00<00?ooool0=_oo00<00?ooool0S_oo00<00?ooool0?_oo000E
ool00`00ooooo`0gool00`00ooooo`2<ool00`00ooooo`0oool001Goo`03003ooooo03Ooo`03003o
oooo08coo`03003ooooo03ooo`005Ooo00<00?ooool0>?oo00<00?ooool0R_oo00<00?ooool0@?oo
00000ooo000000020003ool00`00ooooo`02ool30005ool00`00ooooo`0iool00`00ooooo`28ool0
0`00ooooo`11ool000?oo`03003ooooo00[oo`03003ooooo00;oo`03003ooooo03[oo`03003ooooo
08Koo`03003ooooo04;oo`000ooo00<00?ooool02_oo00<00?ooool00_oo0`00>_oo00<00?ooool0
Q_oo00<00?ooool0@_oo0003ool00`00ooooo`07ool30005ool00`00ooooo`0kool00`00ooooo`24
ool00`00ooooo`13ool000?oo`03003ooooo00Ooo`03003ooooo00Goo`03003ooooo03coo`03003o
oooo08;oo`03003ooooo04Coo`0000Coo`00000000Woo`03003ooooo00Goo`03003ooooo03goo`03
003ooooo083oo`03003ooooo04Goo`000ooo00<00?ooool01ooo10001?oo00<00?ooool0?Ooo00<0
0?ooool0P?oo00<00?ooool0AOoo000Eool00`00ooooo`0nool00`00ooooo`1nool00`00ooooo`16
ool001Goo`03003ooooo03ooo`03003ooooo07coo`03003ooooo04Ooo`005Ooo0P00@?oo00<00?oo
ool0Nooo00<00?ooool0B?oo000Eool00`00ooooo`10ool00`00ooooo`1jool00`00ooooo`18ool0
01Goo`03003ooooo047oo`03003ooooo07Soo`03003ooooo04Woo`005Ooo00<00?ooool0@_oo00<0
0?ooool0M_oo00<00?ooool0B_oo000Eool00`00ooooo`12ool00`00ooooo`1eool00`00ooooo`1;
ool001Goo`03003ooooo04?oo`03003ooooo07Coo`03003ooooo04_oo`005Ooo00<00?ooool0A?oo
00<00?ooool0L_oo00<00?ooool0C?oo000Eool20016ool00`00ooooo`1`ool00`00ooooo`1=ool0
01Goo`03003ooooo04Goo`03003ooooo06ooo`03003ooooo04koo`005Ooo00<00?ooool0A_oo00<0
0?ooool0KOoo00<00?ooool0Cooo000Eool00`00ooooo`17ool00`00ooooo`1/ool00`00ooooo`1?
ool001Goo`03003ooooo04Soo`03003ooooo06[oo`03003ooooo053oo`005Ooo00<00?ooool0B?oo
00<00?ooool0JOoo00<00?ooool0DOoo000Eool00`00ooooo`19ool00`00ooooo`1Wool00`00oooo
o`1Bool001Goo`8004_oo`03003ooooo06Goo`03003ooooo05?oo`005Ooo00<00?ooool0Booo00<0
0?ooool0Hooo00<00?ooool0E?oo000Eool00`00ooooo`1<ool00`00ooooo`1Qool00`00ooooo`1E
ool001Goo`03003ooooo04goo`03003ooooo05ooo`03003ooooo05Koo`005Ooo00<00?ooool0C_oo
00<00?ooool0G_oo00<00?ooool0E_oo000Eool00`00ooooo`1?ool00`00ooooo`1Lool00`00oooo
o`1Gool001Goo`03003ooooo053oo`03003ooooo05[oo`03003ooooo05Soo`005Ooo0P00D_oo00<0
0?ooool0F?oo00<00?ooool0FOoo000Eool00`00ooooo`1Bool00`00ooooo`1Fool00`00ooooo`1J
ool001Goo`03003ooooo05?oo`03003ooooo05Coo`03003ooooo05_oo`005Ooo00<00?ooool0E?oo
00<00?ooool0D_oo00<00?ooool0G?oo000Eool00`00ooooo`1Eool00`00ooooo`1@ool00`00oooo
o`1Mool000goo`@000Coo`03003ooooo05Koo`03003ooooo04koo`03003ooooo05koo`003Ooo00<0
0?ooool01Ooo00<00?ooool0Eooo00<00?ooool0C?oo00<00?ooool0Gooo000>ool00`00ooooo`04
ool3001Hool00`00ooooo`19ool2001Rool000ooo`03003ooooo00?oo`03003ooooo05Woo`8004So
o`03003ooooo06;oo`004?oo00<00?ooool00_oo00<00?ooool0Fooo00<00?ooool0A?oo00<00?oo
ool0Hooo000=ool01000ooooo`001?oo00<00?ooool0G?oo00<00?ooool0@_oo00<00?ooool0I?oo
000>ool20005ool00`00ooooo`1Mool00`00ooooo`10ool00`00ooooo`1Uool001Goo`03003ooooo
05koo`03003ooooo03koo`03003ooooo06Koo`005Ooo00<00?ooool0Gooo0P00??oo0P00JOoo000E
ool00`00ooooo`1Qool00`00ooooo`0hool00`00ooooo`1Yool001Goo`8006?oo`8003Koo`8006co
o`005Ooo00<00?ooool0I?oo00<00?ooool0<Ooo0P00K_oo000Eool00`00ooooo`1Uool2000`ool0
0`00ooooo`1^ool001Goo`03003ooooo06Ooo`8002coo`80077oo`005Ooo00<00?ooool0JOoo0P00
:?oo0P00Looo000Eool00`00ooooo`1[ool3000Sool2001eool001Goo`03003ooooo06koo`8001ko
o`<007Ooo`005Ooo0P00LOoo0`006?oo0`00N_oo000Eool00`00ooooo`1cool4000Aool3001mool0
01Goo`03003ooooo07Oooa40083oo`005Ooo00<00?ooool0oooo2Ooo000Eool00`00ooooo`3oool9
ool001Goo`03003ooooo0?ooo`Woo`005Ooo00<00?ooool0oooo2Ooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.259483, -0.175865, \
0.0121242, 0.0139628}}]
}, Open  ]],

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp5", "=", 
        RowBox[{
          FractionBox["1", "3"], " ", "\[Pi]", " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", 
                      RowBox[{"1", ",", "0"}]], "]"}], "2"], " ", 
                SubsuperscriptBox["\[Beta]", 
                  RowBox[{"0", ",", "0"}], "2"]}], "+", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", 
                      RowBox[{"1", ",", "1"}]], "]"}], "2"], " ", 
                SubsuperscriptBox["\[Beta]", 
                  RowBox[{"0", ",", "1"}], "2"]}], "+", 
              RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                  RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Chi]"}]], " ", 
                RowBox[{"Conjugate", "[", 
                  SubscriptBox["\[Beta]", 
                    RowBox[{"1", ",", "1"}]], "]"}], " ", 
                SubscriptBox["\[Beta]", 
                  RowBox[{"0", ",", "0"}]], " ", 
                SubscriptBox["\[Beta]", 
                  RowBox[{"0", ",", "1"}]], " ", 
                SubscriptBox["\[Beta]", 
                  RowBox[{"1", ",", "0"}]]}], "+", 
              RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                  RowBox[{"\[ImaginaryI]", " ", "\[Chi]"}]], " ", 
                RowBox[{"Conjugate", "[", 
                  SubscriptBox["\[Beta]", 
                    RowBox[{"1", ",", "0"}]], "]"}], " ", 
                SubscriptBox["\[Beta]", 
                  RowBox[{"0", ",", "0"}]], " ", 
                SubscriptBox["\[Beta]", 
                  RowBox[{"0", ",", "1"}]], " ", 
                SubscriptBox["\[Beta]", 
                  RowBox[{"1", ",", "1"}]]}], "+", 
              RowBox[{"2", " ", 
                RowBox[{"(", 
                  RowBox[{
                    SubsuperscriptBox["\[Beta]", 
                      RowBox[{"1", ",", "0"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Cos", "[", "\[Chi]", "]"}], " ", 
                      SubsuperscriptBox["\[Beta]", 
                        RowBox[{"1", ",", "0"}], "2"], " ", 
                      SubsuperscriptBox["\[Beta]", 
                        RowBox[{"1", ",", "1"}], "2"]}], "+", 
                    SubsuperscriptBox["\[Beta]", 
                      RowBox[{"1", ",", "1"}], "4"]}], ")"}]}]}], ")"}]}]}], 
      ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp5", "=", 
        RowBox[{
          FractionBox["1", "3"], " ", "\[Pi]", " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", 
                      RowBox[{"1", ",", "0"}]], "]"}], "2"], " ", 
                SubsuperscriptBox["\[Beta]", 
                  RowBox[{"0", ",", "0"}], "2"]}], "+", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{"Abs", "[", 
                    SubscriptBox["\[Beta]", 
                      RowBox[{"1", ",", "1"}]], "]"}], "2"], " ", 
                SubsuperscriptBox["\[Beta]", 
                  RowBox[{"0", ",", "1"}], "2"]}], "+", 
              RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                  RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Chi]"}]], " ", 
                RowBox[{"Conjugate", "[", 
                  SubscriptBox["\[Beta]", 
                    RowBox[{"1", ",", "1"}]], "]"}], " ", 
                SubscriptBox["\[Beta]", 
                  RowBox[{"0", ",", "0"}]], " ", 
                SubscriptBox["\[Beta]", 
                  RowBox[{"0", ",", "1"}]], " ", 
                SubscriptBox["\[Beta]", 
                  RowBox[{"1", ",", "0"}]]}], "+", 
              RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                  RowBox[{"\[ImaginaryI]", " ", "\[Chi]"}]], " ", 
                RowBox[{"Conjugate", "[", 
                  SubscriptBox["\[Beta]", 
                    RowBox[{"1", ",", "0"}]], "]"}], " ", 
                SubscriptBox["\[Beta]", 
                  RowBox[{"0", ",", "0"}]], " ", 
                SubscriptBox["\[Beta]", 
                  RowBox[{"0", ",", "1"}]], " ", 
                SubscriptBox["\[Beta]", 
                  RowBox[{"1", ",", "1"}]]}], "+", 
              RowBox[{"2", " ", 
                RowBox[{"(", 
                  RowBox[{
                    SubsuperscriptBox["\[Beta]", 
                      RowBox[{"1", ",", "0"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Cos", "[", "\[Chi]", "]"}], " ", 
                      SubsuperscriptBox["\[Beta]", 
                        RowBox[{"1", ",", "0"}], "2"], " ", 
                      SubsuperscriptBox["\[Beta]", 
                        RowBox[{"1", ",", "1"}], "2"]}], "+", 
                    SubsuperscriptBox["\[Beta]", 
                      RowBox[{"1", ",", "1"}], "4"]}], ")"}]}]}], ")"}]}]}], 
      ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp5", "-", "tmp4"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", 
            RowBox[{"Join", "[", "facts1", "]"}]}], "]"}], "&"}]}]], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"tmp4", "/.", 
      RowBox[{"{", 
        RowBox[{
          RowBox[{
            SubscriptBox["\[Beta]", 
              RowBox[{"0", ",", "1"}]], "\[Rule]", "0"}], ",", 
          RowBox[{
            SubscriptBox["\[Beta]", 
              RowBox[{"1", ",", "0"}]], "\[Rule]", "0"}], ",", 
          RowBox[{
            SubscriptBox["\[Beta]", 
              RowBox[{"1", ",", "1"}]], "\[Rule]", 
            RowBox[{"1", "+", 
              RowBox[{"3", "I"}]}]}], ",", 
          RowBox[{"\[Chi]", "\[Rule]", "0"}]}], "}"}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"(", 
        RowBox[{
          FractionBox["56", "3"], "-", 
          RowBox[{"64", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      "\[Pi]"}]], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{
      FractionBox["1", "3"], " ", "\[Pi]", " ", 
      RowBox[{"(", 
        RowBox[{
          RowBox[{
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                SubscriptBox["\[Beta]", 
                  RowBox[{"1", ",", "1"}]], "]"}], "2"], " ", 
            SubsuperscriptBox["\[Beta]", 
              RowBox[{"0", ",", "1"}], "2"]}], "+", 
          RowBox[{"2", " ", 
            RowBox[{"(", 
              RowBox[{
                SubsuperscriptBox["\[Beta]", 
                  RowBox[{"1", ",", "0"}], "4"], "+", 
                RowBox[{"2", " ", 
                  RowBox[{"Cos", "[", "\[Chi]", "]"}], " ", 
                  SubsuperscriptBox["\[Beta]", 
                    RowBox[{"1", ",", "0"}], "2"], " ", 
                  SubsuperscriptBox["\[Beta]", 
                    RowBox[{"1", ",", "1"}], "2"]}], "+", 
                SubsuperscriptBox["\[Beta]", 
                  RowBox[{"1", ",", "1"}], "4"]}], ")"}]}]}], 
        ")"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"tmp5", "-", "tmp4"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["tmp5"], "Input"],

Cell[BoxData[
    RowBox[{
      FractionBox["1", "3"], " ", "\[Pi]", " ", 
      RowBox[{"(", 
        RowBox[{
          RowBox[{
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                SubscriptBox["\[Beta]", 
                  RowBox[{"1", ",", "0"}]], "]"}], "2"], " ", 
            SubsuperscriptBox["\[Beta]", 
              RowBox[{"0", ",", "0"}], "2"]}], "+", 
          RowBox[{
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                SubscriptBox["\[Beta]", 
                  RowBox[{"1", ",", "1"}]], "]"}], "2"], " ", 
            SubsuperscriptBox["\[Beta]", 
              RowBox[{"0", ",", "1"}], "2"]}], "+", 
          RowBox[{
            SuperscriptBox["\[ExponentialE]", 
              RowBox[{
                RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Chi]"}]], " ", 
            RowBox[{"Conjugate", "[", 
              SubscriptBox["\[Beta]", 
                RowBox[{"1", ",", "1"}]], "]"}], " ", 
            SubscriptBox["\[Beta]", 
              RowBox[{"0", ",", "0"}]], " ", 
            SubscriptBox["\[Beta]", 
              RowBox[{"0", ",", "1"}]], " ", 
            SubscriptBox["\[Beta]", 
              RowBox[{"1", ",", "0"}]]}], "+", 
          RowBox[{
            SuperscriptBox["\[ExponentialE]", 
              RowBox[{"\[ImaginaryI]", " ", "\[Chi]"}]], " ", 
            RowBox[{"Conjugate", "[", 
              SubscriptBox["\[Beta]", 
                RowBox[{"1", ",", "0"}]], "]"}], " ", 
            SubscriptBox["\[Beta]", 
              RowBox[{"0", ",", "0"}]], " ", 
            SubscriptBox["\[Beta]", 
              RowBox[{"0", ",", "1"}]], " ", 
            SubscriptBox["\[Beta]", 
              RowBox[{"1", ",", "1"}]]}], "+", 
          RowBox[{"2", " ", 
            RowBox[{"(", 
              RowBox[{
                SubsuperscriptBox["\[Beta]", 
                  RowBox[{"1", ",", "0"}], "4"], "+", 
                RowBox[{"2", " ", 
                  RowBox[{"Cos", "[", "\[Chi]", "]"}], " ", 
                  SubsuperscriptBox["\[Beta]", 
                    RowBox[{"1", ",", "0"}], "2"], " ", 
                  SubsuperscriptBox["\[Beta]", 
                    RowBox[{"1", ",", "1"}], "2"]}], "+", 
                SubsuperscriptBox["\[Beta]", 
                  RowBox[{"1", ",", "1"}], "4"]}], ")"}]}]}], 
        ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{
            RowBox[{"p", "(", 
              RowBox[{"M", "|", "\[Psi]"}], ")"}], "\[Congruent]", 
            "pM\[Psi]"}], ",", 
          RowBox[{
            SubsuperscriptBox["g", "M", "\[DoublePrime]"], "\[Congruent]", 
            "gMpp"}], ",", 
          RowBox[{
            SuperscriptBox[
              RowBox[{"\[LeftBracketingBar]", 
                SubsuperscriptBox["c", "1", "\[DoublePrime]"], 
                "\[RightBracketingBar]"}], "2"], "\[Congruent]", "c12pp"}], 
          ",", 
          RowBox[{"A", "\[Congruent]", "a"}]}], TraditionalForm]]],
  ":"
}], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"pM\[Psi]", "=", 
        SuperscriptBox[
          RowBox[{"Abs", "[", 
            RowBox[{
              SubsuperscriptBox["\[Sum]", 
                RowBox[{"j", "=", "0"}], "1"], 
              RowBox[{
                SqrtBox[
                  SubscriptBox["\[Alpha]p", 
                    RowBox[{"mp", ",", "j"}]]], 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SqrtBox[
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "0"}]]], 
                      SubscriptBox["\[Gamma]", 
                        RowBox[{"j", ",", "0"}]], 
                      RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
                    RowBox[{
                      SqrtBox[
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "1"}]]], 
                      SubscriptBox["\[Gamma]", 
                        RowBox[{"j", ",", "1"}]], 
                      RowBox[{"Exp", "[", 
                        RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}], "]"}], 
                      
                      RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ")"}]}]}], 
            "]"}], "2"]}], ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"General", "::", "\<\"spell1\"\>"}], 
      RowBox[{
      ":", " "}], "\<\"Possible spelling error: new symbol name \\\"\\!\\(\
\[Alpha]p\\)\\\" is similar to existing symbol \
\\\"\\!\\(\[Alpha]\\)\\\".\"\>"}]], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"a", "=", 
        SuperscriptBox[
          RowBox[{"Abs", "[", 
            RowBox[{
              SubsuperscriptBox["\[Sum]", 
                RowBox[{"j", "=", "0"}], "1"], 
              RowBox[{
                SqrtBox[
                  SubscriptBox["\[Alpha]p", 
                    RowBox[{"mp", ",", "j"}]]], 
                SubscriptBox["\[Beta]p", "j"], 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SqrtBox[
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "0"}]]], 
                      SubscriptBox["\[Gamma]", 
                        RowBox[{"j", ",", "0"}]], 
                      RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
                    RowBox[{
                      SqrtBox[
                        SubscriptBox["\[Alpha]", 
                          RowBox[{"m", ",", "1"}]]], 
                      SubscriptBox["\[Gamma]", 
                        RowBox[{"j", ",", "1"}]], 
                      RowBox[{"Exp", "[", 
                        RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}], "]"}], 
                      
                      RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ")"}]}]}], 
            "]"}], "2"]}], ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"General", "::", "\<\"spell\"\>"}], 
      RowBox[{
      ":", " "}], "\<\"Possible spelling error: new symbol name \\\"\\!\\(\
\[Beta]p\\)\\\" is similar to existing symbols \\!\\({\[Alpha]p, \[Beta]}\\).\
\"\>"}]], "Message"]
}, Open  ]],

Cell[BoxData[
    RowBox[{
      RowBox[{"c12pp", "=", 
        RowBox[{
          FractionBox["1", "pM\[Psi]"], 
          SuperscriptBox["a", "2"]}]}], ";"}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{"vMpp1", "\[Congruent]", 
          RowBox[{
            SubsuperscriptBox["\[Integral]", "0", 
              RowBox[{"\[Pi]", "/", "2"}]], 
            RowBox[{"d", " ", "\[Theta]", 
              RowBox[{
                SubsuperscriptBox["\[Integral]", "0", 
                  RowBox[{"2", "\[Pi]"}]], 
                RowBox[{"d", " ", "\[CurlyPhi]", " ", "integrand1"}]}]}]}]}], 
        TraditionalForm]]],
  ", where ",
  Cell[BoxData[
      FormBox[
        RowBox[{" ", 
          RowBox[{
            RowBox[{"integrand1", "\[Congruent]", 
              SubscriptBox["I", "1"]}], "=", 
            RowBox[{
              FractionBox["1", 
                RowBox[{"2", "\[Pi]"}]], 
              SuperscriptBox[
                SubsuperscriptBox["g", "m", "\[DoublePrime]"], "2"], 
              RowBox[{"sin", "(", 
                RowBox[{"2", "\[Theta]"}], ")"}], 
              RowBox[{"p", "(", 
                RowBox[{"M", "|", "\[Psi]"}], ")"}]}]}]}], 
        TraditionalForm]]],
  ":"
}], "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"integrand1", "=", 
        RowBox[{
          FractionBox["1", 
            RowBox[{"2", "\[Pi]"}]], 
          SuperscriptBox["gMpp", "2"], 
          RowBox[{"Sin", "[", 
            RowBox[{"2", "\[Theta]"}], "]"}], "pM\[Psi]"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp1substs", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "1"], "\[Rule]", 
              RowBox[{
                SuperscriptBox["gMpp", "2"], " ", 
                RowBox[{
                  RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "\[Theta]"}], "]"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"2", "\[Pi]"}], ")"}]}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "2"], "\[Rule]", 
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"0", ",", "0"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "3"], "\[Rule]", 
              RowBox[{
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"0", ",", "1"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "4"], "\[Rule]", 
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"1", ",", "0"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "5"], "\[Rule]", 
              RowBox[{
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"1", ",", "1"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "6"], "\[Rule]", 
              SqrtBox[
                SubscriptBox["\[Alpha]p", 
                  RowBox[{"mp", ",", "0"}]]]}], ",", 
            RowBox[{
              SubscriptBox["c", "7"], "\[Rule]", 
              SqrtBox[
                SubscriptBox["\[Alpha]p", 
                  RowBox[{"mp", ",", "1"}]]]}], ",", 
            RowBox[{
              SubscriptBox["c", "8"], "\[Rule]", 
              RowBox[{
                RowBox[{
                  SubscriptBox["c", "6"], 
                  SubscriptBox["c", "2"]}], "+", 
                RowBox[{
                  SubscriptBox["c", "7"], 
                  SubscriptBox["c", "4"]}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "9"], "\[Rule]", 
              RowBox[{
                RowBox[{
                  SubscriptBox["c", "6"], 
                  SubscriptBox["c", "3"]}], "+", 
                RowBox[{
                  SubscriptBox["c", "7"], 
                  SubscriptBox["c", "5"]}]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp1", "=", 
        RowBox[{
          SubscriptBox["c", "1"], 
          SuperscriptBox[
            RowBox[{"Abs", "[", 
              RowBox[{
                SubscriptBox["c", "8"], "+", 
                RowBox[{
                  SubscriptBox["c", "9"], 
                  SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], "]"}],
             "2"]}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"tmp1", "-", "integrand1"}], "//.", "tmp1substs"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp1", ",", 
            RowBox[{"{", 
              RowBox[{"\[CurlyPhi]", ",", "0", ",", 
                RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "//", 
        RowBox[{
          RowBox[{"FullSimplify", "[", 
            RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "//.", "tmp1substs"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "//", 
        RowBox[{
          RowBox[{"FullSimplify", "[", 
            RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp2", "=", "%"}], 
      RowBox[{"(*", 
        RowBox[{"QQQ", ":", 
          RowBox[{".", 
            RowBox[{"/", "substs1"}]}]}], "*)"}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"Integrate", "[", 
        RowBox[{"tmp2", ",", 
          RowBox[{"{", 
            RowBox[{"\[Theta]", ",", "0", ",", 
              RowBox[{"\[Pi]", "/", "2"}]}], "}"}]}], "]"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      FractionBox["1", "2"], " ", 
      SuperscriptBox["gMpp", "2"], " ", 
      RowBox[{"(", 
        RowBox[{
          RowBox[{
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                RowBox[{
                  RowBox[{
                    SqrtBox[
                      SubscriptBox["\[Alpha]p", 
                        RowBox[{"mp", ",", "0"}]]], " ", 
                    SubscriptBox["\[Gamma]", 
                      RowBox[{"0", ",", "0"}]]}], "+", 
                  RowBox[{
                    SqrtBox[
                      SubscriptBox["\[Alpha]p", 
                        RowBox[{"mp", ",", "1"}]]], " ", 
                    SubscriptBox["\[Gamma]", 
                      RowBox[{"1", ",", "0"}]]}]}], "]"}], "2"], " ", 
            SubscriptBox["\[Alpha]", 
              RowBox[{"m", ",", "0"}]]}], "+", 
          RowBox[{
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                RowBox[{
                  RowBox[{
                    SqrtBox[
                      SubscriptBox["\[Alpha]p", 
                        RowBox[{"mp", ",", "0"}]]], " ", 
                    SubscriptBox["\[Gamma]", 
                      RowBox[{"0", ",", "1"}]]}], "+", 
                  RowBox[{
                    SqrtBox[
                      SubscriptBox["\[Alpha]p", 
                        RowBox[{"mp", ",", "1"}]]], " ", 
                    SubscriptBox["\[Gamma]", 
                      RowBox[{"1", ",", "1"}]]}]}], "]"}], "2"], " ", 
            SubscriptBox["\[Alpha]", 
              RowBox[{"m", ",", "1"}]]}]}], ")"}]}]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{"vMpp2", "\[Congruent]", 
          RowBox[{
            SubsuperscriptBox["\[Integral]", "0", 
              RowBox[{"\[Pi]", "/", "2"}]], 
            RowBox[{"d", " ", "\[Theta]", 
              RowBox[{
                SubsuperscriptBox["\[Integral]", "0", 
                  RowBox[{"2", "\[Pi]"}]], 
                RowBox[{"d", " ", "\[CurlyPhi]", " ", "integrand2"}]}]}]}]}], 
        TraditionalForm]]],
  ", where ",
  Cell[BoxData[
      FormBox[
        RowBox[{" ", 
          RowBox[{
            RowBox[{"integrand2", "\[Congruent]", 
              SubscriptBox["I", "2"]}], "=", 
            RowBox[{
              RowBox[{"-", 
                FractionBox["1", "\[Pi]"]}], 
              SubsuperscriptBox["g", "m", "\[DoublePrime]"], 
              RowBox[{"sin", "(", 
                RowBox[{"2", "\[Theta]"}], ")"}], 
              SubscriptBox["C", "a"]}]}]}], TraditionalForm]]],
  ":"
}], "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"integrand2", "=", 
        RowBox[{
          RowBox[{"-", 
            FractionBox["1", "\[Pi]"]}], "gMpp", " ", 
          RowBox[{"Sin", "[", 
            RowBox[{"2", "\[Theta]"}], "]"}], "a"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp1substs", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "1"], "\[Rule]", 
              RowBox[{"gMpp", " ", 
                RowBox[{
                  RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "\[Theta]"}], "]"}], "/", "\[Pi]"}]}]}],
             ",", 
            RowBox[{
              SubscriptBox["c", "2"], "\[Rule]", 
              RowBox[{
                SubscriptBox["\[Beta]p", "0"], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]p", 
                    RowBox[{"mp", ",", "0"}]]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "3"], "\[Rule]", 
              RowBox[{
                SubscriptBox["\[Beta]p", "1"], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]p", 
                    RowBox[{"mp", ",", "1"}]]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "4"], "\[Rule]", 
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"0", ",", "0"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "5"], "\[Rule]", 
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"1", ",", "0"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "6"], "\[Rule]", 
              RowBox[{
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"0", ",", "1"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "7"], "\[Rule]", " ", 
              RowBox[{
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"1", ",", "1"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "8"], "\[Rule]", 
              RowBox[{
                RowBox[{
                  SubscriptBox["c", "2"], 
                  SubscriptBox["c", "4"]}], "+", 
                RowBox[{
                  SubscriptBox["c", "3"], 
                  SubscriptBox["c", "5"]}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "9"], "\[Rule]", 
              RowBox[{
                RowBox[{
                  SubscriptBox["c", "2"], 
                  SubscriptBox["c", "6"]}], "+", 
                RowBox[{
                  SubscriptBox["c", "3"], 
                  SubscriptBox["c", "7"]}]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp1", "=", 
        RowBox[{
          RowBox[{"-", 
            SubscriptBox["c", "1"]}], 
          SuperscriptBox[
            RowBox[{"Abs", "[", 
              RowBox[{
                SubscriptBox["c", "8"], "+", 
                RowBox[{
                  SubscriptBox["c", "9"], 
                  SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], "]"}],
             "2"]}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"tmp1", "-", "integrand2"}], "//.", "tmp1substs"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"Integrate", "[", 
          RowBox[{"tmp1", ",", 
            RowBox[{"{", 
              RowBox[{"\[CurlyPhi]", ",", "0", ",", 
                RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "//", 
        RowBox[{
          RowBox[{"FullSimplify", "[", 
            RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "//.", "tmp1substs"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "//", 
        RowBox[{
          RowBox[{"FullSimplify", "[", 
            RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp2", "=", "%"}], 
      RowBox[{"(*", 
        RowBox[{"QQQ", ":", 
          RowBox[{".", 
            RowBox[{"/", "substs1"}]}]}], "*)"}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData["tmp2"], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"-", "2"}], " ", "gMpp", " ", 
      RowBox[{"Sin", "[", 
        RowBox[{"2", " ", "\[Theta]"}], "]"}], " ", 
      RowBox[{"(", 
        RowBox[{
          RowBox[{
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                RowBox[{
                  RowBox[{
                    SubscriptBox["\[Beta]p", "0"], " ", 
                    SqrtBox[
                      SubscriptBox["\[Alpha]p", 
                        RowBox[{"mp", ",", "0"}]]], " ", 
                    SubscriptBox["\[Gamma]", 
                      RowBox[{"0", ",", "0"}]]}], "+", 
                  RowBox[{
                    SubscriptBox["\[Beta]p", "1"], " ", 
                    SqrtBox[
                      SubscriptBox["\[Alpha]p", 
                        RowBox[{"mp", ",", "1"}]]], " ", 
                    SubscriptBox["\[Gamma]", 
                      RowBox[{"1", ",", "0"}]]}]}], "]"}], "2"], " ", 
            SuperscriptBox[
              RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], " ", 
            SubscriptBox["\[Alpha]", 
              RowBox[{"m", ",", "0"}]]}], "+", 
          RowBox[{
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                RowBox[{
                  RowBox[{
                    SubscriptBox["\[Beta]p", "0"], " ", 
                    SqrtBox[
                      SubscriptBox["\[Alpha]p", 
                        RowBox[{"mp", ",", "0"}]]], " ", 
                    SubscriptBox["\[Gamma]", 
                      RowBox[{"0", ",", "1"}]]}], "+", 
                  RowBox[{
                    SubscriptBox["\[Beta]p", "1"], " ", 
                    SqrtBox[
                      SubscriptBox["\[Alpha]p", 
                        RowBox[{"mp", ",", "1"}]]], " ", 
                    SubscriptBox["\[Gamma]", 
                      RowBox[{"1", ",", "1"}]]}]}], "]"}], "2"], " ", 
            SuperscriptBox[
              RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], " ", 
            SubscriptBox["\[Alpha]", 
              RowBox[{"m", ",", "1"}]]}]}], ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Integrate", "[", 
      RowBox[{"tmp2", ",", 
        RowBox[{"{", 
          RowBox[{"\[Theta]", ",", "0", ",", 
            RowBox[{"\[Pi]", "/", "2"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"-", "2"}], " ", "gMpp", " ", 
      RowBox[{"(", 
        RowBox[{
          RowBox[{
            FractionBox["1", "2"], " ", 
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                RowBox[{
                  RowBox[{
                    SubscriptBox["\[Beta]p", "0"], " ", 
                    SqrtBox[
                      SubscriptBox["\[Alpha]p", 
                        RowBox[{"mp", ",", "0"}]]], " ", 
                    SubscriptBox["\[Gamma]", 
                      RowBox[{"0", ",", "0"}]]}], "+", 
                  RowBox[{
                    SubscriptBox["\[Beta]p", "1"], " ", 
                    SqrtBox[
                      SubscriptBox["\[Alpha]p", 
                        RowBox[{"mp", ",", "1"}]]], " ", 
                    SubscriptBox["\[Gamma]", 
                      RowBox[{"1", ",", "0"}]]}]}], "]"}], "2"], " ", 
            SubscriptBox["\[Alpha]", 
              RowBox[{"m", ",", "0"}]]}], "+", 
          RowBox[{
            FractionBox["1", "2"], " ", 
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                RowBox[{
                  RowBox[{
                    SubscriptBox["\[Beta]p", "0"], " ", 
                    SqrtBox[
                      SubscriptBox["\[Alpha]p", 
                        RowBox[{"mp", ",", "0"}]]], " ", 
                    SubscriptBox["\[Gamma]", 
                      RowBox[{"0", ",", "1"}]]}], "+", 
                  RowBox[{
                    SubscriptBox["\[Beta]p", "1"], " ", 
                    SqrtBox[
                      SubscriptBox["\[Alpha]p", 
                        RowBox[{"mp", ",", "1"}]]], " ", 
                    SubscriptBox["\[Gamma]", 
                      RowBox[{"1", ",", "1"}]]}]}], "]"}], "2"], " ", 
            SubscriptBox["\[Alpha]", 
              RowBox[{"m", ",", "1"}]]}]}], ")"}]}]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{"vMpp3", "\[Congruent]", 
          RowBox[{
            SubsuperscriptBox["\[Integral]", "0", 
              RowBox[{"\[Pi]", "/", "2"}]], 
            RowBox[{"d", " ", "\[Theta]", 
              RowBox[{
                SubsuperscriptBox["\[Integral]", "0", 
                  RowBox[{"2", "\[Pi]"}]], 
                RowBox[{"d", " ", "\[CurlyPhi]", " ", "integrand3"}]}]}]}]}], 
        TraditionalForm]]],
  ", where ",
  Cell[BoxData[
      FormBox[
        RowBox[{" ", 
          RowBox[{
            RowBox[{"integrand3", "\[Congruent]", 
              SubscriptBox["I", "3"]}], "=", 
            RowBox[{
              FractionBox["1", 
                RowBox[{"2", "\[Pi]"}]], 
              RowBox[{"sin", "(", 
                RowBox[{"2", "\[Theta]"}], ")"}], 
              RowBox[{
                SuperscriptBox[
                  RowBox[{
                  "\[LeftBracketingBar]", "A", "\[RightBracketingBar]"}], 
                  "4"], "/", 
                RowBox[{"p", "(", 
                  RowBox[{"M", "|", "\[Psi]"}], ")"}]}]}]}]}], 
        TraditionalForm]]],
  ":"
}], "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"integrand3", "=", 
        RowBox[{
          FractionBox["1", 
            RowBox[{"2", "\[Pi]"}]], 
          RowBox[{"Sin", "[", 
            RowBox[{"2", "\[Theta]"}], "]"}], 
          FractionBox["1", "pM\[Psi]"], 
          SuperscriptBox["a", "2"]}]}], " ", ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp1substs", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "1"], "\[Rule]", " ", 
              RowBox[{
                RowBox[{"Sin", "[", 
                  RowBox[{"2", " ", "\[Theta]"}], "]"}], "/", 
                RowBox[{"(", 
                  RowBox[{"2", "\[Pi]"}], ")"}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "2"], "\[Rule]", 
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"0", ",", "0"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "3"], "\[Rule]", 
              RowBox[{
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"0", ",", "1"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "4"], "\[Rule]", 
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"1", ",", "0"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "5"], "\[Rule]", 
              RowBox[{
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"1", ",", "1"}]]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "6"], "\[Rule]", " ", 
              SqrtBox[
                SubscriptBox["\[Alpha]p", 
                  RowBox[{"mp", ",", "0"}]]]}], ",", 
            RowBox[{
              SubscriptBox["c", "7"], "\[Rule]", 
              SqrtBox[
                SubscriptBox["\[Alpha]p", 
                  RowBox[{"mp", ",", "1"}]]]}], ",", 
            RowBox[{
              SubscriptBox["c", "8"], "\[Rule]", 
              RowBox[{
                RowBox[{
                  SubscriptBox["\[Beta]p", "0"], 
                  SubscriptBox["c", "6"], 
                  SubscriptBox["c", "2"]}], "+", 
                RowBox[{
                  SubscriptBox["\[Beta]p", "1"], " ", 
                  SubscriptBox["c", "7"], 
                  SubscriptBox["c", "4"]}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "9"], "\[Rule]", 
              RowBox[{
                RowBox[{
                  SubscriptBox["\[Beta]p", "0"], 
                  SubscriptBox["c", "6"], 
                  SubscriptBox["c", "3"]}], "+", 
                RowBox[{
                  SubscriptBox["\[Beta]p", "1"], " ", 
                  SubscriptBox["c", "7"], 
                  SubscriptBox["c", "5"]}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "10"], "\[Rule]", 
              RowBox[{
                RowBox[{
                  SubscriptBox["c", "6"], 
                  SubscriptBox["c", "2"]}], "+", 
                RowBox[{
                  SubscriptBox["c", "7"], 
                  SubscriptBox["c", "4"]}]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "11"], "\[Rule]", 
              RowBox[{
                RowBox[{
                  SubscriptBox["c", "6"], 
                  SubscriptBox["c", "3"]}], "+", 
                RowBox[{
                  SubscriptBox["c", "7"], 
                  SubscriptBox["c", "5"]}]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp1", "=", 
        RowBox[{
          SubscriptBox["c", "1"], 
          FractionBox[
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                RowBox[{
                  SubscriptBox["c", "8"], "+", 
                  RowBox[{
                    SubscriptBox["c", "9"], 
                    SuperscriptBox["\[ExponentialE]", 
                      RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], 
                "]"}], "4"], 
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                RowBox[{
                  SubscriptBox["c", "10"], "+", 
                  RowBox[{
                    SubscriptBox["c", "11"], 
                    SuperscriptBox["\[ExponentialE]", 
                      RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], 
                "]"}], "2"]]}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"tmp1", "-", "integrand3"}], "//.", "tmp1substs"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmp2substs", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "12"], "\[Rule]", 
              RowBox[{
                SubscriptBox["c", "9"], "/", 
                SubscriptBox["c", "8"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "13"], "\[Rule]", 
              RowBox[{
                SubscriptBox["c", "10"], "/", 
                SuperscriptBox[
                  SubscriptBox["c", "8"], "2"]}]}], ",", 
            RowBox[{
              SubscriptBox["c", "14"], "\[Rule]", 
              RowBox[{
                SubscriptBox["c", "11"], "/", 
                SuperscriptBox[
                  SubscriptBox["c", "8"], "2"]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmp2", "=", 
        RowBox[{
          SubscriptBox["c", "1"], 
          FractionBox[
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                RowBox[{"1", "+", 
                  RowBox[{
                    SubscriptBox["c", "12"], 
                    SuperscriptBox["\[ExponentialE]", 
                      RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], 
                "]"}], "4"], 
            SuperscriptBox[
              RowBox[{"Abs", "[", 
                RowBox[{
                  SubscriptBox["c", "13"], "+", 
                  RowBox[{
                    SubscriptBox["c", "14"], 
                    SuperscriptBox["\[ExponentialE]", 
                      RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], 
                "]"}], "2"]]}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"tmp1", "-", "tmp2"}], "//.", "tmp2substs"}], "//", 
      "FullSimplify"}]}], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{"Integrate", "[", 
      RowBox[{"tmp2", ",", 
        RowBox[{"{", 
          RowBox[{"\[CurlyPhi]", ",", "0", ",", 
            RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
    RowBox[{"%", "//", 
      RowBox[{"FullSimplify", "&"}]}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "//.", "tmp2substs"}], "//", 
      "FullSimplify"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"%", "//.", "tmp1substs"}], "//", 
      RowBox[{
        RowBox[{"FullSimplify", "[", 
          RowBox[{"#", ",", "facts1"}], "]"}], "&"}]}], "\[IndentingNewLine]",
   
    RowBox[{
      RowBox[{"tmp3", "=", "%"}], 
      RowBox[{"(*", 
        RowBox[{"QQQ", ":", 
          RowBox[{".", 
            RowBox[{"/", "substs1"}]}]}], "*)"}], ";"}]}], "Input"],

Cell[BoxData["$Aborted"], "Output"],

Cell[BoxData["FullSimplify"], "Output"],

Cell[BoxData["FullSimplify"], "Output"],

Cell[BoxData["FullSimplify"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Integrate", "[", 
      RowBox[{
        FractionBox[
          SuperscriptBox[
            RowBox[{"Abs", "[", 
              RowBox[{"1", "+", 
                RowBox[{"b", " ", 
                  RowBox[{"Exp", "[", 
                    RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}]}], "]"}], "4"],
           
          SuperscriptBox[
            RowBox[{"Abs", "[", 
              RowBox[{"c", "+", 
                RowBox[{"d", " ", 
                  RowBox[{"Exp", "[", 
                    RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}]}], "]"}], 
            "2"]], ",", 
        RowBox[{"{", 
          RowBox[{"\[CurlyPhi]", ",", "0", ",", 
            RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData["$Aborted"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      SuperscriptBox[
        RowBox[{"Abs", "[", 
          FractionBox[
            RowBox[{"1", "+", 
              RowBox[{"b", " ", 
                RowBox[{"Exp", "[", 
                  RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}], "+", 
              RowBox[{"c", " ", 
                RowBox[{"Exp", "[", 
                  RowBox[{"2", "I", " ", "\[CurlyPhi]"}], "]"}]}]}], 
            RowBox[{"d", "+", 
              RowBox[{"e", " ", 
                RowBox[{"Exp", "[", 
                  RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}]}]], "]"}], "2"], 
      "//", "FullSimplify"}]], "Input"],

Cell[BoxData[
    SuperscriptBox[
      RowBox[{"Abs", "[", 
        FractionBox[
          RowBox[{"1", "+", 
            RowBox[{"b", " ", 
              SuperscriptBox["\[ExponentialE]", 
                RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}], "+", 
            RowBox[{"c", " ", 
              SuperscriptBox["\[ExponentialE]", 
                RowBox[{"2", " ", "\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], 
          
          RowBox[{"d", "+", 
            RowBox[{"e", " ", 
              SuperscriptBox["\[ExponentialE]", 
                RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}]], "]"}], 
      "2"]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"ComplexExpand", "[", 
      SuperscriptBox[
        RowBox[{"Abs", "[", 
          FractionBox[
            RowBox[{"1", "+", 
              RowBox[{"b", " ", 
                RowBox[{"Exp", "[", 
                  RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}], "+", 
              RowBox[{"c", " ", 
                RowBox[{"Exp", "[", 
                  RowBox[{"2", "I", " ", "\[CurlyPhi]"}], "]"}]}]}], 
            RowBox[{"d", "+", 
              RowBox[{"e", " ", 
                RowBox[{"Exp", "[", 
                  RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}]}]], "]"}], "2"], 
      "]"}]], "Input"],

Cell[BoxData[
    FractionBox[
      SuperscriptBox[
        RowBox[{"Abs", "[", 
          RowBox[{"1", "+", 
            RowBox[{"b", " ", 
              SuperscriptBox["\[ExponentialE]", 
                RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}], "+", 
            RowBox[{"c", " ", 
              SuperscriptBox["\[ExponentialE]", 
                RowBox[{"2", " ", "\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], 
          "]"}], "2"], 
      SuperscriptBox[
        RowBox[{"Abs", "[", 
          RowBox[{"d", "+", 
            RowBox[{"e", " ", 
              SuperscriptBox["\[ExponentialE]", 
                RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], "]"}], 
        "2"]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        SuperscriptBox[
          RowBox[{"Abs", "[", 
            RowBox[{"c", "+", 
              RowBox[{"d", " ", 
                RowBox[{"Exp", "[", 
                  RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}]}], "]"}], "2"], 
        "-", 
        RowBox[{"(", 
          RowBox[{
            SuperscriptBox[
              RowBox[{"Abs", "[", "c", "]"}], "2"], "+", 
            RowBox[{"2", 
              RowBox[{"Re", "[", 
                RowBox[{"c", " ", "d", " ", 
                  RowBox[{"Exp", "[", 
                    RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}], "]"}]}], "+", 
            
            SuperscriptBox[
              RowBox[{"Abs", "[", "d", "]"}], "2"]}], ")"}]}], "//", 
      "FullSimplify"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"-", 
        SuperscriptBox[
          RowBox[{"Abs", "[", "c", "]"}], "2"]}], "-", 
      SuperscriptBox[
        RowBox[{"Abs", "[", "d", "]"}], "2"], "+", 
      SuperscriptBox[
        RowBox[{"Abs", "[", 
          RowBox[{"c", "+", 
            RowBox[{"d", " ", 
              SuperscriptBox["\[ExponentialE]", 
                RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], "]"}], 
        "2"], "-", 
      RowBox[{"2", " ", 
        RowBox[{"Re", "[", 
          RowBox[{"c", " ", "d", " ", 
            SuperscriptBox["\[ExponentialE]", 
              RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}], 
          "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Integrate", "[", 
      RowBox[{
        SuperscriptBox[
          RowBox[{"Abs", "[", 
            FractionBox[
              RowBox[{"1", "+", 
                RowBox[{"b", " ", 
                  RowBox[{"Exp", "[", 
                    RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}], "+", 
                RowBox[{"c", " ", 
                  RowBox[{"Exp", "[", 
                    RowBox[{"2", "I", " ", "\[CurlyPhi]"}], "]"}]}]}], 
              RowBox[{"d", "+", 
                RowBox[{"e", " ", 
                  RowBox[{"Exp", "[", 
                    RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}]}]], "]"}], 
          "2"], ",", 
        RowBox[{"{", 
          RowBox[{"\[CurlyPhi]", ",", "0", ",", 
            RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData["$Aborted"], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{"Integrate", "[", 
      RowBox[{
        FractionBox["b", 
          SuperscriptBox[
            RowBox[{"Abs", "[", 
              RowBox[{"c", "+", 
                RowBox[{"d", " ", 
                  RowBox[{"Exp", "[", 
                    RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}]}], "]"}], 
            "2"]], ",", 
        RowBox[{"{", 
          RowBox[{"\[CurlyPhi]", ",", "0", ",", 
            RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
    RowBox[{" ", "."}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{
          FractionBox[
            RowBox[{"\[Pi]", " ", 
              RowBox[{"Conjugate", "[", 
                SubscriptBox["c", "16"], "]"}], " ", 
              SubsuperscriptBox["c", "15", "2"]}], 
            RowBox[{"Conjugate", "[", 
              SubscriptBox["c", "17"], "]"}]], "+", 
          FractionBox[
            RowBox[{"\[Pi]", " ", 
              SuperscriptBox[
                RowBox[{"Abs", "[", 
                  SubscriptBox["c", "15"], "]"}], "2"], " ", 
              SubscriptBox["c", "16"]}], 
            SubscriptBox["c", "17"]]}], "/.", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SubscriptBox["c", "15"], "\[Rule]", "1"}], ",", 
            RowBox[{
              SubscriptBox["c", "17"], "\[Rule]", " ", "\[ImaginaryI]"}]}], 
          "}"}]}], "//", "FullSimplify"}]], "Input"],

Cell[BoxData[
    RowBox[{"2", " ", "\[ImaginaryI]", " ", "\[Pi]", " ", 
      RowBox[{"(", 
        RowBox[{
          RowBox[{"Re", "[", 
            SubscriptBox["c", "16"], "]"}], "-", 
          SubscriptBox["c", "16"]}], ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Integrate", "[", 
      RowBox[{"tmp2", ",", 
        RowBox[{"{", 
          RowBox[{"\[Theta]", ",", "0", ",", 
            RowBox[{"\[Pi]", "/", "2"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"(", 
        RowBox[{
          RowBox[{
            RowBox[{"Conjugate", "[", 
              RowBox[{
                RowBox[{
                  SubscriptBox["\[Beta]p", "0"], " ", 
                  SqrtBox[
                    SubscriptBox["\[Alpha]p", 
                      RowBox[{"mp", ",", "0"}]]], " ", 
                  SubscriptBox["\[Gamma]", 
                    RowBox[{"0", ",", "1"}]]}], "+", 
                RowBox[{
                  SubscriptBox["\[Beta]p", "1"], " ", 
                  SqrtBox[
                    SubscriptBox["\[Alpha]p", 
                      RowBox[{"mp", ",", "1"}]]], " ", 
                  SubscriptBox["\[Gamma]", 
                    RowBox[{"1", ",", "1"}]]}]}], "]"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{
                  SqrtBox[
                    RowBox[{
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "1"}]], " ", 
                      SubscriptBox["\[Alpha]p", 
                        RowBox[{"mp", ",", "0"}]]}]], " ", 
                  SubscriptBox["\[Gamma]", 
                    RowBox[{"0", ",", "1"}]]}], "+", 
                RowBox[{
                  SqrtBox[
                    RowBox[{
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "1"}]], " ", 
                      SubscriptBox["\[Alpha]p", 
                        RowBox[{"mp", ",", "1"}]]}]], " ", 
                  SubscriptBox["\[Gamma]", 
                    RowBox[{"1", ",", "1"}]]}]}], ")"}]}], "+", 
          RowBox[{
            RowBox[{"Conjugate", "[", 
              RowBox[{
                RowBox[{
                  SqrtBox[
                    SubscriptBox["\[Alpha]p", 
                      RowBox[{"mp", ",", "0"}]]], " ", 
                  SubscriptBox["\[Gamma]", 
                    RowBox[{"0", ",", "1"}]]}], "+", 
                RowBox[{
                  SqrtBox[
                    SubscriptBox["\[Alpha]p", 
                      RowBox[{"mp", ",", "1"}]]], " ", 
                  SubscriptBox["\[Gamma]", 
                    RowBox[{"1", ",", "1"}]]}]}], "]"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{
                  SubscriptBox["\[Beta]p", "0"], " ", 
                  SqrtBox[
                    RowBox[{
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "1"}]], " ", 
                      SubscriptBox["\[Alpha]p", 
                        RowBox[{"mp", ",", "0"}]]}]], " ", 
                  SubscriptBox["\[Gamma]", 
                    RowBox[{"0", ",", "1"}]]}], "+", 
                RowBox[{
                  SubscriptBox["\[Beta]p", "1"], " ", 
                  SqrtBox[
                    RowBox[{
                      SubscriptBox["\[Alpha]", 
                        RowBox[{"m", ",", "1"}]], " ", 
                      SubscriptBox["\[Alpha]p", 
                        RowBox[{"mp", ",", "1"}]]}]], " ", 
                  SubscriptBox["\[Gamma]", 
                    RowBox[{"1", ",", "1"}]]}]}], ")"}]}]}], ")"}], "/", 
      RowBox[{"(", 
        RowBox[{"16", " ", 
          RowBox[{"Conjugate", "[", 
            RowBox[{
              RowBox[{
                SqrtBox[
                  SubscriptBox["\[Alpha]p", 
                    RowBox[{"mp", ",", "0"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"0", ",", "1"}]]}], "+", 
              RowBox[{
                SqrtBox[
                  SubscriptBox["\[Alpha]p", 
                    RowBox[{"mp", ",", "1"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"1", ",", "1"}]]}]}], "]"}], " ", 
          SqrtBox[
            SubscriptBox["\[Alpha]", 
              RowBox[{"m", ",", "1"}]]], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SqrtBox[
                  SubscriptBox["\[Alpha]p", 
                    RowBox[{"mp", ",", "0"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"0", ",", "1"}]]}], "+", 
              RowBox[{
                SqrtBox[
                  SubscriptBox["\[Alpha]p", 
                    RowBox[{"mp", ",", "1"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"1", ",", "1"}]]}]}], ")"}]}], ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Integrate", "[", 
      RowBox[{
        SuperscriptBox[
          RowBox[{"Abs", "[", 
            FractionBox[
              RowBox[{
                SubscriptBox["c", "13"], "+", 
                RowBox[{
                  SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
                  SubscriptBox["c", "14"]}]}], 
              RowBox[{
                SubscriptBox["c", "11"], "+", 
                RowBox[{
                  SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
                  SubscriptBox["c", "12"]}]}]], "]"}], "2"], ",", 
        RowBox[{"{", 
          RowBox[{"\[CurlyPhi]", ",", "0", ",", 
            RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
    RowBox[{
      SubsuperscriptBox["\[Integral]", "0", 
        RowBox[{"2", " ", "\[Pi]"}]], 
      RowBox[{
        SuperscriptBox[
          RowBox[{"Abs", "[", 
            FractionBox[
              RowBox[{
                SubscriptBox["c", "13"], "+", 
                RowBox[{
                  SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
                  SubscriptBox["c", "14"]}]}], 
              RowBox[{
                SubscriptBox["c", "11"], "+", 
                RowBox[{
                  SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
                  SubscriptBox["c", "12"]}]}]], "]"}], "2"], 
        RowBox[{"\[DifferentialD]", "\[CurlyPhi]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Integrate", "[", 
      RowBox[{
        SuperscriptBox[
          RowBox[{"Abs", "[", 
            FractionBox[
              RowBox[{"b", "+", 
                RowBox[{"c", " ", 
                  RowBox[{"Exp", "[", 
                    RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}]}], 
              RowBox[{"1", "+", 
                RowBox[{"d", " ", 
                  RowBox[{"Exp", "[", 
                    RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}]}]], "]"}], 
          "2"], ",", 
        RowBox[{"{", 
          RowBox[{"\[CurlyPhi]", ",", "0", ",", 
            RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"-", 
        RowBox[{
          RowBox[{"(", 
            RowBox[{
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                SuperscriptBox[
                  RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}]}], "-", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "b", "]"}]}], "+", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "b", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}]}], "+", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "c", "]"}]}], "+", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}]}], "-", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "d", "]"}]}], "-", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}]}], "-", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}]}], "+", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                SuperscriptBox[
                  RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                SuperscriptBox[
                  RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "3"]}], "-", 
              RowBox[{"2", " ", 
                RowBox[{"ArcTanh", "[", 
                  FractionBox[
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}]}], 
                    SqrtBox[
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ",
                 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "3"]}], "-", 
              RowBox[{
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{"1", "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "]"}], " ", 
                SqrtBox[
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "-", 
              RowBox[{
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{"1", "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SqrtBox[
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "+", 
              RowBox[{
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{"1", "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                SqrtBox[
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "-", 
              RowBox[{
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{"1", "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                SqrtBox[
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"]}]]}]}], ")"}], "/", 
          
          RowBox[{"(", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"Im", "[", "d", "]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"Im", "[", "d", "]"}], "+", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], ")"}]}]}], "+", 
      
      RowBox[{
        RowBox[{"(", 
          RowBox[{
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}]}], "-", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "b", "]"}]}], "+", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "b", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}]}], "+", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "c", "]"}]}], "+", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "c", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}]}], "-", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "d", "]"}]}], "-", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}]}], "-", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}]}], "+", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "3"]}], "-", 
            RowBox[{"2", " ", 
              RowBox[{"ArcTanh", "[", 
                FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}]}], 
                  SqrtBox[
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}]]], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "3"]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{"1", "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "-", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{"1", "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "+", 
            RowBox[{
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{"1", "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{"1", "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}]}], ")"}], "/", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "d", "]"}], "-", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "d", "]"}], "+", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
            SqrtBox[
              RowBox[{
                RowBox[{"-", "1"}], "+", 
                RowBox[{"2", " ", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                RowBox[{"2", " ", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                RowBox[{"2", " ", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], ")"}]}], "-", 
      RowBox[{
        RowBox[{"(", 
          RowBox[{
            RowBox[{
              RowBox[{"-", 
                RowBox[{"Im", "[", "b", "]"}]}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{"1", "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "-", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "+", 
            RowBox[{"\[Pi]", " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "-", 
            RowBox[{"\[Pi]", " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{"1", "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "-", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "+", 
            RowBox[{"\[Pi]", " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "+", 
            RowBox[{
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{"1", "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "-", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{"1", "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "-", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "+", 
            RowBox[{"\[Pi]", " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "+", 
            FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SqrtBox[
                  FractionBox[
                    SuperscriptBox[
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "\[ImaginaryI]"}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                            RowBox[{"Re", "[", "d", "]"}]}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}], 
                      "2"], 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], " ",
                 
                SqrtBox[
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]], "+", 
            FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SqrtBox[
                  FractionBox[
                    SuperscriptBox[
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "\[ImaginaryI]"}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                            RowBox[{"Re", "[", "d", "]"}]}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}], 
                      "2"], 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], " ",
                 
                SqrtBox[
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]], "-", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "c", "]"}], " ", 
                  RowBox[{"Im", "[", "d", "]"}], " ", 
                  RowBox[{"Re", "[", "b", "]"}], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "-", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "c", "]"}], " ", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                  RowBox[{"Re", "[", "b", "]"}], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "+", 
            FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
                SqrtBox[
                  FractionBox[
                    SuperscriptBox[
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "\[ImaginaryI]"}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                            RowBox[{"Re", "[", "d", "]"}]}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}], 
                      "2"], 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], " ",
                 
                SqrtBox[
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]], "+", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "b", "]"}], " ", 
                  RowBox[{"Im", "[", "d", "]"}], " ", 
                  RowBox[{"Re", "[", "c", "]"}], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "+", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "b", "]"}], " ", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                  RowBox[{"Re", "[", "c", "]"}], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "+", 
            FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
                SqrtBox[
                  FractionBox[
                    SuperscriptBox[
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "\[ImaginaryI]"}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                            RowBox[{"Re", "[", "d", "]"}]}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}], 
                      "2"], 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], " ",
                 
                SqrtBox[
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]], "-", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "b", "]"}], " ", 
                  RowBox[{"Im", "[", "c", "]"}], " ", 
                  RowBox[{"Re", "[", "d", "]"}], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "-", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "b", "]"}], " ", 
                  RowBox[{"Im", "[", "c", "]"}], " ", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                  RowBox[{"Re", "[", "d", "]"}], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "-", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Re", "[", "b", "]"}], " ", 
                  RowBox[{"Re", "[", "c", "]"}], " ", 
                  RowBox[{"Re", "[", "d", "]"}], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "-", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                  RowBox[{"Re", "[", "b", "]"}], " ", 
                  RowBox[{"Re", "[", "c", "]"}], " ", 
                  RowBox[{"Re", "[", "d", "]"}], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "+", 
            FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SqrtBox[
                  FractionBox[
                    SuperscriptBox[
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "\[ImaginaryI]"}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                            RowBox[{"Re", "[", "d", "]"}]}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}], 
                      "2"], 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], " ",
                 
                SqrtBox[
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]], "+", 
            FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SqrtBox[
                  FractionBox[
                    SuperscriptBox[
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "\[ImaginaryI]"}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                            RowBox[{"Re", "[", "d", "]"}]}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}], 
                      "2"], 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], " ",
                 
                SqrtBox[
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]], "-", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "c", "]"}], " ", 
                  RowBox[{"Im", "[", "d", "]"}], " ", 
                  RowBox[{"Re", "[", "b", "]"}], " ", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "+", 
            FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SqrtBox[
                  FractionBox[
                    SuperscriptBox[
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "\[ImaginaryI]"}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                            RowBox[{"Re", "[", "d", "]"}]}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}], 
                      "2"], 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], " ",
                 
                SqrtBox[
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]], "+", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "b", "]"}], " ", 
                  RowBox[{"Im", "[", "d", "]"}], " ", 
                  RowBox[{"Re", "[", "c", "]"}], " ", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "+", 
            FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SqrtBox[
                  FractionBox[
                    SuperscriptBox[
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "\[ImaginaryI]"}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                            RowBox[{"Re", "[", "d", "]"}]}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}], 
                      "2"], 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], " ",
                 
                SqrtBox[
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]], "-", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "b", "]"}], " ", 
                  RowBox[{"Im", "[", "c", "]"}], " ", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "-", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Re", "[", "b", "]"}], " ", 
                  RowBox[{"Re", "[", "c", "]"}], " ", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}]}], 
          ")"}], "/", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "d", "]"}], "-", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "d", "]"}], "+", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
            SqrtBox[
              RowBox[{
                RowBox[{"-", "1"}], "+", 
                RowBox[{"2", " ", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                RowBox[{"2", " ", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                RowBox[{"2", " ", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], ")"}]}], "+", 
      RowBox[{
        RowBox[{"(", 
          RowBox[{
            RowBox[{
              RowBox[{"-", 
                RowBox[{"Im", "[", "b", "]"}]}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{"1", "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "-", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "+", 
            RowBox[{"\[Pi]", " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "-", 
            RowBox[{"\[Pi]", " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{"1", "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "-", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "+", 
            RowBox[{"\[Pi]", " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "+", 
            RowBox[{
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{"1", "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "-", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{"1", "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "-", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "+", 
            RowBox[{"\[Pi]", " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SqrtBox[
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], "-", 
            FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SqrtBox[
                  FractionBox[
                    SuperscriptBox[
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "\[ImaginaryI]"}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                            RowBox[{"Re", "[", "d", "]"}]}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}], 
                      "2"], 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], " ",
                 
                SqrtBox[
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]], "-", 
            FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SqrtBox[
                  FractionBox[
                    SuperscriptBox[
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "\[ImaginaryI]"}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                            RowBox[{"Re", "[", "d", "]"}]}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}], 
                      "2"], 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], " ",
                 
                SqrtBox[
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]], "+", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "c", "]"}], " ", 
                  RowBox[{"Im", "[", "d", "]"}], " ", 
                  RowBox[{"Re", "[", "b", "]"}], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "+", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "c", "]"}], " ", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                  RowBox[{"Re", "[", "b", "]"}], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "-", 
            FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
                SqrtBox[
                  FractionBox[
                    SuperscriptBox[
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "\[ImaginaryI]"}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                            RowBox[{"Re", "[", "d", "]"}]}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}], 
                      "2"], 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], " ",
                 
                SqrtBox[
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]], "-", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "b", "]"}], " ", 
                  RowBox[{"Im", "[", "d", "]"}], " ", 
                  RowBox[{"Re", "[", "c", "]"}], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "-", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "b", "]"}], " ", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                  RowBox[{"Re", "[", "c", "]"}], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "-", 
            FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
                SqrtBox[
                  FractionBox[
                    SuperscriptBox[
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "\[ImaginaryI]"}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                            RowBox[{"Re", "[", "d", "]"}]}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}], 
                      "2"], 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], " ",
                 
                SqrtBox[
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]], "+", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "b", "]"}], " ", 
                  RowBox[{"Im", "[", "c", "]"}], " ", 
                  RowBox[{"Re", "[", "d", "]"}], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "+", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "b", "]"}], " ", 
                  RowBox[{"Im", "[", "c", "]"}], " ", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                  RowBox[{"Re", "[", "d", "]"}], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "+", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Re", "[", "b", "]"}], " ", 
                  RowBox[{"Re", "[", "c", "]"}], " ", 
                  RowBox[{"Re", "[", "d", "]"}], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "+", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                  RowBox[{"Re", "[", "b", "]"}], " ", 
                  RowBox[{"Re", "[", "c", "]"}], " ", 
                  RowBox[{"Re", "[", "d", "]"}], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "-", 
            FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SqrtBox[
                  FractionBox[
                    SuperscriptBox[
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "\[ImaginaryI]"}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                            RowBox[{"Re", "[", "d", "]"}]}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}], 
                      "2"], 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], " ",
                 
                SqrtBox[
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]], "-", 
            FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SqrtBox[
                  FractionBox[
                    SuperscriptBox[
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "\[ImaginaryI]"}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                            RowBox[{"Re", "[", "d", "]"}]}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}], 
                      "2"], 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], " ",
                 
                SqrtBox[
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]], "+", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "c", "]"}], " ", 
                  RowBox[{"Im", "[", "d", "]"}], " ", 
                  RowBox[{"Re", "[", "b", "]"}], " ", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "-", 
            FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SqrtBox[
                  FractionBox[
                    SuperscriptBox[
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "\[ImaginaryI]"}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                            RowBox[{"Re", "[", "d", "]"}]}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}], 
                      "2"], 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], " ",
                 
                SqrtBox[
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]], "-", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "b", "]"}], " ", 
                  RowBox[{"Im", "[", "d", "]"}], " ", 
                  RowBox[{"Re", "[", "c", "]"}], " ", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "-", 
            FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SqrtBox[
                  FractionBox[
                    SuperscriptBox[
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "\[ImaginaryI]"}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                            RowBox[{"Re", "[", "d", "]"}]}], "-", 
                          RowBox[{"\[ImaginaryI]", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}], 
                      "2"], 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], " ",
                 
                SqrtBox[
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      RowBox[{"-", "1"}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]], "+", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Im", "[", "b", "]"}], " ", 
                  RowBox[{"Im", "[", "c", "]"}], " ", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}], "+", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
                  RowBox[{"Re", "[", "b", "]"}], " ", 
                  RowBox[{"Re", "[", "c", "]"}], " ", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
                  SqrtBox[
                    FractionBox[
                      SuperscriptBox[
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            RowBox[{"-", "\[ImaginaryI]"}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                              RowBox[{"Re", "[", "d", "]"}]}], "-", 
                            RowBox[{"\[ImaginaryI]", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}]}], 
                          "]"}], "2"], 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{"-", "1"}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]], 
                  " ", 
                  SqrtBox[
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        RowBox[{"-", "1"}], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        RowBox[{"2", " ", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "4"]}], "]"}]]}], 
                ")"}], "/", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}]}], "]"}]}]}], 
          ")"}], "/", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "d", "]"}], "-", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "d", "]"}], "+", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
            SqrtBox[
              RowBox[{
                RowBox[{"-", "1"}], "+", 
                RowBox[{"2", " ", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"]}], "-", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "4"], "+", 
                RowBox[{"2", " ", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                RowBox[{"2", " ", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "4"]}]]}], 
          ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Integrate", "[", 
      RowBox[{
        SuperscriptBox[
          RowBox[{"Abs", "[", 
            FractionBox[
              RowBox[{
                SubscriptBox["c", "13"], "+", 
                RowBox[{"c", " ", 
                  RowBox[{"Exp", "[", 
                    RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}]}], 
              RowBox[{"d", "+", 
                RowBox[{"e", " ", 
                  RowBox[{"Exp", "[", 
                    RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}]}]], "]"}], 
          "2"], ",", 
        RowBox[{"{", 
          RowBox[{"\[CurlyPhi]", ",", "0", ",", 
            RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"-", 
        RowBox[{
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", 
                    SubscriptBox["c", "13"], "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", 
                    SubscriptBox["c", "13"], "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "3"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", 
                    SubscriptBox["c", "13"], "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", 
                    SubscriptBox["c", "13"], "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "3"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "3"]}], "-", 
              RowBox[{
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-",
               
              RowBox[{
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+",
               
              RowBox[{
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-",
               
              RowBox[{
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+",
               
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "3"], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "3"], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "+", 
              RowBox[{
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "-", 
              RowBox[{
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "+", 
              RowBox[{
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "+", 
              RowBox[{
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], " ", 
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", 
                    SubscriptBox["c", "13"], "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", 
                    SubscriptBox["c", "13"], "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", 
                    SubscriptBox["c", "13"], "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", 
                    SubscriptBox["c", "13"], "]"}], "2"]}]}], ")"}], "/", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"Im", "[", "d", "]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"Im", "[", "d", "]"}], "+", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"Im", "[", "e", "]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"Im", "[", "e", "]"}], "+", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], 
            ")"}]}]}], "+", 
      RowBox[{
        RowBox[{"(", 
          RowBox[{
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "c", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "3"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", 
                  SubscriptBox["c", "13"], "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "3"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "3"]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", 
                SubscriptBox["c", "13"], "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "3"], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "3"], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "+", 
            RowBox[{
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "-", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "+", 
            RowBox[{
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "+", 
            RowBox[{
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], " ", 
              RowBox[{"Re", "[", 
                SubscriptBox["c", "13"], "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", 
                  SubscriptBox["c", "13"], "]"}], "2"]}]}], ")"}], "/", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "d", "]"}], "-", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "d", "]"}], "+", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "e", "]"}], "-", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "e", "]"}], "+", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], " ", 
            RowBox[{"\[Sqrt]", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], 
          ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Integrate", "[", 
      RowBox[{
        SuperscriptBox[
          RowBox[{"Abs", "[", 
            FractionBox[
              RowBox[{"b", "+", 
                RowBox[{"c", " ", 
                  RowBox[{"Exp", "[", 
                    RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}]}], 
              RowBox[{"d", "+", 
                RowBox[{"e", " ", 
                  RowBox[{"Exp", "[", 
                    RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}]}]], "]"}], 
          "2"], ",", 
        RowBox[{"{", 
          RowBox[{"\[CurlyPhi]", ",", "0", ",", 
            RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"-", 
        RowBox[{
          RowBox[{"(", 
            RowBox[{
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Im", "[", "e", "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "3"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "b", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "3"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "3"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "3"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "3"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "3"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "3"]}], "+", 
              RowBox[{
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-",
               
              RowBox[{
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-",
               
              RowBox[{
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-",
               
              RowBox[{
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+",
               
              RowBox[{
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+",
               
              RowBox[{
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+",
               
              RowBox[{
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-",
               
              RowBox[{
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}]}], 
            ")"}], "/", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"Im", "[", "d", "]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"Im", "[", "d", "]"}], "+", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"Im", "[", "e", "]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"Im", "[", "e", "]"}], "+", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], 
            ")"}]}]}], "+", 
      RowBox[{
        RowBox[{"(", 
          RowBox[{
            RowBox[{
              RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Im", "[", "e", "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "3"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "b", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "c", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "3"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "3"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "3"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "3"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "3"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "3"]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}]}], 
          ")"}], "/", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "d", "]"}], "-", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "d", "]"}], "+", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "e", "]"}], "-", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "e", "]"}], "+", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], " ", 
            RowBox[{"\[Sqrt]", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], 
          ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Integrate", "[", 
      RowBox[{
        SuperscriptBox[
          RowBox[{"Abs", "[", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"b", "+", 
                  RowBox[{"c", " ", 
                    RowBox[{"Exp", "[", 
                      RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}]}], ")"}], 
              "/", 
              RowBox[{"(", 
                RowBox[{"d", "+", 
                  RowBox[{"e", " ", 
                    RowBox[{"Exp", "[", 
                      RowBox[{"I", " ", "\[CurlyPhi]"}], "]"}]}]}], ")"}]}], 
            "]"}], "2"], ",", 
        RowBox[{"{", 
          RowBox[{"\[CurlyPhi]", ",", "0", ",", 
            RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"-", 
        RowBox[{
          RowBox[{"(", 
            RowBox[{
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Im", "[", "e", "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "3"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "b", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "3"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "3"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
                RowBox[{"Re", "[", "e", "]"}]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "3"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "3"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "3"]}], "+", 
              RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                RowBox[{"ArcTan", "[", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "e", "]"}], " ", 
                          RowBox[{"Re", "[", "d", "]"}]}], "-", 
                        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          RowBox[{"Im", "[", "d", "]"}], " ", 
                          RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                      RowBox[{"\[Sqrt]", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                            RowBox[{"2", " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                              SuperscriptBox[
                                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                      ")"}]}], "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                SuperscriptBox[
                  RowBox[{"Re", "[", "e", "]"}], "3"]}], "+", 
              RowBox[{
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-",
               
              RowBox[{
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-",
               
              RowBox[{
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-",
               
              RowBox[{
                RowBox[{"Im", "[", "e", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+",
               
              RowBox[{
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+",
               
              RowBox[{
                RowBox[{"Im", "[", "d", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+",
               
              RowBox[{
                RowBox[{"Im", "[", "c", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "b", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-",
               
              RowBox[{
                RowBox[{"Im", "[", "b", "]"}], " ", 
                RowBox[{"Log", "[", 
                  RowBox[{
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Im", "[", "d", "]"}], " ", 
                      RowBox[{"Im", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                      RowBox[{"Re", "[", "d", "]"}], " ", 
                      RowBox[{"Re", "[", "e", "]"}]}], "+", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
                RowBox[{"Re", "[", "c", "]"}], " ", 
                RowBox[{"Re", "[", "d", "]"}], " ", 
                RowBox[{"Re", "[", "e", "]"}], " ", 
                RowBox[{"\[Sqrt]", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{"-", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                      RowBox[{"2", " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                        SuperscriptBox[
                          RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}]}], 
            ")"}], "/", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"Im", "[", "d", "]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"Im", "[", "d", "]"}], "+", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"Im", "[", "e", "]"}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"Im", "[", "e", "]"}], "+", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], 
            ")"}]}]}], "+", 
      RowBox[{
        RowBox[{"(", 
          RowBox[{
            RowBox[{
              RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Im", "[", "e", "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "3"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "b", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "c", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "3"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "3"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "3"], " ", 
              RowBox[{"Re", "[", "e", "]"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "b", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Im", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "b", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "c", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "3"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "3"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "3"]}], "-", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
              RowBox[{"ArcTan", "[", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "e", "]"}], " ", 
                        RowBox[{"Re", "[", "d", "]"}]}], "+", 
                      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                        RowBox[{"Im", "[", "d", "]"}], " ", 
                        RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], "/", 
                  RowBox[{"(", 
                    RowBox[{"\[Sqrt]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{"-", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                          RowBox[{"2", " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                            SuperscriptBox[
                              RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                          SuperscriptBox[
                            RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}], 
                    ")"}]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              SuperscriptBox[
                RowBox[{"Re", "[", "e", "]"}], "3"]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "e", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{
              RowBox[{"Im", "[", "d", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{
              RowBox[{"Im", "[", "c", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "-", 
            RowBox[{
              RowBox[{"Im", "[", "b", "]"}], " ", 
              RowBox[{"Log", "[", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"Im", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Im", "[", "d", "]"}], " ", 
                    RowBox[{"Im", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "2"], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "2"], "+", 
                  RowBox[{"2", " ", 
                    RowBox[{"Re", "[", "d", "]"}], " ", 
                    RowBox[{"Re", "[", "e", "]"}]}], "+", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "2"]}], "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], "+", 
            RowBox[{"2", " ", "\[Pi]", " ", 
              RowBox[{"Re", "[", "b", "]"}], " ", 
              RowBox[{"Re", "[", "c", "]"}], " ", 
              RowBox[{"Re", "[", "d", "]"}], " ", 
              RowBox[{"Re", "[", "e", "]"}], " ", 
              RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                      SuperscriptBox[
                        RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}]}], 
          ")"}], "/", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "d", "]"}], "-", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "d", "]"}], "+", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "d", "]"}]}]}], ")"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "e", "]"}], "-", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{"Im", "[", "e", "]"}], "+", 
                RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"Re", "[", "e", "]"}]}]}], ")"}], " ", 
            RowBox[{"\[Sqrt]", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"-", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "4"]}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Im", "[", "e", "]"}], "4"], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "d", "]"}], "4"], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Im", "[", "e", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "d", "]"}], "2"], " ", 
                    SuperscriptBox[
                      RowBox[{"Re", "[", "e", "]"}], "2"]}], "-", 
                  SuperscriptBox[
                    RowBox[{"Re", "[", "e", "]"}], "4"]}], ")"}]}]}], 
          ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"FullSimplify", "[", 
      RowBox[{"(", 
        FractionBox[
          RowBox[{
            SubscriptBox["c", "13"], "+", 
            RowBox[{
              SuperscriptBox["\[ExponentialE]", 
                RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
              SubscriptBox["c", "14"]}]}], 
          RowBox[{
            SubscriptBox["c", "11"], "+", 
            RowBox[{
              SuperscriptBox["\[ExponentialE]", 
                RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
              SubscriptBox["c", "12"]}]}]], ")"}], "]"}]], "Input"],

Cell[BoxData[
    FractionBox[
      RowBox[{
        SubscriptBox["c", "13"], "+", 
        RowBox[{
          SuperscriptBox["\[ExponentialE]", 
            RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
          SubscriptBox["c", "14"]}]}], 
      RowBox[{
        SubscriptBox["c", "11"], "+", 
        RowBox[{
          SuperscriptBox["\[ExponentialE]", 
            RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
          SubscriptBox["c", "12"]}]}]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    FractionBox[
      RowBox[{
        SubscriptBox["c", "13"], "+", 
        RowBox[{
          SuperscriptBox["\[ExponentialE]", 
            RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
          SubscriptBox["c", "14"]}]}], 
      RowBox[{
        SubscriptBox["c", "11"], "+", 
        RowBox[{
          SuperscriptBox["\[ExponentialE]", 
            RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
          SubscriptBox["c", "12"]}]}]]], "Input"],

Cell[BoxData[
    FractionBox[
      RowBox[{
        SubscriptBox["c", "13"], "+", 
        RowBox[{
          SuperscriptBox["\[ExponentialE]", 
            RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
          SubscriptBox["c", "14"]}]}], 
      RowBox[{
        SubscriptBox["c", "11"], "+", 
        RowBox[{
          SuperscriptBox["\[ExponentialE]", 
            RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
          SubscriptBox["c", "12"]}]}]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"(", 
        RowBox[{
          SubscriptBox["c", "13"], "+", 
          RowBox[{
            SubscriptBox["c", "14"], 
            SuperscriptBox["\[ExponentialE]", 
              RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], ")"}], "/", 
      
      RowBox[{"(", 
        RowBox[{
          SubscriptBox["c", "11"], "+", " ", 
          RowBox[{
            SubscriptBox["c", "12"], 
            SuperscriptBox["\[ExponentialE]", 
              RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], 
        ")"}]}]], "Input"],

Cell[BoxData[
    FractionBox[
      RowBox[{
        SubscriptBox["c", "13"], "+", 
        RowBox[{
          SuperscriptBox["\[ExponentialE]", 
            RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
          SubscriptBox["c", "14"]}]}], 
      RowBox[{
        SubscriptBox["c", "11"], "+", 
        RowBox[{
          SuperscriptBox["\[ExponentialE]", 
            RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
          SubscriptBox["c", "12"]}]}]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"(", 
        RowBox[{"a", "+", 
          RowBox[{"b", " ", 
            SuperscriptBox["\[ExponentialE]", 
              RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], ")"}], "/", 
      
      RowBox[{"(", 
        RowBox[{"c", "+", " ", 
          RowBox[{"d", " ", 
            SuperscriptBox["\[ExponentialE]", 
              RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], 
        ")"}]}]], "Input"],

Cell[BoxData[
    FractionBox[
      RowBox[{
        RowBox[{"b", " ", 
          SuperscriptBox["\[ExponentialE]", 
            RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}], "+", 
        RowBox[{
          SubscriptBox["\[Beta]p", "0"], " ", 
          SqrtBox[
            SubscriptBox["\[Alpha]p", 
              RowBox[{"mp", ",", "0"}]]], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"0", ",", "0"}]]}], "+", 
              RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                  RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"0", ",", "1"}]]}]}], ")"}]}], "+", 
        RowBox[{
          SubscriptBox["\[Beta]p", "1"], " ", 
          SqrtBox[
            SubscriptBox["\[Alpha]p", 
              RowBox[{"mp", ",", "1"}]]], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"1", ",", "0"}]]}], "+", 
              RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                  RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"1", ",", "1"}]]}]}], ")"}]}]}], 
      RowBox[{"c", "+", 
        RowBox[{"d", " ", 
          SuperscriptBox["\[ExponentialE]", 
            RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"(", 
        RowBox[{"a", "+", 
          RowBox[{"b", " ", 
            SuperscriptBox["\[ExponentialE]", 
              RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], ")"}], "/", 
      
      RowBox[{"(", 
        RowBox[{"c", "+", 
          RowBox[{"d", " ", 
            SuperscriptBox["\[ExponentialE]", 
              RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}], 
        ")"}]}]], "Input"],

Cell[BoxData[
    FractionBox[
      RowBox[{
        RowBox[{"b", " ", 
          SuperscriptBox["\[ExponentialE]", 
            RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}], "+", 
        RowBox[{
          SubscriptBox["\[Beta]p", "0"], " ", 
          SqrtBox[
            SubscriptBox["\[Alpha]p", 
              RowBox[{"mp", ",", "0"}]]], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"0", ",", "0"}]]}], "+", 
              RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                  RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"0", ",", "1"}]]}]}], ")"}]}], "+", 
        RowBox[{
          SubscriptBox["\[Beta]p", "1"], " ", 
          SqrtBox[
            SubscriptBox["\[Alpha]p", 
              RowBox[{"mp", ",", "1"}]]], " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "0"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"1", ",", "0"}]]}], "+", 
              RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                  RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]], " ", 
                RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
                SqrtBox[
                  SubscriptBox["\[Alpha]", 
                    RowBox[{"m", ",", "1"}]]], " ", 
                SubscriptBox["\[Gamma]", 
                  RowBox[{"1", ",", "1"}]]}]}], ")"}]}]}], 
      RowBox[{"c", "+", 
        RowBox[{"d", " ", 
          SuperscriptBox["\[ExponentialE]", 
            RowBox[{"\[ImaginaryI]", " ", "\[CurlyPhi]"}]]}]}]]], "Output"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
Evaluator->"psi",
WindowSize->{1025, 740},
WindowMargins->{{-4, Automatic}, {Automatic, 0}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 4377, 113, 105, "Input"],

Cell[CellGroupData[{
Cell[6119, 166, 52, 1, 27, "Input"],
Cell[6174, 169, 28, 0, 27, "Output"]
}, Open  ]],
Cell[6217, 172, 545, 18, 32, "Text"],
Cell[6765, 192, 2144, 48, 77, "Input"],

Cell[CellGroupData[{
Cell[8934, 244, 3413, 86, 77, "Input"],
Cell[12350, 332, 28, 0, 27, "Output"]
}, Open  ]],
Cell[12393, 335, 415, 11, 43, "Input"],
Cell[12811, 348, 2250, 48, 33, "Input"],

Cell[CellGroupData[{
Cell[15086, 400, 189, 5, 27, "Input"],
Cell[15278, 407, 28, 0, 27, "Output"]
}, Open  ]],
Cell[15321, 410, 286, 8, 27, "Input"],
Cell[15610, 420, 319, 9, 30, "Input"],

Cell[CellGroupData[{
Cell[15954, 433, 269, 7, 27, "Input"],
Cell[16226, 442, 227, 6, 30, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[16490, 453, 366, 10, 43, "Input"],
Cell[16859, 465, 31, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[16927, 470, 691, 19, 45, "Input"],
Cell[17621, 491, 28, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[17686, 496, 268, 7, 27, "Input"],
Cell[17957, 505, 94, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[18088, 512, 334, 9, 27, "Input"],
Cell[18425, 523, 156, 4, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[18618, 532, 369, 11, 27, "Input"],
Cell[18990, 545, 15294, 439, 186, 4217, 298, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]],
Cell[34299, 987, 2627, 59, 84, "Input"],
Cell[36929, 1048, 2627, 59, 84, "Input"],

Cell[CellGroupData[{
Cell[39581, 1111, 230, 6, 27, "Input"],
Cell[39814, 1119, 28, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[39879, 1124, 567, 15, 27, "Input"],
Cell[40449, 1141, 194, 6, 44, "Output"]
}, Open  ]],
Cell[40658, 1150, 1016, 25, 44, "Input"],

Cell[CellGroupData[{
Cell[41699, 1179, 189, 5, 27, "Input"],
Cell[41891, 1186, 28, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[41956, 1191, 30, 0, 27, "Input"],
Cell[41989, 1193, 2356, 57, 67, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[44382, 1255, 682, 19, 42, "Subsubsection"],

Cell[CellGroupData[{
Cell[45089, 1278, 1285, 31, 42, "Input"],
Cell[46377, 1311, 265, 6, 23, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[46679, 1322, 1326, 32, 42, "Input"],
Cell[48008, 1356, 268, 6, 23, "Message"]
}, Open  ]],
Cell[48291, 1365, 170, 5, 47, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[48498, 1375, 1087, 31, 46, "Subsubsection"],
Cell[49588, 1408, 293, 8, 44, "Input"],

Cell[CellGroupData[{
Cell[49906, 1420, 3754, 97, 107, "Input"],
Cell[53663, 1519, 28, 0, 27, "Output"]
}, Open  ]],
Cell[53706, 1522, 874, 25, 75, "Input"],

Cell[CellGroupData[{
Cell[54605, 1551, 348, 9, 27, "Input"],
Cell[54956, 1562, 1631, 41, 44, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[56636, 1609, 992, 28, 46, "Subsubsection"],
Cell[57631, 1639, 259, 7, 44, "Input"],

Cell[CellGroupData[{
Cell[57915, 1650, 3855, 100, 107, "Input"],
Cell[61773, 1752, 28, 0, 27, "Output"]
}, Open  ]],
Cell[61816, 1755, 874, 25, 75, "Input"],

Cell[CellGroupData[{
Cell[62715, 1784, 30, 0, 27, "Input"],
Cell[62748, 1786, 2094, 50, 36, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[64879, 1841, 209, 5, 27, "Input"],
Cell[65091, 1848, 1910, 46, 44, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[67050, 1900, 1180, 34, 46, "Subsubsection"],
Cell[68233, 1936, 324, 9, 47, "Input"],

Cell[CellGroupData[{
Cell[68582, 1949, 4967, 127, 128, "Input"],
Cell[73552, 2078, 28, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[73617, 2083, 1784, 48, 95, "Input"],
Cell[75404, 2133, 28, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[75469, 2138, 807, 22, 91, "Input"],
Cell[76279, 2162, 35, 0, 27, "Output"],
Cell[76317, 2164, 39, 0, 27, "Output"],
Cell[76359, 2166, 39, 0, 27, "Output"],
Cell[76401, 2168, 39, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[76477, 2173, 737, 20, 50, "Input"],
Cell[77217, 2195, 35, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[77289, 2200, 629, 16, 48, "Input"],
Cell[77921, 2218, 641, 16, 49, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[78599, 2239, 634, 16, 48, "Input"],
Cell[79236, 2257, 707, 18, 53, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[79980, 2280, 784, 22, 29, "Input"],
Cell[80767, 2304, 692, 19, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[81496, 2328, 801, 20, 48, "Input"],
Cell[82300, 2350, 35, 0, 27, "Output"]
}, Open  ]],
Cell[82350, 2353, 485, 13, 48, "Input"],
Cell[82838, 2368, 47, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[82910, 2373, 907, 24, 49, "Input"],
Cell[83820, 2399, 246, 6, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[84103, 2410, 209, 5, 27, "Input"],
Cell[84315, 2417, 4425, 110, 89, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[88777, 2532, 833, 20, 51, "Input"],
Cell[89613, 2554, 827, 20, 51, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[90477, 2579, 652, 17, 48, "Input"],
Cell[91132, 2598, 234300, 4833, 7269, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[325469, 7436, 689, 18, 47, "Input"],
Cell[326161, 7456, 393443, 7503, 5244, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[719641, 14964, 652, 17, 48, "Input"],
Cell[720296, 14983, 389534, 7404, 5283, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1109867, 22392, 757, 20, 29, "Input"],
Cell[1110627, 22414, 389534, 7404, 5283, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1500198, 29823, 604, 15, 52, "Input"],
Cell[1500805, 29840, 485, 13, 50, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1501327, 29858, 484, 13, 50, "Input"],
Cell[1501814, 29873, 485, 13, 50, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1502336, 29891, 575, 17, 32, "Input"],
Cell[1502914, 29910, 485, 13, 50, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1503436, 29928, 457, 13, 32, "Input"],
Cell[1503896, 29943, 2253, 55, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1506186, 30003, 452, 13, 32, "Input"],
Cell[1506641, 30018, 2253, 55, 52, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

