(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    181724,       6575]*)
(*NotebookOutlinePosition[    182640,       6604]*)
(*  CellTagsIndexPosition[    182596,       6600]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    RowBox[{"<<", "Graphics`Graphics3D`"}]], "Input"],

Cell[BoxData[{
    RowBox[{
      RowBox[{"select\[CurlyPhi]", ":=", 
        RowBox[{"Random", "[", 
          RowBox[{"Real", ",", 
            RowBox[{"{", 
              RowBox[{"0", ",", 
                RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"select\[CurlyTheta]", ":=", 
        RowBox[{"ArcCos", "[", 
          RowBox[{"1", "-", 
            RowBox[{"2", 
              RowBox[{"Random", "[", "]"}]}]}], "]"}]}], ";"}]}], "Input"],

Cell[BoxData[
    RowBox[{"xyz", ":=", 
      RowBox[{"Block", "[", 
        RowBox[{
          RowBox[{"{", 
            RowBox[{
              RowBox[{"\[CurlyPhi]", "=", "select\[CurlyPhi]"}], ",", 
              RowBox[{"\[CurlyTheta]", "=", "select\[CurlyTheta]"}]}], "}"}], 
          ",", 
          RowBox[{"{", 
            RowBox[{
              RowBox[{
                RowBox[{"Sin", "[", "\[CurlyTheta]", "]"}], 
                RowBox[{"Cos", "[", "\[CurlyPhi]", "]"}]}], ",", 
              RowBox[{
                RowBox[{"Sin", "[", "\[CurlyTheta]", "]"}], 
                RowBox[{"Sin", "[", "\[CurlyPhi]", "]"}]}], ",", 
              RowBox[{"Cos", "[", "\[CurlyTheta]", "]"}]}], "}"}]}], 
        "]"}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"xyzs", "=", 
        RowBox[{"Table", "[", 
          RowBox[{"xyz", ",", 
            RowBox[{"{", "5000", "}"}]}], "]"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"ScatterPlot3D", "[", 
        RowBox[{"xyzs", ",", 
          RowBox[{"PlotStyle", "\[Rule]", 
            RowBox[{"{", 
              RowBox[{"PointSize", "[", "0.005", "]"}], "}"}]}]}], "]"}], 
      ";"}]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.08529 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0566367 1.16587 -1.6263e-17 1.16587 [
[.0906 .22993 -11.8322 -9 ]
[.0906 .22993 .16778 0 ]
[.21899 .1757 -22.6157 -9 ]
[.21899 .1757 1.3843 0 ]
[.35448 .11849 -5.39174 -9 ]
[.35448 .11849 .60826 0 ]
[.49768 .05807 -15.3887 -9 ]
[.49768 .05807 2.61132 0 ]
[.64927 -0.00584 -4.86738 -9 ]
[.64927 -0.00584 1.13262 0 ]
[.00947 .82618 -6.92727 0 ]
[.00947 .82618 5.07273 9 ]
[.12074 .9042 -13.4221 0 ]
[.12074 .9042 10.5779 9 ]
[.22053 .97417 -3.26267 0 ]
[.22053 .97417 2.73733 9 ]
[.31055 1.03728 -9.54616 0 ]
[.31055 1.03728 8.45384 9 ]
[.39214 1.09449 -3.11141 0 ]
[.39214 1.09449 2.88859 9 ]
[.07323 .26218 -12 -2.61777 ]
[.07323 .26218 0 6.38223 ]
[.05471 .37808 -24 -2.72068 ]
[.05471 .37808 0 6.27932 ]
[.03458 .50409 -6 -2.83351 ]
[.03458 .50409 0 6.16649 ]
[.01262 .64161 -18 -2.95774 ]
[.01262 .64161 0 6.04226 ]
[-0.01144 .79228 -6 -3.09519 ]
[-0.01144 .79228 0 5.90481 ]
[ 0 0 0 0 ]
[ 1 1.08529 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.08841 .24557 m
.67251 0 L
s
.10076 .24038 m
.10584 .2456 L
s
[(-1)] .0906 .22993 .97204 1 Mshowa
.22864 .18661 m
.23347 .19207 L
s
[(-0.5)] .21899 .1757 .88464 1 Mshowa
.36356 .12989 m
.3681 .13559 L
s
[(0)] .35448 .11849 .79725 1 Mshowa
.50612 .06996 m
.51033 .0759 L
s
[(0.5)] .49768 .05807 .70985 1 Mshowa
.65697 .00653 m
.66082 .01272 L
s
[(1)] .64927 -0.00584 .62246 1 Mshowa
.125 Mabswid
.1258 .22985 m
.12882 .23301 L
s
.1511 .21921 m
.15409 .2224 L
s
.17668 .20846 m
.17963 .21168 L
s
.20252 .1976 m
.20545 .20084 L
s
.25504 .17551 m
.25791 .17882 L
s
.28173 .16429 m
.28456 .16762 L
s
.30871 .15295 m
.31151 .15631 L
s
.33599 .14148 m
.33875 .14487 L
s
.39144 .11817 m
.39413 .12162 L
s
.41963 .10632 m
.42228 .10979 L
s
.44814 .09433 m
.45075 .09784 L
s
.47696 .08221 m
.47953 .08575 L
s
.5356 .05756 m
.53809 .06115 L
s
.56542 .04502 m
.56787 .04865 L
s
.59559 .03234 m
.59799 .03599 L
s
.6261 .01951 m
.62846 .02319 L
s
.25 Mabswid
0 .80354 m
.4003 1.08529 L
s
.01169 .81177 m
.01281 .80457 L
s
[(-1)] .00947 .82618 .15455 -1 Mshowa
.12245 .88973 m
.12331 .88249 L
s
[(-0.5)] .12074 .9042 .11851 -1 Mshowa
.22181 .95966 m
.22244 .9524 L
s
[(0)] .22053 .97417 .08756 -1 Mshowa
.31143 1.02274 m
.31187 1.01546 L
s
[(0.5)] .31055 1.03728 .06068 -1 Mshowa
.39269 1.07993 m
.39296 1.07264 L
s
[(1)] .39214 1.09449 .03714 -1 Mshowa
.125 Mabswid
.03485 .82807 m
.03549 .82375 L
s
.05749 .84401 m
.05809 .83968 L
s
.07962 .85958 m
.0802 .85525 L
s
.10127 .87482 m
.10182 .87048 L
s
.14318 .90431 m
.14366 .89997 L
s
.16346 .91859 m
.16392 .91424 L
s
.18332 .93257 m
.18375 .92822 L
s
.20276 .94625 m
.20317 .9419 L
s
.24046 .97279 m
.24082 .96843 L
s
.25874 .98565 m
.25907 .98129 L
s
.27665 .99826 m
.27696 .9939 L
s
.29421 1.01062 m
.2945 1.00626 L
s
.32831 1.03462 m
.32855 1.03025 L
s
.34487 1.04627 m
.34509 1.0419 L
s
.36111 1.0577 m
.36131 1.05333 L
s
.37705 1.06892 m
.37723 1.06455 L
s
.25 Mabswid
.08841 .24557 m
0 .80354 L
s
.08667 .25656 m
.09339 .25374 L
s
[(-1)] .07323 .26218 1 -0.41827 Mshowa
.06826 .37272 m
.07504 .37004 L
s
[(-0.5)] .05471 .37808 1 -0.3954 Mshowa
.04825 .49903 m
.05508 .4965 L
s
[(0)] .03458 .50409 1 -0.37033 Mshowa
.02641 .63688 m
.0333 .63452 L
s
[(0.5)] .01262 .64161 1 -0.34273 Mshowa
.00247 .78794 m
.00943 .78577 L
s
[(1)] -0.01144 .79228 1 -0.31218 Mshowa
.125 Mabswid
.08311 .27904 m
.08715 .27736 L
s
.07949 .30188 m
.08353 .30023 L
s
.07581 .3251 m
.07986 .32346 L
s
.07207 .34871 m
.07613 .34709 L
s
.0644 .39713 m
.06847 .39553 L
s
.06046 .42195 m
.06454 .42038 L
s
.05646 .4472 m
.06055 .44565 L
s
.05239 .47289 m
.05648 .47135 L
s
.04404 .52563 m
.04814 .52413 L
s
.03975 .5527 m
.04386 .55122 L
s
.03538 .58026 m
.0395 .5788 L
s
.03093 .60831 m
.03506 .60687 L
s
.0218 .66598 m
.02594 .66458 L
s
.0171 .69562 m
.02125 .69424 L
s
.01232 .72581 m
.01647 .72446 L
s
.00744 .75658 m
.01161 .75525 L
s
.25 Mabswid
.08841 .24557 m
0 .80354 L
s
0 .80354 m
.4003 1.08529 L
s
.4003 1.08529 m
.41792 .58155 L
s
.41792 .58155 m
.08841 .24557 L
s
.67251 0 m
.92716 .41491 L
s
.92716 .41491 m
1 .94789 L
s
1 .94789 m
.70649 .58523 L
s
.70649 .58523 m
.67251 0 L
s
.08841 .24557 m
0 .80354 L
s
0 .80354 m
.70649 .58523 L
s
.70649 .58523 m
.67251 0 L
s
.67251 0 m
.08841 .24557 L
s
.41792 .58155 m
.92716 .41491 L
s
.92716 .41491 m
1 .94789 L
s
1 .94789 m
.4003 1.08529 L
s
.4003 1.08529 m
.41792 .58155 L
s
0 0 m
1 0 L
1 1.08529 L
0 1.08529 L
closepath
clip
newpath
.005 w
.52836 .57848 Mdot
.51639 .58547 Mdot
.51403 .58502 Mdot
.54274 .57645 Mdot
.53425 .56642 Mdot
.50836 .57553 Mdot
.54324 .57282 Mdot
.51568 .56628 Mdot
.53732 .59987 Mdot
.50779 .57496 Mdot
.54739 .58386 Mdot
.49921 .58567 Mdot
.51721 .61003 Mdot
.51063 .60857 Mdot
.49636 .59015 Mdot
.54931 .60581 Mdot
.54562 .55645 Mdot
.5043 .60796 Mdot
.53638 .61658 Mdot
.50345 .5556 Mdot
.55271 .60898 Mdot
.53745 .54707 Mdot
.50553 .61528 Mdot
.49621 .55886 Mdot
.55762 .55972 Mdot
.56373 .56944 Mdot
.48654 .58557 Mdot
.48518 .58009 Mdot
.56742 .57137 Mdot
.48471 .57198 Mdot
.48498 .59824 Mdot
.53152 .62674 Mdot
.49645 .54953 Mdot
.4959 .54774 Mdot
.5084 .53954 Mdot
.51355 .53772 Mdot
.57417 .59125 Mdot
.56374 .61477 Mdot
.47843 .57045 Mdot
.56397 .54976 Mdot
.56832 .55514 Mdot
.54639 .53668 Mdot
.54358 .53538 Mdot
.47589 .57457 Mdot
.47926 .5625 Mdot
.51698 .53234 Mdot
.57304 .55867 Mdot
.55381 .53794 Mdot
.57695 .59797 Mdot
.54029 .63409 Mdot
.5018 .53591 Mdot
.48612 .61778 Mdot
.57135 .61342 Mdot
.47184 .5857 Mdot
.5217 .52828 Mdot
.47216 .59305 Mdot
.49515 .53454 Mdot
.5646 .53941 Mdot
.58393 .57429 Mdot
.51566 .52471 Mdot
.46687 .58743 Mdot
.47129 .6061 Mdot
.48149 .54287 Mdot
.54047 .64246 Mdot
.57059 .54019 Mdot
.46713 .56514 Mdot
.49715 .63793 Mdot
.5212 .52076 Mdot
.47455 .54779 Mdot
.53308 .64525 Mdot
.58841 .5711 Mdot
.58545 .56023 Mdot
.56967 .63002 Mdot
.46673 .55829 Mdot
.59182 .585 Mdot
.57144 .53501 Mdot
.46019 .57828 Mdot
.5089 .64715 Mdot
.501 .52154 Mdot
.55778 .6422 Mdot
.45951 .5897 Mdot
.48294 .53046 Mdot
.49392 .52269 Mdot
.49743 .64593 Mdot
.58136 .62503 Mdot
.59403 .5663 Mdot
.5565 .64609 Mdot
.502 .51651 Mdot
.45469 .59087 Mdot
.56952 .52526 Mdot
.46752 .62598 Mdot
.56544 .64484 Mdot
.50589 .65605 Mdot
.52932 .50705 Mdot
.58485 .53413 Mdot
.57198 .64451 Mdot
.44982 .58868 Mdot
.46776 .63466 Mdot
.44933 .5965 Mdot
.59298 .54191 Mdot
.54009 .50554 Mdot
.49785 .50955 Mdot
.45231 .61327 Mdot
.56546 .51153 Mdot
.45231 .61853 Mdot
.44993 .55224 Mdot
.49349 .50677 Mdot
.5887 .63834 Mdot
.46273 .63807 Mdot
.45684 .53553 Mdot
.61042 .58086 Mdot
.61047 .58197 Mdot
.52732 .49836 Mdot
.56008 .66062 Mdot
.46721 .64509 Mdot
.44863 .54653 Mdot
.5304 .49708 Mdot
.47978 .65577 Mdot
.44587 .61449 Mdot
.4845 .50681 Mdot
.59289 .63991 Mdot
.50002 .49895 Mdot
.56705 .50487 Mdot
.61379 .59641 Mdot
.53867 .67155 Mdot
.60795 .54657 Mdot
.48237 .50476 Mdot
.47002 .65308 Mdot
.44795 .62744 Mdot
.61701 .58258 Mdot
.44408 .62255 Mdot
.58578 .51276 Mdot
.43962 .61431 Mdot
.57203 .50274 Mdot
.5745 .50417 Mdot
.55181 .49417 Mdot
.43356 .58893 Mdot
.53416 .49008 Mdot
.56779 .49928 Mdot
.45406 .64277 Mdot
.60913 .53899 Mdot
.47464 .66204 Mdot
.50931 .6764 Mdot
.55538 .67344 Mdot
.53478 .67831 Mdot
.61943 .60657 Mdot
.45512 .64772 Mdot
.43394 .61031 Mdot
.48392 .66969 Mdot
.55311 .67605 Mdot
.62242 .60097 Mdot
.61165 .53416 Mdot
.42774 .58295 Mdot
.57294 .67075 Mdot
.49991 .48712 Mdot
.57624 .66933 Mdot
.4377 .62901 Mdot
.42577 .5818 Mdot
.58316 .66617 Mdot
.56259 .48897 Mdot
.42559 .59471 Mdot
.62489 .60738 Mdot
.47521 .6714 Mdot
.42419 .58176 Mdot
.58085 .66976 Mdot
.60156 .5133 Mdot
.62674 .56201 Mdot
.52694 .48014 Mdot
.62767 .56338 Mdot
.50389 .68382 Mdot
.48263 .48833 Mdot
.51828 .68698 Mdot
.49108 .6813 Mdot
.46384 .66669 Mdot
.4992 .48206 Mdot
.62633 .55261 Mdot
.55866 .48288 Mdot
.43874 .52462 Mdot
.5554 .4816 Mdot
.47036 .67253 Mdot
.61337 .64335 Mdot
.59957 .50576 Mdot
.59201 .49915 Mdot
.45251 .50586 Mdot
.43364 .63624 Mdot
.58292 .49171 Mdot
.54991 .47801 Mdot
.46514 .6721 Mdot
.62769 .62075 Mdot
.52459 .47478 Mdot
.50182 .68852 Mdot
.41794 .58085 Mdot
.59026 .67089 Mdot
.43949 .64846 Mdot
.6353 .58492 Mdot
.43727 .64639 Mdot
.47868 .48404 Mdot
.44177 .65362 Mdot
.50839 .47406 Mdot
.58619 .67613 Mdot
.53674 .47249 Mdot
.4678 .48851 Mdot
.42883 .63664 Mdot
.44771 .50399 Mdot
.61672 .64823 Mdot
.42477 .53655 Mdot
.45384 .66829 Mdot
.56453 .47722 Mdot
.54571 .47195 Mdot
.57277 .4799 Mdot
.60779 .66148 Mdot
.63398 .5479 Mdot
.4154 .55953 Mdot
.48864 .68995 Mdot
.5267 .4696 Mdot
.5867 .67912 Mdot
.41922 .54476 Mdot
.53765 .6962 Mdot
.57239 .68704 Mdot
.56285 .47496 Mdot
.42179 .63027 Mdot
.41819 .6218 Mdot
.45447 .49304 Mdot
.56074 .69306 Mdot
.61944 .65151 Mdot
.56811 .47517 Mdot
.49913 .69586 Mdot
.56087 .47212 Mdot
.57075 .69154 Mdot
.48548 .47303 Mdot
.57077 .69232 Mdot
.45535 .48846 Mdot
.64437 .58906 Mdot
.50159 .4671 Mdot
.56399 .47051 Mdot
.40746 .5876 Mdot
.53373 .70189 Mdot
.41123 .55172 Mdot
.55192 .46649 Mdot
.64561 .58172 Mdot
.64573 .58752 Mdot
.60121 .48954 Mdot
.62629 .64964 Mdot
.40606 .59278 Mdot
.49432 .70002 Mdot
.43008 .5091 Mdot
.61787 .6634 Mdot
.40951 .54805 Mdot
.5667 .46771 Mdot
.40412 .58279 Mdot
.57738 .47192 Mdot
.4039 .58262 Mdot
.59542 .48197 Mdot
.48423 .46775 Mdot
.53041 .70605 Mdot
.4644 .68974 Mdot
.44038 .4941 Mdot
.64831 .60615 Mdot
.4021 .58106 Mdot
.55792 .46247 Mdot
.60472 .68026 Mdot
.49798 .70482 Mdot
.62014 .66567 Mdot
.60551 .48524 Mdot
.40344 .55271 Mdot
.62482 .50347 Mdot
.41398 .64196 Mdot
.53127 .45617 Mdot
.4864 .70375 Mdot
.58124 .6979 Mdot
.64738 .62386 Mdot
.45343 .47787 Mdot
.48526 .46163 Mdot
.64681 .62673 Mdot
.48527 .70461 Mdot
.39867 .56854 Mdot
.51835 .4541 Mdot
.4207 .50853 Mdot
.43384 .67346 Mdot
.59588 .47351 Mdot
.54008 .45371 Mdot
.65473 .60353 Mdot
.65661 .58256 Mdot
.64441 .63828 Mdot
.41735 .65539 Mdot
.59798 .47339 Mdot
.64346 .64231 Mdot
.517 .71435 Mdot
.64675 .6363 Mdot
.42162 .66307 Mdot
.47463 .7057 Mdot
.65504 .54873 Mdot
.39692 .5509 Mdot
.51111 .71556 Mdot
.6001 .47163 Mdot
.41413 .51005 Mdot
.4871 .71098 Mdot
.41064 .51483 Mdot
.54275 .44923 Mdot
.56538 .45365 Mdot
.46114 .46408 Mdot
.39198 .60264 Mdot
.47293 .70808 Mdot
.60928 .69097 Mdot
.39279 .61014 Mdot
.39528 .5451 Mdot
.45389 .4673 Mdot
.63345 .6678 Mdot
.65458 .53445 Mdot
.66156 .60634 Mdot
.57173 .45314 Mdot
.44819 .69628 Mdot
.5012 .71849 Mdot
.38829 .57263 Mdot
.41845 .49601 Mdot
.39246 .5469 Mdot
.42375 .4894 Mdot
.65998 .62059 Mdot
.65502 .63511 Mdot
.40067 .64324 Mdot
.39153 .61972 Mdot
.40069 .6445 Mdot
.46323 .70877 Mdot
.49321 .44624 Mdot
.50519 .4437 Mdot
.66723 .58049 Mdot
.39058 .54459 Mdot
.48221 .71707 Mdot
.53217 .4419 Mdot
.66445 .61295 Mdot
.4283 .48092 Mdot
.65487 .5233 Mdot
.38496 .57001 Mdot
.66469 .61451 Mdot
.51208 .4416 Mdot
.45752 .70768 Mdot
.42703 .48088 Mdot
.56758 .71947 Mdot
.54709 .72411 Mdot
.6017 .46191 Mdot
.42258 .48482 Mdot
.58735 .71224 Mdot
.45463 .45894 Mdot
.61879 .69293 Mdot
.60164 .46068 Mdot
.44986 .46132 Mdot
.44473 .46459 Mdot
.39535 .64302 Mdot
.39117 .53277 Mdot
.66361 .6279 Mdot
.51358 .7272 Mdot
.46743 .45057 Mdot
.65934 .52522 Mdot
.39516 .6455 Mdot
.49734 .72547 Mdot
.6429 .67009 Mdot
.38457 .54827 Mdot
.38324 .61499 Mdot
.38307 .55016 Mdot
.62133 .6951 Mdot
.48441 .44203 Mdot
.64159 .67436 Mdot
.64725 .49833 Mdot
.41287 .67802 Mdot
.67479 .57439 Mdot
.58462 .72051 Mdot
.6653 .52802 Mdot
.51033 .43429 Mdot
.66688 .5316 Mdot
.47514 .44196 Mdot
.55259 .73149 Mdot
.66435 .64408 Mdot
.45189 .45128 Mdot
.58727 .7216 Mdot
.38089 .5402 Mdot
.58699 .44383 Mdot
.66649 .64161 Mdot
.45036 .71488 Mdot
.67089 .5333 Mdot
.60224 .71575 Mdot
.46309 .44292 Mdot
.61638 .70763 Mdot
.61871 .46007 Mdot
.63024 .69654 Mdot
.51997 .42903 Mdot
.50541 .43031 Mdot
.67896 .56005 Mdot
.45342 .71924 Mdot
.38947 .51102 Mdot
.58295 .72721 Mdot
.61882 .70749 Mdot
.66762 .51864 Mdot
.51795 .42774 Mdot
.37953 .53134 Mdot
.64857 .68025 Mdot
.43948 .71295 Mdot
.55252 .4289 Mdot
.68103 .60569 Mdot
.67021 .6447 Mdot
.53231 .42627 Mdot
.3885 .65809 Mdot
.44517 .44841 Mdot
.55066 .73897 Mdot
.48952 .73754 Mdot
.67751 .63192 Mdot
.5377 .42438 Mdot
.65313 .48635 Mdot
.36697 .57605 Mdot
.6035 .72299 Mdot
.54947 .74118 Mdot
.40586 .68816 Mdot
.68305 .61531 Mdot
.36899 .61287 Mdot
.61969 .71323 Mdot
.54518 .74221 Mdot
.55916 .7402 Mdot
.60466 .72336 Mdot
.45771 .72847 Mdot
.6839 .61741 Mdot
.61235 .71948 Mdot
.37925 .6495 Mdot
.39455 .67638 Mdot
.64613 .69204 Mdot
.51534 .42087 Mdot
.66688 .5012 Mdot
.62216 .45158 Mdot
.45588 .43612 Mdot
.40549 .69288 Mdot
.68704 .61225 Mdot
.58121 .42911 Mdot
.37609 .64744 Mdot
.3652 .55388 Mdot
.63667 .70395 Mdot
.68338 .53583 Mdot
.51195 .7467 Mdot
.48164 .74118 Mdot
.68354 .63191 Mdot
.46273 .43054 Mdot
.47274 .73943 Mdot
.39905 .68897 Mdot
.44164 .44063 Mdot
.45411 .43391 Mdot
.36075 .57324 Mdot
.44337 .43917 Mdot
.54384 .41785 Mdot
.51521 .41698 Mdot
.46627 .73825 Mdot
.68842 .62158 Mdot
.49655 .4189 Mdot
.65846 .48084 Mdot
.62721 .71638 Mdot
.37931 .6633 Mdot
.67309 .66388 Mdot
.42776 .44716 Mdot
.37816 .66238 Mdot
.68722 .53106 Mdot
.69278 .61511 Mdot
.37511 .50572 Mdot
.45685 .73798 Mdot
.58709 .42444 Mdot
.66241 .48136 Mdot
.36186 .62622 Mdot
.48465 .74799 Mdot
.67198 .49389 Mdot
.37341 .50669 Mdot
.56279 .75003 Mdot
.58475 .74396 Mdot
.4142 .71271 Mdot
.38235 .48986 Mdot
.51595 .41181 Mdot
.51055 .41218 Mdot
.64544 .45948 Mdot
.55747 .41414 Mdot
.41107 .71086 Mdot
.68024 .50559 Mdot
.69715 .60634 Mdot
.51721 .756 Mdot
.68512 .65224 Mdot
.41774 .71807 Mdot
.69589 .54742 Mdot
.66875 .68182 Mdot
.42472 .72364 Mdot
.61608 .73152 Mdot
.56837 .41442 Mdot
.67863 .49935 Mdot
.6097 .43051 Mdot
.39483 .6969 Mdot
.43944 .73388 Mdot
.62451 .43926 Mdot
.36486 .64904 Mdot
.45828 .74367 Mdot
.56375 .41251 Mdot
.51894 .40848 Mdot
.55608 .4107 Mdot
.3646 .64985 Mdot
.43656 .73344 Mdot
.66959 .48191 Mdot
.69318 .52824 Mdot
.49269 .75555 Mdot
.60082 .42363 Mdot
.49521 .40971 Mdot
.64993 .7095 Mdot
.37656 .67721 Mdot
.40468 .71165 Mdot
.68961 .65222 Mdot
.50911 .75966 Mdot
.66286 .69665 Mdot
.37221 .49446 Mdot
.34909 .56502 Mdot
.70326 .60599 Mdot
.44913 .74391 Mdot
.41674 .44184 Mdot
.39218 .70111 Mdot
.67278 .68557 Mdot
.62191 .4317 Mdot
.55474 .40624 Mdot
.34814 .56455 Mdot
.59413 .41706 Mdot
.45245 .74715 Mdot
.57701 .4103 Mdot
.36268 .50783 Mdot
.69542 .52109 Mdot
.45507 .74856 Mdot
.41492 .44053 Mdot
.34986 .54329 Mdot
.47474 .40952 Mdot
.55486 .76183 Mdot
.34922 .5447 Mdot
.62033 .73786 Mdot
.56815 .75935 Mdot
.3685 .49241 Mdot
.48365 .76008 Mdot
.45838 .41352 Mdot
.39801 .45295 Mdot
.64718 .44544 Mdot
.34653 .54792 Mdot
.36831 .48946 Mdot
.358 .65669 Mdot
.70813 .61191 Mdot
.39398 .71163 Mdot
.7108 .57682 Mdot
.34234 .60006 Mdot
.45855 .75496 Mdot
.62518 .42676 Mdot
.37674 .47419 Mdot
.71122 .58605 Mdot
.70834 .55008 Mdot
.66538 .70499 Mdot
.7096 .60841 Mdot
.46796 .40736 Mdot
.34117 .59001 Mdot
.54752 .39886 Mdot
.37322 .47805 Mdot
.66463 .70713 Mdot
.41931 .43037 Mdot
.65252 .72064 Mdot
.5966 .75604 Mdot
.45594 .75606 Mdot
.34097 .55668 Mdot
.38747 .45727 Mdot
.35645 .66312 Mdot
.34071 .55381 Mdot
.37143 .47646 Mdot
.40707 .43708 Mdot
.35201 .51064 Mdot
.34542 .52901 Mdot
.43496 .41764 Mdot
.64773 .7278 Mdot
.62778 .74257 Mdot
.47353 .40128 Mdot
.5482 .39482 Mdot
.62673 .42226 Mdot
.40652 .72995 Mdot
.36961 .68975 Mdot
.34149 .6254 Mdot
.57722 .40021 Mdot
.34015 .62049 Mdot
.35333 .50464 Mdot
.35328 .66136 Mdot
.34841 .51609 Mdot
.67017 .45873 Mdot
.67788 .69879 Mdot
.3383 .6163 Mdot
.34544 .6449 Mdot
.6116 .41192 Mdot
.68296 .69274 Mdot
.6714 .70771 Mdot
.71223 .62825 Mdot
.70099 .5049 Mdot
.56358 .77093 Mdot
.71531 .61458 Mdot
.612 .41155 Mdot
.69317 .67736 Mdot
.42306 .42131 Mdot
.71745 .60371 Mdot
.57546 .397 Mdot
.64519 .7346 Mdot
.41897 .74316 Mdot
.66778 .71407 Mdot
.44927 .40618 Mdot
.57091 .77067 Mdot
.63656 .42463 Mdot
.34034 .53127 Mdot
.47225 .39763 Mdot
.55716 .39219 Mdot
.64 .73933 Mdot
.49947 .77456 Mdot
.63224 .74514 Mdot
.62829 .4178 Mdot
.69041 .47919 Mdot
.41005 .42744 Mdot
.63495 .42199 Mdot
.40824 .42849 Mdot
.53725 .38883 Mdot
.67938 .46275 Mdot
.71387 .53058 Mdot
.50285 .38956 Mdot
.4875 .77409 Mdot
.34574 .65669 Mdot
.41532 .42219 Mdot
.33584 .53822 Mdot
.43666 .75721 Mdot
.33388 .6199 Mdot
.53915 .77859 Mdot
.66355 .723 Mdot
.33106 .56468 Mdot
.55025 .77798 Mdot
.63208 .41743 Mdot
.67429 .4536 Mdot
.71408 .64143 Mdot
.5978 .76645 Mdot
.69522 .48173 Mdot
.33064 .55922 Mdot
.49875 .77839 Mdot
.38418 .44592 Mdot
.52928 .38555 Mdot
.48658 .38942 Mdot
.45521 .76785 Mdot
.38777 .72458 Mdot
.72216 .61558 Mdot
.35721 .47878 Mdot
.35293 .68009 Mdot
.69863 .68213 Mdot
.39186 .72955 Mdot
.51837 .38426 Mdot
.67506 .45093 Mdot
.69193 .69334 Mdot
.56025 .77935 Mdot
.50927 .38435 Mdot
.32927 .61375 Mdot
.33105 .62372 Mdot
.70729 .4991 Mdot
.45515 .76982 Mdot
.4499 .39797 Mdot
.63619 .4156 Mdot
.39053 .73035 Mdot
.32654 .5995 Mdot
.33194 .63211 Mdot
.32595 .59192 Mdot
.41276 .74857 Mdot
.72705 .58554 Mdot
.32772 .61348 Mdot
.43921 .7641 Mdot
.32546 .57556 Mdot
.69548 .69155 Mdot
.33618 .64833 Mdot
.71204 .66044 Mdot
.72585 .60951 Mdot
.32975 .53917 Mdot
.63515 .75256 Mdot
.44009 .40084 Mdot
.336 .64938 Mdot
.66927 .72567 Mdot
.32411 .58687 Mdot
.3331 .64294 Mdot
.72812 .60118 Mdot
.72533 .54463 Mdot
.72665 .55226 Mdot
.59459 .77386 Mdot
.63514 .41198 Mdot
.60344 .39545 Mdot
.59356 .77439 Mdot
.33228 .52356 Mdot
.32451 .60929 Mdot
.53599 .78645 Mdot
.48804 .38281 Mdot
.69358 .46648 Mdot
.47018 .38675 Mdot
.59562 .39101 Mdot
.61131 .76873 Mdot
.61025 .76942 Mdot
.64486 .74961 Mdot
.70697 .67962 Mdot
.55168 .7864 Mdot
.64773 .74815 Mdot
.67563 .72352 Mdot
.39104 .42889 Mdot
.32774 .63476 Mdot
.6816 .44862 Mdot
.44603 .77213 Mdot
.32154 .56494 Mdot
.45544 .39002 Mdot
.72824 .54442 Mdot
.71073 .49179 Mdot
.3446 .68037 Mdot
.48554 .78613 Mdot
.34214 .67807 Mdot
.67972 .44347 Mdot
.49284 .37808 Mdot
.53644 .79053 Mdot
.72854 .53497 Mdot
.70576 .68853 Mdot
.43559 .77043 Mdot
.31948 .608 Mdot
.4373 .39435 Mdot
.58437 .78354 Mdot
.52208 .79205 Mdot
.49308 .37626 Mdot
.45196 .38715 Mdot
.33685 .49358 Mdot
.36964 .72244 Mdot
.73266 .62152 Mdot
.72735 .64379 Mdot
.51573 .79294 Mdot
.31991 .62301 Mdot
.72843 .64096 Mdot
.31708 .56171 Mdot
.31968 .54277 Mdot
.31575 .58701 Mdot
.6353 .40277 Mdot
.67858 .72856 Mdot
.6408 .75995 Mdot
.66519 .42444 Mdot
.44994 .38649 Mdot
.37816 .43272 Mdot
.51108 .37233 Mdot
.58645 .78556 Mdot
.71063 .68647 Mdot
.4624 .38138 Mdot
.73736 .5688 Mdot
.35621 .45716 Mdot
.31763 .61906 Mdot
.64428 .75887 Mdot
.54476 .79407 Mdot
.72762 .64952 Mdot
.31461 .5696 Mdot
.43686 .39064 Mdot
.73856 .583 Mdot
.63808 .76356 Mdot
.71398 .68237 Mdot
.61303 .3891 Mdot
.36753 .44176 Mdot
.55446 .79369 Mdot
.72496 .50731 Mdot
.32908 .50323 Mdot
.38434 .74169 Mdot
.44713 .78074 Mdot
.7113 .47744 Mdot
.48904 .37319 Mdot
.59365 .78549 Mdot
.71645 .68006 Mdot
.33539 .4871 Mdot
.31261 .58758 Mdot
.67191 .42652 Mdot
.61971 .3906 Mdot
.7215 .67046 Mdot
.48205 .79229 Mdot
.31806 .53368 Mdot
.50975 .36963 Mdot
.34699 .46597 Mdot
.32069 .64297 Mdot
.72163 .67157 Mdot
.61519 .38769 Mdot
.61089 .38552 Mdot
.56969 .37258 Mdot
.38565 .74546 Mdot
.73845 .6177 Mdot
.74031 .60519 Mdot
.69513 .71642 Mdot
.4752 .37393 Mdot
.7354 .63402 Mdot
.68493 .43751 Mdot
.33174 .67513 Mdot
.37934 .42564 Mdot
.69332 .44708 Mdot
.54278 .7979 Mdot
.67337 .74114 Mdot
.48359 .37127 Mdot
.42166 .7722 Mdot
.40547 .76238 Mdot
.70704 .70219 Mdot
.63097 .77259 Mdot
.39809 .75779 Mdot
.73993 .54564 Mdot
.31098 .60964 Mdot
.73343 .64768 Mdot
.52964 .80004 Mdot
.3686 .43364 Mdot
.52544 .36579 Mdot
.71747 .68614 Mdot
.62376 .77731 Mdot
.44526 .38109 Mdot
.31692 .64228 Mdot
.30952 .56371 Mdot
.72173 .48692 Mdot
.33087 .67921 Mdot
.5177 .80075 Mdot
.68453 .43305 Mdot
.53774 .36519 Mdot
.64555 .76573 Mdot
.5927 .37506 Mdot
.69277 .72445 Mdot
.59144 .7916 Mdot
.61913 .78091 Mdot
.50582 .80068 Mdot
.58595 .3723 Mdot
.44328 .78592 Mdot
.74387 .55365 Mdot
.45654 .37481 Mdot
.59788 .37524 Mdot
.74263 .62193 Mdot
.31794 .65366 Mdot
.38759 .41211 Mdot
.71831 .47542 Mdot
.49279 .80057 Mdot
.66748 .75196 Mdot
.31443 .5217 Mdot
.47853 .36737 Mdot
.36065 .72923 Mdot
.73187 .50185 Mdot
.643 .77073 Mdot
.36352 .73267 Mdot
.72131 .47875 Mdot
.74125 .63493 Mdot
.41505 .77414 Mdot
.32409 .67263 Mdot
.43002 .38385 Mdot
.6983 .4437 Mdot
.52 .36175 Mdot
.40661 .39663 Mdot
.74768 .57489 Mdot
.73485 .65832 Mdot
.71638 .46867 Mdot
.56133 .36386 Mdot
.37327 .42205 Mdot
.74818 .59824 Mdot
.56973 .80115 Mdot
.51022 .36059 Mdot
.4783 .80083 Mdot
.32797 .48074 Mdot
.52237 .35989 Mdot
.73694 .6569 Mdot
.52455 .8063 Mdot
.71594 .46499 Mdot
.63271 .77952 Mdot
.46028 .36938 Mdot
.46268 .79742 Mdot
.54285 .35997 Mdot
.73046 .67447 Mdot
.54128 .80645 Mdot
.32684 .68491 Mdot
.7124 .45829 Mdot
.42931 .78517 Mdot
.57433 .36392 Mdot
.51661 .80713 Mdot
.50393 .35967 Mdot
.67818 .41764 Mdot
.59412 .79711 Mdot
.71179 .45635 Mdot
.7401 .65209 Mdot
.3119 .65062 Mdot
.30266 .60613 Mdot
.30494 .62328 Mdot
.72977 .48677 Mdot
.73545 .49912 Mdot
.30267 .6131 Mdot
.60253 .79556 Mdot
.71907 .46529 Mdot
.73039 .68035 Mdot
.70762 .44786 Mdot
.69802 .73021 Mdot
.35526 .73103 Mdot
.59626 .36785 Mdot
.74972 .54705 Mdot
.67053 .75741 Mdot
.46769 .3644 Mdot
.34941 .44176 Mdot
.3493 .72416 Mdot
.3198 .49006 Mdot
.42691 .37931 Mdot
.4918 .35899 Mdot
.3978 .76974 Mdot
.75242 .56271 Mdot
.66799 .40542 Mdot
.47662 .36116 Mdot
.36607 .74455 Mdot
.34698 .4429 Mdot
.3129 .66336 Mdot
.31256 .66316 Mdot
.73294 .48601 Mdot
.69451 .73762 Mdot
.54807 .81044 Mdot
.73744 .49562 Mdot
.64922 .39036 Mdot
.29792 .5922 Mdot
.45926 .80151 Mdot
.56973 .80752 Mdot
.34637 .44168 Mdot
.30431 .52703 Mdot
.29763 .59467 Mdot
.74444 .65259 Mdot
.71321 .45048 Mdot
.6665 .40178 Mdot
.74653 .64636 Mdot
.523 .35375 Mdot
.30421 .52496 Mdot
.74897 .52705 Mdot
.32607 .69568 Mdot
.74279 .50586 Mdot
.32328 .69109 Mdot
.47955 .80837 Mdot
.736 .67786 Mdot
.60473 .36658 Mdot
.41286 .78347 Mdot
.43103 .37315 Mdot
.52371 .81349 Mdot
.41249 .38236 Mdot
.42434 .79003 Mdot
.50235 .35348 Mdot
.56133 .81116 Mdot
.29545 .57747 Mdot
.51287 .81355 Mdot
.49272 .35448 Mdot
.35913 .74261 Mdot
.29553 .56997 Mdot
.73641 .48624 Mdot
.58569 .35942 Mdot
.68017 .75609 Mdot
.38891 .76949 Mdot
.35847 .74307 Mdot
.54191 .35156 Mdot
.29653 .55051 Mdot
.30893 .50158 Mdot
.38965 .39511 Mdot
.63686 .37864 Mdot
.51706 .35058 Mdot
.66692 .39769 Mdot
.39592 .39033 Mdot
.30982 .49767 Mdot
.38611 .76883 Mdot
.71582 .44766 Mdot
.57599 .35542 Mdot
.38906 .39475 Mdot
.3899 .39409 Mdot
.60608 .80211 Mdot
.29631 .5431 Mdot
.74905 .65306 Mdot
.42966 .37024 Mdot
.67809 .76074 Mdot
.29488 .61615 Mdot
.74059 .4892 Mdot
.36462 .41389 Mdot
.38198 .7672 Mdot
.38246 .76769 Mdot
.72313 .70983 Mdot
.40672 .38158 Mdot
.64146 .78705 Mdot
.6969 .74372 Mdot
.62714 .37098 Mdot
.61032 .80231 Mdot
.29826 .5263 Mdot
.67073 .76842 Mdot
.56753 .81456 Mdot
.7597 .55304 Mdot
.29985 .51788 Mdot
.68221 .75969 Mdot
.29479 .53819 Mdot
.29439 .62653 Mdot
.3022 .657 Mdot
.48065 .35136 Mdot
.3083 .49209 Mdot
.65324 .38382 Mdot
.39816 .38453 Mdot
.36102 .4141 Mdot
.61457 .80258 Mdot
.35507 .74644 Mdot
.36271 .7543 Mdot
.63724 .37369 Mdot
.71579 .72533 Mdot
.404 .78605 Mdot
.76334 .58573 Mdot
.67797 .76548 Mdot
.43403 .8017 Mdot
.63337 .79486 Mdot
.70826 .43049 Mdot
.6472 .78765 Mdot
.7315 .46279 Mdot
.67236 .39521 Mdot
.39755 .38266 Mdot
.69293 .75323 Mdot
.74745 .49417 Mdot
.65936 .38525 Mdot
.60695 .3585 Mdot
.2954 .64368 Mdot
.40012 .38027 Mdot
.29107 .54178 Mdot
.60157 .80977 Mdot
.65803 .3836 Mdot
.33749 .43639 Mdot
.56592 .34719 Mdot
.50612 .8213 Mdot
.76141 .62711 Mdot
.761 .5365 Mdot
.46541 .81454 Mdot
.59123 .81347 Mdot
.3072 .48612 Mdot
.74582 .67961 Mdot
.57101 .8188 Mdot
.32049 .45931 Mdot
.66367 .38604 Mdot
.33126 .4429 Mdot
.54652 .34366 Mdot
.76662 .58696 Mdot
.76287 .62611 Mdot
.35975 .40948 Mdot
.52618 .82374 Mdot
.29315 .52277 Mdot
.33378 .43824 Mdot
.76723 .57772 Mdot
.39237 .78345 Mdot
.71161 .73727 Mdot
.67834 .39557 Mdot
.47834 .81966 Mdot
.68045 .39715 Mdot
.47345 .81863 Mdot
.30294 .67499 Mdot
.76725 .6015 Mdot
.29708 .50587 Mdot
.74856 .48759 Mdot
.76109 .64183 Mdot
.45946 .35014 Mdot
.32668 .72032 Mdot
.76434 .62841 Mdot
.34622 .74518 Mdot
.76806 .59964 Mdot
.40472 .37318 Mdot
.76878 .58911 Mdot
.57218 .34479 Mdot
.29198 .64587 Mdot
.369 .3983 Mdot
.66135 .78459 Mdot
.70722 .74479 Mdot
.52451 .8258 Mdot
.37043 .76922 Mdot
.75684 .50647 Mdot
.30952 .69269 Mdot
.42683 .36127 Mdot
.76629 .62137 Mdot
.32833 .72425 Mdot
.3317 .43701 Mdot
.33462 .4332 Mdot
.70122 .41382 Mdot
.33661 .73553 Mdot
.7066 .41946 Mdot
.53134 .3396 Mdot
.30707 .68892 Mdot
.61812 .35743 Mdot
.62333 .3596 Mdot
.76882 .55989 Mdot
.60456 .3522 Mdot
.59119 .34792 Mdot
.75025 .67968 Mdot
.42286 .36176 Mdot
.66854 .38438 Mdot
.75623 .49985 Mdot
.59545 .34843 Mdot
.29251 .51098 Mdot
.3697 .39496 Mdot
.4261 .80632 Mdot
.61067 .35323 Mdot
.55483 .82627 Mdot
.73476 .45409 Mdot
.28319 .61444 Mdot
.29964 .48961 Mdot
.48886 .34056 Mdot
.45503 .81778 Mdot
.77168 .59011 Mdot
.61348 .81258 Mdot
.49532 .82668 Mdot
.52227 .82866 Mdot
.31764 .45318 Mdot
.72271 .43516 Mdot
.28032 .57786 Mdot
.71322 .74298 Mdot
.60625 .81569 Mdot
.56066 .33912 Mdot
.6699 .38288 Mdot
.5828 .3432 Mdot
.46008 .34566 Mdot
.38738 .37949 Mdot
.38623 .38006 Mdot
.59222 .82067 Mdot
.46562 .34395 Mdot
.32339 .44268 Mdot
.5238 .82972 Mdot
.4525 .81855 Mdot
.76161 .65756 Mdot
.58828 .34404 Mdot
.58882 .82188 Mdot
.28417 .6317 Mdot
.55207 .82863 Mdot
.7462 .47058 Mdot
.60747 .34966 Mdot
.38029 .78237 Mdot
.61859 .81233 Mdot
.3046 .47361 Mdot
.64111 .8021 Mdot
.42175 .80722 Mdot
.77357 .59193 Mdot
.7171 .42527 Mdot
.75157 .48032 Mdot
.30254 .47698 Mdot
.33916 .42083 Mdot
.59374 .3446 Mdot
.3874 .37779 Mdot
.56965 .82699 Mdot
.55663 .33697 Mdot
.29526 .67316 Mdot
.68511 .39251 Mdot
.27955 .55759 Mdot
.44486 .34868 Mdot
.27826 .57567 Mdot
.69107 .76872 Mdot
.57014 .33859 Mdot
.5242 .83138 Mdot
.43787 .81539 Mdot
.64879 .79956 Mdot
.60801 .81834 Mdot
.27736 .57341 Mdot
.4914 .33615 Mdot
.77157 .53826 Mdot
.4242 .35539 Mdot
.36615 .77438 Mdot
.71536 .74594 Mdot
.60402 .82021 Mdot
.76881 .64233 Mdot
.44062 .34845 Mdot
.38916 .37425 Mdot
.27697 .56761 Mdot
.40766 .80297 Mdot
.47091 .82672 Mdot
.46891 .82629 Mdot
.51043 .33345 Mdot
.74335 .45882 Mdot
.72153 .73935 Mdot
.44921 .34488 Mdot
.77515 .55581 Mdot
.77678 .58029 Mdot
.29665 .68326 Mdot
.28408 .64787 Mdot
.53009 .33221 Mdot
.62755 .81273 Mdot
.31685 .72154 Mdot
.56898 .33555 Mdot
.29435 .6794 Mdot
.27765 .54741 Mdot
.29805 .47785 Mdot
.77763 .5861 Mdot
.39245 .37021 Mdot
.30164 .69595 Mdot
.59365 .82532 Mdot
.41613 .80926 Mdot
.28109 .64009 Mdot
.27503 .56715 Mdot
.45588 .34129 Mdot
.52415 .33125 Mdot
.75985 .67724 Mdot
.48779 .83199 Mdot
.58592 .8278 Mdot
.36375 .39049 Mdot
.30375 .46447 Mdot
.28345 .51504 Mdot
.70289 .4029 Mdot
.3774 .37934 Mdot
.69667 .39678 Mdot
.65865 .3679 Mdot
.55916 .33258 Mdot
.48595 .33311 Mdot
.29425 .6842 Mdot
.65461 .36476 Mdot
.36665 .77961 Mdot
.37576 .37917 Mdot
.61748 .81949 Mdot
.27297 .57467 Mdot
.53987 .83623 Mdot
.35051 .76589 Mdot
.72842 .73632 Mdot
.37212 .78451 Mdot
.69341 .77395 Mdot
.36199 .38954 Mdot
.39281 .79902 Mdot
.45883 .33817 Mdot
.72462 .42428 Mdot
.34302 .40703 Mdot
.76331 .49139 Mdot
.77198 .64813 Mdot
.52271 .83735 Mdot
.55782 .33049 Mdot
.27741 .52987 Mdot
.27248 .60314 Mdot
.76692 .66658 Mdot
.41797 .81365 Mdot
.75688 .47451 Mdot
.5732 .33236 Mdot
.27364 .61804 Mdot
.27821 .52319 Mdot
.3076 .71483 Mdot
.28799 .67475 Mdot
.77845 .54258 Mdot
.29739 .69628 Mdot
.78025 .55536 Mdot
.2754 .63126 Mdot
.30325 .70783 Mdot
.53775 .83845 Mdot
.7772 .63252 Mdot
.7655 .67355 Mdot
.60483 .82644 Mdot
.32662 .74297 Mdot
.7571 .69348 Mdot
.74794 .71089 Mdot
.27311 .54558 Mdot
.77968 .61916 Mdot
.72923 .42697 Mdot
.27337 .62337 Mdot
.38731 .79826 Mdot
.27074 .6026 Mdot
.44524 .82621 Mdot
.77931 .62441 Mdot
.78149 .5572 Mdot
.53407 .83947 Mdot
.37162 .78774 Mdot
.31499 .72863 Mdot
.64587 .35595 Mdot
.59638 .82991 Mdot
.78097 .55063 Mdot
.64852 .80896 Mdot
.77458 .51705 Mdot
.61506 .3419 Mdot
.39072 .80143 Mdot
.78204 .55644 Mdot
.3055 .45122 Mdot
.68697 .38208 Mdot
.33882 .40679 Mdot
.70889 .40158 Mdot
.30439 .71373 Mdot
.72915 .42429 Mdot
.38928 .80113 Mdot
.78188 .61589 Mdot
.69624 .77683 Mdot
.32729 .41904 Mdot
.78143 .54499 Mdot
.72463 .74797 Mdot
.59988 .33543 Mdot
.30991 .72416 Mdot
.63099 .81922 Mdot
.55045 .84029 Mdot
.73762 .73176 Mdot
.77573 .6506 Mdot
.67675 .3727 Mdot
.66288 .80272 Mdot
.76588 .48496 Mdot
.70516 .39578 Mdot
.55867 .83995 Mdot
.76187 .47536 Mdot
.4835 .32738 Mdot
.31694 .43016 Mdot
.77297 .50283 Mdot
.65235 .35626 Mdot
.26703 .57151 Mdot
.49812 .32487 Mdot
.77315 .50213 Mdot
.78468 .61014 Mdot
.74162 .43761 Mdot
.77907 .64321 Mdot
.78439 .55209 Mdot
.53869 .32318 Mdot
.29167 .69556 Mdot
.38895 .80404 Mdot
.30106 .45257 Mdot
.57176 .32669 Mdot
.78657 .59108 Mdot
.78253 .53607 Mdot
.26599 .59429 Mdot
.44742 .83139 Mdot
.27862 .66416 Mdot
.31362 .73379 Mdot
.78463 .61913 Mdot
.4099 .34947 Mdot
.33856 .76444 Mdot
.65371 .81088 Mdot
.76348 .47388 Mdot
.44513 .83118 Mdot
.7369 .73746 Mdot
.28974 .47218 Mdot
.32754 .41327 Mdot
.78431 .54101 Mdot
.28559 .4808 Mdot
.63926 .34692 Mdot
.3918 .80762 Mdot
.52523 .32117 Mdot
.4188 .82179 Mdot
.42353 .82423 Mdot
.31621 .42588 Mdot
.77322 .67198 Mdot
.71977 .40563 Mdot
.45284 .83505 Mdot
.58403 .32687 Mdot
.6985 .38475 Mdot
.60556 .33262 Mdot
.51352 .32067 Mdot
.27328 .51247 Mdot
.33 .4081 Mdot
.78939 .57943 Mdot
.63388 .82326 Mdot
.38786 .80699 Mdot
.3587 .78611 Mdot
.69271 .37889 Mdot
.53355 .84636 Mdot
.26285 .57763 Mdot
.53289 .84645 Mdot
.66829 .80512 Mdot
.49194 .32149 Mdot
.65553 .35267 Mdot
.34465 .7751 Mdot
.63588 .34233 Mdot
.48627 .84443 Mdot
.61244 .83316 Mdot
.79063 .5942 Mdot
.5443 .84698 Mdot
.38513 .35923 Mdot
.30292 .44104 Mdot
.28521 .69224 Mdot
.78751 .53949 Mdot
.26814 .52314 Mdot
.41476 .34259 Mdot
.27595 .49597 Mdot
.78759 .62786 Mdot
.412 .34375 Mdot
.72136 .76265 Mdot
.55151 .84699 Mdot
.26231 .55639 Mdot
.61406 .83342 Mdot
.34797 .38651 Mdot
.52632 .31763 Mdot
.7693 .47633 Mdot
.26178 .56044 Mdot
.26271 .55117 Mdot
.71415 .39516 Mdot
.27027 .65423 Mdot
.4005 .8171 Mdot
.4324 .33436 Mdot
.30213 .43973 Mdot
.75669 .44992 Mdot
.29331 .71153 Mdot
.45221 .8386 Mdot
.59993 .83873 Mdot
.62008 .33394 Mdot
.77842 .4977 Mdot
.792 .56709 Mdot
.76574 .69933 Mdot
.66956 .80749 Mdot
.26455 .63268 Mdot
.50661 .31725 Mdot
.47644 .84488 Mdot
.38532 .35669 Mdot
.75564 .71923 Mdot
.37841 .36098 Mdot
.35872 .37533 Mdot
.49048 .31855 Mdot
.29045 .45811 Mdot
.40747 .82205 Mdot
.25984 .60365 Mdot
.43177 .333 Mdot
.25932 .56981 Mdot
.49729 .31725 Mdot
.67461 .36056 Mdot
.62019 .83338 Mdot
.69526 .79034 Mdot
.73212 .4122 Mdot
.48841 .31823 Mdot
.51654 .85041 Mdot
.78323 .50792 Mdot
.38166 .35753 Mdot
.74523 .42837 Mdot
.27262 .4961 Mdot
.7943 .57263 Mdot
.33915 .77517 Mdot
.7578 .71857 Mdot
.26339 .63653 Mdot
.43162 .33192 Mdot
.71622 .39341 Mdot
.79476 .57883 Mdot
.55051 .85045 Mdot
.75596 .44346 Mdot
.7768 .48537 Mdot
.72965 .75902 Mdot
.26371 .52462 Mdot
.29772 .44117 Mdot
.79483 .56712 Mdot
.54396 .85146 Mdot
.28134 .69429 Mdot
.27591 .68185 Mdot
.36277 .36916 Mdot
.59468 .32258 Mdot
.26196 .53098 Mdot
.62687 .83298 Mdot
.4491 .84147 Mdot
.39827 .82049 Mdot
.76296 .71259 Mdot
.36455 .79899 Mdot
.46808 .84659 Mdot
.27469 .48471 Mdot
.33038 .76899 Mdot
.29176 .71705 Mdot
.73656 .75266 Mdot
.41446 .82907 Mdot
.76549 .70886 Mdot
.75641 .44116 Mdot
.39669 .82027 Mdot
.31532 .7521 Mdot
.33419 .39251 Mdot
.74293 .74507 Mdot
.32551 .7644 Mdot
.44072 .83993 Mdot
.41232 .82878 Mdot
.28337 .70303 Mdot
.27607 .47889 Mdot
.28187 .4659 Mdot
.67211 .3545 Mdot
.51207 .85377 Mdot
.39036 .34838 Mdot
.71925 .77396 Mdot
.65165 .82385 Mdot
.77885 .48332 Mdot
.29974 .433 Mdot
.62317 .32903 Mdot
.70113 .37463 Mdot
.25916 .53164 Mdot
.46959 .8491 Mdot
.25436 .56981 Mdot
.68578 .80402 Mdot
.42661 .32923 Mdot
.68332 .80592 Mdot
.28759 .71489 Mdot
.76579 .45241 Mdot
.4652 .31702 Mdot
.25778 .53384 Mdot
.72078 .39143 Mdot
.29221 .72354 Mdot
.77632 .47332 Mdot
.28415 .70918 Mdot
.73799 .75549 Mdot
.57507 .31428 Mdot
.73935 .75399 Mdot
.30462 .7428 Mdot
.35207 .37243 Mdot
.72961 .76568 Mdot
.78172 .48556 Mdot
.79563 .63034 Mdot
.62712 .32878 Mdot
.78135 .68187 Mdot
.25298 .59463 Mdot
.54878 .85567 Mdot
.2652 .66473 Mdot
.28102 .46172 Mdot
.26128 .51481 Mdot
.73655 .75828 Mdot
.60682 .84467 Mdot
.70692 .78879 Mdot
.538 .30944 Mdot
.7506 .42585 Mdot
.34324 .37922 Mdot
.42932 .32669 Mdot
.71175 .78508 Mdot
.63444 .83511 Mdot
.61968 .32503 Mdot
.26105 .51284 Mdot
.42342 .83751 Mdot
.25805 .64137 Mdot
.26315 .50478 Mdot
.37624 .35303 Mdot
.57926 .85257 Mdot
.25407 .62057 Mdot
.40671 .3355 Mdot
.52143 .30817 Mdot
.40072 .33845 Mdot
.55141 .85696 Mdot
.75475 .73634 Mdot
.55173 .85707 Mdot
.28416 .71399 Mdot
.63344 .83669 Mdot
.69233 .80295 Mdot
.72688 .39402 Mdot
.76149 .43902 Mdot
.25164 .55815 Mdot
.44204 .3204 Mdot
.78034 .6908 Mdot
.29814 .73863 Mdot
.69308 .80314 Mdot
.70032 .79768 Mdot
.49564 .30822 Mdot
.70399 .79485 Mdot
.28185 .45374 Mdot
.42134 .83884 Mdot
.76399 .72448 Mdot
.42493 .32562 Mdot
.77491 .4616 Mdot
.55148 .30744 Mdot
.77129 .45415 Mdot
.37498 .35109 Mdot
.74789 .7492 Mdot
.53587 .85992 Mdot
.29911 .42439 Mdot
.6679 .82121 Mdot
.72563 .39047 Mdot
.7317 .7691 Mdot
.79566 .51718 Mdot
.71922 .78218 Mdot
.56063 .30779 Mdot
.25236 .62804 Mdot
.33853 .7875 Mdot
.42179 .32536 Mdot
.67439 .34761 Mdot
.80442 .58349 Mdot
.26689 .48254 Mdot
.4298 .84394 Mdot
.79605 .65125 Mdot
.3791 .34644 Mdot
.79757 .51871 Mdot
.79685 .65045 Mdot
.24893 .55427 Mdot
.34702 .36891 Mdot
.27655 .45799 Mdot
.57151 .30738 Mdot
.70696 .79606 Mdot
.25466 .64852 Mdot
.25332 .643 Mdot
.7404 .76299 Mdot
.79942 .64383 Mdot
.77199 .71705 Mdot
.24812 .61389 Mdot
.40403 .33116 Mdot
.5119 .30323 Mdot
.32802 .38501 Mdot
.28518 .72589 Mdot
.28194 .72046 Mdot
.56921 .86008 Mdot
.36184 .35591 Mdot
.60617 .31423 Mdot
.75511 .4208 Mdot
.40665 .32931 Mdot
.54761 .30323 Mdot
.75386 .74718 Mdot
.4046 .83586 Mdot
.34647 .79878 Mdot
.26086 .67533 Mdot
.35091 .80278 Mdot
.24691 .61567 Mdot
.64866 .83631 Mdot
.70732 .36769 Mdot
.80687 .60347 Mdot
.31079 .76384 Mdot
.43714 .84995 Mdot
.58069 .85915 Mdot
.75965 .74045 Mdot
.2492 .53337 Mdot
.53247 .86452 Mdot
.76966 .44135 Mdot
.54404 .30196 Mdot
.40519 .83727 Mdot
.80552 .54507 Mdot
.38155 .82483 Mdot
.43077 .31779 Mdot
.29762 .4181 Mdot
.79124 .67945 Mdot
.7049 .80121 Mdot
.37963 .34216 Mdot
.38149 .34102 Mdot
.29956 .41532 Mdot
.67681 .82159 Mdot
.39657 .83351 Mdot
.8078 .60127 Mdot
.74493 .40466 Mdot
.62976 .32043 Mdot
.7068 .79999 Mdot
.69541 .35692 Mdot
.54363 .86494 Mdot
.2701 .70202 Mdot
.2545 .50589 Mdot
.33271 .37713 Mdot
.26457 .69027 Mdot
.67912 .34494 Mdot
.24743 .53512 Mdot
.62852 .31915 Mdot
.45698 .30865 Mdot
.80932 .58036 Mdot
.26414 .47616 Mdot
.24306 .57819 Mdot
.61931 .31519 Mdot
.31484 .39412 Mdot
.75194 .75485 Mdot
.46315 .85953 Mdot
.54067 .86631 Mdot
.73903 .7707 Mdot
.3833 .33773 Mdot
.81022 .58416 Mdot
.77712 .71623 Mdot
.7942 .67735 Mdot
.53571 .29913 Mdot
.35554 .81003 Mdot
.58561 .30517 Mdot
.58285 .8615 Mdot
.3588 .81259 Mdot
.75894 .74643 Mdot
.8092 .61155 Mdot
.35975 .8135 Mdot
.35519 .81019 Mdot
.24437 .62047 Mdot
.80762 .62501 Mdot
.42175 .31845 Mdot
.31154 .76963 Mdot
.80229 .51368 Mdot
.41706 .32024 Mdot
.42344 .31766 Mdot
.77295 .72512 Mdot
.58583 .30464 Mdot
.2469 .52837 Mdot
.24687 .52835 Mdot
.3334 .7925 Mdot
.78869 .69366 Mdot
.73457 .38872 Mdot
.76543 .42818 Mdot
.78151 .45635 Mdot
.73245 .77974 Mdot
.77102 .72946 Mdot
.56967 .30112 Mdot
.7894 .47288 Mdot
.45373 .30715 Mdot
.35983 .81468 Mdot
.24249 .61243 Mdot
.2592 .48265 Mdot
.7731 .43975 Mdot
.80689 .53056 Mdot
.54872 .29833 Mdot
.28683 .73861 Mdot
.49714 .29885 Mdot
.61108 .85579 Mdot
.24351 .62404 Mdot
.28738 .42623 Mdot
.37079 .34317 Mdot
.46449 .30392 Mdot
.32144 .78248 Mdot
.27737 .44221 Mdot
.28304 .43236 Mdot
.74128 .39414 Mdot
.40353 .84163 Mdot
.31398 .39072 Mdot
.76516 .4249 Mdot
.25854 .68483 Mdot
.37097 .82381 Mdot
.76045 .74824 Mdot
.54412 .86909 Mdot
.72225 .37364 Mdot
.74367 .39591 Mdot
.74606 .39846 Mdot
.36002 .81706 Mdot
.32435 .37892 Mdot
.81103 .54569 Mdot
.60841 .8582 Mdot
.25142 .66636 Mdot
.3319 .79447 Mdot
.81354 .58274 Mdot
.32638 .78929 Mdot
.80991 .62879 Mdot
.76795 .42753 Mdot
.76901 .73711 Mdot
.34739 .80813 Mdot
.3884 .33066 Mdot
.26053 .6929 Mdot
.55362 .86934 Mdot
.5569 .29698 Mdot
.2562 .68222 Mdot
.51304 .87048 Mdot
.42054 .85069 Mdot
.23932 .60532 Mdot
.32827 .37402 Mdot
.8137 .56532 Mdot
.27431 .44366 Mdot
.76606 .74261 Mdot
.76061 .75084 Mdot
.76617 .74312 Mdot
.44334 .85923 Mdot
.62943 .31357 Mdot
.44474 .30615 Mdot
.69277 .34704 Mdot
.51285 .29452 Mdot
.56452 .29674 Mdot
.55572 .29568 Mdot
.43615 .3086 Mdot
.74898 .39882 Mdot
.484 .86892 Mdot
.78465 .71261 Mdot
.35194 .81384 Mdot
.31204 .38845 Mdot
.514 .87222 Mdot
.25296 .48764 Mdot
.28592 .74451 Mdot
.69048 .34423 Mdot
.41545 .31523 Mdot
.36919 .33944 Mdot
.55426 .29448 Mdot
.73706 .78214 Mdot
.25681 .47584 Mdot
.5721 .86948 Mdot
.74902 .39702 Mdot
.51038 .29326 Mdot
.25771 .47306 Mdot
.64544 .84782 Mdot
.24648 .66084 Mdot
.28852 .41608 Mdot
.71855 .36514 Mdot
.81507 .61525 Mdot
.76827 .42195 Mdot
.25736 .69334 Mdot
.81267 .63321 Mdot
.582 .29764 Mdot
.77819 .43776 Mdot
.47673 .86962 Mdot
.28944 .41409 Mdot
.80545 .66524 Mdot
.80255 .49081 Mdot
.765 .41583 Mdot
.23543 .56419 Mdot
.54373 .29197 Mdot
.5895 .29836 Mdot
.26371 .45622 Mdot
.49844 .87329 Mdot
.75456 .4015 Mdot
.3564 .82017 Mdot
.24223 .51644 Mdot
.57667 .29558 Mdot
.81522 .62436 Mdot
.26735 .71778 Mdot
.81815 .5762 Mdot
.79966 .68556 Mdot
.70473 .35159 Mdot
.28688 .75065 Mdot
.80518 .49551 Mdot
.51267 .29092 Mdot
.24573 .66547 Mdot
.32752 .36847 Mdot
.31999 .37564 Mdot
.76821 .7476 Mdot
.49746 .8742 Mdot
.23692 .62663 Mdot
.27711 .73675 Mdot
.47658 .29442 Mdot
.81864 .60041 Mdot
.5198 .29021 Mdot
.37065 .83112 Mdot
.26314 .71166 Mdot
.71809 .80441 Mdot
.79665 .46987 Mdot
.23777 .6352 Mdot
.44493 .30131 Mdot
.381 .32829 Mdot
.37219 .33352 Mdot
.59322 .86855 Mdot
.34414 .3531 Mdot
.43536 .86193 Mdot
.42291 .30847 Mdot
.79249 .45961 Mdot
.23289 .57351 Mdot
.67482 .83624 Mdot
.41198 .85348 Mdot
.80773 .66683 Mdot
.24061 .651 Mdot
.57619 .87244 Mdot
.56964 .29251 Mdot
.72566 .36731 Mdot
.81835 .55169 Mdot
.79366 .70473 Mdot
.81975 .56929 Mdot
.32725 .79911 Mdot
.34837 .81682 Mdot
.24557 .66985 Mdot
.61204 .30189 Mdot
.63585 .85578 Mdot
.81949 .56193 Mdot
.30981 .38402 Mdot
.474 .87247 Mdot
.26606 .72012 Mdot
.60995 .30092 Mdot
.41505 .31061 Mdot
.65841 .31993 Mdot
.27554 .42872 Mdot
.55894 .87573 Mdot
.78051 .43412 Mdot
.23467 .54109 Mdot
.81649 .63402 Mdot
.23753 .64173 Mdot
.23163 .57543 Mdot
.3855 .84207 Mdot
.75421 .77018 Mdot
.31113 .78478 Mdot
.54474 .87747 Mdot
.39679 .31789 Mdot
.79437 .7063 Mdot
.32987 .36278 Mdot
.49872 .28919 Mdot
.57341 .29169 Mdot
.81869 .62309 Mdot
.69006 .82854 Mdot
.77377 .74389 Mdot
.65862 .84688 Mdot
.34643 .34892 Mdot
.77894 .43017 Mdot
.82081 .60464 Mdot
.50407 .87764 Mdot
.38134 .84049 Mdot
.73314 .79412 Mdot
.23457 .63051 Mdot
.68467 .33345 Mdot
.32176 .36961 Mdot
.81914 .54176 Mdot
.31294 .3782 Mdot
.61631 .86482 Mdot
.47704 .29118 Mdot
.60307 .86884 Mdot
.41294 .85652 Mdot
.2912 .40299 Mdot
.25138 .69314 Mdot
.24732 .68259 Mdot
.26736 .72695 Mdot
.79845 .46585 Mdot
.80831 .67404 Mdot
.79184 .71459 Mdot
.72944 .36722 Mdot
.75736 .76876 Mdot
.79306 .45356 Mdot
.25463 .70204 Mdot
.63037 .86105 Mdot
.80912 .6733 Mdot
.5984 .87108 Mdot
.24742 .48096 Mdot
.43252 .86482 Mdot
.23327 .63163 Mdot
.59433 .87217 Mdot
.27134 .43054 Mdot
.23271 .53739 Mdot
.28169 .75171 Mdot
.82346 .58598 Mdot
.25601 .45948 Mdot
.23546 .64434 Mdot
.81498 .51217 Mdot
.31777 .79489 Mdot
.22997 .55913 Mdot
.73858 .37484 Mdot
.24921 .69094 Mdot
.78414 .43477 Mdot
.3233 .36562 Mdot
.24409 .48891 Mdot
.80766 .67976 Mdot
.7222 .35902 Mdot
.79028 .72054 Mdot
.73328 .36909 Mdot
.79433 .71253 Mdot
.23673 .65233 Mdot
.70219 .82333 Mdot
.25626 .70881 Mdot
.29292 .76823 Mdot
.71404 .81471 Mdot
.78062 .4271 Mdot
.55149 .28567 Mdot
.52747 .88146 Mdot
.37197 .32751 Mdot
.71745 .81227 Mdot
.79818 .45962 Mdot
.8029 .47055 Mdot
.74806 .78301 Mdot
.57774 .8772 Mdot
.75911 .77017 Mdot
.70516 .82229 Mdot
.33252 .35554 Mdot
.7372 .79475 Mdot
.6769 .32448 Mdot
.80433 .47228 Mdot
.24455 .48205 Mdot
.79774 .70932 Mdot
.80867 .68301 Mdot
.73458 .79832 Mdot
.22703 .59668 Mdot
.31366 .7941 Mdot
.59966 .29247 Mdot
.82536 .5638 Mdot
.82085 .63835 Mdot
.81398 .49888 Mdot
.82563 .56497 Mdot
.62582 .30013 Mdot
.23289 .52068 Mdot
.40783 .85859 Mdot
.82511 .61051 Mdot
.56597 .88047 Mdot
.22944 .62755 Mdot
.36914 .32716 Mdot
.80317 .69921 Mdot
.75953 .77227 Mdot
.40607 .30775 Mdot
.81941 .51739 Mdot
.56203 .28468 Mdot
.74117 .37296 Mdot
.76701 .76299 Mdot
.41611 .86268 Mdot
.45928 .87611 Mdot
.72808 .36004 Mdot
.39283 .85255 Mdot
.40066 .85637 Mdot
.82705 .59423 Mdot
.32671 .3577 Mdot
.71381 .81846 Mdot
.76685 .76397 Mdot
.36457 .83694 Mdot
.78848 .73104 Mdot
.60532 .87357 Mdot
.30927 .37426 Mdot
.22726 .54752 Mdot
.52465 .28181 Mdot
.2502 .46243 Mdot
.82631 .55545 Mdot
.68377 .32616 Mdot
.23655 .50013 Mdot
.22493 .57891 Mdot
.47598 .88018 Mdot
.66782 .31687 Mdot
.22722 .54523 Mdot
.29934 .38461 Mdot
.24573 .6933 Mdot
.28188 .75953 Mdot
.2248 .58734 Mdot
.59034 .87773 Mdot
.28059 .40772 Mdot
.82773 .56561 Mdot
.46759 .28678 Mdot
.56653 .88234 Mdot
.32494 .8082 Mdot
.58581 .28685 Mdot
.31655 .36553 Mdot
.2295 .526 Mdot
.68145 .84239 Mdot
.24204 .48023 Mdot
.78199 .74433 Mdot
.37489 .32125 Mdot
.81375 .67693 Mdot
.36999 .32408 Mdot
.82841 .56802 Mdot
.32469 .35718 Mdot
.2829 .7632 Mdot
.74391 .37241 Mdot
.2322 .65532 Mdot
.29214 .39092 Mdot
.82203 .64847 Mdot
.32897 .3532 Mdot
.81849 .663 Mdot
.53758 .8858 Mdot
.22456 .55477 Mdot
.70717 .82619 Mdot
.27176 .74759 Mdot
.68886 .83901 Mdot
.27323 .41589 Mdot
.82959 .58094 Mdot
.80609 .46585 Mdot
.54901 .88563 Mdot
.29765 .38337 Mdot
.78983 .73366 Mdot
.82705 .62439 Mdot
.29798 .38287 Mdot
.78789 .4288 Mdot
.49321 .88491 Mdot
.81892 .66429 Mdot
.82146 .65496 Mdot
.22301 .60185 Mdot
.24972 .45712 Mdot
.54341 .88647 Mdot
.31428 .80089 Mdot
.52529 .8871 Mdot
.2988 .38112 Mdot
.71196 .824 Mdot
.39666 .85823 Mdot
.27609 .40993 Mdot
.45975 .28612 Mdot
.52146 .88731 Mdot
.35294 .83316 Mdot
.43807 .29169 Mdot
.42394 .29634 Mdot
.31599 .3629 Mdot
.58632 .88148 Mdot
.52944 .27857 Mdot
.72932 .35599 Mdot
.587 .88148 Mdot
.70704 .82835 Mdot
.81245 .68796 Mdot
.50047 .27931 Mdot
.80425 .45782 Mdot
.63899 .8663 Mdot
.22314 .6164 Mdot
.47523 .28214 Mdot
.22998 .5099 Mdot
.72207 .34874 Mdot
.25275 .71875 Mdot
.49085 .27967 Mdot
.83077 .60687 Mdot
.68661 .84308 Mdot
.69518 .32839 Mdot
.33049 .81759 Mdot
.56829 .8857 Mdot
.32526 .81338 Mdot
.82364 .51172 Mdot
.22222 .61608 Mdot
.60547 .87846 Mdot
.44236 .87714 Mdot
.61241 .87653 Mdot
.40211 .86257 Mdot
.72775 .81344 Mdot
.2203 .59151 Mdot
.43358 .87478 Mdot
.26262 .73891 Mdot
.27383 .40955 Mdot
.82738 .63939 Mdot
.23927 .69006 Mdot
.22647 .52002 Mdot
.7311 .81087 Mdot
.74199 .80073 Mdot
.63231 .87065 Mdot
.7858 .74621 Mdot
.40409 .86417 Mdot
.52123 .27647 Mdot
.73512 .35855 Mdot
.69875 .32946 Mdot
.83077 .5466 Mdot
.82969 .62807 Mdot
.65638 .30519 Mdot
.49867 .88855 Mdot
.83266 .5665 Mdot
.4494 .88005 Mdot
.3337 .82189 Mdot
.82386 .65795 Mdot
.35494 .83771 Mdot
.47535 .88574 Mdot
.71383 .3399 Mdot
.38756 .30907 Mdot
.221 .54982 Mdot
.78237 .41325 Mdot
.25254 .72257 Mdot
.55995 .88844 Mdot
.31073 .80201 Mdot
.83301 .60343 Mdot
.40579 .86584 Mdot
.8335 .57131 Mdot
.67072 .85444 Mdot
.7827 .41333 Mdot
.60133 .88123 Mdot
.49804 .88929 Mdot
.83352 .56677 Mdot
.35978 .84174 Mdot
.83319 .5608 Mdot
.29499 .78604 Mdot
.25686 .4342 Mdot
.70937 .33548 Mdot
.3841 .30979 Mdot
.82573 .51046 Mdot
.5304 .89113 Mdot
.36711 .31917 Mdot
.58464 .28044 Mdot
.40932 .8681 Mdot
.2299 .49842 Mdot
.4766 .88727 Mdot
.44503 .88048 Mdot
.66726 .30873 Mdot
.45843 .28218 Mdot
.50804 .27515 Mdot
.26759 .41509 Mdot
.64128 .86923 Mdot
.23345 .48599 Mdot
.55389 .27569 Mdot
.82189 .4945 Mdot
.51053 .89121 Mdot
.83467 .57025 Mdot
.83479 .57176 Mdot
.23262 .6783 Mdot
.45239 .28319 Mdot
.35876 .84245 Mdot
.41796 .29377 Mdot
.32416 .81659 Mdot
.45521 .88362 Mdot
.45165 .28323 Mdot
.63736 .87131 Mdot
.25718 .73476 Mdot
.2219 .63624 Mdot
.48553 .88933 Mdot
.8173 .68698 Mdot
.76893 .77441 Mdot
.79382 .73779 Mdot
.22514 .51349 Mdot
.7364 .35632 Mdot
.81429 .69526 Mdot
.75728 .37763 Mdot
.77122 .77159 Mdot
.28599 .38844 Mdot
.81932 .68183 Mdot
.22846 .4998 Mdot
.83508 .60078 Mdot
.65205 .86562 Mdot
.2767 .40021 Mdot
.45623 .28162 Mdot
.83481 .60683 Mdot
.40343 .29901 Mdot
.4732 .27808 Mdot
.80499 .71767 Mdot
.79143 .74279 Mdot
.82526 .66357 Mdot
.22233 .52398 Mdot
.6366 .87235 Mdot
.40727 .29714 Mdot
.52885 .27334 Mdot
.23512 .47751 Mdot
.35995 .84427 Mdot
.41665 .87268 Mdot
.64482 .86918 Mdot
.73681 .81026 Mdot
.36548 .31823 Mdot
.61226 .88064 Mdot
.24821 .71967 Mdot
.67315 .31017 Mdot
.30725 .36383 Mdot
.22025 .63202 Mdot
.27048 .40798 Mdot
.26515 .75001 Mdot
.63783 .87225 Mdot
.54046 .27333 Mdot
.36183 .32021 Mdot
.54281 .27342 Mdot
.83206 .6347 Mdot
.22275 .51937 Mdot
.46523 .27884 Mdot
.38 .30939 Mdot
.24058 .46177 Mdot
.22986 .67512 Mdot
.26699 .75367 Mdot
.37766 .31045 Mdot
.83682 .58525 Mdot
.30512 .365 Mdot
.83089 .52227 Mdot
.82426 .49538 Mdot
.47122 .88875 Mdot
.79616 .73703 Mdot
.81404 .46565 Mdot
.34336 .33173 Mdot
.21653 .5571 Mdot
.34199 .33267 Mdot
.66473 .86139 Mdot
.39139 .30288 Mdot
.74787 .80143 Mdot
.21513 .57836 Mdot
.22049 .64107 Mdot
.70341 .32698 Mdot
.40693 .87059 Mdot
.52859 .27161 Mdot
.21486 .59086 Mdot
.81184 .70762 Mdot
.48691 .89207 Mdot
.29457 .37468 Mdot
.5164 .27155 Mdot
.60888 .88353 Mdot
.69792 .32283 Mdot
.8326 .52508 Mdot
.83051 .65158 Mdot
.27749 .39491 Mdot
.26407 .75197 Mdot
.80805 .71693 Mdot
.22312 .5093 Mdot
.83369 .63688 Mdot
.83829 .57117 Mdot
.3607 .84774 Mdot
.31408 .8121 Mdot
.83443 .53219 Mdot
.78184 .76257 Mdot
.65279 .86874 Mdot
.74311 .35783 Mdot
.36188 .84889 Mdot
.21536 .5507 Mdot
.49294 .27218 Mdot
.78861 .75307 Mdot
.64184 .87351 Mdot
.61358 .88322 Mdot
.68351 .85331 Mdot
.71251 .33181 Mdot
.3353 .33531 Mdot
.73073 .81986 Mdot
.33382 .82982 Mdot
.28064 .38904 Mdot
.33434 .83025 Mdot
.83346 .5227 Mdot
.65048 .29564 Mdot
.49408 .27154 Mdot
.2734 .76767 Mdot
.50425 .89538 Mdot
.83049 .50846 Mdot
.53398 .89621 Mdot
.49437 .89472 Mdot
.82122 .47704 Mdot
.21468 .54937 Mdot
.44314 .88521 Mdot
.39354 .29907 Mdot
.22087 .65353 Mdot
.51282 .2698 Mdot
.29347 .79302 Mdot
.21467 .54779 Mdot
.62396 .88109 Mdot
.4891 .27147 Mdot
.83498 .52655 Mdot
.62094 .88224 Mdot
.6121 .28113 Mdot
.21296 .5641 Mdot
.22973 .68601 Mdot
.71475 .8341 Mdot
.52484 .26896 Mdot
.63967 .8759 Mdot
.58089 .27372 Mdot
.26012 .41627 Mdot
.24701 .43915 Mdot
.43282 .28307 Mdot
.25811 .74668 Mdot
.62017 .28306 Mdot
.81876 .46783 Mdot
.32966 .8283 Mdot
.74844 .36043 Mdot
.36024 .31592 Mdot
.30294 .36158 Mdot
.50654 .89692 Mdot
.39419 .86854 Mdot
.24934 .43377 Mdot
.68792 .31308 Mdot
.22292 .66657 Mdot
.69058 .85141 Mdot
.24636 .72683 Mdot
.25934 .74968 Mdot
.70104 .32126 Mdot
.69882 .84632 Mdot
.8399 .55569 Mdot
.62364 .28363 Mdot
.82589 .68001 Mdot
.25806 .74805 Mdot
.29323 .79483 Mdot
.33994 .32911 Mdot
.75257 .36392 Mdot
.45269 .27676 Mdot
.26746 .7625 Mdot
.83994 .55404 Mdot
.25013 .73452 Mdot
.24283 .44564 Mdot
.83894 .62164 Mdot
.79233 .75179 Mdot
.42096 .87994 Mdot
.48325 .2709 Mdot
.83271 .50965 Mdot
.79272 .41476 Mdot
.68554 .3111 Mdot
.61693 .28121 Mdot
.63212 .28618 Mdot
.22902 .68763 Mdot
.81465 .71027 Mdot
.66893 .30194 Mdot
.53281 .26784 Mdot
.76108 .79339 Mdot
.82167 .69333 Mdot
.21296 .5469 Mdot
.83878 .62613 Mdot
.74531 .81007 Mdot
.29998 .80281 Mdot
.47522 .89435 Mdot
.32853 .33712 Mdot
.54415 .26796 Mdot
.65592 .29528 Mdot
.21555 .5276 Mdot
.22885 .47733 Mdot
.4603 .27419 Mdot
.78866 .40722 Mdot
.80927 .44273 Mdot
.21518 .52846 Mdot
.21273 .54479 Mdot
.61942 .28115 Mdot
.36903 .30903 Mdot
.27351 .77249 Mdot
.22274 .67055 Mdot
.3557 .84894 Mdot
.65814 .87019 Mdot
.83639 .52224 Mdot
.24672 .73033 Mdot
.50004 .26807 Mdot
.69724 .84888 Mdot
.76554 .37644 Mdot
.83272 .66085 Mdot
.82263 .47282 Mdot
.30957 .3528 Mdot
.38576 .86628 Mdot
.2105 .59935 Mdot
.21899 .65759 Mdot
.32046 .34292 Mdot
.83266 .50451 Mdot
.21273 .62425 Mdot
.21979 .50495 Mdot
.65277 .87294 Mdot
.84207 .56447 Mdot
.22642 .68371 Mdot
.83539 .51555 Mdot
.4785 .27024 Mdot
.69413 .31478 Mdot
.25228 .74133 Mdot
.75165 .80522 Mdot
.67522 .30365 Mdot
.77728 .39005 Mdot
.83364 .65918 Mdot
.23827 .45142 Mdot
.82256 .69498 Mdot
.6358 .8802 Mdot
.61179 .27803 Mdot
.45547 .89178 Mdot
.3176 .82137 Mdot
.76876 .37908 Mdot
.66097 .86981 Mdot
.21798 .65605 Mdot
.21973 .5028 Mdot
.75325 .80422 Mdot
.23034 .69659 Mdot
.40252 .29115 Mdot
.44872 .89045 Mdot
.2091 .58299 Mdot
.56148 .89828 Mdot
.64409 .87757 Mdot
.24979 .4275 Mdot
.21266 .53515 Mdot
.22272 .67524 Mdot
.73085 .34048 Mdot
.61887 .88651 Mdot
.39751 .87303 Mdot
.84362 .58629 Mdot
.67864 .86141 Mdot
.71854 .83551 Mdot
.71879 .83533 Mdot
.33564 .8368 Mdot
.60489 .89056 Mdot
.7425 .35059 Mdot
.56821 .26833 Mdot
.65266 .87431 Mdot
.76432 .79317 Mdot
.83255 .49903 Mdot
.6347 .28448 Mdot
.84181 .6195 Mdot
.84344 .5654 Mdot
.7148 .32729 Mdot
.66214 .29571 Mdot
.62616 .28118 Mdot
.2161 .65282 Mdot
.20981 .61366 Mdot
.77814 .77715 Mdot
.39064 .87063 Mdot
.31102 .34889 Mdot
.48977 .26707 Mdot
.73943 .34693 Mdot
.74942 .80973 Mdot
.33019 .33254 Mdot
.21328 .52618 Mdot
.58122 .89639 Mdot
.56867 .89836 Mdot
.84443 .58868 Mdot
.82778 .68482 Mdot
.57828 .89698 Mdot
.70089 .84909 Mdot
.83682 .65273 Mdot
.45217 .89256 Mdot
.32061 .34009 Mdot
.68621 .85824 Mdot
.33005 .33235 Mdot
.84424 .5999 Mdot
.27178 .77433 Mdot
.20808 .57192 Mdot
.56648 .26712 Mdot
.37492 .30283 Mdot
.25928 .75658 Mdot
.82558 .47405 Mdot
.83392 .66588 Mdot
.24296 .72872 Mdot
.46378 .2706 Mdot
.20815 .60037 Mdot
.26164 .40557 Mdot
.59238 .89473 Mdot
.20908 .61323 Mdot
.82652 .47623 Mdot
.47731 .89788 Mdot
.53159 .2644 Mdot
.33827 .84033 Mdot
.54929 .90088 Mdot
.35008 .31743 Mdot
.77736 .77937 Mdot
.36999 .30518 Mdot
.41689 .28358 Mdot
.77903 .77734 Mdot
.53774 .90162 Mdot
.8419 .62817 Mdot
.79588 .41275 Mdot
.28238 .78839 Mdot
.2146 .51574 Mdot
.83526 .50399 Mdot
.83258 .4941 Mdot
.84065 .63686 Mdot
.5667 .26664 Mdot
.84325 .5472 Mdot
.27118 .7745 Mdot
.67261 .29953 Mdot
.26021 .75901 Mdot
.51695 .90191 Mdot
.71795 .32794 Mdot
.21003 .54084 Mdot
.59232 .27083 Mdot
.46284 .27025 Mdot
.29662 .80462 Mdot
.78701 .3989 Mdot
.84542 .58873 Mdot
.5972 .8943 Mdot
.3278 .83312 Mdot
.6314 .28151 Mdot
.34943 .31713 Mdot
.31936 .82624 Mdot
.78506 .77022 Mdot
.54687 .9018 Mdot
.73337 .82627 Mdot
.79007 .76331 Mdot
.51285 .26379 Mdot
.77012 .37642 Mdot
.69736 .85297 Mdot
.37278 .86335 Mdot
.45837 .27068 Mdot
.42436 .88599 Mdot
.49641 .26474 Mdot
.58147 .8979 Mdot
.48352 .89983 Mdot
.71941 .83783 Mdot
.80799 .73433 Mdot
.78011 .77752 Mdot
.2109 .63594 Mdot
.3285 .33172 Mdot
.26818 .77185 Mdot
.25033 .74468 Mdot
.4734 .89854 Mdot
.64339 .88078 Mdot
.20644 .57459 Mdot
.22093 .48742 Mdot
.20649 .57191 Mdot
.70239 .31581 Mdot
.35934 .85606 Mdot
.75823 .36248 Mdot
.84631 .57631 Mdot
.2865 .37099 Mdot
.40495 .28681 Mdot
.45078 .89409 Mdot
.78384 .39292 Mdot
.26834 .7726 Mdot
.2098 .53484 Mdot
.40423 .87897 Mdot
.20616 .58637 Mdot
.76788 .79315 Mdot
.3723 .86377 Mdot
.41312 .28339 Mdot
.53302 .26278 Mdot
.84655 .57728 Mdot
.76101 .36494 Mdot
.22649 .46993 Mdot
.67742 .30046 Mdot
.83161 .68034 Mdot
.66008 .8742 Mdot
.20693 .60946 Mdot
.20696 .60984 Mdot
.57642 .26649 Mdot
.65452 .28931 Mdot
.39466 .29081 Mdot
.31002 .34646 Mdot
.21878 .67346 Mdot
.76394 .79812 Mdot
.75482 .80779 Mdot
.44358 .89272 Mdot
.20573 .58018 Mdot
.47422 .26669 Mdot
.25494 .41229 Mdot
.70873 .84664 Mdot
.31646 .34057 Mdot
.49136 .26426 Mdot
.4958 .90226 Mdot
.20796 .62194 Mdot
.21297 .65151 Mdot
.53916 .90354 Mdot
.52587 .26222 Mdot
.38988 .29265 Mdot
.6722 .86875 Mdot
.20829 .54029 Mdot
.51815 .90377 Mdot
.6543 .87726 Mdot
.27795 .7863 Mdot
.35486 .31167 Mdot
.21463 .65976 Mdot
.54475 .90345 Mdot
.80427 .74353 Mdot
.7068 .84846 Mdot
.20643 .61007 Mdot
.78813 .76872 Mdot
.80742 .42802 Mdot
.20534 .59042 Mdot
.84733 .58419 Mdot
.7282 .83262 Mdot
.84476 .54229 Mdot
.23984 .43801 Mdot
.2053 .57553 Mdot
.77365 .37828 Mdot
.83762 .6616 Mdot
.56653 .26445 Mdot
.26764 .39268 Mdot
.50241 .26275 Mdot
.6486 .87998 Mdot
.24601 .42621 Mdot
.57207 .2651 Mdot
.25507 .75511 Mdot
.84414 .53645 Mdot
.3137 .82385 Mdot
.42161 .8868 Mdot
.75276 .35506 Mdot
.56839 .26442 Mdot
.8356 .49582 Mdot
.84678 .60686 Mdot
.6165 .27456 Mdot
.22632 .69835 Mdot
.841 .51786 Mdot
.20891 .63388 Mdot
.24003 .72921 Mdot
.74174 .34447 Mdot
.27478 .38284 Mdot
.64731 .88082 Mdot
.7257 .83518 Mdot
.75641 .80754 Mdot
.43266 .27543 Mdot
.49188 .26332 Mdot
.26763 .392 Mdot
.638 .88454 Mdot
.4583 .89738 Mdot
.8446 .53683 Mdot
.84257 .52439 Mdot
.58151 .89992 Mdot
.2972 .35719 Mdot
.77589 .78598 Mdot
.31902 .33698 Mdot
.80314 .74689 Mdot
.53766 .90453 Mdot
.84482 .62824 Mdot
.84619 .61733 Mdot
.38144 .87029 Mdot
.20463 .5762 Mdot
.54164 .90442 Mdot
.51197 .90447 Mdot
.40206 .87985 Mdot
.22657 .70011 Mdot
.68689 .30417 Mdot
.83247 .48396 Mdot
.50033 .26226 Mdot
.51575 .90465 Mdot
.83052 .47807 Mdot
.72461 .83647 Mdot
.6127 .89306 Mdot
.8277 .69593 Mdot
.83574 .67155 Mdot
.6574 .87697 Mdot
.25764 .40573 Mdot
.21117 .64864 Mdot
.8084 .73806 Mdot
.47512 .90084 Mdot
.81457 .72634 Mdot
.82142 .45435 Mdot
.406 .28438 Mdot
.78478 .39107 Mdot
.21135 .51614 Mdot
.27029 .38775 Mdot
.28153 .3738 Mdot
.40116 .28632 Mdot
.40363 .28529 Mdot
.52116 .26103 Mdot
.31115 .34339 Mdot
.2114 .65046 Mdot
.22529 .46853 Mdot
.38619 .29304 Mdot
.84588 .62283 Mdot
.26574 .39372 Mdot
.82796 .69581 Mdot
.20872 .63678 Mdot
.49938 .26203 Mdot
.21458 .50182 Mdot
.34133 .84673 Mdot
.69436 .85781 Mdot
.61159 .27239 Mdot
.80744 .74024 Mdot
.82042 .45157 Mdot
.74341 .82106 Mdot
.79975 .41259 Mdot
.78206 .38703 Mdot
.5563 .2622 Mdot
.20406 .58173 Mdot
.21893 .67981 Mdot
.31824 .33693 Mdot
.28321 .79457 Mdot
.71359 .84526 Mdot
.23546 .44414 Mdot
.78149 .77986 Mdot
.65846 .87697 Mdot
.25889 .76295 Mdot
.24515 .42537 Mdot
.33367 .84146 Mdot
.29275 .80518 Mdot
.2661 .77329 Mdot
.28377 .79538 Mdot
.312 .82383 Mdot
.22416 .47061 Mdot
.35858 .85832 Mdot
.20396 .58831 Mdot
.47768 .90172 Mdot
.68529 .30256 Mdot
.3175 .82869 Mdot
.46882 .90028 Mdot
.30842 .34533 Mdot
.24549 .42455 Mdot
.36118 .85998 Mdot
.61369 .27264 Mdot
.6318 .27831 Mdot
.74722 .8179 Mdot
.60569 .27048 Mdot
.68753 .86228 Mdot
.20908 .64097 Mdot
.80411 .74676 Mdot
.26031 .40066 Mdot
.68017 .86644 Mdot
.84797 .55992 Mdot
.69918 .85527 Mdot
.42707 .88988 Mdot
.5806 .26508 Mdot
.62029 .89155 Mdot
.20942 .52279 Mdot
.24295 .73714 Mdot
.7381 .82627 Mdot
.30136 .81419 Mdot
.44947 .26973 Mdot
.50755 .90504 Mdot
.23799 .72768 Mdot
.28646 .3673 Mdot
.44189 .89435 Mdot
.39277 .28937 Mdot
.21246 .65771 Mdot
.57859 .26468 Mdot
.66325 .87513 Mdot
.2069 .62859 Mdot
.77023 .37186 Mdot
.34109 .31882 Mdot
.71632 .84377 Mdot
.68298 .30096 Mdot
.28161 .79335 Mdot
.33707 .32167 Mdot
.68609 .3027 Mdot
.75878 .80676 Mdot
.82673 .46532 Mdot
.29411 .80708 Mdot
.84617 .5406 Mdot
.38665 .29211 Mdot
.79493 .76179 Mdot
.38356 .87242 Mdot
.6469 .28371 Mdot
.7289 .33186 Mdot
.59275 .26724 Mdot
.2712 .78067 Mdot
.65108 .28541 Mdot
.2067 .53825 Mdot
.24673 .74423 Mdot
.21541 .66965 Mdot
.25783 .40391 Mdot
.4389 .27235 Mdot
.74337 .82183 Mdot
.41831 .88715 Mdot
.76421 .36495 Mdot
.39115 .8761 Mdot
.58261 .90081 Mdot
.73268 .33488 Mdot
.21318 .66139 Mdot
.78981 .7694 Mdot
.32575 .3301 Mdot
.29482 .35805 Mdot
.38546 .29258 Mdot
.30237 .81551 Mdot
.73802 .33936 Mdot
.52575 .90581 Mdot
.82395 .45813 Mdot
.70625 .851 Mdot
.84288 .64613 Mdot
.81211 .73312 Mdot
.37383 .29845 Mdot
.84862 .60128 Mdot
.59318 .89885 Mdot
.39989 .28595 Mdot
.6169 .89288 Mdot
.33639 .32192 Mdot
.24616 .4225 Mdot
.76673 .36753 Mdot
.20393 .60112 Mdot
.83184 .68734 Mdot
.51495 .90569 Mdot
.67841 .86781 Mdot
.25224 .75373 Mdot
.20412 .60443 Mdot
.84048 .50854 Mdot
.21341 .50325 Mdot
.21547 .49557 Mdot
.36706 .30211 Mdot
.83178 .47842 Mdot
.5623 .9039 Mdot
.67287 .2953 Mdot
.62547 .89031 Mdot
.23333 .44722 Mdot
.30651 .81959 Mdot
.62625 .27597 Mdot
.75067 .81525 Mdot
.5306 .90591 Mdot
.40998 .88427 Mdot
.51205 .2604 Mdot
.25324 .75544 Mdot
.65627 .87865 Mdot
.44333 .27091 Mdot
.45682 .89841 Mdot
.69597 .85781 Mdot
.64697 .88258 Mdot
.76194 .80387 Mdot
.21428 .66639 Mdot
.26851 .38845 Mdot
.20739 .63407 Mdot
.36795 .8645 Mdot
.20345 .59191 Mdot
.60929 .89514 Mdot
.74216 .34278 Mdot
.77564 .7883 Mdot
.47032 .26493 Mdot
.80463 .41918 Mdot
.24543 .42353 Mdot
.23894 .73048 Mdot
.76736 .36806 Mdot
.33129 .32554 Mdot
.58842 .89997 Mdot
.3422 .84841 Mdot
.32514 .83573 Mdot
.77267 .37416 Mdot
.21003 .5174 Mdot
.27111 .38499 Mdot
.43174 .27416 Mdot
.27996 .79194 Mdot
.83897 .50199 Mdot
.78314 .38715 Mdot
.42785 .89066 Mdot
.56246 .26204 Mdot
.66476 .87484 Mdot
.27082 .38535 Mdot
.33817 .8456 Mdot
.28733 .36568 Mdot
.25045 .75109 Mdot
.22554 .70088 Mdot
.37164 .86661 Mdot
.8487 .56303 Mdot
.74889 .34893 Mdot
.83976 .661 Mdot
.3137 .82622 Mdot
.22196 .47472 Mdot
.82129 .4514 Mdot
.71536 .84494 Mdot
.7617 .80422 Mdot
.70123 .31145 Mdot
.83907 .50229 Mdot
.77586 .37792 Mdot
.82752 .6997 Mdot
.71265 .84688 Mdot
.26877 .77804 Mdot
.7566 .80954 Mdot
.22086 .68819 Mdot
.36198 .30489 Mdot
.51221 .26029 Mdot
.79694 .40665 Mdot
.20569 .62259 Mdot
.23275 .44815 Mdot
.29949 .81305 Mdot
.21601 .49314 Mdot
.50302 .26082 Mdot
.43585 .2729 Mdot
.2104 .51547 Mdot
.46815 .26525 Mdot
.41004 .28162 Mdot
.35103 .31166 Mdot
.25871 .40203 Mdot
.65075 .28491 Mdot
.44545 .27026 Mdot
.33555 .32231 Mdot
.48637 .90358 Mdot
.84932 .58033 Mdot
.8376 .49676 Mdot
.83827 .66683 Mdot
.24971 .41612 Mdot
.68107 .86656 Mdot
.40304 .88162 Mdot
.31427 .3393 Mdot
.25433 .75734 Mdot
.21003 .64882 Mdot
.59158 .89939 Mdot
.8491 .59518 Mdot
.42025 .88814 Mdot
.79339 .40133 Mdot
.45518 .26791 Mdot
.21125 .65438 Mdot
.42681 .27569 Mdot
.84821 .60967 Mdot
.52488 .26 Mdot
.51785 .90593 Mdot
.81248 .43322 Mdot
.63646 .88666 Mdot
.25266 .41137 Mdot
.69635 .30839 Mdot
.22697 .70443 Mdot
.44247 .27107 Mdot
.28713 .3659 Mdot
.50663 .90543 Mdot
.84817 .55598 Mdot
.28199 .37172 Mdot
.31198 .34136 Mdot
.84269 .64798 Mdot
.50396 .2608 Mdot
.8105 .42956 Mdot
.48299 .90308 Mdot
.45803 .8987 Mdot
.43451 .27336 Mdot
.66478 .87479 Mdot
.20776 .52968 Mdot
.63847 .88587 Mdot
.47834 .26363 Mdot
.20512 .54907 Mdot
.83333 .48285 Mdot
.42368 .27679 Mdot
.35269 .31069 Mdot
.59057 .26653 Mdot
.31832 .33594 Mdot
.81215 .7333 Mdot
.83256 .68546 Mdot
.37742 .8696 Mdot
.80654 .7435 Mdot
.73906 .82596 Mdot
.39287 .8771 Mdot
.24524 .42396 Mdot
.21564 .49483 Mdot
.24775 .74639 Mdot
.20389 .60104 Mdot
.29978 .35288 Mdot
.52533 .90592 Mdot
.7904 .7688 Mdot
.52014 .26018 Mdot
.30907 .82191 Mdot
.83813 .66674 Mdot
.84333 .64418 Mdot
.22149 .4765 Mdot
.33111 .84022 Mdot
.53665 .90573 Mdot
.84269 .64735 Mdot
.72413 .83817 Mdot
.42749 .89039 Mdot
.30197 .35081 Mdot
.82447 .45921 Mdot
.66121 .87633 Mdot
.21197 .50928 Mdot
.2894 .80235 Mdot
.82101 .7148 Mdot
.28856 .36461 Mdot
.84787 .55464 Mdot
.37572 .29747 Mdot
.83869 .50172 Mdot
.845 .53178 Mdot
.23027 .45432 Mdot
.84403 .63992 Mdot
.67042 .29419 Mdot
.58982 .89948 Mdot
.84797 .60963 Mdot
.84834 .56142 Mdot
.84904 .579 Mdot
.76965 .79505 Mdot
.51528 .90559 Mdot
.68971 .30468 Mdot
.30667 .34651 Mdot
.83868 .50188 Mdot
.24258 .42916 Mdot
.73013 .33279 Mdot
.60448 .26989 Mdot
.69913 .31047 Mdot
.70055 .85466 Mdot
.25693 .40528 Mdot
.26527 .77279 Mdot
.70465 .31407 Mdot
.384 .87266 Mdot
.27336 .38261 Mdot
.24187 .43057 Mdot
.24577 .74253 Mdot
.84634 .62433 Mdot
.23936 .73062 Mdot
.27181 .7814 Mdot
.39031 .29042 Mdot
.75134 .81422 Mdot
.57533 .9019 Mdot
.83905 .66223 Mdot
.6045 .89602 Mdot
.22482 .69791 Mdot
.80433 .74666 Mdot
.66687 .87339 Mdot
.33639 .32223 Mdot
.21217 .50952 Mdot
.20805 .63583 Mdot
.80759 .42512 Mdot
.71509 .84458 Mdot
.74648 .81876 Mdot
.83717 .66907 Mdot
.81947 .44849 Mdot
.70308 .31322 Mdot
.76261 .80255 Mdot
.5043 .90482 Mdot
.77392 .78968 Mdot
.72055 .8405 Mdot
.71695 .32287 Mdot
.2446 .42594 Mdot
.63208 .27834 Mdot
.80151 .41487 Mdot
.32183 .33359 Mdot
.51561 .90536 Mdot
.52599 .2605 Mdot
.46287 .89923 Mdot
.50397 .2613 Mdot
.2302 .71077 Mdot
.35011 .31294 Mdot
.78769 .39419 Mdot
.2542 .40998 Mdot
.52 .90541 Mdot
.49728 .26188 Mdot
.70228 .8532 Mdot
.26865 .77689 Mdot
.84638 .6218 Mdot
.7671 .36861 Mdot
.74013 .82433 Mdot
.66156 .8757 Mdot
.56943 .90254 Mdot
.21209 .65531 Mdot
.20403 .59297 Mdot
.40678 .28357 Mdot
.82628 .70116 Mdot
.54143 .26096 Mdot
.2252 .6983 Mdot
.67019 .87151 Mdot
.74751 .81753 Mdot
.83147 .47917 Mdot
.20835 .63616 Mdot
.81368 .43699 Mdot
.39302 .28952 Mdot
.24799 .42039 Mdot
.58035 .90078 Mdot
.84217 .51882 Mdot
.6773 .29826 Mdot
.65221 .28633 Mdot
.41835 .88668 Mdot
.42229 .27799 Mdot
.73271 .33553 Mdot
.79831 .41021 Mdot
.37345 .29931 Mdot
.81947 .4493 Mdot
.44553 .89496 Mdot
.2572 .76024 Mdot
.84004 .50965 Mdot
.8297 .69148 Mdot
.31757 .33757 Mdot
.84517 .62917 Mdot
.23379 .44792 Mdot
.63693 .8856 Mdot
.67689 .29821 Mdot
.25361 .41145 Mdot
.7873 .77188 Mdot
.7644 .80003 Mdot
.20952 .52448 Mdot
.51805 .90505 Mdot
.41434 .28096 Mdot
.43375 .89157 Mdot
.27532 .3811 Mdot
.77708 .78515 Mdot
.33249 .84028 Mdot
.35071 .31304 Mdot
.2082 .63335 Mdot
.61011 .89395 Mdot
.34832 .85139 Mdot
.69862 .31099 Mdot
.59602 .26865 Mdot
.81402 .4385 Mdot
.62212 .27565 Mdot
.63454 .2798 Mdot
.84221 .64511 Mdot
.365 .30438 Mdot
.21087 .64745 Mdot
.65004 .28581 Mdot
.3844 .29404 Mdot
.73447 .33745 Mdot
.54032 .2614 Mdot
.32651 .3306 Mdot
.76151 .80279 Mdot
.84653 .61566 Mdot
.84793 .57018 Mdot
.7214 .83904 Mdot
.28004 .79029 Mdot
.62161 .2756 Mdot
.72693 .83468 Mdot
.66072 .29061 Mdot
.24928 .74683 Mdot
.84616 .54758 Mdot
.21604 .66847 Mdot
.64694 .88133 Mdot
.82392 .4607 Mdot
.26335 .76846 Mdot
.82089 .45365 Mdot
.77957 .78141 Mdot
.25686 .40721 Mdot
.5039 .90393 Mdot
.75647 .3583 Mdot
.21077 .52044 Mdot
.23488 .71919 Mdot
.2256 .69725 Mdot
.62747 .27769 Mdot
.35463 .85504 Mdot
.34757 .31558 Mdot
.82999 .47712 Mdot
.61081 .8933 Mdot
.64558 .28438 Mdot
.49075 .90262 Mdot
.61315 .27341 Mdot
.24145 .43384 Mdot
.42202 .88718 Mdot
.83172 .6835 Mdot
.24479 .73828 Mdot
.22593 .69762 Mdot
.24327 .43056 Mdot
.84687 .60685 Mdot
.23958 .72839 Mdot
.7895 .39847 Mdot
.40599 .28492 Mdot
.62935 .8875 Mdot
.77226 .78996 Mdot
.20634 .553 Mdot
.60399 .27121 Mdot
.20558 .60302 Mdot
.20498 .58356 Mdot
.24454 .42867 Mdot
.20654 .55197 Mdot
.32452 .83299 Mdot
.65852 .87577 Mdot
.51963 .26189 Mdot
.51115 .90385 Mdot
.83821 .50649 Mdot
.47296 .26632 Mdot
.73507 .33899 Mdot
.34104 .32072 Mdot
.7738 .37845 Mdot
.30681 .34869 Mdot
.82075 .45504 Mdot
.50243 .90318 Mdot
.65815 .87574 Mdot
.35668 .8556 Mdot
.8455 .54899 Mdot
.21016 .63869 Mdot
.69662 .31093 Mdot
.84672 .56405 Mdot
.20535 .57813 Mdot
.7935 .76083 Mdot
.2135 .65493 Mdot
.33625 .84165 Mdot
.47367 .26642 Mdot
.55858 .26371 Mdot
.21632 .66614 Mdot
.33675 .84197 Mdot
.65315 .87778 Mdot
.80838 .43017 Mdot
.46185 .89729 Mdot
.83002 .68622 Mdot
.48112 .9006 Mdot
.23088 .70792 Mdot
.77138 .37617 Mdot
.39571 .87593 Mdot
.26746 .39368 Mdot
.32036 .33727 Mdot
.21706 .49839 Mdot
.84648 .56731 Mdot
.21853 .49332 Mdot
.24907 .74387 Mdot
.30813 .81778 Mdot
.82633 .69558 Mdot
.62625 .88748 Mdot
.44463 .89287 Mdot
.57072 .26575 Mdot
.53672 .26288 Mdot
.2451 .42967 Mdot
.23439 .71481 Mdot
.76227 .79956 Mdot
.84447 .54683 Mdot
.21339 .51496 Mdot
.2361 .44767 Mdot
.61003 .27395 Mdot
.23389 .71352 Mdot
.71065 .84478 Mdot
.21879 .67212 Mdot
.21133 .64028 Mdot
.36361 .85872 Mdot
.31079 .81974 Mdot
.68999 .85811 Mdot
.26387 .39971 Mdot
.21057 .53034 Mdot
.47134 .89835 Mdot
.33021 .33003 Mdot
.57597 .89921 Mdot
.80475 .42522 Mdot
.56591 .26543 Mdot
.51468 .90286 Mdot
.43455 .27641 Mdot
.84624 .58924 Mdot
.83958 .6482 Mdot
.34656 .31826 Mdot
.8381 .65495 Mdot
.78987 .40159 Mdot
.61759 .88966 Mdot
.32265 .33626 Mdot
.82557 .46997 Mdot
.84612 .57536 Mdot
.45717 .89538 Mdot
.23536 .45001 Mdot
.27814 .78486 Mdot
.21181 .52488 Mdot
.84318 .53994 Mdot
.81212 .72644 Mdot
.33239 .32873 Mdot
.20657 .58761 Mdot
.30307 .81192 Mdot
.3204 .33845 Mdot
.38398 .29675 Mdot
.61976 .88873 Mdot
.81712 .45031 Mdot
.56353 .26552 Mdot
.60837 .27406 Mdot
.75386 .80752 Mdot
.44625 .27356 Mdot
.77431 .78463 Mdot
.23096 .46102 Mdot
.29665 .36083 Mdot
.20878 .54721 Mdot
.84085 .52688 Mdot
.25353 .74944 Mdot
.72626 .3339 Mdot
.20716 .59691 Mdot
.8054 .42766 Mdot
.40408 .2879 Mdot
.48127 .26683 Mdot
.21844 .49809 Mdot
.7471 .81373 Mdot
.76043 .80019 Mdot
.84552 .59016 Mdot
.41994 .88408 Mdot
.84108 .52961 Mdot
.39351 .29269 Mdot
.43945 .8902 Mdot
.48979 .26591 Mdot
.77023 .37717 Mdot
.68096 .86217 Mdot
.33573 .83899 Mdot
.21969 .67118 Mdot
.7635 .79624 Mdot
.22204 .48737 Mdot
.248 .73875 Mdot
.83518 .50378 Mdot
.71661 .83887 Mdot
.84261 .62327 Mdot
.31951 .82571 Mdot
.22672 .47392 Mdot
.77151 .37929 Mdot
.42503 .8853 Mdot
.20752 .58655 Mdot
.59298 .89475 Mdot
.71562 .32657 Mdot
.76733 .79156 Mdot
.50209 .90082 Mdot
.6852 .30674 Mdot
.61132 .27586 Mdot
.82908 .48353 Mdot
.80955 .72907 Mdot
.78763 .76541 Mdot
.36978 .30544 Mdot
.2084 .60387 Mdot
.21941 .49756 Mdot
.82531 .69288 Mdot
.84337 .61343 Mdot
.82043 .70517 Mdot
.71644 .32756 Mdot
.51632 .90126 Mdot
.81435 .44738 Mdot
.84217 .54385 Mdot
.62569 .28064 Mdot
.52335 .9013 Mdot
.83626 .51083 Mdot
.21925 .66672 Mdot
.76506 .79331 Mdot
.84372 .56175 Mdot
.25716 .75259 Mdot
.84235 .54706 Mdot
.51133 .26528 Mdot
.57242 .26833 Mdot
.84414 .59378 Mdot
.32102 .34014 Mdot
.56809 .26778 Mdot
.77772 .38836 Mdot
.80332 .73905 Mdot
.84063 .63079 Mdot
.81411 .44797 Mdot
.78104 .77321 Mdot
.7366 .82138 Mdot
.58506 .89541 Mdot
.39106 .29538 Mdot
.60668 .27551 Mdot
.70362 .31927 Mdot
.70664 .84469 Mdot
.46836 .89549 Mdot
.29244 .79819 Mdot
.49169 .89891 Mdot
.33557 .83716 Mdot
.20978 .61096 Mdot
.83252 .49838 Mdot
.26691 .76636 Mdot
.82707 .68489 Mdot
.81868 .45911 Mdot
.78547 .76651 Mdot
.31003 .81549 Mdot
.35348 .84935 Mdot
.819 .46013 Mdot
.47936 .89695 Mdot
.82313 .47057 Mdot
.21586 .64912 Mdot
.21089 .61807 Mdot
.24227 .44146 Mdot
.53207 .9003 Mdot
.61302 .27783 Mdot
.70272 .84671 Mdot
.42043 .28394 Mdot
.70807 .84303 Mdot
.55583 .26715 Mdot
.76008 .36865 Mdot
.73649 .34553 Mdot
.4762 .26987 Mdot
.21916 .50437 Mdot
.22419 .48693 Mdot
.26944 .76878 Mdot
.8055 .7331 Mdot
.47634 .27001 Mdot
.81505 .45232 Mdot
.72516 .33629 Mdot
.26323 .75968 Mdot
.37457 .30484 Mdot
.51481 .26636 Mdot
.50178 .26715 Mdot
.23289 .46368 Mdot
.21895 .65944 Mdot
.69689 .31621 Mdot
.47755 .27013 Mdot
.21187 .54591 Mdot
.55783 .89805 Mdot
.37242 .85968 Mdot
.43522 .27987 Mdot
.84073 .54683 Mdot
.71034 .32555 Mdot
.38056 .86388 Mdot
.8426 .59063 Mdot
.55559 .26801 Mdot
.40053 .29276 Mdot
.70875 .32462 Mdot
.51414 .89902 Mdot
.41925 .88057 Mdot
.79225 .41204 Mdot
.23182 .46798 Mdot
.50284 .26775 Mdot
.48712 .26932 Mdot
.6625 .29781 Mdot
.8389 .53685 Mdot
.72031 .3336 Mdot
.27963 .78052 Mdot
.21544 .5264 Mdot
.75701 .36719 Mdot
.58634 .27285 Mdot
.29284 .79585 Mdot
.25081 .42853 Mdot
.5139 .89859 Mdot
.34018 .83817 Mdot
.82826 .49054 Mdot
.84074 .55474 Mdot
.21667 .52137 Mdot
.24282 .7219 Mdot
.59777 .89048 Mdot
.63171 .2855 Mdot
.46028 .27436 Mdot
.44711 .27751 Mdot
.25497 .74409 Mdot
.62969 .28506 Mdot
.21756 .64747 Mdot
.65116 .87258 Mdot
.64739 .87416 Mdot
.84139 .57229 Mdot
.79802 .42315 Mdot
.25726 .74734 Mdot
.40481 .29214 Mdot
.24348 .72218 Mdot
.84048 .55813 Mdot
.58852 .89198 Mdot
.61752 .28135 Mdot
.24824 .7314 Mdot
.31435 .81628 Mdot
.4679 .27335 Mdot
.40913 .87543 Mdot
.64762 .29232 Mdot
.69349 .31617 Mdot
.30899 .81092 Mdot
.27634 .39157 Mdot
.24691 .72816 Mdot
.27817 .77677 Mdot
.23907 .45416 Mdot
.21149 .58104 Mdot
.69089 .85136 Mdot
.5641 .89547 Mdot
.65554 .86989 Mdot
.21401 .54466 Mdot
.49157 .8957 Mdot
.63874 .28926 Mdot
.69875 .32 Mdot
.76479 .37798 Mdot
.74447 .80955 Mdot
.34589 .84063 Mdot
.38623 .86458 Mdot
.27708 .39124 Mdot
.74587 .80811 Mdot
.66419 .86561 Mdot
.55692 .89583 Mdot
.24598 .44095 Mdot
.80482 .72854 Mdot
.47926 .27233 Mdot
.24896 .43531 Mdot
.28224 .38523 Mdot
.21943 .65016 Mdot
.49289 .89535 Mdot
.83612 .53135 Mdot
.67445 .85986 Mdot
.24045 .45312 Mdot
.66129 .29957 Mdot
.22602 .49138 Mdot
.72355 .33879 Mdot
.75924 .37256 Mdot
.22268 .50328 Mdot
.32099 .34569 Mdot
.79972 .42915 Mdot
.21562 .62687 Mdot
.34625 .32614 Mdot
.32954 .82732 Mdot
.27226 .39904 Mdot
.2301 .68612 Mdot
.68722 .31387 Mdot
.43239 .28387 Mdot
.78667 .75766 Mdot
.21279 .58234 Mdot
.83003 .66059 Mdot
.23478 .46782 Mdot
.69066 .8499 Mdot
.60133 .27872 Mdot
.65735 .29841 Mdot
.31598 .35082 Mdot
.65274 .86964 Mdot
.33724 .83282 Mdot
.60093 .27877 Mdot
.25732 .74352 Mdot
.28683 .78488 Mdot
.31455 .81377 Mdot
.21756 .63533 Mdot
.75985 .79155 Mdot
.81276 .45674 Mdot
.82108 .47766 Mdot
.29704 .79609 Mdot
.38917 .30174 Mdot
.77025 .38705 Mdot
.39772 .86829 Mdot
.71006 .83627 Mdot
.64287 .29269 Mdot
.21729 .63156 Mdot
.73874 .81255 Mdot
.21637 .62481 Mdot
.22358 .66131 Mdot
.28921 .3792 Mdot
.22272 .50832 Mdot
.50411 .89485 Mdot
.65624 .29872 Mdot
.54066 .89525 Mdot
.80861 .44896 Mdot
.22863 .6782 Mdot
.71678 .33529 Mdot
.24123 .71098 Mdot
.21697 .53909 Mdot
.65521 .86757 Mdot
.32616 .34318 Mdot
.73876 .35411 Mdot
.52977 .8953 Mdot
.73574 .81464 Mdot
.71251 .33262 Mdot
.81818 .69334 Mdot
.73842 .35423 Mdot
.47912 .27463 Mdot
.83601 .62026 Mdot
.78928 .75078 Mdot
.75628 .37233 Mdot
.83708 .55704 Mdot
.69764 .8436 Mdot
.33493 .33679 Mdot
.65598 .29952 Mdot
.66928 .86001 Mdot
.82168 .48365 Mdot
.30427 .80168 Mdot
.60897 .28258 Mdot
.52376 .27143 Mdot
.22774 .49413 Mdot
.83408 .53564 Mdot
.24987 .43975 Mdot
.8376 .58731 Mdot
.34238 .33185 Mdot
.22683 .66805 Mdot
.27418 .40049 Mdot
.80716 .71696 Mdot
.71841 .33824 Mdot
.24371 .71329 Mdot
.67942 .31214 Mdot
.7922 .74456 Mdot
.25153 .43707 Mdot
.22746 .66943 Mdot
.33372 .82731 Mdot
.35643 .32247 Mdot
.38944 .86225 Mdot
.45589 .28017 Mdot
.53865 .27235 Mdot
.8325 .63662 Mdot
.80431 .72193 Mdot
.73168 .81626 Mdot
.38956 .86196 Mdot
.21593 .57037 Mdot
.83482 .54741 Mdot
.77484 .76923 Mdot
.83284 .53334 Mdot
.77998 .40391 Mdot
.24962 .44202 Mdot
.80663 .44945 Mdot
.81854 .47821 Mdot
.82012 .48274 Mdot
.80473 .44576 Mdot
.60963 .88205 Mdot
.80436 .72095 Mdot
.79553 .42857 Mdot
.50182 .89244 Mdot
.82152 .48753 Mdot
.77987 .76174 Mdot
.34021 .83104 Mdot
.42681 .28936 Mdot
.81642 .47367 Mdot
.26746 .41284 Mdot
.52687 .27328 Mdot
.66724 .85881 Mdot
.24763 .44787 Mdot
.235 .47789 Mdot
.81206 .46372 Mdot
.83283 .53941 Mdot
.71155 .33495 Mdot
.45655 .88465 Mdot
.63945 .29486 Mdot
.21848 .61601 Mdot
.47929 .27704 Mdot
.75354 .79322 Mdot
.25326 .43731 Mdot
.26282 .42069 Mdot
.76625 .77841 Mdot
.5101 .27404 Mdot
.7051 .33052 Mdot
.52256 .89232 Mdot
.27694 .766 Mdot
.72678 .34752 Mdot
.23577 .47698 Mdot
.72367 .34493 Mdot
.83282 .62313 Mdot
.80721 .454 Mdot
.48022 .88868 Mdot
.57549 .27794 Mdot
.21739 .58852 Mdot
.82453 .5026 Mdot
.81022 .7045 Mdot
.21988 .54536 Mdot
.82855 .64565 Mdot
.82875 .52138 Mdot
.46093 .28135 Mdot
.69892 .32716 Mdot
.72418 .34627 Mdot
.35661 .84066 Mdot
.63101 .87317 Mdot
.345 .83256 Mdot
.53309 .27466 Mdot
.77711 .40358 Mdot
.31218 .80494 Mdot
.24802 .4502 Mdot
.79669 .73115 Mdot
.58291 .88607 Mdot
.32577 .81711 Mdot
.25509 .43661 Mdot
.25982 .73785 Mdot
.72645 .34878 Mdot
.82731 .51759 Mdot
.25986 .42847 Mdot
.81253 .46928 Mdot
.27781 .40102 Mdot
.81384 .69335 Mdot
.22154 .53938 Mdot
.33666 .82549 Mdot
.72503 .81809 Mdot
.4218 .87254 Mdot
.45906 .28268 Mdot
.8259 .51268 Mdot
.66749 .30964 Mdot
.71781 .82374 Mdot
.51835 .27557 Mdot
.76257 .38615 Mdot
.77195 .76801 Mdot
.53997 .89016 Mdot
.32234 .35299 Mdot
.26195 .73991 Mdot
.3204 .35485 Mdot
.52019 .89018 Mdot
.43559 .87646 Mdot
.64684 .30063 Mdot
.38534 .3103 Mdot
.81754 .67996 Mdot
.51268 .8896 Mdot
.75063 .79241 Mdot
.61981 .87529 Mdot
.38934 .30847 Mdot
.78208 .7524 Mdot
.34656 .83163 Mdot
.83085 .54665 Mdot
.42685 .29288 Mdot
.55369 .88845 Mdot
.23121 .49962 Mdot
.44953 .87984 Mdot
.81958 .49376 Mdot
.24082 .47164 Mdot
.38059 .31353 Mdot
.4894 .88714 Mdot
.77676 .75938 Mdot
.75035 .79188 Mdot
.63746 .2977 Mdot
.82599 .64549 Mdot
.29551 .38208 Mdot
.58873 .28352 Mdot
.82364 .5112 Mdot
.23231 .66743 Mdot
.22732 .51855 Mdot
.62085 .87388 Mdot
.83208 .57755 Mdot
.67894 .31813 Mdot
.58184 .28244 Mdot
.29301 .78053 Mdot
.71335 .34144 Mdot
.24618 .46121 Mdot
.22109 .59458 Mdot
.36394 .32432 Mdot
.27232 .41357 Mdot
.42738 .29441 Mdot
.3967 .30684 Mdot
.29538 .38373 Mdot
.77933 .75334 Mdot
.77221 .40259 Mdot
.52986 .88801 Mdot
.57085 .88475 Mdot
.43063 .29351 Mdot
.29196 .77804 Mdot
.53425 .27831 Mdot
.35318 .83386 Mdot
.8309 .5748 Mdot
.24935 .45595 Mdot
.26352 .42886 Mdot
.25146 .45182 Mdot
.3269 .35288 Mdot
.3189 .80591 Mdot
.2219 .58456 Mdot
.74249 .79724 Mdot
.66158 .31043 Mdot
.7972 .44446 Mdot
.82433 .52183 Mdot
.47285 .88253 Mdot
.54058 .27913 Mdot
.82767 .54183 Mdot
.26804 .42255 Mdot
.45095 .87746 Mdot
.36791 .32368 Mdot
.74334 .79568 Mdot
.8227 .5162 Mdot
.3378 .34474 Mdot
.23311 .66271 Mdot
.49882 .88533 Mdot
.22344 .56357 Mdot
.74833 .7898 Mdot
.70588 .3385 Mdot
.75075 .37923 Mdot
.77981 .7491 Mdot
.38033 .31744 Mdot
.78241 .42113 Mdot
.22737 .5336 Mdot
.75819 .38825 Mdot
.65772 .31022 Mdot
.32986 .35265 Mdot
.81685 .49825 Mdot
.54184 .88527 Mdot
.45455 .87702 Mdot
.3734 .32199 Mdot
.28058 .40662 Mdot
.62899 .29863 Mdot
.78279 .74313 Mdot
.22992 .52321 Mdot
.61018 .29258 Mdot
.66782 .31597 Mdot
.4753 .88078 Mdot
.22565 .55403 Mdot
.72513 .81037 Mdot
.67349 .31929 Mdot
.2344 .66038 Mdot
.22557 .61033 Mdot
.80944 .47809 Mdot
.80468 .69998 Mdot
.40203 .30782 Mdot
.32487 .80793 Mdot
.79534 .44624 Mdot
.38893 .8516 Mdot
.68534 .32676 Mdot
.26852 .42646 Mdot
.25969 .44223 Mdot
.48004 .88091 Mdot
.76305 .39643 Mdot
.75556 .38735 Mdot
.74792 .78726 Mdot
.67778 .84335 Mdot
.41206 .30437 Mdot
.78638 .73457 Mdot
.78212 .4244 Mdot
.4555 .87547 Mdot
.29875 .77985 Mdot
.76361 .76794 Mdot
.7648 .76607 Mdot
.56033 .8817 Mdot
.23482 .5099 Mdot
.6485 .85755 Mdot
.25844 .4469 Mdot
.24734 .69441 Mdot
.46116 .28982 Mdot
.8265 .57458 Mdot
.81781 .51094 Mdot
.69897 .82868 Mdot
.28382 .76012 Mdot
.80323 .69895 Mdot
.41569 .86212 Mdot
.71544 .35005 Mdot
.62053 .29838 Mdot
.41266 .30558 Mdot
.76176 .7686 Mdot
.77419 .41444 Mdot
.67009 .84604 Mdot
.25053 .7001 Mdot
.42436 .86473 Mdot
.76651 .40441 Mdot
.64607 .30873 Mdot
.82543 .58889 Mdot
.61772 .8678 Mdot
.27162 .73934 Mdot
.23224 .63605 Mdot
.74235 .78928 Mdot
.70445 .3436 Mdot
.37674 .3248 Mdot
.27817 .74876 Mdot
.52748 .28475 Mdot
.51156 .28512 Mdot
.23803 .50653 Mdot
.27126 .42856 Mdot
.45483 .29357 Mdot
.36915 .83631 Mdot
.78171 .73639 Mdot
.23194 .53725 Mdot
.3386 .81433 Mdot
.63588 .30606 Mdot
.35331 .82545 Mdot
.8109 .67046 Mdot
.68679 .8336 Mdot
.29677 .39392 Mdot
.2293 .59723 Mdot
.3759 .83949 Mdot
.8011 .69634 Mdot
.75564 .39404 Mdot
.64363 .31002 Mdot
.34324 .81708 Mdot
.43941 .2989 Mdot
.27718 .7449 Mdot
.39974 .31466 Mdot
.62152 .30203 Mdot
.81683 .64312 Mdot
.2328 .53995 Mdot
.2952 .76895 Mdot
.50142 .28754 Mdot
.33734 .3545 Mdot
.37983 .32523 Mdot
.79211 .71412 Mdot
.74147 .37925 Mdot
.50844 .28726 Mdot
.72167 .80575 Mdot
.23317 .62597 Mdot
.47801 .29075 Mdot
.81872 .53578 Mdot
.82106 .6121 Mdot
.68949 .83014 Mdot
.5391 .87887 Mdot
.82213 .59514 Mdot
.33115 .36048 Mdot
.30776 .78254 Mdot
.25472 .70043 Mdot
.3344 .35785 Mdot
.6633 .32107 Mdot
.23464 .53623 Mdot
.26679 .44197 Mdot
.55801 .87651 Mdot
.66133 .84549 Mdot
.61937 .30301 Mdot
.30902 .38344 Mdot
.45207 .29749 Mdot
.53256 .28807 Mdot
.26533 .44545 Mdot
.48141 .87454 Mdot
.81369 .51683 Mdot
.80441 .68092 Mdot
.27375 .43086 Mdot
.23812 .52078 Mdot
.2385 .51908 Mdot
.5746 .29232 Mdot
.31001 .38294 Mdot
.37749 .32872 Mdot
.32795 .3652 Mdot
.80703 .49414 Mdot
.41287 .31128 Mdot
.56758 .87449 Mdot
.60052 .29822 Mdot
.25909 .70641 Mdot
.45752 .86918 Mdot
.6551 .31843 Mdot
.64587 .31416 Mdot
.48901 .2914 Mdot
.80616 .67267 Mdot
.23435 .61484 Mdot
.78965 .45307 Mdot
.80657 .49539 Mdot
.81937 .60066 Mdot
.45735 .2978 Mdot
.74359 .38584 Mdot
.5318 .28968 Mdot
.81317 .64452 Mdot
.30276 .39306 Mdot
.30388 .3919 Mdot
.69393 .34242 Mdot
.58326 .29544 Mdot
.60659 .30128 Mdot
.79494 .4662 Mdot
.24635 .49695 Mdot
.24642 .49693 Mdot
.80519 .49408 Mdot
.24409 .65994 Mdot
.79265 .70341 Mdot
.33859 .80704 Mdot
.74161 .78063 Mdot
.31929 .78931 Mdot
.3585 .34384 Mdot
.36651 .33845 Mdot
.59745 .86631 Mdot
.80975 .65319 Mdot
.23846 .53408 Mdot
.54432 .87439 Mdot
.30788 .38983 Mdot
.32714 .79601 Mdot
.40451 .84795 Mdot
.45811 .29954 Mdot
.24956 .67471 Mdot
.42359 .85575 Mdot
.81197 .52592 Mdot
.41365 .85168 Mdot
.79264 .46536 Mdot
.71325 .3598 Mdot
.81691 .56519 Mdot
.67497 .33273 Mdot
.29948 .40082 Mdot
.2514 .48779 Mdot
.27342 .72655 Mdot
.31066 .77802 Mdot
.23562 .57991 Mdot
.65908 .32455 Mdot
.80315 .49485 Mdot
.71131 .35909 Mdot
.57602 .86901 Mdot
.72726 .37357 Mdot
.71035 .35862 Mdot
.29064 .41363 Mdot
.25257 .67935 Mdot
.23627 .5885 Mdot
.41451 .85053 Mdot
.25999 .46849 Mdot
.26361 .70563 Mdot
.35931 .81991 Mdot
.40547 .31959 Mdot
.61618 .30764 Mdot
.3218 .78804 Mdot
.54159 .87217 Mdot
.64507 .319 Mdot
.60158 .30351 Mdot
.40734 .3192 Mdot
.72407 .7939 Mdot
.39802 .324 Mdot
.32197 .37863 Mdot
.48381 .29716 Mdot
.68696 .82324 Mdot
.70656 .80889 Mdot
.67619 .83006 Mdot
.24018 .62112 Mdot
.49064 .86934 Mdot
.72498 .79206 Mdot
.42584 .31276 Mdot
.67876 .82771 Mdot
.39849 .84142 Mdot
.25164 .49564 Mdot
.28387 .42724 Mdot
.71382 .80173 Mdot
.65783 .83932 Mdot
.74947 .40104 Mdot
.43366 .85562 Mdot
.26406 .46425 Mdot
.56512 .2978 Mdot
.38362 .8329 Mdot
.24185 .54044 Mdot
.25094 .66592 Mdot
.44885 .85995 Mdot
.34394 .36077 Mdot
.78789 .46456 Mdot
.78848 .69982 Mdot
.49837 .86867 Mdot
.81301 .573 Mdot
.40687 .84376 Mdot
.33936 .80037 Mdot
.58726 .30299 Mdot
.27288 .44918 Mdot
.2556 .67708 Mdot
.6832 .34328 Mdot
.69939 .81133 Mdot
.252 .66576 Mdot
.78716 .70141 Mdot
.51407 .29687 Mdot
.27986 .72889 Mdot
.24691 .52069 Mdot
.79529 .68086 Mdot
.58561 .86297 Mdot
.47571 .86459 Mdot
.69613 .8132 Mdot
.55571 .86756 Mdot
.74446 .76777 Mdot
.80965 .62058 Mdot
.81155 .56606 Mdot
.62772 .31617 Mdot
.64466 .32325 Mdot
.50718 .29821 Mdot
.49484 .86659 Mdot
.34919 .80669 Mdot
.24318 .61782 Mdot
.81151 .57988 Mdot
.43138 .31405 Mdot
.75796 .74913 Mdot
.7533 .75517 Mdot
.58641 .8614 Mdot
.46811 .86171 Mdot
.26064 .48084 Mdot
.27656 .44696 Mdot
.4492 .85619 Mdot
.68857 .35021 Mdot
.27181 .45753 Mdot
.41555 .84417 Mdot
.49613 .86497 Mdot
.2677 .69917 Mdot
.43836 .85234 Mdot
.67283 .82546 Mdot
.48338 .3032 Mdot
.32189 .77886 Mdot
.78024 .70806 Mdot
.24924 .64051 Mdot
.74058 .39858 Mdot
.24362 .58481 Mdot
.60019 .3102 Mdot
.36181 .35321 Mdot
.64829 .8378 Mdot
.28612 .73147 Mdot
.31594 .39473 Mdot
.33485 .3757 Mdot
.63059 .84522 Mdot
.25052 .64272 Mdot
.34916 .80263 Mdot
.69004 .35331 Mdot
.6453 .32732 Mdot
.29006 .73707 Mdot
.79122 .67951 Mdot
.79435 .67028 Mdot
.26572 .47554 Mdot
.44303 .85216 Mdot
.72413 .38256 Mdot
.60252 .85415 Mdot
.7901 .68157 Mdot
.77571 .71354 Mdot
.67892 .81945 Mdot
.7523 .41542 Mdot
.80242 .63691 Mdot
.80665 .60431 Mdot
.25054 .52822 Mdot
.54107 .86377 Mdot
.77763 .70884 Mdot
.64018 .32609 Mdot
.80719 .59102 Mdot
.60036 .85383 Mdot
.44501 .31445 Mdot
.41528 .32541 Mdot
.56677 .86058 Mdot
.57813 .85866 Mdot
.7065 .36814 Mdot
.71334 .79197 Mdot
.80649 .57143 Mdot
.32123 .39178 Mdot
.79352 .66722 Mdot
.31256 .76389 Mdot
.28104 .44802 Mdot
.34755 .79843 Mdot
.34942 .79993 Mdot
.30848 .75861 Mdot
.24797 .61082 Mdot
.44472 .31555 Mdot
.24872 .54932 Mdot
.55315 .86113 Mdot
.28661 .72646 Mdot
.37314 .34955 Mdot
.40113 .33342 Mdot
.24864 .5542 Mdot
.34167 .37395 Mdot
.79884 .52428 Mdot
.63187 .32501 Mdot
.6365 .839 Mdot
.35061 .7993 Mdot
.53307 .3045 Mdot
.2584 .6595 Mdot
.249 .55639 Mdot
.32837 .38724 Mdot
.61005 .84842 Mdot
.80459 .58506 Mdot
.25086 .54316 Mdot
.67937 .35065 Mdot
.42752 .32289 Mdot
.2538 .63814 Mdot
.80382 .58664 Mdot
.25791 .6535 Mdot
.32616 .391 Mdot
.5927 .85229 Mdot
.24909 .58615 Mdot
.47811 .85594 Mdot
.73691 .76297 Mdot
.73932 .40629 Mdot
.28005 .70942 Mdot
.80134 .55224 Mdot
.76023 .43532 Mdot
.80119 .61217 Mdot
.25509 .63599 Mdot
.26156 .5043 Mdot
.79249 .65649 Mdot
.25364 .62675 Mdot
.77392 .46125 Mdot
.37304 .81243 Mdot
.53741 .85846 Mdot
.60606 .31935 Mdot
.58079 .31305 Mdot
.7507 .7426 Mdot
.72192 .77669 Mdot
.77741 .69574 Mdot
.8005 .6043 Mdot
.40303 .33716 Mdot
.40105 .82782 Mdot
.72032 .7778 Mdot
.57485 .3125 Mdot
.64435 .33488 Mdot
.55995 .31031 Mdot
.25688 .52942 Mdot
.32033 .40146 Mdot
.25253 .59929 Mdot
.48667 .31169 Mdot
.6953 .36735 Mdot
.7404 .41212 Mdot
.31688 .75926 Mdot
.72493 .39487 Mdot
.78766 .5022 Mdot
.74821 .74296 Mdot
.49067 .8542 Mdot
.57303 .31362 Mdot
.29693 .73153 Mdot
.79112 .65016 Mdot
.52757 .85591 Mdot
.4464 .32226 Mdot
.40458 .33904 Mdot
.64049 .33548 Mdot
.26342 .51108 Mdot
.34377 .38066 Mdot
.26571 .50328 Mdot
.45904 .84698 Mdot
.33607 .38806 Mdot
.52452 .85528 Mdot
.51628 .85506 Mdot
.6744 .81138 Mdot
.6151 .8402 Mdot
.61393 .84059 Mdot
.77384 .47018 Mdot
.25478 .59648 Mdot
.28393 .45991 Mdot
.79777 .59653 Mdot
.53183 .31147 Mdot
.78187 .49165 Mdot
.29061 .44845 Mdot
.62764 .83472 Mdot
.75168 .73375 Mdot
.32485 .76433 Mdot
.77693 .68588 Mdot
.71536 .77704 Mdot
.51876 .8538 Mdot
.76178 .44956 Mdot
.4617 .32026 Mdot
.77117 .69755 Mdot
.34461 .78319 Mdot
.32382 .76209 Mdot
.78977 .52269 Mdot
.79615 .56798 Mdot
.42337 .83288 Mdot
.78608 .65732 Mdot
.78979 .64195 Mdot
.5757 .84845 Mdot
.48282 .84939 Mdot
.78677 .51341 Mdot
.78742 .51593 Mdot
.66319 .35083 Mdot
.79356 .54888 Mdot
.71158 .77862 Mdot
.67153 .35611 Mdot
.74922 .43182 Mdot
.7015 .78713 Mdot
.34669 .78322 Mdot
.67497 .80698 Mdot
.79346 .61082 Mdot
.52081 .85148 Mdot
.65768 .81715 Mdot
.4899 .84889 Mdot
.3916 .81505 Mdot
.74504 .42775 Mdot
.73697 .41703 Mdot
.29897 .72533 Mdot
.5242 .31517 Mdot
.5886 .32251 Mdot
.29648 .72059 Mdot
.25864 .58019 Mdot
.62738 .3354 Mdot
.26869 .51232 Mdot
.79336 .58263 Mdot
.68817 .37124 Mdot
.77308 .68366 Mdot
.30297 .43769 Mdot
.66437 .8108 Mdot
.68805 .79463 Mdot
.50818 .84858 Mdot
.69448 .78922 Mdot
.64279 .3438 Mdot
.66546 .80977 Mdot
.26181 .61086 Mdot
.43226 .83171 Mdot
.29794 .71896 Mdot
.64595 .82029 Mdot
.56091 .31961 Mdot
.62679 .33717 Mdot
.2849 .69364 Mdot
.53695 .31785 Mdot
.32483 .75562 Mdot
.68134 .798 Mdot
.6517 .34955 Mdot
.72973 .41332 Mdot
.3533 .3824 Mdot
.66573 .35787 Mdot
.7407 .4276 Mdot
.40733 .34661 Mdot
.27524 .66655 Mdot
.3184 .74661 Mdot
.70747 .39031 Mdot
.77362 .48931 Mdot
.29815 .71643 Mdot
.64812 .81738 Mdot
.46753 .32558 Mdot
.53506 .84691 Mdot
.3954 .81232 Mdot
.73526 .42175 Mdot
.5916 .83852 Mdot
.26496 .61675 Mdot
.74728 .43972 Mdot
.33498 .40233 Mdot
.4145 .82096 Mdot
.45018 .83443 Mdot
.77962 .65207 Mdot
.73819 .42842 Mdot
.57595 .32558 Mdot
.48327 .84146 Mdot
.41025 .81775 Mdot
.65506 .35517 Mdot
.3371 .76379 Mdot
.52034 .84462 Mdot
.3625 .37903 Mdot
.5955 .33083 Mdot
.62802 .82382 Mdot
.73714 .42856 Mdot
.33584 .76154 Mdot
.27468 .51413 Mdot
.782 .53213 Mdot
.49587 .84196 Mdot
.73763 .43058 Mdot
.77906 .6461 Mdot
.36951 .79106 Mdot
.41838 .34599 Mdot
.68675 .37791 Mdot
.73979 .43439 Mdot
.30722 .44301 Mdot
.55733 .32489 Mdot
.27707 .509 Mdot
.34185 .39982 Mdot
.43047 .82458 Mdot
.26694 .59699 Mdot
.32685 .41679 Mdot
.67444 .79621 Mdot
.78566 .59269 Mdot
.78481 .56104 Mdot
.66769 .80051 Mdot
.69975 .77575 Mdot
.65833 .35991 Mdot
.2915 .47321 Mdot
.30552 .71879 Mdot
.55212 .84085 Mdot
.39312 .80523 Mdot
.28028 .50189 Mdot
.56202 .83952 Mdot
.78311 .55022 Mdot
.75897 .46969 Mdot
.30761 .44469 Mdot
.31706 .73516 Mdot
.27827 .51004 Mdot
.38109 .36946 Mdot
.30508 .71616 Mdot
.40191 .80927 Mdot
.27513 .52362 Mdot
.61959 .82356 Mdot
.70381 .77014 Mdot
.7515 .45735 Mdot
.27023 .55235 Mdot
.26945 .56131 Mdot
.7705 .50113 Mdot
.31175 .44065 Mdot
.6553 .3602 Mdot
.55698 .83859 Mdot
.75669 .69777 Mdot
.78088 .54535 Mdot
.37874 .37239 Mdot
.27422 .63335 Mdot
.46232 .83184 Mdot
.78047 .61938 Mdot
.31341 .72612 Mdot
.70479 .39884 Mdot
.27032 .58594 Mdot
.29048 .48348 Mdot
.27344 .62279 Mdot
.34968 .39776 Mdot
.27171 .557 Mdot
.55294 .83745 Mdot
.36489 .78133 Mdot
.37022 .7855 Mdot
.67038 .79407 Mdot
.76833 .66478 Mdot
.68004 .78676 Mdot
.29689 .69466 Mdot
.46399 .83038 Mdot
.27318 .55224 Mdot
.47532 .83263 Mdot
.2716 .58623 Mdot
.77624 .5346 Mdot
.32234 .43075 Mdot
.27193 .57743 Mdot
.58581 .33591 Mdot
.56547 .33192 Mdot
.40293 .80517 Mdot
.3204 .43449 Mdot
.60849 .34289 Mdot
.33638 .75118 Mdot
.72313 .74289 Mdot
.72827 .42988 Mdot
.36102 .39091 Mdot
.72877 .73518 Mdot
.40651 .35987 Mdot
.48476 .83232 Mdot
.75316 .47178 Mdot
.56401 .33348 Mdot
.28181 .64479 Mdot
.50322 .83411 Mdot
.44115 .34569 Mdot
.28684 .50522 Mdot
.44207 .34585 Mdot
.66778 .79112 Mdot
.69387 .77061 Mdot
.65572 .36749 Mdot
.53456 .33188 Mdot
.77713 .59646 Mdot
.27573 .5993 Mdot
.44783 .82139 Mdot
.69209 .39534 Mdot
.29371 .67578 Mdot
.59127 .34124 Mdot
.4298 .35244 Mdot
.27677 .58931 Mdot
.27875 .61344 Mdot
.31792 .44621 Mdot
.4015 .36728 Mdot
.45258 .34501 Mdot
.76941 .63757 Mdot
.64324 .36332 Mdot
.51411 .8316 Mdot
.46209 .34257 Mdot
.61938 .35241 Mdot
.47627 .33948 Mdot
.29481 .67309 Mdot
.41456 .80476 Mdot
.28505 .64156 Mdot
.42401 .80909 Mdot
.39606 .37197 Mdot
.74678 .69627 Mdot
.28042 .61249 Mdot
.77271 .55907 Mdot
.4952 .33807 Mdot
.31876 .44945 Mdot
.76539 .64405 Mdot
.32894 .43501 Mdot
.27963 .58264 Mdot
.29191 .5063 Mdot
.29315 .66287 Mdot
.49228 .82701 Mdot
.71975 .7355 Mdot
.50856 .33753 Mdot
.57088 .3411 Mdot
.65513 .37352 Mdot
.75739 .66716 Mdot
.54279 .33771 Mdot
.65162 .3716 Mdot
.74499 .69493 Mdot
.71846 .73598 Mdot
.68121 .39283 Mdot
.77013 .55723 Mdot
.54457 .82745 Mdot
.7068 .4174 Mdot
.76953 .61171 Mdot
.64444 .36849 Mdot
.73989 .46323 Mdot
.38362 .78187 Mdot
.50178 .33982 Mdot
.74449 .47287 Mdot
.69633 .40766 Mdot
.55272 .82583 Mdot
.77013 .57147 Mdot
.56917 .8233 Mdot
.59839 .81614 Mdot
.76281 .64301 Mdot
.52476 .82687 Mdot
.41722 .80111 Mdot
.74389 .47341 Mdot
.68313 .7687 Mdot
.7551 .50128 Mdot
.728 .44775 Mdot
.76837 .56546 Mdot
.47953 .82105 Mdot
.3297 .72475 Mdot
.45904 .35039 Mdot
.29811 .50247 Mdot
.5998 .35273 Mdot
.76604 .55205 Mdot
.41676 .36766 Mdot
.54731 .82372 Mdot
.54095 .82406 Mdot
.71431 .73444 Mdot
.47418 .34752 Mdot
.737 .46588 Mdot
.69264 .75746 Mdot
.29097 .5315 Mdot
.2964 .5124 Mdot
.63303 .36778 Mdot
.45211 .81139 Mdot
.72981 .45581 Mdot
.52209 .34324 Mdot
.36541 .40572 Mdot
.28693 .58016 Mdot
.36898 .76331 Mdot
.32737 .71568 Mdot
.67586 .7691 Mdot
.75872 .63602 Mdot
.42018 .79644 Mdot
.29111 .54544 Mdot
.41367 .79279 Mdot
.39515 .78163 Mdot
.55208 .34667 Mdot
.3154 .47326 Mdot
.76348 .59602 Mdot
.69201 .75297 Mdot
.51477 .34602 Mdot
.63605 .79337 Mdot
.36113 .41289 Mdot
.37185 .40328 Mdot
.64231 .37662 Mdot
.37138 .40408 Mdot
.7479 .6645 Mdot
.75426 .52216 Mdot
.60511 .36088 Mdot
.59386 .35737 Mdot
.36752 .40904 Mdot
.75981 .61338 Mdot
.36812 .75746 Mdot
.76098 .60068 Mdot
.33522 .72033 Mdot
.56698 .81458 Mdot
.60488 .36173 Mdot
.58025 .35469 Mdot
.34901 .42948 Mdot
.71799 .44793 Mdot
.75206 .51974 Mdot
.39546 .7775 Mdot
.3043 .50821 Mdot
.35449 .42392 Mdot
.30379 .65538 Mdot
.62772 .79337 Mdot
.39023 .77175 Mdot
.75693 .5533 Mdot
.75537 .62171 Mdot
.71195 .4436 Mdot
.68772 .41622 Mdot
.29469 .59702 Mdot
.34712 .43607 Mdot
.46802 .35928 Mdot
.7465 .51366 Mdot
.58127 .35917 Mdot
.38814 .39905 Mdot
.36407 .42013 Mdot
.30017 .62109 Mdot
.32001 .48312 Mdot
.71932 .70638 Mdot
.30645 .51935 Mdot
.34848 .72705 Mdot
.63999 .38451 Mdot
.74844 .52952 Mdot
.44387 .79557 Mdot
.53532 .35533 Mdot
.38262 .40619 Mdot
.32921 .6971 Mdot
.48668 .80723 Mdot
.39971 .77217 Mdot
.35581 .7337 Mdot
.43061 .37708 Mdot
.6741 .75532 Mdot
.30634 .52712 Mdot
.58036 .36274 Mdot
.71451 .45652 Mdot
.39129 .40092 Mdot
.30261 .54773 Mdot
.56979 .36083 Mdot
.7191 .46451 Mdot
.61257 .79184 Mdot
.39973 .39591 Mdot
.34647 .71957 Mdot
.32935 .69316 Mdot
.30088 .57413 Mdot
.74981 .61314 Mdot
.65724 .76655 Mdot
.36248 .42822 Mdot
.33353 .69929 Mdot
.6459 .7737 Mdot
.47463 .80189 Mdot
.39038 .40391 Mdot
.43167 .3793 Mdot
.67543 .75067 Mdot
.38792 .40649 Mdot
.48849 .80361 Mdot
.74974 .59269 Mdot
.30675 .6248 Mdot
.61512 .37803 Mdot
.38096 .41338 Mdot
.73783 .65475 Mdot
.61237 .78894 Mdot
.64495 .77196 Mdot
.50751 .80519 Mdot
.71308 .7047 Mdot
.7469 .55127 Mdot
.55985 .36271 Mdot
.70305 .7179 Mdot
.40343 .398 Mdot
.74276 .53362 Mdot
.63552 .77595 Mdot
.44697 .7899 Mdot
.45672 .37271 Mdot
.31723 .65568 Mdot
.34468 .70907 Mdot
.31025 .62987 Mdot
.3704 .42674 Mdot
.53925 .36276 Mdot
.31119 .53486 Mdot
.7205 .68688 Mdot
.48162 .36764 Mdot
.3125 .53152 Mdot
.31916 .65682 Mdot
.39848 .76176 Mdot
.62087 .38471 Mdot
.66166 .40998 Mdot
.3244 .66929 Mdot
.69379 .44129 Mdot
.74553 .58362 Mdot
.41757 .77321 Mdot
.72083 .68355 Mdot
.32157 .50539 Mdot
.68772 .43531 Mdot
.73296 .51121 Mdot
.70564 .45801 Mdot
.74406 .56411 Mdot
.30852 .59894 Mdot
.56164 .79846 Mdot
.31655 .52245 Mdot
.67861 .4267 Mdot
.42771 .77739 Mdot
.52843 .80089 Mdot
.53174 .80071 Mdot
.40287 .7623 Mdot
.70752 .46345 Mdot
.7432 .59101 Mdot
.47237 .37296 Mdot
.63865 .39758 Mdot
.55043 .36778 Mdot
.34203 .6968 Mdot
.60698 .38227 Mdot
.74239 .58731 Mdot
.42309 .77261 Mdot
.69686 .71508 Mdot
.66067 .41439 Mdot
.71898 .67972 Mdot
.68119 .4333 Mdot
.38106 .74132 Mdot
.60826 .78151 Mdot
.64866 .40676 Mdot
.50906 .36924 Mdot
.73589 .5403 Mdot
.4505 .78304 Mdot
.57072 .37439 Mdot
.42283 .39662 Mdot
.7173 .67738 Mdot
.33971 .48064 Mdot
.32526 .6526 Mdot
.69979 .46064 Mdot
.68247 .72682 Mdot
.68701 .44441 Mdot
.67205 .73718 Mdot
.69095 .44938 Mdot
.73826 .57827 Mdot
.35582 .45722 Mdot
.73128 .53029 Mdot
.31484 .57369 Mdot
.65298 .75229 Mdot
.62999 .39885 Mdot
.52939 .37171 Mdot
.40121 .41415 Mdot
.53003 .37324 Mdot
.71978 .66381 Mdot
.63845 .75999 Mdot
.72082 .50579 Mdot
.68894 .71391 Mdot
.61592 .39452 Mdot
.71415 .49209 Mdot
.59448 .78028 Mdot
.34468 .68557 Mdot
.35373 .6999 Mdot
.73359 .60334 Mdot
.65114 .41638 Mdot
.39681 .42 Mdot
.67637 .72668 Mdot
.56482 .37889 Mdot
.43894 .77139 Mdot
.52497 .37551 Mdot
.66829 .4321 Mdot
.72013 .51101 Mdot
.69432 .46295 Mdot
.33159 .51641 Mdot
.32954 .6432 Mdot
.59214 .38834 Mdot
.6059 .7721 Mdot
.32835 .53038 Mdot
.72972 .60375 Mdot
.52107 .37872 Mdot
.35783 .46784 Mdot
.42514 .40617 Mdot
.54727 .78563 Mdot
.52151 .78662 Mdot
.36563 .45801 Mdot
.70591 .4875 Mdot
.32363 .60049 Mdot
.34122 .49963 Mdot
.51877 .38053 Mdot
.71825 .51851 Mdot
.34156 .50022 Mdot
.40279 .42276 Mdot
.70011 .47972 Mdot
.6845 .70893 Mdot
.36462 .70363 Mdot
.72789 .58197 Mdot
.67091 .44292 Mdot
.49286 .78154 Mdot
.50773 .78315 Mdot
.63843 .74934 Mdot
.60055 .39702 Mdot
.40866 .42096 Mdot
.55017 .78149 Mdot
.47495 .38996 Mdot
.69813 .48163 Mdot
.4153 .41768 Mdot
.32776 .57078 Mdot
.53153 .78164 Mdot
.54219 .3852 Mdot
.36072 .47398 Mdot
.34429 .50467 Mdot
.64869 .42743 Mdot
.3697 .46238 Mdot
.61981 .4091 Mdot
.56643 .38997 Mdot
.70538 .50059 Mdot
.40816 .74018 Mdot
.37192 .70461 Mdot
.34821 .50007 Mdot
.33043 .56813 Mdot
.61471 .75796 Mdot
.71353 .64087 Mdot
.64714 .73662 Mdot
.42058 .74718 Mdot
.4183 .74551 Mdot
.33321 .56023 Mdot
.53838 .38928 Mdot
.54473 .77583 Mdot
.62232 .41505 Mdot
.69741 .49377 Mdot
.34405 .5198 Mdot
.35545 .49422 Mdot
.7184 .5707 Mdot
.46837 .76653 Mdot
.35123 .6622 Mdot
.66373 .71695 Mdot
.37385 .69923 Mdot
.3717 .69634 Mdot
.45984 .40327 Mdot
.70926 .52776 Mdot
.70467 .65137 Mdot
.60853 .41062 Mdot
.59215 .40392 Mdot
.47895 .39848 Mdot
.34154 .62889 Mdot
.70275 .65441 Mdot
.45149 .4081 Mdot
.39558 .72113 Mdot
.63306 .74016 Mdot
.66327 .45176 Mdot
.55181 .39547 Mdot
.64788 .4382 Mdot
.33784 .59009 Mdot
.35408 .65964 Mdot
.66323 .71208 Mdot
.36037 .49479 Mdot
.61647 .41836 Mdot
.6672 .70661 Mdot
.39922 .44561 Mdot
.58027 .40403 Mdot
.70786 .53954 Mdot
.428 .74159 Mdot
.54263 .76882 Mdot
.53924 .39698 Mdot
.52572 .76938 Mdot
.53224 .3968 Mdot
.51235 .76867 Mdot
.60252 .75273 Mdot
.60638 .41524 Mdot
.34208 .55989 Mdot
.54461 .3984 Mdot
.48003 .40335 Mdot
.44875 .41455 Mdot
.57587 .40462 Mdot
.69096 .66743 Mdot
.42058 .43122 Mdot
.4685 .40773 Mdot
.56088 .76417 Mdot
.43257 .7417 Mdot
.39685 .71373 Mdot
.68351 .48833 Mdot
.48275 .40492 Mdot
.55942 .76324 Mdot
.51655 .40031 Mdot
.35527 .51832 Mdot
.56057 .40363 Mdot
.46741 .75568 Mdot
.37953 .47482 Mdot
.34616 .61075 Mdot
.44537 .74627 Mdot
.45765 .41472 Mdot
.4112 .72332 Mdot
.6213 .42853 Mdot
.38321 .47222 Mdot
.65382 .71107 Mdot
.34945 .61893 Mdot
.45303 .4185 Mdot
.63302 .72806 Mdot
.62085 .73612 Mdot
.40333 .45262 Mdot
.48846 .7582 Mdot
.38697 .47061 Mdot
.69859 .53594 Mdot
.69917 .53831 Mdot
.55154 .40645 Mdot
.68797 .65832 Mdot
.41426 .72165 Mdot
.70097 .61776 Mdot
.64724 .71317 Mdot
.44551 .42492 Mdot
.36405 .6546 Mdot
.58123 .75161 Mdot
.5843 .75031 Mdot
.44361 .42654 Mdot
.4088 .71435 Mdot
.36434 .65236 Mdot
.45872 .74565 Mdot
.5861 .41751 Mdot
.62318 .72988 Mdot
.56015 .75552 Mdot
.70147 .58515 Mdot
.69799 .54828 Mdot
.52002 .75774 Mdot
.41345 .7162 Mdot
.35662 .54351 Mdot
.39075 .47396 Mdot
.66417 .68894 Mdot
.35287 .57641 Mdot
.68937 .52442 Mdot
.67337 .49373 Mdot
.6887 .52708 Mdot
.63823 .45295 Mdot
.63407 .44987 Mdot
.50354 .41357 Mdot
.49615 .41497 Mdot
.35849 .55249 Mdot
.467 .42395 Mdot
.37915 .66755 Mdot
.6131 .72874 Mdot
.38015 .49744 Mdot
.47421 .74415 Mdot
.44148 .43675 Mdot
.49343 .74863 Mdot
.68859 .62934 Mdot
.68872 .62743 Mdot
.47369 .4233 Mdot
.69358 .59975 Mdot
.39617 .68907 Mdot
.35919 .56883 Mdot
.69371 .58527 Mdot
.6578 .47971 Mdot
.39478 .48205 Mdot
.40185 .47408 Mdot
.63974 .46275 Mdot
.37249 .64341 Mdot
.68989 .56289 Mdot
.51301 .74715 Mdot
.50782 .41974 Mdot
.56128 .74339 Mdot
.4499 .72701 Mdot
.62626 .71164 Mdot
.56348 .42531 Mdot
.55301 .74278 Mdot
.62394 .712 Mdot
.68725 .56838 Mdot
.57654 .73651 Mdot
.36603 .59871 Mdot
.51334 .74341 Mdot
.43833 .44861 Mdot
.65995 .67139 Mdot
.47272 .73395 Mdot
.36674 .56996 Mdot
.59085 .72922 Mdot
.39824 .48771 Mdot
.53664 .74192 Mdot
.44445 .44651 Mdot
.57614 .4321 Mdot
.65789 .67204 Mdot
.3823 .65004 Mdot
.68349 .56339 Mdot
.50454 .73932 Mdot
.52739 .74023 Mdot
.64853 .68186 Mdot
.3704 .59777 Mdot
.68 .55419 Mdot
.63782 .69247 Mdot
.43684 .45591 Mdot
.4551 .72108 Mdot
.5648 .43303 Mdot
.63734 .47523 Mdot
.42358 .69867 Mdot
.37687 .62018 Mdot
.37951 .53676 Mdot
.41688 .69039 Mdot
.67559 .55335 Mdot
.49079 .73051 Mdot
.4502 .45294 Mdot
.67556 .56246 Mdot
.43204 .70058 Mdot
.37811 .55896 Mdot
.37964 .55208 Mdot
.65464 .65994 Mdot
.4114 .67808 Mdot
.41594 .6833 Mdot
.44341 .45914 Mdot
.48786 .43964 Mdot
.67259 .6075 Mdot
.45578 .71338 Mdot
.6517 .66116 Mdot
.41624 .48473 Mdot
.61916 .69725 Mdot
.63851 .67826 Mdot
.66198 .52775 Mdot
.38001 .57875 Mdot
.60752 .46158 Mdot
.52151 .72782 Mdot
.64541 .50156 Mdot
.38425 .55909 Mdot
.44411 .46509 Mdot
.4038 .50978 Mdot
.61764 .69268 Mdot
.38671 .55704 Mdot
.5941 .4585 Mdot
.6137 .4717 Mdot
.51572 .44194 Mdot
.43273 .4771 Mdot
.56267 .7193 Mdot
.41206 .66288 Mdot
.59935 .46466 Mdot
.44031 .69234 Mdot
.41858 .67088 Mdot
.63037 .67484 Mdot
.63014 .49123 Mdot
.57137 .45213 Mdot
.6427 .65796 Mdot
.44337 .47234 Mdot
.49856 .44758 Mdot
.6119 .69034 Mdot
.42482 .67521 Mdot
.40187 .64013 Mdot
.66238 .57202 Mdot
.5568 .71586 Mdot
.49053 .45199 Mdot
.41 .51301 Mdot
.41531 .5049 Mdot
.45368 .69754 Mdot
.6073 .69153 Mdot
.58859 .70302 Mdot
.56072 .45243 Mdot
.66042 .59808 Mdot
.59829 .46927 Mdot
.47003 .70461 Mdot
.44112 .47984 Mdot
.49863 .45241 Mdot
.44668 .4759 Mdot
.58462 .46299 Mdot
.58046 .46139 Mdot
.39488 .56433 Mdot
.65234 .54171 Mdot
.44017 .68374 Mdot
.65405 .55282 Mdot
.63808 .51503 Mdot
.55409 .709 Mdot
.65493 .57419 Mdot
.41901 .65328 Mdot
.63196 .51039 Mdot
.47154 .46731 Mdot
.65309 .56595 Mdot
.44391 .68087 Mdot
.6116 .67823 Mdot
.40366 .55037 Mdot
.39963 .58725 Mdot
.57319 .70056 Mdot
.58176 .46933 Mdot
.64471 .62661 Mdot
.4046 .61418 Mdot
.44789 .68103 Mdot
.50035 .7052 Mdot
.49511 .70383 Mdot
.50958 .46074 Mdot
.40847 .61851 Mdot
.5038 .4643 Mdot
.64313 .5547 Mdot
.46553 .48067 Mdot
.40888 .58708 Mdot
.63281 .63251 Mdot
.53355 .46581 Mdot
.60645 .66846 Mdot
.44019 .66189 Mdot
.42957 .64818 Mdot
.57372 .68949 Mdot
.53955 .46747 Mdot
.42475 .63945 Mdot
.62947 .63636 Mdot
.42933 .51929 Mdot
.50255 .69635 Mdot
.62023 .64929 Mdot
.41562 .55446 Mdot
.63746 .60572 Mdot
.63922 .57822 Mdot
.63686 .60556 Mdot
.4818 .47973 Mdot
.41899 .54955 Mdot
.44409 .50724 Mdot
.44135 .51093 Mdot
.49041 .68819 Mdot
.47682 .4844 Mdot
.6135 .51552 Mdot
.61953 .52413 Mdot
.55433 .4765 Mdot
.5139 .47511 Mdot
.44046 .51693 Mdot
.62103 .53063 Mdot
.4453 .51134 Mdot
.48853 .68419 Mdot
.42161 .60881 Mdot
.55796 .68601 Mdot
.45521 .66311 Mdot
.60169 .50781 Mdot
.4689 .67222 Mdot
.53328 .47728 Mdot
.63207 .57707 Mdot
.63199 .57724 Mdot
.60887 .51721 Mdot
.52078 .47825 Mdot
.48353 .48771 Mdot
.45802 .50418 Mdot
.51475 .68655 Mdot
.62264 .54617 Mdot
.59935 .65431 Mdot
.58905 .66347 Mdot
.61679 .62846 Mdot
.46544 .50275 Mdot
.5074 .48416 Mdot
.58878 .66186 Mdot
.49347 .48797 Mdot
.5525 .48601 Mdot
.43039 .61101 Mdot
.53469 .48368 Mdot
.46345 .5057 Mdot
.5422 .4853 Mdot
.62213 .55919 Mdot
.6241 .57248 Mdot
.49733 .48913 Mdot
.45498 .65034 Mdot
.58823 .50709 Mdot
.62395 .58977 Mdot
.55296 .48992 Mdot
.62073 .56909 Mdot
.44678 .6356 Mdot
.53076 .48826 Mdot
.61927 .60096 Mdot
.57374 .66262 Mdot
.55281 .49444 Mdot
.43404 .58543 Mdot
.60055 .52982 Mdot
.57351 .66116 Mdot
.48432 .50232 Mdot
.43773 .56334 Mdot
.50916 .67169 Mdot
.58058 .65513 Mdot
.55694 .49826 Mdot
.43677 .57787 Mdot
.43943 .56389 Mdot
.60981 .55265 Mdot
.49639 .49937 Mdot
.47941 .50833 Mdot
.6109 .60684 Mdot
.49411 .66434 Mdot
.54769 .49827 Mdot
.44544 .55027 Mdot
.51266 .4974 Mdot
.46977 .51731 Mdot
.55697 .66385 Mdot
.47159 .64837 Mdot
.44664 .61054 Mdot
.46444 .52629 Mdot
.57996 .51877 Mdot
.44961 .61533 Mdot
.51685 .66461 Mdot
.60714 .59108 Mdot
.52348 .50202 Mdot
.60302 .55879 Mdot
.51463 .50367 Mdot
.59075 .53795 Mdot
.5043 .6576 Mdot
.50937 .50761 Mdot
.54116 .50814 Mdot
.53771 .65777 Mdot
.45235 .59787 Mdot
.47329 .63589 Mdot
.5477 .51427 Mdot
.58609 .62224 Mdot
.47704 .63382 Mdot
.56898 .52773 Mdot
.57439 .53253 Mdot
.57205 .63436 Mdot
.48686 .6377 Mdot
.5082 .51851 Mdot
.56958 .6336 Mdot
.5437 .52467 Mdot
.54098 .64005 Mdot
.4791 .54939 Mdot
.57854 .56193 Mdot
.47092 .57718 Mdot
.53637 .63745 Mdot
.4721 .59024 Mdot
.56638 .61991 Mdot
.5199 .63663 Mdot
.48155 .61178 Mdot
.54576 .53635 Mdot
.47882 .56605 Mdot
.50383 .62751 Mdot
.4973 .54436 Mdot
.57349 .59229 Mdot
.48257 .56713 Mdot
.54144 .62697 Mdot
.51075 .62658 Mdot
.55532 .54749 Mdot
.5547 .54743 Mdot
.50886 .6227 Mdot
.56338 .56367 Mdot
.48626 .57143 Mdot
.48772 .59594 Mdot
.54865 .55202 Mdot
.55479 .60849 Mdot
.51903 .6178 Mdot
.52766 .54789 Mdot
.5448 .61239 Mdot
.55481 .59692 Mdot
.52844 .55435 Mdot
.50958 .56474 Mdot
.50378 .59084 Mdot
.53535 .60466 Mdot
.52655 .60599 Mdot
.51756 .56257 Mdot
.53589 .58826 Mdot
.25 Mabswid
.67251 0 m
.92716 .41491 L
s
.92716 .41491 m
1 .94789 L
s
1 .94789 m
.70649 .58523 L
s
.70649 .58523 m
.67251 0 L
s
.08841 .24557 m
0 .80354 L
s
0 .80354 m
.70649 .58523 L
s
.70649 .58523 m
.67251 0 L
s
.67251 0 m
.08841 .24557 L
s
.08841 .24557 m
.67251 0 L
s
.10076 .24038 m
.10584 .2456 L
s
[(-1)] .0906 .22993 .97204 1 Mshowa
.22864 .18661 m
.23347 .19207 L
s
[(-0.5)] .21899 .1757 .88464 1 Mshowa
.36356 .12989 m
.3681 .13559 L
s
[(0)] .35448 .11849 .79725 1 Mshowa
.50612 .06996 m
.51033 .0759 L
s
[(0.5)] .49768 .05807 .70985 1 Mshowa
.65697 .00653 m
.66082 .01272 L
s
[(1)] .64927 -0.00584 .62246 1 Mshowa
.125 Mabswid
.1258 .22985 m
.12882 .23301 L
s
.1511 .21921 m
.15409 .2224 L
s
.17668 .20846 m
.17963 .21168 L
s
.20252 .1976 m
.20545 .20084 L
s
.25504 .17551 m
.25791 .17882 L
s
.28173 .16429 m
.28456 .16762 L
s
.30871 .15295 m
.31151 .15631 L
s
.33599 .14148 m
.33875 .14487 L
s
.39144 .11817 m
.39413 .12162 L
s
.41963 .10632 m
.42228 .10979 L
s
.44814 .09433 m
.45075 .09784 L
s
.47696 .08221 m
.47953 .08575 L
s
.5356 .05756 m
.53809 .06115 L
s
.56542 .04502 m
.56787 .04865 L
s
.59559 .03234 m
.59799 .03599 L
s
.6261 .01951 m
.62846 .02319 L
s
.25 Mabswid
0 .80354 m
.4003 1.08529 L
s
.01169 .81177 m
.01281 .80457 L
s
[(-1)] .00947 .82618 .15455 -1 Mshowa
.12245 .88973 m
.12331 .88249 L
s
[(-0.5)] .12074 .9042 .11851 -1 Mshowa
.22181 .95966 m
.22244 .9524 L
s
[(0)] .22053 .97417 .08756 -1 Mshowa
.31143 1.02274 m
.31187 1.01546 L
s
[(0.5)] .31055 1.03728 .06068 -1 Mshowa
.39269 1.07993 m
.39296 1.07264 L
s
[(1)] .39214 1.09449 .03714 -1 Mshowa
.125 Mabswid
.03485 .82807 m
.03549 .82375 L
s
.05749 .84401 m
.05809 .83968 L
s
.07962 .85958 m
.0802 .85525 L
s
.10127 .87482 m
.10182 .87048 L
s
.14318 .90431 m
.14366 .89997 L
s
.16346 .91859 m
.16392 .91424 L
s
.18332 .93257 m
.18375 .92822 L
s
.20276 .94625 m
.20317 .9419 L
s
.24046 .97279 m
.24082 .96843 L
s
.25874 .98565 m
.25907 .98129 L
s
.27665 .99826 m
.27696 .9939 L
s
.29421 1.01062 m
.2945 1.00626 L
s
.32831 1.03462 m
.32855 1.03025 L
s
.34487 1.04627 m
.34509 1.0419 L
s
.36111 1.0577 m
.36131 1.05333 L
s
.37705 1.06892 m
.37723 1.06455 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{408.312, 443.125},
  ImageMargins->{{92, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006H0001^a000`40n007h00OooooVOoo003ooonI
ool00?ooo`Soo`@008goo`00oooo2_oo00<00?ooool0S?oo003oool:ool00`00ooooo`2<ool00?oo
o`[oo`03003ooooo08coo`00oooo2_oo00<00?ooool0S?oo003oool8ool3002>ool00?ooo`[oo`03
003ooooo08coo`00ooooVOoo003ooonIool00?oooiWoo`00oooo5?oo0P00Pooo003ooolBool20000
0ooo00000022ool00?ooo`ooo`<000?oo`8008;oo`00oooo3Ooo10001?oo00<00?oo0000POoo003o
ool;ool20003ool00`00ooooo`02ool00`00ool00021ool00?ooo`Soo`<000Koo`05003oooooool0
0002ool00`00ooooo`1nool00?ooo`Koo`8000goo`05003oooooool0001oool00?ooo`?oo`<000oo
o`05003oooooool0001oool00?ooo`7oo`<0017oo`03003ooooo00;oo`03003ooooo07coo`00o_oo
0P000ooo00<00?ooool03ooo00<00?ooool00_oo00<00?ooool0Nooo003kool3000Gool00`00oooo
o`02ool00`00ooooo`1kool00?Woo`8001[oo`03003ooooo00?oo`03003ooooo07[oo`00mooo0P00
7?oo00<00?ooool00ooo00<00?ooool0N_oo003dool4000Mool00`00ooooo`04ool00`00ooooo`1i
ool00?;oo`80027oo`03003ooooo00Goo`03003ooooo07Soo`00`ooo0P001?oo00<00?ooool00_oo
0`007_oo0`008ooo00<00?ooool01Ooo00<00?ooool0N?oo0032ool01000ooooo`002ooo00<00?oo
ool06Ooo0P009_oo00<00?ooool01_oo00<00?ooool0Mooo0032ool01000ooooo`002ooo00<00?oo
ool05ooo0P00:?oo00<00?ooool01_oo00<00?ooool0Mooo0032ool01000ooooo`002?oo0`005ooo
0`0000?oo`00ool09ooo00<00?ooool01ooo00<00?ooool0M_oo0032ool01000ooooo`002?oo00<0
0?ooool05Ooo0P00;Ooo00<00?ooool02?oo00<00?ooool0MOoo0032ool01000ooooo`002?oo00<0
0?ooool04_oo0`00;ooo00<00?ooool02?oo00<00?ooool0MOoo0033ool20009ool4000?ool2000b
ool00`00ooooo`09ool00`00ooooo`1dool00=ooo`8003Coo`03003ooooo00Woo`03003ooooo07Co
o`00g?oo0`0000?oo`00ool0<ooo00<00?ooool02_oo00<00?ooool0Looo003Jool2000iool00`00
ooooo`0;ool00`00ooooo`1bool00=Ooo`<003_oo`03003ooooo00_oo`03003ooooo07;oo`00eOoo
0P00?ooo00<00?ooool02ooo00<00?ooool0LOoo003Cool20011ool00`00ooooo`0<ool00`00oooo
o`1`ool00=3oo`<000;oo`03003ooooo03koo`03003ooooo00coo`03003ooooo073oo`00c_oo0P00
1_oo00<00?ooool0?Ooo00<00?ooool03Ooo00<00?ooool0Kooo003;ool30018ool00`00ooooo`0=
ool00`00ooooo`1_ool00<Woo`8004_oo`03003ooooo00koo`03003ooooo06koo`00aooo0`00C?oo
00<00?ooool03ooo00<00?ooool0KOoo0034ool30003ool00`00ooooo`19ool00`00ooooo`0?ool0
0`00ooooo`1]ool00<;oo`8005;oo`03003ooooo013oo`03003ooooo06coo`00`?oo0P00E?oo00<0
0?ooool04?oo00<00?ooool0K?oo002mool3001Fool00`00ooooo`0Aool00`00ooooo`1[ool00;_o
o`8000;oo`03003ooooo05Coo`03003ooooo01;oo`03003ooooo06[oo`00U_oo0P008?oo0`00Fooo
00<00?ooool04_oo00<00?ooool0J_oo002Eool01000ooooo`007Ooo0P00G_oo00<00?ooool04ooo
00<00?ooool0JOoo002Eool01000ooooo`006ooo0P00H?oo00<00?ooool04ooo00<00?ooool0JOoo
002Eool01000ooooo`006?oo0`00H_oo00<00?ooool05?oo00<00?ooool0J?oo002Eool01000oooo
o`005_oo0P000ooo00<00?ooool0Gooo00<00?ooool05Ooo00<00?ooool0Iooo002Eool01000oooo
o`004ooo0`00Iooo00<00?ooool05Ooo00<00?ooool0Iooo002Fool2000Bool2001[ool00`00oooo
o`0Eool00`00ooooo`1Vool00:Soo`8006goo`03003ooooo01Koo`03003ooooo06Goo`00YOoo1000
K_oo00<00?ooool05_oo00<00?ooool0IOoo002Sool20004ool00`00ooooo`1[ool00`00ooooo`0G
ool00`00ooooo`1Tool00:3oo`<007Coo`03003ooooo01Ooo`03003ooooo06Coo`00W_oo0P00Mooo
00<00?ooool06?oo00<00?ooool0Hooo002Lool2001iool00`00ooooo`0Iool00`00ooooo`1Rool0
09Woo`<000;oo`03003ooooo07Koo`03003ooooo01Woo`03003ooooo06;oo`00Uooo0P001_oo00<0
0?ooool0MOoo00<00?ooool06_oo00<00?ooool0HOoo002Dool30020ool00`00ooooo`0Jool00`00
ooooo`1Qool009;oo`8008?oo`03003ooooo01_oo`03003ooooo063oo`00T?oo0P000_oo00<00?oo
ool0P?oo00<00?ooool07?oo00<00?ooool0Gooo002=ool30027ool00`00ooooo`0Lool00`00oooo
o`1Oool008_oo`8008[oo`03003ooooo01goo`03003ooooo05koo`00R?oo0`00S?oo00<00?ooool0
7_oo00<00?ooool0GOoo0026ool3002>ool00`00ooooo`0Nool00`00ooooo`1Mool005Ooo`8000Co
o`03003ooooo00;oo`<001ooo`8000?oo`03003ooooo08_oo`03003ooooo01ooo`03003ooooo05co
o`00E_oo00@00?ooool000_oo`03003ooooo01Woo`<009Coo`03003ooooo01koo`03003ooooo05co
o`00E_oo00@00?ooool000_oo`03003ooooo01Ooo`8009Ooo`03003ooooo01ooo`03003ooooo05_o
o`00D?oo10000_oo00@00?ooool000Soo`<001Soo`8009Woo`03003ooooo023oo`03003ooooo05[o
o`00E_oo00@00?ooool000Soo`03003ooooo01Goo`<000;oo`03003ooooo09Koo`03003ooooo023o
o`03003ooooo05[oo`00E_oo00@00?ooool000Soo`03003ooooo01?oo`8009koo`03003ooooo027o
o`03003ooooo05Woo`00Eooo0P002Ooo10003ooo0`00X?oo00<00?ooool08Ooo00<00?ooool0FOoo
001cool2002Sool00`00ooooo`0Rool00`00ooooo`1Hool0077oo`<00:Coo`03003ooooo02?oo`03
003ooooo05Ooo`00K_oo0`000ooo00<00?ooool0XOoo00<00?ooool08ooo00<00?ooool0Eooo001/
ool2002Zool00`00ooooo`0Tool00`00ooooo`1Fool006Woo`<00:coo`03003ooooo02Coo`03003o
oooo05Koo`00Iooo0`00[_oo00<00?ooool09Ooo00<00?ooool0EOoo001Uool20003ool00`00oooo
o`2[ool00`00ooooo`0Vool00`00ooooo`1Dool006;oo`<000Koo`03003ooooo0:[oo`03003ooooo
02Koo`03003ooooo05Coo`00H?oo0P00]_oo00<00?ooool09ooo00<00?ooool0Dooo001Mool3002h
ool00`00ooooo`0Xool00`00ooooo`1Bool005_oo`8000?oo`03003ooooo0;Goo`03003ooooo02So
o`03003ooooo05;oo`00FOoo0P00__oo00<00?ooool0:?oo00<00?ooool0DOoo001Fool30030ool0
0`00ooooo`0Xool00`00ooooo`1Aool005Coo`800<?oo`03003ooooo02Woo`03003ooooo053oo`00
;ooo10007_oo0`000_oo00<00?ooool0`?oo00<00?ooool0:_oo00<00?ooool0Cooo000aool00`00
ooooo`0Kool20038ool00`00ooooo`0Zool00`00ooooo`1?ool0037oo`03003ooooo01Woo`800<[o
o`03003ooooo02_oo`03003ooooo04koo`00:Ooo10001?oo00<00?ooool05_oo0`00c?oo00<00?oo
ool0:ooo00<00?ooool0C_oo000aool00`00ooooo`0Dool20002ool00`00ooooo`3:ool00`00oooo
o`0/ool00`00ooooo`1=ool002ooo`<001?oo`<00=7oo`03003ooooo02goo`03003ooooo04coo`00
<Ooo00<00?ooool03ooo0P00e?oo00<00?ooool0;Ooo00<00?ooool0C?oo0011ool2003Fool00`00
ooooo`0^ool00`00ooooo`1;ool003koo`<00003ool000000=Goo`03003ooooo02ooo`03003ooooo
04[oo`00??oo0P00fooo00<00?ooool0;ooo00<00?ooool0B_oo000iool3003Mool00`00ooooo`0`
ool00`00ooooo`19ool003Ooo`800>3oo`03003ooooo033oo`03003ooooo04Woo`00=Ooo0P000_oo
00<00?ooool0gOoo00<00?ooool0<Ooo00<00?ooool0B?oo000cool20005ool00`00ooooo`3Lool0
0`00ooooo`0bool00`00ooooo`17ool003?oo`800>Coo`03003ooooo03;oo`03003ooooo04Ooo`00
<ooo00<00?oo0000i?oo00<00?ooool0<_oo00<00?ooool0A_oo000cool01000ool00000hooo00<0
0?ooool0<_oo00<00?ooool0A_oo000bool30002ool00`00ooooo`3Pool00`00ooooo`0cool00`00
ooooo`15ool003;oo`03003ooooo00?oo`03003ooooo0=ooo`03003ooooo03Coo`03003ooooo04Co
o`00<_oo00<00?ooool01?oo00<00?ooool0V_oo00H00?ooool00?oo000nool00`00ooooo`0dool0
0`00ooooo`14ool002Soo`@000Koo`03003ooooo00Goo`03003ooooo09?oo`@000Goo`03003oo`00
00;oo`800003ool00?oo00Coo`03003oo`00033oo`03003ooooo03Goo`03003ooooo04?oo`00:_oo
00<00?ooool01Ooo00<00?ooool01_oo00<00?ooool0Qooo0P000_oo00<00?ooool00_oo00<00?oo
00001Ooo00<00?ooool01?oo00<00?ooool02?oo00<00?oo00000`000_oo00<00?ooool09ooo00<0
0?ooool0=Ooo00<00?ooool0@ooo000Zool00`00ooooo`05ool00`00ooooo`07ool00`00ooooo`21
ool00`00ooooo`04ool01000ooooo`000_oo00@00?ooooooo`8000Coo`03003ooooo00Coo`05003o
ooooool00004ool01000oooooooo0`0000?oo`00ool00ooo0P009?oo00<00?ooool0=_oo00<00?oo
ool0@_oo000Rool40004ool00`00ooooo`04ool00`00ooooo`09ool00`00ooooo`1kool200001ooo
003ooooo003oo`0000Coo`800003ool0000000Woo`03003ooooo00;oo`03003ooooo01Ooo`8000?o
o`03003ooooo01goo`03003ooooo03Ooo`03003ooooo047oo`00:_oo00<00?ooool01?oo00<00?oo
ool02_oo00<00?ooool0Mooo10002Ooo00D00?ooooooo`0000?oo`03003oo`0000Soo`05003oo`00
ool00003ool3000@ool00`00ooooo`03ool00`00ooooo`02000Lool00`00ooooo`0gool00`00oooo
o`11ool002Soo`<000Koo`03003ooooo00_oo`03003ooooo07?oo`03003oo`0000Goo`03003ooooo
00;oo`03003ooooo00Coo`03003ooooo00Soo`8000;oo`03003ooooo00?oo`03003ooooo00Goo`03
003ooooo00Ooo`03003ooooo00Ooo`<00006ool00?oo003oo`005ooo00<00?ooool0>?oo00<00?oo
ool0@?oo000Zool00`00ooooo`04ool3000<ool00`00ooooo`1`ool20003ool00`00ooooo`02ool0
0`00ool00007ool00`00ool0000?ool01000oooooooo0P003ooo00<00?ooool01ooo00@00?oooooo
o`8000Coo`03003oo`0001Goo`03003ooooo03Woo`03003ooooo03ooo`00<Ooo00<00?ooool03Ooo
00<00?ooool0K?oo00<00?ooool01Ooo00<00?ooool01Ooo00D00?ooooooo`0000Woo`04003ooooo
000?ool00`00ooooo`0>ool00`00ooooo`03ool01P00oooooooo003oo`8000;oo`04003ooooo000D
ool00`00ooooo`0iool00`00ooooo`0oool0037oo`03003ooooo00koo`03003ooooo06Soo`03003o
o`00008000Goo`03003ooooo00Goo`@000Goo`03003ooooo013oo`03003ooooo01?oo`03003oo`00
00Ooo`04003oooooool30002ool00`00ooooo`03ool00`00ooooo`0=ool00`00ooooo`0jool00`00
ooooo`0nool0033oo`03003ooooo013oo`03003ooooo06Goo`<000Goo`03003ooooo00coo`03003o
oooo017oo`03003ooooo00?oo`03003ooooo00Koo`05003oooooool0000Iool30003ool01000ool0
00003Ooo00<00?ooool0>_oo00<00?ooool0?_oo000`ool00`00ooooo`0Aool00`00ooooo`1Uool2
000Gool00`00ooooo`0:ool01000ooooo`002?oo00<00?ooool04Ooo00<00?ooool09Ooo00<00?oo
ool0>ooo00<00?ooool0?Ooo000`ool00`00ooooo`0Bool00`00ooooo`1Oool30002ool00`00oooo
o`06ool01@00oooooooo00002?oo00<00?ooool00ooo0P000ooo00D00?ooooooo`0000Coo`04003o
oooo0004ool00`00ooooo`0=ool00`00ooooo`0Fool00`00ooooo`03ool00`00ool0000:ool00`00
ooooo`0lool00`00ooooo`0lool0033oo`03003ooooo01?oo`03003ooooo05coo`@000;oo`03003o
o`0000Coo`06003ooooo003oo`002?oo00<00?ooool04_oo00<00?ooool02_oo00<00?ooool01ooo
00<00?oo00002Ooo00D00?ooooooo`0000_oo`03003oo`0000Soo`03003ooooo00Goo`03003ooooo
03_oo`03003ooooo03coo`00<?oo00<00?ooool05?oo00<00?ooool0Fooo00<00?oo00003?oo0P00
4_oo00<00?ooool02ooo0P003_oo0P000_oo00<00?ooool00_oo00<00?oo00005Ooo00L00?oooooo
o`00ool00002ool01@00oooooooo00001_oo00<00?ooool0??oo00<00?ooool0>ooo000`ool2000F
ool00`00ooooo`1Fool00`00ooooo`04ool01`00oooooooo003oo`0000_oo`03003ooooo00;oo`03
003oo`0000Woo`03003ooooo00;oo`05003oooooool0000:ool00`00ooooo`02ool01000ooooo`00
0_oo00<00?ooool01?oo00@00?ooool000?oo`03003ooooo00Goo`04003ooooo0002ool00`00oooo
o`05ool00`00ool00004ool20004ool00`00ooooo`0lool00`00ooooo`0kool0033oo`03003ooooo
01Goo`03003ooooo05coo`03003ooooo01;oo`03003ooooo00;oo`03003ooooo01koo`03003ooooo
00Ooo`03003ooooo00_oo`03003oo`0000?oo`03003oo`0000Ooo`06003ooooo003oo`000_oo00L0
0?oo003oo`00ool00002ool00`00ooooo`0mool00`00ooooo`0jool002ooo`03003ooooo01Ooo`03
003ooooo057oo`8000;oo`03003ooooo00?oo`03003ooooo00Goo`03003ooooo01;oo`03003ooooo
00Coo`03003ooooo00Soo`03003ooooo00Goo`03003ooooo00?oo`03003ooooo00_oo`8000Coo`03
003ooooo00Coo`03003ooooo01?oo`07003oooooool00?oo0000@?oo00<00?ooool0>Ooo000_ool0
0`00ooooo`0Hool00`00ooooo`1?ool01P00ooooo`00ool000Ooo`03003ooooo00Coo`03003ooooo
00Woo`04003ooooo000bool00`00ooooo`0Aool00`00ooooo`05ool00`00ooooo`08ool30010ool0
0`00ooooo`0iool002ooo`03003ooooo01Woo`03003ooooo057oo`06003oooooool00?oo0`001?oo
0P001_oo00<00?ooool00_oo00<00?ooool01Ooo00<00?ooool03?oo00<00?ooool01ooo00<00?oo
ool00ooo00<00?ooool00_oo00D00?ooooooo`0000?oo`03003ooooo00koo`03003ooooo00Woo`03
003ooooo00Goo`03003ooooo00Koo`03003oo`0003ooo`03003ooooo03Soo`00;ooo00<00?ooool0
6_oo00<00?ooool0BOoo0P002?oo00@00?ooool000[oo`8001[oo`03003ooooo00ooo`03003ooooo
00Ooo`03003ooooo00goo`03003ooooo00koo`03003ooooo00;oo`03003oo`0000?oo`03003oo`00
00;oo`04003oo`00ool3000mool00`00ooooo`0hool002ooo`03003ooooo01_oo`03003ooooo04So
o`03003ooooo00Soo`03003ooooo00Goo`03003ooooo00Ooo`03003oo`0000Coo`03003ooooo02ko
o`800003ool00?oo00Soo`03003ooooo00Koo`03003ooooo00Coo`03003ooooo00coo`@000?oo`03
003ooooo03_oo`03003ooooo03Ooo`00;ooo00<00?ooool07?oo00<00?ooool0A_oo0P000_oo00<0
0?ooool01Ooo00<00?ooool02ooo00<00?ooool02?oo00<00?ooool01Ooo00<00?ooool02Ooo00D0
0?ooooooo`0000Koo`03003ooooo027oo`05003oooooool0000>ool00`00ooooo`06ool300000ooo
003oo`0nool00`00ooooo`0fool002koo`03003ooooo01koo`03003ooooo04;oo`03003oo`0000Go
o`<000_oo`03003ooooo008000;oo`04003oo`000002ool00`00ooooo`0Cool2000Aool00`00oooo
o`06ool00`00ooooo`0>ool00`00ooooo`06ool00`00ooooo`03ool01000oooooooo0P001Ooo00<0
0?oo00001?oo00H00?ooool00?oo000nool00`00ooooo`0fool002koo`<001ooo`03003ooooo03oo
o`03003oo`0000Goo`03003ooooo00?oo`8001Woo`03003oo`0000Goo`03003ooooo00Soo`03003o
oooo00Goo`03003ooooo00;oo`03003ooooo01Goo`04003ooooo000<ool00`00ooooo`0:ool00`00
ooooo`08ool00`00ooooo`020010ool00`00ooooo`0eool002koo`03003ooooo023oo`03003ooooo
04Woo`<000;oo`8000Koo`03003ooooo00Coo`05003oo`00ool0000Kool00`00ooooo`0<ool00`00
ooooo`04ool00`00ooooo`0Eool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool00`00
ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool01000ooooo`00>ooo00<00?ooool0=?oo000^
ool00`00ooooo`0Qool00`00ooooo`0kool00`00ooooo`03ool00`00ooooo`06ool2000Cool00`00
ool0000>ool00`00ooooo`03ool00`00ooooo`0Oool00`00ool00002ool00`00ooooo`0Bool00`00
ool0000>ool200002_oo003ooooo003oo`00ool00?oo0P00>ooo00<00?ooool0=?oo000^ool00`00
ooooo`0Rool00`00ooooo`0hool01000ool000000_oo00<00?ooool02ooo0P002Ooo00<00?ooool0
1Ooo00<00?ooool0<?oo00<00?ooool05_oo0P006?oo00H00?oo00000?oo0011ool00`00ooooo`0c
ool002koo`03003ooooo02?oo`03003ooooo03Soo`8000?oo`80013oo`03003ooooo00?oo`03003o
oooo00Soo`03003ooooo01;oo`03003ooooo00coo`05003oo`00ool00008ool01000ooooo`000_oo
00<00?ooool01Ooo00D00?ooooooo`0001[oo`03003ooooo00?oo`03003ooooo00Goo`03003ooooo
00Coo`03003ooooo03Goo`03003ooooo03?oo`00;Ooo00<00?ooool09Ooo00<00?ooool0=Ooo00<0
0?ooool00_oo00<00?ooool02ooo00<00?ooool02?oo00<00?oo00002Ooo00<00?ooool06ooo00<0
0?ooool04_oo00<00?oo00002ooo00<00?ooool01Ooo00<00?oo00001?oo00<00?oo00003_oo00@0
0?ooool000Koo`800003ool0000000;oo`03003oo`0003Ooo`03003ooooo03;oo`00;Ooo00<00?oo
ool09_oo00<00?ooool0<_oo0`0000Goo`00ooooo`00017oo`03003ooooo00Goo`03003ooooo01;o
o`03003ooooo00[oo`8000Goo`03003ooooo00[oo`03003ooooo00;oo`03003ooooo00Soo`03003o
oooo00goo`03003ooooo01Ooo`03003ooooo00Koo`04003ooooo0003ool00`00ooooo`0eool00`00
ooooo`0aool002goo`03003ooooo02Ooo`03003ooooo033oo`<0017oo`8000_oo`03003oo`0001[o
o`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00Soo`03003ooooo00Woo`04003ooooo000_
ool00`00ooooo`02ool01000ooooo`000_oo00D00?ooool00?oo008003Koo`03003ooooo037oo`00
;Ooo00<00?ooool0:?oo00<00?ooool0;Ooo0P000_oo00<00?oo00004?oo00@00?ooooooo`8000_o
o`03003ooooo00goo`04003ooooo000Fool00`00ooooo`0@ool01@00oooooooo00000_oo00<00?oo
ool01?oo00@00?ooool000Ooo`03003ooooo00ooo`05003oooooool00007ool00`00ooooo`08ool0
0`00ooooo`0cool00`00ooooo`0`ool002goo`8002[oo`03003ooooo02_oo`03003ooooo00;oo`03
003ooooo00Coo`03003ooooo00Goo`03003ooooo017oo`04003ooooo0008ool00`00ooooo`020002
ool00`00ool0000Bool00`00ooooo`09ool00`00ooooo`07ool00`00ooooo`03ool00`00ool0000B
ool00`00ooooo`0;ool00`00ooooo`02ool20003ool00`00ooooo`05ool01`00oooooooo003oo`00
03Koo`03003ooooo033oo`00;Ooo00<00?ooool0:_oo00<00?ooool0:_oo0P006_oo00D00?oooooo
o`0000Koo`03003ooooo00Woo`03003oo`0000[oo`03003ooooo01_oo`03003ooooo00?oo`03003o
oooo00Koo`03003oo`00013oo`03003ooooo00_oo`03003ooooo00Coo`03003ooooo00Soo`<000Co
o`03003ooooo03Goo`03003ooooo02ooo`00;Ooo00<00?ooool0:ooo00<00?ooool09ooo00H00?oo
ool00?oo000;ool00`00ooooo`07ool2000=ool00`00ooooo`0@ool00`00ooooo`05ool00`00oooo
o`0;ool00`00ooooo`0Pool00`00ooooo`0>ool01@00oooooooo00001Ooo00L00?ooooooo`00ool0
0007ool00`00ooooo`02ool00`00ooooo`03ool00`00ool0000eool00`00ooooo`0^ool002coo`03
003ooooo02goo`03003ooooo02Goo`05003oooooool00004ool01000ool000001?oo00<00?ooool0
1?oo00<00?ooool00ooo00<00?ooool04Ooo00<00?ooool06Ooo00<00?ooool01Ooo00<00?ooool0
1?oo00<00?ooool05?oo00D00?oo003oo`0000;oo`03003ooooo00_oo`03003ooooo00_oo`8000?o
o`03003ooooo04Coo`03003ooooo02koo`00;?oo00<00?ooool0;_oo00<00?ooool0;?oo00<00?oo
ool00_oo00<00?oo00002?oo00<00?ooool05Ooo00<00?ooool05ooo00<00?ooool03_oo00<00?oo
ool03Ooo0P006Ooo00@00?oo000000Goo`8000Ooo`03003ooooo00_oo`04003oo`000005ool00`00
ooooo`0bool00`00ooooo`0]ool002coo`03003ooooo02ooo`03003ooooo027oo`8000[oo`04003o
oooo000Bool2000Xool00`00ooooo`0Tool00`00ooooo`03ool01@00oooooooo00004Ooo00<00?oo
ool02?oo0P001?oo0P000ooo00<00?ooool00_oo00@00?ooool000Coo`03003ooooo03;oo`03003o
oooo02coo`00;?oo00<00?ooool0<?oo00<00?ooool08Ooo00<00?oo00002_oo00<00?ooool00_oo
00<00?ooool02_oo00@00?ooool000Ooo`03003ooooo00Goo`03003ooooo00goo`04003ooooo000:
ool00`00ool00003ool20007ool00`00ooooo`07ool00`00ooooo`02ool20007ool00`00ooooo`04
ool00`00ooooo`09ool20006ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`03ool00`00
ooooo`05ool00`00ooooo`0eool00`00ooooo`0/ool002coo`03003ooooo037oo`03003ooooo02Co
o`04003ooooo0005ool00`00ooooo`0Qool00`00ooooo`0Yool00`00ooooo`05ool20004ool00`00
ool0000Hool00`00ooooo`0@ool00`00ooooo`0Dool00`00ool0000dool00`00ooooo`0[ool002co
o`03003ooooo03;oo`03003ooooo01_oo`8000Goo`03003ooooo00;oo`05003oo`00ool0000eool0
0`00ooooo`0Cool00`00ooooo`02ool00`00ooooo`0Gool00`00ooooo`0@ool00`00ooooo`0<ool0
0`00ooooo`07ool00`00ooooo`0=ool2000bool00`00ooooo`0[ool002_oo`04003oo`00000cool0
0`00ooooo`0Jool00`00ooooo`0=ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`04ool0
0`00ooooo`05ool00`00ooooo`03ool00`00ooooo`0>ool00`00ooooo`04ool2000:ool00`00oooo
o`0=ool00`00ooooo`0>ool00`00ooooo`0<ool01@00oooooooo00000ooo0P003Ooo0P000ooo00<0
0?ooool01?oo00@00?oo000000Soo`05003oo`00ool0000bool00`00ooooo`0Zool002_oo`8003Ko
o`03003ooooo01Ooo`03003oo`0000goo`03003ooooo01Soo`8000coo`03003ooooo01;oo`03003o
oooo00Ooo`03003ooooo00Goo`03003ooooo02;oo`03003ooooo00Ooo`03003ooooo00_oo`03003o
o`0001coo`03003ooooo033oo`03003ooooo02Woo`00:ooo00<00?ooool0=_oo00<00?ooool05_oo
00<00?ooool00_oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00_oo00D00?ooooooo`00
00[oo`05003oooooool00005ool00`00ooooo`07ool00`00ooooo`07ool00`00ooooo`03ool20004
ool00`00ooooo`06ool00`00ooooo`04ool00`00ooooo`0<ool20004ool00`00ooooo`0Aool00`00
ooooo`04ool00`00ooooo`05ool00`00ooooo`04ool01000ooooo`001ooo00<00?oo00001?oo0P00
1?oo0P001?oo00<00?ooool0;ooo00<00?ooool0:Ooo000Fool20004ool00`00ooooo`02ool30007
ool00`00ooooo`0gool00`00ooooo`0Tool00`00ooooo`02ool20008ool00`00ooooo`0Iool00`00
ooooo`07ool00`00ooooo`0;ool00`00ooooo`09ool00`00ooooo`0Gool00`00ool0000@ool00`00
ooooo`0Aool00`00ooooo`0>ool00`00ooooo`08ool3000bool00`00ooooo`0Xool001Goo`04003o
oooo000;ool00`00ooooo`04ool00`00ooooo`0hool00`00ooooo`0Gool00`00ooooo`06ool01000
oooooooo0P001_oo00<00?ooool01?oo00<00?ooool00_oo0P000ooo00<00?ooool03?oo00<00?oo
00005ooo00<00?ooool01ooo00<00?ooool03_oo00<00?ooool04Ooo00<00?ooool01Ooo00<00?oo
ool04?oo00@00?ooool0017oo`07003oooooool00?oo00000_oo00<00?oo00000`00<?oo00<00?oo
ool0:?oo000Eool01000ooooo`002ooo00<00?ooool01?oo00<00?ooool0>Ooo00<00?ooool04Ooo
00<00?ooool01?oo00<00?oo00004?oo00D00?ooooooo`0000_oo`03003ooooo00?oo`03003oo`00
00;oo`03003ooooo00Woo`03003ooooo00Coo`03003ooooo01?oo`03003ooooo01ooo`03003ooooo
01_oo`04003ooooo001Aool00`00ooooo`0Wool000ooo`@000;oo`04003ooooo0008ool30006ool0
0`00ooooo`0kool00`00ooooo`0>ool20007ool30003ool00`00ooooo`04ool00`00ooooo`0Hool0
0`00ooooo`09ool00`00ooooo`0Dool00`00ooooo`05ool01000ooooo`009ooo00<00?ooool01?oo
00<00?ooool00_oo00<00?oo00000ooo0P002Ooo0P002Ooo00<00?ooool0A?oo00<00?ooool09_oo
000Eool01000ooooo`002?oo00<00?ooool01_oo00<00?ooool0??oo00<00?ooool03Ooo00D00?oo
ooooo`00017oo`03003ooooo00Goo`03003ooooo02Coo`8000Koo`03003ooooo01Coo`03003ooooo
00;oo`03003ooooo01Ooo`03003oo`00013oo`8000coo`03003ooooo00ooo`03003ooooo00;oo`03
003oo`0000;oo`03003ooooo00;oo`03003ooooo02koo`03003ooooo02Koo`005Ooo00@00?ooool0
00Soo`03003ooooo00Koo`03003ooooo03goo`03003ooooo00_oo`8000?oo`03003oo`0000Ooo`03
003oo`0000Soo`03003ooooo00Ooo`03003ooooo027oo`03003ooooo00Goo`05003oooooool00005
ool00`00ooooo`0;ool00`00ooooo`08ool00`00ooooo`07ool00`00ooooo`05ool00`00ooooo`0M
ool00`00ooooo`0<ool00`00ooooo`06ool00`00ooooo`04ool00`00ooooo`0aool00`00ooooo`0U
ool001Koo`8000Woo`@000Goo`03003ooooo03koo`03003ooooo00[oo`04003ooooo0005ool00`00
ooooo`02ool02@00oooooooo003oo`00ool00002ool00`00ooooo`08ool2000;ool00`00ooooo`0=
ool00`00ooooo`0[ool00`00ooooo`0<ool00`00ooooo`06ool00`00ooooo`09ool00`00ooooo`09
ool00`00ool00003ool01@00oooooooo00001?oo00<00?oo00005_oo00<00?ooool0;_oo00<00?oo
ool09Ooo000Zool20010ool00`00ooooo`08ool20003ool00`00ooooo`04ool00`00ool00004ool0
0`00ooooo`0Bool00`00ooooo`05ool00`00ooooo`0?ool00`00ooooo`0Xool2000Cool00`00oooo
o`02ool00`00ooooo`0Cool00`00ooooo`04ool00`00ool00006ool20002ool20004ool00`00oooo
o`03ool00`00ooooo`08ool2000`ool00`00ooooo`0Tool002[oo`03003ooooo043oo`03003ooooo
02Ooo`03003ooooo017oo`<000Koo`03003ooooo00Ooo`03003ooooo00Koo`03003ooooo01Coo`03
003oo`0000goo`03003ooooo00Ooo`03003ooooo00coo`03003ooooo00Soo`04003oooooool20005
ool01000ooooo`003_oo00<00?oo00001Ooo00<00?ooool0>?oo00<00?ooool08ooo000Zool00`00
ooooo`11ool00`00ooooo`04ool20003ool2000Hool00`00ooooo`08ool00`00ooooo`04ool00`00
ooooo`0Pool00`00ooooo`0<ool00`00ooooo`07ool00`00ool0000:ool00`00ooooo`0Aool00`00
ooooo`0Gool01000ooooo`003Ooo00@00?oo000000koo`80033oo`03003ooooo02?oo`00:Ooo00<0
0?ooool0@ooo00<00?ooool00_oo00<00?ooool01Ooo00<00?ooool00_oo00@00?ooool000Ooo`03
003ooooo00?oo`03003ooooo01;oo`03003ooooo013oo`03003ooooo00[oo`03003ooooo03_oo`03
003ooooo00Woo`03003ooooo00Woo`03003oo`0000;oo`03003ooooo00coo`03003oo`0000Koo`03
003ooooo00Coo`80033oo`03003ooooo02;oo`00:Ooo00<00?ooool0A?oo00@00?ooooooo`8002Oo
o`04003ooooo0006ool00`00ooooo`0Hool00`00ooooo`05ool2000Mool00`00ooooo`03ool20004
ool00`00ooooo`0Jool00`00ooooo`08ool00`00ooooo`06ool00`00ooooo`07ool00`00ooooo`05
ool01000oooooooo0P00=_oo00<00?ooool08Ooo000Yool00`00ooooo`15ool01000ooooo`001?oo
00D00?ooooooo`0001;oo`06003ooooo003oo`003_oo00<00?oo00003Ooo00<00?ooool01ooo0P00
1Ooo00<00?ooool07Ooo0P009?oo00<00?ooool03ooo00<00?ooool03_oo00<00?ooool04?oo00@0
0?ooool002ooo`03003ooooo027oo`00:Ooo00<00?ooool0A_oo0P001_oo0P007ooo00@00?ooool0
02Woo`03003ooooo00Coo`03003ooooo00Ooo`03003ooooo00_oo`03003ooooo00Goo`03003ooooo
00Woo`05003oooooool0000@ool00`00ooooo`0:ool00`00ooooo`0Tool00`00ooooo`0^ool00`00
ooooo`0Pool002Woo`03003ooooo04Koo`8000Coo`03003oo`0000Koo`03003ooooo00_oo`03003o
oooo00[oo`03003ooooo00Coo`04003ooooo000Jool00`00ooooo`0?ool01@00ool00?oo00004_oo
00<00?ooool03ooo00<00?ooool01_oo00<00?ooool05Ooo00<00?ooool02_oo0P000_oo00<00?oo
ool03Ooo00@00?ooooooo`800003ool00?oo02koo`03003ooooo023oo`00:Ooo00<00?ooool0AOoo
00<00?oo00001?oo00<00?oo00001Ooo00D00?ooooooo`0001Ooo`8000goo`03003ooooo013oo`04
003ooooo000>ool00`00ooooo`0Dool00`00ooooo`02ool00`00ooooo`0;ool00`00ooooo`03ool0
0`00ooooo`03ool00`00ooooo`06ool00`00ooooo`08ool01P00ooooo`00ool001?oo`05003ooooo
ool00003ool00`00ooooo`04ool01@00oooooooo0000;_oo0P008Ooo000Xool00`00ooooo`19ool2
000=ool00`00ooooo`09ool00`00ooooo`0Oool00`00ooooo`04ool00`00ooooo`04ool00`00oooo
o`0Eool00`00ooooo`08ool00`00ooooo`0=ool01@00oooooooo00001ooo00<00?ooool00_oo0P00
1ooo00<00?ooool01ooo00<00?ooool01?oo00D00?ooooooo`0000_oo`03003ooooo04;oo`<00003
ool00?oo023oo`00:?oo0`00AOoo00<00?ooool00_oo0P006?oo00D00?ooooooo`0000Woo`03003o
oooo00[oo`05003oooooool00005ool00`00ooooo`0Iool01@00oooooooo00000_oo00<00?ooool0
@ooo00D00?ooooooo`0001;oo`03003ooooo00Ooo`03003ooooo00Koo`03003ooooo02Goo`<000Co
o`03003ooooo01ooo`00:?oo00<00?ooool0A?oo00<00?ooool01?oo00<00?oo00008?oo00<00?oo
ool01?oo00<00?ooool02Ooo00<00?ooool00_oo00<00?ooool04Ooo00<00?oo0000<?oo00<00?oo
ool01ooo00@00?ooool001Ooo`03003ooooo00coo`03003ooooo00[oo`03003ooooo00Soo`03003o
oooo02Goo`<000Ooo`03003ooooo01ooo`00:?oo00<00?ooool0A?oo00<00?ooool01Ooo0P001_oo
00<00?ooool00_oo00<00?ooool00ooo00<00?ooool05_oo00<00?ooool05_oo00<00?ooool07ooo
00<00?oo00002Ooo00<00?ooool01_oo00<00?ooool04?oo00<00?ooool02?oo00@00?ooool000So
o`03003ooooo00Goo`06003ooooo003oo`001ooo00<00?ooool00_oo00<00?ooool01?oo00<00?oo
ool01_oo0P008?oo0`002ooo00<00?ooool07_oo000Xool00`00ooooo`13ool200000ooo003oo`02
ool200001Ooo00000?oo00000_oo00<00?ooool06ooo00@00?ooool000Ooo`03003ooooo00Coo`80
02Soo`8000coo`03003ooooo00Soo`03003ooooo00coo`03003oo`0000Soo`03003ooooo00Soo`03
003ooooo00Goo`03003ooooo00Woo`03003ooooo00800003ool00?oo00Koo`8000?oo`04003ooooo
0002ool01000ool00?oo0P007Ooo0`003_oo00<00?ooool07_oo000Xool00`00ooooo`13ool20009
ool2000@ool00`00ool00009ool00`00ooooo`0Hool2000?ool00`00ooooo`0=ool00`00ooooo`0V
ool01@00oooooooo00007Ooo00D00?ooooooo`0000Koo`05003oooooool0000?ool00`00ooooo`08
ool2000Iool3000Aool00`00ooooo`0Nool002Ooo`03003ooooo04Coo`04003ooooo0002ool00`00
ooooo`03ool01@00oooooooo00001Ooo00<00?ooool02ooo00<00?ooool02_oo00@00?ooool001go
o`03003ooooo01;oo`03003ooooo01;oo`03003ooooo00;oo`03003ooooo023oo`03003ooooo00;o
o`8000Goo`03003ooooo00goo`04003ooooo000;ool00`00ooooo`0:ool00`00ooooo`0Cool3000D
ool00`00ooooo`0Nool002Ooo`03003ooooo04Ooo`03003oo`0000Ooo`03003ooooo00koo`04003o
oooo0003ool01000ooooo`009?oo00<00?ooool00_oo00<00?ooool0Eooo00D00?ooooooo`0000So
o`03003ooooo00coo`03003ooooo00Koo`03003ooooo01[oo`@001Ooo`03003ooooo01koo`009ooo
00<00?ooool0@ooo00H00?ooool00?oo0009ool00`00ooooo`06ool00`00ooooo`08ool2000Kool0
0`00ooooo`0;ool00`00ooooo`13ool00`00ooooo`06ool00`00ooooo`0<ool00`00ooooo`02ool0
0`00ooooo`0=ool00`00ooooo`05ool00`00ooooo`04ool00`00ooooo`0:ool00`00ooooo`0<ool3
000Kool00`00ooooo`0Nool002Ooo`03003ooooo04Coo`800003ool00?oo00Coo`03003ooooo00?o
o`03003ooooo00?oo`03003oo`0000?oo`03003ooooo00[oo`8000Koo`03003ooooo00ooo`8000Wo
o`03003ooooo00[oo`06003ooooo003oo`002?oo0P001_oo00<00?ooool0>ooo00<00?oo00004_oo
00@00?ooool000Coo`03003oo`0001[oo`<001koo`03003ooooo01koo`009ooo0P00@_oo00<00?oo
ool01ooo00<00?ooool00_oo0P000_oo00<00?ooool01_oo00<00?ooool00ooo00@00?ooool000Go
o`03003ooooo02[oo`03003ooooo00goo`03003ooooo01goo`03003ooooo01goo`07003oooooool0
0?oo00001?oo00<00?ooool00_oo00<00?ooool03_oo00<00?ooool03Ooo00D00?ooooooo`0000[o
o`<002;oo`03003ooooo01goo`009ooo00<00?ooool0@Ooo00@00?ooool000Goo`04003ooooo0003
ool01@00oooooooo00002ooo00<00?ooool05ooo00<00?ooool00_oo00<00?ooool02?oo00<00?oo
ool01?oo00<00?ooool04?oo00<00?ooool0>?oo00<00?ooool03ooo00<00?oo00009?oo00D00?oo
ooooo`0000Soo`<002Goo`03003ooooo01goo`009ooo00<00?ooool0@?oo0`000ooo00<00?ooool0
1ooo00@00?ooool000;oo`8000Woo`03003ooooo02coo`03003oo`0001Coo`03003ooooo00koo`03
003ooooo023oo`03003ooooo00ooo`05003oooooool00002ool01000ooooo`000_oo0P000ooo00<0
0?ooool02?oo00<00?oo00004?oo0P0000?oo`00ool01000:?oo00<00?ooool07Ooo000Vool00`00
ooooo`12ool20003ool2000?ool00`00ooooo`02ool00`00ooooo`0fool00`00ooooo`03ool00`00
ooooo`06ool01000ooooo`005ooo00D00?ooooooo`0001;oo`03003ooooo00goo`03003ooooo00;o
o`03003ooooo00Koo`03003ooooo00;oo`03003ooooo01;oo`03003ooooo00ooo`@002[oo`03003o
oooo01goo`009_oo00<00?ooool0@?oo00D00?ooooooo`0000ooo`03003ooooo00;oo`04003ooooo
0005ool00`00ooooo`0Lool00`00ool0000Aool00`00ooooo`0Gool00`00ooooo`06ool00`00oooo
o`06ool01000ooooo`006Ooo00<00?ooool02_oo00<00?ooool01ooo00<00?ooool02ooo00<00?oo
ool02ooo00<00?ooool01?oo0P001?oo0`000ooo00<00?ooool0:?oo00<00?ooool07Ooo000Vool0
0`00ooooo`18ool00`00ooooo`02ool01000ooooo`002Ooo00<00?ooool05?oo00<00?ooool02Ooo
00<00?ooool04?oo00<00?ooool08Ooo00<00?ooool0?_oo00<00?ooool00_oo0P001Ooo00<00?oo
ool01Ooo00<00?ooool02Ooo00<00?ooool00ooo0`000ooo00<00?ooool0:ooo00<00?ooool07Ooo
000Vool00`00ooooo`1:ool00`00ooooo`05ool01000ooooo`000_oo00@00?ooool000Ooo`03003o
oooo00koo`03003ooooo01_oo`03003ooooo00;oo`03003ooooo03?oo`03003ooooo00Koo`03003o
oooo00Ooo`03003ooooo00Ooo`03003ooooo00Soo`06003ooooo003oo`002ooo00<00?ooool03ooo
10000_oo00<00?ooool00_oo00<00?oo0000:Ooo00<00?ooool07Ooo000Vool00`00ooooo`11ool0
2000ooooo`00ool00?oo000;ool00`00ooooo`05ool00`00ooooo`0Gool00`00ooooo`0Lool00`00
ooooo`0;ool00`00ooooo`06ool00`00ooooo`0@ool00`00ooooo`05ool00`00ooooo`05ool01000
ooooo`002ooo00<00?ooool03?oo00<00?ooool01Ooo00<00?ooool02_oo00<00?ooool03Ooo00<0
0?ooool00`003Ooo00<00?ooool09ooo00<00?ooool07Ooo000Vool00`00ooooo`11ool00`00oooo
o`09ool00`00ooooo`0=ool00`00ooooo`0cool00`00ooooo`03ool00`00ooooo`0>ool00`00oooo
o`0Lool00`00ooooo`03ool00`00ooooo`0Qool00`00ool00002ool01000oooooooo0P001ooo00<0
0?ooool02_oo0`000_oo00<00?oo00001ooo00<00?ooool00_oo00<00?ooool09ooo00<00?ooool0
7?oo000Uool00`00ooooo`12ool2000Aool00`00ooooo`07ool00`00ooooo`0<ool01@00oooooooo
00009Ooo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool01?oo00<00?ooool02Ooo00@00?oo
ool000?oo`03003ooooo00?oo`03003ooooo02koo`03003oo`0000koo`03003ooooo00Soo`<000So
o`8000;oo`06003ooooo003oo`00;?oo00<00?ooool07?oo000Uool3000oool2000<ool00`00oooo
o`0@ool00`00ooooo`0Kool00`00ooooo`0cool00`00ooooo`0;ool00`00ooooo`04ool00`00oooo
o`03ool00`00ooooo`0Tool00`00ooooo`04ool00`00ooooo`08ool00`00ooooo`02ool30003ool0
0`00ooooo`06ool00`00ool00003ool01000oooooooo0P00:Ooo00<00?ooool07?oo000Uool00`00
ooooo`15ool00`00ooooo`04ool00`00ooooo`09ool20007ool2000Iool00`00ooooo`0Dool00`00
ooooo`0>ool00`00ooooo`0@ool01@00oooooooo00001Ooo00<00?ooool00ooo00<00?ooool01_oo
00<00?ooool00_oo00<00?ooool07ooo00<00?ooool03_oo00<00?oo00000P003?oo00<00?ooool0
0ooo00<00?ooool01?oo00<00?ooool0:?oo00<00?ooool07?oo000Uool00`00ooooo`0nool00`00
ool0000;ool01000ooooo`003_oo00D00?ooooooo`00017oo`03003ooooo00?oo`8000?oo`05003o
ooooool0000Aool00`00ooooo`0Eool00`00ool00003ool00`00ooooo`0<ool00`00ool00009ool2
000>ool00`00ooooo`0Fool00`00ooooo`03ool00`00ooooo`07ool30002ool01000ool000001?oo
00<00?ooool03?oo00D00?ooooooo`0002Woo`03003ooooo01coo`009Ooo00<00?ooool0?_oo00H0
0?ooool00?oo000:ool00`00ooooo`0:ool00`00ool00005ool00`00ooooo`0Bool00`00ooooo`0D
ool00`00ooooo`05ool00`00ooooo`0Gool00`00ooooo`02ool00`00ooooo`04ool20003ool00`00
ooooo`0bool01@00oooooooo00001ooo10002_oo00<00?ooool03Ooo00<00?ooool00P0000Coo`00
000002Ooo`03003ooooo01coo`009Ooo00<00?ooool0A_oo00<00?oo00001?oo00<00?ooool00ooo
00D00?ooooooo`0000coo`04003ooooo0004ool00`00ooooo`03ool00`00ooooo`0Hool20004ool0
0`00ooooo`06ool00`00ooooo`03ool00`00ooooo`0?ool00`00ooooo`0>ool00`00ooooo`0Nool0
0`00ooooo`0:ool00`00ooooo`020007ool40007ool00`00ooooo`0Lool00`00ooooo`0Uool00`00
ooooo`0Lool002Coo`03003ooooo04Soo`03003ooooo00;oo`04003ooooo0009ool00`00ooooo`08
ool2000Kool00`00ooooo`0Uool00`00ooooo`0;ool00`00ooooo`05ool2000=ool00`00ooooo`0G
ool01000ooooo`002Ooo0`001Ooo0`005Ooo00<00?ooool03Ooo00H00?ooool00?oo000Wool00`00
ooooo`0Kool002Coo`03003ooooo04Coo`03003ooooo00coo`03003ooooo00[oo`03003ooooo00Co
o`03003ooooo023oo`03003oo`0001Coo`8000[oo`03003ooooo00_oo`05003oooooool0000Cool0
0`00ooooo`0Rool00`00ooooo`030006ool2000;ool01`00oooooooo003oo`0001;oo`03003ooooo
02Koo`03003ooooo01_oo`009?oo00<00?ooool0?ooo0P002Ooo0P007?oo00@00?ooool001Ooo`03
003ooooo01?oo`03003ooooo00;oo`03003ooooo00?oo`07003oooooool00?oo00002ooo00<00?oo
ool0;?oo00<00?ooool02Ooo00<00?ooool01?oo0`001Ooo00@00?ooool000Koo`03003ooooo01Wo
o`03003ooooo02[oo`03003ooooo01_oo`009?oo00<00?ooool0@Ooo00<00?ooool01?oo00<00?oo
ool04_oo00<00?ooool01Ooo00D00?ooooooo`0000koo`03003ooooo00;oo`03003ooooo00goo`03
003ooooo01Woo`03003ooooo00_oo`03003ooooo00Goo`04003ooooo000>ool00`00ooooo`08ool0
0`00ooooo`0Fool4000>ool00`00ooooo`06ool01@00oooooooo00002_oo00<00?ooool01ooo00<0
0?ooool09ooo00<00?ooool06ooo000Tool00`00ooooo`0mool2000Qool00`00ooooo`07ool2000<
ool00`00ooooo`0Nool00`00ooooo`0^ool00`00ooooo`0Pool00`00ooooo`02ool300001?oo003o
o`000ooo0P006Ooo00<00?ooool02ooo00<00?ooool0:ooo00<00?ooool06ooo000Tool3000mool0
1@00oooooooo00002Ooo00<00?ooool01Ooo0P005_oo00<00?ooool01Ooo0P001?oo00<00?ooool0
3ooo00<00?ooool01Ooo00<00?ooool0:?oo0P00;ooo0`001_oo00<00?ooool02ooo00D00?oooooo
o`0001Coo`<000Coo`8000;oo`03003oo`0002Koo`03003ooooo01_oo`009?oo00<00?ooool0?Ooo
0P000ooo00<00?ooool01?oo00<00?ooool05Ooo00<00?ooool02?oo00<00?ooool03Ooo00<00?oo
ool0:ooo00<00?ooool00_oo00<00?ooool00ooo0P001_oo00@00?ooool000goo`03003ooooo01;o
o`03003ooooo00Koo`<000Woo`03003oo`0000[oo`03003ooooo00koo`03003ooooo00[oo`8000Go
o`03003oo`0002Koo`03003ooooo01_oo`008ooo00<00?ooool0?Ooo00<00?ooool00ooo0P0000?o
o`00ool06_oo00<00?ooool02Ooo00@00?ooool003Soo`03003ooooo01Soo`03003ooooo01_oo`03
003ooooo00Coo`<000?oo`03003ooooo00Koo`8001?oo`03003ooooo00?oo`03003ooooo01Ooo`03
003ooooo02Coo`03003ooooo01[oo`006_oo0P001ooo00<00?ooool0?Ooo00@00?oo000000koo`03
003oo`0000Goo`03003ooooo00?oo`03003ooooo00Woo`03003ooooo00?oo`03003ooooo02Goo`05
003oooooool00002ool00`00ooooo`04ool00`00ooooo`09ool01000ooooo`004_oo0P004_oo00<0
0?ooool02Ooo0`003ooo00<00?ooool02Ooo00<00?ooool03Ooo00<00?ooool00_oo00<00?ooool0
2ooo00@00?ooooooo`<002Koo`03003ooooo01[oo`006Ooo00@00?ooool000Koo`03003ooooo03oo
o`03003ooooo00Coo`03003ooooo00Coo`04003ooooo0008ool01@00ool00?oo00002Ooo00<00?oo
ool01Ooo0P000_oo00<00?ooool01?oo0P003ooo00<00?ooool02ooo00D00?ooooooo`0000Koo`80
00?oo`03003ooooo00ooo`03003ooooo00Ooo`03003ooooo00[oo`03003ooooo00ooo`<000[oo`03
003ooooo00Goo`03003ooooo00Coo`03003ooooo00Koo`03003ooooo00;oo`03003ooooo01_oo`03
003oo`0002Koo`03003ooooo01[oo`006Ooo00@00?ooool000Koo`03003ooooo03coo`04003ooooo
ool2000Cool00`00ooooo`08ool00`00ooooo`0>ool00`00ooooo`02ool00`00ooooo`0Dool01000
ooooo`001Ooo00<00?ooool02_oo00<00?ooool01?oo00<00?ooool00_oo00<00?ooool01Ooo00D0
0?ooooooo`00017oo`03003ooooo00;oo`03003ooooo00coo`<001Goo`03003ooooo00Koo`03003o
oooo01?oo`03003ooooo013oo`05003oooooool0000Uool00`00ooooo`0Jool001Woo`04003ooooo
0006ool00`00ooooo`13ool00`00ool0000:ool00`00ooooo`03ool00`00ooooo`02ool00`00oooo
o`0Dool00`00ooooo`0<ool00`00ooooo`02ool01@00oooooooo00002_oo0P00;_oo00<00?ooool0
5_oo0`006?oo00<00?ooool01?oo00<00?ooool00_oo00<00?ooool07Ooo0P0000?oo`0000000_oo
0`009_oo00<00?ooool06_oo000Iool01000ooooo`001_oo00<00?ooool0@Ooo00<00?ooool02ooo
00H00?ooool00?oo0008ool00`00ooooo`0Cool00`00ooooo`0Cool00`00ooooo`0bool00`00oooo
o`0;ool00`00ooooo`03ool00`00ooooo`06ool3000Kool00`00ooooo`0>ool00`00ooooo`0=ool0
0`00ooooo`03ool00`00ooooo`06ool00`00ooooo`0Yool00`00ooooo`0Jool001Woo`04003ooooo
0005ool00`00ooooo`0mool2000:ool00`00ooooo`0=ool00`00ooooo`0?ool00`00ooooo`04ool0
1000ooooo`005?oo00<00?ooool02?oo00<00?ooool02Ooo00<00?ooool02Ooo00<00?ooool09_oo
00<00?oo00000`001_oo00<00?ooool05Ooo00<00?ooool06Ooo00<00?ooool00_oo00@00?ooool0
00Koo`05003oo`00ool00004ool00`00ooooo`0Uool00`00ooooo`0Jool001[oo`8000Koo`03003o
oooo047oo`03003oo`0000?oo`03003ooooo01Goo`04003ooooo000=ool00`00ooooo`02ool2000J
ool00`00ooooo`0Kool00`00ooooo`0Iool00`00ooooo`07ool4000Dool00`00ooooo`0;ool00`00
ooooo`02ool00`00ooooo`0:ool00`00ooooo`0?ool00`00ooooo`08ool00`00ooooo`03ool00`00
ooooo`0Sool00`00ooooo`0Jool002;oo`03003ooooo03goo`03003oo`0000?oo`05003oo`00ool0
0003ool00`00ooooo`0Gool2000@ool00`00ooooo`0cool00`00ooooo`04ool00`00ooooo`0Kool3
000Sool01000ooooo`004_oo00<00?ooool06?oo00H00?oo00000?oo000Xool00`00ooooo`0Iool0
02;oo`<003coo`8000?oo`04003ooooo000<ool00`00ool00002ool20005ool01@00oooooooo0000
2_oo00<00?ooool02Ooo00<00?ooool06_oo00<00?ooool04_oo00<00?ooool01Ooo00<00?ooool0
2?oo00<00?ooool03ooo0`002?oo00<00?ooool02ooo00<00?ooool02_oo00<00?ooool00ooo00<0
0?ooool07_oo00@00?ooool000coo`8000;oo`03003ooooo02Coo`03003ooooo01Woo`008_oo00<0
0?ooool0?_oo0P001?oo00<00?ooool06?oo00@00?oo000001Goo`03003ooooo02Coo`03003ooooo
02Goo`03003ooooo00;oo`<001_oo`8000Woo`03003ooooo00?oo`03003oo`0000koo`03003ooooo
01Koo`03003ooooo00Goo`04003ooooo000Vool00`00ooooo`0Iool002;oo`03003ooooo03coo`80
0003ool00?oo00[oo`8000;oo`03003ooooo00Coo`03003ooooo017oo`03003ooooo00Coo`03003o
oooo00Goo`03003ooooo03Woo`03003ooooo017oo`<000Ooo`03003ooooo01Koo`03003ooooo00So
o`05003oooooool00009ool00`00ooooo`04ool00`00ooooo`0Qool00`00ooooo`0Tool00`00oooo
o`0Iool0027oo`03003ooooo053oo`03003oo`0000[oo`03003ooooo00Goo`03003ooooo00Soo`03
003ooooo00Soo`05003oooooool00003ool00`00ooooo`0Qool00`00ooooo`0:ool00`00ooooo`0@
ool4000Aool00`00ooooo`0?ool00`00ooooo`04ool00`00ooooo`04ool01@00oooooooo00006Ooo
00<00?ooool01ooo00<00?ooool01ooo0P000_oo00<00?ooool08ooo00<00?ooool06Ooo000Qool0
0`00ooooo`0mool00`00ool00004ool01@00oooooooo00000ooo0P000_oo00<00?ooool04_oo00<0
0?oo00005?oo00<00?ooool07_oo00<00?ooool02ooo00<00?ooool04?oo00<00?ooool00ooo0`00
0_oo00<00?ooool00_oo00<00?ooool01ooo00<00?ooool03_oo00<00?ooool00ooo00<00?ooool0
2_oo00<00?ooool01_oo00<00?ooool00ooo00<00?ooool02_oo00<00?ooool04ooo00<00?ooool0
9ooo00<00?ooool06Ooo000Qool00`00ooooo`16ool2000eool00`00ool0000@ool00`00ooooo`0K
ool00`00ooooo`02ool00`00ooooo`09ool00`00ool00002000<ool00`00ooooo`0Qool00`00oooo
o`03ool00`00ool0000Eool00`00ooooo`05ool00`00ooooo`0;ool00`00ooooo`03ool01@00ool0
0?oo00009Ooo00<00?ooool06Ooo000Qool00`00ooooo`0lool20002ool00`00ool00003ool01@00
oooooooo00004ooo00<00?ooool02ooo00<00?oo00003ooo0P00<Ooo00<00?ooool02_oo0`001Ooo
00<00?oo00003_oo00<00?ooool08?oo00@00?oo000000[oo`03003ooooo00_oo`03003ooooo00?o
o`03003ooooo00ooo`04003oooooool2000Uool00`00ooooo`0Hool0027oo`03003ooooo03koo`03
003ooooo00Koo`03003ooooo00?oo`03003ooooo00goo`03003oo`0000Soo`03003ooooo00Soo`03
003ooooo00Woo`03003ooooo02Coo`03003ooooo01;oo`<001?oo`03003ooooo01Coo`03003ooooo
017oo`03003ooooo01[oo`03003oo`0000coo`05003oooooool00005ool00`00ooooo`0Tool00`00
ooooo`0Hool0027oo`03003ooooo03koo`800005ool00?ooool0000Aool00`00ooooo`04ool00`00
ooooo`0Cool01000ooooo`002Ooo00H00?ooool00?oo0008ool00`00ooooo`0Kool00`00ooooo`09
ool30011ool00`00ooooo`05ool20004ool00`00ooooo`0=ool00`00ooooo`06ool00`00ool0000;
ool00`00ooooo`0Uool00`00ooooo`0Hool0023oo`03003ooooo03koo`03003oo`0000Coo`03003o
oooo017oo`03003ooooo00Koo`03003ooooo00koo`03003ooooo00coo`04003ooooo0005ool00`00
ooooo`0<ool00`00ooooo`07ool00`00ooooo`06ool00`00ooooo`06ool40003ool00`00ooooo`03
ool2000Cool00`00ooooo`03ool01@00oooooooo00005ooo0P0000?oo`00ool04?oo00<00?ooool0
7?oo0P000_oo0`009Ooo00<00?ooool06?oo000Pool3000mool00`00ooooo`0200000ooo003oo`08
ool00`00ooooo`0@ool00`00ooooo`0Nool00`00ool00003ool00`00ool00005ool00`00ooooo`07
ool00`00ooooo`0:ool00`00ooooo`04ool00`00ooooo`03ool3000Aool00`00ooooo`0Pool00`00
ooooo`0@ool00`00ool0000Kool01@00oooooooo00004ooo00<00?ooool09?oo00<00?ooool06?oo
000Pool00`00ooooo`0mool00`00ooooo`0Cool00`00ooooo`02000Pool00`00ooooo`05ool01@00
oooooooo00001?oo00@00?ooool000koo`03003ooooo01;oo`<000koo`03003ooooo01Goo`03003o
oooo00?oo`03003ooooo00Soo`03003ooooo00Goo`03003ooooo00Soo`03003ooooo00Koo`03003o
oooo00?oo`8000?oo`8000;oo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo00Coo`03003o
oooo02koo`03003ooooo01Soo`008?oo00<00?ooool0A?oo0P001ooo0P008_oo00<00?ooool01_oo
00<00?ooool02?oo00<00?ooool01_oo00<00?ooool07?oo10002?oo00<00?ooool03Ooo00<00?oo
ool06Ooo00<00?ooool03?oo00<00?ooool01_oo00<00?ooool06?oo00<00?oo00004Ooo00<00?oo
ool00_oo0P0000?oo`00ool09?oo00<00?ooool06?oo000Pool00`00ooooo`11ool00`00ooooo`0:
ool20003ool01000ooooo`000_oo00<00?ooool05Ooo00<00?ooool03ooo00@00?ooool001[oo`03
003ooooo00Koo`@001;oo`03003ooooo00Ooo`03003ooooo00Woo`03003ooooo02Coo`03003ooooo
01Koo`03003ooooo00;oo`03003ooooo01;oo`03003oo`0002Soo`03003ooooo01Ooo`008?oo00<0
0?ooool0A_oo00<00?ooool02Ooo00@00?ooool001Ooo`8000;oo`03003ooooo00_oo`04003ooooo
0004ool00`00ooooo`04ool00`00ooooo`0Eool4000Jool00`00ooooo`08ool00`00ooooo`0;ool0
0`00ooooo`0Cool00`00ooooo`07ool00`00ooooo`0Fool20004ool00`00ooooo`0@ool00`00oooo
o`02ool2000Uool00`00ooooo`0Gool0023oo`03003ooooo043oo`05003oooooool0000Pool01000
ooooo`007ooo00<00?ooool02ooo0P002ooo10003_oo00<00?ooool03ooo00<00?ooool00ooo00<0
0?ooool03ooo00<00?ooool04?oo00H00?ooool00?oo0006ool00`00ooooo`0;ool01@00oooooooo
00006?oo00@00?ooool000Koo`<002Goo`03003ooooo01Ooo`007ooo00<00?ooool0BOoo00<00?oo
ool07ooo00@00?ooool000Koo`03003ooooo00ooo`04003ooooo000Fool30003ool00`00ooooo`09
ool00`00ool00006ool00`00ooooo`0Eool00`00ooooo`0Cool00`00ooooo`0Bool00`00ooooo`0E
ool00`00ooooo`0=ool30003ool200001?oo003ooooo0P009ooo00<00?ooool05ooo000Oool00`00
ooooo`1Iool00`00ooooo`0Bool00`00ooooo`08ool00`00ooooo`0<ool01000ooooo`004_oo0`00
2?oo00<00?ooool0<_oo00<00?ooool05_oo00<00?ooool01Ooo00<00?ooool02Ooo00<00?ooool0
4_oo0P002Ooo00H00?ooool00?oo0004ool00`00ooooo`0Tool00`00ooooo`0Gool001ooo`03003o
oooo04;oo`03003ooooo00coo`05003oo`00ool0000:ool00`00ooooo`05ool00`00ooooo`02ool0
0`00ooooo`0<ool00`00ooooo`04ool00`00ooooo`06ool00`00ooooo`0<ool30009ool01000oooo
o`007Ooo0P001ooo00<00?ooool0:ooo00D00?ooooooo`0001?oo`03003ooooo00_oo`03003ooooo
00Soo`03003oo`0000;oo`03003ooooo02Coo`03003ooooo01Ooo`007ooo00<00?ooool0?_oo0P00
2?oo00<00?ooool03_oo00<00?ooool01ooo00<00?ooool00_oo00<00?ooool03ooo00<00?ooool0
1ooo00<00?ooool01_oo00<00?ooool02?oo0`003_oo00<00?ooool05?oo00<00?ooool03Ooo00<0
0?ooool03?oo00<00?ooool02Ooo00@00?ooool000Coo`03003ooooo00Woo`03003ooooo01ooo`03
003ooooo00Coo`03003ooooo00Soo`03003ooooo02Koo`03003ooooo01Ooo`007ooo00<00?ooool0
?Ooo0P002Ooo00<00?ooool03Ooo00<00?oo00004Ooo00<00?ooool02?oo00<00?ooool00_oo00<0
0?ooool03ooo00<00?ooool01?oo0`003_oo00<00?ooool02Ooo0P003?oo00<00?ooool07ooo00<0
0?ooool06_oo00<00?oo00003Ooo00<00?ooool06?oo00H00?ooool00?oo0005ool00`00ooooo`0T
ool00`00ooooo`0Gool001ooo`8003ooo`04003ooooo0003ool00`00ooooo`04ool00`00ooooo`05
ool01000ooooo`000ooo00<00?ooool00_oo00<00?ooool07_oo00<00?ooool02ooo00<00?ooool0
0`000_oo00<00?ooool01_oo00D00?ooooooo`0001Goo`03003ooooo02Goo`04003ooooo000Iool0
0`00ooooo`09ool00`00ooooo`08ool00`00ooooo`06ool00`00ool0000=ool00`00ooooo`03ool2
000Vool00`00ooooo`0Fool001koo`03003ooooo03koo`800003ool00?oo00Ooo`03003ooooo00Ko
o`03003ooooo00Soo`03003ooooo02[oo`03003ooooo00?oo`@001Koo`03003ooooo02goo`03003o
oooo00[oo`03003ooooo00Koo`03003ooooo00coo`03003ooooo00Goo`03003ooooo013oo`03003o
oooo00[oo`03003ooooo00Coo`03003ooooo00Goo`03003ooooo02Coo`03003ooooo01Koo`007_oo
00<00?ooool0?ooo0P0000Goo`00ooooo`0000Ooo`03003ooooo00_oo`03003ooooo02goo`03003o
oooo00?oo`04003ooooo000^ool00`00ooooo`0Gool00`00ooooo`0=ool00`00ooooo`0?ool2000;
ool01000ooooo`004Ooo00<00?ooool00_oo00@00?oo000000coo`03003ooooo02Goo`03003ooooo
01Koo`007_oo00<00?ooool0?ooo0P001Ooo00<00?ooool01ooo00<00?ooool01Ooo00<00?ooool0
3_oo00@00?ooool001goo`04003ooooo0003ool00`00ooooo`03ool00`00ooooo`0:ool20005ool0
0`00ooooo`02ool00`00ooooo`03ool2000Lool00`00ooooo`0=ool00`00ooooo`0Dool40002ool2
0005ool00`00ooooo`03ool00`00ooooo`05ool20003ool00`00ooooo`07ool20006ool00`00oooo
o`02ool01000ooooo`00:?oo00<00?ooool05_oo000Nool00`00ooooo`0nool20003ool00`00oooo
o`05ool00`00ooooo`0<ool00`00ooooo`0;ool00`00ooooo`08ool00`00ooooo`0Gool01@00oooo
oooo00001Ooo00<00?ooool00ooo00D00?ooooooo`0001coo`03003ooooo01ooo`03003ooooo00Go
o`03003ooooo00goo`@000Koo`03003ooooo01?oo`03003ooooo01?oo`03003ooooo00Coo`8002Oo
o`03003ooooo01Koo`007_oo00<00?ooool0?_oo0P000_oo00<00?oo00007Ooo00<00?ooool02?oo
00<00?ooool00_oo00<00?ooool07?oo00<00?ooool02ooo00<00?ooool01?oo00<00?ooool01_oo
00@00?ooool001[oo`03003ooooo00[oo`03003ooooo01Soo`<000[oo`03003ooooo00Woo`03003o
oooo00Soo`8000Coo`03003ooooo00Goo`03003ooooo00[oo`8002Soo`03003ooooo01Koo`007_oo
00<00?ooool0?_oo00<00?ooool01?oo00<00?ooool02Ooo00<00?ooool00_oo00<00?ooool02Ooo
00<00?ooool09ooo00<00?ooool00_oo00@00?ooool0017oo`03003ooooo04Woo`<000koo`03003o
oooo00_oo`03003ooooo00[oo`03003oo`0000_oo`03003oo`0000Koo`03003oo`0002Koo`03003o
oooo01Koo`007Ooo00<00?ooool0@?oo00<00?ooool01Ooo0P002Ooo00D00?ooooooo`0000[oo`03
003ooooo01[oo`03003ooooo013oo`03003ooooo00Woo`03003ooooo00coo`03003ooooo01Koo`03
003ooooo01Coo`03003ooooo013oo`<001;oo`03003ooooo00ooo`03003ooooo00;oo`03003ooooo
00Goo`03003ooooo03Woo`03003ooooo01Goo`007Ooo00<00?ooool0@Ooo0P003ooo00<00?ooool0
1_oo00<00?ooool02Ooo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool01_oo00<00?ooool0
4Ooo00<00?ooool02_oo00<00?ooool02Ooo00<00?ooool04_oo00<00?ooool03?oo00<00?ooool0
6_oo10003?oo00<00?ooool01ooo00<00?ooool02?oo00<00?ooool01Ooo00<00?ooool04?oo00<0
0?ooool01ooo00<00?ooool09ooo00<00?ooool05Ooo000Mool00`00ooooo`0oool20006ool00`00
ooooo`0?ool00`00ooooo`0Aool00`00ooooo`0Hool00`00ooooo`07ool00`00ooooo`1:ool20008
ool3000Kool00`00ool0000<ool00`00ool0000?ool01@00oooooooo00001Ooo00<00?ooool00ooo
00<00?ooool09Ooo00<00?ooool05Ooo000Mool00`00ooooo`0oool00`00ool0000;ool00`00oooo
o`05ool00`00ooooo`02ool00`00ooooo`0eool00`00ooooo`0Zool00`00ooooo`0Tool30004ool0
0`00ooooo`0Eool00`00ool00002ool20002ool00`00ooooo`0Dool01000ool000001?oo00<00?oo
ool00_oo00<00?ooool0:ooo00<00?ooool05Ooo000Mool3001Uool00`00ooooo`04ool00`00oooo
o`0Sool00`00ooooo`0Aool00`00ooooo`0:ool00`00ooooo`06ool00`00ooooo`05ool00`00oooo
o`0Eool01`00ooooo`00ool00?oo00@000?oo`03003ooooo00?oo`05003oooooool00002ool00`00
ooooo`03ool01000ooooo`001ooo00<00?ooool09_oo0P001?oo00<00?ooool09_oo00<00?ooool0
5Ooo000Mool00`00ooooo`10ool00`00ooooo`05ool00`00ooooo`0Mool00`00ooooo`03ool00`00
ooooo`05ool00`00ooooo`0?ool00`00ooooo`07ool20004ool00`00ooooo`02ool00`00ooooo`0E
ool01000ooooo`003Ooo00<00?ooool05_oo10007ooo00<00?ooool00ooo0P005Ooo00<00?ooool0
3Ooo00<00?ooool01Ooo0P009ooo00<00?ooool05Ooo000Mool00`00ooooo`11ool00`00ooooo`0:
ool00`00ool00004ool00`00ooooo`05ool00`00ooooo`05ool00`00ooooo`0Gool00`00ooooo`0@
ool01@00oooooooo00002?oo00<00?ooool02?oo00<00?ooool05_oo00<00?ooool05_oo0`004_oo
00<00?ooool01Ooo00<00?ooool01_oo00<00?ooool01Ooo00<00?ooool01Ooo00@00?ooool000?o
o`03003ooooo00Koo`04003ooooo0002ool00`00ooooo`02ool00`00ooooo`0`ool00`00ooooo`0E
ool001coo`03003ooooo04;oo`03003ooooo00Ooo`03003ooooo00;oo`03003ooooo00Woo`03003o
o`00013oo`03003ooooo01;oo`03003ooooo00Koo`03003ooooo00;oo`03003ooooo00Goo`05003o
o`00ool0000Dool00`00ooooo`0Dool01000ooooo`002ooo0`005Ooo00<00?ooool01?oo00D00?oo
ooooo`0000Ooo`04003ooooo0003ool00`00ooooo`0@ool00`00ooooo`0:ool00`00ooooo`08ool2
000Yool00`00ooooo`0Dool001coo`03003ooooo04?oo`03003ooooo00<000Koo`03003ooooo00Ko
o`04003ooooo0007ool00`00ooooo`0>ool00`00ooooo`0Hool01000ooooo`003Ooo00<00?ooool0
2_oo00<00?ooool02_oo00<00?ooool00ooo00<00?ooool05?oo0`007ooo00<00?ooool01?oo00<0
0?ooool02Ooo00<00?oo0000:Ooo00<00?ooool09ooo00<00?ooool05?oo000Lool00`00ooooo`1>
ool00`00ool00002ool00`00ooooo`0?ool00`00ooooo`04ool00`00ooooo`03ool01000ooooo`00
0_oo00<00?ooool02?oo00<00?ooool00_oo00<00?ooool01ooo00<00?ooool0=ooo00<00?ooool0
1Ooo0`003Ooo00<00?ooool02Ooo00<00?ooool06_oo00<00?ooool03_oo00<00?oo00002Ooo00<0
0?ooool01ooo00<00?oo0000:ooo00<00?ooool05?oo000Lool00`00ooooo`11ool2000Hool00`00
ooooo`09ool00`00ooooo`03ool01@00oooooooo00008?oo0P002Ooo00<00?ooool05_oo00<00?oo
ool05ooo10009ooo00<00?ooool03_oo00D00?oo003oo`0000Coo`05003oooooool0000Cool00`00
ooooo`03ool01P00ool00000ool002Woo`03003ooooo01Coo`007?oo00<00?ooool0A?oo0P001Ooo
00D00?ooooooo`0001Soo`03003ooooo00[oo`03003ooooo00Goo`03003ooooo01;oo`03003ooooo
017oo`03003ooooo02Coo`<000;oo`03003ooooo01Koo`03003ooooo027oo`03003ooooo00Koo`03
003ooooo00?oo`03003ooooo00Soo`04003ooooo0003ool00`00ooooo`02ool01000ooooo`00:Ooo
00<00?ooool05?oo000Lool00`00ooooo`11ool01@00oooooooo00001?oo00@00?ooool000Goo`03
003ooooo00goo`03003ooooo00ooo`03003ooooo01[oo`03003ooooo00Woo`03003ooooo01?oo`03
003oo`0000Ooo`05003oooooool00007ool3000Bool00`00ooooo`08ool20005ool00`00ooooo`07
ool00`00ooooo`06ool00`00ooooo`09ool00`00ooooo`04ool20008ool00`00ooooo`06ool00`00
ooooo`04ool00`00ooooo`02ool2000Zool00`00ooooo`0Dool001_oo`03003ooooo04Koo`03003o
oooo00Coo`03003ooooo00goo`03003ooooo00[oo`03003ooooo02Koo`03003oo`0000Goo`03003o
oooo02[oo`<000?oo`03003ooooo02_oo`03003ooooo01?oo`03003ooooo013oo`03003ooooo00oo
o`8002[oo`03003ooooo01Coo`006ooo00@00?oo000004;oo`05003oooooool00004ool00`00oooo
o`0:ool01000ooooo`000ooo00<00?ooool04?oo00<00?ooool07Ooo00<00?ooool05?oo00<00?oo
ool05_oo1@001_oo00<00?ooool05Ooo00<00?ooool03ooo00<00?oo00004ooo00D00?ooooooo`00
00_oo`03003ooooo00_oo`8003Goo`03003ooooo01Coo`006ooo0P00A?oo0P0000Coo`00ool000?o
o`03003oo`0000Koo`04003ooooo000Hool00`00ooooo`0Oool00`00ooooo`02ool00`00ool00004
ool00`00ooooo`05ool00`00ool0000Aool00`00ooooo`03ool3000;ool00`00ooooo`0Cool00`00
ooooo`04ool01000ooooo`008?oo00@00?ooool000?oo`03003ooooo01Woo`03003ooooo02koo`03
003ooooo01?oo`006ooo00<00?ooool0@ooo0P003ooo00<00?ooool0??oo00<00?ooool03ooo00<0
0?ooool01_oo00D00?ooooooo`0000_oo`@001?oo`03003ooooo01?oo`03003ooooo02Koo`03003o
oooo00Coo`03003ooooo00[oo`03003ooooo00Coo`03003ooooo00;oo`04003ooooo000/ool00`00
ooooo`0Cool000Koo`8000Coo`03003ooooo00;oo`<000Ooo`03003ooooo04?oo`8000?oo`03003o
oooo00?oo`03003ooooo00;oo`04003ooooo0008ool2000/ool00`00ooooo`03ool01000ooooo`00
9?oo0`001Ooo00<00?ooool04Ooo00<00?ooool06Ooo00<00?ooool04?oo00<00?ooool00_oo00<0
0?ooool01ooo00@00?ooool001Soo`03003ooooo00Coo`03003ooooo02Woo`03003ooooo01?oo`00
1Ooo00@00?ooool000_oo`03003ooooo00Coo`03003ooooo04goo`03003ooooo00?oo`8000ooo`03
003ooooo00Koo`8000?oo`8000koo`03003ooooo00Koo`03003oo`0000Coo`8000koo`03003ooooo
01;oo`@000Soo`03003ooooo00Coo`03003ooooo00;oo`03003ooooo00goo`03003ooooo00Woo`03
003ooooo00Goo`03003ooooo01Goo`03003ooooo00Soo`03003ooooo00<000?oo`05003oooooool0
0003ool00`00ooooo`02ool2000:ool00`00ooooo`0Yool00`00ooooo`0Cool000Goo`04003ooooo
000;ool00`00ooooo`03ool00`00ooooo`1Pool01@00oooooooo00005?oo00<00?ooool04?oo00<0
0?ooool01Ooo00<00?ooool01Ooo00<00?ooool02Ooo00<00?ooool02?oo00<00?oo00000P002Ooo
00<00?ooool01_oo00D00?ooooooo`0002Ooo`03003ooooo01[oo`05003oooooool00008ool00`00
ooooo`0?ool20004ool00`00ooooo`0Zool00`00ooooo`0Cool000Goo`04003ooooo0008ool30006
ool00`00ooooo`15ool00`00ool0000>ool00`00ooooo`08ool00`00ooooo`0Aool00`00ooooo`08
ool00`00ooooo`02ool2000=ool00`00ooooo`02ool01@00oooooooo00001Ooo00<00?ooool00ooo
00<00?ooool01_oo0`000ooo00<00?ooool09_oo00D00?oo003oo`0002Koo`03003oo`0000Woo`03
003ooooo00;oo`03003ooooo013oo`03003ooooo00Coo`8002coo`03003ooooo01?oo`001Ooo00@0
0?ooool000Soo`03003ooooo00Koo`03003ooooo04Goo`800003ool00?oo00Koo`03003ooooo01Wo
o`03003ooooo017oo`03003ooooo00Coo`03003ooooo00[oo`03003ooooo00coo`03003ooooo00Wo
o`<0033oo`03003ooooo01Ooo`8000Goo`03003ooooo00_oo`03003ooooo00Goo`03003ooooo00?o
o`8000Coo`<000coo`03003ooooo02koo`03003ooooo01?oo`001Ooo00@00?ooool000Soo`03003o
oooo00Koo`03003ooooo04Goo`05003oo`00ool00005ool00`00ooooo`05ool00`00ooooo`02ool0
0`00ooooo`0?ool01000ooooo`003_oo00<00?ooool04Ooo0P002?oo00<00?ooool02?oo00<00?oo
00000`00;?oo00<00?ooool09?oo00<00?ooool02ooo00<00?ooool00P001Ooo00<00?ooool03ooo
00<00?ooool01ooo00<00?ooool0;Ooo00<00?ooool04_oo0006ool20009ool40005ool00`00oooo
o`15ool200000ooo003oo`03ool00`00ooooo`0Hool20004ool20009ool00`00ooooo`02ool00`00
ooooo`0Cool00`00ooooo`0Aool300000ooo003oo`09ool00`00ooooo`0Iool00`00ooooo`0jool0
0`00ooooo`08ool00`00ooooo`05ool00`00ool0000:ool00`00ooooo`04ool00`00ooooo`0/ool0
0`00ooooo`0Bool001[oo`03003ooooo04Goo`800003ool00?oo00Soo`03003ooooo00;oo`03003o
oooo02;oo`03003ooooo00[oo`03003ooooo00Soo`03003ooooo00koo`<000koo`03003ooooo00[o
o`03003ooooo02Goo`03003ooooo00;oo`03003ooooo00[oo`03003ooooo00ooo`03003ooooo00Oo
o`03003oo`0001Goo`05003oooooool0000`ool00`00ooooo`0Bool001[oo`03003ooooo04Koo`05
003oooooool00003ool00`00ooooo`02ool00`00ooooo`0Uool20008ool00`00ooooo`0<ool00`00
ooooo`06ool00`00ooooo`02ool30006ool00`00ooooo`0Mool00`00ooooo`03ool00`00ooooo`03
ool00`00ooooo`04ool00`00ooooo`0>ool00`00ooooo`0Dool00`00ooooo`0Cool00`00ooooo`0D
ool00`00ool00002000^ool00`00ooooo`0Bool001Woo`<004koo`03003ooooo00[oo`03003ooooo
00;oo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00koo`03003ooooo00Koo`03003ooooo
00Woo`05003oo`00ool00007ool400000ooo003oo`0=ool00`00ooooo`06ool00`00ooooo`0<ool0
0`00ooooo`0:ool00`00ooooo`08ool00`00ooooo`0Bool00`00ooooo`0?ool00`00ooooo`08ool0
0`00ooooo`05ool2000<ool00`00ooooo`02ool01000ooooo`00<ooo00<00?ooool04_oo000Iool0
0`00ooooo`17ool40003ool00`00ooooo`02ool01000ool000002?oo00<00?ooool09Ooo00<00?oo
ool02ooo00<00?ooool01?oo0`002?oo00<00?ooool0:ooo00<00?ooool03?oo00<00?ooool00_oo
00<00?ooool04ooo00<00?ooool05_oo00D00?ooooooo`0000;oo`03003ooooo00Coo`03003ooooo
00?oo`03003ooooo00Ooo`03003oo`0002koo`03003ooooo01;oo`006Ooo00<00?ooool0B?oo00D0
0?ooooooo`0000Koo`03003ooooo01coo`03003ooooo023oo`04003oooooool30007ool00`00oooo
o`09ool00`00ooooo`0Qool20009ool00`00ooooo`0;ool00`00ooooo`0Lool00`00ooooo`0Bool0
0`00ooooo`04ool00`00ooooo`03ool00`00ooooo`07ool00`00ooooo`0]ool00`00ooooo`0Bool0
01Woo`03003ooooo04Woo`8002Koo`03003ooooo027oo`@000ooo`<00003ool00?oo00_oo`03003o
oooo00Soo`03003ooooo00[oo`03003ooooo00Coo`03003ooooo01Ooo`8001Ooo`03003ooooo017o
o`8000[oo`03003ooooo00Woo`03003ooooo02koo`03003ooooo017oo`006Ooo00<00?ooool0BOoo
0P000_oo00<00?ooool01Ooo00D00?ooooooo`0000[oo`03003oo`0000;oo`03003ooooo00Soo`03
003ooooo01coo`<000;oo`05003oooooool0000^ool00`00ooooo`0Jool01@00oooooooo00008Ooo
00<00?ooool02ooo00<00?ooool00_oo00<00?ooool02?oo00<00?ooool0>Ooo00<00?ooool04Ooo
000Iool00`00ooooo`1=ool00`00ooooo`07ool00`00ooooo`0<ool00`00ooooo`0?ool00`00oooo
o`0;ool00`00ooooo`04ool00`00ool00006000Sool00`00ooooo`0>ool00`00ooooo`0:ool00`00
ooooo`06ool00`00ooooo`08ool00`00ooooo`0Bool00`00ooooo`06ool00`00ooooo`04ool00`00
ooooo`06ool00`00ooooo`06ool00`00ooooo`02ool00`00ooooo`04ool00`00ooooo`0gool00`00
ooooo`0Aool001Soo`03003ooooo04[oo`03003ooooo00;oo`03003ooooo00Goo`03003ooooo00go
o`03003ooooo00_oo`03003ooooo00;oo`05003oooooool0000>ool30006ool00`00ooooo`0[ool0
0`00ooooo`0Aool00`00ooooo`04ool00`00ooooo`0>ool00`00ooooo`0Cool01000oooooooo0P00
0ooo00<00?ooool00ooo00<00?oo00003?oo00@00?ooool000Goo`05003oooooool00002ool00`00
ool0000bool00`00ooooo`0Aool001Soo`03003ooooo05Goo`04003ooooo0007ool00`00ooooo`05
ool00`00ooooo`0Oool30009ool00`00ooooo`08ool2000@ool00`00ooooo`0jool00`00ooooo`04
ool00`00ooooo`09ool00`00ooooo`03ool00`00ooooo`0Gool01P00ool00000ool000?oo`8000?o
o`03003ooooo03Goo`03003ooooo017oo`006?oo00<00?ooool0COoo0P002_oo00<00?ooool02ooo
00<00?ooool02_oo00<00?ooool00ooo00<00?ooool02_oo0`003?oo00<00?ooool01_oo00<00?oo
ool04?oo00<00?ooool00ooo00<00?ooool04_oo00<00?ooool0:Ooo00<00?ooool03ooo00<00?oo
ool04_oo0P000ooo00<00?ooool00_oo00<00?ooool01ooo0`00<_oo00<00?ooool04Ooo000Hool0
0`00ooooo`1;ool01000ooooo`00=?oo10002ooo00D00?ooooooo`0001coo`05003oooooool00004
ool2000Dool00`00ooooo`0aool20002ool2000Jool00`00ooooo`06ool00`00ool00003ool2000b
ool00`00ooooo`0Aool001Soo`03003ooooo05;oo`05003oooooool00005ool00`00ooooo`0=ool0
0`00ooooo`03ool00`00ooooo`0;ool300000ooo003oo`08ool20005ool2000Bool00`00ooooo`06
ool00`00ooooo`0Nool00`00ooooo`0:ool2000Dool00`00ooooo`0Yool00`00ooooo`02ool00`00
ooooo`0oool00`00ooooo`0Aool001Soo`8005Goo`03003oo`0000;oo`8000Soo`03003ooooo00Oo
o`03003ooooo00Goo`03003ooooo00Goo`<001;oo`04003ooooo0009ool00`00ooooo`0/ool01@00
oooooooo00003Ooo00D00?ooooooo`0000Koo`05003oooooool0000=ool01P00ooooo`00ool001Ko
o`03003ooooo00[oo`03003oo`0000Koo`05003oo`00003oo`02000dool00`00ooooo`0@ool001Oo
o`8005Ooo`03003ooooo00[oo`09003oooooool00?oo003oo`0000Soo`03003ooooo00Coo`<000So
o`03003ooooo00goo`03003ooooo00[oo`03003ooooo017oo`8000goo`03003ooooo01goo`03003o
oooo02goo`03003ooooo00Woo`03003ooooo00Goo`8000Coo`04003oooooool3000dool00`00oooo
o`0@ool001Ooo`03003ooooo04goo`<002Goo`03003oo`0000<001Coo`03003ooooo00Coo`05003o
ooooool0000:ool00`00ooooo`0_ool00`00ooooo`0;ool01@00oooooooo00003?oo00<00?ooool0
0ooo00<00?ooool06ooo00<00?ooool00ooo00<00?ooool02?oo0P00?_oo00<00?ooool04?oo000G
ool00`00ooooo`1=ool20008ool00`00ool00004ool00`00ooooo`0Cool40007ool00`00ooooo`05
ool00`00ooooo`04ool00`00ooooo`05ool00`00ooooo`04ool00`00ooooo`0Eool00`00ooooo`0K
ool00`00ooooo`18ool00`00ooooo`05ool00`00ooooo`02ool30007ool2000dool00`00ooooo`0@
ool001Ooo`03003ooooo05Woo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00[oo`<000oo
o`03003ooooo013oo`03003ooooo01Woo`04003ooooo000>ool00`00ooooo`0Bool00`00ooooo`0@
ool00`00ooooo`0Hool00`00ooooo`0Nool01@00oooooooo0000?_oo00<00?ooool04?oo000Gool0
0`00ooooo`1>ool00`00ooooo`09ool00`00ool0000Aool3000Eool00`00ooooo`0=ool00`00oooo
o`0Cool00`00ool00003ool00`00ooooo`02ool00`00ooooo`09ool00`00ooooo`0aool2000@ool0
1000ooooo`006ooo0P000ooo00<00?oo00000ooo00<00?ooool0=Ooo00<00?ooool04?oo000Gool0
0`00ooooo`1@ool00`00ooooo`06ool00`00ooooo`08ool00`00ooooo`03ool4000=ool00`00oooo
o`0Hool00`00ooooo`0>ool00`00ool00003ool00`00ooooo`0Lool00`00ooooo`0Eool2000Aool0
0`00ool00004ool00`00ooooo`0Mool01000oooooooo0P001_oo00@00?ooooooo`8003_oo`03003o
oooo013oo`005ooo00<00?ooool0Cooo00<00?ooool00_oo00<00?ooool01Ooo00<00?ooool01?oo
00@00?ooooooo`<002Coo`03003ooooo00;oo`04003oo`00000Kool00`00ooooo`0cool00`00oooo
o`06ool00`00ool0000Iool00`00ooooo`07ool00`00ooooo`0Eool00`00ool0000jool00`00oooo
o`0?ool001Koo`03003ooooo05;oo`05003oooooool0000>ool30005ool00`00ooooo`0Qool01`00
oooooooo003oo`0000Woo`03003ooooo00?oo`03003ooooo01Goo`03003ooooo01Soo`03003ooooo
00Woo`03003oo`0000Soo`03003ooooo00?oo`03003oo`0000Ooo`03003ooooo01[oo`03003ooooo
00;oo`04003ooooo0002ool20005ool00`00ooooo`0jool00`00ooooo`0?ool001Koo`03003ooooo
05;oo`03003ooooo00goo`<00006ool00?oo003oo`000_oo0P001ooo00<00?ooool07_oo00<00?oo
ool02ooo00<00?ooool02Ooo00<00?ooool02Ooo00<00?ooool03_oo00<00?ooool03ooo00<00?oo
ool01_oo00<00?ooool02ooo00<00?ooool02_oo00<00?ooool06_oo00<00?oo00001Ooo00<00?oo
ool00ooo00<00?oo00000_oo00<00?ooool0=_oo00<00?ooool03ooo000Fool00`00ooooo`1Bool0
0`00ooooo`02ool00`00ool00004ool40008ool01000ooooo`003ooo00<00?ooool05ooo00<00?oo
00003?oo00<00?ooool04?oo00<00?ooool05?oo00<00?oo00004Ooo00<00?ooool08?oo00<00?oo
ool04Ooo0P004Ooo00D00?ooooooo`0003[oo`03003ooooo00ooo`005_oo00<00?ooool0EOoo00<0
0?ooool00ooo10001Ooo00<00?ooool00ooo00<00?ooool01Ooo00@00?ooool000?oo`03003ooooo
01Coo`03003ooooo00Coo`03003ooooo00goo`03003ooooo02ooo`8001Soo`03003ooooo03;oo`03
003ooooo00?oo`03003ooooo00;oo`03003ooooo03Ooo`03003ooooo00ooo`005_oo0P00FOoo0`00
3Ooo00<00?ooool01?oo00<00?ooool01?oo0P001_oo00<00?ooool01Ooo00<00?ooool01?oo00<0
0?ooool01_oo0P000ooo00<00?ooool0;?oo00<00?ooool04ooo0P005Ooo00<00?ooool00_oo00<0
0?ooool01?oo00<00?ooool06?oo00<00?ooool04ooo00<00?ooool0=_oo00<00?ooool03ooo000F
ool00`00ooooo`1Eool30007ool00`00ool00003ool20004ool00`00ooooo`02ool00`00ooooo`0;
ool00`00ooooo`0Fool00`00ooooo`0;ool00`00ooooo`0?ool00`00ooooo`04ool00`00ooooo`0G
ool00`00ooooo`0Oool00`00ool00002ool00`00ooooo`09ool00`00ooooo`0Cool00`00ooooo`0=
ool200000ooo003oo`0gool00`00ooooo`0?ool001Goo`03003ooooo05?oo`@00003ool00?oo00[o
o`03003ooooo00_oo`03003ooooo00ooo`03003ooooo00Woo`03003ooooo00;oo`04003ooooo000@
ool00`00ooooo`0Fool00`00ooooo`0Gool00`00ooooo`06ool01@00oooooooo00000ooo00<00?oo
ool00_oo00<00?ooool02Ooo00<00?ooool08Ooo00<00?ooool02_oo00<00?oo00001?oo00<00?oo
ool0=_oo00<00?ooool03_oo000Eool00`00ooooo`1?ool40002ool01000ooooo`003_oo00D00?oo
ooooo`0001Goo`05003oooooool00009ool00`00ooooo`06ool00`00ooooo`0Kool00`00ooooo`0E
ool00`00ooooo`0Eool00`00ooooo`0Mool00`00ooooo`0<ool00`00ooooo`0@ool01@00oooooooo
00002_oo00<00?ooool0=Ooo00<00?ooool03_oo000Eool00`00ooooo`1<ool3000:ool01000oooo
o`005?oo00<00?oo00003_oo00<00?ooool04ooo00<00?ooool01_oo0P003?oo00<00?ooool0?ooo
00<00?ooool06?oo00<00?ooool00_oo00<00?ooool01_oo00<00?ooool02ooo0P001Ooo0P0000?o
o`00ool01?oo00<00?ooool0=?oo00<00?ooool03_oo000Eool00`00ooooo`19ool3000:ool00`00
ooooo`04ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`0?ool00`00ooooo`0Kool00`00
ooooo`0Jool00`00ooooo`0Oool00`00ooooo`0>ool00`00ooooo`07ool00`00ooooo`07ool00`00
ooooo`05ool00`00ooooo`04ool01000ool000000_oo00D00?ooooooo`0000Goo`03003ooooo00?o
o`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00_oo`03003ooooo03?oo`03003ooooo00ko
o`005Ooo00<00?ooool0A_oo0`003_oo0P001Ooo00@00?ooool000Goo`05003oooooool0000Zool0
0`00ool0000@ool01000ooooo`000_oo00<00?ooool02Ooo00<00?ooool01_oo00<00?ooool01_oo
00@00?ooool001coo`03003oo`0001ooo`03003ooooo00_oo`03003ooooo00koo`03003oo`0000So
o`03003ooooo03?oo`03003ooooo00koo`005Ooo00<00?ooool0@_oo10004Ooo00@00?ooool001?o
o`03003ooooo00Goo`03003ooooo00[oo`03003ooooo00Goo`03003oo`0000[oo`03003ooooo00?o
o`8001;oo`03003ooooo01;oo`04003oooooool200000ooo003oo`0Kool00`00ooooo`0>ool00`00
ooooo`0<ool01@00oooooooo00002Ooo0P001Ooo00<00?ooool01ooo00<00?ooool03Ooo00<00?oo
ool0<_oo00<00?ooool03_oo000Dool00`00ooooo`10ool3000Fool200000ooo00000006ool01@00
oooooooo00005_oo00<00?ooool01Ooo00<00?ooool01?oo00<00?ooool02?oo00<00?oo00002ooo
00@00?ooool000Goo`03003ooooo00coo`03003ooooo013oo`03003ooooo00Koo`03003ooooo00oo
o`03003ooooo01Koo`05003oooooool0000=ool00`00ooooo`09ool01000ooooo`000ooo00<00?oo
ool00_oo00<00?ooool02Ooo00<00?ooool0<Ooo00<00?ooool03_oo000Dool00`00ooooo`0mool3
000Iool20002ool00`00ooooo`02ool00`00ooooo`0?ool00`00ooooo`0;ool00`00ooooo`0Dool0
1000ooooo`002?oo00@00?ooool000_oo`03003ooooo00Soo`03003ooooo037oo`03003ooooo01Oo
o`05003oooooool0000:ool01000ool000000_oo00<00?ooool00ooo00<00?ooool01?oo0P003?oo
00<00?ooool0<?oo00<00?ooool03_oo000Dool00`00ooooo`0jool3000Nool01P00ooooo`00ool0
00Coo`04003ooooo000`ool00`00ooooo`0=ool00`00ooooo`0<ool00`00ooooo`0Gool00`00oooo
o`06ool00`00ooooo`0Bool00`00ool0000;ool00`00ooooo`0Iool01000oooooooo0P001_oo00D0
0?ooooooo`0001?oo`03003ooooo033oo`03003ooooo00goo`005?oo00<00?ooool0=_oo10008?oo
00H00?ooool00?oo0006ool00`00ooooo`0:ool00`00ooooo`05ool00`00ooooo`0Kool00`00oooo
o`0nool00`00ooooo`05ool00`00ooooo`09ool00`00ooooo`04ool00`00ooooo`03ool00`00oooo
o`06ool2000?ool00`00ooooo`0>ool20002ool2000Bool00`00ooooo`0`ool00`00ooooo`0=ool0
01Coo`8003Coo`<002Goo`8000?oo`03003ooooo01Coo`03003ooooo00_oo`03003ooooo017oo`03
003ooooo00goo`8000?oo`03003ooooo00Koo`03003ooooo00Ooo`03003ooooo00goo`03003ooooo
00coo`03003ooooo01[oo`04003ooooo000Eool20003ool2000Rool00`00ooooo`0_ool00`00oooo
o`0=ool001Coo`03003ooooo033oo`<002Woo`03003oo`00017oo`03003ooooo01Coo`03003ooooo
00Woo`03003ooooo00?oo`03003ooooo00Koo`03003ooooo017oo`03003ooooo00Woo`03003ooooo
02;oo`03003ooooo01;oo`03003ooooo00Koo`03003ooooo00goo`03003ooooo017oo`03003ooooo
01Coo`03003ooooo02koo`03003ooooo00goo`005?oo00<00?ooool0;Ooo0`00;Ooo0`001_oo0P00
3?oo00<00?ooool08_oo00<00?ooool06?oo00<00?ooool01ooo00<00?ooool05?oo00<00?ooool0
6?oo0`003?oo00<00?oo00004Ooo00<00?ooool03ooo00<00?ooool00ooo00<00?ooool04ooo00<0
0?ooool0;Ooo00<00?ooool03Ooo000Cool00`00ooooo`0Zool4000`ool01@00oooooooo00001Ooo
00<00?ooool01ooo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool02_oo00<00?ooool02?oo
00H00?oo00000?oo000fool00`00ool0000Nool00`00ooooo`0Mool00`00ooooo`03ool20009ool0
0`00ooooo`02ool20002ool00`00ool0000Eool00`00ooooo`0/ool00`00ooooo`0=ool001?oo`03
003ooooo02Ooo`<003Ooo`05003oooooool0000=ool00`00ooooo`02ool00`00ooooo`02ool00`00
ooooo`02ool00`00ooooo`0Dool00`00ooooo`08ool00`00ooooo`0/ool00`00ooooo`0;ool00`00
ooooo`0?ool00`00ooooo`0:ool00`00ooooo`0Aool00`00ooooo`0:ool20007ool00`00ooooo`0F
ool00`00ooooo`0/ool00`00ooooo`0=ool001?oo`03003ooooo02Coo`<003Woo`05003oo`00ool0
0006ool2000=ool00`00ooooo`0Aool20009ool00`00ooooo`0>ool00`00ooooo`02ool00`00oooo
o`0>ool00`00ooooo`09ool00`00ooooo`0Gool00`00ooooo`0?ool00`00ooooo`02ool00`00oooo
o`02ool01000ooooo`005?oo00H00?ooooooo`00ool20002ool00`00ooooo`02ool3000Hool00`00
ooooo`0/ool00`00ooooo`0<ool001?oo`03003ooooo027oo`<004ooo`03003ooooo01?oo`03003o
oooo00Coo`05003oooooool00004ool00`00ooooo`06ool00`00ool00005ool00`00ooooo`0Hool0
0`00ooooo`0<ool01000ooooo`003_oo00<00?ooool02Ooo00<00?ooool02_oo00<00?ooool01?oo
00D00?ooooooo`0000[oo`03003oo`0000Goo`03003oo`0000Coo`8000?oo`03003oo`0001Woo`03
003ooooo02_oo`03003ooooo00coo`004ooo00<00?ooool07Ooo1000@?oo0P0000?oo`00ool0:ooo
00D00?ooooooo`0000?oo`03003oo`0000<000Ooo`03003ooooo00goo`03003ooooo02Ooo`05003o
ooooool00009ool00`00ooooo`02ool2000Aool00`00ooooo`07ool00`00ooooo`0<ool00`00oooo
o`06ool00`00ool0000Kool00`00ooooo`0Zool00`00ooooo`0<ool001?oo`03003ooooo01[oo`<0
04Koo`04003ooooo000Fool00`00ool00008ool00`00ooooo`0>ool00`00ooooo`0Oool00`00oooo
o`0?ool00`00ooooo`0?ool00`00ooooo`0>ool00`00ooooo`0Dool20008ool00`00ooooo`0?ool0
0`00ooooo`0Qool00`00ooooo`0Yool00`00ooooo`0<ool001;oo`03003ooooo01Soo`<004Soo`03
003ooooo00Koo`03003ooooo00Coo`03003ooooo00;oo`03003ooooo01Woo`03003ooooo00?oo`03
003ooooo00?oo`03003ooooo01Woo`03003ooooo00coo`03003ooooo00;oo`05003oooooool0000G
ool00`00ooooo`0Oool200000ooo003oo`0@ool01000oooooooo0P008?oo00<00?ooool0:?oo00<0
0?ooool03?oo000Bool00`00ooooo`0Eool3001<ool01000ooooo`001Ooo00<00?oo00006?oo0P00
1Ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool02ooo00<00?ooool03ooo00<00?ooool0
2ooo00<00?ooool01Ooo00<00?ooool03_oo00<00?ooool00_oo00D00?ooooooo`0000Coo`03003o
oooo02Coo`04003ooooo000>ool2000Oool00`00ooooo`0Xool00`00ooooo`0<ool001;oo`03003o
oooo01;oo`<005goo`03003ooooo00;oo`03003ooooo00Koo`8000Woo`04003ooooo0004ool00`00
ooooo`04ool2000=ool00`00ooooo`0Cool00`00ooooo`0Kool00`00ooooo`0Jool00`00ooooo`0D
ool00`00ooooo`04ool01@00oooooooo00002Ooo00<00?ooool08Ooo00<00?ooool09ooo00<00?oo
ool03?oo000Bool4000=ool4001Eool01000ooooo`000_oo00<00?ooool00ooo00<00?ooool04?oo
00D00?ooooooo`0000coo`04003ooooo0006ool00`00ooooo`02ool00`00ooooo`0>ool00`00oooo
o`0;ool00`00ooooo`02ool00`00ooooo`02ool2000=ool00`00ool0000Bool00`00ooooo`0<ool0
0`00ooooo`05ool01@00oooooooo00006?oo00<00?ooool08Ooo00<00?ooool09ooo00<00?ooool0
2ooo000Bool00`00ooooo`0;ool3001Jool00`00ooooo`0<ool30004ool00`00ooooo`0:ool00`00
ooooo`0<ool00`00ooooo`1;ool00`00ooooo`0:ool00`00ooooo`0?ool00`00ooooo`02ool00`00
ooooo`0;ool00`00ool00009ool2000Tool00`00ooooo`0Vool00`00ooooo`0;ool000Soo`@000Ko
o`03003ooooo00Soo`<005coo`80027oo`03003ooooo00goo`03003ooooo00;oo`03003ooooo00Ko
o`03003ooooo00[oo`03003ooooo00goo`03003ooooo00;oo`03003ooooo01?oo`03003ooooo00Go
o`03003ooooo01;oo`03003ooooo00Soo`03003ooooo00Coo`05003oooooool00009ool01000oooo
o`000_oo00<00?oo00009ooo00<00?ooool09Ooo00<00?ooool02ooo000:ool00`00ooooo`04ool0
0`00ooooo`06ool3001Pool20003ool00`00ooooo`04ool00`00ool00004ool2000Mool2000Vool0
0`00ooooo`09ool01000ooooo`007?oo00@00?oo000000coo`03003ooooo00Coo`03003ooooo00?o
o`03003ooooo00Goo`06003ooooo003oo`001Ooo00<00?ooool00P0000?oo`00ool09ooo00<00?oo
ool09Ooo00<00?ooool02ooo000:ool00`00ooooo`04ool00`00ooooo`02ool4001Tool01P00oooo
o`00ool000_oo`03003ooooo01goo`05003oooooool00008ool00`00ooooo`04ool00`00ooooo`0`
ool01000ooooo`006ooo00<00?ooool02Ooo00<00?ooool02ooo00<00?ooool01Ooo00<00?oo0000
:Ooo00<00?ooool09?oo00<00?ooool02ooo000:ool00`00ooooo`04ool00`00ool00002001[ool0
0`00ooooo`0;ool00`00ooooo`04ool30004ool00`00ooooo`06ool00`00ool00006ool00`00oooo
o`0[ool00`00ooooo`02ool00`00ooooo`04ool00`00ooooo`0Oool00`00ooooo`09ool00`00oooo
o`05ool00`00ool0000:ool00`00ooooo`07ool2000/ool00`00ooooo`0Sool00`00ooooo`0;ool0
00[oo`03003ooooo00Coo`8006goo`03003ooooo00?oo`05003oo`00ool00008ool01000oooooooo
0P003_oo00<00?ooool01Ooo00<00?oo00001_oo00<00?ooool01ooo00<00?ooool00ooo0P001Ooo
00<00?ooool00_oo00D00?ooooooo`0000?oo`03003oo`0000goo`03003ooooo00_oo`04003oo`00
000:ool00`00ooooo`05ool00`00ool0000=ool01@00oooooooo00002_oo00<00?oo00001?oo0P00
;Ooo00<00?ooool08_oo00<00?ooool02ooo0008ool30007ool20002ool00`00ooooo`1Xool01000
ool000001?oo00<00?ooool06_oo00<00?oo00000ooo00<00?oo00000P007?oo00<00?ooool01?oo
00<00?ooool0>ooo00<00?ooool01?oo00@00?oo000000Soo`03003ooooo00[oo`8000;oo`03003o
oooo02goo`03003ooooo027oo`03003ooooo00_oo`002_oo00<00?ooool01ooo00<00?oo0000Jooo
00<00?ooool01_oo00@00?ooool000Coo`05003oooooool0000>ool00`00ool00006ool01`00oooo
oooo003oo`0001Koo`03003ooooo00Woo`04003ooooo0005ool00`00ooooo`08ool00`00ooooo`0T
ool00`00ool00002ool00`00ooooo`0<ool00`00ooooo`09ool3000`ool00`00ooooo`0Rool00`00
ooooo`0:ool001Goo`8007Ooo`03003ooooo00Goo`03003ooooo0080013oo`07003oooooool00?oo
00000_oo00<00?ooool04_oo00<00?ooool06?oo00<00?ooool04Ooo00<00?ooool04?oo00<00?oo
ool00ooo00<00?ooool03Ooo00<00?ooool01?oo00<00?ooool00_oo00<00?ooool00P000_oo00<0
0?ooool0<?oo00<00?ooool08Ooo00<00?ooool02_oo000Fool2001/ool20002ool00`00ool0000@
ool00`00ooooo`02ool00`00ooooo`06ool00`00ooooo`03ool00`00ooooo`0=ool00`00ooooo`0W
ool00`00ooooo`0Aool00`00ool00002ool00`00ooooo`08ool01@00oooooooo00000ooo00<00?oo
ool01_oo00<00?ooool01?oo00<00?ooool00_oo00@00?ooool003[oo`03003ooooo023oo`03003o
oooo00[oo`006?oo00<00?ooool0J_oo00H00?ooool00?oo0003ool00`00ooooo`02ool00`00oooo
o`02ool01000ooooo`003?oo00<00?ooool01?oo00@00?ooool000Koo`03003ooooo00Soo`03003o
oooo00ooo`05003oooooool0000@ool00`00ooooo`06ool00`00ooooo`03ool00`00ooooo`0Pool0
0`00ooooo`04ool00`00ooooo`02ool01000ooooo`001?oo0P00=_oo00<00?ooool07ooo00<00?oo
ool02_oo000Iool2001/ool01000ooooo`000ooo00<00?oo00001?oo00<00?oo00000ooo00<00?oo
ool03Ooo00D00?ooooooo`00013oo`03003ooooo03Coo`05003oooooool0000>ool01@00oooooooo
00006Ooo00@00?ooool000Goo`03003ooooo03Koo`03003ooooo01koo`03003ooooo00[oo`006ooo
00<00?ooool0JOoo0P004Ooo0P003Ooo0P001?oo00<00?ooool03Ooo00<00?ooool01Ooo00<00?oo
00008ooo00<00?ooool01Ooo00D00?ooooooo`0000Goo`03003ooooo00;oo`03003ooooo00?oo`03
003ooooo00Woo`03003ooooo00_oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo03Ooo`03
003ooooo01koo`03003ooooo00[oo`007?oo0P0000?oo`00ool0Iooo00@00?ooool000Goo`03003o
oooo01[oo`<00003ool00?oo00Woo`03003ooooo00Woo`03003ooooo00Soo`03003ooooo01Goo`03
003ooooo00Goo`03003ooooo00koo`03003ooooo00[oo`04003ooooo0003ool00`00ooooo`03ool2
000;ool01000ooooo`00>ooo00<00?ooool07Ooo00<00?ooool02_oo000Nool2001Yool01000oooo
o`001Ooo00<00?ooool01?oo00<00?ooool01?oo00D00?ooooooo`0000[oo`03003ooooo00;oo`03
003oo`0002Coo`03003ooooo00?oo`06003ooooo003oo`003_oo00<00?ooool01ooo00D00?oooooo
o`0000Soo`03003ooooo00Goo`03003ooooo00coo`03003oo`0000Ooo`8003goo`03003ooooo01go
o`03003ooooo00Woo`007_oo0P00JOoo00@00?oo000000?oo`8001Woo`05003oooooool0000<ool0
0`00ooooo`06ool20007ool2000:ool20006ool00`00ooooo`020005ool00`00ooooo`03ool00`00
ooooo`05ool00`00ooooo`0Iool00`00ooooo`02ool01000ooooo`000_oo00<00?ooool01ooo00<0
0?oo0000?ooo00<00?ooool07?oo00<00?ooool02Ooo000Pool2001_ool01000ooooo`002_oo00<0
0?ooool03Ooo0P002ooo00<00?ooool01?oo00<00?ooool05?oo00<00?ooool06Ooo00<00?ooool0
7?oo00<00?ooool00_oo00<00?ooool0DOoo00<00?ooool06ooo00<00?ooool02Ooo000Eool40009
ool00`00ooooo`1Yool20003ool01000ooooo`000_oo00<00?ooool02?oo00<00?ooool00_oo00<0
0?ooool00ooo00<00?ooool00_oo00@00?ooool000Goo`03003ooooo00?oo`03003ooooo00;oo`06
003ooooo003oo`002Ooo00D00?ooooooo`00027oo`06003ooooo003oo`005_oo00<00?ooool03Ooo
00<00?ooool0@_oo00<00?ooool06ooo00<00?ooool02Ooo000Gool00`00ooooo`09ool2001Yool0
0`00ooooo`0>ool00`00ooooo`0;ool2000?ool2000Cool00`00ooooo`0;ool00`00ooooo`0Nool0
1000ooooo`001Ooo00<00?ooool01ooo00<00?ooool02_oo00H00?oo003oo`00ool20015ool00`00
ooooo`0Jool00`00ooooo`09ool001Ooo`03003ooooo00_oo`03003oo`0006[oo`03003oo`0000Co
o`05003oooooool0000?ool20004ool2000:ool00`00ooooo`0Hool00`00ooooo`03ool00`00oooo
o`03ool2000=ool01000ooooo`003?oo0P000ooo00<00?ooool03Ooo00<00?ooool02?oo1000Aooo
00<00?ooool06Ooo00<00?ooool02Ooo000?ool40004ool00`00ooooo`0<ool2001Xool40002ool0
1@00oooooooo00001_oo00@00?ooool000Goo`05003oo`00ool0000;ool01@00oooooooo00003?oo
00<00?ooool04?oo00<00?ooool01?oo00<00?ooool00P004ooo0P003ooo00<00?ooool05Ooo00<0
0?ooool0B?oo00<00?ooool06?oo00<00?ooool02Ooo000Gool00`00ooooo`0=ool2001Yool00`00
ooooo`06ool00`00ooooo`07ool00`00ooooo`05ool20002ool00`00ooooo`02ool00`00ooooo`0G
ool00`00ooooo`13ool200000ooo003oo`02ool01@00oooooooo00000ooo00<00?ooool0B_oo00<0
0?ooool06?oo00<00?ooool02?oo000Eool3000Aool00`00ooooo`1Wool2000Iool00`00ooooo`0D
ool01000ooooo`000ooo00<00?ooool02_oo00<00?ooool00_oo00<00?ooool06Ooo00<00?ooool0
1ooo00<00?ooool01ooo0P000ooo00<00?ooool02?oo0P0000?oo`0000000P00C_oo00<00?ooool0
5ooo00<00?ooool02?oo000Gool00`00ooooo`0@ool2001Xool00`00ooooo`02ool200000ooo003o
o`0>ool00`00ool0000Cool01@00oooooooo00001?oo00<00?oo00001_oo00<00?ooool02?oo00@0
0?ooool000;oo`03003ooooo00Koo`03003ooooo00_oo`03003ooooo00[oo`03003ooooo017oo`05
003oo`00ool0001Aool00`00ooooo`0Gool00`00ooooo`08ool002coo`03003ooooo06Soo`03003o
oooo00coo`03003ooooo00Goo`03003oo`0000;oo`03003ooooo00?oo`03003ooooo01coo`8000So
o`04003ooooo000eool00`00ooooo`03ool00`00ooooo`1@ool00`00ooooo`0Fool00`00ooooo`08
ool002goo`04003ooooo001gool00`00ooooo`03ool2000:ool2000Bool00`00ooooo`05ool01000
ooooo`005_oo00<00?ooool00_oo00<00?ooool00P006Ooo00<00?ooool00_oo00<00?ooool00_oo
00<00?oo0000EOoo00<00?ooool05Ooo00<00?ooool02?oo000^ool3001Xool3000?ool01P00oooo
o`00ool000?oo`05003oooooool00005ool00`00ooooo`08ool00`00ooooo`0<ool00`00ooooo`02
0007ool2000Fool00`00ooooo`07ool00`00ooooo`0Eool00`00ooooo`1Eool00`00ooooo`0Dool0
0`00ooooo`08ool0033oo`03003ooooo06Soo`03003oo`0000;oo`03003ooooo00Koo`03003ooooo
00;oo`03003ooooo00[oo`03003ooooo00Goo`03003ooooo01[oo`03003ooooo00coo`8000[oo`03
003ooooo00goo`03003ooooo00Coo`04003ooooo0003ool00`00ool00002001Iool00`00ooooo`0C
ool00`00ooooo`08ool0037oo`8006Woo`03003ooooo00Soo`03003ooooo00Coo`04003ooooo0006
ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`0Gool00`00ooooo`04ool00`00ooooo`02
ool20004ool00`00ool0000@ool00`00ooooo`0:ool00`00ool00002ool20002ool00`00ooooo`1J
ool00`00ooooo`0Cool00`00ooooo`08ool003?oo`03003ooooo06Soo`03003oo`0000;oo`03003o
o`0000Koo`03003oo`0000;oo`04003ooooo0002ool00`00ooooo`0>ool00`00ooooo`05ool00`00
ooooo`0;ool00`00ooooo`02000?ool00`00ooooo`09ool00`00ooooo`1gool00`00ooooo`0Cool0
0`00ooooo`07ool003Coo`8006[oo`03003ooooo00;oo`03003ooooo00Goo`80023oo`03003ooooo
00ooo`03003ooooo00?oo`03003ooooo00goo`03003ooooo00goo`03003ooooo00;oo`8000?oo`03
003ooooo00?oo`03003ooooo05ooo`03003ooooo01;oo`03003ooooo00Ooo`00=_oo00<00?oo0000
JOoo00<00?ooool01?oo0P000ooo00<00?ooool04?oo00<00?ooool01?oo00@00?ooool000;oo`04
003ooooo000@ool01@00oooooooo00001_oo00<00?oo00001Ooo00D00?ooooooo`0000Goo`03003o
oooo00Koo`8000;oo`@000Coo`03003oo`0006?oo`03003ooooo017oo`03003ooooo00Ooo`00=ooo
0P00Jooo0P0000?oo`00ool01?oo0P000_oo00<00?oo00004ooo00<00?ooool03?oo0P002Ooo00<0
0?ooool02ooo00<00?ooool01?oo0P003?oo00<00?oo00001Ooo00<00?ooool01?oo00<00?ooool0
IOoo00<00?ooool04?oo00<00?ooool01ooo000hool2001`ool01@00oooooooo00002Ooo00<00?oo
ool03ooo00<00?ooool00ooo0P004?oo00<00?ooool01_oo00<00?ooool03?oo00<00?ooool00_oo
0P000ooo00T00?ooooooo`00ool00?oo00000_oo1000J?oo00<00?ooool04?oo00<00?ooool01ooo
000jool00`00ooooo`1Zool30004ool00`00ooooo`07ool01000ooooo`000_oo00D00?oo003oo`00
013oo`03003ooooo00goo`03003ooooo00;oo`03003ooooo00Coo`03003ooooo00;oo`03003ooooo
00Koo`03003ooooo00Ooo`03003oo`0000;oo`D006_oo`03003ooooo00ooo`03003ooooo00Ooo`00
>ooo0P00Kooo00<00?oo00000ooo0P002?oo00<00?oo00002Ooo00<00?ooool05Ooo00<00?ooool0
2?oo00<00?ooool03?oo00<00?ooool02Ooo00<00?ooool00_oo00@00?ooool006koo`03003ooooo
00koo`03003ooooo00Ooo`00?Ooo00D00?ooooooo`0006[oo`03003oo`0001Soo`800003ool00?oo
013oo`03003ooooo00[oo`03003oo`0000Ooo`03003ooooo00;oo`04003oooooool20002ool20007
ool2001cool00`00ooooo`0>ool00`00ooooo`06ool003koo`04003ooooo001/ool20002ool00`00
ool00006ool00`00ooooo`02ool20006ool00`00ooooo`04ool00`00ool0000>ool20002ool00`00
ooooo`05ool2000=ool00`00ooooo`08ool00`00ooooo`1fool00`00ooooo`0=ool00`00ooooo`06
ool003ooo`8006goo`04003oooooool3000Cool00`00ooooo`02ool00`00ooooo`0:ool200000ooo
003oo`03ool00`00ooooo`0<ool00`00ooooo`0;ool00`00ooooo`020002ool2001gool00`00oooo
o`0=ool00`00ooooo`06ool0043oo`8006coo`03003ooooo00Coo`03003ooooo00;oo`05003ooooo
ool00007ool01`00oooooooo003oo`0000Coo`03003ooooo00;oo`04003ooooo0007ool00`00oooo
o`02ool00`00ool0000>ool01000ooooo`001?oo00@00?ooool007goo`03003ooooo00coo`03003o
oooo00Koo`00@_oo0P00J_oo00<00?ooool01ooo00D00?ooooooo`0000;oo`8000_oo`03003ooooo
00?oo`04003ooooo0004ool01000ooooo`005Ooo00<00?ooool01_oo0`0000?oo`00ool0Oooo00<0
0?ooool02ooo00<00?ooool01_oo0014ool00`00ooooo`1Wool00`00ooooo`0:ool200001Ooo003o
oooo00000ooo00@00?ooool000Goo`8000?oo`03003ooooo00Ooo`05003oooooool00005ool01000
ooooo`001ooo00H00?ooool00?oo0002ool30025ool00`00ooooo`0:ool00`00ooooo`06ool004Go
o`03003ooooo06Koo`03003ooooo013oo`03003oo`0000;oo`800003ool00?oo00Woo`04003ooooo
0006ool00`00ooooo`07ool20002ool01P00ooooo`00ool0097oo`03003ooooo00Woo`03003ooooo
00Koo`00A_oo0`00IOoo00<00?ooool04_oo00<00?oo00000_oo00@00?oo000000;oo`05003ooooo
ool00004ool200000ooo003oo`02ool00`00ooooo`03ool00`00ooooo`08ool300001?oo00000000
SOoo00<00?ooool02_oo00<00?ooool01Ooo0018ool00`00ooooo`1Sool00`00ooooo`0Hool02@00
ool00000ool00?oo003oo`020002ool30007ool01000ooooo`001Ooo00H00?ooool00?oo002Eool0
0`00ooooo`09ool00`00ooooo`05ool004Woo`8006;oo`03003ooooo02?oo`800003ool000000080
0005ool00?oo003oo`03002Sool00`00ooooo`08ool00`00ooooo`05ool004_oo`03003ooooo05oo
o`03003ooooo0=Koo`03003ooooo00Ooo`03003ooooo00Goo`00>_oo0P001?oo00<00?ooool00_oo
0`001?oo0P00Gooo00<00?ooool0eooo00<00?ooool01_oo00<00?ooool01Ooo000iool01000oooo
o`002ooo00<00?ooool00ooo00<00?oo0000G?oo00<00?ooool0f?oo00<00?ooool01Ooo00<00?oo
ool01Ooo000iool01000ooooo`002ooo00<00?ooool01?oo0P00G?oo00<00?ooool0f?oo00<00?oo
ool01Ooo00<00?ooool01Ooo000cool40002ool01000ooooo`002?oo0`002?oo0P00Fooo00<00?oo
ool0fOoo00<00?ooool01?oo00<00?ooool01Ooo000iool01000ooooo`002?oo00<00?ooool02_oo
00<00?ooool0F?oo00<00?ooool0f_oo00<00?ooool01?oo00<00?ooool01?oo000iool01000oooo
o`002?oo00<00?ooool02ooo0P00F?oo00<00?ooool0fooo00<00?ooool00ooo00<00?ooool01?oo
000jool20009ool4000<ool01000ooooo`00E?oo00<00?ooool0g?oo00<00?ooool00_oo00<00?oo
ool01?oo001Fool00`00ool0001Dool00`00ooooo`3Lool00`00ooooo`02ool00`00ooooo`04ool0
05Ooo`8005Coo`03003ooooo0=goo`05003oooooool00006ool005Woo`03003ooooo057oo`03003o
oooo0=koo`04003ooooo0006ool005[oo`80057oo`03003ooooo0=ooo`03003oo`0000Koo`00G?oo
00<00?ooool0C_oo00<00?ooool0h?oo00<00?oo00001Ooo001Mool00`00ool0001=ool00`00oooo
o`3Pool00`00ool00005ool005koo`8004goo`03003ooooo0>7oo`8000Goo`00H?oo00<00?ooool0
B_oo00<00?ooool0h?oo0`001Ooo001Qool2001:ool00`00ooooo`3Lool40008ool006?oo`05003o
ooooool00015ool00`00ooooo`3Hool4000<ool006Coo`800003ool00?oo04Coo`03003ooooo0=?o
o`D0013oo`00I_oo00<00?ooool0A?oo00<00?ooool0cooo10005Ooo001Vool20015ool00`00oooo
o`3;ool4000Iool006Soo`8004?oo`03003ooooo0<Koo`D001goo`00J_oo00<00?ooool0@?oo00<0
0?ooool0`_oo10008_oo001[ool200000ooo003oo`0mool00`00ooooo`2mool5000Vool006goo`80
03koo`03003ooooo0;Woo`@002_oo`00K_oo00<00?ooool0??oo00<00?ooool0]Ooo1000;ooo001_
ool2000lool00`00ooooo`2`ool5000cool0077oo`03003ooooo03Soo`03003ooooo0:goo`@003So
o`00IOoo0P002ooo0P0000?oo`00ool0=Ooo00<00?ooool0ZOoo1000??oo001Tool01000ooooo`00
3?oo0P00=_oo00<00?ooool0Y?oo1@00@?oo001Tool01000ooooo`003Ooo0P00=Ooo00<00?ooool0
X?oo1000AOoo001Tool01000ooooo`003ooo00<00?ooool0<_oo00<00?ooool0W?oo1000BOoo001T
ool01000ooooo`004?oo00<00?ooool0<Ooo00<00?ooool0Uooo1@00COoo001Tool01000ooooo`00
4Ooo0P0000?oo`00ool0;_oo00<00?ooool0Tooo1000D_oo001Uool2000Dool2000_ool00`00oooo
o`2?ool4001Fool007coo`8002koo`03003ooooo08[oo`D005[oo`00O_oo00<00?ooool0:ooo00<0
0?ooool0Q_oo1000Gooo001oool01@00oooooooo0000:?oo00<00?ooool0POoo1@00Hooo0020ool2
00000ooo003oo`0Wool00`00ooooo`1mool4001Xool008;oo`03003ooooo02Ooo`03003ooooo07Wo
o`@006coo`00Pooo0P009ooo00<00?ooool0M?oo1@00L?oo0025ool01@00oooooooo00008_oo00<0
0?ooool0L?oo1000MOoo0026ool01000ooooo`008_oo00<00?ooool0K?oo1000NOoo0027ool3000R
ool00`00ooooo`1Wool5001mool008Woo`03003ooooo023oo`03003ooooo06?oo`@008;oo`00R_oo
0P008?oo00<00?ooool0Gooo1000Q_oo002<ool00`00ooooo`0Mool00`00ooooo`1Jool5002:ool0
08goo`800003ool00?oo01[oo`03003ooooo05Koo`@008ooo`00Sooo0P006ooo00<00?ooool0DOoo
1@00Tooo002@ool00`00ooooo`0Iool00`00ooooo`1=ool4002Hool0097oo`8001Woo`03003ooooo
04Woo`@009coo`00Tooo00@00?ooool001Goo`03003ooooo04Coo`D00:3oo`00POoo0P001?oo00<0
0?ooool00_oo0`001Ooo0`005Ooo00<00?ooool0@?oo1000YOoo0020ool01000ooooo`002ooo00<0
0?ooool01?oo00<00?ooool04ooo00<00?ooool0??oo1000ZOoo0020ool01000ooooo`002ooo00<0
0?ooool01Ooo00<00?ooool04_oo00<00?ooool0=ooo1@00[Ooo0020ool01000ooooo`002?oo0`00
2Ooo0P004Ooo00<00?ooool0=?oo1000/_oo0020ool01000ooooo`002?oo00<00?ooool02ooo00<0
0?oo00003_oo00<00?ooool0<?oo1000]_oo0020ool01000ooooo`002?oo00<00?ooool03?oo0P00
3_oo00<00?ooool0:ooo1@00^_oo0021ool20009ool4000=ool00`00ooooo`0;ool00`00ooooo`0W
ool4002oool009koo`03003ooooo00[oo`03003ooooo02?oo`@00<?oo`00Wooo0P0000?oo`00ool0
1ooo00<00?ooool07_oo1@00aooo002Qool20008ool00`00ooooo`0Jool4003<ool00:;oo`8000Oo
o`03003ooooo01Goo`D00=3oo`00Y?oo00D00?ooooooo`0000;oo`03003ooooo017oo`@00=Goo`00
YOoo0P0000Goo`00ooooo`0000ooo`@00=Woo`00Yooo0P000_oo00<00?ooool02?oo1@00gOoo002X
ool01000ooooo`001_oo1000h_oo002Yool30002ool4003Vool00:_oo`<00>[oo`00ooooVOoo003o
oonIool00?oooiWoo`00ooooVOoo003ooonIool00:Koo`@00>koo`00Z?oo00<00?ooool0kOoo002X
ool00`00ooooo`3]ool00:Soo`03003ooooo0>goo`00Z?oo00<00?ooool0kOoo002Vool3003_ool0
0:Soo`03003ooooo0>goo`00\
\>"],
  ImageRangeCache->{{{130.75, 456.375}, {545.125, 191.625}} -> {-0.354236, \
0.508284, 0.00222659, 0.00222659}}]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
WindowSize->{1012, 740},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"PaperSize"->{597.562, 842.375},
"PaperOrientation"->"Portrait",
"PostScriptOutputFile":>FrontEnd`FileName[{$RootDirectory, "home", "felix", \
"tmp"}, "qqq.ps", CharacterEncoding -> "ISO8859-1"],
"Magnification"->1}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 67, 1, 27, "Input"],
Cell[1787, 52, 509, 14, 43, "Input"],
Cell[2299, 68, 738, 18, 27, "Input"],
Cell[3040, 88, 184, 5, 27, "Input"],

Cell[CellGroupData[{
Cell[3249, 97, 260, 7, 27, "Input"],
Cell[3512, 106, 178196, 6466, 452, 100877, 5507, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

