(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   1258883,      24715]*)
(*NotebookOutlinePosition[   1259872,      24749]*)
(*  CellTagsIndexPosition[   1259734,      24742]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
    RowBox[{"Solve", "[", 
      RowBox[{
        RowBox[{
          RowBox[{
            SuperscriptBox["z", "2"], "+", 
            RowBox[{
              FractionBox[
                RowBox[{"y", "-", "1"}], 
                RowBox[{"2", 
                  RowBox[{"(", 
                    RowBox[{"1", "-", "x"}], ")"}]}]], "z"}]}], "\[Equal]", 
          FractionBox[
            RowBox[{"y", "-", 
              RowBox[{"2", "x"}], "+", "1"}], 
            RowBox[{"2", 
              RowBox[{"(", 
                RowBox[{"1", "-", "x"}], ")"}]}]]}], ",", "z"}], 
      "]"}]], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"{", 
          RowBox[{"z", "\[Rule]", "1"}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{"z", "\[Rule]", 
            FractionBox[
              RowBox[{"1", "-", 
                RowBox[{"2", " ", "x"}], "+", "y"}], 
              RowBox[{"2", " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "1"}], "+", "x"}], ")"}]}]]}], "}"}]}], 
      "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      FractionBox[
        RowBox[{"1", "-", 
          RowBox[{"2", "x"}], "+", "y"}], 
        RowBox[{"2", 
          RowBox[{"(", 
            RowBox[{"x", "-", "1"}], ")"}]}]], "/.", 
      RowBox[{"{", 
        RowBox[{
          RowBox[{"x", "\[Rule]", "0.9"}], ",", 
          RowBox[{"y", "\[Rule]", "0.1"}]}], "}"}]}], "\[IndentingNewLine]", 
    RowBox[{"ArcCos", "[", "%", "]"}]}], "Input"],

Cell[BoxData["3.500000000000001`"], "Output"],

Cell[BoxData[
    RowBox[{
      RowBox[{"0.`", "\[InvisibleSpace]"}], "+", 
      RowBox[{"1.924847300238414`", " ", "\[ImaginaryI]"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      FractionBox[
        RowBox[{"1", "-", 
          RowBox[{"2", "x"}], "+", "y"}], 
        RowBox[{"2", 
          RowBox[{"(", 
            RowBox[{"x", "-", "1"}], ")"}]}]], "/.", 
      RowBox[{"{", 
        RowBox[{
          RowBox[{"x", "\[Rule]", "0.1"}], ",", 
          RowBox[{"y", "\[Rule]", "0.9"}]}], "}"}]}], "\[IndentingNewLine]", 
    RowBox[{"ArcCos", "[", "%", "]"}]}], "Input"],

Cell[BoxData[
    RowBox[{"-", "0.9444444444444445`"}]], "Output"],

Cell[BoxData["2.806696495150415`"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"\[CapitalDelta]t", "=", "1"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"{", 
        RowBox[{
          RowBox[{
            RowBox[{"1", "-", "\[Beta]", "+", 
              RowBox[{"\[Beta]", " ", "z"}]}], "\[Equal]", "x"}], ",", 
          RowBox[{
            RowBox[{"1", "-", "\[Beta]", "+", 
              RowBox[{"\[Beta]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"2", 
                      SuperscriptBox["z", "2"]}], "-", "1"}], ")"}]}]}], 
            "\[Equal]", "y"}]}], "}"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{"%", "/.", 
      RowBox[{"{", 
        RowBox[{
          RowBox[{"x", "\[Rule]", "1"}], ",", 
          RowBox[{"y", "\[Rule]", "1"}]}], "}"}]}], "\[IndentingNewLine]", 
    RowBox[{"Reduce", "[", 
      RowBox[{"%", ",", 
        RowBox[{"{", 
          RowBox[{"\[Beta]", ",", "z"}], "}"}]}], "]"}]}], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{
          RowBox[{"1", "-", "\[Beta]", "+", 
            RowBox[{"z", " ", "\[Beta]"}]}], "\[Equal]", "1"}], ",", 
        RowBox[{
          RowBox[{"1", "-", "\[Beta]", "+", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", "\[Beta]"}]}], 
          "\[Equal]", "1"}]}], "}"}]], "Output"],

Cell[BoxData[
    RowBox[{
      RowBox[{"z", "\[Equal]", "1"}], "||", 
      RowBox[{"\[Beta]", "\[Equal]", "0"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{
          RowBox[{
            SuperscriptBox["z", "2"], "+", 
            RowBox[{
              FractionBox[
                RowBox[{"y", "-", "1"}], 
                RowBox[{"2", 
                  RowBox[{"(", 
                    RowBox[{"1", "-", "x"}], ")"}]}]], "z"}]}], "\[Equal]", 
          FractionBox[
            RowBox[{"y", "-", 
              RowBox[{"2", "x"}], "+", "1"}], 
            RowBox[{"2", 
              RowBox[{"(", 
                RowBox[{"1", "-", "x"}], ")"}]}]]}], "/.", 
        RowBox[{"z", "\[Rule]", "1"}]}], "//", 
      "Simplify"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"Solve", "[", 
          RowBox[{
            RowBox[{
              RowBox[{
                SuperscriptBox["z", "2"], "+", 
                RowBox[{
                  FractionBox[
                    RowBox[{"y", "-", "1"}], 
                    RowBox[{"2", 
                      RowBox[{"(", 
                        RowBox[{"1", "-", "x"}], ")"}]}]], "z"}]}], 
              "\[Equal]", 
              FractionBox[
                RowBox[{"y", "-", 
                  RowBox[{"2", "x"}], "+", "1"}], 
                RowBox[{"2", 
                  RowBox[{"(", 
                    RowBox[{"1", "-", "x"}], ")"}]}]]}], ",", "x"}], "]"}], "/.",
         
        RowBox[{"z", "\[Rule]", "1"}]}], "//", "FullSimplify"}]}], "Input"],

Cell[BoxData["True"], "Output"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"{", 
        RowBox[{"x", "\[Rule]", 
          FractionBox[
            RowBox[{"3", "+", "y"}], "4"]}], "}"}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Reduce", "[", 
      RowBox[{
        RowBox[{
          RowBox[{
            SuperscriptBox["z", "2"], "+", 
            RowBox[{
              FractionBox[
                RowBox[{"y", "-", "1"}], 
                RowBox[{"2", 
                  RowBox[{"(", 
                    RowBox[{"1", "-", "x"}], ")"}]}]], "z"}]}], "\[Equal]", 
          FractionBox[
            RowBox[{"y", "-", 
              RowBox[{"2", "x"}], "+", "1"}], 
            RowBox[{"2", 
              RowBox[{"(", 
                RowBox[{"1", "-", "x"}], ")"}]}]]}], ",", "z"}], 
      "]"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{
          RowBox[{
            RowBox[{"-", "1"}], "+", "x"}], "\[NotEqual]", "0"}], "&&", 
        RowBox[{"z", "\[Equal]", "1"}]}], "||", 
      RowBox[{
        RowBox[{
          RowBox[{
            RowBox[{"-", "1"}], "+", "x"}], "\[NotEqual]", "0"}], "&&", 
        RowBox[{"z", "\[Equal]", 
          FractionBox[
            RowBox[{"1", "-", 
              RowBox[{"2", " ", "x"}], "+", "y"}], 
            RowBox[{"2", " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"-", "1"}], "+", "x"}], ")"}]}]]}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"\[CapitalDelta]t", "=", "1"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"{", 
        RowBox[{
          RowBox[{
            RowBox[{"1", "-", "\[Beta]", "+", 
              RowBox[{"\[Beta]", " ", "z"}]}], "\[Equal]", "x"}], ",", 
          RowBox[{
            RowBox[{"1", "-", "\[Beta]", "+", 
              RowBox[{"\[Beta]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"2", 
                      SuperscriptBox["z", "2"]}], "-", "1"}], ")"}]}]}], 
            "\[Equal]", "y"}]}], "}"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{"%", "/.", 
      RowBox[{"{", 
        RowBox[{
          RowBox[{"x", "\[Rule]", "0.9"}], ",", 
          RowBox[{"y", "\[Rule]", "0.1"}]}], "}"}]}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"Reduce", "[", 
        RowBox[{"%", ",", 
          RowBox[{"{", 
            RowBox[{"\[Beta]", ",", "z"}], "}"}]}], "]"}], 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
        RowBox[{
          RowBox[{"sol\[Omega]", "=", 
            RowBox[{
              RowBox[{
                RowBox[{
                  RowBox[{"ArcCos", "[", "z", "]"}], "*", 
                  RowBox[{"2", "/", "\[CapitalDelta]t"}]}], "/.", 
                RowBox[{
                  RowBox[{"First", "[", "%", "]"}], "\[IndentingNewLine]", 
                  "sol\[Beta]"}]}], "=", 
              RowBox[{"\[Beta]", "/.", 
                RowBox[{
                  RowBox[{"First", "[", "%%", "]"}], "\[IndentingNewLine]", 
                  RowBox[{"Plot", "[", 
                    RowBox[{
                      RowBox[{"1", "-", "sol\[Beta]", "+", 
                        RowBox[{"sol\[Beta]", " ", 
                          RowBox[{"Cos", "[", 
                            RowBox[{"sol\[Omega]", " ", "t"}], "]"}]}]}], ",",
                       
                      RowBox[{"{", 
                        RowBox[{"t", ",", "0", ",", "2"}], "}"}]}], 
                    "]"}]}]}]}]}], ";"}], "*)"}]}]}], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{
          RowBox[{"1", "-", "\[Beta]", "+", 
            RowBox[{"z", " ", "\[Beta]"}]}], "\[Equal]", "0.9`"}], ",", 
        RowBox[{
          RowBox[{"1", "-", "\[Beta]", "+", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"2", " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", "\[Beta]"}]}], 
          "\[Equal]", "0.1`"}]}], "}"}]], "Output"],

Cell[BoxData[
    RowBox[{
      RowBox[{"\[Beta]", "\[Equal]", 
        RowBox[{"-", "0.03999999999999998`"}]}], "&&", 
      RowBox[{"z", "\[Equal]", "3.500000000000001`"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        FractionBox[
          RowBox[{"1", "-", 
            RowBox[{"2", "x"}], "+", "y"}], 
          RowBox[{"2", 
            RowBox[{"(", 
              RowBox[{"x", "-", "1"}], ")"}]}]], "/.", 
        RowBox[{"y", "\[Rule]", "x"}]}], "//", "FullSimplify"}]], "Input"],

Cell[BoxData[
    RowBox[{"-", 
      FractionBox["1", "2"]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Options", "[", "Plot3D", "]"}]], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"AmbientLight", "\[Rule]", 
          RowBox[{"GrayLevel", "[", "0", "]"}]}], ",", 
        RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"Axes", "\[Rule]", "True"}], ",", 
        RowBox[{"AxesEdge", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"AxesLabel", "\[Rule]", "None"}], ",", 
        RowBox[{"AxesStyle", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"Background", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"Boxed", "\[Rule]", "True"}], ",", 
        RowBox[{"BoxRatios", "\[Rule]", 
          RowBox[{"{", 
            RowBox[{"1", ",", "1", ",", "0.4`"}], "}"}]}], ",", 
        RowBox[{"BoxStyle", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"ClipFill", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"ColorFunction", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}], ",", 
        RowBox[{"ColorOutput", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"Compiled", "\[Rule]", "True"}], ",", 
        RowBox[{"DefaultColor", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"DefaultFont", "\[RuleDelayed]", "$DefaultFont"}], ",", 
        RowBox[{"DisplayFunction", "\[RuleDelayed]", "$DisplayFunction"}], 
        ",", 
        RowBox[{"Epilog", "\[Rule]", 
          RowBox[{"{", "}"}]}], ",", 
        RowBox[{"FaceGrids", "\[Rule]", "None"}], ",", 
        RowBox[{"FormatType", "\[RuleDelayed]", "$FormatType"}], ",", 
        RowBox[{"HiddenSurface", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"Lighting", "\[Rule]", "True"}], ",", 
        RowBox[{"LightSources", "\[Rule]", 
          RowBox[{"{", 
            RowBox[{
              RowBox[{"{", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1.`", ",", "0.`", ",", "1.`"}], "}"}], ",", 
                  RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1.`", ",", "1.`", ",", "1.`"}], "}"}], ",", 
                  RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "1", ",", "0"}], "]"}]}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"0.`", ",", "1.`", ",", "1.`"}], "}"}], ",", 
                  RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "1"}], "]"}]}], "}"}]}], 
            "}"}]}], ",", 
        RowBox[{"Mesh", "\[Rule]", "True"}], ",", 
        RowBox[{"MeshStyle", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"Plot3Matrix", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"PlotLabel", "\[Rule]", "None"}], ",", 
        RowBox[{"PlotPoints", "\[Rule]", "25"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"PlotRegion", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"Prolog", "\[Rule]", 
          RowBox[{"{", "}"}]}], ",", 
        RowBox[{"Shading", "\[Rule]", "True"}], ",", 
        RowBox[{"SphericalRegion", "\[Rule]", "False"}], ",", 
        RowBox[{"TextStyle", "\[RuleDelayed]", "$TextStyle"}], ",", 
        RowBox[{"Ticks", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"ViewCenter", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"ViewPoint", "\[Rule]", 
          RowBox[{"{", 
            RowBox[{"1.3`", ",", 
              RowBox[{"-", "2.4`"}], ",", "2.`"}], "}"}]}], ",", 
        RowBox[{"ViewVertical", "\[Rule]", 
          RowBox[{"{", 
            RowBox[{"0.`", ",", "0.`", ",", "1.`"}], "}"}]}]}], 
      "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"?", "Plot3D"}]], "Input"],

Cell[BoxData[
    RowBox[{"\<\"Plot3D[f, {x, xmin, xmax}, {y, ymin, ymax}] generates a \
three-dimensional plot of f as a function of x and y. Plot3D[{f, s}, {x, \
xmin, xmax}, {y, ymin, ymax}] generates a three-dimensional plot in which the \
height of the surface is specified by f, and the shading is specified by s.\"\
\>", " ", 
      ButtonBox[
        StyleBox["More\[Ellipsis]",
          "SR"],
        ButtonData:>"Plot3D",
        Active->True,
        ButtonStyle->"RefGuideLink"]}]], "Print",
  CellTags->"Info3278676956-4344008"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Plot3D", "[", 
      RowBox[{
        FractionBox[
          RowBox[{"1", "-", 
            RowBox[{"2", "x"}], "+", "y"}], 
          RowBox[{"2", 
            RowBox[{"(", 
              RowBox[{"x", "-", "1"}], ")"}]}]], ",", 
        RowBox[{"{", 
          RowBox[{"x", ",", "0", ",", "0.99"}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{"y", ",", "0", ",", "0.99"}], "}"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
          RowBox[{"{", 
            RowBox[{"0", ",", 
              RowBox[{"8", "\[Pi]"}]}], "}"}]}], ",", 
        RowBox[{"ViewPoint", "->", 
          RowBox[{"{", 
            RowBox[{
              RowBox[{"-", "1.184"}], ",", " ", 
              RowBox[{"-", "2.368"}], ",", " ", "2.108"}], "}"}]}], ",", 
        RowBox[{"PlotPoints", "\[Rule]", "40"}], ",", 
        RowBox[{"AxesLabel", "\[Rule]", 
          RowBox[{"{", 
            RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<\>\""}], "}"}]}],
         ",", 
        RowBox[{"Ticks", "\[Rule]", 
          RowBox[{"{", 
            RowBox[{"Automatic", ",", "Automatic", ",", 
              RowBox[{"{", 
                RowBox[{"0", ",", "\[Pi]", ",", 
                  RowBox[{"2", "\[Pi]"}]}], "}"}]}], "}"}]}]}], 
      "]"}]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .8339 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% SurfaceGraphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0536653 1.05367 -0.0605739 1.05367 [
[.29816 -0.01144 -1.28803 -9 ]
[.29816 -0.01144 4.71197 0 ]
[.44629 .04436 -3.17507 -9 ]
[.44629 .04436 14.8249 0 ]
[.58769 .09766 -2.48604 -9 ]
[.58769 .09766 15.514 0 ]
[.7228 .14862 -1.79702 -9 ]
[.7228 .14862 16.203 0 ]
[.85203 .19739 -1.10799 -9 ]
[.85203 .19739 16.892 0 ]
[.69247 .06972 -1.19931 -9.8125 ]
[.69247 .06972 8.80069 0 ]
[.2793 -0.00463 -6 -6.19072 ]
[.2793 -0.00463 0 2.80928 ]
[.2174 .10392 -18 -6.09875 ]
[.2174 .10392 0 2.90125 ]
[.16086 .20308 -18 -6.01626 ]
[.16086 .20308 0 2.98374 ]
[.10901 .29402 -18 -5.94187 ]
[.10901 .29402 0 3.05813 ]
[.0613 .37771 -18 -5.87444 ]
[.0613 .37771 0 3.12556 ]
[.07313 .22666 -10.0625 -6.51985 ]
[.07313 .22666 0 3.29265 ]
[.97296 .25598 0 -2.80928 ]
[.97296 .25598 6 6.19072 ]
[.97757 .2826 0 -3.08436 ]
[.97757 .2826 10 6.72814 ]
[.98227 .30973 0 -3.10626 ]
[.98227 .30973 18.625 6.70624 ]
[ 0 0 0 0 ]
[ 1 .8339 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.29163 0 m
.96063 .25135 L
s
.29163 0 m
.28837 .00572 L
s
[(0)] .29816 -0.01144 -0.57066 1 Mshowa
.43913 .05542 m
.43555 .06095 L
s
[(0.2)] .44629 .04436 -0.64721 1 Mshowa
.57996 .10833 m
.5761 .11367 L
s
[(0.4)] .58769 .09766 -0.72377 1 Mshowa
.71457 .1589 m
.71045 .16405 L
s
[(0.6)] .7228 .14862 -0.80033 1 Mshowa
.84335 .20729 m
.839 .21224 L
s
[(0.8)] .85203 .19739 -0.87689 1 Mshowa
.125 Mabswid
.32916 .0141 m
.32715 .0175 L
s
.36624 .02803 m
.36419 .03141 L
s
.4029 .04181 m
.4008 .04515 L
s
.47495 .06888 m
.47276 .07216 L
s
.51035 .08218 m
.50812 .08544 L
s
.54536 .09533 m
.54308 .09856 L
s
.61418 .12119 m
.61183 .12436 L
s
.64802 .1339 m
.64562 .13704 L
s
.68148 .14647 m
.67905 .14959 L
s
.74729 .1712 m
.74479 .17426 L
s
.77966 .18336 m
.77712 .18639 L
s
.81168 .19539 m
.8091 .19839 L
s
.87467 .21906 m
.87204 .222 L
s
.90567 .2307 m
.903 .23362 L
s
.93633 .24222 m
.93363 .24511 L
s
gsave
.69247 .06972 -62.1993 -13.8125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 17.8125 translate 1 -1 scale
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
69.000 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.29163 0 m
.032 .45496 L
s
.29163 0 m
.29779 .00232 L
s
[(0)] .2793 -0.00463 1 .37572 Mshowa
.22981 .10833 m
.23602 .11054 L
s
[(0.2)] .2174 .10392 1 .35528 Mshowa
.17334 .20729 m
.17958 .20939 L
s
[(0.4)] .16086 .20308 1 .33695 Mshowa
.12155 .29804 m
.12783 .30004 L
s
[(0.6)] .10901 .29402 1 .32042 Mshowa
.07389 .38155 m
.08019 .38348 L
s
[(0.8)] .0613 .37771 1 .30543 Mshowa
.125 Mabswid
.27563 .02803 m
.27934 .02941 L
s
.26 .05542 m
.26372 .05677 L
s
.24473 .08218 m
.24845 .08352 L
s
.21522 .1339 m
.21895 .13521 L
s
.20095 .1589 m
.20468 .1602 L
s
.18699 .18336 m
.19073 .18464 L
s
.15998 .2307 m
.16373 .23195 L
s
.1469 .25362 m
.15065 .25486 L
s
.13409 .27606 m
.13785 .27728 L
s
.10927 .31956 m
.11304 .32075 L
s
.09724 .34064 m
.10101 .34182 L
s
.08545 .3613 m
.08922 .36247 L
s
.06257 .40141 m
.06635 .40255 L
s
.05146 .42087 m
.05524 .422 L
s
.04057 .43996 m
.04436 .44107 L
s
gsave
.07313 .22666 -71.0625 -10.5198 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 17.8125 translate 1 -1 scale
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.062 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(y) show
69.062 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.96063 .25135 m
1 .47975 L
s
.96063 .25135 m
.95446 .24904 L
s
[(0)] .97296 .25598 -1 -0.37572 Mshowa
.96522 .27802 m
.95905 .27573 L
s
gsave
.97757 .2826 -61 -7.08436 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 17.8125 translate 1 -1 scale
63.000 11.250 moveto
%%IncludeResource: font Math1Mono
%%IncludeFont: Math1Mono
/Math1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(p) show
1.000 setlinewidth
grestore
.96991 .30519 m
.96373 .30292 L
s
gsave
.98227 .30973 -61 -7.10626 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 17.8125 translate 1 -1 scale
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
71.625 11.250 moveto
%%IncludeResource: font Math1Mono
%%IncludeFont: Math1Mono
/Math1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(p) show
1.000 setlinewidth
grestore
.29163 0 m
.27509 .23472 L
s
.27509 .23472 m
0 .67486 L
s
0 .67486 m
.032 .45496 L
s
.032 .45496 m
.29163 0 L
s
.96063 .25135 m
.60747 .62325 L
s
.60747 .62325 m
.61631 .8339 L
s
.61631 .8339 m
1 .47975 L
s
1 .47975 m
.96063 .25135 L
s
.29163 0 m
.27509 .23472 L
s
.27509 .23472 m
1 .47975 L
s
1 .47975 m
.96063 .25135 L
s
.96063 .25135 m
.29163 0 L
s
.032 .45496 m
.60747 .62325 L
s
.60747 .62325 m
.61631 .8339 L
s
.61631 .8339 m
0 .67486 L
s
0 .67486 m
.032 .45496 L
s
0 0 m
1 0 L
1 .8339 L
0 .8339 L
closepath
clip
newpath
.5 Mabswid
.591 .6 .83 r
.60144 .61135 .59396 .6193 .60747 .62325 .61525 .6214 Metetra
.67 .732 .897 r
.58783 .60734 .5804 .61533 .59396 .6193 .60144 .61135 Metetra
.67 .732 .897 r
.57415 .60332 .56677 .61135 .5804 .61533 .58783 .60734 Metetra
.67 .732 .897 r
.56042 .59928 .55308 .60734 .56677 .61135 .57415 .60332 Metetra
.67 .732 .897 r
.54663 .59523 .53933 .60332 .55308 .60734 .56042 .59928 Metetra
.67 .732 .897 r
.53277 .59115 .52552 .59928 .53933 .60332 .54663 .59523 Metetra
.67 .732 .897 r
.51885 .58706 .51165 .59523 .52552 .59928 .53277 .59115 Metetra
.67 .732 .897 r
.50486 .58294 .49771 .59115 .51165 .59523 .51885 .58706 Metetra
.67 .732 .897 r
.49082 .57881 .48371 .58706 .49771 .59115 .50486 .58294 Metetra
.67 .732 .897 r
.47671 .57466 .46965 .58294 .48371 .58706 .49082 .57881 Metetra
.67 .732 .897 r
.46253 .57049 .45552 .57881 .46965 .58294 .47671 .57466 Metetra
.67 .732 .897 r
.44829 .5663 .44133 .57466 .45552 .57881 .46253 .57049 Metetra
.67 .732 .897 r
.43398 .5621 .42707 .57049 .44133 .57466 .44829 .5663 Metetra
.67 .732 .897 r
.41961 .55787 .41275 .5663 .42707 .57049 .43398 .5621 Metetra
.67 .732 .897 r
.40517 .55362 .39836 .5621 .41275 .5663 .41961 .55787 Metetra
.67 .732 .897 r
.39066 .54936 .3839 .55787 .39836 .5621 .40517 .55362 Metetra
.67 .732 .897 r
.37609 .54507 .36938 .55362 .3839 .55787 .39066 .54936 Metetra
.67 .732 .897 r
.36145 .54076 .35479 .54936 .36938 .55362 .37609 .54507 Metetra
.67 .732 .897 r
.34674 .53644 .34013 .54507 .35479 .54936 .36145 .54076 Metetra
.67 .732 .897 r
.33196 .53209 .32541 .54076 .34013 .54507 .34674 .53644 Metetra
.67 .732 .897 r
.31711 .52772 .31061 .53644 .32541 .54076 .33196 .53209 Metetra
.67 .732 .897 r
.30219 .52334 .29575 .53209 .31061 .53644 .31711 .52772 Metetra
.67 .732 .897 r
.28721 .51893 .28082 .52772 .29575 .53209 .30219 .52334 Metetra
.67 .732 .897 r
.27215 .5145 .26582 .52334 .28082 .52772 .28721 .51893 Metetra
.67 .732 .897 r
.25702 .51005 .25074 .51893 .26582 .52334 .27215 .5145 Metetra
.67 .732 .897 r
.24182 .50558 .2356 .5145 .25074 .51893 .25702 .51005 Metetra
.67 .732 .897 r
.22654 .50109 .22038 .51005 .2356 .5145 .24182 .50558 Metetra
.67 .732 .897 r
.21119 .49657 .20509 .50558 .22038 .51005 .22654 .50109 Metetra
.67 .732 .897 r
.19577 .49204 .18973 .50109 .20509 .50558 .21119 .49657 Metetra
.67 .732 .897 r
.18028 .48748 .1743 .49657 .18973 .50109 .19577 .49204 Metetra
.67 .732 .897 r
.16471 .4829 .15879 .49204 .1743 .49657 .18028 .48748 Metetra
.67 .732 .897 r
.14907 .4783 .14321 .48748 .15879 .49204 .16471 .4829 Metetra
.67 .732 .897 r
.13335 .47368 .12755 .4829 .14321 .48748 .14907 .4783 Metetra
.67 .732 .897 r
.11756 .46903 .11182 .4783 .12755 .4829 .13335 .47368 Metetra
.67 .732 .897 r
.10168 .46436 .09601 .47368 .11182 .4783 .11756 .46903 Metetra
.67 .732 .897 r
.08574 .45967 .08012 .46903 .09601 .47368 .10168 .46436 Metetra
.67 .732 .897 r
.06971 .45496 .06416 .46436 .08012 .46903 .08574 .45967 Metetra
.67 .732 .897 r
.05361 .45022 .04812 .45967 .06416 .46436 .06971 .45496 Metetra
.67 .732 .897 r
.03742 .44546 .032 .45496 .04812 .45967 .05361 .45022 Metetra
.507 .468 .748 r
.60898 .60332 .60144 .61135 .61525 .6214 .62333 .62352 Metetra
.67 .732 .897 r
.59532 .59928 .58783 .60734 .60144 .61135 .60898 .60332 Metetra
.67 .732 .897 r
.58161 .59523 .57415 .60332 .58783 .60734 .59532 .59928 Metetra
.67 .732 .897 r
.56783 .59115 .56042 .59928 .57415 .60332 .58161 .59523 Metetra
.67 .732 .897 r
.55399 .58706 .54663 .59523 .56042 .59928 .56783 .59115 Metetra
.67 .732 .897 r
.54008 .58294 .53277 .59115 .54663 .59523 .55399 .58706 Metetra
.67 .732 .897 r
.52612 .57881 .51885 .58706 .53277 .59115 .54008 .58294 Metetra
.67 .732 .897 r
.51209 .57466 .50486 .58294 .51885 .58706 .52612 .57881 Metetra
.67 .732 .897 r
.49799 .57049 .49082 .57881 .50486 .58294 .51209 .57466 Metetra
.67 .732 .897 r
.48383 .5663 .47671 .57466 .49082 .57881 .49799 .57049 Metetra
.67 .732 .897 r
.4696 .5621 .46253 .57049 .47671 .57466 .48383 .5663 Metetra
.67 .732 .897 r
.45531 .55787 .44829 .5663 .46253 .57049 .4696 .5621 Metetra
.67 .732 .897 r
.44096 .55362 .43398 .5621 .44829 .5663 .45531 .55787 Metetra
.67 .732 .897 r
.42653 .54936 .41961 .55787 .43398 .5621 .44096 .55362 Metetra
.67 .732 .897 r
.41204 .54507 .40517 .55362 .41961 .55787 .42653 .54936 Metetra
.67 .732 .897 r
.39749 .54076 .39066 .54936 .40517 .55362 .41204 .54507 Metetra
.67 .732 .897 r
.38286 .53644 .37609 .54507 .39066 .54936 .39749 .54076 Metetra
.67 .732 .897 r
.36817 .53209 .36145 .54076 .37609 .54507 .38286 .53644 Metetra
.67 .732 .897 r
.3534 .52772 .34674 .53644 .36145 .54076 .36817 .53209 Metetra
.67 .732 .897 r
.33857 .52334 .33196 .53209 .34674 .53644 .3534 .52772 Metetra
.67 .732 .897 r
.32367 .51893 .31711 .52772 .33196 .53209 .33857 .52334 Metetra
.67 .732 .897 r
.3087 .5145 .30219 .52334 .31711 .52772 .32367 .51893 Metetra
.67 .732 .897 r
.29365 .51005 .28721 .51893 .30219 .52334 .3087 .5145 Metetra
.67 .732 .897 r
.27854 .50558 .27215 .5145 .28721 .51893 .29365 .51005 Metetra
.67 .732 .897 r
.26335 .50109 .25702 .51005 .27215 .5145 .27854 .50558 Metetra
.67 .732 .897 r
.24809 .49657 .24182 .50558 .25702 .51005 .26335 .50109 Metetra
.67 .732 .897 r
.23276 .49204 .22654 .50109 .24182 .50558 .24809 .49657 Metetra
.67 .732 .897 r
.21735 .48748 .21119 .49657 .22654 .50109 .23276 .49204 Metetra
.67 .732 .897 r
.20188 .4829 .19577 .49204 .21119 .49657 .21735 .48748 Metetra
.67 .732 .897 r
.18632 .4783 .18028 .48748 .19577 .49204 .20188 .4829 Metetra
.67 .732 .897 r
.17069 .47368 .16471 .4829 .18028 .48748 .18632 .4783 Metetra
.67 .732 .897 r
.15499 .46903 .14907 .4783 .16471 .4829 .17069 .47368 Metetra
.67 .732 .897 r
.13921 .46436 .13335 .47368 .14907 .4783 .15499 .46903 Metetra
.67 .732 .897 r
.12335 .45967 .11756 .46903 .13335 .47368 .13921 .46436 Metetra
.67 .732 .897 r
.10742 .45496 .10168 .46436 .11756 .46903 .12335 .45967 Metetra
.67 .732 .897 r
.0914 .45022 .08574 .45967 .10168 .46436 .10742 .45496 Metetra
.67 .732 .897 r
.07531 .44546 .06971 .45496 .08574 .45967 .0914 .45022 Metetra
.67 .732 .897 r
.05914 .44068 .05361 .45022 .06971 .45496 .07531 .44546 Metetra
.67 .732 .897 r
.04289 .43588 .03742 .44546 .05361 .45022 .05914 .44068 Metetra
.435 .39 .709 r
.61666 .59695 .60898 .60332 .62333 .62352 .63153 .62567 Metetra
.645 .69 .877 r
.60289 .59115 .59532 .59928 .60898 .60332 .61666 .59695 Metetra
.67 .732 .897 r
.58913 .58706 .58161 .59523 .59532 .59928 .60289 .59115 Metetra
.67 .732 .897 r
.5753 .58294 .56783 .59115 .58161 .59523 .58913 .58706 Metetra
.67 .732 .897 r
.56142 .57881 .55399 .58706 .56783 .59115 .5753 .58294 Metetra
.67 .732 .897 r
.54747 .57466 .54008 .58294 .55399 .58706 .56142 .57881 Metetra
.67 .732 .897 r
.53345 .57049 .52612 .57881 .54008 .58294 .54747 .57466 Metetra
.67 .732 .897 r
.51937 .5663 .51209 .57466 .52612 .57881 .53345 .57049 Metetra
.67 .732 .897 r
.50523 .5621 .49799 .57049 .51209 .57466 .51937 .5663 Metetra
.67 .732 .897 r
.49102 .55787 .48383 .5663 .49799 .57049 .50523 .5621 Metetra
.67 .732 .897 r
.47675 .55362 .4696 .5621 .48383 .5663 .49102 .55787 Metetra
.67 .732 .897 r
.46241 .54936 .45531 .55787 .4696 .5621 .47675 .55362 Metetra
.67 .732 .897 r
.448 .54507 .44096 .55362 .45531 .55787 .46241 .54936 Metetra
.67 .732 .897 r
.43352 .54076 .42653 .54936 .44096 .55362 .448 .54507 Metetra
.67 .732 .897 r
.41898 .53644 .41204 .54507 .42653 .54936 .43352 .54076 Metetra
.67 .732 .897 r
.40437 .53209 .39749 .54076 .41204 .54507 .41898 .53644 Metetra
.67 .732 .897 r
.3897 .52772 .38286 .53644 .39749 .54076 .40437 .53209 Metetra
.67 .732 .897 r
.37495 .52334 .36817 .53209 .38286 .53644 .3897 .52772 Metetra
.67 .732 .897 r
.36013 .51893 .3534 .52772 .36817 .53209 .37495 .52334 Metetra
.67 .732 .897 r
.34525 .5145 .33857 .52334 .3534 .52772 .36013 .51893 Metetra
.67 .732 .897 r
.33029 .51005 .32367 .51893 .33857 .52334 .34525 .5145 Metetra
.67 .732 .897 r
.31526 .50558 .3087 .5145 .32367 .51893 .33029 .51005 Metetra
.67 .732 .897 r
.30016 .50109 .29365 .51005 .3087 .5145 .31526 .50558 Metetra
.67 .732 .897 r
.28499 .49657 .27854 .50558 .29365 .51005 .30016 .50109 Metetra
.67 .732 .897 r
.26975 .49204 .26335 .50109 .27854 .50558 .28499 .49657 Metetra
.67 .732 .897 r
.25443 .48748 .24809 .49657 .26335 .50109 .26975 .49204 Metetra
.67 .732 .897 r
.23904 .4829 .23276 .49204 .24809 .49657 .25443 .48748 Metetra
.67 .732 .897 r
.22357 .4783 .21735 .48748 .23276 .49204 .23904 .4829 Metetra
.67 .732 .897 r
.20804 .47368 .20188 .4829 .21735 .48748 .22357 .4783 Metetra
.67 .732 .897 r
.19242 .46903 .18632 .4783 .20188 .4829 .20804 .47368 Metetra
.67 .732 .897 r
.17673 .46436 .17069 .47368 .18632 .4783 .19242 .46903 Metetra
.67 .732 .897 r
.16097 .45967 .15499 .46903 .17069 .47368 .17673 .46436 Metetra
.67 .732 .897 r
.14512 .45496 .13921 .46436 .15499 .46903 .16097 .45967 Metetra
.67 .732 .897 r
.1292 .45022 .12335 .45967 .13921 .46436 .14512 .45496 Metetra
.67 .732 .897 r
.1132 .44546 .10742 .45496 .12335 .45967 .1292 .45022 Metetra
.67 .732 .897 r
.09713 .44068 .0914 .45022 .10742 .45496 .1132 .44546 Metetra
.67 .732 .897 r
.08097 .43588 .07531 .44546 .0914 .45022 .09713 .44068 Metetra
.67 .732 .897 r
.06474 .43105 .05914 .44068 .07531 .44546 .08097 .43588 Metetra
.67 .732 .897 r
.04842 .42619 .04289 .43588 .05914 .44068 .06474 .43105 Metetra
.394 .341 .68 r
.62448 .59163 .61666 .59695 .63153 .62567 .63986 .62785 Metetra
.609 .629 .846 r
.61052 .58294 .60289 .59115 .61666 .59695 .62448 .59163 Metetra
.67 .732 .897 r
.59672 .57881 .58913 .58706 .60289 .59115 .61052 .58294 Metetra
.67 .732 .897 r
.58285 .57466 .5753 .58294 .58913 .58706 .59672 .57881 Metetra
.67 .732 .897 r
.56891 .57049 .56142 .57881 .5753 .58294 .58285 .57466 Metetra
.67 .732 .897 r
.55491 .5663 .54747 .57466 .56142 .57881 .56891 .57049 Metetra
.67 .732 .897 r
.54085 .5621 .53345 .57049 .54747 .57466 .55491 .5663 Metetra
.67 .732 .897 r
.52673 .55787 .51937 .5663 .53345 .57049 .54085 .5621 Metetra
.67 .732 .897 r
.51254 .55362 .50523 .5621 .51937 .5663 .52673 .55787 Metetra
.67 .732 .897 r
.49828 .54936 .49102 .55787 .50523 .5621 .51254 .55362 Metetra
.67 .732 .897 r
.48395 .54507 .47675 .55362 .49102 .55787 .49828 .54936 Metetra
.67 .732 .897 r
.46956 .54076 .46241 .54936 .47675 .55362 .48395 .54507 Metetra
.67 .732 .897 r
.45511 .53644 .448 .54507 .46241 .54936 .46956 .54076 Metetra
.67 .732 .897 r
.44058 .53209 .43352 .54076 .448 .54507 .45511 .53644 Metetra
.67 .732 .897 r
.42599 .52772 .41898 .53644 .43352 .54076 .44058 .53209 Metetra
.67 .732 .897 r
.41133 .52334 .40437 .53209 .41898 .53644 .42599 .52772 Metetra
.67 .732 .897 r
.39659 .51893 .3897 .52772 .40437 .53209 .41133 .52334 Metetra
.67 .732 .897 r
.38179 .5145 .37495 .52334 .3897 .52772 .39659 .51893 Metetra
.67 .732 .897 r
.36692 .51005 .36013 .51893 .37495 .52334 .38179 .5145 Metetra
.67 .732 .897 r
.35198 .50558 .34525 .5145 .36013 .51893 .36692 .51005 Metetra
.67 .732 .897 r
.33697 .50109 .33029 .51005 .34525 .5145 .35198 .50558 Metetra
.67 .732 .897 r
.32189 .49657 .31526 .50558 .33029 .51005 .33697 .50109 Metetra
.67 .732 .897 r
.30673 .49204 .30016 .50109 .31526 .50558 .32189 .49657 Metetra
.67 .732 .897 r
.2915 .48748 .28499 .49657 .30016 .50109 .30673 .49204 Metetra
.67 .732 .897 r
.2762 .4829 .26975 .49204 .28499 .49657 .2915 .48748 Metetra
.67 .732 .897 r
.26083 .4783 .25443 .48748 .26975 .49204 .2762 .4829 Metetra
.67 .732 .897 r
.24538 .47368 .23904 .4829 .25443 .48748 .26083 .4783 Metetra
.67 .732 .897 r
.22985 .46903 .22357 .4783 .23904 .4829 .24538 .47368 Metetra
.67 .732 .897 r
.21425 .46436 .20804 .47368 .22357 .4783 .22985 .46903 Metetra
.67 .732 .897 r
.19858 .45967 .19242 .46903 .20804 .47368 .21425 .46436 Metetra
.67 .732 .897 r
.18283 .45496 .17673 .46436 .19242 .46903 .19858 .45967 Metetra
.67 .732 .897 r
.167 .45022 .16097 .45967 .17673 .46436 .18283 .45496 Metetra
.67 .732 .897 r
.1511 .44546 .14512 .45496 .16097 .45967 .167 .45022 Metetra
.67 .732 .897 r
.13511 .44068 .1292 .45022 .14512 .45496 .1511 .44546 Metetra
.67 .732 .897 r
.11905 .43588 .1132 .44546 .1292 .45022 .13511 .44068 Metetra
.67 .732 .897 r
.10291 .43105 .09713 .44068 .1132 .44546 .11905 .43588 Metetra
.67 .732 .897 r
.08669 .42619 .08097 .43588 .09713 .44068 .10291 .43105 Metetra
.67 .732 .897 r
.07039 .42131 .06474 .43105 .08097 .43588 .08669 .42619 Metetra
.67 .732 .897 r
.054 .41641 .04842 .42619 .06474 .43105 .07039 .42131 Metetra
.379 .314 .658 r
.63239 .58626 .62448 .59163 .63986 .62785 .64831 .63006 Metetra
.566 .593 .84 r
.61827 .57567 .61052 .58294 .62448 .59163 .63239 .58626 Metetra
.655 .707 .885 r
.60437 .57049 .59672 .57881 .61052 .58294 .61827 .57567 Metetra
.67 .732 .897 r
.59046 .5663 .58285 .57466 .59672 .57881 .60437 .57049 Metetra
.67 .732 .897 r
.57648 .5621 .56891 .57049 .58285 .57466 .59046 .5663 Metetra
.67 .732 .897 r
.56243 .55787 .55491 .5663 .56891 .57049 .57648 .5621 Metetra
.67 .732 .897 r
.54832 .55362 .54085 .5621 .55491 .5663 .56243 .55787 Metetra
.67 .732 .897 r
.53415 .54936 .52673 .55787 .54085 .5621 .54832 .55362 Metetra
.67 .732 .897 r
.51991 .54507 .51254 .55362 .52673 .55787 .53415 .54936 Metetra
.67 .732 .897 r
.5056 .54076 .49828 .54936 .51254 .55362 .51991 .54507 Metetra
.67 .732 .897 r
.49123 .53644 .48395 .54507 .49828 .54936 .5056 .54076 Metetra
.67 .732 .897 r
.47679 .53209 .46956 .54076 .48395 .54507 .49123 .53644 Metetra
.67 .732 .897 r
.46228 .52772 .45511 .53644 .46956 .54076 .47679 .53209 Metetra
.67 .732 .897 r
.4477 .52334 .44058 .53209 .45511 .53644 .46228 .52772 Metetra
.67 .732 .897 r
.43306 .51893 .42599 .52772 .44058 .53209 .4477 .52334 Metetra
.67 .732 .897 r
.41834 .5145 .41133 .52334 .42599 .52772 .43306 .51893 Metetra
.67 .732 .897 r
.40356 .51005 .39659 .51893 .41133 .52334 .41834 .5145 Metetra
.67 .732 .897 r
.38871 .50558 .38179 .5145 .39659 .51893 .40356 .51005 Metetra
.67 .732 .897 r
.37378 .50109 .36692 .51005 .38179 .5145 .38871 .50558 Metetra
.67 .732 .897 r
.35878 .49657 .35198 .50558 .36692 .51005 .37378 .50109 Metetra
.67 .732 .897 r
.34372 .49204 .33697 .50109 .35198 .50558 .35878 .49657 Metetra
.67 .732 .897 r
.32858 .48748 .32189 .49657 .33697 .50109 .34372 .49204 Metetra
.67 .732 .897 r
.31337 .4829 .30673 .49204 .32189 .49657 .32858 .48748 Metetra
.67 .732 .897 r
.29808 .4783 .2915 .48748 .30673 .49204 .31337 .4829 Metetra
.67 .732 .897 r
.28272 .47368 .2762 .4829 .2915 .48748 .29808 .4783 Metetra
.67 .732 .897 r
.26729 .46903 .26083 .4783 .2762 .4829 .28272 .47368 Metetra
.67 .732 .897 r
.25178 .46436 .24538 .47368 .26083 .4783 .26729 .46903 Metetra
.67 .732 .897 r
.23619 .45967 .22985 .46903 .24538 .47368 .25178 .46436 Metetra
.67 .732 .897 r
.22054 .45496 .21425 .46436 .22985 .46903 .23619 .45967 Metetra
.67 .732 .897 r
.2048 .45022 .19858 .45967 .21425 .46436 .22054 .45496 Metetra
.67 .732 .897 r
.18899 .44546 .18283 .45496 .19858 .45967 .2048 .45022 Metetra
.67 .732 .897 r
.1731 .44068 .167 .45022 .18283 .45496 .18899 .44546 Metetra
.67 .732 .897 r
.15713 .43588 .1511 .44546 .167 .45022 .1731 .44068 Metetra
.67 .732 .897 r
.14108 .43105 .13511 .44068 .1511 .44546 .15713 .43588 Metetra
.67 .732 .897 r
.12495 .42619 .11905 .43588 .13511 .44068 .14108 .43105 Metetra
.67 .732 .897 r
.10875 .42131 .10291 .43105 .11905 .43588 .12495 .42619 Metetra
.67 .732 .897 r
.09246 .41641 .08669 .42619 .10291 .43105 .10875 .42131 Metetra
.67 .732 .897 r
.07609 .41148 .07039 .42131 .08669 .42619 .09246 .41641 Metetra
.67 .732 .897 r
.05964 .40653 .054 .41641 .07039 .42131 .07609 .41148 Metetra
.367 .293 .64 r
.64038 .58083 .63239 .58626 .64831 .63006 .65691 .63231 Metetra
.539 .57 .835 r
.62613 .56898 .61827 .57567 .63239 .58626 .64038 .58083 Metetra
.632 .669 .867 r
.6121 .5621 .60437 .57049 .61827 .57567 .62613 .56898 Metetra
.67 .732 .897 r
.59814 .55787 .59046 .5663 .60437 .57049 .6121 .5621 Metetra
.67 .732 .897 r
.58411 .55362 .57648 .5621 .59046 .5663 .59814 .55787 Metetra
.67 .732 .897 r
.57002 .54936 .56243 .55787 .57648 .5621 .58411 .55362 Metetra
.67 .732 .897 r
.55586 .54507 .54832 .55362 .56243 .55787 .57002 .54936 Metetra
.67 .732 .897 r
.54164 .54076 .53415 .54936 .54832 .55362 .55586 .54507 Metetra
.67 .732 .897 r
.52735 .53644 .51991 .54507 .53415 .54936 .54164 .54076 Metetra
.67 .732 .897 r
.513 .53209 .5056 .54076 .51991 .54507 .52735 .53644 Metetra
.67 .732 .897 r
.49857 .52772 .49123 .53644 .5056 .54076 .513 .53209 Metetra
.67 .732 .897 r
.48408 .52334 .47679 .53209 .49123 .53644 .49857 .52772 Metetra
.67 .732 .897 r
.46952 .51893 .46228 .52772 .47679 .53209 .48408 .52334 Metetra
.67 .732 .897 r
.45489 .5145 .4477 .52334 .46228 .52772 .46952 .51893 Metetra
.67 .732 .897 r
.4402 .51005 .43306 .51893 .4477 .52334 .45489 .5145 Metetra
.67 .732 .897 r
.42543 .50558 .41834 .5145 .43306 .51893 .4402 .51005 Metetra
.67 .732 .897 r
.41059 .50109 .40356 .51005 .41834 .5145 .42543 .50558 Metetra
.67 .732 .897 r
.39568 .49657 .38871 .50558 .40356 .51005 .41059 .50109 Metetra
.67 .732 .897 r
.3807 .49204 .37378 .50109 .38871 .50558 .39568 .49657 Metetra
.67 .732 .897 r
.36565 .48748 .35878 .49657 .37378 .50109 .3807 .49204 Metetra
.67 .732 .897 r
.35053 .4829 .34372 .49204 .35878 .49657 .36565 .48748 Metetra
.67 .732 .897 r
.33533 .4783 .32858 .48748 .34372 .49204 .35053 .4829 Metetra
.67 .732 .897 r
.32006 .47368 .31337 .4829 .32858 .48748 .33533 .4783 Metetra
.67 .732 .897 r
.30472 .46903 .29808 .4783 .31337 .4829 .32006 .47368 Metetra
.67 .732 .897 r
.2893 .46436 .28272 .47368 .29808 .4783 .30472 .46903 Metetra
.67 .732 .897 r
.27381 .45967 .26729 .46903 .28272 .47368 .2893 .46436 Metetra
.67 .732 .897 r
.25824 .45496 .25178 .46436 .26729 .46903 .27381 .45967 Metetra
.67 .732 .897 r
.2426 .45022 .23619 .45967 .25178 .46436 .25824 .45496 Metetra
.67 .732 .897 r
.22688 .44546 .22054 .45496 .23619 .45967 .2426 .45022 Metetra
.67 .732 .897 r
.21108 .44068 .2048 .45022 .22054 .45496 .22688 .44546 Metetra
.67 .732 .897 r
.1952 .43588 .18899 .44546 .2048 .45022 .21108 .44068 Metetra
.67 .732 .897 r
.17925 .43105 .1731 .44068 .18899 .44546 .1952 .43588 Metetra
.67 .732 .897 r
.16322 .42619 .15713 .43588 .1731 .44068 .17925 .43105 Metetra
.67 .732 .897 r
.14711 .42131 .14108 .43105 .15713 .43588 .16322 .42619 Metetra
.67 .732 .897 r
.13091 .41641 .12495 .42619 .14108 .43105 .14711 .42131 Metetra
.67 .732 .897 r
.11464 .41148 .10875 .42131 .12495 .42619 .13091 .41641 Metetra
.67 .732 .897 r
.09829 .40653 .09246 .41641 .10875 .42131 .11464 .41148 Metetra
.67 .732 .897 r
.08185 .40156 .07609 .41148 .09246 .41641 .09829 .40653 Metetra
.67 .732 .897 r
.06533 .39656 .05964 .40653 .07609 .41148 .08185 .40156 Metetra
.358 .277 .626 r
.64846 .57534 .64038 .58083 .65691 .63231 .66564 .6346 Metetra
.528 .55 .822 r
.63407 .56222 .62613 .56898 .64038 .58083 .64846 .57534 Metetra
.605 .65 .868 r
.61994 .55434 .6121 .5621 .62613 .56898 .63407 .56222 Metetra
.659 .714 .889 r
.60589 .54936 .59814 .55787 .6121 .5621 .61994 .55434 Metetra
.67 .732 .897 r
.59182 .54507 .58411 .55362 .59814 .55787 .60589 .54936 Metetra
.67 .732 .897 r
.57768 .54076 .57002 .54936 .58411 .55362 .59182 .54507 Metetra
.67 .732 .897 r
.56347 .53644 .55586 .54507 .57002 .54936 .57768 .54076 Metetra
.67 .732 .897 r
.5492 .53209 .54164 .54076 .55586 .54507 .56347 .53644 Metetra
.67 .732 .897 r
.53486 .52772 .52735 .53644 .54164 .54076 .5492 .53209 Metetra
.67 .732 .897 r
.52046 .52334 .513 .53209 .52735 .53644 .53486 .52772 Metetra
.67 .732 .897 r
.50598 .51893 .49857 .52772 .513 .53209 .52046 .52334 Metetra
.67 .732 .897 r
.49144 .5145 .48408 .52334 .49857 .52772 .50598 .51893 Metetra
.67 .732 .897 r
.47683 .51005 .46952 .51893 .48408 .52334 .49144 .5145 Metetra
.67 .732 .897 r
.46215 .50558 .45489 .5145 .46952 .51893 .47683 .51005 Metetra
.67 .732 .897 r
.4474 .50109 .4402 .51005 .45489 .5145 .46215 .50558 Metetra
.67 .732 .897 r
.43258 .49657 .42543 .50558 .4402 .51005 .4474 .50109 Metetra
.67 .732 .897 r
.41769 .49204 .41059 .50109 .42543 .50558 .43258 .49657 Metetra
.67 .732 .897 r
.40273 .48748 .39568 .49657 .41059 .50109 .41769 .49204 Metetra
.67 .732 .897 r
.38769 .4829 .3807 .49204 .39568 .49657 .40273 .48748 Metetra
.67 .732 .897 r
.37259 .4783 .36565 .48748 .3807 .49204 .38769 .4829 Metetra
.67 .732 .897 r
.35741 .47368 .35053 .4829 .36565 .48748 .37259 .4783 Metetra
.67 .732 .897 r
.34215 .46903 .33533 .4783 .35053 .4829 .35741 .47368 Metetra
.67 .732 .897 r
.32683 .46436 .32006 .47368 .33533 .4783 .34215 .46903 Metetra
.67 .732 .897 r
.31142 .45967 .30472 .46903 .32006 .47368 .32683 .46436 Metetra
.67 .732 .897 r
.29595 .45496 .2893 .46436 .30472 .46903 .31142 .45967 Metetra
.67 .732 .897 r
.2804 .45022 .27381 .45967 .2893 .46436 .29595 .45496 Metetra
.67 .732 .897 r
.26477 .44546 .25824 .45496 .27381 .45967 .2804 .45022 Metetra
.67 .732 .897 r
.24906 .44068 .2426 .45022 .25824 .45496 .26477 .44546 Metetra
.67 .732 .897 r
.23328 .43588 .22688 .44546 .2426 .45022 .24906 .44068 Metetra
.67 .732 .897 r
.21742 .43105 .21108 .44068 .22688 .44546 .23328 .43588 Metetra
.67 .732 .897 r
.20148 .42619 .1952 .43588 .21108 .44068 .21742 .43105 Metetra
.67 .732 .897 r
.18547 .42131 .17925 .43105 .1952 .43588 .20148 .42619 Metetra
.67 .732 .897 r
.16937 .41641 .16322 .42619 .17925 .43105 .18547 .42131 Metetra
.67 .732 .897 r
.15319 .41148 .14711 .42131 .16322 .42619 .16937 .41641 Metetra
.67 .732 .897 r
.13693 .40653 .13091 .41641 .14711 .42131 .15319 .41148 Metetra
.67 .732 .897 r
.1206 .40156 .11464 .41148 .13091 .41641 .13693 .40653 Metetra
.67 .732 .897 r
.10417 .39656 .09829 .40653 .11464 .41148 .1206 .40156 Metetra
.67 .732 .897 r
.08767 .39153 .08185 .40156 .09829 .40653 .10417 .39656 Metetra
.67 .732 .897 r
.07108 .38648 .06533 .39656 .08185 .40156 .08767 .39153 Metetra
.351 .264 .615 r
.65663 .56978 .64846 .57534 .66564 .6346 .67451 .63692 Metetra
.518 .532 .81 r
.64209 .5554 .63407 .56222 .64846 .57534 .65663 .56978 Metetra
.589 .64 .869 r
.62787 .54697 .61994 .55434 .63407 .56222 .64209 .5554 Metetra
.643 .686 .876 r
.61372 .54076 .60589 .54936 .61994 .55434 .62787 .54697 Metetra
.67 .732 .897 r
.5996 .53644 .59182 .54507 .60589 .54936 .61372 .54076 Metetra
.67 .732 .897 r
.58541 .53209 .57768 .54076 .59182 .54507 .5996 .53644 Metetra
.67 .732 .897 r
.57116 .52772 .56347 .53644 .57768 .54076 .58541 .53209 Metetra
.67 .732 .897 r
.55684 .52334 .5492 .53209 .56347 .53644 .57116 .52772 Metetra
.67 .732 .897 r
.54245 .51893 .53486 .52772 .5492 .53209 .55684 .52334 Metetra
.67 .732 .897 r
.52799 .5145 .52046 .52334 .53486 .52772 .54245 .51893 Metetra
.67 .732 .897 r
.51347 .51005 .50598 .51893 .52046 .52334 .52799 .5145 Metetra
.67 .732 .897 r
.49887 .50558 .49144 .5145 .50598 .51893 .51347 .51005 Metetra
.67 .732 .897 r
.48421 .50109 .47683 .51005 .49144 .5145 .49887 .50558 Metetra
.67 .732 .897 r
.46948 .49657 .46215 .50558 .47683 .51005 .48421 .50109 Metetra
.67 .732 .897 r
.45467 .49204 .4474 .50109 .46215 .50558 .46948 .49657 Metetra
.67 .732 .897 r
.4398 .48748 .43258 .49657 .4474 .50109 .45467 .49204 Metetra
.67 .732 .897 r
.42486 .4829 .41769 .49204 .43258 .49657 .4398 .48748 Metetra
.67 .732 .897 r
.40984 .4783 .40273 .48748 .41769 .49204 .42486 .4829 Metetra
.67 .732 .897 r
.39475 .47368 .38769 .4829 .40273 .48748 .40984 .4783 Metetra
.67 .732 .897 r
.37959 .46903 .37259 .4783 .38769 .4829 .39475 .47368 Metetra
.67 .732 .897 r
.36435 .46436 .35741 .47368 .37259 .4783 .37959 .46903 Metetra
.67 .732 .897 r
.34904 .45967 .34215 .46903 .35741 .47368 .36435 .46436 Metetra
.67 .732 .897 r
.33365 .45496 .32683 .46436 .34215 .46903 .34904 .45967 Metetra
.67 .732 .897 r
.31819 .45022 .31142 .45967 .32683 .46436 .33365 .45496 Metetra
.67 .732 .897 r
.30266 .44546 .29595 .45496 .31142 .45967 .31819 .45022 Metetra
.67 .732 .897 r
.28705 .44068 .2804 .45022 .29595 .45496 .30266 .44546 Metetra
.67 .732 .897 r
.27136 .43588 .26477 .44546 .2804 .45022 .28705 .44068 Metetra
.67 .732 .897 r
.25559 .43105 .24906 .44068 .26477 .44546 .27136 .43588 Metetra
.67 .732 .897 r
.23975 .42619 .23328 .43588 .24906 .44068 .25559 .43105 Metetra
.67 .732 .897 r
.22383 .42131 .21742 .43105 .23328 .43588 .23975 .42619 Metetra
.67 .732 .897 r
.20782 .41641 .20148 .42619 .21742 .43105 .22383 .42131 Metetra
.67 .732 .897 r
.19174 .41148 .18547 .42131 .20148 .42619 .20782 .41641 Metetra
.67 .732 .897 r
.17558 .40653 .16937 .41641 .18547 .42131 .19174 .41148 Metetra
.67 .732 .897 r
.15934 .40156 .15319 .41148 .16937 .41641 .17558 .40653 Metetra
.67 .732 .897 r
.14302 .39656 .13693 .40653 .15319 .41148 .15934 .40156 Metetra
.67 .732 .897 r
.12661 .39153 .1206 .40156 .13693 .40653 .14302 .39656 Metetra
.67 .732 .897 r
.11012 .38648 .10417 .39656 .1206 .40156 .12661 .39153 Metetra
.67 .732 .897 r
.09355 .3814 .08767 .39153 .10417 .39656 .11012 .38648 Metetra
.67 .732 .897 r
.07689 .3763 .07108 .38648 .08767 .39153 .09355 .3814 Metetra
.345 .253 .606 r
.6649 .56417 .65663 .56978 .67451 .63692 .68352 .63928 Metetra
.508 .515 .798 r
.6502 .5485 .64209 .5554 .65663 .56978 .6649 .56417 Metetra
.583 .629 .863 r
.63588 .53952 .62787 .54697 .64209 .5554 .6502 .5485 Metetra
.623 .674 .878 r
.62164 .53265 .61372 .54076 .62787 .54697 .63588 .53952 Metetra
.662 .718 .891 r
.60745 .52772 .5996 .53644 .61372 .54076 .62164 .53265 Metetra
.67 .732 .897 r
.59321 .52334 .58541 .53209 .5996 .53644 .60745 .52772 Metetra
.67 .732 .897 r
.57891 .51893 .57116 .52772 .58541 .53209 .59321 .52334 Metetra
.67 .732 .897 r
.56454 .5145 .55684 .52334 .57116 .52772 .57891 .51893 Metetra
.67 .732 .897 r
.5501 .51005 .54245 .51893 .55684 .52334 .56454 .5145 Metetra
.67 .732 .897 r
.5356 .50558 .52799 .5145 .54245 .51893 .5501 .51005 Metetra
.67 .732 .897 r
.52102 .50109 .51347 .51005 .52799 .5145 .5356 .50558 Metetra
.67 .732 .897 r
.50638 .49657 .49887 .50558 .51347 .51005 .52102 .50109 Metetra
.67 .732 .897 r
.49166 .49204 .48421 .50109 .49887 .50558 .50638 .49657 Metetra
.67 .732 .897 r
.47687 .48748 .46948 .49657 .48421 .50109 .49166 .49204 Metetra
.67 .732 .897 r
.46202 .4829 .45467 .49204 .46948 .49657 .47687 .48748 Metetra
.67 .732 .897 r
.44709 .4783 .4398 .48748 .45467 .49204 .46202 .4829 Metetra
.67 .732 .897 r
.43209 .47368 .42486 .4829 .4398 .48748 .44709 .4783 Metetra
.67 .732 .897 r
.41702 .46903 .40984 .4783 .42486 .4829 .43209 .47368 Metetra
.67 .732 .897 r
.40187 .46436 .39475 .47368 .40984 .4783 .41702 .46903 Metetra
.67 .732 .897 r
.38665 .45967 .37959 .46903 .39475 .47368 .40187 .46436 Metetra
.67 .732 .897 r
.37136 .45496 .36435 .46436 .37959 .46903 .38665 .45967 Metetra
.67 .732 .897 r
.35599 .45022 .34904 .45967 .36435 .46436 .37136 .45496 Metetra
.67 .732 .897 r
.34055 .44546 .33365 .45496 .34904 .45967 .35599 .45022 Metetra
.67 .732 .897 r
.32503 .44068 .31819 .45022 .33365 .45496 .34055 .44546 Metetra
.67 .732 .897 r
.30944 .43588 .30266 .44546 .31819 .45022 .32503 .44068 Metetra
.67 .732 .897 r
.29376 .43105 .28705 .44068 .30266 .44546 .30944 .43588 Metetra
.67 .732 .897 r
.27801 .42619 .27136 .43588 .28705 .44068 .29376 .43105 Metetra
.67 .732 .897 r
.26219 .42131 .25559 .43105 .27136 .43588 .27801 .42619 Metetra
.67 .732 .897 r
.24628 .41641 .23975 .42619 .25559 .43105 .26219 .42131 Metetra
.67 .732 .897 r
.23029 .41148 .22383 .42131 .23975 .42619 .24628 .41641 Metetra
.67 .732 .897 r
.21423 .40653 .20782 .41641 .22383 .42131 .23029 .41148 Metetra
.67 .732 .897 r
.19808 .40156 .19174 .41148 .20782 .41641 .21423 .40653 Metetra
.67 .732 .897 r
.18186 .39656 .17558 .40653 .19174 .41148 .19808 .40156 Metetra
.67 .732 .897 r
.16555 .39153 .15934 .40156 .17558 .40653 .18186 .39656 Metetra
.67 .732 .897 r
.14916 .38648 .14302 .39656 .15934 .40156 .16555 .39153 Metetra
.67 .732 .897 r
.13269 .3814 .12661 .39153 .14302 .39656 .14916 .38648 Metetra
.67 .732 .897 r
.11613 .3763 .11012 .38648 .12661 .39153 .13269 .3814 Metetra
.67 .732 .897 r
.09949 .37117 .09355 .3814 .11012 .38648 .11613 .3763 Metetra
.67 .732 .897 r
.08276 .36601 .07689 .3763 .09355 .3814 .09949 .37117 Metetra
.34 .244 .598 r
.67325 .55849 .6649 .56417 .68352 .63928 .69268 .64168 Metetra
.499 .499 .787 r
.65839 .54153 .6502 .5485 .6649 .56417 .67325 .55849 Metetra
.577 .619 .857 r
.64398 .532 .63588 .53952 .6502 .5485 .65839 .54153 Metetra
.611 .669 .881 r
.62966 .52481 .62164 .53265 .63588 .53952 .64398 .532 Metetra
.649 .697 .881 r
.61537 .51893 .60745 .52772 .62164 .53265 .62966 .52481 Metetra
.67 .732 .897 r
.60109 .5145 .59321 .52334 .60745 .52772 .61537 .51893 Metetra
.67 .732 .897 r
.58674 .51005 .57891 .51893 .59321 .52334 .60109 .5145 Metetra
.67 .732 .897 r
.57232 .50558 .56454 .5145 .57891 .51893 .58674 .51005 Metetra
.67 .732 .897 r
.55783 .50109 .5501 .51005 .56454 .5145 .57232 .50558 Metetra
.67 .732 .897 r
.54327 .49657 .5356 .50558 .5501 .51005 .55783 .50109 Metetra
.67 .732 .897 r
.52865 .49204 .52102 .50109 .5356 .50558 .54327 .49657 Metetra
.67 .732 .897 r
.51395 .48748 .50638 .49657 .52102 .50109 .52865 .49204 Metetra
.67 .732 .897 r
.49918 .4829 .49166 .49204 .50638 .49657 .51395 .48748 Metetra
.67 .732 .897 r
.48434 .4783 .47687 .48748 .49166 .49204 .49918 .4829 Metetra
.67 .732 .897 r
.46943 .47368 .46202 .4829 .47687 .48748 .48434 .4783 Metetra
.67 .732 .897 r
.45445 .46903 .44709 .4783 .46202 .4829 .46943 .47368 Metetra
.67 .732 .897 r
.4394 .46436 .43209 .47368 .44709 .4783 .45445 .46903 Metetra
.67 .732 .897 r
.42427 .45967 .41702 .46903 .43209 .47368 .4394 .46436 Metetra
.67 .732 .897 r
.40907 .45496 .40187 .46436 .41702 .46903 .42427 .45967 Metetra
.67 .732 .897 r
.39379 .45022 .38665 .45967 .40187 .46436 .40907 .45496 Metetra
.67 .732 .897 r
.37844 .44546 .37136 .45496 .38665 .45967 .39379 .45022 Metetra
.67 .732 .897 r
.36301 .44068 .35599 .45022 .37136 .45496 .37844 .44546 Metetra
.67 .732 .897 r
.34751 .43588 .34055 .44546 .35599 .45022 .36301 .44068 Metetra
.67 .732 .897 r
.33193 .43105 .32503 .44068 .34055 .44546 .34751 .43588 Metetra
.67 .732 .897 r
.31628 .42619 .30944 .43588 .32503 .44068 .33193 .43105 Metetra
.67 .732 .897 r
.30055 .42131 .29376 .43105 .30944 .43588 .31628 .42619 Metetra
.67 .732 .897 r
.28474 .41641 .27801 .42619 .29376 .43105 .30055 .42131 Metetra
.67 .732 .897 r
.26885 .41148 .26219 .42131 .27801 .42619 .28474 .41641 Metetra
.67 .732 .897 r
.25288 .40653 .24628 .41641 .26219 .42131 .26885 .41148 Metetra
.67 .732 .897 r
.23683 .40156 .23029 .41148 .24628 .41641 .25288 .40653 Metetra
.67 .732 .897 r
.2207 .39656 .21423 .40653 .23029 .41148 .23683 .40156 Metetra
.67 .732 .897 r
.20449 .39153 .19808 .40156 .21423 .40653 .2207 .39656 Metetra
.67 .732 .897 r
.1882 .38648 .18186 .39656 .19808 .40156 .20449 .39153 Metetra
.67 .732 .897 r
.17182 .3814 .16555 .39153 .18186 .39656 .1882 .38648 Metetra
.67 .732 .897 r
.15536 .3763 .14916 .38648 .16555 .39153 .17182 .3814 Metetra
.67 .732 .897 r
.13882 .37117 .13269 .3814 .14916 .38648 .15536 .3763 Metetra
.67 .732 .897 r
.1222 .36601 .11613 .3763 .13269 .3814 .13882 .37117 Metetra
.67 .732 .897 r
.10549 .36083 .09949 .37117 .11613 .3763 .1222 .36601 Metetra
.67 .732 .897 r
.08869 .35562 .08276 .36601 .09949 .37117 .10549 .36083 Metetra
.335 .236 .592 r
.6817 .55274 .67325 .55849 .69268 .64168 .70199 .64412 Metetra
.49 .484 .777 r
.66666 .53448 .65839 .54153 .67325 .55849 .6817 .55274 Metetra
.572 .609 .852 r
.65215 .5244 .64398 .532 .65839 .54153 .66666 .53448 Metetra
.608 .663 .878 r
.63777 .51689 .62966 .52481 .64398 .532 .65215 .5244 Metetra
.633 .688 .883 r
.6234 .5105 .61537 .51893 .62966 .52481 .63777 .51689 Metetra
.663 .721 .892 r
.60904 .50558 .60109 .5145 .61537 .51893 .6234 .5105 Metetra
.67 .732 .897 r
.59464 .50109 .58674 .51005 .60109 .5145 .60904 .50558 Metetra
.67 .732 .897 r
.58017 .49657 .57232 .50558 .58674 .51005 .59464 .50109 Metetra
.67 .732 .897 r
.56563 .49204 .55783 .50109 .57232 .50558 .58017 .49657 Metetra
.67 .732 .897 r
.55102 .48748 .54327 .49657 .55783 .50109 .56563 .49204 Metetra
.67 .732 .897 r
.53634 .4829 .52865 .49204 .54327 .49657 .55102 .48748 Metetra
.67 .732 .897 r
.5216 .4783 .51395 .48748 .52865 .49204 .53634 .4829 Metetra
.67 .732 .897 r
.50678 .47368 .49918 .4829 .51395 .48748 .5216 .4783 Metetra
.67 .732 .897 r
.49188 .46903 .48434 .4783 .49918 .4829 .50678 .47368 Metetra
.67 .732 .897 r
.47692 .46436 .46943 .47368 .48434 .4783 .49188 .46903 Metetra
.67 .732 .897 r
.46188 .45967 .45445 .46903 .46943 .47368 .47692 .46436 Metetra
.67 .732 .897 r
.44677 .45496 .4394 .46436 .45445 .46903 .46188 .45967 Metetra
.67 .732 .897 r
.43159 .45022 .42427 .45967 .4394 .46436 .44677 .45496 Metetra
.67 .732 .897 r
.41633 .44546 .40907 .45496 .42427 .45967 .43159 .45022 Metetra
.67 .732 .897 r
.401 .44068 .39379 .45022 .40907 .45496 .41633 .44546 Metetra
.67 .732 .897 r
.38559 .43588 .37844 .44546 .39379 .45022 .401 .44068 Metetra
.67 .732 .897 r
.37011 .43105 .36301 .44068 .37844 .44546 .38559 .43588 Metetra
.67 .732 .897 r
.35454 .42619 .34751 .43588 .36301 .44068 .37011 .43105 Metetra
.67 .732 .897 r
.33891 .42131 .33193 .43105 .34751 .43588 .35454 .42619 Metetra
.67 .732 .897 r
.32319 .41641 .31628 .42619 .33193 .43105 .33891 .42131 Metetra
.67 .732 .897 r
.3074 .41148 .30055 .42131 .31628 .42619 .32319 .41641 Metetra
.67 .732 .897 r
.29152 .40653 .28474 .41641 .30055 .42131 .3074 .41148 Metetra
.67 .732 .897 r
.27557 .40156 .26885 .41148 .28474 .41641 .29152 .40653 Metetra
.67 .732 .897 r
.25954 .39656 .25288 .40653 .26885 .41148 .27557 .40156 Metetra
.67 .732 .897 r
.24343 .39153 .23683 .40156 .25288 .40653 .25954 .39656 Metetra
.67 .732 .897 r
.22723 .38648 .2207 .39656 .23683 .40156 .24343 .39153 Metetra
.67 .732 .897 r
.21096 .3814 .20449 .39153 .2207 .39656 .22723 .38648 Metetra
.67 .732 .897 r
.1946 .3763 .1882 .38648 .20449 .39153 .21096 .3814 Metetra
.67 .732 .897 r
.17816 .37117 .17182 .3814 .1882 .38648 .1946 .3763 Metetra
.67 .732 .897 r
.16163 .36601 .15536 .3763 .17182 .3814 .17816 .37117 Metetra
.67 .732 .897 r
.14502 .36083 .13882 .37117 .15536 .3763 .16163 .36601 Metetra
.67 .732 .897 r
.12833 .35562 .1222 .36601 .13882 .37117 .14502 .36083 Metetra
.67 .732 .897 r
.11155 .35039 .10549 .36083 .1222 .36601 .12833 .35562 Metetra
.67 .732 .897 r
.09468 .34513 .08869 .35562 .10549 .36083 .11155 .35039 Metetra
.332 .23 .586 r
.69025 .54694 .6817 .55274 .70199 .64412 .71146 .6466 Metetra
.483 .471 .768 r
.67502 .52736 .66666 .53448 .6817 .55274 .69025 .54694 Metetra
.566 .6 .846 r
.66041 .51673 .65215 .5244 .66666 .53448 .67502 .52736 Metetra
.605 .657 .875 r
.64595 .5089 .63777 .51689 .65215 .5244 .66041 .51673 Metetra
.624 .685 .887 r
.63151 .50229 .6234 .5105 .63777 .51689 .64595 .5089 Metetra
.652 .703 .884 r
.61707 .49657 .60904 .50558 .6234 .5105 .63151 .50229 Metetra
.67 .732 .897 r
.60262 .49204 .59464 .50109 .60904 .50558 .61707 .49657 Metetra
.67 .732 .897 r
.5881 .48748 .58017 .49657 .59464 .50109 .60262 .49204 Metetra
.67 .732 .897 r
.57351 .4829 .56563 .49204 .58017 .49657 .5881 .48748 Metetra
.67 .732 .897 r
.55885 .4783 .55102 .48748 .56563 .49204 .57351 .4829 Metetra
.67 .732 .897 r
.54412 .47368 .53634 .4829 .55102 .48748 .55885 .4783 Metetra
.67 .732 .897 r
.52932 .46903 .5216 .4783 .53634 .4829 .54412 .47368 Metetra
.67 .732 .897 r
.51444 .46436 .50678 .47368 .5216 .4783 .52932 .46903 Metetra
.67 .732 .897 r
.4995 .45967 .49188 .46903 .50678 .47368 .51444 .46436 Metetra
.67 .732 .897 r
.48448 .45496 .47692 .46436 .49188 .46903 .4995 .45967 Metetra
.67 .732 .897 r
.46939 .45022 .46188 .45967 .47692 .46436 .48448 .45496 Metetra
.67 .732 .897 r
.45422 .44546 .44677 .45496 .46188 .45967 .46939 .45022 Metetra
.67 .732 .897 r
.43898 .44068 .43159 .45022 .44677 .45496 .45422 .44546 Metetra
.67 .732 .897 r
.42367 .43588 .41633 .44546 .43159 .45022 .43898 .44068 Metetra
.67 .732 .897 r
.40828 .43105 .401 .44068 .41633 .44546 .42367 .43588 Metetra
.67 .732 .897 r
.39281 .42619 .38559 .43588 .401 .44068 .40828 .43105 Metetra
.67 .732 .897 r
.37727 .42131 .37011 .43105 .38559 .43588 .39281 .42619 Metetra
.67 .732 .897 r
.36165 .41641 .35454 .42619 .37011 .43105 .37727 .42131 Metetra
.67 .732 .897 r
.34595 .41148 .33891 .42131 .35454 .42619 .36165 .41641 Metetra
.67 .732 .897 r
.33017 .40653 .32319 .41641 .33891 .42131 .34595 .41148 Metetra
.67 .732 .897 r
.31432 .40156 .3074 .41148 .32319 .41641 .33017 .40653 Metetra
.67 .732 .897 r
.29838 .39656 .29152 .40653 .3074 .41148 .31432 .40156 Metetra
.67 .732 .897 r
.28237 .39153 .27557 .40156 .29152 .40653 .29838 .39656 Metetra
.67 .732 .897 r
.26627 .38648 .25954 .39656 .27557 .40156 .28237 .39153 Metetra
.67 .732 .897 r
.25009 .3814 .24343 .39153 .25954 .39656 .26627 .38648 Metetra
.67 .732 .897 r
.23383 .3763 .22723 .38648 .24343 .39153 .25009 .3814 Metetra
.67 .732 .897 r
.21749 .37117 .21096 .3814 .22723 .38648 .23383 .3763 Metetra
.67 .732 .897 r
.20107 .36601 .1946 .3763 .21096 .3814 .21749 .37117 Metetra
.67 .732 .897 r
.18456 .36083 .17816 .37117 .1946 .3763 .20107 .36601 Metetra
.67 .732 .897 r
.16796 .35562 .16163 .36601 .17816 .37117 .18456 .36083 Metetra
.67 .732 .897 r
.15129 .35039 .14502 .36083 .16163 .36601 .16796 .35562 Metetra
.67 .732 .897 r
.13452 .34513 .12833 .35562 .14502 .36083 .15129 .35039 Metetra
.67 .732 .897 r
.11767 .33984 .11155 .35039 .12833 .35562 .13452 .34513 Metetra
.67 .732 .897 r
.10073 .33452 .09468 .34513 .11155 .35039 .11767 .33984 Metetra
.329 .224 .581 r
.69889 .54106 .69025 .54694 .71146 .6466 .72108 .64912 Metetra
.475 .458 .759 r
.68348 .52017 .67502 .52736 .69025 .54694 .69889 .54106 Metetra
.561 .591 .841 r
.66876 .50898 .66041 .51673 .67502 .52736 .68348 .52017 Metetra
.601 .651 .871 r
.65422 .50082 .64595 .5089 .66041 .51673 .66876 .50898 Metetra
.622 .681 .885 r
.63971 .494 .63151 .50229 .64595 .5089 .65422 .50082 Metetra
.64 .696 .887 r
.62519 .48787 .61707 .49657 .63151 .50229 .63971 .494 Metetra
.664 .723 .893 r
.61067 .4829 .60262 .49204 .61707 .49657 .62519 .48787 Metetra
.67 .732 .897 r
.5961 .4783 .5881 .48748 .60262 .49204 .61067 .4829 Metetra
.67 .732 .897 r
.58146 .47368 .57351 .4829 .5881 .48748 .5961 .4783 Metetra
.67 .732 .897 r
.56675 .46903 .55885 .4783 .57351 .4829 .58146 .47368 Metetra
.67 .732 .897 r
.55197 .46436 .54412 .47368 .55885 .4783 .56675 .46903 Metetra
.67 .732 .897 r
.53711 .45967 .52932 .46903 .54412 .47368 .55197 .46436 Metetra
.67 .732 .897 r
.52219 .45496 .51444 .46436 .52932 .46903 .53711 .45967 Metetra
.67 .732 .897 r
.50719 .45022 .4995 .45967 .51444 .46436 .52219 .45496 Metetra
.67 .732 .897 r
.49211 .44546 .48448 .45496 .4995 .45967 .50719 .45022 Metetra
.67 .732 .897 r
.47697 .44068 .46939 .45022 .48448 .45496 .49211 .44546 Metetra
.67 .732 .897 r
.46174 .43588 .45422 .44546 .46939 .45022 .47697 .44068 Metetra
.67 .732 .897 r
.44645 .43105 .43898 .44068 .45422 .44546 .46174 .43588 Metetra
.67 .732 .897 r
.43108 .42619 .42367 .43588 .43898 .44068 .44645 .43105 Metetra
.67 .732 .897 r
.41563 .42131 .40828 .43105 .42367 .43588 .43108 .42619 Metetra
.67 .732 .897 r
.4001 .41641 .39281 .42619 .40828 .43105 .41563 .42131 Metetra
.67 .732 .897 r
.3845 .41148 .37727 .42131 .39281 .42619 .4001 .41641 Metetra
.67 .732 .897 r
.36882 .40653 .36165 .41641 .37727 .42131 .3845 .41148 Metetra
.67 .732 .897 r
.35306 .40156 .34595 .41148 .36165 .41641 .36882 .40653 Metetra
.67 .732 .897 r
.33722 .39656 .33017 .40653 .34595 .41148 .35306 .40156 Metetra
.67 .732 .897 r
.32131 .39153 .31432 .40156 .33017 .40653 .33722 .39656 Metetra
.67 .732 .897 r
.30531 .38648 .29838 .39656 .31432 .40156 .32131 .39153 Metetra
.67 .732 .897 r
.28923 .3814 .28237 .39153 .29838 .39656 .30531 .38648 Metetra
.67 .732 .897 r
.27307 .3763 .26627 .38648 .28237 .39153 .28923 .3814 Metetra
.67 .732 .897 r
.25683 .37117 .25009 .3814 .26627 .38648 .27307 .3763 Metetra
.67 .732 .897 r
.2405 .36601 .23383 .3763 .25009 .3814 .25683 .37117 Metetra
.67 .732 .897 r
.22409 .36083 .21749 .37117 .23383 .3763 .2405 .36601 Metetra
.67 .732 .897 r
.2076 .35562 .20107 .36601 .21749 .37117 .22409 .36083 Metetra
.67 .732 .897 r
.19102 .35039 .18456 .36083 .20107 .36601 .2076 .35562 Metetra
.67 .732 .897 r
.17436 .34513 .16796 .35562 .18456 .36083 .19102 .35039 Metetra
.67 .732 .897 r
.15761 .33984 .15129 .35039 .16796 .35562 .17436 .34513 Metetra
.67 .732 .897 r
.14078 .33452 .13452 .34513 .15129 .35039 .15761 .33984 Metetra
.67 .732 .897 r
.12386 .32918 .11767 .33984 .13452 .34513 .14078 .33452 Metetra
.67 .732 .897 r
.10685 .32381 .10073 .33452 .11767 .33984 .12386 .32918 Metetra
.326 .22 .577 r
.70763 .53512 .69889 .54106 .72108 .64912 .73087 .65169 Metetra
.468 .446 .751 r
.69202 .5129 .68348 .52017 .69889 .54106 .70763 .53512 Metetra
.556 .582 .835 r
.67719 .50114 .66876 .50898 .68348 .52017 .69202 .5129 Metetra
.598 .645 .868 r
.66257 .49266 .65422 .50082 .66876 .50898 .67719 .50114 Metetra
.62 .677 .883 r
.64799 .48562 .63971 .494 .65422 .50082 .66257 .49266 Metetra
.633 .695 .89 r
.63341 .47932 .62519 .48787 .63971 .494 .64799 .48562 Metetra
.655 .708 .886 r
.6188 .47368 .61067 .4829 .62519 .48787 .63341 .47932 Metetra
.67 .732 .897 r
.60418 .46903 .5961 .4783 .61067 .4829 .6188 .47368 Metetra
.67 .732 .897 r
.58949 .46436 .58146 .47368 .5961 .4783 .60418 .46903 Metetra
.67 .732 .897 r
.57473 .45967 .56675 .46903 .58146 .47368 .58949 .46436 Metetra
.67 .732 .897 r
.55989 .45496 .55197 .46436 .56675 .46903 .57473 .45967 Metetra
.67 .732 .897 r
.54498 .45022 .53711 .45967 .55197 .46436 .55989 .45496 Metetra
.67 .732 .897 r
.53 .44546 .52219 .45496 .53711 .45967 .54498 .45022 Metetra
.67 .732 .897 r
.51495 .44068 .50719 .45022 .52219 .45496 .53 .44546 Metetra
.67 .732 .897 r
.49982 .43588 .49211 .44546 .50719 .45022 .51495 .44068 Metetra
.67 .732 .897 r
.48462 .43105 .47697 .44068 .49211 .44546 .49982 .43588 Metetra
.67 .732 .897 r
.46934 .42619 .46174 .43588 .47697 .44068 .48462 .43105 Metetra
.67 .732 .897 r
.45399 .42131 .44645 .43105 .46174 .43588 .46934 .42619 Metetra
.67 .732 .897 r
.43856 .41641 .43108 .42619 .44645 .43105 .45399 .42131 Metetra
.67 .732 .897 r
.42305 .41148 .41563 .42131 .43108 .42619 .43856 .41641 Metetra
.67 .732 .897 r
.40747 .40653 .4001 .41641 .41563 .42131 .42305 .41148 Metetra
.67 .732 .897 r
.3918 .40156 .3845 .41148 .4001 .41641 .40747 .40653 Metetra
.67 .732 .897 r
.37606 .39656 .36882 .40653 .3845 .41148 .3918 .40156 Metetra
.67 .732 .897 r
.36024 .39153 .35306 .40156 .36882 .40653 .37606 .39656 Metetra
.67 .732 .897 r
.34434 .38648 .33722 .39656 .35306 .40156 .36024 .39153 Metetra
.67 .732 .897 r
.32836 .3814 .32131 .39153 .33722 .39656 .34434 .38648 Metetra
.67 .732 .897 r
.3123 .3763 .30531 .38648 .32131 .39153 .32836 .3814 Metetra
.67 .732 .897 r
.29616 .37117 .28923 .3814 .30531 .38648 .3123 .3763 Metetra
.67 .732 .897 r
.27994 .36601 .27307 .3763 .28923 .3814 .29616 .37117 Metetra
.67 .732 .897 r
.26363 .36083 .25683 .37117 .27307 .3763 .27994 .36601 Metetra
.67 .732 .897 r
.24724 .35562 .2405 .36601 .25683 .37117 .26363 .36083 Metetra
.67 .732 .897 r
.23076 .35039 .22409 .36083 .2405 .36601 .24724 .35562 Metetra
.67 .732 .897 r
.2142 .34513 .2076 .35562 .22409 .36083 .23076 .35039 Metetra
.67 .732 .897 r
.19756 .33984 .19102 .35039 .2076 .35562 .2142 .34513 Metetra
.67 .732 .897 r
.18083 .33452 .17436 .34513 .19102 .35039 .19756 .33984 Metetra
.67 .732 .897 r
.16401 .32918 .15761 .33984 .17436 .34513 .18083 .33452 Metetra
.67 .732 .897 r
.1471 .32381 .14078 .33452 .15761 .33984 .16401 .32918 Metetra
.67 .732 .897 r
.13011 .31841 .12386 .32918 .14078 .33452 .1471 .32381 Metetra
.67 .732 .897 r
.11302 .31298 .10685 .32381 .12386 .32918 .13011 .31841 Metetra
.323 .215 .573 r
.71648 .52911 .70763 .53512 .73087 .65169 .74083 .6543 Metetra
.462 .435 .743 r
.70065 .50555 .69202 .5129 .70763 .53512 .71648 .52911 Metetra
.551 .573 .83 r
.68571 .49322 .67719 .50114 .69202 .5129 .70065 .50555 Metetra
.595 .64 .865 r
.671 .48442 .66257 .49266 .67719 .50114 .68571 .49322 Metetra
.618 .673 .881 r
.65635 .47715 .64799 .48562 .66257 .49266 .671 .48442 Metetra
.631 .692 .888 r
.64171 .47069 .63341 .47932 .64799 .48562 .65635 .47715 Metetra
.644 .702 .889 r
.62703 .4647 .6188 .47368 .63341 .47932 .64171 .47069 Metetra
.665 .724 .893 r
.61234 .45967 .60418 .46903 .6188 .47368 .62703 .4647 Metetra
.67 .732 .897 r
.5976 .45496 .58949 .46436 .60418 .46903 .61234 .45967 Metetra
.67 .732 .897 r
.58278 .45022 .57473 .45967 .58949 .46436 .5976 .45496 Metetra
.67 .732 .897 r
.56789 .44546 .55989 .45496 .57473 .45967 .58278 .45022 Metetra
.67 .732 .897 r
.55293 .44068 .54498 .45022 .55989 .45496 .56789 .44546 Metetra
.67 .732 .897 r
.5379 .43588 .53 .44546 .54498 .45022 .55293 .44068 Metetra
.67 .732 .897 r
.52279 .43105 .51495 .44068 .53 .44546 .5379 .43588 Metetra
.67 .732 .897 r
.50761 .42619 .49982 .43588 .51495 .44068 .52279 .43105 Metetra
.67 .732 .897 r
.49235 .42131 .48462 .43105 .49982 .43588 .50761 .42619 Metetra
.67 .732 .897 r
.47701 .41641 .46934 .42619 .48462 .43105 .49235 .42131 Metetra
.67 .732 .897 r
.4616 .41148 .45399 .42131 .46934 .42619 .47701 .41641 Metetra
.67 .732 .897 r
.44611 .40653 .43856 .41641 .45399 .42131 .4616 .41148 Metetra
.67 .732 .897 r
.43055 .40156 .42305 .41148 .43856 .41641 .44611 .40653 Metetra
.67 .732 .897 r
.41491 .39656 .40747 .40653 .42305 .41148 .43055 .40156 Metetra
.67 .732 .897 r
.39918 .39153 .3918 .40156 .40747 .40653 .41491 .39656 Metetra
.67 .732 .897 r
.38338 .38648 .37606 .39656 .3918 .40156 .39918 .39153 Metetra
.67 .732 .897 r
.3675 .3814 .36024 .39153 .37606 .39656 .38338 .38648 Metetra
.67 .732 .897 r
.35154 .3763 .34434 .38648 .36024 .39153 .3675 .3814 Metetra
.67 .732 .897 r
.3355 .37117 .32836 .3814 .34434 .38648 .35154 .3763 Metetra
.67 .732 .897 r
.31937 .36601 .3123 .3763 .32836 .3814 .3355 .37117 Metetra
.67 .732 .897 r
.30316 .36083 .29616 .37117 .3123 .3763 .31937 .36601 Metetra
.67 .732 .897 r
.28687 .35562 .27994 .36601 .29616 .37117 .30316 .36083 Metetra
.67 .732 .897 r
.2705 .35039 .26363 .36083 .27994 .36601 .28687 .35562 Metetra
.67 .732 .897 r
.25404 .34513 .24724 .35562 .26363 .36083 .2705 .35039 Metetra
.67 .732 .897 r
.2375 .33984 .23076 .35039 .24724 .35562 .25404 .34513 Metetra
.67 .732 .897 r
.22087 .33452 .2142 .34513 .23076 .35039 .2375 .33984 Metetra
.67 .732 .897 r
.20416 .32918 .19756 .33984 .2142 .34513 .22087 .33452 Metetra
.67 .732 .897 r
.18736 .32381 .18083 .33452 .19756 .33984 .20416 .32918 Metetra
.67 .732 .897 r
.17047 .31841 .16401 .32918 .18083 .33452 .18736 .32381 Metetra
.67 .732 .897 r
.15349 .31298 .1471 .32381 .16401 .32918 .17047 .31841 Metetra
.67 .732 .897 r
.13642 .30753 .13011 .31841 .1471 .32381 .15349 .31298 Metetra
.67 .732 .897 r
.11927 .30204 .11302 .31298 .13011 .31841 .13642 .30753 Metetra
.321 .211 .57 r
.72543 .52302 .71648 .52911 .74083 .6543 .75095 .65695 Metetra
.456 .425 .735 r
.70938 .49812 .70065 .50555 .71648 .52911 .72543 .52302 Metetra
.546 .565 .825 r
.69432 .48523 .68571 .49322 .70065 .50555 .70938 .49812 Metetra
.591 .634 .862 r
.67953 .47609 .671 .48442 .68571 .49322 .69432 .48523 Metetra
.615 .669 .879 r
.6648 .4686 .65635 .47715 .671 .48442 .67953 .47609 Metetra
.63 .689 .887 r
.65009 .46197 .64171 .47069 .65635 .47715 .6648 .4686 Metetra
.639 .701 .891 r
.63535 .45585 .62703 .4647 .64171 .47069 .65009 .46197 Metetra
.657 .711 .888 r
.62058 .45022 .61234 .45967 .62703 .4647 .63535 .45585 Metetra
.67 .732 .897 r
.60579 .44546 .5976 .45496 .61234 .45967 .62058 .45022 Metetra
.67 .732 .897 r
.59092 .44068 .58278 .45022 .5976 .45496 .60579 .44546 Metetra
.67 .732 .897 r
.57598 .43588 .56789 .44546 .58278 .45022 .59092 .44068 Metetra
.67 .732 .897 r
.56096 .43105 .55293 .44068 .56789 .44546 .57598 .43588 Metetra
.67 .732 .897 r
.54587 .42619 .5379 .43588 .55293 .44068 .56096 .43105 Metetra
.67 .732 .897 r
.53071 .42131 .52279 .43105 .5379 .43588 .54587 .42619 Metetra
.67 .732 .897 r
.51547 .41641 .50761 .42619 .52279 .43105 .53071 .42131 Metetra
.67 .732 .897 r
.50015 .41148 .49235 .42131 .50761 .42619 .51547 .41641 Metetra
.67 .732 .897 r
.48476 .40653 .47701 .41641 .49235 .42131 .50015 .41148 Metetra
.67 .732 .897 r
.46929 .40156 .4616 .41148 .47701 .41641 .48476 .40653 Metetra
.67 .732 .897 r
.45375 .39656 .44611 .40653 .4616 .41148 .46929 .40156 Metetra
.67 .732 .897 r
.43812 .39153 .43055 .40156 .44611 .40653 .45375 .39656 Metetra
.67 .732 .897 r
.42242 .38648 .41491 .39656 .43055 .40156 .43812 .39153 Metetra
.67 .732 .897 r
.40664 .3814 .39918 .39153 .41491 .39656 .42242 .38648 Metetra
.67 .732 .897 r
.39077 .3763 .38338 .38648 .39918 .39153 .40664 .3814 Metetra
.67 .732 .897 r
.37483 .37117 .3675 .3814 .38338 .38648 .39077 .3763 Metetra
.67 .732 .897 r
.35881 .36601 .35154 .3763 .3675 .3814 .37483 .37117 Metetra
.67 .732 .897 r
.3427 .36083 .3355 .37117 .35154 .3763 .35881 .36601 Metetra
.67 .732 .897 r
.32651 .35562 .31937 .36601 .3355 .37117 .3427 .36083 Metetra
.67 .732 .897 r
.31024 .35039 .30316 .36083 .31937 .36601 .32651 .35562 Metetra
.67 .732 .897 r
.29388 .34513 .28687 .35562 .30316 .36083 .31024 .35039 Metetra
.67 .732 .897 r
.27744 .33984 .2705 .35039 .28687 .35562 .29388 .34513 Metetra
.67 .732 .897 r
.26092 .33452 .25404 .34513 .2705 .35039 .27744 .33984 Metetra
.67 .732 .897 r
.24431 .32918 .2375 .33984 .25404 .34513 .26092 .33452 Metetra
.67 .732 .897 r
.22761 .32381 .22087 .33452 .2375 .33984 .24431 .32918 Metetra
.67 .732 .897 r
.21083 .31841 .20416 .32918 .22087 .33452 .22761 .32381 Metetra
.67 .732 .897 r
.19396 .31298 .18736 .32381 .20416 .32918 .21083 .31841 Metetra
.67 .732 .897 r
.177 .30753 .17047 .31841 .18736 .32381 .19396 .31298 Metetra
.67 .732 .897 r
.15995 .30204 .15349 .31298 .17047 .31841 .177 .30753 Metetra
.67 .732 .897 r
.14281 .29653 .13642 .30753 .15349 .31298 .15995 .30204 Metetra
.67 .732 .897 r
.12558 .29099 .11927 .30204 .13642 .30753 .14281 .29653 Metetra
.319 .208 .567 r
.73448 .51687 .72543 .52302 .75095 .65695 .76126 .65965 Metetra
.45 .416 .729 r
.7182 .49061 .70938 .49812 .72543 .52302 .73448 .51687 Metetra
.541 .557 .82 r
.70302 .47714 .69432 .48523 .70938 .49812 .7182 .49061 Metetra
.588 .628 .859 r
.68814 .46768 .67953 .47609 .69432 .48523 .70302 .47714 Metetra
.613 .665 .877 r
.67334 .45996 .6648 .4686 .67953 .47609 .68814 .46768 Metetra
.628 .686 .885 r
.65856 .45317 .65009 .46197 .6648 .4686 .67334 .45996 Metetra
.637 .699 .89 r
.64376 .44691 .63535 .45585 .65009 .46197 .65856 .45317 Metetra
.648 .706 .89 r
.62892 .44098 .62058 .45022 .63535 .45585 .64376 .44691 Metetra
.665 .725 .894 r
.61405 .43588 .60579 .44546 .62058 .45022 .62892 .44098 Metetra
.67 .732 .897 r
.59913 .43105 .59092 .44068 .60579 .44546 .61405 .43588 Metetra
.67 .732 .897 r
.58414 .42619 .57598 .43588 .59092 .44068 .59913 .43105 Metetra
.67 .732 .897 r
.56907 .42131 .56096 .43105 .57598 .43588 .58414 .42619 Metetra
.67 .732 .897 r
.55392 .41641 .54587 .42619 .56096 .43105 .56907 .42131 Metetra
.67 .732 .897 r
.5387 .41148 .53071 .42131 .54587 .42619 .55392 .41641 Metetra
.67 .732 .897 r
.52341 .40653 .51547 .41641 .53071 .42131 .5387 .41148 Metetra
.67 .732 .897 r
.50804 .40156 .50015 .41148 .51547 .41641 .52341 .40653 Metetra
.67 .732 .897 r
.49259 .39656 .48476 .40653 .50015 .41148 .50804 .40156 Metetra
.67 .732 .897 r
.47706 .39153 .46929 .40156 .48476 .40653 .49259 .39656 Metetra
.67 .732 .897 r
.46146 .38648 .45375 .39656 .46929 .40156 .47706 .39153 Metetra
.67 .732 .897 r
.44577 .3814 .43812 .39153 .45375 .39656 .46146 .38648 Metetra
.67 .732 .897 r
.43001 .3763 .42242 .38648 .43812 .39153 .44577 .3814 Metetra
.67 .732 .897 r
.41417 .37117 .40664 .3814 .42242 .38648 .43001 .3763 Metetra
.67 .732 .897 r
.39824 .36601 .39077 .3763 .40664 .3814 .41417 .37117 Metetra
.67 .732 .897 r
.38224 .36083 .37483 .37117 .39077 .3763 .39824 .36601 Metetra
.67 .732 .897 r
.36615 .35562 .35881 .36601 .37483 .37117 .38224 .36083 Metetra
.67 .732 .897 r
.34998 .35039 .3427 .36083 .35881 .36601 .36615 .35562 Metetra
.67 .732 .897 r
.33372 .34513 .32651 .35562 .3427 .36083 .34998 .35039 Metetra
.67 .732 .897 r
.31739 .33984 .31024 .35039 .32651 .35562 .33372 .34513 Metetra
.67 .732 .897 r
.30097 .33452 .29388 .34513 .31024 .35039 .31739 .33984 Metetra
.67 .732 .897 r
.28446 .32918 .27744 .33984 .29388 .34513 .30097 .33452 Metetra
.67 .732 .897 r
.26787 .32381 .26092 .33452 .27744 .33984 .28446 .32918 Metetra
.67 .732 .897 r
.25119 .31841 .24431 .32918 .26092 .33452 .26787 .32381 Metetra
.67 .732 .897 r
.23442 .31298 .22761 .32381 .24431 .32918 .25119 .31841 Metetra
.67 .732 .897 r
.21757 .30753 .21083 .31841 .22761 .32381 .23442 .31298 Metetra
.67 .732 .897 r
.20062 .30204 .19396 .31298 .21083 .31841 .21757 .30753 Metetra
.67 .732 .897 r
.18359 .29653 .177 .30753 .19396 .31298 .20062 .30204 Metetra
.67 .732 .897 r
.16647 .29099 .15995 .30204 .177 .30753 .18359 .29653 Metetra
.67 .732 .897 r
.14926 .28541 .14281 .29653 .15995 .30204 .16647 .29099 Metetra
.67 .732 .897 r
.13195 .27981 .12558 .29099 .14281 .29653 .14926 .28541 Metetra
.317 .205 .564 r
.74364 .51064 .73448 .51687 .76126 .65965 .77174 .66239 Metetra
.445 .407 .722 r
.72712 .48301 .7182 .49061 .73448 .51687 .74364 .51064 Metetra
.537 .549 .815 r
.71182 .46897 .70302 .47714 .7182 .49061 .72712 .48301 Metetra
.585 .623 .856 r
.69684 .45918 .68814 .46768 .70302 .47714 .71182 .46897 Metetra
.611 .662 .875 r
.68197 .45124 .67334 .45996 .68814 .46768 .69684 .45918 Metetra
.626 .684 .884 r
.66712 .44427 .65856 .45317 .67334 .45996 .68197 .45124 Metetra
.636 .697 .889 r
.65225 .43787 .64376 .44691 .65856 .45317 .66712 .44427 Metetra
.643 .706 .892 r
.63735 .43183 .62892 .44098 .64376 .44691 .65225 .43787 Metetra
.658 .713 .889 r
.6224 .42619 .61405 .43588 .62892 .44098 .63735 .43183 Metetra
.67 .732 .897 r
.60743 .42131 .59913 .43105 .61405 .43588 .6224 .42619 Metetra
.67 .732 .897 r
.59238 .41641 .58414 .42619 .59913 .43105 .60743 .42131 Metetra
.67 .732 .897 r
.57726 .41148 .56907 .42131 .58414 .42619 .59238 .41641 Metetra
.67 .732 .897 r
.56206 .40653 .55392 .41641 .56907 .42131 .57726 .41148 Metetra
.67 .732 .897 r
.54678 .40156 .5387 .41148 .55392 .41641 .56206 .40653 Metetra
.67 .732 .897 r
.53143 .39656 .52341 .40653 .5387 .41148 .54678 .40156 Metetra
.67 .732 .897 r
.516 .39153 .50804 .40156 .52341 .40653 .53143 .39656 Metetra
.67 .732 .897 r
.50049 .38648 .49259 .39656 .50804 .40156 .516 .39153 Metetra
.67 .732 .897 r
.48491 .3814 .47706 .39153 .49259 .39656 .50049 .38648 Metetra
.67 .732 .897 r
.46924 .3763 .46146 .38648 .47706 .39153 .48491 .3814 Metetra
.67 .732 .897 r
.4535 .37117 .44577 .3814 .46146 .38648 .46924 .3763 Metetra
.67 .732 .897 r
.43768 .36601 .43001 .3763 .44577 .3814 .4535 .37117 Metetra
.67 .732 .897 r
.42177 .36083 .41417 .37117 .43001 .3763 .43768 .36601 Metetra
.67 .732 .897 r
.40578 .35562 .39824 .36601 .41417 .37117 .42177 .36083 Metetra
.67 .732 .897 r
.38972 .35039 .38224 .36083 .39824 .36601 .40578 .35562 Metetra
.67 .732 .897 r
.37357 .34513 .36615 .35562 .38224 .36083 .38972 .35039 Metetra
.67 .732 .897 r
.35733 .33984 .34998 .35039 .36615 .35562 .37357 .34513 Metetra
.67 .732 .897 r
.34101 .33452 .33372 .34513 .34998 .35039 .35733 .33984 Metetra
.67 .732 .897 r
.32461 .32918 .31739 .33984 .33372 .34513 .34101 .33452 Metetra
.67 .732 .897 r
.30812 .32381 .30097 .33452 .31739 .33984 .32461 .32918 Metetra
.67 .732 .897 r
.29155 .31841 .28446 .32918 .30097 .33452 .30812 .32381 Metetra
.67 .732 .897 r
.27489 .31298 .26787 .32381 .28446 .32918 .29155 .31841 Metetra
.67 .732 .897 r
.25814 .30753 .25119 .31841 .26787 .32381 .27489 .31298 Metetra
.67 .732 .897 r
.2413 .30204 .23442 .31298 .25119 .31841 .25814 .30753 Metetra
.67 .732 .897 r
.22438 .29653 .21757 .30753 .23442 .31298 .2413 .30204 Metetra
.67 .732 .897 r
.20736 .29099 .20062 .30204 .21757 .30753 .22438 .29653 Metetra
.67 .732 .897 r
.19026 .28541 .18359 .29653 .20062 .30204 .20736 .29099 Metetra
.67 .732 .897 r
.17306 .27981 .16647 .29099 .18359 .29653 .19026 .28541 Metetra
.67 .732 .897 r
.15578 .27418 .14926 .28541 .16647 .29099 .17306 .27981 Metetra
.67 .732 .897 r
.1384 .26852 .13195 .27981 .14926 .28541 .15578 .27418 Metetra
.316 .202 .562 r
.75291 .50435 .74364 .51064 .77174 .66239 .78241 .66519 Metetra
.44 .398 .716 r
.73614 .47534 .72712 .48301 .74364 .51064 .75291 .50435 Metetra
.532 .541 .81 r
.7207 .46072 .71182 .46897 .72712 .48301 .73614 .47534 Metetra
.582 .618 .853 r
.70563 .45059 .69684 .45918 .71182 .46897 .7207 .46072 Metetra
.609 .658 .873 r
.69068 .44242 .68197 .45124 .69684 .45918 .70563 .45059 Metetra
.625 .681 .883 r
.67576 .43528 .66712 .44427 .68197 .45124 .69068 .44242 Metetra
.635 .695 .888 r
.66083 .42875 .65225 .43787 .66712 .44427 .67576 .43528 Metetra
.642 .704 .892 r
.64586 .42259 .63735 .43183 .65225 .43787 .66083 .42875 Metetra
.65 .71 .891 r
.63085 .41668 .6224 .42619 .63735 .43183 .64586 .42259 Metetra
.666 .726 .894 r
.61581 .41148 .60743 .42131 .6224 .42619 .63085 .41668 Metetra
.67 .732 .897 r
.6007 .40653 .59238 .41641 .60743 .42131 .61581 .41148 Metetra
.67 .732 .897 r
.58553 .40156 .57726 .41148 .59238 .41641 .6007 .40653 Metetra
.67 .732 .897 r
.57027 .39656 .56206 .40653 .57726 .41148 .58553 .40156 Metetra
.67 .732 .897 r
.55494 .39153 .54678 .40156 .56206 .40653 .57027 .39656 Metetra
.67 .732 .897 r
.53953 .38648 .53143 .39656 .54678 .40156 .55494 .39153 Metetra
.67 .732 .897 r
.52404 .3814 .516 .39153 .53143 .39656 .53953 .38648 Metetra
.67 .732 .897 r
.50848 .3763 .50049 .38648 .516 .39153 .52404 .3814 Metetra
.67 .732 .897 r
.49283 .37117 .48491 .3814 .50049 .38648 .50848 .3763 Metetra
.67 .732 .897 r
.47711 .36601 .46924 .3763 .48491 .3814 .49283 .37117 Metetra
.67 .732 .897 r
.46131 .36083 .4535 .37117 .46924 .3763 .47711 .36601 Metetra
.67 .732 .897 r
.44542 .35562 .43768 .36601 .4535 .37117 .46131 .36083 Metetra
.67 .732 .897 r
.42945 .35039 .42177 .36083 .43768 .36601 .44542 .35562 Metetra
.67 .732 .897 r
.41341 .34513 .40578 .35562 .42177 .36083 .42945 .35039 Metetra
.67 .732 .897 r
.39727 .33984 .38972 .35039 .40578 .35562 .41341 .34513 Metetra
.67 .732 .897 r
.38106 .33452 .37357 .34513 .38972 .35039 .39727 .33984 Metetra
.67 .732 .897 r
.36476 .32918 .35733 .33984 .37357 .34513 .38106 .33452 Metetra
.67 .732 .897 r
.34838 .32381 .34101 .33452 .35733 .33984 .36476 .32918 Metetra
.67 .732 .897 r
.33191 .31841 .32461 .32918 .34101 .33452 .34838 .32381 Metetra
.67 .732 .897 r
.31535 .31298 .30812 .32381 .32461 .32918 .33191 .31841 Metetra
.67 .732 .897 r
.29871 .30753 .29155 .31841 .30812 .32381 .31535 .31298 Metetra
.67 .732 .897 r
.28198 .30204 .27489 .31298 .29155 .31841 .29871 .30753 Metetra
.67 .732 .897 r
.26516 .29653 .25814 .30753 .27489 .31298 .28198 .30204 Metetra
.67 .732 .897 r
.24826 .29099 .2413 .30204 .25814 .30753 .26516 .29653 Metetra
.67 .732 .897 r
.23126 .28541 .22438 .29653 .2413 .30204 .24826 .29099 Metetra
.67 .732 .897 r
.21417 .27981 .20736 .29099 .22438 .29653 .23126 .28541 Metetra
.67 .732 .897 r
.197 .27418 .19026 .28541 .20736 .29099 .21417 .27981 Metetra
.67 .732 .897 r
.17973 .26852 .17306 .27981 .19026 .28541 .197 .27418 Metetra
.67 .732 .897 r
.16237 .26283 .15578 .27418 .17306 .27981 .17973 .26852 Metetra
.67 .732 .897 r
.14491 .25711 .1384 .26852 .15578 .27418 .16237 .26283 Metetra
.314 .2 .56 r
.76229 .49797 .75291 .50435 .78241 .66519 .79326 .66803 Metetra
.435 .39 .71 r
.74526 .46758 .73614 .47534 .75291 .50435 .76229 .49797 Metetra
.528 .534 .805 r
.72968 .45237 .7207 .46072 .73614 .47534 .74526 .46758 Metetra
.579 .612 .85 r
.71451 .44191 .70563 .45059 .7207 .46072 .72968 .45237 Metetra
.607 .654 .871 r
.69948 .43351 .69068 .44242 .70563 .45059 .71451 .44191 Metetra
.623 .678 .881 r
.68449 .4262 .67576 .43528 .69068 .44242 .69948 .43351 Metetra
.634 .693 .887 r
.66949 .41953 .66083 .42875 .67576 .43528 .68449 .4262 Metetra
.641 .703 .891 r
.65447 .41325 .64586 .42259 .66083 .42875 .66949 .41953 Metetra
.646 .709 .893 r
.63939 .40724 .63085 .41668 .64586 .42259 .65447 .41325 Metetra
.66 .715 .89 r
.62427 .40156 .61581 .41148 .63085 .41668 .63939 .40724 Metetra
.67 .732 .897 r
.60911 .39656 .6007 .40653 .61581 .41148 .62427 .40156 Metetra
.67 .732 .897 r
.59388 .39153 .58553 .40156 .6007 .40653 .60911 .39656 Metetra
.67 .732 .897 r
.57857 .38648 .57027 .39656 .58553 .40156 .59388 .39153 Metetra
.67 .732 .897 r
.56318 .3814 .55494 .39153 .57027 .39656 .57857 .38648 Metetra
.67 .732 .897 r
.54771 .3763 .53953 .38648 .55494 .39153 .56318 .3814 Metetra
.67 .732 .897 r
.53217 .37117 .52404 .3814 .53953 .38648 .54771 .3763 Metetra
.67 .732 .897 r
.51655 .36601 .50848 .3763 .52404 .3814 .53217 .37117 Metetra
.67 .732 .897 r
.50084 .36083 .49283 .37117 .50848 .3763 .51655 .36601 Metetra
.67 .732 .897 r
.48506 .35562 .47711 .36601 .49283 .37117 .50084 .36083 Metetra
.67 .732 .897 r
.46919 .35039 .46131 .36083 .47711 .36601 .48506 .35562 Metetra
.67 .732 .897 r
.45325 .34513 .44542 .35562 .46131 .36083 .46919 .35039 Metetra
.67 .732 .897 r
.43722 .33984 .42945 .35039 .44542 .35562 .45325 .34513 Metetra
.67 .732 .897 r
.42111 .33452 .41341 .34513 .42945 .35039 .43722 .33984 Metetra
.67 .732 .897 r
.40491 .32918 .39727 .33984 .41341 .34513 .42111 .33452 Metetra
.67 .732 .897 r
.38863 .32381 .38106 .33452 .39727 .33984 .40491 .32918 Metetra
.67 .732 .897 r
.37227 .31841 .36476 .32918 .38106 .33452 .38863 .32381 Metetra
.67 .732 .897 r
.35582 .31298 .34838 .32381 .36476 .32918 .37227 .31841 Metetra
.67 .732 .897 r
.33928 .30753 .33191 .31841 .34838 .32381 .35582 .31298 Metetra
.67 .732 .897 r
.32266 .30204 .31535 .31298 .33191 .31841 .33928 .30753 Metetra
.67 .732 .897 r
.30595 .29653 .29871 .30753 .31535 .31298 .32266 .30204 Metetra
.67 .732 .897 r
.28915 .29099 .28198 .30204 .29871 .30753 .30595 .29653 Metetra
.67 .732 .897 r
.27226 .28541 .26516 .29653 .28198 .30204 .28915 .29099 Metetra
.67 .732 .897 r
.25528 .27981 .24826 .29099 .26516 .29653 .27226 .28541 Metetra
.67 .732 .897 r
.23822 .27418 .23126 .28541 .24826 .29099 .25528 .27981 Metetra
.67 .732 .897 r
.22106 .26852 .21417 .27981 .23126 .28541 .23822 .27418 Metetra
.67 .732 .897 r
.20381 .26283 .197 .27418 .21417 .27981 .22106 .26852 Metetra
.67 .732 .897 r
.18646 .25711 .17973 .26852 .197 .27418 .20381 .26283 Metetra
.67 .732 .897 r
.16903 .25135 .16237 .26283 .17973 .26852 .18646 .25711 Metetra
.67 .732 .897 r
.15149 .24557 .14491 .25711 .16237 .26283 .16903 .25135 Metetra
.314 .2 .56 r
.77178 .49152 .76229 .49797 .79326 .66803 .80333 .66128 Metetra
.43 .383 .704 r
.75447 .45973 .74526 .46758 .76229 .49797 .77178 .49152 Metetra
.524 .527 .801 r
.73876 .44394 .72968 .45237 .74526 .46758 .75447 .45973 Metetra
.576 .607 .847 r
.72349 .43313 .71451 .44191 .72968 .45237 .73876 .44394 Metetra
.605 .65 .869 r
.70838 .42451 .69948 .43351 .71451 .44191 .72349 .43313 Metetra
.622 .676 .88 r
.69332 .41703 .68449 .4262 .69948 .43351 .70838 .42451 Metetra
.633 .691 .886 r
.67825 .41021 .66949 .41953 .68449 .4262 .69332 .41703 Metetra
.64 .701 .89 r
.66316 .40382 .65447 .41325 .66949 .41953 .67825 .41021 Metetra
.645 .708 .893 r
.64802 .3977 .63939 .40724 .65447 .41325 .66316 .40382 Metetra
.652 .712 .892 r
.63283 .39177 .62427 .40156 .63939 .40724 .64802 .3977 Metetra
.666 .726 .894 r
.61761 .38648 .60911 .39656 .62427 .40156 .63283 .39177 Metetra
.67 .732 .897 r
.60232 .3814 .59388 .39153 .60911 .39656 .61761 .38648 Metetra
.67 .732 .897 r
.58695 .3763 .57857 .38648 .59388 .39153 .60232 .3814 Metetra
.67 .732 .897 r
.5715 .37117 .56318 .3814 .57857 .38648 .58695 .3763 Metetra
.67 .732 .897 r
.55598 .36601 .54771 .3763 .56318 .3814 .5715 .37117 Metetra
.67 .732 .897 r
.54038 .36083 .53217 .37117 .54771 .3763 .55598 .36601 Metetra
.67 .732 .897 r
.5247 .35562 .51655 .36601 .53217 .37117 .54038 .36083 Metetra
.67 .732 .897 r
.50893 .35039 .50084 .36083 .51655 .36601 .5247 .35562 Metetra
.67 .732 .897 r
.49309 .34513 .48506 .35562 .50084 .36083 .50893 .35039 Metetra
.67 .732 .897 r
.47716 .33984 .46919 .35039 .48506 .35562 .49309 .34513 Metetra
.67 .732 .897 r
.46115 .33452 .45325 .34513 .46919 .35039 .47716 .33984 Metetra
.67 .732 .897 r
.44506 .32918 .43722 .33984 .45325 .34513 .46115 .33452 Metetra
.67 .732 .897 r
.42889 .32381 .42111 .33452 .43722 .33984 .44506 .32918 Metetra
.67 .732 .897 r
.41263 .31841 .40491 .32918 .42111 .33452 .42889 .32381 Metetra
.67 .732 .897 r
.39628 .31298 .38863 .32381 .40491 .32918 .41263 .31841 Metetra
.67 .732 .897 r
.37985 .30753 .37227 .31841 .38863 .32381 .39628 .31298 Metetra
.67 .732 .897 r
.36334 .30204 .35582 .31298 .37227 .31841 .37985 .30753 Metetra
.67 .732 .897 r
.34673 .29653 .33928 .30753 .35582 .31298 .36334 .30204 Metetra
.67 .732 .897 r
.33004 .29099 .32266 .30204 .33928 .30753 .34673 .29653 Metetra
.67 .732 .897 r
.31326 .28541 .30595 .29653 .32266 .30204 .33004 .29099 Metetra
.67 .732 .897 r
.29639 .27981 .28915 .29099 .30595 .29653 .31326 .28541 Metetra
.67 .732 .897 r
.27944 .27418 .27226 .28541 .28915 .29099 .29639 .27981 Metetra
.67 .732 .897 r
.26239 .26852 .25528 .27981 .27226 .28541 .27944 .27418 Metetra
.67 .732 .897 r
.24525 .26283 .23822 .27418 .25528 .27981 .26239 .26852 Metetra
.67 .732 .897 r
.22801 .25711 .22106 .26852 .23822 .27418 .24525 .26283 Metetra
.67 .732 .897 r
.21069 .25135 .20381 .26283 .22106 .26852 .22801 .25711 Metetra
.67 .732 .897 r
.19327 .24557 .18646 .25711 .20381 .26283 .21069 .25135 Metetra
.67 .732 .897 r
.17576 .23975 .16903 .25135 .18646 .25711 .19327 .24557 Metetra
.67 .732 .897 r
.15815 .23391 .15149 .24557 .16903 .25135 .17576 .23975 Metetra
.315 .201 .561 r
.78138 .48499 .77178 .49152 .80333 .66128 .81327 .6521 Metetra
.426 .376 .699 r
.76379 .4518 .75447 .45973 .77178 .49152 .78138 .48499 Metetra
.52 .52 .796 r
.74794 .43542 .73876 .44394 .75447 .45973 .76379 .4518 Metetra
.573 .602 .844 r
.73257 .42427 .72349 .43313 .73876 .44394 .74794 .43542 Metetra
.602 .647 .867 r
.71737 .41541 .70838 .42451 .72349 .43313 .73257 .42427 Metetra
.62 .673 .879 r
.70223 .40776 .69332 .41703 .70838 .42451 .71737 .41541 Metetra
.631 .689 .886 r
.6871 .4008 .67825 .41021 .69332 .41703 .70223 .40776 Metetra
.639 .699 .89 r
.67194 .39429 .66316 .40382 .67825 .41021 .6871 .4008 Metetra
.644 .707 .892 r
.65674 .38806 .64802 .3977 .66316 .40382 .67194 .39429 Metetra
.648 .712 .894 r
.64149 .38204 .63283 .39177 .64802 .3977 .65674 .38806 Metetra
.66 .717 .89 r
.62618 .3763 .61761 .38648 .63283 .39177 .64149 .38204 Metetra
.67 .732 .897 r
.61084 .37117 .60232 .3814 .61761 .38648 .62618 .3763 Metetra
.67 .732 .897 r
.59542 .36601 .58695 .3763 .60232 .3814 .61084 .37117 Metetra
.67 .732 .897 r
.57991 .36083 .5715 .37117 .58695 .3763 .59542 .36601 Metetra
.67 .732 .897 r
.56433 .35562 .55598 .36601 .5715 .37117 .57991 .36083 Metetra
.67 .732 .897 r
.54867 .35039 .54038 .36083 .55598 .36601 .56433 .35562 Metetra
.67 .732 .897 r
.53293 .34513 .5247 .35562 .54038 .36083 .54867 .35039 Metetra
.67 .732 .897 r
.51711 .33984 .50893 .35039 .5247 .35562 .53293 .34513 Metetra
.67 .732 .897 r
.5012 .33452 .49309 .34513 .50893 .35039 .51711 .33984 Metetra
.67 .732 .897 r
.48521 .32918 .47716 .33984 .49309 .34513 .5012 .33452 Metetra
.67 .732 .897 r
.46914 .32381 .46115 .33452 .47716 .33984 .48521 .32918 Metetra
.67 .732 .897 r
.45299 .31841 .44506 .32918 .46115 .33452 .46914 .32381 Metetra
.67 .732 .897 r
.43675 .31298 .42889 .32381 .44506 .32918 .45299 .31841 Metetra
.67 .732 .897 r
.42042 .30753 .41263 .31841 .42889 .32381 .43675 .31298 Metetra
.67 .732 .897 r
.40401 .30204 .39628 .31298 .41263 .31841 .42042 .30753 Metetra
.67 .732 .897 r
.38752 .29653 .37985 .30753 .39628 .31298 .40401 .30204 Metetra
.67 .732 .897 r
.37093 .29099 .36334 .30204 .37985 .30753 .38752 .29653 Metetra
.67 .732 .897 r
.35426 .28541 .34673 .29653 .36334 .30204 .37093 .29099 Metetra
.67 .732 .897 r
.3375 .27981 .33004 .29099 .34673 .29653 .35426 .28541 Metetra
.67 .732 .897 r
.32065 .27418 .31326 .28541 .33004 .29099 .3375 .27981 Metetra
.67 .732 .897 r
.30372 .26852 .29639 .27981 .31326 .28541 .32065 .27418 Metetra
.67 .732 .897 r
.28669 .26283 .27944 .27418 .29639 .27981 .30372 .26852 Metetra
.67 .732 .897 r
.26957 .25711 .26239 .26852 .27944 .27418 .28669 .26283 Metetra
.67 .732 .897 r
.25235 .25135 .24525 .26283 .26239 .26852 .26957 .25711 Metetra
.67 .732 .897 r
.23505 .24557 .22801 .25711 .24525 .26283 .25235 .25135 Metetra
.67 .732 .897 r
.21765 .23975 .21069 .25135 .22801 .25711 .23505 .24557 Metetra
.67 .732 .897 r
.20015 .23391 .19327 .24557 .21069 .25135 .21765 .23975 Metetra
.67 .732 .897 r
.18256 .22803 .17576 .23975 .19327 .24557 .20015 .23391 Metetra
.67 .732 .897 r
.16488 .22212 .15815 .23391 .17576 .23975 .18256 .22803 Metetra
.316 .202 .562 r
.79111 .47838 .78138 .48499 .81327 .6521 .82332 .64283 Metetra
.422 .369 .694 r
.77322 .44378 .76379 .4518 .78138 .48499 .79111 .47838 Metetra
.516 .514 .792 r
.75721 .4268 .74794 .43542 .76379 .4518 .77322 .44378 Metetra
.57 .597 .841 r
.74174 .41531 .73257 .42427 .74794 .43542 .75721 .4268 Metetra
.6 .643 .865 r
.72646 .40622 .71737 .41541 .73257 .42427 .74174 .41531 Metetra
.619 .67 .877 r
.71124 .39839 .70223 .40776 .71737 .41541 .72646 .40622 Metetra
.63 .687 .885 r
.69604 .39129 .6871 .4008 .70223 .40776 .71124 .39839 Metetra
.638 .698 .889 r
.68082 .38466 .67194 .39429 .6871 .4008 .69604 .39129 Metetra
.644 .705 .892 r
.66555 .37833 .65674 .38806 .67194 .39429 .68082 .38466 Metetra
.648 .711 .893 r
.65024 .37221 .64149 .38204 .65674 .38806 .66555 .37833 Metetra
.654 .714 .892 r
.63486 .36623 .62618 .3763 .64149 .38204 .65024 .37221 Metetra
.666 .727 .895 r
.61945 .36083 .61084 .37117 .62618 .3763 .63486 .36623 Metetra
.67 .732 .897 r
.60397 .35562 .59542 .36601 .61084 .37117 .61945 .36083 Metetra
.67 .732 .897 r
.58841 .35039 .57991 .36083 .59542 .36601 .60397 .35562 Metetra
.67 .732 .897 r
.57277 .34513 .56433 .35562 .57991 .36083 .58841 .35039 Metetra
.67 .732 .897 r
.55705 .33984 .54867 .35039 .56433 .35562 .57277 .34513 Metetra
.67 .732 .897 r
.54125 .33452 .53293 .34513 .54867 .35039 .55705 .33984 Metetra
.67 .732 .897 r
.52536 .32918 .51711 .33984 .53293 .34513 .54125 .33452 Metetra
.67 .732 .897 r
.5094 .32381 .5012 .33452 .51711 .33984 .52536 .32918 Metetra
.67 .732 .897 r
.49335 .31841 .48521 .32918 .5012 .33452 .5094 .32381 Metetra
.67 .732 .897 r
.47721 .31298 .46914 .32381 .48521 .32918 .49335 .31841 Metetra
.67 .732 .897 r
.461 .30753 .45299 .31841 .46914 .32381 .47721 .31298 Metetra
.67 .732 .897 r
.44469 .30204 .43675 .31298 .45299 .31841 .461 .30753 Metetra
.67 .732 .897 r
.4283 .29653 .42042 .30753 .43675 .31298 .44469 .30204 Metetra
.67 .732 .897 r
.41183 .29099 .40401 .30204 .42042 .30753 .4283 .29653 Metetra
.67 .732 .897 r
.39526 .28541 .38752 .29653 .40401 .30204 .41183 .29099 Metetra
.67 .732 .897 r
.37861 .27981 .37093 .29099 .38752 .29653 .39526 .28541 Metetra
.67 .732 .897 r
.36187 .27418 .35426 .28541 .37093 .29099 .37861 .27981 Metetra
.67 .732 .897 r
.34505 .26852 .3375 .27981 .35426 .28541 .36187 .27418 Metetra
.67 .732 .897 r
.32813 .26283 .32065 .27418 .3375 .27981 .34505 .26852 Metetra
.67 .732 .897 r
.31112 .25711 .30372 .26852 .32065 .27418 .32813 .26283 Metetra
.67 .732 .897 r
.29402 .25135 .28669 .26283 .30372 .26852 .31112 .25711 Metetra
.67 .732 .897 r
.27682 .24557 .26957 .25711 .28669 .26283 .29402 .25135 Metetra
.67 .732 .897 r
.25954 .23975 .25235 .25135 .26957 .25711 .27682 .24557 Metetra
.67 .732 .897 r
.24215 .23391 .23505 .24557 .25235 .25135 .25954 .23975 Metetra
.67 .732 .897 r
.22468 .22803 .21765 .23975 .23505 .24557 .24215 .23391 Metetra
.67 .732 .897 r
.20711 .22212 .20015 .23391 .21765 .23975 .22468 .22803 Metetra
.67 .732 .897 r
.18944 .21617 .18256 .22803 .20015 .23391 .20711 .22212 Metetra
.67 .732 .897 r
.17168 .2102 .16488 .22212 .18256 .22803 .18944 .21617 Metetra
.316 .203 .562 r
.80095 .47169 .79111 .47838 .82332 .64283 .83348 .63345 Metetra
.418 .363 .689 r
.78275 .43566 .77322 .44378 .79111 .47838 .80095 .47169 Metetra
.512 .507 .788 r
.76659 .41809 .75721 .4268 .77322 .44378 .78275 .43566 Metetra
.567 .592 .838 r
.75101 .40625 .74174 .41531 .75721 .4268 .76659 .41809 Metetra
.598 .64 .863 r
.73564 .39693 .72646 .40622 .74174 .41531 .75101 .40625 Metetra
.617 .668 .876 r
.72035 .38892 .71124 .39839 .72646 .40622 .73564 .39693 Metetra
.629 .685 .884 r
.70508 .38168 .69604 .39129 .71124 .39839 .72035 .38892 Metetra
.637 .696 .888 r
.68978 .37492 .68082 .38466 .69604 .39129 .70508 .38168 Metetra
.643 .704 .891 r
.67445 .36849 .66555 .37833 .68082 .38466 .68978 .37492 Metetra
.647 .71 .893 r
.65908 .36227 .65024 .37221 .66555 .37833 .67445 .36849 Metetra
.651 .714 .894 r
.64364 .35621 .63486 .36623 .65024 .37221 .65908 .36227 Metetra
.661 .718 .891 r
.62815 .35039 .61945 .36083 .63486 .36623 .64364 .35621 Metetra
.67 .732 .897 r
.61261 .34513 .60397 .35562 .61945 .36083 .62815 .35039 Metetra
.67 .732 .897 r
.59699 .33984 .58841 .35039 .60397 .35562 .61261 .34513 Metetra
.67 .732 .897 r
.58129 .33452 .57277 .34513 .58841 .35039 .59699 .33984 Metetra
.67 .732 .897 r
.56551 .32918 .55705 .33984 .57277 .34513 .58129 .33452 Metetra
.67 .732 .897 r
.54965 .32381 .54125 .33452 .55705 .33984 .56551 .32918 Metetra
.67 .732 .897 r
.53371 .31841 .52536 .32918 .54125 .33452 .54965 .32381 Metetra
.67 .732 .897 r
.51768 .31298 .5094 .32381 .52536 .32918 .53371 .31841 Metetra
.67 .732 .897 r
.50157 .30753 .49335 .31841 .5094 .32381 .51768 .31298 Metetra
.67 .732 .897 r
.48537 .30204 .47721 .31298 .49335 .31841 .50157 .30753 Metetra
.67 .732 .897 r
.46909 .29653 .461 .30753 .47721 .31298 .48537 .30204 Metetra
.67 .732 .897 r
.45272 .29099 .44469 .30204 .461 .30753 .46909 .29653 Metetra
.67 .732 .897 r
.43627 .28541 .4283 .29653 .44469 .30204 .45272 .29099 Metetra
.67 .732 .897 r
.41972 .27981 .41183 .29099 .4283 .29653 .43627 .28541 Metetra
.67 .732 .897 r
.40309 .27418 .39526 .28541 .41183 .29099 .41972 .27981 Metetra
.67 .732 .897 r
.38638 .26852 .37861 .27981 .39526 .28541 .40309 .27418 Metetra
.67 .732 .897 r
.36957 .26283 .36187 .27418 .37861 .27981 .38638 .26852 Metetra
.67 .732 .897 r
.35267 .25711 .34505 .26852 .36187 .27418 .36957 .26283 Metetra
.67 .732 .897 r
.33568 .25135 .32813 .26283 .34505 .26852 .35267 .25711 Metetra
.67 .732 .897 r
.3186 .24557 .31112 .25711 .32813 .26283 .33568 .25135 Metetra
.67 .732 .897 r
.30142 .23975 .29402 .25135 .31112 .25711 .3186 .24557 Metetra
.67 .732 .897 r
.28416 .23391 .27682 .24557 .29402 .25135 .30142 .23975 Metetra
.67 .732 .897 r
.2668 .22803 .25954 .23975 .27682 .24557 .28416 .23391 Metetra
.67 .732 .897 r
.24934 .22212 .24215 .23391 .25954 .23975 .2668 .22803 Metetra
.67 .732 .897 r
.23179 .21617 .22468 .22803 .24215 .23391 .24934 .22212 Metetra
.67 .732 .897 r
.21414 .2102 .20711 .22212 .22468 .22803 .23179 .21617 Metetra
.67 .732 .897 r
.1964 .20419 .18944 .21617 .20711 .22212 .21414 .2102 Metetra
.67 .732 .897 r
.17856 .19815 .17168 .2102 .18944 .21617 .1964 .20419 Metetra
.317 .204 .563 r
.81091 .46492 .80095 .47169 .83348 .63345 .84375 .62398 Metetra
.415 .357 .684 r
.79239 .42746 .78275 .43566 .80095 .47169 .81091 .46492 Metetra
.508 .501 .784 r
.77607 .40928 .76659 .41809 .78275 .43566 .79239 .42746 Metetra
.564 .587 .835 r
.76038 .3971 .75101 .40625 .76659 .41809 .77607 .40928 Metetra
.596 .636 .861 r
.74492 .38753 .73564 .39693 .75101 .40625 .76038 .3971 Metetra
.616 .665 .875 r
.72955 .37935 .72035 .38892 .73564 .39693 .74492 .38753 Metetra
.628 .683 .883 r
.71421 .37197 .70508 .38168 .72035 .38892 .72955 .37935 Metetra
.636 .695 .887 r
.69885 .36509 .68978 .37492 .70508 .38168 .71421 .37197 Metetra
.642 .703 .89 r
.68345 .35854 .67445 .36849 .68978 .37492 .69885 .36509 Metetra
.647 .709 .893 r
.66801 .35223 .65908 .36227 .67445 .36849 .68345 .35854 Metetra
.65 .713 .894 r
.65251 .34608 .64364 .35621 .65908 .36227 .66801 .35223 Metetra
.655 .716 .893 r
.63695 .34004 .62815 .35039 .64364 .35621 .65251 .34608 Metetra
.667 .727 .895 r
.62134 .33452 .61261 .34513 .62815 .35039 .63695 .34004 Metetra
.67 .732 .897 r
.60566 .32918 .59699 .33984 .61261 .34513 .62134 .33452 Metetra
.67 .732 .897 r
.58991 .32381 .58129 .33452 .59699 .33984 .60566 .32918 Metetra
.67 .732 .897 r
.57407 .31841 .56551 .32918 .58129 .33452 .58991 .32381 Metetra
.67 .732 .897 r
.55814 .31298 .54965 .32381 .56551 .32918 .57407 .31841 Metetra
.67 .732 .897 r
.54214 .30753 .53371 .31841 .54965 .32381 .55814 .31298 Metetra
.67 .732 .897 r
.52605 .30204 .51768 .31298 .53371 .31841 .54214 .30753 Metetra
.67 .732 .897 r
.50987 .29653 .50157 .30753 .51768 .31298 .52605 .30204 Metetra
.67 .732 .897 r
.49361 .29099 .48537 .30204 .50157 .30753 .50987 .29653 Metetra
.67 .732 .897 r
.47727 .28541 .46909 .29653 .48537 .30204 .49361 .29099 Metetra
.67 .732 .897 r
.46083 .27981 .45272 .29099 .46909 .29653 .47727 .28541 Metetra
.67 .732 .897 r
.44431 .27418 .43627 .28541 .45272 .29099 .46083 .27981 Metetra
.67 .732 .897 r
.4277 .26852 .41972 .27981 .43627 .28541 .44431 .27418 Metetra
.67 .732 .897 r
.41101 .26283 .40309 .27418 .41972 .27981 .4277 .26852 Metetra
.67 .732 .897 r
.39422 .25711 .38638 .26852 .40309 .27418 .41101 .26283 Metetra
.67 .732 .897 r
.37734 .25135 .36957 .26283 .38638 .26852 .39422 .25711 Metetra
.67 .732 .897 r
.36037 .24557 .35267 .25711 .36957 .26283 .37734 .25135 Metetra
.67 .732 .897 r
.34331 .23975 .33568 .25135 .35267 .25711 .36037 .24557 Metetra
.67 .732 .897 r
.32616 .23391 .3186 .24557 .33568 .25135 .34331 .23975 Metetra
.67 .732 .897 r
.30891 .22803 .30142 .23975 .3186 .24557 .32616 .23391 Metetra
.67 .732 .897 r
.29157 .22212 .28416 .23391 .30142 .23975 .30891 .22803 Metetra
.67 .732 .897 r
.27414 .21617 .2668 .22803 .28416 .23391 .29157 .22212 Metetra
.67 .732 .897 r
.25661 .2102 .24934 .22212 .2668 .22803 .27414 .21617 Metetra
.67 .732 .897 r
.23898 .20419 .23179 .21617 .24934 .22212 .25661 .2102 Metetra
.67 .732 .897 r
.22125 .19815 .21414 .2102 .23179 .21617 .23898 .20419 Metetra
.67 .732 .897 r
.20343 .19207 .1964 .20419 .21414 .2102 .22125 .19815 Metetra
.67 .732 .897 r
.18551 .18596 .17856 .19815 .1964 .20419 .20343 .19207 Metetra
.318 .205 .564 r
.821 .45806 .81091 .46492 .84375 .62398 .85412 .6144 Metetra
.411 .351 .68 r
.80214 .41916 .79239 .42746 .81091 .46492 .821 .45806 Metetra
.504 .495 .78 r
.78565 .40037 .77607 .40928 .79239 .42746 .80214 .41916 Metetra
.561 .582 .832 r
.76985 .38784 .76038 .3971 .77607 .40928 .78565 .40037 Metetra
.594 .633 .859 r
.7543 .37804 .74492 .38753 .76038 .3971 .76985 .38784 Metetra
.614 .662 .873 r
.73885 .36968 .72955 .37935 .74492 .38753 .7543 .37804 Metetra
.627 .681 .882 r
.72343 .36215 .71421 .37197 .72955 .37935 .73885 .36968 Metetra
.635 .693 .887 r
.70801 .35515 .69885 .36509 .71421 .37197 .72343 .36215 Metetra
.642 .702 .89 r
.69254 .3485 .68345 .35854 .69885 .36509 .70801 .35515 Metetra
.646 .708 .892 r
.67704 .34208 .66801 .35223 .68345 .35854 .69254 .3485 Metetra
.65 .712 .894 r
.66147 .33584 .65251 .34608 .66801 .35223 .67704 .34208 Metetra
.652 .716 .895 r
.64585 .32972 .63695 .34004 .65251 .34608 .66147 .33584 Metetra
.662 .72 .892 r
.63016 .32381 .62134 .33452 .63695 .34004 .64585 .32972 Metetra
.67 .732 .897 r
.61443 .31841 .60566 .32918 .62134 .33452 .63016 .32381 Metetra
.67 .732 .897 r
.59861 .31298 .58991 .32381 .60566 .32918 .61443 .31841 Metetra
.67 .732 .897 r
.58271 .30753 .57407 .31841 .58991 .32381 .59861 .31298 Metetra
.67 .732 .897 r
.56673 .30204 .55814 .31298 .57407 .31841 .58271 .30753 Metetra
.67 .732 .897 r
.55066 .29653 .54214 .30753 .55814 .31298 .56673 .30204 Metetra
.67 .732 .897 r
.53451 .29099 .52605 .30204 .54214 .30753 .55066 .29653 Metetra
.67 .732 .897 r
.51827 .28541 .50987 .29653 .52605 .30204 .53451 .29099 Metetra
.67 .732 .897 r
.50194 .27981 .49361 .29099 .50987 .29653 .51827 .28541 Metetra
.67 .732 .897 r
.48553 .27418 .47727 .28541 .49361 .29099 .50194 .27981 Metetra
.67 .732 .897 r
.46903 .26852 .46083 .27981 .47727 .28541 .48553 .27418 Metetra
.67 .732 .897 r
.45245 .26283 .44431 .27418 .46083 .27981 .46903 .26852 Metetra
.67 .732 .897 r
.43577 .25711 .4277 .26852 .44431 .27418 .45245 .26283 Metetra
.67 .732 .897 r
.41901 .25135 .41101 .26283 .4277 .26852 .43577 .25711 Metetra
.67 .732 .897 r
.40215 .24557 .39422 .25711 .41101 .26283 .41901 .25135 Metetra
.67 .732 .897 r
.3852 .23975 .37734 .25135 .39422 .25711 .40215 .24557 Metetra
.67 .732 .897 r
.36816 .23391 .36037 .24557 .37734 .25135 .3852 .23975 Metetra
.67 .732 .897 r
.35103 .22803 .34331 .23975 .36037 .24557 .36816 .23391 Metetra
.67 .732 .897 r
.3338 .22212 .32616 .23391 .34331 .23975 .35103 .22803 Metetra
.67 .732 .897 r
.31648 .21617 .30891 .22803 .32616 .23391 .3338 .22212 Metetra
.67 .732 .897 r
.29907 .2102 .29157 .22212 .30891 .22803 .31648 .21617 Metetra
.67 .732 .897 r
.28156 .20419 .27414 .21617 .29157 .22212 .29907 .2102 Metetra
.67 .732 .897 r
.26395 .19815 .25661 .2102 .27414 .21617 .28156 .20419 Metetra
.67 .732 .897 r
.24625 .19207 .23898 .20419 .25661 .2102 .26395 .19815 Metetra
.67 .732 .897 r
.22844 .18596 .22125 .19815 .23898 .20419 .24625 .19207 Metetra
.67 .732 .897 r
.21054 .17982 .20343 .19207 .22125 .19815 .22844 .18596 Metetra
.67 .732 .897 r
.19254 .17364 .18551 .18596 .20343 .19207 .21054 .17982 Metetra
.318 .206 .566 r
.83121 .45112 .821 .45806 .85412 .6144 .86461 .60472 Metetra
.408 .346 .676 r
.812 .41076 .80214 .41916 .821 .45806 .83121 .45112 Metetra
.501 .489 .776 r
.79534 .39137 .78565 .40037 .80214 .41916 .812 .41076 Metetra
.558 .578 .83 r
.77942 .37849 .76985 .38784 .78565 .40037 .79534 .39137 Metetra
.592 .629 .857 r
.76378 .36845 .7543 .37804 .76985 .38784 .77942 .37849 Metetra
.613 .66 .872 r
.74825 .3599 .73885 .36968 .7543 .37804 .76378 .36845 Metetra
.626 .679 .881 r
.73276 .35223 .72343 .36215 .73885 .36968 .74825 .3599 Metetra
.635 .692 .886 r
.71726 .3451 .70801 .35515 .72343 .36215 .73276 .35223 Metetra
.641 .701 .889 r
.70173 .33834 .69254 .3485 .70801 .35515 .71726 .3451 Metetra
.646 .707 .892 r
.68616 .33183 .67704 .34208 .69254 .3485 .70173 .33834 Metetra
.649 .711 .893 r
.67053 .32549 .66147 .33584 .67704 .34208 .68616 .33183 Metetra
.652 .715 .894 r
.65484 .31929 .64585 .32972 .66147 .33584 .67053 .32549 Metetra
.656 .717 .893 r
.63909 .31317 .63016 .32381 .64585 .32972 .65484 .31929 Metetra
.667 .728 .895 r
.62328 .30753 .61443 .31841 .63016 .32381 .63909 .31317 Metetra
.67 .732 .897 r
.60741 .30204 .59861 .31298 .61443 .31841 .62328 .30753 Metetra
.67 .732 .897 r
.59144 .29653 .58271 .30753 .59861 .31298 .60741 .30204 Metetra
.67 .732 .897 r
.5754 .29099 .56673 .30204 .58271 .30753 .59144 .29653 Metetra
.67 .732 .897 r
.55927 .28541 .55066 .29653 .56673 .30204 .5754 .29099 Metetra
.67 .732 .897 r
.54305 .27981 .53451 .29099 .55066 .29653 .55927 .28541 Metetra
.67 .732 .897 r
.52675 .27418 .51827 .28541 .53451 .29099 .54305 .27981 Metetra
.67 .732 .897 r
.51036 .26852 .50194 .27981 .51827 .28541 .52675 .27418 Metetra
.67 .732 .897 r
.49389 .26283 .48553 .27418 .50194 .27981 .51036 .26852 Metetra
.67 .732 .897 r
.47732 .25711 .46903 .26852 .48553 .27418 .49389 .26283 Metetra
.67 .732 .897 r
.46067 .25135 .45245 .26283 .46903 .26852 .47732 .25711 Metetra
.67 .732 .897 r
.44392 .24557 .43577 .25711 .45245 .26283 .46067 .25135 Metetra
.67 .732 .897 r
.42709 .23975 .41901 .25135 .43577 .25711 .44392 .24557 Metetra
.67 .732 .897 r
.41016 .23391 .40215 .24557 .41901 .25135 .42709 .23975 Metetra
.67 .732 .897 r
.39315 .22803 .3852 .23975 .40215 .24557 .41016 .23391 Metetra
.67 .732 .897 r
.37604 .22212 .36816 .23391 .3852 .23975 .39315 .22803 Metetra
.67 .732 .897 r
.35883 .21617 .35103 .22803 .36816 .23391 .37604 .22212 Metetra
.67 .732 .897 r
.34153 .2102 .3338 .22212 .35103 .22803 .35883 .21617 Metetra
.67 .732 .897 r
.32414 .20419 .31648 .21617 .3338 .22212 .34153 .2102 Metetra
.67 .732 .897 r
.30665 .19815 .29907 .2102 .31648 .21617 .32414 .20419 Metetra
.67 .732 .897 r
.28906 .19207 .28156 .20419 .29907 .2102 .30665 .19815 Metetra
.67 .732 .897 r
.27138 .18596 .26395 .19815 .28156 .20419 .28906 .19207 Metetra
.67 .732 .897 r
.25359 .17982 .24625 .19207 .26395 .19815 .27138 .18596 Metetra
.67 .732 .897 r
.23571 .17364 .22844 .18596 .24625 .19207 .25359 .17982 Metetra
.67 .732 .897 r
.21773 .16743 .21054 .17982 .22844 .18596 .23571 .17364 Metetra
.67 .732 .897 r
.19965 .16118 .19254 .17364 .21054 .17982 .21773 .16743 Metetra
.319 .208 .567 r
.84155 .4441 .83121 .45112 .86461 .60472 .87521 .59493 Metetra
.405 .341 .672 r
.82198 .40227 .812 .41076 .83121 .45112 .84155 .4441 Metetra
.497 .483 .772 r
.80514 .38227 .79534 .39137 .812 .41076 .82198 .40227 Metetra
.556 .573 .827 r
.7891 .36903 .77942 .37849 .79534 .39137 .80514 .38227 Metetra
.59 .626 .855 r
.77337 .35875 .76378 .36845 .77942 .37849 .7891 .36903 Metetra
.611 .657 .871 r
.75776 .35002 .74825 .3599 .76378 .36845 .77337 .35875 Metetra
.625 .677 .88 r
.74219 .3422 .73276 .35223 .74825 .3599 .75776 .35002 Metetra
.634 .69 .885 r
.72662 .33495 .71726 .3451 .73276 .35223 .74219 .3422 Metetra
.64 .699 .889 r
.71102 .32808 .70173 .33834 .71726 .3451 .72662 .33495 Metetra
.645 .706 .891 r
.69538 .32146 .68616 .33183 .70173 .33834 .71102 .32808 Metetra
.649 .711 .893 r
.67969 .31504 .67053 .32549 .68616 .33183 .69538 .32146 Metetra
.651 .714 .894 r
.66393 .30874 .65484 .31929 .67053 .32549 .67969 .31504 Metetra
.654 .717 .895 r
.64811 .30254 .63909 .31317 .65484 .31929 .66393 .30874 Metetra
.662 .721 .892 r
.63223 .29653 .62328 .30753 .63909 .31317 .64811 .30254 Metetra
.67 .732 .897 r
.61629 .29099 .60741 .30204 .62328 .30753 .63223 .29653 Metetra
.67 .732 .897 r
.60027 .28541 .59144 .29653 .60741 .30204 .61629 .29099 Metetra
.67 .732 .897 r
.58416 .27981 .5754 .29099 .59144 .29653 .60027 .28541 Metetra
.67 .732 .897 r
.56797 .27418 .55927 .28541 .5754 .29099 .58416 .27981 Metetra
.67 .732 .897 r
.55169 .26852 .54305 .27981 .55927 .28541 .56797 .27418 Metetra
.67 .732 .897 r
.53533 .26283 .52675 .27418 .54305 .27981 .55169 .26852 Metetra
.67 .732 .897 r
.51887 .25711 .51036 .26852 .52675 .27418 .53533 .26283 Metetra
.67 .732 .897 r
.50233 .25135 .49389 .26283 .51036 .26852 .51887 .25711 Metetra
.67 .732 .897 r
.4857 .24557 .47732 .25711 .49389 .26283 .50233 .25135 Metetra
.67 .732 .897 r
.46898 .23975 .46067 .25135 .47732 .25711 .4857 .24557 Metetra
.67 .732 .897 r
.45217 .23391 .44392 .24557 .46067 .25135 .46898 .23975 Metetra
.67 .732 .897 r
.43526 .22803 .42709 .23975 .44392 .24557 .45217 .23391 Metetra
.67 .732 .897 r
.41827 .22212 .41016 .23391 .42709 .23975 .43526 .22803 Metetra
.67 .732 .897 r
.40118 .21617 .39315 .22803 .41016 .23391 .41827 .22212 Metetra
.67 .732 .897 r
.38399 .2102 .37604 .22212 .39315 .22803 .40118 .21617 Metetra
.67 .732 .897 r
.36672 .20419 .35883 .21617 .37604 .22212 .38399 .2102 Metetra
.67 .732 .897 r
.34935 .19815 .34153 .2102 .35883 .21617 .36672 .20419 Metetra
.67 .732 .897 r
.33188 .19207 .32414 .20419 .34153 .2102 .34935 .19815 Metetra
.67 .732 .897 r
.31431 .18596 .30665 .19815 .32414 .20419 .33188 .19207 Metetra
.67 .732 .897 r
.29665 .17982 .28906 .19207 .30665 .19815 .31431 .18596 Metetra
.67 .732 .897 r
.27889 .17364 .27138 .18596 .28906 .19207 .29665 .17982 Metetra
.67 .732 .897 r
.26103 .16743 .25359 .17982 .27138 .18596 .27889 .17364 Metetra
.67 .732 .897 r
.24306 .16118 .23571 .17364 .25359 .17982 .26103 .16743 Metetra
.67 .732 .897 r
.225 .1549 .21773 .16743 .23571 .17364 .24306 .16118 Metetra
.67 .732 .897 r
.20684 .14859 .19965 .16118 .21773 .16743 .225 .1549 Metetra
.32 .209 .568 r
.85202 .43698 .84155 .4441 .87521 .59493 .88594 .58503 Metetra
.402 .336 .668 r
.83207 .39368 .82198 .40227 .84155 .4441 .85202 .43698 Metetra
.494 .478 .768 r
.81505 .37306 .80514 .38227 .82198 .40227 .83207 .39368 Metetra
.553 .569 .824 r
.79889 .35947 .7891 .36903 .80514 .38227 .81505 .37306 Metetra
.588 .622 .853 r
.78306 .34895 .77337 .35875 .7891 .36903 .79889 .35947 Metetra
.61 .655 .869 r
.76736 .34003 .75776 .35002 .77337 .35875 .78306 .34895 Metetra
.623 .675 .879 r
.75172 .33206 .74219 .3422 .75776 .35002 .76736 .34003 Metetra
.633 .689 .885 r
.73608 .32469 .72662 .33495 .74219 .3422 .75172 .33206 Metetra
.639 .698 .888 r
.72041 .3177 .71102 .32808 .72662 .33495 .73608 .32469 Metetra
.644 .705 .891 r
.7047 .31099 .69538 .32146 .71102 .32808 .72041 .3177 Metetra
.648 .71 .892 r
.68894 .30447 .67969 .31504 .69538 .32146 .7047 .31099 Metetra
.651 .714 .894 r
.67312 .29808 .66393 .30874 .67969 .31504 .68894 .30447 Metetra
.653 .716 .895 r
.65724 .2918 .64811 .30254 .66393 .30874 .67312 .29808 Metetra
.657 .718 .893 r
.64128 .28559 .63223 .29653 .64811 .30254 .65724 .2918 Metetra
.667 .728 .895 r
.62527 .27981 .61629 .29099 .63223 .29653 .64128 .28559 Metetra
.67 .732 .897 r
.60919 .27418 .60027 .28541 .61629 .29099 .62527 .27981 Metetra
.67 .732 .897 r
.59302 .26852 .58416 .27981 .60027 .28541 .60919 .27418 Metetra
.67 .732 .897 r
.57677 .26283 .56797 .27418 .58416 .27981 .59302 .26852 Metetra
.67 .732 .897 r
.56043 .25711 .55169 .26852 .56797 .27418 .57677 .26283 Metetra
.67 .732 .897 r
.54399 .25135 .53533 .26283 .55169 .26852 .56043 .25711 Metetra
.67 .732 .897 r
.52748 .24557 .51887 .25711 .53533 .26283 .54399 .25135 Metetra
.67 .732 .897 r
.51087 .23975 .50233 .25135 .51887 .25711 .52748 .24557 Metetra
.67 .732 .897 r
.49417 .23391 .4857 .24557 .50233 .25135 .51087 .23975 Metetra
.67 .732 .897 r
.47738 .22803 .46898 .23975 .4857 .24557 .49417 .23391 Metetra
.67 .732 .897 r
.4605 .22212 .45217 .23391 .46898 .23975 .47738 .22803 Metetra
.67 .732 .897 r
.44352 .21617 .43526 .22803 .45217 .23391 .4605 .22212 Metetra
.67 .732 .897 r
.42646 .2102 .41827 .22212 .43526 .22803 .44352 .21617 Metetra
.67 .732 .897 r
.4093 .20419 .40118 .21617 .41827 .22212 .42646 .2102 Metetra
.67 .732 .897 r
.39204 .19815 .38399 .2102 .40118 .21617 .4093 .20419 Metetra
.67 .732 .897 r
.37469 .19207 .36672 .20419 .38399 .2102 .39204 .19815 Metetra
.67 .732 .897 r
.35725 .18596 .34935 .19815 .36672 .20419 .37469 .19207 Metetra
.67 .732 .897 r
.3397 .17982 .33188 .19207 .34935 .19815 .35725 .18596 Metetra
.67 .732 .897 r
.32206 .17364 .31431 .18596 .33188 .19207 .3397 .17982 Metetra
.67 .732 .897 r
.30432 .16743 .29665 .17982 .31431 .18596 .32206 .17364 Metetra
.67 .732 .897 r
.28648 .16118 .27889 .17364 .29665 .17982 .30432 .16743 Metetra
.67 .732 .897 r
.26854 .1549 .26103 .16743 .27889 .17364 .28648 .16118 Metetra
.67 .732 .897 r
.2505 .14859 .24306 .16118 .26103 .16743 .26854 .1549 Metetra
.67 .732 .897 r
.23236 .14223 .225 .1549 .24306 .16118 .2505 .14859 Metetra
.67 .732 .897 r
.21411 .13584 .20684 .14859 .225 .1549 .23236 .14223 Metetra
.32 .21 .569 r
.86262 .42977 .85202 .43698 .88594 .58503 .89677 .57503 Metetra
.399 .331 .665 r
.84228 .38499 .83207 .39368 .85202 .43698 .86262 .42977 Metetra
.491 .472 .764 r
.82507 .36375 .81505 .37306 .83207 .39368 .84228 .38499 Metetra
.55 .564 .821 r
.80878 .3498 .79889 .35947 .81505 .37306 .82507 .36375 Metetra
.586 .619 .852 r
.79285 .33903 .78306 .34895 .79889 .35947 .80878 .3498 Metetra
.608 .652 .868 r
.77707 .32994 .76736 .34003 .78306 .34895 .79285 .33903 Metetra
.622 .673 .878 r
.76135 .32182 .75172 .33206 .76736 .34003 .77707 .32994 Metetra
.632 .687 .884 r
.74564 .31431 .73608 .32469 .75172 .33206 .76135 .32182 Metetra
.639 .697 .888 r
.7299 .30721 .72041 .3177 .73608 .32469 .74564 .31431 Metetra
.644 .704 .89 r
.71412 .3004 .7047 .31099 .72041 .3177 .7299 .30721 Metetra
.648 .709 .892 r
.6983 .29378 .68894 .30447 .7047 .31099 .71412 .3004 Metetra
.651 .713 .893 r
.68241 .28731 .67312 .29808 .68894 .30447 .6983 .29378 Metetra
.653 .716 .894 r
.66646 .28094 .65724 .2918 .67312 .29808 .68241 .28731 Metetra
.655 .718 .895 r
.65044 .27465 .64128 .28559 .65724 .2918 .66646 .28094 Metetra
.663 .721 .892 r
.63435 .26852 .62527 .27981 .64128 .28559 .65044 .27465 Metetra
.67 .732 .897 r
.61821 .26283 .60919 .27418 .62527 .27981 .63435 .26852 Metetra
.67 .732 .897 r
.60198 .25711 .59302 .26852 .60919 .27418 .61821 .26283 Metetra
.67 .732 .897 r
.58566 .25135 .57677 .26283 .59302 .26852 .60198 .25711 Metetra
.67 .732 .897 r
.56925 .24557 .56043 .25711 .57677 .26283 .58566 .25135 Metetra
.67 .732 .897 r
.55276 .23975 .54399 .25135 .56043 .25711 .56925 .24557 Metetra
.67 .732 .897 r
.53617 .23391 .52748 .24557 .54399 .25135 .55276 .23975 Metetra
.67 .732 .897 r
.5195 .22803 .51087 .23975 .52748 .24557 .53617 .23391 Metetra
.67 .732 .897 r
.50273 .22212 .49417 .23391 .51087 .23975 .5195 .22803 Metetra
.67 .732 .897 r
.48587 .21617 .47738 .22803 .49417 .23391 .50273 .22212 Metetra
.67 .732 .897 r
.46892 .2102 .4605 .22212 .47738 .22803 .48587 .21617 Metetra
.67 .732 .897 r
.45188 .20419 .44352 .21617 .4605 .22212 .46892 .2102 Metetra
.67 .732 .897 r
.43474 .19815 .42646 .2102 .44352 .21617 .45188 .20419 Metetra
.67 .732 .897 r
.41751 .19207 .4093 .20419 .42646 .2102 .43474 .19815 Metetra
.67 .732 .897 r
.40018 .18596 .39204 .19815 .4093 .20419 .41751 .19207 Metetra
.67 .732 .897 r
.38276 .17982 .37469 .19207 .39204 .19815 .40018 .18596 Metetra
.67 .732 .897 r
.36523 .17364 .35725 .18596 .37469 .19207 .38276 .17982 Metetra
.67 .732 .897 r
.34761 .16743 .3397 .17982 .35725 .18596 .36523 .17364 Metetra
.67 .732 .897 r
.3299 .16118 .32206 .17364 .3397 .17982 .34761 .16743 Metetra
.67 .732 .897 r
.31208 .1549 .30432 .16743 .32206 .17364 .3299 .16118 Metetra
.67 .732 .897 r
.29416 .14859 .28648 .16118 .30432 .16743 .31208 .1549 Metetra
.67 .732 .897 r
.27614 .14223 .26854 .1549 .28648 .16118 .29416 .14859 Metetra
.67 .732 .897 r
.25802 .13584 .2505 .14859 .26854 .1549 .27614 .14223 Metetra
.67 .732 .897 r
.23979 .12942 .23236 .14223 .2505 .14859 .25802 .13584 Metetra
.67 .732 .897 r
.22146 .12296 .21411 .13584 .23236 .14223 .23979 .12942 Metetra
.321 .212 .57 r
.87336 .42247 .86262 .42977 .89677 .57503 .90773 .56491 Metetra
.396 .327 .661 r
.85261 .3762 .84228 .38499 .86262 .42977 .87336 .42247 Metetra
.487 .467 .761 r
.83521 .35433 .82507 .36375 .84228 .38499 .85261 .3762 Metetra
.548 .56 .819 r
.81879 .34002 .80878 .3498 .82507 .36375 .83521 .35433 Metetra
.584 .616 .85 r
.80276 .32901 .79285 .33903 .80878 .3498 .81879 .34002 Metetra
.607 .65 .867 r
.78689 .31973 .77707 .32994 .79285 .33903 .80276 .32901 Metetra
.621 .671 .877 r
.77109 .31146 .76135 .32182 .77707 .32994 .78689 .31973 Metetra
.631 .686 .883 r
.7553 .30382 .74564 .31431 .76135 .32182 .77109 .31146 Metetra
.638 .696 .887 r
.73949 .29661 .7299 .30721 .74564 .31431 .7553 .30382 Metetra
.643 .703 .89 r
.72365 .28969 .71412 .3004 .7299 .30721 .73949 .29661 Metetra
.647 .708 .892 r
.70776 .28298 .6983 .29378 .71412 .3004 .72365 .28969 Metetra
.65 .712 .893 r
.6918 .27642 .68241 .28731 .6983 .29378 .70776 .28298 Metetra
.653 .715 .894 r
.67579 .26996 .66646 .28094 .68241 .28731 .6918 .27642 Metetra
.655 .718 .895 r
.6597 .26359 .65044 .27465 .66646 .28094 .67579 .26996 Metetra
.658 .719 .894 r
.64354 .25727 .63435 .26852 .65044 .27465 .6597 .26359 Metetra
.667 .728 .895 r
.62732 .25135 .61821 .26283 .63435 .26852 .64354 .25727 Metetra
.67 .732 .897 r
.61103 .24557 .60198 .25711 .61821 .26283 .62732 .25135 Metetra
.67 .732 .897 r
.59464 .23975 .58566 .25135 .60198 .25711 .61103 .24557 Metetra
.67 .732 .897 r
.57817 .23391 .56925 .24557 .58566 .25135 .59464 .23975 Metetra
.67 .732 .897 r
.56161 .22803 .55276 .23975 .56925 .24557 .57817 .23391 Metetra
.67 .732 .897 r
.54496 .22212 .53617 .23391 .55276 .23975 .56161 .22803 Metetra
.67 .732 .897 r
.52822 .21617 .5195 .22803 .53617 .23391 .54496 .22212 Metetra
.67 .732 .897 r
.51138 .2102 .50273 .22212 .5195 .22803 .52822 .21617 Metetra
.67 .732 .897 r
.49446 .20419 .48587 .21617 .50273 .22212 .51138 .2102 Metetra
.67 .732 .897 r
.47744 .19815 .46892 .2102 .48587 .21617 .49446 .20419 Metetra
.67 .732 .897 r
.46032 .19207 .45188 .20419 .46892 .2102 .47744 .19815 Metetra
.67 .732 .897 r
.44311 .18596 .43474 .19815 .45188 .20419 .46032 .19207 Metetra
.67 .732 .897 r
.42581 .17982 .41751 .19207 .43474 .19815 .44311 .18596 Metetra
.67 .732 .897 r
.40841 .17364 .40018 .18596 .41751 .19207 .42581 .17982 Metetra
.67 .732 .897 r
.39091 .16743 .38276 .17982 .40018 .18596 .40841 .17364 Metetra
.67 .732 .897 r
.37331 .16118 .36523 .17364 .38276 .17982 .39091 .16743 Metetra
.67 .732 .897 r
.35562 .1549 .34761 .16743 .36523 .17364 .37331 .16118 Metetra
.67 .732 .897 r
.33782 .14859 .3299 .16118 .34761 .16743 .35562 .1549 Metetra
.67 .732 .897 r
.31992 .14223 .31208 .1549 .3299 .16118 .33782 .14859 Metetra
.67 .732 .897 r
.30193 .13584 .29416 .14859 .31208 .1549 .31992 .14223 Metetra
.67 .732 .897 r
.28383 .12942 .27614 .14223 .29416 .14859 .30193 .13584 Metetra
.67 .732 .897 r
.26562 .12296 .25802 .13584 .27614 .14223 .28383 .12942 Metetra
.67 .732 .897 r
.24731 .11646 .23979 .12942 .25802 .13584 .26562 .12296 Metetra
.67 .732 .897 r
.2289 .10992 .22146 .12296 .23979 .12942 .24731 .11646 Metetra
.322 .213 .571 r
.88423 .41508 .87336 .42247 .90773 .56491 .91882 .55468 Metetra
.393 .322 .658 r
.86306 .3673 .85261 .3762 .87336 .42247 .88423 .41508 Metetra
.484 .462 .757 r
.84546 .34481 .83521 .35433 .85261 .3762 .86306 .3673 Metetra
.545 .556 .816 r
.82891 .33013 .81879 .34002 .83521 .35433 .84546 .34481 Metetra
.582 .612 .848 r
.81277 .31888 .80276 .32901 .81879 .34002 .82891 .33013 Metetra
.605 .647 .866 r
.79682 .30941 .78689 .31973 .80276 .32901 .81277 .31888 Metetra
.62 .669 .876 r
.78093 .30098 .77109 .31146 .78689 .31973 .79682 .30941 Metetra
.63 .684 .882 r
.76507 .29322 .7553 .30382 .77109 .31146 .78093 .30098 Metetra
.637 .695 .887 r
.74919 .28589 .73949 .29661 .7553 .30382 .76507 .29322 Metetra
.643 .702 .889 r
.73328 .27887 .72365 .28969 .73949 .29661 .74919 .28589 Metetra
.647 .707 .891 r
.71732 .27206 .70776 .28298 .72365 .28969 .73328 .27887 Metetra
.65 .712 .893 r
.7013 .26541 .6918 .27642 .70776 .28298 .71732 .27206 Metetra
.652 .715 .894 r
.68521 .25887 .67579 .26996 .6918 .27642 .7013 .26541 Metetra
.654 .717 .895 r
.66906 .25241 .6597 .26359 .67579 .26996 .68521 .25887 Metetra
.656 .719 .895 r
.65283 .24601 .64354 .25727 .6597 .26359 .66906 .25241 Metetra
.663 .722 .893 r
.63653 .23975 .62732 .25135 .64354 .25727 .65283 .24601 Metetra
.67 .732 .897 r
.62018 .23391 .61103 .24557 .62732 .25135 .63653 .23975 Metetra
.67 .732 .897 r
.60373 .22803 .59464 .23975 .61103 .24557 .62018 .23391 Metetra
.67 .732 .897 r
.58719 .22212 .57817 .23391 .59464 .23975 .60373 .22803 Metetra
.67 .732 .897 r
.57057 .21617 .56161 .22803 .57817 .23391 .58719 .22212 Metetra
.67 .732 .897 r
.55385 .2102 .54496 .22212 .56161 .22803 .57057 .21617 Metetra
.67 .732 .897 r
.53704 .20419 .52822 .21617 .54496 .22212 .55385 .2102 Metetra
.67 .732 .897 r
.52013 .19815 .51138 .2102 .52822 .21617 .53704 .20419 Metetra
.67 .732 .897 r
.50314 .19207 .49446 .20419 .51138 .2102 .52013 .19815 Metetra
.67 .732 .897 r
.48605 .18596 .47744 .19815 .49446 .20419 .50314 .19207 Metetra
.67 .732 .897 r
.46886 .17982 .46032 .19207 .47744 .19815 .48605 .18596 Metetra
.67 .732 .897 r
.45158 .17364 .44311 .18596 .46032 .19207 .46886 .17982 Metetra
.67 .732 .897 r
.4342 .16743 .42581 .17982 .44311 .18596 .45158 .17364 Metetra
.67 .732 .897 r
.41673 .16118 .40841 .17364 .42581 .17982 .4342 .16743 Metetra
.67 .732 .897 r
.39915 .1549 .39091 .16743 .40841 .17364 .41673 .16118 Metetra
.67 .732 .897 r
.38148 .14859 .37331 .16118 .39091 .16743 .39915 .1549 Metetra
.67 .732 .897 r
.36371 .14223 .35562 .1549 .37331 .16118 .38148 .14859 Metetra
.67 .732 .897 r
.34583 .13584 .33782 .14859 .35562 .1549 .36371 .14223 Metetra
.67 .732 .897 r
.32786 .12942 .31992 .14223 .33782 .14859 .34583 .13584 Metetra
.67 .732 .897 r
.30978 .12296 .30193 .13584 .31992 .14223 .32786 .12942 Metetra
.67 .732 .897 r
.2916 .11646 .28383 .12942 .30193 .13584 .30978 .12296 Metetra
.67 .732 .897 r
.27331 .10992 .26562 .12296 .28383 .12942 .2916 .11646 Metetra
.67 .732 .897 r
.25492 .10335 .24731 .11646 .26562 .12296 .27331 .10992 Metetra
.67 .732 .897 r
.23643 .09674 .2289 .10992 .24731 .11646 .25492 .10335 Metetra
.323 .215 .573 r
.89525 .40759 .88423 .41508 .91882 .55468 .93002 .54434 Metetra
.391 .318 .655 r
.87364 .3583 .86306 .3673 .88423 .41508 .89525 .40759 Metetra
.481 .457 .754 r
.85583 .33518 .84546 .34481 .86306 .3673 .87364 .3583 Metetra
.543 .551 .813 r
.83914 .32014 .82891 .33013 .84546 .34481 .85583 .33518 Metetra
.58 .609 .846 r
.8229 .30863 .81277 .31888 .82891 .33013 .83914 .32014 Metetra
.604 .645 .864 r
.80685 .29897 .79682 .30941 .81277 .31888 .8229 .30863 Metetra
.619 .668 .875 r
.79089 .2904 .78093 .30098 .79682 .30941 .80685 .29897 Metetra
.629 .683 .882 r
.77495 .2825 .76507 .29322 .78093 .30098 .79089 .2904 Metetra
.637 .693 .886 r
.759 .27506 .74919 .28589 .76507 .29322 .77495 .2825 Metetra
.642 .701 .889 r
.74301 .26793 .73328 .27887 .74919 .28589 .759 .27506 Metetra
.646 .707 .891 r
.72698 .26102 .71732 .27206 .73328 .27887 .74301 .26793 Metetra
.649 .711 .893 r
.71089 .25427 .7013 .26541 .71732 .27206 .72698 .26102 Metetra
.652 .714 .894 r
.69474 .24764 .68521 .25887 .7013 .26541 .71089 .25427 Metetra
.654 .717 .894 r
.67852 .2411 .66906 .25241 .68521 .25887 .69474 .24764 Metetra
.656 .719 .895 r
.66223 .23462 .65283 .24601 .66906 .25241 .67852 .2411 Metetra
.659 .72 .894 r
.64585 .22818 .63653 .23975 .65283 .24601 .66223 .23462 Metetra
.667 .729 .895 r
.62942 .22212 .62018 .23391 .63653 .23975 .64585 .22818 Metetra
.67 .732 .897 r
.61291 .21617 .60373 .22803 .62018 .23391 .62942 .22212 Metetra
.67 .732 .897 r
.59631 .2102 .58719 .22212 .60373 .22803 .61291 .21617 Metetra
.67 .732 .897 r
.57962 .20419 .57057 .21617 .58719 .22212 .59631 .2102 Metetra
.67 .732 .897 r
.56283 .19815 .55385 .2102 .57057 .21617 .57962 .20419 Metetra
.67 .732 .897 r
.54595 .19207 .53704 .20419 .55385 .2102 .56283 .19815 Metetra
.67 .732 .897 r
.52898 .18596 .52013 .19815 .53704 .20419 .54595 .19207 Metetra
.67 .732 .897 r
.51192 .17982 .50314 .19207 .52013 .19815 .52898 .18596 Metetra
.67 .732 .897 r
.49475 .17364 .48605 .18596 .50314 .19207 .51192 .17982 Metetra
.67 .732 .897 r
.4775 .16743 .46886 .17982 .48605 .18596 .49475 .17364 Metetra
.67 .732 .897 r
.46014 .16118 .45158 .17364 .46886 .17982 .4775 .16743 Metetra
.67 .732 .897 r
.44269 .1549 .4342 .16743 .45158 .17364 .46014 .16118 Metetra
.67 .732 .897 r
.42514 .14859 .41673 .16118 .4342 .16743 .44269 .1549 Metetra
.67 .732 .897 r
.40749 .14223 .39915 .1549 .41673 .16118 .42514 .14859 Metetra
.67 .732 .897 r
.38974 .13584 .38148 .14859 .39915 .1549 .40749 .14223 Metetra
.67 .732 .897 r
.37189 .12942 .36371 .14223 .38148 .14859 .38974 .13584 Metetra
.67 .732 .897 r
.35394 .12296 .34583 .13584 .36371 .14223 .37189 .12942 Metetra
.67 .732 .897 r
.33588 .11646 .32786 .12942 .34583 .13584 .35394 .12296 Metetra
.67 .732 .897 r
.31773 .10992 .30978 .12296 .32786 .12942 .33588 .11646 Metetra
.67 .732 .897 r
.29946 .10335 .2916 .11646 .30978 .12296 .31773 .10992 Metetra
.67 .732 .897 r
.28109 .09674 .27331 .10992 .2916 .11646 .29946 .10335 Metetra
.67 .732 .897 r
.26262 .09009 .25492 .10335 .27331 .10992 .28109 .09674 Metetra
.67 .732 .897 r
.24404 .0834 .23643 .09674 .25492 .10335 .26262 .09009 Metetra
.324 .216 .574 r
.90641 .40001 .89525 .40759 .93002 .54434 .94136 .53388 Metetra
.388 .314 .652 r
.88434 .34919 .87364 .3583 .89525 .40759 .90641 .40001 Metetra
.478 .452 .751 r
.86632 .32543 .85583 .33518 .87364 .3583 .88434 .34919 Metetra
.54 .547 .811 r
.84949 .31003 .83914 .32014 .85583 .33518 .86632 .32543 Metetra
.578 .606 .844 r
.83314 .29827 .8229 .30863 .83914 .32014 .84949 .31003 Metetra
.602 .642 .863 r
.817 .28842 .80685 .29897 .8229 .30863 .83314 .29827 Metetra
.618 .666 .874 r
.80095 .27969 .79089 .2904 .80685 .29897 .817 .28842 Metetra
.628 .681 .881 r
.78494 .27166 .77495 .2825 .79089 .2904 .80095 .27969 Metetra
.636 .692 .885 r
.76891 .2641 .759 .27506 .77495 .2825 .78494 .27166 Metetra
.641 .7 .889 r
.75286 .25687 .74301 .26793 .759 .27506 .76891 .2641 Metetra
.646 .706 .891 r
.73675 .24986 .72698 .26102 .74301 .26793 .75286 .25687 Metetra
.649 .71 .892 r
.7206 .24302 .71089 .25427 .72698 .26102 .73675 .24986 Metetra
.651 .714 .893 r
.70438 .2363 .69474 .24764 .71089 .25427 .7206 .24302 Metetra
.654 .716 .894 r
.68809 .22967 .67852 .2411 .69474 .24764 .70438 .2363 Metetra
.655 .718 .895 r
.67173 .2231 .66223 .23462 .67852 .2411 .68809 .22967 Metetra
.657 .72 .895 r
.65529 .21659 .64585 .22818 .66223 .23462 .67173 .2231 Metetra
.664 .723 .893 r
.63877 .2102 .62942 .22212 .64585 .22818 .65529 .21659 Metetra
.67 .732 .897 r
.6222 .20419 .61291 .21617 .62942 .22212 .63877 .2102 Metetra
.67 .732 .897 r
.60553 .19815 .59631 .2102 .61291 .21617 .6222 .20419 Metetra
.67 .732 .897 r
.58877 .19207 .57962 .20419 .59631 .2102 .60553 .19815 Metetra
.67 .732 .897 r
.57192 .18596 .56283 .19815 .57962 .20419 .58877 .19207 Metetra
.67 .732 .897 r
.55497 .17982 .54595 .19207 .56283 .19815 .57192 .18596 Metetra
.67 .732 .897 r
.53793 .17364 .52898 .18596 .54595 .19207 .55497 .17982 Metetra
.67 .732 .897 r
.52079 .16743 .51192 .17982 .52898 .18596 .53793 .17364 Metetra
.67 .732 .897 r
.50356 .16118 .49475 .17364 .51192 .17982 .52079 .16743 Metetra
.67 .732 .897 r
.48623 .1549 .4775 .16743 .49475 .17364 .50356 .16118 Metetra
.67 .732 .897 r
.4688 .14859 .46014 .16118 .4775 .16743 .48623 .1549 Metetra
.67 .732 .897 r
.45128 .14223 .44269 .1549 .46014 .16118 .4688 .14859 Metetra
.67 .732 .897 r
.43365 .13584 .42514 .14859 .44269 .1549 .45128 .14223 Metetra
.67 .732 .897 r
.41592 .12942 .40749 .14223 .42514 .14859 .43365 .13584 Metetra
.67 .732 .897 r
.3981 .12296 .38974 .13584 .40749 .14223 .41592 .12942 Metetra
.67 .732 .897 r
.38017 .11646 .37189 .12942 .38974 .13584 .3981 .12296 Metetra
.67 .732 .897 r
.36214 .10992 .35394 .12296 .37189 .12942 .38017 .11646 Metetra
.67 .732 .897 r
.344 .10335 .33588 .11646 .35394 .12296 .36214 .10992 Metetra
.67 .732 .897 r
.32576 .09674 .31773 .10992 .33588 .11646 .344 .10335 Metetra
.67 .732 .897 r
.30742 .09009 .29946 .10335 .31773 .10992 .32576 .09674 Metetra
.67 .732 .897 r
.28897 .0834 .28109 .09674 .29946 .10335 .30742 .09009 Metetra
.67 .732 .897 r
.27041 .07667 .26262 .09009 .28109 .09674 .28897 .0834 Metetra
.67 .732 .897 r
.25174 .0699 .24404 .0834 .26262 .09009 .27041 .07667 Metetra
.325 .218 .576 r
.91772 .39232 .90641 .40001 .94136 .53388 .95282 .5233 Metetra
.386 .311 .649 r
.89517 .33997 .88434 .34919 .90641 .40001 .91772 .39232 Metetra
.475 .448 .747 r
.87693 .31557 .86632 .32543 .88434 .34919 .89517 .33997 Metetra
.538 .543 .808 r
.85995 .2998 .84949 .31003 .86632 .32543 .87693 .31557 Metetra
.576 .603 .842 r
.84349 .28779 .83314 .29827 .84949 .31003 .85995 .2998 Metetra
.601 .64 .862 r
.82726 .27775 .817 .28842 .83314 .29827 .84349 .28779 Metetra
.617 .664 .873 r
.81113 .26886 .80095 .27969 .817 .28842 .82726 .27775 Metetra
.627 .68 .88 r
.79504 .2607 .78494 .27166 .80095 .27969 .81113 .26886 Metetra
.635 .691 .885 r
.77894 .25302 .76891 .2641 .78494 .27166 .79504 .2607 Metetra
.641 .699 .888 r
.76281 .24568 .75286 .25687 .76891 .2641 .77894 .25302 Metetra
.645 .705 .89 r
.74664 .23857 .73675 .24986 .75286 .25687 .76281 .24568 Metetra
.648 .709 .892 r
.73041 .23164 .7206 .24302 .73675 .24986 .74664 .23857 Metetra
.651 .713 .893 r
.71412 .22483 .70438 .2363 .7206 .24302 .73041 .23164 Metetra
.653 .716 .894 r
.69776 .21811 .68809 .22967 .70438 .2363 .71412 .22483 Metetra
.655 .718 .895 r
.68133 .21146 .67173 .2231 .68809 .22967 .69776 .21811 Metetra
.657 .72 .895 r
.66482 .20486 .65529 .21659 .67173 .2231 .68133 .21146 Metetra
.659 .721 .894 r
.64824 .19829 .63877 .2102 .65529 .21659 .66482 .20486 Metetra
.668 .729 .895 r
.63158 .19207 .6222 .20419 .63877 .2102 .64824 .19829 Metetra
.67 .732 .897 r
.61485 .18596 .60553 .19815 .6222 .20419 .63158 .19207 Metetra
.67 .732 .897 r
.59802 .17982 .58877 .19207 .60553 .19815 .61485 .18596 Metetra
.67 .732 .897 r
.5811 .17364 .57192 .18596 .58877 .19207 .59802 .17982 Metetra
.67 .732 .897 r
.56409 .16743 .55497 .17982 .57192 .18596 .5811 .17364 Metetra
.67 .732 .897 r
.54697 .16118 .53793 .17364 .55497 .17982 .56409 .16743 Metetra
.67 .732 .897 r
.52977 .1549 .52079 .16743 .53793 .17364 .54697 .16118 Metetra
.67 .732 .897 r
.51246 .14859 .50356 .16118 .52079 .16743 .52977 .1549 Metetra
.67 .732 .897 r
.49506 .14223 .48623 .1549 .50356 .16118 .51246 .14859 Metetra
.67 .732 .897 r
.47756 .13584 .4688 .14859 .48623 .1549 .49506 .14223 Metetra
.67 .732 .897 r
.45996 .12942 .45128 .14223 .4688 .14859 .47756 .13584 Metetra
.67 .732 .897 r
.44226 .12296 .43365 .13584 .45128 .14223 .45996 .12942 Metetra
.67 .732 .897 r
.42445 .11646 .41592 .12942 .43365 .13584 .44226 .12296 Metetra
.67 .732 .897 r
.40655 .10992 .3981 .12296 .41592 .12942 .42445 .11646 Metetra
.67 .732 .897 r
.38854 .10335 .38017 .11646 .3981 .12296 .40655 .10992 Metetra
.67 .732 .897 r
.37043 .09674 .36214 .10992 .38017 .11646 .38854 .10335 Metetra
.67 .732 .897 r
.35221 .09009 .344 .10335 .36214 .10992 .37043 .09674 Metetra
.67 .732 .897 r
.33389 .0834 .32576 .09674 .344 .10335 .35221 .09009 Metetra
.67 .732 .897 r
.31546 .07667 .30742 .09009 .32576 .09674 .33389 .0834 Metetra
.67 .732 .897 r
.29693 .0699 .28897 .0834 .30742 .09009 .31546 .07667 Metetra
.67 .732 .897 r
.27828 .0631 .27041 .07667 .28897 .0834 .29693 .0699 Metetra
.67 .732 .897 r
.25953 .05625 .25174 .0699 .27041 .07667 .27828 .0631 Metetra
.326 .22 .577 r
.92917 .38454 .91772 .39232 .95282 .5233 .96441 .5126 Metetra
.384 .307 .646 r
.90614 .33064 .89517 .33997 .91772 .39232 .92917 .38454 Metetra
.473 .443 .744 r
.88766 .3056 .87693 .31557 .89517 .33997 .90614 .33064 Metetra
.535 .539 .806 r
.87054 .28945 .85995 .2998 .87693 .31557 .88766 .3056 Metetra
.574 .6 .841 r
.85397 .27719 .84349 .28779 .85995 .2998 .87054 .28945 Metetra
.599 .637 .86 r
.83764 .26696 .82726 .27775 .84349 .28779 .85397 .27719 Metetra
.615 .662 .872 r
.82142 .25792 .81113 .26886 .82726 .27775 .83764 .26696 Metetra
.627 .678 .879 r
.80525 .24962 .79504 .2607 .81113 .26886 .82142 .25792 Metetra
.634 .69 .884 r
.78907 .24182 .77894 .25302 .79504 .2607 .80525 .24962 Metetra
.64 .698 .888 r
.77287 .23437 .76281 .24568 .77894 .25302 .78907 .24182 Metetra
.645 .704 .89 r
.75663 .22716 .74664 .23857 .76281 .24568 .77287 .23437 Metetra
.648 .709 .892 r
.74033 .22013 .73041 .23164 .74664 .23857 .75663 .22716 Metetra
.651 .712 .893 r
.72397 .21323 .71412 .22483 .73041 .23164 .74033 .22013 Metetra
.653 .715 .894 r
.70754 .20642 .69776 .21811 .71412 .22483 .72397 .21323 Metetra
.655 .718 .895 r
.69104 .19969 .68133 .21146 .69776 .21811 .70754 .20642 Metetra
.656 .719 .895 r
.67447 .193 .66482 .20486 .68133 .21146 .69104 .19969 Metetra
.658 .721 .896 r
.65781 .18635 .64824 .19829 .66482 .20486 .67447 .193 Metetra
.664 .723 .893 r
.64108 .17982 .63158 .19207 .64824 .19829 .65781 .18635 Metetra
.67 .732 .897 r
.62427 .17364 .61485 .18596 .63158 .19207 .64108 .17982 Metetra
.67 .732 .897 r
.60738 .16743 .59802 .17982 .61485 .18596 .62427 .17364 Metetra
.67 .732 .897 r
.59039 .16118 .5811 .17364 .59802 .17982 .60738 .16743 Metetra
.67 .732 .897 r
.5733 .1549 .56409 .16743 .5811 .17364 .59039 .16118 Metetra
.67 .732 .897 r
.55612 .14859 .54697 .16118 .56409 .16743 .5733 .1549 Metetra
.67 .732 .897 r
.53884 .14223 .52977 .1549 .54697 .16118 .55612 .14859 Metetra
.67 .732 .897 r
.52147 .13584 .51246 .14859 .52977 .1549 .53884 .14223 Metetra
.67 .732 .897 r
.50399 .12942 .49506 .14223 .51246 .14859 .52147 .13584 Metetra
.67 .732 .897 r
.48641 .12296 .47756 .13584 .49506 .14223 .50399 .12942 Metetra
.67 .732 .897 r
.46874 .11646 .45996 .12942 .47756 .13584 .48641 .12296 Metetra
.67 .732 .897 r
.45096 .10992 .44226 .12296 .45996 .12942 .46874 .11646 Metetra
.67 .732 .897 r
.43308 .10335 .42445 .11646 .44226 .12296 .45096 .10992 Metetra
.67 .732 .897 r
.4151 .09674 .40655 .10992 .42445 .11646 .43308 .10335 Metetra
.67 .732 .897 r
.39701 .09009 .38854 .10335 .40655 .10992 .4151 .09674 Metetra
.67 .732 .897 r
.37882 .0834 .37043 .09674 .38854 .10335 .39701 .09009 Metetra
.67 .732 .897 r
.36052 .07667 .35221 .09009 .37043 .09674 .37882 .0834 Metetra
.67 .732 .897 r
.34212 .0699 .33389 .0834 .35221 .09009 .36052 .07667 Metetra
.67 .732 .897 r
.32361 .0631 .31546 .07667 .33389 .0834 .34212 .0699 Metetra
.67 .732 .897 r
.30498 .05625 .29693 .0699 .31546 .07667 .32361 .0631 Metetra
.67 .732 .897 r
.28625 .04937 .27828 .0631 .29693 .0699 .30498 .05625 Metetra
.67 .732 .897 r
.26741 .04244 .25953 .05625 .27828 .0631 .28625 .04937 Metetra
.327 .222 .579 r
.94078 .37665 .92917 .38454 .96441 .5126 .97614 .50178 Metetra
.382 .304 .643 r
.91723 .32119 .90614 .33064 .92917 .38454 .94078 .37665 Metetra
.47 .439 .741 r
.89852 .29551 .88766 .3056 .90614 .33064 .91723 .32119 Metetra
.533 .535 .803 r
.88125 .27899 .87054 .28945 .88766 .3056 .89852 .29551 Metetra
.573 .597 .839 r
.86456 .26647 .85397 .27719 .87054 .28945 .88125 .27899 Metetra
.598 .635 .859 r
.84813 .25605 .83764 .26696 .85397 .27719 .86456 .26647 Metetra
.614 .66 .871 r
.83183 .24684 .82142 .25792 .83764 .26696 .84813 .25605 Metetra
.626 .677 .879 r
.81557 .23841 .80525 .24962 .82142 .25792 .83183 .24684 Metetra
.634 .689 .884 r
.79932 .23049 .78907 .24182 .80525 .24962 .81557 .23841 Metetra
.64 .697 .887 r
.78305 .22293 .77287 .23437 .78907 .24182 .79932 .23049 Metetra
.644 .703 .89 r
.76673 .21562 .75663 .22716 .77287 .23437 .78305 .22293 Metetra
.648 .708 .891 r
.75036 .20849 .74033 .22013 .75663 .22716 .76673 .21562 Metetra
.65 .712 .893 r
.73394 .2015 .72397 .21323 .74033 .22013 .75036 .20849 Metetra
.653 .715 .894 r
.71744 .1946 .70754 .20642 .72397 .21323 .73394 .2015 Metetra
.655 .717 .894 r
.70087 .18778 .69104 .19969 .70754 .20642 .71744 .1946 Metetra
.656 .719 .895 r
.68422 .18101 .67447 .193 .69104 .19969 .70087 .18778 Metetra
.657 .721 .895 r
.66749 .17428 .65781 .18635 .67447 .193 .68422 .18101 Metetra
.66 .722 .894 r
.65068 .16757 .64108 .17982 .65781 .18635 .66749 .17428 Metetra
.668 .729 .895 r
.6338 .16118 .62427 .17364 .64108 .17982 .65068 .16757 Metetra
.67 .732 .897 r
.61684 .1549 .60738 .16743 .62427 .17364 .6338 .16118 Metetra
.67 .732 .897 r
.59978 .14859 .59039 .16118 .60738 .16743 .61684 .1549 Metetra
.67 .732 .897 r
.58263 .14223 .5733 .1549 .59039 .16118 .59978 .14859 Metetra
.67 .732 .897 r
.56537 .13584 .55612 .14859 .5733 .1549 .58263 .14223 Metetra
.67 .732 .897 r
.54802 .12942 .53884 .14223 .55612 .14859 .56537 .13584 Metetra
.67 .732 .897 r
.53057 .12296 .52147 .13584 .53884 .14223 .54802 .12942 Metetra
.67 .732 .897 r
.51302 .11646 .50399 .12942 .52147 .13584 .53057 .12296 Metetra
.67 .732 .897 r
.49537 .10992 .48641 .12296 .50399 .12942 .51302 .11646 Metetra
.67 .732 .897 r
.47762 .10335 .46874 .11646 .48641 .12296 .49537 .10992 Metetra
.67 .732 .897 r
.45977 .09674 .45096 .10992 .46874 .11646 .47762 .10335 Metetra
.67 .732 .897 r
.44181 .09009 .43308 .10335 .45096 .10992 .45977 .09674 Metetra
.67 .732 .897 r
.42375 .0834 .4151 .09674 .43308 .10335 .44181 .09009 Metetra
.67 .732 .897 r
.40558 .07667 .39701 .09009 .4151 .09674 .42375 .0834 Metetra
.67 .732 .897 r
.38731 .0699 .37882 .0834 .39701 .09009 .40558 .07667 Metetra
.67 .732 .897 r
.36893 .0631 .36052 .07667 .37882 .0834 .38731 .0699 Metetra
.67 .732 .897 r
.35044 .05625 .34212 .0699 .36052 .07667 .36893 .0631 Metetra
.67 .732 .897 r
.33184 .04937 .32361 .0631 .34212 .0699 .35044 .05625 Metetra
.67 .732 .897 r
.31314 .04244 .30498 .05625 .32361 .0631 .33184 .04937 Metetra
.67 .732 .897 r
.29432 .03547 .28625 .04937 .30498 .05625 .31314 .04244 Metetra
.67 .732 .897 r
.27539 .02846 .26741 .04244 .28625 .04937 .29432 .03547 Metetra
.328 .224 .581 r
.95255 .36865 .94078 .37665 .97614 .50178 .988 .49083 Metetra
.38 .3 .641 r
.92847 .31163 .91723 .32119 .94078 .37665 .95255 .36865 Metetra
.467 .434 .738 r
.90951 .2853 .89852 .29551 .91723 .32119 .92847 .31163 Metetra
.53 .531 .801 r
.89208 .26841 .88125 .27899 .89852 .29551 .90951 .2853 Metetra
.571 .593 .837 r
.87527 .25563 .86456 .26647 .88125 .27899 .89208 .26841 Metetra
.596 .633 .858 r
.85875 .24501 .84813 .25605 .86456 .26647 .87527 .25563 Metetra
.613 .658 .87 r
.84236 .23565 .83183 .24684 .84813 .25605 .85875 .24501 Metetra
.625 .675 .878 r
.82602 .22708 .81557 .23841 .83183 .24684 .84236 .23565 Metetra
.633 .687 .883 r
.80969 .21904 .79932 .23049 .81557 .23841 .82602 .22708 Metetra
.639 .696 .887 r
.79334 .21136 .78305 .22293 .79932 .23049 .80969 .21904 Metetra
.644 .703 .889 r
.77695 .20395 .76673 .21562 .78305 .22293 .79334 .21136 Metetra
.647 .707 .891 r
.76051 .19672 .75036 .20849 .76673 .21562 .77695 .20395 Metetra
.65 .711 .892 r
.74401 .18963 .73394 .2015 .75036 .20849 .76051 .19672 Metetra
.652 .714 .893 r
.72744 .18265 .71744 .1946 .73394 .2015 .74401 .18963 Metetra
.654 .717 .894 r
.7108 .17574 .70087 .18778 .71744 .1946 .72744 .18265 Metetra
.656 .719 .895 r
.69408 .16888 .68422 .18101 .70087 .18778 .7108 .17574 Metetra
.657 .72 .895 r
.67729 .16206 .66749 .17428 .68422 .18101 .69408 .16888 Metetra
.658 .722 .896 r
.6604 .15527 .65068 .16757 .66749 .17428 .67729 .16206 Metetra
.664 .724 .893 r
.64344 .14859 .6338 .16118 .65068 .16757 .6604 .15527 Metetra
.67 .732 .897 r
.62641 .14223 .61684 .1549 .6338 .16118 .64344 .14859 Metetra
.67 .732 .897 r
.60928 .13584 .59978 .14859 .61684 .1549 .62641 .14223 Metetra
.67 .732 .897 r
.59206 .12942 .58263 .14223 .59978 .14859 .60928 .13584 Metetra
.67 .732 .897 r
.57473 .12296 .56537 .13584 .58263 .14223 .59206 .12942 Metetra
.67 .732 .897 r
.55731 .11646 .54802 .12942 .56537 .13584 .57473 .12296 Metetra
.67 .732 .897 r
.53979 .10992 .53057 .12296 .54802 .12942 .55731 .11646 Metetra
.67 .732 .897 r
.52216 .10335 .51302 .11646 .53057 .12296 .53979 .10992 Metetra
.67 .732 .897 r
.50443 .09674 .49537 .10992 .51302 .11646 .52216 .10335 Metetra
.67 .732 .897 r
.48661 .09009 .47762 .10335 .49537 .10992 .50443 .09674 Metetra
.67 .732 .897 r
.46867 .0834 .45977 .09674 .47762 .10335 .48661 .09009 Metetra
.67 .732 .897 r
.45064 .07667 .44181 .09009 .45977 .09674 .46867 .0834 Metetra
.67 .732 .897 r
.4325 .0699 .42375 .0834 .44181 .09009 .45064 .07667 Metetra
.67 .732 .897 r
.41425 .0631 .40558 .07667 .42375 .0834 .4325 .0699 Metetra
.67 .732 .897 r
.39589 .05625 .38731 .0699 .40558 .07667 .41425 .0631 Metetra
.67 .732 .897 r
.37743 .04937 .36893 .0631 .38731 .0699 .39589 .05625 Metetra
.67 .732 .897 r
.35886 .04244 .35044 .05625 .36893 .0631 .37743 .04937 Metetra
.67 .732 .897 r
.34018 .03547 .33184 .04937 .35044 .05625 .35886 .04244 Metetra
.67 .732 .897 r
.32138 .02846 .31314 .04244 .33184 .04937 .34018 .03547 Metetra
.67 .732 .897 r
.30248 .02141 .29432 .03547 .31314 .04244 .32138 .02846 Metetra
.67 .732 .897 r
.28346 .01432 .27539 .02846 .29432 .03547 .30248 .02141 Metetra
.329 .226 .582 r
.96447 .36055 .95255 .36865 .988 .49083 1 .47975 Metetra
.378 .297 .638 r
.93984 .30195 .92847 .31163 .95255 .36865 .96447 .36055 Metetra
.465 .43 .735 r
.92064 .27497 .90951 .2853 .92847 .31163 .93984 .30195 Metetra
.528 .528 .798 r
.90304 .2577 .89208 .26841 .90951 .2853 .92064 .27497 Metetra
.569 .59 .835 r
.88611 .24466 .87527 .25563 .89208 .26841 .90304 .2577 Metetra
.595 .63 .856 r
.86949 .23384 .85875 .24501 .87527 .25563 .88611 .24466 Metetra
.612 .656 .869 r
.853 .22432 .84236 .23565 .85875 .24501 .86949 .23384 Metetra
.624 .674 .877 r
.83658 .21561 .82602 .22708 .84236 .23565 .853 .22432 Metetra
.632 .686 .883 r
.82017 .20745 .80969 .21904 .82602 .22708 .83658 .21561 Metetra
.638 .695 .886 r
.80375 .19966 .79334 .21136 .80969 .21904 .82017 .20745 Metetra
.643 .702 .889 r
.78729 .19214 .77695 .20395 .79334 .21136 .80375 .19966 Metetra
.647 .707 .891 r
.77077 .18482 .76051 .19672 .77695 .20395 .78729 .19214 Metetra
.65 .711 .892 r
.7542 .17764 .74401 .18963 .76051 .19672 .77077 .18482 Metetra
.652 .714 .893 r
.73756 .17056 .72744 .18265 .74401 .18963 .7542 .17764 Metetra
.654 .716 .894 r
.72085 .16356 .7108 .17574 .72744 .18265 .73756 .17056 Metetra
.656 .718 .895 r
.70406 .15661 .69408 .16888 .7108 .17574 .72085 .16356 Metetra
.657 .72 .895 r
.68719 .14971 .67729 .16206 .69408 .16888 .70406 .15661 Metetra
.658 .721 .896 r
.67024 .14283 .6604 .15527 .67729 .16206 .68719 .14971 Metetra
.661 .722 .895 r
.6532 .13598 .64344 .14859 .6604 .15527 .67024 .14283 Metetra
.668 .729 .896 r
.63609 .12942 .62641 .14223 .64344 .14859 .6532 .13598 Metetra
.67 .732 .897 r
.61889 .12296 .60928 .13584 .62641 .14223 .63609 .12942 Metetra
.67 .732 .897 r
.60159 .11646 .59206 .12942 .60928 .13584 .61889 .12296 Metetra
.67 .732 .897 r
.5842 .10992 .57473 .12296 .59206 .12942 .60159 .11646 Metetra
.67 .732 .897 r
.5667 .10335 .55731 .11646 .57473 .12296 .5842 .10992 Metetra
.67 .732 .897 r
.5491 .09674 .53979 .10992 .55731 .11646 .5667 .10335 Metetra
.67 .732 .897 r
.5314 .09009 .52216 .10335 .53979 .10992 .5491 .09674 Metetra
.67 .732 .897 r
.5136 .0834 .50443 .09674 .52216 .10335 .5314 .09009 Metetra
.67 .732 .897 r
.4957 .07667 .48661 .09009 .50443 .09674 .5136 .0834 Metetra
.67 .732 .897 r
.47769 .0699 .46867 .0834 .48661 .09009 .4957 .07667 Metetra
.67 .732 .897 r
.45957 .0631 .45064 .07667 .46867 .0834 .47769 .0699 Metetra
.67 .732 .897 r
.44135 .05625 .4325 .0699 .45064 .07667 .45957 .0631 Metetra
.67 .732 .897 r
.42302 .04937 .41425 .0631 .4325 .0699 .44135 .05625 Metetra
.67 .732 .897 r
.40458 .04244 .39589 .05625 .41425 .0631 .42302 .04937 Metetra
.67 .732 .897 r
.38604 .03547 .37743 .04937 .39589 .05625 .40458 .04244 Metetra
.67 .732 .897 r
.36738 .02846 .35886 .04244 .37743 .04937 .38604 .03547 Metetra
.67 .732 .897 r
.34861 .02141 .34018 .03547 .35886 .04244 .36738 .02846 Metetra
.67 .732 .897 r
.32973 .01432 .32138 .02846 .34018 .03547 .34861 .02141 Metetra
.67 .732 .897 r
.31074 .00718 .30248 .02141 .32138 .02846 .32973 .01432 Metetra
.67 .732 .897 r
.29163 0 .28346 .01432 .30248 .02141 .31074 .00718 Metetra
0 g
.25 Mabswid
.29163 0 m
.27509 .23472 L
s
.27509 .23472 m
0 .67486 L
s
0 .67486 m
.032 .45496 L
s
.032 .45496 m
.29163 0 L
s
.29163 0 m
.27509 .23472 L
s
.27509 .23472 m
1 .47975 L
s
1 .47975 m
.96063 .25135 L
s
.96063 .25135 m
.29163 0 L
s
.29163 0 m
.96063 .25135 L
s
.29163 0 m
.28837 .00572 L
s
[(0)] .29816 -0.01144 -0.57066 1 Mshowa
.43913 .05542 m
.43555 .06095 L
s
[(0.2)] .44629 .04436 -0.64721 1 Mshowa
.57996 .10833 m
.5761 .11367 L
s
[(0.4)] .58769 .09766 -0.72377 1 Mshowa
.71457 .1589 m
.71045 .16405 L
s
[(0.6)] .7228 .14862 -0.80033 1 Mshowa
.84335 .20729 m
.839 .21224 L
s
[(0.8)] .85203 .19739 -0.87689 1 Mshowa
.125 Mabswid
.32916 .0141 m
.32715 .0175 L
s
.36624 .02803 m
.36419 .03141 L
s
.4029 .04181 m
.4008 .04515 L
s
.47495 .06888 m
.47276 .07216 L
s
.51035 .08218 m
.50812 .08544 L
s
.54536 .09533 m
.54308 .09856 L
s
.61418 .12119 m
.61183 .12436 L
s
.64802 .1339 m
.64562 .13704 L
s
.68148 .14647 m
.67905 .14959 L
s
.74729 .1712 m
.74479 .17426 L
s
.77966 .18336 m
.77712 .18639 L
s
.81168 .19539 m
.8091 .19839 L
s
.87467 .21906 m
.87204 .222 L
s
.90567 .2307 m
.903 .23362 L
s
.93633 .24222 m
.93363 .24511 L
s
gsave
.69247 .06972 -62.1993 -13.8125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 17.8125 translate 1 -1 scale
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
69.000 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{535.75, 446.812},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008G0001_Q000`40n007h00Ooooooooo6Ooo003o
oooooolIool009ooo`800?ooogOoo`00W_oo00@00?ooool00?ooogKoo`00W_oo00@00?ooool00?oo
ogKoo`00W_oo00@00?ooool00?ooogKoo`00W_oo00@00?ooool00?ooogKoo`00W_oo00@00?ooool0
0?ooogKoo`00T?oo0P003Ooo0P00ooooMooo002?ool01000ooooo`00ooooQOoo002?ool01000oooo
o`00ooooQOoo002?ool01000ooooo`00ooooQOoo002?ool01000ooooo`00ooooQOoo002?ool01000
ooooo`00ooooQOoo002@ool2003ooon6ool009[oo`800?ooogcoo`00VOoo0P0000B]g00000000?oo
ogWoo`00VOoo0P001:gL1000ooooMOoo002Hool30006[M`5003ooombool009Soo`03002]g00000V]
g0@00?ooog3oo`00Uooo00@00:gL[M`000R]g004002]g:gL[M`4003ooom]ool009Ooo`04002]g:gL
0008[M`00`00[Mb]g003[M`4003ooom[ool009Koo`8000:]g003002]g:gL00F]g003002]g:gL00N]
g0@00?ooofSoo`00UOoo00<00:gL[M`00P002:gL00<00:gL[M`02:gL1@00ooooI_oo002Eool01000
[Mb]g:gL10001:gL00<00:gL[M`02JgL00@00:gL[Mb]g0@00?ooof?oo`00U?oo00<00:gL[M`00ZgL
00@00:gL[Mb]g08000:]g003002]g:gL00R]g003002]g:gL00F]g0<00?ooof7oo`00U?oo00<00:gL
[M`00ZgL00<00:gL[M`00jgL0`002ZgL00<00:gL[M`02:gL0`00ooooG_oo002Cool00`00[Mb]g003
[M`00`00[Mb]g003[M`00`00[Mb]g0030006[M`00`00[Mb]g009[M`00`00[M`00003003ooomKool0
09?oo`03002]g:gL00>]g003002]g:gL00>]g003002]g:gL00>]g0@000:]g003002]g:gL00V]g003
002]g:gL00:]g0D00?oooeOoo`00T_oo0P001JgL00<00:gL[M`00ZgL00<00:gL[M`02:gL0`002ZgL
00<00:gL[M`01ZgL1@00ooooE?oo002Aool200000jgL00000003[M`00`00[Mb]g002[M`00`00[Mb]
g009[M`01000[M`000002:gL00<00:gL[M`02:gL1@00ooooD_oo002Aool00`00[Mb]g002[M`40003
[M`00`00[Mb]g009[M`00`00[Mb]g002[M`30004[M`00`00[Mb]g008[M`20002[M`4000Qool20004
ool00`00ooooo`02ool4003ooolPool0093oo`8000N]g08000:]g003002]g:gL00V]g003002]g:gL
00F]g08000:]g003002]g:gL00R]g003002]g:gL00B]g0<001koo`04003ooooo0008ool00`00oooo
o`3ooolQool0093oo`03002]g:gL00J]g003002]g000008000Z]g003002]g:gL00R]g0<000Z]g003
002]g:gL00J]g0@001_oo`04003ooooo0009ool00`00ooooo`3ooolPool008ooo`8000R]g003002]
g00000:]g08000R]g003002]g:gL00R]g003002]g:gL008000N]g003002]g:gL00R]g003002]g000
008001Woo`04003ooooo000:ool00`00ooooo`3ooolOool008ooo`03002]g:gL00N]g003002]g000
00B]g0<000B]g003002]g:gL00V]g003002]g:gL00:]g08000B]g003002]g:gL00V]g003002]g:gL
00:]g0<001Koo`04003ooooo000;ool00`00ooooo`3ooolNool008koo`8000V]g08000R]g08000:]
g003002]g:gL00R]g003002]g:gL00F]g08000:]g003002]g:gL00R]g003002]g:gL00F]g0@001?o
o`04003ooooo0008ool01000ooooo`00oooo8?oo002=ool30009[M`2000:[M`30009[M`00`00[Mb]
g008[M`3000:[M`00`00[Mb]g008[M`3000Bool2000:ool2003ooolQool008goo`03002]g:gL00<0
00F]g08000^]g003002]g:gL00<000F]g003002]g:gL00V]g003002]g:gL00<000J]g003002]g:gL
00R]g08000:]g0<00?ooockoo`00S?oo0P001JgL100000>]g00000002jgL00<00:gL[M`00jgL0`00
0ZgL00<00:gL[M`02JgL00<00:gL[M`00jgL10000ZgL00<00:gL[M`02JgL00<00:gL[M`00jgL0`00
oooo>ooo002<ool00`00[Mb]g008[M`3000:[M`00`00[Mb]g007[M`3000:[M`00`00[Mb]g008[M`3
000:[M`00`00[Mb]g006[M`4003ooolhool008_oo`8000Z]g0800003[M`0000000N]g003002]g:gL
00R]g003002]g:gL008000R]g003002]g:gL00R]g003002]g:gL008000N]g003002]g:gL00R]g003
002]g00000800?ooocKoo`00Rooo00<00:gL[M`02JgL0P000jgL0P001:gL00<00:gL[M`02JgL00<0
0:gL[M`00ZgL0`001:gL00<00:gL[M`02JgL00<00:gL[M`00ZgL0P001:gL00<00:gL[M`02JgL00<0
0:gL[M`00ZgL0`00oooo<ooo002:ool2000:[M`00`00[M`00005[M`20002[M`00`00[Mb]g008[M`0
0`00[Mb]g006[M`20002[M`00`00[Mb]g008[M`00`00[Mb]g005[M`20002[M`00`00[Mb]g008[M`0
0`00[Mb]g005[M`4003oool`ool008Woo`<000Z]g003002]g00000N]g0<000Z]g003002]g:gL00R]
g0<000V]g003002]g:gL00R]g0<000Z]g003002]g:gL00N]g0@0083oo`800003ool000000:Soo`00
ROoo00<00:gL[M`00`001ZgL00@00:gL[M`000N]g003002]g:gL00<000J]g003002]g:gL00V]g003
002]g:gL00<000F]g003002]g:gL00V]g003002]g:gL00<000J]g003002]g:gL00R]g08000:]g0<0
07koo`03003oo`000:Woo`00R?oo0P001JgL10000ZgL00@00:gL[M`000N]g003002]g:gL00>]g0@0
00:]g003002]g:gL00V]g003002]g:gL00>]g0<000:]g003002]g:gL00V]g003002]g:gL00>]g0@0
00:]g003002]g:gL00N]g003002]g00000B]g0@007coo`03003ooooo0:Soo`00R?oo00<00:gL[M`0
2:gL0`000ZgL00<00:gL[M`01:gL00<00:gL[M`02:gL0`002ZgL00<00:gL[M`01jgL0`002ZgL00<0
0:gL[M`02:gL0`002ZgL00<00:gL[M`01ZgL1000N?oo00<00?oo0000ZOoo0027ool2000:[M`00`00
[Mb]g0030006[M`00`00[Mb]g008[M`00`00[Mb]g0020008[M`00`00[Mb]g007[M`00`00[Mb]g002
0008[M`00`00[Mb]g008[M`00`00[Mb]g0020007[M`00`00[Mb]g008[M`00`00[M`00002001eool2
00000ooo0000002Xool008Ooo`03002]g:gL00V]g003002]g:gL00:]g08000B]g003002]g:gL00V]
g003002]g:gL00:]g0<000B]g003002]g:gL00R]g003002]g:gL00:]g0<000B]g003002]g:gL00V]
g003002]g:gL00:]g08000B]g003002]g:gL00V]g004002]g:gL[M`4003ooolPool008Koo`8000Z]
g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]g008[M`00`00[Mb]g006[M`20002[M`00`00
[Mb]g007[M`00`00[Mb]g006[M`20002[M`00`00[Mb]g008[M`00`00[Mb]g005[M`20002[M`00`00
[Mb]g008[M`00`00[Mb]g005[M`3003ooolNool008Goo`<000Z]g003002]g:gL00>]g004002]g:gL
[M`3000:[M`00`00[Mb]g008[M`30009[M`00`00[Mb]g008[M`30009[M`00`00[Mb]g008[M`3000:
[M`00`00[Mb]g007[M`4003ooolKool008Goo`03002]g:gL00<000J]g003002]g:gL00B]g005002]
g:gL[M`00002[M`30006[M`00`00[Mb]g009[M`00`00[Mb]g0030005[M`00`00[Mb]g009[M`00`00
[Mb]g0030005[M`00`00[Mb]g009[M`00`00[Mb]g0030006[M`00`00[Mb]g007[M`01000[M`00:gL
1000oooo6?oo0024ool20005[M`40002[M`00`00[Mb]g003[M`00`00[Mb]g002[M`00`00[Mb]g003
[M`40002[M`00`00[Mb]g009[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g009[M`00`00[Mb]g003
[M`30002[M`00`00[Mb]g009[M`00`00[Mb]g003[M`40002[M`00`00[Mb]g009[M`00`00[Mb]g002
[M`4003ooolEool008Coo`03002]g:gL00R]g0<000F]g005002]g:gL[M`0000:[M`3000:[M`00`00
[Mb]g007[M`3000:[M`00`00[Mb]g007[M`3000:[M`00`00[Mb]g008[M`3000:[M`00`00[Mb]g006
[M`4003ooolBool008?oo`8000Z]g003002]g:gL008000>]g005002]g:gL[M`0000:[M`00`00[Mb]
g0020007[M`00`00[Mb]g008[M`00`00[Mb]g0020008[M`00`00[Mb]g007[M`00`00[Mb]g0020008
[M`00`00[Mb]g008[M`00`00[Mb]g0020007[M`00`00[Mb]g008[M`5003oool@ool008?oo`03002]
g:gL00V]g003002]g:gL00:]g0800005[M`00:gL[M`0000;[M`00`00[Mb]g002[M`20004[M`00`00
[Mb]g009[M`00`00[Mb]g002[M`30004[M`00`00[Mb]g008[M`00`00[Mb]g002[M`30004[M`00`00
[Mb]g009[M`00`00[Mb]g002[M`20004[M`00`00[Mb]g009[M`01000[Mb]g:gL0`00oooo3_oo0022
ool2000:[M`00`00[Mb]g005[M`20002[M`00`00[Mb]g008[M`00`00[Mb]g005[M`20002[M`00`00
[Mb]g008[M`00`00[Mb]g006[M`20002[M`00`00[Mb]g007[M`00`00[Mb]g006[M`20002[M`00`00
[Mb]g008[M`00`00[Mb]g005[M`20002[M`00`00[Mb]g008[M`00`00[Mb]g005[M`2003oool<ool0
087oo`<000V]g003002]g:gL00N]g0@000Z]g003002]g:gL00N]g0<000Z]g003002]g:gL00R]g0<0
00V]g003002]g:gL00R]g0<000V]g003002]g:gL00R]g0<000V]g003002]g:gL00N]g0@002Coo`80
00Coo`03003ooooo00Coo`03003ooooo0=Coo`00POoo00<00:gL[M`00`001JgL00<00:gL[M`02:gL
0P000ZgL0`001ZgL00<00:gL[M`02:gL00<00:gL[M`00`001ZgL00<00:gL[M`02JgL00<00:gL[M`0
0`001JgL00<00:gL[M`02JgL00<00:gL[M`00`001JgL00<00:gL[M`02JgL00<00:gL[M`00`001JgL
00<00:gL[M`01jgL00<00:gL00000ZgL0`008?oo00@00?ooool000[oo`03003ooooo0=Coo`00P?oo
0P001JgL0`000ZgL00<00:gL[M`02:gL0P001JgL10000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL
10000ZgL00<00:gL[M`02JgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02JgL00<00:gL[M`00jgL
0`000ZgL00<00:gL[M`02JgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02JgL00<00:gL[M`00jgL
0`007Ooo00@00?ooool000Ooo`D00=Goo`00P?oo00<00:gL[M`01jgL0`002ZgL00<00:gL[M`02:gL
0`002JgL00<00:gL[M`02:gL0`002ZgL00<00:gL[M`01jgL0`002ZgL00<00:gL[M`01jgL0`002ZgL
00<00:gL[M`01jgL0`002ZgL00<00:gL[M`01jgL0`006_oo00@00?ooool000Ooo`04003ooooo003F
ool007ooo`8000Z]g004002]g0000008[M`00`00[Mb]g008[M`00`00[Mb]g0020007[M`00`00[Mb]
g008[M`00`00[Mb]g0020007[M`00`00[Mb]g008[M`00`00[Mb]g0020007[M`00`00[Mb]g008[M`0
0`00[Mb]g0020007[M`00`00[Mb]g008[M`00`00[Mb]g0020007[M`00`00[Mb]g008[M`00`00[M`0
0002000Hool01000ooooo`002?oo00<00?oo0000e_oo001oool00`00[Mb]g008[M`00`00[Mb]g002
[M`30004[M`2000:[M`00`00[Mb]g002[M`20004[M`00`00[Mb]g009[M`00`00[Mb]g002[M`20004
[M`00`00[Mb]g009[M`00`00[Mb]g002[M`20004[M`00`00[Mb]g009[M`00`00[Mb]g002[M`20004
[M`00`00[Mb]g009[M`00`00[Mb]g002[M`20004[M`00`00[Mb]g009[M`00`00[Mb]g002[M`3000E
ool01000ooooo`002Ooo0P00e_oo001nool2000:[M`00`00[Mb]g005[M`20002[M`20009[M`00`00
[Mb]g005[M`20002[M`00`00[Mb]g008[M`00`00[Mb]g005[M`20002[M`00`00[Mb]g008[M`00`00
[Mb]g005[M`20002[M`00`00[Mb]g008[M`00`00[Mb]g005[M`20002[M`00`00[Mb]g008[M`00`00
[Mb]g005[M`20002[M`00`00[Mb]g008[M`00`00[Mb]g006[M`2000Dool2000;ool00`00ooooo`3D
ool006Coo`8000Coo`03003ooooo00;oo`@000[oo`<000V]g003002]g:gL00R]g0@000V]g003002]
g:gL00N]g0<000Z]g003002]g:gL00N]g0<000Z]g003002]g:gL00N]g0<000Z]g003002]g:gL00N]
g0<000Z]g003002]g:gL00N]g0<000Z]g003002]g:gL00J]g003002]g00000800?Goo`00Hooo00@0
0?ooool000Soo`03003ooooo00_oo`03002]g:gL00<000J]g003002]g:gL00R]g003002]g:gL00<0
00J]g003002]g:gL00R]g003002]g:gL00<000J]g003002]g:gL00R]g003002]g:gL00<000J]g003
002]g:gL00R]g003002]g:gL00<000J]g003002]g:gL00R]g003002]g:gL00<000J]g003002]g:gL
00R]g003002]g:gL00<000J]g003002]g:gL00J]g004002]g:gL0002[M`3003bool006?oo`04003o
oooo0009ool00`00ooooo`09ool20005[M`400000jgL002]g00:[M`01000[Mb]g0000ZgL10000ZgL
00<00:gL[M`02:gL00<00:gL[M`00jgL10000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL10000ZgL
00<00:gL[M`02:gL00<00:gL[M`00jgL10000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL10000ZgL
00<00:gL[M`02:gL00<00:gL[M`00jgL10000ZgL00<00:gL[M`02:gL00<00:gL[M`01:gL0`00kooo
001Sool01000ooooo`002_oo00<00?ooool02?oo00<00:gL[M`02:gL0`002JgL00@00:gL[M`000N]
g0<000V]g003002]g:gL00R]g0<000V]g003002]g:gL00R]g0<000V]g003002]g:gL00R]g0<000V]
g003002]g:gL00R]g0<000V]g003002]g:gL00R]g0<000Z]g003002]g:gL00J]g0@00>coo`00Hooo
00@00?ooool000_oo`03003ooooo00Koo`03002]g:gL00V]g003002]g:gL00<000F]g005002]g:gL
[M`00007[M`00`00[Mb]g0030005[M`00`00[Mb]g009[M`00`00[Mb]g0030005[M`00`00[Mb]g009
[M`00`00[Mb]g0030005[M`00`00[Mb]g009[M`00`00[Mb]g0030005[M`00`00[Mb]g009[M`00`00
[Mb]g0030005[M`00`00[Mb]g009[M`00`00[Mb]g0030006[M`00`00[Mb]g008[M`00`00[M`00003
003Yool006?oo`04003ooooo0008ool01000ooooo`002?oo00<00:gL[M`02JgL00<00:gL[M`00jgL
0`000ZgL00D00:gL[Mb]g00000N]g003002]g:gL00>]g0<000:]g003002]g:gL00V]g003002]g:gL
00>]g0<000:]g003002]g:gL00V]g003002]g:gL00>]g0<000:]g003002]g:gL00V]g003002]g:gL
00>]g0<000:]g003002]g:gL00V]g003002]g:gL00>]g0<000:]g003002]g:gL00V]g003002]g:gL
00>]g0<000:]g003002]g:gL00V]g003002]g:gL00:]g0@00>Koo`00I?oo0P002_oo0P002?oo0P00
2ZgL00<00:gL[M`01jgL0`000jgL00<00:gL[M`01:gL00<00:gL[M`01jgL0`002ZgL00<00:gL[M`0
1jgL0`002ZgL00<00:gL[M`01jgL0`002ZgL00<00:gL[M`01jgL0`002ZgL00<00:gL[M`01jgL0`00
2ZgL00<00:gL[M`01jgL0`002ZgL00<00:gL[M`01JgL1@00hooo001iool00`00[Mb]g0020008[M`0
0`00[Mb]g007[M`00`00[Mb]g00200000jgL002]g004[M`00`00[Mb]g008[M`00`00[Mb]g0020007
[M`00`00[Mb]g008[M`00`00[Mb]g0020007[M`00`00[Mb]g008[M`00`00[Mb]g0020007[M`00`00
[Mb]g008[M`00`00[Mb]g0020007[M`00`00[Mb]g008[M`00`00[Mb]g0020007[M`00`00[Mb]g008
[M`00`00[Mb]g0020007[M`00`00[Mb]g005[M`00`00[Mb]g005003Qool007Woo`03002]g:gL00:]
g0<000B]g003002]g:gL00R]g003002]g:gL00:]g08000B]g003002]g:gL00V]g003002]g:gL00:]
g08000B]g003002]g:gL00V]g003002]g:gL00:]g08000B]g003002]g:gL00V]g003002]g:gL00:]
g08000B]g003002]g:gL00V]g003002]g:gL00:]g08000B]g003002]g:gL00V]g003002]g:gL00:]
g08000B]g003002]g:gL00V]g003002]g:gL00:]g08000B]g003002]g:gL00F]g005002]g:gL[M`0
0003[M`3003Oool007Soo`03002]g:gL00J]g08000:]g003002]g:gL00N]g003002]g:gL00B]g0<0
00:]g003002]g:gL00R]g003002]g:gL00F]g08000:]g003002]g:gL00R]g003002]g:gL00F]g080
00:]g003002]g:gL00R]g003002]g:gL00F]g08000:]g003002]g:gL00R]g003002]g:gL00F]g080
00:]g003002]g:gL00R]g003002]g:gL00F]g08000:]g003002]g:gL00R]g003002]g:gL00F]g080
00:]g003002]g:gL00R]g003002]g:gL00B]g0<00=goo`00N?oo00<00:gL[M`02:gL0`002JgL00<0
0:gL[M`01:gL00<00:gL[M`00`002ZgL00<00:gL[M`01jgL0`002ZgL00<00:gL[M`01jgL0`002JgL
00<00:gL[M`02:gL0`002JgL00<00:gL[M`02:gL0`002JgL00<00:gL[M`02:gL0`002JgL00<00:gL
[M`02:gL0`002JgL00<00:gL[M`02:gL0`00f_oo001gool00`00[Mb]g009[M`00`00[Mb]g0030005
[M`00`00[Mb]g005[M`01000[Mb]g0000ZgL0`001ZgL00<00:gL[M`02:gL00<00:gL[M`00`001ZgL
00<00:gL[M`02:gL00<00:gL[M`00`001JgL00<00:gL[M`02JgL00<00:gL[M`00`001JgL00<00:gL
[M`02JgL00<00:gL[M`00`001JgL00<00:gL[M`02JgL00<00:gL[M`00`001JgL00<00:gL[M`02JgL
00<00:gL[M`00`001JgL00<00:gL[M`02JgL00<00:gL[M`00`00eooo001gool00`00[Mb]g009[M`0
0`00[Mb]g003[M`30002[M`00`00[Mb]g005[M`01000[Mb]g0001JgL10000ZgL00<00:gL[M`02:gL
00<00:gL[M`00jgL10000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02JgL
00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`01:gL0`000ZgL00<00:gL[M`02:gL
00<00:gL[M`01:gL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`01:gL0`000ZgL00<00:gL[M`02:gL
00<00:gL[M`00jgL1000e?oo001fool2000:[M`00`00[Mb]g007[M`30007[M`00`00[M`0000:[M`3
0009[M`00`00[Mb]g008[M`30009[M`00`00[Mb]g007[M`3000:[M`00`00[Mb]g007[M`3000:[M`0
0`00[Mb]g007[M`3000:[M`00`00[Mb]g007[M`3000:[M`00`00[Mb]g007[M`3000:[M`00`00[Mb]
g005[M`5003Aool007Goo`800004[M`000000006[M`00`00[Mb]g008[M`00`00[Mb]g0030004[M`2
000;[M`00`00[Mb]g0030005[M`00`00[Mb]g009[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`0
0`00[Mb]g0030006[M`00`00[Mb]g008[M`00`00[Mb]g0030006[M`00`00[Mb]g008[M`00`00[Mb]
g0030006[M`00`00[Mb]g008[M`00`00[Mb]g0030006[M`00`00[Mb]g008[M`00`00[Mb]g0030006
[M`00`00[Mb]g005[M`01@00[Mb]g000[M`00`00cooo001eool00`00[Mb]g003[M`40002[M`00`00
[Mb]g008[M`00`00[Mb]g003[M`300000jgL0000000;[M`00`00[Mb]g003[M`30002[M`00`00[Mb]
g009[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`40002[M`00`00[Mb]
g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g009[M`00`00[Mb]g003[M`30002[M`00`00[Mb]
g009[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g009[M`00`00[Mb]g003[M`30002[M`00`00[Mb]
g009[M`01000[Mb]g:gL1000c?oo001dool00`00[Mb]g008[M`30009[M`00`00[Mb]g007[M`3000:
[M`00`00[Mb]g007[M`3000:[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g008[M`30009[M`00`00
[Mb]g007[M`3000:[M`00`00[Mb]g007[M`3000:[M`00`00[Mb]g007[M`3000:[M`00`00[Mb]g007
[M`3000:[M`00`00[Mb]g005[M`40039ool007Coo`03002]g:gL00R]g003002]g:gL008000N]g003
002]g:gL00N]g0800003[M`0000000R]g003002]g:gL00N]g003002]g:gL008000N]g003002]g:gL
00R]g003002]g:gL008000N]g003002]g:gL00R]g003002]g:gL008000N]g003002]g:gL00N]g003
002]g:gL008000R]g003002]g:gL00N]g003002]g:gL008000N]g003002]g:gL00R]g003002]g:gL
008000N]g003002]g:gL00R]g003002]g:gL008000N]g003002]g:gL00N]g003002]g00000800<Oo
o`00Looo00<00:gL[M`02JgL00<00:gL[M`00ZgL0P001:gL00<00:gL[M`02:gL0P000jgL0`001:gL
00<00:gL[M`02:gL00<00:gL[M`00ZgL0P001:gL00<00:gL[M`02JgL00<00:gL[M`00ZgL0P001:gL
00<00:gL[M`02JgL00<00:gL[M`00ZgL0P001:gL00<00:gL[M`02:gL00<00:gL[M`00ZgL0`001:gL
00<00:gL[M`02:gL00<00:gL[M`00ZgL0P001:gL00<00:gL[M`02JgL00<00:gL[M`00ZgL0P001:gL
00<00:gL[M`02JgL00<00:gL[M`00ZgL0P001:gL00<00:gL[M`02:gL00<00:gL[M`00ZgL0P00aOoo
001cool00`00[Mb]g008[M`00`00[Mb]g005[M`20002[M`00`00[Mb]g007[M`20007[M`20002[M`0
0`00[Mb]g007[M`00`00[Mb]g005[M`20002[M`00`00[Mb]g008[M`00`00[Mb]g005[M`20002[M`0
0`00[Mb]g008[M`00`00[Mb]g005[M`20002[M`00`00[Mb]g007[M`00`00[Mb]g006[M`20002[M`0
0`00[Mb]g007[M`00`00[Mb]g005[M`20002[M`00`00[Mb]g008[M`00`00[Mb]g005[M`20002[M`0
0`00[Mb]g008[M`00`00[Mb]g005[M`20002[M`00`00[Mb]g007[M`00`00[Mb]g005[M`3000Tool2
0004ool00`00ooooo`03ool2002@ool007;oo`8000Z]g003002]g:gL00N]g0<000V]g08000V]g0<0
00V]g003002]g:gL00N]g0<000Z]g003002]g:gL00N]g0<000V]g003002]g:gL00R]g0<000V]g003
002]g:gL00R]g0<000V]g003002]g:gL00N]g0<000V]g003002]g:gL00R]g0<000V]g003002]g:gL
00R]g0<000R]g003002]g:gL00F]g003002]g:gL00@0023oo`04003ooooo0008ool01000ooooo`00
Sooo001bool00`00[M`000020006[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[M`00009
[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`00`00[Mb]g0030006[M`00`00[Mb]g008[M`00`00
[Mb]g0030005[M`00`00[Mb]g009[M`00`00[Mb]g0030005[M`00`00[Mb]g009[M`00`00[Mb]g003
0005[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]g009[M`00`00[Mb]g0030005[M`0
0`00[Mb]g009[M`00`00[Mb]g0020005[M`00`00[Mb]g009[M`00`00[Mb]g003000Nool01000oooo
o`002?oo00@00?ooool008ooo`00LOoo00<00:gL[M`00jgL10000ZgL00<00:gL[M`02:gL00<00:gL
[M`00jgL0`000ZgL00<00:gL00002JgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL
[M`00jgL10000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL
[M`01:gL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`01:gL0`000ZgL00<00:gL[M`02:gL00<00:gL
[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`01:gL0`000ZgL00<00:gL[M`02:gL00<00:gL
[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`01:gL0`006ooo00@00?ooool000Soo`<0093o
o`00L?oo0P002JgL0`002JgL00<00:gL[M`01jgL0`0000>]g000[M`01jgL00<00:gL[M`01jgL0`00
2JgL00<00:gL[M`02:gL0`002JgL00<00:gL[M`01jgL0`002ZgL00<00:gL[M`01jgL0`002ZgL00<0
0:gL[M`01jgL0`002JgL00<00:gL[M`01jgL0`002ZgL00<00:gL[M`01jgL0`002ZgL00<00:gL[M`0
1ZgL0`002ZgL00<00:gL[M`01jgL0`006?oo00@00?ooool000Soo`03003ooooo093oo`00L?oo00<0
0:gL[M`02:gL00<00:gL[M`00`001JgL00<00:gL[M`02JgL00<00:gL00000P001ZgL00<00:gL[M`0
2:gL00<00:gL[M`00`001JgL00<00:gL[M`02JgL00<00:gL[M`00`001JgL00<00:gL[M`02:gL00<0
0:gL[M`00`001ZgL00<00:gL[M`02:gL00<00:gL[M`00`001ZgL00<00:gL[M`02:gL00<00:gL[M`0
0`001JgL00<00:gL[M`02:gL00<00:gL[M`00`001ZgL00<00:gL[M`02:gL00<00:gL[M`00`001ZgL
00<00:gL[M`01jgL00<00:gL[M`00`001ZgL00<00:gL[M`02:gL00<00:gL[M`00P005_oo00@00?oo
ool000Soo`03003ooooo093oo`00Kooo0P002ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL
00H00:gL[Mb]g000[M`40002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g009
[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g009
[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g009[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008
[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g009[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008
[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g009[M`00`00[Mb]g002[M`3000Dool2000:ool3002?
ool006ooo`8000V]g003002]g:gL00N]g0<000Z]g005002]g:gL[M`00005[M`30009[M`00`00[Mb]
g007[M`3000:[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`3000:[M`00`00[Mb]g007[M`3
000:[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`3000:[M`00`00[Mb]g007[M`30009[M`0
0`00[Mb]g007[M`3000:[M`00`00[Mb]g005[M`4002_ool006koo`03002]g:gL008000N]g003002]
g:gL00N]g003002]g:gL008000N]g003002]g:gL00:]g003002]g:gL00>]g003002]g:gL008000N]
g003002]g:gL00N]g003002]g:gL008000R]g003002]g:gL00N]g003002]g:gL008000N]g003002]
g:gL00N]g003002]g:gL008000R]g003002]g:gL00N]g003002]g:gL008000N]g003002]g:gL00R]
g003002]g:gL008000N]g003002]g:gL00N]g003002]g:gL008000N]g003002]g:gL00R]g003002]
g:gL008000N]g003002]g:gL00N]g003002]g:gL008000N]g003002]g:gL00F]g003002]g:gL00@0
0:goo`00K_oo00<00:gL[M`00ZgL0P001:gL00<00:gL[M`02:gL00<00:gL[M`00ZgL0`001:gL00<0
0:gL[M`00ZgL00<00:gL[M`00jgL00<00:gL[M`00ZgL0P001:gL00<00:gL[M`02:gL00<00:gL[M`0
0ZgL0`001:gL00<00:gL[M`02:gL00<00:gL[M`00ZgL0P001:gL00<00:gL[M`02:gL00<00:gL[M`0
0ZgL0`001:gL00<00:gL[M`02:gL00<00:gL[M`00ZgL0P001:gL00<00:gL[M`02JgL00<00:gL[M`0
0ZgL0P001:gL00<00:gL[M`02:gL00<00:gL[M`00ZgL0P001:gL00<00:gL[M`02JgL00<00:gL[M`0
0ZgL0P001:gL00<00:gL[M`02:gL00<00:gL[M`00ZgL0P001:gL00<00:gL[M`02JgL00<00:gL[M`0
1000Z_oo001]ool00`00[Mb]g005[M`20002[M`00`00[Mb]g007[M`00`00[Mb]g006[M`200000jgL
002]g004[M`00`00[Mb]g002[M`00`00[Mb]g005[M`20002[M`00`00[Mb]g007[M`00`00[Mb]g006
[M`20002[M`00`00[Mb]g007[M`00`00[Mb]g005[M`20002[M`00`00[Mb]g007[M`00`00[Mb]g006
[M`20002[M`00`00[Mb]g007[M`00`00[Mb]g005[M`20002[M`00`00[Mb]g008[M`00`00[Mb]g005
[M`20002[M`00`00[Mb]g007[M`00`00[Mb]g005[M`20002[M`00`00[Mb]g008[M`00`00[Mb]g005
[M`20002[M`00`00[Mb]g007[M`00`00[Mb]g005[M`20002[M`00`00[Mb]g008[M`00`00[Mb]g003
[M`5002Wool006coo`8000V]g0<000V]g003002]g:gL00R]g0<000B]g003002]g:gL00:]g003002]
g:gL00N]g0<000V]g003002]g:gL00R]g0<000V]g003002]g:gL00N]g0<000V]g003002]g:gL00R]
g0<000V]g003002]g:gL00N]g0<000V]g003002]g:gL00R]g0<000R]g003002]g:gL00R]g0<000V]
g003002]g:gL00R]g0<000R]g003002]g:gL00R]g0<000Z]g003002]g:gL00F]g0800003ool00000
0:Goo`00K?oo00<00:gL[M`02:gL00<00:gL[M`00`001JgL00<00:gL[M`02JgL00<00:gL[M`00`00
00>]g000[M`00ZgL00<00:gL[M`02:gL00<00:gL[M`00`001JgL00<00:gL[M`02JgL00<00:gL[M`0
0`001JgL00<00:gL[M`02:gL00<00:gL[M`00`001JgL00<00:gL[M`02JgL00<00:gL[M`00`001JgL
00<00:gL[M`02:gL00<00:gL[M`00`001JgL00<00:gL[M`02JgL00<00:gL[M`00P001JgL00<00:gL
[M`02JgL00<00:gL[M`00`001JgL00<00:gL[M`02JgL00<00:gL[M`00P001JgL00<00:gL[M`02JgL
00<00:gL[M`00`001ZgL00<00:gL[M`02:gL1P00X_oo001[ool2000:[M`00`00[Mb]g003[M`30002
[M`00`00[Mb]g009[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002
[M`00`00[Mb]g008[M`00`00[Mb]g004[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002
[M`00`00[Mb]g008[M`00`00[Mb]g004[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002
[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g004[M`30002
[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g004[M`30002
[M`00`00[Mb]g009[M`00`00YKbU_00200001?oo00000000Wooo001[ool20009[M`00`00[Mb]g007
[M`3000:[M`00`00[Mb]g005[M`00`00[M`000020009[M`00`00[Mb]g007[M`3000:[M`00`00[Mb]
g007[M`30009[M`00`00[Mb]g007[M`3000:[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`3
000:[M`00`00[Mb]g006[M`3000:[M`00`00[Mb]g007[M`3000:[M`00`00[Mb]g006[M`3000:[M`0
0`00[Mb]g007[M`2000;[M`00`00YKbU_003YK`300000ooo0000002Mool006[oo`03002]g:gL00<0
00F]g003002]g:gL00V]g003002]g000008000J]g003002]g:gL00F]g004002]g:gL0002[M`30005
[M`00`00[Mb]g008[M`00`00[Mb]g0030006[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00
[Mb]g008[M`00`00[Mb]g0030006[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]g008
[M`00`00[Mb]g0030006[M`00`00[Mb]g007[M`00`00[Mb]g0030006[M`00`00[Mb]g008[M`00`00
[Mb]g0030006[M`00`00[Mb]g007[M`00`00[Mb]g0030006[M`00`00[Mb]g008[M`01000[M`00000
2:gL00<00:FlYK`00jFl00@00:FlYKbU_0H009[oo`00J_oo00<00:gL[M`00jgL0`000ZgL00<00:gL
[M`02:gL00<00:gL[M`00jgL10000ZgL00<00:gL[M`01JgL00@00:gL[M`000F]g0<000:]g003002]
g:gL00R]g003002]g:gL00>]g0<000:]g003002]g:gL00V]g003002]g:gL00>]g0<000:]g003002]
g:gL00R]g003002]g:gL00>]g0<000:]g003002]g:gL00R]g003002]g:gL00B]g0<000:]g003002]
g:gL00N]g003002]g:gL00B]g0<000:]g003002]g:gL00R]g003002]g:gL00>]g0<000:]g003002]
g:gL00R]g003002]g:gL00B]g0<000:]g003002]g:gL00N]g003002]g:gL00B]g0<000:]g003002]
g:gL00V]g004002]g:gL[M`20005[M`00`00YKbU_008YK`00`00YKbU_00200001?oo00000000Uooo
001Yool00`00[Mb]g007[M`3000:[M`00`00[Mb]g007[M`30007[M`00`00[M`00009[M`30009[M`0
0`00[Mb]g007[M`3000:[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`3000:[M`00`00[Mb]
g007[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`3000:[M`00`00[Mb]g007[M`3
0009[M`00`00[Mb]g007[M`3000:[M`00`00[Mb]g004[M`20002[M`00`00YKbU_008YK`00`00YKbU
_003YK`20002ool3002Dool006Soo`03002]g:gL00V]g003002]g000008000J]g003002]g:gL00R]
g003002]g:gL00<000B]g08000Z]g003002]g:gL00<000F]g003002]g:gL00R]g003002]g:gL00<0
00J]g003002]g:gL00R]g003002]g:gL00<000F]g003002]g:gL00R]g003002]g:gL00<000J]g003
002]g:gL00R]g003002]g:gL008000J]g003002]g:gL00R]g003002]g:gL00<000F]g003002]g:gL
00R]g003002]g:gL00<000J]g003002]g:gL00R]g003002]g:gL008000J]g003002]g:gL00R]g003
002]g:gL008000N]g003002]g:gL00N]g0<000ZU_003002U_:Fl00FU_08000?oo`8009;oo`00J?oo
00<00:gL[M`02:gL00<00:gL[M`00jgL10000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`0000>]
g00000002ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL10000ZgL00<0
0:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<0
0:gL[M`02JgL00<00:gL[M`00ZgL0`000ZgL00<00:gL[M`02JgL00<00:gL[M`00jgL0`000ZgL00<0
0:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02JgL00<00:gL[M`00ZgL0`000ZgL00<0
0:gL[M`02JgL00<00:gL[M`00ZgL0P001:gL00<00:gL[M`02:gL00<00:GLYM`00`001ZFl00<00:Fl
YK`02:Fl0`000_oo0`00Sooo001Wool2000:[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`3
0009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g008[M`30009[M`00`00[Mb]g007[M`30009[M`0
0`00[Mb]g007[M`3000:[M`00`00[Mb]g006[M`3000:[M`00`00[Mb]g007[M`30009[M`00`00[Mb]
g007[M`3000:[M`00`00[Mb]g006[M`3000:[M`00`00[Mb]g005[M`20002[M`00`00[Mb]g007[M`0
0`00YMbUg004YM`30002YK`00`00YKbU_009YK`00`00YKbU_00200000ooo003oo`03002<ool006Oo
o`04002]g0000007[M`00`00[Mb]g008[M`00`00[Mb]g0020007[M`00`00[Mb]g007[M`200000jgL
00000007[M`00`00[Mb]g007[M`00`00[Mb]g0020007[M`00`00[Mb]g008[M`00`00[Mb]g0020007
[M`00`00[Mb]g007[M`00`00[Mb]g0020007[M`00`00[Mb]g007[M`00`00[Mb]g0020007[M`00`00
[Mb]g007[M`00`00[Mb]g0020007[M`00`00[Mb]g008[M`00`00[Mb]g0020007[M`00`00[Mb]g007
[M`00`00[Mb]g0020007[M`00`00[Mb]g007[M`00`00[Mb]g0020007[M`00`00[Mb]g008[M`30009
[M`00`00YMbUg007YM`3000:YK`00`00YKbU_003YK`30003ool2002:ool006Koo`03002]g:gL00:]
g0<000B]g003002]g:gL00R]g003002]g:gL00:]g08000B]g003002]g:gL00R]g08000>]g08000B]
g003002]g:gL00R]g003002]g:gL00:]g08000B]g003002]g:gL00V]g003002]g:gL00:]g08000B]
g003002]g:gL00R]g003002]g:gL00:]g08000B]g003002]g:gL00R]g003002]g:gL00:]g08000B]
g003002]g:gL00R]g003002]g:gL00:]g08000B]g003002]g:gL00V]g003002]g:gL00:]g08000B]
g003002]g:gL00R]g003002]g:gL00:]g08000B]g003002]g:gL00R]g003002]g:gL00:]g08000B]
g003002]g:gL00V]g003002]g:gL008000J]g003002Ug:GL00RUg003002U_:Fl008000RU_003002U
_:Fl00JU_0<000;oo`<008Ooo`00I_oo00<00:gL[M`01JgL0P0000>]g000[M`02JgL00<00:gL[M`0
1JgL0P000ZgL00<00:gL[M`01jgL00<00:gL00001JgL0P000ZgL00<00:gL[M`01jgL00<00:gL[M`0
1JgL0P000ZgL00<00:gL[M`02:gL00<00:gL[M`01JgL0P000ZgL00<00:gL[M`01jgL00<00:gL[M`0
1JgL0P000ZgL00<00:gL[M`01jgL00<00:gL[M`01JgL0P000ZgL00<00:gL[M`01jgL00<00:gL[M`0
1JgL0P000ZgL00<00:gL[M`02:gL00<00:gL[M`01JgL0P000ZgL00<00:gL[M`01jgL00<00:gL[M`0
1JgL0P000ZgL00<00:gL[M`01jgL00<00:gL[M`01JgL0P000ZgL00<00:gL[M`02:gL00<00:gL[M`0
0jgL0`000ZgL00<00:GLYM`02JGL00<00:FlYK`00ZFl0P001JFl00<00:FlYK`01jFl00<00:FlYK`0
0P000ooo0`00Q?oo001Uool00`00[Mb]g008[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[M`0
0007[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g008[M`30009[M`00`00[Mb]g007[M`3
0009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g008[M`30008[M`0
0`00[Mb]g008[M`30008[M`00`00[Mb]g008[M`3000:[M`00`00[Mb]g006[M`3000:YM`00`00YKbU
_005YK`20002YK`00`00YKbU_008YK`00`00YKbU_002YK`20004ool20022ool006Coo`8000Z]g003
002]g:gL00<000F]g003002]g:gL00R]g003002]g:gL00<000F]g004002]g:gL0007[M`00`00[Mb]
g0030005[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]g009[M`00`00[Mb]g0030005
[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00
[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]g009[M`00`00[Mb]g0020005[M`00`00[Mb]g009
[M`00`00[Mb]g0020005[M`00`00[Mb]g009[M`00`00[Mb]g0030006[M`00`00[Mb]g007[M`00`00
YMbUg0020007YM`00`00YKbU_008YK`2000:YK`00`00YKbU_005YK`20004ool3001oool006Coo`03
002]g:gL00V]g003002]g:gL00>]g0<000:]g003002]g:gL00R]g003002]g:gL00>]g0<000:]g004
002]g:gL0007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`0
0`00[Mb]g008[M`00`00[Mb]g004[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`0
0`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`0
0`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`0
0`00[Mb]g008[M`00`00[Mb]g004[M`30002[M`00`00[Mb]g007[M`00`00YMbUg003YM`20004YM`0
0`00YKbU_009YK`01000YK`000001jFl00<00:FlYK`02:Fl0`000_oo00<00?oo00000P008_oo0P00
1?oo00<00?ooool00ooo0P00C?oo001Sool30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007
[M`30002[M`00`00[Mb]g004[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`3000:[M`00`00
[Mb]g007[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007
[M`3000:[M`00`00[Mb]g006[M`3000:[M`00`00[Mb]g006[M`3000:[M`00`00[Mb]g007[M`30009
[M`00`00YMbUg005YM`20002YM`00`00YKbU_008YK`00`00YKbU_002YK`20004YK`00`00YKbU_009
YK`00`00YKbU_0020005ool2000Oool01000ooooo`002?oo00@00?ooool004_oo`00Hooo00<00:gL
[M`00`001JgL00<00:gL[M`02:gL00<00:gL[M`00`001JgL00<00:gL[M`02:gL00<00:gL[M`00`00
1JgL00<00:gL[M`02:gL00<00:gL[M`00`001JgL00<00:gL[M`02:gL00<00:gL[M`00`001ZgL00<0
0:gL[M`02:gL00<00:gL[M`00`001JgL00<00:gL[M`02:gL00<00:gL[M`00`001JgL00<00:gL[M`0
2:gL00<00:gL[M`00`001JgL00<00:gL[M`02:gL00<00:gL[M`00`001ZgL00<00:gL[M`01jgL00<0
0:gL[M`00`001ZgL00<00:gL[M`01jgL00<00:gL[M`00`001ZgL00<00:gL[M`02:gL00<00:gL[M`0
0P001ZgL00<00:GLYM`02:GL0`002ZFl00<00:FlYK`01:Fl0P000ZFl00<00:FlYK`02:Fl00<00:Fl
YK`00jFl0P001Ooo0`007?oo00@00?ooool000Soo`04003ooooo001;ool006;oo`8000F]g0<000:]
g003002]g:gL00R]g003002]g:gL00>]g0<000:]g003002]g:gL00R]g003002]g:gL00:]g0@000:]
g003002]g:gL00R]g003002]g:gL00>]g0<000:]g003002]g:gL00R]g003002]g:gL00>]g0<000:]
g003002]g:gL00R]g003002]g:gL00B]g0<000:]g003002]g:gL00N]g003002]g:gL00B]g0<000:]
g003002]g:gL00N]g003002]g:gL00B]g0<000:]g003002]g:gL00R]g003002]g:gL00>]g0<000:]
g003002]g:gL00R]g003002]g:gL00>]g0<000:]g003002]g:gL00R]g003002]g:gL00>]g0<000:]
g003002]g:gL00R]g003002]g:gL00>]g0<000:]g003002Ug:GL00VUg003002U_:Fl00<000JU_003
002U_:Fl00NU_0<000ZU_003002U_:Fl00FU_08000Koo`<001Woo`04003ooooo0009ool2001<ool0
06;oo`03002]g:gL00N]g0<000V]g003002]g:gL00N]g0<000V]g003002]g:gL00:]g003002]g:gL
00:]g0<000V]g003002]g:gL00N]g0<000V]g003002]g:gL00N]g0<000Z]g003002]g:gL00N]g0<0
00V]g003002]g:gL00N]g0<000V]g003002]g:gL00N]g0<000V]g003002]g:gL00N]g0<000V]g003
002]g:gL00N]g0<000V]g003002]g:gL00N]g0<000Z]g003002]g:gL00J]g0<000ZUg003002U_:Fl
00BU_0<000:U_003002U_:Fl00RU_003002U_:Fl00<000JU_003002U_:Fl00RU_08000Ooo`8001Oo
o`04003ooooo0008ool01000ooooo`00Booo001Qool00`00[Mb]g008[M`00`00[Mb]g0030005[M`0
0`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]g003[M`00`00[Mb]g002[M`00`00[Mb]g003
0005[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`00`00[Mb]g0030006[M`0
0`00[Mb]g008[M`00`00[Mb]g0020006[M`00`00[Mb]g008[M`00`00[Mb]g0020006[M`00`00[Mb]
g008[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`0
0`00[Mb]g0030005[M`00`00[Mb]g008[M`00`00[Mb]g0030006[M`00`00[Mb]g007[M`00`00YMbU
g0020008YM`00`00YKbU_007YK`2000:YK`00`00YKbU_004YK`30002YK`00`00YKbU_009YK`01000
YI`000001ooo0`005?oo00@00?ooool000Soo`04003ooooo001;ool004Ooo`8000Coo`03003ooooo
00Coo`03003ooooo00Woo`8000Z]g003002]g:gL00>]g0<000:]g003002]g:gL00R]g003002]g:gL
00>]g0<000:]g003002]g:gL00>]g003002]g:gL00:]g003002]g:gL00>]g0<000:]g003002]g:gL
00R]g003002]g:gL00>]g0<000:]g003002]g:gL00R]g003002]g:gL00>]g0<000:]g003002]g:gL
00R]g003002]g:gL00>]g0<000:]g003002]g:gL00R]g003002]g:gL00>]g0<000:]g003002]g:gL
00R]g003002]g:gL00B]g0<000:]g003002]g:gL00N]g003002]g:gL00B]g0<000:]g003002]g:gL
00N]g003002]g:gL00B]g0<000:]g003002]g:gL00N]g003002]g:gL00B]g0<000:]g003002]g:gL
00N]g003002Ug:GL00>Ug08000FUg003002U_:Fl00RU_004002U_0000008YK`00`00YKbU_007YK`2
000;YK`00`00YIbUW002YI`20007ool4000Bool2000:ool2001<ool004Koo`04003ooooo000:ool0
0`00ooooo`09ool20009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`30005[M`01@00[Mb]
g:gL00002JgL0`002JgL00<00:gL[M`01jgL0`002JgL00<00:gL[M`01jgL0`002ZgL00<00:gL[M`0
1ZgL0`002ZgL00<00:gL[M`01ZgL0`002ZgL00<00:gL[M`01jgL0`002JgL00<00:gL[M`01jgL0`00
2JgL00<00:gL[M`01jgL0`002JgL00<00:gL[M`01jgL0`002JgL00<00:GLYM`01JGL0P000ZGL00<0
0:FlYK`02:Fl00<00:FlYK`00ZFl0P001JFl00<00:FlYK`02:Fl00@00:Fl000000RU_003002UW:FL
00FUW08000Coo`03003ooooo00;oo`8006[oo`00A_oo00@00?ooool000Ooo`D000Woo`03002]g:gL
00<000F]g003002]g:gL00R]g003002]g:gL00<000F]g003002]g:gL00R]g003002]g:gL00<000:]
g004002]g:gL000:[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00
[Mb]g008[M`00`00[Mb]g0030006[M`00`00[Mb]g007[M`00`00[Mb]g0030006[M`00`00[Mb]g007
[M`00`00[Mb]g0030006[M`00`00[Mb]g008[M`00`00[Mb]g0020006[M`00`00[Mb]g008[M`00`00
[Mb]g0020006[M`00`00[Mb]g008[M`00`00[Mb]g0020006[M`00`00[Mb]g008[M`00`00[Mb]g002
0006[M`00`00YMbUg008YM`30009YK`00`00YKbU_005YK`20002YK`00`00YKbU_008YK`00`00YKbU
_002YK`20005YK`00`00YIbUW008YI`30008ool3001Wool004Koo`04003ooooo0007ool01000oooo
o`002_oo00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL
[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL
[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL
[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL
[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL
[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:GL
YM`02JGL00<00:FlYK`00P001ZFl00<00:FlYK`02:Fl0`002ZFl00<00:FlYK`01:Fl0P000ZFl00<0
0:FLYI`02JFL00<00:FLYI`00P002Ooo0`00I?oo0016ool01000ooooo`002?oo00<00?oo00002Ooo
00<00:gL[M`01jgL0`002JgL00<00:gL[M`01jgL0`002JgL00<00:gL[M`01ZgL10002JgL00<00:gL
[M`01jgL0`002JgL00<00:gL[M`01jgL0`002JgL00<00:gL[M`01jgL0`002JgL00<00:gL[M`01jgL
0`002JgL00<00:gL[M`01jgL0`002ZgL00<00:gL[M`01ZgL0`002ZgL00<00:gL[M`01ZgL0`002ZgL
00<00:gL[M`01ZgL0`002ZgL00<00:gL[M`01ZgL0`002ZGL00<00:FlYK`00jFl0`000ZFl00<00:Fl
YK`02JFl00<00:FlYK`00`001ZFl00<00:FlYK`01jFl0`002ZFL00<00:FLYI`00jFL0P002_oo0P00
H_oo0016ool01000ooooo`002Ooo0P002?oo0P002ZgL00<00:gL00000P001JgL00<00:gL[M`02JgL
00<00:gL00000P001JgL00<00:gL[M`01jgL0P000ZgL0`001JgL00<00:gL[M`02:gL00<00:gL[M`0
0`001JgL00<00:gL[M`02:gL00<00:gL[M`00`001JgL00<00:gL[M`02:gL00<00:gL[M`00`001JgL
00<00:gL[M`02:gL00<00:gL[M`00`001JgL00<00:gL[M`02:gL00<00:gL[M`00`001ZgL00<00:gL
[M`01jgL00<00:gL[M`00`001ZgL00<00:gL[M`01jgL00<00:gL[M`00`001ZgL00<00:gL[M`01jgL
00<00:gL[M`00`001ZgL00<00:gL[M`01jgL00<00:gL[M`00P002:GL00<00:FlYK`01ZFl0`002ZFl
00<00:FlYK`01:Fl0`000ZFl00<00:FlYK`02:Fl00<00:FLYI`00P002:FL00<00:FLYI`01JFL0P00
2_oo0`00Gooo0017ool2000;ool00`00ooooo`06ool00`00[Mb]g008[M`00`00[Mb]g003[M`30002
[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`20005[M`30002[M`00`00
[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00
[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00
[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00
[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g004[M`30002[M`00`00
[Mb]g008[M`00`00[Mb]g002[M`20005YM`00`00YKbU_007YK`00`00YKbU_0020008YK`00`00YKbU
_007YK`2000:YK`00`00YIbUW003YI`20005YI`00`00YIbUW008YI`2000;ool3001Lool005coo`80
00Z]g003002]g:gL00J]g0<000Z]g003002]g:gL00J]g0<000V]g003002]g:gL00N]g0<000V]g003
002]g:gL00N]g0<000V]g003002]g:gL00N]g0<000V]g003002]g:gL00N]g0<000V]g003002]g:gL
00N]g0<000V]g003002]g:gL00N]g0<000V]g003002]g:gL00N]g0<000V]g003002]g:gL00N]g0<0
00V]g003002]g:gL00N]g08000Z]g003002]g:gL00F]g08000:Ug003002U_:Fl00NU_003002U_:Fl
00>U_08000FU_003002U_:Fl00RU_004002U_0000008YK`00`00YIbUW005YI`20002YI`00`00YIbU
W009YI`01000YG`000001ooo0P000ooo0`00FOoo001Lool00`00[M`000020006[M`00`00[Mb]g008
[M`00`00[M`000020006[M`00`00[Mb]g008[M`00`00[M`000020005[M`20009[M`00`00[Mb]g003
0005[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`0
0`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]
g008[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`0
0`00[Mb]g0020006[M`00`00[Mb]g008[M`01000[M`000001jgL00<00:gL[M`02:gL0`002JFl00<0
0:FlYK`01JFl0P000ZFl00<00:FlYK`02:Fl00<00:FlYK`00ZFl0P001JFl00<00:FLYI`02:FL0P00
2jFL00<00:ElYG`00ZEl0P001?oo00<00?ooool01_oo0P00Eooo001Kool00`00[Mb]g003[M`40002
[M`00`00[Mb]g007[M`00`00[Mb]g003[M`40002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002
[M`20009[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00
[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00
[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00
[Mb]g007[M`00`00[Mb]g004[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00
[Mb]g008[M`00`00[Mb]g002[M`20004[M`00`00[Mb]g009[M`00`00YKbU_0020006YK`00`00YKbU
_008YK`30009YK`00`00YKbU_005YK`20002YK`00`00YIbUW009YI`01000YI`000002:FL00<00:El
YG`01JEl0P003Ooo0`00E?oo001Kool00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`30009[M`0
0`00[Mb]g006[M`40008[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]
g007[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`3
0009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g006[M`3000:[M`00`00[Mb]g004[M`20002[M`0
0`00[Mb]g008[M`00`00YKbU_003YK`30002YK`00`00YKbU_009YK`00`00YKbU_0020006YK`00`00
YKbU_008YK`2000;YI`00`00YIbUW002YI`20005YI`00`00YGbUO008YG`2000>ool3001Aool002;o
o`8003Koo`03002]g:gL00R]g003002]g:gL00<000F]g003002]g:gL00R]g003002]g:gL00<000F]
g003002]g:gL00R]g003002]g000008000F]g003002]g:gL00R]g003002]g:gL00<000F]g003002]
g:gL00R]g003002]g:gL00<000F]g003002]g:gL00R]g003002]g:gL00<000F]g003002]g:gL00R]
g003002]g:gL00<000F]g003002]g:gL00R]g003002]g:gL00<000F]g003002]g:gL00R]g003002]
g:gL008000J]g003002]g:gL00R]g003002]g:gL008000J]g003002]g:gL00N]g003002]g:gL00<0
00J]g003002]g:gL00N]g0<000Z]g003002U_:Fl00JU_0<000ZU_003002U_:Fl00>U_0<000:U_003
002U_:Fl00VU_004002UW0000008YI`00`00YIbUW005YI`20002YI`00`00YGbUO009YG`01000WG`0
00003ooo0P00Cooo000Tool00`00ooooo`0cool00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`0
0`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`01000[Mb]g0000ZgL0`000ZgL
00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL
00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL
00<00:gL[M`01jgL00<00:gL[M`01:gL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00jgL0`000ZgL
00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL
00<00:gL[M`02:gL00<00:gL[M`00`001ZgL00<00:FlYK`01jFl00<00:FlYK`00P002:Fl00<00:Fl
YK`01ZFl0`002ZFl00<00:FLYI`00ZFL0P001JFL00<00:FLYI`02:FL0`002ZEl00<009elWG`00Yel
0P003_oo1000C?oo000Tool2000cool20009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`3
0009[M`00`00[M`00006[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`30009[M`0
0`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]
g006[M`3000:[M`00`00[Mb]g006[M`30009[M`00`00[Mb]g007[M`3000:[M`00`00[Mb]g003[M`3
0002[M`00`00YKbU_007YK`00`00YKbU_003YK`20005YK`00`00YKbU_007YK`00`00YKbU_0020008
YK`00`00YIbUW004YI`20002YI`00`00YIbUW009YI`00`00YGbUO0020008YG`00`00WGbMO004WG`2
000;ool00`00ooooo`02ool30019ool002?oo`04003ooooo000aool200001:gL000000001JgL00<0
0:gL[M`02:gL00<00:gL[M`00`001JgL00<00:gL[M`02:gL00<00:gL[M`00`001JgL00@00:gL[M`0
00N]g003002]g000008000F]g003002]g:gL00R]g003002]g:gL00<000F]g003002]g:gL00R]g003
002]g:gL00<000F]g003002]g:gL00R]g003002]g:gL00<000F]g003002]g:gL00R]g003002]g:gL
008000J]g003002]g:gL00R]g003002]g:gL008000J]g003002]g:gL00N]g003002]g:gL00<000J]
g003002]g:gL00N]g003002]g:gL00<000F]g003002]g:gL00R]g003002]g:gL008000N]g003002]
g:gL00N]g0<000VU_003002U_:Fl00FU_08000:U_003002U_:Fl00NU_003002U_:Fl00>U_08000FU
_003002UW:FL00NUW0<000ZUW003002UO:El00>UO08000FUO003002MO9el00NMO080017oo`8004Oo
o`008ooo00@00?ooool0037oo`03002]g:gL00>]g0<000:]g003002]g:gL00R]g003002]g:gL00>]
g0<000:]g003002]g:gL00R]g003002]g:gL00>]g0<000:]g004002]g:gL0006[M`00`00[Mb]g003
[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003
[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003
[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003
[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003
[M`20004[M`00`00[Mb]g008[M`00`00YKbU_0020006YK`00`00YKbU_008YK`30009YK`00`00YKbU
_005YK`20002YK`00`00YIbUW008YI`00`00YIbUW0020008YI`00`00YGbUO005YG`20002YG`00`00
WGbMO00:WG`00`00ooooo`0@ool30014ool002?oo`04003ooooo000`ool20008[M`30009[M`00`00
[Mb]g007[M`30009[M`00`00[Mb]g007[M`30002[M`00`00[Mb]g004[M`00`00[Mb]g006[M`30009
[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`30009[M`00`00
[Mb]g006[M`3000:[M`00`00[Mb]g006[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007
[M`30009[M`00`00[Mb]g005[M`20002[M`00`00[Mb]g007[M`00`00YKbU_003YK`30002YK`00`00
YKbU_009YK`00`00YKbU_0020006YK`00`00YKbU_008YK`2000:YI`00`00YIbUW003YI`20005YI`0
0`00YGbUO008YG`2000<WG`01000WC/000004ooo0`00@Ooo000Rool200000ooo0000000`ool00`00
[Mb]g008[M`00`00[M`000020005[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]g008
[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`00`00[M`000020005[M`00`00[Mb]g008[M`00`00
[Mb]g0030005[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`00`00[Mb]g002
0006[M`00`00[Mb]g007[M`00`00[Mb]g0030006[M`00`00[Mb]g007[M`00`00[Mb]g0030005[M`0
0`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`00`00[Mb]g0020006[M`00`00[Mb]
g008[M`30009[M`00`00YKbU_006YK`3000:YK`00`00YKbU_003YK`30002YK`00`00YKbU_009YK`0
1000YK`000002:FL00<00:FLYI`01JFL0P000ZFL00<00:ElYG`02JEl00@009el000000RMO08000BM
>`8001Coo`8003ooo`00E_oo0P002JgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL
[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00ZgL10000ZgL00<00:gL[M`01jgL00<00:gL
[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL
[M`00jgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL
[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01jgL00<00:gL
[M`01:gL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02JgL00<00:gL
[M`00P001ZgL00<00:FlYK`01jFl00<00:FlYK`00P002:Fl00<00:FlYK`01ZFl0`002ZFl00<00:Fl
YK`00ZFl0P001JFL00<00:FLYI`02:FL0P002jEl00<009elWG`00Yel0P001Iel00<009dkWC/01Ydk
0P004ooo1000??oo001Fool20009[M`00`00[Mb]g006[M`30009[M`00`00[Mb]g007[M`30009[M`0
0`00[Mb]g003[M`01000[Mb]g:gL0`002JgL00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01jgL0`00
2JgL00<00:gL[M`01jgL0`002JgL00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01jgL0`002JgL00<0
0:gL[M`01jgL0`002JgL00<00:gL[M`01jgL0`002JgL00<00:gL[M`01ZgL0`002ZgL00<00:gL[M`0
0jgL0`000ZgL00<00:FlYK`01jFl00<00:FlYK`00jFl0P001JFl00<00:FlYK`01jFl00<00:FlYK`0
0P002:Fl00<00:FlYK`01:Fl0P000ZFL00<00:FLYI`02JFL00@00:FL000000RUO003002MO9el00FM
O08000:MO003002M>idk00VM>`80013oo`03003ooooo00;oo`<003Woo`00EOoo00<00:gL[M`00`00
1JgL00<00:gL[M`02:gL00<00:gL00000P001JgL00<00:gL[M`02:gL00<00:gL[M`00`001JgL00<0
0:gL[M`01:gL0P000ZgL00<00:gL[M`00`001JgL00<00:gL[M`01jgL00<00:gL[M`00`001JgL00<0
0:gL[M`02:gL00<00:gL[M`00`001JgL00<00:gL[M`02:gL00<00:gL[M`00P001ZgL00<00:gL[M`0
1jgL00<00:gL[M`00`001JgL00<00:gL[M`02:gL00<00:gL[M`00`001JgL00<00:gL[M`02:gL00<0
0:gL[M`00P001ZgL00<00:gL[M`02:gL00<00:gL[M`00P001ZgL00<00:gL[M`01jgL00<00:gL[M`0
0`001ZgL00<00:gL[M`01jgL0`002JFl00<00:FlYK`01JFl0P000ZFl00<00:FlYK`01jFl00<00:Fl
YK`00jFl0P001JFl00<00:FlYK`01jFl0`002ZFL00<00:FLYI`00ZFL0P001JEl00<009elWG`029el
0P0039dk00@009dK000001Koo`8003Ooo`00E?oo0P001JgL0`000ZgL00<00:gL[M`01jgL00<00:gL
[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`00jgL00<00:gL
[M`00`001JgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<0
0:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00ZgL0`000ZgL00<00:gL[M`02:gL00<0
0:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01jgL00<0
0:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<0
0:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:GLYM`00P001ZFl00<00:FlYK`02:Fl0`002JFl
00<00:FlYK`01JFl0P000ZFl00<00:FlYK`02:Fl00<00:FLYI`00P002:FL00<00:FLYI`01:FL0P00
0ZEl00<009elWG`02Iel00@009eK000000VM>`03002M6idK00:M6`03003ooooo01Goo`<003Coo`00
E?oo00<00:gL[M`01jgL0`002JgL00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01jgL0`001JgL00H0
0:gL[Mb]g000[M`30005[M`30008[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`30009[M`0
0`00[Mb]g006[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]
g006[M`3000:[M`00`00[Mb]g006[M`30009[M`00`00[Mb]g007[M`2000:[M`00`00YMbUg003YM`3
0002YK`00`00YKbU_009YK`00`00YKbU_0020006YK`00`00YKbU_008YK`2000:YK`00`00YIbUW003
YI`20005YI`00`00YIbUW007YI`3000:WG`00`00WE^MF`02WE/20007WC/00`00WA^M6`03WA/2000H
ool3000aool005?oo`03002]g:gL00R]g003002]g:gL00<000F]g003002]g:gL00R]g003002]g000
008000F]g003002]g:gL00R]g003002]g:gL00<00003[M`00:gL00:]g003002]g:gL00>]g0<000:]
g003002]g:gL008000F]g003002]g:gL00R]g003002]g:gL00<000F]g003002]g:gL00R]g003002]
g:gL00<000F]g003002]g:gL00N]g003002]g:gL00<000F]g003002]g:gL00R]g003002]g:gL00<0
00F]g003002]g:gL00R]g003002]g:gL008000J]g003002]g:gL00N]g003002]g:gL00<000J]g003
002]g:gL00N]g003002]g:gL00<000F]g003002]g:gL00R]g004002]g0000008[M`00`00YMbUg006
YM`3000:YK`00`00YKbU_003YK`30002YK`00`00YKbU_009YK`01000YK`000002:Fl00<00:FLYI`0
1JFL0P000ZFL00<00:FLYI`02:FL00<00:ElYG`00P0029el00<009eKWE/019eK0P0019dk00<009dK
WA/01YdK00<00?ooool06?oo0P00;ooo001Cool00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`0
0`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`0
0`00[Mb]g006[M`30004[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]
g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]
g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]
g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g004[M`30002[M`00`00[Mb]
g007[M`00`00[Mb]g002[M`20005[M`00`00YMbUg007YM`00`00YKbU_0020008YK`00`00YKbU_006
YK`2000;YK`00`00YKbU_002YK`20005YK`00`00YIbUW008YI`2000:YI`00`00YGbUO003YG`20005
WG`00`00WE^MF`07WE/200000idk002M6`09WA/2000Iool4000/ool005;oo`8000V]g003002]g:gL
00N]g0<000V]g003002]g:gL00J]g0<000V]g003002]g:gL00B]g003002]g:gL00<000V]g003002]
g000008000B]g0<000V]g003002]g:gL00N]g0<000V]g003002]g:gL00N]g0<000R]g003002]g:gL
00N]g0<000V]g003002]g:gL00N]g0<000V]g003002]g:gL00J]g0<000V]g003002]g:gL00N]g0<0
00V]g003002]g:gL00N]g0<000V]g003002]g:gL00B]g08000:]g003002Ug:GL00RUg003002U_:Fl
00:U_08000FU_003002U_:Fl00NU_004002U_0000008YK`00`00YKbU_005YK`20002YK`00`00YIbU
W009YI`01000YI`000002:FL00<00:ElYG`01JEl0P000Yel00<009eKWE/02YeK00<009dKWA/02idK
00<00?ooool05Ooo00<00?ooool00_oo0`00:Ooo001Bool00`00[M`000020005[M`00`00[Mb]g008
[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`00`00[M`000020005[M`00`00[Mb]g004[M`01@00
[Mb]g:gL00000ZgL0`001JgL00<00:gL[M`00jgL0`000ZgL00<00:gL00000P001JgL00<00:gL[M`0
2:gL00<00:gL[M`00`001JgL00<00:gL[M`02:gL00<00:gL[M`00P001JgL00<00:gL[M`02:gL00<0
0:gL[M`00`001JgL00<00:gL[M`02:gL00<00:gL[M`00P001ZgL00<00:gL[M`01jgL00<00:gL[M`0
0`001JgL00<00:gL[M`02:gL00<00:gL[M`00P001ZgL00<00:gL[M`02:gL00<00:gL[M`00P001ZgL
00<00:gL[M`01jgL0`002JGL00<00:FlYK`01JFl0P000ZFl00<00:FlYK`01jFl00<00:FlYK`00ZFl
0P001JFl00<00:FlYK`02:Fl0`002JFL0P001:FL0P001JFL00<00:ElYG`02:El0P0039eK00<009dK
00002idK00<009Bj00007_oo0P009ooo001Aool00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`0
0`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g004[M`0
1@00[Mb]g:gL00001JgL0`000ZgL00<00:gL[M`01ZgL0`001:gL0`000ZgL00<00:gL[M`02:gL00<0
0:gL[M`00jgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<0
0:gL[M`00jgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<0
0:gL[M`00jgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<0
0:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:GLYM`00`001JGL00<00:FlYK`02:Fl0`002JFl
00<00:FlYK`01:Fl0P000ZFl00<00:FlYK`02JFl00<00:FLYI`00P001ZFL00<00:FLYI`01ZFL0P00
0ZFL00<00:ElYG`02JEl00@009eK000000VMF`04002M6idKWA/20008WA/01@00U;ZD^YBj00007ooo
0`009?oo001@ool20008[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g006[M`30005[M`0
1@00[Mb]g:gL00002JgL0`002JgL00<00:gL00000P001:gL0`002JgL00<00:gL[M`01jgL0`002JgL
00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01jgL0`002JgL00<00:gL[M`01ZgL0`002JgL00<00:gL
[M`01jgL0`002JgL00<00:gL[M`01ZgL0`002ZgL00<00:gL[M`01ZgL0P002ZgL00<00:GLYM`01:GL
0`000ZGL00<00:FlYK`02:Fl00<00:FlYK`00P001ZFl00<00:FlYK`01jFl0`002ZFl00<00:FLYI`0
0jFL0`000ZFL00<00:FLYI`02JFL0P002jEl00<009eKWE/00YeK00<009eKWE/01IeK00<009dKWA/0
19dK00<009dKWA/019dK00<009BjU;X00iBj00<00?ooool07ooo0P008_oo001@ool00`00[Mb]g008
[M`00`00[M`000020005[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`00`00
[M`0000200000jgL002]g002[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]g003[M`3
00001:gL002]g:gL0`001JgL00<00:gL[M`02:gL00<00:gL[M`00P001ZgL00<00:gL[M`01jgL00<0
0:gL[M`00`001JgL00<00:gL[M`02:gL00<00:gL[M`00P001ZgL00<00:gL[M`01jgL00<00:gL[M`0
0`001JgL00<00:gL[M`02:gL00<00:gL[M`00P001ZgL00<00:gL[M`01jgL00<00:gL[M`00`001ZgL
00<00:gL[M`01jgL00@00:gL000000R]g003002Ug:GL00NUg0<000VU_003002U_:Fl00>U_0<000:U
_003002U_:Fl00RU_003002U_:Fl00<000JU_003002UW:FL00NUW0<000^UW004002UO0000008YG`0
0`00WE^MF`04WE/20004WE/00`00WA^M6`06WA/00`00WA^M6`02WA/00`00U;ZD^P05U;X2000Oool2
000Rool004ooo`8000V]g003002]g:gL00>]g0<000:]g003002]g:gL00R]g003002]g:gL00>]g0<0
00:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003002]g:gL00R]g003002]g:gL00>]g0<0
00:]g003002]g:gL00J]g0<000B]g0<000:]g003002]g:gL00R]g003002]g:gL00:]g0<000:]g003
002]g:gL00R]g003002]g:gL00>]g0<000:]g003002]g:gL00R]g003002]g:gL00:]g0<000:]g003
002]g:gL00R]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003
002]g:gL00R]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00:]g08000F]g003
002Ug:GL00RUg003002U_:Fl008000JU_003002U_:Fl00NU_0<000VU_003002U_:Fl00BU_0<000:U
_003002UW:FL00RUW003002UW:FL008000RUW003002UO:El00:UO08000FUO003002MFieK00NMF`80
0003WE/009dK00VM6`800003WA/009Bj00VD^P03003ooooo01_oo`03003oo`0002;oo`00Cooo0P00
2JgL00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01jgL0`002JgL00<00:gL[M`00jgL00<00:gL[M`0
0`002JgL00<00:gL[M`01jgL0`002:gL00<00:gL[M`00`001:gL0`002JgL00<00:gL[M`01ZgL0`00
2JgL00<00:gL[M`01jgL0`002JgL00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01jgL0`002JgL00<0
0:gL[M`01ZgL0`002JgL00<00:gL[M`01jgL0`002JgL00<00:gL[M`01:gL0P000ZgL00<00:GLYM`0
2:GL00<00:FlYK`00jFl0`000ZFl00<00:FlYK`02:Fl00<00:FlYK`00P001ZFl00<00:FlYK`02:Fl
0P002ZFL00<00:FLYI`00jFL0P001JFL00<00:ElYG`01JEl0P000ZEl00<009eKWE/02YeK00<009dK
WA/02idK00<009BjU;X02YBj00<00?ooool06Ooo00D00?ooooooo`0000Ooo`8001Soo`00C_oo00<0
0:gL[M`00`001JgL00<00:gL[M`02:gL00<00:gL00000P001JgL00<00:gL[M`02:gL00<00:gL[M`0
0`001JgL00<00:gL[M`00jgL00D00:gL[Mb]g00000:]g0<000F]g003002]g:gL00R]g003002]g:gL
008000F]g003002]g:gL00B]g0<00004[M`00:gL[M`30005[M`00`00[Mb]g007[M`00`00[Mb]g003
0005[M`00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00[Mb]g007[M`00`00[Mb]g0030005[M`0
0`00[Mb]g008[M`00`00[Mb]g0020006[M`00`00[Mb]g007[M`00`00[Mb]g0030005[M`00`00[Mb]
g008[M`00`00[Mb]g0020006[M`00`00[Mb]g007[M`3000:YM`00`00YKbU_006YK`2000:YK`00`00
YKbU_003YK`30002YK`00`00YKbU_009YK`01000YI`000002:FL00<00:FLYI`01JFL0P000ZFL00<0
0:ElYG`02:El0P0039eK00@009dK000000ZM6`04002D^P00000;U;X00`00ooooo`0Gool00`00oooo
o`02ool00`00ooooo`04ool01000ooooo`005ooo001>ool00`00[Mb]g003[M`30002[M`00`00[Mb]
g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]
g003[M`01@00[Mb]g:gL00001JgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00ZgL0`000ZgL00<0
0:gL[M`01jgL0`001:gL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`0
2:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`0
1jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`0
1jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00`001ZGL00<00:FlYK`01jFl
00@00:Fl000000RU_003002U_:Fl00JU_0<000ZU_003002UW:FL00:UW08000FUW003002UW:FL00RU
W08000^UO004002MF`000009WE/00`00WA^M6`02WA/20007WA/00`00U;ZD^P02U;X00`00U;ZD^P07
U;X00`00Q3T0000Gool00`00ooooo`03ool00`00ooooo`04ool01000ooooo`005ooo001=ool00`00
[Mb]g007[M`30009[M`00`00[Mb]g006[M`30009[M`00`00[Mb]g007[M`30004[M`01@00[Mb]g:gL
00002JgL0`002JgL00<00:gL[M`01ZgL0`002JgL00<00:gL[M`00`001:gL0`002:gL00<00:gL[M`0
1jgL0`002JgL00<00:gL[M`01jgL0`002:gL00<00:gL[M`01jgL0`002JgL00<00:gL[M`01ZgL0`00
2JgL00<00:gL[M`01jgL0`002JgL00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01:gL0`000ZGL00<0
0:FlYK`01jFl00<00:FlYK`00ZFl0P001JFl00<00:FlYK`01jFl00<00:FlYK`00P002:Fl00<00:FL
YI`01:FL0P000ZFL00<00:FLYI`02JFL00@00:El000000RUO003002MFieK00:MF`8000NMF`03002M
6idK00BM6`8000BM6`03002D^YBj00BD^P8000JD^P050024>H@iQ3T0000Eool00`00ooooo`04ool0
0`00ooooo`04ool01000ooooo`005ooo001<ool00`00[Mb]g008[M`00`00[Mb]g0030005[M`00`00
[Mb]g008[M`00`00[M`000020005[M`00`00[Mb]g008[M`00`00[Mb]g0020002[M`01000[Mb]g000
2ZgL00<00:gL[M`00`001JgL00<00:gL[M`01jgL00<00:gL[M`00`001JgL00<00:gL[M`01:gL0`00
00B]g000[Mb]g08000F]g003002]g:gL00R]g003002]g:gL00<000F]g003002]g:gL00R]g003002]
g:gL008000F]g003002]g:gL00R]g003002]g:gL008000J]g003002]g:gL00N]g003002]g:gL00<0
00F]g003002]g:gL00R]g003002]g:gL008000J]g003002]g:gL00N]g003002]g:gL00<000J]g003
002]g:gL00N]g0<000VU_003002U_:Fl00BU_08000:U_003002U_:Fl00NU_003002U_:Fl00>U_080
00FU_003002UW:FL00NUW08000^UW003002UO:El00:UO003002UO:El00FUO003002MFieK00BMF`80
00BMF`03002M6idK00NM6`800003WA/009Bj00RD^P03002D^YBj00:D^P030024>H@i00>4>@03003o
oooo017oo`03003ooooo00Goo`03003ooooo00Coo`04003ooooo000Gool004coo`03002]g:gL00R]
g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003002]g:gL00R]
g003002]g:gL00:]g0<000:]g003002]g:gL00R]g003002]g:gL00>]g0<000:]g003002]g:gL00N]
g003002]g:gL00>]g0<000:]g003002]g:gL00N]g0<000>]g0<000:]g003002]g:gL00R]g003002]
g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003002]g:gL00R]g003002]
g:gL00:]g0<000:]g003002]g:gL00R]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]
g:gL00>]g0<000:]g003002]g:gL00R]g003002]g:gL00>]g0<000:]g003002]g:gL00R]g003002U
_:Fl008000JU_003002U_:Fl00NU_0<000VU_003002U_:Fl00FU_08000:U_003002UW:FL00RUW004
002UW0000008YI`00`00YGbUO004YG`20004YG`00`00WE^MF`07WE/200000ieK002M6`0;WA/00`00
U;ZD^P09U;X200000iBj0024>@06Q3T00`00ooooo`0?ool00`00ooooo`06ool00`00ooooo`04ool0
1000ooooo`005ooo001;ool20009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g006[M`30009[M`0
0`00[Mb]g003[M`00`00[Mb]g0030009[M`00`00[Mb]g007[M`30008[M`00`00[Mb]g007[M`30009
[M`00`00[Mb]g0030003[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g006[M`30009[M`0
0`00[Mb]g006[M`30009[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g006[M`30009[M`00`00[Mb]
g007[M`2000:[M`00`00YKbU_003YK`30002YK`00`00YKbU_008YK`00`00YKbU_0020006YK`00`00
YKbU_008YK`2000:YI`00`00YIbUW002YI`20005YI`00`00YGbUO007YG`200000jEl002MF`0;WE/0
0`00WA^M6`0:WA/00`00U=X0000<U;X00`00Q3V4>@07Q3T2000?ool00`00ooooo`07ool00`00oooo
o`04ool2000Hool004_oo`03002]g000008000F]g003002]g:gL00R]g003002]g:gL00<000F]g003
002]g:gL00N]g003002]g:gL00<000F]g003002]g:gL00B]g006002]g:gL[M`00:gL0`001JgL00<0
0:gL[M`02:gL00<00:gL[M`00P001JgL00<00:gL[M`02:gL00<00:gL[M`00`001JgL00<00:gL[M`0
1:gL10000ZgL0`001JgL00<00:gL[M`02:gL00<00:gL[M`00P001ZgL00<00:gL[M`01jgL00<00:gL
[M`00`001JgL00<00:gL[M`01jgL00<00:gL[M`00`001JgL00<00:gL[M`02:gL00<00:gL[M`00P00
1ZgL00<00:gL[M`01jgL00<00:gL[M`00`001JgL00<00:gL[M`02:gL00@00:gL000000R]g003002U
_:Fl00JU_0<000VU_003002U_:Fl00>U_0<000:U_003002U_:Fl00VU_004002UW0000008YI`00`00
YIbUW004YI`20002YI`00`00YGbUO00:YG`00`00WE^MF`0:WE/01000WA/000002IdK00D009CJU=ZD
fP0000ZD^P030024>@0000Z4>@03003ooooo00_oo`03003ooooo00Soo`03003ooooo01koo`00B_oo
00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01jgL
00<00:gL[M`00jgL0`000ZgL00<00:gL[M`00jgL00D00:gL[Mb]g00000F]g0<000:]g003002]g:gL
00R]g003002]g:gL00:]g0<000:]g003002]g:gL00R]g003002]g:gL00>]g0<000:]g003002]g:gL
00N]g0<000>]g0<000:]g003002]g:gL00R]g003002]g:gL00:]g0<000:]g003002]g:gL00R]g003
002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003
002]g:gL00>]g0<000:]g003002]g:gL00R]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003
002]g:gL00:]g08000F]g003002U_:Fl00NU_003002U_:Fl008000JU_003002U_:Fl00NU_0<000ZU
_003002UW:FL00:UW08000FUW003002UW:FL00NUW0<000^UO004002MF`000008WE/20004WA/00`00
WA^M6`05WA/00`00U=ZDfP03U=X00`00U;ZD^P06U;X01@00Q3V4>H@i00002X@i00<00?ooool02Ooo
00<00?ooool02Ooo00<00?ooool07_oo001:ool00`00[Mb]g006[M`30009[M`00`00[Mb]g007[M`3
0008[M`00`00[Mb]g007[M`30004[M`00`00[Mb]g002[M`00`00[Mb]g006[M`30009[M`00`00[Mb]
g006[M`30009[M`00`00[Mb]g007[M`30008[M`01000[Mb]g:gL0`000jgL0`002JgL00<00:gL[M`0
1ZgL0`002JgL00<00:gL[M`01jgL0`002:gL00<00:gL[M`01jgL0`002JgL00<00:gL[M`01ZgL0`00
2JgL00<00:gL[M`01jgL0`002JgL00<00:gL[M`01:gL0P000ZgL00<00:FlYK`01jFl00<00:FlYK`0
0jFl0`000ZFl00<00:FlYK`02:Fl00<00:FlYK`00P002:Fl00<00:FLYI`01:FL0P000ZFL00<00:FL
YI`02:FL00<00:ElYG`00P002:El00<009eKWE/00YeK0P001IeK00<009dKWA/01IdK0P0019dK00<0
09CJU=X01ICJ0P001IBj00<008@iQ3T00h@i00<008@iQ3T028@i00<00?ooool01ooo00<00?ooool0
2_oo00<00?ooool07_oo0019ool00`00[Mb]g008[M`00`00[M`000020005[M`00`00[Mb]g008[M`0
0`00[Mb]g0020005[M`00`00[Mb]g008[M`00`00[Mb]g00300000jgL002]g002[M`00`00[Mb]g007
[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`00`00[M`000020005[M`00`00[Mb]g008[M`00`00
[Mb]g0020005[M`00`00[Mb]g005[M`200001:gL002]g:gL0`001JgL00<00:gL[M`01jgL00<00:gL
[M`00`001JgL00<00:gL[M`02:gL00<00:gL[M`00P001JgL00<00:gL[M`02:gL00<00:gL[M`00P00
1ZgL00<00:gL[M`01jgL00<00:gL[M`00`001JgL00<00:gL[M`02:gL00<00:gL[M`00P001ZgL00<0
0:gL[M`01jgL0`002JFl00<00:FlYK`01ZFl0P002ZFl00<00:FlYK`00jFl0P001JFl00<00:FLYI`0
1jFL0P002ZFL00<00:ElYG`00jEl0P001JEl00<009eKWE/01IeK0P000YeK00<009dKWA/029dK0P00
00>M6`00U=X02ICJ00D009BjU;ZD^P0000N4>@030024>H@i00R4>@03003ooooo00Goo`03003ooooo
00Soo`800003ool00?oo01ooo`00B?oo0P002JgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL
00<00:gL[M`00ZgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01jgL
00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL
00<00:gL[M`00ZgL0`000ZgL00<00:gL[M`01jgL0`001:gL0`000ZgL00<00:gL[M`01jgL00<00:gL
[M`00jgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:gL
[M`00ZgL0`000ZgL00<00:gL[M`02:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01jgL00<00:gL
[M`00jgL0`000ZgL00<00:gL[M`02:gL00<00:FlYK`00P001ZFl00<00:FlYK`01jFl00@00:Fl0000
00RU_003002U_:Fl00FU_08000:U_003002UW:FL00RUW004002UW0000008YI`00`00YGbUO005YG`2
0002YG`00`00WE^MF`08WE/2000=WA/00`00U=ZDfP0:U=X00`00U;X00009Q3T00`00Q3V4>@06Q3T0
0`00LgL00005ool00`00ooooo`0;ool3000Oool004Soo`8000V]g003002]g:gL00J]g0<000V]g003
002]g:gL00J]g0<000V]g003002]g:gL00B]g003002]g:gL00<000R]g003002]g:gL00N]g0<000V]
g003002]g:gL00J]g0<000V]g003002]g:gL00J]g0<000V]g003002]g:gL00<000B]g0<000R]g003
002]g:gL00N]g0<000V]g003002]g:gL00J]g0<000V]g003002]g:gL00J]g0<000V]g003002]g:gL
00N]g0<000V]g003002]g:gL00J]g0<000V]g003002U_:Fl00>U_0<000:U_003002U_:Fl00NU_003
002U_:Fl00:U_08000FU_003002U_:Fl00RU_0<000VUW003002UW:FL00:UW08000FUW003002UO:El
00RUO08000^MF`04002M6`00000:WA/01000U=X000002iCJ00<008@iQ3T02H@i00<008@iQ3T00h@i
0P000W=g00<00?ooool00_oo00<00?ooool03_oo00<00?ooool07Ooo0017ool200001:gL00000000
1JgL00<00:gL[M`02:gL00<00:gL00000P001JgL00<00:gL[M`02:gL00<00:gL00000P001JgL00<0
0:gL[M`01:gL00D00:gL[Mb]g00000:]g08000F]g003002]g:gL00R]g003002]g:gL00<000F]g003
002]g:gL00N]g003002]g:gL00<000F]g003002]g:gL00N]g003002]g:gL00<000F]g003002]g:gL
00B]g0<00004[M`00:gL[M`20005[M`00`00[Mb]g008[M`00`00[Mb]g0020006[M`00`00[Mb]g007
[M`00`00[Mb]g0030005[M`00`00[Mb]g007[M`00`00[Mb]g0030005[M`00`00[Mb]g008[M`00`00
[Mb]g0020006[M`00`00[Mb]g007[M`00`00[Mb]g0020006[M`00`00YKbU_007YK`30009YK`00`00
YKbU_004YK`20002YK`00`00YKbU_009YK`00`00YIbUW0020006YI`00`00YIbUW005YI`20002YI`0
0`00YGbUO009YG`01000WE/0000029eK00<009dKWA/00YdK0P001idK00<009CJU=X00YCJ00<009CJ
U=X01iCJ00<008aI00002h@i00D008@iQ3V4>@0000EcM`04003ooooo000Aool00`00ooooo`0Mool0
04Ooo`03002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003002]g:gL
00N]g003002]g:gL00>]g0<000:]g003002]g:gL00>]g003002]g:gL00:]g003002]g:gL00:]g0<0
00:]g003002]g:gL00R]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<0
00:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g0<000>]g0<000:]g003
002]g:gL00R]g003002]g:gL00:]g0<000:]g003002]g:gL00R]g003002]g:gL00>]g0<000:]g003
002]g:gL00N]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003
002]g:gL00N]g003002]g:gL00>]g0<000:]g003002U_:Fl00RU_003002U_:Fl008000JU_003002U
_:Fl00NU_0<000ZU_003002UW:FL00>UW0<000:UW003002UW:FL00RUW08000^UO003002MFieK00:M
F`03002MFieK00FMF`03002M6idK00BM6`8000BM6`03002DfYCJ00BDfP8000JDfP05002<FHaIS5T0
000;Q3T00`00Q3T00007LgL2000Bool00`00ooooo`05ool00`00ooooo`02ool00`00ooooo`0@ool0
04Koo`8000R]g0<000V]g003002]g:gL00J]g0<000V]g003002]g:gL00J]g0<000F]g005002]g:gL
[M`00008[M`30009[M`00`00[Mb]g007[M`30008[M`00`00[Mb]g007[M`30008[M`00`00[Mb]g007
[M`30009[M`00`00[Mb]g0030003[M`30009[M`00`00[Mb]g006[M`30009[M`00`00[Mb]g007[M`3
0008[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g006[M`30009[M`00`00[Mb]g006[M`30009YK`0
0`00YKbU_003YK`30002YK`00`00YKbU_008YK`00`00YKbU_0030006YK`00`00YIbUW007YI`2000;
YI`01000YG`000002:El00<009eKWE/019eK0P0019eK00<009dKWA/01idK0P0000>M6`00U=X029CJ
00<009CJU=X00YCJ00<008aIS5T00haI00<008@iQ3T02H@i00<007=gLgL01W=g00<00?ooool04Ooo
00<00?ooool01_oo00@00?ooool001?oo`00;?oo0P001?oo00<00?ooool00ooo0P003?oo00<00:gL
[M`02:gL00<00:gL00000P001JgL00<00:gL[M`02:gL00<00:gL00000P001JgL00<00:gL[M`02:gL
00<00:gL00000P0000>]g000[M`00ZgL00<00:gL[M`02:gL00<00:gL00000P001JgL00<00:gL[M`0
2:gL00<00:gL[M`00P001JgL00<00:gL[M`02:gL00<00:gL[M`00P001JgL00<00:gL[M`02:gL00<0
0:gL[M`00`001JgL00<00:gL[M`01:gL10000ZgL0`001JgL00<00:gL[M`01jgL00<00:gL[M`00`00
1JgL00<00:gL[M`02:gL00<00:gL[M`00P001JgL00<00:gL[M`02:gL00<00:gL[M`00P001ZgL00<0
0:gL[M`01jgL00<00:gL[M`00P001ZgL00<00:gL[M`01jgL00<00:fl[K`00P001ZFl00<00:FlYK`0
1jFl0`002JFl00<00:FlYK`01:Fl0`000ZFl00<00:FLYI`02:FL00@00:FL000000RUW003002UO:El
00:UO08000FUO003002MFieK00NMF`800003WE/009dK00^M6`03002DfYCJ00VDfP800003U=X008aI
00J<F@8000R4>@03001cM`0000QcM`03003ooooo013oo`03003ooooo00Ooo`03003oo`0001?oo`00
:ooo00@00?ooool000Soo`04003ooooo000:ool20009[M`00`00[Mb]g003[M`30002[M`00`00[Mb]
g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]
g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g002[M`30002[M`00`00[Mb]
g008[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]
g007[M`30003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`0
0`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`0
0`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Kb]_003[K`30002YK`00`00YKbU_008YK`0
0`00YKbU_0030006YK`00`00YKbU_007YK`2000:YI`00`00YIbUW002YI`20005YI`00`00YGbUO005
YG`20002YG`00`00WE^MF`0:WE/00`00WA^M6`0:WA/00`00U=X0000<U=X00`00S5V<F@08S5T00`00
Q3V4>@03Q3T20002LgL00`00LgMcM`06LgL00`00ooooo`0Aool00`00ooooo`06ool00`00ool0000C
ool002_oo`04003ooooo0008ool01000ooooo`002Ooo0`002JgL00<00:gL[M`01ZgL0`002JgL00<0
0:gL[M`01ZgL0`002JgL00<00:gL[M`00jgL00<00:gL[M`00`002JgL00<00:gL[M`01ZgL0`002JgL
00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01jgL0`002:gL00@00:gL
[Mb]g0<000>]g0<000R]g003002]g:gL00N]g0<000V]g003002]g:gL00J]g0<000V]g003002]g:gL
00J]g0<000V]g003002]g:gL00J]g0<000V]g003002]_:fl00J]_0<000ZU_003002U_:Fl00>U_0<0
00:U_003002U_:Fl00RU_004002UW0000008YI`00`00YIbUW004YI`20002YI`00`00YGbUO008YG`3
000;WE/01000WC/000002IdK00D009CJU=ZDfP0000ZDfP03002<F@0000Z<F@050024>H@iQ3T00005
LgL00`00LgMcM`06LgL00`00ooooo`0@ool00`00ooooo`05ool5000Bool002_oo`04003ooooo0008
ool3000:ool00`00[Mb]g0030005[M`00`00[Mb]g007[M`00`00[Mb]g0030005[M`00`00[Mb]g007
[M`00`00[Mb]g0030005[M`00`00[Mb]g003[M`01@00[Mb]g:gL00000ZgL0`001JgL00<00:gL[M`0
1jgL00<00:gL[M`00`001JgL00<00:gL[M`02:gL00<00:gL00000P001JgL00<00:gL[M`02:gL00<0
0:gL00000P001JgL00<00:gL[M`02:gL00<00:gL[M`00P001JgL00<00:gL[M`01JgL10000ZgL0P00
1JgL00<00:gL[M`02:gL00<00:gL[M`00P001ZgL00<00:gL[M`01jgL00<00:gL[M`00P001ZgL00<0
0:gL[M`01jgL00<00:gL[M`00P001ZgL00<00:gL[M`01jgL00<00:gL[M`00P001ZgL00<00:fl[K`0
1jfl00<00:FlYK`00P001jFl00<00:FlYK`01jFl0P002ZFl00<00:FLYI`00ZFL0P001JFL00<00:FL
YI`01jFL0P002jEl00<009eKWE/00P0029eK00<009dkWC/00Ydk00<009dKWA/01IdK00<009CJU=X0
0iCJ00<009CJU=X01YCJ00D008aIS5V<F@0000Z<F@030024>@0000McM`03001cMg=g00IcM`03003o
oooo00ooo`03003ooooo01coo`00:ooo00@00?ooool000Soo`03003ooooo00Woo`8000F]g0<000:]
g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]
g003002]g:gL00>]g005002]g:gL[M`00005[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`3
0002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`3
0002[M`00`00[Mb]g008[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g008[M`30002[M`30002[M`0
0`00[Mb]g008[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g002[M`30002[M`0
0`00[Mb]g008[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g002[M`30002[M`0
0`00[Kb]_008[K`00`00YKbU_002YK`20004YK`00`00YKbU_008YK`01000YK`000002:Fl00<00:FL
YI`01:FL0P000ZFL00<00:FLYI`02:FL00@00:El000000RUO003002MFieK00>MF`8000FMF`03002M
>idk00BM>`8000BM6`03002DfYCJ00FDfP8000FDfP03002<FHaI00><F@03002<FHaI00R<F@03001c
Mg=g00McM`03001cMg=g00EcM`03003ooooo00ooo`03003ooooo01coo`00:ooo00@00?ooool000So
o`03003ooooo00Woo`03002]g:gL00N]g0<000R]g003002]g:gL00N]g0<000R]g003002]g:gL00N]
g0<000B]g005002]g:gL[M`00009[M`30008[M`00`00[Mb]g007[M`30009[M`00`00[Mb]g006[M`3
0009[M`00`00[Mb]g006[M`30009[M`00`00[Mb]g006[M`30009[M`01000[Mb]g:gL0`000ZgL0`00
2JgL00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01ZgL0`002JgL00<0
0:gL[M`01ZgL0`002Jfl00<00:FlYK`01JFl0P000ZFl00<00:FlYK`01jFl00<00:FlYK`00ZFl0P00
1JFl00<00:FLYI`01jFL0P002ZFL00<00:ElYG`00ZEl0P001JEl00<009eKWE/01YeK0P000YeK00<0
09dkWC/01idk0P0000>M6`00U=X02ICJ00D009CJU=ZDfP0000N<F@03002<FHaI00J<F@03001kU`00
00QcM`03001cMg=g00IcM`03003ooooo00koo`03003ooooo01coo`00;?oo0P002_oo0`001ooo00<0
0:gL[M`02:gL00<00:gL[M`00P001JgL00<00:gL[M`02:gL00<00:gL[M`00P001JgL00<00:gL[M`0
2:gL00<00:gL[M`00P0000>]g000[M`00ZgL00<00:gL[M`02:gL00<00:gL[M`00P001JgL00<00:gL
[M`02:gL00<00:gL[M`00`001JgL00<00:gL[M`01jgL00<00:gL[M`00`001JgL00<00:gL[M`01jgL
00<00:gL[M`00`001JgL00<00:gL[M`01jgL00<00:gL[M`00`001JgL00<00:gL[M`01JgL0`000ZgL
0`001JgL00<00:gL[M`01jgL00<00:gL[M`00`001JgL00<00:gL[M`01jgL00<00:gL[M`00`001JgL
00<00:gL[M`01jgL00<00:gL[M`00`001JgL00<00:gL[M`01jgL00<00:gL[M`00`001Jfl00<00:Fl
YK`02:Fl0`002JFl00<00:FlYK`01:Fl0P000ZFl00<00:FLYI`02:FL00@00:FL000000RUW003002U
O:El00BUO08000:UO003002MFieK00VMF`8000bM>`03002DfYCJ00ZDfP03002DfP0000R<F@03002<
FHaI00F<F@04001kUg^G0009LgL00`00LgMcM`06LgL00`00ooooo`0=ool00`00ooooo`0Lool004;o
o`03002]g:gL00R]g003002]g:gL00:]g0<000:]g003002]g:gL00R]g003002]g:gL00:]g0<000:]
g003002]g:gL00R]g003002]g:gL00:]g0<000:]g003002]g:gL00R]g003002]g:gL00:]g0<000:]
g003002]g:gL00R]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]
g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]
g003002]g:gL00N]g0@000:]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003002]
g:gL00N]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003002]
g:gL00N]g003002]g:gL00>]g0<000:]_003002U_:Fl00RU_003002U_:Fl008000JU_003002U_:Fl
00NU_0<000VUW003002UW:FL00:UW08000FUW003002UO:El00NUO0<000^MF`04002M>`000009WC/0
1000U=/000002iCJ00<008aIS5T028aI00<008aIS5T00haI00<007^GNiL00W^G00<007=gLgL01g=g
00<007=gLgL01G=g00<00?ooool03_oo00<00?ooool06ooo0011ool20009[M`00`00[Mb]g006[M`3
0009[M`00`00[Mb]g006[M`30009[M`00`00[Mb]g003[M`00`00[Mb]g0030009[M`00`00[Mb]g006
[M`30009[M`00`00[Mb]g007[M`30008[M`00`00[Mb]g007[M`30008[M`00`00[Mb]g007[M`30008
[M`00`00[Mb]g007[M`30008[M`00`00[Mb]g002[M`30002[M`30008[M`00`00[Mb]g007[M`30008
[M`00`00[Mb]g007[M`30008[M`00`00[Mb]g007[M`30008[M`00`00[Mb]g007[M`30009YK`00`00
YKbU_003YK`30002YK`00`00YKbU_008YK`00`00YKbU_0020006YI`00`00YIbUW005YI`20002YI`0
0`00YGbUO008YG`00`00WEbMG0020008WE/00`00WC^M>`02WC/00`00WC^M>`05WC/00`00U=^Df`02
U=/00`00U=ZDfP07U=X00`00S5T0000:S5T01@00S5V<FHaI00001W^G00<007=gLgL01W=g00<007=g
LgL01W=g00<00?ooool02_oo0P0000?oo`00ool07?oo0010ool00`00[Mb]g0030005[M`00`00[Mb]
g007[M`00`00[Mb]g0030005[M`00`00[Mb]g007[M`00`00[Mb]g0030005[M`00`00[Mb]g003[M`0
1@00[Mb]g:gL00000ZgL0`001JgL00<00:gL[M`01jgL00<00:gL[M`00`001JgL00<00:gL[M`02:gL
00<00:gL[M`00P001JgL00<00:gL[M`02:gL00<00:gL[M`00P001JgL00<00:gL[M`02:gL00<00:gL
[M`00P001JgL00<00:gL[M`02:gL00<00:gL[M`00P001JgL00<00:gL[M`01ZgL0`000ZgL0P001JgL
00<00:gL[M`02:gL00<00:gL[M`00P001JgL00<00:gL[M`02:gL00<00:gL[M`00P001JgL00<00:gL
[M`02:gL00<00:gL[M`00P001JgL00<00:gL[M`02:gL00<00:FlYK`00P001ZFl00<00:FlYK`01jFl
0`002JFl00<00:FlYK`00jFl0`000ZFL00<00:FLYI`02:FL0P002ZEl00<009eLWE`00ieL0P001IeK
00<009dkWC/019dk0P0019dk00<009CKU=/019CK0P001YCJ00D008aIS5V<F@0000Z<F@03002<F@00
00QkU`03001cMg=g00IcM`03001cMg=g00AcM`8000koo`8001goo`00@?oo00<00:gL[M`00jgL0`00
0ZgL00<00:gL[M`01jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00jgL0`00
0ZgL00<00:gL[M`00jgL00D00:gL[Mb]g00000F]g0<000:]g003002]g:gL00N]g003002]g:gL00>]
g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00>]
g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00>]
g0<000:]g003002]g:gL00N]g003002]g00000800004[M`000000002[M`00`00[Mb]g007[M`00`00
[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00
[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00YKbU_003YK`30002YK`00`00YKbU_008YK`00`00
YKbU_0020006YK`00`00YKbU_007YK`2000;YI`01000YG`000002:El00<009eLWE`01IeL0P000YeK
00<009dkWC/01idk0P0000>M>`00U=/029CK00<009CJU=X00YCJ00<008aIS5T00haI00<008aIS5T0
28aI00<007^GNiL01g^G00<007=gLgL01g=g00<007=gLgL00W=g00@0069dHW@000koo`03003ooooo
01_oo`00?ooo00<00:gL[M`01jgL10001jgL00<00:gL[M`01jgL10001jgL00<00:gL[M`01jgL1000
0jgL00D00:gL[Mb]g00000V]g0@000N]g003002]g:gL00N]g0@000R]g003002]g:gL00J]g0@000R]
g003002]g:gL00J]g0@000R]g003002]g:gL00J]g0<000R]g003002]g:gL00N]g0<000R]g003002]
g:gL00>]g0<00004[M`000000008[M`00`00[Mb]g007[M`30008[M`00`00[Mb]g007[M`30008[M`0
0`00[Mb]g007[M`30008[M`00`00YKbU_007YK`30009YK`00`00YKbU_003YK`30002YK`00`00YKbU
_008YK`01000YI`000002:FL00<00:ElYG`00ZEl0P001JEl00<009eLWE`029eL0P0039dk00<009CK
U=/02ICK0P0000>DfP00S5T01XaI0P001haI00<007^G00002G^G00<007=gLgL01g=g00@007=gLgL0
00=RM003003ooooo00coo`03003ooooo01_oo`00?ooo00<00:gL[M`01jgL00@00:gL[Mb]g0@000>]
g003002]g:gL00N]g004002]g:gL[M`40003[M`00`00[Mb]g007[M`01000[Mb]g:gL10000jgL00<0
0:gL[M`01jgL00@00:gL[Mb]g0@000>]g003002]g:gL00N]g004002]g:gL[M`40003[M`00`00[Mb]
g007[M`01000[Mb]g:gL10000jgL00<00:gL[M`01jgL00@00:gL[Mb]g0@000>]g003002]g:gL00N]
g003002]g:gL00@000>]g003002]g:gL00R]g003002]g:gL00@000>]g003002]g:gL00N]g0<00003
[M`00000008000>]g003002]g:gL00R]g003002]g:gL00@000>]g003002]g:gL00R]g003002]g:gL
00@000>]g003002]g:gL00R]g003002]g:gL00@000>]g003002U_:Fl00RU_003002U_:Fl008000JU
_003002U_:Fl00NU_08000ZU_003002UW:FL00:UW08000FUW003002UO:El00FUO08000:UO003002M
G9eL00VMG004002M>`000009WC/00`00U=/0000<U=/00`00S5V<F@08S5T00`00S5V<F@03S5T01@00
NiMkUg^G00002G^G00<007=gLgL01W=g00<007=g00001F9d00<00?ooool03?oo00<00?ooool01Ooo
10001?oo00<00?ooool00_oo00<00?ooool01Ooo000nool20009[M`00`00[Mb]g005[M`40009[M`0
0`00[Mb]g005[M`40009[M`00`00[Mb]g003[M`00`00[M`000030009[M`00`00[Mb]g005[M`40008
[M`00`00[Mb]g006[M`40008[M`00`00[Mb]g006[M`40008[M`00`00[Mb]g006[M`40008[M`00`00
[Mb]g005[M`40009[M`00`00[Mb]g005[M`40009[M`00`00[Mb]g0030002[M`40009[M`00`00[Mb]
g005[M`40009[M`00`00[Mb]g005[M`40009[M`00`00[Mb]g005[M`3000:YK`00`00YKbU_003YK`3
0002YK`00`00YKbU_008YK`01000YK`000002:Fl00<00:FLYI`01:FL0P000ZFL00<00:ElYG`02:El
0P002ieL00<009dkWC/00Ydk00<009dkWC/01Idk00@009CKU=^Df`8000VDf`03002<N@0000Z<F@05
002<FHaIS5T00004NiL00`00NiMkU`07NiL00`00LgMcM`07LgL00`00HWARM004HW@00`00ooooo`0<
ool00`00ooooo`05ool00`00ooooo`06ool01000ooooo`002?oo000nool00`00[M`000020005[M`0
0`00[Mb]g008[M`00`00[M`000020005[M`00`00[Mb]g008[M`00`00[M`000020005[M`00`00[Mb]
g003[M`01@00[Mb]g:gL00000ZgL0`001JgL00<00:gL[M`01jgL00<00:gL[M`00P001ZgL00<00:gL
[M`01jgL00<00:gL[M`00P001ZgL00<00:gL[M`01jgL00<00:gL[M`00P001ZgL00<00:gL[M`01jgL
00<00:gL[M`00P001ZgL00<00:gL[M`01ZgL00<00:gL[M`00`001ZgL00<00:gL[M`01ZgL00<00:gL
[M`00`001ZgL00<00:gL[M`00jgL10000ZgL0`001ZgL00<00:gL[M`01ZgL00<00:gL[M`00P001ZgL
00<00:gL[M`01jgL00<00:gL[M`00P001ZgL00<00:gL[M`01jgL00@00:Fl000000RU_003002U_:Fl
00JU_08000ZU_003002U_:Fl00:U_08000FU_003002UW:FL00NUW08000^UO004002MG0000008WE`0
0`00WC^M>`04WC/20004WC/00`00U=^Df`04U=/00`00U=^Df`04U=/20003S7T00`00S5V<F@08S5T0
0`00S5T00006NiL00`00NiMkU`07NiL00`00LgMcM`05LgL20007HW@00`00ooooo`0;ool00`00oooo
o`06ool00`00ooooo`06ool00`00ool00008ool003goo`03002]g:gL00>]g0<000:]g003002]g:gL
00N]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003002]g:gL
00>]g005002]g:gL[M`00005[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00
[Mb]g008[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g002[M`30002[M`00`00
[Mb]g008[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00
[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`30003[M`30002[M`00`00[Mb]g007
[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007
[M`00`00YKbU_002YK`20005YK`00`00YKbU_007YK`01000YK`000002:Fl00<00:FlYK`01:Fl0P00
0ZFl00<00:FLYI`02:FL00@00:El000000RUO003002MG9eL00:MG08000FMG003002M>idk00NM>`80
0003WC/009CK00NDf`03002DfiCK00:Df`03002<NHai00B<N@03002<FHaI00R<F@03001kUg^G00Ik
U`03001kUg^G00MkU`03001cMg=g009cM`80009RM003001RM69d00ARM003003ooooo00_oo`03003o
oooo00Ooo`03003ooooo00Goo`03003oo`0000Soo`00??oo0P002:gL0`002JgL00<00:gL[M`01ZgL
0`002JgL00<00:gL[M`01ZgL0`001:gL00D00:gL[Mb]g00000V]g0<000R]g003002]g:gL00J]g0<0
00V]g003002]g:gL00J]g0<000V]g003002]g:gL00J]g0<000V]g003002]g:gL00J]g0<000R]g003
002]g:gL00N]g0<000R]g003002]g:gL00N]g0<000R]g004002]g:gL[M`30003[M`30008[M`00`00
[Mb]g006[M`30009[M`00`00[Mb]g006[M`30009[M`00`00YKbU_004YK`20002YK`00`00YKbU_007
YK`00`00YKbU_002YK`20005YK`00`00YKbU_007YK`30009YI`00`00YGbUO002YG`20005YG`00`00
WEbMG005WE`20002WE`00`00WC^M>`0:WC/00`00U=^Df`08U=/200000iCK002<N@07S7T00`00S5V<
F@06S5T00`00NiL00008NiL00`00NiMkU`07NiL01000LgMcM`00169d00<0069dHW@0169d00<00?oo
ool02ooo00<00?ooool02?oo00<00?ooool00ooo1@001ooo000lool00`00[Mb]g008[M`00`00[M`0
00020005[M`00`00[Mb]g008[M`00`00[M`000020005[M`00`00[Mb]g007[M`00`00[Mb]g0020000
0jgL002]g002[M`00`00[Mb]g008[M`00`00[Mb]g0020005[M`00`00[Mb]g008[M`00`00[M`00002
0005[M`00`00[Mb]g008[M`00`00[M`000020005[M`00`00[Mb]g007[M`00`00[Mb]g0030005[M`0
0`00[Mb]g007[M`00`00[Mb]g0020005[M`00`00[Mb]g008[M`00`00[Mb]g0020005[M`00`00[Mb]
g008[M`00`00[Mb]g0020005[M`00`00[Mb]g005[M`40002[M`20005[M`00`00[Mb]g007[M`00`00
[Mb]g0030005[M`00`00[Mb]g007[M`00`00[Mb]g0020006[M`00`00YKbU_007YK`30009YK`00`00
YKbU_004YK`20002YK`00`00YKbU_008YK`00`00YIbUW0020006YI`00`00YGbUO005YG`20002YG`0
0`00WEbMG008WE`2000<WC/00`00U?/0000;U=/00`00S7V<N@08S7T00`00S5V<F@03S5T20002NiL0
0`00NiMkU`07NiL00`00NiMkU`06NiL00`00LgL00006HW@00`00HWARM004HW@00`00ooooo`0:ool0
0`00ooooo`05ool01000ooooo`004Ooo000kool20009[M`00`00[Mb]g003[M`30002[M`00`00[Mb]
g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]
g008[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]
g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]
g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g002[M`30002[M`00`00[Mb]
g008[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`40002[M`30002[M`00`00[Mb]g007[M`0
0`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00YKbU_008YK`0
0`00YKbU_0020006YK`00`00YKbU_007YK`30009YK`00`00YIbUW003YI`30002YI`00`00YGbUO008
YG`2000;WE`01000WC/000002Idk00@009CkU?^Dn`8000RDf`03002<NP0000Z<N@05002<FHaIS5T0
0005NiL00`00NiMkU`07NiL00`00NiMkU`06NiL00`00HWARM005HW@00`00HWARM004HW@00`00oooo
o`0;ool00`00ooooo`05ool2000Bool003_oo`8000V]g003002]g:gL00J]g0<000V]g003002]g:gL
00J]g0<000R]g003002]g:gL00>]g003002]g:gL00<000V]g003002]g:gL00J]g0<000V]g003002]
g:gL00J]g0<000V]g003002]g:gL00J]g0<000R]g003002]g:gL00N]g0<000R]g003002]g:gL00J]
g0<000V]g003002]g:gL00J]g0<000V]g003002]g:gL00J]g0<000V]g004002]g:gL[M`30002[M`3
0008[M`00`00[Mb]g007[M`30008[M`00`00[Mb]g006[M`30009YK`00`00YKbU_003YK`30002YK`0
0`00YKbU_008YK`00`00YKbU_0020006YK`00`00YIbUW007YI`2000;YG`01000WG`0000029eL00<0
09dkWC/00Ydk0P001idk00<009CkU?/00iCk00<009CKU=/019CK00D008ajS7Z<NP0000Z<N@03002<
F@0000MkU`03001kUg^G00IkU`03001kUg^G00AkU`<000MRM003001RM69d00ERM003003ooooo00[o
o`03003ooooo01Woo`00>_oo00<00:gL[M`00`001JgL00<00:gL[M`01jgL00<00:gL[M`00`001JgL
00<00:gL[M`01jgL00<00:gL[M`00P001JgL00<00:gL[M`01:gL00@00:gL[M`000:]g0<000F]g003
002]g:gL00N]g003002]g:gL00<000F]g003002]g:gL00N]g003002]g:gL00<000F]g003002]g:gL
00N]g003002]g:gL008000F]g003002]g:gL00R]g003002]g:gL008000F]g003002]g:gL00N]g003
002]g:gL00<000F]g003002]g:gL00N]g003002]g:gL00<000F]g003002]g:gL00N]g003002]g:gL
008000J]g003002]g:gL00F]g0<000:]g08000F]g003002]g:gL00R]g003002]g:gL008000F]g003
002]g:gL00N]g003002]g:gL00<000JU_003002U_:Fl00JU_0<000VU_003002U_:Fl00>U_0<000:U
_003002UW:FL00RUW004002UW0000008YG`00`00WGbMO002WG`20005WE`00`00WC^M>`05WC/20004
WC/00`00U?^Dn`05U?/00`00U=^Df`02U=/00`00S7Z<NP03S7X00`00S7V<N@08S7T00`00NiMkU`07
NiL00`00NiMkU`06NiL00`00NiMkU`02NiL01@00HWARM69d00001f9d00<0069dHW@0169d00<00?oo
ool02_oo00<00?ooool06Ooo000jool00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]
g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g003[M`01@00[Mb]
g:gL00001JgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<0
0:gL[M`01:gL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01jgL00<0
0:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`01:gL0`000ZgL00<00:gL[M`01ZgL00<0
0:gL[M`01:gL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01jgL00<0
0:gL00000P0000B]g000000000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003002]g:gL
00J]g003002]g:gL00B]g0<000:U_003002U_:Fl00NU_003002U_:Fl008000JU_003002U_:Fl00NU
_08000ZUW003002UW:FL00:UW08000FUO003002MO9el00FMO08000:MG003002M>idk00RM>`800003
WC/009Ck00RDn`800003U=/008aj00J<NP8000N<N@03001kV00000QkU`03001kUg^G00MkU`04001k
U`000004HW@00`00HWARM005HW@00`00HWARM005HW@00`00ooooo`09ool00`00ooooo`0Iool003Wo
o`03002]g:gL00N]g0@000N]g003002]g:gL00N]g0<000R]g003002]g:gL00J]g0@000>]g005002]
g:gL[M`00009[M`40007[M`00`00[Mb]g007[M`30008[M`00`00[Mb]g007[M`30008[M`00`00[Mb]
g006[M`40008[M`00`00[Mb]g006[M`30008[M`00`00[Mb]g007[M`30008[M`00`00[Mb]g007[M`3
0008[M`00`00[Mb]g006[M`30008[M`00`00[Mb]g003[M`300001:gL000000002:gL00<00:gL[M`0
1jgL0`002:gL00<00:gL[M`01jgL0`002:Fl00<00:FlYK`00jFl0`000ZFl00<00:FlYK`02:Fl00@0
0:FL000000RUW003002UW:FL00BUW08000:UO003002MO9el00RMO08000fM>`03002DniCk00ZDn`03
002<NXaj00R<NP03002<NHai00><N@05001kV7^HNiP00008NiL00`00NiMkU`07NiL00`00HWARM005
HW@00`00HWARM005HW@00`00HWARM004HW@00`00ooooo`09ool00`00ooooo`0Iool003Soo`8000V]
g004002]g:gL[M`40003[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`00`00[Mb]g007[M`01000
[Mb]g:gL10000jgL00<00:gL[M`01jgL00@00:gL[Mb]g0@000>]g003002]g:gL00N]g003002]g:gL
00@000>]g003002]g:gL00R]g003002]g:gL00@000>]g003002]g:gL00N]g004002]g:gL[M`40003
[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`00`00[Mb]g008[M`00`00[Mb]g0040003[M`00`00
[Mb]g008[M`00`00[Mb]g0040003[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`00`00[Mb]g007
[M`300000jgL000000020003[M`00`00[Mb]g008[M`00`00[Mb]g0040003[M`00`00[Mb]g008[M`0
0`00YKbU_0020006YK`00`00YKbU_006YK`30009YK`00`00YIbUW002YI`20005YI`00`00YIbUW007
YI`2000;WG`01000WC/000002Ydk00@009Ck000000VDn`03002<NP0000Z<NP05002<NHaiS7T00004
NiP00`00NiMkU`07NiL00`00NiMkU`05NiL20007HW@00`00HWARM005HW@00`00HWARM004HW@00`00
ooooo`09ool00`00ooooo`0Iool003Soo`8000V]g003002]g:gL00F]g0@000R]g003002]g:gL00F]
g0@000V]g003002]g:gL00>]g003002]g00000<000V]g003002]g:gL00F]g0@000R]g003002]g:gL
00F]g0@000V]g003002]g:gL00F]g0@000R]g003002]g:gL00J]g0@000R]g003002]g:gL00F]g0@0
00V]g003002]g:gL00F]g0@000V]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000V]g003
002]g:gL00<000:]g0@000V]g003002]g:gL00F]g0@000V]g003002U_:Fl00>U_0<000:U_003002U
_:Fl00NU_003002U_:Fl008000JU_003002UW:FL00FUW08000:UW003002UW:FL00RUW004002MO000
0008WG`00`00WC^M>`02WC/00`00WC^M>`05WC/20004U?/00`00U?^Dn`05U?/01@00S7Z<NXaj0000
2Xaj00<008ai00001W^H00<007^GNiL01g^G00<007^GNiL00W^G0P000V9d00<0069dHW@01F9d00<0
069dHW@01F9d00<0069dHW@0169d00<00?ooool02Ooo00<00?ooool06?oo000gool200001:gL0000
00001JgL00<00:gL[M`01jgL00<00:gL[M`00P001ZgL00<00:gL[M`01jgL00<00:gL00000P001JgL
00<00:gL[M`00jgL00D00:gL[Mb]g00000:]g0<000F]g003002]g:gL00N]g003002]g:gL008000J]
g003002]g:gL00N]g003002]g000008000J]g003002]g:gL00J]g003002]g:gL008000J]g003002]
g:gL00N]g003002]g:gL008000J]g003002]g:gL00J]g003002]g:gL00<000J]g003002]g:gL00J]
g003002]g:gL008000J]g003002]g:gL00N]g003002]g:gL008000J]g003002]g:gL00J]g003002]
g:gL00<000J]g003002]g:gL00>]g0@000:]g08000J]g003002]g:gL00N]g003002]g:gL008000J]
g003002U_:Fl00NU_0<000RU_003002U_:Fl00>U_0<000:U_003002UW:FL00RUW0<000VUW003002M
O9el00:MO08000FMO003002M>idk00BM>`8000BM>`03002DniCk00FDn`8000BDn`03002<NXaj00><
NP03002<NXaj00R<NP03001kV7^H00IkV003001kUg^G00IkU`05001kUg^GNiL00004HW@00`00HWAR
M005HW@00`00HWARM005HW@00`00HWARM004HW@00`00ooooo`09ool00`00ooooo`0Hool003Ooo`03
002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00:]g0<000:]g003002]g:gL00N]g003
002]g:gL00>]g0<000:]g003002]g:gL00>]g005002]g:gL[M`00005[M`30002[M`00`00[Mb]g007
[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007
[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007
[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g008
[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007
[M`30002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00YKbU_008YK`00`00
YKbU_0020006YK`00`00YKbU_006YK`2000;YI`00`00YIbUW0020006YI`00`00WGbMO005WG`20002
WG`00`00WC^M>`07WC/200000idk002Dn`09U?/200000iCk002<NP06S7X20007S7X00`00NkP00008
NiP00`00NiMkU`06NiL00`00NiL00006HW@00`00HWARM004HW@00`00HWARM005HW@00`00HWARM005
HW@00`00ooooo`08ool00`00ooooo`0Hool003Koo`8000R]g0<000R]g003002]g:gL00J]g0<000V]
g003002]g:gL00J]g0<000B]g005002]g:gL[M`00009[M`30008[M`00`00[Mb]g006[M`30009[M`0
0`00[Mb]g006[M`30008[M`00`00[Mb]g006[M`30009[M`00`00[Mb]g006[M`30008[M`00`00[Mb]
g007[M`30008[M`00`00[Mb]g006[M`30009[M`00`00[Mb]g006[M`30008[M`00`00[Mb]g007[M`3
0008[M`01000[Mb]g:gL0`000ZgL0`002JgL00<00:gL[M`01ZgL0`002JFl00<00:FlYK`00jFl0`00
0ZFl00<00:FlYK`01jFl00@00:FL000000RUW003002UW:FL00>UW0<000:UW003002MO9el00RMO080
00bM>`03002DniCk00^Dn`03002<NXaj00R<NP03002<NXaj00><NP04001k^7^h0009NiP00`00NiMk
U`06NiL00`00HWARM005HW@00`00HWARM005HW@00`00HWARM005HW@00`00HWARM004HW@00`00oooo
o`08ool00`00ooooo`0Hool003Koo`03002]g:gL00N]g003002]g:gL008000F]g003002]g:gL00R]
g003002]g000008000F]g003002]g:gL00N]g003002]g:gL008000:]g004002]g:gL000:[M`00`00
[Mb]g0020005[M`00`00[Mb]g008[M`00`00[M`000020005[M`00`00[Mb]g007[M`00`00[Mb]g002
0005[M`00`00[Mb]g008[M`00`00[M`000020005[M`00`00[Mb]g007[M`00`00[Mb]g0020005[M`0
0`00[Mb]g008[M`00`00[Mb]g0020005[M`00`00[Mb]g007[M`00`00[Mb]g0030005[M`00`00[Mb]
g007[M`00`00[Mb]g0020005[M`00`00[Mb]g008[M`00`00[Mb]g0020005[M`00`00[Mb]g005[M`3
0002[M`20006[M`00`00[Mb]g007[M`00`00YKbU_0020006YK`00`00YKbU_007YK`2000:YK`01000
YIbUW:FL0P001JFL00<00:FLYI`01jFL0P002iel00@009dk000000VM>`04002Dn`00000:U?/00`00
S7X0000:S7X01@00S7Z<NXaj000017^h00<007^HNiP01g^H00<007^GNiL017^G0P00269d00<0069d
HW@0169d00<0069dHW@01F9d00<0069dHW@01F9d00<00?ooool01ooo00<00?ooool06?oo000eool2
0009[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]
g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g008[M`00`00[Mb]g002[M`30002[M`00`00[Mb]
g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]
g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]
g008[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]
g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]
g007[M`400001:gL000000000ZgL00<00:gL[M`01jgL00<00:FlYK`00jFl0`000ZFl00<00:FlYK`0
2:Fl00@00:Fl000000NU_003002UW:FL00BUW08000:UW003002UW:FL00RUW004002MO0000008WG`0
0`00WC^M>`02WC/00`00WC^M>`05WC/00`00U?^Dn`02U?/20007U?/01@00S7Z<NXaj00002Xaj00<0
08aj00001W^h00<007^HNiP01W^H00<007^GNiL00g^G00@0069dHW@000MRM003001RM69d00ERM003
001RM69d00ERM003001RM69d00ARM003003ooooo00Soo`03003ooooo01Ooo`00=Ooo0P002:gL00<0
0:gL[M`01ZgL0`002JgL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`00jgL00<00:gL[M`00`002JgL
00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002JgL00<00:gL
[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01jgL
0`002:gL00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`00ZgL0`0000B]
g000000000V]g003002U_:Fl00JU_08000ZU_003002U_:Fl00:U_08000BU_003002UW:FL00NUW080
00ZUW003002MO9el00:MO08000FMO003002M>idk00BM>`8000BM>`03002DniCk00FDn`8000BDn`03
002<NXaj00><NP03002<NXaj00R<NP03001k^7^h00Ik^003001kV7^H00IkV005001kUg^GNiL00003
HW@00`00HWARM005HW@00`00HWARM005HW@00`00HWARM005HW@00`00HWARM005HW@00`00ooooo`07
ool00`00ooooo`0Gool003Coo`03002]g:gL008000F]g003002]g:gL00N]g003002]g:gL00<000F]
g003002]g:gL00N]g003002]g:gL008000F]g003002]g:gL00B]g004002]g:gL0002[M`30005[M`0
0`00[Mb]g007[M`00`00[Mb]g0030005[M`00`00[Mb]g007[M`00`00[Mb]g0020005[M`00`00[Mb]
g007[M`00`00[Mb]g0030005[M`00`00[Mb]g007[M`00`00[Mb]g0020005[M`00`00[Mb]g007[M`0
0`00[Mb]g0030005[M`00`00[Mb]g007[M`00`00[Mb]g0020005[M`00`00[Mb]g008[M`00`00[Mb]
g0020005[M`00`00[Mb]g007[M`00`00[Mb]g0020006[M`00`00[Mb]g007[M`00`00[Mb]g0020005
[M`00`00[Mb]g006[M`300000jgL00000006[M`00`00YKbU_007YK`01000YK`000002:Fl00<00:Fl
YK`01:Fl0P000ZFl00<00:FLYI`01jFL00@00:FL000000RUW003002MO9el00BMO08000:MO003002M
>idk00NM>`800003WC/009Ck00VDn`800003U?/008aj00J<NP03002<NXaj00J<NP03001k^00000Mk
^003001kV7^H00MkV003001kU`0000ERM003001RM69d00ERM003001RM69d00ERM003001RM69d00AR
M003001RM69d00ERM003003ooooo00Ooo`03003ooooo01Ooo`00<ooo0P001:gL0`000ZgL00<00:gL
[M`01jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00ZgL0`000ZgL00<00:gL
[M`00jgL00D00:gL[Mb]g00000F]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003
002]g:gL00J]g003002]g:gL00>]g0<000:]g003002]g:gL00J]g003002]g:gL00B]g0<000:]g003
002]g:gL00J]g003002]g:gL00>]g0<000:]g003002]g:gL00J]g003002]g:gL00B]g0<000:]g003
002]g:gL00J]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003
002]g:gL00J]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003
002]g:gL00J]g003002]g:gL00H000:]g003002U_:Fl00NU_003002U_:Fl00:U_08000FU_003002U
_:Fl00NU_0<000RUW003002UW:FL00:UW08000FUW003002MO9el00NMO08000bM>`03002DniCk00^D
n`03002<NXaj00N<NP03002<NXaj00><NP8000=k^003001k^7^h00Ek^003001kV7^H00MkV003001R
M69d00ARM003001RM69d00ERM003001RM69d00ERM003001RM69d00ERM003001RM69d00ARM003003o
oooo00Ooo`03003ooooo01Ooo`00<ooo00<00:gL[M`01ZgL10001jgL00<00:gL[M`01jgL10001jgL
00<00:gL[M`01ZgL10000jgL00D00:gL[Mb]g00000V]g0@000N]g003002]g:gL00N]g0<000R]g003
002]g:gL00J]g0<000R]g003002]g:gL00N]g0<000R]g003002]g:gL00J]g0<000R]g003002]g:gL
00N]g0<000R]g003002]g:gL00J]g0<000R]g003002]g:gL00N]g0<000R]g003002]g:gL00J]g0<0
00R]g003002]g:gL00N]g0<000R]g003002]g:gL00>]g0H000VU_003002U_:Fl00BU_08000:U_003
002U_:Fl00RU_003002UW:FL008000JUW003002UW:FL00BUW08000:UW003002MO9el00RMO004002M
F`000009WC/01000U?/000002YCk00<008bJ00002Haj00D008ajS7Z<NP0000Ek^003001k^7^h00Ik
^003001kV7^H00EkV08000MRM003001RM69d00ERM003001RM69d00ARM003001RM69d00ERM003001R
M69d00ERM003003ooooo00Koo`03003ooooo01Ooo`00<_oo0P002:gL00@00:gL[Mb]g0@000>]g003
002]g:gL00N]g004002]g:gL[M`40003[M`00`00[Mb]g006[M`01000[Mb]g:gL10000jgL00<00:gL
[M`01jgL00@00:gL[Mb]g0@000>]g003002]g:gL00N]g003002]g:gL00@000>]g003002]g:gL00N]
g003002]g:gL00@000>]g003002]g:gL00R]g003002]g:gL00@000>]g003002]g:gL00N]g003002]
g:gL00@000>]g003002]g:gL00R]g003002]g:gL00@000>]g003002]g:gL00N]g003002]g:gL00@0
00>]g003002]g:gL00R]g003002]g:gL00@000>]g003002]g:gL00N]g003002]g:gL00@000>]g003
002]g:gL00R]g003002]g:gL00@000>]g003002]g:gL00N]g0D000JU_003002U_:Fl00NU_0<000VU
_003002UW:FL00>UW0<000:UW003002UW:FL00NUW08000ZMO003002MFieK00:MF`03002M>idk00FM
>`03002DniCk00:Dn`8000NDn`05002<VXbJS9X00009S7X00`00S7X00007NkP00`00NkQk^006NkP0
0`00NiQkV002NiP20002HY@00`00HWARM004HW@00`00HWARM005HW@00`00HWARM005HW@00`00HWAR
M005HW@00`00HWARM004HW@00`00ooooo`06ool00`00ooooo`0Gool003;oo`8000R]g003002]g:gL
00F]g0@000V]g003002]g:gL00F]g0@000R]g003002]g:gL00>]g003002]g00000<000V]g003002]
g:gL00F]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000V]g003002]g:gL00F]
g0@000R]g003002]g:gL00F]g0@000V]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000V]
g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000V]g003002]g:gL00F]g0@000R]g004002]
_:fl[K`50002YK`00`00YKbU_008YK`00`00YKbU_0020006YK`00`00YIbUW007YI`2000:YI`01000
YG`0000029el00<009eKWE/00ieK0P0019dk00<009CkU?/01ICk0P0019Ck00<008bJS9X00hbJ00<0
08ajS7X01haj00<007^hNkP01g^h00<007^hNkP01G^h00D007^HNiQkV00000ARU003001RM69d00ER
M003001RM69d00ERM003001RM69d00ARM003001RM69d00ERM003001RM69d00ERM003003ooooo00Ko
o`03003ooooo01Koo`00<Ooo0P0000>]g00000001JgL00<00:gL[M`02:gL00<00:gL00000P001JgL
00<00:gL[M`01jgL00<00:gL[M`00P001JgL00<00:gL[M`01:gL00H00:gL[Mb]g000[M`30005[M`0
0`00[Mb]g007[M`00`00[Mb]g0020006[M`00`00[Mb]g006[M`00`00[Mb]g0020006[M`00`00[Mb]
g007[M`00`00[M`000020006[M`00`00[Mb]g006[M`00`00[Mb]g0020006[M`00`00[Mb]g007[M`0
0`00[M`000020006[M`00`00[Mb]g006[M`00`00[Mb]g0020006[M`00`00[Mb]g006[M`00`00[Mb]
g0030006[M`00`00[Mb]g006[M`00`00[Mb]g0020006[M`00`00[Mb]g006[M`00`00[Mb]g0020006
[M`00`00[Mb]g007[M`00`00[Mb]g0020006[M`00`00[Kb]_004[K`50009YK`00`00YKbU_003YK`3
0002YK`00`00YIbUW008YI`01000YI`000001jFL00<00:ElYG`00ZEl0P001Iel00<009eKWE/01YeK
0P0000>M>`00U?/02ICk0P0000>Dn`00S9X01XbJ00<008ajS7X01Haj00<007^h00002G^h00<007^h
NkP01G^h00<007^H00001V:D00<0069dHW@0169d00<0069dHW@01F9d00<0069dHW@01F9d00<0069d
HW@01F9d00<0069dHW@0169d00<00?ooool01_oo00<00?ooool05_oo000aool00`00[Mb]g002[M`3
0002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`3
0002[M`00`00[Mb]g003[M`01@00[Mb]g:gL00001JgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`0
0ZgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00ZgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`0
0jgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00ZgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`0
0jgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00ZgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`0
0jgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00ZgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`0
0ZgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00jgL0`000ZgL00<00:fl[K`01jfl1@001ZFl00<0
0:FlYK`01jFl0`002JFL00<00:FLYI`00ZFL0P001JFL00<00:ElYG`01:El0P000Yel00<009eKWE/0
2IeK00<009CkU?/02iCk00<008bJS9X01hbJ00<008ajS7X00haj00D007^hNkQk^00000Uk^003001k
^7^h00Ek^003001RU6:D00ERU003001RM69d00ARM003001RM69d00ERM003001RM69d00ERM003001R
M69d00ERM003001RM69d00ERM003003ooooo00Goo`03003ooooo01Koo`00<?oo0P001jgL0`002JgL
00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`001:gL00<00:gL[M`00ZgL00<00:gL[M`01ZgL
0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01ZgL0`002:gL
00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL
[M`01jgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01ZgL
0`002:fl00@00:FlYKbU_0D000:U_003002U_:Fl00RU_003002UW:FL008000JUW003002UW:FL00FU
W08000:UW003002UO:El00NUO08000^MF`04002E6`00000:U?/00`00S9X00009S9X01@00S7Z<NXaj
000017^h00<007^hNkP027^h00<007^hNkP00g^h0P0026:D00<0069dHW@0169d00<0069dHW@01F9d
00<0069dHW@01F9d00<0069dHW@0169d00<0069dHW@01F9d00<00?ooool01Ooo00<00?ooool05_oo
000_ool20008[M`00`00[Mb]g0030005[M`00`00[Mb]g007[M`00`00[Mb]g0020005[M`00`00[Mb]
g007[M`00`00[Mb]g00300000jgL002]g002[M`00`00[Mb]g007[M`00`00[Mb]g0020005[M`00`00
[Mb]g007[M`00`00[Mb]g0020005[M`00`00[Mb]g007[M`00`00[Mb]g0030005[M`00`00[Mb]g007
[M`00`00[Mb]g0020005[M`00`00[Mb]g007[M`00`00[Mb]g0030005[M`00`00[Mb]g007[M`00`00
[Mb]g0020005[M`00`00[Mb]g007[M`00`00[Mb]g0020005[M`00`00[Mb]g008[M`00`00[Mb]g002
0005[M`00`00[Mb]g007[M`00`00[Mb]g0020005[M`00`00[Mb]g007[M`00`00[Mb]g0020006[M`0
0`00[Mb]g007[M`00`00[Mb]g0020006[K`00`00YKbU_004YK`50009YK`00`00YIbUW003YI`30002
YI`00`00YIbUW008YI`2000:YG`01000WE/0000029eK00<009DKUA/00YDK0P001iCk00D008bJS9Z<
VP0000V<VP03002<NP0000Ik^003001k^7^h00Mk^004001k^7^hNkP20002HY@00`00HYARU005HY@0
0`00HWARM004HW@00`00HWARM005HW@00`00HWARM005HW@00`00HWARM005HW@00`00HWARM002HW@3
0007ool00`00ooooo`0Fool002ooo`8000R]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003
002]g:gL00:]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003002]g:gL00J]g003
002]g:gL00>]g0<000:]g003002]g:gL00J]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003
002]g:gL00>]g0<000:]g003002]g:gL00J]g003002]g:gL00>]g0<000:]g003002]g:gL00J]g003
002]g:gL00B]g0<000:]g003002]g:gL00J]g003002]g:gL00>]g0<000:]g003002]g:gL00J]g003
002]g:gL00>]g0<000:]g003002]g:gL00N]g003002]g:gL00>]g0<000:]g003002]g:gL00J]g003
002]g:gL00>]g0<000:]g003002]g:gL00J]g003002]g:gL00>]g0<000:]g003002]g:gL00N]g003
002]g:gL00>]g0<000:]_003002U_:Fl00NU_0D000JU_003002UW:FL00NUW08000^UW004002UO000
0007YG`00`00WE^MF`02WE/20005WE/00`00UA^E6`05UA/20004U?/00`00S9Z<VP03S9X00`00S9Z<
VP07S9X00`00NkQk^006NkP00`00NkQk^007NkP00`00NkP00004HY@00`00HYARU005HY@00`00HWAR
M005HW@00`00HWARM005HW@00`00HWARM004HW@00`00HWARM005HW@01@00HWARM69d00000e7B00<0
0?ooool01?oo00<00?ooool05_oo000^ool30007[M`00`00[Mb]g007[M`40007[M`00`00[Mb]g006
[M`40007[M`00`00[Mb]g003[M`01000[Mb]g:gL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL
[M`01ZgL10001jgL00<00:gL[M`01jgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01jgL
0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01jgL0`002:gL
00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01jgL0`002:Fl00<00:Fl
YK`00ZFl10000ZFl00<00:FLYI`02:FL00@00:FL000000RUW003002UO:El00:UO08000FUO003002M
FieK00BMF`8000:MF`03002E6iDK00RE6`800003U?/008bJ00J<VP8000J<VP03001kf00000Qk^003
001k^7^h00Mk^003001RU6:D00ARU003001RU6:D00ERU003001RM69d00ARM003001RM69d00ERM003
001RM69d00ERM003001RM69d00ERM0<000AAdP03003ooooo00Goo`03003ooooo01Goo`00;_oo00<0
0:gL[M`010000jgL00<00:gL[M`01jgL00@00:gL[Mb]g0@000>]g003002]g:gL00J]g004002]g:gL
[M`40003[M`00`00[Mb]g003[M`01@00[Mb]g:gL00000ZgL10000jgL00<00:gL[M`01jgL00<00:gL
[M`010000jgL00<00:gL[M`01jgL00@00:gL[Mb]g0@000>]g003002]g:gL00N]g003002]g:gL00@0
00>]g003002]g:gL00N]g003002]g:gL00@000>]g003002]g:gL00R]g003002]g:gL00@000>]g003
002]g:gL00N]g003002]g:gL00@000>]g003002]g:gL00N]g003002]g:gL00@000>]g003002]g:gL
00R]g003002]g:gL00@000>]g003002]g:gL00N]g003002]g:gL00@000>]g003002]g:gL00N]g003
002]g:gL00@000>]g003002]g:gL00R]g003002U_:Fl008000JU_003002U_:Fl00FU_0@000VUW003
002UW:FL00:UW08000FUW003002UO:El00FUO08000:UO003002MFieK00NMF`8000fE6`03002<VXbJ
00R<VP04002<VXbJS9X20003NmP00`00NkQk^006NkP00`00NkQk^005NkP20006HY@00`00HYARU005
HY@00`00HWARM005HW@00`00HWARM005HW@00`00HWARM004HW@00`00HWARM005HW@00`00DM9AdP04
DM800`00ooooo`05ool00`00ooooo`0Eool001?oo`8000Coo`03003ooooo00?oo`8000coo`8000J]
g0@000V]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000B]g005002]g:gL[M`00007[M`4
0009[M`00`00[Mb]g004[M`40009[M`00`00[Mb]g005[M`40008[M`00`00[Mb]g005[M`40008[M`0
0`00[Mb]g005[M`40009[M`00`00[Mb]g005[M`40008[M`00`00[Mb]g005[M`40008[M`00`00[Mb]
g005[M`40009[M`00`00[Mb]g005[M`40008[M`00`00[Mb]g005[M`40008[M`00`00[Mb]g005[M`4
0009[M`00`00YKbU_003YK`30002YK`00`00YKbU_007YK`00`00YK`000020006YI`00`00YIbUW005
YI`20002YI`00`00YGbUO008YG`2000:WE/01000UA/000002YDK00<008bJ00002XbJ00<008bJ0000
1G_H00<007^hNkP01g^h00<007^hNkP00W^h0P000V:E00<006:DHY@016:D00<006:DHY@01F:D00<0
069dHW@0169d00<0069dHW@01F9d00<0069dHW@01F9d00<0069dHW@00V9d0`001e7B00<00?ooool0
1?oo00<00?ooool05Ooo000Bool01000ooooo`002?oo00@00?ooool000_oo`03002]g:gL00N]g003
002]g000008000F]g003002]g:gL00N]g003002]g:gL008000F]g003002]g:gL00R]g004002]g000
0002[M`01@00[Mb]g:gL00002JgL00<00:gL00000P001JgL00<00:gL[M`01jgL00<00:gL00000P00
1JgL00<00:gL[M`01jgL00<00:gL[M`00P001ZgL00<00:gL[M`01ZgL00<00:gL[M`00P001ZgL00<0
0:gL[M`01jgL00<00:gL00000P001ZgL00<00:gL[M`01ZgL00<00:gL[M`00P001ZgL00<00:gL[M`0
1ZgL00<00:gL[M`00P001ZgL00<00:gL[M`01ZgL00<00:gL[M`00`001ZgL00<00:gL[M`01ZgL00<0
0:gL[M`00P001ZgL00<00:gL[M`01ZgL00<00:gL[M`00P001ZgL00<00:gL[M`01ZgL00<00:gL[M`0
0P001ZgL00<00:FlYK`01jFl0`002:Fl00<00:FlYK`00jFl0`000ZFL00<00:FLYI`02:FL0P002jEl
00@009eK000000NMF`03002E6iDK00:E6`8000NE6`05002<VXbJS9X0000:S9X00`00NmQkf005NmP0
0`00NkQk^006NkP01@00NkQk^7^h000016:E00<006:DHY@016:D00<006:DHY@01F:D00<0069dHW@0
1F9d00<0069dHW@0169d00<0069dHW@01F9d00D0069dHWARM00000=AdP03001AdU7B00AAdP03003o
oooo00Coo`03003ooooo01Goo`004_oo00@00?ooool000Soo`04003ooooo000:ool20008[M`00`00
[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00
[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g006[M`00`00
[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00
[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00
[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00
[Mb]g003[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00
[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00YKbU_008YK`00`00
YKbU_0020006YK`00`00YKbU_006YK`3000:YI`01000YG`000002:El00<009eKWE/00YeK0P001IeK
00<009DKUA/019DK0P0019DK00<008bJS9X00hbJ00<008bJS9X01XbJ00<007_H00001g_H00<007^h
NkP01W^h00<007^h00001V:E00<006:DHY@016:D00<006:DHY@016:D00<0069dHW@01F9d00<0069d
HW@01F9d00<0069dHW@01F9d0`00157B00<0057BDM80157B00<00?ooool01?oo00<00?ooool05Ooo
000Bool01000ooooo`002Ooo0P002_oo0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL
0`002JgL00<00:gL[M`00ZgL00<00:gL[M`00`002JgL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`0
1ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01ZgL0`00
2:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01jgL0`002:gL00<0
0:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002JFl00<00:FlYK`0
0jFl0`000ZFl00<00:FlYK`01jFl00<00:FL00000`001ZFL00<00:ElYG`00ZEl0P001JEl00<009eK
WE/01IeK0P000YeK00<009DKUA/01iDK0P0000>E6`00S9X01XbJ0P001HbJ00D007_HNmQkf00000Mk
f003001k^7^h00Ik^003001RUF:E00ERU@03001RU6:D00ARU003001RU6:D00ERU003001RM69d00AR
M003001RM69d00ERM003001RM69d00ERM003001AdU7B00AAdP03001AdU7B00AAdP03003ooooo00Go
o`03003ooooo01Coo`004_oo00@00?ooool000Soo`04003ooooo0009ool00`00[Mb]g0020005[M`0
0`00[Mb]g007[M`00`00[Mb]g0020005[M`00`00[Mb]g007[M`00`00[Mb]g0030005[M`00`00[Mb]
g003[M`01000[Mb]g0000ZgL0`001JgL00<00:gL[M`01jgL00<00:gL[M`00P001JgL00<00:gL[M`0
1jgL00<00:gL[M`00P001JgL00<00:gL[M`01jgL00<00:gL[M`00P001JgL00<00:gL[M`01jgL00<0
0:gL[M`00`001JgL00<00:gL[M`01jgL00<00:gL[M`00P001JgL00<00:gL[M`01jgL00<00:gL[M`0
0P001JgL00<00:gL[M`01jgL00<00:gL[M`00P001JgL00<00:gL[M`02:gL00<00:gL[M`00P001JgL
00<00:gL[M`01jgL00<00:gL[M`00P001JgL00<00:gL[M`01jgL00<00:gL[M`00P001JgL00<00:gL
[M`01jgL00<00:fl[K`00P001ZFl00<00:FlYK`01jFl0`002:Fl00<00:FLYI`00ZFL1@000ZFL00<0
0:ElYG`01JEl0P000ZEl00<009eKWE/029eK0P0039DK00<008bJS9X028bJ00D008bJS9Z<VP0000Ak
f003001kf7_H00Ikf003001k^7^h00Ak^08000QRU@03001RU6:D00=RU003001RU6:D00ERU003001R
M69d00ERM003001RM69d00ERM003001RM69d009RM0<000IAdP03001AdU7B00EAdP03003ooooo00Co
o`03003ooooo01Coo`004_oo00@00?ooool000Soo`04003ooooo0008ool20004[M`30002[M`00`00
[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g003[M`30002[M`00`00
[Mb]g002[M`01@00[Mb]g:gL00001JgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL
00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00ZgL0`000ZgL
00<00:gL[M`01jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL
00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL
00<00:gL[M`01jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL
00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:fl[K`00jfl0`000ZFl
00<00:FlYK`02:Fl00<00:FlYK`00P001ZFl00<00:FLYI`01:FL0P0000BUW000000000VUO08000^M
F`04002M6`000009UA/00`00S9X0000:S9X00`00S9X00006NmP00`00NmQkf006NmP00`00NkQk^002
NkP01000HYERU@001f:E00<006:DHY@016:D00<006:DHY@01F:D00<0069dHW@0169d00<0069dHW@0
1F9d00D0069dHWARM00000=AdP03001AdU7B00AAdP03001AdU7B00AAdP03003ooooo00Coo`03003o
oooo01Coo`004ooo0P002_oo0P002Ooo00<00:gL[M`01ZgL10001jgL00<00:gL[M`01ZgL10001jgL
00<00:gL[M`01jgL0`000jgL00D00:gL[Mb]g00000V]g0<000R]g003002]g:gL00J]g0<000R]g003
002]g:gL00J]g0@000N]g003002]g:gL00J]g0@000N]g003002]g:gL00N]g0<000R]g003002]g:gL
00J]g0<000R]g003002]g:gL00J]g0<000R]g003002]g:gL00J]g0<000R]g003002]g:gL00N]g0<0
00R]g003002]g:gL00J]g0<000R]g003002]g:gL00J]g0<000R]g003002]_:fl00J]_0<000VU_003
002U_:Fl00>U_0<000:U_003002UW:FL00NUW08000:UO0<000JUO004002MF`000008WE/00`00WA^M
6`02WA/00`00UA^E6`05UA/01@00S9Z<VXbJ00002XbJ00<007_HNmP01W_H00<007_HNmP01G_H00D0
07^hNkQk^00000=RU@03001RUF:E00IRU@03001RU6:D00=RU003001RU6:D00ERU003001RM69d00ER
M003001RM69d00ERM0<000AAdP03001AdU7B00AAdP03001AdU7B00AAdP03003ooooo00Coo`03003o
oooo01Coo`00:Ooo0P002:gL00@00:gL[Mb]g0@000>]g003002]g:gL00J]g004002]g:gL[M`40003
[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`00`00
[Mb]g007[M`00`00[Mb]g0040003[M`00`00[Mb]g007[M`01000[Mb]g:gL10000jgL00<00:gL[M`0
1ZgL00@00:gL[Mb]g0@000>]g003002]g:gL00N]g003002]g:gL00@000>]g003002]g:gL00N]g003
002]g:gL00@000>]g003002]g:gL00N]g003002]g:gL00@000>]g003002]g:gL00N]g003002]g:gL
00@000>]g003002]g:gL00R]g003002]g:gL00@000>]g003002]g:gL00N]g003002]g:gL00@000>]
g003002]g:gL00N]g003002]g:gL00@000>]g003002]_:fl00N]_003002U_:Fl008000JU_003002U
_:Fl00NU_08000ZUW004002UO0000003YG`30002YG`00`00WE^MF`02WE/20005WE/00`00WA^M6`04
WA/20004UA/00`00S9Z<VP03S9X00`00S9Z<VP06S9X00`00NmP00008NmP00`00NmQkf005NmP00`00
NkP00005HYD00`00HYERU@05HYD00`00HYARU004HY@00`00HYARU005HY@00`00HWARM004HW@00`00
HWARM005HW@00`00DM9AdP04DM800`00DM9AdP04DM800`00DM9AdP05DM800`00ooooo`03ool00`00
ooooo`0Dool002Woo`8000R]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000R]g003002]
g:gL00>]g003002]g00000<000R]g003002]g:gL00F]g0@000V]g003002]g:gL00B]g0@000V]g003
002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL
00F]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000V]g003002]g:gL00F]g0@0
00R]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000R]_003002U_:Fl00>U_0<000:U_003
002U_:Fl00RU_004002UW0000007YI`00`00YGbUO002YG`20004YG`30006WE/20002WE/00`00WA^M
6`07WA/200000iDK002<VP06S9X20005S9X01@00NmQkf7_H000027_H00<007_HNmP01G_H00<006:E
HYD016:E00<006:EHYD01F:E00<006:DHY@016:D00<006:DHY@01F:D00<0069dHW@01F9d00<0069d
HW@00V9d0`001U7B00<0057BDM801E7B00<0057BDM80157B00<00?ooool00ooo00<00?ooool05?oo
000Xool200000jgL00000005[M`00`00[Mb]g008[M`01000[M`000001JgL00<00:gL[M`02:gL00@0
0:gL000000J]g003002]g:gL00>]g006002]g:gL[M`00:gL0P001ZgL00<00:gL[M`01jgL00<00:gL
00000P001JgL00<00:gL[M`01jgL00<00:gL00000P001JgL00<00:gL[M`01jgL00<00:gL[M`00P00
1JgL00<00:gL[M`01jgL00<00:gL[M`00P001ZgL00<00:gL[M`01ZgL00<00:gL[M`00P001ZgL00<0
0:gL[M`01ZgL00<00:gL[M`00P001ZgL00<00:gL[M`01ZgL00<00:gL[M`00P001ZgL00<00:gL[M`0
1ZgL00<00:gL[M`00P001ZgL00<00:gL[M`01jgL00<00:gL[M`00P001ZgL00<00:gL[M`01ZgL00<0
0:gL[M`00P001ZgL00<00:gL[M`01ZgL00<00:gL[M`00P001Zfl00<00:FlYK`01ZFl0`002JFl00<0
0:FLYI`00ZFL0P001:FL00<00:ElYG`01JEl0P000ZEl00<009eKWE/00`001IeK0P0039dK00<008bJ
S9X028bJ00D008bJS9Z<VP0000Ekf003001kf7_H00Ikf003001kf7_H00=kf08000MRU@03001RUF:E
00ERU@03001RU6:D00ARU003001RU6:D00ARU003001RM69d00ERM005001RM69dHW@00003DM800`00
DM9AdP04DM800`00DM9AdP04DM800`00DM9AdP04DM800`00ooooo`04ool00`00ooooo`0Cool002Oo
o`8000B]g0<000:]g003002]g:gL00N]g003002]g:gL00:]g0<000:]g003002]g:gL00N]g003002]
g:gL00:]g0<000:]g003002]g:gL00>]g005002]g:gL[M`00004[M`30002[M`00`00[Mb]g007[M`0
0`00[Mb]g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`0
0`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`0
0`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`0
0`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`0
0`00[Mb]g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g007[M`0
0`00[Mb]g002[M`30002[K`00`00YKbU_007YK`00`00YKbU_0020006YK`00`00YIbUW005YI`20000
0jFL002UO009YG`20006WE/30002WE/01000WA/000002IdK00<008bj00002XbJ00<008bJ00001g_H
00<007_HNmP01G_H00@007_HNmQkf080009R]@03001RUF:E00ARU@03001RUF:E00ERU@03001RU6:D
00ARU003001RU6:D00ERU003001RM69d00ERM0<000AAdP03001AdU7B00AAdP03001AdU7B00AAdP03
001AdU7B00EAdP03003ooooo00?oo`03003ooooo01?oo`009ooo0P001jgL0`002JgL00<00:gL[M`0
1JgL0`002JgL00<00:gL[M`01JgL0`001:gL00<00:gL[M`00ZgL00<00:gL[M`01JgL0`002JgL00<0
0:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`0
1ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`00
2:gL00<00:gL[M`01ZgL0`002JgL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<0
0:gL[M`01ZgL0`002:Fl00<00:FlYK`00jFl0`000ZFl00<00:FLYI`02:FL0P002ZEl00@009eL0000
00NMF`<000>M6`03002M6idK00FM6`04002<^XbjS;X20009S9X00`00NmQkf006NmP00`00NmQkf006
NmP00`00NmP00004H[D00`00HYERU@05HYD00`00HYERU@05HYD00`00HYARU003HY@00`00HYARU005
HY@00`00HWARM005HW@00`00DM9AdP04DM800`00DM9AdP04DM800`00DM9AdP04DM800`00DM9AdP05
DM800`00ooooo`03ool00`00ooooo`0Cool002Koo`8000R]g003002]g:gL00<000F]g003002]g:gL
00J]g003002]g:gL00<000F]g003002]g:gL00J]g003002]g:gL00<00003[M`00:gL00:]g003002]
g:gL00J]g003002]g:gL00<000F]g003002]g:gL00N]g003002]g:gL008000F]g003002]g:gL00N]
g003002]g:gL008000F]g003002]g:gL00N]g003002]g:gL008000F]g003002]g:gL00N]g003002]
g:gL008000F]g003002]g:gL00N]g003002]g:gL008000F]g003002]g:gL00N]g003002]g:gL0080
00F]g003002]g:gL00N]g003002]g:gL008000F]g003002]g:gL00N]g003002]g:gL008000J]g003
002]g:gL00N]g003002]g:gL008000F]g003002]g:gL00N]g003002]g:gL008000F]g003002]g:gL
00N]g003002U_:Fl008000JU_003002U_:Fl00JU_08000ZUW003002UO:El008000JUO08000BMG080
00FMF`03002M6idK00<00003WA/0000000BM6`03002<^Xbj00B<^P03002<VXbJ00F<VP030023n000
00Qkf003001kf7_H00Ikf003001R]F:e00AR]@03001RUF:E00ARU@03001RUF:E00ERU@03001RU6:D
00ARU003001RU6:D00ERU003001RM69d009RM0<000IAdP03001AdU7B00AAdP03001AdU7B00EAdP03
001AdU7B00AAdP03003ooooo00?oo`03003ooooo01?oo`009_oo0P002:gL00<00:gL[M`00jgL0`00
0ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`00
0ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`00
0ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`00
0ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`00
0ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`00
0ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00jgL0P00
0ZgL00<00:gL[M`01jgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:FlYK`00jFl0`00
0ZFl00<00:FlYK`01jFl00@00:FL000000NUW003002UO:El00>UO0<000:UO003002MG9eL00JMG080
00:MF`03002M6idK00BM6`D00003WA/008bj00N<^P03002<VXbJ00:<VP8000>3n003001kf7_H00Ik
f003001kf7_H00Akf08000IR]@03001RUF:E00ERU@03001RUF:E00ERU@03001RU6:D00=RU003001R
U6:D00ERU005001RM69dHW@00003DK800`00DM9AdP04DM800`00DM9AdP04DM800`00DM9AdP04DM80
0`00DM9AdP05DM800`00ooooo`02ool00`00ooooo`0Cool002Goo`<000N]g003002]g:gL00N]g0<0
00N]g003002]g:gL00N]g0<000N]g003002]g:gL00>]g004002]g:gL[M`30007[M`00`00[Mb]g007
[M`30008[M`00`00[Mb]g006[M`30008[M`00`00[Mb]g006[M`30008[M`00`00[Mb]g006[M`30008
[M`00`00[Mb]g006[M`30008[M`00`00[Mb]g006[M`30008[M`00`00[Mb]g006[M`30008[M`00`00
[Mb]g006[M`30008[M`00`00[Mb]g006[M`30008[M`00`00[Mb]g006[M`30008[M`00`00[Mb]g007
[M`30007[M`00`00YKbU_007YK`30008YK`00`00YIbUW002YI`20005YI`00`00YGbUO006YG`2000;
WE`2000:WA/3000:S;X200000hbJ0023n004PoP00`00NmQkf007NmP01000NmQkf7_H0P000V:e00<0
06:eH[D016:e00<006:EHYD016:E00<006:EHYD01F:E00<006:DHY@016:D00<006:DHY@01F:D0`00
156b00<0057BDM80157B00<0057BDM80157B00<0057BDM80157B00<0057BDM801E7B00<00?ooool0
0ooo00<00?ooool04_oo000Uool00`00[Mb]g0040003[M`00`00[Mb]g007[M`00`00[Mb]g0040003
[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`00`00[Mb]g003[M`01@00[Mb]g:gL00000ZgL1000
0jgL00<00:gL[M`01jgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<00:gL[M`010000jgL00<0
0:gL[M`01jgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<00:gL[M`010000jgL00<00:gL[M`0
1jgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<0
0:gL[M`010000jgL00<00:gL[M`01jgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<00:gL[M`0
10000jgL00<00:gL[M`01jgL00<00:gL[M`010000jgL00<00:gL[M`02:gL00<00:gL[M`010000ZgL
00<00:FlYK`02:Fl00<00:FlYK`00P001JFl00<00:FLYI`01JFL0P000ZFL00<00:ElYG`01jEl00@0
09eL000000VMG004002M6`000009WA/00`00U;X000020009S;X00`00PoR3n005PoP00`00NmQkf007
NmP00`00NmP00004H[D00`00H[ER]@04H[D00`00HYERU@04HYD00`00HYERU@05HYD00`00HYARU004
HY@00`00HYARU005HY@00`00DK9A/P04DK800`00DM9AdP04DM800`00DM9AdP04DM800`00DM9AdP05
DM800`00DM9AdP04DM800`00ooooo`03ool00`00ooooo`0Bool002Coo`8000J]g0@000V]g003002]
g:gL00B]g0@000V]g003002]g:gL00B]g0@000B]g003002]g:gL00:]g003002]g:gL00B]g0@000R]
g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000R]g003002]
g:gL00F]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL00F]
g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000V]
g003002]g:gL00F]g0<000VU_003002U_:Fl00>U_08000:U_003002UW:FL00RUW0<000RUO003002M
G9eL00:MG003002MG9eL00FMG003002M6idK00:M6`03002M6idK00FM6`04002D^YBjU;X50005S;X0
0`00PoP00007PoP00`00NmQkf007NmP00`00H[ER]@04H[D00`00H[ER]@04H[D00`00HYERU@04HYD0
0`00HYERU@05HYD00`00HYARU004HY@00`00HYARU002HY@30006DK800`00DM9AdP04DM800`00DM9A
dP05DM800`00DM9AdP04DM800`00DM9AdP05DM800`00ooooo`02ool00`00ooooo`0Bool002?oo`80
00R]g003002]g:gL00<000F]g003002]g:gL00J]g003002]g:gL00<000F]g003002]g:gL00J]g003
002]g:gL00<00003[M`00:gL00:]g003002]g:gL00J]g003002]g:gL008000J]g003002]g:gL00J]
g003002]g:gL008000J]g003002]g:gL00J]g003002]g:gL008000J]g003002]g:gL00J]g003002]
g:gL008000J]g003002]g:gL00J]g003002]g:gL008000J]g003002]g:gL00J]g003002]g:gL0080
00J]g003002]g:gL00J]g003002]g:gL008000J]g003002]g:gL00J]g003002]g:gL008000J]g003
002]g:gL00J]g003002]g:gL008000J]g003002]g:gL00J]g003002]g:gL008000J]g003002]g:gL
00J]g003002]g:gL008000J]g003002]g:gL00J]g003002]_:fl008000JU_003002U_:Fl00JU_080
00^UW003002UW:FL008000JUO003002MG9eL00>MG08000BMG003002M6idK00BM6`8000BM6`03002D
^YBj00BD^P03002<^Xbj00<00003S;X008?h00:3n0030023n8?h00F3n003001kf7_H00Ekf08000IR
]@03001R]F:e00AR]@03001RUF:E00ARU@03001RUF:E00ERU@03001RU6:D00ARU005001RU6:DHY@0
0003DK800`00DK9A/P04DK800`00DM9AdP04DM800`00DM9AdP04DM800`00DM9AdP04DM800`00DM9A
dP05DM800`00ooooo`02ool00`00ooooo`0Bool002?oo`8000R]g003002]g:gL00>]g0<000:]g003
002]g:gL00J]g003002]g:gL00>]g0<000:]g003002]g:gL00J]g003002]g:gL00>]g0<000:]g003
002]g:gL00J]g003002]g:gL00:]g0<000:]g003002]g:gL00N]g003002]g:gL00:]g0<000:]g003
002]g:gL00N]g003002]g:gL00:]g0<000:]g003002]g:gL00N]g003002]g:gL00:]g0<000:]g003
002]g:gL00N]g003002]g:gL00:]g0<000:]g003002]g:gL00J]g003002]g:gL00>]g0<000:]g003
002]g:gL00J]g003002]g:gL00>]g0<000:]g003002]g:gL00J]g003002]g:gL00>]g0<000:]g003
002]g:gL00J]g003002]g:gL00>]g0<000:]g003002]g:gL00J]g003002]g:gL00>]g0<000:]g003
002]g:gL00J]g003002]g:gL00>]g0<000:]g003002]g:gL00J]g003002]_:fl00>]_0<000:U_003
002U_:Fl00NU_004002UW0000008YI`00`00YIbUW003YI`30002YG`00`00WEbMG006WE`200000ieL
002M6`08WA/200000idK002D^P07U;X00`00S;Z<^P02S;X30002PoP00`00PoR3n006PoP00`00NmQk
f002NmP20002H[D00`00H[ER]@04H[D00`00H[ER]@04H[D00`00HYERU@04HYD00`00HYERU@05HYD0
0`00HYARU004HY@30004DK800`00DK9A/P04DK800`00DM9AdP04DM800`00DM9AdP04DM800`00DM9A
dP04DM800`00DM9AdP05DM800`00ooooo`02ool00`00ooooo`0Bool002;oo`<000N]g003002]g:gL
00N]g0<000N]g003002]g:gL00N]g0<000N]g003002]g:gL00>]g004002]g:gL[M`30007[M`00`00
[Mb]g006[M`40007[M`00`00[Mb]g006[M`40007[M`00`00[Mb]g006[M`40007[M`00`00[Mb]g006
[M`40007[M`00`00[Mb]g006[M`30008[M`00`00[Mb]g006[M`30008[M`00`00[Mb]g006[M`30008
[M`00`00[Mb]g006[M`30008[M`00`00[Mb]g006[M`30008[M`00`00[Mb]g006[M`30008[M`00`00
[Mb]g006[M`30008[M`00`00[Kb]_006[K`30008YK`00`00YIbUW002YI`20005YI`00`00YIbUW007
YI`2000;WE`00`00WA^M6`0:WA/00`00U;ZD^P08U;X200000hbj0023n002PoP40007PoP01@00NmQk
f7_H000016:e00<006:eH[D016:e00<006:eH[D016:e00<006:EHYD016:E00<006:EHYD01F:E00<0
06:DHY@016:D00<0056bDK80156b00<0056bDK80156b00<0057BDM80157B00<0057BDM80157B00<0
057BDM801E7B00<0057BDM80157B00<00?ooool00_oo00<00?ooool04_oo000Rool00`00[Mb]g004
0003[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`0
0`00[Mb]g003[M`01@00[Mb]g:gL00000ZgL10000jgL00<00:gL[M`01ZgL00@00:gL[Mb]g0@000>]
g003002]g:gL00J]g004002]g:gL[M`40003[M`00`00[Mb]g006[M`01000[Mb]g:gL10000jgL00<0
0:gL[M`01ZgL00@00:gL[Mb]g0@000>]g003002]g:gL00J]g003002]g:gL00@000>]g003002]g:gL
00N]g003002]g:gL00@000>]g003002]g:gL00N]g003002]g:gL00@000>]g003002]g:gL00N]g003
002]g:gL00@000>]g003002]g:gL00N]g003002]g:gL00@000>]g003002]g:gL00N]g003002]g:gL
00@000>]g003002]g:gL00N]g003002]g:gL00@000>]g003002]_:fl00N]_003002U_:Fl008000JU
_003002UW:FL00BUW08000:UW003002UW:FL00RUW004002MO0000008WE`01000WC/000002IdK00<0
09Bj00002iBj00<008?hPoP01H?h0`001X?h00<007_H00001V:e00<006:eH[D016:e00<006:eH[D0
16:e00<006:EHYD016:E00<006:EHYD01F:E00<006:DHY@00V:D0P001U6b00<0056bDK80156b00<0
057BDM801E7B00<0057BDM80157B00<0057BDM80157B00<0057BDM801E7B00<00?ooool00_oo00<0
0?ooool04Ooo000Qool20006[M`40009[M`00`00[Mb]g004[M`40008[M`00`00[Mb]g005[M`40004
[M`01@00[Mb]g:gL00001jgL10002:gL00<00:gL[M`01JgL10002:gL00<00:gL[M`01JgL10002:gL
00<00:gL[M`01JgL10002:gL00<00:gL[M`01JgL10002:gL00<00:gL[M`01:gL10002JgL00<00:gL
[M`01:gL10002:gL00<00:gL[M`01JgL10002:gL00<00:gL[M`01JgL10002:gL00<00:gL[M`01JgL
10002:gL00<00:gL[M`01JgL10002:gL00<00:gL[M`01JgL10002:fl00<00:FlYK`00jFl0`000ZFl
00<00:FLYI`01jFL0`002JFL00<009elWG`00Yel0P0019eL0P0019dk0P001IdK0P000iBj0P0029Bj
00<008@I000028?h100018?h00<006:eH[D01F:e00<006:eH[D016:e00<006:eH[D016:e00<006:E
HYD016:E00<006:EHYD01F:E00<006:DHY@00P000U6b00<0056bDK80156b00<0056bDK80156b00<0
057BDM80157B00<0057BDM80157B00<0057BDM80157B00<0057BDM801E7B00<00?ooool00_oo00<0
0?ooool04Ooo000Qool00`00[Mb]g006[M`00`00[Mb]g0030005[M`00`00[Mb]g006[M`00`00[Mb]
g0020006[M`00`00[Mb]g006[M`00`00[Mb]g00200000jgL002]g003[M`00`00[Mb]g006[M`00`00
[Mb]g0020005[M`00`00[Mb]g007[M`00`00[Mb]g0020005[M`00`00[Mb]g007[M`00`00[Mb]g002
0005[M`00`00[Mb]g007[M`00`00[Mb]g0020005[M`00`00[Mb]g007[M`00`00[Mb]g0020005[M`0
0`00[Mb]g006[M`00`00[Mb]g0030005[M`00`00[Mb]g006[M`00`00[Mb]g0020006[M`00`00[Mb]
g006[M`00`00[Mb]g0020006[M`00`00[Mb]g006[M`00`00[Mb]g0020006[M`00`00[Mb]g006[M`0
0`00[Mb]g0020006[M`00`00[Mb]g006[M`00`00[Mb]g0020006[M`00`00[Mb]g006[M`00`00[Mb]
g0020006[K`00`00YKbU_006YK`30009YI`00`00YIbUW0020006YI`00`00WGbMO005WG`200000ieL
002M>`07WC/20002WA/00`00U;ZD^P05U;X00`00U;ZD^P04U;X01@00Q1V46H@I000028?h00<008?h
PoP01@0026:e00<006:eH[D016:e00<006:eH[D016:e00<006:EHYD016:E00<006:EHYD01F:E0P00
156b00<0056bDK80156b00<0056bDK80156b00<0057BDM80157B00<0057BDM80157B00<0057BDM80
1E7B00<0057BDM80157B00<00?ooool00_oo00<00?ooool04Ooo000Pool20008[M`00`00[Mb]g003
[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002
[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003
[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003
[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003
[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003
[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003
[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003
[M`30002[K`00`00YKbU_007YK`00`00YIbUW0020006YI`00`00YIbUW003YI`30002YI`00`00WGbM
O008WG`00`00WC^M>`09WC/20009U;X00`00U;ZD^P02U;X00`00Q1V46@03Q1T00`00PoR3n005PoP0
1000PoR3n8?h1@001f:e00<006:eH[D016:e00<006:eH[D016:e00<006:EHYD016:E00<006:EHYD0
1F:E00<0056bDK800e6b00<0056bDK80156b00<0056bDK80156b00<0057BDM80157B00<0057BDM80
1E7B00<0057BDM80157B00<0057BDM801E7B00D00?ooooooo`0001?oo`007ooo0`001jgL00<00:gL
[M`01jgL0`001jgL00<00:gL[M`01ZgL10001jgL00<00:gL[M`00jgL00<00:gL[M`010001jgL00<0
0:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`0
1ZgL0`002:gL00<00:gL[M`01ZgL0`001jgL00<00:gL[M`01jgL0`001jgL00<00:gL[M`01ZgL0`00
2:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<0
0:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002:Fl00<00:FLYI`00jFL0`000ZFL00<00:FLYI`0
1jFL0P002Yel00@009dk000000VM>`03002DfP0000VD^P800003U;X008@I00J46@030023n8?h00F3
n0030023n00000AZe@@000ER]@03001R]F:e00=R]@03001R]F:e00ER]@03001RUF:E00ARU@03001R
UF:E009RU@<000EA/P03001A/U6b00AA/P03001A/U6b00AA/P03001AdU7B00EAdP03001AdU7B00AA
dP03001AdU7B00AAdP03001AdU7B00EAdP05003oooooool0000Cool001ooo`03002]g:gL00@000>]
g003002]g:gL00N]g003002]g:gL00@000>]g003002]g:gL00J]g004002]g:gL[M`40003[M`00`00
[Mb]g003[M`01000[Mb]g0000jgL10000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL
[M`01jgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<00:gL[M`010000jgL00<00:gL[M`01jgL
00<00:gL[M`010000jgL00<00:gL[M`01jgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<00:gL
[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<00:gL[M`01000
0jgL00<00:gL[M`01jgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<00:gL[M`010000jgL00<0
0:gL[M`01jgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<00:FlYK`00P001ZFl00<00:FLYI`0
1ZFL0P002ZFL00@009el000000NMO003002M>idk00:M>`03002M>idk00FM>`04002DfYCJU=X20009
U;X00`00Q1V46@06Q1T00`00PoR3n006PoP00`00J]EZe@04J]D00`00H[ER]@030002H[D00`00H[ER
]@04H[D00`00H[ER]@04H[D00`00HYERU@04HYD01@00HYERUF:E00000U6b00<0056bDK80156b00<0
056bDK80156b00<0056bDK80156b00<0057BDM80157B00<0057BDM80157B00<0057BDM80157B00<0
057BDM801E7B00D00?ooooooo`0001?oo`007_oo0P001ZgL10002JgL00<00:gL[M`01:gL10002:gL
00<00:gL[M`01JgL10001:gL00D00:gL[Mb]g00000N]g0@000R]g003002]g:gL00B]g0@000V]g003
002]g:gL00B]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL
00F]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL00B]g0@000R]g003002]g:gL00F]g0@0
00R]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000R]g003
002U_:Fl00>U_0<000:U_003002UW:FL00NUW004002UW0000007YI`00`00WGbMO002WG`20005WG`0
0`00WC^M>`03WC/20004WC/00`00U=ZDfP04U=X00`00U;ZD^P05U;X00`00Q1T00008Q1T00`00PoR3
n004PoP20006J]D00`00H[ER]@03H[D40005H[D00`00H[ER]@05H[D00`00HYERU@04HYD30004DK80
0`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P04DK800`00DM9AdP04DM800`00DM9AdP04DM80
0`00DM9AdP05DM800`00DM9AdP05DM801@00oooooooo00004_oo000Nool00`00[Mb]g006[M`00`00
[Mb]g0030005[M`00`00[Mb]g006[M`00`00[Mb]g0020005[M`00`00[Mb]g007[M`00`00[Mb]g002
00000jgL002]g002[M`00`00[Mb]g007[M`00`00[Mb]g0020005[M`00`00[Mb]g006[M`00`00[Mb]
g0030005[M`00`00[Mb]g006[M`00`00[Mb]g0020006[M`00`00[Mb]g006[M`00`00[Mb]g0020006
[M`00`00[Mb]g006[M`00`00[Mb]g0020006[M`00`00[Mb]g006[M`00`00[Mb]g0020006[M`00`00
[Mb]g006[M`00`00[Mb]g0020005[M`00`00[Mb]g006[M`00`00[Mb]g0020006[M`00`00[Mb]g006
[M`00`00[Mb]g0020006[M`00`00[Mb]g006[M`00`00[Mb]g0020006[M`00`00[Mb]g006[M`00`00
[Mb]g0020006[M`00`00[Mb]g006[M`00`00[Mb]g0020005[M`00`00YKbU_007YK`30008YI`00`00
YIbUW002YI`20004YI`00`00WGbMO005WG`20002WG`00`00WC^M>`06WC/200000idk002DfP07U=X0
0`00U;ZD^P02U;X20003Q1T00`00Q1V46@06Q1T01000PoR3n8?h0P000V[E00<006[EJ]D016[E00<0
06:eH[D01F:e0`0016:e00<006:eH[D016:e00<006:EHYD016:E00<0056bDK80156b00<0056bDK80
0e6b00<0056bDK80156b00<0056bDK80156b00<0057BDM80157B00<0057BDM801E7B00<0057BDM80
157B00<0057BDM801E7B00D00?ooooooo`0001;oo`007Ooo0P002:gL00<00:gL[M`00jgL0`000ZgL
00<00:gL[M`01ZgL00<00:gL[M`00ZgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00ZgL0`000ZgL
00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL
00<00:gL[M`01ZgL00<00:gL[M`00ZgL0`000ZgL00<00:gL[M`01jgL00<00:gL[M`00ZgL0`000ZgL
00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL
00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01JgL00<00:gL[M`00jgL0`000ZgL
00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL
00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0P000ZgL
00<00:FlYK`02:Fl00<00:FlYK`00P001JFL00<00:FLYI`01JFL0P0000>UW000WG`02Iel0P002idk
00<009CJU=X029CJ0P0000>D^P00Q1T01H@I00<008@IQ1T01X@I00<008?h000016[E00<006[EJ]D0
16[E00<006:eH[D01F:e00<006:eH[D00`0000=R]@00H[D01V:e00<006:EHYD00V:E0P001U6b00<0
056bDK800e6b00<0056bDK80156b00<0056bDK80156b00<0057BDM801E7B00<0057BDM80157B00<0
057BDM80157B00<0057BDM801E7B00D00?ooooooo`0001;oo`007Ooo0P001jgL00<00:gL[M`01jgL
0`001jgL00<00:gL[M`01ZgL10001jgL00<00:gL[M`00jgL00<00:gL[M`00`002:gL00<00:gL[M`0
1ZgL0`001jgL00<00:gL[M`01jgL0`001jgL00<00:gL[M`01ZgL10001jgL00<00:gL[M`01ZgL0`00
2:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`001jgL00<0
0:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`0
1ZgL0`001jgL00<00:gL[M`01ZgL0`002JFl00<00:FlYK`00jFl0P000ZFL00<00:FLYI`02:FL00<0
09elWG`02Iel00@009dk000000RM>`03002Df`0000^DfP0300246H@I00J46@0300246H@I00J46@03
001ZeF[E00AZe@03001ZeF[E00AZe@03001R]F:e00ER]@03001R]F:e009R]@<000IR]@03001RUF:E
00800003DK80056b00EA/P03001A/U6b00AA/P03001A/U6b00AA/P03001A/U6b00AA/P03001AdU7B
00AAdP03001AdU7B00AAdP03001AdU7B00EAdP03001AdU7B00EAdP04003ooooo000Bool001coo`03
002]g:gL00@000>]g003002]g:gL00N]g003002]g:gL00@000>]g003002]g:gL00J]g004002]g:gL
[M`40003[M`00`00[Mb]g002[M`01@00[Mb]g:gL00000ZgL10000jgL00<00:gL[M`01jgL00<00:gL
[M`010000jgL00<00:gL[M`01jgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00@00:gL[Mb]g0@0
00>]g003002]g:gL00J]g003002]g:gL00@000>]g003002]g:gL00N]g003002]g:gL00@000>]g003
002]g:gL00N]g003002]g:gL00@000>]g003002]g:gL00N]g003002]g:gL00@000:]g003002]g:gL
00N]g003002]g:gL00@000>]g003002]g:gL00N]g003002]g:gL00@000>]g003002]g:gL00N]g003
002]g:gL00@000>]g003002]g:gL00N]g003002]g:gL00@000:]g003002]g:gL00N]g003002]_:fl
008000JU_003002U_:Fl00JU_08000ZUW004002MO0000008WG`00`00WC^M>`02WC/20005WC/01000
U=^DfiCK0P0029CJ00<008@I00001h@I00<008@IQ1T01H@I0P001V[E00<006[EJ]D016[E00<006:e
H[D01F:e00<006:eH[D016:e100016:e0P00156b00<0056bDK80156b00<0056bDK800e6b00<0056b
DK80156b00<0056bDK80156b00<0057BDM80157B00<0057BDM80157B00<0057BDM801E7B00<0057B
DM801E7B00@00?ooool001;oo`006ooo0P001ZgL10002JgL00<00:gL[M`01:gL10002:gL00<00:gL
[M`01JgL10001:gL00D00:gL[Mb]g00000J]g0@000V]g003002]g:gL00B]g0@000R]g003002]g:gL
00F]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL00B]g0@000R]g003002]g:gL00F]g0@0
00R]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0<000R]g003002]g:gL00F]g0@000R]g003
002]g:gL00F]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0<000R]g003002]_:fl
00>]_0<000:U_003002U_:Fl00NU_004002UW0000007YI`00`00WGbMO002WG`20005WG`00`00WC^M
>`05WC/20002WC/00`00U=^Df`04U=/00`00U=ZDfP04U=X01@00Q1V46H@I00001h@I00<008@IQ1T0
0h@I00@006[EJ]D000IZe@03001ZeF[E00AZe@03001R]F:e00ER]@03001R]F:e00AR]@03001R]F:e
00D000EA/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00AA/P03001A
dU7B00EAdP03001AdU7B00AAdP03001AdU7B00AAdP03001AdU7B00EAdP05003oooooool0000Aool0
01_oo`03002]g:gL00J]g003002]g:gL00<000F]g003002]g:gL00J]g003002]g:gL008000F]g003
002]g:gL00N]g003002]g:gL00800003[M`00:gL00:]g003002]g:gL00J]g003002]g:gL00<000F]
g003002]g:gL00J]g003002]g:gL008000J]g003002]g:gL00J]g003002]g:gL008000F]g003002]
g:gL00N]g003002]g:gL008000F]g003002]g:gL00J]g003002]g:gL008000J]g003002]g:gL00J]
g003002]g:gL008000J]g003002]g:gL00J]g003002]g:gL008000J]g003002]g:gL00F]g003002]
g:gL008000J]g003002]g:gL00J]g003002]g:gL008000J]g003002]g:gL00J]g003002]g:gL0080
00J]g003002]g:gL00J]g003002]g:gL008000F]g003002]g:gL00J]g003002]g:gL008000J]g003
002]_:fl00J]_0<000RU_003002UW:FL00:UW08000FUW003002MO9el00BMO08000:MO003002M>idk
00RM>`8000RDf`03002DfYCJ00:DfP0300246H@I00>46@0300246H@I00F46@0500246H@IQ1T00003
J]D00`00J]EZe@04J]D00`00J]EZe@04J]D00`00H[ER]@05H[D00`00H[ER]@04H[D01000H[ER]F:e
1@00156b00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b00<0056bDK801E6b00<0057B
DM80157B00<0057BDM80157B00<0057BDM80157B00<0057BDM801U7B00@00?ooool0017oo`006_oo
0P002:gL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00ZgL0`000ZgL00<00:gL
[M`01jgL00<00:gL[M`00ZgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL
[M`01ZgL00<00:gL[M`00ZgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL
[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00ZgL0`000ZgL00<00:gL
[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL
[M`01ZgL00<00:gL[M`00ZgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL
[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0P000ZgL00<00:gL
[M`01ZgL00<00:gL[M`00jgL0`000ZgL00<00:fl[K`01jfl00<00:FlYK`00P001ZFl00<00:FLYI`0
1:FL0P000ZFL00<009elWG`01iel0P002idk00<009CK000029CK0P0000>DfP00Q1T01X@I00<008@I
Q1T01H@I00<008@I00001F[E00<006[EJ]D016[E00<006[EJ]D016[E00<006:eH[D01F:e00<006:e
H[D016:e0`000e6b00<0056b00000P0000=A/P00DK801E6b00<0056bDK80156b00<0056bDK80156b
00<0056bDK80156b00<0057BDM80157B00<0057BDM80157B00<0057BDM801E7B00<0057BDM801E7B
00@00?ooool0017oo`006_oo0P001jgL00<00:gL[M`01jgL0`001jgL00<00:gL[M`01ZgL10001jgL
00<00:gL[M`00jgL00<00:gL[M`00`001jgL00<00:gL[M`01jgL0`001jgL00<00:gL[M`01ZgL0`00
2:gL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`001jgL00<00:gL[M`01ZgL0`002:gL00<0
0:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`001jgL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`0
1ZgL0`002:gL00<00:gL[M`01ZgL0`001jgL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`00
2:fl00<00:FlYK`00jFl0`000ZFl00<00:FLYI`01jFL0`002Iel00@009dk000000RM>`04002DfiCK
U=/20008U=/00`00Q1V46@06Q1T00`00Q1V46@06Q1T00`00J]EZe@04J]D00`00J]EZe@04J]D00`00
J]EZe@04J]D00`00H[ER]@05H[D00`00H[ER]@04H[D00`00DK9A/P04DK801000DK9A/U6b0`001U6b
00<0056bDK800e6b00<0056bDK80156b00<0056bDK80156b00<0057BDM80157B00<0057BDM801E7B
00<0057BDM80157B00<0057BDM801E7B00@00?ooool0017oo`006Ooo00<00:gL[M`010000jgL00<0
0:gL[M`01jgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00@00:gL[Mb]g0@000>]g003002]g:gL
00:]g005002]g:gL[M`00002[M`40003[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`00`00[Mb]
g006[M`00`00[Mb]g0040003[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`00`00[Mb]g007[M`0
0`00[Mb]g0040003[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00[Mb]g007[M`00`00[Mb]
g0040003[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`00`00[Mb]g006[M`00`00[Mb]g0040003
[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`00`00[Mb]g007[M`00`00[Mb]g0040002[M`00`00
[Mb]g007[M`00`00[Mb]g0040003[M`00`00[Mb]g007[M`00`00[Mb]g0040003[K`00`00YKbU_007
YK`30009YI`00`00WGbMO0020006WG`00`00WC^M>`02WC/20005WC/00`00U=^Df`04U=/00`00U=^D
f`04U=/00`00Q3T00008Q1T00`00Q1V46@04Q1T00`00J_H00006J]D00`00J]EZe@04J]D00`00J]EZ
e@04J]D00`00H[ER]@05H[D00`00H[ER]@02H[D20006DK800`00DK9A/P03DK830004DK800`00DK9A
/P03DK800`00DK9A/P04DK800`00DK9A/P04DK800`00DM9AdP05DM800`00DM9AdP04DM800`00DM9A
dP04DM800`00DM9AdP05DM801000ooooo`004Ooo000Iool00`00[Mb]g004[M`40009[M`00`00[Mb]
g004[M`40008[M`00`00[Mb]g005[M`40004[M`01@00[Mb]g:gL00001ZgL10002:gL00<00:gL[M`0
1JgL10002:gL00<00:gL[M`01:gL10002JgL00<00:gL[M`01:gL10002:gL00<00:gL[M`01JgL1000
2:gL00<00:gL[M`01:gL10002:gL00<00:gL[M`01JgL10002:gL00<00:gL[M`01JgL10001jgL00<0
0:gL[M`01JgL10002:gL00<00:gL[M`01JgL10002:gL00<00:gL[M`01JgL0`002:gL00<00:gL[M`0
1JgL10002:gL00<00:gL[M`01JgL0`002ZFl00<00:FLYI`00P001ZFL00<009elWG`00iel0`000Yel
00<009dkWC/01Idk0P000Ydk00<009CKU=/01YCK00<009CKU=/00YCK00D008@iQ3V4>@0000R46@04
00246H@IQ1T20002J_H00`00J]EZe@04J]D00`00J]EZe@04J]D00`00J]EZe@04J]D00`00H[ER]@05
H[D00`00H[ER]@0200000e6b001A/P05DK800`00DK9A/P03DK800`00DK9A/P0300000e6b001A/P04
DK800`00DK9A/P04DK800`00DK9A/P05DK800`00DM9AdP04DM800`00DM9AdP04DM800`00DM9AdP05
DM800`00DM9AdP05DM800`00ool0000Aool001Soo`03002]g:gL00J]g003002]g:gL00<000F]g003
002]g:gL00J]g003002]g:gL008000F]g003002]g:gL00N]g003002]g:gL00800003[M`00:gL00:]
g003002]g:gL00J]g003002]g:gL008000J]g003002]g:gL00J]g003002]g:gL008000F]g003002]
g:gL00J]g003002]g:gL00<000F]g003002]g:gL00J]g003002]g:gL008000J]g003002]g:gL00J]
g003002]g:gL008000F]g003002]g:gL00J]g003002]g:gL008000J]g003002]g:gL00J]g003002]
g:gL008000J]g003002]g:gL00J]g003002]g:gL008000F]g003002]g:gL00J]g003002]g:gL0080
00J]g003002]g:gL00J]g003002]g:gL008000J]g003002]g:gL00F]g003002]g:gL008000J]g003
002]g:gL00J]g003002]g:gL008000J]g003002]g:gL00J]g004002U_0000007YK`00`00YIbUW003
YI`30002YI`00`00WGbMO007WG`2000:WC/2000:U=/200000iCK0024>@04Q3T00`00Q1V46@06Q1T0
0`00Q1T00005J_H00`00J]EZe@04J]D00`00J]EZe@04J]D00`00J]EZe@04J]D00`00H[ER]@05H[D2
0004DK800`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P03DK830005DK800`00DK9A/P04DK80
0`00DK9A/P04DK800`00DM9AdP04DM800`00DM9AdP04DM800`00DM9AdP05DM800`00DM9AdP05DM80
1000ooooo`004?oo000Gool20008[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]
g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g006[M`00`00[Mb]
g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g006[M`00`00[Mb]
g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g006[M`00`00[Mb]
g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g006[M`00`00[Mb]
g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003[M`20002[M`00`00[Mb]g006[M`00`00[Mb]
g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g005[M`00`00[Mb]
g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g006[M`00`00YKbU
_002YK`20004YK`00`00YIbUW007YI`2000:WG`01000WE/0000029dk00@009Ck000000ZDf`030024
>H@i00F4>@0300246H@I00J46@03001ZmV[f00AZmP03001ZeF[E00AZe@03001ZeF[E00AZe@03001Z
eF[E00AZe@03001R]F:e00ER]@03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A
/U6b00AA/P@0009A/P03001A/U6b00AA/P03001A/U6b00AA/P03001AdU7B00AAdP03001AdU7B00EA
dP03001AdU7B00AAdP03001AdU7B00EAdP04003ooooo000@ool001Ooo`8000N]g003002]g:gL00N]
g0<000N]g003002]g:gL00J]g0@000N]g003002]g:gL00>]g003002]g:gL00<000N]g003002]g:gL
00J]g0@000N]g003002]g:gL00J]g0<000N]g003002]g:gL00N]g0<000N]g003002]g:gL00J]g0<0
00R]g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000R]g003002]g:gL00J]g0<000R]g003
002]g:gL00F]g0<000R]g003002]g:gL00J]g0<000R]g003002]g:gL00J]g0<000N]g003002]g:gL
00J]g0<000R]g003002]g:gL00J]g0<000N]g003002U_:Fl00FU_0800003YK`00:FL00VUW004002U
O0000007WG`00`00WE^MF`02WE/20004WC/20004U?/00`00U=^Df`06U=/00`00Q3T00007Q3T00`00
Q1V46@04Q1T00`00J_H00006J_H00`00J]EZe@04J]D00`00J]EZe@04J]D00`00J]EZe@04J]D00`00
H[ER]@02H[D30005DK800`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P04DK801000DK9A/U6b
0`001U6b00<0056bDK80156b00<0057BDM801E7B00<0057BDM80157B00<0057BDM80157B00<0057B
DM801U7B00<00?oo00004?oo000Fool00`00[Mb]g0040003[M`00`00[Mb]g007[M`00`00[Mb]g004
0003[M`00`00[Mb]g006[M`01000[Mb]g:gL10000jgL00<00:gL[M`00ZgL00D00:gL[Mb]g00000:]
g0@000>]g003002]g:gL00J]g004002]g:gL[M`40003[M`00`00[Mb]g006[M`00`00[Mb]g0040003
[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00
[Mb]g007[M`00`00[Mb]g0040003[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00[Mb]g007
[M`00`00[Mb]g0040003[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00[Mb]g007[M`00`00
[Mb]g0040003[M`00`00[Mb]g007[M`00`00[Mb]g0040002[M`00`00[Mb]g007[M`00`00[Mb]g004
0003[M`00`00[Mb]g007[M`00`00[Mb]g0040002[M`00`00YKbU_008YK`20009YI`00`00YGbUO002
YG`20004WG`00`00WE^MF`05WE/200000idk002Dn`06U?/20004U=/20003Q3T00`00Q3V4>@05Q3T0
1000Q1V46H@I0P000V[f00<006[fJ_H016[f00<006[EJ]D016[E00<006[EJ]D016[E00<006[EJ]D0
16[E00D006:eH[ER]@00009A/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A
/U6b00AA/P03001A/U6b00=A/P@000AA/P03001A/U6b00AA/P03001AdU7B00AAdP03001AdU7B00AA
dP03001AdU7B00EAdP03001AdU7B00EAdP03003oo`00013oo`005_oo00<00:gL[M`01:gL10002JgL
00<00:gL[M`01:gL10002:gL00<00:gL[M`01JgL10001:gL00D00:gL[Mb]g00000J]g0@000R]g003
002]g:gL00F]g0@000R]g003002]g:gL00B]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL
00B]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL00B]g0@000R]g003002]g:gL00F]g0@0
00R]g003002]g:gL00B]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL00F]g0<000R]g003
002]g:gL00F]g0@000R]g003002]g:gL00F]g0<000VU_003002UW:FL008000JUW003002UO:El00FU
O0800003WG`009eK00VMF`03002DniCk00RDn`800003U=/008@i00F4>@030024>H@i00F4>@030024
6@0000EZmP03001ZmV[f00AZmP03001ZeF[E00AZe@03001ZeF[E00AZe@03001ZeF[E00AZe@<000AA
/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00AA
/P03001A/U6b00<00003DK80056b00EA/P03001AdU7B00AAdP03001AdU7B00EAdP03001AdU7B00AA
dP03001AdU7B00EAdP03003oo`00013oo`005Ooo00<00:gL[M`01jgL00<00:gL00000P001JgL00<0
0:gL[M`01ZgL00<00:gL[M`00P001JgL00<00:gL[M`01jgL00<00:gL[M`00P0000>]g000[M`00ZgL
00<00:gL[M`01ZgL00<00:gL[M`00P001JgL00<00:gL[M`01jgL00<00:gL[M`00P001JgL00<00:gL
[M`01ZgL00<00:gL[M`00P001ZgL00<00:gL[M`01ZgL00<00:gL[M`00P001JgL00<00:gL[M`01ZgL
00<00:gL[M`00P001ZgL00<00:gL[M`01ZgL00<00:gL[M`00P001JgL00<00:gL[M`01ZgL00<00:gL
[M`00P001ZgL00<00:gL[M`01ZgL00<00:gL[M`00P001JgL00<00:gL[M`01ZgL00<00:gL[M`00P00
1ZgL00<00:gL[M`01ZgL00<00:gL[M`00P001ZgL00<00:gL[M`01JgL00<00:gL[M`00P001ZgL00<0
0:gL[M`01ZgL00<00:gL[M`00P001ZgL00<00:gL[M`01JgL00<00:fl[K`00P001ZFl00<00:FLYI`0
0jFL0`000ZFL00<00:ElYG`02:El00<009eKWE/029eK00<009Ck00002iCk00<008@iQ3T01X@i00<0
08@iQ3T01H@i00<006[fJ_H016[f00<006[fJ_H016[f00<006[EJ]D016[E00<006[EJ]D016[E00<0
06[EJ]D016[E00<0056bDK80156b00<0056bDK800e6b00<0056bDK800e6b00<0056bDK80156b00<0
056bDK80156b00<0056bDK800e6b00<0056bDK800e6b0`001E6b00<0057BDM801E7B00<0057BDM80
157B00<0057BDM80157B00<0057BDM801U7B00<00?oo00003ooo000Eool00`00[Mb]g006[M`00`00
[Mb]g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00
[Mb]g002[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g006[M`00`00
[Mb]g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g006[M`00`00
[Mb]g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g006[M`00`00
[Mb]g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g006[M`00`00
[Mb]g003[M`30002[M`00`00[Mb]g005[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g006[M`00`00
[Mb]g003[M`30002[M`00`00[Mb]g005[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g006[M`00`00
[Mb]g003[M`30002[M`00`00[Mb]g005[M`00`00[Kb]_003[K`30002YK`00`00YIbUW007YI`30009
YG`01000WE/000001ieK00@009CkU?^Dn`8000RDn`030024F@0000R4>@030024>H@i00>4>@03001[
5P0000IZmP03001ZmV[f00AZmP03001ZeF[E00AZe@03001ZeF[E00AZe@04001ZeF[EJ]D30006DK80
0`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P03DK80
0`00DK9A/P04DK800`00DK8000020002DK800`00DM9AdP05DM800`00DM9AdP04DM800`00DM9AdP05
DM800`00DM9AdP05DM800`00ool0000?ool001Coo`<000N]g003002]g:gL00J]g0<000N]g003002]
g:gL00J]g0@000N]g003002]g:gL00>]g003002]g:gL00<000N]g003002]g:gL00J]g0<000R]g003
002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000R]g003002]g:gL00J]g0<000N]g003002]g:gL
00J]g0<000R]g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000R]g003002]g:gL00J]g0<0
00N]g003002]g:gL00J]g0<000R]g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000R]g003
002]g:gL00J]g0<000N]g003002]_:fl00J]_0<000VUW003002UO:El008000JUO003002MFieK00:M
F`8000FMF`03002DniCk00>Dn`03002DniCk00BDn`050024FHAIQ5T00008Q3T01@00Q3V4>H@i0000
0V/F00<006[fJ_H016[f00<006[fJ_H01F[f00<006[EJ]D00f[E00<006[EJ]D016[E00@006[E0000
009A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b
00AA/P03001A/U6b00=A/P03001A/U6b00EA/P04001A/U6bDK840006DM800`00DM9AdP04DM800`00
DM9AdP05DM800`00DM9AdP05DM800`00ool0000?ool001Coo`03003oo`0000@000:]g003002]g:gL
00N]g003002]g:gL00@000>]g003002]g:gL00J]g004002]g:gL[M`40003[M`00`00[Mb]g002[M`0
1@00[Mb]g:gL00000ZgL10000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01jgL
00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<00:gL
[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<00:gL[M`01000
0jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<00:gL[M`010000ZgL00<0
0:gL[M`01jgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<00:gL[M`010000ZgL00<00:gL[M`0
1jgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<00:gL[M`010000ZgL00<00:fl[K`01jfl00<0
0:FLYI`00P001ZFL00<00:ElYG`00jEl0`000ZEl00<009eKWE/01IeK0P000YeK00<009CkU?/01ICk
00<009CkU?/00YCk00<008AIQ5T00hAI00<008@iQ3T01X@i00<008@i000016/F00<006[fJ_H016[f
00<006[fJ_H016[f00<006[EJ]D016[E00<006[EJ]D016[E00<0056bDK800e6b00<0056bDK80156b
00<0056bDK800e6b00<0056bDK800e6b00<0056bDK800e6b00<0056bDK80156b00<0056bDK80156b
00<0056bDK80156b00<0056bDK80156b0`00157B00<0057BDM801E7B00<0057BDM80157B00<0057B
DM801U7B0P003ooo000Dool00`00ooooo`03ool50008[M`00`00[Mb]g004[M`40008[M`00`00[Mb]
g005[M`40003[M`00`00[Mb]g002[M`00`00[Mb]g004[M`40008[M`00`00[Mb]g004[M`40008[M`0
0`00[Mb]g005[M`40008[M`00`00[Mb]g004[M`40008[M`00`00[Mb]g005[M`40008[M`00`00[Mb]
g004[M`40008[M`00`00[Mb]g005[M`40007[M`00`00[Mb]g005[M`40008[M`00`00[Mb]g005[M`3
0008[M`00`00[Mb]g005[M`40008[M`00`00[Mb]g005[M`30008[M`00`00[Mb]g005[M`40008[M`0
0`00[Mb]g005[M`30008[K`00`00YIbUW003YI`30002YI`00`00YGbUO007YG`2000:WE/20009U?/2
00000iCk0024F@06Q5T00`00Q3V4>@06Q3T00`00JaI[5P03JaH00`00J_IZmP04J_H00`00J_IZmP05
J_H00`00J]EZe@03J]D00`00J]EZe@03J]D20005DK800`00DK9A/P04DK800`00DK9A/P03DK800`00
DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P04DK800`00
DK9A/P04DK800`00DM9AdP030002DM800`00DM9AdP04DM800`00DM9AdP04DM800`00DM9AdP06DM82
000?ool001Coo`03003ooooo00Koo`@000F]g003002]g:gL00J]g003002]g:gL008000F]g003002]
g:gL00N]g003002]g:gL00800003[M`00:gL00:]g003002]g:gL00J]g003002]g:gL008000F]g003
002]g:gL00J]g003002]g:gL008000J]g003002]g:gL00J]g003002]g:gL008000F]g003002]g:gL
00J]g003002]g:gL008000J]g003002]g:gL00J]g003002]g:gL008000F]g003002]g:gL00J]g003
002]g:gL008000J]g003002]g:gL00J]g003002]g:gL008000F]g003002]g:gL00J]g003002]g:gL
008000J]g003002]g:gL00F]g003002]g:gL008000J]g003002]g:gL00J]g003002]g:gL008000J]
g003002]g:gL00F]g003002]g:gL008000J]g003002]g:gL00J]g003002]g:gL008000F]g003002]
g:gL00J]g003002]g:gL008000J]_003002UW:FL00JUW08000ZUO004002MG0000008WE/01000U?/0
00002ICk00<008AIQ5T01hAI00<008@iQ3T018@i00<006/F00001F/F00<006[fJ_H016[f00<006[f
J_H016[f00<006[EJ]D016[E00<006[EJ]D00P0000=A/P00DK80156b00<0056bDK80156b00<0056b
DK800e6b00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b00<0056bDK800e6b00<0056b
DK80156b00<0056bDK801E6b00<0057BDM800U7B0`001U7B00<0057BDM801E7B00<0057BDM801E7B
0P003ooo000Cool00`00ooooo`0:ool40002[M`00`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`0
0`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`0
0`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g007[M`00`00[Mb]g002[M`30002[M`0
0`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003[M`30002[M`0
0`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g003[M`20002[M`0
0`00[Mb]g006[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`0
0`00[Mb]g006[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g005[M`00`00[Mb]g003[M`30002[M`0
0`00[Mb]g006[M`00`00[Mb]g003[M`20002[M`00`00[Mb]g006[M`00`00[Mb]g003[M`30002[K`0
0`00YIbUW007YI`01000YI`000001jEl00<009eLWE`00YeL0P0019eK0P0019Ck00<009CkU?/01ICk
00<008aI00002HAI00@008@iQ3V4>@80009[5P03001[5V/F00A[5P03001ZmV[f00AZmP03001ZmV[f
00AZmP03001ZeF[E00=Ze@03001Ze@0000AA/P03001A/U6b009A/P03001A/U6b00AA/P03001A/U6b
00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b
00EA/P03001A/U6b00AA/P03001AdU7B00AAdP@000=AdP03001AdU7B00EAdP03001AdU7B00IAdP80
00koo`004ooo00<00?ooool03_oo0`001jgL00<00:gL[M`01ZgL10001jgL00<00:gL[M`00jgL00<0
0:gL[M`00`001jgL00<00:gL[M`01ZgL0`001jgL00<00:gL[M`01ZgL10001jgL00<00:gL[M`01ZgL
0`001jgL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01ZgL0`001jgL00<00:gL[M`01ZgL0`002:gL
00<00:gL[M`01JgL0`002:gL00<00:gL[M`01ZgL0`001jgL00<00:gL[M`01ZgL0`002:gL00<00:gL
[M`01ZgL0`001jgL00<00:gL[M`01ZgL0`002:gL00<00:gL[M`01JgL0`002:gL00<00:gL[M`01ZgL
0`002:FL00<00:FLYI`00ZFL0P001:El00<009eLWE`01IeL0P0000>MF`00U?/01YCk0P0019Ck00D0
08aIS5V<F@0000V4F@030024>@0000E[5P03001[5V/F00=[5P03001ZmV[f00AZmP03001ZmV[f00AZ
mP03001ZeF[E00AZe@03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00AA
/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00AA/P03001A/U6b00AA
/P03001A/U6b00AA/P03001AdU7B00AAdP04001AdU7BDM8300000e7B001AdP05DM800`00DM9AdP06
DM82000>ool001?oo`03003ooooo017oo`@000>]g003002]g:gL00J]g004002]g:gL[M`40003[M`0
0`00[Mb]g002[M`01@00[Mb]g:gL00000ZgL10000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL
00<00:gL[M`01ZgL00@00:gL[Mb]g0@000>]g003002]g:gL00J]g003002]g:gL00@000>]g003002]
g:gL00J]g003002]g:gL00@000>]g003002]g:gL00N]g003002]g:gL00@000>]g003002]g:gL00J]
g003002]g:gL00@000>]g003002]g:gL00J]g003002]g:gL00@000>]g003002]g:gL00N]g003002]
g:gL00@000>]g003002]g:gL00J]g003002]g:gL00@000>]g003002]g:gL00N]g003002]g:gL00@0
00:]g003002]g:gL00N]g003002]g:gL00@000>]g003002]g:gL00J]g003002]g:gL00@000>]g003
002]g:gL00N]g003002UW:FL008000FUW003002UW:FL00FUW0800003YG`009eL00VMG003002DniCk
00RDn`800003U?/008aI00B<F@030024FHAI00N4F@03001[5V/F00A[5P03001[5V/F00A[5P03001Z
mV[f00AZmP03001ZmV[f00AZmP04001ZeF[EJ]D30005DK800`00DK9A/P03DK800`00DK9A/P04DK80
0`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P04DK800`00DK9A/P03DK80
0`00DK9A/P04DK800`00DK9A/P04DK800`00DM9AdP05DM800`00DM9AdP03DM830006DM800`00DM9A
dP05DM82000>ool001?oo`03003ooooo01Goo`@000R]g003002]g:gL00F]g0@000>]g003002]g:gL
00:]g003002]g:gL00B]g0@000R]g003002]g:gL00B]g0@000R]g003002]g:gL00F]g0@000R]g003
002]g:gL00B]g0@000R]g003002]g:gL00B]g0@000R]g003002]g:gL00F]g0@000N]g003002]g:gL
00F]g0@000R]g003002]g:gL00B]g0@000R]g003002]g:gL00F]g0@000N]g003002]g:gL00F]g0@0
00R]g003002]g:gL00F]g0<000R]g003002]g:gL00F]g0@000N]g003002]g:gL00F]g0@000R]g003
002UW:FL00>UW08000:UW003002UW:FL00RUW003002MG9eL00RMG004002E6`00000:U?/00`00S5V<
F@05S5T20006Q5T00`00JaH00006JaH00`00JaI[5P03JaH00`00J_IZmP04J_H00`00J_IZmP04J_H0
1000J]D000000U6b00<0056bDK800e6b00<0056bDK800e6b00<0056bDK80156b00<0056bDK800e6b
00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b
00<0056bDK801E6b00<0057BDM80157B00<0057BDM80157B00<0057B00000P000e7B00<0057BDM80
1E7B0P003_oo000Cool00`00ooooo`0Hool50003[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`0
0`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00[Mb]
g007[M`00`00[Mb]g0040003[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00[Mb]g006[M`0
0`00[Mb]g0040003[M`00`00[Mb]g007[M`00`00[Mb]g0040002[M`00`00[Mb]g007[M`00`00[Mb]
g0040003[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00[Mb]g007[M`00`00[Mb]g0040002
[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00
[Mb]g007[M`00`00[Mb]g0040002[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`00`00YIbUW006
YI`30009YI`01000WE`000001ieL00<009DKUA/00YDK00<009CkU?/01YCk00<008aj000028aI00@0
08AIQ5V4F@80009[5P03001[5V/F00A[5P03001[5V/F00A[5P03001ZmV[f00AZmP03001ZmV[f00AZ
mP03001A/U6b00=A/P03001A/U6b009A/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A
/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00EA
/P03001A/U6b00AA/P03001AdU7B00AAdP03001AdU7B00EAdP04001AdU7BDM840008DM800`00oooo
o`0<ool001?oo`03003ooooo01coo`D000V]g003002]g:gL00:]g003002]g00000<000R]g003002]
g:gL00B]g0@000R]g003002]g:gL00B]g0@000R]g003002]g:gL00F]g0@000R]g003002]g:gL00B]
g0@000R]g003002]g:gL00B]g0@000R]g003002]g:gL00F]g0<000R]g003002]g:gL00F]g0@000R]
g003002]g:gL00B]g0@000R]g003002]g:gL00F]g0<000R]g003002]g:gL00F]g0@000N]g003002]
g:gL00F]g0@000R]g003002]g:gL00F]g0<000R]g003002]g:gL00F]g0@000RUW003002UW:FL0080
00JUW003002MG9eL00:MG08000FMG003002E6iDK00>E6`8000BDn`8000><NP03002<FHaI00J<F@03
0024F@0000E[5P03001[5V/F00A[5P03001[5V/F00=[5P03001ZmV[f00AZmP03001ZmV[f00=ZmP80
00EA/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b
00AA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00AA/P03001A/U6b00AA/P03001A/U6b
00AA/P03001AdU7B00EAdP03001AdU7B00AAdP03001AdU7B00AAdP<000IAdP03003ooooo00coo`00
4ooo00<00?ooool07ooo1@001JgL00<00:gL[M`00ZgL00D00:gL[Mb]g00000:]g08000F]g003002]
g:gL00J]g003002]g:gL008000F]g003002]g:gL00J]g003002]g:gL008000J]g003002]g:gL00J]
g003002]g:gL008000F]g003002]g:gL00J]g003002]g:gL008000F]g003002]g:gL00J]g003002]
g:gL008000J]g003002]g:gL00F]g003002]g:gL008000J]g003002]g:gL00J]g003002]g:gL0080
00F]g003002]g:gL00J]g003002]g:gL008000J]g003002]g:gL00F]g003002]g:gL008000J]g003
002]g:gL00J]g003002]g:gL008000F]g003002]g:gL00J]g003002]g:gL008000J]g003002]g:gL
00F]g003002]g:gL008000J]g003002]g:gL00J]g003002U_:Fl008000FUW003002UW:FL00>UW0<0
00:UW003002MG9eL00FMG08000:MG003002E6iDK00JE6`800003U?/008aj00F<NP03002<FHaI00J<
F@03001[5V/F00A[5P03001[5V/F00A[5P03001[5V/F00A[5P03001ZmV[f00AZmP03001ZmV[f0080
0003DI40056b00AA/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00AA
/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA
/P03001A/U6b00AA/P03001AdU7B00EAdP03001AdU7B00AAdP03001AdU7B00EAdP03001AdP000080
00=AdP8000goo`004_oo00<00?ooool08ooo1@000ZgL00<00:gL[M`00ZgL00D00:gL[Mb]g00000B]
g0<000:]g003002]g:gL00J]g003002]g:gL00:]g0<000:]g003002]g:gL00J]g003002]g:gL00:]
g0<000:]g003002]g:gL00J]g003002]g:gL00>]g0<000:]g003002]g:gL00J]g003002]g:gL00:]
g0<000:]g003002]g:gL00J]g003002]g:gL00:]g0<000:]g003002]g:gL00J]g003002]g:gL00:]
g0<000:]g003002]g:gL00J]g003002]g:gL00>]g0<000:]g003002]g:gL00F]g003002]g:gL00>]
g0<000:]g003002]g:gL00J]g003002]g:gL00:]g0<000:]g003002]g:gL00J]g003002]g:gL00>]
g08000:]g003002]g:gL00J]g003002]g:gL00>]g0<000:]g003002]g:gL00F]g003002]g:gL00>]
g0<000:]g003002]g:gL00J]g003002U_:Fl00>U_08000:UW003002UW:FL00NUW08000ZMG08000^E
6`03002<NXaj00J<NP8000F<F@03001c=P0000I[5P03001[5V/F00A[5P03001[5V/F00A[5P03001Z
mV[f00=ZmP03001ZmP0000AAT@03001A/U6b009A/P03001A/U6b00=A/P03001A/U6b00=A/P03001A
/U6b00AA/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00AA/P03001A
/U6b00=A/P03001A/U6b00AA/P03001A/U6b00EA/P03001AdU7B00AAdP03001AdU7B00AAdP03001A
dU7B00EAdP03001AdU7B009AdP<00003DM800?oo00coo`004_oo00<00?ooool09ooo10000jgL00D0
0:gL[Mb]g00000R]g0<000N]g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000R]g003002]
g:gL00J]g0<000N]g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000N]g003002]g:gL00J]
g0<000R]g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000R]
g003002]g:gL00F]g0<000R]g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000N]g003002U
_:Fl00JU_08000ZUW004002MO0000008WE`01000UA/0000029DK00<008aj00002Haj00D008aIS5V<
F@00009c=P03001[5V/F00A[5P03001[5V/F00A[5P03001[5V/F00A[5P03001ZmV[f00AZmP03001A
TE6A00=AT@03001A/U6b009A/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00AA/P03001A
/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A
/U6b00EA/P03001A/U6b00AA/P03001AdU7B00AAdP03001AdU7B00EAdP03001AdU7B00AAdP03001A
dU7B00EAdP8000goo`004_oo00<00?ooool0:_oo1@000jgL00<00:gL[M`01ZgL00<00:gL[M`01000
0jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<0
0:gL[M`01jgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`0
1ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<0
0:gL[M`010000ZgL00<00:gL[M`01jgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`0
10000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<00:gL[M`010000ZgL
00<00:gL[M`01jgL00<00:gL[M`010000ZgL00<00:FlYK`01jFl00@00:FL000000NUW003002MO9el
00:MO08000FMG003002E6iDK00:E6`8000FE6`05002<NXajS7X00009S7X00`00S5T00004LcH00`00
JaI[5P04JaH00`00JaI[5P04JaH00`00JaI[5P04JaH01000J_IZmV[f0`001E6A00<0056bDK800e6b
00<0056bDK800e6b00<0056bDK800U6b00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b
00<0056bDK800e6b00<0056bDK80156b00<0056bDK80156b00<0056bDK80156b00<0056bDK80156b
00<0057BDM801E7B00<0057BDM80157B00<0057BDM801E7B00<0057BDM80157B00<00?ooool03?oo
000Bool00`00ooooo`0]ool60008[M`00`00[Mb]g004[M`40008[M`00`00[Mb]g004[M`40008[M`0
0`00[Mb]g004[M`40008[M`00`00[Mb]g005[M`40007[M`00`00[Mb]g005[M`40008[M`00`00[Mb]
g004[M`40008[M`00`00[Mb]g004[M`40008[M`00`00[Mb]g005[M`30008[M`00`00[Mb]g005[M`4
0007[M`00`00[Mb]g005[M`40007[M`00`00[Mb]g005[M`40008[M`00`00[Mb]g005[M`30008[M`0
0`00[Mb]g005[M`30008YK`00`00YIbUW002YI`20005YI`00`00WGbMO004WG`20002WE`00`00UA^E
6`05UA/20002UA/00`00S7Z<NP03S7X00`00S7Z<NP07S7X00`00LcIc=P03LcH00`00JaI[5P04JaH0
0`00JaI[5P04JaH00`00JaI[5P04JaH01000J_H000000U6A00<0056ADI400e6A00<0056bDK800e6b
00<0056bDK800e6b00<0056bDK800e6b00<0056bDK800e6b00<0056bDK80156b00<0056bDK800e6b
00<0056bDK80156b00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b00<0056bDK80156b
00<0057BDM801E7B00<0057BDM80157B00<0057BDM801E7B00<0057BDM800e7B00<00?ooool03Ooo
000Bool00`00ooooo`0/ool00`00ooooo`02ool60003[M`00`00[Mb]g006[M`00`00[Mb]g0040003
[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00
[Mb]g007[M`00`00[Mb]g0040002[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`00`00[Mb]g006
[M`00`00[Mb]g0040003[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00[Mb]g006[M`00`00
[Mb]g0040003[M`00`00[Mb]g007[M`00`00[Mb]g0040002[M`00`00[Mb]g007[M`00`00[Mb]g004
0002[M`00`00[Mb]g007[M`00`00[Mb]g0040003[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`0
0`00[Mb]g006[M`00`00[Mb]g0020006YK`00`00YIbUW004YI`20002YI`00`00WGbMO007WG`2000:
UA/20007S7X20006S7X00`00LeL00005LcH00`00JaI[5P04JaH00`00JaI[5P04JaH00`00JaI[5P04
JaH00`00DI5AT@03DI400`00DI5AT@02DI400`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P03
DK800`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P04
DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P05DK800`00DM9AdP04DM800`00DM9AdP05
DM800`00DM9AdP04DM801000DM9AdU7B0P004?oo000Bool00`00ooooo`0/ool00`00ooooo`06ool6
0008[M`00`00[Mb]g004[M`40008[M`00`00[Mb]g004[M`40008[M`00`00[Mb]g004[M`40008[M`0
0`00[Mb]g005[M`30008[M`00`00[Mb]g005[M`40007[M`00`00[Mb]g005[M`40007[M`00`00[Mb]
g005[M`40008[M`00`00[Mb]g004[M`40008[M`00`00[Mb]g005[M`30008[M`00`00[Mb]g005[M`3
0008[M`00`00[Mb]g005[M`40007[M`00`00[Mb]g005[M`40007[M`00`00[Mb]g003[M`30002YK`0
0`00YIbUW007YI`30009WG`01000WA/0000029DK00<008bJ000028aj00@008ajS7Z<NP80009cE`03
001c=W<f00Ac=P03001[5V/F00A[5P03001[5V/F00=[5P03001[5V/F00=[5P8000EAT@03001ATE6A
00=AT@03001A/U6b009A/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b
00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b
00EA/P03001A/U6b00AA/P03001AdU7B00AAdP03001AdU7B00EAdP03001AdU7B00AAdP03001AdU7B
0080017oo`004_oo00<00?ooool0:ooo00<00?ooool02_oo1@001JgL00<00:gL[M`01ZgL00<00:gL
[M`00P001JgL00<00:gL[M`01ZgL00<00:gL[M`00P001JgL00<00:gL[M`01ZgL00<00:gL[M`00P00
1ZgL00<00:gL[M`01JgL00<00:gL[M`00P001ZgL00<00:gL[M`01ZgL00<00:gL[M`00P001JgL00<0
0:gL[M`01ZgL00<00:gL[M`00P001JgL00<00:gL[M`01ZgL00<00:gL[M`00P001JgL00<00:gL[M`0
1ZgL00<00:gL[M`00P001ZgL00<00:gL[M`01JgL00<00:gL[M`00P001ZgL00<00:gL[M`01JgL00<0
0:gL[M`00P001ZgL00<00:gL[M`01ZgL00<00:gL[M`00P001JgL00<00:gL[M`01ZgL00<00:gL[M`0
0P001JgL00<00:gL[M`01ZgL0`002JFL00<009elWG`00P001Iel0P0019dK0P0019DK0P000hbJ00<0
08ajS7X01Xaj00<008aj00001G=G00<007<fLcH00g<f00<006/FJaH016/F00<006/FJaH016/F00<0
06/FJaH00P0000=AT@00DI40156A00<0056ADI400e6A00<0056bDK800U6b00<0056bDK800e6b00<0
056bDK800e6b00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b00<0056bDK800e6b00<0
056bDK80156b00<0056bDK80156b00<0056bDK80156b00<0056bDK80156b00<0057BDM801E7B00<0
057BDM80157B00<0057BDM801E7B0`004_oo000Aool00`00ooooo`0[ool00`00ooooo`0>ool50002
[M`00`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g002[M`30002
[M`00`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`00`00[Mb]g006[M`00`00[Mb]g002[M`30002
[M`00`00[Mb]g006[M`00`00[Mb]g003[M`20002[M`00`00[Mb]g006[M`00`00[Mb]g003[M`20002
[M`00`00[Mb]g006[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g005[M`00`00[Mb]g003[M`30002
[M`00`00[Mb]g005[M`00`00[Mb]g003[M`30002[M`00`00[Mb]g005[M`00`00[Mb]g003[M`30002
[M`00`00[Mb]g006[M`00`00[Mb]g003[M`20002[M`00`00[Mb]g006[M`00`00[Mb]g003[M`20002
[M`00`00[Mb]g007[M`00`00YIbUW0020005YI`20005WG`20002WG`00`00WA^M6`06WA/200000iDK
002<VP05S9X00`00S7Z<NP06S7X00`00LeMcE`04LeL00`00LcIc=P04LcH00`00JaI[5P04JaH00`00
JaI[5P03JaH00`00JaH00004DI400`00DI5AT@02DI400`00DI5AT@03DI400`00DK9A/P03DK800`00
DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P03DK800`00
DK9A/P04DK800`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P04DK800`00
DM9AdP05DM800`00DM9AdP04DM800`00DM9AdP05DM82000Cool0017oo`03003ooooo02_oo`03003o
oooo01;oo`@000N]g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000N]g003002]g:gL00J]
g0<000N]g003002]g:gL00J]g0<000R]g003002]g:gL00F]g0<000R]g003002]g:gL00F]g0<000R]
g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000N]g003002]
g:gL00J]g0<000R]g003002]g:gL00F]g0<000R]g003002]g:gL00F]g0<000R]g003002UW:FL00>U
W08000:UW003002MO9el00NMO08000^M6`03002<VXbJ00J<VP03002<NXaj00B<NP03001cE`0000Ic
E`03001c=W<f00=c=P03001[5V/F00A[5P03001[5V/F00A[5P03001ATE6A00=AT@03001ATE6A009A
T@03001ATE6A00=AT@03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00=A
/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00AA/P03001A/U6b00=A
/P03001A/U6b00EA/P03001A/U6b00AA/P03001AdU7B00AAdP03001AdU7B00EAdP03001AdU7B00=A
dP03003ooooo01?oo`004Ooo00<00?ooool0:_oo00<00?ooool05_oo1@000jgL00<00:gL[M`01ZgL
00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL
[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`01000
0jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01jgL00<00:gL[M`010000ZgL00<0
0:gL[M`01jgL00<00:gL[M`010000ZgL00<00:gL[M`01jgL00<00:gL[M`010000ZgL00<00:gL[M`0
1jgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<0
0:gL[M`010000jgL00<00:FLYI`01ZFL0`002Iel00@009dk000000RM6`03002<VP0000R<VP04002<
NXajS7X20002LeL00`00LeMcE`04LeL00`00LcIc=P04LcH00`00JaI[5P04JaH01000JaI[5V/F0`00
1E6A00<0056ADI400e6A00<0056ADI400U6A00<0056bDK800e6b00<0056bDK800e6b00<0056bDK80
0e6b00<0056bDK80156b00<0056bDK800e6b00<0056bDK800e6b00<0056bDK80156b00<0056bDK80
156b00<0056bDK800e6b00<0056bDK801E6b00<0056bDK80156b00<0057BDM801E7B00<0057BDM80
157B00<0057BDM800U7B00<00?ooool05?oo000Aool00`00ooooo`0Zool00`00ooooo`0Jool50008
[M`00`00[Mb]g004[M`40008[M`00`00[Mb]g004[M`40008[M`00`00[Mb]g004[M`40008[M`00`00
[Mb]g004[M`40008[M`00`00[Mb]g004[M`40008[M`00`00[Mb]g004[M`40008[M`00`00[Mb]g005
[M`30008[M`00`00[Mb]g005[M`30008[M`00`00[Mb]g005[M`30008[M`00`00[Mb]g005[M`40007
[M`00`00[Mb]g005[M`40007[M`00`00[Mb]g005[M`40008YI`00`00WGbMO0020006WG`00`00WC^M
>`02WC/00`00WA^M6`04WA/01@00S9Z<VXbJ000028bJ00<008aj00001G=G00<007=GLeL017=G00<0
07<fLcH017<f00<006/FJaH00f/F00@006/F0000009AT@03001ATE6A00=AT@03001ATE6A00=AT@03
001ATE6A009AT@03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00AA/P03
001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00AA/P03
001A/U6b00AA/P03001A/U6b00AA/P03001AdU7B00EAdP03001AdU7B00AAdP05001AdU7BDM80000G
ool0017oo`03003ooooo02Woo`03003ooooo01koo`@000F]g003002]g:gL00J]g003002]g:gL0080
00F]g003002]g:gL00J]g003002]g:gL008000F]g003002]g:gL00J]g003002]g:gL008000F]g003
002]g:gL00J]g003002]g:gL008000F]g003002]g:gL00J]g003002]g:gL008000F]g003002]g:gL
00J]g003002]g:gL008000J]g003002]g:gL00F]g003002]g:gL008000J]g003002]g:gL00F]g003
002]g:gL008000J]g003002]g:gL00F]g003002]g:gL008000J]g003002]g:gL00J]g003002]g:gL
008000F]g003002]g:gL00J]g003002]g:gL008000F]g003002]g:gL00J]g003002UW:FL008000FU
W003002MO9el00>MO0<000:MO003002M>idk00BM>`8000BM6`03002<VXbJ00:<VP03002<VXbJ00J<
VP03001cEg=G00AcE`03001cEg=G00EcE`03001c=W<f00=c=P03001[5V/F00A[5P03001ATE6A00=A
T@03001ATE6A009AT@03001ATE6A00=AT@03001ATE6A00=AT@03001A/U6b00=A/P03001A/U6b009A
/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A
/P03001A/U6b00EA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00EA/P03001AdU7B00AA
dP03001AdU7B00AAdP04001AdU7B000Hool0017oo`03003ooooo02Soo`03003ooooo02?oo`<000:]
g003002]g:gL00J]g003002]g:gL00:]g0<000:]g003002]g:gL00J]g003002]g:gL00:]g0<000:]
g003002]g:gL00J]g003002]g:gL00:]g0<000:]g003002]g:gL00J]g003002]g:gL00:]g0<000:]
g003002]g:gL00J]g003002]g:gL00:]g0<000:]g003002]g:gL00J]g003002]g:gL00:]g0<000:]
g003002]g:gL00J]g003002]g:gL00:]g0<000:]g003002]g:gL00J]g003002]g:gL00:]g0<000:]
g003002]g:gL00J]g003002]g:gL00:]g0<000:]g003002]g:gL00J]g003002]g:gL00>]g08000:]
g003002]g:gL00J]g003002]g:gL00>]g08000:]g003002]g:gL00J]g003002UW:FL00>UW08000:U
W003002MO9el00NMO08000VM>`800003WA/008bJ00F<VP8000F<VP03001cM`0000IcE`03001cEg=G
00AcE`03001c=W<f00Ac=P04001[5V/FJaH30005DI400`00DI5AT@02DI400`00DI5AT@03DI400`00
DI5AT@03DI400`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P03DK800`00
DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P04DK800`00DK9A/P03DK800`00
DK9A/P05DK800`00DK9A/P04DK800`00DM9AdP04DM800`00DM9AdP05DM82000Iool0017oo`03003o
oooo02Soo`03003ooooo02Koo`<000N]g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000N]
g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000N]g003002]
g:gL00J]g0<000N]g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000N]g003002]g:gL00J]
g0<000R]g003002]g:gL00F]g0<000R]g003002]g:gL00F]g0<000N]g003002UW:FL00JUW08000ZM
O004002M>`000009WC/00`00S9Z<VP07S9X01@00S9Z<VXbJ00000W=g00<007=GLeL017=G00<007=G
LeL01G=G00<007<fLcH00g<f00@006/F0000009AT@03001ATE6A00=AT@03001ATE6A00=AT@03001A
TE6A009AT@03001ATE6A00=AT@03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00=A/P03001A
/U6b00AA/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00AA/P03001A
/U6b00=A/P03001A/U6b00EA/P03001A/U6b00AA/P03001AdU7B00EAdP03001AdU7B00AAdP03003o
oooo01Soo`004?oo00<00?ooool0:?oo00<00?ooool0:_oo10000jgL00<00:gL[M`01ZgL00<00:gL
[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`01000
0jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<0
0:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`0
1ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<0
0:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000ZgL00<00:FLYI`01jFL00@009el0000
00NMO003002M>idk00:M>`03002M>idk00FM>`03002<^P0000V<VP03002<VP0000AcM`03001cEg=G
00AcE`03001cEg=G00AcE`03001c=W<f00Ac=P03001ATE6A00=AT@03001ATE6A009AT@03001ATE6A
00=AT@03001ATE6A009AT@03001ATE6A00=AT@03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b
00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b
00AA/P03001A/U6b00AA/P03001A/U6b00AA/P03001A/U6b00AA/P03001AdU7B00EAdP03001AdU7B
00=AdP03003ooooo01Woo`004?oo00<00?ooool09ooo00<00?ooool0;ooo10002:gL00<00:gL[M`0
1:gL10002:gL00<00:gL[M`01:gL10002:gL00<00:gL[M`01:gL10001jgL00<00:gL[M`01JgL1000
1jgL00<00:gL[M`01JgL10001jgL00<00:gL[M`01JgL10001jgL00<00:gL[M`01JgL10001jgL00<0
0:gL[M`01JgL10001jgL00<00:gL[M`01JgL10001jgL00<00:gL[M`01JgL10001jgL00<00:gL[M`0
1JgL0`002:FL00<009elWG`00Yel0P001Iel00<009dkWC/00idk00<009dkWC/00Ydk0P000hbj00<0
08bJS9X01hbJ00<007=gLgL017=g00<007=GLeL017=G00<007=GLeL017=G00@007<fLcIc=P<000EA
T@03001ATE6A009AT@03001ATE6A00=AT@03001ATE6A00=AT@03001ATE6A009AT@03001A/U6b00=A
/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA
/P03001A/U6b00=A/P03001A/U6b00EA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00EA
/P03001AdU7B00AAdP04001AdU7BDM82000Lool0013oo`03003ooooo02Ooo`03003ooooo03;oo`D0
00>]g003002]g:gL00J]g003002]g:gL00@000>]g003002]g:gL00J]g003002]g:gL00@000>]g003
002]g:gL00J]g003002]g:gL00@000:]g003002]g:gL00N]g003002]g:gL00@000:]g003002]g:gL
00N]g003002]g:gL00@000:]g003002]g:gL00N]g003002]g:gL00@000:]g003002]g:gL00N]g003
002]g:gL00@000:]g003002]g:gL00N]g003002]g:gL00@000:]g003002]g:gL00N]g003002]g:gL
00@000:]g003002]g:gL00N]g003002]g:gL00@000:]g003002]g:gL00J]g003002]g:gL00@000>U
W003002MO9el00FMO08000:MO003002M>idk00FM>`800003WC/008bj00F<^P8000J<VP03001cM`00
00EcM`03001cEg=G00AcE`03001cEg=G00AcE`04001c=P000002DI400`00DI5AT@03DI400`00DI5A
T@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DK9A/P03DK800`00DK9A
/P02DK800`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A
/P04DK800`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P05DK800`00DK9A/P04DK800`00DM9A
dP04DM800`00DM9AdP02000Mool0013oo`03003ooooo02Koo`03003ooooo03Ooo`D000R]g003002]
g:gL00B]g0@000N]g003002]g:gL00F]g0@000N]g003002]g:gL00F]g0<000R]g003002]g:gL00F]
g0<000R]g003002]g:gL00F]g0<000R]g003002]g:gL00F]g0<000R]g003002]g:gL00F]g0<000R]
g003002]g:gL00F]g0<000R]g003002]g:gL00F]g0<000N]g08000N]g0<000N]g003002]g:gL00F]
g0<000ZMO08000ZM>`03002<^Xbj00N<^P04002<VXbJS9X20002LgL00`00LgMcM`04LgL00`00LeMc
E`04LeL00`00LeMcE`04LeL00`00DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI400`00DI5A
T@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A
/P03DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A
/P04DK800`00DK9A/P03DK800`00DK9A/P05DK800`00DK9A/P04DK800`00DM9AdP05DM83000Nool0
013oo`03003ooooo02Koo`03003ooooo03[oo`H000>]g003002]g:gL00J]g003002]g:gL00@000:]
g003002]g:gL00N]g003002]g:gL00@000:]g003002]g:gL00J]g003002]g:gL00@000>]g003002]
g:gL00J]g003002]g:gL00@000>]g003002]g:gL00J]g003002]g:gL00@000>]g003002]g:gL00J]
g003002]g:gL00@000>]g003002]g:gL00J]g003002]g:gL00@000>]g003002]g:gL00J]g003002]
g:gL00@000>]g003002]g:gL00J]g003002]g:gL00@000:]g003002]g:gL00N]g003002]g:gL00@0
00:]g003002]g:gL00N]g004002UW0000008WG`01000WE/000001idk00@008bj000000R<^P03002<
VP0000EcM`03001cMg=g00AcM`03001cEg=G00=cE`03001cEg=G00=cE`8000EAT@03001ATE6A009A
T@03001ATE6A00=AT@03001ATE6A00=AT@03001ATE6A009AT@03001ATE6A00=AT@03001A/U6b00=A
/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA
/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00AA/P03001A/U6b00AA/P03001A/U6b00AA
/P03001AdU7B00EAdP8001ooo`004?oo00<00?ooool09Ooo00<00?ooool0?ooo1P001jgL00<00:gL
[M`01JgL0`002:gL00<00:gL[M`01JgL0`002:gL00<00:gL[M`01:gL10002:gL00<00:gL[M`01:gL
10002:gL00<00:gL[M`01:gL10002:gL00<00:gL[M`01:gL10001jgL00<00:gL[M`01JgL10001jgL
00<00:gL[M`01JgL10001jgL00<00:gL[M`01JgL0`002:gL00<00:gL[M`01JgL0`002:gL00<00:FL
YI`00ZFL0P0019el0P0019eK0P0019dk00<008bjS;X00Xbj00<008bjS;X01Xbj00<007=gLgL01G=g
00<007=gLgL017=g00<007=GLeL00g=G00<007=GLeL00P0000=A/P00DI40156A00<0056ADI400U6A
00<0056ADI400e6A00<0056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A00<0056bDK800e6b
00<0056bDK800e6b00<0056bDK800e6b00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b
00<0056bDK800e6b00<0056bDK801E6b00<0056bDK800e6b00<0056bDK80156b00<0056bDK801E6b
00<0057BDM800e7B00<00?ooool07ooo000@ool00`00ooooo`0Tool00`00ooooo`13ool50005[M`0
0`00[Mb]g005[M`00`00[Mb]g0020006[M`00`00[Mb]g005[M`00`00[Mb]g0020005[M`00`00[Mb]
g006[M`00`00[Mb]g0020005[M`00`00[Mb]g006[M`00`00[Mb]g0020005[M`00`00[Mb]g006[M`0
0`00[Mb]g0020005[M`00`00[Mb]g006[M`00`00[Mb]g0020005[M`00`00[Mb]g006[M`00`00[Mb]
g0020005[M`00`00[Mb]g006[M`00`00[Mb]g0020005[M`00`00[Mb]g005[M`00`00[Mb]g0020006
[M`00`00[Mb]g005[M`00`00[Mb]g0020006[M`00`00YIbUW004YI`200000iel002MF`07WE/20000
0idk002<^P05S;X20004S;X200000g>H001cM`05LgL00`00LgMcM`04LgL00`00LeMcE`03LeL00`00
LeL00004DK800`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI400`00
DI5AT@03DI400`00DI5AT@02DI400`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P04DK800`00
DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P04DK800`00
DK9A/P03DK800`00DK9A/P05DK800`00DK9A/P04DK800`00DM9AdP02DM800`00ooooo`0Pool000oo
o`03003ooooo02Goo`03003ooooo04Koo`@000:]g003002]g:gL00J]g003002]g:gL00:]g0<000:]
g003002]g:gL00J]g003002]g:gL00:]g0<000:]g003002]g:gL00J]g003002]g:gL00:]g0<000:]
g003002]g:gL00J]g003002]g:gL00:]g0<000:]g003002]g:gL00F]g003002]g:gL00>]g0<000:]
g003002]g:gL00F]g003002]g:gL00>]g08000:]g003002]g:gL00J]g003002]g:gL00>]g08000:]
g003002]g:gL00J]g003002]g:gL00>]g08000:]g003002]g:gL00J]g003002]g:gL00:]g0<000:]
g003002]g:gL00F]g003002]g:gL00>]g0<000:]g003002UW:FL00NUW003002MFieK00VMF`03002<
^Xbj00N<^P800003S;X007>H009cV003001cMg=g00EcM`03001cMg=g00AcM`03001cEg=G00=cE`03
001A/U6b00=A/P03001ATE6A009AT@03001ATE6A00=AT@03001ATE6A009AT@03001ATE6A00=AT@03
001ATE6A00=AT@03001ATE6A00=AT@03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00=A/P03
001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00AA/P03
001A/U6b00=A/P03001A/U6b00EA/P03001A/U6b00AA/P05001AdU7BDM80000Sool000ooo`03003o
oooo02Coo`03003ooooo04_oo`<000N]g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000N]
g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000N]g003002]
g:gL00F]g0<000R]g003002]g:gL00F]g0<000R]g003002]g:gL00F]g0<000N]g003002]g:gL00J]
g0<000N]g003002]g:gL00J]g0<000RUW004002MG0000008WE/01000U=/000002Hbj00<007>HLiP0
0g>H00<007=gLgL01G=g00<007=gLgL017=g00<007=GLeL00`001E6b00<0056ADI400U6A00<0056A
DI400e6A00<0056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400e6A00<0056b
DK800e6b00<0056bDK800e6b00<0056bDK800e6b00<0056bDK800e6b00<0056bDK80156b00<0056b
DK800e6b00<0056bDK80156b00<0056bDK80156b00<0056bDK80156b00<0056bDK80156b00<0056b
DK80156b00@0057BDM8002Coo`003ooo00<00?ooool08ooo00<00?ooool0Cooo10000jgL00<00:gL
[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL
00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000ZgL00<00:gL[M`01jgL00<00:gL
[M`010000ZgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`01000
0jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000ZgL00<0
0:gL[M`01jgL00<00:FLYI`00P001JFL00<009eLWE`00YeL0P001IeK00<009CKU=/00YCK00<008bj
S;X01Hbj00<007^h00001G>H00<007=gLgL017=g00<007=gLgL017=g00<007=G00000U6b00<0056b
DK800e6b00<0056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400U6A00<0056A
DI400e6A00<0056ADI400e6A00<0056bDK800e6b00<0056bDK800e6b00<0056bDK800e6b00<0056b
DK80156b00<0056bDK800e6b00<0056bDK80156b00<0056bDK800e6b00<0056bDK801E6b00<0056b
DK800e6b00<0056bDK80156b00<0056bDK801E6b0P009Ooo000?ool00`00ooooo`0Sool00`00oooo
o`1Cool40008[M`00`00[Mb]g004[M`40008[M`00`00[Mb]g004[M`40007[M`00`00[Mb]g005[M`4
0007[M`00`00[Mb]g005[M`30008[M`00`00[Mb]g005[M`30008[M`00`00[Mb]g004[M`40007[M`0
0`00[Mb]g005[M`40007[M`00`00[Mb]g005[M`40007[M`00`00[Mb]g005[M`30008[M`00`00YIbU
W003YI`20002YI`00`00WEbMG005WE`20002WE/00`00U=^Df`04U=/20004S;X01000NkQk^0001W>H
00<007=gLgL017=g00<007=gLgL017=g00<0056bDK800U6b00<0056bDK800U6b00<0056ADI400e6A
00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A
00<0056bDK800e6b00<0056bDK800e6b00<0056bDK800e6b00<0056bDK80156b00<0056bDK80156b
00<0056bDK800e6b00<0056bDK80156b00<0056bDK80156b00<0056bDK800e6b00<0056bDK801E6b
00<0056bDK80156b00<00?ooool09?oo000?ool00`00ooooo`0Rool00`00ooooo`1Gool50003[M`0
0`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00[Mb]g006[M`00`00[Mb]g0040002[M`00`00[Mb]
g007[M`00`00[Mb]g0040002[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00[Mb]g006[M`0
0`00[Mb]g0040003[M`00`00[Mb]g006[M`00`00[Mb]g0040002[M`00`00[Mb]g007[M`00`00[Mb]
g0040002[M`00`00[Mb]g007[M`00`00[Mb]g0040002[M`00`00[Mb]g006[M`00`00[Mb]g0040003
[M`00`00YIbUW006YI`30009WE`20009U=/200000hbj001k^003NkP00`00LiQcV003LiP00`00LgMc
M`05LgL01000LgMcMg=g0`00156b00<0056bDK800e6b00<0056ADI400U6A00<0056ADI400e6A00<0
056ADI400U6A00<0056ADI400e6A00<0056ADI400e6A00<0056ADI400U6A00<0056bDK800e6b00<0
056bDK800e6b00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b00<0056bDK800e6b00<0
056bDK80156b00<0056bDK80156b00<0056bDK800e6b00<0056bDK801E6b00<0056bDK800e6b00<0
0?ooool09Ooo000?ool00`00ooooo`0Rool00`00ooooo`1Kool50008[M`00`00[Mb]g004[M`40007
[M`00`00[Mb]g005[M`30008[M`00`00[Mb]g005[M`30008[M`00`00[Mb]g004[M`40007[M`00`00
[Mb]g005[M`40007[M`00`00[Mb]g005[M`30008[M`00`00[Mb]g005[M`30008[M`00`00[Mb]g005
[M`30007[M`00`00[Mb]g005[M`40008YI`00`00WEbMG0020006WE`200000iCK00000009U=/00`00
NkQk^004NkP00`00LiQcV003LiP00`00LgMcM`04LgL01000LgL000000U6b00<0056bDK800U6b00<0
056bDK800e6b00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A00<0
056ADI400e6A00<0056ADI400e6A00<0056bDK800e6b00<0056bDK800e6b00<0056bDK800e6b00<0
056bDK800e6b00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b00<0056bDK80156b00<0
056bDK80156b00<0056bDK80156b00@0056bDK9A/P8002Soo`003ooo00<00?ooool08Ooo00<00?oo
ool0Gooo10001JgL00<00:gL[M`01ZgL00<00:gL[M`00P001JgL00<00:gL[M`01JgL00<00:gL[M`0
0P001ZgL00<00:gL[M`01JgL00<00:gL[M`00P001JgL00<00:gL[M`01ZgL00<00:gL[M`00P001JgL
00<00:gL[M`01ZgL00<00:gL[M`00P001JgL00<00:gL[M`01JgL00<00:gL[M`00P001ZgL00<00:gL
[M`01JgL00<00:gL[M`00P001ZgL00<00:gL[M`01JgL00<00:gL[M`00P001JgL00<00:gL[M`01ZgL
00<00:fl[K`00P001JFL00<009eLWE`00ieL0`000YeL00<009CKU=/00iCK00<009CKU=/01ICK00<0
07_H00001W^h00<007>HLiP00g>H00<007=gLgL017=g00<0056bDK800e6b00D0056bDK9A/P0000EA
/P03001ATE6A009AT@03001ATE6A00=AT@03001ATE6A009AT@03001ATE6A00=AT@03001ATE6A00=A
T@03001ATE6A00=AT@03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00AA
/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00EA/P03001A/U6b00=A
/P03001A/U6b00AA/P03001A/U6b008002Woo`003_oo00<00?ooool08Ooo00<00?ooool0Hooo1000
0ZgL00<00:gL[M`01JgL00<00:gL[M`00jgL0P000ZgL00<00:gL[M`01ZgL00<00:gL[M`00ZgL0`00
0ZgL00<00:gL[M`01ZgL00<00:gL[M`00ZgL0`000ZgL00<00:gL[M`01JgL00<00:gL[M`00jgL0P00
0ZgL00<00:gL[M`01ZgL00<00:gL[M`00jgL0P000ZgL00<00:gL[M`01ZgL00<00:gL[M`00ZgL0`00
0ZgL00<00:gL[M`01JgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`01JgL00<00:gL[M`00jgL0P00
0ZgL00<00:gL[M`01ZgL00<00:fl[K`00jfl0P000ZFL00<009eLWE`01ieL0P001iCK00<009CKU=/0
0YCK0P000W_H00<007^hNkP017^h00<007>HLiP017>H00@007=gLgMcM`<000EA/P05001A/U6bDK80
0005DK800`00DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@02DI400`00DI5A
T@03DI400`00DI5AT@03DI400`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A
/P04DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P04DK800`00DK9A/P04DK800`00DK9A
/P03DK800`00DK9A/P05DK83000Zool000koo`03003ooooo027oo`03003ooooo06Ooo`<000N]g003
002]g:gL00F]g0<000N]g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<000N]g003002]g:gL
00F]g0<000R]g003002]g:gL00F]g0<000N]g003002]g:gL00J]g0<000N]g003002]g:gL00J]g0<0
00N]g003002]g:gL00F]g0<000R]g003002]_:fl00F]_0<000VMG004002Dn`000006U=/200000iCK
001kf004NmP00`00NkQk^004NkP00`00LiQcV003LiP01000LgL000000U6b00<0056bDK800e6b00<0
056bDK800U6b00<0056bDK800U6b00<0056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A00<0
056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A00<0056bDK800e6b00<0056bDK800e6b00<0
056bDK80156b00<0056bDK800e6b00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b00<0
056bDK80156b00<0056bDK800e6b00<0056bDK801E6b0P00:ooo000>ool00`00ooooo`0Pool00`00
ooooo`1[ool40002[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00[Mb]g006[M`00`00[Mb]
g0040003[M`00`00[Mb]g006[M`00`00[Mb]g0040002[M`00`00[Mb]g006[M`00`00[Mb]g0040003
[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00[Mb]g006[M`00`00[Mb]g0040002[M`00`00
[Mb]g007[M`00`00[Mb]g0040002[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00[Kb]_006
[K`00`00WGbMO0020005WE`20004U?/00`00U=^Df`05U=/00`00NmQkf005NmP00`00NkQk^004NkP0
0`00LiQcV003LiP00`00DK9A/P03DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A/P02DK80
0`00DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@02DI40
0`00DI5AT@03DI400`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P03DK80
0`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P04DK800`00DK9A/P04DK80
0`00DK9A/P03DK82000/ool000koo`03003ooooo01ooo`03003ooooo073oo`<000R]g003002]g:gL
00B]g0@000R]g003002]g:gL00B]g0@000N]g003002]g:gL00F]g0<000R]g003002]g:gL00B]g0@0
00N]g003002]g:gL00F]g0@000N]g003002]g:gL00F]g0<000R]g003002]g:gL00F]g0<000N]g003
002]g:gL00F]g0@000N]_003002MO9el00>MO08000:MG003002DniCk00FDn`03002DfiCK00:Df`80
0003NmP007_H00Ekf003001k^7^h00Ek^003001cV7>H00<000EA/P03001A/U6b009A/P03001A/U6b
009A/P03001A/U6b00=A/P03001ATE6A009AT@03001ATE6A00=AT@03001ATE6A009AT@03001ATE6A
00=AT@03001ATE6A00=AT@03001ATE6A009AT@03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b
00=A/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b
00EA/P03001A/U6b00=A/P03001A/U6b009A/P03003ooooo02coo`003_oo00<00?ooool07ooo00<0
0?ooool0Looo10000jgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL
[M`010000ZgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`01000
0ZgL00<00:gL[M`01jgL00<00:gL[M`010000ZgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<0
0:gL[M`01ZgL00<00:gL[M`010000ZgL00<00:gL[M`01jgL00<00:gL[M`010000Zfl00<009elWG`0
1Yel0P002ICk0P0000>Df`00NmP00g_H00<007_HNmP017_H00<007^hNkP017^h00<007>H00000U7B
00<0056bDK800e6b00<0056bDK800e6b00D0056bDK9A/P0000EA/P03001ATE6A009AT@03001ATE6A
00=AT@03001ATE6A009AT@03001ATE6A00=AT@03001ATE6A00=AT@03001ATE6A00=AT@03001A/U6b
00=A/P03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b
00AA/P03001A/U6b00AA/P03001A/U6b00AA/P03001A/U6b00=A/P05001A/U6bDK80000_ool000ko
o`03003ooooo01koo`03003ooooo07Ooo`D000R]g003002]g:gL00B]g0@000N]g003002]g:gL00F]
g0<000R]g003002]g:gL00B]g0@000N]g003002]g:gL00F]g0<000R]g003002]g:gL00F]g0<000N]
g003002]g:gL00F]g0@000N]g003002]g:gL00F]g0<000R]g003002]g:gL00F]g0<000RMO004002E
6`000009U?/00`00NmQkf004NmP00`00NmQkf004NmP00`00NkQk^004NkP00`00DM9AdP02DM800`00
DK9A/P02DK800`00DK9A/P03DK801@00DK9A/U6b00001E6b00<0056ADI400U6A00<0056ADI400e6A
00<0056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400e6A00<0056bDK800e6b
00<0056bDK800e6b00<0056bDK800e6b00<0056bDK80156b00<0056bDK80156b00<0056bDK800e6b
00<0056bDK80156b00<0056bDK80156b00<0056bDK800e6b00@0056bDK80033oo`003_oo00<00?oo
ool07_oo00<00?ooool0Nooo1@000jgL00<00:gL[M`01ZgL00<00:gL[M`010000ZgL00<00:gL[M`0
1ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000ZgL00<00:gL[M`01ZgL00<0
0:gL[M`010000jgL00<00:gL[M`01ZgL00<00:gL[M`010000ZgL00<00:gL[M`01jgL00<00:gL[M`0
10000ZgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<00:ElYG`00P001Iel
00<009DKUA/00YDK00<009CkU?/01ICk00<007_i00001W_H00<007_HNmP017_H00@007^hNkQk^0<0
00AAdP03001A/U6b009A/P03001A/U6b00=A/P05001A/U6bDK800005DK800`00DI5AT@03DI400`00
DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI400`00
DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P04DK800`00
DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P04DK800`00DK9A/P04DK82000aool000goo`03003o
oooo01koo`03003ooooo07ooo`H000N]g003002]g:gL00F]g0<000R]g003002]g:gL00B]g0@000N]
g003002]g:gL00F]g0<000R]g003002]g:gL00B]g0@000N]g003002]g:gL00F]g0<000R]g003002]
g:gL00F]g0<000N]g003002]g:gL00F]g0@000N]g003002UO:El00>UO08000:MO003002E6iDK00BE
6`8000BDn`05001knG_iNoT00005NmP00`00NmQkf004NmP01000NkP000000U7B00<0057BDM800U7B
00<0056bDK800e6b00<0056bDK800U6b00<0056bDK800U6b00<0056bDK800U6b00<0056ADI400e6A
00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A
00<0056bDK800e6b00<0056bDK800e6b00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b
00<0056bDK800e6b00<0056bDK80156b00<0056bDK801E6b00<0056bDK800e6b00<00?ooool0<?oo
000=ool00`00ooooo`0Mool00`00ooooo`24ool60002[M`00`00[Mb]g006[M`00`00[Mb]g0040003
[M`00`00[Mb]g006[M`00`00[Mb]g0040002[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00
[Mb]g006[M`00`00[Mb]g0040002[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00[Mb]g006
[M`00`00[Mb]g0040002[M`00`00[Mb]g007[M`00`00[Mb]g0040002[M`00`00YGbUO006YG`20009
UA/200000iCk001kn@04NoT00`00NmQkf003NmP00`00NmQkf004NmP00`00DM9AdP03DM801@00DM9A
dU7B00001E6b00<0056bDK800U6b00<0056bDK800U6b00<0056bDK800e6b00<0056ADI400U6A00<0
056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400e6A00<0056ADI400U6A00<0
056bDK80156b00<0056bDK800e6b00<0056bDK800e6b00<0056bDK80156b00<0056bDK800e6b00<0
056bDK80156b00<0056bDK80156b00<0056bDK80156b00<0056bDK800U6b00<00?ooool0<Ooo000=
ool00`00ooooo`0Mool00`00ooooo`27ool60008[M`00`00[Mb]g004[M`40007[M`00`00[Mb]g005
[M`30008[M`00`00[Mb]g004[M`40007[M`00`00[Mb]g005[M`30008[M`00`00[Mb]g004[M`40007
[M`00`00[Mb]g005[M`30008[M`00`00[Mb]g005[M`30008YG`01000UA/000002IDK00<007_iNoT0
1G_i00<007_HNmP00g_H00@007_HNmQkf0<000EAdP05001AdU7BDM800005DK800`00DK9A/P02DK80
0`00DK9A/P02DK800`00DK9A/P03DK800`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@02DI40
0`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DK9A/P03DK800`00DK9A/P03DK80
0`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P04DK80
0`00DK9A/P04DK801@00DK9A/U6b0000=?oo000=ool00`00ooooo`0Lool00`00ooooo`2<ool40005
[M`00`00[Mb]g006[M`00`00[Mb]g0020005[M`00`00[Mb]g005[M`00`00[Mb]g0020005[M`00`00
[Mb]g006[M`00`00[Mb]g0020005[M`00`00[Mb]g005[M`00`00[Mb]g0020005[M`00`00[Mb]g006
[M`00`00[Mb]g0020005[M`00`00[Mb]g005[M`00`00[Mb]g0020006[M`00`00[Mb]g005[M`00`00
[Kb]_0020005YG`00`00UA^E6`02UA/00`00UA^E6`05UA/00`00Q1T00006NoT00`00NmQkf004NmP0
0`00NmP00002DM800`00DM9AdP03DM800`00DM9AdP02DM800`00DK9A/P02DK800`00DK9A/P03DK80
1@00DK9A/U6b00001E6b00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400e6A00<0056ADI40
0U6A00<0056ADI400e6A00<0056ADI400e6A00<0056bDK800e6b00<0056bDK800e6b00<0056bDK80
156b00<0056bDK800e6b00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b00<0056bDK80
156b00@0056bDK8003Goo`003Ooo00<00?ooool06ooo00<00?ooool0T?oo10000ZgL00<00:gL[M`0
1JgL00<00:gL[M`00jgL0P000ZgL00<00:gL[M`01ZgL00<00:gL[M`00ZgL0`000ZgL00<00:gL[M`0
1JgL00<00:gL[M`00jgL0P000ZgL00<00:gL[M`01ZgL00<00:gL[M`00ZgL0`000ZgL00<00:gL[M`0
1JgL00<00:gL[M`00jgL0P000ZgL00<00:gL[M`01JgL00<00:gL[M`00jgL0`000ZgL00<00:gL[M`0
1JgL00<00:fl[K`00jfl0P000ZEl00<009DKUA/019DK0P0019DK00D008@IQ1V46@0000Ikn@03001k
f7_H00Akf003001AdU7B009AdP03001AdU7B009AdP03001AdU7B009AdP03001A/U6b009A/P03001A
/U6b00=A/P05001A/U6bDK800005DK800`00DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI40
0`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DK9A/P03DK800`00DK9A/P03DK80
0`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P04DK80
0`00DK9A/P05DK82000fool000goo`03003ooooo01_oo`03003ooooo09?oo`@000N]g003002]g:gL
00F]g0<000N]g003002]g:gL00J]g0<000N]g003002]g:gL00F]g0<000N]g003002]g:gL00J]g0<0
00N]g003002]g:gL00F]g0<000N]g003002]g:gL00J]g0<000N]g003002]_:fl00F]_08000VE6`80
0003UA/008@I00B46@03001knG_i00Akn@04001kf7_HNmP30004DM800`00DM9AdP02DM800`00DM9A
dP02DM800`00DK9A/P03DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DI5A
T@03DI400`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@02DI400`00DI5A
T@03DI400`00DK9A/P04DK800`00DK9A/P02DK800`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A
/P04DK800`00DK9A/P04DK800`00DK9A/P04DK800`00DK9A/P04DK800`00ooooo`0eool000goo`03
003ooooo01[oo`03003ooooo09Soo`@000:]g003002]g:gL00J]g003002]g:gL00@000>]g003002]
g:gL00J]g003002]g:gL00@000:]g003002]g:gL00J]g003002]g:gL00@000>]g003002]g:gL00J]
g003002]g:gL00@000:]g003002]g:gL00J]g003002]g:gL00@000:]g003002]g:gL00N]g003002]
g:gL00@000:]g003002]_:fl00J]_004002M>`000009UA/00`00Q1V46@04Q1T00`00NoUkn@05NoT0
0`00NmP00002DO800`00DM9AdP02DM800`00DM9AdP03DM801@00DM9AdU7B00001E6b00<0056bDK80
0U6b00<0056bDK800U6b00<0056bDK800e6b00<0056ADI400U6A00<0056ADI400U6A00<0056ADI40
0e6A00<0056ADI400e6A00<0056ADI400e6A00<0056ADI400U6A00<0056bDK80156b00<0056bDK80
0e6b00<0056bDK800e6b00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b00<0056bDK80
156b00<0056bDK800e6b00<00?ooool0=_oo000<ool00`00ooooo`0Kool00`00ooooo`2Kool40008
[M`00`00[Mb]g004[M`40007[M`00`00[Mb]g005[M`30007[M`00`00[Mb]g005[M`40007[M`00`00
[Mb]g005[M`30007[M`00`00[Mb]g005[M`30008[M`00`00[Mb]g005[M`30007[K`00`00WC^M>`02
WC/20005UA/200000hAI00246@05Q1T00`00NoUkn@05NoT00`00DO9AlP02DO801@00DM9AdU7B0000
1E7B00D0057BDM9AdP0000EA/P03001A/U6b009A/P03001A/U6b009A/P03001A/U6b00=A/P03001A
TE6A009AT@03001ATE6A00=AT@03001ATE6A009AT@03001ATE6A00=AT@03001ATE6A00=AT@03001A
TE6A00=AT@03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A
/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b009A/P03003ooooo03Ooo`003?oo
00<00?ooool06_oo00<00?ooool0X?oo10000jgL00<00:gL[M`01ZgL00<00:gL[M`010000ZgL00<0
0:gL[M`01ZgL00<00:gL[M`010000ZgL00<00:gL[M`01jgL00<00:gL[M`010000ZgL00<00:gL[M`0
1ZgL00<00:gL[M`010000ZgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL00<0
0:gL[M`010000Zfl00<009dkWC/01Idk0P0000>E6`00000018AI00<008@IQ1T018@I00<007_iNoT0
0W_i0`00157b00D0057BDM9AdP0000EAdP03001AdU7B009AdP03001A/U6b009A/P03001A/U6b00=A
/P05001A/U6bDK800005DK800`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@02DI400`00DI5A
T@03DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A
/P04DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P04DK801@00DK9A
/U6b0000>_oo000<ool00`00ooooo`0Iool00`00ooooo`2Tool50007[M`00`00[Mb]g005[M`30007
[M`00`00[Mb]g005[M`30008[M`00`00[Mb]g005[M`30007[M`00`00[Mb]g005[M`30008[M`00`00
[Mb]g004[M`40007[M`00`00[Mb]g005[M`2000:WC/00`00Q5V4F@05Q5T00`00Q1V46@04Q1T01000
NoT000000U7c00<0057bDO800U7b00<0057BDM800U7B00<0057BDM800U7B00<0057BDM800U7B00<0
056bDK800U6b00<0056bDK800e6b00D0056bDK9A/P0000EA/P03001ATE6A009AT@03001ATE6A00=A
T@03001ATE6A00=AT@03001ATE6A009AT@03001ATE6A00=AT@03001ATE6A00=AT@03001A/U6b00=A
/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A
/P03001A/U6b00EA/P03001A/P0003_oo`003?oo00<00?ooool06Ooo00<00?ooool0Z?oo1@000ZgL
00<00:gL[M`01ZgL00<00:gL[M`010000ZgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL
[M`01ZgL00<00:gL[M`010000ZgL00<00:gL[M`01ZgL00<00:gL[M`010000jgL00<00:gL[M`01ZgL
00<00:gL[M`010000ZgL00<00:gL[M`01ZgL00@00:EK000000NM>`030024NP0000N4F@0300246H@I
00B46@03001Ale7c00=Al`05001AlU7bDO800004DM800`00DM9AdP02DM800`00DM9AdP02DM800`00
DK9A/P03DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DI5AT@03DI400`00
DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI400`00
DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P03DK800`00
DK9A/P04DK800`00DK9A/P04DK82000lool000coo`03003ooooo01Soo`03003ooooo0:coo`D000N]
g003002]g:gL00F]g0<000R]g003002]g:gL00B]g0@000N]g003002]g:gL00F]g0<000N]g003002]
g:gL00F]g0@000N]g003002]g:gL00F]g0<000N]g003002UFjEK00:UF`8000BM>`050024NXAjQ7X0
0007Q5T01000Q1V46H@I0`001E7c00<0057bDO800U7b00D0057BDM9AdP0000EAdP05001AdU7BDM80
0005DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A/P03DK800`00DI5AT@02DI400`00DI5A
T@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI400`00DK9A
/P04DK800`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P04DK800`00DK9A
/P03DK800`00DK9A/P04DK800`00ooooo`0kool000coo`03003ooooo01Ooo`03003ooooo0;3oo`H0
00:]g003002]g:gL00J]g003002]g:gL00@000>]g003002]g:gL00J]g003002]g:gL00@000:]g003
002]g:gL00J]g003002]g:gL00@000:]g003002]g:gL00N]g003002]g:gL00@000:]g003002]g:gL
00J]g003002]g:gL00@000:]g003002UFjEK00FUF`800003WC/008Aj00B4NP030024FHAI00F4F@03
00246@0000=J4`03001Ale7c009Al`03001AlU7b009AlP05001AdU7BDM800005DM801@00DM9AdU7B
00001E6b00<0056bDK800U6b00<0056bDK800U6b00<0056bDK800e6b00<0056ADI400U6A00<0056A
DI400e6A00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400e6A00<0056ADI400e6A00<0056b
DK800e6b00<0056bDK800e6b00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b00<0056b
DK800e6b00<0056bDK800e6b00<00?ooool0??oo000<ool00`00ooooo`0Gool00`00ooooo`2dool5
0008[M`00`00[Mb]g004[M`40007[M`00`00[Mb]g005[M`30007[M`00`00[Mb]g005[M`30008[M`0
0`00[Mb]g005[M`30007[M`00`00[Mb]g005[M`30009YE/00`00Q7Z4NP05Q7X20006Q5T00`00FQ=J
4`02FQ<00`00DO=Al`02DO<00`00DO9AlP02DO800`00DM9AdP02DM800`00DM9AdP02DM800`00DM9A
dP02DM800`00DK9A/P02DK800`00DK9A/P03DK801@00DK9A/U6b00001E6b00<0056ADI400U6A00<0
056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400e6A00<0056ADI400e6A00<0
056bDK800e6b00<0056bDK800e6b00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b00<0
056bDK800e6b00@0056bDK9A/P8003ooo`003?oo00<00?ooool05_oo00<00?ooool0^?oo10001JgL
00<00:gL[M`01ZgL00<00:gL[M`00P001JgL00<00:gL[M`01JgL00<00:gL[M`00P001JgL00<00:gL
[M`01JgL00<00:gL[M`00P001ZgL00<00:gL[M`01JgL00<00:gL[M`00P001JgL00<00:gL[M`01JgL
00<00:FlYK`00P001JEK0P0000><VP00Q7X01hAj00@008AIQ5V4F@<000AJ4`03001Ale7c00=Al`05
001AlU7bDO800004DM800`00DM9AdP02DM800`00DM9AdP02DM800`00DK9A/P02DK800`00DK9A/P03
DK801@00DK9A/U6b00001E6b00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400e6A00<0056A
DI400U6A00<0056ADI400e6A00<0056ADI400e6A00<0056bDK800e6b00<0056bDK800e6b00<0056b
DK80156b00<0056bDK800e6b00<0056bDK80156b00<0056bDK80156b00<0056b0000@Ooo000;ool0
0`00ooooo`0Gool00`00ooooo`2lool30002[M`00`00[Mb]g005[M`00`00[Mb]g003[M`20002[M`0
0`00[Mb]g005[M`00`00[Mb]g003[M`20002[M`00`00[Mb]g006[M`00`00[Mb]g002[M`30002[M`0
0`00[Mb]g005[M`00`00[Mb]g003[M`20002[M`00`00[Mb]g005[M`00`00YKbU_003YK`20002YE/0
0`00S9Z<VP02S9X20007Q7X00`00Q5T00003FQ<01@00FQ=J4eXC00001E7c00<0057bDO800U7b00D0
057BDM9AdP0000AAdP03001AdU7B009AdP03001A/U6b00=A/P03001A/U6b009A/P03001A/U6b009A
/P03001A/U6b009A/P03001ATE6A00=AT@03001ATE6A009AT@03001ATE6A00=AT@03001ATE6A009A
T@03001ATE6A00=AT@03001ATE6A00=AT@03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00=A
/P03001A/U6b00AA/P03001A/U6b00AA/P03001A/U6b00=A/P8004;oo`002ooo00<00?ooool05_oo
00<00?ooool0`?oo0`001jgL00<00:gL[M`01JgL0`001jgL00<00:gL[M`01JgL0`001jgL00<00:gL
[M`01ZgL0`001jgL00<00:gL[M`01JgL0`001jgL00<00:FlYK`01JFl0P001hbJ00<008AjQ7X01HAj
00<005XCFQ<00UXC00<005XCFQ<00UXC00<0057cDO<00U7c00<0057bDO800U7b00D0057BDM9AdP00
00EAdP05001AdU7BDM800005DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A/P02DK800`00
DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@02DI400`00
DI5AT@03DI400`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P03DK800`00
DK9A/P04DK800`00DK9A/P03DK800`00ooooo`11ool000_oo`03003ooooo01Goo`03003ooooo0<Co
o`@000:]g003002]g:gL00J]g003002]g:gL00@000:]g003002]g:gL00J]g003002]g:gL00@000>]
g003002]g:gL00J]g003002]g:gL00@000:]g003002]g:gL00J]g003002]g:gL00@000:]g003002U
_:Fl00JU_003002D^P0000N<VP030024NXAj00:4NP<000AJ4`03001J4eXC009J4`03001Ale7c009A
l`03001AlU7b009AlP05001AdU7BDM800005DM801@00DM9AdU7B00001E6b00<0056bDK800U6b00<0
056bDK800U6b00<0056bDK800e6b00<0056ADI400U6A00<0056ADI400U6A00<0056ADI400e6A00<0
056ADI400e6A00<0056ADI400e6A00<0056ADI400U6A00<0056bDK80156b00<0056bDK800e6b00<0
056bDK80156b00<0056bDK800e6b00<0056bDK80156b00<0056bDK800U6b00<00?ooool0@_oo000;
ool00`00ooooo`0Eool00`00ooooo`38ool30007[M`00`00[Mb]g005[M`30008[M`00`00[Mb]g004
[M`40007[M`00`00[Mb]g005[M`30007[M`00`00[Mb]g005[M`30007YK`01000U;ZD^YBj0P001XbJ
0P0000>4NP00FS@00UXd00D005XCFQ=J4`0000AJ4`03001Ale7c00=Al`05001AlU7bDO800004DM80
0`00DM9AdP02DM800`00DM9AdP02DM800`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A/P02DK80
0`00DK9A/P03DK800`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI40
0`00DI5AT@03DI400`00DI5AT@03DI400`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P04DK80
0`00DK9A/P03DK800`00DK9A/P04DK801@00DK9A/U6b0000AOoo000;ool00`00ooooo`0Dool00`00
ooooo`3<ool40002[M`00`00[Mb]g006[M`00`00[Mb]g0040003[M`00`00[Mb]g006[M`00`00[Mb]
g0040002[M`00`00[Mb]g006[M`00`00[Mb]g0040002[M`00`00[Mb]g006[M`00`00[Mb]g0040002
YK`00`00U;ZD^P04U;X00`00S9Z<VP05S9X00`00FSAJ=002FS@00`00FQ=J4`02FQ<01@00FQ=J4eXC
00001E7c00<0057bDO800U7b00D0057BDM9AdP0000AAdP03001AdU7B009AdP03001A/U6b009A/P03
001A/U6b00=A/P05001A/U6bDK800005DK800`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@02
DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DK9A/P03DK800`00DK9A/P03
DK800`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P05DK800`00DK800016ool000_oo`03003o
oooo01?oo`03003ooooo0=7oo`<000R]g003002]g:gL00B]g0@000N]g003002]g:gL00F]g0<000N]
g003002]g:gL00F]g0<000N]g003002]g:gL00F]g08000RD^P03002<VXbJ00:<VP<000AJ=003001J
4eXC009J4`03001J4eXC009J4`03001Ale7c009Al`03001AlU7b009AlP05001AdU7BDM800004DM80
0`00DM9AdP02DM800`00DK9A/P03DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A/P02DK80
0`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI40
0`00DI5AT@03DI400`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P04DK80
0`00DK9A/P04DK820017ool000_oo`03003ooooo01?oo`03003ooooo0=Coo`@000>]g003002]g:gL
00J]g003002]g:gL00@000:]g003002]g:gL00J]g003002]g:gL00@000:]g003002]g:gL00J]g003
002]g:gL00@000:]g003002]g:gL00J]g004002M6`000007U;X200000hbJ001JE002FU@01@00FSAJ
=5Xd000015XC00<005XCFQ<00UXC00<0057cDO<00U7c00<0057bDO800U7b00D0057BDM9AdP0000EA
dP05001AdU7BDM800005DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DI5A
T@03DI400`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@02DI400`00DI5A
T@03DI400`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A
/P04DK800`00ooooo`16ool000[oo`03003ooooo01?oo`03003ooooo0=Woo`@000N]g003002]g:gL
00F]g0<000N]g003002]g:gL00F]g0<000N]g003002]g:gL00F]g0<000N]g003002M6idK00:M6`80
00JD^P8000AJE003001J=5Xd009J=005001J4eXCFQ<00004FQ<00`00DO=Al`02DO<00`00DO9AlP02
DO801@00DM9AdU7B00001E7B00D0057BDM9AdP0000EA/P03001A/U6b009A/P03001A/U6b009A/P03
001A/U6b00=A/P03001ATE6A009AT@03001ATE6A009AT@03001ATE6A00=AT@03001ATE6A00=AT@03
001ATE6A00=AT@03001ATE6A009AT@03001A/U6b00AA/P03001A/U6b00=A/P03001A/U6b00AA/P03
001A/U6b00=A/P03001A/U6b00=A/P03003ooooo04Ooo`002_oo00<00?ooool04ooo00<00?ooool0
g?oo1@000ZgL00<00:gL[M`01ZgL00<00:gL[M`010000ZgL00<00:gL[M`01ZgL00<00:gL[M`01000
0ZgL00<00:gL[M`01ZgL00<00:gL[M`010000ZgL00<009dKWA/01IdK0P000YBj0P0000=RU@00FU@0
0eYD00<005XdFS@00UXd00<005XCFQ<00UXC00D005XCFQ=J4`0000EAl`05001AlU7bDO800004DM80
0`00DM9AdP02DM800`00DM9AdP02DM800`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A/P02DK80
0`00DK9A/P03DK800`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI40
0`00DI5AT@03DI400`00DI5AT@03DI400`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P04DK80
0`00DK9A/P03DK801000DK9A/U6b0P00B_oo000:ool00`00ooooo`0Bool00`00ooooo`3Qool40007
[M`00`00[Mb]g005[M`30007[M`00`00[Mb]g005[M`30007[M`00`00[Mb]g005[M`30009WA/20004
HYD00`00FUAJE002FU@01@00FSAJ=5Xd000015XC00<005XCFQ<00UXC00<0057cDO<00U7c00<0057b
DO800U7b00D0057BDM9AdP0000AAdP03001AdU7B009AdP03001A/U6b009A/P03001A/U6b00=A/P05
001A/U6bDK800005DK800`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03
DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DK9A/P03DK800`00DK9A/P03DK800`00DK9A/P04
DK800`00DK9A/P04DK800`00DK80001<ool000[oo`03003ooooo017oo`03003ooooo0>Goo`D000:]
g003002]g:gL00J]g003002]g:gL00@000:]g003002]g:gL00J]g003002]g:gL00@000:]g003002]
g:gL00J]g003002UW:FL008000FM6`<000ERU@03001JE5YD009JE003001J=5Xd009J=005001J4eXC
FQ<00004FQ<00`00DO=Al`02DO<00`00DO9AlP02DO801@00DM9AdU7B0000157B00<0057BDM800U7B
00<0056bDK800e6b00<0056bDK800U6b00D0056bDK9A/P0000EA/P03001ATE6A009AT@03001ATE6A
00=AT@03001ATE6A00=AT@03001ATE6A009AT@03001ATE6A00=AT@03001ATE6A00=AT@03001A/U6b
00AA/P03001A/U6b00=A/P03001A/U6b00AA/P03001A/U6b00=A/P8004goo`002_oo00<00?ooool0
4Ooo00<00?ooool0j?oo1@001jgL00<00:gL[M`01JgL0`001jgL00<00:gL[M`01JgL0`001jgL00<0
0:FLYI`00jFL0P000YdK00D006:eH[ER]@0000ARU@03001JE5YD009JE003001J=5Xd009J=005001J
4eXCFQ<00004FQ<00`00DO=Al`02DO<00`00DO9AlP02DO801@00DM9AdU7B0000157B00<0057BDM80
0U7B00<0056bDK800e6b00<0056bDK800U6b00<0056bDK800U6b00<0056bDK800U6b00<0056ADI40
0U6A00<0056ADI400e6A00<0056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A00<0056ADI40
0e6A00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b00<0056bDK800e6b00<00?ooool0
C?oo000:ool00`00ooooo`0@ool00`00ooooo`3]ool50002[M`00`00[Mb]g006[M`00`00[Mb]g004
0002[M`00`00[Mb]g006[M`00`00[Mb]g0040002[M`00`00YIbUW006YI`20004H[D00`00HYERU@03
HYD01@00FUAJE5YD000015Xd00<005XCFQ<00UXC00D005XCFQ=J4`0000EAl`05001AlU7bDO800003
DM800`00DM9AdP03DM801@00DM9AdU7B00001E6b00<0056bDK800U6b00<0056bDK800U6b00<0056b
DK800e6b00<0056ADI400U6A00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400e6A00<0056A
DI400U6A00<0056ADI400e6A00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b00<0056b
DK800U6b00<00?ooool0COoo000:ool00`00ooooo`0?ool00`00ooooo`3aool50007[M`00`00[Mb]
g005[M`30007[M`00`00[Mb]g005[M`30007YI`200000f/F001R]@03H[D00`00HYERU@02HYD00`00
FUAJE002FU@01@00FSAJ=5Xd000015XC00<005XCFQ<00UXC00<0057cDO<00U7c00<0057bDO800U7b
00D0057BDM9AdP0000AAdP03001AdU7B009AdP03001A/U6b009A/P03001A/U6b009A/P03001A/U6b
009A/P03001A/U6b00=A/P03001ATE6A009AT@03001ATE6A009AT@03001ATE6A00=AT@03001ATE6A
00=AT@03001ATE6A00=AT@03001ATE6A00=AT@03001A/U6b00=A/P03001A/U6b00=A/P03001A/U6b
00AA/P05001A/U6bDK80001@ool000Woo`03003ooooo013oo`03003ooooo0?Goo`D000:]g003002]
g:gL00J]g003002]g:gL00@000:]g003002]g:gL00J]g003002]g:gL00@000:UW005001[5V/FJaH0
0004H[D00`00HYERU@03HYD01@00FUAJE5YD000015Xd00D005XCFQ=J4`0000AJ4`03001Ale7c009A
l`03001AlU7b009AlP05001AdU7BDM800004DM800`00DM9AdP02DM800`00DK9A/P02DK800`00DK9A
/P03DK801@00DK9A/U6b00001E6b00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400U6A00<0
056ADI400e6A00<0056ADI400e6A00<0056ADI400e6A00<0056bDK80156b00<0056bDK800e6b00<0
056bDK80156b00<0056b0000DOoo0009ool00`00ooooo`0?ool00`00ooooo`3iool50008[M`00`00
[Mb]g004[M`30008[M`00`00[Mb]g004[M`20005JaH00`00H[ER]@02H[D00`00HYERU@02HYD01@00
FUAJE5YD000015Xd00D005XCFQ=J4`0000AJ4`03001Ale7c009Al`03001AlU7b009AlP05001AdU7B
DM800004DM800`00DM9AdP02DM800`00DK9A/P03DK800`00DK9A/P02DK801@00DK9A/U6b00001E6b
00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400e6A
00<0056ADI400e6A00<0056bDK80156b00<0056bDK800e6b00<0056bDK80156b0P00D_oo0009ool0
0`00ooooo`0?ool00`00ooooo`3mool50003[M`00`00[Mb]g005[M`00`00[Mb]g0040003[M`00`00
[Mb]g005[M`00`00PkL00004JaH00`00H[ER]@02H[D00`00HYERU@02HYD00`00FUAJE002FU@01@00
FSAJ=5Xd000015XC00D005XCFQ=J4`0000EAl`05001AlU7bDO800003DM800`00DM9AdP02DM800`00
DM9AdP02DM800`00DK9A/P03DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A/P02DK800`00
DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI400`00
DI5AT@03DI400`00DK9A/P04DK800`00DK9A/P03DK800`00DK9A/P04DK800`00ooooo`1Aool000Wo
o`03003ooooo00koo`03003ooooo0?ooo`;oo`H000N]g003002]g:gL00B]g0@000N]g0030023]`00
00E[5P05001R]F:eH[D00005HYD01@00FUAJE5YD000015Xd00D005XCFQ=J4`0000AJ4`03001Ale7c
009Al`03001AlU7b009AlP05001AdU7BDM800004DM801@00DM9AdU7B00001E6b00<0056bDK800U6b
00<0056bDK800U6b00<0056bDK800U6b00<0056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A
00<0056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A00<0056bDK80156b00<0056bDK800e6b
00<0056bDK800e6b00<00?ooool0D_oo0009ool00`00ooooo`0=ool00`00ooooo`3oool6ool70002
[M`00`00[Mb]g006[M`00`00[Mb]g0040002[M`01@00PkN3]h>g000016/F00<006:eH[D00V:e00<0
06:EHYD00V:E00D005YDFUAJE00000AJ=005001J4eXCFQ<00004FQ<00`00DO=Al`02DO<00`00DO9A
lP02DO801@00DM9AdU7B0000157B00<0057BDM800U7B00<0056bDK800U6b00<0056bDK800U6b00<0
056bDK800U6b00<0056bDK800e6b00<0056ADI400U6A00<0056ADI400U6A00<0056ADI400e6A00<0
056ADI400e6A00<0056ADI400e6A00<0056ADI400e6A00<0056bDK800e6b00<0056bDK800e6b00@0
056bDK9A/P8005Goo`002Ooo00<00?ooool03Ooo00<00?ooool0oooo2_oo1P001jgL00<00:gL[M`0
1JgL0P001H>g00<006/FJaH00V/F00D006:eH[ER]@0000ARU@03001JE5YD009JE005001J=5XdFS@0
0003FQ<00`00FQ=J4`02FQ<00`00DO=Al`02DO<00`00DO9AlP02DO801@00DM9AdU7B0000157B00<0
057BDM800U7B00<0056bDK800U6b00<0056bDK800U6b00<0056bDK800U6b00<0056bDK800e6b00<0
056ADI400U6A00<0056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400e6A00<0
056ADI400e6A00<0056bDK80156b00<0056bDK800e6b00<0056b0000Eooo0009ool00`00ooooo`0<
ool00`00ooooo`3oool>ool50005[M`00`00[Mb]g005[M`00`00U=X00005PkL01@00JaI[5V/F0000
16:e00<006:EHYD00V:E00D005YDFUAJE00000AJ=005001J4eXCFQ<00003FQ<00`00DO=Al`03DO<0
1@00DO9AlU7b00000e7B00<0057BDM800U7B00<0057BDM800U7B00<0056bDK800e6b00<0056bDK80
0U6b00D0056bDK9A/P0000EA/P03001ATE6A009AT@03001ATE6A00=AT@03001ATE6A009AT@03001A
TE6A00=AT@03001ATE6A00=AT@03001ATE6A00=AT@03001A/U6b00AA/P03001A/U6b00=A/P8005So
o`002?oo00<00?ooool03?oo00<00?ooool0oooo4ooo0`000ZgL00<00:gL[M`01JgL00D009CJU=ZD
fP0000B3]`03001[5V/F009[5P05001R]F:eH[D00004HYD01@00FUAJE5YD000015Xd00D005XCFQ=J
4`0000AJ4`03001Ale7c009Al`05001AlU7bDO800003DM800`00DM9AdP02DM800`00DM9AdP02DM80
0`00DK9A/P03DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DI5AT@02DI40
0`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@03DI40
0`00DK9A/P04DK800`00DK9A/P03DK800`00ooooo`1Gool000Soo`03003ooooo00coo`03003ooooo
0?oooaKoo`<000N]g003002DfYCJ00:DfP8000>3]`05001[5V/FJaH00003H[D00`00HYERU@02HYD0
0`00FUAJE002FU@01@00FSAJ=5Xd00000eXC00<005XCFQ<00UXC00<0057cDO<00U7c00<0057bDO80
0U7b00D0057BDM9AdP0000AAdP05001AdU7BDM800005DK800`00DK9A/P02DK800`00DK9A/P02DK80
0`00DK9A/P02DK800`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@03DI40
0`00DI5AT@02DI400`00DI5AT@03DI400`00DK9A/P04DK800`00DK9A/P02DK800`00ooooo`1Hool0
00Soo`03003ooooo00_oo`03003ooooo0?oooa[oo`@000:]g003002DfYCJ00FDfP050023]h>gPkL0
0003JaH01@00H[ER]F:e000016:E00D005YDFUAJE00000=J=005001J4eXCFQ<00004FQ<00`00DO=A
l`02DO<00`00DO9AlP02DO801@00DM9AdU7B0000157B00<0057BDM800U7B00<0056bDK800U6b00<0
056bDK800U6b00<0056bDK800U6b00<0056bDK800e6b00<0056ADI400U6A00<0056ADI400U6A00<0
056ADI400e6A00<0056ADI400e6A00<0056ADI400e6A00<0056ADI400U6A00<0056bDK80156b00D0
056bDK9A/P0005_oo`002?oo00<00?ooool02ooo00<00?ooool0oooo7_oo0`0029CJ00D008>gPkN3
]`00009[5P05001R]F:eH[D00004HYD01@00FUAJE5YD000015Xd00D005XCFQ=J4`0000=J4`03001A
le7c009Al`03001AlU7b009AlP05001AdU7BDM800004DM800`00DM9AdP02DM800`00DK9A/P02DK80
0`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A/P03DK800`00DI5AT@02DI400`00DI5AT@02DI40
0`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DK9A/P04DK80
0`00DK80001Lool000Soo`03003ooooo00[oo`03003ooooo0?ooob;oo`@000>DfP@00003PkL006/F
009[5P05001R]F:eH[D00004HYD01000FUAJE00015Xd00D005XCFQ=J4`0000AJ4`03001Ale7c009A
l`05001AlU7bDO800003DM800`00DM9AdP02DM800`00DM9AdP02DM800`00DK9A/P03DK800`00DK9A
/P02DK801@00DK9A/U6b00001E6b00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400U6A00<0
056ADI400e6A00<0056ADI400e6A00<0056ADI400e6A00<0056bDK80156b0P00GOoo0008ool00`00
ooooo`09ool00`00ooooo`3ooolWool30004ool400000f/F001R]@02H[D00`00HYERU@02HYD01@00
FUAJE5YD00000eXd00D005XCFQ=J4`0000AJ4`03001Ale7c009Al`03001AlU7b009AlP04001AdU7B
0004DM800`00DM9AdP02DM800`00DK9A/P03DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A
/P02DK800`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@02DI400`00DI5A
T@03DI400`00DI5AT@03DI400`00DK9A/P04DK800`00ooooo`1Lool000Soo`03003ooooo00Woo`03
003ooooo0?ooobSoo`03003ooooo00Ooo`@0009R]@05001RUF:EHYD00003FU@00`00FSAJ=002FS@0
1000FQ=J4`0015XC00<0057cDO<00U7c00<0057bDO800U7b00D0057BDM9AdP0000AAdP05001AdU7B
DM800005DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DI5AT@02DI400`00
DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00
DK9A/P03DK800`00ooooo`1Mool000Ooo`03003ooooo00Woo`03003ooooo0?ooobWoo`03003ooooo
00_oo`D0009RU@04001JE5YD0004FS@01@00FQ=J4eXC00000eXC00<0057cDO<00U7c00<0057bDO80
0U7b00D0057BDM9AdP0000AAdP03001AdU7B009AdP03001A/U6b009A/P03001A/U6b009A/P03001A
/U6b009A/P03001A/U6b00=A/P03001ATE6A009AT@03001ATE6A009AT@03001ATE6A00=AT@03001A
TE6A00=AT@03001ATE6A009AT@03001ATE6A00=AT@04001A/U6bDK82001Pool000Ooo`03003ooooo
00Soo`03003ooooo0?ooob[oo`03003ooooo013oo`@0009JE005001J=5XdFS@00003FQ<00`00FQ=J
4`02FQ<00`00DO=Al`02DO<01@00DO9AlU7b00000e7B00<0057BDM800U7B00<0057BDM800U7B00<0
056bDK800U6b00<0056bDK800U6b00<0056bDK800U6b00<0056bDK800e6b00<0056ADI400U6A00<0
056ADI400U6A00<0056ADI400e6A00<0056ADI400e6A00<0056ADI400e6A00<0056ADI400e6A00<0
056b0000H_oo0007ool00`00ooooo`08ool00`00ooooo`3ooolZool00`00ooooo`0Dool40002FS@0
1@00FQ=J4eXC000015XC00<0057cDO<00U7c00<0057bDO800U7b00@0057BDM8000AAdP03001AdU7B
009AdP03001A/U6b00=A/P03001A/U6b009A/P05001A/U6bDK800005DK800`00DI5AT@02DI400`00
DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@03DI42001S
ool000Ooo`03003ooooo00Ooo`03003ooooo0?ooob_oo`03003ooooo01Soo`800005FS@005XCFQ<0
0004FQ<00`00DO=Al`02DO<00`00DO9AlP02DO801@00DM9AdU7B00000e7B00<0057BDM800U7B00<0
056bDK800e6b00<0056bDK800U6b00<0056bDK800U6b00<0056bDK800U6b00<0056ADI400U6A00<0
056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400e6A00<0056ADI400e6A00<0
0?ooool0H_oo0007ool00`00ooooo`07ool00`00ooooo`3oool[ool00`00ooooo`0Jool30002FQ<0
1@00FQ=J4eXC0000157c00<0057bDO800U7b00D0057BDM9AdP0000AAdP05001AdU7BDM800005DK80
0`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DI5AT@02DI400`00DI5AT@03DI40
0`00DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@02DI400`00ooooo`1Sool0
00Ooo`03003ooooo00Koo`03003ooooo0?ooobcoo`03003ooooo01goo`D0009J4`03001Ale7c009A
l`05001AlU7bDO800003DM800`00DM9AdP02DM800`00DM9AdP02DM800`00DK9A/P02DK800`00DK9A
/P02DK800`00DK9A/P02DK800`00DK9A/P03DK801@00DI5ATE6A00001E6A00<0056ADI400e6A00<0
056ADI400e6A00<0056ADI400U6A00D0056ADI5AT@0006Koo`001ooo00<00?ooool01Ooo00<00?oo
ool0oooo;Ooo00<00?ooool08_oo1@000U7c00<0057bDO800U7b00@0057BDM8000AAdP03001AdU7B
009AdP03001A/U6b009A/P03001A/U6b009A/P03001A/U6b009A/P03001A/U6b00=A/P03001ATE6A
009AT@03001ATE6A009AT@03001ATE6A00=AT@03001ATE6A00=AT@03001ATE6A00=AT@03001AT@00
06Ooo`001_oo00<00?ooool01_oo00<00?ooool0oooo;Ooo00<00?ooool09ooo1@000U7b00@0057B
DM8000AAdP03001AdU7B009AdP03001A/U6b00=A/P05001A/U6bDK800004DK800`00DK9A/P03DK80
0`00DI5AT@02DI400`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@03DI42
001Xool000Koo`03003ooooo00Goo`03003ooooo0?ooobkoo`03003ooooo02coo`<000=AdP05001A
dU7BDM800004DM800`00DK9A/P03DK800`00DK9A/P02DK801@00DK9A/U6b00001E6b00<0056ADI40
0U6A00<0056ADI400e6A00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400e6A00<00?ooool0
Iooo0006ool00`00ooooo`04ool00`00ooooo`3oool_ool00`00ooooo`0_ool200000e7B001AdP03
DM801@00DM9AdU7B00001E6b00<0056bDK800U6b00<0056bDK800U6b00<0056bDK800U6b00<0056A
DI400U6A00<0056ADI400e6A00<0056ADI400e6A00<0056ADI400U6A00<0056ADI400U6A00<00?oo
ool0J?oo0006ool00`00ooooo`04ool00`00ooooo`3oool_ool00`00ooooo`0aool40002DM800`00
DM9AdP02DM800`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A/P02DK800`00
DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI5AT@02DI401@00DI5ATE6A0000Jooo
0006ool00`00ooooo`03ool00`00ooooo`3oool`ool00`00ooooo`0eool50002DM800`00DK9A/P02
DK800`00DK9A/P02DK800`00DK9A/P02DK800`00DK9A/P03DK800`00DI5AT@02DI400`00DI5AT@02
DI400`00DI5AT@03DI400`00DI5AT@03DI400`00DI40001/ool000Koo`03003ooooo00?oo`03003o
oooo0?oooc7oo`03003ooooo03Woo`@000AA/P05001A/U6bDK800004DK800`00DK9A/P03DK800`00
DI5AT@02DI400`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@03DI42001]ool000Koo`03003o
oooo00;oo`03003ooooo0?oooc;oo`03003ooooo03goo`<00003DK80056b00=A/P05001A/U6bDK80
0005DK800`00DI5AT@02DI400`00DI5AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI400`00oooo
o`1/ool000Goo`03003ooooo00;oo`03003ooooo0?oooc?oo`03003ooooo043oo`@0009A/P03001A
/U6b009A/P03001A/U6b009A/P03001ATE6A009AT@03001ATE6A00=AT@03001ATE6A009AT@03001A
TE6A009AT@03003ooooo06goo`001Ooo00<00?ooool00_oo00<00?ooool0oooo<ooo00<00?ooool0
A?oo1@000U6b00<0056bDK800U6b00<0056ADI400U6A00<0056ADI400e6A00<0056ADI400e6A00@0
056A0000073oo`001Ooo00D00?ooooooo`000?ooocKoo`03003ooooo04Woo`@000AA/P05001ATE6A
DI400005DI400`00DI5AT@03DI42001bool000Goo`04003ooooo003ooolgool00`00ooooo`1=ool3
00000e6b001AT@03DI400`00DI5AT@02DI400`00DI5AT@03DI400`00ooooo`1aool000Goo`04003o
oooo003ooolgool00`00ooooo`1@ool40002DI400`00DI5AT@02DI400`00DI5AT@02DI400`00oooo
o`1bool000Goo`03003oo`000?ooocSoo`03003ooooo05Coo`@000AAT@04001AT@00001eool000Go
o`03003oo`000?ooocSoo`03003ooooo05Soo`<00004DI400000001fool000Coo`03003oo`000?oo
ocWoo`03003ooooo05_oo`8007Soo`001?oo0P00oooo>_oo00<00?ooool0Fooo00<00?ooool0Mooo
0004ool2003oooljool00`00ooooo`1Jool00`00ooooo`1hool000Coo`800?oooc[oo`03003ooooo
05Woo`03003ooooo07Woo`001_oo1000oooo=_oo00<00?ooool0F?oo00<00?ooool0N_oo000:ool4
003ooolbool00`00ooooo`1Gool00`00ooooo`1kool000koo`@00?ooobkoo`03003ooooo05Koo`03
003ooooo07coo`004_oo1000oooo:_oo00<00?ooool0EOoo00<00?ooool0OOoo000Fool4003ooolV
ool00`00ooooo`1Dool00`00ooooo`1nool001[oo`@00?ooob;oo`03003ooooo05?oo`03003ooooo
07ooo`007_oo1000oooo7_oo00<00?ooool0D_oo00<00?ooool0P?oo000Rool3003ooolKool00`00
ooooo`1@ool20023ool002Goo`@00?oooaOoo`03003ooooo04ooo`03003ooooo08?oo`00:Ooo1000
oooo4ooo00<00?ooool0C_oo00<00?ooool0Q?oo000]ool4003oool?ool00`00ooooo`1=ool00`00
ooooo`25ool0037oo`@00?ooo`_oo`03003ooooo04coo`03003ooooo08Koo`00=Ooo1000oooo1ooo
00<00?ooool0Booo00<00?ooool0Qooo000iool4003oool3ool00`00ooooo`1:ool00`00ooooo`28
ool003goo`@00?ooo`03003ooooo04Soo`03003ooooo08Woo`00@Ooo0`00o?oo00<00?ooool0Aooo
00<00?ooool0R_oo0014ool4003hool00`00ooooo`16ool00`00ooooo`2;ool004Soo`@00?Coo`03
003ooooo04Goo`03003ooooo08coo`00C?oo1000l?oo00<00?ooool0@ooo0P00Sooo001@ool4003/
ool00`00ooooo`12ool00`00ooooo`2?ool005Coo`@00>Soo`03003ooooo047oo`03003ooooo093o
o`00F?oo1000i?oo00<00?ooool0@?oo00<00?ooool0TOoo001Lool4003Pool00`00ooooo`0oool0
0`00ooooo`2Bool0063oo`@00=coo`03003ooooo03koo`03003ooooo09?oo`00I?oo0`00fOoo00<0
0?ooool0?Ooo00<00?ooool0U?oo001Wool4003Eool00`00ooooo`0lool00`00ooooo`2Eool006_o
o`@00=7oo`03003ooooo03_oo`03003ooooo09Koo`00Kooo1000cOoo00<00?ooool0>_oo00<00?oo
ool0Uooo001cool40039ool00`00ooooo`0iool00`00ooooo`2Hool007Ooo`@00<Goo`03003ooooo
03Soo`03003ooooo09Woo`00Nooo1000`Ooo00<00?ooool0=_oo0P00W?oo001oool4002mool00`00
ooooo`0eool00`00ooooo`2Lool008?oo`<00;[oo`03003ooooo03Coo`03003ooooo09goo`00Q_oo
1000]_oo00<00?ooool0<ooo00<00?ooool0W_oo002:ool4002bool00`00ooooo`0bool00`00oooo
o`2Oool008koo`@00:koo`03003ooooo037oo`03003ooooo0:3oo`00T_oo1000Z_oo00<00?ooool0
<?oo00<00?ooool0XOoo002Fool4002Vool00`00ooooo`0_ool00`00ooooo`2Rool009[oo`@00:;o
o`03003ooooo02koo`03003ooooo0:?oo`00W_oo1000W_oo00<00?ooool0;Ooo00<00?ooool0Y?oo
002Rool3002Kool00`00ooooo`0/ool00`00ooooo`2Uool00:Goo`@009Soo`03003ooooo02Woo`80
0:Soo`00ZOoo1000U?oo00<00?ooool0:?oo00<00?ooool0Z?oo002]ool4002@ool00`00ooooo`0W
ool00`00ooooo`2Yool00;7oo`@008coo`03003ooooo02Koo`03003ooooo0:[oo`00]Ooo1000R?oo
00<00?ooool09Ooo00<00?ooool0Zooo002iool40024ool00`00ooooo`0Tool00`00ooooo`2/ool0
0;goo`@0083oo`03003ooooo02?oo`03003ooooo0:goo`00`Ooo0`00OOoo00<00?ooool08_oo00<0
0?ooool0[_oo0034ool4001iool00`00ooooo`0Qool00`00ooooo`2_ool00<Soo`@007Goo`03003o
oooo023oo`03003ooooo0;3oo`00c?oo1000LOoo00<00?ooool07ooo00<00?ooool0/Ooo003@ool4
001]ool00`00ooooo`0Mool2002dool00=Coo`@006Woo`03003ooooo01coo`03003ooooo0;Coo`00
f?oo1000IOoo00<00?ooool06ooo00<00?ooool0]Ooo003Lool4001Qool00`00ooooo`0Jool00`00
ooooo`2fool00>3oo`<005koo`03003ooooo01Woo`03003ooooo0;Ooo`00hooo1000F_oo00<00?oo
ool06?oo00<00?ooool0^?oo003Wool4001Fool00`00ooooo`0Gool00`00ooooo`2iool00>_oo`@0
05;oo`03003ooooo01Koo`03003ooooo0;[oo`00kooo1000C_oo00<00?ooool05Ooo00<00?ooool0
^ooo003cool4001:ool00`00ooooo`0Dool00`00ooooo`2lool00?Ooo`@004Koo`03003ooooo01?o
o`03003ooooo0;goo`00nooo1000@_oo00<00?ooool04_oo00<00?ooool0__oo003oool4000nool0
0`00ooooo`0@ool20031ool00?ooo`Coo`<003_oo`03003ooooo00ooo`03003ooooo0<7oo`00oooo
1ooo1000=ooo00<00?ooool03_oo00<00?ooool0`_oo003oool;ool4000cool00`00ooooo`0=ool0
0`00ooooo`33ool00?ooo`ooo`@0033oo`03003ooooo00_oo`03003ooooo0<Coo`00oooo4ooo1000
;?oo00<00?ooool02_oo00<00?ooool0aOoo003ooolGool4000Xool00`00ooooo`09ool00`00oooo
o`36ool00?oooa_oo`@002Coo`03003ooooo00Soo`03003ooooo0<Ooo`00oooo7ooo10008?oo00<0
0?ooool01ooo00<00?ooool0b?oo003ooolSool3000Mool00`00ooooo`06ool00`00ooooo`39ool0
0?ooobKoo`@001Woo`03003ooooo00Goo`03003ooooo0<[oo`00oooo:_oo10005Ooo00<00?ooool0
0ooo0P00cOoo003oool^ool4000Aool00`00ooooo`02ool00`00ooooo`3=ool00?oooc;oo`@000go
o`05003oooooool0003@ool00?ooocKoo`@000Woo`04003ooooo003Aool00?oooc[oo`@000Goo`03
003oo`000=;oo`00oooo?_oo100000?oo`000000dooo003ooom2ool2003Dool00001\
\>"],
  ImageRangeCache->{{{0, 534.75}, {445.812, 0}} -> {0.0430692, 0.030097, \
0.00183669, 0.00183669}}],

Cell[BoxData[
    TagBox[
      RowBox[{
      "\[SkeletonIndicator]", "SurfaceGraphics", "\[SkeletonIndicator]"}],
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Plot3D", "[", 
      RowBox[{
        RowBox[{"Re", "[", 
          RowBox[{"ArcCos", "[", 
            FractionBox[
              RowBox[{"1", "-", 
                RowBox[{"2", "x"}], "+", "y"}], 
              RowBox[{"2", 
                RowBox[{"(", 
                  RowBox[{"x", "-", "1"}], ")"}]}]], "]"}], "]"}], ",", 
        RowBox[{"{", 
          RowBox[{"x", ",", "0", ",", "0.99"}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{"y", ",", "0", ",", "0.99"}], "}"}], ",", 
        RowBox[{"PlotPoints", "\[Rule]", "80"}], ",", 
        RowBox[{"AxesLabel", "\[Rule]", 
          RowBox[{"{", 
            RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<\>\""}], 
            "}"}]}]}], "]"}]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .81114 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% SurfaceGraphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
2.53703e-17 1.04977 -0.0679587 1.04977 [
[.02757 .24618 -6 -8.70276 ]
[.02757 .24618 0 .29724 ]
[.1472 .1991 -17.8784 -9 ]
[.1472 .1991 .12162 0 ]
[.2727 .14972 -17.1202 -9 ]
[.2727 .14972 .87977 0 ]
[.40451 .09788 -16.3621 -9 ]
[.40451 .09788 1.63793 0 ]
[.54311 .0434 -15.6039 -9 ]
[.54311 .0434 2.39608 0 ]
[.29165 .07573 -9.31117 -9.8125 ]
[.29165 .07573 .68883 0 ]
[.70096 -0.00478 0 -6.26206 ]
[.70096 -0.00478 6 2.73794 ]
[.76809 .09801 0 -6.16092 ]
[.76809 .09801 18 2.83908 ]
[.82929 .19172 0 -6.07075 ]
[.82929 .19172 18 2.92925 ]
[.8853 .27749 0 -5.98988 ]
[.8853 .27749 18 3.01012 ]
[.93676 .3563 0 -5.91692 ]
[.93676 .3563 18 3.08308 ]
[.91861 .21225 0 -6.57576 ]
[.91861 .21225 10.0625 3.23674 ]
[.02411 .26511 -6 -2.74232 ]
[.02411 .26511 0 6.25768 ]
[.01297 .33498 -6 -2.80142 ]
[.01297 .33498 0 6.19858 ]
[.0013 .4081 -6 -2.86356 ]
[.0013 .4081 0 6.13644 ]
[-0.01092 .48469 -6 -2.92897 ]
[-0.01092 .48469 0 6.07103 ]
[ 0 0 0 0 ]
[ 1 .81114 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.03716 .25514 m
.68874 0 L
s
.03716 .25514 m
.04196 .25962 L
s
[(0)] .02757 .24618 1 .93395 Mshowa
.15642 .20844 m
.16103 .21311 L
s
[(0.2)] .1472 .1991 .98649 1 Mshowa
.28149 .15946 m
.28589 .16434 L
s
[(0.4)] .2727 .14972 .90225 1 Mshowa
.41282 .10804 m
.41697 .11312 L
s
[(0.6)] .40451 .09788 .81801 1 Mshowa
.55087 .05398 m
.55475 .05927 L
s
[(0.8)] .54311 .0434 .73377 1 Mshowa
.125 Mabswid
.06645 .24367 m
.0693 .24638 L
s
.09609 .23206 m
.09891 .23481 L
s
.12608 .22032 m
.12887 .22309 L
s
.18713 .19641 m
.18986 .19925 L
s
.2182 .18425 m
.22091 .18711 L
s
.24966 .17193 m
.25233 .17482 L
s
.31372 .14684 m
.31632 .1498 L
s
.34635 .13407 m
.34891 .13705 L
s
.37937 .12114 m
.38191 .12415 L
s
.44668 .09478 m
.44913 .09786 L
s
.48097 .08135 m
.48338 .08447 L
s
.5157 .06776 m
.51807 .0709 L
s
.5865 .04003 m
.58878 .04324 L
s
.62258 .0259 m
.62482 .02914 L
s
.65914 .01159 m
.66134 .01486 L
s
gsave
.29165 .07573 -70.3112 -13.8125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 17.8125 translate 1 -1 scale
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
69.000 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.68874 0 m
.96935 .42924 L
s
.68874 0 m
.68263 .00239 L
s
[(0)] .70096 -0.00478 -1 .39157 Mshowa
.75578 .10255 m
.74963 .10483 L
s
[(0.2)] .76809 .09801 -1 .36909 Mshowa
.8169 .19604 m
.8107 .1982 L
s
[(0.4)] .82929 .19172 -1 .34906 Mshowa
.87284 .28162 m
.86661 .28368 L
s
[(0.6)] .8853 .27749 -1 .33108 Mshowa
.92424 .36024 m
.91798 .36221 L
s
[(0.8)] .93676 .3563 -1 .31487 Mshowa
.125 Mabswid
.7061 .02656 m
.70243 .02798 L
s
.72305 .05249 m
.71937 .05389 L
s
.73961 .07782 m
.73592 .0792 L
s
.77158 .12673 m
.76788 .12807 L
s
.78703 .15035 m
.78332 .15168 L
s
.80213 .17345 m
.79842 .17477 L
s
.83134 .21814 m
.82762 .21942 L
s
.84547 .23975 m
.84175 .24102 L
s
.8593 .26091 m
.85557 .26216 L
s
.88609 .30189 m
.88235 .30311 L
s
.89907 .32174 m
.89533 .32295 L
s
.91179 .34119 m
.90804 .34238 L
s
.93645 .37891 m
.93269 .38008 L
s
.94841 .39721 m
.94464 .39836 L
s
.96013 .41514 m
.95637 .41629 L
s
gsave
.91861 .21225 -61 -10.5758 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 17.8125 translate 1 -1 scale
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.062 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(y) show
69.062 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.03716 .25514 m
0 .48963 L
s
.03634 .26033 m
.04245 .25795 L
s
[(0)] .02411 .26511 1 -0.3906 Mshowa
.02524 .33035 m
.03138 .32803 L
s
[(1)] .01297 .33498 1 -0.37746 Mshowa
.01363 .40361 m
.0198 .40137 L
s
[(2)] .0013 .4081 1 -0.36365 Mshowa
.00147 .48036 m
.00766 .4782 L
s
[(3)] -0.01092 .48469 1 -0.34912 Mshowa
.125 Mabswid
.03416 .27409 m
.03783 .27266 L
s
.03196 .28796 m
.03563 .28655 L
s
.02974 .30196 m
.03342 .30056 L
s
.0275 .31609 m
.03118 .31469 L
s
.02296 .34473 m
.02665 .34335 L
s
.02066 .35925 m
.02435 .35788 L
s
.01834 .3739 m
.02203 .37254 L
s
.016 .38869 m
.01969 .38733 L
s
.01124 .41867 m
.01495 .41734 L
s
.00883 .43388 m
.01254 .43255 L
s
.0064 .44923 m
.01011 .44791 L
s
.00395 .46472 m
.00766 .46341 L
s
.25 Mabswid
.03716 .25514 m
0 .48963 L
s
0 .48963 m
.39787 .81114 L
s
.39787 .81114 m
.40529 .59895 L
s
.40529 .59895 m
.03716 .25514 L
s
.68874 0 m
.96935 .42924 L
s
.96935 .42924 m
1 .6535 L
s
1 .6535 m
.70298 .24544 L
s
.70298 .24544 m
.68874 0 L
s
.03716 .25514 m
0 .48963 L
s
0 .48963 m
.70298 .24544 L
s
.70298 .24544 m
.68874 0 L
s
.68874 0 m
.03716 .25514 L
s
.40529 .59895 m
.96935 .42924 L
s
.96935 .42924 m
1 .6535 L
s
1 .6535 m
.39787 .81114 L
s
.39787 .81114 m
.40529 .59895 L
s
0 0 m
1 0 L
1 .81114 L
0 .81114 L
closepath
clip
newpath
.5 Mabswid
.647 .623 .812 r
.39408 .79892 .39806 .80578 .40491 .80393 .40094 .79704 Metetra
.647 .623 .811 r
.40094 .79704 .40491 .80393 .41178 .80208 .40782 .79515 Metetra
.647 .622 .811 r
.40782 .79515 .41178 .80208 .41867 .80023 .41471 .79326 Metetra
.647 .622 .81 r
.41471 .79326 .41867 .80023 .42558 .79836 .42163 .79136 Metetra
.647 .621 .81 r
.42163 .79136 .42558 .79836 .4325 .7965 .42855 .78946 Metetra
.647 .62 .809 r
.42855 .78946 .4325 .7965 .43945 .79462 .4355 .78755 Metetra
.647 .62 .808 r
.4355 .78755 .43945 .79462 .4464 .79274 .44247 .78563 Metetra
.647 .619 .808 r
.44247 .78563 .4464 .79274 .45338 .79086 .44945 .78371 Metetra
.647 .618 .807 r
.44945 .78371 .45338 .79086 .46038 .78897 .45645 .78178 Metetra
.647 .618 .807 r
.45645 .78178 .46038 .78897 .46739 .78707 .46346 .77985 Metetra
.647 .617 .806 r
.46346 .77985 .46739 .78707 .47442 .78517 .4705 .7779 Metetra
.647 .616 .805 r
.4705 .7779 .47442 .78517 .48147 .78326 .47755 .77596 Metetra
.647 .616 .804 r
.47755 .77596 .48147 .78326 .48853 .78134 .48462 .774 Metetra
.646 .615 .804 r
.48462 .774 .48853 .78134 .49562 .77942 .49171 .77204 Metetra
.646 .614 .803 r
.49171 .77204 .49562 .77942 .50272 .77749 .49882 .77007 Metetra
.646 .613 .802 r
.49882 .77007 .50272 .77749 .50984 .77556 .50595 .76809 Metetra
.646 .613 .802 r
.50595 .76809 .50984 .77556 .51698 .77362 .51309 .7661 Metetra
.646 .612 .801 r
.51309 .7661 .51698 .77362 .52414 .77167 .52025 .76411 Metetra
.646 .611 .8 r
.52025 .76411 .52414 .77167 .53132 .76972 .52743 .76211 Metetra
.646 .61 .799 r
.52743 .76211 .53132 .76972 .53851 .76776 .53463 .76011 Metetra
.646 .61 .799 r
.53463 .76011 .53851 .76776 .54572 .76579 .54185 .75809 Metetra
.646 .609 .798 r
.54185 .75809 .54572 .76579 .55296 .76382 .54908 .75607 Metetra
.646 .608 .797 r
.54908 .75607 .55296 .76382 .56021 .76184 .55634 .75404 Metetra
.646 .607 .796 r
.55634 .75404 .56021 .76184 .56748 .75985 .56361 .752 Metetra
.646 .606 .795 r
.56361 .752 .56748 .75985 .57476 .75785 .5709 .74995 Metetra
.646 .605 .794 r
.5709 .74995 .57476 .75785 .58207 .75585 .57821 .7479 Metetra
.646 .604 .793 r
.57821 .7479 .58207 .75585 .5894 .75384 .58554 .74583 Metetra
.645 .604 .793 r
.58554 .74583 .5894 .75384 .59674 .75182 .59289 .74376 Metetra
.645 .603 .792 r
.59289 .74376 .59674 .75182 .6041 .7498 .60025 .74168 Metetra
.645 .602 .791 r
.60025 .74168 .6041 .7498 .61149 .74776 .60764 .73958 Metetra
.645 .601 .79 r
.60764 .73958 .61149 .74776 .61889 .74572 .61504 .73748 Metetra
.645 .6 .789 r
.61504 .73748 .61889 .74572 .62631 .74367 .62247 .73537 Metetra
.645 .599 .788 r
.62247 .73537 .62631 .74367 .63375 .74161 .62991 .73325 Metetra
.645 .598 .787 r
.62991 .73325 .63375 .74161 .64121 .73955 .63737 .73112 Metetra
.645 .597 .785 r
.63737 .73112 .64121 .73955 .64869 .73747 .64485 .72898 Metetra
.645 .596 .784 r
.64485 .72898 .64869 .73747 .65619 .73539 .65235 .72682 Metetra
.645 .594 .783 r
.65235 .72682 .65619 .73539 .6637 .73329 .65987 .72466 Metetra
.645 .593 .782 r
.65987 .72466 .6637 .73329 .67124 .73119 .66741 .72248 Metetra
.645 .592 .781 r
.66741 .72248 .67124 .73119 .6788 .72908 .67496 .72029 Metetra
.645 .591 .78 r
.67496 .72029 .6788 .72908 .68637 .72695 .68254 .71809 Metetra
.644 .59 .778 r
.68254 .71809 .68637 .72695 .69397 .72482 .69014 .71588 Metetra
.644 .589 .777 r
.69014 .71588 .69397 .72482 .70159 .72268 .69775 .71365 Metetra
.644 .587 .776 r
.69775 .71365 .70159 .72268 .70922 .72052 .70538 .71141 Metetra
.644 .586 .774 r
.70538 .71141 .70922 .72052 .71688 .71835 .71304 .70915 Metetra
.644 .585 .773 r
.71304 .70915 .71688 .71835 .72455 .71617 .72071 .70688 Metetra
.644 .583 .772 r
.72071 .70688 .72455 .71617 .73224 .71398 .7284 .70459 Metetra
.644 .582 .77 r
.7284 .70459 .73224 .71398 .73996 .71178 .73611 .70229 Metetra
.644 .58 .769 r
.73611 .70229 .73996 .71178 .74769 .70956 .74384 .69997 Metetra
.644 .579 .767 r
.74384 .69997 .74769 .70956 .75544 .70733 .75159 .69762 Metetra
.644 .577 .765 r
.75159 .69762 .75544 .70733 .76322 .70508 .75936 .69526 Metetra
.644 .576 .764 r
.75936 .69526 .76322 .70508 .77101 .70281 .76714 .69288 Metetra
.644 .574 .762 r
.76714 .69288 .77101 .70281 .77882 .70053 .77495 .69047 Metetra
.644 .573 .76 r
.77495 .69047 .77882 .70053 .78665 .69823 .78277 .68804 Metetra
.644 .571 .758 r
.78277 .68804 .78665 .69823 .7945 .69591 .79061 .68559 Metetra
.644 .569 .756 r
.79061 .68559 .7945 .69591 .80237 .69358 .79847 .6831 Metetra
.644 .567 .754 r
.79847 .6831 .80237 .69358 .81026 .69121 .80635 .68058 Metetra
.644 .565 .752 r
.80635 .68058 .81026 .69121 .81817 .68883 .81425 .67804 Metetra
.644 .563 .749 r
.81425 .67804 .81817 .68883 .82609 .68642 .82216 .67545 Metetra
.644 .561 .747 r
.82216 .67545 .82609 .68642 .83404 .68398 .83009 .67282 Metetra
.644 .559 .745 r
.83009 .67282 .83404 .68398 .842 .68151 .83803 .67015 Metetra
.644 .557 .742 r
.83803 .67015 .842 .68151 .84998 .679 .84599 .66743 Metetra
.644 .555 .739 r
.84599 .66743 .84998 .679 .85798 .67645 .85397 .66466 Metetra
.644 .553 .736 r
.85397 .66466 .85798 .67645 .86599 .67387 .86196 .66182 Metetra
.645 .55 .733 r
.86196 .66182 .86599 .67387 .87402 .67123 .86996 .65891 Metetra
.645 .548 .73 r
.86996 .65891 .87402 .67123 .88207 .66853 .87797 .65591 Metetra
.645 .545 .726 r
.87797 .65591 .88207 .66853 .89013 .66577 .88599 .65282 Metetra
.646 .542 .723 r
.88599 .65282 .89013 .66577 .8982 .66293 .89402 .64962 Metetra
.647 .54 .719 r
.89402 .64962 .8982 .66293 .90628 .66 .90205 .64627 Metetra
.648 .537 .714 r
.90205 .64627 .90628 .66 .91436 .65696 .91008 .64276 Metetra
.65 .534 .709 r
.91008 .64276 .91436 .65696 .92245 .65377 .9181 .63904 Metetra
.651 .531 .704 r
.9181 .63904 .92245 .65377 .93054 .65041 .92611 .63506 Metetra
.654 .528 .698 r
.92611 .63506 .93054 .65041 .93862 .64683 .93409 .63073 Metetra
.657 .526 .692 r
.93409 .63073 .93862 .64683 .94668 .64293 .94203 .62593 Metetra
.662 .523 .684 r
.94203 .62593 .94668 .64293 .9547 .63861 .9499 .62047 Metetra
.67 .522 .675 r
.9499 .62047 .9547 .63861 .96265 .63363 .95765 .61401 Metetra
.681 .522 .664 r
.95765 .61401 .96265 .63363 .97048 .6276 .9652 .60591 Metetra
.7 .526 .649 r
.9652 .60591 .97048 .6276 .97805 .61963 .97233 .59476 Metetra
.737 .54 .627 r
.97233 .59476 .97805 .61963 .98503 .60726 .97849 .57643 Metetra
.833 .589 .57 r
.97849 .57643 .98503 .60726 .98973 .57836 .9805 .52798 Metetra
.651 .651 .836 r
.39006 .79294 .39408 .79892 .40094 .79704 .39693 .79104 Metetra
.651 .65 .836 r
.39693 .79104 .40094 .79704 .40782 .79515 .40381 .78913 Metetra
.651 .65 .835 r
.40381 .78913 .40782 .79515 .41471 .79326 .41071 .78721 Metetra
.651 .649 .835 r
.41071 .78721 .41471 .79326 .42163 .79136 .41763 .78528 Metetra
.651 .649 .834 r
.41763 .78528 .42163 .79136 .42855 .78946 .42457 .78335 Metetra
.651 .648 .834 r
.42457 .78335 .42855 .78946 .4355 .78755 .43152 .78141 Metetra
.651 .648 .833 r
.43152 .78141 .4355 .78755 .44247 .78563 .43849 .77946 Metetra
.651 .647 .833 r
.43849 .77946 .44247 .78563 .44945 .78371 .44548 .77751 Metetra
.651 .646 .832 r
.44548 .77751 .44945 .78371 .45645 .78178 .45249 .77555 Metetra
.651 .646 .832 r
.45249 .77555 .45645 .78178 .46346 .77985 .45951 .77358 Metetra
.651 .645 .831 r
.45951 .77358 .46346 .77985 .4705 .7779 .46655 .77161 Metetra
.651 .645 .83 r
.46655 .77161 .4705 .7779 .47755 .77596 .47361 .76963 Metetra
.651 .644 .83 r
.47361 .76963 .47755 .77596 .48462 .774 .48069 .76764 Metetra
.651 .643 .829 r
.48069 .76764 .48462 .774 .49171 .77204 .48779 .76564 Metetra
.651 .643 .828 r
.48779 .76564 .49171 .77204 .49882 .77007 .4949 .76364 Metetra
.651 .642 .828 r
.4949 .76364 .49882 .77007 .50595 .76809 .50203 .76163 Metetra
.651 .641 .827 r
.50203 .76163 .50595 .76809 .51309 .7661 .50918 .75961 Metetra
.651 .641 .826 r
.50918 .75961 .51309 .7661 .52025 .76411 .51635 .75758 Metetra
.651 .64 .826 r
.51635 .75758 .52025 .76411 .52743 .76211 .52354 .75554 Metetra
.651 .639 .825 r
.52354 .75554 .52743 .76211 .53463 .76011 .53074 .7535 Metetra
.651 .639 .824 r
.53074 .7535 .53463 .76011 .54185 .75809 .53797 .75145 Metetra
.651 .638 .824 r
.53797 .75145 .54185 .75809 .54908 .75607 .54521 .74939 Metetra
.652 .637 .823 r
.54521 .74939 .54908 .75607 .55634 .75404 .55247 .74732 Metetra
.652 .636 .822 r
.55247 .74732 .55634 .75404 .56361 .752 .55975 .74524 Metetra
.652 .636 .821 r
.55975 .74524 .56361 .752 .5709 .74995 .56704 .74315 Metetra
.652 .635 .82 r
.56704 .74315 .5709 .74995 .57821 .7479 .57436 .74105 Metetra
.652 .634 .82 r
.57436 .74105 .57821 .7479 .58554 .74583 .58169 .73894 Metetra
.652 .633 .819 r
.58169 .73894 .58554 .74583 .59289 .74376 .58905 .73682 Metetra
.652 .632 .818 r
.58905 .73682 .59289 .74376 .60025 .74168 .59642 .7347 Metetra
.652 .631 .817 r
.59642 .7347 .60025 .74168 .60764 .73958 .60381 .73256 Metetra
.652 .631 .816 r
.60381 .73256 .60764 .73958 .61504 .73748 .61122 .73041 Metetra
.652 .63 .815 r
.61122 .73041 .61504 .73748 .62247 .73537 .61865 .72825 Metetra
.652 .629 .814 r
.61865 .72825 .62247 .73537 .62991 .73325 .6261 .72608 Metetra
.652 .628 .813 r
.6261 .72608 .62991 .73325 .63737 .73112 .63356 .7239 Metetra
.652 .627 .812 r
.63356 .7239 .63737 .73112 .64485 .72898 .64105 .7217 Metetra
.652 .626 .811 r
.64105 .7217 .64485 .72898 .65235 .72682 .64855 .7195 Metetra
.652 .625 .81 r
.64855 .7195 .65235 .72682 .65987 .72466 .65607 .71728 Metetra
.652 .624 .809 r
.65607 .71728 .65987 .72466 .66741 .72248 .66362 .71504 Metetra
.652 .623 .808 r
.66362 .71504 .66741 .72248 .67496 .72029 .67118 .7128 Metetra
.652 .622 .807 r
.67118 .7128 .67496 .72029 .68254 .71809 .67876 .71053 Metetra
.652 .621 .806 r
.67876 .71053 .68254 .71809 .69014 .71588 .68636 .70826 Metetra
.652 .62 .804 r
.68636 .70826 .69014 .71588 .69775 .71365 .69397 .70596 Metetra
.652 .618 .803 r
.69397 .70596 .69775 .71365 .70538 .71141 .70161 .70366 Metetra
.652 .617 .802 r
.70161 .70366 .70538 .71141 .71304 .70915 .70927 .70133 Metetra
.652 .616 .8 r
.70927 .70133 .71304 .70915 .72071 .70688 .71694 .69899 Metetra
.652 .615 .799 r
.71694 .69899 .72071 .70688 .7284 .70459 .72463 .69662 Metetra
.652 .613 .797 r
.72463 .69662 .7284 .70459 .73611 .70229 .73235 .69424 Metetra
.653 .612 .796 r
.73235 .69424 .73611 .70229 .74384 .69997 .74008 .69184 Metetra
.653 .611 .794 r
.74008 .69184 .74384 .69997 .75159 .69762 .74782 .68941 Metetra
.653 .609 .793 r
.74782 .68941 .75159 .69762 .75936 .69526 .75559 .68696 Metetra
.653 .608 .791 r
.75559 .68696 .75936 .69526 .76714 .69288 .76338 .68449 Metetra
.653 .606 .789 r
.76338 .68449 .76714 .69288 .77495 .69047 .77118 .68198 Metetra
.653 .605 .787 r
.77118 .68198 .77495 .69047 .78277 .68804 .779 .67945 Metetra
.654 .603 .786 r
.779 .67945 .78277 .68804 .79061 .68559 .78684 .67689 Metetra
.654 .602 .784 r
.78684 .67689 .79061 .68559 .79847 .6831 .7947 .67429 Metetra
.654 .6 .781 r
.7947 .67429 .79847 .6831 .80635 .68058 .80257 .67166 Metetra
.654 .598 .779 r
.80257 .67166 .80635 .68058 .81425 .67804 .81046 .66898 Metetra
.655 .596 .777 r
.81046 .66898 .81425 .67804 .82216 .67545 .81837 .66626 Metetra
.655 .594 .774 r
.81837 .66626 .82216 .67545 .83009 .67282 .82629 .66349 Metetra
.656 .592 .772 r
.82629 .66349 .83009 .67282 .83803 .67015 .83423 .66067 Metetra
.656 .59 .769 r
.83423 .66067 .83803 .67015 .84599 .66743 .84218 .65779 Metetra
.657 .588 .766 r
.84218 .65779 .84599 .66743 .85397 .66466 .85014 .65483 Metetra
.658 .586 .763 r
.85014 .65483 .85397 .66466 .86196 .66182 .85811 .6518 Metetra
.659 .584 .76 r
.85811 .6518 .86196 .66182 .86996 .65891 .8661 .64868 Metetra
.66 .582 .756 r
.8661 .64868 .86996 .65891 .87797 .65591 .87409 .64546 Metetra
.661 .579 .753 r
.87409 .64546 .87797 .65591 .88599 .65282 .88209 .64212 Metetra
.662 .577 .748 r
.88209 .64212 .88599 .65282 .89402 .64962 .89009 .63863 Metetra
.664 .574 .744 r
.89009 .63863 .89402 .64962 .90205 .64627 .89809 .63497 Metetra
.666 .572 .739 r
.89809 .63497 .90205 .64627 .91008 .64276 .90608 .6311 Metetra
.669 .569 .734 r
.90608 .6311 .91008 .64276 .9181 .63904 .91405 .62697 Metetra
.673 .567 .727 r
.91405 .62697 .9181 .63904 .92611 .63506 .92201 .6225 Metetra
.677 .564 .72 r
.92201 .6225 .92611 .63506 .93409 .63073 .92992 .6176 Metetra
.683 .563 .712 r
.92992 .6176 .93409 .63073 .94203 .62593 .93777 .6121 Metetra
.691 .561 .703 r
.93777 .6121 .94203 .62593 .9499 .62047 .94553 .60574 Metetra
.703 .561 .691 r
.94553 .60574 .9499 .62047 .95765 .61401 .95313 .5981 Metetra
.72 .563 .676 r
.95313 .5981 .95765 .61401 .9652 .60591 .96045 .58833 Metetra
.747 .57 .655 r
.96045 .58833 .9652 .60591 .97233 .59476 .96723 .5745 Metetra
.797 .589 .619 r
.96723 .5745 .97233 .59476 .97849 .57643 .97266 .55076 Metetra
.91 .64 .517 r
.97266 .55076 .97849 .57643 .9805 .52798 .97078 .47356 Metetra
.654 .666 .849 r
.38601 .78739 .39006 .79294 .39693 .79104 .39289 .78546 Metetra
.654 .665 .849 r
.39289 .78546 .39693 .79104 .40381 .78913 .39978 .78352 Metetra
.654 .665 .849 r
.39978 .78352 .40381 .78913 .41071 .78721 .40669 .78158 Metetra
.654 .665 .848 r
.40669 .78158 .41071 .78721 .41763 .78528 .41361 .77963 Metetra
.654 .664 .848 r
.41361 .77963 .41763 .78528 .42457 .78335 .42056 .77767 Metetra
.654 .664 .847 r
.42056 .77767 .42457 .78335 .43152 .78141 .42752 .7757 Metetra
.654 .663 .847 r
.42752 .7757 .43152 .78141 .43849 .77946 .4345 .77373 Metetra
.654 .662 .846 r
.4345 .77373 .43849 .77946 .44548 .77751 .44149 .77175 Metetra
.654 .662 .845 r
.44149 .77175 .44548 .77751 .45249 .77555 .44851 .76976 Metetra
.654 .661 .845 r
.44851 .76976 .45249 .77555 .45951 .77358 .45554 .76777 Metetra
.654 .661 .844 r
.45554 .76777 .45951 .77358 .46655 .77161 .46259 .76577 Metetra
.654 .66 .844 r
.46259 .76577 .46655 .77161 .47361 .76963 .46965 .76376 Metetra
.654 .66 .843 r
.46965 .76376 .47361 .76963 .48069 .76764 .47674 .76174 Metetra
.654 .659 .843 r
.47674 .76174 .48069 .76764 .48779 .76564 .48384 .75971 Metetra
.654 .659 .842 r
.48384 .75971 .48779 .76564 .4949 .76364 .49096 .75768 Metetra
.654 .658 .841 r
.49096 .75768 .4949 .76364 .50203 .76163 .4981 .75564 Metetra
.654 .657 .841 r
.4981 .75564 .50203 .76163 .50918 .75961 .50526 .75359 Metetra
.654 .657 .84 r
.50526 .75359 .50918 .75961 .51635 .75758 .51244 .75153 Metetra
.654 .656 .84 r
.51244 .75153 .51635 .75758 .52354 .75554 .51963 .74946 Metetra
.654 .656 .839 r
.51963 .74946 .52354 .75554 .53074 .7535 .52684 .74738 Metetra
.654 .655 .838 r
.52684 .74738 .53074 .7535 .53797 .75145 .53407 .7453 Metetra
.654 .654 .838 r
.53407 .7453 .53797 .75145 .54521 .74939 .54132 .7432 Metetra
.655 .654 .837 r
.54132 .7432 .54521 .74939 .55247 .74732 .54859 .7411 Metetra
.655 .653 .836 r
.54859 .7411 .55247 .74732 .55975 .74524 .55587 .73898 Metetra
.655 .652 .835 r
.55587 .73898 .55975 .74524 .56704 .74315 .56318 .73686 Metetra
.655 .651 .835 r
.56318 .73686 .56704 .74315 .57436 .74105 .5705 .73472 Metetra
.655 .651 .834 r
.5705 .73472 .57436 .74105 .58169 .73894 .57784 .73258 Metetra
.655 .65 .833 r
.57784 .73258 .58169 .73894 .58905 .73682 .5852 .73042 Metetra
.655 .649 .832 r
.5852 .73042 .58905 .73682 .59642 .7347 .59258 .72825 Metetra
.655 .648 .831 r
.59258 .72825 .59642 .7347 .60381 .73256 .59998 .72608 Metetra
.655 .648 .831 r
.59998 .72608 .60381 .73256 .61122 .73041 .6074 .72389 Metetra
.655 .647 .83 r
.6074 .72389 .61122 .73041 .61865 .72825 .61483 .72168 Metetra
.655 .646 .829 r
.61483 .72168 .61865 .72825 .6261 .72608 .62229 .71947 Metetra
.655 .645 .828 r
.62229 .71947 .6261 .72608 .63356 .7239 .62976 .71724 Metetra
.656 .644 .827 r
.62976 .71724 .63356 .7239 .64105 .7217 .63725 .715 Metetra
.656 .643 .826 r
.63725 .715 .64105 .7217 .64855 .7195 .64476 .71275 Metetra
.656 .642 .825 r
.64476 .71275 .64855 .7195 .65607 .71728 .65229 .71048 Metetra
.656 .642 .824 r
.65229 .71048 .65607 .71728 .66362 .71504 .65984 .7082 Metetra
.656 .641 .823 r
.65984 .7082 .66362 .71504 .67118 .7128 .6674 .7059 Metetra
.656 .64 .822 r
.6674 .7059 .67118 .7128 .67876 .71053 .67499 .70358 Metetra
.656 .639 .82 r
.67499 .70358 .67876 .71053 .68636 .70826 .68259 .70125 Metetra
.657 .638 .819 r
.68259 .70125 .68636 .70826 .69397 .70596 .69022 .69891 Metetra
.657 .636 .818 r
.69022 .69891 .69397 .70596 .70161 .70366 .69786 .69654 Metetra
.657 .635 .817 r
.69786 .69654 .70161 .70366 .70927 .70133 .70552 .69415 Metetra
.657 .634 .815 r
.70552 .69415 .70927 .70133 .71694 .69899 .7132 .69175 Metetra
.657 .633 .814 r
.7132 .69175 .71694 .69899 .72463 .69662 .72089 .68932 Metetra
.658 .632 .813 r
.72089 .68932 .72463 .69662 .73235 .69424 .72861 .68687 Metetra
.658 .631 .811 r
.72861 .68687 .73235 .69424 .74008 .69184 .73634 .6844 Metetra
.658 .629 .81 r
.73634 .6844 .74008 .69184 .74782 .68941 .7441 .6819 Metetra
.658 .628 .808 r
.7441 .6819 .74782 .68941 .75559 .68696 .75187 .67937 Metetra
.659 .627 .806 r
.75187 .67937 .75559 .68696 .76338 .68449 .75965 .67682 Metetra
.659 .625 .805 r
.75965 .67682 .76338 .68449 .77118 .68198 .76746 .67423 Metetra
.66 .624 .803 r
.76746 .67423 .77118 .68198 .779 .67945 .77528 .67161 Metetra
.66 .623 .801 r
.77528 .67161 .779 .67945 .78684 .67689 .78312 .66896 Metetra
.66 .621 .799 r
.78312 .66896 .78684 .67689 .7947 .67429 .79098 .66626 Metetra
.661 .619 .797 r
.79098 .66626 .7947 .67429 .80257 .67166 .79885 .66353 Metetra
.662 .618 .795 r
.79885 .66353 .80257 .67166 .81046 .66898 .80674 .66075 Metetra
.662 .616 .792 r
.80674 .66075 .81046 .66898 .81837 .66626 .81464 .65791 Metetra
.663 .614 .79 r
.81464 .65791 .81837 .66626 .82629 .66349 .82256 .65502 Metetra
.664 .613 .787 r
.82256 .65502 .82629 .66349 .83423 .66067 .83049 .65207 Metetra
.665 .611 .785 r
.83049 .65207 .83423 .66067 .84218 .65779 .83843 .64904 Metetra
.666 .609 .782 r
.83843 .64904 .84218 .65779 .85014 .65483 .84639 .64594 Metetra
.667 .607 .778 r
.84639 .64594 .85014 .65483 .85811 .6518 .85435 .64274 Metetra
.668 .605 .775 r
.85435 .64274 .85811 .6518 .8661 .64868 .86233 .63944 Metetra
.67 .603 .771 r
.86233 .63944 .8661 .64868 .87409 .64546 .87031 .63602 Metetra
.672 .601 .767 r
.87031 .63602 .87409 .64546 .88209 .64212 .87829 .63246 Metetra
.674 .599 .763 r
.87829 .63246 .88209 .64212 .89009 .63863 .88627 .62873 Metetra
.677 .596 .758 r
.88627 .62873 .89009 .63863 .89809 .63497 .89424 .6248 Metetra
.68 .594 .753 r
.89424 .6248 .89809 .63497 .90608 .6311 .9022 .62062 Metetra
.684 .592 .747 r
.9022 .62062 .90608 .6311 .91405 .62697 .91014 .61613 Metetra
.689 .59 .74 r
.91014 .61613 .91405 .62697 .92201 .6225 .91805 .61125 Metetra
.695 .588 .732 r
.91805 .61125 .92201 .6225 .92992 .6176 .92591 .60584 Metetra
.703 .587 .723 r
.92591 .60584 .92992 .6176 .93777 .6121 .93369 .59972 Metetra
.714 .587 .712 r
.93369 .59972 .93777 .6121 .94553 .60574 .94135 .59258 Metetra
.728 .587 .698 r
.94135 .59258 .94553 .60574 .95313 .5981 .94882 .58388 Metetra
.75 .591 .679 r
.94882 .58388 .95313 .5981 .96045 .58833 .95594 .57256 Metetra
.783 .6 .652 r
.95594 .57256 .96045 .58833 .96723 .5745 .96239 .55617 Metetra
.84 .619 .603 r
.96239 .55617 .96723 .5745 .97266 .55076 .96706 .52667 Metetra
.94 .658 .478 r
.96706 .52667 .97266 .55076 .97078 .47356 .96137 .42101 Metetra
.655 .676 .858 r
.38194 .78209 .38601 .78739 .39289 .78546 .38882 .78013 Metetra
.655 .676 .857 r
.38882 .78013 .39289 .78546 .39978 .78352 .39572 .77817 Metetra
.655 .675 .857 r
.39572 .77817 .39978 .78352 .40669 .78158 .40264 .7762 Metetra
.655 .675 .857 r
.40264 .7762 .40669 .78158 .41361 .77963 .40957 .77423 Metetra
.655 .674 .856 r
.40957 .77423 .41361 .77963 .42056 .77767 .41652 .77225 Metetra
.655 .674 .856 r
.41652 .77225 .42056 .77767 .42752 .7757 .42349 .77026 Metetra
.655 .673 .855 r
.42349 .77026 .42752 .7757 .4345 .77373 .43048 .76826 Metetra
.655 .673 .855 r
.43048 .76826 .4345 .77373 .44149 .77175 .43748 .76626 Metetra
.655 .672 .854 r
.43748 .76626 .44149 .77175 .44851 .76976 .4445 .76425 Metetra
.656 .672 .854 r
.4445 .76425 .44851 .76976 .45554 .76777 .45154 .76223 Metetra
.656 .671 .853 r
.45154 .76223 .45554 .76777 .46259 .76577 .4586 .7602 Metetra
.656 .671 .853 r
.4586 .7602 .46259 .76577 .46965 .76376 .46568 .75816 Metetra
.656 .67 .852 r
.46568 .75816 .46965 .76376 .47674 .76174 .47277 .75612 Metetra
.656 .67 .852 r
.47277 .75612 .47674 .76174 .48384 .75971 .47988 .75406 Metetra
.656 .669 .851 r
.47988 .75406 .48384 .75971 .49096 .75768 .48701 .752 Metetra
.656 .669 .85 r
.48701 .752 .49096 .75768 .4981 .75564 .49416 .74993 Metetra
.656 .668 .85 r
.49416 .74993 .4981 .75564 .50526 .75359 .50132 .74785 Metetra
.656 .668 .849 r
.50132 .74785 .50526 .75359 .51244 .75153 .50851 .74576 Metetra
.656 .667 .849 r
.50851 .74576 .51244 .75153 .51963 .74946 .51571 .74367 Metetra
.656 .666 .848 r
.51571 .74367 .51963 .74946 .52684 .74738 .52293 .74156 Metetra
.656 .666 .847 r
.52293 .74156 .52684 .74738 .53407 .7453 .53017 .73944 Metetra
.657 .665 .847 r
.53017 .73944 .53407 .7453 .54132 .7432 .53742 .73732 Metetra
.657 .665 .846 r
.53742 .73732 .54132 .7432 .54859 .7411 .5447 .73518 Metetra
.657 .664 .845 r
.5447 .73518 .54859 .7411 .55587 .73898 .55199 .73303 Metetra
.657 .663 .845 r
.55199 .73303 .55587 .73898 .56318 .73686 .55931 .73088 Metetra
.657 .663 .844 r
.55931 .73088 .56318 .73686 .5705 .73472 .56664 .72871 Metetra
.657 .662 .843 r
.56664 .72871 .5705 .73472 .57784 .73258 .57399 .72653 Metetra
.657 .661 .842 r
.57399 .72653 .57784 .73258 .5852 .73042 .58135 .72434 Metetra
.657 .661 .842 r
.58135 .72434 .5852 .73042 .59258 .72825 .58874 .72213 Metetra
.657 .66 .841 r
.58874 .72213 .59258 .72825 .59998 .72608 .59615 .71992 Metetra
.658 .659 .84 r
.59615 .71992 .59998 .72608 .6074 .72389 .60357 .71769 Metetra
.658 .658 .839 r
.60357 .71769 .6074 .72389 .61483 .72168 .61101 .71545 Metetra
.658 .658 .838 r
.61101 .71545 .61483 .72168 .62229 .71947 .61847 .7132 Metetra
.658 .657 .837 r
.61847 .7132 .62229 .71947 .62976 .71724 .62595 .71093 Metetra
.658 .656 .837 r
.62595 .71093 .62976 .71724 .63725 .715 .63345 .70865 Metetra
.658 .655 .836 r
.63345 .70865 .63725 .715 .64476 .71275 .64097 .70635 Metetra
.659 .654 .835 r
.64097 .70635 .64476 .71275 .65229 .71048 .6485 .70404 Metetra
.659 .654 .834 r
.6485 .70404 .65229 .71048 .65984 .7082 .65606 .70171 Metetra
.659 .653 .833 r
.65606 .70171 .65984 .7082 .6674 .7059 .66363 .69937 Metetra
.659 .652 .831 r
.66363 .69937 .6674 .7059 .67499 .70358 .67122 .697 Metetra
.66 .651 .83 r
.67122 .697 .67499 .70358 .68259 .70125 .67884 .69462 Metetra
.66 .65 .829 r
.67884 .69462 .68259 .70125 .69022 .69891 .68646 .69222 Metetra
.66 .649 .828 r
.68646 .69222 .69022 .69891 .69786 .69654 .69411 .68981 Metetra
.66 .648 .827 r
.69411 .68981 .69786 .69654 .70552 .69415 .70178 .68737 Metetra
.661 .647 .826 r
.70178 .68737 .70552 .69415 .7132 .69175 .70946 .6849 Metetra
.661 .646 .824 r
.70946 .6849 .7132 .69175 .72089 .68932 .71717 .68242 Metetra
.661 .645 .823 r
.71717 .68242 .72089 .68932 .72861 .68687 .72489 .67991 Metetra
.662 .644 .821 r
.72489 .67991 .72861 .68687 .73634 .6844 .73263 .67737 Metetra
.662 .642 .82 r
.73263 .67737 .73634 .6844 .7441 .6819 .74038 .67481 Metetra
.663 .641 .818 r
.74038 .67481 .7441 .6819 .75187 .67937 .74816 .67221 Metetra
.663 .64 .817 r
.74816 .67221 .75187 .67937 .75965 .67682 .75595 .66959 Metetra
.664 .639 .815 r
.75595 .66959 .75965 .67682 .76746 .67423 .76376 .66693 Metetra
.664 .637 .813 r
.76376 .66693 .76746 .67423 .77528 .67161 .77158 .66423 Metetra
.665 .636 .811 r
.77158 .66423 .77528 .67161 .78312 .66896 .77943 .66149 Metetra
.665 .635 .809 r
.77943 .66149 .78312 .66896 .79098 .66626 .78728 .65871 Metetra
.666 .633 .807 r
.78728 .65871 .79098 .66626 .79885 .66353 .79516 .65588 Metetra
.667 .632 .805 r
.79516 .65588 .79885 .66353 .80674 .66075 .80305 .653 Metetra
.668 .63 .803 r
.80305 .653 .80674 .66075 .81464 .65791 .81095 .65007 Metetra
.669 .629 .8 r
.81095 .65007 .81464 .65791 .82256 .65502 .81887 .64707 Metetra
.67 .627 .798 r
.81887 .64707 .82256 .65502 .83049 .65207 .8268 .64399 Metetra
.671 .625 .795 r
.8268 .64399 .83049 .65207 .83843 .64904 .83474 .64084 Metetra
.673 .624 .792 r
.83474 .64084 .83843 .64904 .84639 .64594 .84269 .6376 Metetra
.674 .622 .788 r
.84269 .6376 .84639 .64594 .85435 .64274 .85064 .63426 Metetra
.676 .62 .785 r
.85064 .63426 .85435 .64274 .86233 .63944 .85861 .6308 Metetra
.678 .618 .781 r
.85861 .6308 .86233 .63944 .87031 .63602 .86658 .6272 Metetra
.681 .616 .777 r
.86658 .6272 .87031 .63602 .87829 .63246 .87454 .62344 Metetra
.684 .614 .772 r
.87454 .62344 .87829 .63246 .88627 .62873 .88251 .61949 Metetra
.687 .613 .767 r
.88251 .61949 .88627 .62873 .89424 .6248 .89046 .61532 Metetra
.691 .611 .762 r
.89046 .61532 .89424 .6248 .9022 .62062 .8984 .61085 Metetra
.696 .609 .755 r
.8984 .61085 .9022 .62062 .91014 .61613 .90631 .60604 Metetra
.702 .607 .748 r
.90631 .60604 .91014 .61613 .91805 .61125 .91418 .60077 Metetra
.71 .606 .739 r
.91418 .60077 .91805 .61125 .92591 .60584 .92199 .5949 Metetra
.719 .605 .729 r
.92199 .5949 .92591 .60584 .93369 .59972 .92971 .58821 Metetra
.732 .606 .716 r
.92971 .58821 .93369 .59972 .94135 .59258 .93728 .58033 Metetra
.75 .607 .7 r
.93728 .58033 .94135 .59258 .94882 .58388 .94463 .57062 Metetra
.775 .612 .677 r
.94463 .57062 .94882 .58388 .95594 .57256 .95157 .5578 Metetra
.812 .621 .644 r
.95157 .5578 .95594 .57256 .96239 .55617 .95768 .53878 Metetra
.874 .64 .582 r
.95768 .53878 .96239 .55617 .96706 .52667 .96145 .50243 Metetra
.925 .65 .501 r
.96145 .50243 .96706 .52667 .96137 .42101 .95845 .41656 Metetra
.656 .683 .864 r
.37784 .77695 .38194 .78209 .38882 .78013 .38473 .77498 Metetra
.656 .683 .864 r
.38473 .77498 .38882 .78013 .39572 .77817 .39164 .77299 Metetra
.656 .683 .863 r
.39164 .77299 .39572 .77817 .40264 .7762 .39856 .771 Metetra
.656 .682 .863 r
.39856 .771 .40264 .7762 .40957 .77423 .40551 .76901 Metetra
.656 .682 .862 r
.40551 .76901 .40957 .77423 .41652 .77225 .41247 .767 Metetra
.656 .681 .862 r
.41247 .767 .41652 .77225 .42349 .77026 .41944 .76499 Metetra
.657 .681 .861 r
.41944 .76499 .42349 .77026 .43048 .76826 .42644 .76297 Metetra
.657 .68 .861 r
.42644 .76297 .43048 .76826 .43748 .76626 .43345 .76094 Metetra
.657 .68 .86 r
.43345 .76094 .43748 .76626 .4445 .76425 .44048 .75891 Metetra
.657 .68 .86 r
.44048 .75891 .4445 .76425 .45154 .76223 .44753 .75686 Metetra
.657 .679 .859 r
.44753 .75686 .45154 .76223 .4586 .7602 .4546 .75481 Metetra
.657 .679 .859 r
.4546 .75481 .4586 .7602 .46568 .75816 .46168 .75275 Metetra
.657 .678 .858 r
.46168 .75275 .46568 .75816 .47277 .75612 .46878 .75068 Metetra
.657 .678 .858 r
.46878 .75068 .47277 .75612 .47988 .75406 .4759 .7486 Metetra
.657 .677 .857 r
.4759 .7486 .47988 .75406 .48701 .752 .48304 .74652 Metetra
.657 .677 .857 r
.48304 .74652 .48701 .752 .49416 .74993 .49019 .74442 Metetra
.657 .676 .856 r
.49019 .74442 .49416 .74993 .50132 .74785 .49737 .74231 Metetra
.658 .676 .856 r
.49737 .74231 .50132 .74785 .50851 .74576 .50456 .7402 Metetra
.658 .675 .855 r
.50456 .7402 .50851 .74576 .51571 .74367 .51177 .73807 Metetra
.658 .675 .855 r
.51177 .73807 .51571 .74367 .52293 .74156 .519 .73594 Metetra
.658 .674 .854 r
.519 .73594 .52293 .74156 .53017 .73944 .52625 .73379 Metetra
.658 .673 .853 r
.52625 .73379 .53017 .73944 .53742 .73732 .53351 .73164 Metetra
.658 .673 .853 r
.53351 .73164 .53742 .73732 .5447 .73518 .5408 .72947 Metetra
.658 .672 .852 r
.5408 .72947 .5447 .73518 .55199 .73303 .5481 .72729 Metetra
.659 .672 .851 r
.5481 .72729 .55199 .73303 .55931 .73088 .55542 .7251 Metetra
.659 .671 .851 r
.55542 .7251 .55931 .73088 .56664 .72871 .56276 .7229 Metetra
.659 .67 .85 r
.56276 .7229 .56664 .72871 .57399 .72653 .57012 .72069 Metetra
.659 .67 .849 r
.57012 .72069 .57399 .72653 .58135 .72434 .57749 .71847 Metetra
.659 .669 .848 r
.57749 .71847 .58135 .72434 .58874 .72213 .58489 .71623 Metetra
.659 .668 .848 r
.58489 .71623 .58874 .72213 .59615 .71992 .5923 .71398 Metetra
.66 .668 .847 r
.5923 .71398 .59615 .71992 .60357 .71769 .59973 .71172 Metetra
.66 .667 .846 r
.59973 .71172 .60357 .71769 .61101 .71545 .60718 .70944 Metetra
.66 .666 .845 r
.60718 .70944 .61101 .71545 .61847 .7132 .61465 .70715 Metetra
.66 .666 .844 r
.61465 .70715 .61847 .7132 .62595 .71093 .62214 .70485 Metetra
.66 .665 .843 r
.62214 .70485 .62595 .71093 .63345 .70865 .62965 .70253 Metetra
.661 .664 .843 r
.62965 .70253 .63345 .70865 .64097 .70635 .63717 .70019 Metetra
.661 .663 .842 r
.63717 .70019 .64097 .70635 .6485 .70404 .64472 .69784 Metetra
.661 .663 .841 r
.64472 .69784 .6485 .70404 .65606 .70171 .65228 .69547 Metetra
.661 .662 .84 r
.65228 .69547 .65606 .70171 .66363 .69937 .65986 .69308 Metetra
.662 .661 .839 r
.65986 .69308 .66363 .69937 .67122 .697 .66746 .69067 Metetra
.662 .66 .838 r
.66746 .69067 .67122 .697 .67884 .69462 .67508 .68825 Metetra
.662 .659 .836 r
.67508 .68825 .67884 .69462 .68646 .69222 .68271 .6858 Metetra
.663 .658 .835 r
.68271 .6858 .68646 .69222 .69411 .68981 .69037 .68333 Metetra
.663 .657 .834 r
.69037 .68333 .69411 .68981 .70178 .68737 .69804 .68084 Metetra
.664 .656 .833 r
.69804 .68084 .70178 .68737 .70946 .6849 .70573 .67833 Metetra
.664 .655 .831 r
.70573 .67833 .70946 .6849 .71717 .68242 .71344 .67579 Metetra
.664 .654 .83 r
.71344 .67579 .71717 .68242 .72489 .67991 .72117 .67322 Metetra
.665 .653 .829 r
.72117 .67322 .72489 .67991 .73263 .67737 .72891 .67063 Metetra
.665 .652 .827 r
.72891 .67063 .73263 .67737 .74038 .67481 .73668 .668 Metetra
.666 .651 .826 r
.73668 .668 .74038 .67481 .74816 .67221 .74446 .66534 Metetra
.667 .65 .824 r
.74446 .66534 .74816 .67221 .75595 .66959 .75225 .66265 Metetra
.667 .649 .822 r
.75225 .66265 .75595 .66959 .76376 .66693 .76007 .65992 Metetra
.668 .648 .821 r
.76007 .65992 .76376 .66693 .77158 .66423 .7679 .65715 Metetra
.669 .646 .819 r
.7679 .65715 .77158 .66423 .77943 .66149 .77574 .65434 Metetra
.67 .645 .817 r
.77574 .65434 .77943 .66149 .78728 .65871 .7836 .65148 Metetra
.671 .644 .815 r
.7836 .65148 .78728 .65871 .79516 .65588 .79148 .64857 Metetra
.672 .642 .812 r
.79148 .64857 .79516 .65588 .80305 .653 .79937 .6456 Metetra
.673 .641 .81 r
.79937 .6456 .80305 .653 .81095 .65007 .80728 .64256 Metetra
.674 .64 .808 r
.80728 .64256 .81095 .65007 .81887 .64707 .81519 .63946 Metetra
.675 .638 .805 r
.81519 .63946 .81887 .64707 .8268 .64399 .82312 .63628 Metetra
.677 .637 .802 r
.82312 .63628 .8268 .64399 .83474 .64084 .83106 .63301 Metetra
.679 .635 .799 r
.83106 .63301 .83474 .64084 .84269 .6376 .83901 .62964 Metetra
.681 .633 .796 r
.83901 .62964 .84269 .6376 .85064 .63426 .84696 .62616 Metetra
.683 .632 .792 r
.84696 .62616 .85064 .63426 .85861 .6308 .85492 .62255 Metetra
.685 .63 .788 r
.85492 .62255 .85861 .6308 .86658 .6272 .86288 .61879 Metetra
.688 .628 .784 r
.86288 .61879 .86658 .6272 .87454 .62344 .87084 .61485 Metetra
.692 .627 .779 r
.87084 .61485 .87454 .62344 .88251 .61949 .87879 .6107 Metetra
.696 .625 .773 r
.87879 .6107 .88251 .61949 .89046 .61532 .88673 .60629 Metetra
.701 .624 .767 r
.88673 .60629 .89046 .61532 .8984 .61085 .89465 .60156 Metetra
.707 .622 .76 r
.89465 .60156 .8984 .61085 .90631 .60604 .90253 .59644 Metetra
.714 .621 .752 r
.90253 .59644 .90631 .60604 .91418 .60077 .91037 .59081 Metetra
.723 .62 .743 r
.91037 .59081 .91418 .60077 .92199 .5949 .91813 .58451 Metetra
.734 .62 .731 r
.91813 .58451 .92199 .5949 .92971 .58821 .92579 .57727 Metetra
.749 .621 .717 r
.92579 .57727 .92971 .58821 .93728 .58033 .93329 .56867 Metetra
.768 .623 .698 r
.93329 .56867 .93728 .58033 .94463 .57062 .94051 .55797 Metetra
.796 .628 .672 r
.94051 .55797 .94463 .57062 .95157 .5578 .94727 .54363 Metetra
.837 .637 .632 r
.94727 .54363 .95157 .5578 .95768 .53878 .95302 .52179 Metetra
.902 .655 .555 r
.95302 .52179 .95768 .53878 .96145 .50243 .95558 .47604 Metetra
.888 .626 .537 r
.95558 .47604 .96145 .50243 .95845 .41656 .95552 .41209 Metetra
.657 .689 .869 r
.37372 .77194 .37784 .77695 .38473 .77498 .38062 .76994 Metetra
.657 .689 .868 r
.38062 .76994 .38473 .77498 .39164 .77299 .38754 .76794 Metetra
.657 .688 .868 r
.38754 .76794 .39164 .77299 .39856 .771 .39447 .76593 Metetra
.657 .688 .867 r
.39447 .76593 .39856 .771 .40551 .76901 .40142 .76391 Metetra
.657 .688 .867 r
.40142 .76391 .40551 .76901 .41247 .767 .40839 .76189 Metetra
.657 .687 .866 r
.40839 .76189 .41247 .767 .41944 .76499 .41538 .75985 Metetra
.657 .687 .866 r
.41538 .75985 .41944 .76499 .42644 .76297 .42238 .75781 Metetra
.658 .686 .866 r
.42238 .75781 .42644 .76297 .43345 .76094 .4294 .75576 Metetra
.658 .686 .865 r
.4294 .75576 .43345 .76094 .44048 .75891 .43644 .7537 Metetra
.658 .686 .865 r
.43644 .7537 .44048 .75891 .44753 .75686 .4435 .75163 Metetra
.658 .685 .864 r
.4435 .75163 .44753 .75686 .4546 .75481 .45057 .74956 Metetra
.658 .685 .864 r
.45057 .74956 .4546 .75481 .46168 .75275 .45766 .74747 Metetra
.658 .684 .863 r
.45766 .74747 .46168 .75275 .46878 .75068 .46478 .74538 Metetra
.658 .684 .863 r
.46478 .74538 .46878 .75068 .4759 .7486 .4719 .74328 Metetra
.658 .683 .862 r
.4719 .74328 .4759 .7486 .48304 .74652 .47905 .74117 Metetra
.658 .683 .862 r
.47905 .74117 .48304 .74652 .49019 .74442 .48622 .73904 Metetra
.659 .682 .861 r
.48622 .73904 .49019 .74442 .49737 .74231 .4934 .73691 Metetra
.659 .682 .861 r
.4934 .73691 .49737 .74231 .50456 .7402 .5006 .73477 Metetra
.659 .681 .86 r
.5006 .73477 .50456 .7402 .51177 .73807 .50782 .73262 Metetra
.659 .681 .859 r
.50782 .73262 .51177 .73807 .519 .73594 .51506 .73046 Metetra
.659 .68 .859 r
.51506 .73046 .519 .73594 .52625 .73379 .52231 .72829 Metetra
.659 .68 .858 r
.52231 .72829 .52625 .73379 .53351 .73164 .52959 .7261 Metetra
.66 .679 .858 r
.52959 .7261 .53351 .73164 .5408 .72947 .53688 .72391 Metetra
.66 .679 .857 r
.53688 .72391 .5408 .72947 .5481 .72729 .54419 .7217 Metetra
.66 .678 .856 r
.54419 .7217 .5481 .72729 .55542 .7251 .55152 .71948 Metetra
.66 .678 .856 r
.55152 .71948 .55542 .7251 .56276 .7229 .55887 .71725 Metetra
.66 .677 .855 r
.55887 .71725 .56276 .7229 .57012 .72069 .56623 .71501 Metetra
.66 .676 .854 r
.56623 .71501 .57012 .72069 .57749 .71847 .57362 .71276 Metetra
.661 .676 .854 r
.57362 .71276 .57749 .71847 .58489 .71623 .58102 .71049 Metetra
.661 .675 .853 r
.58102 .71049 .58489 .71623 .5923 .71398 .58845 .70821 Metetra
.661 .675 .852 r
.58845 .70821 .5923 .71398 .59973 .71172 .59589 .70591 Metetra
.661 .674 .851 r
.59589 .70591 .59973 .71172 .60718 .70944 .60335 .7036 Metetra
.662 .673 .85 r
.60335 .7036 .60718 .70944 .61465 .70715 .61082 .70127 Metetra
.662 .673 .85 r
.61082 .70127 .61465 .70715 .62214 .70485 .61832 .69893 Metetra
.662 .672 .849 r
.61832 .69893 .62214 .70485 .62965 .70253 .62584 .69658 Metetra
.662 .671 .848 r
.62584 .69658 .62965 .70253 .63717 .70019 .63337 .6942 Metetra
.663 .67 .847 r
.63337 .6942 .63717 .70019 .64472 .69784 .64092 .69181 Metetra
.663 .67 .846 r
.64092 .69181 .64472 .69784 .65228 .69547 .64849 .6894 Metetra
.663 .669 .845 r
.64849 .6894 .65228 .69547 .65986 .69308 .65608 .68697 Metetra
.664 .668 .844 r
.65608 .68697 .65986 .69308 .66746 .69067 .66369 .68452 Metetra
.664 .667 .843 r
.66369 .68452 .66746 .69067 .67508 .68825 .67131 .68205 Metetra
.665 .666 .842 r
.67131 .68205 .67508 .68825 .68271 .6858 .67896 .67956 Metetra
.665 .666 .841 r
.67896 .67956 .68271 .6858 .69037 .68333 .68662 .67705 Metetra
.665 .665 .84 r
.68662 .67705 .69037 .68333 .69804 .68084 .6943 .67451 Metetra
.666 .664 .838 r
.6943 .67451 .69804 .68084 .70573 .67833 .702 .67195 Metetra
.666 .663 .837 r
.702 .67195 .70573 .67833 .71344 .67579 .70972 .66936 Metetra
.667 .662 .836 r
.70972 .66936 .71344 .67579 .72117 .67322 .71745 .66674 Metetra
.668 .661 .834 r
.71745 .66674 .72117 .67322 .72891 .67063 .7252 .66409 Metetra
.668 .66 .833 r
.7252 .66409 .72891 .67063 .73668 .668 .73297 .6614 Metetra
.669 .659 .831 r
.73297 .6614 .73668 .668 .74446 .66534 .74076 .65869 Metetra
.67 .658 .83 r
.74076 .65869 .74446 .66534 .75225 .66265 .74856 .65593 Metetra
.67 .657 .828 r
.74856 .65593 .75225 .66265 .76007 .65992 .75638 .65314 Metetra
.671 .656 .826 r
.75638 .65314 .76007 .65992 .7679 .65715 .76422 .6503 Metetra
.672 .655 .824 r
.76422 .6503 .7679 .65715 .77574 .65434 .77207 .64741 Metetra
.673 .653 .822 r
.77207 .64741 .77574 .65434 .7836 .65148 .77993 .64448 Metetra
.674 .652 .82 r
.77993 .64448 .7836 .65148 .79148 .64857 .78781 .64148 Metetra
.676 .651 .818 r
.78781 .64148 .79148 .64857 .79937 .6456 .79571 .63843 Metetra
.677 .65 .816 r
.79571 .63843 .79937 .6456 .80728 .64256 .80361 .63531 Metetra
.678 .648 .813 r
.80361 .63531 .80728 .64256 .81519 .63946 .81153 .63211 Metetra
.68 .647 .81 r
.81153 .63211 .81519 .63946 .82312 .63628 .81946 .62882 Metetra
.682 .646 .807 r
.81946 .62882 .82312 .63628 .83106 .63301 .8274 .62545 Metetra
.684 .644 .804 r
.8274 .62545 .83106 .63301 .83901 .62964 .83535 .62196 Metetra
.686 .643 .801 r
.83535 .62196 .83901 .62964 .84696 .62616 .8433 .61835 Metetra
.689 .641 .797 r
.8433 .61835 .84696 .62616 .85492 .62255 .85125 .6146 Metetra
.692 .64 .793 r
.85125 .6146 .85492 .62255 .86288 .61879 .85921 .61068 Metetra
.695 .638 .788 r
.85921 .61068 .86288 .61879 .87084 .61485 .86716 .60657 Metetra
.699 .637 .783 r
.86716 .60657 .87084 .61485 .87879 .6107 .8751 .60222 Metetra
.704 .636 .778 r
.8751 .60222 .87879 .6107 .88673 .60629 .88302 .59759 Metetra
.709 .634 .771 r
.88302 .59759 .88673 .60629 .89465 .60156 .89092 .59262 Metetra
.716 .633 .764 r
.89092 .59262 .89465 .60156 .90253 .59644 .89878 .5872 Metetra
.724 .632 .755 r
.89878 .5872 .90253 .59644 .91037 .59081 .90659 .58123 Metetra
.734 .632 .745 r
.90659 .58123 .91037 .59081 .91813 .58451 .91431 .57449 Metetra
.747 .632 .732 r
.91431 .57449 .91813 .58451 .92579 .57727 .92192 .56672 Metetra
.763 .633 .716 r
.92192 .56672 .92579 .57727 .93329 .56867 .92934 .55742 Metetra
.785 .635 .695 r
.92934 .55742 .93329 .56867 .94051 .55797 .93645 .54573 Metetra
.815 .64 .666 r
.93645 .54573 .94051 .55797 .94727 .54363 .94301 .5298 Metetra
.858 .649 .619 r
.94301 .5298 .94727 .54363 .95302 .52179 .94837 .50475 Metetra
.931 .667 .516 r
.94837 .50475 .95302 .52179 .95558 .47604 .94869 .44166 Metetra
.773 .545 .589 r
.94869 .44166 .95558 .47604 .95552 .41209 .95257 .40759 Metetra
.658 .694 .872 r
.36958 .76701 .37372 .77194 .38062 .76994 .37649 .765 Metetra
.658 .693 .872 r
.37649 .765 .38062 .76994 .38754 .76794 .38342 .76298 Metetra
.658 .693 .871 r
.38342 .76298 .38754 .76794 .39447 .76593 .39036 .76095 Metetra
.658 .693 .871 r
.39036 .76095 .39447 .76593 .40142 .76391 .39732 .75891 Metetra
.658 .692 .871 r
.39732 .75891 .40142 .76391 .40839 .76189 .4043 .75686 Metetra
.658 .692 .87 r
.4043 .75686 .40839 .76189 .41538 .75985 .41129 .75481 Metetra
.658 .692 .87 r
.41129 .75481 .41538 .75985 .42238 .75781 .4183 .75275 Metetra
.658 .691 .869 r
.4183 .75275 .42238 .75781 .4294 .75576 .42533 .75067 Metetra
.658 .691 .869 r
.42533 .75067 .4294 .75576 .43644 .7537 .43238 .74859 Metetra
.659 .69 .868 r
.43238 .74859 .43644 .7537 .4435 .75163 .43945 .7465 Metetra
.659 .69 .868 r
.43945 .7465 .4435 .75163 .45057 .74956 .44653 .74441 Metetra
.659 .69 .868 r
.44653 .74441 .45057 .74956 .45766 .74747 .45363 .7423 Metetra
.659 .689 .867 r
.45363 .7423 .45766 .74747 .46478 .74538 .46075 .74018 Metetra
.659 .689 .867 r
.46075 .74018 .46478 .74538 .4719 .74328 .46789 .73806 Metetra
.659 .688 .866 r
.46789 .73806 .4719 .74328 .47905 .74117 .47505 .73592 Metetra
.659 .688 .866 r
.47505 .73592 .47905 .74117 .48622 .73904 .48222 .73377 Metetra
.66 .687 .865 r
.48222 .73377 .48622 .73904 .4934 .73691 .48941 .73162 Metetra
.66 .687 .865 r
.48941 .73162 .4934 .73691 .5006 .73477 .49662 .72945 Metetra
.66 .686 .864 r
.49662 .72945 .5006 .73477 .50782 .73262 .50385 .72727 Metetra
.66 .686 .863 r
.50385 .72727 .50782 .73262 .51506 .73046 .5111 .72509 Metetra
.66 .685 .863 r
.5111 .72509 .51506 .73046 .52231 .72829 .51836 .72289 Metetra
.66 .685 .862 r
.51836 .72289 .52231 .72829 .52959 .7261 .52565 .72068 Metetra
.661 .684 .862 r
.52565 .72068 .52959 .7261 .53688 .72391 .53295 .71846 Metetra
.661 .684 .861 r
.53295 .71846 .53688 .72391 .54419 .7217 .54027 .71622 Metetra
.661 .683 .86 r
.54027 .71622 .54419 .7217 .55152 .71948 .54761 .71398 Metetra
.661 .683 .86 r
.54761 .71398 .55152 .71948 .55887 .71725 .55496 .71172 Metetra
.662 .682 .859 r
.55496 .71172 .55887 .71725 .56623 .71501 .56234 .70945 Metetra
.662 .682 .858 r
.56234 .70945 .56623 .71501 .57362 .71276 .56973 .70716 Metetra
.662 .681 .858 r
.56973 .70716 .57362 .71276 .58102 .71049 .57715 .70486 Metetra
.662 .681 .857 r
.57715 .70486 .58102 .71049 .58845 .70821 .58458 .70255 Metetra
.663 .68 .856 r
.58458 .70255 .58845 .70821 .59589 .70591 .59203 .70022 Metetra
.663 .679 .855 r
.59203 .70022 .59589 .70591 .60335 .7036 .5995 .69788 Metetra
.663 .679 .855 r
.5995 .69788 .60335 .7036 .61082 .70127 .60698 .69552 Metetra
.663 .678 .854 r
.60698 .69552 .61082 .70127 .61832 .69893 .61449 .69314 Metetra
.664 .677 .853 r
.61449 .69314 .61832 .69893 .62584 .69658 .62201 .69075 Metetra
.664 .677 .852 r
.62201 .69075 .62584 .69658 .63337 .6942 .62956 .68834 Metetra
.664 .676 .851 r
.62956 .68834 .63337 .6942 .64092 .69181 .63712 .68591 Metetra
.665 .675 .85 r
.63712 .68591 .64092 .69181 .64849 .6894 .6447 .68347 Metetra
.665 .675 .849 r
.6447 .68347 .64849 .6894 .65608 .68697 .65229 .681 Metetra
.666 .674 .848 r
.65229 .681 .65608 .68697 .66369 .68452 .65991 .67851 Metetra
.666 .673 .847 r
.65991 .67851 .66369 .68452 .67131 .68205 .66754 .676 Metetra
.667 .672 .846 r
.66754 .676 .67131 .68205 .67896 .67956 .6752 .67346 Metetra
.667 .672 .845 r
.6752 .67346 .67896 .67956 .68662 .67705 .68287 .67091 Metetra
.668 .671 .844 r
.68287 .67091 .68662 .67705 .6943 .67451 .69056 .66832 Metetra
.668 .67 .843 r
.69056 .66832 .6943 .67451 .702 .67195 .69826 .66571 Metetra
.669 .669 .841 r
.69826 .66571 .702 .67195 .70972 .66936 .70599 .66307 Metetra
.669 .668 .84 r
.70599 .66307 .70972 .66936 .71745 .66674 .71373 .6604 Metetra
.67 .667 .839 r
.71373 .6604 .71745 .66674 .7252 .66409 .72149 .6577 Metetra
.671 .666 .837 r
.72149 .6577 .7252 .66409 .73297 .6614 .72927 .65496 Metetra
.671 .666 .836 r
.72927 .65496 .73297 .6614 .74076 .65869 .73706 .65219 Metetra
.672 .665 .834 r
.73706 .65219 .74076 .65869 .74856 .65593 .74487 .64938 Metetra
.673 .664 .832 r
.74487 .64938 .74856 .65593 .75638 .65314 .75269 .64652 Metetra
.674 .662 .831 r
.75269 .64652 .75638 .65314 .76422 .6503 .76053 .64361 Metetra
.675 .661 .829 r
.76053 .64361 .76422 .6503 .77207 .64741 .76839 .64066 Metetra
.676 .66 .827 r
.76839 .64066 .77207 .64741 .77993 .64448 .77626 .63765 Metetra
.678 .659 .825 r
.77626 .63765 .77993 .64448 .78781 .64148 .78415 .63458 Metetra
.679 .658 .822 r
.78415 .63458 .78781 .64148 .79571 .63843 .79205 .63145 Metetra
.681 .657 .82 r
.79205 .63145 .79571 .63843 .80361 .63531 .79996 .62824 Metetra
.682 .656 .817 r
.79996 .62824 .80361 .63531 .81153 .63211 .80788 .62495 Metetra
.684 .654 .815 r
.80788 .62495 .81153 .63211 .81946 .62882 .81581 .62157 Metetra
.686 .653 .812 r
.81581 .62157 .81946 .62882 .8274 .62545 .82375 .61808 Metetra
.688 .652 .808 r
.82375 .61808 .8274 .62545 .83535 .62196 .8317 .61448 Metetra
.691 .651 .805 r
.8317 .61448 .83535 .62196 .8433 .61835 .83965 .61075 Metetra
.694 .649 .801 r
.83965 .61075 .8433 .61835 .85125 .6146 .8476 .60686 Metetra
.697 .648 .797 r
.8476 .60686 .85125 .6146 .85921 .61068 .85555 .60279 Metetra
.701 .647 .792 r
.85555 .60279 .85921 .61068 .86716 .60657 .86349 .59851 Metetra
.706 .645 .787 r
.86349 .59851 .86716 .60657 .8751 .60222 .87142 .59398 Metetra
.711 .644 .781 r
.87142 .59398 .8751 .60222 .88302 .59759 .87934 .58914 Metetra
.717 .643 .774 r
.87934 .58914 .88302 .59759 .89092 .59262 .88722 .58393 Metetra
.724 .642 .766 r
.88722 .58393 .89092 .59262 .89878 .5872 .89506 .57823 Metetra
.733 .642 .757 r
.89506 .57823 .89878 .5872 .90659 .58123 .90284 .57191 Metetra
.745 .641 .746 r
.90284 .57191 .90659 .58123 .91431 .57449 .91052 .56477 Metetra
.759 .642 .732 r
.91052 .56477 .91431 .57449 .92192 .56672 .91807 .55646 Metetra
.776 .643 .714 r
.91807 .55646 .92192 .56672 .92934 .55742 .92542 .54646 Metetra
.8 .646 .691 r
.92542 .54646 .92934 .55742 .93645 .54573 .93241 .53374 Metetra
.832 .65 .657 r
.93241 .53374 .93645 .54573 .94301 .5298 .93877 .51611 Metetra
.877 .659 .603 r
.93877 .51611 .94301 .5298 .94837 .50475 .94366 .48722 Metetra
.946 .671 .486 r
.94366 .48722 .94837 .50475 .94869 .44166 .94161 .40552 Metetra
.595 .426 .622 r
.94161 .40552 .94869 .44166 .95257 .40759 .94961 .40307 Metetra
.658 .698 .875 r
.36542 .76216 .36958 .76701 .37649 .765 .37234 .76013 Metetra
.658 .697 .875 r
.37234 .76013 .37649 .765 .38342 .76298 .37927 .75809 Metetra
.658 .697 .874 r
.37927 .75809 .38342 .76298 .39036 .76095 .38623 .75604 Metetra
.659 .697 .874 r
.38623 .75604 .39036 .76095 .39732 .75891 .39319 .75398 Metetra
.659 .696 .874 r
.39319 .75398 .39732 .75891 .4043 .75686 .40018 .75191 Metetra
.659 .696 .873 r
.40018 .75191 .4043 .75686 .41129 .75481 .40718 .74984 Metetra
.659 .695 .873 r
.40718 .74984 .41129 .75481 .4183 .75275 .41421 .74775 Metetra
.659 .695 .872 r
.41421 .74775 .4183 .75275 .42533 .75067 .42125 .74566 Metetra
.659 .695 .872 r
.42125 .74566 .42533 .75067 .43238 .74859 .4283 .74356 Metetra
.659 .694 .872 r
.4283 .74356 .43238 .74859 .43945 .7465 .43538 .74145 Metetra
.66 .694 .871 r
.43538 .74145 .43945 .7465 .44653 .74441 .44247 .73933 Metetra
.66 .694 .871 r
.44247 .73933 .44653 .74441 .45363 .7423 .44958 .7372 Metetra
.66 .693 .87 r
.44958 .7372 .45363 .7423 .46075 .74018 .45671 .73506 Metetra
.66 .693 .87 r
.45671 .73506 .46075 .74018 .46789 .73806 .46386 .73291 Metetra
.66 .692 .869 r
.46386 .73291 .46789 .73806 .47505 .73592 .47102 .73075 Metetra
.66 .692 .869 r
.47102 .73075 .47505 .73592 .48222 .73377 .47821 .72858 Metetra
.66 .692 .868 r
.47821 .72858 .48222 .73377 .48941 .73162 .48541 .7264 Metetra
.661 .691 .868 r
.48541 .7264 .48941 .73162 .49662 .72945 .49263 .72421 Metetra
.661 .691 .867 r
.49263 .72421 .49662 .72945 .50385 .72727 .49987 .72201 Metetra
.661 .69 .867 r
.49987 .72201 .50385 .72727 .5111 .72509 .50712 .7198 Metetra
.661 .69 .866 r
.50712 .7198 .5111 .72509 .51836 .72289 .5144 .71758 Metetra
.661 .689 .865 r
.5144 .71758 .51836 .72289 .52565 .72068 .52169 .71534 Metetra
.662 .689 .865 r
.52169 .71534 .52565 .72068 .53295 .71846 .529 .71309 Metetra
.662 .688 .864 r
.529 .71309 .53295 .71846 .54027 .71622 .53633 .71083 Metetra
.662 .688 .864 r
.53633 .71083 .54027 .71622 .54761 .71398 .54368 .70856 Metetra
.662 .687 .863 r
.54368 .70856 .54761 .71398 .55496 .71172 .55105 .70627 Metetra
.663 .687 .862 r
.55105 .70627 .55496 .71172 .56234 .70945 .55843 .70397 Metetra
.663 .686 .862 r
.55843 .70397 .56234 .70945 .56973 .70716 .56584 .70166 Metetra
.663 .686 .861 r
.56584 .70166 .56973 .70716 .57715 .70486 .57326 .69933 Metetra
.663 .685 .86 r
.57326 .69933 .57715 .70486 .58458 .70255 .5807 .69699 Metetra
.664 .685 .86 r
.5807 .69699 .58458 .70255 .59203 .70022 .58816 .69463 Metetra
.664 .684 .859 r
.58816 .69463 .59203 .70022 .5995 .69788 .59564 .69225 Metetra
.664 .683 .858 r
.59564 .69225 .5995 .69788 .60698 .69552 .60313 .68986 Metetra
.665 .683 .857 r
.60313 .68986 .60698 .69552 .61449 .69314 .61065 .68745 Metetra
.665 .682 .856 r
.61065 .68745 .61449 .69314 .62201 .69075 .61818 .68503 Metetra
.666 .682 .856 r
.61818 .68503 .62201 .69075 .62956 .68834 .62573 .68258 Metetra
.666 .681 .855 r
.62573 .68258 .62956 .68834 .63712 .68591 .6333 .68012 Metetra
.666 .68 .854 r
.6333 .68012 .63712 .68591 .6447 .68347 .64089 .67763 Metetra
.667 .68 .853 r
.64089 .67763 .6447 .68347 .65229 .681 .6485 .67513 Metetra
.667 .679 .852 r
.6485 .67513 .65229 .681 .65991 .67851 .65612 .6726 Metetra
.668 .678 .851 r
.65612 .6726 .65991 .67851 .66754 .676 .66377 .67005 Metetra
.668 .677 .85 r
.66377 .67005 .66754 .676 .6752 .67346 .67143 .66748 Metetra
.669 .677 .849 r
.67143 .66748 .6752 .67346 .68287 .67091 .67911 .66488 Metetra
.669 .676 .847 r
.67911 .66488 .68287 .67091 .69056 .66832 .6868 .66225 Metetra
.67 .675 .846 r
.6868 .66225 .69056 .66832 .69826 .66571 .69452 .65959 Metetra
.671 .674 .845 r
.69452 .65959 .69826 .66571 .70599 .66307 .70225 .65691 Metetra
.671 .674 .844 r
.70225 .65691 .70599 .66307 .71373 .6604 .71 .65419 Metetra
.672 .673 .842 r
.71 .65419 .71373 .6604 .72149 .6577 .71777 .65143 Metetra
.673 .672 .841 r
.71777 .65143 .72149 .6577 .72927 .65496 .72555 .64864 Metetra
.674 .671 .839 r
.72555 .64864 .72927 .65496 .73706 .65219 .73335 .64582 Metetra
.675 .67 .838 r
.73335 .64582 .73706 .65219 .74487 .64938 .74117 .64294 Metetra
.676 .669 .836 r
.74117 .64294 .74487 .64938 .75269 .64652 .749 .64003 Metetra
.677 .668 .834 r
.749 .64003 .75269 .64652 .76053 .64361 .75685 .63706 Metetra
.678 .667 .832 r
.75685 .63706 .76053 .64361 .76839 .64066 .76471 .63404 Metetra
.679 .666 .83 r
.76471 .63404 .76839 .64066 .77626 .63765 .77259 .63096 Metetra
.681 .665 .828 r
.77259 .63096 .77626 .63765 .78415 .63458 .78048 .62782 Metetra
.682 .664 .826 r
.78048 .62782 .78415 .63458 .79205 .63145 .78839 .62461 Metetra
.684 .663 .823 r
.78839 .62461 .79205 .63145 .79996 .62824 .7963 .62132 Metetra
.686 .662 .821 r
.7963 .62132 .79996 .62824 .80788 .62495 .80423 .61794 Metetra
.688 .661 .818 r
.80423 .61794 .80788 .62495 .81581 .62157 .81216 .61446 Metetra
.69 .66 .815 r
.81216 .61446 .81581 .62157 .82375 .61808 .8201 .61088 Metetra
.693 .658 .812 r
.8201 .61088 .82375 .61808 .8317 .61448 .82805 .60716 Metetra
.696 .657 .808 r
.82805 .60716 .8317 .61448 .83965 .61075 .836 .60331 Metetra
.699 .656 .804 r
.836 .60331 .83965 .61075 .8476 .60686 .84395 .59929 Metetra
.703 .655 .8 r
.84395 .59929 .8476 .60686 .85555 .60279 .8519 .59508 Metetra
.707 .654 .795 r
.8519 .59508 .85555 .60279 .86349 .59851 .85984 .59064 Metetra
.712 .653 .789 r
.85984 .59064 .86349 .59851 .87142 .59398 .86776 .58593 Metetra
.718 .652 .783 r
.86776 .58593 .87142 .59398 .87934 .58914 .87566 .58089 Metetra
.724 .651 .776 r
.87566 .58089 .87934 .58914 .88722 .58393 .88353 .57543 Metetra
.732 .65 .767 r
.88353 .57543 .88722 .58393 .89506 .57823 .89135 .56946 Metetra
.742 .65 .757 r
.89135 .56946 .89506 .57823 .90284 .57191 .8991 .56281 Metetra
.754 .65 .745 r
.8991 .56281 .90284 .57191 .91052 .56477 .90675 .55525 Metetra
.769 .65 .73 r
.90675 .55525 .91052 .56477 .91807 .55646 .91425 .54642 Metetra
.789 .652 .711 r
.91425 .54642 .91807 .55646 .92542 .54646 .92152 .53569 Metetra
.814 .654 .685 r
.92152 .53569 .92542 .54646 .93241 .53374 .92839 .52189 Metetra
.847 .659 .647 r
.92839 .52189 .93241 .53374 .93877 .51611 .93454 .50239 Metetra
.895 .666 .584 r
.93454 .50239 .93877 .51611 .94366 .48722 .93881 .46859 Metetra
.929 .662 .512 r
.93881 .46859 .94366 .48722 .94161 .40552 .93862 .40099 Metetra
.664 .741 .908 r
.93862 .40099 .94161 .40552 .94961 .40307 .94663 .39853 Metetra
.659 .701 .878 r
.36124 .75737 .36542 .76216 .37234 .76013 .36817 .75531 Metetra
.659 .7 .877 r
.36817 .75531 .37234 .76013 .37927 .75809 .37511 .75325 Metetra
.659 .7 .877 r
.37511 .75325 .37927 .75809 .38623 .75604 .38207 .75118 Metetra
.659 .7 .876 r
.38207 .75118 .38623 .75604 .39319 .75398 .38905 .74911 Metetra
.659 .699 .876 r
.38905 .74911 .39319 .75398 .40018 .75191 .39605 .74702 Metetra
.659 .699 .876 r
.39605 .74702 .40018 .75191 .40718 .74984 .40306 .74493 Metetra
.66 .699 .875 r
.40306 .74493 .40718 .74984 .41421 .74775 .41009 .74282 Metetra
.66 .698 .875 r
.41009 .74282 .41421 .74775 .42125 .74566 .41714 .74071 Metetra
.66 .698 .874 r
.41714 .74071 .42125 .74566 .4283 .74356 .42421 .73859 Metetra
.66 .698 .874 r
.42421 .73859 .4283 .74356 .43538 .74145 .43129 .73646 Metetra
.66 .697 .874 r
.43129 .73646 .43538 .74145 .44247 .73933 .43839 .73431 Metetra
.66 .697 .873 r
.43839 .73431 .44247 .73933 .44958 .7372 .44551 .73216 Metetra
.661 .697 .873 r
.44551 .73216 .44958 .7372 .45671 .73506 .45265 .73 Metetra
.661 .696 .872 r
.45265 .73 .45671 .73506 .46386 .73291 .45981 .72783 Metetra
.661 .696 .872 r
.45981 .72783 .46386 .73291 .47102 .73075 .46698 .72565 Metetra
.661 .695 .871 r
.46698 .72565 .47102 .73075 .47821 .72858 .47418 .72346 Metetra
.661 .695 .871 r
.47418 .72346 .47821 .72858 .48541 .7264 .48139 .72126 Metetra
.661 .695 .87 r
.48139 .72126 .48541 .7264 .49263 .72421 .48862 .71904 Metetra
.662 .694 .87 r
.48862 .71904 .49263 .72421 .49987 .72201 .49587 .71682 Metetra
.662 .694 .869 r
.49587 .71682 .49987 .72201 .50712 .7198 .50313 .71458 Metetra
.662 .693 .869 r
.50313 .71458 .50712 .7198 .5144 .71758 .51042 .71233 Metetra
.662 .693 .868 r
.51042 .71233 .5144 .71758 .52169 .71534 .51772 .71007 Metetra
.663 .692 .868 r
.51772 .71007 .52169 .71534 .529 .71309 .52504 .7078 Metetra
.663 .692 .867 r
.52504 .7078 .529 .71309 .53633 .71083 .53238 .70551 Metetra
.663 .692 .866 r
.53238 .70551 .53633 .71083 .54368 .70856 .53974 .70321 Metetra
.663 .691 .866 r
.53974 .70321 .54368 .70856 .55105 .70627 .54711 .7009 Metetra
.664 .691 .865 r
.54711 .7009 .55105 .70627 .55843 .70397 .55451 .69857 Metetra
.664 .69 .864 r
.55451 .69857 .55843 .70397 .56584 .70166 .56192 .69623 Metetra
.664 .69 .864 r
.56192 .69623 .56584 .70166 .57326 .69933 .56935 .69387 Metetra
.665 .689 .863 r
.56935 .69387 .57326 .69933 .5807 .69699 .5768 .6915 Metetra
.665 .689 .862 r
.5768 .6915 .5807 .69699 .58816 .69463 .58427 .68911 Metetra
.665 .688 .862 r
.58427 .68911 .58816 .69463 .59564 .69225 .59176 .6867 Metetra
.666 .687 .861 r
.59176 .6867 .59564 .69225 .60313 .68986 .59927 .68428 Metetra
.666 .687 .86 r
.59927 .68428 .60313 .68986 .61065 .68745 .60679 .68184 Metetra
.666 .686 .859 r
.60679 .68184 .61065 .68745 .61818 .68503 .61433 .67938 Metetra
.667 .686 .858 r
.61433 .67938 .61818 .68503 .62573 .68258 .6219 .6769 Metetra
.667 .685 .857 r
.6219 .6769 .62573 .68258 .6333 .68012 .62948 .6744 Metetra
.668 .684 .857 r
.62948 .6744 .6333 .68012 .64089 .67763 .63707 .67188 Metetra
.668 .684 .856 r
.63707 .67188 .64089 .67763 .6485 .67513 .64469 .66934 Metetra
.669 .683 .855 r
.64469 .66934 .6485 .67513 .65612 .6726 .65232 .66678 Metetra
.669 .682 .854 r
.65232 .66678 .65612 .6726 .66377 .67005 .65998 .66419 Metetra
.67 .682 .853 r
.65998 .66419 .66377 .67005 .67143 .66748 .66765 .66157 Metetra
.67 .681 .851 r
.66765 .66157 .67143 .66748 .67911 .66488 .67534 .65893 Metetra
.671 .68 .85 r
.67534 .65893 .67911 .66488 .6868 .66225 .68304 .65626 Metetra
.672 .68 .849 r
.68304 .65626 .6868 .66225 .69452 .65959 .69077 .65356 Metetra
.672 .679 .848 r
.69077 .65356 .69452 .65959 .70225 .65691 .69851 .65083 Metetra
.673 .678 .846 r
.69851 .65083 .70225 .65691 .71 .65419 .70627 .64806 Metetra
.674 .677 .845 r
.70627 .64806 .71 .65419 .71777 .65143 .71404 .64526 Metetra
.675 .677 .844 r
.71404 .64526 .71777 .65143 .72555 .64864 .72183 .64242 Metetra
.676 .676 .842 r
.72183 .64242 .72555 .64864 .73335 .64582 .72964 .63954 Metetra
.677 .675 .84 r
.72964 .63954 .73335 .64582 .74117 .64294 .73747 .63661 Metetra
.678 .674 .839 r
.73747 .63661 .74117 .64294 .749 .64003 .74531 .63364 Metetra
.679 .673 .837 r
.74531 .63364 .749 .64003 .75685 .63706 .75316 .63061 Metetra
.681 .672 .835 r
.75316 .63061 .75685 .63706 .76471 .63404 .76103 .62753 Metetra
.682 .671 .833 r
.76103 .62753 .76471 .63404 .77259 .63096 .76892 .62438 Metetra
.684 .67 .831 r
.76892 .62438 .77259 .63096 .78048 .62782 .77681 .62117 Metetra
.685 .669 .829 r
.77681 .62117 .78048 .62782 .78839 .62461 .78472 .61788 Metetra
.687 .668 .826 r
.78472 .61788 .78839 .62461 .7963 .62132 .79264 .61451 Metetra
.689 .667 .823 r
.79264 .61451 .7963 .62132 .80423 .61794 .80057 .61105 Metetra
.691 .666 .821 r
.80057 .61105 .80423 .61794 .81216 .61446 .80851 .60748 Metetra
.694 .665 .817 r
.80851 .60748 .81216 .61446 .8201 .61088 .81646 .60379 Metetra
.697 .664 .814 r
.81646 .60379 .8201 .61088 .82805 .60716 .82441 .59998 Metetra
.7 .663 .81 r
.82441 .59998 .82805 .60716 .836 .60331 .83236 .59601 Metetra
.703 .662 .806 r
.83236 .59601 .836 .60331 .84395 .59929 .84031 .59186 Metetra
.707 .661 .802 r
.84031 .59186 .84395 .59929 .8519 .59508 .84825 .58751 Metetra
.712 .66 .797 r
.84825 .58751 .8519 .59508 .85984 .59064 .85619 .58291 Metetra
.717 .659 .791 r
.85619 .58291 .85984 .59064 .86776 .58593 .8641 .57802 Metetra
.724 .658 .784 r
.8641 .57802 .86776 .58593 .87566 .58089 .87199 .57278 Metetra
.731 .657 .777 r
.87199 .57278 .87566 .58089 .88353 .57543 .87985 .56709 Metetra
.74 .657 .768 r
.87985 .56709 .88353 .57543 .89135 .56946 .88765 .56084 Metetra
.75 .657 .757 r
.88765 .56084 .89135 .56946 .8991 .56281 .89537 .55386 Metetra
.763 .657 .744 r
.89537 .55386 .8991 .56281 .90675 .55525 .90299 .54589 Metetra
.78 .658 .728 r
.90299 .54589 .90675 .55525 .91425 .54642 .91044 .53652 Metetra
.8 .659 .707 r
.91044 .53652 .91425 .54642 .92152 .53569 .91763 .52504 Metetra
.826 .662 .678 r
.91763 .52504 .92152 .53569 .92839 .52189 .92438 .51011 Metetra
.862 .665 .636 r
.92438 .51011 .92839 .52189 .93454 .50239 .93027 .48847 Metetra
.913 .672 .56 r
.93027 .48847 .93454 .50239 .93881 .46859 .93368 .44758 Metetra
.891 .638 .549 r
.93368 .44758 .93881 .46859 .93862 .40099 .93561 .39644 Metetra
.664 .741 .908 r
.93561 .39644 .93862 .40099 .94663 .39853 .94364 .39397 Metetra
.659 .704 .88 r
.35704 .75261 .36124 .75737 .36817 .75531 .36398 .75054 Metetra
.659 .703 .879 r
.36398 .75054 .36817 .75531 .37511 .75325 .37093 .74846 Metetra
.66 .703 .879 r
.37093 .74846 .37511 .75325 .38207 .75118 .3779 .74638 Metetra
.66 .703 .879 r
.3779 .74638 .38207 .75118 .38905 .74911 .38489 .74428 Metetra
.66 .702 .878 r
.38489 .74428 .38905 .74911 .39605 .74702 .39189 .74217 Metetra
.66 .702 .878 r
.39189 .74217 .39605 .74702 .40306 .74493 .39892 .74006 Metetra
.66 .702 .877 r
.39892 .74006 .40306 .74493 .41009 .74282 .40596 .73794 Metetra
.66 .701 .877 r
.40596 .73794 .41009 .74282 .41714 .74071 .41302 .7358 Metetra
.66 .701 .877 r
.41302 .7358 .41714 .74071 .42421 .73859 .42009 .73366 Metetra
.661 .701 .876 r
.42009 .73366 .42421 .73859 .43129 .73646 .42719 .73151 Metetra
.661 .7 .876 r
.42719 .73151 .43129 .73646 .43839 .73431 .4343 .72935 Metetra
.661 .7 .875 r
.4343 .72935 .43839 .73431 .44551 .73216 .44143 .72718 Metetra
.661 .7 .875 r
.44143 .72718 .44551 .73216 .45265 .73 .44858 .72499 Metetra
.661 .699 .874 r
.44858 .72499 .45265 .73 .45981 .72783 .45574 .7228 Metetra
.662 .699 .874 r
.45574 .7228 .45981 .72783 .46698 .72565 .46293 .7206 Metetra
.662 .699 .874 r
.46293 .7206 .46698 .72565 .47418 .72346 .47013 .71838 Metetra
.662 .698 .873 r
.47013 .71838 .47418 .72346 .48139 .72126 .47735 .71616 Metetra
.662 .698 .873 r
.47735 .71616 .48139 .72126 .48862 .71904 .48459 .71392 Metetra
.662 .697 .872 r
.48459 .71392 .48862 .71904 .49587 .71682 .49185 .71167 Metetra
.663 .697 .871 r
.49185 .71167 .49587 .71682 .50313 .71458 .49912 .70941 Metetra
.663 .697 .871 r
.49912 .70941 .50313 .71458 .51042 .71233 .50642 .70714 Metetra
.663 .696 .87 r
.50642 .70714 .51042 .71233 .51772 .71007 .51373 .70485 Metetra
.663 .696 .87 r
.51373 .70485 .51772 .71007 .52504 .7078 .52106 .70255 Metetra
.664 .695 .869 r
.52106 .70255 .52504 .7078 .53238 .70551 .52841 .70024 Metetra
.664 .695 .869 r
.52841 .70024 .53238 .70551 .53974 .70321 .53578 .69792 Metetra
.664 .694 .868 r
.53578 .69792 .53974 .70321 .54711 .7009 .54317 .69558 Metetra
.665 .694 .867 r
.54317 .69558 .54711 .7009 .55451 .69857 .55057 .69322 Metetra
.665 .693 .867 r
.55057 .69322 .55451 .69857 .56192 .69623 .55799 .69085 Metetra
.665 .693 .866 r
.55799 .69085 .56192 .69623 .56935 .69387 .56544 .68847 Metetra
.666 .692 .865 r
.56544 .68847 .56935 .69387 .5768 .6915 .5729 .68606 Metetra
.666 .692 .865 r
.5729 .68606 .5768 .6915 .58427 .68911 .58037 .68365 Metetra
.666 .691 .864 r
.58037 .68365 .58427 .68911 .59176 .6867 .58787 .68121 Metetra
.667 .691 .863 r
.58787 .68121 .59176 .6867 .59927 .68428 .59539 .67876 Metetra
.667 .69 .862 r
.59539 .67876 .59927 .68428 .60679 .68184 .60292 .67629 Metetra
.668 .69 .862 r
.60292 .67629 .60679 .68184 .61433 .67938 .61047 .6738 Metetra
.668 .689 .861 r
.61047 .6738 .61433 .67938 .6219 .6769 .61805 .67129 Metetra
.668 .689 .86 r
.61805 .67129 .6219 .6769 .62948 .6744 .62564 .66875 Metetra
.669 .688 .859 r
.62564 .66875 .62948 .6744 .63707 .67188 .63324 .6662 Metetra
.67 .687 .858 r
.63324 .6662 .63707 .67188 .64469 .66934 .64087 .66362 Metetra
.67 .687 .857 r
.64087 .66362 .64469 .66934 .65232 .66678 .64851 .66102 Metetra
.671 .686 .856 r
.64851 .66102 .65232 .66678 .65998 .66419 .65618 .65839 Metetra
.671 .686 .855 r
.65618 .65839 .65998 .66419 .66765 .66157 .66386 .65574 Metetra
.672 .685 .854 r
.66386 .65574 .66765 .66157 .67534 .65893 .67155 .65306 Metetra
.673 .684 .853 r
.67155 .65306 .67534 .65893 .68304 .65626 .67927 .65035 Metetra
.673 .684 .851 r
.67927 .65035 .68304 .65626 .69077 .65356 .687 .64761 Metetra
.674 .683 .85 r
.687 .64761 .69077 .65356 .69851 .65083 .69475 .64483 Metetra
.675 .682 .849 r
.69475 .64483 .69851 .65083 .70627 .64806 .70252 .64202 Metetra
.676 .681 .847 r
.70252 .64202 .70627 .64806 .71404 .64526 .71031 .63917 Metetra
.677 .681 .846 r
.71031 .63917 .71404 .64526 .72183 .64242 .71811 .63628 Metetra
.678 .68 .845 r
.71811 .63628 .72183 .64242 .72964 .63954 .72592 .63335 Metetra
.679 .679 .843 r
.72592 .63335 .72964 .63954 .73747 .63661 .73376 .63037 Metetra
.68 .678 .841 r
.73376 .63037 .73747 .63661 .74531 .63364 .7416 .62733 Metetra
.682 .677 .839 r
.7416 .62733 .74531 .63364 .75316 .63061 .74947 .62425 Metetra
.683 .676 .837 r
.74947 .62425 .75316 .63061 .76103 .62753 .75734 .6211 Metetra
.685 .676 .835 r
.75734 .6211 .76103 .62753 .76892 .62438 .76524 .61789 Metetra
.686 .675 .833 r
.76524 .61789 .76892 .62438 .77681 .62117 .77314 .61461 Metetra
.688 .674 .831 r
.77314 .61461 .77681 .62117 .78472 .61788 .78105 .61125 Metetra
.69 .673 .828 r
.78105 .61125 .78472 .61788 .79264 .61451 .78898 .6078 Metetra
.692 .672 .826 r
.78898 .6078 .79264 .61451 .80057 .61105 .79691 .60425 Metetra
.695 .671 .823 r
.79691 .60425 .80057 .61105 .80851 .60748 .80486 .60059 Metetra
.697 .67 .82 r
.80486 .60059 .80851 .60748 .81646 .60379 .81281 .59681 Metetra
.7 .669 .816 r
.81281 .59681 .81646 .60379 .82441 .59998 .82076 .59289 Metetra
.704 .668 .812 r
.82076 .59289 .82441 .59998 .83236 .59601 .82871 .58881 Metetra
.708 .667 .808 r
.82871 .58881 .83236 .59601 .84031 .59186 .83666 .58454 Metetra
.712 .666 .803 r
.83666 .58454 .84031 .59186 .84825 .58751 .84461 .58005 Metetra
.717 .665 .798 r
.84461 .58005 .84825 .58751 .85619 .58291 .85254 .5753 Metetra
.723 .665 .792 r
.85254 .5753 .85619 .58291 .8641 .57802 .86045 .57024 Metetra
.73 .664 .785 r
.86045 .57024 .8641 .57802 .87199 .57278 .86833 .56479 Metetra
.737 .663 .777 r
.86833 .56479 .87199 .57278 .87985 .56709 .87617 .55887 Metetra
.747 .663 .768 r
.87617 .55887 .87985 .56709 .88765 .56084 .88396 .55235 Metetra
.758 .663 .756 r
.88396 .55235 .88765 .56084 .89537 .55386 .89166 .54504 Metetra
.772 .663 .743 r
.89166 .54504 .89537 .55386 .90299 .54589 .89923 .53665 Metetra
.789 .664 .725 r
.89923 .53665 .90299 .54589 .91044 .53652 .90663 .52672 Metetra
.811 .665 .702 r
.90663 .52672 .91044 .53652 .91763 .52504 .91374 .51447 Metetra
.838 .668 .671 r
.91374 .51447 .91763 .52504 .92438 .51011 .92036 .49829 Metetra
.875 .671 .623 r
.92036 .49829 .92438 .51011 .93027 .48847 .92596 .47416 Metetra
.935 .678 .524 r
.92596 .47416 .93027 .48847 .93368 .44758 .92771 .41966 Metetra
.775 .555 .601 r
.92771 .41966 .93368 .44758 .93561 .39644 .93259 .39187 Metetra
.664 .741 .908 r
.93259 .39187 .93561 .39644 .94364 .39397 .94064 .38938 Metetra
.66 .706 .881 r
.35282 .7479 .35704 .75261 .36398 .75054 .35977 .74581 Metetra
.66 .706 .881 r
.35977 .74581 .36398 .75054 .37093 .74846 .36673 .74371 Metetra
.66 .705 .881 r
.36673 .74371 .37093 .74846 .3779 .74638 .37371 .74161 Metetra
.66 .705 .88 r
.37371 .74161 .3779 .74638 .38489 .74428 .38071 .73949 Metetra
.66 .705 .88 r
.38071 .73949 .38489 .74428 .39189 .74217 .38772 .73737 Metetra
.661 .705 .88 r
.38772 .73737 .39189 .74217 .39892 .74006 .39475 .73523 Metetra
.661 .704 .879 r
.39475 .73523 .39892 .74006 .40596 .73794 .4018 .73309 Metetra
.661 .704 .879 r
.4018 .73309 .40596 .73794 .41302 .7358 .40887 .73094 Metetra
.661 .704 .878 r
.40887 .73094 .41302 .7358 .42009 .73366 .41596 .72877 Metetra
.661 .703 .878 r
.41596 .72877 .42009 .73366 .42719 .73151 .42306 .7266 Metetra
.661 .703 .878 r
.42306 .7266 .42719 .73151 .4343 .72935 .43018 .72442 Metetra
.662 .703 .877 r
.43018 .72442 .4343 .72935 .44143 .72718 .43732 .72223 Metetra
.662 .702 .877 r
.43732 .72223 .44143 .72718 .44858 .72499 .44448 .72002 Metetra
.662 .702 .876 r
.44448 .72002 .44858 .72499 .45574 .7228 .45166 .71781 Metetra
.662 .702 .876 r
.45166 .71781 .45574 .7228 .46293 .7206 .45885 .71559 Metetra
.662 .701 .875 r
.45885 .71559 .46293 .7206 .47013 .71838 .46607 .71335 Metetra
.663 .701 .875 r
.46607 .71335 .47013 .71838 .47735 .71616 .4733 .7111 Metetra
.663 .7 .874 r
.4733 .7111 .47735 .71616 .48459 .71392 .48055 .70884 Metetra
.663 .7 .874 r
.48055 .70884 .48459 .71392 .49185 .71167 .48781 .70657 Metetra
.663 .7 .873 r
.48781 .70657 .49185 .71167 .49912 .70941 .4951 .70429 Metetra
.664 .699 .873 r
.4951 .70429 .49912 .70941 .50642 .70714 .5024 .70199 Metetra
.664 .699 .872 r
.5024 .70199 .50642 .70714 .51373 .70485 .50973 .69968 Metetra
.664 .698 .872 r
.50973 .69968 .51373 .70485 .52106 .70255 .51707 .69736 Metetra
.665 .698 .871 r
.51707 .69736 .52106 .70255 .52841 .70024 .52443 .69502 Metetra
.665 .698 .871 r
.52443 .69502 .52841 .70024 .53578 .69792 .5318 .69267 Metetra
.665 .697 .87 r
.5318 .69267 .53578 .69792 .54317 .69558 .5392 .6903 Metetra
.665 .697 .869 r
.5392 .6903 .54317 .69558 .55057 .69322 .54662 .68792 Metetra
.666 .696 .869 r
.54662 .68792 .55057 .69322 .55799 .69085 .55405 .68552 Metetra
.666 .696 .868 r
.55405 .68552 .55799 .69085 .56544 .68847 .5615 .68311 Metetra
.667 .695 .867 r
.5615 .68311 .56544 .68847 .5729 .68606 .56897 .68068 Metetra
.667 .695 .867 r
.56897 .68068 .5729 .68606 .58037 .68365 .57646 .67824 Metetra
.667 .694 .866 r
.57646 .67824 .58037 .68365 .58787 .68121 .58397 .67577 Metetra
.668 .694 .865 r
.58397 .67577 .58787 .68121 .59539 .67876 .59149 .67329 Metetra
.668 .693 .864 r
.59149 .67329 .59539 .67876 .60292 .67629 .59904 .67079 Metetra
.669 .693 .864 r
.59904 .67079 .60292 .67629 .61047 .6738 .6066 .66826 Metetra
.669 .692 .863 r
.6066 .66826 .61047 .6738 .61805 .67129 .61418 .66572 Metetra
.67 .692 .862 r
.61418 .66572 .61805 .67129 .62564 .66875 .62178 .66316 Metetra
.67 .691 .861 r
.62178 .66316 .62564 .66875 .63324 .6662 .6294 .66057 Metetra
.671 .691 .86 r
.6294 .66057 .63324 .6662 .64087 .66362 .63704 .65796 Metetra
.671 .69 .859 r
.63704 .65796 .64087 .66362 .64851 .66102 .64469 .65532 Metetra
.672 .689 .858 r
.64469 .65532 .64851 .66102 .65618 .65839 .65236 .65266 Metetra
.673 .689 .857 r
.65236 .65266 .65618 .65839 .66386 .65574 .66005 .64996 Metetra
.673 .688 .856 r
.66005 .64996 .66386 .65574 .67155 .65306 .66776 .64724 Metetra
.674 .688 .855 r
.66776 .64724 .67155 .65306 .67927 .65035 .67549 .64449 Metetra
.675 .687 .854 r
.67549 .64449 .67927 .65035 .687 .64761 .68323 .64171 Metetra
.676 .686 .852 r
.68323 .64171 .687 .64761 .69475 .64483 .69099 .63889 Metetra
.677 .686 .851 r
.69099 .63889 .69475 .64483 .70252 .64202 .69877 .63603 Metetra
.678 .685 .85 r
.69877 .63603 .70252 .64202 .71031 .63917 .70656 .63314 Metetra
.679 .684 .848 r
.70656 .63314 .71031 .63917 .71811 .63628 .71437 .6302 Metetra
.68 .683 .847 r
.71437 .6302 .71811 .63628 .72592 .63335 .72219 .62722 Metetra
.681 .683 .845 r
.72219 .62722 .72592 .63335 .73376 .63037 .73004 .62418 Metetra
.682 .682 .843 r
.73004 .62418 .73376 .63037 .7416 .62733 .73789 .6211 Metetra
.684 .681 .841 r
.73789 .6211 .7416 .62733 .74947 .62425 .74576 .61795 Metetra
.685 .68 .839 r
.74576 .61795 .74947 .62425 .75734 .6211 .75365 .61475 Metetra
.687 .68 .837 r
.75365 .61475 .75734 .6211 .76524 .61789 .76155 .61147 Metetra
.689 .679 .835 r
.76155 .61147 .76524 .61789 .77314 .61461 .76946 .60812 Metetra
.691 .678 .833 r
.76946 .60812 .77314 .61461 .78105 .61125 .77738 .60469 Metetra
.693 .677 .83 r
.77738 .60469 .78105 .61125 .78898 .6078 .78531 .60116 Metetra
.695 .676 .827 r
.78531 .60116 .78898 .6078 .79691 .60425 .79325 .59753 Metetra
.698 .675 .824 r
.79325 .59753 .79691 .60425 .80486 .60059 .8012 .59379 Metetra
.701 .674 .821 r
.8012 .59379 .80486 .60059 .81281 .59681 .80915 .58991 Metetra
.704 .674 .818 r
.80915 .58991 .81281 .59681 .82076 .59289 .81711 .58589 Metetra
.708 .673 .814 r
.81711 .58589 .82076 .59289 .82871 .58881 .82506 .5817 Metetra
.712 .672 .809 r
.82506 .5817 .82871 .58881 .83666 .58454 .83302 .5773 Metetra
.716 .671 .804 r
.83302 .5773 .83666 .58454 .84461 .58005 .84096 .57268 Metetra
.722 .67 .799 r
.84096 .57268 .84461 .58005 .85254 .5753 .84889 .56777 Metetra
.728 .67 .793 r
.84889 .56777 .85254 .5753 .86045 .57024 .85679 .56254 Metetra
.735 .669 .785 r
.85679 .56254 .86045 .57024 .86833 .56479 .86467 .5569 Metetra
.744 .669 .777 r
.86467 .5569 .86833 .56479 .87617 .55887 .8725 .55075 Metetra
.754 .668 .767 r
.8725 .55075 .87617 .55887 .88396 .55235 .88027 .54395 Metetra
.766 .668 .755 r
.88027 .54395 .88396 .55235 .89166 .54504 .88794 .5363 Metetra
.78 .669 .74 r
.88794 .5363 .89166 .54504 .89923 .53665 .89548 .52749 Metetra
.798 .669 .722 r
.89548 .52749 .89923 .53665 .90663 .52672 .90283 .517 Metetra
.821 .671 .697 r
.90283 .517 .90663 .52672 .91374 .51447 .90986 .50392 Metetra
.85 .673 .662 r
.90986 .50392 .91374 .51447 .92036 .49829 .91633 .48638 Metetra
.889 .675 .608 r
.91633 .48638 .92036 .49829 .92596 .47416 .92157 .45916 Metetra
.947 .679 .496 r
.92157 .45916 .92596 .47416 .92771 .41966 .92151 .38976 Metetra
.598 .437 .634 r
.92151 .38976 .92771 .41966 .93259 .39187 .92955 .38727 Metetra
.664 .741 .908 r
.92955 .38727 .93259 .39187 .94064 .38938 .93762 .38477 Metetra
.66 .708 .883 r
.34858 .74321 .35282 .7479 .35977 .74581 .35554 .7411 Metetra
.66 .708 .883 r
.35554 .7411 .35977 .74581 .36673 .74371 .36251 .73899 Metetra
.661 .708 .882 r
.36251 .73899 .36673 .74371 .37371 .74161 .3695 .73686 Metetra
.661 .707 .882 r
.3695 .73686 .37371 .74161 .38071 .73949 .3765 .73473 Metetra
.661 .707 .882 r
.3765 .73473 .38071 .73949 .38772 .73737 .38353 .73259 Metetra
.661 .707 .881 r
.38353 .73259 .38772 .73737 .39475 .73523 .39057 .73043 Metetra
.661 .706 .881 r
.39057 .73043 .39475 .73523 .4018 .73309 .39763 .72827 Metetra
.661 .706 .88 r
.39763 .72827 .4018 .73309 .40887 .73094 .40471 .7261 Metetra
.662 .706 .88 r
.40471 .7261 .40887 .73094 .41596 .72877 .41181 .72392 Metetra
.662 .706 .88 r
.41181 .72392 .41596 .72877 .42306 .7266 .41892 .72173 Metetra
.662 .705 .879 r
.41892 .72173 .42306 .7266 .43018 .72442 .42605 .71952 Metetra
.662 .705 .879 r
.42605 .71952 .43018 .72442 .43732 .72223 .4332 .71731 Metetra
.662 .705 .878 r
.4332 .71731 .43732 .72223 .44448 .72002 .44037 .71509 Metetra
.663 .704 .878 r
.44037 .71509 .44448 .72002 .45166 .71781 .44756 .71285 Metetra
.663 .704 .878 r
.44756 .71285 .45166 .71781 .45885 .71559 .45476 .71061 Metetra
.663 .704 .877 r
.45476 .71061 .45885 .71559 .46607 .71335 .46198 .70835 Metetra
.663 .703 .877 r
.46198 .70835 .46607 .71335 .4733 .7111 .46922 .70608 Metetra
.664 .703 .876 r
.46922 .70608 .4733 .7111 .48055 .70884 .47648 .7038 Metetra
.664 .702 .876 r
.47648 .7038 .48055 .70884 .48781 .70657 .48376 .7015 Metetra
.664 .702 .875 r
.48376 .7015 .48781 .70657 .4951 .70429 .49106 .69919 Metetra
.664 .702 .875 r
.49106 .69919 .4951 .70429 .5024 .70199 .49837 .69687 Metetra
.665 .701 .874 r
.49837 .69687 .5024 .70199 .50973 .69968 .5057 .69454 Metetra
.665 .701 .873 r
.5057 .69454 .50973 .69968 .51707 .69736 .51306 .69219 Metetra
.665 .701 .873 r
.51306 .69219 .51707 .69736 .52443 .69502 .52043 .68983 Metetra
.666 .7 .872 r
.52043 .68983 .52443 .69502 .5318 .69267 .52781 .68746 Metetra
.666 .7 .872 r
.52781 .68746 .5318 .69267 .5392 .6903 .53522 .68506 Metetra
.666 .699 .871 r
.53522 .68506 .5392 .6903 .54662 .68792 .54265 .68266 Metetra
.667 .699 .87 r
.54265 .68266 .54662 .68792 .55405 .68552 .55009 .68023 Metetra
.667 .698 .87 r
.55009 .68023 .55405 .68552 .5615 .68311 .55755 .6778 Metetra
.667 .698 .869 r
.55755 .6778 .5615 .68311 .56897 .68068 .56503 .67534 Metetra
.668 .698 .868 r
.56503 .67534 .56897 .68068 .57646 .67824 .57253 .67286 Metetra
.668 .697 .868 r
.57253 .67286 .57646 .67824 .58397 .67577 .58005 .67037 Metetra
.669 .697 .867 r
.58005 .67037 .58397 .67577 .59149 .67329 .58759 .66786 Metetra
.669 .696 .866 r
.58759 .66786 .59149 .67329 .59904 .67079 .59514 .66533 Metetra
.67 .696 .865 r
.59514 .66533 .59904 .67079 .6066 .66826 .60271 .66277 Metetra
.67 .695 .864 r
.60271 .66277 .6066 .66826 .61418 .66572 .61031 .6602 Metetra
.671 .695 .864 r
.61031 .6602 .61418 .66572 .62178 .66316 .61792 .6576 Metetra
.671 .694 .863 r
.61792 .6576 .62178 .66316 .6294 .66057 .62554 .65498 Metetra
.672 .693 .862 r
.62554 .65498 .6294 .66057 .63704 .65796 .63319 .65233 Metetra
.673 .693 .861 r
.63319 .65233 .63704 .65796 .64469 .65532 .64085 .64966 Metetra
.673 .692 .86 r
.64085 .64966 .64469 .65532 .65236 .65266 .64854 .64696 Metetra
.674 .692 .859 r
.64854 .64696 .65236 .65266 .66005 .64996 .65624 .64423 Metetra
.675 .691 .858 r
.65624 .64423 .66005 .64996 .66776 .64724 .66396 .64148 Metetra
.676 .691 .856 r
.66396 .64148 .66776 .64724 .67549 .64449 .67169 .63869 Metetra
.676 .69 .855 r
.67169 .63869 .67549 .64449 .68323 .64171 .67944 .63586 Metetra
.677 .689 .854 r
.67944 .63586 .68323 .64171 .69099 .63889 .68721 .633 Metetra
.678 .689 .853 r
.68721 .633 .69099 .63889 .69877 .63603 .695 .6301 Metetra
.679 .688 .851 r
.695 .6301 .69877 .63603 .70656 .63314 .7028 .62716 Metetra
.68 .687 .85 r
.7028 .62716 .70656 .63314 .71437 .6302 .71062 .62417 Metetra
.682 .687 .848 r
.71062 .62417 .71437 .6302 .72219 .62722 .71846 .62114 Metetra
.683 .686 .847 r
.71846 .62114 .72219 .62722 .73004 .62418 .72631 .61805 Metetra
.684 .685 .845 r
.72631 .61805 .73004 .62418 .73789 .6211 .73417 .61491 Metetra
.686 .685 .843 r
.73417 .61491 .73789 .6211 .74576 .61795 .74205 .61171 Metetra
.687 .684 .841 r
.74205 .61171 .74576 .61795 .75365 .61475 .74994 .60845 Metetra
.689 .683 .839 r
.74994 .60845 .75365 .61475 .76155 .61147 .75785 .60511 Metetra
.691 .682 .837 r
.75785 .60511 .76155 .61147 .76946 .60812 .76577 .60169 Metetra
.693 .681 .834 r
.76577 .60169 .76946 .60812 .77738 .60469 .7737 .59819 Metetra
.695 .681 .832 r
.7737 .59819 .77738 .60469 .78531 .60116 .78164 .59459 Metetra
.698 .68 .829 r
.78164 .59459 .78531 .60116 .79325 .59753 .78958 .59088 Metetra
.701 .679 .826 r
.78958 .59088 .79325 .59753 .8012 .59379 .79754 .58705 Metetra
.704 .678 .822 r
.79754 .58705 .8012 .59379 .80915 .58991 .80549 .58308 Metetra
.707 .677 .819 r
.80549 .58308 .80915 .58991 .81711 .58589 .81345 .57896 Metetra
.711 .677 .815 r
.81345 .57896 .81711 .58589 .82506 .5817 .82141 .57465 Metetra
.716 .676 .81 r
.82141 .57465 .82506 .5817 .83302 .5773 .82936 .57014 Metetra
.721 .675 .805 r
.82936 .57014 .83302 .5773 .84096 .57268 .83731 .56538 Metetra
.726 .675 .799 r
.83731 .56538 .84096 .57268 .84889 .56777 .84523 .56033 Metetra
.733 .674 .793 r
.84523 .56033 .84889 .56777 .85679 .56254 .85314 .55492 Metetra
.74 .674 .785 r
.85314 .55492 .85679 .56254 .86467 .5569 .86101 .54908 Metetra
.749 .673 .777 r
.86101 .54908 .86467 .5569 .8725 .55075 .86882 .5427 Metetra
.76 .673 .766 r
.86882 .5427 .8725 .55075 .88027 .54395 .87657 .53563 Metetra
.773 .673 .753 r
.87657 .53563 .88027 .54395 .88794 .5363 .88423 .52764 Metetra
.788 .674 .738 r
.88423 .52764 .88794 .5363 .89548 .52749 .89173 .51839 Metetra
.807 .674 .717 r
.89173 .51839 .89548 .52749 .90283 .517 .89903 .5073 Metetra
.831 .675 .69 r
.89903 .5073 .90283 .517 .90986 .50392 .90597 .49334 Metetra
.861 .677 .652 r
.90597 .49334 .90986 .50392 .91633 .48638 .91227 .47426 Metetra
.902 .679 .59 r
.91227 .47426 .91633 .48638 .92157 .45916 .91705 .443 Metetra
.929 .669 .522 r
.91705 .443 .92157 .45916 .92151 .38976 .91844 .38515 Metetra
.664 .741 .908 r
.91844 .38515 .92151 .38976 .92955 .38727 .9265 .38265 Metetra
.664 .741 .908 r
.9265 .38265 .92955 .38727 .93762 .38477 .93458 .38013 Metetra
.661 .71 .884 r
.34433 .73854 .34858 .74321 .35554 .7411 .35129 .73642 Metetra
.661 .71 .884 r
.35129 .73642 .35554 .7411 .36251 .73899 .35827 .73429 Metetra
.661 .71 .884 r
.35827 .73429 .36251 .73899 .3695 .73686 .36527 .73214 Metetra
.661 .709 .883 r
.36527 .73214 .3695 .73686 .3765 .73473 .37228 .72999 Metetra
.661 .709 .883 r
.37228 .72999 .3765 .73473 .38353 .73259 .37932 .72783 Metetra
.662 .709 .883 r
.37932 .72783 .38353 .73259 .39057 .73043 .38637 .72566 Metetra
.662 .708 .882 r
.38637 .72566 .39057 .73043 .39763 .72827 .39344 .72348 Metetra
.662 .708 .882 r
.39344 .72348 .39763 .72827 .40471 .7261 .40053 .72129 Metetra
.662 .708 .881 r
.40053 .72129 .40471 .7261 .41181 .72392 .40763 .71909 Metetra
.662 .708 .881 r
.40763 .71909 .41181 .72392 .41892 .72173 .41476 .71687 Metetra
.663 .707 .881 r
.41476 .71687 .41892 .72173 .42605 .71952 .4219 .71465 Metetra
.663 .707 .88 r
.4219 .71465 .42605 .71952 .4332 .71731 .42906 .71242 Metetra
.663 .707 .88 r
.42906 .71242 .4332 .71731 .44037 .71509 .43624 .71018 Metetra
.663 .706 .879 r
.43624 .71018 .44037 .71509 .44756 .71285 .44343 .70792 Metetra
.663 .706 .879 r
.44343 .70792 .44756 .71285 .45476 .71061 .45065 .70565 Metetra
.664 .706 .878 r
.45065 .70565 .45476 .71061 .46198 .70835 .45788 .70337 Metetra
.664 .705 .878 r
.45788 .70337 .46198 .70835 .46922 .70608 .46513 .70108 Metetra
.664 .705 .878 r
.46513 .70108 .46922 .70608 .47648 .7038 .4724 .69878 Metetra
.664 .705 .877 r
.4724 .69878 .47648 .7038 .48376 .7015 .47969 .69646 Metetra
.665 .704 .877 r
.47969 .69646 .48376 .7015 .49106 .69919 .487 .69413 Metetra
.665 .704 .876 r
.487 .69413 .49106 .69919 .49837 .69687 .49432 .69179 Metetra
.665 .704 .875 r
.49432 .69179 .49837 .69687 .5057 .69454 .50167 .68943 Metetra
.666 .703 .875 r
.50167 .68943 .5057 .69454 .51306 .69219 .50903 .68706 Metetra
.666 .703 .874 r
.50903 .68706 .51306 .69219 .52043 .68983 .51641 .68467 Metetra
.666 .702 .874 r
.51641 .68467 .52043 .68983 .52781 .68746 .52381 .68227 Metetra
.667 .702 .873 r
.52381 .68227 .52781 .68746 .53522 .68506 .53122 .67986 Metetra
.667 .702 .873 r
.53122 .67986 .53522 .68506 .54265 .68266 .53866 .67743 Metetra
.667 .701 .872 r
.53866 .67743 .54265 .68266 .55009 .68023 .54611 .67498 Metetra
.668 .701 .871 r
.54611 .67498 .55009 .68023 .55755 .6778 .55359 .67251 Metetra
.668 .7 .871 r
.55359 .67251 .55755 .6778 .56503 .67534 .56108 .67003 Metetra
.669 .7 .87 r
.56108 .67003 .56503 .67534 .57253 .67286 .56859 .66752 Metetra
.669 .699 .869 r
.56859 .66752 .57253 .67286 .58005 .67037 .57612 .665 Metetra
.67 .699 .868 r
.57612 .665 .58005 .67037 .58759 .66786 .58366 .66246 Metetra
.67 .699 .868 r
.58366 .66246 .58759 .66786 .59514 .66533 .59123 .6599 Metetra
.671 .698 .867 r
.59123 .6599 .59514 .66533 .60271 .66277 .59881 .65732 Metetra
.671 .698 .866 r
.59881 .65732 .60271 .66277 .61031 .6602 .60641 .65471 Metetra
.672 .697 .865 r
.60641 .65471 .61031 .6602 .61792 .6576 .61404 .65208 Metetra
.672 .697 .864 r
.61404 .65208 .61792 .6576 .62554 .65498 .62167 .64943 Metetra
.673 .696 .863 r
.62167 .64943 .62554 .65498 .63319 .65233 .62933 .64675 Metetra
.674 .696 .862 r
.62933 .64675 .63319 .65233 .64085 .64966 .63701 .64404 Metetra
.674 .695 .861 r
.63701 .64404 .64085 .64966 .64854 .64696 .6447 .64131 Metetra
.675 .694 .86 r
.6447 .64131 .64854 .64696 .65624 .64423 .65241 .63854 Metetra
.676 .694 .859 r
.65241 .63854 .65624 .64423 .66396 .64148 .66014 .63575 Metetra
.677 .693 .858 r
.66014 .63575 .66396 .64148 .67169 .63869 .66788 .63292 Metetra
.678 .693 .857 r
.66788 .63292 .67169 .63869 .67944 .63586 .67564 .63005 Metetra
.679 .692 .855 r
.67564 .63005 .67944 .63586 .68721 .633 .68342 .62715 Metetra
.68 .691 .854 r
.68342 .62715 .68721 .633 .695 .6301 .69122 .62421 Metetra
.681 .691 .853 r
.69122 .62421 .695 .6301 .7028 .62716 .69903 .62122 Metetra
.682 .69 .851 r
.69903 .62122 .7028 .62716 .71062 .62417 .70686 .61819 Metetra
.683 .69 .85 r
.70686 .61819 .71062 .62417 .71846 .62114 .71471 .6151 Metetra
.685 .689 .848 r
.71471 .6151 .71846 .62114 .72631 .61805 .72257 .61197 Metetra
.686 .688 .846 r
.72257 .61197 .72631 .61805 .73417 .61491 .73044 .60878 Metetra
.688 .688 .844 r
.73044 .60878 .73417 .61491 .74205 .61171 .73833 .60552 Metetra
.689 .687 .842 r
.73833 .60552 .74205 .61171 .74994 .60845 .74623 .6022 Metetra
.691 .686 .84 r
.74623 .6022 .74994 .60845 .75785 .60511 .75415 .5988 Metetra
.693 .685 .838 r
.75415 .5988 .75785 .60511 .76577 .60169 .76207 .59531 Metetra
.696 .685 .836 r
.76207 .59531 .76577 .60169 .7737 .59819 .77001 .59174 Metetra
.698 .684 .833 r
.77001 .59174 .7737 .59819 .78164 .59459 .77795 .58807 Metetra
.701 .683 .83 r
.77795 .58807 .78164 .59459 .78958 .59088 .78591 .58428 Metetra
.704 .683 .827 r
.78591 .58428 .78958 .59088 .79754 .58705 .79387 .58037 Metetra
.707 .682 .823 r
.79387 .58037 .79754 .58705 .80549 .58308 .80183 .57631 Metetra
.711 .681 .82 r
.80183 .57631 .80549 .58308 .81345 .57896 .80979 .57208 Metetra
.715 .68 .815 r
.80979 .57208 .81345 .57896 .82141 .57465 .81775 .56767 Metetra
.719 .68 .811 r
.81775 .56767 .82141 .57465 .82936 .57014 .82571 .56303 Metetra
.725 .679 .806 r
.82571 .56303 .82936 .57014 .83731 .56538 .83365 .55814 Metetra
.731 .679 .8 r
.83365 .55814 .83731 .56538 .84523 .56033 .84158 .55294 Metetra
.738 .678 .793 r
.84158 .55294 .84523 .56033 .85314 .55492 .84948 .54736 Metetra
.746 .678 .785 r
.84948 .54736 .85314 .55492 .86101 .54908 .85734 .54133 Metetra
.755 .677 .776 r
.85734 .54133 .86101 .54908 .86882 .5427 .86515 .53472 Metetra
.766 .677 .765 r
.86515 .53472 .86882 .5427 .87657 .53563 .87288 .52736 Metetra
.779 .677 .751 r
.87288 .52736 .87657 .53563 .88423 .52764 .88051 .51903 Metetra
.796 .678 .734 r
.88051 .51903 .88423 .52764 .89173 .51839 .88798 .50932 Metetra
.815 .679 .713 r
.88798 .50932 .89173 .51839 .89903 .5073 .89522 .49761 Metetra
.84 .679 .683 r
.89522 .49761 .89903 .5073 .90597 .49334 .90206 .48269 Metetra
.871 .68 .641 r
.90206 .48269 .90597 .49334 .91227 .47426 .90817 .46183 Metetra
.917 .682 .568 r
.90817 .46183 .91227 .47426 .91705 .443 .91226 .42463 Metetra
.891 .645 .559 r
.91226 .42463 .91705 .443 .91844 .38515 .91535 .38052 Metetra
.664 .741 .908 r
.91535 .38052 .91844 .38515 .9265 .38265 .92343 .378 Metetra
.664 .741 .908 r
.92343 .378 .9265 .38265 .93458 .38013 .93153 .37548 Metetra
.661 .712 .886 r
.34005 .7339 .34433 .73854 .35129 .73642 .34702 .73175 Metetra
.661 .712 .885 r
.34702 .73175 .35129 .73642 .35827 .73429 .35401 .7296 Metetra
.661 .711 .885 r
.35401 .7296 .35827 .73429 .36527 .73214 .36102 .72744 Metetra
.662 .711 .885 r
.36102 .72744 .36527 .73214 .37228 .72999 .36804 .72527 Metetra
.662 .711 .884 r
.36804 .72527 .37228 .72999 .37932 .72783 .37509 .72309 Metetra
.662 .71 .884 r
.37509 .72309 .37932 .72783 .38637 .72566 .38215 .7209 Metetra
.662 .71 .883 r
.38215 .7209 .38637 .72566 .39344 .72348 .38923 .71871 Metetra
.662 .71 .883 r
.38923 .71871 .39344 .72348 .40053 .72129 .39633 .7165 Metetra
.663 .71 .883 r
.39633 .7165 .40053 .72129 .40763 .71909 .40344 .71427 Metetra
.663 .709 .882 r
.40344 .71427 .40763 .71909 .41476 .71687 .41058 .71204 Metetra
.663 .709 .882 r
.41058 .71204 .41476 .71687 .4219 .71465 .41773 .7098 Metetra
.663 .709 .881 r
.41773 .7098 .4219 .71465 .42906 .71242 .4249 .70755 Metetra
.663 .708 .881 r
.4249 .70755 .42906 .71242 .43624 .71018 .43209 .70528 Metetra
.664 .708 .881 r
.43209 .70528 .43624 .71018 .44343 .70792 .43929 .70301 Metetra
.664 .708 .88 r
.43929 .70301 .44343 .70792 .45065 .70565 .44652 .70072 Metetra
.664 .708 .88 r
.44652 .70072 .45065 .70565 .45788 .70337 .45376 .69842 Metetra
.664 .707 .879 r
.45376 .69842 .45788 .70337 .46513 .70108 .46102 .69611 Metetra
.665 .707 .879 r
.46102 .69611 .46513 .70108 .4724 .69878 .4683 .69378 Metetra
.665 .707 .878 r
.4683 .69378 .4724 .69878 .47969 .69646 .4756 .69144 Metetra
.665 .706 .878 r
.4756 .69144 .47969 .69646 .487 .69413 .48292 .68909 Metetra
.666 .706 .877 r
.48292 .68909 .487 .69413 .49432 .69179 .49026 .68673 Metetra
.666 .706 .877 r
.49026 .68673 .49432 .69179 .50167 .68943 .49761 .68435 Metetra
.666 .705 .876 r
.49761 .68435 .50167 .68943 .50903 .68706 .50498 .68195 Metetra
.667 .705 .876 r
.50498 .68195 .50903 .68706 .51641 .68467 .51237 .67954 Metetra
.667 .704 .875 r
.51237 .67954 .51641 .68467 .52381 .68227 .51978 .67712 Metetra
.667 .704 .874 r
.51978 .67712 .52381 .68227 .53122 .67986 .52721 .67467 Metetra
.668 .704 .874 r
.52721 .67467 .53122 .67986 .53866 .67743 .53466 .67222 Metetra
.668 .703 .873 r
.53466 .67222 .53866 .67743 .54611 .67498 .54212 .66974 Metetra
.669 .703 .873 r
.54212 .66974 .54611 .67498 .55359 .67251 .54961 .66725 Metetra
.669 .702 .872 r
.54961 .66725 .55359 .67251 .56108 .67003 .55711 .66474 Metetra
.67 .702 .871 r
.55711 .66474 .56108 .67003 .56859 .66752 .56463 .66221 Metetra
.67 .702 .87 r
.56463 .66221 .56859 .66752 .57612 .665 .57217 .65966 Metetra
.671 .701 .87 r
.57217 .65966 .57612 .665 .58366 .66246 .57973 .65709 Metetra
.671 .701 .869 r
.57973 .65709 .58366 .66246 .59123 .6599 .5873 .6545 Metetra
.672 .7 .868 r
.5873 .6545 .59123 .6599 .59881 .65732 .5949 .65189 Metetra
.672 .7 .867 r
.5949 .65189 .59881 .65732 .60641 .65471 .60251 .64925 Metetra
.673 .699 .866 r
.60251 .64925 .60641 .65471 .61404 .65208 .61014 .64659 Metetra
.673 .699 .866 r
.61014 .64659 .61404 .65208 .62167 .64943 .61779 .6439 Metetra
.674 .698 .865 r
.61779 .6439 .62167 .64943 .62933 .64675 .62546 .64119 Metetra
.675 .698 .864 r
.62546 .64119 .62933 .64675 .63701 .64404 .63314 .63845 Metetra
.676 .697 .863 r
.63314 .63845 .63701 .64404 .6447 .64131 .64084 .63568 Metetra
.676 .697 .862 r
.64084 .63568 .6447 .64131 .65241 .63854 .64857 .63288 Metetra
.677 .696 .86 r
.64857 .63288 .65241 .63854 .66014 .63575 .6563 .63005 Metetra
.678 .696 .859 r
.6563 .63005 .66014 .63575 .66788 .63292 .66406 .62718 Metetra
.679 .695 .858 r
.66406 .62718 .66788 .63292 .67564 .63005 .67183 .62428 Metetra
.68 .695 .857 r
.67183 .62428 .67564 .63005 .68342 .62715 .67962 .62133 Metetra
.681 .694 .855 r
.67962 .62133 .68342 .62715 .69122 .62421 .68743 .61835 Metetra
.682 .693 .854 r
.68743 .61835 .69122 .62421 .69903 .62122 .69525 .61532 Metetra
.684 .693 .853 r
.69525 .61532 .69903 .62122 .70686 .61819 .70309 .61224 Metetra
.685 .692 .851 r
.70309 .61224 .70686 .61819 .71471 .6151 .71094 .60911 Metetra
.686 .692 .849 r
.71094 .60911 .71471 .6151 .72257 .61197 .71881 .60592 Metetra
.688 .691 .848 r
.71881 .60592 .72257 .61197 .73044 .60878 .7267 .60268 Metetra
.69 .69 .846 r
.7267 .60268 .73044 .60878 .73833 .60552 .7346 .59937 Metetra
.691 .69 .844 r
.7346 .59937 .73833 .60552 .74623 .6022 .74251 .59598 Metetra
.693 .689 .841 r
.74251 .59598 .74623 .6022 .75415 .5988 .75043 .59252 Metetra
.696 .688 .839 r
.75043 .59252 .75415 .5988 .76207 .59531 .75836 .58898 Metetra
.698 .688 .837 r
.75836 .58898 .76207 .59531 .77001 .59174 .76631 .58534 Metetra
.7 .687 .834 r
.76631 .58534 .77001 .59174 .77795 .58807 .77426 .58159 Metetra
.703 .686 .831 r
.77426 .58159 .77795 .58807 .78591 .58428 .78222 .57772 Metetra
.706 .686 .828 r
.78222 .57772 .78591 .58428 .79387 .58037 .79019 .57372 Metetra
.71 .685 .824 r
.79019 .57372 .79387 .58037 .80183 .57631 .79816 .56957 Metetra
.714 .684 .82 r
.79816 .56957 .80183 .57631 .80979 .57208 .80612 .56525 Metetra
.718 .684 .816 r
.80612 .56525 .80979 .57208 .81775 .56767 .81409 .56073 Metetra
.723 .683 .811 r
.81409 .56073 .81775 .56767 .82571 .56303 .82205 .55598 Metetra
.728 .683 .806 r
.82205 .55598 .82571 .56303 .83365 .55814 .82999 .55095 Metetra
.735 .682 .8 r
.82999 .55095 .83365 .55814 .84158 .55294 .83792 .5456 Metetra
.742 .682 .793 r
.83792 .5456 .84158 .55294 .84948 .54736 .84581 .53985 Metetra
.751 .681 .784 r
.84581 .53985 .84948 .54736 .85734 .54133 .85367 .53362 Metetra
.76 .681 .775 r
.85367 .53362 .85734 .54133 .86515 .53472 .86146 .52677 Metetra
.772 .681 .763 r
.86146 .52677 .86515 .53472 .87288 .52736 .86918 .51914 Metetra
.786 .681 .749 r
.86918 .51914 .87288 .52736 .88051 .51903 .87679 .51044 Metetra
.803 .682 .731 r
.87679 .51044 .88051 .51903 .88798 .50932 .88422 .50027 Metetra
.823 .682 .707 r
.88422 .50027 .88798 .50932 .89522 .49761 .8914 .48789 Metetra
.849 .683 .676 r
.8914 .48789 .89522 .49761 .90206 .48269 .89814 .47192 Metetra
.882 .683 .629 r
.89814 .47192 .90206 .48269 .90817 .46183 .90402 .44893 Metetra
.935 .685 .534 r
.90402 .44893 .90817 .46183 .91226 .42463 .90676 .40014 Metetra
.776 .562 .61 r
.90676 .40014 .91226 .42463 .91535 .38052 .91226 .37586 Metetra
.664 .741 .908 r
.91226 .37586 .91535 .38052 .92343 .378 .92035 .37333 Metetra
.664 .741 .908 r
.92035 .37333 .92343 .378 .93153 .37548 .92846 .37079 Metetra
.661 .713 .887 r
.33575 .72926 .34005 .7339 .34702 .73175 .34273 .7271 Metetra
.662 .713 .886 r
.34273 .7271 .34702 .73175 .35401 .7296 .34973 .72494 Metetra
.662 .713 .886 r
.34973 .72494 .35401 .7296 .36102 .72744 .35675 .72276 Metetra
.662 .713 .886 r
.35675 .72276 .36102 .72744 .36804 .72527 .36378 .72057 Metetra
.662 .712 .885 r
.36378 .72057 .36804 .72527 .37509 .72309 .37084 .71837 Metetra
.662 .712 .885 r
.37084 .71837 .37509 .72309 .38215 .7209 .37791 .71617 Metetra
.663 .712 .885 r
.37791 .71617 .38215 .7209 .38923 .71871 .385 .71395 Metetra
.663 .712 .884 r
.385 .71395 .38923 .71871 .39633 .7165 .39211 .71172 Metetra
.663 .711 .884 r
.39211 .71172 .39633 .7165 .40344 .71427 .39923 .70948 Metetra
.663 .711 .883 r
.39923 .70948 .40344 .71427 .41058 .71204 .40638 .70723 Metetra
.663 .711 .883 r
.40638 .70723 .41058 .71204 .41773 .7098 .41354 .70497 Metetra
.664 .71 .883 r
.41354 .70497 .41773 .7098 .4249 .70755 .42072 .70269 Metetra
.664 .71 .882 r
.42072 .70269 .4249 .70755 .43209 .70528 .42792 .70041 Metetra
.664 .71 .882 r
.42792 .70041 .43209 .70528 .43929 .70301 .43514 .69811 Metetra
.664 .71 .881 r
.43514 .69811 .43929 .70301 .44652 .70072 .44237 .6958 Metetra
.665 .709 .881 r
.44237 .6958 .44652 .70072 .45376 .69842 .44963 .69348 Metetra
.665 .709 .88 r
.44963 .69348 .45376 .69842 .46102 .69611 .4569 .69115 Metetra
.665 .709 .88 r
.4569 .69115 .46102 .69611 .4683 .69378 .46419 .6888 Metetra
.666 .708 .879 r
.46419 .6888 .4683 .69378 .4756 .69144 .4715 .68644 Metetra
.666 .708 .879 r
.4715 .68644 .4756 .69144 .48292 .68909 .47883 .68407 Metetra
.666 .708 .878 r
.47883 .68407 .48292 .68909 .49026 .68673 .48617 .68168 Metetra
.667 .707 .878 r
.48617 .68168 .49026 .68673 .49761 .68435 .49354 .67928 Metetra
.667 .707 .877 r
.49354 .67928 .49761 .68435 .50498 .68195 .50092 .67686 Metetra
.667 .707 .877 r
.50092 .67686 .50498 .68195 .51237 .67954 .50832 .67443 Metetra
.668 .706 .876 r
.50832 .67443 .51237 .67954 .51978 .67712 .51574 .67198 Metetra
.668 .706 .876 r
.51574 .67198 .51978 .67712 .52721 .67467 .52318 .66951 Metetra
.669 .706 .875 r
.52318 .66951 .52721 .67467 .53466 .67222 .53064 .66703 Metetra
.669 .705 .874 r
.53064 .66703 .53466 .67222 .54212 .66974 .53811 .66453 Metetra
.669 .705 .874 r
.53811 .66453 .54212 .66974 .54961 .66725 .54561 .66201 Metetra
.67 .704 .873 r
.54561 .66201 .54961 .66725 .55711 .66474 .55312 .65947 Metetra
.67 .704 .872 r
.55312 .65947 .55711 .66474 .56463 .66221 .56065 .65692 Metetra
.671 .704 .872 r
.56065 .65692 .56463 .66221 .57217 .65966 .5682 .65434 Metetra
.671 .703 .871 r
.5682 .65434 .57217 .65966 .57973 .65709 .57577 .65174 Metetra
.672 .703 .87 r
.57577 .65174 .57973 .65709 .5873 .6545 .58336 .64912 Metetra
.673 .702 .869 r
.58336 .64912 .5873 .6545 .5949 .65189 .59096 .64648 Metetra
.673 .702 .868 r
.59096 .64648 .5949 .65189 .60251 .64925 .59859 .64381 Metetra
.674 .701 .868 r
.59859 .64381 .60251 .64925 .61014 .64659 .60623 .64112 Metetra
.674 .701 .867 r
.60623 .64112 .61014 .64659 .61779 .6439 .61389 .6384 Metetra
.675 .7 .866 r
.61389 .6384 .61779 .6439 .62546 .64119 .62157 .63566 Metetra
.676 .7 .865 r
.62157 .63566 .62546 .64119 .63314 .63845 .62926 .63289 Metetra
.677 .699 .864 r
.62926 .63289 .63314 .63845 .64084 .63568 .63698 .63008 Metetra
.678 .699 .863 r
.63698 .63008 .64084 .63568 .64857 .63288 .64471 .62725 Metetra
.678 .698 .862 r
.64471 .62725 .64857 .63288 .6563 .63005 .65246 .62438 Metetra
.679 .698 .86 r
.65246 .62438 .6563 .63005 .66406 .62718 .66022 .62147 Metetra
.68 .697 .859 r
.66022 .62147 .66406 .62718 .67183 .62428 .66801 .61853 Metetra
.681 .697 .858 r
.66801 .61853 .67183 .62428 .67962 .62133 .67581 .61554 Metetra
.683 .696 .857 r
.67581 .61554 .67962 .62133 .68743 .61835 .68362 .61251 Metetra
.684 .696 .855 r
.68362 .61251 .68743 .61835 .69525 .61532 .69146 .60944 Metetra
.685 .695 .854 r
.69146 .60944 .69525 .61532 .70309 .61224 .69931 .60632 Metetra
.687 .695 .852 r
.69931 .60632 .70309 .61224 .71094 .60911 .70717 .60314 Metetra
.688 .694 .85 r
.70717 .60314 .71094 .60911 .71881 .60592 .71505 .5999 Metetra
.69 .694 .849 r
.71505 .5999 .71881 .60592 .7267 .60268 .72294 .59661 Metetra
.691 .693 .847 r
.72294 .59661 .7267 .60268 .7346 .59937 .73085 .59324 Metetra
.693 .692 .845 r
.73085 .59324 .7346 .59937 .74251 .59598 .73877 .5898 Metetra
.695 .692 .842 r
.73877 .5898 .74251 .59598 .75043 .59252 .7467 .58628 Metetra
.698 .691 .84 r
.7467 .58628 .75043 .59252 .75836 .58898 .75465 .58267 Metetra
.7 .69 .837 r
.75465 .58267 .75836 .58898 .76631 .58534 .7626 .57896 Metetra
.703 .69 .835 r
.7626 .57896 .76631 .58534 .77426 .58159 .77056 .57514 Metetra
.706 .689 .832 r
.77056 .57514 .77426 .58159 .78222 .57772 .77853 .5712 Metetra
.709 .689 .828 r
.77853 .5712 .78222 .57772 .79019 .57372 .7865 .56712 Metetra
.713 .688 .825 r
.7865 .56712 .79019 .57372 .79816 .56957 .79447 .56288 Metetra
.717 .687 .821 r
.79447 .56288 .79816 .56957 .80612 .56525 .80245 .55846 Metetra
.721 .687 .816 r
.80245 .55846 .80612 .56525 .81409 .56073 .81042 .55383 Metetra
.726 .686 .811 r
.81042 .55383 .81409 .56073 .82205 .55598 .81838 .54896 Metetra
.732 .686 .806 r
.81838 .54896 .82205 .55598 .82999 .55095 .82632 .5438 Metetra
.739 .685 .799 r
.82632 .5438 .82999 .55095 .83792 .5456 .83425 .5383 Metetra
.747 .685 .792 r
.83425 .5383 .83792 .5456 .84581 .53985 .84214 .53238 Metetra
.755 .685 .783 r
.84214 .53238 .84581 .53985 .85367 .53362 .84999 .52595 Metetra
.766 .685 .773 r
.84999 .52595 .85367 .53362 .86146 .52677 .85778 .51886 Metetra
.778 .685 .761 r
.85778 .51886 .86146 .52677 .86918 .51914 .86548 .51093 Metetra
.792 .685 .746 r
.86548 .51093 .86918 .51914 .87679 .51044 .87306 .50187 Metetra
.81 .685 .727 r
.87306 .50187 .87679 .51044 .88422 .50027 .88045 .4912 Metetra
.831 .686 .702 r
.88045 .4912 .88422 .50027 .8914 .48789 .88757 .47812 Metetra
.858 .686 .667 r
.88757 .47812 .8914 .48789 .89814 .47192 .89419 .46098 Metetra
.893 .685 .615 r
.89419 .46098 .89814 .47192 .90402 .44893 .89979 .43533 Metetra
.947 .684 .506 r
.89979 .43533 .90402 .44893 .90676 .40014 .90105 .37372 Metetra
.6 .445 .643 r
.90105 .37372 .90676 .40014 .91226 .37586 .90914 .37119 Metetra
.664 .741 .908 r
.90914 .37119 .91226 .37586 .92035 .37333 .91725 .36864 Metetra
.664 .741 .908 r
.91725 .36864 .92035 .37333 .92846 .37079 .92538 .36609 Metetra
.662 .715 .888 r
.33143 .72464 .33575 .72926 .34273 .7271 .33842 .72247 Metetra
.662 .715 .887 r
.33842 .72247 .34273 .7271 .34973 .72494 .34543 .72028 Metetra
.662 .714 .887 r
.34543 .72028 .34973 .72494 .35675 .72276 .35246 .71808 Metetra
.662 .714 .887 r
.35246 .71808 .35675 .72276 .36378 .72057 .3595 .71588 Metetra
.663 .714 .886 r
.3595 .71588 .36378 .72057 .37084 .71837 .36657 .71366 Metetra
.663 .714 .886 r
.36657 .71366 .37084 .71837 .37791 .71617 .37365 .71144 Metetra
.663 .713 .886 r
.37365 .71144 .37791 .71617 .385 .71395 .38075 .7092 Metetra
.663 .713 .885 r
.38075 .7092 .385 .71395 .39211 .71172 .38787 .70695 Metetra
.663 .713 .885 r
.38787 .70695 .39211 .71172 .39923 .70948 .39501 .7047 Metetra
.664 .713 .884 r
.39501 .7047 .39923 .70948 .40638 .70723 .40216 .70243 Metetra
.664 .712 .884 r
.40216 .70243 .40638 .70723 .41354 .70497 .40933 .70015 Metetra
.664 .712 .884 r
.40933 .70015 .41354 .70497 .42072 .70269 .41652 .69785 Metetra
.664 .712 .883 r
.41652 .69785 .42072 .70269 .42792 .70041 .42373 .69555 Metetra
.665 .711 .883 r
.42373 .69555 .42792 .70041 .43514 .69811 .43096 .69323 Metetra
.665 .711 .882 r
.43096 .69323 .43514 .69811 .44237 .6958 .43821 .6909 Metetra
.665 .711 .882 r
.43821 .6909 .44237 .6958 .44963 .69348 .44547 .68856 Metetra
.666 .711 .881 r
.44547 .68856 .44963 .69348 .4569 .69115 .45275 .68621 Metetra
.666 .71 .881 r
.45275 .68621 .4569 .69115 .46419 .6888 .46005 .68384 Metetra
.666 .71 .88 r
.46005 .68384 .46419 .6888 .4715 .68644 .46737 .68146 Metetra
.667 .71 .88 r
.46737 .68146 .4715 .68644 .47883 .68407 .47471 .67906 Metetra
.667 .709 .879 r
.47471 .67906 .47883 .68407 .48617 .68168 .48207 .67665 Metetra
.667 .709 .879 r
.48207 .67665 .48617 .68168 .49354 .67928 .48944 .67422 Metetra
.668 .709 .878 r
.48944 .67422 .49354 .67928 .50092 .67686 .49684 .67178 Metetra
.668 .708 .878 r
.49684 .67178 .50092 .67686 .50832 .67443 .50425 .66933 Metetra
.668 .708 .877 r
.50425 .66933 .50832 .67443 .51574 .67198 .51168 .66685 Metetra
.669 .708 .877 r
.51168 .66685 .51574 .67198 .52318 .66951 .51913 .66436 Metetra
.669 .707 .876 r
.51913 .66436 .52318 .66951 .53064 .66703 .5266 .66186 Metetra
.67 .707 .875 r
.5266 .66186 .53064 .66703 .53811 .66453 .53409 .65933 Metetra
.67 .706 .875 r
.53409 .65933 .53811 .66453 .54561 .66201 .54159 .65679 Metetra
.671 .706 .874 r
.54159 .65679 .54561 .66201 .55312 .65947 .54912 .65422 Metetra
.671 .706 .873 r
.54912 .65422 .55312 .65947 .56065 .65692 .55666 .65164 Metetra
.672 .705 .873 r
.55666 .65164 .56065 .65692 .5682 .65434 .56422 .64904 Metetra
.672 .705 .872 r
.56422 .64904 .5682 .65434 .57577 .65174 .5718 .64641 Metetra
.673 .705 .871 r
.5718 .64641 .57577 .65174 .58336 .64912 .5794 .64376 Metetra
.673 .704 .87 r
.5794 .64376 .58336 .64912 .59096 .64648 .58701 .64109 Metetra
.674 .704 .869 r
.58701 .64109 .59096 .64648 .59859 .64381 .59465 .63839 Metetra
.675 .703 .869 r
.59465 .63839 .59859 .64381 .60623 .64112 .6023 .63567 Metetra
.675 .703 .868 r
.6023 .63567 .60623 .64112 .61389 .6384 .60997 .63292 Metetra
.676 .702 .867 r
.60997 .63292 .61389 .6384 .62157 .63566 .61766 .63015 Metetra
.677 .702 .866 r
.61766 .63015 .62157 .63566 .62926 .63289 .62537 .62734 Metetra
.678 .701 .865 r
.62537 .62734 .62926 .63289 .63698 .63008 .63309 .6245 Metetra
.679 .701 .864 r
.63309 .6245 .63698 .63008 .64471 .62725 .64084 .62163 Metetra
.68 .701 .863 r
.64084 .62163 .64471 .62725 .65246 .62438 .6486 .61872 Metetra
.681 .7 .861 r
.6486 .61872 .65246 .62438 .66022 .62147 .65637 .61578 Metetra
.682 .7 .86 r
.65637 .61578 .66022 .62147 .66801 .61853 .66417 .6128 Metetra
.683 .699 .859 r
.66417 .6128 .66801 .61853 .67581 .61554 .67198 .60977 Metetra
.684 .699 .858 r
.67198 .60977 .67581 .61554 .68362 .61251 .67981 .6067 Metetra
.685 .698 .856 r
.67981 .6067 .68362 .61251 .69146 .60944 .68765 .60359 Metetra
.687 .697 .855 r
.68765 .60359 .69146 .60944 .69931 .60632 .69551 .60042 Metetra
.688 .697 .853 r
.69551 .60042 .69931 .60632 .70717 .60314 .70338 .5972 Metetra
.69 .696 .851 r
.70338 .5972 .70717 .60314 .71505 .5999 .71127 .59391 Metetra
.691 .696 .849 r
.71127 .59391 .71505 .5999 .72294 .59661 .71918 .59056 Metetra
.693 .695 .847 r
.71918 .59056 .72294 .59661 .73085 .59324 .72709 .58715 Metetra
.695 .695 .845 r
.72709 .58715 .73085 .59324 .73877 .5898 .73502 .58365 Metetra
.697 .694 .843 r
.73502 .58365 .73877 .5898 .7467 .58628 .74296 .58007 Metetra
.7 .694 .841 r
.74296 .58007 .7467 .58628 .75465 .58267 .75092 .5764 Metetra
.702 .693 .838 r
.75092 .5764 .75465 .58267 .7626 .57896 .75888 .57262 Metetra
.705 .692 .835 r
.75888 .57262 .7626 .57896 .77056 .57514 .76685 .56873 Metetra
.708 .692 .832 r
.76685 .56873 .77056 .57514 .77853 .5712 .77482 .56471 Metetra
.712 .691 .829 r
.77482 .56471 .77853 .5712 .7865 .56712 .7828 .56054 Metetra
.715 .691 .825 r
.7828 .56054 .7865 .56712 .79447 .56288 .79078 .55622 Metetra
.72 .69 .821 r
.79078 .55622 .79447 .56288 .80245 .55846 .79876 .5517 Metetra
.724 .69 .817 r
.79876 .5517 .80245 .55846 .81042 .55383 .80673 .54696 Metetra
.73 .689 .811 r
.80673 .54696 .81042 .55383 .81838 .54896 .8147 .54197 Metetra
.736 .689 .806 r
.8147 .54197 .81838 .54896 .82632 .5438 .82265 .53668 Metetra
.743 .688 .799 r
.82265 .53668 .82632 .5438 .83425 .5383 .83057 .53102 Metetra
.751 .688 .791 r
.83057 .53102 .83425 .5383 .84214 .53238 .83846 .52493 Metetra
.76 .688 .782 r
.83846 .52493 .84214 .53238 .84999 .52595 .8463 .5183 Metetra
.771 .688 .772 r
.8463 .5183 .84999 .52595 .85778 .51886 .85408 .51097 Metetra
.784 .688 .759 r
.85408 .51097 .85778 .51886 .86548 .51093 .86177 .50275 Metetra
.799 .688 .743 r
.86177 .50275 .86548 .51093 .87306 .50187 .86932 .4933 Metetra
.817 .688 .722 r
.86932 .4933 .87306 .50187 .88045 .4912 .87668 .48212 Metetra
.839 .688 .695 r
.87668 .48212 .88045 .4912 .88757 .47812 .88372 .46827 Metetra
.867 .688 .658 r
.88372 .46827 .88757 .47812 .89419 .46098 .89022 .44978 Metetra
.904 .687 .598 r
.89022 .44978 .89419 .46098 .89979 .43533 .89543 .42061 Metetra
.929 .674 .532 r
.89543 .42061 .89979 .43533 .90105 .37372 .89791 .36903 Metetra
.664 .741 .908 r
.89791 .36903 .90105 .37372 .90914 .37119 .90601 .36648 Metetra
.664 .741 .908 r
.90601 .36648 .90914 .37119 .91725 .36864 .91413 .36392 Metetra
.664 .741 .908 r
.91413 .36392 .91725 .36864 .92538 .36609 .92228 .36136 Metetra
.662 .716 .888 r
.32709 .72003 .33143 .72464 .33842 .72247 .33409 .71783 Metetra
.662 .716 .888 r
.33409 .71783 .33842 .72247 .34543 .72028 .34111 .71563 Metetra
.663 .716 .888 r
.34111 .71563 .34543 .72028 .35246 .71808 .34815 .71342 Metetra
.663 .715 .887 r
.34815 .71342 .35246 .71808 .3595 .71588 .35521 .7112 Metetra
.663 .715 .887 r
.35521 .7112 .3595 .71588 .36657 .71366 .36228 .70896 Metetra
.663 .715 .887 r
.36228 .70896 .36657 .71366 .37365 .71144 .36937 .70672 Metetra
.663 .715 .886 r
.36937 .70672 .37365 .71144 .38075 .7092 .37648 .70446 Metetra
.664 .714 .886 r
.37648 .70446 .38075 .7092 .38787 .70695 .38361 .7022 Metetra
.664 .714 .886 r
.38361 .7022 .38787 .70695 .39501 .7047 .39076 .69992 Metetra
.664 .714 .885 r
.39076 .69992 .39501 .7047 .40216 .70243 .39792 .69763 Metetra
.664 .714 .885 r
.39792 .69763 .40216 .70243 .40933 .70015 .40511 .69533 Metetra
.665 .713 .884 r
.40511 .69533 .40933 .70015 .41652 .69785 .41231 .69302 Metetra
.665 .713 .884 r
.41231 .69302 .41652 .69785 .42373 .69555 .41953 .6907 Metetra
.665 .713 .884 r
.41953 .6907 .42373 .69555 .43096 .69323 .42676 .68836 Metetra
.666 .713 .883 r
.42676 .68836 .43096 .69323 .43821 .6909 .43402 .68601 Metetra
.666 .712 .883 r
.43402 .68601 .43821 .6909 .44547 .68856 .4413 .68365 Metetra
.666 .712 .882 r
.4413 .68365 .44547 .68856 .45275 .68621 .44859 .68127 Metetra
.666 .712 .882 r
.44859 .68127 .45275 .68621 .46005 .68384 .4559 .67888 Metetra
.667 .711 .881 r
.4559 .67888 .46005 .68384 .46737 .68146 .46323 .67648 Metetra
.667 .711 .881 r
.46323 .67648 .46737 .68146 .47471 .67906 .47058 .67406 Metetra
.667 .711 .88 r
.47058 .67406 .47471 .67906 .48207 .67665 .47795 .67163 Metetra
.668 .71 .88 r
.47795 .67163 .48207 .67665 .48944 .67422 .48534 .66918 Metetra
.668 .71 .879 r
.48534 .66918 .48944 .67422 .49684 .67178 .49274 .66672 Metetra
.669 .71 .879 r
.49274 .66672 .49684 .67178 .50425 .66933 .50016 .66424 Metetra
.669 .709 .878 r
.50016 .66424 .50425 .66933 .51168 .66685 .50761 .66174 Metetra
.669 .709 .878 r
.50761 .66174 .51168 .66685 .51913 .66436 .51507 .65923 Metetra
.67 .709 .877 r
.51507 .65923 .51913 .66436 .5266 .66186 .52255 .6567 Metetra
.67 .708 .876 r
.52255 .6567 .5266 .66186 .53409 .65933 .53004 .65415 Metetra
.671 .708 .876 r
.53004 .65415 .53409 .65933 .54159 .65679 .53756 .65158 Metetra
.671 .708 .875 r
.53756 .65158 .54159 .65679 .54912 .65422 .5451 .64899 Metetra
.672 .707 .874 r
.5451 .64899 .54912 .65422 .55666 .65164 .55265 .64638 Metetra
.672 .707 .874 r
.55265 .64638 .55666 .65164 .56422 .64904 .56022 .64375 Metetra
.673 .707 .873 r
.56022 .64375 .56422 .64904 .5718 .64641 .56781 .64109 Metetra
.674 .706 .872 r
.56781 .64109 .5718 .64641 .5794 .64376 .57542 .63842 Metetra
.674 .706 .871 r
.57542 .63842 .5794 .64376 .58701 .64109 .58305 .63572 Metetra
.675 .705 .87 r
.58305 .63572 .58701 .64109 .59465 .63839 .5907 .63299 Metetra
.676 .705 .87 r
.5907 .63299 .59465 .63839 .6023 .63567 .59836 .63024 Metetra
.676 .705 .869 r
.59836 .63024 .6023 .63567 .60997 .63292 .60604 .62746 Metetra
.677 .704 .868 r
.60604 .62746 .60997 .63292 .61766 .63015 .61374 .62465 Metetra
.678 .704 .867 r
.61374 .62465 .61766 .63015 .62537 .62734 .62146 .62181 Metetra
.679 .703 .866 r
.62146 .62181 .62537 .62734 .63309 .6245 .6292 .61894 Metetra
.68 .703 .865 r
.6292 .61894 .63309 .6245 .64084 .62163 .63695 .61603 Metetra
.681 .702 .863 r
.63695 .61603 .64084 .62163 .6486 .61872 .64472 .61309 Metetra
.682 .702 .862 r
.64472 .61309 .6486 .61872 .65637 .61578 .65251 .61011 Metetra
.683 .701 .861 r
.65251 .61011 .65637 .61578 .66417 .6128 .66031 .60709 Metetra
.684 .701 .86 r
.66031 .60709 .66417 .6128 .67198 .60977 .66814 .60402 Metetra
.685 .7 .858 r
.66814 .60402 .67198 .60977 .67981 .6067 .67597 .60091 Metetra
.687 .7 .857 r
.67597 .60091 .67981 .6067 .68765 .60359 .68383 .59775 Metetra
.688 .699 .855 r
.68383 .59775 .68765 .60359 .69551 .60042 .6917 .59454 Metetra
.69 .699 .854 r
.6917 .59454 .69551 .60042 .70338 .5972 .69958 .59127 Metetra
.691 .698 .852 r
.69958 .59127 .70338 .5972 .71127 .59391 .70748 .58794 Metetra
.693 .698 .85 r
.70748 .58794 .71127 .59391 .71918 .59056 .7154 .58454 Metetra
.695 .697 .848 r
.7154 .58454 .71918 .59056 .72709 .58715 .72332 .58107 Metetra
.697 .697 .846 r
.72332 .58107 .72709 .58715 .73502 .58365 .73126 .57752 Metetra
.699 .696 .844 r
.73126 .57752 .73502 .58365 .74296 .58007 .73921 .57388 Metetra
.702 .696 .841 r
.73921 .57388 .74296 .58007 .75092 .5764 .74717 .57014 Metetra
.704 .695 .839 r
.74717 .57014 .75092 .5764 .75888 .57262 .75514 .5663 Metetra
.707 .695 .836 r
.75514 .5663 .75888 .57262 .76685 .56873 .76312 .56234 Metetra
.711 .694 .833 r
.76312 .56234 .76685 .56873 .77482 .56471 .77111 .55824 Metetra
.714 .694 .829 r
.77111 .55824 .77482 .56471 .7828 .56054 .77909 .55399 Metetra
.718 .693 .825 r
.77909 .55399 .7828 .56054 .79078 .55622 .78708 .54957 Metetra
.723 .693 .821 r
.78708 .54957 .79078 .55622 .79876 .5517 .79506 .54496 Metetra
.727 .692 .817 r
.79506 .54496 .79876 .5517 .80673 .54696 .80304 .54011 Metetra
.733 .692 .811 r
.80304 .54011 .80673 .54696 .8147 .54197 .81101 .535 Metetra
.739 .692 .805 r
.81101 .535 .8147 .54197 .82265 .53668 .81896 .52958 Metetra
.747 .691 .798 r
.81896 .52958 .82265 .53668 .83057 .53102 .82689 .52377 Metetra
.755 .691 .79 r
.82689 .52377 .83057 .53102 .83846 .52493 .83477 .51751 Metetra
.765 .691 .781 r
.83477 .51751 .83846 .52493 .8463 .5183 .84261 .51067 Metetra
.776 .691 .77 r
.84261 .51067 .8463 .5183 .85408 .51097 .85038 .5031 Metetra
.789 .691 .756 r
.85038 .5031 .85408 .51097 .86177 .50275 .85805 .49456 Metetra
.805 .691 .739 r
.85805 .49456 .86177 .50275 .86932 .4933 .86558 .48472 Metetra
.824 .691 .718 r
.86558 .48472 .86932 .4933 .87668 .48212 .87289 .47298 Metetra
.847 .691 .689 r
.87289 .47298 .87668 .48212 .88372 .46827 .87986 .45829 Metetra
.876 .69 .647 r
.87986 .45829 .88372 .46827 .89022 .44978 .8862 .43824 Metetra
.917 .688 .576 r
.8862 .43824 .89022 .44978 .89543 .42061 .89084 .40385 Metetra
.891 .65 .569 r
.89084 .40385 .89543 .42061 .89791 .36903 .89474 .36432 Metetra
.664 .741 .908 r
.89474 .36432 .89791 .36903 .90601 .36648 .90286 .36175 Metetra
.664 .741 .908 r
.90286 .36175 .90601 .36648 .91413 .36392 .911 .35918 Metetra
.664 .741 .908 r
.911 .35918 .91413 .36392 .92228 .36136 .91917 .35661 Metetra
.663 .717 .889 r
.32273 .71542 .32709 .72003 .33409 .71783 .32974 .71321 Metetra
.663 .717 .889 r
.32974 .71321 .33409 .71783 .34111 .71563 .33677 .71099 Metetra
.663 .717 .889 r
.33677 .71099 .34111 .71563 .34815 .71342 .34382 .70876 Metetra
.663 .717 .888 r
.34382 .70876 .34815 .71342 .35521 .7112 .35089 .70652 Metetra
.663 .716 .888 r
.35089 .70652 .35521 .7112 .36228 .70896 .35797 .70427 Metetra
.664 .716 .888 r
.35797 .70427 .36228 .70896 .36937 .70672 .36507 .70201 Metetra
.664 .716 .887 r
.36507 .70201 .36937 .70672 .37648 .70446 .37219 .69973 Metetra
.664 .716 .887 r
.37219 .69973 .37648 .70446 .38361 .7022 .37933 .69745 Metetra
.664 .715 .886 r
.37933 .69745 .38361 .7022 .39076 .69992 .38649 .69515 Metetra
.665 .715 .886 r
.38649 .69515 .39076 .69992 .39792 .69763 .39367 .69285 Metetra
.665 .715 .886 r
.39367 .69285 .39792 .69763 .40511 .69533 .40086 .69053 Metetra
.665 .715 .885 r
.40086 .69053 .40511 .69533 .41231 .69302 .40807 .6882 Metetra
.665 .714 .885 r
.40807 .6882 .41231 .69302 .41953 .6907 .4153 .68585 Metetra
.666 .714 .884 r
.4153 .68585 .41953 .6907 .42676 .68836 .42255 .6835 Metetra
.666 .714 .884 r
.42255 .6835 .42676 .68836 .43402 .68601 .42982 .68113 Metetra
.666 .714 .884 r
.42982 .68113 .43402 .68601 .4413 .68365 .4371 .67874 Metetra
.667 .713 .883 r
.4371 .67874 .4413 .68365 .44859 .68127 .44441 .67635 Metetra
.667 .713 .883 r
.44441 .67635 .44859 .68127 .4559 .67888 .45173 .67394 Metetra
.667 .713 .882 r
.45173 .67394 .4559 .67888 .46323 .67648 .45907 .67151 Metetra
.668 .712 .882 r
.45907 .67151 .46323 .67648 .47058 .67406 .46643 .66907 Metetra
.668 .712 .881 r
.46643 .66907 .47058 .67406 .47795 .67163 .47381 .66662 Metetra
.668 .712 .881 r
.47381 .66662 .47795 .67163 .48534 .66918 .48121 .66415 Metetra
.669 .712 .88 r
.48121 .66415 .48534 .66918 .49274 .66672 .48862 .66166 Metetra
.669 .711 .88 r
.48862 .66166 .49274 .66672 .50016 .66424 .49606 .65916 Metetra
.67 .711 .879 r
.49606 .65916 .50016 .66424 .50761 .66174 .50351 .65664 Metetra
.67 .711 .878 r
.50351 .65664 .50761 .66174 .51507 .65923 .51098 .6541 Metetra
.671 .71 .878 r
.51098 .6541 .51507 .65923 .52255 .6567 .51847 .65155 Metetra
.671 .71 .877 r
.51847 .65155 .52255 .6567 .53004 .65415 .52598 .64897 Metetra
.672 .71 .876 r
.52598 .64897 .53004 .65415 .53756 .65158 .53351 .64638 Metetra
.672 .709 .876 r
.53351 .64638 .53756 .65158 .5451 .64899 .54106 .64376 Metetra
.673 .709 .875 r
.54106 .64376 .5451 .64899 .55265 .64638 .54862 .64112 Metetra
.673 .709 .874 r
.54862 .64112 .55265 .64638 .56022 .64375 .55621 .63847 Metetra
.674 .708 .874 r
.55621 .63847 .56022 .64375 .56781 .64109 .56381 .63579 Metetra
.674 .708 .873 r
.56381 .63579 .56781 .64109 .57542 .63842 .57143 .63308 Metetra
.675 .707 .872 r
.57143 .63308 .57542 .63842 .58305 .63572 .57907 .63035 Metetra
.676 .707 .871 r
.57907 .63035 .58305 .63572 .5907 .63299 .58672 .6276 Metetra
.676 .707 .87 r
.58672 .6276 .5907 .63299 .59836 .63024 .5944 .62481 Metetra
.677 .706 .869 r
.5944 .62481 .59836 .63024 .60604 .62746 .60209 .622 Metetra
.678 .706 .868 r
.60209 .622 .60604 .62746 .61374 .62465 .60981 .61916 Metetra
.679 .705 .868 r
.60981 .61916 .61374 .62465 .62146 .62181 .61754 .61629 Metetra
.68 .705 .866 r
.61754 .61629 .62146 .62181 .6292 .61894 .62528 .61338 Metetra
.681 .705 .865 r
.62528 .61338 .6292 .61894 .63695 .61603 .63305 .61044 Metetra
.682 .704 .864 r
.63305 .61044 .63695 .61603 .64472 .61309 .64083 .60747 Metetra
.683 .704 .863 r
.64083 .60747 .64472 .61309 .65251 .61011 .64863 .60445 Metetra
.684 .703 .862 r
.64863 .60445 .65251 .61011 .66031 .60709 .65645 .60139 Metetra
.685 .703 .86 r
.65645 .60139 .66031 .60709 .66814 .60402 .66428 .59829 Metetra
.687 .702 .859 r
.66428 .59829 .66814 .60402 .67597 .60091 .67213 .59514 Metetra
.688 .702 .858 r
.67213 .59514 .67597 .60091 .68383 .59775 .67999 .59193 Metetra
.689 .701 .856 r
.67999 .59193 .68383 .59775 .6917 .59454 .68787 .58868 Metetra
.691 .701 .854 r
.68787 .58868 .6917 .59454 .69958 .59127 .69577 .58536 Metetra
.693 .7 .853 r
.69577 .58536 .69958 .59127 .70748 .58794 .70368 .58198 Metetra
.695 .7 .851 r
.70368 .58198 .70748 .58794 .7154 .58454 .7116 .57853 Metetra
.697 .699 .849 r
.7116 .57853 .7154 .58454 .72332 .58107 .71954 .57501 Metetra
.699 .699 .847 r
.71954 .57501 .72332 .58107 .73126 .57752 .72749 .5714 Metetra
.701 .698 .844 r
.72749 .5714 .73126 .57752 .73921 .57388 .73545 .5677 Metetra
.704 .698 .842 r
.73545 .5677 .73921 .57388 .74717 .57014 .74342 .5639 Metetra
.706 .697 .839 r
.74342 .5639 .74717 .57014 .75514 .5663 .7514 .55999 Metetra
.709 .697 .836 r
.7514 .55999 .75514 .5663 .76312 .56234 .75939 .55596 Metetra
.713 .696 .833 r
.75939 .55596 .76312 .56234 .77111 .55824 .76738 .55179 Metetra
.717 .696 .829 r
.76738 .55179 .77111 .55824 .77909 .55399 .77537 .54746 Metetra
.721 .696 .826 r
.77537 .54746 .77909 .55399 .78708 .54957 .78337 .54295 Metetra
.725 .695 .821 r
.78337 .54295 .78708 .54957 .79506 .54496 .79136 .53824 Metetra
.731 .695 .816 r
.79136 .53824 .79506 .54496 .80304 .54011 .79934 .53329 Metetra
.736 .694 .811 r
.79934 .53329 .80304 .54011 .81101 .535 .80731 .52806 Metetra
.743 .694 .805 r
.80731 .52806 .81101 .535 .81896 .52958 .81527 .5225 Metetra
.75 .694 .798 r
.81527 .5225 .81896 .52958 .82689 .52377 .82319 .51654 Metetra
.759 .694 .789 r
.82319 .51654 .82689 .52377 .83477 .51751 .83108 .5101 Metetra
.769 .694 .779 r
.83108 .5101 .83477 .51751 .84261 .51067 .83891 .50305 Metetra
.781 .694 .768 r
.83891 .50305 .84261 .51067 .85038 .5031 .84667 .49522 Metetra
.794 .694 .753 r
.84667 .49522 .85038 .5031 .85805 .49456 .85432 .48637 Metetra
.811 .694 .735 r
.85432 .48637 .85805 .49456 .86558 .48472 .86182 .47611 Metetra
.83 .693 .712 r
.86182 .47611 .86558 .48472 .87289 .47298 .86909 .46379 Metetra
.854 .693 .681 r
.86909 .46379 .87289 .47298 .87986 .45829 .87598 .44816 Metetra
.885 .691 .636 r
.87598 .44816 .87986 .45829 .8862 .43824 .88212 .42622 Metetra
.935 .69 .542 r
.88212 .42622 .8862 .43824 .89084 .40385 .88563 .38154 Metetra
.777 .568 .617 r
.88563 .38154 .89084 .40385 .89474 .36432 .89156 .35958 Metetra
.664 .741 .908 r
.89156 .35958 .89474 .36432 .90286 .36175 .8997 .357 Metetra
.664 .741 .908 r
.8997 .357 .90286 .36175 .911 .35918 .90786 .35442 Metetra
.664 .741 .908 r
.90786 .35442 .911 .35918 .91917 .35661 .91604 .35183 Metetra
.663 .718 .89 r
.31835 .71082 .32273 .71542 .32974 .71321 .32537 .70859 Metetra
.663 .718 .89 r
.32537 .70859 .32974 .71321 .33677 .71099 .33241 .70635 Metetra
.663 .718 .889 r
.33241 .70635 .33677 .71099 .34382 .70876 .33947 .7041 Metetra
.664 .718 .889 r
.33947 .7041 .34382 .70876 .35089 .70652 .34655 .70185 Metetra
.664 .718 .889 r
.34655 .70185 .35089 .70652 .35797 .70427 .35364 .69958 Metetra
.664 .717 .888 r
.35364 .69958 .35797 .70427 .36507 .70201 .36075 .6973 Metetra
.664 .717 .888 r
.36075 .6973 .36507 .70201 .37219 .69973 .36789 .69501 Metetra
.664 .717 .888 r
.36789 .69501 .37219 .69973 .37933 .69745 .37504 .6927 Metetra
.665 .717 .887 r
.37504 .6927 .37933 .69745 .38649 .69515 .3822 .69039 Metetra
.665 .716 .887 r
.3822 .69039 .38649 .69515 .39367 .69285 .38939 .68806 Metetra
.665 .716 .886 r
.38939 .68806 .39367 .69285 .40086 .69053 .39659 .68573 Metetra
.666 .716 .886 r
.39659 .68573 .40086 .69053 .40807 .6882 .40382 .68338 Metetra
.666 .716 .886 r
.40382 .68338 .40807 .6882 .4153 .68585 .41106 .68101 Metetra
.666 .715 .885 r
.41106 .68101 .4153 .68585 .42255 .6835 .41832 .67864 Metetra
.666 .715 .885 r
.41832 .67864 .42255 .6835 .42982 .68113 .4256 .67625 Metetra
.667 .715 .884 r
.4256 .67625 .42982 .68113 .4371 .67874 .43289 .67384 Metetra
.667 .715 .884 r
.43289 .67384 .4371 .67874 .44441 .67635 .44021 .67143 Metetra
.667 .714 .883 r
.44021 .67143 .44441 .67635 .45173 .67394 .44754 .669 Metetra
.668 .714 .883 r
.44754 .669 .45173 .67394 .45907 .67151 .45489 .66655 Metetra
.668 .714 .882 r
.45489 .66655 .45907 .67151 .46643 .66907 .46226 .66409 Metetra
.669 .713 .882 r
.46226 .66409 .46643 .66907 .47381 .66662 .46965 .66161 Metetra
.669 .713 .881 r
.46965 .66161 .47381 .66662 .48121 .66415 .47706 .65912 Metetra
.669 .713 .881 r
.47706 .65912 .48121 .66415 .48862 .66166 .48449 .65661 Metetra
.67 .713 .88 r
.48449 .65661 .48862 .66166 .49606 .65916 .49193 .65409 Metetra
.67 .712 .88 r
.49193 .65409 .49606 .65916 .50351 .65664 .4994 .65154 Metetra
.671 .712 .879 r
.4994 .65154 .50351 .65664 .51098 .6541 .50688 .64898 Metetra
.671 .712 .878 r
.50688 .64898 .51098 .6541 .51847 .65155 .51438 .6464 Metetra
.672 .711 .878 r
.51438 .6464 .51847 .65155 .52598 .64897 .5219 .6438 Metetra
.672 .711 .877 r
.5219 .6438 .52598 .64897 .53351 .64638 .52944 .64118 Metetra
.673 .711 .877 r
.52944 .64118 .53351 .64638 .54106 .64376 .537 .63854 Metetra
.673 .71 .876 r
.537 .63854 .54106 .64376 .54862 .64112 .54458 .63588 Metetra
.674 .71 .875 r
.54458 .63588 .54862 .64112 .55621 .63847 .55217 .63319 Metetra
.675 .71 .874 r
.55217 .63319 .55621 .63847 .56381 .63579 .55979 .63049 Metetra
.675 .709 .874 r
.55979 .63049 .56381 .63579 .57143 .63308 .56742 .62775 Metetra
.676 .709 .873 r
.56742 .62775 .57143 .63308 .57907 .63035 .57507 .625 Metetra
.677 .709 .872 r
.57507 .625 .57907 .63035 .58672 .6276 .58274 .62221 Metetra
.677 .708 .871 r
.58274 .62221 .58672 .6276 .5944 .62481 .59043 .6194 Metetra
.678 .708 .87 r
.59043 .6194 .5944 .62481 .60209 .622 .59813 .61656 Metetra
.679 .707 .869 r
.59813 .61656 .60209 .622 .60981 .61916 .60585 .61369 Metetra
.68 .707 .868 r
.60585 .61369 .60981 .61916 .61754 .61629 .61359 .61078 Metetra
.681 .707 .867 r
.61359 .61078 .61754 .61629 .62528 .61338 .62135 .60784 Metetra
.682 .706 .866 r
.62135 .60784 .62528 .61338 .63305 .61044 .62913 .60487 Metetra
.683 .706 .865 r
.62913 .60487 .63305 .61044 .64083 .60747 .63692 .60185 Metetra
.684 .705 .864 r
.63692 .60185 .64083 .60747 .64863 .60445 .64473 .5988 Metetra
.685 .705 .862 r
.64473 .5988 .64863 .60445 .65645 .60139 .65256 .5957 Metetra
.686 .704 .861 r
.65256 .5957 .65645 .60139 .66428 .59829 .66041 .59256 Metetra
.688 .704 .86 r
.66041 .59256 .66428 .59829 .67213 .59514 .66827 .58937 Metetra
.689 .704 .858 r
.66827 .58937 .67213 .59514 .67999 .59193 .67614 .58613 Metetra
.691 .703 .857 r
.67614 .58613 .67999 .59193 .68787 .58868 .68404 .58282 Metetra
.692 .703 .855 r
.68404 .58282 .68787 .58868 .69577 .58536 .69194 .57946 Metetra
.694 .702 .853 r
.69194 .57946 .69577 .58536 .70368 .58198 .69986 .57603 Metetra
.696 .702 .851 r
.69986 .57603 .70368 .58198 .7116 .57853 .7078 .57254 Metetra
.698 .701 .849 r
.7078 .57254 .7116 .57853 .71954 .57501 .71574 .56896 Metetra
.7 .701 .847 r
.71574 .56896 .71954 .57501 .72749 .5714 .7237 .5653 Metetra
.703 .7 .845 r
.7237 .5653 .72749 .5714 .73545 .5677 .73167 .56154 Metetra
.705 .7 .842 r
.73167 .56154 .73545 .5677 .74342 .5639 .73965 .55768 Metetra
.708 .699 .839 r
.73965 .55768 .74342 .5639 .7514 .55999 .74764 .5537 Metetra
.712 .699 .836 r
.74764 .5537 .7514 .55999 .75939 .55596 .75564 .5496 Metetra
.715 .699 .833 r
.75564 .5496 .75939 .55596 .76738 .55179 .76364 .54535 Metetra
.719 .698 .83 r
.76364 .54535 .76738 .55179 .77537 .54746 .77164 .54094 Metetra
.723 .698 .826 r
.77164 .54094 .77537 .54746 .78337 .54295 .77964 .53634 Metetra
.728 .697 .821 r
.77964 .53634 .78337 .54295 .79136 .53824 .78764 .53153 Metetra
.733 .697 .816 r
.78764 .53153 .79136 .53824 .79934 .53329 .79563 .52647 Metetra
.739 .697 .81 r
.79563 .52647 .79934 .53329 .80731 .52806 .8036 .52112 Metetra
.746 .697 .804 r
.8036 .52112 .80731 .52806 .81527 .5225 .81156 .51543 Metetra
.754 .696 .797 r
.81156 .51543 .81527 .5225 .82319 .51654 .81949 .50932 Metetra
.763 .696 .788 r
.81949 .50932 .82319 .51654 .83108 .5101 .82737 .50269 Metetra
.774 .696 .778 r
.82737 .50269 .83108 .5101 .83891 .50305 .8352 .49543 Metetra
.786 .696 .765 r
.8352 .49543 .83891 .50305 .84667 .49522 .84295 .48734 Metetra
.8 .696 .75 r
.84295 .48734 .84667 .49522 .85432 .48637 .85058 .47816 Metetra
.817 .696 .731 r
.85058 .47816 .85432 .48637 .86182 .47611 .85805 .46746 Metetra
.837 .695 .707 r
.85805 .46746 .86182 .47611 .86909 .46379 .86527 .4545 Metetra
.862 .695 .673 r
.86527 .4545 .86909 .46379 .87598 .44816 .87206 .43783 Metetra
.895 .692 .622 r
.87206 .43783 .87598 .44816 .88212 .42622 .87797 .41352 Metetra
.946 .688 .515 r
.87797 .41352 .88212 .42622 .88563 .38154 .88024 .3574 Metetra
.602 .452 .651 r
.88024 .3574 .88563 .38154 .89156 .35958 .88837 .35482 Metetra
.664 .741 .908 r
.88837 .35482 .89156 .35958 .8997 .357 .89652 .35223 Metetra
.664 .741 .908 r
.89652 .35223 .8997 .357 .90786 .35442 .90469 .34963 Metetra
.664 .741 .908 r
.90469 .34963 .90786 .35442 .91604 .35183 .91289 .34703 Metetra
.663 .719 .891 r
.31395 .70621 .31835 .71082 .32537 .70859 .32098 .70397 Metetra
.663 .719 .89 r
.32098 .70397 .32537 .70859 .33241 .70635 .32803 .70172 Metetra
.664 .719 .89 r
.32803 .70172 .33241 .70635 .33947 .7041 .3351 .69945 Metetra
.664 .719 .89 r
.3351 .69945 .33947 .7041 .34655 .70185 .34219 .69717 Metetra
.664 .719 .889 r
.34219 .69717 .34655 .70185 .35364 .69958 .34929 .69489 Metetra
.664 .718 .889 r
.34929 .69489 .35364 .69958 .36075 .6973 .35642 .69259 Metetra
.665 .718 .889 r
.35642 .69259 .36075 .6973 .36789 .69501 .36356 .69028 Metetra
.665 .718 .888 r
.36356 .69028 .36789 .69501 .37504 .6927 .37072 .68796 Metetra
.665 .718 .888 r
.37072 .68796 .37504 .6927 .3822 .69039 .3779 .68563 Metetra
.665 .717 .887 r
.3779 .68563 .3822 .69039 .38939 .68806 .38509 .68328 Metetra
.666 .717 .887 r
.38509 .68328 .38939 .68806 .39659 .68573 .39231 .68093 Metetra
.666 .717 .887 r
.39231 .68093 .39659 .68573 .40382 .68338 .39954 .67856 Metetra
.666 .717 .886 r
.39954 .67856 .40382 .68338 .41106 .68101 .40679 .67617 Metetra
.667 .717 .886 r
.40679 .67617 .41106 .68101 .41832 .67864 .41406 .67378 Metetra
.667 .716 .885 r
.41406 .67378 .41832 .67864 .4256 .67625 .42135 .67137 Metetra
.667 .716 .885 r
.42135 .67137 .4256 .67625 .43289 .67384 .42866 .66895 Metetra
.668 .716 .884 r
.42866 .66895 .43289 .67384 .44021 .67143 .43599 .66651 Metetra
.668 .715 .884 r
.43599 .66651 .44021 .67143 .44754 .669 .44333 .66406 Metetra
.668 .715 .884 r
.44333 .66406 .44754 .669 .45489 .66655 .4507 .66159 Metetra
.669 .715 .883 r
.4507 .66159 .45489 .66655 .46226 .66409 .45808 .65911 Metetra
.669 .715 .883 r
.45808 .65911 .46226 .66409 .46965 .66161 .46548 .65661 Metetra
.669 .714 .882 r
.46548 .65661 .46965 .66161 .47706 .65912 .4729 .6541 Metetra
.67 .714 .881 r
.4729 .6541 .47706 .65912 .48449 .65661 .48034 .65156 Metetra
.67 .714 .881 r
.48034 .65156 .48449 .65661 .49193 .65409 .48779 .64902 Metetra
.671 .713 .88 r
.48779 .64902 .49193 .65409 .4994 .65154 .49527 .64645 Metetra
.671 .713 .88 r
.49527 .64645 .4994 .65154 .50688 .64898 .50276 .64386 Metetra
.672 .713 .879 r
.50276 .64386 .50688 .64898 .51438 .6464 .51028 .64126 Metetra
.672 .713 .879 r
.51028 .64126 .51438 .6464 .5219 .6438 .51781 .63864 Metetra
.673 .712 .878 r
.51781 .63864 .5219 .6438 .52944 .64118 .52536 .63599 Metetra
.673 .712 .877 r
.52536 .63599 .52944 .64118 .537 .63854 .53293 .63333 Metetra
.674 .712 .876 r
.53293 .63333 .537 .63854 .54458 .63588 .54052 .63064 Metetra
.675 .711 .876 r
.54052 .63064 .54458 .63588 .55217 .63319 .54812 .62793 Metetra
.675 .711 .875 r
.54812 .62793 .55217 .63319 .55979 .63049 .55575 .62519 Metetra
.676 .711 .874 r
.55575 .62519 .55979 .63049 .56742 .62775 .56339 .62243 Metetra
.677 .71 .873 r
.56339 .62243 .56742 .62775 .57507 .625 .57105 .61965 Metetra
.677 .71 .873 r
.57105 .61965 .57507 .625 .58274 .62221 .57873 .61683 Metetra
.678 .71 .872 r
.57873 .61683 .58274 .62221 .59043 .6194 .58643 .61399 Metetra
.679 .709 .871 r
.58643 .61399 .59043 .6194 .59813 .61656 .59415 .61112 Metetra
.68 .709 .87 r
.59415 .61112 .59813 .61656 .60585 .61369 .60188 .60821 Metetra
.681 .708 .869 r
.60188 .60821 .60585 .61369 .61359 .61078 .60964 .60528 Metetra
.682 .708 .868 r
.60964 .60528 .61359 .61078 .62135 .60784 .61741 .6023 Metetra
.683 .708 .867 r
.61741 .6023 .62135 .60784 .62913 .60487 .6252 .5993 Metetra
.684 .707 .866 r
.6252 .5993 .62913 .60487 .63692 .60185 .633 .59625 Metetra
.685 .707 .864 r
.633 .59625 .63692 .60185 .64473 .5988 .64082 .59316 Metetra
.686 .706 .863 r
.64082 .59316 .64473 .5988 .65256 .5957 .64866 .59002 Metetra
.688 .706 .862 r
.64866 .59002 .65256 .5957 .66041 .59256 .65652 .58684 Metetra
.689 .706 .86 r
.65652 .58684 .66041 .59256 .66827 .58937 .66439 .58361 Metetra
.69 .705 .859 r
.66439 .58361 .66827 .58937 .67614 .58613 .67228 .58032 Metetra
.692 .705 .857 r
.67228 .58032 .67614 .58613 .68404 .58282 .68018 .57698 Metetra
.694 .704 .855 r
.68018 .57698 .68404 .58282 .69194 .57946 .6881 .57357 Metetra
.696 .704 .854 r
.6881 .57357 .69194 .57946 .69986 .57603 .69603 .5701 Metetra
.698 .703 .852 r
.69603 .5701 .69986 .57603 .7078 .57254 .70398 .56655 Metetra
.7 .703 .85 r
.70398 .56655 .7078 .57254 .71574 .56896 .71193 .56292 Metetra
.702 .703 .847 r
.71193 .56292 .71574 .56896 .7237 .5653 .7199 .5592 Metetra
.705 .702 .845 r
.7199 .5592 .7237 .5653 .73167 .56154 .72788 .55539 Metetra
.707 .702 .842 r
.72788 .55539 .73167 .56154 .73965 .55768 .73587 .55146 Metetra
.71 .701 .84 r
.73587 .55146 .73965 .55768 .74764 .5537 .74387 .54742 Metetra
.714 .701 .837 r
.74387 .54742 .74764 .5537 .75564 .5496 .75188 .54325 Metetra
.717 .701 .833 r
.75188 .54325 .75564 .5496 .76364 .54535 .75989 .53892 Metetra
.721 .7 .83 r
.75989 .53892 .76364 .54535 .77164 .54094 .7679 .53443 Metetra
.726 .7 .825 r
.7679 .53443 .77164 .54094 .77964 .53634 .77591 .52974 Metetra
.731 .699 .821 r
.77591 .52974 .77964 .53634 .78764 .53153 .78391 .52483 Metetra
.736 .699 .816 r
.78391 .52483 .78764 .53153 .79563 .52647 .7919 .51967 Metetra
.743 .699 .81 r
.7919 .51967 .79563 .52647 .8036 .52112 .79988 .5142 Metetra
.75 .699 .803 r
.79988 .5142 .8036 .52112 .81156 .51543 .80784 .50836 Metetra
.758 .699 .795 r
.80784 .50836 .81156 .51543 .81949 .50932 .81577 .50209 Metetra
.767 .698 .786 r
.81577 .50209 .81949 .50932 .82737 .50269 .82365 .49529 Metetra
.778 .698 .776 r
.82365 .49529 .82737 .50269 .8352 .49543 .83148 .48781 Metetra
.79 .698 .763 r
.83148 .48781 .8352 .49543 .84295 .48734 .83921 .47945 Metetra
.805 .698 .747 r
.83921 .47945 .84295 .48734 .85058 .47816 .84683 .46993 Metetra
.823 .698 .727 r
.84683 .46993 .85058 .47816 .85805 .46746 .85427 .45876 Metetra
.844 .697 .7 r
.85427 .45876 .85805 .46746 .86527 .4545 .86144 .44511 Metetra
.87 .696 .664 r
.86144 .44511 .86527 .4545 .87206 .43783 .86812 .42723 Metetra
.905 .693 .605 r
.86812 .42723 .87206 .43783 .87797 .41352 .87371 .39975 Metetra
.928 .679 .541 r
.87371 .39975 .87797 .41352 .88024 .3574 .87701 .35263 Metetra
.664 .741 .908 r
.87701 .35263 .88024 .3574 .88837 .35482 .88515 .35003 Metetra
.664 .741 .908 r
.88515 .35003 .88837 .35482 .89652 .35223 .89332 .34743 Metetra
.664 .741 .908 r
.89332 .34743 .89652 .35223 .90469 .34963 .90151 .34482 Metetra
.664 .741 .908 r
.90151 .34482 .90469 .34963 .91289 .34703 .90973 .3422 Metetra
.664 .72 .891 r
.30953 .70161 .31395 .70621 .32098 .70397 .31657 .69935 Metetra
.664 .72 .891 r
.31657 .69935 .32098 .70397 .32803 .70172 .32363 .69708 Metetra
.664 .72 .89 r
.32363 .69708 .32803 .70172 .3351 .69945 .33071 .6948 Metetra
.664 .72 .89 r
.33071 .6948 .3351 .69945 .34219 .69717 .33781 .6925 Metetra
.665 .72 .89 r
.33781 .6925 .34219 .69717 .34929 .69489 .34492 .6902 Metetra
.665 .719 .889 r
.34492 .6902 .34929 .69489 .35642 .69259 .35206 .68788 Metetra
.665 .719 .889 r
.35206 .68788 .35642 .69259 .36356 .69028 .35921 .68556 Metetra
.665 .719 .889 r
.35921 .68556 .36356 .69028 .37072 .68796 .36638 .68322 Metetra
.666 .719 .888 r
.36638 .68322 .37072 .68796 .3779 .68563 .37357 .68087 Metetra
.666 .719 .888 r
.37357 .68087 .3779 .68563 .38509 .68328 .38078 .6785 Metetra
.666 .718 .888 r
.38078 .6785 .38509 .68328 .39231 .68093 .388 .67613 Metetra
.666 .718 .887 r
.388 .67613 .39231 .68093 .39954 .67856 .39525 .67374 Metetra
.667 .718 .887 r
.39525 .67374 .39954 .67856 .40679 .67617 .40251 .67134 Metetra
.667 .718 .886 r
.40251 .67134 .40679 .67617 .41406 .67378 .40979 .66892 Metetra
.667 .717 .886 r
.40979 .66892 .41406 .67378 .42135 .67137 .41709 .66649 Metetra
.668 .717 .886 r
.41709 .66649 .42135 .67137 .42866 .66895 .42441 .66405 Metetra
.668 .717 .885 r
.42441 .66405 .42866 .66895 .43599 .66651 .43175 .66159 Metetra
.668 .717 .885 r
.43175 .66159 .43599 .66651 .44333 .66406 .4391 .65912 Metetra
.669 .716 .884 r
.4391 .65912 .44333 .66406 .4507 .66159 .44648 .65663 Metetra
.669 .716 .884 r
.44648 .65663 .4507 .66159 .45808 .65911 .45387 .65413 Metetra
.67 .716 .883 r
.45387 .65413 .45808 .65911 .46548 .65661 .46128 .65161 Metetra
.67 .715 .883 r
.46128 .65161 .46548 .65661 .4729 .6541 .46871 .64907 Metetra
.67 .715 .882 r
.46871 .64907 .4729 .6541 .48034 .65156 .47616 .64652 Metetra
.671 .715 .882 r
.47616 .64652 .48034 .65156 .48779 .64902 .48363 .64395 Metetra
.671 .715 .881 r
.48363 .64395 .48779 .64902 .49527 .64645 .49112 .64136 Metetra
.672 .714 .88 r
.49112 .64136 .49527 .64645 .50276 .64386 .49863 .63875 Metetra
.672 .714 .88 r
.49863 .63875 .50276 .64386 .51028 .64126 .50615 .63612 Metetra
.673 .714 .879 r
.50615 .63612 .51028 .64126 .51781 .63864 .51369 .63347 Metetra
.673 .713 .878 r
.51369 .63347 .51781 .63864 .52536 .63599 .52126 .6308 Metetra
.674 .713 .878 r
.52126 .6308 .52536 .63599 .53293 .63333 .52884 .62811 Metetra
.675 .713 .877 r
.52884 .62811 .53293 .63333 .54052 .63064 .53644 .6254 Metetra
.675 .713 .876 r
.53644 .6254 .54052 .63064 .54812 .62793 .54406 .62266 Metetra
.676 .712 .876 r
.54406 .62266 .54812 .62793 .55575 .62519 .55169 .6199 Metetra
.677 .712 .875 r
.55169 .6199 .55575 .62519 .56339 .62243 .55935 .61711 Metetra
.677 .712 .874 r
.55935 .61711 .56339 .62243 .57105 .61965 .56702 .6143 Metetra
.678 .711 .873 r
.56702 .6143 .57105 .61965 .57873 .61683 .57471 .61145 Metetra
.679 .711 .872 r
.57471 .61145 .57873 .61683 .58643 .61399 .58242 .60858 Metetra
.68 .71 .871 r
.58242 .60858 .58643 .61399 .59415 .61112 .59015 .60568 Metetra
.681 .71 .87 r
.59015 .60568 .59415 .61112 .60188 .60821 .5979 .60275 Metetra
.682 .71 .869 r
.5979 .60275 .60188 .60821 .60964 .60528 .60566 .59978 Metetra
.683 .709 .868 r
.60566 .59978 .60964 .60528 .61741 .6023 .61345 .59677 Metetra
.684 .709 .867 r
.61345 .59677 .61741 .6023 .6252 .5993 .62125 .59373 Metetra
.685 .709 .866 r
.62125 .59373 .6252 .5993 .633 .59625 .62906 .59065 Metetra
.686 .708 .865 r
.62906 .59065 .633 .59625 .64082 .59316 .6369 .58752 Metetra
.687 .708 .864 r
.6369 .58752 .64082 .59316 .64866 .59002 .64475 .58435 Metetra
.689 .708 .862 r
.64475 .58435 .64866 .59002 .65652 .58684 .65262 .58113 Metetra
.69 .707 .861 r
.65262 .58113 .65652 .58684 .66439 .58361 .6605 .57786 Metetra
.692 .707 .859 r
.6605 .57786 .66439 .58361 .67228 .58032 .6684 .57453 Metetra
.693 .706 .858 r
.6684 .57453 .67228 .58032 .68018 .57698 .67631 .57114 Metetra
.695 .706 .856 r
.67631 .57114 .68018 .57698 .6881 .57357 .68424 .56769 Metetra
.697 .706 .854 r
.68424 .56769 .6881 .57357 .69603 .5701 .69218 .56417 Metetra
.699 .705 .852 r
.69218 .56417 .69603 .5701 .70398 .56655 .70014 .56057 Metetra
.701 .705 .85 r
.70014 .56057 .70398 .56655 .71193 .56292 .70811 .55688 Metetra
.704 .704 .848 r
.70811 .55688 .71193 .56292 .7199 .5592 .71609 .55311 Metetra
.706 .704 .845 r
.71609 .55311 .7199 .5592 .72788 .55539 .72408 .54924 Metetra
.709 .704 .843 r
.72408 .54924 .72788 .55539 .73587 .55146 .73208 .54525 Metetra
.712 .703 .84 r
.73208 .54525 .73587 .55146 .74387 .54742 .74009 .54115 Metetra
.716 .703 .837 r
.74009 .54115 .74387 .54742 .75188 .54325 .7481 .5369 Metetra
.719 .702 .833 r
.7481 .5369 .75188 .54325 .75989 .53892 .75612 .5325 Metetra
.724 .702 .829 r
.75612 .5325 .75989 .53892 .7679 .53443 .76414 .52793 Metetra
.728 .702 .825 r
.76414 .52793 .7679 .53443 .77591 .52974 .77216 .52315 Metetra
.733 .701 .82 r
.77216 .52315 .77591 .52974 .78391 .52483 .78017 .51814 Metetra
.739 .701 .815 r
.78017 .51814 .78391 .52483 .7919 .51967 .78817 .51287 Metetra
.746 .701 .809 r
.78817 .51287 .7919 .51967 .79988 .5142 .79615 .50727 Metetra
.753 .701 .802 r
.79615 .50727 .79988 .5142 .80784 .50836 .80411 .5013 Metetra
.761 .701 .794 r
.80411 .5013 .80784 .50836 .81577 .50209 .81204 .49487 Metetra
.771 .701 .785 r
.81204 .49487 .81577 .50209 .82365 .49529 .81992 .48788 Metetra
.782 .7 .774 r
.81992 .48788 .82365 .49529 .83148 .48781 .82774 .48017 Metetra
.795 .7 .76 r
.82774 .48017 .83148 .48781 .83921 .47945 .83547 .47154 Metetra
.81 .7 .743 r
.83547 .47154 .83921 .47945 .84683 .46993 .84307 .46165 Metetra
.828 .7 .722 r
.84307 .46165 .84683 .46993 .85427 .45876 .85048 .44999 Metetra
.85 .699 .694 r
.85048 .44999 .85427 .45876 .86144 .44511 .85758 .43558 Metetra
.878 .697 .654 r
.85758 .43558 .86144 .44511 .86812 .42723 .86413 .41628 Metetra
.917 .694 .584 r
.86413 .41628 .86812 .42723 .87371 .39975 .86924 .38408 Metetra
.89 .655 .576 r
.86924 .38408 .87371 .39975 .87701 .35263 .87376 .34783 Metetra
.664 .741 .908 r
.87376 .34783 .87701 .35263 .88515 .35003 .88193 .34522 Metetra
.664 .741 .908 r
.88193 .34522 .88515 .35003 .89332 .34743 .89011 .3426 Metetra
.664 .741 .908 r
.89011 .3426 .89332 .34743 .90151 .34482 .89832 .33998 Metetra
.664 .741 .908 r
.89832 .33998 .90151 .34482 .90973 .3422 .90655 .33735 Metetra
.664 .721 .892 r
.30509 .69701 .30953 .70161 .31657 .69935 .31214 .69473 Metetra
.664 .721 .891 r
.31214 .69473 .31657 .69935 .32363 .69708 .31921 .69244 Metetra
.664 .721 .891 r
.31921 .69244 .32363 .69708 .33071 .6948 .3263 .69014 Metetra
.665 .721 .891 r
.3263 .69014 .33071 .6948 .33781 .6925 .33341 .68783 Metetra
.665 .721 .89 r
.33341 .68783 .33781 .6925 .34492 .6902 .34053 .68551 Metetra
.665 .72 .89 r
.34053 .68551 .34492 .6902 .35206 .68788 .34768 .68318 Metetra
.665 .72 .89 r
.34768 .68318 .35206 .68788 .35921 .68556 .35484 .68083 Metetra
.666 .72 .889 r
.35484 .68083 .35921 .68556 .36638 .68322 .36202 .67847 Metetra
.666 .72 .889 r
.36202 .67847 .36638 .68322 .37357 .68087 .36922 .67611 Metetra
.666 .719 .889 r
.36922 .67611 .37357 .68087 .38078 .6785 .37644 .67372 Metetra
.667 .719 .888 r
.37644 .67372 .38078 .6785 .388 .67613 .38368 .67133 Metetra
.667 .719 .888 r
.38368 .67133 .388 .67613 .39525 .67374 .39093 .66892 Metetra
.667 .719 .887 r
.39093 .66892 .39525 .67374 .40251 .67134 .39821 .6665 Metetra
.667 .719 .887 r
.39821 .6665 .40251 .67134 .40979 .66892 .4055 .66407 Metetra
.668 .718 .887 r
.4055 .66407 .40979 .66892 .41709 .66649 .41281 .66162 Metetra
.668 .718 .886 r
.41281 .66162 .41709 .66649 .42441 .66405 .42014 .65915 Metetra
.668 .718 .886 r
.42014 .65915 .42441 .66405 .43175 .66159 .42749 .65668 Metetra
.669 .718 .885 r
.42749 .65668 .43175 .66159 .4391 .65912 .43486 .65418 Metetra
.669 .717 .885 r
.43486 .65418 .4391 .65912 .44648 .65663 .44224 .65167 Metetra
.67 .717 .884 r
.44224 .65167 .44648 .65663 .45387 .65413 .44965 .64915 Metetra
.67 .717 .884 r
.44965 .64915 .45387 .65413 .46128 .65161 .45707 .64661 Metetra
.671 .717 .883 r
.45707 .64661 .46128 .65161 .46871 .64907 .46451 .64405 Metetra
.671 .716 .883 r
.46451 .64405 .46871 .64907 .47616 .64652 .47197 .64147 Metetra
.671 .716 .882 r
.47197 .64147 .47616 .64652 .48363 .64395 .47945 .63888 Metetra
.672 .716 .881 r
.47945 .63888 .48363 .64395 .49112 .64136 .48695 .63627 Metetra
.672 .715 .881 r
.48695 .63627 .49112 .64136 .49863 .63875 .49447 .63363 Metetra
.673 .715 .88 r
.49447 .63363 .49863 .63875 .50615 .63612 .50201 .63098 Metetra
.673 .715 .88 r
.50201 .63098 .50615 .63612 .51369 .63347 .50956 .62831 Metetra
.674 .715 .879 r
.50956 .62831 .51369 .63347 .52126 .6308 .51714 .62562 Metetra
.675 .714 .878 r
.51714 .62562 .52126 .6308 .52884 .62811 .52473 .6229 Metetra
.675 .714 .878 r
.52473 .6229 .52884 .62811 .53644 .6254 .53234 .62016 Metetra
.676 .714 .877 r
.53234 .62016 .53644 .6254 .54406 .62266 .53997 .6174 Metetra
.677 .713 .876 r
.53997 .6174 .54406 .62266 .55169 .6199 .54762 .61461 Metetra
.677 .713 .875 r
.54762 .61461 .55169 .6199 .55935 .61711 .55529 .61179 Metetra
.678 .713 .875 r
.55529 .61179 .55935 .61711 .56702 .6143 .56297 .60895 Metetra
.679 .712 .874 r
.56297 .60895 .56702 .6143 .57471 .61145 .57068 .60608 Metetra
.68 .712 .873 r
.57068 .60608 .57471 .61145 .58242 .60858 .5784 .60318 Metetra
.681 .712 .872 r
.5784 .60318 .58242 .60858 .59015 .60568 .58614 .60025 Metetra
.682 .711 .871 r
.58614 .60025 .59015 .60568 .5979 .60275 .5939 .59728 Metetra
.683 .711 .87 r
.5939 .59728 .5979 .60275 .60566 .59978 .60167 .59428 Metetra
.684 .711 .869 r
.60167 .59428 .60566 .59978 .61345 .59677 .60947 .59124 Metetra
.685 .71 .868 r
.60947 .59124 .61345 .59677 .62125 .59373 .61728 .58816 Metetra
.686 .71 .867 r
.61728 .58816 .62125 .59373 .62906 .59065 .62511 .58505 Metetra
.687 .71 .865 r
.62511 .58505 .62906 .59065 .6369 .58752 .63295 .58188 Metetra
.688 .709 .864 r
.63295 .58188 .6369 .58752 .64475 .58435 .64082 .57868 Metetra
.69 .709 .863 r
.64082 .57868 .64475 .58435 .65262 .58113 .6487 .57542 Metetra
.691 .709 .861 r
.6487 .57542 .65262 .58113 .6605 .57786 .65659 .5721 Metetra
.693 .708 .86 r
.65659 .5721 .6605 .57786 .6684 .57453 .6645 .56874 Metetra
.695 .708 .858 r
.6645 .56874 .6684 .57453 .67631 .57114 .67243 .5653 Metetra
.696 .707 .856 r
.67243 .5653 .67631 .57114 .68424 .56769 .68037 .56181 Metetra
.698 .707 .854 r
.68037 .56181 .68424 .56769 .69218 .56417 .68832 .55824 Metetra
.701 .707 .852 r
.68832 .55824 .69218 .56417 .70014 .56057 .69629 .55459 Metetra
.703 .706 .85 r
.69629 .55459 .70014 .56057 .70811 .55688 .70427 .55085 Metetra
.705 .706 .848 r
.70427 .55085 .70811 .55688 .71609 .55311 .71226 .54703 Metetra
.708 .706 .845 r
.71226 .54703 .71609 .55311 .72408 .54924 .72026 .54309 Metetra
.711 .705 .843 r
.72026 .54309 .72408 .54924 .73208 .54525 .72827 .53905 Metetra
.714 .705 .84 r
.72827 .53905 .73208 .54525 .74009 .54115 .73629 .53488 Metetra
.718 .704 .837 r
.73629 .53488 .74009 .54115 .7481 .5369 .74431 .53056 Metetra
.722 .704 .833 r
.74431 .53056 .7481 .5369 .75612 .5325 .75234 .52608 Metetra
.726 .704 .829 r
.75234 .52608 .75612 .5325 .76414 .52793 .76037 .52143 Metetra
.731 .704 .825 r
.76037 .52143 .76414 .52793 .77216 .52315 .76839 .51656 Metetra
.736 .703 .82 r
.76839 .51656 .77216 .52315 .78017 .51814 .77641 .51145 Metetra
.742 .703 .815 r
.77641 .51145 .78017 .51814 .78817 .51287 .78442 .50607 Metetra
.749 .703 .808 r
.78442 .50607 .78817 .51287 .79615 .50727 .79241 .50035 Metetra
.756 .703 .801 r
.79241 .50035 .79615 .50727 .80411 .5013 .80037 .49424 Metetra
.765 .703 .793 r
.80037 .49424 .80411 .5013 .81204 .49487 .8083 .48765 Metetra
.775 .702 .783 r
.8083 .48765 .81204 .49487 .81992 .48788 .81618 .48046 Metetra
.786 .702 .771 r
.81618 .48046 .81992 .48788 .82774 .48017 .824 .47252 Metetra
.8 .702 .757 r
.824 .47252 .82774 .48017 .83547 .47154 .83171 .4636 Metetra
.816 .702 .74 r
.83171 .4636 .83547 .47154 .84307 .46165 .83929 .45333 Metetra
.834 .701 .717 r
.83929 .45333 .84307 .46165 .85048 .44999 .84666 .44113 Metetra
.857 .7 .686 r
.84666 .44113 .85048 .44999 .85758 .43558 .8537 .42587 Metetra
.886 .698 .642 r
.8537 .42587 .85758 .43558 .86413 .41628 .8601 .40486 Metetra
.934 .694 .55 r
.8601 .40486 .86413 .41628 .86924 .38408 .86423 .36331 Metetra
.777 .573 .624 r
.86423 .36331 .86924 .38408 .87376 .34783 .8705 .34301 Metetra
.664 .741 .908 r
.8705 .34301 .87376 .34783 .88193 .34522 .87868 .34038 Metetra
.664 .741 .908 r
.87868 .34038 .88193 .34522 .89011 .3426 .88688 .33775 Metetra
.664 .741 .908 r
.88688 .33775 .89011 .3426 .89832 .33998 .8951 .33511 Metetra
.664 .741 .908 r
.8951 .33511 .89832 .33998 .90655 .33735 .90335 .33247 Metetra
.664 .722 .892 r
.30062 .6924 .30509 .69701 .31214 .69473 .30769 .69011 Metetra
.664 .722 .892 r
.30769 .69011 .31214 .69473 .31921 .69244 .31477 .6878 Metetra
.665 .722 .892 r
.31477 .6878 .31921 .69244 .3263 .69014 .32187 .68548 Metetra
.665 .722 .891 r
.32187 .68548 .3263 .69014 .33341 .68783 .32899 .68316 Metetra
.665 .721 .891 r
.32899 .68316 .33341 .68783 .34053 .68551 .33612 .68082 Metetra
.665 .721 .891 r
.33612 .68082 .34053 .68551 .34768 .68318 .34328 .67847 Metetra
.666 .721 .89 r
.34328 .67847 .34768 .68318 .35484 .68083 .35045 .6761 Metetra
.666 .721 .89 r
.35045 .6761 .35484 .68083 .36202 .67847 .35765 .67373 Metetra
.666 .721 .889 r
.35765 .67373 .36202 .67847 .36922 .67611 .36486 .67134 Metetra
.667 .72 .889 r
.36486 .67134 .36922 .67611 .37644 .67372 .37209 .66894 Metetra
.667 .72 .889 r
.37209 .66894 .37644 .67372 .38368 .67133 .37933 .66653 Metetra
.667 .72 .888 r
.37933 .66653 .38368 .67133 .39093 .66892 .3866 .6641 Metetra
.668 .72 .888 r
.3866 .6641 .39093 .66892 .39821 .6665 .39388 .66166 Metetra
.668 .719 .887 r
.39388 .66166 .39821 .6665 .4055 .66407 .40119 .65921 Metetra
.668 .719 .887 r
.40119 .65921 .4055 .66407 .41281 .66162 .40851 .65674 Metetra
.669 .719 .887 r
.40851 .65674 .41281 .66162 .42014 .65915 .41585 .65426 Metetra
.669 .719 .886 r
.41585 .65426 .42014 .65915 .42749 .65668 .42321 .65176 Metetra
.669 .719 .886 r
.42321 .65176 .42749 .65668 .43486 .65418 .43059 .64924 Metetra
.67 .718 .885 r
.43059 .64924 .43486 .65418 .44224 .65167 .43799 .64671 Metetra
.67 .718 .885 r
.43799 .64671 .44224 .65167 .44965 .64915 .4454 .64417 Metetra
.671 .718 .884 r
.4454 .64417 .44965 .64915 .45707 .64661 .45284 .6416 Metetra
.671 .718 .884 r
.45284 .6416 .45707 .64661 .46451 .64405 .46029 .63902 Metetra
.671 .717 .883 r
.46029 .63902 .46451 .64405 .47197 .64147 .46776 .63643 Metetra
.672 .717 .883 r
.46776 .63643 .47197 .64147 .47945 .63888 .47526 .63381 Metetra
.672 .717 .882 r
.47526 .63381 .47945 .63888 .48695 .63627 .48277 .63117 Metetra
.673 .716 .881 r
.48277 .63117 .48695 .63627 .49447 .63363 .4903 .62852 Metetra
.674 .716 .881 r
.4903 .62852 .49447 .63363 .50201 .63098 .49784 .62584 Metetra
.674 .716 .88 r
.49784 .62584 .50201 .63098 .50956 .62831 .50541 .62315 Metetra
.675 .716 .879 r
.50541 .62315 .50956 .62831 .51714 .62562 .513 .62043 Metetra
.675 .715 .879 r
.513 .62043 .51714 .62562 .52473 .6229 .5206 .61769 Metetra
.676 .715 .878 r
.5206 .61769 .52473 .6229 .53234 .62016 .52822 .61492 Metetra
.677 .715 .877 r
.52822 .61492 .53234 .62016 .53997 .6174 .53587 .61213 Metetra
.677 .714 .877 r
.53587 .61213 .53997 .6174 .54762 .61461 .54353 .60931 Metetra
.678 .714 .876 r
.54353 .60931 .54762 .61461 .55529 .61179 .55121 .60647 Metetra
.679 .714 .875 r
.55121 .60647 .55529 .61179 .56297 .60895 .5589 .6036 Metetra
.68 .714 .874 r
.5589 .6036 .56297 .60895 .57068 .60608 .56662 .6007 Metetra
.681 .713 .873 r
.56662 .6007 .57068 .60608 .5784 .60318 .57435 .59777 Metetra
.681 .713 .872 r
.57435 .59777 .5784 .60318 .58614 .60025 .58211 .59481 Metetra
.682 .713 .871 r
.58211 .59481 .58614 .60025 .5939 .59728 .58988 .59181 Metetra
.683 .712 .87 r
.58988 .59181 .5939 .59728 .60167 .59428 .59767 .58878 Metetra
.684 .712 .869 r
.59767 .58878 .60167 .59428 .60947 .59124 .60547 .58571 Metetra
.686 .712 .868 r
.60547 .58571 .60947 .59124 .61728 .58816 .6133 .5826 Metetra
.687 .711 .867 r
.6133 .5826 .61728 .58816 .62511 .58505 .62114 .57945 Metetra
.688 .711 .866 r
.62114 .57945 .62511 .58505 .63295 .58188 .62899 .57625 Metetra
.689 .711 .864 r
.62899 .57625 .63295 .58188 .64082 .57868 .63687 .573 Metetra
.691 .71 .863 r
.63687 .573 .64082 .57868 .6487 .57542 .64476 .56971 Metetra
.692 .71 .862 r
.64476 .56971 .6487 .57542 .65659 .5721 .65267 .56635 Metetra
.694 .709 .86 r
.65267 .56635 .65659 .5721 .6645 .56874 .66059 .56294 Metetra
.696 .709 .858 r
.66059 .56294 .6645 .56874 .67243 .5653 .66853 .55947 Metetra
.698 .709 .857 r
.66853 .55947 .67243 .5653 .68037 .56181 .67648 .55593 Metetra
.7 .708 .855 r
.67648 .55593 .68037 .56181 .68832 .55824 .68445 .55231 Metetra
.702 .708 .853 r
.68445 .55231 .68832 .55824 .69629 .55459 .69243 .54861 Metetra
.704 .708 .85 r
.69243 .54861 .69629 .55459 .70427 .55085 .70042 .54482 Metetra
.707 .707 .848 r
.70042 .54482 .70427 .55085 .71226 .54703 .70842 .54094 Metetra
.71 .707 .846 r
.70842 .54094 .71226 .54703 .72026 .54309 .71643 .53695 Metetra
.713 .707 .843 r
.71643 .53695 .72026 .54309 .72827 .53905 .72445 .53284 Metetra
.716 .706 .84 r
.72445 .53284 .72827 .53905 .73629 .53488 .73248 .52861 Metetra
.72 .706 .837 r
.73248 .52861 .73629 .53488 .74431 .53056 .74051 .52422 Metetra
.724 .706 .833 r
.74051 .52422 .74431 .53056 .75234 .52608 .74855 .51967 Metetra
.728 .706 .829 r
.74855 .51967 .75234 .52608 .76037 .52143 .75659 .51492 Metetra
.733 .705 .824 r
.75659 .51492 .76037 .52143 .76839 .51656 .76462 .50997 Metetra
.739 .705 .82 r
.76462 .50997 .76839 .51656 .77641 .51145 .77264 .50476 Metetra
.745 .705 .814 r
.77264 .50476 .77641 .51145 .78442 .50607 .78066 .49926 Metetra
.752 .705 .807 r
.78066 .49926 .78442 .50607 .79241 .50035 .78865 .49342 Metetra
.76 .705 .8 r
.78865 .49342 .79241 .50035 .80037 .49424 .79662 .48717 Metetra
.768 .704 .791 r
.79662 .48717 .80037 .49424 .8083 .48765 .80455 .48041 Metetra
.779 .704 .781 r
.80455 .48041 .8083 .48765 .81618 .48046 .81243 .47303 Metetra
.791 .704 .769 r
.81243 .47303 .81618 .48046 .824 .47252 .82024 .46485 Metetra
.804 .704 .754 r
.82024 .46485 .824 .47252 .83171 .4636 .82794 .45563 Metetra
.821 .704 .735 r
.82794 .45563 .83171 .4636 .83929 .45333 .8355 .44496 Metetra
.84 .703 .711 r
.8355 .44496 .83929 .45333 .84666 .44113 .84283 .43218 Metetra
.864 .701 .678 r
.84283 .43218 .84666 .44113 .8537 .42587 .84979 .41596 Metetra
.895 .698 .629 r
.84979 .41596 .8537 .42587 .8601 .40486 .85599 .39278 Metetra
.945 .692 .523 r
.85599 .39278 .8601 .40486 .86423 .36331 .85905 .34079 Metetra
.603 .458 .657 r
.85905 .34079 .86423 .36331 .8705 .34301 .86722 .33816 Metetra
.664 .741 .908 r
.86722 .33816 .8705 .34301 .87868 .34038 .87542 .33552 Metetra
.664 .741 .908 r
.87542 .33552 .87868 .34038 .88688 .33775 .88363 .33288 Metetra
.664 .741 .908 r
.88363 .33288 .88688 .33775 .8951 .33511 .89188 .33023 Metetra
.664 .741 .908 r
.89188 .33023 .8951 .33511 .90335 .33247 .90014 .32757 Metetra
.665 .723 .893 r
.29614 .68779 .30062 .6924 .30769 .69011 .30321 .68548 Metetra
.665 .723 .892 r
.30321 .68548 .30769 .69011 .31477 .6878 .31031 .68316 Metetra
.665 .723 .892 r
.31031 .68316 .31477 .6878 .32187 .68548 .31742 .68082 Metetra
.665 .722 .892 r
.31742 .68082 .32187 .68548 .32899 .68316 .32455 .67848 Metetra
.666 .722 .891 r
.32455 .67848 .32899 .68316 .33612 .68082 .33169 .67612 Metetra
.666 .722 .891 r
.33169 .67612 .33612 .68082 .34328 .67847 .33886 .67375 Metetra
.666 .722 .891 r
.33886 .67375 .34328 .67847 .35045 .6761 .34604 .67137 Metetra
.666 .722 .89 r
.34604 .67137 .35045 .6761 .35765 .67373 .35325 .66898 Metetra
.667 .721 .89 r
.35325 .66898 .35765 .67373 .36486 .67134 .36047 .66657 Metetra
.667 .721 .89 r
.36047 .66657 .36486 .67134 .37209 .66894 .36771 .66415 Metetra
.667 .721 .889 r
.36771 .66415 .37209 .66894 .37933 .66653 .37497 .66172 Metetra
.668 .721 .889 r
.37497 .66172 .37933 .66653 .3866 .6641 .38225 .65928 Metetra
.668 .721 .888 r
.38225 .65928 .3866 .6641 .39388 .66166 .38954 .65682 Metetra
.668 .72 .888 r
.38954 .65682 .39388 .66166 .40119 .65921 .39686 .65434 Metetra
.669 .72 .887 r
.39686 .65434 .40119 .65921 .40851 .65674 .40419 .65186 Metetra
.669 .72 .887 r
.40419 .65186 .40851 .65674 .41585 .65426 .41154 .64935 Metetra
.669 .72 .887 r
.41154 .64935 .41585 .65426 .42321 .65176 .41891 .64683 Metetra
.67 .719 .886 r
.41891 .64683 .42321 .65176 .43059 .64924 .4263 .6443 Metetra
.67 .719 .886 r
.4263 .6443 .43059 .64924 .43799 .64671 .43371 .64175 Metetra
.671 .719 .885 r
.43371 .64175 .43799 .64671 .4454 .64417 .44114 .63918 Metetra
.671 .719 .885 r
.44114 .63918 .4454 .64417 .45284 .6416 .44859 .6366 Metetra
.672 .718 .884 r
.44859 .6366 .45284 .6416 .46029 .63902 .45605 .634 Metetra
.672 .718 .884 r
.45605 .634 .46029 .63902 .46776 .63643 .46354 .63138 Metetra
.672 .718 .883 r
.46354 .63138 .46776 .63643 .47526 .63381 .47104 .62874 Metetra
.673 .718 .882 r
.47104 .62874 .47526 .63381 .48277 .63117 .47856 .62608 Metetra
.674 .717 .882 r
.47856 .62608 .48277 .63117 .4903 .62852 .4861 .6234 Metetra
.674 .717 .881 r
.4861 .6234 .4903 .62852 .49784 .62584 .49366 .6207 Metetra
.675 .717 .881 r
.49366 .6207 .49784 .62584 .50541 .62315 .50124 .61798 Metetra
.675 .717 .88 r
.50124 .61798 .50541 .62315 .513 .62043 .50884 .61524 Metetra
.676 .716 .879 r
.50884 .61524 .513 .62043 .5206 .61769 .51646 .61247 Metetra
.677 .716 .879 r
.51646 .61247 .5206 .61769 .52822 .61492 .52409 .60968 Metetra
.677 .716 .878 r
.52409 .60968 .52822 .61492 .53587 .61213 .53174 .60686 Metetra
.678 .716 .877 r
.53174 .60686 .53587 .61213 .54353 .60931 .53942 .60402 Metetra
.679 .715 .876 r
.53942 .60402 .54353 .60931 .55121 .60647 .54711 .60115 Metetra
.68 .715 .875 r
.54711 .60115 .55121 .60647 .5589 .6036 .55482 .59825 Metetra
.68 .715 .875 r
.55482 .59825 .5589 .6036 .56662 .6007 .56255 .59532 Metetra
.681 .714 .874 r
.56255 .59532 .56662 .6007 .57435 .59777 .57029 .59236 Metetra
.682 .714 .873 r
.57029 .59236 .57435 .59777 .58211 .59481 .57806 .58937 Metetra
.683 .714 .872 r
.57806 .58937 .58211 .59481 .58988 .59181 .58584 .58634 Metetra
.684 .713 .871 r
.58584 .58634 .58988 .59181 .59767 .58878 .59364 .58328 Metetra
.685 .713 .87 r
.59364 .58328 .59767 .58878 .60547 .58571 .60146 .58018 Metetra
.687 .713 .868 r
.60146 .58018 .60547 .58571 .6133 .5826 .6093 .57703 Metetra
.688 .712 .867 r
.6093 .57703 .6133 .5826 .62114 .57945 .61715 .57384 Metetra
.689 .712 .866 r
.61715 .57384 .62114 .57945 .62899 .57625 .62502 .57061 Metetra
.69 .712 .865 r
.62502 .57061 .62899 .57625 .63687 .573 .63291 .56733 Metetra
.692 .711 .863 r
.63291 .56733 .63687 .573 .64476 .56971 .64081 .56399 Metetra
.694 .711 .862 r
.64081 .56399 .64476 .56971 .65267 .56635 .64873 .5606 Metetra
.695 .711 .86 r
.64873 .5606 .65267 .56635 .66059 .56294 .65666 .55715 Metetra
.697 .71 .859 r
.65666 .55715 .66059 .56294 .66853 .55947 .66461 .55363 Metetra
.699 .71 .857 r
.66461 .55363 .66853 .55947 .67648 .55593 .67258 .55004 Metetra
.701 .71 .855 r
.67258 .55004 .67648 .55593 .68445 .55231 .68055 .54638 Metetra
.703 .709 .853 r
.68055 .54638 .68445 .55231 .69243 .54861 .68854 .54263 Metetra
.706 .709 .851 r
.68854 .54263 .69243 .54861 .70042 .54482 .69655 .53879 Metetra
.708 .709 .848 r
.69655 .53879 .70042 .54482 .70842 .54094 .70456 .53486 Metetra
.711 .708 .846 r
.70456 .53486 .70842 .54094 .71643 .53695 .71258 .53081 Metetra
.714 .708 .843 r
.71258 .53081 .71643 .53695 .72445 .53284 .72062 .52664 Metetra
.718 .708 .84 r
.72062 .52664 .72445 .53284 .73248 .52861 .72865 .52233 Metetra
.722 .708 .836 r
.72865 .52233 .73248 .52861 .74051 .52422 .7367 .51788 Metetra
.726 .707 .833 r
.7367 .51788 .74051 .52422 .74855 .51967 .74474 .51325 Metetra
.73 .707 .829 r
.74474 .51325 .74855 .51967 .75659 .51492 .75279 .50842 Metetra
.735 .707 .824 r
.75279 .50842 .75659 .51492 .76462 .50997 .76083 .50337 Metetra
.741 .707 .819 r
.76083 .50337 .76462 .50997 .77264 .50476 .76886 .49807 Metetra
.747 .707 .813 r
.76886 .49807 .77264 .50476 .78066 .49926 .77688 .49246 Metetra
.755 .706 .806 r
.77688 .49246 .78066 .49926 .78865 .49342 .78488 .48649 Metetra
.763 .706 .799 r
.78488 .48649 .78865 .49342 .79662 .48717 .79286 .48009 Metetra
.772 .706 .79 r
.79286 .48009 .79662 .48717 .80455 .48041 .80079 .47316 Metetra
.783 .706 .779 r
.80079 .47316 .80455 .48041 .81243 .47303 .80867 .46558 Metetra
.795 .706 .766 r
.80867 .46558 .81243 .47303 .82024 .46485 .81647 .45715 Metetra
.809 .706 .751 r
.81647 .45715 .82024 .46485 .82794 .45563 .82416 .44761 Metetra
.826 .705 .731 r
.82416 .44761 .82794 .45563 .8355 .44496 .83169 .43651 Metetra
.846 .704 .705 r
.83169 .43651 .8355 .44496 .84283 .43218 .83898 .4231 Metetra
.871 .702 .67 r
.83898 .4231 .84283 .43218 .84979 .41596 .84585 .40577 Metetra
.905 .698 .612 r
.84585 .40577 .84979 .41596 .85599 .39278 .85177 .37969 Metetra
.927 .682 .548 r
.85177 .37969 .85599 .39278 .85905 .34079 .85574 .33593 Metetra
.664 .741 .908 r
.85574 .33593 .85905 .34079 .86722 .33816 .86393 .33328 Metetra
.664 .741 .908 r
.86393 .33328 .86722 .33816 .87542 .33552 .87214 .33063 Metetra
.664 .741 .908 r
.87214 .33063 .87542 .33552 .88363 .33288 .88037 .32798 Metetra
.664 .741 .908 r
.88037 .32798 .88363 .33288 .89188 .33023 .88863 .32531 Metetra
.664 .741 .908 r
.88863 .32531 .89188 .33023 .90014 .32757 .89691 .32264 Metetra
.665 .724 .893 r
.29164 .68317 .29614 .68779 .30321 .68548 .29872 .68085 Metetra
.665 .724 .893 r
.29872 .68085 .30321 .68548 .31031 .68316 .30582 .67851 Metetra
.665 .723 .892 r
.30582 .67851 .31031 .68316 .31742 .68082 .31295 .67616 Metetra
.666 .723 .892 r
.31295 .67616 .31742 .68082 .32455 .67848 .32009 .67379 Metetra
.666 .723 .892 r
.32009 .67379 .32455 .67848 .33169 .67612 .32724 .67142 Metetra
.666 .723 .891 r
.32724 .67142 .33169 .67612 .33886 .67375 .33442 .66903 Metetra
.666 .723 .891 r
.33442 .66903 .33886 .67375 .34604 .67137 .34162 .66664 Metetra
.667 .722 .891 r
.34162 .66664 .34604 .67137 .35325 .66898 .34883 .66422 Metetra
.667 .722 .89 r
.34883 .66422 .35325 .66898 .36047 .66657 .35606 .6618 Metetra
.667 .722 .89 r
.35606 .6618 .36047 .66657 .36771 .66415 .36331 .65936 Metetra
.668 .722 .89 r
.36331 .65936 .36771 .66415 .37497 .66172 .37058 .65691 Metetra
.668 .722 .889 r
.37058 .65691 .37497 .66172 .38225 .65928 .37787 .65445 Metetra
.668 .721 .889 r
.37787 .65445 .38225 .65928 .38954 .65682 .38518 .65197 Metetra
.669 .721 .888 r
.38518 .65197 .38954 .65682 .39686 .65434 .3925 .64948 Metetra
.669 .721 .888 r
.3925 .64948 .39686 .65434 .40419 .65186 .39985 .64697 Metetra
.669 .721 .887 r
.39985 .64697 .40419 .65186 .41154 .64935 .40721 .64445 Metetra
.67 .721 .887 r
.40721 .64445 .41154 .64935 .41891 .64683 .4146 .64191 Metetra
.67 .72 .887 r
.4146 .64191 .41891 .64683 .4263 .6443 .422 .63935 Metetra
.671 .72 .886 r
.422 .63935 .4263 .6443 .43371 .64175 .42942 .63678 Metetra
.671 .72 .886 r
.42942 .63678 .43371 .64175 .44114 .63918 .43686 .63419 Metetra
.672 .72 .885 r
.43686 .63419 .44114 .63918 .44859 .6366 .44431 .63159 Metetra
.672 .719 .885 r
.44431 .63159 .44859 .6366 .45605 .634 .45179 .62896 Metetra
.672 .719 .884 r
.45179 .62896 .45605 .634 .46354 .63138 .45929 .62632 Metetra
.673 .719 .883 r
.45929 .62632 .46354 .63138 .47104 .62874 .4668 .62366 Metetra
.674 .719 .883 r
.4668 .62366 .47104 .62874 .47856 .62608 .47434 .62098 Metetra
.674 .718 .882 r
.47434 .62098 .47856 .62608 .4861 .6234 .48189 .61828 Metetra
.675 .718 .882 r
.48189 .61828 .4861 .6234 .49366 .6207 .48946 .61555 Metetra
.675 .718 .881 r
.48946 .61555 .49366 .6207 .50124 .61798 .49705 .61281 Metetra
.676 .718 .88 r
.49705 .61281 .50124 .61798 .50884 .61524 .50466 .61004 Metetra
.677 .717 .88 r
.50466 .61004 .50884 .61524 .51646 .61247 .51229 .60725 Metetra
.677 .717 .879 r
.51229 .60725 .51646 .61247 .52409 .60968 .51994 .60443 Metetra
.678 .717 .878 r
.51994 .60443 .52409 .60968 .53174 .60686 .5276 .60159 Metetra
.679 .716 .877 r
.5276 .60159 .53174 .60686 .53942 .60402 .53529 .59872 Metetra
.679 .716 .877 r
.53529 .59872 .53942 .60402 .54711 .60115 .54299 .59582 Metetra
.68 .716 .876 r
.54299 .59582 .54711 .60115 .55482 .59825 .55071 .5929 Metetra
.681 .716 .875 r
.55071 .5929 .55482 .59825 .56255 .59532 .55845 .58994 Metetra
.682 .715 .874 r
.55845 .58994 .56255 .59532 .57029 .59236 .56621 .58695 Metetra
.683 .715 .873 r
.56621 .58695 .57029 .59236 .57806 .58937 .57399 .58393 Metetra
.684 .715 .872 r
.57399 .58393 .57806 .58937 .58584 .58634 .58179 .58087 Metetra
.685 .714 .871 r
.58179 .58087 .58584 .58634 .59364 .58328 .5896 .57777 Metetra
.686 .714 .87 r
.5896 .57777 .59364 .58328 .60146 .58018 .59743 .57464 Metetra
.687 .714 .869 r
.59743 .57464 .60146 .58018 .6093 .57703 .60528 .57146 Metetra
.689 .714 .868 r
.60528 .57146 .6093 .57703 .61715 .57384 .61314 .56824 Metetra
.69 .713 .866 r
.61314 .56824 .61715 .57384 .62502 .57061 .62103 .56497 Metetra
.691 .713 .865 r
.62103 .56497 .62502 .57061 .63291 .56733 .62892 .56165 Metetra
.693 .713 .864 r
.62892 .56165 .63291 .56733 .64081 .56399 .63684 .55828 Metetra
.695 .712 .862 r
.63684 .55828 .64081 .56399 .64873 .5606 .64477 .55485 Metetra
.696 .712 .86 r
.64477 .55485 .64873 .5606 .65666 .55715 .65272 .55135 Metetra
.698 .712 .859 r
.65272 .55135 .65666 .55715 .66461 .55363 .66068 .54779 Metetra
.7 .711 .857 r
.66068 .54779 .66461 .55363 .67258 .55004 .66866 .54416 Metetra
.702 .711 .855 r
.66866 .54416 .67258 .55004 .68055 .54638 .67665 .54045 Metetra
.705 .711 .853 r
.67665 .54045 .68055 .54638 .68854 .54263 .68465 .53665 Metetra
.707 .71 .851 r
.68465 .53665 .68854 .54263 .69655 .53879 .69266 .53276 Metetra
.71 .71 .848 r
.69266 .53276 .69655 .53879 .70456 .53486 .70069 .52877 Metetra
.713 .71 .846 r
.70069 .52877 .70456 .53486 .71258 .53081 .70872 .52466 Metetra
.716 .71 .843 r
.70872 .52466 .71258 .53081 .72062 .52664 .71676 .52043 Metetra
.72 .709 .84 r
.71676 .52043 .72062 .52664 .72865 .52233 .72481 .51606 Metetra
.724 .709 .836 r
.72481 .51606 .72865 .52233 .7367 .51788 .73287 .51153 Metetra
.728 .709 .832 r
.73287 .51153 .7367 .51788 .74474 .51325 .74092 .50682 Metetra
.733 .709 .828 r
.74092 .50682 .74474 .51325 .75279 .50842 .74898 .50191 Metetra
.738 .708 .823 r
.74898 .50191 .75279 .50842 .76083 .50337 .75703 .49677 Metetra
.744 .708 .818 r
.75703 .49677 .76083 .50337 .76886 .49807 .76507 .49136 Metetra
.75 .708 .812 r
.76507 .49136 .76886 .49807 .77688 .49246 .7731 .48564 Metetra
.758 .708 .805 r
.7731 .48564 .77688 .49246 .78488 .48649 .7811 .47954 Metetra
.766 .708 .797 r
.7811 .47954 .78488 .48649 .79286 .48009 .78908 .473 Metetra
.775 .708 .788 r
.78908 .473 .79286 .48009 .80079 .47316 .79701 .4659 Metetra
.786 .708 .777 r
.79701 .4659 .80079 .47316 .80867 .46558 .80489 .4581 Metetra
.799 .707 .764 r
.80489 .4581 .80867 .46558 .81647 .45715 .81268 .44942 Metetra
.814 .707 .747 r
.81268 .44942 .81647 .45715 .82416 .44761 .82036 .43954 Metetra
.831 .706 .726 r
.82036 .43954 .82416 .44761 .83169 .43651 .82787 .42799 Metetra
.852 .705 .699 r
.82787 .42799 .83169 .43651 .83898 .4231 .83511 .41387 Metetra
.878 .702 .66 r
.83511 .41387 .83898 .4231 .84585 .40577 .84187 .39524 Metetra
.917 .698 .591 r
.84187 .39524 .84585 .40577 .85177 .37969 .84737 .36481 Metetra
.889 .659 .584 r
.84737 .36481 .85177 .37969 .85574 .33593 .85241 .33104 Metetra
.664 .741 .908 r
.85241 .33104 .85574 .33593 .86393 .33328 .86061 .32839 Metetra
.664 .741 .908 r
.86061 .32839 .86393 .33328 .87214 .33063 .86884 .32572 Metetra
.664 .741 .908 r
.86884 .32572 .87214 .33063 .88037 .32798 .87709 .32305 Metetra
.664 .741 .908 r
.87709 .32305 .88037 .32798 .88863 .32531 .88537 .32037 Metetra
.664 .741 .908 r
.88537 .32037 .88863 .32531 .89691 .32264 .89366 .31769 Metetra
.665 .724 .893 r
.28711 .67855 .29164 .68317 .29872 .68085 .29421 .67621 Metetra
.665 .724 .893 r
.29421 .67621 .29872 .68085 .30582 .67851 .30132 .67385 Metetra
.666 .724 .893 r
.30132 .67385 .30582 .67851 .31295 .67616 .30845 .67148 Metetra
.666 .724 .892 r
.30845 .67148 .31295 .67616 .32009 .67379 .3156 .6691 Metetra
.666 .724 .892 r
.3156 .6691 .32009 .67379 .32724 .67142 .32277 .66671 Metetra
.666 .724 .892 r
.32277 .66671 .32724 .67142 .33442 .66903 .32996 .66431 Metetra
.667 .723 .891 r
.32996 .66431 .33442 .66903 .34162 .66664 .33717 .66189 Metetra
.667 .723 .891 r
.33717 .66189 .34162 .66664 .34883 .66422 .34439 .65946 Metetra
.667 .723 .891 r
.34439 .65946 .34883 .66422 .35606 .6618 .35163 .65702 Metetra
.668 .723 .89 r
.35163 .65702 .35606 .6618 .36331 .65936 .3589 .65457 Metetra
.668 .723 .89 r
.3589 .65457 .36331 .65936 .37058 .65691 .36618 .6521 Metetra
.668 .722 .89 r
.36618 .6521 .37058 .65691 .37787 .65445 .37348 .64961 Metetra
.669 .722 .889 r
.37348 .64961 .37787 .65445 .38518 .65197 .38079 .64712 Metetra
.669 .722 .889 r
.38079 .64712 .38518 .65197 .3925 .64948 .38813 .6446 Metetra
.669 .722 .888 r
.38813 .6446 .3925 .64948 .39985 .64697 .39549 .64207 Metetra
.67 .722 .888 r
.39549 .64207 .39985 .64697 .40721 .64445 .40286 .63953 Metetra
.67 .721 .887 r
.40286 .63953 .40721 .64445 .4146 .64191 .41026 .63697 Metetra
.671 .721 .887 r
.41026 .63697 .4146 .64191 .422 .63935 .41767 .6344 Metetra
.671 .721 .886 r
.41767 .6344 .422 .63935 .42942 .63678 .4251 .63181 Metetra
.672 .721 .886 r
.4251 .63181 .42942 .63678 .43686 .63419 .43255 .6292 Metetra
.672 .72 .885 r
.43255 .6292 .43686 .63419 .44431 .63159 .44002 .62657 Metetra
.672 .72 .885 r
.44002 .62657 .44431 .63159 .45179 .62896 .44751 .62392 Metetra
.673 .72 .884 r
.44751 .62392 .45179 .62896 .45929 .62632 .45502 .62126 Metetra
.673 .72 .884 r
.45502 .62126 .45929 .62632 .4668 .62366 .46255 .61858 Metetra
.674 .719 .883 r
.46255 .61858 .4668 .62366 .47434 .62098 .47009 .61587 Metetra
.675 .719 .883 r
.47009 .61587 .47434 .62098 .48189 .61828 .47766 .61315 Metetra
.675 .719 .882 r
.47766 .61315 .48189 .61828 .48946 .61555 .48524 .6104 Metetra
.676 .719 .881 r
.48524 .6104 .48946 .61555 .49705 .61281 .49284 .60763 Metetra
.676 .718 .881 r
.49284 .60763 .49705 .61281 .50466 .61004 .50047 .60484 Metetra
.677 .718 .88 r
.50047 .60484 .50466 .61004 .51229 .60725 .50811 .60202 Metetra
.678 .718 .879 r
.50811 .60202 .51229 .60725 .51994 .60443 .51577 .59918 Metetra
.679 .718 .879 r
.51577 .59918 .51994 .60443 .5276 .60159 .52345 .59631 Metetra
.679 .717 .878 r
.52345 .59631 .5276 .60159 .53529 .59872 .53114 .59342 Metetra
.68 .717 .877 r
.53114 .59342 .53529 .59872 .54299 .59582 .53886 .59049 Metetra
.681 .717 .876 r
.53886 .59049 .54299 .59582 .55071 .5929 .54659 .58754 Metetra
.682 .717 .875 r
.54659 .58754 .55071 .5929 .55845 .58994 .55435 .58455 Metetra
.683 .716 .874 r
.55435 .58455 .55845 .58994 .56621 .58695 .56212 .58153 Metetra
.684 .716 .873 r
.56212 .58153 .56621 .58695 .57399 .58393 .56991 .57848 Metetra
.685 .716 .872 r
.56991 .57848 .57399 .58393 .58179 .58087 .57771 .57539 Metetra
.686 .715 .871 r
.57771 .57539 .58179 .58087 .5896 .57777 .58554 .57226 Metetra
.687 .715 .87 r
.58554 .57226 .5896 .57777 .59743 .57464 .59338 .5691 Metetra
.688 .715 .869 r
.59338 .5691 .59743 .57464 .60528 .57146 .60124 .56589 Metetra
.69 .715 .868 r
.60124 .56589 .60528 .57146 .61314 .56824 .60912 .56263 Metetra
.691 .714 .867 r
.60912 .56263 .61314 .56824 .62103 .56497 .61702 .55932 Metetra
.692 .714 .865 r
.61702 .55932 .62103 .56497 .62892 .56165 .62493 .55597 Metetra
.694 .714 .864 r
.62493 .55597 .62892 .56165 .63684 .55828 .63285 .55256 Metetra
.696 .713 .862 r
.63285 .55256 .63684 .55828 .64477 .55485 .6408 .54908 Metetra
.697 .713 .861 r
.6408 .54908 .64477 .55485 .65272 .55135 .64876 .54555 Metetra
.699 .713 .859 r
.64876 .54555 .65272 .55135 .66068 .54779 .65673 .54195 Metetra
.701 .713 .857 r
.65673 .54195 .66068 .54779 .66866 .54416 .66472 .53827 Metetra
.704 .712 .855 r
.66472 .53827 .66866 .54416 .67665 .54045 .67272 .53451 Metetra
.706 .712 .853 r
.67272 .53451 .67665 .54045 .68465 .53665 .68073 .53066 Metetra
.709 .712 .851 r
.68073 .53066 .68465 .53665 .69266 .53276 .68876 .52672 Metetra
.711 .711 .848 r
.68876 .52672 .69266 .53276 .70069 .52877 .6968 .52267 Metetra
.715 .711 .846 r
.6968 .52267 .70069 .52877 .70872 .52466 .70484 .51851 Metetra
.718 .711 .843 r
.70484 .51851 .70872 .52466 .71676 .52043 .7129 .51421 Metetra
.721 .711 .839 r
.7129 .51421 .71676 .52043 .72481 .51606 .72096 .50978 Metetra
.725 .71 .836 r
.72096 .50978 .72481 .51606 .73287 .51153 .72902 .50518 Metetra
.73 .71 .832 r
.72902 .50518 .73287 .51153 .74092 .50682 .73709 .50039 Metetra
.735 .71 .828 r
.73709 .50039 .74092 .50682 .74898 .50191 .74515 .4954 Metetra
.74 .71 .823 r
.74515 .4954 .74898 .50191 .75703 .49677 .75321 .49017 Metetra
.746 .71 .817 r
.75321 .49017 .75703 .49677 .76507 .49136 .76126 .48465 Metetra
.753 .71 .811 r
.76126 .48465 .76507 .49136 .7731 .48564 .76929 .47881 Metetra
.76 .709 .804 r
.76929 .47881 .7731 .48564 .7811 .47954 .77731 .47258 Metetra
.769 .709 .796 r
.77731 .47258 .7811 .47954 .78908 .473 .78529 .46589 Metetra
.779 .709 .786 r
.78529 .46589 .78908 .473 .79701 .4659 .79322 .45861 Metetra
.79 .709 .775 r
.79322 .45861 .79701 .4659 .80489 .4581 .8011 .4506 Metetra
.803 .709 .761 r
.8011 .4506 .80489 .4581 .81268 .44942 .80888 .44165 Metetra
.818 .708 .743 r
.80888 .44165 .81268 .44942 .82036 .43954 .81655 .43142 Metetra
.837 .707 .721 r
.81655 .43142 .82036 .43954 .82787 .42799 .82403 .41937 Metetra
.858 .706 .692 r
.82403 .41937 .82787 .42799 .83511 .41387 .83121 .40447 Metetra
.886 .702 .648 r
.83121 .40447 .83511 .41387 .84187 .39524 .83784 .38425 Metetra
.933 .697 .558 r
.83784 .38425 .84187 .39524 .84737 .36481 .8425 .34518 Metetra
.777 .577 .629 r
.8425 .34518 .84737 .36481 .85241 .33104 .84906 .32613 Metetra
.664 .741 .908 r
.84906 .32613 .85241 .33104 .86061 .32839 .85728 .32346 Metetra
.664 .741 .908 r
.85728 .32346 .86061 .32839 .86884 .32572 .86553 .32078 Metetra
.664 .741 .908 r
.86553 .32078 .86884 .32572 .87709 .32305 .8738 .3181 Metetra
.664 .741 .908 r
.8738 .3181 .87709 .32305 .88537 .32037 .88209 .31541 Metetra
.664 .741 .908 r
.88209 .31541 .88537 .32037 .89366 .31769 .8904 .31271 Metetra
.665 .725 .894 r
.28256 .67392 .28711 .67855 .29421 .67621 .28967 .67156 Metetra
.666 .725 .893 r
.28967 .67156 .29421 .67621 .30132 .67385 .29679 .66919 Metetra
.666 .725 .893 r
.29679 .66919 .30132 .67385 .30845 .67148 .30394 .6668 Metetra
.666 .725 .893 r
.30394 .6668 .30845 .67148 .3156 .6691 .3111 .66441 Metetra
.667 .724 .892 r
.3111 .66441 .3156 .6691 .32277 .66671 .31828 .662 Metetra
.667 .724 .892 r
.31828 .662 .32277 .66671 .32996 .66431 .32548 .65958 Metetra
.667 .724 .892 r
.32548 .65958 .32996 .66431 .33717 .66189 .33269 .65714 Metetra
.667 .724 .891 r
.33269 .65714 .33717 .66189 .34439 .65946 .33993 .6547 Metetra
.668 .724 .891 r
.33993 .6547 .34439 .65946 .35163 .65702 .34718 .65223 Metetra
.668 .723 .891 r
.34718 .65223 .35163 .65702 .3589 .65457 .35446 .64976 Metetra
.668 .723 .89 r
.35446 .64976 .3589 .65457 .36618 .6521 .36175 .64727 Metetra
.669 .723 .89 r
.36175 .64727 .36618 .6521 .37348 .64961 .36906 .64477 Metetra
.669 .723 .889 r
.36906 .64477 .37348 .64961 .38079 .64712 .37639 .64225 Metetra
.669 .723 .889 r
.37639 .64225 .38079 .64712 .38813 .6446 .38374 .63972 Metetra
.67 .722 .889 r
.38374 .63972 .38813 .6446 .39549 .64207 .39111 .63717 Metetra
.67 .722 .888 r
.39111 .63717 .39549 .64207 .40286 .63953 .39849 .63461 Metetra
.671 .722 .888 r
.39849 .63461 .40286 .63953 .41026 .63697 .4059 .63203 Metetra
.671 .722 .887 r
.4059 .63203 .41026 .63697 .41767 .6344 .41332 .62944 Metetra
.672 .722 .887 r
.41332 .62944 .41767 .6344 .4251 .63181 .42077 .62682 Metetra
.672 .721 .886 r
.42077 .62682 .4251 .63181 .43255 .6292 .42823 .62419 Metetra
.672 .721 .886 r
.42823 .62419 .43255 .6292 .44002 .62657 .43571 .62154 Metetra
.673 .721 .885 r
.43571 .62154 .44002 .62657 .44751 .62392 .44321 .61888 Metetra
.673 .721 .885 r
.44321 .61888 .44751 .62392 .45502 .62126 .45073 .61619 Metetra
.674 .721 .884 r
.45073 .61619 .45502 .62126 .46255 .61858 .45827 .61348 Metetra
.675 .72 .884 r
.45827 .61348 .46255 .61858 .47009 .61587 .46583 .61076 Metetra
.675 .72 .883 r
.46583 .61076 .47009 .61587 .47766 .61315 .47341 .60801 Metetra
.676 .72 .882 r
.47341 .60801 .47766 .61315 .48524 .6104 .481 .60524 Metetra
.676 .72 .882 r
.481 .60524 .48524 .6104 .49284 .60763 .48862 .60245 Metetra
.677 .719 .881 r
.48862 .60245 .49284 .60763 .50047 .60484 .49625 .59963 Metetra
.678 .719 .88 r
.49625 .59963 .50047 .60484 .50811 .60202 .5039 .59679 Metetra
.678 .719 .88 r
.5039 .59679 .50811 .60202 .51577 .59918 .51158 .59392 Metetra
.679 .719 .879 r
.51158 .59392 .51577 .59918 .52345 .59631 .51927 .59103 Metetra
.68 .718 .878 r
.51927 .59103 .52345 .59631 .53114 .59342 .52698 .5881 Metetra
.681 .718 .877 r
.52698 .5881 .53114 .59342 .53886 .59049 .5347 .58515 Metetra
.682 .718 .876 r
.5347 .58515 .53886 .59049 .54659 .58754 .54245 .58217 Metetra
.683 .718 .876 r
.54245 .58217 .54659 .58754 .55435 .58455 .55022 .57916 Metetra
.684 .717 .875 r
.55022 .57916 .55435 .58455 .56212 .58153 .558 .57611 Metetra
.685 .717 .874 r
.558 .57611 .56212 .58153 .56991 .57848 .5658 .57303 Metetra
.686 .717 .873 r
.5658 .57303 .56991 .57848 .57771 .57539 .57362 .56991 Metetra
.687 .716 .872 r
.57362 .56991 .57771 .57539 .58554 .57226 .58146 .56675 Metetra
.688 .716 .87 r
.58146 .56675 .58554 .57226 .59338 .5691 .58932 .56355 Metetra
.689 .716 .869 r
.58932 .56355 .59338 .5691 .60124 .56589 .59719 .5603 Metetra
.691 .716 .868 r
.59719 .5603 .60124 .56589 .60912 .56263 .60508 .55701 Metetra
.692 .715 .867 r
.60508 .55701 .60912 .56263 .61702 .55932 .61299 .55367 Metetra
.693 .715 .865 r
.61299 .55367 .61702 .55932 .62493 .55597 .62091 .55028 Metetra
.695 .715 .864 r
.62091 .55028 .62493 .55597 .63285 .55256 .62885 .54683 Metetra
.697 .714 .862 r
.62885 .54683 .63285 .55256 .6408 .54908 .63681 .54332 Metetra
.699 .714 .861 r
.63681 .54332 .6408 .54908 .64876 .54555 .64478 .53974 Metetra
.701 .714 .859 r
.64478 .53974 .64876 .54555 .65673 .54195 .65277 .53609 Metetra
.703 .714 .857 r
.65277 .53609 .65673 .54195 .66472 .53827 .66077 .53237 Metetra
.705 .713 .855 r
.66077 .53237 .66472 .53827 .67272 .53451 .66878 .52857 Metetra
.707 .713 .853 r
.66878 .52857 .67272 .53451 .68073 .53066 .67681 .52467 Metetra
.71 .713 .851 r
.67681 .52467 .68073 .53066 .68876 .52672 .68484 .52068 Metetra
.713 .713 .848 r
.68484 .52068 .68876 .52672 .6968 .52267 .69289 .51657 Metetra
.716 .712 .845 r
.69289 .51657 .6968 .52267 .70484 .51851 .70095 .51235 Metetra
.72 .712 .842 r
.70095 .51235 .70484 .51851 .7129 .51421 .70902 .50799 Metetra
.723 .712 .839 r
.70902 .50799 .7129 .51421 .72096 .50978 .71709 .50349 Metetra
.727 .712 .836 r
.71709 .50349 .72096 .50978 .72902 .50518 .72516 .49881 Metetra
.732 .712 .832 r
.72516 .49881 .72902 .50518 .73709 .50039 .73324 .49395 Metetra
.737 .711 .827 r
.73324 .49395 .73709 .50039 .74515 .4954 .74131 .48887 Metetra
.742 .711 .822 r
.74131 .48887 .74515 .4954 .75321 .49017 .74938 .48355 Metetra
.749 .711 .817 r
.74938 .48355 .75321 .49017 .76126 .48465 .75744 .47793 Metetra
.756 .711 .81 r
.75744 .47793 .76126 .48465 .76929 .47881 .76548 .47197 Metetra
.763 .711 .803 r
.76548 .47197 .76929 .47881 .77731 .47258 .7735 .46561 Metetra
.772 .711 .794 r
.7735 .46561 .77731 .47258 .78529 .46589 .78148 .45876 Metetra
.782 .711 .784 r
.78148 .45876 .78529 .46589 .79322 .45861 .78942 .4513 Metetra
.794 .71 .772 r
.78942 .4513 .79322 .45861 .8011 .4506 .79729 .44307 Metetra
.807 .71 .758 r
.79729 .44307 .8011 .4506 .80888 .44165 .80507 .43383 Metetra
.823 .709 .739 r
.80507 .43383 .80888 .44165 .81655 .43142 .81272 .42323 Metetra
.842 .708 .716 r
.81272 .42323 .81655 .43142 .82403 .41937 .82017 .41064 Metetra
.865 .706 .684 r
.82017 .41064 .82403 .41937 .83121 .40447 .82729 .39485 Metetra
.894 .702 .635 r
.82729 .39485 .83121 .40447 .83784 .38425 .83374 .37263 Metetra
.944 .695 .53 r
.83374 .37263 .83784 .38425 .8425 .34518 .83748 .32387 Metetra
.604 .463 .663 r
.83748 .32387 .8425 .34518 .84906 .32613 .8457 .3212 Metetra
.664 .741 .908 r
.8457 .3212 .84906 .32613 .85728 .32346 .85393 .31851 Metetra
.664 .741 .908 r
.85393 .31851 .85728 .32346 .86553 .32078 .8622 .31582 Metetra
.664 .741 .908 r
.8622 .31582 .86553 .32078 .8738 .3181 .87048 .31312 Metetra
.664 .741 .908 r
.87048 .31312 .8738 .3181 .88209 .31541 .87879 .31041 Metetra
.664 .741 .908 r
.87879 .31041 .88209 .31541 .8904 .31271 .88712 .3077 Metetra
.666 .726 .894 r
.278 .66929 .28256 .67392 .28967 .67156 .28511 .66691 Metetra
.666 .726 .894 r
.28511 .66691 .28967 .67156 .29679 .66919 .29225 .66452 Metetra
.666 .725 .893 r
.29225 .66452 .29679 .66919 .30394 .6668 .2994 .66212 Metetra
.667 .725 .893 r
.2994 .66212 .30394 .6668 .3111 .66441 .30657 .6597 Metetra
.667 .725 .893 r
.30657 .6597 .3111 .66441 .31828 .662 .31376 .65728 Metetra
.667 .725 .892 r
.31376 .65728 .31828 .662 .32548 .65958 .32097 .65484 Metetra
.667 .725 .892 r
.32097 .65484 .32548 .65958 .33269 .65714 .3282 .65238 Metetra
.668 .725 .892 r
.3282 .65238 .33269 .65714 .33993 .6547 .33545 .64992 Metetra
.668 .724 .891 r
.33545 .64992 .33993 .6547 .34718 .65223 .34271 .64744 Metetra
.668 .724 .891 r
.34271 .64744 .34718 .65223 .35446 .64976 .35 .64495 Metetra
.669 .724 .891 r
.35 .64495 .35446 .64976 .36175 .64727 .3573 .64244 Metetra
.669 .724 .89 r
.3573 .64244 .36175 .64727 .36906 .64477 .36463 .63992 Metetra
.669 .724 .89 r
.36463 .63992 .36906 .64477 .37639 .64225 .37197 .63738 Metetra
.67 .723 .889 r
.37197 .63738 .37639 .64225 .38374 .63972 .37933 .63483 Metetra
.67 .723 .889 r
.37933 .63483 .38374 .63972 .39111 .63717 .38671 .63227 Metetra
.671 .723 .889 r
.38671 .63227 .39111 .63717 .39849 .63461 .3941 .62968 Metetra
.671 .723 .888 r
.3941 .62968 .39849 .63461 .4059 .63203 .40152 .62708 Metetra
.672 .723 .888 r
.40152 .62708 .4059 .63203 .41332 .62944 .40896 .62447 Metetra
.672 .722 .887 r
.40896 .62447 .41332 .62944 .42077 .62682 .41641 .62183 Metetra
.672 .722 .887 r
.41641 .62183 .42077 .62682 .42823 .62419 .42389 .61918 Metetra
.673 .722 .886 r
.42389 .61918 .42823 .62419 .43571 .62154 .43138 .61651 Metetra
.673 .722 .886 r
.43138 .61651 .43571 .62154 .44321 .61888 .43889 .61382 Metetra
.674 .722 .885 r
.43889 .61382 .44321 .61888 .45073 .61619 .44643 .61112 Metetra
.674 .721 .884 r
.44643 .61112 .45073 .61619 .45827 .61348 .45398 .60839 Metetra
.675 .721 .884 r
.45398 .60839 .45827 .61348 .46583 .61076 .46155 .60564 Metetra
.676 .721 .883 r
.46155 .60564 .46583 .61076 .47341 .60801 .46914 .60287 Metetra
.676 .721 .883 r
.46914 .60287 .47341 .60801 .481 .60524 .47674 .60007 Metetra
.677 .72 .882 r
.47674 .60007 .481 .60524 .48862 .60245 .48437 .59725 Metetra
.678 .72 .881 r
.48437 .59725 .48862 .60245 .49625 .59963 .49202 .59441 Metetra
.678 .72 .881 r
.49202 .59441 .49625 .59963 .5039 .59679 .49968 .59155 Metetra
.679 .72 .88 r
.49968 .59155 .5039 .59679 .51158 .59392 .50737 .58865 Metetra
.68 .719 .879 r
.50737 .58865 .51158 .59392 .51927 .59103 .51507 .58573 Metetra
.681 .719 .878 r
.51507 .58573 .51927 .59103 .52698 .5881 .52279 .58278 Metetra
.681 .719 .878 r
.52279 .58278 .52698 .5881 .5347 .58515 .53053 .57981 Metetra
.682 .719 .877 r
.53053 .57981 .5347 .58515 .54245 .58217 .53829 .5768 Metetra
.683 .718 .876 r
.53829 .5768 .54245 .58217 .55022 .57916 .54607 .57375 Metetra
.684 .718 .875 r
.54607 .57375 .55022 .57916 .558 .57611 .55387 .57068 Metetra
.685 .718 .874 r
.55387 .57068 .558 .57611 .5658 .57303 .56168 .56757 Metetra
.686 .718 .873 r
.56168 .56757 .5658 .57303 .57362 .56991 .56951 .56442 Metetra
.688 .717 .872 r
.56951 .56442 .57362 .56991 .58146 .56675 .57736 .56122 Metetra
.689 .717 .871 r
.57736 .56122 .58146 .56675 .58932 .56355 .58523 .55799 Metetra
.69 .717 .87 r
.58523 .55799 .58932 .56355 .59719 .5603 .59312 .55471 Metetra
.691 .717 .868 r
.59312 .55471 .59719 .5603 .60508 .55701 .60102 .55139 Metetra
.693 .716 .867 r
.60102 .55139 .60508 .55701 .61299 .55367 .60894 .54801 Metetra
.694 .716 .866 r
.60894 .54801 .61299 .55367 .62091 .55028 .61688 .54458 Metetra
.696 .716 .864 r
.61688 .54458 .62091 .55028 .62885 .54683 .62483 .54109 Metetra
.698 .715 .863 r
.62483 .54109 .62885 .54683 .63681 .54332 .6328 .53754 Metetra
.7 .715 .861 r
.6328 .53754 .63681 .54332 .64478 .53974 .64078 .53392 Metetra
.702 .715 .859 r
.64078 .53392 .64478 .53974 .65277 .53609 .64878 .53023 Metetra
.704 .715 .857 r
.64878 .53023 .65277 .53609 .66077 .53237 .6568 .52647 Metetra
.706 .714 .855 r
.6568 .52647 .66077 .53237 .66878 .52857 .66482 .52261 Metetra
.709 .714 .853 r
.66482 .52261 .66878 .52857 .67681 .52467 .67286 .51867 Metetra
.711 .714 .851 r
.67286 .51867 .67681 .52467 .68484 .52068 .68091 .51462 Metetra
.714 .714 .848 r
.68091 .51462 .68484 .52068 .69289 .51657 .68897 .51046 Metetra
.718 .714 .845 r
.68897 .51046 .69289 .51657 .70095 .51235 .69704 .50618 Metetra
.721 .713 .842 r
.69704 .50618 .70095 .51235 .70902 .50799 .70512 .50176 Metetra
.725 .713 .839 r
.70512 .50176 .70902 .50799 .71709 .50349 .7132 .49719 Metetra
.729 .713 .835 r
.7132 .49719 .71709 .50349 .72516 .49881 .72129 .49244 Metetra
.734 .713 .831 r
.72129 .49244 .72516 .49881 .73324 .49395 .72937 .4875 Metetra
.739 .713 .827 r
.72937 .4875 .73324 .49395 .74131 .48887 .73746 .48234 Metetra
.745 .712 .821 r
.73746 .48234 .74131 .48887 .74938 .48355 .74553 .47692 Metetra
.751 .712 .816 r
.74553 .47692 .74938 .48355 .75744 .47793 .7536 .47119 Metetra
.758 .712 .809 r
.7536 .47119 .75744 .47793 .76548 .47197 .76165 .46512 Metetra
.766 .712 .802 r
.76165 .46512 .76548 .47197 .7735 .46561 .76967 .45862 Metetra
.775 .712 .793 r
.76967 .45862 .7735 .46561 .78148 .45876 .77766 .45161 Metetra
.786 .712 .782 r
.77766 .45161 .78148 .45876 .78942 .4513 .7856 .44396 Metetra
.798 .712 .77 r
.7856 .44396 .78942 .4513 .79729 .44307 .79347 .4355 Metetra
.812 .711 .754 r
.79347 .4355 .79729 .44307 .80507 .43383 .80124 .42597 Metetra
.828 .71 .735 r
.80124 .42597 .80507 .43383 .81272 .42323 .80887 .41496 Metetra
.847 .709 .71 r
.80887 .41496 .81272 .42323 .82017 .41064 .81629 .40178 Metetra
.871 .706 .675 r
.81629 .40178 .82017 .41064 .82729 .39485 .82333 .38496 Metetra
.904 .702 .619 r
.82333 .38496 .82729 .39485 .83374 .37263 .82955 .36004 Metetra
.926 .685 .555 r
.82955 .36004 .83374 .37263 .83748 .32387 .83408 .31893 Metetra
.664 .741 .908 r
.83408 .31893 .83748 .32387 .8457 .3212 .84231 .31624 Metetra
.664 .741 .908 r
.84231 .31624 .8457 .3212 .85393 .31851 .85057 .31354 Metetra
.664 .741 .908 r
.85057 .31354 .85393 .31851 .8622 .31582 .85885 .31083 Metetra
.664 .741 .908 r
.85885 .31083 .8622 .31582 .87048 .31312 .86715 .30812 Metetra
.664 .741 .908 r
.86715 .30812 .87048 .31312 .87879 .31041 .87548 .3054 Metetra
.664 .741 .908 r
.87548 .3054 .87879 .31041 .88712 .3077 .88382 .30267 Metetra
.666 .726 .894 r
.27341 .66464 .278 .66929 .28511 .66691 .28053 .66224 Metetra
.666 .726 .894 r
.28053 .66224 .28511 .66691 .29225 .66452 .28768 .65984 Metetra
.667 .726 .894 r
.28768 .65984 .29225 .66452 .2994 .66212 .29484 .65742 Metetra
.667 .726 .893 r
.29484 .65742 .2994 .66212 .30657 .6597 .30203 .65499 Metetra
.667 .726 .893 r
.30203 .65499 .30657 .6597 .31376 .65728 .30923 .65254 Metetra
.667 .726 .893 r
.30923 .65254 .31376 .65728 .32097 .65484 .31645 .65009 Metetra
.668 .725 .892 r
.31645 .65009 .32097 .65484 .3282 .65238 .32369 .64762 Metetra
.668 .725 .892 r
.32369 .64762 .3282 .65238 .33545 .64992 .33095 .64513 Metetra
.668 .725 .892 r
.33095 .64513 .33545 .64992 .34271 .64744 .33822 .64264 Metetra
.669 .725 .891 r
.33822 .64264 .34271 .64744 .35 .64495 .34552 .64013 Metetra
.669 .725 .891 r
.34552 .64013 .35 .64495 .3573 .64244 .35283 .6376 Metetra
.669 .724 .891 r
.35283 .6376 .3573 .64244 .36463 .63992 .36017 .63506 Metetra
.67 .724 .89 r
.36017 .63506 .36463 .63992 .37197 .63738 .36752 .63251 Metetra
.67 .724 .89 r
.36752 .63251 .37197 .63738 .37933 .63483 .37489 .62994 Metetra
.671 .724 .889 r
.37489 .62994 .37933 .63483 .38671 .63227 .38228 .62735 Metetra
.671 .724 .889 r
.38228 .62735 .38671 .63227 .3941 .62968 .38969 .62475 Metetra
.671 .723 .888 r
.38969 .62475 .3941 .62968 .40152 .62708 .39712 .62213 Metetra
.672 .723 .888 r
.39712 .62213 .40152 .62708 .40896 .62447 .40457 .61949 Metetra
.672 .723 .887 r
.40457 .61949 .40896 .62447 .41641 .62183 .41204 .61684 Metetra
.673 .723 .887 r
.41204 .61684 .41641 .62183 .42389 .61918 .41952 .61416 Metetra
.673 .723 .886 r
.41952 .61416 .42389 .61918 .43138 .61651 .42703 .61147 Metetra
.674 .722 .886 r
.42703 .61147 .43138 .61651 .43889 .61382 .43455 .60876 Metetra
.674 .722 .885 r
.43455 .60876 .43889 .61382 .44643 .61112 .4421 .60603 Metetra
.675 .722 .885 r
.4421 .60603 .44643 .61112 .45398 .60839 .44966 .60328 Metetra
.676 .722 .884 r
.44966 .60328 .45398 .60839 .46155 .60564 .45724 .60051 Metetra
.676 .722 .884 r
.45724 .60051 .46155 .60564 .46914 .60287 .46485 .59771 Metetra
.677 .721 .883 r
.46485 .59771 .46914 .60287 .47674 .60007 .47247 .59489 Metetra
.677 .721 .882 r
.47247 .59489 .47674 .60007 .48437 .59725 .48011 .59205 Metetra
.678 .721 .882 r
.48011 .59205 .48437 .59725 .49202 .59441 .48776 .58919 Metetra
.679 .721 .881 r
.48776 .58919 .49202 .59441 .49968 .59155 .49544 .5863 Metetra
.68 .72 .88 r
.49544 .5863 .49968 .59155 .50737 .58865 .50314 .58338 Metetra
.68 .72 .879 r
.50314 .58338 .50737 .58865 .51507 .58573 .51085 .58043 Metetra
.681 .72 .879 r
.51085 .58043 .51507 .58573 .52279 .58278 .51859 .57746 Metetra
.682 .72 .878 r
.51859 .57746 .52279 .58278 .53053 .57981 .52634 .57445 Metetra
.683 .719 .877 r
.52634 .57445 .53053 .57981 .53829 .5768 .53411 .57141 Metetra
.684 .719 .876 r
.53411 .57141 .53829 .5768 .54607 .57375 .5419 .56834 Metetra
.685 .719 .875 r
.5419 .56834 .54607 .57375 .55387 .57068 .54971 .56524 Metetra
.686 .719 .874 r
.54971 .56524 .55387 .57068 .56168 .56757 .55754 .56209 Metetra
.687 .718 .873 r
.55754 .56209 .56168 .56757 .56951 .56442 .56539 .55891 Metetra
.688 .718 .872 r
.56539 .55891 .56951 .56442 .57736 .56122 .57325 .55569 Metetra
.69 .718 .871 r
.57325 .55569 .57736 .56122 .58523 .55799 .58113 .55243 Metetra
.691 .718 .87 r
.58113 .55243 .58523 .55799 .59312 .55471 .58903 .54911 Metetra
.692 .717 .868 r
.58903 .54911 .59312 .55471 .60102 .55139 .59695 .54575 Metetra
.694 .717 .867 r
.59695 .54575 .60102 .55139 .60894 .54801 .60488 .54234 Metetra
.695 .717 .866 r
.60488 .54234 .60894 .54801 .61688 .54458 .61283 .53888 Metetra
.697 .717 .864 r
.61283 .53888 .61688 .54458 .62483 .54109 .62079 .53535 Metetra
.699 .716 .863 r
.62079 .53535 .62483 .54109 .6328 .53754 .62878 .53176 Metetra
.701 .716 .861 r
.62878 .53176 .6328 .53754 .64078 .53392 .63677 .5281 Metetra
.703 .716 .859 r
.63677 .5281 .64078 .53392 .64878 .53023 .64478 .52437 Metetra
.705 .716 .857 r
.64478 .52437 .64878 .53023 .6568 .52647 .65281 .52055 Metetra
.708 .715 .855 r
.65281 .52055 .6568 .52647 .66482 .52261 .66085 .51665 Metetra
.71 .715 .853 r
.66085 .51665 .66482 .52261 .67286 .51867 .6689 .51266 Metetra
.713 .715 .85 r
.6689 .51266 .67286 .51867 .68091 .51462 .67696 .50856 Metetra
.716 .715 .848 r
.67696 .50856 .68091 .51462 .68897 .51046 .68503 .50434 Metetra
.719 .715 .845 r
.68503 .50434 .68897 .51046 .69704 .50618 .69311 .5 Metetra
.723 .714 .842 r
.69311 .5 .69704 .50618 .70512 .50176 .7012 .49552 Metetra
.727 .714 .839 r
.7012 .49552 .70512 .50176 .7132 .49719 .7093 .49088 Metetra
.731 .714 .835 r
.7093 .49088 .7132 .49719 .72129 .49244 .71739 .48606 Metetra
.736 .714 .831 r
.71739 .48606 .72129 .49244 .72937 .4875 .72549 .48104 Metetra
.741 .714 .826 r
.72549 .48104 .72937 .4875 .73746 .48234 .73358 .47579 Metetra
.747 .714 .821 r
.73358 .47579 .73746 .48234 .74553 .47692 .74167 .47027 Metetra
.754 .714 .815 r
.74167 .47027 .74553 .47692 .7536 .47119 .74975 .46444 Metetra
.761 .714 .808 r
.74975 .46444 .7536 .47119 .76165 .46512 .7578 .45824 Metetra
.769 .713 .8 r
.7578 .45824 .76165 .46512 .76967 .45862 .76583 .45161 Metetra
.779 .713 .791 r
.76583 .45161 .76967 .45862 .77766 .45161 .77382 .44443 Metetra
.789 .713 .78 r
.77382 .44443 .77766 .45161 .7856 .44396 .78176 .43658 Metetra
.802 .713 .767 r
.78176 .43658 .7856 .44396 .79347 .4355 .78963 .42788 Metetra
.816 .712 .751 r
.78963 .42788 .79347 .4355 .80124 .42597 .7974 .41804 Metetra
.833 .711 .73 r
.7974 .41804 .80124 .42597 .80887 .41496 .80501 .40661 Metetra
.853 .71 .703 r
.80501 .40661 .80887 .41496 .81629 .40178 .81239 .39277 Metetra
.878 .706 .665 r
.81239 .39277 .81629 .40178 .82333 .38496 .81934 .37474 Metetra
.915 .701 .598 r
.81934 .37474 .82333 .38496 .82955 .36004 .8252 .34576 Metetra
.888 .662 .59 r
.8252 .34576 .82955 .36004 .83408 .31893 .83067 .31395 Metetra
.664 .741 .908 r
.83067 .31395 .83408 .31893 .84231 .31624 .83891 .31125 Metetra
.664 .741 .908 r
.83891 .31125 .84231 .31624 .85057 .31354 .84719 .30854 Metetra
.664 .741 .908 r
.84719 .30854 .85057 .31354 .85885 .31083 .85548 .30581 Metetra
.664 .741 .908 r
.85548 .30581 .85885 .31083 .86715 .30812 .8638 .30309 Metetra
.664 .741 .908 r
.8638 .30309 .86715 .30812 .87548 .3054 .87214 .30035 Metetra
.664 .741 .908 r
.87214 .30035 .87548 .3054 .88382 .30267 .88051 .29761 Metetra
.666 .727 .895 r
.26879 .65998 .27341 .66464 .28053 .66224 .27593 .65757 Metetra
.667 .727 .894 r
.27593 .65757 .28053 .66224 .28768 .65984 .28309 .65515 Metetra
.667 .727 .894 r
.28309 .65515 .28768 .65984 .29484 .65742 .29026 .65271 Metetra
.667 .726 .894 r
.29026 .65271 .29484 .65742 .30203 .65499 .29746 .65026 Metetra
.667 .726 .893 r
.29746 .65026 .30203 .65499 .30923 .65254 .30467 .6478 Metetra
.668 .726 .893 r
.30467 .6478 .30923 .65254 .31645 .65009 .3119 .64533 Metetra
.668 .726 .893 r
.3119 .64533 .31645 .65009 .32369 .64762 .31915 .64284 Metetra
.668 .726 .892 r
.31915 .64284 .32369 .64762 .33095 .64513 .32642 .64034 Metetra
.669 .726 .892 r
.32642 .64034 .33095 .64513 .33822 .64264 .33371 .63782 Metetra
.669 .725 .892 r
.33371 .63782 .33822 .64264 .34552 .64013 .34102 .6353 Metetra
.669 .725 .891 r
.34102 .6353 .34552 .64013 .35283 .6376 .34835 .63275 Metetra
.67 .725 .891 r
.34835 .63275 .35283 .6376 .36017 .63506 .35569 .63019 Metetra
.67 .725 .89 r
.35569 .63019 .36017 .63506 .36752 .63251 .36305 .62762 Metetra
.671 .725 .89 r
.36305 .62762 .36752 .63251 .37489 .62994 .37044 .62503 Metetra
.671 .725 .89 r
.37044 .62503 .37489 .62994 .38228 .62735 .37784 .62242 Metetra
.671 .724 .889 r
.37784 .62242 .38228 .62735 .38969 .62475 .38526 .6198 Metetra
.672 .724 .889 r
.38526 .6198 .38969 .62475 .39712 .62213 .3927 .61716 Metetra
.672 .724 .888 r
.3927 .61716 .39712 .62213 .40457 .61949 .40016 .6145 Metetra
.673 .724 .888 r
.40016 .6145 .40457 .61949 .41204 .61684 .40764 .61183 Metetra
.673 .724 .887 r
.40764 .61183 .41204 .61684 .41952 .61416 .41514 .60913 Metetra
.674 .723 .887 r
.41514 .60913 .41952 .61416 .42703 .61147 .42266 .60642 Metetra
.674 .723 .886 r
.42266 .60642 .42703 .61147 .43455 .60876 .43019 .60369 Metetra
.675 .723 .886 r
.43019 .60369 .43455 .60876 .4421 .60603 .43775 .60094 Metetra
.675 .723 .885 r
.43775 .60094 .4421 .60603 .44966 .60328 .44533 .59816 Metetra
.676 .722 .884 r
.44533 .59816 .44966 .60328 .45724 .60051 .45292 .59537 Metetra
.677 .722 .884 r
.45292 .59537 .45724 .60051 .46485 .59771 .46053 .59255 Metetra
.677 .722 .883 r
.46053 .59255 .46485 .59771 .47247 .59489 .46817 .58971 Metetra
.678 .722 .883 r
.46817 .58971 .47247 .59489 .48011 .59205 .47582 .58684 Metetra
.679 .722 .882 r
.47582 .58684 .48011 .59205 .48776 .58919 .48349 .58395 Metetra
.679 .721 .881 r
.48349 .58395 .48776 .58919 .49544 .5863 .49118 .58104 Metetra
.68 .721 .88 r
.49118 .58104 .49544 .5863 .50314 .58338 .49889 .57809 Metetra
.681 .721 .88 r
.49889 .57809 .50314 .58338 .51085 .58043 .50662 .57512 Metetra
.682 .721 .879 r
.50662 .57512 .51085 .58043 .51859 .57746 .51437 .57212 Metetra
.683 .72 .878 r
.51437 .57212 .51859 .57746 .52634 .57445 .52213 .56909 Metetra
.684 .72 .877 r
.52213 .56909 .52634 .57445 .53411 .57141 .52992 .56602 Metetra
.685 .72 .876 r
.52992 .56602 .53411 .57141 .5419 .56834 .53772 .56292 Metetra
.686 .72 .875 r
.53772 .56292 .5419 .56834 .54971 .56524 .54554 .55979 Metetra
.687 .72 .874 r
.54554 .55979 .54971 .56524 .55754 .56209 .55338 .55661 Metetra
.688 .719 .873 r
.55338 .55661 .55754 .56209 .56539 .55891 .56124 .5534 Metetra
.689 .719 .872 r
.56124 .5534 .56539 .55891 .57325 .55569 .56912 .55015 Metetra
.69 .719 .871 r
.56912 .55015 .57325 .55569 .58113 .55243 .57701 .54685 Metetra
.692 .719 .87 r
.57701 .54685 .58113 .55243 .58903 .54911 .58492 .54351 Metetra
.693 .718 .869 r
.58492 .54351 .58903 .54911 .59695 .54575 .59285 .54011 Metetra
.695 .718 .867 r
.59285 .54011 .59695 .54575 .60488 .54234 .6008 .53666 Metetra
.696 .718 .866 r
.6008 .53666 .60488 .54234 .61283 .53888 .60876 .53316 Metetra
.698 .718 .864 r
.60876 .53316 .61283 .53888 .62079 .53535 .61674 .52959 Metetra
.7 .717 .863 r
.61674 .52959 .62079 .53535 .62878 .53176 .62473 .52596 Metetra
.702 .717 .861 r
.62473 .52596 .62878 .53176 .63677 .5281 .63274 .52226 Metetra
.704 .717 .859 r
.63274 .52226 .63677 .5281 .64478 .52437 .64077 .51849 Metetra
.706 .717 .857 r
.64077 .51849 .64478 .52437 .65281 .52055 .64881 .51463 Metetra
.709 .716 .855 r
.64881 .51463 .65281 .52055 .66085 .51665 .65686 .51068 Metetra
.711 .716 .853 r
.65686 .51068 .66085 .51665 .6689 .51266 .66492 .50664 Metetra
.714 .716 .85 r
.66492 .50664 .6689 .51266 .67696 .50856 .67299 .50248 Metetra
.717 .716 .848 r
.67299 .50248 .67696 .50856 .68503 .50434 .68108 .49821 Metetra
.721 .716 .845 r
.68108 .49821 .68503 .50434 .69311 .5 .68917 .49381 Metetra
.724 .716 .842 r
.68917 .49381 .69311 .5 .7012 .49552 .69727 .48927 Metetra
.728 .715 .838 r
.69727 .48927 .7012 .49552 .7093 .49088 .70538 .48456 Metetra
.733 .715 .834 r
.70538 .48456 .7093 .49088 .71739 .48606 .71349 .47967 Metetra
.738 .715 .83 r
.71349 .47967 .71739 .48606 .72549 .48104 .72159 .47456 Metetra
.743 .715 .825 r
.72159 .47456 .72549 .48104 .73358 .47579 .7297 .46922 Metetra
.749 .715 .82 r
.7297 .46922 .73358 .47579 .74167 .47027 .73779 .46361 Metetra
.756 .715 .814 r
.73779 .46361 .74167 .47027 .74975 .46444 .74588 .45767 Metetra
.764 .715 .807 r
.74588 .45767 .74975 .46444 .7578 .45824 .75394 .45135 Metetra
.772 .715 .799 r
.75394 .45135 .7578 .45824 .76583 .45161 .76198 .44457 Metetra
.782 .715 .789 r
.76198 .44457 .76583 .45161 .77382 .44443 .76997 .43723 Metetra
.793 .714 .778 r
.76997 .43723 .77382 .44443 .78176 .43658 .77792 .42918 Metetra
.805 .714 .764 r
.77792 .42918 .78176 .43658 .78963 .42788 .78578 .42022 Metetra
.82 .713 .747 r
.78578 .42022 .78963 .42788 .7974 .41804 .79354 .41005 Metetra
.838 .712 .725 r
.79354 .41005 .7974 .41804 .80501 .40661 .80113 .39816 Metetra
.859 .71 .696 r
.80113 .39816 .80501 .40661 .81239 .39277 .80846 .38359 Metetra
.886 .706 .654 r
.80846 .38359 .81239 .39277 .81934 .37474 .8153 .36407 Metetra
.932 .7 .565 r
.8153 .36407 .81934 .37474 .8252 .34576 .82043 .327 Metetra
.777 .581 .635 r
.82043 .327 .8252 .34576 .83067 .31395 .82723 .30895 Metetra
.664 .741 .908 r
.82723 .30895 .83067 .31395 .83891 .31125 .8355 .30623 Metetra
.664 .741 .908 r
.8355 .30623 .83891 .31125 .84719 .30854 .84378 .30351 Metetra
.664 .741 .908 r
.84378 .30351 .84719 .30854 .85548 .30581 .8521 .30077 Metetra
.664 .741 .908 r
.8521 .30077 .85548 .30581 .8638 .30309 .86043 .29803 Metetra
.664 .741 .908 r
.86043 .29803 .8638 .30309 .87214 .30035 .86879 .29528 Metetra
.664 .741 .908 r
.86879 .29528 .87214 .30035 .88051 .29761 .87718 .29252 Metetra
.667 .727 .895 r
.26416 .65532 .26879 .65998 .27593 .65757 .27131 .65289 Metetra
.667 .727 .895 r
.27131 .65289 .27593 .65757 .28309 .65515 .27848 .65045 Metetra
.667 .727 .894 r
.27848 .65045 .28309 .65515 .29026 .65271 .28566 .648 Metetra
.667 .727 .894 r
.28566 .648 .29026 .65271 .29746 .65026 .29287 .64553 Metetra
.668 .727 .894 r
.29287 .64553 .29746 .65026 .30467 .6478 .30009 .64305 Metetra
.668 .727 .893 r
.30009 .64305 .30467 .6478 .3119 .64533 .30734 .64056 Metetra
.668 .727 .893 r
.30734 .64056 .3119 .64533 .31915 .64284 .3146 .63805 Metetra
.669 .726 .893 r
.3146 .63805 .31915 .64284 .32642 .64034 .32188 .63553 Metetra
.669 .726 .892 r
.32188 .63553 .32642 .64034 .33371 .63782 .32918 .633 Metetra
.669 .726 .892 r
.32918 .633 .33371 .63782 .34102 .6353 .3365 .63045 Metetra
.67 .726 .891 r
.3365 .63045 .34102 .6353 .34835 .63275 .34383 .62789 Metetra
.67 .726 .891 r
.34383 .62789 .34835 .63275 .35569 .63019 .35119 .62531 Metetra
.671 .725 .891 r
.35119 .62531 .35569 .63019 .36305 .62762 .35857 .62272 Metetra
.671 .725 .89 r
.35857 .62272 .36305 .62762 .37044 .62503 .36596 .62011 Metetra
.671 .725 .89 r
.36596 .62011 .37044 .62503 .37784 .62242 .37338 .61748 Metetra
.672 .725 .889 r
.37338 .61748 .37784 .62242 .38526 .6198 .38081 .61484 Metetra
.672 .725 .889 r
.38081 .61484 .38526 .6198 .3927 .61716 .38826 .61218 Metetra
.673 .725 .888 r
.38826 .61218 .3927 .61716 .40016 .6145 .39573 .6095 Metetra
.673 .724 .888 r
.39573 .6095 .40016 .6145 .40764 .61183 .40323 .60681 Metetra
.674 .724 .887 r
.40323 .60681 .40764 .61183 .41514 .60913 .41074 .60409 Metetra
.674 .724 .887 r
.41074 .60409 .41514 .60913 .42266 .60642 .41827 .60136 Metetra
.675 .724 .886 r
.41827 .60136 .42266 .60642 .43019 .60369 .42581 .5986 Metetra
.675 .724 .886 r
.42581 .5986 .43019 .60369 .43775 .60094 .43338 .59583 Metetra
.676 .723 .885 r
.43338 .59583 .43775 .60094 .44533 .59816 .44097 .59303 Metetra
.677 .723 .885 r
.44097 .59303 .44533 .59816 .45292 .59537 .44858 .59022 Metetra
.677 .723 .884 r
.44858 .59022 .45292 .59537 .46053 .59255 .4562 .58737 Metetra
.678 .723 .883 r
.4562 .58737 .46053 .59255 .46817 .58971 .46385 .58451 Metetra
.679 .723 .883 r
.46385 .58451 .46817 .58971 .47582 .58684 .47151 .58162 Metetra
.679 .722 .882 r
.47151 .58162 .47582 .58684 .48349 .58395 .4792 .57871 Metetra
.68 .722 .881 r
.4792 .57871 .48349 .58395 .49118 .58104 .4869 .57576 Metetra
.681 .722 .881 r
.4869 .57576 .49118 .58104 .49889 .57809 .49462 .57279 Metetra
.682 .722 .88 r
.49462 .57279 .49889 .57809 .50662 .57512 .50236 .5698 Metetra
.682 .721 .879 r
.50236 .5698 .50662 .57512 .51437 .57212 .51012 .56677 Metetra
.683 .721 .878 r
.51012 .56677 .51437 .57212 .52213 .56909 .5179 .56371 Metetra
.684 .721 .877 r
.5179 .56371 .52213 .56909 .52992 .56602 .5257 .56062 Metetra
.685 .721 .876 r
.5257 .56062 .52992 .56602 .53772 .56292 .53352 .55749 Metetra
.686 .721 .875 r
.53352 .55749 .53772 .56292 .54554 .55979 .54135 .55432 Metetra
.687 .72 .874 r
.54135 .55432 .54554 .55979 .55338 .55661 .5492 .55112 Metetra
.689 .72 .873 r
.5492 .55112 .55338 .55661 .56124 .5534 .55708 .54788 Metetra
.69 .72 .872 r
.55708 .54788 .56124 .5534 .56912 .55015 .56497 .54459 Metetra
.691 .72 .871 r
.56497 .54459 .56912 .55015 .57701 .54685 .57287 .54126 Metetra
.693 .719 .87 r
.57287 .54126 .57701 .54685 .58492 .54351 .5808 .53789 Metetra
.694 .719 .869 r
.5808 .53789 .58492 .54351 .59285 .54011 .58874 .53446 Metetra
.696 .719 .867 r
.58874 .53446 .59285 .54011 .6008 .53666 .5967 .53097 Metetra
.697 .719 .866 r
.5967 .53097 .6008 .53666 .60876 .53316 .60467 .52743 Metetra
.699 .718 .864 r
.60467 .52743 .60876 .53316 .61674 .52959 .61267 .52383 Metetra
.701 .718 .863 r
.61267 .52383 .61674 .52959 .62473 .52596 .62067 .52016 Metetra
.703 .718 .861 r
.62067 .52016 .62473 .52596 .63274 .52226 .6287 .51642 Metetra
.705 .718 .859 r
.6287 .51642 .63274 .52226 .64077 .51849 .63673 .5126 Metetra
.707 .718 .857 r
.63673 .5126 .64077 .51849 .64881 .51463 .64478 .50869 Metetra
.71 .717 .855 r
.64478 .50869 .64881 .51463 .65686 .51068 .65285 .5047 Metetra
.713 .717 .853 r
.65285 .5047 .65686 .51068 .66492 .50664 .66092 .5006 Metetra
.716 .717 .85 r
.66092 .5006 .66492 .50664 .67299 .50248 .66901 .4964 Metetra
.719 .717 .847 r
.66901 .4964 .67299 .50248 .68108 .49821 .67711 .49207 Metetra
.722 .717 .844 r
.67711 .49207 .68108 .49821 .68917 .49381 .68521 .48761 Metetra
.726 .717 .841 r
.68521 .48761 .68917 .49381 .69727 .48927 .69333 .483 Metetra
.73 .716 .838 r
.69333 .483 .69727 .48927 .70538 .48456 .70144 .47822 Metetra
.735 .716 .834 r
.70144 .47822 .70538 .48456 .71349 .47967 .70956 .47326 Metetra
.74 .716 .829 r
.70956 .47326 .71349 .47967 .72159 .47456 .71768 .46807 Metetra
.745 .716 .824 r
.71768 .46807 .72159 .47456 .7297 .46922 .7258 .46264 Metetra
.752 .716 .819 r
.7258 .46264 .7297 .46922 .73779 .46361 .7339 .45693 Metetra
.758 .716 .813 r
.7339 .45693 .73779 .46361 .74588 .45767 .742 .45088 Metetra
.766 .716 .805 r
.742 .45088 .74588 .45767 .75394 .45135 .75007 .44443 Metetra
.775 .716 .797 r
.75007 .44443 .75394 .45135 .76198 .44457 .75811 .43751 Metetra
.785 .716 .787 r
.75811 .43751 .76198 .44457 .76997 .43723 .76611 .42999 Metetra
.796 .715 .775 r
.76611 .42999 .76997 .43723 .77792 .42918 .77405 .42173 Metetra
.809 .715 .761 r
.77405 .42173 .77792 .42918 .78578 .42022 .78191 .41251 Metetra
.825 .714 .743 r
.78191 .41251 .78578 .42022 .79354 .41005 .78966 .40199 Metetra
.843 .713 .72 r
.78966 .40199 .79354 .41005 .80113 .39816 .79723 .38959 Metetra
.865 .71 .689 r
.79723 .38959 .80113 .39816 .80846 .38359 .8045 .37418 Metetra
.894 .706 .641 r
.8045 .37418 .80846 .38359 .8153 .36407 .8112 .35279 Metetra
.943 .697 .537 r
.8112 .35279 .8153 .36407 .82043 .327 .81552 .30665 Metetra
.604 .468 .668 r
.81552 .30665 .82043 .327 .82723 .30895 .82378 .30393 Metetra
.664 .741 .908 r
.82378 .30393 .82723 .30895 .8355 .30623 .83206 .30119 Metetra
.664 .741 .908 r
.83206 .30119 .8355 .30623 .84378 .30351 .84037 .29845 Metetra
.664 .741 .908 r
.84037 .29845 .84378 .30351 .8521 .30077 .8487 .2957 Metetra
.664 .741 .908 r
.8487 .2957 .8521 .30077 .86043 .29803 .85705 .29295 Metetra
.664 .741 .908 r
.85705 .29295 .86043 .29803 .86879 .29528 .86543 .29018 Metetra
.664 .741 .908 r
.86543 .29018 .86879 .29528 .87718 .29252 .87383 .28741 Metetra
.667 .728 .895 r
.2595 .65064 .26416 .65532 .27131 .65289 .26666 .6482 Metetra
.667 .728 .895 r
.26666 .6482 .27131 .65289 .27848 .65045 .27384 .64574 Metetra
.667 .728 .895 r
.27384 .64574 .27848 .65045 .28566 .648 .28104 .64327 Metetra
.668 .728 .894 r
.28104 .64327 .28566 .648 .29287 .64553 .28826 .64079 Metetra
.668 .727 .894 r
.28826 .64079 .29287 .64553 .30009 .64305 .29549 .63829 Metetra
.668 .727 .894 r
.29549 .63829 .30009 .64305 .30734 .64056 .30275 .63578 Metetra
.669 .727 .893 r
.30275 .63578 .30734 .64056 .3146 .63805 .31002 .63326 Metetra
.669 .727 .893 r
.31002 .63326 .3146 .63805 .32188 .63553 .31731 .63072 Metetra
.669 .727 .892 r
.31731 .63072 .32188 .63553 .32918 .633 .32462 .62817 Metetra
.67 .727 .892 r
.32462 .62817 .32918 .633 .3365 .63045 .33195 .6256 Metetra
.67 .726 .892 r
.33195 .6256 .3365 .63045 .34383 .62789 .3393 .62302 Metetra
.671 .726 .891 r
.3393 .62302 .34383 .62789 .35119 .62531 .34667 .62042 Metetra
.671 .726 .891 r
.34667 .62042 .35119 .62531 .35857 .62272 .35406 .61781 Metetra
.671 .726 .89 r
.35406 .61781 .35857 .62272 .36596 .62011 .36147 .61518 Metetra
.672 .726 .89 r
.36147 .61518 .36596 .62011 .37338 .61748 .36889 .61253 Metetra
.672 .726 .89 r
.36889 .61253 .37338 .61748 .38081 .61484 .37634 .60987 Metetra
.673 .725 .889 r
.37634 .60987 .38081 .61484 .38826 .61218 .3838 .60719 Metetra
.673 .725 .889 r
.3838 .60719 .38826 .61218 .39573 .6095 .39128 .60449 Metetra
.674 .725 .888 r
.39128 .60449 .39573 .6095 .40323 .60681 .39879 .60178 Metetra
.674 .725 .888 r
.39879 .60178 .40323 .60681 .41074 .60409 .40631 .59904 Metetra
.675 .725 .887 r
.40631 .59904 .41074 .60409 .41827 .60136 .41385 .59629 Metetra
.675 .724 .887 r
.41385 .59629 .41827 .60136 .42581 .5986 .42141 .59351 Metetra
.676 .724 .886 r
.42141 .59351 .42581 .5986 .43338 .59583 .42899 .59071 Metetra
.676 .724 .885 r
.42899 .59071 .43338 .59583 .44097 .59303 .43659 .58789 Metetra
.677 .724 .885 r
.43659 .58789 .44097 .59303 .44858 .59022 .44421 .58505 Metetra
.678 .724 .884 r
.44421 .58505 .44858 .59022 .4562 .58737 .45185 .58219 Metetra
.678 .723 .884 r
.45185 .58219 .4562 .58737 .46385 .58451 .45951 .5793 Metetra
.679 .723 .883 r
.45951 .5793 .46385 .58451 .47151 .58162 .46719 .57639 Metetra
.68 .723 .882 r
.46719 .57639 .47151 .58162 .4792 .57871 .47488 .57345 Metetra
.681 .723 .882 r
.47488 .57345 .4792 .57871 .4869 .57576 .4826 .57048 Metetra
.681 .723 .881 r
.4826 .57048 .4869 .57576 .49462 .57279 .49033 .56749 Metetra
.682 .722 .88 r
.49033 .56749 .49462 .57279 .50236 .5698 .49809 .56446 Metetra
.683 .722 .879 r
.49809 .56446 .50236 .5698 .51012 .56677 .50586 .56141 Metetra
.684 .722 .878 r
.50586 .56141 .51012 .56677 .5179 .56371 .51365 .55832 Metetra
.685 .722 .877 r
.51365 .55832 .5179 .56371 .5257 .56062 .52146 .5552 Metetra
.686 .722 .877 r
.52146 .5552 .5257 .56062 .53352 .55749 .52929 .55204 Metetra
.687 .721 .876 r
.52929 .55204 .53352 .55749 .54135 .55432 .53714 .54885 Metetra
.688 .721 .875 r
.53714 .54885 .54135 .55432 .5492 .55112 .54501 .54562 Metetra
.689 .721 .874 r
.54501 .54562 .5492 .55112 .55708 .54788 .55289 .54235 Metetra
.691 .721 .872 r
.55289 .54235 .55708 .54788 .56497 .54459 .56079 .53903 Metetra
.692 .72 .871 r
.56079 .53903 .56497 .54459 .57287 .54126 .56871 .53567 Metetra
.693 .72 .87 r
.56871 .53567 .57287 .54126 .5808 .53789 .57665 .53225 Metetra
.695 .72 .869 r
.57665 .53225 .5808 .53789 .58874 .53446 .58461 .52879 Metetra
.696 .72 .867 r
.58461 .52879 .58874 .53446 .5967 .53097 .59258 .52527 Metetra
.698 .72 .866 r
.59258 .52527 .5967 .53097 .60467 .52743 .60057 .52169 Metetra
.7 .719 .864 r
.60057 .52169 .60467 .52743 .61267 .52383 .60857 .51805 Metetra
.702 .719 .863 r
.60857 .51805 .61267 .52383 .62067 .52016 .61659 .51434 Metetra
.704 .719 .861 r
.61659 .51434 .62067 .52016 .6287 .51642 .62463 .51056 Metetra
.706 .719 .859 r
.62463 .51056 .6287 .51642 .63673 .5126 .63268 .50669 Metetra
.709 .719 .857 r
.63268 .50669 .63673 .5126 .64478 .50869 .64074 .50274 Metetra
.711 .718 .855 r
.64074 .50274 .64478 .50869 .65285 .5047 .64882 .4987 Metetra
.714 .718 .853 r
.64882 .4987 .65285 .5047 .66092 .5006 .65691 .49455 Metetra
.717 .718 .85 r
.65691 .49455 .66092 .5006 .66901 .4964 .66501 .4903 Metetra
.72 .718 .847 r
.66501 .4903 .66901 .4964 .67711 .49207 .67312 .48591 Metetra
.724 .718 .844 r
.67312 .48591 .67711 .49207 .68521 .48761 .68124 .48139 Metetra
.728 .718 .841 r
.68124 .48139 .68521 .48761 .69333 .483 .68936 .47672 Metetra
.732 .717 .837 r
.68936 .47672 .69333 .483 .70144 .47822 .69749 .47187 Metetra
.737 .717 .833 r
.69749 .47187 .70144 .47822 .70956 .47326 .70562 .46683 Metetra
.742 .717 .829 r
.70562 .46683 .70956 .47326 .71768 .46807 .71375 .46156 Metetra
.747 .717 .824 r
.71375 .46156 .71768 .46807 .7258 .46264 .72188 .45605 Metetra
.754 .717 .818 r
.72188 .45605 .7258 .46264 .7339 .45693 .72999 .45023 Metetra
.761 .717 .811 r
.72999 .45023 .7339 .45693 .742 .45088 .7381 .44407 Metetra
.769 .717 .804 r
.7381 .44407 .742 .45088 .75007 .44443 .74618 .43749 Metetra
.778 .717 .795 r
.74618 .43749 .75007 .44443 .75811 .43751 .75422 .43041 Metetra
.788 .717 .785 r
.75422 .43041 .75811 .43751 .76611 .42999 .76223 .42272 Metetra
.8 .716 .773 r
.76223 .42272 .76611 .42999 .77405 .42173 .77017 .41424 Metetra
.813 .716 .758 r
.77017 .41424 .77405 .42173 .78191 .41251 .77803 .40475 Metetra
.829 .715 .739 r
.77803 .40475 .78191 .41251 .78966 .40199 .78576 .39385 Metetra
.848 .713 .714 r
.78576 .39385 .78966 .40199 .79723 .38959 .7933 .38089 Metetra
.871 .71 .68 r
.7933 .38089 .79723 .38959 .8045 .37418 .80052 .36452 Metetra
.903 .705 .625 r
.80052 .36452 .8045 .37418 .8112 .35279 .80701 .34058 Metetra
.925 .688 .562 r
.80701 .34058 .8112 .35279 .81552 .30665 .81203 .30161 Metetra
.664 .741 .908 r
.81203 .30161 .81552 .30665 .82378 .30393 .82031 .29887 Metetra
.664 .741 .908 r
.82031 .29887 .82378 .30393 .83206 .30119 .82861 .29613 Metetra
.664 .741 .908 r
.82861 .29613 .83206 .30119 .84037 .29845 .83693 .29337 Metetra
.664 .741 .908 r
.83693 .29337 .84037 .29845 .8487 .2957 .84528 .29061 Metetra
.664 .741 .908 r
.84528 .29061 .8487 .2957 .85705 .29295 .85365 .28784 Metetra
.664 .741 .908 r
.85365 .28784 .85705 .29295 .86543 .29018 .86204 .28506 Metetra
.664 .741 .908 r
.86204 .28506 .86543 .29018 .87383 .28741 .87046 .28227 Metetra
.667 .729 .895 r
.25483 .64595 .2595 .65064 .26666 .6482 .262 .64349 Metetra
.667 .728 .895 r
.262 .64349 .26666 .6482 .27384 .64574 .26919 .64102 Metetra
.668 .728 .895 r
.26919 .64102 .27384 .64574 .28104 .64327 .2764 .63853 Metetra
.668 .728 .894 r
.2764 .63853 .28104 .64327 .28826 .64079 .28362 .63603 Metetra
.668 .728 .894 r
.28362 .63603 .28826 .64079 .29549 .63829 .29087 .63352 Metetra
.669 .728 .894 r
.29087 .63352 .29549 .63829 .30275 .63578 .29814 .63099 Metetra
.669 .728 .893 r
.29814 .63099 .30275 .63578 .31002 .63326 .30542 .62845 Metetra
.669 .727 .893 r
.30542 .62845 .31002 .63326 .31731 .63072 .31272 .62589 Metetra
.67 .727 .893 r
.31272 .62589 .31731 .63072 .32462 .62817 .32005 .62332 Metetra
.67 .727 .892 r
.32005 .62332 .32462 .62817 .33195 .6256 .32739 .62074 Metetra
.67 .727 .892 r
.32739 .62074 .33195 .6256 .3393 .62302 .33475 .61814 Metetra
.671 .727 .891 r
.33475 .61814 .3393 .62302 .34667 .62042 .34213 .61552 Metetra
.671 .727 .891 r
.34213 .61552 .34667 .62042 .35406 .61781 .34953 .61289 Metetra
.672 .726 .891 r
.34953 .61289 .35406 .61781 .36147 .61518 .35695 .61024 Metetra
.672 .726 .89 r
.35695 .61024 .36147 .61518 .36889 .61253 .36438 .60757 Metetra
.673 .726 .89 r
.36438 .60757 .36889 .61253 .37634 .60987 .37184 .60489 Metetra
.673 .726 .889 r
.37184 .60489 .37634 .60987 .3838 .60719 .37932 .60219 Metetra
.674 .726 .889 r
.37932 .60219 .3838 .60719 .39128 .60449 .38681 .59947 Metetra
.674 .726 .888 r
.38681 .59947 .39128 .60449 .39879 .60178 .39433 .59673 Metetra
.675 .725 .888 r
.39433 .59673 .39879 .60178 .40631 .59904 .40186 .59398 Metetra
.675 .725 .887 r
.40186 .59398 .40631 .59904 .41385 .59629 .40942 .5912 Metetra
.676 .725 .887 r
.40942 .5912 .41385 .59629 .42141 .59351 .41699 .5884 Metetra
.676 .725 .886 r
.41699 .5884 .42141 .59351 .42899 .59071 .42459 .58558 Metetra
.677 .725 .886 r
.42459 .58558 .42899 .59071 .43659 .58789 .4322 .58274 Metetra
.677 .724 .885 r
.4322 .58274 .43659 .58789 .44421 .58505 .43983 .57988 Metetra
.678 .724 .884 r
.43983 .57988 .44421 .58505 .45185 .58219 .44748 .57699 Metetra
.679 .724 .884 r
.44748 .57699 .45185 .58219 .45951 .5793 .45515 .57408 Metetra
.68 .724 .883 r
.45515 .57408 .45951 .5793 .46719 .57639 .46284 .57114 Metetra
.68 .724 .882 r
.46284 .57114 .46719 .57639 .47488 .57345 .47055 .56818 Metetra
.681 .723 .882 r
.47055 .56818 .47488 .57345 .4826 .57048 .47828 .56519 Metetra
.682 .723 .881 r
.47828 .56519 .4826 .57048 .49033 .56749 .48603 .56217 Metetra
.683 .723 .88 r
.48603 .56217 .49033 .56749 .49809 .56446 .49379 .55912 Metetra
.684 .723 .879 r
.49379 .55912 .49809 .56446 .50586 .56141 .50158 .55603 Metetra
.685 .723 .879 r
.50158 .55603 .50586 .56141 .51365 .55832 .50938 .55292 Metetra
.686 .722 .878 r
.50938 .55292 .51365 .55832 .52146 .5552 .51721 .54977 Metetra
.687 .722 .877 r
.51721 .54977 .52146 .5552 .52929 .55204 .52505 .54659 Metetra
.688 .722 .876 r
.52505 .54659 .52929 .55204 .53714 .54885 .53291 .54337 Metetra
.689 .722 .875 r
.53291 .54337 .53714 .54885 .54501 .54562 .54079 .5401 Metetra
.69 .722 .874 r
.54079 .5401 .54501 .54562 .55289 .54235 .54869 .5368 Metetra
.691 .721 .873 r
.54869 .5368 .55289 .54235 .56079 .53903 .5566 .53345 Metetra
.693 .721 .871 r
.5566 .53345 .56079 .53903 .56871 .53567 .56454 .53005 Metetra
.694 .721 .87 r
.56454 .53005 .56871 .53567 .57665 .53225 .57249 .52661 Metetra
.696 .721 .869 r
.57249 .52661 .57665 .53225 .58461 .52879 .58046 .52311 Metetra
.697 .721 .867 r
.58046 .52311 .58461 .52879 .59258 .52527 .58844 .51956 Metetra
.699 .72 .866 r
.58844 .51956 .59258 .52527 .60057 .52169 .59645 .51594 Metetra
.701 .72 .864 r
.59645 .51594 .60057 .52169 .60857 .51805 .60446 .51226 Metetra
.703 .72 .863 r
.60446 .51226 .60857 .51805 .61659 .51434 .6125 .50851 Metetra
.705 .72 .861 r
.6125 .50851 .61659 .51434 .62463 .51056 .62055 .50468 Metetra
.707 .72 .859 r
.62055 .50468 .62463 .51056 .63268 .50669 .62861 .50078 Metetra
.71 .719 .857 r
.62861 .50078 .63268 .50669 .64074 .50274 .63669 .49678 Metetra
.712 .719 .855 r
.63669 .49678 .64074 .50274 .64882 .4987 .64478 .49269 Metetra
.715 .719 .852 r
.64478 .49269 .64882 .4987 .65691 .49455 .65288 .48849 Metetra
.718 .719 .85 r
.65288 .48849 .65691 .49455 .66501 .4903 .66099 .48418 Metetra
.722 .719 .847 r
.66099 .48418 .66501 .4903 .67312 .48591 .66912 .47974 Metetra
.725 .719 .844 r
.66912 .47974 .67312 .48591 .68124 .48139 .67725 .47516 Metetra
.729 .719 .84 r
.67725 .47516 .68124 .48139 .68936 .47672 .68538 .47042 Metetra
.734 .718 .837 r
.68538 .47042 .68936 .47672 .69749 .47187 .69352 .4655 Metetra
.738 .718 .833 r
.69352 .4655 .69749 .47187 .70562 .46683 .70167 .46039 Metetra
.744 .718 .828 r
.70167 .46039 .70562 .46683 .71375 .46156 .70981 .45504 Metetra
.75 .718 .823 r
.70981 .45504 .71375 .46156 .72188 .45605 .71794 .44943 Metetra
.756 .718 .817 r
.71794 .44943 .72188 .45605 .72999 .45023 .72607 .44351 Metetra
.763 .718 .81 r
.72607 .44351 .72999 .45023 .7381 .44407 .73418 .43723 Metetra
.771 .718 .802 r
.73418 .43723 .7381 .44407 .74618 .43749 .74227 .43052 Metetra
.781 .718 .793 r
.74227 .43052 .74618 .43749 .75422 .43041 .75032 .42329 Metetra
.791 .718 .783 r
.75032 .42329 .75422 .43041 .76223 .42272 .75833 .41541 Metetra
.803 .717 .77 r
.75833 .41541 .76223 .42272 .77017 .41424 .76628 .40671 Metetra
.817 .717 .754 r
.76628 .40671 .77017 .41424 .77803 .40475 .77413 .39691 Metetra
.833 .715 .734 r
.77413 .39691 .77803 .40475 .78576 .39385 .78185 .38561 Metetra
.853 .714 .708 r
.78185 .38561 .78576 .39385 .7933 .38089 .78936 .37204 Metetra
.877 .71 .671 r
.78936 .37204 .7933 .38089 .80052 .36452 .7965 .35452 Metetra
.914 .704 .604 r
.7965 .35452 .80052 .36452 .80701 .34058 .80268 .32676 Metetra
.887 .665 .596 r
.80268 .32676 .80701 .34058 .81203 .30161 .80853 .29655 Metetra
.664 .741 .908 r
.80853 .29655 .81203 .30161 .82031 .29887 .81682 .2938 Metetra
.664 .741 .908 r
.81682 .2938 .82031 .29887 .82861 .29613 .82513 .29103 Metetra
.664 .741 .908 r
.82513 .29103 .82861 .29613 .83693 .29337 .83347 .28826 Metetra
.664 .741 .908 r
.83347 .28826 .83693 .29337 .84528 .29061 .84184 .28548 Metetra
.664 .741 .908 r
.84184 .28548 .84528 .29061 .85365 .28784 .85023 .2827 Metetra
.664 .741 .908 r
.85023 .2827 .85365 .28784 .86204 .28506 .85864 .2799 Metetra
.664 .741 .908 r
.85864 .2799 .86204 .28506 .87046 .28227 .86707 .2771 Metetra
.667 .729 .896 r
.25013 .64125 .25483 .64595 .262 .64349 .25731 .63878 Metetra
.668 .729 .895 r
.25731 .63878 .262 .64349 .26919 .64102 .26451 .63628 Metetra
.668 .729 .895 r
.26451 .63628 .26919 .64102 .2764 .63853 .27173 .63378 Metetra
.668 .729 .895 r
.27173 .63378 .2764 .63853 .28362 .63603 .27897 .63126 Metetra
.669 .728 .894 r
.27897 .63126 .28362 .63603 .29087 .63352 .28623 .62873 Metetra
.669 .728 .894 r
.28623 .62873 .29087 .63352 .29814 .63099 .2935 .62618 Metetra
.669 .728 .894 r
.2935 .62618 .29814 .63099 .30542 .62845 .3008 .62362 Metetra
.67 .728 .893 r
.3008 .62362 .30542 .62845 .31272 .62589 .30811 .62105 Metetra
.67 .728 .893 r
.30811 .62105 .31272 .62589 .32005 .62332 .31545 .61846 Metetra
.67 .728 .892 r
.31545 .61846 .32005 .62332 .32739 .62074 .3228 .61586 Metetra
.671 .727 .892 r
.3228 .61586 .32739 .62074 .33475 .61814 .33017 .61324 Metetra
.671 .727 .892 r
.33017 .61324 .33475 .61814 .34213 .61552 .33756 .6106 Metetra
.672 .727 .891 r
.33756 .6106 .34213 .61552 .34953 .61289 .34498 .60795 Metetra
.672 .727 .891 r
.34498 .60795 .34953 .61289 .35695 .61024 .35241 .60529 Metetra
.672 .727 .89 r
.35241 .60529 .35695 .61024 .36438 .60757 .35986 .6026 Metetra
.673 .727 .89 r
.35986 .6026 .36438 .60757 .37184 .60489 .36733 .5999 Metetra
.673 .726 .89 r
.36733 .5999 .37184 .60489 .37932 .60219 .37481 .59718 Metetra
.674 .726 .889 r
.37481 .59718 .37932 .60219 .38681 .59947 .38232 .59444 Metetra
.674 .726 .889 r
.38232 .59444 .38681 .59947 .39433 .59673 .38985 .59168 Metetra
.675 .726 .888 r
.38985 .59168 .39433 .59673 .40186 .59398 .3974 .5889 Metetra
.676 .726 .887 r
.3974 .5889 .40186 .59398 .40942 .5912 .40496 .5861 Metetra
.676 .726 .887 r
.40496 .5861 .40942 .5912 .41699 .5884 .41255 .58328 Metetra
.677 .725 .886 r
.41255 .58328 .41699 .5884 .42459 .58558 .42016 .58044 Metetra
.677 .725 .886 r
.42016 .58044 .42459 .58558 .4322 .58274 .42778 .57758 Metetra
.678 .725 .885 r
.42778 .57758 .4322 .58274 .43983 .57988 .43542 .57469 Metetra
.679 .725 .885 r
.43542 .57469 .43983 .57988 .44748 .57699 .44309 .57178 Metetra
.679 .725 .884 r
.44309 .57178 .44748 .57699 .45515 .57408 .45077 .56884 Metetra
.68 .724 .883 r
.45077 .56884 .45515 .57408 .46284 .57114 .45847 .56588 Metetra
.681 .724 .883 r
.45847 .56588 .46284 .57114 .47055 .56818 .4662 .56289 Metetra
.682 .724 .882 r
.4662 .56289 .47055 .56818 .47828 .56519 .47394 .55988 Metetra
.682 .724 .881 r
.47394 .55988 .47828 .56519 .48603 .56217 .4817 .55683 Metetra
.683 .724 .88 r
.4817 .55683 .48603 .56217 .49379 .55912 .48948 .55376 Metetra
.684 .723 .879 r
.48948 .55376 .49379 .55912 .50158 .55603 .49728 .55065 Metetra
.685 .723 .879 r
.49728 .55065 .50158 .55603 .50938 .55292 .5051 .54751 Metetra
.686 .723 .878 r
.5051 .54751 .50938 .55292 .51721 .54977 .51293 .54433 Metetra
.687 .723 .877 r
.51293 .54433 .51721 .54977 .52505 .54659 .52079 .54112 Metetra
.688 .723 .876 r
.52079 .54112 .52505 .54659 .53291 .54337 .52866 .53787 Metetra
.69 .722 .875 r
.52866 .53787 .53291 .54337 .54079 .5401 .53656 .53457 Metetra
.691 .722 .874 r
.53656 .53457 .54079 .5401 .54869 .5368 .54447 .53124 Metetra
.692 .722 .873 r
.54447 .53124 .54869 .5368 .5566 .53345 .5524 .52786 Metetra
.694 .722 .871 r
.5524 .52786 .5566 .53345 .56454 .53005 .56034 .52443 Metetra
.695 .722 .87 r
.56034 .52443 .56454 .53005 .57249 .52661 .56831 .52095 Metetra
.697 .721 .869 r
.56831 .52095 .57249 .52661 .58046 .52311 .57629 .51742 Metetra
.698 .721 .867 r
.57629 .51742 .58046 .52311 .58844 .51956 .58429 .51383 Metetra
.7 .721 .866 r
.58429 .51383 .58844 .51956 .59645 .51594 .5923 .51017 Metetra
.702 .721 .864 r
.5923 .51017 .59645 .51594 .60446 .51226 .60034 .50645 Metetra
.704 .721 .863 r
.60034 .50645 .60446 .51226 .6125 .50851 .60838 .50266 Metetra
.706 .721 .861 r
.60838 .50266 .6125 .50851 .62055 .50468 .61645 .4988 Metetra
.708 .72 .859 r
.61645 .4988 .62055 .50468 .62861 .50078 .62452 .49484 Metetra
.711 .72 .857 r
.62452 .49484 .62861 .50078 .63669 .49678 .63261 .4908 Metetra
.714 .72 .855 r
.63261 .4908 .63669 .49678 .64478 .49269 .64072 .48666 Metetra
.717 .72 .852 r
.64072 .48666 .64478 .49269 .65288 .48849 .64883 .48242 Metetra
.72 .72 .849 r
.64883 .48242 .65288 .48849 .66099 .48418 .65696 .47805 Metetra
.723 .72 .847 r
.65696 .47805 .66099 .48418 .66912 .47974 .66509 .47355 Metetra
.727 .72 .843 r
.66509 .47355 .66912 .47974 .67725 .47516 .67324 .46891 Metetra
.731 .719 .84 r
.67324 .46891 .67725 .47516 .68538 .47042 .68139 .46411 Metetra
.735 .719 .836 r
.68139 .46411 .68538 .47042 .69352 .4655 .68954 .45912 Metetra
.74 .719 .832 r
.68954 .45912 .69352 .4655 .70167 .46039 .69769 .45392 Metetra
.746 .719 .827 r
.69769 .45392 .70167 .46039 .70981 .45504 .70585 .44849 Metetra
.752 .719 .822 r
.70585 .44849 .70981 .45504 .71794 .44943 .71399 .44279 Metetra
.758 .719 .816 r
.71399 .44279 .71794 .44943 .72607 .44351 .72213 .43677 Metetra
.766 .719 .809 r
.72213 .43677 .72607 .44351 .73418 .43723 .73025 .43037 Metetra
.774 .719 .801 r
.73025 .43037 .73418 .43723 .74227 .43052 .73835 .42352 Metetra
.784 .719 .792 r
.73835 .42352 .74227 .43052 .75032 .42329 .74641 .41613 Metetra
.794 .719 .78 r
.74641 .41613 .75032 .42329 .75833 .41541 .75442 .40806 Metetra
.807 .718 .767 r
.75442 .40806 .75833 .41541 .76628 .40671 .76237 .39912 Metetra
.821 .717 .75 r
.76237 .39912 .76628 .40671 .77413 .39691 .77021 .38902 Metetra
.838 .716 .729 r
.77021 .38902 .77413 .39691 .78185 .38561 .77792 .37727 Metetra
.858 .714 .701 r
.77792 .37727 .78185 .38561 .78936 .37204 .78539 .36301 Metetra
.885 .71 .66 r
.78539 .36301 .78936 .37204 .7965 .35452 .79243 .34409 Metetra
.931 .703 .571 r
.79243 .34409 .7965 .35452 .80268 .32676 .79798 .30871 Metetra
.777 .585 .639 r
.79798 .30871 .80268 .32676 .80853 .29655 .805 .29146 Metetra
.664 .741 .908 r
.805 .29146 .80853 .29655 .81682 .2938 .81331 .28869 Metetra
.664 .741 .908 r
.81331 .28869 .81682 .2938 .82513 .29103 .82164 .28591 Metetra
.664 .741 .908 r
.82164 .28591 .82513 .29103 .83347 .28826 .83 .28313 Metetra
.664 .741 .908 r
.83 .28313 .83347 .28826 .84184 .28548 .83838 .28033 Metetra
.664 .741 .908 r
.83838 .28033 .84184 .28548 .85023 .2827 .84679 .27753 Metetra
.664 .741 .908 r
.84679 .27753 .85023 .2827 .85864 .2799 .85522 .27472 Metetra
.664 .741 .908 r
.85522 .27472 .85864 .2799 .86707 .2771 .86367 .27191 Metetra
.668 .729 .896 r
.2454 .63654 .25013 .64125 .25731 .63878 .2526 .63405 Metetra
.668 .729 .895 r
.2526 .63405 .25731 .63878 .26451 .63628 .25981 .63154 Metetra
.668 .729 .895 r
.25981 .63154 .26451 .63628 .27173 .63378 .26704 .62901 Metetra
.669 .729 .895 r
.26704 .62901 .27173 .63378 .27897 .63126 .27429 .62648 Metetra
.669 .729 .894 r
.27429 .62648 .27897 .63126 .28623 .62873 .28156 .62393 Metetra
.669 .729 .894 r
.28156 .62393 .28623 .62873 .2935 .62618 .28885 .62137 Metetra
.67 .729 .894 r
.28885 .62137 .2935 .62618 .3008 .62362 .29615 .61879 Metetra
.67 .728 .893 r
.29615 .61879 .3008 .62362 .30811 .62105 .30348 .6162 Metetra
.67 .728 .893 r
.30348 .6162 .30811 .62105 .31545 .61846 .31083 .61359 Metetra
.671 .728 .893 r
.31083 .61359 .31545 .61846 .3228 .61586 .31819 .61097 Metetra
.671 .728 .892 r
.31819 .61097 .3228 .61586 .33017 .61324 .32558 .60833 Metetra
.672 .728 .892 r
.32558 .60833 .33017 .61324 .33756 .6106 .33298 .60568 Metetra
.672 .728 .891 r
.33298 .60568 .33756 .6106 .34498 .60795 .3404 .60301 Metetra
.672 .727 .891 r
.3404 .60301 .34498 .60795 .35241 .60529 .34784 .60032 Metetra
.673 .727 .891 r
.34784 .60032 .35241 .60529 .35986 .6026 .35531 .59761 Metetra
.673 .727 .89 r
.35531 .59761 .35986 .6026 .36733 .5999 .36279 .59489 Metetra
.674 .727 .89 r
.36279 .59489 .36733 .5999 .37481 .59718 .37029 .59215 Metetra
.674 .727 .889 r
.37029 .59215 .37481 .59718 .38232 .59444 .37781 .58939 Metetra
.675 .727 .889 r
.37781 .58939 .38232 .59444 .38985 .59168 .38535 .58661 Metetra
.675 .726 .888 r
.38535 .58661 .38985 .59168 .3974 .5889 .39291 .58381 Metetra
.676 .726 .888 r
.39291 .58381 .3974 .5889 .40496 .5861 .40049 .58099 Metetra
.677 .726 .887 r
.40049 .58099 .40496 .5861 .41255 .58328 .40809 .57815 Metetra
.677 .726 .887 r
.40809 .57815 .41255 .58328 .42016 .58044 .4157 .57529 Metetra
.678 .726 .886 r
.4157 .57529 .42016 .58044 .42778 .57758 .42334 .5724 Metetra
.678 .726 .885 r
.42334 .5724 .42778 .57758 .43542 .57469 .431 .56949 Metetra
.679 .725 .885 r
.431 .56949 .43542 .57469 .44309 .57178 .43868 .56656 Metetra
.68 .725 .884 r
.43868 .56656 .44309 .57178 .45077 .56884 .44637 .5636 Metetra
.681 .725 .883 r
.44637 .5636 .45077 .56884 .45847 .56588 .45409 .56061 Metetra
.681 .725 .883 r
.45409 .56061 .45847 .56588 .4662 .56289 .46182 .5576 Metetra
.682 .725 .882 r
.46182 .5576 .4662 .56289 .47394 .55988 .46958 .55456 Metetra
.683 .724 .881 r
.46958 .55456 .47394 .55988 .4817 .55683 .47735 .55148 Metetra
.684 .724 .88 r
.47735 .55148 .4817 .55683 .48948 .55376 .48514 .54838 Metetra
.685 .724 .88 r
.48514 .54838 .48948 .55376 .49728 .55065 .49296 .54525 Metetra
.686 .724 .879 r
.49296 .54525 .49728 .55065 .5051 .54751 .50079 .54208 Metetra
.687 .724 .878 r
.50079 .54208 .5051 .54751 .51293 .54433 .50864 .53887 Metetra
.688 .724 .877 r
.50864 .53887 .51293 .54433 .52079 .54112 .51651 .53563 Metetra
.689 .723 .876 r
.51651 .53563 .52079 .54112 .52866 .53787 .52439 .53235 Metetra
.69 .723 .875 r
.52439 .53235 .52866 .53787 .53656 .53457 .5323 .52903 Metetra
.692 .723 .874 r
.5323 .52903 .53656 .53457 .54447 .53124 .54022 .52566 Metetra
.693 .723 .873 r
.54022 .52566 .54447 .53124 .5524 .52786 .54817 .52225 Metetra
.694 .723 .871 r
.54817 .52225 .5524 .52786 .56034 .52443 .55613 .51879 Metetra
.696 .722 .87 r
.55613 .51879 .56034 .52443 .56831 .52095 .56411 .51528 Metetra
.697 .722 .869 r
.56411 .51528 .56831 .52095 .57629 .51742 .5721 .51171 Metetra
.699 .722 .867 r
.5721 .51171 .57629 .51742 .58429 .51383 .58011 .50808 Metetra
.701 .722 .866 r
.58011 .50808 .58429 .51383 .5923 .51017 .58814 .50439 Metetra
.703 .722 .864 r
.58814 .50439 .5923 .51017 .60034 .50645 .59619 .50063 Metetra
.705 .721 .863 r
.59619 .50063 .60034 .50645 .60838 .50266 .60425 .4968 Metetra
.707 .721 .861 r
.60425 .4968 .60838 .50266 .61645 .4988 .61233 .49289 Metetra
.71 .721 .859 r
.61233 .49289 .61645 .4988 .62452 .49484 .62042 .4889 Metetra
.712 .721 .857 r
.62042 .4889 .62452 .49484 .63261 .4908 .62852 .48481 Metetra
.715 .721 .854 r
.62852 .48481 .63261 .4908 .64072 .48666 .63664 .48062 Metetra
.718 .721 .852 r
.63664 .48062 .64072 .48666 .64883 .48242 .64477 .47632 Metetra
.721 .721 .849 r
.64477 .47632 .64883 .48242 .65696 .47805 .6529 .4719 Metetra
.725 .721 .846 r
.6529 .4719 .65696 .47805 .66509 .47355 .66105 .46735 Metetra
.728 .72 .843 r
.66105 .46735 .66509 .47355 .67324 .46891 .66921 .46264 Metetra
.732 .72 .839 r
.66921 .46264 .67324 .46891 .68139 .46411 .67737 .45777 Metetra
.737 .72 .836 r
.67737 .45777 .68139 .46411 .68954 .45912 .68554 .45271 Metetra
.742 .72 .831 r
.68554 .45271 .68954 .45912 .69769 .45392 .6937 .44744 Metetra
.748 .72 .826 r
.6937 .44744 .69769 .45392 .70585 .44849 .70187 .44192 Metetra
.754 .72 .821 r
.70187 .44192 .70585 .44849 .71399 .44279 .71003 .43612 Metetra
.761 .72 .815 r
.71003 .43612 .71399 .44279 .72213 .43677 .71817 .43 Metetra
.768 .72 .808 r
.71817 .43 .72213 .43677 .73025 .43037 .7263 .42348 Metetra
.777 .72 .799 r
.7263 .42348 .73025 .43037 .73835 .42352 .73441 .4165 Metetra
.787 .72 .79 r
.73441 .4165 .73835 .42352 .74641 .41613 .74247 .40894 Metetra
.798 .719 .778 r
.74247 .40894 .74641 .41613 .75442 .40806 .75049 .40067 Metetra
.81 .719 .764 r
.75049 .40067 .75442 .40806 .76237 .39912 .75844 .39148 Metetra
.825 .718 .747 r
.75844 .39148 .76237 .39912 .77021 .38902 .76628 .38104 Metetra
.843 .716 .724 r
.76628 .38104 .77021 .38902 .77792 .37727 .77396 .36882 Metetra
.864 .714 .693 r
.77396 .36882 .77792 .37727 .78539 .36301 .7814 .35376 Metetra
.893 .709 .647 r
.7814 .35376 .78539 .36301 .79243 .34409 .78831 .33307 Metetra
.942 .7 .543 r
.78831 .33307 .79243 .34409 .79798 .30871 .79315 .28912 Metetra
.605 .472 .673 r
.79315 .28912 .79798 .30871 .805 .29146 .80146 .28634 Metetra
.664 .741 .908 r
.80146 .28634 .805 .29146 .81331 .28869 .80978 .28356 Metetra
.664 .741 .908 r
.80978 .28356 .81331 .28869 .82164 .28591 .81813 .28076 Metetra
.664 .741 .908 r
.81813 .28076 .82164 .28591 .83 .28313 .82651 .27796 Metetra
.664 .741 .908 r
.82651 .27796 .83 .28313 .83838 .28033 .83491 .27516 Metetra
.664 .741 .908 r
.83491 .27516 .83838 .28033 .84679 .27753 .84333 .27234 Metetra
.664 .741 .908 r
.84333 .27234 .84679 .27753 .85522 .27472 .85178 .26952 Metetra
.664 .741 .908 r
.85178 .26952 .85522 .27472 .86367 .27191 .86025 .26668 Metetra
.668 .73 .896 r
.24066 .63182 .2454 .63654 .2526 .63405 .24786 .6293 Metetra
.668 .73 .896 r
.24786 .6293 .2526 .63405 .25981 .63154 .25509 .62678 Metetra
.669 .73 .895 r
.25509 .62678 .25981 .63154 .26704 .62901 .26233 .62424 Metetra
.669 .729 .895 r
.26233 .62424 .26704 .62901 .27429 .62648 .26959 .62168 Metetra
.669 .729 .895 r
.26959 .62168 .27429 .62648 .28156 .62393 .27687 .61912 Metetra
.67 .729 .894 r
.27687 .61912 .28156 .62393 .28885 .62137 .28417 .61654 Metetra
.67 .729 .894 r
.28417 .61654 .28885 .62137 .29615 .61879 .29149 .61394 Metetra
.67 .729 .894 r
.29149 .61394 .29615 .61879 .30348 .6162 .29883 .61133 Metetra
.671 .729 .893 r
.29883 .61133 .30348 .6162 .31083 .61359 .30618 .60871 Metetra
.671 .729 .893 r
.30618 .60871 .31083 .61359 .31819 .61097 .31356 .60606 Metetra
.671 .728 .892 r
.31356 .60606 .31819 .61097 .32558 .60833 .32096 .60341 Metetra
.672 .728 .892 r
.32096 .60341 .32558 .60833 .33298 .60568 .32837 .60073 Metetra
.672 .728 .892 r
.32837 .60073 .33298 .60568 .3404 .60301 .33581 .59804 Metetra
.673 .728 .891 r
.33581 .59804 .3404 .60301 .34784 .60032 .34326 .59534 Metetra
.673 .728 .891 r
.34326 .59534 .34784 .60032 .35531 .59761 .35074 .59261 Metetra
.674 .728 .89 r
.35074 .59261 .35531 .59761 .36279 .59489 .35823 .58987 Metetra
.674 .727 .89 r
.35823 .58987 .36279 .59489 .37029 .59215 .36574 .58711 Metetra
.675 .727 .889 r
.36574 .58711 .37029 .59215 .37781 .58939 .37327 .58433 Metetra
.675 .727 .889 r
.37327 .58433 .37781 .58939 .38535 .58661 .38083 .58153 Metetra
.676 .727 .888 r
.38083 .58153 .38535 .58661 .39291 .58381 .3884 .57871 Metetra
.676 .727 .888 r
.3884 .57871 .39291 .58381 .40049 .58099 .39599 .57586 Metetra
.677 .727 .887 r
.39599 .57586 .40049 .58099 .40809 .57815 .4036 .573 Metetra
.678 .726 .887 r
.4036 .573 .40809 .57815 .4157 .57529 .41123 .57012 Metetra
.678 .726 .886 r
.41123 .57012 .4157 .57529 .42334 .5724 .41888 .56721 Metetra
.679 .726 .886 r
.41888 .56721 .42334 .5724 .431 .56949 .42655 .56427 Metetra
.68 .726 .885 r
.42655 .56427 .431 .56949 .43868 .56656 .43424 .56132 Metetra
.68 .726 .884 r
.43424 .56132 .43868 .56656 .44637 .5636 .44195 .55833 Metetra
.681 .726 .884 r
.44195 .55833 .44637 .5636 .45409 .56061 .44968 .55532 Metetra
.682 .725 .883 r
.44968 .55532 .45409 .56061 .46182 .5576 .45743 .55229 Metetra
.683 .725 .882 r
.45743 .55229 .46182 .5576 .46958 .55456 .46519 .54922 Metetra
.684 .725 .881 r
.46519 .54922 .46958 .55456 .47735 .55148 .47298 .54612 Metetra
.684 .725 .881 r
.47298 .54612 .47735 .55148 .48514 .54838 .48079 .54299 Metetra
.685 .725 .88 r
.48079 .54299 .48514 .54838 .49296 .54525 .48861 .53983 Metetra
.686 .725 .879 r
.48861 .53983 .49296 .54525 .50079 .54208 .49646 .53664 Metetra
.687 .724 .878 r
.49646 .53664 .50079 .54208 .50864 .53887 .50432 .5334 Metetra
.689 .724 .877 r
.50432 .5334 .50864 .53887 .51651 .53563 .5122 .53013 Metetra
.69 .724 .876 r
.5122 .53013 .51651 .53563 .52439 .53235 .5201 .52682 Metetra
.691 .724 .875 r
.5201 .52682 .52439 .53235 .5323 .52903 .52802 .52347 Metetra
.692 .724 .874 r
.52802 .52347 .5323 .52903 .54022 .52566 .53596 .52007 Metetra
.694 .723 .873 r
.53596 .52007 .54022 .52566 .54817 .52225 .54392 .51663 Metetra
.695 .723 .871 r
.54392 .51663 .54817 .52225 .55613 .51879 .55189 .51314 Metetra
.697 .723 .87 r
.55189 .51314 .55613 .51879 .56411 .51528 .55988 .50959 Metetra
.698 .723 .869 r
.55988 .50959 .56411 .51528 .5721 .51171 .56789 .50599 Metetra
.7 .723 .867 r
.56789 .50599 .5721 .51171 .58011 .50808 .57592 .50232 Metetra
.702 .723 .866 r
.57592 .50232 .58011 .50808 .58814 .50439 .58396 .49859 Metetra
.704 .722 .864 r
.58396 .49859 .58814 .50439 .59619 .50063 .59202 .4948 Metetra
.706 .722 .862 r
.59202 .4948 .59619 .50063 .60425 .4968 .6001 .49092 Metetra
.708 .722 .861 r
.6001 .49092 .60425 .4968 .61233 .49289 .60819 .48697 Metetra
.711 .722 .859 r
.60819 .48697 .61233 .49289 .62042 .4889 .61629 .48293 Metetra
.713 .722 .856 r
.61629 .48293 .62042 .4889 .62852 .48481 .62441 .4788 Metetra
.716 .722 .854 r
.62441 .4788 .62852 .48481 .63664 .48062 .63254 .47456 Metetra
.719 .722 .852 r
.63254 .47456 .63664 .48062 .64477 .47632 .64068 .47021 Metetra
.722 .721 .849 r
.64068 .47021 .64477 .47632 .6529 .4719 .64883 .46574 Metetra
.726 .721 .846 r
.64883 .46574 .6529 .4719 .66105 .46735 .657 .46113 Metetra
.73 .721 .843 r
.657 .46113 .66105 .46735 .66921 .46264 .66516 .45636 Metetra
.734 .721 .839 r
.66516 .45636 .66921 .46264 .67737 .45777 .67334 .45142 Metetra
.739 .721 .835 r
.67334 .45142 .67737 .45777 .68554 .45271 .68152 .44629 Metetra
.744 .721 .831 r
.68152 .44629 .68554 .45271 .6937 .44744 .6897 .44094 Metetra
.75 .721 .826 r
.6897 .44094 .6937 .44744 .70187 .44192 .69787 .43533 Metetra
.756 .721 .82 r
.69787 .43533 .70187 .44192 .71003 .43612 .70604 .42944 Metetra
.763 .721 .813 r
.70604 .42944 .71003 .43612 .71817 .43 .7142 .4232 Metetra
.771 .721 .806 r
.7142 .4232 .71817 .43 .7263 .42348 .72234 .41656 Metetra
.779 .721 .798 r
.72234 .41656 .7263 .42348 .73441 .4165 .73045 .40944 Metetra
.789 .721 .788 r
.73045 .40944 .73441 .4165 .74247 .40894 .73853 .40171 Metetra
.801 .72 .775 r
.73853 .40171 .74247 .40894 .75049 .40067 .74655 .39323 Metetra
.814 .72 .761 r
.74655 .39323 .75049 .40067 .75844 .39148 .75449 .38377 Metetra
.829 .718 .742 r
.75449 .38377 .75844 .39148 .76628 .38104 .76233 .37298 Metetra
.848 .717 .718 r
.76233 .37298 .76628 .38104 .77396 .36882 .76999 .36023 Metetra
.87 .713 .685 r
.76999 .36023 .77396 .36882 .7814 .35376 .77737 .34426 Metetra
.902 .708 .631 r
.77737 .34426 .7814 .35376 .78831 .33307 .78412 .32116 Metetra
.924 .69 .567 r
.78412 .32116 .78831 .33307 .79315 .28912 .78957 .28398 Metetra
.664 .741 .908 r
.78957 .28398 .79315 .28912 .80146 .28634 .79789 .28119 Metetra
.664 .741 .908 r
.79789 .28119 .80146 .28634 .80978 .28356 .80624 .2784 Metetra
.664 .741 .908 r
.80624 .2784 .80978 .28356 .81813 .28076 .8146 .27559 Metetra
.664 .741 .908 r
.8146 .27559 .81813 .28076 .82651 .27796 .823 .27277 Metetra
.664 .741 .908 r
.823 .27277 .82651 .27796 .83491 .27516 .83141 .26995 Metetra
.664 .741 .908 r
.83141 .26995 .83491 .27516 .84333 .27234 .83985 .26712 Metetra
.664 .741 .908 r
.83985 .26712 .84333 .27234 .85178 .26952 .84832 .26428 Metetra
.664 .741 .908 r
.84832 .26428 .85178 .26952 .86025 .26668 .85681 .26143 Metetra
.668 .73 .896 r
.23589 .62708 .24066 .63182 .24786 .6293 .2431 .62455 Metetra
.669 .73 .896 r
.2431 .62455 .24786 .6293 .25509 .62678 .25034 .622 Metetra
.669 .73 .896 r
.25034 .622 .25509 .62678 .26233 .62424 .25759 .61945 Metetra
.669 .73 .895 r
.25759 .61945 .26233 .62424 .26959 .62168 .26487 .61688 Metetra
.67 .73 .895 r
.26487 .61688 .26959 .62168 .27687 .61912 .27216 .61429 Metetra
.67 .73 .894 r
.27216 .61429 .27687 .61912 .28417 .61654 .27947 .61169 Metetra
.67 .729 .894 r
.27947 .61169 .28417 .61654 .29149 .61394 .2868 .60908 Metetra
.671 .729 .894 r
.2868 .60908 .29149 .61394 .29883 .61133 .29415 .60645 Metetra
.671 .729 .893 r
.29415 .60645 .29883 .61133 .30618 .60871 .30152 .60381 Metetra
.671 .729 .893 r
.30152 .60381 .30618 .60871 .31356 .60606 .30891 .60115 Metetra
.672 .729 .893 r
.30891 .60115 .31356 .60606 .32096 .60341 .31631 .59847 Metetra
.672 .729 .892 r
.31631 .59847 .32096 .60341 .32837 .60073 .32374 .59578 Metetra
.673 .729 .892 r
.32374 .59578 .32837 .60073 .33581 .59804 .33119 .59307 Metetra
.673 .728 .891 r
.33119 .59307 .33581 .59804 .34326 .59534 .33866 .59034 Metetra
.674 .728 .891 r
.33866 .59034 .34326 .59534 .35074 .59261 .34614 .5876 Metetra
.674 .728 .89 r
.34614 .5876 .35074 .59261 .35823 .58987 .35365 .58483 Metetra
.675 .728 .89 r
.35365 .58483 .35823 .58987 .36574 .58711 .36117 .58205 Metetra
.675 .728 .89 r
.36117 .58205 .36574 .58711 .37327 .58433 .36872 .57925 Metetra
.676 .728 .889 r
.36872 .57925 .37327 .58433 .38083 .58153 .37628 .57643 Metetra
.676 .727 .888 r
.37628 .57643 .38083 .58153 .3884 .57871 .38387 .57359 Metetra
.677 .727 .888 r
.38387 .57359 .3884 .57871 .39599 .57586 .39147 .57072 Metetra
.677 .727 .887 r
.39147 .57072 .39599 .57586 .4036 .573 .39909 .56784 Metetra
.678 .727 .887 r
.39909 .56784 .4036 .573 .41123 .57012 .40674 .56493 Metetra
.679 .727 .886 r
.40674 .56493 .41123 .57012 .41888 .56721 .4144 .562 Metetra
.679 .727 .886 r
.4144 .562 .41888 .56721 .42655 .56427 .42208 .55904 Metetra
.68 .726 .885 r
.42208 .55904 .42655 .56427 .43424 .56132 .42979 .55606 Metetra
.681 .726 .884 r
.42979 .55606 .43424 .56132 .44195 .55833 .43751 .55306 Metetra
.682 .726 .884 r
.43751 .55306 .44195 .55833 .44968 .55532 .44525 .55002 Metetra
.682 .726 .883 r
.44525 .55002 .44968 .55532 .45743 .55229 .45301 .54696 Metetra
.683 .726 .882 r
.45301 .54696 .45743 .55229 .46519 .54922 .46079 .54387 Metetra
.684 .726 .881 r
.46079 .54387 .46519 .54922 .47298 .54612 .46859 .54074 Metetra
.685 .725 .881 r
.46859 .54074 .47298 .54612 .48079 .54299 .47641 .53759 Metetra
.686 .725 .88 r
.47641 .53759 .48079 .54299 .48861 .53983 .48425 .5344 Metetra
.687 .725 .879 r
.48425 .5344 .48861 .53983 .49646 .53664 .49211 .53118 Metetra
.688 .725 .878 r
.49211 .53118 .49646 .53664 .50432 .5334 .49998 .52792 Metetra
.689 .725 .877 r
.49998 .52792 .50432 .5334 .5122 .53013 .50788 .52462 Metetra
.69 .725 .876 r
.50788 .52462 .5122 .53013 .5201 .52682 .5158 .52128 Metetra
.692 .724 .875 r
.5158 .52128 .5201 .52682 .52802 .52347 .52373 .5179 Metetra
.693 .724 .874 r
.52373 .5179 .52802 .52347 .53596 .52007 .53168 .51447 Metetra
.694 .724 .873 r
.53168 .51447 .53596 .52007 .54392 .51663 .53965 .51099 Metetra
.696 .724 .871 r
.53965 .51099 .54392 .51663 .55189 .51314 .54764 .50746 Metetra
.697 .724 .87 r
.54764 .50746 .55189 .51314 .55988 .50959 .55564 .50388 Metetra
.699 .724 .869 r
.55564 .50388 .55988 .50959 .56789 .50599 .56367 .50025 Metetra
.701 .723 .867 r
.56367 .50025 .56789 .50599 .57592 .50232 .57171 .49655 Metetra
.703 .723 .866 r
.57171 .49655 .57592 .50232 .58396 .49859 .57976 .49278 Metetra
.705 .723 .864 r
.57976 .49278 .58396 .49859 .59202 .4948 .58784 .48894 Metetra
.707 .723 .862 r
.58784 .48894 .59202 .4948 .6001 .49092 .59592 .48503 Metetra
.709 .723 .86 r
.59592 .48503 .6001 .49092 .60819 .48697 .60403 .48104 Metetra
.712 .723 .858 r
.60403 .48104 .60819 .48697 .61629 .48293 .61215 .47695 Metetra
.714 .723 .856 r
.61215 .47695 .61629 .48293 .62441 .4788 .62028 .47277 Metetra
.717 .722 .854 r
.62028 .47277 .62441 .4788 .63254 .47456 .62842 .46849 Metetra
.72 .722 .851 r
.62842 .46849 .63254 .47456 .64068 .47021 .63658 .46408 Metetra
.724 .722 .848 r
.63658 .46408 .64068 .47021 .64883 .46574 .64474 .45955 Metetra
.727 .722 .845 r
.64474 .45955 .64883 .46574 .657 .46113 .65292 .45488 Metetra
.731 .722 .842 r
.65292 .45488 .657 .46113 .66516 .45636 .6611 .45005 Metetra
.736 .722 .838 r
.6611 .45005 .66516 .45636 .67334 .45142 .66929 .44505 Metetra
.74 .722 .834 r
.66929 .44505 .67334 .45142 .68152 .44629 .67748 .43984 Metetra
.746 .722 .83 r
.67748 .43984 .68152 .44629 .6897 .44094 .68567 .43441 Metetra
.751 .722 .825 r
.68567 .43441 .6897 .44094 .69787 .43533 .69386 .42872 Metetra
.758 .722 .819 r
.69386 .42872 .69787 .43533 .70604 .42944 .70204 .42273 Metetra
.765 .722 .812 r
.70204 .42273 .70604 .42944 .7142 .4232 .71021 .41638 Metetra
.773 .722 .805 r
.71021 .41638 .7142 .4232 .72234 .41656 .71836 .40961 Metetra
.782 .722 .796 r
.71836 .40961 .72234 .41656 .73045 .40944 .72648 .40234 Metetra
.792 .721 .785 r
.72648 .40234 .73045 .40944 .73853 .40171 .73456 .39444 Metetra
.804 .721 .773 r
.73456 .39444 .73853 .40171 .74655 .39323 .74258 .38574 Metetra
.818 .72 .757 r
.74258 .38574 .74655 .39323 .75449 .38377 .75053 .376 Metetra
.834 .719 .738 r
.75053 .376 .75449 .38377 .76233 .37298 .75835 .36482 Metetra
.853 .717 .712 r
.75835 .36482 .76233 .37298 .76999 .36023 .766 .35149 Metetra
.877 .713 .676 r
.766 .35149 .76999 .36023 .77737 .34426 .77331 .33443 Metetra
.913 .707 .61 r
.77331 .33443 .77737 .34426 .78412 .32116 .77979 .30771 Metetra
.886 .667 .601 r
.77979 .30771 .78412 .32116 .78957 .28398 .78598 .27883 Metetra
.664 .741 .908 r
.78598 .27883 .78957 .28398 .79789 .28119 .79431 .27602 Metetra
.664 .741 .908 r
.79431 .27602 .79789 .28119 .80624 .2784 .80267 .27321 Metetra
.664 .741 .908 r
.80267 .27321 .80624 .2784 .8146 .27559 .81106 .27039 Metetra
.664 .741 .908 r
.81106 .27039 .8146 .27559 .823 .27277 .81947 .26756 Metetra
.664 .741 .908 r
.81947 .26756 .823 .27277 .83141 .26995 .8279 .26472 Metetra
.664 .741 .908 r
.8279 .26472 .83141 .26995 .83985 .26712 .83636 .26187 Metetra
.664 .741 .908 r
.83636 .26187 .83985 .26712 .84832 .26428 .84484 .25902 Metetra
.664 .741 .908 r
.84484 .25902 .84832 .26428 .85681 .26143 .85335 .25615 Metetra
.669 .731 .896 r
.2311 .62232 .23589 .62708 .2431 .62455 .23832 .61978 Metetra
.669 .731 .896 r
.23832 .61978 .2431 .62455 .25034 .622 .24557 .61721 Metetra
.669 .73 .896 r
.24557 .61721 .25034 .622 .25759 .61945 .25283 .61464 Metetra
.669 .73 .895 r
.25283 .61464 .25759 .61945 .26487 .61688 .26012 .61205 Metetra
.67 .73 .895 r
.26012 .61205 .26487 .61688 .27216 .61429 .26742 .60945 Metetra
.67 .73 .895 r
.26742 .60945 .27216 .61429 .27947 .61169 .27475 .60683 Metetra
.671 .73 .894 r
.27475 .60683 .27947 .61169 .2868 .60908 .28209 .6042 Metetra
.671 .73 .894 r
.28209 .6042 .2868 .60908 .29415 .60645 .28945 .60155 Metetra
.671 .73 .894 r
.28945 .60155 .29415 .60645 .30152 .60381 .29683 .59889 Metetra
.672 .729 .893 r
.29683 .59889 .30152 .60381 .30891 .60115 .30423 .59621 Metetra
.672 .729 .893 r
.30423 .59621 .30891 .60115 .31631 .59847 .31165 .59352 Metetra
.673 .729 .892 r
.31165 .59352 .31631 .59847 .32374 .59578 .31909 .59081 Metetra
.673 .729 .892 r
.31909 .59081 .32374 .59578 .33119 .59307 .32655 .58808 Metetra
.673 .729 .892 r
.32655 .58808 .33119 .59307 .33866 .59034 .33403 .58533 Metetra
.674 .729 .891 r
.33403 .58533 .33866 .59034 .34614 .5876 .34153 .58257 Metetra
.674 .729 .891 r
.34153 .58257 .34614 .5876 .35365 .58483 .34904 .57978 Metetra
.675 .728 .89 r
.34904 .57978 .35365 .58483 .36117 .58205 .35658 .57698 Metetra
.675 .728 .89 r
.35658 .57698 .36117 .58205 .36872 .57925 .36414 .57416 Metetra
.676 .728 .889 r
.36414 .57416 .36872 .57925 .37628 .57643 .37172 .57132 Metetra
.677 .728 .889 r
.37172 .57132 .37628 .57643 .38387 .57359 .37931 .56845 Metetra
.677 .728 .888 r
.37931 .56845 .38387 .57359 .39147 .57072 .38693 .56557 Metetra
.678 .728 .888 r
.38693 .56557 .39147 .57072 .39909 .56784 .39457 .56266 Metetra
.678 .727 .887 r
.39457 .56266 .39909 .56784 .40674 .56493 .40222 .55973 Metetra
.679 .727 .886 r
.40222 .55973 .40674 .56493 .4144 .562 .4099 .55678 Metetra
.68 .727 .886 r
.4099 .55678 .4144 .562 .42208 .55904 .41759 .5538 Metetra
.68 .727 .885 r
.41759 .5538 .42208 .55904 .42979 .55606 .42531 .55079 Metetra
.681 .727 .884 r
.42531 .55079 .42979 .55606 .43751 .55306 .43304 .54776 Metetra
.682 .727 .884 r
.43304 .54776 .43751 .55306 .44525 .55002 .4408 .5447 Metetra
.683 .726 .883 r
.4408 .5447 .44525 .55002 .45301 .54696 .44857 .54162 Metetra
.684 .726 .882 r
.44857 .54162 .45301 .54696 .46079 .54387 .45637 .5385 Metetra
.685 .726 .882 r
.45637 .5385 .46079 .54387 .46859 .54074 .46418 .53535 Metetra
.686 .726 .881 r
.46418 .53535 .46859 .54074 .47641 .53759 .47201 .53217 Metetra
.687 .726 .88 r
.47201 .53217 .47641 .53759 .48425 .5344 .47987 .52895 Metetra
.688 .726 .879 r
.47987 .52895 .48425 .5344 .49211 .53118 .48774 .5257 Metetra
.689 .725 .878 r
.48774 .5257 .49211 .53118 .49998 .52792 .49563 .52241 Metetra
.69 .725 .877 r
.49563 .52241 .49998 .52792 .50788 .52462 .50354 .51909 Metetra
.691 .725 .876 r
.50354 .51909 .50788 .52462 .5158 .52128 .51147 .51572 Metetra
.692 .725 .875 r
.51147 .51572 .5158 .52128 .52373 .5179 .51941 .5123 Metetra
.694 .725 .874 r
.51941 .5123 .52373 .5179 .53168 .51447 .52738 .50884 Metetra
.695 .725 .873 r
.52738 .50884 .53168 .51447 .53965 .51099 .53536 .50534 Metetra
.697 .724 .871 r
.53536 .50534 .53965 .51099 .54764 .50746 .54336 .50178 Metetra
.698 .724 .87 r
.54336 .50178 .54764 .50746 .55564 .50388 .55138 .49816 Metetra
.7 .724 .869 r
.55138 .49816 .55564 .50388 .56367 .50025 .55942 .49449 Metetra
.702 .724 .867 r
.55942 .49449 .56367 .50025 .57171 .49655 .56747 .49075 Metetra
.704 .724 .866 r
.56747 .49075 .57171 .49655 .57976 .49278 .57554 .48695 Metetra
.706 .724 .864 r
.57554 .48695 .57976 .49278 .58784 .48894 .58363 .48307 Metetra
.708 .724 .862 r
.58363 .48307 .58784 .48894 .59592 .48503 .59173 .47912 Metetra
.71 .723 .86 r
.59173 .47912 .59592 .48503 .60403 .48104 .59985 .47508 Metetra
.713 .723 .858 r
.59985 .47508 .60403 .48104 .61215 .47695 .60798 .47095 Metetra
.715 .723 .856 r
.60798 .47095 .61215 .47695 .62028 .47277 .61613 .46673 Metetra
.718 .723 .854 r
.61613 .46673 .62028 .47277 .62842 .46849 .62429 .46239 Metetra
.722 .723 .851 r
.62429 .46239 .62842 .46849 .63658 .46408 .63246 .45794 Metetra
.725 .723 .848 r
.63246 .45794 .63658 .46408 .64474 .45955 .64064 .45335 Metetra
.729 .723 .845 r
.64064 .45335 .64474 .45955 .65292 .45488 .64883 .44862 Metetra
.733 .723 .842 r
.64883 .44862 .65292 .45488 .6611 .45005 .65702 .44373 Metetra
.737 .723 .838 r
.65702 .44373 .6611 .45005 .66929 .44505 .66522 .43865 Metetra
.742 .723 .834 r
.66522 .43865 .66929 .44505 .67748 .43984 .67343 .43337 Metetra
.747 .723 .829 r
.67343 .43337 .67748 .43984 .68567 .43441 .68163 .42786 Metetra
.753 .723 .824 r
.68163 .42786 .68567 .43441 .69386 .42872 .68983 .42208 Metetra
.76 .723 .818 r
.68983 .42208 .69386 .42872 .70204 .42273 .69802 .41599 Metetra
.767 .723 .811 r
.69802 .41599 .70204 .42273 .71021 .41638 .7062 .40953 Metetra
.776 .722 .803 r
.7062 .40953 .71021 .41638 .71836 .40961 .71436 .40263 Metetra
.785 .722 .794 r
.71436 .40263 .71836 .40961 .72648 .40234 .72249 .39521 Metetra
.795 .722 .783 r
.72249 .39521 .72648 .40234 .73456 .39444 .73058 .38712 Metetra
.807 .722 .77 r
.73058 .38712 .73456 .39444 .74258 .38574 .73861 .3782 Metetra
.821 .721 .754 r
.73861 .3782 .74258 .38574 .75053 .376 .74655 .36816 Metetra
.838 .719 .733 r
.74655 .36816 .75053 .376 .75835 .36482 .75436 .35656 Metetra
.858 .717 .705 r
.75436 .35656 .75835 .36482 .766 .35149 .76198 .34257 Metetra
.884 .712 .665 r
.76198 .34257 .766 .35149 .77331 .33443 .76921 .32419 Metetra
.93 .705 .577 r
.76921 .32419 .77331 .33443 .77979 .30771 .77514 .29022 Metetra
.777 .588 .644 r
.77514 .29022 .77979 .30771 .78598 .27883 .78236 .27364 Metetra
.664 .741 .908 r
.78236 .27364 .78598 .27883 .79431 .27602 .79071 .27082 Metetra
.664 .741 .908 r
.79071 .27082 .79431 .27602 .80267 .27321 .79909 .26799 Metetra
.664 .741 .908 r
.79909 .26799 .80267 .27321 .81106 .27039 .80749 .26515 Metetra
.664 .741 .908 r
.80749 .26515 .81106 .27039 .81947 .26756 .81592 .26231 Metetra
.664 .741 .908 r
.81592 .26231 .81947 .26756 .8279 .26472 .82437 .25945 Metetra
.664 .741 .908 r
.82437 .25945 .8279 .26472 .83636 .26187 .83284 .25659 Metetra
.664 .741 .908 r
.83284 .25659 .83636 .26187 .84484 .25902 .84135 .25372 Metetra
.664 .741 .908 r
.84135 .25372 .84484 .25902 .85335 .25615 .84987 .25084 Metetra
.669 .731 .896 r
.22628 .61755 .2311 .62232 .23832 .61978 .23352 .61499 Metetra
.669 .731 .896 r
.23352 .61499 .23832 .61978 .24557 .61721 .24078 .61241 Metetra
.669 .731 .896 r
.24078 .61241 .24557 .61721 .25283 .61464 .24805 .60982 Metetra
.67 .731 .895 r
.24805 .60982 .25283 .61464 .26012 .61205 .25535 .60721 Metetra
.67 .731 .895 r
.25535 .60721 .26012 .61205 .26742 .60945 .26266 .60459 Metetra
.67 .73 .895 r
.26266 .60459 .26742 .60945 .27475 .60683 .27 .60196 Metetra
.671 .73 .894 r
.27 .60196 .27475 .60683 .28209 .6042 .27735 .59931 Metetra
.671 .73 .894 r
.27735 .59931 .28209 .6042 .28945 .60155 .28473 .59664 Metetra
.672 .73 .894 r
.28473 .59664 .28945 .60155 .29683 .59889 .29212 .59396 Metetra
.672 .73 .893 r
.29212 .59396 .29683 .59889 .30423 .59621 .29953 .59127 Metetra
.672 .73 .893 r
.29953 .59127 .30423 .59621 .31165 .59352 .30696 .58855 Metetra
.673 .73 .892 r
.30696 .58855 .31165 .59352 .31909 .59081 .31441 .58582 Metetra
.673 .729 .892 r
.31441 .58582 .31909 .59081 .32655 .58808 .32189 .58307 Metetra
.674 .729 .892 r
.32189 .58307 .32655 .58808 .33403 .58533 .32938 .58031 Metetra
.674 .729 .891 r
.32938 .58031 .33403 .58533 .34153 .58257 .33689 .57752 Metetra
.675 .729 .891 r
.33689 .57752 .34153 .58257 .34904 .57978 .34442 .57472 Metetra
.675 .729 .89 r
.34442 .57472 .34904 .57978 .35658 .57698 .35197 .5719 Metetra
.676 .729 .89 r
.35197 .5719 .35658 .57698 .36414 .57416 .35954 .56905 Metetra
.676 .729 .889 r
.35954 .56905 .36414 .57416 .37172 .57132 .36713 .56619 Metetra
.677 .728 .889 r
.36713 .56619 .37172 .57132 .37931 .56845 .37474 .5633 Metetra
.678 .728 .888 r
.37474 .5633 .37931 .56845 .38693 .56557 .38237 .5604 Metetra
.678 .728 .888 r
.38237 .5604 .38693 .56557 .39457 .56266 .39002 .55747 Metetra
.679 .728 .887 r
.39002 .55747 .39457 .56266 .40222 .55973 .39769 .55452 Metetra
.68 .728 .886 r
.39769 .55452 .40222 .55973 .4099 .55678 .40537 .55154 Metetra
.68 .728 .886 r
.40537 .55154 .4099 .55678 .41759 .5538 .41308 .54854 Metetra
.681 .727 .885 r
.41308 .54854 .41759 .5538 .42531 .55079 .42081 .54551 Metetra
.682 .727 .885 r
.42081 .54551 .42531 .55079 .43304 .54776 .42856 .54245 Metetra
.683 .727 .884 r
.42856 .54245 .43304 .54776 .4408 .5447 .43633 .53937 Metetra
.683 .727 .883 r
.43633 .53937 .4408 .5447 .44857 .54162 .44411 .53626 Metetra
.684 .727 .882 r
.44411 .53626 .44857 .54162 .45637 .5385 .45192 .53312 Metetra
.685 .727 .882 r
.45192 .53312 .45637 .5385 .46418 .53535 .45975 .52994 Metetra
.686 .727 .881 r
.45975 .52994 .46418 .53535 .47201 .53217 .4676 .52673 Metetra
.687 .726 .88 r
.4676 .52673 .47201 .53217 .47987 .52895 .47546 .52349 Metetra
.688 .726 .879 r
.47546 .52349 .47987 .52895 .48774 .5257 .48335 .52021 Metetra
.689 .726 .878 r
.48335 .52021 .48774 .5257 .49563 .52241 .49125 .5169 Metetra
.69 .726 .877 r
.49125 .5169 .49563 .52241 .50354 .51909 .49917 .51354 Metetra
.692 .726 .876 r
.49917 .51354 .50354 .51909 .51147 .51572 .50712 .51014 Metetra
.693 .726 .875 r
.50712 .51014 .51147 .51572 .51941 .5123 .51508 .5067 Metetra
.694 .725 .874 r
.51508 .5067 .51941 .5123 .52738 .50884 .52306 .50321 Metetra
.696 .725 .873 r
.52306 .50321 .52738 .50884 .53536 .50534 .53105 .49966 Metetra
.697 .725 .871 r
.53105 .49966 .53536 .50534 .54336 .50178 .53907 .49607 Metetra
.699 .725 .87 r
.53907 .49607 .54336 .50178 .55138 .49816 .5471 .49242 Metetra
.701 .725 .869 r
.5471 .49242 .55138 .49816 .55942 .49449 .55515 .48871 Metetra
.703 .725 .867 r
.55515 .48871 .55942 .49449 .56747 .49075 .56322 .48494 Metetra
.705 .725 .866 r
.56322 .48494 .56747 .49075 .57554 .48695 .57131 .4811 Metetra
.707 .724 .864 r
.57131 .4811 .57554 .48695 .58363 .48307 .57941 .47718 Metetra
.709 .724 .862 r
.57941 .47718 .58363 .48307 .59173 .47912 .58752 .47319 Metetra
.711 .724 .86 r
.58752 .47319 .59173 .47912 .59985 .47508 .59566 .46911 Metetra
.714 .724 .858 r
.59566 .46911 .59985 .47508 .60798 .47095 .6038 .46494 Metetra
.717 .724 .856 r
.6038 .46494 .60798 .47095 .61613 .46673 .61196 .46066 Metetra
.72 .724 .853 r
.61196 .46066 .61613 .46673 .62429 .46239 .62013 .45628 Metetra
.723 .724 .851 r
.62013 .45628 .62429 .46239 .63246 .45794 .62832 .45177 Metetra
.726 .724 .848 r
.62832 .45177 .63246 .45794 .64064 .45335 .63651 .44713 Metetra
.73 .724 .844 r
.63651 .44713 .64064 .45335 .64883 .44862 .64471 .44234 Metetra
.734 .724 .841 r
.64471 .44234 .64883 .44862 .65702 .44373 .65292 .43738 Metetra
.739 .724 .837 r
.65292 .43738 .65702 .44373 .66522 .43865 .66114 .43224 Metetra
.744 .723 .833 r
.66114 .43224 .66522 .43865 .67343 .43337 .66936 .42688 Metetra
.749 .723 .828 r
.66936 .42688 .67343 .43337 .68163 .42786 .67757 .42129 Metetra
.755 .723 .823 r
.67757 .42129 .68163 .42786 .68983 .42208 .68578 .41542 Metetra
.762 .723 .817 r
.68578 .41542 .68983 .42208 .69802 .41599 .69399 .40922 Metetra
.77 .723 .81 r
.69399 .40922 .69802 .41599 .7062 .40953 .70218 .40265 Metetra
.778 .723 .801 r
.70218 .40265 .7062 .40953 .71436 .40263 .71035 .39562 Metetra
.788 .723 .792 r
.71035 .39562 .71436 .40263 .72249 .39521 .71849 .38803 Metetra
.798 .723 .781 r
.71849 .38803 .72249 .39521 .73058 .38712 .72658 .37976 Metetra
.811 .722 .767 r
.72658 .37976 .73058 .38712 .73861 .3782 .73461 .37059 Metetra
.825 .721 .75 r
.73461 .37059 .73861 .3782 .74655 .36816 .74255 .36024 Metetra
.842 .719 .728 r
.74255 .36024 .74655 .36816 .75436 .35656 .75035 .34819 Metetra
.863 .717 .698 r
.75035 .34819 .75436 .35656 .76198 .34257 .75793 .33344 Metetra
.891 .712 .652 r
.75793 .33344 .76198 .34257 .76921 .32419 .76506 .31337 Metetra
.941 .702 .549 r
.76506 .31337 .76921 .32419 .77514 .29022 .77038 .27125 Metetra
.605 .476 .678 r
.77038 .27125 .77514 .29022 .78236 .27364 .77872 .26843 Metetra
.664 .741 .908 r
.77872 .26843 .78236 .27364 .79071 .27082 .78709 .26559 Metetra
.664 .741 .908 r
.78709 .26559 .79071 .27082 .79909 .26799 .79549 .26275 Metetra
.664 .741 .908 r
.79549 .26275 .79909 .26799 .80749 .26515 .80391 .25989 Metetra
.664 .741 .908 r
.80391 .25989 .80749 .26515 .81592 .26231 .81235 .25703 Metetra
.664 .741 .908 r
.81235 .25703 .81592 .26231 .82437 .25945 .82082 .25416 Metetra
.664 .741 .908 r
.82082 .25416 .82437 .25945 .83284 .25659 .82931 .25129 Metetra
.664 .741 .908 r
.82931 .25129 .83284 .25659 .84135 .25372 .83783 .2484 Metetra
.664 .741 .908 r
.83783 .2484 .84135 .25372 .84987 .25084 .84637 .24551 Metetra
.669 .731 .897 r
.22145 .61277 .22628 .61755 .23352 .61499 .22869 .61019 Metetra
.669 .731 .896 r
.22869 .61019 .23352 .61499 .24078 .61241 .23596 .60759 Metetra
.67 .731 .896 r
.23596 .60759 .24078 .61241 .24805 .60982 .24325 .60498 Metetra
.67 .731 .896 r
.24325 .60498 .24805 .60982 .25535 .60721 .25056 .60236 Metetra
.67 .731 .895 r
.25056 .60236 .25535 .60721 .26266 .60459 .25788 .59972 Metetra
.671 .731 .895 r
.25788 .59972 .26266 .60459 .27 .60196 .26523 .59707 Metetra
.671 .731 .895 r
.26523 .59707 .27 .60196 .27735 .59931 .2726 .5944 Metetra
.672 .731 .894 r
.2726 .5944 .27735 .59931 .28473 .59664 .27998 .59172 Metetra
.672 .73 .894 r
.27998 .59172 .28473 .59664 .29212 .59396 .28739 .58902 Metetra
.672 .73 .893 r
.28739 .58902 .29212 .59396 .29953 .59127 .29481 .5863 Metetra
.673 .73 .893 r
.29481 .5863 .29953 .59127 .30696 .58855 .30225 .58357 Metetra
.673 .73 .893 r
.30225 .58357 .30696 .58855 .31441 .58582 .30972 .58082 Metetra
.674 .73 .892 r
.30972 .58082 .31441 .58582 .32189 .58307 .3172 .57805 Metetra
.674 .73 .892 r
.3172 .57805 .32189 .58307 .32938 .58031 .3247 .57526 Metetra
.675 .73 .891 r
.3247 .57526 .32938 .58031 .33689 .57752 .33223 .57246 Metetra
.675 .729 .891 r
.33223 .57246 .33689 .57752 .34442 .57472 .33977 .56964 Metetra
.676 .729 .89 r
.33977 .56964 .34442 .57472 .35197 .5719 .34733 .56679 Metetra
.676 .729 .89 r
.34733 .56679 .35197 .5719 .35954 .56905 .35492 .56393 Metetra
.677 .729 .889 r
.35492 .56393 .35954 .56905 .36713 .56619 .36252 .56104 Metetra
.677 .729 .889 r
.36252 .56104 .36713 .56619 .37474 .5633 .37014 .55814 Metetra
.678 .729 .888 r
.37014 .55814 .37474 .5633 .38237 .5604 .37778 .55521 Metetra
.679 .729 .888 r
.37778 .55521 .38237 .5604 .39002 .55747 .38544 .55226 Metetra
.679 .728 .887 r
.38544 .55226 .39002 .55747 .39769 .55452 .39313 .54928 Metetra
.68 .728 .887 r
.39313 .54928 .39769 .55452 .40537 .55154 .40083 .54628 Metetra
.681 .728 .886 r
.40083 .54628 .40537 .55154 .41308 .54854 .40855 .54326 Metetra
.681 .728 .885 r
.40855 .54326 .41308 .54854 .42081 .54551 .41629 .54021 Metetra
.682 .728 .885 r
.41629 .54021 .42081 .54551 .42856 .54245 .42405 .53713 Metetra
.683 .728 .884 r
.42405 .53713 .42856 .54245 .43633 .53937 .43183 .53402 Metetra
.684 .727 .883 r
.43183 .53402 .43633 .53937 .44411 .53626 .43963 .53088 Metetra
.685 .727 .882 r
.43963 .53088 .44411 .53626 .45192 .53312 .44746 .52771 Metetra
.686 .727 .882 r
.44746 .52771 .45192 .53312 .45975 .52994 .4553 .52451 Metetra
.687 .727 .881 r
.4553 .52451 .45975 .52994 .4676 .52673 .46316 .52128 Metetra
.688 .727 .88 r
.46316 .52128 .4676 .52673 .47546 .52349 .47103 .51801 Metetra
.689 .727 .879 r
.47103 .51801 .47546 .52349 .48335 .52021 .47893 .5147 Metetra
.69 .727 .878 r
.47893 .5147 .48335 .52021 .49125 .5169 .48685 .51136 Metetra
.691 .726 .877 r
.48685 .51136 .49125 .5169 .49917 .51354 .49479 .50797 Metetra
.692 .726 .876 r
.49479 .50797 .49917 .51354 .50712 .51014 .50274 .50454 Metetra
.694 .726 .875 r
.50274 .50454 .50712 .51014 .51508 .5067 .51072 .50107 Metetra
.695 .726 .874 r
.51072 .50107 .51508 .5067 .52306 .50321 .51871 .49755 Metetra
.697 .726 .873 r
.51871 .49755 .52306 .50321 .53105 .49966 .52672 .49398 Metetra
.698 .726 .871 r
.52672 .49398 .53105 .49966 .53907 .49607 .53475 .49035 Metetra
.7 .726 .87 r
.53475 .49035 .53907 .49607 .5471 .49242 .5428 .48667 Metetra
.702 .725 .869 r
.5428 .48667 .5471 .49242 .55515 .48871 .55087 .48292 Metetra
.703 .725 .867 r
.55087 .48292 .55515 .48871 .56322 .48494 .55895 .47911 Metetra
.705 .725 .865 r
.55895 .47911 .56322 .48494 .57131 .4811 .56705 .47523 Metetra
.708 .725 .864 r
.56705 .47523 .57131 .4811 .57941 .47718 .57516 .47128 Metetra
.71 .725 .862 r
.57516 .47128 .57941 .47718 .58752 .47319 .58329 .46724 Metetra
.712 .725 .86 r
.58329 .46724 .58752 .47319 .59566 .46911 .59144 .46312 Metetra
.715 .725 .858 r
.59144 .46312 .59566 .46911 .6038 .46494 .5996 .4589 Metetra
.718 .725 .855 r
.5996 .4589 .6038 .46494 .61196 .46066 .60777 .45458 Metetra
.721 .725 .853 r
.60777 .45458 .61196 .46066 .62013 .45628 .61596 .45014 Metetra
.724 .724 .85 r
.61596 .45014 .62013 .45628 .62832 .45177 .62416 .44558 Metetra
.728 .724 .847 r
.62416 .44558 .62832 .45177 .63651 .44713 .63237 .44088 Metetra
.732 .724 .844 r
.63237 .44088 .63651 .44713 .64471 .44234 .64058 .43603 Metetra
.736 .724 .84 r
.64058 .43603 .64471 .44234 .65292 .43738 .64881 .43101 Metetra
.74 .724 .837 r
.64881 .43101 .65292 .43738 .66114 .43224 .65703 .4258 Metetra
.746 .724 .832 r
.65703 .4258 .66114 .43224 .66936 .42688 .66527 .42037 Metetra
.751 .724 .827 r
.66527 .42037 .66936 .42688 .67757 .42129 .67349 .41469 Metetra
.757 .724 .822 r
.67349 .41469 .67757 .42129 .68578 .41542 .68172 .40872 Metetra
.764 .724 .815 r
.68172 .40872 .68578 .41542 .69399 .40922 .68994 .40242 Metetra
.772 .724 .808 r
.68994 .40242 .69399 .40922 .70218 .40265 .69814 .39573 Metetra
.781 .724 .8 r
.69814 .39573 .70218 .40265 .71035 .39562 .70632 .38856 Metetra
.79 .724 .79 r
.70632 .38856 .71035 .39562 .71849 .38803 .71446 .38082 Metetra
.802 .723 .778 r
.71446 .38082 .71849 .38803 .72658 .37976 .72256 .37234 Metetra
.814 .723 .764 r
.72256 .37234 .72658 .37976 .73461 .37059 .73059 .36293 Metetra
.829 .721 .746 r
.73059 .36293 .73461 .37059 .74255 .36024 .73853 .35223 Metetra
.847 .72 .722 r
.73853 .35223 .74255 .36024 .75035 .34819 .74632 .33968 Metetra
.869 .716 .69 r
.74632 .33968 .75035 .34819 .75793 .33344 .75386 .32406 Metetra
.9 .71 .636 r
.75386 .32406 .75793 .33344 .76506 .31337 .76084 .30169 Metetra
.922 .693 .573 r
.76084 .30169 .76506 .31337 .77038 .27125 .7667 .26603 Metetra
.664 .741 .908 r
.7667 .26603 .77038 .27125 .77872 .26843 .77506 .26318 Metetra
.664 .741 .908 r
.77506 .26318 .77872 .26843 .78709 .26559 .78345 .26033 Metetra
.664 .741 .908 r
.78345 .26033 .78709 .26559 .79549 .26275 .79186 .25747 Metetra
.664 .741 .908 r
.79186 .25747 .79549 .26275 .80391 .25989 .8003 .25461 Metetra
.664 .741 .908 r
.8003 .25461 .80391 .25989 .81235 .25703 .80876 .25173 Metetra
.664 .741 .908 r
.80876 .25173 .81235 .25703 .82082 .25416 .81725 .24885 Metetra
.664 .741 .908 r
.81725 .24885 .82082 .25416 .82931 .25129 .82576 .24595 Metetra
.664 .741 .908 r
.82576 .24595 .82931 .25129 .83783 .2484 .8343 .24305 Metetra
.664 .741 .908 r
.8343 .24305 .83783 .2484 .84637 .24551 .84286 .24014 Metetra
.669 .732 .897 r
.21658 .60797 .22145 .61277 .22869 .61019 .22384 .60537 Metetra
.67 .732 .896 r
.22384 .60537 .22869 .61019 .23596 .60759 .23112 .60276 Metetra
.67 .732 .896 r
.23112 .60276 .23596 .60759 .24325 .60498 .23842 .60013 Metetra
.67 .731 .896 r
.23842 .60013 .24325 .60498 .25056 .60236 .24574 .59749 Metetra
.671 .731 .895 r
.24574 .59749 .25056 .60236 .25788 .59972 .25308 .59484 Metetra
.671 .731 .895 r
.25308 .59484 .25788 .59972 .26523 .59707 .26044 .59217 Metetra
.671 .731 .895 r
.26044 .59217 .26523 .59707 .2726 .5944 .26782 .58948 Metetra
.672 .731 .894 r
.26782 .58948 .2726 .5944 .27998 .59172 .27521 .58678 Metetra
.672 .731 .894 r
.27521 .58678 .27998 .59172 .28739 .58902 .28263 .58406 Metetra
.673 .731 .894 r
.28263 .58406 .28739 .58902 .29481 .5863 .29007 .58132 Metetra
.673 .731 .893 r
.29007 .58132 .29481 .5863 .30225 .58357 .29752 .57857 Metetra
.674 .73 .893 r
.29752 .57857 .30225 .58357 .30972 .58082 .305 .5758 Metetra
.674 .73 .892 r
.305 .5758 .30972 .58082 .3172 .57805 .31249 .57301 Metetra
.674 .73 .892 r
.31249 .57301 .3172 .57805 .3247 .57526 .32001 .57021 Metetra
.675 .73 .891 r
.32001 .57021 .3247 .57526 .33223 .57246 .32754 .56738 Metetra
.675 .73 .891 r
.32754 .56738 .33223 .57246 .33977 .56964 .3351 .56454 Metetra
.676 .73 .89 r
.3351 .56454 .33977 .56964 .34733 .56679 .34267 .56167 Metetra
.677 .73 .89 r
.34267 .56167 .34733 .56679 .35492 .56393 .35027 .55879 Metetra
.677 .729 .889 r
.35027 .55879 .35492 .56393 .36252 .56104 .35788 .55588 Metetra
.678 .729 .889 r
.35788 .55588 .36252 .56104 .37014 .55814 .36552 .55296 Metetra
.678 .729 .888 r
.36552 .55296 .37014 .55814 .37778 .55521 .37317 .55 Metetra
.679 .729 .888 r
.37317 .55 .37778 .55521 .38544 .55226 .38085 .54703 Metetra
.68 .729 .887 r
.38085 .54703 .38544 .55226 .39313 .54928 .38854 .54403 Metetra
.68 .729 .887 r
.38854 .54403 .39313 .54928 .40083 .54628 .39626 .54101 Metetra
.681 .729 .886 r
.39626 .54101 .40083 .54628 .40855 .54326 .40399 .53796 Metetra
.682 .728 .885 r
.40399 .53796 .40855 .54326 .41629 .54021 .41175 .53489 Metetra
.683 .728 .885 r
.41175 .53489 .41629 .54021 .42405 .53713 .41952 .53178 Metetra
.683 .728 .884 r
.41952 .53178 .42405 .53713 .43183 .53402 .42732 .52865 Metetra
.684 .728 .883 r
.42732 .52865 .43183 .53402 .43963 .53088 .43513 .52549 Metetra
.685 .728 .882 r
.43513 .52549 .43963 .53088 .44746 .52771 .44297 .5223 Metetra
.686 .728 .882 r
.44297 .5223 .44746 .52771 .4553 .52451 .45082 .51907 Metetra
.687 .728 .881 r
.45082 .51907 .4553 .52451 .46316 .52128 .45869 .51581 Metetra
.688 .727 .88 r
.45869 .51581 .46316 .52128 .47103 .51801 .46659 .51251 Metetra
.689 .727 .879 r
.46659 .51251 .47103 .51801 .47893 .5147 .4745 .50918 Metetra
.69 .727 .878 r
.4745 .50918 .47893 .5147 .48685 .51136 .48243 .5058 Metetra
.692 .727 .877 r
.48243 .5058 .48685 .51136 .49479 .50797 .49038 .50239 Metetra
.693 .727 .876 r
.49038 .50239 .49479 .50797 .50274 .50454 .49835 .49893 Metetra
.694 .727 .875 r
.49835 .49893 .50274 .50454 .51072 .50107 .50634 .49543 Metetra
.696 .726 .874 r
.50634 .49543 .51072 .50107 .51871 .49755 .51435 .49187 Metetra
.697 .726 .873 r
.51435 .49187 .51871 .49755 .52672 .49398 .52238 .48827 Metetra
.699 .726 .871 r
.52238 .48827 .52672 .49398 .53475 .49035 .53042 .48461 Metetra
.701 .726 .87 r
.53042 .48461 .53475 .49035 .5428 .48667 .53848 .48089 Metetra
.702 .726 .868 r
.53848 .48089 .5428 .48667 .55087 .48292 .54656 .47711 Metetra
.704 .726 .867 r
.54656 .47711 .55087 .48292 .55895 .47911 .55466 .47326 Metetra
.706 .726 .865 r
.55466 .47326 .55895 .47911 .56705 .47523 .56277 .46934 Metetra
.708 .726 .864 r
.56277 .46934 .56705 .47523 .57516 .47128 .5709 .46535 Metetra
.711 .725 .862 r
.5709 .46535 .57516 .47128 .58329 .46724 .57905 .46127 Metetra
.713 .725 .86 r
.57905 .46127 .58329 .46724 .59144 .46312 .58721 .4571 Metetra
.716 .725 .857 r
.58721 .4571 .59144 .46312 .5996 .4589 .59538 .45284 Metetra
.719 .725 .855 r
.59538 .45284 .5996 .4589 .60777 .45458 .60357 .44847 Metetra
.722 .725 .853 r
.60357 .44847 .60777 .45458 .61596 .45014 .61177 .44398 Metetra
.725 .725 .85 r
.61177 .44398 .61596 .45014 .62416 .44558 .61998 .43937 Metetra
.729 .725 .847 r
.61998 .43937 .62416 .44558 .63237 .44088 .6282 .43462 Metetra
.733 .725 .843 r
.6282 .43462 .63237 .44088 .64058 .43603 .63643 .4297 Metetra
.737 .725 .84 r
.63643 .4297 .64058 .43603 .64881 .43101 .64467 .42462 Metetra
.742 .725 .836 r
.64467 .42462 .64881 .43101 .65703 .4258 .65291 .41933 Metetra
.747 .725 .831 r
.65291 .41933 .65703 .4258 .66527 .42037 .66116 .41383 Metetra
.753 .725 .826 r
.66116 .41383 .66527 .42037 .67349 .41469 .6694 .40806 Metetra
.759 .725 .821 r
.6694 .40806 .67349 .41469 .68172 .40872 .67764 .402 Metetra
.766 .725 .814 r
.67764 .402 .68172 .40872 .68994 .40242 .68587 .3956 Metetra
.774 .725 .807 r
.68587 .3956 .68994 .40242 .69814 .39573 .69408 .38878 Metetra
.783 .725 .798 r
.69408 .38878 .69814 .39573 .70632 .38856 .70227 .38147 Metetra
.793 .724 .788 r
.70227 .38147 .70632 .38856 .71446 .38082 .71042 .37356 Metetra
.805 .724 .775 r
.71042 .37356 .71446 .38082 .72256 .37234 .71853 .36487 Metetra
.818 .723 .76 r
.71853 .36487 .72256 .37234 .73059 .36293 .72656 .35519 Metetra
.833 .722 .741 r
.72656 .35519 .73059 .36293 .73853 .35223 .7345 .34413 Metetra
.852 .719 .716 r
.7345 .34413 .73853 .35223 .74632 .33968 .74227 .33101 Metetra
.875 .716 .68 r
.74227 .33101 .74632 .33968 .75386 .32406 .74975 .31436 Metetra
.912 .709 .616 r
.74975 .31436 .75386 .32406 .76084 .30169 .75651 .28854 Metetra
.885 .67 .606 r
.75651 .28854 .76084 .30169 .7667 .26603 .76301 .26077 Metetra
.664 .741 .908 r
.76301 .26077 .7667 .26603 .77506 .26318 .77139 .25791 Metetra
.664 .741 .908 r
.77139 .25791 .77506 .26318 .78345 .26033 .77979 .25505 Metetra
.664 .741 .908 r
.77979 .25505 .78345 .26033 .79186 .25747 .78822 .25217 Metetra
.664 .741 .908 r
.78822 .25217 .79186 .25747 .8003 .25461 .79668 .24929 Metetra
.664 .741 .908 r
.79668 .24929 .8003 .25461 .80876 .25173 .80516 .2464 Metetra
.664 .741 .908 r
.80516 .2464 .80876 .25173 .81725 .24885 .81366 .2435 Metetra
.664 .741 .908 r
.81366 .2435 .81725 .24885 .82576 .24595 .82219 .24059 Metetra
.664 .741 .908 r
.82219 .24059 .82576 .24595 .8343 .24305 .83074 .23767 Metetra
.664 .741 .908 r
.83074 .23767 .8343 .24305 .84286 .24014 .83932 .23475 Metetra
.67 .732 .897 r
.2117 .60316 .21658 .60797 .22384 .60537 .21897 .60054 Metetra
.67 .732 .897 r
.21897 .60054 .22384 .60537 .23112 .60276 .22626 .59791 Metetra
.67 .732 .896 r
.22626 .59791 .23112 .60276 .23842 .60013 .23357 .59527 Metetra
.671 .732 .896 r
.23357 .59527 .23842 .60013 .24574 .59749 .2409 .59261 Metetra
.671 .732 .896 r
.2409 .59261 .24574 .59749 .25308 .59484 .24825 .58993 Metetra
.671 .732 .895 r
.24825 .58993 .25308 .59484 .26044 .59217 .25562 .58724 Metetra
.672 .731 .895 r
.25562 .58724 .26044 .59217 .26782 .58948 .26301 .58454 Metetra
.672 .731 .894 r
.26301 .58454 .26782 .58948 .27521 .58678 .27042 .58182 Metetra
.673 .731 .894 r
.27042 .58182 .27521 .58678 .28263 .58406 .27785 .57908 Metetra
.673 .731 .894 r
.27785 .57908 .28263 .58406 .29007 .58132 .2853 .57633 Metetra
.673 .731 .893 r
.2853 .57633 .29007 .58132 .29752 .57857 .29277 .57355 Metetra
.674 .731 .893 r
.29277 .57355 .29752 .57857 .305 .5758 .30025 .57077 Metetra
.674 .731 .892 r
.30025 .57077 .305 .5758 .31249 .57301 .30776 .56796 Metetra
.675 .731 .892 r
.30776 .56796 .31249 .57301 .32001 .57021 .31529 .56513 Metetra
.675 .73 .891 r
.31529 .56513 .32001 .57021 .32754 .56738 .32284 .56229 Metetra
.676 .73 .891 r
.32284 .56229 .32754 .56738 .3351 .56454 .33041 .55942 Metetra
.676 .73 .891 r
.33041 .55942 .3351 .56454 .34267 .56167 .33799 .55654 Metetra
.677 .73 .89 r
.33799 .55654 .34267 .56167 .35027 .55879 .3456 .55363 Metetra
.678 .73 .89 r
.3456 .55363 .35027 .55879 .35788 .55588 .35323 .5507 Metetra
.678 .73 .889 r
.35323 .5507 .35788 .55588 .36552 .55296 .36088 .54775 Metetra
.679 .73 .888 r
.36088 .54775 .36552 .55296 .37317 .55 .36854 .54478 Metetra
.679 .729 .888 r
.36854 .54478 .37317 .55 .38085 .54703 .37623 .54179 Metetra
.68 .729 .887 r
.37623 .54179 .38085 .54703 .38854 .54403 .38394 .53877 Metetra
.681 .729 .887 r
.38394 .53877 .38854 .54403 .39626 .54101 .39167 .53572 Metetra
.682 .729 .886 r
.39167 .53572 .39626 .54101 .40399 .53796 .39942 .53265 Metetra
.682 .729 .885 r
.39942 .53265 .40399 .53796 .41175 .53489 .40719 .52955 Metetra
.683 .729 .885 r
.40719 .52955 .41175 .53489 .41952 .53178 .41497 .52642 Metetra
.684 .729 .884 r
.41497 .52642 .41952 .53178 .42732 .52865 .42278 .52327 Metetra
.685 .728 .883 r
.42278 .52327 .42732 .52865 .43513 .52549 .43061 .52008 Metetra
.686 .728 .882 r
.43061 .52008 .43513 .52549 .44297 .5223 .43846 .51686 Metetra
.687 .728 .882 r
.43846 .51686 .44297 .5223 .45082 .51907 .44632 .51361 Metetra
.688 .728 .881 r
.44632 .51361 .45082 .51907 .45869 .51581 .45421 .51032 Metetra
.689 .728 .88 r
.45421 .51032 .45869 .51581 .46659 .51251 .46212 .50699 Metetra
.69 .728 .879 r
.46212 .50699 .46659 .51251 .4745 .50918 .47005 .50363 Metetra
.691 .728 .878 r
.47005 .50363 .4745 .50918 .48243 .5058 .47799 .50023 Metetra
.692 .727 .877 r
.47799 .50023 .48243 .5058 .49038 .50239 .48596 .49679 Metetra
.694 .727 .876 r
.48596 .49679 .49038 .50239 .49835 .49893 .49394 .4933 Metetra
.695 .727 .875 r
.49394 .4933 .49835 .49893 .50634 .49543 .50194 .48976 Metetra
.696 .727 .874 r
.50194 .48976 .50634 .49543 .51435 .49187 .50996 .48618 Metetra
.698 .727 .873 r
.50996 .48618 .51435 .49187 .52238 .48827 .518 .48254 Metetra
.7 .727 .871 r
.518 .48254 .52238 .48827 .53042 .48461 .52606 .47885 Metetra
.701 .727 .87 r
.52606 .47885 .53042 .48461 .53848 .48089 .53414 .47509 Metetra
.703 .727 .868 r
.53414 .47509 .53848 .48089 .54656 .47711 .54223 .47128 Metetra
.705 .726 .867 r
.54223 .47128 .54656 .47711 .55466 .47326 .55034 .46739 Metetra
.707 .726 .865 r
.55034 .46739 .55466 .47326 .56277 .46934 .55847 .46344 Metetra
.709 .726 .863 r
.55847 .46344 .56277 .46934 .5709 .46535 .56662 .4594 Metetra
.712 .726 .861 r
.56662 .4594 .5709 .46535 .57905 .46127 .57478 .45528 Metetra
.714 .726 .859 r
.57478 .45528 .57905 .46127 .58721 .4571 .58295 .45107 Metetra
.717 .726 .857 r
.58295 .45107 .58721 .4571 .59538 .45284 .59114 .44676 Metetra
.72 .726 .855 r
.59114 .44676 .59538 .45284 .60357 .44847 .59934 .44234 Metetra
.723 .726 .852 r
.59934 .44234 .60357 .44847 .61177 .44398 .60756 .43781 Metetra
.727 .726 .849 r
.60756 .43781 .61177 .44398 .61998 .43937 .61578 .43314 Metetra
.73 .726 .846 r
.61578 .43314 .61998 .43937 .6282 .43462 .62402 .42833 Metetra
.734 .726 .843 r
.62402 .42833 .6282 .43462 .63643 .4297 .63227 .42335 Metetra
.739 .726 .839 r
.63227 .42335 .63643 .4297 .64467 .42462 .64052 .4182 Metetra
.744 .726 .835 r
.64052 .4182 .64467 .42462 .65291 .41933 .64877 .41284 Metetra
.749 .726 .83 r
.64877 .41284 .65291 .41933 .66116 .41383 .65703 .40726 Metetra
.755 .726 .825 r
.65703 .40726 .66116 .41383 .6694 .40806 .66529 .40141 Metetra
.761 .726 .819 r
.66529 .40141 .6694 .40806 .67764 .402 .67354 .39525 Metetra
.768 .726 .813 r
.67354 .39525 .67764 .402 .68587 .3956 .68178 .38874 Metetra
.777 .725 .805 r
.68178 .38874 .68587 .3956 .69408 .38878 .69 .3818 Metetra
.786 .725 .796 r
.69 .3818 .69408 .38878 .70227 .38147 .6982 .37434 Metetra
.796 .725 .785 r
.6982 .37434 .70227 .38147 .71042 .37356 .70636 .36625 Metetra
.808 .724 .773 r
.70636 .36625 .71042 .37356 .71853 .36487 .71448 .35735 Metetra
.821 .723 .757 r
.71448 .35735 .71853 .36487 .72656 .35519 .72251 .34738 Metetra
.838 .722 .737 r
.72251 .34738 .72656 .35519 .7345 .34413 .73044 .33592 Metetra
.857 .719 .71 r
.73044 .33592 .7345 .34413 .74227 .33101 .73819 .32217 Metetra
.882 .715 .67 r
.73819 .32217 .74227 .33101 .74975 .31436 .74561 .30425 Metetra
.928 .707 .582 r
.74561 .30425 .74975 .31436 .75651 .28854 .75189 .27151 Metetra
.778 .591 .648 r
.75189 .27151 .75651 .28854 .76301 .26077 .75929 .25549 Metetra
.664 .741 .908 r
.75929 .25549 .76301 .26077 .77139 .25791 .76769 .25262 Metetra
.664 .741 .908 r
.76769 .25262 .77139 .25791 .77979 .25505 .77611 .24973 Metetra
.664 .741 .908 r
.77611 .24973 .77979 .25505 .78822 .25217 .78456 .24684 Metetra
.664 .741 .908 r
.78456 .24684 .78822 .25217 .79668 .24929 .79303 .24394 Metetra
.664 .741 .908 r
.79303 .24394 .79668 .24929 .80516 .2464 .80153 .24104 Metetra
.664 .741 .908 r
.80153 .24104 .80516 .2464 .81366 .2435 .81005 .23812 Metetra
.664 .741 .908 r
.81005 .23812 .81366 .2435 .82219 .24059 .8186 .2352 Metetra
.664 .741 .908 r
.8186 .2352 .82219 .24059 .83074 .23767 .82717 .23226 Metetra
.664 .741 .908 r
.82717 .23226 .83074 .23767 .83932 .23475 .83577 .22932 Metetra
.67 .733 .897 r
.20679 .59833 .2117 .60316 .21897 .60054 .21407 .59569 Metetra
.67 .732 .897 r
.21407 .59569 .21897 .60054 .22626 .59791 .22138 .59304 Metetra
.67 .732 .896 r
.22138 .59304 .22626 .59791 .23357 .59527 .2287 .59038 Metetra
.671 .732 .896 r
.2287 .59038 .23357 .59527 .2409 .59261 .23604 .58771 Metetra
.671 .732 .896 r
.23604 .58771 .2409 .59261 .24825 .58993 .2434 .58501 Metetra
.672 .732 .895 r
.2434 .58501 .24825 .58993 .25562 .58724 .25078 .58231 Metetra
.672 .732 .895 r
.25078 .58231 .25562 .58724 .26301 .58454 .25818 .57958 Metetra
.672 .732 .895 r
.25818 .57958 .26301 .58454 .27042 .58182 .2656 .57684 Metetra
.673 .732 .894 r
.2656 .57684 .27042 .58182 .27785 .57908 .27305 .57409 Metetra
.673 .731 .894 r
.27305 .57409 .27785 .57908 .2853 .57633 .28051 .57131 Metetra
.674 .731 .893 r
.28051 .57131 .2853 .57633 .29277 .57355 .28799 .56852 Metetra
.674 .731 .893 r
.28799 .56852 .29277 .57355 .30025 .57077 .29549 .56571 Metetra
.675 .731 .892 r
.29549 .56571 .30025 .57077 .30776 .56796 .30301 .56289 Metetra
.675 .731 .892 r
.30301 .56289 .30776 .56796 .31529 .56513 .31055 .56004 Metetra
.676 .731 .892 r
.31055 .56004 .31529 .56513 .32284 .56229 .31811 .55717 Metetra
.676 .731 .891 r
.31811 .55717 .32284 .56229 .33041 .55942 .32569 .55429 Metetra
.677 .731 .891 r
.32569 .55429 .33041 .55942 .33799 .55654 .33329 .55138 Metetra
.677 .73 .89 r
.33329 .55138 .33799 .55654 .3456 .55363 .34091 .54846 Metetra
.678 .73 .89 r
.34091 .54846 .3456 .55363 .35323 .5507 .34855 .54551 Metetra
.679 .73 .889 r
.34855 .54551 .35323 .5507 .36088 .54775 .35621 .54254 Metetra
.679 .73 .889 r
.35621 .54254 .36088 .54775 .36854 .54478 .36389 .53954 Metetra
.68 .73 .888 r
.36389 .53954 .36854 .54478 .37623 .54179 .37159 .53652 Metetra
.681 .73 .887 r
.37159 .53652 .37623 .54179 .38394 .53877 .37931 .53348 Metetra
.681 .73 .887 r
.37931 .53348 .38394 .53877 .39167 .53572 .38706 .53041 Metetra
.682 .729 .886 r
.38706 .53041 .39167 .53572 .39942 .53265 .39482 .52732 Metetra
.683 .729 .885 r
.39482 .52732 .39942 .53265 .40719 .52955 .4026 .52419 Metetra
.684 .729 .885 r
.4026 .52419 .40719 .52955 .41497 .52642 .4104 .52104 Metetra
.684 .729 .884 r
.4104 .52104 .41497 .52642 .42278 .52327 .41822 .51786 Metetra
.685 .729 .883 r
.41822 .51786 .42278 .52327 .43061 .52008 .42606 .51465 Metetra
.686 .729 .883 r
.42606 .51465 .43061 .52008 .43846 .51686 .43393 .5114 Metetra
.687 .729 .882 r
.43393 .5114 .43846 .51686 .44632 .51361 .44181 .50812 Metetra
.688 .728 .881 r
.44181 .50812 .44632 .51361 .45421 .51032 .44971 .50481 Metetra
.689 .728 .88 r
.44971 .50481 .45421 .51032 .46212 .50699 .45763 .50146 Metetra
.69 .728 .879 r
.45763 .50146 .46212 .50699 .47005 .50363 .46557 .49807 Metetra
.692 .728 .878 r
.46557 .49807 .47005 .50363 .47799 .50023 .47353 .49464 Metetra
.693 .728 .877 r
.47353 .49464 .47799 .50023 .48596 .49679 .48151 .49116 Metetra
.694 .728 .876 r
.48151 .49116 .48596 .49679 .49394 .4933 .48951 .48765 Metetra
.696 .728 .875 r
.48951 .48765 .49394 .4933 .50194 .48976 .49752 .48408 Metetra
.697 .728 .874 r
.49752 .48408 .50194 .48976 .50996 .48618 .50556 .48046 Metetra
.699 .727 .872 r
.50556 .48046 .50996 .48618 .518 .48254 .51361 .47679 Metetra
.7 .727 .871 r
.51361 .47679 .518 .48254 .52606 .47885 .52169 .47307 Metetra
.702 .727 .87 r
.52169 .47307 .52606 .47885 .53414 .47509 .52978 .46928 Metetra
.704 .727 .868 r
.52978 .46928 .53414 .47509 .54223 .47128 .53789 .46543 Metetra
.706 .727 .867 r
.53789 .46543 .54223 .47128 .55034 .46739 .54601 .4615 Metetra
.708 .727 .865 r
.54601 .4615 .55034 .46739 .55847 .46344 .55415 .45751 Metetra
.71 .727 .863 r
.55415 .45751 .55847 .46344 .56662 .4594 .56231 .45343 Metetra
.713 .727 .861 r
.56231 .45343 .56662 .4594 .57478 .45528 .57049 .44927 Metetra
.715 .727 .859 r
.57049 .44927 .57478 .45528 .58295 .45107 .57868 .44502 Metetra
.718 .727 .857 r
.57868 .44502 .58295 .45107 .59114 .44676 .58688 .44066 Metetra
.721 .726 .854 r
.58688 .44066 .59114 .44676 .59934 .44234 .5951 .43619 Metetra
.724 .726 .852 r
.5951 .43619 .59934 .44234 .60756 .43781 .60333 .43161 Metetra
.728 .726 .849 r
.60333 .43161 .60756 .43781 .61578 .43314 .61157 .42688 Metetra
.732 .726 .846 r
.61157 .42688 .61578 .43314 .62402 .42833 .61982 .42201 Metetra
.736 .726 .842 r
.61982 .42201 .62402 .42833 .63227 .42335 .62808 .41698 Metetra
.74 .726 .839 r
.62808 .41698 .63227 .42335 .64052 .4182 .63634 .41176 Metetra
.745 .726 .834 r
.63634 .41176 .64052 .4182 .64877 .41284 .64461 .40633 Metetra
.751 .726 .83 r
.64461 .40633 .64877 .41284 .65703 .40726 .65288 .40066 Metetra
.757 .726 .824 r
.65288 .40066 .65703 .40726 .66529 .40141 .66115 .39472 Metetra
.763 .726 .818 r
.66115 .39472 .66529 .40141 .67354 .39525 .66942 .38847 Metetra
.771 .726 .811 r
.66942 .38847 .67354 .39525 .68178 .38874 .67767 .38184 Metetra
.779 .726 .803 r
.67767 .38184 .68178 .38874 .69 .3818 .68591 .37477 Metetra
.788 .726 .794 r
.68591 .37477 .69 .3818 .6982 .37434 .69412 .36717 Metetra
.799 .725 .783 r
.69412 .36717 .6982 .37434 .70636 .36625 .70229 .35889 Metetra
.811 .725 .77 r
.70229 .35889 .70636 .36625 .71448 .35735 .71041 .34976 Metetra
.825 .724 .753 r
.71041 .34976 .71448 .35735 .72251 .34738 .71844 .33949 Metetra
.842 .722 .732 r
.71844 .33949 .72251 .34738 .73044 .33592 .72636 .32759 Metetra
.862 .719 .702 r
.72636 .32759 .73044 .33592 .73819 .32217 .73409 .31313 Metetra
.89 .714 .657 r
.73409 .31313 .73819 .32217 .74561 .30425 .74142 .29359 Metetra
.939 .704 .554 r
.74142 .29359 .74561 .30425 .75189 .27151 .74717 .25306 Metetra
.605 .479 .682 r
.74717 .25306 .75189 .27151 .75929 .25549 .75556 .25018 Metetra
.664 .741 .908 r
.75556 .25018 .75929 .25549 .76769 .25262 .76398 .24729 Metetra
.664 .741 .908 r
.76398 .24729 .76769 .25262 .77611 .24973 .77242 .24439 Metetra
.664 .741 .908 r
.77242 .24439 .77611 .24973 .78456 .24684 .78088 .24148 Metetra
.664 .741 .908 r
.78088 .24148 .78456 .24684 .79303 .24394 .78937 .23857 Metetra
.664 .741 .908 r
.78937 .23857 .79303 .24394 .80153 .24104 .79788 .23565 Metetra
.664 .741 .908 r
.79788 .23565 .80153 .24104 .81005 .23812 .80642 .23271 Metetra
.664 .741 .908 r
.80642 .23271 .81005 .23812 .8186 .2352 .81499 .22977 Metetra
.664 .741 .908 r
.81499 .22977 .8186 .2352 .82717 .23226 .82358 .22682 Metetra
.664 .741 .908 r
.82358 .22682 .82717 .23226 .83577 .22932 .8322 .22387 Metetra
.67 .733 .897 r
.20186 .59348 .20679 .59833 .21407 .59569 .20915 .59083 Metetra
.67 .733 .897 r
.20915 .59083 .21407 .59569 .22138 .59304 .21646 .58816 Metetra
.671 .733 .896 r
.21646 .58816 .22138 .59304 .2287 .59038 .2238 .58548 Metetra
.671 .733 .896 r
.2238 .58548 .2287 .59038 .23604 .58771 .23115 .58279 Metetra
.671 .732 .896 r
.23115 .58279 .23604 .58771 .2434 .58501 .23853 .58008 Metetra
.672 .732 .895 r
.23853 .58008 .2434 .58501 .25078 .58231 .24592 .57735 Metetra
.672 .732 .895 r
.24592 .57735 .25078 .58231 .25818 .57958 .25333 .57461 Metetra
.673 .732 .895 r
.25333 .57461 .25818 .57958 .2656 .57684 .26077 .57185 Metetra
.673 .732 .894 r
.26077 .57185 .2656 .57684 .27305 .57409 .26822 .56907 Metetra
.674 .732 .894 r
.26822 .56907 .27305 .57409 .28051 .57131 .27569 .56628 Metetra
.674 .732 .893 r
.27569 .56628 .28051 .57131 .28799 .56852 .28318 .56347 Metetra
.674 .732 .893 r
.28318 .56347 .28799 .56852 .29549 .56571 .2907 .56064 Metetra
.675 .731 .893 r
.2907 .56064 .29549 .56571 .30301 .56289 .29823 .5578 Metetra
.675 .731 .892 r
.29823 .5578 .30301 .56289 .31055 .56004 .30578 .55493 Metetra
.676 .731 .892 r
.30578 .55493 .31055 .56004 .31811 .55717 .31336 .55204 Metetra
.677 .731 .891 r
.31336 .55204 .31811 .55717 .32569 .55429 .32095 .54914 Metetra
.677 .731 .891 r
.32095 .54914 .32569 .55429 .33329 .55138 .32856 .54621 Metetra
.678 .731 .89 r
.32856 .54621 .33329 .55138 .34091 .54846 .3362 .54326 Metetra
.678 .731 .89 r
.3362 .54326 .34091 .54846 .34855 .54551 .34385 .54029 Metetra
.679 .73 .889 r
.34385 .54029 .34855 .54551 .35621 .54254 .35152 .5373 Metetra
.68 .73 .889 r
.35152 .5373 .35621 .54254 .36389 .53954 .35922 .53428 Metetra
.68 .73 .888 r
.35922 .53428 .36389 .53954 .37159 .53652 .36693 .53124 Metetra
.681 .73 .887 r
.36693 .53124 .37159 .53652 .37931 .53348 .37467 .52818 Metetra
.682 .73 .887 r
.37467 .52818 .37931 .53348 .38706 .53041 .38242 .52509 Metetra
.682 .73 .886 r
.38242 .52509 .38706 .53041 .39482 .52732 .3902 .52197 Metetra
.683 .73 .885 r
.3902 .52197 .39482 .52732 .4026 .52419 .39799 .51882 Metetra
.684 .73 .885 r
.39799 .51882 .4026 .52419 .4104 .52104 .40581 .51564 Metetra
.685 .729 .884 r
.40581 .51564 .4104 .52104 .41822 .51786 .41364 .51244 Metetra
.686 .729 .883 r
.41364 .51244 .41822 .51786 .42606 .51465 .4215 .5092 Metetra
.687 .729 .883 r
.4215 .5092 .42606 .51465 .43393 .5114 .42937 .50593 Metetra
.688 .729 .882 r
.42937 .50593 .43393 .5114 .44181 .50812 .43727 .50262 Metetra
.689 .729 .881 r
.43727 .50262 .44181 .50812 .44971 .50481 .44518 .49928 Metetra
.69 .729 .88 r
.44518 .49928 .44971 .50481 .45763 .50146 .45312 .4959 Metetra
.691 .729 .879 r
.45312 .4959 .45763 .50146 .46557 .49807 .46107 .49249 Metetra
.692 .728 .878 r
.46107 .49249 .46557 .49807 .47353 .49464 .46904 .48903 Metetra
.694 .728 .877 r
.46904 .48903 .47353 .49464 .48151 .49116 .47704 .48552 Metetra
.695 .728 .876 r
.47704 .48552 .48151 .49116 .48951 .48765 .48505 .48197 Metetra
.696 .728 .875 r
.48505 .48197 .48951 .48765 .49752 .48408 .49308 .47838 Metetra
.698 .728 .874 r
.49308 .47838 .49752 .48408 .50556 .48046 .50113 .47473 Metetra
.699 .728 .872 r
.50113 .47473 .50556 .48046 .51361 .47679 .5092 .47102 Metetra
.701 .728 .871 r
.5092 .47102 .51361 .47679 .52169 .47307 .51729 .46726 Metetra
.703 .728 .87 r
.51729 .46726 .52169 .47307 .52978 .46928 .52539 .46344 Metetra
.705 .728 .868 r
.52539 .46344 .52978 .46928 .53789 .46543 .53352 .45955 Metetra
.707 .727 .866 r
.53352 .45955 .53789 .46543 .54601 .4615 .54166 .45559 Metetra
.709 .727 .865 r
.54166 .45559 .54601 .4615 .55415 .45751 .54981 .45156 Metetra
.711 .727 .863 r
.54981 .45156 .55415 .45751 .56231 .45343 .55799 .44744 Metetra
.714 .727 .861 r
.55799 .44744 .56231 .45343 .57049 .44927 .56618 .44324 Metetra
.716 .727 .859 r
.56618 .44324 .57049 .44927 .57868 .44502 .57438 .43894 Metetra
.719 .727 .857 r
.57438 .43894 .57868 .44502 .58688 .44066 .5826 .43454 Metetra
.722 .727 .854 r
.5826 .43454 .58688 .44066 .5951 .43619 .59083 .43002 Metetra
.725 .727 .851 r
.59083 .43002 .5951 .43619 .60333 .43161 .59908 .42538 Metetra
.729 .727 .848 r
.59908 .42538 .60333 .43161 .61157 .42688 .60733 .4206 Metetra
.733 .727 .845 r
.60733 .4206 .61157 .42688 .61982 .42201 .6156 .41568 Metetra
.737 .727 .842 r
.6156 .41568 .61982 .42201 .62808 .41698 .62387 .41058 Metetra
.742 .727 .838 r
.62387 .41058 .62808 .41698 .63634 .41176 .63215 .40529 Metetra
.747 .727 .834 r
.63215 .40529 .63634 .41176 .64461 .40633 .64044 .39979 Metetra
.752 .727 .829 r
.64044 .39979 .64461 .40633 .65288 .40066 .64872 .39404 Metetra
.758 .727 .823 r
.64872 .39404 .65288 .40066 .66115 .39472 .657 .38801 Metetra
.765 .727 .817 r
.657 .38801 .66115 .39472 .66942 .38847 .66528 .38165 Metetra
.773 .727 .81 r
.66528 .38165 .66942 .38847 .67767 .38184 .67355 .37491 Metetra
.781 .727 .802 r
.67355 .37491 .67767 .38184 .68591 .37477 .68179 .36771 Metetra
.791 .726 .792 r
.68179 .36771 .68591 .37477 .69412 .36717 .69001 .35995 Metetra
.802 .726 .781 r
.69001 .35995 .69412 .36717 .70229 .35889 .69819 .35148 Metetra
.814 .725 .767 r
.69819 .35148 .70229 .35889 .71041 .34976 .70632 .34211 Metetra
.829 .724 .749 r
.70632 .34211 .71041 .34976 .71844 .33949 .71436 .33151 Metetra
.846 .722 .726 r
.71436 .33151 .71844 .33949 .72636 .32759 .72227 .31913 Metetra
.868 .719 .694 r
.72227 .31913 .72636 .32759 .73409 .31313 .72996 .30383 Metetra
.899 .713 .641 r
.72996 .30383 .73409 .31313 .74142 .29359 .73717 .2821 Metetra
.921 .695 .578 r
.73717 .2821 .74142 .29359 .74717 .25306 .7434 .24773 Metetra
.664 .741 .908 r
.7434 .24773 .74717 .25306 .75556 .25018 .75181 .24484 Metetra
.664 .741 .908 r
.75181 .24484 .75556 .25018 .76398 .24729 .76024 .24193 Metetra
.664 .741 .908 r
.76024 .24193 .76398 .24729 .77242 .24439 .7687 .23902 Metetra
.664 .741 .908 r
.7687 .23902 .77242 .24439 .78088 .24148 .77718 .2361 Metetra
.664 .741 .908 r
.77718 .2361 .78088 .24148 .78937 .23857 .78569 .23317 Metetra
.664 .741 .908 r
.78569 .23317 .78937 .23857 .79788 .23565 .79422 .23023 Metetra
.664 .741 .908 r
.79422 .23023 .79788 .23565 .80642 .23271 .80278 .22728 Metetra
.664 .741 .908 r
.80278 .22728 .80642 .23271 .81499 .22977 .81136 .22432 Metetra
.664 .741 .908 r
.81136 .22432 .81499 .22977 .82358 .22682 .81997 .22136 Metetra
.664 .741 .908 r
.81997 .22136 .82358 .22682 .8322 .22387 .8286 .21838 Metetra
.67 .733 .897 r
.1969 .58861 .20186 .59348 .20915 .59083 .2042 .58594 Metetra
.671 .733 .897 r
.2042 .58594 .20915 .59083 .21646 .58816 .21153 .58326 Metetra
.671 .733 .896 r
.21153 .58326 .21646 .58816 .2238 .58548 .21888 .58056 Metetra
.671 .733 .896 r
.21888 .58056 .2238 .58548 .23115 .58279 .22624 .57785 Metetra
.672 .733 .896 r
.22624 .57785 .23115 .58279 .23853 .58008 .23363 .57512 Metetra
.672 .733 .895 r
.23363 .57512 .23853 .58008 .24592 .57735 .24103 .57238 Metetra
.673 .732 .895 r
.24103 .57238 .24592 .57735 .25333 .57461 .24846 .56962 Metetra
.673 .732 .895 r
.24846 .56962 .25333 .57461 .26077 .57185 .2559 .56684 Metetra
.673 .732 .894 r
.2559 .56684 .26077 .57185 .26822 .56907 .26337 .56405 Metetra
.674 .732 .894 r
.26337 .56405 .26822 .56907 .27569 .56628 .27085 .56123 Metetra
.674 .732 .893 r
.27085 .56123 .27569 .56628 .28318 .56347 .27836 .5584 Metetra
.675 .732 .893 r
.27836 .5584 .28318 .56347 .2907 .56064 .28588 .55556 Metetra
.675 .732 .893 r
.28588 .55556 .2907 .56064 .29823 .5578 .29343 .55269 Metetra
.676 .732 .892 r
.29343 .55269 .29823 .5578 .30578 .55493 .30099 .5498 Metetra
.676 .732 .892 r
.30099 .5498 .30578 .55493 .31336 .55204 .30858 .5469 Metetra
.677 .731 .891 r
.30858 .5469 .31336 .55204 .32095 .54914 .31619 .54397 Metetra
.677 .731 .891 r
.31619 .54397 .32095 .54914 .32856 .54621 .32381 .54102 Metetra
.678 .731 .89 r
.32381 .54102 .32856 .54621 .3362 .54326 .33146 .53805 Metetra
.679 .731 .89 r
.33146 .53805 .3362 .54326 .34385 .54029 .33912 .53506 Metetra
.679 .731 .889 r
.33912 .53506 .34385 .54029 .35152 .5373 .34681 .53205 Metetra
.68 .731 .889 r
.34681 .53205 .35152 .5373 .35922 .53428 .35452 .52901 Metetra
.681 .731 .888 r
.35452 .52901 .35922 .53428 .36693 .53124 .36225 .52594 Metetra
.681 .73 .887 r
.36225 .52594 .36693 .53124 .37467 .52818 .36999 .52286 Metetra
.682 .73 .887 r
.36999 .52286 .37467 .52818 .38242 .52509 .37776 .51974 Metetra
.683 .73 .886 r
.37776 .51974 .38242 .52509 .3902 .52197 .38555 .5166 Metetra
.684 .73 .886 r
.38555 .5166 .3902 .52197 .39799 .51882 .39336 .51343 Metetra
.684 .73 .885 r
.39336 .51343 .39799 .51882 .40581 .51564 .40119 .51023 Metetra
.685 .73 .884 r
.40119 .51023 .40581 .51564 .41364 .51244 .40904 .507 Metetra
.686 .73 .883 r
.40904 .507 .41364 .51244 .4215 .5092 .41691 .50373 Metetra
.687 .73 .883 r
.41691 .50373 .4215 .5092 .42937 .50593 .42479 .50044 Metetra
.688 .729 .882 r
.42479 .50044 .42937 .50593 .43727 .50262 .4327 .4971 Metetra
.689 .729 .881 r
.4327 .4971 .43727 .50262 .44518 .49928 .44063 .49374 Metetra
.69 .729 .88 r
.44063 .49374 .44518 .49928 .45312 .4959 .44858 .49033 Metetra
.692 .729 .879 r
.44858 .49033 .45312 .4959 .46107 .49249 .45655 .48688 Metetra
.693 .729 .878 r
.45655 .48688 .46107 .49249 .46904 .48903 .46454 .48339 Metetra
.694 .729 .877 r
.46454 .48339 .46904 .48903 .47704 .48552 .47255 .47986 Metetra
.696 .729 .876 r
.47255 .47986 .47704 .48552 .48505 .48197 .48057 .47628 Metetra
.697 .729 .875 r
.48057 .47628 .48505 .48197 .49308 .47838 .48862 .47265 Metetra
.698 .728 .874 r
.48862 .47265 .49308 .47838 .50113 .47473 .49668 .46897 Metetra
.7 .728 .872 r
.49668 .46897 .50113 .47473 .5092 .47102 .50477 .46524 Metetra
.702 .728 .871 r
.50477 .46524 .5092 .47102 .51729 .46726 .51287 .46144 Metetra
.704 .728 .869 r
.51287 .46144 .51729 .46726 .52539 .46344 .52099 .45758 Metetra
.706 .728 .868 r
.52099 .45758 .52539 .46344 .53352 .45955 .52913 .45366 Metetra
.708 .728 .866 r
.52913 .45366 .53352 .45955 .54166 .45559 .53728 .44966 Metetra
.71 .728 .865 r
.53728 .44966 .54166 .45559 .54981 .45156 .54545 .44559 Metetra
.712 .728 .863 r
.54545 .44559 .54981 .45156 .55799 .44744 .55364 .44143 Metetra
.715 .728 .861 r
.55364 .44143 .55799 .44744 .56618 .44324 .56185 .43719 Metetra
.717 .728 .859 r
.56185 .43719 .56618 .44324 .57438 .43894 .57007 .43284 Metetra
.72 .728 .856 r
.57007 .43284 .57438 .43894 .5826 .43454 .5783 .42839 Metetra
.723 .728 .854 r
.5783 .42839 .5826 .43454 .59083 .43002 .58655 .42383 Metetra
.727 .728 .851 r
.58655 .42383 .59083 .43002 .59908 .42538 .59481 .41913 Metetra
.73 .728 .848 r
.59481 .41913 .59908 .42538 .60733 .4206 .60308 .4143 Metetra
.734 .728 .845 r
.60308 .4143 .60733 .4206 .6156 .41568 .61136 .40931 Metetra
.739 .728 .841 r
.61136 .40931 .6156 .41568 .62387 .41058 .61965 .40415 Metetra
.743 .728 .837 r
.61965 .40415 .62387 .41058 .63215 .40529 .62794 .39879 Metetra
.748 .728 .833 r
.62794 .39879 .63215 .40529 .64044 .39979 .63624 .39322 Metetra
.754 .728 .828 r
.63624 .39322 .64044 .39979 .64872 .39404 .64454 .38739 Metetra
.76 .728 .822 r
.64454 .38739 .64872 .39404 .657 .38801 .65284 .38127 Metetra
.767 .727 .816 r
.65284 .38127 .657 .38801 .66528 .38165 .66113 .37481 Metetra
.775 .727 .808 r
.66113 .37481 .66528 .38165 .67355 .37491 .6694 .36795 Metetra
.784 .727 .8 r
.6694 .36795 .67355 .37491 .68179 .36771 .67766 .36061 Metetra
.794 .727 .79 r
.67766 .36061 .68179 .36771 .69001 .35995 .68589 .35268 Metetra
.805 .726 .778 r
.68589 .35268 .69001 .35995 .69819 .35148 .69408 .34402 Metetra
.818 .726 .763 r
.69408 .34402 .69819 .35148 .70632 .34211 .70221 .33439 Metetra
.833 .724 .745 r
.70221 .33439 .70632 .34211 .71436 .33151 .71025 .32343 Metetra
.851 .722 .72 r
.71025 .32343 .71436 .33151 .72227 .31913 .71815 .31052 Metetra
.874 .718 .685 r
.71815 .31052 .72227 .31913 .72996 .30383 .7258 .29422 Metetra
.91 .711 .621 r
.7258 .29422 .72996 .30383 .73717 .2821 .73281 .26918 Metetra
.884 .672 .611 r
.73281 .26918 .73717 .2821 .7434 .24773 .73961 .24238 Metetra
.664 .741 .908 r
.73961 .24238 .7434 .24773 .75181 .24484 .74803 .23947 Metetra
.664 .741 .908 r
.74803 .23947 .75181 .24484 .76024 .24193 .75648 .23655 Metetra
.664 .741 .908 r
.75648 .23655 .76024 .24193 .7687 .23902 .76496 .23362 Metetra
.664 .741 .908 r
.76496 .23362 .7687 .23902 .77718 .2361 .77346 .23068 Metetra
.664 .741 .908 r
.77346 .23068 .77718 .2361 .78569 .23317 .78198 .22773 Metetra
.664 .741 .908 r
.78198 .22773 .78569 .23317 .79422 .23023 .79053 .22478 Metetra
.664 .741 .908 r
.79053 .22478 .79422 .23023 .80278 .22728 .79911 .22181 Metetra
.664 .741 .908 r
.79911 .22181 .80278 .22728 .81136 .22432 .80771 .21884 Metetra
.664 .741 .908 r
.80771 .21884 .81136 .22432 .81997 .22136 .81634 .21586 Metetra
.664 .741 .908 r
.81634 .21586 .81997 .22136 .8286 .21838 .82499 .21287 Metetra
.671 .733 .897 r
.19192 .58373 .1969 .58861 .2042 .58594 .19923 .58104 Metetra
.671 .733 .897 r
.19923 .58104 .2042 .58594 .21153 .58326 .20657 .57834 Metetra
.671 .733 .897 r
.20657 .57834 .21153 .58326 .21888 .58056 .21393 .57563 Metetra
.672 .733 .896 r
.21393 .57563 .21888 .58056 .22624 .57785 .22131 .5729 Metetra
.672 .733 .896 r
.22131 .5729 .22624 .57785 .23363 .57512 .2287 .57015 Metetra
.672 .733 .896 r
.2287 .57015 .23363 .57512 .24103 .57238 .23612 .56739 Metetra
.673 .733 .895 r
.23612 .56739 .24103 .57238 .24846 .56962 .24356 .56461 Metetra
.673 .733 .895 r
.24356 .56461 .24846 .56962 .2559 .56684 .25102 .56181 Metetra
.674 .733 .894 r
.25102 .56181 .2559 .56684 .26337 .56405 .25849 .559 Metetra
.674 .732 .894 r
.25849 .559 .26337 .56405 .27085 .56123 .26599 .55617 Metetra
.675 .732 .894 r
.26599 .55617 .27085 .56123 .27836 .5584 .27351 .55332 Metetra
.675 .732 .893 r
.27351 .55332 .27836 .5584 .28588 .55556 .28105 .55045 Metetra
.676 .732 .893 r
.28105 .55045 .28588 .55556 .29343 .55269 .2886 .54756 Metetra
.676 .732 .892 r
.2886 .54756 .29343 .55269 .30099 .5498 .29618 .54466 Metetra
.677 .732 .892 r
.29618 .54466 .30099 .5498 .30858 .5469 .30378 .54173 Metetra
.677 .732 .891 r
.30378 .54173 .30858 .5469 .31619 .54397 .3114 .53878 Metetra
.678 .732 .891 r
.3114 .53878 .31619 .54397 .32381 .54102 .31904 .53581 Metetra
.678 .731 .89 r
.31904 .53581 .32381 .54102 .33146 .53805 .3267 .53282 Metetra
.679 .731 .89 r
.3267 .53282 .33146 .53805 .33912 .53506 .33438 .52981 Metetra
.68 .731 .889 r
.33438 .52981 .33912 .53506 .34681 .53205 .34208 .52677 Metetra
.68 .731 .889 r
.34208 .52677 .34681 .53205 .35452 .52901 .3498 .52371 Metetra
.681 .731 .888 r
.3498 .52371 .35452 .52901 .36225 .52594 .35754 .52063 Metetra
.682 .731 .887 r
.35754 .52063 .36225 .52594 .36999 .52286 .3653 .51751 Metetra
.682 .731 .887 r
.3653 .51751 .36999 .52286 .37776 .51974 .37308 .51438 Metetra
.683 .731 .886 r
.37308 .51438 .37776 .51974 .38555 .5166 .38088 .51121 Metetra
.684 .73 .886 r
.38088 .51121 .38555 .5166 .39336 .51343 .38871 .50801 Metetra
.685 .73 .885 r
.38871 .50801 .39336 .51343 .40119 .51023 .39655 .50479 Metetra
.686 .73 .884 r
.39655 .50479 .40119 .51023 .40904 .507 .40441 .50153 Metetra
.687 .73 .883 r
.40441 .50153 .40904 .507 .41691 .50373 .41229 .49824 Metetra
.688 .73 .883 r
.41229 .49824 .41691 .50373 .42479 .50044 .4202 .49492 Metetra
.689 .73 .882 r
.4202 .49492 .42479 .50044 .4327 .4971 .42812 .49156 Metetra
.69 .73 .881 r
.42812 .49156 .4327 .4971 .44063 .49374 .43606 .48817 Metetra
.691 .73 .88 r
.43606 .48817 .44063 .49374 .44858 .49033 .44403 .48473 Metetra
.692 .729 .879 r
.44403 .48473 .44858 .49033 .45655 .48688 .45201 .48126 Metetra
.693 .729 .878 r
.45201 .48126 .45655 .48688 .46454 .48339 .46001 .47774 Metetra
.695 .729 .877 r
.46001 .47774 .46454 .48339 .47255 .47986 .46803 .47418 Metetra
.696 .729 .876 r
.46803 .47418 .47255 .47986 .48057 .47628 .47607 .47057 Metetra
.698 .729 .875 r
.47607 .47057 .48057 .47628 .48862 .47265 .48413 .46691 Metetra
.699 .729 .873 r
.48413 .46691 .48862 .47265 .49668 .46897 .49221 .4632 Metetra
.701 .729 .872 r
.49221 .4632 .49668 .46897 .50477 .46524 .50031 .45943 Metetra
.703 .729 .871 r
.50031 .45943 .50477 .46524 .51287 .46144 .50843 .4556 Metetra
.704 .729 .869 r
.50843 .4556 .51287 .46144 .52099 .45758 .51656 .4517 Metetra
.706 .729 .868 r
.51656 .4517 .52099 .45758 .52913 .45366 .52472 .44774 Metetra
.708 .728 .866 r
.52472 .44774 .52913 .45366 .53728 .44966 .53289 .44371 Metetra
.711 .728 .864 r
.53289 .44371 .53728 .44966 .54545 .44559 .54107 .4396 Metetra
.713 .728 .862 r
.54107 .4396 .54545 .44559 .55364 .44143 .54928 .4354 Metetra
.716 .728 .86 r
.54928 .4354 .55364 .44143 .56185 .43719 .5575 .43111 Metetra
.718 .728 .858 r
.5575 .43111 .56185 .43719 .57007 .43284 .56573 .42672 Metetra
.721 .728 .856 r
.56573 .42672 .57007 .43284 .5783 .42839 .57398 .42222 Metetra
.724 .728 .853 r
.57398 .42222 .5783 .42839 .58655 .42383 .58224 .41761 Metetra
.728 .728 .851 r
.58224 .41761 .58655 .42383 .59481 .41913 .59052 .41286 Metetra
.732 .728 .848 r
.59052 .41286 .59481 .41913 .60308 .4143 .5988 .40797 Metetra
.736 .728 .844 r
.5988 .40797 .60308 .4143 .61136 .40931 .6071 .40292 Metetra
.74 .728 .841 r
.6071 .40292 .61136 .40931 .61965 .40415 .6154 .3977 Metetra
.745 .728 .836 r
.6154 .3977 .61965 .40415 .62794 .39879 .62371 .39227 Metetra
.75 .728 .832 r
.62371 .39227 .62794 .39879 .63624 .39322 .63202 .38662 Metetra
.756 .728 .827 r
.63202 .38662 .63624 .39322 .64454 .38739 .64034 .3807 Metetra
.762 .728 .821 r
.64034 .3807 .64454 .38739 .65284 .38127 .64865 .37449 Metetra
.769 .728 .815 r
.64865 .37449 .65284 .38127 .66113 .37481 .65695 .36792 Metetra
.777 .728 .807 r
.65695 .36792 .66113 .37481 .6694 .36795 .66524 .36095 Metetra
.786 .728 .798 r
.66524 .36095 .6694 .36795 .67766 .36061 .67351 .35347 Metetra
.796 .727 .788 r
.67351 .35347 .67766 .36061 .68589 .35268 .68175 .34537 Metetra
.808 .727 .775 r
.68175 .34537 .68589 .35268 .69408 .34402 .68995 .33649 Metetra
.821 .726 .76 r
.68995 .33649 .69408 .34402 .70221 .33439 .69808 .32659 Metetra
.837 .724 .74 r
.69808 .32659 .70221 .33439 .71025 .32343 .70612 .31525 Metetra
.856 .722 .713 r
.70612 .31525 .71025 .32343 .71815 .31052 .71401 .30173 Metetra
.881 .717 .674 r
.71401 .30173 .71815 .31052 .7258 .29422 .72161 .28422 Metetra
.927 .709 .588 r
.72161 .28422 .7258 .29422 .73281 .26918 .72821 .25254 Metetra
.778 .594 .651 r
.72821 .25254 .73281 .26918 .73961 .24238 .7358 .237 Metetra
.664 .741 .908 r
.7358 .237 .73961 .24238 .74803 .23947 .74424 .23407 Metetra
.664 .741 .908 r
.74424 .23407 .74803 .23947 .75648 .23655 .7527 .23113 Metetra
.664 .741 .908 r
.7527 .23113 .75648 .23655 .76496 .23362 .7612 .22819 Metetra
.664 .741 .908 r
.7612 .22819 .76496 .23362 .77346 .23068 .76971 .22523 Metetra
.664 .741 .908 r
.76971 .22523 .77346 .23068 .78198 .22773 .77826 .22227 Metetra
.664 .741 .908 r
.77826 .22227 .78198 .22773 .79053 .22478 .78683 .2193 Metetra
.664 .741 .908 r
.78683 .2193 .79053 .22478 .79911 .22181 .79542 .21632 Metetra
.664 .741 .908 r
.79542 .21632 .79911 .22181 .80771 .21884 .80404 .21333 Metetra
.664 .741 .908 r
.80404 .21333 .80771 .21884 .81634 .21586 .81268 .21033 Metetra
.664 .741 .908 r
.81268 .21033 .81634 .21586 .82499 .21287 .82136 .20732 Metetra
.671 .734 .897 r
.18691 .57883 .19192 .58373 .19923 .58104 .19424 .57613 Metetra
.671 .734 .897 r
.19424 .57613 .19923 .58104 .20657 .57834 .20159 .57341 Metetra
.672 .734 .897 r
.20159 .57341 .20657 .57834 .21393 .57563 .20896 .57067 Metetra
.672 .733 .896 r
.20896 .57067 .21393 .57563 .22131 .5729 .21635 .56792 Metetra
.672 .733 .896 r
.21635 .56792 .22131 .5729 .2287 .57015 .22376 .56516 Metetra
.673 .733 .896 r
.22376 .56516 .2287 .57015 .23612 .56739 .23119 .56238 Metetra
.673 .733 .895 r
.23119 .56238 .23612 .56739 .24356 .56461 .23864 .55958 Metetra
.674 .733 .895 r
.23864 .55958 .24356 .56461 .25102 .56181 .2461 .55676 Metetra
.674 .733 .894 r
.2461 .55676 .25102 .56181 .25849 .559 .25359 .55393 Metetra
.674 .733 .894 r
.25359 .55393 .25849 .559 .26599 .55617 .2611 .55108 Metetra
.675 .733 .894 r
.2611 .55108 .26599 .55617 .27351 .55332 .26863 .54821 Metetra
.675 .733 .893 r
.26863 .54821 .27351 .55332 .28105 .55045 .27618 .54532 Metetra
.676 .732 .893 r
.27618 .54532 .28105 .55045 .2886 .54756 .28375 .54242 Metetra
.676 .732 .892 r
.28375 .54242 .2886 .54756 .29618 .54466 .29135 .53949 Metetra
.677 .732 .892 r
.29135 .53949 .29618 .54466 .30378 .54173 .29896 .53654 Metetra
.678 .732 .891 r
.29896 .53654 .30378 .54173 .3114 .53878 .30659 .53358 Metetra
.678 .732 .891 r
.30659 .53358 .3114 .53878 .31904 .53581 .31424 .53059 Metetra
.679 .732 .89 r
.31424 .53059 .31904 .53581 .3267 .53282 .32191 .52757 Metetra
.679 .732 .89 r
.32191 .52757 .3267 .53282 .33438 .52981 .32961 .52454 Metetra
.68 .732 .889 r
.32961 .52454 .33438 .52981 .34208 .52677 .33732 .52148 Metetra
.681 .731 .889 r
.33732 .52148 .34208 .52677 .3498 .52371 .34505 .5184 Metetra
.681 .731 .888 r
.34505 .5184 .3498 .52371 .35754 .52063 .35281 .51529 Metetra
.682 .731 .888 r
.35281 .51529 .35754 .52063 .3653 .51751 .36058 .51215 Metetra
.683 .731 .887 r
.36058 .51215 .3653 .51751 .37308 .51438 .36838 .50899 Metetra
.684 .731 .886 r
.36838 .50899 .37308 .51438 .38088 .51121 .37619 .5058 Metetra
.685 .731 .886 r
.37619 .5058 .38088 .51121 .38871 .50801 .38403 .50258 Metetra
.685 .731 .885 r
.38403 .50258 .38871 .50801 .39655 .50479 .39188 .49933 Metetra
.686 .731 .884 r
.39188 .49933 .39655 .50479 .40441 .50153 .39976 .49605 Metetra
.687 .73 .883 r
.39976 .49605 .40441 .50153 .41229 .49824 .40766 .49274 Metetra
.688 .73 .883 r
.40766 .49274 .41229 .49824 .4202 .49492 .41557 .48939 Metetra
.689 .73 .882 r
.41557 .48939 .4202 .49492 .42812 .49156 .42351 .486 Metetra
.69 .73 .881 r
.42351 .486 .42812 .49156 .43606 .48817 .43147 .48258 Metetra
.692 .73 .88 r
.43147 .48258 .43606 .48817 .44403 .48473 .43945 .47912 Metetra
.693 .73 .879 r
.43945 .47912 .44403 .48473 .45201 .48126 .44744 .47562 Metetra
.694 .73 .878 r
.44744 .47562 .45201 .48126 .46001 .47774 .45546 .47207 Metetra
.695 .73 .877 r
.45546 .47207 .46001 .47774 .46803 .47418 .4635 .46848 Metetra
.697 .73 .876 r
.4635 .46848 .46803 .47418 .47607 .47057 .47155 .46484 Metetra
.698 .729 .875 r
.47155 .46484 .47607 .47057 .48413 .46691 .47963 .46114 Metetra
.7 .729 .873 r
.47963 .46114 .48413 .46691 .49221 .4632 .48772 .4574 Metetra
.701 .729 .872 r
.48772 .4574 .49221 .4632 .50031 .45943 .49584 .4536 Metetra
.703 .729 .871 r
.49584 .4536 .50031 .45943 .50843 .4556 .50397 .44973 Metetra
.705 .729 .869 r
.50397 .44973 .50843 .4556 .51656 .4517 .51212 .4458 Metetra
.707 .729 .868 r
.51212 .4458 .51656 .4517 .52472 .44774 .52028 .4418 Metetra
.709 .729 .866 r
.52028 .4418 .52472 .44774 .53289 .44371 .52847 .43773 Metetra
.712 .729 .864 r
.52847 .43773 .53289 .44371 .54107 .4396 .53667 .43358 Metetra
.714 .729 .862 r
.53667 .43358 .54107 .4396 .54928 .4354 .54489 .42934 Metetra
.717 .729 .86 r
.54489 .42934 .54928 .4354 .5575 .43111 .55312 .42501 Metetra
.719 .729 .858 r
.55312 .42501 .5575 .43111 .56573 .42672 .56137 .42057 Metetra
.722 .729 .856 r
.56137 .42057 .56573 .42672 .57398 .42222 .56964 .41603 Metetra
.726 .729 .853 r
.56964 .41603 .57398 .42222 .58224 .41761 .57792 .41136 Metetra
.729 .729 .85 r
.57792 .41136 .58224 .41761 .59052 .41286 .5862 .40656 Metetra
.733 .729 .847 r
.5862 .40656 .59052 .41286 .5988 .40797 .59451 .40162 Metetra
.737 .729 .844 r
.59451 .40162 .5988 .40797 .6071 .40292 .60282 .39651 Metetra
.741 .729 .84 r
.60282 .39651 .6071 .40292 .6154 .3977 .61113 .39122 Metetra
.746 .729 .836 r
.61113 .39122 .6154 .3977 .62371 .39227 .61946 .38572 Metetra
.752 .729 .831 r
.61946 .38572 .62371 .39227 .63202 .38662 .62779 .37999 Metetra
.758 .729 .826 r
.62779 .37999 .63202 .38662 .64034 .3807 .63612 .37399 Metetra
.764 .729 .82 r
.63612 .37399 .64034 .3807 .64865 .37449 .64444 .36768 Metetra
.771 .729 .813 r
.64444 .36768 .64865 .37449 .65695 .36792 .65276 .36101 Metetra
.78 .728 .805 r
.65276 .36101 .65695 .36792 .66524 .36095 .66106 .3539 Metetra
.789 .728 .796 r
.66106 .3539 .66524 .36095 .67351 .35347 .66935 .34628 Metetra
.799 .728 .785 r
.66935 .34628 .67351 .35347 .68175 .34537 .6776 .338 Metetra
.811 .727 .772 r
.6776 .338 .68175 .34537 .68995 .33649 .6858 .32891 Metetra
.825 .726 .756 r
.6858 .32891 .68995 .33649 .69808 .32659 .69394 .31871 Metetra
.841 .724 .735 r
.69394 .31871 .69808 .32659 .70612 .31525 .70198 .30695 Metetra
.861 .721 .706 r
.70198 .30695 .70612 .31525 .71401 .30173 .70984 .29274 Metetra
.889 .716 .662 r
.70984 .29274 .71401 .30173 .72161 .28422 .71737 .27367 Metetra
.938 .705 .559 r
.71737 .27367 .72161 .28422 .72821 .25254 .72353 .23452 Metetra
.606 .482 .686 r
.72353 .23452 .72821 .25254 .7358 .237 .73196 .23158 Metetra
.664 .741 .908 r
.73196 .23158 .7358 .237 .74424 .23407 .74042 .22864 Metetra
.664 .741 .908 r
.74042 .22864 .74424 .23407 .7527 .23113 .74891 .22569 Metetra
.664 .741 .908 r
.74891 .22569 .7527 .23113 .7612 .22819 .75742 .22273 Metetra
.664 .741 .908 r
.75742 .22273 .7612 .22819 .76971 .22523 .76595 .21976 Metetra
.664 .741 .908 r
.76595 .21976 .76971 .22523 .77826 .22227 .77451 .21678 Metetra
.664 .741 .908 r
.77451 .21678 .77826 .22227 .78683 .2193 .7831 .21379 Metetra
.664 .741 .908 r
.7831 .21379 .78683 .2193 .79542 .21632 .79171 .21079 Metetra
.664 .741 .908 r
.79171 .21079 .79542 .21632 .80404 .21333 .80035 .20778 Metetra
.664 .741 .908 r
.80035 .20778 .80404 .21333 .81268 .21033 .80901 .20477 Metetra
.664 .741 .908 r
.80901 .20477 .81268 .21033 .82136 .20732 .8177 .20174 Metetra
.671 .734 .897 r
.18188 .57391 .18691 .57883 .19424 .57613 .18922 .57119 Metetra
.671 .734 .897 r
.18922 .57119 .19424 .57613 .20159 .57341 .19658 .56845 Metetra
.672 .734 .897 r
.19658 .56845 .20159 .57341 .20896 .57067 .20396 .5657 Metetra
.672 .734 .896 r
.20396 .5657 .20896 .57067 .21635 .56792 .21136 .56293 Metetra
.673 .734 .896 r
.21136 .56293 .21635 .56792 .22376 .56516 .21878 .56015 Metetra
.673 .734 .896 r
.21878 .56015 .22376 .56516 .23119 .56238 .22623 .55735 Metetra
.673 .733 .895 r
.22623 .55735 .23119 .56238 .23864 .55958 .23369 .55453 Metetra
.674 .733 .895 r
.23369 .55453 .23864 .55958 .2461 .55676 .24117 .5517 Metetra
.674 .733 .894 r
.24117 .5517 .2461 .55676 .25359 .55393 .24867 .54885 Metetra
.675 .733 .894 r
.24867 .54885 .25359 .55393 .2611 .55108 .25619 .54598 Metetra
.675 .733 .894 r
.25619 .54598 .2611 .55108 .26863 .54821 .26374 .54309 Metetra
.676 .733 .893 r
.26374 .54309 .26863 .54821 .27618 .54532 .2713 .54018 Metetra
.676 .733 .893 r
.2713 .54018 .27618 .54532 .28375 .54242 .27888 .53725 Metetra
.677 .733 .892 r
.27888 .53725 .28375 .54242 .29135 .53949 .28649 .53431 Metetra
.677 .733 .892 r
.28649 .53431 .29135 .53949 .29896 .53654 .29411 .53134 Metetra
.678 .732 .891 r
.29411 .53134 .29896 .53654 .30659 .53358 .30175 .52835 Metetra
.678 .732 .891 r
.30175 .52835 .30659 .53358 .31424 .53059 .30942 .52534 Metetra
.679 .732 .89 r
.30942 .52534 .31424 .53059 .32191 .52757 .3171 .5223 Metetra
.68 .732 .89 r
.3171 .5223 .32191 .52757 .32961 .52454 .32481 .51925 Metetra
.68 .732 .889 r
.32481 .51925 .32961 .52454 .33732 .52148 .33254 .51617 Metetra
.681 .732 .889 r
.33254 .51617 .33732 .52148 .34505 .5184 .34028 .51306 Metetra
.682 .732 .888 r
.34028 .51306 .34505 .5184 .35281 .51529 .34805 .50993 Metetra
.683 .732 .888 r
.34805 .50993 .35281 .51529 .36058 .51215 .35584 .50677 Metetra
.683 .731 .887 r
.35584 .50677 .36058 .51215 .36838 .50899 .36365 .50359 Metetra
.684 .731 .886 r
.36365 .50359 .36838 .50899 .37619 .5058 .37148 .50037 Metetra
.685 .731 .886 r
.37148 .50037 .37619 .5058 .38403 .50258 .37933 .49713 Metetra
.686 .731 .885 r
.37933 .49713 .38403 .50258 .39188 .49933 .3872 .49385 Metetra
.687 .731 .884 r
.3872 .49385 .39188 .49933 .39976 .49605 .39509 .49055 Metetra
.688 .731 .883 r
.39509 .49055 .39976 .49605 .40766 .49274 .403 .48721 Metetra
.689 .731 .882 r
.403 .48721 .40766 .49274 .41557 .48939 .41093 .48383 Metetra
.69 .731 .882 r
.41093 .48383 .41557 .48939 .42351 .486 .41888 .48042 Metetra
.691 .731 .881 r
.41888 .48042 .42351 .486 .43147 .48258 .42685 .47697 Metetra
.692 .73 .88 r
.42685 .47697 .43147 .48258 .43945 .47912 .43485 .47348 Metetra
.693 .73 .879 r
.43485 .47348 .43945 .47912 .44744 .47562 .44286 .46995 Metetra
.695 .73 .878 r
.44286 .46995 .44744 .47562 .45546 .47207 .45089 .46637 Metetra
.696 .73 .877 r
.45089 .46637 .45546 .47207 .4635 .46848 .45894 .46275 Metetra
.697 .73 .876 r
.45894 .46275 .4635 .46848 .47155 .46484 .46701 .45908 Metetra
.699 .73 .874 r
.46701 .45908 .47155 .46484 .47963 .46114 .4751 .45536 Metetra
.7 .73 .873 r
.4751 .45536 .47963 .46114 .48772 .4574 .48321 .45158 Metetra
.702 .73 .872 r
.48321 .45158 .48772 .4574 .49584 .4536 .49134 .44774 Metetra
.704 .73 .87 r
.49134 .44774 .49584 .4536 .50397 .44973 .49948 .44384 Metetra
.706 .73 .869 r
.49948 .44384 .50397 .44973 .51212 .4458 .50765 .43988 Metetra
.708 .73 .867 r
.50765 .43988 .51212 .4458 .52028 .4418 .51583 .43584 Metetra
.71 .729 .866 r
.51583 .43584 .52028 .4418 .52847 .43773 .52403 .43173 Metetra
.712 .729 .864 r
.52403 .43173 .52847 .43773 .53667 .43358 .53225 .42754 Metetra
.715 .729 .862 r
.53225 .42754 .53667 .43358 .54489 .42934 .54048 .42326 Metetra
.717 .729 .86 r
.54048 .42326 .54489 .42934 .55312 .42501 .54873 .41888 Metetra
.72 .729 .858 r
.54873 .41888 .55312 .42501 .56137 .42057 .557 .4144 Metetra
.723 .729 .855 r
.557 .4144 .56137 .42057 .56964 .41603 .56528 .40981 Metetra
.727 .729 .852 r
.56528 .40981 .56964 .41603 .57792 .41136 .57357 .40509 Metetra
.73 .729 .85 r
.57357 .40509 .57792 .41136 .5862 .40656 .58187 .40024 Metetra
.734 .729 .846 r
.58187 .40024 .5862 .40656 .59451 .40162 .59019 .39524 Metetra
.738 .729 .843 r
.59019 .39524 .59451 .40162 .60282 .39651 .59852 .39007 Metetra
.743 .729 .839 r
.59852 .39007 .60282 .39651 .61113 .39122 .60685 .38471 Metetra
.748 .729 .835 r
.60685 .38471 .61113 .39122 .61946 .38572 .61519 .37914 Metetra
.753 .729 .83 r
.61519 .37914 .61946 .38572 .62779 .37999 .62353 .37333 Metetra
.759 .729 .825 r
.62353 .37333 .62779 .37999 .63612 .37399 .63188 .36724 Metetra
.766 .729 .819 r
.63188 .36724 .63612 .37399 .64444 .36768 .64022 .36083 Metetra
.773 .729 .812 r
.64022 .36083 .64444 .36768 .65276 .36101 .64855 .35405 Metetra
.782 .729 .804 r
.64855 .35405 .65276 .36101 .66106 .3539 .65686 .34682 Metetra
.791 .729 .794 r
.65686 .34682 .66106 .3539 .66935 .34628 .66516 .33904 Metetra
.802 .728 .783 r
.66516 .33904 .66935 .34628 .6776 .338 .67342 .33058 Metetra
.814 .728 .769 r
.67342 .33058 .6776 .338 .6858 .32891 .68164 .32125 Metetra
.828 .726 .752 r
.68164 .32125 .6858 .32891 .69394 .31871 .68978 .31074 Metetra
.846 .724 .73 r
.68978 .31074 .69394 .31871 .70198 .30695 .69781 .29852 Metetra
.867 .721 .698 r
.69781 .29852 .70198 .30695 .70984 .29274 .70565 .2835 Metetra
.898 .715 .646 r
.70565 .2835 .70984 .29274 .71737 .27367 .71308 .26233 Metetra
.92 .696 .583 r
.71308 .26233 .71737 .27367 .72353 .23452 .71966 .22909 Metetra
.664 .741 .908 r
.71966 .22909 .72353 .23452 .73196 .23158 .72811 .22614 Metetra
.664 .741 .908 r
.72811 .22614 .73196 .23158 .74042 .22864 .73659 .22318 Metetra
.664 .741 .908 r
.73659 .22318 .74042 .22864 .74891 .22569 .74509 .22021 Metetra
.664 .741 .908 r
.74509 .22021 .74891 .22569 .75742 .22273 .75362 .21723 Metetra
.664 .741 .908 r
.75362 .21723 .75742 .22273 .76595 .21976 .76217 .21425 Metetra
.664 .741 .908 r
.76217 .21425 .76595 .21976 .77451 .21678 .77075 .21125 Metetra
.664 .741 .908 r
.77075 .21125 .77451 .21678 .7831 .21379 .77935 .20825 Metetra
.664 .741 .908 r
.77935 .20825 .7831 .21379 .79171 .21079 .78798 .20523 Metetra
.664 .741 .908 r
.78798 .20523 .79171 .21079 .80035 .20778 .79664 .20221 Metetra
.664 .741 .908 r
.79664 .20221 .80035 .20778 .80901 .20477 .80532 .19918 Metetra
.664 .741 .908 r
.80532 .19918 .80901 .20477 .8177 .20174 .81403 .19614 Metetra
.671 .734 .897 r
.17682 .56897 .18188 .57391 .18922 .57119 .18417 .56623 Metetra
.672 .734 .897 r
.18417 .56623 .18922 .57119 .19658 .56845 .19155 .56348 Metetra
.672 .734 .897 r
.19155 .56348 .19658 .56845 .20396 .5657 .19894 .56071 Metetra
.672 .734 .896 r
.19894 .56071 .20396 .5657 .21136 .56293 .20635 .55792 Metetra
.673 .734 .896 r
.20635 .55792 .21136 .56293 .21878 .56015 .21379 .55512 Metetra
.673 .734 .896 r
.21379 .55512 .21878 .56015 .22623 .55735 .22124 .5523 Metetra
.674 .734 .895 r
.22124 .5523 .22623 .55735 .23369 .55453 .22872 .54947 Metetra
.674 .734 .895 r
.22872 .54947 .23369 .55453 .24117 .5517 .23621 .54661 Metetra
.675 .734 .895 r
.23621 .54661 .24117 .5517 .24867 .54885 .24372 .54374 Metetra
.675 .733 .894 r
.24372 .54374 .24867 .54885 .25619 .54598 .25126 .54085 Metetra
.676 .733 .894 r
.25126 .54085 .25619 .54598 .26374 .54309 .25881 .53794 Metetra
.676 .733 .893 r
.25881 .53794 .26374 .54309 .2713 .54018 .26639 .53502 Metetra
.677 .733 .893 r
.26639 .53502 .2713 .54018 .27888 .53725 .27398 .53207 Metetra
.677 .733 .892 r
.27398 .53207 .27888 .53725 .28649 .53431 .2816 .5291 Metetra
.678 .733 .892 r
.2816 .5291 .28649 .53431 .29411 .53134 .28924 .52611 Metetra
.678 .733 .891 r
.28924 .52611 .29411 .53134 .30175 .52835 .2969 .5231 Metetra
.679 .733 .891 r
.2969 .5231 .30175 .52835 .30942 .52534 .30457 .52007 Metetra
.679 .732 .89 r
.30457 .52007 .30942 .52534 .3171 .5223 .31227 .51702 Metetra
.68 .732 .89 r
.31227 .51702 .3171 .5223 .32481 .51925 .31999 .51394 Metetra
.681 .732 .889 r
.31999 .51394 .32481 .51925 .33254 .51617 .32773 .51083 Metetra
.681 .732 .889 r
.32773 .51083 .33254 .51617 .34028 .51306 .33549 .50771 Metetra
.682 .732 .888 r
.33549 .50771 .34028 .51306 .34805 .50993 .34327 .50455 Metetra
.683 .732 .888 r
.34327 .50455 .34805 .50993 .35584 .50677 .35108 .50137 Metetra
.684 .732 .887 r
.35108 .50137 .35584 .50677 .36365 .50359 .3589 .49816 Metetra
.685 .732 .886 r
.3589 .49816 .36365 .50359 .37148 .50037 .36674 .49492 Metetra
.685 .732 .886 r
.36674 .49492 .37148 .50037 .37933 .49713 .3746 .49165 Metetra
.686 .731 .885 r
.3746 .49165 .37933 .49713 .3872 .49385 .38249 .48836 Metetra
.687 .731 .884 r
.38249 .48836 .3872 .49385 .39509 .49055 .39039 .48502 Metetra
.688 .731 .883 r
.39039 .48502 .39509 .49055 .403 .48721 .39832 .48166 Metetra
.689 .731 .882 r
.39832 .48166 .403 .48721 .41093 .48383 .40626 .47826 Metetra
.69 .731 .882 r
.40626 .47826 .41093 .48383 .41888 .48042 .41423 .47482 Metetra
.691 .731 .881 r
.41423 .47482 .41888 .48042 .42685 .47697 .42221 .47134 Metetra
.693 .731 .88 r
.42221 .47134 .42685 .47697 .43485 .47348 .43022 .46782 Metetra
.694 .731 .879 r
.43022 .46782 .43485 .47348 .44286 .46995 .43825 .46426 Metetra
.695 .731 .878 r
.43825 .46426 .44286 .46995 .45089 .46637 .44629 .46066 Metetra
.697 .731 .877 r
.44629 .46066 .45089 .46637 .45894 .46275 .45436 .457 Metetra
.698 .73 .876 r
.45436 .457 .45894 .46275 .46701 .45908 .46244 .4533 Metetra
.7 .73 .874 r
.46244 .4533 .46701 .45908 .4751 .45536 .47055 .44955 Metetra
.701 .73 .873 r
.47055 .44955 .4751 .45536 .48321 .45158 .47867 .44574 Metetra
.703 .73 .872 r
.47867 .44574 .48321 .45158 .49134 .44774 .48682 .44187 Metetra
.705 .73 .87 r
.48682 .44187 .49134 .44774 .49948 .44384 .49498 .43793 Metetra
.707 .73 .869 r
.49498 .43793 .49948 .44384 .50765 .43988 .50316 .43393 Metetra
.709 .73 .867 r
.50316 .43393 .50765 .43988 .51583 .43584 .51136 .42986 Metetra
.711 .73 .865 r
.51136 .42986 .51583 .43584 .52403 .43173 .51957 .42571 Metetra
.713 .73 .864 r
.51957 .42571 .52403 .43173 .53225 .42754 .5278 .42148 Metetra
.716 .73 .862 r
.5278 .42148 .53225 .42754 .54048 .42326 .53605 .41715 Metetra
.718 .73 .86 r
.53605 .41715 .54048 .42326 .54873 .41888 .54432 .41273 Metetra
.721 .73 .857 r
.54432 .41273 .54873 .41888 .557 .4144 .5526 .40821 Metetra
.724 .73 .855 r
.5526 .40821 .557 .4144 .56528 .40981 .56089 .40356 Metetra
.728 .73 .852 r
.56089 .40356 .56528 .40981 .57357 .40509 .5692 .3988 Metetra
.731 .73 .849 r
.5692 .3988 .57357 .40509 .58187 .40024 .57752 .39389 Metetra
.735 .73 .846 r
.57752 .39389 .58187 .40024 .59019 .39524 .58585 .38883 Metetra
.74 .73 .842 r
.58585 .38883 .59019 .39524 .59852 .39007 .5942 .38359 Metetra
.744 .73 .838 r
.5942 .38359 .59852 .39007 .60685 .38471 .60254 .37817 Metetra
.749 .73 .834 r
.60254 .37817 .60685 .38471 .61519 .37914 .6109 .37253 Metetra
.755 .73 .829 r
.6109 .37253 .61519 .37914 .62353 .37333 .61926 .36663 Metetra
.761 .73 .824 r
.61926 .36663 .62353 .37333 .63188 .36724 .62762 .36046 Metetra
.768 .73 .817 r
.62762 .36046 .63188 .36724 .64022 .36083 .63597 .35395 Metetra
.776 .73 .81 r
.63597 .35395 .64022 .36083 .64855 .35405 .64432 .34706 Metetra
.784 .729 .802 r
.64432 .34706 .64855 .35405 .65686 .34682 .65265 .33969 Metetra
.794 .729 .792 r
.65265 .33969 .65686 .34682 .66516 .33904 .66095 .33176 Metetra
.805 .729 .78 r
.66095 .33176 .66516 .33904 .67342 .33058 .66923 .32311 Metetra
.817 .728 .766 r
.66923 .32311 .67342 .33058 .68164 .32125 .67745 .31352 Metetra
.832 .726 .748 r
.67745 .31352 .68164 .32125 .68978 .31074 .68559 .30267 Metetra
.85 .724 .724 r
.68559 .30267 .68978 .31074 .69781 .29852 .69362 .28993 Metetra
.873 .72 .689 r
.69362 .28993 .69781 .29852 .70565 .2835 .70143 .27396 Metetra
.909 .713 .626 r
.70143 .27396 .70565 .2835 .71308 .26233 .7087 .2496 Metetra
.883 .674 .615 r
.7087 .2496 .71308 .26233 .71966 .22909 .71576 .22364 Metetra
.664 .741 .908 r
.71576 .22364 .71966 .22909 .72811 .22614 .72423 .22067 Metetra
.664 .741 .908 r
.72423 .22067 .72811 .22614 .73659 .22318 .73273 .21769 Metetra
.664 .741 .908 r
.73273 .21769 .73659 .22318 .74509 .22021 .74125 .21471 Metetra
.664 .741 .908 r
.74125 .21471 .74509 .22021 .75362 .21723 .74979 .21171 Metetra
.664 .741 .908 r
.74979 .21171 .75362 .21723 .76217 .21425 .75836 .20871 Metetra
.664 .741 .908 r
.75836 .20871 .76217 .21425 .77075 .21125 .76696 .2057 Metetra
.664 .741 .908 r
.76696 .2057 .77075 .21125 .77935 .20825 .77558 .20268 Metetra
.664 .741 .908 r
.77558 .20268 .77935 .20825 .78798 .20523 .78423 .19965 Metetra
.664 .741 .908 r
.78423 .19965 .78798 .20523 .79664 .20221 .79291 .19661 Metetra
.664 .741 .908 r
.79291 .19661 .79664 .20221 .80532 .19918 .80161 .19356 Metetra
.664 .741 .908 r
.80161 .19356 .80532 .19918 .81403 .19614 .81033 .1905 Metetra
.672 .735 .897 r
.17174 .56402 .17682 .56897 .18417 .56623 .17911 .56126 Metetra
.672 .735 .897 r
.17911 .56126 .18417 .56623 .19155 .56348 .18649 .55849 Metetra
.672 .734 .897 r
.18649 .55849 .19155 .56348 .19894 .56071 .1939 .5557 Metetra
.673 .734 .896 r
.1939 .5557 .19894 .56071 .20635 .55792 .20132 .5529 Metetra
.673 .734 .896 r
.20132 .5529 .20635 .55792 .21379 .55512 .20877 .55007 Metetra
.673 .734 .896 r
.20877 .55007 .21379 .55512 .22124 .5523 .21623 .54724 Metetra
.674 .734 .895 r
.21623 .54724 .22124 .5523 .22872 .54947 .22372 .54438 Metetra
.674 .734 .895 r
.22372 .54438 .22872 .54947 .23621 .54661 .23122 .54151 Metetra
.675 .734 .895 r
.23122 .54151 .23621 .54661 .24372 .54374 .23875 .53862 Metetra
.675 .734 .894 r
.23875 .53862 .24372 .54374 .25126 .54085 .2463 .53571 Metetra
.676 .734 .894 r
.2463 .53571 .25126 .54085 .25881 .53794 .25387 .53278 Metetra
.676 .733 .893 r
.25387 .53278 .25881 .53794 .26639 .53502 .26145 .52983 Metetra
.677 .733 .893 r
.26145 .52983 .26639 .53502 .27398 .53207 .26906 .52687 Metetra
.677 .733 .892 r
.26906 .52687 .27398 .53207 .2816 .5291 .27669 .52388 Metetra
.678 .733 .892 r
.27669 .52388 .2816 .5291 .28924 .52611 .28434 .52087 Metetra
.679 .733 .891 r
.28434 .52087 .28924 .52611 .2969 .5231 .29201 .51784 Metetra
.679 .733 .891 r
.29201 .51784 .2969 .5231 .30457 .52007 .2997 .51478 Metetra
.68 .733 .89 r
.2997 .51478 .30457 .52007 .31227 .51702 .30742 .51171 Metetra
.68 .733 .89 r
.30742 .51171 .31227 .51702 .31999 .51394 .31515 .50861 Metetra
.681 .733 .889 r
.31515 .50861 .31999 .51394 .32773 .51083 .3229 .50548 Metetra
.682 .732 .889 r
.3229 .50548 .32773 .51083 .33549 .50771 .33068 .50233 Metetra
.683 .732 .888 r
.33068 .50233 .33549 .50771 .34327 .50455 .33847 .49915 Metetra
.683 .732 .888 r
.33847 .49915 .34327 .50455 .35108 .50137 .34629 .49595 Metetra
.684 .732 .887 r
.34629 .49595 .35108 .50137 .3589 .49816 .35412 .49271 Metetra
.685 .732 .886 r
.35412 .49271 .3589 .49816 .36674 .49492 .36198 .48945 Metetra
.686 .732 .886 r
.36198 .48945 .36674 .49492 .3746 .49165 .36986 .48616 Metetra
.687 .732 .885 r
.36986 .48616 .3746 .49165 .38249 .48836 .37775 .48284 Metetra
.688 .732 .884 r
.37775 .48284 .38249 .48836 .39039 .48502 .38567 .47948 Metetra
.689 .732 .883 r
.38567 .47948 .39039 .48502 .39832 .48166 .39361 .47609 Metetra
.69 .732 .882 r
.39361 .47609 .39832 .48166 .40626 .47826 .40157 .47266 Metetra
.691 .731 .882 r
.40157 .47266 .40626 .47826 .41423 .47482 .40955 .46919 Metetra
.692 .731 .881 r
.40955 .46919 .41423 .47482 .42221 .47134 .41755 .46569 Metetra
.693 .731 .88 r
.41755 .46569 .42221 .47134 .43022 .46782 .42557 .46214 Metetra
.694 .731 .879 r
.42557 .46214 .43022 .46782 .43825 .46426 .43361 .45855 Metetra
.696 .731 .878 r
.43361 .45855 .43825 .46426 .44629 .46066 .44168 .45492 Metetra
.697 .731 .877 r
.44168 .45492 .44629 .46066 .45436 .457 .44976 .45123 Metetra
.699 .731 .875 r
.44976 .45123 .45436 .457 .46244 .4533 .45786 .4475 Metetra
.7 .731 .874 r
.45786 .4475 .46244 .4533 .47055 .44955 .46598 .44371 Metetra
.702 .731 .873 r
.46598 .44371 .47055 .44955 .47867 .44574 .47412 .43987 Metetra
.704 .731 .872 r
.47412 .43987 .47867 .44574 .48682 .44187 .48227 .43597 Metetra
.705 .731 .87 r
.48227 .43597 .48682 .44187 .49498 .43793 .49045 .432 Metetra
.707 .73 .869 r
.49045 .432 .49498 .43793 .50316 .43393 .49865 .42796 Metetra
.709 .73 .867 r
.49865 .42796 .50316 .43393 .51136 .42986 .50686 .42385 Metetra
.712 .73 .865 r
.50686 .42385 .51136 .42986 .51957 .42571 .51509 .41966 Metetra
.714 .73 .863 r
.51509 .41966 .51957 .42571 .5278 .42148 .52334 .41539 Metetra
.717 .73 .861 r
.52334 .41539 .5278 .42148 .53605 .41715 .5316 .41102 Metetra
.719 .73 .859 r
.5316 .41102 .53605 .41715 .54432 .41273 .53988 .40656 Metetra
.722 .73 .857 r
.53988 .40656 .54432 .41273 .5526 .40821 .54818 .40198 Metetra
.725 .73 .854 r
.54818 .40198 .5526 .40821 .56089 .40356 .55649 .39729 Metetra
.729 .73 .852 r
.55649 .39729 .56089 .40356 .5692 .3988 .56481 .39247 Metetra
.733 .73 .849 r
.56481 .39247 .5692 .3988 .57752 .39389 .57315 .38751 Metetra
.737 .73 .845 r
.57315 .38751 .57752 .39389 .58585 .38883 .5815 .38239 Metetra
.741 .73 .842 r
.5815 .38239 .58585 .38883 .5942 .38359 .58985 .3771 Metetra
.746 .73 .838 r
.58985 .3771 .5942 .38359 .60254 .37817 .59822 .3716 Metetra
.751 .73 .833 r
.59822 .3716 .60254 .37817 .6109 .37253 .60659 .36588 Metetra
.757 .73 .828 r
.60659 .36588 .6109 .37253 .61926 .36663 .61496 .35991 Metetra
.763 .73 .823 r
.61496 .35991 .61926 .36663 .62762 .36046 .62334 .35364 Metetra
.77 .73 .816 r
.62334 .35364 .62762 .36046 .63597 .35395 .63171 .34703 Metetra
.778 .73 .809 r
.63171 .34703 .63597 .35395 .64432 .34706 .64007 .34002 Metetra
.786 .73 .8 r
.64007 .34002 .64432 .34706 .65265 .33969 .64841 .33252 Metetra
.796 .73 .79 r
.64841 .33252 .65265 .33969 .66095 .33176 .65673 .32442 Metetra
.808 .729 .778 r
.65673 .32442 .66095 .33176 .66923 .32311 .66501 .31557 Metetra
.821 .728 .762 r
.66501 .31557 .66923 .32311 .67745 .31352 .67324 .30572 Metetra
.836 .726 .743 r
.67324 .30572 .67745 .31352 .68559 .30267 .68139 .2945 Metetra
.855 .724 .717 r
.68139 .2945 .68559 .30267 .69362 .28993 .68941 .28118 Metetra
.88 .719 .678 r
.68941 .28118 .69362 .28993 .70143 .27396 .69718 .26403 Metetra
.926 .711 .593 r
.69718 .26403 .70143 .27396 .7087 .2496 .7041 .23329 Metetra
.778 .597 .655 r
.7041 .23329 .7087 .2496 .71576 .22364 .71185 .21815 Metetra
.664 .741 .908 r
.71185 .21815 .71576 .22364 .72423 .22067 .72034 .21517 Metetra
.664 .741 .908 r
.72034 .21517 .72423 .22067 .73273 .21769 .72885 .21217 Metetra
.664 .741 .908 r
.72885 .21217 .73273 .21769 .74125 .21471 .73739 .20917 Metetra
.664 .741 .908 r
.73739 .20917 .74125 .21471 .74979 .21171 .74595 .20616 Metetra
.664 .741 .908 r
.74595 .20616 .74979 .21171 .75836 .20871 .75454 .20314 Metetra
.664 .741 .908 r
.75454 .20314 .75836 .20871 .76696 .2057 .76315 .20011 Metetra
.664 .741 .908 r
.76315 .20011 .76696 .2057 .77558 .20268 .77179 .19707 Metetra
.664 .741 .908 r
.77179 .19707 .77558 .20268 .78423 .19965 .78046 .19403 Metetra
.664 .741 .908 r
.78046 .19403 .78423 .19965 .79291 .19661 .78915 .19097 Metetra
.664 .741 .908 r
.78915 .19097 .79291 .19661 .80161 .19356 .79787 .1879 Metetra
.664 .741 .908 r
.79787 .1879 .80161 .19356 .81033 .1905 .80662 .18483 Metetra
.672 .735 .898 r
.16663 .55904 .17174 .56402 .17911 .56126 .17401 .55627 Metetra
.672 .735 .897 r
.17401 .55627 .17911 .56126 .18649 .55849 .18141 .55348 Metetra
.673 .735 .897 r
.18141 .55348 .18649 .55849 .1939 .5557 .18882 .55067 Metetra
.673 .735 .897 r
.18882 .55067 .1939 .5557 .20132 .5529 .19626 .54785 Metetra
.673 .734 .896 r
.19626 .54785 .20132 .5529 .20877 .55007 .20372 .54501 Metetra
.674 .734 .896 r
.20372 .54501 .20877 .55007 .21623 .54724 .2112 .54215 Metetra
.674 .734 .895 r
.2112 .54215 .21623 .54724 .22372 .54438 .2187 .53928 Metetra
.675 .734 .895 r
.2187 .53928 .22372 .54438 .23122 .54151 .22621 .53639 Metetra
.675 .734 .895 r
.22621 .53639 .23122 .54151 .23875 .53862 .23375 .53348 Metetra
.676 .734 .894 r
.23375 .53348 .23875 .53862 .2463 .53571 .24131 .53055 Metetra
.676 .734 .894 r
.24131 .53055 .2463 .53571 .25387 .53278 .24889 .5276 Metetra
.677 .734 .893 r
.24889 .5276 .25387 .53278 .26145 .52983 .2565 .52463 Metetra
.677 .734 .893 r
.2565 .52463 .26145 .52983 .26906 .52687 .26412 .52164 Metetra
.678 .734 .892 r
.26412 .52164 .26906 .52687 .27669 .52388 .27176 .51863 Metetra
.678 .733 .892 r
.27176 .51863 .27669 .52388 .28434 .52087 .27942 .5156 Metetra
.679 .733 .891 r
.27942 .5156 .28434 .52087 .29201 .51784 .28711 .51255 Metetra
.679 .733 .891 r
.28711 .51255 .29201 .51784 .2997 .51478 .29481 .50947 Metetra
.68 .733 .89 r
.29481 .50947 .2997 .51478 .30742 .51171 .30254 .50638 Metetra
.681 .733 .89 r
.30254 .50638 .30742 .51171 .31515 .50861 .31028 .50325 Metetra
.681 .733 .889 r
.31028 .50325 .31515 .50861 .3229 .50548 .31805 .50011 Metetra
.682 .733 .889 r
.31805 .50011 .3229 .50548 .33068 .50233 .32584 .49693 Metetra
.683 .733 .888 r
.32584 .49693 .33068 .50233 .33847 .49915 .33364 .49373 Metetra
.684 .733 .888 r
.33364 .49373 .33847 .49915 .34629 .49595 .34147 .4905 Metetra
.685 .732 .887 r
.34147 .4905 .34629 .49595 .35412 .49271 .34932 .48725 Metetra
.685 .732 .886 r
.34932 .48725 .35412 .49271 .36198 .48945 .35719 .48396 Metetra
.686 .732 .886 r
.35719 .48396 .36198 .48945 .36986 .48616 .36509 .48064 Metetra
.687 .732 .885 r
.36509 .48064 .36986 .48616 .37775 .48284 .373 .47729 Metetra
.688 .732 .884 r
.373 .47729 .37775 .48284 .38567 .47948 .38093 .47391 Metetra
.689 .732 .883 r
.38093 .47391 .38567 .47948 .39361 .47609 .38888 .47049 Metetra
.69 .732 .882 r
.38888 .47049 .39361 .47609 .40157 .47266 .39686 .46704 Metetra
.691 .732 .882 r
.39686 .46704 .40157 .47266 .40955 .46919 .40485 .46355 Metetra
.692 .732 .881 r
.40485 .46355 .40955 .46919 .41755 .46569 .41287 .46001 Metetra
.694 .732 .88 r
.41287 .46001 .41755 .46569 .42557 .46214 .4209 .45644 Metetra
.695 .731 .879 r
.4209 .45644 .42557 .46214 .43361 .45855 .42896 .45282 Metetra
.696 .731 .878 r
.42896 .45282 .43361 .45855 .44168 .45492 .43704 .44916 Metetra
.698 .731 .876 r
.43704 .44916 .44168 .45492 .44976 .45123 .44513 .44544 Metetra
.699 .731 .875 r
.44513 .44544 .44976 .45123 .45786 .4475 .45325 .44168 Metetra
.701 .731 .874 r
.45325 .44168 .45786 .4475 .46598 .44371 .46138 .43786 Metetra
.702 .731 .873 r
.46138 .43786 .46598 .44371 .47412 .43987 .46954 .43398 Metetra
.704 .731 .871 r
.46954 .43398 .47412 .43987 .48227 .43597 .47771 .43004 Metetra
.706 .731 .87 r
.47771 .43004 .48227 .43597 .49045 .432 .4859 .42604 Metetra
.708 .731 .868 r
.4859 .42604 .49045 .432 .49865 .42796 .49411 .42197 Metetra
.71 .731 .867 r
.49411 .42197 .49865 .42796 .50686 .42385 .50234 .41782 Metetra
.713 .731 .865 r
.50234 .41782 .50686 .42385 .51509 .41966 .51059 .41359 Metetra
.715 .731 .863 r
.51059 .41359 .51509 .41966 .52334 .41539 .51885 .40927 Metetra
.718 .731 .861 r
.51885 .40927 .52334 .41539 .5316 .41102 .52713 .40487 Metetra
.72 .731 .859 r
.52713 .40487 .5316 .41102 .53988 .40656 .53543 .40036 Metetra
.723 .731 .856 r
.53543 .40036 .53988 .40656 .54818 .40198 .54374 .39574 Metetra
.727 .731 .854 r
.54374 .39574 .54818 .40198 .55649 .39729 .55207 .391 Metetra
.73 .731 .851 r
.55207 .391 .55649 .39729 .56481 .39247 .56041 .38612 Metetra
.734 .731 .848 r
.56041 .38612 .56481 .39247 .57315 .38751 .56876 .38111 Metetra
.738 .731 .845 r
.56876 .38111 .57315 .38751 .5815 .38239 .57712 .37593 Metetra
.742 .731 .841 r
.57712 .37593 .5815 .38239 .58985 .3771 .58549 .37057 Metetra
.747 .731 .837 r
.58549 .37057 .58985 .3771 .59822 .3716 .59387 .365 Metetra
.752 .731 .832 r
.59387 .365 .59822 .3716 .60659 .36588 .60226 .35921 Metetra
.758 .731 .827 r
.60226 .35921 .60659 .36588 .61496 .35991 .61065 .35315 Metetra
.765 .731 .821 r
.61065 .35315 .61496 .35991 .62334 .35364 .61904 .34679 Metetra
.772 .731 .815 r
.61904 .34679 .62334 .35364 .63171 .34703 .62742 .34008 Metetra
.78 .731 .807 r
.62742 .34008 .63171 .34703 .64007 .34002 .6358 .33294 Metetra
.789 .73 .798 r
.6358 .33294 .64007 .34002 .64841 .33252 .64415 .3253 Metetra
.799 .73 .788 r
.64415 .3253 .64841 .33252 .65673 .32442 .65249 .31703 Metetra
.811 .729 .775 r
.65249 .31703 .65673 .32442 .66501 .31557 .66078 .30796 Metetra
.824 .728 .759 r
.66078 .30796 .66501 .31557 .67324 .30572 .66902 .29783 Metetra
.84 .726 .738 r
.66902 .29783 .67324 .30572 .68139 .2945 .67717 .2862 Metetra
.86 .723 .71 r
.67717 .2862 .68139 .2945 .68941 .28118 .68517 .27222 Metetra
.887 .718 .666 r
.68517 .27222 .68941 .28118 .69718 .26403 .69289 .25357 Metetra
.937 .707 .564 r
.69289 .25357 .69718 .26403 .7041 .23329 .69943 .21563 Metetra
.606 .485 .69 r
.69943 .21563 .7041 .23329 .71185 .21815 .70791 .21264 Metetra
.664 .741 .908 r
.70791 .21264 .71185 .21815 .72034 .21517 .71642 .20964 Metetra
.664 .741 .908 r
.71642 .20964 .72034 .21517 .72885 .21217 .72495 .20663 Metetra
.664 .741 .908 r
.72495 .20663 .72885 .21217 .73739 .20917 .7335 .20361 Metetra
.664 .741 .908 r
.7335 .20361 .73739 .20917 .74595 .20616 .74208 .20058 Metetra
.664 .741 .908 r
.74208 .20058 .74595 .20616 .75454 .20314 .75069 .19754 Metetra
.664 .741 .908 r
.75069 .19754 .75454 .20314 .76315 .20011 .75932 .1945 Metetra
.664 .741 .908 r
.75932 .1945 .76315 .20011 .77179 .19707 .76798 .19144 Metetra
.664 .741 .908 r
.76798 .19144 .77179 .19707 .78046 .19403 .77667 .18838 Metetra
.664 .741 .908 r
.77667 .18838 .78046 .19403 .78915 .19097 .78538 .1853 Metetra
.664 .741 .908 r
.78538 .1853 .78915 .19097 .79787 .1879 .79412 .18222 Metetra
.664 .741 .908 r
.79412 .18222 .79787 .1879 .80662 .18483 .80288 .17913 Metetra
.672 .735 .898 r
.1615 .55405 .16663 .55904 .17401 .55627 .16889 .55125 Metetra
.672 .735 .897 r
.16889 .55125 .17401 .55627 .18141 .55348 .1763 .54845 Metetra
.673 .735 .897 r
.1763 .54845 .18141 .55348 .18882 .55067 .18373 .54562 Metetra
.673 .735 .897 r
.18373 .54562 .18882 .55067 .19626 .54785 .19118 .54278 Metetra
.674 .735 .896 r
.19118 .54278 .19626 .54785 .20372 .54501 .19865 .53992 Metetra
.674 .735 .896 r
.19865 .53992 .20372 .54501 .2112 .54215 .20614 .53705 Metetra
.674 .735 .895 r
.20614 .53705 .2112 .54215 .2187 .53928 .21365 .53415 Metetra
.675 .734 .895 r
.21365 .53415 .2187 .53928 .22621 .53639 .22118 .53124 Metetra
.675 .734 .895 r
.22118 .53124 .22621 .53639 .23375 .53348 .22873 .52831 Metetra
.676 .734 .894 r
.22873 .52831 .23375 .53348 .24131 .53055 .2363 .52536 Metetra
.676 .734 .894 r
.2363 .52536 .24131 .53055 .24889 .5276 .2439 .52239 Metetra
.677 .734 .893 r
.2439 .52239 .24889 .5276 .2565 .52463 .25151 .51941 Metetra
.677 .734 .893 r
.25151 .51941 .2565 .52463 .26412 .52164 .25915 .5164 Metetra
.678 .734 .892 r
.25915 .5164 .26412 .52164 .27176 .51863 .2668 .51337 Metetra
.679 .734 .892 r
.2668 .51337 .27176 .51863 .27942 .5156 .27448 .51032 Metetra
.679 .734 .892 r
.27448 .51032 .27942 .5156 .28711 .51255 .28217 .50724 Metetra
.68 .734 .891 r
.28217 .50724 .28711 .51255 .29481 .50947 .28989 .50415 Metetra
.68 .733 .89 r
.28989 .50415 .29481 .50947 .30254 .50638 .29763 .50102 Metetra
.681 .733 .89 r
.29763 .50102 .30254 .50638 .31028 .50325 .30539 .49788 Metetra
.682 .733 .889 r
.30539 .49788 .31028 .50325 .31805 .50011 .31317 .49471 Metetra
.683 .733 .889 r
.31317 .49471 .31805 .50011 .32584 .49693 .32097 .49151 Metetra
.683 .733 .888 r
.32097 .49151 .32584 .49693 .33364 .49373 .32879 .48829 Metetra
.684 .733 .888 r
.32879 .48829 .33364 .49373 .34147 .4905 .33664 .48504 Metetra
.685 .733 .887 r
.33664 .48504 .34147 .4905 .34932 .48725 .3445 .48176 Metetra
.686 .733 .886 r
.3445 .48176 .34932 .48725 .35719 .48396 .35239 .47845 Metetra
.687 .733 .885 r
.35239 .47845 .35719 .48396 .36509 .48064 .36029 .4751 Metetra
.688 .732 .885 r
.36029 .4751 .36509 .48064 .373 .47729 .36822 .47173 Metetra
.689 .732 .884 r
.36822 .47173 .373 .47729 .38093 .47391 .37616 .46832 Metetra
.69 .732 .883 r
.37616 .46832 .38093 .47391 .38888 .47049 .38413 .46488 Metetra
.691 .732 .882 r
.38413 .46488 .38888 .47049 .39686 .46704 .39212 .46139 Metetra
.692 .732 .881 r
.39212 .46139 .39686 .46704 .40485 .46355 .40013 .45787 Metetra
.693 .732 .881 r
.40013 .45787 .40485 .46355 .41287 .46001 .40816 .45431 Metetra
.694 .732 .88 r
.40816 .45431 .41287 .46001 .4209 .45644 .41621 .45071 Metetra
.696 .732 .879 r
.41621 .45071 .4209 .45644 .42896 .45282 .42428 .44706 Metetra
.697 .732 .877 r
.42428 .44706 .42896 .45282 .43704 .44916 .43237 .44337 Metetra
.698 .732 .876 r
.43237 .44337 .43704 .44916 .44513 .44544 .44048 .43963 Metetra
.7 .732 .875 r
.44048 .43963 .44513 .44544 .45325 .44168 .44861 .43583 Metetra
.701 .732 .874 r
.44861 .43583 .45325 .44168 .46138 .43786 .45676 .43198 Metetra
.703 .731 .873 r
.45676 .43198 .46138 .43786 .46954 .43398 .46493 .42807 Metetra
.705 .731 .871 r
.46493 .42807 .46954 .43398 .47771 .43004 .47312 .4241 Metetra
.707 .731 .87 r
.47312 .4241 .47771 .43004 .4859 .42604 .48133 .42006 Metetra
.709 .731 .868 r
.48133 .42006 .4859 .42604 .49411 .42197 .48955 .41595 Metetra
.711 .731 .867 r
.48955 .41595 .49411 .42197 .50234 .41782 .4978 .41176 Metetra
.713 .731 .865 r
.4978 .41176 .50234 .41782 .51059 .41359 .50606 .40749 Metetra
.716 .731 .863 r
.50606 .40749 .51059 .41359 .51885 .40927 .51434 .40314 Metetra
.718 .731 .861 r
.51434 .40314 .51885 .40927 .52713 .40487 .52264 .39868 Metetra
.721 .731 .858 r
.52264 .39868 .52713 .40487 .53543 .40036 .53095 .39413 Metetra
.724 .731 .856 r
.53095 .39413 .53543 .40036 .54374 .39574 .53928 .38946 Metetra
.728 .731 .853 r
.53928 .38946 .54374 .39574 .55207 .391 .54762 .38467 Metetra
.731 .731 .851 r
.54762 .38467 .55207 .391 .56041 .38612 .55598 .37975 Metetra
.735 .731 .847 r
.55598 .37975 .56041 .38612 .56876 .38111 .56434 .37467 Metetra
.739 .731 .844 r
.56434 .37467 .56876 .38111 .57712 .37593 .57272 .36943 Metetra
.744 .731 .84 r
.57272 .36943 .57712 .37593 .58549 .37057 .58111 .36401 Metetra
.749 .731 .836 r
.58111 .36401 .58549 .37057 .59387 .365 .58951 .35837 Metetra
.754 .731 .831 r
.58951 .35837 .59387 .365 .60226 .35921 .59791 .3525 Metetra
.76 .731 .826 r
.59791 .3525 .60226 .35921 .61065 .35315 .60631 .34636 Metetra
.766 .731 .82 r
.60631 .34636 .61065 .35315 .61904 .34679 .61472 .33991 Metetra
.774 .731 .813 r
.61472 .33991 .61904 .34679 .62742 .34008 .62312 .33308 Metetra
.782 .731 .805 r
.62312 .33308 .62742 .34008 .6358 .33294 .63151 .32583 Metetra
.791 .731 .796 r
.63151 .32583 .6358 .33294 .64415 .3253 .63988 .31804 Metetra
.802 .73 .785 r
.63988 .31804 .64415 .3253 .65249 .31703 .64822 .30959 Metetra
.814 .729 .772 r
.64822 .30959 .65249 .31703 .66078 .30796 .65653 .30029 Metetra
.828 .728 .755 r
.65653 .30029 .66078 .30796 .66902 .29783 .66477 .28986 Metetra
.845 .726 .733 r
.66477 .28986 .66902 .29783 .67717 .2862 .67292 .27778 Metetra
.866 .722 .702 r
.67292 .27778 .67717 .2862 .68517 .27222 .68092 .26302 Metetra
.896 .716 .651 r
.68092 .26302 .68517 .27222 .69289 .25357 .68855 .24234 Metetra
.919 .698 .587 r
.68855 .24234 .69289 .25357 .69943 .21563 .69546 .2101 Metetra
.664 .741 .908 r
.69546 .2101 .69943 .21563 .70791 .21264 .70396 .20709 Metetra
.664 .741 .908 r
.70396 .20709 .70791 .21264 .71642 .20964 .71248 .20407 Metetra
.664 .741 .908 r
.71248 .20407 .71642 .20964 .72495 .20663 .72103 .20105 Metetra
.664 .741 .908 r
.72103 .20105 .72495 .20663 .7335 .20361 .7296 .19801 Metetra
.664 .741 .908 r
.7296 .19801 .7335 .20361 .74208 .20058 .7382 .19497 Metetra
.664 .741 .908 r
.7382 .19497 .74208 .20058 .75069 .19754 .74682 .19191 Metetra
.664 .741 .908 r
.74682 .19191 .75069 .19754 .75932 .1945 .75547 .18885 Metetra
.664 .741 .908 r
.75547 .18885 .75932 .1945 .76798 .19144 .76415 .18578 Metetra
.664 .741 .908 r
.76415 .18578 .76798 .19144 .77667 .18838 .77286 .1827 Metetra
.664 .741 .908 r
.77286 .1827 .77667 .18838 .78538 .1853 .78159 .1796 Metetra
.664 .741 .908 r
.78159 .1796 .78538 .1853 .79412 .18222 .79034 .1765 Metetra
.664 .741 .908 r
.79034 .1765 .79412 .18222 .80288 .17913 .79913 .17339 Metetra
.672 .735 .898 r
.15634 .54903 .1615 .55405 .16889 .55125 .16374 .54622 Metetra
.673 .735 .897 r
.16374 .54622 .16889 .55125 .1763 .54845 .17116 .54339 Metetra
.673 .735 .897 r
.17116 .54339 .1763 .54845 .18373 .54562 .17861 .54055 Metetra
.673 .735 .897 r
.17861 .54055 .18373 .54562 .19118 .54278 .18607 .53769 Metetra
.674 .735 .896 r
.18607 .53769 .19118 .54278 .19865 .53992 .19355 .53481 Metetra
.674 .735 .896 r
.19355 .53481 .19865 .53992 .20614 .53705 .20105 .53192 Metetra
.675 .735 .895 r
.20105 .53192 .20614 .53705 .21365 .53415 .20858 .52901 Metetra
.675 .735 .895 r
.20858 .52901 .21365 .53415 .22118 .53124 .21612 .52608 Metetra
.676 .735 .895 r
.21612 .52608 .22118 .53124 .22873 .52831 .22368 .52313 Metetra
.676 .735 .894 r
.22368 .52313 .22873 .52831 .2363 .52536 .23127 .52016 Metetra
.677 .734 .894 r
.23127 .52016 .2363 .52536 .2439 .52239 .23888 .51717 Metetra
.677 .734 .893 r
.23888 .51717 .2439 .52239 .25151 .51941 .2465 .51416 Metetra
.678 .734 .893 r
.2465 .51416 .25151 .51941 .25915 .5164 .25415 .51113 Metetra
.678 .734 .892 r
.25415 .51113 .25915 .5164 .2668 .51337 .26182 .50808 Metetra
.679 .734 .892 r
.26182 .50808 .2668 .51337 .27448 .51032 .26951 .50501 Metetra
.68 .734 .892 r
.26951 .50501 .27448 .51032 .28217 .50724 .27722 .50191 Metetra
.68 .734 .891 r
.27722 .50191 .28217 .50724 .28989 .50415 .28495 .49879 Metetra
.681 .734 .89 r
.28495 .49879 .28989 .50415 .29763 .50102 .2927 .49565 Metetra
.682 .734 .89 r
.2927 .49565 .29763 .50102 .30539 .49788 .30047 .49248 Metetra
.682 .734 .889 r
.30047 .49248 .30539 .49788 .31317 .49471 .30827 .48929 Metetra
.683 .733 .889 r
.30827 .48929 .31317 .49471 .32097 .49151 .31608 .48607 Metetra
.684 .733 .888 r
.31608 .48607 .32097 .49151 .32879 .48829 .32392 .48282 Metetra
.685 .733 .888 r
.32392 .48282 .32879 .48829 .33664 .48504 .33178 .47955 Metetra
.685 .733 .887 r
.33178 .47955 .33664 .48504 .3445 .48176 .33965 .47624 Metetra
.686 .733 .886 r
.33965 .47624 .3445 .48176 .35239 .47845 .34755 .47291 Metetra
.687 .733 .885 r
.34755 .47291 .35239 .47845 .36029 .4751 .35547 .46954 Metetra
.688 .733 .885 r
.35547 .46954 .36029 .4751 .36822 .47173 .36341 .46614 Metetra
.689 .733 .884 r
.36341 .46614 .36822 .47173 .37616 .46832 .37137 .46271 Metetra
.69 .733 .883 r
.37137 .46271 .37616 .46832 .38413 .46488 .37936 .45924 Metetra
.691 .733 .882 r
.37936 .45924 .38413 .46488 .39212 .46139 .38736 .45573 Metetra
.692 .732 .881 r
.38736 .45573 .39212 .46139 .40013 .45787 .39538 .45218 Metetra
.694 .732 .88 r
.39538 .45218 .40013 .45787 .40816 .45431 .40343 .44859 Metetra
.695 .732 .879 r
.40343 .44859 .40816 .45431 .41621 .45071 .41149 .44496 Metetra
.696 .732 .878 r
.41149 .44496 .41621 .45071 .42428 .44706 .41958 .44129 Metetra
.697 .732 .877 r
.41958 .44129 .42428 .44706 .43237 .44337 .42768 .43756 Metetra
.699 .732 .876 r
.42768 .43756 .43237 .44337 .44048 .43963 .43581 .43379 Metetra
.7 .732 .875 r
.43581 .43379 .44048 .43963 .44861 .43583 .44396 .42996 Metetra
.702 .732 .874 r
.44396 .42996 .44861 .43583 .45676 .43198 .45212 .42607 Metetra
.704 .732 .872 r
.45212 .42607 .45676 .43198 .46493 .42807 .46031 .42213 Metetra
.706 .732 .871 r
.46031 .42213 .46493 .42807 .47312 .4241 .46851 .41812 Metetra
.708 .732 .87 r
.46851 .41812 .47312 .4241 .48133 .42006 .47673 .41405 Metetra
.71 .732 .868 r
.47673 .41405 .48133 .42006 .48955 .41595 .48498 .4099 Metetra
.712 .732 .866 r
.48498 .4099 .48955 .41595 .4978 .41176 .49324 .40568 Metetra
.714 .732 .864 r
.49324 .40568 .4978 .41176 .50606 .40749 .50151 .40137 Metetra
.717 .732 .862 r
.50151 .40137 .50606 .40749 .51434 .40314 .50981 .39697 Metetra
.719 .732 .86 r
.50981 .39697 .51434 .40314 .52264 .39868 .51812 .39248 Metetra
.722 .732 .858 r
.51812 .39248 .52264 .39868 .53095 .39413 .52645 .38788 Metetra
.725 .732 .856 r
.52645 .38788 .53095 .39413 .53928 .38946 .53479 .38316 Metetra
.729 .732 .853 r
.53479 .38316 .53928 .38946 .54762 .38467 .54315 .37832 Metetra
.732 .732 .85 r
.54315 .37832 .54762 .38467 .55598 .37975 .55152 .37334 Metetra
.736 .732 .847 r
.55152 .37334 .55598 .37975 .56434 .37467 .55991 .36821 Metetra
.74 .732 .843 r
.55991 .36821 .56434 .37467 .57272 .36943 .5683 .36291 Metetra
.745 .732 .84 r
.5683 .36291 .57272 .36943 .58111 .36401 .57671 .35742 Metetra
.75 .732 .835 r
.57671 .35742 .58111 .36401 .58951 .35837 .58512 .35171 Metetra
.756 .732 .83 r
.58512 .35171 .58951 .35837 .59791 .3525 .59354 .34576 Metetra
.762 .732 .825 r
.59354 .34576 .59791 .3525 .60631 .34636 .60196 .33953 Metetra
.768 .732 .819 r
.60196 .33953 .60631 .34636 .61472 .33991 .61038 .33298 Metetra
.776 .732 .812 r
.61038 .33298 .61472 .33991 .62312 .33308 .61879 .32605 Metetra
.784 .731 .804 r
.61879 .32605 .62312 .33308 .63151 .32583 .6272 .31866 Metetra
.794 .731 .794 r
.6272 .31866 .63151 .32583 .63988 .31804 .63558 .31072 Metetra
.804 .731 .783 r
.63558 .31072 .63988 .31804 .64822 .30959 .64394 .30208 Metetra
.817 .73 .768 r
.64394 .30208 .64822 .30959 .65653 .30029 .65226 .29254 Metetra
.831 .728 .751 r
.65226 .29254 .65653 .30029 .66477 .28986 .66051 .28178 Metetra
.849 .726 .727 r
.66051 .28178 .66477 .28986 .67292 .27778 .66866 .26921 Metetra
.872 .722 .693 r
.66866 .26921 .67292 .27778 .68092 .26302 .67663 .25352 Metetra
.907 .715 .63 r
.67663 .25352 .68092 .26302 .68855 .24234 .68413 .22977 Metetra
.883 .676 .619 r
.68413 .22977 .68855 .24234 .69546 .2101 .69146 .20454 Metetra
.664 .741 .908 r
.69146 .20454 .69546 .2101 .70396 .20709 .69998 .20151 Metetra
.664 .741 .908 r
.69998 .20151 .70396 .20709 .71248 .20407 .70852 .19848 Metetra
.664 .741 .908 r
.70852 .19848 .71248 .20407 .72103 .20105 .71708 .19543 Metetra
.664 .741 .908 r
.71708 .19543 .72103 .20105 .7296 .19801 .72567 .19238 Metetra
.664 .741 .908 r
.72567 .19238 .7296 .19801 .7382 .19497 .73429 .18932 Metetra
.664 .741 .908 r
.73429 .18932 .7382 .19497 .74682 .19191 .74293 .18625 Metetra
.664 .741 .908 r
.74293 .18625 .74682 .19191 .75547 .18885 .7516 .18317 Metetra
.664 .741 .908 r
.7516 .18317 .75547 .18885 .76415 .18578 .7603 .18008 Metetra
.664 .741 .908 r
.7603 .18008 .76415 .18578 .77286 .1827 .76902 .17698 Metetra
.664 .741 .908 r
.76902 .17698 .77286 .1827 .78159 .1796 .77777 .17387 Metetra
.664 .741 .908 r
.77777 .17387 .78159 .1796 .79034 .1765 .78655 .17076 Metetra
.664 .741 .908 r
.78655 .17076 .79034 .1765 .79913 .17339 .79535 .16763 Metetra
.672 .736 .898 r
.15116 .544 .15634 .54903 .16374 .54622 .15857 .54117 Metetra
.673 .736 .897 r
.15857 .54117 .16374 .54622 .17116 .54339 .166 .53832 Metetra
.673 .735 .897 r
.166 .53832 .17116 .54339 .17861 .54055 .17346 .53546 Metetra
.674 .735 .897 r
.17346 .53546 .17861 .54055 .18607 .53769 .18093 .53258 Metetra
.674 .735 .896 r
.18093 .53258 .18607 .53769 .19355 .53481 .18843 .52969 Metetra
.675 .735 .896 r
.18843 .52969 .19355 .53481 .20105 .53192 .19594 .52677 Metetra
.675 .735 .896 r
.19594 .52677 .20105 .53192 .20858 .52901 .20348 .52384 Metetra
.675 .735 .895 r
.20348 .52384 .20858 .52901 .21612 .52608 .21103 .52089 Metetra
.676 .735 .895 r
.21103 .52089 .21612 .52608 .22368 .52313 .21861 .51792 Metetra
.676 .735 .894 r
.21861 .51792 .22368 .52313 .23127 .52016 .22621 .51493 Metetra
.677 .735 .894 r
.22621 .51493 .23127 .52016 .23888 .51717 .23383 .51192 Metetra
.678 .735 .893 r
.23383 .51192 .23888 .51717 .2465 .51416 .24147 .50889 Metetra
.678 .734 .893 r
.24147 .50889 .2465 .51416 .25415 .51113 .24913 .50584 Metetra
.679 .734 .893 r
.24913 .50584 .25415 .51113 .26182 .50808 .25681 .50277 Metetra
.679 .734 .892 r
.25681 .50277 .26182 .50808 .26951 .50501 .26451 .49968 Metetra
.68 .734 .892 r
.26451 .49968 .26951 .50501 .27722 .50191 .27224 .49656 Metetra
.681 .734 .891 r
.27224 .49656 .27722 .50191 .28495 .49879 .27998 .49342 Metetra
.681 .734 .89 r
.27998 .49342 .28495 .49879 .2927 .49565 .28775 .49026 Metetra
.682 .734 .89 r
.28775 .49026 .2927 .49565 .30047 .49248 .29553 .48707 Metetra
.683 .734 .889 r
.29553 .48707 .30047 .49248 .30827 .48929 .30334 .48385 Metetra
.683 .734 .889 r
.30334 .48385 .30827 .48929 .31608 .48607 .31117 .48061 Metetra
.684 .734 .888 r
.31117 .48061 .31608 .48607 .32392 .48282 .31902 .47734 Metetra
.685 .734 .887 r
.31902 .47734 .32392 .48282 .33178 .47955 .32689 .47404 Metetra
.686 .733 .887 r
.32689 .47404 .33178 .47955 .33965 .47624 .33478 .47071 Metetra
.687 .733 .886 r
.33478 .47071 .33965 .47624 .34755 .47291 .34269 .46735 Metetra
.688 .733 .885 r
.34269 .46735 .34755 .47291 .35547 .46954 .35063 .46396 Metetra
.689 .733 .885 r
.35063 .46396 .35547 .46954 .36341 .46614 .35858 .46053 Metetra
.69 .733 .884 r
.35858 .46053 .36341 .46614 .37137 .46271 .36656 .45707 Metetra
.691 .733 .883 r
.36656 .45707 .37137 .46271 .37936 .45924 .37456 .45357 Metetra
.692 .733 .882 r
.37456 .45357 .37936 .45924 .38736 .45573 .38257 .45004 Metetra
.693 .733 .881 r
.38257 .45004 .38736 .45573 .39538 .45218 .39061 .44647 Metetra
.694 .733 .88 r
.39061 .44647 .39538 .45218 .40343 .44859 .39867 .44285 Metetra
.695 .733 .879 r
.39867 .44285 .40343 .44859 .41149 .44496 .40675 .43919 Metetra
.697 .733 .878 r
.40675 .43919 .41149 .44496 .41958 .44129 .41485 .43548 Metetra
.698 .732 .877 r
.41485 .43548 .41958 .44129 .42768 .43756 .42297 .43173 Metetra
.7 .732 .876 r
.42297 .43173 .42768 .43756 .43581 .43379 .43111 .42792 Metetra
.701 .732 .875 r
.43111 .42792 .43581 .43379 .44396 .42996 .43928 .42406 Metetra
.703 .732 .874 r
.43928 .42406 .44396 .42996 .45212 .42607 .44746 .42015 Metetra
.704 .732 .872 r
.44746 .42015 .45212 .42607 .46031 .42213 .45566 .41617 Metetra
.706 .732 .871 r
.45566 .41617 .46031 .42213 .46851 .41812 .46388 .41213 Metetra
.708 .732 .869 r
.46388 .41213 .46851 .41812 .47673 .41405 .47212 .40801 Metetra
.71 .732 .868 r
.47212 .40801 .47673 .41405 .48498 .4099 .48037 .40383 Metetra
.713 .732 .866 r
.48037 .40383 .48498 .4099 .49324 .40568 .48865 .39957 Metetra
.715 .732 .864 r
.48865 .39957 .49324 .40568 .50151 .40137 .49694 .39522 Metetra
.718 .732 .862 r
.49694 .39522 .50151 .40137 .50981 .39697 .50525 .39078 Metetra
.72 .732 .86 r
.50525 .39078 .50981 .39697 .51812 .39248 .51358 .38624 Metetra
.723 .732 .858 r
.51358 .38624 .51812 .39248 .52645 .38788 .52193 .3816 Metetra
.726 .732 .855 r
.52193 .3816 .52645 .38788 .53479 .38316 .53029 .37683 Metetra
.73 .732 .853 r
.53029 .37683 .53479 .38316 .54315 .37832 .53866 .37194 Metetra
.733 .732 .85 r
.53866 .37194 .54315 .37832 .55152 .37334 .54705 .36691 Metetra
.737 .732 .846 r
.54705 .36691 .55152 .37334 .55991 .36821 .55545 .36172 Metetra
.742 .732 .843 r
.55545 .36172 .55991 .36821 .5683 .36291 .56386 .35635 Metetra
.746 .732 .839 r
.56386 .35635 .5683 .36291 .57671 .35742 .57228 .3508 Metetra
.751 .732 .834 r
.57228 .3508 .57671 .35742 .58512 .35171 .58071 .34502 Metetra
.757 .732 .83 r
.58071 .34502 .58512 .35171 .59354 .34576 .58915 .33899 Metetra
.763 .732 .824 r
.58915 .33899 .59354 .34576 .60196 .33953 .59758 .33267 Metetra
.77 .732 .818 r
.59758 .33267 .60196 .33953 .61038 .33298 .60602 .32602 Metetra
.778 .732 .81 r
.60602 .32602 .61038 .33298 .61879 .32605 .61445 .31897 Metetra
.786 .732 .802 r
.61445 .31897 .61879 .32605 .6272 .31866 .62287 .31145 Metetra
.796 .731 .792 r
.62287 .31145 .6272 .31866 .63558 .31072 .63127 .30335 Metetra
.807 .731 .78 r
.63127 .30335 .63558 .31072 .64394 .30208 .63964 .29451 Metetra
.82 .73 .765 r
.63964 .29451 .64394 .30208 .65226 .29254 .64797 .28472 Metetra
.835 .728 .746 r
.64797 .28472 .65226 .29254 .66051 .28178 .65623 .2736 Metetra
.854 .725 .721 r
.65623 .2736 .66051 .28178 .66866 .26921 .66437 .26046 Metetra
.878 .721 .682 r
.66437 .26046 .66866 .26921 .67663 .25352 .67231 .24364 Metetra
.925 .712 .597 r
.67231 .24364 .67663 .25352 .68413 .22977 .67954 .21372 Metetra
.778 .6 .658 r
.67954 .21372 .68413 .22977 .69146 .20454 .68744 .19895 Metetra
.664 .741 .908 r
.68744 .19895 .69146 .20454 .69998 .20151 .69597 .1959 Metetra
.664 .741 .908 r
.69597 .1959 .69998 .20151 .70852 .19848 .70453 .19285 Metetra
.664 .741 .908 r
.70453 .19285 .70852 .19848 .71708 .19543 .71312 .18979 Metetra
.664 .741 .908 r
.71312 .18979 .71708 .19543 .72567 .19238 .72172 .18672 Metetra
.664 .741 .908 r
.72172 .18672 .72567 .19238 .73429 .18932 .73036 .18364 Metetra
.664 .741 .908 r
.73036 .18364 .73429 .18932 .74293 .18625 .73902 .18056 Metetra
.664 .741 .908 r
.73902 .18056 .74293 .18625 .7516 .18317 .74771 .17746 Metetra
.664 .741 .908 r
.74771 .17746 .7516 .18317 .7603 .18008 .75642 .17435 Metetra
.664 .741 .908 r
.75642 .17435 .7603 .18008 .76902 .17698 .76517 .17124 Metetra
.664 .741 .908 r
.76517 .17124 .76902 .17698 .77777 .17387 .77393 .16811 Metetra
.664 .741 .908 r
.77393 .16811 .77777 .17387 .78655 .17076 .78273 .16497 Metetra
.664 .741 .908 r
.78273 .16497 .78655 .17076 .79535 .16763 .79155 .16183 Metetra
.673 .736 .898 r
.14595 .53894 .15116 .544 .15857 .54117 .15337 .53609 Metetra
.673 .736 .897 r
.15337 .53609 .15857 .54117 .166 .53832 .16082 .53323 Metetra
.674 .736 .897 r
.16082 .53323 .166 .53832 .17346 .53546 .16828 .53035 Metetra
.674 .736 .897 r
.16828 .53035 .17346 .53546 .18093 .53258 .17577 .52745 Metetra
.674 .736 .896 r
.17577 .52745 .18093 .53258 .18843 .52969 .18328 .52454 Metetra
.675 .735 .896 r
.18328 .52454 .18843 .52969 .19594 .52677 .1908 .5216 Metetra
.675 .735 .896 r
.1908 .5216 .19594 .52677 .20348 .52384 .19835 .51865 Metetra
.676 .735 .895 r
.19835 .51865 .20348 .52384 .21103 .52089 .20592 .51568 Metetra
.676 .735 .895 r
.20592 .51568 .21103 .52089 .21861 .51792 .21351 .51269 Metetra
.677 .735 .894 r
.21351 .51269 .21861 .51792 .22621 .51493 .22112 .50968 Metetra
.677 .735 .894 r
.22112 .50968 .22621 .51493 .23383 .51192 .22875 .50666 Metetra
.678 .735 .893 r
.22875 .50666 .23383 .51192 .24147 .50889 .23641 .50361 Metetra
.678 .735 .893 r
.23641 .50361 .24147 .50889 .24913 .50584 .24408 .50054 Metetra
.679 .735 .893 r
.24408 .50054 .24913 .50584 .25681 .50277 .25178 .49744 Metetra
.68 .735 .892 r
.25178 .49744 .25681 .50277 .26451 .49968 .25949 .49433 Metetra
.68 .734 .892 r
.25949 .49433 .26451 .49968 .27224 .49656 .26723 .49119 Metetra
.681 .734 .891 r
.26723 .49119 .27224 .49656 .27998 .49342 .27499 .48803 Metetra
.682 .734 .89 r
.27499 .48803 .27998 .49342 .28775 .49026 .28277 .48484 Metetra
.682 .734 .89 r
.28277 .48484 .28775 .49026 .29553 .48707 .29057 .48163 Metetra
.683 .734 .889 r
.29057 .48163 .29553 .48707 .30334 .48385 .29839 .47839 Metetra
.684 .734 .889 r
.29839 .47839 .30334 .48385 .31117 .48061 .30623 .47512 Metetra
.684 .734 .888 r
.30623 .47512 .31117 .48061 .31902 .47734 .31409 .47183 Metetra
.685 .734 .887 r
.31409 .47183 .31902 .47734 .32689 .47404 .32198 .46851 Metetra
.686 .734 .887 r
.32198 .46851 .32689 .47404 .33478 .47071 .32988 .46515 Metetra
.687 .734 .886 r
.32988 .46515 .33478 .47071 .34269 .46735 .33781 .46177 Metetra
.688 .734 .885 r
.33781 .46177 .34269 .46735 .35063 .46396 .34576 .45835 Metetra
.689 .733 .885 r
.34576 .45835 .35063 .46396 .35858 .46053 .35373 .4549 Metetra
.69 .733 .884 r
.35373 .4549 .35858 .46053 .36656 .45707 .36172 .45141 Metetra
.691 .733 .883 r
.36172 .45141 .36656 .45707 .37456 .45357 .36973 .44789 Metetra
.692 .733 .882 r
.36973 .44789 .37456 .45357 .38257 .45004 .37777 .44433 Metetra
.693 .733 .881 r
.37777 .44433 .38257 .45004 .39061 .44647 .38582 .44072 Metetra
.695 .733 .88 r
.38582 .44072 .39061 .44647 .39867 .44285 .39389 .43708 Metetra
.696 .733 .879 r
.39389 .43708 .39867 .44285 .40675 .43919 .40199 .43339 Metetra
.697 .733 .878 r
.40199 .43339 .40675 .43919 .41485 .43548 .4101 .42965 Metetra
.699 .733 .877 r
.4101 .42965 .41485 .43548 .42297 .43173 .41824 .42587 Metetra
.7 .733 .876 r
.41824 .42587 .42297 .43173 .43111 .42792 .4264 .42203 Metetra
.702 .733 .875 r
.4264 .42203 .43111 .42792 .43928 .42406 .43457 .41814 Metetra
.703 .733 .873 r
.43457 .41814 .43928 .42406 .44746 .42015 .44277 .41419 Metetra
.705 .733 .872 r
.44277 .41419 .44746 .42015 .45566 .41617 .45098 .41018 Metetra
.707 .733 .871 r
.45098 .41018 .45566 .41617 .46388 .41213 .45922 .4061 Metetra
.709 .732 .869 r
.45922 .4061 .46388 .41213 .47212 .40801 .46747 .40196 Metetra
.711 .732 .867 r
.46747 .40196 .47212 .40801 .48037 .40383 .47575 .39773 Metetra
.713 .732 .866 r
.47575 .39773 .48037 .40383 .48865 .39957 .48404 .39343 Metetra
.716 .732 .864 r
.48404 .39343 .48865 .39957 .49694 .39522 .49235 .38904 Metetra
.718 .732 .862 r
.49235 .38904 .49694 .39522 .50525 .39078 .50068 .38456 Metetra
.721 .732 .86 r
.50068 .38456 .50525 .39078 .51358 .38624 .50902 .37998 Metetra
.724 .732 .857 r
.50902 .37998 .51358 .38624 .52193 .3816 .51738 .37529 Metetra
.727 .732 .855 r
.51738 .37529 .52193 .3816 .53029 .37683 .52576 .37047 Metetra
.731 .732 .852 r
.52576 .37047 .53029 .37683 .53866 .37194 .53415 .36553 Metetra
.735 .732 .849 r
.53415 .36553 .53866 .37194 .54705 .36691 .54256 .36044 Metetra
.739 .732 .846 r
.54256 .36044 .54705 .36691 .55545 .36172 .55097 .3552 Metetra
.743 .732 .842 r
.55097 .3552 .55545 .36172 .56386 .35635 .5594 .34977 Metetra
.748 .733 .838 r
.5594 .34977 .56386 .35635 .57228 .3508 .56784 .34414 Metetra
.753 .733 .834 r
.56784 .34414 .57228 .3508 .58071 .34502 .57629 .33829 Metetra
.759 .733 .829 r
.57629 .33829 .58071 .34502 .58915 .33899 .58474 .33218 Metetra
.765 .733 .823 r
.58474 .33218 .58915 .33899 .59758 .33267 .59319 .32577 Metetra
.772 .732 .816 r
.59319 .32577 .59758 .33267 .60602 .32602 .60164 .31902 Metetra
.78 .732 .809 r
.60164 .31902 .60602 .32602 .61445 .31897 .61009 .31185 Metetra
.789 .732 .8 r
.61009 .31185 .61445 .31897 .62287 .31145 .61852 .30419 Metetra
.799 .732 .79 r
.61852 .30419 .62287 .31145 .63127 .30335 .62694 .29592 Metetra
.81 .731 .777 r
.62694 .29592 .63127 .30335 .63964 .29451 .63532 .28688 Metetra
.823 .73 .761 r
.63532 .28688 .63964 .29451 .64797 .28472 .64366 .27681 Metetra
.839 .728 .741 r
.64366 .27681 .64797 .28472 .65623 .2736 .65192 .2653 Metetra
.859 .725 .714 r
.65192 .2653 .65623 .2736 .66437 .26046 .66007 .25152 Metetra
.886 .719 .67 r
.66007 .25152 .66437 .26046 .67231 .24364 .66796 .23325 Metetra
.936 .708 .569 r
.66796 .23325 .67231 .24364 .67954 .21372 .67488 .19637 Metetra
.606 .488 .693 r
.67488 .19637 .67954 .21372 .68744 .19895 .6834 .19332 Metetra
.664 .741 .908 r
.6834 .19332 .68744 .19895 .69597 .1959 .69195 .19026 Metetra
.664 .741 .908 r
.69195 .19026 .69597 .1959 .70453 .19285 .70053 .1872 Metetra
.664 .741 .908 r
.70053 .1872 .70453 .19285 .71312 .18979 .70913 .18412 Metetra
.664 .741 .908 r
.70913 .18412 .71312 .18979 .72172 .18672 .71775 .18103 Metetra
.664 .741 .908 r
.71775 .18103 .72172 .18672 .73036 .18364 .72641 .17794 Metetra
.664 .741 .908 r
.72641 .17794 .73036 .18364 .73902 .18056 .73509 .17483 Metetra
.664 .741 .908 r
.73509 .17483 .73902 .18056 .74771 .17746 .74379 .17172 Metetra
.664 .741 .908 r
.74379 .17172 .74771 .17746 .75642 .17435 .75253 .16859 Metetra
.664 .741 .908 r
.75253 .16859 .75642 .17435 .76517 .17124 .76129 .16546 Metetra
.664 .741 .908 r
.76129 .16546 .76517 .17124 .77393 .16811 .77007 .16231 Metetra
.664 .741 .908 r
.77007 .16231 .77393 .16811 .78273 .16497 .77889 .15916 Metetra
.664 .741 .908 r
.77889 .15916 .78273 .16497 .79155 .16183 .78773 .156 Metetra
.673 .736 .898 r
.14071 .53387 .14595 .53894 .15337 .53609 .14815 .531 Metetra
.673 .736 .897 r
.14815 .531 .15337 .53609 .16082 .53323 .15561 .52812 Metetra
.674 .736 .897 r
.15561 .52812 .16082 .53323 .16828 .53035 .16308 .52522 Metetra
.674 .736 .897 r
.16308 .52522 .16828 .53035 .17577 .52745 .17058 .5223 Metetra
.675 .736 .896 r
.17058 .5223 .17577 .52745 .18328 .52454 .1781 .51937 Metetra
.675 .736 .896 r
.1781 .51937 .18328 .52454 .1908 .5216 .18564 .51641 Metetra
.676 .736 .896 r
.18564 .51641 .1908 .5216 .19835 .51865 .1932 .51344 Metetra
.676 .735 .895 r
.1932 .51344 .19835 .51865 .20592 .51568 .20078 .51045 Metetra
.677 .735 .895 r
.20078 .51045 .20592 .51568 .21351 .51269 .20839 .50745 Metetra
.677 .735 .894 r
.20839 .50745 .21351 .51269 .22112 .50968 .21601 .50442 Metetra
.678 .735 .894 r
.21601 .50442 .22112 .50968 .22875 .50666 .22366 .50137 Metetra
.678 .735 .893 r
.22366 .50137 .22875 .50666 .23641 .50361 .23132 .4983 Metetra
.679 .735 .893 r
.23132 .4983 .23641 .50361 .24408 .50054 .23901 .4952 Metetra
.679 .735 .893 r
.23901 .4952 .24408 .50054 .25178 .49744 .24672 .49209 Metetra
.68 .735 .892 r
.24672 .49209 .25178 .49744 .25949 .49433 .25445 .48895 Metetra
.681 .735 .892 r
.25445 .48895 .25949 .49433 .26723 .49119 .2622 .48579 Metetra
.681 .735 .891 r
.2622 .48579 .26723 .49119 .27499 .48803 .26997 .48261 Metetra
.682 .735 .89 r
.26997 .48261 .27499 .48803 .28277 .48484 .27776 .4794 Metetra
.683 .734 .89 r
.27776 .4794 .28277 .48484 .29057 .48163 .28557 .47616 Metetra
.683 .734 .889 r
.28557 .47616 .29057 .48163 .29839 .47839 .29341 .4729 Metetra
.684 .734 .889 r
.29341 .4729 .29839 .47839 .30623 .47512 .30127 .46961 Metetra
.685 .734 .888 r
.30127 .46961 .30623 .47512 .31409 .47183 .30914 .4663 Metetra
.686 .734 .887 r
.30914 .4663 .31409 .47183 .32198 .46851 .31704 .46295 Metetra
.687 .734 .887 r
.31704 .46295 .32198 .46851 .32988 .46515 .32496 .45957 Metetra
.687 .734 .886 r
.32496 .45957 .32988 .46515 .33781 .46177 .33291 .45616 Metetra
.688 .734 .885 r
.33291 .45616 .33781 .46177 .34576 .45835 .34087 .45272 Metetra
.689 .734 .885 r
.34087 .45272 .34576 .45835 .35373 .4549 .34885 .44924 Metetra
.69 .734 .884 r
.34885 .44924 .35373 .4549 .36172 .45141 .35686 .44573 Metetra
.691 .734 .883 r
.35686 .44573 .36172 .45141 .36973 .44789 .36488 .44218 Metetra
.693 .733 .882 r
.36488 .44218 .36973 .44789 .37777 .44433 .37293 .43859 Metetra
.694 .733 .881 r
.37293 .43859 .37777 .44433 .38582 .44072 .381 .43496 Metetra
.695 .733 .88 r
.381 .43496 .38582 .44072 .39389 .43708 .38909 .43129 Metetra
.696 .733 .879 r
.38909 .43129 .39389 .43708 .40199 .43339 .3972 .42757 Metetra
.698 .733 .878 r
.3972 .42757 .40199 .43339 .4101 .42965 .40533 .4238 Metetra
.699 .733 .877 r
.40533 .4238 .4101 .42965 .41824 .42587 .41348 .41999 Metetra
.701 .733 .876 r
.41348 .41999 .41824 .42587 .4264 .42203 .42165 .41612 Metetra
.702 .733 .875 r
.42165 .41612 .4264 .42203 .43457 .41814 .42984 .41219 Metetra
.704 .733 .873 r
.42984 .41219 .43457 .41814 .44277 .41419 .43806 .40821 Metetra
.706 .733 .872 r
.43806 .40821 .44277 .41419 .45098 .41018 .44629 .40417 Metetra
.708 .733 .87 r
.44629 .40417 .45098 .41018 .45922 .4061 .45454 .40005 Metetra
.71 .733 .869 r
.45454 .40005 .45922 .4061 .46747 .40196 .46281 .39587 Metetra
.712 .733 .867 r
.46281 .39587 .46747 .40196 .47575 .39773 .4711 .39161 Metetra
.714 .733 .865 r
.4711 .39161 .47575 .39773 .48404 .39343 .47941 .38727 Metetra
.717 .733 .864 r
.47941 .38727 .48404 .39343 .49235 .38904 .48774 .38284 Metetra
.719 .733 .862 r
.48774 .38284 .49235 .38904 .50068 .38456 .49608 .37832 Metetra
.722 .733 .859 r
.49608 .37832 .50068 .38456 .50902 .37998 .50444 .37369 Metetra
.725 .733 .857 r
.50444 .37369 .50902 .37998 .51738 .37529 .51282 .36895 Metetra
.728 .733 .854 r
.51282 .36895 .51738 .37529 .52576 .37047 .52121 .36409 Metetra
.732 .733 .852 r
.52121 .36409 .52576 .37047 .53415 .36553 .52962 .35909 Metetra
.736 .733 .848 r
.52962 .35909 .53415 .36553 .54256 .36044 .53804 .35395 Metetra
.74 .733 .845 r
.53804 .35395 .54256 .36044 .55097 .3552 .54647 .34864 Metetra
.744 .733 .841 r
.54647 .34864 .55097 .3552 .5594 .34977 .55492 .34315 Metetra
.749 .733 .837 r
.55492 .34315 .5594 .34977 .56784 .34414 .56337 .33746 Metetra
.754 .733 .833 r
.56337 .33746 .56784 .34414 .57629 .33829 .57184 .33153 Metetra
.76 .733 .827 r
.57184 .33153 .57629 .33829 .58474 .33218 .5803 .32533 Metetra
.767 .733 .822 r
.5803 .32533 .58474 .33218 .59319 .32577 .58877 .31883 Metetra
.774 .733 .815 r
.58877 .31883 .59319 .32577 .60164 .31902 .59724 .31197 Metetra
.782 .733 .807 r
.59724 .31197 .60164 .31902 .61009 .31185 .6057 .30469 Metetra
.791 .732 .798 r
.6057 .30469 .61009 .31185 .61852 .30419 .61415 .29688 Metetra
.801 .732 .787 r
.61415 .29688 .61852 .30419 .62694 .29592 .62258 .28844 Metetra
.813 .731 .774 r
.62258 .28844 .62694 .29592 .63532 .28688 .63098 .27918 Metetra
.827 .73 .758 r
.63098 .27918 .63532 .28688 .64366 .27681 .63933 .26882 Metetra
.843 .728 .736 r
.63933 .26882 .64366 .27681 .65192 .2653 .6476 .25687 Metetra
.864 .724 .706 r
.6476 .25687 .65192 .2653 .66007 .25152 .65573 .24233 Metetra
.895 .718 .655 r
.65573 .24233 .66007 .25152 .66796 .23325 .66357 .2221 Metetra
.918 .7 .592 r
.66357 .2221 .66796 .23325 .67488 .19637 .6708 .19074 Metetra
.664 .741 .908 r
.6708 .19074 .67488 .19637 .6834 .19332 .67934 .18767 Metetra
.664 .741 .908 r
.67934 .18767 .6834 .19332 .69195 .19026 .6879 .18459 Metetra
.664 .741 .908 r
.6879 .18459 .69195 .19026 .70053 .1872 .6965 .18151 Metetra
.664 .741 .908 r
.6965 .18151 .70053 .1872 .70913 .18412 .70512 .17841 Metetra
.664 .741 .908 r
.70512 .17841 .70913 .18412 .71775 .18103 .71376 .17531 Metetra
.664 .741 .908 r
.71376 .17531 .71775 .18103 .72641 .17794 .72243 .1722 Metetra
.664 .741 .908 r
.72243 .1722 .72641 .17794 .73509 .17483 .73113 .16907 Metetra
.664 .741 .908 r
.73113 .16907 .73509 .17483 .74379 .17172 .73986 .16594 Metetra
.664 .741 .908 r
.73986 .16594 .74379 .17172 .75253 .16859 .74861 .1628 Metetra
.664 .741 .908 r
.74861 .1628 .75253 .16859 .76129 .16546 .75739 .15965 Metetra
.664 .741 .908 r
.75739 .15965 .76129 .16546 .77007 .16231 .76619 .15648 Metetra
.664 .741 .908 r
.76619 .15648 .77007 .16231 .77889 .15916 .77503 .15331 Metetra
.664 .741 .908 r
.77503 .15331 .77889 .15916 .78773 .156 .78389 .15013 Metetra
.673 .736 .898 r
.13545 .52877 .14071 .53387 .14815 .531 .1429 .52588 Metetra
.674 .736 .897 r
.1429 .52588 .14815 .531 .15561 .52812 .15037 .52298 Metetra
.674 .736 .897 r
.15037 .52298 .15561 .52812 .16308 .52522 .15786 .52006 Metetra
.674 .736 .897 r
.15786 .52006 .16308 .52522 .17058 .5223 .16537 .51713 Metetra
.675 .736 .896 r
.16537 .51713 .17058 .5223 .1781 .51937 .1729 .51418 Metetra
.675 .736 .896 r
.1729 .51418 .1781 .51937 .18564 .51641 .18045 .5112 Metetra
.676 .736 .896 r
.18045 .5112 .18564 .51641 .1932 .51344 .18803 .50821 Metetra
.676 .736 .895 r
.18803 .50821 .1932 .51344 .20078 .51045 .19562 .5052 Metetra
.677 .736 .895 r
.19562 .5052 .20078 .51045 .20839 .50745 .20324 .50217 Metetra
.677 .736 .894 r
.20324 .50217 .20839 .50745 .21601 .50442 .21087 .49913 Metetra
.678 .735 .894 r
.21087 .49913 .21601 .50442 .22366 .50137 .21853 .49606 Metetra
.678 .735 .893 r
.21853 .49606 .22366 .50137 .23132 .4983 .22621 .49296 Metetra
.679 .735 .893 r
.22621 .49296 .23132 .4983 .23901 .4952 .23391 .48985 Metetra
.68 .735 .893 r
.23391 .48985 .23901 .4952 .24672 .49209 .24163 .48672 Metetra
.68 .735 .892 r
.24163 .48672 .24672 .49209 .25445 .48895 .24937 .48356 Metetra
.681 .735 .892 r
.24937 .48356 .25445 .48895 .2622 .48579 .25714 .48038 Metetra
.681 .735 .891 r
.25714 .48038 .2622 .48579 .26997 .48261 .26492 .47717 Metetra
.682 .735 .89 r
.26492 .47717 .26997 .48261 .27776 .4794 .27273 .47394 Metetra
.683 .735 .89 r
.27273 .47394 .27776 .4794 .28557 .47616 .28056 .47068 Metetra
.684 .735 .889 r
.28056 .47068 .28557 .47616 .29341 .4729 .28841 .46739 Metetra
.684 .735 .889 r
.28841 .46739 .29341 .4729 .30127 .46961 .29628 .46408 Metetra
.685 .734 .888 r
.29628 .46408 .30127 .46961 .30914 .4663 .30417 .46074 Metetra
.686 .734 .887 r
.30417 .46074 .30914 .4663 .31704 .46295 .31208 .45737 Metetra
.687 .734 .887 r
.31208 .45737 .31704 .46295 .32496 .45957 .32002 .45397 Metetra
.688 .734 .886 r
.32002 .45397 .32496 .45957 .33291 .45616 .32797 .45053 Metetra
.689 .734 .885 r
.32797 .45053 .33291 .45616 .34087 .45272 .33595 .44706 Metetra
.69 .734 .884 r
.33595 .44706 .34087 .45272 .34885 .44924 .34395 .44356 Metetra
.691 .734 .884 r
.34395 .44356 .34885 .44924 .35686 .44573 .35197 .44002 Metetra
.692 .734 .883 r
.35197 .44002 .35686 .44573 .36488 .44218 .36001 .43645 Metetra
.693 .734 .882 r
.36001 .43645 .36488 .44218 .37293 .43859 .36807 .43283 Metetra
.694 .734 .881 r
.36807 .43283 .37293 .43859 .381 .43496 .37616 .42917 Metetra
.696 .734 .88 r
.37616 .42917 .381 .43496 .38909 .43129 .38426 .42547 Metetra
.697 .734 .879 r
.38426 .42547 .38909 .43129 .3972 .42757 .39239 .42172 Metetra
.698 .734 .878 r
.39239 .42172 .3972 .42757 .40533 .4238 .40053 .41792 Metetra
.7 .733 .877 r
.40053 .41792 .40533 .4238 .41348 .41999 .4087 .41408 Metetra
.701 .733 .876 r
.4087 .41408 .41348 .41999 .42165 .41612 .41689 .41018 Metetra
.703 .733 .874 r
.41689 .41018 .42165 .41612 .42984 .41219 .42509 .40622 Metetra
.705 .733 .873 r
.42509 .40622 .42984 .41219 .43806 .40821 .43332 .40221 Metetra
.706 .733 .872 r
.43332 .40221 .43806 .40821 .44629 .40417 .44157 .39813 Metetra
.708 .733 .87 r
.44157 .39813 .44629 .40417 .45454 .40005 .44984 .39398 Metetra
.71 .733 .869 r
.44984 .39398 .45454 .40005 .46281 .39587 .45812 .38976 Metetra
.713 .733 .867 r
.45812 .38976 .46281 .39587 .4711 .39161 .46643 .38546 Metetra
.715 .733 .865 r
.46643 .38546 .4711 .39161 .47941 .38727 .47475 .38108 Metetra
.718 .733 .863 r
.47475 .38108 .47941 .38727 .48774 .38284 .4831 .37661 Metetra
.72 .733 .861 r
.4831 .37661 .48774 .38284 .49608 .37832 .49146 .37204 Metetra
.723 .733 .859 r
.49146 .37204 .49608 .37832 .50444 .37369 .49983 .36737 Metetra
.726 .733 .857 r
.49983 .36737 .50444 .37369 .51282 .36895 .50823 .36258 Metetra
.729 .733 .854 r
.50823 .36258 .51282 .36895 .52121 .36409 .51664 .35767 Metetra
.733 .733 .851 r
.51664 .35767 .52121 .36409 .52962 .35909 .52506 .35262 Metetra
.737 .733 .848 r
.52506 .35262 .52962 .35909 .53804 .35395 .5335 .34742 Metetra
.741 .733 .844 r
.5335 .34742 .53804 .35395 .54647 .34864 .54195 .34206 Metetra
.746 .733 .841 r
.54195 .34206 .54647 .34864 .55492 .34315 .55041 .3365 Metetra
.751 .733 .836 r
.55041 .3365 .55492 .34315 .56337 .33746 .55889 .33074 Metetra
.756 .733 .832 r
.55889 .33074 .56337 .33746 .57184 .33153 .56736 .32473 Metetra
.762 .733 .826 r
.56736 .32473 .57184 .33153 .5803 .32533 .57585 .31845 Metetra
.769 .733 .82 r
.57585 .31845 .5803 .32533 .58877 .31883 .58434 .31186 Metetra
.776 .733 .813 r
.58434 .31186 .58877 .31883 .59724 .31197 .59282 .30489 Metetra
.784 .733 .805 r
.59282 .30489 .59724 .31197 .6057 .30469 .6013 .29748 Metetra
.793 .733 .796 r
.6013 .29748 .6057 .30469 .61415 .29688 .60976 .28952 Metetra
.804 .732 .785 r
.60976 .28952 .61415 .29688 .62258 .28844 .61821 .2809 Metetra
.816 .731 .771 r
.61821 .2809 .62258 .28844 .63098 .27918 .62662 .2714 Metetra
.831 .73 .753 r
.62662 .2714 .63098 .27918 .63933 .26882 .63498 .26072 Metetra
.848 .727 .73 r
.63498 .26072 .63933 .26882 .6476 .25687 .64325 .24829 Metetra
.87 .723 .697 r
.64325 .24829 .6476 .25687 .65573 .24233 .65138 .23286 Metetra
.906 .716 .634 r
.65138 .23286 .65573 .24233 .66357 .2221 .65911 .20965 Metetra
.882 .678 .623 r
.65911 .20965 .66357 .2221 .6708 .19074 .66669 .18507 Metetra
.664 .741 .908 r
.66669 .18507 .6708 .19074 .67934 .18767 .67525 .18198 Metetra
.664 .741 .908 r
.67525 .18198 .67934 .18767 .6879 .18459 .68384 .17889 Metetra
.664 .741 .908 r
.68384 .17889 .6879 .18459 .6965 .18151 .69245 .17579 Metetra
.664 .741 .908 r
.69245 .17579 .6965 .18151 .70512 .17841 .70108 .17267 Metetra
.664 .741 .908 r
.70108 .17267 .70512 .17841 .71376 .17531 .70975 .16955 Metetra
.664 .741 .908 r
.70975 .16955 .71376 .17531 .72243 .1722 .71844 .16642 Metetra
.664 .741 .908 r
.71844 .16642 .72243 .1722 .73113 .16907 .72715 .16328 Metetra
.664 .741 .908 r
.72715 .16328 .73113 .16907 .73986 .16594 .7359 .16013 Metetra
.664 .741 .908 r
.7359 .16013 .73986 .16594 .74861 .1628 .74467 .15697 Metetra
.664 .741 .908 r
.74467 .15697 .74861 .1628 .75739 .15965 .75347 .1538 Metetra
.664 .741 .908 r
.75347 .1538 .75739 .15965 .76619 .15648 .76229 .15062 Metetra
.664 .741 .908 r
.76229 .15062 .76619 .15648 .77503 .15331 .77114 .14743 Metetra
.664 .741 .908 r
.77114 .14743 .77503 .15331 .78389 .15013 .78002 .14423 Metetra
.673 .737 .898 r
.13016 .52365 .13545 .52877 .1429 .52588 .13762 .52075 Metetra
.674 .736 .897 r
.13762 .52075 .1429 .52588 .15037 .52298 .1451 .51783 Metetra
.674 .736 .897 r
.1451 .51783 .15037 .52298 .15786 .52006 .1526 .51489 Metetra
.675 .736 .897 r
.1526 .51489 .15786 .52006 .16537 .51713 .16013 .51193 Metetra
.675 .736 .896 r
.16013 .51193 .16537 .51713 .1729 .51418 .16767 .50896 Metetra
.676 .736 .896 r
.16767 .50896 .1729 .51418 .18045 .5112 .17524 .50597 Metetra
.676 .736 .896 r
.17524 .50597 .18045 .5112 .18803 .50821 .18282 .50296 Metetra
.677 .736 .895 r
.18282 .50296 .18803 .50821 .19562 .5052 .19043 .49993 Metetra
.677 .736 .895 r
.19043 .49993 .19562 .5052 .20324 .50217 .19806 .49688 Metetra
.678 .736 .894 r
.19806 .49688 .20324 .50217 .21087 .49913 .20571 .49381 Metetra
.678 .736 .894 r
.20571 .49381 .21087 .49913 .21853 .49606 .21338 .49072 Metetra
.679 .736 .893 r
.21338 .49072 .21853 .49606 .22621 .49296 .22107 .48761 Metetra
.679 .735 .893 r
.22107 .48761 .22621 .49296 .23391 .48985 .22879 .48448 Metetra
.68 .735 .893 r
.22879 .48448 .23391 .48985 .24163 .48672 .23652 .48132 Metetra
.681 .735 .892 r
.23652 .48132 .24163 .48672 .24937 .48356 .24428 .47814 Metetra
.681 .735 .891 r
.24428 .47814 .24937 .48356 .25714 .48038 .25205 .47493 Metetra
.682 .735 .891 r
.25205 .47493 .25714 .48038 .26492 .47717 .25985 .47171 Metetra
.683 .735 .89 r
.25985 .47171 .26492 .47717 .27273 .47394 .26767 .46845 Metetra
.683 .735 .89 r
.26767 .46845 .27273 .47394 .28056 .47068 .27551 .46517 Metetra
.684 .735 .889 r
.27551 .46517 .28056 .47068 .28841 .46739 .28338 .46186 Metetra
.685 .735 .889 r
.28338 .46186 .28841 .46739 .29628 .46408 .29126 .45853 Metetra
.686 .735 .888 r
.29126 .45853 .29628 .46408 .30417 .46074 .29917 .45516 Metetra
.686 .735 .887 r
.29917 .45516 .30417 .46074 .31208 .45737 .3071 .45177 Metetra
.687 .735 .887 r
.3071 .45177 .31208 .45737 .32002 .45397 .31505 .44834 Metetra
.688 .734 .886 r
.31505 .44834 .32002 .45397 .32797 .45053 .32302 .44488 Metetra
.689 .734 .885 r
.32302 .44488 .32797 .45053 .33595 .44706 .33101 .44139 Metetra
.69 .734 .884 r
.33101 .44139 .33595 .44706 .34395 .44356 .33902 .43786 Metetra
.691 .734 .884 r
.33902 .43786 .34395 .44356 .35197 .44002 .34706 .43429 Metetra
.692 .734 .883 r
.34706 .43429 .35197 .44002 .36001 .43645 .35511 .43069 Metetra
.694 .734 .882 r
.35511 .43069 .36001 .43645 .36807 .43283 .36319 .42704 Metetra
.695 .734 .881 r
.36319 .42704 .36807 .43283 .37616 .42917 .37129 .42336 Metetra
.696 .734 .88 r
.37129 .42336 .37616 .42917 .38426 .42547 .37941 .41962 Metetra
.697 .734 .879 r
.37941 .41962 .38426 .42547 .39239 .42172 .38755 .41585 Metetra
.699 .734 .878 r
.38755 .41585 .39239 .42172 .40053 .41792 .39571 .41202 Metetra
.7 .734 .877 r
.39571 .41202 .40053 .41792 .4087 .41408 .40389 .40814 Metetra
.702 .734 .876 r
.40389 .40814 .4087 .41408 .41689 .41018 .4121 .40421 Metetra
.704 .734 .874 r
.4121 .40421 .41689 .41018 .42509 .40622 .42032 .40022 Metetra
.705 .734 .873 r
.42032 .40022 .42509 .40622 .43332 .40221 .42856 .39617 Metetra
.707 .734 .872 r
.42856 .39617 .43332 .40221 .44157 .39813 .43683 .39206 Metetra
.709 .734 .87 r
.43683 .39206 .44157 .39813 .44984 .39398 .44511 .38788 Metetra
.711 .734 .868 r
.44511 .38788 .44984 .39398 .45812 .38976 .45341 .38362 Metetra
.713 .734 .867 r
.45341 .38362 .45812 .38976 .46643 .38546 .46173 .37928 Metetra
.716 .734 .865 r
.46173 .37928 .46643 .38546 .47475 .38108 .47008 .37486 Metetra
.718 .734 .863 r
.47008 .37486 .47475 .38108 .4831 .37661 .47843 .37035 Metetra
.721 .734 .861 r
.47843 .37035 .4831 .37661 .49146 .37204 .48681 .36574 Metetra
.724 .734 .859 r
.48681 .36574 .49146 .37204 .49983 .36737 .49521 .36102 Metetra
.727 .734 .856 r
.49521 .36102 .49983 .36737 .50823 .36258 .50362 .35619 Metetra
.73 .734 .853 r
.50362 .35619 .50823 .36258 .51664 .35767 .51204 .35123 Metetra
.734 .734 .85 r
.51204 .35123 .51664 .35767 .52506 .35262 .52048 .34612 Metetra
.738 .734 .847 r
.52048 .34612 .52506 .35262 .5335 .34742 .52894 .34087 Metetra
.742 .734 .844 r
.52894 .34087 .5335 .34742 .54195 .34206 .53741 .33544 Metetra
.747 .734 .84 r
.53741 .33544 .54195 .34206 .55041 .3365 .54589 .32982 Metetra
.752 .734 .836 r
.54589 .32982 .55041 .3365 .55889 .33074 .55438 .32398 Metetra
.757 .734 .831 r
.55438 .32398 .55889 .33074 .56736 .32473 .56287 .3179 Metetra
.764 .734 .825 r
.56287 .3179 .56736 .32473 .57585 .31845 .57137 .31153 Metetra
.77 .734 .819 r
.57137 .31153 .57585 .31845 .58434 .31186 .57988 .30484 Metetra
.778 .734 .812 r
.57988 .30484 .58434 .31186 .59282 .30489 .58838 .29776 Metetra
.786 .733 .804 r
.58838 .29776 .59282 .30489 .6013 .29748 .59687 .29022 Metetra
.796 .733 .794 r
.59687 .29022 .6013 .29748 .60976 .28952 .60536 .28211 Metetra
.807 .732 .782 r
.60536 .28211 .60976 .28952 .61821 .2809 .61381 .27329 Metetra
.819 .731 .768 r
.61381 .27329 .61821 .2809 .62662 .2714 .62224 .26355 Metetra
.834 .73 .749 r
.62224 .26355 .62662 .2714 .63498 .26072 .63061 .25252 Metetra
.853 .727 .724 r
.63061 .25252 .63498 .26072 .64325 .24829 .63888 .23954 Metetra
.877 .722 .686 r
.63888 .23954 .64325 .24829 .65138 .23286 .64699 .22301 Metetra
.923 .714 .601 r
.64699 .22301 .65138 .23286 .65911 .20965 .6545 .19383 Metetra
.778 .602 .662 r
.6545 .19383 .65911 .20965 .66669 .18507 .66256 .17937 Metetra
.664 .741 .908 r
.66256 .17937 .66669 .18507 .67525 .18198 .67114 .17626 Metetra
.664 .741 .908 r
.67114 .17626 .67525 .18198 .68384 .17889 .67974 .17315 Metetra
.664 .741 .908 r
.67974 .17315 .68384 .17889 .69245 .17579 .68837 .17003 Metetra
.664 .741 .908 r
.68837 .17003 .69245 .17579 .70108 .17267 .69703 .1669 Metetra
.664 .741 .908 r
.69703 .1669 .70108 .17267 .70975 .16955 .70571 .16377 Metetra
.664 .741 .908 r
.70571 .16377 .70975 .16955 .71844 .16642 .71442 .16062 Metetra
.664 .741 .908 r
.71442 .16062 .71844 .16642 .72715 .16328 .72315 .15746 Metetra
.664 .741 .908 r
.72315 .15746 .72715 .16328 .7359 .16013 .73192 .15429 Metetra
.664 .741 .908 r
.73192 .15429 .7359 .16013 .74467 .15697 .74071 .15111 Metetra
.664 .741 .908 r
.74071 .15111 .74467 .15697 .75347 .1538 .74952 .14792 Metetra
.664 .741 .908 r
.74952 .14792 .75347 .1538 .76229 .15062 .75837 .14473 Metetra
.664 .741 .908 r
.75837 .14473 .76229 .15062 .77114 .14743 .76724 .14152 Metetra
.664 .741 .908 r
.76724 .14152 .77114 .14743 .78002 .14423 .77613 .1383 Metetra
.674 .737 .898 r
.12484 .51851 .13016 .52365 .13762 .52075 .13231 .51559 Metetra
.674 .737 .897 r
.13231 .51559 .13762 .52075 .1451 .51783 .13981 .51265 Metetra
.674 .737 .897 r
.13981 .51265 .1451 .51783 .1526 .51489 .14732 .50969 Metetra
.675 .737 .897 r
.14732 .50969 .1526 .51489 .16013 .51193 .15486 .50672 Metetra
.675 .736 .896 r
.15486 .50672 .16013 .51193 .16767 .50896 .16242 .50373 Metetra
.676 .736 .896 r
.16242 .50373 .16767 .50896 .17524 .50597 .16999 .50072 Metetra
.676 .736 .896 r
.16999 .50072 .17524 .50597 .18282 .50296 .17759 .49769 Metetra
.677 .736 .895 r
.17759 .49769 .18282 .50296 .19043 .49993 .18521 .49464 Metetra
.677 .736 .895 r
.18521 .49464 .19043 .49993 .19806 .49688 .19286 .49157 Metetra
.678 .736 .894 r
.19286 .49157 .19806 .49688 .20571 .49381 .20052 .48848 Metetra
.678 .736 .894 r
.20052 .48848 .20571 .49381 .21338 .49072 .2082 .48536 Metetra
.679 .736 .893 r
.2082 .48536 .21338 .49072 .22107 .48761 .21591 .48223 Metetra
.68 .736 .893 r
.21591 .48223 .22107 .48761 .22879 .48448 .22363 .47908 Metetra
.68 .736 .892 r
.22363 .47908 .22879 .48448 .23652 .48132 .23138 .4759 Metetra
.681 .736 .892 r
.23138 .4759 .23652 .48132 .24428 .47814 .23915 .4727 Metetra
.681 .735 .891 r
.23915 .4727 .24428 .47814 .25205 .47493 .24694 .46947 Metetra
.682 .735 .891 r
.24694 .46947 .25205 .47493 .25985 .47171 .25476 .46622 Metetra
.683 .735 .89 r
.25476 .46622 .25985 .47171 .26767 .46845 .26259 .46294 Metetra
.684 .735 .89 r
.26259 .46294 .26767 .46845 .27551 .46517 .27045 .45964 Metetra
.684 .735 .889 r
.27045 .45964 .27551 .46517 .28338 .46186 .27832 .45631 Metetra
.685 .735 .889 r
.27832 .45631 .28338 .46186 .29126 .45853 .28622 .45295 Metetra
.686 .735 .888 r
.28622 .45295 .29126 .45853 .29917 .45516 .29414 .44956 Metetra
.687 .735 .887 r
.29414 .44956 .29917 .45516 .3071 .45177 .30208 .44614 Metetra
.688 .735 .887 r
.30208 .44614 .3071 .45177 .31505 .44834 .31005 .44269 Metetra
.689 .735 .886 r
.31005 .44269 .31505 .44834 .32302 .44488 .31803 .4392 Metetra
.69 .735 .885 r
.31803 .4392 .32302 .44488 .33101 .44139 .32604 .43568 Metetra
.691 .735 .884 r
.32604 .43568 .33101 .44139 .33902 .43786 .33407 .43213 Metetra
.692 .735 .884 r
.33407 .43213 .33902 .43786 .34706 .43429 .34212 .42853 Metetra
.693 .734 .883 r
.34212 .42853 .34706 .43429 .35511 .43069 .35019 .4249 Metetra
.694 .734 .882 r
.35019 .4249 .35511 .43069 .36319 .42704 .35828 .42123 Metetra
.695 .734 .881 r
.35828 .42123 .36319 .42704 .37129 .42336 .3664 .41752 Metetra
.697 .734 .88 r
.3664 .41752 .37129 .42336 .37941 .41962 .37453 .41376 Metetra
.698 .734 .879 r
.37453 .41376 .37941 .41962 .38755 .41585 .38269 .40995 Metetra
.699 .734 .878 r
.38269 .40995 .38755 .41585 .39571 .41202 .39086 .40609 Metetra
.701 .734 .877 r
.39086 .40609 .39571 .41202 .40389 .40814 .39906 .40218 Metetra
.702 .734 .875 r
.39906 .40218 .40389 .40814 .4121 .40421 .40728 .39822 Metetra
.704 .734 .874 r
.40728 .39822 .4121 .40421 .42032 .40022 .41552 .3942 Metetra
.706 .734 .873 r
.41552 .3942 .42032 .40022 .42856 .39617 .42378 .39012 Metetra
.708 .734 .871 r
.42378 .39012 .42856 .39617 .43683 .39206 .43206 .38597 Metetra
.71 .734 .87 r
.43206 .38597 .43683 .39206 .44511 .38788 .44036 .38175 Metetra
.712 .734 .868 r
.44036 .38175 .44511 .38788 .45341 .38362 .44868 .37745 Metetra
.714 .734 .866 r
.44868 .37745 .45341 .38362 .46173 .37928 .45702 .37308 Metetra
.717 .734 .865 r
.45702 .37308 .46173 .37928 .47008 .37486 .46537 .36862 Metetra
.719 .734 .863 r
.46537 .36862 .47008 .37486 .47843 .37035 .47375 .36406 Metetra
.722 .734 .86 r
.47375 .36406 .47843 .37035 .48681 .36574 .48214 .35941 Metetra
.725 .734 .858 r
.48214 .35941 .48681 .36574 .49521 .36102 .49055 .35464 Metetra
.728 .734 .856 r
.49055 .35464 .49521 .36102 .50362 .35619 .49898 .34976 Metetra
.731 .734 .853 r
.49898 .34976 .50362 .35619 .51204 .35123 .50743 .34475 Metetra
.735 .734 .85 r
.50743 .34475 .51204 .35123 .52048 .34612 .51588 .33959 Metetra
.739 .734 .847 r
.51588 .33959 .52048 .34612 .52894 .34087 .52436 .33428 Metetra
.743 .734 .843 r
.52436 .33428 .52894 .34087 .53741 .33544 .53284 .32879 Metetra
.748 .734 .839 r
.53284 .32879 .53741 .33544 .54589 .32982 .54134 .3231 Metetra
.753 .734 .835 r
.54134 .3231 .54589 .32982 .55438 .32398 .54985 .31719 Metetra
.759 .734 .83 r
.54985 .31719 .55438 .32398 .56287 .3179 .55836 .31103 Metetra
.765 .734 .824 r
.55836 .31103 .56287 .3179 .57137 .31153 .56688 .30457 Metetra
.772 .734 .818 r
.56688 .30457 .57137 .31153 .57988 .30484 .5754 .29778 Metetra
.78 .734 .81 r
.5754 .29778 .57988 .30484 .58838 .29776 .58392 .29059 Metetra
.789 .734 .802 r
.58392 .29059 .58838 .29776 .59687 .29022 .59243 .28291 Metetra
.798 .733 .792 r
.59243 .28291 .59687 .29022 .60536 .28211 .60093 .27464 Metetra
.81 .733 .779 r
.60093 .27464 .60536 .28211 .61381 .27329 .6094 .26562 Metetra
.823 .731 .764 r
.6094 .26562 .61381 .27329 .62224 .26355 .61784 .25561 Metetra
.838 .73 .744 r
.61784 .25561 .62224 .26355 .63061 .25252 .62622 .2442 Metetra
.858 .726 .717 r
.62622 .2442 .63061 .25252 .63888 .23954 .6345 .23059 Metetra
.885 .721 .674 r
.6345 .23059 .63888 .23954 .64699 .22301 .64257 .21266 Metetra
.935 .71 .573 r
.64257 .21266 .64699 .22301 .6545 .19383 .64984 .17674 Metetra
.606 .491 .697 r
.64984 .17674 .6545 .19383 .66256 .17937 .65841 .17363 Metetra
.664 .741 .908 r
.65841 .17363 .66256 .17937 .67114 .17626 .66701 .17051 Metetra
.664 .741 .908 r
.66701 .17051 .67114 .17626 .67974 .17315 .67563 .16739 Metetra
.664 .741 .908 r
.67563 .16739 .67974 .17315 .68837 .17003 .68428 .16425 Metetra
.664 .741 .908 r
.68428 .16425 .68837 .17003 .69703 .1669 .69295 .1611 Metetra
.664 .741 .908 r
.69295 .1611 .69703 .1669 .70571 .16377 .70165 .15794 Metetra
.664 .741 .908 r
.70165 .15794 .70571 .16377 .71442 .16062 .71038 .15478 Metetra
.664 .741 .908 r
.71038 .15478 .71442 .16062 .72315 .15746 .71913 .1516 Metetra
.664 .741 .908 r
.71913 .1516 .72315 .15746 .73192 .15429 .72791 .14842 Metetra
.664 .741 .908 r
.72791 .14842 .73192 .15429 .74071 .15111 .73672 .14522 Metetra
.664 .741 .908 r
.73672 .14522 .74071 .15111 .74952 .14792 .74555 .14201 Metetra
.664 .741 .908 r
.74555 .14201 .74952 .14792 .75837 .14473 .75442 .1388 Metetra
.664 .741 .908 r
.75442 .1388 .75837 .14473 .76724 .14152 .76331 .13557 Metetra
.664 .741 .908 r
.76331 .13557 .76724 .14152 .77613 .1383 .77223 .13234 Metetra
.674 .737 .898 r
.1195 .51335 .12484 .51851 .13231 .51559 .12698 .51041 Metetra
.674 .737 .897 r
.12698 .51041 .13231 .51559 .13981 .51265 .13449 .50745 Metetra
.675 .737 .897 r
.13449 .50745 .13981 .51265 .14732 .50969 .14202 .50447 Metetra
.675 .737 .897 r
.14202 .50447 .14732 .50969 .15486 .50672 .14957 .50148 Metetra
.676 .737 .896 r
.14957 .50148 .15486 .50672 .16242 .50373 .15714 .49847 Metetra
.676 .737 .896 r
.15714 .49847 .16242 .50373 .16999 .50072 .16473 .49544 Metetra
.677 .736 .896 r
.16473 .49544 .16999 .50072 .17759 .49769 .17234 .49239 Metetra
.677 .736 .895 r
.17234 .49239 .17759 .49769 .18521 .49464 .17997 .48932 Metetra
.678 .736 .895 r
.17997 .48932 .18521 .49464 .19286 .49157 .18763 .48623 Metetra
.678 .736 .894 r
.18763 .48623 .19286 .49157 .20052 .48848 .1953 .48312 Metetra
.679 .736 .894 r
.1953 .48312 .20052 .48848 .2082 .48536 .203 .47998 Metetra
.679 .736 .893 r
.203 .47998 .2082 .48536 .21591 .48223 .21072 .47683 Metetra
.68 .736 .893 r
.21072 .47683 .21591 .48223 .22363 .47908 .21846 .47365 Metetra
.68 .736 .892 r
.21846 .47365 .22363 .47908 .23138 .4759 .22622 .47045 Metetra
.681 .736 .892 r
.22622 .47045 .23138 .4759 .23915 .4727 .234 .46723 Metetra
.682 .736 .891 r
.234 .46723 .23915 .4727 .24694 .46947 .24181 .46398 Metetra
.682 .736 .891 r
.24181 .46398 .24694 .46947 .25476 .46622 .24963 .46071 Metetra
.683 .736 .89 r
.24963 .46071 .25476 .46622 .26259 .46294 .25748 .45741 Metetra
.684 .735 .89 r
.25748 .45741 .26259 .46294 .27045 .45964 .26535 .45408 Metetra
.685 .735 .889 r
.26535 .45408 .27045 .45964 .27832 .45631 .27324 .45073 Metetra
.686 .735 .889 r
.27324 .45073 .27832 .45631 .28622 .45295 .28116 .44734 Metetra
.686 .735 .888 r
.28116 .44734 .28622 .45295 .29414 .44956 .28909 .44393 Metetra
.687 .735 .887 r
.28909 .44393 .29414 .44956 .30208 .44614 .29705 .44048 Metetra
.688 .735 .887 r
.29705 .44048 .30208 .44614 .31005 .44269 .30503 .43701 Metetra
.689 .735 .886 r
.30503 .43701 .31005 .44269 .31803 .4392 .31303 .4335 Metetra
.69 .735 .885 r
.31303 .4335 .31803 .4392 .32604 .43568 .32105 .42995 Metetra
.691 .735 .884 r
.32105 .42995 .32604 .43568 .33407 .43213 .32909 .42637 Metetra
.692 .735 .883 r
.32909 .42637 .33407 .43213 .34212 .42853 .33715 .42275 Metetra
.693 .735 .883 r
.33715 .42275 .34212 .42853 .35019 .4249 .34524 .41909 Metetra
.695 .735 .882 r
.34524 .41909 .35019 .4249 .35828 .42123 .35335 .41539 Metetra
.696 .735 .881 r
.35335 .41539 .35828 .42123 .3664 .41752 .36148 .41165 Metetra
.697 .735 .88 r
.36148 .41165 .3664 .41752 .37453 .41376 .36963 .40786 Metetra
.698 .734 .879 r
.36963 .40786 .37453 .41376 .38269 .40995 .3778 .40402 Metetra
.7 .734 .878 r
.3778 .40402 .38269 .40995 .39086 .40609 .38599 .40014 Metetra
.701 .734 .876 r
.38599 .40014 .39086 .40609 .39906 .40218 .39421 .3962 Metetra
.703 .734 .875 r
.39421 .3962 .39906 .40218 .40728 .39822 .40244 .3922 Metetra
.705 .734 .874 r
.40244 .3922 .40728 .39822 .41552 .3942 .4107 .38815 Metetra
.707 .734 .873 r
.4107 .38815 .41552 .3942 .42378 .39012 .41897 .38403 Metetra
.708 .734 .871 r
.41897 .38403 .42378 .39012 .43206 .38597 .42727 .37984 Metetra
.711 .734 .87 r
.42727 .37984 .43206 .38597 .44036 .38175 .43558 .37559 Metetra
.713 .734 .868 r
.43558 .37559 .44036 .38175 .44868 .37745 .44392 .37126 Metetra
.715 .734 .866 r
.44392 .37126 .44868 .37745 .45702 .37308 .45227 .36684 Metetra
.717 .734 .864 r
.45227 .36684 .45702 .37308 .46537 .36862 .46065 .36234 Metetra
.72 .734 .862 r
.46065 .36234 .46537 .36862 .47375 .36406 .46904 .35775 Metetra
.723 .734 .86 r
.46904 .35775 .47375 .36406 .48214 .35941 .47745 .35305 Metetra
.726 .734 .858 r
.47745 .35305 .48214 .35941 .49055 .35464 .48588 .34824 Metetra
.729 .734 .855 r
.48588 .34824 .49055 .35464 .49898 .34976 .49432 .34331 Metetra
.732 .734 .852 r
.49432 .34331 .49898 .34976 .50743 .34475 .50279 .33824 Metetra
.736 .734 .849 r
.50279 .33824 .50743 .34475 .51588 .33959 .51126 .33303 Metetra
.74 .734 .846 r
.51126 .33303 .51588 .33959 .52436 .33428 .51975 .32766 Metetra
.745 .734 .842 r
.51975 .32766 .52436 .33428 .53284 .32879 .52825 .32211 Metetra
.75 .734 .838 r
.52825 .32211 .53284 .32879 .54134 .3231 .53677 .31635 Metetra
.755 .735 .834 r
.53677 .31635 .54134 .3231 .54985 .31719 .54529 .31037 Metetra
.761 .735 .829 r
.54529 .31037 .54985 .31719 .55836 .31103 .55382 .30412 Metetra
.767 .734 .823 r
.55382 .30412 .55836 .31103 .56688 .30457 .56236 .29758 Metetra
.774 .734 .816 r
.56236 .29758 .56688 .30457 .5754 .29778 .5709 .29068 Metetra
.782 .734 .809 r
.5709 .29068 .5754 .29778 .58392 .29059 .57943 .28337 Metetra
.791 .734 .8 r
.57943 .28337 .58392 .29059 .59243 .28291 .58796 .27555 Metetra
.801 .733 .789 r
.58796 .27555 .59243 .28291 .60093 .27464 .59648 .26711 Metetra
.812 .733 .776 r
.59648 .26711 .60093 .27464 .6094 .26562 .60497 .25788 Metetra
.826 .731 .76 r
.60497 .25788 .6094 .26562 .61784 .25561 .61342 .24758 Metetra
.842 .729 .739 r
.61342 .24758 .61784 .25561 .62622 .2442 .62181 .23575 Metetra
.863 .726 .709 r
.62181 .23575 .62622 .2442 .6345 .23059 .63009 .22141 Metetra
.893 .719 .659 r
.63009 .22141 .6345 .23059 .64257 .21266 .63812 .20158 Metetra
.917 .701 .596 r
.63812 .20158 .64257 .21266 .64984 .17674 .64565 .171 Metetra
.664 .741 .908 r
.64565 .171 .64984 .17674 .65841 .17363 .65424 .16787 Metetra
.664 .741 .908 r
.65424 .16787 .65841 .17363 .66701 .17051 .66285 .16473 Metetra
.664 .741 .908 r
.66285 .16473 .66701 .17051 .67563 .16739 .67149 .16159 Metetra
.664 .741 .908 r
.67149 .16159 .67563 .16739 .68428 .16425 .68015 .15843 Metetra
.664 .741 .908 r
.68015 .15843 .68428 .16425 .69295 .1611 .68885 .15527 Metetra
.664 .741 .908 r
.68885 .15527 .69295 .1611 .70165 .15794 .69757 .15209 Metetra
.664 .741 .908 r
.69757 .15209 .70165 .15794 .71038 .15478 .70631 .14891 Metetra
.664 .741 .908 r
.70631 .14891 .71038 .15478 .71913 .1516 .71508 .14571 Metetra
.664 .741 .908 r
.71508 .14571 .71913 .1516 .72791 .14842 .72388 .14251 Metetra
.664 .741 .908 r
.72388 .14251 .72791 .14842 .73672 .14522 .73271 .13929 Metetra
.664 .741 .908 r
.73271 .13929 .73672 .14522 .74555 .14201 .74157 .13607 Metetra
.664 .741 .908 r
.74157 .13607 .74555 .14201 .75442 .1388 .75045 .13283 Metetra
.664 .741 .908 r
.75045 .13283 .75442 .1388 .76331 .13557 .75936 .12959 Metetra
.664 .741 .908 r
.75936 .12959 .76331 .13557 .77223 .13234 .76829 .12634 Metetra
.674 .737 .898 r
.11413 .50816 .1195 .51335 .12698 .51041 .12162 .5052 Metetra
.675 .737 .897 r
.12162 .5052 .12698 .51041 .13449 .50745 .12914 .50223 Metetra
.675 .737 .897 r
.12914 .50223 .13449 .50745 .14202 .50447 .13668 .49923 Metetra
.675 .737 .897 r
.13668 .49923 .14202 .50447 .14957 .50148 .14424 .49622 Metetra
.676 .737 .896 r
.14424 .49622 .14957 .50148 .15714 .49847 .15183 .49319 Metetra
.676 .737 .896 r
.15183 .49319 .15714 .49847 .16473 .49544 .15943 .49014 Metetra
.677 .737 .896 r
.15943 .49014 .16473 .49544 .17234 .49239 .16705 .48707 Metetra
.677 .737 .895 r
.16705 .48707 .17234 .49239 .17997 .48932 .1747 .48398 Metetra
.678 .737 .895 r
.1747 .48398 .17997 .48932 .18763 .48623 .18237 .48087 Metetra
.678 .736 .894 r
.18237 .48087 .18763 .48623 .1953 .48312 .19006 .47773 Metetra
.679 .736 .894 r
.19006 .47773 .1953 .48312 .203 .47998 .19777 .47458 Metetra
.68 .736 .893 r
.19777 .47458 .203 .47998 .21072 .47683 .2055 .47141 Metetra
.68 .736 .893 r
.2055 .47141 .21072 .47683 .21846 .47365 .21325 .46821 Metetra
.681 .736 .892 r
.21325 .46821 .21846 .47365 .22622 .47045 .22103 .46499 Metetra
.681 .736 .892 r
.22103 .46499 .22622 .47045 .234 .46723 .22883 .46174 Metetra
.682 .736 .891 r
.22883 .46174 .234 .46723 .24181 .46398 .23664 .45847 Metetra
.683 .736 .891 r
.23664 .45847 .24181 .46398 .24963 .46071 .24449 .45517 Metetra
.684 .736 .89 r
.24449 .45517 .24963 .46071 .25748 .45741 .25235 .45185 Metetra
.684 .736 .89 r
.25235 .45185 .25748 .45741 .26535 .45408 .26023 .4485 Metetra
.685 .736 .889 r
.26023 .4485 .26535 .45408 .27324 .45073 .26814 .44512 Metetra
.686 .736 .889 r
.26814 .44512 .27324 .45073 .28116 .44734 .27606 .44171 Metetra
.687 .735 .888 r
.27606 .44171 .28116 .44734 .28909 .44393 .28401 .43828 Metetra
.688 .735 .887 r
.28401 .43828 .28909 .44393 .29705 .44048 .29198 .43481 Metetra
.689 .735 .886 r
.29198 .43481 .29705 .44048 .30503 .43701 .29998 .43131 Metetra
.689 .735 .886 r
.29998 .43131 .30503 .43701 .31303 .4335 .30799 .42777 Metetra
.691 .735 .885 r
.30799 .42777 .31303 .4335 .32105 .42995 .31603 .4242 Metetra
.692 .735 .884 r
.31603 .4242 .32105 .42995 .32909 .42637 .32409 .42059 Metetra
.693 .735 .883 r
.32409 .42059 .32909 .42637 .33715 .42275 .33217 .41694 Metetra
.694 .735 .882 r
.33217 .41694 .33715 .42275 .34524 .41909 .34027 .41326 Metetra
.695 .735 .882 r
.34027 .41326 .34524 .41909 .35335 .41539 .34839 .40953 Metetra
.696 .735 .881 r
.34839 .40953 .35335 .41539 .36148 .41165 .35653 .40576 Metetra
.698 .735 .88 r
.35653 .40576 .36148 .41165 .36963 .40786 .3647 .40194 Metetra
.699 .735 .879 r
.3647 .40194 .36963 .40786 .3778 .40402 .37289 .39807 Metetra
.7 .735 .877 r
.37289 .39807 .3778 .40402 .38599 .40014 .3811 .39416 Metetra
.702 .735 .876 r
.3811 .39416 .38599 .40014 .39421 .3962 .38933 .39018 Metetra
.704 .735 .875 r
.38933 .39018 .39421 .3962 .40244 .3922 .39758 .38616 Metetra
.705 .735 .874 r
.39758 .38616 .40244 .3922 .4107 .38815 .40585 .38207 Metetra
.707 .735 .872 r
.40585 .38207 .4107 .38815 .41897 .38403 .41414 .37792 Metetra
.709 .735 .871 r
.41414 .37792 .41897 .38403 .42727 .37984 .42245 .3737 Metetra
.711 .735 .869 r
.42245 .3737 .42727 .37984 .43558 .37559 .43078 .3694 Metetra
.713 .735 .868 r
.43078 .3694 .43558 .37559 .44392 .37126 .43914 .36503 Metetra
.716 .735 .866 r
.43914 .36503 .44392 .37126 .45227 .36684 .44751 .36058 Metetra
.718 .735 .864 r
.44751 .36058 .45227 .36684 .46065 .36234 .4559 .35604 Metetra
.721 .735 .862 r
.4559 .35604 .46065 .36234 .46904 .35775 .46431 .3514 Metetra
.724 .735 .86 r
.46431 .3514 .46904 .35775 .47745 .35305 .47274 .34666 Metetra
.727 .735 .857 r
.47274 .34666 .47745 .35305 .48588 .34824 .48118 .3418 Metetra
.73 .735 .855 r
.48118 .3418 .48588 .34824 .49432 .34331 .48964 .33682 Metetra
.734 .735 .852 r
.48964 .33682 .49432 .34331 .50279 .33824 .49812 .3317 Metetra
.737 .735 .849 r
.49812 .3317 .50279 .33824 .51126 .33303 .50662 .32644 Metetra
.741 .735 .845 r
.50662 .32644 .51126 .33303 .51975 .32766 .51512 .32101 Metetra
.746 .735 .842 r
.51512 .32101 .51975 .32766 .52825 .32211 .52364 .31539 Metetra
.751 .735 .837 r
.52364 .31539 .52825 .32211 .53677 .31635 .53218 .30956 Metetra
.756 .735 .833 r
.53218 .30956 .53677 .31635 .54529 .31037 .54072 .30351 Metetra
.762 .735 .828 r
.54072 .30351 .54529 .31037 .55382 .30412 .54927 .29718 Metetra
.769 .735 .822 r
.54927 .29718 .55382 .30412 .56236 .29758 .55782 .29054 Metetra
.776 .735 .815 r
.55782 .29054 .56236 .29758 .5709 .29068 .56638 .28353 Metetra
.784 .735 .807 r
.56638 .28353 .5709 .29068 .57943 .28337 .57493 .2761 Metetra
.793 .734 .798 r
.57493 .2761 .57943 .28337 .58796 .27555 .58348 .26814 Metetra
.804 .734 .787 r
.58348 .26814 .58796 .27555 .59648 .26711 .59201 .25952 Metetra
.815 .733 .773 r
.59201 .25952 .59648 .26711 .60497 .25788 .60051 .25006 Metetra
.83 .731 .756 r
.60051 .25006 .60497 .25788 .61342 .24758 .60898 .23945 Metetra
.847 .729 .733 r
.60898 .23945 .61342 .24758 .62181 .23575 .61738 .22715 Metetra
.869 .725 .7 r
.61738 .22715 .62181 .23575 .63009 .22141 .62565 .21195 Metetra
.905 .717 .639 r
.62565 .21195 .63009 .22141 .63812 .20158 .63361 .18923 Metetra
.881 .68 .626 r
.63361 .18923 .63812 .20158 .64565 .171 .64144 .16522 Metetra
.664 .741 .908 r
.64144 .16522 .64565 .171 .65424 .16787 .65004 .16207 Metetra
.664 .741 .908 r
.65004 .16207 .65424 .16787 .66285 .16473 .65867 .15892 Metetra
.664 .741 .908 r
.65867 .15892 .66285 .16473 .67149 .16159 .66733 .15575 Metetra
.664 .741 .908 r
.66733 .15575 .67149 .16159 .68015 .15843 .67601 .15258 Metetra
.664 .741 .908 r
.67601 .15258 .68015 .15843 .68885 .15527 .68472 .1494 Metetra
.664 .741 .908 r
.68472 .1494 .68885 .15527 .69757 .15209 .69346 .1462 Metetra
.664 .741 .908 r
.69346 .1462 .69757 .15209 .70631 .14891 .70222 .143 Metetra
.664 .741 .908 r
.70222 .143 .70631 .14891 .71508 .14571 .71101 .13979 Metetra
.664 .741 .908 r
.71101 .13979 .71508 .14571 .72388 .14251 .71983 .13657 Metetra
.664 .741 .908 r
.71983 .13657 .72388 .14251 .73271 .13929 .72868 .13333 Metetra
.664 .741 .908 r
.72868 .13333 .73271 .13929 .74157 .13607 .73755 .13009 Metetra
.664 .741 .908 r
.73755 .13009 .74157 .13607 .75045 .13283 .74645 .12684 Metetra
.664 .741 .908 r
.74645 .12684 .75045 .13283 .75936 .12959 .75538 .12357 Metetra
.664 .741 .908 r
.75538 .12357 .75936 .12959 .76829 .12634 .76434 .1203 Metetra
.674 .737 .898 r
.10873 .50296 .11413 .50816 .12162 .5052 .11624 .49998 Metetra
.675 .737 .897 r
.11624 .49998 .12162 .5052 .12914 .50223 .12377 .49698 Metetra
.675 .737 .897 r
.12377 .49698 .12914 .50223 .13668 .49923 .13132 .49397 Metetra
.676 .737 .897 r
.13132 .49397 .13668 .49923 .14424 .49622 .13889 .49093 Metetra
.676 .737 .896 r
.13889 .49093 .14424 .49622 .15183 .49319 .14649 .48788 Metetra
.677 .737 .896 r
.14649 .48788 .15183 .49319 .15943 .49014 .15411 .48481 Metetra
.677 .737 .896 r
.15411 .48481 .15943 .49014 .16705 .48707 .16174 .48172 Metetra
.678 .737 .895 r
.16174 .48172 .16705 .48707 .1747 .48398 .1694 .47861 Metetra
.678 .737 .895 r
.1694 .47861 .1747 .48398 .18237 .48087 .17708 .47548 Metetra
.679 .737 .894 r
.17708 .47548 .18237 .48087 .19006 .47773 .18479 .47233 Metetra
.679 .737 .894 r
.18479 .47233 .19006 .47773 .19777 .47458 .19251 .46915 Metetra
.68 .736 .893 r
.19251 .46915 .19777 .47458 .2055 .47141 .20026 .46596 Metetra
.68 .736 .893 r
.20026 .46596 .2055 .47141 .21325 .46821 .20802 .46274 Metetra
.681 .736 .892 r
.20802 .46274 .21325 .46821 .22103 .46499 .21581 .45949 Metetra
.682 .736 .892 r
.21581 .45949 .22103 .46499 .22883 .46174 .22362 .45623 Metetra
.682 .736 .891 r
.22362 .45623 .22883 .46174 .23664 .45847 .23146 .45293 Metetra
.683 .736 .891 r
.23146 .45293 .23664 .45847 .24449 .45517 .23931 .44961 Metetra
.684 .736 .89 r
.23931 .44961 .24449 .45517 .25235 .45185 .24719 .44627 Metetra
.685 .736 .89 r
.24719 .44627 .25235 .45185 .26023 .4485 .25508 .44289 Metetra
.685 .736 .889 r
.25508 .44289 .26023 .4485 .26814 .44512 .263 .43949 Metetra
.686 .736 .888 r
.263 .43949 .26814 .44512 .27606 .44171 .27095 .43606 Metetra
.687 .736 .888 r
.27095 .43606 .27606 .44171 .28401 .43828 .27891 .4326 Metetra
.688 .736 .887 r
.27891 .4326 .28401 .43828 .29198 .43481 .28689 .4291 Metetra
.689 .736 .886 r
.28689 .4291 .29198 .43481 .29998 .43131 .2949 .42558 Metetra
.69 .736 .886 r
.2949 .42558 .29998 .43131 .30799 .42777 .30293 .42202 Metetra
.691 .735 .885 r
.30293 .42202 .30799 .42777 .31603 .4242 .31098 .41842 Metetra
.692 .735 .884 r
.31098 .41842 .31603 .4242 .32409 .42059 .31906 .41478 Metetra
.693 .735 .883 r
.31906 .41478 .32409 .42059 .33217 .41694 .32715 .41111 Metetra
.694 .735 .882 r
.32715 .41111 .33217 .41694 .34027 .41326 .33527 .4074 Metetra
.695 .735 .881 r
.33527 .4074 .34027 .41326 .34839 .40953 .34341 .40364 Metetra
.697 .735 .88 r
.34341 .40364 .34839 .40953 .35653 .40576 .35157 .39984 Metetra
.698 .735 .879 r
.35157 .39984 .35653 .40576 .3647 .40194 .35975 .39599 Metetra
.7 .735 .878 r
.35975 .39599 .3647 .40194 .37289 .39807 .36795 .39209 Metetra
.701 .735 .877 r
.36795 .39209 .37289 .39807 .3811 .39416 .37617 .38815 Metetra
.703 .735 .876 r
.37617 .38815 .3811 .39416 .38933 .39018 .38442 .38414 Metetra
.704 .735 .875 r
.38442 .38414 .38933 .39018 .39758 .38616 .39269 .38008 Metetra
.706 .735 .874 r
.39269 .38008 .39758 .38616 .40585 .38207 .40097 .37596 Metetra
.708 .735 .872 r
.40097 .37596 .40585 .38207 .41414 .37792 .40928 .37177 Metetra
.71 .735 .871 r
.40928 .37177 .41414 .37792 .42245 .3737 .41761 .36752 Metetra
.712 .735 .869 r
.41761 .36752 .42245 .3737 .43078 .3694 .42596 .36319 Metetra
.714 .735 .867 r
.42596 .36319 .43078 .3694 .43914 .36503 .43433 .35878 Metetra
.716 .735 .866 r
.43433 .35878 .43914 .36503 .44751 .36058 .44272 .35429 Metetra
.719 .735 .864 r
.44272 .35429 .44751 .36058 .4559 .35604 .45113 .34971 Metetra
.722 .735 .862 r
.45113 .34971 .4559 .35604 .46431 .3514 .45955 .34502 Metetra
.725 .735 .859 r
.45955 .34502 .46431 .3514 .47274 .34666 .468 .34024 Metetra
.728 .735 .857 r
.468 .34024 .47274 .34666 .48118 .3418 .47646 .33533 Metetra
.731 .735 .854 r
.47646 .33533 .48118 .3418 .48964 .33682 .48494 .3303 Metetra
.735 .735 .851 r
.48494 .3303 .48964 .33682 .49812 .3317 .49343 .32513 Metetra
.738 .735 .848 r
.49343 .32513 .49812 .3317 .50662 .32644 .50195 .31981 Metetra
.743 .735 .845 r
.50195 .31981 .50662 .32644 .51512 .32101 .51047 .31432 Metetra
.747 .735 .841 r
.51047 .31432 .51512 .32101 .52364 .31539 .51901 .30864 Metetra
.752 .735 .837 r
.51901 .30864 .52364 .31539 .53218 .30956 .52756 .30274 Metetra
.758 .735 .832 r
.52756 .30274 .53218 .30956 .54072 .30351 .53612 .29661 Metetra
.764 .735 .827 r
.53612 .29661 .54072 .30351 .54927 .29718 .54469 .29019 Metetra
.77 .735 .82 r
.54469 .29019 .54927 .29718 .55782 .29054 .55326 .28346 Metetra
.778 .735 .813 r
.55326 .28346 .55782 .29054 .56638 .28353 .56183 .27634 Metetra
.786 .735 .805 r
.56183 .27634 .56638 .28353 .57493 .2761 .57041 .26878 Metetra
.795 .734 .796 r
.57041 .26878 .57493 .2761 .58348 .26814 .57897 .26067 Metetra
.806 .734 .784 r
.57897 .26067 .58348 .26814 .59201 .25952 .58752 .25187 Metetra
.819 .733 .77 r
.58752 .25187 .59201 .25952 .60051 .25006 .59604 .24216 Metetra
.833 .731 .752 r
.59604 .24216 .60051 .25006 .60898 .23945 .60452 .23121 Metetra
.851 .728 .727 r
.60452 .23121 .60898 .23945 .61738 .22715 .61292 .21838 Metetra
.876 .724 .69 r
.61292 .21838 .61738 .22715 .62565 .21195 .62119 .20211 Metetra
.922 .715 .606 r
.62119 .20211 .62565 .21195 .63361 .18923 .62898 .1736 Metetra
.778 .604 .665 r
.62898 .1736 .63361 .18923 .64144 .16522 .6372 .1594 Metetra
.664 .741 .908 r
.6372 .1594 .64144 .16522 .65004 .16207 .64582 .15624 Metetra
.664 .741 .908 r
.64582 .15624 .65004 .16207 .65867 .15892 .65447 .15307 Metetra
.664 .741 .908 r
.65447 .15307 .65867 .15892 .66733 .15575 .66314 .14989 Metetra
.664 .741 .908 r
.66314 .14989 .66733 .15575 .67601 .15258 .67184 .1467 Metetra
.664 .741 .908 r
.67184 .1467 .67601 .15258 .68472 .1494 .68057 .14349 Metetra
.664 .741 .908 r
.68057 .14349 .68472 .1494 .69346 .1462 .68933 .14028 Metetra
.664 .741 .908 r
.68933 .14028 .69346 .1462 .70222 .143 .69811 .13706 Metetra
.664 .741 .908 r
.69811 .13706 .70222 .143 .71101 .13979 .70692 .13383 Metetra
.664 .741 .908 r
.70692 .13383 .71101 .13979 .71983 .13657 .71576 .13059 Metetra
.664 .741 .908 r
.71576 .13059 .71983 .13657 .72868 .13333 .72462 .12734 Metetra
.664 .741 .908 r
.72462 .12734 .72868 .13333 .73755 .13009 .73352 .12408 Metetra
.664 .741 .908 r
.73352 .12408 .73755 .13009 .74645 .12684 .74244 .1208 Metetra
.664 .741 .908 r
.74244 .1208 .74645 .12684 .75538 .12357 .75139 .11752 Metetra
.664 .741 .908 r
.75139 .11752 .75538 .12357 .76434 .1203 .76036 .11423 Metetra
.675 .738 .898 r
.1033 .49773 .10873 .50296 .11624 .49998 .11082 .49473 Metetra
.675 .737 .897 r
.11082 .49473 .11624 .49998 .12377 .49698 .11837 .49171 Metetra
.675 .737 .897 r
.11837 .49171 .12377 .49698 .13132 .49397 .12593 .48868 Metetra
.676 .737 .897 r
.12593 .48868 .13132 .49397 .13889 .49093 .13352 .48563 Metetra
.676 .737 .896 r
.13352 .48563 .13889 .49093 .14649 .48788 .14113 .48256 Metetra
.677 .737 .896 r
.14113 .48256 .14649 .48788 .15411 .48481 .14876 .47946 Metetra
.677 .737 .896 r
.14876 .47946 .15411 .48481 .16174 .48172 .15641 .47635 Metetra
.678 .737 .895 r
.15641 .47635 .16174 .48172 .1694 .47861 .16408 .47322 Metetra
.678 .737 .895 r
.16408 .47322 .1694 .47861 .17708 .47548 .17177 .47007 Metetra
.679 .737 .894 r
.17177 .47007 .17708 .47548 .18479 .47233 .17949 .4669 Metetra
.68 .737 .894 r
.17949 .4669 .18479 .47233 .19251 .46915 .18723 .4637 Metetra
.68 .737 .893 r
.18723 .4637 .19251 .46915 .20026 .46596 .19498 .46048 Metetra
.681 .737 .893 r
.19498 .46048 .20026 .46596 .20802 .46274 .20277 .45724 Metetra
.681 .737 .892 r
.20277 .45724 .20802 .46274 .21581 .45949 .21057 .45398 Metetra
.682 .736 .892 r
.21057 .45398 .21581 .45949 .22362 .45623 .21839 .45069 Metetra
.683 .736 .891 r
.21839 .45069 .22362 .45623 .23146 .45293 .22624 .44737 Metetra
.683 .736 .891 r
.22624 .44737 .23146 .45293 .23931 .44961 .23411 .44403 Metetra
.684 .736 .89 r
.23411 .44403 .23931 .44961 .24719 .44627 .242 .44066 Metetra
.685 .736 .89 r
.242 .44066 .24719 .44627 .25508 .44289 .24991 .43726 Metetra
.686 .736 .889 r
.24991 .43726 .25508 .44289 .263 .43949 .25784 .43384 Metetra
.687 .736 .888 r
.25784 .43384 .263 .43949 .27095 .43606 .2658 .43038 Metetra
.687 .736 .888 r
.2658 .43038 .27095 .43606 .27891 .4326 .27378 .42689 Metetra
.688 .736 .887 r
.27378 .42689 .27891 .4326 .28689 .4291 .28178 .42338 Metetra
.689 .736 .886 r
.28178 .42338 .28689 .4291 .2949 .42558 .2898 .41982 Metetra
.69 .736 .886 r
.2898 .41982 .2949 .42558 .30293 .42202 .29785 .41624 Metetra
.691 .736 .885 r
.29785 .41624 .30293 .42202 .31098 .41842 .30591 .41261 Metetra
.692 .736 .884 r
.30591 .41261 .31098 .41842 .31906 .41478 .314 .40895 Metetra
.694 .736 .883 r
.314 .40895 .31906 .41478 .32715 .41111 .32211 .40525 Metetra
.695 .736 .882 r
.32211 .40525 .32715 .41111 .33527 .4074 .33024 .40151 Metetra
.696 .735 .881 r
.33024 .40151 .33527 .4074 .34341 .40364 .3384 .39772 Metetra
.697 .735 .88 r
.3384 .39772 .34341 .40364 .35157 .39984 .34657 .39389 Metetra
.699 .735 .879 r
.34657 .39389 .35157 .39984 .35975 .39599 .35477 .39002 Metetra
.7 .735 .878 r
.35477 .39002 .35975 .39599 .36795 .39209 .36299 .38609 Metetra
.702 .735 .877 r
.36299 .38609 .36795 .39209 .37617 .38815 .37123 .38211 Metetra
.703 .735 .876 r
.37123 .38211 .37617 .38815 .38442 .38414 .37949 .37807 Metetra
.705 .735 .875 r
.37949 .37807 .38442 .38414 .39269 .38008 .38777 .37398 Metetra
.707 .735 .873 r
.38777 .37398 .39269 .38008 .40097 .37596 .39608 .36983 Metetra
.708 .735 .872 r
.39608 .36983 .40097 .37596 .40928 .37177 .4044 .3656 Metetra
.71 .735 .87 r
.4044 .3656 .40928 .37177 .41761 .36752 .41275 .36131 Metetra
.713 .735 .869 r
.41275 .36131 .41761 .36752 .42596 .36319 .42111 .35695 Metetra
.715 .735 .867 r
.42111 .35695 .42596 .36319 .43433 .35878 .4295 .3525 Metetra
.717 .735 .865 r
.4295 .3525 .43433 .35878 .44272 .35429 .4379 .34797 Metetra
.72 .735 .863 r
.4379 .34797 .44272 .35429 .45113 .34971 .44633 .34334 Metetra
.723 .735 .861 r
.44633 .34334 .45113 .34971 .45955 .34502 .45477 .33862 Metetra
.725 .735 .859 r
.45477 .33862 .45955 .34502 .468 .34024 .46323 .33378 Metetra
.729 .735 .856 r
.46323 .33378 .468 .34024 .47646 .33533 .47171 .32883 Metetra
.732 .735 .854 r
.47171 .32883 .47646 .33533 .48494 .3303 .48021 .32375 Metetra
.736 .735 .851 r
.48021 .32375 .48494 .3303 .49343 .32513 .48872 .31853 Metetra
.74 .735 .848 r
.48872 .31853 .49343 .32513 .50195 .31981 .49725 .31315 Metetra
.744 .735 .844 r
.49725 .31315 .50195 .31981 .51047 .31432 .5058 .3076 Metetra
.749 .735 .84 r
.5058 .3076 .51047 .31432 .51901 .30864 .51435 .30185 Metetra
.754 .736 .836 r
.51435 .30185 .51901 .30864 .52756 .30274 .52292 .29588 Metetra
.759 .736 .831 r
.52292 .29588 .52756 .30274 .53612 .29661 .5315 .28967 Metetra
.765 .736 .825 r
.5315 .28967 .53612 .29661 .54469 .29019 .54009 .28317 Metetra
.772 .735 .819 r
.54009 .28317 .54469 .29019 .55326 .28346 .54868 .27633 Metetra
.78 .735 .812 r
.54868 .27633 .55326 .28346 .56183 .27634 .55727 .26911 Metetra
.788 .735 .803 r
.55727 .26911 .56183 .27634 .57041 .26878 .56586 .26142 Metetra
.798 .735 .793 r
.56586 .26142 .57041 .26878 .57897 .26067 .57444 .25314 Metetra
.809 .734 .781 r
.57444 .25314 .57897 .26067 .58752 .25187 .58301 .24414 Metetra
.822 .733 .766 r
.58301 .24414 .58752 .25187 .59604 .24216 .59154 .23418 Metetra
.837 .731 .747 r
.59154 .23418 .59604 .24216 .60452 .23121 .60004 .22286 Metetra
.856 .728 .72 r
.60004 .22286 .60452 .23121 .61292 .21838 .60845 .20942 Metetra
.883 .722 .678 r
.60845 .20942 .61292 .21838 .62119 .20211 .6167 .19179 Metetra
.934 .711 .577 r
.6167 .19179 .62119 .20211 .62898 .1736 .62432 .15673 Metetra
.605 .494 .7 r
.62432 .15673 .62898 .1736 .6372 .1594 .63293 .15356 Metetra
.664 .741 .908 r
.63293 .15356 .6372 .1594 .64582 .15624 .64157 .15038 Metetra
.664 .741 .908 r
.64157 .15038 .64582 .15624 .65447 .15307 .65024 .14719 Metetra
.664 .741 .908 r
.65024 .14719 .65447 .15307 .66314 .14989 .65893 .14399 Metetra
.664 .741 .908 r
.65893 .14399 .66314 .14989 .67184 .1467 .66765 .14078 Metetra
.664 .741 .908 r
.66765 .14078 .67184 .1467 .68057 .14349 .6764 .13756 Metetra
.664 .741 .908 r
.6764 .13756 .68057 .14349 .68933 .14028 .68517 .13433 Metetra
.664 .741 .908 r
.68517 .13433 .68933 .14028 .69811 .13706 .69398 .13109 Metetra
.664 .741 .908 r
.69398 .13109 .69811 .13706 .70692 .13383 .70281 .12784 Metetra
.664 .741 .908 r
.70281 .12784 .70692 .13383 .71576 .13059 .71166 .12458 Metetra
.664 .741 .908 r
.71166 .12458 .71576 .13059 .72462 .12734 .72055 .12131 Metetra
.664 .741 .908 r
.72055 .12131 .72462 .12734 .73352 .12408 .72946 .11803 Metetra
.664 .741 .908 r
.72946 .11803 .73352 .12408 .74244 .1208 .7384 .11474 Metetra
.664 .741 .908 r
.7384 .11474 .74244 .1208 .75139 .11752 .74737 .11144 Metetra
.664 .741 .908 r
.74737 .11144 .75139 .11752 .76036 .11423 .75636 .10813 Metetra
.675 .738 .898 r
.09785 .49247 .1033 .49773 .11082 .49473 .10538 .48946 Metetra
.675 .738 .897 r
.10538 .48946 .11082 .49473 .11837 .49171 .11294 .48642 Metetra
.676 .738 .897 r
.11294 .48642 .11837 .49171 .12593 .48868 .12051 .48337 Metetra
.676 .738 .897 r
.12051 .48337 .12593 .48868 .13352 .48563 .12811 .4803 Metetra
.677 .737 .896 r
.12811 .4803 .13352 .48563 .14113 .48256 .13573 .4772 Metetra
.677 .737 .896 r
.13573 .4772 .14113 .48256 .14876 .47946 .14338 .47409 Metetra
.678 .737 .896 r
.14338 .47409 .14876 .47946 .15641 .47635 .15104 .47096 Metetra
.678 .737 .895 r
.15104 .47096 .15641 .47635 .16408 .47322 .15873 .46781 Metetra
.679 .737 .895 r
.15873 .46781 .16408 .47322 .17177 .47007 .16643 .46464 Metetra
.679 .737 .894 r
.16643 .46464 .17177 .47007 .17949 .4669 .17416 .46144 Metetra
.68 .737 .894 r
.17416 .46144 .17949 .4669 .18723 .4637 .18191 .45823 Metetra
.68 .737 .893 r
.18191 .45823 .18723 .4637 .19498 .46048 .18969 .45499 Metetra
.681 .737 .893 r
.18969 .45499 .19498 .46048 .20277 .45724 .19748 .45172 Metetra
.682 .737 .892 r
.19748 .45172 .20277 .45724 .21057 .45398 .2053 .44844 Metetra
.682 .737 .892 r
.2053 .44844 .21057 .45398 .21839 .45069 .21314 .44512 Metetra
.683 .737 .891 r
.21314 .44512 .21839 .45069 .22624 .44737 .221 .44178 Metetra
.684 .737 .891 r
.221 .44178 .22624 .44737 .23411 .44403 .22888 .43842 Metetra
.685 .736 .89 r
.22888 .43842 .23411 .44403 .242 .44066 .23678 .43503 Metetra
.685 .736 .89 r
.23678 .43503 .242 .44066 .24991 .43726 .24471 .43161 Metetra
.686 .736 .889 r
.24471 .43161 .24991 .43726 .25784 .43384 .25266 .42816 Metetra
.687 .736 .888 r
.25266 .42816 .25784 .43384 .2658 .43038 .26063 .42468 Metetra
.688 .736 .888 r
.26063 .42468 .2658 .43038 .27378 .42689 .26862 .42117 Metetra
.689 .736 .887 r
.26862 .42117 .27378 .42689 .28178 .42338 .27664 .41762 Metetra
.69 .736 .886 r
.27664 .41762 .28178 .42338 .2898 .41982 .28467 .41404 Metetra
.691 .736 .886 r
.28467 .41404 .2898 .41982 .29785 .41624 .29273 .41043 Metetra
.692 .736 .885 r
.29273 .41043 .29785 .41624 .30591 .41261 .30081 .40678 Metetra
.693 .736 .884 r
.30081 .40678 .30591 .41261 .314 .40895 .30892 .40309 Metetra
.694 .736 .883 r
.30892 .40309 .314 .40895 .32211 .40525 .31704 .39936 Metetra
.695 .736 .882 r
.31704 .39936 .32211 .40525 .33024 .40151 .32519 .39559 Metetra
.696 .736 .881 r
.32519 .39559 .33024 .40151 .3384 .39772 .33336 .39178 Metetra
.698 .736 .88 r
.33336 .39178 .3384 .39772 .34657 .39389 .34155 .38792 Metetra
.699 .736 .879 r
.34155 .38792 .34657 .39389 .35477 .39002 .34976 .38401 Metetra
.701 .736 .878 r
.34976 .38401 .35477 .39002 .36299 .38609 .358 .38006 Metetra
.702 .736 .877 r
.358 .38006 .36299 .38609 .37123 .38211 .36626 .37605 Metetra
.704 .736 .876 r
.36626 .37605 .37123 .38211 .37949 .37807 .37453 .37198 Metetra
.705 .736 .874 r
.37453 .37198 .37949 .37807 .38777 .37398 .38283 .36785 Metetra
.707 .735 .873 r
.38283 .36785 .38777 .37398 .39608 .36983 .39115 .36366 Metetra
.709 .735 .872 r
.39115 .36366 .39608 .36983 .4044 .3656 .39949 .35941 Metetra
.711 .735 .87 r
.39949 .35941 .4044 .3656 .41275 .36131 .40786 .35508 Metetra
.713 .735 .869 r
.40786 .35508 .41275 .36131 .42111 .35695 .41624 .35067 Metetra
.716 .735 .867 r
.41624 .35067 .42111 .35695 .4295 .3525 .42464 .34619 Metetra
.718 .735 .865 r
.42464 .34619 .4295 .3525 .4379 .34797 .43306 .34162 Metetra
.721 .736 .863 r
.43306 .34162 .4379 .34797 .44633 .34334 .44151 .33695 Metetra
.723 .736 .861 r
.44151 .33695 .44633 .34334 .45477 .33862 .44997 .33218 Metetra
.726 .736 .858 r
.44997 .33218 .45477 .33862 .46323 .33378 .45845 .3273 Metetra
.73 .736 .856 r
.45845 .3273 .46323 .33378 .47171 .32883 .46694 .3223 Metetra
.733 .736 .853 r
.46694 .3223 .47171 .32883 .48021 .32375 .47546 .31717 Metetra
.737 .736 .85 r
.47546 .31717 .48021 .32375 .48872 .31853 .48399 .31189 Metetra
.741 .736 .847 r
.48399 .31189 .48872 .31853 .49725 .31315 .49254 .30646 Metetra
.745 .736 .843 r
.49254 .30646 .49725 .31315 .5058 .3076 .5011 .30084 Metetra
.75 .736 .839 r
.5011 .30084 .5058 .3076 .51435 .30185 .50967 .29503 Metetra
.755 .736 .835 r
.50967 .29503 .51435 .30185 .52292 .29588 .51826 .28899 Metetra
.761 .736 .83 r
.51826 .28899 .52292 .29588 .5315 .28967 .52686 .28269 Metetra
.767 .736 .824 r
.52686 .28269 .5315 .28967 .54009 .28317 .53546 .2761 Metetra
.774 .736 .818 r
.53546 .2761 .54009 .28317 .54868 .27633 .54407 .26917 Metetra
.782 .736 .81 r
.54407 .26917 .54868 .27633 .55727 .26911 .55268 .26183 Metetra
.79 .735 .802 r
.55268 .26183 .55727 .26911 .56586 .26142 .56129 .254 Metetra
.8 .735 .791 r
.56129 .254 .56586 .26142 .57444 .25314 .56989 .24556 Metetra
.812 .734 .778 r
.56989 .24556 .57444 .25314 .58301 .24414 .57847 .23635 Metetra
.825 .733 .763 r
.57847 .23635 .58301 .24414 .59154 .23418 .58703 .22611 Metetra
.841 .731 .742 r
.58703 .22611 .59154 .23418 .60004 .22286 .59553 .21438 Metetra
.862 .727 .712 r
.59553 .21438 .60004 .22286 .60845 .20942 .60396 .20023 Metetra
.892 .721 .663 r
.60396 .20023 .60845 .20942 .6167 .19179 .61219 .18075 Metetra
.916 .702 .599 r
.61219 .18075 .6167 .19179 .62432 .15673 .62001 .15087 Metetra
.664 .741 .908 r
.62001 .15087 .62432 .15673 .63293 .15356 .62864 .14768 Metetra
.664 .741 .908 r
.62864 .14768 .63293 .15356 .64157 .15038 .6373 .14448 Metetra
.664 .741 .908 r
.6373 .14448 .64157 .15038 .65024 .14719 .64599 .14127 Metetra
.664 .741 .908 r
.64599 .14127 .65024 .14719 .65893 .14399 .6547 .13805 Metetra
.664 .741 .908 r
.6547 .13805 .65893 .14399 .66765 .14078 .66344 .13483 Metetra
.664 .741 .908 r
.66344 .13483 .66765 .14078 .6764 .13756 .6722 .13159 Metetra
.664 .741 .908 r
.6722 .13159 .6764 .13756 .68517 .13433 .681 .12834 Metetra
.664 .741 .908 r
.681 .12834 .68517 .13433 .69398 .13109 .68982 .12508 Metetra
.664 .741 .908 r
.68982 .12508 .69398 .13109 .70281 .12784 .69867 .12181 Metetra
.664 .741 .908 r
.69867 .12181 .70281 .12784 .71166 .12458 .70754 .11853 Metetra
.664 .741 .908 r
.70754 .11853 .71166 .12458 .72055 .12131 .71644 .11524 Metetra
.664 .741 .908 r
.71644 .11524 .72055 .12131 .72946 .11803 .72538 .11195 Metetra
.664 .741 .908 r
.72538 .11195 .72946 .11803 .7384 .11474 .73434 .10864 Metetra
.664 .741 .908 r
.73434 .10864 .7384 .11474 .74737 .11144 .74332 .10532 Metetra
.664 .741 .908 r
.74332 .10532 .74737 .11144 .75636 .10813 .75234 .10198 Metetra
.675 .738 .898 r
.09236 .4872 .09785 .49247 .10538 .48946 .09991 .48416 Metetra
.675 .738 .897 r
.09991 .48416 .10538 .48946 .11294 .48642 .10748 .48111 Metetra
.676 .738 .897 r
.10748 .48111 .11294 .48642 .12051 .48337 .11507 .47803 Metetra
.676 .738 .897 r
.11507 .47803 .12051 .48337 .12811 .4803 .12268 .47494 Metetra
.677 .738 .896 r
.12268 .47494 .12811 .4803 .13573 .4772 .13032 .47183 Metetra
.677 .738 .896 r
.13032 .47183 .13573 .4772 .14338 .47409 .13797 .4687 Metetra
.678 .737 .896 r
.13797 .4687 .14338 .47409 .15104 .47096 .14565 .46555 Metetra
.678 .737 .895 r
.14565 .46555 .15104 .47096 .15873 .46781 .15335 .46237 Metetra
.679 .737 .895 r
.15335 .46237 .15873 .46781 .16643 .46464 .16107 .45918 Metetra
.68 .737 .894 r
.16107 .45918 .16643 .46464 .17416 .46144 .16881 .45596 Metetra
.68 .737 .894 r
.16881 .45596 .17416 .46144 .18191 .45823 .17657 .45273 Metetra
.681 .737 .893 r
.17657 .45273 .18191 .45823 .18969 .45499 .18436 .44946 Metetra
.681 .737 .893 r
.18436 .44946 .18969 .45499 .19748 .45172 .19217 .44618 Metetra
.682 .737 .892 r
.19217 .44618 .19748 .45172 .2053 .44844 .2 .44287 Metetra
.683 .737 .892 r
.2 .44287 .2053 .44844 .21314 .44512 .20785 .43953 Metetra
.683 .737 .891 r
.20785 .43953 .21314 .44512 .221 .44178 .21572 .43617 Metetra
.684 .737 .891 r
.21572 .43617 .221 .44178 .22888 .43842 .22362 .43278 Metetra
.685 .737 .89 r
.22362 .43278 .22888 .43842 .23678 .43503 .23154 .42937 Metetra
.686 .737 .89 r
.23154 .42937 .23678 .43503 .24471 .43161 .23948 .42592 Metetra
.686 .737 .889 r
.23948 .42592 .24471 .43161 .25266 .42816 .24744 .42245 Metetra
.687 .736 .888 r
.24744 .42245 .25266 .42816 .26063 .42468 .25543 .41895 Metetra
.688 .736 .888 r
.25543 .41895 .26063 .42468 .26862 .42117 .26344 .41541 Metetra
.689 .736 .887 r
.26344 .41541 .26862 .42117 .27664 .41762 .27147 .41184 Metetra
.69 .736 .886 r
.27147 .41184 .27664 .41762 .28467 .41404 .27952 .40824 Metetra
.691 .736 .885 r
.27952 .40824 .28467 .41404 .29273 .41043 .28759 .4046 Metetra
.692 .736 .885 r
.28759 .4046 .29273 .41043 .30081 .40678 .29569 .40092 Metetra
.693 .736 .884 r
.29569 .40092 .30081 .40678 .30892 .40309 .30381 .3972 Metetra
.694 .736 .883 r
.30381 .3972 .30892 .40309 .31704 .39936 .31195 .39345 Metetra
.696 .736 .882 r
.31195 .39345 .31704 .39936 .32519 .39559 .32011 .38965 Metetra
.697 .736 .881 r
.32011 .38965 .32519 .39559 .33336 .39178 .3283 .38581 Metetra
.698 .736 .88 r
.3283 .38581 .33336 .39178 .34155 .38792 .3365 .38192 Metetra
.7 .736 .879 r
.3365 .38192 .34155 .38792 .34976 .38401 .34473 .37798 Metetra
.701 .736 .878 r
.34473 .37798 .34976 .38401 .358 .38006 .35298 .37399 Metetra
.703 .736 .877 r
.35298 .37399 .358 .38006 .36626 .37605 .36126 .36995 Metetra
.704 .736 .876 r
.36126 .36995 .36626 .37605 .37453 .37198 .36955 .36585 Metetra
.706 .736 .874 r
.36955 .36585 .37453 .37198 .38283 .36785 .37787 .36169 Metetra
.708 .736 .873 r
.37787 .36169 .38283 .36785 .39115 .36366 .3862 .35747 Metetra
.71 .736 .871 r
.3862 .35747 .39115 .36366 .39949 .35941 .39456 .35318 Metetra
.712 .736 .87 r
.39456 .35318 .39949 .35941 .40786 .35508 .40294 .34881 Metetra
.714 .736 .868 r
.40294 .34881 .40786 .35508 .41624 .35067 .41134 .34437 Metetra
.716 .736 .866 r
.41134 .34437 .41624 .35067 .42464 .34619 .41976 .33985 Metetra
.719 .736 .865 r
.41976 .33985 .42464 .34619 .43306 .34162 .4282 .33523 Metetra
.721 .736 .863 r
.4282 .33523 .43306 .34162 .44151 .33695 .43666 .33052 Metetra
.724 .736 .86 r
.43666 .33052 .44151 .33695 .44997 .33218 .44514 .32571 Metetra
.727 .736 .858 r
.44514 .32571 .44997 .33218 .45845 .3273 .45364 .32078 Metetra
.73 .736 .855 r
.45364 .32078 .45845 .3273 .46694 .3223 .46215 .31574 Metetra
.734 .736 .853 r
.46215 .31574 .46694 .3223 .47546 .31717 .47068 .31055 Metetra
.738 .736 .85 r
.47068 .31055 .47546 .31717 .48399 .31189 .47923 .30522 Metetra
.742 .736 .846 r
.47923 .30522 .48399 .31189 .49254 .30646 .4878 .29973 Metetra
.746 .736 .843 r
.4878 .29973 .49254 .30646 .5011 .30084 .49638 .29405 Metetra
.751 .736 .839 r
.49638 .29405 .5011 .30084 .50967 .29503 .50497 .28817 Metetra
.756 .736 .834 r
.50497 .28817 .50967 .29503 .51826 .28899 .51358 .28205 Metetra
.762 .736 .829 r
.51358 .28205 .51826 .28899 .52686 .28269 .52219 .27568 Metetra
.769 .736 .823 r
.52219 .27568 .52686 .28269 .53546 .2761 .53082 .26899 Metetra
.776 .736 .816 r
.53082 .26899 .53546 .2761 .54407 .26917 .53944 .26196 Metetra
.784 .736 .809 r
.53944 .26196 .54407 .26917 .55268 .26183 .54807 .25449 Metetra
.793 .736 .8 r
.54807 .25449 .55268 .26183 .56129 .254 .5567 .24652 Metetra
.803 .735 .789 r
.5567 .24652 .56129 .254 .56989 .24556 .56532 .23791 Metetra
.815 .734 .775 r
.56532 .23791 .56989 .24556 .57847 .23635 .57392 .22848 Metetra
.829 .733 .759 r
.57392 .22848 .57847 .23635 .58703 .22611 .58249 .21793 Metetra
.846 .73 .736 r
.58249 .21793 .58703 .22611 .59553 .21438 .59101 .20575 Metetra
.868 .726 .704 r
.59101 .20575 .59553 .21438 .60396 .20023 .59944 .19075 Metetra
.903 .719 .642 r
.59944 .19075 .60396 .20023 .61219 .18075 .60762 .16847 Metetra
.88 .681 .63 r
.60762 .16847 .61219 .18075 .62001 .15087 .61568 .14497 Metetra
.664 .741 .908 r
.61568 .14497 .62001 .15087 .62864 .14768 .62433 .14177 Metetra
.664 .741 .908 r
.62433 .14177 .62864 .14768 .6373 .14448 .63301 .13855 Metetra
.664 .741 .908 r
.63301 .13855 .6373 .14448 .64599 .14127 .64171 .13532 Metetra
.664 .741 .908 r
.64171 .13532 .64599 .14127 .6547 .13805 .65044 .13209 Metetra
.664 .741 .908 r
.65044 .13209 .6547 .13805 .66344 .13483 .6592 .12884 Metetra
.664 .741 .908 r
.6592 .12884 .66344 .13483 .6722 .13159 .66798 .12558 Metetra
.664 .741 .908 r
.66798 .12558 .6722 .13159 .681 .12834 .67679 .12232 Metetra
.664 .741 .908 r
.67679 .12232 .681 .12834 .68982 .12508 .68563 .11904 Metetra
.664 .741 .908 r
.68563 .11904 .68982 .12508 .69867 .12181 .6945 .11575 Metetra
.664 .741 .908 r
.6945 .11575 .69867 .12181 .70754 .11853 .7034 .11245 Metetra
.664 .741 .908 r
.7034 .11245 .70754 .11853 .71644 .11524 .71232 .10915 Metetra
.664 .741 .908 r
.71232 .10915 .71644 .11524 .72538 .11195 .72127 .10583 Metetra
.664 .741 .908 r
.72127 .10583 .72538 .11195 .73434 .10864 .73025 .1025 Metetra
.664 .741 .908 r
.73025 .1025 .73434 .10864 .74332 .10532 .73926 .09916 Metetra
.664 .741 .908 r
.73926 .09916 .74332 .10532 .75234 .10198 .74829 .09581 Metetra
.675 .738 .898 r
.08685 .4819 .09236 .4872 .09991 .48416 .09441 .47884 Metetra
.676 .738 .897 r
.09441 .47884 .09991 .48416 .10748 .48111 .10199 .47577 Metetra
.676 .738 .897 r
.10199 .47577 .10748 .48111 .11507 .47803 .1096 .47267 Metetra
.677 .738 .897 r
.1096 .47267 .11507 .47803 .12268 .47494 .11722 .46956 Metetra
.677 .738 .896 r
.11722 .46956 .12268 .47494 .13032 .47183 .12487 .46643 Metetra
.678 .738 .896 r
.12487 .46643 .13032 .47183 .13797 .4687 .13254 .46328 Metetra
.678 .738 .896 r
.13254 .46328 .13797 .4687 .14565 .46555 .14023 .46011 Metetra
.679 .738 .895 r
.14023 .46011 .14565 .46555 .15335 .46237 .14794 .45691 Metetra
.679 .738 .895 r
.14794 .45691 .15335 .46237 .16107 .45918 .15567 .4537 Metetra
.68 .737 .894 r
.15567 .4537 .16107 .45918 .16881 .45596 .16343 .45046 Metetra
.68 .737 .894 r
.16343 .45046 .16881 .45596 .17657 .45273 .17121 .4472 Metetra
.681 .737 .893 r
.17121 .4472 .17657 .45273 .18436 .44946 .17901 .44392 Metetra
.682 .737 .893 r
.17901 .44392 .18436 .44946 .19217 .44618 .18683 .44061 Metetra
.682 .737 .892 r
.18683 .44061 .19217 .44618 .2 .44287 .19467 .43728 Metetra
.683 .737 .892 r
.19467 .43728 .2 .44287 .20785 .43953 .20254 .43392 Metetra
.684 .737 .891 r
.20254 .43392 .20785 .43953 .21572 .43617 .21043 .43054 Metetra
.684 .737 .891 r
.21043 .43054 .21572 .43617 .22362 .43278 .21834 .42712 Metetra
.685 .737 .89 r
.21834 .42712 .22362 .43278 .23154 .42937 .22627 .42368 Metetra
.686 .737 .889 r
.22627 .42368 .23154 .42937 .23948 .42592 .23423 .42022 Metetra
.687 .737 .889 r
.23423 .42022 .23948 .42592 .24744 .42245 .2422 .41672 Metetra
.688 .737 .888 r
.2422 .41672 .24744 .42245 .25543 .41895 .2502 .41319 Metetra
.689 .737 .888 r
.2502 .41319 .25543 .41895 .26344 .41541 .25823 .40963 Metetra
.69 .737 .887 r
.25823 .40963 .26344 .41541 .27147 .41184 .26627 .40603 Metetra
.691 .737 .886 r
.26627 .40603 .27147 .41184 .27952 .40824 .27434 .4024 Metetra
.692 .736 .885 r
.27434 .4024 .27952 .40824 .28759 .4046 .28243 .39874 Metetra
.693 .736 .885 r
.28243 .39874 .28759 .4046 .29569 .40092 .29054 .39503 Metetra
.694 .736 .884 r
.29054 .39503 .29569 .40092 .30381 .3972 .29867 .39129 Metetra
.695 .736 .883 r
.29867 .39129 .30381 .3972 .31195 .39345 .30683 .38751 Metetra
.696 .736 .882 r
.30683 .38751 .31195 .39345 .32011 .38965 .31501 .38368 Metetra
.697 .736 .881 r
.31501 .38368 .32011 .38965 .3283 .38581 .32321 .37981 Metetra
.699 .736 .88 r
.32321 .37981 .3283 .38581 .3365 .38192 .33143 .37589 Metetra
.7 .736 .879 r
.33143 .37589 .3365 .38192 .34473 .37798 .33968 .37192 Metetra
.702 .736 .878 r
.33968 .37192 .34473 .37798 .35298 .37399 .34794 .36791 Metetra
.703 .736 .877 r
.34794 .36791 .35298 .37399 .36126 .36995 .35623 .36383 Metetra
.705 .736 .875 r
.35623 .36383 .36126 .36995 .36955 .36585 .36454 .3597 Metetra
.707 .736 .874 r
.36454 .3597 .36955 .36585 .37787 .36169 .37288 .35551 Metetra
.708 .736 .873 r
.37288 .35551 .37787 .36169 .3862 .35747 .38123 .35125 Metetra
.71 .736 .871 r
.38123 .35125 .3862 .35747 .39456 .35318 .3896 .34692 Metetra
.712 .736 .87 r
.3896 .34692 .39456 .35318 .40294 .34881 .398 .34252 Metetra
.715 .736 .868 r
.398 .34252 .40294 .34881 .41134 .34437 .40642 .33804 Metetra
.717 .736 .866 r
.40642 .33804 .41134 .34437 .41976 .33985 .41485 .33348 Metetra
.72 .736 .864 r
.41485 .33348 .41976 .33985 .4282 .33523 .42331 .32882 Metetra
.722 .736 .862 r
.42331 .32882 .4282 .33523 .43666 .33052 .43179 .32407 Metetra
.725 .736 .86 r
.43179 .32407 .43666 .33052 .44514 .32571 .44028 .31921 Metetra
.728 .736 .858 r
.44028 .31921 .44514 .32571 .45364 .32078 .4488 .31424 Metetra
.731 .736 .855 r
.4488 .31424 .45364 .32078 .46215 .31574 .45733 .30914 Metetra
.735 .736 .852 r
.45733 .30914 .46215 .31574 .47068 .31055 .46588 .3039 Metetra
.739 .736 .849 r
.46588 .3039 .47068 .31055 .47923 .30522 .47445 .29852 Metetra
.743 .736 .846 r
.47445 .29852 .47923 .30522 .4878 .29973 .48304 .29296 Metetra
.748 .736 .842 r
.48304 .29296 .4878 .29973 .49638 .29405 .49163 .28722 Metetra
.752 .736 .838 r
.49163 .28722 .49638 .29405 .50497 .28817 .50025 .28127 Metetra
.758 .736 .833 r
.50025 .28127 .50497 .28817 .51358 .28205 .50887 .27508 Metetra
.764 .736 .828 r
.50887 .27508 .51358 .28205 .52219 .27568 .51751 .26862 Metetra
.77 .736 .822 r
.51751 .26862 .52219 .27568 .53082 .26899 .52615 .26184 Metetra
.778 .736 .815 r
.52615 .26184 .53082 .26899 .53944 .26196 .5348 .2547 Metetra
.786 .736 .807 r
.5348 .2547 .53944 .26196 .54807 .25449 .54344 .24711 Metetra
.795 .736 .797 r
.54344 .24711 .54807 .25449 .5567 .24652 .55209 .23899 Metetra
.806 .735 .786 r
.55209 .23899 .5567 .24652 .56532 .23791 .56073 .2302 Metetra
.818 .734 .772 r
.56073 .2302 .56532 .23791 .57392 .22848 .56935 .22053 Metetra
.832 .732 .754 r
.56935 .22053 .57392 .22848 .58249 .21793 .57794 .20965 Metetra
.85 .73 .73 r
.57794 .20965 .58249 .21793 .59101 .20575 .58647 .19695 Metetra
.874 .725 .693 r
.58647 .19695 .59101 .20575 .59944 .19075 .5949 .18092 Metetra
.921 .716 .61 r
.5949 .18092 .59944 .19075 .60762 .16847 .60297 .153 Metetra
.778 .607 .668 r
.60297 .153 .60762 .16847 .61568 .14497 .61133 .13905 Metetra
.664 .741 .908 r
.61133 .13905 .61568 .14497 .62433 .14177 .61999 .13582 Metetra
.664 .741 .908 r
.61999 .13582 .62433 .14177 .63301 .13855 .62869 .13259 Metetra
.664 .741 .908 r
.62869 .13259 .63301 .13855 .64171 .13532 .63741 .12934 Metetra
.664 .741 .908 r
.63741 .12934 .64171 .13532 .65044 .13209 .64616 .12608 Metetra
.664 .741 .908 r
.64616 .12608 .65044 .13209 .6592 .12884 .65493 .12282 Metetra
.664 .741 .908 r
.65493 .12282 .6592 .12884 .66798 .12558 .66374 .11954 Metetra
.664 .741 .908 r
.66374 .11954 .66798 .12558 .67679 .12232 .67257 .11626 Metetra
.664 .741 .908 r
.67257 .11626 .67679 .12232 .68563 .11904 .68143 .11296 Metetra
.664 .741 .908 r
.68143 .11296 .68563 .11904 .6945 .11575 .69031 .10965 Metetra
.664 .741 .908 r
.69031 .10965 .6945 .11575 .7034 .11245 .69923 .10634 Metetra
.664 .741 .908 r
.69923 .10634 .7034 .11245 .71232 .10915 .70817 .10301 Metetra
.664 .741 .908 r
.70817 .10301 .71232 .10915 .72127 .10583 .71714 .09967 Metetra
.664 .741 .908 r
.71714 .09967 .72127 .10583 .73025 .1025 .72614 .09632 Metetra
.664 .741 .908 r
.72614 .09632 .73025 .1025 .73926 .09916 .73517 .09296 Metetra
.664 .741 .908 r
.73517 .09296 .73926 .09916 .74829 .09581 .74422 .08959 Metetra
.675 .738 .898 r
.08131 .47657 .08685 .4819 .09441 .47884 .08888 .4735 Metetra
.676 .738 .897 r
.08888 .4735 .09441 .47884 .10199 .47577 .09648 .4704 Metetra
.676 .738 .897 r
.09648 .4704 .10199 .47577 .1096 .47267 .10409 .46729 Metetra
.677 .738 .897 r
.10409 .46729 .1096 .47267 .11722 .46956 .11173 .46416 Metetra
.677 .738 .896 r
.11173 .46416 .11722 .46956 .12487 .46643 .11939 .46101 Metetra
.678 .738 .896 r
.11939 .46101 .12487 .46643 .13254 .46328 .12707 .45783 Metetra
.678 .738 .896 r
.12707 .45783 .13254 .46328 .14023 .46011 .13478 .45464 Metetra
.679 .738 .895 r
.13478 .45464 .14023 .46011 .14794 .45691 .1425 .45143 Metetra
.679 .738 .895 r
.1425 .45143 .14794 .45691 .15567 .4537 .15025 .44819 Metetra
.68 .738 .894 r
.15025 .44819 .15567 .4537 .16343 .45046 .15802 .44493 Metetra
.681 .738 .894 r
.15802 .44493 .16343 .45046 .17121 .4472 .16581 .44165 Metetra
.681 .738 .893 r
.16581 .44165 .17121 .4472 .17901 .44392 .17362 .43834 Metetra
.682 .737 .893 r
.17362 .43834 .17901 .44392 .18683 .44061 .18146 .43501 Metetra
.683 .737 .892 r
.18146 .43501 .18683 .44061 .19467 .43728 .18932 .43166 Metetra
.683 .737 .892 r
.18932 .43166 .19467 .43728 .20254 .43392 .1972 .42828 Metetra
.684 .737 .891 r
.1972 .42828 .20254 .43392 .21043 .43054 .2051 .42487 Metetra
.685 .737 .891 r
.2051 .42487 .21043 .43054 .21834 .42712 .21303 .42144 Metetra
.686 .737 .89 r
.21303 .42144 .21834 .42712 .22627 .42368 .22097 .41797 Metetra
.686 .737 .889 r
.22097 .41797 .22627 .42368 .23423 .42022 .22894 .41448 Metetra
.687 .737 .889 r
.22894 .41448 .23423 .42022 .2422 .41672 .23694 .41096 Metetra
.688 .737 .888 r
.23694 .41096 .2422 .41672 .2502 .41319 .24495 .40741 Metetra
.689 .737 .887 r
.24495 .40741 .2502 .41319 .25823 .40963 .25299 .40382 Metetra
.69 .737 .887 r
.25299 .40382 .25823 .40963 .26627 .40603 .26105 .4002 Metetra
.691 .737 .886 r
.26105 .4002 .26627 .40603 .27434 .4024 .26913 .39654 Metetra
.692 .737 .885 r
.26913 .39654 .27434 .4024 .28243 .39874 .27723 .39285 Metetra
.693 .737 .884 r
.27723 .39285 .28243 .39874 .29054 .39503 .28536 .38912 Metetra
.694 .737 .884 r
.28536 .38912 .29054 .39503 .29867 .39129 .29351 .38535 Metetra
.695 .737 .883 r
.29351 .38535 .29867 .39129 .30683 .38751 .30168 .38154 Metetra
.697 .737 .882 r
.30168 .38154 .30683 .38751 .31501 .38368 .30988 .37768 Metetra
.698 .736 .881 r
.30988 .37768 .31501 .38368 .32321 .37981 .31809 .37378 Metetra
.699 .736 .88 r
.31809 .37378 .32321 .37981 .33143 .37589 .32633 .36984 Metetra
.701 .736 .879 r
.32633 .36984 .33143 .37589 .33968 .37192 .33459 .36584 Metetra
.702 .736 .878 r
.33459 .36584 .33968 .37192 .34794 .36791 .34288 .36179 Metetra
.704 .736 .876 r
.34288 .36179 .34794 .36791 .35623 .36383 .35118 .35768 Metetra
.705 .736 .875 r
.35118 .35768 .35623 .36383 .36454 .3597 .35951 .35352 Metetra
.707 .736 .874 r
.35951 .35352 .36454 .3597 .37288 .35551 .36786 .34929 Metetra
.709 .736 .872 r
.36786 .34929 .37288 .35551 .38123 .35125 .37623 .345 Metetra
.711 .736 .871 r
.37623 .345 .38123 .35125 .3896 .34692 .38462 .34063 Metetra
.713 .736 .869 r
.38462 .34063 .3896 .34692 .398 .34252 .39303 .33619 Metetra
.715 .736 .868 r
.39303 .33619 .398 .34252 .40642 .33804 .40147 .33168 Metetra
.718 .736 .866 r
.40147 .33168 .40642 .33804 .41485 .33348 .40992 .32707 Metetra
.72 .736 .864 r
.40992 .32707 .41485 .33348 .42331 .32882 .4184 .32238 Metetra
.723 .736 .862 r
.4184 .32238 .42331 .32882 .43179 .32407 .42689 .31758 Metetra
.726 .736 .86 r
.42689 .31758 .43179 .32407 .44028 .31921 .43541 .31268 Metetra
.729 .736 .857 r
.43541 .31268 .44028 .31921 .4488 .31424 .44394 .30766 Metetra
.732 .737 .854 r
.44394 .30766 .4488 .31424 .45733 .30914 .45249 .30251 Metetra
.736 .737 .852 r
.45249 .30251 .45733 .30914 .46588 .3039 .46106 .29722 Metetra
.74 .737 .848 r
.46106 .29722 .46588 .3039 .47445 .29852 .46965 .29178 Metetra
.744 .737 .845 r
.46965 .29178 .47445 .29852 .48304 .29296 .47825 .28616 Metetra
.749 .737 .841 r
.47825 .28616 .48304 .29296 .49163 .28722 .48687 .28036 Metetra
.754 .737 .837 r
.48687 .28036 .49163 .28722 .50025 .28127 .4955 .27433 Metetra
.759 .737 .832 r
.4955 .27433 .50025 .28127 .50887 .27508 .50414 .26807 Metetra
.765 .737 .827 r
.50414 .26807 .50887 .27508 .51751 .26862 .51279 .26152 Metetra
.772 .737 .82 r
.51279 .26152 .51751 .26862 .52615 .26184 .52146 .25465 Metetra
.779 .737 .813 r
.52146 .25465 .52615 .26184 .5348 .2547 .53012 .24739 Metetra
.788 .736 .805 r
.53012 .24739 .5348 .2547 .54344 .24711 .53879 .23968 Metetra
.797 .736 .795 r
.53879 .23968 .54344 .24711 .55209 .23899 .54746 .2314 Metetra
.808 .735 .783 r
.54746 .2314 .55209 .23899 .56073 .2302 .55612 .22242 Metetra
.821 .734 .769 r
.55612 .22242 .56073 .2302 .56935 .22053 .56475 .21249 Metetra
.836 .732 .75 r
.56475 .21249 .56935 .22053 .57794 .20965 .57336 .20126 Metetra
.855 .729 .723 r
.57336 .20126 .57794 .20965 .58647 .19695 .58191 .18796 Metetra
.882 .724 .681 r
.58191 .18796 .58647 .19695 .5949 .18092 .59034 .17061 Metetra
.932 .712 .581 r
.59034 .17061 .5949 .18092 .60297 .153 .59829 .13632 Metetra
.605 .496 .703 r
.59829 .13632 .60297 .153 .61133 .13905 .60695 .13308 Metetra
.664 .741 .908 r
.60695 .13308 .61133 .13905 .61999 .13582 .61563 .12984 Metetra
.664 .741 .908 r
.61563 .12984 .61999 .13582 .62869 .13259 .62435 .12659 Metetra
.664 .741 .908 r
.62435 .12659 .62869 .13259 .63741 .12934 .63308 .12332 Metetra
.664 .741 .908 r
.63308 .12332 .63741 .12934 .64616 .12608 .64185 .12005 Metetra
.664 .741 .908 r
.64185 .12005 .64616 .12608 .65493 .12282 .65065 .11676 Metetra
.664 .741 .908 r
.65065 .11676 .65493 .12282 .66374 .11954 .65947 .11347 Metetra
.664 .741 .908 r
.65947 .11347 .66374 .11954 .67257 .11626 .66832 .11016 Metetra
.664 .741 .908 r
.66832 .11016 .67257 .11626 .68143 .11296 .67719 .10685 Metetra
.664 .741 .908 r
.67719 .10685 .68143 .11296 .69031 .10965 .6861 .10352 Metetra
.664 .741 .908 r
.6861 .10352 .69031 .10965 .69923 .10634 .69503 .10019 Metetra
.664 .741 .908 r
.69503 .10019 .69923 .10634 .70817 .10301 .704 .09684 Metetra
.664 .741 .908 r
.704 .09684 .70817 .10301 .71714 .09967 .71299 .09348 Metetra
.664 .741 .908 r
.71299 .09348 .71714 .09967 .72614 .09632 .722 .09011 Metetra
.664 .741 .908 r
.722 .09011 .72614 .09632 .73517 .09296 .73105 .08674 Metetra
.664 .741 .908 r
.73105 .08674 .73517 .09296 .74422 .08959 .74013 .08335 Metetra
.676 .738 .898 r
.07574 .47122 .08131 .47657 .08888 .4735 .08333 .46813 Metetra
.676 .738 .897 r
.08333 .46813 .08888 .4735 .09648 .4704 .09093 .46501 Metetra
.677 .738 .897 r
.09093 .46501 .09648 .4704 .10409 .46729 .09856 .46188 Metetra
.677 .738 .897 r
.09856 .46188 .10409 .46729 .11173 .46416 .10621 .45873 Metetra
.678 .738 .896 r
.10621 .45873 .11173 .46416 .11939 .46101 .11389 .45556 Metetra
.678 .738 .896 r
.11389 .45556 .11939 .46101 .12707 .45783 .12158 .45236 Metetra
.679 .738 .895 r
.12158 .45236 .12707 .45783 .13478 .45464 .1293 .44915 Metetra
.679 .738 .895 r
.1293 .44915 .13478 .45464 .1425 .45143 .13704 .44591 Metetra
.68 .738 .895 r
.13704 .44591 .1425 .45143 .15025 .44819 .1448 .44266 Metetra
.68 .738 .894 r
.1448 .44266 .15025 .44819 .15802 .44493 .15258 .43938 Metetra
.681 .738 .894 r
.15258 .43938 .15802 .44493 .16581 .44165 .16039 .43607 Metetra
.682 .738 .893 r
.16039 .43607 .16581 .44165 .17362 .43834 .16821 .43275 Metetra
.682 .738 .893 r
.16821 .43275 .17362 .43834 .18146 .43501 .17606 .42939 Metetra
.683 .738 .892 r
.17606 .42939 .18146 .43501 .18932 .43166 .18394 .42602 Metetra
.684 .738 .892 r
.18394 .42602 .18932 .43166 .1972 .42828 .19183 .42261 Metetra
.684 .737 .891 r
.19183 .42261 .1972 .42828 .2051 .42487 .19975 .41918 Metetra
.685 .737 .891 r
.19975 .41918 .2051 .42487 .21303 .42144 .20769 .41572 Metetra
.686 .737 .89 r
.20769 .41572 .21303 .42144 .22097 .41797 .21565 .41224 Metetra
.687 .737 .889 r
.21565 .41224 .22097 .41797 .22894 .41448 .22363 .40872 Metetra
.688 .737 .889 r
.22363 .40872 .22894 .41448 .23694 .41096 .23164 .40517 Metetra
.688 .737 .888 r
.23164 .40517 .23694 .41096 .24495 .40741 .23967 .40159 Metetra
.689 .737 .887 r
.23967 .40159 .24495 .40741 .25299 .40382 .24772 .39798 Metetra
.69 .737 .887 r
.24772 .39798 .25299 .40382 .26105 .4002 .2558 .39434 Metetra
.691 .737 .886 r
.2558 .39434 .26105 .4002 .26913 .39654 .26389 .39065 Metetra
.692 .737 .885 r
.26389 .39065 .26913 .39654 .27723 .39285 .27201 .38694 Metetra
.693 .737 .884 r
.27201 .38694 .27723 .39285 .28536 .38912 .28016 .38318 Metetra
.695 .737 .883 r
.28016 .38318 .28536 .38912 .29351 .38535 .28832 .37938 Metetra
.696 .737 .883 r
.28832 .37938 .29351 .38535 .30168 .38154 .29651 .37554 Metetra
.697 .737 .882 r
.29651 .37554 .30168 .38154 .30988 .37768 .30472 .37166 Metetra
.698 .737 .881 r
.30472 .37166 .30988 .37768 .31809 .37378 .31295 .36773 Metetra
.7 .737 .88 r
.31295 .36773 .31809 .37378 .32633 .36984 .32121 .36375 Metetra
.701 .737 .879 r
.32121 .36375 .32633 .36984 .33459 .36584 .32948 .35972 Metetra
.703 .737 .877 r
.32948 .35972 .33459 .36584 .34288 .36179 .33778 .35564 Metetra
.704 .737 .876 r
.33778 .35564 .34288 .36179 .35118 .35768 .34611 .3515 Metetra
.706 .737 .875 r
.34611 .3515 .35118 .35768 .35951 .35352 .35445 .3473 Metetra
.708 .737 .874 r
.35445 .3473 .35951 .35352 .36786 .34929 .36282 .34304 Metetra
.71 .737 .872 r
.36282 .34304 .36786 .34929 .37623 .345 .3712 .33871 Metetra
.712 .737 .871 r
.3712 .33871 .37623 .345 .38462 .34063 .37961 .33431 Metetra
.714 .737 .869 r
.37961 .33431 .38462 .34063 .39303 .33619 .38804 .32984 Metetra
.716 .737 .867 r
.38804 .32984 .39303 .33619 .40147 .33168 .39649 .32528 Metetra
.719 .737 .866 r
.39649 .32528 .40147 .33168 .40992 .32707 .40496 .32064 Metetra
.721 .737 .864 r
.40496 .32064 .40992 .32707 .4184 .32238 .41346 .3159 Metetra
.724 .737 .861 r
.41346 .3159 .4184 .32238 .42689 .31758 .42197 .31106 Metetra
.727 .737 .859 r
.42197 .31106 .42689 .31758 .43541 .31268 .4305 .30611 Metetra
.73 .737 .857 r
.4305 .30611 .43541 .31268 .44394 .30766 .43905 .30104 Metetra
.733 .737 .854 r
.43905 .30104 .44394 .30766 .45249 .30251 .44762 .29585 Metetra
.737 .737 .851 r
.44762 .29585 .45249 .30251 .46106 .29722 .45621 .2905 Metetra
.741 .737 .848 r
.45621 .2905 .46106 .29722 .46965 .29178 .46482 .285 Metetra
.745 .737 .844 r
.46482 .285 .46965 .29178 .47825 .28616 .47344 .27933 Metetra
.75 .737 .84 r
.47344 .27933 .47825 .28616 .48687 .28036 .48207 .27345 Metetra
.755 .737 .836 r
.48207 .27345 .48687 .28036 .4955 .27433 .49072 .26736 Metetra
.761 .737 .831 r
.49072 .26736 .4955 .27433 .50414 .26807 .49939 .26101 Metetra
.767 .737 .825 r
.49939 .26101 .50414 .26807 .51279 .26152 .50806 .25438 Metetra
.774 .737 .819 r
.50806 .25438 .51279 .26152 .52146 .25465 .51674 .24741 Metetra
.781 .737 .812 r
.51674 .24741 .52146 .25465 .53012 .24739 .52543 .24004 Metetra
.79 .737 .803 r
.52543 .24004 .53012 .24739 .53879 .23968 .53412 .23219 Metetra
.8 .736 .793 r
.53412 .23219 .53879 .23968 .54746 .2314 .54281 .22375 Metetra
.811 .735 .781 r
.54281 .22375 .54746 .2314 .55612 .22242 .55148 .21456 Metetra
.824 .734 .765 r
.55148 .21456 .55612 .22242 .56475 .21249 .56014 .20437 Metetra
.84 .732 .745 r
.56014 .20437 .56475 .21249 .57336 .20126 .56876 .19273 Metetra
.86 .728 .715 r
.56876 .19273 .57336 .20126 .58191 .18796 .57733 .17874 Metetra
.891 .722 .666 r
.57733 .17874 .58191 .18796 .59034 .17061 .58575 .15959 Metetra
.915 .704 .603 r
.58575 .15959 .59034 .17061 .59829 .13632 .59387 .13034 Metetra
.664 .741 .908 r
.59387 .13034 .59829 .13632 .60695 .13308 .60254 .12709 Metetra
.664 .741 .908 r
.60254 .12709 .60695 .13308 .61563 .12984 .61125 .12383 Metetra
.664 .741 .908 r
.61125 .12383 .61563 .12984 .62435 .12659 .61998 .12055 Metetra
.664 .741 .908 r
.61998 .12055 .62435 .12659 .63308 .12332 .62873 .11727 Metetra
.664 .741 .908 r
.62873 .11727 .63308 .12332 .64185 .12005 .63752 .11398 Metetra
.664 .741 .908 r
.63752 .11398 .64185 .12005 .65065 .11676 .64633 .11067 Metetra
.664 .741 .908 r
.64633 .11067 .65065 .11676 .65947 .11347 .65517 .10736 Metetra
.664 .741 .908 r
.65517 .10736 .65947 .11347 .66832 .11016 .66404 .10404 Metetra
.664 .741 .908 r
.66404 .10404 .66832 .11016 .67719 .10685 .67294 .1007 Metetra
.664 .741 .908 r
.67294 .1007 .67719 .10685 .6861 .10352 .68186 .09736 Metetra
.664 .741 .908 r
.68186 .09736 .6861 .10352 .69503 .10019 .69082 .094 Metetra
.664 .741 .908 r
.69082 .094 .69503 .10019 .704 .09684 .6998 .09063 Metetra
.664 .741 .908 r
.6998 .09063 .704 .09684 .71299 .09348 .70881 .08726 Metetra
.664 .741 .908 r
.70881 .08726 .71299 .09348 .722 .09011 .71785 .08387 Metetra
.664 .741 .908 r
.71785 .08387 .722 .09011 .73105 .08674 .72691 .08047 Metetra
.664 .741 .908 r
.72691 .08047 .73105 .08674 .74013 .08335 .73601 .07706 Metetra
.676 .739 .898 r
.07014 .46585 .07574 .47122 .08333 .46813 .07774 .46274 Metetra
.676 .739 .897 r
.07774 .46274 .08333 .46813 .09093 .46501 .08536 .4596 Metetra
.677 .739 .897 r
.08536 .4596 .09093 .46501 .09856 .46188 .093 .45645 Metetra
.677 .738 .897 r
.093 .45645 .09856 .46188 .10621 .45873 .10067 .45328 Metetra
.678 .738 .896 r
.10067 .45328 .10621 .45873 .11389 .45556 .10835 .45008 Metetra
.678 .738 .896 r
.10835 .45008 .11389 .45556 .12158 .45236 .11606 .44687 Metetra
.679 .738 .895 r
.11606 .44687 .12158 .45236 .1293 .44915 .12379 .44363 Metetra
.679 .738 .895 r
.12379 .44363 .1293 .44915 .13704 .44591 .13154 .44038 Metetra
.68 .738 .895 r
.13154 .44038 .13704 .44591 .1448 .44266 .13932 .4371 Metetra
.681 .738 .894 r
.13932 .4371 .1448 .44266 .15258 .43938 .14711 .4338 Metetra
.681 .738 .894 r
.14711 .4338 .15258 .43938 .16039 .43607 .15493 .43047 Metetra
.682 .738 .893 r
.15493 .43047 .16039 .43607 .16821 .43275 .16277 .42712 Metetra
.683 .738 .893 r
.16277 .42712 .16821 .43275 .17606 .42939 .17064 .42375 Metetra
.683 .738 .892 r
.17064 .42375 .17606 .42939 .18394 .42602 .17852 .42035 Metetra
.684 .738 .892 r
.17852 .42035 .18394 .42602 .19183 .42261 .18643 .41692 Metetra
.685 .738 .891 r
.18643 .41692 .19183 .42261 .19975 .41918 .19436 .41347 Metetra
.685 .738 .891 r
.19436 .41347 .19975 .41918 .20769 .41572 .20232 .40998 Metetra
.686 .738 .89 r
.20232 .40998 .20769 .41572 .21565 .41224 .21029 .40647 Metetra
.687 .737 .889 r
.21029 .40647 .21565 .41224 .22363 .40872 .21829 .40293 Metetra
.688 .737 .889 r
.21829 .40293 .22363 .40872 .23164 .40517 .22632 .39936 Metetra
.689 .737 .888 r
.22632 .39936 .23164 .40517 .23967 .40159 .23436 .39576 Metetra
.69 .737 .887 r
.23436 .39576 .23967 .40159 .24772 .39798 .24243 .39212 Metetra
.691 .737 .887 r
.24243 .39212 .24772 .39798 .2558 .39434 .25052 .38845 Metetra
.692 .737 .886 r
.25052 .38845 .2558 .39434 .26389 .39065 .25863 .38474 Metetra
.693 .737 .885 r
.25863 .38474 .26389 .39065 .27201 .38694 .26677 .38099 Metetra
.694 .737 .884 r
.26677 .38099 .27201 .38694 .28016 .38318 .27492 .37721 Metetra
.695 .737 .883 r
.27492 .37721 .28016 .38318 .28832 .37938 .2831 .37338 Metetra
.696 .737 .882 r
.2831 .37338 .28832 .37938 .29651 .37554 .29131 .36951 Metetra
.697 .737 .882 r
.29131 .36951 .29651 .37554 .30472 .37166 .29953 .3656 Metetra
.699 .737 .881 r
.29953 .3656 .30472 .37166 .31295 .36773 .30778 .36164 Metetra
.7 .737 .879 r
.30778 .36164 .31295 .36773 .32121 .36375 .31605 .35764 Metetra
.702 .737 .878 r
.31605 .35764 .32121 .36375 .32948 .35972 .32435 .35358 Metetra
.703 .737 .877 r
.32435 .35358 .32948 .35972 .33778 .35564 .33266 .34946 Metetra
.705 .737 .876 r
.33266 .34946 .33778 .35564 .34611 .3515 .341 .34529 Metetra
.707 .737 .875 r
.341 .34529 .34611 .3515 .35445 .3473 .34936 .34106 Metetra
.708 .737 .873 r
.34936 .34106 .35445 .3473 .36282 .34304 .35775 .33676 Metetra
.71 .737 .872 r
.35775 .33676 .36282 .34304 .3712 .33871 .36615 .3324 Metetra
.712 .737 .87 r
.36615 .3324 .3712 .33871 .37961 .33431 .37458 .32796 Metetra
.715 .737 .869 r
.37458 .32796 .37961 .33431 .38804 .32984 .38302 .32345 Metetra
.717 .737 .867 r
.38302 .32345 .38804 .32984 .39649 .32528 .39149 .31886 Metetra
.719 .737 .865 r
.39149 .31886 .39649 .32528 .40496 .32064 .39998 .31417 Metetra
.722 .737 .863 r
.39998 .31417 .40496 .32064 .41346 .3159 .40849 .30939 Metetra
.725 .737 .861 r
.40849 .30939 .41346 .3159 .42197 .31106 .41702 .30451 Metetra
.728 .737 .859 r
.41702 .30451 .42197 .31106 .4305 .30611 .42557 .29951 Metetra
.731 .737 .856 r
.42557 .29951 .4305 .30611 .43905 .30104 .43414 .2944 Metetra
.734 .737 .853 r
.43414 .2944 .43905 .30104 .44762 .29585 .44273 .28915 Metetra
.738 .737 .85 r
.44273 .28915 .44762 .29585 .45621 .2905 .45134 .28375 Metetra
.742 .737 .847 r
.45134 .28375 .45621 .2905 .46482 .285 .45996 .27819 Metetra
.746 .737 .843 r
.45996 .27819 .46482 .285 .47344 .27933 .4686 .27245 Metetra
.751 .737 .839 r
.4686 .27245 .47344 .27933 .48207 .27345 .47726 .26651 Metetra
.756 .737 .835 r
.47726 .26651 .48207 .27345 .49072 .26736 .48593 .26035 Metetra
.762 .737 .83 r
.48593 .26035 .49072 .26736 .49939 .26101 .49461 .25392 Metetra
.769 .737 .824 r
.49461 .25392 .49939 .26101 .50806 .25438 .5033 .24719 Metetra
.776 .737 .818 r
.5033 .24719 .50806 .25438 .51674 .24741 .51201 .24012 Metetra
.783 .737 .81 r
.51201 .24012 .51674 .24741 .52543 .24004 .52071 .23263 Metetra
.792 .737 .801 r
.52071 .23263 .52543 .24004 .53412 .23219 .52942 .22465 Metetra
.802 .736 .791 r
.52942 .22465 .53412 .23219 .54281 .22375 .53813 .21604 Metetra
.814 .735 .778 r
.53813 .21604 .54281 .22375 .55148 .21456 .54683 .20663 Metetra
.828 .734 .761 r
.54683 .20663 .55148 .21456 .56014 .20437 .55551 .19614 Metetra
.844 .731 .739 r
.55551 .19614 .56014 .20437 .56876 .19273 .56415 .18406 Metetra
.866 .727 .707 r
.56415 .18406 .56876 .19273 .57733 .17874 .57272 .16925 Metetra
.902 .72 .646 r
.57272 .16925 .57733 .17874 .58575 .15959 .58112 .14736 Metetra
.879 .683 .633 r
.58112 .14736 .58575 .15959 .59387 .13034 .58942 .12433 Metetra
.664 .741 .908 r
.58942 .12433 .59387 .13034 .60254 .12709 .59811 .12106 Metetra
.664 .741 .908 r
.59811 .12106 .60254 .12709 .61125 .12383 .60683 .11778 Metetra
.664 .741 .908 r
.60683 .11778 .61125 .12383 .61998 .12055 .61558 .11448 Metetra
.664 .741 .908 r
.61558 .11448 .61998 .12055 .62873 .11727 .62436 .11118 Metetra
.664 .741 .908 r
.62436 .11118 .62873 .11727 .63752 .11398 .63316 .10787 Metetra
.664 .741 .908 r
.63316 .10787 .63752 .11398 .64633 .11067 .64199 .10455 Metetra
.664 .741 .908 r
.64199 .10455 .64633 .11067 .65517 .10736 .65085 .10121 Metetra
.664 .741 .908 r
.65085 .10121 .65517 .10736 .66404 .10404 .65974 .09787 Metetra
.664 .741 .908 r
.65974 .09787 .66404 .10404 .67294 .1007 .66866 .09452 Metetra
.664 .741 .908 r
.66866 .09452 .67294 .1007 .68186 .09736 .6776 .09115 Metetra
.664 .741 .908 r
.6776 .09115 .68186 .09736 .69082 .094 .68657 .08778 Metetra
.664 .741 .908 r
.68657 .08778 .69082 .094 .6998 .09063 .69557 .08439 Metetra
.664 .741 .908 r
.69557 .08439 .6998 .09063 .70881 .08726 .7046 .08099 Metetra
.664 .741 .908 r
.7046 .08099 .70881 .08726 .71785 .08387 .71366 .07758 Metetra
.664 .741 .908 r
.71366 .07758 .71785 .08387 .72691 .08047 .72275 .07417 Metetra
.664 .741 .908 r
.72275 .07417 .72691 .08047 .73601 .07706 .73187 .07074 Metetra
.676 .739 .898 r
.06452 .46045 .07014 .46585 .07774 .46274 .07213 .45732 Metetra
.677 .739 .897 r
.07213 .45732 .07774 .46274 .08536 .4596 .07976 .45416 Metetra
.677 .739 .897 r
.07976 .45416 .08536 .4596 .093 .45645 .08741 .45099 Metetra
.678 .739 .897 r
.08741 .45099 .093 .45645 .10067 .45328 .09509 .4478 Metetra
.678 .739 .896 r
.09509 .4478 .10067 .45328 .10835 .45008 .10279 .44458 Metetra
.679 .738 .896 r
.10279 .44458 .10835 .45008 .11606 .44687 .11051 .44135 Metetra
.679 .738 .895 r
.11051 .44135 .11606 .44687 .12379 .44363 .11825 .43809 Metetra
.68 .738 .895 r
.11825 .43809 .12379 .44363 .13154 .44038 .12602 .43481 Metetra
.68 .738 .895 r
.12602 .43481 .13154 .44038 .13932 .4371 .13381 .43151 Metetra
.681 .738 .894 r
.13381 .43151 .13932 .4371 .14711 .4338 .14162 .42819 Metetra
.682 .738 .894 r
.14162 .42819 .14711 .4338 .15493 .43047 .14945 .42484 Metetra
.682 .738 .893 r
.14945 .42484 .15493 .43047 .16277 .42712 .15731 .42147 Metetra
.683 .738 .893 r
.15731 .42147 .16277 .42712 .17064 .42375 .16518 .41807 Metetra
.684 .738 .892 r
.16518 .41807 .17064 .42375 .17852 .42035 .17308 .41465 Metetra
.684 .738 .892 r
.17308 .41465 .17852 .42035 .18643 .41692 .18101 .4112 Metetra
.685 .738 .891 r
.18101 .4112 .18643 .41692 .19436 .41347 .18895 .40772 Metetra
.686 .738 .89 r
.18895 .40772 .19436 .41347 .20232 .40998 .19692 .40422 Metetra
.687 .738 .89 r
.19692 .40422 .20232 .40998 .21029 .40647 .20491 .40068 Metetra
.687 .738 .889 r
.20491 .40068 .21029 .40647 .21829 .40293 .21293 .39712 Metetra
.688 .738 .889 r
.21293 .39712 .21829 .40293 .22632 .39936 .22096 .39352 Metetra
.689 .738 .888 r
.22096 .39352 .22632 .39936 .23436 .39576 .22902 .38989 Metetra
.69 .738 .887 r
.22902 .38989 .23436 .39576 .24243 .39212 .23711 .38623 Metetra
.691 .737 .886 r
.23711 .38623 .24243 .39212 .25052 .38845 .24521 .38253 Metetra
.692 .737 .886 r
.24521 .38253 .25052 .38845 .25863 .38474 .25334 .37879 Metetra
.693 .737 .885 r
.25334 .37879 .25863 .38474 .26677 .38099 .26149 .37502 Metetra
.694 .737 .884 r
.26149 .37502 .26677 .38099 .27492 .37721 .26966 .37121 Metetra
.695 .737 .883 r
.26966 .37121 .27492 .37721 .2831 .37338 .27786 .36736 Metetra
.697 .737 .882 r
.27786 .36736 .2831 .37338 .29131 .36951 .28608 .36346 Metetra
.698 .737 .881 r
.28608 .36346 .29131 .36951 .29953 .3656 .29432 .35952 Metetra
.699 .737 .88 r
.29432 .35952 .29953 .3656 .30778 .36164 .30259 .35553 Metetra
.701 .737 .879 r
.30259 .35553 .30778 .36164 .31605 .35764 .31087 .35149 Metetra
.702 .737 .878 r
.31087 .35149 .31605 .35764 .32435 .35358 .31918 .3474 Metetra
.704 .737 .877 r
.31918 .3474 .32435 .35358 .33266 .34946 .32752 .34325 Metetra
.705 .737 .876 r
.32752 .34325 .33266 .34946 .341 .34529 .33587 .33905 Metetra
.707 .737 .875 r
.33587 .33905 .341 .34529 .34936 .34106 .34425 .33479 Metetra
.709 .737 .873 r
.34425 .33479 .34936 .34106 .35775 .33676 .35265 .33046 Metetra
.711 .737 .872 r
.35265 .33046 .35775 .33676 .36615 .3324 .36107 .32606 Metetra
.713 .737 .87 r
.36107 .32606 .36615 .3324 .37458 .32796 .36951 .32158 Metetra
.715 .737 .868 r
.36951 .32158 .37458 .32796 .38302 .32345 .37798 .31703 Metetra
.718 .737 .867 r
.37798 .31703 .38302 .32345 .39149 .31886 .38647 .3124 Metetra
.72 .737 .865 r
.38647 .3124 .39149 .31886 .39998 .31417 .39497 .30767 Metetra
.723 .737 .863 r
.39497 .30767 .39998 .31417 .40849 .30939 .4035 .30285 Metetra
.726 .737 .861 r
.4035 .30285 .40849 .30939 .41702 .30451 .41205 .29792 Metetra
.729 .737 .858 r
.41205 .29792 .41702 .30451 .42557 .29951 .42062 .29288 Metetra
.732 .737 .856 r
.42062 .29288 .42557 .29951 .43414 .2944 .42921 .28772 Metetra
.735 .737 .853 r
.42921 .28772 .43414 .2944 .44273 .28915 .43781 .28241 Metetra
.739 .737 .85 r
.43781 .28241 .44273 .28915 .45134 .28375 .44644 .27696 Metetra
.743 .738 .846 r
.44644 .27696 .45134 .28375 .45996 .27819 .45508 .27135 Metetra
.748 .738 .843 r
.45508 .27135 .45996 .27819 .4686 .27245 .46374 .26554 Metetra
.753 .738 .839 r
.46374 .26554 .4686 .27245 .47726 .26651 .47242 .25954 Metetra
.758 .738 .834 r
.47242 .25954 .47726 .26651 .48593 .26035 .48111 .25329 Metetra
.764 .738 .829 r
.48111 .25329 .48593 .26035 .49461 .25392 .48981 .24678 Metetra
.77 .738 .823 r
.48981 .24678 .49461 .25392 .5033 .24719 .49852 .23997 Metetra
.777 .737 .816 r
.49852 .23997 .5033 .24719 .51201 .24012 .50725 .23279 Metetra
.785 .737 .808 r
.50725 .23279 .51201 .24012 .52071 .23263 .51597 .22518 Metetra
.794 .737 .799 r
.51597 .22518 .52071 .23263 .52942 .22465 .52471 .21705 Metetra
.805 .736 .788 r
.52471 .21705 .52942 .22465 .53813 .21604 .53343 .20826 Metetra
.817 .735 .774 r
.53343 .20826 .53813 .21604 .54683 .20663 .54215 .19862 Metetra
.831 .734 .757 r
.54215 .19862 .54683 .20663 .55551 .19614 .55085 .18781 Metetra
.849 .731 .733 r
.55085 .18781 .55551 .19614 .56415 .18406 .55951 .17522 Metetra
.873 .726 .697 r
.55951 .17522 .56415 .18406 .57272 .16925 .5681 .1594 Metetra
.919 .717 .613 r
.5681 .1594 .57272 .16925 .58112 .14736 .57644 .13202 Metetra
.778 .609 .67 r
.57644 .13202 .58112 .14736 .58942 .12433 .58494 .11828 Metetra
.664 .741 .908 r
.58494 .11828 .58942 .12433 .59811 .12106 .59365 .11499 Metetra
.664 .741 .908 r
.59365 .11499 .59811 .12106 .60683 .11778 .60239 .11169 Metetra
.664 .741 .908 r
.60239 .11169 .60683 .11778 .61558 .11448 .61116 .10838 Metetra
.664 .741 .908 r
.61116 .10838 .61558 .11448 .62436 .11118 .61996 .10506 Metetra
.664 .741 .908 r
.61996 .10506 .62436 .11118 .63316 .10787 .62878 .10173 Metetra
.664 .741 .908 r
.62878 .10173 .63316 .10787 .64199 .10455 .63763 .09839 Metetra
.664 .741 .908 r
.63763 .09839 .64199 .10455 .65085 .10121 .64651 .09503 Metetra
.664 .741 .908 r
.64651 .09503 .65085 .10121 .65974 .09787 .65542 .09167 Metetra
.664 .741 .908 r
.65542 .09167 .65974 .09787 .66866 .09452 .66435 .0883 Metetra
.664 .741 .908 r
.66435 .0883 .66866 .09452 .6776 .09115 .67331 .08491 Metetra
.664 .741 .908 r
.67331 .08491 .6776 .09115 .68657 .08778 .68231 .08152 Metetra
.664 .741 .908 r
.68231 .08152 .68657 .08778 .69557 .08439 .69133 .07811 Metetra
.664 .741 .908 r
.69133 .07811 .69557 .08439 .7046 .08099 .70038 .07469 Metetra
.664 .741 .908 r
.70038 .07469 .7046 .08099 .71366 .07758 .70945 .07126 Metetra
.664 .741 .908 r
.70945 .07126 .71366 .07758 .72275 .07417 .71856 .06783 Metetra
.664 .741 .908 r
.71856 .06783 .72275 .07417 .73187 .07074 .7277 .06438 Metetra
.676 .739 .898 r
.05886 .45503 .06452 .46045 .07213 .45732 .06648 .45187 Metetra
.677 .739 .897 r
.06648 .45187 .07213 .45732 .07976 .45416 .07413 .4487 Metetra
.677 .739 .897 r
.07413 .4487 .07976 .45416 .08741 .45099 .0818 .44551 Metetra
.678 .739 .897 r
.0818 .44551 .08741 .45099 .09509 .4478 .08949 .44229 Metetra
.678 .739 .896 r
.08949 .44229 .09509 .4478 .10279 .44458 .0972 .43906 Metetra
.679 .739 .896 r
.0972 .43906 .10279 .44458 .11051 .44135 .10493 .4358 Metetra
.679 .739 .895 r
.10493 .4358 .11051 .44135 .11825 .43809 .11269 .43252 Metetra
.68 .739 .895 r
.11269 .43252 .11825 .43809 .12602 .43481 .12047 .42923 Metetra
.681 .738 .895 r
.12047 .42923 .12602 .43481 .13381 .43151 .12827 .4259 Metetra
.681 .738 .894 r
.12827 .4259 .13381 .43151 .14162 .42819 .13609 .42256 Metetra
.682 .738 .894 r
.13609 .42256 .14162 .42819 .14945 .42484 .14394 .41919 Metetra
.682 .738 .893 r
.14394 .41919 .14945 .42484 .15731 .42147 .15181 .41579 Metetra
.683 .738 .893 r
.15181 .41579 .15731 .42147 .16518 .41807 .1597 .41237 Metetra
.684 .738 .892 r
.1597 .41237 .16518 .41807 .17308 .41465 .16762 .40893 Metetra
.685 .738 .892 r
.16762 .40893 .17308 .41465 .18101 .4112 .17555 .40545 Metetra
.685 .738 .891 r
.17555 .40545 .18101 .4112 .18895 .40772 .18351 .40195 Metetra
.686 .738 .89 r
.18351 .40195 .18895 .40772 .19692 .40422 .1915 .39842 Metetra
.687 .738 .89 r
.1915 .39842 .19692 .40422 .20491 .40068 .1995 .39486 Metetra
.688 .738 .889 r
.1995 .39486 .20491 .40068 .21293 .39712 .20753 .39127 Metetra
.689 .738 .888 r
.20753 .39127 .21293 .39712 .22096 .39352 .21558 .38765 Metetra
.689 .738 .888 r
.21558 .38765 .22096 .39352 .22902 .38989 .22366 .384 Metetra
.69 .738 .887 r
.22366 .384 .22902 .38989 .23711 .38623 .23176 .38031 Metetra
.691 .738 .886 r
.23176 .38031 .23711 .38623 .24521 .38253 .23988 .37658 Metetra
.692 .738 .886 r
.23988 .37658 .24521 .38253 .25334 .37879 .24802 .37282 Metetra
.694 .738 .885 r
.24802 .37282 .25334 .37879 .26149 .37502 .25619 .36902 Metetra
.695 .738 .884 r
.25619 .36902 .26149 .37502 .26966 .37121 .26438 .36518 Metetra
.696 .737 .883 r
.26438 .36518 .26966 .37121 .27786 .36736 .27259 .3613 Metetra
.697 .737 .882 r
.27259 .3613 .27786 .36736 .28608 .36346 .28082 .35738 Metetra
.698 .737 .881 r
.28082 .35738 .28608 .36346 .29432 .35952 .28908 .3534 Metetra
.7 .737 .88 r
.28908 .3534 .29432 .35952 .30259 .35553 .29736 .34939 Metetra
.701 .737 .879 r
.29736 .34939 .30259 .35553 .31087 .35149 .30567 .34532 Metetra
.703 .737 .878 r
.30567 .34532 .31087 .35149 .31918 .3474 .31399 .3412 Metetra
.704 .737 .877 r
.31399 .3412 .31918 .3474 .32752 .34325 .32234 .33702 Metetra
.706 .737 .876 r
.32234 .33702 .32752 .34325 .33587 .33905 .33072 .33278 Metetra
.708 .737 .874 r
.33072 .33278 .33587 .33905 .34425 .33479 .33911 .32848 Metetra
.71 .737 .873 r
.33911 .32848 .34425 .33479 .35265 .33046 .34753 .32412 Metetra
.712 .737 .871 r
.34753 .32412 .35265 .33046 .36107 .32606 .35597 .31968 Metetra
.714 .737 .87 r
.35597 .31968 .36107 .32606 .36951 .32158 .36443 .31517 Metetra
.716 .737 .868 r
.36443 .31517 .36951 .32158 .37798 .31703 .37291 .31058 Metetra
.718 .737 .866 r
.37291 .31058 .37798 .31703 .38647 .3124 .38141 .30591 Metetra
.721 .737 .864 r
.38141 .30591 .38647 .3124 .39497 .30767 .38994 .30114 Metetra
.723 .737 .862 r
.38994 .30114 .39497 .30767 .4035 .30285 .39849 .29628 Metetra
.726 .738 .86 r
.39849 .29628 .4035 .30285 .41205 .29792 .40705 .2913 Metetra
.729 .738 .858 r
.40705 .2913 .41205 .29792 .42062 .29288 .41564 .28622 Metetra
.733 .738 .855 r
.41564 .28622 .42062 .29288 .42921 .28772 .42425 .281 Metetra
.736 .738 .852 r
.42425 .281 .42921 .28772 .43781 .28241 .43287 .27565 Metetra
.74 .738 .849 r
.43287 .27565 .43781 .28241 .44644 .27696 .44152 .27014 Metetra
.744 .738 .846 r
.44152 .27014 .44644 .27696 .45508 .27135 .45018 .26446 Metetra
.749 .738 .842 r
.45018 .26446 .45508 .27135 .46374 .26554 .45886 .2586 Metetra
.754 .738 .838 r
.45886 .2586 .46374 .26554 .47242 .25954 .46755 .25252 Metetra
.759 .738 .833 r
.46755 .25252 .47242 .25954 .48111 .25329 .47626 .2462 Metetra
.765 .738 .828 r
.47626 .2462 .48111 .25329 .48981 .24678 .48499 .23961 Metetra
.772 .738 .822 r
.48499 .23961 .48981 .24678 .49852 .23997 .49372 .23269 Metetra
.779 .738 .815 r
.49372 .23269 .49852 .23997 .50725 .23279 .50246 .22541 Metetra
.787 .737 .807 r
.50246 .22541 .50725 .23279 .51597 .22518 .51121 .21767 Metetra
.797 .737 .797 r
.51121 .21767 .51597 .22518 .52471 .21705 .51996 .20939 Metetra
.807 .736 .785 r
.51996 .20939 .52471 .21705 .53343 .20826 .52871 .20041 Metetra
.82 .735 .771 r
.52871 .20041 .53343 .20826 .54215 .19862 .53745 .19052 Metetra
.835 .733 .752 r
.53745 .19052 .54215 .19862 .55085 .18781 .54617 .17936 Metetra
.854 .73 .726 r
.54617 .17936 .55085 .18781 .55951 .17522 .55486 .16619 Metetra
.88 .725 .684 r
.55486 .16619 .55951 .17522 .5681 .1594 .56346 .14908 Metetra
.931 .713 .585 r
.56346 .14908 .5681 .1594 .57644 .13202 .57174 .1155 Metetra
.605 .498 .706 r
.57174 .1155 .57644 .13202 .58494 .11828 .58044 .1122 Metetra
.664 .741 .908 r
.58044 .1122 .58494 .11828 .59365 .11499 .58917 .10889 Metetra
.664 .741 .908 r
.58917 .10889 .59365 .11499 .60239 .11169 .59793 .10557 Metetra
.664 .741 .908 r
.59793 .10557 .60239 .11169 .61116 .10838 .60672 .10224 Metetra
.664 .741 .908 r
.60672 .10224 .61116 .10838 .61996 .10506 .61553 .0989 Metetra
.664 .741 .908 r
.61553 .0989 .61996 .10506 .62878 .10173 .62437 .09555 Metetra
.664 .741 .908 r
.62437 .09555 .62878 .10173 .63763 .09839 .63324 .09219 Metetra
.664 .741 .908 r
.63324 .09219 .63763 .09839 .64651 .09503 .64214 .08882 Metetra
.664 .741 .908 r
.64214 .08882 .64651 .09503 .65542 .09167 .65106 .08543 Metetra
.664 .741 .908 r
.65106 .08543 .65542 .09167 .66435 .0883 .66002 .08204 Metetra
.664 .741 .908 r
.66002 .08204 .66435 .0883 .67331 .08491 .669 .07863 Metetra
.664 .741 .908 r
.669 .07863 .67331 .08491 .68231 .08152 .67801 .07522 Metetra
.664 .741 .908 r
.67801 .07522 .68231 .08152 .69133 .07811 .68705 .07179 Metetra
.664 .741 .908 r
.68705 .07179 .69133 .07811 .70038 .07469 .69612 .06836 Metetra
.664 .741 .908 r
.69612 .06836 .70038 .07469 .70945 .07126 .70522 .06491 Metetra
.664 .741 .908 r
.70522 .06491 .70945 .07126 .71856 .06783 .71435 .06145 Metetra
.664 .741 .908 r
.71435 .06145 .71856 .06783 .7277 .06438 .72351 .05798 Metetra
.677 .739 .898 r
.05317 .44958 .05886 .45503 .06648 .45187 .06081 .44641 Metetra
.677 .739 .897 r
.06081 .44641 .06648 .45187 .07413 .4487 .06847 .44321 Metetra
.678 .739 .897 r
.06847 .44321 .07413 .4487 .0818 .44551 .07615 .44 Metetra
.678 .739 .897 r
.07615 .44 .0818 .44551 .08949 .44229 .08385 .43676 Metetra
.679 .739 .896 r
.08385 .43676 .08949 .44229 .0972 .43906 .09158 .43351 Metetra
.679 .739 .896 r
.09158 .43351 .0972 .43906 .10493 .4358 .09932 .43023 Metetra
.68 .739 .895 r
.09932 .43023 .10493 .4358 .11269 .43252 .10709 .42693 Metetra
.68 .739 .895 r
.10709 .42693 .11269 .43252 .12047 .42923 .11489 .42361 Metetra
.681 .739 .894 r
.11489 .42361 .12047 .42923 .12827 .4259 .1227 .42027 Metetra
.681 .739 .894 r
.1227 .42027 .12827 .4259 .13609 .42256 .13054 .4169 Metetra
.682 .738 .894 r
.13054 .4169 .13609 .42256 .14394 .41919 .1384 .41351 Metetra
.683 .738 .893 r
.1384 .41351 .14394 .41919 .15181 .41579 .14628 .41009 Metetra
.683 .738 .893 r
.14628 .41009 .15181 .41579 .1597 .41237 .15419 .40665 Metetra
.684 .738 .892 r
.15419 .40665 .1597 .41237 .16762 .40893 .16212 .40318 Metetra
.685 .738 .891 r
.16212 .40318 .16762 .40893 .17555 .40545 .17007 .39968 Metetra
.686 .738 .891 r
.17007 .39968 .17555 .40545 .18351 .40195 .17805 .39615 Metetra
.686 .738 .89 r
.17805 .39615 .18351 .40195 .1915 .39842 .18604 .3926 Metetra
.687 .738 .89 r
.18604 .3926 .1915 .39842 .1995 .39486 .19406 .38902 Metetra
.688 .738 .889 r
.19406 .38902 .1995 .39486 .20753 .39127 .20211 .3854 Metetra
.689 .738 .888 r
.20211 .3854 .20753 .39127 .21558 .38765 .21017 .38175 Metetra
.69 .738 .888 r
.21017 .38175 .21558 .38765 .22366 .384 .21826 .37807 Metetra
.691 .738 .887 r
.21826 .37807 .22366 .384 .23176 .38031 .22638 .37436 Metetra
.692 .738 .886 r
.22638 .37436 .23176 .38031 .23988 .37658 .23451 .37061 Metetra
.693 .738 .886 r
.23451 .37061 .23988 .37658 .24802 .37282 .24267 .36682 Metetra
.694 .738 .885 r
.24267 .36682 .24802 .37282 .25619 .36902 .25085 .36299 Metetra
.695 .738 .884 r
.25085 .36299 .25619 .36902 .26438 .36518 .25906 .35913 Metetra
.696 .738 .883 r
.25906 .35913 .26438 .36518 .27259 .3613 .26729 .35522 Metetra
.698 .738 .882 r
.26729 .35522 .27259 .3613 .28082 .35738 .27554 .35126 Metetra
.699 .738 .881 r
.27554 .35126 .28082 .35738 .28908 .3534 .28381 .34726 Metetra
.7 .738 .88 r
.28381 .34726 .28908 .3534 .29736 .34939 .29211 .34321 Metetra
.702 .738 .879 r
.29211 .34321 .29736 .34939 .30567 .34532 .30043 .33911 Metetra
.703 .738 .878 r
.30043 .33911 .30567 .34532 .31399 .3412 .30878 .33496 Metetra
.705 .738 .877 r
.30878 .33496 .31399 .3412 .32234 .33702 .31714 .33075 Metetra
.707 .738 .875 r
.31714 .33075 .32234 .33702 .33072 .33278 .32553 .32648 Metetra
.708 .738 .874 r
.32553 .32648 .33072 .33278 .33911 .32848 .33394 .32215 Metetra
.71 .738 .873 r
.33394 .32215 .33911 .32848 .34753 .32412 .34238 .31775 Metetra
.712 .738 .871 r
.34238 .31775 .34753 .32412 .35597 .31968 .35083 .31328 Metetra
.714 .738 .87 r
.35083 .31328 .35597 .31968 .36443 .31517 .35931 .30873 Metetra
.717 .738 .868 r
.35931 .30873 .36443 .31517 .37291 .31058 .36781 .3041 Metetra
.719 .738 .866 r
.36781 .3041 .37291 .31058 .38141 .30591 .37633 .29939 Metetra
.722 .738 .864 r
.37633 .29939 .38141 .30591 .38994 .30114 .38488 .29458 Metetra
.724 .738 .862 r
.38488 .29458 .38994 .30114 .39849 .29628 .39344 .28967 Metetra
.727 .738 .86 r
.39344 .28967 .39849 .29628 .40705 .2913 .40203 .28465 Metetra
.73 .738 .857 r
.40203 .28465 .40705 .2913 .41564 .28622 .41063 .27951 Metetra
.734 .738 .855 r
.41063 .27951 .41564 .28622 .42425 .281 .41926 .27425 Metetra
.737 .738 .852 r
.41926 .27425 .42425 .281 .43287 .27565 .42791 .26884 Metetra
.741 .738 .849 r
.42791 .26884 .43287 .27565 .44152 .27014 .43657 .26328 Metetra
.745 .738 .845 r
.43657 .26328 .44152 .27014 .45018 .26446 .44525 .25754 Metetra
.75 .738 .841 r
.44525 .25754 .45018 .26446 .45886 .2586 .45395 .25161 Metetra
.755 .738 .837 r
.45395 .25161 .45886 .2586 .46755 .25252 .46267 .24546 Metetra
.761 .738 .832 r
.46267 .24546 .46755 .25252 .47626 .2462 .4714 .23906 Metetra
.767 .738 .827 r
.4714 .23906 .47626 .2462 .48499 .23961 .48014 .23238 Metetra
.774 .738 .82 r
.48014 .23238 .48499 .23961 .49372 .23269 .48889 .22537 Metetra
.781 .738 .813 r
.48889 .22537 .49372 .23269 .50246 .22541 .49766 .21797 Metetra
.789 .738 .805 r
.49766 .21797 .50246 .22541 .51121 .21767 .50643 .21011 Metetra
.799 .737 .795 r
.50643 .21011 .51121 .21767 .51996 .20939 .5152 .20166 Metetra
.81 .736 .783 r
.5152 .20166 .51996 .20939 .52871 .20041 .52397 .19249 Metetra
.823 .735 .767 r
.52397 .19249 .52871 .20041 .53745 .19052 .53274 .18233 Metetra
.839 .733 .747 r
.53274 .18233 .53745 .19052 .54617 .17936 .54148 .17078 Metetra
.859 .729 .718 r
.54148 .17078 .54617 .17936 .55486 .16619 .55018 .15694 Metetra
.889 .723 .67 r
.55018 .15694 .55486 .16619 .56346 .14908 .55879 .13807 Metetra
.913 .705 .607 r
.55879 .13807 .56346 .14908 .57174 .1155 .56719 .1094 Metetra
.664 .741 .908 r
.56719 .1094 .57174 .1155 .58044 .1122 .57592 .10608 Metetra
.664 .741 .908 r
.57592 .10608 .58044 .1122 .58917 .10889 .58466 .10275 Metetra
.664 .741 .908 r
.58466 .10275 .58917 .10889 .59793 .10557 .59344 .09942 Metetra
.664 .741 .908 r
.59344 .09942 .59793 .10557 .60672 .10224 .60225 .09607 Metetra
.664 .741 .908 r
.60225 .09607 .60672 .10224 .61553 .0989 .61108 .09271 Metetra
.664 .741 .908 r
.61108 .09271 .61553 .0989 .62437 .09555 .61994 .08934 Metetra
.664 .741 .908 r
.61994 .08934 .62437 .09555 .63324 .09219 .62883 .08595 Metetra
.664 .741 .908 r
.62883 .08595 .63324 .09219 .64214 .08882 .63774 .08256 Metetra
.664 .741 .908 r
.63774 .08256 .64214 .08882 .65106 .08543 .64669 .07916 Metetra
.664 .741 .908 r
.64669 .07916 .65106 .08543 .66002 .08204 .65566 .07575 Metetra
.664 .741 .908 r
.65566 .07575 .66002 .08204 .669 .07863 .66466 .07232 Metetra
.664 .741 .908 r
.66466 .07232 .669 .07863 .67801 .07522 .6737 .06888 Metetra
.664 .741 .908 r
.6737 .06888 .67801 .07522 .68705 .07179 .68276 .06544 Metetra
.664 .741 .908 r
.68276 .06544 .68705 .07179 .69612 .06836 .69184 .06198 Metetra
.664 .741 .908 r
.69184 .06198 .69612 .06836 .70522 .06491 .70096 .05851 Metetra
.664 .741 .908 r
.70096 .05851 .70522 .06491 .71435 .06145 .71011 .05503 Metetra
.664 .741 .908 r
.71011 .05503 .71435 .06145 .72351 .05798 .71929 .05154 Metetra
.677 .739 .898 r
.04745 .44411 .05317 .44958 .06081 .44641 .0551 .44091 Metetra
.677 .739 .897 r
.0551 .44091 .06081 .44641 .06847 .44321 .06278 .4377 Metetra
.678 .739 .897 r
.06278 .4377 .06847 .44321 .07615 .44 .07047 .43446 Metetra
.678 .739 .897 r
.07047 .43446 .07615 .44 .08385 .43676 .07819 .43121 Metetra
.679 .739 .896 r
.07819 .43121 .08385 .43676 .09158 .43351 .08593 .42793 Metetra
.679 .739 .896 r
.08593 .42793 .09158 .43351 .09932 .43023 .09369 .42463 Metetra
.68 .739 .895 r
.09369 .42463 .09932 .43023 .10709 .42693 .10147 .42131 Metetra
.68 .739 .895 r
.10147 .42131 .10709 .42693 .11489 .42361 .10928 .41797 Metetra
.681 .739 .894 r
.10928 .41797 .11489 .42361 .1227 .42027 .11711 .4146 Metetra
.682 .739 .894 r
.11711 .4146 .1227 .42027 .13054 .4169 .12496 .41121 Metetra
.682 .739 .893 r
.12496 .41121 .13054 .4169 .1384 .41351 .13283 .4078 Metetra
.683 .739 .893 r
.13283 .4078 .1384 .41351 .14628 .41009 .14073 .40436 Metetra
.684 .739 .892 r
.14073 .40436 .14628 .41009 .15419 .40665 .14865 .40089 Metetra
.684 .738 .892 r
.14865 .40089 .15419 .40665 .16212 .40318 .15659 .3974 Metetra
.685 .738 .891 r
.15659 .3974 .16212 .40318 .17007 .39968 .16456 .39388 Metetra
.686 .738 .891 r
.16456 .39388 .17007 .39968 .17805 .39615 .17255 .39033 Metetra
.687 .738 .89 r
.17255 .39033 .17805 .39615 .18604 .3926 .18056 .38675 Metetra
.688 .738 .89 r
.18056 .38675 .18604 .3926 .19406 .38902 .1886 .38314 Metetra
.688 .738 .889 r
.1886 .38314 .19406 .38902 .20211 .3854 .19666 .3795 Metetra
.689 .738 .888 r
.19666 .3795 .20211 .3854 .21017 .38175 .20474 .37583 Metetra
.69 .738 .888 r
.20474 .37583 .21017 .38175 .21826 .37807 .21284 .37212 Metetra
.691 .738 .887 r
.21284 .37212 .21826 .37807 .22638 .37436 .22097 .36838 Metetra
.692 .738 .886 r
.22097 .36838 .22638 .37436 .23451 .37061 .22912 .36461 Metetra
.693 .738 .885 r
.22912 .36461 .23451 .37061 .24267 .36682 .2373 .36079 Metetra
.694 .738 .885 r
.2373 .36079 .24267 .36682 .25085 .36299 .24549 .35694 Metetra
.696 .738 .884 r
.24549 .35694 .25085 .36299 .25906 .35913 .25372 .35304 Metetra
.697 .738 .883 r
.25372 .35304 .25906 .35913 .26729 .35522 .26196 .3491 Metetra
.698 .738 .882 r
.26196 .3491 .26729 .35522 .27554 .35126 .27023 .34512 Metetra
.699 .738 .881 r
.27023 .34512 .27554 .35126 .28381 .34726 .27852 .34109 Metetra
.701 .738 .88 r
.27852 .34109 .28381 .34726 .29211 .34321 .28683 .33701 Metetra
.702 .738 .879 r
.28683 .33701 .29211 .34321 .30043 .33911 .29517 .33288 Metetra
.704 .738 .878 r
.29517 .33288 .30043 .33911 .30878 .33496 .30353 .32869 Metetra
.705 .738 .876 r
.30353 .32869 .30878 .33496 .31714 .33075 .31191 .32445 Metetra
.707 .738 .875 r
.31191 .32445 .31714 .33075 .32553 .32648 .32032 .32015 Metetra
.709 .738 .874 r
.32032 .32015 .32553 .32648 .33394 .32215 .32875 .31578 Metetra
.711 .738 .872 r
.32875 .31578 .33394 .32215 .34238 .31775 .3372 .31134 Metetra
.713 .738 .871 r
.3372 .31134 .34238 .31775 .35083 .31328 .34567 .30684 Metetra
.715 .738 .869 r
.34567 .30684 .35083 .31328 .35931 .30873 .35417 .30225 Metetra
.717 .738 .868 r
.35417 .30225 .35931 .30873 .36781 .3041 .36269 .29759 Metetra
.72 .738 .866 r
.36269 .29759 .36781 .3041 .37633 .29939 .37123 .29283 Metetra
.722 .738 .864 r
.37123 .29283 .37633 .29939 .38488 .29458 .37979 .28798 Metetra
.725 .738 .862 r
.37979 .28798 .38488 .29458 .39344 .28967 .38837 .28303 Metetra
.728 .738 .859 r
.38837 .28303 .39344 .28967 .40203 .28465 .39698 .27796 Metetra
.731 .738 .857 r
.39698 .27796 .40203 .28465 .41063 .27951 .4056 .27278 Metetra
.735 .738 .854 r
.4056 .27278 .41063 .27951 .41926 .27425 .41425 .26746 Metetra
.738 .738 .851 r
.41425 .26746 .41926 .27425 .42791 .26884 .42291 .262 Metetra
.742 .738 .848 r
.42291 .262 .42791 .26884 .43657 .26328 .4316 .25638 Metetra
.747 .738 .844 r
.4316 .25638 .43657 .26328 .44525 .25754 .4403 .25058 Metetra
.751 .738 .84 r
.4403 .25058 .44525 .25754 .45395 .25161 .44902 .24458 Metetra
.756 .738 .836 r
.44902 .24458 .45395 .25161 .46267 .24546 .45775 .23836 Metetra
.762 .738 .831 r
.45775 .23836 .46267 .24546 .4714 .23906 .4665 .23188 Metetra
.768 .738 .825 r
.4665 .23188 .4714 .23906 .48014 .23238 .47527 .22512 Metetra
.775 .738 .819 r
.47527 .22512 .48014 .23238 .48889 .22537 .48404 .218 Metetra
.783 .738 .812 r
.48404 .218 .48889 .22537 .49766 .21797 .49283 .21049 Metetra
.792 .738 .803 r
.49283 .21049 .49766 .21797 .50643 .21011 .50162 .20249 Metetra
.802 .737 .792 r
.50162 .20249 .50643 .21011 .5152 .20166 .51042 .19388 Metetra
.813 .736 .78 r
.51042 .19388 .5152 .20166 .52397 .19249 .51921 .18449 Metetra
.827 .735 .763 r
.51921 .18449 .52397 .19249 .53274 .18233 .528 .17405 Metetra
.843 .732 .742 r
.528 .17405 .53274 .18233 .54148 .17078 .53676 .16205 Metetra
.865 .728 .71 r
.53676 .16205 .54148 .17078 .55018 .15694 .54549 .14741 Metetra
.901 .721 .65 r
.54549 .14741 .55018 .15694 .55879 .13807 .5541 .12588 Metetra
.878 .684 .636 r
.5541 .12588 .55879 .13807 .56719 .1094 .56262 .10327 Metetra
.664 .741 .908 r
.56262 .10327 .56719 .1094 .57592 .10608 .57136 .09993 Metetra
.664 .741 .908 r
.57136 .09993 .57592 .10608 .58466 .10275 .58013 .09658 Metetra
.664 .741 .908 r
.58013 .09658 .58466 .10275 .59344 .09942 .58892 .09322 Metetra
.664 .741 .908 r
.58892 .09322 .59344 .09942 .60225 .09607 .59775 .08985 Metetra
.664 .741 .908 r
.59775 .08985 .60225 .09607 .61108 .09271 .6066 .08647 Metetra
.664 .741 .908 r
.6066 .08647 .61108 .09271 .61994 .08934 .61548 .08308 Metetra
.664 .741 .908 r
.61548 .08308 .61994 .08934 .62883 .08595 .62439 .07968 Metetra
.664 .741 .908 r
.62439 .07968 .62883 .08595 .63774 .08256 .63332 .07627 Metetra
.664 .741 .908 r
.63332 .07627 .63774 .08256 .64669 .07916 .64229 .07285 Metetra
.664 .741 .908 r
.64229 .07285 .64669 .07916 .65566 .07575 .65128 .06941 Metetra
.664 .741 .908 r
.65128 .06941 .65566 .07575 .66466 .07232 .6603 .06597 Metetra
.664 .741 .908 r
.6603 .06597 .66466 .07232 .6737 .06888 .66935 .06251 Metetra
.664 .741 .908 r
.66935 .06251 .6737 .06888 .68276 .06544 .67843 .05905 Metetra
.664 .741 .908 r
.67843 .05905 .68276 .06544 .69184 .06198 .68754 .05557 Metetra
.664 .741 .908 r
.68754 .05557 .69184 .06198 .70096 .05851 .69668 .05208 Metetra
.664 .741 .908 r
.69668 .05208 .70096 .05851 .71011 .05503 .70585 .04858 Metetra
.664 .741 .908 r
.70585 .04858 .71011 .05503 .71929 .05154 .71505 .04507 Metetra
.677 .739 .898 r
.04171 .43861 .04745 .44411 .0551 .44091 .04937 .43539 Metetra
.678 .739 .897 r
.04937 .43539 .0551 .44091 .06278 .4377 .05705 .43215 Metetra
.678 .739 .897 r
.05705 .43215 .06278 .4377 .07047 .43446 .06476 .4289 Metetra
.679 .739 .897 r
.06476 .4289 .07047 .43446 .07819 .43121 .07249 .42562 Metetra
.679 .739 .896 r
.07249 .42562 .07819 .43121 .08593 .42793 .08024 .42232 Metetra
.68 .739 .896 r
.08024 .42232 .08593 .42793 .09369 .42463 .08802 .419 Metetra
.68 .739 .895 r
.08802 .419 .09369 .42463 .10147 .42131 .09582 .41566 Metetra
.681 .739 .895 r
.09582 .41566 .10147 .42131 .10928 .41797 .10364 .4123 Metetra
.681 .739 .894 r
.10364 .4123 .10928 .41797 .11711 .4146 .11148 .40891 Metetra
.682 .739 .894 r
.11148 .40891 .11711 .4146 .12496 .41121 .11934 .4055 Metetra
.683 .739 .893 r
.11934 .4055 .12496 .41121 .13283 .4078 .12723 .40206 Metetra
.683 .739 .893 r
.12723 .40206 .13283 .4078 .14073 .40436 .13514 .3986 Metetra
.684 .739 .892 r
.13514 .3986 .14073 .40436 .14865 .40089 .14308 .39511 Metetra
.685 .739 .892 r
.14308 .39511 .14865 .40089 .15659 .3974 .15104 .39159 Metetra
.685 .739 .891 r
.15104 .39159 .15659 .3974 .16456 .39388 .15902 .38805 Metetra
.686 .739 .891 r
.15902 .38805 .16456 .39388 .17255 .39033 .16702 .38447 Metetra
.687 .739 .89 r
.16702 .38447 .17255 .39033 .18056 .38675 .17505 .38087 Metetra
.688 .738 .89 r
.17505 .38087 .18056 .38675 .1886 .38314 .1831 .37724 Metetra
.689 .738 .889 r
.1831 .37724 .1886 .38314 .19666 .3795 .19117 .37357 Metetra
.69 .738 .888 r
.19117 .37357 .19666 .3795 .20474 .37583 .19927 .36988 Metetra
.691 .738 .888 r
.19927 .36988 .20474 .37583 .21284 .37212 .20739 .36614 Metetra
.692 .738 .887 r
.20739 .36614 .21284 .37212 .22097 .36838 .21553 .36238 Metetra
.693 .738 .886 r
.21553 .36238 .22097 .36838 .22912 .36461 .2237 .35857 Metetra
.694 .738 .885 r
.2237 .35857 .22912 .36461 .2373 .36079 .23189 .35473 Metetra
.695 .738 .884 r
.23189 .35473 .2373 .36079 .24549 .35694 .24011 .35085 Metetra
.696 .738 .884 r
.24011 .35085 .24549 .35694 .25372 .35304 .24834 .34692 Metetra
.697 .738 .883 r
.24834 .34692 .25372 .35304 .26196 .3491 .2566 .34296 Metetra
.698 .738 .882 r
.2566 .34296 .26196 .3491 .27023 .34512 .26489 .33894 Metetra
.7 .738 .881 r
.26489 .33894 .27023 .34512 .27852 .34109 .27319 .33488 Metetra
.701 .738 .88 r
.27319 .33488 .27852 .34109 .28683 .33701 .28153 .33077 Metetra
.703 .738 .879 r
.28153 .33077 .28683 .33701 .29517 .33288 .28988 .32661 Metetra
.704 .738 .877 r
.28988 .32661 .29517 .33288 .30353 .32869 .29826 .3224 Metetra
.706 .738 .876 r
.29826 .3224 .30353 .32869 .31191 .32445 .30666 .31812 Metetra
.708 .738 .875 r
.30666 .31812 .31191 .32445 .32032 .32015 .31508 .31378 Metetra
.709 .738 .874 r
.31508 .31378 .32032 .32015 .32875 .31578 .32353 .30938 Metetra
.711 .738 .872 r
.32353 .30938 .32875 .31578 .3372 .31134 .33199 .30491 Metetra
.713 .738 .871 r
.33199 .30491 .3372 .31134 .34567 .30684 .34049 .30037 Metetra
.716 .738 .869 r
.34049 .30037 .34567 .30684 .35417 .30225 .349 .29574 Metetra
.718 .738 .867 r
.349 .29574 .35417 .30225 .36269 .29759 .35754 .29104 Metetra
.72 .738 .865 r
.35754 .29104 .36269 .29759 .37123 .29283 .3661 .28624 Metetra
.723 .738 .863 r
.3661 .28624 .37123 .29283 .37979 .28798 .37468 .28135 Metetra
.726 .738 .861 r
.37468 .28135 .37979 .28798 .38837 .28303 .38328 .27635 Metetra
.729 .738 .859 r
.38328 .27635 .38837 .28303 .39698 .27796 .3919 .27124 Metetra
.732 .738 .856 r
.3919 .27124 .39698 .27796 .4056 .27278 .40054 .26601 Metetra
.736 .738 .854 r
.40054 .26601 .4056 .27278 .41425 .26746 .40921 .26064 Metetra
.739 .738 .851 r
.40921 .26064 .41425 .26746 .42291 .262 .41789 .25512 Metetra
.743 .739 .847 r
.41789 .25512 .42291 .262 .4316 .25638 .4266 .24944 Metetra
.748 .739 .844 r
.4266 .24944 .4316 .25638 .4403 .25058 .43532 .24358 Metetra
.753 .739 .84 r
.43532 .24358 .4403 .25058 .44902 .24458 .44406 .23752 Metetra
.758 .739 .835 r
.44406 .23752 .44902 .24458 .45775 .23836 .45281 .23122 Metetra
.764 .739 .83 r
.45281 .23122 .45775 .23836 .4665 .23188 .46158 .22466 Metetra
.77 .739 .824 r
.46158 .22466 .4665 .23188 .47527 .22512 .47037 .2178 Metetra
.777 .738 .818 r
.47037 .2178 .47527 .22512 .48404 .218 .47917 .21059 Metetra
.785 .738 .81 r
.47917 .21059 .48404 .218 .49283 .21049 .48798 .20295 Metetra
.794 .738 .801 r
.48798 .20295 .49283 .21049 .50162 .20249 .49679 .19481 Metetra
.804 .737 .79 r
.49679 .19481 .50162 .20249 .51042 .19388 .50561 .18602 Metetra
.816 .736 .776 r
.50561 .18602 .51042 .19388 .51921 .18449 .51443 .17641 Metetra
.83 .735 .759 r
.51443 .17641 .51921 .18449 .528 .17405 .52324 .16565 Metetra
.848 .732 .736 r
.52324 .16565 .528 .17405 .53676 .16205 .53203 .15317 Metetra
.872 .727 .7 r
.53203 .15317 .53676 .16205 .54549 .14741 .54077 .13754 Metetra
.918 .718 .617 r
.54077 .13754 .54549 .14741 .5541 .12588 .54938 .11065 Metetra
.778 .611 .673 r
.54938 .11065 .5541 .12588 .56262 .10327 .55802 .0971 Metetra
.664 .741 .908 r
.55802 .0971 .56262 .10327 .57136 .09993 .56678 .09374 Metetra
.664 .741 .908 r
.56678 .09374 .57136 .09993 .58013 .09658 .57557 .09037 Metetra
.664 .741 .908 r
.57557 .09037 .58013 .09658 .58892 .09322 .58438 .087 Metetra
.664 .741 .908 r
.58438 .087 .58892 .09322 .59775 .08985 .59322 .08361 Metetra
.664 .741 .908 r
.59322 .08361 .59775 .08985 .6066 .08647 .60209 .08021 Metetra
.664 .741 .908 r
.60209 .08021 .6066 .08647 .61548 .08308 .61099 .0768 Metetra
.664 .741 .908 r
.61099 .0768 .61548 .08308 .62439 .07968 .61992 .07338 Metetra
.664 .741 .908 r
.61992 .07338 .62439 .07968 .63332 .07627 .62887 .06994 Metetra
.664 .741 .908 r
.62887 .06994 .63332 .07627 .64229 .07285 .63786 .0665 Metetra
.664 .741 .908 r
.63786 .0665 .64229 .07285 .65128 .06941 .64687 .06305 Metetra
.664 .741 .908 r
.64687 .06305 .65128 .06941 .6603 .06597 .65591 .05958 Metetra
.664 .741 .908 r
.65591 .05958 .6603 .06597 .66935 .06251 .66498 .0561 Metetra
.664 .741 .908 r
.66498 .0561 .66935 .06251 .67843 .05905 .67408 .05262 Metetra
.664 .741 .908 r
.67408 .05262 .67843 .05905 .68754 .05557 .68321 .04912 Metetra
.664 .741 .908 r
.68321 .04912 .68754 .05557 .69668 .05208 .69237 .04561 Metetra
.664 .741 .908 r
.69237 .04561 .69668 .05208 .70585 .04858 .70156 .04208 Metetra
.664 .741 .908 r
.70156 .04208 .70585 .04858 .71505 .04507 .71078 .03855 Metetra
.677 .74 .898 r
.03593 .43308 .04171 .43861 .04937 .43539 .0436 .42984 Metetra
.678 .74 .897 r
.0436 .42984 .04937 .43539 .05705 .43215 .0513 .42659 Metetra
.678 .739 .897 r
.0513 .42659 .05705 .43215 .06476 .4289 .05902 .42331 Metetra
.679 .739 .897 r
.05902 .42331 .06476 .4289 .07249 .42562 .06677 .42001 Metetra
.679 .739 .896 r
.06677 .42001 .07249 .42562 .08024 .42232 .07453 .41669 Metetra
.68 .739 .896 r
.07453 .41669 .08024 .42232 .08802 .419 .08232 .41335 Metetra
.68 .739 .895 r
.08232 .41335 .08802 .419 .09582 .41566 .09013 .40999 Metetra
.681 .739 .895 r
.09013 .40999 .09582 .41566 .10364 .4123 .09797 .4066 Metetra
.682 .739 .894 r
.09797 .4066 .10364 .4123 .11148 .40891 .10582 .40319 Metetra
.682 .739 .894 r
.10582 .40319 .11148 .40891 .11934 .4055 .1137 .39976 Metetra
.683 .739 .893 r
.1137 .39976 .11934 .4055 .12723 .40206 .1216 .3963 Metetra
.684 .739 .893 r
.1216 .3963 .12723 .40206 .13514 .3986 .12953 .39281 Metetra
.684 .739 .892 r
.12953 .39281 .13514 .3986 .14308 .39511 .13748 .3893 Metetra
.685 .739 .892 r
.13748 .3893 .14308 .39511 .15104 .39159 .14545 .38576 Metetra
.686 .739 .891 r
.14545 .38576 .15104 .39159 .15902 .38805 .15345 .38219 Metetra
.687 .739 .891 r
.15345 .38219 .15902 .38805 .16702 .38447 .16147 .37859 Metetra
.687 .739 .89 r
.16147 .37859 .16702 .38447 .17505 .38087 .16951 .37496 Metetra
.688 .739 .889 r
.16951 .37496 .17505 .38087 .1831 .37724 .17757 .37131 Metetra
.689 .739 .889 r
.17757 .37131 .1831 .37724 .19117 .37357 .18566 .36762 Metetra
.69 .739 .888 r
.18566 .36762 .19117 .37357 .19927 .36988 .19377 .36389 Metetra
.691 .739 .887 r
.19377 .36389 .19927 .36988 .20739 .36614 .20191 .36013 Metetra
.692 .738 .887 r
.20191 .36013 .20739 .36614 .21553 .36238 .21007 .35634 Metetra
.693 .738 .886 r
.21007 .35634 .21553 .36238 .2237 .35857 .21825 .35251 Metetra
.694 .738 .885 r
.21825 .35251 .2237 .35857 .23189 .35473 .22646 .34864 Metetra
.695 .738 .884 r
.22646 .34864 .23189 .35473 .24011 .35085 .23469 .34473 Metetra
.696 .738 .883 r
.23469 .34473 .24011 .35085 .24834 .34692 .24294 .34078 Metetra
.698 .738 .883 r
.24294 .34078 .24834 .34692 .2566 .34296 .25122 .33678 Metetra
.699 .738 .882 r
.25122 .33678 .2566 .34296 .26489 .33894 .25952 .33274 Metetra
.7 .738 .881 r
.25952 .33274 .26489 .33894 .27319 .33488 .26784 .32865 Metetra
.702 .738 .88 r
.26784 .32865 .27319 .33488 .28153 .33077 .27619 .32451 Metetra
.703 .738 .878 r
.27619 .32451 .28153 .33077 .28988 .32661 .28456 .32032 Metetra
.705 .738 .877 r
.28456 .32032 .28988 .32661 .29826 .3224 .29295 .31607 Metetra
.706 .738 .876 r
.29295 .31607 .29826 .3224 .30666 .31812 .30137 .31176 Metetra
.708 .738 .875 r
.30137 .31176 .30666 .31812 .31508 .31378 .30981 .30739 Metetra
.71 .738 .873 r
.30981 .30739 .31508 .31378 .32353 .30938 .31828 .30295 Metetra
.712 .738 .872 r
.31828 .30295 .32353 .30938 .33199 .30491 .32676 .29844 Metetra
.714 .738 .87 r
.32676 .29844 .33199 .30491 .34049 .30037 .33527 .29386 Metetra
.716 .738 .869 r
.33527 .29386 .34049 .30037 .349 .29574 .3438 .2892 Metetra
.719 .738 .867 r
.3438 .2892 .349 .29574 .35754 .29104 .35236 .28446 Metetra
.721 .738 .865 r
.35236 .28446 .35754 .29104 .3661 .28624 .36094 .27962 Metetra
.724 .738 .863 r
.36094 .27962 .3661 .28624 .37468 .28135 .36953 .27468 Metetra
.727 .738 .861 r
.36953 .27468 .37468 .28135 .38328 .27635 .37816 .26964 Metetra
.73 .739 .858 r
.37816 .26964 .38328 .27635 .3919 .27124 .3868 .26448 Metetra
.733 .739 .856 r
.3868 .26448 .3919 .27124 .40054 .26601 .39546 .2592 Metetra
.737 .739 .853 r
.39546 .2592 .40054 .26601 .40921 .26064 .40414 .25378 Metetra
.74 .739 .85 r
.40414 .25378 .40921 .26064 .41789 .25512 .41285 .24821 Metetra
.744 .739 .847 r
.41285 .24821 .41789 .25512 .4266 .24944 .42157 .24247 Metetra
.749 .739 .843 r
.42157 .24247 .4266 .24944 .43532 .24358 .43031 .23654 Metetra
.754 .739 .839 r
.43031 .23654 .43532 .24358 .44406 .23752 .43907 .23041 Metetra
.759 .739 .834 r
.43907 .23041 .44406 .23752 .45281 .23122 .44785 .22404 Metetra
.765 .739 .829 r
.44785 .22404 .45281 .23122 .46158 .22466 .45664 .2174 Metetra
.772 .739 .823 r
.45664 .2174 .46158 .22466 .47037 .2178 .46545 .21044 Metetra
.779 .739 .816 r
.46545 .21044 .47037 .2178 .47917 .21059 .47427 .20312 Metetra
.787 .738 .808 r
.47427 .20312 .47917 .21059 .48798 .20295 .4831 .19536 Metetra
.796 .738 .799 r
.4831 .19536 .48798 .20295 .49679 .19481 .49194 .18707 Metetra
.807 .737 .787 r
.49194 .18707 .49679 .19481 .50561 .18602 .50078 .1781 Metetra
.819 .736 .773 r
.50078 .1781 .50561 .18602 .51443 .17641 .50962 .16824 Metetra
.834 .734 .755 r
.50962 .16824 .51443 .17641 .52324 .16565 .51846 .15714 Metetra
.853 .731 .729 r
.51846 .15714 .52324 .16565 .53203 .15317 .52727 .14409 Metetra
.879 .726 .688 r
.52727 .14409 .53203 .15317 .54077 .13754 .53604 .1272 Metetra
.93 .714 .588 r
.53604 .1272 .54077 .13754 .54938 .11065 .54465 .09426 Metetra
.605 .501 .709 r
.54465 .09426 .54938 .11065 .55802 .0971 .5534 .09089 Metetra
.664 .741 .908 r
.5534 .09089 .55802 .0971 .56678 .09374 .56218 .08752 Metetra
.664 .741 .908 r
.56218 .08752 .56678 .09374 .57557 .09037 .57098 .08413 Metetra
.664 .741 .908 r
.57098 .08413 .57557 .09037 .58438 .087 .57981 .08073 Metetra
.664 .741 .908 r
.57981 .08073 .58438 .087 .59322 .08361 .58867 .07732 Metetra
.664 .741 .908 r
.58867 .07732 .59322 .08361 .60209 .08021 .59756 .0739 Metetra
.664 .741 .908 r
.59756 .0739 .60209 .08021 .61099 .0768 .60648 .07047 Metetra
.664 .741 .908 r
.60648 .07047 .61099 .0768 .61992 .07338 .61542 .06703 Metetra
.664 .741 .908 r
.61542 .06703 .61992 .07338 .62887 .06994 .6244 .06358 Metetra
.664 .741 .908 r
.6244 .06358 .62887 .06994 .63786 .0665 .6334 .06011 Metetra
.664 .741 .908 r
.6334 .06011 .63786 .0665 .64687 .06305 .64243 .05664 Metetra
.664 .741 .908 r
.64243 .05664 .64687 .06305 .65591 .05958 .6515 .05315 Metetra
.664 .741 .908 r
.6515 .05315 .65591 .05958 .66498 .0561 .66059 .04966 Metetra
.664 .741 .908 r
.66059 .04966 .66498 .0561 .67408 .05262 .66971 .04615 Metetra
.664 .741 .908 r
.66971 .04615 .67408 .05262 .68321 .04912 .67886 .04263 Metetra
.664 .741 .908 r
.67886 .04263 .68321 .04912 .69237 .04561 .68804 .0391 Metetra
.664 .741 .908 r
.68804 .0391 .69237 .04561 .70156 .04208 .69725 .03555 Metetra
.664 .741 .908 r
.69725 .03555 .70156 .04208 .71078 .03855 .70649 .032 Metetra
.677 .74 .898 r
.03012 .42753 .03593 .43308 .0436 .42984 .03781 .42427 Metetra
.678 .74 .897 r
.03781 .42427 .0436 .42984 .0513 .42659 .04552 .42099 Metetra
.678 .74 .897 r
.04552 .42099 .0513 .42659 .05902 .42331 .05325 .41769 Metetra
.679 .74 .896 r
.05325 .41769 .05902 .42331 .06677 .42001 .06101 .41437 Metetra
.68 .739 .896 r
.06101 .41437 .06677 .42001 .07453 .41669 .06879 .41103 Metetra
.68 .739 .896 r
.06879 .41103 .07453 .41669 .08232 .41335 .07659 .40767 Metetra
.681 .739 .895 r
.07659 .40767 .08232 .41335 .09013 .40999 .08442 .40429 Metetra
.681 .739 .895 r
.08442 .40429 .09013 .40999 .09797 .4066 .09226 .40088 Metetra
.682 .739 .894 r
.09226 .40088 .09797 .4066 .10582 .40319 .10013 .39744 Metetra
.683 .739 .894 r
.10013 .39744 .10582 .40319 .1137 .39976 .10803 .39399 Metetra
.683 .739 .893 r
.10803 .39399 .1137 .39976 .1216 .3963 .11595 .3905 Metetra
.684 .739 .893 r
.11595 .3905 .1216 .3963 .12953 .39281 .12389 .38699 Metetra
.685 .739 .892 r
.12389 .38699 .12953 .39281 .13748 .3893 .13185 .38346 Metetra
.685 .739 .892 r
.13185 .38346 .13748 .3893 .14545 .38576 .13984 .37989 Metetra
.686 .739 .891 r
.13984 .37989 .14545 .38576 .15345 .38219 .14785 .3763 Metetra
.687 .739 .891 r
.14785 .3763 .15345 .38219 .16147 .37859 .15588 .37268 Metetra
.688 .739 .89 r
.15588 .37268 .16147 .37859 .16951 .37496 .16394 .36903 Metetra
.689 .739 .889 r
.16394 .36903 .16951 .37496 .17757 .37131 .17202 .36535 Metetra
.689 .739 .889 r
.17202 .36535 .17757 .37131 .18566 .36762 .18012 .36163 Metetra
.69 .739 .888 r
.18012 .36163 .18566 .36762 .19377 .36389 .18825 .35788 Metetra
.691 .739 .887 r
.18825 .35788 .19377 .36389 .20191 .36013 .1964 .3541 Metetra
.692 .739 .887 r
.1964 .3541 .20191 .36013 .21007 .35634 .20457 .35028 Metetra
.693 .739 .886 r
.20457 .35028 .21007 .35634 .21825 .35251 .21277 .34642 Metetra
.694 .739 .885 r
.21277 .34642 .21825 .35251 .22646 .34864 .221 .34252 Metetra
.696 .739 .884 r
.221 .34252 .22646 .34864 .23469 .34473 .22924 .33858 Metetra
.697 .739 .883 r
.22924 .33858 .23469 .34473 .24294 .34078 .23751 .3346 Metetra
.698 .739 .882 r
.23751 .3346 .24294 .34078 .25122 .33678 .2458 .33058 Metetra
.699 .738 .881 r
.2458 .33058 .25122 .33678 .25952 .33274 .25412 .3265 Metetra
.701 .738 .88 r
.25412 .3265 .25952 .33274 .26784 .32865 .26246 .32238 Metetra
.702 .738 .879 r
.26246 .32238 .26784 .32865 .27619 .32451 .27082 .31821 Metetra
.704 .738 .878 r
.27082 .31821 .27619 .32451 .28456 .32032 .27921 .31399 Metetra
.705 .738 .877 r
.27921 .31399 .28456 .32032 .29295 .31607 .28762 .30971 Metetra
.707 .738 .876 r
.28762 .30971 .29295 .31607 .30137 .31176 .29606 .30536 Metetra
.709 .738 .875 r
.29606 .30536 .30137 .31176 .30981 .30739 .30452 .30096 Metetra
.711 .738 .873 r
.30452 .30096 .30981 .30739 .31828 .30295 .313 .29649 Metetra
.713 .738 .872 r
.313 .29649 .31828 .30295 .32676 .29844 .3215 .29194 Metetra
.715 .739 .87 r
.3215 .29194 .32676 .29844 .33527 .29386 .33003 .28733 Metetra
.717 .739 .868 r
.33003 .28733 .33527 .29386 .3438 .2892 .33858 .28263 Metetra
.719 .739 .867 r
.33858 .28263 .3438 .2892 .35236 .28446 .34715 .27784 Metetra
.722 .739 .865 r
.34715 .27784 .35236 .28446 .36094 .27962 .35575 .27296 Metetra
.725 .739 .863 r
.35575 .27296 .36094 .27962 .36953 .27468 .36437 .26798 Metetra
.727 .739 .86 r
.36437 .26798 .36953 .27468 .37816 .26964 .37301 .26289 Metetra
.731 .739 .858 r
.37301 .26289 .37816 .26964 .3868 .26448 .38167 .25769 Metetra
.734 .739 .855 r
.38167 .25769 .3868 .26448 .39546 .2592 .39035 .25236 Metetra
.737 .739 .852 r
.39035 .25236 .39546 .2592 .40414 .25378 .39905 .24688 Metetra
.741 .739 .849 r
.39905 .24688 .40414 .25378 .41285 .24821 .40778 .24125 Metetra
.746 .739 .846 r
.40778 .24125 .41285 .24821 .42157 .24247 .41652 .23546 Metetra
.75 .739 .842 r
.41652 .23546 .42157 .24247 .43031 .23654 .42528 .22947 Metetra
.755 .739 .838 r
.42528 .22947 .43031 .23654 .43907 .23041 .43406 .22326 Metetra
.761 .739 .833 r
.43406 .22326 .43907 .23041 .44785 .22404 .44286 .21681 Metetra
.767 .739 .828 r
.44286 .21681 .44785 .22404 .45664 .2174 .45168 .21009 Metetra
.773 .739 .822 r
.45168 .21009 .45664 .2174 .46545 .21044 .46051 .20304 Metetra
.781 .739 .815 r
.46051 .20304 .46545 .21044 .47427 .20312 .46935 .19561 Metetra
.789 .739 .806 r
.46935 .19561 .47427 .20312 .4831 .19536 .4782 .18772 Metetra
.798 .738 .796 r
.4782 .18772 .4831 .19536 .49194 .18707 .48706 .17927 Metetra
.809 .737 .784 r
.48706 .17927 .49194 .18707 .50078 .1781 .49593 .1701 Metetra
.822 .736 .769 r
.49593 .1701 .50078 .1781 .50962 .16824 .5048 .15998 Metetra
.838 .734 .75 r
.5048 .15998 .50962 .16824 .51846 .15714 .51366 .1485 Metetra
.858 .73 .721 r
.51366 .1485 .51846 .15714 .52727 .14409 .5225 .13479 Metetra
.888 .724 .673 r
.5225 .13479 .52727 .14409 .53604 .1272 .5313 .11619 Metetra
.912 .706 .61 r
.5313 .11619 .53604 .1272 .54465 .09426 .53998 .08804 Metetra
.664 .741 .908 r
.53998 .08804 .54465 .09426 .5534 .09089 .54875 .08465 Metetra
.664 .741 .908 r
.54875 .08465 .5534 .09089 .56218 .08752 .55754 .08125 Metetra
.664 .741 .908 r
.55754 .08125 .56218 .08752 .57098 .08413 .56636 .07785 Metetra
.664 .741 .908 r
.56636 .07785 .57098 .08413 .57981 .08073 .57522 .07443 Metetra
.664 .741 .908 r
.57522 .07443 .57981 .08073 .58867 .07732 .5841 .071 Metetra
.664 .741 .908 r
.5841 .071 .58867 .07732 .59756 .0739 .593 .06756 Metetra
.664 .741 .908 r
.593 .06756 .59756 .0739 .60648 .07047 .60194 .06411 Metetra
.664 .741 .908 r
.60194 .06411 .60648 .07047 .61542 .06703 .6109 .06065 Metetra
.664 .741 .908 r
.6109 .06065 .61542 .06703 .6244 .06358 .6199 .05717 Metetra
.664 .741 .908 r
.6199 .05717 .6244 .06358 .6334 .06011 .62892 .05369 Metetra
.664 .741 .908 r
.62892 .05369 .6334 .06011 .64243 .05664 .63797 .05019 Metetra
.664 .741 .908 r
.63797 .05019 .64243 .05664 .6515 .05315 .64705 .04669 Metetra
.664 .741 .908 r
.64705 .04669 .6515 .05315 .66059 .04966 .65617 .04317 Metetra
.664 .741 .908 r
.65617 .04317 .66059 .04966 .66971 .04615 .66531 .03964 Metetra
.664 .741 .908 r
.66531 .03964 .66971 .04615 .67886 .04263 .67448 .0361 Metetra
.664 .741 .908 r
.67448 .0361 .67886 .04263 .68804 .0391 .68368 .03255 Metetra
.664 .741 .908 r
.68368 .03255 .68804 .0391 .69725 .03555 .69291 .02898 Metetra
.664 .741 .908 r
.69291 .02898 .69725 .03555 .70649 .032 .70217 .02541 Metetra
.678 .74 .898 r
.02428 .42195 .03012 .42753 .03781 .42427 .03198 .41867 Metetra
.678 .74 .897 r
.03198 .41867 .03781 .42427 .04552 .42099 .03971 .41537 Metetra
.679 .74 .897 r
.03971 .41537 .04552 .42099 .05325 .41769 .04745 .41205 Metetra
.679 .74 .896 r
.04745 .41205 .05325 .41769 .06101 .41437 .05522 .40871 Metetra
.68 .74 .896 r
.05522 .40871 .06101 .41437 .06879 .41103 .06302 .40535 Metetra
.68 .74 .896 r
.06302 .40535 .06879 .41103 .07659 .40767 .07083 .40196 Metetra
.681 .74 .895 r
.07083 .40196 .07659 .40767 .08442 .40429 .07867 .39856 Metetra
.682 .739 .895 r
.07867 .39856 .08442 .40429 .09226 .40088 .08653 .39512 Metetra
.682 .739 .894 r
.08653 .39512 .09226 .40088 .10013 .39744 .09442 .39167 Metetra
.683 .739 .894 r
.09442 .39167 .10013 .39744 .10803 .39399 .10232 .38819 Metetra
.683 .739 .893 r
.10232 .38819 .10803 .39399 .11595 .3905 .11026 .38468 Metetra
.684 .739 .893 r
.11026 .38468 .11595 .3905 .12389 .38699 .11821 .38115 Metetra
.685 .739 .892 r
.11821 .38115 .12389 .38699 .13185 .38346 .12619 .37759 Metetra
.686 .739 .892 r
.12619 .37759 .13185 .38346 .13984 .37989 .13419 .374 Metetra
.686 .739 .891 r
.13419 .374 .13984 .37989 .14785 .3763 .14222 .37039 Metetra
.687 .739 .891 r
.14222 .37039 .14785 .3763 .15588 .37268 .15026 .36674 Metetra
.688 .739 .89 r
.15026 .36674 .15588 .37268 .16394 .36903 .15834 .36306 Metetra
.689 .739 .889 r
.15834 .36306 .16394 .36903 .17202 .36535 .16643 .35935 Metetra
.69 .739 .889 r
.16643 .35935 .17202 .36535 .18012 .36163 .17455 .35561 Metetra
.691 .739 .888 r
.17455 .35561 .18012 .36163 .18825 .35788 .18269 .35184 Metetra
.692 .739 .887 r
.18269 .35184 .18825 .35788 .1964 .3541 .19086 .34803 Metetra
.693 .739 .886 r
.19086 .34803 .1964 .3541 .20457 .35028 .19905 .34418 Metetra
.694 .739 .886 r
.19905 .34418 .20457 .35028 .21277 .34642 .20726 .34029 Metetra
.695 .739 .885 r
.20726 .34029 .21277 .34642 .221 .34252 .2155 .33637 Metetra
.696 .739 .884 r
.2155 .33637 .221 .34252 .22924 .33858 .22376 .3324 Metetra
.697 .739 .883 r
.22376 .3324 .22924 .33858 .23751 .3346 .23205 .32839 Metetra
.698 .739 .882 r
.23205 .32839 .23751 .3346 .2458 .33058 .24036 .32434 Metetra
.7 .739 .881 r
.24036 .32434 .2458 .33058 .25412 .3265 .24869 .32024 Metetra
.701 .739 .88 r
.24869 .32024 .25412 .3265 .26246 .32238 .25705 .31609 Metetra
.703 .739 .879 r
.25705 .31609 .26246 .32238 .27082 .31821 .26543 .31188 Metetra
.704 .739 .878 r
.26543 .31188 .27082 .31821 .27921 .31399 .27384 .30763 Metetra
.706 .739 .877 r
.27384 .30763 .27921 .31399 .28762 .30971 .28226 .30331 Metetra
.707 .739 .876 r
.28226 .30331 .28762 .30971 .29606 .30536 .29072 .29894 Metetra
.709 .739 .874 r
.29072 .29894 .29606 .30536 .30452 .30096 .29919 .2945 Metetra
.711 .739 .873 r
.29919 .2945 .30452 .30096 .313 .29649 .30769 .28999 Metetra
.713 .739 .871 r
.30769 .28999 .313 .29649 .3215 .29194 .31621 .28541 Metetra
.715 .739 .87 r
.31621 .28541 .3215 .29194 .33003 .28733 .32476 .28075 Metetra
.718 .739 .868 r
.32476 .28075 .33003 .28733 .33858 .28263 .33333 .27602 Metetra
.72 .739 .866 r
.33333 .27602 .33858 .28263 .34715 .27784 .34192 .27119 Metetra
.723 .739 .864 r
.34192 .27119 .34715 .27784 .35575 .27296 .35053 .26627 Metetra
.725 .739 .862 r
.35053 .26627 .35575 .27296 .36437 .26798 .35917 .26125 Metetra
.728 .739 .86 r
.35917 .26125 .36437 .26798 .37301 .26289 .36783 .25611 Metetra
.731 .739 .857 r
.36783 .25611 .37301 .26289 .38167 .25769 .37651 .25086 Metetra
.735 .739 .855 r
.37651 .25086 .38167 .25769 .39035 .25236 .38521 .24548 Metetra
.738 .739 .852 r
.38521 .24548 .39035 .25236 .39905 .24688 .39394 .23995 Metetra
.742 .739 .849 r
.39394 .23995 .39905 .24688 .40778 .24125 .40268 .23426 Metetra
.747 .739 .845 r
.40268 .23426 .40778 .24125 .41652 .23546 .41144 .2284 Metetra
.751 .739 .841 r
.41144 .2284 .41652 .23546 .42528 .22947 .42023 .22235 Metetra
.756 .739 .837 r
.42023 .22235 .42528 .22947 .43406 .22326 .42903 .21607 Metetra
.762 .739 .832 r
.42903 .21607 .43406 .22326 .44286 .21681 .43785 .20954 Metetra
.768 .739 .827 r
.43785 .20954 .44286 .21681 .45168 .21009 .44668 .20273 Metetra
.775 .739 .82 r
.44668 .20273 .45168 .21009 .46051 .20304 .45554 .19558 Metetra
.782 .739 .813 r
.45554 .19558 .46051 .20304 .46935 .19561 .4644 .18804 Metetra
.791 .739 .804 r
.4644 .18804 .46935 .19561 .4782 .18772 .47328 .18001 Metetra
.801 .738 .794 r
.47328 .18001 .4782 .18772 .48706 .17927 .48216 .1714 Metetra
.812 .737 .781 r
.48216 .1714 .48706 .17927 .49593 .1701 .49106 .16202 Metetra
.825 .736 .765 r
.49106 .16202 .49593 .1701 .5048 .15998 .49995 .15162 Metetra
.842 .733 .744 r
.49995 .15162 .5048 .15998 .51366 .1485 .50884 .13971 Metetra
.864 .729 .713 r
.50884 .13971 .51366 .1485 .5225 .13479 .51771 .12522 Metetra
.899 .722 .653 r
.51771 .12522 .5225 .13479 .5313 .11619 .52654 .10401 Metetra
.878 .686 .639 r
.52654 .10401 .5313 .11619 .53998 .08804 .53528 .08178 Metetra
.664 .741 .908 r
.53528 .08178 .53998 .08804 .54875 .08465 .54407 .07837 Metetra
.664 .741 .908 r
.54407 .07837 .54875 .08465 .55754 .08125 .55288 .07496 Metetra
.664 .741 .908 r
.55288 .07496 .55754 .08125 .56636 .07785 .56172 .07153 Metetra
.664 .741 .908 r
.56172 .07153 .56636 .07785 .57522 .07443 .57059 .06809 Metetra
.664 .741 .908 r
.57059 .06809 .57522 .07443 .5841 .071 .57949 .06464 Metetra
.664 .741 .908 r
.57949 .06464 .5841 .071 .593 .06756 .58842 .06118 Metetra
.664 .741 .908 r
.58842 .06118 .593 .06756 .60194 .06411 .59737 .05771 Metetra
.664 .741 .908 r
.59737 .05771 .60194 .06411 .6109 .06065 .60636 .05423 Metetra
.664 .741 .908 r
.60636 .05423 .6109 .06065 .6199 .05717 .61537 .05073 Metetra
.664 .741 .908 r
.61537 .05073 .6199 .05717 .62892 .05369 .62441 .04723 Metetra
.664 .741 .908 r
.62441 .04723 .62892 .05369 .63797 .05019 .63348 .04371 Metetra
.664 .741 .908 r
.63348 .04371 .63797 .05019 .64705 .04669 .64259 .04018 Metetra
.664 .741 .908 r
.64259 .04018 .64705 .04669 .65617 .04317 .65172 .03664 Metetra
.664 .741 .908 r
.65172 .03664 .65617 .04317 .66531 .03964 .66088 .03309 Metetra
.664 .741 .908 r
.66088 .03309 .66531 .03964 .67448 .0361 .67007 .02953 Metetra
.664 .741 .908 r
.67007 .02953 .67448 .0361 .68368 .03255 .67929 .02596 Metetra
.664 .741 .908 r
.67929 .02596 .68368 .03255 .69291 .02898 .68854 .02237 Metetra
.664 .741 .908 r
.68854 .02237 .69291 .02898 .70217 .02541 .69782 .01877 Metetra
.678 .74 .898 r
.01841 .41634 .02428 .42195 .03198 .41867 .02612 .41304 Metetra
.678 .74 .897 r
.02612 .41304 .03198 .41867 .03971 .41537 .03386 .40972 Metetra
.679 .74 .897 r
.03386 .40972 .03971 .41537 .04745 .41205 .04162 .40638 Metetra
.679 .74 .896 r
.04162 .40638 .04745 .41205 .05522 .40871 .04941 .40302 Metetra
.68 .74 .896 r
.04941 .40302 .05522 .40871 .06302 .40535 .05721 .39963 Metetra
.681 .74 .896 r
.05721 .39963 .06302 .40535 .07083 .40196 .06504 .39623 Metetra
.681 .74 .895 r
.06504 .39623 .07083 .40196 .07867 .39856 .07289 .3928 Metetra
.682 .74 .895 r
.07289 .3928 .07867 .39856 .08653 .39512 .08077 .38934 Metetra
.682 .74 .894 r
.08077 .38934 .08653 .39512 .09442 .39167 .08867 .38587 Metetra
.683 .74 .894 r
.08867 .38587 .09442 .39167 .10232 .38819 .09659 .38236 Metetra
.684 .739 .893 r
.09659 .38236 .10232 .38819 .11026 .38468 .10454 .37883 Metetra
.684 .739 .893 r
.10454 .37883 .11026 .38468 .11821 .38115 .11251 .37528 Metetra
.685 .739 .892 r
.11251 .37528 .11821 .38115 .12619 .37759 .1205 .37169 Metetra
.686 .739 .892 r
.1205 .37169 .12619 .37759 .13419 .374 .12851 .36808 Metetra
.687 .739 .891 r
.12851 .36808 .13419 .374 .14222 .37039 .13655 .36444 Metetra
.687 .739 .89 r
.13655 .36444 .14222 .37039 .15026 .36674 .14462 .36077 Metetra
.688 .739 .89 r
.14462 .36077 .15026 .36674 .15834 .36306 .1527 .35707 Metetra
.689 .739 .889 r
.1527 .35707 .15834 .36306 .16643 .35935 .16081 .35333 Metetra
.69 .739 .889 r
.16081 .35333 .16643 .35935 .17455 .35561 .16895 .34957 Metetra
.691 .739 .888 r
.16895 .34957 .17455 .35561 .18269 .35184 .17711 .34577 Metetra
.692 .739 .887 r
.17711 .34577 .18269 .35184 .19086 .34803 .18529 .34193 Metetra
.693 .739 .886 r
.18529 .34193 .19086 .34803 .19905 .34418 .1935 .33805 Metetra
.694 .739 .886 r
.1935 .33805 .19905 .34418 .20726 .34029 .20173 .33414 Metetra
.695 .739 .885 r
.20173 .33414 .20726 .34029 .2155 .33637 .20998 .33019 Metetra
.696 .739 .884 r
.20998 .33019 .2155 .33637 .22376 .3324 .21826 .32619 Metetra
.698 .739 .883 r
.21826 .32619 .22376 .3324 .23205 .32839 .22656 .32216 Metetra
.699 .739 .882 r
.22656 .32216 .23205 .32839 .24036 .32434 .23489 .31807 Metetra
.7 .739 .881 r
.23489 .31807 .24036 .32434 .24869 .32024 .24324 .31394 Metetra
.702 .739 .88 r
.24324 .31394 .24869 .32024 .25705 .31609 .25161 .30976 Metetra
.703 .739 .879 r
.25161 .30976 .25705 .31609 .26543 .31188 .26001 .30552 Metetra
.705 .739 .878 r
.26001 .30552 .26543 .31188 .27384 .30763 .26843 .30123 Metetra
.706 .739 .877 r
.26843 .30123 .27384 .30763 .28226 .30331 .27688 .29689 Metetra
.708 .739 .875 r
.27688 .29689 .28226 .30331 .29072 .29894 .28535 .29248 Metetra
.71 .739 .874 r
.28535 .29248 .29072 .29894 .29919 .2945 .29384 .288 Metetra
.712 .739 .873 r
.29384 .288 .29919 .2945 .30769 .28999 .30236 .28346 Metetra
.714 .739 .871 r
.30236 .28346 .30769 .28999 .31621 .28541 .3109 .27884 Metetra
.716 .739 .869 r
.3109 .27884 .31621 .28541 .32476 .28075 .31946 .27415 Metetra
.718 .739 .868 r
.31946 .27415 .32476 .28075 .33333 .27602 .32805 .26937 Metetra
.721 .739 .866 r
.32805 .26937 .33333 .27602 .34192 .27119 .33666 .2645 Metetra
.723 .739 .864 r
.33666 .2645 .34192 .27119 .35053 .26627 .34529 .25954 Metetra
.726 .739 .862 r
.34529 .25954 .35053 .26627 .35917 .26125 .35395 .25447 Metetra
.729 .739 .859 r
.35395 .25447 .35917 .26125 .36783 .25611 .36263 .24929 Metetra
.732 .739 .857 r
.36263 .24929 .36783 .25611 .37651 .25086 .37133 .24399 Metetra
.736 .739 .854 r
.37133 .24399 .37651 .25086 .38521 .24548 .38005 .23856 Metetra
.739 .739 .851 r
.38005 .23856 .38521 .24548 .39394 .23995 .38879 .23298 Metetra
.743 .739 .848 r
.38879 .23298 .39394 .23995 .40268 .23426 .39756 .22723 Metetra
.748 .74 .844 r
.39756 .22723 .40268 .23426 .41144 .2284 .40634 .22131 Metetra
.753 .74 .84 r
.40634 .22131 .41144 .2284 .42023 .22235 .41514 .21519 Metetra
.758 .74 .836 r
.41514 .21519 .42023 .22235 .42903 .21607 .42397 .20884 Metetra
.763 .74 .831 r
.42397 .20884 .42903 .21607 .43785 .20954 .43281 .20223 Metetra
.77 .74 .825 r
.43281 .20223 .43785 .20954 .44668 .20273 .44167 .19533 Metetra
.777 .739 .819 r
.44167 .19533 .44668 .20273 .45554 .19558 .45054 .18808 Metetra
.784 .739 .811 r
.45054 .18808 .45554 .19558 .4644 .18804 .45943 .18041 Metetra
.793 .739 .802 r
.45943 .18041 .4644 .18804 .47328 .18001 .46833 .17225 Metetra
.803 .738 .792 r
.46833 .17225 .47328 .18001 .48216 .1714 .47724 .16346 Metetra
.815 .737 .778 r
.47724 .16346 .48216 .1714 .49106 .16202 .48616 .15387 Metetra
.829 .736 .761 r
.48616 .15387 .49106 .16202 .49995 .15162 .49508 .14316 Metetra
.846 .733 .738 r
.49508 .14316 .49995 .15162 .50884 .13971 .504 .13076 Metetra
.87 .728 .703 r
.504 .13076 .50884 .13971 .51771 .12522 .5129 .11531 Metetra
.917 .719 .62 r
.5129 .11531 .51771 .12522 .52654 .10401 .52177 .08887 Metetra
.778 .613 .676 r
.52177 .08887 .52654 .10401 .53528 .08178 .53056 .07548 Metetra
.664 .741 .908 r
.53056 .07548 .53528 .08178 .54407 .07837 .53936 .07206 Metetra
.664 .741 .908 r
.53936 .07206 .54407 .07837 .55288 .07496 .54819 .06862 Metetra
.664 .741 .908 r
.54819 .06862 .55288 .07496 .56172 .07153 .55705 .06517 Metetra
.664 .741 .908 r
.55705 .06517 .56172 .07153 .57059 .06809 .56594 .06171 Metetra
.664 .741 .908 r
.56594 .06171 .57059 .06809 .57949 .06464 .57486 .05824 Metetra
.664 .741 .908 r
.57486 .05824 .57949 .06464 .58842 .06118 .5838 .05476 Metetra
.664 .741 .908 r
.5838 .05476 .58842 .06118 .59737 .05771 .59278 .05127 Metetra
.664 .741 .908 r
.59278 .05127 .59737 .05771 .60636 .05423 .60178 .04777 Metetra
.664 .741 .908 r
.60178 .04777 .60636 .05423 .61537 .05073 .61082 .04425 Metetra
.664 .741 .908 r
.61082 .04425 .61537 .05073 .62441 .04723 .61988 .04073 Metetra
.664 .741 .908 r
.61988 .04073 .62441 .04723 .63348 .04371 .62897 .03719 Metetra
.664 .741 .908 r
.62897 .03719 .63348 .04371 .64259 .04018 .63809 .03364 Metetra
.664 .741 .908 r
.63809 .03364 .64259 .04018 .65172 .03664 .64724 .03008 Metetra
.664 .741 .908 r
.64724 .03008 .65172 .03664 .66088 .03309 .65642 .02651 Metetra
.664 .741 .908 r
.65642 .02651 .66088 .03309 .67007 .02953 .66563 .02292 Metetra
.664 .741 .908 r
.66563 .02292 .67007 .02953 .67929 .02596 .67487 .01933 Metetra
.664 .741 .908 r
.67487 .01933 .67929 .02596 .68854 .02237 .68415 .01572 Metetra
.664 .741 .908 r
.68415 .01572 .68854 .02237 .69782 .01877 .69345 .0121 Metetra
.678 .74 .898 r
.01251 .4107 .01841 .41634 .02612 .41304 .02024 .40738 Metetra
.679 .74 .897 r
.02024 .40738 .02612 .41304 .03386 .40972 .02799 .40404 Metetra
.679 .74 .897 r
.02799 .40404 .03386 .40972 .04162 .40638 .03576 .40068 Metetra
.68 .74 .896 r
.03576 .40068 .04162 .40638 .04941 .40302 .04356 .3973 Metetra
.68 .74 .896 r
.04356 .3973 .04941 .40302 .05721 .39963 .05138 .39389 Metetra
.681 .74 .896 r
.05138 .39389 .05721 .39963 .06504 .39623 .05922 .39046 Metetra
.681 .74 .895 r
.05922 .39046 .06504 .39623 .07289 .3928 .06709 .38701 Metetra
.682 .74 .895 r
.06709 .38701 .07289 .3928 .08077 .38934 .07498 .38353 Metetra
.683 .74 .894 r
.07498 .38353 .08077 .38934 .08867 .38587 .08289 .38003 Metetra
.683 .74 .894 r
.08289 .38003 .08867 .38587 .09659 .38236 .09083 .37651 Metetra
.684 .74 .893 r
.09083 .37651 .09659 .38236 .10454 .37883 .09879 .37295 Metetra
.685 .74 .893 r
.09879 .37295 .10454 .37883 .11251 .37528 .10677 .36937 Metetra
.685 .74 .892 r
.10677 .36937 .11251 .37528 .1205 .37169 .11478 .36577 Metetra
.686 .739 .892 r
.11478 .36577 .1205 .37169 .12851 .36808 .12281 .36213 Metetra
.687 .739 .891 r
.12281 .36213 .12851 .36808 .13655 .36444 .13086 .35847 Metetra
.688 .739 .89 r
.13086 .35847 .13655 .36444 .14462 .36077 .13894 .35477 Metetra
.689 .739 .89 r
.13894 .35477 .14462 .36077 .1527 .35707 .14704 .35104 Metetra
.689 .739 .889 r
.14704 .35104 .1527 .35707 .16081 .35333 .15517 .34728 Metetra
.69 .739 .888 r
.15517 .34728 .16081 .35333 .16895 .34957 .16332 .34349 Metetra
.691 .739 .888 r
.16332 .34349 .16895 .34957 .17711 .34577 .17149 .33966 Metetra
.692 .739 .887 r
.17149 .33966 .17711 .34577 .18529 .34193 .17969 .3358 Metetra
.693 .739 .886 r
.17969 .3358 .18529 .34193 .1935 .33805 .18791 .3319 Metetra
.694 .739 .885 r
.18791 .3319 .1935 .33805 .20173 .33414 .19616 .32796 Metetra
.696 .739 .885 r
.19616 .32796 .20173 .33414 .20998 .33019 .20443 .32398 Metetra
.697 .739 .884 r
.20443 .32398 .20998 .33019 .21826 .32619 .21272 .31995 Metetra
.698 .739 .883 r
.21272 .31995 .21826 .32619 .22656 .32216 .22104 .31588 Metetra
.699 .739 .882 r
.22104 .31588 .22656 .32216 .23489 .31807 .22938 .31177 Metetra
.701 .739 .881 r
.22938 .31177 .23489 .31807 .24324 .31394 .23775 .30761 Metetra
.702 .739 .88 r
.23775 .30761 .24324 .31394 .25161 .30976 .24614 .3034 Metetra
.704 .739 .879 r
.24614 .3034 .25161 .30976 .26001 .30552 .25456 .29913 Metetra
.705 .739 .878 r
.25456 .29913 .26001 .30552 .26843 .30123 .263 .29481 Metetra
.707 .739 .876 r
.263 .29481 .26843 .30123 .27688 .29689 .27146 .29043 Metetra
.709 .739 .875 r
.27146 .29043 .27688 .29689 .28535 .29248 .27995 .28598 Metetra
.71 .739 .874 r
.27995 .28598 .28535 .29248 .29384 .288 .28846 .28148 Metetra
.712 .739 .872 r
.28846 .28148 .29384 .288 .30236 .28346 .29699 .2769 Metetra
.714 .739 .871 r
.29699 .2769 .30236 .28346 .3109 .27884 .30555 .27224 Metetra
.717 .739 .869 r
.30555 .27224 .3109 .27884 .31946 .27415 .31413 .26751 Metetra
.719 .739 .867 r
.31413 .26751 .31946 .27415 .32805 .26937 .32274 .26269 Metetra
.721 .739 .866 r
.32274 .26269 .32805 .26937 .33666 .2645 .33137 .25778 Metetra
.724 .739 .864 r
.33137 .25778 .33666 .2645 .34529 .25954 .34002 .25278 Metetra
.727 .739 .861 r
.34002 .25278 .34529 .25954 .35395 .25447 .3487 .24766 Metetra
.73 .739 .859 r
.3487 .24766 .35395 .25447 .36263 .24929 .35739 .24244 Metetra
.733 .739 .856 r
.35739 .24244 .36263 .24929 .37133 .24399 .36611 .23709 Metetra
.737 .74 .854 r
.36611 .23709 .37133 .24399 .38005 .23856 .37486 .2316 Metetra
.74 .74 .851 r
.37486 .2316 .38005 .23856 .38879 .23298 .38362 .22596 Metetra
.745 .74 .847 r
.38362 .22596 .38879 .23298 .39756 .22723 .39241 .22016 Metetra
.749 .74 .844 r
.39241 .22016 .39756 .22723 .40634 .22131 .40121 .21418 Metetra
.754 .74 .84 r
.40121 .21418 .40634 .22131 .41514 .21519 .41004 .20799 Metetra
.759 .74 .835 r
.41004 .20799 .41514 .21519 .42397 .20884 .41888 .20156 Metetra
.765 .74 .83 r
.41888 .20156 .42397 .20884 .43281 .20223 .42775 .19487 Metetra
.771 .74 .824 r
.42775 .19487 .43281 .20223 .44167 .19533 .43663 .18788 Metetra
.778 .74 .817 r
.43663 .18788 .44167 .19533 .45054 .18808 .44552 .18052 Metetra
.786 .739 .809 r
.44552 .18052 .45054 .18808 .45943 .18041 .45444 .17273 Metetra
.795 .739 .8 r
.45444 .17273 .45943 .18041 .46833 .17225 .46336 .16442 Metetra
.806 .738 .789 r
.46336 .16442 .46833 .17225 .47724 .16346 .4723 .15546 Metetra
.818 .737 .775 r
.4723 .15546 .47724 .16346 .48616 .15387 .48124 .14562 Metetra
.833 .735 .757 r
.48124 .14562 .48616 .15387 .49508 .14316 .49019 .13457 Metetra
.851 .732 .731 r
.49019 .13457 .49508 .14316 .504 .13076 .49914 .12163 Metetra
.878 .727 .691 r
.49914 .12163 .504 .13076 .5129 .11531 .50808 .10494 Metetra
.929 .715 .592 r
.50808 .10494 .5129 .11531 .52177 .08887 .51701 .07258 Metetra
.604 .503 .712 r
.51701 .07258 .52177 .08887 .53056 .07548 .5258 .06915 Metetra
.664 .741 .908 r
.5258 .06915 .53056 .07548 .53936 .07206 .53463 .0657 Metetra
.664 .741 .908 r
.53463 .0657 .53936 .07206 .54819 .06862 .54348 .06225 Metetra
.664 .741 .908 r
.54348 .06225 .54819 .06862 .55705 .06517 .55236 .05878 Metetra
.664 .741 .908 r
.55236 .05878 .55705 .06517 .56594 .06171 .56126 .0553 Metetra
.664 .741 .908 r
.56126 .0553 .56594 .06171 .57486 .05824 .5702 .05181 Metetra
.664 .741 .908 r
.5702 .05181 .57486 .05824 .5838 .05476 .57916 .04831 Metetra
.664 .741 .908 r
.57916 .04831 .5838 .05476 .59278 .05127 .58816 .04479 Metetra
.664 .741 .908 r
.58816 .04479 .59278 .05127 .60178 .04777 .59718 .04127 Metetra
.664 .741 .908 r
.59718 .04127 .60178 .04777 .61082 .04425 .60623 .03773 Metetra
.664 .741 .908 r
.60623 .03773 .61082 .04425 .61988 .04073 .61532 .03419 Metetra
.664 .741 .908 r
.61532 .03419 .61988 .04073 .62897 .03719 .62443 .03063 Metetra
.664 .741 .908 r
.62443 .03063 .62897 .03719 .63809 .03364 .63357 .02706 Metetra
.664 .741 .908 r
.63357 .02706 .63809 .03364 .64724 .03008 .64274 .02348 Metetra
.664 .741 .908 r
.64274 .02348 .64724 .03008 .65642 .02651 .65194 .01988 Metetra
.664 .741 .908 r
.65194 .01988 .65642 .02651 .66563 .02292 .66117 .01628 Metetra
.664 .741 .908 r
.66117 .01628 .66563 .02292 .67487 .01933 .67043 .01266 Metetra
.664 .741 .908 r
.67043 .01266 .67487 .01933 .68415 .01572 .67973 .00903 Metetra
.664 .741 .908 r
.67973 .00903 .68415 .01572 .69345 .0121 .68905 .00539 Metetra
0 g
.25 Mabswid
.68874 0 m
.96935 .42924 L
s
.96935 .42924 m
1 .6535 L
s
1 .6535 m
.70298 .24544 L
s
.70298 .24544 m
.68874 0 L
s
.03716 .25514 m
0 .48963 L
s
0 .48963 m
.70298 .24544 L
s
.70298 .24544 m
.68874 0 L
s
.68874 0 m
.03716 .25514 L
s
.03716 .25514 m
.68874 0 L
s
.03716 .25514 m
.04196 .25962 L
s
[(0)] .02757 .24618 1 .93395 Mshowa
.15642 .20844 m
.16103 .21311 L
s
[(0.2)] .1472 .1991 .98649 1 Mshowa
.28149 .15946 m
.28589 .16434 L
s
[(0.4)] .2727 .14972 .90225 1 Mshowa
.41282 .10804 m
.41697 .11312 L
s
[(0.6)] .40451 .09788 .81801 1 Mshowa
.55087 .05398 m
.55475 .05927 L
s
[(0.8)] .54311 .0434 .73377 1 Mshowa
.125 Mabswid
.06645 .24367 m
.0693 .24638 L
s
.09609 .23206 m
.09891 .23481 L
s
.12608 .22032 m
.12887 .22309 L
s
.18713 .19641 m
.18986 .19925 L
s
.2182 .18425 m
.22091 .18711 L
s
.24966 .17193 m
.25233 .17482 L
s
.31372 .14684 m
.31632 .1498 L
s
.34635 .13407 m
.34891 .13705 L
s
.37937 .12114 m
.38191 .12415 L
s
.44668 .09478 m
.44913 .09786 L
s
.48097 .08135 m
.48338 .08447 L
s
.5157 .06776 m
.51807 .0709 L
s
.5865 .04003 m
.58878 .04324 L
s
.62258 .0259 m
.62482 .02914 L
s
.65914 .01159 m
.66134 .01486 L
s
gsave
.29165 .07573 -70.3112 -13.8125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 17.8125 translate 1 -1 scale
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
69.000 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{627.812, 509.25},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009c0001oA000`40n007h00OooooooooMOoo003o
oooooomeool00?ooooooogGoo`00oooo__oo0P00]?oo003ooonmool01000ooooo`00/ooo003ooonm
ool01000ooooo`00/ooo003ooonmool01000ooooo`00/ooo003ooonmool01000ooooo`00/ooo003o
oonmool01000ooooo`00/ooo003ooonnool2002dool00?oook;oo`<00;ooo`00oooo/?oo0`0000?o
o`000000__oo003ooon^ool30003ool2002nool00?ooojcoo`8000Goo`800003ool00?oo0;coo`00
ooooZOoo0`001Ooo0P0000F]o@00003oo`000;coo`00ooooY_oo0`001Ooo0`000jgm0P0000?oo`00
ool0^ooo003ooonTool20006ool200000jgm002]o@03[Od01@00[Od00?oo0000^ooo003ooonQool3
0006ool20004[Od01P00[Of]oJgm002]o@800003ool00?oo0;Woo`00ooooWooo0P0000?oo`00ool0
1?oo0P001Zgm00@00:gm[Of]o@8000:]o@800;[oo`00ooooW?oo0`001?oo00<00?oo00000P000Zgm
00<00:gm[Od01:gm0`0000N]o@00[Of]o@00ool0002iool00?oooi[oo`8000Koo`<000F]o@03002]
oJgm00>]o@8000>]o@07002]oJgm[Od00?oo0000^?oo003ooonGool30006ool20002[Od00`00[Of]
o@04[Od00`00[Of]o@020002[Od01000[Of]o@000jgm0`00^?oo003ooonEool20006ool30004[Od0
0`00[Of]o@04[Od30004[Od01@00[Of]o@00[Od00P0000B]o@00ool00;Ooo`00ooooT_oo0`001Ooo
0`0000>]o@00[Od01Jgm00<00:gm[Od00`0000>]o@00[Od01Jgm00@00:gm000000B]o@800;Ooo`00
ooooT?oo0P001Ooo0`001Jgm00<00:gm[Od00jgm0`001Jgm00<00:gm[Od00jgm0`001Jgm00<00?oo
0000]_oo003ooon=ool30005ool20002[Od00`00[Of]o@03[Od00`00[Of]o@030002[Od00`00[Of]
o@03[Od00`00[Of]o@030002[Od00`00[Of]o@04[Od00`00ool0002eool00?oooh[oo`<000Koo`80
00B]o@03002]oJgm00>]o@<000F]o@03002]oJgm00>]o@<000F]o@03002]oJgm00>]o@800003ool0
00000;Coo`00ooooR?oo0P000_oo00<00?ooool00_oo0P001jgm00<00:gm[Od00P000Zgm00<00:gm
[Od01:gm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm0P000Zgm0P000Zgm00<00?oo0000]?oo003o
oon5ool30005ool01000ool000000Zgm00<00:gm[Od01:gm0`001:gm00<00:gm[Od01:gm0`001:gm
00<00:gm[Od00jgm10001:gm00@00?ooool00;?oo`00ooooPooo0P001ooo0`001:gm00<00:gm[Od0
0Zgm0P0000>]o@00[Od01Jgm00<00:gm[Od00`0000>]o@00[Od01Jgm00<00:gm[Od00`0000>]o@00
[Od01Jgm00<00?oo0000/ooo003ooom=ool20004ool00`00ooooo`03ool2000Uool30006ool30000
0jgm002]o@05[Od01000[Od000001:gm00<00:gm[Od00jgm0`001Jgm00<00:gm[Od00jgm0`000Zgm
00@00:gm[Od000F]o@800003ool00?oo0;7oo`00ooooC?oo00@00?ooool000Soo`04003ooooo000R
ool20006ool30005[Od00`00[Of]o@03[Od20006[Od00`00[Of]o@030002[Od00`00[Of]o@03[Od0
0`00[Of]o@030002[Od01000[Of]o@000Zgm00<00:gm[Od00`000Zgm00<00?oo0000/Ooo003ooom<
ool01000ooooo`002?oo00@00?ooool001ooo`<000Goo`<000:]o@03002]oJgm00>]o@03002]oJgm
00<000:]o@03002]oJgm00B]o@8000F]o@03002]oJgm00>]o@<000F]o@04002]oJgm0002[Od30005
[Od00`00ool0002aool00?ooodcoo`04003ooooo0009ool2000Nool20005ool30005[Od00`00[Of]
o@03[Od30005[Od00`00[Of]o@02[Od200000jgm002]o@05[Od00`00[Of]o@020002[Od00`00[Of]
o@04[Od00`00[Od000020002[Od00`00[Of]o@04[Od00`00ool0002`ool00?ooodcoo`04003ooooo
0008ool01000ooooo`006Ooo10001Ooo0P000Zgm00<00:gm[Od01:gm00<00:gm[Od00P000Zgm00<0
0:gm[Od01:gm00@00:gm000000>]o@03002]oJgm00B]o@<000B]o@03002]oJgm00B]o@<000B]o@03
002]oJgm00B]o@800003ool00?oo0:koo`00ooooC?oo00@00?ooool000Soo`04003ooooo000Hool3
0004ool30004[Od00`00[Of]o@04[Od30004[Od00`00[Of]o@04[Od20006[Od00`00[Of]o@030000
0jgm002]o@05[Od00`00[Of]o@0300000jgm00000005[Od00`00[Of]o@0300001:gm003oo`00[ooo
003ooom=ool2000:ool2000Fool30003ool40002[Od00`00[Of]o@03[Od00`00[Of]o@030002[Od0
0`00[Of]o@03[Od00`00[Of]o@030002[Od00`00[Of]o@04[Od20005[Od00`00[Of]o@03[Od30005
[Od20004[Od30005[Od00`00ool0002^ool00?ooofkoo`<000Goo`8000F]o@03002]oJgm00>]o@<0
00F]o@03002]oJgm00>]o@<000F]o@03002]oJgm00:]o@800003[Od00:gm00B]o@03002]oJgm00<0
00:]o@03002]oJgm00>]o@800004[Od000000002[Od00`00[Of]o@03[Od01000ooooo`00[Ooo003o
oom/ool20006ool200000jgm002]o@05[Od00`00[Of]o@020002[Od00`00[Of]o@04[Od00`00[Of]
o@020002[Od00`00[Of]o@04[Od01000[Od000000jgm00<00:gm[Od00jgm0`001Jgm00<00:gm[Od0
0jgm0`001Jgm00<00:gm[Od00jgm0P0000?oo`00ool0[?oo003ooomYool30006ool20003[Od00`00
[Of]o@04[Od30004[Od00`00[Of]o@04[Od30004[Od00`00[Of]o@04[Od20006[Od00`00[Of]o@02
0002[Od00`00[Of]o@04[Od00`00[Of]o@0200000jgm00000006[Od00`00[Of]o@020002[Od00`00
ool0002/ool00?ooofOoo`8000Ooo`8000J]o@03002]oJgm00<000:]o@03002]oJgm00>]o@03002]
oJgm00<00003[Od00:gm00F]o@03002]oJgm00<00003[Od00:gm00F]o@<000B]o@03002]oJgm00B]
o@<000>]o@8000J]o@<000B]o@04003ooooo002[ool00?ooofCoo`<000Koo`<000:]o@03002]oJgm
00B]o@8000F]o@03002]oJgm00>]o@<000F]o@03002]oJgm00>]o@<000F]o@04002]oJgm[Od20002
[Od00`00[Of]o@03[Od00`00[Of]o@0300000jgm002]o@03[Od00`00[Od00002[Od300000jgm002]
o@05[Od00`00ool0002[ool00?ooof;oo`8000Koo`<000F]o@03002]oJgm00:]o@800003[Od00:gm
00F]o@03002]oJgm008000:]o@03002]oJgm00>]o@03002]oJgm00<000:]o@03002]oJgm00>]o@04
002]o@000004[Od00`00[Of]o@03[Od30005[Od01P00[Of]oJgm002]o@<000F]o@03002]oJgm00>]
o@@00:[oo`00ooooGooo0`001_oo0P000Zgm00<00:gm[Od01:gm00@00:gm000000>]o@03002]oJgm
00B]o@<000B]o@03002]oJgm00>]o@<000F]o@03002]oJgm00>]o@8000N]o@03002]oJgm008000:]
o@03002]oJgm00>]o@03002]oJgm00<000:]o@03002]oJgm00>]o@03002]oJgm00<000:]o@800:[o
o`00ooooGOoo0P000_oo00@00?ooooooo`<000B]o@03002]oJgm00B]o@8000J]o@03002]oJgm00<0
0003[Od00:gm00F]o@03002]oJgm008000:]o@03002]oJgm00B]o@03002]oJgm008000:]o@03002]
oJgm00B]o@<000B]o@03002]oJgm00>]o@<00003[Od00:gm00:]o@03002]oJgm00>]o@<000F]o@03
003oo`000:Woo`00ooooF_oo0`001?oo10000Zgm00<00:gm[Od00jgm00<00:gm[Od00`000Zgm00<0
0:gm[Od00jgm0`001Jgm00<00:gm[Od00jgm0`001:gm00<00:gm[Od01:gm0`001Jgm00<00:gm[Od0
0`0000>]o@00[Od01Jgm00<00:gm[Od00P000Zgm00<00:gm00001:gm00<00:gm[Od00P000Zgm00<0
0:gm[Od01:gm00<00?oo0000Z?oo003ooomHool20005ool40004[Od00`00[Of]o@03[Od30006[Od0
0`00[Of]o@020002[Od00`00[Of]o@03[Od00`00[Of]o@030002[Od00`00[Of]o@03[Od00`00[Of]
o@0300000jgm002]o@05[Od30005[Od00`00[Of]o@03[Od30004[Od00`00[Od00004[Od30004[Od0
0`00[Of]o@04[Od3002Xool00?oooeGoo`<000Goo`8000:]o@03002]oJgm00B]o@03002]oJgm0080
00:]o@03002]oJgm00B]o@<000B]o@03002]oJgm00>]o@<000F]o@03002]oJgm00>]o@<000F]o@04
002]oJgm[Od20002[Od00`00[Of]o@03[Od00`00[Of]o@0300000jgm002]o@05[Od200001Zgm0000
0000[Od000J]o@03002]oJgm00<000:]o@800:Ooo`00ooooD_oo0`001Ooo0`001:gm00<00:gm[Od0
1:gm0`001:gm00<00:gm[Od00Zgm0P0000>]o@00[Od01Jgm00<00:gm[Od00P000Zgm00<00:gm[Od0
1:gm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00@00:gm000000B]o@03002]oJgm00>]o@<000F]
o@03002]oJgm00>]o@<000F]o@03002]oJgm00>]o@<000F]o@03003oo`000:Koo`00ooooD?oo0P00
1_oo0P000Zgm00<00:gm[Od00jgm00<00:gm[Od00`000Zgm00<00:gm[Od00jgm00@00:gm000000B]
o@03002]oJgm00>]o@<000B]o@03002]oJgm00B]o@<000B]o@03002]oJgm00>]o@8000N]o@03002]
oJgm008000:]o@03002]oJgm00>]o@03002]oJgm00<00003[Od0000000F]o@03002]oJgm00<00003
[Od00:gm00F]o@<00:Koo`00^?oo0P0000?oo`000000Sooo0`001Ooo0`001:gm00<00:gm[Od00jgm
0`001Jgm00<00:gm[Od00jgm0P001Zgm00<00:gm[Od00`000Zgm00<00:gm[Od00jgm00<00:gm[Od0
0`0000>]o@00[Od01Jgm00<00:gm[Od00P000Zgm00<00:gm[Od01:gm0`001:gm00<00:gm[Od00jgm
0`001:gm0P001Jgm0`001Jgm00@00:gm[Of]o@8000:]o@800:Goo`00^Ooo00<00?oo0000S_oo0P00
1Ooo0`0000>]o@00[Od01Jgm00<00:gm[Od00P000Zgm00<00:gm[Od01:gm00<00:gm[Od00P000Zgm
00<00:gm[Od01:gm0P001Jgm00<00:gm[Od00jgm0`001Jgm00<00:gm[Od00jgm0`001:gm00<00:gm
[Od00Zgm0P0000>]o@00[Od01Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00Zgm00<00:gm00000Zgm
0P000Zgm00<00:gm[Od00jgm00@00:gm000000B]o@03003oo`000:Coo`00^_oo00<00?ooool0R_oo
0`001?oo0`001Jgm00<00:gm[Od00jgm0`001:gm00<00:gm[Od01:gm0`001:gm00<00:gm[Od00Zgm
0P0000>]o@00[Od01Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<00:gm[Od00`000Zgm00<0
0:gm[Od00jgm00@00:gm000000B]o@03002]oJgm00>]o@<000B]o@03002]oJgm00>]o@@000B]o@03
002]oJgm00>]o@8000N]o@800:Coo`00^Ooo00<00?oo0000ROoo0P000ooo00@00?oo000000:L5P03
002]oJgm00>]o@03002]oJgm00<000:]o@03002]oJgm00>]o@03002]oJgm00<00003[Od00:gm00F]
o@04002]o@000003[Od00`00[Of]o@04[Od30004[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@03
[Od20006[Od00`00[Of]o@030002[Od00`00[Of]o@03[Od00`00[Of]o@0300000jgm002]o@05[Od0
0`00[Of]o@020002[Od00`00[Of]o@04[Od3002Sool00;Soo`800003ool0000008Goo`<000Goo`80
00BL5P03002]oJgm00>]o@<000F]o@03002]oJgm00>]o@<000F]o@03002]oJgm00>]o@8000J]o@03
002]oJgm00<00003[Od00:gm00F]o@03002]oJgm008000:]o@03002]oJgm00B]o@03002]oJgm0080
00:]o@03002]oJgm00>]o@<000F]o@03002]oJgm00>]o@<000:]o@04002]oJgm0005[Od30005[Od0
0`00[Of]o@0300001:gm003oo`00X_oo003ooom1ool20008ool00`00W1JL5P04W1H00`00[Of]o@02
0002[Od00`00[Of]o@04[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od00`00[Of]o@030002[Od0
0`00[Of]o@03[Od30005[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@04[Od30005[Od00`00[Of]
o@020002[Od00`00[Of]o@04[Od00`00[Of]o@020002[Od01000[Of]o@000Zgm00<00:gm[Od00`00
00>]o@00[Od01Jgm0`001Jgm0P00X_oo003ooolnool30009ool00`00kK800006W1H20004[Od00`00
[Of]o@04[Od30004[Od00`00[Of]o@03[Od30006[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od0
0`00[Of]o@030002[Od00`00[Of]o@03[Od00`00[Of]o@0300000jgm002]o@05[Od30004[Od00`00
[Of]o@04[Od30004[Od01000[Of]o@000Zgm0`001Jgm00@00:gm[Of]o@8000:]o@03002]oJgm00>]
o@03003oo`000:7oo`00oooo>ooo0`003?oo00<00>fb00001I`F00<00<Ce00001Jgm00<00:gm[Od0
0`000Zgm00<00:gm[Od00jgm00<00:gm[Od00P000Zgm00<00:gm[Od01:gm0`001:gm00<00:gm[Od0
0jgm0`001Jgm00<00:gm[Od00jgm0`001Jgm00@00:gm[Of]o@8000:]o@03002]oJgm00>]o@03002]
oJgm00<00003[Od00:gm00F]o@03002]o@00008000:]o@03002]oJgm00>]o@04002]o@000004[Od0
0`00[Of]o@03[Od200000ooo003oo`2Oool00?ooocWoo`8000ooo`03003]/P0000FL5P030034m@00
00F]o@<000F]o@03002]oJgm00>]o@<000F]o@03002]oJgm00<000:]o@03002]oJgm00>]o@03002]
oJgm008000:]o@03002]oJgm00B]o@03002]oJgm008000:]o@03002]oJgm00>]o@04002]o@000004
[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@03[Od20007[Od00`00
[Of]o@020002[Od2002Pool00?ooocKoo`<0017oo`03003]/P0000BL5P050034mLCea?D00002[Od2
0002[Od00`00[Of]o@04[Od00`00[Of]o@020002[Od00`00[Of]o@04[Od20005[Od00`00[Of]o@03
[Od30004[Od00`00[Of]o@04[Od30004[Od00`00[Of]o@03[Od20007[Od00`00[Of]o@020002[Od0
0`00[Of]o@03[Od00`00[Of]o@0300000jgm00000005[Od00`00[Of]o@020002[Od00`00[Of]o@04
[Od30004[Od00`00ool0002Oool00?ooocCoo`8001?oo`05003]/^fbkK800003W1H00`00a?G4m@02
a?D20004[Od00`00[Of]o@04[Od30004[Od00`00[Of]o@02[Od200000jgm002]o@05[Od00`00[Of]
o@020002[Od00`00[Of]o@03[Od00`00[Of]o@0300000jgm002]o@05[Od00`00[Of]o@020002[Od0
0`00[Of]o@04[Od30004[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@03[Od30005[Od00`00[Of]
o@0300000jgm002]o@05[Od00`00ool0002Nool00?oooc7oo`<00003ool00?oo01;oo`05003]/^fb
kK800002W1H00`00a?G4m@03a?D20005[Od00`00[Of]o@0300000jgm002]o@05[Od01000[Od00000
0jgm00<00:gm[Od01:gm0`001:gm00<00:gm[Od00jgm0`001Jgm00<00:gm[Od00jgm0`001Jgm00<0
0:gm[Od00`0000>]o@00[Od01Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<00:gm[Od00`00
0Zgm00<00:gm[Od00jgm0`001Jgm00<00:gm[Od00jgm0`00W_oo003oool_ool20005ool00`00oooo
o`0@ool01`00kK;]/^fb002L5P0000G4m@03003UM00000F]o@<000F]o@03002]oJgm00>]o@8000J]
o@03002]oJgm00<00003[Od00:gm00F]o@03002]oJgm008000:]o@03002]oJgm00>]o@03002]oJgm
00<000:]o@03002]oJgm00>]o@<000F]o@03002]oJgm00>]o@<000B]o@03002]oJgm00>]o@<000F]
o@03002]oJgm00<000:]o@03002]oJgm00>]o@03002]oJgm00<00004[Od00?oo002Mool00?Koo`80
00Coo`03003ooooo00?oo`8002Ooo`<001Woo`03003]/^fb00?]/P8000G4m@04003UM>Ed0002[Od2
0002[Od00`00[Of]o@03[Od00`00[Of]o@030002[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@03
[Od30004[Od00`00[Of]o@03[Od30006[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od00`00[Of]
o@0300000jgm002]o@05[Od00`00[Of]o@0300000jgm002]o@05[Od20005[Od00`00[Of]o@03[Od3
0005[Od00`00ool0002Lool00?Goo`04003ooooo0008ool01000ooooo`009?oo0P007?oo00<00>fb
kK800nfb00<00<Cea?D01<Ce00@00>EdiGCUM08000B]o@03002]oJgm00>]o@<000J]o@03002]oJgm
008000:]o@03002]oJgm00>]o@03002]oJgm00<00003[Od00:gm00F]o@03002]oJgm008000:]o@03
002]oJgm00B]o@<000B]o@03002]oJgm00>]o@<000F]o@03002]oJgm00>]o@<000:]o@03002]o@00
00B]o@800003[Od00:gm00F]o@03002]oJgm008000:]o@03002]oJgm00>]o@03003oo`0009coo`00
mOoo00@00?ooool000Soo`04003ooooo000Qool3000Nool00`00kK;]/P03kK800`00a?G4m@03a?D0
0`00iGCUM002iG@20005[Od00`00[Of]o@020002[Od00`00[Of]o@04[Od30004[Od00`00[Of]o@03
[Od30005[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@02[Od200000jgm002]o@05[Od00`00[Of]
o@020002[Od00`00[Of]o@03[Od00`00[Of]o@0300000jgm002]o@02[Od01@00[Of]o@00[Od00P00
0jgm00<00:gm[Od01:gm0`001:gm00<00:gm[Od00jgm0P0000?oo`00ool0V_oo003eool01000oooo
o`002?oo0`008?oo0P008?oo00<00>fbkK800nfb00<00>gC00001<Ce00L00>EdiGCUM000kK<00005
[Od30005[Od00`00[Of]o@0300000jgm002]o@05[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od0
0`00[Of]o@030002[Od00`00[Of]o@03[Od01000[Od000001:gm00<00:gm[Od00jgm0`001:gm00<0
0:gm[Od00jgm0`001Jgm00@00:gm[Od000:]o@8000J]o@03002]oJgm00<00003[Od00:gm00F]o@03
002]oJgm008000:]o@8000koo`8000Coo`03003ooooo00;oo`@007koo`00mOoo00@00?ooool000So
o`03003ooooo01goo`<002;oo`03003]/^fb00?]/P03003]d`0000C4m@05003UM>EdiG@00002kK<0
0`00[Of]o@020002W1H00`00[Of]o@04[Od20005[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@03
[Od30005[Od00`00[Of]o@03[Od20006[Od00`00[Of]o@0300000jgm002]o@05[Od00`00[Of]o@02
0002[Od00`00[Of]o@03[Od00`00[Of]o@030002[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@03
[Od30004[Od00`00ool0000<ool01000ooooo`002?oo00<00?ooool0Oooo003eool01000ooooo`00
2?oo00<00?ooool06_oo0`009Ooo00<00>fbkK800nfb00<00>gC00000lCe00<00>EdiG@00^Ed00@0
0>fckK?]/`8000BL5P03002]oJgm00:]o@800003[Od00:gm00B]o@03002]oJgm00<000:]o@03002]
oJgm00>]o@03002]oJgm008000:]o@03002]oJgm00B]o@03002]oJgm008000:]o@03002]oJgm00>]
o@<000F]o@03002]oJgm00>]o@<000B]o@03002]oJgm00>]o@@000F]o@03002]oJgm008000:]o@03
002]oJgm00>]o@03002]oJgm00<00003[Od00:gm00F]o@03003oo`0000_oo`04003ooooo0009ool0
0`00ooooo`1nool00?Koo`8000[oo`<001Ooo`800003ool00?oo02Goo`03003]/^fb00;]/P04003]
dngC0003a?D01@00iGCUM>Ed00001>fc00<009`FW1H019`F00@00:gm000000>]o@03002]oJgm00>]
o@<000F]o@03002]oJgm00>]o@<000B]o@03002]oJgm00B]o@<000F]o@03002]oJgm008000:]o@03
002]oJgm00>]o@03002]oJgm00<00003[Od00:gm00F]o@03002]oJgm008000:]o@03002]o@0000B]
o@<000B]o@03002]oJgm00>]o@<000F]o@03002]oJgm00>]o@<000_oo`04003ooooo000:ool00`00
ooooo`1mool00?oooa[oo`<000Coo`03003ooooo02;oo`03003]/^fb00?]/P07003]dngCkM<00<Ce
00001>Ed00L00>fckK?]/`00kK800006W1H00`00[Of]o@04[Od00`00[Of]o@020002[Od00`00[Of]
o@04[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od00`00[Of]o@030002[Od00`00[Of]o@03[Od3
0004[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@03[Od30005[Od200001Zgm00000000[Od000J]
o@03002]oJgm008000:]o@03002]oJgm00>]o@03002]oJgm00<00004[Od00?oo000:ool01000oooo
o`002ooo00<00?ooool0O?oo003ooolHool2000/ool00`00kK;]/P03kK801`00kM?]dngC0034m@00
00CUM007003]/nfckK<00>fb00001I`F00<00<Ce00001Jgm0`001:gm00<00:gm[Od01:gm0`001:gm
00<00:gm[Od00jgm0`001Jgm00<00:gm[Od00`0000>]o@00[Od01Jgm00<00:gm[Od00P000Zgm00<0
0:gm[Od00jgm00<00:gm[Od00`000Zgm00<00:gm[Od00jgm0`001Jgm00<00:gm[Od00jgm0`001:gm
00<00:gm[Od00jgm0`001Jgm00<00?oo00002Ooo00@00?ooool000Soo`04003ooooo001nool00?oo
oaGoo`<002koo`03003]/^fb00;]/P03003]dngC00;]d`030034m@0000?UM003003]/nfc00;]/`03
003]/P0000FL5P040034mLCe0002[Od20002[Od00`00[Of]o@03[Od00`00[Of]o@0300000jgm002]
o@05[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@03[Od30004[Od00`00
[Of]o@03[Od30006[Od00`00[Of]o@0200000jgm00000005[Od00`00[Of]o@0300000jgm002]o@05
[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od00`00ool0000:ool2000:ool2001oool00?oooa?o
o`80033oo`03003]/^fb00?]/P03003]dngC00?]d`03003UM>Ed00;UM003003]/nfc00;]/`03003]
/P0000BL5P030034mLCe00;4m@8000B]o@03002]oJgm00>]o@<000F]o@03002]oJgm00>]o@<000F]
o@03002]oJgm008000:]o@03002]oJgm00>]o@03002]oJgm00<000:]o@03002]oJgm00>]o@03002]
oJgm008000:]o@03002]oJgm00B]o@<000>]o@8000F]o@<000F]o@03002]oJgm00>]o@<000B]o@03
002]oJgm00>]o@@009Koo`00oooo4?oo0`00<_oo00<00>fbkK800^fb00<00>gCkM<01>gC00D00>Ed
iGCUM00000C]/`05003]/^fbkK800003W1H00`00a?G4m@02a?D20005[Od00`00[Of]o@020002[Od0
0`00[Of]o@03[Od00`00[Of]o@030002[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@03[Od30005
[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@02[Od200000jgm002]o@03[Od00`00[Od00002[Od2
0002[Od00`00[Of]o@03[Od00`00[Of]o@0300000jgm002]o@05[Od00`00[Of]o@020002[Od00`00
ool0002Eool00?ooo`koo`8003Goo`03003]/^fb00;]/P03003]dngC00C]d`05003UM>EdiG@00004
kK<01@00kK;]/^fb00000Y`F00<00<Cea?D00/Ce00<00>Ed00001Jgm0`001:gm00<00:gm[Od00jgm
0`001Zgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<00:gm[Od00P000Zgm00<00:gm[Od01:gm
00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00@00:gm000000B]o@06002]oJgm[Od00:gm0`001:gm
00<00:gm[Od00jgm0`001Jgm00<00:gm[Od00jgm0`001Jgm0P00UOoo003oool;ool3000fool00`00
iMH00003kK800`00kM?]d`03kM<00`00iM@00002iG@00`00kK?]/`02kK<01`00kK;]/^fb002L5P00
00G4m@04003UM>Ed0002[Od20002[Od00`00[Of]o@03[Od00`00[Of]o@020002[Od00`00[Of]o@04
[Od30004[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@04[Od30004[Od00`00[Of]o@03[Od20006
[Od00`00[Of]o@0300000jgm002]o@05[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od00`00[Of]
o@030002[Od00`00[Of]o@03[Od3002Dool00?ooo`Woo`800003ool00?oo03Koo`03003UeP0000;]
/P03003]dngC00C]d`05003Ue000iG@00004kK<00`00kK;]/P03kK820004a?D00`00iGCUM002iG@2
0004[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@0300000jgm002]o@05[Od00`00[Of]o@020002
[Od00`00[Of]o@03[Od00`00[Of]o@0300000jgm002]o@05[Od00`00[Of]o@020002[Od00`00[Of]
o@03[Od300000jgm002]o@02[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@03[Od30005[Od00`00
[Of]o@0300001:gm003oo`00Tooo003oool6ool30003ool00`00ooooo`0dool01`00iMKUe^GF003]
/P0000G]d`06003Ue>GD003UM0001>fc00<00>fbkK800nfb00<00<Cea?D00lCe00<00>EdiG@00^Ed
00<00:gm[Od01:gm00<00:gm[Od00P000Zgm00<00:gm[Od01:gm0P001Jgm00<00:gm[Od00jgm0`00
1:gm00<00:gm[Od00jgm0`001Jgm00<00:gm[Od00jgm0`001Jgm00<00:gm[Od00P000Zgm00<00:gm
00000jgm00<00:gm[Od00`0000>]o@00[Od01Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm0`00
1Jgm0P00Tooo003oool3ool30007ool00`00ooooo`0cool01`00iMKUe^GF003]/P0000G]d`06003U
e>GD003UM0001>fc00<00>fbkK800nfb00<00<Cea?D00/Ce00<00>EdiG@00^Ed00<00>fc00001Jgm
0`001:gm00<00:gm[Od00Zgm0P0000>]o@00[Od01:gm00<00:gm[Od00`0000>]o@00[Od01Jgm00<0
0:gm[Od00P000Zgm00<00:gm[Od00jgm00<00:gm[Od00`000Zgm00<00:gm[Od00jgm0`001:gm00<0
0:gm00000jgm0`001Jgm00<00:gm[Od00jgm0`001Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm
00<00?oo0000T_oo003oool1ool2000oool00`00iMKUeP03iMH00`00kM?]d`03kM<00`00iMCUe002
iM@00`00kK?]/`02kK<00`00kK;]/P03kK820004a?D00`00iGCUM002iG@00`00kK<00002[Od30000
0i_f002]o@05[Od01000[Od000000jgm00<00:gm[Od00jgm0`001Jgm00<00:gm[Od00jgm0`001:gm
00<00:gm[Od00jgm0`001Jgm00<00:gm[Od00`0000>]o@00[Od01Jgm0P0000>]o@0000000Zgm00<0
0:gm[Od00jgm00<00:gm[Od00`000Zgm00<00:gm[Od00jgm0`001:gm00<00:gm[Od00jgm0P0000?o
o`00ool0T?oo003mool30011ool00`00iMKUeP03iMH00`00kM?]d`03kM<00`00iMCUe002iM@00`00
kK?]/`02kK<00`00kK;]/P03kK800`00kK<00003a?D00`00iGCUM002iG@00`00kK?]/`020005VoH0
0`00[Of]o@03[Od20006[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od00`00[Of]o@0300000jgm
002]o@05[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@03[Od30004[Od0
0`00[Of]o@03[Od30005[Od00`00[Of]o@0300000jgm002]o@05[Od00`00[Of]o@020002[Od2002A
ool00?_oo`8004?oo`03003Ue^GF00?UeP8000C]d`03003Ue>GD00?Ue003003]/nfc00;]/`03003]
/^fb00?]/P03003]/`0000;4m@03003UM>Ed00;UM005003]/nfckK<00006VoH00`00[Of]o@030002
[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@03[Od30005[Od00`00
[Of]o@020002[Od00`00[Of]o@03[Od00`00[Of]o@0300000jgm002]o@05[Od00`00[Of]o@020002
[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@03[Od30004[Od00`00ool0002@ool00?Soo`<004Go
o`03003Ue^GF00?UeP03003MeP0000?]d`03003Ue>GD00;Ue003003Ue@0000?]/`03003]/^fb00;]
/P04003]/nfc0002a?D00`00iGCUM002iG@01000kK?]/nfc0P001Y_f0P001Zgm00<00:gm[Od00P00
0Zgm00<00:gm[Od00jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<00:gm[Od00`000Zgm00<0
0:gm[Od00jgm0`001:gm00<00:gm[Od00jgm0`001:gm0P001Jgm0`001Jgm00<00:gm[Od00P000Zgm
00<00:gm[Od00jgm00<00:gm[Od00`0000>]o@00[Od01Jgm00<00?oo0000Sooo003eool30017ool0
0`00iMKUeP03iMH01000gMKMeP000^gC00<00>GDiM@00nGD00<00>GE00000^fc00<00>fbkK800nfb
00H00>fckK<00<Ce0005iG@01P00kK?]/`00kK8000FKmP030034e@0000J]o@<000B]o@03002]oJgm
00>]o@<000B]o@03002]oJgm00>]o@<000F]o@03002]oJgm00<00003[Od00:gm00F]o@03002]oJgm
008000:]o@03002]oJgm00:]o@8000:]o@<000:]o@03002]oJgm00>]o@<000B]o@03002]oJgm00>]
o@<000F]o@03002]oJgm00>]o@<008ooo`00looo1000B?oo00<00>GFiMH00nGF00L00=gFgMKMeP00
kM<00004iM@01`00iMGUeNGE003]/`0000C]/P03003]/nfc00;]/`8000CUM007003]/nfckK<00>fb
00001I_f00@00<CEa=D000:]o@<00003[Od00:gm00F]o@03002]oJgm008000:]o@03002]oJgm00>]
o@03002]oJgm008000:]o@03002]oJgm00>]o@<000F]o@03002]oJgm00>]o@<000B]o@03002]oJgm
00:]o@@000F]o@03002]oJgm00<00003[Od00:gm00F]o@03002]oJgm008000:]o@03002]oJgm00>]
o@03002]oJgm00<000:]o@8008koo`00lOoo0P001?oo00<00?ooool0A?oo00<00=gG00000nGF00<0
0=gFgMH00]gF0P001NGD00L00>GEiMGUe@00kK<00004kK800`00kK?]/`02kK<00`00iGCUM003iG@0
1`00kK?]/nfc003]/P0000BKmP030034eLCE00;4e@8000F]o@03002]oJgm00>]o@<000B]o@03002]
oJgm00>]o@<000F]o@03002]oJgm008000:]o@03002]oJgm00>]o@03002]oJgm00<00003[Od00:gm
00F]o@03002]oJgm00<00003[Od00:gm00B]o@<000F]o@03002]oJgm00>]o@<000B]o@03002]oJgm
00>]o@<000F]o@03003oo`0008goo`00k_oo0`00COoo00<00=gG00000nGF00<00=gFgMH00mgF00<0
0>GDiM@00nGD00<00>GEiMD00^GE00<00>fbkK800nfb00<00>fckK<00^fc00<00>EdiG@00nEd00D0
0>fckK?]/`0000;]/P05002KmY_fVoH00004a=D20005[Od00`00[Of]o@0300000jgm002]o@05[Od0
0`00[Of]o@020002[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@03
[Od30002[Od01000[Of]o@000Zgm0P000Zgm00<00:gm[Od00jgm00<00:gm[Od00`0000>]o@00[Od0
1Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm0`00SOoo003[ool3001?ool01`00gMOMemgG003U
eP0000GMeP8000CUe003003UeNGE00?Ue@03003]/^fb00;]/P03003]/nfc00?]/`03003UM>Ed00;U
M005003]/nfckK<00003kK801000VoJKmP001<CE00<00>Ed00001Jgm0`001Jgm00<00:gm[Od00jgm
0`001Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm
00<00:gm[Od00`000Zgm00@00:gm[Od000:]o@<000B]o@03002]oJgm00>]o@<000F]o@03002]oJgm
00>]o@<000F]o@03002]oJgm00800004[Od00000002<ool00>Woo`80057oo`03003MemgG00;Me`03
003UeP0000GMeP03003MeP0000?Ue003003UeNGE00?Ue@03003]/^fb00;]/P03003]/nfc00;]/`03
003Ue00000?UM005003]/nfckK<00003kK800`00VoH00005a=D01000iGCUM0000Zgm0P000Zgm00<0
0:gm[Od00jgm00<00:gm[Od00`000Zgm00<00:gm[Od00jgm0`001:gm00<00:gm[Od00jgm0`001:gm
00<00:gm[Od00jgm0`001Jgm00<00:gm[Od00`0000>]o@00[Od01Jgm00<00:gm[Od00P000Zgm00<0
0:gm[Od00jgm00<00:gm[Od00`000Zgm00<00:gm[Od00jgm0`001:gm0P00S?oo003Vool3001Bool0
0`00gMOMe`04gML00`00gMKMeP03gMH01000gMKMeP000^GD00<00>GEiMD00nGE00<00>GF00000nfb
00<00>fckK<00^fc00<00>GD00000nEd00D00>fckK?]/`0000C]/P8000G4e@04003UM>EdiG@20004
[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@0300000jgm002]o@05[Od00`00[Of]o@020002[Od0
0`00[Of]o@03[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od40004[Od00`00[Of]o@03[Od30004
[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@0300000jgm002]o@04[Od00`00ool0002;ool00>Co
o`8005Goo`03003MemgG00?Me`8000GMeP07003Me]gFgMH00>GD00001NGE00<00>GF00000^fb00<0
0>fckK<00^fc00@00>GDiM@000;UM003003]/nfc00;]/`03003]/^fb00;]/P030034eLCE00?4e@03
003UM>Ed00;UM08000F]o@03002]oJgm008000:]o@03002]oJgm00>]o@<000F]o@03002]oJgm00>]
o@<000B]o@03002]oJgm00>]o@<000F]o@03002]oJgm008000:]o@8000B]o@03002]oJgm00<00003
[Od00:gm00F]o@03002]oJgm008000:]o@03002]oJgm00>]o@<000F]o@03002]oJgm00:]o@800003
ool00?oo08Woo`00hOoo0`00E_oo00<00=gGgML01=gG00<00=gG00000mgF00<00=gFgMH00]gF0P00
1NGE00L00>GFiMKUeP00kK800004kK<01`00iMCUe>GD003UM00000?]/`03003]/^fb00?]/P030034
eLCE00?4e@07003UM>EdiG@00>fc00001Jgm0`001Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm
00<00:gm[Od00`0000>]o@00[Od01Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm0`001:gm0P00
1:gm0`001Jgm00<00:gm[Od00jgm0`001Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<00:gm
[Od00P000Zgm0P00R_oo003Oool3001Gool00`00gMOMe`04gML01000gMOMe`000mgF00<00=gFgMH0
0mgF00<00>GEiMD00nGE00@00>GFiMKUeP8000G]/`07003Ue>GDiM@00>Ed00000nfc00<00>fbkK80
0^fb00<00>fc00001<CE00D00>EdiGCUM00000;]/`03002]oJgm008000:KmP03002]oJgm00>]o@<0
00B]o@03002]oJgm00>]o@<000F]o@03002]oJgm00>]o@<000F]o@03002]oJgm008000:]o@03002]
oJgm00>]o@03002]oJgm008000:]o@03002]oJgm00>]o@03002]oJgm00<000:]o@03002]oJgm00>]
o@<000B]o@03002]oJgm00>]o@<000B]o@03003oo`0008Woo`00g?oo0`000ooo00<00?ooool0Dooo
00<00=Gh00001=gG00<00=gGgML00]gG00<00=gF00001MgF00<00=gG00000nGE00<00>GFiMH00nGF
00<00>fckK<00^fc00<00>GDiM@00nGD00<00>fckK<00^fc00<00>fbkK800^fb00<00>fc00000lCE
00<00>EdiG@00^Ed00@00>fckK?]/`8000FKmP03002]oJgm008000:]o@03002]oJgm00>]o@03002]
oJgm008000:]o@03002]oJgm00>]o@03002]oJgm00<000:]o@03002]oJgm00>]o@<000B]o@03002]
oJgm00>]o@<000B]o@03002]oJgm00>]o@<000F]o@03002]oJgm00<00003[Od00:gm00F]o@03002]
oJgm00800003[Od00:gm00F]o@03003oo`0008Soo`00YOoo0P001?oo00<00?ooool01?oo00<00?oo
ool09Ooo0P00Fooo00@00=GheOP000?Me`03003MemgG00?Me`03003MeP0000GMeP03003Me`0000?U
e@03003Ue^GF00?UeP03003]/nfc00;]/`03003Ue>GD00?Ue003003]/nfc00;]/`03003]/^fb00;]
/P03003]/`0000?4e@03003UM>Ed00;UM005003]/nfckK<00007VoH20004[Od00`00[Of]o@03[Od3
0004[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@0300000jgm002]o@05[Od00`00[Of]o@040006
[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@03[Od30004[Od00`00[Of]
o@03[Od30028ool00:Coo`04003ooooo000:ool00`00ooooo`0Rool3001Mool01@00eOSEn=Gh0000
0]gG00<00=gGgML01=gG00<00=gFgMH00mgF00L00=gGgMOMe`00iMD00005iMH00`00gMH00003kK<0
0`00iMCUe003iM@01@00kK?]/nfc00001Nfb00H00>fckK<00<CE0004iG@00`00kK?]/`02kK<00`00
VoJKmP04VoH20006[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od00`00[Of]o@020002[Od00`00
[Of]o@03[Od30005[Od00`00[Of]o@03[Od30002[Od00`00[Od00005[Od30005[Od00`00[Of]o@02
0002[Od00`00[Of]o@03[Od00`00[Of]o@0300000jgm002]o@04[Od00`00[Of]o@030002[Od20027
ool00:Coo`04003ooooo0007ool5000Qool2001Oool00`00eOSEn002eOP00`00gML00006gML00`00
eML00004gMH01`00gMOMemgG003Ue@0000GUeP03003MeP0000;]/`03003Ue>GD00?Ue003003Ue@00
00;]/`03003]/^fb00;]/P07003]/nfckK<00<CE00001>Ed00L00>fckK?]/`00kK800005VoH00`00
a=D00005[Od30004[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od0
0`00[Of]o@0300000jgm002]o@02[Od00`00[Od00002[Od30002[Od00`00[Of]o@03[Od30004[Od0
0`00[Of]o@03[Od30005[Od00`00[Of]o@02[Od30005[Od00`00ool00026ool00:Coo`04003ooooo
0007ool01000ooooo`007ooo0`00H?oo00<00=GheOP01=Gh00<00=gGgML01=gG00@00=GGeML000?M
eP03003MemgG00?Me`03003Ue^GF00?UeP07003Me]gFgMH00>fc00001NGD00<00>GE00000^fc00<0
0>fbkK800^fb00L00>fckK?]/`00a=D00004iG@01`00kK?]/nfc003]/P0000BKmP040034eLCE0002
[Od300000jgm002]o@05[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@03
[Od30005[Od01@00[Of]o@00[Od00`001Jgm00<00:gm[Od00`0000>]o@00[Od01Jgm00<00:gm[Od0
0P0000>]o@00[Od01Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm0`00Q_oo002Tool01000oooo
o`002?oo00<00?oo00007?oo0`00H_oo00<00=GheOP01=Gh00<00=Gh00001=gG00<00=GGeML00]GG
00<00=gF00001MgG0P001NGF00@00=gFgMKMeP8000GUe007003UeNGEiMD00>fc00001>fb00<00>fc
kK<00^fc00<00>EdiG@00nEd00L00>fckK?]/`00kK800003VoH00`00a=G4e@02a=D20005[Od00`00
[Of]o@03[Od30005[Od00`00[Of]o@0200000jgm002]o@05[Od00`00[Of]o@020002[Od00`00[Of]
o@03[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@03[Od30004[Od00`00
[Of]o@03[Od30005[Od00`00[Of]o@020002[Od20025ool00:Coo`04003ooooo0009ool2000Jool2
001Tool00`00eOP00004eOP01000eOSEn0001=gG00<00=GGeML00]GG00<00=gF00001MgG00<00=gG
00000nGF00<00=gFgMH00mgF00<00>GDiM@00nGD00@00>GEiMGUe@8000C]/P03003]/nfc00?]/`03
003UM>Ed00;UM003003]/nfc00;]/`03003]/P0000>KmP030034eLCE00;4e@8000F]o@03002]oJgm
00<000:]o@03002]oJgm00>]o@<000B]o@03002]oJgm00>]o@<000B]o@03002]oJgm00>]o@@000B]
o@03002]oJgm008000:]o@03002]oJgm00>]o@03002]oJgm00<00003[Od00:gm00B]o@03002]oJgm
00<000:]o@03002]oJgm00>]o@<000B]o@03003oo`0008Coo`00YOoo0P002ooo00<00?ooool05Ooo
1000I?oo00@00=GheOP000CEn005003En=GheOP00002gML00`00eMOEe`04eML00`00gMOMe`03gML0
1000gMOMe`000nGF00<00=gFgMH00]gF0P001>GD00<00>GEiMD00nGE00<00>fbkK800^fb00<00>fc
kK<00nfc00<00>EdiG@00^Ed00D00>fckK?]/`0000;]/P04002KmY_f0004a=D00`00iG@00005[Od3
0005[Od00`00[Of]o@0300000jgm002]o@04[Od00`00[Of]o@0300000jgm002]o@05[Od00`00[Of]
o@020002[Od20004[Od30004[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@02[Od30005[Od00`00
[Of]o@0300000jgm002]o@05[Od20024ool00<Soo`8000Coo`03003ooooo063oo`03003En=Gh00;E
n004003En=Gh0004eOP00`00gML00006eML00`00eML00004gML01`00gMOMemgG003UeP0000GMeP03
003MeP0000?Ue003003UeNGE00?Ue@03003]/^fb00;]/P03003]/nfc00;]/`03003Ue00000?UM005
003]/nfckK<00003kK820005a=D01000iGCUM0000Zgm0P000Zgm00<00:gm[Od00jgm0`001Jgm00<0
0:gm[Od00Zgm0`001Jgm00<00:gm[Od00jgm0`001Jgm00<00:gm[Od00P0000>]o@00[Od01Jgm00<0
0:gm[Od00P000Zgm00<00:gm[Od00jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm0`001Jgm00<0
0:gm[Od00jgm1000P_oo0035ool3001Xool00`00eOSEn003eOP00`00eOP00006eOP00`00eMOEe`04
eML01000eMOEe`000mgG00<00=gGgML00]gG00<00>GF00001=gF00@00=gFgMH000;Ue003003UeNGE
00?Ue@03003Ue@0000;]/P03003]/nfc00?]/`03003Ue00000;UM003003]/nfc00;]/`04003]/^fb
kK820005a=D01000iGCUM>Ed0P001Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<00:gm[Od0
0P000Zgm00<00:gm[Od00jgm00<00:gm[Od00`000Zgm00<00:gm[Od00jgm0`001:gm00<00:gm[Od0
0jgm0`001:gm00<00:gm[Od00jgm0`001Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<00:gm
[Od00`0000B]o@00ool008;oo`00`ooo0P00J_oo00<00=GheOP01MGh00<00=GheOP01=Gh00<00=Gh
00001=GG00<00=GGeML00]GG00<00=gG00001]gG00<00=gFgMH00mgF00L00=gFgMKMeP00iM@00005
iMD00`00iMD00002kK800`00kK?]/`03kK<00`00iM@00002iG@00`00kK?]/`02kK<01@00kK;]/^fb
00001LCE00<00>EdiG@00^Ed0P001Jgm0`001:gm00<00:gm[Od00jgm0`001:gm00<00:gm[Od00jgm
0`001Jgm00<00:gm[Od00`0000>]o@00[Od01:gm00<00:gm[Od00`0000>]o@00[Od01Jgm00<00:gm
[Od00P000Zgm00<00:gm[Od00jgm0`001:gm00<00:gm[Od00jgm0`001Jgm0P00P_oo0030ool3001[
ool00`00eOSEn005eOP00`00eOP00004eOP01000eOSEn0001=GG00<00=GGeML00]GG00<00=gG0000
1MgG00<00=gG00000mgF00<00=gFgMH00]gF0P001NGE00L00>GEiMGUe@00kK800004kK<01`00iMCU
e>GD003UM00000?]/`03003]/^fb00;]/P030034eLCE00?4e@05003UM>EdiG@00002kI<00`00[Of]
o@020002VoH00`00[Of]o@03[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od00`00[Of]o@020002
[Od00`00[Of]o@03[Od30004[Od20004[Od30005[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@02
00000jgm002]o@05[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od00`00ool00021ool00;koo`80
06goo`03003=n@0000GEn004003En=Gh0004eOP01@00eOSEn=Gh00000]GG00<00=GGeML01=GG00<0
0=gGgML01=gG00<00=gG00000mgF00<00=gFgMH00mgF00<00>GEiMD00nGE00L00>GEiMGUe@00kK80
0004kK<01`00iMCUe>GD003UM00000?]/`03003]/^fb00;]/P8000C4e@05003UM>EdiG@00003kI<2
0004VoH00`00[Of]o@03[Od30004[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@020002[Od00`00
[Of]o@02[Od20002[Od20002[Od00`00[Of]o@03[Od00`00[Of]o@030002[Od00`00[Of]o@03[Od3
0004[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@03[Od200000ooo003oo`1oool00;_oo`<006ko
o`04003=nLgi0004eOP00`00eOSEn002eOP01000eOSEn0001=Gh00<00=GG00001]GG0P001MgG00L0
0=gGgMOMe`00gMH00005gMH20004iMD00`00iMGUe@03iMD00`00kK?]/`03kK<00`00iMCUe002iM@0
0`00kK?]/`02kK<01`00kK;]/^fb003]/`0000?4e@03003UM>Ed00;UM005003]TnfCkI<00006VoH0
0`00[Of]o@020002[Od00`00[Of]o@03[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od30004[Od0
0`00[Of]o@02[Od40004[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@0300000jgm002]o@04[Od0
0`00[Of]o@0300000jgm002]o@05[Od00`00[Of]o@020002[Od20020ool00;Woo`80077oo`05003=
nLgicOT00002eOP00`00eOSEn003eOP00`00eOP00006eOP00`00eMOEe`04eML01000eMSEf0001=gG
00L00=gGgMOMe`00gMH00005gMH00`00gMH00003iMD00`00iMGUe@03iMD00`00kK?]/`02kK<00`00
iMCUe003iM@00`00kK?]/`02kK<01`00kK;]/^fb003]/`0000?4e@03003UM>Ed00;UM005003]TnfC
kI<00007VoH20004[Od01000[Of]oJgm1@001Jgm00<00:gm[Od00P0000>]o@00[Od01Jgm00<00:gm
[Od00P000Zgm00<00:gm[Od00jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm0`001Jgm00<00:gm
[Od00Zgm0`001Jgm00<00:gm[Od00jgm0`001:gm00<00?oo0000Oooo002fool300000ooo003oo`1_
ool00`00cOW=n@02cOT00`00eOP00007eOP00`00eOSEn004eOP00`00eOP00004eML01@00eMSEf=GH
00000mgG00<00=gGgML00mgG00<00=gFgMH00mgF00@00=gFgMH000;Ue@03003UeNGE00CUe@03003]
/nfc00;]/`03003Ue>GD00?Ue005003]/nfckK<00004kK801P00kK?]/`00a=D000CUM007003]TnfC
kI<00>fb00001I_f00<00<CE00001:gm10001:gm00<00:gm[Od00jgm0`001:gm00<00:gm[Od00jgm
0`0000>]o@00[Od00Zgm00@00:gm[Of]o@@000F]o@03002]oJgm008000:]o@03002]oJgm00>]o@03
002]oJgm008000:]o@03002]oJgm00>]o@03002]oJgm00<000:]o@03002]oJgm00:]o@<007ooo`00
/ooo0`001Ooo00<00?ooool0K?oo00<00<gicOT01<gi00<00=GheOP01MGh00<00<gh00001=Gh00@0
0=GheOP000CEe`03003Ef=GH00;Ef003003Me`0000GMe`8000GMeP07003Me]gFgMH00>GE00001NGE
00<00=gF00000^fc00<00>GDiM@00nGD00<00>GE00000^fc00<00>fbkK800^fb00H00>fckK<00<CE
0004iG@01`00kI?]TnfC003]/P0000FKmP030034e@0000:]o@8000:]o@03002]oJgm00>]o@03002]
oJgm00<00003[Od00:gm00B]o@03002]oJgm00<000:]o@03002]o@0000>]o@@000>]o@03002]oJgm
00>]o@<000B]o@03002]oJgm00>]o@<000B]o@03002]oJgm00>]o@<000F]o@03002]oJgm008000:]
o@8007koo`00/Ooo0P002Ooo00<00?ooool0J_oo00<00<gicOT01<gi00<00<gi00001MGh00@00<gh
cOP000CEn005003En=GheOP00002eML00`00eMSEf003eMP00`00gML00005gML00`00eML00003gMH0
0`00gMKMeP02gMH20006iMD00`00gMH00002kK<00`00iMCUe003iM@00`00iMD00002kK<01@00kK;]
/^fb00000nfc00<00<CE00001>Ed00L00>fCkI?]T`00kK800004VoH01000a=G4eLCE0P001:gm00<0
0:gm[Od00jgm0`001Jgm00<00:gm[Od00Zgm0`001Jgm00<00:gm00000`0000>]o@00[Od01:gm00<0
0:gm[Od00`0000>]o@00[Od01Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<00:gm[Od00P00
0Zgm00<00:gm[Od00jgm0`001:gm00<00?oo0000OOoo002^ool3001gool00`00cOT00004cOT01000
cOW=n@001=Gh00<00<ghcOP00/gh00@00=GheOP000CEn003003Ee`0000OEf003003MemgG00?Me`04
003EemGG0003gMH00`00gMKMeP03gMH00`00iMGUe@03iMD01`00gMKMe]gF003]/`0000CUe007003U
eNGEiMD00>fc00000nfb00<00>fckK<00^fc00<00>EdiG@00nEd00L00>fCkI?]T`00kK800003VoH0
0`00a=G4e@02a=D20005[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od00`00[Of]o@020002[Od0
0`00[Of]o@03[Od30005[Od00`00[Of]o@02[Od30005[Od00`00[Of]o@03[Od30004[Od01000[Of]
oJgm1@001:gm00<00:gm[Od00`0000>]o@00[Od01Jgm0P00OOoo002/ool2001hool20002cOT00`00
cOW=n@02cOT01@00cOW=nLgi00000]Gh00<00<ghcOP00lgh00<00=Gh00001]Gh00<00=GHeMP01MGH
0P001=gG00<00=GGeML00]GG00<00=gF00001MgF0P001NGE00@00=gFgMKMeP8000GUe004003UeNGE
iMD20004kK800`00kK?]/`02kK<00`00iGCUM002iG@01@00kI?]TnfC00000^fb00D009_fVoJKmP00
00?4e@03003UM00000F]o@<000B]o@03002]oJgm00>]o@<000F]o@03002]oJgm008000:]o@03002]
oJgm00>]o@03002]oJgm008000:]o@03002]oJgm00>]o@03002]oJgm00<000:]o@03002]oJgm00:]
o@@000B]o@03002]oJgm00:]o@<000F]o@03002]oJgm00>]o@<007coo`00ZOoo0`00NOoo00<00<gi
cOT00lgi00@00<gicOT000C=n@03003En00000O=n003003En=Gh00CEn003003En00000GEf004003E
n=Gh0002gML00`00eMOEe`03eML00`00gMH00005gMH00`00gML00003iMD00`00gMKMeP03gMH00`00
iMCUe003iM@00`00iMGUe@02iMD00`00kK;]/P02kK800`00kK?]/`02kK<00`00iGCUM002iG@01@00
kI?]TnfC00000^fb00@009_fVoH000C4e@04003UM>Ed0002[Od20002[Od00`00[Of]o@03[Od00`00
[Of]o@020002[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@03[Od3
0005[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od0
0`00[Of]o@030002[Od2001kool00:Koo`<007_oo`03003=nLgi00C=n@03003=n@0000K=n@03003=
n<gh00G=n003003=n@0000CEn004003En=Gh0004eMP01@00eOSEn=Gh00000]gG00<00=GGeML01=GG
00<00=gFgMH00mgF00@00=gGgML000?Ue@03003Me]gF00;MeP8000CUe003003UeNGE00?Ue@05003]
/^fbkK800004kK<00`00iM@00003iG@01@00kI?]TnfC00000nfb0P001LCE00@00>EdiGCUM08000B]
o@03002]oJgm00>]o@<000F]o@03002]oJgm00800003[Od00:gm00B]o@8000:]o@8000:]o@03002]
oJgm00>]o@03002]oJgm008000:]o@03002]oJgm00>]o@<000B]o@03002]oJgm00>]o@<000B]o@03
002]oJgm00>]o@<000F]o@8007_oo`00Y?oo0`00O?oo00<00<gicOT01/gi00<00<gicOT01<gi00<0
0<gi00001Lgh00@00<gicOT000CEn005003En=GheOP00002eMP00`00eOSEn003eOP20006eML00`00
eML00004gMH01`00gMOMemgG003Ue@0000GMeP03003MeP0000?Ue003003UeNGE00?Ue@05003]/^fb
kK800004kK<00`00iM@00002iG@00`00kI?]T`02kI<01000kK;]/^fb0P001<CE00<00>EdiG@00^Ed
0P001Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm0`001:gm00<00:gm[Od00Zgm10001:gm00<0
0:gm[Od00jgm0`001Jgm00<00:gm[Od00P0000>]o@00[Od01Jgm00<00:gm[Od00P0000>]o@00[Od0
1Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm1000NOoo002Rool20003ool00`00ooooo`1hool0
0`00cOT00006cOT00`00cOT00004cOT01000cOW=n@001<gh00<00<gicOT00/gi00@00=GheOP000CE
n003003Ef00000KEn003003EemGG00CEe`04003EemGG0003gMH00`00gMOMe`02gML00`00iMD00004
gMH01000gMKMeP000^GD00<00>GEiMD00nGE00<00>GE00000^fb00<00>fckK<00^fc00<00>GD0000
0^Ed00<00>fCkI<00^fC00D00>fbkK;]/P0000G4e@07003UM>EdiG@00>fC00000jgm1@001:gm00<0
0:gm[Od00`0000>]o@00[Od01:gm00<00:gm[Od00`000Zgm00<00:gm[Od00jgm00<00:gm[Od00P00
0Zgm00<00:gm[Od00jgm0`001:gm00<00:gm[Od00jgm0`001:gm00<00:gm[Od00jgm0`001Jgm00<0
0:gm[Od00P0000B]o@00ool007Woo`00Wooo0`00Oooo00@00<gicOT000C=n@8000;=n@05003=nLgi
cOT00004cOT01000cOS=n0001Lgi00<00=Gh00001]Gh00<00=GheOP01=Gh00<00=Gh00001=GG00<0
0=GGeML00]GG00<00=gF00001]gG00<00=gFgMH00mgF00L00=gFgMKMeP00iM@00005iMD00`00iMD0
0002kK801@00kK?]/nfc00000nGD00<00>Ed00000nfC00<00>fbkK800^fb00<00<CEa=D00lCE00D0
0>EdiGCUM00000;]T`<000BKmP03002]oJgm00:]o@<000F]o@03002]oJgm00:]o@<000:]o@04002]
oJgm0003[Od50004[Od00`00[Of]o@0300000jgm002]o@04[Od00`00[Of]o@030002[Od00`00[Of]
o@02[Od00`00[Of]o@030002[Od00`00[Of]o@03[Od30004[Od2001iool009goo`80087oo`03003=
nLgi00;=n@04003=nLgi0005cOT00`00cOT00005cOT00`00cOP00007cOT00`00eOSEn004eOP00`00
eOP00004eOP01000eOSEn0001=GG00<00=GGeML00]GG00<00=gF00001MgG00<00=gG00000mgF00<0
0=gFgMH00]gF0P001NGE00@00>GEiMGUe@8000C]/`07003Ue>GDiM@00>Ed00000nfC00<00>fbkK80
0^fb0P000lCE00<00>EdiG@00^Ed00@00>fCkI<000JKmP03002]oJgm008000:]o@03002]oJgm00>]
o@03002]oJgm008000:]o@04002]oJgm0002[Od40004[Od00`00[Of]o@02[Od30005[Od00`00[Of]
o@02[Od30005[Od01000[Of]oJgm10001Jgm00<00:gm[Od00`0000>]o@00[Od01:gm00<00?oo0000
N?oo002Jool30022ool00`00cOW=n@03cOT00`00cOT00007cOT00`00cOW=n@05cOT00`00cOW=n@05
cOT00`00cOT00004eOP01000eOSEn0001=Gh00D00=GheOSEn00000;Ee`03003EemGG00CEe`03003M
emgG00?Me`04003MemgG0003gMH00`00gMKMeP03gMH00`00iMGUe@03iMD01000iMGUeNGE0P001>fc
00<00>GDiM@00^GD00<00>fCkI<00^fC00L00>fbkK;]/P00kK<00003a=D00`00iGCUM002iG@00`00
kI?]T`020006VoH20004[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@020002[Od00`00[Of]o@03
[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od40003
[Od00`00[Of]o@03[Od30005[Od00`00[Of]o@02[Od200000ooo003oo`1fool009Ooo`<008Coo`03
003=nLgi00G=n@03003=nLgi00G=n@03003=n@0000G=n@03003=n@0000G=n@04003=nLgi0004eOP0
1@00eOSEn=Gh00000]Gh00<00=GheOP00]Gh00<00=GG00001]GG0P001=gG00<00=gGgML00]gG00<0
0=gF00001MgF00<00=gF00000nGE00<00>GEiMD00nGE00D00>fckK?]/`0000GUe003003]TnfC00;]
T`07003]/^fbkK800>fc00000lCE00D00>EdiGCUM00000;]T`03003]/P0000FKmP030034e@0000F]
o@03002]oJgm008000:]o@03002]oJgm00>]o@@000>]o@03002]oJgm00>]o@<000B]o@03002]oJgm
00>]o@<000F]o@03002]oJgm00800003[Od00:gm00F]o@03002]oJgm008000:]o@03002]oJgm00>]
o@03002]oJgm008000:]o@8007Ooo`00UOoo0P00QOoo0P0000?5nP00cOT01<gi00<00<gi00001<gi
0P000/gi00<00<gicOT00/gi00@00<gicOT000C=n@03003=nLgi00;=n@04003En=Gh0004eOP00`00
eOP00006eOP00`00eMOEe`04eML01000eMSEf0000mgG00<00=gGgML00]gG00<00=gF00001MgF00<0
0=gF00000nGE00<00>GEiMD00^GE0P000nfc00<00>GDiM@00nGD00D00>fCkI?]T`0000C]/P06003]
/nfc0034e@001>Ed00H00>fCkI<00>fb0005VoH00`00a=D00005[Od30005[Od00`00[Of]o@020000
1:gm002]o@001:gm00<00:gm[Od00P0000>]o@00[Od01Jgm00<00:gm[Od00P000Zgm00<00:gm[Od0
0jgm0`001:gm00<00:gm[Od00jgm0`001:gm00<00:gm[Od00jgm0`001Jgm0P00M_oo002Bool30026
ool01@00aO[5n/Gj00000lgi0P000/gi00D00<gicOW=n@0000G=n@04003=nLgi0004cOT01000cOW=
n@001Lgi00<00=Gh00001]Gh00<00=GheOP01=Gh00<00=Gh00001=GG00D00=GHeMSEf00000;Me`03
003MemgG00CMe`03003Me]gF00?MeP07003Me]gFgMH00>GE00001NGE00D00=gF003]/`0000GUe003
003Ue@0000;]T`03003]/^fb00;]/P06003]/nfc0034e@001>Ed00H00>fCkI<00>fb0004VoH01@00
a=G4eLCE00000Zgm0P000Zgm00<00:gm[Od00jgm0`001:gm0P001:gm0`001:gm00<00:gm[Od00jgm
0`001:gm00<00:gm[Od00`0000>]o@00[Od01:gm00<00:gm[Od00`0000>]o@00[Od01Jgm00<00:gm
[Od00P000Zgm00<00:gm[Od00jgm0`00MOoo002@ool200000ooo003oo`24ool20005aOX00`00cOT0
0005cOT00`00cOT00006cOT00`00cOT00005cOT00`00cOT00007cOT00`00eOSEn004eOP00`00eOP0
0004eOP01000eOSEn0001=GG00<00=GHeMP00]GH0P001]gG0P001=gF00<00=gFgMH00]gF00<00>GE
00001>GE00H00=gFgMH00>fc0005iM@00`00iMD00002kI<01@00kK;]/^fb00000nfc00<00<CE0000
1>Ed00@00>fCkI<000;]/P05002KmY_fVoH00004a=D20004[Od00`00[Of]o@0300000jgm002]o@04
[Od200001:gm000000000Zgm00<00:gm[Od00Zgm00<00:gm[Od00`000Zgm00<00:gm[Od00Zgm0`00
1Jgm00<00:gm[Od00Zgm0`001Jgm00<00:gm[Od00jgm0`001:gm00<00:gm[Od00`0000>]o@000000
3Ooo0P001?oo00<00?ooool01?oo00<00?ooool0F?oo001Gool20004ool00`00ooooo`02ool4000W
ool30004ool00`00ooooo`21ool00`00aO[5nP06aOX00`00cOW=n@05cOT00`00cOW=n@06cOT00`00
cOW=n@05cOT00`00cOW=n@05cOT00`00cOT00004eOP01000eOSEn0001=Gh00D00=GheOSEn00000;E
e`03003Ef=GH00?Ef003003MemgG00CMe`04003MemgG0002gMH00`00gMKMeP04gMH00`00iMGUe@03
iMD01P00gMKMeP00kK<000CUe007003UeNGEiMD00>fC00000nfb00<00>fckK<00^fc00<00>EdiG@0
0^Ed00D00>fCkI?]T`0000;]/P04002KmY_f0005a=D20004[Od30005[Od00`00[Of]o@02[Od30005
[Od01000[Of]oJgm10001Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<00:gm[Od00P000Zgm
00<00:gm[Od00jgm00<00:gm[Od00`000Zgm00<00:gm[Od00Zgm0`001Jgm0P002ooo00@00?ooool0
00[oo`03003ooooo05Soo`00E_oo00@00?ooool000Soo`03003ooooo02Koo`8008[oo`030035nP00
00K5nP030035nP0000G=n@03003=nP0000K=n@03003=n@0000G=n@03003=n@0000G=n@04003=nLgi
0004eOP01@00eOSEn=Gh00000]Gh00<00=GheOP00]Gh00<00=GG00001MGH00<00=GH00001=gG00D0
0=gGgMOMe`0000;MeP03003Me]gF00?MeP8000CUe@03003Me]gF00;MeP03003Ue>GD00?Ue004003U
eNGEiMD20004kK800`00kK?]/`02kK<00`00iGCUM002iG@01@00kI?]TnfC00000^fb00@009_fVoH0
00C4e@03003UL`0000:]o@8000:]o@03002]oJgm00>]o@03002]oJgm00800003[Od0000000F]o@@0
00>]o@03002]oJgm00>]o@<000B]o@03002]oJgm00>]o@<000F]o@04002]oJgm[Od40005[Od00`00
[Of]o@0200000jgm002]o@05[Od00`00ool0000:ool01000ooooo`001ooo1@00FOoo001Fool01000
ooooo`002Ooo00<00?ooool08_oo0`00Rooo00@00<GjaOX000C5nP8000;5nP03003=nLgi00;=n@04
003=n/gj0004cOT20002cOT00`00cOW=n@02cOT01000cOW=n@001<gi00<00<gicOT00/gi00@00=Gh
eOP000CEn003003En00000KEn003003Ef=GH00CEf003003Ef00000CMe`03003MemgG00;Me`8000KM
eP03003Me`0000;Ue@03003Me]gF00?MeP03003Ue>GD00?Ue003003UeNGE00;Ue@03003]/^fb00;]
/P03003]/nfc00;]/`03003UM>Ed00;UM004003]TnfC0003kK800`00VoH00005a=D00`00iG?UL`02
0004[Od00`00[Of]o@03[Od30003[Od00`00[Od00002[Od20002[Od00`00[Of]o@03[Od00`00[Of]
o@020002[Od00`00[Of]o@03[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od40003[Od00`00[Of]
o@03[Od30004[Od00`00[Of]o@03[Od3000:ool01000ooooo`001ooo00@00?ooool005[oo`00E_oo
00@00?ooool000[oo`03003ooooo01ooo`8008goo`030035n/Gj00;5nP040035n/Gj0005aOX01000
cOW=n@001<gj00@00<gicOT000G=n@04003=nLgi0004cOT01000cOW=n@001Lgi00<00=Gh00001]Gh
00<00=GheOP01=Gh00<00=Gh00001=GH00D00=GHeMSEf00000;Me`03003MemgG00?Me`03003Me]gF
00CMeP04003MemgG0002iMD00`00gMKMeP02gMH20004iM@00`00iMGUe@03iMD01@00kK;]/^fb0000
1>fc00<00>Fd00000nEd00@00>fCkI<000C]/P8000G4e@03003ULnEc008000F]o@03002]oJgm0080
00:]o@06002]oJgm[Od00:gm0`001:gm00<00:gm[Od00jgm0`001:gm00<00:gm[Od00jgm0`001Jgm
00<00:gm[Od00P0000>]o@00[Od01:gm00<00:gm[Od00`0000>]o@00[Od01:gm00<00:gm[Od00`00
0Zgm0P002Ooo00@00?ooool000Soo`03003oo`0005[oo`00E_oo00@00?ooool000_oo`03003ooooo
01_oo`<008koo`030035n/Gj00?5nP030035nP0000K5nP03003=n@0000G=nP03003=n@0000K=n@03
003=n@0000G=n@03003=n@0000O=n@03003En=Gh00CEn003003=n@0000CEn004003En=Gh0003eMP0
0`00eMSEf002eMP00`00gML00005gML20005gMH01`00gMOMemgG003Ue@0000GMeP03003MeP0000?U
e003003UeNGE00?Ue@05003]/^fbkK800004kK<00`00iK@00002iG@01@00kI?]TnfC00001>fb00<0
0<CEa=D00lCE00@00>EciG?UL`8000F]o@<000F]o@03002]oJgm00800003[Od00:gm00F]o@03002]
oJgm00800003[Od00:gm00F]o@03002]oJgm008000:]o@03002]oJgm00>]o@<000B]o@03002]oJgm
00:]o@<000F]o@03002]oJgm00:]o@<000F]o@03003oo`0000Soo`04003ooooo0009ool2001Jool0
05Koo`04003ooooo0008ool01000ooooo`006_oo0`00T?oo00<00<GjaOX01LGj00<00<GjaOX01/Gj
00<00<gjcOX01Lgj00<00<gicOT01/gi00<00<gicOT01Lgi00<00<gicOT01Lgi00<00<gi00001=Gh
00@00<gicOT000CEn007003En=GheOP00=GH00001]GH00<00=gGgML01=gG00<00=GG00001=gF00<0
0=gGgML00]gG0P001=gF00@00=gFgMH000;Ue003003UeNGE00?Ue@03003Ue@0000;]/P03003]/nfc
00;]/`03003U]00000;UM005003]TnfCkI<00004kK800`00a=G4e@03a=D01000iG?UL`000^fB00<0
0:gm[Od00P000Y_f00<00:gm[Od00jgm10000jgm00<00:gm[Od00jgm0`001:gm00<00:gm[Od00jgm
0`001:gm00<00:gm[Od00`0000>]o@00[Od01:gm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<0
0:gm[Od00P000Zgm00<00:gm[Od00jgm10002?oo0P002ooo00<00?ooool0F?oo001Gool2000:ool2
000Iool2002Aool200000lGj0035nP04aOX00`00aOX00006aOX00`00aOX00005cOX00`00aOX00006
cOT00`00cOT00005cOT00`00cOT00004cOT20002cOT00`00eOSEn002eOP01@00cOW=nLgi00000]Gh
00<00=GheOP00]Gh00<00=GH00001MGH00<00=GH00001=gG00@00=GGeML000?MeP03003MemgG00?M
e`03003Me]gF00?MeP07003Me]gFgMH00>GD00001NGE00<00>GE00000^fb00D00>fckK?]/`0000?U
]003003UM00000?]T`03003]/^fb00;]/P8000C4e@04003ULnEc0003kI820004VoH00`00[Of]o@03
00001:gm002]o@000jgm00<00:gm[Od00`000Zgm00<00:gm[Od00Zgm00<00:gm[Od00`000Zgm00<0
0:gm[Od00Zgm0`001Jgm00<00:gm[Od00Zgm0`001:gm00<00:gm[Od00jgm0`001Jgm00<00:gm[Od0
0P0000B]o@00ool0073oo`00Nooo0`000_oo0P00S_oo00D00<GjaO[5nP0000?5nP8000?5nP040035
n/GjaOX20002aOX00`00cO[=nP02cOX01000aO[5nP001<gi0P000/gi00<00<gicOT00/gi00@00<gi
cOT000?=n@03003=nLgi00?=n@04003En=Gh0004cOT00`00eOP00006eOP00`00eMSEf004eMP00`00
eMP00003gML00`00eMOEe`02eML00`00gMH00005gML00`00gML00003gMH00`00gMKMeP02gMH20005
iMD01000iMGUeNGE0P001>fc00L00>FdiKCU]000iG@00003kI<01`00kK;]/^fb003]/`0000?4e@05
003ULnEciG<00003kI800`00VoJKmP04VoH20005[Od20003[Od30005[Od01000[Of]oJgm10001Jgm
00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<00:gm
[Od00P000Zgm00<00:gm[Od00jgm0`001:gm0P00L?oo001iool2002Cool20005aOX00`00aOX00006
aOX00`00aOX00005aOX01000cO[=nP001<Gj00@00<gicOT000G=n@04003=nLgi0004cOT00`00cOT0
0006cOT00`00eOP00006cOT00`00eOSEn004eOP00`00eOP00004eMP01`00eMSEf=GH003Me`0000GE
e`03003MeP0000GMe`03003Me`0000?MeP03003Me]gF00?MeP03003UeNGE00?Ue@04003UeNGEiMD2
0004kK<00`00iKCU]002iK@01@00kI?]TnfC00001>fb00<00>fc00000lCE00D00>EciG?UL`0000?]
TP8000FKmP8000F]o@800003[Od0000000:]o@03002]oJgm00>]o@@000>]o@03002]oJgm00>]o@<0
00B]o@03002]oJgm00>]o@<000B]o@04002]oJgm[Od50004[Od00`00[Of]o@0300000jgm002]o@04
[Od00`00ool0001_ool007Koo`<009Coo`030035n/Gj00K5nP030035n/Gj00K5nP030035n/Gj00C5
nP03003=nP0000G5nP03003=n@0000K=n@03003=n@0000K=n@03003=nLgi00K=n@03003=nLgi00C=
n@03003=n@0000CEn004003En=Gh0003eMP00`00eMSEf002eMP00`00gML00006eML00`00gMOMe`03
gML01`00gMOMemgG003MeP0000GMeP8000CUe@03003UeNGE00?Ue@05003]/nfckK<00005iK@01@00
kI?]TnfC00001>fb00<00>fc00000lCE00D00>EciG?UL`0000;]TP03003]/P0000BKmP030034e@00
00F]o@<000F]o@03002]oJgm00800003[Od00:gm00F]o@03002]oJgm00800003[Od00:gm00F]o@03
002]oJgm008000:]o@03002]oJgm00:]o@@000B]o@03002]oJgm00:]o@<000F]o@03002]oJgm00:]
o@800003ool00?oo06goo`00M?oo0P00U_oo00<00<Gj00001/Gj00<00<Gj00001/Gj00<00<Gj0000
1/Gj00<00<GjaOX01LGj00<00<gicOT01/gi00<00<gicOT01<gi00<00<gi00001/gi00<00<gi0000
1<gi00@00<gicOT000CEn007003En=GheOP00=GH00001]GH00<00=GGeML01=GG00<00=GG00001=gG
00L00=gGgMOMe`00gMH00005gMH00`00gMH00003iMD00`00iMGUe@03iMD01@00kK?]/nfc00001NFd
00D00>fCkI?]T`0000C]/P06003]/nfc0034e@000nEc00L00>fBkI;]TP00kK800004VoH01000a=G4
e@000Zgm0P0000>]o@0000001Jgm0`001:gm00<00:gm[Od00jgm0`001:gm00<00:gm[Od00jgm0`00
1:gm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<0
0:gm[Od00P000Zgm0P00?Ooo0P00;ooo001aool3002Fool20003aOX01000aO[5n/Gj0P000/Gj00<0
0<GjaOX00/Gj0P000/Gj00<00<GjaOX00lGj00<00<Gj00001LGj00<00<Gj00001Lgi0P0000?=n@00
cOT00lgi00@00<gicOT000C=n@8000;=n@05003=nLgicOT00004cOT01000eOSEn0001=Gh00<00=GH
00001MGH00<00=GH00001=GG00@00=GGeML000?Me`03003MemgG00?Me`03003Me]gF00?MeP04003M
e]gF0002iMD00`00iMGUe@03iMD01@00iMH00>fc00001NFd00<00>GE00000^fC00D00>fbkK;]/P00
00?]/`030034e@0000?UL`07003]T^fBkI800>fb00000i_f00<00<CEa=D00/CE0P001:gm0P000Zgm
0P0000>]o@00[Od01:gm00<00:gm[Od00`000Zgm00<00:gm[Od00Zgm00<00:gm[Od00`000Zgm00<0
0:gm[Od00Zgm0`001:gm00<00:gm[Od00jgm0`001:gm00<00:gm[Od00jgm0`001Jgm0P00?_oo00<0
0?ooool0;?oo001_ool2002Hool00`00aO[5nP04aOX00`00aOX00005aOX01000aO[5nP001LGj00<0
0<GjaOX00P000/Gj00@00<GjaO[5nP8000;5nP03003=nLgi00;=n@05003=nLgicOT00003cOT00`00
cOW=n@02cOT01000cOW=n@001Lgi00<00<gi00001Lgi00<00=Gh00001]Gh00<00=GHeMP01=GH00<0
0=GH00001=GG00L00=GGeMOEe`00gML00005gML20005gMH01`00gMKMe]gF003Ue@0000GUe@05003U
eP00kK<00005iK@00`00iMD00002kI<01@00kK;]/^fb00000nfc00<00<CE00000nEc00D00>fBkI;]
TP0000;]/P04002KmY_f0004a=D20004[Od40004[Od00`00[Of]o@02[Od30005[Od01000[Of]oJgm
10001Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm
00<00:gm[Od00P000Zgm00<00:gm[Od00jgm0`00?Ooo0P00;Ooo001/ool3002Iool00`00aO[5nP06
aOX00`00aO[5nP04aOX00`00aOX00006aOX00`00aOX00005aOX00`00aOX00005aOX01000cOT00000
1Lgi00<00<gi00001Lgi00<00<gi00001lgi00<00<gicOT01Lgi00<00=GheOP01=Gh00<00=Gh0000
1=GH00D00=GHeMSEf00000;Ee`03003EemGG00;Ee`03003Me`0000GMe`03003Me`0000?MeP03003M
e]gF00;MeP8000GUe@06003Ue^GF003]/`001>Fd00L00>GEiMGUe@00kI<00003kK800`00kK?]/`02
kK<00`00iG?UL`02iG<01000kI;]TP000nfb00<009_f00001<CE00<00>Ec00000Zgm0`000Zgm00<0
0:gm[Od00Zgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm10000jgm00<00:gm[Od00jgm0`001:gm
00<00:gm[Od00jgm0`001:gm00@00:gm[Of]o@D000B]o@03002]oJgm00<00003[Od0000003coo`04
003ooooo000/ool006[oo`800003ool00?oo09Ooo`800003aOX00<Gj00C5nP800003aOX00<Gj00G5
nP030035n/Gj00K5nP030035n/Gj00G5nP030035n/Gj00G5nP03003=nLgi00K=n@03003=nLgi00G=
n@03003=nLgi00G=n@8000K=n@03003=n@0000CEn004003En=Gh0003eMP00`00eMSEf002eMP00`00
eML00006eML00`00gMOMe`03gML01000gMOMe`000mgF00<00=gFgMH00mgF00<00>GEiMD00nGE00D0
0>GFiMKUeP0000GU]004003UeNGEiMD20004kK800`00kK?]/`02kK<01@00iG?ULnEc00000nfB00L0
0>fbkK;]/P00VoH00004a=D00`00iG?UL`020002[Od01000[Of]o@000jgm10001Jgm00<00:gm[Od0
0P0000>]o@00[Od01Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<00:gm[Od00P000Zgm00<0
0:gm[Od00Zgm10001:gm00<00:gm[Od00Zgm0`001Jgm0P00>ooo00@00?ooool002coo`00Iooo0`00
1?oo00<00?ooool0Tooo0P000lGj00<00<GjaOX00/Gj00D00<GjaO[5nP0000G5nP030035nP0000G5
nP800003aOX00<Gj00C5nP030035nP0000G5nP030035nP0000K=n@03003=n@0000G=n@03003=n@00
00G=n@04003=nLgi0003cOT20002cOT00`00eOSEn002eOP01`00eOSEn=Gh003Ef00000KEf003003E
emGG00CEe`03003Ef00000CMe`07003MemgGgML00=gF00001MgF00<00=gG00000nGE00<00>GFiMH0
0^GF00<00>FdiK@00nFd00<00>GEiMD00^GE00<00>fbkK800^fb00<00>fckK<00^fc00D00>EciG?U
L`0000?]TP03003]/^fb00;]/P030034eLCE00?4e@03003ULnEc008000:]o@03002]oJgm00@000>]
o@03002]oJgm00>]o@<000B]o@03002]oJgm00>]o@<000B]o@04002]oJgm[Od50004[Od00`00[Of]
o@020002[Od00`00[Of]o@03[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od00`00ool0000jool0
1000ooooo`00;?oo001Tool30008ool00`00ooooo`2Aool00`00aO[5nP04aOX01000aOX000001LGj
00<00<GjaOX00P000/Gj00<00<GjaOX00/Gj00D00<GjaO[5nP0000?5nP8000;5nP030035n/Gj00;5
nP040035n/Gj0004cOT20002cOT00`00cOW=n@02cOT01000cOW=n@001<gi00D00<gicOW=n@0000;=
n@03003=nLgi00?=n@04003En=Gh0004eOP00`00eMP00005eMP00`00eMP00004eML01000eMSEf000
0mgG00<00=gGgML00]gG00<00=gF00001MgF00<00=gG00000nGE00@00>GFiMKUeP8000CU]003003U
eNGE00?Ue@05003]/^fbkK800004kK<00`00iK@00002iG<01@00kI;]T^fB00001>fb00<00<CEa=D0
0/CE00P00>EciG?UL`00kI800:gm0`0000>KmP00[Od01Jgm00<00:gm[Od00P0000>]o@00[Od01:gm
00<00:gm[Od00`000Zgm00<00:gm[Od00Zgm10001:gm00<00:gm[Od00Zgm0`001:gm00<00:gm[Od0
0jgm0`001Jgm00@00:gm[Of]o@@003Woo`800003ool0000002coo`00H_oo0P00WOoo0P0000>mn`00
aOX01LGj00<00<GjaOX01LGj00<00<Gj00001LGj00@00<Gj000000G5nP030035nP0000G5nP040035
n/Gj0004aOX01000cOW=n@001Lgi00@00<gicOT000C=n@04003=nLgi0005cOT20006cOT00`00eOP0
0006eOP00`00eMSEf003eMP01000eMSEf0001=GG00L00=GHeMSEf000gML00006gML00`00gMKMeP03
gMH01`00gMOMemgG003Ue@0000CUeP03003MeP0000?U]003003UeNGE00?Ue@05003]/^fbkK800004
kK<00`00iK@00002iG<01@00kI;]T^fB00001>fb00<00<CEa=D00/CE00@00>EciG<000?]TP8000BK
mP03002]oJgm00>]o@<000B]o@03002]oJgm00:]o@<000F]o@03002]oJgm008000:]o@03002]oJgm
00>]o@03002]oJgm00800003[Od00:gm00F]o@03002]oJgm008000:]o@03002]oJgm00>]o@@000>]
o@8006Woo`00Gooo0`00W_oo00D00;gk_O^mn`0000G5nP030035nP0000K5nP8000O5nP030035n/Gj
00K5nP030035n/Gj00C5nP030035nP0000G5nP03003=n@0000K=n@03003=n@0000G=n@03003=n@00
00K=n@03003=nLgi00K=n@03003En=Gh00CEn003003=n00000CEf005003Ef=GHeMP00002eML00`00
eMSEf002eMP00`00gML00005gML00`00eML00004gMH01`00gMOMemgG003Ue@0000?UeP04003Me]gF
0002iK@00`00iMGUe@03iMD00`00iMD00002kK800`00kK?]/`02kK<01P00iKCU]000iG<000;]TP03
003]/^fb00;]/P8000C4e@04003ULnEc0003kI820004VoH00`00[Of]o@030002[Od00`00[Of]o@02
[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@03[Od30004[Od00`00[Of]
o@03[Od30004[Od00`00[Of]o@0300000jgm002]o@04[Od00`00ool0001Xool005goo`8009ooo`80
00Fmn`030035n/Gj008000;5nP030035n/Gj00;5nP8000;5nP030035n/Gj00?5nP030035nP0000G5
nP800003aOX00<Gj00G5nP030035n/Gj00G5nP03003=nLgi00K=n@03003=nLgi00G=n@03003=nLgi
00C=n@03003=n@0000K=n@03003=n@0000CEn004003=n<gh0003eMP00`00eMSEf002eMP00`00eML0
0006eMP00`00gMOMe`04gML00`00eML00003gMH00`00gMOMe`03gML00`00iMKUeP02iMH01`00gMKM
e]gF003U]00000GUe@03003Ue@0000;]/P05003]/nfckK<00003iK@20003kI800`00kK;]/P02kK80
0`00kK<00002a=D01@00iG?ULnEc00000nfB0P001I_f0P001Jgm00@00:gm[Of]o@@000F]o@03002]
oJgm00800003[Od00:gm00F]o@03002]oJgm008000:]o@03002]oJgm00:]o@03002]oJgm00<000:]
o@03002]oJgm00:]o@<000F]o@03002]oJgm00:]o@@006Ooo`00F_oo0`00X?oo00<00;gk_O/01Kgk
00<00<Gj00001LGj00@00<Gj000000C5nP040035n/GjaOX20002aOX00`00aO[5nP02aOX01@00aO[5
n/Gj00001LGj00<00<Gj00001LGj00<00<Gj00001Lgi0P0000?5nP00cOT01<gi00<00<gi00001<gi
00@00<gicOT000C=n@8000;=n@05003En=GheOP00004cOP00`00eMP00006eMP00`00eMSEf004eMP0
0`00eMP00004gML01`00eMOEemGG003MeP0000GMe`8000?UeP03003Me]gF00;MeP8000GUe@04003U
eNGEiMD20004kK<00`00iKCU]002iK@01@00kI;]T^fB00001>fb00<00>fc00000/CE00D00>EciG?U
L`0000?]TP8000FKmP8000F]o@@000>]o@03002]oJgm00>]o@<000B]o@03002]oJgm00>]o@<000B]
o@04002]oJgm[Od40005[Od00`00[Of]o@0200000jgm002]o@05[Od00`00[Of]o@020002[Od2001W
ool005Soo`<00:7oo`03002mn`0000Jmn`8000O5nP030035n/Gj00G5nP030035nP0000G5nP040035
nP000005aOX00`00aO[5nP020002aOX01000aO[5n/Gj0P000/Gj00<00<gicOT00/gi00D00<GjaO[5
nP0000?=n@8000;=n@05003=nLgicOT00004cOT01000cOW=n@001Lgi00<00=Gh00001/gh00<00=GH
eMP01=GH00<00=GH00001=GH00@00=GHeMP000?Me`03003EemGG00;Ee`03003MeP0000GMe`03003M
e`0000;UeP03003Me]gF00?MeP03003UeNGE00?Ue@04003UeNGEiMD20004kK<00`00iKCU]002iK@0
1@00kI;]T^fB00001>fb00<00>fc00000/CE00D00>EciG?UL`0000;]TP03003]/P0000BKmP040034
e<CD0002[Od200000jgm002]o@05[Od00`00[Of]o@0200000jgm002]o@04[Od00`00[Of]o@030002
[Od00`00[Of]o@02[Od40003[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@03[Od30004[Od00`00
ool0001Vool005Goo`<000?oo`03003ooooo09coo`8000:mn`03002mnkgk00:mn`8000:mn`030035
n/Gj00?5nP030035nP0000O5nP030035n/Gj00G5nP030035n/Gj00G5nP030035nP0000G5nP030035
nP0000G5nP04003=n@000005aOX00`00cOT00005cOT00`00cOT00005cOT00`00cOT00007cOT00`00
cOS=n004cOP00`00cOT00004eMP01000eMSEf0001=GH00L00=GHeMSEf000gML00006eML00`00gMOM
e`03gML01P00gMOMe`00iMH000GMeP8000CUe@03003UeNGE00?Ue@05003]/nfckK<00005iK@01000
kI;]TP001>fb00H00>fckK<00<CE0003iG<01`00kI;]T^fB003]/P0000BKmP040034e<CDa=@20004
[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@02[Od30005[Od00`00[Of]o@0200000jgm002]o@05
[Od00`00[Of]o@020002[Od00`00[Of]o@02[Od00`00[Of]o@030002[Od00`00[Of]o@02[Od3001V
ool005?oo`800:Coo`03002mnkgk00>mn`04002mn`000004_O/01000aO[5n/Gj0P000/Gj00<00<Gj
aOX00lGj0P0000?5nP00aOX01<Gj00<00<Gj00001lGj00<00<GjaOX01LGj00<00<GjaOX01LGj00<0
0<GjaOX01/Gj00<00<gicOT01Lgi00<00<gicOT01Lgi00<00<gicOT01Lgi0P001Lgh00@00<gicOT0
00CEf005003Ef=GHeMP00002eMP00`00eMSEf002eMP00`00gML00005eML20004gML00`00gMOMe`02
gML20005gMH00`00gMH00003iMD00`00iMGUe@03iMD01@00kK?]/nfc00001>Fd00D00>Fd003]TP00
00C]/P06003]/nfc0034e@000nEc00H00>fBkI;]TP00kK820002VoH00`00a=C4e002a=@00`00[Of]
o@03[Od00`00[Of]o@030002[Od00`00[Of]o@02[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od3
0004[Od00`00[Of]o@03[Od30004[Od01000[Of]oJgm10001Jgm00<00:gm[Od00P0000B]o@00ool0
06Goo`00D?oo0`00Y?oo0P001kgk00<00;gk_O/01Kgk00<00<Gj00001LGj00D00<GjaO[5nP0000?5
nP040035n/GjaOX20002aOX00`00aO[5nP03aOX200000lGj0035nP04aOX00`00aOX00005aOX00`00
aOX00006aOX00`00aOX00005cOT00`00cOT00005cOT00`00cOT00004cOT20002cOT01@00cOS=n<gh
00001<gi00@00=GHeMP000CEf003003Ef00000KEf003003EemGG00?Ee`04003EemGG0002gML00`00
gMOMe`03gML00`00gMKMeP03gMH01000gMKMeP000^GE00<00>GEiMD00nGE00D00>GE003]/`0000GU
]005003U]000kI800004kK801000kK?]/nfc0P000nEc00H00>fBkI;]TP00kK820002VoH01`00a=C4
e<CD003UL`0000B]o@<000F]o@04002]oJgm[Od40005[Od00`00[Of]o@0200000jgm002]o@04[Od0
0`00[Of]o@030002[Od00`00[Of]o@02[Od40003[Od00`00[Of]o@03[Od30004[Od00`00ool0001T
ool004koo`800:Goo`8000:mn`03002mnkgk00>mn`03002mn`0000Nmn`030035n/Gj00C5nP040035
nP000005aOX00`00aOX00005aOX01@00aO[5n/Gj00000lGj00@00<GjaO[5nP8000;5nP030035n/Gj
00;5nP040035n/Gj0004aOX20002aOX00`00cOW=n@02cOT01000cOW=n@001<gi00@00<gicOT000?=
n@03003=nLgi00;=n@04003=n<gh0005cOT00`00eMP00006eMP00`00eMSEf004eMP20004eML01@00
eMOEemGG00000]gG00<00=gGgML00]gG0P001MgF00L00=gFgMKMeP00iMD00005iMD01@00iMD00>fc
00001>Fd00H00>FdiK@00>fB0004kK801@00kK?]/nfc00001>Ec00H00>fBkI;]TP00kK8200000i_f
0034e003a=@00`00iG<00002[Od20002[Od00`00[Of]o@03[Od40003[Od00`00[Of]o@03[Od30004
[Od00`00[Of]o@02[Od30005[Od00`00[Of]o@0200000jgm002]o@05[Od00`00[Of]o@0200000jgm
002]o@04[Od00`00ool0001Tool004_oo`<00:Goo`8000Bmn`04002mnkgk_O/20002_O/00`00_O^m
n`03_O/200000kgk0035nP05aOX00`00aO[5nP06aOX00`00aO[5nP04aOX01000aOX000001LGj00<0
0<Gj00001LGj00@00<GjaOX000C5nP040035n/Gj0005aOX01000cOW=n@001<gi00@00<gicOT000C=
n@03003=n@0000K=n@8000O=n@03003Ef=GH00CEf08000GEf004003Ef=GH0003eML00`00eMOEe`02
eML20005gML00`00gML00003gMH00`00gMKMeP02gMH20005iMD01P00iMGUe@00kK<000CU]003003U
]>Fd008000C]/P03003]/nfc00;]/`03003ULnEc00;UL`06003]T^fBkI800>fb0P0000>KmP00a=@0
0lCD00<00>EciG<00P001Jgm00<00:gm[Od00P0000>]o@00[Od01:gm00<00:gm[Od00`000Zgm00<0
0:gm[Od00Zgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm0`001:gm00<00:gm[Od00jgm0`001:gm
00<00:gm[Od00Zgm0P0000?oo`00ool0H_oo0017ool4002Wool00`00_O^mn`05_O/00`00_O/00005
_O/01@00_O^mnkgk00000kgk00<00<GjaOX00lGj00<00;gj00001LGj0P0000?5nP00aOX01LGj00<0
0<GjaOX01/Gj00<00<GjaOX01<Gj00<00<Gj00001LGj00<00<Gj00001/Gj00<00<gi00001Lgi00<0
0<gi00001/gi00<00<gicOT01Lgi00<00<gicOT01Lgi0P001MGH00@00=GHeMP000?Ef005003Ef=GH
eMP00002eML00`00eMOEe`03eML00`00gMOMe`03gML01000gMOMe`000mgF00<00=gFgMH00mgF00<0
0>GEiMD00nGE00D00>GEiMGUe@0000GU]005003U]>FdiK@00004kK800`00kK?]/`02kK<01@00iG?U
LnEc00000nfB00H00>fbkK800>fb0004a=@01000iG?ULnEc0P001Jgm0`001:gm00<00:gm[Od00Zgm
0`001Jgm00@00:gm[Of]o@@000F]o@03002]oJgm00800003[Od00:gm00B]o@03002]oJgm00<000:]
o@03002]oJgm00:]o@03002]oJgm008000:]o@03003oo`0006;oo`00A_oo0`00Z?oo00<00;gk0000
1kgk00<00;gk_O/01;gk00@00;gk000000Fmn`030035n/Gj008000:mnP030035n/Gj00;5nP050035
n/GjaOX00005aOX00`00aOX00005aOX200000lGj0035nP05aOX00`00aO[5nP05aOX00`00aO[5nP06
aOX00`00cOW=n@05cOT00`00cOW=n@04cOT00`00cOT00005cOT00`00cOT00005cOT01000cOW=n@00
0mGH00D00=GHeMSEf00000;Ef003003Ef=GH00?Ef08000GEe`03003Ef00000CMe`07003MemgGgML0
0=gF00001MgF00<00=gF00000nGE00<00>GEiMD00^GE00<00>FdiK@00^Fd00<00>FdiK@00^Fd00<0
0>fbkK800^fb00L00>fckK?]/`00kK@00002iG<01@00kI;]T^fB00000nfb0P001<CD00L00>EciG?U
L`00kI800002[Od20002VmD00`00[Of]o@02[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od40003
[Od00`00[Of]o@03[Od30004[Od00`00[Of]o@02[Od30005[Od01000[Of]oJgm10001Jgm0P00H_oo
000Iool2000Xool30003ool00`00ooooo`2Sool20003_O/00`00_O^mn`02_O/200000kgk002mn`05
_O/00`00_O^mn`05_O/00`00aOX00005_OX01000aOX000001LGj00<00<GjaOX00P000/Gj00<00<Gj
aOX00/Gj00D00<GjaO[5nP0000G5nP030035nP0000G5nP030035nP0000G5nP800003aOX00<gi00C=
n@03003=n@0000C=n@04003=nLgi0004cOT01000cOW=n@001<gi00D00<gicOW=n@0000;Ef003003E
f=GH00?Ef08000KEf003003EemGG00CEe`03003Ef00000?Me`03003MemgG00;Me`03003MeP0000GM
eP03003MeP0000?Ue@04003UeNGEiMD20004iK@00`00iKCU]002iK@00`00kK;]/P02kK801`00kK?]
/nfc003]]00000;UL`05003]T^fBkI800003kK820004a=@01000iG?UL`000nfB0P0019_E00@00:gm
[Of]o@@000F]o@03002]oJgm00800003[Od00:gm00B]o@03002]oJgm00<000:]o@03002]oJgm00:]
o@03002]oJgm008000:]o@03002]oJgm00>]o@@000>]o@03002]oJgm00>]o@<0067oo`006?oo00@0
0?ooool002Goo`800:_oo`03002mnkgk00Bmn`04002mn`000003_O/00`00_O^mn`02_O/200000kgk
002mn`06_O/00`00_OZmnP05_OX00`00aO[5nP05aOX00`00aOX00005aOX01000aOX000001LGj00<0
0<GjaOX00P000/Gj00@00<GjaO[5nP8000;5nP030035n/Gj00;5nP050035n/GjaOX00003cOT20002
cOT01@00cOW=nLgi00001<gi00@00<gicOT000C=n@04003=nLgi0005cOT20006eMP00`00eMSEf004
eMP00`00eMP00004eML01`00eMSEf=GH003Me`0000KMe`03003Me]gF00?MeP07003Me]gFgMH00>GE
00001>GE00<00=gF00000nFd00L00>FdiKCU]000iMD00002kK800`00kK?]/`02kK<00`00kK@00002
iG<01@00kI;]T^fB00000nfb0P001<CD00@00>EciG<000?]TP03002KeI_E00BKe@<000>]o@03002]
oJgm00>]o@<000B]o@03002]oJgm00:]o@<000F]o@04002]oJgm[Od40005[Od00`00[Of]o@020000
0jgm002]o@04[Od00`00[Of]o@030002[Od00`00ooooo`1Oool001Soo`04003ooooo000Rool3002/
ool00`00_O^mn`06_O/00`00_O^mn`04_O/01000_O/000001;gk00<00;gk_O/00[gk0P0000>mn`00
_OX01;gj00<00;gj00001lGj00<00<GjaOX01LGj00<00<GjaOX01LGj00<00<Gj00001LGj00<00<Gj
00001LGj00@00<Gj000000G5nP03003=n@0000G=n@03003=n@0000G=n@03003=n@0000G=n@03003=
n@0000K=n@03003Ef=GH00CEf003003=f00000CEf004003Ef=GH0003eML00`00eMSEf002eMP00`00
gML00005gML00`00eML00004gMH01`00gMKMe]gF003Ue@0000?Ue@04003Me]gF0002iK@00`00iKCU
]002iK@00`00iMD00002kK800`00kK?]/`02kK<01P00kKC]]000iG<000?]TP07003]/^fbkK800>fb
00000/CD00D00>EciG?UL`0000?]TP03002KeI_E00BKe@03002]oJgm00B]o@03002]oJgm008000:]
o@03002]oJgm00:]o@03002]oJgm008000:]o@03002]oJgm00>]o@@000>]o@03002]oJgm00>]o@<0
00B]o@03002]oJgm00:]o@<000F]o@80063oo`006?oo00@00?ooool0023oo`800:goo`800003_O/0
0;gk00Bmn`800003_O/00;gk00Fmn`03002mnkgk00Fmn`04002mn`000003_O/01000_OZmn[gj0P00
0kgj00<00<GjaOX00/Gj0P0000?5nP00aOX01<Gj00<00<Gj00001lGj00<00<GjaOX01LGj00<00<Gj
aOX01LGj00<00<GjaOX01/Gj00<00<gicOT01Lgi00<00<gicOT01Lgi00<00<gicOT01Lgi00<00<gi
cOT01<gi00<00<gi00001=GH00@00<gHcMP000CEf007003Ef=GHeMP00=GG00001]GH00<00=gGgML0
1=gG00<00=GG00000mgF00<00=gFgMH00mgF00<00>GEiMD00^GE00L00=gFgMKMeP00iK@00004iK@0
1P00iMGUe@00kK8000?]/`04003]]>fdkK@20004kI801`00kK;]/^fb003]/P0000;4e005003ULnEc
iG<00003kI820004VmD00`00a=@00005[Od30004[Od01000[Of]oJgm10001Jgm00<00:gm[Od00P00
00>]o@00[Od01:gm00<00:gm[Od00`000Zgm00<00:gm[Od00Zgm00<00:gm[Od00P000Zgm00<00:gm
[Od00jgm0`00Gooo000Hool01000ooooo`007Ooo0`00[Ooo0P000kgk00<00;gk_O/00[gk00D00;gk
_O^mn`0000Fmn`03002mn`0000Nmn`03002mnkgk00Bmn`03002mnP0000JmnP040035nP000003aOX0
1000aO[5n/Gj0P000/Gj00<00<GjaOX00lGj0P0000?5nP00aOX01<Gj00<00<Gj00001LGj00<00<Gj
00001/Gj00<00<Gj00001Lgi00<00<Gi00001Lgi00<00<gi00001Lgi00<00<gi00001<gi00@00<gi
cOT000CEf005003=f<gHcMP00002eMP00`00eMSEf002eMP00`00eML00005eMP00`00eMP00004gML0
1`00eMOEemGG003MeP0000GMeP8000?Ue@03003Me]gF00;MeP8000CU]007003UeNGEiMD00>fb0000
0nfc00<00>fdkK@00^fd00D00>fBkI;]TP0000C]/P03003]/P0000;4e005003ULnEciG<00002kI80
0`00mK400004VmD00`00a=@00002[Od30002[Od00`00[Of]o@02[Od40003[Od00`00[Of]o@03[Od3
0004[Od00`00[Of]o@02[Od30005[Od01000[Of]oJgm10001Jgm00<00:gm[Od00P0000>]o@000000
Gooo000Hool01000ooooo`006ooo0P00[_oo0P001[gk00@00;gk000000Fmn`03002mnkgk008000:m
n`03002mnkgk00>mn`800003_O/00;gk00Fmn`03002mn[gj00JmnP030035n/Gj00C5nP030035nP00
00G5nP050035n/GjaOX00003aOX01000aO[5n/Gj0P000/Gj00@00<GjaO[5nP8000;5nP030035n/Gj
00;5nP8000;5nP03003=nLgi00;=n@040035nLGi0004cOT01000cOW=n@001<gi00@00<gicOT000?=
n@03003=nLgi00;=n@04003Ef=GH0004cMP00`00eMP00006eMP00`00eMSEf003eMP01000eMSEf000
0mgG00<00=GGeML00]GG00<00=gF00001MgF00<00=gG00000^GE00<00=gFgMH00mgF00<00>FdiK@0
0^Fd00<00>GEiMD00^GE00<00>fckK<00^fc00<00>fdkK@00^fd00D00>fBkI;]TP0000?]/P800004
kK800<CD0003iG<01`00kI;]T^fB003e/@0000>Ke@040034e<CDa=@20005[Od00`00[Of]o@020000
0jgm002]o@05[Od00`00[Of]o@020002[Od00`00[Of]o@02[Od00`00[Of]o@020002[Od00`00[Of]
o@03[Od40003[Od00`00[Of]o@03[Od30004[Od2001Nool001Woo`8001Woo`<00:koo`8000:mn`03
002mnkgk00Bmn`03002mnkgk00Fmn`03002mn`0000Fmn`05002mnkgk_O/00003_O/00`00_O^mn`02
_O/200000kgk002mnP04_OX200000kgk0035nP05aOX00`00aO[5nP04aOX01000aOX000001LGj00<0
0<Gj00001LGj00<00<Gj00001LGj00@00<GjaOX000G5nP04003=nLgi0004aOT01000cOW=n@001<gi
00@00<gicOT000C=n@03003=n@0000G=n@03003Ef00000K=f003003Ef=GH00CEf003003Ef00000CE
f007003Ef=GHeMP00=gG00001]GG00<00=gFgMH00mgF00H00=gGgML00>GE0005gMH00`00gMH00002
iK@00`00iMGUe@03iMD00`00kK?]/`02kK<00`00kKC]]002kK@01@00kI;]T^fB00000nfb0P0000C]
/P00a=@000?UL`07003]T^fBkI800?Fa00000i_E00@00<CDa=C4e08000F]o@<000B]o@03002]oJgm
00>]o@<000B]o@04002]oJgm[Od40005[Od00`00[Of]o@0200000jgm002]o@04[Od00`00[Of]o@03
0002[Od00`00[Of]o@02[Od00`00ool0001Mool003;oo`8000;oo`800:_oo`8000Bmn`03002mnkgk
00:mn`800003_O/00;gk00Fmn`8000Jmn`04002mn`000005_O/01000_O/000000kgk00<00;gj_OX0
0[gj00D00;gk_O^mn`0000G5nP030035nP0000K5nP030035n/Gj00K5nP030035n/Gj00G5nP030035
n/Gj00C5nP030035nP0000K5nP03003=n@0000G5n@03003=n@0000G=n@03003=n@0000K=n@03003=
nLgi00G=n@03003=f<gH00C=f003003=f00000CEf004003Ef=GH0003eMP00`00eMSEf002eMP00`00
gML00005eML20004gMH00`00gMOMe`02gML20005gMH00`00gMH00002iK@00`00iMGUe@03iMD01@00
kK?]/nfc00001>fd00<00>Fd00000^fB00@00>fbkK;]/P8000;]/P8000?UL`07003]T^fBkI800?Fa
00000Y_E00<00<CDa=@00/CD00<00>Ec00000Zgm0P0000>]o@00[Od01:gm00<00:gm[Od00`000Zgm
00<00:gm[Od00Zgm10000jgm00<00:gm[Od00jgm0`001:gm00<00:gm[Od00Zgm0`001Jgm00@00:gm
[Of]o@@005goo`00;ooo0`00/?oo00<00;gk_O/01Kgk00@00;gk000000>mn`03002mnkgk00:mn`80
00:mn`03002mnkgk00Bmn`03002mnkgk00Jmn`03002mnkgk00Bmn`04002mnP000005_O/00`00aO[5
nP020002aOX00`00aO[5nP02aOX200000lGj0035nP04aOX200000lGj0035nP04aOX00`00aOX00006
aOX00`00aO[5nP06aOX00`00aOW5n@05aOT00`00cOW=n@05cOT00`00cOW=n@04cOT00`00cOT00005
cOT00`00cOT00004cMP01000cMS=f0001=GH00L00=GHeMSEf000eMP00006eMP00`00eMOEe`04eML0
0`00eML00002gMH00`00gMOMe`03gML00`00gMKMeP03gMH01`00gMKMe]gF003U]00000CUe@03003U
e@0000;]/`03003]]>fd00;]]003003U]00000;]TPD00004kK800>fb0004iG<01`00kI;]T^fB003e
/@0000:Ke@050034e<CDa=@00003iG<20004[Od00`00[Of]o@02[Od30005[Od00`00[Of]o@020000
0jgm002]o@04[Od00`00[Of]o@030002[Od00`00[Of]o@02[Od00`00[Of]o@020002[Od00`00[Of]
o@03[Od40003[Od2001Lool002coo`<00;7oo`800003_O/00;gk00Jmn`03002mnkgk00Bmn`04002m
n`000004_O/00`00_O^mn`02_O/200000kgk002mn`04_O/200000kgk002mn`05_O/00`00_O^mn`05
_O/00`00aOX00005aOX01000aOX000000lGj00<00<GjaOX00/Gj00D00<GjaO[5nP0000?5nP8000;5
nP030035n/Gj00?5nP030035nP0000G5nP<000G5n@800003aOX00<gi00C=n@03003=n@0000C=n@04
003=nLgi0004cOT01000cOW=n@000lgH00<00<gHcMP00/gH00@00=GHeMP000GEf003003Ef=GH00CE
f003003Ef00000CEe`04003EemGG0002gMH00`00gMOMe`02gML20005gMH01000gMKMe]gF0P001NGE
00<00>GE00000^fc00D00>fdkKC]]00000?U]0<000;]/P06003]/^fb003]/P001>Ec00D00>fBkI;]
TP0000;e/@8000C4e004003ULnEciG<20004[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od30004
[Od00`00[Of]o@02[Od30005[Od01000[Of]oJgm10001:gm00<00:gm[Od00`0000>]o@00[Od01:gm
00<00?oo0000Fooo000Zool2002bool20004_O/00`00_O^mn`02_O/200000kgk002mn`05_O/00`00
_O^mn`05_O/01000_O/000000kgk00<00;gk_O/00[gk00D00;gk_O^mn`0000Fmn`03002mn`0000Jm
n`8000O5nP030035n/Gj00C5nP040035nP000005aOX00`00aOX00005aOX00`00aO[5nP020002aOX0
0`00aO[5nP02aOX01@00aO[5n/Gj00000lGi00D00<GjaO[5nP0000?=n@8000;=n@05003=nLgicOT0
0004cOT01000cOW=n@001<gi00<00<gH00001LgH00<00=GH00001MGH00<00=GH00001=GH00@00=GH
eMP000?Ee`03003EemGG00;Ee`8000GMe`03003Me`0000?MeP03003Me]gF00?MeP03003UeNGE00;U
e@07003UeNGEiMD00>fc00000nfd1P000nfb00@00>fbkK;]/P8000?UL`05003]T^fBkI800003mK42
0004a=@01000iG?ULnEc0P000jgm10001Jgm00<00:gm[Od00P0000>]o@00[Od01:gm00<00:gm[Od0
0P000Zgm00<00:gm[Od00jgm10000jgm00<00:gm[Od00Zgm0`001Jgm00<00:gm[Od00Zgm0`00Fooo
000Wool3002cool00`00_O^mn`05_O/01000_O/000000kgk00<00;gk_O/00[gk0P0000>mn`00_O/0
1[gk00<00;gk_O/01;gk00@00;gk000000Fmn`03002mnkgk008000:mn`03002mnkgk00:mn`8000:m
n`030035n/Gj00?5nP03002mnP0000K5nP030035n/Gj00K5nP030035n/Gj00C5nP030035nP0000G5
nP040035nP000004aOX01000aOT000001LGj00<00<gi00001Lgi00<00<gi00001Lgi00<00<gi0000
1/gi00<00<gHcMP01LgH00<00=GHeMP00mGH00@00=GHeMP000CEf007003Ef=GHeMP00=GG00001MGG
00<00=gGgML00mgG00@00=gGgML000?MeP03003Me]gF00;MeP8000CUe@04003UeNGEiMD20003kK@2
0004iK@01@00kK;]/^fb00000nfb0`000^Ec00D00>fBkI;]TP0000?e/@030034e<CD00?4e004003U
LnEc0002kI830003VmD00`00[Of]o@03[Od30004[Od00`00[Of]o@02[Od30005[Od00`00[Of]o@02
00000jgm002]o@04[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od00`00[Of]o@020002[Od2001J
ool002Goo`800;Coo`800003_O/00;gk00Fmn`8000Jmn`04002mn`000004_O/00`00_O^mn`02_O/2
00000kgk002mn`05_O/00`00_O^mn`05_O/00`00_O/00005_O/01000_O/000001;gk00@00<GjaO[5
nP8000:mnP030035n/Gj00?5nP030035nP0000G5nP800003aOX00<Gj00G5nP030035n/Gj00G5nP03
0035n/Gj00G5nP030035n/Gj00K5nP03003=nLgi00G=n@03003=nLgi00G=n@03003=nLgi00C=n@03
003=n@0000G=f003003=f@0000CEf005003Ef=GHeMP00002eMP00`00eMSEf002eMP00`00eML00004
eML00`00eML00004gML01`00gMOMemgG003MeP0000GMeP03003MeP0000;Ue@03003UeNGE00?Ue@D0
00GU]005003]/^fbkK800003kK800`00kK@00002iG<01@00kI;]T^fB00000oFa00<00<CDa=@00/CD
00D00>EciG?UL`0000;]TP03002KeI_E00>Ke@03002]oJgm00<000:]o@03002]oJgm00:]o@03002]
oJgm008000:]o@03002]oJgm00>]o@<000B]o@03002]oJgm00:]o@<000F]o@04002]oJgm[Od40004
[Od00`00ool0001Iool002?oo`800;Coo`8000>mn`03002mnkgk00:mn`8000:mn`03002mnkgk00Bm
n`03002mnkgk00Fmn`04002mn`000003_O/00`00_O^mn`02_O/200000kgk002mn`06_O/00`00_O^m
n`05_O/00`00_O^mn`05_O/00`00aOX00005_OX00`00aO[5nP020002aOX00`00aO[5nP02aOX01@00
aO[5n/Gj00001LGj00<00<Gj00001LGj00<00<Gj00001LGj00<00<Gj00001/Gj0P001/gi00<00<gi
00001Lgi00<00<gi00001<gi00@00<gicOT000C=f004003=fLgI0003eMP00`00eMSEf002eMP00`00
eMP00006eMP00`00eMOEe`03eML00`00eML00003gML00`00gMOMe`02gML00`00gMH00004gMH01000
gMKMeP000^GE00@00>GEiMGUe@<000?]]003003U]>Fd00?U]004003]/^fb0004kK800`00kK@00002
iG<01@00kI;]T^fB00000oFa0P000lCD00D00>EciG?UL`0000;]TP03002KeI_E00BKe@8000F]o@04
002]oJgm[Od40004[Od00`00[Of]o@0300000jgm002]o@04[Od00`00[Of]o@020002[Od00`00[Of]
o@03[Od40003[Od00`00[Of]o@02[Od3001Iool002?oo`@00;3oo`8000Jmn`04002mn`000004_O/0
0`00_O^mn`02_O/200000kgk002mn`05_O/20006_O/01000_O/000001;gk00<00;gk_O/00[gk0P00
00>mn`00_O/01;gk00<00;gk00001kgk00<00;gj_OX01;gj00<00<Gj00001LGj00@00<Gj000000G5
nP030035n/Gj008000;5nP040035n/GjaOX20002aOX00`00aO[5nP02aOX01000aO[5nP001<Gj0P00
0/Gj00@00<gicOW=n@8000;=n@03003=nLgi00;=n@04003=nLgi0003cOT00`00cOW=n@02cOT01000
cMS=f0001<gI00<00=GH00001]GH00<00=GHeMP01=GH0P001=GG00L00=GGeMOEe`00gML00006gML0
0`00gMKMeP03gMH01`00gMKMeP00iMD00>GE00<00006iMD00=gF003]]0001NFd00D00>Fe003]/P00
00C]/P06003]]>fd003UL`000nfB00H00?FamK400>fb0003a=@01@00iG?ULnEc00000^fB0P001I_E
0P001Jgm10000jgm00<00:gm[Od00Zgm0`001Jgm00<00:gm[Od00Zgm0`001:gm00<00:gm[Od00`00
00>]o@00[Od01:gm00<00:gm[Od00P000Zgm0P00F?oo000Sool4002^ool20002_O/00`00_O^mn`04
_O/00`00_O^mn`05_O/01000_O/000000kgk00<00;gk_O/00[gk0P000[gk00<00;gk_O/01;gk00<0
0;gk_O/01Kgk00@00;gk000000>mn`04002mnkgk_O/20002_O/00`00_O^mn`03_O/200000kgk002m
nP05_OX00`00aO[5nP05aOX00`00aO[5nP05aOX00`00aOX00005aOX00`00aOX00005aOX01000aO[5
nP001<Gj00@00<GjaOX000C5nP04003=nLgi0005cOT01000cOW=n@001<gi00<00<gi00001Lgi00<0
0<gH00001/gI00<00=GHeMP01=GH0P001MGH00@00=GHeMP000;Ee`03003EemGG00;Ee`03003Me`00
00GMe`03003Ee`0000?MeP03003Me]gF00;MeP<000?Ue@06003Me]gF003]]0001NFd00D00>Fe003]
/P0000?]/P04003]]>fdkK@20004kI801P00mK7e/@00kK8000?4e005003ULnEciG<00002kI820004
VmD01000a;C4]0000Zgm0P0000>]o@00[Od01:gm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm00<0
0:gm[Od00P000Zgm00<00:gm[Od00Zgm0`001Jgm00<00:gm[Od00Zgm0`001:gm00<00?oo0000Eooo
000Sool01000ooooo`00[?oo0P001;gk00<00;gk_O/00[gk0P0000>mn`00_O/01Kgk0P001[gk00@0
0;gk000000Bmn`03002mnkgk00:mn`800003_O/00;gk00Fmn`8000Jmn`03002mn`0000Fmn`05002m
nkgk_O/00003_O/00`00_OZmnP02_OX200000kgj0035nP04aOX00`00aOX00007aOX00`00aO[5nP05
aOX00`00aO[5nP04aOX00`00aOX00005aOX00`00aOX00006aOX20006cOT00`00cOT00006cOT00`00
cOW=n@05cOT00`00cMW=f@04cMT00`00cMT00004eMP01000cMS=f0000mGH00L00=GHeMSEf000eML0
0006eML00`00gMOMe`04gML00`00eML00003gMH00`00gMH000030005iMD01@00gMKMe]gF00001NFd
00H00>FeiKD00>fb0003kK800`00kKC]]002kK@20002kI801`00mK7e/OFa003]/P0000;4e005003U
LnEciG<00002kI800`00mK400004VmD01000a;C4]<Bd0P001:gm00<00:gm[Od00Zgm0`001Jgm00@0
0:gm[Of]o@@000B]o@03002]oJgm008000:]o@03002]oJgm00>]o@03002]oJgm008000:]o@03002]
oJgm00:]o@@005Koo`008_oo00<00?ooool00_oo00<00?ooool0Z?oo00<00;gk_O/01Kgk00@00;gk
000000>mn`03002mnkgk00:mn`8000:mn`03002mnkgk00Bmn`03002mnkgk00Fmn`04002mn`000003
_O/00`00_O^mn`02_O/20002_O/00`00_O^mn`04_O/00`00_O^mn`04_O/01000_O/000001Kgk00@0
0;gj000000>mnP040035n/GjaOX20002aOX00`00aO[5nP03aOX200000lGj0035nP04aOX00`00aOX0
0006aOX00`00aO[5nP05aOX00`00aO[5nP05aOX00`00cOW=n@06cOT00`00cOW=n@04cOT00`00cOT0
0005cOT00`00cMT00004cMT01000cMW=f@001=GH00@00<gHcMP000;Ef003003Ef=GH00?Ef08000GE
e`03003Ef00000CMe`06003EemGGeML00=gF0`000]gF00<00=gG00000nGE00<00=gFgMH00]gF00<0
0>FdiK@00nFd00D00>FeiKGU]@0000C]/P03003]]>fd00;]]08000;]TP05003e/OFamK400002kK80
0`00a=@00003iG<01P00kI;]TP00mK4000>Ke@030034]<Bd00;4]08000B]o@03002]oJgm008000:]
o@03002]oJgm00>]o@@000>]o@03002]oJgm00:]o@<000F]o@04002]oJgm[Od40004[Od00`00[Of]
o@0200001:gm003oo`00E_oo000Rool00`00ooooo`03ool00`00ooooo`2Uool200000kgk002mn`06
_O/00`00_O^mn`04_O/01000_O/000001;gk00<00;gk_O/00[gk0P0000>mn`00_O/01Kgk0P001[gk
00@00;gk000000Bmn`03002mnkgk00:mn`800003_O/00;gk00Fmn`03002mnkgk00Jmn`03002mn[gj
00BmnP030035nP0000G5nP050035n/GjaOX00003aOX01000aO[5n/Gj0P000/Gj00<00<GjaOX00lGj
00<00<Gj00001LGj00<00<Gj00001LGj00<00<Gj00001Lgi0`001<gi0P000/gi00<00<gicOT00/gi
00@00<gIcMT000C=f@05003=fLgIcMT00002eMP00`00cMS=f002cMP20006eMP00`00eMOEe`04eML0
0`00eMP00003gML01000eMOEemGG10001=gF00<00=gG00000nGE00@00=gFgMKMeP8000CU]003003U
]NFe00;U]@03003]/^fb00;]/P03003]]>fd00;]]005003]TP00kI800003mK401P00kK;]/P00a=@0
00?UL`04003]T^fB0002mK401000VmFKe@001<Bd0P000jgm10001Jgm00<00:gm[Od00P000Zgm00<0
0:gm[Od00Zgm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm10000jgm00<00:gm[Od00Zgm0`001:gm
00<00?oo0000EOoo000Gool20009ool00`00ooooo`04ool00`00ooooo`2Rool20004_O/00`00_O^m
n`02_O/200000kgk002mn`05_O/00`00_O^mn`05_O/01000_O/000000kgk00<00;gk_O/00[gk0P00
0[gk00<00;gk_O/01;gk00<00;gk_O/01Kgk00@00;gk000000>mn`03002mnkgk00:mn`800003_O/0
0;gk00Bmn`800003_O/00;gj00FmnP030035n/Gj00C5nP040035nP000005aOX00`00aOX00005aOX0
0`00aO[5nP020002aOX01000aO[5n/Gj0P000/Gj00@00<GjaO[5nP8000;5nP03003=nLgi00;=n@05
003=nLgicOT00002cOT00`00cOW=n@03cOT01000cOW=n@001<gI00@00<gIcMT000C=f@03003Ef000
00G=f003003Ef=GH00CEf003003Ef00000CEe`08003Ef=GHeMP00=gG003Ee`<000;Ee`03003Me]gF
00;MeP07003MemgGgML00>GE00001=gF00<00=gF00000nFd00<00>FeiKD00^Fe00D00>fbkK;]/P00
00C]]004003U]000kI820002mK401`00kK;]/^fb0034e00000?UL`04003]T^fB0002mK401000VmFK
e@000lBd00<00>ECiE<00`000jgm00<00:gm[Od00jgm0`001:gm00@00:gm[Of]o@@000B]o@03002]
oJgm00<00003[Od00:gm00B]o@03002]oJgm008000:]o@03002]oJgm00:]o@03003oo`0005Goo`00
5_oo00@00?ooool000Soo`03003ooooo00Goo`800:7oo`03002mnkgk00Fmn`04002mn`000003_O/0
0`00_O^mn`02_O/200000kgk002mn`06_O/00`00_O^mn`04_O/01000_O/000001;gk00<00;gk_O/0
0[gk0P0000>mn`00_O/01Kgk0P001[gk00@00;gk000000>mn`03002mnkgk00:mn`05002mnkgk_O/0
0005_OX00`00_OX00006aOX00`00aO[5nP06aOX00`00aO[5nP04aOX00`00aOX00005aOX00`00aOX0
0005aOX00`00aOX00005aOX01000cOT000001<gi00<00<gi00001/gi00<00<gi00001LgI00<00<gI
00001/gI00<00<gHcMP00lgH00<00<gH00001=GH00@00=GHeMP000?Ee`03003Ef=GH00;Ef004003M
e`000004eML20004gMH01`00gMOMemgG003Ue@0000?MeP04003Me]gF0002iK@00`00iKGU]@02iKD0
0`00iMD00002kK800`00kKC]]002kK@01000iK@00>fB0P000_Fa00<00>fbkK800^fb00<00>EciG<0
0^Ec00@00>fBkI8000;e/@03002Ke@0000C4]003003UDnEC008000B]o@03002]oJgm00<000:]o@03
002]oJgm00:]o@@000>]o@03002]oJgm00:]o@<000F]o@03002]oJgm00:]o@<000B]o@04002]oJgm
[Od300000ooo003oo`1Cool001Koo`04003ooooo0008ool00`00ooooo`07ool00`00ooooo`2Lool2
00000kGk002mn`05_O/20006_O/01000_O/000001;gk00<00;gk_O/00kgk00<00;gk00001[gk00<0
0;gk_O/01Kgk00@00;gk000000>mn`03002mnkgk00:mn`8000:mn`03002mnkgk00Bmn`03002mnkgk
00Bmn`04002mn`000005_O/00`00_OZmnP020002_OX00`00aO[5nP02aOX200000lGj0035nP04aOX3
0006aOX20007aOX00`00aO[5nP05aOX00`00aO[5nP05aOX00`00cOW=n@05cOT00`00cOW=n@06cOT0
0`00cMW=f@05cMT00`00cMW=f@04cMT20004cMP01000cMS=f0001=GH00L00=GHeMSEf000eML00004
eMP30005eML01000eMOEe`000]gF00<00=gGgML00mgG00<00=gFgMH00]gF00L00=gFgMKMeP00iK@0
0004iKD00`00iMD00002kK800`00kKC]]002kK@01P00iKCU]000kI8000;e/@03003]/^fb00;]/P03
003ULnEc00;UL`04003]T^fB0002mK400`00VmD00004a;@00`00iE?UD`020003[Od40005[Od00`00
[Of]o@0200000jgm002]o@04[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od00`00[Of]o@020002
[Od00`00[Of]o@02[Od40003[Od2001Dool001Koo`04003ooooo0008ool00`00ooooo`08ool00`00
ooooo`2Iool20003]O/00`00_O^mn`02_O/20002]O/00`00_O^mn`04_O/00`00_O^mn`04_O/01000
_O^mnkgk0P000[gk00<00;gk_O/00kgk00<00;gk00001kgk00<00;gk_O/01;gk00@00;gk000000Bm
n`03002mnkgk00:mn`800003_O/00;gk00Fmn`03002mnkgk00Fmn`03002mnP0000FmnP040035nP00
0003aOX00`00aO[5nP02aOX01@00aO[5n/Gj00000lGj0P000/Gj00<00<GjaOX00lGj00<00<Gj0000
1LGj00<00<Gj00001LGj00<00<Gj00001Lgi00<00<Gi00001/gi0P001LgI0`001<gI0P000/gI00D0
0<gHcMS=f00000?=f004003Ef=GH0004eMP01000eML00=GH0`0000?Ef00000001=GG00L00=GGeMOE
e`00gMH00005gML20003gMH00`00gMKMeP02gMH20005iKD01P00iMGUe@00kK8000?]]004003U]>Fd
iK@200001?Fa003e/@001>fb00D00>EciG?UL`0000?]TP05003e/OFamK400005a;@00`00iE<00002
kI830003VmD00`00[Of]o@03[Od30004[Od00`00[Of]o@02[Od30005[Od01000[Of]oJgm10001:gm
00<00:gm[Od00P0000>]o@00[Od01Jgm0P00Dooo000Fool01000ooooo`001ooo0`002_oo00<00?oo
ool0Uooo00<00;Gk]O/01;Gk00@00;gk000000Ben`03002mnkgk00:mn`800003_O/00;gk00Fmn`03
002mn`0000Fmn`03002mnkgk008000>mn`03002mnkgk00>mn`03002mn`0000Jmn`03002mnkgk00Fm
n`04002mn`000003_O/00`00_O^mn`02_O/200000kgk002mn`05_O/20007_OX00`00aO[5nP04aOX0
1000aOX000001<Gj00@00<Gj000000C5nP040035n/GjaOX20002aOX01000aO[5n/Gj0P000/Gj00@0
0<GjaO[5nP8000;5nP03003=nLgi00;=n@040035nLGi0004cOT20002cOT01@00cMW=fLgI00000lgI
00@00<gIcMT000C=f@04003=f<gH0004cMP00`00eMP00006eMP30003eMP01000eMSEf0000mGG00<0
0=GGeML00]GG0P001MgG00<00=gG00000]gF00<00=gFgMH00mgF00<00>FeiKD00^Fe00@00>GEiMGU
e@8000C]]003003U]>Fd00;U]004003e/OFa0005kK820002iG<01@00kI;]T^fB00000oFa00<00<Bd
a;@00/Bd00@00>ECiE<000;]TP03002KeI_E00BKe@03002]oJgm008000:]o@03002]oJgm00:]o@03
002]oJgm008000:]o@03002]oJgm00>]o@@000>]o@03002]oJgm00:]o@<000B]o@03002]oJgm00>]
o@<000goo`8000Coo`03003ooooo00?oo`8003Ooo`005_oo00@00?ooool000Ooo`03003ooooo00_o
o`03003ooooo09Coo`800003]O/00;Gk00Fen`03002enkGk00Fen`04002mn`000003_O/00`00_O^m
n`04_O/20006_O/00`00_O/00005_O/01000_O^mnkgk0P000[gk00<00;gk_O/00kgk00<00;gk0000
1kgk00<00;gk_O/01;gk00@00;gk000000>mn`03002mnkgk00:mn`8000:mn`03002mn[gj00>mnP03
002mnP0000K5nP030035n/Gj00G5nP030035n/Gj00G5nP030035nP0000G5nP030035nP0000G5nP03
0035nP0000G5nP04003=nLgi0004aOT01000cOW=n@001<gi00@00<gI000000C=f@03003=f@0000K=
f@8000K=f003003Ef=GH00;Ef0<00003eMP00=GH00?Ef004003Ef=GH0002eML00`00eMOEe`03eML0
0`00gMOMe`03gML01P00gMOMe`00gMH000GMeP8000CU]@03003UeNGE00;Ue@03003]]>fd00;]]003
003U]>Fd00;U]004003e/OFa0004kK800`00kK<00002iG<01000kI;]TP001?Fa00<00<Bda;@00/Bd
00@00>ECiE<000;]TP03002KeI_E00FKe@8000B]o@04002]oJgm[Od40004[Od00`00[Of]o@030000
0jgm002]o@04[Od00`00[Of]o@020002[Od00`00[Of]o@02[Od00`00[Of]o@030002[Od00`00oooo
o`0:ool01000ooooo`002?oo00@00?ooool003Koo`005ooo0P002?oo00<00?ooool03?oo00<00?oo
ool0TOoo0P000kGk00<00;Gk]O/00[Gk0P0000>en`00]O/01[Gk00<00;gk_O/01;gk00@00;gk_O^m
n`8000:mn`03002mnkgk00Bmn`03002mnkgk00Fmn`03002mn`0000Fmn`03002mnkgk008000:mn`03
002mnkgk00>mn`800003_O/00;gk00Fmn`03002mnkgk00Bmn`04002mn`000004_O/01000_OZmn[gj
0P000[gj00<00<GjaOX00/Gj0P0000>mnP00aOX01<Gj00<00<Gj00001lGj00<00<GjaOX01LGj00<0
0<GjaOX01LGj00<00<GjaOX01<Gj00<00<gi00001LGi00<00<gi00001/gi00<00<gIcMT01LgI00<0
0<gIcMT01LgI00<00<gHcMP01<gH00<00<gI00000`0000GEf000eMSEf00000?Ef003003Ef=GH00;E
f08000GEe`03003Ee`0000CMe`04003MemgGgML20005gMH00`00gMH00002iKD00`00iMGUe@03iMD0
0`00kKC]]002kK@00`00iKCU]002iK@00`00mK7e/@020003kK800`00kK<00002iG<01000kI;]TP00
1?Fa0P000lBd00@00>ECiE<000;]TP8000JKe@8000B]o@@000>]o@03002]oJgm00:]o@<000F]o@03
002]oJgm00:]o@<000B]o@04002]oJgm[Od40005[Od2000;ool01000ooooo`002?oo00@00?ooool0
03Koo`008Ooo00<00?ooool03Ooo00<00?ooool0S_oo0P001[Gk00@00;Gk000000Ben`03002enkGk
00:en`800003]O/00;gk00Bmn`04002mn`000004_O/00`00_O^mn`02_O/200000kgk002mn`05_O/2
0006_O/00`00_O/00005_O/01@00_O^mnkgk00000kgk00<00;gk_O/00[gk0P0000>mn`00_O/01Kgk
00<00;gk_O/01Kgk00<00;gj00001Kgj00@00<Gj000000>mnP040035n/GjaOX20002aOX00`00aO[5
nP03aOX200000lGj0035nP04aOX00`00aOX00005aOX00`00aOX00006aOX00`00aOW5n@05aOT00`00
cOW=n@04cOT00`00cOT00005cMT00`00cMT00005cMT00`00cMT00004cMP40003eMP00`00eMSEf002
eMP00`00eMP00005eMP00`00eMOEe`04eML00`00eML00003gML00`00gMOMe`02gML00`00gMKMeP03
gMH01000gMKMeP000^Fe00<00>GEiMD00^GE00<00=gF00000^fd00<00>FdiK@00^Fd00L00>Fe003e
/@00kK800002kK801P00kK?]/`00iG<000;]TP07003e/OFamK400>fb00000lBd00@00>ECiE<000;]
TP8000FKe@030034]00000:]o@800003[Od00:gm00B]o@03002]oJgm008000:]o@03002]oJgm00>]
o@03002]oJgm008000:]o@03002]oJgm00:]o@@000>]o@03002]oJgm00>]o@<000[oo`04003ooooo
0008ool3000gool0027oo`03003ooooo00koo`03003ooooo08_oo`8000:en`03002enkGk00Ben`03
002enkGk00Fen`04002en`000003]O/00`00_O^mn`03_O/20007_O/01000_O/000000kgk00<00;gk
_O/00[gk0P000[gk00<00;gk_O/01;gk00<00;gk_O/01;gk00@00;gk000000Fmn`04002mn`000003
_O/00`00_O^mn`02_O/200000kgk002mn`05_O/20007_OX00`00_OZmnP04_OX00`00aOX00005aOX0
1@00aO[5n/Gj00000lGj00@00<GjaO[5nP8000;5nP030035n/Gj00;5nP040035n/Gj0005aOX00`00
aOX00005aOT00`00aOX00004cOT01000cOW=n@001<gI00@00<gIcMT000C=f@04003=fLgI0002cMP3
0003cMT00`00eMP00006eMP00`00eMSEf003eMP00`00eMP00004eML01`00eMOEemGG003Me`0000CM
e`8000GMeP07003Me]gFgMH00>Fe00001>GE00<00=gF00000^fd00<00>FdiK@00^Fd00D00>Fe003e
/@0000;]/P03003]/P0000;]/`8000?]TP07003e/OFamK400>fb00000/Bd00T00>ECiE?UD`00kI80
0?FA00001I_E00<00<Bda;@00P001:gm00<00:gm[Od00Zgm0`001Jgm00@00:gm[Of]o@@000B]o@03
002]oJgm00800003[Od00:gm00F]o@03002]oJgm008000:]o@03003ooooo00Soo`04003ooooo0008
ool00`00ooooo`0gool0027oo`03003ooooo00ooo`03003ooooo08Soo`8000Ben`03002enkGk00:e
n`800003]O/00;Gk00Fen`8000Jen`03002mnkgk008000:mn`03002mnkgk00Fmn`03002mnkgk00Bm
n`04002mn`000004_O/00`00_O^mn`02_O/200000kgk002mn`05_O/00`00_O^mn`06_O/00`00_O^m
n`04_O/01000_O/000000kgk00<00;gk_O/00[gk0P000[gk00<00;gj_OX00kgj00<00;gk00001[gj
00<00<GjaOX01<Gj00@00<Gj000000G5nP030035nP0000G5nP040035n/Gj0004aOX00`00aO[5nP02
0002aOX01000aOW5nLGi0P000/Gj00D00<gicOW=n@0000C=n@04003=fLgI0004cMT01000cMW=f@00
1<gI0`001/gI00<00=GHeMP01=GH0P001=GH00@00=GHeMP000?Ee`03003EemGG00;Ee`03003Me`00
00CMe`03003Me`0000?MeP03003Me]gF00;MeP8000CUe@07003Me]gFgMH00>fd00000nFd00<00>Fe
iKD00P000nfb0P001>fc00D00>fBkI;]TP0000?e/@03003]/P0000;4]004003UDnEC0002kI800`00
mI400004VmD01000a;C4]<Bd0P001:gm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm10000jgm00<0
0:gm[Od00Zgm0`001:gm00<00:gm[Od00jgm0`001:gm0P002Ooo00@00?ooool000Soo`03003ooooo
03Ooo`008?oo00<00?ooool04Ooo00<00?ooool0Q_oo00<00;Gk]O/01KGk00@00;Gk000000>en`03
002enkGk00:en`8000:en`03002enkGk00Ben`8000Fmn`03002mnkgk00:mn`800003_O/00;gk00Fm
n`03002mnkgk00Fmn`04002mn`000003_O/00`00_O^mn`02_O/200000kgk002mn`04_O/200000kgk
002mn`05_O/00`00_O^mn`04_O/01000_O/000001;gk00@00;gj_OZmnP8000:mn`03002mn[gj00>m
nP03002mnP0000K5nP030035n/Gj00K5nP030035n/Gj00C5nP030035nP0000G5nP030035nP0000G5
nP030035n@0000G5nP03003=n@0000G=n@03003=f@0000G=f@03003=f@0000;=f@<00003cMT00<gI
00G=f@03003=f@0000CEf004003Ef=GH0003eMP01`00eMSEf=GH003Ee`0000KEe`03003MemgG00;M
e`04003MemgG0003gMH00`00gMKMeP03gMH00`00iMGUe@02iMD01000gMKMe]gF0P001>Fd00D00>Fe
iKGU]@0000C]/P03003]/nfc00;]/`05003]T^fBkI800003mK401P00kK;]/P00a;@000;UD`04003]
T^fB0002mI401@00VmFKeI_E00000lBd0P000jgm10001:gm00<00:gm[Od00`000Zgm00<00:gm[Od0
0Zgm00<00:gm[Od00P000Zgm00<00:gm[Od00Zgm00<00:gm[Od00`000Zgm00<00:gm[Od00Zgm0`00
2Ooo0P002_oo0`00=_oo000Pool00`00ooooo`0Bool00`00ooooo`23ool200000kGk002en`06]O/0
0`00]O^en`04]O/01000]O/000001;Gk00<00;Gk]O/00[Gk0P0000>en`00_O/01Kgk00@00;gk0000
00>mn`03002mnkgk00:mn`800003_O/00;gk00Fmn`8000Jmn`04002mn`000003_O/00`00_O^mn`02
_O/01@00_O^mnkgk00001Kgk00<00;gk00001[gk00<00;gk_O/01Kgk00<00;gj00001Kgk00<00;gj
_OX00P000[gj00<00<GjaOX00/Gj0P0000?5nP00aOX01<Gj0`001/Gj0P001lGj00<00<GjaOX01LGj
00<00<GjaOX01LGj00<00<gicOT01Lgi00<00<gIcMT01LgI10000lgI00<00<gI00001<gI00@00<gI
cMT000CEf004003Ef=GH0002eMP00`00eMSEf002eMP00`00eML00005eML20004gML01`00gMOMemgG
003MeP0000GMeP8000?Ue@03003Me]gF00?MeP03003U]>Fd00;U]005003U]NFeiKD00004kK820003
kK<01@00kI;]T^fB00000oFa00H00>fbkK800<Bd0002iE<01000kI;]TP000_FA00@009_EVmD000?4
]003003UDnEC00<000>]o@03002]oJgm00:]o@<000F]o@04002]oJgm[Od40004[Od01000[Of]oJgm
10001Jgm00<00:gm[Od00P000Zgm00<00?ooool0C?oo000Pool00`00ooooo`0Cool00`00ooooo`20
ool20004]O/00`00]O^en`02]O/200000kGk002en`05]O/00`00]O^en`05]O/01000]O/000000kGk
00<00;gk_O/01;gk0P001[gk00@00;gk000000>mn`03002mnkgk00:mn`8000:mn`03002mnkgk00Bm
n`03002mnkgk00Bmn`04002mn`000005_O/00`00_O^mn`020002_O/00`00_O^mn`02_O/200000kgk
002mn`05_O/20006_O/00`00_OX00005_OX01000aOX000000lGj00<00<GjaOX00/Gj00D00<GjaO[5
nP0000?5nP8000;5nP030035n/Gj00?5nP030035nP0000G5nP030035nP0000G5nP030035nP0000G=
n@03003=f@0000C=f@@000C=f@04003=fLgI0004cMT01@00cMW=fLgI00000]GH00<00=GHeMP00]GH
0P001]GH00<00=GGeML01=GG00<00=GH00000]gG00<00=gGgML00]gG00<00=gF00001MgF00<00=gF
00000^GE00<00=gFgMH00]gF0P000nFd00<00>FeiKD00^Fe00<00>fbkK800^fb0P000^fc00<00>Fd
00000^fB00@00?FamK4000?]/P8000?UD`04003]T^fB0002mI401000VmFKe@000lBd00<00>ECiE<0
0P001:gm00<00:gm[Od00P000Zgm00<00:gm[Od00jgm10000jgm00<00:gm[Od00Zgm10000jgm00<0
0:gm[Od00jgm0`001:gm0P00COoo000Pool3000Dool00`00ooooo`1mool20007]O/01000]O/00000
0kGk00<00;Gk]O/00[Gk0P0000>en`00]O/01[Gk00<00;Gk]O/01;Gk00@00;gk_O^mn`8000:mn`03
002mnkgk00Bmn`03002mnkgk00Bmn`04002mn`000004_O/00`00_O^mn`02_O/200000kgk002mn`05
_O/00`00_O^mn`05_O/00`00_O/00005_O/01000_O/000000kgk00<00;gk_O/00[gk0P000[gk00<0
0;gk_O/01;gk00<00;gj_OX01Kgj00<00<GjaOX01<Gj00@00<Gj000000C5nP040035nP000004aOX0
1000aO[5n/Gj0P000/Gj00@00<GjaO[5nP8000;5nP040035n/GjaOX20002aOX01000cOW=nLgi0P00
0/gI00<00<gI00000`000/gI00D00<gIcMW=f@0000C=f@04003=fLgI0004cMT00`00eMP00005eMP0
0`00eMSEf004eMP00`00eMP00004eML01P00eMSEf000gML000KMe`03003Me]gF00?MeP06003Me]gF
003Ue@001MgF00<00=gF00000^Fd00L00>FeiKGU]@00iKD00002kK802P00kK?]/`00kK<00>Fd003]
TP000oFa00<00>fbkK800^fb00D00>ECiE?UD`0000;]TP06003eTOFA002Ke@001<Bd00<00>ECiE<0
0P000jgm10001Jgm00<00:gm[Od00P0000>]o@00[Od01:gm00<00:gm[Od00P000Zgm00<00:gm[Od0
0Zgm00<00:gm[Od00`000Zgm00<00:gm[Od00Zgm0`00C?oo000Pool00`00ooooo`0Eool00`00oooo
o`1jool20002]O/00`00]O^en`04]O/20006]O/01000]O/000001;Gk00<00;Gk]O/00[Gk0P0000>e
n`00]O/01;Gk00@00;gk000000Bmn`03002mnkgk00:mn`800003_O/00;gk00Fmn`03002mnkgk00Fm
n`04002mn`000003_O/00`00_O^mn`02_O/200000kgk002mn`06_O/00`00_O^mn`05_O/00`00_O^m
n`04_O/01000_O/000001;gk00<00;gk_O/00[gk0P0000>mn`00_OX01;gj00<00;gj00001/Gj00<0
0<GjaOX01LGj00<00<GjaOX01LGj00<00<Gj00001LGj00<00<Gj00001LGj00<00<Gj00001LGj00<0
0<gi00000lgI0`0000?=f@00cMT01<gI00<00<gI00001LgI00<00<gI00001/gI00<00=GHeMP00mGH
00<00<gH00001=GH00@00=GHeMP000?Ee`03003Ef=GH00;Ef08000GMe`03003Ee`0000CMeP04003M
e]gFgMH20004gMH01P00gMKMeP00iK@000CU]@03003U]@0000;]/P05003]/nfckK<00003iK@20003
mK400`00kK;]/P02kK801000iE?UD`000nfB00@00?FAmI7eT@8000C4]005003UDnEC003]TP030003
VmD00`00[Of]o@03[Od30004[Od00`00[Of]o@02[Od30004[Od01000[Of]oJgm10001Jgm00<00:gm
[Od00P0000>]o@000000C?oo000Pool00`00ooooo`0Fool2001hool20004]O/00`00]O^en`02]O/2
0002]O/00`00]O^en`04]O/00`00]O^en`05]O/01000]O/000000kGk00<00;Gk]O/00kGk0P001kgk
00@00;gk000000>mn`03002mnkgk00:mn`800003_O/00;gk00Jmn`03002mnkgk00Bmn`04002mn`00
0004_O/00`00_O^mn`02_O/200000kgk002mn`04_O/00`00_O/00006_O/00`00_O^mn`05_O/01000
_O/000000kgk00@00;gj_OZmnP8000:mnP030035n/Gj00;5nP800003aOX00<Gj00C5nP030035nP00
00O5nP030035n/Gj00G5nP030035n/Gj00G5nP030035n/Gj00G5nP03003=f@00008000?=f@03003=
fLgI00G=f@03003=fLgI00G=f@03003=fLgI00C=f@8000CEf004003=f<gH0004eMP01`00eMSEf=GH
003Ee`0000GEf003003MemgG00CMe`03003Ee`0000?MeP03003Me]gF00;MeP03003Me]gF00?MeP06
003Me]gF003U]0001>Fe00H00>FeiKD00>fb0003kK<20002iK@20003mK400`00kK;]/P02kK801000
iE?UD`000nfB00D00?FAmI7eT@0000C4]004003UDnEC0002kI800`00VmFKe@04VmD00`00[Of]o@02
0002[Od00`00[Of]o@02[Od00`00[Of]o@020002[Od00`00[Of]o@02[Od40003[Od00`00[Of]o@03
[Od30004[Od2001;ool001ooo`03003ooooo01Woo`03003ooooo07?oo`800003]O`00;Gk00Ben`04
002en`000004]O/00`00]O^en`02]O/200000kGk002en`05]O/20006]O/00`00]O^en`020002]O/0
0`00_O^mn`05_O/00`00_O^mn`04_O/01000_O/000001;gk00<00;gk_O/00[gk0P0000>mn`00_O/0
1Kgk00<00;gk_O/01Kgk00@00;gk000000>mn`04002mnkgk_O/20002_O/00`00_O^mn`03_O/00`00
_O/00006_O/20006_O/00`00_OX00005_OX01000aOX000000lGj00@00<GjaO[5nP8000;5nP030035
n/Gj00?5nP<000G5nP800003aOX00<Gj00C5nP030035nP0000G5nP<000G=f@030035f@0000G=f@80
00K=f@8000C=f@8000;=f@05003Ef=GHeMP00003cMP01000eMSEf0001=GH00<00=GG00001=GH00<0
0=GH00001=gG00L00=GGeMOEe`00gMH00004gMH00`00gML00003gMH00`00gMKMeP02gMH00`00iKGU
]@02iKD01`00iKGU]NFe003]/P0000?]/`8000?U]005003e/OFamK400004kK801000iE?UD`000nfB
00D00?FAmI7eT@0000C4]004003UDnEC0002kI800`00VmFKe@05VmD20004[Od01000[Of]oJgm1000
1:gm00<00:gm[Od00P0000>]o@00[Od01Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00Zgm00<00?oo
0000B_oo000Oool00`00ooooo`0Jool00`00ooooo`1`ool20003]O`00`00]O^en`03]O/20007]O/0
1000]O/000000kGk00<00;Gk]O/00[Gk0P000[Gk00<00;Gk]O/01;Gk0P001KGk00<00;gk_O/00[gk
0P0000>en`00_O/01Kgk00<00;gk_O/01Kgk00@00;gk000000>mn`03002mnkgk00:mn`800003_O/0
0;gk00Fmn`8000Jmn`03002mn`0000Fmn`03002mnkgk008000:mn`03002mnkgk00:mn`8000:mn`03
002mnkgk00Bmn`03002mn[gj00FmnP030035n/Gj00C5nP030035nP0000G5nP050035n/GjaOX00003
aOX01@00aO[5n/Gj00000lGj00@00<GjaO[5nP8000;5nP040035n/GjaOX20002aMX00`00cMW=f@02
cMT01000aMW5f@001<gI00@00<gIcMT000?=f@8000;=f@04003=fLgI0004cMT01000eMSEf0001<gH
00<00=GH00001]GH00<00=GHeMP00]GH00@00=GHeMP000?Me`03003EemGG00;Ee`03003MeP0000CM
eP03003Me`0000?MeP03003Me]gF00;MeP03003U]NFe00;U]@03003U]NFe00;U]@05003]/nfckK<0
0002iK@01000iKCU]0000_Fa00<00>fbkK800^fb00D00>fc003UD`0000;]TP03003eTOFA00;eT@80
00?4]004003UDnEC0002kI820006VmD20004[Od40003[Od00`00[Of]o@02[Od30004[Od00`00[Of]
o@03[Od30004[Od01000[Of]oJgm1000B_oo000Oool00`00ooooo`0Kool00`00ooooo`1^ool00`00
]Obeo004]O`00`00]O^en`020002]O/00`00]O^en`04]O/20006]O/01000]O/000001;Gk00<00;Gk
]O/00[Gk0P0000>en`00]O/01KGk00@00;gk000000>en`03002mnkgk00:mn`800003_O/00;gk00Fm
n`8000Jmn`04002mn`000003_O/00`00_O^mn`02_O/20002_O/00`00_O^mn`04_O/00`00_O^mn`04
_O/00`00_O/00005_O/01000_O/000001;gk00<00;gk_O/00[gk0P0000>mn`00_OX01;gj00<00;gj
00001/Gj00<00<GjaOX01<Gj00@00<Gj000000C5nP040035nP000005aOX00`00aOX00005aOX40004
aMX01000cMW=f@001<GI00@00<gIcMT000?=f@04003=fLgI0004cMT00`00cMT00006cMT20006cMP0
0`00eMSEf004eMP20004eMP01`00eMSEf=GH003Me`0000KEe`03003Me]gF00;MeP07003MemgGgML0
0=gF00001=gF00<00=gF00000^Fe00<00>FeiKD00nFe00D00>fckK?]/`0000?U]003003U]00000;e
/@03003]/^fb00;]/P05003]/`00iE<00002kI800`00mI7eT@02mI420003a;@01000iE?UD`000^fB
0P001I_E00<00<Bd00000Zgm0P000Zgm00<00:gm[Od00Zgm00<00:gm[Od00P000Zgm00<00:gm[Od0
0Zgm00<00:gm[Od00`000Zgm00<00:gm[Od00Zgm10000jgm0P00BOoo000Oool00`00ooooo`0Lool0
0`00ooooo`1[ool200000kGl002eo005]O`20005]O/20002]O/20002]O/00`00]O^en`04]O/00`00
]O^en`05]O/01000]O/000000kGk00<00;Gk]O/01;Gk0P001[Gk00@00;gk000000>mn`03002mnkgk
00:mn`8000:mn`03002mnkgk00Bmn`03002mnkgk00Bmn`04002mn`000004_O/00`00_O^mn`02_O/2
00000kgk002mn`05_O/00`00_O^mn`05_O/00`00_O^mn`05_O/01000_O/000000kgk00@00;gj_OZm
nP8000:mnP030035n/Gj00?5nP03002mnP0000K5nP030035n/Gj00G5nP030035n/Gj00K5nP040035
n/GjaOX400000lGj0035fP04aMX00`00cMT00005aMT00`00cMT00005cMT20006cMT00`00cMW=f@05
cMT00`00cMS=f004cMP00`00cMP00004eMP01000eMSEf0000]GH00<00=GHeMP00]GH00<00=gG0000
1MGG0P001=gF00L00=gGgMOMe`00gMH00004gMH00`00gMH00002iKD00`00iKGU]@03iKD01@00kK?]
/nfc00001>Fd00D00>Fe003e/@0000C]/P05003]/`00iE<00002kI801`00mI7eTOFA003]/P0000?4
]008003UDnEC003]TP00mI4000FKe@030034]<Bd008000B]o@04002]oJgm[Od40004[Od01000[Of]
oJgm10001Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00Zgm00<00?oo0000B?oo000Oool00`00oooo
o`0Mool00`00ooooo`1Xool20003]O`00`00]Obeo002]O`200000kGl002en`06]O/20004]O/00`00
]O^en`02]O/200000kGk002en`06]O/00`00]O^en`04]O/00`00]O^en`030002]O/00`00]O^en`04
]O/00`00_O^mn`04_O/01000_O/000001;gk00<00;gk_O/00[gk0P0000>mn`00_O/01Kgk00<00;gk
_O/01Kgk00@00;gk000000>mn`03002mnkgk00:mn`800003_O/00;gk00Bmn`03002mn`0000Nmn`03
002mnkgk00Bmn`03002mnP0000FmnP030035n/Gj008000:mnP030035n/Gj00;5nP800003aOX00<Gj
00C5nP030035nP0000G5nPH000C5nP030035f/GJ00G5fP030035fLGI00G5f@03003=fLgI00C=f@03
003=fLgI00C=f@03003=f@0000G=f@03003=f@0000C=f004003=f<gH0003eMP01`00eMSEf=GH003E
f00000KEf003003EemGG00CEe`03003Ee`0000;MeP03003MemgG00?Me`03003Me]gF00;MeP07003M
e]gFgMH00>Fe00001>Fe00D00=fe003]/`0000GU]005003U]@00mK400004kK801000kK<000000nfB
00L00?FAmI7eT@00kK800002a;@02@00iE?UDnEC003]TP00mI400004VmD01000a;C4]<Bd0P001:gm
10000jgm00<00:gm[Od00Zgm10000jgm00<00:gm[Od00jgm0`001:gm00@00:gm[Of]o@@004Soo`00
7ooo0`007_oo00<00?ooool0IOoo0P001[Gl00@00;Gl000000Beo003002enkGk00:en`800003]O`0
0;Gk00Ben`04002en`000004]O/00`00]O^en`02]O/200000kGk002en`05]O/20005]O/00`00]O^e
n`02]O/200000kGk002mn`05_O/00`00_O^mn`05_O/01000_O/000000kgk00<00;gk_O/00[gk0P00
00>mn`00_O/01Kgk0P001[gk00@00;gk000000>mn`04002mnkgk_O/20002_O/00`00_O^mn`03_O/2
00000kgk002mn`05_O/00`00_OZmnP04_OX00`00aOX00005_OX01000aOX000000lGj00@00<GjaO[5
nP8000;5nP030035n/Gj00;5nPD000C5nP<000G5fP<000G5f@<000G=f@03003=f@0000C=f@04003=
fLgI0004cMT01000cMW=f@000lgH00<00<gHcMP00/gH00<00=GH00001MGH00<00=GHeMP01=GH00<0
0=GH00001=GG00H00=GGeML00=gF0005gML20004gMH01000gMKMe]gF0P001NFe00D00=fe003]/`00
00CU]006003U]@00003e/@000nfb00D00>fckK?]/`0000?]TP05003eTOFAmI400002kK800`00a;@0
0003iE<00`00kI800002mI401@00VmFKeI_E00000lBd0P000Zgm0P0000>]o@00[Od01:gm00<00:gm
[Od00P000Zgm00<00:gm[Od00Zgm00<00:gm[Od00`000Zgm00<00:gm[Od00Zgm10000jgm0P00Aooo
000Nool2000Qool00`00ooooo`1Qool30002]O`00`00]Obeo004]O`00`00]Obeo005]O`01000]O/0
00000kGl00<00;Gk]O/00kGk0P001kGk00@00;Gk000000>en`03002enkGk00:en`800003]O/00;Gk
00Fen`04002en`000003]O/00`00_O^mn`02_O/200000kgk002mn`05_O/20006_O/01000_O/00000
0kgk00<00;gk_O/00[gk0P000[gk00<00;gk_O/01;gk00<00;gk_O/01;gk00<00;gk00001Kgk00D0
0;gk_O^mn`0000>mn`03002mnkgk00:mn`800003_O/00;gj00FmnP03002mn[gj00FmnP030035n/Gj
00C5nP030035nP0000G5nP030035nP00008000?5nP050035n/GjaOX00003aMX01@00aM[5f/GJ0000
0lGJ00D00<GIaMW5f@0000?5f@03003=fLgI008000;=f@05003=fLgIcMT00004cMT01000cMW=f@00
1<gI00<00<gH00001/gH00<00=GHeMP00mGH00<00=GH00001=GH00@00=GHeMP000?Ee`03003EemGG
00;Ee`8000GMe`03003Me`0000;MeP03003Me]gF00?MeP03003U]NFe00;U]@05003M]MfegKD00005
iK@00`00iKGU]@020004kK801@00kK?]/nfc00000nfB00D00?FAmI7eT@0000;]/P030034]00000?U
D`03003]TP0000;eT@04002KeI_E0003a;@00`00iE?UD`020004[Od00`00[Of]o@02[Od30004[Od0
1000[Of]oJgm10001Jgm00<00:gm[Od00P000Zgm00<00:gm[Od00Zgm0`00A_oo000Nool00`00oooo
o`0Qool00`00ooooo`1Nool20005]O`00`00]Obeo002]O`200000kGl002eo005]O`20006]O`00`00
]O^en`020002]O/00`00]O^en`04]O/20006]O/01000]O/000000kGk00<00;Gk]O/01;Gk0P001[Gk
00@00;gk000000>mn`03002mnkgk00:mn`8000:mn`03002mnkgk00Bmn`03002mnkgk00Bmn`04002m
n`000004_O/00`00_O^mn`02_O/200000kgk002mn`05_O/00`00_O^mn`04_O/01000_O/000001Kgk
00@00;gk000000>mn`03002mn[gj00:mnP800003_OX00;gj00BmnP03002mnP0000K5nP030035n/Gj
00?5nP<000O5nP<000C5fP040035fP000004aMX01000aMT000001<GI00<00<gI00001LgI00<00<gI
00001LgI00<00<gI00001/gI00<00<gHcMP01<gH0P001=GH00@00=GHeMP000CEf007003Ef=GHeMP0
0=GG00001MGG00<00=gGgML00mgG00H00=gGgML00=gF0005gMH20004iKD01@00gKGM]Mfe00001NFd
00<00>FeiKD00P001>fb00D00>fckK?]/`0000?]TP05003eTOFAmI400002kK800`00a;@00002iE<0
1000kI;]TP000_FA00@009_EVmD000?4]003003UDnEC008000B]o@03002]oJgm008000:]o@03002]
oJgm00:]o@@000>]o@03002]oJgm00>]o@<000B]o@04002]oJgm[Od40016ool001koo`03003ooooo
02;oo`03003ooooo05_oo`800003]O`00;Gl00Feo004002eo0000003]O`00`00]Obeo002]O`20002
]O`00`00]Obeo004]O`20004]O/00`00]O^en`02]O/20002]O/00`00]O^en`04]O/00`00]O^en`04
]O/00`00]O^en`030002]O/00`00]O^en`04]O/00`00_O^mn`04_O/01000_O/000001;gk00<00;gk
_O/00[gk0P0000>mn`00_O/01Kgk00<00;gk_O/01Kgk00@00;gk000000>mn`03002mnkgk00:mn`80
0003_O/00;gk00Fmn`03002mnkgk00Jmn`03002mnkgk00Bmn`04002mnP000003_OX01000_OZmn[gj
0P000[gj00<00<GjaOX00/Gj0P0000?5nP00aOX00`0000C5nP00aOX000K5nP030035f/GJ00G5fP03
0035f/GJ00G5fP030035fLGI00G5f@03003=fLgI00G=f@03003=fLgI00G=f@03003=fLgI00C=f@03
003=f@0000C=f004003=fLgI0003eMP01@00eMSEf=GH00000]GH00<00=GHeMP00]GH00<00=GG0000
1=GG00<00=GG00001=gG00@00=gGgMOMe`8000GMeP03003MeP0000;U]@03003M]Mfe00;M]@03003U
]>Fd00;U]003003U]NFe00;U]@03003]/^fb00;]/P06003]/nfc003U]0000^fB00D00?FAmI7eT@00
00;]/P8000?UD`04003]T^fB0002mI400`00VmD00004a;@00`00iE?UD`020003[Od40004[Od00`00
[Of]o@020002[Od00`00[Of]o@03[Od00`00[Of]o@020002[Od00`00[Of]o@02[Od40003[Od20015
ool001koo`03003ooooo02?oo`03003ooooo05Soo`8000Beo003002eo;Gl00>eo08000Jeo004002e
o0000004]O`00`00]Obeo002]O`200000kGl002en`04]O/01000]O/000001;Gk00<00;Gk]O/00[Gk
0P0000>en`00]O/01KGk0P001KGk00<00;Gk]O/00[Gk0P0000>en`00_O/01Kgk00<00;gk_O/01Kgk
00@00;gk000000>mn`03002mnkgk00:mn`800003_O/00;gk00Fmn`8000Jmn`04002mn`000003_O/0
0`00_O^mn`02_O/200000kgk002mn`04_O/30006_O/20006_OX00`00_OX00005_OX01000aOX00000
0/Gj0`000/Gj0P000/Gj00<00<GjaOX00lGj00<00<Gj00001LGJ00<00<GJ00001LGJ00<00<GJ0000
1LGI00<00<GJ00001LgI00<00<gI00001LgI00<00<gI00001<gI00@00<gIcMT000C=f004003=fLgI
0002eMP00`00eMSEf002eMP00`00eMP00006eMP00`00eMOEe`02eML01000eMOEe`000mgG00<00=gG
gML00]gG00<00=gFgMH00mgF00@00=gFgMH000;U]@07003M]MfegKD00=gF00000nFd00<00>FeiKD0
0^Fe0P000^fb00T00>fckK?]/`00iK@00>fB00001?FA00D00>fbkK;]/P0000?UD`04003]T^fB0003
mI420004a;@01@00iE?UD`00kI400`000i^e00<00:gm[Od00Zgm0`001:gm00@00:gm[Of]o@D000B]
o@03002]oJgm00800003[Od00:gm00B]o@8004Goo`007_oo00<00?ooool09?oo00<00?ooool0EOoo
0P001kGl00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl0P001kGl00@00;Gl000000>eo003002enkGk
00>en`8000Nen`04002en`000003]O/00`00]O^en`02]O/200000kGk002en`05]O/01000]O/00000
0kGk00<00;gk_O/00[gk0P0000>en`00_O/01[gk00<00;gk_O/01;gk00@00;gk000000>mn`03002m
nkgk00:mn`8000:mn`03002mnkgk00Bmn`03002mnkgk00Bmn`04002mn`000003_O/00`00_O^mn`02
_O/01@00_O^mnkgk00000kgk0P000[gk00<00;gj_OX01;gj00<00;gj_OX01Kgj00<00<GjaOX00P00
0/Gj00<00<Gj00001LGj00<00<GjaOX00P000/Gj00@00<GJaM[5fP8000;5fP040035f/GJaMX20002
aMX01000aMW5fLGI0P000/GJ00@00<gIcMW=f@8000;=f@04003=fLgIcMT20002cMT01@00cMW=fLgI
00001<gI00@00<gHcMP000C=f@8000KEf003003Ef=GH00CEf08000CEe`07003EemGGeML00=gG0000
1=gG0P001MgF00H00=gFgMH00>Fe0004gKD00`00gMH00002iK@00`00iKGU]@02iKD01P00iKD00000
kK8000?]/`03003U]>Fd008000?eT@03003]/^fb00;]/P05003UDnECiE<00002kI801@00mI7eTOFA
00001LBd00H00>ECiE<00>fA0005VkD00`00[Of]o@020002[Od00`00[Of]o@02[Od40004[Od00`00
[Of]o@02[Od30004[Od00`00[Of]o@02[Od30014ool001koo`03003ooooo02Goo`03003ooooo05;o
o`8000:eo003002eo;Gl00Feo08000Feo003002eo;Gl008000:eo003002eo;Gl00Feo003002eo;Gl
00Beo003002enkGk008000:en`03002enkGk00Fen`03002enkGk00Ben`04002en`000004]O/00`00
]O^en`03]O/20006]O/01000_O/000001;Gk00<00;gk_O/00[gk0P0000>mn`00_O/01Kgk00<00;gk
_O/01;gk00@00;gk000000Bmn`03002mnkgk00:mn`800003_O/00;gk00Fmn`03002mnkgk00Bmn`04
002mn`000004_O/01000_O/000001;gk00<00;gj_OX00[gj0P0000>mn`00_OX01;gj10001LGj00<0
0<GjaOX01<Gj00<00<Gj00001LGj00<00<GJ00001LGJ00<00<GJ00001LGJ00<00<GI00001LGJ00<0
0<gI00001LgI00<00<gI00001LgI00<00<gI00001LgI00<00<gH00001LgI00<00=GHeMP01=GH00<0
0<gH00001=GH00@00=GHeMP000;Ee`03003EemGG00;Ee`03003Me`0000CMe`03003Ee`0000?MeP03
003Me]gF00;MeP8000?M]@07003Me]gFgMH00>Fd00001>Fe00H00>Fe00000>fb0003kK<00`00iKCU
]0020003mI400`00kK;]/P02kK801@00iE?UDnEC00000^fB00D00?FAmI7eT@0000C4]004003UDnEC
0002kI400`00VkFK]@04VkD20004[Od00`00[Of]o@020002[Od00`00[Of]o@03[Od00`00[Of]o@02
0002[Od00`00[Of]o@02[Od00`00[Of]o@020002[Od20013ool001koo`03003ooooo02Koo`03003o
oooo04ooo`8000Feo003002eo;Gl00:eo0800003]O`00;Gl00Feo08000Feo003002eo;Gl00:eo080
0003]O`00;Gl00Feo08000Fen`03002enkGk00:en`800003]O/00;Gk00Fen`03002enkGk00Fen`03
002enkGk008000:en`03002enkGk00>en`8000Nen`04002mn`000003_O/00`00_O^mn`02_O/20000
0kgk002mn`05_O/00`00_O^mn`05_O/01000_O/000000kgk00<00;gk_O/00[gk0P0000>mn`00_O/0
1Kgk00<00;gk_O/01Kgk00<00;gk_O/01Kgk00@00;gj000000>mn`04002mn[gj_OX300000kgj0035
nP04aOX00`00aOX00006aOX00`00aO[5nP05aOX00`00aM[5fP05aMX00`00aM[5fP05aMX00`00aM[5
fP05aMX00`00cMW=f@05cMT00`00cMW=f@05cMT00`00cMW=f@05cMT00`00cMW=f@03cMT00`00cMT0
0004eMP01000cMS=f0001=GH00H00=GHeMP00=GG0006eML00`00gMOMe`02gML01000eMOEe`000mgF
00<00=gFgMH00]gF00<00=fegKD00]fe00@00=gFgMKMeP8000GU]@03003U]NFe00<000;]/`03003U
]>Fd00;U]005003eTOFAmI400004kK820002iE<00`00kI800004mI400`00a;C4]002a;@01000iE?U
D`000^fA0P001I^e0P001:gm0`001Jgm00@00:gm[Of]o@@000B]o@04002]oJgm[Od40004[Od20013
ool001goo`03003ooooo02Soo`8004goo`800003]O`00;Gl00Feo004002eo0000003]O`00`00]Obe
o002]O`200000kGl002eo005]O`01000]O`000000kGl00<00;Gl]O`00[Gl0P0000>eo000]O/01KGk
00@00;Gk000000>en`03002enkGk00:en`800003]O/00;Gk00Fen`<000Fen`03002enkGk008000:e
n`03002enkGk00Ben`8000Jmn`04002mn`000003_O/00`00_O^mn`02_O/200000kgk002mn`05_O/2
0006_O/01000_O/000000kgk00<00;gk_O/00[gk0P0000>mn`00_O/01;gk00<00;gk00001kgk00<0
0;gk_O/01;gk0`001Kgj00<00<GjaOX00P000/Gj00<00<GjaOX00/Gj0P0000?5nP00aOX01<Gj00<0
0<GJ00001LGJ00<00<GJ00001LGJ00<00<GJ00001LGJ00<00<GJ00001LgI00<00<GI00001LgI0P00
1/gI0P001<gI00@00<gIcMT000CEf005003=f<gHcMP00002eMP00`00eMSEf002eMP00`00eMOEe`04
eML20004gML01`00eMOEemGG003MeP0000CMeP03003Me`0000?M]@03003Me]gF00;MeP03003U]NFe
00;U]@04003U]NFeiKD30002kK<00`00iKCU]002iK@01@00mI7eTOFA00000nfb00<00>fc00000^EC
00<00>fB00001?FA0P000lBd00@00>ECiE<000;]T@8000BK]@030034]00000:]o@8000:]o@03002]
oJgm00>]o@@000>]o@03002]oJgm00:]o@@000>]o@03002]oJgm00:]o@<004;oo`007Ooo0`00:_oo
00<00?ooool0B?oo0P000kGl00<00;Gl]O`01;Gl0P001[Gl00@00;Gl000000Beo003002eo;Gl00>e
o08000Jeo004002eo0000004]O`00`00]O^en`03]O/20006]O/01000]O/000000kGk00<00;Gk]O/0
0[Gk0P000[Gk00<00;Gk]O/01;Gk0P001;Gk00<00;Gk]O/00[Gk0P000[Gk00<00;gk_O/01;gk00<0
0;gk_O/01;gk00@00;gk000000>mn`03002mnkgk00:mn`8000:mn`03002mnkgk00Bmn`03002mnkgk
00Bmn`04002mn`000003_O/01000_O^mnkgk0P000[gk00<00;gk_O/00kgk0`000kgk1@001[gj00<0
0<Gj00001LGj00@00<Gj000000?5nP040035n/GjaOX20002aMX01000aM[5f/GJ0P000/GJ00@00<GJ
aM[5fP8000;5fP030035f/GJ00;5fP040035f/GJ0004cMT01000aMW5f@001<gI00@00<gIcMT000?=
f@8000;=f@04003=fLgI0004cMT01000eMSEf0001<gH00<00=GH00001=GH00<00=GH00001=GG00@0
0=GHeMP000;Me`03003EemGG00;Ee`03003MeP0000CMeP03003Me`0000;M]@03003Me]gF00;MeP80
00CU]@03003U]NFe00;U]@05003]/`00kK<00004iK@01@00mI7eTOFA00000nfb00<00>fc00000^EC
00<00>fB00000oFA00<00>fB00000lBd00P00>ECiE<00>fA003eT@0019^e00<00<Bda;@00P001:gm
00<00:gm[Od00`0000>]o@00[Od01:gm00<00:gm[Od00P000Zgm00<00:gm[Od00Zgm00<00:gm[Od0
0P000Zgm0P00@Ooo000Mool00`00ooooo`0[ool00`00ooooo`15ool20006]O`00`00]Obeo0030002
]O`00`00]Obeo004]O`00`00]Obeo005]O`00`00]Obeo0020002]O`00`00]Obeo004]O`00`00]Obe
o005]O`00`00]O^en`020002]O/00`00]O^en`04]O/00`00]O^en`04]O/01000]O/000001;Gk00<0
0;Gk]O/00[Gk0P0000>en`00]O/01;Gk00@00;Gk000000Ben`03002mnkgk00:mn`800003_O/00;gk
00Fmn`03002mnkgk00Bmn`04002mn`000004_O/00`00_O^mn`02_O/200000kgk002mn`05_O/00`00
_O^mn`04_O/00`00_O/00005_O/01@00_O^mnkgk00000kgk0`0000>mn`0000000[gk00<00;gj_OX0
1;gj00<00<GjaOX01LGj00<00<GjaOX01<Gj00<00<Gj00001LGJ00<00<GJ00001LGJ00<00<GJ0000
1LGJ00@00<GJaMX000C5fP04003=fLgI0004aMT01000cMW=f@000lgI00@00<gIcMT000C=f@03003=
f@0000G=f@03003Ef00000K=f003003Ef=GH00;Ef004003Ef=GH0004eML01P00eMSEf000gML000KE
e`03003Me]gF00;MeP07003MemgGgML00=fe00001=gF00<00=gF00000^Fe00<00>FeiKD00nFe00@0
0>fc000000CU]003003U]00000;eT@05003]/^fbkK800002kK<20002kI801`00mI7eTOFA003]TP00
00;4]009003UDnECiE<00>fA003eT@0000BK]@030034]<Bd008000B]o@<000F]o@03002]oJgm00:]
o@<000B]o@04002]oJgm[Od40004[Od20011ool001goo`03003ooooo02coo`03003ooooo04;oo`80
00:eo003002eo;Gl00Beo08000Feo003002eo;Gl00:eo0800003]O`00;Gl00Feo0<000Beo003002e
o;Gl00:eo0800003]O`00;Gl00Feo0<000Ben`03002enkGk00:en`800003]O/00;Gk00Fen`03002e
nkGk00Fen`04002en`000003]O/00`00]O^en`03]O/20007]O/01000_O/000000kgk00<00;gk_O/0
0[gk0P0000>mn`00_O/01Kgk00<00;gk_O/01Kgk00@00;gk000000>mn`03002mnkgk00:mn`800003
_O/00;gk00Fmn`03002mnkgk00Bmn`05002mn`00002mn`0400000kgk00000004_O/00`00_OZmnP02
_OX200000kgj0035nP04aOX00`00_MX00006aOX00`00aM[5fP05aMX00`00aM[5fP05aMX00`00aM[5
fP04aMX00`00aMX00005aMX00`00cMT00005aMT00`00cMT00005cMT20006cMT00`00cMW=f@05cMT0
0`00cMS=f004cMP20004eMP01@00eMSEf=GH00000]GG00<00=GHeMP00]GH0P001MGG0P001=gF00@0
0=gGgMOMe`8000CMeP04003Me]gF0002iKD00`00iKGU]@02iKD01@00gKD00>fc00001>Fd00<00>Fd
00000_FA00D00>fbkK;]/P0000;]/`8000;]TP07003eTOFAmI400>fB00000/Bd00L00>ECiE?UD`00
kI400002mI401000VkFK]@000lBd0P000Zgm0P000Zgm00<00:gm[Od00jgm00<00:gm[Od00P000Zgm
00<00:gm[Od00Zgm10000jgm00<00:gm[Od00Zgm0`00@?oo000Mool00`00ooooo`0]ool00`00oooo
o`0oool20004]O`00`00]Obeo002]O`200000kGl002eo005]O`01000]O`000000kGl00<00;Gl]O`0
0[Gl0P000[Gl00<00;Gl]O`00kGl00@00;Gl000000>eo003002eo;Gl00:eo08000:eo003002enkGk
00>en`04002en`000003]O/00`00]O^en`02]O/200000kGk002en`06]O/00`00]O^en`04]O/00`00
]O^en`020002]O/00`00]O^en`04]O/20006_O/01000_O/000000kgk00<00;gk_O/00[gk0P0000>m
n`00_O/01Kgk0P001[gk00@00;gk000000>mn`03002mnkgk00:mn`800003_O/00;gk00Fmn`@000Bm
n`03002mnkgk00Fmn`04002mnP000003_OX01000aO[5n/Gj0P000[gJ00<00<GjaOX00/Gj0P0000?5
fP00aMX01<GJ00<00<GJ00001LGJ00<00<GJ00001/GJ00<00<GJaMX01LGJ00<00<GIaMT01LGI00<0
0<gIcMT01<gI00<00<gIcMT01<gI00<00<gI00001LgI00<00<gI00001<gH00@00<gHcMP000;Ef003
003Ef=GH00;Ef003003Ee`0000GEf003003EemGG00?Ee`04003EemGG0002gMH00`00gMOMe`03gML0
0`00gMKMeP02gMH01`00gMKMe]gF003U]@0000CU]@04003M]@00kK<20003iK@00`00iKCU]0020003
kK800`00kK?]/`02kK<01000kI;]TP000oFA00H00>fBkI800<Bd0003iE<00`00kI400002mI401000
VkFK]@000lBd00@00>EB000000F]o@04002]oJgm[Od40004[Od00`00[Of]o@020002[Od00`00[Of]
o@02[Od00`00[Of]o@020002[Od2000oool001goo`03003ooooo02koo`03003ooooo03coo`800003
]O`00;Gl00Beo004002eo0000004]O`00`00]Obeo003]O`20006]O`01000]O`000001;Gl00<00;Gl
]O`00kGl0P001[Gl00@00;Gl000000Beo003002enkGk00>en`8000Jen`04002en`000004]O/00`00
]O^en`02]O/200000kGk002en`05]O/20004]O/00`00]O^en`02]O/20002]O/00`00_O^mn`04_O/0
0`00_O^mn`04_O/01000_O/000000kgk00<00;gk_O/00[gk0P000[gk00<00;gk_O/01;gk00<00;gk
_O/01;gk00@00;gk000000>mn`03002mnkgk00:mn`@000Fmn`03002mn`0000Jmn`8000JmnP030035
nP0000FmfP040035nP000003aMX01000aM[5f/GJ0P000/GJ00@00<GJaM[5fP8000;5fP030035f/GJ
00?5fP8000G5fP<000G5f@<000G=f@03003=f@0000C=f@04003=fLgI0004cMT01000cMW=f@000lgH
00L00<gHcMS=f000eMP00006eMP00`00eMSEf003eMP00`00eMP00004eML01P00eMOEe`00gMH000GM
e`8000?MeP03003Me]gF00;MeP8000CU]@05003M]Mfe003]/`020002iK@01000iKCU]>Fd0P000nfb
00<00>fckK<00^fc00@00>fBkI8000?eT@06003]T^fB0034]0000nEC00<00>fA00000_FA00<009^e
00000lBd00<00>EBiE800P001Jgm10000jgm00<00:gm[Od00Zgm0`001:gm00@00:gm[Of]o@@000B]
o@<003koo`007?oo00<00?ooool0<?oo00<00?ooool0>Ooo0P000kGl00<00;Gl]O`00kGl0P001kGl
00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl0P001kGl00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl
0P001kGl00<00;Gk]O/00P000[Gk00<00;Gk]O/00kGk0P001kGk00@00;Gk000000>en`03002enkGk
00:en`800003]O/00;Gk00Ben`04002en`000004]O/00`00_O^mn`02_O/200000kgk002mn`05_O/0
0`00_O^mn`04_O/01000_O/000001;gk00<00;gk_O/00[gk0P0000>mn`00_O/01Kgk00<00;gk_O/0
1;gk00<00;gk00000P000[gk00@00;gk_O^mn`8000:mn`03002mnkgk00:mn`800003_O/00;gj00Fm
nP8000NmfP030035f/GJ00C5fP030035fP0000G5fP030035fP0000G5fP030035f/GJ008000;5fP05
0035f/GJaMX00003aMX01@00aMW5fLGI00000lGI00<00<gIcMT00P000/gI00D00<gIcMW=f@0000C=
f@04003=fLgI0004cMT00`00cMP00005cMP00`00eMSEf004eMP20004eMP01000eMSEf0000mGG00<0
0=GGeML00]GG0P001MgG00<00=gG00000]gF00<00=gFgMH00mgF00<00>FeiKD00^Fe00D00=fegKGM
]@0000;U]003003U]00000CU]005003]/^fbkK800004kK<01000kI;]TP000oFA00H00>fBkI800<Bd
0002iE<01000kI7]T@000_FA00<009^e00000lBd00H00>EBiE800>ea0002[Od20002VkD00`00[Of]
o@02[Od00`00[Of]o@020002[Od00`00[Of]o@02[Od40003[Od00`00[Of]o@02[Od3000nool001co
o`03003ooooo037oo`03003ooooo03Koo`8000Jeo003002eo;Gl008000:eo003002eo;Gl00Feo080
00Feo003002eo;Gl008000:eo003002eo;Gl00Feo08000Feo003002eo;Gl008000:eo003002eo;Gl
00Feo08000Fen`03002enkGk008000:en`03002enkGk00Ben`8000Jen`04002en`000003]O/00`00
]O^en`03]O/20007]O/01000_O/000000kgk00<00;gk_O/00[gk0P0000>mn`00_O/01Kgk00<00;gk
_O/01Kgk00@00;gk000000>mn`03002mnkgk00:mn`800003_O/00;gk00>mn`<000Jmn`03002mn`00
00Fmn`04002mn`000004_O/01000_OZmn[gj0P0000>mfP00_MX01;gJ0`001/GJ0P001lGJ00<00<GJ
aMX01<GJ00<00<GJ00001<GJ00@00<GJ000000C5fP040035f@000004aMT00`00cMT00005cMT00`00
cMT00005cMT00`00cMT00006cMT00`00cMS=f003cMP00`00cMP00004eMP01000eMSEf0000mGH00L0
0=GHeMSEf000eML00005eML00`00gMOMe`03gML01P00gMOMe`00gMH000GMeP8000?U]@03003M]Mfe
00;M]@04003U]>FdiK@20004iK@01@00kK;]/^fb00000nfc00D00>Fd003]TP0000?eT@03003]T^fB
008000?UD`04003]TNfA0003mI420003a;@01000iE;UDP000^ea0P0019^e00@00:gm[Of]o@@000B]
o@03002]oJgm008000:]o@03002]oJgm00:]o@03002]oJgm008000:]o@8003goo`007?oo00<00?oo
ool0<_oo00<00?ooool0<ooo0P000[Gl00<00;Gl]O`01;Gl0P001KGl00<00;Gl]O`00[Gl0P0000>e
o000]O`01KGl0P001KGl00<00;Gl]O`00[Gl0P0000>eo000]O`01KGl0P001KGl00<00;Gl]O`00[Gl
0P0000>eo000]O/01KGk0P001;Gk00<00;Gk]O/00[Gk0P000[Gk00<00;Gk]O/01;Gk00<00;Gk]O/0
1;Gk00<00;Gk]O/00P000[Gk00<00;Gk]O/01;Gk0P001[gk00@00;gk000000>mn`03002mnkgk00:m
n`800003_O/00;gk00Fmn`8000Jmn`04002mn`000003_O/00`00_O/0000400000kgk002mn`05_O/0
0`00_O^mn`05_O/00`00_O^mn`04_O/01000_OX000001;gJ00D00;gJ_MZmfP0000>mfP040035f/GJ
aMX200000lGJ0035fP04aMX30007aMX00`00aM[5fP04aMX00`00aM[5fP05aMX00`00aMW5f@05aMT0
0`00cMW=f@05cMT00`00cMW=f@05cMT00`00cMW=f@04cMT20004cMP01000cMS=f0001=GH00@00=GH
eMP000;Ef003003Ef=GH00?Ef003003EemGG00?Ee`03003Ee`0000?Me`03003MemgG00;Me`8000GM
eP03003MeP0000;U]@03003M]Mfe00;M]@03003U]>Fd00;U]003003U]>Fd00;U]004003]/^fb0004
kK<01000iK@000001?FA00D00>fBkI;]TP0000?UD`04003]TNfA0003mI400`00a;C4]002a;@01000
iE;UDP000^ea00<009^eVkD019^e0`000jgm00<00:gm[Od00Zgm0`001:gm00@00:gm[Of]o@@000B]
o@8003goo`007?oo00@00?ooool003;oo`03003ooooo033oo`8000Beo003002eo;Gl00:eo0800003
]O`00;Gl00Feo004002eo0000003]O`00`00]Obeo002]O`200000kGl002eo005]O`01000]O`00000
0kGl00<00;Gl]O`00[Gl0P0000>eo000]O`01KGl00@00;Gl000000>eo003002enkGk00:en`800003
]O/00;Gk00Ben`04002en`000004]O/00`00]O^en`02]O/200000kGk002en`05]O/20005]O/20002
]O/20002]O/00`00_O^mn`04_O/00`00_O^mn`04_O/01000_O/000000kgk00<00;gk_O/00[gk0P00
0[gk00<00;gk_O/01;gk00<00;gk_O/00[gk0`0000>mn`0000000kgk00<00;gk_O/00[gk0P0000>m
n`00_O/01;gk00<00;gk00001[gk00<00;gJ_MX01;gJ00@00;gJ000000BmfP040035fP000004aMX0
1@00aM[5f/GJ00000lGJ00<00<GJaMX00/GJ0`001LGJ00<00<GJ00001LGJ00<00<GJ00001LGI00<0
0<GI00001LgI00<00<gI00001LgI0P001<gI0P000/gI00D00<gHcMS=f00000?=f004003Ef=GH0004
eMP20005eMP20004eML01000eMOEe`000]gG00<00=gGgML00mgG00<00=gFgMH00mgF00H00=gFgMH0
0>Fe0004gKD00`00gKH00002iK@20003iK@01@00iKD00>fb00001>fc00@00>Fd000000?eT@03003]
T^fB00;]TP05003UDnECiE<00002kI401@00mI7eTOFA00001<Bd00@00>EBiE8000;]L@03002K]I^e
00BK]@8000B]o@03002]oJgm008000:]o@03002]oJgm00:]o@@000>]o@03002]oJgm00:]o@<003co
o`007?oo0`00=?oo00<00?ooool0;Ooo0P0000>eo000]O`01;Gl00@00;Gl000000Beo003002eo;Gl
00>eo08000Jeo004002eo0000004]O`00`00]Obeo003]O`20006]O`01000]O`000000kGl00<00;Gl
]O`01;Gl0P001[Gl00@00;Gk000000>en`03002enkGk00>en`8000Nen`04002en`000003]O/00`00
]O^en`02]O/200000kGk002en`05]O/30004]O/00`00_O^mn`02_O/200000kGk002mn`05_O/00`00
_O^mn`04_O/01000_O/000001;gk00<00;gk_O/00[gk0P0000>mn`0000000P000kgk00<00;gk_O/0
1;gk00@00;gk000000>mn`04002mnkgk_O/20002_O/00`00_O^mn`02_O/200000kgK002mfP05_MX0
0`00_MZmfP05_MX00`00aM[5fP04aMX01000aMX000001<GJ00D00<GJaM[5fP0000?5fP030035f/GJ
008000;5fP040035f/GJaMX20002aMX01000aMW5fLGI0P000/GI00@00<gIcMW=f@8000;=f@04003=
fLgIcMT20002cMT01000cMW=f@001<gI00@00<gHcMP000C=f003003Ef00000GEf003003Ef=GH00CE
f003003Ef00000?Ee`07003EemGGeML00=gG00001=gG00<00=GG00001=gF00@00=gFgMKMeP8000CM
]@03003M]P0000;U]003003U]00000;U]005003U]@00kK800004kK<01000iK@000000oFA00<00>fB
kI800^fB00D00>ECiE?UD`0000;]T@05003eTOFAmI400004a;@01000iE;UDP000^ea0P0019^e00<0
0<BD00000jgm10001:gm00<00:gm[Od00P000Zgm00<00:gm[Od00Zgm00<00:gm[Od00P000Zgm0P00
>ooo000Lool00`00ooooo`0eool00`00ooooo`0Zool20003]O`00`00]Obeo003]O`20007]O`00`00
]Obeo0020002]O`00`00]Obeo003]O`20007]O`00`00]Obeo0020002]O`00`00]Obeo004]O`00`00
]Obeo004]O`00`00]Obeo0030002]O`00`00]Obeo004]O`00`00]O^en`04]O/00`00]O^en`020002
]O/00`00]O^en`05]O/00`00]O^en`04]O/01000]O/000000kGk00<00;Gk]O/00[Gk0P000[Gk00<0
0;Gk]O/00kGk00@00;gk000000>en`03002mnkgk00:mn`800003_O/00;gk00Fmn`03002mnkgk00Fm
n`05002mn`00002mn`030004_O/200000kgk002mn`05_O/00`00_O^mn`04_O/00`00_O/00005_O/0
1000_O/000000kgK00<00;gJ_MX00[gJ0P0000>mfP00_MX01;gJ00<00;gJ00001/GJ00<00<GJaMX0
1LGJ0`001<GJ00<00<GJ00001LGJ00<00<GJ00001LGJ00<00<GI00001LGI00<00<gI00001LgI00<0
0<gI00001<gI00<00<gI00001/gI0P001/gH00<00=GHeMP00mGH00<00<gH00001=GH00@00=GHeMP0
00;Ee`03003EemGG00?Ee`03003MemgG00?Me`03003Ee`0000?MeP03003Me]gF00;MeP03003M]Mfe
00;M]@07003M]]ffgKH00>Fd00000^Fd0P000^Fe00<00>fb00000nfc00D00>FdiKCU]00000?eT@03
003]T^fB00;]TP8000;UD`03003]T@0000CeT@8000;4]004003UD^EB0003kG420004VkD00`00a9C4
U0030003[Od00`00[Of]o@02[Od30004[Od01000[Of]oJgm10001:gm0P00>ooo000Kool00`00oooo
o`0gool00`00ooooo`0Wool20006]O`00`00]Obeo0020002]O`00`00]Obeo004]O`30005]O`00`00
]Obeo0020002]O`00`00]Obeo004]O`30004]O`00`00]Obeo002]O`200000kGl002eo005]O`20005
]O`00`00]Obeo002]O`200000kGl002en`05]O/20005]O/00`00]O^en`02]O/200000kGk002en`05
]O/00`00]O^en`04]O/01000]O/000001;Gk00<00;Gk]O/00kGk0P001[Gk00@00;gk000000>mn`03
002mnkgk00:mn`800003_O/00;gk00Fmn`D000>mn`04002mn`000003_O/00`00_O^mn`02_O/20000
0kgk002mn`05_O/00`00_O^mn`05_O/00`00_M^mf`04_M/01000_MX000000kgJ00@00;gJ_MZmfP80
00:mfP030035f/GJ00?5fP030035fP0000K5fP030035f/GJ00G5fP030035f/GJ00G5fP030035f/GJ
00G5fP030035fLGI00G5f@03003=fLgI00G=f@03003=fLgI00C=f@03003=fLgI00G=f@03003=f<gH
00C=f08000CEf004003=f<gH0003eMP00`00eMSEf002eMP20005eML20004gML01`00eMOEemGG003M
eP0000CMeP8000CM]@04003M]]ffgKH20004iK@01@00iKGU]NFe00001>fc00D00>FdiKCU]00000?e
T@07003]T^fBkI800>fc00000^EC00<00>fA00001?FA0P000/Bd00@00>EBiE8000?]L@8000BK]@03
0034U<BD008000B]o@03002]oJgm008000:]o@03002]oJgm00:]o@@000>]o@03002]oJgm00:]o@<0
03[oo`006ooo00<00?ooool0>?oo00<00?ooool09?oo0P000[Gl00<00;Gl]O`01;Gl0P001KGl0P00
0[Gl0P000[Gl00<00;Gl]O`01;Gl0P001;Gl00<00;Gl]O`00[Gl0P000[Gl00<00;Gl]O`00kGl00@0
0;Gl000000>eo003002eo;Gl00:eo0800003]O`00;Gl00Feo004002eo0000003]O`00`00]O^en`02
]O/200000kGl002en`05]O/01000]O/000000kGk00<00;Gk]O/00[Gk0P0000>en`00]O/01KGk00<0
0;Gk]O/01KGk00<00;Gk]O/00P000[Gk00<00;Gk]O/01;Gk00<00;gk_O/01;gk00@00;gk000000>m
n`03002mnkgk00:mn`@000Jmn`8000Jmn`04002mn`000003_O/00`00_O^mn`02_O/200000kgk002m
n`04_O/00`00_M/00006_M/00`00_MZmfP04_MX00`00_MX00005_MX00`00aM[5fP020002aMX00`00
aM[5fP02aMX200000lGJ0035fP04aMX00`00aMX00005aMX00`00aMX00005aMX00`00aMX00005aMT0
0`00aMX00005cMT20005cMT00`00cMT00005cMT00`00cMT00004cMP01000cMW=f@000]GH00<00<gH
cMP00/gH00<00=GH00001MGH00<00=GGeML01=GG00<00=GG00000]gG00<00=GGeML00]GG00<00=gF
00001=gF00<00=gF00000mfe00<00=ffgKH00]ff00@00>FdiKCU]08000?U]@03003]/nfc00;]/`05
003U]>FdiK@00003mI401`00kI;]T^fB003]/`0000;UD`03003]T@0000?eT@03003]TP0000;4]004
003UD^EB0002kG400`00mI000003VkD01000a9C4U<BD0P000jgm10001:gm00<00:gm[Od00P000Zgm
00<00:gm[Od00Zgm00<00:gm[Od00P000Zgm0P00>Ooo000?ool40008ool00`00ooooo`0iool2000Q
ool30004]O`00`00]Obeo002]O`200000kGl002eo005]O`30004]O`00`00]Obeo002]O`200000kGl
002eo004]O`01000]O`000001;Gl00<00;Gl]O`00kGl0P001[Gl00@00;Gl000000Beo003002eo;Gl
00>eo08000Jeo004002en`000003]O`00`00]O^en`04]O/20006]O/01000]O/000000kGk00<00;Gk
]O/00[Gk0P0000>en`00]O/01KGk0`001;Gk00<00;Gk]O/00[Gk0P0000>en`00_O/01Kgk00<00;gk
_O/01;gk00<00;gk00000`000[gk00@00;gk_O^mn`8000:mn`03002mnkgk00Bmn`03002mnkgk00Bm
n`04002mn`000003_O/01000_O^mnkgk0P000[gK00<00;gK_M/00[gK0P0000>mf`00_MX01KgJ00<0
0;gJ_MX01;gJ00<00<GJ00001LGJ00@00<GJ000000?5fP040035f/GJaMX20002aMX01000aM[5f/GJ
0P000/GJ00@00<GJaM[5fP8000;5fP030035fLGI00;5f@040035f/GJ0004cMT01000aMW5f@000lgI
00@00<gIcMT000C=f@04003=fLgI0003cMP01`00cMW=fLgI003Ef00000G=f003003Ef00000CEf003
003Ef00000CEe`06003EemGG003Me`001]GG00<00=gFgMH00]gF00@00=gFgMH000;M]@03003M]]ff
00;M]P8000?U]003003U]@0000;U]@05003]/nfckK<00003iK@00`00iK@00002mI401@00kI;]T^fB
00000^fc0P000^fA00L00?FAmI7eT@00kI800002a;@01000iE;UDP000^ea00@00?F@mI0000:K]@06
0034U<BDa9@00>EB0`000jgm00<00:gm[Od00Zgm0`001:gm00@00:gm[Of]o@@000B]o@8003Woo`00
4Ooo00<00?ooool01ooo00<00?ooool0>ooo00<00?ooool07?oo0P000[Gl00<00;Gl]O`00kGl00@0
0;Gl000000>eo003002eo;Gl00:eo08000:eo003002eo;Gl00>eo004002eo0000003]O`00`00]Obe
o003]O`20007]O`00`00]Obeo0020002]O`00`00]Obeo003]O`20007]O`00`00]Obeo0020002]O`0
0`00]Obeo003]O`20006]O`00`00]O^en`030002]O/00`00]O^en`03]O/20006]O/01000]O/00000
0kGk00<00;Gk]O/00[Gk0P000[Gk00<00;Gk]O/00kGk00@00;Gk000000>en`03002mnkgk00:mn`80
0003_O/00;gk00Bmn`<000Fmn`04002mn`000004_O/00`00_O^mn`02_O/200000kgk002mn`05_O/0
0`00_O^mn`04_O/00`00_O/00005_M/01000_M/000000kgK00<00;gJ_MX00[gJ0P0000>mf`00_MX0
1KgJ00<00<GJaMX01LGJ00<00<GJaMX01<GJ00<00<GJ00001LGJ00<00<GJ00001LGJ00<00<GJ0000
1LGJ00@00<GIaMT000C5fP04003=fLgI0003aMT01000cMW=f@001<gI00@00<gIcMT000C=f@03003=
f00000G=f@03003=f<gH00G=f003003Ef=GH00;Ef004003Ef=GH0003eML00`00eMOEe`02eML20005
eML20004gMH01`00gMKMe]gF003M]@0000CM]P05003M]P00iK@00003iKD200001NFe003]/nfc0000
0nFd00<00>Fd00000_FA00D00>fBkI;]TP0000;]/`8000;]T@05003eTOFAmI400002kI800`00a;@0
0002iE801000kG7]L@000_F@00@009^eVkD000;4U003003UD^EB008000B]o@03002]oJgm008000:]
o@03002]oJgm00:]o@@000>]o@03002]oJgm00:]o@<003Soo`004Ooo00<00?ooool01ooo00<00?oo
ool0??oo00<00?ooool06Ooo0P001;Gl00<00;Gl]O`00kGl0P001[Gl00@00;Gl000000Beo003002e
o;Gl00>eo08000Jeo003002eo;Gl008000:eo003002eo;Gl00Feo08000Feo003002eo;Gl008000:e
o003002eo;Gl00Feo08000Feo003002eo;Gl008000:eo003002eo;Gl00Beo08000Jen`03002enkGk
008000:en`03002enkGk00Ben`03002enkGk00Ben`04002en`000004]O/00`00]O^en`03]O/20006
]O/01000_O/000000kgk00<00;gk_O/0100000>mn`00_O/01Kgk00<00;gk_O/01Kgk00@00;gk0000
00>mn`03002mnkgk00:mn`800003_O/00;gk00Fmn`03002mfkgK00Fmf`03002mfkgK00Bmf`04002m
fP000003_M/00`00_MZmfP02_MX200000kgJ0035fP04aMX00`00_MX00006aMX00`00aM[5fP05aMX0
0`00aM[5fP05aMX00`00aM[5fP04aMX00`00aMT00005aMX00`00cMT00005aMT20005cMT00`00cMT0
0006cMT00`00cMW=f@03cMT00`00cMT00005cMP20004eMP01`00eMSEf=GH003Ee`0000GEe`03003E
emGG00CEe`03003Ee`0000;MeP03003Me]gF00;MeP8000CM]P06003M]]ff003U]0000nFe0P0000GU
]@00kK?]/`0000?U]003003U]>Fd008000?]TP03003]/nfc00;]/`04003]TNfA0003mI401P00kI;]
TP00a;@000;UDP04003]LNea0002mI000`00VkD00003a9@00`00iE;UDP020003[Od40004[Od00`00
[Of]o@020002[Od00`00[Of]o@02[Od00`00[Of]o@020002[Od2000gool0017oo`03003ooooo00Oo
o`03003ooooo03goo`03003ooooo01Koo`800003]O`00;Gl00Beo003002eo;Gl008000:eo003002e
o;Gl00>eo08000Neo003002eo;Gl008000:eo003002eo;Gl00Beo08000Feo003002eo;Gl00:eo080
0003]O`00;Gl00Feo08000Feo003002eo;Gl00:eo0800003]O`00;Gl00Feo08000Beo003002eo;Gl
00:eo0800003]O`00;Gk00Jen`8000Ben`03002enkGk00:en`800003]O/00;Gk00Fen`03002enkGk
00Fen`03002enkGk008000:en`03002enkGk00>en`8000Fmn`D000>mn`03002mnkgk00:mn`800003
_O/00;gk00Fmn`8000Jmn`04002mn`000003_O/00`00_O^mn`02_O/200000kgK002mf`04_M/00`00
_M/00006_M/00`00_M^mf`04_M/01000_MX000000kgJ00@00<GJaM[5fP8000:mfP030035f/GJ00;5
fP800003aMX00<GJ00C5fP030035fP0000G5fP030035fP0000K5fP030035f/GJ00G5fP030035fLGI
00C5f@03003=fLgI00G=f@03003=fLgI00C=f@8000C=f@04003=fLgI0004cMP01000cMS=f0000]GH
00<00=GHeMP00]GH00<00=GG00001=GG00<00=GH00001=GG00H00=GGeML00=gF0006gMH00`00gKKM
]P02gKH01@00gKKM]]ff00001NFe00H00>FeiKD00>fc0002iK@01000iKCU]>Fd0P000nfB00<00>fc
kK<00^fc00@00>fAkI4000?eT@03003]T^fB008000?UDP04003]LNea0002mI000`00VkD00003a9@0
1@00iE;UDP00kG400`000i^e00<00:gm[Od00Zgm0`001:gm00@00:gm[Of]o@@000B]o@<003Koo`00
4Ooo00<00?ooool01ooo00<00?ooool0?_oo00<00?ooool04ooo0P000kGl00<00;Gl]O`00kGl0`00
1KGl00<00;Gl]O`00P000[Gl00<00;Gl]O`01KGl0P001;Gl00<00;Gl]O`00[Gl0P0000>eo000]O`0
1KGl00@00;Gl000000>eo003002eo;Gl00:eo0800003]O`00;Gl00Feo004002eo0000003]O`00`00
]Obeo002]O`200000kGl002eo004]O`01000]O`000001;Gl00<00;Gk]O/00[Gk0P0000>en`00]O/0
1;Gk00@00;Gk000000>en`03002enkGk00:en`800003]O/00;Gk00Fen`<000Fen`03002enkGk0080
00:en`03002mn`00008000:mn`03002mnkgk00Bmn`04002mn`000003_O/00`00_O^mn`02_O/20002
_O/00`00_O^mn`04_O/00`00_O^mn`04_O/01000_O/000000kgK00@00;gK_M^mf`8000:mf`03002m
fkgK00:mf`800003_M/00;gK00Fmf`03002mf[gJ00BmfP030035fP0000FmfP040035fP000003aMX0
1000aM[5f/GJ0P000/GJ00@00<GJaM[5fP8000;5fP030035f/GJ00?5fP8000G5fP<000G5f@030035
f@0000G=f@03003=f@0000C=f@04003=fLgI0003cMT01@00cMW=fLgI00000/gH00L00<gHcMS=f000
eMP00006eMP00`00eMOEe`03eML00`00eMP00003eML00`00eMOEe`02eML20005gMH20003gKH00`00
gKKM]P02gKH00`00iKGU]@02iKD01000iKD00>Fe0P000nFd00<00>FdiK@00^Fd00D00>fBkI;]TP00
00C]/`04003]TNfA0003mI400`00kI;]TP020003iE801000kG7]L@000oF@0P000lBD00H00>EBiE80
0>ea0005VkD00`00[Of]o@020002[Od00`00[Of]o@02[Od40003[Od00`00[Of]o@02[Od3000fool0
00ooo`<000Soo`04003oo`00000oool00`00ooooo`0@ool20006]O`00`00]Obeo0020002]O`00`00
]Obeo004]O`20005]O`00`00]Obeo002]O`200000kGl002eo004]O`01000]O`000001;Gl00<00;Gl
]O`00kGl0P001[Gl00@00;Gl000000>eo003002eo;Gl00Beo08000Jeo004002eo0000003]O`00`00
]Obeo003]O`20007]O`01000]O/000000kGk00<00;Gk]O/00kGk0P001[Gk00@00;Gk000000>en`03
002enkGk00:en`8000:en`03002enkGk00Ben`8000>en`<000>mn`800003]O/00;gk00Fmn`03002m
nkgk00Bmn`04002mn`000004_O/00`00_O^mn`02_O/200000kgk002mn`05_O/00`00_M^mf`04_M/0
0`00_M/00005_M/01000_M/000000kgK00<00;gK_M/00[gK0P0000>mf`00_MX01KgJ00<00;gJ_MX0
1KgJ00<00<GJaMX01<GJ00<00<GJ00001LGJ00<00<GJ00001LGJ00<00<GJaMX00P000/GJ00D00<GJ
aM[5fP0000?5fP030035fLGI008000;5f@04003=fLgIcMT20002cMT01@00cMW=fLgI00000lgI00@0
0<gIcMT000C=f@03003=f00000G=f003003Ef=GH00CEf08000CEe`07003Ef=GHeMP00=GG00001MGG
00<00=gFgMH01=gF00<00=gG00000]ff00@00=ffgKKM]P8000CU]@06003U]NFe003U]@000nFd00<0
0>FdiK@00^Fd00D00>fBkI;]TP0000?]/`8000;]T@05003eTOFAmI400003kI801@00iE;UD^EB0000
0^ea00D00?F@mI3eT00000C4U003003UDP0000;]L@03002K]I^e00BK]@8000B]o@03002]oJgm0080
00:]o@03002]oJgm00:]o@03002]oJgm008000:]o@03003ooooo03Coo`004Ooo00<00?ooool01_oo
0P00@_oo00<00?ooool03Ooo0P000[Gl00<00;Gl]O`01;Gl0P001;Gl00<00;Gl]O`00[Gl0P0000>e
o000]O`01KGl00@00;Gl000000>eo003002eo;Gl00>eo08000Neo003002eo;Gl008000:eo003002e
o;Gl00>eo08000Jeo003002eo;Gl00<000:eo003002eo;Gl00>eo08000Jeo003002eo;Gl008000:e
o003002eo;Gl00Beo08000Jen`03002enkGk008000:en`03002enkGk00>en`8000Jen`04002en`00
0004]O/00`00]O^en`02]O/200000kGk000000020002]O/01000_O/000000kGk00<00;gk_O/00[gk
0P0000>mn`00_O/01Kgk00<00;gk_O/01Kgk00@00;gk000000>mn`03002mnkgk00:mn`800003_M/0
0;gK00Fmf`03002mfkgK00Fmf`03002mfkgK00Bmf`04002mf`000003_M/00`00_MZmfP02_MX20000
0kgJ002mfP04_MX00`00_MX00006aMX00`00aM[5fP05aMX00`00aM[5fP04aMX00`00aMX00004aMX0
1000aMX000001<GJ00<00<GI00001LGI00<00<gI00001LgI00<00<gI00001LgI0P001/gI00<00<gH
cMP00lgH00<00<gH00001=GH00@00=GHeMP000;Ee`03003Ef=GH00;Ef003003Ee`0000CEe`03003E
e`0000CMeP06003MemgG003M]P001=ff00<00=ff00000^Fe00L00>FeiKGU]@00iKD00003iK@00`00
iKCU]002iK@01000kI;]TP001>fc00D00>Fc003]T@0000?eT@05003]T^fBkI800003iE801000kG7]
L@000oF@00<00<BDa9@00/BD00<00>EB00000^ea0P001I^e0P001:gm0`001:gm00@00:gm[Of]o@@0
00B]o@8003Goo`006_oo00<00?ooool0@_oo00<00?ooool02Ooo0`001;Gl00<00;Gl]O`00[Gl0P00
00>eo000]O`01;Gl00@00;Gl000000Beo003002eo;Gl00>eo08000Jeo003002eo;Gl008000:eo003
002eo;Gl00Beo0<000Feo003002eo;Gl008000:eo003002eo;Gl00Beo08000Jeo003002eo;Gl0080
00:eo003002eo;Gl00Beo08000Beo003002eo;Gl00:eo08000:eo003002enkGk00Ben`8000Fen`03
002enkGk008000:en`03002enkGk00Ben`03002enkGk00Fen`05002en`00002en`030005]O/20006
]O/01000_O/000000kgk00<00;gk_O/00[gk0P0000>mn`00_O/01Kgk0P001[gk00@00;gk000000>m
f`03002mfkgK00:mf`800003_M/00;gK00Bmf`03002mf`0000Jmf`03002mfkgK00Bmf`04002mfP00
0003_MX01000_MZmf[gJ0P000[gJ00<00<GJaMX00/GJ0P0000?5fP00aMX01<GJ0P001/GJ0P001/GJ
00<00<GJaMX01LGJ00<00<GIaMT01LGI00<00<gIcMT01LgI00<00<gIcMT01<gI00<00<gIcMT01<gI
0P001<gH00@00<gHcMP000CEf006003Ef=GH003Ee`001]GH00<00=GGeML00mGG00<00=GG00000mgF
00<00=gGgML00]gG0P000mff00@00=ffgKH000;U]@03003U]NFe00;U]@05003M]@00iK@00004iK@0
1@00iKD00>fB00001>fc00@00>Fc000000?eT@03003]T^fB00;]TP05003UD^EBiE800002kG401@00
mI3eT?F@00001<BD00<00>EB00000^ea0P0019^e00<00<BC00000Zgm0P000Zgm00<00:gm[Od00Zgm
10000jgm00<00:gm[Od00Zgm0`00=?oo000Jool00`00ooooo`13ool00`00ooooo`06ool20002]O`0
0`00]Obeo003]O`01000]O`000000kGl00<00;Gl]O`00kGl0P001kGl00<00;Gl]O`00P000[Gl00<0
0;Gl]O`00kGl0`001KGl0P000[Gl0P000[Gl00<00;Gl]O`01;Gl0P001;Gl00<00;Gl]O`00[Gl0P00
00>eo000]O`01[Gl0P001;Gl00<00;Gl]O`00[Gl0P0000>eo000]O`01;Gl00@00;Gl000000Beo003
002enkGk00:en`800003]O/00;Gk00Fen`8000Ben`03002enkGk00:en`800003]O/00;Gk00Jen`04
002en`000003]O/00`00]O^en`020002]O/00`00]O^en`03]O/20006_O/01000_O/000000kgk00<0
0;gk_O/00[gk0P0000>mn`00_O/01Kgk0P001[gK00@00;gK000000>mf`04002mfkgK_M/20002_M/0
0`00_M^mf`02_M/200000kgK002mf`05_M/00`00_MZmfP04_MX00`00_MX00005_MX01000aMX00000
0lGJ00@00<GJaM[5fP8000;5fP040035f/GJaMX200000lGJ0035fP04aMX00`00aMX00005aMX00`00
aMX00005aMT20005cMT30005cMT00`00cMT00004cMT01000cMW=f@000/gH00<00<gHcMP00/gH00@0
0=GHeMP000CEf08000GEf08000CEe`07003EemGGeML00=gF00001MgG00<00=ffgKH00]ff00L00=ff
gKKM]P00iKD00004iKD300000nFd003U]003iK@01@00iKD00>fB00001>fc00@00>Fc000000?eT@03
003]T^fB00;]TP8000;UDP04003]LNea0003mI001@00a9C4U<BD00000^EB00<00>eakG400P0019^e
00<00<BCa9<00P001:gm00<00:gm[Od00P000Zgm00<00:gm[Od00Zgm00<00:gm[Od00P000Zgm00<0
0?ooool0<_oo000Jool00`00ooooo`14ool00`00ooooo`03ool20004]O`00`00]Obeo003]O`20006
]O`00`00]Obeo0020002]O`00`00]Obeo004]O`30005]O`00`00]Obeo0020002]O`00`00]Obeo005
]O`20004]O`00`00]Obeo002]O`200000kGl002eo004]O`01000]O`000001;Gl00<00;Gl]O`00[Gl
0P0000>eo000]O`01;Gl00@00;Gl000000>eo003002eo;Gl00>eo08000Neo004002en`000003]O/0
0`00]O^en`02]O/200000kGk002en`04]O/01000]O/000001;Gk00<00;Gk]O/00[Gk10001[Gk0P00
1KGk00<00;Gk]O/00P000[Gk00<00;gk_O/00kgk0P001[gk00@00;gk000000Bmn`04002mnkgk_O/2
00000kgK002mf`05_M/20006_M/00`00_M/00005_M/01000_M/000000kgK00<00;gK_M/00[gK0P00
00>mf`00_MX01KgJ00<00;gJ_MX01KgJ00<00<GJaMX01<GJ00<00<GJ00001<GJ00@00<GJ000000C5
fP030035f/GJ008000;5fP040035f/GJaMX20002aMX01000aMW5fLGI0P000/GI00D00<gIcMW=f@00
00?=f@03003=fLgI008000;=f@05003=fLgIcMT00003cMT00`00cMP00005cMP00`00eMP00005eMP0
0`00eMSEf003eMP01000eMSEf0000]GG00<00=GGeML00]GG00<00=gF00001=gG0P000mff00<00=ff
gKH00]ff0P001>Fe00H00=fegKD00>Fd0004iK@01@00iKD00>fB00000nfc00<00>FciK<00P000oFA
00T00>fBkI;]TP00kI<00>EB00000^ea00<00?F@mI000_F@0P000/BD00@00>EBiE8000;]L@8000BK
]@030034TlBC008000>]o@@000B]o@04002]oJgm[Od40004[Od2000=ool20004ool00`00ooooo`03
ool2000Hool001[oo`03003ooooo04Goo`03003ooooo00800003]O`00;Gl00Beo003002eo;Gl0080
00:eo003002eo;Gl00>eo0<000Feo08000:eo08000:eo003002eo;Gl00Beo08000Feo003002eo;Gl
00:eo0800003]O`00;Gl00Beo004002eo0000003]O`00`00]Obeo003]O`20007]O`01000]O`00000
0kGl00<00;Gl]O`00kGl0P001[Gl00<00;Gl]O`00P000[Gl00<00;Gl]O`01;Gl0P001[Gk00@00;Gk
000000>en`03002enkGk00>en`8000Nen`03002en`00008000:en`03002enkGk00:en`800003]O/0
0;Gk00Fen`8000Fen`03002mnkgk008000:mn`03002mnkgk00Bmn`03002mnkgk00Bmn`04002mn`00
0004_M/01000_M^mfkgK0P0000>mf`00_M/01KgK0P001kgK00<00;gK_M/01;gK00@00;gK000000>m
f`03002mf[gJ00:mfP<000FmfP<000K5fP8000K5fP030035f/GJ00C5fP030035fP0000G5fP030035
fP0000G5fP030035f@0000C5f@04003=f@000004cMT00`00cMT00005cMT00`00cMT00005cMT00`00
cMS=f005cMP00`00eMSEf003eMP00`00cMP00004eMP01P00eMSEf000eML000KEe`03003MemgG00?M
e`03003Ee`0000;M]P03003M]]ff00?M]P03003U]NFe00;U]@03003M]Mfe008000CU]003003U]NFe
008000C]/`05003U/nFciK<00003mI402@00kI;]T^fB003]T`00iE800002kG400`00mI3eT002mI02
0002a9@01000iE;UDP000^ea0P000i^e00H00<BCa9?4T`00iC830003[Od00`00[Of]o@02[Od40003
[Od00`00[Of]o@02[Od3000;ool01000ooooo`002?oo00@00?ooool001Ooo`006Ooo00<00?ooool0
Aooo0P000kGl00<00;Gl]O`00kGl0`001KGl00<00;Gl]O`00P000[Gl00<00;Gl]O`01KGl0P001;Gl
00<00;Gl]O`00[Gl0P0000>eo000]O`01KGl00@00;Gl000000>eo003002eo;Gl00>eo08000Jeo003
002eo;Gl008000:eo003002eo;Gl00Beo08000Jeo003002eo;Gl008000:eo003002eo;Gl00Beo080
00Feo08000:eo08000:eo003002enkGk00Ben`03002enkGk00Ben`03002enkGk008000:en`03002e
nkGk00>en`<000Jen`04002en`000003]O/00`00]O^en`02]O/200000kGk002en`05]O/20004_O/0
0`00_O^mn`02_O/200000kgk002mn`05_O/00`00_M^mf`04_M/01000_M/000001;gK00@00;gK_M^m
f`800003_M/00;gK00Bmf`<000Jmf`8000Jmf`04002mfP000003_MX01@00_MZmf[gJ00000kgJ00@0
0<GJaM[5fP800003_MX00<GJ00C5fP030035fP0000K5fP030035f/GJ00G5fP030035f/GJ00G5fP03
0035fLGI00C5f@03003=fLgI00G=f@03003=fLgI00G=f@03003=fLgI00?=f@03003=f@0000G=f080
00CEf004003=f<gH0003eMP00`00eMSEf002eMP20005eML20004gML01P00eMOEe`00gKH000GM]P80
00?U]@03003M]Mfe00;M]@03003U]>Fd00;U]005003U]NFeiKD00004kK<01@00iK?U/nFc00000oFA
00D00>fBkI;]TP0000;]T`8000;]L@07003eT?F@mI000>fA00000/BD00@00>EBiE8000;]L@03003e
T00000:K]@060034TlBCa9<00>Db0P001:gm00<00:gm[Od00P000Zgm00<00:gm[Od00Zgm00<00:gm
[Od00P000Zgm00<00?ooool02Ooo00@00?ooool000Soo`04003ooooo000Gool001Woo`03003ooooo
04Goo`8000Jeo003002eo;Gl008000:eo003002eo;Gl00Beo08000Feo003002eo;Gl00:eo0800003
]O`00;Gl00Beo004002eo0000004]O`00`00]Obeo003]O`20006]O`00`00]Obeo0020002]O`00`00
]Obeo003]O`30005]O`20002]O`20002]O`00`00]Obeo004]O`20004]O`00`00]Obeo002]O`20000
0kGl002eo006]O`20004]O`00`00]O^en`02]O/200000kGk002en`05]O/20005]O/00`00]O/00003
0002]O/00`00]O^en`04]O/00`00]O^en`04]O/01000]O/000000kGk00<00;Gk]O/00[Gk0P0000>e
n`00_O/01;gk00@00;gk000000>mn`03002mnkgk00:mn`800003_M/00;gK00Fmf`03002mfkgK00Bm
f`04002mf`000004_M/01@00_M^mfkgK00000kgK00@00;gK_M^mf`800003_M/00;gK00Fmf`8000Fm
fP04002mfP000004_MX01000aMX000001;gJ00<00<GJaMX00P000/GJ00<00<GJaMX00lGJ00<00<GJ
00001LGJ00<00<GJ00001LGJ0P001LGI00<00<GI00001LgI00<00<GI00001LgI0P001<gI00@00<gI
cMT000C=f004003=f<gH0002eMP00`00cMS=f002cMP00`00eMP00005eMP00`00eMOEe`04eML00`00
eML00002gML00`00eMOEe`02eML20005gKH00`00gKH00002iKD00`00gKGM]@02gKD20003iK@01@00
iKGU]NFe00001>fc00D00>FciK?U/`0000?eT@05003]T^fBkI800002kI<20002kG401`00mI3eT?F@
003]T@0000;4U006003UD^EB003]L@000_F@00@009^eVkD000;4T`03003U<^Db008000>]o@@000B]
o@04002]oJgm[Od40004[Od2000:ool01000ooooo`002Ooo0P006?oo000Iool00`00ooooo`13ool2
0002]O`00`00]Obeo003]O`30004]O`00`00]Obeo002]O`200000kGl002eo005]O`01000]O`00000
0kGl00<00;Gl]O`00kGl0P001kGl00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl0`001KGl00<00;Gl
]O`00P000[Gl00<00;Gl]O`01KGl0P001;Gl00<00;Gl]O`00[Gl0P0000>eo000]O`01;Gl00@00;Gl
000000Beo003002eo;Gl00:eo0800003]O`00;Gl00Beo004002en`000003]O/00`00]O^en`02]O/2
00000kGk002en`03]O/40005]O/00`00]O^en`02]O/200000kGk002en`05]O/00`00]O^en`04]O/0
1000]O/000000kGk00<00;gk_O/00kgk0P001[gk00@00;gk000000>mf`03002mfkgK00:mf`800003
_M/00;gK00Fmf`03002mfkgK00Bmf`04002mf`000004_M/01000_M/000001;gK00@00;gK_M^mf`80
0003_M/00;gJ00FmfP03002mf[gJ00FmfP03002mf[gJ00BmfP030035fP0000G5fP030035f/GJ0080
00;5fP040035f/GJaMX20002aMX01000aM[5f/GJ0P000/GJ00<00<GIaMT00P000/GI00<00<gIcMT0
0/gI00@00<GIaMT000C=f@04003=fLgI0002cMT00`00cMW=f@02cMT01000cMS=f0000lgH00<00=GH
00001/gH00<00=GHeMP00mGH00<00=GH00001=GG00H00=GGeML00=gG0005eML00`00gKKM]P03gKH0
1P00gKKM]P00iKD000CM]@06003M]P00003U]0001>Fe00D00>fckK?]/`0000?U/`03003U]00000;e
T@04003]T^fB0003kI<20002kG401@00mI3eT?F@00000^fA00<00<BD00000^EB00<00>ea00000_F@
00<009^e00000lBC00D00>DbiC800>ea00<000>KU003002]oJgm00:]o@@000>]o@04002]oJgm[Od4
0009ool01000ooooo`002?oo00@00?ooool001Ooo`006Ooo0`00@?oo0`001KGl00<00;Gl]O`00P00
0[Gl00<00;Gl]O`00kGl00@00;Gl000000Beo003002eo;Gl00>eo08000Jeo003002eo;Gl008000:e
o003002eo;Gl00Beo0<000Feo003002eo;Gl008000:eo003002eo;Gl00Beo08000Feo003002eo;Gl
00:eo0800003]O`00;Gl00Beo004002eo0000003]O`00`00]Obeo003]O`20007]O`01000]O`00000
0kGl00<00;Gl]O`00kGl0P001[Gk00@00;Gk000000>en`03002en`0000@00003]O/00;Gk00Fen`04
002en`000003]O/00`00]O^en`02]O/200000kGk002en`05]O/00`00]O^en`04]O/00`00_O^mn`02
0002]O/00`00_O^mn`03_O/20006_M/01000_M/000000kgK00<00;gK_M/00[gK0P0000>mf`00_M/0
1KgK00<00;gK_M/01KgK00<00;gK_M/01;gK00@00;gK000000Bmf`04002mf[gJ_MX200000kgJ002m
fP04_MX00`00_MX00006_MX00`00aM[5fP04aMX00`00aMX00005aMX00`00aMX00005aMX00`00aMX0
0004aMX00`00aMT00005aMT01000cMW=f@001<GI00@00<gIcMT000?=f@03003=f@0000G=f@03003=
f00000G=f003003=f<gH00C=f08000CEf004003Ef=GH0003eML00`00eMOEe`02eML20004eML00`00
eML00004gKH01000gKKM]]ff0P001=fe00H00=ff00000>Fd0003iKD00`00iKD00002kK<02@00iK?U
/nFc003U]000mI400003kI800`00kI?]T`02kI<01000kG7]L@000oF@00P00>fAkI400<BD003UDP00
0^ea00H00?F@mI0009^e0003a9<01P00iC;U<P00kG4000FKU003002]oJgm008000:]o@03002]oJgm
00:]o@@000>]o@03003ooooo00Ooo`04003ooooo0008ool01000ooooo`005ooo000Iool00`00oooo
o`0nool20002[O`00`00]Obeo004]O`20004]O`00`00]Obeo003]O`20007]O`00`00]Obeo0020002
]O`00`00]Obeo003]O`30005]O`20002]O`20002]O`00`00]Obeo004]O`20004]O`00`00]Obeo002
]O`200000kGl002eo005]O`01000]O`000000kGl00<00;Gl]O`00kGl0P001[Gl00<00;Gl]O`00P00
0[Gl00<00;Gl]O`01;Gl0P001[Gl00<00;Gl]O`00P000[Gl00<00;Gk]O/00kGk0P001;Gk0`0000>e
n`0000000kGk00<00;Gk]O/01;Gk0P001[Gk00@00;Gk000000>en`03002enkGk00:en`800003]O/0
0;Gk00Fen`8000Fen`03002mnkgk008000:mf`03002mfkgK00>mf`8000Jmf`04002mf`000003_M/0
0`00_M^mf`02_M/200000kgK002mf`03_M/200000kgK002mf`05_M/00`00_M^mf`04_M/01000_MX0
00000kgJ00@00;gJ_MZmfP8000:mfP03002mf[gJ00:mfP800003_MX00<GJ00G5fP030035f/GJ00G5
fP030035f/GJ00G5fP030035f/GJ00C5fP030035fLGI00C5f@03003=f@0000G5f@03003=f@0000G=
f@03003=fLgI00G=f@03003=f<gH00?=f003003=f@0000C=f004003=f<gH0003eMP01`00eMSEf=GH
003Ee`0000GEe`03003EemGG00?Ee`03003Ee`0000?M]P03003M]]ff00;M]P03003M]Mfe00;M]@04
003M]]ffgKH30003iKD00`00iKD00002kK<01@00iK?U/nFc00000^Fd0P000nfB00<00>fCkI<00^fC
00@00>eakG4000?eT003003]TNfA008000;UDP04003]LNea0003mI020003a9<01P00iC;U<P00kG40
00JKU08000B]o@03002]oJgm008000:]o@03002]oJgm00:]o@<000Soo`8000[oo`8001Soo`006Ooo
00<00?ooool0??oo0P001:gl00<00;Gl]O`00[Gl0P0000>]o000]O`01;Gl00<00;Gl]O`00P000[Gl
00<00;Gl]O`01;Gl0`001KGl00<00;Gl]O`00P000[Gl00<00;Gl]O`01KGl0P001;Gl00<00;Gl]O`0
0[Gl0P0000>eo000]O`01;Gl00@00;Gl000000Beo003002eo;Gl00>eo08000Jeo003002eo;Gl0080
00:eo003002eo;Gl00>eo0<000Feo003002eo;Gl00<000:eo003002eo;Gl00Beo08000Feo003002e
nkGk008000:en`04002en`000003]O/00`00]O^en`04]O/00`00]O^en`030002]O/00`00]O^en`03
]O/20006]O/01000]O/000000kGk00<00;Gk]O/00[Gk0P0000>en`00]O/01KGk0P001KgK00<00;gK
_M/00P000[gK00<00;gK_M/01;gK00<00;gK_M/01;gK00@00;gK000000Bmf`04002mf`000003_M/0
0`00_M^mf`02_M/200000kgK002mf`05_M/00`00_MZmfP04_MX00`00_MX00005_MX01000_MX00000
0kgJ00<00<GJaMX00/GJ0P0000?5fP00aMX01<GJ0P001LGJ0`001LGJ00<00<GJ00001/GI00<00<GI
aMT01LGI00<00<gIcMT00lgI00<00<gI00001LgI0P001<gH00@00<gIcMT000C=f004003=f<gH0002
eMP00`00eMSEf002eMP00`00eML00004eML00`00eML00003eML01`00eMOEemGG003M]P0000CM]P03
003M]P0000?M]@04003M]]ffgKH30002iKD01`00iKGU]NFe003]/`0000;U/`04003U]>FdiK@20003
kI800`00kI?]T`02kI<01000kG7]L@000oF@00<00>fAkI400P000^EB00@00>eakG4000?eT0030034
TlBC00;4T`05003U<^Db003]L@020005Vi@20004[Od30004[Od01000[Of]oJgm1000;_oo000Hool0
0`00ooooo`0kool200000jgl002]o004[O`01000]O`000000jgl00<00;Gl]O`00kGl0`001KGl0P00
0[Gl0P000[Gl00<00;Gl]O`01;Gl0P001KGl00<00;Gl]O`00[Gl0P0000>eo000]O`01;Gl00@00;Gl
000000>eo003002eo;Gl00>eo08000Neo003002eo;Gl008000:eo003002eo;Gl00Beo08000Feo003
002eo;Gl008000:eo003002eo;Gl00Beo08000Feo003002eo;Gl00:eo0800003]O`00;Gl00Feo080
00>en`<000>en`800003]O/00;Gk00Fen`8000Jen`03002enkGk008000:en`03002enkGk00Ben`03
002enkGk00Ben`04002en`000003]O/00`00]O^en`02]O/200000kGK002mf`05_M/20004_M/00`00
_M^mf`02_M/200000kgK002mf`05_M/00`00_M^mf`05_M/00`00_M^mf`04_M/01000_M/000000kgK
00<00;gK_M/00[gK0P0000>mf`00_MX01KgJ00<00;gJ_MX01KgJ00<00;gJ_MX01;gJ00@00<GJ0000
00?5fP040035f/GJaMX20002aMX01@00aM[5f/GJ00000lGJ00<00<GJaMX00P000/GJ00<00<GIaMT0
0lGI00<00<GJ00001LGI0P001<gI00@00<gIcMT000C=f@04003=fLgI0002cMP00`00cMW=f@02cMT0
1000cMS=f0001<gH0P001]GH00<00=GGeML00]GG00@00=GGeML000?Ee`07003EemGGeML00=ff0000
1=ff00<00=ff00000]fe00<00=ffgKH00mff0P000^Fe00@00>FeiKGU]@8000?U/`03003U]>Fd00;U
]005003]T^fBkI800003kI<20002kG401@00mI3eT?F@00000nfA00@00>EBiE8000;]L@05003eT?F@
mI000004a9<01@00iC;U<P00kG400P0019^D00<00<BC00000Zgm0P000Zgm00<00:gm[Od00Zgm1000
0Zgm0P00;_oo000Hool00`00ooooo`0iool20003[O`00`00[Ob]o003[O`20006[O`00`00]Obeo002
0002]O`00`00]Obeo005]O`20004]O`00`00]Obeo002]O`200000kGl002eo005]O`01000]O`00000
0kGl00<00;Gl]O`00kGl0P001[Gl00<00;Gl]O`00P000[Gl00<00;Gl]O`01KGl0P001;Gl00<00;Gl
]O`00[Gl0P0000>eo000]O`01KGl0P001;Gl00<00;Gl]O`00[Gl0P0000>eo000]O`01KGl00@00;Gl
000000>eo003002eo;Gl00:eo0800003]O`00000008000:en`04002en`000003]O/00`00]O^en`02
]O/200000kGk002en`05]O/30004]O/00`00]O^en`02]O/200000kGk002en`05]O/00`00]O^en`04
]O/01000]O/000000kGK00<00;gK_M/00[gK0P0000>mf`00_M/01;gK00@00;gK000000>mf`03002m
fkgK00:mf`800003_M/00;gK00>mf`800003_M/00;gK00Fmf`03002mfkgK00Bmf`04002mf`000003
_M/00`00_MZmfP02_MX200000kgJ002mfP04_MX00`00_MX00006_MX00`00aM[5fP04aMX00`00aMX0
0004aMX01000aMX000001<GJ00<00<GJ00001LGJ00<00<GIaMT00P000/GJ00@00<GIaMW5f@8000;5
f@04003=fLgI0004cMT01000cMW=f@000lgI00<00<gH00001LgI00<00<gH00001LgH00<00=GHeMP0
1=GH0P001=GG00L00=GGeMOEe`00eML00005eML00`00gKKM]P02gKH01`00gKKM]]ff003M]@0000CM
]P800004iKD00>Fe0004iKD01@00iK?U/nFc00001>Fd00@00>fBkI8000C]T`05003UT`00kG400003
mI001@00kI7]TNfA00000^EB00@00>eakG4000?eT0030034TlBC00;4T`03003U<P0000;]L@8000BK
U0030034TlBC008000B]o@03002]oJgm00800003[Od00:gm00B]o@8002goo`006?oo00<00?ooool0
=ooo0P001Zgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001KGl00<00;Gl]O`00[Gl0P0000>e
o000]O`01;Gl00@00;Gl000000Beo003002eo;Gl00>eo08000Jeo003002eo;Gl008000:eo003002e
o;Gl00Beo08000Feo003002eo;Gl00:eo0800003]O`00;Gl00Beo004002eo0000003]O`00`00]Obe
o002]O`200000kGl002eo004]O`01000]O`000001;Gl00<00;Gl]O`00kGl0P001[Gl00D00;Gl0000
0;Gl00<000Fen`8000Jen`04002en`000003]O/00`00]O^en`02]O/20002]O/00`00]O^en`03]O/0
1000]O/000000kGk00<00;Gk]O/00[Gk0P0000>en`00]O/01KGk00<00;GK]M/01;GK00@00;gK0000
00>mf`03002mfkgK00>mf`8000Jmf`04002mf`000004_M/01000_M/000000kgK00<00;gK_M/00[gK
0P0000>mf`00_M/01KgK00<00;gK_M/01;gK00@00;gJ000000>mfP04002mf[gJ_MX20002_MX00`00
_MZmfP02_MX200000kgJ0035fP05aMX00`00aM[5fP04aMX00`00aM[5fP05aMX00`00aM[5fP04aMX0
0`00aMT00005aMX00`00aMT00004aMT00`00cMT00005cMT00`00cMT00005cMT00`00cMW=f@05cMT0
0`00cMS=f003cMP00`00cMP00004eMP01000eMSEf0000]GG00<00=GGeML00]GG00<00=GG00001=GG
0P001=ff00@00=ffgKKM]P8000GM]P05003M]P00iKD00005iKD01@00iK?U/nFc00000nFd00D00>Fd
003]TP0000C]T`04003UT`000003mI000`00kI7]T@02kI401000iE;UDP000^ea00D00?F@mI3eT000
00C4T`03003U<P0000;]L@8000BKU0030034TlBC008000B]o@<000B]o@03002]oJgm00<00003ool0
0?oo02_oo`006?oo00<00?ooool0=Ooo0P000Zgl00<00:gl[O`00jgl0`001Jgl0P0000>]o0000000
0Zgl00<00;Gl]O`01;Gl00@00;Gl000000>eo003002eo;Gl00>eo08000Neo003002eo;Gl008000:e
o003002eo;Gl00>eo0<000Beo003002eo;Gl00:eo0800003]O`00;Gl00Feo004002eo0000003]O`0
0`00]Obeo003]O`20006]O`01000]O`000000kGl00<00;Gl]O`00kGl0P001kGl00<00;Gl]O`00P00
0[Gl00<00;Gl]O`00kGl1@000kGl00<00;Gk]O/00P000[Gl00<00;Gk]O/00kGk0P001[Gk00@00;Gk
000000Ben`03002enkGk00>en`8000Jen`04002en`000003]O/00`00]O^en`02]O/200000kGK002e
f`05]M/00`00_M^mf`04_M/00`00_M^mf`020002_M/00`00_M^mf`03_M/20007_M/00`00_M^mf`04
_M/01000_M/000000kgK00<00;gK_M/00[gK0P0000>mf`00_M/01KgK00<00;gJ_MX01;gJ00<00;gJ
00001KgJ00@00;gJ000000>mfP030035f/GJ00;5fP<000G5fP030035fP0000G5fP030035fP0000K5
fP030035f/GJ00G5fP030035fLGI00C5f@03003=fLgI00G=f@03003=fLgI00?=f@03003=f@0000G=
f@8000C=f004003=f<gH0004eMP01P00eMSEf000eML000KEe`03003EemGG00?Ee`03003Ee`0000;M
]P03003M]]ff00?M]P03003M]]ff00;M]P05003M]]ff003U]@020003iKD01@00gKD00>Fc00001>Fd
00D00>Fd003]TP0000C]T`04003UT`000003mI000`00kI7]T@02kI401000iE;UDP000^ea00@00?F@
mI3eT08000;4T`04003U<^Db0002kG420003Vi@01000a9?4TlBC0P000Zgm0P000Zgm00@00:gm[Of]
o@@000>]o@8002coo`006?oo00<00?ooool0<_oo0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`0
1Jgl00<00:gl[O`00jgl00<00;Gl]O`00kGl0P001[Gl00<00;Gl]O`00P000[Gl00<00;Gl]O`01;Gl
0`001KGl00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl00@00;Gl000000Beo003002eo;Gl00>eo080
00Jeo003002eo;Gl008000:eo003002eo;Gl00>eo08000Jeo003002eo;Gl008000:eo003002eo;Gl
00Beo0<000Feo003002eo;Gl00D000Jeo08000Feo003002enkGk008000:en`03002enkGk00Ben`03
002enkGk00Fen`03002enkGk008000:en`03002enkGk00>en`8000Jen`04002en`000003]M/00`00
]M^ef`02]M/200000kGK002mf`05_M/20005_M/00`00_M^mf`020002_M/00`00_M^mf`02_M/20000
0kgK002mf`05_M/00`00_M^mf`04_M/01000_M/000000kgK00<00;gK_M/00[gK0P0000>mf`00_MX0
1KgJ00<00;gJ_MX01KgJ00<00;gJ_MX01;gJ00@00<GJ000000?5fP030035f/GJ008000;5fP040035
f/GJaMX20002aMX00`00aM[5fP03aMX00`00aMX00005aMX20005aMT00`00aMT00005cMT20004cMT0
1000cMW=f@001<gI00@00<gIcMT000;=f003003=f<gH00;=f004003Ef=GH0004eMP00`00eMOEe`04
eML20004eML01P00eMOEe`00gKH000GM]P8000CM]P07003M]]ffgKH00>Fe00000nFe00D00=fe003U
/`0000CU]005003U]000kI800003kI<00`00iI?UT`020003mI002@00kI7]TNfA003]TP00iE800002
kG401000mI3eT?F@0P000/BC00@00>DbiC8000;]L@03003eT00000:KU0060034TlBCa9<00>Db0P00
1:gm00@00:gm000000:]o@03002]oJgm00:]o@03003oo`0002_oo`006?oo00<00?ooool0<?oo0P00
0Zgl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00Zgl0P0000>]o000[O`01:gl00<00;Gl]O`00P00
0[Gl00<00;Gl]O`00kGl0`001KGl0P000[Gl0P000[Gl00<00;Gl]O`01;Gl0P001;Gl00<00;Gl]O`0
0kGl0P001kGl00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl0`001KGl00<00;Gl]O`00P000[Gl00<0
0;Gl]O`01;Gl0P001KGl0P000[Gl0P000[Gl00<00;Gl]O`01;Gl0`000kGl00<00;Gl]O`00[Gl0P00
00>eo000]O`01KGl0P001;Gk00<00;Gk]O/00[Gk0P0000>en`00]O/01KGk0`001KGk00<00;Gk]O/0
0P000[Gk00<00;Gk]O/01;Gk00<00;GK]M/01;GK00@00;GK000000>ef`03002mfkgK00:mf`800003
]M/00;gK00Fmf`8000Fmf`04002mf`000003_M/00`00_M^mf`02_M/200000kgK002mf`05_M/00`00
_M^mf`04_M/01000_M/000000kgK00<00;gJ_MX00[gJ0P0000>mf`00_MX01;gJ0P001[gJ0P001LGJ
00<00<GJ00001LGJ00<00<GJ00001LGJ00<00<GJaMX00P000/GJ00@00<GJaM[5fP8000;5fP030035
fLGI008000;5f@04003=fLgIcMT20002aMT01000cMW=f@001<gI00@00<gIcMT000?=f@03003=f000
00G=f003003Ef00000CEf003003=f00000CEe`04003Ef=GH0002eML00`00eMOEe`02eML20005gKH0
0`00eKL00002gKH00`00gKKM]P02gKH01P00iKGU]@00iKD000;M]@03003U/`0000?U]003003U]>Fd
008000C]T`05003UTnFCiI<00003mI002@00kI7]TNfA003]TP00iE800002kG401P00mI3eT000kI40
00;4T`06003U<^Db003]L@000_F@00@009^DVi@000?4T`04003U<P000003[Od30004[Od01000[Of]
oJgm0`0000?oo`00ool0:Ooo000Hool3000]ool30005[O`00`00[Ob]o0020002[O`00`00[Ob]o004
[O`01000[O`000000jgl00<00:gl[O`00jgl0`001KGl00<00;Gl]O`00P000[Gl00<00;Gl]O`01KGl
0P001;Gl00<00;Gl]O`00[Gl0P0000>eo000]O`01;Gl00<00;Gl]O`00P000[Gl00<00;Gl]O`01;Gl
0`001KGl00<00;Gl]O`00P000[Gl00<00;Gl]O`01;Gl0P001;Gl00<00;Gl]O`00[Gl0P0000>eo000
]O`01[Gl0P001;Gl00@00;Gl]Obeo0<00003]O`00;Gl00Beo004002eo0000003]O`00`00]Obeo002
]O`200000kGl002en`04]O/01000]O/000000kGk00<00;Gk]O/00[Gk0P000[Gk00<00;Gk]O/01;Gk
0P001;Gk00<00;Gk]O/00[Gk0P0000>ef`00]M/01KGK00<00;GK]M/01;GK00@00;gK000000>ef`03
002mfkgK00:mf`800003_M/00;gK00Fmf`03002mfkgK00Bmf`04002mf`000003_M/00`00_M^mf`02
_M/200000kgK002mf`05_M/00`00_M^mf`04_M/01000_MX000000kgK00@00;gJ_MZmfP8000:mfP04
002mf[gJ_MX200000kgJ0035fP05aMX00`00aM[5fP05aMX00`00aM[5fP04aMX00`00aMX00005aMX0
0`00aMX00004aMX00`00aMT00005aMT00`00cMT00004aMT00`00cMT00005cMT00`00cMT00005cMT0
0`00cMS=f005cMP00`00eMSEf002eMP01000cMS=f0001=GG00H00=GHeMP00=GG0005eML00`00gKKM
]P03gKH01000eKOE]`000]ff00@00=ffgKKM]P8000?U]@8000?M]@03003U]>Fd00;U]005003U]>Fd
iK@00004kI<01@00iI?UTnFC00000oF@00H00>fAkI7]T@00kI820003kG401P00mI3eT000kI4000;4
T`06003U<^Db003]L@000_F@00@009^DVi@000;4T`05003U<^Db003]L@030002Vi@00`00[Of]o@02
[Od40003[Od2000Zool001Ooo`8002goo`8000:]o003002]o:gl00B]o08000F]o003002]o:gl00>]
o08000J]o003002]o:gl008000:]o003002eo;Gl00>eo0<000Feo003002eo;Gl00:eo0800003]O`0
0;Gl00Beo004002eo0000003]O`00`00]Obeo003]O`30005]O`20002]O`20002]O`00`00]Obeo004
]O`20004]O`00`00]Obeo002]O`200000kGl002eo004]O`01000]O`000001;Gl00<00;Gl]O`00[Gl
0P0000>eo000]O`01;Gl10000kGl00<00;Gl]O`00kGl0P001[Gl00@00;Gl000000>eo003002enkGk
00>en`8000Jen`04002en`000004]O/00`00]O^en`02]O/200000kGk002en`04]O/01000]O/00000
0kGK00<00;GK]M/00[GK0P0000>ef`00]M/01KGK00<00;GK]M/01;GK00@00;gK000000>mf`03002m
fkgK00:mf`800003_M/00;gK00Fmf`03002mfkgK00Bmf`04002mf`000003_M/00`00_M^mf`02_M/2
00000kgK002mf`05_M/00`00_M^mf`04_M/00`00_MX00004_MX01000_MX000001;gJ00@00<GJaM[5
fP800003_MX00<GJ00C5fP030035fP0000K5fP030035f/GJ00G5fP030035f/GJ00C5fP030035fLGI
00G5f@030035fLGI00C5f@03003=fLgI00G=f@03003=fLgI00?=f@03003=f@0000G=f08000CEf005
003=f<gHcMP00002eML00`00eMSEf002eMP20004eML00`00eKL00004gKH01P00eKOE]`00gKH000CM
]P03003M]P0000;U]@8000?M]@03003U]>Fd00;U]005003U]>FdiK@00004kI<01@00iI?UTnFC0000
0oF@00H00>fAkI7]T@00kI820003kG401000mI3eT0000^fA00<00<BC00000^Db00<00>ea00000_F@
00<009^D00000lBC00H00>DbiC800>ea0005Vi@01000[Od000000Zgm00<00:gm[Od00Zgm0`00:Ooo
000Gool00`00ooooo`0Yool30004[O`00`00[Ob]o002[O`200000jgl002]o005[O`00`00[Ob]o002
0002[O`00`00[Ob]o003[O`30005[O`00`00]Obeo0020002[O`00`00]Obeo004]O`01000]O`00000
0kGl00<00;Gl]O`00kGl0P001[Gl00<00;Gl]O`00P000[Gl00<00;Gl]O`01;Gl0`001;Gl00<00;Gl
]O`00[Gl0P0000>eo000]O`01;Gl00@00;Gl000000>eo003002eo;Gl00>eo08000Neo004002eo000
0003]O`01000]Obeo;Gl10001[Gl00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl0P001[Gl00<00;Gk
]O/00P000[Gk00<00;Gk]O/00kGk0P001kGk00@00;Gk000000>en`03002enkGk00>en`8000Jef`04
002ef`000003]M/00`00]M^ef`02]M/200000kGK002ef`05]M/00`00_M^mf`04_M/01000_M/00000
0kgK00<00;gK_M/00[gK0P0000>mf`00_M/01KgK00<00;gK_M/01;gK00@00;gK000000>mf`03002m
fkgK00:mf`<000Jmf`8000JmfP03002mf[gJ00BmfP040035fP000003_MX01000aM[5f/GJ0P000/GJ
00<00<GJaMX00/GJ0`001LGJ0`001LGJ00<00<GJ00001LGI0P001LGI00<00<GI00001LgI0P001<gI
00@00<gIcMT000C=f004003=f<gH0002eMP00`00cMS=f002cMP00`00eML00005eMP00`00eMOEe`03
eML00`00eKL00003gKH00`00eKOE]`02eKL20003gKH01000gKKM]P000^Fe0P000mfe0P000^Fd00<0
0>FdiK@00^Fd00D00>fCkI?]T`0000?UT`03003UU00000;eT005003]TNfAkI400002kI801@00kG7]
LNea00000_F@00H00>fAkI400<BC0002iC800`00kG400002mI000`00Vi@00003a9<01P00iC;U<P00
kG4000FKU08000B]o@03002]oJgm008000:]o@03003ooooo02Ooo`005ooo00<00?ooool09ooo0P00
0Zgl00<00:gl[O`00jgl00@00:gl000000B]o003002]o:gl00>]o0<000F]o003002]o:gl008000:]
o003002]o:gl00B]o08000F]o003002eo;Gl00>eo08000Jeo003002eo;Gl008000:eo003002eo;Gl
00>eo0<000Feo08000:eo08000:eo003002eo;Gl00>eo004002eo0000003]O`00`00]Obeo003]O`2
0006]O`00`00]Obeo0020002]O`00`00]Obeo004]O`20006]O`50002]O`00`00]Obeo003]O`30005
]O`00`00]Obeo0020002]O`00`00]Obeo004]O`20005]O/00`00]O^en`020002]O/00`00]O^en`04
]O/20006]O/00`00]O^en`020002]M/00`00]M^ef`03]M/20006]M/01000]M/000000kGK00<00;GK
]M/00[GK0P0000>ef`00_M/01KgK00<00;gK_M/01;gK00@00;gK000000>mf`03002mfkgK00:mf`80
0003_M/00;gK00Fmf`03002mfkgK00Bmf`04002mf`000003_M/01000_M^mfkgK0P0000>mf`00_MX0
1;gJ00<00;gJ00001[gJ00<00;gJ_MX01;gJ00<00<GJ00001LGJ00@00<GJ000000?5fP050035f/GJ
aMX00003aMX00`00aM[5fP020002aMX01000aMW5fLGI0P000/GI00<00<GIaMT00P000/GI00@00<gI
cMW=f@8000;=f@04003=fLgI0004cMT01000cMS=f0000lgH00<00=GH00001/gH00<00=GHeMP00mGH
00<00=GH00000mGG00L00=FgeKOE]`00gKH00005eKL00`00gKKM]P02gKH01P00gKKM]P00iKD000;M
]@05003M]@00gKH00002iK@01`00iKCU]>Fd003U]@0000;]T`07003UTnFCiI<00>FD00000_F@00@0
0>fAkI4000?]TP05003]LNeakG400002mI001P00kI7]T@00a9<000;U<P03003]L@0000?eT08000?4
T`05003U<^Db003]L@020004Vi@20004[Od30004[Od2000Xool001Ooo`03003ooooo02Coo`<000F]
o003002]o:gl00:]o08000N]o003002]o:gl008000:]o003002]o:gl00>]o0<000B]o003002]o:gl
00:]o0800003[O`00:gl00F]o003002eo;Gl008000:eo003002eo;Gl00>eo0<000Feo003002eo;Gl
008000:eo003002eo;Gl00Feo08000Beo003002eo;Gl00>eo08000Jeo003002eo;Gl008000:eo003
002eo;Gl00>eo0<000Feo003002eo;Gl00<000:eo003002eo;Gl00<00003]O`0000000Feo003002e
o;Gl008000:eo003002eo;Gl00Beo08000Beo003002eo;Gl00:eo0800003]O`00;Gk00Fen`8000Be
n`03002enkGk00:en`8000:en`03002enkGk00Ben`8000Fef`03002efkGK008000:ef`03002efkGK
00>ef`8000Jef`04002ef`000003]M/00`00_M^mf`02_M/200000kgK002mf`05_M/00`00_M^mf`04
_M/01000_M/000000kgK00<00;gK_M/00[gK0P0000>mf`00_M/01KgK00<00;gK_M/00kgK00@00;gK
000000Bmf`03002mf[gJ008000:mfP03002mf[gJ00:mfP800003_MX00;gJ00FmfP030035f/GJ00G5
fP030035f/GJ00?5fP040035fP000004aMX00`00aMX00005aMX00`00aMT00004aMT00`00aMT00005
aMT00`00cMT00004cMT00`00cMT00005cMT00`00cMP00005cMP00`00cMS=f004cMP20004eMP01000
eMSEf0000mGG00L00=FgeKOE]`00gKH00004eKL20003gKH00`00gKKM]P02gKH20003gKD20002gKH0
0`00iK@00003iK@00`00iKD00002kI<01@00iI?UTnFC00000^FD0P000nfA00D00>fBkI;]TP0000?]
L@04003eT?F@0002kI420003iC800`00kG400003mI000`00a9?4T`02a9<01@00iC;U<P00kG400P00
19^D0P000Zgm0P000Zgm00<00:gm[Od00Zgm0`009ooo000Gool00`00ooooo`0Rool20002[O`00`00
[Ob]o004[O`01000[O`000000Zgl00<00:gl[O`01:gl0`001Jgl00<00:gl[O`00P000Zgl00<00:gl
[O`00jgl00@00:gl000000B]o003002]o:gl00>]o0<000Feo003002eo;Gl008000:eo003002eo;Gl
00Beo08000Feo003002eo;Gl00:eo0800003]O`00;Gl00Beo003002eo;Gl008000:eo003002eo;Gl
00>eo0<000Feo003002eo;Gl008000:eo003002eo;Gl00Beo08000Feo0<000:eo0800003]O`00;Gl
00Feo08000Beo003002eo;Gl00:eo0800003]O`00;Gl00Beo004002eo0000003]O`00`00]O^en`02
]O/200000kGk002en`04]O/01000]O/000001;Gk00<00;Gk]O/00[Gk0P0000>ef`00]M/01KGK0P00
1KGK00<00;GK]M/00P000[GK00<00;GK]M/01;GK00<00;GK]M/01;GK00@00;gK000000>mf`03002m
fkgK00:mf`800003_M/00;gK00Fmf`03002mfkgK00Bmf`04002mf`000003_M/00`00_M^mf`02_M/3
0006_M/00`00_M^mf`04_M/00`00_MX00005_MX01000_MX000000kgJ00<00;gJ_MX00[gJ0P0000>m
fP00aMX01<GJ0P001/GJ00<00<GJaMX01LGJ00<00<GJaMX01LGJ00<00<GIaMT01<GI00<00<GIaMT0
1LGI00<00<gIcMT01<gI00<00<gIcMT01LgI00<00<gHcMP00lgH00<00<gH00001<gH00@00<gHcMP0
00?Ef007003Ef=GHeMP00=GG00001MFg00<00=FgeKL00mFg00<00=Fg00000]ff00<00=ffgKH00]ff
00<00=fegKD00]fe00@00=ffgKKM]P8000CU]006003U]NFe003]T`000^FC00@00>FDiICUU08000?]
T@05003]T^fBkI800002kG401@00mI3eT?F@00000nfA00L00>DbiC;U<P00kG400003mI000`00a9?4
T`02a9<01@00iC;U<P00kG400P000i^D00<00<Aca7<00P001:gm00<00:gm[Od00P000Zgm00<00?oo
ool09Ooo000Gool00`00ooooo`0Pool20005[O`00`00[Ob]o003[O`20005[O`20002[O`20002[O`0
0`00[Ob]o004[O`20005[O`00`00[Ob]o002[O`20007[O`00`00[Ob]o0020002[O`00`00]Obeo003
]O`30004]O`00`00]Obeo002]O`200000kGl002eo005]O`01000]O`000000kGl00<00;Gl]O`00kGl
0`001KGl00<00;Gl]O`00P000[Gl00<00;Gl]O`01;Gl0P001;Gl00<00;Gl]O`00[Gl0P0000Beo000
]Obeo0<00003]O`00;Gl008000>eo003002eo;Gl00:eo0800003]O`00;Gl00Beo004002eo0000003
]O`00`00]Obeo003]O`20006]O`01000]O/000000kGk00<00;Gk]O/00kGk0P001kGk00@00;Gk0000
00>ef`03002efkGK00:ef`800003]M/00;GK00Fef`8000Bef`03002efkGK00:ef`800003]M/00;GK
00Fef`03002mfkgK00Bmf`04002mf`000003_M/00`00_M^mf`02_M/200000kgK002mf`05_M/00`00
_M^mf`04_M/01000_M/000000kgK00@00;gK_M^mf`800003_M/00;gK00Fmf`03002mf[gJ00FmfP03
002mf[gJ00BmfP04002mfP000003_MX01000aM[5f/GJ0P000/GJ00@00<GJaM[5fP800003aMX00<GJ
00C5fP030035fP0000G5fP8000G5f@030035f@0000G5f@8000G=f@03003=f@0000G=f@8000C=f004
003=f<gH0004cMP01000cMS=f0000]GH00<00=GHeMP00]GH00<00=GG00001=Fg0P001=Fg00H00=Fg
eKL00=ff0005gKH20003gKD20003gKH01@00iKCU]>Fd00000nFe0P000nFC00<00>FDiI@00^FD00D0
0>fAkI7]T@0000?]TP800003kG400?F@00;eT005003]TNfAkI400003iC800`00kG400003mI000`00
a9?4T`02a9<00`00iC800002kG420003Vi@00`00a7?4L`020003[Od40004[Od2000Vool001Koo`03
003ooooo01ooo`800003[O`00:gl00F]o003002]o:gl008000:]o003002]o:gl00>]o0<000B]o003
002]o:gl00:]o0800003[O`00:gl00F]o004002]o0000002[O`00`00[Ob]o004[O`30005[O`00`00
]Obeo0020002]O`00`00]Obeo003]O`01000]O`000001;Gl00<00;Gl]O`00kGl0P001[Gl00<00;Gl
]O`00P000[Gl00<00;Gl]O`00kGl0`001;Gl00<00;Gl]O`00[Gl0P0000>eo000]O`01;Gl00@00;Gl
000000>eo0<000Beo08000Jeo004002eo0000003]O`00`00]Obeo003]O`20006]O`00`00]Obeo002
0002]O`00`00]Obeo003]O`20006]O/00`00]O^en`020002]O/00`00]O^en`04]O/20006]M/01000
]M/000000kGK00<00;GK]M/00[GK0P0000>ef`00]M/01;GK00@00;GK000000>ef`03002efkGK00:e
f`800003]M/00;gK00Fmf`03002mfkgK00Bmf`04002mf`000003_M/00`00_M^mf`02_M/30006_M/2
0005_M/01000_M/000000kgK00<00;gK_M/00[gK0P0000>mf`00_MX01;gJ00<00;gJ00001[gJ00<0
0;gJ_MX01;gJ00<00<GJ00001<GJ00@00<GJ000000?5fP040035f/GJaMX20002aMX01000aM[5f/GJ
0P000/GJ00<00<GIaMT00P000/GI00<00<GIaMT00/GI00@00<GIaMT000?=f@04003=fLgI0004cMT0
1000cMW=f@000/gH00<00<gHcMP00/gH00@00<gHcMP000C=f08000KEf003003E]mFg00;E]`04003E
]mFg0002eKL00`00eKOE]`02eKL20004gKH00`00gKH00002gKD01@00gKKM]P00gKH00P000nFd00<0
0>FeiKD00^Fe00D00>FCiI?UT`0000CUU004003]TNfA0003kI801@00iI<00>ea00000oF@00D00>fA
kI7]T@0000?U<P03003]L@0000?eT0030034TlBC00;4T`03003U<P0000;]L@8000>KU0050034LlAc
003U<@030003[Od00`00[Of]o@02[Od3000Uool001Koo`03003ooooo01goo`8000B]o003002]o:gl
00>]o0<000F]o003002]o:gl008000:]o003002]o:gl00>]o004002]o0000004[O`00`00[Ob]o003
[O`20005[O`20002[O`20002[O`00`00[Ob]o004[O`20004]O`00`00]Obeo003]O`20007]O`00`00
]Obeo0020002]O`00`00]Obeo003]O`30005]O`00`00]Obeo0020002]O`00`00]Obeo003]O`01000
]O`000000kGl00<00;Gl]O`00kGl0P000[Gl0`000[Gl00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl
0P001[Gl00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl0`001KGl00<00;Gl]O`00P000[Gl00<00;Gk
]O/01;Gk0P001KGk00<00;Gk]O/00`000[GK00<00;GK]M/00kGK0P001[GK00@00;GK000000>ef`03
002efkGK00>ef`8000Jef`04002ef`000003]M/00`00_M^mf`02_M/30006_M/20006_M/01000_M/0
00000kgK00@00;gK_M^mf`800003_M/00;gK00Fmf`03002mfkgK00Bmf`04002mf`000003_M/01000
_MZmf[gJ0P000[gJ00<00;gJ_MX00[gJ0P0000>mfP00_MX01KgJ00<00<GJaMX01<GJ00<00<GJaMX0
1<GJ00<00<GJ00001LGJ00<00<GJ00001<GJ00<00<GI00001LGI00@00<GIaMT000?5f@04003=fLgI
0004cMT01000cMW=f@000lgI00<00<gH00001LgH00<00<gH00001LgH00<00=GHeMP01=GH0P001=Fg
00H00=FgeKL00=Fg0005eKL00`00gKKM]P03gKH01P00gKKM]P00gKD000?M]P800004gKH00>Fd0005
iKD01@00iI?UTnFC00001>FD00@00>fAkI4000?]TP05003UT`00kG400002mI000`00kI7]T@02kI40
1`00iC;U<^Db003]L@0000?eT08000;4T`04003U<^Db0002kG420003Vi@01@00a7?4L`00iC400P00
1:gm00<00:gm[Od00P000Zgm00<00?ooool08ooo000Fool3000Kool20007[O`00`00[Ob]o0020002
[O`00`00[Ob]o003[O`30004[O`00`00[Ob]o003[O`20007[O`00`00[Ob]o0020002[O`00`00[Ob]
o003[O`30004[O`00`00[Ob]o002[O`200000jgl002eo004]O`00`00]Obeo0020002]O`00`00]Obe
o004]O`30005]O`00`00]Obeo0020002]O`00`00]Obeo004]O`20004]O`00`00]Obeo003]O`20006
]O`00`00]Obeo00200001;Gl000000001KGl0`001KGl00<00;Gl]O`00P000[Gl00<00;Gl]O`01;Gl
0P001KGl00<00;Gl]O`00P000[Gl00<00;Gl]O`01;Gl0P001;Gl00<00;Gk]O/00[Gk0P0000>en`00
]O/01KGk0P001KGK00<00;GK]M/00`0000>ef`00]M/01KGK0P001[GK00<00;GK]M/00P000[GK00<0
0;GK]M/00kGK0P001[GK00@00;gK000000>ef`04002mfkgK_M/200000kgK002mf`05_M/20005_M/0
1000_M/000001;gK00@00;gK_M^mf`800003_M/00;gK00Fmf`03002mfkgK00Bmf`03002mfP0000Fm
fP04002mfP000003_MX00`00_MZmfP02_MX30005aMX00`00_MX00006aMX00`00aM[5fP05aMX00`00
aM[5fP04aMX00`00aMW5f@04aMT00`00aMT00005aMT20005cMT00`00cMT00005cMT00`00cMS=f005
cMP00`00cMS=f003cMP00`00cMP00004eMP01000eMSEf0000]Fg00<00=FgeKL00]Fg0P001=Fg00<0
0=Fg00000mff00@00=ffgKKM]P8000CM]P06003M]]ff003U]0001>Fe00D00=fe003UT`0000CUU005
003UU000kI400003kI800`00iI?UT`020002mI000`00kI7]T@02kI4200001NDb003]LNea00000oF@
0P000/BC00@00>DbiC8000;]L@03003eL00000:KU0050034LlAc003U<@020003[Od40004[Od2000T
ool001Koo`03003ooooo01Woo`8000:]o003002]o:gl00B]o0<000F]o003002]o:gl008000:]o003
002]o:gl00>]o003002]o:gl008000:]o003002]o:gl00B]o0<000F]o003002]o:gl008000:]o003
002]o:gl00>]o004002]o0000003[O`00`00]Obeo003]O`30005]O`20002]O`20002]O`00`00]Obe
o004]O`20004]O`00`00]Obeo002]O`200000kGl002eo004]O`00`00]Obeo0020002]O`00`00]Obe
o003]O`300000kGl00000002]O`20002]O`20002]O`00`00]Obeo004]O`20004]O`00`00]Obeo002
]O`200000kGl002eo005]O`20004]O`00`00]Obeo002]O`200000kGl002eo004]O`01000]O/00000
0kGk00<00;Gk]O/00[Gk0P0000>ef`00]M/01KGK0P001KGK00@00;GK]M^ef`800003]M/00;GK00Fe
f`<000Fef`03002efkGK00800003]M/00;GK00Fef`8000Fef`04002mf`000004_M/01000_M^mfkgK
0P0000>mf`00_M/01KgK00<00;gK_M/01;gK00@00;gK000000>mf`03002mfkgK00:mf`800003_M/0
0;gK00Fmf`03002mf[gJ00FmfP03002mf[gJ00BmfP04002mfP000003_MX00`00aM[5fP020002_MX0
0`00aM[5fP02aMX200000lGJ0035fP04aMX20005aMX00`00aMX00006aMT00`00aMW5f@04aMT00`00
cMW=f@05cMT00`00cMW=f@03cMT00`00cMT00005cMP20004cMP01000cMS=f0000mGH00L00=GHeMSE
f000eKL00005eKL00`00eKOE]`03eKL00`00eKL00003gKH00`00gKKM]P02gKH00`00gKKM]P02gKH2
00001=ff003U]0001>Fe00D00=fe003UT`0000CUU005003UU000kI400003kI800`00iI?UT`020002
mI000`00kI7]T@02kI4200001NDb003]LNea00000oF@0P000/BC00@00>DbiC8000;]L@05003eL000
Vi@00003a7<01000iC400>e@0`000i]d00<00:gm[Od00Zgm0`008ooo000Fool00`00ooooo`0Gool2
0005[O`20002[O`20002[O`00`00[Ob]o004[O`20005[O`00`00[Ob]o002[O`30005[O`20002[O`2
0002[O`00`00[Ob]o004[O`20004[O`00`00[Ob]o003[O`20006[O`00`00]Obeo0020002[O`00`00
]Obeo004]O`30004]O`00`00]Obeo002]O`200000kGl002eo004]O`01000]O`000000kGl00<00;Gl
]O`00kGl0`001KGl00<00;Gl]O`00P0000Beo000000000Feo0<000Beo003002eo;Gl00:eo0800003
]O`00;Gl00Beo004002eo0000003]O`00`00]Obeo002]O`200000kGl002eo004]O`01000]O`00000
0kGl00<00;Gl]O`00kGl0P001[Gk00@00;Gk000000>ef`03002efkGK00:ef`800003]M/00;GK00Be
f`04002ef`000004]M/01000]M^efkGK0P0000>ef`00]M/01KGK0`001;GK00@00;GK]M^ef`800003
]M/00;GK00Fef`03002mfkgK00Bmf`04002mf`000004_M/01000_M^mfkgK0P0000>mf`00_M/01KgK
00<00;gK_M/01;gK00@00;gK000000>mf`03002mfkgK00:mf`800003_M/00;gJ00BmfP8000JmfP80
00FmfP030035fP0000FmfP040035fP000003aMX01000aM[5f/GJ0P000/GJ00<00<GJaMX00P000/GJ
00<00<GIaMT00lGI0P001LGI00<00<GI00001LgI0P001<gI00@00<gIcMT000C=f004003=fLgI0002
cMP00`00cMS=f002cMP00`00eMP00005eMP00`00eKOE]`03eKL00`00eKL00003eKL01`00eKOE]mFg
003M]P0000CM]P8000?M]P06003M]]ff003M]P001>Fe00H00=fegKD00>FC0004iI@01@00iI@00>fA
00000nfB00D00>FCiI?UT`0000;eT009003]TNfAkI400>fB003U<P0000;]L@04003eT?F@mI020002
a9<01000iC;U<P000^ea00D00?E`002KU00000?4L`05003U<@00kE000005Vg@00`00[Of]o@020002
[Od00`00ooooo`0Qool001Koo`03003ooooo01Goo`8000:]o003002]o:gl00>]o0<000B]o003002]
o:gl00:]o0800003[O`00:gl00F]o004002]o0000002[O`00`00[Ob]o004[O`30004[O`00`00[Ob]
o002[O`200000jgl002]o004[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30005[O`20002]O`2
0002]O`00`00]Obeo003]O`01000]O`000000kGl00<00;Gl]O`00kGl0P001[Gl00<00;Gl]O`00P00
0[Gl00<00;Gl]O`00kGl1P000[Gl0P000[Gl0P000[Gl00<00;Gl]O`00kGl00@00;Gl000000>eo003
002eo;Gl00>eo08000Jeo004002eo0000003]O`00`00]Obeo003]O`20006]O`00`00]Obeo0020002
]O`00`00]O^en`03]O/20006]M/01000]M/000000kGK00<00;GK]M/00kGK0P001[GK00@00;GK0000
00Bef`04002efkGK]M/200000kGK002ef`04]M/01000]M/000001;GK00@00;GK]M^ef`800003]M/0
0;gK00Fmf`03002mfkgK00Bmf`04002mf`000003_M/00`00_M^mf`02_M/200000kgK002mf`05_M/0
0`00_M^mf`04_M/01000_M/000000kgK00@00;gJ_MZmfP8000:mfP04002mf[gJ_MX200000kgJ002m
fP05_MX00`00_MZmfP05_MX00`00aM[5fP04aMX00`00aMX00004aMX00`00aMX00005aMX00`00aMW5
f@020002aMX00`00aMW5f@020002aMT01000cMW=fLgI0P000/GI00@00<gIcMT000C=f@04003=f<gH
0003cMT00`00cMP00006cMP00`00eMSEf003eMP20004eKL01000eKOE]`000mFg00L00=FgeKOE]`00
gKH00004gKH00`00eKL00002gKH01000gKKM]]ff0P001>Fe00D00=fegKGM]@0000CUU003003UU>FD
008000C]TP05003UTnFCiI<00002mI001@00kI7]TNfA00000^fB0P000^ea00@00?F@mI3eT08000;4
T`04003U<^Db0002kG401@00mG0009^D00000/Ac00H00>DaiC400>e@0006Vg@20004[Od2000Rool0
01Goo`03003ooooo01?oo`<000F]o003002]o:gl008000:]o003002]o:gl00>]o004002]o0000004
[O`00`00[Ob]o003[O`20005[O`20002[O`20002[O`00`00[Ob]o003[O`01000[O`000000jgl00<0
0:gl[O`00jgl0`001Jgl0P0000>]o00000000Zgl00<00:gl[O`01Jgl0P001;Gl00<00;Gl]O`00kGl
0P001[Gl00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl0`001KGl00<00;Gl]O`01@001kGl0P001;Gl
00<00;Gl]O`00kGl0P001[Gl00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl0P001[Gl00<00;Gl]O`0
0P000[Gl00<00;Gl]O`00kGl0`001KGl00<00;Gk]O/00P000[GK00<00;GK]M/00kGK0P001[GK00<0
0;GK]M/00P000[GK00<00;GK]M/00kGK0P001[GK00@00;GK000000Bef`03002efkGK00:ef`8000Je
f`04002ef`000003]M/00`00_M^mf`02_M/200000kgK002mf`05_M/00`00_M^mf`04_M/01000_M/0
00000kgK00<00;gK_M/00[gK0P0000>mf`00_M/01KgK00<00;gK_M/01;gK00<00;gJ00001;gJ00@0
0;gJ000000BmfP04002mf[gJ_MX200000kgJ002mfP04_MX00`00_MX00006aMX00`00aM[5fP04aMX0
0`00aM[5fP04aMX00`00aMT00004aMX00`00aMT00005aMT00`00cMT00004aMT00`00cMT00005cMT0
0`00cMP00005cMT00`00cMS=f004cMP20004eMP01000cMS=f0000mFg00L00=FgeKOE]`00eKL00005
eKL00`00gKKM]P02gKH01P00eKOE]`00gKH000CM]P8000?U]@03003M]Mfe00;M]@03003UU>FD00;U
U005003UU>FDiI@00003kI800`00iI?UT`02iI<01000mI3eT0000nfA00<00>fBkI800P000^ea00@0
0?F@mI0000;]T@030034T`0000;U<P08003]LNea003eL000Vi@000;4L`05003U<NDa003]D0020005
Vg@20003[Od4000Qool001Goo`03003ooooo017oo`8000:]o003002]o:gl00>]o0<000F]o003002]
o:gl00:]o08000N]o003002]o:gl008000:]o003002]o:gl00>]o0<000B]o003002]o:gl00>]o080
00J]o003002]o:gl008000:]o003002]o:gl00B]o08000F]o003002]o:gl00:]o0800003[O`00;Gl
00Beo003002eo;Gl008000:eo003002eo;Gl00>eo0<000Feo003002eo;Gl008000:eo003002eo;Gl
00Beo0@000>eo003002eo;Gl00:eo0800003]O`00;Gl00Beo003002eo;Gl008000:eo003002eo;Gl
00>eo0<000Feo003002eo;Gl008000:eo003002eo;Gl00>eo0<000Feo003002eo;Gl008000:eo003
002eo;Gl00Beo08000Fef`03002efkGK008000:ef`03002efkGK00Bef`8000Fef`03002efkGK0080
00:ef`03002efkGK00Bef`03002efkGK00Bef`03002efkGK008000:ef`03002efkGK00>ef`8000Je
f`04002mf`000003_M/00`00_M^mf`02_M/200000kgK002mf`05_M/00`00_M^mf`04_M/01000_M/0
00000kgK00<00;gK_M/00[gK0P0000>mf`00_M/01KgK00<00;gJ_MX01;gJ00<00;gJ_MX01;gJ00@0
0;gJ000000>mfP04002mf[gJ_MX20002_MX00`00aM[5fP02aMX30005aMX00`00aMX00006aMX00`00
aM[5fP04aMX00`00aMW5f@05aMT00`00aMW5f@04aMT00`00cMW=f@05cMT00`00cMW=f@03cMT00`00
cMT00004cMP01000cMS=f0000mGH00@00<gHcMP000;E]`03003E]mFg00;E]`03003E]`0000CE]`80
00CM]P04003E]mFgeKL20004gKH30002iKD00`00gKGM]@02gKD00`00iICUU002iI@01@00iICUU>FD
00000nfB00@00>FCiI?UT`8000;eT005003]TNfAkI400002kI820002kG401000mI3eT0000^fA00<0
0<BC00000^Db00P00>eakG400?E`002KU0000/Ac00D00>DaiC400>e@008000FKM0030034L`000080
00>]o@03003ooooo01ooo`005Ooo00<00?ooool03_oo0`001Jgl00<00:gl[O`00P000Zgl00<00:gl
[O`01:gl00@00:gl000000:]o003002]o:gl00B]o0<000F]o003002]o:gl008000:]o003002]o:gl
00>]o003002]o:gl008000:]o003002]o:gl00>]o0<000F]o08000:]o08000:]o003002]o:gl00>]
o004002]o0000003[O`00`00]Obeo003]O`30005]O`00`00]Obeo0020002]O`00`00]Obeo004]O`2
0005]O`01000]Obeo;Gl10001[Gl00@00;Gl000000>eo003002eo;Gl00>eo0<000Feo003002eo;Gl
008000:eo003002eo;Gl00>eo0<000Feo003002eo;Gl008000:eo003002eo;Gl00Beo08000Beo003
002eo;Gl00:eo0800003]M`00;GK00Fef`8000Bef`03002efkGK00:ef`800003]M/00;GK00Fef`80
00Bef`03002efkGK00:ef`800003]M/00;GK00Fef`8000Fef`03002efkGK008000:ef`03002efkGK
00>ef`8000Jmf`04002mf`000003_M/00`00_M^mf`02_M/200000kgK002mf`05_M/00`00_M^mf`04
_M/01000_M/000000kgK00<00;gK_M/00[gK0`001KgJ00<00;gK00001[gJ00<00;gJ_MX01;gJ00<0
0;gJ00001KgJ00@00<GJ000000?5fP030035f/GJ008000;5fP030035f/GJ00;5fP<000G5fP030035
fP0000G5f@8000G5f@030035f@0000G=f@8000C=f@04003=fLgI0004cMP01000cMS=f0000]GH00<0
0<gHcMP00/gH0P001]Fg00<00=FgeKL00]Fg00@00=FgeKL000;M]P03003E]mFg00;E]`03003M]]ff
00?M]P05003M]P00iKD00004gKD00`00gKD00002iI@00`00iICUU002iI@01@00kI;]T^fB00000nFC
00D00>FD003eT00000?]T@05003]T^fBkI800002kG401000mI3eT0000^fA00<00<BC00000^Db00@0
0>eakG4000;eL0050034LlAca7<00002iC401000kE00000019]d00<00<Aca7<00P001:gm0`007ooo
000Eool00`00ooooo`0<ool20002[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o003[O`20005[O`2
0002[O`20002[O`00`00[Ob]o004[O`20004[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002
[O`00`00[Ob]o005[O`20004[O`00`00[Ob]o003[O`20006[O`00`00]Obeo0020002[O`00`00]Obe
o003]O`30004]O`00`00]Obeo002]O`200000kGl002eo005]O`30004]O`00`00]Obeo003]O`20006
]O`00`00]Obeo0020002]O`00`00]Obeo003]O`30005]O`00`00]Obeo0020002]O`00`00]Obeo004
]O`20004]O`00`00]Obeo002]O`200000kGl002eo004]O`01000]O`000000kGL00<00;GK]M/00[GK
0P0000>ef`00]M/01;GK00@00;GK000000>ef`03002efkGK00:ef`800003]M/00;GK00Bef`04002e
f`000003]M/00`00]M^ef`02]M/200000kGK002ef`05]M/20005]M/00`00]M^ef`020002]M/00`00
_M^mf`03_M/20006_M/01000_M/000000kgK00<00;gK_M/00[gK0P0000>mf`00_M/01KgK00<00;gK
_M/01;gK00@00;gK000000>mf`03002mf[gJ008000:mf`03002mf[gJ00:mfP800003_MX00;gJ00Fm
fP03002mf[gJ00FmfP030035f/GJ00?5fP030035fP0000G5fP040035fP000003aMX00`00aM[5fP02
0002aMX01000aMW5fLGI0P000/GI00<00<GIaMT00P000/GI00@00<gIcMW=f@8000;=f@04003=fLgI
0004cMT01000cMS=f0001<gH0P001LgH00<00=FgeKL01=Fg0P001=Fg00H00=FgeKL00=ff0005eKL0
0`00gKKM]P02gKH01P00gKKM]P00iKD000CM]@03003M]@0000;UU007003UU>FDiI@00>FE00000^fB
00H00>FCiI?UT`00iI@20004kI401@00kI;]T^fB00000^ea00@00?F@mI0000;]T@8000?U<P04003]
LNea0002mG001@00a7?4LlAc00000^Da00@00>e@000000BKM0030034LlAc008000>]o@@001ooo`00
5Ooo00@00?ooool000Soo`<000F]o0800003[O`0000000:]o003002]o:gl00B]o003002]o:gl0080
00:]o003002]o:gl00>]o0<000B]o003002]o:gl00:]o0800003[O`00:gl00B]o003002]o:gl0080
00:]o003002]o:gl00>]o0<000F]o003002]o:gl00:]o0800003[O`00:gl00B]o003002]o:gl0080
00:]o003002]o:gl00>]o0<000F]o003002eo;Gl008000:eo003002eo;Gl00>eo004002eo0000004
]O`00`00]Obeo0050006]O`00`00]Obeo0020002]O`00`00]Obeo003]O`30005]O`00`00]Obeo002
0002]O`00`00]Obeo004]O`20004]O`00`00]Obeo002]O`200000kGl002eo004]O`01000]O`00000
0kGl00<00;Gl]O`00kGl0P001[GL00@00;GK000000>ef`03002efkGK00>ef`8000Jef`04002ef`00
0003]M/00`00]M^ef`03]M/20006]M/01000]M/000000kGK00<00;GK]M/00[GK0P0000>ef`00]M/0
1KGK0P001KGK00<00;gK_M/00P000[GK00<00;gK_M/01;gK00<00;gK_M/01;gK00@00;gK000000>m
f`03002mfkgK00:mf`<000Jmf`8000Fmf`03002mfP0000Fmf`04002mfP000003_MX00`00_MZmfP02
_MX30005_MX30006aMX00`00aM[5fP05aMX00`00aM[5fP03aMX00`00aMX00005aMX00`00aMT00004
aMT00`00aMT00005aMT00`00cMT00004cMT00`00cMT00005cMT00`00cMP00005cMP00`00cMS=f003
cMP00`00cKP00004eKL01000eKSE^0000]Fg00<00=FgeKL00]Fg0P001=Fg00<00=Fg00000mff00D0
0=ffgKKM]P0000CM]@07003M]MfegKD00>FD00000nFD00<00>FE00000^fB00H00>FCiI?UT`00iI@2
0004kI401`00kI;]T^fB003]L@0000?eT005003]TNfAkI400003iC801000kG7]L@000_E`00D00<Ac
a7?4L`0000;U<@04003]D0000004Vg@01@00a7?4L`00iA400`000Zgm0P007ooo000Eool30007ool2
0002[O`00`00[Ob]o004[O`20005[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002[O`00`00
[Ob]o003[O`01000[O`000000jgl00<00:gl[O`00jgl0`001Jgl0P0000>]o00000000Zgl00<00:gl
[O`01:gl00@00:gl000000>]o003002]o:gl00>]o0<000F]o003002]o:gl008000:]o003002]o:gl
00B]o08000Beo003002eo;Gl00>eo08000Neo0800003]O`0000000:eo003002eo;Gl00>eo0<000Fe
o003002eo;Gl008000:eo003002eo;Gl00Beo08000Beo003002eo;Gl00:eo0800003]O`00;Gl00Be
o004002eo0000003]O`00`00]Obeo003]O`20006]O`00`00]Obeo0020002]M`00`00]Mbeg003]M`2
0006]M/00`00]M^ef`020002]M/00`00]M^ef`03]M/20006]M/00`00]M^ef`020002]M/00`00]M^e
f`03]M/20006]M/01000]M/000000kGK00<00;GK]M/00[GK0P0000>ef`00]M/01KGK0P001;GK00<0
0;gK_M/00[gK0P0000>mf`00_M/01KgK00<00;gK_M/01;gK00@00;gK000000>mf`04002mfkgK_M/2
00000kgK002mf`05_M/00`00_M^mf`05_M/00`00_MZmfP04_MX01000_MX000000kgJ00D00;gJ_MZm
fP0000>mfP040035f/GJaMX200000lGJ0035fP04aMX20006aMX00`00aM[5fP05aMX00`00aMW5f@04
aMT00`00aMW5f@05aMT00`00cMW=f@04cMT00`00cMW=f@05cMT00`00cMS=f003cMP00`00cMP00004
cMP00`00cKP00004eKL01P00eKSE^000eKL000GE]`03003E]mFg00?E]`03003E]`0000;M]P03003M
]]ff00;M]P8000?M]@04003M]MfegKD20004iI@00`00iIGUU@020003iI<00`00iICUU0020003kI40
0`00kI;]TP02kI800`00kG400003mI001@00kI7]TNfA00000nDb00@00>eakG4000;eL0050034LlAc
a7<00002iC401@00kE000?E_00000i]d00H00<Aca7<00>DA0004[Od3000Nool001Coo`8000Koo`<0
00F]o08000:]o08000:]o003002]o:gl00>]o003002]o:gl008000:]o003002]o:gl00>]o0<000B]
o003002]o:gl00>]o08000J]o003002]o:gl008000:]o003002]o:gl00B]o08000F]o003002]o:gl
00>]o08000J]o003002]o:gl008000:]o003002]o:gl00>]o0<000B]o003002]o:gl00:]o0800003
[O`00;Gl00Beo003002eo;Gl008000:eo004002eo;Gl]O`60005]O`00`00]Obeo0020002]O`00`00
]Obeo004]O`20004]O`00`00]Obeo002]O`200000kGl002eo004]O`01000]O`000000kGl00<00;Gl
]O`00kGl0P001[Gl00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl0`001KGL00<00;GL]M`00P000[GL
00<00;GK]M/01;GK0P001KGK00<00;GK]M/00P000[GK00<00;GK]M/01;GK0P001KGK00<00;GK]M/0
0P000[GK00<00;GK]M/00kGK0P001[GK00@00;GK000000>ef`03002efkGK00:ef`800003]M/00;GK
00Bef`04002mf`000003_M/00`00_M^mf`02_M/200000kgK002mf`05_M/00`00_M^mf`03_M/01000
_M/000001;gK00@00;gK_M^mf`800003_M/00;gK00>mf`800003_M/00;gJ00FmfP03002mf[gJ00>m
fP04002mfP000004_MX01000aMX000000lGJ00@00<GJaM[5fP8000;5fP030035f/GJ00;5fP030035
fP0000G5fP8000G5f@030035f@0000G5f@8000G=f@03003=f@0000G=f@8000C=f004003=f<gH0003
cMP01@00cKS=^<fh00000]Fg00<00=FheKP00]Fh00<00=FgeKL00mFg00<00=Fg00000mFg00L00=Fg
eKOE]`00gKH00004gKH30002gKD00`00gKGM]@02gKD01@00iICUU>FD00000nFE0P000nFC00D00>FD
iICUU00000?]T@06003]T^fBkI800>FC0P000oF@00D00>fAkI7]T@0000?U<P04003]LNea0002mG00
1@00a7?4LlAc00000^Da00D00>e@003eK`0000>KM0050034LlAc003U4@0200000jgm00000002Vg<2
000Mool001Coo`03003ooooo00?oo`8000:]o003002]o:gl00F]o08000B]o003002]o:gl00>]o0<0
00F]o003002]o:gl008000:]o003002]o:gl00>]o003002]o:gl008000:]o003002]o:gl00>]o0<0
00F]o08000:]o08000:]o003002]o:gl00>]o003002]o:gl008000:]o003002]o:gl00>]o0<000F]
o003002]o:gl008000:]o003002]o:gl00>]o004002]o0000004[O`00`00]Obeo002]O`30005]O`3
00000kGl00000002]O`00`00]Obeo003]O`30004]O`00`00]Obeo002]O`200000kGl002eo004]O`0
1000]O`000000kGl00<00;Gl]O`00kGl0P001[Gl00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl0`00
1KGl00<00;Gl]O`00P000[GL00<00;GL]M`01;GL0P001;GL00<00;GK]M/00[GK0P0000>eg000]M/0
1KGK0P001;GK00<00;GK]M/00[GK0P0000>ef`00]M/01KGK0P001KGK00<00;GK]M/00P000[GK00<0
0;GK]M/01;GK00<00;GK]M/01;GK00@00;GK000000>ef`03002efkGK00>ef`8000Jmf`04002mf`00
0003_M/00`00_M^mf`02_M/30006_M/00`00_M^mf`04_M/01000_M/000001;gK00@00;gK000000>m
f`03002mf[gJ00:mfP<000JmfP03002mf[gJ00FmfP030035f/GJ00C5fP030035fP0000C5fP030035
f/GJ008000;5fP040035f/GJaMX20002aMX00`00aMW5f@020002aMT01000aMW5fLGI0P000/GI00<0
0<gIcMT00P000/gI00@00<gIcMW=f@8000;=f@04003=f<gH0004cMP00`00cMP00004cKP00`00eKL0
0004eKP20004eKL01000eKOE]`000mFg00@00=FgeKOE]`8000CM]P06003M]P00003M]@001=fe0P00
0nFD00<00>FEiID00^FE00D00>FCiI?UT`0000?UU005003]TNfAkI400003kI801000iI<000000oF@
00D00>fAkI7]T@0000?U<P03003]L@0000?eL08000;4L`08003U<NDa003]D000mFl000>KM0050034
LlAc003U4@030004Vg<2000Mool000Soo`@000Soo`04003oooooool20005[O`00`00[Ob]o002[O`2
00000jgl002]o004[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o002[O`3
0005[O`200000jgl00000002[O`00`00[Ob]o004[O`30004[O`00`00[Ob]o003[O`30005[O`00`00
[Ob]o0020002[O`00`00[Ob]o003[O`30004[O`00`00[Ob]o003[O`20007[O`01000]O`000000[Gl
00<00;Gl]O`00`0000Beo000000000Feo003002eo;Gl008000:eo003002eo;Gl00>eo004002eo000
0003]O`00`00]Obeo003]O`20006]O`00`00]Obeo0020002]O`00`00]Obeo003]O`30005]O`00`00
]Obeo0020002]O`00`00]Obeo004]O`20004]M`00`00]Mbeg002]M`200000kGL002eg004]M`01000
]M/000000kGL00<00;GK]M/00[GK0P0000>ef`00]M/01;GK00@00;GK000000>ef`03002efkGK00:e
f`800003]M/00;GK00Fef`8000Bef`03002efkGK00:ef`800003]M/00;GK00Fef`03002efkGK00Be
f`03002efkGK008000:ef`03002mfkgK00>mf`8000Jmf`04002mf`000003_M/01000_M^mfkgK0P00
00>mf`00_M/01KgK00<00;gK_M/01KgK00<00;gK_M/01;gK00@00;gJ000000>mfP04002mf[gJ_MX2
00000kgJ002mfP04_MX00`00_MX00006aMX00`00aM[5fP04aMX20005aMX00`00aMX00004aMX00`00
aMT00005aMT00`00aMT00004aMT00`00cMT00005cMT00`00cMT00004cMT00`00cMP00005cMP00`00
cMP00005cKP00`00eKSE^002eKP01000eKSE^0000mFg00L00=FgeKOE]`00eKL00005eKL00`00gKKM
]P02gKH00`00gKKM]P030004gKD01@00gKH00>FD00001NFE00@00>FCiI<000CUU005003]TNfAkI40
0003kI801000iI<000000oF@00@00>fAkI7]T@8000;U<P03003]L@0000?eL08000;4L`08003U<NDa
003]D000mFl000:KM0060034LlAca7<00>DA0P001Y]c0P007?oo0008ool00`00ooooo`09ool01000
ool000000Zgl00<00:gl[O`00jgl00@00:gl000000>]o003002]o:gl00>]o0<000F]o003002]o:gl
008000:]o003002]o:gl00B]o004002]o0000002[O`00`00[Ob]o004[O`20005[O`20002[O`20002
[O`00`00[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002
[O`00`00[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]o004[O`20004]O`30002]O`20002]O`0
0`00]Obeo004]O`20004]O`00`00]Obeo003]O`20006]O`00`00]Obeo0020002]O`00`00]Obeo003
]O`30005]O`00`00]Obeo0020002]O`00`00]Obeo004]O`20004]O`00`00]Obeo002]O`200000kGl
002eg004]M`01000]M`000000kGL00<00;GL]M`00kGL0P001[GL00@00;GK000000>ef`03002efkGK
00>ef`8000Jef`04002ef`000003]M/00`00]M^ef`02]M/200000kGK002ef`04]M/01000]M/00000
0kGK00<00;GK]M/00[GK0P0000>ef`00]M/01KGK0P001KGK00<00;gK_M/00P000[gK00<00;gK_M/0
0kgK0P001KgK00@00;gK000000>mf`03002mfkgK00:mf`800003_M/00;gK00>mf`800003_M/00;gK
00Fmf`03002mf[gJ00>mfP04002mfP000003_MX01000_MZmf[gJ0P000[gJ00<00<GJaMX00/GJ0`00
1/GJ00<00<GJaMX01LGJ00<00<GJaMX01<GJ00<00<GIaMT01LGI00<00<GIaMT01<GI00<00<gIcMT0
1LgI00<00<gIcMT01<gI00<00<gHcMP01LgH00<00<fhcKP00lfh0P001=Fh00@00=FheKP000;E]`03
003E]mFg00;E]`03003E]`0000CE]`8000?M]P04003M]]ffgKH30003gKD01P00gKKM]P00iI@000CU
U@05003MU@00iI<00003iI@00`00iI@00002kI401P00kI;]T^fB003UT`8000?eT004003]TNfAkI42
00001NDb003]LNea00000oE`0P000/Ac00H00>DaiC400>e@0002mFl00`00Vg@00003a7<01000iA40
00001Y]c0`006ooo0009ool00`00ooooo`08ool20004[O`00`00[Ob]o003[O`20006[O`00`00[Ob]
o0020002[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o003[O`20005[O`20002[O`20002[O`00`00
[Ob]o004[O`20004[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002[O`00`00[Ob]o004[O`2
0005[O`00`00[Ob]o002[O`30005[O`20002[O`20002[O`40002]O`30004]O`00`00]Obeo002]O`2
00000kGl002eo004]O`00`00]Obeo0020002]O`00`00]Obeo003]O`30005]O`00`00]Obeo0020002
]O`00`00]Obeo004]O`20004]O`00`00]Obeo002]O`200000kGl002eo004]O`01000]O`000000kGl
00<00;GL]M`00kGL0P001[GL00<00;GL]M`00P000[GL00<00;GL]M`00kGL0P001[GK00<00;GK]M/0
0P000[GK00<00;GK]M/00kGK0P001[GK00@00;GK000000>ef`03002efkGK00>ef`8000Jef`04002e
f`000003]M/00`00]M^ef`02]M/200000kGK002ef`05]M/20004_M/00`00_M^mf`030002_M/00`00
_M^mf`02_M/20006_M/01000_M/000001;gK00@00;gK000000>mf`03002mfkgK00:mf`<000JmfP03
002mf[gJ00BmfP03002mfP0000FmfP040035fP000003_MX01000aM[5f/GJ0P0000?5fP00aMX01<GJ
0P001LGJ00<00<GJ00001LGI0P001LGI00<00<GI00001LgI0P001LgI00<00<gI00001LgH0P001<fh
00@00<fhcKP000;E^003003E^=Fh00;E^08000KE]`03003E]mFg00?E]`03003E]`0000;M]P03003M
]]ff00;M]P03003M]@0000;M]@06003M]]ff003UU0001>FE00D00=fE003UT`0000?UU003003UU000
00;]T@04003]T^fB0003iI<01@00mI3eT?F@00000^fA00D00>fB003U<P0000;]L@04003eL?E`mG02
0002a7<01P00iC7U<@00kE0000;eK`03002KM00000?4L`03003U4@00008000FKL`<001_oo`002_oo
00<00?ooool01ooo0P001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001Jgl0P0000>]o000
00000Zgl00<00:gl[O`01:gl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001:gl00<00:gl[O`0
0Zgl0P0000>]o000[O`01:gl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001:gl00<00:gl[O`0
0Zgl0P0000>]o000[O`01Jgl00@00:gl000000:]o003002]o:gl00B]o0<000:]o0@000:eo08000:]
o003002eo;Gl00>eo004002eo0000003]O`00`00]Obeo003]O`30005]O`00`00]Obeo0020002]O`0
0`00]Obeo004]O`20004]O`00`00]Obeo002]O`200000kGl002eo004]O`01000]O`000000kGl00<0
0;Gl]O`00kGl0P001[Gl00<00;GL]M`00P000[GL00<00;GL]M`00kGL0`001KGL00<00;GL]M`00P00
0[GL00<00;GK]M/00kGK0`001KGK00<00;GK]M/00P000[GK00<00;GK]M/00kGK0P001[GK00<00;GK
]M/00P000[GK00<00;GK]M/00kGK0P001[GK00@00;GK000000>ef`03002efkGK00:ef`<000Jmf`80
00Fmf`03002mfkgK008000:mf`03002mfkgK00>mf`8000Nmf`03002mfkgK00Bmf`04002mf`000003
_M/01000_MZmf[gJ0P0000>mfP00_MX01KgJ00<00;gJ_MX01KgJ00<00;gJ_MX00kgJ00@00<GJ0000
00?5fP040035f/GJaMX20002aMX00`00aM[5fP020002aMX01000aMW5fLGI0P000/GI00D00<GIaMW5
f@0000;5f@03003=fLgI00;=f@040035fLGI0003cMT01000cMW=f@000lgH0P000/gH00@00<fhcKP0
00?=^003003E^00000GE^003003E]mFg00CE]`8000CE]`06003E]mFg003M]P001=ff0P0000CM]@00
gKD000CM]P03003UUNFE00;UU@06003MUMfE003UT`000nFD00<00>FDiI@00P000nfB00D00>FCiI?U
T`0000?eT008003]TNfA003]TP00iC8000;]L@04003eL?E`mG020002a7<01P00iC7U<@00kE0000;e
K`03002KM00000?4L`03003U4@00008000FKL`040034DP00000Jool000_oo`03003ooooo00Koo`03
003oo`0000B]o0<000F]o0800003[O`0000000:]o003002]o:gl00B]o08000F]o003002]o:gl00>]
o0<000F]o003002]o:gl008000:]o003002]o:gl00>]o004002]o0000003[O`00`00[Ob]o003[O`3
0005[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`01000[O`000001:gl00<00:gl[O`00jgl0P00
1Jgl0P000Zgl0P000Zgl0`001:gl0P001:gl00<00;Gl]O`00kGl0P001[Gl00<00;Gl]O`00P000[Gl
00<00;Gl]O`00kGl0`001;Gl00<00;Gl]O`00[Gl0P0000>eo000]O`01;Gl00@00;Gl000000>eo003
002eo;Gl00>eo08000Jeo003002eo;Gl008000:eo003002eo;Gl00>eo0<000Feg003002eg;GL0080
00:eg003002eg;GL00Beg08000Feg003002efkGK008000:ef`03002efkGK00Bef`8000Fef`03002e
fkGK008000:ef`03002efkGK00Bef`8000Fef`03002efkGK008000:ef`03002efkGK00>ef`8000Je
f`04002ef`000003]M/01000_M^mfkgK0P0000>ef`00_M/01KgK0P001KgK00<00;gK_M/00P000[gK
00<00;gK_M/00[gK0`001[gK0P001KgK00@00;gJ000000>mfP03002mf[gJ00:mfP800003_MX00;gJ
00BmfP8000JmfP030035f/GJ00C5fP030035fP0000C5fP030035fP0000G5fP030035f@0000C5f@04
0035fLGI0004aMT01000cMW=f@000lGI00@00<gIcMT000C=f@03003=f00000C=f003003=^00000G=
^003003E^=Fh00?E^003003=^00000CE]`04003E]mFg0002eKL00`00eKOE]`02eKL20004gKH01000
eKH00=fe0P001=ff00<00>FEiID00^FE00D00=fEgIGMU@0000?UU004003UU>FDiI@20003kI801@00
iI?UTnFC00000oF@00@00>fAkI4000;]TP8000;]L@04003eL?E`0002kG400`00a7<00002iC400`00
kE000002mFl00`00Vg@00003a7<00`00iA4000020005Vg<01000a58000006_oo0008ool01000oooo
o`001ooo00H00?ooooooo`00[O`20002[O`00`00[Ob]o004[O`20005[O`20002[O`20002[O`00`00
[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30004[O`00`00[Ob]o003[O`20006[O`0
0`00[Ob]o0020002[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o002[O`20007[O`00`00[Ob]o002
0002[O`00`00[Ob]o003[O`30002[O`30004[O`200000jgl002]o004[O`00`00]Obeo0020002]O`0
0`00]Obeo003]O`30005]O`00`00]Obeo0020002]O`00`00]Obeo003]O`01000]O`000000kGl00<0
0;Gl]O`00kGl0P001[Gl00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl0`001KGl00<00;Gl]O`00P00
0[GL00<00;GL]M`01;GL0P001;GL00<00;GL]M`00[GL0P0000>eg000]M`01KGL0P001;GK00<00;GK
]M/00[GK0P0000>ef`00]M/01KGK0P001;GK00<00;GK]M/00[GK0P0000>ef`00]M/01KGK0P001KGK
00<00;GK]M/00P000[GK00<00;GK]M/01;GK00<00;GK]M/00kGK00@00;gK000000>ef`03002mfkgK
00:mf`800003_M/00;gK00Fmf`8000Fmf`04002mf`000003_M/01000_M^mfkgK0P0000>mf`00_M/0
1KgK00<00;gJ_MX01;gJ00@00;gJ000000>mfP04002mf[gJ_MX20002_MX01000_MZmf[gJ0P0000>m
fP00aMX01LGJ00<00<GJaMX01<GJ00<00<GJaMX01LGJ00<00<GIaMT01<GI0P001LGI00<00<gI0000
1LGI0P001/gI00<00<gHcMP01<gH00<00<fhcKP00lfh00<00<fh00001=Fh00<00<fh00001=Fg00H0
0=FgeKL00=Fg0005eKL00`00gKKM]P02gKH01@00eKKE]P00gKD00P001=ff00D00>FEiIGUU@0000CM
U@05003UU>FDiI@00004iI@01@00kI;]T^fB00000nFC00D00?F@mI3eT00000;]T@03003]T^fB0080
00;]L@04003eL?E`0002kG420002iC401000kE3]D0000_E_00<009]d00000lAc00<00>DA00000P00
1I]c00<00<AB00000`006?oo0009ool20008ool30002ool00`00[Ob]o003[O`20002[O`20002[O`0
0`00[Ob]o003[O`30004[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002[O`00`00[Ob]o003
[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30005[O`200000jgl00000002[O`00`00[Ob]o004
[O`01000[O`000000Zgl00<00:gl[O`01:gl0`001Jgl00<00:gl[O`00P000Zgl0`000jgl00@00:gl
000000>]o003002]o:gl00>]o0<000Feo003002eo;Gl008000:eo003002eo;Gl00Beo08000Beo003
002eo;Gl00>eo08000Jeo003002eo;Gl008000:eo003002eo;Gl00>eo0<000Feo003002eo;Gl0080
00:eo003002eo;Gl00Beo08000Beg003002eg;GL00:eg0800003]M`00;GL00Beg004002eg0000003
]M`00`00]Mbeg002]M`200000kGL002ef`04]M/01000]M/000000kGK00<00;GK]M/00[GK0P0000>e
f`00]M/01;GK00@00;GK000000>ef`03002efkGK00:ef`800003]M/00;GK00Fef`8000Bef`03002e
fkGK00:ef`<000Jef`03002efkGK00Bef`04002mf`000003_M/00`00_M^mf`02_M/200000kgK002m
f`05_M/00`00_M^mf`03_M/01000_M/000001;gK00@00;gK_M^mf`800003_M/00;gJ00FmfP03002m
f[gJ00BmfP03002mfP0000BmfP04002mfP000003_MX00`00aM[5fP02aMX30005aMX00`00aMX00005
aMX20006aMT00`00aMW5f@05aMT00`00aMW5f@04aMT00`00cMW=f@04cMT20005cMP20004cKP01000
cKS=^0000mFh00D00<fhcKS=^00000;E]`03003E]mFg00;E]`8000CE]`8000CM]P04003E]]FfeKH3
0003gKH00`00gKH00002iID00`00gIGMU@02gID01@00iICUU>FD00001>FD00@00>fBkI8000CUT`80
0003mI000>fA00;]T@03003]T^fB008000;]L@04003eL?E`0002kG420002iC401000kE3]D0000oE_
00<00<Aca7<00/Ac00H00>DA00000?E?0003Vg<01@00a5;4DP00iA400P006?oo000Cool00`00oooo
o`03ool00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`00`00[Ob]o002
0002[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o002[O`30005[O`200000jgl00000002[O`00`00
[Ob]o004[O`20005[O`00`00[Ob]o003[O`20005[O`20002[O`20002[O`00`00[Ob]o003[O`30000
0jgl000000020005[O`20006[O`00`00[Ob]o0020002[O`00`00]Obeo003]O`30004]O`00`00]Obe
o002]O`200000kGl002eo004]O`00`00]Obeo0020002]O`00`00]Obeo003]O`30005]O`00`00]Obe
o0020002]O`00`00]Obeo004]O`20004]O`00`00]Obeo002]O`200000kGL002eg004]M`01000]M`0
00000kGL00<00;GL]M`00kGL0P001[GL00@00;GL000000>eg003002efkGK00>ef`8000Jef`04002e
f`000003]M/00`00]M^ef`03]M/20006]M/01000]M/000000kGK00<00;GK]M/00[GK0`001[GK00@0
0;GK000000>ef`04002efkGK]M/200000kGK002ef`05]M/00`00_M^mf`04_M/01000_M/000000kgK
00<00;gK_M/00[gK0`001[gK00<00;gK_M/01;gK00@00;gK000000>mf`03002mf[gJ00:mfP<000Jm
fP8000JmfP03002mf[gJ00BmfP040035fP000003aMX00`00aM[5fP020002aMX01000aM[5f/GJ0P00
0/GJ00<00<GIaMT00/GI00<00<GI00001LGI0P001LGI00<00<GI00001<gI00@00<gIcMT000?=f004
003=^Lfi0003cKP01`00cKS=^<fh003E^00000C=^003003E]`0000GE]`03003E]mFg00;E]`04003E
]mFg0002gKH00`00eKKE]P02eKH01000gKKM]P000]ff00D00=ff003UU@0000CMU@05003MU@00iI@0
0005iI@01000kI;]TP000nFC00D00>FC003eT00000?]T@05003]T^fBkI800002kG401000mG3eL000
0^ea0P000^Da00@00>e@kE0000?eK`030034LlAc00;4L`06003U4@00003eC`000i]c00D00<ABa580
0>DA008001Soo`004ooo00<00?ooool01?oo00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001:gl
00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`01:gl00@00:gl000000:]o003
002]o:gl00B]o08000F]o08000:]o08000:]o003002]o:gl00>]o003002]o:gl008000:]o003002]
o:gl00>]o0<000F]o003002]o:gl00800004[O`000000004[O`00`00[Ob]o0020002[O`00`00[Ob]
o003[O`30005[O`00`00]Obeo0020002[O`00`00]Obeo003]O`01000]O`000000kGl00<00;Gl]O`0
0kGl0`001KGl00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl0`001;Gl00<00;Gl]O`00[Gl0P0000>e
o000]O`01;Gl00@00;Gl000000>eg003002eg;GL00>eg08000Jeg003002eg;GL008000:eg003002e
g;GL00>eg08000Jeg003002efkGK008000:ef`03002efkGK00>ef`8000Jef`03002efkGK008000:e
f`03002efkGK00>ef`8000Jef`04002ef`000003]M/00`00]M^ef`03]M/20005]M/01000]M/00000
0kGK00<00;GK]M/00[GK0P0000>ef`00_M/01KgK00<00;gK_M/01;gK00@00;gK000000>mf`04002m
fkgK_M/200000kgK002mf`05_M/00`00_M^mf`04_M/01000_MX000000kgJ00@00;gJ_MZmfP800003
_MX00;gJ00BmfP03002mfP0000JmfP030035f/GJ00?5fP030035fP0000G5fP030035fP0000C5fP03
0035fLGI008000;5f@040035fLGIaMT20002aMT00`00aMW5f@020002aMT01@00cMW=fLgI00000lgI
00@00<gHcMP000?=^@04003=^<fh0004cKP00`00eKP00005cKP00`00eKOE]`03eKL20004eKL01P00
eKOE]`00gKH000GE]P04003M]]ffgKH20002gKH00`00iID00004gID01@00gID00>FD00001>FD00D0
0>FD003]TP0000?UT`05003UT`00mI000003kI401@00kI;]T^fB00000^ea00@00?E`mG0000;]L@80
00;U<@04003]D>e@0003mFl00`00a7?4L`02a7<01P00iA400000mDl000>KL`080034D/AB003U4@00
kC0001Ooo`004ooo00<00?ooool01Ooo0P001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl00<0
0:gl[O`00P000Zgl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00jgl0P001Jgl0P000Zgl0P000Zgl
00<00:gl[O`00jgl0`001:gl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`0
1:gl1@0000>]o000[O`01:gl0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001:gl00<0
0;Gl]O`00kGl0P001[Gl00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl0`001KGl00<00;Gl]O`00P00
0[Gl00<00;Gl]O`00kGl00@00;Gl000000>eo003002eo;Gl00>eo08000Jeg003002eg;GL008000:e
g003002eg;GL00>eg0<000Feg003002eg;GL008000:eg003002eg;GL00>eg0<000Fef`03002efkGK
008000:ef`03002efkGK00Bef`8000Fef`03002efkGK008000:ef`03002efkGK00Bef`03002efkGK
00>ef`03002efkGK00<000:ef`03002efkGK00:ef`8000Jef`04002ef`000003]M/00`00_M^mf`02
_M/200000kgK002mf`05_M/00`00_M^mf`03_M/01000_M/000000kgK00<00;gK_M/00[gK0P0000>m
f`00_M/01KgK00<00;gJ_MX00kgJ00@00;gJ000000BmfP03002mf[gJ008000:mfP03002mf[gJ00:m
fP<000K5fP030035f/GJ00G5fP030035f/GJ00C5fP8000G5f@030035f@0000C5f@030035f@0000G5
f@03003=f@0000G=f@8000G=^@8000K=^003003=^<fh00?=^08000CE]`04003E^=Fh0002eKL00`00
eKOE]`02eKL20004eKH00`00eKL00003gKH01@00gKKM]]ff00001=fE00H00=fEgID00>FD0004iI@0
1@00iI@00>fB00000nFC00<00>FCiI<00P000^fA00<00>fBkI800^fB00@00>eakG4000;eL005003]
LNeakG400002iC401000kE3]D0000oE_00<00<Aca7<00/Ac00H00>DA00000?E?0003Vg<01`00a5;4
DP00iA400>d`008001Koo`004ooo00<00?ooool01_oo00<00:gl[O`00jgl0`001Jgl00<00:gl[O`0
0Zgl0`001Jgl0P0000>]o00000000Zgl00<00:gl[O`01:gl00<00:gl[O`00P000Zgl00<00:gl[O`0
0jgl0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<00:gl[O`0
0jgl0`001:gl00<00:gl[O`00Zgl10001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001Jgl
00<00:gl[O`00P000Zgl00<00:gl[O`00jgl00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl0`001KGl
00<00;Gl]O`00P000[Gl00<00;Gl]O`01;Gl0P001;Gl00<00;Gl]O`00kGl0P001[Gl00<00;Gl]O`0
0P000[GL00<00;GL]M`00kGL0`001KGL00<00;GL]M`00P000[GL00<00;GL]M`00kGL0`001KGL00<0
0;GL]M`00P000[GL00<00;GK]M/01;GK0P001;GK00<00;GK]M/00[GK0P0000>ef`00]M/01KGK0P00
1;GK00<00;GK]M/00[GK0`001[GK0P001KGK00<00;GK]M/00P000[GK00<00;GK]M/00kGK0P001[GK
00@00;gK000000>mf`03002mfkgK00:mf`<000Jmf`03002mfkgK00Bmf`04002mf`000003_M/00`00
_M^mf`02_M/30006_MX00`00_MZmfP04_MX00`00_MX00005_MX01000_MX000000kgJ00@00<GJaM[5
fP800003_MX00<GJ00C5fP8000K5fP030035fLGI00G5f@030035fLGI00C5f@030035fLGI00G5f@03
003=fLgI00C=f@03003=^Lfi00C=^@03003=^<fh00C=^08000C=^004003=^<fh0003eKL01P00eKSE
^000eKL000GE]`03003E]]Ff00?E]P03003E]`0000;M]P8000?M]P03003MUMfE00;MU@05003MUMfE
gID00005iI@01000iI@000001>FC00<00>FCiI<00P000^fA00<00>fBkI800^fB0P0000G]L@00mG3e
L00000?]L@04003U<NDa0002kE001@00mFoeKoE_00000lAc00<00>DAiA400P0000?eC`00Vg<00Y]c
00L00<ABa5800>DA003]<002000Fool001;oo`03003ooooo00Soo`800003[O`0000000:]o003002]
o:gl00B]o004002]o0000002[O`00`00[Ob]o004[O`20005[O`00`00[Ob]o003[O`30005[O`00`00
[Ob]o0020002[O`00`00[Ob]o004[O`20004[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002
[O`00`00[Ob]o003[O`00`00[O`000020002[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002
[O`00`00[Ob]o004[O`20004[O`00`00[Ob]o003[O`30005]O`00`00]Obeo0020002]O`00`00]Obe
o003]O`30004]O`00`00]Obeo002]O`200000kGl002eo004]O`00`00]Obeo0020002]O`00`00]Obe
o003]O`30005]M`00`00]Mbeg0020002]M`00`00]Mbeg003]M`30005]M`00`00]Mbeg0020002]M`0
0`00]Mbeg004]M`20004]M`00`00]M^ef`02]M/200000kGK002ef`04]M/01000]M/000000kGK00<0
0;GK]M/00[GK0P0000>ef`00]M/01;GK00@00;GK000000>ef`04002efkGK]M/200000kGK002ef`05
]M/20005]M/00`00]M^ef`020002]M/00`00]M^ef`04]M/00`00_M^mf`04_M/01000_M/000000kgK
00@00;gK_M^mf`800003_M/00;gK00Fmf`03002mfkgK00Bmf`04002mf`000003_M/01000_MZmf[gJ
0P0000>mfP00_MX01KgJ00<00;gJ_MX01KgJ00<00;gJ_MX00kgJ00@00<GJ000000>mfP040035f/GJ
aMX20002aMX01000aM[5f/GJ0P0000?5fP00aMT01<GI0P001LGI00<00<GI00001LGI0P001LgI0P00
1Lfi00<00<fi00001<fh00@00<fhcKP000;=^005003=^<fhcKP00002eKL00`00eKSE^002eKP00`00
eKOE]`03eKL00`00eKL00003eKH02@00eKOE]mFg003M]P00gKH00002gKH20003gID01@00gIGMUMfE
00001>FD00D00>FDiICUU00000CUT`05003UTnFCiI<00002kI400`00kI;]TP02kI8200001Nea003e
L?E`00000nea00@00>DaiC4000;]D004003eKoE_mFl20002a7<00`00iA7U4@020002mDl01000Vg>K
L`000/AB00L00>DA003]<000ool0000Eool001;oo`03003ooooo00[oo`03002]o:gl00>]o003002]
o:gl00>]o08000F]o08000:]o08000:]o003002]o:gl00>]o003002]o:gl008000:]o003002]o:gl
00>]o0<000B]o003002]o:gl00:]o0800003[O`00:gl00B]o003002]o:gl008000:]o003002]o:gl
00>]o0<000B]o003002]o:gl00:]o0<000J]o003002]o:gl008000:]o003002]o:gl00>]o0<000B]
o003002]o:gl00:]o0800003[O`00:gl00B]o003002]o:gl008000:]o003002eo;Gl00>eo0<000Fe
o003002eo;Gl008000:eo003002eo;Gl00>eo004002eo0000003]O`00`00]Obeo003]O`30005]O`0
0`00]Obeo0020002]M`00`00]Mbeg003]M`30005]M`00`00]Mbeg0020002]M`00`00]Mbeg004]M`2
0004]M`00`00]Mbeg002]M`200000kGL002eg004]M`01000]M/000000kGK00<00;GK]M/00kGK0P00
1[GK00@00;GK000000>ef`03002efkGK00>ef`8000Fef`04002ef`000003]M/00`00]M^ef`02]M/2
00000kGK002ef`05]M/20004]M/00`00]M^ef`02]M/200000kGK002mf`05_M/00`00_M^mf`03_M/0
1000_M/000000kgK00<00;gK_M/00[gK0P0000>mf`00_M/01KgK00<00;gK_M/00kgK00@00;gJ0000
00>mfP03002mf[gJ00:mfP800003_MX00;gJ00BmfP8000JmfP03002mf[gJ00BmfP030035fP0000C5
fP040035fP000003aMX01000aMW5fLGI0P000/GJ00<00<GIaMT00P000/GI00@00<GIaMW5f@8000;5
f@03003=fLgI008000;5^@03003=^Lfi008000;=^@05003=^<fhcKP00003cKP00`00cKP00005cKP2
0004eKP00`00cKP00004eKL00`00eKL00003eKH01000eKOE]mFg0P000mff0P0000GM]P00gIGMU@00
00CMU@03003UU>FD00;UU005003UU>FDiI@00003iI<00`00iI?UT`02iI<01000kI7]T@000nfB00D0
0>Ec003]L@0000;eL005003]LNeakG400002iC401000kE3]D0000oE_0P000/Ac00P00>DAiA400>e@
003eC`000Y]c00L00<ABa5800>DA003]<00200000ooo003oo`0Cool001;oo`03003ooooo00_oo`03
002]o:gl00>]o003002]o:gl008000:]o003002]o:gl00>]o0<000B]o003002]o:gl00>]o0<000F]
o003002]o:gl008000:]o003002]o:gl00>]o004002]o0000003[O`00`00[Ob]o003[O`30005[O`0
0`00[Ob]o0020002[O`00`00[Ob]o003[O`50002[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o002
0002[O`00`00[Ob]o003[O`01000[O`000000jgl00<00:gl[O`00jgl0`001Jgl00<00;Gl]O`00P00
0Zgl00<00;Gl]O`01;Gl0P001;Gl00<00;Gl]O`00kGl0P001[Gl00<00;Gl]O`00P000[Gl00<00;Gl
]O`00kGl0`001KGL00<00;GL]M`00P000[GL00<00;GL]M`01;GL0P001;GL00<00;GL]M`00[GL0P00
00>eg000]M`01;GL00@00;GL000000>eg003002eg;GL00>eg08000Jef`03002efkGK008000:ef`03
002efkGK00>ef`8000Jef`03002efkGK008000:ef`03002efkGK00:ef`8000Jef`04002ef`000003
]M/00`00]M^ef`02]M/200000kGK002ef`04]M/01000]M/000000kGK00<00;gK_M/00[gK0`001[gK
00<00;gK_M/01;gK00@00;gK000000>mf`03002mfkgK00:mf`<000Jmf`03002mf[gJ00BmfP04002m
fP000003_MX01000_MZmf[gJ0P000[gJ00@00;gJ_MZmfP800003_MX00;gJ00FmfP030035f/GJ00C5
fP030035f/GJ00C5fP030035f@0000C5fP030035f@0000G5f@030035f@0000C5f@03003=f@0000C5
^@03003=^@0000G=^@03003=^00000G=^003003=^<fh00C=^003003E^=Fh00;E^004003=^<fh0003
eKL01`00eKOE]mFg003E]P0000GE]`03003M]]ff00;M]P06003M]]ff003MU@000mfE00<00=fE0000
0^FD00<00>FDiI@00^FD00D00>FCiI?UT`0000CUT`04003]TNfA0003kI800`00iG?UL`020002mG00
1000kG7]LNea0P0000GU<@00kE3]D00000?eK`8000;4L`08003U4NDA003]D000mDl000:KL`070034
D/AB003U4@00kC000P0000?oo`00ool04ooo000Bool00`00ooooo`0;ool00`00[Ob]o003[O`30005
[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30004
[O`00`00[Ob]o003[O`20006[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30005[O`01000[Ob]
o:gl10001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00Zgl0P001Zgl
00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001:gl00<00;Gl]O`00[Gl0P0000>eo000]O`01;Gl
00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl0`001KGl00<00;Gl]O`00P000[Gl00<00;GL]M`01;GL
0P001;GL00<00;GL]M`00[GL0P0000>eg000]M`01;GL00@00;GL000000>eg003002eg;GL00>eg080
00Jeg003002eg;GL008000:eg003002efkGK00>ef`<000Fef`03002efkGK008000:ef`03002efkGK
00>ef`<000Bef`03002efkGK008000:ef`03002efkGK00>ef`8000Jef`04002ef`000003]M/00`00
]M^ef`03]M/20006]M/01000_M/000000kGK00@00;gK_M^mf`800003_M/00;gK00Fmf`03002mfkgK
00Bmf`04002mf`000003_M/01000_M^mfkgK0P0000>mf`00_MX01KgJ00<00;gJ_MX01;gJ00<00;gJ
00001;gJ00@00;gJ000000>mfP03002mf[gJ00:mfP<000G5fP030035fP0000K5fP030035f/GJ00C5
fP030035fLGI00G5f@030035fLGI00C5f@030035^LFi00C5^@03003=^Lfi00G=^@03003=^<fh00?=
^08000G=^08000CE^007003=^<fhcKP00=Fg00001=Fg00<00=Ff00001=Fg0P000mff0P000]ff0P00
1=fE00<00=fE00000^FD00L00>FDiICUU000gID00002iI<02@00iI?UTnFC003UU000kI400003kI80
0`00iG?UL`020002mG001000kG7]LNea0P0000GU<@00kE3]D00000?eK`8000;4L`08003U4NDA003]
D000mDl000:KL`070034D/AB003U4@00kC000P0000?oo`0000004ooo000Bool00`00ooooo`0<ool0
0`00[Ob]o0020002[O`00`00[Ob]o003[O`30004[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o002
0002[O`00`00[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30005[O`200000jgl0000
0002[O`00`00[Ob]o004[O`40002[O`00`00[Ob]o003[O`30005[O`200000jgl00000002[O`00`00
[Ob]o004[O`01000[O`000000Zgl00<00:gl[O`00jgl0`001Jgl0P0000>]o00000000Zgl00<00:gl
[O`00jgl00@00;Gl000000Beo003002eo;Gl00:eo0<000Feo003002eo;Gl008000:eo003002eo;Gl
00>eo0<000Beo003002eg;GL00:eg0800003]M`00;GL00Beg004002eg0000003]M`00`00]Mbeg003
]M`20006]M`00`00]Mbeg0020002]M`00`00]Mbeg003]M`30005]M`00`00]M^ef`020002]M/00`00
]M^ef`04]M/20005]M/00`00]M^ef`0200000kGK002ef`05]M/20005]M/00`00]M^ef`020002]M/0
0`00]M^ef`04]M/00`00]M^ef`04]M/00`00]M^ef`020002]M/00`00]M^ef`03]M/20005]M/01000
_M/000000kgK00<00;gK_M/00[gK0P0000>mf`00_M/01KgK00<00;gK_M/00kgK00@00;gK000000>m
f`03002mf[gJ00:mfP800003_MX00;gJ00FmfP03002mf[gJ00BmfP03002mf[gJ00BmfP04002mfP00
0003_MX00`00aM[5fP020002aMX00`00aM[5fP02aMX30005aMX00`00aMX00005aMT20005aMT20005
aKT00`00aKT00005cKT20004cKP01000cKS=^0000lfh00@00<fhcKP000;E^003003=^<fh00;=^003
003E]`0000GE]`03003E]mFg00?E]`03003E]`0000;M]P03003M]P0000;M]P05003MUMfEgID00003
gID00`00iI@00003iI@00`00gID00002iI<02@00iI?UTnFC003UU000kI400003kI800`00iG?UL`02
0002mG001000kG7]LNea0P0000GU<@00kE3]D00000?eK`05003]L000a7<00002iA400`00kE000002
mDl00`00Vg<00002a5801000iA400>d`0`0000?oo`00ool04_oo000Bool3000=ool20005[O`20000
0jgl00000002[O`00`00[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30005[O`00`00
[Ob]o002[O`30005[O`200000jgl00000002[O`00`00[Ob]o004[O`20005[O`00`00[Ob]o0050005
[O`200000jgl00000002[O`00`00[Ob]o004[O`20005[O`00`00[Ob]o003[O`20005[O`200000jgl
00000002[O`00`00[Ob]o004[O`20005[O`00`00[Ob]o002[O`20007]O`01000]O`000000[Gl00<0
0;Gl]O`00kGl0`001KGl00<00;Gl]O`00P000[Gl00<00;Gl]O`00kGl00@00;GL000000>eg003002e
g;GL00>eg08000Jeg003002eg;GL008000:eg003002eg;GL00>eg0<000Feg003002eg;GL008000:e
g003002eg;GL00Beg08000Bef`03002efkGK00:ef`800003]M/00;GK00Fef`8000Bef`04002efkGK
]M/200000kGK002ef`05]M/20004]M/00`00]M^ef`02]M/200000kGK002ef`05]M/20005]M/00`00
]M^ef`020002]M/00`00]M^ef`02]M/20006_M/01000_M/000000kgK00<00;gK_M/00[gK0`001[gK
00<00;gK_M/01;gK00@00;gJ000000>mfP03002mf[gJ00:mfP<000FmfP03002mfP0000JmfP03002m
f[gJ00>mfP030035fP0000G5fP040035fP000003aMX00`00aM[5fP020002aMX01000aMW5fLGI0P00
0/GI00<00<GIaMT00P000/Fi00D00<FiaKW5^@0000;5^@03003=^Lfi00;=^@04003=^Lfi0002cKP0
1@00cKS=^<fh00000/fh00L00<fhcKS=^000eKP00006cKP00`00eKOE]`03eKL20004eKL01P00eKOE
]`00gKH000?M]P<000?MU@04003MUMfEgID20004iI@01P00gIGMU@00iI<000?UT`04003UU0000004
kI801@00iG?ULnEc00000_E`00@00>eakG7]L@800005iC400>e@kE000003mFl01@00kG000<Ac0000
0^DA00<00>e@00000_E?0P000lAB00@00>DA003]<08000;oo`03003ooooo017oo`004Ooo00<00?oo
ool03ooo00<00:gl[O`01:gl0P001Jgl00<00:gl[O`00Zgl0`001Jgl0P0000>]o00000000Zgl00<0
0:gl[O`01:gl00@00:gl000000:]o003002]o:gl00B]o08000F]o08000:]o08000:]o003002]o:gl
00:]o0<00003[O`0000000:]o003002]o:gl00>]o08000F]o08000:]o08000:]o003002]o:gl00>]
o003002]o:gl008000:]o003002]o:gl00>]o08000F]o08000:]o08000:]o003002]o:gl00>]o004
002]o0000002[O`00`00]Obeo004]O`20005]O`200000kGl00000002]O`00`00]Obeo004]O`20004
]O`00`00]Obeo003]O`20006]M`00`00]Mbeg0020002]M`00`00]Mbeg003]M`30005]M`00`00]Mbe
g0020002]M`00`00]Mbeg004]M`20004]M`00`00]Mbeg002]M`200000kGL002ef`04]M/01000]M/0
00000kGK00<00;GK]M/00[GK0`001KGK00@00;GK000000>ef`03002efkGK00:ef`800003]M/00;GK
00Bef`04002ef`000003]M/00`00]M^ef`02]M/30006]M/30004]M/00`00]M^ef`020002]M/00`00
_M^mf`03_M/20006_M/01000_M/000000kgK00@00;gK_M^mf`800003_M/00;gK00Fmf`03002mf[gJ
00BmfP04002mfP000003_MX00`00_MZmfP020002_MX00`00_MZmfP02_MX30006_MX00`00aM[5fP05
aMX00`00aM[5fP03aMX00`00aMX00005aMX00`00aMT00004aMT00`00aMT00004aKT01000aKW5^@00
1<Fi00@00<ficKT000?=^@03003=^00000G=^08000G=^003003=^<fh00C=^08000CE]`04003E]mFg
0002eKL00`00eKOE]`02eKL20003gKH200001MFF003MUMfE00001=fE00D00>FDiICUU00000?MU@80
00?UT`03003UU>FD008000C]TP05003ULnEciG<00002mG001000kG7]L@000^eb0P000^e@00T00?E_
mFoeK`00kG000<Ac00000^DA00<00>e@00000_E?0P000lAB00@00>DA003]<08000;oo`03003ooooo
017oo`004Ooo00<00?ooool04?oo0P000Zgl0P000Zgl00<00:gl[O`00jgl00@00:gl000000:]o003
002]o:gl00B]o08000F]o003002]o:gl00>]o08000F]o08000:]o08000:]o003002]o:gl00>]o0<0
00B]o003002]o00000800004[O`000000005[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30004
[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002[O`00`00[Ob]o004[O`20004[O`00`00[Ob]
o003[O`20005[O`20002]O`20002]O`00`00]Obeo003]O`20005]O`01000]Obeo;Gl0P0000>eo000
]O`01;Gl00<00;Gl]O`00P000[GL00<00;GL]M`00kGL0`001KGL00<00;GL]M`00P000[GL00<00;GL
]M`01;GL0P001;GL00<00;GL]M`00[GL0P0000>eg000]M`01;GL00@00;GL000000>eg003002efkGK
00>ef`8000Jef`04002ef`000003]M/00`00]M^ef`02]M/20006]M/01000]M/000000kGK00<00;GK
]M/00kGK0P001[GK00@00;GK000000>ef`04002efkGK]M/200000kGK002ef`05]M/20005]M/00`00
_M^mf`020002_M/00`00_M^mf`04_M/00`00_M^mf`03_M/01000_M/000000kgK00<00;gK_M/00[gK
0P0000>mf`00_MX01KgJ00<00;gJ_MX00kgJ00<00;gJ00001KgJ00@00;gJ000000>mfP04002mf[gJ
_MX200000kgJ0035fP04aMX20006aMX00`00aM[5fP05aMX00`00aMW5f@04aMT00`00aKW5^@04aKT2
0005aKT00`00cKT00005cKT00`00cKS=^004cKP00`00cKS=^003cKP00`00cKP00004cKP01000cKS=
^0000mFg00H00=FgeKL00=Fg0005eKL00`00gKKM]P02gKH200001=FF003MU@001=fE0P000nFD00<0
0=fEgID00]fE00D00>FCiI?UT`0000?UU005003]T^fBkI800004iG<01000mG3eL0000^ea00<00>eb
kG800P000^e@00T00?E_mFoeK`00kG000<Ac00000^DA00<00>e@00000_E?0P000lAB00L00>DA003]
<000mDl00002ool00`00ooooo`0@ool0017oo`03003ooooo01;oo`8000B]o003002]o:gl00>]o080
00F]o08000:]o08000:]o003002]o:gl00>]o003002]o:gl008000:]o003002]o:gl00>]o0<000F]
o003002]o:gl008000:]o004002]o:gl[O`30002[O`20002[O`00`00[Ob]o003[O`30005[O`00`00
[Ob]o0020002[O`00`00[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30004[O`00`00
[Ob]o002[O`200000jgl002]o004[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30005]O`00`00
]Obeo0020002]O`00`00]Obeo003]O`00`00]O`00003]O`00`00]Obeo003]O`30005]M`00`00]Mbe
g0020002]M`00`00]Mbeg003]M`30004]M`00`00]Mbeg002]M`200000kGL002eg004]M`01000]M`0
00000kGL00<00;GL]M`00kGL0P001[GL00<00;GK]M/00P000[GK00<00;GK]M/00kGK0P001KGK00<0
0;GK]M/00P000[GK00<00;GK]M/00kGK0P001[GK00<00;GK]M/00P000[GK00<00;GK]M/00kGK0P00
1KGK00@00;GK000000Bef`04002efkGK]M/200000kGK002ef`05]M/20004_M/00`00_M^mf`02_M/3
0006_M/00`00_M^mf`04_M/01000_M/000000kgK00<00;gJ_MX00[gJ0`001[gJ00<00;gJ_MX01KgJ
00<00;gJ_MX00kgJ00@00;gJ000000>mfP040035f/GJaMX20002_MX01000aM[5f/GJ0P0000?5fP00
aMX01<GJ0P001LGI0P001/Fi00<00<FiaKT01LFi00<00<ficKT00lfi0P001Lfh00<00<fh00001<fh
00<00<fh00001<fh00@00<fhcKP000;E]`03003E]mFg00;E]`8000CE]`8000CM]P06003EUP00003M
U@001=fE00D00=fF003UU00000GMU@05003UTnFCiI<00003iI@01@00kI;]T^fB00001>Ec00<00?E`
00000nea00<00>ebkG800P000^e@00D00?E_mFoeK`0000;]L08000;U4@03003]D00000?eC`070034
D/ABa5800>DA00000^d`0P000_oo00<00?ooool04?oo000Aool00`00ooooo`0Cool00`00[Ob]o003
[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30004[O`00`00[Ob]o003[O`30005[O`00`00[Ob]
o0020002[O`00`00[Ob]o003[O`30004[O`40002[O`30005[O`00`00[Ob]o0020002[O`00`00[Ob]
o004[O`20004[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`01000
[O`000000jgl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl00<00;Gl]O`01;Gl0P001;Gl
00<00;Gl]O`00kGl0P001KGl00<00;Gl]O`00P000[GL00<00;GL]M`00kGL0`001KGL00<00;GL]M`0
0P000[GL00<00;GL]M`00kGL00@00;GL000000>eg003002eg;GL00>eg08000Jeg003002eg;GL0080
00:eg003002eg;GL00>eg0<000Fef`03002efkGK008000:ef`03002efkGK00:ef`<000Fef`03002e
fkGK008000:ef`03002efkGK00>ef`<000Fef`03002efkGK008000:ef`03002efkGK00:ef`8000Je
f`04002ef`000003]M/00`00]M^ef`02]M/200000kGK002mf`04_M/01000_M/000000kgK00@00;gK
_M^mf`800003_M/00;gK00Fmf`03002mfkgK00Bmf`04002mfP000003_M/01000_MZmf[gJ0P0000>m
fP00_MX00kgJ0`001[gJ00<00;gJ_MX01;gJ00<00<GJ00001;gJ00@00<GJ000000?5fP040035f/GJ
aMX20002aMX00`00aMW5f@020002aKT00`00aKW5^@02aKT00`00aKT00005aKT20004cKT01000cKW=
^@000lfh00@00<fhcKP000?=^005003=^<fhcKP00002cKP00`00cKS=^002cKP20005eKL00`00eKOE
]`03eKL00`00eKL00002gKH01000eIKEU]FF0P001=fE00H00=fFgIH00>FD0005gID01@00iI?UTnFC
00000nFD00D00>fBkI;]TP0000?UL`04003UL`000003kG400`00kG;]LP020002kE001@00mFoeKoE_
00000^e`0P000^DA00<00>e@00000oE?00D00<ABa5;4DP0000;U4@04003]<0000002ool00`00oooo
o`0@ool0017oo`03003ooooo01?oo`03002]o:gl00>]o0<000F]o003002]o:gl008000:]o003002]
o:gl00>]o003002]o:gl008000:]o003002]o:gl00>]o0<000F]o003002]o:gl008000:]o003002]
o:gl00@000:]o08000:]o003002]o:gl00>]o0<000B]o003002]o:gl00:]o0800003[O`00:gl00B]
o003002]o:gl008000:]o003002]o:gl00>]o0<000B]o003002]o:gl00>]o08000J]o003002]o:gl
008000:]o003002]o:gl00>]o0<000B]o003002eo;Gl00:eo0800003[O`00;Gl00Beo003002eo;Gl
008000:eo003002eo;Gl00:eo0<000Feg003002eg;GL008000:eg003002eg;GL00Beg08000Beg003
002eg;GL00>eg08000Jeg003002eg;GL008000:eg003002eg;GL00>eg0<000Feg003002eg;GL0080
00:eg003002efkGK00>ef`<000Bef`03002efkGK008000:ef`03002efkGK00Bef`8000Fef`03002e
fkGK008000:ef`03002efkGK00Bef`8000Bef`03002efkGK008000:ef`03002efkGK00Bef`03002e
fkGK00Bef`04002ef`000003]M/00`00_M^mf`03_M/20005_M/01000_M/000000kgK00<00;gK_M/0
0[gK0P0000>mf`00_M/01KgK00<00;gK_M/00kgK00@00;gJ000000BmfP04002mfP000003_MX01000
_MZmf[gJ0P0000>mfP00_MX01KgJ00<00;gJ_MX01;gJ00<00<GJaMX01<GJ00<00<GJ00001<GJ00<0
0<GI00001<Fi00<00<FiaKT00P000/Fi00@00<FiaKW5^@8000;5^@04003=^Lfi0003cKT01000cKS=
^0001<fh00<00<fh00001<fh00<00<fh00001Lfh00<00=FgeKL00mFg0P001=Fg00H00=FgeKL00=ff
0004eIH20004gID01P00gIKMUP00iI@000CMU@05003MU@00iI<00004iI@20002kI801P00iG?ULnEc
003UL`8000?]L@05003]L^ebkG800002kE001@00mFoeKoE_00000^e`0P000^DA00<00>e@00000oE?
00D00<ABa5;4DP0000;U4@04003]<0000002ool00`00ooooo`0@ool0017oo`03003ooooo01Coo`03
002]o:gl008000:]o003002]o:gl00>]o0<000F]o004002]o:gl[O`40005[O`00`00[Ob]o0020002
[O`00`00[Ob]o003[O`30004[O`30003[O`30005[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`0
1000[O`000000jgl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl00<0
0:gl[O`00P000Zgl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl00@0
0;Gl000000>]o003002eo;Gl00>eo0<000Feo004002eo0000002]M`00`00]Mbeg003]M`30004]M`0
0`00]Mbeg002]M`200000kGL002eg004]M`00`00]Mbeg0020002]M`00`00]Mbeg003]M`30005]M`0
0`00]Mbeg0020002]M`00`00]Mbeg003]M`30005]M`00`00]M^ef`0200000kGK002ef`05]M/20004
]M/00`00]M^ef`02]M/200000kGK002ef`05]M/20004]M/00`00]M^ef`02]M/30006]M/20004]M/0
0`00]M^ef`02]M/200000kGK002ef`05]M/00`00]M^ef`04]M/00`00_M^mf`020002]M/00`00_M^m
f`02_M/20006_M/01000_M/000000kgK00<00;gK_M/00[gK0P0000>mf`00_M/00kgK0P001kgJ00<0
0;gJ_MX00kgJ00@00;gJ000000>mfP03002mf[gJ00:mfP<000FmfP03002mfP0000K5fP030035f/GJ
00C5fP030035^LFi00C5^@8000G5^@030035^@0000C5^@03003=^@0000G=^@8000G=^003003=^000
00G=^003003=^<fh00?=^08000CE]`04003E]mFg0002eKL00`00eKOE]`02eKL20004eIH20003gID0
0`00gIKMUP02gIH00`00gIGMU@03gID01@00gID00>FC00000nFD00<00>FD00000^fB00H00>EciG?U
L`00iG<20003kG401@00kG;]L^eb00000^e@00D00?E_mFoeK`0000;]L08000;U4@03003]D00000?e
C`050034D/ABa5800002iA401000kC0000000_oo00<00?ooool04?oo000@ool00`00ooooo`0Fool2
0005[O`200000jgl00000002[O`00`00[Ob]o003[O`40003[O`00`00[Ob]o003[O`30005[O`00`00
[Ob]o0020002[O`00`00[Ob]o0040002[O`20002[O`00`00[Ob]o003[O`30004[O`00`00[Ob]o003
[O`20006[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30004[O`00`00[Ob]o003[O`30005[O`0
0`00[Ob]o0020002[O`00`00[Ob]o003[O`30004[O`00`00[Ob]o003[O`20006[O`00`00]Obeo002
0002]O`00`00]Obeo003]O`20005]M`200000kGL00000002]M`00`00]Mbeg003]M`01000]M`00000
0kGL00<00;GL]M`00kGL0`001KGL00<00;GL]M`00P000[GL00<00;GL]M`00kGL0`001KGL00<00;GL
]M`00P000[GL00<00;GL]M`01;GL0P001;GK00@00;GK]M^ef`800003]M/00;GK00Bef`04002ef`00
0003]M/00`00]M^ef`02]M/200000kGK002ef`04]M/01000]M/000000kGK00@00;GK]M^ef`800003
]M/00;GK00Bef`04002ef`000003]M/00`00]M^ef`02]M/200000kGK002ef`05]M/20004]M/00`00
_M^mf`020002_M/00`00_M^mf`03_M/20006_M/01000_M/000000kgK00<00;gK_M/00P000[gK00<0
0;gJ_MX00[gJ0`001[gJ00<00;gJ_MX01;gJ00@00;gJ000000>mfP03002mf[gJ008000:mfP030035
f/GJ00;5fP<000G5fP8000K5^@030035^LFi00G5^@030035^LFi00C5^@03003=^Lfi00C=^@03003=
^<fh00G=^003003=^<fh00?=^08000C=^004003=^<fh0003eKL01P00eKOE]`00eKL000GE]`03003E
U]FF00?EUP03003EUP0000;MU@03003MU]fF00;MUP03003MUMfE00;MU@06003MUMfE003UT`000nFD
00H00>FDiI@00>fB0003iG<01000iG<000000nea00D00>ebkG;]LP0000;]D005003eKoE_mFl00003
kG001P00iA7U4@00kE0000?eC`050034D/ABa5800002iA401000kC0000000_oo00<00?ooool04?oo
000@ool00`00ooooo`0Gool00`00[Ob]o004[O`20005[O`200000jgl00000002[O`00`00[Ob]o003
[O`200000jgl00000002[O`00`00[Ob]o003[O`30004[O`30003[O`30005[O`00`00[Ob]o0020002
[O`00`00[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002
[O`00`00[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002
[O`00`00[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30005]O`00`00]Obeo0020002
]M`00`00]Mbeg004]M`00`00]Mbeg002]M`00`00]Mbeg003]M`20006]M`00`00]Mbeg0020002]M`0
0`00]Mbeg003]M`30005]M`00`00]Mbeg0020002]M`00`00]Mbeg004]M`20004]M`00`00]Mbeg002
]M`30005]M/01000]M/000000kGK00<00;GK]M/00kGK0P001[GK00@00;GK000000>ef`03002efkGK
00>ef`8000Fef`04002ef`000003]M/00`00]M^ef`03]M/20006]M/01000]M/000000kGK00<00;GK
]M/00[GK0`001[GK0P001KgK00<00;gK_M/00P000[gK00<00;gK_M/00kgK0P001[gK0P001KgK00@0
0;gJ000000>mfP04002mf[gJ_MX200000kgJ002mfP05_MX00`00_MZmfP03_MX00`00_MX00005_MX0
1000aMX000000lGJ00<00<GJaMX00P000/Fj00@00<FiaKW5^@800003aKT00<Fi00C5^@8000G5^@03
0035^@0000C=^@030035^@0000G=^08000C=^004003=^<fh0003cKP01000cKS=^0000]Fg00<00=Fg
eKL00]Fg0P001=Fg00<00=Fg00000mFF00<00=FFeIH00`001MfF00<00=fEgID00]fE00D00=fEgIGM
U@0000CUU003003UU>FD008000?UL`05003ULnEciG<00003kG401000kG;]L^eb0P0000?]D000mFl0
0_E_00D00>e`kG3]L00000;U4@03003]D00000?eC`8000;4DP05003U4NDA003]<0020002ool00`00
ooooo`0@ool0013oo`<001Soo`8000:]o08000:]o003002]o:gl00>]o08000F]o003002]o:gl00>]
o08000F]o0800003[O`0000000:]o003002]o000008000:]o004002]o0000002[O`00`00[Ob]o003
[O`30005[O`00`00[Ob]o002[O`30005[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30004[O`0
0`00[Ob]o003[O`30005[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30004[O`00`00[Ob]o003
[O`30005[O`00`00[Ob]o0020002[O`00`00]Obeo003]O`30004]M`00`00]Mbeg002]M`200000kGL
002eg003]M`00`00]Mbeg0020002]M`00`00]Mbeg003]M`30005]M`00`00]Mbeg0020002]M`00`00
]Mbeg004]M`20004]M`00`00]Mbeg002]M`200000kGL002eg004]M`01000]M`000000kGL00<00;GK
]M/00[GK0P001[GK00<00;GK]M/00P000[GK00<00;GK]M/00kGK0P001[GK00<00;GK]M/00P000[GK
00<00;GK]M/00[GK0P001[GK00<00;GK]M/00P000[GK00<00;GK]M/00kGK0P001[GK00@00;GK0000
00>ef`04002efkGK]M/200000kGK002mf`05_M/20004_M/00`00_M^mf`030002_M/01000_M^mfkgK
0P0000>mf`00_M/01KgK00<00;gJ_MX00kgJ00@00;gJ000000>mfP03002mf[gJ00:mfP<000JmfP03
002mf[gJ00FmfP030035f/GJ00?5fP030035fP0000C5^P040035^@000003aKT01000aKW5^LFi0P00
0/Fi00<00<FiaKT00P000/Fi00D00<ficKW=^@0000;5^@04003=^<fhcKP20002cKT01000cKS=^000
0lfh00@00<fhcKP000C=^08000GE]`03003E]mFg00?E]`03003E]`0000?EUP04003EU]FFeIH20004
gIH00`00gIH00003gID01@00gIGMUMfE00001>FD00D00>FDiICUU00000?UL`05003ULnEciG<00003
kG401000kG;]L^eb0P0000G]D000mFoeK`0000C]L006003U4NDA003]D0000oE?0P000/AB00P00>DA
iA400>d`003eC`000_oo00<00?ooool03ooo000@ool00`00ooooo`0Jool20005[O`00`00[Ob]o002
0002[O`00`00[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`20003[O`30005[O`20005
[O`200000jgl00000002[O`00`00[Ob]o004[O`01000[O`000000Zgl00<00:gl[O`00jgl0`001Jgl
00<00:gl[O`00P000Zgl00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001Jgl
00<00:gl[O`00P000Zgl00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001Jgl
00<00;Gl]O`00P000Zgl00<00;GL]M`00kGL00@00;GL000000>eg003002eg;GL00:eg0<000Feg003
002eg;GL008000:eg003002eg;GL00>eg0<000Beg003002eg;GL00:eg0800003]M`00;GL00Beg004
002eg0000003]M`00`00]Mbeg003]M`20005]M`00`00]M^ef`020002]M/00`00]M^ef`03]M/30005
]M/00`00]M^ef`020002]M/00`00]M^ef`03]M/30004]M/00`00]M^ef`020002]M/00`00]M^ef`04
]M/20005]M/00`00]M^ef`020002]M/00`00]M^ef`03]M/20005]M/01000]M/000000kGK00<00;gK
_M/00[gK0`001[gK0P001KgK00@00;gK000000>mf`03002mfkgK00:mf`<000JmfP03002mf[gJ00Bm
fP04002mfP000003_MX01000_MZmf[gJ0P0000>mfP00_MX01;gJ0P001/GJ00<00<FjaKX01<Fj00<0
0<FiaKT01<Fi00<00<Fi00001<Fi00<00<Fi00001LFi00<00<fi00001<Fi00<00<fh00001<fi00<0
0<fh00001Lfh0P001Lfh00<00=FgeKL00mFg00<00<fh00000mFg00L00=FgeKOE]`00eIH00004eIH2
0004gIH00`00gIH00002gID00`00gIGMU@02gID01@00iICUU>FD00001>FD00D00>EciG?UL`0000?U
L`05003]LNeakG400002kG801@00iG800>e@00000_E_00<00>e`kG000^e`00H00>DAiA400>e@0003
mDl20002a5802000iA7U4@00kC000?E?0002ool00`00ooooo`0?ool0013oo`03003ooooo01_oo`03
002]o:gl00>]o0<000B]o003002]o:gl00>]o0<000F]o003002]o:gl008000:]o0<000>]o003002]
o:gl008000:]o003002]o:gl00>]o08000F]o003002]o:gl00>]o08000F]o0800003[O`0000000:]
o003002]o:gl00>]o0<000F]o003002]o:gl00:]o0<000F]o003002]o:gl008000:]o003002]o:gl
00>]o0<000B]o003002]o:gl00>]o0<000F]o003002]o:gl008000:]o003002]o:gl00>]o0<000B]
o003002eg;GL00>eg08000Jeg004002eg0000002]M`00`00]Mbeg003]M`30005]M`00`00]Mbeg002
0002]M`00`00]Mbeg003]M`01000]M`000000kGL00<00;GL]M`00kGL0P001[GL00<00;GL]M`00P00
0[GL00<00;GL]M`00[GL0`001KGK00<00;GK]M/00P000[GK00<00;GK]M/01;GK0P001KGK00<00;GK
]M/00P0000>ef`00]M/01KGK0P001;GK00<00;GK]M/00[GK0P0000>ef`00]M/01KGK0P001KGK00<0
0;GK]M/00P000[GK00<00;GK]M/00[GK0P001[GK00@00;gK000000>mf`04002mfkgK_M/200000kgK
002mf`05_M/00`00_M^mf`04_M/01000_M/000000kgK00@00;gJ_MZmfP800003_MX00;gJ00FmfP03
002mf[gJ00>mfP04002mfP000003_MX01000_MZmf[gJ0P000[gJ00@00<GJaM[5fP800003_KX00<Fj
00?5^P030035^P0000K5^@030035^LFi00C5^@030035^LFi00G5^@030035^LFi00C5^@03003=^Lfi
00C=^@03003=^<fh00C=^003003=^<fh00?=^003003=^00000CE]`03003=^00000?E]`07003E]mFg
eKL00=FF00000mFF0P0000GMUP00gIKMUP0000?MUP03003MU@0000?MU@03003MU@0000;UU003003U
U>FD00;UU005003ULnEciG<00003iG<01@00kG7]LNea00000^eb00D00>Eb003]D00000;eK`03003]
L>e`00;]L006003U4NDA003]D0000oE?0P000/AB00P00>DAiA400>d`003eC`000_oo00<00?ooool0
3ooo000@ool00`00ooooo`0Lool00`00[Ob]o0020002[O`00`00[Ob]o003[O`00`00[Ob]o0020002
[O`00`00[Ob]o003[O`300000jgl000000020005[O`30005[O`00`00[Ob]o0020002[O`00`00[Ob]
o003[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`20005[O`200000jgl00000002[O`00`00[Ob]
o004[O`01000[O`000000Zgl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`0
0jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`0
0jgl00<00;GL]M`00P000[GL00<00;GL]M`00kGL0P001KGL00<00;GL]M`00P000[GL00<00;GL]M`0
1;GL0P001;GL00<00;GL]M`00kGL0P001[GL00<00;GL]M`00P000[GL00<00;GL]M`00kGL0`001;GL
00<00;GL]M`00P000[GL00<00;GK]M/01;GK0P001;GK00<00;GK]M/00[GK0P0000>ef`00]M/01KGK
0P001;GK00@00;GK]M^ef`800003]M/00;GK00Bef`04002ef`000003]M/00`00]M^ef`02]M/20000
0kGK002ef`05]M/20004]M/00`00]M^ef`020002]M/00`00]M^ef`04]M/00`00_M^mf`03_M/01000
_M/000000kgK00<00;gK_M/00[gK0P0000>mf`00_M/01KgK00<00;gK_M/00kgK00@00;gJ000000>m
fP03002mf[gJ00:mfP<000JmfP03002mf[gJ00BmfP03002mfP0000BmfP040035fP000003_KX01@00
aK[5^/Fj00000/Fj00<00<FiaKT00lFi0P001LFi00<00<Fi00001LFi0P001LFi0P001Lfi0P001Lfh
0P001<fh00@00<fhcKP000?E]`07003=^<fhcKP00=Fg00001MFg00<00=FFeIH00]FF00@00=FG0000
00;MUP04003MU]fFgIH20004gID00`00gID00002iI@02@00iICUU>FD003MU@00iG<00004iG<20002
kG401000kG;]LP000^Eb0P000_E_00<00>e`kG000^e`0P0000CU4@00kE0000?eC`8000;4DP08003U
4NDA003]<000mDl000;oo`03003ooooo00ooo`004?oo00<00?ooool07Ooo0P001Jgl00<00:gl[O`0
0Zgl0`001Jgl00<00:gl[O`00P0000B]o000000000B]o003002]o:gl008000:]o003002]o:gl00>]
o0<000F]o004002]o:gl[O`40005[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`20005[O`00`00
[Ob]o003[O`20005[O`200000jgl00000002[O`00`00[Ob]o003[O`30004[O`00`00[Ob]o003[O`3
0005[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30004[O`00`00[Ob]o003[O`30005]M`00`00
]Mbeg0020002]M`00`00]Mbeg002]M`30004]M`00`00]Mbeg002]M`200000kGL002eg004]M`00`00
]Mbeg0020002]M`00`00]Mbeg003]M`30005]M`00`00]Mbeg00200000kGL002eg005]M`20004]M`0
0`00]M^ef`02]M/200000kGL002ef`04]M/01000]M/000000kGK00<00;GK]M/00[GK0`001KGK00@0
0;GK000000>ef`03002efkGK00>ef`8000Jef`04002ef`000003]M/00`00]M^ef`02]M/30006]M/2
0004]M/00`00]M^ef`02]M/30006_M/00`00_M^mf`04_M/01000_M/000000kgK00<00;gK_M/00[gK
0`001[gK00<00;gJ_MX01;gJ00@00;gJ000000>mfP04002mf[gJ_MX200000kgJ002mfP05_MX00`00
_MZmfP04_MX00`00_KZm^P04_KX00`00aKX00004aKX00`00aKW5^@020002aKX00`00aKW5^@020002
aKT01000aKW5^LFi0P000/Fi00D00<FiaKW5^@0000;5^@05003=^LficKT00002cKT01@00cKS=^<fh
00000/fh00@00<fhcKP000C=^003003E]`0000C=^003003E]`0000CE]`8000?EUP05003EUmFG003M
UP020005gIH01@00gIGMUMfE00000mfE00<00>FD00000nFD00D00=fE003UL`0000?UL`05003UM000
kG400003kG800`00iG;ULP020002mFl00`00kG3]L002kG0200001>DA003]D0000oE?00D00>e@0034
DP0000;U4@05003]<000mDl00002ool00`00ooooo`0?ool000ooo`03003ooooo01ooo`03002]o:gl
00B]o004002]o0000002[O`00`00[Ob]o003[O`300001Jgl00000:gl00001Jgl0`001Jgl00<00:gl
[O`00P000Zgl00<00:gl[O`00jgl10000jgl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl
00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0P001Jgl0P0000>]o00000000Zgl
00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl
00<00:gl[O`00jgl00<00:gl[O`00P000ZgL00<00;GL]M`00kGL0`001KGL00@00;GL000000:eg003
002eg;GL00>eg004002eg0000003]M`00`00]Mbeg003]M`30005]M`00`00]Mbeg0020002]M`00`00
]Mbeg003]M`30004]M`01000]Mbeg;GL0P0000>eg000]M`01;GL00@00;GK000000>eg003002efkGK
00>ef`8000Jef`04002ef`000003]M/00`00]M^ef`02]M/20006]M/00`00]M^ef`020002]M/00`00
]M^ef`03]M/20006]M/01000]M/000000kGK00@00;GK]M^ef`800003]M/00;GK00Bef`04002ef`00
0003]M/01000_M^mfkgK0P0000>ef`00_M/01KgK00<00;gK_M/01;gK00@00;gK000000>mf`04002m
fkgK_M/200000kgK002mfP05_MX00`00_MZmfP03_MX01000_MX000000kgJ00<00;gJ_MX00[gJ0`00
1KgJ00<00;fj00001[fj00<00<FjaKX00lFj00<00<Fi00001<Fj00<00<Fi00001LFi00<00<Fi0000
1<Fi00@00<FiaKT000?5^@04003=^Lfi0003cKT01000cKS=^0000lfh00<00<fh00001Lfh00<00=Fg
00001Lfh00<00=FgeKL00mFg00<00=FG00000]FF00L00=FGeIOEU`00gIH00004gIH20003gID01000
gIGMUMfE0P001>FD00D00=fE003UL`0000?UL`05003UM000kG400003kG800`00iG;ULP020002mFl0
2`00kG3]L>e`003]L@00iA400>e@00000oE?00D00>e@0034DP0000;U4@05003]<000mDl00002ool0
0`00ooooo`0?ool000ooo`03003ooooo023oo`03002]o:gl00>]o08000F]o0800004[O`00000[O`3
0004[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002[O`00`00[Ob]
o003[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30004[O`00`00[Ob]o003[O`30005[O`00`00
[Ob]o0020002[O`00`00[Ob]o003[O`20005[O`00`00[Ob]o002[O`30005[O`00`00[Ob]o0020002
[O`00`00[Ob]o004[O`20004[O`00`00[Ob]o003[O`30005[M`00`00]Mbeg0020002[M`00`00]Mbe
g003]M`20004]M`00`00]Mbeg003]M`20006]M`00`00]Mbeg0020002]M`00`00]Mbeg003]M`30005
]M`00`00]Mbeg0020002]M`00`00]Mbeg002]M`01000]M`000000kGL00<00;GL]M`00kGL0P001[GL
00<00;GK]M/00P000[GK00<00;GK]M/00kGK0P001KGK00<00;GK]M/00P000[GK00<00;GK]M/00kGK
0`001KGK00<00;GK]M/00P000[GK00<00;GK]M/00kGK0P001KGK00@00;GK000000>ef`03002efkGK
00>ef`8000Fef`04002mf`000003]M/00`00_M^mf`02_M/200000kgK002mf`05_M/00`00_M^mf`03
_M/01000_M/000000kgK00<00;gJ_MX00[gJ0`001[gJ00<00;gJ_MX01;gJ00@00;gJ000000>mfP03
002mf[gJ008000:m^P03002m^[fj00:m^P<000K5^P030035^/Fj00C5^P030035^LFi00G5^@030035
^LFi00C5^@8000G5^@8000G=^@8000G=^003003=^<fh00G=^003003=^<fh00?=^08000CE]`06003E
UmFG003EUP001=FG0P0000?MUP00gIH00]fF00<00=FF00000]fE00<00=fEgID00]fE00D00>FDiICU
U00000;MU@03003UL`0000?UL`03003UM>Ed008000?]LP05003UL^EbiG800002mFl02`00kG3]L>e`
003]L@00iA400>e@00000oE?00D00>e@0034DP0000;U4@05003]<000mDl00002ool00`00ooooo`0?
ool000ooo`03003ooooo027oo`03002]o:gl008000:]o003002]o:gl00>]o0D000:]o003002]o:gl
00:]o0<000F]o0800003[O`0000000:]o003002]o:gl00>]o0<000B]o003002]o:gl00>]o0<000F]
o003002]o:gl008000:]o003002]o:gl00>]o003002]o:gl008000:]o003002]o:gl00>]o0<000F]
o003002]o:gl008000:]o003002]o:gl00>]o004002]o0000002[O`00`00[Ob]o003[O`30004[O`0
0`00[Ob]o002[O`200000jgl002]o004[O`00`00[Ob]o0020002[M`00`00[Mb]g003[M`30005[M`0
0`00]Mbeg0020002]M`00`00]Mbeg002]M`00`00]Mbeg0020002]M`00`00]Mbeg003]M`30005]M`0
0`00]Mbeg0020002]M`00`00]Mbeg004]M`20004]M`00`00]Mbeg002]M`20006]M`00`00]Mbeg002
0002]M`00`00]Mbeg003]M`30005]M/00`00]M^ef`020002]M/00`00]M^ef`02]M/30005]M/00`00
]M^ef`020002]M/00`00]M^ef`04]M/20005]M/00`00]M^ef`0200000kGK002ef`05]M/00`00]M^e
f`04]M/00`00]M^ef`020002]M/00`00]M^ef`02]M/20006]M/01000_M/000000kgK00<00;gK_M/0
0[gK0`001[gK00<00;gK_M/01;gK00@00;gJ000000>mfP04002mf[gJ_MX200000kgJ002mfP05_MX0
0`00_MZmfP03_MX00`00_MX00005_KX01000_KX000000kfj00@00<FjaK[5^P<000G5^P030035^P00
00G5^@8000K5^@030035^LFi00C5^@03003=^Lfi00C=^@03003=^<fh00?=^003003=^00000G=^080
00C=^004003=^<fh0002eKL00`00eIOEU`02eIL20005eIL00`00gIH00002gIH01P00eIKEUP00gID0
00CMU@8000?UU005003MUMfEgID00004iG<00`00iGCUM0020002kG800`00iG;ULP02iG801000mFoe
K`000ne`00<00>eakG400P0000?]D000mDl00_E?00D00>e@0034DP0000;U4@03003]<00000;eC`03
003oo`00017oo`003ooo00<00?ooool08_oo0P001Jgl00<00:gl[O`01@001Jgl00@00:gl000000:]
o003002]o:gl00B]o08000F]o0800003[O`0000000:]o003002]o:gl00>]o003002]o:gl008000:]
o003002]o:gl00>]o0<000B]o003002]o:gl00>]o0<000F]o003002]o:gl008000:]o003002]o:gl
00>]o0<000B]o003002]o:gl00>]o08000F]o003002]o:gl008000:]o003002]o:gl00>]o004002]
o0000003[O`00`00[Ob]o003[O`30005[M`00`00[Mb]g0020002[M`00`00[Mb]g004[M`20004]M`0
0`00]Mbeg002]M`30005]M`00`00]Mbeg0020002]M`00`00]Mbeg003]M`30004]M`00`00]Mbeg002
]M`200000kGL002eg004]M`01000]M`000000[GL00<00;GL]M`00kGL0`001KGL00<00;GL]M`00P00
0[GL00<00;GK]M/00kGK0`001;GK00<00;GK]M/00P000[GK00<00;GK]M/01;GK0P001;GK00<00;GK
]M/00[GK0P0000>ef`00]M/01KGK0P001;GK00@00;GK]M^ef`800003]M/00;GK00Fef`8000Bef`03
002efkGK008000:ef`03002efkGK00>ef`8000Jmf`04002mf`000003_M/01000_M^mfkgK0P0000>m
f`00_M/01KgK00<00;gJ_MX00kgJ00@00;gJ000000>mfP03002mf[gJ00:mfP<000JmfP03002m^[fj
00Fm^P03002m^[fj00>m^P040035^P000003aKX00`00aK[5^P020002aKX01000aKW5^LFi0P000/Fi
00<00<FiaKT00/Fi0P001LFi0P001Lfi00<00<Fi00000lfh00@00<fhcKP000C=^004003=^<fh0002
cKP01`00cKS=^<fh003E]`0000GEU`03003EUmFG00?EU`8000;MUP03003MUP0000;EUP03003MU@00
00CMU@05003MUP00iI@00004gID00`00iG?UL`02iG<01@00iGCUM>Ed00000^eb00<00>EbiG800^Eb
00@00?E_mFl000?]L003003]LNea00800003kE000?E?00;eC`05003]D000a5800002iA400`00kC00
0002mDl01000ooooo`004?oo000?ool3000Sool00`00[Ob]o003[O`40004[O`01000[Ob]o:gl0`00
1Jgl0P000Zgl0P000Zgl00<00:gl[O`00jgl0P001Jgl00<00:gl[O`00Zgl0`001Jgl00<00:gl[O`0
0P000Zgl00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`0
0P000Zgl00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<00:gl[O`00Zgl0`001:gl00<00:gl[O`0
0jgl0P001Zgl00<00:gl[O`00P000ZgL00<00:gL[M`00jgL0`001:gL00<00:gL[M`00ZgL0P0000>]
g000]M`01;GL00@00;GL000000:eg003002eg;GL00>eg0<000Feg003002eg;GL008000:eg003002e
g;GL00>eg004002eg0000003]M`00`00]Mbeg003]M`20005]M`00`00]Mbeg0020002]M`00`00]Mbe
g003]M`30005]M`00`00]M^ef`020002]M/00`00]M^ef`03]M/20004]M/00`00]M^ef`02]M/20000
0kGK002ef`04]M/01000]M/000000kGK00<00;GK]M/00[GK0`001KGK00@00;GK000000>ef`03002e
fkGK00:ef`<000Jef`8000Fef`03002efkGK008000:ef`03002mfkgK00Bmf`03002mfkgK00>mf`04
002mf`000003_M/00`00_M^mf`02_M/30006_MX00`00_MZmfP04_MX01000_MX000000kgJ00@00;gJ
_MZmfP800003_KX00;fj00Bm^P8000Jm^P030035^/Fj00?5^P030035^P0000G5^P030035^@0000C5
^@030035^LFi008000;5^@030035^LFi008000;5^@03003=^Lfi008000;5^@05003=^<fhcKP00003
cKP01000cKS=^0000lfh00<00<fh00001Lfh0P001=FG0P001=FG00@00=FGeIL000;MUP03003EU]FF
00;EUP03003MUMfE00;MU@06003MU]fF003UU0001=fE00D00>EciG?UL`0000CUM004003]L^eb0004
iG8200000oE_003]L002kG000`00kG7]L@0200000ne@003eC`02mDl01@00kE000<AB00000^DA00<0
0>d`00000_E?00@00?ooool0013oo`003ooo00<00?ooool09?oo00<00:gl[O`00`0000>]o000[O`0
1:gl10000jgl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl00@00:gl
000000:]o003002]o:gl00>]o0<000B]o003002]o:gl00>]o0<000F]o003002]o:gl008000:]o003
002]o:gl00>]o0<000B]o003002]o:gl00>]o0<000F]o004002]o0000002[O`00`00[Ob]o003[O`0
0`00[Ob]o0020002[O`00`00[Ob]o003[O`30005[M`00`00[Mb]g0020002[M`00`00[Mb]g003[M`0
1000[M`000000jgL00<00;GL]M`00kGL0P001KGL00<00;GL]M`00P000[GL00<00;GL]M`01;GL0P00
1;GL00<00;GL]M`00kGL0P001[GL00<00;GL]M`00P000[GL00<00;GL]M`00[GL0`001KGL00<00;GL
]M`00P000[GL00<00;GL]M`01;GL0P001;GK00@00;GK]M^ef`800003]M/00;GK00Bef`04002ef`00
0003]M/00`00]M^ef`03]M/20006]M/01000]M/000000kGK00<00;GK]M/00[GK0P001[GK00@00;GK
000000>ef`04002efkGK]M/200000kGK002ef`05]M/20004]M/00`00_M^mf`02_M/30006_M/00`00
_M^mf`04_M/01000_M/000000kgK00@00;gJ_MZmfP800003_MX00;gJ00FmfP03002mf[gJ00>mfP04
002mfP000003_KX01000_KZm^[fj0P000[fj00@00;fj_KZm^P<000K5^P030035^/Fj00G5^P030035
^LFi00C5^@8000C5^@030035^@0000C5^@03003=^@0000G5^@03003=^00000C=^003003=^00000G=
^003003=^<fh00C=^003003EUmFG00;EU`04003=UlfG0003eIL02000eIOEU`00gIH00=FF0003eIH0
0`00gIGMU@02gID01P00gIKMUP00iI@000?MU@03003MM@0000;UL`03003UM>Ed00;UM004003]L^eb
0003iG801@00iG<00?E_00000ne`00<00>eakG400P0000?]D000mDl00_E?00<00>e@kE000P000^DA
00<00>d`00000_E?00@00?ooool0013oo`003_oo00<00?ooool09Ooo0`001Jgl00<00:gl[O`00P00
0Zgl00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001:gl00<00:gl[O`00jgl
0P001Jgl0P0000>]o00000000Zgl00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl
0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl
0P001Jgl00<00:gl[O`00Zgl0`001Jgl00<00:gl[O`00P000Zgl00<00:gL[M`00jgL0`001:gL00<0
0:gL[M`00jgL0P001ZgL00<00;GL]M`00P000[GL00<00;GL]M`00[GL0`001;GL00<00;GL]M`00[GL
0P0000>eg000]M`01;GL00<00;GL]M`00P000[GL00<00;GL]M`00kGL0`001;GL00<00;GL]M`00P00
0[GL00<00;GL]M`01;GL0P001;GL00<00;GL]M`00[GL0P0000>eg000]M/01;GK00<00;GK00000kGK
00<00;GK]M/00kGK0P001[GK00<00;GK]M/00P000[GK00<00;GK]M/00kGK0P001KGK00<00;GK]M/0
0P000[GK00<00;GK]M/00kGK0P001KGK00@00;GK000000>ef`03002efkGK00:ef`800003]M/00;GK
00Bef`04002mf`000003]M/01000_M^mfkgK0P0000>mf`00_M/01KgK00<00;gK_M/00kgK00@00;gJ
000000>mfP03002mf[gJ00:mfP<000JmfP03002m^[fj00Bm^P03002m^P0000Bm^P04002m^P000003
_KX01000aK[5^/Fj0P0000>m^P00aKX01<Fj0P001/Fi00<00<FiaKT01<Fi00<00<FiaKT01<Fi00<0
0<FiaKT01LFi00<00<fhcKP01<fh00<00<fhcKP00lfh0P001Lfh0P001=FG00@00<fGcIL000;EU`03
003EUmFG00;EU`800004eIH00=FFeIH20003gID00`00gIKMUP02gIH00`00gIGMU@02gID00`00gGD0
0002iG<02@00iGCUM>Ed003MM000kG800003iG801@00iG<00?E_00000ne`00L00>eakG7]L@00kE00
0003mDl00`00kE3]D0020002iA400`00kC000002mDl01000ooooo`004?oo000>ool00`00ooooo`0R
ool30002ool00`00[Ob]o003[O`30004[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002[O`0
0`00[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`20005[O`00`00[Ob]o002[O`30005
[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30004[O`00`00[Ob]o003[O`30005[O`00`00[Ob]
o0020002[O`00`00[Ob]o003[O`01000[O`000000Zgl00<00:gl[O`00jgl0`001Jgl00<00:gL[M`0
0P000ZgL00<00:gL[M`00jgL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL0`001KGL00@00;GL0000
00:eg003002eg;GL00>eg004002eg0000003]M`00`00]Mbeg003]M`30005]M`00`00]Mbeg0020002
]M`00`00]Mbeg002]M`30004]M`00`00]Mbeg002]M`200000kGL002eg004]M`01000]M`000000kGL
00<00;GK]M/00kGK0P001KGK00<00;GK]M/00P000[GK00<00;GK]M/00kGK0`001KGK00<00;GK]M/0
0P000[GK00<00;GK]M/00[GK0`001KGK00<00;GK]M/00P000[GK00<00;GK]M/00[GK0P001[GK00@0
0;GK000000>ef`03002efkGK00>ef`8000Fef`04002mf`000003_M/00`00_M^mf`02_M/30006_M/0
0`00_MZmfP04_MX01000_MX000000kgJ00@00;gJ_MZmfP800003_KX00;fj00Fm^P03002m^[fj00Bm
^P03002m^[fj00>m^P040035^P000003_KX01000aK[5^/Fj0P000/Fj00@00<FiaKW5^@<000G5^@03
0035^@0000C5^@030035^@0000G5^@8000G=^08000C=^004003=^<fh0003cKP01000cIS=V0000]FG
00<00<fGcIL00/fG0P001MFG00T00=FFeIKEUP00eIH00=FF00000]fE00<00=fFgIH00]fF00<00=fE
gID00]fE00H00=eegGD00>Ec0003iG@01@00gG@00>eb00000nEb00<00>EciG<00P000ne`00D00>ea
kG7]L@0000;]D004003eCoE?0002kE020002iA400`00kC000002mDl01000ooooo`004?oo000>ool0
0`00ooooo`0Oool30006ool200000jgl00000002[O`00`00[Ob]o003[O`00`00[Ob]o0020002[O`0
0`00[Ob]o003[O`30004[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002[O`00`00[Ob]o003
[O`01000[O`000000Zgl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl
00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001:gl00<00:gl[O`00jgl0P001Jgl0P0000>]o000
00000Zgl00<00:gl[O`00jgl0`001:gL00<00:gL[M`00jgL0`001JgL00<00:gL[M`00P000ZgL00<0
0;GL]M`00kGL0P001;GL00<00;GL]M`00kGL0P001[GL00<00;GL]M`00P000[GL00<00;GL]M`00kGL
0`001;GL00<00;GL]M`00P000[GL00<00;GL]M`00kGL00@00;GL000000>eg003002eg;GL00>eg080
00Jeg003002efkGK008000:ef`03002efkGK00:ef`<000Fef`03002efkGK008000:ef`03002efkGK
00>ef`<000Bef`03002efkGK008000:ef`03002efkGK00Bef`8000Bef`03002efkGK008000:ef`03
002efkGK00>ef`8000Jef`03002efkGK008000:ef`03002efkGK00:ef`8000Jmf`04002mf`000003
_M/01000_M^mfkgK0P0000>mf`00_MX01KgJ00<00;gJ_MX00kgJ00@00;gJ000000>m^P03002m^[fj
00:m^P<000Fm^P8000Jm^P03002m^[fj00Bm^P030035^P0000C5^P040035^@000003aKT00`00aKW5
^@020002aKT01@00aKW5^LFi00000/Fi00@00<FiaKW5^@8000;5^@03003=^<fh008000;=^004003=
^<fh0003cKP01000cKS=^0000lfH00<00=FG00001LfG00<00=FGeIL00mFG0P001=FF00H00=FFeIH0
0=fE0005gIH01@00gIGMUMfE00000mee0P001>Ed00@00=ed000000CULP03003ULnEc008000;]L003
003]LNea00;]L@04003]D>e@0002mDl00`00kE3]D0020002iA400`00kC000003mDl00`00ool0000@
ool000koo`03003ooooo01goo`8000_oo`03002]o:gl00>]o003002]o:gl00:]o0<000F]o0800003
[O`0000000:]o003002]o:gl00>]o003002]o:gl008000:]o003002]o:gl00>]o0<000B]o003002]
o:gl00>]o08000F]o0800003[O`0000000:]o003002]o:gl00>]o0<000B]o003002]o:gl00>]o0<0
00F]o003002]o:gl008000:]o003002]o:gl00>]o003002]o:gl008000:]o003002]o:gl00>]o080
00F]o003002]o:gl008000:]g003002]g:gL00>]g003002]g:gL008000:]g003002]g:gL00>]g0<0
00F]g003002eg;GL00800003[M`00;GL00Beg003002eg;GL008000:eg003002eg;GL00>eg0<000Fe
g003002eg;GL008000:eg003002eg;GL00:eg0<000Beg003002eg;GL00>eg08000Jeg003002eg;GL
008000:eg003002eg;GL00>eg0<000Bef`03002efkGK008000:ef`03002efkGK00>ef`<000Fef`03
002efkGK00800003]M/00;GK00Fef`8000Bef`03002efkGK00:ef`<000Jef`8000Fef`03002efkGK
008000:ef`03002efkGK00Bef`8000Bef`03002efkGK008000:ef`03002mfkgK00>mf`8000Fmf`04
002mf`000003_M/00`00_MZmfP02_MX30006_MX00`00_KZm^P04_KX01000_KX000000kfj00<00;fj
_KX00P000[fj00@00;fj_KZm^P800003_KX00;fj00Fm^P030035^/Fj00C5^P030035^LFi00?5^@03
0035^@0000G5^@030035^@0000C5^@030035^@0000C5^@03003=^00000C=^003003=^00000G=^080
00G=V003003=UlfG00?=U`8000GEU`03003EU`0000;EUP8000?EUP8000CMUP03003EUP0000;MU@03
003MMMee00;MM@05003UM>EdiG@00002gG@20004iG800`00iG?UL`020002kG000`00kG7]L@02kG40
1000kE3]D0000_E?00<00>e@kE000P000^DA00<00>d`00000oE?00<00?oo00004?oo000>ool00`00
ooooo`0Jool3000>ool00`00[Ob]o003[O`01000[O`000000Zgl00<00:gl[O`01:gl0P001Jgl00<0
0:gl[O`00Zgl0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<0
0:gl[O`00jgl0P001Jgl0P0000>]o00000000Zgl00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<0
0:gl[O`00jgl0`001:gl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00Zgl
0`001:gL00<00:gL[M`00jgL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL0`001:gL00<0
0;GL]M`00[GL0`001KGL00<00;GL]M`00P000[GL00<00;GL]M`00kGL0`001KGL00@00;GL000000:e
g003002eg;GL00>eg003002eg;GL008000:eg003002eg;GL00>eg0<000Feg003002eg;GL008000:e
g003002efkGK00:ef`<000Fef`03002efkGK008000:ef`03002efkGK00Bef`8000Bef`04002efkGK
]M/200000kGK002ef`04]M/01000]M/000000kGK00@00;GK]M^ef`800003]M/00;GK00Fef`8000Be
f`03002efkGK00:ef`<000Jef`8000Fef`03002mfkgK008000:mf`03002mfkgK00:mf`8000Jmf`04
002mfP000003_MX01000_MZmf[gJ0P0000>mfP00_KX01Kfj00<00;fj_KX00kfj00<00;fj00001;fj
00@00;fj000000>m^P03002m^[fj00:m^P<000G5^P8000K5^@030035^LFi00G5^@030035^LFi00C5
^@030035^LFi00C5^@03003=^<fh00C=^003003=^<fh00C=^003003=V<fH00?=V003003=V00000C=
U`03003=U`0000?EU`06003EUmFG003EUP000]FF00@00=FFeIH000GMUP05003EUP00gID00005gGD0
1@00iGCUM>Ed00000med00<00>EbiG800^Eb00D00>EciG?UL`0000;]L003003]LNea00;]L@800005
kE000?E?mDl00003kE001P00iA7U4@00kC0000?eC`04003ooooo000?ool000koo`03003ooooo01Oo
o`<0017oo`03002]o:gl00>]o08000F]o08000:]o08000:]o003002]o:gl00>]o004002]o0000002
[O`00`00[Ob]o003[O`30005[O`01000[Ob]o:gl10001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`0
0jgl0P001Jgl00<00:gl[O`00Zgl0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl00<00:gl
[O`00P000Zgl00<00:gl[O`00jgl0`001Jgl00@00:gl000000:]g003002]g:gL00>]g003002]g:gL
008000:]g003002]g:gL00>]g0<000F]g003002]g:gL008000:]g003002]g:gL00:]g003002eg;GL
008000:eg003002eg;GL00>eg0<000Feg003002eg;GL008000:eg003002eg;GL00Beg003002eg;GL
00:eg003002eg;GL00>eg0<000Feg003002eg;GL008000:eg003002eg;GL00>eg0<000Beg003002e
fkGK008000:ef`03002efkGK00Bef`8000Bef`03002efkGK00:ef`<000Fef`04002ef`000003]M/0
0`00]M^ef`03]M/20005]M/01000]M/000000kGK00<00;GK]M/00[GK0P0000>ef`00]M/01;GK00@0
0;GK000000>ef`04002efkGK]M/200000kGK002ef`05]M/20004_M/00`00_M^mf`020002_M/00`00
_M^mf`03_M/20005_MX01000_MX000000kgJ00<00;fj_KX00[fj0`001[fj00<00;fj_KX01;fj00<0
0;fj_KX01;fj00@00;fj000000>m^P030035^/Fj008000;5^P040035^LFiaKT200000lFi0035^@04
aKT20005aKT20005aKT20005cKP20005cKP00`00cIP00004cIP00`00cIP00003cIL01000cIO=U`00
0mFG00@00=FGeIOEU`8000?EUP03003EUP0000CMUP06003EU]FF003MU@001Mee00D00>EdiGCUM000
00?MM005003UL^EbiG800004iG<01000kG3]L0001>ea0P0000G]D000mDoeC`0000?]D004003U4NDA
0002kC001000mDoeC`000_oo00<00?ooool03Ooo000=ool00`00ooooo`0Eool3000Eool00`00[Ob]
o0020002[O`00`00[Ob]o003[O`30005[O`01000[Ob]o:gl0`001Jgl0P0000>]o00000000Zgl00<0
0:gl[O`00jgl10000jgl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl
00@00:gl000000:]o003002]o:gl00>]o0<000B]o003002]o:gl00>]o0<000F]o003002]o:gl0080
00:]o003002]o:gl00>]o08000B]g003002]g:gL00>]g0<000F]g003002]g:gL008000:]g003002]
g:gL00>]g0<000B]g003002]g:gL00:]g0<000Feg003002eg;GL008000:eg003002eg;GL00>eg0<0
00Beg003002eg;GL00:eg0<000Feg003002eg;GL008000:eg003002eg;GL00>eg0<000Feg003002e
g;GL00800003]M`00;GL00Feg08000Bef`03002efkGK00:ef`800003]M/00;GK00Bef`04002ef`00
0003]M/00`00]M^ef`02]M/20006]M/00`00]M^ef`020002]M/00`00]M^ef`02]M/20006]M/01000
]M/000000kGK00<00;GK]M/00kGK0P001KGK00@00;GK000000>ef`03002efkGK00:ef`<000Jmf`80
00Fmf`03002mfkgK00800003_M/00;gJ00FmfP03002mf[gJ00BmfP04002m^P000003_KX01000_KZm
^[fj0P0000>m^P00_KX00[fj0P0000>m^P00_KX01Kfj00<00;fj_KX00kfj00<00<Fj00001<Fj00@0
0<Fi000000?5^@040035^LFiaKT20002aKT00`00aKW5^@020002aKT01@00aKW5^LFi00000/Fi00D0
0<fhcKS=^00000;5^005003=^<fhcKP00002cIP01@00cIS=V<fH00000lfH00<00<fG00001<fG00<0
0=FG00001=FG00<00=FFeIH00mFF00<00=FF00000mfF00H00=FFeIH00=fE0004gGD01@00gGD00>Ed
00001=ed00D00>EbiG;ULP0000CUL`04003]L>e`0003kG401@00iE800>e@00000_E?00D00>e@kE3]
D00000;U4@04003]<>d`0002mDl01000ooooo`003ooo000=ool00`00ooooo`0Bool3000Iool20005
[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`40003[O`00`00[Ob]o003[O`20005[O`200000jgl
00000002[O`00`00[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30004[O`00`00[Ob]
o003[O`20005[O`200000jgl00000002[O`00`00[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]
o003[O`30005[O`00`00[Ob]o0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]
g003[M`30005[M`00`00[Mb]g0020002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00;GL]M`0
0kGL0`001KGL00<00;GL]M`00P000[GL00<00;GL]M`00kGL00@00;GL000000>eg003002eg;GL00:e
g0<000Feg003002eg;GL008000:eg003002eg;GL00>eg0<000Beg004002eg;GL]M`200000kGL002e
f`04]M/01000]M/000000kGK00<00;GK]M/00kGK0P001KGK00<00;GK]M/00P000[GK00<00;GK]M/0
0kGK0`001;GK00<00;GK]M/00P000[GK00<00;GK]M/00kGK0P001[GK00<00;GK]M/00P000[GK00<0
0;GK]M/00[GK0P001[GK00@00;GK000000>ef`04002mfkgK_M/200000kGK002mf`05_M/20004_M/0
1000_MZmf[gJ0P0000>mf`00_MX01KgJ00<00;fj_KX00kfj00@00;fj000000>m^P04002m^P000003
_KX00`00_KZm^P02_KX30006_KX00`00aK[5^P04aKX00`00aKW5^@04aKT00`00aKT00004aKT00`00
aKT00004aKT01000aKW5^@000lFi00@00<fhcKP000?5^004003=^<fh0004cIP00`00cIP00004cIP0
0`00cIL00004cIL00`00eIL00003eIL20005eIH00`00eIH00002gIH00`00eIKEUP02eIH00`00gGGM
M@03gGD01@00gGD00>Ed00001=ed0P000^Eb00@00>EciG?UL`8000;]L009003]LNeakG400>EB003]
D00000;eC`05003]D>e@kE000002iA401000kC3]<0000_E?00@00?ooool000ooo`003Ooo00<00?oo
00000P003Ooo0`007Ooo00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl
00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0P001Jgl00<00:gl[O`00Zgl0`001Jgl00<00:gl[O`0
0P000Zgl00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0P001Jgl00@00:gl[Ob]
o0@000F]o003002]o:gl008000:]o003002]o:gl00>]o0<000B]g003002]g:gL00:]g0<000F]g003
002]g:gL008000:]g003002]g:gL00>]g0<000B]g003002]g:gL00>]g08000F]g003002eg;GL0080
00:]g003002eg;GL00>eg0<000Beg003002eg;GL00>eg08000Feg003002eg;GL008000:eg003002e
g;GL00>eg0<000Feg003002eg;GL00800003]M`00;GL00Beg004002eg0000003]M`00`00]M^ef`03
]M/20006]M/00`00]M^ef`020002]M/00`00]M^ef`02]M/30005]M/00`00]M^ef`020002]M/00`00
]M^ef`02]M/30005]M/00`00]M^ef`020002]M/00`00]M^ef`04]M/20004]M/00`00]M^ef`020002
]M/00`00]M^ef`03]M/20005]M/01000_M/000000kGK00<00;gK_M/00[gK0`001KgK00@00;gJ0000
00>mf`03002mf[gJ00:mfP<000Jm^P03002m^[fj00Bm^P03002m^[fj00Bm^P04002m^P000003_KX0
1000_KZm^[fj0`001LFj00<00;fj00001/Fi00<00<FiaKT01<Fi00<00<FiaKT01<Fi0P001LFi0P00
1LFh0P001LfH00<00<fH00001LfH00<00<fGcIL01<fG00<00=FGeIL00]FG00<00<fG00000mFF00L0
0=FF003EUP00gIH00004eIH00`00gGGMM@02gGD01P00gGGMM@00iG@000?MM003003MM00000;ULP09
003ULnEciG<00=eC003]L00000?]L@03003UD^EB008000;eC`05003]D>e@kE000002iA401000kC3]
<0000_E?0P0000?oo`00ool03_oo000=ool2000=ool3000Qool200000jgl00000002[O`00`00[Ob]
o003[O`30004[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`01000
[O`000000Zgl00<00:gl[O`00jgl0`001:gl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl
00<00:gl[O`00Zgl10000jgl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl00<00:gL[M`0
0jgL00@00:gL000000:]g003002]g:gL00>]g0<000F]g003002]g:gL008000:]g003002]g:gL00>]
g003002]g:gL008000:]g003002]g:gL00:]g0<000F]g003002eg;GL008000:eg003002eg;GL00>e
g003002eg;GL008000:eg003002eg;GL00:eg0<000Feg003002eg;GL008000:eg003002eg;GL00Be
g08000Beg003002eg;GL00:eg08000Jeg003002efkGK008000:ef`03002efkGK00>ef`<000Bef`03
002efkGK008000:ef`03002efkGK00Bef`8000Fef`04002ef`000002]M/00`00]M^ef`04]M/20004
]M/00`00]M^ef`02]M/30006]M/20005]M/00`00]M^ef`0200000kGK002ef`05]M/00`00]M^ef`04
]M/01000_M/000000kgK00<00;gK_M/00[gK0P001[gK00@00;gJ000000>m^P04002m^[fj_KX20000
0kfj002m^P02_KX200000kfj002m^P05_KX00`00_KZm^P03_KX01000_KX000000kfj00<00<FjaKX0
0P000[fj00<00<FiaKT00lFi0P001LFi0P001/Fi00<00<FiaKT01<Fi00<00<FhaKP01<Fh00<00<fH
cIP01LfH00<00<fHcIP00lfH0P001LfG0P000mFG00@00<fGcIL000?EUP03003EU]FF00<000GEUP03
003MMMee00;MM@05003MMMeegGD00004gG@00`00gG@00002iG802@00iG?ULnEc003MD`00kG000003
kG400`00iE;UDP020002mDl01000kE3]D>e@0P0000GU4@00kC3]<00000;eC`800003ool00?oo00ko
o`003Ooo00<00?ooool02Ooo0`009_oo00<00:gl[O`00jgl0P0000>]o00000000Zgl00<00:gl[O`0
0jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001:gl00<00:gl[O`00jgl0P001Jgl00<00:gl
[O`00P000Zgl00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001Jgl00@00:gl
000000:]o003002]o:gl00>]o003002]o:gl008000:]o003002]o:gl00>]o0<000B]o003002]g:gL
00>]g08000F]g003002]g:gL008000:]g003002]g:gL00>]g0<000B]g003002]g:gL00>]g0<000F]
g004002]g0000002[M`00`00[Mb]g003[M`30004]M`00`00]Mbeg003]M`30005]M`01000]M`00000
0[GL00<00;GL]M`00kGL0`001;GL00<00;GL]M`00[GL0P0000>eg000]M`00kGL00<00;GL]M`00P00
0[GL00<00;GL]M`00kGL0`001KGK00<00;GK]M/00P000[GK00<00;GK]M/00[GK0`001;GK00<00;GK
]M/00[GK0P0000>ef`00]M/01KGK00<00;GK]M/00[GK00<00;GK]M/00[GK0P0000>ef`00]M/01;GK
00@00;GK000000>ef`04002efkGK]M/200000kGK002ef`05]M/20004]M/01000]M^efkGK0P0000>e
f`00]M/01KGK00<00;gK_M/00kgK00<00;gK_M/00P000[gK00<00;gK_M/00kgK0P001Kfj00@00;fj
000000>m^P04002m^P000003_KX00`00_KZm^P02_KX30006_KX00`00_KZm^P03_KX00`00aKX00005
_KX00`00aKW5^@020002aKT00`00aKW5^@020002aKT00`00aKW5^@02aKT20005aKT00`00aKT00004
aKP00`00aIT00005cIP20004cIP01000cIS=V0000lfG00@00<fGcIL000;EU`07003=UlfGcIL00=FF
00001=FF0P001=FF00<00=Ef00000mee00D00=eegGGMM@0000CMM006003MM=ed003ULP000nEc00@0
0=eC000000C]L@03003UD^EB008000;eC`04003]D>e@kE020002iA400`00kC000002mDl200000ooo
003oo`0>ool000;oo`8000Woo`03003ooooo00Ooo`8002[oo`03002]o:gl00>]o08000F]o003002]
o:gl00:]o0<000F]o003002]o:gl008000:]o003002]o:gl00>]o003002]o:gl008000:]o003002]
o:gl00:]o0<000B]o003002]o:gl00>]o0<000F]o003002]o:gl008000:]o003002]o:gl00>]o080
00F]o003002]o:gl00:]o0<000F]o003002]o:gl008000:]o003002]o:gl00>]o003002]g:gL0080
00:]g003002]g:gL00:]g0<000F]g003002]g:gL008000:]g003002]g:gL00>]g003002]g:gL0080
00:]g003002]g:gL00>]g08000F]g003002]g:gL008000:]g003002eg;GL00>eg003002eg;GL0080
00:eg003002eg;GL00>eg08000Feg003002eg;GL008000:eg003002eg;GL00>eg004002eg0000003
]M`00`00]Mbeg002]M`30005]M`00`00]Mbeg0020002]M`00`00]M^ef`03]M/30004]M/00`00]M^e
f`020002]M/00`00]M^ef`03]M/01000]M/000000kGK00<00;GK]M/00[GK0`001KGK00@00;GK0000
00>ef`03002efkGK00>ef`8000Fef`04002ef`000003]M/00`00]M^ef`02]M/30005]M/01000]M/0
00000kGK00<00;GK]M/00[GK0`001[gK0P001KgK00<00;gK_M/00P000[fk00<00;fj_KX00[fj0P00
1[fj00<00;fj_KX01;fj00@00;fj000000>m^P04002m^[fj_KX30006_KX00`00_KZm^P04_KX00`00
aKT00004aKT00`00aKT00004aKT00`00aKW5^@020002aKT00`00aKW5^@020002aKT01@00aKS5^<Fh
00000/FI00<00<fHcIP00/fH00@00<fHcIP000;=V005003=V<fHcIP00002cIL01`00cIO=UlfG003E
U`0000C=U`03003EUP0000CEUP8000CEUP03003EMP0000;MM@03003MMMee00;MM@03003MM=ed00;M
M003003MM=ed008000?UL`03003MDmeC008000C]L@03003UD^EB008000;eC`04003]D>e@kE020002
iA400`00kC000002mDl20002ool00`00ooooo`0<ool00005ool00?ooool00007ool00`00ooooo`05
ool3000]ool00`00[Ob]o0020002[O`00`00[Ob]o003[O`01000[O`000000Zgl00<00:gl[O`00jgl
0`001:gl00<00:gl[O`00jgl0`001Jgl00@00:gl000000:]o003002]o:gl00>]o003002]o:gl0080
00:]o003002]o:gl00>]o0<000F]o003002]o:gl008000:]o003002]o:gl00>]o004002]o0000002
[O`00`00[Ob]o003[O`30004[O`00`00[Ob]o003[O`30005[M`01000[M`000000ZgL00<00:gL[M`0
0jgL0`001:gL00<00:gL[M`00jgL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL0`001:gL
00<00;GL]M`00kGL0`001KGL00<00;GL]M`00P000[GL00<00;GL]M`00[GL0`001;GL00<00;GL]M`0
0kGL0P001[GL00@00;GL000000:eg003002eg;GL00>eg0<000Feg003002efkGK00800003]M/00;GK
00Fef`8000Bef`03002efkGK00>ef`8000Jef`04002ef`000003]M/00`00]M^ef`02]M/20006]M/0
0`00]M^ef`020002]M/00`00]M^ef`02]M/20006]M/01000]M/000000kGK00<00;GK]M/00[GK0P00
1[GK00@00;GK000000>ef`04002mfkgK_M/200000kGK002mf`05_M/20004_K/00`00_KZm^P020002
_KX01000_KZm^[fj0P0000>m^P00_KX01Kfj00<00;fj_KX00kfj00@00;fj000000>m^P04002m^[fj
_KX200000kfj002m^P05_KX00`00aKW5^@04aKT00`00aKW5^@04aKT20004aKT00`00aKT00005aKT0
0`00aKP00004aIT01000cIS=V0000lfH00<00<fH00001LfH0P001LfG0P001LfG00<00=FFeIH00mFF
0`000]FF00L00=EfeGKEMP00gGD00003gGD00`00eGD00002gG@00`00gGCMM002gG@01@00iG?ULnEc
00000meC00<00>eakG400^ea00D00>EBiE;UDP0000;eC`04003]D>e@kE020002iA400`00kC000002
mDl20002ool00`00ooooo`0<ool000Coo`03003ooooo00Goo`03003ooooo00;oo`<0037oo`8000F]
o004002]o:gl[O`30005[O`200000jgl00000002[O`00`00[Ob]o003[O`00`00[Ob]o0020002[O`0
0`00[Ob]o003[O`20005[O`20002[O`40005[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30004
[O`00`00[Ob]o003[O`20005[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`00`00[Ob]o0020002
[M`00`00[Mb]g003[M`20005[M`200000jgL00000002[M`00`00[Mb]g003[M`00`00[Mb]g0020002
[M`00`00[Mb]g003[M`30005[M`01000[M`000000ZgL00<00:gL[M`00jgL00<00;GL]M`00P000ZgL
00<00;GL]M`00kGL0`001;GL00<00;GL]M`00P000[GL00<00;GL]M`00kGL00<00;GL]M`00P000[GL
00<00;GL]M`00kGL0P001KGL00<00;GL]M`00P000[GL00<00;GL]M`01;GL0P001;GK00@00;GK]M^e
f`800003]M/00;GK00Bef`03002efkGK008000:ef`03002efkGK00>ef`8000Fef`03002efkGK0080
00:ef`03002efkGK00>ef`<000Bef`03002efkGK008000:ef`03002efkGK00>ef`8000Fef`03002e
fkGK008000:ef`03002efkGK00>ef`8000Fef`04002mf`000003]M/00`00_M^mf`02_M/30006_K/2
0004_KX01000_KX000000kfj00<00;fj_KX00[fj0`001[fj00<00;fj_KX00kfj00@00;fj000000>m
^P03002m^[fj00:m^P<000G5^@8000K5^@030035^LFi00C5^@030035^LFi00G5^@030035VLFI00?5
V@03003=V00000G=V003003=V<fH00C=V003003=UlfG00C=U`03003=UlfG00?=U`8000CEUP04003E
UmFG0002eIH01000eGKEM]Ef0P001=ee00<00=Ee00000]ed00<00=edgG@00]ed00D00>EciG?UL`00
00?MD`05003]LNeakG400004iE801000mDoeC`000ne@00L00>Da003U4@00kC000002mDl20002ool0
0`00ooooo`0<ool000;oo`8000Soo`03003oo`00008003Goo`03002]o:gl00>]o0@000>]o003002]
o:gl00>]o08000F]o08000:]o0@000F]o003002]o:gl008000:]o003002]o:gl00>]o0<000>]o003
002]o:gl00>]o0<000F]o003002]o:gl008000:]o003002]o:gl00>]o003002]o:gl008000:]o003
002]o:gl00:]o0<000B]o003002]o:gl00>]o0<000F]g003002]g:gL008000:]g003002]g:gL00>]
g08000B]g003002]g:gL00>]g0<000F]g003002]g:gL008000:]g003002]g:gL00>]g08000B]g003
002]g:gL00>]g0<000F]g003002eg;GL008000:eg003002eg;GL00>eg08000Beg003002eg;GL00>e
g0<000Feg003002eg;GL008000:eg003002eg;GL00:eg0<000Beg003002eg;GL00:eg0800003]M`0
0;GK00>ef`04002ef`000003]M/00`00]M^ef`03]M/30005]M/00`00]M^ef`020002]M/00`00]M^e
f`02]M/30005]M/00`00]M^ef`0200000kGK002ef`05]M/20005]M/00`00]M^ef`0200000kGK002e
f`05]M/20005]M/00`00]M^ef`020002]M/00`00]M^ef`02]M/20006]M/01000_M/000000kfk00@0
0;fk_K^m^`<000Jm^P03002m^[fj00Bm^P04002m^P000003_KX01000_KZm^[fj0`001[fj00<00;fj
_KX01;fj00@00;fj000000>m^P030035^LFi008000:m^@040035^LFiaKT200000lFi0035^@03aKT0
0`00aKT00005aKT20006aIT00`00cIS=V003cIP20005cIP20005cIL20004cIL01000cIO=U`000]FF
00L00=FGeIOEU`00eIH00005eGH01@00gGGMMMee00000mEe00<00=ed00001=ed00D00>EciG?UL`00
00?MD`05003]LNeakG400004iE801000mDoeC`000^e@00P00>DaiC400>DA003]<0000_E?00D00>d@
003oo`0000koo`001?oo00<00?ooool01Ooo0P00>Ooo00<00:gl[O`00P000Zgl00<00:gl[O`00jgl
00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`000jgl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`0
0P000Zgl00<00:gl[O`00Zgl0P0000>]o00000000Zgl00<00:gl[O`00jgl0`001:gl00<00:gl[O`0
0jgl0`001Jgl00@00:gl000000:]o003002]o:gl00>]o003002]o:gl008000:]g003002]g:gL00>]
g0<000F]g003002]g:gL008000:]g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00>]
g0<000F]g003002]g:gL00800003[M`00:gL00B]g003002]g:gL008000:]g003002]g:gL00>]g0<0
00Beg004002eg;GL]M`200000kGL002eg004]M`00`00]Mbeg0020002]M`00`00]Mbeg003]M`30004
]M`00`00]Mbeg0020002]M`00`00]Mbeg003]M`01000]M`000000kGL00<00;GK]M/00[GK0P001[GK
00<00;GK]M/00P000[GK00<00;GK]M/00kGK0`001;GK00<00;GK]M/00P000[GK00<00;GK]M/01;GK
0P001;GK00@00;GK]M^ef`800003]M/00;GK00Fef`8000Bef`04002efkGK]M/200000kGK002ef`05
]M/20004]M/00`00]M^ef`020002]M/00`00]M^ef`04]M/00`00_K^m^`03_K/01000_K/000000kfk
00@00;fj_KZm^P800003_KX00;fj00Fm^P03002m^[fj00>m^P04002m^P000003_KX01000_KZm^[fj
0P0000>m^P00_KX01Kfj00<00;fj_KX00kfj00<00<Fi00001;fi00@00<Fi000000?5^@050035^LFi
aKT00002aKT01000aKW5^LFi0P000/FI00<00<FIaIT00/FI0P001<fH00@00<FHaIP000?=V004003=
V<fH0003cIL01000cIS=V0000lfG00H00<fGcIL00=FF0005eIL20004eGH20003gGD01`00eGGEMMEe
003MM00000?MM005003MM@00iG<00004gE<01@00kG7]LNea00001>EB0P0000GeC`00kE3]D00000;U
<@05003U4@00kC000002mDl01@00kA000?oo00003_oo00001Ooo003ooooo00002?oo00<00?ooool0
>?oo0P001:gl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00Zgl00<00:gl
[O`00P000Zgl00<00:gl[O`00jgl0`001:gl00<00:gl[O`00jgl0P001Jgl0P0000>]o00000000Zgl
00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0P001Jgl0P000Zgl10001JgL00<0
0:gL[M`00P000ZgL00<00:gL[M`00jgL0`001:gL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`00P00
0ZgL00<00:gL[M`00jgL0`001:gL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`00P000ZgL00<00;GL
]M`00kGL00<00;GL00000kGL00<00;GL]M`00kGL0`001KGL00<00;GL]M`00P000[GL00<00;GL]M`0
0[GL0`001;GL00<00;GL]M`00kGL0P001[GL00@00;GK000000:ef`03002efkGK00>ef`<000Fef`03
002efkGK00800003]M/00;GK00Fef`8000Bef`03002efkGK00:ef`<000Fef`04002ef`000003]M/0
0`00]M^ef`02]M/30005]M/01000]M/000000kGK00<00;GK]M/00[GK0`001[GK0P001;GK00<00;GK
]M/00[GK0`001[fk00<00;fk_K/00kfk00@00;fj000000>m^P03002m^[fj00:m^P<000Jm^P03002m
^[fj00>m^P04002m^P000003_KX00`00_KZm^P02_KX30006_KX00`00_KVm^@04_KT00`00aKW5^@04
aKT00`00aKT00004aKT00`00aKT00004aIT00`00aIW5V@020002aIT01000cIS=V0000lFH00@00<fH
cIP000?=V004003=UlfG0003cIP01000cIO=U`001<fG0P001MFG0P001=Ef00D00=Ef003MM@0000GE
M@03003MM=ed00;MM005003MM@00iG<00004gE<20002kG400`00iE;UDP02iE8200001OE?003]D>e@
00000^Da00D00>DA003]<00000;eC`05003]4000ool0000>ool000;oo`8000[oo`8003Woo`03002]
o:gl00>]o003002]o:gl008000:]o003002]o:gl00>]o0<000B]o003002]o:gl00:]o0<000F]o003
002]o:gl008000:]o003002]o:gl00>]o003002]o:gl008000:]o003002]o:gl00>]o08000B]o003
002]o:gl00>]o0<000F]o003002]o:gl008000:]o003002]o:gl00>]o0<000>]g003002]g:gL00>]
g0<000F]g003002]g:gL008000:]g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`3
0005[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g003[M`3
0004[M`00`00]Mbeg003]M`20005]M`00`00]Mbeg0020002]M`00`00]Mbeg003]M`30004]M`00`00
]Mbeg0020002]M`00`00]Mbeg003]M`00`00]Mbeg0020002]M`00`00]Mbeg003]M`20005]M/00`00
]M^ef`020002]M/00`00]M^ef`03]M/30004]M/01000]M^efkGK0P0000>ef`00]M/01;GK00@00;GK
000000>ef`03002efkGK00:ef`8000Jef`04002ef`000003]M/00`00]M^ef`02]M/20006]M/01000
]M/000000kGK00@00;GK]M^ef`800003]M/00;GK00Bef`04002ef`000003]K/01000_K^m^kfk0`00
1[fk00<00;fj_KX01;fj00@00;fj000000>m^P04002m^[fj_KX200000kfj002m^P04_KX00`00_KZm
^P04_KX01000_KX000000kfj00@00;fj_KZm^P<000Fm^@03002m^P0000K5^@030035^LFi00C5^@03
0035VLFI00C5V@8000C5V@03003=V00000G5V08000G=V08000G=V08000G=U`03003EUmFG00?EU`80
0005eGH00=EfeGH00002eGH00`00gGD00005eGD01@00gGCMM=ed00000]ee00<00>Ec00000meC00<0
0=eD00000^ea00T00>EBiE;UDP00iE<00?E?00000^e@00@00>DaiC7U<@800003kC000?E?00;eC`80
0003ool00?oo00goo`004?oo00<00?ooool0=ooo00<00:gl[O`00Zgl0`001Jgl00<00:gl[O`00P00
0Zgl00<00:gl[O`00jgl00@00:gl000000:]o003002]o:gl00>]o0<000B]o003002]o:gl00>]o0<0
00F]o003002]o:gl008000:]o003002]o:gl00:]o003002]o:gl008000:]o003002]o:gl00>]o0<0
00F]o003002]o:gl008000:]o003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00>]g0<0
00B]g003002]g:gL00>]g08000F]g003002]g:gL008000:]g003002]g:gL00>]g0<000B]g003002]
g:gL00:]g0<000F]g003002]g:gL008000:]g003002]g:gL00>]g003002eg;GL008000:]g003002e
g;GL00:eg0<000Feg003002eg;GL008000:eg003002eg;GL00>eg08000Beg003002eg;GL00>eg0<0
00Feg003002eg;GL008000:eg003002efkGK00:ef`<000Fef`03002efkGK00800003]M/00;GK00Be
f`04002ef`000003]M/00`00]M^ef`03]M/20005]M/00`00]M^ef`020002]M/00`00]M^ef`03]M/2
0005]M/00`00]M^ef`020002]M/00`00]M^ef`03]M/20005]M/01000]M/000000kGK00<00;GK]M/0
0kGK0P001KFk00@00;fk000000>m^`04002m^kfk_K/200000kfk002m^P05_KX00`00_KZm^P03_KX0
1000_KX000000kfj00@00;fj_KZm^P800003_KX00;fj00Fm^P03002m^[fj00>m^P04002m^P000003
_KX00`00_KVm^@020002_KX00`00aKW5^@03aKT20005aKT20006aIT00`00aIW5V@04aIT00`00aIS5
V004aIP00`00cIS=V004cIP00`00cIS=V004cIP00`00cIO=U`03cIL20004eIL00`00cGO=M`020000
0mEf003EMP03eGH00`00eGGEM@03eGD20003gG@01P00gGGMM@00iG<000?MD`03003ME00000;]L@09
003UD^EBiE800>EC003eC`0000;]D004003U<NDaiC4200000nd`003eC`02mDl20002ool00`00oooo
o`0;ool0017oo`03003ooooo03Ooo`04002]o0000002[O`00`00[Ob]o003[O`30005[O`01000[Ob]
o:gl0`001Jgl0P0000>]o00000000Zgl00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<00:gl[O`0
0jgl0`001Jgl00<00:gl[O`010001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`001:gl00<0
0:gL[M`00ZgL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL00<00:gL[M`00P000ZgL00<0
0:gL[M`00ZgL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL00@00:gL000000:]g003002]
g:gL00>]g0<000B]g003002]g:gL00>]g0<000B]g003002eg;GL008000:eg003002eg;GL00>eg0<0
00Beg004002eg;GL]M`200000kGL002eg004]M`00`00]Mbeg0020002]M`00`00]Mbeg003]M`30004
]M`00`00]M^ef`020002]M/00`00]M^ef`04]M/20004]M/00`00]M^ef`02]M/20006]M/00`00]M^e
f`020002]M/00`00]M^ef`02]M/30005]M/00`00]M^ef`020002]M/00`00]M^ef`02]M/30005]M/0
0`00]M^ef`020002]M/00`00]M^ef`02]M/20006]M/00`00]M^ef`020002]K/00`00]K^e^`02]K/2
0005_K/01000_K/000000kfk00<00;fj_KX00[fj0`001[fj00<00;fj_KX01;fj00<00;fj00000kfj
00<00;fj_KX00[fj0`001[fj00<00;fj_KX00kfj00<00;fi00001Kfj00<00<FiaKT00P000/Fi00<0
0<FiaKT00P000/FI00<00<FIaIT00/FI0P001LFI0P001LFH0P001LfH0P001LfH0P001<fG00@00<fG
cIL000?EU`06003=Mleg003EMP001MEf00<00=EeeGD00mEe00<00=Ef00000]ed00D00=eegGGMM@00
00CMD`03003ME=eD008000CUDP03003UDnEC008000;]D004003U<NDaiC4200000nd`003eC`02mDl0
1@00kA000?oo00003Ooo000Bool00`00ooooo`0gool00`00[Ob]o003[O`200000jgl00000002[O`0
0`00[Ob]o003[O`40003[O`00`00[Ob]o003[O`20005[O`20002[O`40005[O`00`00[Ob]o0020002
[O`00`00[Ob]o003[O`30003[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002[O`00`00[Ob]
o003[O`01000[M`000000ZgL00<00:gL[M`00jgL0`001:gL00<00:gL[M`00jgL0`001JgL00@00:gL
000000:]g003002]g:gL00>]g0<000B]g003002]g:gL00>]g08000F]g003002]g:gL008000:]g003
002]g:gL00>]g003002]g:gL008000:]g003002]g:gL00:]g0<000Feg003002eg;GL008000:eg003
002eg;GL00>eg003002eg00000>eg003002eg;GL00>eg0<000Feg003002eg;GL008000:eg003002e
g;GL00:eg0<000Bef`03002efkGK00:ef`<000Fef`03002efkGK008000:ef`03002efkGK00>ef`<0
00Bef`03002efkGK008000:ef`03002efkGK00>ef`<000Bef`03002efkGK008000:ef`03002efkGK
00Bef`8000Bef`03002efkGK008000:ef`03002efkGK00Bef`8000Be^`03002e^kFk008000:e^`03
002m^kfk00:m^`8000Jm^`04002m^P000003_KX01000_KZm^[fj0P0000>m^P00_KX01Kfj00<00;fj
_KX00kfj00@00;fj000000>m^P04002m^[fj_KX30006_KX00`00_KZm^P04_KX00`00aKT00004aKT0
0`00aKT00004aIT00`00aIW5V@020002aIT00`00aIW5V@020002aIT01@00aIS5V<FH00000/FH00D0
0<fHcIS=V00000;5V005003=V<fHcIP00002cIP01@00cIO=UlfG00000/fG00@00=FGeIL000C=M`<0
00CEMP03003EMMEe00;EM@06003EM]Ef003MM0001=ee00<00=eCgE<00]eC00<00=eDgE@00P001>EB
00<00>ECiE<00P000^e@00@00>DaiC7U<@800003kC000?E?00;eC`05003]4000ool0000=ool001?o
o`8003Soo`03002]o:gl00>]o08000F]o0800003[O`0000000:]o003002]o:gl00>]o003002]o:gl
008000:]o003002]o:gl00>]o0<000>]o003002]o:gl00>]o0<000F]o003002]o:gl008000:]o003
002]o:gl00:]o0800003[O`0000000:]o003002]o:gl00>]o0<000B]o003002]o:gl00>]o08000F]
g003002]g:gL008000:]g003002]g:gL00>]g003002]g:gL008000:]g003002]g:gL00>]g08000F]
g003002]g:gL008000:]g003002]g:gL00>]g003002]g:gL008000:]g003002]g:gL00:]g0<000B]
g003002]g:gL00>]g0<000F]g004002]g0000002[M`00`00]Mbeg003]M`30004]M`00`00]Mbeg003
]M`20005]M`00`00]Mbeg0020002]M`00`00]Mbeg003]M`30004]M`00`00]Mbeg0020002]M`00`00
]M^ef`03]M/01000]M/000000kGK00<00;GK]M/00[GK0`001KGK00<00;GK]M/00P000[GK00<00;GK
]M/00[GK0`001KGK00<00;GK]M/00P0000>ef`00]M/01KGK0P001;GK00<00;GK]M/00[GK0`001[GK
0P001;GK00<00;GK]M/00[GK0`001[Fk0P001;Fk00<00;fk_K/00P000[Fk00<00;fk_K/01;fk00<0
0;fj_KX00kfj00@00;fj000000>m^P03002m^[fj00:m^P<000Jm^P03002m^[fj00>m^P04002m^P00
0003_KX01000_KZm^[fj0P0000>m^P00_KX01Kfj00<00<FiaKT01<Fi00<00<FIaIT01<FI0P001<FI
00<00<FI00001<FI00@00<FHaIP000?5V004003=V<fH0003aIP01000cIS=V0000lfH00@00<fGcIL0
00C=U`8000G=M`04003EM]Ef0002eGH00`00eGH00003eGD01P00eGKEMP00gG@000CMM@05003MDmeC
gE<00004gE@00`00iE;UDP02iE800`00iE?UD`020002kE000`00iC7U<@02iC400`00kC000003mDl0
1@00kA000?oo00003Ooo000Eool00`00ooooo`0fool00`00[Ob]o0020002[O`00`00[Ob]o003[O`2
0004[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0020002[O`00`00[Ob]o002[O`00`00[Ob]o002
0002[O`00`00[Ob]o003[O`30004[O`00`00[Ob]o003[O`20005[O`00`00[Ob]o0020002[O`00`00
[Ob]o003[O`00`00[Ob]o0020002[M`00`00[Mb]g002[M`30004[M`00`00[Mb]g003[M`30005[M`0
0`00[Mb]g0020002[M`00`00[Mb]g002[M`30004[M`00`00[Mb]g003[M`30005[M`01000[M`00000
0ZgL00<00:gL[M`00jgL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL0P001JgL00<00;GL]M`00P00
0ZgL00<00;GL]M`00kGL00<00;GL]M`00P000[GL00<00;GL]M`00[GL0`001KGL00<00;GL]M`00P00
00>eg000]M`01KGL0P001;GL00<00;GK]M/00kGK0P001KGK00<00;GK]M/00P000[GK00<00;GK]M/0
0kGK0`001;GK00<00;GK]M/00P000[GK00<00;GK]M/01;GK0P001;GK00@00;GK]M^ef`800003]M/0
0;GK00Bef`04002ef`000003]M/01000]M^efkGK0P0000>ef`00]M/01;GK00@00;GK000000>e^`04
002e^kFk]K/200000kFk002e^`04]K/20004]K/00`00_K^m^`02_K/30006_KX00`00_KZm^P04_KX0
1000_KX000000kfj00@00;fj_KZm^P<000Jm^P03002m^[fj00>m^P04002m^P000003_KX00`00_KZm
^P02_KX30005aKT20006aIT00`00aIW5V@04aIT00`00aIW5V@04aIT20005aIP20005aIP20005cIP2
0005cIL00`00cGO=M`03cGL20002eGH01P00eGKEMP00eGH000;EM@03003EM]Ef00;EMP03003MMMee
00;MM@03003EE@0000;MD`03003ME=eD00;ME003003UD^EB00;UDP03003UDnEC008000;]D003003U
<NDa00;U<@03003]<00000?eC`05003]4000ool0000=ool001Koo`03003ooooo03Koo`8000F]o003
002]o:gl008000:]o003002]o:gl00:]o003002]o:gl008000:]o003002]o:gl00>]o0<000B]o003
002]o:gl00:]o0<000F]o003002]o:gl008000:]o003002]o:gl00>]o003002]o:gl008000:]o003
002]o:gl00:]o0<000B]o003002]o:gl00>]o0<000F]g004002]g0000002[M`00`00[Mb]g003[M`0
0`00[Mb]g0020002[M`00`00[Mb]g003[M`30005[M`01000[M`000000ZgL00<00:gL[M`00jgL00<0
0:gL[M`00P000ZgL00<00:gL[M`00jgL0P001:gL00<00:gL[M`00jgL0`001JgL00<00:gL[M`00P00
0ZgL00<00:gL[M`00ZgL0`001:gL00<00;GL]M`00kGL0`001;GL00<00;GL]M`00P000[GL00<00;GL
]M`00kGL0`001;GL00@00;GL]Mbeg0800003]M`00;GL00Beg003002efkGK008000:ef`03002efkGK
00:ef`<000Fef`03002efkGK008000:ef`03002efkGK00>ef`8000Bef`03002efkGK00:ef`<000Fe
f`04002ef`000003]M/00`00]M^ef`03]M/20005]M/01000]M/000000kGK00<00;GK]M/00kGK0P00
1KFk00@00;Fk000000>e^`04002e^kFk]K/200000kFk002e^`04]K/01000_K/000000kfk00@00;fj
_KZm^P800003_KX00;fj00Fm^P03002m^[fj00>m^P04002m^P000003_KX01000_KZm^[fj0`001[fj
00<00;fj_KX01;fj00@00;fj000000>m^P030035^LFi008000:mV@040035VLFIaIT30005aIT20006
aIT00`00aIS5V004aIP00`00aIS5V004aIP00`00cIS=V004cIP00`00cIO=U`03cIL00`00cGL00004
cGL00`00cGL00002eGH20002eGH00`00eGD00005eGH00`00gGGMM@02gGD00`00eED00002gE<00`00
gECME002gE@01@00iE;UD^EB00001>EC00@00>e@kE0000CU<@03003]<00000?eC`05003]4000ool0
000=ool001Ooo`03003ooooo03Koo`03002]o:gl00>]o0<000B]o003002]o:gl00:]o0<000F]o003
002]o:gl008000:]o003002]o:gl00>]o004002]o0000002[O`00`00[Ob]o003[O`30004[O`00`00
[Ob]o003[O`30005[O`01000[O`000000Zgl00<00:gl[O`00jgl00<00:gl[O`00P000ZgL00<00:gL
[M`00jgL0P001JgL00@00:gL[Mb]g0@000F]g003002]g:gL008000:]g003002]g:gL00>]g08000B]
g003002]g:gL00>]g0<000F]g003002]g:gL008000:]g003002]g:gL00:]g003002]g:gL008000:]
g003002]g:gL00>]g0<000B]g003002]g:gL008000:]g003002]g:gL00>]g003002eg;GL008000:e
g003002eg;GL00:eg0<000Feg003002eg;GL008000:eg003002eg;GL00:eg004002eg0000003]M`0
0`00]Mbeg003]M`30005]M/01000]M/000000[GK00<00;GK]M/00kGK0`001;GK00@00;GK]M^ef`80
0003]M/00;GK00Bef`04002ef`000003]M/00`00]M^ef`02]M/20006]M/00`00]M^ef`020002]M/0
0`00]M^ef`02]M/20006]M/00`00]M^ef`020002]M/00`00]K^e^`02]K/20006]K/00`00]K/00003
]K/00`00]K^e^`03]K/20005_K/01000_KX000000kfj00<00;fj_KX00[fj0`001[fj00<00;fj_KX0
0kfj00@00;fj000000>m^P04002m^[fj_KX200000kfj002m^P05_KX00`00_KZm^P03_KX00`00aKT0
0004_IT01000aIT000000lFI00<00<FIaIT00P000/FI00<00<FIaIT00/FI00<00<FI00001<FH00<0
0<FH00001<FH00<00<FH00001<fH00<00<fH00001<fG00<00<eg00000leg00@00<egcGL000?EMP04
003EM]EfeGH20005eGH01@00gGGMMMee00000mEE00<00=eC00000meD00<00=eD00000^EB00<00>EC
iE<00^EC00@00>e@kE0000CU<@03003]<00000?eC`05003]4000ool0000=ool001Soo`8003Ooo`03
002]o:gl008000:]o003002]o:gl00>]o004002]o0000002[O`00`00[Ob]o003[O`30005[O`01000
[Ob]o:gl0`001Jgl0P0000>]o00000000Zgl00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<00:gl
[O`00jgl0P001Jgl00@00:gl[Ob]o0@000F]g003002]g:gL008000:]g003002]g:gL00:]g0@000>]
g003002]g:gL00>]g0<000F]g003002]g:gL00800003[M`00:gL00B]g003002]g:gL008000:]g003
002]g:gL00>]g0<000B]g004002]g:gL[M`40005[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`3
0004[M`00`00[Mb]g003[M`30005]M`01000]M`000000[GL00<00;GL]M`00kGL0`001;GL00<00;GL
]M`00[GL0P001[GL00<00;GL]M`00P000[GL00<00;GK]M/00kGK0P001KGK00<00;GK]M/00P000[GK
00<00;GK]M/00kGK00<00;GK00000kGK00<00;GK]M/00kGK0P001KGK00<00;GK]M/00P000[GK00<0
0;GK]M/00kGK0`001;GK00<00;GK]M/00P000[GK00<00;GK]M/00kGK0`001;GK00<00;Fk]K/00P00
0[Fk00<00;Fk]K/01;Fk00<00;Fk]K/00kFk00<00;Fk]K/00P000[Fk00<00;fk_K/00[fk0P001[fj
00@00;fj000000>m^P04002m^[fj_KX30006_KX00`00_KZm^P03_KX01000_KX000000kfj00<00;fj
_KX00[fj0`001[fj00<00;fI_IT01;fI00<00<FIaIT00lFI00<00<FI00001<FI00<00<FIaIT00P00
0/FI00D00<FHaIS5V00000;5V0050035V<FHaIP00002aIP01@00cIS=V<fH00000/fH00D00<fGcIO=
U`0000?=M`03003=M`0000C=M`04003EMP000003eGH00`00eGKEMP03eGH00`00eEH00002gGD01000
eEGEEMEE0P001=eD00<00=eD00000^EB00<00>ECiE<00^EC00@00>e@kE0000CU<@<000?eC`06003]
4>d@003oo`003?oo000Jool00`00ooooo`0eool20005[O`01000[Ob]o:gl0`001Jgl0P0000>]o000
00000Zgl00<00:gl[O`00jgl10000jgl00<00:gl[O`00jgl0P001Jgl0P000Zgl10001Jgl00<00:gl
[O`00P000Zgl00<00:gl[O`00Zgl10000jgL00<00:gL[M`00jgL0`001JgL00@00:gL000000:]g003
002]g:gL00>]g003002]g:gL008000:]g003002]g:gL00>]g0<000B]g003002]g:gL00:]g0<000F]
g003002]g:gL008000:]g003002]g:gL00:]g0@000>]g003002]g:gL00>]g0<000F]g004002]g000
0002[M`00`00[Mb]g003[M`00`00[Mb]g0020002[M`00`00]Mbeg003]M`20005]M`00`00]Mbeg002
0002]M`00`00]Mbeg003]M`01000]M`000000[GL00<00;GL]M`00kGL0`001KGL00<00;GK]M/00P00
00>ef`00]M/01KGK0P001;GK00<00;GK]M/00kGK0P001KGK00<00;GK]M/00P000[GK00<00;GK]M/0
0[GK0`001KGK00<00;GK]M/00P000[GK00<00;GK]M/00[GK0`001KGK00<00;GK]M/00P0000>ef`00
]M/01KGK0P001;Fk00<00;Fk]K/00[Fk0`001[Fk0P001;Fk00<00;fk_K/00P000[Fk00<00;fj_KX0
1;fj00<00;fj_KX00kfj00@00;fj000000>m^P04002m^[fj_KX200000kfj002m^P04_KX00`00_KZm
^P04_KX01000_KX000000kfj00@00;fj_KZm^P<000FmV@8000K5V@030035VLFI00C5V@8000G5V@03
0035V00000C5V0040035V<FH0003aIP01000cIS=V0000lfH00<00<fG00001<eg00<00<eg00001<eg
00H00=Ef003EMP00eGH20005eGH00`00eEH00002gGD00`00eEGEE@02eED00`00gECME002gE@00`00
gE@00002iE801000iE?UDnEC0P000^e@00H00>DaiC7U<@00gA820003mDl01P00kA3]4000ool000co
o`006ooo00<00?ooool0=Ooo00<00:gl[O`00jgl10000jgl00<00:gl[O`00jgl0P001Jgl0P0000>]
o00000000Zgl00<00:gl[O`00jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`000jgl00<00:gl
[O`00jgl0`001Jgl00@00:gl000000:]o003002]g:gL00>]g003002]g:gL008000:]g003002]g:gL
00>]g08000F]g003002]g:gL00:]g0<000F]g003002]g:gL008000:]g003002]g:gL00:]g003002]
g:gL008000:]g003002]g:gL00>]g0<000F]g004002]g0000002[M`00`00[Mb]g003[M`00`00[Mb]
g0020002[M`00`00[Mb]g003[M`20004[M`00`00[Mb]g003[M`30005[M`00`00]Mbeg0020002[M`0
0`00]Mbeg002]M`30004]M`00`00]Mbeg003]M`20005]M`00`00]Mbeg0020002]M`00`00]Mbeg003
]M`30004]M/01000]M^efkGK0P0000>ef`00]M/01;GK00<00;GK]M/00P000[GK00<00;GK]M/00[GK
0`001KGK00@00;GK000000:ef`03002efkGK00>ef`<000Bef`03002efkGK008000:ef`03002efkGK
00Bef`8000Bef`04002efkGK]M/200000kFk002e^`04]K/01000]K/000000kFk00@00;Fk]K^e^`<0
00Je^`8000Be^`03002m^[fj00:m^P<000Jm^P03002m^[fj00>m^P04002m^P000003_KX01000_KZm
^[fj0P0000>m^P00_KX01Kfj00<00;fj_KX00kfj00@00;fj000000>mVP03002mVKfI008000:mV@03
0035VLFI00;5V@03002mV@0000G5V@030035VLFI00G5V@030035V<FH00?5V0030035V00000C5V003
003=V00000C=V003003=U`0000G=M`03003=Mleg00C=M`04003EM]EfeGH200000lef003EMP02eGH0
1P00eEKEEP00gGD000GEE@05003ME=eDgE@00003gE@00`00iE800003iE<01@00gC<00>e@00000nDa
00D00=dB003]<00000;eC`06003]4>d@003oo`003?oo000Lool00`00ooooo`0eool200000jgl0000
0002[O`00`00[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`20004[O`00`00[Ob]o003
[O`30005[O`00`00[Ob]o0020002[O`00`00[Ob]o002[O`00`00[Ob]o0020002[O`00`00[Ob]o003
[O`20005[O`00`00[Mb]g002[M`30005[M`00`00[Mb]g0020002[M`00`00[Mb]g003[M`01000[M`0
00000ZgL00<00:gL[M`00jgL0`001:gL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`00P000ZgL00<0
0:gL[M`00jgL0P001:gL00<00:gL[M`00jgL0`001JgL00<00:gL[M`00P0000>]g000[M`01:gL00<0
0:gL[M`00P000ZgL00<00:gL[M`00jgL0`001:gL00<00;GL]M`00P000[GL00<00;GL]M`00kGL00<0
0;GL]M`00P000[GL00<00;GL]M`00[GL0`001KGL00<00;GL]M`00P0000>eg000]M/01;GK00@00;GK
000000>ef`03002efkGK00>ef`<000Bef`03002efkGK008000:ef`03002efkGK00>ef`8000Fef`03
002efkGK00800003]M/00;GK00Fef`8000Bef`03002efkGK00:ef`<000Fef`04002ef`000003]K/0
0`00]K^e^`03]K/20005]K/01000]K/000000kFk00@00;Fk]K^e^`800003]K/00;Fk00Be^`04002m
^P000003_KX01000_KZm^[fj0`001[fj00<00;fj_KX01;fj00<00;fj00000kfj00<00;fj_KX00[fj
0`001[fj00<00;fJ_IX00kfJ00<00;fI00001;fI00<00<FIaIT00P000[fI00@00<FIaIW5V@800003
aIT00<FI00C5V@8000K5V0030035V<FH00C5V003003=V<fH00C=V003003=Mleg00?=M`8000G=M`80
00?EMP800003cGH00=Ef00;EMP06003EE]EF003MM@001MEE00D00=eDgECME00000?ME003003UDP00
00?UD`04003M<`000004iC401@00gA800>d`00000_E?00H00>d@kA000?oo000<ool001goo`8003Oo
o`03002]o:gl00:]o003002]o:gl00>]o0<000F]o003002]o:gl008000:]o003002]o:gl00:]o003
002]o:gl008000:]o003002]o:gl00>]o0<000B]o003002]o:gl00:]o0<000F]o003002]o:gl0080
00:]o003002]o:gl00>]o004002]g0000002[M`00`00[Mb]g003[M`30004[M`00`00[Mb]g003[M`2
0005[M`00`00[Mb]g0020002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL0`00
1JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL0`00
1:gL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL0`001;GL00<00;GL
]M`00kGL0`001;GL00<00;GL]M`00P000[GL00<00;GL]M`00kGL0`001;GL00<00;GK]M/00[GK0P00
1[GK00<00;GK]M/00P000[GK00<00;GK]M/00[GK0`001KGK00<00;GK]M/00P0000>ef`00]M/01KGK
0P001;GK00@00;GK]M^ef`800003]M/00;GK00Bef`04002ef`000003]M/00`00]M^ef`02]M/20006
]K/00`00]K^e^`020002]K/00`00]K^e^`02]K/20005]K/01000]K/000000kFk00<00;Fk]K/00kFk
0P001Kfj00@00;fj000000>m^P04002m^[fj_KX200000kfj002m^P05_KX00`00_KZm^P03_KX01000
_KX000000kfj00@00;fj_KZm^P<000JmVP03002mVKfI00BmV@8000FmV@030035V@0000?5V@040035
VLFIaIT20002aIT00`00aIS5V002aIP20005aIP20005cIP20004cGL01000cGO=M`000leg00@00<eg
cGL000;EMP8000;=MP03003EMP0000CEEP03003EEMEE00?EE@03003EE@0000;ME004003ME=eDgE@2
0004iE<01000gC<000001>Da00D00=dB003]<00000;eC`06003]4>d@003oo`003?oo000Oool00`00
ooooo`0eool00`00[Ob]o002[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30005[O`00`00[Ob]
o0040005[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`01000[O`000000Zgl00<00:gl[O`00jgl
0`001:gl00<00:gl[O`00jgl0P001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL00<00:gL[M`0
0P000ZgL00<00:gL[M`00ZgL0`001JgL00@00:gL[Mb]g0<000F]g003002]g:gL008000:]g003002]
g:gL00>]g0<000B]g003002]g:gL00:]g0<000F]g003002]g:gL008000:]g003002]g:gL00:]g003
002]g:gL008000:]g003002]g:gL00>]g0<000B]g003002]g:gL008000:]g003002eg;GL00>eg003
002eg;GL008000:eg003002eg;GL00:eg0<000Feg003002eg;GL00800003]M`00;GL00Beg003002e
fkGK008000:ef`03002efkGK00>ef`<000Bef`03002efkGK008000:ef`03002efkGK00Bef`8000Be
f`04002efkGK]M/200000kGK002ef`03]M/01000]M/000000kGK00<00;GK]M/00kGK0P001KGK00<0
0;GK]M/00P000[Fk00<00;Fk]K/00kFk0`001;Fk00<00;Fk]K/00P000[Fk00<00;Fk]K/00[Fk0P00
1[Fk00<00;Fk]K/00P000[Fk00<00;fj_KX00[fj0P001Kfj00@00;fj000000>m^P03002m^[fj00:m
^P<000Jm^P03002m^[fj00>m^P04002m^P000003_IX01000_IZmV[fJ0P0000>mVP00_IT01;fI00<0
0;fI_IT01KfI00<00<FIaIT00lFI00<00<FI00001<FI00<00<FHaIP00P000/FH00<00<FHaIP00P00
0/FH00D00<fHcIS=V00000;5N005003=MlegcGL00002cGL01@00cGO=Mleg00000/eg00<00=Ef0000
0/ef00D00<ef003EMP0000CEEP03003EEMEE00?EE@05003EE@00gE@00005gE@01@00iE?UDnEC0000
0]dc0P001>Da00<00=dBgA800P000_E?00@00>d@kA3]408000coo`008?oo00<00?ooool0=Ooo00<0
0:gl[O`010001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl0`000jgl00<00:gl[O`00jgl0`00
1Jgl00@00:gl[Ob]o0<000F]o003002]o:gl008000:]o003002]o:gl00>]o003002]o:gl008000:]
g003002]g:gL00:]g0<000F]g004002]g:gL[M`40005[M`01000[M`000000ZgL00<00:gL[M`00jgL
10000jgL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL00@00:gL0000
00:]g003002]g:gL00>]g0<000B]g003002]g:gL00:]g0<000F]g003002]g:gL008000:]g003002]
g:gL00:]g0<000B]g003002eg;GL00>eg0<000Beg003002eg;GL008000:eg003002eg;GL00>eg0<0
00Beg003002eg;GL00:eg0<000Fef`03002efkGK008000:ef`03002efkGK00:ef`<000Bef`03002e
fkGK00:ef`<000Fef`04002ef`000003]M/00`00]M^ef`02]M/20006]M/00`00]M^ef`020002]M/0
0`00]M^ef`02]M/30005]K/00`00]K^e^`0200000kFk002e^`05]K/20004]K/00`00]K^e^`020002
]K/00`00]K^e^`04]K/20004]K/00`00_KZm^P0200000kFj002m^P05_KX00`00_KZm^P04_KX01000
_KX000000kfj00@00;fj_KZm^P<000Jm^P03002mV[fJ00>mVP04002mVP000003_IX01000_IVmVKfI
0P0000>mV@00_IT01;fI0P001/FI00<00<FIaIT01<FI0P001<FH00<00<FH00001<FH00@00<fHcIP0
00?5N004003=Mleg0003cGL01000cGO=M`001<eg0P000lef00<00<ef00001=EF0P001=EE00H00=EE
eED00=eD0005gE@01@00iE?UDnEC00000]dc0P001>Da00<00=dBgA800P000_E?00@00>d@kA3]4080
00coo`008Ooo00<00?ooool0=Ooo0P000jgl00<00:gl[O`00jgl0`001Jgl00<00:gl[O`00P000Zgl
00<00:gl[O`00Zgl0P0000>]o00000000Zgl00<00:gl[O`00jgl10000jgl00<00:gl[O`00Zgl0`00
1Jgl00@00:gl[Ob]o0@000F]g004002]g0000002[M`00`00[Mb]g003[M`40003[M`00`00[Mb]g003
[M`20005[M`00`00[Mb]g0020002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL
0`001:gL00<00:gL[M`00jgL0P001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL00@00:gL0000
00:]g003002]g:gL00>]g0<000F]g004002]g0000002[M`00`00[Mb]g003[M`00`00]Mbeg0020002
[M`00`00]Mbeg002]M`30005]M`00`00]Mbeg0020002]M`00`00]Mbeg002]M`00`00]Mbeg0020002
]M`00`00]M^ef`03]M/30004]M/00`00]M^ef`020002]M/00`00]M^ef`03]M/01000]M/000000kGK
00<00;GK]M/00[GK0P001[GK00@00;GK000000:ef`03002efkGK00>ef`<000Bef`03002efkGK0080
00:e^`03002e^kFk00Be^`8000Be^`04002e^kFk]K/30006]K/20004]K/00`00]K^e^`02]K/30006
]K/20004]KX01000_KZm^[fj0P0000>m^P00_KX01Kfj00<00;fj_KX00kfj00@00;fj000000>m^P04
002m^[fj_KX30006_IX00`00_IZmVP04_IX00`00_IT00003_IT01000_IVmVKfI0P000[fI00<00<FI
aIT00/FI0P001/FI00<00<FHaIP01<FH00<00<FHaIP01<FH0P001LEh0P001Leg0P001Leg00<00<ef
cGH00lef0P001=EF00<00<eF00000mEE00H00=EEeED00=eD0005gE@01@00iE?UDnEC00000mdc00<0
0>DaiC400^Da00<00=dBgA800P000_E?00@00>d@kA3]408000coo`008_oo0P00=_oo00<00:gl[O`0
0Zgl0P0000>]o00000000Zgl00<00:gl[O`00jgl0`001:gl00<00:gl[O`00jgl0P001Jgl00<00:gl
[O`00P000Zgl00<00:gl[O`00jgl00@00:gl000000:]o003002]o:gl00>]o0@000>]g003002]g:gL
00>]g08000F]g003002]g:gL008000:]g003002]g:gL00>]g003002]g:gL008000:]g003002]g:gL
00:]g0<000B]g003002]g:gL00>]g08000F]g003002]g:gL008000:]g003002]g:gL00>]g003002]
g:gL008000:]g003002]g:gL00:]g0<000F]g004002]g:gL[M`30005[M`00`00[Mb]g0020002[M`0
0`00[Mb]g003[M`20004[M`00`00[Mb]g003[M`30005[M`01000]M`000000[GL00<00;GL]M`00kGL
0`001;GL00<00;GL]M`00[GL0`001KGL00<00;GK]M/00P000[GK00<00;GK]M/00[GK0`001;GK00<0
0;GK]M/00kGK0P001KGK00<00;GK]M/00P000[GK00<00;GK]M/00kGK0P001KGK00<00;GK]M/00P00
00>ef`00]M/01KGK0P001;Fk00<00;Fk]K/00[Fk0`001KFk00@00;Fk000000>e^`04002e^kFk]K/2
00000kFk002e^`04]K/01000]K/000000kFk00@00;Fk]K^e^`<000Fe^P04002m^P000003_KX00`00
_KZm^P02_KX30006_KX00`00_KZm^P03_KX01000_KX000000kfj00@00;fJ_IZmVP800003_IX00;fJ
00FmVP03002mVKfI00>mV@03002mV@0000BmV@030035VLFI008000:mV@030035VLFI00;5V@8000G5
V08000K5V0030035N<Eh00C5N003003=Mleg00C=M`03003=Mleg00?=M`8000G=MP03003=E`0000;E
EP04003=E/eF0002eED00`00eEGEE@02eED00`00gECME003gE@20003iE<01@00gC?M<mdc00001>Da
00<00=dBgA800P000_E?00L00>d@kA3]4000ool0000;ool002Coo`03003ooooo03Coo`04002]o:gl
[O`30005[O`200000jgl00000002[O`00`00[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]o002
[O`30004[O`00`00[Ob]o003[O`20005[O`200000jgl00000002[O`00`00[Mb]g003[M`00`00[Mb]
g0020002[M`00`00[Mb]g002[M`30004[M`00`00[Mb]g003[M`30005[M`01000[M`000000ZgL00<0
0:gL[M`00jgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL0`001:gL00<00:gL[M`00jgL0`001:gL
00<00:gL[M`00P000ZgL00<00:gL[M`00jgL10000jgL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`0
0P0000>]g000[M`01:gL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL0P001KGL00<00;GL]M`00P00
0[GL00<00;GL]M`00kGL00@00;GL000000:eg003002eg;GL00>eg0<000Bef`03002efkGK008000:e
f`03002efkGK00>ef`03002efkGK008000:ef`03002efkGK00:ef`<000Fef`03002efkGK008000:e
f`03002efkGK00:ef`<000Bef`04002efkGK]M/200000kFk002e^`04]K/01000]K/000000kFk00<0
0;Fk]K/00[Fk0P001KFk00@00;Fk000000>e^`03002e^kFk00>e^`8000Fe^`04002e^`000003]K/0
0`00]KZe^P02]KX20006_KX01000_KX000000kfj00@00;fj_KZm^P<000Jm^P03002m^[fj00>m^P04
002mVP000003_IX00`00_IZmVP02_IX30006_IT00`00_IVmV@04_IT20004_IT00`00aIW5V@020002
aIT00`00aIS5V0020002aIT00`00aIS5V002aIP20005aGP20005cGL20004cGL01000cGO=M`000lef
00@00<eG000000;EEP07003=E/eFcEH00=EE00001=EE00<00=eDgE@00meD00D00=De003UD`0000CM
<`05003U<NDaiC400003gA820002mDl01`00kA3]4>d@003oo`0000_oo`009Ooo00<00?ooool0=?oo
0`000jgl00<00:gl[O`00jgl0P001Jgl00@00:gl[Ob]o0@000F]o004002]o0000002[O`00`00[Ob]
o003[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`20004[O`00`00[Mb]g003[M`30005[M`01000
[M`000000ZgL00<00:gL[M`00jgL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL0P001:gL00<00:gL
[M`00jgL0`001JgL00@00:gL000000:]g003002]g:gL00>]g003002]g:gL008000:]g003002]g:gL
00:]g0<000F]g003002]g:gL008000:]g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL
00>]g0<000B]g003002]g:gL00:]g0<000F]g003002]g:gL008000:]g003002eg;GL00:eg0<000Be
g003002eg;GL00>eg08000Feg003002eg;GL008000:eg003002efkGK00:ef`<000Bef`03002efkGK
00>ef`<000Bef`03002efkGK008000:ef`03002efkGK00>ef`<000Bef`03002efkGK008000:ef`03
002efkGK00:ef`04002ef`000003]K/00`00]K^e^`03]K/20005]K/00`00]K^e^`020002]K/00`00
]K^e^`02]K/20006]K/00`00]K^e^`020002]K/00`00]K^e^`02]K/20005]K/00`00]KZe^P020002
]KX00`00_KZm^P03_KX20005_KX01000_KX000000kfj00@00;fj_KZm^P<000Jm^P03002mV[fJ00Bm
VP04002mVP000003_IX01000_IVmVKfI0`001[fI00<00;fI_IT01;fI0P001<FI00<00<FH00001<FI
00<00<FHaIP00P000/Eh00<00<EhaGP00P000/Eh00D00<egcGO=M`0000;5N005003=MlegcGL00002
cGL01000cGK=MP000leG00<00=EF00001<eF0P001MEE00<00=eDgE@00meD00D00=De003UD`0000CM
<`05003U<NDaiC400004gA801000mDoeC`000nd@00<00?oo00002ooo000Vool00`00ooooo`0dool0
0`00[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]o002[O`40003[O`00`00[Ob]o003[O`20005
[O`20002[O`40005[O`00`00[Ob]o0020002[O`00`00[Ob]o002[O`00`00[Mb]g0020002[M`00`00
[Mb]g003[M`20005[M`01000[Mb]g:gL10001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<0
0:gL[M`00P000ZgL00<00:gL[M`00jgL0P001JgL00@00:gL[Mb]g0@000F]g004002]g0000002[M`0
0`00[Mb]g003[M`30004[M`00`00[Mb]g002[M`30005[M`00`00[Mb]g0020002[M`00`00[Mb]g002
[M`00`00[Mb]g0020002[M`00`00[Mb]g003[M`30004[M`00`00]Mbeg0020002[M`00`00]Mbeg003
]M`00`00]Mbeg0020002]M`00`00]Mbeg002]M`30005]M`01000]M/000000[GK00<00;GK]M/00kGK
00<00;GK]M/00P000[GK00<00;GK]M/00[GK0`001KGK00<00;GK]M/00P0000>ef`00]M/01KGK0P00
1;GK00<00;GK]M/00[GK0P001[Fk00<00;Fk]K/00P000[Fk00<00;Fk]K/00[Fk0`001KFk00@00;Fk
000000:e^`03002e^kFk00Be^`8000Be^`03002e^kFk008000:e^`03002e^kFk00>e^`8000Fe^P03
002m^[fj00800003]KX00;fj00Fm^P03002m^[fj00>m^P04002m^P000003_KX01000_KZm^[fj0P00
00>mVP00_IX01KfJ00<00;fJ_IX00kfJ00@00;fI000000>mV@04002mVKfI_IT30006_IT00`00aIW5
V@04aIT00`00aIW5V@04aIT20004aGP00`00aGP00004aGP01000cGO=M`000lEh00@00<egcGL000?=
M`03003=MP0000C=E`<000G=EP03003EEMEE00;EE@03003E=@0000?ME006003E=MDe003UD`001=dc
0P000^Da00<00=dBgA800]dB00@00?E?mDl000C]408000_oo`009ooo00<00?ooool0<ooo00<00:gl
[O`00jgl0`001Jgl00@00:gl000000:]o003002]o:gl00>]o003002]o:gl008000:]o003002]o:gl
00>]o0<000>]o003002]o:gl00>]o0<000F]o003002]o:gl00@000F]g003002]g:gL008000:]g003
002]g:gL00:]g0@000>]g003002]g:gL00>]g0<000F]g003002]g:gL00@000F]g003002]g:gL0080
00:]g003002]g:gL00:]g0@000>]g003002]g:gL00>]g08000F]g003002]g:gL008000:]g003002]
g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`30004[M`00`00[Mb]g002[M`30005[M`00`00
[Mb]g0020002[M`00`00[Mb]g002[M`30004[M`00`00]Mbeg003]M`30004]M`00`00]Mbeg0020002
]M`00`00]Mbeg003]M`20004]M/00`00]M^ef`03]M/30004]M/00`00]M^ef`020002]M/00`00]M^e
f`03]M/30004]M/01000]M^efkGK0P0000>ef`00]M/01;GK00@00;GK000000:e^`03002e^kFk00>e
^`<000Be^`03002e^kFk008000:e^`03002e^kFk00Be^`03002e^kFk00:e^`03002e^kFk00:e^`<0
00Je^`8000Be^`04002e^kFk]K/200000kFk002e^P05]KX20004]KX01000_KZm^[fj0`001[fj00<0
0;fj_KX00kfj00@00;fj000000>mVP03002mV[fJ00:mVP<000JmVP03002mVKfI00>mV@04002mV@00
0003_IT01000_IVmVKfI0`001LFI0P001/FI00<00<EhaGP01<Eh00<00<EhaGP01<Eh0P001LEh0P00
1Leg0P001LeG00<00<eFcEH00leF0P001=EE00<00=De00000meD00H00=DeeCD00>EC0003gC<00`00
eA@00002iC400`00gA;M4P02gA801000mDoeC`001>d@0P002ooo000Xool2000dool00`00[Ob]o002
0002[O`00`00[Ob]o003[O`20005[O`00`00[Ob]o002[O`30005[O`00`00[Ob]o0020002[O`00`00
[Ob]o002[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30003[M`00`00[Mb]g003[M`30005[M`0
1000[M`000000ZgL00<00:gL[M`00jgL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL0`000jgL00<0
0:gL[M`00jgL0`001JgL00@00:gL000000:]g003002]g:gL00>]g003002]g:gL008000:]g003002]
g:gL00:]g0<000B]g003002]g:gL00>]g08000F]g003002]g:gL008000:]g003002]g:gL00>]g004
002]g0000002[M`00`00[Mb]g003[M`30005[M`01000[M`000000ZgL00<00:gL[M`00jgL00<00;GL
]M`00P000[GL00<00;GL]M`00[GL0`001KGL00<00;GL]M`00P0000>eg000]M/01;GK00<00;GK]M/0
0P000[GK00<00;GK]M/00[GK0`001KGK00<00;GK]M/00P0000>ef`00]M/01;GK00@00;GK000000>e
f`03002efkGK00>ef`8000Fe^`03002e^kFk008000:e^`03002e^kFk00:e^`<000Be^`03002e^kFk
00:e^`<000Fe^`04002e^`000003]K/01000]K^e^kFk0P0000>e^`00]K/01;Fk00<00;Fk00000kFk
00<00;Fj]KX00[Fj0`001KFj00@00;fj000000>m^P04002m^[fj_KX200000kfj002m^P04_KX00`00
_IZmVP04_IX01000_IX000000kfJ00@00;fJ_IZmVP<000JmV@03002mVKfI00>mV@04002mV@000003
_IT00`00aIW5V@020002aIT00`00aIW5V@02aIT20005aGP20006aGP00`00aGS5N004aGP00`00cGO=
M`04cGL00`00cEO=E`03cEL30004cEH00`00cEH00002eED01000eCGE=@000]eD00<00=DeeCD00]De
00<00=dcgC<00]dc00<00=DD00000^Da00<00=dBgA800]dB00@00?E?mDl000C]408000_oo`00:_oo
00<00?ooool0<_oo0P001Jgl00<00:gl[O`00P000Zgl00<00:gl[O`00jgl00@00:gl000000:]o003
002]o:gl00>]o0<000B]o003002]o:gl00:]o0<000F]o003002]o:gl008000:]g003002]g:gL00:]
g003002]g:gL008000:]g003002]g:gL00>]g08000B]g003002]g:gL00>]g0<000F]g003002]g:gL
00800003[M`00:gL00B]g003002]g:gL008000:]g003002]g:gL00>]g08000B]g003002]g:gL00>]
g0<000F]g004002]g0000002[M`00`00[Mb]g003[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`3
0005[M`01000[Mb]g:gL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL0P001:gL00<00:gL
[M`00jgL0`001;GL00<00;GL]M`00P000[GL00<00;GL]M`00kGL0`001;GL00<00;GK]M/00[GK0`00
1KGK00@00;GK000000:ef`03002efkGK00Bef`8000Bef`03002efkGK00:ef`8000Jef`03002efkGK
008000:ef`03002e^kFk00:e^`<000Be^`03002e^kFk008000:e^`03002e^kFk00>e^`04002e^`00
0003]K/00`00]K^e^`02]K/20005]K/01000]K/000000kFk00<00;Fk]K/00kFk0P001KFk00@00;Fj
000000>e^P03002e^[Fj00:e^P8000Fm^P04002m^P000003_KX01000_KZm^[fj0P0000>mVP00_IX0
1KfJ00<00;fJ_IX00kfJ00@00;fJ000000>mVP04002mVKfI_IT30006_IT00`00_IVmV@03_IT00`00
aIT00004aIT00`00aIW5V@020002aGT01@00aGS5N<Eh00000/Eh00<00<EhaGP00/Eh00<00<Eh0000
1<Eh0P001Leg0P001<eG00<00<eGcEL00P000/eF00@00<eFcEH000;EE@07003E=MDeeCD00=eD0000
1=De00<00=dcgC<00]dc00<00=DD00000^Da00<00=dBgA800]dB0P0000?eC`00kA000nd@0P002ooo
000[ool00`00ooooo`0bool00`00[Ob]o003[O`30005[O`01000[Ob]o:gl0`001Jgl00<00:gl[O`0
0P000Zgl00<00:gl[O`00jgl00@00:gl000000:]o003002]o:gl00>]o0<000B]g003002]g:gL00:]
g0<000F]g003002]g:gL008000:]g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00>]
g0<000B]g003002]g:gL00:]g0<000F]g003002]g:gL008000:]g003002]g:gL00:]g003002]g:gL
008000:]g003002]g:gL00>]g08000B]g003002]g:gL00>]g0<000B]g003002]g:gL008000:]g003
002]g:gL00>]g0@000>]g003002]g:gL00:]g0<000F]g003002]g:gL00800003[M`00:gL00B]g003
002]g:gL008000:]g003002eg;GL00:eg0<000Feg003002eg;GL00800003]M`00;GL00Beg003002e
fkGK008000:ef`03002efkGK00>ef`8000Bef`03002efkGK00:ef`<000Fef`03002efkGK008000:e
f`03002efkGK00>ef`<000Bef`03002e^kFk00800003]K/00;Fk00Fe^`8000Be^`03002e^kFk00>e
^`8000Fe^`03002e^kFk008000:e^`03002e^kFk00:e^`8000Je^`03002e^kFk008000:e^`03002e
^kFk00:e^`8000Fe^P03002e^[Fj008000:e^P03002m^[fj00:m^P8000Jm^P03002m^P0000>mVP03
002mV[fJ00:mVP<000JmVP03002mV[fJ00>mVP04002mV@000003_IT01000_IVmVKfI0`001[fI00<0
0<FIaIT01<FI0P001<Ei00@00<EhaGP000?5N0030035N<Eh008000;5N0050035N<EhaGP00002aGP0
1@00cGO=Mleg00000/EG00D00<eGcEO=E`0000;=E`800003cEH00<eF00;=EP03003EE@0000CE=@03
003ME00000CE=@03003M<mdc00;M<`06003E5=DD003U<@001=dB0P0000?eC`00kA000nd@00<00?oo
00002_oo000/ool00`00ooooo`0bool200000jgl00000002[O`00`00[Ob]o003[O`40003[O`00`00
[Ob]o002[O`30005[O`01000[Ob]o:gl0`001Jgl00<00:gl[O`00P000ZgL00<00:gL[M`00jgL00@0
0:gL000000:]g003002]g:gL00>]g0<000F]g003002]g:gL00@000F]g003002]g:gL008000:]g003
002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00>]g0<000B]g004002]g:gL[M`40005[M`0
0`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`30005[M`0
0`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g003[M`30004[M`0
0`00[Mb]g002[M`30005[M`01000]M`000000ZgL00<00;GL]M`00kGL0`001;GL00<00;GL]M`00[GL
0`001KGK00<00;GK]M/00P0000>ef`00]M/01;GK00@00;GK000000>ef`03002efkGK00:ef`<000Fe
f`03002efkGK008000:ef`03002efkGK00:ef`<000Be^`04002e^kFk]K/200000kFk002e^`04]K/0
0`00]K^e^`020002]K/00`00]K^e^`02]K/30004]K/00`00]K^e^`020002]K/00`00]K^e^`03]K/3
0004]K/00`00]K^e^`0200000kFk002e^P05]KX20004]KX00`00_KZm^P020002]KX00`00_KZm^P04
_KX00`00_IZmVP03_IX01000_IX000000kfJ00@00;fJ_IZmVP<000JmVP03002mVKfI00>mV@04002m
V@000003_IT01000_IVmVKfI0P0000>mV@00aIT01<FI00<00<EiaGT01<Ei0P001LEh0P001LEh00@0
0<EhaGP000;5N004003=Mleg0003aEL01000cEO=E`000leG00<00<eF00001<eF00<00=EE00001MDe
00<00=DeeCD00]De00<00=DE00000mdc00H00=DDeA@00>Da0003gA800`00e?<00002mDl01000kA3]
4>d@0`002_oo000]ool2000dool00`00[Ob]o003[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`0
1000[O`000000Zgl00<00:gl[O`00jgl10000jgl00<00:gl[O`00Zgl0`001JgL00@00:gL[Mb]g0<0
00F]g003002]g:gL008000:]g003002]g:gL00>]g0<000>]g003002]g:gL00>]g0<000F]g003002]
g:gL00@000F]g003002]g:gL008000:]g003002]g:gL00:]g0@000>]g003002]g:gL00>]g0<000B]
g004002]g:gL[M`40005[M`01000[M`000000ZgL00<00:gL[M`00jgL0`001:gL00<00:gL[M`00ZgL
0`001JgL00<00:gL[M`00P0000>]g000[M`01:gL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL0P00
1JgL00<00;GL]M`00P000ZgL00<00;GL]M`00[GL00<00;GL]M`00P000[GL00<00;GK]M/00kGK0`00
1;GK00<00;GK]M/00[GK0P001KGK00<00;GK]M/00P000[GK00<00;GK]M/00kGK0`001;GK00<00;GK
]M/00P000[Fk00<00;Fk]K/00[Fk00@00;Fk000000>e^`03002e^kFk00>e^`<000Be^`03002e^kFk
008000:e^`03002e^kFk00:e^`<000Fe^`03002e^kFk00800003]K/00;Fk00Fe^`8000Be^`04002e
^[Fj]KX30006]KX20004]KX00`00_KZm^P02_KX30006_IX00`00_IZmVP03_IX01000_IX000000kfJ
00@00;fJ_IZmVP<000JmV@03002mVKfI00>mV@04002mV@000003_IT01000aIW5VLFI0P0000>mN@00
aGT01<Ei00<00<EhaGP01<Eh00<00<EhaGP01<Eh00<00<Eh00001<Eh0P001LEG0P001LeG0`001<eF
00<00=DeeCD01=De00<00=DeeCD00]De00<00=DE00000]dc00@00=DDeACE508000CM4P03003Dl`00
00;eC`04003]4>d@kA03000:ool002ooo`03003ooooo03;oo`03002]o:gl00:]o0<000F]o004002]
o:gl[O`30005[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`01000[O`000000Zgl00<00:gL[M`0
0jgL10000jgL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL
[M`00P000ZgL00<00:gL[M`00jgL0`000jgL00<00:gL[M`00jgL0`001JgL00@00:gL000000:]g003
002]g:gL00>]g003002]g:gL008000:]g003002]g:gL00:]g0@000>]g003002]g:gL00>]g08000F]
g003002]g:gL008000:]g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`30004[M`0
0`00[Mb]g002[M`30005[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`30004[M`00`00]Mbeg002
]M`30005]M`00`00]M^ef`0200000kGK002ef`04]M/00`00]M^ef`020002]M/00`00]M^ef`02]M/3
0005]M/00`00]M^ef`0200000kGK002ef`05]M/20004]K/00`00]K^e^`02]K/20006]K/00`00]K^e
^`020002]K/00`00]K^e^`02]K/30004]K/00`00]K^e^`020002]K/00`00]K^e^`04]K/20004]K/0
1000]K^e^kFk0`001KFk00@00;Fj000000>e^P04002e^[Fj]KX200000kFj002e^P04]KX01000_KX0
00000kfJ00@00;fJ_IZmVP<000JmVP03002mV[fJ00>mVP04002mVP000003_IX00`00_IVmV@02_IT0
0`00_IT00005_IT00`00_IVmV@04_IT00`00aIT00003_GT01000aGW5NLEi0P0000?5N@00aGP00lEh
00<00<Eh00001/Eh00<00<EhaGP00lEh00<00<EGaEL01<EG00<00<eGcEL01<eG00@00<eFcEH000?=
EP03003E=MDe00?E=@8000?E=@04003E5MDE0002gC<01000eACE5=DD0P001=dB00H00=Cce?<00?E?
0003kA03000:ool0033oo`03003ooooo03;oo`04002]o0000002[O`00`00[Ob]o003[O`40003[O`0
0`00[Ob]o002[O`30005[O`01000[Ob]o:gl0`001Jgl0P0000>]g00000000ZgL00<00:gL[M`00jgL
00@00:gL000000:]g003002]g:gL00>]g0<000B]g003002]g:gL00:]g0<000F]g003002]g:gL0080
00:]g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00>]g08000B]g003002]g:gL00>]
g0<000F]g004002]g0000002[M`00`00[Mb]g003[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`3
0004[M`00`00[Mb]g003[M`20005[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g002
0002[M`00`00[Mb]g003[M`30004[M`00`00[Mb]g0020002[M`00`00[Mb]g003[M`01000]M`00000
0[GL00<00;GL]M`00kGL0`001;GK00<00;GK]M/00[GK0`001KGK00@00;GK000000:ef`03002efkGK
00>ef`<000Bef`04002efkGK]M/200000kFk002e^`04]K/01000]K/000000[Fk00<00;Fk]K/00kFk
0`001;Fk00<00;Fk]K/00P000[Fk00<00;Fk]K/00kFk0P001;Fk00<00;Fk]K/00[Fk0`001KFk00@0
0;Fk000000>e^`03002e^kFk00:e^`8000Fe^P04002e^P000003]KX00`00]KZe^P03]KX20005_IX0
1000_IX000000kfJ00@00;fJ_IZmVP<000JmVP03002mV[fJ00>mVP03002mVKfI008000:mV@03002m
VKfI00:mV@03002mV@0000JmV@03002mNKei00>mN@030035N@0000?5N@050035N<EhaGP00002aGP0
0`00aGS5N003aGP20004aGP20005aEL20005cEL20002cEH00`00cEK=EP020005eCD00`00cCH00002
eCD01`00eAGE5MDE003M<`0000CE5003003M4]dB00;M4P06003DlmCc003eC`000nd@0`002_oo000a
ool00`00ooooo`0bool00`00[Ob]o003[O`200000jgl00000002[O`00`00[Ob]o003[O`01000[O`0
00000Zgl00<00:gl[O`00jgl10000jgl00<00:gl[O`00jgl0P001JgL00@00:gL[Mb]g0<000F]g080
0003[M`0000000:]g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`30004[M`00`00
[Mb]g002[M`30005[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00
[Mb]g003[M`20004[M`00`00[Mb]g003[M`30005[M`01000[M`000000ZgL00<00:gL[M`00jgL00<0
0:gL[M`00P000ZgL00<00:gL[M`00ZgL0`001:gL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`00P00
0ZgL00<00:gL[M`00ZgL0`001:gL00<00:gL[M`00jgL0P001KGL00<00;GL]M`00P0000>eg000]M/0
1;GK00<00;GK]M/00P000[GK00<00;GK]M/00kGK0P001KGK00<00;GK]M/00P0000>ef`00]M/01;GK
00@00;GK000000>e^`03002e^kFk00>e^`8000Fe^`03002e^kFk00800003]K/00;Fk00Fe^`8000Be
^`04002e^kFk]K/200000kFk002e^`04]K/01000]K/000000kFk00<00;Fk]K/00[Fk0P001KFk00<0
0;Fk]K/00P000[Fk00<00;Fj]KX00[Fj0P001[Fj00<00;Fj]KX00P0000>eVP00_IX01KfJ00<00;fJ
_IX00kfJ00@00;fJ000000>mVP04002mV[fJ_IX30006_IX20005_IT01000_IVmV@000[fI00<00;fI
_IT00kfI0P001[ei00<00<EiaGT00lEi00<00<Eh00001<Eh00<00<EhaGP00P000/Eh00@00<EhaGP0
00;5F0030035ElEG00;5E`030035E`0000C=E`030035E`0000;=EP05003=EP00cCH00003eCD01000
cCK==P000]De00L00=DEeAGE5@00gC<00004eA@00`00gA;M4P02gA801P00e??Dl`00mDl000?]40<0
00[oo`00<_oo0P00<ooo00<00:gl[O`00jgl0P001:gl00<00:gl[O`00jgl0P001Jgl0P0000>]o000
00000Zgl00<00:gl[O`00jgl00<00:gl[O`00P000ZgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`0
0jgL0P001JgL00@00:gL[Mb]g0<000F]g003002]g:gL008000:]g003002]g:gL00>]g004002]g000
0002[M`00`00[Mb]g003[M`30004[M`00`00[Mb]g002[M`30005[M`00`00[Mb]g0020002[M`00`00
[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g003[M`20004[M`00`00[Mb]g003[M`30004[M`0
0`00[Mb]g0020002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL0`001:gL00<0
0:gL[M`00P000ZgL00<00:gL[M`00jgL00<00:gL[M`00P000ZgL00<00;GL]M`00[GL0`001;GL00<0
0;GK]M/00[GK0`001KGK00<00;GK]M/00P000[GK00<00;GK]M/00[GK0`001;GK00<00;GK]M/00[GK
0P001[Fk00<00;Fk]K/00P000[Fk00<00;Fk]K/00[Fk0`001;Fk00@00;Fk]K^e^`800003]K/00;Fk
00Be^`03002e^`0000>e^`03002e^kFk00>e^`8000Fe^`03002e^kFk008000:e^`03002e^kFk00:e
^`<000Fe^`04002e^P000002]KX00`00]KZe^P04]KX20004]IX01000_IZmV[fJ0`001[fJ00<00;fJ
_IX00kfJ00@00;fJ000000>mVP03002mV[fJ00>mVP03002mVKfI00BmV@03002mV@0000BmV@03002m
VKfI008000:mN@03002mNKei00:mN@8000K5N@030035N<Eh00?5N0030035N00000C5N0040035N<Eh
0002aEP01@00aEO5ElEG00000/EG00D00<eGcEO=E`0000;5E`05003=E/eFcEH00002cCH01@00eCGE
=MDe00000/df00<00=De00001=DE0P001MDD00<00=dBgA800]dB00H00=Cce?<00?E?0003kA000`00
e;80000:ool003Coo`03003ooooo037oo`03002]o:gl008000:]o003002]o:gl00:]o003002]o:gl
008000:]o003002]o:gl00>]o08000B]o003002]o:gl00>]o0<000F]g004002]g0000002[M`00`00
[Mb]g003[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`40003[M`00`00[Mb]g002[M`30005[M`0
1000[Mb]g:gL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL00@00:gL000000:]g003002]
g:gL00>]g0<000F]g003002]g:gL00@000F]g003002]g:gL008000:]g003002]g:gL00:]g003002]
g:gL008000:]g003002]g:gL00:]g0<000F]g004002]g:gL[M`30005[M`00`00[Mb]g0020002[M`0
0`00[Mb]g002[M`30004[M`00`00[Mb]g003[M`30004[M`00`00]Mbeg0020002[M`00`00]Mbeg002
]M`00`00]M^ef`020002]M/00`00]M^ef`03]M/30004]M/00`00]M^ef`020002]M/00`00]M^ef`02
]M/00`00]M^ef`020002]K/00`00]K^e^`03]K/30004]K/00`00]K^e^`0200000kFk002e^`04]K/0
1000]K/000000kFk00<00;Fk]K/00kFk0P001KFk00<00;Fk]K/00P000[Fk00<00;Fk]K/00[Fk0`00
1;Fk00<00;Fk]K/00P000[Fk00<00;Fk]K/01;Fk00<00;Fj]KX00[Fj00<00;Fj]KX00[Fj0`001KFJ
00@00;fJ000000>eVP04002mV[fJ_IX30006_IX00`00_IZmVP03_IX01000_IZmV[fJ0P0000>mVP00
_IT01KfI00<00;fI_IT00kfI00<00;fI00001;ei00<00;ei_GT00P000[ei00<00<EiaGT00/Ei0P00
1/Eh00<00<EhaGP01<Eh0P001<EH00<00<EG00001<EG00<00<eG00001<EG00@00<eF000000?==P03
003E=@0000?==P03003E=@0000GE5@03003E5=DD00;E5003003<m00000;M4P03003DlmCc00;Dl`80
00?]4004003D/P000009ool003Goo`03003ooooo037oo`8000F]o003002]o:gl00@000F]o003002]
o:gl008000:]o003002]o:gl00:]o003002]o:gl008000:]g003002]g:gL00>]g08000B]g003002]
g:gL00>]g0<000F]g004002]g0000002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`0
0jgL10000jgL00<00:gL[M`00ZgL0`001JgL00@00:gL[Mb]g0<000F]g003002]g:gL008000:]g003
002]g:gL00>]g0<000>]g003002]g:gL00>]g0<000B]g004002]g:gL[M`40005[M`01000[M`00000
0ZgL00<00:gL[M`00jgL10000jgL00<00:gL[M`00ZgL0`001JgL00@00:gL000000:]g003002]g:gL
00>]g003002]g:gL008000:]g003002]g:gL00:]g0<000B]g003002eg;GL00:eg0<000Fef`03002e
fkGK008000:ef`03002efkGK00:ef`<000Bef`03002efkGK00:ef`<000Fe^`03002e^kFk008000:e
^`03002e^kFk00:e^`<000Be^`03002e^kFk00:e^`8000Je^`03002e^kFk008000:e^`03002e^kFk
00:e^`<000Be^`03002e^kFk00800003]K/00;Fk00Fe^`8000Be^`03002e^kFk00:e^`<000Fe^P04
002e^P000003]IX00`00]IZeVP02]IX20005]IX01000_IX000000kfJ00@00;fJ_IZmVP800003_IX0
0;fJ00BmVP<000>mVP03002mVKfI00:mV@<000JmV@03002mNKei00BmN@8000BmN@030035NLEi0080
00:mN@030035N<Eh00;5N08000K5N0030035F<EH00?5F0030035E`0000C5E`03003=E`0000C5E`05
003=EP00cCH00002cCH00`00eCD00004cCH00`00eAGE5@04eAD00`00eACE5002eA@00`00c?@00002
gA800`00e??Dl`02e?<20003kA001000e;8000002Ooo000fool00`00ooooo`0aool00`00[Ob]o003
[O`30003[O`00`00[Ob]o003[O`30005[O`00`00[Ob]o0040005[M`00`00[Mb]g0020002[M`00`00
[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g003[M`20004[M`00`00[Mb]g003[M`20005[M`0
0`00[Mb]g0020002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL10000jgL00<0
0:gL[M`00ZgL0`001JgL00<00:gL[M`00P0000>]g000[M`01:gL00<00:gL[M`00P000ZgL00<00:gL
[M`00ZgL10000jgL00<00:gL[M`00jgL0P001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<0
0:gL[M`00P000ZgL00<00:gL[M`00jgL0P001:gL00<00:gL[M`00jgL0`001:gL00<00:gL[M`00P00
0ZgL00<00:gL[M`00jgL00@00;GL000000:eg003002efkGK00>ef`<000Bef`03002efkGK008000:e
f`03002efkGK00>ef`04002ef`000002]M/00`00]K^e^`03]K/30004]K/00`00]K^e^`020002]K/0
0`00]K^e^`02]K/00`00]K^e^`020002]K/00`00]K^e^`03]K/30004]K/00`00]K^e^`0200000kFk
002e^`05]K/20004]K/01000]K^e^kFk0P0000>e^`00]K/01;Fk00@00;Fk000000>e^`03002e^[Fj
00:e^P8000FeVP03002eV[FJ008000:eVP03002eV[FJ00:eVP8000FmVP04002mVP000003_IX00`00
_IZmVP02_IX20006_IX01000_IT000000kfI00@00;fI_IVmV@<000JmN@03002mNKei00BmN@8000Bm
N@030035N<Eh008000:mN0030035N<Eh00;5N08000K5F0030035ElEG00C5E`030035ElEG00C5E`05
003==/dfcCH00002cCH00`00cCK==P03cCH00`00eAGE5@04eAD00`00eACE5002eA@00`00c?@00002
gA800`00e??Dl`02e?<20003kA001000e;8000002Ooo000gool2000bool00`00[Ob]o0020002[O`0
0`00[Ob]o002[O`00`00[Ob]o0020002[O`00`00[Ob]o003[O`30003[M`00`00[Mb]g003[M`30005
[M`00`00[Mb]g0040005[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`0
0`00[Mb]g002[M`30004[M`00`00[Mb]g003[M`20005[M`00`00[Mb]g0020002[M`00`00[Mb]g003
[M`01000[M`000000ZgL00<00:gL[M`00jgL0`001:gL00<00:gL[M`00ZgL0`001JgL00@00:gL0000
00:]g003002]g:gL00>]g003002]g:gL008000:]g003002]g:gL00:]g0<000B]g003002]g:gL00:]
g0<000F]g003002]g:gL00800003[M`00:gL00B]g003002]g:gL008000:]g003002]g:gL00:]g0<0
00B]g003002]g:gL00>]g08000Feg003002efkGK008000:ef`03002efkGK00:ef`<000Bef`03002e
fkGK00>ef`8000Fef`03002e^kFk00800003]K/00;Fk00Fe^`8000Be^`03002e^kFk00:e^`<000Fe
^`03002e^kFk008000:e^`03002e^kFk00:e^`<000Be^`04002e^kFk]K/200000kFk002e^`03]K/0
1000]K/000000kFk00<00;Fk]K/00kFk0P001KFk00<00;Fj]KX00P0000>e^P00]IX01KFJ0P001;FJ
00<00;FJ]IX00P0000>eVP00_IX01KfJ00<00;fJ_IX01;fJ00@00;fJ000000:mVP03002mV[fJ00Bm
VP03002mVKfI00>mV@04002mV@000003_GT01000_GVmNKei0`001[ei00<00;ei_GT01;ei0P001;eh
00<00<EhaGP00P000/EH00<00<EHaEP00/EH0P001LEG0P001LEG0P001<df0`001<df0P001MDE00<0
0<dE00000mDD00<00<cd00000]dB00<00=Cce?<00]Cc0P000nd@00@00=Bb000000Woo`00>Ooo00<0
0?ooool0<?oo0P001Jgl00<00:gl[O`010001Jgl00<00:gl[O`00P000Zgl00<00:gL[M`00ZgL00<0
0:gL[M`00P000ZgL00<00:gL[M`00jgL0`000jgL00<00:gL[M`00jgL0`001JgL00<00:gL[M`01000
1JgL00@00:gL000000:]g003002]g:gL00>]g003002]g:gL008000:]g003002]g:gL00:]g0<000B]
g003002]g:gL00>]g08000F]g003002]g:gL008000:]g003002]g:gL00:]g003002]g:gL008000:]
g003002]g:gL00>]g08000B]g003002]g:gL00>]g0<000B]g003002]g:gL008000:]g003002]g:gL
00>]g004002]g0000002[M`00`00[Mb]g003[M`30004[M`00`00[Mb]g002[M`30005[M`01000[M`0
00000ZgL00<00:gL[M`00jgL00<00:gL[M`00P000ZgL00<00;GL]M`00[GL0`001;GK00<00;GK]M/0
0P000[GK00<00;GK]M/00kGK00<00;GK]M/00P000[GK00<00;GK]M/00[GK0`001;Fk00@00;Fk]K^e
^`800003]K/00;Fk00Be^`04002e^`000002]K/00`00]K^e^`03]K/30004]K/00`00]K^e^`020000
0kFk002e^`04]K/01000]K/000000kFk00<00;Fk]K/00[Fk0P001[Fk00<00;Fk]K/00P0000>e^`00
]K/01KFk0P001;Fj00@00;FJ]IZeVP<000JeVP8000BeVP04002mV[fJ_IX200000kFJ002mVP05_IX0
0`00_IZmVP02_IX00`00_IZmVP02_IX30006_IT00`00_GVmN@03_GT01000_GT000000kei00@00;ei
_GVmN@<000JmN@03002mN;eh00BmN08000C5F0030035F<EH008000;5F0050035ElEGaEL00002aEL0
1@00aEO5ElEG00000/Dg00@00<dfcCK==P800003aCH00<df00;==P03003=5P0000CE5@03003=5@00
00;E5007003<m<cdc?@00=dB00001MCc00D00>d@kA3]400000;D/P03003ooooo00Ooo`00>_oo00<0
0?ooool0<?oo00<00:gl[O`00jgl0`000jgl00<00:gl[O`00jgl0`001Jgl00<00:gL[M`010001JgL
00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL0`000jgL
00<00:gL[M`00jgL0P001JgL00@00:gL[Mb]g0@000F]g004002]g0000002[M`00`00[Mb]g003[M`0
0`00[Mb]g0020002[M`00`00[Mb]g002[M`30005[M`00`00[Mb]g0040005[M`00`00[Mb]g0020002
[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`30004[M`00`00[Mb]g003[M`2
0005[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g003[M`2
0005[M`01000[Mb]g:gL10001:gL00<00;GL]M`00P000ZgL00<00;GK]M/00[GK0`001;GK00<00;GK
]M/00kGK0`001;GK00<00;GK]M/00P0000>e^`00]K/01;Fk00@00;Fk000000>e^`03002e^kFk00>e
^`8000Fe^`03002e^kFk00800003]K/00;Fk00Fe^`8000Be^`03002e^kFk00:e^`8000Je^`04002e
^`000002]K/00`00]K^e^`03]K/30004]K/01000]K^e^kFk0`001KFj00@00;FJ000000>eVP04002e
V[FJ]IX200000kFJ002eVP03]IX01000_IX000000kFJ00<00;fJ_IX00[fJ0`001KfJ00@00;fJ0000
00>mVP04002mVKfI_IT30006_GT00`00_GVmN@03_GT01000_GT000000kei00<00;ei_GT00[ei0P00
1[eh00<00<EHaEP01<EH0P001<EH00@00<EGaEL000?5E`050035ElEGaEL00002aCL01000cCK==/df
0P0000G5=P00cCK==P0000;=5P05003E5MDEeAD00002cAD01000eACE50000lcd00<00=dB00001MCc
00D00>d@kA3]400000;D/P03003ooooo00Ooo`00>ooo00<00?ooool0<?oo00<00:gl[O`00P000Zgl
00<00:gl[O`00Zgl0P0000>]o00000000Zgl00<00:gl[O`00jgl0`000jgL00<00:gL[M`00jgL0`00
1JgL00<00:gL[M`010001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL
00<00:gL[M`00ZgL10000jgL00<00:gL[M`00jgL0P001JgL00@00:gL[Mb]g0@000B]g003002]g:gL
008000:]g003002]g:gL00>]g0<000>]g003002]g:gL00>]g0<000B]g004002]g:gL[M`40005[M`0
1000[M`000000ZgL00<00:gL[M`00jgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL0`001JgL00<0
0:gL[M`010001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL0`00
1JgL00@00;GK000000:]f`03002efkGK00>ef`03002efkGK008000:ef`03002efkGK00:ef`<000Be
^`03002e^kFk00:e^`8000Je^`03002e^kFk008000:e^`03002e^kFk00:e^`<000Be^`04002e^kFk
]K/30005]K/00`00]K^e^`020002]K/00`00]K^e^`03]K/20005]K/00`00]K^e^`0200000kFk002e
^`04]K/01000]K/000000kFk00<00;Fj]KX00[Fj0P001KFJ00@00;FJ000000>eVP03002eV[FJ00:e
VP8000JeVP04002mVP000003]IX00`00_IZmVP02_IX20005_IX01000_IT000000kei00@00;ei_GVm
N@<000JmN@03002mNKei00>mN@03002mNKei008000:mN@03002mN;eh00:mN08000K5F0030035F<EH
00C5F08000C5E`040035ElEG0003aCL01000cCK==P000/Df0P000/df00@00<dFcAH000?E5@07003=
5LdEcAD00=DD00000lcd0P001]Cc00D00>d@kA3]400000;D/P03003ooooo00Ooo`00??oo0P00<Ooo
0P001:gl00<00:gl[O`00jgl0P001Jgl00<00:gl[O`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`0
0P000ZgL00<00:gL[M`00jgL0`000jgL00<00:gL[M`00jgL0`001JgL00<00:gL[M`010001JgL00@0
0:gL000000:]g003002]g:gL00>]g003002]g:gL008000:]g003002]g:gL00:]g0@000>]g003002]
g:gL00:]g0<000F]g003002]g:gL008000:]g003002]g:gL00:]g003002]g:gL008000:]g003002]
g:gL00:]g0@000>]g003002]g:gL00>]g08000F]g004002]g:gL[M`40004[M`00`00[Mb]g0020002
[M`00`00[Mb]g003[M`30003[M`00`00[Mb]g003[M`30004[M`00`00[Mb]g0020002[M`00`00[Mb]
g002[M`00`00[Mb]g0020002[M`00`00[Mb]g003[M`20004[M/00`00]M^ef`03]M/30004]M/00`00
]M^ef`020002]K/00`00]K^e^`02]K/00`00]K^e^`020002]K/00`00]K^e^`03]K/30004]K/00`00
]K^e^`0200000kFk002e^`04]K/01000]K/000000kFk00<00;Fk]K/00[Fk0`001KFk00<00;Fk]K/0
0P0000>e^`00]K/01KFk0P001;Fk00<00;Fk]K/00[Fk0P001KFk00<00;Fj]KX00P000[FJ00<00;FJ
]IX00[FJ0P001[FJ00@00;FJ000000:eVP03002eV[FJ00BeVP03002eV[FJ00>eVP03002mV[fJ0080
0003_IX00;fJ00FmVP03002mNKei00>mN@04002mN@000003_GT00`00_GVmN@02_GT20006_GT20004
_GT00`00_GRmN0020002_EP00`00aES5F002aEP20006aEP00`00aEO5E`04aEL20004aCL00`00cCH0
0004aCH00`00cCH00004cAH00`00eAD00004cAD00`00eA@00004c?@00`00e??Dl`03e?<20002kA00
1000e;;D/]Bb0P002?oo000nool00`00ooooo`0_ool00`00[Ob]o003[O`00`00[Ob]o0020002[O`0
0`00[Ob]o002[O`30004[M`00`00[Mb]g002[M`30005[M`00`00[Mb]g0020002[M`00`00[Mb]g002
[M`00`00[Mb]g0020002[M`00`00[Mb]g003[M`30003[M`00`00[Mb]g003[M`20005[M`01000[Mb]
g:gL10001JgL00@00:gL000000:]g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`3
0004[M`00`00[Mb]g002[M`30005[M`01000[M`000000ZgL00<00:gL[M`00jgL00<00:gL[M`00P00
0ZgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`00P0000>]g000[M`0
1:gL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL0`001:gL00<00:gL[M`00ZgL0`001JgL00<00:gL
[M`00P0000>]f`00[M/01:gK00<00;GK]M/00P000[GK00<00;GK]M/00[GK0`001;Fk00<00;Fk]K/0
0[Fk0`001KFk00<00;Fk]K/00P000[Fk00<00;Fk]K/00[Fk0`001;Fk00<00;Fk]K/00[Fk0P001KFk
00<00;Fk]K/00P000[Fk00<00;Fk]K/00kFk0`001;Fk00@00;Fk]K^e^`<000Fe^`03002e^kFk0080
00:e^`03002e^kFk00:e^`<000BeVP03002eV[FJ008000:eVP03002eV[FJ00BeVP03002eV[FJ00:e
VP03002eV[FJ00:eVP<000JeVP8000BmVP04002mV[fJ_IX30006_GT00`00_GVmN@03_GT00`00_GVm
N@020002_GT00`00_GVmN@03_GT00`00_GVmN@04_GT20004_EP00`00aES5F0020002_EP00`00aES5
F002aEP20006aEL00`00aCO5=`04aCL20004aCH30004cAH00`00eAD00005cAD00`00c?C<m003c?@0
0`00e??Dl`03e?<01@00c;<00>d@00000mBb0P002?oo000oool00`00ooooo`0_ool20002[O`40005
[O`01000[O`000000ZgL00<00:gL[M`00jgL00@00:gL000000:]g003002]g:gL00>]g0<000B]g003
002]g:gL00:]g0<000F]g003002]g:gL008000:]g003002]g:gL00:]g003002]g:gL008000:]g003
002]g:gL00:]g0@000>]g003002]g:gL00>]g08000F]g004002]g:gL[M`30005[M`00`00[Mb]g002
0002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL0P001:gL00<00:gL[M`00jgL
0`001:gL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL00@00:gL000000:]g003002]g:gL00>]g0<0
00B]g003002]g:gL00:]g0<000B]g003002]g:gL008000:]g003002]g:gL00>]g004002]g0000002
[M`00`00[Mb]g003[M`30004[M/00`00[M^]f`02[M/30004]M/00`00]M^ef`020002]K/00`00]K^e
^`03]K/01000]K/000000[Fk00<00;Fk]K/00kFk0`001;Fk00<00;Fk]K/00P0000>e^`00]K/01;Fk
00<00;Fk]K/00P000[Fk00<00;Fk]K/00[Fk0`001KFk00<00;Fk]K/00P0000>e^`00]K/01;Fk00@0
0;Fk000000>e^`03002e^kFk00:e^`<000Be^`03002e^kFk008000:eV`03002eV[FJ00>eVP8000Be
VP03002eV[FJ00:eVP<000FeVP04002eVP000003]IX01000]IZeV[FJ0`001KfJ00@00;fJ000000>m
NP04002mNKei_GT30006_GT20004_GT01000_GVmNKei0`001[ei00<00;eH_EP01;eH0P001;eH00<0
0<EHaEP00P000[eH00<00<EGaEL00/EG0P001/Dg00<00<DfaCH01<Df00<00<dFcAH01<dF00<00<dE
cAD01<dE00<00<cdc?@00lcd00<00=Cce?<00mCc00D00<bc003]400000?D/P8000Soo`00@?oo00<0
0?ooool0<?oo0P000jgl00<00:gl[O`00jgl0P001JgL00@00:gL[Mb]g0<000F]g0800003[M`00000
00:]g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`30004[M`00`00[Mb]g002[M`3
0005[M`01000[M`000000ZgL00<00:gL[M`00jgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL1000
0jgL00<00:gL[M`00ZgL0`001JgL00@00:gL[Mb]g0<000F]g003002]g:gL008000:]g003002]g:gL
00:]g003002]g:gL008000:]g003002]g:gL00:]g0<000B]g003002]g:gL00>]g08000F]g003002]
g:gL008000:]g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00:]g0<000B]g003002]
g:gL00>]g08000F]g003002]g:gL00800003[M`00:gK00B]f`03002]fjgK008000:]f`03002efkGK
00:ef`<000Be^`03002e^kFk00>e^`8000Fe^`03002e^kFk008000:e^`03002e^kFk00:e^`<000Be
^`03002e^kFk00:e^`<000Fe^`04002e^`000002]K/00`00]K^e^`04]K/20004]K/00`00]K^e^`02
]K/20005]K/00`00]K^e^`0200000kFk002e^`05]K/20004]I/01000]IZeV[FJ0P0000>eVP00]IX0
1;FJ00@00;FJ000000>eVP03002eV[FJ00:eVP8000FeVP04002eVP000003]IX00`00_IZmVP03_IX0
0`00_GZmNP03_GX01000_GT000000kei00<00;ei_GT00kei00<00;ei_GT01;ei0`000kei00@00;ei
_GVmN@<000JmF003002mF;eH00BmF08000BmF0050035ElEGaEL00002aCL00`00aCO5=`02aCL20005
aCH30005cAH00`00cAG=5@03cAD20004c?@20005e?<01@00c;<00>d@00001=Bb00<00?ooool01_oo
0011ool2000aool00`00[Ob]o002[O`00`00[Ob]o0020002[O`00`00[Mb]g002[M`40003[M`00`00
[Mb]g003[M`20005[M`01000[Mb]g:gL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL00@0
0:gL000000:]g003002]g:gL00>]g08000B]g003002]g:gL00>]g0<000B]g003002]g:gL008000:]
g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`40003[M`00`00[Mb]g002[M`30005
[M`00`00[Mb]g0040005[M`01000[M`000000ZgL00<00:gL[M`00jgL00<00:gL[M`00P000ZgL00<0
0:gL[M`00ZgL0`001:gL00<00:gL[M`00ZgL0`001JgL00@00:gL000000:]g003002]g:gL00>]g003
002]g:gL008000:]g003002]g:gL00:]g0<000B]g003002]fjgK00:]f`<000F]f`04002ef`000002
[K/00`00]K^e^`03]K/00`00]K^e^`020002]K/00`00]K^e^`02]K/30004]K/00`00]K^e^`020002
]K/00`00]K^e^`02]K/00`00]K^e^`020002]K/00`00]K^e^`03]K/20004]K/00`00]K^e^`02]K/3
0005]K/00`00]K^e^`020002]K/00`00]K^e^`02]K/30004]K/01000]K^e^kFk0P0000>eV`00]I/0
1;FK00<00;FJ00000kFJ00<00;FJ]IX00kFJ0P001KFJ00<00;FJ]IX00P0000>eVP00]IX01KFJ00<0
0;FJ]IX00kFJ00@00;fJ_IZmVP<000JmNP03002mNKei00>mN@04002mNKei_GT30006_GT00`00_GVm
N@03_GT01000_GT000000keI00<00;eH_EP00[eH00<00;eH00001KeH00<00;eH_EP00keH00@00<EG
aEL000?5=`050035=lDgaCL00002aCL01@00aCK5=/Df00000/DF0P000ldF0P001LdE0P001<cd00<0
0<cD00000mCc00H00<bcc;<00>d@0004e;800`00ooooo`06ool004?oo`03003ooooo02ooo`03002]
o:gl00@000F]o004002]g0000002[M`00`00[Mb]g003[M`00`00[Mb]g0020002[M`00`00[Mb]g002
[M`40003[M`00`00[Mb]g002[M`30005[M`01000[Mb]g:gL0`001JgL00<00:gL[M`00P000ZgL00<0
0:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL0`001:gL00<00:gL[M`00jgL0P001JgL
00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL0`000jgL
00<00:gL[M`00jgL0P001JgL00@00:gL[Mb]g0@000B]g003002]g:gL008000:]g003002]g:gL00>]
g004002]g0000002[M`00`00[Mb]g003[M`20004[M`00`00[Mb]g003[M`30004[M`00`00[Mb]g002
0002[M`00`00[Mb]g002[M`00`00[M^]f`020002[M/00`00[M^]f`03[M/20004[K/00`00]K^e^`03
]K/30004]K/00`00]K^e^`020002]K/00`00]K^e^`02]K/30004]K/00`00]K^e^`02]K/30005]K/0
0`00]K^e^`0200000kFk002e^`04]K/01000]K/000000kFk00<00;Fk]K/00[Fk0`001;Fk00<00;Fk
]K/00P000[Fk00<00;Fk]K/00[Fk00@00;Fk000000>eV`03002eVkFK00>eV`8000FeVP03002eV[FJ
00800003]IX00;FJ00FeVP8000BeVP04002eV[FJ]IX30006]IX30003]GX01000_GZmN[ej0`001[ei
0`000kei00@00;ei_GVmN@800003_GT00;ei00BmN@03002mFKeI00>mF@03002mF;eH008000:mF003
002mF;eH00:mF08000JmF08000C5=`040035=lDg0003aCL01@00aCK5=/Df00000/DF0P000/dF00@0
0<Cfa?H000?=5@040034mLCe0003c?@00`00c=@00003e?<01P00c;?</`00kA0000CD/P03003ooooo
00Koo`00A?oo00<00?ooool0;ooo0P000jgl00<00:gl[O`00jgl0P001JgL00@00:gL[Mb]g0@000F]
g004002]g0000002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL10000jgL00<0
0:gL[M`00ZgL0`001JgL00<00:gL[M`010001JgL00@00:gL000000:]g003002]g:gL00>]g003002]
g:gL008000:]g003002]g:gL00:]g0<000B]g003002]g:gL00:]g0<000F]g003002]g:gL00800003
[M`00:gL00B]g003002]g:gL008000:]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0<000F]
g004002]g:gL[M`30005[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`0
0`00[Mb]g002[M`30004[M`00`00[Mb]g002[M`30005[M/00`00[M^]f`020002[M/00`00[K^]^`02
[K/00`00]K^e^`020002]K/00`00]K^e^`02]K/30004]K/00`00]K^e^`020002]K/00`00]K^e^`03
]K/01000]K/000000[Fk00<00;Fk]K/00kFk0`001;Fk00<00;Fk]K/00[Fk0P001KFk00<00;Fk]K/0
0P0000>e^`00]K/01KFk0P001;Fk00<00;Fk]K/00[Fk0P001[FK00<00;FK]I/00P0000>eV`00]IX0
1KFJ0P001;FJ00@00;FJ]IZeVP<000FeVP04002eVP000003]IX00`00]IZeVP02]IX20005]GX01000
_GX000000kEj00<00;ei_GT00kei00<00;ei_GT00kei00@00;ei000000>mN@03002mNKei00:mN@03
002mF@0000FmF@8000FmF004002mF;eH0002_EP00`00_ERmF003_EP00`00aCO5=`04aCL20004aCL0
1000aCK5=P000lDF00D00<dF003=5P0000;4mP05003=5LdEcAD00002a?D01000c?C<m0000/cD00D0
0=Cce??Dl`0000;</`03003]400000CD/P03003ooooo00Koo`00AOoo00<00?ooool0;ooo00<00:gl
[O`00Zgl00<00:gl[O`00P000ZgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00jgL0P001JgL00@0
0:gL[Mb]g0<000F]g003002]g:gL008000:]g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]
g003[M`30003[M`00`00[Mb]g003[M`20005[M`01000[Mb]g:gL10001JgL00@00:gL000000:]g003
002]g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`30004[M`00`00[Mb]g002[M`30004[M`0
0`00[Mb]g0020002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL10000jgL00<0
0:gL[M`00ZgL0`001:gL00@00:gL[Mb]g0@000B]g003002]g:gL008000:]g003002]g:gL00>]g004
002]g0000002[M`00`00[M^]f`03[M/30004[M/01000[K^]^jfk10001;Fk00<00;Fk]K/00P000[Fk
00<00;Fk]K/00[Fk0`001;Fk00<00;Fk]K/00kFk0P001KFk00<00;Fk]K/00P0000>e^`00]K/01;Fk
00<00;Fk]K/00P000[Fk00<00;Fk]K/00[Fk0`001;Fk00@00;Fk]K^e^`800003]K/00;Fk00Be^`04
002e^`000002]I/00`00]I^eV`03]I/30004]I/01000]IZeV[FJ0`001KFJ00@00;FJ000000>eVP03
002eV[FJ00:eVP8000FeVP03002eV[FJ00800003]IX00;Ej00FeNP03002eN[Ej00>eNP04002mNKei
_GT200000kei002mN@04_GT00`00_GVmN@04_GT01000_GVmN@000[eI00<00;eI_ET00keI00<00;eH
_EP01;eH00<00;eH00000keH00<00;eH_EP00[eH00<00;dh00001LDg00<00<DgaCL01<Dg0P001<DF
00@00<dFcAH000?4mP04003=5LdE0003a?D01000c?C<m0000/cD00D00=Cce??Dl`0000?</`8000CD
/P8000Ooo`00A_oo0P00<?oo00<00:gl[O`010001JgL00@00:gL000000:]g003002]g:gL00>]g003
002]g:gL008000:]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0<000F]g004002]g:gL[M`3
0005[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`4
0003[M`00`00[Mb]g003[M`20005[M`01000[Mb]g:gL0`001JgL00<00:gL[M`00P000ZgL00<00:gL
[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL0`001:gL00<00:gL[M`00jgL0P001JgL00<0
0:gL[M`00P0000>]g000[M`01:gL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL10000jgL00<00:gL
[M`00ZgL0`001JgL00@00:gL[Mb]g0<000F]g003002]fjgK008000:]f`03002]fjgK00:]f`@000>]
^`03002e^kFk00:e^`<000Fe^`04002e^`000002]K/00`00]K^e^`03]K/00`00]K^e^`020002]K/0
0`00]K^e^`02]K/30004]K/00`00]K^e^`02]K/30004]K/00`00]K^e^`020002]K/00`00]K^e^`02
]K/01000]K/000000kFk00<00;Fk]K/00kFk0P001KFK00<00;FK]I/00P0000>eV`00]I/01;FK00@0
0;FJ000000>eVP03002eV[FJ00:eVP8000FeVP03002eV[FJ00800003]IX00;FJ00FeVP8000BeVP04
002eN[Ej]GX200000kEj002eNP04]GX30003_GT01000_GVmNKei0P0000>mN@00_GT01;ei00<00;ei
00001;eI00<00;eI_ET00P0000>mF@00_EP01KeH00<00;eH_EP00keH00@00;eH_EP000:m>0030035
=lDg00;5=`8000K5=`0300355/DF00C55P<000?4mP03003=5@0000C4m@03003<m00000C<e003003D
l`0000C</`8000GD/P03003ooooo00Goo`00B?oo00<00?ooool0;_oo0P000jgL00<00:gL[M`00jgL
0P001JgL0P000ZgL10001JgL00@00:gL000000:]g003002]g:gL00>]g004002]g0000002[M`00`00
[Mb]g003[M`40003[M`00`00[Mb]g002[M`30005[M`00`00[Mb]g0040005[M`01000[M`000000ZgL
00<00:gL[M`00jgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL0`00
1JgL00<00:gL[M`010001JgL00@00:gL000000:]g003002]g:gL00>]g003002]g:gL008000:]g003
002]g:gL00:]g0<000B]g003002]g:gL00:]g0<000F]g004002]g0000002[M`00`00[Mb]g003[M`0
1000[M`000000ZgL00<00:gL[M`00jgL10000jgL00<00:gL[M`00ZgL0`001:gK00<00:gK[M/00P00
0Zfk00<00:fk[K/00Zfk00<00;Fk]K/00P000Zfk00<00;Fk]K/00kFk0P001;Fk00<00;Fk]K/00kFk
0`001;Fk00<00;Fk]K/00P0000>e^`00]K/01;Fk00<00;Fk]K/00P000[Fk00<00;Fk]K/00[Fk0`00
1;Fk00<00;Fk]K/00[Fk0P001[Fk00<00;Fk]K/00P0000>eV`00]I/01KFK0P001;FK00<00;FK]I/0
0[FK0P001KFJ00<00;FJ]IX00P0000>eVP00]IX01KFJ0P001;FJ00@00;FJ]IZeVP<000FeVP04002e
NP000003]GX00`00]GZeNP02]GX20006_GT00`00_GT00003_GT00`00_GVmN@04_GT00`00_EVmF@03
_ET00`00_ET00003_ET00`00_ERmF003_EP20005_EP00`00_EP00004_CP01000aCO5=`000[dg00<0
0<DgaCL00/Dg0P001/DF00@00<Cfa?H000?4mP8000C4m@03003<m00000C<e003003Dl`0000C</`80
00GD/P03003ooooo00Goo`00BOoo00<00?ooool0;_oo00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL
00<00:gL[M`00jgL0`000jgL00<00:gL[M`00jgL0P001JgL00@00:gL[Mb]g0<000F]g003002]g:gL
008000:]g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00>]g0<000>]g003002]g:gL
00>]g08000F]g004002]g:gL[M`40004[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]
g0020002[M`00`00[Mb]g003[M`30003[M`00`00[Mb]g003[M`20005[M`01000[Mb]g:gL10001:gL
00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL0P001:gL
00<00:gL[M`00jgL0P001JgL00<00:gL[M`00P0000>]g000[M`01:gL00<00:gL[M`00P000ZgL00<0
0:gK[M/00ZgK0`001:fk00<00:fk[K/00Zfk0`001Jfk00<00;Fk]K/00P0000>]^`00]K/01;Fk00<0
0;Fk]K/00P000[Fk00<00;Fk]K/00[Fk0`001;Fk00<00;Fk]K/00[Fk0`001;Fk00<00;Fk]K/00P00
0[Fk00<00;Fk]K/00kFk00@00;Fk000000:e^`03002e^kFk00>e^`<000BeV`04002eVkFK]I/30005
]I/00`00]I^eV`020002]I/00`00]IZeVP02]IX30004]IX01000]IZeV[FJ0`001KFJ00@00;FJ0000
00>eVP03002eV[FJ00:eVP8000JeNP04002eNP000002]GX00`00_GVmN@04_GT00`00_GVmN@03_GT0
1000_GVmNKei0`001[eI00<00;eI_ET00keI00<00;eH_EP00P000[eH00<00;eH_EP00keH00<00;dh
_CP00kdh00<00<Dg00000kdg00D00<DgaCO5=`0000:m5`0300355/DF00;55P8000?4mP040034m/Cf
0006a?D20004c=@00`00e?<00004c;<20005e;800`00ooooo`05ool004[oo`03003ooooo02koo`03
002]g:gL00@000F]g003002]g:gL008000:]g003002]g:gL00:]g003002]g:gL008000:]g003002]
g:gL00:]g0@000>]g003002]g:gL00:]g0<000F]g003002]g:gL00@000F]g003002]g:gL008000:]
g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0<0
00B]g003002]g:gL00:]g0<000F]g003002]g:gL00800003[M`00:gL00B]g003002]g:gL008000:]
g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0<000F]g003002]g:gL00@000F]g003002]g:gL
008000:]g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00:]g0<000B]g003002]g:gL
00:]g0<000F]g004002]f`000002[K/00`00[K^]^`03[K/01000[K/000000Zfk00<00:fk[K/00jfk
0`001:fk00<00;Fk]K/00[Fk0`001;Fk00<00;Fk]K/00P0000>e^`00]K/01;Fk00<00;Fk]K/00P00
0[Fk00<00;Fk]K/00[Fk0`001;Fk00<00;Fk]K/00kFk0P001KFk00<00;Fk]K/00P0000>e^`00]I/0
1;FK00@00;FK000000>eV`03002eVkFK00:eV`<000BeV`03002eV[FJ00800003]IX00;FJ00BeVP04
002eVP000003]IX00`00]IZeVP02]IX20005]IX00`00]IZeVP020002]GX00`00]GZeNP04]GX00`00
]GZeNP02]GX00`00_GVmN@02_GT30005_GT01000_GT000000keI00@00;eI_EVmF@<000FmF@03002m
F00000BmF004002mF;eH_EP30006_CP00`00_CNm=`03_CL01000aCO5=`000[dG00D00<DFaAK55P00
00:lmP040034m/Cfa?H30006a?D00`00c=C<e003c=@00`00e?<00004c;<20005e;800`00ooooo`05
ool004_oo`8002ooo`8000>]g003002]g:gL00>]g0<000F]g003002]g:gL00@000F]g004002]g000
0002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL0`000jgL00<00:gL[M`00jgL
0`001:gL00<00:gL[M`00ZgL0`001JgL00@00:gL000000:]g003002]g:gL00>]g004002]g0000002
[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL0`001:gL00<00:gL[M`00ZgL0`00
1:gL00<00:gL[M`00P000ZgL00<00:gL[M`00jgL00@00:gL000000:]g003002]g:gL00>]g0<000>]
g003002]g:gL00>]g0<000B]g004002]g:gL[M`40004[M`00`00[Mb]g0020002[M`00`00[Mb]g002
[M`00`00[Mb]g0020002[M`00`00[Mb]g003[M`20004[K/00`00[K^]^`03[K/20005[K/00`00[K^]
^`0200000jfk002]^`04[K/00`00]K^e^`020002[K/00`00]K^e^`02]K/30004]K/00`00]K^e^`02
]K/30005]K/01000]K/000000[Fk00<00;Fk]K/00kFk00<00;Fk]K/00P000[Fk00<00;Fk]K/00[Fk
0`001;Fk00<00;FK]I/00[FK0P001KFK00<00;FK]I/00P0000>eV`00]I/01KFK0P001;FJ00<00;FJ
]IX00[FJ0P001KFJ00<00;FJ]IX00P000[FJ00<00;FJ]IX00kFJ0P001;Ej00<00;Ej]GX00[Ej0`00
1KEj00@00;ei000000>eN@03002mNKei00:mN@8000FmF@04002mF@000003_ET00`00_EVmF@03_ET0
0`00_ERmF004_EP30003_CP00`00_CRm>002_CP20005_CL00`00aCL00004_AL01000aAK55P000[cf
00@00<Cfa?K4mP800003_=H00<Ce00C4m@03003<e<cD00C<e003003</lbc00C</`03003D/]Bb00?D
/P03003ooooo00Goo`00COoo00<00?ooool0;Ooo00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<0
0:gL[M`00jgL0`000jgL00<00:gL[M`00jgL0P001JgL00@00:gL[Mb]g0<000F]g003002]g:gL0080
00:]g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00>]g004002]g0000002[M`00`00
[Mb]g003[M`20004[M`00`00[Mb]g003[M`20005[M`01000[Mb]g:gL0`001JgL00<00:gL[M`00P00
0ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL0`001:gL00<00:gL[M`00jgL
0P001JgL00<00:gL[M`00P0000>]g000[M`01:gL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL1000
0jgL00<00:gL[M`00ZgL0`001:gL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`00P0000>]_000[K/0
1:fk00<00:fk[K/00P000Zfk00<00:fk[K/00Zfk0`001:fk00<00:fk[K/00Zfk0`001:fk00<00;Fk
]K/00P000[Fk00<00;Fk]K/00[Fk00<00;Fk]K/00P000[Fk00<00;Fk]K/00kFk0P001;Fk00<00;Fk
]K/00kFk0`001;Fk00<00;Fk]K/00P0000>e^`00]K/01;Fk00<00;FK]I/00P000[FK00<00;FK]I/0
0[FK0`001;FK00@00;FK]I^eV`<000FeVP03002eV[FJ008000:eVP03002eV[FJ00:eVP<000BeVP04
002eV[FJ]IX200000kEj002eNP04]GX01000]GX000000kEj00<00;Ej]GX00[Ej0P001KEi00<00;ei
_GT00P0000>eF@00_ET01KeI00<00;eI_ET00keI00@00;eI_EVmF@<000JmF003002m>;dh00>m>003
002m>;dh008000:m>003002m=kdg00>m=`03002m5kdG00>m5`0300355P0000BlmP030034m/Cf0080
0003_=H00<Ce00?4m@8000K<e003003</lbc00C</`03003D/]Bb00?D/P8000Koo`00C_oo00<00?oo
ool0;Ooo00<00:gL[M`010001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P00
0ZgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL0`001:gL00<00:gL[M`00ZgL0`001JgL00@0
0:gL[Mb]g0<000F]g003002]g:gL008000:]g003002]g:gL00:]g003002]g:gL008000:]g003002]
g:gL00:]g0@000>]g003002]g:gL00:]g0<000F]g003002]g:gL00@000F]g004002]g0000002[M`0
0`00[Mb]g003[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`30004[M`00`00[Mb]g002[M`30004
[M`00`00[Mb]g0020002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL00@00:gL
000000:]g003002]g:gL00>]g0<000B]_003002]^jfk00:]^`<000B]^`03002]^jfk00800003[K/0
0:fk00B]^`03002]^jfk008000:]^`03002]^jfk00:]^`<000Be^`03002e^kFk00:e^`<000Fe^`03
002e^kFk00800003]K/00;Fk00Be^`03002e^kFk008000:e^`03002e^kFk00:e^`<000Be^`03002e
^kFk00:e^`<000BeV`03002eVkFK00800003]I/00;FK00BeV`04002eV`000003]I/00`00]IZeVP02
]IX30005]IX01000]IX000000[FJ00<00;FJ]IX00kFJ00<00;FJ00000kEj00<00;Ej]GX00kEj0P00
1KEj00<00;Ej]GX00P0000>eNP00]GT01KEi0P001;EI00@00;eI_EVmF@<000JmF@<000>mF@03002m
F;eH00:mF08000Jm>08000Bm>003002m=kdg00:m=`8000Jm5`03002lm[cf00>lmP030034mP0000:l
eP8000C4m@03002l]@0000G<e003003</lbc00C</`03003D/]Bb00?D/P8000Koo`00Cooo00<00?oo
ool0;Ooo0P000jgL00<00:gL[M`00jgL0`001JgL00<00:gL[M`010001JgL00@00:gL000000:]g003
002]g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL
10000jgL00<00:gL[M`00ZgL0`001:gL00@00:gL[Mb]g0@000F]g004002]g0000002[M`00`00[Mb]
g003[M`01000[M`000000ZgL00<00:gL[M`00jgL0`000jgL00<00:gL[M`00jgL0P001JgL00@00:gL
[Mb]g0@000B]g003002]g:gL008000:]g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL
00:]g0<000B]g003002]g:gL00>]g08000F]g004002]g:gL[M`30005[M`00`00[Mb]g0020002[M`0
0`00[Kb]_002[K`00`00[K^]^`020002[K/00`00[K^]^`02[K/30004[K/00`00[K^]^`02[K/30005
[K/01000[K/000000Zfk00<00;Fk]K/00kFk00@00;Fk000000:e^`03002e^kFk00>e^`<000Be^`03
002e^kFk00:e^`<000Be^`03002e^kFk00800003]K/00;Fk00Be^`03002e^kFk008000:eV`03002e
VkFK00:eV`<000BeV`03002eVkFK00:eV`8000FeV`03002eV[FJ008000:eVP03002eV[FJ00BeVP03
002eV[FJ00:eVP03002eV[FJ00>eVP8000FeNP03002eN[Ej00800003]GX00;Ej00FeNP8000BeNP04
002eNKEi]GT30005]ET01000_ET000000kEI00<00;eI_ET00keI00<00;eI_ET00keI00<00;eH_EP0
0P000[dh00<00;dh_CP00kdh00<00;dh_CP00kdh00<00;dg_CL00P000[dG00<00;dG_AL00[dG0P00
1[cf0P000kcF0P000/Ce00@00;be_;D000C<e08000K</`03003D/]Bb00CD/P03003ooooo00Coo`00
D?oo0P00;_oo00<00:gL[M`00ZgL0P0000>]g00000000ZgL00<00:gL[M`00jgL0`000jgL00<00:gL
[M`00jgL0P001:gL00<00:gL[M`00jgL0P001JgL00@00:gL[Mb]g0<000F]g003002]g:gL008000:]
g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00:]g0@000>]g003002]g:gL00>]g080
00F]g004002]g:gL[M`30005[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002
[M`00`00[Mb]g002[M`40003[M`00`00[Mb]g002[M`30005[M`00`00[Mb]g0040005[M`01000[M`0
00000ZgL00<00:gL[M`00jgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`0
0ZgL0`001:gL00@00:fl[Kb]_0@000B]^`03002]^jfk008000:]^`03002]^jfk00:]^`03002]^jfk
008000:]^`03002]^jfk00>]^`8000B]^`03002e^kFk00>e^`8000Fe^`03002e^kFk00800003]K/0
0;Fk00Be^`03002e^kFk008000:e^`03002e^kFk00:e^`<000Be^`03002e^kFk00:e^`<000BeV`03
002eVkFK008000:eV`03002eVkFK00:eV`03002eVkFK008000:eV`03002eVkFK00:eV`<000BeVP03
002eV[FJ00:eVP<000FeVP03002eV[FJ00800003]GX00;Ej00FeNP8000BeNP04002eN[Ej]GX30005
]GX01000]GT000000kEi00<00;EI]ET00kEI00<00;EI]ET00kEI00@00;eI_EVmF@<000JmF@8000Bm
>003002m>;dh00:m>08000Jm>08000Bm5`05002m5kdG_AL00002_?L00`00_?JlmP03_?H00`00_=Jl
eP02_=H200000lCe002l]@02_;D00`00c=C<e002c=@00`00_9@00004c;<20006e;800`00ooooo`04
ool005;oo`03003ooooo02coo`04002]g:gL[M`30005[M`00`00[Mb]g0020002[M`00`00[Mb]g002
[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`40003
[M`00`00[Mb]g002[M`30005[M`00`00[Mb]g0040005[M`01000[M`000000ZgL00<00:gL[M`00jgL
00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL0`001:gL00@00:gL[Mb]
g0@000F]g004002]g0000002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL0`00
0jgL00<00:gL[M`00jgL0P001:gL00<00:gL[M`00jgL0`001:gL00<00:gL[M`00P000ZgL00<00:gL
[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL10000jfl00<00:fk[K/00Zfk0`001:fk00<0
0:fk[K/00Zfk0`001Jfk00<00:fk[K/00P0000>]^`00[K/01:fk00<00;Fk]K/00P000Zfk00<00;Fk
]K/00[Fk0`001;Fk00<00;Fk]K/00[Fk0`001;Fk00<00;Fk]K/00P0000>e^`00]K/01;Fk00<00;Fk
]K/00P000[FK00<00;FK]I/00[FK0`001;FK00<00;FK]I/00[FK0`001KFK00@00;FK000000:eVP03
002eV[FJ00>eVP04002eVP000003]IX00`00]IZeVP02]IX30004]GX01000]GZeN[Ej0`001KEj00@0
0;Ej000000>eNP03002eN[Ej00>eNP03002eNKEi00>eN@04002eFKEI]ET30006]ET30003]ET00`00
_EVmF@03_ET00`00_CRm>003_CP00`00_CRm>0020002_CP00`00_CRm>003_CP00`00_ANm5`03_AL0
1000_ANm5`000kcg00<00;cf_?H00[cf0P001KcF0`001;be00@00<cDc=@000:lU003003</lbc00;<
/`03002lE00000GD/P03003ooooo00Coo`00Dooo00<00?ooool0;?oo0`000jgL00<00:gL[M`00ZgL
0`001JgL00<00:gL[M`010001JgL00<00:gL[M`010001JgL00@00:gL000000:]g003002]g:gL00>]
g004002]g0000002[M`00`00[Mb]g003[M`30003[M`00`00[Mb]g003[M`20005[M`01000[Mb]g:gL
10001:gL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL
10000jgL00<00:gL[M`00jgL0P001:gL00<00:gL[M`00jgL0P001JgL00<00:gL[M`00P0000>]g000
[M`01:gL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL
0`001:gL00<00:gL[M`00ZgL0`001JgL00@00:gL000000:]_003002]_:fl00>]_004002]^`000002
[K/00`00[K^]^`03[K/01000[K/000000Zfk00<00:fk[K/00jfk0`001:fk00<00:fk[K/00Zfk0`00
1:fk00<00;Fk]K/00P0000>]^`00]K/01;Fk00<00;Fk]K/00P000[Fk00<00;Fk]K/00[Fk0`001;Fk
00<00;Fk]K/00[Fk0`001;FK00<00;FK]I/00P000[FK00<00;FK]I/00kFK00@00;FK000000:eV`03
002eVkFK00>eV`8000BeVP03002eV[FJ00>eVP8000FeVP03002eV[FJ00800003]GX00;Ej00BeNP04
002eNP000003]GX00`00]GZeNP02]GX20005]GX01000]GZeN[Ej0`001[Ei0`000kEI00<00;EI]ET0
0kEI00<00;EI]ET00kEI00@00;eI_EVmF@<000Jm>08000Bm>003002m>;dh00:m>08000Jm5`8000Bl
m`07002lm[cf_?H00;cF00001[cF00<00;be_;D00kbe00@00<cDc=@000:lU003003</lbc00;</`03
002lE00000GD/P03003ooooo00Coo`00E?oo00<00?ooool0;?oo00<00:gL[M`00jgL00@00:gL0000
00:]g003002]g:gL00>]g0<000>]g003002]g:gL00>]g0<000>]g003002]g:gL00>]g08000F]g004
002]g:gL[M`30005[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00
[Mb]g002[M`40003[M`00`00[Mb]g002[M`30005[M`00`00[Mb]g0040005[M`01000[M`000000ZgL
00<00:gL[M`00jgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL
[M`00ZgL0`001:gL00<00:gL[M`00ZgL0`001:gL00@00:gL[Mb]g0@000B]g003002]g:gL008000:]
g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`20004[K`00`00[Kb]_003[K`20005
[K/01000[K^]^jfk0`001Jfk00<00:fk[K/00P000Zfk00<00:fk[K/00Zfk00<00:fk[K/00P000Zfk
00<00:fk[K/00Zfk0`001:fk00<00;Fk]K/00[Fk0`001;Fk00<00;Fk]K/00P000[Fk00<00;Fk]K/0
0[Fk00<00;Fk]K/00P000[FK00<00;FK]I/00[FK0`001;FK00<00;FK]I/00kFK0P001KFK00<00;FK
]I/00P0000>eV`00]IX01;FJ00<00;FJ]IX00P0000>eVP00]IX01KFJ0P001;Ej00<00;Ej]GX00[Ej
0P001KEj00<00;Ej]GX00P0000>eNP00]GX01KEj0`000kEj00<00;Ei]GT00[Ei0P001KEI00@00;EI
]EVeF@<000JeF@<000>e>@03002m>;dh00>m>003002m>;dh00>m>003002m>;dh008000:m6003002m
5kdG00>m5`03002lmkcg00>lm`04002lm[cf0003_=H00`00_=JleP02_=H20005_;D00`00c=@00003
_9@01@00c;?</lbc00000[aD00<00=Bbe;800]Bb0P001_oo001Eool00`00ooooo`0/ool01000[Mb]
g:gL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`0
0ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL0`001JgL00<00:gL
[M`010001JgL00@00:gL000000:]g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`3
0003[M`00`00[Mb]g003[M`20004[M`00`00[Mb]g003[M`30004[M`01000[Mb]g:gL10001:gL00<0
0:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL10000jgL00<0
0:gL[M`00ZgL0`001JgL00@00:gL[Mb]g0<000F]g003002]g:gL00800003[K`00:fl00B]_003002]
_:fl008000:]^`03002]^jfk00:]^`@000>]^`03002]^jfk00:]^`<000B]^`04002]^jfk[K/40004
[K/00`00[K^]^`020002[K/00`00[K^]^`02[K/00`00]K^e^`020002[K/00`00]K^e^`02]K/30004
]K/00`00]K^e^`02]K/30005]I/01000]I/000000[FK00<00;FK]I/00kFK00<00;FK]I/00P0000>e
V`00]I/01KFK0P001;FK00<00;FJ]IX00[FJ0`001;FJ00@00;FJ]IZeVP<000FeNP03002eN[Ej0080
0003]GX00;Ej00FeNP8000BeNP03002eN[Ej00:eNP8000FeNP03002eNKEi00800003]ET00;EI00Fe
F@<000>eF@03002eFKEI00>eF@03002e>KDi00>e>@04002m>;dh_CP30006_CP20004_AP00`00_ANm
5`02_AL20006_?L20004_=H01@00_=Jle[cF00000[bf00<00;be_;D00kbe0P001;bD00@00<bcc;<0
00:lE003003D/]Bb00;D/P8000Koo`00E_oo0P00;Ooo0`000jgL00<00:gL[M`00ZgL0`001JgL00<0
0:gL[M`010001JgL00<00:gL[M`010001JgL00@00:gL000000:]g003002]g:gL00>]g004002]g000
0002[M`00`00[Mb]g003[M`30003[M`00`00[Mb]g003[M`20005[M`01000[Mb]g:gL0`001JgL00<0
0:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`0
0P000ZgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`010001JgL00@0
0:gL000000:]g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`40003[M`00`00[Mb]
g002[M`30004[K`00`00[Kb]_002[K`30004[K/00`00[K^]^`0200000jfk002]^`04[K/00`00[K^]
^`020002[K/00`00[K^]^`02[K/40003[K/00`00[K^]^`02[K/30004[K/00`00[K^]^`02[K/30005
[K/01000]K/000000[Fk00<00;Fk]K/00kFk00@00;Fk000000:e^`03002eVkFK00>eV`8000BeV`03
002eVkFK00>eV`<000BeV`04002eVkFK]I/30005]I/00`00]IZeVP0200000kFJ002eVP04]IX01000
]IX000000kFJ00<00;Ej]GX00[Ej0`001;Ej00@00;Ej]GZeNP<000FeNP03002eN[Ej00800003]GX0
0;Ej00FeNP8000BeF@03002eFKEI00:eF@8000FeF@04002eFKEI]ET30006]CT30003]CP00`00_CRm
>003_CP00`00_ARm6003_AP00`00_ANm5`020002_?L00`00_?Nlm`03_?L00`00_=JleP03_=H01@00
_=Jle[cF00000[bf0P001;be00<00;bD_9@00kbD00<00<bc00000kaD00<00=Bbe;800]Bb0P001_oo
001Hool00`00ooooo`0[ool00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL0`000jgL
00<00:gL[M`00jgL0`000jgL00<00:gL[M`00jgL0P001JgL00@00:gL[Mb]g0<000F]g003002]g:gL
008000:]g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00:]g0@000>]g003002]g:gL
00:]g0<000B]g003002]g:gL00:]g0<000F]g003002]g:gL00@000F]g004002]g0000002[M`00`00
[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL0`000jgL00<00:gL[M`00jgL0P001JgL00@0
0:gL[Mb]g0<000F]g003002]g:gL00800003[M`00:gL00B]g003002]g:gL008000:]_003002]_:fl
00:]_003002]_:fl008000:]_003002]^jfk00:]^`<000B]^`03002]^jfk00:]^`<000B]^`03002]
^jfk008000:]^`03002]^jfk00:]^`03002]^jfk008000:]^`03002]^jfk00>]^`04002]^`000002
[K/00`00[K^]^`03[K/20004]K/00`00]K^e^`03]K/20005]K/00`00]I^eV`0200000kFK002eV`04
]I/00`00]I^eV`0200000kFK002eV`04]I/01000]I/000000kFK00<00;FK]I/00[FK0`001;FJ00<0
0;FJ]IX00[FJ0P001KFJ00<00;Ej]GX00P0000>eNP00]GX01;Ej00@00;Ej000000>eNP03002eN[Ej
00>eNP8000BeNP04002eN[Ej]GX30005]ET00`00]EVeF@0200000kEI002eF@05]ET30003]CT00`00
]CVe>@03]CT00`00]CRe>003]CP01000_CRm>;dh0`001[dH0P001;cg00<00;cg_?L00[cg0P001KcF
00@00;cF_=H000>l]P03002l]@0000:l]@8000FlU003003</`0000BlE007003D/]Bbe;800?oo0000
1Ooo001Iool00`00ooooo`0[ool01000[Mb]g:gL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`0
0ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL1000
0jgL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`010001JgL00@00:gL000000:]g003002]g:gL00>]
g004002]g0000002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL0`000jgL00<0
0:gL[M`00jgL0P001JgL00@00:gL[Mb]g0<000F]g003002]g:gL00800003[M`00:gL00B]g003002]
g:gL008000:]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0<000B]g003002]g:gL00:]g0<0
00B]_004002]_:fl[K`40004[K`00`00[K^]^`020002[K/00`00[K^]^`02[K/00`00[K^]^`020002
[K/00`00[K^]^`02[K/30004[K/00`00[K^]^`02[K/30004[K/00`00[K^]^`03[K/20005[K/00`00
[K^]^`0200000jfk002e^`04]K/00`00]K^e^`020002]K/00`00]K^e^`02]K/30004]I/00`00]I^e
V`02]I/30004]I/00`00]I^eV`02]I/20005]I/00`00]I^eV`0200000kFK002eVP04]IX00`00]IZe
VP020002]IX00`00]IZeVP02]IX30004]GX00`00]GZeNP02]GX20005]GX01000]GZeN[Ej0`001KEj
00@00;Ej000000>eF@03002eFKEI00>eF@8000BeF@03002eFKEI00:eF@8000Fe>@04002e>KDi]CT3
0006]CP30003]AP00`00_ARm6003_AP00`00_?Nlm`03_?L00`00_?Nlm`020002_=L00`00_=JleP03
_=H20005_;H20002_;D00`00_9D00004_9@00`00c;<00004_5@01`00e;;D/]Bb003oo`0000Goo`00
F_oo00<00?ooool0:ooo0`000jgL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`010001JgL00<00:gL
[M`010001JgL00@00:gL000000:]g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`3
0003[M`00`00[Mb]g003[M`20004[M`00`00[Mb]g003[M`20005[M`01000[Mb]g:gL0`001JgL00<0
0:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL10000jgL00<0
0:gL[M`00ZgL0`001:gL00<00:gL[M`00ZgL0`001:gL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL
00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:fl[K`00Zfl10000jfl
00<00:fl[K`00Zfl0`001Jfk00<00:fk[K/010001Jfk00@00:fk000000:]^`03002]^jfk00>]^`04
002]^`000002[K/00`00[K^]^`03[K/00`00[K^]^`020002[K/00`00[K^]^`02[K/30004[K/00`00
]K^e^`02]K/30004]K/00`00]K^e^`0200000kFK002eV`04]I/00`00]I^eV`0200000kFK002eV`04
]I/00`00]I^eV`020002]I/00`00]I^eV`02]I/30004]I/00`00]IZeVP02]IX30004]IX00`00]IZe
VP0200000kEj002eNP04]GX00`00]GZeNP0200000kEj002eNP05]GX30003]GX00`00]GZeNP02]GX2
0005]ET01000]EVeFKEI0`001KEI00<00;EI]ET00P0000>e>@00]CT01KDi0`000kDh00<00;Dh]CP0
0kDh00<00;DH]AP00kDH00@00;dH_ARm60<000Jlm`8000Ble`03002le[cF00>leP03002l][bf00Bl
]P04002l]@000002_9D00`00_9BlU003_9@00`00_5BlE003_5@01`00e;;D/]Bb003oo`0000Goo`00
Fooo0P00;?oo00<00:gL[M`00jgL00@00:gL000000:]g003002]g:gL00>]g0<000>]g003002]g:gL
00>]g0<000>]g003002]g:gL00>]g08000F]g004002]g:gL[M`30005[M`00`00[Mb]g0020002[M`0
0`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]
g002[M`40003[M`00`00[Mb]g002[M`30004[M`01000[Mb]g:gL10001:gL00<00:gL[M`00P000ZgL
00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL
[M`00ZgL0`001:gL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`010001JgL00@00:fl000000:]_003
002]_:fl00>]_004002]_0000002[K`00`00[K^]^`03[K/30003[K/00`00[K^]^`03[K/20004[K/0
0`00[K^]^`03[K/20005[K/01000[K^]^jfk10001:fk00<00:fk[K/00P0000>]^`00[K/01:fk00<0
0;Fk]K/00P000Zfk00<00;Fk]K/00[Fk0`001;FK00<00;FK]I/00[FK0`001;FK00<00;FK]I/00[FK
0`001;FK00<00;FK]I/00P0000>eV`00]I/01;FK00<00;FJ]IX00P0000>eVP00]IX01KFJ0P001;Ej
00<00;Ej]GX00[Ej0`001;Ej00<00;Ej]GX00[Ej0P001KEj00<00;Ej]GX00P0000>eFP00]ET01KEI
0`000kEI00<00;EI]ET00kEI0P001;Di00<00;Di]CT00[Di0P001KDh00@00;Dh]CRe>0800003]AP0
0;DH00Be60<000>dn003002lmkcg00>lm`03002lekcG00Ble`04002le[cF_=H20006_;H01000_;D0
00000[bE00<00;bD_9@00kbD00<00;aD_5@00kaD00@00=Bbe;8000;oo`03003ooooo00?oo`00GOoo
00<00?ooool0:_oo00@00:gL[Mb]g0<000F]g003002]g:gL008000:]g003002]g:gL00:]g003002]
g:gL008000:]g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00:]g0@000>]g003002]
g:gL00:]g0<000B]g004002]g:gL[M`40004[M`01000[Mb]g:gL10001:gL00<00:gL[M`00P000ZgL
00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL0`00
1:gL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`010001JgL00@00:gL000000:]g003002]g:gL00>]
g004002]g0000002[M`00`00[Mb]g003[M`30003[M`00`00[Mb]g003[M`20004[K`00`00[Kb]_003
[K`20005[K`00`00[K^]^`0200000jfk002]^`04[K/00`00[K^]^`0200000jfk002]^`04[K/00`00
[K^]^`020002[K/00`00[K^]^`02[K/40003[K/00`00[K^]^`02[K/30004[K/00`00[K^]^`02[K/3
0004[K/00`00]K^e^`0200000jfK002eV`04]I/00`00]I^eV`0200000kFK002eV`04]I/00`00]I^e
V`020002]I/00`00]I^eV`02]I/30004]I/00`00]I^eV`02]I/30004]IX01000]IZeV[FJ0`001KEj
00<00;Ej]GX00P0000>eNP00]GX01;Ej00<00;Ej]GX00P0000>eNP00]GX01KEj0P001;EJ00<00;EI
]ET00[EI0P001KEI00@00;EI]EVeF@800003]CT00;Di00>e>@03002e>KDi008000:e>@03002e>;Dh
00>e>0<000>e6003002e6;DH00>e6003002dn;Ch00>dn003002lmkcg00:lm`8000Jle`04002le[cF
0002];H00`00_;Jl]P04_;H200001;bE002lU@001;bD0P001[aD00<00=Bb00000_oo00<00?ooool0
0ooo001Nool00`00ooooo`0Zool30003[M`00`00[Mb]g002[M`30005[M`00`00[Mb]g0040005[M`0
0`00[Mb]g0040005[M`01000[M`000000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL
[M`00ZgL10000jgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`01000
1JgL00@00:gL000000:]g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`01000[M`0
00000ZgL00<00:gL[M`00jgL0`000jgL00<00:gL[M`00jgL0P001JgL00@00:gL[Mb]g0<000F]g003
002]g:gL00800003[M`00:gL00B]g003002]g:gL008000:]_003002]_:fl00:]_003002]_:fl0080
00:]_003002]_:fl00:]_0<000B]^`03002]^jfk00:]^`<000B]^`03002]^jfk00:]^`<000B]^`03
002]^jfk00800003[K/00:fk00B]^`03002]^jfk00800003[K/00:fk00B]^`03002]^jfk008000:]
^`03002]^jfk00:]^`<000B]V`03002eVkFK00:eV`<000BeV`03002eVkFK00:eV`<000BeV`03002e
VkFK00800003]I/00;FK00BeV`03002eVkFK00800003]I/00;FJ00BeVP04002eVP000003]GX00`00
]GZeNP02]GX30004]GX00`00]GZeNP02]GX30004]GX01000]GZeN[Ej0P0000>eFP00]EX00kEJ00<0
0;EI]ET00P000[EI00<00;EI]ET00kEI0`000kDi00<00;Di]CT00kDi0P001;Di00<00;Dh]CP00kDh
00<00;DH]AP01;DH00<00;DH]AP00`001[Ch00@00;cg_?L000:de`03002lekcG00Ble`8000>d]P03
002l][bf00Bl]P04002lUKbE0002_9D01`00_9BlU;bD002d=00000FlE003003D/P0000;oo`03003o
oooo00?oo`00Gooo00<00?ooool0:_oo00<00:gL[M`00jgL00@00:gL000000:]g003002]g:gL00>]
g0<000>]g003002]g:gL00>]g0<000>]g003002]g:gL00>]g08000F]g003002]g:gL00@000F]g004
002]g0000002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL00@00:gL000000:]
g003002]g:gL00>]g0<000>]g003002]g:gL00>]g08000F]g004002]g:gL[M`30005[M`01000[Mb]
g:gL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`0
0ZgL10000jgL00<00:gL[M`00ZgL0`001:gL00<00:gL[M`00ZgL0`001:fl00@00:fl[Kb]_0@000B]
_003002]_:fl00800003[K/00:fk00B]^`03002]^jfk008000:]^`03002]^jfk00:]^`03002]^jfk
008000:]^`03002]^jfk00:]^`<000B]^`03002]^jfk00:]^`<000B]^`03002]^jfk00:]^`<000B]
^`03002]^jfk008000:]V`03002]VjfK00:]V`03002eVkFK00800003[I/00;FK00BeV`03002eVkFK
008000:eV`03002eVkFK00:eV`<000BeV`03002eVkFK00:eV`<000BeV`03002eV[FJ00:eVP8000Fe
NP03002eN[Ej008000:eNP03002eN[Ej00:eNP03002eN[Ej008000:eNP03002eN[Ej00:eNP04002e
NP000003]EX00`00]EZeFP03]EX20004]ET00`00]EVeF@02]ET20006]CT00`00]CVe>@0200000kDi
002e>@04]CT00`00]CRe>00200000kDH002e6004]AP00`00]AP00003]?P00`00]?Rdn003]?P00`00
_?L00003]=L00`00_=Nle`04_=L00`00];Jd]P02];H00`00_;Jl]P03_;H20003_9D00`00_9D00002
_9@01000]3Bd=0001KaD00<00=Bb00000_oo00<00?ooool00ooo001Pool2000[ool01000[Mb]g:gL
0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL
00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL0`000jgL00<00:gL[M`00jgL0P001JgL00@00:gL[Mb]
g0<000F]g004002]g:gL[M`30005[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g002
0002[M`00`00[Mb]g002[M`40003[M`00`00[Mb]g002[M`40003[M`00`00[Mb]g002[M`30004[M`0
1000[Mb]g:gL10001:gL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<0
0:gL[M`00ZgL00<00:gL[M`00P000Zfl00<00:fl[K`00Zfl10000jfl00<00:fl[K`00Zfl0`001:fk
00<00:fk[K/00Zfk0`001:fk00@00:fk[K^]^`@000B]^`03002]^jfk008000:]^`03002]^jfk00:]
^`03002]^jfk008000:]^`03002]^jfk00:]^`03002]^jfk008000:]^`03002]^jfk00:]^`<000B]
V`03002]VjfK00:]V`<000B]V`03002eVkFK00:eV`<000BeV`03002eVkFK008000:eV`03002eVkFK
00:eV`03002eVkFK008000:eV`03002eVkFK00:eV`03002eV[FJ008000:eNP03002eN[Ej00>eNP80
00BeNP03002eN[Ej00:eNP<000BeNP03002eN[Ej00:eNP8000JeFP03002eF[EJ00800003]EX00;EI
00BeF@04002eF@000002]CT00`00]CVe>@03]CT00`00]CT00003]CT00`00]CVe>@03]CT00`00]CP0
0003]AP00`00]ARe6004]AP00`00]?Rdn002]?P00`00]?Rdn004]?P00`00]=Nde`03]=L00`00_=Nl
e`02_=L20005];H01`00_;Jl][bf002dMP0000BlU@8000:lU004002d=;@d0005_5@00`00e;800003
ool00`00ooooo`02ool006;oo`03003ooooo02Woo`<000>]g003002]g:gL00:]g0<000F]g003002]
g:gL00@000F]g003002]g:gL00@000B]g003002]g:gL008000:]g003002]g:gL00:]g003002]g:gL
008000:]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0<000F]
g003002]g:gL00@000B]g003002]g:gL008000:]g003002]g:gL00:]g003002]g:gL008000:]g003
002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0<000B]
g003002]g:gL00:]g0<000F]g003002]g:gL00@000F]_004002]_0000002[K`00`00[Kb]_002[K`0
0`00[Kb]_0020002[K`00`00[K^]^`02[K/00`00[K^]^`020002[K/00`00[K^]^`02[K/40003[K/0
0`00[K^]^`02[K/30004[K/00`00[K^]^`02[K/30005[K/00`00[K^]^`040005[K/01000[K/00000
0ZfK00<00:fK[I/00jfK00@00:fK000000:]V`03002]VjfK00:]V`03002eVkFK008000:]V`03002e
VkFK00:eV`<000BeV`03002eVkFK00:eV`<000BeV`03002eVkFK00:eV`<000BeNP04002eN[Ej]GX2
00000kEj002eNP04]GX01000]GX000000[Ej00<00;Ej]GX00kEj00@00;Ej000000:eFP03002eF[EJ
00>eFP03002eFP0000>eFP03002eFKEI00BeF@03002e>KDi00:e>@03002e>KDi00Be>@03002e>KDi
00>e>@03002e>KDi00:e>@8000Fe6004002e6;DH]AP30005]?P01000]?Rdn;Ch0`001KCG00<00;cG
_=L00P0000>d]`00];H01;Bf00@00;bf_;H000>dMP04002lUKbE_9D200000kbD002d=002]3@00`00
_5BlE003_5@00`00e;800003ool00`00ooooo`02ool006?oo`03003ooooo02Woo`03002]g:gL00>]
g004002]g0000002[M`00`00[Mb]g003[M`30003[M`00`00[Mb]g003[M`30003[M`00`00[Mb]g002
[M`30005[M`00`00[Mb]g0040005[M`01000[M`000000ZgL00<00:gL[M`00jgL00@00:gL000000:]
g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`30003[M`00`00[Mb]g002[M`30004
[M`00`00[Mb]g002[M`30005[M`00`00[Mb]g0040005[M`01000[M`000000ZgL00<00:gL[M`00jgL
00@00:gL000000:]g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`30003[K`00`00
[Kb]_003[K`20004[K`00`00[Kb]_002[K`30005[K`00`00[K^]^`040005[K/01000[K/000000Zfk
00<00:fk[K/00jfk00@00:fk000000:]^`03002]^jfk00>]^`04002]^`000002[K/00`00[K^]^`03
[K/30003[K/00`00[K^]^`03[K/20004[I/00`00[I^]V`03[I/20005[I/00`00[I^]V`040005[I/0
1000]I/000000ZfK00<00;FK]I/00kFK00@00;FK000000:eV`03002eVkFK00>eV`04002eV`000002
]GX00`00]GZeNP03]GX00`00]GX00003]GX00`00]GZeNP03]GX20004]GX00`00]GZeNP03]GX20004
]EX00`00]EZeFP03]EX20005]EX01000]EVeFKEI0`001KDi00@00;Di]CVe>@<000Fe>@03002e>KDi
00800003]AT00;DH00Be6004002e60000003]?P00`00]?Rdn002]?P01000]?P000000kCG00<00;CG
]=L00kCG0P001;Bg00<00;Bf];H00kBf0P001;Af00<00;bE_9D00[bE0`001;@d00<00;aD_5@00kaD
00<00?ooool00_oo00<00?ooool00_oo001Tool00`00ooooo`0Yool01000[Mb]g:gL0`001JgL00<0
0:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00@00:gL0000
00:]g003002]g:gL00>]g0<000>]g003002]g:gL00>]g08000F]g004002]g:gL[M`30005[M`01000
[Mb]g:gL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00@00:gL000000:]g003002]g:gL
00>]g004002]g0000002[M`00`00[Mb]g003[M`30003[M`00`00[Mb]g003[M`20004[M`00`00[Mb]
g003[M`20005[M`01000[Mb]g:gL0`001JgL00<00:gL[M`00P0000>]_000[K`01:fl00<00:fl[K`0
0P000Zfl00<00:fl[K`00Zfl00@00:fl000000:]_003002]_:fl00>]_0<000>]^`03002]^jfk00>]
^`8000B]^`03002]^jfk00>]^`8000F]^`04002]^jfk[K/30005[K/00`00[K^]^`0200000jfk002]
^`04[K/00`00[K^]^`0200000jfk002]V`04[I/00`00[I^]V`020002[I/00`00[I^]V`02[I/30003
[I/00`00[I^]V`03[I/20004[I/00`00]I^eV`03]I/20004]I/00`00]I^eV`03]I/20004]GX00`00
]GZeNP03]GX20005]GX00`00]GZeNP0200000kEj002eNP04]GX00`00]GZeNP0200000kEj002eFP04
]EX00`00]EZeFP0200000kEJ002eFP04]EX01000]ET000000kEI00<00;Di]CT00[Di00@00;Di0000
00>e>@03002e>KDi00>e>@8000Be6@03002e6;DH00>e6003002dn;Ch00>dn003002dn;Ch00>dn003
002dekCG00>de`03002dekCG00>de`03002d]kBg00>d]`03002d][Bf00>d]P03002dM[Af00>dMP03
002lUKbE00>lU@03002d=;@d00>d=003002lE;aD00>lE003003ooooo00;oo`03003ooooo00;oo`00
IOoo0P00:_oo0`000jgL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`010001:gL00@00:gL[Mb]g0<0
00F]g003002]g:gL008000:]g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00:]g0@0
00>]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0<000B]g004002]g:gL[M`30005[M`01000
[Mb]g:gL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL
[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL0`001:fl00<0
0:fl[K`00Zfl0`001:fl00@00:fl[Kb]_0<000F]_003002]_:fl00800003[K`00:fk00B]^`03002]
^jfk008000:]^`03002]^jfk00:]^`03002]^jfk008000:]^`03002]^jfk00:]^`@000>]^`03002]
^jfk00:]^`<000B]^`03002]^jfk00:]^`<000B]^`03002]VjfK00:]V`<000B]V`03002]VjfK0080
0003[I/00:fK00B]V`03002]VjfK00800003[I/00:fK00B]V`03002eVkFK00800003[I/00;FK00Be
V`03002eVkFK00800003]I/00;Ej00BeNP03002eN[Ej008000:eNP03002eN[Ej00:eNP<000BeNP03
002eN[Ej00:eNP<000BeNP03002eF[EJ00:eFP<000BeFP03002eF[EJ00:eFP8000FeF@03002e>KDi
00:e>@8000Fe>@04002e>KDi]CT30005]AT01000]ARe6;DH0`001KCh00@00;Ch]?Rdn0<000Fde`04
002dekCG]=L30005];L00`00];Jd]P02];H20005]7H00`00_9FlU@02_9D30004]3@00`00_5BlE003
_5@00`00ooooo`02ool00`00ooooo`02ool006Ooo`03003ooooo02Soo`03002]g:gL00>]g004002]
g0000002[M`00`00[Mb]g003[M`30003[M`00`00[Mb]g002[M`40003[M`00`00[Mb]g002[M`30005
[M`00`00[Mb]g0040005[M`01000[M`000000ZgL00<00:gL[M`00jgL00@00:gL000000:]g003002]
g:gL00:]g003002]g:gL008000:]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0@000>]g003
002]g:gL00:]g0<000B]g004002]g:gL[M`40004[M`01000[Mb]g:gL10001:gL00<00:gL[M`00P00
0ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:fl[K`00Zfl00<00:fl[K`00P000Zfl00<0
0:fl[K`00Zfl10000jfl00<00:fl[K`00Zfl0`001:fl00<00:fk[K/00Zfk0`001:fk00@00:fk[K^]
^`@000B]^`03002]^jfk00800003[K/00:fk00B]^`03002]^jfk00800003[K/00:fk00B]^`03002]
^jfk008000:]^`03002]^jfk00:]^`03002]VjfK008000:]V`03002]VjfK00:]V`<000B]V`03002]
VjfK00:]V`<000B]V`03002]VjfK00:]V`<000B]V`03002eVkFK00:eV`<000BeV`03002eN[Ej00:e
NP<000BeNP03002eN[Ej00800003]GX00;Ej00BeNP03002eN[Ej00800003]GX00;Ej00BeNP03002e
F[EJ00800003]EX00;EJ00BeFP03002eF[EJ00800003]ET00;EI00FeF@06002e>@00002e>@001[Di
0`000kDI00<00;DI]AT00kDI0`000kCh00<00;Ch]?P00kCh0`000kCH00<00;CG]=L00kCG0`000kBg
00<00;Bg];L00[Bg00<00;Bf];H00P000[Af00<00;Af]7H00[Af00H00;bE_9FlU@00[3D20004]3@0
0`00_5BlE002_5@00`00ooooo`03ool00`00ooooo`02ool006Soo`03003ooooo02Soo`04002]g:gL
[M`30005[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`01000[M`000000ZgL00<00:gL[M`00jgL
00@00:gL000000:]g003002]g:gL00>]g0<000>]g003002]g:gL00>]g08000B]g003002]g:gL00>]
g08000F]g003002]g:gL00@000F]g004002]g0000002[M`00`00[Mb]g003[M`01000[M`000000ZgL
00<00:gL[M`00jgL00@00:gL000000:]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0@000>]
g003002]g:gL00:]g0<000F]g003002]g:gL00@000B]g004002]_:fl[K`40004[K`00`00[Kb]_002
0002[K`00`00[Kb]_002[K`00`00[Kb]_0020002[K`00`00[Kb]_002[K`00`00[K^]^`020002[K/0
0`00[K^]^`02[K/40003[K/00`00[K^]^`02[K/30004[K/00`00[K^]^`02[K/30004[K/00`00[K^]
^`02[K/30004[K/01000[K^]^jfk10001:fK00<00:fK[I/00P0000>]V`00[I/01:fK00<00:fK[I/0
0P0000>]V`00[I/01:fK00<00:fK[I/00P0000>]V`00[I/01:fK00<00;FK]I/00P0000>]V`00]I/0
1;FK00<00;Ej]GX00P000Zej00<00;Ej]GX00[Ej0`001;Ej00<00;Ej]GX00[Ej0`001;Ej00<00;Ej
]GX00[Ej0`001;EJ00<00;EJ]EX00[EJ0`001;EI00<00;EI]ET00[EI0`001;Di00<00;Di]CT00[Di
0P001KDI00<00;DI]AT00[DI0P001KCh00<00;Ch]?P00kCh00<00;CH]=P00kCH00<00;CG]=L00kCG
00<00;Bg];L00kBg00<00;Bg];L00kBg0P001;Af00<00;Af]7H00kAf00<00;bE00000j`e0P001;@d
00D00;aD_5BlE00000Goo`03003ooooo00;oo`00JOoo00<00?ooool0:?oo0`000jgL00<00:gL[M`0
0ZgL0`001:gL00@00:gL[Mb]g0<000F]g004002]g:gL[M`30005[M`00`00[Mb]g0020002[M`00`00
[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002
[M`30003[M`00`00[Mb]g003[M`20005[M`01000[Mb]g:gL0`001JgL00@00:gL[Mb]g0<000F]g004
002]g0000002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL00@00:gL000000:]
g003002]g:gL00>]g0<000>]g003002]g:gL00:]g0@000>]_003002]_:fl00:]_0<000B]_003002]
_:fl00:]_0<000F]_003002]_:fl00@000B]^`03002]^jfk008000:]^`03002]^jfk00:]^`03002]
^jfk008000:]^`03002]^jfk00:]^`03002]^jfk008000:]^`03002]^jfk00:]^`03002]^jfk0080
00:]^`03002]^jfk00:]^`@000>]V`03002]VjfK00:]V`<000B]V`03002]VjfK00:]V`<000B]V`03
002]VjfK00:]V`<000B]V`03002]VjfK00:]V`<000B]V`03002eVkFK00:eV`<000B]NP03002eN[Ej
00800003[GX00;Ej00BeNP03002eN[Ej00800003]GX00;Ej00BeNP03002eN[Ej00800003]EX00;EJ
00BeFP03002eF[EJ00800003]EX00;EI00BeF@03002eFKEI00800003]CT00;Di00Be>@03002e>KDi
00800003]AT00;DI00Fe6@06002e6@00002e60001KCh00@00;Ch]?Rdn0<000Fdf004002dekCG]=L3
0005];L00`00];Nd]`03];L00`00]7JdMP03]7H00`00]7JdMP03]7H20004[3D00`00]3@00003]3@0
1000_5BlE0001ooo00<00?ooool00Ooo001Zool2000Yool00`00[Mb]g003[M`01000[M`000000ZgL
00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL0`001JgL00<00:gL
[M`010001:gL00@00:gL[Mb]g0@000B]g003002]g:gL008000:]g003002]g:gL00:]g003002]g:gL
008000:]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g08000B]
g003002]g:gL00>]g08000F]g004002]g:gL[M`30005[M`00`00[Mb]g00200000jgL002]g004[M`0
1000[M`000000Zfl00<00:fl[K`00jfl00@00:fl000000:]_003002]_:fl00>]_004002]_0000002
[K`00`00[Kb]_003[K`30003[K/00`00[K^]^`02[K/30004[K/00`00[K^]^`02[K/30004[K/00`00
[K^]^`02[K/30004[K/01000[K^]^jfk10001:fk00<00:fk[K/00P000ZfK00<00:fK[I/00ZfK00<0
0:fK[I/00P0000>]V`00[I/01:fK00<00:fK[I/00P0000>]V`00[I/01:fK00<00:fK[I/00P0000>]
V`00[I/01:fK00<00:fK[I/00P000ZfK00<00:fK[I/00ZfK00<00;FK]I/00P000Zej00<00:ej[GX0
0Zej0`001:ej00<00;Ej]GX00[Ej0`001;Ej00<00;Ej]GX00[Ej0`001;EJ00<00;EJ]EX00[EJ0`00
1;EJ00<00;EI]ET00[EI0`001;Di00<00;Di]CT00kDi0P001;DI00<00;DI]AT00kDI0P001;DH00<0
0;Ch]?P00kCh0`000kCh00<00;CH]=P00kCH0`000kBg00<00;Bg];L00[Bg00@00;Bg];Nd]`<000Jd
MP03002dM[Af00:dMP03002/=J`e00>/=@04002d=;@d0002]3@01000_5BlE0001ooo00<00?ooool0
0Ooo001/ool00`00ooooo`0Wool01000[Mb]g:gL0`001JgL00@00:gL000000:]g003002]g:gL00>]
g004002]g0000002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00jgL0`000jgL00<0
0:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL0`001JgL00<00:gL[M`010001JgL00@00:gL000000:]
g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00:]g003002]g:gL008000:]g003002]
g:gL00:]g003002]g:gL008000:]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0<000B]g003
002]g:gL00:]g08000F]_004002]_:fl[K`30005[K`01000[Kb]_:fl0`001Jfl00<00:fl[K`00P00
00>]_000[K/01:fk00@00:fk000000:]^`03002]^jfk00>]^`04002]^`000002[K/00`00[K^]^`03
[K/01000[K/000000Zfk00<00:fk[K/00Zfk10000jfk00<00:fk[K/00Zfk0`001:fK00<00:fK[I/0
0ZfK0`001:fK00<00:fK[I/00ZfK0`001:fK00<00:fK[I/00ZfK0`001:fK00<00:fK[I/00ZfK0`00
1:fK00@00:fK[I^]V`@000B]NP03002]NZej00800003[GX00:ej00B]NP03002eN[Ej00800003[GX0
0;Ej00BeNP03002eN[Ej00800003[EX00;EJ00BeFP03002eF[EJ00800003]EX00;EJ00BeFP03002e
FKEI00800003]CT00;Di00Be>@04002e>KDi]CT30005]AT01000]AVe6KDI0`001KDH00<00;Ch]?P0
0[Ch0P001KCh00<00;CH]=P00kCH00<00;Bg];L00kBg00<00;Bg];L00kBg0`000jbF00<00;Af]7H0
0kAf00@00;Af]7JdMP8000F/=@04002d=;@d0002]3@00`00_5@00008ool00`00ooooo`01ool006go
o`03003ooooo02Ooo`<000>]g003002]g:gL00:]g08000F]g004002]g:gL[M`30005[M`01000[Mb]
g:gL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00@00:gL000000:]g003002]g:gL00>]
g004002]g0000002[M`00`00[Mb]g003[M`30003[M`00`00[Mb]g003[M`20004[M`00`00[Mb]g002
[M`30005[M`00`00[Mb]g0040005[M`00`00[Mb]g0040004[M`00`00[Mb]g0020002[M`00`00[Mb]
g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[K`00`00[Kb]_002[K`4
0003[K`00`00[Kb]_002[K`40003[K`00`00[Kb]_002[K`30004[K`00`00[K^]^`02[K/20005[K/0
1000[K^]^jfk0`001Jfk00@00:fk[K^]^`<000F]^`04002]^`000002[K/00`00[K^]^`03[K/01000
[K/000000ZfK00<00:fK[I/00jfK00@00:fK000000:]V`03002]VjfK00:]V`03002]VjfK008000:]
V`03002]VjfK00:]V`03002]VjfK008000:]V`03002]VjfK00:]V`03002]VjfK008000:]V`03002]
VjfK00:]V`@000>]N`03002]NZej00:]NP<000B]NP03002]NZej00:]NP<000B]NP03002eN[Ej00:e
NP<000B]FP03002eF[EJ00:eFP<000BeFP03002eF[EJ00>eFP8000Be>@03002e>KDi00>e>@<000>e
>@03002e6KDI00>e6@<000>e6@03002e6;DH00>e6006002dn000002/n0001KCh00@00;CH]=Rdf0<0
00Fd]`03002d]kBg00>d]`03002/UZbF00>/UP03002dM[Af00>dMP06002dM[Af002/=@001Z`e00@0
0;@d]3@000:d=08000Soo`03003ooooo007oo`00K_oo00<00?ooool09ooo00<00:gL[M`00jgL00@0
0:gL000000:]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0@000>]g08000:]g0@000B]g004
002]g:gL[M`30005[M`01000[Mb]g:gL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<0
0:gL[M`00P000ZgL00<00:gL[M`00ZgL00@00:gL000000:]g003002]g:gL00>]g0<000>]g003002]
g:gL00>]g0<000>]g003002]g:gL00:]g0<000F]g003002]g:gL00@000F]g003002]g:gL00@000B]
_003002]_:fl008000:]_003002]_:fl00:]_003002]_:fl008000:]_003002]_:fl00:]_003002]
_:fl008000:]_003002]_:fl00:]_003002]^jfk008000:]^`03002]^jfk00:]^`@000>]^`03002]
^jfk00:]^`@000>]^`03002]^jfk00:]^`8000B]^`03002]^jfk00>]^`8000B]V`03002]VjfK00>]
V`8000B]V`03002]VjfK00:]V`<000F]V`03002]VjfK00@000B]V`04002]VjfK[I/40004[I/00`00
[I^]V`020002[G/00`00[G^]N`02[G/00`00[GZ]NP0200000jej002]NP04[GX00`00[GZ]NP020000
0jej002]NP04[GX00`00]GZeNP0200000jeJ002]FP04[EX00`00]EZeFP0200000jeJ002eFP04]EX0
1000]EZeF[EJ0`001KDi00<00;Di]CT00[Di0P001KDi00<00;DI]AT00[DI0P001KDI00<00;DH]AP0
0kDH0P001:ch00<00;Ch]?P00kCh0`000jbg00<00;Bg];L00[Bg00@00;Bg];Nd]`<000F/UP03002d
M[Af00BdMP8000>/=@03002/=J`e00>/=@07002d=;@d]3@00;@d00002Ooo00<00?ooool00Ooo001_
ool2000Xool01000[Mb]g:gL0`001JgL00@00:gL000000:]g003002]g:gL00>]g004002]g0000002
[M`00`00[Mb]g003[M`30003[M`00`00[Mb]g002[M`40003[M`00`00[Mb]g002[M`40003[M`00`00
[Mb]g002[M`30004[M`01000[Mb]g:gL10001:gL00@00:gL[Mb]g0<000F]g003002]g:gL008000:]
g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00:]g004002]g0000002[M`00`00[Mb]
g003[M`30003[M`00`00[Mb]g003[M`30003[K`00`00[Kb]_002[K`30004[K`00`00[Kb]_002[K`3
0004[K`01000[Kb]_:fl10001:fl00@00:fl[Kb]_0@000B]^`03002]^jfk00800003[K/00:fk00B]
^`03002]^jfk00800003[K/00:fk00B]^`03002]^jfk00800003[K/00:fk00B]^`03002]^jfk0080
00:]V`03002]VjfK00:]V`03002]VjfK008000:]V`03002]VjfK00:]V`04002]V`000002[I/00`00
[I^]V`03[I/30003[I/00`00[I^]V`02[I/40003[I/00`00[I^]V`02[I/30004[G/00`00[G^]N`02
[G/30004[GX00`00[GZ]NP02[GX30004[GX00`00[GZ]NP02[GX30004[EX00`00[EZ]FP02[EX30004
[EX00`00]EZeFP03]EX30003[CT00`00]CVe>@03]CT01P00]CT00000[CT000Je>@06002e6@00002]
6@001KDI00@00;DH]ARe60<000F/n003002dn;Ch00>dn003002/]jbg00>/]`03002d]kBg00>d]`<0
00>/U`03002/UZbF00>/UP03002dM[Af00>dMP03002/=J`e00:/=@03002/=J`e00>/=@04002d=;@d
]3@2000:ool00`00ooooo`01ool0077oo`03003ooooo02Koo`<000>]g004002]g:gL[M`30005[M`0
1000[Mb]g:gL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00@00:gL000000:]g003002]
g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00ZgL1000
0jgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL0`001:gL00@00:gL[Mb]g0@000B]g004002]
g:gL[M`30005[M`00`00[Mb]g00200000jgL002]g004[M`00`00[Mb]g0020002[M`00`00[Kb]_002
[K`01000[K`000000Zfl00<00:fl[K`00jfl00@00:fl000000:]_003002]_:fl00:]_0@000>]_003
002]_:fl00:]_0@000>]_003002]^jfk00:]^`<000B]^`03002]^jfk00:]^`<000B]^`03002]^jfk
00:]^`<000B]^`03002]^jfk00:]^`<000B]V`04002]VjfK[I/40004[I/01000[I^]VjfK0`001JfK
00<00:fK[I/00P0000>]V`00[I/01:fK00@00:fK000000:]V`03002]VjfK00>]V`04002]V`000002
[G/00`00[G^]N`03[G/01000[G/000000Zej00<00:ej[GX00Zej00<00:ej[GX00P000Zej00<00:ej
[GX00Zej00<00:ej[GX00P000ZeJ00<00:eJ[EX00ZeJ00<00:eJ[EX00P0000>]FP00[EX01:eJ00<0
0;EJ]EX00[EJ0P001Jdi00<00;Di]CT00[Di0`001:di00<00;Di]CT00[Di0`001:dI00<00;DI]AT0
0kDI0`000jch00<00:ch[?P00Zch00@00;Ch]?Rdn0<000J/]`03002d]kBg00:d]`03002/UjbG00>/
U`03002/UZbF00>/UP04002dM[Af]7H30004[3D00`00[3F/=@03[3D01000]3Bd=;@d0P002_oo00<0
0?ooool00Ooo001bool00`00ooooo`0Vool00`00[Mb]g002[M`40003[M`00`00[Mb]g002[M`40003
[M`00`00[Mb]g002[M`30004[M`01000[Mb]g:gL0`001JgL00@00:gL[Mb]g0<000F]g004002]g:gL
[M`30005[M`01000[M`000000ZgL00<00:gL[M`00jgL00@00:gL000000:]g003002]g:gL00>]g004
002]g0000002[M`00`00[Mb]g002[M`40003[M`00`00[Mb]g002[M`40003[M`00`00[Mb]g002[M`3
0004[M`00`00[Mb]g002[M`30004[M`01000[Kb]_:fl0`001Jfl00@00:fl[Kb]_0<000F]_004002]
_0000002[K`00`00[Kb]_003[K`01000[K`000000Zfl00<00:fl[K`00Zfl00<00:fk[K/00P000Zfk
00<00:fk[K/00Zfk00<00:fk[K/00P000Zfk00<00:fk[K/00Zfk00<00:fk[K/00P000Zfk00<00:fk
[K/00Zfk00<00:fk[K/00P000Zfk00<00:fK[I/00ZfK10000jfK00<00:fK[I/00ZfK10000jfK00<0
0:fK[I/00ZfK0`001:fK00<00:fK[I/00ZfK0P001:fK00<00:fK[I/00jfK0P001:ek00<00:ek[G/0
0jek0P001:ej00<00:ej[GX00Zej0`001:ej00<00:ej[GX00Zej0`001:eJ00<00:eJ[EX00ZeJ0`00
1:eJ00<00:eJ[EX00jeJ00H00;EJ00000:dj0006[CT01P00]CT00000[CT000F]>@03002e>KDi0080
0003[AT00:dI00B]6@03002e6KDI00:e6@8000F/n003002/n:ch00>/n0<000>/f003002/]jbg00>/
]`03002d]kBg00<000F/U`03002/UZbF00B/UP<000:/=@03002/=J`e00:/=@03002/=J`e00B/=@03
002d=00000;oo`03003ooooo00Soo`40007oo`7oo`00Looo00<00?ooool09_oo00@00:gL000000:]
g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`0
0ZgL10000jgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL10000jgL00@00:gL[Mb]g0<000F]
g004002]g:gL[M`30005[M`01000[Mb]g:gL0`001JgL00@00:gL000000:]g003002]g:gL00>]g004
002]g0000002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g002
0002[M`00`00[Mb]g002[M`40003[K`00`00[Kb]_002[K`40003[K`00`00[Kb]_002[K`20004[K`0
0`00[Kb]_003[K`20004[K`00`00[Kb]_002[K`30005[K/00`00[K^]^`040005[K/00`00[K^]^`04
0004[K/01000[K^]^jfk10001:fk00<00:fK[I/00P0000>]V`00[I/01:fK00<00:fK[I/00P0000>]
V`00[I/01:fK00<00:fK[I/00P0000>]V`00[I/01:fK00<00:fK[I/00P0000>]V`00[I/01:fK00<0
0:fK[I/00P0000>]N`00[G/01:ek00<00:ek[G/00P0000>]N`00[GX01:ej00@00:ej000000:]NP03
002]NZej00>]NP04002]NP000002[EX00`00[EZ]FP03[EX01000[EX000000ZeJ00<00:eJ[EX00ZeJ
00<00:eJ[EX00ZeJ0`001:dj00<00:di[CT00Zdi0`001:di00<00:di[CT00jdi0P001:dI00<00:dI
[AT00jdI00@00;DI000000:/n003002/n:ch00:/n003002/n:ch00:/n08000F/f003002/]jbg00B/
]`8000>/U`03002/UjbG00>/U`03002/UZbF00>/UP03002/=J`e00>/=@03002/=J`e00:/=@03002/
=J`e00>/=@8000Coo`03003ooooo00Ooo`40007oo`7oo`00M?oo0P009ooo00<00:gL[M`00jgL00@0
0:gL[Mb]g0<000F]g004002]g:gL[M`30005[M`01000[M`000000ZgL00<00:gL[M`00jgL00@00:gL
000000:]g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]g002[M`40003[M`00`00[Mb]g002
[M`40003[M`00`00[Mb]g002[M`40003[M`00`00[Mb]g002[M`20005[M`01000[Mb]g:gL0`001JgL
00<00:gL[M`010001JgL00<00:gL[M`010001:gL00<00:gL[M`00P000Zfl00<00:fl[K`00Zfl00<0
0:fl[K`00P000Zfl00<00:fl[K`00Zfl00<00:fl[K`00P000Zfl00<00:fl[K`00Zfl00<00:fl[K`0
0P000Zfl00<00:fl[K`00Zfl00@00:fl000000:]^`03002]^jfk00>]^`<000>]^`03002]^jfk00>]
^`<000>]^`03002]^jfk00:]^`@000>]^`03002]^jfk00:]^`<000B]V`03002]VjfK00:]V`<000B]
V`03002]VjfK00:]V`<000B]V`03002]VjfK00:]V`<000B]V`03002]VjfK00:]V`<000B]N`03002]
Njek00:]N`<000B]N`03002]NZej00:]NP8000B]NP03002]NZej00>]NP8000B]FP03002]FZeJ00>]
FP8000B]FP03002]FZeJ00>]FP04002]FP000002[CX00`00[CZ]>P02[CX00`00[CV]>@020002[CT0
0`00[CV]>@02[CT01000[CV]>Jdi0P0000>]6@00[AT00jdI00<00:dI[AT00ZdI0`001:ch00<00:ch
[?P00jch00H00:ch00000:cH0006[=P00`00[;N/]`02[;L20004[9L00`00[9N/U`03[9L01000[9J/
UZbF0`001J`e00<00:`e[3D00Z`e00<00:`e[3D00j`e00<00?ooool00ooo00<00?ooool01ooo0@00
0Ooo0Ooo001fool00`00ooooo`0Uool00`00[Mb]g002[M`40003[M`00`00[Mb]g002[M`40003[M`0
0`00[Mb]g002[M`20005[M`01000[Mb]g:gL0`001JgL00@00:gL[Mb]g0<000F]g004002]g0000002
[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL
[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL0`000jgL00<0
0:gL[M`00jgL0`000jgL00<00:gL[M`00ZgL0`001:fl00<00:fl[K`00Zfl0`001:fl00@00:fl[Kb]
_0@000B]_004002]_:fl[K`40004[K`01000[Kb]_:fl0`001Jfk00<00:fk[K/00P0000>]^`00[K/0
1:fk00<00:fk[K/00P0000>]^`00[K/01:fk00@00:fk000000:]^`03002]^jfk00>]^`04002]^`00
0002[I/00`00[I^]V`02[I/00`00[I^]V`0200000jfK002]V`04[I/00`00[I^]V`0200000jfK002]
V`04[I/00`00[I^]V`0200000jfK002]V`04[I/00`00[I^]V`0200000jfK002]N`04[G/00`00[G^]
N`0200000jek002]N`04[G/00`00[GZ]NP0200000jej002]NP04[GX00`00[GZ]NP0200000jej002]
FP04[EX00`00[EZ]FP0200000jeJ002]FP04[EX01000[EZ]FZeJ0`001:dj00<00:dj[CX00Zdj0`00
1:di00<00:di[CT00jdi0`000jdI00<00:dI[AT00jdI00@00:dI000000:/n003002/n:ch00>/n004
002/n:ch[?P30004[=P00`00[=R/f003[=P00`00[;N/]`0200000jbG002/U`03[9L00`00[9N/U`04
[9L30003[3H00`00[3F/=@02[3D00`00[3F/=@02[3D00`00[3F/=@02[3D00`00ooooo`05ool00`00
ooooo`06ool10001ool1ool007Ooo`03003ooooo02Goo`04002]g0000002[M`00`00[Mb]g003[M`0
1000[M`000000ZgL00<00:gL[M`00jgL00@00:gL000000:]g003002]g:gL00:]g0@000>]g003002]
g:gL00:]g0@000>]g003002]g:gL00:]g08000F]g004002]g:gL[M`30005[M`00`00[Mb]g0040005
[M`00`00[Mb]g0040004[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`0
0`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`01000[M`000000Zfl00<00:fl[K`0
0jfl00@00:fl000000:]_003002]_:fl00:]_0@000>]_003002]_:fl00:]_0@000>]_003002]_:fl
00:]_0@000>]_003002]^jfk00:]^`<000B]^`03002]^jfk00:]^`<000B]^`03002]^jfk00:]^`80
00B]^`03002]^jfk00>]^`8000B]V`03002]VjfK00:]V`<000B]V`03002]VjfK00:]V`<000B]V`03
002]VjfK00:]V`<000B]V`03002]VjfK00:]V`<000B]V`03002]Njek00:]N`<000B]N`03002]Njek
00:]N`<000B]NP03002]NZej00:]NP<000B]NP03002]FZeJ00:]FP<000B]FP03002]FZeJ00:]FP04
002]FP000002[EX00`00[CZ]>P03[CX01000[CX000000Zdi00<00:di[CT00jdi00@00:di[CV]>@80
00J]6@04002]6JdI[AT30004[?P00`00[?R/n003[?P01P00[?P00000[=P000F/f003002/f:cH00B/
f08000B/U`03002/UjbG00:/U`03002/UjbG00>/U`03002/=Z`f00>/=P03002/=J`e00:/=@03002/
=J`e00:/=@03002/=J`e008000Woo`03003ooooo00Goo`40007oo`7oo`00N?oo00<00?ooool09Ooo
00<00:gL[M`00jgL00@00:gL[Mb]g0<000F]g004002]g:gL[M`30005[M`01000[M`000000ZgL00<0
0:gL[M`00jgL00@00:gL000000:]g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00:]
g0@000>]g003002]g:gL00:]g0<000>]g003002]g:gL00>]g0<000>]g003002]g:gL00:]g0<000F]
g003002]g:gL00@000B]g004002]g:gL[M`40004[M`01000[Mb]g:gL0`001Jfl00@00:fl[Kb]_0<0
00F]_004002]_0000002[K`00`00[Kb]_003[K`01000[K`000000Zfl00<00:fl[K`00Zfl00<00:fl
[K`00P000Zfl00<00:fl[K`00Zfl00<00:fk[K/00P000Zfk00<00:fk[K/00Zfk00<00:fk[K/00P00
0Zfk00<00:fk[K/00Zfk00<00:fk[K/00P000Zfk00<00:fk[K/00Zfk00<00:fk[K/00P000ZfK00<0
0:fK[I/00ZfK00@00:fK000000:]V`03002]VjfK00:]V`03002]VjfK008000:]V`03002]VjfK00:]
V`03002]VjfK008000:]V`03002]VjfK00:]V`03002]VjfK008000:]V`03002]VjfK00:]V`03002]
Njek00800003[G/00:ek00B]N`03002]Njek00800003[GX00:ej00B]NP03002]NZej00800003[GX0
0:ej00B]NP03002]FZeJ00800003[EX00:eJ00B]FP03002]FZeJ00:]FP8000B]FP03002]>Zdj00>]
>P8000B]>@03002]>Jdi00>]>@04002]>@000002[AT00`00[AV]6@03[AT01P00[AT00000[?T000J/
n003002/n:ch00:/n08000B/f003002/f:cH00>/f004002/f:cH[=P30005[9L00`00[9N/U`02[9L0
1000[9N/UjbG0`001J`f00<00:`e[3D00Z`e00<00:`e[3D00j`e0P003?oo00<00?ooool01?oo0@00
0Ooo0Ooo001iool2000Vool00`00[Mb]g002[M`40003[M`00`00[Mb]g002[M`40003[M`01000[Mb]
g:gL0`001JgL00@00:gL[Mb]g0<000F]g003002]g:gL00@000F]g004002]g0000002[M`00`00[Mb]
g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`0
1000[M`000000ZgL00<00:gL[M`00jgL0`000jgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL
10000jfl00<00:fl[K`00Zfl10000jfl00<00:fl[K`00Zfl0P001:fl00<00:fl[K`00jfl0P001Jfl
00<00:fl[K`010001Jfl00<00:fl[K`010001:fk00@00:fk[K^]^`@000B]^`04002]^jfk[K/40004
[K/01000[K^]^jfk10001:fK00@00:fK[I^]V`<000F]V`03002]VjfK00@000F]V`03002]VjfK00@0
00B]V`04002]VjfK[I/40004[I/01000[I^]VjfK10001:ek00<00:ek[G/00Zek0`001:ej00<00:ej
[GX00Zej0`001:ej00<00:ej[GX00Zej0`001:eJ00<00:eJ[EX00jeJ00H00:eJ00000:eJ0005[EX0
0`00[CZ]>P0200000jdj002]>@04[CT00`00[CV]>@02[CT20004[AT00`00[AV]6@03[AT20004[?T0
0`00[?R/n003[?P00`00[?R/n00200000jcH002/f003[=P00`00[=R/f003[=P01000[=P000000ZbG
00<00:bG[9L00jbG00<00:bG[9L00jbG0`000j@f00<00:`f[3H00Z`f00<00:`e[3D00Z`e00<00:`e
[3D00j`e00<00?ooool02ooo00<00?ooool01?oo0@000Ooo0Ooo001kool00`00ooooo`0Tool01000
[M`000000ZgL00<00:gL[M`00jgL00@00:gL000000:]g003002]g:gL00:]g0@000>]g003002]g:gL
00:]g0@000>]g003002]g:gL00:]g0<000>]g003002]g:gL00>]g08000F]g003002]g:gL00@000F]
g003002]g:gL00@000B]g004002]g:gL[M`30005[M`00`00[Mb]g00200000jgL002]g004[M`01000
[M`000000ZgL00<00:gL[M`00jgL00@00:gL000000:]_003002]_:fl00:]_003002]_:fl008000:]
_003002]_:fl00:]_003002]_:fl008000:]_003002]_:fl00:]_003002]_:fl008000:]_003002]
_:fl00:]_0<000>]_003002]_:fl00>]_0<000>]^`03002]^jfk00:]^`@000>]^`03002]^jfk00:]
^`@000>]^`03002]^jfk00:]^`@000>]V`03002]VjfK00:]V`@000>]V`03002]VjfK00:]V`<000>]
V`03002]VjfK00>]V`<000>]V`03002]VjfK00:]V`@000>]V`03002]VjfK00:]V`@000>]N`03002]
Njek00:]N`03002]Njek00800003[G/00:ej00B]NP03002]NZej00800003[GX00:ej00B]NP03002]
NZej00800003[EX00:eJ00B]FP04002]FZeJ[EX40004[EX00`00[EZ]FP02[EX30004[CX00`00[CV]
>@02[CT00`00[CV]>@0200000jdI002]6@04[AT00`00[AV]6@0200000jci002/n@03[?T00`00[?R/
n004[?P20004[=P00`00[=R/f002[=P00`00[=R/f002[=P20005[9L00`00[9N/U`02[9L00`00[9N/
U`02[9L20005Y3H00`00[3J/=P03[3H00`00[3F/=@02[3D00`00[3F/=@02000?ool00`00ooooo`03
ool10001ool1ool007coo`03003ooooo02Coo`03002]g:gL00>]g004002]g:gL[M`30005[M`01000
[M`000000ZgL00<00:gL[M`00jgL00@00:gL000000:]g003002]g:gL00:]g003002]g:gL008000:]
g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00:]g0<000>]g003002]g:gL00>]g0<0
00>]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0<000B]g003002]g:gL00:]g08000F]g004
002]g:gL[M`30005[K`00`00[Kb]_0040005[K`00`00[Kb]_0040004[K`01000[Kb]_:fl10001:fl
00<00:fl[K`00P0000>]_000[K`01:fl00<00:fl[K`00P0000>]_000[K/01:fk00@00:fk000000:]
^`03002]^jfk00>]^`04002]^`000002[K/00`00[K^]^`02[K/00`00[K^]^`0200000jfK002]V`04
[I/00`00[I^]V`0200000jfK002]V`04[I/00`00[I^]V`0200000jfK002]V`04[I/00`00[I^]V`02
00000jfK002]V`04[I/01000[I/000000ZfK00<00:fK[I/00jfK00@00:fK000000:]N`03002]Njek
00:]N`04002]Njek[G/40004[G/00`00[GZ]NP02[GX30004[GX00`00[GZ]NP02[GX30004[EX00`00
[EZ]FP02[EX40002[EX00`00[EZ]FP03[EX00`00[EZ]FP0200000jdj002]>P04[CX00`00[CV]>@02
[CT30004[AT00`00[AV]6@02[AT30004[?T00`00[?V/n@02[?T01000[?R/n:ch0`001JcH00<00:cH
[=P00ZcH00<00:cH[=P00P0000>/U`00[9L01:bG00<00:bG[9L00jbG00H00:bG00000:@f0005Y3H0
0`00[3J/=P03[3H00`00[3F/=@02[3D3000Bool00`00ooooo`03ool10001ool007goo`03003ooooo
02Coo`03002]g:gL00:]g0@000>]g003002]g:gL00:]g08000F]g004002]g:gL[M`30005[M`00`00
[Mb]g0040005[M`00`00[Mb]g0040004[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]
g0020002[M`00`00[Mb]g002[M`01000[M`000000ZgL00<00:gL[M`00jgL00@00:gL000000:]g003
002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00:]g0@000>]g003002]_:fl00:]_0<000>]
_003002]_:fl00>]_0<000>]_003002]_:fl00:]_0@000>]_003002]_:fl00:]_0<000B]_003002]
_:fl00:]_0<000B]_003002]^jfk00:]^`8000B]^`03002]^jfk00>]^`8000B]^`03002]^jfk00:]
^`<000B]V`03002]VjfK00:]V`<000B]V`03002]VjfK00:]V`<000B]V`03002]VjfK00:]V`<000B]
V`03002]VjfK00:]V`8000B]V`03002]VjfK00>]V`8000B]N`03002]Njek00:]N`@000>]N`03002]
Njek00:]N`03002]NZej00800003[GX00:ej00B]NP03002]NZej00800003[EX00:eJ00B]FP03002]
FZeJ00800003[EX00:eJ00B]FP03002]FZeJ00:]FP<000B]>P03002]>Zdj00>]>P06002]>@00002]
6@001JdI00<00:dI[AT00P0000>/n@00[?T01:ci00<00:ci[?T00Zci00@00:ch000000>/f003002/
f:cH00:/f003002/f:cH00:/f0<000B/U`03002/UjbG00:/U`03002/UjbG00>/U`8000BT=P03002T
=Z@f00:T=P03002/=Z`f00>/=P03002/=J`e00:/=@03003ooooo01;oo`03003ooooo00?oo`40007o
o`00O_oo0P009Ooo00@00:gL000000:]g003002]g:gL00>]g004002]g0000002[M`00`00[Mb]g002
[M`40003[M`00`00[Mb]g002[M`30003[M`00`00[Mb]g003[M`30003[M`00`00[Mb]g002[M`30005
[M`00`00[Mb]g0040004[M`01000[Mb]g:gL0`001JgL00@00:gL[Mb]g0<000F]g003002]g:gL00@0
00F]g004002]g0000002[M`00`00[Mb]g002[M`00`00[Kb]_0020002[K`00`00[Kb]_002[K`00`00
[Kb]_0020002[K`00`00[Kb]_002[K`01000[K`000000Zfl00<00:fl[K`00jfl00@00:fl000000:]
_003002]_:fl00:]_003002]_:fl008000:]_003002]_:fl00:]_003002]^jfk008000:]^`03002]
^jfk00:]^`03002]^jfk008000:]^`03002]^jfk00:]^`04002]^`000002[K/00`00[I^]V`02[I/0
0`00[I^]V`020002[I/00`00[I^]V`02[I/00`00[I^]V`020002[I/00`00[I^]V`02[I/00`00[I^]
V`0200000jfK002]V`04[I/00`00[I^]V`0200000jfK002]V`04[I/00`00[I^]V`0200000jek002]
N`04[G/01000[G/000000Zek00<00:ek[G/00Zek00@00:ek[G^]N`@000B]NP03002]NZej00:]NP<0
00B]FP03002]FZeJ00:]FP<000B]FP03002]FZeJ00:]FP03002]FZeJ00800003[CX00:dj00B]>P03
002]>Zdj00:]>P<000B]6@03002]6JdI00:]6@<000B/n@03002/nJci00:/n@03002/nJci00:/n@80
00F/f003002/f:cH00>/f006002/f000002/U`001JbG00<00:bG[9L00ZbG00@00:bG[9N/U`<000FT
=P03002T=Z@f00>T=P03002/=Z`f00:/=P03002/=J`e008001Koo`03003ooooo00;oo`40007oo`00
P?oo00<00?ooool08ooo00<00:gL[M`00jgL00@00:gL[Mb]g0<000F]g004002]g0000002[M`00`00
[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002
[M`01000[M`000000ZgL00<00:gL[M`00jgL0`000jgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`0
0ZgL10000jgL00<00:gL[M`00ZgL0`000jgL00<00:gL[M`00jgL0P001JgL00<00:gL[M`010001:fl
00@00:fl[Kb]_0@000B]_004002]_:fl[K`30005[K`01000[Kb]_:fl0`001Jfl00<00:fl[K`01000
1:fl00@00:fl[Kb]_0@000B]^`04002]^jfk[K/40004[K/01000[K^]^jfk0`001Jfk00<00:fK[I/0
10001JfK00<00:fK[I/010001:fK00@00:fK[I^]V`@000B]V`03002]VjfK00:]V`<000B]V`03002]
VjfK00:]V`<000B]N`03002]Njek00:]N`8000B]N`03002]Njek00:]N`@000>]NP03002]NZej00:]
NP03002]NZej00800003[EX00:eJ00B]FP03002]FZeJ00800003[EX00:eJ00B]FP03002]FZeJ00:]
FP<000B]>P03002]>Zdj00>]>P06002]>P00002]6@001JdI00<00:dI[AT00P0000>/n@00[?T01:ci
00<00:ci[?T00jci00H00:ci00000:cH0005[=P00`00[=R/f002[=P30004[9L00`00[9N/U`02[9L0
0`00[9N/U`03[9L30003Y5H00`00Y3JT=P02Y3H00`00Y3JT=P03Y3H00`00[3J/=P03[3H2000Iool0
1@00oooooooo00000Ooo0021ool00`00ooooo`0Sool00`00[Mb]g002[M`40003[M`01000[Mb]g:gL
0`001JgL00<00:gL[M`010001JgL00<00:gL[M`010001:gL00@00:gL[Mb]g0<000F]g003002]g:gL
008000:]g003002]g:gL00:]g004002]g0000002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<0
0:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`0
0ZgL0`000jfl00<00:fl[K`00Zfl10000jfl00<00:fl[K`00Zfl10000jfl00<00:fl[K`00Zfl1000
0jfl00<00:fl[K`00Zfl0`000jfl00<00:fl[K`00Zfl10000jfk00<00:fk[K/00Zfk10000jfk00<0
0:fk[K/00Zfk10000jfk00<00:fk[K/00Zfk0`000jfK00<00:fK[I/00jfK0`000jfK00<00:fK[I/0
0ZfK10000jfK00<00:fK[I/00ZfK00<00:fK[I/00P000ZfK00<00:fK[I/00ZfK00<00:fK[I/00P00
00>]N`00[G/01:ek00<00:ek[G/00P0000>]N`00[G/01:ek00@00:ek000000:]N`03002]NZej00:]
NP03002]NZej00:]NP<000B]FP03002]FZeJ00:]FP<000B]FP03002]FZeJ00>]FP06002]FP00002]
>P001Jdj00@00:dj[CZ]>P@000B]6@03002]6JdI00:]6@<000B/n@03002/nJci00:/n@03002/nJci
00:/n@<000B/f003002/f:cH00>/f006002/f000002/^0001JbG00<00:bG[9L00ZbG00<00:bG[9L0
0ZbG0P001JAF00<00:@fY3H00j@f00<00:@fY3H00Z@f00<00:`f[3H00Z`f0P006ooo00@00?ooool0
007oo`00P_oo00<00?ooool08ooo00@00:gL000000:]g003002]g:gL00:]g0@000>]g003002]g:gL
00:]g0<000>]g003002]g:gL00>]g0<000>]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0<0
00B]g004002]g:gL[M`30005[M`01000[Mb]g:gL0`001JgL00<00:gL[M`010001:gL00@00:gL[Mb]
g0@000B]g003002]g:gL00800003[K`00:fl00B]_004002]_0000002[K`00`00[Kb]_003[K`01000
[K`000000Zfl00<00:fl[K`00Zfl00<00:fl[K`00P000Zfl00<00:fl[K`00Zfl00<00:fl[K`00P00
0Zfl00<00:fl[K`00Zfl00@00:fl000000:]_003002]^jfk00>]^`04002]^`000002[K/00`00[K^]
^`02[K/00`00[K^]^`0200000jfk002]^`04[K/00`00[K^]^`0200000jfK002]V`04[I/00`00[I^]
V`0200000jfK002]V`04[I/01000[I/000000ZfK00<00:fK[I/00ZfK00@00:fK[I^]V`@000B]V`04
002]VjfK[I/40004[G/00`00[G^]N`02[G/30004[G/00`00[G^]N`02[G/20004[G/00`00[GZ]NP03
[GX01000[GX000000ZeJ00<00:eJ[EX00ZeJ00<00:eJ[EX00P000ZeJ00<00:eJ[EX00ZeJ00@00:eJ
[EZ]FP@000B]>P03002]>Zdj00:]>P@000:]>@03002]6JdI00>]6@03002]6JdI00800003[AT00:ci
00B/n@03002/nJci00>/n@06002/n@00002/f0001JcH00<00:cH[=P00ZcH0`001:bh00<00:bG[9L0
0ZbG00<00:bG[9L00jbG00H00:bG00000:AF0005Y5H00`00Y3JT=P03Y3H00`00Y3JT=P03Y3H01000
[3H000007Ooo00@00?ooool0007oo`00Pooo0P009?oo00<00:gL[M`00jgL00@00:gL000000:]g003
002]g:gL00>]g004002]g0000002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002
[M`01000[M`000000ZgL00<00:gL[M`00jgL00@00:gL000000:]g003002]g:gL00:]g0@000>]g003
002]g:gL00:]g0@000>]g003002]g:gL00:]g0<000>]g003002]g:gL00:]g0@000>]g003002]g:gL
00:]g0<000B]_003002]_:fl00:]_08000B]_003002]_:fl00>]_08000F]_003002]_:fl00@000B]
_004002]_:fl[K`40004[K`01000[Kb]_:fl0`001Jfl00@00:fk[K^]^`<000F]^`03002]^jfk00@0
00B]^`03002]^jfk00:]^`<000B]V`03002]VjfK00:]V`<000B]V`03002]VjfK00:]V`8000B]V`03
002]VjfK00:]V`@000>]V`03002]VjfK00:]V`@000>]V`03002]Njek00:]N`03002]Njek00800003
[G/00:ek00B]N`03002]Njek00800003[G/00:ek00B]N`04002]NZej[GX30004[EX00`00[EZ]FP02
[EX30004[EX00`00[EZ]FP02[EX40002[CX00`00[CZ]>P03[CX00`00[CZ]>P0200000jdi002]>@04
[CT00`00[AV]6@02[AT30004[AT00`00[?V/n@03[?T00`00[?V/n@040004[=P00`00[=R/f003[=P0
1P00[=P00000[;P000F/^003002/UjbG00:/U`03002/UjbG00:/U`<000BTEP03002TEZAF00>TEP03
002T=Z@f00:T=P03002T=Z@f00:T=P<0023oo`03003oo`00007oo`00QOoo00<00?ooool08_oo0P00
0ZgL0`001JgL00@00:gL[Mb]g0<000F]g003002]g:gL00@000F]g003002]g:gL00<000F]g004002]
g:gL[M`30005[M`01000[M`000000ZgL00<00:gL[M`00jgL00@00:gL000000:]g003002]g:gL00:]
g003002]g:gL008000:]g003002]g:gL00:]g004002]g0000002[M`00`00[Mb]g003[M`01000[M`0
00000Zfl00<00:fl[K`00Zfl00<00:fl[K`00P000Zfl00<00:fl[K`00Zfl00<00:fl[K`00P000Zfl
00<00:fl[K`00Zfl0`000jfl00<00:fl[K`00Zfl10000jfl00<00:fl[K`00Zfl10000jfl00<00:fl
[K`00Zfl10000jfk00<00:fk[K/00Zfk0`000jfk00<00:fk[K/00Zfk00<00:fk[K/00P000ZfK00<0
0:fK[I/00ZfK00<00:fK[I/00P000ZfK00<00:fK[I/00ZfK00<00:fK[I/00P0000>]V`00[I/01:fK
00@00:fK000000:]V`03002]VjfK00>]V`04002]V`000002[I/00`00[I^]V`02[I/01000[G^]Njek
10001:ek00<00:ek[G/00Zek0`001:ek00<00:ek[G/00Zek10000jeJ00<00:eJ[EX00ZeJ00@00:eJ
000000:]FP03002]FZeJ00>]FP04002]FP000002[CX00`00[CZ]>P02[CX00`00[CZ]>P02[CX30004
[CT00`00[CV]>@02[CT00`00[AV]6@0200000jdI002]6@04[AT00`00[?V/n@02[?T40002[=T00`00
[=R/f003[=P00`00[=R/f002[=P30004[;P00`00[;R/^002[;P00`00[9N/U`03[9L01P00[9L00000
Y5L000FTEP03002TEZAF00>TEP03002T=Z@f00>T=P04002T=P00000Tool10001ool1000008Koo`03
003ooooo02?oo`8000>]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0<000>]g003002]g:gL
00>]g0<000>]g003002]g:gL00:]g0@000>]g004002]g:gL[M`30005[M`01000[Mb]g:gL0`001JgL
00<00:gL[M`010001:gL00@00:gL[Mb]g0<000F]g004002]g:gL[M`30005[K`00`00[Kb]_0040004
[K`01000[Kb]_:fl10001:fl00<00:fl[K`00P0000>]_000[K`01:fl00@00:fl000000:]_003002]
_:fl00>]_004002]_0000002[K`00`00[Kb]_002[K`00`00[Kb]_00200000jfk002]^`04[K/00`00
[K^]^`0200000jfk002]^`04[K/00`00[K^]^`040005[I/00`00[I^]V`040004[I/01000[I^]VjfK
10001:fK00<00:fK[I/00ZfK0P001:fK00<00:fK[I/00jfK0P001:fK00<00:fK[I/00ZfK10000jek
00<00:ek[G/00Zek00<00:ek[G/00P0000>]N`00[G/01:ek00<00:ek[G/00P0000>]NP00[EX01:eJ
00@00:eJ[EZ]FP<000B]FP03002]FZeJ00>]FP8000B]>P03002]>Zdj00:]>P03002]>Zdj008000:]
>P03002]>Jdi00:]>@03002]>Jdi00:]>@<000B]6@03002]6JdI00>]6@06002/n@00002/n@001JcI
00<00:cH[=P00jcH00H00:cH00000:bh0005[;P00`00[;R/^002[;P00`00[9N/U`02[9L30004Y5L0
0`00Y5JTEP02Y5H00`00Y5JTEP03Y5H00`00Y3JT=P02Y3H3000Wool2000008Ooo`03003ooooo02?o
o`03002]g:gL00:]g004002]g0000002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]
g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`01000[M`000000ZgL00<00:gL[M`00ZgL1000
0jgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL0`000jgL00<00:gL[M`00ZgL10000jgL00<0
0:gL[M`00ZgL10000jgL00<00:fl[K`00Zfl0`000jfl00<00:fl[K`00Zfl10000jfl00<00:fl[K`0
0Zfl0`001:fl00<00:fl[K`00Zfl0P001:fl00<00:fl[K`00jfl0P001:fl00<00:fl[K`00Zfl0`00
1:fk00<00:fk[K/00Zfk0`001:fk00<00:fk[K/00Zfk0`000jfK00<00:fK[I/00jfK0`000jfK00<0
0:fK[I/00ZfK10000jfK00<00:fK[I/00ZfK00<00:fK[I/00P000ZfK00<00:fK[I/00ZfK00<00:fK
[I/00P0000>]V`00[I/01:fK00@00:fK000000:]N`03002]Njek00:]N`04002]Njek[G/40004[G/0
0`00[G^]N`02[G/30004[GX00`00[EZ]FP02[EX40002[EX00`00[EZ]FP03[EX00`00[EZ]FP020000
0jdj002]>P04[CX01000[CZ]>Zdj0`001:dj00<00:di[CT00jdi00H00:di00000:dI0005[AT00`00
[AV]6@02[AT30004[?T00`00[=V/f@02[=T00`00[=R/f002[=P30004[;P00`00[;R/^002[;P00`00
[;R/^003[;P01P00[9L00000Y5L000FTE`03002TEZAF00>TEP03002TEZAF00>TEP04002T=P00000Z
ool2000008Soo`03003ooooo02;oo`04002]g:gL[M`30005[M`00`00[Mb]g0040005[M`00`00[Mb]
g0040004[M`01000[Mb]g:gL0`001JgL00@00:gL000000:]g003002]g:gL00>]g004002]g0000002
[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`01000[M`000000ZgL00<00:gL
[M`00jgL00@00:gL000000:]g003002]g:gL00:]g003002]_:fl008000:]_003002]_:fl00:]_004
002]_0000002[K`00`00[Kb]_003[K`01000[K`000000Zfl00<00:fl[K`00Zfl00<00:fl[K`00P00
0Zfl00<00:fl[K`00Zfl00<00:fl[K`00P000Zfl00<00:fl[K`00Zfl00@00:fl000000:]_003002]
^jfk00:]^`03002]^jfk008000:]^`03002]^jfk00:]^`03002]^jfk008000:]V`03002]VjfK00:]
V`03002]VjfK00800003[I/00:fK00B]V`04002]V`000002[I/00`00[I^]V`02[I/01000[I^]VjfK
10001:fK00@00:fK[I^]V`@000B]V`03002]VjfK00:]V`8000B]N`03002]Njek00:]N`@000>]N`03
002]Njek00:]N`03002]Njek00800003[GX00:ej00B]NP03002]FZeJ00800003[EX00:eJ00B]FP03
002]FZeJ00:]FP<000B]>P03002]>Zdj00:]>P04002]>P000002[CX00`00[CZ]>P03[CX01000[CV]
>Jdi0`001:dI00<00:dI[AT00jdI00H00:dI00000:ci0005[?T00`00[=V/f@03[=T01P00[=P00000
[;P000F/^003002/^:bh00:/^003002/^:bh00:/^0<000BTE`03002TEjAG00:TE`03002TEZAF00>T
EP03002TEZAF00:TEP<002coo`800000ROoo0P008ooo0`000jgL00<00:gL[M`00ZgL0`000jgL00<0
0:gL[M`00jgL0`000jgL00<00:gL[M`00ZgL10000jgL0P000ZgL0`001JgL00@00:gL[Mb]g0<000F]
g003002]g:gL00@000B]g004002]g:gL[M`30005[M`01000[Mb]g:gL0`001JgL00<00:gL[M`01000
1:fl00@00:fl[Kb]_0<000F]_004002]_:fl[K`30005[K`00`00[Kb]_0040004[K`01000[Kb]_:fl
10001:fl00@00:fl[Kb]_0<000F]_003002]^jfk00@000F]^`03002]^jfk00@000B]V`04002]VjfK
[I/40004[I/00`00[I^]V`02[I/20004[I/00`00[I^]V`02[I/40003[I/00`00[I^]V`02[I/40003
[I/00`00[I^]V`02[I/00`00[I^]V`0200000jek002]N`04[G/01000[G/000000Zek00<00:ek[G/0
0Zek00@00:ek[G^]N`@000B]NP03002]NZej00:]NP<000B]FP03002]FZeJ00:]FP03002]FZeJ0080
0003[EX00:dj00B]>P04002]>Zdj[CX30004[CX00`00[CZ]>P03[CX01000[CT000000ZdI00<00:dI
[AT00ZdI00<00:dI[AT00ZdI0`001:ci00<00:ci[?T00Zci00<00:cI[=T00ZcI0`001:bh00<00:bh
[;P00Zbh00<00:bh[;P00jbh00H00:bh00000:AG0005Y5L00`00Y5NTE`03Y5L00`00Y5JTEP03Y5H0
1000Y5H00000:ooo10000_oo002;ool00`00ooooo`0Qool00`00[Mb]g003[M`01000[M`000000ZgL
00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00@00:gL000000:]g003002]g:gL
00>]g0<000>]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0<000>]g003002]g:gL00:]g0@0
00>]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0<000>]_003002]_:fl00:]_0@000>]_003
002]_:fl00:]_0@000>]_003002]_:fl00:]_0<000>]_003002]_:fl00:]_0@000>]_003002]_:fl
00:]_0@000>]_003002]_:fl00:]_0<000>]^`03002]^jfk00>]^`<000>]^`03002]VjfK00:]V`@0
00>]V`03002]VjfK00:]V`03002]VjfK008000:]V`03002]VjfK00:]V`04002]V`000002[I/00`00
[I^]V`02[I/00`00[I^]V`0200000jfK002]V`04[I/01000[I^]VjfK10001:ek00<00:ek[G/00Zek
0P001:ek00<00:ek[G/00Zek10000jek00<00:ej[GX00Zej00<00:ej[GX00P0000>]FP00[EX01:eJ
00@00:eJ[EZ]FP@000B]FP03002]>Zdj00:]>P@000:]>P03002]>Zdj00>]>P04002]>Zdj[CX30004
[AT00`00[AV]6@03[AT01000[AT000000Zci00<00:ci[?T00Zci00<00:ci[?T00jci00H00:cI0000
0:bh0005[;P00`00[;R/^002[;P00`00[;R/^002[;P30004Y5L00`00Y5NTE`02Y5L00`00Y5NTE`03
Y5L00`00Y5JTEP02Y5H3000Yool40006ool008coo`03003ooooo027oo`04002]g:gL[M`30005[M`0
0`00[Mb]g0040004[M`01000[Mb]g:gL0`001JgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00@0
0:gL000000:]g003002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00:]g004002]g0000002
[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000Zfl00<00:fl
[K`00Zfl00@00:fl000000:]_003002]_:fl00>]_004002]_0000002[K`00`00[Kb]_002[K`00`00
[Kb]_0020002[K`00`00[Kb]_002[K`01000[K`000000Zfl00<00:fl[K`00jfl00@00:fl000000:]
_003002]_:fl00:]_003002]_:fl008000:]^`03002]^jfk00:]^`03002]^jfk00800003[K/00:fk
00B]^`04002]V`000002[I/00`00[I^]V`02[I/01000[I^]VjfK10001:fK00@00:fK[I^]V`<000B]
V`03002]VjfK00:]V`<000B]V`03002]VjfK00:]V`@000>]N`03002]Njek00:]N`03002]Njek0080
0003[G/00:ek00B]N`04002]N`000002[G/00`00[G^]N`03[G/00`00[GZ]NP040004[EX00`00[EZ]
FP02[EX40002[EX00`00[EZ]FP03[EX00`00[CZ]>P0200000jdj002]>P04[CX00`00[CZ]>P02[CX4
0002[AT00`00[AV]6@03[AT01000[AV]6JdI0`001:ci00<00:ci[?T00jci00@00:ci[?V/n@<000B/
^003002/^:bh00>/^003002/^:bh00:/^006002/^000002TM`001JAG00<00:AGY5L00jAG00<00:AG
Y5L00jAG00@00:AF000002Soo`@000[oo`00SOoo00<00?ooool08Ooo0`000jgL00<00:gL[M`00ZgL
0`000jgL00<00:gL[M`00ZgL10000jgL0P000ZgL10001:gL00@00:gL[Mb]g0<000F]g003002]g:gL
00@000B]g004002]g:gL[M`30005[M`01000[Mb]g:gL0`001JgL00<00:gL[M`010001:fl00@00:fl
[Kb]_0<000F]_004002]_:fl[K`30005[K`00`00[Kb]_0040004[K`01000[Kb]_:fl0`001Jfl00@0
0:fl[Kb]_0<000F]_003002]_:fl00@000B]^`04002]^jfk[K/40004[K/00`00[K^]^`02[K/20004
[I/00`00[I^]V`02[I/40003[I/00`00[I^]V`02[I/40003[I/00`00[I^]V`02[I/01000[I/00000
0ZfK00<00:fK[I/00ZfK00<00:fK[I/00P000Zek00<00:ek[G/00Zek00@00:ek[G^]N`@000B]N`03
002]Njek00:]N`8000B]N`03002]Njek00>]N`<000>]FP03002]FZeJ00:]FP03002]FZeJ00800003
[EX00:eJ00B]FP03002]FZeJ00:]FP<000B]>P03002]>Zdj00:]>P03002]>Zdj00800003[AT00:dI
00B]6@03002]6JdI00:]6@04002]6@000002[?T00`00[?V/n@03[?T00`00[?V/n@02[?T01P00[?T0
0000Y;P000F/^003002/^:bh00>/^003002/^:bh00@000BTM`03002TEjAG00:TE`03002TEjAG00>T
E`03002TEjAG00:TE`<002Koo`@000koo`00S_oo0P008_oo00<00:gL[M`00ZgL00<00:gL[M`00P00
0ZgL00<00:gL[M`00ZgL00@00:gL000000:]g003002]g:gL00>]g0<000>]g003002]g:gL00:]g0@0
00>]g003002]g:gL00:]g0<000>]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0@000>]g003
002]g:gL00:]g0<000>]_003002]_:fl00:]_0@000>]_003002]_:fl00:]_0@000>]_003002]_:fl
00:]_0<000>]_003002]_:fl00:]_0@000>]_003002]_:fl00:]_0@000>]_003002]_:fl00:]_0<0
00>]^`03002]^jfk00:]^`@000>]^`03002]^jfk00:]^`03002]^jfk008000:]V`03002]VjfK00:]
V`04002]V`000002[I/00`00[I^]V`02[I/00`00[I^]V`0200000jfK002]V`04[I/01000[I^]VjfK
0`001JfK00<00:fK[I/010001:ek00<00:ek[G/00Zek10000jek00<00:ek[G/00Zek00<00:ek[G/0
0P0000>]N`00[G/01:ek00<00:ek[G/00P0000>]FP00[EX00jeJ00<00:eJ[EX00ZeJ0`001:eJ00<0
0:eJ[EX00ZeJ00<00:eJ[EX00P0000>]>P00[CX01:dj00<00:dj[CX00Zdj0`001:dI00<00:dI[AT0
0ZdI00@00:dI[AV]6@<000B/n@03002/nJci00>/n@04002/nJci[?T30004Y;P00`00[;R/^003[;P0
0`00[;R/^002[;P30002Y7L00`00Y7NTM`03Y7L00`00Y5NTE`03Y5L00`00Y5NTE`03Y5L01000Y5L0
00009_oo0`004_oo002@ool00`00ooooo`0Pool00`00[Mb]g0040005[M`00`00[Mb]g0030005[M`0
0`00[Mb]g0020002[M`00`00[Mb]g002[M`01000[M`000000ZgL00<00:gL[M`00ZgL00<00:gL[M`0
0P000ZgL00<00:gL[M`00ZgL00@00:gL000000:]g003002]g:gL00>]g004002]g0000002[M`00`00
[Mb]g002[M`00`00[Mb]g0020002[K`00`00[Kb]_002[K`01000[K`000000Zfl00<00:fl[K`00Zfl
00<00:fl[K`00P000Zfl00<00:fl[K`00Zfl00<00:fl[K`00P000Zfl00<00:fl[K`00Zfl00@00:fl
000000:]_003002]_:fl00:]_003002]_:fl008000:]_003002]_:fl00:]_003002]_:fl00800003
[K`00:fk00B]^`04002]^`000002[K/00`00[K^]^`02[K/01000[K^]^jfk10001:fK00@00:fK[I^]
V`<000F]V`03002]VjfK00@000B]V`03002]VjfK00:]V`@000>]V`03002]VjfK00:]V`<000>]N`03
002]Njek00>]N`04002]N`000002[G/00`00[G^]N`02[G/01000[G^]Njek10001:ek00<00:ek[G/0
0Zek0`001:eJ00<00:eJ[EX00ZeJ00@00:eJ000000:]FP03002]FZeJ00:]FP04002]FZeJ[EX40004
[CX00`00[CZ]>P03[CX01P00[CX00000[AT000F]6@03002]6JdI00:]6@@000:/n@03002/nJci00>/
n@03002/nJci00:/n@@000:T^003002T^:Bh00:T^003002/^:bh00>/^003002/^:bh00800003Y7L0
0:Ag00>TM`03002TMjAg00>TM`03002TEjAG00:TE`03002TEjAG00:TE`<002Coo`@001Goo`00TOoo
00<00?ooool08?oo0P000jgL0P000jgL10000jgL0P000ZgL10001:gL00@00:gL[Mb]g0<000F]g003
002]g:gL00@000F]g003002]g:gL00<000F]g004002]g:gL[M`30005[M`00`00[Mb]g0040004[K`0
1000[Kb]_:fl0`001Jfl00<00:fl[K`010001Jfl00<00:fl[K`010001:fl00@00:fl[Kb]_0<000F]
_003002]_:fl00@000B]_004002]_:fl[K`40004[K`00`00[K^]^`02[K/20004[K/00`00[K^]^`02
[K/40003[I/00`00[I^]V`02[I/40003[I/00`00[I^]V`02[I/30003[I/00`00[I^]V`02[I/00`00
[I^]V`0200000jfK002]V`04[I/00`00[I^]V`0200000jek002]N`04[G/01000[G^]Njek0`001:ek
00<00:ek[G/00Zek10000jek00<00:ek[G/00Zek00<00:ek[G/00P0000>]FP00[EX01:eJ00@00:eJ
[EZ]FP<000B]FP03002]FZeJ00:]FP@000:]>P03002]>Zdj00>]>P04002]>Zdj[CX40004[AT00`00
[AV]6@03[AT01P00[AT00000[?T000F/n@03002/nJci00:/n@03002/nJci00800003Y=P00:Bh00BT
^003002T^:Bh00:T^003002/^:bh00:/^0<000>TM`03002TMjAg00:TM`03002TMjAg00>TM`03002T
EjAG00>TE`04002TE`00000Sool4000Iool009;oo`03003ooooo023oo`03002]g:gL00:]g0@000>]
g003002]g:gL00:]g0<000>]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0<000>]g003002]
g:gL00>]g0<000>]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0<000>]g003002]_:fl00:]
_0@000>]_003002]_:fl00:]_0<000>]_003002]_:fl00>]_0<000>]_003002]_:fl00:]_0@000>]
_003002]_:fl00:]_0<000>]_003002]_:fl00:]_0@000>]_003002]_:fl00:]_003002]^jfk0080
00:]^`03002]^jfk00:]^`04002]^`000002[I/00`00[I^]V`02[I/00`00[I^]V`0200000jfK002]
V`04[I/00`00[I^]V`0200000jfK002]V`04[I/00`00[I^]V`040004[I/00`00[I^]V`02[I/30004
[G/00`00[G^]N`02[G/40003[G/00`00[G^]N`02[G/01000[G/000000Zek00<00:ek[G/00Zek00@0
0:ek[G^]N`@000B]FP03002]FZeJ00:]FP@000:]FP03002]FZeJ00>]FP04002]FP000002[CX00`00
[CZ]>P02[CX00`00[CZ]>P02[CX40002[AX00`00[AV]6@03[AT00`00[AV]6@02[AT30004[?T00`00
[?V/n@02[?T00`00[?V/n@02[?T30004Y=P00`00Y;RT^002Y;P00`00Y;RT^002Y;P00`00[;R/^002
00000jAg002TM`04Y7L00`00Y7NTM`02Y7L00`00Y7NTM`03Y7L00`00Y5NTE`04000Qool4000Mool0
09?oo`80027oo`04002]g0000002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002
[M`01000[M`000000ZgL00<00:gL[M`00jgL00@00:gL000000:]g003002]g:gL00:]g003002]g:gL
008000:]g003002]g:gL00:]g004002]g0000002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`0
0`00[Mb]g002[M`01000[K`000000Zfl00<00:fl[K`00Zfl00<00:fl[K`00P000Zfl00<00:fl[K`0
0Zfl00<00:fl[K`00P000Zfl00<00:fl[K`00Zfl00@00:fl000000:]_003002]_:fl00:]_003002]
_:fl008000:]_003002]_:fl00:]_004002]_0000002[K`00`00[Kb]_002[K`01000[Kb]_:fl1000
1:fk00@00:fk[K^]^`<000F]V`03002]VjfK00@000B]V`03002]VjfK00:]V`<000B]V`03002]VjfK
00:]V`<000>]V`03002]VjfK00:]V`03002]VjfK00800003[I/00:ek00B]N`03002]Njek00800003
[G/00:ek00B]N`04002]Njek[G/30004[G/00`00[G^]N`02[G/40002[EX00`00[EZ]FP03[EX00`00
[EZ]FP0200000jeJ002]FP04[EX00`00[EZ]FP02[EX20004[CX00`00[CZ]>P02[CX00`00[CZ]>P02
0002[AX00`00[AZ]6P02[AX00`00[AV]6@03[AT01P00[AT00000[?T000F/n@03002/nJci00>/n@06
002/n@00002Tf0001JCH00<00:BhY;P00jBh00<00:BhY;P010001:Ag00<00:AgY7L00ZAg00<00:Ag
Y7L00ZAg00<00:AgY7L00ZAg10008Ooo10008Ooo002Eool00`00ooooo`0Oool00`00[Mb]g003[M`0
0`00[Mb]g0040005[M`00`00[Mb]g0030005[M`01000[Mb]g:gL0`001JgL00<00:gL[M`010001:gL
00@00:gL[Mb]g0<000F]g003002]g:gL00@000B]g004002]g:gL[M`30005[K`00`00[Kb]_0040005
[K`00`00[Kb]_0040004[K`01000[Kb]_:fl0`001Jfl00<00:fl[K`010001:fl00@00:fl[Kb]_0<0
00B]_003002]_:fl00:]_0@000>]^`03002]^jfk00:]^`@000>]V`03002]VjfK00:]V`<000>]V`03
002]VjfK00:]V`03002]VjfK008000:]V`03002]VjfK00:]V`03002]VjfK00800003[I/00:fK00B]
V`03002]VjfK00@000B]V`03002]Njek00:]N`<000B]N`03002]Njek00:]N`@000>]N`03002]Njek
00:]N`04002]N`000002[E/00`00[EZ]FP02[EX00`00[EZ]FP02[EX30004[EX00`00[EZ]FP02[EX0
0`00[EZ]FP0200000jdj002]>P04[CX01000[CZ]>Zdj0`001:dJ00<00:dJ[AX00ZdJ00@00:dI[AV]
6@@000B/n@03002/nJci00>/n@03002/nJci00@000BTf003002Tf:CH00:Tf003002T^:Bh00:T^0@0
00:TM`03002TMjAg00>TM`03002TMjAg00:TM`03002TMjAg00>TM`04002TM`00000Rool3000Uool0
09Koo`03003ooooo01ooo`03002]g:gL00:]g0<000>]g003002]g:gL00>]g0<000>]g003002]g:gL
00:]g0@000>]g003002]g:gL00:]g0<000>]g003002]g:gL00:]g0@000>]g003002]g:gL00:]g0<0
00>]g003002]g:gL00:]g0@000>]_003002]_:fl00:]_0<000>]_003002]_:fl00>]_0<000>]_003
002]_:fl00:]_0@000>]_003002]_:fl00:]_0<000>]_003002]_:fl00:]_0@000>]_003002]_:fl
00:]_004002]_0000002[K`00`00[K^]^`03[K/01000[K/000000ZfK00<00:fK[I/00ZfK00<00:fK
[I/00P0000>]V`00[I/01:fK00<00:fK[I/010001:fK00@00:fK[I^]V`@000B]V`03002]VjfK00:]
V`<000>]V`03002]VjfK00:]V`03002]Njek00800003[G/00:ek00B]N`03002]Njek00800003[G/0
0:ek00B]N`04002]Njek[G/30004[E/00`00[EZ]FP02[EX00`00[EZ]FP0200000jeJ002]FP04[EX0
1000[EZ]FZeJ10001:dj00<00:dj[CX00Zdj00@00:dj000000:]6P03002]6ZdJ00>]6P04002]6ZdJ
[AX40002[?T00`00[?V/n@03[?T00`00[?V/n@02[?T40002Y=P00`00Y=RTf003Y=P00`00Y=RTf003
Y=P01P00Y;P00000Y7L000FTM`03002TMjAg00:TM`03002TMjAg00:TM`03002TMjAg00:TM`<0023o
o`@002Soo`00Uooo00<00?ooool07ooo00@00:gL000000:]g003002]g:gL00:]g003002]g:gL0080
00:]g003002]g:gL00:]g004002]g0000002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00
[Mb]g002[M`01000[M`000000ZgL00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL
00@00:gL000000:]_003002]_:fl00:]_003002]_:fl008000:]_003002]_:fl00:]_003002]_:fl
008000:]_003002]_:fl00:]_004002]_0000002[K`00`00[Kb]_002[K`00`00[Kb]_0020002[K`0
0`00[Kb]_002[K`01000[K`000000Zfl00<00:fl[K`00Zfl00@00:fl[Kb]_0<000F]_004002]^jfk
[K/30005[I/00`00[I^]V`040004[I/00`00[I^]V`02[I/30003[I/00`00[I^]V`02[I/40003[I/0
0`00[I^]V`02[I/00`00[I^]V`0200000jfK002]V`04[I/00`00[I^]V`040004[G/00`00[G^]N`02
[G/30004[G/00`00[G^]N`02[G/40002[G/00`00[E^]F`03[E/00`00[EZ]FP040004[EX00`00[EZ]
FP02[EX40002[CX00`00[CZ]>P03[CX01000[CZ]>Zdj0`001:dJ00<00:dJ[AX00jdJ00@00:dJ0000
00:/n@03002/nJci00:/n@03002/nJci00>/n@06002/n@00002Tf0001JCH00<00:CHY=P00ZCH00<0
0:CHY=P00ZCH0`001:Ag00<00:AgY7L00ZAg00<00:AgY7L00ZAg00<00:AgY7L00jAg00@00:Ag0000
01ooo`@002coo`00V?oo0P008?oo00<00:gL[M`00jgL00<00:gL[M`010001:gL00@00:gL[Mb]g0<0
00F]g003002]g:gL00@000B]g004002]g:gL[M`30005[M`00`00[Mb]g0040004[M`01000[Mb]g:gL
0`001Jfl00<00:fl[K`010001Jfl00<00:fl[K`010001:fl00@00:fl[Kb]_0<000F]_003002]_:fl
00@000B]_004002]_:fl[K`30004[K`00`00[Kb]_002[K`40003[K`00`00[Kb]_002[K`40003[K/0
0`00[I^]V`02[I/30003[I/00`00[I^]V`02[I/00`00[I^]V`020002[I/00`00[I^]V`02[I/01000
[I/000000ZfK00<00:fK[I/00ZfK00@00:fK[I^]V`@000B]V`03002]VjfK00:]V`<000>]N`03002]
Njek00:]N`03002]Njek00800003[G/00:ek00B]N`03002]Njek00800003[G/00:ek00B]N`03002]
FjeK00:]F`<000>]FP03002]FZeJ00:]FP03002]FZeJ00800003[CX00:dj00B]>P03002]>Zdj00:]
>P@000:]>P03002]6ZdJ00>]6P03002]6ZdJ00:]6P8000B/n@03002/nJci00:/n@03002/nJci00:/
n@<000BTf003002Tf:CH00:Tf003002Tf:CH00>Tf006002Tf000002TM`001JAg00<00:AgY7L00ZAg
00<00:AgY7L00jAg00<00:AgY7L010007Ooo1000<?oo002Jool00`00ooooo`0Nool00`00[Mb]g002
[M`30003[M`00`00[Mb]g002[M`40003[M`00`00[Mb]g002[M`30003[M`00`00[Mb]g002[M`40003
[M`00`00[Mb]g002[M`30003[M`00`00[Mb]g002[M`40003[K`00`00[Kb]_002[K`30003[K`00`00
[Kb]_003[K`30003[K`00`00[Kb]_002[K`40003[K`00`00[Kb]_002[K`30003[K`00`00[Kb]_002
[K`40003[K`00`00[Kb]_002[K`01000[K`000000Zfl00<00:fl[K`00Zfl00<00:fl[K`00P000Zfk
00<00:fk[K/00Zfk00<00:fK[I/00P0000>]V`00[I/01:fK00<00:fK[I/010001:fK00@00:fK[I^]
V`<000B]V`03002]VjfK00:]V`@000>]V`03002]VjfK00:]V`03002]VjfK00800003[G/00:ek00B]
N`03002]Njek00@000B]N`03002]Njek00:]N`<000B]N`03002]Njek00:]N`03002]FjeK00800003
[EX00:eJ00B]FP03002]FZeJ00@000B]>P03002]>Zdj00:]>P03002]>Zdj00800003[CX00:dj00B]
>P03002]6ZdJ00:]6P03002]6ZdJ00800003[?T00:ci00B/n@03002/nJci00:/n@04002/n@000002
Y=T00`00Y=RTf002Y=P00`00Y=RTf003Y=P00`00Y=RTf0040004Y7L00`00Y7NTM`02Y7L00`00Y7NT
M`02Y7L00`00Y7NTM`02Y7L4000Mool4000dool009_oo`03003ooooo01koo`04002]g0000002[M`0
0`00[Mb]g002[M`01000[M`000000ZgL00<00:gL[M`00jgL00@00:gL000000:]g003002]g:gL00:]
g004002]g0000002[M`00`00[Mb]g003[M`01000[M`000000ZgL00<00:gL[M`00ZgL00@00:gL0000
00:]_003002]_:fl00>]_004002]_0000002[K`00`00[Kb]_002[K`00`00[Kb]_0020002[K`00`00
[Kb]_002[K`01000[K`000000Zfl00<00:fl[K`00Zfl00<00:fl[K`00P000Zfl00<00:fl[K`00Zfl
00@00:fl000000:]_003002]_:fl00:]_004002]_:fl[K`30005[K`00`00[Kb]_0040004[K/01000
[K^]^jfk10001:fK00<00:fK[I/00ZfK0`000jfK00<00:fK[I/00ZfK10000jfK00<00:fK[I/00ZfK
00@00:fK000000:]V`03002]VjfK00:]V`04002]VjfK[I/40004[G/00`00[G^]N`02[G/30003[G/0
0`00[G^]N`02[G/00`00[G^]N`0200000jek002]N`04[G/01000[G^]Njek10001:eJ00<00:eJ[EX0
0ZeJ0`000jdj00<00:dj[CX00Zdj00@00:dj[CZ]>P@000B]>P03002]>Zdj00:]>P04002]6ZdJ[AX4
0004[?T00`00[?V/n@02[?T00`00[?V/n@040004Y=T00`00Y=RTf002Y=P00`00Y=RTf002Y=P40002
Y9L00`00Y7NTM`03Y7L00`00Y7NTM`02Y7L00`00Y7NTM`03Y7L01000Y7L000007_oo0`00>?oo002L
ool00`00ooooo`0Nool00`00[Mb]g003[M`00`00[Mb]g0030005[M`01000[Mb]g:gL0`001JgL00<0
0:gL[M`00`001JgL00@00:gL[Mb]g0<000F]g003002]g:gL00<000F]_004002]_:fl[K`30005[K`0
0`00[Kb]_0040004[K`01000[Kb]_:fl0`001Jfl00<00:fl[K`010001:fl00@00:fl[Kb]_0<000B]
_003002]_:fl00:]_0@000>]_003002]_:fl00:]_0<000>]^`03002]^jfk00:]^`@000>]V`03002]
VjfK00:]V`03002]VjfK008000:]V`03002]VjfK00:]V`04002]V`000002[I/00`00[I^]V`02[I/0
1000[I^]VjfK0`001:fK00<00:fK[I/00ZfK10000jek00<00:ek[G/00Zek00<00:ek[G/00P0000>]
N`00[G/01:ek00<00:ek[G/010001:ek00<00:ek[G/00Zek10000ZeJ00<00:eJ[EX00jeJ00<00:eJ
[EX00P0000>]>P00[CX00jdj00<00:dj[CX00Zdj10000Zdj00<00:dj[CX00jdj00<00:dj[CX00Zdj
10000ZdI00<00:ci[?T00jci00<00:ci[?T00Zci0`000jCI00<00:CIY=T00jCI00<00:CHY=P00ZCH
00H00:CH00000:BH0005Y9L00`00Y7NTM`02Y7L00`00Y7NTM`03Y7L00`00Y7NTM`04000Lool4000k
ool009goo`8001ooo`04002]g:gL[M`40003[M`20002[M`50003[M`01000[Mb]g:gL10000jgL0P00
0ZgL1@000jgL00@00:gL[Mb]g0@000>]g003002]_:fl00:]_0@000>]_003002]_:fl00:]_0<000>]
_003002]_:fl00:]_0@000>]_003002]_:fl00:]_0<000>]_003002]_:fl00:]_0@000>]_003002]
_:fl00:]_004002]_0000002[K`00`00[Kb]_002[K`00`00[Kb]_0020002[K`00`00[K^]^`02[K/0
1000[K/000000ZfK00<00:fK[I/00ZfK00@00:fK[I^]V`@000B]V`04002]VjfK[I/30004[I/00`00
[I^]V`02[I/40003[I/00`00[I^]V`02[I/01000[I/000000Zek00<00:ek[G/00Zek00@00:ek[G^]
N`@000B]N`03002]Njek00:]N`<000>]N`03002]Njek00:]N`03002]Njek00800003[EX00:eJ00B]
FP03002]FZeJ00:]FP<000B]>P03002]>Zdj00:]>P04002]>P000002[CX00`00[CZ]>P02[CX00`00
[CZ]>P03[CX01P00[CX00000[AT000F]6@03002/nJci00>/n@06002/n@00002Tf@001:CI00<00:CI
Y=T00jCI00<00:CHY=P010001:BH00<00:BGY9L00ZBG00<00:AgY7L00ZAg00<00:AgY7L00ZAg1000
7?oo1000?ooo002Oool00`00ooooo`0Mool30003[M`00`00[Mb]g002[M`30003[M`00`00[Mb]g002
[M`40003[M`00`00[Mb]g002[M`30003[M`00`00[Mb]g002[M`40003[M`00`00[Mb]g002[M`01000
[K`000000Zfl00<00:fl[K`00Zfl00<00:fl[K`00P000Zfl00<00:fl[K`00Zfl00@00:fl000000:]
_003002]_:fl00:]_003002]_:fl008000:]_003002]_:fl00:]_004002]_0000002[K`00`00[Kb]
_002[K`01000[Kb]_:fl0`001Jfl00<00:fl[K`010001:fl00@00:fk[K^]^`<000B]V`03002]VjfK
00:]V`@000>]V`03002]VjfK00:]V`@000>]V`03002]VjfK00:]V`04002]V`000002[I/00`00[I^]
V`02[I/01000[I^]VjfK0`001:ek00<00:ek[G/00Zek10000jek00<00:ek[G/00Zek00<00:ek[G/0
0P0000>]N`00[G/01:ek00<00:ek[G/010001:eJ00<00:eJ[EX00ZeJ00<00:eJ[EX00P0000>]FP00
[CX01:dj00<00:dj[CX00Zdj0P001:dj00<00:dj[CX00Zdj00@00:dj[CZ]>P@000B]6@03002]6JdI
00:]6@04002/nJci[?T40004Y=T00`00Y=VTf@02Y=T00`00Y=VTf@02Y=T30002Y9P00`00Y9RTV003
Y9P00`00Y9NTU`03Y9L00`00Y7NTM`02Y7L01000Y7L000007?oo1000@ooo002Pool00`00ooooo`0M
ool00`00[Mb]g002[M`00`00[Mb]g0020002[M`00`00[Mb]g002[M`01000[M`000000ZgL00<00:gL
[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00@00:gL000000:]g003002]g:gL00:]g004
002]g:gL[M`30005[K`00`00[Kb]_0040004[K`01000[Kb]_:fl0`001Jfl00<00:fl[K`010001:fl
00@00:fl[Kb]_0<000F]_003002]_:fl00D000>]_003002]_:fl00:]_0<000>]_003002]_:fl00:]
_0@000>]V`03002]VjfK00:]V`04002]V`000002[I/00`00[I^]V`02[I/00`00[I^]V`0200000jfK
002]V`04[I/01000[I^]VjfK0`001:fK00<00:fK[I/00ZfK10000jek00<00:ek[G/00Zek00@00:ek
000000:]N`03002]Njek00:]N`04002]Njek[G/40004[G/00`00[G^]N`02[G/30003[EX00`00[EZ]
FP02[EX01000[EZ]FZeJ10001:eJ00<00:dj[CX00jdj00H00:dj00000:dj0005[CX01000[CZ]>Zdj
10000ZdI00<00:dI[AT00jdI00<00:dI[AT00ZdI10000ZCI00<00:CIY=T00jCI00<00:CIY=T00ZCI
00<00:CIY=T00P0000>TV000Y9P00jBH00<00:BHY9P00jBH00<00:BGY9L00ZBG00<00:AgY7L01000
6_oo1000Aooo002Qool00`00ooooo`0Mool00`00[Mb]g0040005[M`00`00[Mb]g0030005[M`00`00
[Mb]g0040004[M`01000[Mb]g:gL0`001JgL00<00:gL[M`01@000jfl00@00:fl[Kb]_0@000>]_003
002]_:fl00:]_0@000>]_003002]_:fl00:]_0<000>]_003002]_:fl00:]_0@000>]_003002]_:fl
00:]_0<000>]_003002]_:fl00:]_003002]_:fl008000:]_003002]_:fl00:]_004002]_0000002
[I/00`00[I^]V`02[I/01000[I^]VjfK0`001JfK00<00:fK[I/010001:fK00<00:fK[I/00ZfK1000
0jfK00<00:fK[I/00ZfK00@00:fK000000:]N`03002]Njek00:]N`04002]Njek[G/30004[G/00`00
[G^]N`02[G/40003[G/00`00[G^]N`02[G/00`00[G^]N`0200000jeK002]FP03[EX00`00[EZ]FP02
[EX40002[EX00`00[EZ]FP03[EX01000[CZ]>Zdj10001:dj00<00:dj[CX00Zdj00@00:dj000000:]
6@03002]6JdI00:]6@03002]6JdI00>]6@06002]6@00002Tf@001JCI00<00:CIY=T00jCI00<00:CI
Y=T010001:BH00D00:BHY9RTV00000FTV003002TUjBG00:TU`<001_oo`<004_oo`00X_oo0P007_oo
0P000jgL00<00:gL[M`00jgL0`000jgL00<00:gL[M`00ZgL0`000jgL00<00:gL[M`00ZgL10000jgL
00<00:gL[M`00ZgL0`000jfl00<00:fl[K`00Zfl10000jfl00<00:fl[K`00Zfl00@00:fl000000:]
_003002]_:fl00:]_003002]_:fl008000:]_003002]_:fl00:]_004002]_0000002[K`00`00[Kb]
_002[K`00`00[Kb]_00200000jfl002]_004[K`00`00[Kb]_0040004[K`01000[Kb]_:fl0`001:fK
00<00:fK[I/00ZfK10000jfK00<00:fK[I/00ZfK0`000jfK00<00:fK[I/00ZfK00<00:fK[I/00P00
00>]V`00[I/01:fK00@00:fK[I^]V`<000B]N`03002]Njek00:]N`@000>]N`03002]Njek00:]N`04
002]N`000002[G/00`00[G^]N`02[G/01000[G^]Njek10001:eK00<00:eJ[EX00ZeJ00@00:eJ0000
00:]FP03002]FZeJ00:]FP03002]FZeJ00:]FP@000:]>P03002]>Zdj00>]>P04002]>Zdj[CX30004
[AT00`00[AV]6@02[AT01000[AV]6JdI10001:CI00<00:CIY=T00ZCI00<00:CIY=T00ZCI10000ZBH
00<00:BHY9P00jBH00<00:BHY9P00ZBH00<00:BHY9P00jBH00@00:BG000001[oo`@004koo`00Y?oo
00<00?ooool07?oo00<00:gL[M`00ZgL00<00:gL[M`00P000ZgL00<00:gL[M`00ZgL00@00:gL0000
00:]g003002]g:gL00:]g004002]g0000002[M`00`00[Mb]g002[M`00`00[Mb]g0020002[K`00`00
[Kb]_002[K`01000[K`000000Zfl00<00:fl[K`00Zfl00@00:fl[Kb]_0<000F]_003002]_:fl00@0
00B]_004002]_:fl[K`30005[K`00`00[Kb]_0040004[K`00`00[Kb]_002[K`30003[K`00`00[Kb]
_002[K`40003[I/00`00[I^]V`02[I/01000[I/000000ZfK00<00:fK[I/00ZfK00<00:fK[I/00P00
00>]V`00[I/01:fK00<00:fK[I/010001:fK00<00:fK[I/00ZfK10000jfK00<00:ek[G/00Zek00@0
0:ek000000:]N`03002]Njek00:]N`04002]Njek[G/30004[G/00`00[G^]N`02[G/40002[E/00`00
[E^]F`03[E/01000[EZ]FZeJ0`001:eJ00<00:eJ[EX00ZeJ00<00:eJ[EX00P0000>]>P00[CX01:dj
00<00:dj[CX00Zdj10000ZdJ00<00:dI[AT00jdI00@00:dI[AV]6@@000>Tf@03002TfJCI00:Tf@03
002TfJCI00>Tf@06002Tf@00002TV0001JBH00<00:BHY9P00ZBH00<00:BHY9P00ZBH00@00:BHY9RT
V0@001Soo`@005;oo`00YOoo00<00?ooool07?oo00<00:gL[M`010001:gL00@00:gL[Mb]g0<000F]
g003002]g:gL00<000F]g003002]g:gL00@000F]_003002]_:fl00<000F]_003002]_:fl00D000>]
_004002]_:fl[K`40003[K`00`00[Kb]_002[K`40003[K`00`00[Kb]_002[K`30003[K`00`00[Kb]
_002[K`00`00[Kb]_0020002[K`00`00[Kb]_002[K`01000[K`000000Zfk00<00:fK[I/00ZfK00@0
0:fK[I^]V`<000F]V`03002]VjfK00@000B]V`03002]VjfK00:]V`<000>]V`03002]VjfK00:]V`03
002]VjfK008000:]V`03002]VjfK00:]V`04002]Njek[G/30004[G/00`00[G^]N`02[G/40003[G/0
0`00[G^]N`02[G/01000[G/000000ZeK00<00:eK[E/00ZeK00<00:eK[E/00ZeK10000jeJ00<00:eJ
[EX00ZeJ00<00:eJ[EX010001:dj00<00:dj[CX00Zdj00<00:dj[CX00P0000>]6P00[AX01:dJ00<0
0:dI[AT00ZdI00@00:dI000000:Tn@03002TfJCI00:Tf@03002TfJCI00>Tf@03002TfJCI00@000BT
V003002TV:BH00:TV003002TV:BH00:TV003002TV:BH00:TV0@001Soo`@005Koo`00Y_oo00<00?oo
ool07?oo0P000jgL00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL0`000jgL00<00:gL[M`00ZgL
0`000jfl00<00:fl[K`00jfl0`000jfl00<00:fl[K`00Zfl0`000jfl00<00:fl[K`00Zfl10000jfl
00<00:fl[K`00Zfl00@00:fl000000:]_003002]_:fl00:]_003002]_:fl008000:]_003002]_:fl
00:]_003002]_:fl00@000B]_004002]_:fl[K`30005[K/00`00[I^]V`050003[I/00`00[I^]V`02
[I/30003[I/00`00[I^]V`02[I/00`00[I^]V`020002[I/00`00[I^]V`02[I/00`00[I^]V`040004
[I/01000[I^]VjfK1@000jek00<00:ek[G/00Zek00@00:ek000000:]N`03002]Njek00:]N`04002]
Njek[G/30004[E/00`00[E^]F`02[E/00`00[E^]F`0200000jeJ002]FP04[EX01000[EZ]FZeJ1000
0jdj00<00:dj[CX00Zdj00@00:dj[CZ]>P@000B]6P03002]6ZdJ00:]6P04002]6JdI[AT30004Y?T0
0`00Y=VTf@03Y=T01000Y=VTfJCI10000ZBH00<00:BHY9P00jBH00<00:BHY9P00ZBH00<00:BHY9P0
0jBH00@00:BH000001Soo`@005[oo`00Yooo0P007Ooo00<00:gL[M`00ZgL00@00:gL000000:]g003
002]g:gL00:]g003002]g:gL008000:]g003002]g:gL00:]g004002]g0000002[K`00`00[Kb]_002
[K`00`00[Kb]_0020002[K`00`00[Kb]_002[K`01000[K`000000Zfl00<00:fl[K`00Zfl00@00:fl
000000:]_003002]_:fl00:]_004002]_:fl[K`30005[K`00`00[Kb]_0040004[K`01000[Kb]_:fl
10000jfl00<00:fl[K`00Zfl10000jfl00<00:fk[K/00Zfk0`000jfK00<00:fK[I/00ZfK00<00:fK
[I/00P0000>]V`00[I/01:fK00<00:fK[I/010001:fK00@00:fK[I^]V`@000>]V`03002]VjfK00:]
V`@000>]N`03002]Njek00:]N`04002]Njek[G/30004[G/00`00[G^]N`02[G/40003[E/00`00[E^]
F`02[E/00`00[E^]F`040004[EX00`00[EZ]FP02[EX40002[CX00`00[CZ]>P02[CX00`00[CZ]>P02
[CX40002[AX00`00[AZ]6P03[AX00`00[AZ]6P02[AX40002Y?T00`00Y?VTn@03Y?T00`00Y=VTf@02
Y=T01P00Y=T00000Y9P000FTV003002TV:BH00:TV003002TV:BH00>TV003002TV:BH00@001Koo`@0
05koo`00ZOoo00<00?ooool06ooo00<00:gL[M`00`001JgL00<00:gL[M`010001:gL00@00:gL[Mb]
g0<000F]_003002]_:fl00@000B]_004002]_:fl[K`30005[K`00`00[Kb]_0030005[K`00`00[Kb]
_0050003[K`00`00[Kb]_002[K`30003[K`00`00[Kb]_002[K`40003[K`00`00[Kb]_002[K`01000
[K`000000Zfl00<00:fl[K`00Zfl00<00:fk[K/00P0000>]V`00[I/01:fK00<00:fK[I/010001:fK
00<00:fK[I/00ZfK0`000jfK00<00:fK[I/00ZfK10000jfK00<00:fK[I/00ZfK00@00:fK000000:]
N`03002]Njek00:]N`04002]Njek[G/50003[G/00`00[G^]N`02[G/01P00[G/00000[E/000F]F`04
002]FjeK[E/40003[EX00`00[EZ]FP02[EX00`00[EZ]FP0200000jdj002]>P04[CX00`00[CZ]>P02
[CX01000[CX000000ZdJ00<00:dJ[AX00ZdJ00<00:dJ[AX00jdJ00H00:dJ00000:Ci0005Y?T00`00
Y?VTn@02Y?T01000Y=VTfJCI0`001:BH00<00:BHY9P00ZBH00<00:BHY9P00ZBH00<00:BHY9P00ZBH
10005ooo0`00H_oo002Zool00`00ooooo`0Kool20003[M`20002[M`40003[M`20002[M`50003[M`0
0`00[Kb]_002[K`30003[K`00`00[Kb]_002[K`40003[K`00`00[Kb]_002[K`30003[K`00`00[Kb]
_002[K`30003[K`00`00[Kb]_002[K`00`00[Kb]_0020002[K`00`00[Kb]_002[K`01000[K`00000
0Zfl00<00:fl[K`00Zfl00@00:fl[Kb]_0<000F]_003002]_:fl00@000B]V`03002]VjfK00:]V`<0
00>]V`03002]VjfK00:]V`03002]VjfK008000:]V`03002]VjfK00:]V`04002]V`000002[I/00`00
[I^]V`02[I/01000[I^]VjfK0`001:ek00<00:ek[G/00Zek10000Zek00<00:ek[G/00jek00@00:ek
[G^]N`<000B]F`03002]FjeK00:]F`@000:]FP03002]FZeJ00>]FP03002]FZeJ00@000B]>P03002]
>Zdj00:]>P04002]>Zdj[CX30004[AX00`00[AZ]6P02[AX01000[AZ]6ZdJ10001:Ci00<00:CiY?T0
0ZCi00<00:CiY?T00ZCi10000ZBH00<00:BHY9P00ZBH00<00:BHY9P00ZBH00<00:BHY9P00jBH00@0
0:BH000001Ooo`@006Goo`00Zooo00<00?ooool06ooo00<00:gL[M`00ZgL0`000jgL00<00:gL[M`0
0ZgL0`000jgL00<00:gL[M`00ZgL00<00:fl[K`00P000Zfl00<00:fl[K`00Zfl00@00:fl000000:]
_003002]_:fl00:]_003002]_:fl008000:]_003002]_:fl00:]_004002]_0000002[K`00`00[Kb]
_002[K`00`00[Kb]_0040004[K`01000[Kb]_:fl0`001Jfl00<00:fl[K`01@000jfl00<00:fl[K`0
0Zfl0`000jfK00<00:fK[I/00ZfK00<00:fK[I/00P000ZfK00<00:fK[I/00ZfK00<00:fK[I/01000
1:fK00@00:fK[I^]V`<000B]V`03002]VjfK00:]V`@000>]N`03002]Njek00:]N`04002]N`000002
[G/00`00[G^]N`02[G/00`00[G^]N`02[G/40003[G/01@00[E^]FjeK00000ZeK0P0000>]FP00[EX0
1:eJ00<00:eJ[EX00ZeJ0`000jdj00<00:dj[CX00Zdj00<00:dj[CX00Zdj10000ZdJ00<00:dJ[AX0
0jdJ00@00:dJ[AZ]6P@000>Tn@03002TnJCi00:Tn@03002TnJCi00>Tn@06002Tn@00002T^0001JBH
00<00:BHY9P00ZBH00<00:BHY9P00ZBH00<00:BHY9P010005Ooo1000JOoo002/ool2000Kool00`00
[Mb]g0020002[M`00`00[Mb]g002[M`01000[M`000000ZgL00<00:gL[M`00ZgL00<00:gL[M`01000
1:fl00@00:fl[Kb]_0<000F]_003002]_:fl00@000B]_004002]_:fl[K`30005[K`00`00[Kb]_004
0003[K`00`00[Kb]_002[K`40003[K`00`00[Kb]_002[K`30003[K`00`00[Kb]_002[K`00`00[Kb]
_0020002[I/00`00[I^]V`02[I/00`00[I^]V`040004[I/01000[I^]VjfK10000jfK00<00:fK[I/0
0ZfK10000jfK00<00:fK[I/00ZfK00@00:fK000000:]N`03002]Njek00:]N`04002]Njek[G/30004
[G/00`00[G^]N`02[G/00`00[G^]N`0200000jek002]N`04[G/00`00[E^]F`040004[EX00`00[EZ]
FP02[EX00`00[EZ]FP0200000jdj002]>P03[CX00`00[CZ]>P03[CX01P00[CX00000[AX000F]6P03
002]6ZdJ00:]6P04002]6P000002Y?T00`00Y?VTn@02Y?T00`00Y?VTn@03Y?T00`00Y?VTn@040004
Y;P00`00Y9RTV002Y9P00`00Y9RTV002Y9P01000Y9RTV:BH10005Ooo1000KOoo002^ool00`00oooo
o`0Iool20004[M`01000[Mb]g:gL0`001JgL00<00:gL[M`010000jfl0P000Zfl1@000jfl00<00:fl
[K`00Zfl0`000jfl00<00:fl[K`00Zfl10000jfl00<00:fl[K`00Zfl0`000jfl00<00:fl[K`00Zfl
00@00:fl000000:]_003002]_:fl00:]_003002]_:fl00800003[K`00:fl00B]_003002]_:fl00@0
00B]V`04002]VjfK[I/40003[I/00`00[I^]V`02[I/40003[I/00`00[I^]V`02[I/01000[I/00000
0ZfK00<00:fK[I/00ZfK00@00:fK[I^]V`<000B]N`03002]Njek00:]N`@000>]N`03002]Njek00:]
N`03002]Njek00@000B]N`03002]Njek00:]N`<000>]FP03002]FZeJ00:]FP04002]FZeJ[EX40004
[CX00`00[CZ]>P02[CX00`00[CZ]>P040004[AX00`00[AZ]6P02[AX01000[AZ]6ZdJ0`001:Ci00<0
0:CiY?T00jCi00@00:CiY?VTn@@000:T^003002T^:Bh00>T^003002TV:BH00:TV003002TV:BH00>T
V0<001Goo`@0077oo`00[ooo00<00?ooool06Ooo00<00:gL[M`00ZgL10000jgL00<00:gL[M`00ZgL
0`000jfl00<00:fl[K`00Zfl0`000jfl00<00:fl[K`00Zfl00<00:fl[K`00P000Zfl00<00:fl[K`0
0Zfl00@00:fl000000:]_003002]_:fl00:]_003002]_:fl008000:]_003002]_:fl00:]_003002]
_:fl00<000F]_003002]_:fl00@000B]_003002]_:fl00:]_0<000>]W003002]VjfK00:]V`@000>]
V`03002]VjfK00:]V`04002]V`000002[I/00`00[I^]V`02[I/01000[I^]VjfK0`001:fK00<00:fK
[I/00ZfK10000jek00<00:ek[G/00Zek00@00:ek000000:]N`03002]Njek00:]N`04002]Njek[G/4
0003[G/00`00[G^]N`02[G/00`00[G^]N`0200000jeJ002]FP03[EX00`00[EZ]FP02[EX40002[CX0
0`00[CZ]>P03[CX01000[CZ]>Zdj10000jDJ00<00:dJ[AX00ZdJ00@00:dJ[AZ]6PD000:Tn@03002T
nJCi00>Tn@03002TnJCi00:Tn@06002Tn@00002T^0001JBh00<00:BhY;P00ZBh00<00:BHY9P00jBH
00<00:BHY9P00`005?oo0`00MOoo002`ool00`00ooooo`0Iool01000[M`000000ZgL00<00:gL[M`0
0ZgL00<00:gL[M`00P000Zfl00<00:fl[K`00Zfl00@00:fl000000:]_003002]_:fl00:]_003002]
_:fl00@000B]_004002]_:fl[K`30005[K`00`00[Kb]_0040004[K`01000[Kb]_:fl10000jfl00<0
0:fl[K`00Zfl0`000jfl00<00:fl[K`00Zfl00<00:fl[K`00P000ZfL00<00:fL[I`00ZfL00@00:fK
000000:]V`03002]VjfK00:]V`04002]VjfK[I/30004[I/00`00[I^]V`02[I/40003[I/00`00[I^]
V`02[I/01000[I/000000Zek00<00:ek[G/00Zek00@00:ek[G^]N`<000B]N`03002]Njek00:]N`@0
00:]N`03002]Njek00>]N`03002]Njek00@000B]FP03002]FZeJ00:]FP04002]FP000002[CX00`00
[CZ]>P02[CX00`00[CZ]>P02[CX40002YAX00`00YAZU6P02YAX00`00[AZ]6P02[AX40002Y?T00`00
Y?VTn@03Y?T00`00Y?VTn@02Y?T01000Y?VTnJCi0`001:Bh00<00:BhY;P00ZBh00<00:BhY;P00jBh
00<00:BHY9P01@004ooo1000N?oo002aool2000Jool00`00[Mb]g003[M`00`00[Mb]g0040004[K`0
1000[Kb]_:fl0`001Jfl00<00:fl[K`010000jfl0P000Zfl1@000jfl00<00:fl[K`00Zfl0`000jfl
00<00:fl[K`00Zfl10000jfl00<00:fl[K`00Zfl00@00:fl000000:]_003002]_:fl00:]_003002]
_:fl00@000B]W004002]W:fL[I`30004[I/00`00[I^]V`02[I/40003[I/00`00[I^]V`02[I/01000
[I/000000ZfK00<00:fK[I/00ZfK00@00:fK[I^]V`<000B]N`03002]Njek00:]N`@000>]N`03002]
Njek00:]N`04002]N`000002[G/00`00[G^]N`02[G/00`00[G^]N`02[G/30003[E/00`00[EZ]FP02
[EX01000[EZ]FZeJ0`001:dj00<00:dj[CX00Zdj00<00:dj[CX00P0000>U>P00YAX01:DJ00<00:DJ
YAX00ZDJ00@00:dJ000000:Tn@03002TnJCi00:Tn@03002TnJCi00:Tn@04002TnJCiY?T50002Y;P0
0`00Y;RT^002Y;P00`00Y;RT^002Y;P00`00Y;RT^002Y;P4000Dool4001lool00;?oo`03003ooooo
01Soo`8000:]g0@000>]_003002]_:fl00:]_0@000>]_003002]_:fl00:]_0<000>]_003002]_:fl
00:]_0<000>]_003002]_:fl00:]_003002]_:fl008000:]_003002]_:fl00:]_004002]_0000002
[K`00`00[Kb]_002[K`01000[Kb]_:fl0`001:fl00@00:fl[Kb]_0@000>]W003002]W:fL00:]W0@0
00>]V`03002]VjfK00:]V`04002]V`000002[I/00`00[I^]V`02[I/01000[I^]VjfK0`001JfK00<0
0:fK[I/01@000jek00<00:ek[G/00Zek00H00:ek00000:ek0005[G/01000[G^]Njek0`001:ek00<0
0:ek[G/00Zek00<00:ek[G/00P0000>]F`00[E/01:eK00<00:eJ[EX01@000Zdj00<00:dj[CX00jdj
00<00:dj[CX010001:Dj00<00:DJYAX00ZDJ00@00:DJYAZU6P<000BTn@03002TnJCi00:Tn@03002T
nJCi00:Tn@@000:T^003002T^:Bh00>T^003002T^:Bh00:T^003002T^:Bh00:T^004002T^000000D
ool40020ool00;Coo`03003ooooo01Woo`8000>]_003002]_:fl00:]_004002]_0000002[K`00`00
[Kb]_002[K`00`00[Kb]_0020002[K`00`00[Kb]_002[K`01000[K`000000Zfl00<00:fl[K`00Zfl
00<00:fl[K`010001:fl00@00:fl[Kb]_0<000F]_003002]_:fl00D000>]_004002]_:fl[K`40003
[K`00`00[Ib]W002[I`01000[I`000000ZfK00<00:fK[I/00ZfK00@00:fK[I^]V`<000F]V`03002]
VjfK00D000>]V`03002]VjfK00:]V`<000>]V`03002]Njek00:]N`04002]Njek[G/30004[G/00`00
[G^]N`02[G/40003[G/00`00[G^]N`02[G/00`00[G^]N`040004[E/00`00[E^]F`02[E/30003[CX0
0`00[CZ]>P02[CX00`00[CZ]>P02[CX30003YCX00`00YCZU>P02YCX00`00YAZU6P02YAX40002Y?T0
0`00Y?VTn@03Y?T00`00Y?VTn@02Y?T01P00Y?T00000Y;P000FT^003002T^:Bh00:T^003002T^:Bh
00:T^003002T^:Bh00@001;oo`@008Coo`00]Ooo00<00?ooool06Ooo00<00:fl[K`00Zfl00<00:fl
[K`00`001Jfl00<00:fl[K`010001:fl00@00:fl[Kb]_0<000F]_003002]_:fl00@000>]_003002]
_:fl00:]_0@000>]_003002]_:fl00:]_0<000>]_003002]_:fl00:]_004002]_0000002[K`00`00
[Kb]_002[K`01000[Ib]W:fL0`001JfK00<00:fK[I/01@000jfK00<00:fK[I/00ZfK0`000jfK00<0
0:fK[I/00ZfK00<00:fK[I/00P0000>]V`00[I/00jfK00@00:ek[G^]N`D000>]N`05002]Njek[G/0
0002[G/200000jek002]N`04[G/01000[G^]Njek10000jeK00<00:eK[E/00ZeK00<00:eK[E/00P00
00>]FP00[CX00jdj00<00:dj[CX00Zdj00<00:dj[CX00P0000>U>P00YCX00jDj00<00:DjYCX00jDj
00H00:DJ00000:Ci0005Y?T00`00Y?VTn@02Y?T00`00Y?VTn@040004Y;P00`00Y;RT^002Y;P00`00
Y;RT^003Y;P00`00Y;RT^004000Cool30028ool00;Koo`8001Woo`04002]_:fl[K`40003[K`20002
[K`40003[K`00`00[Kb]_002[K`40003[K`00`00[Kb]_002[K`30003[K`00`00[Kb]_002[K`01000
[K`000000Zfl00<00:fl[K`00Zfl00<00:fl[K`00P000Zfl00<00:fl[K`00Zfl00<00:fl[K`00`00
1Jfl00<00:fl[K`01@000jfK00<00:fK[I/00ZfK0`000jfK00<00:fK[I/00ZfK00<00:fK[I/00P00
00>]V`00[I/01:fK00<00:fK[I/010001:fK00@00:fK[I^]V`@000>]N`03002]Njek00:]N`03002]
Njek00@000B]N`03002]Njek00:]N`@000:]F`03002]FjeK00:]F`04002]FjeK[E/40004[EX00`00
[CZ]>P02[CX00`00[CZ]>P040004YCX00`00YCZU>P02YCX00`00YCZU>P040004Y?T00`00Y?VTn@02
Y?T00`00Y?VTn@02Y?T30003Y;P00`00Y;RT^002Y;P00`00Y;RT^002Y;P00`00Y;RT^002Y;P4000C
ool4002;ool00;Soo`03003ooooo01Ooo`<000>]_003002]_:fl00:]_0<000>]_003002]_:fl00:]
_004002]_0000002[K`00`00[Kb]_002[K`00`00[Kb]_0020002[K`00`00[Kb]_002[K`00`00[Kb]
_0030005[K`00`00[Kb]_0040004[K`01000[Kb]_:fl10000jfl00<00:fl[K`00Zfl0`000jfK00<0
0:fK[I/00ZfK00<00:fK[I/00P000ZfK00<00:fK[I/00ZfK00<00:fK[I/010001:fK00<00:fK[I/0
0ZfK0`000jfK00<00:fK[I/00ZfK00@00:fK000000:]N`03002]Njek00:]N`04002]Njek[G/40003
[G/00`00[G^]N`02[G/00`00[G^]N`0200000jeK002]F`04[E/01000[E^]FjeK10000ZeJ00<00:eJ
[EX00jeJ00@00:dj[CZ]>P@000:U>P03002U>ZDj00>U>P04002U>ZDjYCX40003Y?T00`00Y?VTn@02
Y?T00`00Y?VTn@03Y?T01P00Y?T00000Y;P000BT^003002T^:Bh00:T^003002T^:Bh00>T^004002T
^000000Cool4002?ool00;Woo`03003ooooo01Ooo`03002]_:fl00:]_003002]_:fl008000:]_003
002]_:fl00:]_003002]_:fl00<000F]_003002]_:fl00@000B]_004002]_:fl[K`40003[K`00`00
[Kb]_002[K`30003[K`00`00[Kb]_002[K`40003[K`00`00[Kb]_002[K`01000[K`000000ZfL00<0
0:fK[I/00ZfK00<00:fK[I/010001:fK00@00:fK[I^]V`@000>]V`03002]VjfK00:]V`03002]VjfK
008000:]V`05002]VjfK[I/00003[I/30004[G/00`00[G^]N`02[G/40003[G/00`00[G^]N`02[G/0
0`00[G^]N`040004[E/00`00[E^]F`02[E/01000[E/000000ZeJ00<00:eJ[EX00ZeJ00<00:eJ[EX0
0ZeJ10000ZDj00<00:DjYCX00ZDj00<00:DjYCX00ZDj10000ZCi00<00:CiY?T00ZCi00<00:CiY?T0
0jCi00<00:CiY?T010001:Bh00<00:BhY;P00ZBh00<00:BhY;P00ZBh00<00:BhY;P010004Ooo1000
Tooo002jool00`00ooooo`0Gool00`00[Kb]_0040004[K`01000[Kb]_:fl10000jfl0P000Zfl1000
0jfl00<00:fl[K`00Zfl10000jfl00<00:fl[K`00Zfl00@00:fl000000:]_003002]_:fl00:]_004
002]_0000002[K`00`00[Kb]_002[K`01000[Kb]_:fl0`001:fL00@00:fK[I^]V`@000>]V`03002]
VjfK00:]V`@000>]V`03002]VjfK00:]V`03002]VjfK00@000B]V`03002]VjfK00D000>]N`03002]
Njek00:]N`04002]N`000002[G/00`00[G^]N`02[G/01000[G^]Njek10000jeK00<00:eK[E/00ZeK
00@00:eK[E^]F`<000B]FP03002]FZeJ00:]FP03002]FZeJ00800003YCX00:Dj00BU>P05002U>ZDj
YCX00002YCX200000jCi002Tn@04Y?T00`00Y?VTn@02Y?T00`00Y?VTn@050002Y;P00`00Y;RT^003
Y;P00`00Y;RT^002Y;P00`00Y;RT^005000Aool4002Gool00;_oo`03003ooooo01Ooo`8000>]_003
002]_:fl00:]_0@000>]_003002]_:fl00:]_0<000>]_003002]_:fl00:]_004002]_0000002[K`0
0`00[Kb]_002[K`01000[Kb]_:fl0`001:fl00@00:fl[Kb]_0<000F]_003002]_:fl00D000>]W004
002]W:fL[I`40003[I/00`00[I^]V`02[I/01000[I/000000ZfK00<00:fK[I/00ZfK00@00:fK[I^]
V`@000>]V`03002]VjfK00:]V`<000>]N`03002]Njek00:]N`04002]Njek[G/30004[G/00`00[G^]
N`02[G/40002[E/00`00[E^]F`03[E/00`00[E^]F`050003[EX00`00[EZ]FP02[EX00`00[EZ]FP04
0004YCX00`00YCZU>P02YCX00`00YCZU>P040004Y?T00`00Y?VTn@02Y?T00`00Y?VTn@02Y?T30003
Y;P00`00Y;RT^002Y;P00`00Y;RT^002Y;P00`00Y;RT^002Y;P3000Cool3002Kool00;coo`8001So
o`03002]_:fl00:]_004002]_0000002[K`00`00[Kb]_002[K`00`00[Kb]_0020002[K`00`00[Kb]
_002[K`00`00[Kb]_0030005[K`00`00[Kb]_0050003[K`00`00[Kb]_0050003[K`00`00[Kb]_002
[K`30003[I`00`00[Ib]W002[I`01000[I`000000ZfK00<00:fK[I/00ZfK00@00:fK[I^]V`<000B]
V`03002]VjfK00:]V`@000>]V`03002]VjfK00:]V`06002]V`00002]N`001Jek00<00:ek[G/01@00
0jek00<00:ek[G/00Zek00@00:ek000000:]F`03002]FjeK00:]F`03002]FjeK00:]F`<000>]FP03
002]FZeJ00:]FP04002]FZeJ[EX40003YCX00`00YCZU>P02YCX01000YCZU>ZDj10000jDI00<00:Ci
Y?T00ZCi00<00:CiY?T00jCi00H00:Ci00000:Bh0004Y;P00`00Y;RT^002Y;P00`00Y;RT^003Y;P0
1000Y;P000004_oo1000W_oo002nool00`00ooooo`0Fool00`00[Kb]_0030005[K`00`00[Kb]_004
0004[K`01000[Kb]_:fl10000jfl00<00:fl[K`00Zfl0`000jfl00<00:fl[K`00Zfl0`000jfl00<0
0:fl[K`00Zfl00<00:fl[K`00P000ZfL00<00:fL[I`00ZfL00<00:fL[I`00`001:fK00<00:fK[I/0
0ZfK10000jfK00<00:fK[I/00ZfK00@00:fK000000:]V`03002]VjfK00:]V`04002]VjfK[I/30004
[G/00`00[G^]N`02[G/30003[G/00`00[G^]N`02[G/01000[G^]Njek0`001:eK00<00:eK[E/00ZeK
00<00:eK[E/00P0000>]FP00[EX00jeJ00<00:eJ[EX00ZeJ10000ZDj00<00:DjYCX00ZDj00<00:Dj
YCX00ZDj10000ZDI00<00:DIYAT00ZDI00<00:CiY?T00jCi00<00:CiY?T010001:Bh00<00:BhY;P0
0ZBh00<00:BhY;P00ZBh00<00:BhY;P010004?oo1000X_oo002oool00`00ooooo`0Fool20003[K`2
0002[K`40003[K`00`00[Kb]_002[K`40003[K`01@00[Kb]_:fl00000Zfl0P000Zfl00<00:fl[K`0
0Zfl00@00:fl000000:]_003002]_:fl00:]_003002]_:fl00@000B]W004002]W:fL[I`40003[I/0
0`00[I^]V`02[I/01000[I/000000ZfK00<00:fK[I/00ZfK00@00:fK[I^]V`<000B]V`03002]VjfK
00:]V`@000>]N`05002]Njek[G/00002[G/200000jek002]N`03[G/00`00[G^]N`02[G/40003[E/0
0`00[E^]F`02[E/00`00[E^]F`040004[EX00`00[EZ]FP02[EX01000[EX000000ZDj00<00:DjYCX0
0ZDj00<00:DjYCX00ZDj00@00:Dj000000:U6P03002U6JDI00:U6@03002U6JDI00:U6@03002TnJCi
00D000:T^@03002T^:Bh00>T^003002T^:Bh00:T^003002T^:Bh00D0013oo`@00:Koo`00`?oo00<0
0?ooool05_oo00<00:fl[K`00Zfl0`000jfl00<00:fl[K`00Zfl00@00:fl000000:]_003002]_:fl
00:]_003002]_:fl00@000B]_004002]_:fl[K`30005[K`00`00[Kb]_0040003[I`00`00[Ib]W002
[I`40003[I/00`00[I^]V`02[I/00`00[I^]V`030005[I/00`00[I^]V`050003[I/00`00[I^]V`02
[I/01000[I/000000Zek00<00:ek[G/00Zek00<00:ek[G/010001:ek00<00:ek[G/00Zek00@00:ek
000000:]N`03002]FjeK00:]F`04002]FjeK[E/40003[EX00`00[EZ]FP02[EX01000[EZ]FZeJ0`00
1:Dj00<00:DjYCX00ZDj00@00:DjYCZU>P<000BU6P03002U6JDI00:U6@03002U6JDI00:U6@<000>T
f@03002T^JBi00:T^@03002T^:Bh00:T^003002T^:Bh00:T^0<0017oo`@00:[oo`00`Ooo0P005_oo
00<00:fl[K`00P000Zfl00<00:fl[K`00Zfl00<00:fl[K`00`001Jfl00<00:fl[K`010000jfl0P00
0Zfl1@000jfl00<00:fl[K`00Zfl0`000jfL00<00:fL[I`00ZfL00@00:fL000000:]V`03002]VjfK
00:]V`04002]VjfK[I/40003[I/00`00[I^]V`02[I/30003[I/00`00[I^]V`02[I/01000[I^]VjfK
0`001Jek00<00:ek[G/010000jek00<00:ek[G/00Zek00@00:ek[G^]N`<000B]N`03002]FjeK00:]
F`@000:]FP03002]FZeJ00>]FP03002]FZeJ00D000:U>P03002U>ZDj00>U>P03002U>ZDj00D000:U
6P03002U6ZDJ00>U6P03002U6JDI00:U6@06002U6@00002Tf@001:CI00<00:BiY;T00ZBi00<00:Bh
Y;P00jBh00@00:Bh0000017oo`<00:koo`00`ooo00<00?ooool05?oo0P001:fl00@00:fl[Kb]_0@0
00>]_003002]_:fl00:]_0<000>]_003002]_:fl00:]_0<000>]_003002]_:fl00:]_003002]_:fl
008000:]_003002]W:fL00:]W003002]W:fL00<000B]V`03002]VjfK00:]V`@000>]V`05002]VjfK
[I/00002[I/200000jfK002]V`04[I/00`00[I^]V`050003[G/00`00[G^]N`02[G/30002[G/00`00
[G^]N`03[G/00`00[G^]N`050003[G/00`00[G^]N`02[G/01000[E/000000ZeK00<00:eJ[EX00ZeJ
00<00:eJ[EX00ZeJ0`000ZDj00<00:DjYCX00jDj00<00:DjYCX00ZDj0`000ZDJ00<00:DJYAX00jDJ
00<00:DJYAX00ZDJ00<00:DIYAT010001:CI00<00:CIY=T00ZCI00<00:BiY;T00ZBi00<00:BhY;P0
10003ooo1000/Ooo0034ool00`00ooooo`0Dool00`00[Kb]_002[K`40003[K`00`00[Kb]_002[K`0
1000[K`000000Zfl00<00:fl[K`00Zfl00@00:fl000000:]_003002]_:fl00:]_003002]_:fl00@0
00B]_004002]W:fL[I`40003[I`00`00[I^]V`02[I/01000[I/000000ZfK00<00:fK[I/00ZfK00<0
0:fK[I/010001:fK00<00:fK[I/00ZfK0`000jek00<00:ek[G/00Zek00<00:ek[G/00P0000>]N`00
[G/00jek00<00:ek[G/00Zek0`000jek00<00:ek[G/00Zek00@00:ek[G^]N`<000B]F`03002]FZeJ
00:]FP03002]FZeJ00800003YCX00:Dj00>U>P03002U>ZDj00:U>P03002U>ZDj00800003YAX00:DJ
00>U6P03002U6ZDJ00:U6P04002U6ZDJYAX40003Y=T00`00Y=VTf@02Y=T00`00Y=VTf@02Y=T00`00
Y;VT^@05000?ool4002eool00<Goo`03003ooooo01Coo`04002]_0000002[K`00`00[Kb]_002[K`0
1000[Kb]_:fl0`001:fl00@00:fl[Kb]_0<000F]_003002]_:fl00@000>]_003002]_:fl00:]_0@0
00>]W005002]W:fL[I`00003[I/30005[I/00`00[I^]V`040003[I/00`00[I^]V`02[I/00`00[I^]
V`020002[G/00`00[G^]N`02[G/00`00[G^]N`040004[G/01@00[G^]Njek00000Zek0P0000>]N`00
[G/01:ek00<00:ek[G/01@000jeK00<00:eK[E/00ZeK00<00:eJ[EX010001:Dj00D00:DjYCZU>P00
00>U>P@000BU6P05002U6ZDJYAX00004YAX40002Y=T00`00Y=VTf@02Y=T00`00Y=VTf@02Y=T00`00
Y=VTf@02Y=T3000@ool4002iool00<Koo`8001Goo`03002]_:fl00>]_003002]_:fl00D000>]_003
002]_:fl00D000>]_003002]_:fl00:]_0<000>]_003002]_:fl00:]_004002]_0000002[I`00`00
[Ib]W002[I`00`00[Ib]W0050003[I/00`00[I^]V`02[I/30003[I/00`00[I^]V`02[I/00`00[I^]
V`040004[G/01000[G^]Njek10000jek00<00:ek[G/00Zek00<00:ek[G/010001:ek00<00:ek[G/0
0Zek0`000jeK00<00:eK[E/00ZeK00@00:eK[E^]F`@000:U>P03002U>ZDj00>U>P03002U>ZDj00D0
00:U6P03002U6ZDJ00>U6P03002U6ZDJ00:U6P06002U6P00002Tf@001JCI00<00:CIY=T00ZCI00<0
0:CIY=T00ZCI00@00:CI000000ooo`@00;goo`00b?oo00<00?ooool04ooo0P000Zfl10000jfl00<0
0:fl[K`00Zfl0`000jfl00<00:fl[K`00Zfl00<00:fl[K`00P000Zfl00<00:fl[K`00Zfl00<00:fl
[K`00`001JfL00<00:fL[I`010000jfK00<00:fK[I/00ZfK00<00:fK[I/00P000ZfK00<00:fK[I/0
0ZfK00<00:fK[I/010000jfK00<00:ek[G/00Zek10000jek00D00:ek[G^]N`0000>]N`@000>]N`03
002]Njek00:]N`03002]Njek00800003[E/00:eK00>]F`03002]FjeK00:]F`@000:U>P03002U>ZDj
00:U>P03002U>ZDj00:U>P<000>U6P03002U6ZDJ00:U6P03002U6ZDJ00>U6P03002U6P0000<000BT
f@03002TfJCI00:Tf@03002TfJCI00:Tf@03002TfJCI00@000koo`<00<7oo`00bOoo00<00?ooool0
5?oo0P000jfl00<00:fl[K`00Zfl00@00:fl000000:]_003002]_:fl00:]_003002]_:fl00@000B]
_004002]_:fl[K`40003[I`00`00[Ib]W002[I`30003[I/00`00[I^]V`02[I/00`00[I^]V`040004
[I/01000[I^]VjfK10000jfK00<00:fK[I/00ZfK00@00:ek000000:]N`03002]Njek00:]N`03002]
Njek00D000>]N`03002]Njek00:]N`03002]Njek00@000B]F`03002]FjeK00:]F`06002]F`00002U
>P001JDj00D00:DjYCZU>P0000:U>P800003YAX00:DJ00>U6P03002U6ZDJ00:U6P04002U6ZDJYAX4
0003Y=T00`00Y=VTf@02Y=T00`00Y=VTf@03Y=T00`00Y=VTf@04000>ool40034ool00<[oo`03003o
oooo01Coo`03002]_:fl00:]_003002]_:fl00<000F]_003002]_:fl00@000>]_003002]_:fl00:]
_0@000>]W005002]W:fL[I`00002[I`200000jfK002]V`04[I/00`00[I^]V`040003[I/00`00[I^]
V`02[I/40003[I/01@00[I^]VjfK00000jfK0`001:ek00<00:ek[G/00Zek0`000jek00<00:ek[G/0
0Zek00@00:ek[G^]N`@000>]F`03002]FjeK00:]F`04002]FjeK[E/30004YCX00`00YCZU>P02YCX0
0`00YCZU>P040004YAX00`00YAZU6P02YAX00`00YAZU6P050002Y=T00`00Y=VTf@02Y=T00`00Y=VT
f@03Y=T00`00Y=VTf@05000>ool40038ool00<_oo`8001Coo`04002]_:fl[K`40003[K`00`00[Kb]
_002[K`30003[K`00`00[Kb]_002[K`01000[K`000000ZfL00<00:fL[I`00ZfL00<00:fL[I`01000
1:fK00<00:fK[I/00ZfK0`000jfK00<00:fK[I/00ZfK00@00:fK000000:]V`03002]VjfK00:]V`03
002]VjfK00D000>]N`03002]Njek00:]N`06002]N`00002]N`001:ek00<00:ek[G/00Zek10000ZEK
00<00:eK[E/00jeK00<00:eK[E/01@000ZDj00<00:DjYCX00ZDj00@00:DjYCZU>P@000>U6P03002U
6ZDJ00:U6P03002U6ZDJ00:U6P<000>Tf@03002TfJCI00:Tf@03002TfJCI00:Tf@04002TfJCIY=T4
000?ool4003<ool00<goo`03003ooooo01;oo`<000>]_005002]_:fl[K`00002[K`20002[K`00`00
[Kb]_002[K`00`00[Kb]_0030005[I`00`00[Ib]W0040003[I/00`00[I^]V`02[I/00`00[I^]V`02
0002[I/01@00[I^]VjfK00000jfK0`001:fK00<00:fK[I/00ZfK0`000jek00<00:ek[G/00Zek00@0
0:ek[G^]N`<000B]N`03002]Njek00:]N`04002]N`000002YE/00`00YE^UF`02YE/00`00[E^]F`02
[E/30002YCX00`00YCZU>P03YCX01000YCZU>ZDj10000ZDJ00<00:DJYAX00ZDJ00<00:DJYAX00jDJ
00H00:DJ00000:CI0004Y=T00`00Y=VTf@02Y=T00`00Y=VTf@02Y=T01000Y=T000003ooo1000d?oo
003>ool00`00ooooo`0Bool00`00[Kb]_002[K`00`00[Kb]_0040004[K`01000[Kb]_:fl10000jfL
00<00:fL[I`00ZfL0`000jfK00<00:fK[I/00ZfK00<00:fK[I/010001:fK00<00:fK[I/01@000jfK
00<00:fK[I/00ZfK00H00:fK00000:ek0005[G/00`00[G^]N`050003[G/01@00[G^]Njek00000jek
0`001:EK00<00:EKYE/00ZEK00<00:eK[E/00P0000>U>P00YCX00jDj00<00:DjYCX00ZDj00@00:Dj
000000:U6P03002U6ZDJ00:U6P03002U6ZDJ00:U6P03002U6ZDJ00@000BTf@03002TfJCI00:Tf@03
002TfJCI00:Tf@03002TfJCI00<000koo`<00=Coo`00cooo00<00?ooool04_oo00<00:fl[K`01000
0jfl00<00:fl[K`00Zfl10000jfL00D00:fL[Ib]W00000:]W08000:]W003002]VjfK00:]V`03002]
VjfK00@000>]V`03002]VjfK00:]V`<000>]V`03002]VjfK00:]V`04002]VjfK[I/30004[G/00`00
[G^]N`02[G/30003[G/00`00[G^]N`02[G/00`00[G^]N`050003YE/00`00YE^UF`02YE/00`00YE^U
F`040004YCX01@00YCZU>ZDj00000jDj0`001:DJ00<00:DJYAX00ZDJ00@00:DJYAZU6P@000>Tf@03
002TfJCI00:Tf@03002TfJCI00:Tf@03002TfJCI00D000goo`@00=Ooo`00d?oo0P004ooo0P000jfl
00<00:fl[K`00Zfl00@00:fl000000:]W003002]W:fL00:]W003002]W:fL00@000B]W004002]VjfK
[I/40003[I/00`00[I^]V`02[I/01000[I/000000ZfK00<00:fK[I/00ZfK00<00:fK[I/01@000jek
00D00:ek[G^]N`0000:]N`800003[G/00:ek00B]N`03002]Njek00@000>UF`03002UFjEK00:UF`04
002UFjEKYE/40003YCX00`00YCZU>P02YCX00`00YCZU>P050002YAX00`00YAZU6P03YAX00`00YAZU
6P050002Y=T00`00Y=VTf@02Y=T00`00Y=VTf@03Y=T00`00Y=VTf@04000>ool4003Kool00=;oo`03
003ooooo017oo`03002]_:fl00:]_003002]_:fl00<000F]W003002]W:fL00@000>]W003002]W:fL
00:]W0@000>]V`05002]VjfK[I/00003[I/30005[I/00`00[I^]V`040003[G/00`00[G^]N`02[G/0
0`00[G^]N`040004[G/00`00[G^]N`02[G/30002YE/00`00YE^UF`03YE/00`00YE^UF`050002YCX0
0`00YCZU>P03YCX00`00YCZU>P040003YAX00`00YAZU6P02YAX00`00YAZU6P02YAX30003Y=T00`00
Y=VTf@02Y=T00`00Y=VTf@02Y=T01000Y=VTfJCI10003_oo1000gooo003Cool00`00ooooo`0@ool0
1000[Kb]_:fl10000jfL0P000ZfL10000jfL00<00:fL[I`00ZfL00@00:fL000000:]V`03002]VjfK
00:]V`03002]VjfK00D000>]V`03002]VjfK00:]V`<000>]N`03002]Njek00:]N`03002]Njek00@0
00>]N`03002]Njek00:]N`03002]Njek00800003YE/00:EK00>UF`03002UFjEK00:UF`<000>U>P03
002U>ZDj00:U>P03002U>ZDj00:U>P<000:U6P03002U6ZDJ00:U6P03002U6ZDJ00:U6P03002U6ZDJ
00800003Y=T00:CI00>Tf@03002TfJCI00:Tf@03002TfJCI00:Tf@04002Tf@00000>ool4003Sool0
0=Coo`03003ooooo013oo`<000>]_003002]W:fL00:]W0<000>]W003002]W:fL00:]W003002]W:fL
00<000F]V`03002]VjfK00@000>]V`03002]VjfK00:]V`03002]VjfK00800003[G/00:ek00>]N`04
002]Njek[G/40003[G/00`00[G^]N`02[G/00`00[G^]N`040004YE/01@00YE^UFjEK00000ZEK0P00
00>UFP00YCX00jDj00<00:DjYCX00ZDj00<00:DjYCX00P0000>U6P00YAX00jDJ00<00:DJYAX00ZDJ
00<00:DJYAX010001:CI00<00:CIY=T00ZCI00<00:CIY=T00ZCI00<00:CIY=T00`003Ooo0`00iooo
003Eool2000Aool00`00[Kb]_002[K`00`00[Ib]W0020002[I`01@00[Ib]W:fL00000jfL10000jfK
00<00:fK[I/00ZfK0`000jfK00<00:fK[I/00ZfK00<00:fK[I/010001:ek00@00:ek[G^]N`@000>]
N`03002]Njek00:]N`03002]Njek00@000>UF`03002UFjEK00:UF`03002UFjEK00@000BUFP03002U
>ZDj00:U>P03002U>ZDj00@000BU6P05002U6ZDJYAX00003YAX40003Y=T00`00Y=VTf@02Y=T00`00
Y=VTf@02Y=T00`00Y=VTf@05000<ool4003Zool00=Ooo`03003ooooo00ooo`03002]_:fl00@000B]
W003002]W:fL00D000>]V`05002]VjfK[I/00002[I/200000jfK002]V`04[I/00`00[I^]V`040003
[G/00`00[G^]N`02[G/01000[G/000000Zek00<00:ek[G/00Zek00@00:ek[G^]N`@000>UF`03002U
FjEK00:UF`03002UFjEK00@000>UFP03002UFZEJ00:UFP04002U>ZDjYCX40003YAX00`00YAZU6P02
YAX00`00YAZU6P050002Y=T00`00Y=VTf@02Y=T00`00Y=VTf@03Y=T00`00Y=VTf@04000=ool4003^
ool00=Soo`03003ooooo00ooo`8000>]W003002]W:fL00:]W0<000>]V`03002]VjfK00:]V`03002]
VjfK00@000B]V`03002]VjfK00:]V`<000>]N`03002]Njek00:]N`03002]Njek00<000B]N`03002]
Njek00:]N`@000:UF`03002UFjEK00:UF`04002UFjEKYE/40003YEX00`00YEZUFP02YEX00`00YEZU
FP050002YAX00`00YAZU6P02YAX00`00YAZU6P02YAX30003Y=T00`00Y=VTf@02Y=T00`00Y=VTf@02
Y=T01000Y=VTfJCI10003Ooo1000l_oo003Iool00`00ooooo`0?ool00`00[Ib]W002[I`01000[I`0
00000ZfK00<00:fK[I/00ZfK00<00:fK[I/010000jfK00<00:fK[I/00ZfK00<00:fK[I/00P000Zek
00D00:ek[G^]N`0000>]N`@000>]N`03002]Njek00:]N`04002]N`000002YE/00`00YE^UF`02YE/0
1000YE^UFjEK10000ZEJ00<00:EJYEX00ZEJ00<00:EJYEX00ZEJ0`000jDj00<00:DJYAX00ZDJ00<0
0:DJYAX00ZDJ00H00:DJ00000:Ci0004Y=T00`00Y=VTf@02Y=T00`00Y=VTf@02Y=T01000Y=T00000
3Ooo1000m_oo003Jool2000@ool00`00[Ib]W0030005[I/00`00[I^]V`040003[I/00`00[I^]V`02
[I/00`00[I^]V`040004[G/00`00[G^]N`050003[G/00`00[G^]N`02[G/00`00[G^]N`030004YE/0
0`00YE^UF`02YE/01000YE/000000ZEJ00<00:EJYEX00ZEJ00<00:EJYEX00ZEJ00H00:EJ00000:Dj
0004YCX00`00YAZU6P02YAX01000YAZU6ZDJ0`001:Ci00<00:CIY=T00ZCI00<00:CIY=T00ZCI00<0
0:CIY=T00`003?oo0`00n_oo003Lool00`00ooooo`0>ool20003[I/00`00[I^]V`02[I/30003[I/0
0`00[I^]V`02[I/00`00[I^]V`040003[G/00`00[G^]N`02[G/30003[G/00`00[G^]N`02[G/01000
[G^]Njek10000jEK00<00:EKYE/00ZEK00<00:EKYE/00`001:EJ00<00:EJYEX00ZEJ00@00:EJYEZU
FP<000BU>P03002U>ZDj00:U>P03002U6ZDJ00D000:Tn@03002TnJCi00:Tn@03002TfJCI00:Tf@03
002TfJCI00D000_oo`@00?goo`00gOoo00<00?ooool03_oo00D00:fK[I^]V`0000:]V`800003[I/0
0:fK00>]V`04002]VjfK[I/40003[I/00`00[G^]N`02[G/01000[G/000000Zek00<00:ek[G/00Zek
00<00:ek[G/01@000jEk00D00:EKYE^UF`0000>UF`@000>UFP03002UFZEJ00:UFP03002UFZEJ00D0
00:U>P03002U>ZDj00:U>P04002U>ZDjYCX40002Y?T00`00Y?VTn@03Y?T00`00Y?VTn@02Y?T00`00
Y=VTf@04000<ool4003oool2ool00=koo`03003ooooo00goo`03002]VjfK00@000B]V`04002]VjfK
[I/40003[I/00`00[I^]V`02[I/00`00[G^]N`030004[G/00`00[G^]N`02[G/30003YG/00`00YG^U
N`02YG/00`00YE^UF`050002YE/00`00YEZUFP02YEX01000YEZUFZEJ10000jDj00<00:DjYCX00ZDj
00@00:DjYCZU>P@000:Tn@03002TnJCi00:Tn@03002TnJCi00:Tn@03002TnJCi00D000coo`@00?oo
o`Koo`00gooo0P003_oo0P000jfK00<00:fK[I/00ZfK00@00:fK000000:]V`03002]VjfK00:]V`04
002]VjfK[I/40003YG/00`00[G^]N`02[G/01P00[G/00000YG/000BUN`03002UNjEk00:UN`<000>U
F`03002UFjEK00:UF`04002UFZEJYEX40002YCX00`00YCZU>P02YCX00`00YCZU>P02YCX01000YCX0
00000ZCi00<00:CiY?T00ZCi00D00:CiY?VTn@0000BTn@<000goo`@00?ooo`[oo`00hOoo00<00?oo
ool03?oo00<00:fK[I/00ZfK00<00:fK[I/00`001JfK00<00:fK[I/01@000jEk00D00:EkYG^UN`00
00>]N`<000BUN`03002UNjEk00:UN`06002UN`00002UF`001:EK00<00:EKYE/00ZEK00@00:EJ0000
00:U>P03002U>ZDj00:U>P03002U>ZDj00:U>P03002U>ZDj00<000BTn@03002TnJCi00:Tn@03002T
nJCi00:Tn@04002Tn@00000=ool3003oool>ool00>;oo`03003ooooo00coo`03002]VjfK00@000>]
V`03002]VjfK00:]V`<000>UN`03002UNjEk00:UN`03002UNjEk00D000>UN`05002UNjEkYG/00003
YG/30004YE/00`00YE^UF`02YE/00`00YE^UF`030004YCX00`00YCZU>P02YCX01000YCZU>ZDj1000
0ZCi00<00:CiY?T00jCi00<00:CiY?T00ZCi00<00:Ci00000`002ooo1000oooo4Ooo003Sool00`00
ooooo`0<ool20003[I/00`00[I^]V`02[I/01P00[I/00000YG/000FUN`03002UNjEk00@000>UN`03
002UNjEk00:UN`03002UNjEk00D000>UF`05002UFjEKYE/00003YE/40003YCX00`00YCZU>P02YCX0
0`00YCZU>P050002Y?T00`00Y?VTn@02Y?T00`00Y?VTn@02Y?T00`00Y?VTn@04000;ool4003ooolE
ool00>Coo`8000goo`05002]VjfK[I/00003[I/30004YG/00`00YG^UN`02YG/30003YG/00`00YG^U
N`02YG/00`00YG^UN`040003YE/00`00YE^UF`02YE/00`00YE^UF`050002YCX00`00YCZU>P02YCX0
1000YCZU>ZDj10000jCi00<00:CiY?T00ZCi00D00:CiY?VTn@0000>Tn@@000_oo`@00?oooaWoo`00
i_oo00<00?ooool02_oo00<00:fK[I/01@000jEk00D00:EkYG^UN`0000:UN`800003YG/00:Ek00>U
N`04002UNjEkYG/40002YE/00`00YE^UF`03YE/00`00YE^UF`040003YCX00`00YCZU>P02YCX01000
YCZU>ZDj10000ZCi00<00:CiY?T00ZCi00<00:CiY?T00ZCi00<00:CiY?T01@002ooo1000oooo7Ooo
003Wool00`00ooooo`0:ool20003YG/00`00YG^UN`02YG/00`00YG^UN`040004YG/01000YG^UNjEk
10000ZEK00<00:EKYE/00ZEK00<00:EKYE/00ZEK0`000jDj00D00:DjYCZU>P0000BU>P04002U>P00
0002Y?T00`00Y?VTn@02Y?T00`00Y?VTn@02Y?T01000Y?VTnJCi0`003?oo1000oooo8Ooo003Xool0
0`00ooooo`0:ool00`00YG^UN`02YG/00`00YG^UN`040003YG/00`00YG^UN`02YG/01000YG/00000
0ZEK00<00:EKYE/00ZEK00D00:EKYE^UF`0000:UF`800003YCX00:Dj00>U>P03002U>ZDj00:U>P03
002U>ZDj00<000BTn@03002TnJCi00:Tn@03002TnJCi00:Tn@04002Tn@00000<ool3003ooolUool0
0>Woo`03003ooooo00[oo`03002UNjEk00@000>UN`03002UNjEk00:UN`03002UNjEk00<000BUF`03
002UFjEK00:UF`03002UFjEK00@000BU>P03002U>ZDj00:U>P03002U>ZDj00@000>Tn@03002TnJCi
00:Tn@03002TnJCi00:Tn@03002TnJCi00<000[oo`@00?ooobSoo`00j_oo0P002ooo0P000jEk00<0
0:EkYG/00ZEk00<00:EkYG/010000jEK00<00:EKYE/00ZEK00<00:EKYE/010000jDj00<00:DjYCX0
0ZDj00@00:DjYCZU>P@000:Tn@03002TnJCi00:Tn@03002TnJCi00:Tn@03002TnJCi00D000Woo`@0
0?ooobcoo`00k?oo00<00?ooool02Ooo00D00:EkYG^UN`0000>UN`@000>UF`03002UFjEK00:UF`03
002UFjEK00@000>U>P03002U>ZDj00:U>P03002U>ZDj00D000:Tn@03002TnJCi00:Tn@03002TnJCi
00:Tn@03002TnJCi00@000[oo`@00?oooc3oo`00kOoo00<00?ooool02?oo00<00:EkYG/01@000ZEK
00<00:EKYE/00ZEK00@00:EKYE^UF`@000:U>P03002U>ZDj00:U>P03002U>ZDj00:U>P<000>Tn@03
002TnJCi00:Tn@05002TnJCiY?T00003Y?T4000:ool4003oooldool00>koo`03003ooooo00Soo`80
00>UF`03002UFjEK00:UF`04002UFjEKYE/40002YCX00`00YCZU>P02YCX00`00YCZU>P02YCX01P00
YCX00000Y?T000BTn@03002TnJCi00:Tn@03002TnJCi00D000_oo`<00?ooocSoo`00kooo0P002Ooo
00D00:EKYE^UF`0000BUF`04002UF`000002YCX00`00YCZU>P02YCX01@00YCZU>ZDj00000jDj0`00
1:Ci00<00:CiY?T00ZCi00@00:CiY?VTn@<000coo`@00?oooc_oo`00lOoo00<00?ooool01_oo00<0
0:EKYE/00ZEK00<00:EKYE/00`001:Dj00<00:DjYCX00ZDj00<00:DjYCX01@000ZCi00<00:CiY?T0
0ZCi00<00:CiY?T00ZCi00@00:Ci000000_oo`@00?ooocooo`00l_oo00<00?ooool01_oo00<00:EK
YE/010000jDj00<00:DjYCX00ZDj00<00:DjYCX010000jCi00<00:CiY?T00ZCi00<00:CiY?T00ZCi
00<00:CiY?T00`002Ooo1000oooo@ooo003cool00`00ooooo`06ool20003YCX00`00YCZU>P02YCX0
0`00YCZU>P040003Y?T01@00Y?VTnJCi00001:Ci00<00:CiY?T01@002?oo1000ooooAooo003dool2
0006ool00`00YCZU>P02YCX01000YCZU>ZDj10000ZCi00<00:CiY?T00ZCi00<00:CiY?T00ZCi00<0
0:CiY?T010002_oo0`00ooooBooo003fool00`00ooooo`04ool01000YCZU>ZDj10000ZCi00<00:Ci
Y?T00ZCi00<00:CiY?T00ZCi00<00:CiY?T010002_oo1000ooooC_oo003gool00`00ooooo`03ool0
1000YCX000000ZCi00<00:CiY?T00ZCi00D00:CiY?VTn@0000>Tn@@000[oo`@00?oooe;oo`00n?oo
00<00?ooool00ooo00<00:CiY?T00ZCi00<00:CiY?T00ZCi00<00:CiY?T01@002_oo1000ooooE_oo
003iool20004ool00`00Y?VTn@02Y?T01000Y?VTnJCi0`002ooo1000ooooF_oo003kool01@00oooo
oooo00001:Ci00@00:Ci000000_oo`<00?oooekoo`00o?oo00D00?ooooooo`0000:Tn@<000Woo`@0
0?ooof7oo`00oOoo00@00?ooooooo`8000Soo`@00?ooofGoo`00o_oo0P0000?oo`00ool01?oo1000
ooooJOoo003oool1ool200000ooo00000002003ooom]ool00?ooo`;oo`800?ooog7oo`00\
\>"],
  ImageRangeCache->{{{0, 626.812}, {508.25, 0}} -> {-0.0197143, 0.0497475, \
0.0015512, 0.0015512}}],

Cell[BoxData[
    TagBox[
      RowBox[{
      "\[SkeletonIndicator]", "SurfaceGraphics", "\[SkeletonIndicator]"}],
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Options", "[", "Plot3D", "]"}]], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"AmbientLight", "\[Rule]", 
          RowBox[{"GrayLevel", "[", "0", "]"}]}], ",", 
        RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"Axes", "\[Rule]", "True"}], ",", 
        RowBox[{"AxesEdge", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"AxesLabel", "\[Rule]", "None"}], ",", 
        RowBox[{"AxesStyle", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"Background", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"Boxed", "\[Rule]", "True"}], ",", 
        RowBox[{"BoxRatios", "\[Rule]", 
          RowBox[{"{", 
            RowBox[{"1", ",", "1", ",", "0.4`"}], "}"}]}], ",", 
        RowBox[{"BoxStyle", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"ClipFill", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"ColorFunction", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}], ",", 
        RowBox[{"ColorOutput", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"Compiled", "\[Rule]", "True"}], ",", 
        RowBox[{"DefaultColor", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"DefaultFont", "\[RuleDelayed]", "$DefaultFont"}], ",", 
        RowBox[{"DisplayFunction", "\[RuleDelayed]", "$DisplayFunction"}], 
        ",", 
        RowBox[{"Epilog", "\[Rule]", 
          RowBox[{"{", "}"}]}], ",", 
        RowBox[{"FaceGrids", "\[Rule]", "None"}], ",", 
        RowBox[{"FormatType", "\[RuleDelayed]", "$FormatType"}], ",", 
        RowBox[{"HiddenSurface", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"Lighting", "\[Rule]", "True"}], ",", 
        RowBox[{"LightSources", "\[Rule]", 
          RowBox[{"{", 
            RowBox[{
              RowBox[{"{", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1.`", ",", "0.`", ",", "1.`"}], "}"}], ",", 
                  RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1.`", ",", "1.`", ",", "1.`"}], "}"}], ",", 
                  RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "1", ",", "0"}], "]"}]}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"0.`", ",", "1.`", ",", "1.`"}], "}"}], ",", 
                  RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "1"}], "]"}]}], "}"}]}], 
            "}"}]}], ",", 
        RowBox[{"Mesh", "\[Rule]", "True"}], ",", 
        RowBox[{"MeshStyle", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"Plot3Matrix", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"PlotLabel", "\[Rule]", "None"}], ",", 
        RowBox[{"PlotPoints", "\[Rule]", "25"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"PlotRegion", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"Prolog", "\[Rule]", 
          RowBox[{"{", "}"}]}], ",", 
        RowBox[{"Shading", "\[Rule]", "True"}], ",", 
        RowBox[{"SphericalRegion", "\[Rule]", "False"}], ",", 
        RowBox[{"TextStyle", "\[RuleDelayed]", "$TextStyle"}], ",", 
        RowBox[{"Ticks", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"ViewCenter", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"ViewPoint", "\[Rule]", 
          RowBox[{"{", 
            RowBox[{"1.3`", ",", 
              RowBox[{"-", "2.4`"}], ",", "2.`"}], "}"}]}], ",", 
        RowBox[{"ViewVertical", "\[Rule]", 
          RowBox[{"{", 
            RowBox[{"0.`", ",", "0.`", ",", "1.`"}], "}"}]}]}], 
      "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"?", "PlotPoints"}]], "Input"],

Cell[BoxData[
    RowBox[{"\<\"PlotPoints is an option for plotting functions that \
specifies how many sample points to use.\"\>", " ", 
      ButtonBox[
        StyleBox["More\[Ellipsis]",
          "SR"],
        ButtonData:>"PlotPoints",
        Active->True,
        ButtonStyle->"RefGuideLink"]}]], "Print",
  CellTags->"Info3278663005-6908846"]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
Evaluator->"psi",
WindowSize->{1012, 740},
WindowMargins->{{0, Automatic}, {Automatic, 0}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Info3278676956-4344008"->{
    Cell[15858, 467, 543, 12, 55, "Print",
      CellTags->"Info3278676956-4344008"]},
  "Info3278663005-6908846"->{
    Cell[1258516, 24703, 351, 9, 23, "Print",
      CellTags->"Info3278663005-6908846"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Info3278676956-4344008", 1259502, 24732},
  {"Info3278663005-6908846", 1259619, 24735}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 608, 18, 46, "Input"],
Cell[2350, 71, 479, 14, 46, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2866, 90, 430, 12, 64, "Input"],
Cell[3299, 104, 45, 0, 27, "Output"],
Cell[3347, 106, 149, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3533, 114, 430, 12, 64, "Input"],
Cell[3966, 128, 66, 1, 27, "Output"],
Cell[4035, 131, 45, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4117, 136, 955, 25, 77, "Input"],
Cell[5075, 163, 522, 14, 29, "Output"],
Cell[5600, 179, 128, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5765, 187, 1439, 41, 85, "Input"],
Cell[7207, 230, 31, 0, 27, "Output"],
Cell[7241, 232, 177, 5, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7455, 242, 609, 18, 46, "Input"],
Cell[8067, 262, 624, 18, 46, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8728, 285, 2056, 51, 125, "Input"],
Cell[10787, 338, 528, 14, 29, "Output"],
Cell[11318, 354, 188, 4, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11543, 363, 317, 9, 46, "Input"],
Cell[11863, 374, 73, 2, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11973, 381, 68, 1, 27, "Input"],
Cell[12044, 384, 3722, 75, 155, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15803, 464, 52, 1, 27, "Input"],
Cell[15858, 467, 543, 12, 55, "Print",
  CellTags->"Info3278676956-4344008"]
}, Open  ]],

Cell[CellGroupData[{
Cell[16438, 484, 1274, 33, 72, "Input"],
Cell[17715, 519, 330724, 6100, 455, 130983, 3630, "GraphicsData", \
"PostScript", "Graphics"],
Cell[348442, 6621, 163, 5, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[348642, 6631, 753, 19, 46, "Input"],
Cell[349398, 6652, 905026, 17953, 518, 507722, 13044, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1254427, 24607, 163, 5, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1254627, 24617, 68, 1, 27, "Input"],
Cell[1254698, 24620, 3722, 75, 155, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1258457, 24700, 56, 1, 27, "Input"],
Cell[1258516, 24703, 351, 9, 23, "Print",
  CellTags->"Info3278663005-6908846"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

