(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    326783,       7456]*)
(*NotebookOutlinePosition[    327878,       7490]*)
(*  CellTagsIndexPosition[    327834,       7486]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
  "Plot of ",
  Cell[BoxData[
      FormBox["f", TraditionalForm]]],
  " on ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{"[", 
            RowBox[{"0", ",", "1"}], "]"}], "\[Times]", 
          RowBox[{"[", 
            RowBox[{"0", ",", "1"}], "]"}]}], TraditionalForm]]],
  ":"
}], "Subsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"f", "[", 
          RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
        RowBox[{"If", "[", 
          RowBox[{
            RowBox[{
              RowBox[{"x", "\[GreaterEqual]", "0"}], "&&", 
              RowBox[{"x", "<", "1"}], "&&", 
              RowBox[{"y", "\[GreaterEqual]", 
                RowBox[{
                  RowBox[{"4", "x"}], "-", "3"}]}], "&&", 
              RowBox[{"y", "\[LessEqual]", "1"}]}], ",", 
            RowBox[{
              FractionBox[
                RowBox[{"y", "-", "1"}], 
                RowBox[{"2", 
                  RowBox[{"(", 
                    RowBox[{"x", "-", "1"}], ")"}]}]], "-", "1"}], ",", "1"}],
           "]"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"Plot3D", "[", 
        RowBox[{
          RowBox[{"f", "[", 
            RowBox[{"x", ",", "y"}], "]"}], ",", 
          RowBox[{"{", 
            RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
            RowBox[{"y", ",", "0", ",", "1"}], "}"}], ",", 
          RowBox[{"Shading", "\[Rule]", "False"}], ",", 
          RowBox[{"PlotPoints", "\[Rule]", "50"}], ",", 
          RowBox[{"AxesLabel", "\[Rule]", 
            RowBox[{"{", 
              RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<\>\""}], 
              "}"}]}], ",", 
          RowBox[{"ViewPoint", "->", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"-", "2.391"}], ",", " ", 
                RowBox[{"-", "1.883"}], ",", " ", "1.479"}], "}"}]}]}], "]"}],
       ";"}]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .69293 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% SurfaceGraphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-2.0112e-17 1.02277 -0.10921 1.02277 [
[.59197 -0.00531 0 -6.55267 ]
[.59197 -0.00531 6 2.44733 ]
[.68623 .06814 0 -6.4024 ]
[.68623 .06814 18 2.5976 ]
[.77195 .13493 0 -6.27263 ]
[.77195 .13493 18 2.72737 ]
[.85023 .19593 0 -6.15944 ]
[.85023 .19593 18 2.84056 ]
[.92201 .25186 0 -6.05983 ]
[.92201 .25186 18 2.94017 ]
[.98806 .30333 0 -5.97151 ]
[.98806 .30333 6 3.02849 ]
[.87169 .14335 0 -6.77517 ]
[.87169 .14335 10 3.03733 ]
[.58014 -0.01278 -3.04674 -9 ]
[.58014 -0.01278 2.95326 0 ]
[.45299 .04538 -8.88244 -9 ]
[.45299 .04538 9.11756 0 ]
[.33507 .09933 -8.6493 -9 ]
[.33507 .09933 9.3507 0 ]
[.22541 .1495 -8.43743 -9 ]
[.22541 .1495 9.56257 0 ]
[.12318 .19628 -8.24405 -9 ]
[.12318 .19628 9.75595 0 ]
[.02764 .23999 -2.68895 -9 ]
[.02764 .23999 3.31105 0 ]
[.28252 .06102 -4.7746 -9.8125 ]
[.28252 .06102 5.2879 0 ]
[.01432 .25269 -12 -6.7746 ]
[.01432 .25269 0 2.2254 ]
[.00818 .3111 -24 -6.66634 ]
[.00818 .3111 0 2.33366 ]
[.00188 .371 -6 -6.55589 ]
[.00188 .371 0 2.44411 ]
[-0.00457 .43242 -18 -6.44318 ]
[-0.00457 .43242 0 2.55682 ]
[-0.01118 .49544 -6 -6.32815 ]
[-0.01118 .49544 0 2.67185 ]
[ 0 0 0 0 ]
[ 1 .69293 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.58034 0 m
.97591 .3073 L
s
.58034 0 m
.57452 .00265 L
s
[(0)] .59197 -0.00531 -1 .45615 Mshowa
.67445 .07312 m
.66857 .0756 L
s
[(0.2)] .68623 .06814 -1 .42276 Mshowa
.76005 .13961 m
.7541 .14196 L
s
[(0.4)] .77195 .13493 -1 .39392 Mshowa
.83824 .20035 m
.83224 .20256 L
s
[(0.6)] .85023 .19593 -1 .36876 Mshowa
.90993 .25605 m
.90389 .25814 L
s
[(0.8)] .92201 .25186 -1 .34663 Mshowa
.97591 .3073 m
.96984 .30929 L
s
[(1)] .98806 .30333 -1 .327 Mshowa
.125 Mabswid
.60473 .01895 m
.60123 .02052 L
s
.62854 .03745 m
.62503 .03899 L
s
.65177 .05549 m
.64825 .05701 L
s
.69661 .09032 m
.69306 .09179 L
s
.71824 .10713 m
.71469 .10858 L
s
.73939 .12356 m
.73583 .12499 L
s
.78025 .15531 m
.77668 .15669 L
s
.80001 .17065 m
.79643 .17202 L
s
.81933 .18566 m
.81574 .18701 L
s
.85674 .21472 m
.85313 .21603 L
s
.87484 .22879 m
.87123 .23008 L
s
.89257 .24256 m
.88895 .24383 L
s
.92693 .26926 m
.9233 .2705 L
s
.94359 .2822 m
.93996 .28342 L
s
.95991 .29488 m
.95627 .29608 L
s
gsave
.87169 .14335 -61 -10.7752 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 17.8125 translate 1 -1 scale
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
69.000 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.58034 0 m
.02633 .25271 L
s
.58034 0 m
.58044 .00639 L
s
[(0)] .58014 -0.01278 .01558 1 Mshowa
.45282 .05817 m
.45274 .06456 L
s
[(0.2)] .45299 .04538 -0.01306 1 Mshowa
.33457 .11211 m
.33432 .11849 L
s
[(0.4)] .33507 .09933 -0.03897 1 Mshowa
.22462 .16226 m
.22422 .16864 L
s
[(0.6)] .22541 .1495 -0.06251 1 Mshowa
.12211 .20902 m
.12158 .21539 L
s
[(0.8)] .12318 .19628 -0.08399 1 Mshowa
.02633 .25271 m
.02567 .25907 L
s
[(1)] .02764 .23999 -0.10368 1 Mshowa
.125 Mabswid
.54753 .01497 m
.54756 .0188 L
s
.51535 .02964 m
.51536 .03348 L
s
.48379 .04404 m
.48376 .04788 L
s
.42243 .07203 m
.42235 .07586 L
s
.3926 .08564 m
.3925 .08947 L
s
.36332 .09899 m
.36319 .10283 L
s
.30634 .12498 m
.30617 .12882 L
s
.27861 .13763 m
.27842 .14146 L
s
.25138 .15006 m
.25116 .15388 L
s
.19832 .17426 m
.19806 .17808 L
s
.17248 .18604 m
.1722 .18987 L
s
.14708 .19763 m
.14678 .20145 L
s
.09756 .22022 m
.09722 .22404 L
s
.07342 .23123 m
.07306 .23505 L
s
.04968 .24206 m
.0493 .24588 L
s
gsave
.28252 .06102 -65.7746 -13.8125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 17.8125 translate 1 -1 scale
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.062 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(y) show
69.062 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.02633 .25271 m
0 .50662 L
s
.02573 .25845 m
.03144 .26134 L
s
[(-1)] .01432 .25269 1 .50547 Mshowa
.0197 .31665 m
.02546 .31942 L
s
[(-0.5)] .00818 .3111 1 .48141 Mshowa
.01351 .37631 m
.01933 .37897 L
s
[(0)] .00188 .371 1 .45686 Mshowa
.00717 .43749 m
.01304 .44003 L
s
[(0.5)] -0.00457 .43242 1 .43182 Mshowa
.00066 .50025 m
.00658 .50266 L
s
[(1)] -0.01118 .49544 1 .40625 Mshowa
.125 Mabswid
.02454 .26998 m
.02797 .27169 L
s
.02334 .28156 m
.02677 .28326 L
s
.02213 .2932 m
.02557 .29489 L
s
.02092 .30489 m
.02436 .30657 L
s
.01847 .32846 m
.02193 .33011 L
s
.01724 .34034 m
.02071 .34197 L
s
.016 .35227 m
.01948 .35389 L
s
.01476 .36426 m
.01824 .36587 L
s
.01225 .38842 m
.01575 .39 L
s
.01099 .4006 m
.01449 .40216 L
s
.00972 .41283 m
.01323 .41438 L
s
.00845 .42513 m
.01196 .42667 L
s
.00588 .44992 m
.00941 .45142 L
s
.00458 .4624 m
.00812 .46389 L
s
.00328 .47496 m
.00682 .47643 L
s
.00197 .48757 m
.00552 .48903 L
s
.25 Mabswid
.58034 0 m
.58486 .29035 L
s
.58486 .29035 m
0 .50662 L
s
0 .50662 m
.02633 .25271 L
s
.02633 .25271 m
.58034 0 L
s
.97591 .3073 m
.46366 .47481 L
s
.46366 .47481 m
.46154 .69293 L
s
.46154 .69293 m
1 .55274 L
s
1 .55274 m
.97591 .3073 L
s
.58034 0 m
.58486 .29035 L
s
.58486 .29035 m
1 .55274 L
s
1 .55274 m
.97591 .3073 L
s
.97591 .3073 m
.58034 0 L
s
.02633 .25271 m
.46366 .47481 L
s
.46366 .47481 m
.46154 .69293 L
s
.46154 .69293 m
0 .50662 L
s
0 .50662 m
.02633 .25271 L
s
0 0 m
1 0 L
1 .69293 L
0 .69293 L
closepath
clip
newpath
.5 Mabswid
1 g
.4648 .52365 .45619 .47604 .46159 .68751 .47104 .68503 Metetra
1 g
.45753 .4945 .44872 .47226 .45619 .47604 .4648 .52365 Metetra
1 g
.45008 .48228 .44119 .46845 .44872 .47226 .45753 .4945 Metetra
1 g
.44255 .47424 .43361 .46462 .44119 .46845 .45008 .48228 Metetra
1 g
.43494 .46785 .42597 .46076 .43361 .46462 .44255 .47424 Metetra
1 g
.42727 .46227 .41828 .45687 .42597 .46076 .43494 .46785 Metetra
1 g
.41955 .45714 .41054 .45296 .41828 .45687 .42727 .46227 Metetra
1 g
.41176 .45228 .40273 .44901 .41054 .45296 .41955 .45714 Metetra
1 g
.40392 .44759 .39488 .44504 .40273 .44901 .41176 .45228 Metetra
1 g
.39602 .44301 .38696 .44104 .39488 .44504 .40392 .44759 Metetra
1 g
.38806 .4385 .37899 .43701 .38696 .44104 .39602 .44301 Metetra
1 g
.38004 .43404 .37095 .43295 .37899 .43701 .38806 .4385 Metetra
1 g
.37196 .4296 .36286 .42886 .37095 .43295 .38004 .43404 Metetra
1 g
.36382 .42519 .35471 .42474 .36286 .42886 .37196 .4296 Metetra
1 g
.35562 .42077 .3465 .42059 .35471 .42474 .36382 .42519 Metetra
1 g
.34736 .41636 .33822 .41641 .3465 .42059 .35562 .42077 Metetra
1 g
.33903 .41194 .32989 .41219 .33822 .41641 .34736 .41636 Metetra
1 g
.33064 .4075 .32149 .40795 .32989 .41219 .33903 .41194 Metetra
1 g
.32219 .40305 .31303 .40367 .32149 .40795 .33064 .4075 Metetra
1 g
.31368 .39859 .3045 .39936 .31303 .40367 .32219 .40305 Metetra
1 g
.3051 .3941 .29591 .39502 .3045 .39936 .31368 .39859 Metetra
1 g
.29645 .38959 .28726 .39064 .29591 .39502 .3051 .3941 Metetra
1 g
.28774 .38506 .27853 .38624 .28726 .39064 .29645 .38959 Metetra
1 g
.27896 .3805 .26975 .38179 .27853 .38624 .28774 .38506 Metetra
1 g
.27011 .37591 .26089 .37732 .26975 .38179 .27896 .3805 Metetra
1 g
.26119 .3713 .25196 .37281 .26089 .37732 .27011 .37591 Metetra
1 g
.25221 .36665 .24297 .36826 .25196 .37281 .26119 .3713 Metetra
1 g
.24315 .36198 .2339 .36368 .24297 .36826 .25221 .36665 Metetra
1 g
.23402 .35727 .22477 .35906 .2339 .36368 .24315 .36198 Metetra
1 g
.22482 .35253 .21556 .3544 .22477 .35906 .23402 .35727 Metetra
1 g
.21555 .34775 .20628 .34971 .21556 .3544 .22482 .35253 Metetra
1 g
.2062 .34295 .19692 .34498 .20628 .34971 .21555 .34775 Metetra
1 g
.19678 .3381 .1875 .34022 .19692 .34498 .2062 .34295 Metetra
1 g
.18729 .33322 .17799 .33541 .1875 .34022 .19678 .3381 Metetra
1 g
.17771 .32831 .16841 .33057 .17799 .33541 .18729 .33322 Metetra
1 g
.16806 .32336 .15875 .32569 .16841 .33057 .17771 .32831 Metetra
1 g
.15833 .31837 .14902 .32077 .15875 .32569 .16806 .32336 Metetra
1 g
.14852 .31334 .1392 .31581 .14902 .32077 .15833 .31837 Metetra
1 g
.13863 .30827 .12931 .31081 .1392 .31581 .14852 .31334 Metetra
1 g
.12866 .30317 .11933 .30576 .12931 .31081 .13863 .30827 Metetra
1 g
.11861 .29802 .10927 .30068 .11933 .30576 .12866 .30317 Metetra
1 g
.10848 .29283 .09913 .29555 .10927 .30068 .11861 .29802 Metetra
1 g
.09826 .2876 .08891 .29039 .09913 .29555 .10848 .29283 Metetra
1 g
.08795 .28233 .0786 .28517 .08891 .29039 .09826 .2876 Metetra
1 g
.07756 .27702 .0682 .27992 .0786 .28517 .08795 .28233 Metetra
1 g
.06708 .27166 .05772 .27462 .0682 .27992 .07756 .27702 Metetra
1 g
.05651 .26626 .04714 .26928 .05772 .27462 .06708 .27166 Metetra
1 g
.04586 .26081 .03648 .26389 .04714 .26928 .05651 .26626 Metetra
1 g
.03511 .25532 .02573 .25845 .03648 .26389 .04586 .26081 Metetra
1 g
.47363 .57253 .4648 .52365 .47104 .68503 .48054 .68254 Metetra
1 g
.46649 .51709 .45753 .4945 .4648 .52365 .47363 .57253 Metetra
1 g
.45909 .49628 .45008 .48228 .45753 .4945 .46649 .51709 Metetra
1 g
.45158 .48396 .44255 .47424 .45008 .48228 .45909 .49628 Metetra
1 g
.444 .47501 .43494 .46785 .44255 .47424 .45158 .48396 Metetra
1 g
.43635 .46771 .42727 .46227 .43494 .46785 .444 .47501 Metetra
1 g
.42864 .46136 .41955 .45714 .42727 .46227 .43635 .46771 Metetra
1 g
.42087 .45557 .41176 .45228 .41955 .45714 .42864 .46136 Metetra
1 g
.41304 .45016 .40392 .44759 .41176 .45228 .42087 .45557 Metetra
1 g
.40515 .44499 .39602 .44301 .40392 .44759 .41304 .45016 Metetra
1 g
.3972 .44 .38806 .4385 .39602 .44301 .40515 .44499 Metetra
1 g
.38919 .43513 .38004 .43404 .38806 .4385 .3972 .44 Metetra
1 g
.38113 .43035 .37196 .4296 .38004 .43404 .38919 .43513 Metetra
1 g
.373 .42563 .36382 .42519 .37196 .4296 .38113 .43035 Metetra
1 g
.36481 .42096 .35562 .42077 .36382 .42519 .373 .42563 Metetra
1 g
.35656 .41631 .34736 .41636 .35562 .42077 .36481 .42096 Metetra
1 g
.34824 .41168 .33903 .41194 .34736 .41636 .35656 .41631 Metetra
1 g
.33986 .40705 .33064 .4075 .33903 .41194 .34824 .41168 Metetra
1 g
.33142 .40243 .32219 .40305 .33064 .4075 .33986 .40705 Metetra
1 g
.32292 .39781 .31368 .39859 .32219 .40305 .33142 .40243 Metetra
1 g
.31435 .39318 .3051 .3941 .31368 .39859 .32292 .39781 Metetra
1 g
.30571 .38853 .29645 .38959 .3051 .3941 .31435 .39318 Metetra
1 g
.29701 .38387 .28774 .38506 .29645 .38959 .30571 .38853 Metetra
1 g
.28824 .3792 .27896 .3805 .28774 .38506 .29701 .38387 Metetra
1 g
.2794 .3745 .27011 .37591 .27896 .3805 .28824 .3792 Metetra
1 g
.27049 .36978 .26119 .3713 .27011 .37591 .2794 .3745 Metetra
1 g
.26151 .36503 .25221 .36665 .26119 .3713 .27049 .36978 Metetra
1 g
.25246 .36026 .24315 .36198 .25221 .36665 .26151 .36503 Metetra
1 g
.24334 .35546 .23402 .35727 .24315 .36198 .25246 .36026 Metetra
1 g
.23415 .35064 .22482 .35253 .23402 .35727 .24334 .35546 Metetra
1 g
.22489 .34578 .21555 .34775 .22482 .35253 .23415 .35064 Metetra
1 g
.21555 .34089 .2062 .34295 .21555 .34775 .22489 .34578 Metetra
1 g
.20613 .33597 .19678 .3381 .2062 .34295 .21555 .34089 Metetra
1 g
.19665 .33102 .18729 .33322 .19678 .3381 .20613 .33597 Metetra
1 g
.18708 .32603 .17771 .32831 .18729 .33322 .19665 .33102 Metetra
1 g
.17744 .32101 .16806 .32336 .17771 .32831 .18708 .32603 Metetra
1 g
.16771 .31595 .15833 .31837 .16806 .32336 .17744 .32101 Metetra
1 g
.15791 .31085 .14852 .31334 .15833 .31837 .16771 .31595 Metetra
1 g
.14803 .30572 .13863 .30827 .14852 .31334 .15791 .31085 Metetra
1 g
.13806 .30055 .12866 .30317 .13863 .30827 .14803 .30572 Metetra
1 g
.12802 .29534 .11861 .29802 .12866 .30317 .13806 .30055 Metetra
1 g
.11789 .29009 .10848 .29283 .11861 .29802 .12802 .29534 Metetra
1 g
.10767 .2848 .09826 .2876 .10848 .29283 .11789 .29009 Metetra
1 g
.09737 .27946 .08795 .28233 .09826 .2876 .10767 .2848 Metetra
1 g
.08699 .27409 .07756 .27702 .08795 .28233 .09737 .27946 Metetra
1 g
.07651 .26867 .06708 .27166 .07756 .27702 .08699 .27409 Metetra
1 g
.06595 .26321 .05651 .26626 .06708 .27166 .07651 .26867 Metetra
1 g
.05529 .25771 .04586 .26081 .05651 .26626 .06595 .26321 Metetra
1 g
.04455 .25216 .03511 .25532 .04586 .26081 .05529 .25771 Metetra
1 g
.48271 .62272 .47363 .57253 .48054 .68254 .4901 .68004 Metetra
1 g
.4756 .54005 .46649 .51709 .47363 .57253 .48271 .62272 Metetra
1 g
.46821 .51045 .45909 .49628 .46649 .51709 .4756 .54005 Metetra
1 g
.46072 .49379 .45158 .48396 .45909 .49628 .46821 .51045 Metetra
1 g
.45314 .48223 .444 .47501 .45158 .48396 .46072 .49379 Metetra
1 g
.44551 .47321 .43635 .46771 .444 .47501 .45314 .48223 Metetra
1 g
.43781 .46561 .42864 .46136 .43635 .46771 .44551 .47321 Metetra
1 g
.43005 .45889 .42087 .45557 .42864 .46136 .43781 .46561 Metetra
1 g
.42223 .45274 .41304 .45016 .42087 .45557 .43005 .45889 Metetra
1 g
.41435 .44699 .40515 .44499 .41304 .45016 .42223 .45274 Metetra
1 g
.40642 .44152 .3972 .44 .40515 .44499 .41435 .44699 Metetra
1 g
.39842 .43624 .38919 .43513 .3972 .44 .40642 .44152 Metetra
1 g
.39036 .43111 .38113 .43035 .38919 .43513 .39842 .43624 Metetra
1 g
.38224 .42609 .373 .42563 .38113 .43035 .39036 .43111 Metetra
1 g
.37406 .42114 .36481 .42096 .373 .42563 .38224 .42609 Metetra
1 g
.36582 .41626 .35656 .41631 .36481 .42096 .37406 .42114 Metetra
1 g
.35752 .41142 .34824 .41168 .35656 .41631 .36582 .41626 Metetra
1 g
.34915 .4066 .33986 .40705 .34824 .41168 .35752 .41142 Metetra
1 g
.34072 .40181 .33142 .40243 .33986 .40705 .34915 .4066 Metetra
1 g
.33222 .39702 .32292 .39781 .33142 .40243 .34072 .40181 Metetra
1 g
.32366 .39225 .31435 .39318 .32292 .39781 .33222 .39702 Metetra
1 g
.31504 .38747 .30571 .38853 .31435 .39318 .32366 .39225 Metetra
1 g
.30634 .38268 .29701 .38387 .30571 .38853 .31504 .38747 Metetra
1 g
.29758 .37788 .28824 .3792 .29701 .38387 .30634 .38268 Metetra
1 g
.28875 .37307 .2794 .3745 .28824 .3792 .29758 .37788 Metetra
1 g
.27985 .36825 .27049 .36978 .2794 .3745 .28875 .37307 Metetra
1 g
.27088 .3634 .26151 .36503 .27049 .36978 .27985 .36825 Metetra
1 g
.26184 .35854 .25246 .36026 .26151 .36503 .27088 .3634 Metetra
1 g
.25273 .35365 .24334 .35546 .25246 .36026 .26184 .35854 Metetra
1 g
.24355 .34873 .23415 .35064 .24334 .35546 .25273 .35365 Metetra
1 g
.23429 .34379 .22489 .34578 .23415 .35064 .24355 .34873 Metetra
1 g
.22496 .33882 .21555 .34089 .22489 .34578 .23429 .34379 Metetra
1 g
.21555 .33383 .20613 .33597 .21555 .34089 .22496 .33882 Metetra
1 g
.20607 .3288 .19665 .33102 .20613 .33597 .21555 .33383 Metetra
1 g
.19651 .32374 .18708 .32603 .19665 .33102 .20607 .3288 Metetra
1 g
.18688 .31864 .17744 .32101 .18708 .32603 .19651 .32374 Metetra
1 g
.17716 .31351 .16771 .31595 .17744 .32101 .18688 .31864 Metetra
1 g
.16736 .30835 .15791 .31085 .16771 .31595 .17716 .31351 Metetra
1 g
.15749 .30315 .14803 .30572 .15791 .31085 .16736 .30835 Metetra
1 g
.14753 .29791 .13806 .30055 .14803 .30572 .15749 .30315 Metetra
1 g
.13749 .29264 .12802 .29534 .13806 .30055 .14753 .29791 Metetra
1 g
.12737 .28733 .11789 .29009 .12802 .29534 .13749 .29264 Metetra
1 g
.11716 .28197 .10767 .2848 .11789 .29009 .12737 .28733 Metetra
1 g
.10686 .27658 .09737 .27946 .10767 .2848 .11716 .28197 Metetra
1 g
.09648 .27114 .08699 .27409 .09737 .27946 .10686 .27658 Metetra
1 g
.08601 .26567 .07651 .26867 .08699 .27409 .09648 .27114 Metetra
1 g
.07545 .26015 .06595 .26321 .07651 .26867 .08601 .26567 Metetra
1 g
.0648 .25458 .05529 .25771 .06595 .26321 .07545 .26015 Metetra
1 g
.05406 .24897 .04455 .25216 .05529 .25771 .0648 .25458 Metetra
1 g
.49203 .6743 .48271 .62272 .4901 .68004 .49972 .67752 Metetra
1 g
.48485 .56339 .4756 .54005 .48271 .62272 .49203 .6743 Metetra
1 g
.47745 .52481 .46821 .51045 .4756 .54005 .48485 .56339 Metetra
1 g
.46995 .50372 .46072 .49379 .46821 .51045 .47745 .52481 Metetra
1 g
.46238 .48953 .45314 .48223 .46072 .49379 .46995 .50372 Metetra
1 g
.45475 .47875 .44551 .47321 .45314 .48223 .46238 .48953 Metetra
1 g
.44706 .4699 .43781 .46561 .44551 .47321 .45475 .47875 Metetra
1 g
.43931 .46224 .43005 .45889 .43781 .46561 .44706 .4699 Metetra
1 g
.4315 .45535 .42223 .45274 .43005 .45889 .43931 .46224 Metetra
1 g
.42363 .44901 .41435 .44699 .42223 .45274 .4315 .45535 Metetra
1 g
.4157 .44304 .40642 .44152 .41435 .44699 .42363 .44901 Metetra
1 g
.40771 .43735 .39842 .43624 .40642 .44152 .4157 .44304 Metetra
1 g
.39967 .43187 .39036 .43111 .39842 .43624 .40771 .43735 Metetra
1 g
.39156 .42654 .38224 .42609 .39036 .43111 .39967 .43187 Metetra
1 g
.38339 .42133 .37406 .42114 .38224 .42609 .39156 .42654 Metetra
1 g
.37516 .41621 .36582 .41626 .37406 .42114 .38339 .42133 Metetra
1 g
.36686 .41115 .35752 .41142 .36582 .41626 .37516 .41621 Metetra
1 g
.3585 .40615 .34915 .4066 .35752 .41142 .36686 .41115 Metetra
1 g
.35008 .40118 .34072 .40181 .34915 .4066 .3585 .40615 Metetra
1 g
.3416 .39623 .33222 .39702 .34072 .40181 .35008 .40118 Metetra
1 g
.33304 .39131 .32366 .39225 .33222 .39702 .3416 .39623 Metetra
1 g
.32443 .38639 .31504 .38747 .32366 .39225 .33304 .39131 Metetra
1 g
.31574 .38148 .30634 .38268 .31504 .38747 .32443 .38639 Metetra
1 g
.30699 .37656 .29758 .37788 .30634 .38268 .31574 .38148 Metetra
1 g
.29817 .37164 .28875 .37307 .29758 .37788 .30699 .37656 Metetra
1 g
.28928 .36671 .27985 .36825 .28875 .37307 .29817 .37164 Metetra
1 g
.28032 .36176 .27088 .3634 .27985 .36825 .28928 .36671 Metetra
1 g
.27129 .3568 .26184 .35854 .27088 .3634 .28032 .36176 Metetra
1 g
.26218 .35182 .25273 .35365 .26184 .35854 .27129 .3568 Metetra
1 g
.25301 .34682 .24355 .34873 .25273 .35365 .26218 .35182 Metetra
1 g
.24376 .34179 .23429 .34379 .24355 .34873 .25301 .34682 Metetra
1 g
.23444 .33674 .22496 .33882 .23429 .34379 .24376 .34179 Metetra
1 g
.22504 .33166 .21555 .33383 .22496 .33882 .23444 .33674 Metetra
1 g
.21556 .32656 .20607 .3288 .21555 .33383 .22504 .33166 Metetra
1 g
.20601 .32142 .19651 .32374 .20607 .3288 .21556 .32656 Metetra
1 g
.19638 .31626 .18688 .31864 .19651 .32374 .20601 .32142 Metetra
1 g
.18667 .31106 .17716 .31351 .18688 .31864 .19638 .31626 Metetra
1 g
.17689 .30583 .16736 .30835 .17716 .31351 .18667 .31106 Metetra
1 g
.16702 .30056 .15749 .30315 .16736 .30835 .17689 .30583 Metetra
1 g
.15707 .29526 .14753 .29791 .15749 .30315 .16702 .30056 Metetra
1 g
.14703 .28992 .13749 .29264 .14753 .29791 .15707 .29526 Metetra
1 g
.13691 .28454 .12737 .28733 .13749 .29264 .14703 .28992 Metetra
1 g
.12671 .27913 .11716 .28197 .12737 .28733 .13691 .28454 Metetra
1 g
.11642 .27367 .10686 .27658 .11716 .28197 .12671 .27913 Metetra
1 g
.10604 .26818 .09648 .27114 .10686 .27658 .11642 .27367 Metetra
1 g
.09558 .26264 .08601 .26567 .09648 .27114 .10604 .26818 Metetra
1 g
.08502 .25706 .07545 .26015 .08601 .26567 .09558 .26264 Metetra
1 g
.07438 .25144 .0648 .25458 .07545 .26015 .08502 .25706 Metetra
1 g
.06364 .24577 .05406 .24897 .0648 .25458 .07438 .25144 Metetra
1 g
.50171 .67174 .49203 .6743 .49972 .67752 .50939 .67498 Metetra
1 g
.49425 .58711 .48485 .56339 .49203 .6743 .50171 .67174 Metetra
1 g
.4868 .53935 .47745 .52481 .48485 .56339 .49425 .58711 Metetra
1 g
.47929 .51377 .46995 .50372 .47745 .52481 .4868 .53935 Metetra
1 g
.47171 .49691 .46238 .48953 .46995 .50372 .47929 .51377 Metetra
1 g
.46408 .48435 .45475 .47875 .46238 .48953 .47171 .49691 Metetra
1 g
.45639 .47423 .44706 .4699 .45475 .47875 .46408 .48435 Metetra
1 g
.44865 .46561 .43931 .46224 .44706 .4699 .45639 .47423 Metetra
1 g
.44084 .45799 .4315 .45535 .43931 .46224 .44865 .46561 Metetra
1 g
.43298 .45104 .42363 .44901 .4315 .45535 .44084 .45799 Metetra
1 g
.42506 .44458 .4157 .44304 .42363 .44901 .43298 .45104 Metetra
1 g
.41708 .43847 .40771 .43735 .4157 .44304 .42506 .44458 Metetra
1 g
.40904 .43264 .39967 .43187 .40771 .43735 .41708 .43847 Metetra
1 g
.40094 .427 .39156 .42654 .39967 .43187 .40904 .43264 Metetra
1 g
.39278 .42152 .38339 .42133 .39156 .42654 .40094 .427 Metetra
1 g
.38456 .41616 .37516 .41621 .38339 .42133 .39278 .42152 Metetra
1 g
.37627 .41089 .36686 .41115 .37516 .41621 .38456 .41616 Metetra
1 g
.36793 .40569 .3585 .40615 .36686 .41115 .37627 .41089 Metetra
1 g
.35951 .40054 .35008 .40118 .3585 .40615 .36793 .40569 Metetra
1 g
.35104 .39544 .3416 .39623 .35008 .40118 .35951 .40054 Metetra
1 g
.34249 .39036 .33304 .39131 .3416 .39623 .35104 .39544 Metetra
1 g
.33388 .38531 .32443 .38639 .33304 .39131 .34249 .39036 Metetra
1 g
.32521 .38026 .31574 .38148 .32443 .38639 .33388 .38531 Metetra
1 g
.31647 .37523 .30699 .37656 .31574 .38148 .32521 .38026 Metetra
1 g
.30765 .37019 .29817 .37164 .30699 .37656 .31647 .37523 Metetra
1 g
.29877 .36515 .28928 .36671 .29817 .37164 .30765 .37019 Metetra
1 g
.28982 .36011 .28032 .36176 .28928 .36671 .29877 .36515 Metetra
1 g
.2808 .35505 .27129 .3568 .28032 .36176 .28982 .36011 Metetra
1 g
.2717 .34998 .26218 .35182 .27129 .3568 .2808 .35505 Metetra
1 g
.26254 .34489 .25301 .34682 .26218 .35182 .2717 .34998 Metetra
1 g
.2533 .33978 .24376 .34179 .25301 .34682 .26254 .34489 Metetra
1 g
.24398 .33464 .23444 .33674 .24376 .34179 .2533 .33978 Metetra
1 g
.23459 .32949 .22504 .33166 .23444 .33674 .24398 .33464 Metetra
1 g
.22512 .32431 .21556 .32656 .22504 .33166 .23459 .32949 Metetra
1 g
.21558 .3191 .20601 .32142 .21556 .32656 .22512 .32431 Metetra
1 g
.20596 .31386 .19638 .31626 .20601 .32142 .21558 .3191 Metetra
1 g
.19626 .30859 .18667 .31106 .19638 .31626 .20596 .31386 Metetra
1 g
.18647 .30329 .17689 .30583 .18667 .31106 .19626 .30859 Metetra
1 g
.17661 .29795 .16702 .30056 .17689 .30583 .18647 .30329 Metetra
1 g
.16667 .29259 .15707 .29526 .16702 .30056 .17661 .29795 Metetra
1 g
.15664 .28718 .14703 .28992 .15707 .29526 .16667 .29259 Metetra
1 g
.14653 .28174 .13691 .28454 .14703 .28992 .15664 .28718 Metetra
1 g
.13633 .27626 .12671 .27913 .13691 .28454 .14653 .28174 Metetra
1 g
.12605 .27074 .11642 .27367 .12671 .27913 .13633 .27626 Metetra
1 g
.11568 .26519 .10604 .26818 .11642 .27367 .12605 .27074 Metetra
1 g
.10522 .25959 .09558 .26264 .10604 .26818 .11568 .26519 Metetra
1 g
.09467 .25395 .08502 .25706 .09558 .26264 .10522 .25959 Metetra
1 g
.08403 .24827 .07438 .25144 .08502 .25706 .09467 .25395 Metetra
1 g
.0733 .24254 .06364 .24577 .07438 .25144 .08403 .24827 Metetra
1 g
.51146 .66918 .50171 .67174 .50939 .67498 .51912 .67243 Metetra
1 g
.50381 .61122 .49425 .58711 .50171 .67174 .51146 .66918 Metetra
1 g
.49628 .55408 .4868 .53935 .49425 .58711 .50381 .61122 Metetra
1 g
.48873 .52393 .47929 .51377 .4868 .53935 .49628 .55408 Metetra
1 g
.48114 .50436 .47171 .49691 .47929 .51377 .48873 .52393 Metetra
1 g
.4735 .49 .46408 .48435 .47171 .49691 .48114 .50436 Metetra
1 g
.46581 .4786 .45639 .47423 .46408 .48435 .4735 .49 Metetra
1 g
.45806 .46902 .44865 .46561 .45639 .47423 .46581 .4786 Metetra
1 g
.45026 .46064 .44084 .45799 .44865 .46561 .45806 .46902 Metetra
1 g
.44241 .45309 .43298 .45104 .44084 .45799 .45026 .46064 Metetra
1 g
.43449 .44613 .42506 .44458 .43298 .45104 .44241 .45309 Metetra
1 g
.42652 .43961 .41708 .43847 .42506 .44458 .43449 .44613 Metetra
1 g
.41849 .43341 .40904 .43264 .41708 .43847 .42652 .43961 Metetra
1 g
.4104 .42746 .40094 .427 .40904 .43264 .41849 .43341 Metetra
1 g
.40225 .42171 .39278 .42152 .40094 .427 .4104 .42746 Metetra
1 g
.39403 .41611 .38456 .41616 .39278 .42152 .40225 .42171 Metetra
1 g
.38576 .41062 .37627 .41089 .38456 .41616 .39403 .41611 Metetra
1 g
.37742 .40523 .36793 .40569 .37627 .41089 .38576 .41062 Metetra
1 g
.36901 .3999 .35951 .40054 .36793 .40569 .37742 .40523 Metetra
1 g
.36054 .39464 .35104 .39544 .35951 .40054 .36901 .3999 Metetra
1 g
.35201 .38941 .34249 .39036 .35104 .39544 .36054 .39464 Metetra
1 g
.34341 .38422 .33388 .38531 .34249 .39036 .35201 .38941 Metetra
1 g
.33474 .37904 .32521 .38026 .33388 .38531 .34341 .38422 Metetra
1 g
.32601 .37389 .31647 .37523 .32521 .38026 .33474 .37904 Metetra
1 g
.31721 .36874 .30765 .37019 .31647 .37523 .32601 .37389 Metetra
1 g
.30833 .36359 .29877 .36515 .30765 .37019 .31721 .36874 Metetra
1 g
.29939 .35844 .28982 .36011 .29877 .36515 .30833 .36359 Metetra
1 g
.29038 .35329 .2808 .35505 .28982 .36011 .29939 .35844 Metetra
1 g
.28129 .34812 .2717 .34998 .2808 .35505 .29038 .35329 Metetra
1 g
.27213 .34294 .26254 .34489 .2717 .34998 .28129 .34812 Metetra
1 g
.2629 .33775 .2533 .33978 .26254 .34489 .27213 .34294 Metetra
1 g
.25359 .33253 .24398 .33464 .2533 .33978 .2629 .33775 Metetra
1 g
.24421 .3273 .23459 .32949 .24398 .33464 .25359 .33253 Metetra
1 g
.23475 .32204 .22512 .32431 .23459 .32949 .24421 .3273 Metetra
1 g
.22521 .31675 .21558 .3191 .22512 .32431 .23475 .32204 Metetra
1 g
.2156 .31144 .20596 .31386 .21558 .3191 .22521 .31675 Metetra
1 g
.20591 .3061 .19626 .30859 .20596 .31386 .2156 .31144 Metetra
1 g
.19613 .30073 .18647 .30329 .19626 .30859 .20591 .3061 Metetra
1 g
.18628 .29533 .17661 .29795 .18647 .30329 .19613 .30073 Metetra
1 g
.17634 .28989 .16667 .29259 .17661 .29795 .18628 .29533 Metetra
1 g
.16632 .28442 .15664 .28718 .16667 .29259 .17634 .28989 Metetra
1 g
.15621 .27892 .14653 .28174 .15664 .28718 .16632 .28442 Metetra
1 g
.14602 .27338 .13633 .27626 .14653 .28174 .15621 .27892 Metetra
1 g
.13574 .2678 .12605 .27074 .13633 .27626 .14602 .27338 Metetra
1 g
.12538 .26218 .11568 .26519 .12605 .27074 .13574 .2678 Metetra
1 g
.11492 .25652 .10522 .25959 .11568 .26519 .12538 .26218 Metetra
1 g
.10438 .25082 .09467 .25395 .10522 .25959 .11492 .25652 Metetra
1 g
.09375 .24507 .08403 .24827 .09467 .25395 .10438 .25082 Metetra
1 g
.08302 .23929 .0733 .24254 .08403 .24827 .09375 .24507 Metetra
1 g
.52126 .66659 .51146 .66918 .51912 .67243 .52891 .66987 Metetra
1 g
.51353 .63574 .50381 .61122 .51146 .66918 .52126 .66659 Metetra
1 g
.50588 .569 .49628 .55408 .50381 .61122 .51353 .63574 Metetra
1 g
.49827 .5342 .48873 .52393 .49628 .55408 .50588 .569 Metetra
1 g
.49066 .51188 .48114 .50436 .48873 .52393 .49827 .5342 Metetra
1 g
.483 .49571 .4735 .49 .48114 .50436 .49066 .51188 Metetra
1 g
.47531 .48301 .46581 .4786 .4735 .49 .483 .49571 Metetra
1 g
.46756 .47245 .45806 .46902 .46581 .4786 .47531 .48301 Metetra
1 g
.45976 .46331 .45026 .46064 .45806 .46902 .46756 .47245 Metetra
1 g
.45191 .45515 .44241 .45309 .45026 .46064 .45976 .46331 Metetra
1 g
.444 .44769 .43449 .44613 .44241 .45309 .45191 .45515 Metetra
1 g
.43604 .44074 .42652 .43961 .43449 .44613 .444 .44769 Metetra
1 g
.42801 .43419 .41849 .43341 .42652 .43961 .43604 .44074 Metetra
1 g
.41993 .42793 .4104 .42746 .41849 .43341 .42801 .43419 Metetra
1 g
.41178 .4219 .40225 .42171 .4104 .42746 .41993 .42793 Metetra
1 g
.40357 .41606 .39403 .41611 .40225 .42171 .41178 .4219 Metetra
1 g
.39531 .41035 .38576 .41062 .39403 .41611 .40357 .41606 Metetra
1 g
.38698 .40476 .37742 .40523 .38576 .41062 .39531 .41035 Metetra
1 g
.37858 .39926 .36901 .3999 .37742 .40523 .38698 .40476 Metetra
1 g
.37012 .39383 .36054 .39464 .36901 .3999 .37858 .39926 Metetra
1 g
.3616 .38845 .35201 .38941 .36054 .39464 .37012 .39383 Metetra
1 g
.353 .38312 .34341 .38422 .35201 .38941 .3616 .38845 Metetra
1 g
.34435 .37782 .33474 .37904 .34341 .38422 .353 .38312 Metetra
1 g
.33562 .37254 .32601 .37389 .33474 .37904 .34435 .37782 Metetra
1 g
.32683 .36727 .31721 .36874 .32601 .37389 .33562 .37254 Metetra
1 g
.31796 .36202 .30833 .36359 .31721 .36874 .32683 .36727 Metetra
1 g
.30903 .35676 .29939 .35844 .30833 .36359 .31796 .36202 Metetra
1 g
.30002 .35151 .29038 .35329 .29939 .35844 .30903 .35676 Metetra
1 g
.29095 .34625 .28129 .34812 .29038 .35329 .30002 .35151 Metetra
1 g
.2818 .34098 .27213 .34294 .28129 .34812 .29095 .34625 Metetra
1 g
.27257 .3357 .2629 .33775 .27213 .34294 .2818 .34098 Metetra
1 g
.26327 .3304 .25359 .33253 .2629 .33775 .27257 .3357 Metetra
1 g
.2539 .32509 .24421 .3273 .25359 .33253 .26327 .3304 Metetra
1 g
.24445 .31975 .23475 .32204 .24421 .3273 .2539 .32509 Metetra
1 g
.23492 .31439 .22521 .31675 .23475 .32204 .24445 .31975 Metetra
1 g
.22531 .30901 .2156 .31144 .22521 .31675 .23492 .31439 Metetra
1 g
.21563 .30359 .20591 .3061 .2156 .31144 .22531 .30901 Metetra
1 g
.20586 .29815 .19613 .30073 .20591 .3061 .21563 .30359 Metetra
1 g
.19601 .29268 .18628 .29533 .19613 .30073 .20586 .29815 Metetra
1 g
.18608 .28718 .17634 .28989 .18628 .29533 .19601 .29268 Metetra
1 g
.17607 .28165 .16632 .28442 .17634 .28989 .18608 .28718 Metetra
1 g
.16597 .27608 .15621 .27892 .16632 .28442 .17607 .28165 Metetra
1 g
.15578 .27047 .14602 .27338 .15621 .27892 .16597 .27608 Metetra
1 g
.14551 .26483 .13574 .2678 .14602 .27338 .15578 .27047 Metetra
1 g
.13515 .25914 .12538 .26218 .13574 .2678 .14551 .26483 Metetra
1 g
.1247 .25342 .11492 .25652 .12538 .26218 .13515 .25914 Metetra
1 g
.11416 .24766 .10438 .25082 .11492 .25652 .1247 .25342 Metetra
1 g
.10354 .24186 .09375 .24507 .10438 .25082 .11416 .24766 Metetra
1 g
.09281 .23601 .08302 .23929 .09375 .24507 .10354 .24186 Metetra
1 g
.53111 .66399 .52126 .66659 .52891 .66987 .53875 .66729 Metetra
1 g
.52342 .66067 .51353 .63574 .52126 .66659 .53111 .66399 Metetra
1 g
.5156 .58411 .50588 .569 .51353 .63574 .52342 .66067 Metetra
1 g
.50793 .54459 .49827 .5342 .50588 .569 .5156 .58411 Metetra
1 g
.50027 .51948 .49066 .51188 .49827 .5342 .50793 .54459 Metetra
1 g
.4926 .50146 .483 .49571 .49066 .51188 .50027 .51948 Metetra
1 g
.48489 .48745 .47531 .48301 .483 .49571 .4926 .50146 Metetra
1 g
.47714 .47592 .46756 .47245 .47531 .48301 .48489 .48745 Metetra
1 g
.46934 .46601 .45976 .46331 .46756 .47245 .47714 .47592 Metetra
1 g
.46149 .45723 .45191 .45515 .45976 .46331 .46934 .46601 Metetra
1 g
.45358 .44926 .444 .44769 .45191 .45515 .46149 .45723 Metetra
1 g
.44562 .44189 .43604 .44074 .444 .44769 .45358 .44926 Metetra
1 g
.4376 .43497 .42801 .43419 .43604 .44074 .44562 .44189 Metetra
1 g
.42952 .4284 .41993 .42793 .42801 .43419 .4376 .43497 Metetra
1 g
.42139 .4221 .41178 .4219 .41993 .42793 .42952 .4284 Metetra
1 g
.41319 .416 .40357 .41606 .41178 .4219 .42139 .4221 Metetra
1 g
.40493 .41008 .39531 .41035 .40357 .41606 .41319 .416 Metetra
1 g
.3966 .40429 .38698 .40476 .39531 .41035 .40493 .41008 Metetra
1 g
.38822 .39861 .37858 .39926 .38698 .40476 .3966 .40429 Metetra
1 g
.37977 .39302 .37012 .39383 .37858 .39926 .38822 .39861 Metetra
1 g
.37125 .38749 .3616 .38845 .37012 .39383 .37977 .39302 Metetra
1 g
.36267 .38201 .353 .38312 .3616 .38845 .37125 .38749 Metetra
1 g
.35402 .37658 .34435 .37782 .353 .38312 .36267 .38201 Metetra
1 g
.3453 .37118 .33562 .37254 .34435 .37782 .35402 .37658 Metetra
1 g
.33652 .3658 .32683 .36727 .33562 .37254 .3453 .37118 Metetra
1 g
.32766 .36043 .31796 .36202 .32683 .36727 .33652 .3658 Metetra
1 g
.31874 .35508 .30903 .35676 .31796 .36202 .32766 .36043 Metetra
1 g
.30974 .34972 .30002 .35151 .30903 .35676 .31874 .35508 Metetra
1 g
.30067 .34437 .29095 .34625 .30002 .35151 .30974 .34972 Metetra
1 g
.29153 .33901 .2818 .34098 .29095 .34625 .30067 .34437 Metetra
1 g
.28231 .33364 .27257 .3357 .2818 .34098 .29153 .33901 Metetra
1 g
.27302 .32826 .26327 .3304 .27257 .3357 .28231 .33364 Metetra
1 g
.26366 .32286 .2539 .32509 .26327 .3304 .27302 .32826 Metetra
1 g
.25421 .31745 .24445 .31975 .2539 .32509 .26366 .32286 Metetra
1 g
.24469 .31201 .23492 .31439 .24445 .31975 .25421 .31745 Metetra
1 g
.23509 .30655 .22531 .30901 .23492 .31439 .24469 .31201 Metetra
1 g
.22542 .30107 .21563 .30359 .22531 .30901 .23509 .30655 Metetra
1 g
.21566 .29556 .20586 .29815 .21563 .30359 .22542 .30107 Metetra
1 g
.20582 .29002 .19601 .29268 .20586 .29815 .21566 .29556 Metetra
1 g
.19589 .28445 .18608 .28718 .19601 .29268 .20582 .29002 Metetra
1 g
.18588 .27885 .17607 .28165 .18608 .28718 .19589 .28445 Metetra
1 g
.17579 .27321 .16597 .27608 .17607 .28165 .18588 .27885 Metetra
1 g
.16561 .26754 .15578 .27047 .16597 .27608 .17579 .27321 Metetra
1 g
.15535 .26183 .14551 .26483 .15578 .27047 .16561 .26754 Metetra
1 g
.145 .25609 .13515 .25914 .14551 .26483 .15535 .26183 Metetra
1 g
.13455 .2503 .1247 .25342 .13515 .25914 .145 .25609 Metetra
1 g
.12402 .24448 .11416 .24766 .1247 .25342 .13455 .2503 Metetra
1 g
.1134 .23862 .10354 .24186 .11416 .24766 .12402 .24448 Metetra
1 g
.10268 .23271 .09281 .23601 .10354 .24186 .1134 .23862 Metetra
1 g
.54103 .66138 .53111 .66399 .53875 .66729 .54865 .6647 Metetra
1 g
.53335 .65804 .52342 .66067 .53111 .66399 .54103 .66138 Metetra
1 g
.52546 .59943 .5156 .58411 .52342 .66067 .53335 .65804 Metetra
1 g
.51769 .55509 .50793 .54459 .5156 .58411 .52546 .59943 Metetra
1 g
.50999 .52716 .50027 .51948 .50793 .54459 .51769 .55509 Metetra
1 g
.50229 .50728 .4926 .50146 .50027 .51948 .50999 .52716 Metetra
1 g
.49456 .49194 .48489 .48745 .4926 .50146 .50229 .50728 Metetra
1 g
.4868 .47941 .47714 .47592 .48489 .48745 .49456 .49194 Metetra
1 g
.479 .46873 .46934 .46601 .47714 .47592 .4868 .47941 Metetra
1 g
.47115 .45933 .46149 .45723 .46934 .46601 .479 .46873 Metetra
1 g
.46324 .45085 .45358 .44926 .46149 .45723 .47115 .45933 Metetra
1 g
.45528 .44305 .44562 .44189 .45358 .44926 .46324 .45085 Metetra
1 g
.44727 .43576 .4376 .43497 .44562 .44189 .45528 .44305 Metetra
1 g
.4392 .42887 .42952 .4284 .4376 .43497 .44727 .43576 Metetra
1 g
.43107 .42229 .42139 .4221 .42952 .4284 .4392 .42887 Metetra
1 g
.42287 .41595 .41319 .416 .42139 .4221 .43107 .42229 Metetra
1 g
.41462 .40981 .40493 .41008 .41319 .416 .42287 .41595 Metetra
1 g
.4063 .40382 .3966 .40429 .40493 .41008 .41462 .40981 Metetra
1 g
.39793 .39796 .38822 .39861 .3966 .40429 .4063 .40382 Metetra
1 g
.38948 .3922 .37977 .39302 .38822 .39861 .39793 .39796 Metetra
1 g
.38098 .38652 .37125 .38749 .37977 .39302 .38948 .3922 Metetra
1 g
.3724 .3809 .36267 .38201 .37125 .38749 .38098 .38652 Metetra
1 g
.36376 .37533 .35402 .37658 .36267 .38201 .3724 .3809 Metetra
1 g
.35505 .36981 .3453 .37118 .35402 .37658 .36376 .37533 Metetra
1 g
.34628 .36431 .33652 .3658 .3453 .37118 .35505 .36981 Metetra
1 g
.33743 .35883 .32766 .36043 .33652 .3658 .34628 .36431 Metetra
1 g
.32851 .35337 .31874 .35508 .32766 .36043 .33743 .35883 Metetra
1 g
.31953 .34792 .30974 .34972 .31874 .35508 .32851 .35337 Metetra
1 g
.31047 .34247 .30067 .34437 .30974 .34972 .31953 .34792 Metetra
1 g
.30133 .33702 .29153 .33901 .30067 .34437 .31047 .34247 Metetra
1 g
.29212 .33157 .28231 .33364 .29153 .33901 .30133 .33702 Metetra
1 g
.28284 .3261 .27302 .32826 .28231 .33364 .29212 .33157 Metetra
1 g
.27349 .32062 .26366 .32286 .27302 .32826 .28284 .3261 Metetra
1 g
.26405 .31513 .25421 .31745 .26366 .32286 .27349 .32062 Metetra
1 g
.25454 .30962 .24469 .31201 .25421 .31745 .26405 .31513 Metetra
1 g
.24495 .30409 .23509 .30655 .24469 .31201 .25454 .30962 Metetra
1 g
.23528 .29853 .22542 .30107 .23509 .30655 .24495 .30409 Metetra
1 g
.22552 .29295 .21566 .29556 .22542 .30107 .23528 .29853 Metetra
1 g
.21569 .28734 .20582 .29002 .21566 .29556 .22552 .29295 Metetra
1 g
.20578 .2817 .19589 .28445 .20582 .29002 .21569 .28734 Metetra
1 g
.19578 .27603 .18588 .27885 .19589 .28445 .20578 .2817 Metetra
1 g
.18569 .27033 .17579 .27321 .18588 .27885 .19578 .27603 Metetra
1 g
.17552 .26459 .16561 .26754 .17579 .27321 .18569 .27033 Metetra
1 g
.16526 .25882 .15535 .26183 .16561 .26754 .17552 .26459 Metetra
1 g
.15491 .25301 .145 .25609 .15535 .26183 .16526 .25882 Metetra
1 g
.14448 .24716 .13455 .2503 .145 .25609 .15491 .25301 Metetra
1 g
.13395 .24128 .12402 .24448 .13455 .2503 .14448 .24716 Metetra
1 g
.12333 .23535 .1134 .23862 .12402 .24448 .13395 .24128 Metetra
1 g
.11262 .22938 .10268 .23271 .1134 .23862 .12333 .23535 Metetra
1 g
.55101 .65875 .54103 .66138 .54865 .6647 .55862 .66209 Metetra
1 g
.54334 .65539 .53335 .65804 .54103 .66138 .55101 .65875 Metetra
1 g
.53544 .61495 .52546 .59943 .53335 .65804 .54334 .65539 Metetra
1 g
.52757 .56572 .51769 .55509 .52546 .59943 .53544 .61495 Metetra
1 g
.5198 .53491 .50999 .52716 .51769 .55509 .52757 .56572 Metetra
1 g
.51207 .51314 .50229 .50728 .50999 .52716 .5198 .53491 Metetra
1 g
.50432 .49647 .49456 .49194 .50229 .50728 .51207 .51314 Metetra
1 g
.49655 .48293 .4868 .47941 .49456 .49194 .50432 .49647 Metetra
1 g
.48874 .47147 .479 .46873 .4868 .47941 .49655 .48293 Metetra
1 g
.48088 .46144 .47115 .45933 .479 .46873 .48874 .47147 Metetra
1 g
.47298 .45245 .46324 .45085 .47115 .45933 .48088 .46144 Metetra
1 g
.46502 .44422 .45528 .44305 .46324 .45085 .47298 .45245 Metetra
1 g
.45701 .43656 .44727 .43576 .45528 .44305 .46502 .44422 Metetra
1 g
.44894 .42935 .4392 .42887 .44727 .43576 .45701 .43656 Metetra
1 g
.44082 .42249 .43107 .42229 .4392 .42887 .44894 .42935 Metetra
1 g
.43263 .4159 .42287 .41595 .43107 .42229 .44082 .42249 Metetra
1 g
.42438 .40953 .41462 .40981 .42287 .41595 .43263 .4159 Metetra
1 g
.41608 .40335 .4063 .40382 .41462 .40981 .42438 .40953 Metetra
1 g
.40771 .3973 .39793 .39796 .4063 .40382 .41608 .40335 Metetra
1 g
.39927 .39137 .38948 .3922 .39793 .39796 .40771 .3973 Metetra
1 g
.39077 .38554 .38098 .38652 .38948 .3922 .39927 .39137 Metetra
1 g
.38221 .37978 .3724 .3809 .38098 .38652 .39077 .38554 Metetra
1 g
.37357 .37408 .36376 .37533 .3724 .3809 .38221 .37978 Metetra
1 g
.36487 .36843 .35505 .36981 .36376 .37533 .37357 .37408 Metetra
1 g
.35611 .36281 .34628 .36431 .35505 .36981 .36487 .36843 Metetra
1 g
.34727 .35723 .33743 .35883 .34628 .36431 .35611 .36281 Metetra
1 g
.33836 .35166 .32851 .35337 .33743 .35883 .34727 .35723 Metetra
1 g
.32938 .34611 .31953 .34792 .32851 .35337 .33836 .35166 Metetra
1 g
.32033 .34057 .31047 .34247 .31953 .34792 .32938 .34611 Metetra
1 g
.31121 .33502 .30133 .33702 .31047 .34247 .32033 .34057 Metetra
1 g
.30201 .32948 .29212 .33157 .30133 .33702 .31121 .33502 Metetra
1 g
.29273 .32393 .28284 .3261 .29212 .33157 .30201 .32948 Metetra
1 g
.28338 .31837 .27349 .32062 .28284 .3261 .29273 .32393 Metetra
1 g
.27396 .3128 .26405 .31513 .27349 .32062 .28338 .31837 Metetra
1 g
.26445 .30721 .25454 .30962 .26405 .31513 .27396 .3128 Metetra
1 g
.25487 .3016 .24495 .30409 .25454 .30962 .26445 .30721 Metetra
1 g
.24521 .29597 .23528 .29853 .24495 .30409 .25487 .3016 Metetra
1 g
.23546 .29031 .22552 .29295 .23528 .29853 .24521 .29597 Metetra
1 g
.22564 .28463 .21569 .28734 .22552 .29295 .23546 .29031 Metetra
1 g
.21573 .27893 .20578 .2817 .21569 .28734 .22564 .28463 Metetra
1 g
.20574 .27319 .19578 .27603 .20578 .2817 .21573 .27893 Metetra
1 g
.19566 .26742 .18569 .27033 .19578 .27603 .20574 .27319 Metetra
1 g
.1855 .26162 .17552 .26459 .18569 .27033 .19566 .26742 Metetra
1 g
.17524 .25578 .16526 .25882 .17552 .26459 .1855 .26162 Metetra
1 g
.1649 .24991 .15491 .25301 .16526 .25882 .17524 .25578 Metetra
1 g
.15447 .244 .14448 .24716 .15491 .25301 .1649 .24991 Metetra
1 g
.14395 .23805 .13395 .24128 .14448 .24716 .15447 .244 Metetra
1 g
.13334 .23206 .12333 .23535 .13395 .24128 .14395 .23805 Metetra
1 g
.12264 .22603 .11262 .22938 .12333 .23535 .13334 .23206 Metetra
1 g
.56104 .6561 .55101 .65875 .55862 .66209 .56864 .65946 Metetra
1 g
.55339 .65272 .54334 .65539 .55101 .65875 .56104 .6561 Metetra
1 g
.54556 .63067 .53544 .61495 .54334 .65539 .55339 .65272 Metetra
1 g
.53755 .57646 .52757 .56572 .53544 .61495 .54556 .63067 Metetra
1 g
.52972 .54275 .5198 .53491 .52757 .56572 .53755 .57646 Metetra
1 g
.52194 .51907 .51207 .51314 .5198 .53491 .52972 .54275 Metetra
1 g
.51417 .50103 .50432 .49647 .51207 .51314 .52194 .51907 Metetra
1 g
.50638 .48649 .49655 .48293 .50432 .49647 .51417 .50103 Metetra
1 g
.49856 .47424 .48874 .47147 .49655 .48293 .50638 .48649 Metetra
1 g
.4907 .46358 .48088 .46144 .48874 .47147 .49856 .47424 Metetra
1 g
.48279 .45406 .47298 .45245 .48088 .46144 .4907 .46358 Metetra
1 g
.47484 .44539 .46502 .44422 .47298 .45245 .48279 .45406 Metetra
1 g
.46683 .43736 .45701 .43656 .46502 .44422 .47484 .44539 Metetra
1 g
.45876 .42983 .44894 .42935 .45701 .43656 .46683 .43736 Metetra
1 g
.45064 .42268 .44082 .42249 .44894 .42935 .45876 .42983 Metetra
1 g
.44246 .41585 .43263 .4159 .44082 .42249 .45064 .42268 Metetra
1 g
.43422 .40926 .42438 .40953 .43263 .4159 .44246 .41585 Metetra
1 g
.42592 .40287 .41608 .40335 .42438 .40953 .43422 .40926 Metetra
1 g
.41756 .39664 .40771 .3973 .41608 .40335 .42592 .40287 Metetra
1 g
.40913 .39054 .39927 .39137 .40771 .3973 .41756 .39664 Metetra
1 g
.40064 .38455 .39077 .38554 .39927 .39137 .40913 .39054 Metetra
1 g
.39208 .37865 .38221 .37978 .39077 .38554 .40064 .38455 Metetra
1 g
.38346 .37281 .37357 .37408 .38221 .37978 .39208 .37865 Metetra
1 g
.37477 .36704 .36487 .36843 .37357 .37408 .38346 .37281 Metetra
1 g
.36601 .3613 .35611 .36281 .36487 .36843 .37477 .36704 Metetra
1 g
.35718 .35561 .34727 .35723 .35611 .36281 .36601 .3613 Metetra
1 g
.34828 .34994 .33836 .35166 .34727 .35723 .35718 .35561 Metetra
1 g
.33931 .34428 .32938 .34611 .33836 .35166 .34828 .34994 Metetra
1 g
.33027 .33864 .32033 .34057 .32938 .34611 .33931 .34428 Metetra
1 g
.32115 .33301 .31121 .33502 .32033 .34057 .33027 .33864 Metetra
1 g
.31196 .32738 .30201 .32948 .31121 .33502 .32115 .33301 Metetra
1 g
.3027 .32174 .29273 .32393 .30201 .32948 .31196 .32738 Metetra
1 g
.29336 .3161 .28338 .31837 .29273 .32393 .3027 .32174 Metetra
1 g
.28394 .31044 .27396 .3128 .28338 .31837 .29336 .3161 Metetra
1 g
.27444 .30478 .26445 .30721 .27396 .3128 .28394 .31044 Metetra
1 g
.26487 .29909 .25487 .3016 .26445 .30721 .27444 .30478 Metetra
1 g
.25521 .29339 .24521 .29597 .25487 .3016 .26487 .29909 Metetra
1 g
.24548 .28766 .23546 .29031 .24521 .29597 .25521 .29339 Metetra
1 g
.23566 .28191 .22564 .28463 .23546 .29031 .24548 .28766 Metetra
1 g
.22576 .27613 .21573 .27893 .22564 .28463 .23566 .28191 Metetra
1 g
.21577 .27033 .20574 .27319 .21573 .27893 .22576 .27613 Metetra
1 g
.2057 .26449 .19566 .26742 .20574 .27319 .21577 .27033 Metetra
1 g
.19555 .25863 .1855 .26162 .19566 .26742 .2057 .26449 Metetra
1 g
.1853 .25272 .17524 .25578 .1855 .26162 .19555 .25863 Metetra
1 g
.17497 .24679 .1649 .24991 .17524 .25578 .1853 .25272 Metetra
1 g
.16455 .24081 .15447 .244 .1649 .24991 .17497 .24679 Metetra
1 g
.15403 .2348 .14395 .23805 .15447 .244 .16455 .24081 Metetra
1 g
.14343 .22875 .13334 .23206 .14395 .23805 .15403 .2348 Metetra
1 g
.13273 .22266 .12264 .22603 .13334 .23206 .14343 .22875 Metetra
1 g
.57114 .65344 .56104 .6561 .56864 .65946 .57872 .65682 Metetra
1 g
.56351 .65004 .55339 .65272 .56104 .6561 .57114 .65344 Metetra
1 g
.55581 .64661 .54556 .63067 .55339 .65272 .56351 .65004 Metetra
1 g
.54765 .58733 .53755 .57646 .54556 .63067 .55581 .64661 Metetra
1 g
.53974 .55067 .52972 .54275 .53755 .57646 .54765 .58733 Metetra
1 g
.53191 .52505 .52194 .51907 .52972 .54275 .53974 .55067 Metetra
1 g
.52411 .50564 .51417 .50103 .52194 .51907 .53191 .52505 Metetra
1 g
.5163 .49007 .50638 .48649 .51417 .50103 .52411 .50564 Metetra
1 g
.50847 .47702 .49856 .47424 .50638 .48649 .5163 .49007 Metetra
1 g
.5006 .46573 .4907 .46358 .49856 .47424 .50847 .47702 Metetra
1 g
.49269 .45569 .48279 .45406 .4907 .46358 .5006 .46573 Metetra
1 g
.48473 .44658 .47484 .44539 .48279 .45406 .49269 .45569 Metetra
1 g
.47672 .43817 .46683 .43736 .47484 .44539 .48473 .44658 Metetra
1 g
.46866 .43031 .45876 .42983 .46683 .43736 .47672 .43817 Metetra
1 g
.46054 .42288 .45064 .42268 .45876 .42983 .46866 .43031 Metetra
1 g
.45237 .41579 .44246 .41585 .45064 .42268 .46054 .42288 Metetra
1 g
.44413 .40898 .43422 .40926 .44246 .41585 .45237 .41579 Metetra
1 g
.43584 .40238 .42592 .40287 .43422 .40926 .44413 .40898 Metetra
1 g
.42748 .39597 .41756 .39664 .42592 .40287 .43584 .40238 Metetra
1 g
.41906 .3897 .40913 .39054 .41756 .39664 .42748 .39597 Metetra
1 g
.41058 .38356 .40064 .38455 .40913 .39054 .41906 .3897 Metetra
1 g
.40203 .37751 .39208 .37865 .40064 .38455 .41058 .38356 Metetra
1 g
.39341 .37154 .38346 .37281 .39208 .37865 .40203 .37751 Metetra
1 g
.38473 .36564 .37477 .36704 .38346 .37281 .39341 .37154 Metetra
1 g
.37598 .35978 .36601 .3613 .37477 .36704 .38473 .36564 Metetra
1 g
.36716 .35398 .35718 .35561 .36601 .3613 .37598 .35978 Metetra
1 g
.35827 .3482 .34828 .34994 .35718 .35561 .36716 .35398 Metetra
1 g
.34931 .34244 .33931 .34428 .34828 .34994 .35827 .3482 Metetra
1 g
.34027 .33671 .33027 .33864 .33931 .34428 .34931 .34244 Metetra
1 g
.33117 .33098 .32115 .33301 .33027 .33864 .34027 .33671 Metetra
1 g
.32199 .32526 .31196 .32738 .32115 .33301 .33117 .33098 Metetra
1 g
.31273 .31953 .3027 .32174 .31196 .32738 .32199 .32526 Metetra
1 g
.3034 .31381 .29336 .3161 .3027 .32174 .31273 .31953 Metetra
1 g
.29399 .30807 .28394 .31044 .29336 .3161 .3034 .31381 Metetra
1 g
.2845 .30233 .27444 .30478 .28394 .31044 .29399 .30807 Metetra
1 g
.27494 .29657 .26487 .29909 .27444 .30478 .2845 .30233 Metetra
1 g
.26529 .29079 .25521 .29339 .26487 .29909 .27494 .29657 Metetra
1 g
.25556 .28499 .24548 .28766 .25521 .29339 .26529 .29079 Metetra
1 g
.24575 .27917 .23566 .28191 .24548 .28766 .25556 .28499 Metetra
1 g
.23586 .27332 .22576 .27613 .23566 .28191 .24575 .27917 Metetra
1 g
.22588 .26745 .21577 .27033 .22576 .27613 .23586 .27332 Metetra
1 g
.21582 .26154 .2057 .26449 .21577 .27033 .22588 .26745 Metetra
1 g
.20567 .25561 .19555 .25863 .2057 .26449 .21582 .26154 Metetra
1 g
.19543 .24964 .1853 .25272 .19555 .25863 .20567 .25561 Metetra
1 g
.18511 .24364 .17497 .24679 .1853 .25272 .19543 .24964 Metetra
1 g
.17469 .2376 .16455 .24081 .17497 .24679 .18511 .24364 Metetra
1 g
.16418 .23153 .15403 .2348 .16455 .24081 .17469 .2376 Metetra
1 g
.15358 .22541 .14343 .22875 .15403 .2348 .16418 .23153 Metetra
1 g
.14289 .21926 .13273 .22266 .14343 .22875 .15358 .22541 Metetra
1 g
.5813 .65077 .57114 .65344 .57872 .65682 .58886 .65416 Metetra
1 g
.57368 .64734 .56351 .65004 .57114 .65344 .5813 .65077 Metetra
1 g
.566 .64389 .55581 .64661 .56351 .65004 .57368 .64734 Metetra
1 g
.55787 .59833 .54765 .58733 .55581 .64661 .566 .64389 Metetra
1 g
.54986 .55867 .53974 .55067 .54765 .58733 .55787 .59833 Metetra
1 g
.54198 .53109 .53191 .52505 .53974 .55067 .54986 .55867 Metetra
1 g
.53414 .5103 .52411 .50564 .53191 .52505 .54198 .53109 Metetra
1 g
.5263 .49369 .5163 .49007 .52411 .50564 .53414 .5103 Metetra
1 g
.51845 .47984 .50847 .47702 .5163 .49007 .5263 .49369 Metetra
1 g
.51058 .46789 .5006 .46573 .50847 .47702 .51845 .47984 Metetra
1 g
.50266 .45732 .49269 .45569 .5006 .46573 .51058 .46789 Metetra
1 g
.4947 .44777 .48473 .44658 .49269 .45569 .50266 .45732 Metetra
1 g
.48669 .43899 .47672 .43817 .48473 .44658 .4947 .44777 Metetra
1 g
.47863 .4308 .46866 .43031 .47672 .43817 .48669 .43899 Metetra
1 g
.47052 .42308 .46054 .42288 .46866 .43031 .47863 .4308 Metetra
1 g
.46235 .41574 .45237 .41579 .46054 .42288 .47052 .42308 Metetra
1 g
.45412 .4087 .44413 .40898 .45237 .41579 .46235 .41574 Metetra
1 g
.44583 .4019 .43584 .40238 .44413 .40898 .45412 .4087 Metetra
1 g
.43748 .3953 .42748 .39597 .43584 .40238 .44583 .4019 Metetra
1 g
.42907 .38886 .41906 .3897 .42748 .39597 .43748 .3953 Metetra
1 g
.42059 .38255 .41058 .38356 .41906 .3897 .42907 .38886 Metetra
1 g
.41205 .37636 .40203 .37751 .41058 .38356 .42059 .38255 Metetra
1 g
.40344 .37026 .39341 .37154 .40203 .37751 .41205 .37636 Metetra
1 g
.39477 .36423 .38473 .36564 .39341 .37154 .40344 .37026 Metetra
1 g
.38603 .35825 .37598 .35978 .38473 .36564 .39477 .36423 Metetra
1 g
.37721 .35233 .36716 .35398 .37598 .35978 .38603 .35825 Metetra
1 g
.36833 .34645 .35827 .3482 .36716 .35398 .37721 .35233 Metetra
1 g
.35938 .34059 .34931 .34244 .35827 .3482 .36833 .34645 Metetra
1 g
.35036 .33476 .34027 .33671 .34931 .34244 .35938 .34059 Metetra
1 g
.34126 .32893 .33117 .33098 .34027 .33671 .35036 .33476 Metetra
1 g
.33209 .32312 .32199 .32526 .33117 .33098 .34126 .32893 Metetra
1 g
.32284 .31731 .31273 .31953 .32199 .32526 .33209 .32312 Metetra
1 g
.31352 .3115 .3034 .31381 .31273 .31953 .32284 .31731 Metetra
1 g
.30412 .30569 .29399 .30807 .3034 .31381 .31352 .3115 Metetra
1 g
.29464 .29986 .2845 .30233 .29399 .30807 .30412 .30569 Metetra
1 g
.28508 .29403 .27494 .29657 .2845 .30233 .29464 .29986 Metetra
1 g
.27544 .28817 .26529 .29079 .27494 .29657 .28508 .29403 Metetra
1 g
.26572 .2823 .25556 .28499 .26529 .29079 .27544 .28817 Metetra
1 g
.25592 .27641 .24575 .27917 .25556 .28499 .26572 .2823 Metetra
1 g
.24604 .27049 .23586 .27332 .24575 .27917 .25592 .27641 Metetra
1 g
.23607 .26455 .22588 .26745 .23586 .27332 .24604 .27049 Metetra
1 g
.22601 .25857 .21582 .26154 .22588 .26745 .23607 .26455 Metetra
1 g
.21587 .25257 .20567 .25561 .21582 .26154 .22601 .25857 Metetra
1 g
.20564 .24654 .19543 .24964 .20567 .25561 .21587 .25257 Metetra
1 g
.19532 .24047 .18511 .24364 .19543 .24964 .20564 .24654 Metetra
1 g
.18491 .23437 .17469 .2376 .18511 .24364 .19532 .24047 Metetra
1 g
.17441 .22823 .16418 .23153 .17469 .2376 .18491 .23437 Metetra
1 g
.16382 .22205 .15358 .22541 .16418 .23153 .17441 .22823 Metetra
1 g
.15313 .21583 .14289 .21926 .15358 .22541 .16382 .22205 Metetra
1 g
.59152 .64807 .5813 .65077 .58886 .65416 .59906 .65149 Metetra
1 g
.58391 .64463 .57368 .64734 .5813 .65077 .59152 .64807 Metetra
1 g
.57625 .64116 .566 .64389 .57368 .64734 .58391 .64463 Metetra
1 g
.56821 .60945 .55787 .59833 .566 .64389 .57625 .64116 Metetra
1 g
.56009 .56675 .54986 .55867 .55787 .59833 .56821 .60945 Metetra
1 g
.55214 .53719 .54198 .53109 .54986 .55867 .56009 .56675 Metetra
1 g
.54426 .51499 .53414 .5103 .54198 .53109 .55214 .53719 Metetra
1 g
.5364 .49734 .5263 .49369 .53414 .5103 .54426 .51499 Metetra
1 g
.52853 .48267 .51845 .47984 .5263 .49369 .5364 .49734 Metetra
1 g
.52064 .47008 .51058 .46789 .51845 .47984 .52853 .48267 Metetra
1 g
.51272 .45898 .50266 .45732 .51058 .46789 .52064 .47008 Metetra
1 g
.50475 .44897 .4947 .44777 .50266 .45732 .51272 .45898 Metetra
1 g
.49674 .43981 .48669 .43899 .4947 .44777 .50475 .44897 Metetra
1 g
.48868 .43129 .47863 .4308 .48669 .43899 .49674 .43981 Metetra
1 g
.48057 .42329 .47052 .42308 .47863 .4308 .48868 .43129 Metetra
1 g
.4724 .41569 .46235 .41574 .47052 .42308 .48057 .42329 Metetra
1 g
.46418 .40841 .45412 .4087 .46235 .41574 .4724 .41569 Metetra
1 g
.4559 .40141 .44583 .4019 .45412 .4087 .46418 .40841 Metetra
1 g
.44755 .39462 .43748 .3953 .44583 .4019 .4559 .40141 Metetra
1 g
.43915 .38801 .42907 .38886 .43748 .3953 .44755 .39462 Metetra
1 g
.43068 .38155 .42059 .38255 .42907 .38886 .43915 .38801 Metetra
1 g
.42214 .3752 .41205 .37636 .42059 .38255 .43068 .38155 Metetra
1 g
.41355 .36896 .40344 .37026 .41205 .37636 .42214 .3752 Metetra
1 g
.40488 .3628 .39477 .36423 .40344 .37026 .41355 .36896 Metetra
1 g
.39615 .35671 .38603 .35825 .39477 .36423 .40488 .3628 Metetra
1 g
.38734 .35068 .37721 .35233 .38603 .35825 .39615 .35671 Metetra
1 g
.37847 .34468 .36833 .34645 .37721 .35233 .38734 .35068 Metetra
1 g
.36953 .33872 .35938 .34059 .36833 .34645 .37847 .34468 Metetra
1 g
.36051 .33279 .35036 .33476 .35938 .34059 .36953 .33872 Metetra
1 g
.35142 .32687 .34126 .32893 .35036 .33476 .36051 .33279 Metetra
1 g
.34226 .32097 .33209 .32312 .34126 .32893 .35142 .32687 Metetra
1 g
.33302 .31508 .32284 .31731 .33209 .32312 .34226 .32097 Metetra
1 g
.32371 .30918 .31352 .3115 .32284 .31731 .33302 .31508 Metetra
1 g
.31432 .30328 .30412 .30569 .31352 .3115 .32371 .30918 Metetra
1 g
.30485 .29738 .29464 .29986 .30412 .30569 .31432 .30328 Metetra
1 g
.2953 .29146 .28508 .29403 .29464 .29986 .30485 .29738 Metetra
1 g
.28567 .28554 .27544 .28817 .28508 .29403 .2953 .29146 Metetra
1 g
.27596 .27959 .26572 .2823 .27544 .28817 .28567 .28554 Metetra
1 g
.26617 .27362 .25592 .27641 .26572 .2823 .27596 .27959 Metetra
1 g
.25629 .26763 .24604 .27049 .25592 .27641 .26617 .27362 Metetra
1 g
.24633 .26162 .23607 .26455 .24604 .27049 .25629 .26763 Metetra
1 g
.23628 .25558 .22601 .25857 .23607 .26455 .24633 .26162 Metetra
1 g
.22615 .24951 .21587 .25257 .22601 .25857 .23628 .25558 Metetra
1 g
.21593 .24341 .20564 .24654 .21587 .25257 .22615 .24951 Metetra
1 g
.20562 .23728 .19532 .24047 .20564 .24654 .21593 .24341 Metetra
1 g
.19521 .23111 .18491 .23437 .19532 .24047 .20562 .23728 Metetra
1 g
.18472 .2249 .17441 .22823 .18491 .23437 .19521 .23111 Metetra
1 g
.17413 .21866 .16382 .22205 .17441 .22823 .18472 .2249 Metetra
1 g
.16345 .21238 .15313 .21583 .16382 .22205 .17413 .21866 Metetra
1 g
.6018 .64536 .59152 .64807 .59906 .65149 .60933 .6488 Metetra
1 g
.59421 .6419 .58391 .64463 .59152 .64807 .6018 .64536 Metetra
1 g
.58657 .6384 .57625 .64116 .58391 .64463 .59421 .6419 Metetra
1 g
.57867 .62071 .56821 .60945 .57625 .64116 .58657 .6384 Metetra
1 g
.57043 .57492 .56009 .56675 .56821 .60945 .57867 .62071 Metetra
1 g
.5624 .54335 .55214 .53719 .56009 .56675 .57043 .57492 Metetra
1 g
.55447 .51973 .54426 .51499 .55214 .53719 .5624 .54335 Metetra
1 g
.54658 .50102 .5364 .49734 .54426 .51499 .55447 .51973 Metetra
1 g
.53869 .48553 .52853 .48267 .5364 .49734 .54658 .50102 Metetra
1 g
.53078 .47228 .52064 .47008 .52853 .48267 .53869 .48553 Metetra
1 g
.52285 .46064 .51272 .45898 .52064 .47008 .53078 .47228 Metetra
1 g
.51488 .45019 .50475 .44897 .51272 .45898 .52285 .46064 Metetra
1 g
.50687 .44064 .49674 .43981 .50475 .44897 .51488 .45019 Metetra
1 g
.49881 .43179 .48868 .43129 .49674 .43981 .50687 .44064 Metetra
1 g
.4907 .42349 .48057 .42329 .48868 .43129 .49881 .43179 Metetra
1 g
.48254 .41563 .4724 .41569 .48057 .42329 .4907 .42349 Metetra
1 g
.47432 .40813 .46418 .40841 .4724 .41569 .48254 .41563 Metetra
1 g
.46604 .40091 .4559 .40141 .46418 .40841 .47432 .40813 Metetra
1 g
.4577 .39394 .44755 .39462 .4559 .40141 .46604 .40091 Metetra
1 g
.4493 .38715 .43915 .38801 .44755 .39462 .4577 .39394 Metetra
1 g
.44084 .38053 .43068 .38155 .43915 .38801 .4493 .38715 Metetra
1 g
.43231 .37404 .42214 .3752 .43068 .38155 .44084 .38053 Metetra
1 g
.42372 .36766 .41355 .36896 .42214 .3752 .43231 .37404 Metetra
1 g
.41506 .36137 .40488 .3628 .41355 .36896 .42372 .36766 Metetra
1 g
.40634 .35516 .39615 .35671 .40488 .3628 .41506 .36137 Metetra
1 g
.39755 .34901 .38734 .35068 .39615 .35671 .40634 .35516 Metetra
1 g
.38868 .34291 .37847 .34468 .38734 .35068 .39755 .34901 Metetra
1 g
.37975 .33684 .36953 .33872 .37847 .34468 .38868 .34291 Metetra
1 g
.37074 .33081 .36051 .33279 .36953 .33872 .37975 .33684 Metetra
1 g
.36166 .3248 .35142 .32687 .36051 .33279 .37074 .33081 Metetra
1 g
.35251 .31881 .34226 .32097 .35142 .32687 .36166 .3248 Metetra
1 g
.34328 .31282 .33302 .31508 .34226 .32097 .35251 .31881 Metetra
1 g
.33397 .30684 .32371 .30918 .33302 .31508 .34328 .31282 Metetra
1 g
.32459 .30086 .31432 .30328 .32371 .30918 .33397 .30684 Metetra
1 g
.31513 .29488 .30485 .29738 .31432 .30328 .32459 .30086 Metetra
1 g
.30559 .28888 .2953 .29146 .30485 .29738 .31513 .29488 Metetra
1 g
.29597 .28288 .28567 .28554 .2953 .29146 .30559 .28888 Metetra
1 g
.28627 .27686 .27596 .27959 .28567 .28554 .29597 .28288 Metetra
1 g
.27648 .27082 .26617 .27362 .27596 .27959 .28627 .27686 Metetra
1 g
.26662 .26476 .25629 .26763 .26617 .27362 .27648 .27082 Metetra
1 g
.25666 .25868 .24633 .26162 .25629 .26763 .26662 .26476 Metetra
1 g
.24663 .25257 .23628 .25558 .24633 .26162 .25666 .25868 Metetra
1 g
.2365 .24643 .22615 .24951 .23628 .25558 .24663 .25257 Metetra
1 g
.22629 .24026 .21593 .24341 .22615 .24951 .2365 .24643 Metetra
1 g
.21598 .23406 .20562 .23728 .21593 .24341 .22629 .24026 Metetra
1 g
.20559 .22783 .19521 .23111 .20562 .23728 .21598 .23406 Metetra
1 g
.1951 .22155 .18472 .2249 .19521 .23111 .20559 .22783 Metetra
1 g
.18453 .21525 .17413 .21866 .18472 .2249 .1951 .22155 Metetra
1 g
.17385 .2089 .16345 .21238 .17413 .21866 .18453 .21525 Metetra
1 g
.61214 .64263 .6018 .64536 .60933 .6488 .61965 .64609 Metetra
1 g
.60457 .63915 .59421 .6419 .6018 .64536 .61214 .64263 Metetra
1 g
.59694 .63564 .58657 .6384 .59421 .6419 .60457 .63915 Metetra
1 g
.58926 .6321 .57867 .62071 .58657 .6384 .59694 .63564 Metetra
1 g
.58088 .58318 .57043 .57492 .57867 .62071 .58926 .6321 Metetra
1 g
.57277 .54956 .5624 .54335 .57043 .57492 .58088 .58318 Metetra
1 g
.56478 .52451 .55447 .51973 .5624 .54335 .57277 .54956 Metetra
1 g
.55685 .50473 .54658 .50102 .55447 .51973 .56478 .52451 Metetra
1 g
.54894 .48842 .53869 .48553 .54658 .50102 .55685 .50473 Metetra
1 g
.54102 .47451 .53078 .47228 .53869 .48553 .54894 .48842 Metetra
1 g
.53307 .46232 .52285 .46064 .53078 .47228 .54102 .47451 Metetra
1 g
.52509 .45141 .51488 .45019 .52285 .46064 .53307 .46232 Metetra
1 g
.51708 .44147 .50687 .44064 .51488 .45019 .52509 .45141 Metetra
1 g
.50902 .43229 .49881 .43179 .50687 .44064 .51708 .44147 Metetra
1 g
.50091 .4237 .4907 .42349 .49881 .43179 .50902 .43229 Metetra
1 g
.49275 .41558 .48254 .41563 .4907 .42349 .50091 .4237 Metetra
1 g
.48453 .40784 .47432 .40813 .48254 .41563 .49275 .41558 Metetra
1 g
.47626 .40042 .46604 .40091 .47432 .40813 .48453 .40784 Metetra
1 g
.46792 .39325 .4577 .39394 .46604 .40091 .47626 .40042 Metetra
1 g
.45953 .38629 .4493 .38715 .4577 .39394 .46792 .39325 Metetra
1 g
.45108 .37951 .44084 .38053 .4493 .38715 .45953 .38629 Metetra
1 g
.44256 .37287 .43231 .37404 .44084 .38053 .45108 .37951 Metetra
1 g
.43398 .36635 .42372 .36766 .43231 .37404 .44256 .37287 Metetra
1 g
.42533 .35993 .41506 .36137 .42372 .36766 .43398 .36635 Metetra
1 g
.41661 .3536 .40634 .35516 .41506 .36137 .42533 .35993 Metetra
1 g
.40782 .34733 .39755 .34901 .40634 .35516 .41661 .3536 Metetra
1 g
.39897 .34112 .38868 .34291 .39755 .34901 .40782 .34733 Metetra
1 g
.39004 .33495 .37975 .33684 .38868 .34291 .39897 .34112 Metetra
1 g
.38104 .32882 .37074 .33081 .37975 .33684 .39004 .33495 Metetra
1 g
.37197 .32271 .36166 .3248 .37074 .33081 .38104 .32882 Metetra
1 g
.36283 .31662 .35251 .31881 .36166 .3248 .37197 .32271 Metetra
1 g
.35361 .31055 .34328 .31282 .35251 .31881 .36283 .31662 Metetra
1 g
.34431 .30449 .33397 .30684 .34328 .31282 .35361 .31055 Metetra
1 g
.33494 .29842 .32459 .30086 .33397 .30684 .34431 .30449 Metetra
1 g
.32549 .29236 .31513 .29488 .32459 .30086 .33494 .29842 Metetra
1 g
.31596 .28629 .30559 .28888 .31513 .29488 .32549 .29236 Metetra
1 g
.30635 .2802 .29597 .28288 .30559 .28888 .31596 .28629 Metetra
1 g
.29666 .27411 .28627 .27686 .29597 .28288 .30635 .2802 Metetra
1 g
.28688 .26799 .27648 .27082 .28627 .27686 .29666 .27411 Metetra
1 g
.27702 .26186 .26662 .26476 .27648 .27082 .28688 .26799 Metetra
1 g
.26708 .25571 .25666 .25868 .26662 .26476 .27702 .26186 Metetra
1 g
.25705 .24953 .24663 .25257 .25666 .25868 .26708 .25571 Metetra
1 g
.24693 .24332 .2365 .24643 .24663 .25257 .25705 .24953 Metetra
1 g
.23673 .23709 .22629 .24026 .2365 .24643 .24693 .24332 Metetra
1 g
.22643 .23082 .21598 .23406 .22629 .24026 .23673 .23709 Metetra
1 g
.21605 .22452 .20559 .22783 .21598 .23406 .22643 .23082 Metetra
1 g
.20557 .21818 .1951 .22155 .20559 .22783 .21605 .22452 Metetra
1 g
.195 .21181 .18453 .21525 .1951 .22155 .20557 .21818 Metetra
1 g
.18433 .20539 .17385 .2089 .18453 .21525 .195 .21181 Metetra
1 g
.62255 .63989 .61214 .64263 .61965 .64609 .63004 .64337 Metetra
1 g
.615 .63638 .60457 .63915 .61214 .64263 .62255 .63989 Metetra
1 g
.60738 .63285 .59694 .63564 .60457 .63915 .615 .63638 Metetra
1 g
.59971 .62929 .58926 .6321 .59694 .63564 .60738 .63285 Metetra
1 g
.59144 .59152 .58088 .58318 .58926 .6321 .59971 .62929 Metetra
1 g
.58323 .55584 .57277 .54956 .58088 .58318 .59144 .59152 Metetra
1 g
.57519 .52934 .56478 .52451 .57277 .54956 .58323 .55584 Metetra
1 g
.56722 .50848 .55685 .50473 .56478 .52451 .57519 .52934 Metetra
1 g
.55927 .49133 .54894 .48842 .55685 .50473 .56722 .50848 Metetra
1 g
.55133 .47675 .54102 .47451 .54894 .48842 .55927 .49133 Metetra
1 g
.54337 .46401 .53307 .46232 .54102 .47451 .55133 .47675 Metetra
1 g
.53539 .45264 .52509 .45141 .53307 .46232 .54337 .46401 Metetra
1 g
.52737 .44231 .51708 .44147 .52509 .45141 .53539 .45264 Metetra
1 g
.51931 .43279 .50902 .43229 .51708 .44147 .52737 .44231 Metetra
1 g
.5112 .4239 .50091 .4237 .50902 .43229 .51931 .43279 Metetra
1 g
.50304 .41552 .49275 .41558 .50091 .4237 .5112 .4239 Metetra
1 g
.49482 .40755 .48453 .40784 .49275 .41558 .50304 .41552 Metetra
1 g
.48655 .39992 .47626 .40042 .48453 .40784 .49482 .40755 Metetra
1 g
.47823 .39255 .46792 .39325 .47626 .40042 .48655 .39992 Metetra
1 g
.46984 .38542 .45953 .38629 .46792 .39325 .47823 .39255 Metetra
1 g
.46139 .37847 .45108 .37951 .45953 .38629 .46984 .38542 Metetra
1 g
.45288 .37169 .44256 .37287 .45108 .37951 .46139 .37847 Metetra
1 g
.4443 .36503 .43398 .36635 .44256 .37287 .45288 .37169 Metetra
1 g
.43566 .35848 .42533 .35993 .43398 .36635 .4443 .36503 Metetra
1 g
.42695 .35202 .41661 .3536 .42533 .35993 .43566 .35848 Metetra
1 g
.41818 .34564 .40782 .34733 .41661 .3536 .42695 .35202 Metetra
1 g
.40933 .33931 .39897 .34112 .40782 .34733 .41818 .34564 Metetra
1 g
.40041 .33304 .39004 .33495 .39897 .34112 .40933 .33931 Metetra
1 g
.39142 .32681 .38104 .32882 .39004 .33495 .40041 .33304 Metetra
1 g
.38236 .32061 .37197 .32271 .38104 .32882 .39142 .32681 Metetra
1 g
.37323 .31443 .36283 .31662 .37197 .32271 .38236 .32061 Metetra
1 g
.36402 .30826 .35361 .31055 .36283 .31662 .37323 .31443 Metetra
1 g
.35473 .30211 .34431 .30449 .35361 .31055 .36402 .30826 Metetra
1 g
.34537 .29596 .33494 .29842 .34431 .30449 .35473 .30211 Metetra
1 g
.33593 .28982 .32549 .29236 .33494 .29842 .34537 .29596 Metetra
1 g
.32641 .28367 .31596 .28629 .32549 .29236 .33593 .28982 Metetra
1 g
.3168 .27751 .30635 .2802 .31596 .28629 .32641 .28367 Metetra
1 g
.30712 .27134 .29666 .27411 .30635 .2802 .3168 .27751 Metetra
1 g
.29736 .26515 .28688 .26799 .29666 .27411 .30712 .27134 Metetra
1 g
.28751 .25894 .27702 .26186 .28688 .26799 .29736 .26515 Metetra
1 g
.27757 .25272 .26708 .25571 .27702 .26186 .28751 .25894 Metetra
1 g
.26755 .24647 .25705 .24953 .26708 .25571 .27757 .25272 Metetra
1 g
.25744 .24019 .24693 .24332 .25705 .24953 .26755 .24647 Metetra
1 g
.24724 .23389 .23673 .23709 .24693 .24332 .25744 .24019 Metetra
1 g
.23696 .22755 .22643 .23082 .23673 .23709 .24724 .23389 Metetra
1 g
.22658 .22118 .21605 .22452 .22643 .23082 .23696 .22755 Metetra
1 g
.21611 .21478 .20557 .21818 .21605 .22452 .22658 .22118 Metetra
1 g
.20555 .20834 .195 .21181 .20557 .21818 .21611 .21478 Metetra
1 g
.19489 .20186 .18433 .20539 .195 .21181 .20555 .20834 Metetra
1 g
.63302 .63713 .62255 .63989 .63004 .64337 .64049 .64063 Metetra
1 g
.62548 .6336 .615 .63638 .62255 .63989 .63302 .63713 Metetra
1 g
.61789 .63005 .60738 .63285 .615 .63638 .62548 .6336 Metetra
1 g
.61024 .62646 .59971 .62929 .60738 .63285 .61789 .63005 Metetra
1 g
.60211 .59996 .59144 .59152 .59971 .62929 .61024 .62646 Metetra
1 g
.59381 .56219 .58323 .55584 .59144 .59152 .60211 .59996 Metetra
1 g
.58569 .53421 .57519 .52934 .58323 .55584 .59381 .56219 Metetra
1 g
.57767 .51226 .56722 .50848 .57519 .52934 .58569 .53421 Metetra
1 g
.5697 .49427 .55927 .49133 .56722 .50848 .57767 .51226 Metetra
1 g
.56174 .47901 .55133 .47675 .55927 .49133 .5697 .49427 Metetra
1 g
.55376 .46572 .54337 .46401 .55133 .47675 .56174 .47901 Metetra
1 g
.54577 .45389 .53539 .45264 .54337 .46401 .55376 .46572 Metetra
1 g
.53774 .44316 .52737 .44231 .53539 .45264 .54577 .45389 Metetra
1 g
.52967 .4333 .51931 .43279 .52737 .44231 .53774 .44316 Metetra
1 g
.52156 .42411 .5112 .4239 .51931 .43279 .52967 .4333 Metetra
1 g
.5134 .41547 .50304 .41552 .5112 .4239 .52156 .42411 Metetra
1 g
.50519 .40726 .49482 .40755 .50304 .41552 .5134 .41547 Metetra
1 g
.49693 .39941 .48655 .39992 .49482 .40755 .50519 .40726 Metetra
1 g
.48861 .39186 .47823 .39255 .48655 .39992 .49693 .39941 Metetra
1 g
.48022 .38454 .46984 .38542 .47823 .39255 .48861 .39186 Metetra
1 g
.47178 .37744 .46139 .37847 .46984 .38542 .48022 .38454 Metetra
1 g
.46328 .3705 .45288 .37169 .46139 .37847 .47178 .37744 Metetra
1 g
.45471 .3637 .4443 .36503 .45288 .37169 .46328 .3705 Metetra
1 g
.44608 .35702 .43566 .35848 .4443 .36503 .45471 .3637 Metetra
1 g
.43738 .35043 .42695 .35202 .43566 .35848 .44608 .35702 Metetra
1 g
.42861 .34393 .41818 .34564 .42695 .35202 .43738 .35043 Metetra
1 g
.41977 .3375 .40933 .33931 .41818 .34564 .42861 .34393 Metetra
1 g
.41086 .33112 .40041 .33304 .40933 .33931 .41977 .3375 Metetra
1 g
.40188 .32478 .39142 .32681 .40041 .33304 .41086 .33112 Metetra
1 g
.39283 .31848 .38236 .32061 .39142 .32681 .40188 .32478 Metetra
1 g
.3837 .31221 .37323 .31443 .38236 .32061 .39283 .31848 Metetra
1 g
.3745 .30596 .36402 .30826 .37323 .31443 .3837 .31221 Metetra
1 g
.36523 .29972 .35473 .30211 .36402 .30826 .3745 .30596 Metetra
1 g
.35587 .29349 .34537 .29596 .35473 .30211 .36523 .29972 Metetra
1 g
.34644 .28726 .33593 .28982 .34537 .29596 .35587 .29349 Metetra
1 g
.33693 .28103 .32641 .28367 .33593 .28982 .34644 .28726 Metetra
1 g
.32734 .27479 .3168 .27751 .32641 .28367 .33693 .28103 Metetra
1 g
.31766 .26854 .30712 .27134 .3168 .27751 .32734 .27479 Metetra
1 g
.30791 .26228 .29736 .26515 .30712 .27134 .31766 .26854 Metetra
1 g
.29807 .256 .28751 .25894 .29736 .26515 .30791 .26228 Metetra
1 g
.28814 .24971 .27757 .25272 .28751 .25894 .29807 .256 Metetra
1 g
.27813 .24338 .26755 .24647 .27757 .25272 .28814 .24971 Metetra
1 g
.26803 .23704 .25744 .24019 .26755 .24647 .27813 .24338 Metetra
1 g
.25784 .23066 .24724 .23389 .25744 .24019 .26803 .23704 Metetra
1 g
.24756 .22426 .23696 .22755 .24724 .23389 .25784 .23066 Metetra
1 g
.2372 .21782 .22658 .22118 .23696 .22755 .24756 .22426 Metetra
1 g
.22673 .21135 .21611 .21478 .22658 .22118 .2372 .21782 Metetra
1 g
.21618 .20485 .20555 .20834 .21611 .21478 .22673 .21135 Metetra
1 g
.20553 .1983 .19489 .20186 .20555 .20834 .21618 .20485 Metetra
1 g
.64355 .63436 .63302 .63713 .64049 .64063 .65101 .63788 Metetra
1 g
.63603 .6308 .62548 .6336 .63302 .63713 .64355 .63436 Metetra
1 g
.62846 .62723 .61789 .63005 .62548 .6336 .63603 .6308 Metetra
1 g
.62082 .62362 .61024 .62646 .61789 .63005 .62846 .62723 Metetra
1 g
.6129 .60848 .60211 .59996 .61024 .62646 .62082 .62362 Metetra
1 g
.60448 .56859 .59381 .56219 .60211 .59996 .6129 .60848 Metetra
1 g
.5963 .53913 .58569 .53421 .59381 .56219 .60448 .56859 Metetra
1 g
.58823 .51608 .57767 .51226 .58569 .53421 .5963 .53913 Metetra
1 g
.58022 .49723 .5697 .49427 .57767 .51226 .58823 .51608 Metetra
1 g
.57223 .48129 .56174 .47901 .5697 .49427 .58022 .49723 Metetra
1 g
.56424 .46744 .55376 .46572 .56174 .47901 .57223 .48129 Metetra
1 g
.55623 .45514 .54577 .45389 .55376 .46572 .56424 .46744 Metetra
1 g
.5482 .44402 .53774 .44316 .54577 .45389 .55623 .45514 Metetra
1 g
.54012 .43381 .52967 .4333 .53774 .44316 .5482 .44402 Metetra
1 g
.53201 .42432 .52156 .42411 .52967 .4333 .54012 .43381 Metetra
1 g
.52385 .41541 .5134 .41547 .52156 .42411 .53201 .42432 Metetra
1 g
.51564 .40697 .50519 .40726 .5134 .41547 .52385 .41541 Metetra
1 g
.50738 .3989 .49693 .39941 .50519 .40726 .51564 .40697 Metetra
1 g
.49906 .39115 .48861 .39186 .49693 .39941 .50738 .3989 Metetra
1 g
.49069 .38366 .48022 .38454 .48861 .39186 .49906 .39115 Metetra
1 g
.48225 .37639 .47178 .37744 .48022 .38454 .49069 .38366 Metetra
1 g
.47375 .3693 .46328 .3705 .47178 .37744 .48225 .37639 Metetra
1 g
.46519 .36236 .45471 .3637 .46328 .3705 .47375 .3693 Metetra
1 g
.45657 .35554 .44608 .35702 .45471 .3637 .46519 .36236 Metetra
1 g
.44788 .34883 .43738 .35043 .44608 .35702 .45657 .35554 Metetra
1 g
.43912 .34221 .42861 .34393 .43738 .35043 .44788 .34883 Metetra
1 g
.43029 .33567 .41977 .3375 .42861 .34393 .43912 .34221 Metetra
1 g
.42139 .32918 .41086 .33112 .41977 .3375 .43029 .33567 Metetra
1 g
.41242 .32274 .40188 .32478 .41086 .33112 .42139 .32918 Metetra
1 g
.40338 .31635 .39283 .31848 .40188 .32478 .41242 .32274 Metetra
1 g
.39426 .30998 .3837 .31221 .39283 .31848 .40338 .31635 Metetra
1 g
.38507 .30364 .3745 .30596 .3837 .31221 .39426 .30998 Metetra
1 g
.3758 .29731 .36523 .29972 .3745 .30596 .38507 .30364 Metetra
1 g
.36646 .29099 .35587 .29349 .36523 .29972 .3758 .29731 Metetra
1 g
.35703 .28468 .34644 .28726 .35587 .29349 .36646 .29099 Metetra
1 g
.34753 .27837 .33693 .28103 .34644 .28726 .35703 .28468 Metetra
1 g
.33795 .27205 .32734 .27479 .33693 .28103 .34753 .27837 Metetra
1 g
.32829 .26573 .31766 .26854 .32734 .27479 .33795 .27205 Metetra
1 g
.31854 .25939 .30791 .26228 .31766 .26854 .32829 .26573 Metetra
1 g
.30871 .25304 .29807 .256 .30791 .26228 .31854 .25939 Metetra
1 g
.29879 .24667 .28814 .24971 .29807 .256 .30871 .25304 Metetra
1 g
.28879 .24028 .27813 .24338 .28814 .24971 .29879 .24667 Metetra
1 g
.2787 .23386 .26803 .23704 .27813 .24338 .28879 .24028 Metetra
1 g
.26852 .22742 .25784 .23066 .26803 .23704 .2787 .23386 Metetra
1 g
.25825 .22094 .24756 .22426 .25784 .23066 .26852 .22742 Metetra
1 g
.24789 .21444 .2372 .21782 .24756 .22426 .25825 .22094 Metetra
1 g
.23744 .2079 .22673 .21135 .2372 .21782 .24789 .21444 Metetra
1 g
.22689 .20133 .21618 .20485 .22673 .21135 .23744 .2079 Metetra
1 g
.21625 .19471 .20553 .1983 .21618 .20485 .22689 .20133 Metetra
1 g
.65415 .63156 .64355 .63436 .65101 .63788 .66159 .63511 Metetra
1 g
.64665 .62799 .63603 .6308 .64355 .63436 .65415 .63156 Metetra
1 g
.63909 .62439 .62846 .62723 .63603 .6308 .64665 .62799 Metetra
1 g
.63148 .62076 .62082 .62362 .62846 .62723 .63909 .62439 Metetra
1 g
.6238 .6171 .6129 .60848 .62082 .62362 .63148 .62076 Metetra
1 g
.61526 .57506 .60448 .56859 .6129 .60848 .6238 .6171 Metetra
1 g
.607 .5441 .5963 .53913 .60448 .56859 .61526 .57506 Metetra
1 g
.59888 .51992 .58823 .51608 .5963 .53913 .607 .5441 Metetra
1 g
.59083 .50021 .58022 .49723 .58823 .51608 .59888 .51992 Metetra
1 g
.58281 .48359 .57223 .48129 .58022 .49723 .59083 .50021 Metetra
1 g
.5748 .46917 .56424 .46744 .57223 .48129 .58281 .48359 Metetra
1 g
.56678 .4564 .55623 .45514 .56424 .46744 .5748 .46917 Metetra
1 g
.55873 .44488 .5482 .44402 .55623 .45514 .56678 .4564 Metetra
1 g
.55066 .43432 .54012 .43381 .5482 .44402 .55873 .44488 Metetra
1 g
.54254 .42453 .53201 .42432 .54012 .43381 .55066 .43432 Metetra
1 g
.53438 .41535 .52385 .41541 .53201 .42432 .54254 .42453 Metetra
1 g
.52618 .40667 .51564 .40697 .52385 .41541 .53438 .41535 Metetra
1 g
.51792 .39839 .50738 .3989 .51564 .40697 .52618 .40667 Metetra
1 g
.5096 .39044 .49906 .39115 .50738 .3989 .51792 .39839 Metetra
1 g
.50123 .38277 .49069 .38366 .49906 .39115 .5096 .39044 Metetra
1 g
.4928 .37533 .48225 .37639 .49069 .38366 .50123 .38277 Metetra
1 g
.48431 .36809 .47375 .3693 .48225 .37639 .4928 .37533 Metetra
1 g
.47576 .361 .46519 .36236 .47375 .3693 .48431 .36809 Metetra
1 g
.46714 .35406 .45657 .35554 .46519 .36236 .47576 .361 Metetra
1 g
.45845 .34722 .44788 .34883 .45657 .35554 .46714 .35406 Metetra
1 g
.4497 .34048 .43912 .34221 .44788 .34883 .45845 .34722 Metetra
1 g
.44088 .33382 .43029 .33567 .43912 .34221 .4497 .34048 Metetra
1 g
.43199 .32723 .42139 .32918 .43029 .33567 .44088 .33382 Metetra
1 g
.42303 .32069 .41242 .32274 .42139 .32918 .43199 .32723 Metetra
1 g
.414 .3142 .40338 .31635 .41242 .32274 .42303 .32069 Metetra
1 g
.40489 .30773 .39426 .30998 .40338 .31635 .414 .3142 Metetra
1 g
.39571 .3013 .38507 .30364 .39426 .30998 .40489 .30773 Metetra
1 g
.38645 .29488 .3758 .29731 .38507 .30364 .39571 .3013 Metetra
1 g
.37712 .28848 .36646 .29099 .3758 .29731 .38645 .29488 Metetra
1 g
.36771 .28209 .35703 .28468 .36646 .29099 .37712 .28848 Metetra
1 g
.35822 .27569 .34753 .27837 .35703 .28468 .36771 .28209 Metetra
1 g
.34864 .2693 .33795 .27205 .34753 .27837 .35822 .27569 Metetra
1 g
.33899 .2629 .32829 .26573 .33795 .27205 .34864 .2693 Metetra
1 g
.32925 .25648 .31854 .25939 .32829 .26573 .33899 .2629 Metetra
1 g
.31943 .25006 .30871 .25304 .31854 .25939 .32925 .25648 Metetra
1 g
.30952 .24361 .29879 .24667 .30871 .25304 .31943 .25006 Metetra
1 g
.29953 .23715 .28879 .24028 .29879 .24667 .30952 .24361 Metetra
1 g
.28945 .23066 .2787 .23386 .28879 .24028 .29953 .23715 Metetra
1 g
.27928 .22414 .26852 .22742 .2787 .23386 .28945 .23066 Metetra
1 g
.26902 .2176 .25825 .22094 .26852 .22742 .27928 .22414 Metetra
1 g
.25867 .21103 .24789 .21444 .25825 .22094 .26902 .2176 Metetra
1 g
.24823 .20442 .23744 .2079 .24789 .21444 .25867 .21103 Metetra
1 g
.23769 .19778 .22689 .20133 .23744 .2079 .24823 .20442 Metetra
1 g
.22705 .1911 .21625 .19471 .22689 .20133 .23769 .19778 Metetra
1 g
.66481 .62875 .65415 .63156 .66159 .63511 .67224 .63232 Metetra
1 g
.65734 .62516 .64665 .62799 .65415 .63156 .66481 .62875 Metetra
1 g
.6498 .62153 .63909 .62439 .64665 .62799 .65734 .62516 Metetra
1 g
.6422 .61788 .63148 .62076 .63909 .62439 .6498 .62153 Metetra
1 g
.63454 .6142 .6238 .6171 .63148 .62076 .6422 .61788 Metetra
1 g
.62616 .5816 .61526 .57506 .6238 .6171 .63454 .6142 Metetra
1 g
.6178 .54911 .607 .5441 .61526 .57506 .62616 .5816 Metetra
1 g
.60962 .52381 .59888 .51992 .607 .5441 .6178 .54911 Metetra
1 g
.60153 .50323 .59083 .50021 .59888 .51992 .60962 .52381 Metetra
1 g
.59348 .4859 .58281 .48359 .59083 .50021 .60153 .50323 Metetra
1 g
.58545 .47092 .5748 .46917 .58281 .48359 .59348 .4859 Metetra
1 g
.57741 .45768 .56678 .4564 .5748 .46917 .58545 .47092 Metetra
1 g
.56936 .44575 .55873 .44488 .56678 .4564 .57741 .45768 Metetra
1 g
.56128 .43484 .55066 .43432 .55873 .44488 .56936 .44575 Metetra
1 g
.55316 .42475 .54254 .42453 .55066 .43432 .56128 .43484 Metetra
1 g
.545 .4153 .53438 .41535 .54254 .42453 .55316 .42475 Metetra
1 g
.53679 .40637 .52618 .40667 .53438 .41535 .545 .4153 Metetra
1 g
.52853 .39787 .51792 .39839 .52618 .40667 .53679 .40637 Metetra
1 g
.52022 .38973 .5096 .39044 .51792 .39839 .52853 .39787 Metetra
1 g
.51185 .38188 .50123 .38277 .5096 .39044 .52022 .38973 Metetra
1 g
.50343 .37427 .4928 .37533 .50123 .38277 .51185 .38188 Metetra
1 g
.49494 .36687 .48431 .36809 .4928 .37533 .50343 .37427 Metetra
1 g
.4864 .35964 .47576 .361 .48431 .36809 .49494 .36687 Metetra
1 g
.47779 .35256 .46714 .35406 .47576 .361 .4864 .35964 Metetra
1 g
.46911 .3456 .45845 .34722 .46714 .35406 .47779 .35256 Metetra
1 g
.46037 .33874 .4497 .34048 .45845 .34722 .46911 .3456 Metetra
1 g
.45156 .33197 .44088 .33382 .4497 .34048 .46037 .33874 Metetra
1 g
.44268 .32526 .43199 .32723 .44088 .33382 .45156 .33197 Metetra
1 g
.43373 .31862 .42303 .32069 .43199 .32723 .44268 .32526 Metetra
1 g
.4247 .31203 .414 .3142 .42303 .32069 .43373 .31862 Metetra
1 g
.41561 .30547 .40489 .30773 .414 .3142 .4247 .31203 Metetra
1 g
.40643 .29894 .39571 .3013 .40489 .30773 .41561 .30547 Metetra
1 g
.39719 .29244 .38645 .29488 .39571 .3013 .40643 .29894 Metetra
1 g
.38786 .28595 .37712 .28848 .38645 .29488 .39719 .29244 Metetra
1 g
.37846 .27947 .36771 .28209 .37712 .28848 .38786 .28595 Metetra
1 g
.36898 .273 .35822 .27569 .36771 .28209 .37846 .27947 Metetra
1 g
.35942 .26652 .34864 .2693 .35822 .27569 .36898 .273 Metetra
1 g
.34977 .26004 .33899 .2629 .34864 .2693 .35942 .26652 Metetra
1 g
.34005 .25355 .32925 .25648 .33899 .2629 .34977 .26004 Metetra
1 g
.33023 .24705 .31943 .25006 .32925 .25648 .34005 .25355 Metetra
1 g
.32034 .24053 .30952 .24361 .31943 .25006 .33023 .24705 Metetra
1 g
.31036 .23399 .29953 .23715 .30952 .24361 .32034 .24053 Metetra
1 g
.30028 .22743 .28945 .23066 .29953 .23715 .31036 .23399 Metetra
1 g
.29012 .22085 .27928 .22414 .28945 .23066 .30028 .22743 Metetra
1 g
.27987 .21423 .26902 .2176 .27928 .22414 .29012 .22085 Metetra
1 g
.26953 .20759 .25867 .21103 .26902 .2176 .27987 .21423 Metetra
1 g
.2591 .20091 .24823 .20442 .25867 .21103 .26953 .20759 Metetra
1 g
.24857 .1942 .23769 .19778 .24823 .20442 .2591 .20091 Metetra
1 g
.23794 .18746 .22705 .1911 .23769 .19778 .24857 .1942 Metetra
1 g
.67555 .62592 .66481 .62875 .67224 .63232 .68295 .62951 Metetra
1 g
.66808 .6223 .65734 .62516 .66481 .62875 .67555 .62592 Metetra
1 g
.66057 .61866 .6498 .62153 .65734 .62516 .66808 .6223 Metetra
1 g
.65299 .61498 .6422 .61788 .6498 .62153 .66057 .61866 Metetra
1 g
.64535 .61128 .63454 .6142 .6422 .61788 .65299 .61498 Metetra
1 g
.63716 .5882 .62616 .5816 .63454 .6142 .64535 .61128 Metetra
1 g
.62871 .55417 .6178 .54911 .62616 .5816 .63716 .5882 Metetra
1 g
.62046 .52773 .60962 .52381 .6178 .54911 .62871 .55417 Metetra
1 g
.61233 .50627 .60153 .50323 .60962 .52381 .62046 .52773 Metetra
1 g
.60425 .48824 .59348 .4859 .60153 .50323 .61233 .50627 Metetra
1 g
.59619 .47269 .58545 .47092 .59348 .4859 .60425 .48824 Metetra
1 g
.58814 .45896 .57741 .45768 .58545 .47092 .59619 .47269 Metetra
1 g
.58007 .44662 .56936 .44575 .57741 .45768 .58814 .45896 Metetra
1 g
.57198 .43537 .56128 .43484 .56936 .44575 .58007 .44662 Metetra
1 g
.56385 .42496 .55316 .42475 .56128 .43484 .57198 .43537 Metetra
1 g
.55569 .41524 .545 .4153 .55316 .42475 .56385 .42496 Metetra
1 g
.54748 .40607 .53679 .40637 .545 .4153 .55569 .41524 Metetra
1 g
.53923 .39735 .52853 .39787 .53679 .40637 .54748 .40607 Metetra
1 g
.53092 .38901 .52022 .38973 .52853 .39787 .53923 .39735 Metetra
1 g
.52256 .38097 .51185 .38188 .52022 .38973 .53092 .38901 Metetra
1 g
.51414 .3732 .50343 .37427 .51185 .38188 .52256 .38097 Metetra
1 g
.50566 .36564 .49494 .36687 .50343 .37427 .51414 .3732 Metetra
1 g
.49712 .35827 .4864 .35964 .49494 .36687 .50566 .36564 Metetra
1 g
.48852 .35105 .47779 .35256 .4864 .35964 .49712 .35827 Metetra
1 g
.47985 .34396 .46911 .3456 .47779 .35256 .48852 .35105 Metetra
1 g
.47112 .33698 .46037 .33874 .46911 .3456 .47985 .34396 Metetra
1 g
.46231 .33009 .45156 .33197 .46037 .33874 .47112 .33698 Metetra
1 g
.45344 .32328 .44268 .32526 .45156 .33197 .46231 .33009 Metetra
1 g
.4445 .31654 .43373 .31862 .44268 .32526 .45344 .32328 Metetra
1 g
.43549 .30984 .4247 .31203 .43373 .31862 .4445 .31654 Metetra
1 g
.4264 .30319 .41561 .30547 .4247 .31203 .43549 .30984 Metetra
1 g
.41724 .29657 .40643 .29894 .41561 .30547 .4264 .30319 Metetra
1 g
.408 .28997 .39719 .29244 .40643 .29894 .41724 .29657 Metetra
1 g
.39869 .2834 .38786 .28595 .39719 .29244 .408 .28997 Metetra
1 g
.38929 .27683 .37846 .27947 .38786 .28595 .39869 .2834 Metetra
1 g
.37982 .27028 .36898 .273 .37846 .27947 .38929 .27683 Metetra
1 g
.37027 .26372 .35942 .26652 .36898 .273 .37982 .27028 Metetra
1 g
.36064 .25716 .34977 .26004 .35942 .26652 .37027 .26372 Metetra
1 g
.35092 .2506 .34005 .25355 .34977 .26004 .36064 .25716 Metetra
1 g
.34112 .24402 .33023 .24705 .34005 .25355 .35092 .2506 Metetra
1 g
.33123 .23742 .32034 .24053 .33023 .24705 .34112 .24402 Metetra
1 g
.32126 .23081 .31036 .23399 .32034 .24053 .33123 .23742 Metetra
1 g
.3112 .22418 .30028 .22743 .31036 .23399 .32126 .23081 Metetra
1 g
.30105 .21752 .29012 .22085 .30028 .22743 .3112 .22418 Metetra
1 g
.29081 .21084 .27987 .21423 .29012 .22085 .30105 .21752 Metetra
1 g
.28048 .20413 .26953 .20759 .27987 .21423 .29081 .21084 Metetra
1 g
.27005 .19738 .2591 .20091 .26953 .20759 .28048 .20413 Metetra
1 g
.25953 .1906 .24857 .1942 .2591 .20091 .27005 .19738 Metetra
1 g
.24892 .18379 .23794 .18746 .24857 .1942 .25953 .1906 Metetra
1 g
.68634 .62308 .67555 .62592 .68295 .62951 .69373 .62669 Metetra
1 g
.6789 .61944 .66808 .6223 .67555 .62592 .68634 .62308 Metetra
1 g
.6714 .61577 .66057 .61866 .66808 .6223 .6789 .61944 Metetra
1 g
.66384 .61207 .65299 .61498 .66057 .61866 .6714 .61577 Metetra
1 g
.65622 .60834 .64535 .61128 .65299 .61498 .66384 .61207 Metetra
1 g
.64827 .59487 .63716 .5882 .64535 .61128 .65622 .60834 Metetra
1 g
.63973 .55928 .62871 .55417 .63716 .5882 .64827 .59487 Metetra
1 g
.63141 .53169 .62046 .52773 .62871 .55417 .63973 .55928 Metetra
1 g
.62322 .50933 .61233 .50627 .62046 .52773 .63141 .53169 Metetra
1 g
.6151 .4906 .60425 .48824 .61233 .50627 .62322 .50933 Metetra
1 g
.60702 .47447 .59619 .47269 .60425 .48824 .6151 .4906 Metetra
1 g
.59895 .46025 .58814 .45896 .59619 .47269 .60702 .47447 Metetra
1 g
.59087 .44751 .58007 .44662 .58814 .45896 .59895 .46025 Metetra
1 g
.58277 .43589 .57198 .43537 .58007 .44662 .59087 .44751 Metetra
1 g
.57464 .42518 .56385 .42496 .57198 .43537 .58277 .43589 Metetra
1 g
.56647 .41518 .55569 .41524 .56385 .42496 .57464 .42518 Metetra
1 g
.55826 .40577 .54748 .40607 .55569 .41524 .56647 .41518 Metetra
1 g
.55001 .39683 .53923 .39735 .54748 .40607 .55826 .40577 Metetra
1 g
.5417 .38828 .53092 .38901 .53923 .39735 .55001 .39683 Metetra
1 g
.53335 .38006 .52256 .38097 .53092 .38901 .5417 .38828 Metetra
1 g
.52493 .37212 .51414 .3732 .52256 .38097 .53335 .38006 Metetra
1 g
.51646 .36441 .50566 .36564 .51414 .3732 .52493 .37212 Metetra
1 g
.50793 .35689 .49712 .35827 .50566 .36564 .51646 .36441 Metetra
1 g
.49933 .34953 .48852 .35105 .49712 .35827 .50793 .35689 Metetra
1 g
.49067 .34231 .47985 .34396 .48852 .35105 .49933 .34953 Metetra
1 g
.48194 .33521 .47112 .33698 .47985 .34396 .49067 .34231 Metetra
1 g
.47315 .32821 .46231 .33009 .47112 .33698 .48194 .33521 Metetra
1 g
.46429 .32129 .45344 .32328 .46231 .33009 .47315 .32821 Metetra
1 g
.45536 .31444 .4445 .31654 .45344 .32328 .46429 .32129 Metetra
1 g
.44635 .30764 .43549 .30984 .4445 .31654 .45536 .31444 Metetra
1 g
.43727 .30089 .4264 .30319 .43549 .30984 .44635 .30764 Metetra
1 g
.42812 .29418 .41724 .29657 .4264 .30319 .43727 .30089 Metetra
1 g
.4189 .28749 .408 .28997 .41724 .29657 .42812 .29418 Metetra
1 g
.40959 .28083 .39869 .2834 .408 .28997 .4189 .28749 Metetra
1 g
.40021 .27418 .38929 .27683 .39869 .2834 .40959 .28083 Metetra
1 g
.39075 .26754 .37982 .27028 .38929 .27683 .40021 .27418 Metetra
1 g
.38121 .2609 .37027 .26372 .37982 .27028 .39075 .26754 Metetra
1 g
.37159 .25426 .36064 .25716 .37027 .26372 .38121 .2609 Metetra
1 g
.36188 .24762 .35092 .2506 .36064 .25716 .37159 .25426 Metetra
1 g
.35209 .24096 .34112 .24402 .35092 .2506 .36188 .24762 Metetra
1 g
.34221 .2343 .33123 .23742 .34112 .24402 .35209 .24096 Metetra
1 g
.33225 .22761 .32126 .23081 .33123 .23742 .34221 .2343 Metetra
1 g
.3222 .2209 .3112 .22418 .32126 .23081 .33225 .22761 Metetra
1 g
.31206 .21418 .30105 .21752 .3112 .22418 .3222 .2209 Metetra
1 g
.30183 .20742 .29081 .21084 .30105 .21752 .31206 .21418 Metetra
1 g
.29151 .20064 .28048 .20413 .29081 .21084 .30183 .20742 Metetra
1 g
.28109 .19382 .27005 .19738 .28048 .20413 .29151 .20064 Metetra
1 g
.27058 .18697 .25953 .1906 .27005 .19738 .28109 .19382 Metetra
1 g
.25998 .18009 .24892 .18379 .25953 .1906 .27058 .18697 Metetra
1 g
.69721 .62021 .68634 .62308 .69373 .62669 .70457 .62384 Metetra
1 g
.68979 .61655 .6789 .61944 .68634 .62308 .69721 .62021 Metetra
1 g
.68231 .61286 .6714 .61577 .6789 .61944 .68979 .61655 Metetra
1 g
.67477 .60914 .66384 .61207 .6714 .61577 .68231 .61286 Metetra
1 g
.66716 .60539 .65622 .60834 .66384 .61207 .67477 .60914 Metetra
1 g
.6595 .6016 .64827 .59487 .65622 .60834 .66716 .60539 Metetra
1 g
.65085 .56444 .63973 .55928 .64827 .59487 .6595 .6016 Metetra
1 g
.64245 .53568 .63141 .53169 .63973 .55928 .65085 .56444 Metetra
1 g
.63421 .51243 .62322 .50933 .63141 .53169 .64245 .53568 Metetra
1 g
.62605 .49298 .6151 .4906 .62322 .50933 .63421 .51243 Metetra
1 g
.61794 .47626 .60702 .47447 .6151 .4906 .62605 .49298 Metetra
1 g
.60985 .46156 .59895 .46025 .60702 .47447 .61794 .47626 Metetra
1 g
.60175 .4484 .59087 .44751 .59895 .46025 .60985 .46156 Metetra
1 g
.59364 .43643 .58277 .43589 .59087 .44751 .60175 .4484 Metetra
1 g
.5855 .4254 .57464 .42518 .58277 .43589 .59364 .43643 Metetra
1 g
.57734 .41512 .56647 .41518 .57464 .42518 .5855 .4254 Metetra
1 g
.56913 .40546 .55826 .40577 .56647 .41518 .57734 .41512 Metetra
1 g
.56087 .3963 .55001 .39683 .55826 .40577 .56913 .40546 Metetra
1 g
.55257 .38755 .5417 .38828 .55001 .39683 .56087 .3963 Metetra
1 g
.54421 .37915 .53335 .38006 .5417 .38828 .55257 .38755 Metetra
1 g
.53581 .37103 .52493 .37212 .53335 .38006 .54421 .37915 Metetra
1 g
.52734 .36316 .51646 .36441 .52493 .37212 .53581 .37103 Metetra
1 g
.51881 .3555 .50793 .35689 .51646 .36441 .52734 .36316 Metetra
1 g
.51022 .348 .49933 .34953 .50793 .35689 .51881 .3555 Metetra
1 g
.50157 .34065 .49067 .34231 .49933 .34953 .51022 .348 Metetra
1 g
.49285 .33343 .48194 .33521 .49067 .34231 .50157 .34065 Metetra
1 g
.48407 .32631 .47315 .32821 .48194 .33521 .49285 .33343 Metetra
1 g
.47522 .31928 .46429 .32129 .47315 .32821 .48407 .32631 Metetra
1 g
.46629 .31232 .45536 .31444 .46429 .32129 .47522 .31928 Metetra
1 g
.4573 .30542 .44635 .30764 .45536 .31444 .46629 .31232 Metetra
1 g
.44823 .29857 .43727 .30089 .44635 .30764 .4573 .30542 Metetra
1 g
.43909 .29177 .42812 .29418 .43727 .30089 .44823 .29857 Metetra
1 g
.42988 .28499 .4189 .28749 .42812 .29418 .43909 .29177 Metetra
1 g
.42058 .27824 .40959 .28083 .4189 .28749 .42988 .28499 Metetra
1 g
.41121 .2715 .40021 .27418 .40959 .28083 .42058 .27824 Metetra
1 g
.40176 .26478 .39075 .26754 .40021 .27418 .41121 .2715 Metetra
1 g
.39223 .25806 .38121 .2609 .39075 .26754 .40176 .26478 Metetra
1 g
.38262 .25134 .37159 .25426 .38121 .2609 .39223 .25806 Metetra
1 g
.37292 .24462 .36188 .24762 .37159 .25426 .38262 .25134 Metetra
1 g
.36314 .23789 .35209 .24096 .36188 .24762 .37292 .24462 Metetra
1 g
.35328 .23114 .34221 .2343 .35209 .24096 .36314 .23789 Metetra
1 g
.34333 .22438 .33225 .22761 .34221 .2343 .35328 .23114 Metetra
1 g
.33329 .2176 .3222 .2209 .33225 .22761 .34333 .22438 Metetra
1 g
.32316 .2108 .31206 .21418 .3222 .2209 .33329 .2176 Metetra
1 g
.31294 .20397 .30183 .20742 .31206 .21418 .32316 .2108 Metetra
1 g
.30263 .19712 .29151 .20064 .30183 .20742 .31294 .20397 Metetra
1 g
.29222 .19023 .28109 .19382 .29151 .20064 .30263 .19712 Metetra
1 g
.28172 .18331 .27058 .18697 .28109 .19382 .29222 .19023 Metetra
1 g
.27113 .17636 .25998 .18009 .27058 .18697 .28172 .18331 Metetra
1 g
.70814 .61733 .69721 .62021 .70457 .62384 .71548 .62099 Metetra
1 g
.70074 .61364 .68979 .61655 .69721 .62021 .70814 .61733 Metetra
1 g
.69328 .60993 .68231 .61286 .68979 .61655 .70074 .61364 Metetra
1 g
.68576 .60618 .67477 .60914 .68231 .61286 .69328 .60993 Metetra
1 g
.67818 .60241 .66716 .60539 .67477 .60914 .68576 .60618 Metetra
1 g
.67054 .5986 .6595 .6016 .66716 .60539 .67818 .60241 Metetra
1 g
.66207 .56965 .65085 .56444 .6595 .6016 .67054 .5986 Metetra
1 g
.6536 .53971 .64245 .53568 .65085 .56444 .66207 .56965 Metetra
1 g
.6453 .51555 .63421 .51243 .64245 .53568 .6536 .53971 Metetra
1 g
.6371 .49538 .62605 .49298 .63421 .51243 .6453 .51555 Metetra
1 g
.62896 .47807 .61794 .47626 .62605 .49298 .6371 .49538 Metetra
1 g
.62084 .46288 .60985 .46156 .61794 .47626 .62896 .47807 Metetra
1 g
.61273 .44929 .60175 .4484 .60985 .46156 .62084 .46288 Metetra
1 g
.6046 .43696 .59364 .43643 .60175 .4484 .61273 .44929 Metetra
1 g
.59646 .42562 .5855 .4254 .59364 .43643 .6046 .43696 Metetra
1 g
.58829 .41506 .57734 .41512 .5855 .4254 .59646 .42562 Metetra
1 g
.58007 .40515 .56913 .40546 .57734 .41512 .58829 .41506 Metetra
1 g
.57182 .39577 .56087 .3963 .56913 .40546 .58007 .40515 Metetra
1 g
.56352 .38681 .55257 .38755 .56087 .3963 .57182 .39577 Metetra
1 g
.55517 .37822 .54421 .37915 .55257 .38755 .56352 .38681 Metetra
1 g
.54676 .36994 .53581 .37103 .54421 .37915 .55517 .37822 Metetra
1 g
.5383 .36191 .52734 .36316 .53581 .37103 .54676 .36994 Metetra
1 g
.52978 .35409 .51881 .3555 .52734 .36316 .5383 .36191 Metetra
1 g
.5212 .34646 .51022 .348 .51881 .3555 .52978 .35409 Metetra
1 g
.51256 .33898 .50157 .34065 .51022 .348 .5212 .34646 Metetra
1 g
.50385 .33163 .49285 .33343 .50157 .34065 .51256 .33898 Metetra
1 g
.49507 .3244 .48407 .32631 .49285 .33343 .50385 .33163 Metetra
1 g
.48623 .31725 .47522 .31928 .48407 .32631 .49507 .3244 Metetra
1 g
.47732 .31019 .46629 .31232 .47522 .31928 .48623 .31725 Metetra
1 g
.46833 .30319 .4573 .30542 .46629 .31232 .47732 .31019 Metetra
1 g
.45927 .29624 .44823 .29857 .4573 .30542 .46833 .30319 Metetra
1 g
.45014 .28934 .43909 .29177 .44823 .29857 .45927 .29624 Metetra
1 g
.44094 .28247 .42988 .28499 .43909 .29177 .45014 .28934 Metetra
1 g
.43166 .27563 .42058 .27824 .42988 .28499 .44094 .28247 Metetra
1 g
.4223 .26881 .41121 .2715 .42058 .27824 .43166 .27563 Metetra
1 g
.41286 .262 .40176 .26478 .41121 .2715 .4223 .26881 Metetra
1 g
.40334 .2552 .39223 .25806 .40176 .26478 .41286 .262 Metetra
1 g
.39374 .2484 .38262 .25134 .39223 .25806 .40334 .2552 Metetra
1 g
.38405 .24159 .37292 .24462 .38262 .25134 .39374 .2484 Metetra
1 g
.37428 .23478 .36314 .23789 .37292 .24462 .38405 .24159 Metetra
1 g
.36443 .22796 .35328 .23114 .36314 .23789 .37428 .23478 Metetra
1 g
.35449 .22113 .34333 .22438 .35328 .23114 .36443 .22796 Metetra
1 g
.34446 .21428 .33329 .2176 .34333 .22438 .35449 .22113 Metetra
1 g
.33434 .2074 .32316 .2108 .33329 .2176 .34446 .21428 Metetra
1 g
.32413 .2005 .31294 .20397 .32316 .2108 .33434 .2074 Metetra
1 g
.31383 .19357 .30263 .19712 .31294 .20397 .32413 .2005 Metetra
1 g
.30344 .18661 .29222 .19023 .30263 .19712 .31383 .19357 Metetra
1 g
.29295 .17962 .28172 .18331 .29222 .19023 .30344 .18661 Metetra
1 g
.28236 .1726 .27113 .17636 .28172 .18331 .29295 .17962 Metetra
1 g
.71914 .61443 .70814 .61733 .71548 .62099 .72646 .61811 Metetra
1 g
.71176 .61072 .70074 .61364 .70814 .61733 .71914 .61443 Metetra
1 g
.70432 .60698 .69328 .60993 .70074 .61364 .71176 .61072 Metetra
1 g
.69682 .60321 .68576 .60618 .69328 .60993 .70432 .60698 Metetra
1 g
.68926 .59942 .67818 .60241 .68576 .60618 .69682 .60321 Metetra
1 g
.68164 .59559 .67054 .5986 .67818 .60241 .68926 .59942 Metetra
1 g
.67341 .57491 .66207 .56965 .67054 .5986 .68164 .59559 Metetra
1 g
.66485 .54378 .6536 .53971 .66207 .56965 .67341 .57491 Metetra
1 g
.65649 .5187 .6453 .51555 .6536 .53971 .66485 .54378 Metetra
1 g
.64824 .4978 .6371 .49538 .6453 .51555 .65649 .5187 Metetra
1 g
.64007 .47989 .62896 .47807 .6371 .49538 .64824 .4978 Metetra
1 g
.63192 .4642 .62084 .46288 .62896 .47807 .64007 .47989 Metetra
1 g
.62379 .4502 .61273 .44929 .62084 .46288 .63192 .4642 Metetra
1 g
.61566 .4375 .6046 .43696 .61273 .44929 .62379 .4502 Metetra
1 g
.6075 .42584 .59646 .42562 .6046 .43696 .61566 .4375 Metetra
1 g
.59932 .415 .58829 .41506 .59646 .42562 .6075 .42584 Metetra
1 g
.59111 .40484 .58007 .40515 .58829 .41506 .59932 .415 Metetra
1 g
.58286 .39523 .57182 .39577 .58007 .40515 .59111 .40484 Metetra
1 g
.57456 .38607 .56352 .38681 .57182 .39577 .58286 .39523 Metetra
1 g
.56621 .37729 .55517 .37822 .56352 .38681 .57456 .38607 Metetra
1 g
.55781 .36883 .54676 .36994 .55517 .37822 .56621 .37729 Metetra
1 g
.54935 .36064 .5383 .36191 .54676 .36994 .55781 .36883 Metetra
1 g
.54084 .35268 .52978 .35409 .5383 .36191 .54935 .36064 Metetra
1 g
.53226 .3449 .5212 .34646 .52978 .35409 .54084 .35268 Metetra
1 g
.52363 .33729 .51256 .33898 .5212 .34646 .53226 .3449 Metetra
1 g
.51493 .32982 .50385 .33163 .51256 .33898 .52363 .33729 Metetra
1 g
.50616 .32247 .49507 .3244 .50385 .33163 .51493 .32982 Metetra
1 g
.49732 .31521 .48623 .31725 .49507 .3244 .50616 .32247 Metetra
1 g
.48842 .30804 .47732 .31019 .48623 .31725 .49732 .31521 Metetra
1 g
.47945 .30093 .46833 .30319 .47732 .31019 .48842 .30804 Metetra
1 g
.4704 .29389 .45927 .29624 .46833 .30319 .47945 .30093 Metetra
1 g
.46128 .28689 .45014 .28934 .45927 .29624 .4704 .29389 Metetra
1 g
.45209 .27993 .44094 .28247 .45014 .28934 .46128 .28689 Metetra
1 g
.44281 .273 .43166 .27563 .44094 .28247 .45209 .27993 Metetra
1 g
.43346 .26609 .4223 .26881 .43166 .27563 .44281 .273 Metetra
1 g
.42404 .25919 .41286 .262 .4223 .26881 .43346 .26609 Metetra
1 g
.41453 .25231 .40334 .2552 .41286 .262 .42404 .25919 Metetra
1 g
.40494 .24543 .39374 .2484 .40334 .2552 .41453 .25231 Metetra
1 g
.39527 .23855 .38405 .24159 .39374 .2484 .40494 .24543 Metetra
1 g
.38551 .23166 .37428 .23478 .38405 .24159 .39527 .23855 Metetra
1 g
.37567 .22476 .36443 .22796 .37428 .23478 .38551 .23166 Metetra
1 g
.36574 .21785 .35449 .22113 .36443 .22796 .37567 .22476 Metetra
1 g
.35572 .21092 .34446 .21428 .35449 .22113 .36574 .21785 Metetra
1 g
.34561 .20397 .33434 .2074 .34446 .21428 .35572 .21092 Metetra
1 g
.33541 .197 .32413 .2005 .33434 .2074 .34561 .20397 Metetra
1 g
.32512 .19 .31383 .19357 .32413 .2005 .33541 .197 Metetra
1 g
.31474 .18297 .30344 .18661 .31383 .19357 .32512 .19 Metetra
1 g
.30426 .17591 .29295 .17962 .30344 .18661 .31474 .18297 Metetra
1 g
.29369 .16881 .28236 .1726 .29295 .17962 .30426 .17591 Metetra
1 g
.73021 .61151 .71914 .61443 .72646 .61811 .73751 .61521 Metetra
1 g
.72285 .60778 .71176 .61072 .71914 .61443 .73021 .61151 Metetra
1 g
.71543 .60402 .70432 .60698 .71176 .61072 .72285 .60778 Metetra
1 g
.70795 .60023 .69682 .60321 .70432 .60698 .71543 .60402 Metetra
1 g
.70042 .5964 .68926 .59942 .69682 .60321 .70795 .60023 Metetra
1 g
.69282 .59255 .68164 .59559 .68926 .59942 .70042 .5964 Metetra
1 g
.68486 .58022 .67341 .57491 .68164 .59559 .69282 .59255 Metetra
1 g
.67621 .54788 .66485 .54378 .67341 .57491 .68486 .58022 Metetra
1 g
.66778 .52188 .65649 .5187 .66485 .54378 .67621 .54788 Metetra
1 g
.65948 .50024 .64824 .4978 .65649 .5187 .66778 .52188 Metetra
1 g
.65127 .48173 .64007 .47989 .64824 .4978 .65948 .50024 Metetra
1 g
.6431 .46554 .63192 .4642 .64007 .47989 .65127 .48173 Metetra
1 g
.63495 .45111 .62379 .4502 .63192 .4642 .6431 .46554 Metetra
1 g
.6268 .43805 .61566 .4375 .62379 .4502 .63495 .45111 Metetra
1 g
.61864 .42606 .6075 .42584 .61566 .4375 .6268 .43805 Metetra
1 g
.61045 .41495 .59932 .415 .6075 .42584 .61864 .42606 Metetra
1 g
.60223 .40453 .59111 .40484 .59932 .415 .61045 .41495 Metetra
1 g
.59398 .39469 .58286 .39523 .59111 .40484 .60223 .40453 Metetra
1 g
.58568 .38532 .57456 .38607 .58286 .39523 .59398 .39469 Metetra
1 g
.57733 .37636 .56621 .37729 .57456 .38607 .58568 .38532 Metetra
1 g
.56894 .36772 .55781 .36883 .56621 .37729 .57733 .37636 Metetra
1 g
.56048 .35937 .54935 .36064 .55781 .36883 .56894 .36772 Metetra
1 g
.55198 .35125 .54084 .35268 .54935 .36064 .56048 .35937 Metetra
1 g
.54341 .34334 .53226 .3449 .54084 .35268 .55198 .35125 Metetra
1 g
.53478 .33559 .52363 .33729 .53226 .3449 .54341 .34334 Metetra
1 g
.52609 .328 .51493 .32982 .52363 .33729 .53478 .33559 Metetra
1 g
.51733 .32052 .50616 .32247 .51493 .32982 .52609 .328 Metetra
1 g
.50851 .31315 .49732 .31521 .50616 .32247 .51733 .32052 Metetra
1 g
.49961 .30587 .48842 .30804 .49732 .31521 .50851 .31315 Metetra
1 g
.49065 .29866 .47945 .30093 .48842 .30804 .49961 .30587 Metetra
1 g
.48161 .29152 .4704 .29389 .47945 .30093 .49065 .29866 Metetra
1 g
.4725 .28442 .46128 .28689 .4704 .29389 .48161 .29152 Metetra
1 g
.46332 .27737 .45209 .27993 .46128 .28689 .4725 .28442 Metetra
1 g
.45406 .27035 .44281 .273 .45209 .27993 .46332 .27737 Metetra
1 g
.44472 .26335 .43346 .26609 .44281 .273 .45406 .27035 Metetra
1 g
.4353 .25637 .42404 .25919 .43346 .26609 .44472 .26335 Metetra
1 g
.42581 .2494 .41453 .25231 .42404 .25919 .4353 .25637 Metetra
1 g
.41623 .24244 .40494 .24543 .41453 .25231 .42581 .2494 Metetra
1 g
.40657 .23548 .39527 .23855 .40494 .24543 .41623 .24244 Metetra
1 g
.39682 .22851 .38551 .23166 .39527 .23855 .40657 .23548 Metetra
1 g
.38699 .22153 .37567 .22476 .38551 .23166 .39682 .22851 Metetra
1 g
.37707 .21455 .36574 .21785 .37567 .22476 .38699 .22153 Metetra
1 g
.36707 .20754 .35572 .21092 .36574 .21785 .37707 .21455 Metetra
1 g
.35697 .20052 .34561 .20397 .35572 .21092 .36707 .20754 Metetra
1 g
.34678 .19347 .33541 .197 .34561 .20397 .35697 .20052 Metetra
1 g
.33651 .1864 .32512 .19 .33541 .197 .34678 .19347 Metetra
1 g
.32613 .17929 .31474 .18297 .32512 .19 .33651 .1864 Metetra
1 g
.31567 .17216 .30426 .17591 .31474 .18297 .32613 .17929 Metetra
1 g
.3051 .16499 .29369 .16881 .30426 .17591 .31567 .17216 Metetra
1 g
.74135 .60858 .73021 .61151 .73751 .61521 .74863 .6123 Metetra
1 g
.73401 .60482 .72285 .60778 .73021 .61151 .74135 .60858 Metetra
1 g
.72662 .60103 .71543 .60402 .72285 .60778 .73401 .60482 Metetra
1 g
.71916 .59722 .70795 .60023 .71543 .60402 .72662 .60103 Metetra
1 g
.71164 .59337 .70042 .5964 .70795 .60023 .71916 .59722 Metetra
1 g
.70406 .58949 .69282 .59255 .70042 .5964 .71164 .59337 Metetra
1 g
.69642 .58558 .68486 .58022 .69282 .59255 .70406 .58949 Metetra
1 g
.68767 .55203 .67621 .54788 .68486 .58022 .69642 .58558 Metetra
1 g
.67917 .52509 .66778 .52188 .67621 .54788 .68767 .55203 Metetra
1 g
.67082 .5027 .65948 .50024 .66778 .52188 .67917 .52509 Metetra
1 g
.66257 .48359 .65127 .48173 .65948 .50024 .67082 .5027 Metetra
1 g
.65437 .46689 .6431 .46554 .65127 .48173 .66257 .48359 Metetra
1 g
.6462 .45203 .63495 .45111 .6431 .46554 .65437 .46689 Metetra
1 g
.63803 .4386 .6268 .43805 .63495 .45111 .6462 .45203 Metetra
1 g
.62986 .42629 .61864 .42606 .6268 .43805 .63803 .4386 Metetra
1 g
.62167 .41488 .61045 .41495 .61864 .42606 .62986 .42629 Metetra
1 g
.61344 .40421 .60223 .40453 .61045 .41495 .62167 .41488 Metetra
1 g
.60519 .39414 .59398 .39469 .60223 .40453 .61344 .40421 Metetra
1 g
.59689 .38457 .58568 .38532 .59398 .39469 .60519 .39414 Metetra
1 g
.58854 .37541 .57733 .37636 .58568 .38532 .59689 .38457 Metetra
1 g
.58015 .3666 .56894 .36772 .57733 .37636 .58854 .37541 Metetra
1 g
.5717 .35808 .56048 .35937 .56894 .36772 .58015 .3666 Metetra
1 g
.5632 .34982 .55198 .35125 .56048 .35937 .5717 .35808 Metetra
1 g
.55464 .34176 .54341 .34334 .55198 .35125 .5632 .34982 Metetra
1 g
.54602 .33388 .53478 .33559 .54341 .34334 .55464 .34176 Metetra
1 g
.53734 .32616 .52609 .328 .53478 .33559 .54602 .33388 Metetra
1 g
.52859 .31856 .51733 .32052 .52609 .328 .53734 .32616 Metetra
1 g
.51977 .31108 .50851 .31315 .51733 .32052 .52859 .31856 Metetra
1 g
.51089 .30369 .49961 .30587 .50851 .31315 .51977 .31108 Metetra
1 g
.50193 .29638 .49065 .29866 .49961 .30587 .51089 .30369 Metetra
1 g
.49291 .28913 .48161 .29152 .49065 .29866 .50193 .29638 Metetra
1 g
.48381 .28194 .4725 .28442 .48161 .29152 .49291 .28913 Metetra
1 g
.47464 .27479 .46332 .27737 .4725 .28442 .48381 .28194 Metetra
1 g
.46539 .26768 .45406 .27035 .46332 .27737 .47464 .27479 Metetra
1 g
.45606 .26059 .44472 .26335 .45406 .27035 .46539 .26768 Metetra
1 g
.44666 .25352 .4353 .25637 .44472 .26335 .45606 .26059 Metetra
1 g
.43717 .24647 .42581 .2494 .4353 .25637 .44666 .25352 Metetra
1 g
.42761 .23943 .41623 .24244 .42581 .2494 .43717 .24647 Metetra
1 g
.41796 .23238 .40657 .23548 .41623 .24244 .42761 .23943 Metetra
1 g
.40822 .22534 .39682 .22851 .40657 .23548 .41796 .23238 Metetra
1 g
.3984 .21828 .38699 .22153 .39682 .22851 .40822 .22534 Metetra
1 g
.3885 .21122 .37707 .21455 .38699 .22153 .3984 .21828 Metetra
1 g
.3785 .20414 .36707 .20754 .37707 .21455 .3885 .21122 Metetra
1 g
.36842 .19704 .35697 .20052 .36707 .20754 .3785 .20414 Metetra
1 g
.35824 .18991 .34678 .19347 .35697 .20052 .36842 .19704 Metetra
1 g
.34798 .18277 .33651 .1864 .34678 .19347 .35824 .18991 Metetra
1 g
.33762 .17559 .32613 .17929 .33651 .1864 .34798 .18277 Metetra
1 g
.32716 .16838 .31567 .17216 .32613 .17929 .33762 .17559 Metetra
1 g
.31661 .16114 .3051 .16499 .31567 .17216 .32716 .16838 Metetra
1 g
.75256 .60562 .74135 .60858 .74863 .6123 .75982 .60937 Metetra
1 g
.74524 .60184 .73401 .60482 .74135 .60858 .75256 .60562 Metetra
1 g
.73787 .59803 .72662 .60103 .73401 .60482 .74524 .60184 Metetra
1 g
.73044 .59419 .71916 .59722 .72662 .60103 .73787 .59803 Metetra
1 g
.72294 .59032 .71164 .59337 .71916 .59722 .73044 .59419 Metetra
1 g
.71538 .58641 .70406 .58949 .71164 .59337 .72294 .59032 Metetra
1 g
.70776 .58248 .69642 .58558 .70406 .58949 .71538 .58641 Metetra
1 g
.69924 .55621 .68767 .55203 .69642 .58558 .70776 .58248 Metetra
1 g
.69066 .52832 .67917 .52509 .68767 .55203 .69924 .55621 Metetra
1 g
.68226 .50519 .67082 .5027 .67917 .52509 .69066 .52832 Metetra
1 g
.67397 .48546 .66257 .48359 .67082 .5027 .68226 .50519 Metetra
1 g
.66574 .46825 .65437 .46689 .66257 .48359 .67397 .48546 Metetra
1 g
.65754 .45296 .6462 .45203 .65437 .46689 .66574 .46825 Metetra
1 g
.64936 .43915 .63803 .4386 .6462 .45203 .65754 .45296 Metetra
1 g
.64117 .42652 .62986 .42629 .63803 .4386 .64936 .43915 Metetra
1 g
.63297 .41482 .62167 .41488 .62986 .42629 .64117 .42652 Metetra
1 g
.62475 .40389 .61344 .40421 .62167 .41488 .63297 .41482 Metetra
1 g
.61649 .39359 .60519 .39414 .61344 .40421 .62475 .40389 Metetra
1 g
.60819 .38381 .59689 .38457 .60519 .39414 .61649 .39359 Metetra
1 g
.59984 .37446 .58854 .37541 .59689 .38457 .60819 .38381 Metetra
1 g
.59145 .36547 .58015 .3666 .58854 .37541 .59984 .37446 Metetra
1 g
.58301 .35679 .5717 .35808 .58015 .3666 .59145 .36547 Metetra
1 g
.57452 .34837 .5632 .34982 .5717 .35808 .58301 .35679 Metetra
1 g
.56596 .34017 .55464 .34176 .5632 .34982 .57452 .34837 Metetra
1 g
.55735 .33216 .54602 .33388 .55464 .34176 .56596 .34017 Metetra
1 g
.54867 .32431 .53734 .32616 .54602 .33388 .55735 .33216 Metetra
1 g
.53993 .31659 .52859 .31856 .53734 .32616 .54867 .32431 Metetra
1 g
.53113 .30899 .51977 .31108 .52859 .31856 .53993 .31659 Metetra
1 g
.52225 .30149 .51089 .30369 .51977 .31108 .53113 .30899 Metetra
1 g
.51331 .29407 .50193 .29638 .51089 .30369 .52225 .30149 Metetra
1 g
.50429 .28672 .49291 .28913 .50193 .29638 .51331 .29407 Metetra
1 g
.49521 .27943 .48381 .28194 .49291 .28913 .50429 .28672 Metetra
1 g
.48605 .27219 .47464 .27479 .48381 .28194 .49521 .27943 Metetra
1 g
.47681 .26499 .46539 .26768 .47464 .27479 .48605 .27219 Metetra
1 g
.46749 .25781 .45606 .26059 .46539 .26768 .47681 .26499 Metetra
1 g
.4581 .25066 .44666 .25352 .45606 .26059 .46749 .25781 Metetra
1 g
.44863 .24352 .43717 .24647 .44666 .25352 .4581 .25066 Metetra
1 g
.43907 .23639 .42761 .23943 .43717 .24647 .44863 .24352 Metetra
1 g
.42943 .22926 .41796 .23238 .42761 .23943 .43907 .23639 Metetra
1 g
.41971 .22214 .40822 .22534 .41796 .23238 .42943 .22926 Metetra
1 g
.40991 .215 .3984 .21828 .40822 .22534 .41971 .22214 Metetra
1 g
.40001 .20786 .3885 .21122 .3984 .21828 .40991 .215 Metetra
1 g
.39003 .2007 .3785 .20414 .3885 .21122 .40001 .20786 Metetra
1 g
.37996 .19353 .36842 .19704 .3785 .20414 .39003 .2007 Metetra
1 g
.3698 .18633 .35824 .18991 .36842 .19704 .37996 .19353 Metetra
1 g
.35954 .17911 .34798 .18277 .35824 .18991 .3698 .18633 Metetra
1 g
.34919 .17186 .33762 .17559 .34798 .18277 .35954 .17911 Metetra
1 g
.33875 .16457 .32716 .16838 .33762 .17559 .34919 .17186 Metetra
1 g
.32821 .15726 .31661 .16114 .32716 .16838 .33875 .16457 Metetra
1 g
.76384 .60265 .75256 .60562 .75982 .60937 .77108 .60642 Metetra
1 g
.75655 .59884 .74524 .60184 .75256 .60562 .76384 .60265 Metetra
1 g
.7492 .59501 .73787 .59803 .74524 .60184 .75655 .59884 Metetra
1 g
.74178 .59114 .73044 .59419 .73787 .59803 .7492 .59501 Metetra
1 g
.73431 .58725 .72294 .59032 .73044 .59419 .74178 .59114 Metetra
1 g
.72678 .58332 .71538 .58641 .72294 .59032 .73431 .58725 Metetra
1 g
.71918 .57935 .70776 .58248 .71538 .58641 .72678 .58332 Metetra
1 g
.71092 .56043 .69924 .55621 .70776 .58248 .71918 .57935 Metetra
1 g
.70226 .53159 .69066 .52832 .69924 .55621 .71092 .56043 Metetra
1 g
.6938 .5077 .68226 .50519 .69066 .52832 .70226 .53159 Metetra
1 g
.68547 .48735 .67397 .48546 .68226 .50519 .6938 .5077 Metetra
1 g
.6772 .46963 .66574 .46825 .67397 .48546 .68547 .48735 Metetra
1 g
.66898 .4539 .65754 .45296 .66574 .46825 .6772 .46963 Metetra
1 g
.66078 .43971 .64936 .43915 .65754 .45296 .66898 .4539 Metetra
1 g
.65258 .42675 .64117 .42652 .64936 .43915 .66078 .43971 Metetra
1 g
.64437 .41476 .63297 .41482 .64117 .42652 .65258 .42675 Metetra
1 g
.63614 .40357 .62475 .40389 .63297 .41482 .64437 .41476 Metetra
1 g
.62787 .39304 .61649 .39359 .62475 .40389 .63614 .40357 Metetra
1 g
.61958 .38304 .60819 .38381 .61649 .39359 .62787 .39304 Metetra
1 g
.61123 .3735 .59984 .37446 .60819 .38381 .61958 .38304 Metetra
1 g
.60285 .36433 .59145 .36547 .59984 .37446 .61123 .3735 Metetra
1 g
.59441 .35548 .58301 .35679 .59145 .36547 .60285 .36433 Metetra
1 g
.58592 .34691 .57452 .34837 .58301 .35679 .59441 .35548 Metetra
1 g
.57737 .33857 .56596 .34017 .57452 .34837 .58592 .34691 Metetra
1 g
.56876 .33042 .55735 .33216 .56596 .34017 .57737 .33857 Metetra
1 g
.5601 .32244 .54867 .32431 .55735 .33216 .56876 .33042 Metetra
1 g
.55137 .3146 .53993 .31659 .54867 .32431 .5601 .32244 Metetra
1 g
.54257 .30689 .53113 .30899 .53993 .31659 .55137 .3146 Metetra
1 g
.53371 .29927 .52225 .30149 .53113 .30899 .54257 .30689 Metetra
1 g
.52477 .29175 .51331 .29407 .52225 .30149 .53371 .29927 Metetra
1 g
.51577 .2843 .50429 .28672 .51331 .29407 .52477 .29175 Metetra
1 g
.50669 .27691 .49521 .27943 .50429 .28672 .51577 .2843 Metetra
1 g
.49754 .26957 .48605 .27219 .49521 .27943 .50669 .27691 Metetra
1 g
.48832 .26227 .47681 .26499 .48605 .27219 .49754 .26957 Metetra
1 g
.47901 .25501 .46749 .25781 .47681 .26499 .48832 .26227 Metetra
1 g
.46963 .24777 .4581 .25066 .46749 .25781 .47901 .25501 Metetra
1 g
.46017 .24054 .44863 .24352 .4581 .25066 .46963 .24777 Metetra
1 g
.45063 .23333 .43907 .23639 .44863 .24352 .46017 .24054 Metetra
1 g
.441 .22612 .42943 .22926 .43907 .23639 .45063 .23333 Metetra
1 g
.43129 .21891 .41971 .22214 .42943 .22926 .441 .22612 Metetra
1 g
.4215 .2117 .40991 .215 .41971 .22214 .43129 .21891 Metetra
1 g
.41162 .20448 .40001 .20786 .40991 .215 .4215 .2117 Metetra
1 g
.40165 .19724 .39003 .2007 .40001 .20786 .41162 .20448 Metetra
1 g
.39159 .18999 .37996 .19353 .39003 .2007 .40165 .19724 Metetra
1 g
.38144 .18272 .3698 .18633 .37996 .19353 .39159 .18999 Metetra
1 g
.3712 .17542 .35954 .17911 .3698 .18633 .38144 .18272 Metetra
1 g
.36086 .16809 .34919 .17186 .35954 .17911 .3712 .17542 Metetra
1 g
.35043 .16074 .33875 .16457 .34919 .17186 .36086 .16809 Metetra
1 g
.3399 .15335 .32821 .15726 .33875 .16457 .35043 .16074 Metetra
1 g
.7752 .59965 .76384 .60265 .77108 .60642 .78241 .60345 Metetra
1 g
.76793 .59583 .75655 .59884 .76384 .60265 .7752 .59965 Metetra
1 g
.7606 .59197 .7492 .59501 .75655 .59884 .76793 .59583 Metetra
1 g
.75321 .58808 .74178 .59114 .7492 .59501 .7606 .59197 Metetra
1 g
.74576 .58415 .73431 .58725 .74178 .59114 .75321 .58808 Metetra
1 g
.73824 .5802 .72678 .58332 .73431 .58725 .74576 .58415 Metetra
1 g
.73067 .57621 .71918 .57935 .72678 .58332 .73824 .5802 Metetra
1 g
.72271 .5647 .71092 .56043 .71918 .57935 .73067 .57621 Metetra
1 g
.71397 .53489 .70226 .53159 .71092 .56043 .72271 .5647 Metetra
1 g
.70545 .51023 .6938 .5077 .70226 .53159 .71397 .53489 Metetra
1 g
.69706 .48925 .68547 .48735 .6938 .5077 .70545 .51023 Metetra
1 g
.68876 .47101 .6772 .46963 .68547 .48735 .69706 .48925 Metetra
1 g
.68052 .45484 .66898 .4539 .6772 .46963 .68876 .47101 Metetra
1 g
.6723 .44027 .66078 .43971 .66898 .4539 .68052 .45484 Metetra
1 g
.66408 .42698 .65258 .42675 .66078 .43971 .6723 .44027 Metetra
1 g
.65586 .4147 .64437 .41476 .65258 .42675 .66408 .42698 Metetra
1 g
.64762 .40325 .63614 .40357 .64437 .41476 .65586 .4147 Metetra
1 g
.63935 .39248 .62787 .39304 .63614 .40357 .64762 .40325 Metetra
1 g
.63105 .38227 .61958 .38304 .62787 .39304 .63935 .39248 Metetra
1 g
.62271 .37253 .61123 .3735 .61958 .38304 .63105 .38227 Metetra
1 g
.61433 .36318 .60285 .36433 .61123 .3735 .62271 .37253 Metetra
1 g
.6059 .35417 .59441 .35548 .60285 .36433 .61433 .36318 Metetra
1 g
.59741 .34544 .58592 .34691 .59441 .35548 .6059 .35417 Metetra
1 g
.58887 .33695 .57737 .33857 .58592 .34691 .59741 .34544 Metetra
1 g
.58027 .32867 .56876 .33042 .57737 .33857 .58887 .33695 Metetra
1 g
.57161 .32056 .5601 .32244 .56876 .33042 .58027 .32867 Metetra
1 g
.56289 .3126 .55137 .3146 .5601 .32244 .57161 .32056 Metetra
1 g
.5541 .30476 .54257 .30689 .55137 .3146 .56289 .3126 Metetra
1 g
.54525 .29704 .53371 .29927 .54257 .30689 .5541 .30476 Metetra
1 g
.53632 .28941 .52477 .29175 .53371 .29927 .54525 .29704 Metetra
1 g
.52733 .28185 .51577 .2843 .52477 .29175 .53632 .28941 Metetra
1 g
.51827 .27437 .50669 .27691 .51577 .2843 .52733 .28185 Metetra
1 g
.50913 .26693 .49754 .26957 .50669 .27691 .51827 .27437 Metetra
1 g
.49991 .25954 .48832 .26227 .49754 .26957 .50913 .26693 Metetra
1 g
.49062 .25218 .47901 .25501 .48832 .26227 .49991 .25954 Metetra
1 g
.48125 .24485 .46963 .24777 .47901 .25501 .49062 .25218 Metetra
1 g
.4718 .23754 .46017 .24054 .46963 .24777 .48125 .24485 Metetra
1 g
.46228 .23024 .45063 .23333 .46017 .24054 .4718 .23754 Metetra
1 g
.45266 .22295 .441 .22612 .45063 .23333 .46228 .23024 Metetra
1 g
.44297 .21566 .43129 .21891 .441 .22612 .45266 .22295 Metetra
1 g
.43319 .20837 .4215 .2117 .43129 .21891 .44297 .21566 Metetra
1 g
.42332 .20107 .41162 .20448 .4215 .2117 .43319 .20837 Metetra
1 g
.41336 .19375 .40165 .19724 .41162 .20448 .42332 .20107 Metetra
1 g
.40331 .18642 .39159 .18999 .40165 .19724 .41336 .19375 Metetra
1 g
.39318 .17907 .38144 .18272 .39159 .18999 .40331 .18642 Metetra
1 g
.38295 .1717 .3712 .17542 .38144 .18272 .39318 .17907 Metetra
1 g
.37262 .1643 .36086 .16809 .3712 .17542 .38295 .1717 Metetra
1 g
.3622 .15687 .35043 .16074 .36086 .16809 .37262 .1643 Metetra
1 g
.35169 .1494 .3399 .15335 .35043 .16074 .3622 .15687 Metetra
1 g
.78662 .59664 .7752 .59965 .78241 .60345 .79381 .60046 Metetra
1 g
.77937 .59279 .76793 .59583 .7752 .59965 .78662 .59664 Metetra
1 g
.77207 .58891 .7606 .59197 .76793 .59583 .77937 .59279 Metetra
1 g
.7647 .58499 .75321 .58808 .7606 .59197 .77207 .58891 Metetra
1 g
.75727 .58104 .74576 .58415 .75321 .58808 .7647 .58499 Metetra
1 g
.74979 .57706 .73824 .5802 .74576 .58415 .75727 .58104 Metetra
1 g
.74223 .57305 .73067 .57621 .73824 .5802 .74979 .57706 Metetra
1 g
.73462 .569 .72271 .5647 .73067 .57621 .74223 .57305 Metetra
1 g
.72579 .53821 .71397 .53489 .72271 .5647 .73462 .569 Metetra
1 g
.7172 .51278 .70545 .51023 .71397 .53489 .72579 .53821 Metetra
1 g
.70876 .49118 .69706 .48925 .70545 .51023 .7172 .51278 Metetra
1 g
.70043 .47241 .68876 .47101 .69706 .48925 .70876 .49118 Metetra
1 g
.69215 .45579 .68052 .45484 .68876 .47101 .70043 .47241 Metetra
1 g
.68391 .44084 .6723 .44027 .68052 .45484 .69215 .45579 Metetra
1 g
.67568 .42721 .66408 .42698 .6723 .44027 .68391 .44084 Metetra
1 g
.66745 .41464 .65586 .4147 .66408 .42698 .67568 .42721 Metetra
1 g
.6592 .40292 .64762 .40325 .65586 .4147 .66745 .41464 Metetra
1 g
.65093 .39192 .63935 .39248 .64762 .40325 .6592 .40292 Metetra
1 g
.64262 .38149 .63105 .38227 .63935 .39248 .65093 .39192 Metetra
1 g
.63428 .37155 .62271 .37253 .63105 .38227 .64262 .38149 Metetra
1 g
.6259 .36203 .61433 .36318 .62271 .37253 .63428 .37155 Metetra
1 g
.61747 .35284 .6059 .35417 .61433 .36318 .6259 .36203 Metetra
1 g
.60899 .34396 .59741 .34544 .6059 .35417 .61747 .35284 Metetra
1 g
.60046 .33532 .58887 .33695 .59741 .34544 .60899 .34396 Metetra
1 g
.59186 .3269 .58027 .32867 .58887 .33695 .60046 .33532 Metetra
1 g
.58321 .31866 .57161 .32056 .58027 .32867 .59186 .3269 Metetra
1 g
.5745 .31058 .56289 .3126 .57161 .32056 .58321 .31866 Metetra
1 g
.56572 .30263 .5541 .30476 .56289 .3126 .5745 .31058 Metetra
1 g
.55688 .29479 .54525 .29704 .5541 .30476 .56572 .30263 Metetra
1 g
.54797 .28705 .53632 .28941 .54525 .29704 .55688 .29479 Metetra
1 g
.53898 .27939 .52733 .28185 .53632 .28941 .54797 .28705 Metetra
1 g
.52993 .2718 .51827 .27437 .52733 .28185 .53898 .27939 Metetra
1 g
.5208 .26427 .50913 .26693 .51827 .27437 .52993 .2718 Metetra
1 g
.5116 .25678 .49991 .25954 .50913 .26693 .5208 .26427 Metetra
1 g
.50232 .24934 .49062 .25218 .49991 .25954 .5116 .25678 Metetra
1 g
.49297 .24192 .48125 .24485 .49062 .25218 .50232 .24934 Metetra
1 g
.48353 .23452 .4718 .23754 .48125 .24485 .49297 .24192 Metetra
1 g
.47401 .22713 .46228 .23024 .4718 .23754 .48353 .23452 Metetra
1 g
.46442 .21976 .45266 .22295 .46228 .23024 .47401 .22713 Metetra
1 g
.45473 .21239 .44297 .21566 .45266 .22295 .46442 .21976 Metetra
1 g
.44496 .20501 .43319 .20837 .44297 .21566 .45473 .21239 Metetra
1 g
.43511 .19763 .42332 .20107 .43319 .20837 .44496 .20501 Metetra
1 g
.42516 .19024 .41336 .19375 .42332 .20107 .43511 .19763 Metetra
1 g
.41513 .18283 .40331 .18642 .41336 .19375 .42516 .19024 Metetra
1 g
.40501 .1754 .39318 .17907 .40331 .18642 .41513 .18283 Metetra
1 g
.39479 .16795 .38295 .1717 .39318 .17907 .40501 .1754 Metetra
1 g
.38448 .16047 .37262 .1643 .38295 .1717 .39479 .16795 Metetra
1 g
.37407 .15297 .3622 .15687 .37262 .1643 .38448 .16047 Metetra
1 g
.36357 .14543 .35169 .1494 .3622 .15687 .37407 .15297 Metetra
1 g
.79812 .59361 .78662 .59664 .79381 .60046 .80529 .59746 Metetra
1 g
.7909 .58973 .77937 .59279 .78662 .59664 .79812 .59361 Metetra
1 g
.78361 .58582 .77207 .58891 .77937 .59279 .7909 .58973 Metetra
1 g
.77627 .58188 .7647 .58499 .77207 .58891 .78361 .58582 Metetra
1 g
.76887 .57791 .75727 .58104 .7647 .58499 .77627 .58188 Metetra
1 g
.7614 .5739 .74979 .57706 .75727 .58104 .76887 .57791 Metetra
1 g
.75388 .56986 .74223 .57305 .74979 .57706 .7614 .5739 Metetra
1 g
.74628 .56579 .73462 .569 .74223 .57305 .75388 .56986 Metetra
1 g
.73771 .54157 .72579 .53821 .73462 .569 .74628 .56579 Metetra
1 g
.72905 .51535 .7172 .51278 .72579 .53821 .73771 .54157 Metetra
1 g
.72056 .49312 .70876 .49118 .7172 .51278 .72905 .51535 Metetra
1 g
.71219 .47382 .70043 .47241 .70876 .49118 .72056 .49312 Metetra
1 g
.70388 .45675 .69215 .45579 .70043 .47241 .71219 .47382 Metetra
1 g
.69562 .44141 .68391 .44084 .69215 .45579 .70388 .45675 Metetra
1 g
.68737 .42745 .67568 .42721 .68391 .44084 .69562 .44141 Metetra
1 g
.67912 .41458 .66745 .41464 .67568 .42721 .68737 .42745 Metetra
1 g
.67087 .4026 .6592 .40292 .66745 .41464 .67912 .41458 Metetra
1 g
.66259 .39135 .65093 .39192 .6592 .40292 .67087 .4026 Metetra
1 g
.65429 .38071 .64262 .38149 .65093 .39192 .66259 .39135 Metetra
1 g
.64595 .37057 .63428 .37155 .64262 .38149 .65429 .38071 Metetra
1 g
.63757 .36086 .6259 .36203 .63428 .37155 .64595 .37057 Metetra
1 g
.62914 .35151 .61747 .35284 .6259 .36203 .63757 .36086 Metetra
1 g
.62066 .34246 .60899 .34396 .61747 .35284 .62914 .35151 Metetra
1 g
.61214 .33368 .60046 .33532 .60899 .34396 .62066 .34246 Metetra
1 g
.60355 .32512 .59186 .3269 .60046 .33532 .61214 .33368 Metetra
1 g
.59491 .31675 .58321 .31866 .59186 .3269 .60355 .32512 Metetra
1 g
.5862 .30854 .5745 .31058 .58321 .31866 .59491 .31675 Metetra
1 g
.57744 .30047 .56572 .30263 .5745 .31058 .5862 .30854 Metetra
1 g
.5686 .29252 .55688 .29479 .56572 .30263 .57744 .30047 Metetra
1 g
.5597 .28467 .54797 .28705 .55688 .29479 .5686 .29252 Metetra
1 g
.55073 .27691 .53898 .27939 .54797 .28705 .5597 .28467 Metetra
1 g
.54169 .26922 .52993 .2718 .53898 .27939 .55073 .27691 Metetra
1 g
.53257 .26159 .5208 .26427 .52993 .2718 .54169 .26922 Metetra
1 g
.52338 .25401 .5116 .25678 .5208 .26427 .53257 .26159 Metetra
1 g
.51412 .24647 .50232 .24934 .5116 .25678 .52338 .25401 Metetra
1 g
.50477 .23896 .49297 .24192 .50232 .24934 .51412 .24647 Metetra
1 g
.49535 .23147 .48353 .23452 .49297 .24192 .50477 .23896 Metetra
1 g
.48585 .224 .47401 .22713 .48353 .23452 .49535 .23147 Metetra
1 g
.47626 .21654 .46442 .21976 .47401 .22713 .48585 .224 Metetra
1 g
.46659 .20909 .45473 .21239 .46442 .21976 .47626 .21654 Metetra
1 g
.45684 .20163 .44496 .20501 .45473 .21239 .46659 .20909 Metetra
1 g
.44699 .19417 .43511 .19763 .44496 .20501 .45684 .20163 Metetra
1 g
.43706 .1867 .42516 .19024 .43511 .19763 .44699 .19417 Metetra
1 g
.42704 .17921 .41513 .18283 .42516 .19024 .43706 .1867 Metetra
1 g
.41693 .1717 .40501 .1754 .41513 .18283 .42704 .17921 Metetra
1 g
.40673 .16417 .39479 .16795 .40501 .1754 .41693 .1717 Metetra
1 g
.39643 .15662 .38448 .16047 .39479 .16795 .40673 .16417 Metetra
1 g
.38604 .14904 .37407 .15297 .38448 .16047 .39643 .15662 Metetra
1 g
.37555 .14142 .36357 .14543 .37407 .15297 .38604 .14904 Metetra
1 g
.80969 .59056 .79812 .59361 .80529 .59746 .81684 .59443 Metetra
1 g
.80249 .58666 .7909 .58973 .79812 .59361 .80969 .59056 Metetra
1 g
.79524 .58272 .78361 .58582 .7909 .58973 .80249 .58666 Metetra
1 g
.78792 .57876 .77627 .58188 .78361 .58582 .79524 .58272 Metetra
1 g
.78054 .57476 .76887 .57791 .77627 .58188 .78792 .57876 Metetra
1 g
.7731 .57072 .7614 .5739 .76887 .57791 .78054 .57476 Metetra
1 g
.76559 .56666 .75388 .56986 .7614 .5739 .7731 .57072 Metetra
1 g
.75803 .56256 .74628 .56579 .75388 .56986 .76559 .56666 Metetra
1 g
.74975 .54496 .73771 .54157 .74628 .56579 .75803 .56256 Metetra
1 g
.74102 .51795 .72905 .51535 .73771 .54157 .74975 .54496 Metetra
1 g
.73247 .49507 .72056 .49312 .72905 .51535 .74102 .51795 Metetra
1 g
.72405 .47524 .71219 .47382 .72056 .49312 .73247 .49507 Metetra
1 g
.71571 .45772 .70388 .45675 .71219 .47382 .72405 .47524 Metetra
1 g
.70742 .44199 .69562 .44141 .70388 .45675 .71571 .45772 Metetra
1 g
.69916 .42768 .68737 .42745 .69562 .44141 .70742 .44199 Metetra
1 g
.6909 .41451 .67912 .41458 .68737 .42745 .69916 .42768 Metetra
1 g
.68263 .40227 .67087 .4026 .67912 .41458 .6909 .41451 Metetra
1 g
.67435 .39078 .66259 .39135 .67087 .4026 .68263 .40227 Metetra
1 g
.66604 .37991 .65429 .38071 .66259 .39135 .67435 .39078 Metetra
1 g
.6577 .36958 .64595 .37057 .65429 .38071 .66604 .37991 Metetra
1 g
.64932 .35968 .63757 .36086 .64595 .37057 .6577 .36958 Metetra
1 g
.6409 .35016 .62914 .35151 .63757 .36086 .64932 .35968 Metetra
1 g
.63243 .34096 .62066 .34246 .62914 .35151 .6409 .35016 Metetra
1 g
.62391 .33203 .61214 .33368 .62066 .34246 .63243 .34096 Metetra
1 g
.61533 .32332 .60355 .32512 .61214 .33368 .62391 .33203 Metetra
1 g
.60669 .31482 .59491 .31675 .60355 .32512 .61533 .32332 Metetra
1 g
.598 .30649 .5862 .30854 .59491 .31675 .60669 .31482 Metetra
1 g
.58924 .2983 .57744 .30047 .5862 .30854 .598 .30649 Metetra
1 g
.58042 .29023 .5686 .29252 .57744 .30047 .58924 .2983 Metetra
1 g
.57153 .28228 .5597 .28467 .5686 .29252 .58042 .29023 Metetra
1 g
.56257 .27441 .55073 .27691 .5597 .28467 .57153 .28228 Metetra
1 g
.55354 .26661 .54169 .26922 .55073 .27691 .56257 .27441 Metetra
1 g
.54443 .25889 .53257 .26159 .54169 .26922 .55354 .26661 Metetra
1 g
.53526 .25121 .52338 .25401 .53257 .26159 .54443 .25889 Metetra
1 g
.526 .24357 .51412 .24647 .52338 .25401 .53526 .25121 Metetra
1 g
.51667 .23597 .50477 .23896 .51412 .24647 .526 .24357 Metetra
1 g
.50726 .2284 .49535 .23147 .50477 .23896 .51667 .23597 Metetra
1 g
.49777 .22084 .48585 .224 .49535 .23147 .50726 .2284 Metetra
1 g
.4882 .2133 .47626 .21654 .48585 .224 .49777 .22084 Metetra
1 g
.47854 .20576 .46659 .20909 .47626 .21654 .4882 .2133 Metetra
1 g
.4688 .19822 .45684 .20163 .46659 .20909 .47854 .20576 Metetra
1 g
.45898 .19068 .44699 .19417 .45684 .20163 .4688 .19822 Metetra
1 g
.44906 .18312 .43706 .1867 .44699 .19417 .45898 .19068 Metetra
1 g
.43905 .17556 .42704 .17921 .43706 .1867 .44906 .18312 Metetra
1 g
.42896 .16797 .41693 .1717 .42704 .17921 .43905 .17556 Metetra
1 g
.41877 .16036 .40673 .16417 .41693 .1717 .42896 .16797 Metetra
1 g
.40848 .15273 .39643 .15662 .40673 .16417 .41877 .16036 Metetra
1 g
.3981 .14507 .38604 .14904 .39643 .15662 .40848 .15273 Metetra
1 g
.38763 .13738 .37555 .14142 .38604 .14904 .3981 .14507 Metetra
1 g
.82134 .58749 .80969 .59056 .81684 .59443 .82846 .59138 Metetra
1 g
.81417 .58356 .80249 .58666 .80969 .59056 .82134 .58749 Metetra
1 g
.80693 .5796 .79524 .58272 .80249 .58666 .81417 .58356 Metetra
1 g
.79964 .57561 .78792 .57876 .79524 .58272 .80693 .5796 Metetra
1 g
.79228 .57158 .78054 .57476 .78792 .57876 .79964 .57561 Metetra
1 g
.78487 .56752 .7731 .57072 .78054 .57476 .79228 .57158 Metetra
1 g
.77739 .56343 .76559 .56666 .7731 .57072 .78487 .56752 Metetra
1 g
.76985 .5593 .75803 .56256 .76559 .56666 .77739 .56343 Metetra
1 g
.7619 .54838 .74975 .54496 .75803 .56256 .76985 .5593 Metetra
1 g
.75309 .52058 .74102 .51795 .74975 .54496 .7619 .54838 Metetra
1 g
.74448 .49704 .73247 .49507 .74102 .51795 .75309 .52058 Metetra
1 g
.73602 .47667 .72405 .47524 .73247 .49507 .74448 .49704 Metetra
1 g
.72765 .45869 .71571 .45772 .72405 .47524 .73602 .47667 Metetra
1 g
.71933 .44257 .70742 .44199 .71571 .45772 .72765 .45869 Metetra
1 g
.71104 .42792 .69916 .42768 .70742 .44199 .71933 .44257 Metetra
1 g
.70277 .41445 .6909 .41451 .69916 .42768 .71104 .42792 Metetra
1 g
.6945 .40193 .68263 .40227 .6909 .41451 .70277 .41445 Metetra
1 g
.68621 .3902 .67435 .39078 .68263 .40227 .6945 .40193 Metetra
1 g
.6779 .37912 .66604 .37991 .67435 .39078 .68621 .3902 Metetra
1 g
.66956 .36858 .6577 .36958 .66604 .37991 .6779 .37912 Metetra
1 g
.66118 .3585 .64932 .35968 .6577 .36958 .66956 .36858 Metetra
1 g
.65276 .34881 .6409 .35016 .64932 .35968 .66118 .3585 Metetra
1 g
.64429 .33944 .63243 .34096 .6409 .35016 .65276 .34881 Metetra
1 g
.63577 .33036 .62391 .33203 .63243 .34096 .64429 .33944 Metetra
1 g
.6272 .32152 .61533 .32332 .62391 .33203 .63577 .33036 Metetra
1 g
.61857 .31288 .60669 .31482 .61533 .32332 .6272 .32152 Metetra
1 g
.60989 .30442 .598 .30649 .60669 .31482 .61857 .31288 Metetra
1 g
.60114 .29611 .58924 .2983 .598 .30649 .60989 .30442 Metetra
1 g
.59233 .28793 .58042 .29023 .58924 .2983 .60114 .29611 Metetra
1 g
.58345 .27986 .57153 .28228 .58042 .29023 .59233 .28793 Metetra
1 g
.5745 .27189 .56257 .27441 .57153 .28228 .58345 .27986 Metetra
1 g
.56548 .26399 .55354 .26661 .56257 .27441 .5745 .27189 Metetra
1 g
.55639 .25616 .54443 .25889 .55354 .26661 .56548 .26399 Metetra
1 g
.54723 .24839 .53526 .25121 .54443 .25889 .55639 .25616 Metetra
1 g
.53798 .24066 .526 .24357 .53526 .25121 .54723 .24839 Metetra
1 g
.52867 .23297 .51667 .23597 .526 .24357 .53798 .24066 Metetra
1 g
.51927 .2253 .50726 .2284 .51667 .23597 .52867 .23297 Metetra
1 g
.50979 .21766 .49777 .22084 .50726 .2284 .51927 .2253 Metetra
1 g
.50024 .21003 .4882 .2133 .49777 .22084 .50979 .21766 Metetra
1 g
.49059 .2024 .47854 .20576 .4882 .2133 .50024 .21003 Metetra
1 g
.48087 .19478 .4688 .19822 .47854 .20576 .49059 .2024 Metetra
1 g
.47105 .18716 .45898 .19068 .4688 .19822 .48087 .19478 Metetra
1 g
.46115 .17952 .44906 .18312 .45898 .19068 .47105 .18716 Metetra
1 g
.45116 .17187 .43905 .17556 .44906 .18312 .46115 .17952 Metetra
1 g
.44108 .16421 .42896 .16797 .43905 .17556 .45116 .17187 Metetra
1 g
.4309 .15652 .41877 .16036 .42896 .16797 .44108 .16421 Metetra
1 g
.42063 .14881 .40848 .15273 .41877 .16036 .4309 .15652 Metetra
1 g
.41027 .14108 .3981 .14507 .40848 .15273 .42063 .14881 Metetra
1 g
.39981 .13331 .38763 .13738 .3981 .14507 .41027 .14108 Metetra
1 g
.83307 .5844 .82134 .58749 .82846 .59138 .84016 .58832 Metetra
1 g
.82592 .58045 .81417 .58356 .82134 .58749 .83307 .5844 Metetra
1 g
.81871 .57646 .80693 .5796 .81417 .58356 .82592 .58045 Metetra
1 g
.81144 .57244 .79964 .57561 .80693 .5796 .81871 .57646 Metetra
1 g
.80411 .56839 .79228 .57158 .79964 .57561 .81144 .57244 Metetra
1 g
.79672 .5643 .78487 .56752 .79228 .57158 .80411 .56839 Metetra
1 g
.78926 .56018 .77739 .56343 .78487 .56752 .79672 .5643 Metetra
1 g
.78175 .55603 .76985 .5593 .77739 .56343 .78926 .56018 Metetra
1 g
.77417 .55183 .7619 .54838 .76985 .5593 .78175 .55603 Metetra
1 g
.76527 .52322 .75309 .52058 .7619 .54838 .77417 .55183 Metetra
1 g
.7566 .49903 .74448 .49704 .75309 .52058 .76527 .52322 Metetra
1 g
.74809 .47812 .73602 .47667 .74448 .49704 .7566 .49903 Metetra
1 g
.73968 .45968 .72765 .45869 .73602 .47667 .74809 .47812 Metetra
1 g
.73134 .44316 .71933 .44257 .72765 .45869 .73968 .45968 Metetra
1 g
.72303 .42816 .71104 .42792 .71933 .44257 .73134 .44316 Metetra
1 g
.71474 .41439 .70277 .41445 .71104 .42792 .72303 .42816 Metetra
1 g
.70646 .40159 .6945 .40193 .70277 .41445 .71474 .41439 Metetra
1 g
.69816 .38962 .68621 .3902 .6945 .40193 .70646 .40159 Metetra
1 g
.68985 .37831 .6779 .37912 .68621 .3902 .69816 .38962 Metetra
1 g
.6815 .36757 .66956 .36858 .6779 .37912 .68985 .37831 Metetra
1 g
.67312 .3573 .66118 .3585 .66956 .36858 .6815 .36757 Metetra
1 g
.66471 .34744 .65276 .34881 .66118 .3585 .67312 .3573 Metetra
1 g
.65624 .33791 .64429 .33944 .65276 .34881 .66471 .34744 Metetra
1 g
.64773 .32868 .63577 .33036 .64429 .33944 .65624 .33791 Metetra
1 g
.63917 .31969 .6272 .32152 .63577 .33036 .64773 .32868 Metetra
1 g
.63055 .31092 .61857 .31288 .6272 .32152 .63917 .31969 Metetra
1 g
.62187 .30233 .60989 .30442 .61857 .31288 .63055 .31092 Metetra
1 g
.61313 .2939 .60114 .29611 .60989 .30442 .62187 .30233 Metetra
1 g
.60433 .28561 .59233 .28793 .60114 .29611 .61313 .2939 Metetra
1 g
.59546 .27743 .58345 .27986 .59233 .28793 .60433 .28561 Metetra
1 g
.58652 .26934 .5745 .27189 .58345 .27986 .59546 .27743 Metetra
1 g
.57752 .26134 .56548 .26399 .5745 .27189 .58652 .26934 Metetra
1 g
.56844 .25342 .55639 .25616 .56548 .26399 .57752 .26134 Metetra
1 g
.55929 .24554 .54723 .24839 .55639 .25616 .56844 .25342 Metetra
1 g
.55006 .23772 .53798 .24066 .54723 .24839 .55929 .24554 Metetra
1 g
.54076 .22994 .52867 .23297 .53798 .24066 .55006 .23772 Metetra
1 g
.53138 .22218 .51927 .2253 .52867 .23297 .54076 .22994 Metetra
1 g
.52191 .21445 .50979 .21766 .51927 .2253 .53138 .22218 Metetra
1 g
.51237 .20673 .50024 .21003 .50979 .21766 .52191 .21445 Metetra
1 g
.50274 .19902 .49059 .2024 .50024 .21003 .51237 .20673 Metetra
1 g
.49303 .19132 .48087 .19478 .49059 .2024 .50274 .19902 Metetra
1 g
.48323 .18361 .47105 .18716 .48087 .19478 .49303 .19132 Metetra
1 g
.47334 .17589 .46115 .17952 .47105 .18716 .48323 .18361 Metetra
1 g
.46337 .16816 .45116 .17187 .46115 .17952 .47334 .17589 Metetra
1 g
.4533 .16042 .44108 .16421 .45116 .17187 .46337 .16816 Metetra
1 g
.44314 .15265 .4309 .15652 .44108 .16421 .4533 .16042 Metetra
1 g
.43288 .14486 .42063 .14881 .4309 .15652 .44314 .15265 Metetra
1 g
.42253 .13705 .41027 .14108 .42063 .14881 .43288 .14486 Metetra
1 g
.41208 .1292 .39981 .13331 .41027 .14108 .42253 .13705 Metetra
1 g
.84486 .58129 .83307 .5844 .84016 .58832 .85193 .58523 Metetra
1 g
.83774 .57731 .82592 .58045 .83307 .5844 .84486 .58129 Metetra
1 g
.83056 .5733 .81871 .57646 .82592 .58045 .83774 .57731 Metetra
1 g
.82331 .56925 .81144 .57244 .81871 .57646 .83056 .5733 Metetra
1 g
.81601 .56517 .80411 .56839 .81144 .57244 .82331 .56925 Metetra
1 g
.80864 .56106 .79672 .5643 .80411 .56839 .81601 .56517 Metetra
1 g
.80122 .55691 .78926 .56018 .79672 .5643 .80864 .56106 Metetra
1 g
.79372 .55273 .78175 .55603 .78926 .56018 .80122 .55691 Metetra
1 g
.78617 .54851 .77417 .55183 .78175 .55603 .79372 .55273 Metetra
1 g
.77756 .52589 .76527 .52322 .77417 .55183 .78617 .54851 Metetra
1 g
.76883 .50104 .7566 .49903 .76527 .52322 .77756 .52589 Metetra
1 g
.76027 .47957 .74809 .47812 .7566 .49903 .76883 .50104 Metetra
1 g
.75182 .46067 .73968 .45968 .74809 .47812 .76027 .47957 Metetra
1 g
.74345 .44375 .73134 .44316 .73968 .45968 .75182 .46067 Metetra
1 g
.73512 .42841 .72303 .42816 .73134 .44316 .74345 .44375 Metetra
1 g
.72681 .41432 .71474 .41439 .72303 .42816 .73512 .42841 Metetra
1 g
.71852 .40126 .70646 .40159 .71474 .41439 .72681 .41432 Metetra
1 g
.71021 .38903 .69816 .38962 .70646 .40159 .71852 .40126 Metetra
1 g
.70189 .3775 .68985 .37831 .69816 .38962 .71021 .38903 Metetra
1 g
.69355 .36656 .6815 .36757 .68985 .37831 .70189 .3775 Metetra
1 g
.68517 .3561 .67312 .3573 .6815 .36757 .69355 .36656 Metetra
1 g
.67675 .34606 .66471 .34744 .67312 .3573 .68517 .3561 Metetra
1 g
.66829 .33637 .65624 .33791 .66471 .34744 .67675 .34606 Metetra
1 g
.65979 .32698 .64773 .32868 .65624 .33791 .66829 .33637 Metetra
1 g
.65123 .31786 .63917 .31969 .64773 .32868 .65979 .32698 Metetra
1 g
.64262 .30895 .63055 .31092 .63917 .31969 .65123 .31786 Metetra
1 g
.63395 .30023 .62187 .30233 .63055 .31092 .64262 .30895 Metetra
1 g
.62522 .29168 .61313 .2939 .62187 .30233 .63395 .30023 Metetra
1 g
.61643 .28327 .60433 .28561 .61313 .2939 .62522 .29168 Metetra
1 g
.60757 .27497 .59546 .27743 .60433 .28561 .61643 .28327 Metetra
1 g
.59865 .26678 .58652 .26934 .59546 .27743 .60757 .27497 Metetra
1 g
.58965 .25868 .57752 .26134 .58652 .26934 .59865 .26678 Metetra
1 g
.58059 .25065 .56844 .25342 .57752 .26134 .58965 .25868 Metetra
1 g
.57145 .24268 .55929 .24554 .56844 .25342 .58059 .25065 Metetra
1 g
.56224 .23476 .55006 .23772 .55929 .24554 .57145 .24268 Metetra
1 g
.55295 .22688 .54076 .22994 .55006 .23772 .56224 .23476 Metetra
1 g
.54358 .21904 .53138 .22218 .54076 .22994 .55295 .22688 Metetra
1 g
.53413 .21121 .52191 .21445 .53138 .22218 .54358 .21904 Metetra
1 g
.5246 .20341 .51237 .20673 .52191 .21445 .53413 .21121 Metetra
1 g
.51499 .19561 .50274 .19902 .51237 .20673 .5246 .20341 Metetra
1 g
.50529 .18782 .49303 .19132 .50274 .19902 .51499 .19561 Metetra
1 g
.4955 .18003 .48323 .18361 .49303 .19132 .50529 .18782 Metetra
1 g
.48563 .17223 .47334 .17589 .48323 .18361 .4955 .18003 Metetra
1 g
.47567 .16442 .46337 .16816 .47334 .17589 .48563 .17223 Metetra
1 g
.46562 .15659 .4533 .16042 .46337 .16816 .47567 .16442 Metetra
1 g
.45547 .14875 .44314 .15265 .4533 .16042 .46562 .15659 Metetra
1 g
.44523 .14088 .43288 .14486 .44314 .15265 .45547 .14875 Metetra
1 g
.4349 .13298 .42253 .13705 .43288 .14486 .44523 .14088 Metetra
1 g
.42446 .12506 .41208 .1292 .42253 .13705 .4349 .13298 Metetra
1 g
.85674 .57816 .84486 .58129 .85193 .58523 .86378 .58213 Metetra
1 g
.84964 .57415 .83774 .57731 .84486 .58129 .85674 .57816 Metetra
1 g
.84249 .57012 .83056 .5733 .83774 .57731 .84964 .57415 Metetra
1 g
.83527 .56604 .82331 .56925 .83056 .5733 .84249 .57012 Metetra
1 g
.82799 .56194 .81601 .56517 .82331 .56925 .83527 .56604 Metetra
1 g
.82065 .5578 .80864 .56106 .81601 .56517 .82799 .56194 Metetra
1 g
.81325 .55362 .80122 .55691 .80864 .56106 .82065 .5578 Metetra
1 g
.80578 .54941 .79372 .55273 .80122 .55691 .81325 .55362 Metetra
1 g
.79825 .54516 .78617 .54851 .79372 .55273 .80578 .54941 Metetra
1 g
.78997 .52859 .77756 .52589 .78617 .54851 .79825 .54516 Metetra
1 g
.78117 .50307 .76883 .50104 .77756 .52589 .78997 .52859 Metetra
1 g
.77255 .48105 .76027 .47957 .76883 .50104 .78117 .50307 Metetra
1 g
.76406 .46167 .75182 .46067 .76027 .47957 .77255 .48105 Metetra
1 g
.75566 .44435 .74345 .44375 .75182 .46067 .76406 .46167 Metetra
1 g
.74731 .42865 .73512 .42841 .74345 .44375 .75566 .44435 Metetra
1 g
.73898 .41426 .72681 .41432 .73512 .42841 .74731 .42865 Metetra
1 g
.73067 .40091 .71852 .40126 .72681 .41432 .73898 .41426 Metetra
1 g
.72236 .38844 .71021 .38903 .71852 .40126 .73067 .40091 Metetra
1 g
.71404 .37668 .70189 .3775 .71021 .38903 .72236 .38844 Metetra
1 g
.70569 .36553 .69355 .36656 .70189 .3775 .71404 .37668 Metetra
1 g
.69731 .35489 .68517 .3561 .69355 .36656 .70569 .36553 Metetra
1 g
.6889 .34467 .67675 .34606 .68517 .3561 .69731 .35489 Metetra
1 g
.68044 .33482 .66829 .33637 .67675 .34606 .6889 .34467 Metetra
1 g
.67194 .32528 .65979 .32698 .66829 .33637 .68044 .33482 Metetra
1 g
.66339 .316 .65123 .31786 .65979 .32698 .67194 .32528 Metetra
1 g
.65479 .30696 .64262 .30895 .65123 .31786 .66339 .316 Metetra
1 g
.64613 .29811 .63395 .30023 .64262 .30895 .65479 .30696 Metetra
1 g
.63741 .28944 .62522 .29168 .63395 .30023 .64613 .29811 Metetra
1 g
.62863 .28091 .61643 .28327 .62522 .29168 .63741 .28944 Metetra
1 g
.61978 .2725 .60757 .27497 .61643 .28327 .62863 .28091 Metetra
1 g
.61087 .2642 .59865 .26678 .60757 .27497 .61978 .2725 Metetra
1 g
.60188 .25599 .58965 .25868 .59865 .26678 .61087 .2642 Metetra
1 g
.59283 .24786 .58059 .25065 .58965 .25868 .60188 .25599 Metetra
1 g
.58371 .23979 .57145 .24268 .58059 .25065 .59283 .24786 Metetra
1 g
.57451 .23177 .56224 .23476 .57145 .24268 .58371 .23979 Metetra
1 g
.56523 .2238 .55295 .22688 .56224 .23476 .57451 .23177 Metetra
1 g
.55588 .21586 .54358 .21904 .55295 .22688 .56523 .2238 Metetra
1 g
.54644 .20795 .53413 .21121 .54358 .21904 .55588 .21586 Metetra
1 g
.53693 .20006 .5246 .20341 .53413 .21121 .54644 .20795 Metetra
1 g
.52733 .19218 .51499 .19561 .5246 .20341 .53693 .20006 Metetra
1 g
.51765 .1843 .50529 .18782 .51499 .19561 .52733 .19218 Metetra
1 g
.50788 .17642 .4955 .18003 .50529 .18782 .51765 .1843 Metetra
1 g
.49802 .16854 .48563 .17223 .4955 .18003 .50788 .17642 Metetra
1 g
.48808 .16065 .47567 .16442 .48563 .17223 .49802 .16854 Metetra
1 g
.47804 .15274 .46562 .15659 .47567 .16442 .48808 .16065 Metetra
1 g
.46791 .14481 .45547 .14875 .46562 .15659 .47804 .15274 Metetra
1 g
.45768 .13686 .44523 .14088 .45547 .14875 .46791 .14481 Metetra
1 g
.44737 .12889 .4349 .13298 .44523 .14088 .45768 .13686 Metetra
1 g
.43695 .12088 .42446 .12506 .4349 .13298 .44737 .12889 Metetra
1 g
.8687 .57501 .85674 .57816 .86378 .58213 .87571 .579 Metetra
1 g
.86162 .57098 .84964 .57415 .85674 .57816 .8687 .57501 Metetra
1 g
.85449 .56691 .84249 .57012 .84964 .57415 .86162 .57098 Metetra
1 g
.8473 .56281 .83527 .56604 .84249 .57012 .85449 .56691 Metetra
1 g
.84005 .55868 .82799 .56194 .83527 .56604 .8473 .56281 Metetra
1 g
.83274 .55451 .82065 .5578 .82799 .56194 .84005 .55868 Metetra
1 g
.82536 .55031 .81325 .55362 .82065 .5578 .83274 .55451 Metetra
1 g
.81792 .54607 .80578 .54941 .81325 .55362 .82536 .55031 Metetra
1 g
.81042 .54179 .79825 .54516 .80578 .54941 .81792 .54607 Metetra
1 g
.80249 .53131 .78997 .52859 .79825 .54516 .81042 .54179 Metetra
1 g
.79362 .50511 .78117 .50307 .78997 .52859 .80249 .53131 Metetra
1 g
.78495 .48253 .77255 .48105 .78117 .50307 .79362 .50511 Metetra
1 g
.77642 .46268 .76406 .46167 .77255 .48105 .78495 .48253 Metetra
1 g
.76798 .44495 .75566 .44435 .76406 .46167 .77642 .46268 Metetra
1 g
.7596 .4289 .74731 .42865 .75566 .44435 .76798 .44495 Metetra
1 g
.75126 .41419 .73898 .41426 .74731 .42865 .7596 .4289 Metetra
1 g
.74293 .40057 .73067 .40091 .73898 .41426 .75126 .41419 Metetra
1 g
.73461 .38784 .72236 .38844 .73067 .40091 .74293 .40057 Metetra
1 g
.72628 .37586 .71404 .37668 .72236 .38844 .73461 .38784 Metetra
1 g
.71793 .3645 .70569 .36553 .71404 .37668 .72628 .37586 Metetra
1 g
.70955 .35366 .69731 .35489 .70569 .36553 .71793 .3645 Metetra
1 g
.70114 .34327 .6889 .34467 .69731 .35489 .70955 .35366 Metetra
1 g
.69269 .33325 .68044 .33482 .6889 .34467 .70114 .34327 Metetra
1 g
.68419 .32356 .67194 .32528 .68044 .33482 .69269 .33325 Metetra
1 g
.67565 .31414 .66339 .316 .67194 .32528 .68419 .32356 Metetra
1 g
.66705 .30496 .65479 .30696 .66339 .316 .67565 .31414 Metetra
1 g
.6584 .29598 .64613 .29811 .65479 .30696 .66705 .30496 Metetra
1 g
.64969 .28718 .63741 .28944 .64613 .29811 .6584 .29598 Metetra
1 g
.64092 .27853 .62863 .28091 .63741 .28944 .64969 .28718 Metetra
1 g
.63209 .27001 .61978 .2725 .62863 .28091 .64092 .27853 Metetra
1 g
.62318 .2616 .61087 .2642 .61978 .2725 .63209 .27001 Metetra
1 g
.61422 .25328 .60188 .25599 .61087 .2642 .62318 .2616 Metetra
1 g
.60518 .24504 .59283 .24786 .60188 .25599 .61422 .25328 Metetra
1 g
.59606 .23688 .58371 .23979 .59283 .24786 .60518 .24504 Metetra
1 g
.58688 .22876 .57451 .23177 .58371 .23979 .59606 .23688 Metetra
1 g
.57762 .2207 .56523 .2238 .57451 .23177 .58688 .22876 Metetra
1 g
.56828 .21267 .55588 .21586 .56523 .2238 .57762 .2207 Metetra
1 g
.55886 .20466 .54644 .20795 .55588 .21586 .56828 .21267 Metetra
1 g
.54936 .19668 .53693 .20006 .54644 .20795 .55886 .20466 Metetra
1 g
.53978 .18871 .52733 .19218 .53693 .20006 .54936 .19668 Metetra
1 g
.53011 .18075 .51765 .1843 .52733 .19218 .53978 .18871 Metetra
1 g
.52036 .17279 .50788 .17642 .51765 .1843 .53011 .18075 Metetra
1 g
.51051 .16482 .49802 .16854 .50788 .17642 .52036 .17279 Metetra
1 g
.50058 .15684 .48808 .16065 .49802 .16854 .51051 .16482 Metetra
1 g
.49056 .14885 .47804 .15274 .48808 .16065 .50058 .15684 Metetra
1 g
.48045 .14084 .46791 .14481 .47804 .15274 .49056 .14885 Metetra
1 g
.47024 .13281 .45768 .13686 .46791 .14481 .48045 .14084 Metetra
1 g
.45994 .12476 .44737 .12889 .45768 .13686 .47024 .13281 Metetra
1 g
.44954 .11667 .43695 .12088 .44737 .12889 .45994 .12476 Metetra
1 g
.88073 .57184 .8687 .57501 .87571 .579 .88771 .57586 Metetra
1 g
.87368 .56778 .86162 .57098 .8687 .57501 .88073 .57184 Metetra
1 g
.86658 .56369 .85449 .56691 .86162 .57098 .87368 .56778 Metetra
1 g
.85942 .55956 .8473 .56281 .85449 .56691 .86658 .56369 Metetra
1 g
.85219 .5554 .84005 .55868 .8473 .56281 .85942 .55956 Metetra
1 g
.8449 .5512 .83274 .55451 .84005 .55868 .85219 .5554 Metetra
1 g
.83756 .54697 .82536 .55031 .83274 .55451 .8449 .5512 Metetra
1 g
.83015 .5427 .81792 .54607 .82536 .55031 .83756 .54697 Metetra
1 g
.82267 .5384 .81042 .54179 .81792 .54607 .83015 .5427 Metetra
1 g
.81513 .53405 .80249 .53131 .81042 .54179 .82267 .5384 Metetra
1 g
.80618 .50718 .79362 .50511 .80249 .53131 .81513 .53405 Metetra
1 g
.79745 .48403 .78495 .48253 .79362 .50511 .80618 .50718 Metetra
1 g
.78887 .4637 .77642 .46268 .78495 .48253 .79745 .48403 Metetra
1 g
.7804 .44556 .76798 .44495 .77642 .46268 .78887 .4637 Metetra
1 g
.772 .42915 .7596 .4289 .76798 .44495 .7804 .44556 Metetra
1 g
.76364 .41412 .75126 .41419 .7596 .4289 .772 .42915 Metetra
1 g
.7553 .40022 .74293 .40057 .75126 .41419 .76364 .41412 Metetra
1 g
.74696 .38724 .73461 .38784 .74293 .40057 .7553 .40022 Metetra
1 g
.73863 .37503 .72628 .37586 .73461 .38784 .74696 .38724 Metetra
1 g
.73027 .36346 .71793 .3645 .72628 .37586 .73863 .37503 Metetra
1 g
.72189 .35243 .70955 .35366 .71793 .3645 .73027 .36346 Metetra
1 g
.71348 .34185 .70114 .34327 .70955 .35366 .72189 .35243 Metetra
1 g
.70503 .33167 .69269 .33325 .70114 .34327 .71348 .34185 Metetra
1 g
.69654 .32182 .68419 .32356 .69269 .33325 .70503 .33167 Metetra
1 g
.68801 .31225 .67565 .31414 .68419 .32356 .69654 .32182 Metetra
1 g
.67942 .30293 .66705 .30496 .67565 .31414 .68801 .31225 Metetra
1 g
.67077 .29383 .6584 .29598 .66705 .30496 .67942 .30293 Metetra
1 g
.66207 .2849 .64969 .28718 .6584 .29598 .67077 .29383 Metetra
1 g
.65331 .27613 .64092 .27853 .64969 .28718 .66207 .2849 Metetra
1 g
.64449 .26749 .63209 .27001 .64092 .27853 .65331 .27613 Metetra
1 g
.6356 .25897 .62318 .2616 .63209 .27001 .64449 .26749 Metetra
1 g
.62665 .25055 .61422 .25328 .62318 .2616 .6356 .25897 Metetra
1 g
.61762 .24221 .60518 .24504 .61422 .25328 .62665 .25055 Metetra
1 g
.60852 .23394 .59606 .23688 .60518 .24504 .61762 .24221 Metetra
1 g
.59935 .22573 .58688 .22876 .59606 .23688 .60852 .23394 Metetra
1 g
.5901 .21757 .57762 .2207 .58688 .22876 .59935 .22573 Metetra
1 g
.58078 .20944 .56828 .21267 .57762 .2207 .5901 .21757 Metetra
1 g
.57138 .20135 .55886 .20466 .56828 .21267 .58078 .20944 Metetra
1 g
.56189 .19328 .54936 .19668 .55886 .20466 .57138 .20135 Metetra
1 g
.55232 .18522 .53978 .18871 .54936 .19668 .56189 .19328 Metetra
1 g
.54267 .17717 .53011 .18075 .53978 .18871 .55232 .18522 Metetra
1 g
.53294 .16912 .52036 .17279 .53011 .18075 .54267 .17717 Metetra
1 g
.52311 .16107 .51051 .16482 .52036 .17279 .53294 .16912 Metetra
1 g
.5132 .15301 .50058 .15684 .51051 .16482 .52311 .16107 Metetra
1 g
.50319 .14493 .49056 .14885 .50058 .15684 .5132 .15301 Metetra
1 g
.49309 .13684 .48045 .14084 .49056 .14885 .50319 .14493 Metetra
1 g
.4829 .12873 .47024 .13281 .48045 .14084 .49309 .13684 Metetra
1 g
.47261 .12059 .45994 .12476 .47024 .13281 .4829 .12873 Metetra
1 g
.46223 .11242 .44954 .11667 .45994 .12476 .47261 .12059 Metetra
1 g
.89284 .56864 .88073 .57184 .88771 .57586 .8998 .57269 Metetra
1 g
.88582 .56456 .87368 .56778 .88073 .57184 .89284 .56864 Metetra
1 g
.87875 .56044 .86658 .56369 .87368 .56778 .88582 .56456 Metetra
1 g
.87161 .55629 .85942 .55956 .86658 .56369 .87875 .56044 Metetra
1 g
.86441 .5521 .85219 .5554 .85942 .55956 .87161 .55629 Metetra
1 g
.85715 .54787 .8449 .5512 .85219 .5554 .86441 .5521 Metetra
1 g
.84983 .54361 .83756 .54697 .8449 .5512 .85715 .54787 Metetra
1 g
.84245 .53931 .83015 .5427 .83756 .54697 .84983 .54361 Metetra
1 g
.835 .53498 .82267 .5384 .83015 .5427 .84245 .53931 Metetra
1 g
.82749 .53061 .81513 .53405 .82267 .5384 .835 .53498 Metetra
1 g
.81886 .50926 .80618 .50718 .81513 .53405 .82749 .53061 Metetra
1 g
.81007 .48554 .79745 .48403 .80618 .50718 .81886 .50926 Metetra
1 g
.80144 .46473 .78887 .4637 .79745 .48403 .81007 .48554 Metetra
1 g
.79293 .44617 .7804 .44556 .78887 .4637 .80144 .46473 Metetra
1 g
.7845 .4294 .772 .42915 .7804 .44556 .79293 .44617 Metetra
1 g
.77612 .41406 .76364 .41412 .772 .42915 .7845 .4294 Metetra
1 g
.76776 .39987 .7553 .40022 .76364 .41412 .77612 .41406 Metetra
1 g
.75942 .38664 .74696 .38724 .7553 .40022 .76776 .39987 Metetra
1 g
.75107 .37419 .73863 .37503 .74696 .38724 .75942 .38664 Metetra
1 g
.74271 .36241 .73027 .36346 .73863 .37503 .75107 .37419 Metetra
1 g
.73433 .35118 .72189 .35243 .73027 .36346 .74271 .36241 Metetra
1 g
.72592 .34043 .71348 .34185 .72189 .35243 .73433 .35118 Metetra
1 g
.71748 .33008 .70503 .33167 .71348 .34185 .72592 .34043 Metetra
1 g
.70899 .32007 .69654 .32182 .70503 .33167 .71748 .33008 Metetra
1 g
.70046 .31036 .68801 .31225 .69654 .32182 .70899 .32007 Metetra
1 g
.69188 .3009 .67942 .30293 .68801 .31225 .70046 .31036 Metetra
1 g
.68325 .29165 .67077 .29383 .67942 .30293 .69188 .3009 Metetra
1 g
.67456 .2826 .66207 .2849 .67077 .29383 .68325 .29165 Metetra
1 g
.66581 .27371 .65331 .27613 .66207 .2849 .67456 .2826 Metetra
1 g
.657 .26496 .64449 .26749 .65331 .27613 .66581 .27371 Metetra
1 g
.64812 .25632 .6356 .25897 .64449 .26749 .657 .26496 Metetra
1 g
.63918 .24779 .62665 .25055 .6356 .25897 .64812 .25632 Metetra
1 g
.63016 .23935 .61762 .24221 .62665 .25055 .63918 .24779 Metetra
1 g
.62108 .23098 .60852 .23394 .61762 .24221 .63016 .23935 Metetra
1 g
.61192 .22267 .59935 .22573 .60852 .23394 .62108 .23098 Metetra
1 g
.60269 .21441 .5901 .21757 .59935 .22573 .61192 .22267 Metetra
1 g
.59338 .20619 .58078 .20944 .5901 .21757 .60269 .21441 Metetra
1 g
.58399 .19801 .57138 .20135 .58078 .20944 .59338 .20619 Metetra
1 g
.57453 .18984 .56189 .19328 .57138 .20135 .58399 .19801 Metetra
1 g
.56497 .1817 .55232 .18522 .56189 .19328 .57453 .18984 Metetra
1 g
.55534 .17356 .54267 .17717 .55232 .18522 .56497 .1817 Metetra
1 g
.54562 .16542 .53294 .16912 .54267 .17717 .55534 .17356 Metetra
1 g
.53581 .15729 .52311 .16107 .53294 .16912 .54562 .16542 Metetra
1 g
.52591 .14914 .5132 .15301 .52311 .16107 .53581 .15729 Metetra
1 g
.51592 .14098 .50319 .14493 .5132 .15301 .52591 .14914 Metetra
1 g
.50584 .13281 .49309 .13684 .50319 .14493 .51592 .14098 Metetra
1 g
.49567 .12461 .4829 .12873 .49309 .13684 .50584 .13281 Metetra
1 g
.4854 .11639 .47261 .12059 .4829 .12873 .49567 .12461 Metetra
1 g
.47503 .10814 .46223 .11242 .47261 .12059 .4854 .11639 Metetra
1 g
.90503 .56543 .89284 .56864 .8998 .57269 .91196 .56951 Metetra
1 g
.89804 .56132 .88582 .56456 .89284 .56864 .90503 .56543 Metetra
1 g
.89099 .55717 .87875 .56044 .88582 .56456 .89804 .56132 Metetra
1 g
.88389 .55299 .87161 .55629 .87875 .56044 .89099 .55717 Metetra
1 g
.87672 .54877 .86441 .5521 .87161 .55629 .88389 .55299 Metetra
1 g
.86949 .54452 .85715 .54787 .86441 .5521 .87672 .54877 Metetra
1 g
.86219 .54023 .84983 .54361 .85715 .54787 .86949 .54452 Metetra
1 g
.85484 .5359 .84245 .53931 .84983 .54361 .86219 .54023 Metetra
1 g
.84742 .53154 .835 .53498 .84245 .53931 .85484 .5359 Metetra
1 g
.83994 .52714 .82749 .53061 .835 .53498 .84742 .53154 Metetra
1 g
.83165 .51136 .81886 .50926 .82749 .53061 .83994 .52714 Metetra
1 g
.8228 .48706 .81007 .48554 .81886 .50926 .83165 .51136 Metetra
1 g
.81412 .46577 .80144 .46473 .81007 .48554 .8228 .48706 Metetra
1 g
.80557 .44679 .79293 .44617 .80144 .46473 .81412 .46577 Metetra
1 g
.79711 .42966 .7845 .4294 .79293 .44617 .80557 .44679 Metetra
1 g
.78871 .41399 .77612 .41406 .7845 .4294 .79711 .42966 Metetra
1 g
.78033 .39952 .76776 .39987 .77612 .41406 .78871 .41399 Metetra
1 g
.77198 .38602 .75942 .38664 .76776 .39987 .78033 .39952 Metetra
1 g
.76362 .37335 .75107 .37419 .75942 .38664 .77198 .38602 Metetra
1 g
.75526 .36135 .74271 .36241 .75107 .37419 .76362 .37335 Metetra
1 g
.74688 .34993 .73433 .35118 .74271 .36241 .75526 .36135 Metetra
1 g
.73847 .33899 .72592 .34043 .73433 .35118 .74688 .34993 Metetra
1 g
.73003 .32847 .71748 .33008 .72592 .34043 .73847 .33899 Metetra
1 g
.72155 .31831 .70899 .32007 .71748 .33008 .73003 .32847 Metetra
1 g
.71302 .30844 .70046 .31036 .70899 .32007 .72155 .31831 Metetra
1 g
.70445 .29884 .69188 .3009 .70046 .31036 .71302 .30844 Metetra
1 g
.69582 .28947 .68325 .29165 .69188 .3009 .70445 .29884 Metetra
1 g
.68714 .28029 .67456 .2826 .68325 .29165 .69582 .28947 Metetra
1 g
.6784 .27127 .66581 .27371 .67456 .2826 .68714 .28029 Metetra
1 g
.6696 .2624 .657 .26496 .66581 .27371 .6784 .27127 Metetra
1 g
.66074 .25366 .64812 .25632 .657 .26496 .6696 .2624 Metetra
1 g
.65181 .24502 .63918 .24779 .64812 .25632 .66074 .25366 Metetra
1 g
.64281 .23647 .63016 .23935 .63918 .24779 .65181 .24502 Metetra
1 g
.63374 .228 .62108 .23098 .63016 .23935 .64281 .23647 Metetra
1 g
.6246 .21959 .61192 .22267 .62108 .23098 .63374 .228 Metetra
1 g
.61538 .21123 .60269 .21441 .61192 .22267 .6246 .21959 Metetra
1 g
.60609 .20292 .59338 .20619 .60269 .21441 .61538 .21123 Metetra
1 g
.59672 .19464 .58399 .19801 .59338 .20619 .60609 .20292 Metetra
1 g
.58726 .18638 .57453 .18984 .58399 .19801 .59672 .19464 Metetra
1 g
.57773 .17814 .56497 .1817 .57453 .18984 .58726 .18638 Metetra
1 g
.56811 .16992 .55534 .17356 .56497 .1817 .57773 .17814 Metetra
1 g
.55841 .1617 .54562 .16542 .55534 .17356 .56811 .16992 Metetra
1 g
.54862 .15347 .53581 .15729 .54562 .16542 .55841 .1617 Metetra
1 g
.53874 .14524 .52591 .14914 .53581 .15729 .54862 .15347 Metetra
1 g
.52876 .137 .51592 .14098 .52591 .14914 .53874 .14524 Metetra
1 g
.5187 .12874 .50584 .13281 .51592 .14098 .52876 .137 Metetra
1 g
.50854 .12046 .49567 .12461 .50584 .13281 .5187 .12874 Metetra
1 g
.49829 .11215 .4854 .11639 .49567 .12461 .50854 .12046 Metetra
1 g
.48794 .10382 .47503 .10814 .4854 .11639 .49829 .11215 Metetra
1 g
.9173 .56219 .90503 .56543 .91196 .56951 .92421 .5663 Metetra
1 g
.91034 .55806 .89804 .56132 .90503 .56543 .9173 .56219 Metetra
1 g
.90332 .55388 .89099 .55717 .89804 .56132 .91034 .55806 Metetra
1 g
.89624 .54967 .88389 .55299 .89099 .55717 .90332 .55388 Metetra
1 g
.8891 .54543 .87672 .54877 .88389 .55299 .89624 .54967 Metetra
1 g
.8819 .54114 .86949 .54452 .87672 .54877 .8891 .54543 Metetra
1 g
.87464 .53683 .86219 .54023 .86949 .54452 .8819 .54114 Metetra
1 g
.86731 .53247 .85484 .5359 .86219 .54023 .87464 .53683 Metetra
1 g
.85992 .52808 .84742 .53154 .85484 .5359 .86731 .53247 Metetra
1 g
.85247 .52364 .83994 .52714 .84742 .53154 .85992 .52808 Metetra
1 g
.84456 .51348 .83165 .51136 .83994 .52714 .85247 .52364 Metetra
1 g
.83564 .4886 .8228 .48706 .83165 .51136 .84456 .51348 Metetra
1 g
.82691 .46681 .81412 .46577 .8228 .48706 .83564 .4886 Metetra
1 g
.81833 .44742 .80557 .44679 .81412 .46577 .82691 .46681 Metetra
1 g
.80983 .42991 .79711 .42966 .80557 .44679 .81833 .44742 Metetra
1 g
.8014 .41392 .78871 .41399 .79711 .42966 .80983 .42991 Metetra
1 g
.79301 .39916 .78033 .39952 .78871 .41399 .8014 .41392 Metetra
1 g
.78464 .38541 .77198 .38602 .78033 .39952 .79301 .39916 Metetra
1 g
.77628 .3725 .76362 .37335 .77198 .38602 .78464 .38541 Metetra
1 g
.76791 .36028 .75526 .36135 .76362 .37335 .77628 .3725 Metetra
1 g
.75953 .34867 .74688 .34993 .75526 .36135 .76791 .36028 Metetra
1 g
.75112 .33755 .73847 .33899 .74688 .34993 .75953 .34867 Metetra
1 g
.74268 .32685 .73003 .32847 .73847 .33899 .75112 .33755 Metetra
1 g
.7342 .31653 .72155 .31831 .73003 .32847 .74268 .32685 Metetra
1 g
.72568 .30651 .71302 .30844 .72155 .31831 .7342 .31653 Metetra
1 g
.71712 .29677 .70445 .29884 .71302 .30844 .72568 .30651 Metetra
1 g
.7085 .28726 .69582 .28947 .70445 .29884 .71712 .29677 Metetra
1 g
.69983 .27795 .68714 .28029 .69582 .28947 .7085 .28726 Metetra
1 g
.6911 .26881 .6784 .27127 .68714 .28029 .69983 .27795 Metetra
1 g
.68231 .25983 .6696 .2624 .6784 .27127 .6911 .26881 Metetra
1 g
.67346 .25097 .66074 .25366 .6696 .2624 .68231 .25983 Metetra
1 g
.66455 .24222 .65181 .24502 .66074 .25366 .67346 .25097 Metetra
1 g
.65556 .23356 .64281 .23647 .65181 .24502 .66455 .24222 Metetra
1 g
.64651 .22499 .63374 .228 .64281 .23647 .65556 .23356 Metetra
1 g
.63738 .21648 .6246 .21959 .63374 .228 .64651 .22499 Metetra
1 g
.62818 .20802 .61538 .21123 .6246 .21959 .63738 .21648 Metetra
1 g
.6189 .19961 .60609 .20292 .61538 .21123 .62818 .20802 Metetra
1 g
.60954 .19124 .59672 .19464 .60609 .20292 .6189 .19961 Metetra
1 g
.60011 .18289 .58726 .18638 .59672 .19464 .60954 .19124 Metetra
1 g
.59059 .17456 .57773 .17814 .58726 .18638 .60011 .18289 Metetra
1 g
.58099 .16625 .56811 .16992 .57773 .17814 .59059 .17456 Metetra
1 g
.5713 .15794 .55841 .1617 .56811 .16992 .58099 .16625 Metetra
1 g
.56153 .14963 .54862 .15347 .55841 .1617 .5713 .15794 Metetra
1 g
.55167 .14131 .53874 .14524 .54862 .15347 .56153 .14963 Metetra
1 g
.54171 .13298 .52876 .137 .53874 .14524 .55167 .14131 Metetra
1 g
.53167 .12464 .5187 .12874 .52876 .137 .54171 .13298 Metetra
1 g
.52153 .11627 .50854 .12046 .5187 .12874 .53167 .12464 Metetra
1 g
.51129 .10788 .49829 .11215 .50854 .12046 .52153 .11627 Metetra
1 g
.50096 .09946 .48794 .10382 .49829 .11215 .51129 .10788 Metetra
1 g
.92966 .55894 .9173 .56219 .92421 .5663 .93653 .56307 Metetra
1 g
.92273 .55477 .91034 .55806 .9173 .56219 .92966 .55894 Metetra
1 g
.91573 .55057 .90332 .55388 .91034 .55806 .92273 .55477 Metetra
1 g
.90868 .54633 .89624 .54967 .90332 .55388 .91573 .55057 Metetra
1 g
.90157 .54206 .8891 .54543 .89624 .54967 .90868 .54633 Metetra
1 g
.8944 .53775 .8819 .54114 .8891 .54543 .90157 .54206 Metetra
1 g
.88717 .5334 .87464 .53683 .8819 .54114 .8944 .53775 Metetra
1 g
.87987 .52901 .86731 .53247 .87464 .53683 .88717 .5334 Metetra
1 g
.87251 .52459 .85992 .52808 .86731 .53247 .87987 .52901 Metetra
1 g
.86509 .52012 .85247 .52364 .85992 .52808 .87251 .52459 Metetra
1 g
.85759 .51562 .84456 .51348 .85247 .52364 .86509 .52012 Metetra
1 g
.8486 .49015 .83564 .4886 .84456 .51348 .85759 .51562 Metetra
1 g
.83982 .46787 .82691 .46681 .83564 .4886 .8486 .49015 Metetra
1 g
.83119 .44805 .81833 .44742 .82691 .46681 .83982 .46787 Metetra
1 g
.82266 .43017 .80983 .42991 .81833 .44742 .83119 .44805 Metetra
1 g
.81421 .41385 .8014 .41392 .80983 .42991 .82266 .43017 Metetra
1 g
.8058 .3988 .79301 .39916 .8014 .41392 .81421 .41385 Metetra
1 g
.79742 .38479 .78464 .38541 .79301 .39916 .8058 .3988 Metetra
1 g
.78904 .37164 .77628 .3725 .78464 .38541 .79742 .38479 Metetra
1 g
.78067 .35921 .76791 .36028 .77628 .3725 .78904 .37164 Metetra
1 g
.77228 .34739 .75953 .34867 .76791 .36028 .78067 .35921 Metetra
1 g
.76387 .33609 .75112 .33755 .75953 .34867 .77228 .34739 Metetra
1 g
.75543 .32522 .74268 .32685 .75112 .33755 .76387 .33609 Metetra
1 g
.74696 .31473 .7342 .31653 .74268 .32685 .75543 .32522 Metetra
1 g
.73845 .30457 .72568 .30651 .7342 .31653 .74696 .31473 Metetra
1 g
.72989 .29468 .71712 .29677 .72568 .30651 .73845 .30457 Metetra
1 g
.72128 .28504 .7085 .28726 .71712 .29677 .72989 .29468 Metetra
1 g
.71262 .2756 .69983 .27795 .7085 .28726 .72128 .28504 Metetra
1 g
.70391 .26634 .6911 .26881 .69983 .27795 .71262 .2756 Metetra
1 g
.69513 .25723 .68231 .25983 .6911 .26881 .70391 .26634 Metetra
1 g
.68629 .24826 .67346 .25097 .68231 .25983 .69513 .25723 Metetra
1 g
.67739 .2394 .66455 .24222 .67346 .25097 .68629 .24826 Metetra
1 g
.66842 .23063 .65556 .23356 .66455 .24222 .67739 .2394 Metetra
1 g
.65938 .22195 .64651 .22499 .65556 .23356 .66842 .23063 Metetra
1 g
.65026 .21334 .63738 .21648 .64651 .22499 .65938 .22195 Metetra
1 g
.64108 .20479 .62818 .20802 .63738 .21648 .65026 .21334 Metetra
1 g
.63182 .19628 .6189 .19961 .62818 .20802 .64108 .20479 Metetra
1 g
.62248 .18781 .60954 .19124 .6189 .19961 .63182 .19628 Metetra
1 g
.61306 .17937 .60011 .18289 .60954 .19124 .62248 .18781 Metetra
1 g
.60356 .17095 .59059 .17456 .60011 .18289 .61306 .17937 Metetra
1 g
.59397 .16255 .58099 .16625 .59059 .17456 .60356 .17095 Metetra
1 g
.58431 .15415 .5713 .15794 .58099 .16625 .59397 .16255 Metetra
1 g
.57455 .14575 .56153 .14963 .5713 .15794 .58431 .15415 Metetra
1 g
.56471 .13734 .55167 .14131 .56153 .14963 .57455 .14575 Metetra
1 g
.55477 .12893 .54171 .13298 .55167 .14131 .56471 .13734 Metetra
1 g
.54474 .1205 .53167 .12464 .54171 .13298 .55477 .12893 Metetra
1 g
.53462 .11205 .52153 .11627 .53167 .12464 .54474 .1205 Metetra
1 g
.52441 .10357 .51129 .10788 .52153 .11627 .53462 .11205 Metetra
1 g
.51409 .09507 .50096 .09946 .51129 .10788 .52441 .10357 Metetra
1 g
.94209 .55566 .92966 .55894 .93653 .56307 .94894 .55982 Metetra
1 g
.93519 .55146 .92273 .55477 .92966 .55894 .94209 .55566 Metetra
1 g
.92823 .54723 .91573 .55057 .92273 .55477 .93519 .55146 Metetra
1 g
.92121 .54297 .90868 .54633 .91573 .55057 .92823 .54723 Metetra
1 g
.91413 .53867 .90157 .54206 .90868 .54633 .92121 .54297 Metetra
1 g
.90699 .53433 .8944 .53775 .90157 .54206 .91413 .53867 Metetra
1 g
.89978 .52995 .88717 .5334 .8944 .53775 .90699 .53433 Metetra
1 g
.89252 .52553 .87987 .52901 .88717 .5334 .89978 .52995 Metetra
1 g
.88519 .52108 .87251 .52459 .87987 .52901 .89252 .52553 Metetra
1 g
.87779 .51658 .86509 .52012 .87251 .52459 .88519 .52108 Metetra
1 g
.87033 .51205 .85759 .51562 .86509 .52012 .87779 .51658 Metetra
1 g
.86168 .49172 .8486 .49015 .85759 .51562 .87033 .51205 Metetra
1 g
.85284 .46893 .83982 .46787 .8486 .49015 .86168 .49172 Metetra
1 g
.84417 .44868 .83119 .44805 .83982 .46787 .85284 .46893 Metetra
1 g
.8356 .43043 .82266 .43017 .83119 .44805 .84417 .44868 Metetra
1 g
.82712 .41378 .81421 .41385 .82266 .43017 .8356 .43043 Metetra
1 g
.81869 .39844 .8058 .3988 .81421 .41385 .82712 .41378 Metetra
1 g
.8103 .38416 .79742 .38479 .8058 .3988 .81869 .39844 Metetra
1 g
.80191 .37077 .78904 .37164 .79742 .38479 .8103 .38416 Metetra
1 g
.79353 .35812 .78067 .35921 .78904 .37164 .80191 .37077 Metetra
1 g
.78514 .3461 .77228 .34739 .78067 .35921 .79353 .35812 Metetra
1 g
.77673 .33461 .76387 .33609 .77228 .34739 .78514 .3461 Metetra
1 g
.7683 .32358 .75543 .32522 .76387 .33609 .77673 .33461 Metetra
1 g
.75983 .31293 .74696 .31473 .75543 .32522 .7683 .32358 Metetra
1 g
.75132 .30261 .73845 .30457 .74696 .31473 .75983 .31293 Metetra
1 g
.74277 .29258 .72989 .29468 .73845 .30457 .75132 .30261 Metetra
1 g
.73417 .28279 .72128 .28504 .72989 .29468 .74277 .29258 Metetra
1 g
.72552 .27322 .71262 .2756 .72128 .28504 .73417 .28279 Metetra
1 g
.71681 .26384 .70391 .26634 .71262 .2756 .72552 .27322 Metetra
1 g
.70805 .25461 .69513 .25723 .70391 .26634 .71681 .26384 Metetra
1 g
.69922 .24552 .68629 .24826 .69513 .25723 .70805 .25461 Metetra
1 g
.69033 .23655 .67739 .2394 .68629 .24826 .69922 .24552 Metetra
1 g
.68138 .22768 .66842 .23063 .67739 .2394 .69033 .23655 Metetra
1 g
.67235 .2189 .65938 .22195 .66842 .23063 .68138 .22768 Metetra
1 g
.66326 .21018 .65026 .21334 .65938 .22195 .67235 .2189 Metetra
1 g
.65409 .20153 .64108 .20479 .65026 .21334 .66326 .21018 Metetra
1 g
.64484 .19293 .63182 .19628 .64108 .20479 .65409 .20153 Metetra
1 g
.63552 .18436 .62248 .18781 .63182 .19628 .64484 .19293 Metetra
1 g
.62612 .17583 .61306 .17937 .62248 .18781 .63552 .18436 Metetra
1 g
.61664 .16731 .60356 .17095 .61306 .17937 .62612 .17583 Metetra
1 g
.60707 .15882 .59397 .16255 .60356 .17095 .61664 .16731 Metetra
1 g
.59742 .15033 .58431 .15415 .59397 .16255 .60707 .15882 Metetra
1 g
.58768 .14184 .57455 .14575 .58431 .15415 .59742 .15033 Metetra
1 g
.57785 .13334 .56471 .13734 .57455 .14575 .58768 .14184 Metetra
1 g
.56794 .12484 .55477 .12893 .56471 .13734 .57785 .13334 Metetra
1 g
.55793 .11633 .54474 .1205 .55477 .12893 .56794 .12484 Metetra
1 g
.54783 .10779 .53462 .11205 .54474 .1205 .55793 .11633 Metetra
1 g
.53763 .09923 .52441 .10357 .53462 .11205 .54783 .10779 Metetra
1 g
.52734 .09064 .51409 .09507 .52441 .10357 .53763 .09923 Metetra
1 g
.95461 .55236 .94209 .55566 .94894 .55982 .96143 .55655 Metetra
1 g
.94774 .54814 .93519 .55146 .94209 .55566 .95461 .55236 Metetra
1 g
.94081 .54388 .92823 .54723 .93519 .55146 .94774 .54814 Metetra
1 g
.93382 .53958 .92121 .54297 .92823 .54723 .94081 .54388 Metetra
1 g
.92677 .53525 .91413 .53867 .92121 .54297 .93382 .53958 Metetra
1 g
.91966 .53088 .90699 .53433 .91413 .53867 .92677 .53525 Metetra
1 g
.91248 .52647 .89978 .52995 .90699 .53433 .91966 .53088 Metetra
1 g
.90525 .52203 .89252 .52553 .89978 .52995 .91248 .52647 Metetra
1 g
.89795 .51754 .88519 .52108 .89252 .52553 .90525 .52203 Metetra
1 g
.89058 .51301 .87779 .51658 .88519 .52108 .89795 .51754 Metetra
1 g
.88315 .50845 .87033 .51205 .87779 .51658 .89058 .51301 Metetra
1 g
.87488 .4933 .86168 .49172 .87033 .51205 .88315 .50845 Metetra
1 g
.86598 .47001 .85284 .46893 .86168 .49172 .87488 .4933 Metetra
1 g
.85726 .44932 .84417 .44868 .85284 .46893 .86598 .47001 Metetra
1 g
.84866 .43069 .8356 .43043 .84417 .44868 .85726 .44932 Metetra
1 g
.84015 .41371 .82712 .41378 .8356 .43043 .84866 .43069 Metetra
1 g
.8317 .39807 .81869 .39844 .82712 .41378 .84015 .41371 Metetra
1 g
.82329 .38353 .8103 .38416 .81869 .39844 .8317 .39807 Metetra
1 g
.81489 .3699 .80191 .37077 .8103 .38416 .82329 .38353 Metetra
1 g
.8065 .35703 .79353 .35812 .80191 .37077 .81489 .3699 Metetra
1 g
.79811 .34481 .78514 .3461 .79353 .35812 .8065 .35703 Metetra
1 g
.7897 .33313 .77673 .33461 .78514 .3461 .79811 .34481 Metetra
1 g
.78126 .32192 .7683 .32358 .77673 .33461 .7897 .33313 Metetra
1 g
.7728 .3111 .75983 .31293 .7683 .32358 .78126 .32192 Metetra
1 g
.7643 .30063 .75132 .30261 .75983 .31293 .7728 .3111 Metetra
1 g
.75575 .29046 .74277 .29258 .75132 .30261 .7643 .30063 Metetra
1 g
.74716 .28053 .73417 .28279 .74277 .29258 .75575 .29046 Metetra
1 g
.73852 .27083 .72552 .27322 .73417 .28279 .74716 .28053 Metetra
1 g
.72983 .26132 .71681 .26384 .72552 .27322 .73852 .27083 Metetra
1 g
.72108 .25197 .70805 .25461 .71681 .26384 .72983 .26132 Metetra
1 g
.71226 .24277 .69922 .24552 .70805 .25461 .72108 .25197 Metetra
1 g
.70339 .23368 .69033 .23655 .69922 .24552 .71226 .24277 Metetra
1 g
.69445 .2247 .68138 .22768 .69033 .23655 .70339 .23368 Metetra
1 g
.68544 .21581 .67235 .2189 .68138 .22768 .69445 .2247 Metetra
1 g
.67636 .207 .66326 .21018 .67235 .2189 .68544 .21581 Metetra
1 g
.6672 .19824 .65409 .20153 .66326 .21018 .67636 .207 Metetra
1 g
.65798 .18954 .64484 .19293 .65409 .20153 .6672 .19824 Metetra
1 g
.64867 .18088 .63552 .18436 .64484 .19293 .65798 .18954 Metetra
1 g
.63929 .17225 .62612 .17583 .63552 .18436 .64867 .18088 Metetra
1 g
.62982 .16364 .61664 .16731 .62612 .17583 .63929 .17225 Metetra
1 g
.62027 .15505 .60707 .15882 .61664 .16731 .62982 .16364 Metetra
1 g
.61064 .14647 .59742 .15033 .60707 .15882 .62027 .15505 Metetra
1 g
.60092 .13789 .58768 .14184 .59742 .15033 .61064 .14647 Metetra
1 g
.59112 .12931 .57785 .13334 .58768 .14184 .60092 .13789 Metetra
1 g
.58122 .12072 .56794 .12484 .57785 .13334 .59112 .12931 Metetra
1 g
.57123 .11212 .55793 .11633 .56794 .12484 .58122 .12072 Metetra
1 g
.56115 .10349 .54783 .10779 .55793 .11633 .57123 .11212 Metetra
1 g
.55097 .09485 .53763 .09923 .54783 .10779 .56115 .10349 Metetra
1 g
.54069 .08617 .52734 .09064 .53763 .09923 .55097 .09485 Metetra
1 g
.96722 .54904 .95461 .55236 .96143 .55655 .974 .55325 Metetra
1 g
.96037 .54479 .94774 .54814 .95461 .55236 .96722 .54904 Metetra
1 g
.95348 .5405 .94081 .54388 .94774 .54814 .96037 .54479 Metetra
1 g
.94652 .53617 .93382 .53958 .94081 .54388 .95348 .5405 Metetra
1 g
.9395 .53181 .92677 .53525 .93382 .53958 .94652 .53617 Metetra
1 g
.93242 .52741 .91966 .53088 .92677 .53525 .9395 .53181 Metetra
1 g
.92527 .52297 .91248 .52647 .91966 .53088 .93242 .52741 Metetra
1 g
.91807 .5185 .90525 .52203 .91248 .52647 .92527 .52297 Metetra
1 g
.9108 .51398 .89795 .51754 .90525 .52203 .91807 .5185 Metetra
1 g
.90347 .50942 .89058 .51301 .89795 .51754 .9108 .51398 Metetra
1 g
.89607 .50483 .88315 .50845 .89058 .51301 .90347 .50942 Metetra
1 g
.8882 .49489 .87488 .4933 .88315 .50845 .89607 .50483 Metetra
1 g
.87924 .47109 .86598 .47001 .87488 .4933 .8882 .49489 Metetra
1 g
.87046 .44997 .85726 .44932 .86598 .47001 .87924 .47109 Metetra
1 g
.86183 .43096 .84866 .43069 .85726 .44932 .87046 .44997 Metetra
1 g
.85329 .41364 .84015 .41371 .84866 .43069 .86183 .43096 Metetra
1 g
.84482 .3977 .8317 .39807 .84015 .41371 .85329 .41364 Metetra
1 g
.83639 .38289 .82329 .38353 .8317 .39807 .84482 .3977 Metetra
1 g
.82798 .36902 .81489 .3699 .82329 .38353 .83639 .38289 Metetra
1 g
.81959 .35593 .8065 .35703 .81489 .3699 .82798 .36902 Metetra
1 g
.81119 .3435 .79811 .34481 .8065 .35703 .81959 .35593 Metetra
1 g
.80278 .33163 .7897 .33313 .79811 .34481 .81119 .3435 Metetra
1 g
.79434 .32024 .78126 .32192 .7897 .33313 .80278 .33163 Metetra
1 g
.78588 .30927 .7728 .3111 .78126 .32192 .79434 .32024 Metetra
1 g
.77738 .29864 .7643 .30063 .7728 .3111 .78588 .30927 Metetra
1 g
.76885 .28832 .75575 .29046 .7643 .30063 .77738 .29864 Metetra
1 g
.76027 .27825 .74716 .28053 .75575 .29046 .76885 .28832 Metetra
1 g
.75164 .26842 .73852 .27083 .74716 .28053 .76027 .27825 Metetra
1 g
.74295 .25878 .72983 .26132 .73852 .27083 .75164 .26842 Metetra
1 g
.73421 .24931 .72108 .25197 .72983 .26132 .74295 .25878 Metetra
1 g
.72541 .23999 .71226 .24277 .72108 .25197 .73421 .24931 Metetra
1 g
.71655 .23079 .70339 .23368 .71226 .24277 .72541 .23999 Metetra
1 g
.70763 .2217 .69445 .2247 .70339 .23368 .71655 .23079 Metetra
1 g
.69863 .2127 .68544 .21581 .69445 .2247 .70763 .2217 Metetra
1 g
.68957 .20378 .67636 .207 .68544 .21581 .69863 .2127 Metetra
1 g
.68043 .19493 .6672 .19824 .67636 .207 .68957 .20378 Metetra
1 g
.67122 .18612 .65798 .18954 .6672 .19824 .68043 .19493 Metetra
1 g
.66193 .17737 .64867 .18088 .65798 .18954 .67122 .18612 Metetra
1 g
.65257 .16864 .63929 .17225 .64867 .18088 .66193 .17737 Metetra
1 g
.64312 .15994 .62982 .16364 .63929 .17225 .65257 .16864 Metetra
1 g
.63359 .15126 .62027 .15505 .62982 .16364 .64312 .15994 Metetra
1 g
.62398 .14258 .61064 .14647 .62027 .15505 .63359 .15126 Metetra
1 g
.61428 .13392 .60092 .13789 .61064 .14647 .62398 .14258 Metetra
1 g
.60449 .12524 .59112 .12931 .60092 .13789 .61428 .13392 Metetra
1 g
.59461 .11656 .58122 .12072 .59112 .12931 .60449 .12524 Metetra
1 g
.58464 .10787 .57123 .11212 .58122 .12072 .59461 .11656 Metetra
1 g
.57458 .09916 .56115 .10349 .57123 .11212 .58464 .10787 Metetra
1 g
.56442 .09043 .55097 .09485 .56115 .10349 .57458 .09916 Metetra
1 g
.55417 .08166 .54069 .08617 .55097 .09485 .56442 .09043 Metetra
1 g
.9799 .54569 .96722 .54904 .974 .55325 .98666 .54994 Metetra
1 g
.97309 .54141 .96037 .54479 .96722 .54904 .9799 .54569 Metetra
1 g
.96623 .5371 .95348 .5405 .96037 .54479 .97309 .54141 Metetra
1 g
.9593 .53274 .94652 .53617 .95348 .5405 .96623 .5371 Metetra
1 g
.95231 .52835 .9395 .53181 .94652 .53617 .9593 .53274 Metetra
1 g
.94526 .52392 .93242 .52741 .9395 .53181 .95231 .52835 Metetra
1 g
.93815 .51945 .92527 .52297 .93242 .52741 .94526 .52392 Metetra
1 g
.93098 .51494 .91807 .5185 .92527 .52297 .93815 .51945 Metetra
1 g
.92374 .51039 .9108 .51398 .91807 .5185 .93098 .51494 Metetra
1 g
.91644 .50581 .90347 .50942 .9108 .51398 .92374 .51039 Metetra
1 g
.90907 .50118 .89607 .50483 .90347 .50942 .91644 .50581 Metetra
1 g
.90164 .4965 .8882 .49489 .89607 .50483 .90907 .50118 Metetra
1 g
.89261 .47218 .87924 .47109 .8882 .49489 .90164 .4965 Metetra
1 g
.88379 .45062 .87046 .44997 .87924 .47109 .89261 .47218 Metetra
1 g
.87511 .43122 .86183 .43096 .87046 .44997 .88379 .45062 Metetra
1 g
.86654 .41357 .85329 .41364 .86183 .43096 .87511 .43122 Metetra
1 g
.85805 .39733 .84482 .3977 .85329 .41364 .86654 .41357 Metetra
1 g
.8496 .38225 .83639 .38289 .84482 .3977 .85805 .39733 Metetra
1 g
.84118 .36813 .82798 .36902 .83639 .38289 .8496 .38225 Metetra
1 g
.83278 .35482 .81959 .35593 .82798 .36902 .84118 .36813 Metetra
1 g
.82437 .34218 .81119 .3435 .81959 .35593 .83278 .35482 Metetra
1 g
.81596 .33012 .80278 .33163 .81119 .3435 .82437 .34218 Metetra
1 g
.80753 .31856 .79434 .32024 .80278 .33163 .81596 .33012 Metetra
1 g
.79907 .30741 .78588 .30927 .79434 .32024 .80753 .31856 Metetra
1 g
.79058 .29663 .77738 .29864 .78588 .30927 .79907 .30741 Metetra
1 g
.78205 .28616 .76885 .28832 .77738 .29864 .79058 .29663 Metetra
1 g
.77348 .27596 .76027 .27825 .76885 .28832 .78205 .28616 Metetra
1 g
.76486 .26599 .75164 .26842 .76027 .27825 .77348 .27596 Metetra
1 g
.75619 .25622 .74295 .25878 .75164 .26842 .76486 .26599 Metetra
1 g
.74746 .24663 .73421 .24931 .74295 .25878 .75619 .25622 Metetra
1 g
.73867 .23719 .72541 .23999 .73421 .24931 .74746 .24663 Metetra
1 g
.72983 .22787 .71655 .23079 .72541 .23999 .73867 .23719 Metetra
1 g
.72091 .21867 .70763 .2217 .71655 .23079 .72983 .22787 Metetra
1 g
.71194 .20957 .69863 .2127 .70763 .2217 .72091 .21867 Metetra
1 g
.70289 .20054 .68957 .20378 .69863 .2127 .71194 .20957 Metetra
1 g
.69377 .19158 .68043 .19493 .68957 .20378 .70289 .20054 Metetra
1 g
.68457 .18268 .67122 .18612 .68043 .19493 .69377 .19158 Metetra
1 g
.67531 .17382 .66193 .17737 .67122 .18612 .68457 .18268 Metetra
1 g
.66596 .165 .65257 .16864 .66193 .17737 .67531 .17382 Metetra
1 g
.65653 .15621 .64312 .15994 .65257 .16864 .66596 .165 Metetra
1 g
.64702 .14743 .63359 .15126 .64312 .15994 .65653 .15621 Metetra
1 g
.63743 .13866 .62398 .14258 .63359 .15126 .64702 .14743 Metetra
1 g
.62775 .1299 .61428 .13392 .62398 .14258 .63743 .13866 Metetra
1 g
.61798 .12114 .60449 .12524 .61428 .13392 .62775 .1299 Metetra
1 g
.60812 .11237 .59461 .11656 .60449 .12524 .61798 .12114 Metetra
1 g
.59817 .10359 .58464 .10787 .59461 .11656 .60812 .11237 Metetra
1 g
.58813 .09479 .57458 .09916 .58464 .10787 .59817 .10359 Metetra
1 g
.57799 .08597 .56442 .09043 .57458 .09916 .58813 .09479 Metetra
1 g
.56776 .07712 .55417 .08166 .56442 .09043 .57799 .08597 Metetra
1 g
.99268 .54232 .9799 .54569 .98666 .54994 .9994 .5466 Metetra
1 g
.9859 .53802 .97309 .54141 .9799 .54569 .99268 .54232 Metetra
1 g
.97906 .53367 .96623 .5371 .97309 .54141 .9859 .53802 Metetra
1 g
.97217 .52929 .9593 .53274 .96623 .5371 .97906 .53367 Metetra
1 g
.96521 .52486 .95231 .52835 .9593 .53274 .97217 .52929 Metetra
1 g
.9582 .5204 .94526 .52392 .95231 .52835 .96521 .52486 Metetra
1 g
.95112 .5159 .93815 .51945 .94526 .52392 .9582 .5204 Metetra
1 g
.94398 .51136 .93098 .51494 .93815 .51945 .95112 .5159 Metetra
1 g
.93677 .50678 .92374 .51039 .93098 .51494 .94398 .51136 Metetra
1 g
.9295 .50216 .91644 .50581 .92374 .51039 .93677 .50678 Metetra
1 g
.92217 .4975 .90907 .50118 .91644 .50581 .9295 .50216 Metetra
1 g
.91477 .4928 .90164 .4965 .90907 .50118 .92217 .4975 Metetra
1 g
.90611 .47329 .89261 .47218 .90164 .4965 .91477 .4928 Metetra
1 g
.89724 .45128 .88379 .45062 .89261 .47218 .90611 .47329 Metetra
1 g
.88852 .43149 .87511 .43122 .88379 .45062 .89724 .45128 Metetra
1 g
.87992 .4135 .86654 .41357 .87511 .43122 .88852 .43149 Metetra
1 g
.87139 .39695 .85805 .39733 .86654 .41357 .87992 .4135 Metetra
1 g
.86293 .3816 .8496 .38225 .85805 .39733 .87139 .39695 Metetra
1 g
.8545 .36723 .84118 .36813 .8496 .38225 .86293 .3816 Metetra
1 g
.84608 .35369 .83278 .35482 .84118 .36813 .8545 .36723 Metetra
1 g
.83767 .34085 .82437 .34218 .83278 .35482 .84608 .35369 Metetra
1 g
.82926 .3286 .81596 .33012 .82437 .34218 .83767 .34085 Metetra
1 g
.82083 .31686 .80753 .31856 .81596 .33012 .82926 .3286 Metetra
1 g
.81237 .30554 .79907 .30741 .80753 .31856 .82083 .31686 Metetra
1 g
.80389 .2946 .79058 .29663 .79907 .30741 .81237 .30554 Metetra
1 g
.79536 .28398 .78205 .28616 .79058 .29663 .80389 .2946 Metetra
1 g
.7868 .27364 .77348 .27596 .78205 .28616 .79536 .28398 Metetra
1 g
.77819 .26353 .76486 .26599 .77348 .27596 .7868 .27364 Metetra
1 g
.76953 .25364 .75619 .25622 .76486 .26599 .77819 .26353 Metetra
1 g
.76081 .24392 .74746 .24663 .75619 .25622 .76953 .25364 Metetra
1 g
.75204 .23436 .73867 .23719 .74746 .24663 .76081 .24392 Metetra
1 g
.74321 .22493 .72983 .22787 .73867 .23719 .75204 .23436 Metetra
1 g
.73431 .21562 .72091 .21867 .72983 .22787 .74321 .22493 Metetra
1 g
.72535 .2064 .71194 .20957 .72091 .21867 .73431 .21562 Metetra
1 g
.71632 .19727 .70289 .20054 .71194 .20957 .72535 .2064 Metetra
1 g
.70722 .18821 .69377 .19158 .70289 .20054 .71632 .19727 Metetra
1 g
.69804 .17921 .68457 .18268 .69377 .19158 .70722 .18821 Metetra
1 g
.68879 .17025 .67531 .17382 .68457 .18268 .69804 .17921 Metetra
1 g
.67946 .16133 .66596 .165 .67531 .17382 .68879 .17025 Metetra
1 g
.67005 .15244 .65653 .15621 .66596 .165 .67946 .16133 Metetra
1 g
.66056 .14357 .64702 .14743 .65653 .15621 .67005 .15244 Metetra
1 g
.65099 .13471 .63743 .13866 .64702 .14743 .66056 .14357 Metetra
1 g
.64133 .12586 .62775 .1299 .63743 .13866 .65099 .13471 Metetra
1 g
.63158 .117 .61798 .12114 .62775 .1299 .64133 .12586 Metetra
1 g
.62175 .10814 .60812 .11237 .61798 .12114 .63158 .117 Metetra
1 g
.61182 .09927 .59817 .10359 .60812 .11237 .62175 .10814 Metetra
1 g
.6018 .09038 .58813 .09479 .59817 .10359 .61182 .09927 Metetra
1 g
.59168 .08147 .57799 .08597 .58813 .09479 .6018 .09038 Metetra
1 g
.58147 .07253 .56776 .07712 .57799 .08597 .59168 .08147 Metetra
0 g
.25 Mabswid
.58034 0 m
.58486 .29035 L
s
.58486 .29035 m
0 .50662 L
s
0 .50662 m
.02633 .25271 L
s
.02633 .25271 m
.58034 0 L
s
.58034 0 m
.58486 .29035 L
s
.58486 .29035 m
1 .55274 L
s
1 .55274 m
.97591 .3073 L
s
.97591 .3073 m
.58034 0 L
s
.58034 0 m
.97591 .3073 L
s
.58034 0 m
.57452 .00265 L
s
[(0)] .59197 -0.00531 -1 .45615 Mshowa
.67445 .07312 m
.66857 .0756 L
s
[(0.2)] .68623 .06814 -1 .42276 Mshowa
.76005 .13961 m
.7541 .14196 L
s
[(0.4)] .77195 .13493 -1 .39392 Mshowa
.83824 .20035 m
.83224 .20256 L
s
[(0.6)] .85023 .19593 -1 .36876 Mshowa
.90993 .25605 m
.90389 .25814 L
s
[(0.8)] .92201 .25186 -1 .34663 Mshowa
.97591 .3073 m
.96984 .30929 L
s
[(1)] .98806 .30333 -1 .327 Mshowa
.125 Mabswid
.60473 .01895 m
.60123 .02052 L
s
.62854 .03745 m
.62503 .03899 L
s
.65177 .05549 m
.64825 .05701 L
s
.69661 .09032 m
.69306 .09179 L
s
.71824 .10713 m
.71469 .10858 L
s
.73939 .12356 m
.73583 .12499 L
s
.78025 .15531 m
.77668 .15669 L
s
.80001 .17065 m
.79643 .17202 L
s
.81933 .18566 m
.81574 .18701 L
s
.85674 .21472 m
.85313 .21603 L
s
.87484 .22879 m
.87123 .23008 L
s
.89257 .24256 m
.88895 .24383 L
s
.92693 .26926 m
.9233 .2705 L
s
.94359 .2822 m
.93996 .28342 L
s
.95991 .29488 m
.95627 .29608 L
s
gsave
.87169 .14335 -61 -10.7752 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 17.8125 translate 1 -1 scale
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
69.000 11.250 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.02633 .25271 m
0 .50662 L
s
.02573 .25845 m
.03144 .26134 L
s
[(-1)] .01432 .25269 1 .50547 Mshowa
.0197 .31665 m
.02546 .31942 L
s
[(-0.5)] .00818 .3111 1 .48141 Mshowa
.01351 .37631 m
.01933 .37897 L
s
[(0)] .00188 .371 1 .45686 Mshowa
.00717 .43749 m
.01304 .44003 L
s
[(0.5)] -0.00457 .43242 1 .43182 Mshowa
.00066 .50025 m
.00658 .50266 L
s
[(1)] -0.01118 .49544 1 .40625 Mshowa
.125 Mabswid
.02454 .26998 m
.02797 .27169 L
s
.02334 .28156 m
.02677 .28326 L
s
.02213 .2932 m
.02557 .29489 L
s
.02092 .30489 m
.02436 .30657 L
s
.01847 .32846 m
.02193 .33011 L
s
.01724 .34034 m
.02071 .34197 L
s
.016 .35227 m
.01948 .35389 L
s
.01476 .36426 m
.01824 .36587 L
s
.01225 .38842 m
.01575 .39 L
s
.01099 .4006 m
.01449 .40216 L
s
.00972 .41283 m
.01323 .41438 L
s
.00845 .42513 m
.01196 .42667 L
s
.00588 .44992 m
.00941 .45142 L
s
.00458 .4624 m
.00812 .46389 L
s
.00328 .47496 m
.00682 .47643 L
s
.00197 .48757 m
.00552 .48903 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{529, 366.5},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008A0001KQ000`40n007h00Ooooooooo4ooo003o
oooooolCool00?oooc[oo`800=Koo`00oooo>Ooo00@00?ooool00=Goo`00oooo>Ooo00@00?ooool0
0=Goo`00oooo>Ooo00@00?ooool00=Goo`00oooo>Ooo00@00?ooool00=Goo`00oooo>Ooo00@00?oo
ool00=Goo`00oooo>_oo0P00e_oo003ooom3ool2003=ool00?oood;oo`04003ooooo003<ool00?oo
od;oo`04003ooooo003<ool00?oood;oo`04003ooooo003<ool00?oood;oo`04003ooooo003<ool0
0?oood;oo`04003ooooo003<ool00?oooc[oo`8000Ooo`800<goo`00oooo>?oo1@00eOoo003ooolf
ool30002ool01000ool00000dooo003oooldool20005ool01@00oooooooo0000d_oo003ooolbool2
0007ool00`00ooooo`02ool00`00ooooo`3?ool00?ooobooo`<000Woo`03003ooooo00?oo`800<oo
o`00oooo;Ooo0P003?oo00<00?ooool01Ooo00<00?ooool0c?oo003oool[ool2000>ool00`00oooo
o`06ool00`00ooooo`3;ool00?ooobWoo`<000ooo`03003ooooo00Ooo`03003ooooo0<[oo`00oooo
9ooo0P000_oo00<00?ooool03Ooo00<00?ooool02?oo0P00b_oo003ooolUool20004ool00`00oooo
o`0=ool00`00ooooo`09ool20039ool00?ooob;oo`<001Koo`03003ooooo00Soo`04003ooooo0038
ool00?ooob3oo`8001Woo`03003ooooo00coo`800<Koo`00oooo7_oo0P006ooo00<00?ooool03_oo
00<00?ooool0`ooo003ooolLool2000Mool00`00ooooo`0?ool00`00ooooo`32ool00?oooa[oo`80
01ooo`03003ooooo013oo`03003ooooo0<7oo`00looo0P001?oo00<00?ooool00_oo10005?oo1000
8?oo00<00?ooool04Ooo0P00`Ooo003bool01000ooooo`002?oo00<00?ooool04ooo0P000ooo00<0
0?ooool07_oo00<00?ooool04ooo00<00?ooool0__oo003bool01000ooooo`002Ooo00<00?ooool0
4?oo0P009_oo00<00?ooool05?oo00<00?ooool0_Ooo003bool01000ooooo`002_oo00<00?ooool0
3Ooo0P00:?oo00<00?ooool05Ooo0P00_Ooo003bool01000ooooo`002ooo00<00?ooool02_oo0P00
:_oo00<00?ooool05?oo00@00?oo00000;coo`00l_oo00@00?ooool000Soo`04003ooooo0009ool3
000/ool00`00ooooo`0Hool00`00ooooo`2iool00??oo`8000[oo`8000Soo`8002ooo`03003ooooo
01Woo`03003ooooo0;Soo`00XOoo0P00I?oo0`00<?oo00<00?ooool06_oo0P00^?oo002Sool00`00
ooooo`1Oool20002ool00`00ooooo`0^ool00`00ooooo`0Lool00`00ooooo`2eool00:?oo`8005ko
o`8000Coo`03003ooooo02ooo`03003ooooo01coo`03003ooooo0;Coo`00X_oo00@00?ooool005_o
o`8003Soo`03003ooooo01goo`03003ooooo0;?oo`00X_oo00@00?ooool005Soo`<003[oo`03003o
oooo01koo`800;?oo`00X_oo00@00?ooool005Koo`8003goo`03003ooooo023oo`03003ooooo0;3o
o`00XOoo0P0000?oo`000000E?oo0P00?ooo00<00?ooool07ooo00<00?oo0000/Ooo003hool30010
ool00`00ooooo`0Rool2002_ool00?Koo`8000;oo`03003ooooo03koo`03003ooooo02Coo`03003o
oooo00goo`8000Coo`03003ooooo00;oo`@0093oo`00looo0`001?oo00<00?ooool0?_oo00<00?oo
ool09Ooo00<00?ooool02ooo00@00?ooool000Soo`03003ooooo097oo`00lOoo0P001ooo00<00?oo
ool0?_oo00<00?ooool09_oo00<00?ooool02_oo00@00?ooool000Woo`03003ooooo093oo`00kooo
0P00B_oo00<00?ooool09ooo0P002_oo00@00?ooool000[oo`03003ooooo08ooo`00kOoo0P00C?oo
00<00?ooool0:Ooo00<00?ooool01ooo00@00?ooool000_oo`03003ooooo08koo`00jooo0P00C_oo
00<00?ooool0:_oo00<00?ooool01_oo00@00?ooool000Soo`04003ooooo002@ool00>Soo`<004oo
o`8002goo`8000Ooo`8000[oo`80097oo`00i_oo0P000_oo00<00?ooool0BOoo100000?oo`000000
:ooo0P0000?oo`00ool0Y?oo003Tool20004ool00`00ooooo`16ool30005ool00`00ool0000Yool0
0`00ooooo`02ool00`00ooooo`2Rool00>;oo`8004goo`8000;oo`03003ooooo00?oo`04003ooooo
000^ool00`00ooooo`2Qool00>3oo`8004goo`8000Goo`03003ooooo00;oo`05003oooooool0000^
ool2002Qool00=koo`8004coo`<000Soo`05003oooooool00003ool2000_ool00`00ooooo`2Nool0
0=_oo`<004[oo`@000;oo`03003ooooo00Ooo`03003ooooo00@000;oo`03003ooooo02goo`03003o
oooo09goo`00^?oo0P001?oo00<00?ooool01?oo00<00?ooool04Ooo0`00BOoo0`001ooo0P001ooo
10001_oo0P00;_oo0P00WOoo002gool01000ooooo`002_oo00<00?ooool03ooo0P000_oo00<00?oo
ool0@ooo10000_oo00<00?ooool01ooo00<00?ooool010000_oo0P002?oo00<00?ooool0;Ooo00<0
0?ooool0V_oo002gool01000ooooo`001ooo1@003_oo0P001?oo00<00?ooool0@?oo0`001ooo0P00
1ooo0`001ooo0P001ooo0P00;_oo0P00Vooo002gool01000ooooo`001ooo00@00?ooool000goo`80
04Koo`<000;oo`03003ooooo00Ooo`03003ooooo00@000;oo`03003ooooo00Goo`03003oo`0000;o
o`@000;oo`03003ooooo02[oo`04003ooooo002Jool00;Ooo`04003ooooo0008ool00`00ool0000:
ool30015ool30006ool00`00ooooo`06ool30007ool00`00ooooo`04ool00`00ool000020007ool0
0`00ooooo`0]ool2002Hool00;Ooo`04003ooooo0009ool20008ool20016ool20002ool00`00oooo
o`05ool20004ool20002ool00`00ooooo`06ool00`00ooooo`03ool20002ool00`00ooooo`06ool0
0`00ooooo`0^ool00`00ooooo`2Eool00;Soo`8000_oo`03003ooooo00Coo`8004Koo`8000Goo`03
003ooooo00Koo`04003oo`000005ool00`00ooooo`06ool00`00ooooo`030004ool00`00ooooo`06
ool00`00ooooo`0^ool00`00ooooo`2Dool00<[oo`800003ool00?oo04;oo`<000Soo`03003ooooo
00Goo`8000Soo`8000Koo`<000;oo`03003ooooo00?oo`03003ooooo00Goo`80033oo`8009Coo`00
b?oo0P000ooo00<00?ooool0?_oo0`000_oo00<00?ooool01ooo00<00?ooool010000_oo00<00?oo
ool01ooo00<00?ooool00`000_oo00@00?ooool000Koo`03003ooooo00@000;oo`03003ooooo02oo
o`03003ooooo097oo`00aOoo0`00@ooo0`001_oo0P001ooo0`001ooo0P001ooo0`001_oo0`001_oo
0`001ooo0P00<?oo00<00?ooool0T?oo0033ool20012ool40002ool00`00ooooo`06ool00`00oooo
o`040002ool00`00ooooo`07ool00`00ooooo`040002ool00`00ooooo`06ool00`00ooooo`040002
ool00`00ooooo`07ool00`00ooooo`0^ool00`00ooooo`2?ool00<7oo`80047oo`<000Ooo`8000Ko
o`<000Ooo`8000Ooo`<000Ooo`8000Koo`<000Ooo`8000Ooo`8002koo`@008ooo`00_ooo0P00@?oo
0`000_oo00<00?ooool01ooo00<00?ooool00`000_oo0P002?oo00<00?ooool010000_oo00<00?oo
ool01ooo00<00?ooool0100000?oo`00ool02?oo00<00?ooool010000_oo00<00?ooool0;ooo00<0
0?ooool0S?oo002mool2000oool30006ool20007ool30007ool00`00ooooo`05ool30007ool20007
ool30003ool00`00ooooo`020007ool30007ool00`00ooooo`0_ool00`00ooooo`2;ool00;_oo`80
0003ool00?oo03[oo`@000;oo`03003ooooo00Koo`03003ooooo00@000;oo`03003ooooo00Koo`80
00;oo`<000;oo`03003ooooo00Ooo`03003ooooo00@000;oo`05003oooooool00004ool00`00oooo
o`040002ool00`00ooooo`06ool00`00ooooo`0_ool00`00ooooo`2:ool00;Soo`<000?oo`03003o
oooo03Koo`<000Ooo`8000Koo`<000Ooo`8000Ooo`<000Koo`8000Ooo`<000Ooo`800003ool00?oo
00?oo`<000Ooo`03003ooooo00Koo`03003ooooo02ooo`8008[oo`00]_oo0P001_oo00<00?ooool0
=?oo0P000_oo00<00?ooool01ooo00<00?ooool00`000_oo00<00?ooool01ooo00<00?ooool01000
0_oo00<00?ooool01_oo00<00?ooool010000_oo00<00?ooool01ooo0P0000Coo`00000000;oo`03
003ooooo00Koo`03003ooooo00Goo`8003;oo`03003ooooo08Ooo`00]?oo0P00?Ooo0P001Ooo0P00
1ooo0`001_oo0P001ooo0`001ooo0P001_oo0`001ooo00<00?ooool01_oo0`001_oo00<00?ooool0
1_oo00<00?ooool010000_oo00<00?ooool0<?oo00<00?ooool0Q_oo002bool2000mool20009ool0
0`00ooooo`040002ool00`00ooooo`06ool00`00ooooo`040002ool00`00ooooo`07ool00`00oooo
o`030002ool00`00ooooo`06ool00`00ooooo`03ool200000ooo00000007ool00`00ooooo`05ool3
0007ool2000aool20026ool00;3oo`8003_oo`@000;oo`03003ooooo00Koo`<000Ooo`8000Koo`<0
00Ooo`8000Ooo`<000Koo`03003ooooo00Koo`03003ooooo008000?oo`03003oo`0000Ooo`03003o
oooo00@000;oo`03003ooooo00Ooo`03003ooooo02ooo`8008Goo`00[Ooo1000>Ooo0`001ooo0P00
1?oo0P000_oo00<00?ooool01ooo00<00?ooool00`000_oo00<00?ooool01ooo00<00?ooool01000
0_oo00<00?ooool01Ooo00<00?ooool01Ooo0`001Ooo00@00?ooool000Koo`<000Ooo`8000Ooo`80
02ooo`04003ooooo0024ool00:_oo`8000?oo`03003ooooo03Coo`<000;oo`8000Soo`04003oo`00
0005ool00`00ooooo`06ool30006ool00`00ooooo`06ool30007ool00`00ooooo`05ool00`00oooo
o`040002ool00`00ooooo`03ool01@00oooooooo00000_oo0`000_oo00<00?ooool01ooo00<00?oo
ool010000_oo00<00?ooool0<?oo00<00?ooool03Ooo0P001?oo00<00?ooool01?oo00<00?ooool0
I?oo002Yool20005ool00`00ooooo`0aool30007ool00`00ooooo`05ool20008ool20004ool20002
ool00`00ooooo`05ool20004ool20002ool00`00ooooo`06ool00`00ooooo`04ool30007ool20003
ool01000oooooooo0`001_oo0P001ooo0`001ooo00<00?ooool0<?oo0P003?oo00@00?ooool000[o
o`03003ooooo06Coo`00Yooo0P00>?oo0`000_oo0P001ooo0P000_oo0`000_oo00<00?ooool01ooo
00@00?oo000000Goo`03003ooooo00Koo`04003oo`000005ool00`00ooooo`06ool00`00ooooo`03
0002ool00`00ooooo`07ool00`00ooooo`040002ool00`00ooooo`06ool00`00ooooo`040002ool0
0`00ooooo`06ool00`00ooooo`0aool00`00ooooo`09ool01000ooooo`001ooo1@00IOoo002Uool2
000gool30007ool00`00ooooo`05ool30006ool20007ool20008ool00`00ooooo`05ool20008ool0
0`00ooooo`05ool30006ool20007ool40006ool20006ool30007ool00`00ooooo`06ool00`00oooo
o`0aool00`00ooooo`08ool01000ooooo`001ooo00@00?ooool006Koo`00POoo0P001?oo00<00?oo
ool00ooo0P004ooo0`00=_oo0`000_oo00<00?ooool01_oo0P000_oo0`000_oo00<00?ooool01_oo
00<00?ooool010000_oo00<00?ooool01_oo00<00?ooool010000_oo00<00?ooool01_oo00<00?oo
ool010000_oo00<00?ooool01_oo00<00?ooool010000_oo0P002?oo00<00?ooool00`000_oo00<0
0?ooool01_oo00<00?ooool01Ooo0P00<ooo0P002?oo00@00?ooool000Soo`03003oo`0006Koo`00
P?oo00@00?ooool000Soo`04003ooooo000@ool3000eool30006ool20007ool30006ool20006ool3
0007ool20006ool30007ool20006ool30007ool20006ool30007ool20007ool30006ool20007ool0
0`00ooooo`040002ool00`00ooooo`0bool00`00ooooo`05ool01000ooooo`002Ooo0P009?oo0P00
00?oo`000000?Ooo0020ool01000ooooo`002?oo00@00?ooool000koo`8000;oo`03003ooooo033o
o`<000;oo`03003ooooo00Koo`03003ooooo00@000;oo`03003ooooo00Koo`03003ooooo00<000;o
o`03003ooooo00Ooo`03003ooooo00<000;oo`03003ooooo00Ooo`03003ooooo00<000;oo`03003o
oooo00Ooo`03003ooooo00<000;oo`03003ooooo00Goo`03003oo`0000;oo`@000;oo`03003ooooo
00Koo`03003ooooo00;oo`D000Ooo`8003;oo`8000Ooo`8000_oo`03003ooooo02?oo`03003oo`00
03koo`00P?oo00@00?ooool000Soo`<000goo`8000Coo`03003ooooo02goo`<000Koo`8000Koo`<0
00Ooo`8000Koo`<000Koo`8000Ooo`<000Koo`8000Ooo`<000Koo`8000Ooo`<000Koo`8000Goo`03
003oo`00008000Ooo`8000Koo`D000Coo`03003ooooo00Ooo`03003ooooo02goo`8000;oo`03003o
oooo03Soo`03003ooooo03goo`00P?oo00@00?ooool000Soo`03003ooooo00_oo`8003?oo`<000;o
o`03003ooooo00Koo`03003ooooo00<000;oo`8000Soo`03003ooooo00<000;oo`03003ooooo00Ko
o`03003ooooo00@000;oo`03003ooooo00Koo`03003ooooo00@000;oo`03003ooooo00Koo`03003o
oooo00@000;oo`03003ooooo00Koo`03003ooooo00@000;oo`03003ooooo00Ooo`03003ooooo00<0
00;oo`03003ooooo00Goo`8000Ooo`8003?oo`8003Ooo`03003oo`0003koo`00P?oo00@00?ooool0
00Soo`03003ooooo00Woo`8003;oo`<000Koo`8000Koo`<000Ooo`03003ooooo00Goo`<000Koo`80
00Koo`<000Ooo`8000Koo`<000Ooo`8000Koo`<000Ooo`8000Koo`<000?oo`04003oooooool20007
ool30006ool00`00ooooo`06ool00`00ooooo`040002ool00`00ooooo`0bool00`00ooooo`0cool2
00000ooo0000000mool0087oo`8000[oo`<000Goo`<0037oo`<000;oo`03003ooooo00Koo`03003o
oooo00<000;oo`03003ooooo00Koo`8000;oo`<000;oo`03003ooooo00Koo`03003ooooo00<000;o
o`8000Soo`03003ooooo00<000;oo`03003ooooo00Ooo`03003ooooo00<000;oo`03003ooooo00Oo
o`03003ooooo00<000;oo`05003oooooool00005ool00`00ooooo`040002ool00`00ooooo`05ool0
0`00ooooo`05ool30007ool2000cool00`00ooooo`1dool009?oo`80037oo`<000Koo`8000Koo`<0
00Koo`8000Ooo`<000Koo`8000Koo`<000Ooo`03003ooooo00Goo`<000Koo`8000Ooo`<000Koo`80
00Ooo`<000Koo`800003ool00?oo00Coo`<000Ooo`03003ooooo00Goo`03003ooooo00@000;oo`03
003ooooo00Ooo`03003ooooo037oo`8007Coo`00TOoo0P0000?oo`00ool0;Ooo0`000_oo00<00?oo
ool01_oo00<00?ooool00`000_oo00<00?ooool01_oo00<00?ooool010000_oo00<00?ooool01_oo
00<00?ooool00`000_oo00<00?ooool01_oo0P000_oo0`000_oo00<00?ooool01_oo00<00?ooool0
10000_oo00<00?ooool01_oo00<00?ooool010000_oo00<00?ooool01_oo0P0000?oo`0000000P00
0_oo00<00?ooool01Ooo00<00?ooool01Ooo0`001ooo0P001ooo0P00=?oo00<00?ooool0LOoo002?
ool20003ool00`00ooooo`0Yool30006ool20006ool30006ool20006ool30007ool20006ool30006
ool20007ool30006ool20006ool30007ool20006ool30007ool20006ool30007ool00`00ooooo`05
ool00`00ooooo`040002ool00`00ooooo`07ool00`00ooooo`040002ool00`00ooooo`0bool00`00
ooooo`1`ool008goo`8002koo`<000;oo`03003ooooo00Koo`03003ooooo00<000;oo`03003ooooo
00Koo`03003ooooo00<000;oo`8000Soo`03003ooooo00<000;oo`8000Ooo`03003ooooo00@000;o
o`03003ooooo00Koo`03003ooooo00<000;oo`03003ooooo00Ooo`03003ooooo00<000;oo`03003o
oooo00Ooo`03003ooooo00<00003ool0000000Soo`03003ooooo00Coo`<000Ooo`8000Ooo`<000Oo
o`03003ooooo037oo`80077oo`00R_oo0`00;Ooo0`001_oo0P001_oo0`001_oo0P001_oo0`001ooo
0P001?oo1@001ooo0P000ooo1@001ooo0P001_oo0`001_oo0P001ooo0`001_oo0P001ooo0`001?oo
00<00?oo00002?oo00<00?ooool00`000_oo00<00?ooool01ooo00<00?ooool010000_oo00<00?oo
ool01Ooo00<00?ooool0<?oo00<00?ooool00P00Kooo0028ool2000]ool30002ool00`00ooooo`06
ool00`00ooooo`030002ool20007ool00`00ooooo`030002ool20008ool40004ool20007ool40004
ool00`00ooooo`07ool00`00ooooo`030002ool00`00ooooo`06ool00`00ooooo`040002ool00`00
ooooo`06ool00`00ooooo`040002ool00`00ooooo`02ool01000ooooo`001ooo0`001_oo0P001ooo
0`001ooo00<00?ooool01Ooo00<00?ooool0=?oo00<00?ooool0K?oo0026ool2000/ool30006ool2
0006ool30007ool20003ool50007ool20003ool30002ool00`00ooooo`05ool20002ool30002ool0
0`00ooooo`04ool20007ool30006ool20006ool30007ool20006ool30007ool20002ool01@00oooo
oooo00000_oo10000_oo00<00?ooool01_oo00<00?ooool010000_oo00<00?ooool01Ooo00<00?oo
ool01Ooo0P00=_oo00<00?ooool0Jooo0024ool200000ooo003oo`0Xool30002ool00`00ooooo`06
ool00`00ooooo`030002ool20007ool40004ool20008ool30006ool20006ool30006ool20006ool0
0`00ooooo`040002ool00`00ooooo`06ool00`00ooooo`030002ool00`00ooooo`07ool00`00oooo
o`030002ool00`00ooooo`07ool01000ool00?oo1@001ooo0P001_oo0`001ooo00<00?ooool01Ooo
00<00?ooool010000_oo00<00?ooool0=?oo0P00Jooo0022ool20003ool00`00ooooo`0Tool30006
ool20006ool30007ool20002ool30002ool20006ool20003ool30002ool00`00ooooo`06ool00`00
ooooo`030002ool00`00ooooo`06ool01000oooooooo1@001ooo0P001_oo0`001_oo0P001ooo0`00
1_oo0P001ooo10001?oo00<00?ooool01ooo00<00?ooool00`000_oo00<00?ooool01_oo00<00?oo
ool01?oo0`001ooo0P00=_oo00<00?ooool0J?oo001oool30004ool00`00ooooo`0Rool30002ool2
0007ool00`00ooooo`030002ool20007ool30007ool00`00ooooo`05ool30006ool20006ool30006
ool20006ool40004ool20008ool00`00ooooo`030002ool00`00ooooo`06ool00`00ooooo`040002
ool00`00ooooo`06ool00`00ooooo`040002ool00`00ooooo`04ool20007ool30006ool20007ool0
0`00ooooo`030002ool00`00ooooo`07ool00`00ooooo`0dool00`00ooooo`1Wool007goo`8000Oo
o`03003ooooo01ooo`<000Ooo`8000Coo`@000Ooo`8000;oo`<000;oo`8000Ooo`8000;oo`<000;o
o`03003ooooo00Koo`03003ooooo00<000;oo`03003ooooo00Koo`03003ooooo00<000;oo`03003o
oooo00Goo`8000Coo`D000Koo`8000Koo`<000Ooo`8000Koo`<000Koo`8000Ooo`03003ooooo00@0
00;oo`03003ooooo00Koo`03003ooooo00;oo`D000Koo`8000Ooo`8003Koo`03003ooooo06Koo`00
Nooo0P00:Ooo0P000_oo0P002?oo10000ooo0P001ooo0`001ooo00<00?ooool01Ooo0`001_oo0P00
1_oo0`001_oo0P001_oo0`001_oo0P001_oo1@001?oo00<00?ooool01_oo00<00?ooool00`000_oo
00<00?ooool01ooo00<00?ooool00`000_oo00<00?ooool01?oo0P001ooo0`001ooo00<00?ooool0
1Ooo1@001?oo00<00?ooool01_oo00<00?ooool010000_oo00<00?ooool0<_oo1000I_oo001iool2
000Xool30006ool20003ool30002ool00`00ooooo`04ool20003ool20002ool20007ool20002ool3
0002ool00`00ooooo`06ool00`00ooooo`030002ool00`00ooooo`06ool00`00ooooo`030002ool0
0`00ooooo`06ool00`00ooooo`030002ool00`00ooooo`05ool20006ool30006ool20007ool30006
ool20004ool00`00ool00002ool40002ool00`00ooooo`06ool00`00ooooo`040002ool00`00oooo
o`05ool00`00ooooo`05ool30007ool00`00ooooo`0eool00`00ooooo`1Sool007Ooo`<002Koo`<0
00;oo`8000Ooo`<000Koo`8000Koo`<000Koo`03003ooooo00Goo`<000Koo`8000Koo`<000Koo`80
00Koo`<000Koo`8000Koo`<000Koo`8000Ooo`03003ooooo00<000;oo`03003ooooo00Koo`03003o
oooo00@000;oo`03003ooooo00Koo`04003oooooool50007ool20006ool30007ool00`00ooooo`05
ool00`00ooooo`040002ool00`00ooooo`06ool00`00ooooo`0eool00`00ooooo`1Rool007Goo`80
00;oo`03003ooooo01ooo`D000Ooo`8000;oo`<000;oo`03003ooooo00Koo`03003ooooo00<000;o
o`03003ooooo00Goo`8000;oo`<000;oo`03003ooooo00Koo`03003ooooo00<000;oo`03003ooooo
00Koo`03003ooooo00<000;oo`03003ooooo00Koo`03003ooooo00<000;oo`03003ooooo00Koo`03
003ooooo00;oo`D000Koo`8000Koo`<000Ooo`03003ooooo00Goo`D000?oo`03003ooooo00Ooo`03
003ooooo00<000;oo`03003ooooo00Koo`03003ooooo00Coo`<000Ooo`03003ooooo00Koo`03003o
oooo03Goo`8006;oo`00L_oo0`008_oo10001?oo0P001ooo0`001_oo0P001_oo0`001_oo0P001_oo
0`001_oo0P001_oo0`001_oo0P001_oo0`001_oo0P001_oo0`001_oo0P001_oo1@001?oo00<00?oo
ool01_oo00<00?ooool00`000_oo00<00?ooool01_oo00<00?ooool010000_oo00<00?oo00001?oo
0P001ooo0`001_oo00<00?ooool01_oo00<00?ooool00`000_oo00<00?ooool01_oo00<00?ooool0
1Ooo0P00>?oo00<00?ooool0Gooo001`ool2000Sool20002ool20006ool20002ool30002ool00`00
ooooo`06ool00`00ooooo`030002ool00`00ooooo`06ool00`00ooooo`030002ool00`00ooooo`06
ool00`00ooooo`030002ool00`00ooooo`06ool00`00ooooo`030002ool00`00ooooo`06ool00`00
ooooo`030002ool00`00ooooo`06ool00`00ooooo`030002ool00`00ooooo`05ool20006ool30006
ool20006ool30007ool20006ool00`00ooooo`040002ool00`00ooooo`05ool00`00ooooo`05ool3
0006ool20007ool00`00ooooo`040002ool00`00ooooo`0fool00`00ooooo`1Nool004goo`8000Co
o`03003ooooo00?oo`8001?oo`8002;oo`<000Koo`03003ooooo00Coo`<000Koo`8000Koo`<000Ko
o`8000Koo`<000Koo`8000Koo`<000Koo`8000Koo`<000Koo`8000Koo`<000Koo`8000Koo`<000Ko
o`8000Ooo`03003ooooo00<000;oo`03003ooooo00Koo`03003ooooo00<000;oo`03003ooooo00Ko
o`03003ooooo00Coo`<000Ooo`8000Koo`03003ooooo00@000;oo`03003ooooo00Koo`03003ooooo
00;oo`D000Ooo`03003ooooo03Koo`03003ooooo05goo`00C?oo00@00?ooool000Soo`04003ooooo
000@ool2000Qool30002ool00`00ooooo`05ool20002ool20002ool20007ool00`00ooooo`030002
ool20007ool00`00ooooo`030002ool20007ool00`00ooooo`030002ool20007ool00`00ooooo`03
0002ool00`00ooooo`06ool00`00ooooo`030002ool00`00ooooo`06ool00`00ooooo`030002ool0
0`00ooooo`06ool00`00ooooo`02ool50006ool20006ool30006ool20006ool20002ool30002ool0
0`00ooooo`07ool01000oooooooo1@001ooo00<00?ooool01Ooo1@001?oo00<00?ooool01Ooo00<0
0?ooool0=ooo0P00GOoo001<ool01000ooooo`002?oo00@00?ooool000koo`<001ooo`<000Koo`80
00Koo`<000Koo`03003ooooo00Coo`<000Ooo`8000?oo`D000Ooo`8000?oo`D000Ooo`8000?oo`D0
00Koo`8000Koo`<000Koo`8000Koo`<000Koo`8000Koo`D000Coo`03003ooooo00Koo`03003ooooo
00<000;oo`03003ooooo00Koo`03003ooooo00;oo`D000Koo`8000Ooo`@000Coo`03003ooooo00Ko
o`03003ooooo00@000;oo`03003ooooo00Goo`8000Koo`03003ooooo03Goo`04003ooooo001Lool0
04coo`04003ooooo0009ool2000<ool30002ool00`00ooooo`0Kool20002ool20007ool00`00oooo
o`030002ool20006ool20002ool20002ool20007ool40004ool20007ool40004ool20007ool40004
ool20007ool00`00ooooo`030002ool00`00ooooo`06ool00`00ooooo`030002ool00`00ooooo`06
ool00`00ooooo`030002ool00`00ooooo`05ool00`00ooooo`05ool30006ool20006ool500001Ooo
003ooooo00002?oo00<00?ooool010000_oo00<00?ooool01?oo0P001_oo0`001ooo00<00?ooool0
1_oo00@00?ooooooo`@003[oo`03003ooooo00goo`8000Coo`03003ooooo00?oo`8003koo`00C?oo
00@00?ooool000Soo`04003ooooo0009ool2000Pool30006ool00`00ooooo`04ool30007ool20003
ool50006ool20003ool20002ool20006ool20002ool30002ool00`00ooooo`05ool20002ool30002
ool00`00ooooo`05ool20003ool50006ool20006ool30006ool20006ool30006ool20006ool00`00
ooooo`040002ool00`00ooooo`06ool00`00ooooo`030002ool01@00oooooooo00000ooo0P001_oo
0`001ooo00<00?ooool01Ooo00<00?ooool00`000_oo00<00?ooool01_oo00<00?ooool01Ooo1000
1?oo00<00?ooool0>?oo00<00?ooool02ooo00@00?ooool000Soo`04003ooooo000mool004coo`04
003ooooo0008ool01000ooooo`001ooo0P007ooo0`000_oo0P001_oo0P000_oo0P000_oo0P001ooo
10001?oo0P001ooo0`001_oo00<00?ooool01?oo0`001_oo0P001_oo0`001_oo0P001_oo10001?oo
0P001ooo00<00?ooool00`000_oo00<00?ooool01_oo00<00?ooool00`000_oo00<00?ooool01_oo
00@00?ooooooo`D000Ooo`8000Koo`<000Koo`800003ool00?oo00Coo`03003ooooo00<000;oo`03
003ooooo00Goo`03003ooooo00Goo`<000Koo`03003ooooo00Koo`03003ooooo00@000;oo`03003o
oooo00Coo`8003Woo`8000_oo`04003ooooo0008ool01000ooooo`00?Ooo001=ool2000:ool20006
ool2000Nool30007ool20003ool50006ool20002ool30002ool00`00ooooo`05ool20002ool30002
ool00`00ooooo`05ool20002ool20002ool00`00ooooo`06ool00`00ooooo`030002ool00`00oooo
o`06ool00`00ooooo`030002ool00`00ooooo`05ool20003ool50006ool20006ool30006ool20006
ool40004ool00`00ooooo`07ool00`00ooooo`030002ool00`00ooooo`06ool20003ool50006ool2
0006ool00`00ooooo`040002ool00`00ooooo`05ool00`00ooooo`05ool30007ool00`00ooooo`05
ool00`00ooooo`0hool00`00ooooo`08ool01000ooooo`002?oo0`00?_oo001Oool2000Nool20002
ool20007ool40004ool20006ool30006ool20006ool30006ool20006ool30005ool20006ool30006
ool20006ool30006ool20006ool40004ool20007ool00`00ooooo`030002ool00`00ooooo`06ool0
0`00ooooo`030002ool00`00ooooo`04ool20007ool30006ool20006ool50004ool00`00ooooo`06
ool01000oooooooo1@001ooo00<00?ooool01Ooo00<00?ooool010000_oo00<00?ooool01Ooo00<0
0?ooool01Ooo0P00>_oo00<00?ooool01ooo00@00?ooool000Soo`03003ooooo03koo`00G?oo1000
6ooo10001_oo0P000ooo0P000_oo00<00?ooool01Ooo0P000_oo0P000_oo0P001ooo00<00?ooool0
0`000_oo0P001ooo00<00?ooool00`000_oo0P001_oo00<00?ooool00`000_oo00<00?ooool01_oo
00<00?ooool00`000_oo00<00?ooool01_oo00<00?ooool00`000_oo00<00?ooool01Ooo0P000ooo
1@001_oo0P001_oo0`001_oo0P001_oo00<00?ooool010000_oo00<00?ooool01_oo00<00?ooool0
0`0000?oo`0000001ooo00<00?ooool01Ooo10001?oo00<00?ooool01_oo00<00?ooool00_oo1@00
1ooo00<00?ooool01Ooo00<00?ooool010000_oo00<00?ooool0>?oo0P001ooo00@00?ooool000So
o`03003ooooo03koo`00F_oo0P000ooo00<00?ooool05Ooo10000ooo0P001ooo0`001Ooo0P001_oo
0`001_oo00<00?ooool01?oo0`001ooo0P000ooo1@001ooo0P000ooo10001_oo0P001_oo0`001_oo
0P001_oo0`001_oo0P001_oo10001?oo0P001ooo00<00?ooool00`000_oo00<00?ooool01_oo00@0
0?ooooooo`D000Ooo`03003ooooo00Goo`<000Coo`03003oo`0000Ooo`03003ooooo00@000;oo`03
003ooooo00Coo`8000Koo`D000Coo`03003ooooo00Koo`03003ooooo00;oo`D000Ooo`03003ooooo
03Ooo`<000Ooo`8000[oo`<003goo`00F?oo0P006_oo0`000_oo00<00?ooool01?oo0P000_oo0`00
0_oo0P001_oo00<00?ooool00`000_oo0P001_oo0P000_oo0P000_oo0P001ooo10001?oo0P001ooo
10000ooo0P001ooo00<00?ooool00`000_oo0P001ooo00<00?ooool00`000_oo00<00?ooool01_oo
00<00?ooool00`000_oo00<00?ooool01Ooo0P000ooo1@001_oo0P001_oo10001?oo00<00?ooool0
1_oo00<00?ooool010000_oo00<00?ooool00_oo00@00?ooool000Koo`<000Ooo`03003ooooo00Go
o`03003ooooo00<000;oo`03003ooooo00Goo`8000Koo`D000Coo`03003ooooo00Goo`03003ooooo
03Goo`8000?oo`03003ooooo053oo`00E_oo0P006Ooo0`001_oo0P001Ooo0`001ooo0P000ooo1000
1ooo0P000ooo1@001_oo0P000ooo0P000_oo00<00?ooool01Ooo0P000_oo0`000_oo00<00?ooool0
1?oo0P001?oo10001ooo0P000ooo1@001_oo0P001_oo0`001_oo0P001_oo10001?oo00<00?ooool0
1_oo00<00?ooool00`000_oo00<00?ooool01?oo0P001_oo0`001ooo00D00?ooooooo`0000?oo`03
003ooooo00<000;oo`03003ooooo00Goo`03003ooooo00Goo`<000Koo`03003ooooo00Koo`03003o
oooo00<000;oo`03003ooooo00Goo`8000Koo`03003ooooo03[oo`03003ooooo04ooo`00E?oo0P00
6Ooo0P000_oo0P001ooo00<00?ooool00P000_oo0P001ooo10000ooo0P001ooo10001?oo0P001ooo
0`001Ooo0P001_oo0`001_oo0P001_oo10000ooo0P001ooo10001?oo0P001ooo00<00?ooool00`00
0_oo00<00?ooool01_oo00<00?ooool00`000_oo00<00?ooool01?oo0P001_oo0`001_oo0P001_oo
00<00?ooool00`000_oo00<00?ooool01_oo00D00?ooool00?oo00D000Koo`8000Koo`03003ooooo
00@000;oo`03003ooooo00Goo`03003ooooo00Goo`<000Koo`03003ooooo00Koo`04003oooooool4
000lool2001?ool005;oo`8001Soo`<000Koo`8000Coo`@000Koo`8000?oo`8000;oo`03003ooooo
00Coo`8000?oo`8000;oo`03003ooooo00Goo`8000;oo`<000;oo`03003ooooo00Goo`03003ooooo
00<000;oo`03003ooooo00Koo`03003ooooo00<000;oo`03003ooooo00Coo`8000;oo`<000;oo`03
003ooooo00Goo`8000?oo`D000Koo`8000Koo`<000Koo`8000Koo`03003ooooo00<000;oo`03003o
oooo00Koo`04003oooooool50006ool20006ool50004ool00`00ooooo`06ool01000oooooooo1@00
1ooo0P001_oo00<00?ooool010000_oo00<00?ooool01Ooo00<00?ooool01Ooo10001?oo00<00?oo
ool0>ooo00<00?ooool0C?oo001?ool300000ooo003oo`0Eool20002ool20007ool40003ool20007
ool30005ool20006ool30005ool20006ool30006ool20005ool30006ool20006ool30006ool20005
ool30006ool20006ool40004ool20007ool00`00ooooo`030002ool00`00ooooo`06ool01000oooo
oooo1@001_oo0P001_oo10001?oo0P001ooo00<00?ooool00`000_oo0P001_oo0P001_oo10001?oo
00<00?ooool01ooo00@00?ooooooo`D000Ooo`03003ooooo00Goo`03003ooooo00@000;oo`03003o
oooo00Coo`8003coo`03003ooooo04_oo`00COoo0P000ooo00<00?ooool04?oo1@001_oo0P000_oo
0`000_oo00<00?ooool01?oo0P000_oo0`000_oo0P001_oo00<00?ooool00`000_oo0P001_oo00<0
0?ooool00`000_oo0P001ooo00<00?ooool00P000_oo0P001ooo00<00?ooool00`000_oo00<00?oo
ool01_oo00<00?ooool00P000_oo00<00?ooool01_oo00<00?ooool00`000_oo00<00?ooool01Ooo
0P000ooo1@001_oo0P001_oo10001?oo0P001ooo00<00?ooool00`000_oo00<00?ooool01Ooo0P00
0ooo1@001_oo0P001ooo00<00?ooool00`000_oo00<00?ooool01?oo0P001ooo10001?oo00<00?oo
ool01_oo00<00?ooool00_oo1@001ooo00<00?ooool01Ooo00<00?ooool0>_oo0P00Booo001;ool2
0005ool00`00ooooo`0<ool40004ool20006ool30006ool20005ool30007ool20003ool40007ool2
0003ool40007ool20003ool50006ool20003ool50006ool20006ool30005ool20006ool30006ool2
0006ool40004ool20007ool00`00ooooo`030002ool00`00ooooo`05ool20003ool50006ool20006
ool40004ool00`00ooooo`04ool00`00ool00004ool50006ool20006ool00`00ooooo`040002ool0
0`00ooooo`04ool20006ool50004ool00`00ooooo`05ool00`00ooooo`05ool2000lool2001:ool0
04Woo`8001Coo`8000;oo`8000Koo`8000;oo`8000;oo`8000Ooo`03003ooooo008000;oo`8000Oo
o`@000?oo`8000Ooo`@000?oo`8000Ooo`@000Coo`8000Koo`@000Coo`8000Ooo`03003ooooo00<0
00;oo`8000Koo`03003ooooo00<000;oo`03003ooooo00Koo`03003ooooo00<000;oo`03003ooooo
00Goo`8000?oo`D000Koo`8000Koo`@000Coo`03003ooooo00Koo`03003ooooo00<000;oo`03003o
oooo00Coo`8000Coo`03003oo`0000@000Coo`03003ooooo00Koo`04003oooooool50007ool00`00
ooooo`05ool00`00ooooo`030002ool00`00ooooo`05ool20006ool00`00ooooo`040002ool00`00
ooooo`0hool01000ooooo`00BOoo0017ool2000Cool30006ool00`00ooooo`04ool30006ool20004
ool40006ool20003ool20002ool00`00ooooo`04ool20003ool20002ool00`00ooooo`04ool20003
ool20002ool00`00ooooo`05ool20002ool20002ool20006ool20003ool50007ool20003ool40006
ool20006ool30006ool20006ool40004ool00`00ooooo`06ool00`00ooooo`030002ool00`00oooo
o`04ool20006ool30006ool00`00ooooo`05ool00`00ooooo`030002ool00`00ooooo`05ool00`00
ooooo`05ool40004ool00`00ooooo`05ool00`00ooooo`05ool30006ool00`00ooooo`06ool01000
oooooooo1@001ooo00<00?ooool0>ooo00<00?ooool0A_oo0014ool3000Cool20002ool20006ool2
0002ool20002ool20007ool40003ool20007ool30005ool20006ool30005ool20006ool30005ool2
0006ool30006ool00`00ooooo`04ool40004ool20007ool40003ool20007ool00`00ooooo`030002
ool00`00ooooo`06ool00`00ooooo`030002ool00`00ooooo`04ool20006ool30006ool00`00oooo
o`05ool00`00ooooo`030002ool00`00ooooo`05ool00`00ooooo`04ool300000ooo003oo`03ool2
0006ool00`00ooooo`040002ool00`00ooooo`04ool20006ool00`00ooooo`040002ool00`00oooo
o`05ool00`00ooooo`05ool40004ool00`00ooooo`06ool00`00ooooo`0kool20016ool004;oo`80
00;oo`03003ooooo00koo`<000Koo`8000Coo`@000Koo`8000;oo`<000;oo`03003ooooo00Coo`80
00;oo`<000;oo`8000Koo`03003ooooo00<000;oo`8000Koo`03003ooooo00<000;oo`8000Koo`03
003ooooo00<000;oo`8000Koo`8000;oo`8000;oo`03003ooooo00Goo`8000;oo`<000;oo`03003o
oooo00Coo`8000?oo`D000Koo`8000Koo`<000Koo`8000Koo`03003ooooo00<000;oo`03003ooooo
00Goo`03003ooooo00;oo`D000Koo`03003ooooo00Goo`03003ooooo00<000;oo`03003oo`0000Ko
o`04003oooooool50007ool00`00ooooo`05ool01000oooooooo1@001ooo00<00?ooool01Ooo00<0
0?ooool010000_oo00<00?ooool01?oo00<00?ooool01_oo00<00?ooool0??oo00<00?ooool0@ooo
0010ool20004ool00`00ooooo`0<ool20002ool20007ool40003ool20006ool30006ool20005ool3
0007ool20003ool40007ool20003ool40007ool20003ool40007ool20003ool50005ool20006ool3
0006ool20005ool40004ool20007ool00`00ooooo`030002ool00`00ooooo`06ool01000oooooooo
1@001_oo00<00?ooool01?oo1@001?oo00<00?ooool01Ooo00<00?ooool00_oo1@001_oo0P001_oo
10001?oo00<00?ooool01Ooo00<00?ooool01Ooo10001?oo00<00?ooool01_oo00<00?ooool00_oo
1@001ooo00<00?ooool01?oo00<00?ooool01Ooo0P00?_oo00<00?ooool0@_oo000Qool4000Iool2
000Aool40006ool20003ool20002ool20005ool20002ool20002ool20007ool00`00ooooo`020002
ool20007ool40003ool20007ool40003ool20007ool40003ool20007ool40004ool20006ool00`00
ooooo`030002ool20007ool00`00ooooo`020002ool00`00ooooo`05ool20003ool50006ool20006
ool40004ool00`00ooooo`05ool00`00ooooo`030002ool00`00ooooo`05ool00`00ooooo`04ool5
0004ool00`00ooooo`05ool20002ool30002ool00`00ooooo`04ool20006ool00`00ooooo`040002
ool00`00ooooo`04ool20006ool50004ool00`00ooooo`05ool00`00ooooo`05ool00`00ooooo`04
0002ool00`00ooooo`0lool20012ool002?oo`03003ooooo01Koo`8000ooo`@000?oo`8000Ooo`<0
00Koo`8000?oo`@000Koo`8000Coo`@000Koo`8000;oo`<000;oo`03003ooooo00Coo`8000;oo`<0
00;oo`03003ooooo00Coo`8000;oo`<000;oo`03003ooooo00Coo`8000;oo`<000;oo`03003ooooo
00Goo`8000?oo`@000Ooo`8000?oo`D000Goo`8000Koo`@000Coo`8000Ooo`03003ooooo00<000;o
o`03003ooooo00Coo`8000?oo`D000Koo`8000Koo`03003ooooo00<000;oo`03003ooooo00Goo`03
003ooooo00Coo`@000Koo`03003ooooo00Goo`04003oooooool50007ool00`00ooooo`05ool00`00
ooooo`030002ool00`00ooooo`05ool00`00ooooo`05ool00`00ooooo`02ool50007ool00`00oooo
o`0lool20011ool002?oo`03003ooooo01?oo`<000ooo`8000;oo`8000Goo`8000;oo`<000;oo`80
00Koo`@000?oo`8000Ooo`@000?oo`8000Koo`<000Koo`8000Goo`<000Koo`8000Goo`<000Koo`80
00Goo`<000Koo`8000Koo`@000?oo`8000Ooo`@000Coo`03003ooooo00Goo`03003ooooo00<000;o
o`03003ooooo00Goo`8000?oo`D000Koo`03003ooooo00Coo`@000Coo`03003ooooo00Koo`04003o
ooooool50006ool20006ool00`00ooooo`040002ool00`00ooooo`04ool00`00ooooo`05ool40004
ool00`00ooooo`06ool00`00ooooo`02ool50006ool00`00ooooo`04ool00`00ooooo`05ool50004
ool00`00ooooo`05ool00`00ooooo`0kool01000ooooo`00@?oo000Sool00`00ooooo`0Aool20000
0ooo003oo`0<ool30006ool20003ool40007ool20002ool20002ool20005ool20002ool30002ool2
0005ool20002ool20002ool20007ool00`00ooooo`020002ool20007ool00`00ooooo`020002ool2
0007ool00`00ooooo`020002ool20007ool00`00ooooo`030002ool00`00ooooo`04ool20002ool3
0002ool00`00ooooo`04ool20003ool50006ool20006ool40004ool00`00ooooo`05ool00`00oooo
o`030002ool00`00ooooo`04ool20006ool40004ool00`00ooooo`06ool01000oooooooo1@000ooo
00D00?ooooooo`0000Koo`03003ooooo00@000;oo`03003ooooo00Coo`8000Koo`D000Coo`03003o
oooo00Goo`03003ooooo00Coo`03003ooooo00@000;oo`03003ooooo00Goo`03003ooooo00Goo`03
003ooooo03koo`03003ooooo03goo`008ooo00<00?ooool03ooo0P000ooo00<00?ooool02Ooo0P00
0_oo0P001_oo10000ooo0P001ooo0`001_oo0P000ooo10001ooo0P000ooo10001_oo0P001?oo1000
1_oo0P000ooo1@001_oo0P000ooo1@001_oo0P000ooo1@001_oo0P001Ooo0`001_oo0P001Ooo1000
1?oo0P001ooo00<00?ooool00`000_oo00<00?ooool01?oo0P000ooo1@001_oo0P001_oo00<00?oo
ool00`000_oo00<00?ooool01?oo0P001_oo10001?oo00D00?ooooooo`0000Coo`04003oooooool5
0007ool00`00ooooo`05ool00`00ooooo`030002ool00`00ooooo`05ool00`00ooooo`05ool01000
oooooooo1@001ooo00<00?ooool01Ooo00<00?ooool00_oo1000@?oo0P00?Ooo000Qool3000?ool2
000=ool40006ool20002ool20002ool20005ool20003ool20002ool20006ool40003ool20007ool4
0003ool20007ool40003ool20006ool40004ool20006ool40004ool20006ool40004ool20007ool0
0`00ooooo`020002ool20007ool00`00ooooo`020002ool00`00ooooo`05ool20003ool50006ool2
0005ool40004ool00`00ooooo`06ool01000oooooooo1@001_oo0P001_oo00<00?ooool00`000_oo
00<00?ooool01?oo0P0000?oo`00ool00ooo10001?oo00<00?ooool01_oo00<00?ooool00_oo1@00
1_oo00<00?ooool01Ooo00<00?ooool00_oo1P001?oo00<00?ooool01_oo00<00?ooool01?oo1@00
1?oo00<00?ooool0?ooo00<00?ooool0>_oo000Sool00`00ooooo`0;ool2000;ool40003ool20006
ool30006ool20004ool40006ool20002ool20002ool20005ool20003ool20002ool20005ool20002
ool30002ool20005ool20002ool20002ool20006ool20002ool20002ool00`00ooooo`05ool20002
ool20002ool00`00ooooo`05ool20003ool50006ool20003ool50005ool20006ool40004ool20007
ool00`00ooooo`020002ool00`00ooooo`04ool20006ool40004ool20007ool01000oooooooo1@00
1_oo0P001_oo0P0000Coo`00000000;oo`03003ooooo00Coo`8000Koo`D000Coo`03003ooooo00Go
o`03003ooooo00Coo`D000Coo`03003ooooo00Coo`8000Ooo`03003ooooo00<000;oo`03003ooooo
00Goo`03003ooooo03ooo`03003ooooo03Woo`00;ooo0P002ooo0P000_oo0P001Ooo0P000_oo0P00
0_oo0P001ooo10000ooo0P001_oo0`001_oo00<00?ooool01?oo0`001_oo0P000ooo10001ooo0P00
0ooo10001_oo0P001?oo10001Ooo0P001_oo0`001Ooo0P001_oo10001?oo00<00?ooool01Ooo1000
1?oo0P001_oo00<00?ooool00`000_oo00<00?ooool01Ooo0P000ooo1@001Ooo0P001_oo00<00?oo
ool00`000_oo00<00?ooool01Ooo0P000ooo1P001?oo0P001ooo00@00?ooooooo`D000Koo`8000Ko
o`03003ooooo00<000;oo`03003ooooo00Goo`03003ooooo00Goo`03003ooooo00<000;oo`03003o
oooo00Goo`03003ooooo00Goo`03003ooooo00;oo`D000Koo`03003ooooo00Coo`03003ooooo043o
o`8003Woo`00;?oo0`002_oo0`001_oo0P000ooo10001_oo0P000ooo0P000_oo0P001Ooo0P000_oo
0P000_oo0P001_oo0P000_oo0P000_oo0P001_oo10000ooo0P001ooo10000ooo0P001ooo10000ooo
0P001_oo00<00?ooool00`000_oo0P001_oo00<00?ooool00`000_oo00<00?ooool01?oo0P000_oo
0`000_oo00<00?ooool01Ooo0P000ooo10001_oo0P001_oo10001?oo00<00?ooool01Ooo00@00?oo
ooooo`D000Koo`8000Koo`@000Coo`03003ooooo00Goo`8000?oo`H000Coo`03003ooooo00Koo`04
003oooooool50006ool00`00ooooo`05ool00`00ooooo`02ool50006ool00`00ooooo`05ool00`00
ooooo`02ool70004ool00`00ooooo`05ool00`00ooooo`04ool00`00ooooo`10ool2000hool001Oo
o`@000ooo`8000;oo`03003ooooo00Koo`8000;oo`8000Koo`@000?oo`8000Ooo`<000Koo`8000?o
o`@000Koo`8000?oo`D000Koo`8000;oo`8000;oo`8000Goo`8000?oo`8000;oo`03003ooooo00Co
o`8000;oo`<000;oo`03003ooooo00Coo`8000?oo`@000Ooo`8000?oo`@000Koo`8000Goo`<000Ko
o`8000Koo`@000?oo`8000Ooo`03003ooooo00<000;oo`03003ooooo00Coo`03003ooooo00Coo`@0
00Coo`8000Ooo`03003ooooo00<000;oo`03003ooooo00Coo`8000Koo`@000Coo`03003ooooo00?o
o`<000Koo`@000Coo`03003ooooo00Goo`03003ooooo00Coo`D000Coo`03003ooooo00Goo`03003o
oooo00Coo`D000Coo`03003ooooo00Goo`03003ooooo00Goo`04003oooooool40010ool01000oooo
o`003ooo0P001?oo00<00?ooool00ooo0P006_oo000Iool00`00ooooo`0<ool20004ool00`00oooo
o`02ool40006ool20002ool20002ool20005ool20003ool20002ool20006ool40003ool20006ool4
0004ool20006ool30006ool20003ool50005ool20005ool30006ool20005ool40003ool20007ool4
0003ool20007ool00`00ooooo`020002ool20007ool00`00ooooo`030002ool00`00ooooo`04ool2
0003ool50006ool00`00ooooo`04ool00`00ooooo`030002ool00`00ooooo`05ool20003ool50006
ool00`00ooooo`05ool00`00ooooo`030002ool00`00ooooo`04ool00`00ooooo`02ool01000oooo
o`000_oo0`000_oo00<00?ooool01?oo0P001_oo00<00?ooool00`000_oo00<00?ooool01Ooo00<0
0?ooool01Ooo00<00?ooool00`000_oo00<00?ooool01Ooo00<00?ooool01Ooo00<00?ooool00_oo
1P001?oo00<00?ooool0@Ooo00<00?ooool02ooo00@00?ooool000Soo`04003ooooo000Iool001Wo
o`03003ooooo00[oo`8000Ooo`@000Coo`<000Coo`<000Koo`8000Coo`@000Koo`8000;oo`8000;o
o`8000Goo`8000;oo`8000;oo`8000Koo`8000;oo`8000;oo`8000Koo`@000Coo`8000Koo`03003o
oooo008000;oo`8000Ooo`03003ooooo008000;oo`8000Goo`8000;oo`<000;oo`03003ooooo00Co
o`8000?oo`D000Koo`8000?oo`D000Koo`03003ooooo00Coo`@000Coo`03003ooooo00Goo`04003o
ooooool50006ool20006ool40004ool00`00ooooo`05ool00`00ooooo`02ool50006ool00`00oooo
o`04ool01000oooooooo1P001_oo00<00?ooool01Ooo00@00?ooooooo`D000Koo`03003ooooo00Go
o`03003ooooo00;oo`D000Koo`03003ooooo00Coo`03003ooooo00Goo`D000Coo`03003ooooo00Co
o`03003ooooo047oo`8000_oo`04003ooooo0008ool01000ooooo`006Ooo000Aool40004ool00`00
ooooo`08ool20007ool20002ool20007ool40003ool20006ool40004ool20004ool40006ool20003
ool40006ool20004ool40006ool20002ool20002ool00`00ooooo`05ool20003ool40006ool20003
ool50006ool20003ool40006ool20005ool40004ool20006ool40004ool20006ool00`00ooooo`03
0002ool00`00ooooo`04ool20005ool40004ool20007ool00`00ooooo`030002ool00`00ooooo`04
ool00`00ooooo`04ool50004ool00`00ooooo`05ool01000oooooooo1`001?oo00<00?ooool01Ooo
00<00?ooool00_oo1P001?oo00<00?ooool01Ooo00<00?ooool01?oo1@001?oo00<00?ooool01Ooo
00<00?ooool01?oo00<00?ooool010000_oo00<00?ooool01Ooo00<00?ooool01?oo00<00?ooool0
@_oo00<00?ooool02?oo00@00?ooool000Woo`8001[oo`006Ooo00<00?ooool01_oo0P001_oo0`00
1_oo0P000ooo0P000_oo0P001Ooo0P000_oo0P000_oo0P001_oo10000ooo0P001_oo10000ooo0P00
1ooo10000ooo0P001_oo0`001Ooo0P001_oo10000ooo0P001_oo10001?oo0P001_oo10000ooo0P00
1ooo00<00?ooool00P000_oo0P001_oo0P000_oo0P000_oo00<00?ooool01Ooo0P000ooo10001_oo
0P001_oo00<00?ooool00P000_oo00<00?ooool01Ooo0P000ooo1@001_oo0P001Ooo00<00?ooool0
0`000_oo00<00?ooool01Ooo00<00?ooool01?oo10001?oo00<00?oo00001Ooo00<00?ooool01?oo
1@001?oo00<00?ooool01?oo00<00?ooool01Ooo00<00?ooool00`000_oo00<00?ooool01Ooo00<0
0?ooool01Ooo00@00?ooooooo`D000Ooo`03003ooooo00Coo`03003ooooo00Goo`03003ooooo04;o
o`03003ooooo00Ooo`04003ooooo0008ool01000ooooo`006Ooo000Gool30008ool300000ooo0000
00020003ool20006ool30006ool20003ool40006ool20002ool20002ool20005ool20002ool20002
ool20005ool20003ool20002ool20005ool20002ool20002ool20006ool00`00ooooo`030002ool2
0005ool20002ool20002ool20006ool20002ool20002ool20005ool20003ool50006ool20003ool5
0005ool20006ool40003ool20007ool01000oooooooo1@001Ooo0P001_oo10001?oo00<00?ooool0
1_oo00@00?ooooooo`@000Koo`8000Koo`03003ooooo00<000;oo`03003ooooo00Coo`8000Koo`03
003ooooo00<000;oo`03003ooooo00Goo`03003ooooo00Coo`03003ooooo00;oo`D000Koo`03003o
oooo00Goo`03003ooooo00;oo`H000Coo`03003ooooo00Goo`03003ooooo00Goo`03003ooooo00;o
o`@004Coo`8000Ooo`04003ooooo0008ool01000ooooo`006Ooo000Iool00`00ooooo`06ool01000
ool000000_oo0P001Ooo0P000_oo0P000_oo0P001_oo10000ooo0P001_oo0`001_oo0P000ooo1000
1_oo0P001?oo10001_oo0P000ooo10001_oo0P000ooo10001ooo0P000ooo10001_oo0P000ooo1@00
1_oo0P000ooo1@001?oo0P001_oo10001?oo0P001_oo00<00?ooool00`000_oo00<00?ooool01?oo
0P000ooo1P001?oo00<00?ooool01Ooo00<00?ooool00`000_oo00<00?ooool01?oo0P001_oo1000
0ooo00<00?ooool01_oo00@00?ooooooo`D000Koo`8000Goo`8000?oo`D000Koo`03003ooooo00Go
o`04003oooooool70004ool00`00ooooo`05ool00`00ooooo`04ool50004ool00`00ooooo`04ool2
0006ool00`00ooooo`02ool70004ool00`00ooooo`12ool20007ool2000:ool2000Jool002;oo`80
00Koo`8000?oo`@000Koo`8000;oo`8000;oo`8000Goo`8000;oo`8000;oo`8000Koo`@000?oo`80
00Ooo`@000?oo`8000Koo`@000?oo`8000Koo`@000?oo`8000Ooo`@000?oo`8000Koo`@000Coo`80
00Koo`@000?oo`8000Koo`8000;oo`8000;oo`03003ooooo00Goo`8000?oo`@000Koo`8000Goo`@0
00Coo`8000Goo`8000?oo`D000Koo`8000Koo`03003ooooo00<000;oo`03003ooooo00?oo`8000Ko
o`@000Coo`03003ooooo00Koo`04003oooooool60004ool00`00ooooo`05ool00`00ooooo`04ool4
0004ool00`00ooooo`05ool00`00ooooo`05ool00`00ooooo`030002ool00`00ooooo`05ool00`00
ooooo`05ool01000oooooooo1`001?oo00<00?ooool01Ooo00<00?ooool0?ooo0P000_oo00<00?oo
ool0;?oo000Rool40005ool40004ool20004ool40006ool20003ool40006ool20002ool20002ool2
0005ool20003ool20002ool20005ool20002ool20002ool20005ool20002ool20002ool20005ool2
0003ool20002ool20005ool20002ool20002ool20006ool20002ool20002ool00`00ooooo`04ool2
0003ool50005ool20006ool40003ool20007ool00`00ooooo`020002ool00`00ooooo`05ool20003
ool50004ool20007ool01000oooooooo1@001_oo00<00?ooool01?oo00<00?ooool00`000_oo00<0
0?ooool01?oo0P001_oo100000Goo`00ooooo`0000Koo`8000Koo`03003ooooo00<000;oo`03003o
oooo00Coo`8000Koo`03003ooooo00;oo`D000Koo`03003ooooo00Coo`03003ooooo00Goo`@000Co
o`03003ooooo00Goo`03003ooooo00Coo`03003ooooo04Coo`03003ooooo02_oo`008Ooo00@00?oo
ooooo`8000;oo`8000;oo`8000Koo`@000?oo`8000Koo`@000Coo`<000?oo`@000Koo`8000Coo`@0
00Koo`8000?oo`@000Koo`8000?oo`@000Koo`8000?oo`D000Koo`8000?oo`@000Koo`8000?oo`D0
00Goo`8000Goo`@000Coo`8000Koo`03003ooooo00<000;oo`03003ooooo00Coo`8000?oo`D000Go
o`8000Koo`@000?oo`03003ooooo00Goo`8000?oo`H000Coo`03003ooooo00Goo`04003oooooool5
0006ool20006ool00`00ooooo`030002ool01000ooooo`000ooo00<00?ooool01Ooo00@00?oooooo
o`D000Koo`03003ooooo00Goo`04003oooooool70004ool00`00ooooo`05ool00`00ooooo`04ool0
0`00ooooo`040002ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`05ool00`00ooooo`14
ool2000[ool0027oo`03003ooooo00?oo`<000Goo`8000;oo`8000;oo`8000Goo`8000;oo`8000;o
o`8000Ooo`<000?oo`8000Ooo`@000?oo`8000Koo`@000?oo`8000Koo`@000?oo`8000Koo`@000Co
o`8000Koo`@000?oo`8000Koo`@000Coo`8000Koo`03003ooooo008000;oo`8000Koo`8000?oo`@0
00Koo`03003ooooo00Coo`@000Coo`03003ooooo00Goo`03003ooooo00<000;oo`03003ooooo00?o
o`8000Koo`@000Coo`03003ooooo00Coo`8000?oo`H000Coo`8000Ooo`04003oooooool50006ool0
0`00ool00004ool00`00ooooo`02ool60004ool00`00ooooo`05ool00`00ooooo`04ool40004ool0
0`00ooooo`05ool00`00ooooo`05ool01000oooooooo1@001ooo00<00?ooool01?oo00<00?ooool0
1?oo00<00?ooool00_oo1000Aooo00<00?ooool0:?oo000Qool00`00ooooo`06ool20004ool30006
ool20004ool40005ool20003ool20002ool20004ool20003ool20002ool20005ool20002ool20002
ool20005ool20002ool20002ool20005ool20002ool20002ool20006ool20002ool20002ool20005
ool20002ool20002ool00`00ooooo`05ool20003ool40006ool20003ool60003ool20006ool00`00
ooooo`030002ool00`00ooooo`04ool20003ool50006ool00`00ooooo`04ool00`00ooooo`030002
ool00`00ooooo`04ool00`00ooooo`04ool40004ool00`00ooooo`05ool20003ool60004ool00`00
ooooo`04ool00`00ool00004ool50004ool00`00ooooo`04ool00`00ooooo`05ool00`00ooooo`03
0002ool00`00ooooo`04ool20006ool00`00ooooo`02ool60004ool00`00ooooo`05ool00`00oooo
o`05ool01000oooooooo1`001?oo00<00?ooool0AOoo00<00?ooool09ooo000Qool00`00ooooo`08
ool40003ool20006ool40004ool20004ool40006ool20003ool40006ool20003ool40006ool20003
ool40006ool20003ool40006ool20003ool50006ool20003ool40005ool20006ool40003ool20006
ool40004ool00`00ooooo`04ool20003ool40006ool20005ool40004ool20006ool01000oooooooo
1@001_oo0P001Ooo00<00?ooool00`000_oo00<00?ooool01?oo0P001_oo10001?oo00<00?ooool0
1?oo00<00?ooool01?oo0P0000Coo`00000000;oo`03003ooooo00Goo`03003ooooo00Coo`03003o
oooo00;oo`D000Koo`03003ooooo00Goo`04003oooooool70004ool00`00ooooo`04ool20006ool0
0`00ooooo`02ool60004ool00`00ooooo`05ool00`00ooooo`15ool2000Wool0027oo`03003ooooo
00[oo`8000Goo`8000;oo`8000;oo`8000Koo`@000?oo`8000Koo`@000?oo`8000Koo`@000Coo`80
00Coo`D000Coo`8000Coo`D000?oo`8000Koo`@000Coo`8000Koo`@000?oo`8000Koo`03003ooooo
00<000;oo`03003ooooo00Coo`8000;oo`8000;oo`03003ooooo00Coo`8000?oo`H000?oo`8000Oo
o`03003ooooo008000;oo`03003ooooo00Goo`8000?oo`D000Coo`8000Ooo`04003oooooool40006
ool20006ool00`00ooooo`030002ool00`00ooooo`04ool00`00ooooo`04ool01000oooooooo1@00
1_oo0P001_oo00@00?ooooooo`L000Coo`03003ooooo00Coo`03003ooooo00Goo`@000Coo`03003o
oooo00Goo`03003ooooo00Goo`04003oooooool70004ool00`00ooooo`04ool00`00ooooo`05ool0
0`00ooooo`13ool01000ool000009_oo000Qool3000<ool20003ool40006ool20002ool20002ool2
0005ool20002ool20002ool20005ool20002ool20002ool20006ool40003ool20006ool40003ool2
0005ool20002ool20002ool20006ool20002ool20002ool20005ool20003ool40006ool20003ool5
0005ool20005ool40004ool20005ool20003ool50005ool20006ool40003ool00`00ooooo`05ool2
0003ool60003ool20007ool01000oooooooo1@001_oo00<00?ooool01?oo00@00?ooooooo`H000?o
o`8000Soo`04003oooooool60004ool00`00ooooo`05ool00`00ooooo`04ool00`00ooooo`040002
ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`05ool40004ool00`00ooooo`05ool00`00
ooooo`04ool00`00ooooo`05ool00`00ooooo`16ool00`00ooooo`0Sool0027oo`03003ooooo00ko
o`<000Coo`8000Coo`@000Koo`8000?oo`@000Koo`8000?oo`@000Koo`8000;oo`8000;oo`8000Go
o`8000;oo`8000;oo`8000Goo`8000?oo`@000Koo`8000?oo`D000Koo`8000?oo`D000?oo`8000Ko
o`@000Coo`8000Koo`03003ooooo008000;oo`03003ooooo00Goo`8000?oo`D000Coo`8000Koo`03
003ooooo00<000;oo`03003ooooo00?oo`8000Koo`@000Coo`03003ooooo00Coo`8000?oo`H000Co
o`03003ooooo00Goo`04003oooooool60004ool00`00ooooo`02ool01000ool000001_oo10001?oo
00<00?ooool01?oo0P001_oo00@00?ooooooo`D000Ooo`03003ooooo00Coo`03003ooooo00Coo`03
003ooooo00@000;oo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00Goo`03003ooooo00;o
o`@004Soo`03003ooooo02;oo`008Ooo00<00?ooool03ooo0P001_oo10000ooo0P001_oo10001?oo
0P001?oo1@001?oo0P001?oo10001_oo0P000ooo10001_oo0P000ooo1@001?oo0P001?oo1@001?oo
00<00?ooool01Ooo10000ooo0P001Ooo0P000_oo0P000_oo0P001_oo0P000ooo10001Ooo0P001_oo
10000ooo0P001_oo0P000ooo10001_oo00<00?ooool01?oo00<00?ooool00`000_oo00<00?ooool0
1?oo00<00?ooool01?oo10001?oo00<00?ooool01?oo00<00?ooool01?oo10001?oo00<00?ooool0
1?oo0P000_oo00D00?ooooooo`0000;oo`<000;oo`03003ooooo00Coo`8000Koo`04003oooooool6
0004ool00`00ooooo`05ool00`00ooooo`05ool01000oooooooo1@001ooo00<00?ooool01?oo00<0
0?ooool01?oo00<00?ooool00_oo1`001?oo00<00?ooool0A_oo0P008_oo000Qool00`00ooooo`0A
ool20002ool20002ool20005ool20002ool20002ool20006ool40003ool20006ool40003ool20006
ool40003ool20006ool40003ool20006ool40003ool20005ool20002ool30002ool20005ool20003
ool40006ool20003ool60003ool20006ool00`00ooooo`030002ool00`00ooooo`04ool20003ool6
0003ool20006ool01000oooooooo1@001_oo00<00?ooool01?oo00<00?ooool00`000_oo00<00?oo
ool01?oo00<00?ooool01?oo00<00?ooool00`000_oo00<00?ooool01?oo0P001_oo00@00?oo003o
o`D000Koo`03003ooooo00Goo`04003oooooool60004ool00`00ooooo`04ool20006ool00`00oooo
o`02ool60004ool00`00ooooo`05ool00`00ooooo`05ool01000oooooooo1`001?oo00<00?ooool0
1Ooo00<00?ooool0Aooo00<00?ooool07ooo000Qool00`00ooooo`0Cool20006ool20003ool40006
ool20002ool20002ool20005ool20002ool20002ool20005ool20002ool20002ool20005ool20002
ool20002ool20005ool20002ool20002ool20005ool20003ool40007ool20003ool50003ool20006
ool40004ool00`00ooooo`04ool20003ool40006ool00`00ooooo`04ool40004ool00`00ooooo`04
ool20003ool50004ool20006ool01000oooooooo1@001_oo0P001Ooo00@00?ooooooo`D000Koo`80
00Koo`04003oooooool60004ool00`00ooooo`04ool00`00ooooo`05ool40004ool00`00ooooo`04
ool20006ool01000oooooooo1`001?oo00<00?ooool01?oo00<00?ooool01Ooo00<00?ooool00_oo
1P001?oo00<00?ooool01Ooo00<00?ooool01?oo00<00?ooool0B?oo00<00?ooool07_oo000Pool2
000Gool20006ool30004ool20004ool40006ool20003ool40006ool20003ool40006ool20003ool4
0006ool20003ool40006ool20003ool50003ool20007ool40003ool20005ool20002ool20002ool0
0`00ooooo`04ool20003ool60003ool20006ool00`00ooooo`030002ool00`00ooooo`04ool20003
ool60003ool20006ool20003ool50004ool20007ool01000oooooooo1@001?oo0P001ooo00@00?oo
ooooo`H000Coo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00@000;oo`03003ooooo00Co
o`03003ooooo00Goo`04003oooooool60004ool00`00ooooo`05ool00`00ooooo`04ool00`00oooo
o`02ool70004ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`05ool00`00ooooo`18ool2
000Nool0023oo`04003oo`00000Gool20002ool20002ool20005ool40003ool20006ool40003ool2
0006ool40003ool20006ool40003ool20006ool40003ool20006ool40003ool20005ool20002ool3
0002ool00`00ooooo`04ool20003ool40005ool20005ool40004ool20005ool20003ool40006ool2
0005ool40004ool00`00ooooo`04ool20003ool60003ool00`00ooooo`05ool20003ool60003ool0
0`00ooooo`05ool20003ool60004ool00`00ooooo`03ool20006ool01000oooooooo1@001ooo00<0
0?ooool00ooo00<00?ooool01Ooo10001?oo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool0
1?oo1@001?oo00<00?ooool01Ooo00<00?ooool00ooo00<00?ooool01Ooo00<00?ooool00_oo1000
B?oo00@00?oo000001goo`008?oo00<00?ooool06_oo0P001_oo0P0000?oo`0000000_oo0P001Ooo
0P000_oo0P000_oo0P001Ooo0P000_oo0P000_oo0P001Ooo0P000_oo0P000_oo0P001Ooo0P000_oo
0P000_oo0P001Ooo0P000_oo0P000_oo0P001Ooo0P000ooo10001_oo0P000ooo1P000ooo0P001_oo
00<00?ooool00P000_oo0P001_oo0P000ooo1@000ooo0P001ooo00<00?ooool00P000_oo00<00?oo
ool01?oo00<00?ooool01?oo10001?oo00<00?ooool00ooo0P001_oo10001?oo00<00?ooool00ooo
0P001_oo10001?oo00<00?ooool01?oo00<00?ooool00_oo00<00?oo00000ooo1P001?oo00<00?oo
ool01Ooo00<00?ooool01?oo00<00?ooool010000_oo00<00?ooool01?oo00<00?ooool01?oo00<0
0?ooool01?oo00<00?ooool00`000_oo00<00?ooool01Ooo00<00?ooool01?oo00<00?ooool01?oo
00<00?ooool00_oo1`001?oo00<00?ooool0BOoo00<00?ooool06_oo000Pool00`00ooooo`0Lool2
0004ool40005ool20003ool40006ool20003ool40006ool20003ool40006ool20003ool40006ool2
0003ool40006ool20003ool50003ool20006ool40004ool20005ool20003ool40006ool20003ool6
0003ool20005ool20003ool50005ool20005ool00`00ooooo`030002ool00`00ooooo`04ool00`00
ooooo`04ool00`00ooooo`030002ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`030002
ool00`00ooooo`04ool00`00ooooo`04ool01000oooooooo1P001?oo00<00?ooool01?oo0P001_oo
00@00?ooooooo`D000Ooo`03003ooooo00?oo`03003ooooo00Goo`04003oooooool50006ool00`00
ooooo`04ool00`00ooooo`05ool01000oooooooo1`001?oo00<00?ooool01Ooo00<00?ooool0BOoo
00<00?ooool06Ooo000Pool00`00ooooo`0Nool40004ool20004ool40004ool30003ool50004ool2
0004ool50004ool20004ool50004ool20004ool50003ool20006ool40003ool20005ool20002ool2
0002ool20006ool20003ool50003ool20006ool40004ool00`00ooooo`04ool20003ool50004ool0
0`00ooooo`05ool01000oooooooo10001_oo0P001Ooo00@00?ooooooo`D000Koo`03003ooooo00Co
o`04003oooooool50006ool00`00ooooo`04ool01000oooooooo1`000ooo00<00?ooool01?oo0P00
1_oo00@00?ooooooo`H000Coo`03003ooooo00Goo`03003ooooo00Coo`03003ooooo00;oo`H000Co
o`03003ooooo00Goo`03003ooooo00Coo`03003ooooo00;oo`H000Coo`03003ooooo00Goo`03003o
oooo00Coo`03003ooooo04[oo`8001Woo`008?oo00<00?ooool08?oo0P001_oo10000ooo0P001_oo
0`000ooo0P001_oo10000ooo0P001_oo10000ooo0P001_oo10000ooo0P001Ooo0P000_oo0P000_oo
0P001Ooo0P000ooo10001_oo0P000ooo1P000ooo0P001Ooo0P000_oo0P000_oo00<00?ooool01?oo
0P000ooo1P000ooo0P001Ooo0P000ooo1P000ooo0P001ooo00@00?ooooooo`D000Coo`8000Koo`04
003oooooool60004ool00`00ooooo`05ool01000oooooooo1P000_oo0`000_oo0P000_oo0P001_oo
00@00?ooooooo`H000Coo`03003ooooo00Coo`8000Koo`04003oooooool70004ool00`00ooooo`04
ool00`00ooooo`05ool01000oooooooo1`001?oo00<00?ooool01?oo00<00?ooool01?oo00<00?oo
ool01Ooo00<00?ooool0Booo00<00?ooool05_oo000Pool3000Rool20002ool20002ool20005ool2
0002ool20002ool20004ool20002ool20002ool20005ool20002ool20002ool20005ool20002ool2
0002ool20005ool20003ool40006ool20003ool50003ool20006ool40004ool00`00ooooo`04ool2
0003ool40005ool20005ool40004ool00`00ooooo`04ool20003ool50004ool20005ool20003ool6
0003ool20006ool20003ool50004ool00`00ooooo`04ool20005ool40004ool01000ool000000ooo
0P000_oo00D00?ooooooo`0000?oo`H000Coo`03003ooooo00Coo`03003ooooo00Goo`04003ooooo
ool60004ool00`00ooooo`05ool00`00ooooo`04ool00`00ooooo`02ool60004ool00`00ooooo`05
ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`02ool4001=ool2000Fool0023oo`03003o
oooo02Coo`8000Koo`8000?oo`@000Koo`8000;oo`@000Koo`8000?oo`@000Koo`8000?oo`@000Ko
o`8000?oo`D000?oo`8000Koo`@000?oo`8000Goo`8000;oo`8000;oo`8000Goo`8000?oo`H000?o
o`8000Koo`03003ooooo008000;oo`03003ooooo00Coo`8000?oo`H000?oo`8000Koo`8000?oo`D0
00Coo`03003ooooo00Coo`8000?oo`H000?oo`03003ooooo00Coo`8000Koo`03003ooooo008000;o
o`03003ooooo00;oo`@000Koo`03003ooooo00L000Coo`03003ooooo00Coo`03003ooooo00Coo`03
003ooooo00;oo`H000Coo`03003ooooo00Coo`8000Koo`04003oooooool70004ool00`00ooooo`04
ool00`00ooooo`04ool00`00ooooo`05ool01000oooooooo1`001?oo00<00?ooool0BOoo00<00?oo
00003_oo10001?oo000Pool00`00ooooo`0Vool20004ool50004ool20004ool40004ool20004ool5
0004ool20004ool50003ool20006ool40003ool20005ool20002ool20002ool20005ool20003ool4
0006ool20003ool50004ool00`00ooooo`04ool20003ool40005ool20005ool40004ool00`00oooo
o`04ool20003ool60003ool00`00ooooo`04ool20003ool60004ool00`00ooooo`03ool20006ool0
1000oooooooo1@001Ooo10001?oo00@00?ooooooo`H00005ool00000ool00006ool00`00ooooo`04
ool01000oooooooo1`001?oo00<00?ooool01?oo00<00?ooool01Ooo00@00?ooooooo`H000Coo`03
003ooooo00Goo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00;oo`H000Coo`03003ooooo
00Coo`03003ooooo04coo`8000koo`03003ooooo00?oo`008?oo00<00?ooool0:?oo10000ooo0P00
1_oo10000ooo0P001Ooo10000ooo0P001_oo10000ooo0P001Ooo0P000_oo0P000_oo0P001Ooo0P00
0ooo10001_oo0P000ooo1@000ooo0P001_oo10000ooo0P001Ooo0P000ooo1P000ooo0P001_oo00<0
0?ooool00P000_oo00<00?ooool01?oo00<00?ooool01?oo10001?oo00<00?ooool00ooo0P001Ooo
10001?oo00<00?ooool01?oo00<00?ooool01?oo00@00?ooooooo`H000Coo`03003ooooo00;oo`80
0003ool00?oo00;oo`H000Coo`03003ooooo00;oo`03003oo`0000Koo`04003oooooool60004ool0
0`00ooooo`05ool00`00ooooo`04ool00`00ooooo`02ool60004ool00`00ooooo`04ool00`00oooo
o`04ool00`00ooooo`05ool01000oooooooo1`001?oo00<00?ooool01?oo00<00?ooool01?oo00<0
0?ooool0COoo00<00?ooool02ooo00<00?ooool00ooo0009ool20004ool00`00ooooo`02ool30008
ool00`00ooooo`0[ool20005ool20002ool20002ool20005ool200000ooo00000002ool20005ool2
0002ool20002ool20005ool20003ool40006ool20003ool50004ool20004ool50003ool20005ool2
0002ool20002ool20005ool20003ool50004ool00`00ooooo`04ool20003ool40005ool20005ool0
0`00ooooo`030002ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`020002ool00`00oooo
o`04ool00`00ooooo`04ool01000oooooooo1P001?oo00<00?ooool01?oo100000?oo`0000001000
1?oo00<00?ooool01?oo00<00?ooool00_oo0`000ooo1P001?oo00<00?ooool01?oo00<00?ooool0
1?oo00<00?ooool01?oo1@001?oo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool01?oo00<0
0?ooool00_oo1P001?oo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool01Ooo00<00?ooool0
COoo00<00?ooool02_oo00<00?ooool00ooo0008ool01000ooooo`002ooo00<00?ooool01Ooo0P00
;_oo0P000ooo10001_oo0P000ooo10001Ooo0P000ooo10001_oo0P000ooo1@001?oo0P001?oo1@00
0ooo0P001_oo10000ooo0P001Ooo0P000ooo10001_oo0P000ooo1@000ooo0P001Ooo0P000ooo1P00
0ooo0P001_oo00@00?ooooooo`@000Koo`8000Goo`04003oooooool50005ool20005ool01000oooo
oooo1P001?oo00<00?ooool01?oo0P000_oo1`001?oo00<00?ooool01?oo00<00?ooool01?oo00@0
0?ooooooo`H000Coo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00<0
00;oo`03003ooooo00Goo`03003ooooo00?oo`03003ooooo00Goo`04003oooooool70004ool00`00
ooooo`03ool00`00ooooo`05ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`1>ool2000:
ool00`00ooooo`03ool000Soo`04003ooooo000;ool00`00ooooo`05ool00`00ool0000_ool30004
ool20004ool50004ool20003ool50004ool20004ool50003ool20006ool40003ool20005ool20002
ool20002ool20005ool20003ool50003ool20006ool40003ool20005ool20003ool50004ool00`00
ooooo`04ool20003ool50003ool20007ool01000oooooooo1@001?oo00<00?ooool01Ooo00@00?oo
ooooo`D000Coo`03003ooooo00Coo`03003ooooo00Coo`@000Coo`03003ooooo00Coo`03003ooooo
00Coo`04003oooooool60003ool20006ool00`00ooooo`04ool00`00ooooo`04ool01000oooooooo
1@001_oo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool00_oo1P001?oo00<00?ooool01?oo
00<00?ooool01?oo00<00?ooool01Ooo00<00?ooool01?oo00@00?ooooooo`@0057oo`03003ooooo
00Goo`<000Goo`000_oo10000_oo00@00?ooool000Soo`<000Soo`03003ooooo037oo`8000Coo`D0
00Coo`8000Coo`@000?oo`8000Koo`@000?oo`8000Goo`8000;oo`8000;oo`8000Goo`8000?oo`@0
00Koo`8000?oo`D000?oo`03003ooooo00Coo`8000;oo`8000;oo`03003ooooo00Coo`8000?oo`D0
00?oo`8000Goo`8000?oo`H000?oo`8000Goo`8000?oo`H000?oo`8000Goo`8000?oo`H000?oo`03
003ooooo00Coo`8000Goo`03003ooooo00<000;oo`03003ooooo00Coo`03003ooooo00Coo`04003o
ooooool60004ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`04ool01000oooooooo1P00
1?oo00<00?ooool01Ooo00<00?ooool01?oo00@00?ooooooo`L000Coo`03003ooooo00Coo`03003o
oooo00Coo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00;oo`H000Coo`03003ooooo04ko
o`8000Soo`03003ooooo00?oo`002?oo00@00?ooool000Soo`03003ooooo00Soo`03003ooooo03?o
o`@000?oo`8000Koo`@000?oo`8000Coo`8000;oo`8000;oo`8000Goo`8000?oo`@000Koo`8000?o
o`D000?oo`8000Coo`H000?oo`03003ooooo00?oo`8000?oo`D000Goo`8000?oo`H000?oo`8000Go
o`8000?oo`D000Coo`03003ooooo00Coo`8000?oo`D000Coo`03003ooooo00Coo`8000?oo`D000Co
o`03003ooooo00?oo`8000Koo`04003oooooool50005ool20005ool01000oooooooo1P001?oo00<0
0?ooool01?oo0P001Ooo0P001Ooo00@00?ooooooo`H000Coo`03003ooooo00Coo`03003ooooo00Go
o`04003oooooool60004ool00`00ooooo`05ool00`00ooooo`03ool00`00ooooo`05ool00`00oooo
o`03ool00`00ooooo`02ool70004ool00`00ooooo`04ool00`00ooooo`1:ool300000ooo003oo`0=
ool000Soo`04003ooooo0008ool00`00ooooo`08ool00`00ooooo`0eool20005ool20002ool20002
ool20005ool20002ool40006ool20003ool50004ool20004ool50003ool00`00ooooo`04ool40004
ool00`00ooooo`03ool20003ool50004ool00`00ooooo`04ool40004ool00`00ooooo`04ool20003
ool50003ool20005ool20003ool60003ool20005ool20003ool60003ool00`00ooooo`04ool00`00
ooooo`04ool01000oooooooo200000?oo`0000001ooo00@00?ooooooo`D000Coo`03003ooooo00Co
o`8000Koo`03003ooooo00?oo`<00003ool0000000@000Coo`03003ooooo00Coo`03003ooooo00Co
o`03003ooooo00;oo`H000Coo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00Coo`03003o
oooo00Coo`04003oooooool70004ool00`00ooooo`05ool00`00ooooo`03ool00`00ooooo`17ool3
0004ool00`00ooooo`0<ool000Woo`8000Woo`@000Ooo`03003ooooo03Ooo`8000?oo`@000Koo`80
00?oo`@000Coo`8000Coo`D000Coo`8000Coo`D000?oo`03003ooooo00?oo`8000;oo`8000;oo`80
00Goo`8000?oo`D000?oo`8000Goo`8000;oo`8000;oo`03003ooooo00Coo`8000?oo`H000?oo`80
00Goo`8000?oo`D000Coo`03003ooooo00Coo`8000?oo`D000Coo`03003ooooo00?oo`8000Goo`04
003oooooool60003ool20006ool20003ool60003ool00`00ooooo`04ool20006ool01000oooooooo
30001?oo00<00?ooool01?oo00<00?ooool01?oo00@00?ooooooo`L000Coo`03003ooooo00Coo`03
003ooooo00Coo`03003ooooo00Coo`04003oooooool=0004ool00`00ooooo`05ool00`00ooooo`04
ool00`00ooooo`04ool00`00ooooo`13ool30007ool00`00ooooo`0<ool001ooo`03003ooooo03Wo
o`<000Coo`8000Coo`D000?oo`8000Coo`D000?oo`8000Koo`@000?oo`8000Coo`8000?oo`@000Ko
o`8000?oo`D000?oo`8000Goo`8000?oo`@000Goo`8000Goo`@000Coo`03003ooooo00Coo`8000?o
o`D000?oo`8000Goo`8000?oo`H000?oo`03003ooooo00Coo`03003ooooo00Coo`04003oooooool5
0004ool00`00ool000020002ool20003ool60004ool00`00ooooo`03ool20006ool01000oooooooo
1P001?oo00<00?ooool00ooo00@00?oo000000?oo`03003ooooo00Coo`04003oooooool60004ool0
0`00ooooo`05ool00`00ooooo`03ool00`00ooooo`05ool01000oooooooo1P001?oo00<00?ooool0
1?oo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool01Ooo00<00?ooool01?oo00<00?ooool0
?ooo0`002_oo00<00?ooool03?oo000Oool3000kool20004ool50003ool20005ool40003ool20005
ool20002ool20002ool20005ool20002ool50004ool20004ool50003ool20005ool20003ool50003
ool20006ool00`00ooooo`020002ool20005ool20003ool60003ool00`00ooooo`04ool20003ool5
0004ool00`00ooooo`03ool20005ool01000oooooooo1P000ooo0P000ooo10000ooo1P001?oo00<0
0?ooool01?oo00<00?ooool01?oo00@00?ooooooo`H000Coo`03003ooooo00Coo`03003ooooo00?o
o`04003ooooo0003ool01000oooooooo1P001?oo00<00?ooool01?oo00<00?ooool01?oo00<00?oo
ool01?oo00<00?ooool00_oo1P001?oo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool01?oo
00<00?ooool01?oo00<00?ooool00_oo2`00?Ooo0`003Ooo00<00?ooool03?oo000Oool01000oooo
o`00??oo10000ooo0P001Ooo0P0000?oo`0000000_oo0P001Ooo0P000ooo10001_oo0P000ooo1000
0ooo0P001_oo10000ooo0P001Ooo0P000ooo1@000ooo0P001Ooo0P000ooo10001_oo0P000ooo1@00
1?oo00<00?ooool00ooo0P000ooo1P000ooo00<00?ooool01?oo00<00?ooool01?oo00@00?oooooo
o`D000Coo`03003ooooo00Coo`<000;oo`D000Coo`03003ooooo00Coo`03003ooooo00Coo`04003o
ooooool60004ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`070004
ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`04ool01000oooooooo1`001?oo00<00?oo
ool00ooo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool01Ooo00@00?ooooooo`L000Coo`03
003ooooo00Coo`03003ooooo03Koo`@0017oo`03003ooooo00_oo`007_oo00<00?ooool0@?oo0P00
1Ooo0P000ooo10001Ooo0P000ooo1@001?oo0P001?oo1@000ooo00<00?ooool00ooo0P000_oo0P00
0_oo0P001Ooo0P000ooo1@000ooo0P001Ooo0P000ooo1@000ooo0P001_oo10000ooo00<00?ooool0
1?oo00<00?ooool00ooo10001?oo00<00?ooool00ooo0P001Ooo00@00?ooooooo`H000?oo`8000Go
o`8000;oo`L000?oo`03003ooooo00Coo`8000Goo`04003oooooool60004ool00`00ooooo`04ool0
0`00ooooo`03ool00`00ooooo`04ool01000oooooooo1P0000Goo`00ooooo`0000Koo`03003ooooo
00Coo`03003ooooo00Coo`04003oooooool60004ool00`00ooooo`05ool00`00ooooo`03ool00`00
ooooo`04ool00`00ooooo`04ool00`00ooooo`02ool60004ool00`00ooooo`04ool00`00ooooo`05
ool00`00ooooo`0bool3000Eool00`00ooooo`0;ool001koo`03003ooooo04;oo`8000?oo`D000Co
o`8000?oo`D000Coo`8000Coo`D000?oo`03003ooooo00?oo`8000?oo`@000Koo`8000?oo`D000?o
o`8000Goo`8000?oo`D000?oo`8000Goo`8000;oo`8000;oo`03003ooooo00?oo`8000Goo`03003o
oooo008000;oo`03003ooooo00Coo`03003ooooo00Coo`04003oooooool50004ool00`00ooooo`04
ool20003ool50004ool00`00ooooo`03ool20006ool01000oooooooo1@001?oo00<00?ooool01?oo
00<00?ooool00ooo00<00?ooool01?oo00@00?ooooooo`H000Coo`04003oooooool200000ooo003o
o`04ool00`00ooooo`05ool01000oooooooo1P001?oo00<00?ooool01?oo00<00?ooool01?oo00<0
0?ooool01?oo00<00?ooool01?oo00@00?ooooooo`L000Coo`03003ooooo00Coo`03003ooooo00Co
o`03003ooooo00Coo`03003ooooo02ooo`<001Soo`03003ooooo00_oo`007_oo00<00?ooool0A?oo
0`001?oo0P001?oo10000ooo0P001_oo10000ooo0P001?oo0P000ooo1@001?oo0P001?oo1@000ooo
0P001Ooo0P000ooo1@000ooo00<00?ooool01?oo0P000ooo10001Ooo0P001Ooo00@00?ooooooo`@0
00Goo`8000Goo`04003oooooool60003ool20005ool20003ool70002ool00`00ooooo`04ool00`00
ooooo`04ool01000oooooooo1P000ooo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool00ooo
00@00?ooooooo`H000Coo`03003ooooo00Coo`03003ooooo00;oo`<000Goo`03003ooooo00;oo`H0
00Coo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo
00;oo`H000Coo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00Goo`03003ooooo00Coo`03
003ooooo02_oo`<001_oo`03003ooooo00_oo`007_oo00<00?ooool0A_oo0P001?oo1@000ooo00<0
0?ooool00ooo0P000_oo0P000_oo0P001Ooo0P000_oo1@001?oo0P001?oo1@000ooo0P001Ooo0P00
0ooo1@000ooo00<00?ooool00ooo0P000ooo1P000ooo00<00?ooool01Ooo00@00?ooooooo`D000?o
o`8000Koo`04003oooooool50004ool00`00ooooo`04ool20003ool50002ool30005ool20005ool0
1000oooooooo1P001?oo00<00?ooool00ooo0P001Ooo00@00?ooooooo``000Coo`03003ooooo00Co
o`03003ooooo00Coo`04003oooooool=0004ool00`00ooooo`04ool00`00ooooo`03ool00`00oooo
o`05ool01000oooooooo3@001?oo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool01?oo00<0
0?ooool01?oo00<00?ooool00_oo1000:Ooo0`007_oo00<00?ooool02ooo000Nool30018ool40003
ool20004ool20003ool40006ool20003ool40004ool20004ool50003ool20005ool20003ool50003
ool00`00ooooo`03ool20003ool50004ool00`00ooooo`03ool20003ool60003ool00`00ooooo`04
ool20003ool50003ool20005ool20003ool60003ool40003ool00`00ooooo`04ool01000oooooooo
1@001?oo00<00?ooool01?oo00<00?ooool01?oo00@00?ooooooo`D000Coo`03003ooooo00?oo`03
003ooooo00Coo`03003ooooo00Coo`04003oooooool60003ool20005ool00`00ooooo`05ool00`00
ooooo`03ool00`00ooooo`04ool00`00ooooo`02ool60004ool00`00ooooo`03ool00`00ooooo`05
ool00`00ooooo`03ool00`00ooooo`05ool00`00ooooo`04ool01000oooooooo1`001?oo00<00?oo
ool08ooo0`008Ooo00<00?ooool02ooo000Nool00`00ooooo`1:ool20005ool20002ool50004ool2
0004ool50003ool00`00ooooo`04ool40003ool20005ool20003ool50003ool00`00ooooo`03ool2
0003ool50003ool20005ool20003ool50004ool00`00ooooo`03ool20003ool60003ool00`00oooo
o`04ool20003ool50004ool00`00ooooo`050005ool01000oooooooo1P000ooo00<00?ooool01?oo
00<00?ooool01?oo00@00?ooooooo`H000?oo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo
00Coo`04003oooooool60004ool00`00ooooo`04ool00`00ooooo`03ool20005ool00`00ooooo`04
ool01000oooooooo1`001?oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool01?oo00<00?oo
ool01?oo00<00?ooool01?oo00<00?ooool00_oo1P001?oo00<00?ooool01?oo00<00?ooool08?oo
0`009?oo00<00?ooool02ooo000Nool00`00ooooo`1<ool20003ool40004ool20004ool50003ool2
0004ool20002ool20002ool20005ool20003ool50003ool00`00ooooo`03ool20003ool50003ool2
0005ool20003ool50003ool20005ool20003ool50004ool00`00ooooo`03ool20003ool60003ool0
0`00ooooo`03ool30005ool01000oooooooo1@001?oo00<00?ooool00ooo0P001Ooo00@00?oooooo
o`H000Coo`03003ooooo00?oo`8000Goo`03003ooooo00?oo`04003oooooool60004ool00`00oooo
o`04ool00`00ooooo`04ool20005ool00`00ooooo`03ool01000oooooooo1P001?oo00<00?ooool0
1Ooo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool01?oo00@00?ooooooo`h000Coo`03003o
oooo00Coo`03003ooooo00Coo`03003ooooo01coo`<002Ooo`03003ooooo00_oo`007_oo00<00?oo
ool0C_oo0`000ooo0P001?oo1@000ooo0P001Ooo0P000_oo10001_oo0P000ooo1@000ooo00<00?oo
ool00ooo0P000ooo1@000ooo0P001Ooo0P000ooo1@000ooo0P001Ooo0P000ooo1@000ooo0P001Ooo
0P000ooo1@001?oo00<00?ooool00ooo0P0000?oo`0000000_oo00@00?ooooooo`H000?oo`03003o
oooo00Coo`03003ooooo00Coo`04003oooooool50004ool00`00ooooo`04ool00`00ooooo`04ool0
0`00ooooo`03ool01000oooooooo1@001?oo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool0
1?oo0P000_oo30001?oo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool0
1?oo00@00?ooooooo`H000Coo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00Coo`03003o
oooo00Coo`03003ooooo01Woo`<002[oo`03003ooooo00_oo`007_oo00<00?ooool0D?oo0P000ooo
1@000ooo0P001Ooo0P000ooo10001?oo0P001?oo1@000ooo00<00?ooool00ooo0P000ooo1@001?oo
0P001?oo0P000ooo1@000ooo0P001Ooo0P000ooo1@000ooo0P001Ooo0P000ooo1@000ooo0P001Ooo
0P000ooo0`000ooo1@001?oo00<00?ooool00ooo00<00?ooool01?oo00@00?ooooooo`H000?oo`03
003ooooo00Coo`03003ooooo00Coo`04003oooooool<0003ool00`00ooooo`04ool20005ool00`00
ooooo`04ool01000oooooooo1P001?oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo
00<00?ooool01Ooo00<00?ooool00ooo00<00?ooool00_oo1P001?oo00<00?ooool01?oo00<00?oo
ool00ooo00<00?ooool01Ooo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool05Ooo0`00;Ooo
00<00?ooool02ooo000Nool00`00ooooo`1Bool30003ool20005ool20003ool50003ool20004ool5
0003ool20004ool20003ool50004ool20004ool:0004ool20004ool20003ool50003ool00`00oooo
o`04ool20003ool50003ool20005ool20003ool;0003ool00`00ooooo`04ool20004ool01000oooo
oooo1P001?oo00<00?ooool00ooo0P001Ooo00@00?ooooooo`H000Coo`03003ooooo00?oo`03003o
oooo00?oo`8000Koo`03003ooooo00?oo`04003oooooool60004ool01000ool000000ooo00<00?oo
ool00ooo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00_oo3@001?oo00<00?ooool00ooo
00<00?ooool01?oo00<00?ooool01?oo00<00?ooool01Ooo00<00?ooool01?oo00<00?ooool00ooo
00<00?ooool04_oo0`00<Ooo00<00?ooool02_oo000Mool01000ool00000E?oo0P001?oo0P000ooo
1@000ooo0P001?oo1@000ooo0P001Ooo0P000_oo1@001?oo0P001?oo1@000ooo00<00?ooool00_oo
0P001?oo2`000ooo00<00?ooool00ooo0P000ooo1P000ooo00<00?ooool01?oo0P000ooo1`0000?o
o`00ool01?oo00<00?ooool00ooo0P000ooo2`001?oo00<00?ooool01?oo00<00?ooool01?oo00@0
0?ooooooo`D000Coo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo00Coo`04003oooooool<
0004ool00`00ooooo`04ool01000ooooo`000_oo00<00?ooool00ooo00<00?ooool01?oo00@00?oo
ooooo`L000Coo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00Coo`03
003ooooo00Coo`03003ooooo00Coo`03003ooooo00;oo`X0013oo`<003Coo`03003ooooo00[oo`00
7Ooo00<00?ooool0Eooo0P000_oo1@001?oo0P000ooo1@000ooo0P001Ooo0P000ooo10001?oo0P00
1?oo1@000ooo00<00?ooool00ooo0P000ooo1@001?oo00<00?ooool00_oo0P001?oo0P000ooo1@00
1?oo00<00?ooool00ooo0P000ooo1P000_oo0`001?oo0P001?oo0P000ooo1@001?oo00<00?ooool0
0_oo0P001Ooo0P001Ooo00@00?ooooooo`H000?oo`03003ooooo00Coo`03003ooooo00?oo`03003o
oooo00Coo`04003oooooool60004ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool0
1000oooooooo0P0000?oo`00ool01?oo00@00?ooooooo`H000Coo`03003ooooo00Coo`03003ooooo
00Coo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo
00;oo`L000Coo`03003ooooo00?oo`03003ooooo00Woo`@003Ooo`03003ooooo00[oo`007Ooo00<0
0?ooool0FOoo0P001?oo0P001?oo10000ooo0P001Ooo0P000ooo1@000ooo0P001?oo1@000ooo0P00
1?oo0P000ooo1@000ooo0P001Ooo0P000ooo2P000ooo0P001Ooo0P000ooo1@001?oo10000_oo00<0
0?ooool01?oo00@00?ooooooo`D000?oo`03003ooooo00Coo`03003ooooo00?oo`8000?oo`/000Co
o`03003ooooo00?oo`8000Goo`03003ooooo00?oo`04003oooooool60004ool00`00ooooo`04ool0
0`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool01000oooooooo30001?oo00<00?ooool0
1?oo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool01Ooo00<00?ooool00ooo00<00?ooool0
0_oo3@001?oo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool01_oo0`00>ooo00<00?ooool0
2_oo000Mool00`00ooooo`1Jool20004ool50003ool00`00ooooo`03ool20003ool50003ool20004
ool50003ool20005ool20002ool50003ool20005ool20003ool50003ool20003ool20005ool20003
ool50003ool20002ool50004ool01000oooooooo1P000ooo00<00?ooool00ooo0P001Ooo00@00?oo
ooooo`H000?oo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00Coo`04003oooooool;0004
ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool01000oooooooo
1P000_oo0`001Ooo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool00ooo
00<00?ooool01?oo00@00?ooooooo`L000Coo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo
00Goo`03003ooooo00?oo`03003ooooo00;oo`<003koo`03003ooooo00[oo`007Ooo00<00?ooool0
G?oo10000ooo0P001?oo0P000ooo1@001?oo0P000ooo1@000ooo0P001Ooo0P000ooo10000ooo0P00
1Ooo0P000ooo1@000ooo0P001Ooo0P000ooo0P000ooo1@000ooo0P001Ooo0P000ooo2P001?oo00<0
0?ooool00ooo00<00?ooool01?oo00@00?ooooooo`D000Coo`03003ooooo00?oo`8000Coo`03003o
oooo00Coo`04003oooooool60003ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool0
0`00ooooo`04ool01000oooooooo30001?oo00<00?ooool00ooo0P001Ooo00<00?ooool01?oo00<0
0?ooool01?oo00<00?ooool00ooo00@00?ooooooo`d000Coo`03003ooooo00Coo`03003ooooo00?o
o`03003ooooo00Goo`03003ooooo00Coo`03003ooooo00Coo`@0047oo`03003ooooo00[oo`007Ooo
00<00?ooool0Gooo0P001?oo0P000_oo1@001?oo0P001?oo10000ooo0P001Ooo0P000ooo1@000ooo
00<00?ooool00ooo0P000ooo1@000ooo0P001Ooo0P000ooo2P000ooo00<00?ooool01?oo2P000ooo
00<00?ooool00_oo0P001Ooo0P001?oo00@00?ooooooo`H000?oo`03003ooooo00Coo`03003ooooo
00Coo`03003ooooo00;oo`04003oooooool60004ool00`00ooooo`03ool00`00ooooo`03ool00`00
ooooo`04ool00`00ooooo`03ool01000oooooooo1P001?oo00<00?ooool00ooo00<00?ooool01?oo
00<00?ooool00ooo0P001?oo00<00?ooool01Ooo00@00?ooooooo``000Coo`03003ooooo00Coo`03
003ooooo00?oo`03003ooooo00Goo`03003ooooo00?oo`03003ooooo00Goo`03003ooooo00Coo`03
003ooooo00?oo`03003ooooo04;oo`03003ooooo00[oo`007Ooo0`00HOoo20001?oo0P001?oo1@00
0ooo00<00?ooool00ooo0P000ooo1@000ooo00<00?ooool00ooo0P000ooo1@000ooo0P001Ooo0P00
0ooo1@000ooo00<00?ooool00_oo00<00?ooool00ooo0P000ooo1P000ooo00<00?ooool00ooo00<0
0?ooool00ooo0P000ooo2P001?oo00<00?ooool00ooo0P001Ooo00@00?ooooooo`/000Coo`03003o
oooo00Coo`03003ooooo00?oo`03003ooooo00?oo`04003oooooool<0004ool00`00ooooo`04ool0
0`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool30003ool00`00ooooo`02ool60004ool0
0`00ooooo`03ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`05ool0
0`00ooooo`03ool00`00ooooo`04ool00`00ooooo`04ool01000oooooooo1000@ooo00<00?ooool0
2_oo000Mool00`00ooooo`1Sool20003ool20004ool50003ool00`00ooooo`03ool20003ool50003
ool00`00ooooo`03ool20003ool50003ool20005ool20003ool50003ool00`00ooooo`03ool20003
ool20003ool50004ool00`00ooooo`03ool00`00ooooo`03ool01000oooooooo1P000ooo00<00?oo
ool00_oo0P001Ooo0P001Ooo00@00?ooooooo`D000Coo`03003ooooo00;oo`03003ooooo00Coo`03
003ooooo00Coo`03003ooooo00?oo`04003oooooool50004ool00`00ooooo`03ool00`00ooooo`04
ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool01000oooooooo3@001?oo00<00?oo
ool00ooo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool01?oo00<00?oo
ool01?oo00<00?ooool00ooo00<00?ooool00_oo3@001?oo00<00?ooool0@?oo00<00?ooool02_oo
000Mool00`00ooooo`1Uool20002ool50004ool20003ool20003ool50003ool20004ool20003ool5
0003ool20005ool20003ool50003ool00`00ooooo`03ool20003ool?0005ool20004ool01000oooo
oooo1@001?oo00<00?ooool00ooo00<00?ooool00ooo0P000ooo2`000ooo00<00?ooool01?oo00<0
0?ooool00_oo0P001Ooo00@00?ooooooo``000?oo`03003ooooo00Coo`03003ooooo00?oo`03003o
oooo00?oo`03003ooooo00Coo`03003ooooo00?oo`04003oooooool60004ool01000ool000000_oo
00<00?ooool01?oo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool01?oo
00<00?ooool00ooo00<00?ooool00_oo3@001?oo00<00?ooool01?oo00<00?ooool00ooo00<00?oo
ool0@?oo00<00?ooool02_oo000Mool00`00ooooo`1Wool20004ool20004ool90004ool20003ool:
0004ool20004ool20003ool50003ool00`00ooooo`03ool20003ool50003ool01000oooooooo0`00
1Ooo0P000ooo2P000ooo0P001Ooo00<00?ooool00ooo00@00?ooooooo`H000?oo`03003ooooo00?o
o`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00?oo`04003oooooool50004ool00`00oooo
o`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool01000oooo
oooo30001?oo00<00?ooool00ooo00D00?ooooooo`0000;oo`03003ooooo00Coo`03003ooooo00Co
o`03003ooooo00?oo`03003ooooo00Coo`04003oooooool=0004ool00`00ooooo`03ool00`00oooo
o`04ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`10ool00`00ooooo`09ool001coo`03
003ooooo06Woo`8000Coo`D000?oo`03003ooooo00;oo`8000Coo`@000?oo`8000Coo`8000Coo`X0
00?oo`8000Coo`8000?oo`D000?oo`03003ooooo00?oo`<000?oo`8000?oo`D000?oo`03003ooooo
00;oo`8000Goo`8000Coo`04003oooooool50004ool00`00ooooo`03ool20004ool00`00ooooo`03
ool01000oooooooo30000ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool00ooo00<00?oo
ool00ooo00@00?ooooooo``000Coo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00?oo`04
003oooooool200000ooo003oo`05ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool6
0004ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`04ool00`00oooo
o`04ool00`00ooooo`04ool00`00ooooo`0oool00`00ooooo`09ool001;oo`8000Soo`8006coo`@0
00?oo`03003ooooo00?oo`8000?oo`D000?oo`03003ooooo00?oo`8000?oo`D000?oo`03003ooooo
00;oo`8000Coo`X000?oo`03003ooooo00?oo`800003ool0000000/000?oo`03003ooooo00?oo`03
003ooooo00?oo`8000?oo`X000?oo`8000Goo`03003ooooo00Coo`03003ooooo00;oo`04003ooooo
ool50004ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool00`00
ooooo`03ool01000oooooooo1@001?oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo
00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00_oo00<00?oo00001Ooo00@00?ooooooo`d0
00Coo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo
00Coo`03003ooooo00Goo`03003ooooo00Coo`03003ooooo03koo`03003ooooo00Woo`004Ooo00@0
0?ooool000Ooo`03003oo`0006koo`8000?oo`8000?oo`D000?oo`8000Coo`8000?oo`D000?oo`03
003ooooo00?oo`8000?oo`D000?oo`03003ooooo00;oo`03003ooooo00?oo`8000?oo`D000?oo`80
00Coo`03003ooooo00?oo`8000Coo`04003oooooool60003ool00`00ooooo`02ool00`00ooooo`04
ool20004ool01000oooooooo2`000ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool00ooo
00<00?ooool00ooo00@00?ooooooo``000?oo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo
00?oo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo00;oo``000Coo`03
003ooooo00?oo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo00Coo`03
003ooooo00Coo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo03koo`03
003ooooo00Woo`004Ooo00@00?ooool000Ooo`03003ooooo073oo`P000Coo`8000?oo`X000?oo`80
00Coo`8000?oo`D000?oo`8000Coo`8000?oo`8000?oo`D000?oo`8000Goo`8000?oo`8000?oo`X0
00Coo`03003ooooo00?oo`03003ooooo00;oo`8000?oo`/000Coo`03003ooooo00;oo`03003ooooo
00?oo`8000Goo`03003ooooo00?oo`04003oooooool;0004ool00`00ooooo`03ool00`00ooooo`03
ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool01000oooooooo
3@000ooo0P001Ooo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool00ooo
00<00?ooool01?oo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool00_oo
2`00?ooo00<00?ooool02Ooo000Aool01000ooooo`001ooo00<00?ooool0L_oo00<00?ooool00_oo
0P001?oo10000ooo0P001?oo0P000ooo2P000ooo0P001Ooo0P000_oo300000?oo`0000001Ooo0P00
0ooo2P000ooo00<00?ooool00_oo0P001Ooo0P001?oo00@00?ooooooo`D000Coo`03003ooooo00;o
o`03003ooooo00Coo`03003ooooo00;oo`8000Goo`04003oooooool;0003ool00`00ooooo`03ool0
0`00ooooo`04ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool0
1000oooooooo30001?oo00<00?ooool00ooo00<00?ooool01?oo0P001Ooo00<00?ooool00ooo00<0
0?ooool00ooo00<00?ooool01Ooo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00<0
0?ooool00_oo3@000ooo00<00?ooool01Ooo00<00?ooool0??oo00<00?ooool02Ooo000Aool01000
ooooo`001ooo00<00?ooool0Looo0P000ooo1@000ooo00<00?ooool00ooo0P000ooo10000ooo0P00
1?oo0P001?oo0P000ooo10000ooo0P000_oo10001?oo0P000ooo1@000ooo00<00?ooool00_oo00<0
0?ooool00ooo0P001?oo0P000ooo2P000ooo00<00?ooool01?oo00<00?ooool00_oo00<00?ooool0
1?oo00@00?ooooooo`/000?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003o
oooo00?oo`03003ooooo00Coo`03003ooooo00?oo`04003oooooool;0004ool00`00ooooo`03ool0
0`00ooooo`04ool00`00ooooo`03ool00`00ooooo`04ool30003ool00`00ooooo`04ool00`00oooo
o`03ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`02ool=0004ool00`00ooooo`03ool0
0`00ooooo`04ool00`00ooooo`04ool00`00ooooo`0lool00`00ooooo`09ool0017oo`04003ooooo
0007ool00`00ooooo`1eool30004ool20003ool20003ool50003ool00`00ooooo`03ool20003ool:
0003ool00`00ooooo`02ool30003ool:0003ool00`00ooooo`03ool00`00ooooo`02ool20003ool;
0003ool00`00ooooo`02ool00`00ooooo`03ool20005ool00`00ooooo`02ool01000oooooooo1P00
0ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool0
0ooo00<00?ooool00ooo00@00?ooooooo``000?oo`03003ooooo00?oo`03003ooooo00Coo`03003o
oooo00?oo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00Coo`03003oo`0000?oo`03003o
oooo00?oo`04003ooooooolD0004ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool0
0`00ooooo`04ool00`00ooooo`05ool00`00ooooo`0kool00`00ooooo`09ool001;oo`8000Soo`03
003ooooo07Ooo`8000Coo`T000?oo`8000Coo`8000?oo`D000?oo`03003ooooo00;oo`8000Coo`@0
0003ool0000000<000?oo`03003ooooo00;oo`03003ooooo00?oo`8000Coo`04003oooooool50003
ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool20005ool01000oooooooo2P001?oo
00<00?ooool00ooo0P001?oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00@00?oo
ooooo`/000Coo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00Coo`03
003ooooo00?oo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo00d000Co
o`03003ooooo00Coo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo00Go
o`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo03_oo`03003ooooo00Wo
o`007?oo0P00N_oo10000ooo00<00?ooool00_oo0P000ooo2P000ooo00<00?ooool00ooo0P000ooo
2P000ooo00<00?ooool00ooo0P000ooo0P000ooo2P000ooo0P001?oo0P001?oo0P001?oo00@00?oo
ooooo`/000?oo`03003ooooo00;oo`8000Goo`03003ooooo00Coo`03003ooooo00;oo`03003ooooo
00?oo`04003oooooool;0003ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool00`00
ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`03ool01000
oooooooo300000Goo`00ooooo`0000Goo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00?o
o`03003ooooo00Goo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00?o
o`03003ooooo00Goo`03003ooooo03[oo`03003ooooo00Woo`007?oo00@00?oo000007[oo`8000Co
o`8000?oo`@000?oo`8000Coo`8000?oo`8000?oo`D00004ool000000004ool20004ool20003ool:
0003ool00`00ooooo`02ool20005ool20004ool01000oooooooo2P000ooo00<00?ooool00ooo00<0
0?ooool00ooo00<00?ooool00ooo0P001?oo00@00?oooooooa4000?oo`03003ooooo00?oo`03003o
oooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00Coo`03003o
oooo00?oo`04003ooooooolB0004ool00`00ooooo`03ool01000oooooooo0`001Ooo00<00?ooool0
1?oo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool0
1Ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool0>_oo00<00?ooool0
2Ooo000Kool00`00ooooo`1nool90003ool20004ool20003ool90003ool30003ool20003ool:0003
ool00`00ooooo`02ool00`00ooooo`03ool20004ool20003ool:0003ool00`00ooooo`02ool00`00
ooooo`03ool20004ool20004ool01000oooooooo2`001?oo00<00?ooool00_oo00<00?ooool00ooo
00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo
00<00?ooool00ooo00@00?ooooooo``000Coo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo
00?oo`03003ooooo00?oo`03003ooooo00?oo`8000Goo`03003ooooo00Coo`03003ooooo00Coo`03
003ooooo00?oo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00Coo`03
003ooooo00?oo`03003ooooo00;oo`@003coo`03003ooooo00Soo`006ooo00<00?ooool0P?oo0P00
0ooo0P001?oo2P000ooo00<00?ooool00_oo10000_oo0P000_oo1@000ooo0P000ooo0P001?oo0P00
0ooo0P000ooo2`000ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo0P001Ooo00@0
0?ooooooo`X000Coo`03003ooooo00;oo`03003ooooo00Coo`03003ooooo00;oo`03003ooooo00?o
o`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`04003ooooooolA0004ool00`00oooo
o`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool00`00oooo
o`03ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool00`00oooo
o`03ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`02oolD0003ool00`00ooooo`0jool0
0`00ooooo`08ool001_oo`03003ooooo08;oo`8000;oo`D000?oo`8000?oo`8000Coo`800003ool0
000000T000?oo`8000Goo`8000?oo`8000;oo`X000?oo`8000Coo`03003ooooo00?oo`8000?oo`80
00Coo`04003oooooool;0003ool00`00ooooo`02ool00`00ooooo`04ool00`00ooooo`02ool00`00
ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool01000oooooooo4@000ooo00<00?ooool00ooo
00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo
00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool00ooo0`000ooo00<00?oo
ool01?oo00@00?oooooooaX000?oo`03003ooooo00Goo`03003ooooo00?oo`03003ooooo00Coo`03
003ooooo03Woo`03003ooooo00Soo`006ooo00<00?ooool0Q?oo0P001?oo0P001?oo0P000_oo2P00
0ooo00<00?ooool00_oo0P001?oo0P000ooo2@000ooo0P000ooo0P001Ooo0P000ooo0P000ooo3`00
0ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00_oo0P001Ooo00<00?ooool00_oo00<0
0?ooool00ooo00@00?ooooooo`/000?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?o
o`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00Co
o`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`04003ooooooolC
0004ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`04ool00`00oooo
o`04ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`0iool00`00ooooo`08ool001_oo`<0
08Goo`8000Coo`T000;oo`<000?oo`8000Coo`8000?oo`X000?oo`03003ooooo00;oo`03003ooooo
00?oo`8000?oo`8000?oo`X000?oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00?oo`80
00Coo`8000Coo`03003ooooo00?oo`04003oooooool@0003ool00`00ooooo`03ool00`00ooooo`03
ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03
ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool01000oooooooo
4P001?oo00@00?oo000000;oo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo00?oo`03003o
oooo00Coo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00Goo`03003ooooo00?oo`03003o
oooo00Coo`03003ooooo03Soo`03003ooooo00Soo`006ooo00<00?ooool0Qooo10000ooo00<00?oo
ool00_oo0`000ooo0P000_oo2P000ooo00<00?ooool00_oo0P001?oo0P000ooo0P000ooo2P000ooo
00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo0P000ooo0P001Ooo00@00?oooooooa00
00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo
00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00;oo`03003ooooo
00?oo`04003ooooooolH0004ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool01`00
oooooooo003oo`0000Koo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo
00?oo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo
03Soo`03003ooooo00Soo`006ooo00<00?ooool0R_oo0P000ooo3P000ooo0P000ooo0P001?oo0P00
0ooo3`000ooo00<00?ooool00_oo00<00?ooool00ooo0P000ooo0P001?oo00@00?oooooooa0000?o
o`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?o
o`03003ooooo00;oo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?o
o`04003ooooooolA0004ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00oooo
o`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool01000oooooooo0`001_oo00<0
0?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00<0
0?ooool01Ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool0=ooo00<00?ooool02?oo000K
ool00`00ooooo`2<ool80003ool20003ool20004ool20002ool:0003ool00`00ooooo`02ool00`00
ooooo`02ool20004ool20003ool20003ool?0003ool00`00ooooo`02ool00`00ooooo`03ool00`00
ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00
ooooo`03ool00`00ooooo`02ool01000oooooooo5`001?oo00<00?ooool00_oo00<00?ooool00ooo
00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo
00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo0P001_oo00<00?oo
ool00ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00<00?oo
ool01?oo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool0=ooo00<00?ooool02?oo000Kool0
0`00ooooo`2;ool50003ool20003ool>0003ool20003ool20004ool20003ool20003ool?0003ool0
0`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool20003ool20004ool20004ool00`00oooo
o`02ool00`00ooooo`03ool01000oooooooo5@001?oo00<00?ooool00ooo00<00?ooool00_oo00<0
0?ooool00ooo00<00?ooool01?oo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00ooo00<0
0?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00<0
0?ooool00ooo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool00ooo00<0
0?ooool01?oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool00_oo4@00
>?oo00<00?ooool02?oo000Jool00`00ooooo`2:ool20005ool80003ool00`00ooooo`02ool20003
ool20004ool20002ool?0003ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool00`00
ooooo`02ool20003ool20005ool00`00ooooo`02ool01000oooooooo5@000ooo00<00?ooool00_oo
00<00?ooool00ooo00<00?ooool00_oo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool00_oo
00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool01?oo
00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo
00<00?ooool00ooo00<00?ooool00ooo00<00?ooool01?oo0`0000?oo`0000009@000ooo00<00?oo
ool01?oo00<00?ooool01?oo00<00?ooool0=Ooo00<00?ooool02?oo000Jool20028ool30009ool2
0003ool20003ool20003ool>0003ool20003ool20003ool00`00ooooo`03ool20003ool20003ool2
0004ool01000oooooooo5@000ooo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00ooo00<0
0?ooool00ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo0P001?oo00<00?ooool0
0ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00_oo00<00?ooool0
0ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00@00?ooooooobD000?oo`03003o
oooo00Coo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00Goo`03003ooooo00?oo`03003o
oooo00Coo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo03Koo`03003ooooo00Ooo`006_oo
00<00?oo0000Q?oo0`003_oo3@000ooo00<00?ooool00_oo00<00?ooool00_oo0P001?oo0P000ooo
0P000_oo0P000ooo50000ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo00<00?oo
ool00ooo00<00?ooool00_oo00<00?ooool00_oo0P001?oo00<00?ooool00_oo00<00?ooool00ooo
00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo
00<00?ooool00ooo00@00?ooooooob<000Coo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo
00?oo`03003ooooo00?oo`03003ooooo00Coo`04003oo`000002ool00`00ooooo`03ool00`00oooo
o`04ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`04ool00`00oooo
o`04ool00`00ooooo`04ool00`00ooooo`0eool00`00ooooo`07ool001[oo`03003ooooo08;oo`80
01?oo`03003ooooo00;oo`8000?oo`8000?oo`8000?oo`8000?ooa<000?oo`8000?oo`03003ooooo
00;oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00;oo`8000Coo`03003ooooo00;oo`80
00Coo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo
00?oo`04003ooooooolQ0004ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool00`00
ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00
ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool01`00oooooooo003oo`0000Koo`03003ooooo
00?oo`03003ooooo00?oo`03003ooooo00Goo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo
00Coo`03003ooooo00?oo`03003ooooo03Goo`03003ooooo00Ooo`006_oo00<00?ooool0Oooo0`00
5_oo0P000ooo4`000ooo00<00?ooool00_oo00<00?ooool00_oo00@00?ooooooo`8000Goo`8000;o
o`8000?oo`8000?oo`8000Coo`03003ooooo00?oo`03003ooooo00;oo`04003ooooooolU0003ool0
0`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool0
0`00ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool0
0`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool0
0`00ooooo`03ool00`00ooooo`04ool01000oooooooo0`001Ooo00<00?ooool01?oo00<00?ooool0
0ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool0
1?oo00<00?ooool0=?oo00<00?ooool01ooo000Jool00`00ooooo`1lool3000Kool30003ool00`00
ooooo`02ool20003ool20002ool20004ool20003ool20003ool20003ool20003oolS0003ool00`00
ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`02ool00`00
ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00
ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00
ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00
ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`03ool20005
ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`05ool00`00ooooo`03ool00`00ooooo`04
ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`0cool00`00ooooo`07ool001[oo`03003o
oooo07Woo`<0023oo`8000?oo`8000?oob8000?oo`05003oooooool00004ool00`00ooooo`02ool2
0003ool20004ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`02ool0
0`00ooooo`03ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool0
0`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool0
0`00ooooo`04ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool0
0`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool0
0`00ooooo`04ool00`00ooooo`03ool00`00ooooo`03ool20005ool00`00ooooo`03ool00`00oooo
o`03ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`04ool00`00oooo
o`04ool00`00ooooo`0cool00`00ooooo`07ool001[oo`03003ooooo07Ooo`8002Goo`P000?oo`03
003ooooo00;oo`04003oooooool20003ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02
ool00`00ooooo`03ool01000oooooooo0P000ooo0P001?oo0P000ooo0P000ooo0P000ooo0P001?oo
00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00_oo
00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00ooo
00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00_oo
00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo
00<00?ooool00ooo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool00ooo
00@00?oo000000?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00;ooal003Coo`03003o
oooo00Ooo`006_oo0`00M?oo0`00:Ooo0P000ooo0P000ooo0P000ooo0P000ooo0P000_oo0P000ooo
0P000ooo0P000ooo0P001?oo00<00?ooool00_oo00<00?ooool00_oo00@00?oooooook`000?oo`03
003ooooo00Coo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo03;oo`03
003ooooo00Ooo`006_oo00<00?ooool0LOoo0`00;_oo>@000ooo00<00?ooool00_oo00<00?ooool0
0_oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool0
0ooo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool0
0ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool0
0ooo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool0
0ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool0
1?oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00P0000?oo`00ool01?oo00<00?ooool0
1?oo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool0
1?oo00<00?ooool0<Ooo00<00?ooool01ooo000Iool00`00ooooo`1`ool2000cool20003ool20002
ool20003ool20003ool20002ool20003ool20003ool00`00ooooo`02ool00`00ooooo`02ool00`00
ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`02ool00`00
ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool00`00
ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00
ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00
ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool00`00
ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool00`00
ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00ool00005ool00`00ooooo`03ool00`00
ooooo`04ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`04ool00`00
ooooo`0aool00`00ooooo`07ool001Woo`03003ooooo06goo`<003Ooob8000?oo`8000?oo`8000?o
o`8000?oo`8000Coo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;o
o`05003oooooool00005ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool00`00oooo
o`02ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00oooo
o`02ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00oooo
o`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00oooo
o`03ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`03ool00`00oooo
o`02ool20005ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`04ool0
0`00ooooo`04ool00`00ooooo`04ool00`00ooooo`0aool00`00ooooo`06ool001Woo`03003ooooo
06[oo`<003coo`8000?oo`8000?oo`8000;oo`03003ooooo00;oo`04003oooooool20003ool00`00
ool0000a00000ooo003oo`04ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool00`00
ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00
ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00
ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool00`00
ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00
ooooo`04ool20004ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`03
ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`0aool00`00ooooo`06ool000?oo`8000Co
o`03003ooooo00;oo`<000Soo`03003ooooo06Ooo`<0047oo`l000?oo`8000?oo`8000;oo`8000;o
o`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;o
o`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003oo`0002l0
00;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo
00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo
00?oo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo
00?oo`03003ooooo00?oo`03003oo`0000?oo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo
00?oo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo033oo`03003ooooo
00Koo`000_oo00@00?ooool000_oo`03003ooooo00Goo`<006Goo`8004Koo`8000?oo`8000?ooaH0
00?oo`8000?oo`8000?oo`8000?oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03
003ooooo00;oo`03003ooooo00;oo`05003oooooool00005ool00`00ooooo`02ool00`00ooooo`02
ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02
ool00`00ool0000]0002ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00oooo
o`04ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool01000ool0
00000_oo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00<00?oo
ool01?oo00<00?ooool01?oo00<00?ooool0<?oo00<00?ooool01_oo0002ool01000ooooo`002ooo
00<00?ooool01Ooo00<00?ooool0H_oo0`00B_oo2`0000?oo`0000000ooo00<00?ooool00_oo00H0
0?ooooooo`00oolD00000ooo003oo`03ool00`00ooooo`02ool00`00ooooo`02ool01@00oooooooo
00001?oo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00_oo00<00?oo
ool00ooo00<00?ooool00_oo00D00?ooooooo`0000Goo`03003ooooo00;oo`03003ooooo00?oo`03
003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03
003ooooo00;oo`03003ooooo00?oo`03003oo`00034000;oo`07003oooooool00?oo00001_oo00<0
0?ooool01?oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool01?oo00<0
0?ooool0;ooo00<00?ooool01_oo0002ool01000ooooo`002?oo0`002?oo00<00?ooool0Gooo0`00
Cooo0P000ooo00<00?oo00002P000ooo0P000_oo0P000_oo00<00?ooool00_oo00<00?ooool00_oo
00<00?ooool00_oo00<00?oo00004`0000?oo`00ool00ooo00<00?ooool00_oo00<00?ooool00ooo
00D00?ooooooo`0000Coo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo
00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo
00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo
00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo
00?oo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo0380037oo`03003ooooo00Koo`000_oo
00@00?ooool000Soo`03003ooooo00Soo`03003ooooo05goo`8005Coo`H000;oo`8000;oo`03003o
o`0000l000?oo`8000?oo`03003ooooo00;oo`05003oooooool00004ool00`00ooooo`02ool00`00
ooooo`02ool00`00ool0000D00000ooo003oo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00
ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool00`00
ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00
ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00
ooooo`04ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00
ooooo`03ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`03ool00`00
ooooo`04ool00`00ooooo`04ool00`00ooooo`0_ool00`00ooooo`06ool000;oo`04003ooooo0008
ool00`00ooooo`08ool00`00ooooo`1Jool3001Iool<0002ool20003ool01P00oooooooo003oo`X0
0003ool00?oo00?oo`04003oooooool20003ool00`00ooooo`02ool00`00ooooo`02ool01@00oooo
oooo00001?oo00<00?ooool00_oo00<00?ooool00ooo00<00?oo0000500000?oo`00ool01?oo00<0
0?ooool00_oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00ooo00<0
0?ooool00_oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00ooo00<0
0?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<0
0?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool00ooo0P001Ooo00<00?ooool0
0ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool0
;_oo00<00?ooool01_oo0003ool20009ool40007ool00`00ooooo`1Gool3001Nool40003ool=0002
ool20002ool00`00ooooo`02ool00`00ool0000>00000ooo003oo`03ool01@00oooooooo00001?oo
00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00ooo00D00?ooooooo`0000Coo`03003ooooo
00?oo`03003ooooo00;oo`03003oo`0001D000;oo`03003ooooo00;oo`03003ooooo00?oo`03003o
oooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00;oo`03003o
oooo00?oo`03003ooooo00Coo`03003ooooo00;oo`03003ooooo00Coo`03003ooooo00?oo`03003o
oooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`04003oo`000003ool00`00
ooooo`04ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`04ool00`00
ooooo`0^ool00`00ooooo`06ool001Soo`04003oo`00001Dool3001Sool800000ooo00000003ool0
0`00ool0000400001?oo003ooooo0P000ooo00D00?ooooooo`0000Coo`03003ooooo00;oo`03003o
o`0000T00003ool00?oo00?oo`03003ooooo00;oo`05003oooooool00005ool00`00ooooo`02ool0
0`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool0
0`00ooooo`02ool00`00ooooo`03ool00`00ool0000@0002ool00`00ooooo`03ool00`00ooooo`03
ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`02
ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03
ool00`00ooooo`03ool01000ooooo`000ooo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool0
0ooo00<00?ooool01?oo00<00?ooool01?oo00<00?ooool0;Ooo00<00?ooool01_oo000Hool01@00
oooooooo0000DOoo0P00J?oo3`000_oo00<00?oo0000200000?oo`00ool00_oo0P000ooo00<00?oo
ool00_oo00D00?ooooooo`0000Coo`03003oo`0000h00003ool00?oo00Coo`05003oooooool00004
ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03
ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ool0000F
0002ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`03ool00`00oooo
o`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool01000oooo
oooo0P0000?oo`00ool01Ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool01?oo00<00?oo
ool01?oo00<00?ooool0;Ooo00<00?ooool01_oo000Hool00`00ooooo`1@ool3001/ool70002ool0
0`00ool000060002ool01P00oooooooo003oo`X00003ool00?oo00?oo`05003oooooool00004ool0
1@00oooooooo00001?oo00<00?ooool00_oo00<00?oo00002P0000?oo`00ool00ooo00<00?ooool0
0ooo00<00?ooool00_oo00D00?ooooooo`0000Goo`03003ooooo00;oo`03003ooooo00?oo`03003o
oooo00;oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003o
oooo00;oo`03003ooooo00?oo`03003oo`00018000;oo`03003ooooo00?oo`03003ooooo00?oo`03
003ooooo00?oo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00;oo`03
003oo`0000Goo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00?oo`03
003ooooo02koo`03003ooooo00Goo`006?oo00<00?ooool0COoo0`00LOoo0`0000?oo`0000001000
0_oo00<00?oo00001P000_oo00D00?ooooooo`0000Coo`03003oo`0000T00003ool00?oo00;oo`03
003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`05003oooooool00005ool00`00ool00009
0002ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00oooo
o`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00oooo
o`03ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool00`00oooo
o`03ool00`00ooooo`0B0003ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00
ooooo`03ool20006ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`04
ool00`00ooooo`0]ool00`00ooooo`05ool001Soo`03003ooooo04_oo`8007Koo`<000;oo`P000;o
o`03003oo`0000<00003ool00?oo00;oo`8000?oo`05003oooooool00004ool00`00ool000040000
0ooo003oo`03ool01@00oooooooo00001?oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool0
0_oo00<00?ooool00_oo00<00?oo00002P000_oo00<00?ooool00_oo00<00?ooool00ooo00<00?oo
ool00_oo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00ooo00<00?oo
ool00ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00ooo00<00?oo
ool01?oo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool06P000ooo00<0
0?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00<0
0?ooool0;Ooo00<00?ooool01Ooo000Hool00`00ooooo`18ool3001jool600000ooo003oo`070002
ool;00000ooo003oo`02ool00`00ooooo`02ool01P00oooooooo003oo`X00003ool00?oo00?oo`03
003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`05003oooooool00005ool00`00ooooo`02
ool00`00ool0000@00000ooo003oo`04ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`02
ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03
ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03
ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool01000oooooooo50000_oo00<00?oo
ool01?oo00<00?ooool01?oo00<00?ooool0;?oo00<00?ooool01Ooo000Hool30015ool3001oool8
0002ool00`00ool0000600000ooo003oo`03ool00`00ool0000400000ooo003oo`02ool00`00oooo
o`02ool01@00oooooooo00001?oo00<00?oo00002@000_oo00<00?ooool00_oo00D00?ooooooo`00
00Coo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo
00?oo`03003oo`0000X000;oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03003o
oooo00;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00Coo`03003o
oooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00Coo`03003o
oooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo008000;oo`03003ooooo00?oo`04
003ooooooolA000^ool00`00ooooo`05ool001Soo`03003ooooo04;oo`<008Coo`/000;oo`03003o
o`0000D000?oo`06003oooooool00?oo1@0000?oo`00ool00_oo00<00?ooool00_oo00<00?ooool0
0_oo00D00?ooooooo`0000Coo`03003oo`0000D00003ool00?oo00?oo`03003ooooo00;oo`03003o
oooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00?oo`03003o
oooo00;oo`03003ooooo00;oo`03003ooooo00/000;oo`03003ooooo00?oo`03003ooooo00?oo`03
003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03
003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03
003ooooo00?oo`03003ooooo00Coo`05003oooooool00002ool00`00ooooo`03ool00`00ooooo`03
ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`0/ool00`00ooooo`05ool001Soo`03003o
oooo043oo`8008Soo`D00003ool00?oo00@00003ool00?oo00;oo`H00003ool00?oo00;oo`06003o
ooooool00?oo1@0000?oo`00ool00ooo00D00?ooooooo`0000Coo`05003oooooool00005ool00`00
ool0000900000ooo003oo`04ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool00`00
ooooo`03ool01@00oooooooo00001Ooo00<00?ooool00ooo00D00?ooooooo`0000;oo``000;oo`03
003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00;oo`03
003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00?oo`03
003ooooo00?oo`03003ooooo00?oo`03003ooooo00;oo`<000Goo`03003ooooo00Coo`03003ooooo
00Coo`03003ooooo00?oo`03003ooooo02_oo`03003ooooo00Goo`006?oo00<00?ooool0?Ooo0`00
S?oo1`000_oo10000ooo00D00?ooool00?oo00D00003ool00?oo00;oo`06003oooooool00?oo2P00
00?oo`00ool00_oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00_oo
00<00?oo000010000_oo00<00?ooool00_oo00<00?ooool00ooo00D00?ooooooo`0000Goo`03003o
oooo00;oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00;oo`03003o
oooo00?oo`03003ooooo00`000;oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03
003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03
003ooooo00?oo`03003ooooo00Coo`03003ooooo00?oo`8000Goo`03003ooooo00?oo`03003ooooo
00Coo`03003ooooo00?oo`03003ooooo02_oo`03003ooooo00Goo`005ooo00<00?ooool0>ooo0`00
TOoo1`0000?oo`00ool0100000Goo`00ooooo`0000?oo`03003oo`0000<00003ool00?oo00?oo`05
003oooooool00004ool00`00ool0000400000ooo003oo`03ool00`00ooooo`02ool01@00oooooooo
00001?oo00<00?ooool00_oo00<00?oo00002P000_oo00<00?ooool00_oo00<00?ooool00ooo00D0
0?ooooooo`0000Goo`03003ooooo00?oo`05003oooooool00005ool00`00ooooo`03ool00`00oooo
o`02ool00`00ooooo`03ool00`00ooooo`0<0003ool00`00ooooo`02ool00`00ooooo`03ool00`00
ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`02ool00`00ooooo`04ool00`00
ooooo`03ool00`00ooooo`04ool20004ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`04
ool00`00ooooo`0Zool00`00ooooo`05ool001Ooo`03003ooooo03Woo`8009Koo`<00003ool00000
008000;oo`03003oo`0000800003ool00?oo00?oo`04003oooooool40003ool00`00ooooo`02ool0
1@00oooooooo00001?oo00<00?oo0000100000?oo`00ool01?oo00D00?ooooooo`0000Coo`05003o
ooooool00005ool00`00ooooo`02ool00`00ool0000500000ooo003oo`04ool00`00ooooo`02ool0
0`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool0
0`00ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`0<0003
ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03
ool00`00ooooo`03ool00`00ooooo`04ool00`00ool00004ool00`00ooooo`03ool00`00ooooo`04
ool00`00ooooo`03ool00`00ooooo`0Zool00`00ooooo`05ool001Ooo`03003ooooo03Koo`<009[o
o`800003ool00?oo00<00003ool00?oo00;oo`<000?oo`03003ooooo00;oo`03003oo`0000<00003
ool00?oo00;oo`03003ooooo00;oo`05003oooooool00004ool00`00ool000040002ool00`00oooo
o`02ool01@00oooooooo00001?oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00ooo00<0
0?oo00002P0000?oo`00ool01?oo00<00?ooool00ooo00D00?ooooooo`0000Goo`03003ooooo00?o
o`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00;o
o`03003ooooo00?oo`03003ooooo00d000;oo`03003ooooo00Coo`03003ooooo00;oo`03003ooooo
00Coo`03003ooooo00?oo`03003ooooo00Coo`04003oo`000002ool00`00ooooo`03ool00`00oooo
o`04ool00`00ooooo`03ool00`00ooooo`0[ool00`00ooooo`04ool001Ooo`<003?oo`<009koo`@0
00;oo`@000;oo`03003oo`0000<00003ool00?oo00;oo`06003oooooool00?oo1@0000?oo`00ool0
0ooo00D00?ooooooo`0000?oo`03003ooooo00;oo`03003oo`0000D00003ool00?oo00?oo`03003o
oooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003o
oooo00;oo`03003ooooo00D000;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00;oo`03
003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03
003ooooo00?oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`04003oooooool<0003
ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool01000oooooooo0P0000?oo`00ool0
1?oo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool0:_oo00<00?ooool01?oo000Gool00`00
ooooo`0`ool3002Rool500000ooo003oo`0300001_oo003ooooo003oo`D00003ool00?oo00;oo`06
003oooooool00?oo1@0000?oo`00ool00ooo00D00?ooooooo`0000?oo`03003ooooo00?oo`03003o
o`0000@00003ool00?oo00?oo`03003ooooo00?oo`05003oooooool00005ool01@00oooooooo0000
1Ooo00D00?ooooooo`0000;oo``00003ool00?oo00Coo`03003ooooo00?oo`03003ooooo00;oo`03
003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03
003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00d000?o
o`03003ooooo00Coo`03003ooooo00;oo`8000Goo`03003ooooo00Coo`03003ooooo00?oo`03003o
oooo02[oo`03003ooooo00Coo`005ooo00<00?ooool0;_oo0P00Yooo1P000_oo1@0000?oo`00ool0
0_oo00<00?oo00000`0000?oo`00ool00ooo00H00?ooooooo`00ool500000ooo003oo`03ool01@00
oooooooo00001?oo00<00?ooool00_oo00<00?oo00002@000_oo00<00?ooool00_oo00<00?ooool0
0_oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool0
0ooo00<00?ooool01@000_oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?oo
ool00_oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00_oo00<00?oo
ool00ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool01?oo00<00?oo
ool03P000_oo0P001Ooo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool0:Ooo00<00?ooool0
1?oo000Gool00`00ooooo`0[ool3002Zool300001_oo00000000ool000;oo`@000?oo`04003ooooo
ool40003ool00`00ooooo`02ool01P00oooooooo003oo`D00003ool00?oo00?oo`03003ooooo00;o
o`05003oooooool00004ool01@00oooooooo00000_oo1P0000?oo`00ool01?oo00D00?ooooooo`00
00Goo`05003oooooool00005ool00`00ooooo`03ool00`00ooooo`02ool00`00ool0000;0002ool0
0`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool0
0`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool0
0`00ooooo`04ool00`00ooooo`02ool00`00ooooo`04ool01000oooooooo3@000ooo00<00?ooool0
0ooo00<00?ooool0:Ooo00<00?ooool01?oo000Gool00`00ooooo`0Xool3002^ool30002ool40002
ool00`00ool0000200000ooo003oo`02ool00`00ooooo`0400000ooo003oo`02ool01@00oooooooo
00001?oo00<00?oo0000100000?oo`00ool01?oo00D00?ooooooo`0000?oo`03003ooooo00;oo`03
003ooooo00;oo`03003ooooo00D000;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;o
o`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00?o
o`03003ooooo00H000?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo
00;oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00;oo`03003ooooo
00?oo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00?oo`04003oo`00
0002ool01000oooooooo1`000ooo00<00?ooool0:?oo00<00?ooool01?oo000Gool00`00ooooo`0V
ool2002cool300000ooo003oo`0200000ooo003oo`02ool40003ool01P00oooooooo003oo`D00003
ool00?oo00;oo`05003oooooool00004ool00`00ool000040002ool00`00ooooo`02ool01@00oooo
oooo00000ooo00<00?ooool00ooo00D00?ooooooo`0000;oo`H00003ool00?oo00Coo`05003ooooo
ool00005ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool00`00
ooooo`02ool00`00ooooo`060003ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool0
0`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool0
0`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`04ool01000ooooo`000_oo
00<00?ooool00ooo00@00?ooooooo`@002[oo`03003ooooo00Coo`005ooo0`008ooo0`00]_oo1@00
0_oo0`000ooo00<00?oo00000P000_oo00D00?ooooooo`0000?oo`03003oo`0000<000;oo`05003o
ooooool00003ool00`00ooooo`02ool00`00ool0000500000ooo003oo`02ool00`00ooooo`02ool0
0`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`050002ool00`00ooooo`02
ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03
ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`0<0003ool00`00ooooo`02ool00`00oooo
o`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00oooo
o`04ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool01000oooooooo0`001_oo00<0
0?ooool00ooo00<00?ooool0:?oo00<00?ooool01?oo000Fool00`00ooooo`0Qool3002iool30000
0ooo00000002ool400000ooo003oo`02ool40003ool01@00oooooooo00001?oo10001?oo00D00?oo
ooooo`0000?oo`03003ooooo00;oo`03003ooooo00@000;oo`05003oooooool00005ool01@00oooo
oooo00001Ooo00D00?ooooooo`0000;oo`H00003ool00?oo00Coo`03003ooooo00?oo`03003ooooo
00;oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo
00;oo`03003ooooo00?oo`03003ooooo00H000?oo`03003ooooo00?oo`03003ooooo00?oo`03003o
oooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003o
oooo00Coo`03003ooooo00?oo`03003ooooo00?oo`8000Goo`03003ooooo00Coo`03003ooooo02Oo
o`03003ooooo00Coo`005_oo00<00?ooool07_oo0`00_Ooo00<00?oo00000_oo0`000_oo10000_oo
00<00?ooool0100000?oo`00ool00_oo00D00?ooooooo`0000;oo`@00003ool00?oo00;oo`03003o
oooo00;oo`03003ooooo00;oo`06003oooooool00?oo0`001?oo00<00?ooool00_oo00<00?ooool0
0_oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool01@000_oo00<00?oo
ool00ooo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00ooo00<00?oo
ool00_oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool03@000_oo00<0
0?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00<0
0?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo0P001Ooo00<00?ooool00ooo00<00?ooool0
9ooo00<00?ooool01?oo000Fool00`00ooooo`0Lool20031ool01P00ool00?oo003oo`800004ool0
0?ooool20002ool01P00oooooooo003oo`@000;oo`05003oooooool00003ool00`00ool000030002
ool01@00oooooooo00001?oo00<00?ooool00_oo00<00?ooool0100000?oo`00ool01?oo00D00?oo
ooooo`0000Goo`05003oooooool00005ool00`00ooooo`02ool00`00ool000050003ool00`00oooo
o`02ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool00`00oooo
o`02ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool01000oooo
oooo1P000ooo00<00?ooool00_oo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool00ooo00<0
0?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00@00?oo000000?oo`03003ooooo00Coo`03
003ooooo02Ooo`03003ooooo00?oo`005_oo00<00?ooool06Ooo0`00a?oo00D00?oo003oo`0000;o
o`03003oo`0000?oo`800005ool00?ooool00004ool40003ool01@00oooooooo00000ooo00<00?oo
00000P001?oo00<00?ooool00_oo00D00?ooooooo`0000?oo`03003ooooo00D000;oo`03003ooooo
00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo
00;oo`03003ooooo00H000;oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00;oo`03003o
oooo00?oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03003o
oooo00?oo`03003ooooo00?oo`03003ooooo00H000?oo`03003ooooo00?oo`03003ooooo00?oo`03
003ooooo00Coo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00Coo`04003ooooo0002ool0
0`00ooooo`04ool00`00ooooo`0Wool00`00ooooo`03ool001Koo`03003ooooo01Koo`<00<Ooo`H0
0005ool00000ool00002ool01000ool000000ooo00D00?ooooooo`0000;oo`<000;oo`05003ooooo
ool00003ool00`00ooooo`0400000ooo003oo`03ool00`00ooooo`02ool01@00oooooooo00001?oo
00<00?oo00001@0000?oo`00ool01?oo00D00?ooooooo`0000Goo`03003ooooo00;oo`03003ooooo
00;oo`03003ooooo00;oo`03003ooooo00H000;oo`03003ooooo00;oo`03003ooooo00?oo`03003o
oooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03003o
oooo00?oo`03003ooooo00Coo`03003ooooo00;oo`03003ooooo00d000?oo`03003ooooo00?oo`03
003ooooo00?oo`03003ooooo00Coo`03003ooooo00?oo`04003oooooool200000ooo003oo`05ool0
0`00ooooo`0Vool00`00ooooo`03ool000[oo`@000Soo`<001Coo`800<_oo`<00004ool00?ooool3
0003ool00`00ooooo`020002ool01@00oooooooo00000_oo00<00?oo00000P000ooo00D00?oooooo
o`0000?oo`03003ooooo00@000?oo`05003oooooool00003ool00`00ooooo`02ool00`00ooooo`02
ool00`00ooooo`050002ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool00`00oooo
o`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`050003ool00`00ooooo`02ool00`00
ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00
ooooo`04ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`04ool00`00
ooooo`070003ool00`00ooooo`02ool00`00ooooo`04ool00`00ooooo`04ool00`00ooooo`02ool2
0006ool00`00ooooo`0Vool00`00ooooo`03ool000coo`03003ooooo00Ooo`03003ooooo017oo`<0
0<koo`<00004ool00?oo0002ool01000ooooo`000ooo10000ooo00D00?ooooooo`0000;oo`<000;o
o`05003oooooool00003ool01P00oooooooo003oo`@000Coo`05003oooooool00004ool00`00oooo
o`02ool01@00oooooooo00000_oo1P0000?oo`00ool01?oo00<00?ooool00_oo00<00?ooool00_oo
00<00?ooool00_oo00<00?ooool00ooo00D00?ooooooo`0000;oo`H000?oo`03003ooooo00;oo`03
003ooooo00?oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03
003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00;oo`04
003oooooool60003ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`03ool20006ool00`00
ooooo`0Uool00`00ooooo`03ool000coo`03003ooooo00Ooo`03003ooooo00koo`<00=7oo`<00005
ool00000ool00002ool200001Ooo003ooooo00000_oo0`000_oo00@00?ooool000?oo`03003oo`00
008000?oo`05003oooooool00004ool01000oooooooo100000?oo`00ool00_oo00<00?ooool00_oo
00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool010000ooo00<00?ooool0
0_oo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool0
0_oo00<00?ooool01P000ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00ooo00<00?oo
ool00_oo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00_oo00<00?ooool00ooo00<00?oo
ool01?oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool01`000ooo00<00?ooool01?oo00<0
0?ooool00ooo0`000ooo0P009ooo00<00?ooool00ooo000<ool00`00ooooo`07ool00`00ooooo`0;
ool3003Eool01000ool00?oo0`000_oo00@00?oo000000?oo`05003ooooo003oo`030003ool01@00
oooooooo00000_oo0`000_oo00D00?ooooooo`0000?oo`03003ooooo00;oo`03003ooooo00@000;o
o`03003ooooo00;oo`03003ooooo00;oo`05003oooooool00005ool01P00oooooooo003oo`<00003
ool00?oo00?oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00?oo`05003oooooool00005
ool00`00ooooo`02ool00`00ooooo`060003ool00`00ooooo`02ool00`00ooooo`03ool00`00oooo
o`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00oooo
o`03ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`02ool01000oooooooo3P000ooo00<0
0?oo00000P000_oo00<00?ooool09?oo00<00?ooool00ooo000<ool00`00ooooo`07ool00`00oooo
o`09ool2003Hool50002ool01000ooooo`000_oo00@00?ooool000?oo`03003ooooo008000;oo`05
003oooooool00003ool00`00ool000020003ool00`00ooooo`02ool00`00ooooo`02ool01P00oooo
oooo003oo`<000Goo`05003oooooool00004ool00`00ooooo`02ool00`00ooooo`02ool01000oooo
oooo10000_oo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00_oo00<0
0?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool01P000ooo00<00?ooool00_oo
00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo
00<00?ooool01?oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool01?oo
00<00?ooool01?oo00<00?ooool01@0000?oo`0000000ooo0P009?oo00<00?ooool00ooo000:ool3
0008ool00`00ooooo`07ool3003Jool600001Ooo00000?oo00000_oo0`0000Goo`00ooooo`0000?o
o`<00003ool00?oo00;oo`05003oooooool00002ool30002ool01@00oooooooo00001?oo00<00?oo
ool00_oo00<00?ooool010000_oo00<00?ooool00_oo00D00?ooooooo`0000Goo`05003oooooool0
0004ool00`00ooooo`060002ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool00`00
ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`060003ool0
0`00ooooo`02ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool0
0`00ooooo`04ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool0
0`00ooooo`05ool00`00ooooo`03ool01@00oooooooo00000ooo0P008ooo00<00?ooool00ooo000<
ool00`00ooooo`06ool20005ool3003Mool60002ool40002ool01000ool000000ooo00H00?oooooo
o`00ool20003ool01@00oooooooo00000ooo00<00?oo00000P001?oo00<00?ooool00_oo00D00?oo
ooooo`0000?oo`03003ooooo00D000;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;o
o`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00D000?oo`03003ooooo00;oo`03003ooooo
00;oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo
00;oo`03003ooooo00H000?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003o
oooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00?oo`03003o
oooo00Coo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00@000;oo`80027oo`03003ooooo
00?oo`005Ooo00D00?oo00000?oo00800>3oo`L00005ool00?ooool00002ool01@00oooooooo0000
0_oo00D00?ooooooo`0000?oo`8000;oo`05003oooooool00003ool00`00ooooo`0400000ooo003o
o`03ool00`00ooooo`02ool01@00oooooooo00001?oo00H00?oo00000?oo0003ool00`00ooooo`02
ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool01@00oooooooo00000_oo1@000ooo
00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00ooo
00<00?ooool00ooo00<00?ooool00_oo00<00?ooool01`000ooo00<00?ooool00_oo00<00?ooool0
0ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool0
0ooo00<00?ooool01?oo00<00?ooool01Ooo00@00?ooooooo`D000?oo`03003ooooo00;oo`8001oo
o`03003ooooo00?oo`005Ooo00<00?oo00000P00h_oo0`0000Coo`00ool000;oo`04003ooooo0002
ool00`00ooooo`0300000ooo003oo`02ool01@00ooooo`00ool00`000ooo00D00?ooooooo`0000?o
o`03003ooooo00@000?oo`05003oooooool00003ool00`00ooooo`03ool00`00ooooo`040002ool0
0`00ooooo`02ool01@00oooooooo00001Ooo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool0
0_oo00<00?oo00000P0000?oo`00ool00ooo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool0
0ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00_oo00@00?oooooo
o`H000?oo`03003ooooo00;oo`03003ooooo00Coo`03003ooooo00?oo`03003ooooo00?oo`03003o
oooo00?oo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00Coo`@000Coo`8000?oo`@000;o
o`8001koo`03003ooooo00;oo`005Ooo0P00iOoo00D00?oo00000?oo00<00004ool00?ooool20000
0ooo003oo`02ool01000ool000000ooo00D00?ooooooo`0000;oo`<000;oo`05003oooooool00003
ool01P00oooooooo003oo`@000Coo`05003oooooool00004ool01@00oooooooo00000_oo10000ooo
00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00ooo00D00?ooooooo`0000Goo`04003ooooo
ool40002ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00
ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`060003ool0
0`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool0
0`00ooooo`04ool00`00ooooo`040002ool00`00ooooo`05ool30002ool20003ool2000Mool00`00
ooooo`02ool001Ooo`800>?oo`07003oo`00003oo`00ool00P0000Coo`00ooooo`@000;oo`05003o
ooooool00003ool01000ooooo`000ooo00<00?oo00000P000ooo00D00?ooooooo`0000Coo`04003o
ooooool30002ool01@00oooooooo00001Ooo00D00?ooooooo`0000?oo`03003oo`0000800003ool0
0?oo00;oo`03003ooooo00;oo`03003ooooo00?oo`05003oooooool00005ool00`00ooooo`02ool0
0`00ooooo`060002ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03
ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`04ool00`00ooooo`02ool00`00ooooo`07
0003ool00`00ooooo`02ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`04ool00`00oooo
o`03ool30007ool00`00ooooo`040002ool20003ool30002ool00`00ooooo`0Jool00`00ooooo`02
ool001Woo`<00>3oo`03003oo`0000800004ool00000ool20002ool01000ooooo`000ooo00<00?oo
ool00`0000?oo`00ool00_oo00D00?ooooooo`0000;oo`8000?oo`05003oooooool00003ool00`00
ooooo`02ool01P00ool00000ool000?oo`03003ooooo00;oo`05003oooooool00004ool01000oooo
oooo10000_oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00_oo00<0
0?ooool00ooo00<00?ooool00_oo00<00?ooool01@000ooo00<00?ooool00_oo00<00?ooool00ooo
00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo
00<00?ooool00_oo00@00?ooooooo`H000?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo
00Coo`03003ooooo00<000;oo`03003ooooo00Goo`<000Soo`<00003ool0000000?oo`8001[oo`03
003ooooo00;oo`007?oo0P00g_oo00H00?oo003oo`00ool20002ool20002ool01000ooooo`000_oo
00H00?ooooooo`00ool30002ool01@00oooooooo00000ooo0`0000?oo`00ool00_oo00<00?ooool0
0_oo00<00?ooool00_oo00<00?ooool00`000_oo00<00?ooool00_oo00<00?ooool00_oo00D00?oo
ooooo`0000Coo`03003ooooo00@000?oo`03003ooooo00?oo`05003oooooool00005ool00`00oooo
o`02ool00`00ooooo`03ool01@00oooooooo00000_oo1@000ooo00<00?ooool00ooo00<00?ooool0
0ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool0
0ooo00<00?ooool00ooo00<00?ooool01`000ooo00<00?ooool00_oo00<00?ooool01?oo0`001_oo
0P000_oo0`000_oo0P000ooo10000_oo00D00?ooooooo`0000?oo`8001Woo`03003ooooo00;oo`00
7_oo0`00fooo00<00?ooool00P0000Coo`00000000;oo`04003ooooo0002ool20002ool01000oooo
o`000ooo00D00?ooooooo`0000?oo`06003oooooool00?oo0`000ooo00D00?ooooooo`0000Coo`06
003oooooool00?oo0P0000?oo`00ool00ooo00D00?ooooooo`0000Coo`03003ooooo00;oo`06003o
ooooool00?oo0`0000?oo`00ool00ooo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00_oo
00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00_oo00<00?oo00000P0000?oo`00ool00ooo
00<00?ooool01?oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool01?oo00<00?ooool00_oo
00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00_oo00@00?ooooooo`H000?oo`03003oo`00
00<000;oo`8000Coo`D000Ooo`<000Ooo`03003ooooo00@000;oo`8001Ooo`03003ooooo00;oo`00
8Ooo0P00fOoo00L00?ooool00?oo003oo`020002ool200000ooo003oo`02ool40003ool00`00oooo
o`0300000ooo003oo`02ool01@00oooooooo00000ooo0P000_oo00D00?ooooooo`0000Coo`03003o
oooo00;oo`03003ooooo00<000?oo`05003oooooool00004ool00`00ooooo`02ool00`00ooooo`02
ool01000oooooooo10000ooo00D00?ooooooo`0000Coo`03003ooooo00?oo`03003ooooo00;oo`03
003ooooo00;oo`03003ooooo00?oo`04003oooooool40003ool00`00ooooo`03ool00`00ooooo`02
ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03
ool00`00ooooo`03ool00`00ooooo`04ool00`00ool000040008ool40004ool20003ool30002ool2
0004ool50003ool00`00ooooo`02ool2000Eool00`00ooooo`02ool002?oo`<00=Koo`07003ooooo
003oo`00ool00`000_oo0P0000Goo`00ooooo`0000;oo`8000;oo`06003oooooool00?oo0`000_oo
00D00?ooooooo`0000?oo`06003oo`00003oo`000ooo00<00?ooool00_oo00D00?ooooooo`0000?o
o`03003oo`0000800003ool00?oo00;oo`03003ooooo00;oo`05003oooooool00004ool00`00oooo
o`02ool00`00ooooo`050002ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00
ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`070003ool00`00ooooo`02ool0
0`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`04ool0
0`00ooooo`02ool00`00ooooo`05ool00`00ooooo`02ool20003ool40002ool00`00ooooo`05ool3
0007ool40004ool20003ool40002ool2000Cool00`00ooooo`02ool002Koo`800=Coo`07003ooooo
003oo`00ool00`000_oo00@00?oo000000;oo`05003oooooool00002ool01@00oooooooo00000ooo
00D00?ooooooo`0000?oo`05003oooooool00002ool30002ool00`00ooooo`02ool01@00oooooooo
00001?oo00@00?ooooooo`<000;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03
003ooooo00;oo`03003ooooo00;oo`06003oo`00003oo`001?oo00<00?ooool00ooo00<00?ooool0
0_oo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00_oo00@00?oooooo
o`D000?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03003o
oooo00Coo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00Coo`<000Ooo`03003ooooo00@0
00;oo`8000;oo`@000;oo`03003ooooo00Goo`<000;oo`8000?oo`8001;oo`03003ooooo00;oo`00
:?oo0`00dOoo00@00?ooooooo`@00005ool00?ooool00002ool20002ool00`00ooooo`020002ool0
1000ooooo`000ooo0`0000?oo`00ool00_oo00D00?ooooooo`0000?oo`06003oo`00003oo`001?oo
00D00?ooooooo`0000?oo`03003ooooo00;oo`06003oo`00003oo`001?oo00D00?ooooooo`0000Co
o`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00<000?oo`03003ooooo00?oo`03003ooooo
00;oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo
00?oo`03003oo`0000800003ool00?oo00?oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo
00Coo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00Goo`03003ooooo00<000;oo`8000Co
o`D000Ooo`<000Ooo`03003ooooo00@000;oo`8000?oo`<000;oo`03003ooooo00ooo`03003ooooo
00;oo`00:ooo0P00cooo00@00?ooooooo`@00003ool0000000;oo`04003ooooo0002ool01000oooo
oooo10000ooo00H00?ooooooo`00ool30003ool01000ooooo`001?oo00<00?ooool00P001?oo00D0
0?ooooooo`0000?oo`03003ooooo00?oo`03003ooooo00<000?oo`03003ooooo00;oo`05003ooooo
ool00004ool00`00ooooo`03ool01P00oooooooo003oo`<00003ool00?oo00?oo`03003ooooo00?o
o`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00Co
o`04003oooooool40003ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool00`00oooo
o`04ool00`00ooooo`03ool00`00ooooo`04ool30007ool40004ool20003ool30002ool20004ool5
0008ool300000ooo00000003ool2000@ool00`00ooooo`01ool002goo`<00<coo`04003oooooool3
00001?oo003oo`000_oo00<00?ooool00P000_oo00@00?ooool000;oo`8000;oo`05003oooooool0
0003ool01@00oooooooo00000ooo00D00?ooooooo`0000?oo`<000;oo`03003ooooo00;oo`05003o
ooooool00004ool01P00oooooooo003oo`<00003ool00?oo00;oo`03003ooooo00;oo`03003ooooo
00;oo`03003ooooo00;oo`03003ooooo00;oo`04003oooooool40003ool00`00ooooo`02ool00`00
ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`04ool00`00
ooooo`02ool00`00ooooo`060003ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`04ool0
0`00ooooo`03ool00`00ooooo`040002ool20002ool40002ool00`00ooooo`05ool30007ool40004
ool20003ool40002ool20002ool00`00ool00003000?ool00`00ooooo`01ool0033oo`800<[oo`06
003oooooool00?oo0`0000Goo`00003oo`0000?oo`800005ool00?ooool00003ool01@00oooooooo
00000_oo00@00?ooooooo`<00003ool00?oo00;oo`05003oooooool00004ool01P00ool00000ool0
00?oo`05003oooooool00004ool00`00ooooo`02ool01000oooooooo0`000_oo00<00?ooool00_oo
00<00?ooool00_oo00<00?ooool00ooo00D00?ooooooo`0000Coo`03003ooooo00D000?oo`03003o
oooo00;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03003o
oooo00?oo`03003ooooo00;oo`03003ooooo00D000?oo`03003ooooo00Coo`03003ooooo00Coo`03
003ooooo00D000Ooo`<000Ooo`8000;oo`<000;oo`8000?oo`<000;oo`03003ooooo00Goo`<000Oo
o`H000?oo`8000goo`03003ooooo007oo`00<_oo0P00bOoo00D00?ooool00?oo00<00005ool00000
ool00003ool01000ool000000ooo00<00?ooool00P000_oo00D00?ooooooo`0000?oo`03003oo`00
008000?oo`05003oooooool00003ool01000oooooooo0`000_oo00D00?ooooooo`0000Goo`05003o
ooooool00004ool01P00ool00000ool000Coo`05003oooooool00005ool00`00ooooo`02ool00`00
ooooo`02ool00`00ooooo`02ool00`00ool0000200000ooo003oo`03ool00`00ooooo`02ool00`00
ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00
ooooo`02ool00`00ool0000200000ooo003oo`04ool00`00ooooo`03ool40004ool20003ool30002
ool20005ool50007ool30006ool20002ool30002ool20003ool30002ool01@00oooooooo00000ooo
0P003?oo00<00?ooool00Ooo000dool30036ool00`00ooooo`0300001?oo003ooooo0P0000Goo`00
ooooo`0000;oo`8000;oo`04003oooooool40003ool01@00oooooooo00000ooo00D00?ooooooo`00
00?oo`05003oooooool00004ool01P00ool00000ool000?oo`03003ooooo00;oo`05003oooooool0
0005ool00`00ooooo`030003ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool00`00
ooooo`02ool00`00ooooo`03ool01000oooooooo0`000ooo00<00?ooool00ooo00<00?ooool00_oo
00<00?ooool00_oo00<00?ooool01?oo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00ooo
00@00?ooooooo`D000?oo`03003oo`00008000;oo`03003ooooo00Goo`<000Ooo`D000Coo`8000;o
o`@000;oo`8000Coo`D000Ooo`<000Koo`8000;oo`<000;oo`8000[oo`03003ooooo007oo`00=ooo
0P00a?oo00<00?ooool00`0000Koo`00ooooo`00ool20002ool01@00oooooooo00000_oo00D00?oo
ooooo`0000;oo`8000;oo`05003oooooool00003ool300000ooo003oo`02ool00`00ooooo`02ool0
0`00ooooo`02ool00`00ooooo`020003ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02
ool01P00oooooooo003oo`<00003ool00?oo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003o
oooo00;oo`03003ooooo00?oo`03003ooooo00;oo`03003oo`0000800003ool00?oo00?oo`03003o
oooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03003o
oooo00?oo`03003ooooo00?oo`03003ooooo00D000Koo`8000;oo`<000;oo`8000?oo`<000;oo`03
003ooooo00Goo`<000Ooo`D000Coo`8000;oo`@000;oo`8000Coo`D000;oo`8000?oo`8000Soo`03
003ooooo007oo`00>Ooo0`00`Ooo00<00?ooool00`0000Goo`00003oo`0000;oo`05003oooooool0
0002ool200000ooo003oo`02ool01@00oooooooo00000ooo00D00?ooooooo`0000?oo`03003oo`00
008000?oo`05003oooooool00004ool01000oooooooo0`0000?oo`00ool01?oo00D00?ooooooo`00
00Coo`03003ooooo00;oo`04003oooooool30002ool00`00ooooo`03ool00`00ooooo`02ool00`00
ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool01000oooooooo10000ooo00<00?ooool00_oo
00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00ooo
00<00?ooool00ooo00<00?ooool00ooo0P001?oo1@001ooo0`001_oo0P000_oo0`000_oo0P000ooo
0`000_oo00<00?ooool01Ooo0`001ooo1@001?oo0P000_oo10000_oo0P001_oo00<00?ooool00Ooo
000lool2002oool00`00ooooo`030002ool00`00ool00002ool20002ool02000ooooo`00ool00?oo
0002ool01000oooooooo0P000_oo00D00?ooooooo`0000?oo`05003oooooool00003ool01@00oooo
oooo00001?oo00<00?ooool00_oo00<00?oo00000P001?oo00D00?ooooooo`0000Goo`05003ooooo
ool00004ool01P00ool00000ool000Coo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;o
o`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00D000?oo`03003ooooo00?oo`03003ooooo
00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo
00Goo`@000Coo`8000?oo`<000;oo`8000Coo`D000Ooo`<000Koo`8000;oo`<000;oo`8000?oo`<0
00;oo`8000Coo`D000;oo`8000?oo`8000Goo`03003ooooo007oo`00?_oo0`00_?oo00<00?ooool0
0`000_oo00<00?oo00000ooo00@00?ooool000?oo`800003ool00?oo00;oo`04003oooooool40003
ool01@00oooooooo00000ooo0`0000?oo`00ool00_oo00<00?ooool00ooo00D00?ooooooo`0000?o
o`8000?oo`05003oooooool00005ool01@00oooooooo00001Ooo00<00?ooool00`000ooo00<00?oo
ool00_oo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00ooo00<00?oo
ool00_oo00<00?oo00000P0000?oo`00ool00ooo00<00?ooool00ooo00<00?ooool00_oo00<00?oo
ool00ooo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool010000_oo00<00?ooool01Ooo0`00
1ooo10001?oo0P000ooo0`000_oo0P001?oo1@001ooo0`001ooo10001?oo0P000ooo0`000_oo0P00
0ooo00<00?ooool00Ooo0011ool2002jool00`00ooooo`030002ool01000ooooo`000_oo0P0000?o
o`00ool00_oo00@00?oo000000?oo`05003oooooool00002ool20002ool01@00oooooooo00001?oo
00<00?oo00000P000ooo00<00?ooool00_oo00D00?ooooooo`0000?oo`03003oo`0000800003ool0
0?oo00;oo`03003ooooo00;oo`05003oooooool00005ool01P00oooooooo003oo`<00003ool00?oo
00?oo`05003oooooool00005ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00
ooooo`02ool30003ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03
ool00`00ooooo`03ool30007ool00`00ooooo`040002ool20002ool40002ool00`00ooooo`05ool3
0007ool40004ool20002ool40002ool20002ool40002ool00`00ooooo`05ool300000ooo00000004
ool200000ooo003oo`02ool004?oo`<00;Ooo`06003ooooo003oo`000_oo0P0000Coo`00ooooo`80
00;oo`04003ooooo0002ool20002ool01@00oooooooo00000ooo00D00?ooooooo`0000?oo`05003o
ooooool00003ool01@00oooooooo00001?oo00D00?ooooooo`0000Coo`04003oooooool20003ool0
0`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool01000oooooooo0`00
0ooo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool0
0ooo00<00?ooool00_oo00<00?oo00000P0000?oo`00ool00ooo00<00?ooool00ooo00<00?ooool0
0ooo00<00?ooool01?oo00<00?oo00000P000_oo0P001?oo1@001ooo0`001ooo00<00?ooool01000
0_oo0P000_oo10000_oo0P000ooo1@001ooo0`001ooo00<00?ooool010000_oo0P000_oo10000_oo
00<00?oo00000_oo0016ool2002eool01P00ooooo`00ool000;oo`800009ool00?ooool00?oo003o
o`0000;oo`05003oooooool00003ool01000ooooo`000ooo0P000_oo00D00?ooooooo`0000?oo`04
003oooooool300000ooo003oo`03ool00`00ooooo`02ool01@00oooooooo00001?oo0`0000?oo`00
ool01?oo00D00?ooooooo`0000Coo`03003ooooo00;oo`03003ooooo00;oo`03003oo`0000800003
ool00?oo00;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00?oo`03
003ooooo00?oo`04003oooooool40003ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03
ool30007ool40004ool20003ool30002ool20004ool50007ool30007ool40004ool20003ool30002
ool20004ool50007ool300000ooo00000004ool20002ool004Soo`<00;;oo`05003ooooo003oo`02
00000ooo003oo`020003ool01000ool000000ooo00<00?ooool00P000_oo00D00?ooooooo`0000;o
o`03003oo`00008000?oo`05003oooooool00003ool00`00ooooo`030004ool01@00oooooooo0000
0ooo00<00?ooool00_oo00<00?ooool00`001?oo00D00?ooooooo`0000Goo`05003oooooool00004
ool00`00ooooo`02ool30002ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00
ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`050003ool00`00ooooo`04ool0
0`00ool000020002ool20003ool30002ool20004ool50007ool40004ool20003ool30002ool20003
ool30002ool00`00ooooo`05ool30007ool40004ool20003ool30002ool20002ool60002ool004_o
o`800;3oo`05003ooooo003oo`0200001_oo003oo`00ool000;oo`04003ooooo0003ool02000oooo
o`00ool00?oo0003ool01@00oooooooo00000_oo0P000ooo00D00?ooooooo`0000?oo`05003ooooo
ool00004ool01@00oooooooo00000ooo00<00?ooool00ooo00@00?ooooooo`8000?oo`03003ooooo
00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`06003oo`00
003oo`001?oo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00ooo00<0
0?ooool00ooo00<00?ooool00ooo100000Coo`00ooooo`D000Ooo`<000Ooo`@000Coo`8000?oo`<0
00;oo`8000Coo`D000Ooo`<000Koo`8000;oo`<000;oo`8000;oo`@000;oo`8000Coo`D000Koo`H0
00;oo`40007oo`7oo`00COoo0`00[Ooo00@00?ooooooo`<000;oo`800005ool00?ooool00002ool2
0002ool01P00oooooooo003oo`8000?oo`05003oooooool00003ool01@00oooooooo00000ooo00D0
0?ooooooo`0000?oo`<000;oo`03003ooooo00;oo`05003oooooool00004ool01P00oooooooo003o
o`<00003ool00?oo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo
00;oo`04003oooooool30003ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00
ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool01000oooooooo10001?oo0P000ooo0`000_oo
0P000ooo0`000_oo00<00?ooool01Ooo0`001ooo10001?oo0P000ooo0`000_oo0P001?oo1@001_oo
0`001ooo1@001?oo0P000_oo0`001_oo0`000_oo001@ool2002[ool01000oooooooo0`000_oo00@0
0?oo000000;oo`05003oooooool00002ool01@00oooooooo00000_oo0P000_oo00D00?ooooooo`00
00?oo`8000;oo`05003oooooool00003ool00`00ooooo`02ool01P00ool00000ool000?oo`05003o
ooooool00004ool01@00oooooooo00001?oo0P000ooo00<00?ooool00_oo00<00?ooool00_oo00<0
0?ooool00_oo00<00?ooool00ooo00H00?ooooooo`00ool300000ooo003oo`03ool00`00ooooo`02
ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`02
ool20004ool50007ool30006ool20002ool30002ool20003ool30002ool20004ool50006ool50004
ool20002ool30002ool20003ool30002ool00`00ooooo`05ool3000:ool20002ool005;oo`<00:So
o`07003oooooool00?oo00000_oo00@00?oo000000;oo`04003oooooool200000ooo003oo`02ool0
1@00oooooooo00000ooo00@00?ooool000?oo`03003oo`00008000?oo`05003oooooool00004ool0
1000oooooooo0P000ooo00D00?ooooooo`0000Coo`03003ooooo00;oo`03003ooooo00;oo`<00003
ool00?oo00Coo`03003ooooo00;oo`05003oooooool00005ool00`00ooooo`02ool01000oooooooo
0P001?oo00<00?ooool00ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00ooo00<00?oo
ool01?oo00<00?ooool00ooo10001?oo0P000ooo0`000_oo0P001?oo1@001ooo0`001_oo1@001?oo
0P000_oo0`000_oo0P001?oo1@001ooo0`001_oo0P000_oo0`002Ooo10001?oo001Eool2002Vool0
1`00oooooooo003oo`0000;oo`04003ooooo0002ool01000oooooooo0P000_oo00@00?ooool000?o
o`8000;oo`05003oooooool00003ool00`00ooooo`020003ool01@00oooooooo00000ooo00<00?oo
ool00_oo0`0000?oo`00ool00_oo00<00?ooool00ooo00D00?ooooooo`0000Coo`03003ooooo00<0
00Coo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo
00;oo`<000;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00Coo`03003ooooo00?oo`03
003ooooo00?oo`03003ooooo00<000;oo`8000Coo`D000Ooo`@000Coo`8000;oo`@000;oo`8000;o
o`<000;oo`03003ooooo00Goo`<000Ooo`@000Coo`8000?oo`<000;oo`8000Coo`D000Soo`@000So
o`00Eooo0`00Xooo00L00?ooooooo`00ool00002ool00`00ooooo`020002ool02000ooooo`00ool0
0?oo0002ool02@00oooooooo003oo`00ool00003ool01@00oooooooo00000ooo00D00?ooooooo`00
00?oo`05003oooooool00004ool00`00ooooo`030003ool00`00ooooo`02ool01@00oooooooo0000
1Ooo00D00?ooooooo`0000Coo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003o
oooo00;oo`03003ooooo00?oo`06003oo`00003oo`001?oo00<00?ooool00ooo00<00?ooool00ooo
00<00?ooool00ooo00<00?ooool00ooo0`001ooo10001?oo0P000ooo0`000_oo0P000ooo1@001ooo
0`001_oo0P000_oo0`000_oo0P000ooo0`000_oo0P001?oo1@001_oo1@002Ooo10003?oo001Jool2
002Qool01`00oooooooo003oo`0000;oo`05003oooooool00002ool01000oooooooo0P0000?oo`00
ool00_oo00H00?ooooooo`00ool20003ool01@00oooooooo00000ooo0P000_oo00D00?ooooooo`00
00Coo`03003ooooo00;oo`05003oooooool00003ool00`00ooooo`02ool01@00oooooooo00001Ooo
00@00?ooooooo`<000;oo`03003ooooo00?oo`05003oooooool00005ool01@00oooooooo00001Ooo
00@00?ooooooo`<000?oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00Coo`03003oo`00
008000;oo`8000?oo`<000;oo`03003ooooo00Goo`<000Koo`@000Coo`8000?oo`<000;oo`8000Co
o`D000Ooo`<000Koo`D000Coo`8000;oo`<000[oo`@0013oo`00G?oo0`00W_oo00L00?ooooooo`00
ool00002ool01@00oooooooo00000_oo00H00?ooooooo`00ool20003ool01@00oooooooo00000_oo
0P000_oo00D00?ooooooo`0000?oo`03003oo`00008000?oo`03003ooooo00;oo`03003ooooo00;o
o`04003oooooool20002ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool00`00oooo
o`02ool01P00ool00000ool000Coo`05003oooooool00005ool00`00ooooo`02ool00`00ooooo`02
ool00`00ooooo`02ool00`00ool0000200000ooo003oo`03ool00`00ooooo`04ool00`00ooooo`05
0007ool30006ool20002ool30002ool20002ool30002ool20004ool50007ool40004ool20003ool3
0002ool20002ool30002ool00`00ooooo`05ool30009ool4000Dool005ooo`8009coo`06003ooooo
ool00?oo0P0000?oo`00ool00_oo00@00?ooool000?oo`03003ooooo008000;oo`05003oooooool0
0003ool01@00oooooooo00000ooo00D00?ooooooo`0000;oo`8000?oo`05003oooooool00004ool0
1P00oooooooo003oo`<000Goo`05003oooooool00004ool00`00ooooo`02ool01000oooooooo0`00
0ooo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool0
0_oo00@00?ooooooo`<000?oo`03003ooooo00?oo`@000Coo`8000?oo`<000;oo`8000Coo`D000Ko
o`<000Ooo`@000Coo`8000?oo`<000;oo`8000Coo`D000Koo`<000Koo`8000;oo`<000Soo`@001So
o`00HOoo0`00VOoo00D00?ooooooo`0000;oo`03003oo`0000?oo`800003ool00?oo00;oo`03003o
oooo008000;oo`05003oooooool00003ool20002ool01@00oooooooo00000ooo00D00?ooooooo`00
00?oo`03003ooooo00;oo`05003oooooool00004ool00`00ooooo`020004ool01@00oooooooo0000
1Ooo00D00?ooooooo`0000Coo`03003oo`0000800003ool00?oo00;oo`03003ooooo00;oo`03003o
oooo00;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`@00003ool00?oo00<000;o
o`8000Coo`D000Ooo`@000Coo`8000;oo`<000;oo`8000?oo`<000;oo`8000Coo`D000Koo`D000Co
o`8000;oo`<000;oo`8000Coo`D000Ooo`@001coo`00I?oo0P00Uooo00D00?ooooooo`0000;oo`03
003oo`0000?oo`800003ool00?oo00;oo`05003oooooool00002ool01@00oooooooo00000ooo00D0
0?oo003oo`0000?oo`05003oooooool00003ool20002ool00`00ooooo`02ool00`00ooooo`02ool0
1@00oooooooo00000ooo00<00?ooool00_oo00D00?ooooooo`0000Goo`05003oooooool00004ool0
0`00ooooo`02ool20003ool00`00ooooo`03ool00`00ooooo`02ool00`00ooooo`02ool00`00oooo
o`03ool00`00ooooo`02ool01000oooooooo0`001ooo10001?oo0P000ooo0`000_oo0P000ooo1@00
1ooo0`001ooo10001?oo0P000_oo0`000_oo0P001?oo1@001ooo10002?oo10008?oo001Vool3002D
ool01@00oooooooo00000_oo00@00?ooool000;oo`05003oo`00ool00002ool01000oooooooo0P00
0_oo00@00?ooool000?oo`05003oo`00ool00003ool01@00oooooooo00000ooo00<00?oo00000P00
1?oo00<00?ooool00_oo00D00?ooooooo`0000?oo`<000;oo`03003ooooo00;oo`03003ooooo00;o
o`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`<00003ool00?oo00Coo`03003ooooo
00;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00;oo`8000?oo`<0
00;oo`8000Coo`D000Koo`@000Coo`8000?oo`<000;oo`8000?oo`<000;oo`8000?oo`D000Ooo`@0
00Coo`8000?oo`<000Woo`<002Coo`00JOoo0P00T_oo00D00?ooooooo`0000;oo`04003ooooo0002
ool01@00ool00?oo00000_oo00@00?ooooooo`8000;oo`05003oooooool00003ool01@00ool00?oo
00000_oo00D00?ooooooo`0000Coo`03003ooooo008000Coo`05003oooooool00003ool01@00oooo
oooo00000_oo0P0000?oo`00ool00_oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00_oo
00<00?ooool00ooo00<00?oo00000P001?oo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool0
0ooo00<00?ooool00ooo00<00?ooool00ooo0`001ooo10001?oo0P000_oo0`000_oo0P001?oo1@00
1ooo0`001_oo10001?oo0P000ooo0`000_oo0P001?oo1@002?oo10009ooo001[ool2002@ool01@00
oooooooo00000_oo00@00?ooool000;oo`05003oo`00ool00003ool02000ooooo`00ool00?oo0003
ool01@00oooooooo00000_oo0P000ooo00D00?ooooooo`0000?oo`05003oooooool00004ool01@00
oooooooo00000ooo00<00?ooool00_oo00@00?ooooooo`8000?oo`03003ooooo00;oo`03003ooooo
00;oo`03003ooooo00;oo`03003ooooo00?oo`05003oooooool00004ool00`00ooooo`03ool00`00
ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`030002ool20003ool30002ool2
0003ool50007ool40004ool20003ool30002ool20002ool30002ool00`00ooooo`05ool30007ool4
0009ool4000[ool006goo`<008goo`05003oooooool00002ool01000ooooo`000_oo00<00?ooool0
0P000ooo00P00?ooool00?oo003oo`000ooo00D00?ooooooo`0000?oo`05003oooooool00003ool0
1@00oooooooo00000ooo0`000_oo00D00?ooooooo`0000Coo`05003oooooool00004ool300000ooo
003oo`04ool01@00oooooooo00001?oo00<00?ooool00ooo00@00?ooooooo`<000?oo`03003ooooo
00;oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00D000Ooo`<000Koo`@000Coo`8000?o
o`<000;oo`8000Coo`D000Koo`<000Koo`8000;oo`<000;oo`8000;oo`@000Woo`@002ooo`00L?oo
0P00Rooo00D00?ooooooo`0000;oo`800003ool00?oo00;oo`04003oo`000003ool01000ooooo`00
0_oo0P000ooo00D00?ooooooo`0000?oo`8000;oo`05003oooooool00003ool01@00oooooooo0000
0_oo00<00?oo00001?oo00D00?ooooooo`0000?oo`03003ooooo00;oo`03003ooooo00<000Coo`03
003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`06003oo`00003oo`00
1?oo00<00?ooool00ooo00<00?ooool00_oo10001?oo0P000ooo0`000_oo0P000ooo0P000_oo0P00
1?oo1@001ooo10001?oo0P000_oo0`000_oo0P001?oo1@001_oo0`002Ooo1000<ooo001bool30028
ool01@00oooooooo00000_oo0P0000?oo`00ool00_oo00@00?ooool000?oo`05003oooooool00002
ool20002ool01@00oooooooo00000ooo00D00?oo003oo`0000?oo`05003oooooool00004ool00`00
ooooo`030003ool01@00oooooooo00000ooo00<00?ooool00ooo00D00?ooooooo`0000Coo`03003o
oooo00;oo`03003ooooo00;oo`03003ooooo00?oo`05003oooooool00003ool30003ool00`00oooo
o`04ool01000ool000000_oo0P001?oo1@001ooo0`001_oo10001?oo0P000ooo0`000_oo0P000ooo
1@001ooo10001?oo0P000_oo0`002?oo1000=ooo001eool20026ool01@00oooooooo00000_oo0P00
00?oo`00ool00_oo00<00?ooool00P000_oo00D00?ooooooo`0000;oo`8000?oo`04003ooooo0003
ool01P00ooooo`00ool000;oo`03003ooooo00;oo`05003oooooool00004ool01@00oooooooo0000
0ooo00<00?ooool00_oo00<00?ooool00_oo00@00?ooooooo`<000;oo`03003ooooo00;oo`03003o
oooo00;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00;oo`@00004ool00?ooool50006
ool40004ool20003ool30002ool20002ool30002ool20004ool50006ool40004ool20003ool30002
ool20003ool50007ool4000kool007Ooo`<008?oo`05003oooooool00002ool200000ooo003oo`02
ool01@00oooooooo00000_oo00D00?ooooooo`0000?oo`05003oooooool00003ool01@00oooooooo
00000_oo0P000ooo00D00?ooooooo`0000?oo`03003ooooo00;oo`8000;oo`05003oooooool00004
ool00`00ooooo`02ool00`00ooooo`02ool00`00ool00002ool00`00ooooo`02ool01@00oooooooo
00001Ooo00<00?ooool00_oo00<00?ooool00_oo00@00?ooooooo`@000Coo`8000;oo`<000;oo`80
00Coo`D000Koo`<000Ooo`@000Coo`8000;oo`<000;oo`8000Coo`D000Koo`@000Soo`@003ooo`00
N_oo0P00POoo00D00?ooooooo`0000?oo`03003oo`0000?oo`05003oooooool00002ool01@00oooo
oooo00000ooo0P000_oo00D00?ooooooo`0000?oo`05003oooooool00003ool01@00oooooooo0000
0ooo00<00?ooool00_oo00H00?oo00000?oo0003ool01@00oooooooo00001?oo00<00?ooool00_oo
00<00?ooool00`001?oo00D00?ooooooo`0000Goo`03003ooooo00;oo`03003ooooo00?oo`03003o
oooo00;oo`8000Coo`@000Ooo`@000Coo`8000?oo`8000;oo`8000?oo`<000;oo`8000Coo`@000Oo
o`@000Coo`8000;oo`<000Soo`@004?oo`00O?oo0`00O_oo00D00?ooooooo`0000?oo`<000?oo`05
003oooooool00002ool01@00oooooooo00000ooo0P000_oo00D00?ooooooo`0000?oo`04003ooooo
ool20002ool01@00oooooooo00000ooo00<00?ooool00_oo00@00?ooooooo`8000?oo`05003ooooo
ool00004ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool00`00
ooooo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`03ool40003ool20003ool30002
ool20004ool50004ool50007ool40003ool20003ool30002ool20004ool40008ool30017ool007oo
o`8007coo`05003oooooool00003ool30003ool01000oooooooo0P000_oo00@00?ooool000?oo`05
003oo`00ool00003ool01@00oooooooo00000ooo00D00?oo003oo`0000?oo`05003oooooool00005
ool01@00oooooooo00000ooo00<00?ooool00_oo00<00?ooool00_oo00D00?ooooooo`0000Coo`<0
00;oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo
00<000;oo`8000Coo`@000Ooo`@000Goo`@000Coo`8000?oo`<000;oo`8000?oo`D000Ooo`@000So
o`@004[oo`00POoo0`00NOoo00D00?ooooooo`0000?oo`800005ool00?ooool00003ool20002ool0
1000ooooo`000ooo00<00?ooool00P000ooo00D00?ooooooo`0000?oo`05003oo`00ool00003ool0
0`00ooooo`02ool00`00ooooo`02ool01000oooooooo0P000_oo00<00?ooool00_oo00<00?ooool0
0_oo00<00?ooool00_oo00<00?ooool00_oo00H00?oo00000?oo0003ool00`00ooooo`03ool00`00
ooooo`03ool00`00ooooo`050007ool40003ool20003ool30002ool20003ool20002ool20004ool5
0006ool40004ool20003ool30008ool4001>ool008Coo`8007Ooo`05003oooooool00003ool20000
1Ooo003ooooo00000ooo00D00?oo003oo`0000;oo`05003oooooool00003ool20002ool01@00oooo
oooo00001?oo00D00?oo003oo`0000?oo`05003oooooool00004ool02@00oooooooo003oo`00ool0
0004ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool01000oooooooo0P000ooo00<0
0?ooool00ooo00<00?ooool00_oo10001?oo0P000ooo0`000_oo0P000ooo1@001ooo0`001_oo1000
1?oo0P000_oo0`000_oo0P001?oo1@001ooo1000D_oo0026ool3001dool01@00oooooooo00000ooo
0P0000Goo`00ooooo`0000?oo`05003oo`00ool00002ool01@00oooooooo00000ooo0P000ooo00@0
0?ooool000Coo`03003ooooo008000?oo`05003oooooool00004ool00`00ooooo`02ool01@00ool0
0?oo00000ooo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00ooo0P00
0_oo00<00?ooool00ooo00@00?oo000000;oo`8000Coo`D000Koo`@000Coo`8000?oo`<000;oo`80
00;oo`<000;oo`8000Coo`@000Ooo`@000Soo`@005Koo`00ROoo0P00L_oo00D00?ooooooo`0000?o
o`04003oo`000002ool00`00ooooo`02ool200001Ooo003ooooo00001?oo00D00?ooooooo`0000?o
o`05003oooooool00003ool01@00oooooooo00000ooo00D00?ooooooo`0000Coo`03003ooooo00;o
o`03003ooooo008000Coo`05003oooooool00005ool00`00ooooo`02ool00`00ooooo`02ool00`00
ool000020002ool50006ool40004ool20003ool20002ool20004ool50005ool40007ool40003ool2
0003ool30008ool4001Jool008_oo`<006ooo`05003oooooool00003ool01000ool000000_oo00<0
0?ooool00_oo00@00?oo000000;oo`03003ooooo00;oo`04003oooooool20002ool01@00oooooooo
00000ooo00@00?ooooooo`8000;oo`05003oooooool00004ool00`00ooooo`02ool01@00oooooooo
00001?oo00D00?ooooooo`0000Goo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00<000Co
o`8000?oo`8000;oo`8000Coo`D000Koo`@000Goo`D000?oo`8000?oo`<000;oo`8000?oo`D000Oo
o`@005koo`00S_oo0P00KOoo00D00?ooooooo`0000?oo`04003oo`000002ool00`00ooooo`02ool0
1000ool000000_oo00<00?ooool00_oo00@00?ooooooo`8000;oo`05003oooooool00003ool02@00
oooooooo003oo`00ool00003ool00`00ooooo`03ool01@00oooooooo00000ooo0`000_oo00<00?oo
ool00_oo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo00@00?ooooooo`8000Coo`D0
00Koo`@000Coo`8000;oo`<000;oo`8000?oo`<000;oo`8000?oo`D000Koo`@000Soo`@006;oo`00
T?oo0`00J_oo00D00?ooooooo`0000?oo`04003oo`000002ool00`00ooooo`02ool00`00ooooo`02
0002ool01@00oooooooo00000ooo00D00?oo003oo`0000?oo`05003oooooool00004ool01@00ool0
0?oo00000ooo00<00?ooool00_oo00D00?ooooooo`0000Coo`05003oo`00ool00004ool00`00oooo
o`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool40004ool20002ool30002ool2
0004ool40005ool50006ool40004ool20003ool20009ool3001Vool009?oo`8006Soo`03003ooooo
00;oo`05003ooooo003oo`020003ool01@00oooooooo00000_oo0P000_oo00D00?ooooooo`0000Co
o`800003ool00?oo00;oo`05003oooooool00004ool00`00ooooo`020003ool00`00ooooo`02ool0
0`00ooooo`02ool01@00oooooooo00000_oo0`000ooo00<00?ooool00ooo00<00?ooool00_oo00<0
0?ooool00ooo00<00?ooool00P000_oo0P001?oo10001ooo10001?oo1@001?oo0P000ooo0P000_oo
0P001?oo1@001ooo1000JOoo002Eool3001Uool00`00ooooo`02ool01000ooooo`000_oo00D00?oo
ooooo`0000?oo`05003oooooool00002ool01@00oooooooo00001?oo00D00?oo003oo`0000;oo`05
003oooooool00004ool01@00oooooooo00000ooo00<00?ooool00_oo00<00?ooool00_oo00D00?oo
ooooo`0000Coo`05003oooooool00005ool00`00ooooo`03ool00`00ooooo`050006ool40003ool2
0003ool30002ool20003ool20002ool20004ool50006ool40008ool4001]ool009Soo`8006?oo`03
003ooooo00;oo`04003ooooo0002ool01@00oooooooo00000ooo00D00?ooooooo`0000;oo`05003o
ooooool00004ool00`00ooooo`020003ool01@00oooooooo00000ooo00@00?ooooooo`8000;oo`03
003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`04003ooooo0005ool0
0`00ooooo`02ool40004ool20002ool30002ool20004ool40005ool50006ool40004ool20002ool3
0008ool4001aool009[oo`<0063oo`03003ooooo00;oo`04003ooooo0002ool20002ool01@00oooo
oooo00000ooo00@00?ooool000?oo`03003ooooo00;oo`03003ooooo008000?oo`05003oooooool0
0003ool02@00oooooooo003oo`00ool00004ool00`00ooooo`02ool00`00ooooo`02ool00`00oooo
o`02ool300000ooo003oo`04ool01000ool000000_oo0P001?oo10001ooo10001?oo1@001?oo0P00
0_oo0`000_oo0P001?oo10001ooo1000MOoo002Mool2001Nool00`00ooooo`02ool01P00oooooooo
003oo`8000;oo`05003oooooool00003ool200000ooo003oo`02ool00`00ooooo`02ool01@00oooo
oooo00000ooo00D00?ooooooo`0000?oo`03003ooooo00;oo`800003ool00?oo00Coo`03003ooooo
00;oo`05003oooooool00005ool01000ool000000_oo1@001_oo10000ooo0P000ooo0`000_oo0P00
0ooo0P000_oo0P001?oo10001ooo10001ooo1000NOoo002Oool3001Kool00`00ooooo`02ool01P00
oooooooo003oo`8000;oo`05003oooooool00003ool200000ooo003oo`02ool00`00ooooo`02ool0
1000oooooooo0P000_oo00D00?ooooooo`0000Coo`09003oooooool00?oo003oo`0000Coo`03003o
oooo00;oo`05003oooooool00005ool00`00ooooo`030004ool20002ool30002ool20004ool40005
ool50006ool40003ool20003ool30007ool4001mool00:;oo`8005Woo`03003ooooo00;oo`05003o
ooooool00002ool01000ooooo`000ooo00@00?ooooooo`800003ool00?oo00;oo`03003ooooo00;o
o`04003oooooool20002ool01@00oooooooo00001?oo00D00?ooooooo`0000;oo`8000Coo`03003o
oooo00;oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo008000Coo`@000Goo`H000Coo`D0
00Coo`8000;oo`<000;oo`8000Coo`@000Koo`@0087oo`00Y?oo0`00E_oo00<00?ooool00_oo00D0
0?ooooooo`0000;oo`04003ooooo0004ool01000oooooooo0`000ooo00<00?ooool00_oo00<00?oo
ool00_oo0P0000?oo`00ool00_oo00<00?ooool00_oo00D00?ooooooo`0000?oo`03003ooooo00;o
o`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00?oo`04003oooooool50004ool50004ool2
0003ool20002ool20004ool40007ool40006ool40025ool00:Ooo`8005Coo`03003ooooo00;oo`05
003oooooool00002ool01000ooooo`001?oo00@00?ooooooo`<000?oo`03003ooooo00?oo`04003o
ooooool200000ooo003oo`02ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`020003ool0
0`00ooooo`02ool00`00ooooo`02ool00`00ooooo`03ool40003ool20003ool20002ool20004ool5
0006ool40003ool20003ool30007ool30029ool00:Woo`8005;oo`03003ooooo00;oo`05003ooooo
ool00002ool01000ooooo`001?oo00@00?ooooooo`<000Coo`03003ooooo00;oo`09003oooooool0
0?oo003oo`0000?oo`05003oooooool00004ool01000oooooooo0P000_oo00<00?ooool00ooo00<0
0?ooool00_oo00<00?oo00000P000_oo0P001?oo10001_oo10001?oo0P000_oo0`000_oo0P001?oo
10001_oo1000S?oo002[ool3001?ool00`00ooooo`02ool01@00oooooooo00000_oo00@00?ooool0
00Coo`04003oooooool200000ooo003oo`02ool00`00ooooo`02ool01@00oooooooo00000_oo0P00
0ooo00D00?ooooooo`0000Coo`07003oooooool00?oo00000_oo00<00?ooool00_oo00<00?ooool0
10001ooo10000ooo0P000ooo0P000_oo0P001?oo10001Ooo1P001_oo1000T?oo002^ool2001=ool0
0`00ooooo`02ool01@00oooooooo00000_oo0P0000?oo`00ool00ooo00H00?ooooooo`00ool20003
ool00`00ooooo`02ool01@00oooooooo00000_oo0P000ooo00<00?ooool00_oo00D00?ooooooo`00
00Coo`05003oo`00ool00003ool40003ool20003ool30002ool20003ool50005ool50004ool50008
ool4002Dool00;3oo`<004[oo`03003ooooo00;oo`05003oooooool00003ool00`00ool00004ool0
1P00oooooooo003oo`8000?oo`03003ooooo00;oo`03003ooooo00;oo`04003ooooo0003ool00`00
ooooo`02ool00`00ooooo`02ool01@00oooooooo00000_oo0P0000?oo`0000000_oo0P001?oo1000
1_oo10001Ooo1@000ooo0P000ooo0P002?oo1000V?oo002cool20018ool00`00ooooo`02ool01@00
oooooooo00000ooo00<00?oo00001?oo00H00?ooooooo`00ool20003ool00`00ooooo`02ool00`00
ooooo`02ool00`00ooooo`020002ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool0
0`00ooooo`020006ool40003ool20003ool20002ool20003ool30002ool20003ool50006ool4002L
ool00;Goo`<004Goo`03003ooooo00;oo`05003oooooool00003ool01000ooooo`000ooo00D00?oo
ooooo`0000;oo`05003oooooool00004ool00`00ooooo`02ool01@00oooooooo00000_oo00<00?oo
ool00_oo00<00?ooool00_oo00<00?ooool00_oo00@00?ooooooo`8000?oo`8000;oo`8000Coo`@0
00Goo`@000Koo`@000Ooo`@00:3oo`00^?oo0P00A?oo00D00?ooooooo`0000?oo`05003oooooool0
0002ool01@00oooooooo00000ooo00@00?ooool000?oo`03003ooooo00?oo`05003oooooool00003
ool200000ooo003oo`03ool00`00ooooo`02ool00`00ooooo`03ool00`00ooooo`050004ool60004
ool50003ool20003ool20007ool4002Tool00;[oo`<0047oo`05003oooooool00003ool01000oooo
oooo0P0000?oo`00ool00_oo00D00?ooooooo`0000;oo`05003oooooool00005ool01@00oooooooo
00000ooo0P0000?oo`00ool00ooo00<00?ooool00ooo00<00?ooool01@001Ooo10001?oo0P000ooo
0P000_oo0P001?oo10001Ooo1000Z?oo002mool2000oool01@00oooooooo00000ooo00@00?oooooo
o`800003ool00?oo00?oo`05003oooooool00002ool01000ooooo`001Ooo00D00?ooooooo`0000Co
o`800003ool00?oo00?oo`04003oooooool40003ool20003ool20002ool20004ool50004ool60006
ool3002/ool00;ooo`<003coo`05003oooooool00004ool00`00ooooo`0200000ooo003oo`03ool0
1@00oooooooo00000_oo00@00?ooool000Goo`03003ooooo00;oo`06003oooooool00?oo0P001?oo
00@00?oo000000;oo`8000Coo`@000Goo`D000Goo`@000Soo`@00:ooo`00`_oo0P00>_oo00D00?oo
ooooo`0000Coo`07003oooooool00?oo00001?oo00D00?ooooooo`0000;oo`800003ool00?oo00Co
o`03003ooooo00;oo`03003ooooo00;oo`<000;oo`@000Goo`D000Coo`D000?oo`8000?oo`8000So
o`@00;?oo`00a?oo0`00=ooo00D00?ooooooo`0000Coo`07003oooooool00?oo00001?oo00D00?oo
ooooo`0000;oo`800003ool00?oo00Coo`03003ooooo00;oo`03003ooooo00;oo`03003oo`000080
00Coo`D000?oo`8000?oo`8000;oo`8000Coo`@000Koo`@00;Ooo`00aooo0P00=Ooo00D00?oooooo
o`0000Coo`07003oooooool00?oo00001?oo00D00?ooooooo`0000?oo`04003ooooo0004ool00`00
ooooo`02ool00`00ooooo`02ool00`00ooooo`020003ool20002ool20004ool40006ool40006ool4
002kool00<Woo`<003;oo`05003oooooool00004ool01000oooooooo0`001?oo00D00?ooooooo`00
00?oo`800003ool00?oo00?oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00@000Koo`@0
00?oo`8000?oo`8000Koo`@00;ooo`00c?oo0P00<?oo00D00?ooooooo`0000Coo`04003oooooool3
0004ool01@00oooooooo00000ooo0P0000?oo`00ool01?oo00<00?ooool00_oo00@00?ooooooo`@0
00?oo`8000?oo`8000;oo`8000Coo`@000Coo`@00<?oo`00c_oo0`00;Ooo00D00?ooooooo`0000Co
o`04003oooooool30004ool01@00oooooooo00000ooo00@00?oo000000Goo`03003ooooo00;oo`04
003oo`000002ool20003ool50004ool60004ool40037ool00=7oo`8002_oo`05003oooooool00004
ool01000oooooooo0`001?oo00D00?ooooooo`0000Coo`<000Goo`03003ooooo00@000Coo`D000Go
o`@000Koo`@00<_oo`00dooo0`00:?oo00D00?ooooooo`0000Coo`04003oooooool30004ool01@00
oooooooo00001?oo00<00?oo00000_oo1P001?oo10000ooo0P000ooo0P001ooo0`00cooo003Fool2
000Vool00`00ooooo`02ool01@00oooooooo00001?oo0P001?oo00<00?ooool00_oo00H00?oooooo
o`00ool30004ool20002ool20002ool20004ool40005ool4003Bool00=Soo`<002?oo`03003ooooo
00;oo`05003oooooool00004ool30004ool01@00oooooooo00000ooo00<00?ooool00P001?oo1000
1Ooo1@001Ooo1000e_oo003Kool2000Qool00`00ooooo`02ool01@00oooooooo00001?oo0`001?oo
00D00?ooooooo`0000Coo`03003ooooo00D000Coo`D000Koo`@00=[oo`00gOoo0`007_oo00<00?oo
ool00_oo00D00?ooooooo`0000Coo`<000Coo`05003oooooool00002ool50003ool20003ool20006
ool4003Nool00>3oo`8001coo`03003ooooo00;oo`05003oooooool00004ool30004ool00`00oooo
o`040003ool20004ool40004ool4003Rool00>;oo`8001[oo`03003ooooo00;oo`03003ooooo00;o
o`07003oooooool00?oo00001?oo0`000_oo0P001?oo1@001?oo1000i_oo003Tool3000Gool00`00
ooooo`02ool00`00ooooo`02ool01`00oooooooo003oo`0000;oo`@000Coo`D000Goo`@00>[oo`00
iooo0P005Ooo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool00_oo10001?oo10001ooo0`00
k_oo003Yool3000Bool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02ool01000ool00000
0_oo0P001ooo1000lOoo003/ool2000@ool00`00ooooo`02ool00`00ooooo`02ool00`00ooooo`02
ool00`00ooooo`030005ool4003eool00>koo`<000goo`03003ooooo00;oo`03003ooooo00;oo`03
003ooooo00D000Coo`@00?Woo`00lOoo0P002ooo00<00?ooool00_oo00@00?ooooooo`@000Goo`@0
0?goo`00looo0`002?oo00<00?ooool00_oo00@00?oo000000Goo`@00?ooo`;oo`00m_oo0P001_oo
00<00?ooool010000ooo1000oooo1_oo003hool30003ool30003ool4003oool:ool00?_oo`800003
ool00?oo00@00?ooo`koo`00oOoo0`00oooo4_oo0000\
\>"],
  ImageRangeCache->{{{122.438, 544.625}, {467.062, 174.875}} -> {-0.338337, \
0.500251, 0.00193694, 0.00193694}}]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
ScreenStyleEnvironment->"Working",
WindowSize->{1012, 740},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"PrintingMargins"->{{84.875, 54}, {72, 72}},
"PaperSize"->{597.562, 842.375},
"PaperOrientation"->"Portrait",
"PrintCellBrackets"->False,
"PrintRegistrationMarks"->True,
"PrintMultipleHorizontalPages"->False,
"PostScriptOutputFile":>FrontEnd`FileName[{$RootDirectory, "home", "felix", \
"tmp"}, "qqq.ps", CharacterEncoding -> "ISO8859-1"],
"Magnification"->1}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 337, 13, 45, "Subsection"],
Cell[2079, 66, 750, 20, 46, "Input"],

Cell[CellGroupData[{
Cell[2854, 90, 846, 21, 43, "Input"],
Cell[3703, 113, 323052, 7339, 375, 172089, 5471, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

