(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    951278,      12446]*)
(*NotebookOutlinePosition[    951916,      12469]*)
(*  CellTagsIndexPosition[    951872,      12465]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    RowBox[{
      RowBox[{"data", "=", 
        RowBox[{"Import", "[", 
          RowBox[{
          "\"\</home/felix/projects/official-education/uni-studium/physik/\
diplomarbeit/fekleediploma200234/calculations/auxiliary/tmp/0408182138/qqq.\
table\>\"", ",", "\"\<Table\>\""}], "]"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"?", "ConvertToBitmapPacket"}]], "Input"],

Cell[BoxData["\<\"System`ConvertToBitmapPacket\"\>"], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Options", "[", "Raster", "]"}]], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"ColorFunction", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], 
      "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{
      RowBox[{"gr", "=", 
        RowBox[{"Graphics", "[", 
          RowBox[{
            RowBox[{"Raster", "[", "data", "]"}], ",", 
            RowBox[{"AspectRatio", "\[Rule]", "4"}], ",", 
            RowBox[{"PlotRegion", "\[Rule]", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"0", ",", "1"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}]}], "]"}]}], 
      ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"?", "Export"}]], "Input"],

Cell[BoxData["\<\"Export[\\\"file.ext\\\", expr] exports data to a file, \
converting it to a format corresponding to the file extension ext. \
Export[\\\"file\\\", expr, \\\"format\\\"] exports data to a file, converting \
it to the specified format.\"\>"], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Export", "[", 
      RowBox[{"\"\</tmp/gr.bmp\>\"", ",", "gr"}], "]"}]], "Input"],

Cell[BoxData["\<\"/tmp/gr.bmp\"\>"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"?", "Import"}]], "Input"],

Cell[BoxData["\<\"Import[\\\"name.ext\\\"] imports data from a file, assuming \
that it is in the format indicated by the file extension ext, and converts it \
to a Mathematica expression. Import[\\\"file\\\", \\\"format\\\"] imports \
data in the specified format from a file.\"\>"], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"grB", "=", 
      RowBox[{"Import", "[", "\"\</tmp/gr.bmp\>\"", "]"}]}]], "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"\[SkeletonIndicator]", "Graphics", "\[SkeletonIndicator]"}],
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Show", "[", "grB", "]"}]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.014881 0.0238095 0.014881 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
% Start of gray image
p
.02381 .02381 translate
.95238 .95238 scale
64 string
64 64 8 [64 0 0 64 0 0] {
\tcurrentfile
\t1 index
\treadhexstring
\tpop
}  Mimage
00040B4F4C4A49474544A8EAFAFEF8C2C25E1801012886D9E9FDF4EDE6E0872E1F020022
7D7B7875CFF8FEF8C05C170109105BBDF2FEFBCC6A1D0201070F161C
217CD4F9FEF9F1EAE3DE84878A8D310700040C514EB2EEFEFCF5EDE69296999D3C320700
050D53B7F0FDFDF6EEE7E1892F06001A1F24807D7BD3F9FDF7EFE896
370900040C1361C2F4FEFBF3B0B34F11000D1463C3CEF7FEF9F2EA9B9EA240362A050126
292C2E3032949494E1F1FEFCF5B65213000B4FB2EEFCF8F0E9E3DD83
2B1C0201070F1668C7F5FEFAF3EB9DA03F350800171D2226292C2F3092E0FCFEF7EFE8E2
8B300700050C141A70CCD9FAFEF8C0C15D5A1606001A706CCAF6FEE7
E1892F210300060E161C73CEDCFBFBF4ECE5DF872D0600070E161C217CD4E2FCF8C15D17
0700050D151B202581D7FAFCD4D171727374220300060E1566C5F5FE
FAF3AF4C453D330800040C141A6F6C69C7D3F9FEF9F1ABAE4A0F00020A4AAEECFEF2EA9C
9FA2A5A8ABAEB0B2B4B652120002094846AAEBFEF3EB9EA1400C0003
0B4DB1EDFEFCD1CFCD6B1E0D0003313294E1FCFDDAD7D3D1CFCDCB6969691D02050D141B
71CDF7FEE6E0DBD7797B7E80291A0101074342A6E9F9FDF6BB571405
00050D151B202581D7FAFEF8C25E170108105A57BAF1FEFBF4ECE5E0DBD7797B7D280400
063CA0E6FDF6EEA4420C00020911186B6864C4F4FEFBF3EBE5DFDA7E
280501292C8C8A89DBFBFEDEDA7D7F290500050D1565C4F4FEFAC967661B02060E1565C5
F5FEFAC9C8661B0B00030B13191F78D1F8FEF9C4C460190101272A2D
8DDDEEFCFDF7EFA6440D0010176A67C6F5FEFAF3EB9DA03F0B00020A125E5B5855B8F0FE
FBF4ECE5E0DB7F82852C1D0D00030A125FC0F3FEEEA4A7AA470E0101
0845A9EAFEFCD3D1CF6D6E1F0200070F161C2125292C2E30323396E2F2FEFCF5EDA13F36
0800040C50B3EEFEFCF4B4B6524D11000D53504EB2B8F0FDFDF6EEA3
A6A9AC490F0101272A2D8D8CDDFBFEF8F0A8450E00030A12191E237F7CD4F9FEE2DD822A
0500050D141B2025282B2E30329393E0FCFEDB7F28190101268482D7
FAFEF8C1C25E180700040C514EB2EEFEF1E999390A00043536363738389CE4F5FFFAF3EB
E4DF85892E0600217B78D1F8FEF9C461190101272A89DBFBFEDEDAD6
77240400060E555250B3EEFDF8F0E8973809001566C5F5FEEAE3DED9D6D3D0CE6D1F0204
3838399C9DE5FDF7EFA6440D00030A4CB0EDFEFCD171211002012428
2B2D30313395E1F2FEEDA1A442392D0600050D1464C4F4FEFBCB691D02012480D6FAFEF8
C25E1801010810176966C5F5FEFAC967661B020107424141A5E8F8FE
E38D3107001D227D7AD3F9FEE3DDD97C270400063D3CA0A2A5A8ACB1EEFEFCF5EDE6E088
2E0600050D141B202481D7FAFDF5B8B955511200020911186BC9F6FE
FAC6C562615F1801080F5956B9C1F3FEFBCB691C020124807ED5F9FEF9C2C3C35F180101
272A8A8887DAEAFEF4B34F11000209115D5ABCF1FEEDE6E0888B3007
00196DCAF6FEE7E1898C310700050C514F4C4AAEECFEFCF5EDE693969A9DA03F0B000332
94E1FCFDDAD6787A260400060E151B2125292B8B8A88DBEBFAFEF8F0
E9E38C310700050C141A20242886DAFAFEF8F0E99839090004353699E3FCFDD9D5D27322
11030007403FA3E8FDFDD57778250400060E1566C5F5FEEAE3DED97D
7F8285888B3022120002094846ABEBFAFEF8C0C1C1C1C15E5B59150500050D146461C1F3
FEEBE48F9296372B0500050D1464C4F4FEEA9A3A2F0600063EA2E7FD
FDF6EEE7E1DCD87B26160600060E151C726FCCF7FEFAF2EAE48E9295370900161C212529
2C2E8F8EDEFBFEF7BE5A57534F490F01010810595653514EB2B9F0FD
FDF6EEE7E1DC8129050108444342414040A4E8FDFDF6B9BABB57531300020911181E76D0
F8FEF9C5611901012684827FD6F9FEF9F1E9E3DED97D271801081017
69C8F5FEFAC7641A0101070F1668C7D3F9FEF9F1AB480F00020A4A4847ABEBFAFCF4EDE6
E0872D1F0F00020A11181E77D1DFEFFEFCCFCDCCCAC967661B0B0013
61C2F4FEFBF4EC9FA240372B1C0201070F161C74CFDCFBFEDD832B0500050D1464C4F4FE
FBF3B0B3B5501200022C8C8BDCFBFBCC6A1D020124278684817F7C7A
D2E1FCFDDA7E8184872D0600050D5250B3BAF1FEFBCDCCCA686868671C0B00030B1260C1
F3FEFBCD6C1E0E01012A898785D9E9FDFDF6EEA3410C00115E5A5754
B7BFF3FEFBCBCAC9C865651B02010743A7ABAFEDFCFEF7EFA7AA470E000F1668C7F5FEFA
F2EB9CA0A3410C00030A12191F7874CFF8FEF9C5C5C4C4615F180108
0F171D74CFF8FEDFDA7E280400060D54514F4CB0B6F0FEFCF4ECA03F0B0003333496E2F2
FEECE5919498390900040B131A6F6B68C7F5FEFAF3AFB14D1102050D
524F4D4B4947ACEBFEF3EBE48F330800181D227ED5F9FEE2DDD8D5D272210300060E1667
C6D1F8FEF9F1EA9A9E3D0B00033335363699E3F4FEFBF3ECE5909497
9B9E3D330800050D141B716DCAD7E6FDF6BA5514000A125F5CBEC7D3E2FCF9C25F180101
08105A575451B5BCC5D0F8FEF9C5C4C4611901070F161C7470CCF7FE
FAF2EAE4DEDAD6D3D070201000022E8F8EDEFBFEDC822A0500050D141B716ECBD7FAFCF5
EDA2A5430D0011186B6764605D5A57BAF1FEFBF4ECE5E0878A2F2103
00063F3FA3A5E9FDF5B5B753130300060E5553B6BDF2FEF1AAADAFB2B4504A430D000209
4746AAEBFEFCF5EDE6E1882E200300070E56B9F1FEEEE7E1898C9033
0800050D1464C4CFF8FEE5DFDAD7D3D1702003040B131A1F7875D0DEEEFEFCF5EDA13F0C
00030B4DB1B7BEF2FEFBF3EC9EA2A5433A0A000435979898E3FCFDD9
7C7F2805010810176AC8F5FEFAF2EBE48F3207000437389B9CE5FDFDF6BABCBD58150109
11181E23272A2D8D8CDDFBFEDDD9D5772403001F2480D6FAFEF8F1E9
E38D310700063C3CA0E6FDFDF6BABB5714000A12196DCAF6FEFAC764631A010740A4E8FD
FDF6B9541300020911181D22262A2D2F31323435363799E3FCFDF7BB
57531300022B2E8E8D8CDDEDFEFCF5EDE693350800171D222683817E7CD4F9FEE2DDD9D5
772414000A12191F237FD6F9FDD677240400060E1566625FC0CAF6FE
E48F9296372B05010742414040A4A7E9FDF4EDE6E0872D06002226292C2E303294949494
E1FCFDF7BD5955514C10020124817ED5F9FEE1DC81842C1D0201070F
166864C4F4FEEBE48F320700181E23278482807D7AD3F9FEE38C909335290501282B8ADC
ECFEF2AE4B1000022E30929191DFF0FEFCCFCD6B6B1E0D000A12191E
77D1F8FEE48E91340800171D7571CDF7FEFAF2AD4A430D00030A125FC0F3FEEBE5DFDA7E
81842B1D0201070F58555250B3EEFEFCF4EDA03F0B00020A4A48ACEC
FEF2AF4B10000E156662C2F4FEFBCA681C02050D151B71CDF7FEFAF2AD4A433A0A00141A
2079D2E1FCFDF7EFE8E2DDD8D5D2D06F7071211000022E309190DFEF
FEFCCFCDCBCAC9661B0201070F161C217CD4F9FDF6EFA5430D00033133349697E2FCFDDA
D678240400063EA2A4E8F8FEF9F1EAE38D310700053C3C9FE6FDFDF6
BA561404022A2D2F9090DFFBFEF7BEBEBFC05C591505001B2025282B2E303293E1F1FEFC
D3D0CE6D1F0200070F161C217C79D2F8FEE38D312404001F242886D9
FAFEDF86892E06001A6FCBD8FAFEF8C15D17010810176AC8D4F9FEE2DDD9D5762403030A
12181E77D1F8FEE48E320700050D53B6F0FEFCCF6E6E6F7020100201
252988DAFBFEF8F0E9E28C30231300022B2E303293E1F1FEFBCDCC6A6A1D0D0011181E76
D0DEFBFEF7F0E8E2DD822A0500050D141B207AD3E1F2FEFBF4ECE5DF
862D060022268482D7FAFEF8C15E170101282B8ADCECFEFCD2D0CE6C6D6D1F0200237ED5
F9FDF6EEE7E1DCD8D5D272210300063F3FA3A5E9FDFDD5D2CFCD6C6C
1E0E0101084644A9ADECFEF2AFB14D110201074141403FA3A6AAEBFEFCD3747577240300
1F24807E7BD3F9FEF9F1AB48400C00125EBFC9D6F9FEF9C25E180700
181E227ED5F9FEF9C2C35F180101272A8A88DBFBFBF4B3B5B7524E480F00020A4AAEECFB
FEF7F0E8E2DDD9D5D2D0CECCCB681C0C00030B12191F23278583D8E8
FDFDD6D3D0CECCCBCAC966651B0A00131A1F24288684D8E8FDFDF6EEA3410C000209115D
BEF2FEFBCCCAC9C8C7651B0201070F161D222683817ED5E4FDFDF6BB
57140500053C3C3C3C9FA1A4E8FDFDF6EEE7E1DCD87A7D270400060D151B207BD3F9FDF7
EFE896993A0A00141B71CDF7FEFAF2EAE48E320700053B3B9FE6FDFD
D7D4D1CFCDCBCAC9C8C7641A0A00030B12196E6A6763605DBEF2FEFBF3EC9E3D0B00030A
12191E23272A8ADBFBFEF8F0E9E28C8F92350800050C141A2079D2E1
FCFDDAD7797B7D27040209105BBDF2FEFBF3EC9F3E0B0010176AC8D4F9FEF9F1EA9A3A0A
000334359798E3FCFDF7EFE8E2DCD8D57678241400010910171D7572
6FCBD8FAFCF5EDA1400C00033294E1FCFDF7BD59150500053B3B9EE6F6FEFAF2EBE48F32
2515010108105B58BAF1FEFBF4ECE5E0872D06001A2024282B8BDCFB
FEDDD97C270400060D54B7BFF3FEFCF4ECE692340800171D22268381D7FAFEF8F1AAADAF
4B1002060E151B72CDDBFBFEDEDA7D80290500053C9FA1A4A7E9FEFD
F6B85413000209115C59BBF1FEFBF4B2B4B6B85313000B13196E6BC9D5F9FEF9C3C35F5D
17010108105ABCF2FEFBF4ECE5DFDBD7D4D1CFCD6B6C6C1E0200070F
161C217CD4E3FCFDF7EFA6430D00115C595653504EB2EEFEF1E9999D3C0A00030A125FC0
F3FEEBE590330800053A9EE5F6FEE8E1DC822A1B02063E3E3D3DA1A3
E8FDFDF6B955504B443C31240400063EA2E7F7FEF9C5621901074140A4E8F8FEE38E9134
0800040C131A6F6CC9F6FEE79598390900040B131A1F242886D9FAFE
F8C05D170101288684D9E8FDF5EDE6E0882E060005393A3A9DE5F6FEE8E2DD82852C0601
24807D7BD3F9FEF9F1EAE38D91340800043738389BE4FDF7EFA7AAAD
490F0101272A2D8DDDFBFEDDD97B7E2804001D222684D8FAFCF5EDA2A5433A2E06001A6F
CBD8FAFCF5EDA2400C00030B12191F78D1DFFCFEF7EFE8E2DD82852C
0600074140A4E8FDF5EDA140362A05010843A7EAF9FEE18A8D31240300060E151B726FCB
F7FEF9F1AB48410C00030B4CB0EDFEFCD1CFCDCB691D02010742A6A9
EAFAFEE0888B8E3207000438389B9D9EE6FDF7EFE8E18A8D91340800040C50B4EFFDFDF6
EFA5430D0011181E227E7BD3F9FEE28C300700050C1463C3F4FEFACA
681C0C00125FC0F3FEEBE5909397380900040B131A1F7976D0DEEEFEFCF4EDE6E0DBD7D4
75230300063F3EA2A5A8EAFEFCF5EEA3A6430D00033192E0F0FEFBCE
CCCB681C0C0002094947ACEBFEFCF5EDA2A5433A2F0600050C52B5BCC5F5FEFAF3EBE4DF
DA7E2805010810171D222684D8FAFEF8C15D5B1601010845A9EBFEFC
D37422120300217BD3F9FDD9D5D2D0CE6D6D1F0200070F161C212583D8FAFCF5EDE6E0DC
80832B1C02063CA0A2E7F7FEF8F0A9AC48410C000D53504EB2B8C0F3
FEEBE5909497380900040B4F4DB0EDFEF1EAE3DE842B1D0C00020911181E23272A2D2F90
8FDEEFFEFCF4EDA03F0B0012605CBEF2FEECE5E0878A2F0600050C51
4F4DB1B7BEF2FEFBCC6A6A6A6A1D0201074141A5E8FDFDF6EEA3410C0003323334979798
98E3FCFDF7BC5754130400060E151B726F6B68C6F5FEFAF3AFB1B34F
pop
P
% End of image
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000181000`40n007h00Ooooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool000Koo`D000@0
80@8@@U:J@Q:B@e2:0B]E@G_G@Cog`Coo`Gog`S660AJj`DH``P000DYA@B4<0CNf`C_G@Goo`Cg_PC_
O@GW?0CW70B4<0@YI@DHh`P000DQ10Akk`Qkc`Ec[PC>N@Cog`Goo`Cog`C660AJj`D@XP@000@8@@D@
PPAJb`Bmm`CgWPGoo`Cog`C>N@E[C@@Hh`P000D080@8H@@@XPDHh`Ooo`001_oo1@00100P10Q12DYY
24Y93D8X1:eE1NmM1?oO1?oo1OoO2<HH15[[1AS320001BU518@`1=kK1>mM1Ooo1?Nn1>mm1NLl1>LL
18@`12UU1ASS20001B4417__27_?1G>^1<ii1?oO1Ooo1?oO1<HH15[[1A2R100010Q11A2215[;1;gg
1?NN1Ooo1?oO1<ii1F]=11SS20001@0P10QQ112R1ASS1ooo0006ool5000402042449BVT8BTT=@RP4
[ED5ked4oml4ool5oml8aQP4F^/56<<80005:DD4Q304g]/4ked5ool4mkh4kgd5ic`4ia`4Q304:FD5
6><800058@@4Nnl8Nll5Ljh4cWT4oml5ool4oml4aQP4F^/54:84000424454884F//4_OL4mih5ool4
oml4cWT5Jdd46><80005020426444:856><7ool000Koo`D000@080@8@@U:J@Q:B@e2:0B]E@G_G@Co
g`Coo`Gog`S660AJj`DH``P000DYA@B4<0CNf`C_G@Goo`Cg_PC_O@GW?0CW70B4<0@YI@DHh`P000DQ
10Akk`Qkc`Ec[PC>N@Cog`Goo`Cog`C660AJj`D@XP@000@8@@D@PPAJb`Bmm`CgWPGoo`Cog`C>N@E[
C@@Hh`P000D080@8H@@@XPDHh`Ooo`001_oo1@00100P10Q12DYY24Y93D8X1:eE1NmM1?oO1?oo1OoO
2<HH15[[1AS320001BU518@`1=kK1>mM1Ooo1?Nn1>mm1NLl1>LL18@`12UU1ASS20001B4417__27_?
1G>^1<ii1?oO1Ooo1?oO1<HH15[[1A2R100010Q11A2215[;1;gg1?NN1Ooo1?oO1<ii1F]=11SS2000
1@0P10QQ112R1ASS1ooo0006ool58@@4Nnl4e[X4oml5ool4oml4mih5ked4ia`4g_/9Q304S544S745
<HH40204000402052644DXX4BVT5]IH4kgd8ool5mkh4kgd4ic`5U984U;84W=<4W?<5>NL4<HH40205
000402042644DXX5]KH4mih9ool4mkh4kgd4ic`5ia`4S544:FD5020400046<<46><58B@4Q104Nnl5
Nll4eYX4oml4ool5mkh4kgd4ked5U;87ool000Koo`DQ10Akk`CF^PCog`Goo`Cog`CgWPG_G@CW70CN
n`V4<0B<D@B<L@DaQP@080@000@080D8H@ABRPA:J@FeUPC_O@Soo`Gg_PC_O@CW?0FDTPBD/PBLd`BL
l`Dii`@aQP@080D000@080@8H@ABRPFe]PCgWPWoo`Cg_PC_O@CW?0GW70B<D@@YI@D080@000@H``@H
h`DQ90B440Akk`Ekc`CFVPCog`Coo`Gg_PC_O@C_G@FD/POoo`001_oo1B4417__1=Jj1?oO1Ooo1?oO
1?NN1NmM1>LL1=kk2H@`18aA18aa1C66100P1000100P1@QQ15::14YY1KFF1>mm2?oo1ONn1>mm1>Ll
1IBB19Bb19cC19cc1CWW1366100P1@00100P10QQ15::1KFf1?NN2Ooo1?Nn1>mm1>Ll1NLL18aA12UU
1@0P100011S311SS1B4T18@@17__1G_?1=JJ1?oO1?oo1ONn1>mm1>mM1IBb1ooo0006ool58@@4Nnl4
e[X4oml5ool4oml4mih5ked4ia`4g_/9Q304S544S745<HH40204000402052644DXX4BVT5]IH4kgd8
ool5mkh4kgd4ic`5U984U;84W=<4W?<5>NL4<HH40205000402042644DXX5]KH4mih9ool4mkh4kgd4
ic`5ia`4S544:FD5020400046<<46><58B@4Q104Nnl5Nll4eYX4oml4ool5mkh4kgd4ked5U;87ool0
00Koo`DaYP@8@@@000@080D8H@@@PPAS30G660Cg_PCoo`Cog`GgWPReUPE:J@@@PP@000@8H@D@XPAS
30C660G>N@Cg_PCoo`Cog`GgWPC_G@BLd`FLl`BU50A220@aYPDYA@@080@000DQ90@YA@PYI@TaQPfD
/PCW70CgWPWoo`Cg_PFe]PABRP@@PP@000D8@@A:J@BeUPG_O@Coo`Cog`CgWPG_G@CW70CNn`F440Oo
o`001_oo1C6V10Q11000100P1@QQ112216<<1LHH1?Nn1?oo1?oO1ONN2;FF1DYY1122100010QQ1A2R
16<<1<HH1Lii1?Nn1?oo1?oO1ONN1>mM19cC1Icc1:DD1488136V1BU5100P10001B4T12U522UU2C66
3IBb1>LL1?NN2Ooo1?Nn1KFf15::112210001@Q114YY1;FF1Nmm1?oo1?oO1?NN1NmM1>LL1=kk1H@@
1ooo0006ool5<JH424440004020526444884H``5aQP4mkh4ool4oml5mih8]IH5BVT4488400042645
4:84H``4aQP5cWT4mkh4ool4oml5mih4ked4W=<5W?<4YA@4@PP4<JH5:DD4020400058B@4:DD8:FD9
<HH=U;84ia`4mih9ool4mkh5]KH4DXX4488400052444BVT4]IH5kgd4ool4oml4mih5ked4ia`4g_/5
Q107ool000Koo`DaYP@8@@@000@080D8H@@@PPAS30G660Cg_PCoo`Cog`GgWPReUPE:J@@@PP@000@8
H@D@XPAS30C660G>N@Cg_PCoo`Cog`GgWPC_G@BLd`FLl`BU50A220@aYPDYA@@080@000DQ90@YA@PY
I@TaQPfD/PCW70CgWPWoo`Cg_PFe]PABRP@@PP@000D8@@A:J@BeUPG_O@Coo`Cog`CgWPG_G@CW70CN
n`F440Ooo`001_oo1BU511SS20001@0P10QQ112R1F]=1<Hh1?Nn1?oo1OoO1?NN1>mM1Icc1:DD13WW
136V1@Q11000112R1ASS1244124T12U52BUU13661IBB1>LL2?oo1ONn1>mm1>mM1NLL18aA1366100P
1@00100P10QQ1A2R11S317>>1<ii1MkK1?oO1?oo1OoO2<HH15[[1E[;112R100P1@0011S317>>16]]
1LiI1?Nn1?oo1NLl1ooo0006ool5:DD46><80005020426444:85Jdd4aSP4mkh4ool5oml4mih4ked5
W?<4YA@4>NL4<JH5244400044:856><48@@48B@4:DD9:FD4<HH5U984ia`8ool5mkh4kgd4ked5ia`4
S544<HH402050004020426454:846<<4Lhh4cWT5g]/4oml4ool5oml8aQP4F^/5F//44:8402050004
6<<4Lhh4Jfd5cUT4mkh4ool5ic`7ool000Koo`DYA@@Hh`P000D080@8H@@@XPE[C@C6>0Cg_PCoo`Go
g`CgWPC_G@FLl`BU50@ii`@aYPD8@@@000@@XPDHh`@Q10@Q90@YA@TYI@@aQPFDTPCW70Soo`Gg_PC_
O@C_G@GW70B<D@@aQP@080D000@080@8H@D@XP@H``AcSPC>N@GNf`Cog`Coo`Gog`S660AJj`EJb`@@
XP@080D000@H``AcSPA[K@G>F@Cg_PCoo`GW?0Ooo`001_oo1BU511SS20001@0P10QQ112R1F]=1<Hh
1?Nn1?oo1OoO1?NN1>mM1Icc1:DD13WW136V1@Q11000112R1ASS1244124T12U52BUU13661IBB1>LL
2?oo1ONn1>mm1>mM1NLL18aA1366100P1@00100P10QQ1A2R11S317>>1<ii1MkK1?oO1?oo1OoO2<HH
15[[1E[;112R100P1@0011S317>>16]]1LiI1?Nn1?oo1NLl1ooo0006ool5ia`4S544:FD48@@90004
020526444:846><4Lhh5cWT4g_/9oml4mkh4kgd4ic`5g_/4Q304:FD502040004020426454:846><4
8@@5Nnl4e[X4ia`4ool5oml4aQP4F^/54:8402040004020526444:846<<58@@48B@4Q104e[X5oml4
ool4e[X5eYX<Lhh5Ljh48@@90004020426444:85Hb`4aSP4mkh<ool000Koo`GW70B<D@@YI@@Q10T0
00@080D8H@@@XP@Hh`AcSPG>N@CNn`Wog`Cg_PC_O@CW?0GNn`B4<0@YI@D080@000@080@8H@D@XP@H
h`@Q10Ekk`CF^PCW70Coo`Gog`C660AJj`D@XP@080@000@080D8H@@@XP@H``DQ10@Q90B440CF^PGo
g`Coo`CF^PGFVPacSPEc[P@Q10T000@080@8H@@@XPES;0C6>0Cg_Pcoo`001_oo1NLL18aA12UU1244
2@00100P1@QQ112R11SS17>>1Lii1=kk2OoO1?Nn1>mm1>Ll1Mkk18@`12UU1@0P1000100P10QQ1A2R
11SS12441G__1=Jj1>LL1?oo1OoO1<HH15[[1A2R100P1000100P1@QQ112R11S31B44124T18@@1=Jj
1OoO1?oo1=Jj1MJJ37>>1G>^12442@00100P10QQ112R1F</1<Hh1?Nn3?oo0006ool5ia`4S544:FD4
8@@90004020526444:846><4Lhh5cWT4g_/9oml4mkh4kgd4ic`5g_/4Q304:FD50204000402042645
4:846><48@@5Nnl4e[X4ia`4ool5oml4aQP4F^/54:8402040004020526444:846<<58@@48B@4Q104
e[X5oml4ool4e[X5eYX<Lhh5Ljh48@@90004020426444:85Hb`4aSP4mkh<ool000Koo`GW70B<D@@Y
I@@Q10T000@080D8H@@@XP@Hh`AcSPG>N@CNn`Wog`Cg_PC_O@CW?0GNn`B4<0@YI@D080@000@080@8
H@D@XP@Hh`@Q10Ekk`CF^PCW70Coo`Gog`C660AJj`D@XP@080@000@080D8H@@@XP@H``DQ10@Q90B4
40CF^PGog`Coo`CF^PGFVPacSPEc[P@Q10T000@080@8H@@@XPES;0C6>0Cg_Pcoo`001_oo1OoO1?NN
1:ee14YY1D8X13WW13661@Q11000100P10QQ1A2R11S32F]]16]=1<Hh1=JJ1OoO1?oo1?oO1ONN1:eE
1:ee14Y91@QQ20001@Q114Y91:ee1>mm1Ooo1?NN1>mM2Icc1:DD1:Dd2JeE1:ee2KFF2;Ff1E::1122
2@0010Q114Y9148X1JeE1>mM1?oo1ONN1>mM19cc1:DD1D8810QQ2@001ooo0006ool5oml4mih4[GD4
BVT5@RP4>NL4<HH524440004020426454:846<<9Jfd4Jdd4aSP4eYX5oml4ool4oml5mih4[ED4[GD4
BTT5264800052444BTT4[GD4kgd5ool4mih4ked9W?<4YA@4YC@9[ED4[GD9]IH8]KH5DXX448890004
2444BTT4@RP5[ED4ked4ool5mih4ked4W?<4YA@5@PP426490007ool000Koo`Gog`CgWPB]M@A:J@E2
:0@ii`@aQPD8@@@000@080@8H@D@XP@H``U[K@A[C@C6>0CFVPGog`Coo`Cog`GgWPB]E@B]M@A:B@D8
H@P000D8@@A:B@B]M@C_O@Goo`CgWPC_G@VLl`BU50BU=0V]E@B]M@VeUPRe]PEBRP@@PPT000@8@@A:
B@A2:0F]E@C_G@Coo`GgWPC_G@BLl`BU50E220@8H@T000Ooo`001_oo1OoO1?NN1:ee14YY1D8X13WW
13661@Q11000100P10QQ1A2R11S32F]]16]=1<Hh1=JJ1OoO1?oo1?oO1ONN1:eE1:ee14Y91@QQ2000
1@Q114Y91:ee1>mm1Ooo1?NN1>mM2Icc1:DD1:Dd2JeE1:ee2KFF2;Ff1E::11222@0010Q114Y9148X
1JeE1>mM1?oo1ONN1>mM19cc1:DD1D8810QQ2@001ooo0006ool52444BVT4]IH4kgd9ool4eYX9cWT4
Jdd46><526480009<HH4U;84ia`9ool4g]/5e[X8eYX9cWT4cUT=Jdd46><40005020426444:856<<4
Lhh4cWT4mkh5ool4ic`4ia`5g]/4e[X8Nll5Nnl4Q104:DD56<<800040209@PP4YC@5ked4oml4ool4
mkh5_ML4DZX44:850207ool000Koo`D8@@A:J@BeUPC_O@Woo`CFVPW>N@A[C@@Hh`D8H@P000TaQPBD
/PCW70Woo`CNf`GF^PSFVPW>N@C>F@e[C@@Hh`@000D080@8H@@@XPDH``AcSPC>N@Cg_PGoo`CW?0CW
70GNf`CF^PQkc`Ekk`B440@YA@DH``P000@080U220BU=0G_G@Cog`Coo`Cg_PFme`ABZP@@XPD080Oo
o`001_oo1@Q114YY1;FF1>mm2Ooo1=JJ2Lii16]=11SS1@QQ20002C6619Bb1>LL2Ooo1=kK1MJj2=JJ
2Lii1<iI3F]=11SS10001@0P10QQ112R1AS317>>1<ii1?Nn1Ooo1>Ll1>LL1MkK1=Jj27_?1G__18@@
12U51AS32000100P2D881:Dd1NmM1?oO1?oo1?Nn1KgG15:Z112R1@0P1ooo0006ool52444BVT4]IH4
kgd9ool4eYX9cWT4Jdd46><526480009<HH4U;84ia`9ool4g]/5e[X8eYX9cWT4cUT=Jdd46><40005
020426444:856<<4Lhh4cWT4mkh5ool4ic`4ia`5g]/4e[X8Nll5Nnl4Q104:DD56<<800040209@PP4
YC@5ked4oml4ool4mkh5_ML4DZX44:850207ool000Koo`D000@080@8H@@@XPDH``@Q10@Q90F440CF
^PCog`Coo`Gog`C660AJj`D@XP@000@8@@@@PPEJb`ABZPBme`GgWPCoo`Cog`Cg_PG_O@CW?0CW70GN
f`CF^PQkc`Ekk`@YA@@080D000@080@ii`BU50GW?0Coo`Cg_PG_O@BU=0A220@8H@T000@8@@D@PP@H
``Q[C@ES;0C6>0Cg_PGoo`Cog`CgWPC_G@GW?0CNn`CNf`Ekk`Ooo`001_oo1@00100P10QQ112R1AS3
1244124T1H@@1=Jj1?oO1?oo1OoO1<HH15[[1A2R100010Q111221E[;15:Z1;gG1ONN1?oo1?oO1?Nn
1Nmm1>Ll1>LL1MkK1=Jj27_?1G__12U5100P1@00100P13WW1:DD1NLl1?oo1?Nn1Nmm1:Dd148810QQ
2@0010Q11A2211S326]=1F</1<Hh1?Nn1Ooo1?oO1?NN1>mM1NLl1=kk1=kK1G__1ooo0006ool50004
020426444:856<<48@@48B@5Q104e[X4oml4ool5oml4aQP4F^/54:84000424444885F//4DZX4_ML5
mih4ool4oml4mkh5kgd4ic`4ia`5g]/4e[X8Nll5Nnl4:DD4020500040204>NL4YA@5ic`4ool4mkh5
kgd4YC@4@PP426490004244548846<<8Jdd5Hb`4aSP4mkh5ool4oml4mih4ked5ic`4g_/4g]/5Nnl7
ool000Koo`D000@080@8H@@@XPDH``@Q10@Q90F440CF^PCog`Coo`Gog`C660AJj`D@XP@000@8@@@@
PPEJb`ABZPBme`GgWPCoo`Cog`Cg_PG_O@CW?0CW70GNf`CF^PQkc`Ekk`@YA@@080D000@080@ii`BU
50GW?0Coo`Cg_PG_O@BU=0A220@8H@T000@8@@D@PP@H``Q[C@ES;0C6>0Cg_PGoo`Cog`CgWPC_G@GW
?0CNn`CNf`Ekk`Ooo`001_oo1BU5100P100012U51BUU18aa2HaA1=kK1?oO1?oo1Mkk1=kK2G__12U5
100P10001@0P10QQ112R1F</1<Hh1?Nn1?oo1OoO1<iI2F</11S31000100P1@QQ112R16</1LHh1?Nn
1?oo1?oO2LiI16</1AS310Q120001@Q1112211S31ASS17_?1=JJ1?oO1Ooo1?oO2LHh16<<11S32@00
124T12U51BUU1ooo0006ool5:DD402040004:DD5:FD4S749S544g]/4oml4ool5g_/4g]/9Nnl4:DD4
02040005020426444:85Hb`4aSP4mkh4ool5oml4cUT9Hb`46<<40004020526444:84Hb`5aSP4mkh4
ool4oml9cUT4Hb`56<<424480005244448846<<56><4Nll4eYX4oml5ool4oml9aSP4H``46<<90004
8B@4:DD5:FD7ool000Koo`DYA@@080@000@YA@DYI@B<L@V<D@CNf`Cog`Coo`GNn`CNf`Ukk`@YA@@0
80@000D080@8H@@@XPES;0C6>0Cg_PCoo`Gog`C>F@US;0@H``@000@080D8H@@@XPAS;0G6>0Cg_PCo
o`Cog`W>F@AS;0DH``@8@@P000D8@@@@PP@H``DHh`Akc`CFVPCog`Goo`Cog`W6>0AS30@H``T000@Q
90@YA@DYI@Ooo`001_oo1BU5100P100012U51BUU18aa2HaA1=kK1?oO1?oo1Mkk1=kK2G__12U5100P
10001@0P10QQ112R1F</1<Hh1?Nn1?oo1OoO1<iI2F</11S31000100P1@QQ112R16</1LHh1?Nn1?oo
1?oO2LiI16</1AS310Q120001@Q1112211S31ASS17_?1=JJ1?oO1Ooo1?oO2LHh16<<11S32@00124T
12U51BUU1ooo0006ool5:DD402040004:DD5:FD4S749S544g]/4oml4ool5g_/4g]/9Nnl4:DD40204
0005020426444:85Hb`4aSP4mkh4ool5oml4cUT9Hb`46<<40004020526444:84Hb`5aSP4mkh4ool4
oml9cUT4Hb`56<<424480005244448846<<56><4Nll4eYX4oml5ool4oml9aSP4H``46<<900048B@4
:DD5:FD7ool000Koo`F<L@CNn`C_O@Woo`Cg_PC_O@FU=0A2:0@8H@@000D@PP@@XPA[C@ES;0C6>0Cg
_PCoo`Gog`CgWPC_G@FLl`BU50@ii`@8@@T000@8@@D@PPAJj`QJb`EBZPBme`CgWPGoo`Cog`Cg_PC_
O@GW?0CW70CNf`Ekk`B440B4<0@YI@DHh`@8H@T000@8@@@@PPAJj`G660CgWPCoo`G_O@RU=0B]E@E2
:0@8H@T000Ooo`001_oo1Haa1=kk1>mm2Ooo1?Nn1>mm1JDd148X10QQ10001A22112R16]=1F</1<Hh
1?Nn1?oo1OoO1?NN1>mM1Icc1:DD13WW10Q12@0010Q11A2215[[25[;1E:Z1;gG1?NN1Ooo1?oO1?Nn
1>mm1NLl1>LL1=kK1G__18@@18@`12UU1ASS10QQ2@0010Q1112215[[1LHH1?NN1?oo1Nmm2:Dd1:eE
1D8X10QQ2@001ooo0006ool5S744g_/4kgd9ool4mkh4kgd5YC@4@RP42644000548844:84Jdd5Hb`4
aSP4mkh4ool5oml4mih4ked5W?<4YA@4>NL42449000424454884F^/8F//5DZX4_ML4mih5ool4oml4
mkh4kgd5ic`4ia`4g]/5Nnl4Q104Q304:FD56><42649000424444884F^/5aQP4mih4ool5kgd8YC@4
[ED5@RP426490007ool000Koo`F<L@CNn`C_O@Woo`Cg_PC_O@FU=0A2:0@8H@@000D@PP@@XPA[C@ES
;0C6>0Cg_PCoo`Gog`CgWPC_G@FLl`BU50@ii`@8@@T000@8@@D@PPAJj`QJb`EBZPBme`CgWPGoo`Co
g`Cg_PC_O@GW?0CW70CNf`Ekk`B440B4<0@YI@DHh`@8H@T000@8@@@@PPAJj`G660CgWPCoo`G_O@RU
=0B]E@E2:0@8H@T000Ooo`001_oo1@Q1148X1:eE1>mM2Ooo2MJJ1<ii26]]1ASS20001@0P10QQ112R
11SS1B44124T12U52BUU3C6619Bb1>LL1ONN2?oo1?Nn1Nmm1:DD13WW1C6V10Q11000100P1@QQ15::
1;FF1Nmm2?oo1?Nn2KFf15::1DYY1122100010QQ2E::14YY1KFF1;gG1?NN2Ooo1?Nn1>mm1JDD1ooo
0006ool52444@RP4[ED4ked9ool9eYX4cWT8Jfd56><80005020426444:846><58@@48B@4:DD9:FD=
<HH4U;84ia`5mih8ool4mkh5kgd4YA@4>NL5<JH42444000402052644DXX4]IH5kgd8ool4mkh9]KH4
DXX5BVT4488400042649DXX4BVT5]IH4_ML4mih9ool4mkh4kgd5YA@7ool000Koo`D8@@A2:0B]E@C_
G@Woo`WFVPC>N@Q[K@DHh`P000D080@8H@@@XP@Hh`DQ10@Q90@YA@TYI@daQPBD/PCW70GgWPSoo`Cg
_PG_O@BU50@ii`DaYP@8@@@000@080D8H@ABRPBeUPG_O@Soo`Cg_PVe]PABRPE:J@@@PP@000@8H@UB
RPA:J@FeUPBme`CgWPWoo`Cg_PC_O@FU50Ooo`001_oo1@Q1148X1:eE1>mM2Ooo2MJJ1<ii26]]1ASS
20001@0P10QQ112R11SS1B44124T12U52BUU3C6619Bb1>LL1ONN2?oo1?Nn1Nmm1:DD13WW1C6V10Q1
1000100P1@QQ15::1;FF1Nmm2?oo1?Nn2KFf15::1DYY1122100010QQ2E::14YY1KFF1;gG1?NN2Ooo
1?Nn1>mm1JDD1ooo0006ool5YC@4[ED4[GD4BTT5264800058B@4:DD4:FD9S744g_/4oml5ool4oml4
mih4[ED5@RP426490004244448846<<56><48@@9Nnl4e[X4oml4ool5ia`4g_/4Q105:DD402040004
020526444:846<<58@@48B@8:DD5:FD8<HH9U984ia`9ool4g]/4Nnl5:DD46<<800058B@4Q304Q105
e[X7ool000Koo`FU=0B]E@B]M@A:B@D8H@P000DQ90@YA@@YI@V<L@CNn`Cog`Goo`Cog`CgWPB]E@E2
:0@8H@T000@8@@@@PP@H``DHh`@Q10Ukk`CF^PCog`Coo`GW70CNn`B440DYA@@080@000@080D8H@@@
XP@H``DQ10@Q90PYA@DYI@PaQPVDTPCW70Woo`CNf`Akk`DYA@@H``P000DQ90B4<0B440GF^POoo`00
1_oo1JDd1:eE1:ee14Y91@QQ20001B4T12U512UU2Haa1=kk1?oO1Ooo1?oO1?NN1:eE1D8X10QQ2@00
10Q1112211S31ASS12442G__1=Jj1?oO1?oo1NLL1=kk18@@1BU5100P1000100P1@QQ112R11S31B44
124T22U51BUU23662IBB1>LL2Ooo1=kK17__1BU511S320001B4T18@`18@@1MJj1ooo0006ool5YC@4
[ED4[GD4BTT5264800058B@4:DD4:FD9S744g_/4oml5ool4oml4mih4[ED5@RP42649000424444884
6<<56><48@@9Nnl4e[X4oml4ool5ia`4g_/4Q105:DD402040004020526444:846<<58@@48B@8:DD5
:FD8<HH9U984ia`9ool4g]/4Nnl5:DD46<<800058B@4Q304Q105e[X7ool000Koo`Gog`Coo`Cog`W6
60AJj`@H``D080@000@080@8H@EBRPA:J@BeUPG_O@Coo`CgWPC_G@FLd`@ia`@8@@D000@0814aYPTi
a`BLl`CW?0Cg_PGoo`Cog`CgWPG_G@CW?0CNn`B4<0F<D@@YI@@080D000@Q10Qkc`GFVPCog`Coo`Go
g`C6>0AS30@H``T000@Q90DYA@B<D@CNf`Cog`Goo`CNn`CNf`GF^POoo`001_oo1OoO1?oo1?oO2LHH
15[[11S31@0P1000100P10QQ1E::14YY1;FF1Nmm1?oo1?NN1>mM1IcC13W710Q11@00100P4C6V2CW7
19cc1>Ll1?Nn1Ooo1?oO1?NN1NmM1>Ll1=kk18@`1HaA12UU100P1@00124427_?1MJJ1?oO1?oo1OoO
1<Hh16<<11S32@00124T1BU518aA1=kK1?oO1Ooo1=kk1=kK1MJj1ooo0006ool5oml4ool4oml9aQP4
F^/46<<50204000402042645DXX4BVT4]IH5kgd4ool4mih4ked5W=<4>LL424450004020A<JH9>LL4
W?<4ic`4mkh5ool4oml4mih5ked4ic`4g_/4Q305S544:FD4020500048@@8Nll5eYX4oml4ool5oml4
aSP4H``46<<900048B@5:DD4S544g]/4oml5ool4g_/4g]/5e[X7ool000Koo`Gog`Coo`Cog`W660AJ
j`@H``D080@000@080@8H@EBRPA:J@BeUPG_O@Coo`CgWPC_G@FLd`@ia`@8@@D000@0814aYPTia`BL
l`CW?0Cg_PGoo`Cog`CgWPG_G@CW?0CNn`B4<0F<D@@YI@@080D000@Q10Qkc`GFVPCog`Coo`Gog`C6
>0AS30@H``T000@Q90DYA@B<D@CNf`Cog`Goo`CNn`CNf`GF^POoo`001_oo1OoO1?oo1?oO2LHH15[[
11S31@0P1000100P10QQ1E::14YY1;FF1Nmm1?oo1?NN1>mM1IcC13W710Q11@00100P4C6V2CW719cc
1>Ll1?Nn1Ooo1?oO1?NN1NmM1>Ll1=kk18@`1HaA12UU100P1@00124427_?1MJJ1?oO1?oo1OoO1<Hh
16<<11S32@00124T1BU518aA1=kK1?oO1Ooo1=kk1=kK1MJj1ooo0006ool5Ljh48B@4020400050204
2644DZX9DXX4]IH4kgd5ool4oml4mih5ked4U;84>LL4244500044:84Hb`5aSP4mkh4ool4ked5ia`4
g_/4g]/5e[X8eYX4cWT5Jfd46><40005020<>LL9W?<4ic`5ool4mkh4kgd4YC@5@RP4264900042444
BVT4]IH5kgd8ool5eYX4Lhh48@@4488900048B@5:DD7ool000Koo`Ec[P@Q90@080@000D080@8H@AB
ZPUBRPBeUPC_O@Goo`Cog`CgWPG_G@BD/P@ia`@8@@D000@@XPAS;0G6>0Cg_PCoo`C_G@GW70CNn`CN
f`GF^PSFVPC>N@E[K@@Hh`@000D080`ia`VLl`CW?0Goo`Cg_PC_O@BU=0E2:0@8H@T000@8@@A:J@Be
UPG_O@Soo`GFVPAcSP@Q10@@PPT000@Q90DYA@Ooo`001_oo1G>^124T100P10001@0P10QQ15:Z2E::
1;FF1>mm1Ooo1?oO1?NN1NmM19Bb13W710Q11@00112R16</1LHh1?Nn1?oo1>mM1NLL1=kk1=kK1MJj
2=JJ1<ii1F]]11SS10001@0P33W72Icc1>Ll1Ooo1?Nn1>mm1:Dd1D8X10QQ2@0010Q114YY1;FF1Nmm
2?oo1MJJ17>>124411222@00124T1BU51ooo0006ool5Ljh48B@40204000502042644DZX9DXX4]IH4
kgd5ool4oml4mih5ked4U;84>LL4244500044:84Hb`5aSP4mkh4ool4ked5ia`4g_/4g]/5e[X8eYX4
cWT5Jfd46><40005020<>LL9W?<4ic`5ool4mkh4kgd4YC@5@RP4264900042444BVT4]IH5kgd8ool5
eYX4Lhh48@@4488900048B@5:DD7ool000Koo`DYA@@YI@daQPBD/PCW70GgWPCoo`C_O@BU50FU=0A2
20@ia`DYI@@080@000@080D8H@@@XPAS;0G6>0Cg_PCoo`Cog`G>F@A[C@@Hh`T000@Q90B440GF^PCo
g`Coo`Gog`C660AJj`@H``T000@8@@D@PP@@XPA[C@AS;0G6>0Cg_PCoo`Gog`C>F@QS;0DH``P000D0
80a220FU=0C_G@Cog`coo`001_oo1BU512UU3C6619Bb1>LL1ONN1?oo1>mm1:DD1JDd148813W71BUU
100P1000100P1@QQ112R16</1LHh1?Nn1?oo1?oO1LiI16]=11SS2@00124T18@@1MJj1?oO1?oo1OoO
1<HH15[[11S32@0010Q11A22112R16]=16</1LHh1?Nn1?oo1OoO1<iI26</1AS320001@0P34881JDd
1>mM1?oO3?oo0006ool5:DD4:FD=<HH4U;84ia`5mih4ool4kgd4YA@5YC@4@PP4>LL5:FD402040004
020526444:84Hb`5aSP4mkh4ool4oml5cUT4Jdd46><900048B@4Q105e[X4oml4ool5oml4aQP4F^/4
6<<90004244548844:84Jdd4Hb`5aSP4mkh4ool5oml4cUT8Hb`56<<80005020<@PP5YC@4ked4oml<
ool000Koo`DYA@@YI@daQPBD/PCW70GgWPCoo`C_O@BU50FU=0A220@ia`DYI@@080@000@080D8H@@@
XPAS;0G6>0Cg_PCoo`Cog`G>F@A[C@@Hh`T000@Q90B440GF^PCog`Coo`Gog`C660AJj`@H``T000@8
@@D@PP@@XPA[C@AS;0G6>0Cg_PCoo`Gog`C>F@QS;0DH``P000D080a220FU=0C_G@Cog`coo`001_oo
1NLL18aa1366100P1@0011SS12441G__17_?1=JJ1?oO1Ooo1>LL1=kk1MkK17__124T100P1@00100P
2CWW2:DD1:Dd1JeE1:ee1;FF1Nmm2?oo1?Nn1Nmm1>Ll1>LL1HaA12UU100P10001@0P10QQ112R1AS3
1244124T18@@1MJj1?oO1?oo1ONn2;gG15:Z1E::11222@0010Q1112211S31F]=1<iI1?Nn3?oo0006
ool5ia`4S744<HH4020500046><48@@5Nnl4Nll4eYX4oml5ool4ia`4g_/5g]/4Nnl48B@402050004
0209>NL8YA@4YC@5[ED4[GD4]IH5kgd8ool4mkh5kgd4ic`4ia`5S544:FD402040005020426444:85
6<<48@@48B@4Q105e[X4oml4ool5mkh8_ML4DZX5DXX448890004244448846<<5Jdd4cUT4mkh<ool0
00Koo`GW70B<L@@aQP@080D000@Hh`@Q10Ekk`Akc`CFVPCog`Goo`CW70CNn`GNf`Akk`@Q90@080D0
00@080Tii`RU50BU=0F]E@B]M@BeUPG_O@Soo`Cg_PG_O@CW?0CW70F<D@@YI@@080@000D080@8H@@@
XPDH``@Q10@Q90B440GF^PCog`Coo`Gg_PRme`ABZPEBRP@@PPT000@8@@@@PP@H``E[C@C>F@Cg_Pco
o`001_oo1NLL18aa1366100P1@0011SS12441G__17_?1=JJ1?oO1Ooo1>LL1=kk1MkK17__124T100P
1@00100P2CWW2:DD1:Dd1JeE1:ee1;FF1Nmm2?oo1?Nn1Nmm1>Ll1>LL1HaA12UU100P10001@0P10QQ
112R1AS31244124T18@@1MJj1?oO1?oo1ONn2;gG15:Z1E::11222@0010Q1112211S31F]=1<iI1?Nn
3?oo0006ool5oml8aSP9H``4F^/46<<5000424442644F//5DZX4_ML4aQP5mih4ool4oml4cUT5Jdd4
6><900048B@4Q104Nnl5e[X4oml4ool5oml<aQP5F^/46<<900048B@4:DD9S544Q304g]/5ked4ool4
mkh4]IH5BVT44889000424444884F^/5F//4_OL4mih5ool4kgd4ic`4ia`9S544<HH50207ool000Ko
o`Gog`S6>0US30AJj`@H``D000@8@@@8H@AJb`EBZPBme`C660GgWPCoo`Cog`C>F@E[C@@Hh`T000@Q
90B440Akk`GF^PCog`Coo`Gog`c660EJj`@H``T000@Q90@YA@V<D@B4<0CNf`G_G@Coo`Cg_PBeUPE:
J@@@PPT000@8@@@@PPAJj`EJb`Bmm`CgWPGoo`C_O@CW?0CW70V<D@@aQPD080Ooo`001_oo1OoO2<Hh
2F<<15[[11S31@0010Q110QQ15[;1E:Z1;gG1<HH1ONN1?oo1?oO1<iI1F]=11SS2@00124T18@@17__
1MJj1?oO1?oo1OoO3<HH1E[[11S32@00124T12U52HaA18@`1=kK1NmM1?oo1?Nn1;FF1DYY11222@00
10Q1112215[[1E[;1;gg1?NN1Ooo1>mm1>Ll1>LL2HaA13661@0P1ooo0006ool5oml8aSP9H``4F^/4
6<<5000424442644F//5DZX4_ML4aQP5mih4ool4oml4cUT5Jdd46><900048B@4Q104Nnl5e[X4oml4
ool5oml<aQP5F^/46<<900048B@4:DD9S544Q304g]/5ked4ool4mkh4]IH5BVT44889000424444884
F^/5F//4_OL4mih5ool4kgd4ic`4ia`9S544<HH50207ool000Koo`Gog`S6>0US30AJj`@H``D000@8
@@@8H@AJb`EBZPBme`C660GgWPCoo`Cog`C>F@E[C@@Hh`T000@Q90B440Akk`GF^PCog`Coo`Gog`c6
60EJj`@H``T000@Q90@YA@V<D@B4<0CNf`G_G@Coo`Cg_PBeUPE:J@@@PPT000@8@@@@PPAJj`EJb`Bm
m`CgWPGoo`C_O@CW?0CW70V<D@@aQPD080Ooo`001_oo1@0011S316]]1<iI1ONn1?oo1>Ll1NLL18aA
18aa13661@0P1000100P1@QQ15::24YY1DY91:ee1>mm2Ooo1?Nn1>mm1NLl19BB19Bb1IcC19cc1:DD
13WW1@Q120001C6619Bb1>LL2Ooo1=kK1=Jj2G_?124T100P1@00100P10QQ1A2R11S31244124T2BU5
3HaA1=kK1>mM1OoO1?oo1?oO1ONN1ooo0006ool500046<<4Jfd4cUT5mkh4ool4ic`5ia`4S544S744
<HH50204000402052644DXX8BVT5BTT4[GD4kgd9ool4mkh4kgd5ic`4U984U;85W=<4W?<4YA@4>NL5
24480005<HH4U;84ia`9ool4g]/4e[X9Nll48B@402050004020426454:846<<48@@48B@9:DD=S544
g]/4ked5oml4ool4oml5mih7ool000Koo`D000@H``A[K@C>F@Gg_PCoo`CW?0GW70B<D@B<L@@aQPD0
80@000@080D8H@ABRPQ:J@E:B@B]M@C_O@Woo`Cg_PC_O@GW?0BDTPBD/PFLd`BLl`BU50@ii`D8@@P0
00DaQPBD/PCW70Woo`CNf`CF^PUkc`@Q90@080D000@080@8H@D@XP@H``@Q10@Q90TYA@f<D@CNf`C_
G@Gog`Coo`Cog`GgWPOoo`001_oo1@0011S316]]1<iI1ONn1?oo1>Ll1NLL18aA18aa13661@0P1000
100P1@QQ15::24YY1DY91:ee1>mm2Ooo1?Nn1>mm1NLl19BB19Bb1IcC19cc1:DD13WW1@Q120001C66
19Bb1>LL2Ooo1=kK1=Jj2G_?124T100P1@00100P10QQ1A2R11S31244124T2BU53HaA1=kK1>mM1OoO
1?oo1?oO1ONN1ooo0006ool5ked4ia`4S744<HH502040004020526444:846<<48@@58B@4:DD4Q305
g]/4oml4ool4oml5mih4ked4W=<5>LL4244400040209<JH4W=<5ia`8ool4g]/5e[X4eYX4Lhh58@@4
488800050204@PP4>NL5YA@4ked8ool5e[X4Ljh4Nll58B@402040004020526444:84Hb`5aSP4mkh4
ool4ked5ia`4g_/4g]/5Nnl7ool000Koo`G_G@CW70B<L@@aQPD080@000@080D8H@@@XP@H``@Q10DQ
90@YA@B4<0GNf`Cog`Coo`Cog`GgWPC_G@BLd`Dia`@8@@@000@080TaYPBLd`GW70Soo`CNf`GF^PCF
VPAcSPDQ10@@PPP000D080A220@ii`FU50C_G@Soo`GF^PAc[PAkc`DQ90@080@000@080D8H@@@XPAS
;0G6>0Cg_PCoo`C_G@GW70CNn`CNf`Ekk`Ooo`001_oo1NmM1>LL18aa13661@0P1000100P1@QQ112R
11S312441B4T12U518@`1MkK1?oO1?oo1?oO1ONN1>mM19cC1CW710Q11000100P2C6V19cC1NLL2?oo
1=kK1MJj1=JJ17>>1B44112220001@0P148813WW1JDD1>mM2?oo1MJj17>^17_?1B4T100P1000100P
1@QQ112R16</1LHh1?Nn1?oo1>mM1NLL1=kk1=kK1G__1ooo0006ool5ked4ia`4S744<HH502040004
020526444:846<<48@@58B@4:DD4Q305g]/4oml4ool4oml5mih4ked4W=<5>LL4244400040209<JH4
W=<5ia`8ool4g]/5e[X4eYX4Lhh58@@4488800050204@PP4>NL5YA@4ked8ool5e[X4Ljh4Nll58B@4
02040004020526444:84Hb`5aSP4mkh4ool4ked5ia`4g_/4g]/5Nnl7ool000Koo`Ekk`B440B4<0V<
D@@aQP@Q10D@PPP000@8@@E:B@A2:0B]E@G_G@Cog`Coo`CogaK660AJj`UJb`@@XP@080D000@080@8
H@@@XPES;0AS30C660GgWPCoo`C_G@CW?0F<L@BDTPBD/PDaYP@YA@@080@000D080@8H@@@XPES;0C6
>0Cg_PCoo`G_G@BLd`@ia`DYI@@080@000@080Dii`BU50CW?0coo`001_oo1G__18@@18@`2HaA1366
12441A22200010Q11DY9148X1:eE1NmM1?oO1?oo1?oO5/HH15[[2E[;112R100P1@00100P10QQ112R
1F</16<<1<HH1ONN1?oo1>mM1>Ll1Haa19BB19Bb1C6V12U5100P10001@0P10QQ112R1F</1<Hh1?Nn
1?oo1NmM19cC13W71BUU100P1000100P1CWW1:DD1>Ll3?oo0006ool5Nnl4Q104Q309S544<HH48@@5
488800042445BTT4@RP4[ED5ked4oml4ool4omlFaQP4F^/9F//44:8402050004020426444:85Hb`4
H``4aQP5mih4ool4ked4ic`5S744U984U;85<JH4:DD402040005020426444:85Hb`4aSP4mkh4ool5
ked4W=<4>LL5:FD4020400040205>NL4YA@4ic`<ool000Koo`Ekk`B440B4<0V<D@@aQP@Q10D@PPP0
00@8@@E:B@A2:0B]E@G_G@Cog`Coo`CogaK660AJj`UJb`@@XP@080D000@080@8H@@@XPES;0AS30C6
60GgWPCoo`C_G@CW?0F<L@BDTPBD/PDaYP@YA@@080@000D080@8H@@@XPES;0C6>0Cg_PCoo`G_G@BL
d`@ia`DYI@@080@000@080Dii`BU50CW?0coo`002ooo1?Nn1>mm1>Ll1NLL1=kk1=kK1G_?124T112R
100P1@00100P10QQ1A2R11SS17>>16]]1Lii1?Nn1?oo1OoO1?NN1>mM1>Ll1Haa19BB19Bb1C6V10Q1
1000112R1ASS1244124T1BU522UU2Haa1=kk1?oO1Ooo1?Nn1;gg15[;1E:Z15::14YY1DY910QQ2000
1@Q1112215[;1E:Z25::14YY1KFF1;gG1?NN3?oo000;ool4mkh4kgd4ic`5ia`4g_/4g]/5Nll48B@4
4:8402050004020426454:846><4Lhh4Jfd5cWT4mkh4ool5oml4mih4ked4ic`5S744U984U;85<JH4
244400044:856><48@@48B@5:DD8:FD9S744g_/4oml5ool4mkh4_OL4F//5DZX4DXX4BVT5BTT42648
000524444884F//5DZX8DXX4BVT5]IH4_ML4mih<ool000_oo`Cg_PC_O@CW?0GW70CNn`CNf`Ekc`@Q
90@@XP@080D000@080@8H@D@XP@Hh`AcSPA[K@G>N@Cg_PCoo`Gog`CgWPC_G@CW?0F<L@BDTPBD/PDa
YP@8@@@000@@XPDHh`@Q10@Q90DYA@PYI@V<L@CNn`Cog`Goo`Cg_PBmm`AJb`EBZPABRPA:J@E:B@@8
H@P000D8@@@@PPAJb`EBZPQBRPA:J@FeUPBme`CgWPcoo`002ooo1?Nn1>mm1>Ll1NLL1=kk1=kK1G_?
124T112R100P1@00100P10QQ1A2R11SS17>>16]]1Lii1?Nn1?oo1OoO1?NN1>mM1>Ll1Haa19BB19Bb
1C6V10Q11000112R1ASS1244124T1BU522UU2Haa1=kk1?oO1Ooo1?Nn1;gg15[;1E:Z15::14YY1DY9
10QQ20001@Q1112215[;1E:Z25::14YY1KFF1;gG1?NN3?oo000;ool4mkh4kgd4ic`5ia`4g_/4g]/5
Nll48B@44:8402050004020426454:846><4Lhh4Jfd5cWT4mkh4ool5oml4mih4ked4ic`5S744U984
U;85<JH4244400044:856><48@@48B@5:DD8:FD9S744g_/4oml5ool4mkh4_OL4F//5DZX4DXX4BVT5
BTT42648000524444884F//5DZX8DXX4BVT5]IH4_ML4mih<ool000_oo`Cg_PC_O@CW?0GW70CNn`B4
40DYA@@080@000@8@@E2:1E220BU=0G_G@Soo`Gg_Pbme`EBZPABRP@@PPT000@8@@@@PPDH``@Hh`Ac
[PGFVPCog`Coo`Cog`G6>0AS30@H``T000@Q90B4<0F440Akk`CF^PGog`Coo`Cog`CgWPG_G@CW70CN
n`GNf`Akk`@Q90@H``D000@8@@@@PPD@XPOoo`002ooo1?Nn1>mm1>Ll1NLL1=kk18@@1BU5100P1000
10Q11D8X5D881:Dd1NmM2?oo1ONn3;gG1E:Z15::11222@0010Q111221AS311SS17>^1MJJ1?oO1?oo
1?oO1LHh16<<11S32@00124T18@`1H@@17__1=Jj1OoO1?oo1?oO1?NN1NmM1>LL1=kk1MkK17__124T
11S31@0010Q111221A2R1ooo000;ool4mkh4kgd4ic`5ia`4g_/4Q105:DD4020400042445@RPE@PP4
YC@5ked8ool5mkh<_ML5DZX4DXX448890004244448856<<46><4Ljh5eYX4oml4ool4oml5aSP4H``4
6<<900048B@4Q305Q104Nnl4e[X5oml4ool4oml4mih5ked4ia`4g_/5g]/4Nnl48B@46<<500042444
48854:87ool000_oo`Cg_PC_O@CW?0GW70CNn`B440DYA@@080@000@8@@E2:1E220BU=0G_G@Soo`Gg
_Pbme`EBZPABRP@@PPT000@8@@@@PPDH``@Hh`Ac[PGFVPCog`Coo`Cog`G6>0AS30@H``T000@Q90B4
<0F440Akk`CF^PGog`Coo`Cog`CgWPG_G@CW70CNn`GNf`Akk`@Q90@H``D000@8@@@@PPD@XPOoo`00
1_oo1F]=1<iI1?Nn1?oo1OoO1<Hh16</1AS32000100P1@QQ112R16]=1LHh1=JJ1?oO1?oo1OoO1?NN
1:eE1DY910QQ20001@Q124Y91D8X1:eE1>mM1?oO1Ooo1?Nn1>mm1NLl1>LL18@`12UU1ASS10QQ2@00
10Q1112211S31ASS17>^1=JJ1Mkk1>mm2?oo3Lii2LiI26</1AS310Q110001A221ooo0006ool5Jdd4
cUT4mkh4ool5oml4aSP4Hb`56<<80004020526444:84Jdd5aSP4eYX4oml4ool5oml4mih4[ED5BTT4
264800052448BTT5@RP4[ED4ked4oml5ool4mkh4kgd5ic`4ia`4Q304:FD56><42649000424444884
6<<56><4Ljh4eYX5g_/4kgd8ool=cWT9cUT8Hb`56<<4244400054887ool000Koo`E[C@C>F@Cg_PCo
o`Gog`C6>0AS;0DH``P000@080D8H@@@XPA[C@G6>0CFVPCog`Coo`Gog`CgWPB]E@E:B@@8H@P000D8
@@Q:B@E2:0B]E@C_G@Cog`Goo`Cg_PC_O@GW?0CW70B4<0@YI@DHh`@8H@T000@8@@@@PP@H``DHh`Ac
[PCFVPGNn`C_O@Soo`g>N@W>F@QS;0DH``@8@@@000D@PPOoo`001_oo1F]=1<iI1?Nn1?oo1OoO1<Hh
16</1AS32000100P1@QQ112R16]=1LHh1=JJ1?oO1?oo1OoO1?NN1:eE1DY910QQ20001@Q124Y91D8X
1:eE1>mM1?oO1Ooo1?Nn1>mm1NLl1>LL18@`12UU1ASS10QQ2@0010Q1112211S31ASS17>^1=JJ1Mkk
1>mm2?oo3Lii2LiI26</1AS310Q110001A221ooo0006ool5H``4aQP4mkh4ool5oml4mkh4kgd5W?<4
YA@4@PP4<JH5:DD46><90004020426444:856><4Ljh4cWT5g_/4oml4ool4g_/5Q104:DD402050004
020426444:85Hb`4aSP4mkh5ool4oml4mih9]IH4]KH4DXX548880004:FD5S744S544g_/9oml4cWT4
Jdd56><800098B@8Q305Q108Nnl5Nll7ool000Koo`ES30C660Cg_PCoo`Gog`Cg_PC_O@FLl`BU50A2
20@aYPDYA@@Hh`T000@080@8H@@@XPDHh`Ac[PC>N@GNn`Cog`Coo`CNn`F440@YA@@080D000@080@8
H@@@XPES;0C6>0Cg_PGoo`Cog`CgWPVeUPBe]PABRPD@PPP000@YI@F<L@B<D@CNn`Wog`C>N@A[C@DH
h`P000TQ90R4<0F440Qkk`Ekc`Ooo`001_oo1F<<1<HH1?Nn1?oo1OoO1?Nn1>mm1Icc1:DD1488136V
1BU511SS2@00100P10QQ112R1ASS17>^1<ii1Mkk1?oO1?oo1=kk1H@@12U5100P1@00100P10QQ112R
1F</1<Hh1?Nn1Ooo1?oO1?NN2KFF1;Ff15::1A22200012UU1Haa18aA1=kk2OoO1<ii16]=1ASS2000
2B4T28@`1H@@27__1G_?1ooo0006ool5H``4aQP4mkh4ool5oml4mkh4kgd5W?<4YA@4@PP4<JH5:DD4
6><90004020426444:856><4Ljh4cWT5g_/4oml4ool4g_/5Q104:DD402050004020426444:85Hb`4
aSP4mkh5ool4oml4mih9]IH4]KH4DXX548880004:FD5S744S544g_/9oml4cWT4Jdd56><800098B@8
Q305Q108Nnl5Nll7ool000Koo`GFVPCW70Soo`GNf`Akk`B440V4<0@YI@@080D000@080@8H@UBRPBe
UPBme`GgWPCoo`Cog`W>N@C>F@e[C@AS;0DHh`@8@@P000D8@@@@PPAS30G660CgWPCoo`Cog`G>N@A[
K@@Hh`D8H@P000@YA@F<D@R4<0GNf`C_G@Soo`Gg_PC_O@BU50E220@8H@@000@@PPEJj`AJb`UBZPOo
o`001_oo1MJJ1>LL2?oo1MkK17__18@@2H@`12UU100P1@00100P10QQ2E::1;FF1;gG1ONN1?oo1?oO
2Lii1<iI3F]=16</1ASS10Q120001@Q1112216<<1LHH1?NN1?oo1?oO1Lii16]]11SS1@QQ200012U5
1HaA28@`1MkK1>mM2?oo1ONn1>mm1:DD1D8810QQ100011221E[[15[;2E:Z1ooo0006ool5eYX4ia`8
ool5g]/4Nnl4Q109Q304:FD40205000402042649DXX4]IH4_ML5mih4ool4oml9cWT4cUT=Jdd4Hb`5
6><42448000524444884H``5aQP4mih4ool4oml5cWT4Jfd46><526480004:DD5S548Q305g]/4ked8
ool5mkh4kgd4YA@5@PP4264400044885F^/4F//9DZX7ool000Koo`GFVPCW70Soo`GNf`Akk`B440V4
<0@YI@@080D000@080@8H@UBRPBeUPBme`GgWPCoo`Cog`W>N@C>F@e[C@AS;0DHh`@8@@P000D8@@@@
PPAS30G660CgWPCoo`Cog`G>N@A[K@@Hh`D8H@P000@YA@F<D@R4<0GNf`C_G@Soo`Gg_PC_O@BU50E2
20@8H@@000@@PPEJj`AJb`UBZPOoo`001_oo1MJJ1>LL2?oo1MkK17__18@@2H@`12UU100P1@00100P
10QQ2E::1;FF1;gG1ONN1?oo1?oO2Lii1<iI3F]=16</1ASS10Q120001@Q1112216<<1LHH1?NN1?oo
1?oO1Lii16]]11SS1@QQ200012U51HaA28@`1MkK1>mM2?oo1ONn1>mm1:DD1D8810QQ100011221E[[
15[;2E:Z1ooo0006ool5]KH4_OL4mih4ool5omlAcUT8Hb`56<<800050204@PP4YC@4[ED5[GD4kgd9
ool4mkh4kgd4YC@5[ED4@RP42645000426444:84Jdd5aSP4mkh4ool5oml4mih4ked4W?<9YA@4@PP5
26480004244548846<<46><5Nll4Ljh4cWT4oml5ool4omlAaSP4H``5F^/46<<400052447ool000Ko
o`Fe]PBmm`CgWPCoo`Goga7>F@QS;0DH``P000D080A220BU=0B]E@F]M@C_O@Woo`Cg_PC_O@BU=0F]
E@A2:0@8H@D000@8H@@@XPA[C@G6>0Cg_PCoo`Gog`CgWPC_G@BLl`VU50A220D8H@P000@8@@D@PP@H
``@Hh`Ekc`Ac[PC>N@Cog`Goo`Coga76>0AS30EJj`@H``@000D8@@Ooo`001_oo1KFf1;gg1?NN1?oo
1OoO4LiI26</1AS320001@0P14881:Dd1:eE1Jee1>mm2Ooo1?Nn1>mm1:Dd1JeE148X10QQ1@0010QQ
112R16]=1LHh1?Nn1?oo1OoO1?NN1>mM19cc2JDD14881@QQ200010Q11A2211S311SS1G_?17>^1<ii
1?oO1Ooo1?oO4LHh16<<1E[[11S310001@Q11ooo0006ool5]KH4_OL4mih4ool5omlAcUT8Hb`56<<8
00050204@PP4YC@4[ED5[GD4kgd9ool4mkh4kgd4YC@5[ED4@RP42645000426444:84Jdd5aSP4mkh4
ool5oml4mih4ked4W?<9YA@4@PP526480004244548846<<46><5Nll4Ljh4cWT4oml5ool4omlAaSP4
H``5F^/46<<400052447ool000Koo`D8H@@@XP@Hh`Ac[PG>N@Cog`Coo`GNn`CNf`Akk`@YA@D080@0
00@080D8H@ABZPABRPU:J@BeUPBe]PGgWPSoo`Cg_PG_O@BU50@ii`D8@@P000@aQPDaYPBD/PCW70Gg
WPCoo`C_O@CW?0FDTPBD/PBLd`Dia`@8@@@000@080D8@@@@PP@H``E[K@Q[C@C6>0Gg_PCoo`Cog`Gg
WPB]M@BeUPA:J@D@PP@000@080D8H@Ooo`001_oo1@QQ112R11SS17>^1Lii1?oO1?oo1Mkk1=kK17__
12U51@0P1000100P1@QQ15:Z15::2DYY1;FF1;Ff1ONN2?oo1?Nn1Nmm1:DD13WW1@Q1200013661C6V
19Bb1>LL1ONN1?oo1>mm1>Ll1IBB19Bb19cC1CW710Q11000100P1@Q1112211S31F]]26]=1<Hh1ONn
1?oo1?oO1ONN1:ee1;FF14YY1A221000100P1@QQ1ooo0006ool526444:846><4Ljh5cWT4oml4ool5
g_/4g]/4Nnl4:DD50204000402052644DZX4DXX9BVT4]IH4]KH5mih8ool4mkh5kgd4YA@4>NL52448
0004<HH5<JH4U;84ia`5mih4ool4kgd4ic`5U984U;84W=<5>LL4244400040205244448846<<5Jfd8
Jdd4aSP5mkh4ool4oml5mih4[GD4]IH4BVT54884000402052647ool000Koo`D8H@@@XP@Hh`Ac[PG>
N@Cog`Coo`GNn`CNf`Akk`@YA@D080@000@080D8H@ABZPABRPU:J@BeUPBe]PGgWPSoo`Cg_PG_O@BU
50@ii`D8@@P000@aQPDaYPBD/PCW70GgWPCoo`C_O@CW?0FDTPBD/PBLd`Dia`@8@@@000@080D8@@@@
PP@H``E[K@Q[C@C6>0Gg_PCoo`Cog`GgWPB]M@BeUPA:J@D@PP@000@080D8H@Ooo`001_oo1E::24YY
2DY9148X1:ee1NmM1?oo1?NN1>mM1NLl18aa13661@Q1100011S311SS1B4417__1=Jj1OoO1?oo1>LL
1=kk1MkK1=Jj1=JJ1G>>124420001@0P10QQ112R1F</1<Hh1=JJ1?oO1Ooo1?oO1?NN1NmM19cC19cc
13WW1@Q120001C66336V1IcC1>LL1?Nn1Ooo1?oO1?NN1>mm1NLl19BB2IBb1ooo0006ool5DXX8BVT9
BTT4@RP4[GD5ked4ool4mih4ked5ic`4S744<HH5244400046<<46><58@@4Nnl4e[X5oml4ool4ia`4
g_/5g]/4e[X4eYX5Lhh48@@80005020426444:85Hb`4aSP4eYX4oml5ool4oml4mih5ked4W=<4W?<4
>NL524480005<HH<<JH5W=<4ia`4mkh5ool4oml4mih4kgd5ic`4U989U;87ool000Koo`EBRPQ:J@U:
B@A2:0B]M@G_G@Coo`CgWPC_G@GW?0B<L@@aQPD8@@@000@H``@Hh`DQ10Akk`CF^PGog`Coo`CW70CN
n`GNf`CF^PCFVPEcSP@Q10P000D080@8H@@@XPES;0C6>0CFVPCog`Goo`Cog`CgWPG_G@BLd`BLl`@i
i`D8@@P000DaQP`aYPFLd`CW70Cg_PGoo`Cog`CgWPC_O@GW?0BDTPVD/POoo`001_oo1E::24YY2DY9
148X1:ee1NmM1?oo1?NN1>mM1NLl18aa13661@Q1100011S311SS1B4417__1=Jj1OoO1?oo1>LL1=kk
1MkK1=Jj1=JJ1G>>124420001@0P10QQ112R1F</1<Hh1=JJ1?oO1Ooo1?oO1?NN1NmM19cC19cc13WW
1@Q120001C66336V1IcC1>LL1?Nn1Ooo1?oO1?NN1>mm1NLl19BB2IBb1ooo0006ool5DXX8BVT9BTT4
@RP4[GD5ked4ool4mih4ked5ic`4S744<HH5244400046<<46><58@@4Nnl4e[X5oml4ool4ia`4g_/5
g]/4e[X4eYX5Lhh48@@80005020426444:85Hb`4aSP4eYX4oml5ool4oml4mih5ked4W=<4W?<4>NL5
24480005<HH<<JH5W=<4ia`4mkh5ool4oml4mih4kgd5ic`4U989U;87ool000Koo`FLd`BLl`@ii`@a
QPD8@@@000@080D8H@@@XP@H``AcSPE[K@C>F@CF^PGW?0Coo`Cg_PBme`EBZP@@XP@000D8@@@@PPQJ
j`Fmm`C6>0CFVPGW70Coo`Cog`C660EJj`@H``T000@8@@@@PPAJb`UBZPABRPFe]PBmm`C6>0CFVPGo
g`Coo`Cog`g6>0AS30DH``@000@080D8H@@@XP@Hh`Ac[PEcSPC>N@Cg_Pcoo`001_oo1IcC19cc13WW
13661@Q11000100P1@QQ112R11S317>>1F]]1<iI1=Jj1NLl1?oo1?Nn1;gG1E:Z112R10001@Q11122
25[[1Kgg1<Hh1=JJ1NLL1?oo1?oO1<HH1E[[11S32@0010Q1112215[;2E:Z15::1KFf1;gg1<Hh1=JJ
1OoO1?oo1?oO3LHh16<<1AS31000100P1@QQ112R11SS17>^1G>>1<ii1?Nn3?oo0006ool5W=<4W?<4
>NL4<HH524440004020526444:846<<4Lhh5Jfd4cUT4e[X5ic`4ool4mkh4_ML5DZX44:8400052444
4888F^/5_OL4aSP4eYX5ia`4ool4oml4aQP5F^/46<<9000424444884F//9DZX4DXX5]KH4_OL4aSP4
eYX5oml4ool4oml=aSP4H``56<<40004020526444:846><4Ljh5Lhh4cWT4mkh<ool000Koo`FLd`BL
l`@ii`@aQPD8@@@000@080D8H@@@XP@H``AcSPE[K@C>F@CF^PGW?0Coo`Cg_PBme`EBZP@@XP@000D8
@@@@PPQJj`Fmm`C6>0CFVPGW70Coo`Cog`C660EJj`@H``T000@8@@@@PPAJb`UBZPABRPFe]PBmm`C6
>0CFVPGog`Coo`Cog`g6>0AS30DH``@000@080D8H@@@XP@Hh`Ac[PEcSPC>N@Cg_Pcoo`001_oo1OoO
1?NN1>mM1>Ll1Mkk1=kK1=Jj2MJJ17>>12441A2220001BUU28aa1=kk1OoO1?oo1=kk1H@@12U5100P
10001@0P10QQ112R1AS317>>16]]1<iI1MJj1?oO1?oo1ONn1>mm1:DD1:Dd1D8810QQ10001A2211S3
16]=2F</16<<15[[1E[;15:Z1;gG1?NN1Ooo1?oO1?Nn1Nmm1>Ll1>LL18@`1HaA12UU12441@001ooo
0006ool5oml4mih4ked4ic`5g_/4g]/4e[X9eYX4Lhh48@@548880005:FD8S744g_/5oml4ool4g_/5
Q104:DD402040005020426444:856<<4Lhh4Jfd4cUT5e[X4oml4ool5mkh4kgd4YA@4YC@5@PP42644
000548846<<4Jdd9Hb`4H``4F^/5F//4DZX4_ML4mih5ool4oml4mkh5kgd4ic`4ia`4Q305S544:FD4
8@@50007ool000Koo`Gog`CgWPC_G@CW?0GNn`CNf`CF^PWFVPAcSP@Q10D@PPP000DYI@R<L@CNn`Go
g`Coo`CNn`F440@YA@@080@000D080@8H@@@XPDH``AcSPA[K@C>F@GF^PCog`Coo`Gg_PC_O@BU50BU
=0E220@8H@@000D@PP@H``A[C@US;0AS30AJj`EJb`ABZPBme`CgWPGoo`Cog`Cg_PG_O@CW?0CW70B4
<0F<D@@YI@@Q10D000Ooo`001_oo1OoO1?NN1>mM1>Ll1Mkk1=kK1=Jj2MJJ17>>12441A2220001BUU
28aa1=kk1OoO1?oo1=kk1H@@12U5100P10001@0P10QQ112R1AS317>>16]]1<iI1MJj1?oO1?oo1ONn
1>mm1:DD1:Dd1D8810QQ10001A2211S316]=2F</16<<15[[1E[;15:Z1;gG1?NN1Ooo1?oO1?Nn1Nmm
1>Ll1>LL18@`1HaA12UU12441@001ooo0006ool500040208>NL5YA@4YC@4ked5ool4mkh8]KH5DXX4
4889000402042644DZX5DXX4]KH4_OL5mih4ool4mih4[ED9[GD4]IH5]KH4DXX4BTT4@PP526480005
2448@RP4[ED5ked8ool5mkh4kgd4ic`4ia`5S544:FD48@@9000402042645DZX4_ML4mih5ool4kgd4
ic`4ia`5S544S744U985<HH7ool000Koo`D000@080Pii`FU50BU=0C_G@Goo`Cg_PRe]PEBRP@@PPT0
00@080@8H@ABZPEBRPBe]PBmm`GgWPCoo`CgWPB]E@V]M@BeUPFe]PABRPA:B@A220D8H@P000D8@@Q2
:0B]E@G_G@Soo`Gg_PC_O@CW?0CW70F<D@@YI@@Q10T000@080@8H@EBZPBme`CgWPGoo`C_O@CW?0CW
70F<D@B<L@BDTPDaQPOoo`001_oo1@00100P23WW1JDD1:Dd1>mM1Ooo1?Nn2;Ff1E::11222@00100P
10QQ15:Z1E::1;Ff1;gg1ONN1?oo1?NN1:eE2Jee1;FF1KFf15::14Y914881@QQ20001@Q1248X1:eE
1NmM2?oo1ONn1>mm1>Ll1>LL1HaA12UU12442@00100P10QQ1E:Z1;gG1?NN1Ooo1>mm1>Ll1>LL1HaA
18aa19BB1C661ooo0006ool500040208>NL5YA@4YC@4ked5ool4mkh8]KH5DXX44889000402042644
DZX5DXX4]KH4_OL5mih4ool4mih4[ED9[GD4]IH5]KH4DXX4BTT4@PP5264800052448@RP4[ED5ked8
ool5mkh4kgd4ic`4ia`5S544:FD48@@9000402042645DZX4_ML4mih5ool4kgd4ic`4ia`5S544S744
U985<HH7ool000Koo`D8@@@000@080@8H@D@XPAS;0C6>0G>N@Cog`Coo`CW?0GNn`CNf`CF^PWFVPAc
SP@Q10D000@080@8@@D@PP@H``@Hh`Akc`Ec[PCFVPCNn`G_O@Soo`Cg_PG_O@BU50@ii`D8H@P000@8
@@E:J@BeUPBe]PFmm`CgWPCoo`Cog`GgWPC_O@BLl`FU50BU=0A220@ia`D8@@@000@080DaYPBD/PRL
d`GW70Soo`GNf`Ooo`001_oo1@Q11000100P10QQ1A2R16</1<Hh1Lii1?oO1?oo1>Ll1Mkk1=kK1=Jj
2MJJ17>>12441@00100P10Q11A2211S311SS17_?1G>^1=JJ1=kk1Nmm2?oo1?Nn1Nmm1:DD13WW1@QQ
200010Q11DYY1;FF1;Ff1Kgg1?NN1?oo1?oO1ONN1>mm19cc1JDD1:Dd148813W71@Q11000100P1C6V
19Bb29cC1NLL2?oo1MkK1ooo0006ool524440004020426454:84Hb`4aSP5cWT4oml4ool4ic`5g_/4
g]/4e[X9eYX4Lhh48@@500040204244548846<<46><4Nll5Ljh4eYX4g_/5kgd8ool4mkh5kgd4YA@4
>NL5264800042445BVT4]IH4]KH5_OL4mih4ool4oml5mih4kgd4W?<5YA@4YC@4@PP4>LL524440004
0205<JH4U;88W=<5ia`8ool5g]/7ool000Koo`D8@@@000@080@8H@D@XPAS;0C6>0G>N@Cog`Coo`CW
?0GNn`CNf`CF^PWFVPAcSP@Q10D000@080@8@@D@PP@H``@Hh`Akc`Ec[PCFVPCNn`G_O@Soo`Cg_PG_
O@BU50@ii`D8H@P000@8@@E:J@BeUPBe]PFmm`CgWPCoo`Cog`GgWPC_O@BLl`FU50BU=0A220@ia`D8
@@@000@080DaYPBD/PRLd`GW70Soo`GNf`Ooo`001_oo1@Q11000100P10QQ1A2R16</1<Hh1Lii1?oO
1?oo1>Ll1Mkk1=kK1=Jj2MJJ17>>12441@00100P10Q11A2211S311SS17_?1G>^1=JJ1=kk1Nmm2?oo
1?Nn1Nmm1:DD13WW1@QQ200010Q11DYY1;FF1;Ff1Kgg1?NN1?oo1?oO1ONN1>mm19cc1JDD1:Dd1488
13W71@Q11000100P1C6V19Bb29cC1NLL2?oo1MkK1ooo0006ool9Nnl4:DD402050004244448854:84
Jdd4cUT4mkh5ool4oml4mih5ked4ic`4S744<HH5020400040205<JH4>LL4W=<4W?<5ic`8ool5mkh4
_ML8_OL5F//44:840005244448846<<46><58@@48B@4:DD5:FD8S744g_/5oml4ool4g_/5g]/4e[X4
Ljh48B@900046><58B@4Q104e[X4oml5ool4oml4mih5ked7ool000Koo`Ukk`@YA@@080D000@8@@@@
PPD@XPA[C@C>F@Cg_PGoo`Cog`CgWPG_G@CW?0B<L@@aQPD080@000@080DaYP@ia`BLd`BLl`GW?0So
o`Gg_PBme`Rmm`EJb`@@XP@000D8@@@@PP@H``@Hh`DQ10@Q90@YA@DYI@R<L@CNn`Gog`Coo`CNn`GN
f`CF^PAc[P@Q90T000@Hh`DQ90B440CF^PCog`Goo`Cog`CgWPG_G@Ooo`001_oo2G__12U5100P1@00
10Q111221A2R16]=1<iI1?Nn1Ooo1?oO1?NN1NmM1>Ll18aa13661@0P1000100P1C6V13W719cC19cc
1NLl2?oo1ONn1;gG2;gg1E[;112R10001@Q1112211S311SS1B44124T12U51BUU28aa1=kk1OoO1?oo
1=kk1MkK1=Jj17>^124T2@0011SS1B4T18@@1=Jj1?oO1Ooo1?oO1?NN1NmM1ooo0006ool9Nnl4:DD4
02050004244448854:84Jdd4cUT4mkh5ool4oml4mih5ked4ic`4S744<HH5020400040205<JH4>LL4
W=<4W?<5ic`8ool5mkh4_ML8_OL5F//44:840005244448846<<46><58@@48B@4:DD5:FD8S744g_/5
oml4ool4g_/5g]/4e[X4Ljh48B@900046><58B@4Q104e[X4oml5ool4oml4mih5ked7ool000Koo`GW
70B<L@@aQP@080D000@080Tii`BU50CW?0Woo`Cg_PVme`ABZP@@XP@000D8@@@@PP@H``E[K@C>F@Cg
_PCoo`Gog`C6>0AS;0ES30@H``@000@080E220BU=0C_G@Woo`Cg_PBme`EBZP@@PPT000@8@@@@PP@H
``DHh`@Q10@Q90DYA@PYI@TaQQ4aYPBLd`CW70Woo`Cg_PFme`Ooo`001_oo1NLL18aa1366100P1@00
100P2CWW1:DD1>Ll2Ooo1?Nn2KgG15:Z112R10001@Q1112211S31F]]1<iI1?Nn1?oo1OoO1<Hh16</
1F<<11S31000100P1D881:Dd1>mM2Ooo1?Nn1;gG1E:Z11222@0010Q1112211S31ASS1244124T1BU5
22UU2C664C6V19cC1>LL2Ooo1?Nn1KgG1ooo0006ool5ia`4S744<HH4020500040209>NL4YA@4ic`9
ool4mkh9_ML4DZX44:840005244448846<<5Jfd4cUT4mkh4ool5oml4aSP4Hb`5H``46<<400040205
@PP4YC@4ked9ool4mkh4_ML5DZX448890004244448846<<56><48@@48B@5:DD8:FD9<HHA<JH4W=<4
ia`9ool4mkh5_ML7ool000Koo`GW70B<L@@aQP@080D000@080Tii`BU50CW?0Woo`Cg_PVme`ABZP@@
XP@000D8@@@@PP@H``E[K@C>F@Cg_PCoo`Gog`C6>0AS;0ES30@H``@000@080E220BU=0C_G@Woo`Cg
_PBme`EBZP@@PPT000@8@@@@PP@H``DHh`@Q10@Q90DYA@PYI@TaQQ4aYPBLd`CW70Woo`Cg_PFme`Oo
o`001_oo1E:Z15::11222@0012U512UU3Haa1=kk1Nmm2?oo1ONn1>mm1>Ll19BB1C6V10Q110001A2R
11SS1244124T2H@@2G__1=Jj1?oO1?oo1NLL1=kk1=kK1MJj17>^124T112R1@0010Q111221AS311SS
124417__1MJj1?oO1?oo1MJj17>^124T100P1@00100P10QQ1A2R16</16<<15[[1LHH1<iI1?Nn3?oo
0006ool5DZX4DXX448890004:DD4:FD=S744g_/5kgd8ool5mkh4kgd4ic`4U985<JH4244400054:84
6><48@@48B@9Q109Nnl4e[X4oml4ool5ia`4g_/4g]/5e[X4Ljh48B@44:850004244448856<<46><4
8@@4Nnl5e[X4oml4ool5e[X4Ljh48B@402050004020426454:84Hb`4H``4F^/5aQP4cUT4mkh<ool0
00Koo`EBZPABRP@@PPT000@YA@@YI@f<L@CNn`G_O@Soo`Gg_PC_O@CW?0BDTPDaYP@8@@@000D@XP@H
h`@Q10@Q90V440Ukk`CF^PCog`Coo`GW70CNn`CNf`GF^PAc[P@Q90@@XPD000@8@@@@PPDH``@Hh`@Q
10Akk`GF^PCog`Coo`GF^PAc[P@Q90@080D000@080@8H@D@XPAS;0AS30AJj`G660C>F@Cg_Pcoo`00
1_oo1E:Z15::11222@0012U512UU3Haa1=kk1Nmm2?oo1ONn1>mm1>Ll19BB1C6V10Q110001A2R11SS
1244124T2H@@2G__1=Jj1?oO1?oo1NLL1=kk1=kK1MJj17>^124T112R1@0010Q111221AS311SS1244
17__1MJj1?oO1?oo1MJj17>^124T100P1@00100P10QQ1A2R16</16<<15[[1LHH1<iI1?Nn3?oo0006
ool5ic`4S744U984U;85<JH4:DD402050004020A@PP9YC@4ked4ool4mkh5kgd4ic`4ia`5Q304:FD4
020400058@@48B@4:DD9:FD8<HHBU;84ia`8ool5mkh4_OL4F//5DZX4DXX4BVT4488900048B@5Q104
Nnl4e[X4oml5ool4ia`4g_/5Q104Q304:FD46><9000402052647ool000Koo`GW?0B<L@BDTPBD/PDa
YP@YA@@080D000@0815220VU=0C_G@Coo`Cg_PG_O@CW?0CW70F4<0@YI@@080@000DQ10@Q90@YA@TY
I@PaQQ:D/PCW70Soo`Gg_PBmm`AJb`EBZPABRPA:J@@@PPT000@Q90F440Akk`CF^PCog`Goo`CW70CN
n`F440B4<0@YI@@Hh`T000@080D8H@Ooo`001_oo1NLl18aa19BB19Bb1C6V12U5100P1@00100P4D88
2JDd1>mM1?oo1?Nn1Nmm1>Ll1>LL1H@`12UU100P10001B44124T12U52BUU23664YBb1>LL2?oo1ONn
1;gg15[;1E:Z15::14YY11222@00124T1H@@17__1=Jj1?oO1Ooo1>LL1=kk1H@@18@`12UU11SS2@00
100P1@QQ1ooo0006ool5ic`4S744U984U;85<JH4:DD402050004020A@PP9YC@4ked4ool4mkh5kgd4
ic`4ia`5Q304:FD4020400058@@48B@4:DD9:FD8<HHBU;84ia`8ool5mkh4_OL4F//5DZX4DXX4BVT4
488900048B@5Q104Nnl4e[X4oml5ool4ia`4g_/5Q104Q304:FD46><9000402052647ool000Koo`GW
?0B<L@BDTPBD/PDaYP@YA@@080D000@0815220VU=0C_G@Coo`Cg_PG_O@CW?0CW70F4<0@YI@@080@0
00DQ10@Q90@YA@TYI@PaQQ:D/PCW70Soo`Gg_PBmm`AJb`EBZPABRPA:J@@@PPT000@Q90F440Akk`CF
^PCog`Goo`CW70CNn`F440B4<0@YI@@Hh`T000@080D8H@Ooo`001_oo1A2R16]=16</1<Hh1ONn1?oo
1>mM1NLl18aa1366100P1@0011S311SS1B44124T18@`2H@@17__17_?1MJJ1?oO1?oo1>LL1Haa29BB
1C6V12U5100P10002BU518aA1Mkk1>mm1?oo1?NN1Jee14Y911222@0012UU13663IBB1Mkk1?NN2?oo
2Lii2F]=11SS10QQ10001@Q1112211S31ASS1ooo0006ool54:84Jdd4Hb`4aSP5mkh4ool4ked5ic`4
S744<HH4020500046<<46><58@@48B@4Q309Q104Nnl4Nll5eYX4oml4ool4ia`5S748U985<JH4:DD4
02040009:DD4S545g_/4kgd4ool4mih5[GD4BTT448890004:FD4<HH=U985g_/4mih8ool9cWT9Jdd4
6><426440005244448846<<56><7ool000Koo`D@XPA[C@AS;0C6>0Gg_PCoo`C_G@GW?0B<L@@aQP@0
80D000@H``@Hh`DQ10@Q90B4<0V440Akk`Akc`GFVPCog`Coo`CW70F<L@RDTPDaYP@YA@@080@000TY
A@B<D@GNn`C_O@Coo`CgWPF]M@A:B@@@PPT000@YI@@aQPfDTPGNn`CgWPSoo`W>N@U[C@@Hh`@8H@@0
00D8@@@@PP@H``DHh`Ooo`001_oo1A2R16]=16</1<Hh1ONn1?oo1>mM1NLl18aa1366100P1@0011S3
11SS1B44124T18@`2H@@17__17_?1MJJ1?oO1?oo1>LL1Haa29BB1C6V12U5100P10002BU518aA1Mkk
1>mm1?oo1?NN1Jee14Y911222@0012UU13663IBB1Mkk1?NN2?oo2Lii2F]=11SS10QQ10001@Q11122
11S31ASS1ooo0006ool5Ljh4eYX4oml4ool5ic`4S744U985<JH4244400044:856><4Ljh4Lhh5cWT4
mkh4ool4oml5mih4[GD4BTT5@PP42648000524444884F^/5aQP4mih4ool4ked5ic`4g_/4g]/5Nnl4
Q104Q304:DD56><8000502042644F//4DZX9DXX4]IH5kgd8ool4mkh5kgd4YA@4>NL5244800042449
BTT4[GD5kgd7ool000Koo`Ec[PCFVPCog`Coo`GW?0B<L@BDTPDaYP@8@@@000@@XPDHh`Ac[PAcSPG>
N@Cg_PCoo`Cog`GgWPB]M@A:B@E220@8H@P000D8@@@@PPAJj`G660CgWPCoo`C_G@GW?0CNn`CNf`Ek
k`B440B4<0@YA@DHh`P000D080@8H@AJb`ABZPUBRPBeUPG_O@Soo`Cg_PG_O@BU50@ii`D8@@P000@8
@@U:B@B]M@G_O@Ooo`001_oo1G>^1=JJ1?oO1?oo1NLl18aa19BB1C6V10Q11000112R1ASS17>^17>>
1Lii1?Nn1?oo1?oO1ONN1:ee14Y91D8810QQ20001@Q1112215[[1LHH1?NN1?oo1>mM1NLl1=kk1=kK
1G__18@@18@`12U51ASS20001@0P10QQ15[;15:Z2E::1;FF1Nmm2?oo1?Nn1Nmm1:DD13WW1@Q12000
10Q12DY91:ee1Nmm1ooo0006ool5Ljh4eYX4oml4ool5ic`4S744U985<JH4244400044:856><4Ljh4
Lhh5cWT4mkh4ool4oml5mih4[GD4BTT5@PP42648000524444884F^/5aQP4mih4ool4ked5ic`4g_/4
g]/5Nnl4Q104Q304:DD56><8000502042644F//4DZX9DXX4]IH5kgd8ool4mkh5kgd4YA@4>NL52448
00042449BTT4[GD5kgd7ool000_oo`CgWPB]M@A:B@D@PP@000@8H@D@XPAS;0AS30C660Gg_PCoo`Co
g`G>F@A[C@@Hh`@000D080@8H@@@XPDH``AcSPC>N@Cg_PGoo`Cog`CgWPF]M@A:B@A220@ia`D8@@@0
00@@XPDH``@Q10Akc`CFVPGW70Soo`Gg_PC_O@C_G@CW70GNn`CNf`CF^PWFVPA[K@UcSP@Q10@@PPT0
00@YI@@aQPVDTPCNn`G_O@Ooo`002ooo1?NN1:ee14Y91A22100010QQ1A2R16</16<<1<HH1ONn1?oo
1?oO1LiI16]=11SS10001@0P10QQ112R1AS317>>1<ii1?Nn1Ooo1?oO1?NN1Jee14Y9148813W71@Q1
1000112R1AS3124417_?1=JJ1NLL2?oo1ONn1>mm1>mM1>LL1Mkk1=kK1=Jj2MJJ16]]2G>>12441122
2@0012UU13662IBB1=kk1Nmm1ooo000;ool4mih4[GD4BTT54884000426454:84Hb`4H``4aQP5mkh4
ool4oml5cUT4Jdd46><40005020426444:856<<4Lhh4cWT4mkh5ool4oml4mih5[GD4BTT4@PP4>LL5
244400044:856<<48@@4Nll4eYX5ia`8ool5mkh4kgd4ked4ia`5g_/4g]/4e[X9eYX4Jfd9Lhh48@@4
48890004:FD4<HH9U984g_/5kgd7ool000_oo`CgWPB]M@A:B@D@PP@000@8H@D@XPAS;0AS30C660Gg
_PCoo`Cog`G>F@A[C@@Hh`@000D080@8H@@@XPDH``AcSPC>N@Cg_PGoo`Cog`CgWPF]M@A:B@A220@i
a`D8@@@000@@XPDH``@Q10Akc`CFVPGW70Soo`Gg_PC_O@C_G@CW70GNn`CNf`CF^PWFVPA[K@UcSP@Q
10@@PPT000@YI@@aQPVDTPCNn`G_O@Ooo`003ooo2<ii3LiI1F</11S320001@0P10QQ112R1ASS1244
17__1=Jj1OoO1?oo1?Nn1Nmm1:Dd148810QQ2@002C66136V29Bb1NLL2?oo1MkK1=Jj17_?124T1@0P
1000100P1CWW1:DD1:Dd1>mM1OoO1?oo1?oO1ONN1>mM1>LL18aa1C66100P10001@0P23WW19cc1NLl
2?oo1ONn1ooo000?ool8cWT=cUT5Hb`46<<80005020426444:856><48@@4Nnl4e[X5oml4ool4mkh5
kgd4YC@4@PP426490009<HH4<JH8U;85ia`8ool5g]/4e[X4Nll48B@5020400040205>NL4YA@4YC@4
ked5oml4ool4oml5mih4ked4ia`4S745<HH4020400050208>NL4W?<5ic`8ool5mkh7ool000ooo`S>
N@g>F@ES;0@H``P000D080@8H@@@XPDHh`@Q10Akk`CF^PGog`Coo`Cg_PG_O@BU=0A220@8H@T000Ta
QP@aYPRD/PGW70Soo`GNf`CF^PAkc`@Q90D080@000@080Dii`BU50BU=0C_G@Gog`Coo`Cog`GgWPC_
G@CW70B<L@DaQP@080@000D080Pii`BLl`GW?0Soo`Gg_POoo`003ooo2<ii3LiI1F</11S320001@0P
10QQ112R1ASS124417__1=Jj1OoO1?oo1?Nn1Nmm1:Dd148810QQ2@002C66136V29Bb1NLL2?oo1MkK
1=Jj17_?124T1@0P1000100P1CWW1:DD1:Dd1>mM1OoO1?oo1?oO1ONN1>mM1>LL18aa1C66100P1000
1@0P23WW19cc1NLl2?oo1ONn1ooo000?ool8cWT=cUT5Hb`46<<80005020426444:856><48@@4Nnl4
e[X5oml4ool4mkh5kgd4YC@4@PP426490009<HH4<JH8U;85ia`8ool5g]/4e[X4Nll48B@502040004
0205>NL4YA@4YC@4ked5oml4ool4oml5mih4ked4ia`4S745<HH4020400050208>NL4W?<5ic`8ool5
mkh7ool000Koo`Fme`ABZP@@XP@080D000@YA@TYI@RDTPCNn`Gog`Coo`Cg_Pfmm`C660EJj`AJb`@@
XPD080@000@H``@Q10DQ90PYA@DYI@PaQPBDTPGW70CgWPWoo`SFVPC>N@E[K@@Hh`T000@080@8H@@@
XPDHh`@Q10Akk`Ekc`CFVPCog`Coo`GW70B<L@@aQPDQ90@080@000@Hh`DQ90@YA@B4<0GNf`Ooo`00
1_oo1KgG15:Z112R100P1@0012U52BUU29BB1=kk1OoO1?oo1?Nn3Kgg1<HH1E[[15[;112R1@0P1000
11S312441B4T22U51BUU236619BB1NLL1?NN2Ooo2=JJ1<ii1F]]11SS2@00100P10QQ112R1ASS1244
17__1G_?1=JJ1?oO1?oo1NLL18aa13661B4T100P100011SS1B4T12U518@`1MkK1ooo0006ool5_ML4
DZX44:8402050004:DD9:FD8U984g_/5oml4ool4mkh=_OL4aQP5F^/4F//44:85020400046<<48@@5
8B@8:DD5:FD8<HH4U985ia`4mih9ool8eYX4cWT5Jfd46><90004020426444:856><48@@4Nnl5Nll4
eYX4oml4ool5ia`4S744<HH58B@4020400046><58B@4:DD4Q305g]/7ool000Koo`Fme`ABZP@@XP@0
80D000@YA@TYI@RDTPCNn`Gog`Coo`Cg_Pfmm`C660EJj`AJb`@@XPD080@000@H``@Q10DQ90PYA@DY
I@PaQPBDTPGW70CgWPWoo`SFVPC>N@E[K@@Hh`T000@080@8H@@@XPDHh`@Q10Akk`Ekc`CFVPCog`Co
o`GW70B<L@@aQPDQ90@080@000@Hh`DQ90@YA@B4<0GNf`Ooo`001_oo1OoO1?oo1=kk18@`1HaA12UU
100P1@0011S316]]1<iI1MkK1?oO1?oo1OoO1<HH15[[112R1@0010Q111221A2R16]=1<iI1=Jj1OoO
1?oo1>LL1Mkk1=kK1=Jj17>^1B4T20001@Q1112211S311SS1G>^1=JJ1?oO1Ooo1>Ll18aa13661@0P
1000100P1@QQ15::1;Ff1?NN2Ooo1<ii3F]]17>>1B4411222@001ooo0006ool5oml4ool4g_/4Q305
S544:FD4020500046<<4Jfd4cUT5g]/4oml4ool5oml4aQP4F^/44:850004244448854:84Jdd4cUT4
e[X5oml4ool4ia`5g_/4g]/4e[X4Ljh58B@80005244448846<<46><5Ljh4eYX4oml5ool4ic`4S744
<HH50204000402052644DXX4]KH4mih9ool4cWT=Jfd4Lhh58@@448890007ool000Koo`Gog`Coo`CN
n`B4<0F<D@@YI@@080D000@H``A[K@C>F@GNf`Cog`Coo`Gog`C660AJj`@@XPD000@8@@@@PPD@XPA[
C@C>F@CF^PGog`Coo`CW70GNn`CNf`CF^PAc[PDQ90P000D8@@@@PP@H``@Hh`Ec[PCFVPCog`Goo`CW
?0B<L@@aQPD080@000@080D8H@ABRPBe]PCgWPWoo`C>N@e[K@AcSPDQ10@@PPT000Ooo`001_oo1OoO
1?oo1=kk18@`1HaA12UU100P1@0011S316]]1<iI1MkK1?oO1?oo1OoO1<HH15[[112R1@0010Q11122
1A2R16]=1<iI1=Jj1OoO1?oo1>LL1Mkk1=kK1=Jj17>^1B4T20001@Q1112211S311SS1G>^1=JJ1?oO
1Ooo1>Ll18aa13661@0P1000100P1@QQ15::1;Ff1?NN2Ooo1<ii3F]]17>>1B4411222@001ooo0006
ool58B@4:DD4S544g]/5oml4ool4oml5mih4ked4ia`4S745<HH48@@448890004:DD4:FD9<HH4U985
ia`4mih4ool4oml9cWT9Jdd46><42644000548846<<46><5Ljh4eYX4g_/4oml5ool4mkh4mih5ked4
ia`4g_/4Q105:DD402040005020426444:846<<58@@4Nll4eYX5ia`4mih4ool4oml5mkh4kgd4ic`5
g_/7ool000Koo`DQ90@YA@B<D@CNf`Gog`Coo`Cog`GgWPC_G@CW70B<L@DaQP@Q10@@PPT000@YA@@Y
I@TaQPBDTPGW70CgWPCoo`Cog`W>N@U[C@@Hh`@8H@@000D@PP@H``@Hh`Ec[PCFVPCNn`Cog`Goo`Cg
_PCgWPG_G@CW70CNn`B440DYA@@080@000D080@8H@@@XP@H``DQ10Akc`CFVPGW70CgWPCoo`Cog`Gg
_PC_O@CW?0GNn`Ooo`001_oo1B4T12U518aA1=kK1OoO1?oo1?oO1ONN1>mM1>LL18aa1C6612441122
2@0012U512UU2C6619BB1NLL1?NN1?oo1?oO2Lii2F]=11SS10QQ10001A2211S311SS1G>^1=JJ1=kk
1?oO1Ooo1?Nn1?NN1NmM1>LL1=kk18@@1BU5100P10001@0P10QQ112R11S31B4417_?1=JJ1NLL1?NN
1?oo1?oO1ONn1>mm1>Ll1Mkk1ooo0006ool58B@4:DD4S544g]/5oml4ool4oml5mih4ked4ia`4S745
<HH48@@448890004:DD4:FD9<HH4U985ia`4mih4ool4oml9cWT9Jdd46><42644000548846<<46><5
Ljh4eYX4g_/4oml5ool4mkh4mih5ked4ia`4g_/4Q105:DD402040005020426444:846<<58@@4Nll4
eYX5ia`4mih4ool4oml5mkh4kgd4ic`5g_/7ool000Koo`F4<0@YI@@080@000DQ10@Q90B4<0F440CF
^PCog`Coo`Gog`C660AJj`D@XPP000TYA@B<D@CNn`G_O@Soo`WFVPC>N@e[K@@Hh`T000@Q10Akk`GF
^PCog`Coo`Cg_PG_O@CW?0CW70GNn`CNf`CF^PCFVPEcSP@Q10T000@080Pii`FU50BU=0C_G@Woo`CF
^PCFVPW>N@U[K@Ooo`001_oo1H@`12UU100P10001B44124T18@`1H@@1=Jj1?oO1?oo1OoO1<HH15[[
1A2R20002BU518aA1=kk1Nmm2?oo2MJJ1<ii3F]]11SS2@00124417__1MJj1?oO1?oo1?Nn1Nmm1>Ll
1>LL1Mkk1=kK1=Jj1=JJ1G>>12442@00100P23WW1JDD1:Dd1>mM2Ooo1=Jj1=JJ2Lii2F]]1ooo0006
ool5Q304:FD4020400058@@48B@4Q305Q104e[X4oml4ool5oml4aQP4F^/54:880009:DD4S544g_/5
kgd8ool9eYX4cWT=Jfd46><900048@@4Nnl5e[X4oml4ool4mkh5kgd4ic`4ia`5g_/4g]/4e[X4eYX5
Lhh48@@900040208>NL5YA@4YC@4ked9ool4e[X4eYX9cWT9Jfd7ool000Koo`F4<0@YI@@080@000DQ
10@Q90B4<0F440CF^PCog`Coo`Gog`C660AJj`D@XPP000TYA@B<D@CNn`G_O@Soo`WFVPC>N@e[K@@H
h`T000@Q10Akk`GF^PCog`Coo`Cg_PG_O@CW?0CW70GNn`CNf`CF^PCFVPEcSP@Q10T000@080Pii`FU
50BU=0C_G@Woo`CF^PCFVPW>N@U[K@Ooo`001_oo1H@`12UU100P10001B44124T18@`1H@@1=Jj1?oO
1?oo1OoO1<HH15[[1A2R20002BU518aA1=kk1Nmm2?oo2MJJ1<ii3F]]11SS2@00124417__1MJj1?oO
1?oo1?Nn1Nmm1>Ll1>LL1Mkk1=kK1=Jj1=JJ1G>>12442@00100P23WW1JDD1:Dd1>mM2Ooo1=Jj1=JJ
2Lii2F]]1ooo0006ool56><4264800052448@RP5[ED4[GD4kgd4ool5mih4[GD4]IH5BVT448880005
020=@PP4>NL4YA@4YC@5[ED4ked9ool4eYX=Ljh48B@900046><48B@4Q105Nnl4Nll4eYX5oml4ool4
oml4mih5[ED4BTT4@PP5264400044884F^/5_OL4cUT4e[X5oml4ool4oml4aQP5F^/46<<402050007
ool000Koo`DHh`@8H@P000D8@@Q2:0F]E@B]M@C_O@Coo`GgWPB]M@BeUPE:J@@@PPP000D080e220@i
i`BU50BU=0F]E@C_G@Woo`CFVPec[P@Q90T000@Hh`@Q90B440Ekk`Akc`CFVPGog`Coo`Cog`CgWPF]
E@A:B@A220D8H@@000@@PPAJj`Fmm`C>F@CF^PGog`Coo`Cog`C660EJj`@H``@080D000Ooo`001_oo
1ASS10QQ20001@Q1248X1JeE1:ee1>mm1?oo1ONN1:ee1;FF1DYY112220001@0P3D8813WW1:DD1:Dd
1JeE1>mM2Ooo1=JJ3G>^124T2@0011SS124T18@@1G__17_?1=JJ1OoO1?oo1?oO1?NN1JeE14Y91488
1@QQ1000112215[[1Kgg1<iI1=Jj1OoO1?oo1?oO1<HH1E[[11S3100P1@001ooo0006ool56><42648
00052448@RP5[ED4[GD4kgd4ool5mih4[GD4]IH5BVT448880005020=@PP4>NL4YA@4YC@5[ED4ked9
ool4eYX=Ljh48B@900046><48B@4Q105Nnl4Nll4eYX5oml4ool4oml4mih5[ED4BTT4@PP526440004
4884F^/5_OL4cUT4e[X5oml4ool4oml4aQP5F^/46<<402050007ool000Koo`DH``@Hh`@Q10Akk`GF
^PCog`Coo`Gog`S660AJj`DH``P000DQ90@YA@R<D@GNf`Sog`Gg_PBeUPRe]PEBRPA:J@A:B@D8H@P0
00@8@@E:B@B]M@C_O@Gog`Coo`Cg_PCgWPG_G@CW70CNn`GNf`CF^PSFVPW>N@C>F@E[C@@Hh`@8H@T0
00@8@@@@PPDH``@Hh`@Q10@Q90F4<0B440CNf`G_G@Ooo`001_oo1AS311SS124417__1MJj1?oO1?oo
1OoO2<HH15[[1AS320001B4T12U528aA1MkK2?oO1ONn1;FF2;Ff1E::14YY14Y91@QQ200010Q11DY9
1:ee1>mm1OoO1?oo1?Nn1?NN1NmM1>LL1=kk1MkK1=Jj2=JJ2Lii1<iI1F]=11SS10QQ2@0010Q11122
1AS311SS1244124T1H@`18@@1=kK1NmM1ooo0006ool56<<46><48@@4Nnl5e[X4oml4ool5oml8aQP4
F^/56<<800058B@4:DD8S545g]/8oml5mkh4]IH8]KH5DXX4BVT4BTT5264800042445BTT4[GD4kgd5
oml4ool4mkh4mih5ked4ia`4g_/5g]/4e[X8eYX9cWT4cUT5Jdd46><426490004244448856<<46><4
8@@48B@5Q304Q104g]/5ked7ool000Koo`DH``@Hh`@Q10Akk`GF^PCog`Coo`Gog`S660AJj`DH``P0
00DQ90@YA@R<D@GNf`Sog`Gg_PBeUPRe]PEBRPA:J@A:B@D8H@P000@8@@E:B@B]M@C_O@Gog`Coo`Cg
_PCgWPG_G@CW70CNn`GNf`CF^PSFVPW>N@C>F@E[C@@Hh`@8H@T000@8@@@@PPDH``@Hh`@Q10@Q90F4
<0B440CNf`G_G@Ooo`003ooo1=Jj2MJJ2<ii3LiI2F</11S310Q11@00112211S311SS1B4T12U52H@`
1=kK1>mM2Ooo1?Nn1>mm1JDD148810QQ2@0010Q111221E[[1;gg1?NN1?oo1OoO1<ii3LiI1<Hh16</
1AS320001@0P10QQ112R11SS1B44124T2H@@17__1=Jj1>Ll2Ooo1?Nn1KgG1ooo000?ool4e[X9eYX8
cWT=cUT9Hb`46<<42445000448846<<46><58B@4:DD9Q304g]/4ked9ool4mkh4kgd5YA@4@PP42649
000424444885F^/4_OL4mih4ool5oml4cWT=cUT4aSP4Hb`56<<80005020426444:846><58@@48B@9
Q104Nnl4e[X4ic`9ool4mkh5_ML7ool000ooo`CF^PWFVPS>N@g>F@US;0@H``@8@@D000@@PP@H``@H
h`DQ90@YA@V4<0CNf`C_G@Woo`Cg_PC_O@FU50A220@8H@T000@8@@@@PPEJj`Bmm`CgWPCoo`Gog`C>
N@g>F@C6>0AS;0DH``P000D080@8H@@@XP@Hh`DQ10@Q90V440Akk`CF^PCW?0Woo`Cg_PFme`Ooo`00
3ooo1=Jj2MJJ2<ii3LiI2F</11S310Q11@00112211S311SS1B4T12U52H@`1=kK1>mM2Ooo1?Nn1>mm
1JDD148810QQ2@0010Q111221E[[1;gg1?NN1?oo1OoO1<ii3LiI1<Hh16</1AS320001@0P10QQ112R
11SS1B44124T2H@@17__1=Jj1>Ll2Ooo1?Nn1KgG1ooo0006ool5DZX44:8402040005020A>NL4W?<4
YA@5YC@4ked9ool4mkh4kgd4ic`5ia`4g_/4g]/5Nll4Nnl48B@402050004020426454:846<<48@@4
Nll5eYX4oml4ool5mkh4kgd4ked4U;85W=<4>LL4244500044:846<<4Lhh5cWT4mkh4ool5oml4mih4
ked4ic`5S744<HH4020500040208>LL5W?<4ic`@ool000Koo`EBZP@@XP@080@000D0814ii`BLl`BU
50FU=0C_G@Woo`Cg_PC_O@CW?0GW70CNn`CNf`Ekc`Akk`@Q90@080D000@080@8H@D@XP@H``@Q10Ak
c`GFVPCog`Coo`Gg_PC_O@C_G@BD/PFLd`@ia`@8@@D000@@XP@H``AcSPG>N@Cg_PCoo`Gog`CgWPC_
G@CW?0F<L@@aQP@080D000@080Pia`FLl`CW?13oo`001_oo1E:Z112R100P10001@0P4CWW19cc1:DD
1JDd1>mM2Ooo1?Nn1>mm1>Ll1NLL1=kk1=kK1G_?17__124T100P1@00100P10QQ1A2R11S3124417_?
1MJJ1?oO1?oo1ONn1>mm1>mM19Bb1IcC13W710Q11@00112R11S317>>1Lii1?Nn1?oo1OoO1?NN1>mM
1>Ll1Haa1366100P1@00100P23W71Icc1>Ll4?oo0006ool5DZX44:8402040005020A>NL4W?<4YA@5
YC@4ked9ool4mkh4kgd4ic`5ia`4g_/4g]/5Nll4Nnl48B@402050004020426454:846<<48@@4Nll5
eYX4oml4ool5mkh4kgd4ked4U;85W=<4>LL4244500044:846<<4Lhh5cWT4mkh4ool5oml4mih4ked4
ic`5S744<HH4020500040208>LL5W?<4ic`@ool000Koo`EBZP@@XP@080@000D0814ii`BLl`BU50FU
=0C_G@Woo`Cg_PC_O@CW?0GW70CNn`CNf`Ekc`Akk`@Q90@080D000@080@8H@D@XP@H``@Q10Akc`GF
VPCog`Coo`Gg_PC_O@C_G@BD/PFLd`@ia`@8@@D000@@XP@H``AcSPG>N@Cg_PCoo`Gog`CgWPC_G@CW
?0F<L@@aQP@080D000@080Pia`FLl`CW?13oo`001_oo2MJj1=JJ2Lii4LiI1<Hh16</1AS310Q12@00
10Q1112211S31F]]16]=16</2F<<15[[1;gg1ONN1?oo1?oO1ONN1>mm19cc13WW1@Q120001@Q11122
11S311SS1B44124T12U51HaA1=kK1?oO1?oo1OoO1?NN1>mM1NLL28aa19BB1C6V10Q110001@0P10QQ
112R11S31B4417_?1=JJ1NLL1ooo0006ool9e[X4eYX9cWTAcUT4aSP4Hb`56<<42449000424444884
6<<5Jfd4Jdd4Hb`9H``4F^/4_OL5mih4ool4oml5mih4kgd4W?<4>NL524480005244448846<<46><5
8@@48B@4:DD5S544g]/4oml4ool5oml4mih4ked5ia`8S744U985<JH424440005020426444:846<<5
8@@4Nll4eYX5ia`7ool000Koo`WF^PCFVPW>NA7>F@C6>0AS;0DH``@8@@T000@8@@@@PP@H``E[K@A[
C@AS;0US30AJj`Bmm`GgWPCoo`Cog`GgWPC_O@BLl`@ii`D8@@P000D8@@@@PP@H``@Hh`DQ10@Q90@Y
A@F<D@CNf`Cog`Coo`Gog`CgWPC_G@GW70R<L@BDTPDaYP@8@@@000D080@8H@@@XP@H``DQ10Akc`CF
VPGW70Ooo`001_oo2MJj1=JJ2Lii4LiI1<Hh16</1AS310Q12@0010Q1112211S31F]]16]=16</2F<<
15[[1;gg1ONN1?oo1?oO1ONN1>mm19cc13WW1@Q120001@Q1112211S311SS1B44124T12U51HaA1=kK
1?oO1?oo1OoO1?NN1>mM1NLL28aa19BB1C6V10Q110001@0P10QQ112R11S31B4417_?1=JJ1NLL1ooo
000?ool4g]/4e[X9Nll4Nnl58B@40204000424454884F//4_OL5mih4ool4oml4mih5kgd4W?<4>NL5
2444000448844:85Jdd4cUT4e[X5oml4ool4oml4mih5ked4W=<4>LL524480009<JH4U;84W=<5ia`8
ool4mkh5kgd4ked4ia`5g_/4g]/4e[X4Ljh5Nll48B@44:890004244448854:846><4Ljh5Lhh7ool0
00ooo`CNf`CF^PUkc`Akk`DQ90@080@000@8@@D@PPAJb`Bmm`GgWPCoo`Cog`CgWPG_O@BLl`@ii`D8
@@@000@@PP@@XPE[C@C>F@CF^PGog`Coo`Cog`CgWPG_G@BLd`@ia`D8@@P000TaYPBD/PBLd`GW70So
o`Cg_PG_O@C_G@CW70GNn`CNf`CF^PAc[PEkc`@Q90@@XPT000@8@@@@PPD@XP@Hh`Ac[PEcSPOoo`00
3ooo1=kK1=Jj2G_?17__1B4T100P100010Q11A2215[;1;gg1ONN1?oo1?oO1?NN1Nmm19cc13WW1@Q1
10001122112R1F]=1<iI1=Jj1OoO1?oo1?oO1?NN1NmM19cC13W71@Q120002C6V19Bb19cC1NLL2?oo
1?Nn1Nmm1>mM1>LL1Mkk1=kK1=Jj17>^1G_?124T112R2@0010Q111221A2R11SS17>^1G>>1ooo000?
ool4g]/4e[X9Nll4Nnl58B@40204000424454884F//4_OL5mih4ool4oml4mih5kgd4W?<4>NL52444
000448844:85Jdd4cUT4e[X5oml4ool4oml4mih5ked4W=<4>LL524480009<JH4U;84W=<5ia`8ool4
mkh5kgd4ked4ia`5g_/4g]/4e[X4Ljh5Nll48B@44:890004244448854:846><4Ljh5Lhh7ool000Ko
o`E[K@C>F@CNf`Cog`Goo`Cg_PC_O@FU50A220@8H@T000@aQPBD/PGW70Soo`Cg_PFmm`AJb`@@XPD0
80@000@080Tia`BLl`CW?0Gg_PCoo`Cog`CgWPG_G@CW?0B<L@DaQP@Q90@@XPT000@8@@@@PPUJb`Bm
e`CgWPGoo`Cog`Cg_PG_O@CW?0CW70B4<0DYI@@080@000DH``@Q10@Q90TYA@B<D@CNn`Gog`Ooo`00
1_oo1F]]1<iI1=kK1?oO1Ooo1?Nn1>mm1JDD148810QQ2@00136619Bb1NLL2?oo1?Nn1Kgg15[;112R
1@0P1000100P2CW719cc1>Ll1ONn1?oo1?oO1?NN1NmM1>Ll18aa1C66124T112R2@0010Q111222E[;
1;gG1?NN1Ooo1?oO1?Nn1Nmm1>Ll1>LL18@`1BUU100P10001AS31244124T2BU518aA1=kk1OoO1ooo
0006ool5Jfd4cUT4g]/4oml5ool4mkh4kgd5YA@4@PP426490004<HH4U;85ia`8ool4mkh5_OL4F//4
4:85020400040209>LL4W?<4ic`5mkh4ool4oml4mih5ked4ic`4S745<HH48B@44:89000424444889
F//4_ML4mih5ool4oml4mkh5kgd4ic`4ia`4Q305:FD4020400056<<48@@48B@9:DD4S544g_/5oml7
ool000Koo`E[K@C>F@CNf`Cog`Goo`Cg_PC_O@FU50A220@8H@T000@aQPBD/PGW70Soo`Cg_PFmm`AJ
b`@@XPD080@000@080Tia`BLl`CW?0Gg_PCoo`Cog`CgWPG_G@CW?0B<L@DaQP@Q90@@XPT000@8@@@@
PPUJb`Bme`CgWPGoo`Cog`Cg_PG_O@CW?0CW70B4<0DYI@@080@000DH``@Q10@Q90TYA@B<D@CNn`Go
g`Ooo`002ooo1=kk1=kK17__1B4T100P10001@0P10QQ15:Z1;Ff1Kgg1?NN2Ooo1?Nn1>mm1>Ll1IBB
136V10Q11@00112R11SS12441B4T28@@1MJj1?oO1?oo1?oO1ONN1:eE2Jee14Y9112210001@0P10QQ
112R1AS317>>1<ii1=kK1OoO1?oo1=kk1MkK17__18@@12U51@0P1000100P1CWW19cc1:DD2JDd1>mM
4?oo000;ool4g_/4g]/4Nnl58B@40204000502042644DZX4]KH5_OL4mih9ool4mkh4kgd4ic`5U984
<JH4244500044:846><48@@58B@8Q105e[X4oml4ool4oml5mih4[ED9[GD4BTT44884000502042644
4:856<<4Lhh4cWT4g]/5oml4ool4g_/5g]/4Nnl4Q104:DD5020400040205>NL4W?<4YA@9YC@4ked@
ool000_oo`CNn`CNf`Akk`DQ90@080@000D080@8H@ABZPBe]PFmm`CgWPWoo`Cg_PC_O@CW?0FDTP@a
YP@8@@D000@@XP@Hh`@Q10DQ90R440GF^PCog`Coo`Cog`GgWPB]E@V]M@A:B@@@PP@000D080@8H@@@
XPDH``AcSPC>N@CNf`Gog`Coo`CNn`GNf`Akk`B440@YA@D080@000@080Dii`BLl`BU50VU=0C_GA3o
o`002ooo1=kk1=kK17__1B4T100P10001@0P10QQ15:Z1;Ff1Kgg1?NN2Ooo1?Nn1>mm1>Ll1IBB136V
10Q11@00112R11SS12441B4T28@@1MJj1?oO1?oo1?oO1ONN1:eE2Jee14Y9112210001@0P10QQ112R
1AS317>>1<ii1=kK1OoO1?oo1=kk1MkK17__18@@12U51@0P1000100P1CWW19cc1:DD2JDd1>mM4?oo
000;ool4g_/4g]/4Nnl58B@40204000502042644DZX4]KH5_OL4mih9ool4mkh4kgd4ic`5U984<JH4
244500044:846><48@@58B@8Q105e[X4oml4ool4oml5mih4[ED9[GD4BTT448840005020426444:85
6<<4Lhh4cWT4g]/5oml4ool4g_/5g]/4Nnl4Q104:DD5020400040205>NL4W?<4YA@9YC@4ked@ool0
00Koo`Gg_PBme`ABZP@@PPT000@8@@D@PPAJj`AJb`Bme`GgWPCoo`Cog`Gg_PBeUPRe]PFme`ABRP@@
PPD000@8@@@@PP@H``E[K@A[C@C>F@GF^PCog`Coo`Cog`W660UJj`@@XPP000D8@@@@PPAJb`Fmm`Cg
WPCoo`Cog`Gg_PC_O@CW?0GNn`CNf`SF^PGFVPS>N@E[C@Q[K@@Hh`T000@080D8H@Ooo`001_oo1ONn
1;gG15:Z11222@0010Q11A2215[[15[;1;gG1ONN1?oo1?oO1ONn1;FF2;Ff1KgG15::11221@0010Q1
112211S31F]]16]=1<iI1MJj1?oO1?oo1?oO2LHH2E[[112R20001@Q1112215[;1Kgg1?NN1?oo1?oO
1ONn1>mm1>Ll1Mkk1=kK2=Jj1MJJ2<ii1F]=26]]11SS2@00100P1@QQ1ooo0006ool5mkh4_ML4DZX4
4889000424454884F^/4F//4_ML5mih4ool4oml5mkh4]IH8]KH5_ML4DXX448850004244448846<<5
Jfd4Jdd4cUT5e[X4oml4ool4oml9aQP9F^/44:88000524444884F//5_OL4mih4ool4oml5mkh4kgd4
ic`5g_/4g]/8e[X5eYX8cWT5Jdd8Jfd46><9000402052647ool000Koo`Gg_PBme`ABZP@@PPT000@8
@@D@PPAJj`AJb`Bme`GgWPCoo`Cog`Gg_PBeUPRe]PFme`ABRP@@PPD000@8@@@@PP@H``E[K@A[C@C>
F@GF^PCog`Coo`Cog`W660UJj`@@XPP000D8@@@@PPAJb`Fmm`CgWPCoo`Cog`Gg_PC_O@CW?0GNn`CN
f`SF^PGFVPS>N@E[C@Q[K@@Hh`T000@080D8H@Ooo`001_oo1A2R11SS124417__1MJj1>LL2Ooo1?Nn
1>mm1:Dd1D8810QQ10001A2215[[15[;15:Z2E::14YY1KFF1>mm1?oo1?NN1NmM19cC19cc1CWW10Q1
20001@Q1112215[[1LHH1?NN1?oo1>mM1NLl19BB13661@Q11000100P13W71Icc1>Ll1?Nn1Ooo1>mM
1>LL1=kk1H@@12U511S31@00100P4CWW2JDD1ooo0006ool54:846><48@@4Nnl5e[X4ia`9ool4mkh4
kgd4YC@5@PP4264400054884F^/4F//4DZX9DXX4BVT5]IH4kgd4ool4mih5ked4W=<4W?<5>NL42448
000524444884F^/5aQP4mih4ool4ked5ic`4U984<HH5244400040204>LL5W?<4ic`4mkh5ool4ked4
ia`4g_/5Q104:DD46<<50004020A>NL9YA@7ool000Koo`D@XP@Hh`@Q10Akk`GF^PCW70Woo`Cg_PC_
O@BU=0E220@8H@@000D@PPAJj`AJb`ABZPUBRPA:J@FeUPC_O@Coo`CgWPG_G@BLd`BLl`Dii`@8@@P0
00D8@@@@PPAJj`G660CgWPCoo`C_G@GW?0BDTP@aQPD8@@@000@080@ia`FLl`CW?0Cg_PGoo`C_G@CW
70CNn`F440@YA@@H``D000@0814ii`VU50Ooo`001_oo1A2R11SS124417__1MJj1>LL2Ooo1?Nn1>mm
1:Dd1D8810QQ10001A2215[[15[;15:Z2E::14YY1KFF1>mm1?oo1?NN1NmM19cC19cc1CWW10Q12000
1@Q1112215[[1LHH1?NN1?oo1>mM1NLl19BB13661@Q11000100P13W71Icc1>Ll1?Nn1Ooo1>mM1>LL
1=kk1H@@12U511S31@00100P4CWW2JDD1ooo0006ool5ked8ool4mkh5_ML4DZX4DXX5BTT4@RP4>NL4
<HH58B@4020400050204>NL4YA@4ic`5mkh4ool4oml5aSP4H``46<<400050208@PP5YC@4ked4oml4
ool5ia`4S744U985<JH4244400040205264448846<<9Jfd4cUT4mkh5ool4ic`4U;85W=<4>LL42444
00050204244448856<<46><48B@4:DD5Q304g]/4oml<ool000Koo`G_G@Soo`Cg_PFme`ABZPABRPE:
B@A2:0@ii`@aQPDQ90@080@000D080@ii`BU50CW?0Gg_PCoo`Cog`G6>0AS30@H``@000D080Q220FU
=0C_G@Cog`Coo`GW70B<L@BDTPDaYP@8@@@000@080D8H@@@PP@H``U[K@C>F@Cg_PGoo`CW?0BD/PFL
d`@ia`@8@@@000D080@8@@@@PPDH``@Hh`@Q90@YA@F4<0CNf`Cog`coo`001_oo1NmM2?oo1?Nn1KgG
15:Z15::1DY9148X13WW13661B4T100P10001@0P13WW1:DD1>Ll1ONn1?oo1?oO1LHh16<<11S31000
1@0P24881JDd1>mM1?oO1?oo1NLL18aa19BB1C6V10Q11000100P1@QQ112211S32F]]1<iI1?Nn1Ooo
1>Ll19Bb1IcC13W710Q110001@0P10Q111221AS311SS124T12U51H@`1=kK1?oO3?oo0006ool5ked8
ool4mkh5_ML4DZX4DXX5BTT4@RP4>NL4<HH58B@4020400050204>NL4YA@4ic`5mkh4ool4oml5aSP4
H``46<<400050208@PP5YC@4ked4oml4ool5ia`4S744U985<JH4244400040205264448846<<9Jfd4
cUT4mkh5ool4ic`4U;85W=<4>LL4244400050204244448856<<46><48B@4:DD5Q304g]/4oml<ool0
00Koo`Gog`C660AJj`@@XPT000@YA@V4<0CNf`C_G@Goo`Cg_PC_O@GW?0CW70B<D@@YI@D080@000@0
80dia`BLl`GW?0Cg_PCoo`G_G@CW70CNn`B440F4<0@YI@@080D000@Q90B440Akk`Ekc`CFVPCog`Go
o`Cog`CgWPC_G@GW70B<L@BDTPDaYP@8@@@000@080DaYPPia`FLd`CW?0Coo`Cg_PG_O@BU=0B]E@F]
M@Ooo`001_oo1OoO1<HH15[[112R2@0012U52H@`1=kK1>mM1Ooo1?Nn1>mm1NLl1>LL18aA12UU1@0P
1000100P3CW719cc1NLl1?Nn1?oo1NmM1>LL1=kk18@@1H@`12UU100P1@00124T18@@17__1G_?1=JJ
1?oO1Ooo1?oO1?NN1>mM1NLL18aa19BB1C6V10Q11000100P1C6V23W71IcC1>Ll1?oo1?Nn1Nmm1:Dd
1:eE1Jee1ooo0006ool5oml4aQP4F^/44:890004:DD9Q304g]/4ked5ool4mkh4kgd5ic`4ia`4S544
:FD502040004020=>LL4W?<5ic`4mkh4ool5ked4ia`4g_/4Q105Q304:FD4020500048B@4Q104Nnl5
Nll4eYX4oml5ool4oml4mih4ked5ia`4S744U985<JH4244400040205<JH8>LL5W=<4ic`4ool4mkh5
kgd4YC@4[ED5[GD7ool000Koo`Gog`C660AJj`@@XPT000@YA@V4<0CNf`C_G@Goo`Cg_PC_O@GW?0CW
70B<D@@YI@D080@000@080dia`BLl`GW?0Cg_PCoo`G_G@CW70CNn`B440F4<0@YI@@080D000@Q90B4
40Akk`Ekc`CFVPCog`Goo`Cog`CgWPC_G@GW70B<L@BDTPDaYP@8@@@000@080DaYPPia`FLd`CW?0Co
o`Cg_PG_O@BU=0B]E@F]M@Ooo`001_oo1OoO1<HH15[[112R2@0012U52H@`1=kK1>mM1Ooo1?Nn1>mm
1NLl1>LL18aA12UU1@0P1000100P3CW719cc1NLl1?Nn1?oo1NmM1>LL1=kk18@@1H@`12UU100P1@00
124T18@@17__1G_?1=JJ1?oO1Ooo1?oO1?NN1>mM1NLL18aa19BB1C6V10Q11000100P1C6V23W71IcC
1>Ll1?oo1?Nn1Nmm1:Dd1:eE1Jee1ooo0006ool5BTT4264800058B@4:DD4:FD5S744g_/4oml4ool5
g_/4g]/4Nll5Nnl4:DD4020400056><48@@48B@5Q304g]/4oml4ool5mkh4kgd4YA@5YC@4@PP4>LL4
:FD5020400046<<5Jfd4cUT4g]/4oml5ool4mkh4kgd5YA@4@PP426490004244448856<<46><4Nll4
eYX5g_/8ool5mkh4kgd4ked4ia`5g_/4Q104Q305:FD7ool000Koo`E:B@@8H@P000DQ90@YA@@YI@F<
L@CNn`Cog`Coo`GNn`CNf`Akc`Ekk`@YA@@080@000DHh`@Q10@Q90F4<0CNf`Cog`Coo`Gg_PC_O@BU
50FU=0A220@ia`@YI@D080@000@H``E[K@C>F@CNf`Cog`Goo`Cg_PC_O@FU50A220@8H@T000@8@@@@
PPDH``@Hh`Akc`CFVPGNn`Soo`Gg_PC_O@C_G@CW70GNn`B440B4<0DYI@Ooo`001_oo1DY910QQ2000
1B4T12U512UU1Haa1=kk1?oO1?oo1Mkk1=kK17_?1G__12U5100P10001ASS1244124T1H@`1=kK1?oO
1?oo1ONn1>mm1:DD1JDd148813W712UU1@0P100011S31F]]1<iI1=kK1?oO1Ooo1?Nn1>mm1JDD1488
10QQ2@0010Q111221AS311SS17_?1=JJ1Mkk2?oo1ONn1>mm1>mM1>LL1Mkk18@@18@`1BUU1ooo0006
ool5BTT4264800058B@4:DD4:FD5S744g_/4oml4ool5g_/4g]/4Nll5Nnl4:DD4020400056><48@@4
8B@5Q304g]/4oml4ool5mkh4kgd4YA@5YC@4@PP4>LL4:FD5020400046<<5Jfd4cUT4g]/4oml5ool4
mkh4kgd5YA@4@PP426490004244448856<<46><4Nll4eYX5g_/8ool5mkh4kgd4ked4ia`5g_/4Q104
Q305:FD7ool000Koo`D080@000@080U220BU=0C_G@Goo`Cg_PC_O@BU50E220@aYP@YA@D080@000@8
@@A220FU=0C_G@Cog`Goo`CW70B<D@B<L@DaQP@Q90T000@080@8H@@@XPDH``AcSPA[K@G>F@Cg_PCo
o`Cog`GgWPB]E@A:B@E220@8H@P000D8@@A:J@BeUPG_O@Soo`CFVPW>N@C>F@E[C@@Hh`P000D080A2
20BU=0F]E@Ooo`001_oo1@0P1000100P2D881:Dd1>mM1Ooo1?Nn1>mm1:DD1D88136V12U51@0P1000
10Q114881JDd1>mM1?oO1Ooo1>LL18aA18aa1C66124T2@00100P10QQ112R1AS317>>16]]1LiI1?Nn
1?oo1?oO1ONN1:eE14Y91D8810QQ20001@Q114YY1;FF1Nmm2?oo1=JJ2Lii1<iI1F]=11SS20001@0P
14881:Dd1JeE1ooo0006ool5020400040209@PP4YC@4ked5ool4mkh4kgd4YA@5@PP4<JH4:DD50204
00042444@PP5YC@4ked4oml5ool4ia`4S544S745<HH48B@90004020426444:856<<4Lhh4Jfd5cUT4
mkh4ool4oml5mih4[ED4BTT5@PP4264800052444BVT4]IH5kgd8ool4eYX9cWT4cUT5Jdd46><80005
0204@PP4YC@5[ED7ool000Koo`D080@000@080U220BU=0C_G@Goo`Cg_PC_O@BU50E220@aYP@YA@D0
80@000@8@@A220FU=0C_G@Cog`Goo`CW70B<D@B<L@DaQP@Q90T000@080@8H@@@XPDH``AcSPA[K@G>
F@Cg_PCoo`Cog`GgWPB]E@A:B@E220@8H@P000D8@@A:J@BeUPG_O@Soo`CFVPW>N@C>F@E[C@@Hh`P0
00D080A220BU=0F]E@Ooo`001_oo1NmM1?oO1?oo1>LL2HaA18aa1C66100P1000100P2CW719cC2Icc
1>Ll1?oo1ONn1>mm1>mM1NLL18aA18aa19BB1C6V10Q110001@0P10QQ15::1;Ff1Nmm2?oo1ONn1>mm
1:Dd14881@QQ100011221AS311SS124417__1G_?1=JJ1?oO1Ooo1>LL18aa13661@0P1000100P1@QQ
112R16<<1<HH1ONn1?oo1?oO1LiI1ooo0006ool5ked4oml4ool4ia`9S544S745<HH4020400040209
>LL4W=<9W?<4ic`4ool5mkh4kgd4ked5ia`4S544S744U985<JH42444000502042644DXX4]KH5kgd8
ool5mkh4kgd4YC@4@PP52644000448856<<46><48@@4Nnl5Nll4eYX4oml5ool4ia`4S744<HH50204
0004020526444:84H``4aQP5mkh4ool4oml5cUT7ool000Koo`G_G@Cog`Coo`CW70V<D@B<L@DaQP@0
80@000@080Tia`BLd`VLl`CW?0Coo`Gg_PC_O@C_G@GW70B<D@B<L@BDTPDaYP@8@@@000D080@8H@AB
RPBe]PG_O@Soo`Gg_PC_O@BU=0A220D8H@@000@@PPDH``@Hh`@Q10Akk`Ekc`CFVPCog`Goo`CW70B<
L@@aQPD080@000@080D8H@@@XPAS30C660Gg_PCoo`Cog`G>F@Ooo`001_oo1NmM1?oO1?oo1>LL2HaA
18aa1C66100P1000100P2CW719cC2Icc1>Ll1?oo1ONn1>mm1>mM1NLL18aA18aa19BB1C6V10Q11000
1@0P10QQ15::1;Ff1Nmm2?oo1ONn1>mm1:Dd14881@QQ100011221AS311SS124417__1G_?1=JJ1?oO
1Ooo1>LL18aa13661@0P1000100P1@QQ112R16<<1<HH1ONn1?oo1?oO1LiI1ooo0006ool5Jdd46><4
264400054884F^/4aQP5mih4ool4ked4ic`9U984U;85>LL4244400040205244448846<<56><4Nll4
Ljh4eYX5g_/4kgd9ool4mkh4kgd4ic`5ia`4g]/9e[X4Ljh48@@900040209>NL4YA@4YC@4[ED5ked8
ool5mkh4kgd4YA@4YC@5@PP426490004<HH4U984ia`5mih4ool4oml5cWT7ool000Koo`E[C@@Hh`@8
H@@000D@PPAJj`C660GgWPCoo`C_G@CW?0VDTPBD/PDia`@8@@@000@080D8@@@@PP@H``DHh`Akc`Ac
[PCFVPGNn`C_O@Woo`Cg_PC_O@CW?0GW70CNf`WF^PAc[P@Q10T000@080Tii`BU50BU=0B]E@G_G@So
o`Gg_PC_O@BU50BU=0E220@8H@T000@aQPBDTPCW70GgWPCoo`Cog`G>N@Ooo`001_oo1F]=11SS10QQ
10001A2215[[1<HH1ONN1?oo1>mM1>Ll2IBB19Bb1CW710Q11000100P1@Q1112211S31ASS17_?17>^
1=JJ1Mkk1>mm2Ooo1?Nn1>mm1>Ll1NLL1=kK2MJj17>^12442@00100P2CWW1:DD1:Dd1:eE1NmM2?oo
1ONn1>mm1:DD1:Dd1D8810QQ2@00136619BB1>LL1ONN1?oo1?oO1Lii1ooo0006ool5Jdd46><42644
00054884F^/4aQP5mih4ool4ked4ic`9U984U;85>LL4244400040205244448846<<56><4Nll4Ljh4
eYX5g_/4kgd9ool4mkh4kgd4ic`5ia`4g]/9e[X4Ljh48@@900040209>NL4YA@4YC@4[ED5ked8ool5
mkh4kgd4YA@4YC@5@PP426490004<HH4U984ia`5mih4ool4oml5cWT7ool000Koo`E[C@@Hh`@8H@@0
00D@PPAJj`C660GgWPCoo`C_G@CW?0VDTPBD/PDia`@8@@@000@080D8@@@@PP@H``DHh`Akc`Ac[PCF
VPGNn`C_O@Woo`Cg_PC_O@CW?0GW70CNf`WF^PAc[P@Q10T000@080Tii`BU50BU=0B]E@G_G@Soo`Gg
_PC_O@BU50BU=0E220@8H@T000@aQPBDTPCW70GgWPCoo`Cog`G>N@Ooo`001_oo1Lii1<iI16]=11SS
1@QQ20001@Q114Y9148X1:ee1NmM2?oo1ONn1>mm1:DD1:Dd1D8813W712UU1@0P1000100P10QQ1E::
1;Ff1;gg1LHh1?Nn1?oo1?oO1ONN1>mM1>Ll1Mkk1=kK17__12U51@0P100010Q11A22112R11SS1244
1B4T18@`1=kK1OoO1?oo1?oO1<HH1E[[15[;112R2@0010Q1148X1JeE1>mM4?oo0006ool5cWT4cUT4
Jdd46><5264800052444BTT4@RP4[GD5ked8ool5mkh4kgd4YA@4YC@5@PP4>LL4:FD5020400040204
2645DXX4]KH4_OL5aSP4mkh4ool4oml5mih4ked4ic`5g_/4g]/4Nnl4:DD502040004244548844:84
6><48@@58B@4Q304g]/5oml4ool4oml4aQP5F^/4F//44:8900042444@RP5[ED4ked@ool000Koo`G>
N@C>F@A[C@@Hh`D8H@P000D8@@A:B@A2:0B]M@G_G@Soo`Gg_PC_O@BU50BU=0E220@ia`@YI@D080@0
00@080@8H@EBRPBe]PBmm`G6>0Cg_PCoo`Cog`GgWPC_G@CW?0GNn`CNf`Akk`@YA@D080@000@8@@D@
PP@@XP@Hh`@Q10DQ90B4<0CNf`Gog`Coo`Cog`C660EJj`AJb`@@XPT000@8@@A2:0F]E@C_GA3oo`00
1_oo1Lii1<iI16]=11SS1@QQ20001@Q114Y9148X1:ee1NmM2?oo1ONn1>mm1:DD1:Dd1D8813W712UU
1@0P1000100P10QQ1E::1;Ff1;gg1LHh1?Nn1?oo1?oO1ONN1>mM1>Ll1Mkk1=kK17__12U51@0P1000
10Q11A22112R11SS12441B4T18@`1=kK1OoO1?oo1?oO1<HH1E[[15[;112R2@0010Q1148X1JeE1>mM
4?oo0006ool5eYX4Ljh48@@4488900048@@5Nll4eYX4oml4ool5g]/4e[X9eYX4cWT8Jfd56><80005
020426444:846><58@@48B@4Q105g]/4oml4ool4mkh5kgd4ic`4ia`5g_/8Q104:DD56><400040205
>NL8YA@4ic`5mkh4ool4oml5mih4[ED4[GD4BTT5@PP4264400052648DXX4BVT5]IH4_ML4aQP5mih7
ool000Koo`GFVPAc[P@Q10@@PPT000@Q10Ekc`CFVPCog`Coo`GNf`CF^PWFVPC>N@Q[K@DHh`P000D0
80@8H@@@XP@Hh`DQ10@Q90B440GNf`Cog`Coo`Cg_PG_O@CW?0CW70GNn`R440@YA@DHh`@000@080Di
i`RU50CW?0Gg_PCoo`Cog`GgWPB]E@B]M@A:B@E220@8H@@000D8H@QBRPA:J@FeUPBme`C660GgWPOo
o`001_oo1MJJ17>^124411222@0012441G_?1=JJ1?oO1?oo1MkK1=Jj2MJJ1<ii26]]1ASS20001@0P
10QQ112R11SS1B44124T18@@1MkK1?oO1?oo1?Nn1Nmm1>Ll1>LL1Mkk28@@12U51ASS1000100P1CWW
2:DD1>Ll1ONn1?oo1?oO1ONN1:eE1:ee14Y91D8810QQ10001@QQ25::14YY1KFF1;gG1<HH1ONN1ooo
0006ool5eYX4Ljh48@@4488900048@@5Nll4eYX4oml4ool5g]/4e[X9eYX4cWT8Jfd56><800050204
26444:846><58@@48B@4Q105g]/4oml4ool4mkh5kgd4ic`4ia`5g_/8Q104:DD56><400040205>NL8
YA@4ic`5mkh4ool4oml5mih4[ED4[GD4BTT5@PP4264400052648DXX4BVT5]IH4_ML4aQP5mih7ool0
00_oo`C_G@CW?0BDTPVD/P@ia`D8@@@000@080@8@@U:J@BeUPG_O@Coo`CgWPC_G@GW70CNn`B4<0DY
A@@Hh`@8H@T000@8@@@@PPDH``@Hh`@Q10@Q90DYA@PYI@FDTPB<L@CNn`C_O@Woo`Cg_PG_O@BU50@i
i`@8@@D000@@PPAS30EJj`Bmm`CgWPCoo`G_O@CW?0CW70F4<0B<D@@YI@@080D000@080@8H@EBRPOo
o`002ooo1>mM1>Ll19BB2IBb13W71@Q11000100P10Q12DYY1;FF1Nmm1?oo1?NN1>mM1NLL1=kk18@`
1BU511SS10QQ2@0010Q111221AS311SS1244124T1BU522UU1IBB18aa1=kk1>mm2Ooo1?Nn1Nmm1:DD
13WW10Q11@00112216<<1E[[1;gg1?NN1?oo1Nmm1>Ll1>LL1H@`18aA12UU100P1@00100P10QQ1E::
1ooo000;ool4ked4ic`4U989U;84>LL52444000402042449BVT4]IH5kgd4ool4mih4ked5ia`4g_/4
Q305:DD46><426490004244448856<<46><48@@48B@5:DD8:FD5U984S744g_/4kgd9ool4mkh5kgd4
YA@4>NL4244500044884H``5F^/4_OL4mih4ool5kgd4ic`4ia`5Q304S544:FD40205000402042645
DXX7ool000_oo`C_G@CW?0BDTPVD/P@ia`D8@@@000@080@8@@U:J@BeUPG_O@Coo`CgWPC_G@GW70CN
n`B4<0DYA@@Hh`@8H@T000@8@@@@PPDH``@Hh`@Q10@Q90DYA@PYI@FDTPB<L@CNn`C_O@Woo`Cg_PG_
O@BU50@ii`@8@@D000@@PPAS30EJj`Bmm`CgWPCoo`G_O@CW?0CW70F4<0B<D@@YI@@080D000@080@8
H@EBRPOoo`001_oo2DYY1;FF1;Ff1Kgg1?NN1?oo1OoO1<ii4F]=11SS2@00100P2D881:Dd1>mM2Ooo
1?Nn1>mm1JDD148810QQ2@0023661C6V29Bb2IcC1>LL2Ooo1?Nn1;gg2E:Z1122100P1@00100P10QQ
1A2R11S317>>16]]2F]=1<Hh1ONn1?oo1?oO1?NN1Jee2;FF1DYY1ooo0006ool9BVT4]IH4]KH5_OL4
mih4ool5oml4cWTAJdd46><900040209@PP4YC@4ked9ool4mkh4kgd5YA@4@PP426490008<HH5<JH8
U;89W=<4ia`9ool4mkh4_OL9DZX4488402050004020426454:846<<4Lhh4Jfd9Jdd4aSP5mkh4ool4
oml4mih5[GD8]IH5BVT7ool000Koo`U:J@BeUPBe]PFmm`CgWPCoo`Gog`C>NA5[C@@Hh`T000@080U2
20BU=0C_G@Woo`Cg_PC_O@FU50A220@8H@T000PaQPDaYPRD/PVLd`CW70Woo`Cg_PBmm`UBZP@@PP@0
80D000@080@8H@D@XP@H``AcSPA[K@U[C@C6>0Gg_PCoo`Cog`CgWPF]M@ReUPE:J@Ooo`001_oo2DYY
1;FF1;Ff1Kgg1?NN1?oo1OoO1<ii4F]=11SS2@00100P2D881:Dd1>mM2Ooo1?Nn1>mm1JDD148810QQ
2@0023661C6V29Bb2IcC1>LL2Ooo1?Nn1;gg2E:Z1122100P1@00100P10QQ1A2R11S317>>16]]2F]=
1<Hh1ONn1?oo1?oO1?NN1Jee2;FF1DYY1ooo0006ool9BVT4]IH4]KH5_OL4mih4ool5oml4cWTAJdd4
6><900040209@PP4YC@4ked9ool4mkh4kgd5YA@4@PP426490008<HH5<JH8U;89W=<4ia`9ool4mkh4
_OL9DZX4488402050004020426454:846<<4Lhh4Jfd9Jdd4aSP5mkh4ool4oml4mih5[GD8]IH5BVT7
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00
\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-1.60033, -1.60033, 0.234148, \
0.234148}}],

Cell[BoxData[
    TagBox[
      RowBox[{"\[SkeletonIndicator]", "Graphics", "\[SkeletonIndicator]"}],
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"Show", "[", 
        RowBox[{"gr", ",", 
          RowBox[{"DisplayFunction", "\[Rule]", "$DisplayFunction"}]}], "]"}],
       ";"}]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 4 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% PlotRegion
0 1 0 1 MPlotRegion
% Scaling calculations
0.0238095 0.014881 0.0952381 0.0595238 [
[ 0 0 0 0 ]
[ 1 4 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 4 L
0 4 L
closepath
clip
newpath
% Start of gray image
p
.02381 .09524 translate
.95238 3.80952 scale
64 string
64 64 8 [64 0 0 64 0 0] {
\tcurrentfile
\t1 index
\treadhexstring
\tpop
}  Mimage
00040B4F4D4B49474644A9EBFBFFF9C2C35E1801012886DAEAFEF5EEE7E1882E1F030022
7E7B7875D0F9FFF9C05C170109105CBEF3FFFCCD6B1E0201070F161C
217DD5FAFFFAF2EAE4DF84878A8E310700040C514FB3EFFFFDF5EEE793969A9D3C320700
050D54B7F1FEFEF7EFE8E28A2F06001A1F24807E7BD4FAFEF8F0E996
370900040C1362C3F5FFFCF4B1B34F11000D1464C4CFF8FFFAF3EB9B9FA240372B050126
292C2F3132949494E2F2FFFDF6B75313000B4FB3EFFDF9F1EAE4DE84
2B1C0201070F1668C7F6FFFBF3EC9DA13F350800171D2226292C2F3192E1FDFFF8F0E9E3
8B300700050C141A70CDDAFBFFF9C1C15D5B1606001A706DCAF7FFE8
E28A2F210300060E161C73CFDCFCFCF5EDE6E0872D0600070F161C217CD4E3FDF9C25E17
0700050D151B212582D8FBFDD4D271727375230300060E1567C6F6FF
FBF4B04C463D330800040C141A706D69C8D4FAFFFAF2ACAE4A0F00020A4AAEEDFFF3EB9C
A0A3A6A9ACAEB1B3B5B752130002094846ABECFFF4EC9EA2400C0003
0B4DB1EEFFFDD2CFCE6C1E0D0003313295E2FDFEDBD7D4D2CFCECC6A6A691D02050D141B
71CEF8FFE7E1DCD87A7C7E81291A0101084342A7EAFAFEF7BB571405
00050D151B202582D8FBFFF9C25E180108105A57BAF2FFFCF5EDE6E0DCD87A7C7E280400
063CA1E7FEF7EFA5420D00020911186C6865C5F5FFFCF4ECE6E0DB7F
280501292C8C8B89DCFCFFDFDA7E80290500050D1565C5F5FFFBCA67671C02060E1566C6
F5FFFBCAC9661B0B00030B13191F79D2F9FFFAC5C561190101272A2D
8EDEEEFDFEF8F0A7440D0010176B67C7F6FFFBF4EC9DA13F0B00020A125F5B5855B9F1FF
FCF5EDE6E1DC8082852C1D0D00030A125FC1F4FFEFA5A8AB470E0101
0845AAEBFFFDD4D2CF6E6E1F0200070F161C2126292C2E30323496E2F3FFFDF5EEA14036
0800040C50B4EFFFFDF5B5B7524E11000D53514EB2B9F1FEFEF7EFA4
A7AAAD490F0101272B2D8E8DDEFCFFF9F1A9450E00030A12191E237F7DD5FAFFE3DE832B
0500050D151B2025282B2E30329494E1FDFFDC7F28190101278482D8
FBFFF9C2C25E180700040C514EB3EFFFF2EA9A3A0A00043536373738399CE5F6FFFBF4EC
E5E086892E0600217B78D2F9FFFAC561190101272A8ADCFCFFDFDAD7
78240400060E555350B4EFFEF9F1E9983909001566C6F6FFEBE4DFDAD7D4D1CF6D1F0204
3838399C9EE6FEF8F0A7440D00030A4CB0EEFFFDD271211002012428
2B2E30323396E2F3FFEEA1A442392D0600050D1464C4F5FFFCCC691D02012481D7FBFFF9
C35E1801010810176A66C6F6FFFBCA67671C020107434241A5E9F9FF
E48E3107001D227E7BD4FAFFE4DEDA7D270400063D3DA1A3A6A9ADB2EFFFFDF6EEE7E188
2E0600050D141B202581D8FBFEF6B8BA55511200020911186CCAF7FF
FBC7C66361601801080F5956BAC2F4FFFCCC691D020124817ED6FAFFFAC3C3C35F180101
272B8A8987DBEBFFF5B44F11000209115D5ABCF2FFEEE7E1888C3007
00196ECBF7FFE8E28A8D310700050C514F4D4BAFEDFFFDF6EEE793979A9EA13F0B000333
95E2FDFEDBD7797B260400060E151B2125292C8C8B89DCECFBFFF9F1
EAE38D310700050C141A20242887DBFBFFF9F1EA9939090004353699E4FDFEDAD6D37322
110300074040A4E9FEFED67779250400060E1566C6F6FFEBE4DFDA7D
808285888B3022120002094847ABECFBFFF9C1C1C2C2C25E5C59150500050D146561C2F4
FFECE5909397372C0500050D1464C5F5FFEB9B3A2F0600063EA3E8FE
FEF7EFE8E2DDD97B26160600060E161C7370CCF8FFFBF3EBE58F9296370900161C212629
2C2E908FDFFCFFF8BF5B58544F4A0F010108105A5754514FB3B9F1FE
FEF7EFE8E2DD812A050108444342414140A4E9FEFEF7B9BBBC57531300020911181E76D1
F9FFFAC56219010127848280D7FAFFFAF2EAE4DEDA7D271801081017
6AC8F6FFFBC8651B0101070F1769C8D4FAFFFAF2AC480F00020A4B4947ACECFBFDF5EDE7
E1882E1F0F00020A12181E77D1E0F0FFFDD0CECCCBCA67661B0B0013
62C3F4FFFCF5ED9FA341372B1C0201070F161C74CFDDFCFFDE842B0500050D1465C5F5FF
FCF4B1B3B5511200022C8D8CDDFCFCCC6A1D020124288684827F7D7A
D3E2FDFEDB7F8184872D0600050D5250B4BBF2FFFCCECDCB696868681C0B00030B1260C2
F4FFFCCE6C1E0E01012A898886DAEAFEFEF7EFA4410C00115E5B5855
B8C0F4FFFCCCCBCAC966651B02010743A8ABB0EEFDFFF8F0A8AB470E000F1669C8F6FFFB
F3EC9DA0A4410C00030B12191F7875D0F9FFFAC6C5C5C5615F180108
10171D75D0F9FFDFDB7E280400060D54524F4DB1B7F0FFFDF5EDA13F0B0003333497E3F3
FFEDE6919598390900040B131A6F6C68C7F6FFFBF3B0B24E1102050D
52504D4B4948ACECFFF4ECE590330800181E227ED6FAFFE3DDD9D6D372210300060E1667
C6D2F9FFFAF2EB9B9E3D0B0003343536379AE4F5FFFCF4EDE6919498
9B9F3E330800050D141B716ECBD8E7FEF7BA5614000A12605CBEC8D4E3FDFAC35F180101
08105A575451B5BCC5D1F9FFFAC6C5C5611901070F161C7471CDF8FF
FBF3EBE5DFDBD7D4D170201000022E8F8EDFFCFFDD822A0500050D151B716ECBD8FBFDF6
EEA3A6430D0011186B6864615D5A57BAF2FFFCF5EDE6E0878A2F2103
00063F3FA3A6EAFEF6B6B753130300060E5653B7BEF3FFF2ABAEB0B2B4504B440D000209
4846ABECFFFDF6EEE7E1892E200300070E57BAF2FFEFE8E28A8D9033
0800050D1464C5D0F8FFE6E0DBD7D4D2712103040B131A1F7976D0DFEFFFFDF5EEA1400C
00030B4DB1B7BFF3FFFCF4ED9FA2A5433A0A000435989899E4FDFEDA
7D7F2805010810176AC9F6FFFBF3ECE5903307000438389C9DE6FEFEF7BBBCBD5915010A
11181E23272A2D8E8CDEFCFFDEDAD677240300202481D7FBFFF9F2EA
E48D310700063C3CA0E7FEFEF7BABC5714000A12196DCBF7FFFBC865641A010740A4E9FE
FEF7B9551400020911181E22272A2D2F3133343536379AE4FDFEF8BC
57541300022B2E8F8E8DDEEEFFFDF6EEE793350800171D222684817F7CD5FAFFE3DEDAD6
772414000B12191F2380D7FAFED677240400060E1566635FC1CBF7FF
E5909397372C05010742414040A4A7EAFEF5EDE7E1882E06002226292C2F313295949494
E2FDFEF8BD5956524C10020125817FD6FAFFE2DD82852C1D0201070F
166865C5F5FFECE58F330700181E23278583807E7BD4FAFFE48D909435290501282B8BDD
EDFFF3AF4B1000022E30929291E0F1FFFCCFCE6C6C1E0D000A12191F
78D2F9FFE58F92340800171D7572CEF8FFFBF3AE4A430D00030A1260C1F4FFECE6E0DB7F
81842B1D0201070F58555250B4EFFFFDF5EEA13F0B00020A4A49ADED
FFF3AF4B10000E156663C3F5FFFCCB681C02050D151B72CEF8FFFBF3AE4A433A0A00141A
207AD3E1FDFEF8F0E9E3DED9D6D3D16F7071211000022E309291E0F0
FFFDD0CECCCBCA671C0201070F161D227DD5FAFEF7F0A6430D00033133349797E3FDFEDA
D778240400063EA2A5E9F9FFFAF2EBE48E320700053C3CA0E7FEFEF7
BA561404022A2D2F9190DFFCFFF8BFBFC0C05C591505001B2125292C2E303294E1F2FFFD
D4D1CF6D1F0200070F161C217C79D3F9FFE48E3124040020242886DA
FBFFE086892F06001A6FCCD9FBFFF9C25D17010810176AC9D5FAFFE3DED9D6772403030A
12191E77D1F9FFE58F320700050D53B7F0FFFDD06E6F6F7020100201
252988DBFCFFF9F1EAE38C31231300022B2E303294E1F2FFFCCECC6A6A1D0D0011181E77
D1DFFCFFF8F1E9E3DE832B0500050D151B207BD4E2F3FFFCF4EDE6E0
872D060022268482D8FBFFF9C25E180101282B8BDDEDFFFDD3D0CE6D6D6D1F0200237FD6
FAFEF7EFE8E2DDD9D5D37221030006403FA3A6EAFEFED5D3D0CE6C6D
1E0E0101084645A9ADEDFFF3AFB24D110201074241403FA4A7AAEBFFFDD4747677240400
2024817E7CD4FAFFFAF2AC48410C00125FC0CAD7FAFFFAC35F180700
181E237ED6FAFFFAC3C35F180101272B8A89DCFCFCF5B4B6B7534E480F00020A4BAFEDFC
FFF8F1E9E3DEDAD6D3D1CFCDCB691D0C00030B12191F23278684D9E8
FEFED6D3D1CFCDCCCAC966661B0B00131A2024288785D9E9FEFEF7EFA4420C000209115D
BFF3FFFCCDCBCAC9C8651B0201070F161D222684817FD6E5FEFEF7BC
57140500053C3C3C3CA0A2A4E9FEFEF7EFE8E2DDD97B7D270400060D151B217BD4FAFEF8
F0E9969A3A0A00151B71CEF8FFFBF3EBE58F320700053B3B9FE7FEFE
D8D4D2D0CECCCBCAC9C8651B0A00030B13196E6B6764605DBFF3FFFCF4ED9F3E0B00030A
12191F23272A8ADCFCFFF9F1EAE38C9093350800050C141A207AD3E2
FDFEDBD7797B7D27040209105CBEF3FFFCF4ED9F3E0B0010176AC9D5FAFFFAF2EA9A3A0A
000334359898E4FDFEF8F0E9E2DDD9D67678241500010910171D7673
6FCCD9FBFDF6EEA2400C00033295E2FDFEF8BD59150500053B3B9FE7F7FFFBF3ECE58F32
2516010108105B58BBF2FFFCF5EDE6E0872D06001A2024282B8BDDFC
FFDEDA7D270400060D54B8C0F4FFFDF5EDE792350800171D22268482D8FBFFF9F2ABADB0
4C1002060E151C72CEDCFCFFDFDA7E80290500053CA0A2A5A8EAFFFE
F6B85413000209115C59BCF2FFFCF5B3B5B7B85413000B13196E6BC9D6FAFFFAC3C35F5D
17010108105ABDF3FFFCF5EDE6E0DCD8D4D2D0CE6C6C6C1E0200070F
161C217CD5E3FDFEF8F0A6440D00115C595653514EB2EFFFF2EA9A9D3C0A00030B1260C1
F4FFECE590330800053A9EE6F7FFE8E2DD822A1B02063E3E3D3DA1A4
E9FEFEF7B955514B453C32240400063EA2E8F8FFFAC6631A01074140A5E9F9FFE48E9234
0800040C141A706CCAF7FFE89699390900040B131A1F242886DAFBFF
F9C15D170101288785D9E9FEF6EEE7E1892E0600053A3A3A9EE6F7FFE9E3DD82852C0601
24807E7BD4FAFFFAF2EBE48E91340800043738389CE5FEF8F0A8ABAD
490F0101272A2D8DDEFCFFDED97C7E2804001D222684D9FBFDF6EEA2A5433A2F06001A6F
CCD9FBFDF6EEA2400C00030B12191F78D2E0FDFFF8F0E9E3DE83862C
0601074141A5E9FEF6EEA240362A05010843A8EBFAFFE28A8E31240400060E151C736FCC
F7FFFAF2AC48410C00030B4DB1EEFFFDD2CFCECC6A1D02010742A6AA
EBFBFFE1888B8F3207000438389C9D9FE7FEF8F0E8E28B8E91340800040C50B4EFFEFEF7
F0A6430D0011181E237E7CD4FAFFE38C310700050C1463C4F5FFFBCB
681C0C001260C1F4FFECE5909497380900040B131A1F7976D1DFEFFFFDF5EEE7E1DCD8D5
75230300063F3EA3A5A8EBFFFDF6EFA3A6440D00033193E1F1FFFCCF
CDCB691D0C00020A4A48ACECFFFDF6EEA3A6433A2F0600050C52B6BDC6F6FFFBF4ECE5E0
DB7F2805010810171D222684D9FBFFF9C25D5B1601010846AAEBFFFD
D47422120300217CD4FAFEDAD6D3D1CF6D6D1F0200070F161C212683D8FBFDF6EEE7E1DC
81832B1C02063CA0A3E8F8FFF9F1AAAD49410C000D53504EB2B9C0F4
FFECE6919498380900040B4F4DB1EEFFF2EBE4DF842C1D0C00020911181E23272A2D2F90
90DFF0FFFDF5EEA13F0B0012605DBFF3FFEDE6E1878B2F0700050C52
4F4DB1B7BFF3FFFCCD6A6A6A6A1D0201074241A5E9FEFEF7EFA4420C0003323335979898
99E4FDFEF8BC5854130400060E151B726F6B68C7F6FFFBF3B0B2B450
pop
P
% End of image
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{81, 324},
  ImageMargins->{{40, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40001A0001A1000`40n007h00ODOoo001Aool0057o
o`00DOoo001Aool0057oo`00DOoo001Aool0057oo`00DOoo001Aool00005ool000000208@@02BVT3
BTT3@RP2[ED01>mMomoooooO0lHH00=JjaS300000P0000<YAH@`g]/00^mM00CoooNnkggW?0;W7003
S54YIASS00<000048@Akkg_?Nll2Ljh01=JJomoooooO0/HH00AJja2R0008@@8@PP03F^^mmoNN00?o
o`03cWU[CASS00<000030208HA2R008Hh`;oo`0000Goo`00000080Q1009:J@=:B@=2:0:]E@04kego
gooooml3aQP00e[[6<<0000200000bU5Q33Nf`02ked01?oomkk_ONLl0^LL00><DBUU6><00`0000@Q
17__Nlmkc`9c[P04eY[ogooooml2aQP015[[4:8000Q10Q2200=Jjkggmih00ooo00?>NF]=6><00`00
00<080QQ4:800QSS0_oo00001Ooo0000000P24400TYY0dY90d8X0ZeE00C_GOoOoooog`?66003F^/H
``0000800003:DF4<=kK00;_G@04ooog_^mmic`2ia`00haA:FDHh`0300001244Nnmkcg_?0W>^00CF
V_oOoooog`;66004F^/@XP00244248800e[[_OOgWP03ool00liiJddHh`0300000`0P264@XP026><2
ool00005ool000000208@@02BVT3BTT3@RP2[ED01>mMomoooooO0lHH00=JjaS300000P0000<YAH@`
g]/00^mM00CoooNnkggW?0;W7003S54YIASS00<000048@Akkg_?Nll2Ljh01=JJomoooooO0/HH00AJ
ja2R0008@@8@PP03F^^mmoNN00?oo`03cWU[CASS00<000030208HA2R008Hh`;oo`0000Ooob448@Ak
kmJjomooo`02oml01?NNkegW?=kk0h@`00><DHaa<HH00P0P00@0000P265BRP9:J@03]IK_OOoo00;o
o`04mkk_ONLlU982U;8019cCW?<iic660P0P00@0000P265BZP:e]P04mikooooomkh2kgd01>mMiab<
DBUU0P0P00<001S36><00R4T00B447__NloF^P;og`04oooogoNNked2U;82ool00007oolQ1244NnoF
^_oOool00_oO00CgW^mMiccNn`>4<003S56<LC6600808004000080QQDXX2BVT00kFFkggoo`02ool0
1?NnkggW?9BB0YBb00BLdicc>NLaQP808004000080QQDZX2]KH01?NNooooooNn0^mm00C_GNLLS54Y
I@808003000H`aSS008Q9004Q11kkg_?e[X2oml01?ooomogW^mM0YBb0_oo00001ooo8@@Q17__e[[o
gooo00;og`04mik_GNLlg_/3Q3000haAS74aQP02020010000208HE::0TYY00>eU^mmool00_oo00Cg
_^mmicbDTP:D/P04W=>LlcWW<HH2020010000208HE:Z0[Ff00CgW_ooooog_P;_O@04kegW78aA:FD2
02000`006<<Hh`028B@018@@NnmkcmJj0_oO00CooooOmik_G@:D/P;oo`0000Ooob448@AkkmJjomoo
o`02oml01?NNkegW?=kk0h@`00><DHaa<HH00P0P00@0000P265BRP9:J@03]IK_OOoo00;oo`04mkk_
ONLlU982U;8019cCW?<iic660P0P00@0000P265BZP:e]P04mikooooomkh2kgd01>mMiab<DBUU0P0P
00<001S36><00R4T00B447__NloF^P;og`04oooogoNNked2U;82ool00007oolQ1244NnoF^_oOool0
0_oO00CgW^mMiccNn`>4<003S56<LC6600808004000080QQDXX2BVT00kFFkggoo`02ool01?NnkggW
?9BB0YBb00BLdicc>NLaQP808004000080QQDZX2]KH01?NNooooooNn0^mm00C_GNLLS54YI@808003
000H`aSS008Q9004Q11kkg_?e[X2oml01?ooomogW^mM0YBb0_oo00001ooo<JHaYPQ1000080QQ008@
PP03H`c66?Nn00?oo`04mkjeU[FFBVT248801000264@XV</0/Hh00?>NOoOool00_oO00CgW^mMW=>L
l`:U5004@PPaYRU502020000124T:DDYIBUU0c660iBb0^LL00CgW_ooooog_P:e]P03DXX@PP000088
@@04BVVeU^mmool2oml01?NNkegW?=kk0X@`0_oo00001ooo<JHaYPQ1000080QQ008@PP03H`c66?Nn
00?oo`04mkjeU[FFBVT248801000264@XV</0/Hh00?>NOoOool00_oO00CgW^mMW=>Ll`:U5004@PPa
YRU502020000124T:DDYIBUU0c660iBb0^LL00CgW_ooooog_P:e]P03DXX@PP000088@@04BVVeU^mm
ool2oml01?NNkegW?=kk0X@`0_oo00001ooo<JHaYPQ1000080QQ008@PP03H`c66?Nn00?oo`04mkje
U[FFBVT248801000264@XV</0/Hh00?>NOoOool00_oO00CgW^mMW=>Ll`:U5004@PPaYRU502020000
124T:DDYIBUU0c660iBb0^LL00CgW_ooooog_P:e]P03DXX@PP000088@@04BVVeU^mmool2oml01?NN
kegW?=kk0X@`0_oo00001ooo<JHaYPQ1000080QQ008@PP03H`c66?Nn00?oo`04mkjeU[FFBVT24880
1000264@XV</0/Hh00?>NOoOool00_oO00CgW^mMW=>Ll`:U5004@PPaYRU502020000124T:DDYIBUU
0c660iBb0^LL00CgW_ooooog_P:e]P03DXX@PP000088@@04BVVeU^mmool2oml01?NNkegW?=kk0X@`
0_oo00001ooo<JHaYPQ1000080QQ008@PP03H`c66?Nn00?oo`04mkjeU[FFBVT248801000264@XV</
0/Hh00?>NOoOool00_oO00CgW^mMW=>Ll`:U5004@PPaYRU502020000124T:DDYIBUU0c660iBb0^LL
00CgW_ooooog_P:e]P03DXX@PP000088@@04BVVeU^mmool2oml01?NNkegW?=kk0X@`0_oo00001?oo
:DDYAASS0P0000L080QQ264@XV]=aSSg_P02ool01?oOmik_OIcc0ZDD00@iic6V2440008@XP036><Q
124T008YA@8YI@04<HJDT^LLia`2ool02?oOmik_GNmMiab<DC6602020000100P264@XQS30W>>00C>
NMkKomooo`;og`;66007F^]Jbe[;4:8080006<<00W>>00A[KLiImkkoo`;_G@;oo`0000CoobU5:DDH
h`8000070208H@QQ4:9[CLHhmkh00_oo00CogoNNkgfLl`:U5004>NLaYPQ100024:800aSS8@@Q9002
:DD2:FD01366U9;W7>LL0_oo00SogoNNkeg_GNLLS54aQP0P0P0000@080QQ4:8H``9cSP04cWWNfooO
ool2oml2aQP01e[[F/]Jba2R020001S3009cSP04Jfg>FONnool2ked2ool00004oolYABU56><20000
1`0P2648HA2RJdg6>?Nn00;oo`04omogW^mmW?<2YA@013WW<JH8@@000Q2R00<Hhb448B@00RU50RUU
00@aQYBBiacW70;oo`08omogW^mMkegW78aA<HH0808000040208HA2R6<<2Lhh01<iig]_ogooo0_oO
0/HH00MJje[;F//@XP0P000H``02Lhh016]]cUWg__oo0^mM0_oo00001?oo:DDYAASS0P0000L080QQ
264@XV]=aSSg_P02ool01?oOmik_OIcc0ZDD00@iic6V2440008@XP036><Q124T008YA@8YI@04<HJD
T^LLia`2ool02?oOmik_GNmMiab<DC6602020000100P264@XQS30W>>00C>NMkKomooo`;og`;66007
F^]Jbe[;4:8080006<<00W>>00A[KLiImkkoo`;_G@;oo`0000CoobU5:DDHh`8000070208H@QQ4:9[
CLHhmkh00_oo00CogoNNkgfLl`:U5004>NLaYPQ100024:800aSS8@@Q9002:DD2:FD01366U9;W7>LL
0_oo00SogoNNkeg_GNLLS54aQP0P0P0000@080QQ4:8H``9cSP04cWWNfooOool2oml2aQP01e[[F/]J
ba2R020001S3009cSP04Jfg>FONnool2ked2ool00006oooW7>LLS54YIB440`0000@080QQ4:8Hh`9c
SP04cWWNnoooool2mkh01>mmiccW78@`0RUU00<0800002000PQQ00@@XQSS8@Akk`;F^P04iacooooO
aQP2F^/0112R0200000P0PQQ00@@XQS38@@Q90:44004g]_ogoooe[X2eYX3Lhh2Ljh012440000000P
0PQQ00@@XV</aSSg_PCoo`0000KoonLLiab<DBUU8@@30000100P264@XQSS0W>>00C>NMkkooooo`;g
_P04kggW?>LLQ302:FD00`0P000080022640112R6><Q17__0]Jj00CW7?ooomo6609Jj`044:808000
02022640112R6<<Q124T0X@@00CNfooOoooF^P;FVP=cSP9c[P048@@0000002022640112RHbc6>?Nn
1?oo00001_ooiacW78aA:FDQ10<000040208HA2R6><2Lhh01<iig__ooooo0_Nn00C_ONLliab4<08Y
I@030200000P0088H@044:8Hhb44Nnl2e[X01>LLooooglHH0U[[00@@XP0P00008088H@044:8H`b44
8B@2Q1001=kKomooomJj0]JJ0g>>0W>^00@Q100000008088H@044:9S;<Hhmkh4ool00006oooW7>LL
S54YIB440`0000@080QQ4:8Hh`9cSP04cWWNnoooool2mkh01>mmiccW78@`0RUU00<0800002000PQQ
00@@XQSS8@Akk`;F^P04iacooooOaQP2F^/0112R0200000P0PQQ00@@XQS38@@Q90:44004g]_ogooo
e[X2eYX3Lhh2Ljh012440000000P0PQQ00@@XV</aSSg_PCoo`0000OooooOomog_[FFBVU2:002>NL0
13662440000P0PQQ00@@XQS3Lhi[K@9[C@04cUWF^_oOool2oml00oNN[GF]M@02BTT010QQ000000Q1
0TY900B]MNmmooogWP;_G@04W?>U5:DDYC@2[ED2[GD2]IH3]KH00e::4880000200000`Q1BTU2:002
[ED01>mmooog_^mm0Ycc00>U548826400`000_oo00001oooomoogoNn]II:JD8X008ii`04<HH8@@00
02022640112R6<=cSV]]0V]=00C>FMJjomooo`;og`03mij]MJee009:B@04264000002442BTT01:ee
kggoooNN0^mM00BLljDDYABU=0:]E@:]M@:eUP>e]P03DXX@PP0000800003245:BD8X00:]E@04kggo
ooNnkgd2W?<00jDD@PP8H@030002ool00007oooogooOmkjeUTYY@RP00SWW00@aQPQ100008088H@04
4:8H`g>>Jfd2Jdd01<iIe[[ogooo0_oO00?gWZee[GD00TY900@8H@000008@@9:B@04[GG_OOoomih2
ked019ccYABU5:Dd0ZeE0Zee0[FF0kFf00=BRQ2200000P0000<8@DY9@RP00ZeE00C_OOoomkk_O@:L
l`03YAA220QQ00<000;oo`0000OooooOomog_[FFBVU2:002>NL013662440000P0PQQ00@@XQS3Lhi[
K@9[C@04cUWF^_oOool2oml00oNN[GF]M@02BTT010QQ000000Q10TY900B]MNmmooogWP;_G@04W?>U
5:DDYC@2[ED2[GD2]IH3]KH00e::4880000200000`Q1BTU2:002[ED01>mmooog_^mm0Ycc00>U5488
26400`000_oo00001oooomoogoNn]II:JD8X008ii`04<HH8@@0002022640112R6<=cSV]]0V]=00C>
FMJjomooo`;og`03mij]MJee009:B@04264000002442BTT01:eekggoooNN0^mM00BLljDDYABU=0:]
E@:]M@:eUP>e]P03DXX@PP0000800003245:BD8X00:]E@04kggoooNnkgd2W?<00jDD@PP8H@030002
ool00006ool8@@Q1BVVeU^mm0ooo00CFV/iicWU[K@8Hh`032640000000<aQP04U;;W7?ooool2g]/2
e[X00mJJcWW>N@02cWT4Jdd011SS000080QQ0Q2R00@H`g>>cWWog`;oo`04iccW7=kkg]/2Nll2Nnl0
18@@:DDH`aS30P0000L8@D88@PQ22:Ddkegog`02ool01?Nn_MMBZQ2R0P0P0_oo00001_oo2448@DYY
]IK_O@?oo`04eY[>NLiiJfd26><00`QQ00000003<HH019Bbiacooooo0]kK0]Jj00?FV/iicWT00/ii
16]=00@Hh`000208H@8@XP046<=cS/iioml2ool01>LliacNnmkK0W_?0W__00B442U56<<H``800007
24522488@PRU=>mMoml00_oo00Cg_[gGDZX@XP8080;oo`0000Koo`Q1245:JKFFkgd3ool01=JJcWW>
NF]]0QSS00<8H@0000000c6600BD/^LLooooo`;Nf`;F^P03eY[>NLii00;>N@A[C@046><0000P2642
4:8011S3Lhk>NOoO0_oo00CW?>LLg__Nf`9kc`9kk`04Q10YAAS36<<200001`Q1@PQ22488YCC_GOoO
00;oo`04mkjmee:Z4:820202ool00006ool8@@Q1BVVeU^mm0ooo00CFV/iicWU[K@8Hh`0326400000
00<aQP04U;;W7?ooool2g]/2e[X00mJJcWW>N@02cWT4Jdd011SS000080QQ0Q2R00@H`g>>cWWog`;o
o`04iccW7=kkg]/2Nll2Nnl018@@:DDH`aS30P0000L8@D88@PQ22:Ddkegog`02ool01?Nn_MMBZQ2R
0P0P0_oo00001_oo2448@DYY]IK_O@?oo`04eY[>NLiiJfd26><00`QQ00000003<HH019Bbiacooooo
0]kK0]Jj00?FV/iicWT00/ii16]=00@Hh`000208H@8@XP046<=cS/iioml2ool01>LliacNnmkK0W_?
0W__00B442U56<<H``80000724522488@PRU=>mMoml00_oo00Cg_[gGDZX@XP8080;oo`0000Ooo`00
000080QQ4:8H``028@@0124TQ13NfooO0_oo00CoglHHF^/H``800004244@PU[;DZX2_ML00oNNoooo
o`02mkh01>mmiccW7=kk0]kK00Akcg__NnlYA@808004000083WWYA@2ic`01?oomkk_OJDd0T8800@8
H@000008@@8@PP036<=[KF]=009S;004aSSg__ooool2mkh01>mmiccW7=kK0W__0_oo00001ooo0000
000P264@XQS3008Q10048BB44=kKoml2ool01?oOaQQJjaS30P0000@8@A22F/]BZP:me`03mikooooo
00;g_P04kggW?>LLg_/2g]/017_?NnmkkbU50P0P00@0000P>NNU50;W?004ooog_^mmYC@2@PP010QQ
000000Q10Q2200<H`f]]Jdd00V</00C6>?Nnooooo`;g_P04kggW?>LLg]/2Nnl2ool00007ool00000
0208HA2R6<<00R4400@Q98@@g]_og`;oo`04omo665[[6<<2000010Q1489Jbe:Z0[gG00?gW_ooool0
0_Nn00C_ONLliacNn`;Nf`04Nlmkkg__:DD202001000020iijDD0^Ll00CoooNnkgfU=09220042640
0000244248800aS3Jfe[C@02Hb`01<Hhmkkooooo0_Nn00C_ONLliacNf`9kk`;oo`0000Ooo`000000
80QQ4:8H``028@@0124TQ13NfooO0_oo00CoglHHF^/H``800004244@PU[;DZX2_ML00oNNooooo`02
mkh01>mmiccW7=kk0]kK00Akcg__NnlYA@808004000083WWYA@2ic`01?oomkk_OJDd0T8800@8H@00
0008@@8@PP036<=[KF]=009S;004aSSg__ooool2mkh01>mmiccW7=kK0W__0_oo00001ooo0000000P
264@XQS3008Q10048BB44=kKoml2ool01?oOaQQJjaS30P0000@8@A22F/]BZP:me`03mikooooo00;g
_P04kggW?>LLg_/2g]/017_?NnmkkbU50P0P00@0000P>NNU50;W?004ooog_^mmYC@2@PP010QQ0000
00Q10Q2200<H`f]]Jdd00V</00C6>?Nnooooo`;g_P04kggW?>LLg]/2Nnl2ool00007oolYABU50200
02U5:FD00Xaa0XaA00SNnoooooooomkkg]]kkh@@0RU500@080000208H@8@XP03Hbc6>?Nn00;oo`04
omo>FF</Hb`26><010000208HA2R0V</00C6>?Nnoooog`?>F@03Hb`H``Q100<00003244@PQS3008H
h`03NloFV_oO00;oo`04omo6><HhH``26<<20000124T:DDYIBUU0_oo00001ooo:DDYA@0P000YABUU
00:<L@:<D@08g__ooooooooNnmkKNnn4408YA@040200000P26424:800f</aSSg_P02ool01?oOcUUS
;6</0QSS00@0000P264@XP9S;004aSSg__oooml3cUT00f</6<<8@@0300000`Q1488H``026><00g_?
eY[og`02ool01?oOaSS6>6<<0QS30P0000@Q92U5:FDYI@;oo`0000OoobU5:DD08000:DDYI@02S742
S5402=kkoooooooog__Nfg__Q102:DD0100P000080QQ0Q2R00=S;<Hhmkh00_oo00CogliIHbaS;08H
h`04000080QQ4:82Hb`01<HhmkkooooO0liI00=S;1S324400`0000<8@A226<<00QSS00=kcmJJoml0
0_oo00CoglHhaSQS308H``8000048B@YABUU:FD2ool00007oolYABU5020002U5:FD00Xaa0XaA00SN
noooooooomkkg]]kkh@@0RU500@080000208H@8@XP03Hbc6>?Nn00;oo`04omo>FF</Hb`26><01000
0208HA2R0V</00C6>?Nnoooog`?>F@03Hb`H``Q100<00003244@PQS3008Hh`03NloFV_oO00;oo`04
omo6><HhH``26<<20000124T:DDYIBUU0_oo00001OooS76<LMkkkgd00_oo0_oO00CgWZDd@RP8H@80
0004488@XV]=Hb`2aSP01?NnoooogoNn0^mm00>LljDD>NL00PQ10P0000@8@A22F^]Jj`9Jb`04DZZm
eoNNmih2ool01_NnkggW?>LliacNn`:440:4<003:FDHh`QQ00<00003244@PU[[00;66004mkkoonmm
YC@3[ED00d8X264000020002ool00005oon<LHaag___O@02ool2oml01?NNYCA2:0QQ0P0000@@PQ2R
JdeS;0;6>004mkkooooOmkh2kgd00iccYA@ii`022442000010Q1489Jje[[0U[;00ABZ[gGmikgWP;o
o`06mkk_ONLliccW7=kk0X@@0X@`00<YIASS26400`0000<8@A22F^/00/HH00Cg__ookgfU=0>]E@03
@RP8H@00008000;oo`0000GoohaaS77Nnnmm00;oo`;og`04mijU=48X2642000011224:9[CF</0/Hh
00Cg__ooomog_P;_O@03W?>U53WW0088@@800004244@PU[[F^/2F//015:Z_MOgW_NN0_oo00Kg_^mm
iccW?>LLg_/2Q102Q3000bUU6><8H@0300000`Q1489Jj`02aQP01?Nnooo_OJDd0jeE00=2:0QQ0000
0P000_oo00001OooS76<LMkkkgd00_oo0_oO00CgWZDd@RP8H@800004488@XV]=Hb`2aSP01?Nnoooo
goNn0^mm00>LljDD>NL00PQ10P0000@8@A22F^]Jj`9Jb`04DZZmeoNNmih2ool01_NnkggW?>LliacN
n`:440:4<003:FDHh`QQ00<00003244@PU[[00;66004mkkoonmmYC@3[ED00d8X264000020002ool0
0005oon<LHaag___O@02ool2oml01?NNYCA2:0QQ0P0000@@PQ2RJdeS;0;6>004mkkooooOmkh2kgd0
0iccYA@ii`022442000010Q1489Jje[[0U[;00ABZ[gGmikgWP;oo`06mkk_ONLliccW7=kk0X@@0X@`
00<YIASS26400`0000<8@A22F^/00/HH00Cg__ookgfU=0>]E@03@RP8H@00008000;oo`0000Koo`Q1
2452::eEked3ool00mJjeY[>N@03Jfd011SS0000000P0PQQ00@@XQSS8@@Q908YA@8YI@<aQP04<JJD
/^LLmih3ool00oNnkgfU5002@PP0136V2440000P0PQQ00=BR[Ffkgd00ooo00Cg_[Ff]KIBRP9:J@03
488000QQ00=BRP03BVVeU[gG00;gWP;oo`04mkk_OJDdYC@2ool00006ool8@@Q1@RR]ENmM0ooo00?F
^]JJcWT00f]]00@Hh`0000008088H@044:8Hhb448B@2:DD2:FD3<HH0136VU;;W7?NN0ooo00?g_^mm
YA@00T8800@aYPQ100008088H@03DXZe]^mm00?oo`04mkje][FfDXX2BVT00a220008H@03DXX00dYY
]IJme`02mih2ool01?NnkgfU=:Dd0_oo00001_oo2448@D8X[EG_G@?oo`03e[[FV/ii00=[K@046><0
000002022640112R6><Q124T0RU50RUU0c6600@aYYBbiacgWP?oo`03mkk_OJDD00922004<JH8@@00
020226400e::]KK_O@03ool01?Nn]KJe]U::0TYY00<@PP0026400e::00=:JKFF_ML00_NN0_oo00Cg
_^mmYCBU=0;oo`0000Koo`Q12452::eEked3ool00mJjeY[>N@03Jfd011SS0000000P0PQQ00@@XQSS
8@@Q908YA@8YI@<aQP04<JJD/^LLmih3ool00oNnkgfU5002@PP0136V2440000P0PQQ00=BR[Ffkgd0
0ooo00Cg_[Ff]KIBRP9:J@03488000QQ00=BRP03BVVeU[gG00;gWP;oo`04mkk_OJDdYC@2ool00006
ool8@@Q1@RR]ENmM0ooo00?F^]JJcWT00f]]00@Hh`0000008088H@044:8Hhb448B@2:DD2:FD3<HH0
136VU;;W7?NN0ooo00?g_^mmYA@00T8800@aYPQ100008088H@03DXZe]^mm00?oo`04mkje][FfDXX2
BVT00a220008H@03DXX00dYY]IJme`02mih2ool01?NnkgfU=:Dd0_oo00001oooYCBU=:eE[GE:B@QQ
00<000038B@YABUU00><L@03g__ooooo00;og`04mij]ED8X264300001PQ1488H`aS36><Q109kk`;F
^P04omooonLLg_/2Q10012U50200000P0PQQ00@@XQS38@@Q90<YA@03:FDaQS6600>D/P08iacooooo
oooNng__:DDH``<000038BB4<8@@00;Nf`;oo`0000OoojDdYCB]EJeeBTT8H@0300000b4T:DDYI@03
S7400mkkooooo`02oml01?NN[EE2:0QQ0`0000H8@A226<<H`aSS8@@2Nnl2e[X01?oOoooW7=kk0X@@
00@YA@0P00008088H@044:8H`b448B@3:DD00bUU<HHaQP03U;802>LLoooooooog_]kkbU56<<30000
0b4TQ3244002g]/2ool00007oonU=:Dd[EF]MDY926400`0000<Q92U5:FD00haa00?Nnoooool00_oO
00CgWZeE@RP8H@<00006244@PQS36<<Hhb440W__0]Jj00CogoooiacNn`:44004:DD0800002022640
112R6<<Q124T0bU500<YIC66<HH00iBb00SW7?ooooooomkkNnlYAAS30`0000<Q98@`Q1000]kK0_oo
00001oooYCBU=:eE[GE:B@QQ00<000038B@YABUU00><L@03g__ooooo00;og`04mij]ED8X26430000
1PQ1488H`aS36><Q109kk`;F^P04omooonLLg_/2Q10012U50200000P0PQQ00@@XQS38@@Q90<YA@03
:FDaQS6600>D/P08iacooooooooNng__:DDH``<000038BB4<8@@00;Nf`;oo`0000OoojDdYCB]EJee
BTT8H@0300000b4T:DDYI@03S7400mkkooooo`02oml01?NN[EE2:0QQ0`0000H8@A226<<H`aSS8@@2
Nnl2e[X01?oOoooW7=kk0X@@00@YA@0P00008088H@044:8H`b448B@3:DD00bUU<HHaQP03U;802>LL
oooooooog_]kkbU56<<300000b4TQ3244002g]/2ool00005oooogooOoooog`02aQP2F^/011S30200
000P0PQQ00ABRTYY]IK_O@;oo`04mik_GIcC>LL224400`00020aYP04<JH2>LL2W?<01>LlmkkooooO
0_Nn00C_ONLliab4<0:<D@04:FD080008@@3Nll00mJJomooo`02oml00lHhH``H``0300000b4T:DF<
D@02g_/2ool01=kkg]_F^]Jj0_oo00001Oooomoogooooml00/HH0U[[00@H``0P00008088H@04DXY:
JKFFkgd2ool01?NNkefLdcW70PQ100<0000P<JH0136V0SW70Ycc00CW??Nnoooog`;g_P04kggW?>LL
Q302S54012UU020002440g_?00?FV_oOool00_oO00?6>6<<6<<00`0000<Q92U5S5400]kk0_oo00CN
nmkKe[[F^P;oo`0000GooooOomoooooO00;6609Jj`046<<080000202264015::BVVeU^mm0_oo00Cg
W^mMW=<ia`88@@030000836V00@aYP8ia`:Ll`04iccg__oooml2mkh01>mmiccW78@`0XaA00@YI@0P
000Q10=kc`03eY[ogooo00;og`03aSQS31S300<000038B@YAHaA00;Nn`;oo`04g__NfmJje[X2ool0
0005oooogooOoooog`02aQP2F^/011S30200000P0PQQ00ABRTYY]IK_O@;oo`04mik_GIcC>LL22440
0`00020aYP04<JH2>LL2W?<01>LlmkkooooO0_Nn00C_ONLliab4<0:<D@04:FD080008@@3Nll00mJJ
omooo`02oml00lHhH``H``0300000b4T:DF<D@02g_/2ool01=kkg]_F^]Jj0_oo00001oooNlmkcb4T
0200000P0088H@04DZYBRU::]KH2kgd01?ooomogW^mM0YcC00@ia`Q1000@XP9S;003aSSg__oo00;_
G@03iccNnmkK00?F^P04eY[>NF]]6><20000100P>LLiacW70icc00?W??oooml00_NN00>U=48X2640
0`0000<8@DYY]IH00^mm0_oo00GFVW>>8@@Q1122008000038B@YABU500;oo`0000Ooog_?NllQ900P
00008002264015:ZDXYBR[Ff0^mm00CooooOmik_G@:Ld`04>LL8@@004:82Hb`00lHhmkkoo`02ked0
0nLlg__Nf`03e[X01=JJcWU[KASS0P0000@083W7>LLia`>Ll`03iccooooO00;gWP03YCA2:0QQ00<0
0003245:JKFF00;_O@;oo`05eYYcSR448@@@PP0200000b4T:DDYA@02ool00007oomkcg_?8B@08000
02000PQQ00ABZU::DXZe]P;_O@04oooogoNNked2W=<013W72440012R0V</00?6>?Nnool00^mM00?W
?=kkg]/00mJj00CFV/iiJfdHh`800004020iacW7>LL3W?<00nLloooog`02mih00jDd@RP8H@030000
0`Q1BVVeUP02kgd2ool01MJJLhhQ124448800P0000<Q92U5:DD00_oo00001oooNlmkcb4T0200000P
0088H@04DZYBRU::]KH2kgd01?ooomogW^mM0YcC00@ia`Q1000@XP9S;003aSSg__oo00;_G@03iccN
nmkK00?F^P04eY[>NF]]6><20000100P>LLiacW70icc00?W??oooml00_NN00>U=48X26400`0000<8
@DYY]IH00^mm0_oo00GFVW>>8@@Q1122008000038B@YABU500;oo`0000Ooog_?NllQ900P00008002
264015:ZDXYBR[Ff0^mm00CooooOmik_G@:Ld`04>LL8@@004:82Hb`00lHhmkkoo`02ked00nLlg__N
f`03e[X01=JJcWU[KASS0P0000@083W7>LLia`>Ll`03iccooooO00;gWP03YCA2:0QQ00<00003245:
JKFF00;_O@;oo`05eYYcSR448@@@PP0200000b4T:DDYA@02ool00004oolYABU5:FD3<HH2U;801>LL
mikoonmm0ZDD00BU=488>LLYI@808004000080QQ4:82Hb`00lHhmkkoo`02ool00liiJddHh`030000
124TQ13F^_oO0_oo00CoglHHF^/H``<00003244@PQ2R009[C@04Hbc6>?Nnool2oml00liIHbaS;002
6><200000`0P@PQ22002@PP00jDdkegog`04ool00004oolYABU5:FD3<HH2U;801>LLmikoonmm0ZDD
00BU=488>LLYI@808004000080QQ4:82Hb`00lHhmkkoo`02ool00liiJddHh`030000124TQ13F^_oO
0_oo00CoglHHF^/H``<00003244@PQ2R009[C@04Hbc6>?Nnool2oml00liIHbaS;0026><200000`0P
@PQ22002@PP00jDdkegog`04ool00004oolYABU5:FD3<HH2U;801>LLmikoonmm0ZDD00BU=488>LLY
I@808004000080QQ4:82Hb`00lHhmkkoo`02ool00liiJddHh`030000124TQ13F^_oO0_oo00CoglHH
F^/H``<00003244@PQ2R009[C@04Hbc6>?Nnool2oml00liIHbaS;0026><200000`0P@PQ22002@PP0
0jDdkegog`04ool00004oolYABU5:FD3<HH2U;801>LLmikoonmm0ZDD00BU=488>LLYI@8080040000
80QQ4:82Hb`00lHhmkkoo`02ool00liiJddHh`030000124TQ13F^_oO0_oo00CoglHHF^/H``<00003
244@PQ2R009[C@04Hbc6>?Nnool2oml00liIHbaS;0026><200000`0P@PQ22002@PP00jDdkegog`04
ool00004oolYABU5:FD3<HH2U;801>LLmikoonmm0ZDD00BU=488>LLYI@808004000080QQ4:82Hb`0
0lHhmkkoo`02ool00liiJddHh`030000124TQ13F^_oO0_oo00CoglHHF^/H``<00003244@PQ2R009[
C@04Hbc6>?Nnool2oml00liIHbaS;0026><200000`0P@PQ22002@PP00jDdkegog`04ool00007oooW
?>LlS74aQP0P00000QSS00@Q17__NloF^P;og`04oooW?=kkg]/2Nnl0124T0200000P0cWW0ZDD0ZDd
00B]EJee]IK_O@?oo`03mkk_ONLl00;W7004S54YI@0P0002020010QQ4:8H`b440R4T00B44=kKomoo
o`;g_P:me`04DZYBRU::488200001`Q1488@PQS3Jfg>FONn00Coo`0000OoonLlicb<LC6602000002
6><01244NnmkcmJj0_oO00CoonLlg__Nf`9kk`048B@080000203>NL2YA@2YC@01:eE[GFeU^mm0ooo
00?g_^mmic`00^LL00B<DBUU020000808004264@XQS38@@28B@018@@g]_ogooo0_Nn0[gG00ABZU::
DXX@PP800007244@PQ226<=[KLiImkh01?oo00001oooiccW?8aa<HH08000008Hh`048@Akkg_?e[X2
oml01?ooiccNnmkK0W__00@Q900P000080<ii`:U50:U=004[EF]MKFFkgd3ool00oNnkggW?002ia`0
18aA:FD080000P0P00@8HA2R6<<Q108Q9004Q13NfooOool2mkh2_ML015:ZDXYBRQ220P0000L8@A22
488H`f]]cUWg_P04ool00007oooW?>LlS74aQP0P00000QSS00@Q17__NloF^P;og`04oooW?=kkg]/2
Nnl0124T0200000P0cWW0ZDD0ZDd00B]EJee]IK_O@?oo`03mkk_ONLl00;W7004S54YI@0P00020200
10QQ4:8H`b440R4T00B44=kKomooo`;g_P:me`04DZYBRU::488200001`Q1488@PQS3Jfg>FONn00Co
o`0000OoonLlicb<LC66020000026><01244NnmkcmJj0_oO00CoonLlg__Nf`9kk`048B@080000203
>NL2YA@2YC@01:eE[GFeU^mm0ooo00?g_^mmic`00^LL00B<DBUU020000808004264@XQS38@@28B@0
18@@g]_ogooo0_Nn0[gG00ABZU::DXX@PP800007244@PQ226<=[KLiImkh01?oo00000oooomoog`02
aSP4H``011S30008@@QQ0U[;00ABZ[gGaQSg_P?oo`03cWU[CASS00<000088BB447__NnoF^_oOoooo
g`C66003F^/H``00008000038B@YAHaA00:<D@04Q33NfnmMool2mkh00kFfBVT@PP0300000`Q1489J
j`02F//01;ggmikoonmm0^Ll00CW78aAS74aQP8080;oo`0000?ooooOoml00/Hh16<<00@H``002448
H@9Jb`04DZZmelHHmkh3ool00liiJddHh`030000224TQ11kkg__e[[ogooooml4aQP00e[[6<<00002
00000b4T:DF<D@02S54018@`g]__GOoo0_Nn00>e]TYY48800`0000<8@A22F^/00U[;00BmmoNNooo_
O@;W?004iab<DHaa<HH20202ool00003oooogooO00;6>0AS30046<<000Q12642F//015:Z_MO66?Nn
0ooo00?>NF]=6><00`0000PQ98@@NnmkkmJjomoooooO1<HH00=JjaS300000P0000<Q92U5S5400XaA
00B4<=kKkegoo`;g_P03]KI:JA2200<00003244@PU[[009Jb`04_OOgW_ookgd2ic`01>LLS56<LC66
0P0P0_oo00000oooomoog`02aSP4H``011S30008@@QQ0U[;00ABZ[gGaQSg_P?oo`03cWU[CASS00<0
00088BB447__NnoF^_oOoooog`C66003F^/H``00008000038B@YAHaA00:<D@04Q33NfnmMool2mkh0
0kFfBVT@PP0300000`Q1489Jj`02F//01;ggmikoonmm0^Ll00CW78aAS74aQP8080;oo`0000Ooo`00
000H`f]]cUWg_P02ool01>mMiab<DHaa0S6600@080000208H@9BRP9:J@04BTV]MNmmkgd2ool01oNn
kgg_ONLlU9:D/YcC00:Ll`03YA@ii`Q100<00003<HJD/^LL00?oo`04g]_F^W_?Nll28B@0100P0000
80QQ0Q2R00<H`b448B@00RU500@YIHaaS56<D@;Nn`04kggogooooml2mih2ool00007ool000006<=[
KLiImkh00_oo00C_GNLLS56<L@8aQP040200000P2642DXX2BVT014Y9[GG_ONmm0_oo00Og_^mmkggW
?9BBU;:Ld`02W?<00jDD>NL8@@0300000c66U;;W7003ool01=kKe[Ykcg_?0R4T00@080000208H@8@
XP036<<Q124T008YA@04:FF<LHaAS542g_/01>mmomoooooO0_NN0_oo00001ooo000001S3Jfg>FONn
00;oo`04kegW78aAS742<HH0100P000080QQ0U::0TYY00A:BJeekgg_O@;oo`07mkk_ONmmicbDTYBb
W=<00Ycc00>U53WW24400`0000<aQYBbia`00ooo00CNfmJjNlmkc`8Q90040200000P26424:800aS3
8@@Q9002:DD012UUS76<DHaA0]kk00C_OOoOoooog`;gWP;oo`0000Ooo`00000H`f]]cUWg_P02ool0
1>mMiab<DHaa0S6600@080000208H@9BRP9:J@04BTV]MNmmkgd2ool01oNnkgg_ONLlU9:D/YcC00:L
l`03YA@ii`Q100<00003<HJD/^LL00?oo`04g]_F^W_?Nll28B@0100P000080QQ0Q2R00<H`b448B@0
0RU500@YIHaaS56<D@;Nn`04kggogooooml2mih2ool00007ool000006<=[KLiImkh00_oo00C_GNLL
S56<L@8aQP040200000P2642DXX2BVT014Y9[GG_ONmm0_oo00Og_^mmkggW?9BBU;:Ld`02W?<00jDD
>NL8@@0300000c66U;;W7003ool01=kKe[Ykcg_?0R4T00@080000208H@8@XP036<<Q124T008YA@04
:FF<LHaAS542g_/01>mmomoooooO0_NN0_oo00001oookeg_GNLLS74aQP0P008000040208HA2R6<<2
8@@0124T:DF4<=kK0_oO00CooooOmik_G@:Ld`03>LL8@@000080808aYP03W=?W??oo00;oo`03g]_F
^]JJ009cSP048@@@PP0000020202@PP00jDdkegoo`02ool00mJjLjikc`028B@00`0P000080022640
112RHbc6>?Nn0_oo00C_GNLlg__Nf`9kk`;oo`0000OoonmMkegW78aa<HH080020000100P264@XQS3
0R4400@Q92U5Q33Nf`;og`04oooogoNNked2W=<00cW7244000020202<JH00icCiccoo`02ool00mkK
e[[FVP02Lhh01244488000000P0P0T8800>U=>mMool00_oo00?F^W>^Nll00R4T00<0800002000PQQ
00@@XV</aSSg_P;oo`04kegW?=kkg]/2Nnl2ool00007ooo_GNmMiab<LC6602000P0000@080QQ4:8H
``8Q10048B@YAH@`g]/2oml01?ooomogW^mM0YcC00<ia`Q100000P0P0S6V00>LdnLlool00_oo00?N
fmJjeYX00W>>00@Q11220000008080922003YCC_GOoo00;oo`03e[Yc[W_?008Q90030200000P0088
H@044:9S;<Hhmkh2ool01>mMiccNnmkK0W__0_oo00001oookeg_GNLLS74aQP0P008000040208HA2R
6<<28@@0124T:DF4<=kK0_oO00CooooOmik_G@:Ld`03>LL8@@000080808aYP03W=?W??oo00;oo`03
g]_F^]JJ009cSP048@@@PP0000020202@PP00jDdkegoo`02ool00mJjLjikc`028B@00`0P00008002
2640112RHbc6>?Nn0_oo00C_GNLlg__Nf`9kk`;oo`0000OoonmMkegW78aa<HH080020000100P264@
XQS30R4400@Q92U5Q33Nf`;og`04oooogoNNked2W=<00cW7244000020202<JH00icCiccoo`02ool0
0mkKe[[FVP02Lhh01244488000000P0P0T8800>U=>mMool00_oo00?F^W>^Nll00R4T00<080000200
0PQQ00@@XV</aSSg_P;oo`04kegW?=kkg]/2Nnl2ool00005oon448@@Q124<002S542<HH012444880
00000PQ100A:BD8X[EG_O@;og`03ooooglHH00G660=Jj`04F//@XP0P0002020010QQ4:9S;6<<0/HH
00Cg__ookggW?0>DTP03U;8aYRUU00808004000080QQ4:82Hb`00lHhmkkoo`02ked019cC>LLYI@0P
0P0000@083WWYAC_G@Coo`0000Gooh@@Q12448@`00:<D@8aQP048@@@PP000002244014Y9@RR]ENmm
0_oO00?ooooOaQP01LHH0e[[00AJba2R020000808004264@XV</H``2aQP01?Nnooo_ONLl0iBB00>D
/S6V:FD00P0P00@0000P264@XP9S;003aSSg__oo00;_G@04W=<iabUU02020000100P>NNU5>mM1?oo
00001OooQ12448@@Q3000XaA0S6600@Q112200000088@@04BTU2::eEkgd2oml00oooomo66005aQP3
F^/015[;4:8080000P0P00@8HA2RHbaS30;66004mkkoonmmic`3U9800iBb<JHYI@02020010000208
HA2R0V</00?6>?Nnool00^mM00BLdcW7:FD080800004020iijDDked4ool00005oon448@@Q124<002
S542<HH01244488000000PQ100A:BD8X[EG_O@;og`03ooooglHH00G660=Jj`04F//@XP0P00020200
10QQ4:9S;6<<0/HH00Cg__ookggW?0>DTP03U;8aYRUU00808004000080QQ4:82Hb`00lHhmkkoo`02
ked019cC>LLYI@0P0P0000@083WWYAC_G@Coo`0000Gooh@@Q12448@`00:<D@8aQP048@@@PP000002
244014Y9@RR]ENmm0_oO00?ooooOaQP01LHH0e[[00AJba2R020000808004264@XV</H``2aQP01?Nn
ooo_ONLl0iBB00>D/S6V:FD00P0P00@0000P264@XP9S;003aSSg__oo00;_G@04W=<iabUU02020000
100P>NNU5>mM1?oo0003ool01?Nnkgg_GNLL0]kk00CNfg_?8B@@XP808004000080QQ4:826><2Lhh0
1liiomooooooomogW^mM00;W?004S76DTYBb<JH2244010004:8Hhb440R4T00@YABUU:FFDTP:<L@04
g__ooooooml2_OL2F//01E:ZBVU:BDY926400P000PQ100@@PU[;DZYBZP9BRP04BVVeU[gGmih4ool0
00?oo`04mkk_ONmMia`2g_/01=kKNllQ912R0P0P00@0000P264@XP8Hh`9cSP07cWWogooooooogoNN
ked00^Ll00B<LIBBU;8aYP88@@04000@XQSS8@@28B@012U5:FDYIIBB0Xaa00CNnooooooog`:mm`9J
b`05DZY:JDY9BTT8H@02000224401122F/]BZU:Z0U::00A:JKFF_MOgWPCoo`000ooo00Cg_^mmkegW
70;Nn`04g]]kcb4T4:82020010000208HA2R0QSS0W>>00O>NOoOoooooooOmik_G@02ic`018aaU9:D
/S6V0PQ100@0012R6><Q108Q9004:DDYIBUUU982S7401=kkoooooooO0[gg0U[;00EBZTYYBTU:B@QQ
00800088@@04489Jbe:ZDZX2DXX014YY]IJmeoNN1?oo0003ool01?Nnkgg_GNLL0]kk00CNfg_?8B@@
XP808004000080QQ4:826><2Lhh01liiomooooooomogW^mM00;W?004S76DTYBb<JH2244010004:8H
hb440R4T00@YABUU:FFDTP:<L@04g__ooooooml2_OL2F//01E:ZBVU:BDY926400P000PQ100@@PU[;
DZYBZP9BRP04BVVeU[gGmih4ool000?oo`04mkk_ONmMia`2g_/018@@:DD080000PQ100=2:488@PP0
148800>U=>mMool00_oo00?g_[gG_ML00[gg00=BZU::48800`0000@8@A226<<Hh`9c[P04eY[ogooo
oml2aSP016<<6<<000000R4T00B4<8@@Q13F^P;og`03oooogoNN00;_G@04iccNnmkKNnl28B@011S3
0008@A220Q2R0_oo0003ool01?Nnkgg_GNLL0]kk00B442U502000088@@03@RQ2248800A22003YCC_
GOoo00;oo`03mkjmekgG00:mm`03DZYBRQ2200<00004244@PQS36><2Ljh01=JJomoooooO0/Hh00AS
31S30000008Q9004Q32448@@e[X2oml00oooomogWP02ked01>Llg__Nfg__0R4T00@H``00244@PP8@
XP;oo`000ooo00Cg_^mmkegW70;Nn`04Q10YA@0P000224400d8X@PQ22004@PP00jDdkegoo`02ool0
0oNn_MNme`02_OL00e:ZDXX@PP03000010Q1488H`aSS0W>^00CFV_oOoooog`;6>004H``H``000002
8B@018@`Q1244=Jj0_oO00?ooooOmih00^mM00CW?=kkg]]kk`8Q90046<<000Q148824:82ool000?o
o`04mkk_ONmMia`2g_/018@@:DD080000PQ100=2:488@PP0148800>U=>mMool00_oo00?g_[gG_ML0
0[gg00=BZU::48800`0000@8@A226<<Hh`9c[P04eY[ogooooml2aSP016<<6<<000000R4T00B4<8@@
Q13F^P;og`03oooogoNN00;_G@04iccNnmkKNnl28B@011S30008@A220Q2R0_oo0003ool01?Nnkgg_
GNLL0]kk00B442U502000088@@03@RQ2248800A22003YCC_GOoo00;oo`03mkjmekgG00:mm`03DZYB
RQ2200<00004244@PQS36><2Ljh01=JJomoooooO0/Hh00AS31S30000008Q9004Q32448@@e[X2oml0
0oooomogWP02ked01>Llg__Nfg__0R4T00@H``00244@PP8@XP;oo`0000Ooof]=Jdg>FONnoooog`02
cUT016</6<<000000P0P00@8HA2RJdg>F@;F^P04omoooooOmih2[GD00dY926400002000010Q1BTU:
BD8X0Zee00C_OOoOooog_P;_O@04iccW78aA:FD26><010QQ000000Q10Q2200@H`aSSLjkFVP;W7003
mikooooo00;FVP;>N@;>F@=S;0036<<8@@00008@PP;oo`0000Ooof]=Jdg>FONnoooog`02cUT016</
6<<000000P0P00@8HA2RJdg>F@;F^P04omoooooOmih2[GD00dY926400002000010Q1BTU:BD8X0Zee
00C_OOoOooog_P;_O@04iccW78aA:FD26><010QQ000000Q10Q2200@H`aSSLjkFVP;W7003mikooooo
00;FVP;>N@;>F@=S;0036<<8@@00008@PP;oo`0000Ooof]=Jdg>FONnoooog`02cUT016</6<<00000
0P0P00@8HA2RJdg>F@;F^P04omoooooOmih2[GD00dY926400002000010Q1BTU:BD8X0Zee00C_OOoO
ooog_P;_O@04iccW78aA:FD26><010QQ000000Q10Q2200@H`aSSLjkFVP;W7003mikooooo00;FVP;>
N@;>F@=S;0036<<8@@00008@PP;oo`0000Ooof]=Jdg>FONnoooog`02cUT016</6<<000000P0P00@8
HA2RJdg>F@;F^P04omoooooOmih2[GD00dY926400002000010Q1BTU:BD8X0Zee00C_OOoOooog_P;_
O@04iccW78aA:FD26><010QQ000000Q10Q2200@H`aSSLjkFVP;W7003mikooooo00;FVP;>N@;>F@=S
;0036<<8@@00008@PP;oo`0000Ooof]=Jdg>FONnoooog`02cUT016</6<<000000P0P00@8HA2RJdg>
F@;F^P04omoooooOmih2[GD00dY926400002000010Q1BTU:BD8X0Zee00C_OOoOooog_P;_O@04iccW
78aA:FD26><010QQ000000Q10Q2200@H`aSSLjkFVP;W7003mikooooo00;FVP;>N@;>F@=S;0036<<8
@@00008@PP;oo`0000Goof<<H`c66?Nn00;oo`;g_P04kgfLljDD@PP2<JH012U56><000000P0P00@8
HA2R6>=c[P;>N@03g__ooooo00;Nn`04Q30YA@0P0002020010QQ4:9S;<Hh0_Nn0_oo00Og_[FF]IJe
U[FfDXX@PP03000012UUS76<LMkk0ooo00C>NF]=6><Hh`8000038B@YAH@`00:4<003Q11kkg__009k
c`;oo`0000Goof<<H`c66?Nn00;oo`;g_P04kgfLljDD@PP2<JH012U56><000000P0P00@8HA2R6>=c
[P;>N@03g__ooooo00;Nn`04Q30YA@0P0002020010QQ4:9S;<Hh0_Nn0_oo00Og_[FF]IJeU[FfDXX@
PP03000012UUS76<LMkk0ooo00C>NF]=6><Hh`8000038B@YAH@`00:4<003Q11kkg__009kc`;oo`00
00Goof<<H`c66?Nn00;oo`;g_P04kgfLljDD@PP2<JH012U56><000000P0P00@8HA2R6>=c[P;>N@03
g__ooooo00;Nn`04Q30YA@0P0002020010QQ4:9S;<Hh0_Nn0_oo00Og_[FF]IJeU[FfDXX@PP030000
12UUS76<LMkk0ooo00C>NF]=6><Hh`8000038B@YAH@`00:4<003Q11kkg__009kc`;oo`0000Goof<<
H`c66?Nn00;oo`;g_P04kgfLljDD@PP2<JH012U56><000000P0P00@8HA2R6>=c[P;>N@03g__ooooo
00;Nn`04Q30YA@0P0002020010QQ4:9S;<Hh0_Nn0_oo00Og_[FF]IJeU[FfDXX@PP03000012UUS76<
LMkk0ooo00C>NF]=6><Hh`8000038B@YAH@`00:4<003Q11kkg__009kc`;oo`0000Goof<<H`c66?Nn
00;oo`;g_P04kgfLljDD@PP2<JH012U56><000000P0P00@8HA2R6>=c[P;>N@03g__ooooo00;Nn`04
Q30YA@0P0002020010QQ4:9S;<Hh0_Nn0_oo00Og_[FF]IJeU[FfDXX@PP03000012UUS76<LMkk0ooo
00C>NF]=6><Hh`8000038B@YAH@`00:4<003Q11kkg__009kc`;oo`0000CoomJJeY[W70;oo`04g]]k
kg__Q102Q3001RUU020080000208H@=BRP03]KJmeoNN00?oo`;>N@03cUU[CF]=00=[C@036><8@@Q1
00800006244@PV<<H`c66?Nn0_oo0/ii00=[KASS26400`0000@YAHaAS564<0;Nf`03kegooooo00;g
_P04kgfU=488264200001122F^]Jbe[;0U:Z0_oo00001?ooeY[FV^LL0_oo00CNfg__Nnn440:4<006
:FD0800P000080QQ0e::00>e][gGmih00ooo0/ii00?>FF]=Jdd00f]=00<Hh`Q124400P0000H8@A22
H`aS3<HHmkh2ool2cWT00f]]6><8H@03000012U5S56<DH@`0]kK00?_GOooool00_Nn00C_OJDd@PP8
H@800004489Jje[;F//2DZX2ool00004oooFV]JJia`2ool01=kKNnmkkh@@0X@`00HYI@0P0200000P
2643DXX00kFf_MOgWP03ool2cWT00liIJde[C@03Jdd00aSS2448@@0200001PQ1489S36<<aQSg_P;o
o`;>N@03JfdHh`QQ00<00004:DF<DHaAQ302g]/00nmMooooo`02mkh01>mmYCA220QQ0P0000@@PU[[
F/]Jb`9BZP;oo`0000CoomJJeY[W70;oo`04g]]kkg__Q102Q3001RUU020080000208H@=BRP03]KJm
eoNN00?oo`;>N@03cUU[CF]=00=[C@036><8@@Q100800006244@PV<<H`c66?Nn0_oo0/ii00=[KASS
26400`0000@YAHaAS564<0;Nf`03kegooooo00;g_P04kgfU=488264200001122F^]Jbe[;0U:Z0_oo
00001Ooo_MNmelHHmkh00_oo0/ii0liI0f</00@H``000000809220:]E@03]IK_OOoo00;oo`03omog
WZeE00:]E@03@RP8H@000088H@044:9[CLiImkh2ool01?oOmik_OIcc0ZDD00>U=48826400`0000@8
@A226<<Hh`9kc`03LjkFV_oO00;oo`03omo6><Hh00?6>004H`aJjaS300022442ool00005oonmekgG
aQSg_P02ool2cWT3cUT3Hb`011S30000000P0T880ZeE00>eU^mmool00_oo00?ogoNN[ED00ZeE00=2
:0QQ00000PQQ00@@XV]=cUWg_P;oo`04omogW^mmW?<2YA@00jDd@PP8H@03000010Q1488H`aSS0W_?
00=c[]JJoml00_oo00?oglHhaSP00lHh00AS35[[6<<00088@@;oo`0000GookgG_MO66?Nn00;oo`;>
N@?>F@=S;0046<<000000202@PP2[ED00kFFkggoo`02ool00ooOmij]E@02[ED00d8X264000022640
112RJdg>FONn0_oo00CogoNNkgfLl`:U5003YCA220QQ00<00004244@PQS36><2Nll00g>^eY[og`02
ool00ooOaSS6>003aSP016<<F^/H``000PQ10_oo00001Ooo_MNmelHHmkh00_oo0/ii0liI0f</00@H
``000000809220:]E@03]IK_OOoo00;oo`03omogWZeE00:]E@03@RP8H@000088H@044:9[CLiImkh2
ool01?oOmik_OIcc0ZDD00>U=48826400`0000@8@A226<<Hh`9kc`03LjkFV_oO00;oo`03omo6><Hh
00?6>004H`aJjaS300022442ool00005oonmekgGaQSg_P02ool2cWT3cUT3Hb`011S30000000P0T88
0ZeE00>eU^mmool00_oo00?ogoNN[ED00ZeE00=2:0QQ00000PQQ00@@XV]=cUWg_P;oo`04omogW^mm
W?<2YA@00jDd@PP8H@03000010Q1488H`aSS0W_?00=c[]JJoml00_oo00?oglHhaSP00lHh00AS35[[
6<<00088@@;oo`0000Oooa22488@XQSSLjkFVP02oml01?oog__Nfg__0RU500@080000208H@9BZP04
DXY:JDYY]IH2]KH00oNNooooo`02mkh01>mmYA@ii`Q10`0000<aQS6VU;800^LL00CgW_ookggW?0:D
TP04U;:LdcW724420000100P244@PQS30f]]00M[CLHhmkkg__ooomogWP03]IH014YY4880000P0PQQ
0_oo00001ooo488@PQ2R6>=c[]JJ00;og`04oooNnmkKNnl2:DD0100P000080QQ0U:Z00ABRTYYBVVe
UP:e]P03mikooooo00;g_P04kgfU53WW244300000c66<JJD/P02ia`01?NNooo_ONLl0YBB00BD/YcC
>LL8@@8000040208@A226<<3Jfd01f]=aSSg__NnoooogoNN00>eUP04BVT@PP0002022642ool00007
ool@PQ224:8Hhg>^eYX00_oO00Coomkkg]]kk`8YA@040200000P2642DZX015::BVU:JKFF0[Ff00?g
W_ooool00_Nn00C_OJDD>NL8@@<00003<HHaYYBb00;W7004mikoonmmic`2U98019BbW=<ia`Q10P00
00@080Q1488H``=[K@07Jdg6>?NnmkkooooOmih00kFF00A:JA2200008088H@;oo`0000Oooa22488@
XQSSLjkFVP02oml01?oog__Nfg__0RU500@080000208H@9BZP04DXY:JDYY]IH2]KH00oNNooooo`02
mkh01>mmYA@ii`Q10`0000<aQS6VU;800^LL00CgW_ookggW?0:DTP04U;:LdcW724420000100P244@
PQS30f]]00M[CLHhmkkg__ooomogWP03]IH014YY4880000P0PQQ0_oo00001ooo488@PQ2R6>=c[]JJ
00;og`04oooNnmkKNnl2:DD0100P000080QQ0U:Z00ABRTYYBVVeUP:e]P03mikooooo00;g_P04kgfU
53WW244300000c66<JJD/P02ia`01?NNooo_ONLl0YBB00BD/YcC>LL8@@8000040208@A226<<3Jfd0
1f]=aSSg__NnoooogoNN00>eUP04BVT@PP0002022642ool00005oomBRU::DXY:J@04BTT01:eekggo
ooNn0^mm00CW?9BB<HH8@@8000046<<Hhb44Nnl2e[X00ooOoooW7002g_/01=kKe[[FVW>>0R440P00
00P080QQ4:8@XV</aSSFV_oO0_oo00CogoNNkefLd`:Ll`04>NL8@@000005<JH2W=<01>Llmkkooooo
0_Nn00C_ONLlU9:D/P:Ld`;oo`0000Gooe::DXYBRTYY00A:B@04[GG_OOoomkh2kgd01>LlU98aQPQ1
0P0000@H`aSS8@Akk`;F^P03omooonLL00;Nn`04g]_F^]JJLhh28@@20000200P264@XQ2RHbc6>=JJ
oml2ool01?oOmik_GIcC0Ycc00@ii`Q1000000DaYP:Ld`04iccg__ooool2mkh01>mmicbDTYBb0YcC
0_oo00001OooDXYBRU::BVT014Y900B]MNmmooog_P;_O@04icbDTS662442000011S36><Q17__0]Jj
00?ogoooia`00]kk00CNfmJjeYYcSP8Q108000080208HA2R4:9S;<HheY[og`;oo`04omogW^mMW=<2
W?<013WW244000001C6V0YcC00CW??Nnooooo`;g_P04kggW?9BBU;82W=<2ool00005oomBRU::DXY:
J@04BTT01:eekggoooNn0^mm00CW?9BB<HH8@@8000046<<Hhb44Nnl2e[X00ooOoooW7002g_/01=kK
e[[FVW>>0R440P0000P080QQ4:8@XV</aSSFV_oO0_oo00CogoNNkefLd`:Ll`04>NL8@@000005<JH2
W=<01>Llmkkooooo0_Nn00C_ONLlU9:D/P:Ld`;oo`0000Gooe::DXYBRTYY00A:B@04[GG_OOoomkh2
kgd01>LlU98aQPQ10P0000@H`aSS8@Akk`;F^P03omooonLL00;Nn`04g]_F^]JJLhh28@@20000200P
264@XQ2RHbc6>=JJoml2ool01?oOmik_GIcC0Ycc00@ii`Q1000000DaYP:Ld`04iccg__ooool2mkh0
1>mmicbDTYBb0YcC0_oo00001oooW=>Ldicc>NLaQPQ1008000040208HA2R6<<2Lhh016]]cUWNfnLl
0_oo00Cg_[gGDZX@XP800003244@PV<<009Jj`04_OO>FMJjia`2ool01?oOaQQJjaS30`0000<8@A22
F//00e:Z00=BR[Ff_OL00/Hh00CFV_oOoooog`C6>007H``H`aS3000080QQ4:800QSS00Ac[W>>cWWo
g`Coo`0000OooicCW=>LlcWW<HH8@@020000100P264@XQS30W>>00A[KLiIg]_W?0;oo`04mkjmee:Z
4:8200000`Q1489S3002F^/01;ggcUWF^^LL0_oo00CoglHHF^/H``<00003244@PU[;00=BZP03DXZe
][gg00;6>004eY[ogooooml4aSP01f<<6<<H``000208HA2R008Hh`04LjicS/iioml4ool00007oonL
dicCW?<iic6624400P0000@080QQ4:8H``9cSP04Jfg>FMkKic`2ool01?Nn_MMBZQ2R0P0000<8@A22
H``00U[[00BmmliIe[[W70;oo`04omo665[[6<<300000`Q1489Jb`03DZX00e::]KJmm`02aSP01=JJ
omoooooO1<Hh00MS31S36<<0000P264@XP026><017>^Lhk>NOoO1?oo00001oooW=>Ldicc>NLaQPQ1
008000040208HA2R6<<2Lhh016]]cUWNfnLl0_oo00Cg_[gGDZX@XP800003244@PV<<009Jj`04_OO>
FMJjia`2ool01?oOaQQJjaS30`0000<8@A22F//00e:Z00=BR[Ff_OL00/Hh00CFV_oOoooog`C6>007
H``H`aS3000080QQ4:800QSS00Ac[W>>cWWog`Coo`0000OooooOomogW^mMiccNn`02g]/2e[X01MJJ
LhhQ124448800P0000DYIHaaS76<LMkk00;oo`;Nn`03Q10YA@0P008000040208HA2R6<<2Lhh016]]
cUWNfooO0_oo00Cg_^mmYABU=0922004264001226<<3Jdd00f</H`aJj`02F//00e:Z_MOgWP03ool0
0oNnkggW?002ia`018@`S54YIB440P000_oo00001oooomoogoNNkegW?=kk00;Nf`;F^P05eYYcSR44
8@@@PP0200001BUUS76<LHaag_/00_oo0]kk00>442U502000P0000@080QQ4:8H``9cSP04Jfg>FMkK
oml2ool01?NnkgfU5:Dd0T8800@8H@00488H``=[C@03HbaS35[[009Jb`03DZZmeoNN00?oo`03mkk_
ONLl00;W7004Q32<DBUU8@@20002ool00007oooogooOmik_GNLlg_/00]kK0]Jj00GFVW>>8@@Q1122
00800005:FF<LHaaS77Nn`02ool2g_/00h@@:DD080020000100P264@XQS30W>>00A[KLiIg]_og`;o
o`04mkk_OJDDYC@2@PP010QQ000@PQS30f]=00=S;6<<F^/00U[;00=BZ[gGmih00ooo00?g_^mmic`0
0^LL00B4<8aA:FDQ108000;oo`0000OooooOomogW^mMiccNn`02g]/2e[X01MJJLhhQ124448800P00
00DYIHaaS76<LMkk00;oo`;Nn`03Q10YA@0P008000040208HA2R6<<2Lhh016]]cUWNfooO0_oo00Cg
_^mmYABU=0922004264001226<<3Jdd00f</H`aJj`02F//00e:Z_MOgWP03ool00oNnkggW?002ia`0
18@`S54YIB440P000_oo00001oooomoogoNNkegW?=kk00;Nf`;F^P05eYYcSR448@@@PP0200001BUU
S76<LHaag_/00_oo0]kk00>442U502000P0000@080QQ4:8H``9cSP04Jfg>FMkKoml2ool01?NnkgfU
5:Dd0T8800@8H@00488H``=[C@03HbaS35[[009Jb`03DZZmeoNN00?oo`03mkk_ONLl00;W7004Q32<
DBUU8@@20002ool00004ool000000202>NL01ZDDYCBU=>mMooog_P>e]P04DXX@PP000002020010QQ
DZYBR[Ff0[gg00?gW_oomih00ZeE00B]MKFF]IJe]P9BRP03BTU2:0QQ00<00004245:BD8X[ED2kgd2
ool02?NnkggW?>Lliab<DBUU8@@30000200P265BZU:Z_MOgW_ookgd2ked01>LLS56<LIBB0S660_oo
00001?oo0000000P0SWW00JU5:DdYCC_GOoomkh3]KH015::488000000P0P00@8HE:ZDXZe]P:mm`03
mikoooNN00:]E@04[GFeU[FF]KH2DXX00dY9@RP8H@03000010Q1BTU2::eE0^mm0_oo00Sg_^mmiccW
?>LLS54YIB440`0000P080QQDZYBZ[gGmikoonmm0^mM00CW78aAS76DTP8aQP;oo`0000Coo`000000
808ii`06YABU=:DdkegoooNn0kFf00ABRQ22000000808004265BZU::]KH2_OL00oNNooogWP02[ED0
1:ee]IJeU[Ff0U::00=:BD8X26400`0000@8@DY9@RR]E@;_O@;oo`08mkk_ONLliccW78aA:FDQ10<0
00080208HE:ZDZZmeoNNooo_O@;_G@04iab<DHaaU982<HH2ool00004ool000000202>NL01ZDDYCBU
=>mMooog_P>e]P04DXX@PP000002020010QQDZYBR[Ff0[gg00?gW_oomih00ZeE00B]MKFF]IJe]P9B
RP03BTU2:0QQ00<00004245:BD8X[ED2kgd2ool02?NnkggW?>Lliab<DBUU8@@30000200P265BZU:Z
_MOgW_ookgd2ked01>LLS56<LIBB0S660_oo00001?oo0000000P0SWW00JU5:DdYCC_GOoomkh3]KH0
15::488000000P0P00@8HE:ZDXZe]P:mm`03mikoooNN00:]E@04[GFeU[FF]KH2DXX00dY9@RP8H@03
000010Q1BTU2::eE0^mm0_oo00Sg_^mmiccW?>LLS54YIB440`0000P080QQDZYBZ[gGmikoonmm0^mM
00CW78aAS76DTP8aQP;oo`0000Ooo`Q12440000P264@XP02Hb`01<HheY[ogooo0^Ll00CW7=kKe[[F
^P;FVP04LhhQ1000020224400a226<<Hh`02Nll017>^eY[Nnnmm0ooo00?g_^mmYA@00T8800@8H@00
0008@@9:J@04]IJe][ggmih3ool00oNnkgfLl`02YA@00jDd@PPia`0224400`00020aYP04W=<00nLl
ooooo`02g]/2ool00007ool8@@Q1000080QQ4:800V</00C6>=JJomooo`;W?004iacNfmJje[X2eYX0
17>>8@@0000P0PQ100<@PQS36><00W_?00Ac[]JJg___O@?oo`03mkk_OJDD00922004264000002442
BVT01;FF]KJmmoNN0ooo00?g_^mmW?<00ZDD00>U=488>LL00PQ100<0000P<JH019cC00?W??ooool0
0]kK0_oo00001ooo2448@@000208HA2R009S;004aSSFV_oOool2ic`01>LLg]_F^]Jj0]JJ00AcSR44
00008088@@03488H`aSS009kc`04LjkFV]kkkgd3ool00oNnkgfU5002@PP010QQ000000Q10TYY00Be
U[Ff_OOgWP?oo`03mkk_OIcc00:U5003YCA223W70088@@030000836V00BLd`03iccooooo00;Nf`;o
o`0000Ooo`Q12440000P264@XP02Hb`01<HheY[ogooo0^Ll00CW7=kKe[[F^P;FVP04LhhQ10000202
24400a226<<Hh`02Nll017>^eY[Nnnmm0ooo00?g_^mmYA@00T8800@8H@000008@@9:J@04]IJe][gg
mih3ool00oNnkgfLl`02YA@00jDd@PPia`0224400`00020aYP04W=<00nLlooooo`02g]/2ool00007
ool8@@Q1000080QQ4:800V</00C6>=JJomooo`;W?004iacNfmJje[X2eYX017>>8@@0000P0PQ100<@
PQS36><00W_?00Ac[]JJg___O@?oo`03mkk_OJDD00922004264000002442BVT01;FF]KJmmoNN0ooo
00?g_^mmW?<00ZDD00>U=488>LL00PQ100<0000P<JH019cC00?W??ooool00]kK0_oo00001oooNnmk
kg__:DD080000088@@04488@XV]=cUT2mkh01?ooomogW^mm0^Ll00BDTS6602000080808ia`>Ll`04
iccooooomkh2_ML2_OL025[;4:800000244@PQS36><28@@00b4T:DDYI@03S7401=kkooooomkk0]kK
00?F^W>^8B@00`0000<Q124TQ1000]Jj00CogoooomogWP;_G@;oo`0000Ooog__NnmkkbU502000002
244011224:9[CLiI0_Nn00CooooOmik_O@;W?004U98aQP0P00020202>LL3W?<01>LlooooooNn0[gG
0[gg00QJba2R000000Q1488H`aSS0R4400<Q92U5:FD00haa00CNnooooooNn`;Nf`03e[Yc[R4T00<0
00038@@Q98@@00;F^P04omoooooOmih2ked2ool00007oomkkg__NnlYA@0P00000PQ100@@PQ2RJdg>
F@;g_P04oooogoNNkgd2ic`019BB<HH080000P0P0SW70icc00CW??ooooog_P:me`:mm`08F//@XP00
0008@A226<<Hh`8Q10038B@YABUU00><L@04g__ooooog_/2g]/00mJjLjhQ900300000b448BB44002
e[X01?oOoooogoNN0^mM0_oo00001oooNnmkkg__:DD080000088@@04488@XV]=cUT2mkh01?ooomog
W^mm0^Ll00BDTS6602000080808ia`>Ll`04iccooooomkh2_ML2_OL025[;4:800000244@PQS36><2
8@@00b4T:DDYI@03S7401=kkooooomkk0]kK00?F^W>^8B@00`0000<Q124TQ1000]Jj00Cogoooomog
WP;_G@;oo`0000OoonLlicb<LC66020000020202>NL00jDDiccoo`02ool00oNn_MNmm`02DZX0112R
0008@A220QS300=[KLiImkh00_oo00CogliIHbaS;08H``0400008488YC@2ked2ool01ONn_MMBZU:Z
4:800P0000L8@A22488H`aSS8@@Q9002:DD2:FD3<HH4<JH2W=<01>LloooooooO0[gg0_oo00001ooo
iccW?8aa<HH080000080808ii`03YACW??oo00;oo`03mkjmekgg009BZP044:8000Q148826<<00f]]
cUWg_P02ool01?oOcUUS;6</0QS300@0000P@PRU=0;_G@;oo`05mkjmee:ZDZX@XP0200001`Q1488@
PQS36><Q124T008YA@8YI@<aQP@aYP:Ld`04iccooooooml2_OL2ool00007oooW?>LlS74aQP0P0000
0P0P0SWW00>U5>Llool00_oo00?g_[gG_OL00U:Z00@@XP00244@PP8H``03Jfg>FONn00;oo`04omo>
FF</Hb`26<<0100002122:Dd0^mM0_oo00Gg_[gGDZYBZQ2R00800007244@PQ226<<Hhb448B@00RU5
0RUU0c66136V0YcC00CW??oooooog`:mm`;oo`0000OoonLlicb<LC66020000020202>NL00jDDicco
o`02ool00oNn_MNmm`02DZX0112R0008@A220QS300=[KLiImkh00_oo00CogliIHbaS;08H``040000
8488YC@2ked2ool01ONn_MMBZU:Z4:800P0000L8@A22488H`aSS8@@Q9002:DD2:FD3<HH4<JH2W=<0
1>LloooooooO0[gg0_oo00001oooiccW?8aa<HH080000080808ii`03YACW??oo00;oo`03mkjmekgg
009BZP044:8000Q148826<<00f]]cUWg_P02ool01?oOcUUS;6</0QS300@0000P@PRU=0;_G@;oo`05
mkjmee:ZDZX@XP0200001`Q1488@PQS36><Q124T008YA@8YI@<aQP@aYP:Ld`04iccooooooml2_OL2
ool00005oomBZU:ZDZX@PP020002:DD012UUS76<LHaa0]kk00C_OOooooog_P;_O@04icbDTS6V2442
00000a2R6><Q10028B@018@`Q11kkg__0]Jj00CogoooiacNn`;Nf`04e[Yc[R4T4:82000010Q1488H
`aSS0R4400B44=Jjomooo`;F^P03LjhQ900P008000040208HA2RHb`2H``015[[aQS>FONn1?oo0000
1OooDZYBZU:Z48800P000RU500@YIHaaS76<L@;Nn`04kggooooomkh2kgd01>LlU98aYPQ10P0000<@
XQSS8@@00R4T00B4<8@@Nnmkk`;F^P04omooonLLg_/2g]/01=JjLjhQ912R0P0000@8@A226<<Hh`8Q
1004Q13F^_oOool2e[X00g>^8B@080020000100P264@XV</0V<<00AJjlHHcUWg_PCoo`0000Gooe:Z
DZYBZQ220080008YA@04:FF<LHaaS742g_/01>mmooooooNn0^mm00CW?9BB<JH8@@8000034:8Hhb44
008Q9004Q32447__Nnl2e[X01?oOoooW7=kk0]kK00CF^W>^8B@@XP800004244@PQS36><28@@018@@
e[[ogooo0]Jj00=c[R4T02000P0000@080QQ4:9S;09S3004F^_66<iImkh4ool00005oomBZU:ZDZX@
PP020002:DD012UUS76<LHaa0]kk00C_OOooooog_P;_O@04icbDTS6V244200000a2R6><Q10028B@0
18@`Q11kkg__0]Jj00CogoooiacNn`;Nf`04e[Yc[R4T4:82000010Q1488H`aSS0R4400B44=Jjomoo
o`;F^P03LjhQ900P008000040208HA2RHb`2H``015[[aQS>FONn1?oo00001OooDZYBZU:Z48800P00
0RU500@YIHaaS76<L@;Nn`04kggooooomkh2kgd01>LlU98aYPQ10P0000<@XQSS8@@00R4T00B4<8@@
Nnmkk`;F^P04omooonLLg_/2g]/01=JjLjhQ912R0P0000@8@A226<<Hh`8Q1004Q13F^_oOool2e[X0
0g>^8B@080020000100P264@XV</0V<<00AJjlHHcUWg_PCoo`0000?oonLlic`00YBB00ND/S6V:FDY
I@0P00008005@PP2YC@2ked01?oomkk_ONLl0^LL00><DBUU02000P0000<Q124T:DD00bUU0S661IBb
00?W7?ooool00_oO00Bmme[;DZYBRP9:J@04488000008B@2Q1000g__e[[og`02ool01>LLg_^448@`
0RUU00@Hh`0000008088H@;oo`0000?oonLlic`00YBB00ND/S6V:FDYI@0P00008005@PP2YC@2ked0
1?oomkk_ONLl0^LL00><DBUU02000P0000<Q124T:DD00bUU0S661IBb00?W7?ooool00_oO00Bmme[;
DZYBRP9:J@04488000008B@2Q1000g__e[[og`02ool01>LLg_^448@`0RUU00@Hh`0000008088H@;o
o`0000?oonLlic`00YBB00ND/S6V:FDYI@0P00008005@PP2YC@2ked01?oomkk_ONLl0^LL00><DBUU
02000P0000<Q124T:DD00bUU0S661IBb00?W7?ooool00_oO00Bmme[;DZYBRP9:J@04488000008B@2
Q1000g__e[[og`02ool01>LLg_^448@`0RUU00@Hh`0000008088H@;oo`0000?oonLlic`00YBB00ND
/S6V:FDYI@0P00008005@PP2YC@2ked01?oomkk_ONLl0^LL00><DBUU02000P0000<Q124T:DD00bUU
0S661IBb00?W7?ooool00_oO00Bmme[;DZYBRP9:J@04488000008B@2Q1000g__e[[og`02ool01>LL
g_^448@`0RUU00@Hh`0000008088H@;oo`0000?oonLlic`00YBB00ND/S6V:FDYI@0P00008005@PP2
YC@2ked01?oomkk_ONLl0^LL00><DBUU02000P0000<Q124T:DD00bUU0S661IBb00?W7?ooool00_oO
00Bmme[;DZYBRP9:J@04488000008B@2Q1000g__e[[og`02ool01>LLg_^448@`0RUU00@Hh`000000
8088H@;oo`0000Oooa2R4:9[CF</aSSg_P02ool01>mmicb<LC660P0P00@001S36><Q108Q9004Q324
48@@Nnl2Nll00mJjomooo`02ic`018aaU9:D/S6V0RU500@08000:DDYA@:<D@04g___OOoomih2[GD0
14Y9488000000RUU00@aQYBBU9:DTP;W7003mikooooo00?>N@9[K@076><8H@QQ0008@A226<<00QSS
0_oo00001ooo4:8@XV]=Hbc6>?Nn00;oo`04kggW?8aa<HH2020010006<<Hhb440R4T00B4<8@@Q11k
k`9kc`03e[[ogooo00;W?004S76DTYBb<JH2:DD0100P000YABU50XaA00CNnnmmooogWP:]M@04BTT@
PP000002:FD01366U9:DTYBB0^LL00?gW_ooool00lii0V]]00LHh`QQ264000Q1488H``026><2ool0
0007ool@XQ2RJdeS;<Hhmkh00_oo00C_ONLlS74aQP808004000H`aSS8@@28B@018@`Q12447__0W_?
00?F^_oOool00^Ll00B<LIBBU;8aYP8YA@04020002U5:DD2S5401=kkkggoooNN0Zee00A:BA220000
008YI@04<HJDTYBBU982ia`00oNNooooo`03cWT2Jfd01aSS2648H@00244@PQS3008Hh`;oo`0000Oo
oa2R4:9[CF</aSSg_P02ool01>mmicb<LC660P0P00@001S36><Q108Q9004Q32448@@Nnl2Nll00mJj
omooo`02ic`018aaU9:D/S6V0RU500@08000:DDYA@:<D@04g___OOoomih2[GD014Y9488000000RUU
00@aQYBBU9:DTP;W7003mikooooo00?>N@9[K@076><8H@QQ0008@A226<<00QSS0_oo00001oooNlmk
cmJJomooonLl00:<L@04U98aYPQ100024:8011SSLjicS/ii0_oO00CooooOmij]M@9:B@03@PP8H@00
00800004244@PV<<aQP2mkh01?ookggW?>LL0]kK00Akkh@@Q30YA@8Hh`8000050208HE[;F/]BZP02
DXX00kFfkgg_O@02ool01_Nnkgg_OJDD>NL8@@<00004245:BDY9[GD2kgd2ool00007oomkcg_?eY[o
goooic`00Xaa00BDTS6V2440008@XP046>=c[W>>cWT2oml01?ooomogWZee0TY900=220QQ00000P00
00@8@A22H`c660;g_P04ooo_ONLlia`2g]/017__Q124<2U50QSS0P0000D080QQF/]Jbe:Z009BRP03
]KK_ONmm00;oo`06mkk_ONmmYA@ii`Q10`0000@8@DY9BTV]M@;_O@;oo`0000Ooog_?NloFV_oOoooW
?002S74019BB<JH8@@000Q2R00@Hhg>^Lhk>N@;og`04oooogoNN[GD2BTT00d8826400002000010Q1
489S3<HH0_Nn00CoonmmiccW70;Nf`04Nnn448@`:DD26><200001@0P265Jbe[;DZX00U::00>e]^mm
kgd00_oo00Kg_^mmkgfU53WW2443000010Q1BTU:BJee0^mm0_oo00001oooNlmkcmJJomooonLl00:<
L@04U98aYPQ100024:8011SSLjicS/ii0_oO00CooooOmij]M@9:B@03@PP8H@0000800004244@PV<<
aQP2mkh01?ookggW?>LL0]kK00Akkh@@Q30YA@8Hh`8000050208HE[;F/]BZP02DXX00kFfkgg_O@02
ool01_Nnkgg_OJDD>NL8@@<00004245:BDY9[GD2kgd2ool00007oomkcg_?eY[ogoooic`00Xaa00BD
TS6V2440008@XP046>=c[W>>cWT2oml01?ooomogWZee0TY900=220QQ00000P0000@8@A22H`c660;g
_P04ooo_ONLlia`2g]/017__Q124<2U50QSS0P0000D080QQF/]Jbe:Z009BRP03]KK_ONmm00;oo`06
mkk_ONmmYA@ii`Q10`0000@8@DY9BTV]M@;_O@;oo`000ooo00CgWZeeBTT@PP800004264@XV</H``2
aQP01?NnoooooliI0V]=00@Hh`000208H@8@XP036<=cS/ii00;og`04oooogoNN[GD2BTT01488>LL8
@@000Q2R00@H`b44NloFVP;W70;oo`08omogW^mMkegW7=kkg]_F^P?FVP06JfecSW>>LhhQ11220P00
0RUU00@aQYBBU9;W70;gWP;oo`000ooo00CgWZeeBTT@PP800004264@XV</H``2aQP01?NnoooooliI
0V]=00@Hh`000208H@8@XP036<=cS/ii00;og`04oooogoNN[GD2BTT01488>LL8@@000Q2R00@H`b44
NloFVP;W70;oo`08omogW^mMkegW7=kkg]_F^P?FVP06JfecSW>>LhhQ11220P000RUU00@aQYBBU9;W
70;gWP;oo`000ooo00CgWZeeBTT@PP800004264@XV</H``2aQP01?NnoooooliI0V]=00@Hh`000208
H@8@XP036<=cS/ii00;og`04oooogoNN[GD2BTT01488>LL8@@000Q2R00@H`b44NloFVP;W70;oo`08
omogW^mMkegW7=kkg]_F^P?FVP06JfecSW>>LhhQ11220P000RUU00@aQYBBU9;W70;gWP;oo`000ooo
00CgWZeeBTT@PP800004264@XV</H``2aQP01?NnoooooliI0V]=00@Hh`000208H@8@XP036<=cS/ii
00;og`04oooogoNN[GD2BTT01488>LL8@@000Q2R00@H`b44NloFVP;W70;oo`08omogW^mMkegW7=kk
g]_F^P?FVP06JfecSW>>LhhQ11220P000RUU00@aQYBBU9;W70;gWP;oo`000ooo00CgWZeeBTT@PP80
0004264@XV</H``2aQP01?NnoooooliI0V]=00@Hh`000208H@8@XP036<=cS/ii00;og`04oooogoNN
[GD2BTT01488>LL8@@000Q2R00@H`b44NloFVP;W70;oo`08omogW^mMkegW7=kkg]_F^P?FVP06Jfec
SW>>LhhQ11220P000RUU00@aQYBBU9;W70;gWP;oo`001?oo00?FV/iicWT00liI00=S;1SS00000P00
00@080QQ4:8Hh`8Q1004NnoF^_oOool2mkh00oNNYCA2200226420002<HH2<JH2U;802>LLoooooooo
g]_F^W_?8B@202001000020iijDD0ZDd00C_GOoOoooog`;gWP03kegW?8aa008aQP030200000P00<i
i`04YACW??ooool2mkh2ool000Coo`03eY[>NLii00?>F@03Hb`Hh`00008000040208HA2R6><28@@0
17__e[[ogooo0_Nn00?gWZDd@PP00PQQ0P000S660S6V0YBb00SW7?ooooooomkKe[Ykcb4T0P0P00@0
000P>NNU50:U=004kegogooooml2mih00nmMicb<L@02<HH00`0P00008003>NL01:DDiccooooo0_Nn
0_oo0004ool00mJJcWW>N@03cUT00f</6><000020000100P264@XQSS0R4400AkkmJjomooo`;g_P03
mijU=4880088H@80008aQP8aYP:D/P08iacooooooooNfmJjNllQ90808004000083WWYA@2YC@01>mM
omoooooO0_NN00?_GNLlS7400S6600<0800002000cWW00BU5>Llooooo`;g_P;oo`001?oo00?FV/ii
cWT00liI00=S;1SS00000P0000@080QQ4:8Hh`8Q1004NnoF^_oOool2mkh00oNNYCA2200226420002
<HH2<JH2U;802>LLoooooooog]_F^W_?8B@202001000020iijDD0ZDd00C_GOoOoooog`;gWP03kegW
?8aa008aQP030200000P00<ii`04YACW??ooool2mkh2ool000Coo`03eY[>NLii00?>F@03Hb`Hh`00
008000040208HA2R6><28@@017__e[[ogooo0_Nn00?gWZDd@PP00PQQ0P000S660S6V0YBb00SW7?oo
ooooomkKe[Ykcb4T0P0P00@0000P>NNU50:U=004kegogooooml2mih00nmMicb<L@02<HH00`0P0000
8003>NL01:DDiccooooo0_Nn0_oo00001ooo_MNmee:Z4:808000008YA@8YI@:DTP;Nn`;oo`04omnm
mkgg_OL2aQP01e[[F//@XQ2R020001S3008Q10048B@YABUU:FD3<HH00iBbiacgWP03ool00mJjeY[>
N@02Jfd011SS0000000P0PQQ00@@XQSS8@Akk`9kc`03eY[ogooo00;W?004S74aQR4T020200001244
8B@YAH@`0]kK0_oo00001ooo_MNmee:Z4:808000008YA@8YI@:DTP;Nn`;oo`04omnmmkgg_OL2aQP0
1e[[F//@XQ2R020001S3008Q10048B@YABUU:FD3<HH00iBbiacgWP03ool00mJjeY[>N@02Jfd011SS
0000000P0PQQ00@@XQSS8@Akk`9kc`03eY[ogooo00;W?004S74aQR4T0202000012448B@YAH@`0]kK
0_oo00001ooo_MNmee:Z4:808000008YA@8YI@:DTP;Nn`;oo`04omnmmkgg_OL2aQP01e[[F//@XQ2R
020001S3008Q10048B@YABUU:FD3<HH00iBbiacgWP03ool00mJjeY[>N@02Jfd011SS0000000P0PQQ
00@@XQSS8@Akk`9kc`03eY[ogooo00;W?004S74aQR4T0202000012448B@YAH@`0]kK0_oo00001ooo
_MNmee:Z4:808000008YA@8YI@:DTP;Nn`;oo`04omnmmkgg_OL2aQP01e[[F//@XQ2R020001S3008Q
10048B@YABUU:FD3<HH00iBbiacgWP03ool00mJjeY[>N@02Jfd011SS0000000P0PQQ00@@XQSS8@Ak
k`9kc`03eY[ogooo00;W?004S74aQR4T0202000012448B@YAH@`0]kK0_oo00001oooomoogoooiab4
<8aA008YI@04020001S3Jfd2cWT01=kKomoooooO0/HH00AJja2R0008@@8@PP034:9[CLiI00;F^P04
omooonLLg_/2g]/00mJjLjhQ9003000010Q1488H`aSS0W>^00CFV_oOoooW?0:<L@04<HH080000202
26400e::]KKgWP03ool00mJJJfe[K@02Jfd00g>>8@@@PP030002ool00007oooogooOoooW78@`S540
0RUU00@080006<=[K@;>N@04g]_ogooooml2aQP015[[4:8000Q10Q2200<@XV]=cUT00]Jj00Cogooo
iacNn`;Nf`03e[Yc[R4T00<00004244@PQS36><2Ljh01=JJomooonLl0Xaa00@aQP0P00008088H@03
DXZe]_NN00?oo`03eYY[KF]]009[K@03LhhQ112200<000;oo`0000OooooOomooonLLQ32<D@02:FD0
100P000H`f]]0/ii00CNfooOoooog`;66004F^/@XP00244248800a2RJdg>F@02e[X01?oOoooW7=kk
0]kK00?F^W>^8B@00`0000@8@A226<<Hh`9c[P04eY[ogoooic`2S74013660200000P0PQQ00=BR[Ff
mih00ooo00?FVV]]Jfd00V]]00=cSR4448800`000_oo00001oooomoogoooiab4<8aA008YI@040200
01S3Jfd2cWT01=kKomoooooO0/HH00AJja2R0008@@8@PP034:9[CLiI00;F^P04omooonLLg_/2g]/0
0mJjLjhQ9003000010Q1488H`aSS0W>^00CFV_oOoooW?0:<L@04<HH08000020226400e::]KKgWP03
ool00mJJJfe[K@02Jfd00g>>8@@@PP030002ool00007oooogooOoooW78@`S5400RUU00@080006<=[
K@;>N@04g]_ogooooml2aQP015[[4:8000Q10Q2200<@XV]=cUT00]Jj00CogoooiacNn`;Nf`03e[Yc
[R4T00<00004244@PQS36><2Ljh01=JJomooonLl0Xaa00@aQP0P00008088H@03DXZe]_NN00?oo`03
eYY[KF]]009[K@03LhhQ112200<000;oo`0000Koob4T8B@YAHaAg]/3ool01?oOmik_GNLL0Xaa00<a
QR4448800`0000@YABUU<HHaQP:D/P03iacgW_oo00;oo`;>N@9[C@8Hh`04264001226<<26><00g>^
eY[Nn`03ool01?oOmik_GNLL0]kk00B442U5020000808003264@XQS3008Q1004NloF^^LLmih3ool0
0oNnkggW?002ia`2ool00006oolQ924T:DF<DMkK0ooo00CogoNNkegW70:<L@03<HHQ112200<00004
:DDYIC66<HH2U;800nLLmikoo`02ool2cWT2Jdd26><010QQ000@PQS30QSS00=c[]JJg_/00ooo00Co
goNNkegW70;Nn`04Q10YA@0P000202000`QQ4:8H``028@@017_?e[[W7?NN0ooo00?g_^mmic`00^LL
0_oo00001_oo8B@Q92U5S57Nf`?oo`04omogW^mMia`2S7400c668@@@PP03000012U5:FDaQS660YBb
00?W7?NNool00_oo0/ii0V]=0QSS00@8H@00488H``8Hh`03LjkFV]kk00?oo`04omogW^mMia`2g_/0
18@@:DD080000P0P00<8HA2R6<<00R4400AkcmJjiacgWP?oo`03mkk_ONLl00;W70;oo`0000Koob4T
8B@YAHaAg]/3ool01?oOmik_GNLL0Xaa00<aQR4448800`0000@YABUU<HHaQP:D/P03iacgW_oo00;o
o`;>N@9[C@8Hh`04264001226<<26><00g>^eY[Nn`03ool01?oOmik_GNLL0]kk00B442U502000080
8003264@XQS3008Q1004NloF^^LLmih3ool00oNnkggW?002ia`2ool00006oolQ924T:DF<DMkK0ooo
00CogoNNkegW70:<L@03<HHQ112200<00004:DDYIC66<HH2U;800nLLmikoo`02ool2cWT2Jdd26><0
10QQ000@PQS30QSS00=c[]JJg_/00ooo00CogoNNkegW70;Nn`04Q10YA@0P000202000`QQ4:8H``02
8@@017_?e[[W7?NN0ooo00?g_^mmic`00^LL0_oo00001oooQ324<2UU02000244008Q9004Q3244=kK
oml2ool01?oOaQQJjaS30`000RU500B<DMkkg___O@;oo`?FVP03cWU[KF]]009[K@046><000008@@2
Nnl01=JjomooooNn0^mm00C_GNLLg__Nf`;F^P03eYYcSR4400<00003021223WW00:U5004YCC_GOoo
ool2e[X2eYX01<iiJfe[KF]]0_oo00001oooQ324<2UU02000244008Q9004Q3244=kKoml2ool01?oO
aQQJjaS30`000RU500B<DMkkg___O@;oo`?FVP03cWU[KF]]009[K@046><000008@@2Nnl01=Jjomoo
ooNn0^mm00C_GNLLg__Nf`;F^P03eYYcSR4400<00003021223WW00:U5004YCC_GOooool2e[X2eYX0
1<iiJfe[KF]]0_oo00001oooQ324<2UU02000244008Q9004Q3244=kKoml2ool01?oOaQQJjaS30`00
0RU500B<DMkkg___O@;oo`?FVP03cWU[KF]]009[K@046><000008@@2Nnl01=JjomooooNn0^mm00C_
GNLLg__Nf`;F^P03eYYcSR4400<00003021223WW00:U5004YCC_GOooool2e[X2eYX01<iiJfe[KF]]
0_oo00001oooQ324<2UU02000244008Q9004Q3244=kKoml2ool01?oOaQQJjaS30`000RU500B<DMkk
g___O@;oo`?FVP03cWU[KF]]009[K@046><000008@@2Nnl01=JjomooooNn0^mm00C_GNLLg__Nf`;F
^P03eYYcSR4400<00003021223WW00:U5004YCC_GOooool2e[X2eYX01<iiJfe[KF]]0_oo00001?oo
6><Hh`QQ0P0000L8@D8X@RQ2::eE[GG_O@02ool01?NN[GFeUTYY0Q220P0000<08488@PP00T8800Hi
ijDdYCBU=:eEked2ool2e[X3Ljh01b4T020080008@@Q98@@00=kk`03e[[ogooo00;og`04mij]MDY9
@PP226400`00489Jj`02aQP01<iIe[[ogooo0_oO00C665[[6<<0808000;oo`0000CooaSS6><8H@80
00072452:48X@RR]EJeekgd00_oo00CgWZee]II:J@8@PP8000030212248800922006>NNU=:DdYCB]
ENmM0_oo0]Jj0g>^00LQ900P020002448BB44003Nnl00mJjomooo`02oml01?NN[GE:BD880PQQ00<0
0122F^/00/HH00C>FMJjomooo`;og`04aQQJjaS302020002ool00004oolHhaSS264200001`Q1@RQ2
:48X[EF]MNmm00;oo`04mij]MKFFBVT2488200000`0P@PQ22002@PP01SWWYCBU=:Dd[EG_G@;oo`;F
^P=c[P078B@0800P000Q124TQ1000g__00?F^_oOool00_oO00CgWZeeBTU22088H@03000@PU[[00;6
6004cUWF^_oOool2oml01<HHF^/H``0P0P000_oo00001?oo6><Hh`QQ0P0000L8@D8X@RQ2::eE[GG_
O@02ool01?NN[GFeUTYY0Q220P0000<08488@PP00T8800HiijDdYCBU=:eEked2ool2e[X3Ljh01b4T
020080008@@Q98@@00=kk`03e[[ogooo00;og`04mij]MDY9@PP226400`00489Jj`02aQP01<iIe[[o
gooo0_oO00C665[[6<<0808000;oo`0000CooaSS6><8H@8000072452:48X@RR]EJeekgd00_oo00Cg
WZee]II:J@8@PP8000030212248800922006>NNU=:DdYCB]ENmM0_oo0]Jj0g>^00LQ900P02000244
8BB44003Nnl00mJjomooo`02oml01?NN[GE:BD880PQQ00<00122F^/00/HH00C>FMJjomooo`;og`04
aQQJjaS302020002ool00007oolH`aS36><Q17__e[X00_oO00CooooOaQS6609Jj`046<<000008B@2
:DD2S5401Mkkoooooooomkh01;Ff00ABRTYYBTT8H@<00003245:BJee00;_O@;oo`08omogW^mMkegW
7=kkg]_F^P?FVP;>N@05cUU[CF]=6><8H@03000010Q1488H`aSS0R4400@Q98@`Q33Nf`;_G@;oo`00
00OooaS36<<Hhb44NnoF^P02oml01?ooomo66<HH0U[[00@H``00000Q908YA@:<D@05g__oooooooog
_P04]KH015::BVU:B@QQ0`0000<8@DY9[GD00^mm0_oo00SogoNNkeg_GNLLg__NfmJj0mJJ0/ii00G>
FF]=JddHh`QQ00<00004244@PQS36><28@@0124TQ324<=kK0^mM0_oo00001ooo6<<H`aSS8@AkkmJj
00;og`04ooooglHHaQP2F^/011S30000024T0RU50XaA00GNnoooooooooNn00Be]P04DXY:JDY92643
00000`Q1BTV]M@02kgd2ool02?oOmik_GNmMiacNnmkKe[X3eYX2cWT01LiIJde[CASS26400`0000@8
@A226<<Hh`8Q10048BB4<8@`g]/2ked2ool00007oolH`aS36><Q17__e[X00_oO00CooooOaQS6609J
j`046<<000008B@2:DD2S5401Mkkoooooooomkh01;Ff00ABRTYYBTT8H@<00003245:BJee00;_O@;o
o`08omogW^mMkegW7=kkg]_F^P?FVP;>N@05cUU[CF]=6><8H@03000010Q1488H`aSS0R4400@Q98@`
Q33Nf`;_G@;oo`0000OooaS36<<Hhb44NnoF^P02oml01?ooomo66<HH0U[[00@H``00000Q908YA@:<
D@05g__oooooooog_P04]KH015::BVU:B@QQ0`0000<8@DY9[GD00^mm0_oo00SogoNNkeg_GNLLg__N
fmJj0mJJ0/ii00G>FF]=JddHh`QQ00<00004244@PQS36><28@@0124TQ324<=kK0^mM0_oo0004ool0
0mJjeY[FVP04cWT2cUT3Hb`00aS324400002488011S38@@Q92U50h@`00?NfnmMool00_oo00?g_^mm
YC@00T8800@8H@000008@@8@PP03F^^mmoNN00?oo`03cWW>FLiI00?>F@04Hb`H``00000202000`QQ
4:8Hh`028@@0124TQ32447__0]Jj00CW??ooooog_P:mm`;oo`001?oo00?F^]JJeYX01<ii0/iI0f</
00<H``Q100000Q2200@H`b448B@YA@>4<003g]__GOoo00;oo`03mkk_OJDd00922004264000002442
48800e[[_OOgWP03ool00liicUW>F@03cUT016</6<<000000P0P00<8HA2R6><00R4400@Q98@`Q11k
k`;F^P04iccooooomkh2_OL2ool000Coo`03e[[FV]JJ00C>N@;>F@=S;0036<<8@@00008@PP046<<Q
124T:DD3Q3000mkKkegoo`02ool00oNnkgfU=002@PP010QQ000000Q10Q2200=Jjkggmih00ooo00?>
NLiIcUT00liI00AS;1S3000000808003264@XQSS008Q10048BB4<8@@Nnl2e[X01>LlooooooNn0[gg
0_oo0004ool00mJjeY[FVP04cWT2cUT3Hb`00aS324400002488011S38@@Q92U50h@`00?NfnmMool0
0_oo00?g_^mmYC@00T8800@8H@000008@@8@PP03F^^mmoNN00?oo`03cWW>FLiI00?>F@04Hb`H``00
000202000`QQ4:8Hh`028@@0124TQ32447__0]Jj00CW??ooooog_P:mm`;oo`001?oo00?F^]JJeYX0
1<ii0/iI0f</00<H``Q100000Q2200@H`b448B@YA@>4<003g]__GOoo00;oo`03mkk_OJDd00922004
26400000244248800e[[_OOgWP03ool00liicUW>F@03cUT016</6<<000000P0P00<8HA2R6><00R44
00@Q98@`Q11kk`;F^P04iccooooomkh2_OL2ool00007oomBZU:Z4:80800002001CWW0jDD00BU=>mM
ooooo`;g_P04kgg_GNLLg_/2g]/00g_?NnlQ9002020010000208HA2R0QS300@Q17_?e[[og`;oo`04
omogW^mMU;82W=<013W72440012R0QS300AcS/iiomooo`;og`03mik_GNLl00:<L@04<HH080000203
>LL00icciccoo`04ool00007oomBZU:Z4:80800002001CWW0jDD00BU=>mMooooo`;g_P04kgg_GNLL
g_/2g]/00g_?NnlQ9002020010000208HA2R0QS300@Q17_?e[[og`;oo`04omogW^mMU;82W=<013W7
2440012R0QS300AcS/iiomooo`;og`03mik_GNLl00:<L@04<HH080000203>LL00icciccoo`04ool0
0007oomBZU:Z4:80800002001CWW0jDD00BU=>mMooooo`;g_P04kgg_GNLLg_/2g]/00g_?NnlQ9002
020010000208HA2R0QS300@Q17_?e[[og`;oo`04omogW^mMU;82W=<013W72440012R0QS300AcS/ii
omooo`;og`03mik_GNLl00:<L@04<HH080000203>LL00icciccoo`04ool00007oomBZU:Z4:808000
02001CWW0jDD00BU=>mMooooo`;g_P04kgg_GNLLg_/2g]/00g_?NnlQ9002020010000208HA2R0QS3
00@Q17_?e[[og`;oo`04omogW^mMU;82W=<013W72440012R0QS300AcS/iiomooo`;og`03mik_GNLl
00:<L@04<HH080000203>LL00icciccoo`04ool00004oooNfmkKe[X2eYX3cWT4cUT2Hb`011S32440
00000PQ100@@PQS3Jfe[C@=S;005H`aJjkgg_OOgWP02ool01_Nnkgg_OIcc>NL8@@<00004244@PQS3
6><28@@0124T:DF<DMkk0ooo00?ogoNNked00^LL00><LIBBU9800S6V00@8@@000208H@8@XP046<<Q
17_?eYX2ia`2ool00004oooNfmkKe[X2eYX3cWT4cUT2Hb`011S3244000000PQ100@@PQS3Jfe[C@=S
;005H`aJjkgg_OOgWP02ool01_Nnkgg_OIcc>NL8@@<00004244@PQS36><28@@0124T:DF<DMkk0ooo
00?ogoNNked00^LL00><LIBBU9800S6V00@8@@000208H@8@XP046<<Q17_?eYX2ia`2ool00004oooN
fmkKe[X2eYX3cWT4cUT2Hb`011S3244000000PQ100@@PQS3Jfe[C@=S;005H`aJjkgg_OOgWP02ool0
1_Nnkgg_OIcc>NL8@@<00004244@PQS36><28@@0124T:DF<DMkk0ooo00?ogoNNked00^LL00><LIBB
U9800S6V00@8@@000208H@8@XP046<<Q17_?eYX2ia`2ool00004oooNfmkKe[X2eYX3cWT4cUT2Hb`0
11S3244000000PQ100@@PQS3Jfe[C@=S;005H`aJjkgg_OOgWP02ool01_Nnkgg_OIcc>NL8@@<00004
244@PQS36><28@@0124T:DF<DMkk0ooo00?ogoNNked00^LL00><LIBBU9800S6V00@8@@000208H@8@
XP046<<Q17_?eYX2ia`2ool00004oooNfmkKe[X2eYX3cWT4cUT2Hb`011S3244000000PQ100@@PQS3
Jfe[C@=S;005H`aJjkgg_OOgWP02ool01_Nnkgg_OIcc>NL8@@<00004244@PQS36><28@@0124T:DF<
DMkk0ooo00?ogoNNked00^LL00><LIBBU9800S6V00@8@@000208H@8@XP046<<Q17_?eYX2ia`2ool0
00Coo`03g]_F^W_?009kc`04NnlQ900P000224401122F^^mmoNN0ooo00?g_^mmW?<00SWW00<8@@00
48800Q2R00A[CLiIe[[og`;oo`04omogW^mMW=<2>LL00`Q100000003<JH2W=<02>Llooooooooomog
W^mMia`2g_/00mkKe[Yc[P02Nll0124T4:8000000PQ100@@PQ2R6>=c[P9cSP;oo`001?oo00?NfmJj
Nll00W_?00Akkb4T02000088@@04489Jjkggmih3ool00oNnkgfLl`02>NL00`Q1000@PP024:8016]=
cUWF^_oO0_oo00CogoNNkefLd`8ia`032440000000<aYP:Ld`08iccooooooooogoNNkegW70;Nn`03
g]_F^W>^009kc`048B@@XP000002244011224:8Hhg>^0W>>0_oo0004ool00mkKe[Ykc`02Nll017__
8B@080000PQ100@@PU[[_OOgWP?oo`03mkk_OIcc008ii`0324400122008@XP04Jdg>FMJjoml2ool0
1?oOmik_GIcC0SW700<8@@0000000c6V0YcC00SW??oooooooooOmik_GNLL0]kk00?NfmJjLjh00W_?
00@Q912R00000088@@04488@XQSSLjh2Lhh2ool000Coo`03g]_F^W_?009kc`04NnlQ900P00022440
1122F^^mmoNN0ooo00?g_^mmW?<00SWW00<8@@0048800Q2R00A[CLiIe[[og`;oo`04omogW^mMW=<2
>LL00`Q100000003<JH2W=<02>LlooooooooomogW^mMia`2g_/00mkKe[Yc[P02Nll0124T4:800000
0PQ100@@PQ2R6>=c[P9cSP;oo`001?oo00?NfmJjNll00W_?00Akkb4T02000088@@04489Jjkggmih3
ool00oNnkgfLl`02>NL00`Q1000@PP024:8016]=cUWF^_oO0_oo00CogoNNkefLd`8ia`0324400000
00<aYP:Ld`08iccooooooooogoNNkegW70;Nn`03g]_F^W>^009kc`048B@@XP000002244011224:8H
hg>^0W>>0_oo00001oooJfe[KLiig]_ogooo00;g_P04kgfU5488264300000c66U;;W7003ool00ooO
_OMJb`024:800`0P00008003>LL00icciccg_P02ool01?oOmik_ONLl0Xaa00<aQR4T4:800`0000@8
@A22F/]Jb`:me`04mikooooomkh2kgd00nLliab4<002:FD0100P000H`b440R4T0RU500><DMkkool0
0ooo00001oooJfe[KLiig]_ogooo00;g_P04kgfU5488264300000c66U;;W7003ool00ooO_OMJb`02
4:800`0P00008003>LL00icciccg_P02ool01?oOmik_ONLl0Xaa00<aQR4T4:800`0000@8@A22F/]J
b`:me`04mikooooomkh2kgd00nLliab4<002:FD0100P000H`b440R4T0RU500><DMkkool00ooo0000
1oooJfe[KLiig]_ogooo00;g_P04kgfU5488264300000c66U;;W7003ool00ooO_OMJb`024:800`0P
00008003>LL00icciccg_P02ool01?oOmik_ONLl0Xaa00<aQR4T4:800`0000@8@A22F/]Jb`:me`04
mikooooomkh2kgd00nLliab4<002:FD0100P000H`b440R4T0RU500><DMkkool00ooo00001oooJfe[
KLiig]_ogooo00;g_P04kgfU5488264300000c66U;;W7003ool00ooO_OMJb`024:800`0P00008003
>LL00icciccg_P02ool01?oOmik_ONLl0Xaa00<aQR4T4:800`0000@8@A22F/]Jb`:me`04mikooooo
mkh2kgd00nLliab4<002:FD0100P000H`b440R4T0RU500><DMkkool00ooo00001oooJfe[KLiig]_o
gooo00;g_P04kgfU5488264300000c66U;;W7003ool00ooO_OMJb`024:800`0P00008003>LL00icc
iccg_P02ool01?oOmik_ONLl0Xaa00<aQR4T4:800`0000@8@A22F/]Jb`:me`04mikooooomkh2kgd0
0nLliab4<002:FD0100P000H`b440R4T0RU500><DMkkool00ooo0003ool01=kkg]]kkb4T0P0P00@0
000P265BZP:me`04aQSg__ooool2mkh01>mmicbDTS6V0PQ100<0012R6><00R4400@Q98@`Q13Nf`;o
g`04oooogoNN[ED2[GD01;FFBVT@PP000P0P00@8HA2R6>=cSP;>N@04g__ooooog_/2g]/00g__Q10Y
A@0202000`00020ii`03YA@00jDd[EG_G@05ool000?oo`04g__Nfg__8B@2020010000208HE:Z0[gG
00C66?Nnooooo`;g_P04kggW?9BB<JH224400`004:8Hh`028@@0124TQ3244=kK0_oO00CooooOmij]
E@:]M@04]II:JA220002020010QQ4:8Hhg>>0/ii00CNnooooooNn`;Nf`03Nnn442U5008080030000
83WW00>U5003YCB]ENmM00Goo`000ooo00CNnmkKNnlQ90808004000080QQDZX2_ML01<HHmkkooooo
0_Nn00C_ONLlU98aYP88@@03000@XQSS008Q10048BB4<8@@g]/2oml01?ooomogWZeE0Zee00BeUTYY
488000808004264@XQSSLhh2cWT01=kkooooomkk0]kK00=kkh@@:DD00P0P00<0000P>NL00jDD00>U
=:eEked01Ooo0003ool01=kkg]]kkb4T0P0P00@0000P265BZP:me`04aQSg__ooool2mkh01>mmicbD
TS6V0PQ100<0012R6><00R4400@Q98@`Q13Nf`;og`04oooogoNN[ED2[GD01;FFBVT@PP000P0P00@8
HA2R6>=cSP;>N@04g__ooooog_/2g]/00g__Q10YA@0202000`00020ii`03YA@00jDd[EG_G@05ool0
0006ooog__Nn_MMBZQ220`0000@8@A22F^]Jb`:mm`04mikooooomkh2]IH2]KH01kgGDZX@PQ220008
@A22008H``04Jfe[CLiIe[X2oml01?ooomo66<HH0e[[00<@XP0000000PQ100@@PU[;_OOgWP?oo`03
mkk_ONLl00;W7003g__NfmJj00?FVP03cWU[KF]]009[K@046><0000002022642ool00006ooog__Nn
_MMBZQ220`0000@8@A22F^]Jb`:mm`04mikooooomkh2]IH2]KH01kgGDZX@PQ220008@A22008H``04
Jfe[CLiIe[X2oml01?ooomo66<HH0e[[00<@XP0000000PQ100@@PU[;_OOgWP?oo`03mkk_ONLl00;W
7003g__NfmJj00?FVP03cWU[KF]]009[K@046><0000002022642ool00006ooog__Nn_MMBZQ220`00
00@8@A22F^]Jb`:mm`04mikooooomkh2]IH2]KH01kgGDZX@PQ220008@A22008H``04Jfe[CLiIe[X2
oml01?ooomo66<HH0e[[00<@XP0000000PQ100@@PU[;_OOgWP?oo`03mkk_ONLl00;W7003g__NfmJj
00?FVP03cWU[KF]]009[K@046><0000002022642ool00006ooog__Nn_MMBZQ220`0000@8@A22F^]J
b`:mm`04mikooooomkh2]IH2]KH01kgGDZX@PQ220008@A22008H``04Jfe[CLiIe[X2oml01?ooomo6
6<HH0e[[00<@XP0000000PQ100@@PU[;_OOgWP?oo`03mkk_ONLl00;W7003g__NfmJj00?FVP03cWU[
KF]]009[K@046><0000002022642ool00006ooog__Nn_MMBZQ220`0000@8@A22F^]Jb`:mm`04miko
oooomkh2]IH2]KH01kgGDZX@PQ220008@A22008H``04Jfe[CLiIe[X2oml01?ooomo66<HH0e[[00<@
XP0000000PQ100@@PU[;_OOgWP?oo`03mkk_ONLl00;W7003g__NfmJj00?FVP03cWU[KF]]009[K@04
6><0000002022642ool00007ool@XQ2R6><Q17__e[X00^LL0_oo00SogoNNYCBU=48X264001220U[[
00AJbe:ZDXYBRP9:J@03]IK_OOoo00;gWP04kefLdicc>NL22442000020Q1489S36<<aQSg__ookgd2
ic`019BB<HH8@@000P0P00@iaicciccg_P;oo`03kegW7=kk00:44004:DDH``000205>NL00jDDYCBU
=002ool00007ool@XQ2R6><Q17__e[X00^LL0_oo00SogoNNYCBU=48X264001220U[[00AJbe:ZDXYB
RP9:J@03]IK_OOoo00;gWP04kefLdicc>NL22442000020Q1489S36<<aQSg__ookgd2ic`019BB<HH8
@@000P0P00@iaicciccg_P;oo`03kegW7=kk00:44004:DDH``000205>NL00jDDYCBU=002ool00007
ool@XQ2R6><Q17__e[X00^LL0_oo00SogoNNYCBU=48X264001220U[[00AJbe:ZDXYBRP9:J@03]IK_
OOoo00;gWP04kefLdicc>NL22442000020Q1489S36<<aQSg__ookgd2ic`019BB<HH8@@000P0P00@i
aicciccg_P;oo`03kegW7=kk00:44004:DDH``000205>NL00jDDYCBU=002ool00007ool@XQ2R6><Q
17__e[X00^LL0_oo00SogoNNYCBU=48X264001220U[[00AJbe:ZDXYBRP9:J@03]IK_OOoo00;gWP04
kefLdicc>NL22442000020Q1489S36<<aQSg__ookgd2ic`019BB<HH8@@000P0P00@iaicciccg_P;o
o`03kegW7=kk00:44004:DDH``000205>NL00jDDYCBU=002ool00007ool@XQ2R6><Q17__e[X00^LL
0_oo00SogoNNYCBU=48X264001220U[[00AJbe:ZDXYBRP9:J@03]IK_OOoo00;gWP04kefLdicc>NL2
2442000020Q1489S36<<aQSg__ookgd2ic`019BB<HH8@@000P0P00@iaicciccg_P;oo`03kegW7=kk
00:44004:DDH``000205>NL00jDDYCBU=002ool00003ooo_GNmM00;oo`08mkjmee:ZDZYBRTY9@RPi
i`8aQP048B@080000202>NL01:DDkegogooo0_oO00?6>6<<6<<00P0000@08488@PRU=0;_G@04omoo
onLlS742U980136V2440000P0PQQ00@@XQS3Lhi[K@;>F@04mkkoonmMU;82W=<00cW7244000020200
10Q1488H`aSS0R4T00@YAH@`g]_og`Coo`0000?oonmMked00_oo00Sg_[gGDZYBZU::BTU2:3WW0S66
00@Q900P0000808ii`04YAC_GOoOool2oml00lHhH``H``020000100P@PQ22:Dd0^mM00Cogoooicb<
L@:DTP04<JH8@@0002022640112R6<=cSV]]0/iI00Cg__ookefD/P:Ld`03>LL8@@0000808004244@
PQS36><28B@012U5Q33NfooO1?oo00000oookeg_G@02ool02?Nn_MMBZU:ZDXY:BD8X>NL2<HH0124T
0200000P0SWW00BU5>mMomooo`;og`03aSQS31S30080000402122488YC@2ked01?oOoooW?8aa0YBB
00@aYPQ100008088H@044:8H`g>>Jfd2cUT01?Nnooo_GIBb0YcC00<ia`Q100000P0P00@8@A226<<H
h`8Q9004:DF4<=kKoml4ool00003ooo_GNmM00;oo`08mkjmee:ZDZYBRTY9@RPii`8aQP048B@08000
0202>NL01:DDkegogooo0_oO00?6>6<<6<<00P0000@08488@PRU=0;_G@04omooonLlS742U980136V
2440000P0PQQ00@@XQS3Lhi[K@;>F@04mkkoonmMU;82W=<00cW724400002020010Q1488H`aSS0R4T
00@YAH@`g]_og`Coo`0000?oonmMked00_oo00Sg_[gGDZYBZU::BTU2:3WW0S6600@Q900P0000808i
i`04YAC_GOoOool2oml00lHhH``H``020000100P@PQ22:Dd0^mM00Cogoooicb<L@:DTP04<JH8@@00
02022640112R6<=cSV]]0/iI00Cg__ookefD/P:Ld`03>LL8@@0000808004244@PQS36><28B@012U5
Q33NfooO1?oo00001_ooomooglHHF^/@XP<00004:DF4<8@`g]/2ked01?oomkk_ONLl0^LL00B<DBUU
0200008080<ia`:Ll`04iccg__ooked2ia`01=kkQ124<2UU0P0P00@0024TQ11kk`9kc`04e[[ogooo
oml2mih01>mMicb<LIBB0S6V00<8@@0002000S6V0SW700JLlnLloooooooOmih2[ED2[GD2ool00006
oooogooOaQQJja2R0`0000@YAH@`Q33Nf`;_G@04ooog_^mmic`2ia`018aA:FD080000P0P0cW70Ycc
00CW??Nnooo_G@;W7004g_^448@`:FD2020010008BB447__0W_?00CF^_oOoooog`;gWP04kegW?8aa
U982<JH00`Q100008002<JH2>LL01YcciccoooooomogWP:]E@:]M@;oo`0000KooooOomo665[[4:83
000012U5Q324<=kK0^mM00CoooNnkggW?0;W7004S54YI@0P00020203>LL2W?<01>LlmkkoonmM0^LL
00CNnh@@Q30YI@808004000Q98@@Nnl2Nll01=JjomoooooO0_NN00C_GNLlS76DTP8aYP032440000P
008aYP8ia`06W??W??oooooogoNN0ZeE0Zee0_oo00001_ooomooglHHF^/@XP<00004:DF4<8@`g]/2
ked01?oomkk_ONLl0^LL00B<DBUU0200008080<ia`:Ll`04iccg__ooked2ia`01=kkQ124<2UU0P0P
00@0024TQ11kk`9kc`04e[[ogooooml2mih01>mMicb<LIBB0S6V00<8@@0002000S6V0SW700JLlnLl
oooooooOmih2[ED2[GD2ool00004oom:BDY9264200001R4T:DDYABUUS77Nn`?oo`04g__Nfg__Nnl2
:DD0100P000Hhb440R4T00>4<=kKoml00_oo00Cg_^mmYABU=0922004>LLYI@0P00026<<016]]cWWN
fooO0_oo00Cg_^mmYAA22088H@800007244@PQS36<<Hhg_?eYX00^LL0_oo00SogoNNkeg_GNLLg_^4
48@`0RUU0_oo00001?ooBTU:B@QQ0P0000HQ92U5:DDYIHaag_/3ool01=kkg]]kkg__0RU500@08000
6><Q108Q9003Q33NfooO00;oo`04mkk_OJDDYC@2@PP013W7:FD080000QS300A[KLiig]_og`;oo`04
mkk_OJDD@PP2264200001`Q1488H`aS36>=kcmJJ00;W70;oo`08omogW^mMkegW7=kkQ124<08YI@;o
o`0000CoodY9BTT8H@8000068B@YABU5:FF<LMkk0ooo00CNnmkKNnmkk`8YA@04020001SS8@@28B@0
0h@`g]_og`02ool01?NnkgfU5:Dd0T8800@iabUU0200008H``04Jfg>NMkKoml2ool01?NnkgfU5488
0PQQ0P0000L8@A226<<H`aSSNloFVP02ia`2ool02?oOmik_GNmMiacNnh@@Q302:FD2ool00004oom:
BDY9264200001R4T:DDYABUUS77Nn`?oo`04g__Nfg__Nnl2:DD0100P000Hhb440R4T00>4<=kKoml0
0_oo00Cg_^mmYABU=0922004>LLYI@0P00026<<016]]cWWNfooO0_oo00Cg_^mmYAA22088H@800007
244@PQS36<<Hhg_?eYX00^LL0_oo00SogoNNkeg_GNLLg_^448@`0RUU0_oo00001?ooBTU:B@QQ0P00
00HQ92U5:DDYIHaag_/3ool01=kkg]]kkg__0RU500@080006><Q108Q9003Q33NfooO00;oo`04mkk_
OJDDYC@2@PP013W7:FD080000QS300A[KLiig]_og`;oo`04mkk_OJDD@PP2264200001`Q1488H`aS3
6>=kcmJJ00;W70;oo`08omogW^mMkegW7=kkQ124<08YI@;oo`0000Goo`0P0200000P009220:U=004
kegoooNnkgd2YA@01488<JHYA@0P0P0000@8@D88[EG_G@;og`03oooW78aA00:<L@04<HHQ900P0002
020010QQ4:8Hhg>>0V]]00C>NONnoooog`;gWP04[GE:BD88264300000`Q1BVVeUP02kgd2ool00mJJ
cWW>N@02cWT00f]=6><0000200000`0P@PRU=002[ED2ool00005ool0800P00008002@PP2YC@01>mM
ooog_^mm0ZDD00A2236V:DD08080000424522:eEked2oml00oooiab<D@02S74013668B@080000P0P
00@8HA2R6>=cSP9[K@04cWWg__oooml2mih01:eeBTU220QQ0`0000<8@DYY]IH00^mm0_oo00?FV/ii
cWT00/ii00=[CASS00000P0000<08488YC@00ZeE0_oo00001Ooo0200800002000T880ZDd00C_GOoo
mkk_O@:U5004@PPaYRU50202000010Q1@PR]ENmM0_oO00?oonLLS5400Xaa00@aQR4T020000808004
264@XQSSLhh2Jfd01<iimkkooooO0_NN00B]MDY9@PP8H@<00003245:JKFF00;_O@;oo`03eY[>NLii
00;>N@03JddHh`000080000302122:Dd00:]E@;oo`0000Goo`0P0200000P009220:U=004kegoooNn
kgd2YA@01488<JHYA@0P0P0000@8@D88[EG_G@;og`03oooW78aA00:<L@04<HHQ900P0002020010QQ
4:8Hhg>>0V]]00C>NONnoooog`;gWP04[GE:BD88264300000`Q1BVVeUP02kgd2ool00mJJcWW>N@02
cWT00f]=6><0000200000`0P@PRU=002[ED2ool00005ool0800P00008002@PP2YC@01>mMooog_^mm
0ZDD00A2236V:DD08080000424522:eEked2oml00oooiab<D@02S74013668B@080000P0P00@8HA2R
6>=cSP9[K@04cWWg__oooml2mih01:eeBTU220QQ0`0000<8@DYY]IH00^mm0_oo00?FV/iicWT00/ii
00=[CASS00000P0000<08488YC@00ZeE0_oo00001_ookeg_GOoOoooW70><D@04S74aQP0P00020202
>LL4W?<01>LloooogoNN0^mM00?W78aAS7400YBB00@aYPQ100008088H@03DXZe]^mm00?oo`04mkkg
WZDd@PP226401000488H`aSS0R440W__00OF^_oOooooonLLS74aQP02020010000208HA2R0V<<00C6
>?Nnoooog`;>F@;oo`0000KoonmMkegogoooia`3S54018aa<HH080000P0P0SW719cc00CW??ooomog
WP;_G@03iab<DHaa00:DTP04<JH8@@00020226400e::]KK_O@03ool01?NnmijU=4880PQQ00@00122
6<<Hh`8Q109kk`07e[[ogooooooW78aa<HH00P0P00@0000P264@XP9S3004aSSg__oooml2cUT2ool0
0006ooo_GNmMomooonLL0haA00B<LC6602000080808ia`BLl`04iccooooOmih2ked00nLLS56<L@02
U980136V2440000P0PQQ00=BR[Ffkgd00ooo00Cg__NNYCA22088H@04000@PQS36><28@@2Nnl01mJj
omooooooiab<LC6600808004000080QQ4:82H``01<HhmkkooooO0/iI0_oo00001_ookeg_GOoOoooW
70><D@04S74aQP0P00020202>LL4W?<01>LloooogoNN0^mM00?W78aAS7400YBB00@aYPQ100008088
H@03DXZe]^mm00?oo`04mkkgWZDd@PP226401000488H`aSS0R440W__00OF^_oOooooonLLS74aQP02
020010000208HA2R0V<<00C6>?Nnoooog`;>F@;oo`0000KoonmMkegogoooia`3S54018aa<HH08000
0P0P0SW719cc00CW??ooomogWP;_G@03iab<DHaa00:DTP04<JH8@@00020226400e::]KK_O@03ool0
1?NnmijU=4880PQQ00@001226<<Hh`8Q109kk`07e[[ogooooooW78aa<HH00P0P00@0000P264@XP9S
3004aSSg__oooml2cUT2ool00007oom[CF]=6><8H@0048800V<<00C66?Nnooo_O@;W?004U9:D/YBb
>LL2244010000208@A220QS300<Hhg_?Ljh00]JJ00CNnnmmooooo`;g_P04kggW?>LLg_/2g]/00mJj
LjhQ10030000100P>NLiijDD0ZDd00B]ENmMooooo`;g_P03kgfU5:Dd0092:00426400000<HH2U980
1>LLmikooooo0/ii0_oo00001oooJde[CASS26400122009S3004aQSg__ookgd2ic`019BBU;:D/SW7
0PQ100@0000P244@PP8H``036>=kcg>^00;FVP04g___OOooool2mkh01>mmiccW7=kk0]kK00?F^W>^
8@@00`0000@083WW>NNU50:U=004[EG_GOooool2mkh00nmmYABU=002@RP010QQ000003660YBB00CW
7?NNooooo`;>N@;oo`0000Ooof]=JddHh`QQ000@PP02H``01<HHmkkoonmm0^Ll00BDTYBbU;8ia`88
@@04000080Q148826<<00aSSNlmc[P02eYX01=kkkggooooo0_Nn00C_ONLliacNn`;Nf`03e[Yc[R44
00<00004020iicWWYA@2YC@01:eEkegooooo0_Nn00?_OJDDYC@00T8X00@8H@00000aQP:DTP04iacg
W_ooool2cWT2ool00007oom[CF]=6><8H@0048800V<<00C66?Nnooo_O@;W?004U9:D/YBb>LL22440
10000208@A220QS300<Hhg_?Ljh00]JJ00CNnnmmooooo`;g_P04kggW?>LLg_/2g]/00mJjLjhQ1003
0000100P>NLiijDD0ZDd00B]ENmMooooo`;g_P03kgfU5:Dd0092:00426400000<HH2U9801>LLmiko
oooo0/ii0_oo00001ooocWW>NLiIJddHh`QQ00<00003245:BDY900:]M@04kggooooomkh2kgd01:DD
YCA223W70RUU00<0800002000PQQ00ABR[Ff_OO6>0;g_P04oooogoNnkgd2ic`01>LLg]]kkbU50P0P
00@000Q1488@XP8Hh`048@@Q98@`g]/2oml00oooomo66002F^/015[;4:8000000PQ100=2::eEked0
1Ooo00001ooocWW>NLiIJddHh`QQ00<00003245:BDY900:]M@04kggooooomkh2kgd01:DDYCA223W7
0RUU00<0800002000PQQ00ABR[Ff_OO6>0;g_P04oooogoNnkgd2ic`01>LLg]]kkbU50P0P00@000Q1
488@XP8Hh`048@@Q98@`g]/2oml00oooomo66002F^/015[;4:8000000PQ100=2::eEked01Ooo0000
1ooocWW>NLiIJddHh`QQ00<00003245:BDY900:]M@04kggooooomkh2kgd01:DDYCA223W70RUU00<0
800002000PQQ00ABR[Ff_OO6>0;g_P04oooogoNnkgd2ic`01>LLg]]kkbU50P0P00@000Q1488@XP8H
h`048@@Q98@`g]/2oml00oooomo66002F^/015[;4:8000000PQ100=2::eEked01Ooo00001ooocWW>
NLiIJddHh`QQ00<00003245:BDY900:]M@04kggooooomkh2kgd01:DDYCA223W70RUU00<080000200
0PQQ00ABR[Ff_OO6>0;g_P04oooogoNnkgd2ic`01>LLg]]kkbU50P0P00@000Q1488@XP8Hh`048@@Q
98@`g]/2oml00oooomo66002F^/015[;4:8000000PQ100=2::eEked01Ooo00001ooocWW>NLiIJddH
h`QQ00<00003245:BDY900:]M@04kggooooomkh2kgd01:DDYCA223W70RUU00<0800002000PQQ00AB
R[Ff_OO6>0;g_P04oooogoNnkgd2ic`01>LLg]]kkbU50P0P00@000Q1488@XP8Hh`048@@Q98@`g]/2
oml00oooomo66002F^/015[;4:8000000PQ100=2::eEked01Ooo00001_ooe[[F^W>^8@@@PP<00004
8@AkkmJjoml2ool01=kKe[[FV]JJ0/ii0V]]00LHh`000000000P264@XP026><012448BB44=kK0_oO
00CoooNnkggW?0;W7004g_^448@@:DD26><00`00020ii`03YA@01>mMomoooooO0_NN00>]EJeeBTT0
0T8800<8H@0026400e::00A:JKFF_MO660;g_P;oo`0000KoomJje[Yc[R44488300001244NnoF^_oO
0_oo00CNfmJjeY[FVP;>N@9[K@076><00000000080QQ4:800QSS00@Q124TQ13Nf`;og`04ooog_^mm
ic`2ia`01=kkQ12442U50QSS00<0000P>NL00jDD00C_GOoOoooog`;gWP03[EF]MDY9009220032640
00QQ00=BRP04BVVeU[gGaQP2mkh2ool00006oooF^]JjLjhQ11220`0000@Q17__e[[og`;oo`04g]_F
^]JJeYX2cWT2Jfd01aSS000000000208HA2R008Hh`048@@Q98@@g]/2oml01?oomkk_ONLl0^LL00CN
nh@@Q10YA@8Hh`03000083WW00>U5004kegogooooml2mih00jeE[GE:B@02@PP00`QQ0008H@03DXX0
14YY]IJmelHH0_Nn0_oo00001_ooe[[F^W>^8@@@PP<000048@AkkmJjoml2ool01=kKe[[FV]JJ0/ii
0V]]00LHh`000000000P264@XP026><012448BB44=kK0_oO00CoooNnkggW?0;W7004g_^448@@:DD2
6><00`00020ii`03YA@01>mMomoooooO0_NN00>]EJeeBTT00T8800<8H@0026400e::00A:JKFF_MO6
60;g_P;oo`0000KoomJje[Yc[R44488300001244NnoF^_oO0_oo00CNfmJjeY[FVP;>N@9[K@076><0
0000000080QQ4:800QSS00@Q124TQ13Nf`;og`04ooog_^mmic`2ia`01=kkQ12442U50QSS00<0000P
>NL00jDD00C_GOoOoooog`;gWP03[EF]MDY900922003264000QQ00=BRP04BVVeU[gGaQP2mkh2ool0
00?oo`04kggW?9BBU;82W=<013W72440000P0PQ10TYY00ReU^mmooooooNNkegW?=kk0X@`00<YIASS
26400`0000<8@A226<<00QSS00<Q124T:DD00bUU0YBB00?NnoNNool00_oo00?g_^mmYA@00SWW00@8
@@00489S309Jj`03_OOgW_oo00;_O@04iccW78@`S542:FD0100P000080QQ0U::0_oo0003ool01>mm
icbDTYBb0YcC00@ia`Q100008088@@9:J@08]IK_OOooooogW^mMiccNn`:4<003:FDHh`QQ00<00003
244@PQS3008Hh`038@@Q92U500<YI@:DTP03g__gW_oo00;oo`03mkk_OJDD008ii`0424400122H``2
F^/00kggmikoo`02kgd01>Lliab4<8aA0RUU00@080000208H@9BRP;oo`000ooo00C_ONLlU9:D/P:L
d`04>LL8@@0002022442BVT02;FFkggooooomik_GNLlg_/2Q3000bUU6><8H@0300000`Q1488H``02
6><00b448B@YA@03:FD2U9800mkkmikoo`02ool00oNnkgfU5002>NL010Q1000@PV<<0U[[00>mmoNN
ool00^mm00CW?>LLQ32<D@8YI@040200000P2642DXX2ool000?oo`04kggW?9BBU;82W=<013W72440
000P0PQ10TYY00ReU^mmooooooNNkegW?=kk0X@`00<YIASS26400`0000<8@A226<<00QSS00<Q124T
:DD00bUU0YBB00?NnoNNool00_oo00?g_^mmYA@00SWW00@8@@00489S309Jj`03_OOgW_oo00;_O@04
iccW78@`S542:FD0100P000080QQ0U::0_oo0003ool01>mmicbDTYBb0YcC00@ia`Q100008088@@9:
J@08]IK_OOooooogW^mMiccNn`:4<003:FDHh`QQ00<00003244@PQS3008Hh`038@@Q92U500<YI@:D
TP03g__gW_oo00;oo`03mkk_OJDD008ii`0424400122H``2F^/00kggmikoo`02kgd01>Lliab4<8aA
0RUU00@080000208H@9BRP;oo`0000OoodYYBVU:JKFF]KJmm`02mih2ool00liiJde[C@03Jdd01ASS
0000000002000T8800>U=>mMked00_oo00Kg_^mmkgfU=48826430002<HH00c6VU;:Ld`03W=<02>Ll
ooooooooomnmme[;DZX24880100P000080QQ0Q2R00<H`g>>Jfd00f]=00?6>?Nnool00_oO00CgW[FF
]IJe]P9BRP;oo`0000OoodYYBVU:JKFF]KJmm`02mih2ool00liiJde[C@03Jdd01ASS000000000200
0T8800>U=>mMked00_oo00Kg_^mmkgfU=48826430002<HH00c6VU;:Ld`03W=<02>Llooooooooomnm
me[;DZX24880100P000080QQ0Q2R00<H`g>>Jfd00f]=00?6>?Nnool00_oO00CgW[FF]IJe]P9BRP;o
o`0000OoodYYBVU:JKFF]KJmm`02mih2ool00liiJde[C@03Jdd01ASS0000000002000T8800>U=>mM
ked00_oo00Kg_^mmkgfU=48826430002<HH00c6VU;:Ld`03W=<02>Llooooooooomnmme[;DZX24880
100P000080QQ0Q2R00<H`g>>Jfd00f]=00?6>?Nnool00_oO00CgW[FF]IJe]P9BRP;oo`0000OoodYY
BVU:JKFF]KJmm`02mih2ool00liiJde[C@03Jdd01ASS0000000002000T8800>U=>mMked00_oo00Kg
_^mmkgfU=48826430002<HH00c6VU;:Ld`03W=<02>Llooooooooomnmme[;DZX24880100P000080QQ
0Q2R00<H`g>>Jfd00f]=00?6>?Nnool00_oO00CgW[FF]IJe]P9BRP;oo`00DOoo001Aool0057oo`00
DOoo001Aool0057oo`00DOoo001Aool0057oo`00DOoo0000\
\>"],
  ImageRangeCache->{{{0, 80}, {323, 0}} -> {-1.60033, -1.91534, 0.840006, \
0.210002}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"GraphicsArray", "[", 
        RowBox[{
          RowBox[{"{", 
            RowBox[{"{", 
              RowBox[{"grB", ",", "grB"}], "}"}], "}"}], ",", 
          RowBox[{"GraphicsSpacing", "\[Rule]", "0"}]}], "]"}], "//", 
      "Show"}]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0119048 0.47619 [
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0119048 0.5 0.488095 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.014881 0.0238095 0.014881 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
% Start of gray image
p
.02381 .02381 translate
.95238 .95238 scale
64 string
64 64 8 [64 0 0 64 0 0] {
\tcurrentfile
\t1 index
\treadhexstring
\tpop
}  Mimage
00040B4F4C4A49474544A8EAFAFEF8C2C25E1801012886D9E9FDF4EDE6E0872E1F020022
7D7B7875CFF8FEF8C05C170109105BBDF2FEFBCC6A1D0201070F161C
217CD4F9FEF9F1EAE3DE84878A8D310700040C514EB2EEFEFCF5EDE69296999D3C320700
050D53B7F0FDFDF6EEE7E1892F06001A1F24807D7BD3F9FDF7EFE896
370900040C1361C2F4FEFBF3B0B34F11000D1463C3CEF7FEF9F2EA9B9EA240362A050126
292C2E3032949494E1F1FEFCF5B65213000B4FB2EEFCF8F0E9E3DD83
2B1C0201070F1668C7F5FEFAF3EB9DA03F350800171D2226292C2F3092E0FCFEF7EFE8E2
8B300700050C141A70CCD9FAFEF8C0C15D5A1606001A706CCAF6FEE7
E1892F210300060E161C73CEDCFBFBF4ECE5DF872D0600070E161C217CD4E2FCF8C15D17
0700050D151B202581D7FAFCD4D171727374220300060E1566C5F5FE
FAF3AF4C453D330800040C141A6F6C69C7D3F9FEF9F1ABAE4A0F00020A4AAEECFEF2EA9C
9FA2A5A8ABAEB0B2B4B652120002094846AAEBFEF3EB9EA1400C0003
0B4DB1EDFEFCD1CFCD6B1E0D0003313294E1FCFDDAD7D3D1CFCDCB6969691D02050D141B
71CDF7FEE6E0DBD7797B7E80291A0101074342A6E9F9FDF6BB571405
00050D151B202581D7FAFEF8C25E170108105A57BAF1FEFBF4ECE5E0DBD7797B7D280400
063CA0E6FDF6EEA4420C00020911186B6864C4F4FEFBF3EBE5DFDA7E
280501292C8C8A89DBFBFEDEDA7D7F290500050D1565C4F4FEFAC967661B02060E1565C5
F5FEFAC9C8661B0B00030B13191F78D1F8FEF9C4C460190101272A2D
8DDDEEFCFDF7EFA6440D0010176A67C6F5FEFAF3EB9DA03F0B00020A125E5B5855B8F0FE
FBF4ECE5E0DB7F82852C1D0D00030A125FC0F3FEEEA4A7AA470E0101
0845A9EAFEFCD3D1CF6D6E1F0200070F161C2125292C2E30323396E2F2FEFCF5EDA13F36
0800040C50B3EEFEFCF4B4B6524D11000D53504EB2B8F0FDFDF6EEA3
A6A9AC490F0101272A2D8D8CDDFBFEF8F0A8450E00030A12191E237F7CD4F9FEE2DD822A
0500050D141B2025282B2E30329393E0FCFEDB7F28190101268482D7
FAFEF8C1C25E180700040C514EB2EEFEF1E999390A00043536363738389CE4F5FFFAF3EB
E4DF85892E0600217B78D1F8FEF9C461190101272A89DBFBFEDEDAD6
77240400060E555250B3EEFDF8F0E8973809001566C5F5FEEAE3DED9D6D3D0CE6D1F0204
3838399C9DE5FDF7EFA6440D00030A4CB0EDFEFCD171211002012428
2B2D30313395E1F2FEEDA1A442392D0600050D1464C4F4FEFBCB691D02012480D6FAFEF8
C25E1801010810176966C5F5FEFAC967661B020107424141A5E8F8FE
E38D3107001D227D7AD3F9FEE3DDD97C270400063D3CA0A2A5A8ACB1EEFEFCF5EDE6E088
2E0600050D141B202481D7FAFDF5B8B955511200020911186BC9F6FE
FAC6C562615F1801080F5956B9C1F3FEFBCB691C020124807ED5F9FEF9C2C3C35F180101
272A8A8887DAEAFEF4B34F11000209115D5ABCF1FEEDE6E0888B3007
00196DCAF6FEE7E1898C310700050C514F4C4AAEECFEFCF5EDE693969A9DA03F0B000332
94E1FCFDDAD6787A260400060E151B2125292B8B8A88DBEBFAFEF8F0
E9E38C310700050C141A20242886DAFAFEF8F0E99839090004353699E3FCFDD9D5D27322
11030007403FA3E8FDFDD57778250400060E1566C5F5FEEAE3DED97D
7F8285888B3022120002094846ABEBFAFEF8C0C1C1C1C15E5B59150500050D146461C1F3
FEEBE48F9296372B0500050D1464C4F4FEEA9A3A2F0600063EA2E7FD
FDF6EEE7E1DCD87B26160600060E151C726FCCF7FEFAF2EAE48E9295370900161C212529
2C2E8F8EDEFBFEF7BE5A57534F490F01010810595653514EB2B9F0FD
FDF6EEE7E1DC8129050108444342414040A4E8FDFDF6B9BABB57531300020911181E76D0
F8FEF9C5611901012684827FD6F9FEF9F1E9E3DED97D271801081017
69C8F5FEFAC7641A0101070F1668C7D3F9FEF9F1AB480F00020A4A4847ABEBFAFCF4EDE6
E0872D1F0F00020A11181E77D1DFEFFEFCCFCDCCCAC967661B0B0013
61C2F4FEFBF4EC9FA240372B1C0201070F161C74CFDCFBFEDD832B0500050D1464C4F4FE
FBF3B0B3B5501200022C8C8BDCFBFBCC6A1D020124278684817F7C7A
D2E1FCFDDA7E8184872D0600050D5250B3BAF1FEFBCDCCCA686868671C0B00030B1260C1
F3FEFBCD6C1E0E01012A898785D9E9FDFDF6EEA3410C00115E5A5754
B7BFF3FEFBCBCAC9C865651B02010743A7ABAFEDFCFEF7EFA7AA470E000F1668C7F5FEFA
F2EB9CA0A3410C00030A12191F7874CFF8FEF9C5C5C4C4615F180108
0F171D74CFF8FEDFDA7E280400060D54514F4CB0B6F0FEFCF4ECA03F0B0003333496E2F2
FEECE5919498390900040B131A6F6B68C7F5FEFAF3AFB14D1102050D
524F4D4B4947ACEBFEF3EBE48F330800181D227ED5F9FEE2DDD8D5D272210300060E1667
C6D1F8FEF9F1EA9A9E3D0B00033335363699E3F4FEFBF3ECE5909497
9B9E3D330800050D141B716DCAD7E6FDF6BA5514000A125F5CBEC7D3E2FCF9C25F180101
08105A575451B5BCC5D0F8FEF9C5C4C4611901070F161C7470CCF7FE
FAF2EAE4DEDAD6D3D070201000022E8F8EDEFBFEDC822A0500050D141B716ECBD7FAFCF5
EDA2A5430D0011186B6764605D5A57BAF1FEFBF4ECE5E0878A2F2103
00063F3FA3A5E9FDF5B5B753130300060E5553B6BDF2FEF1AAADAFB2B4504A430D000209
4746AAEBFEFCF5EDE6E1882E200300070E56B9F1FEEEE7E1898C9033
0800050D1464C4CFF8FEE5DFDAD7D3D1702003040B131A1F7875D0DEEEFEFCF5EDA13F0C
00030B4DB1B7BEF2FEFBF3EC9EA2A5433A0A000435979898E3FCFDD9
7C7F2805010810176AC8F5FEFAF2EBE48F3207000437389B9CE5FDFDF6BABCBD58150109
11181E23272A2D8D8CDDFBFEDDD9D5772403001F2480D6FAFEF8F1E9
E38D310700063C3CA0E6FDFDF6BABB5714000A12196DCAF6FEFAC764631A010740A4E8FD
FDF6B9541300020911181D22262A2D2F31323435363799E3FCFDF7BB
57531300022B2E8E8D8CDDEDFEFCF5EDE693350800171D222683817E7CD4F9FEE2DDD9D5
772414000A12191F237FD6F9FDD677240400060E1566625FC0CAF6FE
E48F9296372B05010742414040A4A7E9FDF4EDE6E0872D06002226292C2E303294949494
E1FCFDF7BD5955514C10020124817ED5F9FEE1DC81842C1D0201070F
166864C4F4FEEBE48F320700181E23278482807D7AD3F9FEE38C909335290501282B8ADC
ECFEF2AE4B1000022E30929191DFF0FEFCCFCD6B6B1E0D000A12191E
77D1F8FEE48E91340800171D7571CDF7FEFAF2AD4A430D00030A125FC0F3FEEBE5DFDA7E
81842B1D0201070F58555250B3EEFEFCF4EDA03F0B00020A4A48ACEC
FEF2AF4B10000E156662C2F4FEFBCA681C02050D151B71CDF7FEFAF2AD4A433A0A00141A
2079D2E1FCFDF7EFE8E2DDD8D5D2D06F7071211000022E309190DFEF
FEFCCFCDCBCAC9661B0201070F161C217CD4F9FDF6EFA5430D00033133349697E2FCFDDA
D678240400063EA2A4E8F8FEF9F1EAE38D310700053C3C9FE6FDFDF6
BA561404022A2D2F9090DFFBFEF7BEBEBFC05C591505001B2025282B2E303293E1F1FEFC
D3D0CE6D1F0200070F161C217C79D2F8FEE38D312404001F242886D9
FAFEDF86892E06001A6FCBD8FAFEF8C15D17010810176AC8D4F9FEE2DDD9D5762403030A
12181E77D1F8FEE48E320700050D53B6F0FEFCCF6E6E6F7020100201
252988DAFBFEF8F0E9E28C30231300022B2E303293E1F1FEFBCDCC6A6A1D0D0011181E76
D0DEFBFEF7F0E8E2DD822A0500050D141B207AD3E1F2FEFBF4ECE5DF
862D060022268482D7FAFEF8C15E170101282B8ADCECFEFCD2D0CE6C6D6D1F0200237ED5
F9FDF6EEE7E1DCD8D5D272210300063F3FA3A5E9FDFDD5D2CFCD6C6C
1E0E0101084644A9ADECFEF2AFB14D110201074141403FA3A6AAEBFEFCD3747577240300
1F24807E7BD3F9FEF9F1AB48400C00125EBFC9D6F9FEF9C25E180700
181E227ED5F9FEF9C2C35F180101272A8A88DBFBFBF4B3B5B7524E480F00020A4AAEECFB
FEF7F0E8E2DDD9D5D2D0CECCCB681C0C00030B12191F23278583D8E8
FDFDD6D3D0CECCCBCAC966651B0A00131A1F24288684D8E8FDFDF6EEA3410C000209115D
BEF2FEFBCCCAC9C8C7651B0201070F161D222683817ED5E4FDFDF6BB
57140500053C3C3C3C9FA1A4E8FDFDF6EEE7E1DCD87A7D270400060D151B207BD3F9FDF7
EFE896993A0A00141B71CDF7FEFAF2EAE48E320700053B3B9FE6FDFD
D7D4D1CFCDCBCAC9C8C7641A0A00030B12196E6A6763605DBEF2FEFBF3EC9E3D0B00030A
12191E23272A8ADBFBFEF8F0E9E28C8F92350800050C141A2079D2E1
FCFDDAD7797B7D27040209105BBDF2FEFBF3EC9F3E0B0010176AC8D4F9FEF9F1EA9A3A0A
000334359798E3FCFDF7EFE8E2DCD8D57678241400010910171D7572
6FCBD8FAFCF5EDA1400C00033294E1FCFDF7BD59150500053B3B9EE6F6FEFAF2EBE48F32
2515010108105B58BAF1FEFBF4ECE5E0872D06001A2024282B8BDCFB
FEDDD97C270400060D54B7BFF3FEFCF4ECE692340800171D22268381D7FAFEF8F1AAADAF
4B1002060E151B72CDDBFBFEDEDA7D80290500053C9FA1A4A7E9FEFD
F6B85413000209115C59BBF1FEFBF4B2B4B6B85313000B13196E6BC9D5F9FEF9C3C35F5D
17010108105ABCF2FEFBF4ECE5DFDBD7D4D1CFCD6B6C6C1E0200070F
161C217CD4E3FCFDF7EFA6430D00115C595653504EB2EEFEF1E9999D3C0A00030A125FC0
F3FEEBE590330800053A9EE5F6FEE8E1DC822A1B02063E3E3D3DA1A3
E8FDFDF6B955504B443C31240400063EA2E7F7FEF9C5621901074140A4E8F8FEE38E9134
0800040C131A6F6CC9F6FEE79598390900040B131A1F242886D9FAFE
F8C05D170101288684D9E8FDF5EDE6E0882E060005393A3A9DE5F6FEE8E2DD82852C0601
24807D7BD3F9FEF9F1EAE38D91340800043738389BE4FDF7EFA7AAAD
490F0101272A2D8DDDFBFEDDD97B7E2804001D222684D8FAFCF5EDA2A5433A2E06001A6F
CBD8FAFCF5EDA2400C00030B12191F78D1DFFCFEF7EFE8E2DD82852C
0600074140A4E8FDF5EDA140362A05010843A7EAF9FEE18A8D31240300060E151B726FCB
F7FEF9F1AB48410C00030B4CB0EDFEFCD1CFCDCB691D02010742A6A9
EAFAFEE0888B8E3207000438389B9D9EE6FDF7EFE8E18A8D91340800040C50B4EFFDFDF6
EFA5430D0011181E227E7BD3F9FEE28C300700050C1463C3F4FEFACA
681C0C00125FC0F3FEEBE5909397380900040B131A1F7976D0DEEEFEFCF4EDE6E0DBD7D4
75230300063F3EA2A5A8EAFEFCF5EEA3A6430D00033192E0F0FEFBCE
CCCB681C0C0002094947ACEBFEFCF5EDA2A5433A2F0600050C52B5BCC5F5FEFAF3EBE4DF
DA7E2805010810171D222684D8FAFEF8C15D5B1601010845A9EBFEFC
D37422120300217BD3F9FDD9D5D2D0CE6D6D1F0200070F161C212583D8FAFCF5EDE6E0DC
80832B1C02063CA0A2E7F7FEF8F0A9AC48410C000D53504EB2B8C0F3
FEEBE5909497380900040B4F4DB0EDFEF1EAE3DE842B1D0C00020911181E23272A2D2F90
8FDEEFFEFCF4EDA03F0B0012605CBEF2FEECE5E0878A2F0600050C51
4F4DB1B7BEF2FEFBCC6A6A6A6A1D0201074141A5E8FDFDF6EEA3410C0003323334979798
98E3FCFDF7BC5754130400060E151B726F6B68C6F5FEFAF3AFB1B34F
pop
P
% End of image
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0119048 0.97619 0.488095 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.014881 0.0238095 0.014881 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
% Start of gray image
p
.02381 .02381 translate
.95238 .95238 scale
64 string
64 64 8 [64 0 0 64 0 0] {
\tcurrentfile
\t1 index
\treadhexstring
\tpop
}  Mimage
00040B4F4C4A49474544A8EAFAFEF8C2C25E1801012886D9E9FDF4EDE6E0872E1F020022
7D7B7875CFF8FEF8C05C170109105BBDF2FEFBCC6A1D0201070F161C
217CD4F9FEF9F1EAE3DE84878A8D310700040C514EB2EEFEFCF5EDE69296999D3C320700
050D53B7F0FDFDF6EEE7E1892F06001A1F24807D7BD3F9FDF7EFE896
370900040C1361C2F4FEFBF3B0B34F11000D1463C3CEF7FEF9F2EA9B9EA240362A050126
292C2E3032949494E1F1FEFCF5B65213000B4FB2EEFCF8F0E9E3DD83
2B1C0201070F1668C7F5FEFAF3EB9DA03F350800171D2226292C2F3092E0FCFEF7EFE8E2
8B300700050C141A70CCD9FAFEF8C0C15D5A1606001A706CCAF6FEE7
E1892F210300060E161C73CEDCFBFBF4ECE5DF872D0600070E161C217CD4E2FCF8C15D17
0700050D151B202581D7FAFCD4D171727374220300060E1566C5F5FE
FAF3AF4C453D330800040C141A6F6C69C7D3F9FEF9F1ABAE4A0F00020A4AAEECFEF2EA9C
9FA2A5A8ABAEB0B2B4B652120002094846AAEBFEF3EB9EA1400C0003
0B4DB1EDFEFCD1CFCD6B1E0D0003313294E1FCFDDAD7D3D1CFCDCB6969691D02050D141B
71CDF7FEE6E0DBD7797B7E80291A0101074342A6E9F9FDF6BB571405
00050D151B202581D7FAFEF8C25E170108105A57BAF1FEFBF4ECE5E0DBD7797B7D280400
063CA0E6FDF6EEA4420C00020911186B6864C4F4FEFBF3EBE5DFDA7E
280501292C8C8A89DBFBFEDEDA7D7F290500050D1565C4F4FEFAC967661B02060E1565C5
F5FEFAC9C8661B0B00030B13191F78D1F8FEF9C4C460190101272A2D
8DDDEEFCFDF7EFA6440D0010176A67C6F5FEFAF3EB9DA03F0B00020A125E5B5855B8F0FE
FBF4ECE5E0DB7F82852C1D0D00030A125FC0F3FEEEA4A7AA470E0101
0845A9EAFEFCD3D1CF6D6E1F0200070F161C2125292C2E30323396E2F2FEFCF5EDA13F36
0800040C50B3EEFEFCF4B4B6524D11000D53504EB2B8F0FDFDF6EEA3
A6A9AC490F0101272A2D8D8CDDFBFEF8F0A8450E00030A12191E237F7CD4F9FEE2DD822A
0500050D141B2025282B2E30329393E0FCFEDB7F28190101268482D7
FAFEF8C1C25E180700040C514EB2EEFEF1E999390A00043536363738389CE4F5FFFAF3EB
E4DF85892E0600217B78D1F8FEF9C461190101272A89DBFBFEDEDAD6
77240400060E555250B3EEFDF8F0E8973809001566C5F5FEEAE3DED9D6D3D0CE6D1F0204
3838399C9DE5FDF7EFA6440D00030A4CB0EDFEFCD171211002012428
2B2D30313395E1F2FEEDA1A442392D0600050D1464C4F4FEFBCB691D02012480D6FAFEF8
C25E1801010810176966C5F5FEFAC967661B020107424141A5E8F8FE
E38D3107001D227D7AD3F9FEE3DDD97C270400063D3CA0A2A5A8ACB1EEFEFCF5EDE6E088
2E0600050D141B202481D7FAFDF5B8B955511200020911186BC9F6FE
FAC6C562615F1801080F5956B9C1F3FEFBCB691C020124807ED5F9FEF9C2C3C35F180101
272A8A8887DAEAFEF4B34F11000209115D5ABCF1FEEDE6E0888B3007
00196DCAF6FEE7E1898C310700050C514F4C4AAEECFEFCF5EDE693969A9DA03F0B000332
94E1FCFDDAD6787A260400060E151B2125292B8B8A88DBEBFAFEF8F0
E9E38C310700050C141A20242886DAFAFEF8F0E99839090004353699E3FCFDD9D5D27322
11030007403FA3E8FDFDD57778250400060E1566C5F5FEEAE3DED97D
7F8285888B3022120002094846ABEBFAFEF8C0C1C1C1C15E5B59150500050D146461C1F3
FEEBE48F9296372B0500050D1464C4F4FEEA9A3A2F0600063EA2E7FD
FDF6EEE7E1DCD87B26160600060E151C726FCCF7FEFAF2EAE48E9295370900161C212529
2C2E8F8EDEFBFEF7BE5A57534F490F01010810595653514EB2B9F0FD
FDF6EEE7E1DC8129050108444342414040A4E8FDFDF6B9BABB57531300020911181E76D0
F8FEF9C5611901012684827FD6F9FEF9F1E9E3DED97D271801081017
69C8F5FEFAC7641A0101070F1668C7D3F9FEF9F1AB480F00020A4A4847ABEBFAFCF4EDE6
E0872D1F0F00020A11181E77D1DFEFFEFCCFCDCCCAC967661B0B0013
61C2F4FEFBF4EC9FA240372B1C0201070F161C74CFDCFBFEDD832B0500050D1464C4F4FE
FBF3B0B3B5501200022C8C8BDCFBFBCC6A1D020124278684817F7C7A
D2E1FCFDDA7E8184872D0600050D5250B3BAF1FEFBCDCCCA686868671C0B00030B1260C1
F3FEFBCD6C1E0E01012A898785D9E9FDFDF6EEA3410C00115E5A5754
B7BFF3FEFBCBCAC9C865651B02010743A7ABAFEDFCFEF7EFA7AA470E000F1668C7F5FEFA
F2EB9CA0A3410C00030A12191F7874CFF8FEF9C5C5C4C4615F180108
0F171D74CFF8FEDFDA7E280400060D54514F4CB0B6F0FEFCF4ECA03F0B0003333496E2F2
FEECE5919498390900040B131A6F6B68C7F5FEFAF3AFB14D1102050D
524F4D4B4947ACEBFEF3EBE48F330800181D227ED5F9FEE2DDD8D5D272210300060E1667
C6D1F8FEF9F1EA9A9E3D0B00033335363699E3F4FEFBF3ECE5909497
9B9E3D330800050D141B716DCAD7E6FDF6BA5514000A125F5CBEC7D3E2FCF9C25F180101
08105A575451B5BCC5D0F8FEF9C5C4C4611901070F161C7470CCF7FE
FAF2EAE4DEDAD6D3D070201000022E8F8EDEFBFEDC822A0500050D141B716ECBD7FAFCF5
EDA2A5430D0011186B6764605D5A57BAF1FEFBF4ECE5E0878A2F2103
00063F3FA3A5E9FDF5B5B753130300060E5553B6BDF2FEF1AAADAFB2B4504A430D000209
4746AAEBFEFCF5EDE6E1882E200300070E56B9F1FEEEE7E1898C9033
0800050D1464C4CFF8FEE5DFDAD7D3D1702003040B131A1F7875D0DEEEFEFCF5EDA13F0C
00030B4DB1B7BEF2FEFBF3EC9EA2A5433A0A000435979898E3FCFDD9
7C7F2805010810176AC8F5FEFAF2EBE48F3207000437389B9CE5FDFDF6BABCBD58150109
11181E23272A2D8D8CDDFBFEDDD9D5772403001F2480D6FAFEF8F1E9
E38D310700063C3CA0E6FDFDF6BABB5714000A12196DCAF6FEFAC764631A010740A4E8FD
FDF6B9541300020911181D22262A2D2F31323435363799E3FCFDF7BB
57531300022B2E8E8D8CDDEDFEFCF5EDE693350800171D222683817E7CD4F9FEE2DDD9D5
772414000A12191F237FD6F9FDD677240400060E1566625FC0CAF6FE
E48F9296372B05010742414040A4A7E9FDF4EDE6E0872D06002226292C2E303294949494
E1FCFDF7BD5955514C10020124817ED5F9FEE1DC81842C1D0201070F
166864C4F4FEEBE48F320700181E23278482807D7AD3F9FEE38C909335290501282B8ADC
ECFEF2AE4B1000022E30929191DFF0FEFCCFCD6B6B1E0D000A12191E
77D1F8FEE48E91340800171D7571CDF7FEFAF2AD4A430D00030A125FC0F3FEEBE5DFDA7E
81842B1D0201070F58555250B3EEFEFCF4EDA03F0B00020A4A48ACEC
FEF2AF4B10000E156662C2F4FEFBCA681C02050D151B71CDF7FEFAF2AD4A433A0A00141A
2079D2E1FCFDF7EFE8E2DDD8D5D2D06F7071211000022E309190DFEF
FEFCCFCDCBCAC9661B0201070F161C217CD4F9FDF6EFA5430D00033133349697E2FCFDDA
D678240400063EA2A4E8F8FEF9F1EAE38D310700053C3C9FE6FDFDF6
BA561404022A2D2F9090DFFBFEF7BEBEBFC05C591505001B2025282B2E303293E1F1FEFC
D3D0CE6D1F0200070F161C217C79D2F8FEE38D312404001F242886D9
FAFEDF86892E06001A6FCBD8FAFEF8C15D17010810176AC8D4F9FEE2DDD9D5762403030A
12181E77D1F8FEE48E320700050D53B6F0FEFCCF6E6E6F7020100201
252988DAFBFEF8F0E9E28C30231300022B2E303293E1F1FEFBCDCC6A6A1D0D0011181E76
D0DEFBFEF7F0E8E2DD822A0500050D141B207AD3E1F2FEFBF4ECE5DF
862D060022268482D7FAFEF8C15E170101282B8ADCECFEFCD2D0CE6C6D6D1F0200237ED5
F9FDF6EEE7E1DCD8D5D272210300063F3FA3A5E9FDFDD5D2CFCD6C6C
1E0E0101084644A9ADECFEF2AFB14D110201074141403FA3A6AAEBFEFCD3747577240300
1F24807E7BD3F9FEF9F1AB48400C00125EBFC9D6F9FEF9C25E180700
181E227ED5F9FEF9C2C35F180101272A8A88DBFBFBF4B3B5B7524E480F00020A4AAEECFB
FEF7F0E8E2DDD9D5D2D0CECCCB681C0C00030B12191F23278583D8E8
FDFDD6D3D0CECCCBCAC966651B0A00131A1F24288684D8E8FDFDF6EEA3410C000209115D
BEF2FEFBCCCAC9C8C7651B0201070F161D222683817ED5E4FDFDF6BB
57140500053C3C3C3C9FA1A4E8FDFDF6EEE7E1DCD87A7D270400060D151B207BD3F9FDF7
EFE896993A0A00141B71CDF7FEFAF2EAE48E320700053B3B9FE6FDFD
D7D4D1CFCDCBCAC9C8C7641A0A00030B12196E6A6763605DBEF2FEFBF3EC9E3D0B00030A
12191E23272A8ADBFBFEF8F0E9E28C8F92350800050C141A2079D2E1
FCFDDAD7797B7D27040209105BBDF2FEFBF3EC9F3E0B0010176AC8D4F9FEF9F1EA9A3A0A
000334359798E3FCFDF7EFE8E2DCD8D57678241400010910171D7572
6FCBD8FAFCF5EDA1400C00033294E1FCFDF7BD59150500053B3B9EE6F6FEFAF2EBE48F32
2515010108105B58BAF1FEFBF4ECE5E0872D06001A2024282B8BDCFB
FEDDD97C270400060D54B7BFF3FEFCF4ECE692340800171D22268381D7FAFEF8F1AAADAF
4B1002060E151B72CDDBFBFEDEDA7D80290500053C9FA1A4A7E9FEFD
F6B85413000209115C59BBF1FEFBF4B2B4B6B85313000B13196E6BC9D5F9FEF9C3C35F5D
17010108105ABCF2FEFBF4ECE5DFDBD7D4D1CFCD6B6C6C1E0200070F
161C217CD4E3FCFDF7EFA6430D00115C595653504EB2EEFEF1E9999D3C0A00030A125FC0
F3FEEBE590330800053A9EE5F6FEE8E1DC822A1B02063E3E3D3DA1A3
E8FDFDF6B955504B443C31240400063EA2E7F7FEF9C5621901074140A4E8F8FEE38E9134
0800040C131A6F6CC9F6FEE79598390900040B131A1F242886D9FAFE
F8C05D170101288684D9E8FDF5EDE6E0882E060005393A3A9DE5F6FEE8E2DD82852C0601
24807D7BD3F9FEF9F1EAE38D91340800043738389BE4FDF7EFA7AAAD
490F0101272A2D8DDDFBFEDDD97B7E2804001D222684D8FAFCF5EDA2A5433A2E06001A6F
CBD8FAFCF5EDA2400C00030B12191F78D1DFFCFEF7EFE8E2DD82852C
0600074140A4E8FDF5EDA140362A05010843A7EAF9FEE18A8D31240300060E151B726FCB
F7FEF9F1AB48410C00030B4CB0EDFEFCD1CFCDCB691D02010742A6A9
EAFAFEE0888B8E3207000438389B9D9EE6FDF7EFE8E18A8D91340800040C50B4EFFDFDF6
EFA5430D0011181E227E7BD3F9FEE28C300700050C1463C3F4FEFACA
681C0C00125FC0F3FEEBE5909397380900040B131A1F7976D0DEEEFEFCF4EDE6E0DBD7D4
75230300063F3EA2A5A8EAFEFCF5EEA3A6430D00033192E0F0FEFBCE
CCCB681C0C0002094947ACEBFEFCF5EDA2A5433A2F0600050C52B5BCC5F5FEFAF3EBE4DF
DA7E2805010810171D222684D8FAFEF8C15D5B1601010845A9EBFEFC
D37422120300217BD3F9FDD9D5D2D0CE6D6D1F0200070F161C212583D8FAFCF5EDE6E0DC
80832B1C02063CA0A2E7F7FEF8F0A9AC48410C000D53504EB2B8C0F3
FEEBE5909497380900040B4F4DB0EDFEF1EAE3DE842B1D0C00020911181E23272A2D2F90
8FDEEFFEFCF4EDA03F0B0012605CBEF2FEECE5E0878A2F0600050C51
4F4DB1B7BEF2FEFBCC6A6A6A6A1D0201074141A5E8FDFDF6EEA3410C0003323334979798
98E3FCFDF7BC5754130400060E151B726F6B68C6F5FEFAF3AFB1B34F
pop
P
% End of image
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{252, 126},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003l0000OQ000`40n007h00Oo?oo003lool00?co
o`00o?oo003lool00?coo`00o?oo0009ool200000`0P2448@@04BVT3BTT6@RP00jeEkeg_G@02oml2
ool2oml3aQP2F^/26<<30002:DD2Q302g]/00nmMooooo`02mkh2kgd2ic`00nLLQ324<002:FD26><3
00028@@2Nnl3Nll2Ljh2cWT2oml2ool00ooOaQS66002F^/24:8200000`Q1488@PP02F//2_OL00oNN
ooooo`02oml2cWT2Jdd00aSS000000020002020226400a2R6><Hh`05ool200000`0P2448@@04BVT3
BTT6@RP00jeEkeg_G@02oml2ool2oml3aQP2F^/26<<30002:DD2Q302g]/00nmMooooo`02mkh2kgd2
ic`00nLLQ324<002:FD26><300028@@2Nnl3Nll2Ljh2cWT2oml2ool00ooOaQS66002F^/24:820000
0`Q1488@PP02F//2_OL00oNNooooo`02oml2cWT2Jdd00aSS000000020002020226400a2R6><Hh`0:
ool000Woo`8000030208@@Q100A:J@=:B@I2:003[EG_GNmM00;og`;oo`;og`?6609Jj`8H``<0008Y
A@:4<0;Nf`03kegooooo00;g_P;_O@;W?003iab4<8@`008YI@8Hh`<0008Q109kk`=kc`9c[P;>N@;o
g`;oo`03omo66<HH009Jj`8@XP800003244@PQ22009Jb`:mm`03mikooooo00;og`;>N@9[C@036><0
0000008000808088H@034:8HhaSS00Goo`8000030208@@Q100A:J@=:B@I2:003[EG_GNmM00;og`;o
o`;og`?6609Jj`8H``<0008YA@:4<0;Nf`03kegooooo00;g_P;_O@;W?003iab4<8@`008YI@8Hh`<0
008Q109kk`=kc`9c[P;>N@;og`;oo`03omo66<HH009Jj`8@XP800003244@PQ22009Jb`:mm`03miko
oooo00;og`;>N@9[C@036><00000008000808088H@034:8HhaSS00[oo`002Ooo0R4400=kkmJje[X0
0_oO0_oo00?ogoNNmih00^mM0^LL0]kk0h@`0XaA0Xaa0S6600<0800000000P0P0PQQ00=BRTYYBVT0
0[FF0^mm0ooo0_Nn0^mm0^Ll0YBB00>D/YcCW=<00Ycc0SWW0S6600<0800000000P0P0PQQ00=BR[Ff
]KH00_NN1?oo00?g_^mmkgd00^Ll0^LL0XaA00<YI@0P02000P000QS300<Hhb4T8B@00X@@0W__0W_?
00?FV_oOoml00_oo0_Nn0^mm00?_GIBbU;801Ooo0R4400=kkmJje[X00_oO0_oo0_oO00?gW^mMked0
0^LL0]kk0h@`0XaA0Xaa0S6600<0800000000P0P0PQQ0U::00=:JKFF]IH00^mm0ooo0_Nn0^mm0^Ll
0YBB00>D/YcCW=<00Ycc0SWW0S6600<0800000000P0P0PQQ00=BR[Ff]KH00_NN1?oo00?g_^mmkgd0
0^Ll0^LL0XaA00<YI@0P02000P000QS300<Hhb4T8B@00X@@0W__0W_?00?FV_oOoml00_oo0_Nn0^mm
00?_GIBbU;802_oo0009ool28@@00g__e[[F^P02oml2ool00ooOmikgWP02ked2ia`2g_/3Q302S542
S742<HH00`0P00000002020226400e::BVU:J@02]IH2kgd3ool2mkh2kgd2ic`2U9800iBbW=>Ld`02
W?<2>NL2<HH00`0P00000002020226400e::]KJe]P02mih4ool00oNnkgg_O@02ic`2ia`2S5400bUU
0200800200026<<00aSS8B@Q9002Q102Nnl2Nll00mJJomoog`02ool2mkh2kgd00nmMU;:D/P05ool2
8@@00g__e[[F^P02oml2ool2oml00oNNkeg_G@02ia`2g_/3Q302S542S742<HH00`0P000000020202
2642DXX00dYY]IJeUP02kgd3ool2mkh2kgd2ic`2U9800iBbW=>Ld`02W?<2>NL2<HH00`0P00000002
020226400e::]KJe]P02mih4ool00oNnkgg_O@02ic`2ia`2S5400bUU0200800200026<<00aSS8B@Q
9002Q102Nnl2Nll00mJJomoog`02ool2mkh2kgd00nmMU;:D/P0:ool000Woo`8aYP03244000000080
8088H@03489S36<<00;660;g_P;oo`03omogW_NN00BeUP9:J@03488000000088H@8@XP03H`c66<HH
00;>N@;g_P;oo`03omogW_NN00;_G@:Ld`:Ll`03YAA22488008aYP8YA@808003000Q924T008YA@<Y
I@@aQPFD/P;W70;gWPCoo`03mkje][Ff009BRP8@PP030008@@Q1009:J@:eUP;_O@03oooogooO00;g
WP;_G@;W7003g_^448@@00Goo`8aYP032440000000808088H@8@PP03H`c66<HH00;g_P;oo`03omog
W_NN00BeUP9:J@03488000000088H@8@XP9S3003aQS>NLii00;g_P;oo`03omogW_NN00;_G@:Ld`:L
l`03YAA22488008aYP8YA@808003000Q924T008YA@<YI@@aQPFD/P;W70;gWPCoo`03mkje][Ff009B
RP8@PP030008@@Q1009:J@:eUP;_O@03oooogooO00;gWP;_G@;W7003g_^448@@00[oo`002Ooo0S6V
00<8@@0000000P0P0PQQ00<@PV<<H``00/HH0_Nn0_oo00?ogoNNmih01;FF0TYY00<@PP0000000PQQ
0Q2R00=S3<HHaQP00/ii0_Nn0_oo00?ogoNNmih00^mM0YcC0Ycc00>U5488@PP00S6V0RU50P0P00<0
024T8B@00RU50bUU13661IBb0^LL0_NN1?oo00?g_[Ff]KH00U::0Q2200<000Q124400TYY0[FF0^mm
00?ooooOoml00_NN0^mM0^LL00?Nnh@@Q1001Ooo0S6V00<8@@0000000P0P0PQQ0Q2200=S3<HHaQP0
0_Nn0_oo00?ogoNNmih01;FF0TYY00<@PP0000000PQQ0Q2R0V<<00?66<iicWT00_Nn0_oo00?ogoNN
mih00^mM0YcC0Ycc00>U5488@PP00S6V0RU50P0P00<0024T8B@00RU50bUU13661IBb0^LL0_NN1?oo
00?g_[Ff]KH00U::0Q2200<000Q124400TYY0[FF0^mm00?ooooOoml00_NN0^mM0^LL00?Nnh@@Q100
2_oo0009ool2:DD00aSS00000002000202000`QQ4:8@XP02Jdd2aSP2mkh00oooomoog`02mih2ked2
W?<00jDD>NLii`02<JH224400`004:8@XP026><28@@28B@00bU5:FDYI@02:FD2<HH2U9800nLLoooo
o`02ool2mkh2kgd00nmMiacW7002S542<HH00`0P00000002020226424:800aS3LhicSP02cWT2g]/2
oml00oooomoog`04aQP00e[[F/]Jb`024:82020200000aS3LhicSP02Jfd2cUT2mkh00oooiccW?005
ool2:DD00aSS000000020002020226400a2RJde[C@02aSP2mkh00oooomoog`02mih2ked2W?<00jDD
>NLii`02<JH2244200000a2R6><Hh`028@@28B@00bU5:FDYI@02:FD2<HH2U9800nLLooooo`02ool2
mkh2kgd00nmMiacW7002S542<HH00`0P00000002020226424:800aS3LhicSP02cWT2g]/2oml00ooo
omoog`04aQP00e[[F/]Jb`024:82020200000aS3LhicSP02Jfd2cUT2mkh00oooiccW?00:ool000Wo
o`;W7003S54YIBUU008Q10<000808088H@8@XP8Hh`03Lhk>NLii00;Nn`Cog`03mkk_ONmm00;W?0;N
n`03Q30YIBUU0080808000808003264@XQ2R008Hh`8Q109kk`03e[[W7>LL00;oo`;og`;66003F^/@
XQ2R0080808000030208H@QQ008@XP8H``8Q10038BB448@@00;F^P;og`;oo`03e[[FV]JJ00EcSP9c
[P8Q10@000030208H@QQ008@XP9S;0;6>003mkkooooo00Goo`;W7003S54YIBUU008Q10@000030208
H@QQ008@XP8Hh`03Lhk>NLii00;Nn`Cog`03mkk_ONmm00;W?0;Nn`:4<003:FD0800P008000808003
264@XQ2R008Hh`8Q109kk`03e[[W7>LL00;oo`;og`;66003F^/@XQ2R0080808000030208H@QQ008@
XP8H``8Q10038BB448@@00;F^P;og`;oo`03e[[FV]JJ00EcSP9c[P8Q10@000030208H@QQ008@XP9S
;0;6>003mkkooooo00[oo`002Ooo0^LL00><DBUU:FD00R440`000P0P0PQQ0Q2R0QSS00=cS/iicWT0
0]kk1?oO00?g_^mmkgd00^Ll0]kk00>4<2UU:FD00P0P0P000P0P00<8HA2R4:800QSS0R440W__00?F
^^LLia`00_oo0_oO0/HH00=Jja2R4:800P0P0P0000<080QQ26400Q2R0QS30R4400<Q98@@Q1000]Jj
0_oO0_oo00?F^]JJeYX01G>>0W>^0R44100000<080QQ26400Q2R0V</0/Hh00?g__ooool01Ooo0^LL
00><DBUU:FD00R44100000<080QQ26400Q2R0QSS00=cS/iicWT00]kk1?oO00?g_^mmkgd00^Ll0]kk
0X@`00<YI@0P02000P000P0P00<8HA2R4:800QSS0R440W__00?F^^LLia`00_oo0_oO0/HH00=Jja2R
4:800P0P0P0000<080QQ26400Q2R0QS30R4400<Q98@@Q1000]Jj0_oO0_oo00?F^]JJeYX01G>>0W>^
0R44100000<080QQ26400Q2R0V</0/Hh00?g__ooool02_oo0009ool2oml00oNN[GF]M@02BVT2@RP0
0cWW<HHaQP022442000202000`QQ4:8@XP026<<4Jfd00f]=aSS6>002eYX2oml00oooomoog`02mih2
[ED2[GD00dY92648H@04000224400dY9[GF]M@02kgd2ool2mih00nmMW?>Ll`02W?<2YA@00jDd[EF]
E@02[ED2[GD3]IH4]KH2DXX2488300022442BTT00d8X[EF]E@02ked2ool2mih00nmMW?>Ll`02YA@2
@PP226430005ool2oml00oNN[GF]M@02BVT2@RP2>NL00c662448@@02000202000`QQ4:8@XP026<<4
Jfd00f]=aSS6>002eYX2oml2ool00ooOmikgWP02[ED2[GD00dY92648H@04000224400dY9[GF]M@02
kgd2ool2mih00nmMW?>Ll`02W?<2YA@00jDd[EF]E@02[ED2[GD3]IH4]KH2DXX2488300022442BTT0
0d8X[EF]E@02ked2ool2mih00nmMW?>Ll`02YA@2@PP22643000:ool000Woo`;og`03mij]MJee009:
J@92:003>NLaQS660088@@8000808003264@XQ2R008H``A[K@03Jdg6><Hh00;FVP;og`03oooogooO
00;gWP:]E@:]M@03BTT8H@QQ00@00088@@03BTV]MJee00;_O@;oo`;gWP03kefLlicc00:Ll`:U5003
YCB]EJeE00:]E@:]M@>eUPBe]P9BRP8@PP<00088@@9:B@03@RR]EJeE00;_G@;oo`;gWP03kefLlicc
00:U50922088H@<000Goo`;og`03mij]MJee009:J@92:08ii`03<HH8@@Q1008000808003264@XQ2R
008H``A[K@03Jdg6><Hh00;FVP;og`;oo`03omogW_NN00:]E@:]M@03BTT8H@QQ00@00088@@03BTV]
MJee00;_O@;oo`;gWP03kefLlicc00:Ll`:U5003YCB]EJeE00:]E@:]M@>eUPBe]P9BRP8@PP<00088
@@9:B@03@RR]EJeE00;_G@;oo`;gWP03kefLlicc00:U50922088H@<000[oo`002Ooo0PQ100=:JKFF
]IH00^mm0ooo0]JJ1<ii0V]=00<Hh`QQ264010000c660YBb0^LL0ooo0]kK0]Jj1=JJ0lii0/iI1F]=
0QSS0P000P0P0PQQ00<@XQS36<<00W>>0/ii00?g__ooool00^Ll0^LL0]kK00?F^W_?Nll00W_?0W__
0X@@00<YAAS36<<0100000<08488@PP00T880ZDd0^mM00?ogoooool00_Nn0[gG0U:Z00<@XP0P0200
1Ooo0PQ100=:JKFF]IH00^mm1?oo00?FV/iicWT00/ii0V]=00<Hh`QQ264010000c660YBb0^LL1?oo
00?NfmJje[X01=JJ0lii0/iI1F]=0QSS0P000P0P0PQQ00<@XQS36<<00W>>0/ii00?g__ooool00^Ll
0^LL0]kK00?F^W_?Nll00W_?0W__0X@@00<YAAS36<<0100000<08488@PP00T880ZDd0^mM00?ogooo
ool00_Nn0[gG0U:Z00<@XP0P02002_oo0009ool224400dYY]IJeUP02kgd3ool2eYX4cWT2Jdd00aSS
2648H@040003<HH2U;82ia`3ool2g]/2e[X4eYX3cWT2cUT5Jdd26><20002020226400a2R6<<H``02
Lhh2cWT00oNnooooo`02ic`2ia`2g]/00mJjNlmkc`02Nll2Nnl2Q1000bU56<<H``0400000`0P@PQ2
2002@PP2YC@2ked00ooOooooo`02mkh2_ML2DZX00a2R02008005ool224400dYY]IJeUP02kgd4ool0
0mJJcWW>N@02cWT2Jdd00aSS2648H@040003<HH2U;82ia`4ool00mkKe[[F^P04eYX3cWT2cUT5Jdd2
6><20002020226400a2R6<<H``02Lhh2cWT00oNnooooo`02ic`2ia`2g]/00mJjNlmkc`02Nll2Nnl2
Q1000bU56<<H``0400000`0P@PQ22002@PP2YC@2ked00ooOooooo`02mkh2_ML2DZX00a2R0200800:
ool000Woo`8000030208H@QQ008@XP8H``038@@Q924T00:440;F^P;og`03oooogooO00;6609Jj`8@
XP030008@@Q1008@PP9Jb`03DZZmekgG00;gWP;oo`;og`03mkk_ONmm00;W?0;W70;Nf`03e[Ykcg_?
009kc`9kk`8YA@03020000000080808ii`03YACW?>Ll00;oo`;g_P;_O@03YCA224880088H@@00003
244@PQ22008H``=[C@9S;0;6>0;g_P;oo`03omogW_NN00;_G@;W?0;Nn`03g]]kkg__00Goo`800003
0208H@QQ008@XP8H``8Q10038BB448@@00;F^P;og`03oooogooO00;6609Jj`8@XP030008@@Q1008@
PP9Jb`9BZP03_MOgW_NN00;oo`;og`03mkk_ONmm00;W?0;W70;Nf`03e[Ykcg_?009kc`9kk`8YA@03
020000000080808ii`03YACW?>Ll00;oo`;g_P;_O@03YCA224880088H@@00003244@PQ22008H``=[
C@9S;0;6>0;g_P;oo`03omogW_NN00;_G@;W?0;Nn`03g]]kkg__00[oo`002Ooo0RU500<080000000
0RU50RUU00><LHaAS5400XaA0]kK0_oO00?oomkkg_/00]kK17__00<YA@0P02000P000P0P00<8HA2R
4:800V</0/Hh0_Nn00?ooooOoml00/iI16</00<H``0000000P0P0PQQ0Q2R00=S;<HhaSP00_Nn0_oo
00?ogliIcUT00/iI0V</0QS300<8@@0000000P000PQ10Q2200<H`aSS6><00W_?0]JJ00?ogoooool0
0_oO1<Hh00=S31S36<<010000R4T00<YABUU:FD01Ooo0RU500<0800000000RU50RUU0Xaa0haA0]kK
0_oO00?oomkkg_/00]kK17__00<YA@0P02000P000P0P0PQQ00<@XV</Hb`00/Hh0_Nn00?ooooOoml0
0/iI16</00<H``0000000P0P0PQQ0Q2R00=S;<HhaSP00_Nn0_oo00?ogliIcUT00/iI0V</0QS300<8
@@0000000P000PQ10Q2200<H`aSS6><00W_?0]JJ00?ogoooool00_oO1<Hh00=S31S36<<010000R4T
00<YABUU:FD02_oo0009ool2:DD00`0P00000002:DD2:FD00haaS56<D@02S542g]/2oml00ooog__N
n`02g]/4Nnl00bU502008002000202000`QQ4:8@XP02Hb`2aSP2mkh00oooomoog`02cUT4Hb`00aS3
00000002020226424:800f</aSS6>002mkh2ool00ooOcUW>F@02cUT2Hb`26<<00`Q1000000020002
244248800aS36><Hh`02Nll2eYX00ooOooooo`02oml4aSP00f<<6<<H``0400028B@00bU5:FDYI@05
ool2:DD00`0P00000002:DD2:FD2S743S542g]/2oml00ooog__Nn`02g]/4Nnl00bU5020080020002
020226400a2RHbaS;002aSP2mkh00oooomoog`02cUT4Hb`00aS300000002020226424:800f</aSS6
>002mkh2ool00ooOcUW>F@02cUT2Hb`26<<00`Q1000000020002244248800aS36><Hh`02Nll2eYX0
0ooOooooo`02oml4aSP00f<<6<<H``0400028B@00bU5:FDYI@0:ool000Woo`:<L@03g___ONmm00Co
o`03mkk_ONmm00:U=092:088H@03000@PQ22008@XP9[C@9S;003aSSg__Nn00;oo`;og`03mik_GNmM
00:Ll`:U508ii`032440000000800088@@8@PP03F^]Jbe[;009Jb`9BZP:me`03mikooooo00;og`;g
_P03kggW?>Ll00;W70;Nf`9kk`03Q124<8@`008YI@8Hh`88H@<00088@@8@PP03F^_66<HH00;gWP;o
o`;_O@>U=0:]E@92:088H@<000Goo`:<L@03g___ONmm00Coo`;g_P03kgfU=:Dd0092:088H@03000@
PQ22008@XP9[C@9S;003aSSg__Nn00;oo`;og`;gWP03kefLlicc00:U508ii`032440000000800088
@@8@PP03F^]Jbe[;009Jb`9BZP:me`03mikooooo00;og`;g_P03kggW?>Ll00;W70;Nf`9kk`03Q124
<8@`008YI@8Hh`88H@<00088@@8@PP03F^_66<HH00;gWP;oo`;_O@>U=0:]E@92:088H@<000[oo`00
2Ooo0Xaa00?Nnnmmkgd01?oo00?g_^mmkgd00ZDd0T8X0PQQ00<0012248800Q2R0V]=0V</00?6>?Nn
mkh00_oo0_oO00?gW^mMked00Ycc0ZDD0SWW00<8@@0000000P000PQ10Q2200=Jje[;F//00U[;0U:Z
0[gG00?gW_ooool00_oO0_Nn00?_ONLlic`00^LL0]kK0W__00>448@`Q3000RUU0QSS0PQQ0`000PQ1
0Q2200=JjlHHaQP00_NN0_oo0^mm0jDd0ZeE0T8X0PQQ0`001Ooo0Xaa00?Nnnmmkgd01?oo0_Nn00?_
OJDdYC@00T8X0PQQ00<0012248800Q2R0V]=0V</00?6>?Nnmkh00_oo0_oO0_NN00?_GIccW?<00ZDD
0SWW00<8@@0000000P000PQ10Q2200=Jje[;F//00U[;0U:Z0[gG00?gW_ooool00_oO0_Nn00?_ONLl
ic`00^LL0]kK0W__00>448@`Q3000RUU0QSS0PQQ0`000PQ10Q2200=JjlHHaQP00_NN0_oo0^mm0jDd
0ZeE0T8X0PQQ0`002_oo0009ool224400d8X[EF]E@02ked3ool4eYX2cWT3Jfd26><4000202000`QQ
4:8@XP026><28@@00b4T:DDYA@04:FD5<HH2U;82ia`2mih3ool2mkh2kgd2YA@00cWW<JHaYP022442
00000`0P2648H@02DXX2]IH2kgd3ool2mkh4]KH00e::BVU:J@02488200000`QQDXYBRP02DXX2BVT2
]IH00kgGmikgWP04ool2mkh00nmmYABU5005ool224400d8X[EF]E@02ked4ool3eYX2cWT3Jfd26><4
000202000`QQ4:8@XP026><28@@28B@00bU5:FDYI@02:FD5<HH2U;82ia`2mih3ool2mkh2kgd2YA@0
0cWW<JHaYP02244200000`0P2648H@02DXX2]IH2kgd3ool2mkh4]KH00e::BVU:J@02488200000`QQ
DXYBRP02DXX2BVT2]IH00kgGmikgWP04ool2mkh00nmmYABU500:ool000Woo`88@@03@RR]EJeE00;_
G@?oo`CFVP;>N@=[K@8Hh`@000808003264@XQ2R008Hh`8Q10038B@YABU500@YI@DaQP:D/P;W70;g
WP?oo`;g_P;_O@:U5003>NLaYS6V0088@@8000030208H@QQ009BRP:eUP;_O@?oo`;g_PBe]P03DXY:
JDYY008@PP800003265BRU::009BRP9:J@:eUP03_MOgW_NN00Coo`;g_P03kgfU5:DD00Goo`88@@03
@RR]EJeE00;_G@Coo`?FVP;>N@=[K@8Hh`@000808003264@XQ2R008Hh`8Q108Q9003:DDYIBUU008Y
I@DaQP:D/P;W70;gWP?oo`;g_P;_O@:U5003>NLaYS6V0088@@8000030208H@QQ009BRP:eUP;_O@?o
o`;g_PBe]P03DXY:JDYY008@PP800003265BRU::009BRP9:J@:eUP03_MOgW_NN00Coo`;g_P03kgfU
5:DD00[oo`002Ooo0ZDd00>]EJee[GD00TY90PQQ0`000R4T0RU50RUU0haa0]kk0_oO0_oo00?ogoNN
mih00ZeE0T8X00<8H@0000000P000PQ10Q2200<H`aSS6><00R4417__00?F^_oOoml00_oo0^LL0]kk
00>442U5:DD00P0P0P0000<080QQ26400Q2R0QS30R4400<Q92U5:DD00RU50RUU0c6619BB0^LL0ooo
0]kK0W__0RU500<H``0000000P000R4T0X@`00>44=Jje[X01Ooo0ZDd00>]EJee[GD00TY90PQQ0`00
0R4T0RU50RUU0haa0]kk0_oO0_oo00?ogoNNmih00ZeE0T8X0PQQ0`000PQ10Q2200<H`aSS6><00R44
17__00?F^_oOoml00_oo0^LL0]kk00>442U5:DD00P0P0P0000<080QQ26400Q2R0QS30R4400<Q92U5
:DD00RU50RUU0c6619BB0^LL0ooo0]kK0W__0RU500<H``0000000P000R4T0X@`00>44=Jje[X02_oo
0009ool2oml00oooomoog`04aQP00e[[6<<H``020202000202000`QQDXYBRP02BVT2]IH2kgd00ooo
mikgWP02ked2W=<00cW72448@@0200020207<JH4>LL00icciccW?002mkh2ool2oml00oNNkeg_G@02
ic`2g_/00h@`S56<D@02:FD2020200000b44Nlmkc`02Nll2eYX2oml00oooomoog`02aSP2H``00aS3
0000000200028B@2:DD00haAg]_Nf`02oml2ool2g_/00mkKe[[F^P05ool2oml00oooomoog`04aQP2
F^/00aS302008002000202000`QQDXYBRP02BVT2]IH2kgd00ooomikgWP02ked2W=<2>LL00`Q10000
00020207<JH4>LL00icciccW?002mkh2ool2oml00oNNkeg_G@02ic`2g_/00h@`S56<D@02:FD20202
00000b44Nlmkc`02Nll2eYX2oml00oooomoog`02aSP2H``00aS30000000200028B@2:DD00haAg]_N
f`02oml2ool2g_/00mkKe[[F^P0:ool000Woo`;og`03oooogooO00C66003F^/H`aS3008080800080
8003265BRU::009:J@:eUP;_O@03ooogW_NN00;_G@:Ld`03>LL8@@Q10080008080LaYP@ia`03W??W
?>Ll00;g_P;oo`;og`03mik_GNmM00;W?0;Nn`03Q32<DHaA008YI@80808000038@Akcg_?009kc`;F
VP;og`03oooogooO00;6>09S30036<<000000080008Q908YA@03S57NfmkK00;og`;oo`;Nn`03g]_F
^]Jj00Goo`;og`03oooogooO00C6609Jj`036<<0800P008000808003265BRU::009:J@:eUP;_O@03
ooogW_NN00;_G@:Ld`8ia`0324400000008080LaYP@ia`03W??W?>Ll00;g_P;oo`;og`03mik_GNmM
00;W?0;Nn`03Q32<DHaA008YI@80808000038@Akcg_?009kc`;FVP;og`03oooogooO00;6>09S3003
6<<000000080008Q908YA@03S57NfmkK00;og`;oo`;Nn`03g]_F^]Jj00[oo`002Ooo0W>^00<Q900P
02000P000P0P00<8HE:ZDZX015::0[FF00?_OOooool00_oO0_NN0^mM00>D/SW7>LL00PQ10P0000<@
XV</Hb`00/Hh0_Nn0_oo00?_GNLLia`00]kk0]kK0]Jj0mJJ0/ii0V]]0QSS00<0000P02001CW719cc
0^Ll0_oo00?g_^mmkgd00ZDd0T8X0PQQ0`000PQ10TYY00>eU^mmkgd01?oo0]JJ00=cSR448@@00Q22
100000<Q92U5:DD01Ooo0W>^00<Q900P02000P000P0P0PQQ00=BZU::DXX00U::0[FF00?_OOooool0
0_oO0_NN0^mM00>D/SW7>LL00PQ10P000Q2R00=S;<HhaSP00_Nn0_oo00?_GNLLia`00]kk0]kK0]Jj
0mJJ0/ii0V]]0QSS00<0000P02001CW719cc0^Ll0_oo00?g_^mmkgd00ZDd0T8X0PQQ0`000PQ10TYY
00>eU^mmkgd01?oo0]JJ00=cSR448@@00Q22100000<Q92U5:DD02_oo0009ool2Ljh00b4T02008002
000202000`QQDZYBZP04DXX2]IH00nmmooooo`02oml2mih2ked00iBb>LLia`02244200000a2RHbaS
;002aSP2mkh2ool00nmMiacW7002g_/2g]/2e[X3eYX2cWT2Jfd26><00`0002008005>LL4W?<2ic`2
ool00oNnkgg_O@02YC@2@RP2264300022442BVT00kFFkgg_O@04ool2eYX00g>>8@@Q100248840000
0b4T:DDYA@05ool2Ljh00b4T020080020002020226400e:ZDXYBRP02DXX2]IH00nmmooooo`02oml2
mih2ked00iBb>LLia`02244200024:800f</aSS6>002mkh2ool00nmMiacW7002g_/2g]/2e[X3eYX2
cWT2Jfd26><00`0002008005>LL4W?<2ic`2ool00oNnkgg_O@02YC@2@RP2264300022442BVT00kFF
kgg_O@04ool2eYX00g>>8@@Q1002488400000b4T:DDYA@0:ool000Woo`8YA@03:FDaQS6600@aQP03
U;;W7>LL00;gWP;oo`;_O@03YABU=:Dd0092208ia`8YI@030200000000808088H@034:9S;6</00;6
>0;g_P;oo`03omo>FLiI009[C@8Hh`<0008Q90:440;F^P;og`03oooogooO00;6609Jj`036<<00000
00800088@@8@PP034:9[CF]=009S;0;6>0;g_P03oooogooO00;>F@=S;08H``@0008080E220:U=0;_
G@03omoooooo00Goo`8YA@03:FDaQS6600@aQP:D/P03iacgW_NN00;oo`;_O@03YABU=:Dd0092208i
a`8YI@030200000000808088H@8@XP03Hbc6><Hh00;g_P;oo`03omo>FLiI009[C@8Hh`<0008Q90:4
40;F^P;og`03oooogooO00;6609Jj`036<<0000000800088@@8@PP034:9[CF]=009S;0;6>0;g_P03
oooogooO00;>F@=S;08H``@0008080E220:U=0;_G@03omoooooo00[oo`002Ooo0RU500<YIC66<HH0
136600>D/^LLia`00_NN0_oo0^mm00>U5:DdYC@00T880SW70RUU00<0800000000P0P0PQQ00<@XV</
Hb`00/Hh0_Nn0_oo00?ogliIcUT00V]=0QSS0`000R4T0X@@0]Jj0_oO00?ooooOoml00/HH0U[[00<H
``0000000P000PQ10Q2200<@XV]=Jdd00V</0/Hh0_Nn00?ooooOoml00/iI0f</0QS310000P0P1D88
0ZDd0^mM00?ogoooool01Ooo0RU500<YIC66<HH013660YBb00?W7?NNmih00_oo0^mm00>U5:DdYC@0
0T880SW70RUU00<0800000000P0P0PQQ0Q2R00=S;<HhaSP00_Nn0_oo00?ogliIcUT00V]=0QSS0`00
0R4T0X@@0]Jj0_oO00?ooooOoml00/HH0U[[00<H``0000000P000PQ10Q2200<@XV]=Jdd00V</0/Hh
0_Nn00?ooooOoml00/iI0f</0QS310000P0P1D880ZDd0^mM00?ogoooool02_oo0009ool2ia`00haa
<HHaQP02020200000aSS8@@Q1002Nnl2Nll2eYX00ooOooooo`02ia`2g_/2g]/00g__8B@Q90020202
00000`0P>NLii`02>NL4YA@00jDd[EF]E@02[GD2]IH2kgd3ool2mkh2kgd2ic`00nLLS56<D@02:FD2
02000`000200800226424:826<<00b448B@Q9002Q102e[X2oml00ooomkkg_P04_ML00e:ZDXYBRP02
488400000`Q1488@PP026<<2Jdd2cUT00oNnooooo`05ool2ia`00haa<HHaQP02020200026><00b44
Nnmkk`02Nll2eYX00ooOooooo`02ia`2g_/2g]/00g__8B@Q9002020200020203>NL4YA@00jDd[EF]
E@02[GD2]IH2kgd3ool2mkh2kgd2ic`00nLLS56<D@02:FD202000`000200800226424:826<<00b44
8B@Q9002Q102e[X2oml00ooomkkg_P04_ML00e:ZDXYBRP02488400000`Q1488@PP026<<2Jdd2cUT0
0oNnooooo`0:ool000Woo`;og`?6>0AS3003F^/H`aS300800088@@88H@03F/]BZU:Z00:me`;660;g
WP03oooogooO00;>F@9[C@036><000000080008Q90:44003NnoF^]Jj00;og`;oo`;og`G6609Jj`8H
``<0008Q908YA@><D@:4<0;Nf`;_G@03ooog__Nn00:eUP9:J@8@PP<00088@@8@PP03F^]Jbe[;00:m
m`;gWP;oo`03kggW?>Ll00;W70B<D@03<HH0800P00Goo`;og`?6>0AS309Jj`036<<000000088@@88
H@03F/]BZU:Z00:me`;660;gWP03oooogooO00;>F@9[C@8Hh`<0008Q90:44003NnoF^]Jj00;og`;o
o`;og`G6609Jj`8H``<0008Q908YA@><D@:4<0;Nf`;_G@03ooog__Nn00:eUP9:J@8@PP<00088@@8@
PP03F^]Jbe[;00:mm`;gWP;oo`03kggW?>Ll00;W70B<D@03<HH0800P00[oo`002Ooo0_oO0lHh16<<
00=JjaS36<<00P000PQ10PQQ00=Jbe:ZDZX00[gG0/HH0_NN00?ooooOoml00/iI0V]=00<Hh`000000
0P000R4T0X@@00=kkmJje[X00_oO0_oo0_oO1LHH0U[[0QS30`000R4T0RU50haA0X@`0]kK0^mM00?o
ooNnmkh00[FF0TYY0Q220`000PQ10Q2200=Jje[;F//00[gg0_NN0_oo00?_ONLlic`00^LL18aA00<a
QP0P02001Ooo0_oO0lHh16<<0U[[00<H``0000000PQ10PQQ00=Jbe:ZDZX00[gG0/HH0_NN00?ooooO
oml00/iI0V]=0QSS0`000R4T0X@@00=kkmJje[X00_oO0_oo0_oO1LHH0U[[0QS30`000R4T0RU50haA
0X@`0]kK0^mM00?oooNnmkh00[FF0TYY0Q220`000PQ10Q2200=Jje[;F//00[gg0_NN0_oo00?_ONLl
ic`00^LL18aA00<aQP0P02002_oo0009ool200000aS3Jfe[K@02cUT2mkh00oooiccW?002ia`2S542
S7400c66020080020002020226400e::BVU:J@02BVT2BTT00jeekgg_O@04ool2mkh00nmmiccW?002
U982U;82W=<00iccYABU5002>NL224430002<HH2U;82ia`3ool2g]/2e[X3Nll28B@2020200020200
0`QQ4:8@XP026<<28@@00b4T:DDYA@02:DD5S542g]/2ked2oml2ool00ooOmikgWP05ool200000aS3
Jfe[K@02cUT2mkh2ool00nLliacW7002S542S7400c66020080020002020226400e::BVU:J@02BVT2
BTT2[GD00nmmooooo`02ool2mkh00nmmiccW?002U982U;82W=<00iccYABU5002>NL224430002<HH2
U;82ia`3ool2g]/2e[X3Nll28B@20202000202000`QQ4:8@XP026<<28@@00b4T:DDYA@02:DD5S542
g]/2ked2oml2ool00ooOmikgWP0:ool000Woo`8000036<=[KF]]00;>F@;g_P03oooW?>Ll00;W70:<
D@:<L@03<HH0800P008000808088H@03DXY:JDYY009:J@9:B@03[GG_ONmm00Coo`;g_P03kggW?>Ll
00:DTP:D/P:Ld`03W?>U5:DD008ii`88@@<0008aQP:D/P;W70?oo`;Nf`;F^P=kc`8Q908080800080
8003264@XQ2R008H``8Q10038B@YABU5008YA@F<D@;Nf`;_G@;og`;oo`03omogW_NN00Goo`800003
6<=[KF]]00;>F@;g_P;oo`03iccW7>LL00:<D@:<L@03<HH0800P008000808088H@03DXY:JDYY009:
J@9:B@:]M@03kggooooo00;oo`;g_P03kggW?>Ll00:DTP:D/P:Ld`03W?>U5:DD008ii`88@@<0008a
QP:D/P;W70?oo`;Nf`;F^P=kc`8Q9080808000808003264@XQ2R008H``8Q10038B@YABU5008YA@F<
D@;Nf`;_G@;og`;oo`03omogW_NN00[oo`002Ooo0^mM00?W78aaS7400S660P0P00<0000P02000PQQ
0Q2R0QS300<Q124T8B@00RU50X@`0]kK00?ogoooool00_oO0_NN00?_GIcCW=<00SW70PQ10P0000<0
836V<JH00S6V0YcC0^LL0ooo0]kK0]Jj0]JJ00=cSR448@@00Q220`000P0P0T880SWW0ZDD00?_GOoo
ool00_oo0]Jj0W>^00=kcb4T8B@00P0P0P0000<080QQ26400Q2R0V</0/Hh00?g__ooool00^mM0^LL
0]kk00?Nfg__Nnl01Ooo0^mM00?W78aaS7400S660P0P0P0000<080QQ26400Q2R0QS300<Q124T8B@0
0RU50X@`0]kK00?ogoooool00_oO0_NN0^mM00>LdcW7>LL00PQ10P0000<0836V<JH00S6V0YcC0^LL
0ooo0]kK0]Jj0]JJ00=cSR448@@00Q220`000P0P0T880SWW0ZDD00?_GOooool00_oo0]Jj0W>^00=k
cb4T8B@00P0P0P0000<080QQ26400Q2R0V</0/Hh00?g__ooool00^mM0^LL0]kk00?Nfg__Nnl02_oo
0009ool2ked00nLLS76<L@02<HH202000`000200800226424:826<<00b448B@Q9002:DD2Q302g]/0
0ooOooooo`02oml2mih00nmMW=>Ld`02>LL2244200000`0P<JHaYP02<JH2W=<2ia`3ool2g]/2e[X2
eYX00g>>8@@Q1002488300020202@PP2>NL2YA@00nmMooooo`02ool2e[X2Ljh00g_?8B@Q90020202
00000`0P2648H@024:82Hb`2aSP00oNnooooo`02ked2ia`2g_/00mkKNnmkk`05ool2ked00nLLS76<
L@02<HH2020200000`0P2648H@024:826<<00b448B@Q9002:DD2Q302g]/00ooOooooo`02oml2mih2
ked00icC>LLia`02244200000`0P<JHaYP02<JH2W=<2ia`3ool2g]/2e[X2eYX00g>>8@@Q10024883
00020202@PP2>NL2YA@00nmMooooo`02ool2e[X2Ljh00g_?8B@Q9002020200000`0P2648H@024:82
Hb`2aSP00oNnooooo`02ked2ia`2g_/00mkKNnmkk`0:ool000Woo`9kk`03Q124<8@`00B<D@03<HHQ
1244008@PP@00003245:BDY90092:0:]E@;_G@03omoooooo00;og`W6609Jj`=Jb`8@XP8080800003
0208H@QQ008@XP9S;09S3003aQSgW_NN00;oo`;_G@03icb<LHaa00:DTP:D/P8aYP03:DD0800P0080
00808088H@034:9S;6</00;6>0;g_P03ooo_GNmM00:Ld`8ia`8YI@03020000000080808ii`:U5003
iccooooo00Goo`9kk`03Q124<8@`00B<D@8aQP038@@@PQ2200@00003245:BDY90092:0:]E@;_G@03
omoooooo00;og`W6609Jj`=Jb`8@XP80808000030208H@QQ008@XP9S;09S3003aQSgW_NN00;oo`;_
G@03icb<LHaa00:DTP:D/P8aYP03:DD0800P008000808088H@034:9S;6</00;6>0;g_P03ooo_GNmM
00:Ld`8ia`8YI@03020000000080808ii`:U5003iccooooo00[oo`002ooo00?g_^mmkgd00^Ll0^LL
00?NnmkKg]/00W_?0R4T0Q2R00<0800000000P0P0PQQ0Q2R00<Hhg>>Lhh00V]]0/ii00?g__ooool0
0_oO0_NN0^mM00?W?8aaS7400YBB0YBb0S6V00<8@@0000000Q2R0QSS0R4400<Q92U5:DD012UU0haa
0]kk0_oO0_oo00?g_[gg_OL00U[;0U:Z0U::00=:JDY9BTT00PQQ0`000PQ10Q220U[;0U:Z0e::0TYY
0[FF0[gG00?gW_ooool01ooo00?g_^mmkgd00^Ll0^LL0]kk00?Nfg_?Nll00R4T0Q2R00<080000000
0P0P0PQQ0Q2R00<Hhg>>Lhh00V]]0/ii0_Nn00?ooooOoml00_NN0^mM00?W?8aaS7400YBB0YBb0S6V
00<8@@0000000Q2R0QSS0R4400<Q92U5:DD012UU0haa0]kk0_oO0_oo00?g_[gg_OL00U[;0U:Z0U::
00=:JDY9BTT00PQQ0`000PQ10Q220U[;0U:Z0e::0TYY0[FF0[gG00?gW_ooool02_oo000;ool00oNn
kgg_O@02ic`2ia`00mkkg]_Nf`02Nll28B@24:800`0P00000002020226424:800aSSLhicSP02Jfd2
cWT00oNnooooo`02oml2mih2ked00nLlS76<L@02U982U;82<JH00`Q1000000024:826><28@@00b4T
:DDYA@04:FD3S742g_/2oml2ool00oNn_ONmm`02F//2DZX2DXX00dYYBTU:B@022643000224424882
F//2DZX3DXX2BVT2]IH2_ML00oNNooooo`07ool00oNnkgg_O@02ic`2ia`2g_/00mkKNlmkc`028B@2
4:800`0P00000002020226424:800aSSLhicSP02Jfd2cWT2mkh00oooomoog`02mih2ked00nLlS76<
L@02U982U;82<JH00`Q1000000024:826><28@@00b4T:DDYA@04:FD3S742g_/2oml2ool00oNn_ONm
m`02F//2DZX2DXX00dYYBTU:B@022643000224424882F//2DZX3DXX2BVT2]IH2_ML00oNNooooo`0:
ool000_oo`03mkk_ONmm00;W?0;W7003g_^448@@008YA@80808000032452:48X00U220:U=0;_G@?o
o`;g_PFme`9BZP9BRP8@PP<00088@@8@PP8H``8Hh`03LjkFV]JJ00;og`;oo`03omo6><Hh009S308H
``<0008Q90:4<0:4409kk`03e[[ogooO00;oo`;og`03mik_GNmM00;W70;Nn`;Nf`03NnlQ924T008H
``800088@@03488@XQ2R00Ooo`03mkk_ONmm00;W?0;W70;Nn`03Q10YABU50080808000032452:48X
00U220:U=0;_G@?oo`;g_PFme`9BZP9BRP8@PP<00088@@8@PP8H``8Hh`03LjkFV]JJ00;og`;oo`03
omo6><Hh009S308H``<0008Q90:4<0:4409kk`03e[[ogooO00;oo`;og`03mik_GNmM00;W70;Nn`;N
f`03NnlQ924T008H``800088@@03488@XQ2R00[oo`002ooo00?g_^mmkgd00^Ll0^LL00?Nnh@@Q100
0RU50P0P0P0000<8@D8X@RP02D880ZDd0^mM0ooo0_Nn1KgG0U:Z0U::0Q220`000PQ10Q220QS30QSS
00=c[]JJeYX00_oO0_oo00?oglHhaSP00V<<0QS30`000R4T0X@`0X@@0W__00?F^_oOoml00_oo0_oO
00?gW^mMked00^LL0]kk0]kK00=kkb4T8B@00QS30P000PQ100<@PQ2R4:801ooo00?g_^mmkgd00^Ll
0^LL0]kk00>442U5:DD00P0P0P0000<8@D8X@RP02D880ZDd0^mM0ooo0_Nn1KgG0U:Z0U::0Q220`00
0PQ10Q220QS30QSS00=c[]JJeYX00_oO0_oo00?oglHhaSP00V<<0QS30`000R4T0X@`0X@@0W__00?F
^_oOoml00_oo0_oO00?gW^mMked00^LL0]kk0]kK00=kkb4T8B@00QS30P000PQ100<@PQ2R4:802_oo
0009ool2Jdd00liImkkg_P02ool2oml00lHhHbaS;0026<<400000`0P2648H@024:82Jdd2aSP00mJJ
omoog`02ool2oml00oNN[EF]E@02BTT2264300022444BTT2@RP00jeEkeg_G@02oml2ool2mkh00nmm
iccW?002ia`2Q3000bUU6><Hh`02264400000`Q1488@PP026<<26><2Ljh00mJJg__Nn`02kgd3ool6
cWT3cUT4Hb`26<<224400`00488@PP05ool2Jdd00liImkkg_P02ool2oml2aSP00f</6<<H``040000
0`0P2648H@024:82Jdd2aSP00mJJomoog`02ool2oml2mih00jeEBTU:B@02264300022444BTT2@RP0
0jeEkeg_G@02oml2ool2mkh00nmmiccW?002ia`2Q3000bUU6><Hh`02264400000`Q1488@PP026<<2
6><2Ljh00mJJg__Nn`02kgd3ool6cWT3cUT4Hb`26<<224400`00488@PP0:ool000Woo`9[C@03cUWg
__Nn00;oo`;og`03aSQS;6</008H``@000030208H@QQ008@XP9[C@;6>003eY[ogooO00;oo`;og`03
mij]EJeE009:B@88H@<00088@@A:B@92:003[EG_GNmM00;og`;oo`;g_P03kggW?>Ll00;W70:4<003
:FDHhaSS0088H@@00003244@PQ22008H``8Hh`9c[P03eY[Nnmkk00;_O@?oo`K>N@?>F@AS;08H``88
@@03000@PQ2200Goo`9[C@03cUWg__Nn00;oo`;og`;6>003Hb`H`aS300@000030208H@QQ008@XP9[
C@;6>003eY[ogooO00;oo`;og`;gWP03[EE:BDY90088H@<00088@@A:B@92:003[EG_GNmM00;og`;o
o`;g_P03kggW?>Ll00;W70:4<003:FDHhaSS0088H@@00003244@PQ22008H``8Hh`9c[P03eY[Nnmkk
00;_O@?oo`K>N@?>F@AS;08H``88@@03000@PQ2200[oo`002Ooo0V<<00?66?Nnmkh00_oo0_oO00?g
_^mmkgd00Ycc0ZDD0T8800<aYRU5:DD00QSS100000<080QQ26400Q2R0QSS00=c[/iicWT00]kk0_oO
0_oo00?Nnh@@Q1000RU50P0P0P0000<080QQ26400Q2R0V</0/Hh00?g__ooool00_oO0_NN0kFF0[Ff
0U::0Q220`000RUU0Xaa0XaA00?NnooOoml00_oO0/ii00=[CASS6><010000b4T18@`0X@@0g__0W_?
1Ooo0V<<00?66?Nnmkh00_oo0_oO0_Nn00?_OIccW?<00ZDD0T8800<aYRU5:DD00QSS100000<080QQ
26400Q2R0QSS0W>^00?>NMkkg_/00_oO0_oo00?Nnh@@Q1000RU50P0P0P0000<080QQ26400Q2R0V</
0/Hh00?g__ooool00_oO0_NN0kFF0[Ff0U::0Q220`000RUU0Xaa0XaA00?NnooOoml00_oO0/ii00=[
CASS6><010000b4T18@`0X@@0g__0W_?2_oo0009ool2H``00lHHmkkg_P02ool2oml00oNnkgg_O@02
W?<2YA@2@PP00c6V:DDYA@026><400000`0P2648H@024:826><00g>^cWW>N@02g_/2oml2ool00mkk
Q1244002:DD2020200000`0P2648H@024:82Hb`2aSP00oNnooooo`02oml2mih3]IH2]KH2DXX24883
0002:FD2S742S5400mkkomoog`02oml2cWT00f]=6><Hh`0400038B@4Q302Q103Nnl2Nll5ool2H``0
0lHHmkkg_P02ool2oml2mkh00nmmW?>Ll`02YA@2@PP00c6V:DDYA@026><400000`0P2648H@024:82
6><2Ljh00liig__Nn`02oml2ool00mkkQ1244002:DD2020200000`0P2648H@024:82Hb`2aSP00oNn
ooooo`02oml2mih3]IH2]KH2DXX248830002:FD2S742S5400mkkomoog`02oml2cWT00f]=6><Hh`04
00038B@4Q302Q103Nnl2Nll:ool000Woo`;FVP03iacooooo00;oo`;Nf`03Nnn448@@00B4<08YI@03
0200000000808088H@=BRP:eUP:me`;gWP03oooogooO00C>N@;>F@E[C@9S;08Hh`03244000000080
0088@@8@PP03H`c66<HH00;gWP;oo`03omo>NLii009[K@8Hh`88H@<0008YA@:<D@>4<0;Nf`;_G@?o
o`;g_P;_O@:U5092200326400000008@PP9Jj`9Jb`=BZPGoo`;FVP03iacooooo00;oo`;Nf`9kk`03
Q124<8@`00:4<08YI@030200000000808088H@=BRP:eUP:me`;gWP;oo`03omo>NLii00;>N@;>F@E[
C@9S;08Hh`032440000000800088@@8@PP03H`c66<HH00;gWP;oo`03omo>NLii009[K@8Hh`88H@<0
008YA@:<D@>4<0;Nf`;_G@?oo`;g_P;_O@:U5092200326400000008@PP9Jj`9Jb`=BZP[oo`002Ooo
0[Ff00>mmoNNmih00_oo0_oO1liI0f</0QS310000P0P00=22:DdYC@00ZeE0Zee00?_OOooool00_oo
0_Nn0^mm00>U=:eE[ED00T8X0PQQ0P0000<8HA2R4:800V]=0/Hh0_Nn00?ooooOoml00_NN0^mM00>L
ljDDYA@00ZDD0T880PQQ0`000PQ10Q220QS300<Hhg_?Nll00W>^0/ii00?ogoooool00_oO1lHh0V<<
0U[[0QS300<000Q124401Ooo0[Ff00>mmoNNmih00_oo0_oO1liI0f</0QS310000P0P00=22:DdYC@0
0ZeE0Zee0^mm0ooo0_Nn0^mm00>U=:eE[ED00T8X0PQQ0P0000<8HA2R4:800V]=0/Hh0_Nn00?ooooO
oml00_NN0^mM00>LljDDYA@00ZDD0T880PQQ0`000PQ10Q220QS300<Hhg_?Nll00W>^0/ii00?ogooo
ool00_oO1lHh0V<<0U[[0QS300<000Q124402_oo0009ool2]KH00kggmikgWP02ool2oml7cUT3Hb`2
6<<4000202000d88YCBU=002[ED2[GD00nmmooooo`02ool2mkh2kgd00jDd[EF]E@02@RP226420000
0`QQ4:8@XP02Jdd2aSP2mkh00oooomoog`02mih2ked00iccYABU5002YA@2@PP22643000224424882
6<<00aSSNlmkc`02Ljh2cWT00ooOooooo`02oml7aSP2H``2F^/26<<00`002448@@05ool2]KH00kgg
mikgWP02ool2oml7cUT3Hb`26<<4000202000d88YCBU=002[ED2[GD2kgd3ool2mkh2kgd00jDd[EF]
E@02@RP2264200000`QQ4:8@XP02Jdd2aSP2mkh00oooomoog`02mih2ked00iccYABU5002YA@2@PP2
26430002244248826<<00aSSNlmkc`02Ljh2cWT00ooOooooo`02oml7aSP2H``2F^/26<<00`002448
@@0:ool000Woo`88H@034:8HhaSS009c[P;>N@03omoooooo00;Nn`;Nf`9kk`03:DD0800P00800080
8088H@03DZYBRU::00A:J@03]IJe][Ff00;gWPCoo`03mkk_ONmm00:U508ii`88@@<0008aQP8aYP:D
/P03iacgW_NN00;oo`;_O@03icbDTYBB00:D/P:Ld`8ia`032440000000808088@@8@PP036<=[KF]]
00A[C@03aSSg__Nn00;oo`;og`;gWP03[GFeU[FF009:J@8@PP8000030208H@QQ00Goo`88H@034:8H
haSS009c[P;>N@;og`03oooNnmkk00;Nf`9kk`03:DD0800P008000808088H@03DZYBRU::00A:J@:e
UP03]KKgW_NN00Coo`03mkk_ONmm00:U508ii`88@@<0008aQP8aYP:D/P03iacgW_NN00;oo`;_O@03
icbDTYBB00:D/P:Ld`8ia`032440000000808088@@8@PP036<=[KF]]00A[C@03aSSg__Nn00;oo`;o
g`;gWP03[GFeU[FF009:J@8@PP8000030208H@QQ00[oo`002Ooo0PQQ00<@XQSS6><00W>^0/ii00?o
goooool00]kk0]kK0W__00<YA@0P02000P000P0P0PQQ00=BZU::DXX014YY00>eU[Ff]KH00_NN1?oo
00?g_^mmkgd00ZDD0SWW0PQ10`000S660S6V0YBb00?W7?NNmih00_oo0^mm00?W?9BBU9800YBb0YcC
0SW700<8@@0000000P0P0PQ10Q2200<H`f]]Jfd016]=00?6>?Nnmkh00_oo0_oO0_NN00>]MKFF]IH0
0TYY0Q220P0000<080QQ26401Ooo0PQQ00<@XQSS6><00W>^0/ii0_oO00?oomkkg_/00]kK0W__00<Y
A@0P02000P000P0P0PQQ00=BZU::DXX014YY0[FF00>e]_NNmih01?oo00?g_^mmkgd00ZDD0SWW0PQ1
0`000S660S6V0YBb00?W7?NNmih00_oo0^mm00?W?9BBU9800YBb0YcC0SW700<8@@0000000P0P0PQ1
0Q2200<H`f]]Jfd016]=00?6>?Nnmkh00_oo0_oO0_NN00>]MKFF]IH00TYY0Q220P0000<080QQ2640
2_oo0009ool2DXX3BVT4BTT00d8X[GF]M@02ked2ool2mih00nmMiccW?002S742<HH224400`006<<H
``026><28@@00g__e[[F^P02oml2ool2ia`00mkkg]_Nf`02e[X2eYX2Lhh00b440000000200020202
26400a2RHbaS;002aSP2eYX00ooOooooo`02oml2mih2ked00icCW?>Ll`02>NL224430002<HH5<JH2
W=<2ia`2mkh2ool00ooOmikgWP02kgd2ic`2U983U;85ool2DXX3BVT4BTT2@RP00jeekeg_G@02ool2
mih00nmMiccW?002S742<HH224400`006<<H``026><28@@2Nnl00mJjomoog`02ool2ia`00mkkg]_N
f`02e[X2eYX2Lhh00b44000000020002020226400a2RHbaS;002aSP2eYX00ooOooooo`02oml2mih2
ked00icCW?>Ll`02>NL224430002<HH5<JH2W=<2ia`2mkh2ool00ooOmikgWP02kgd2ic`2U983U;8:
ool000Woo`9BRP=:J@A:B@03@RR]MJee00;_G@;oo`;gWP03kegW?>Ll00:<L@8aQP88@@03000H`aS3
008Hh`8Q1003NnoF^]Jj00;og`;oo`;W7003g__NfmkK00;F^P;FVP9cSP038@@00000008000808088
H@034:9S;6</00;6>0;FVP03omoooooo00;og`;gWP;_G@03W=>Llicc008ii`88@@<0008aQPDaYP:L
d`;W70;g_P;oo`03omogW_NN00;_O@;W?0:DTP>D/PGoo`9BRP=:J@A:B@92:003[GG_GNmM00;oo`;g
WP03kegW?>Ll00:<L@8aQP88@@03000H`aS3008Hh`8Q109kk`03e[[ogooO00;oo`;W7003g__NfmkK
00;F^P;FVP9cSP038@@00000008000808088H@034:9S;6</00;6>0;FVP03omoooooo00;og`;gWP;_
G@03W=>Llicc008ii`88@@<0008aQPDaYP:Ld`;W70;g_P;oo`03omogW_NN00;_O@;W?0:DTP>D/P[o
o`002Ooo0YcC00>LlcWW>NL00S660PQ100<0000P02000PQQ0Q2R0QS300=cSV]]Jfd00/iI0]Jj0^Ll
00?oooNnmkh00[gG0U:Z00<@XP0000000PQ10Q220e[[0[gg0/Hh0]JJ0^LL00?ooooOoml00/HH0U[[
0QS30`000PQ10Q2200=Jbe:ZDZX00U:Z0U::0[Ff00>mmlHhaSP00]JJ0_oO0_oo00?oglHhaSP01<Hh
00=S31S36<<00P000P0P0PQQ00<@XQSS6><00W>^0W>>0/ii00?g__ooool01Ooo0YcC00>LlcWW>NL0
0S660PQ10P0000<080QQ26400Q2R0QS300=cSV]]Jfd00/iI0]Jj0^Ll00?oooNnmkh00[gG0U:Z0Q2R
00<000Q124400Q220e[[0[gg0/Hh0]JJ0^LL00?ooooOoml00/HH0U[[0QS30`000PQ10Q2200=Jbe:Z
DZX00U:Z0U::0[Ff00>mmlHhaSP00]JJ0_oO0_oo00?oglHhaSP01<Hh00=S31S36<<00P000P0P0PQQ
00<@XQSS6><00W>^0W>>0/ii00?g__ooool02_oo0009ool2oml00oNNkeg_G@02ic`2g_/00mkKe[[F
^P04eYX2Lhh00b44488@PP040002:FD3S742g_/2oml00ooog__Nn`02Q102:DD202000`0002008002
26424:826<<00g>>Jfe[K@02cUT2e[X2oml00ooomkkg_P02kgd2YA@00jDd@PQ22002264200024880
0aS3Jde[C@04Hb`2H``00e[[F/]Jb`02DZX2_ML00oNNooooo`02oml2mkh2kgd00nLliacW7002Q302
S542:FD00b4400000005ool2oml00oNNkeg_G@02ic`2g_/2g]/00mJjeY[FVP02eYX2Lhh00b44488@
PP040002:FD3S742g_/2oml2ool00mkkQ1244002:DD202000`000200800226424:826<<00g>>Jfe[
K@02cUT2e[X2oml00ooomkkg_P02kgd2YA@00jDd@PQ220022642000248800aS3Jde[C@04Hb`2H``0
0e[[F/]Jb`02DZX2_ML00oNNooooo`02oml2mkh2kgd00nLliacW7002Q302S542:FD00b440000000:
ool000Woo`;og`03mik_GNmM00;W?0;Nn`03g]_F^]Jj00CFVP9cSP038@@@PQ2200@0008YI@><L@;N
n`;og`03oooNnmkk00:4408YA@8080030000800P0088H@8@XP8H``03Lhi[KF]]00;>F@;F^P;og`03
ooog__Nn00;_O@:U5003YCA224880088H@80008@PP036<=[CF]=00AS;09S3003F^]Jbe[;009BZP:m
e`03mikooooo00;og`;g_P;_O@03iccW7>LL00:4<0:<D@8YI@038@@0000000Goo`;og`03mik_GNmM
00;W?0;Nn`;Nf`03e[[FV]JJ00;FVP9cSP038@@@PQ2200@0008YI@><L@;Nn`;og`;oo`03g_^448@@
008YA@8080030000800P0088H@8@XP8H``03Lhi[KF]]00;>F@;F^P;og`03ooog__Nn00;_O@:U5003
YCA224880088H@80008@PP036<=[CF]=00AS;09S3003F^]Jbe[;009BZP:me`03mikooooo00;og`;g
_P;_O@03iccW7>LL00:4<0:<D@8YI@038@@0000000[oo`002Ooo0P0000<083WW>NL00SWW0ZDD00>U
=>mMked00_oo0_Nn0kFf0U::0Q22100000<080QQ26400U:Z0U::00>e][gg_OL00_NN0_oo0_NN00>]
EJee[GD00Zee0[FF0[Ff00=BRTY9BTT00T880PQQ0`000PQ1148X00>]ENmMked01?oo0_Nn00?_ONLl
ic`00^LL0XaA0RUU00<Q100000000P000P0P00<8HE:ZDZX00[gG0_NN0_oo00?_ONLlic`00^LL0XaA
0Xaa00>DTS66<HH01Ooo0P0000<083WW>NL00SWW0ZDD0ZDd00?_GOooool00_Nn0kFf0U::0Q221000
00<080QQ26400U:Z0U::0[Ff00>mmoNNmih00_oo0_NN00>]EJee[GD00Zee0[FF0[Ff00=BRTY9BTT0
0T880PQQ0`000PQ1148X00>]ENmMked01?oo0_Nn00?_ONLlic`00^LL0XaA0RUU00<Q100000000P00
0P0P00<8HE:ZDZX00[gG0_NN0_oo00?_ONLlic`00^LL0XaA0Xaa00>DTS66<HH02_oo0009ool20000
0`0P>NLii`02>NL2YA@00jDdkeg_G@02ool2mkh3]KH2DXX2488400000`0P2648H@02DZX2DXX00kFf
_ONmm`02mih2ool2mih00jeE[GF]M@02[GD2]IH2]KH00e::BTU:B@02@PP2264300022444@RP00jeE
keg_G@04ool2mkh00nmmiccW?002ia`2S542:FD00b4400000002000202000`QQDZYBZP02_ML2mih2
ool00nmmiccW?002ia`2S542S7400iBB<HHaQP05ool200000`0P>NLii`02>NL2YA@2YC@00nmMoooo
o`02mkh3]KH2DXX2488400000`0P2648H@02DZX2DXX2]KH00kggmikgWP02ool2mih00jeE[GF]M@02
[GD2]IH2]KH00e::BTU:B@02@PP2264300022444@RP00jeEkeg_G@04ool2mkh00nmmiccW?002ia`2
S542:FD00b4400000002000202000`QQDZYBZP02_ML2mih2ool00nmmiccW?002ia`2S542S7400iBB
<HHaQP0:ool000Woo`88@@030000800P0088H@8@XP03Hbc6><Hh00;>N@;og`;oo`03iccNnmkk00;N
f`;F^P?FVP9cSP8Q108000030208@@Q1008@PP8H``8Hh`03Nlmc[W>^00;FVP;Nn`;_O@?oo`;g_P;_
O@:U5003>NL8H@QQ00@00003245:JDYY00:eUP:e]P:mm`03mikooooo00;og`;gWP;_O@03W?>U5:DD
00:U=0922003>LL8@@Q100800080808aYP03U;:LdicC00:Ld`;W70?oo`;Nf`Goo`88@@030000800P
0088H@8@XP9S;003aSS>NLii00;og`;oo`03iccNnmkk00;Nf`;F^P?FVP9cSP8Q108000808003244@
PQ22008H``8Hh`03Nlmc[W>^00;FVP;Nn`;_O@?oo`;g_P;_O@:U5003>NL8H@QQ00@00003245:JDYY
00:eUP:e]P:mm`03mikooooo00;og`;gWP;_O@03W?>U5:DD00:U=0922003>LL8@@Q100800080808a
YP03U;:LdicC00:Ld`;W70?oo`;Nf`[oo`002Ooo0PQ100<0000P02000PQQ0Q2R00=S;<HhaSP00/ii
0_oO0_oo00?W?=kkg_/00]kK0]Jj0mJJ0W>>0R440P0000<080Q124400Q220QS30QSS00=kcg>^Ljh0
0]JJ0]kk0^mm0ooo0_Nn0^mm0ZDD00<ii`QQ2640100000<8@DYYBVT00[FF0[Ff0[gg00?gW_ooool0
0_oO0_NN0^mm00>LljDDYA@00ZDd0T8800<ia`Q124400P000P0P0S6V00>D/YcCW=<00YcC0^LL0ooo
0]kK1Ooo0PQ100<0000P02000PQQ0Q2R0V</00?6><iicWT00_oO0_oo00?W?=kkg_/00]kK0]Jj0mJJ
0W>>0R440P000P0P00<8@A2248800QS30QSS00=kcg>^Ljh00]JJ0]kk0^mm0ooo0_Nn0^mm0ZDD00<i
i`QQ2640100000<8@DYYBVT00[FF0[Ff0[gg00?gW_ooool00_oO0_NN0^mm00>LljDDYA@00ZDd0T88
00<ia`Q124400P000P0P0S6V00>D/YcCW=<00YcC0^LL0ooo0]kK2_oo0009ool3Nnl2:DD202020000
0`Q1488@PP024:82Jdd2cUT00oNnooooo`02oml2mih2ked00nLlS76<L@02<HH202000`0002008002
<JH2>LL2W=<00icciccW?004ool2mkh00kgG_ONmm`02_OL2F//24:800`002448@@0248826<<00aSS
8@@Q10028B@2:DD2:FD3S742g_/2oml2ool00mkkg]_Nf`02e[X2Ljh00b4T0000000200026><28B@0
0h@@e[[F^P02oml2ool2oml00oNNkeg_G@05ool3Nnl2:DD20202000224400a224:8@XP02Jdd2cUT0
0oNnooooo`02oml2mih2ked00nLlS76<L@02<HH2020200000`0P<JHaYP02>LL2W=<00icciccW?004
ool2mkh00kgG_ONmm`02_OL2F//24:800`002448@@0248826<<00aSS8@@Q10028B@2:DD2:FD3S742
g_/2oml2ool00mkkg]_Nf`02e[X2Ljh00b4T0000000200026><28B@00h@@e[[F^P02oml2ool2oml0
0oNNkeg_G@0:ool000Woo`;W7003S74aQS66008080800003020iicWW008ii`:U50;W?0?oo`;g_PBm
e`03DZX@XQ2R00800088@@03488H`aS3009[K@;>F@;g_P03oooogooO00;6>09S;09S30036<<00000
0080809220:U=003kegooooo00;oo`;g_P03_MMBZU:Z008@PP@00003244@PQ22008H``8Hh`8Q1003
8B@YABU500@YI@<aQPLaYP:Ld`;W70Coo`03mkjmekgG00Goo`;W7003S74aQS6600808080008080<i
i`:U50;W?0?oo`;g_PBme`03DZX@XQ2R00800088@@8@PP036<=[KF]]00;>F@;g_P03oooogooO00;6
>09S;09S30036<<000000080809220:U=003kegooooo00;oo`;g_P03_MMBZU:Z008@PP@00003244@
PQ22008H``8Hh`8Q10038B@YABU500@YI@<aQPLaYP:Ld`;W70Coo`03mkjmekgG00[oo`002Ooo0^LL
00><LC66<HH00P0P0P0000<083WW>NL00SWW0ZDD0^Ll0ooo0_Nn1;gG00=BZQ2R4:800P000PQ100<@
PQS36<<00V]]0/iI0_Nn00?ooooOoml00/Hh0V</0V<<00<H``0000000P0P0T880ZDd00?_GOooool0
0_oo0_Nn00>mee:ZDZX00Q22100000<8@A2248800QS30QSS0R4400<Q92U5:DD012UU0c661c6V0YcC
0^LL1?oo00?g_[gG_ML01Ooo0^LL00><LC66<HH00P0P0P000P0P0cWW0ZDD0^Ll0ooo0_Nn1;gG00=B
ZQ2R4:800P000PQ10Q2200<H`f]]Jfd00/iI0_Nn00?ooooOoml00/Hh0V</0V<<00<H``0000000P0P
0T880ZDd00?_GOooool00_oo0_Nn00>mee:ZDZX00Q22100000<8@A2248800QS30QSS0R4400<Q92U5
:DD012UU0c661c6V0YcC0^LL1?oo00?g_[gG_ML02_oo0009ool2DZX00e::488@PP0400000bU5:FDY
I@06S7400mkkkgg_O@04ool2mkh00nmmiccW?002U982<JH00`Q1000000024:826><28@@00b4TQ124
4002Q104Nnl00mJjomoog`02ool2ia`2g_/00mkKe[[F^P02Ljh28B@00a2R00000002244248826<<0
0aSS8@@Q1002Nnl2e[X2oml00oooe[[F^P02Ljh28B@00`0P00000002020226424:800f</H`aS3002
F^/2aQP2cUT00oNnooooo`05ool2DZX00e::488@PP040002:DD00bUUS76<L@04S7400mkkkgg_O@04
ool2mkh00nmmiccW?002U982<JH224400`004:8@XP026><28@@00b4TQ1244002Q104Nnl00mJjomoo
g`02ool2ia`2g_/00mkKe[[F^P02Ljh28B@00a2R00000002244248826<<00aSS8@@Q1002Nnl2e[X2
oml00oooe[[F^P02Ljh28B@00`0P00000002020226424:800f</H`aS3002F^/2aQP2cUT00oNnoooo
o`0:ool000Woo`9BZP03DXX@PQ2200@00003:DDYIBUU00J<L@03g___ONmm00Coo`;g_P03kggW?>Ll
00:DTP8aYP0324400000008@XP8Hh`8Q10038BB448@@00:440Akk`03e[[ogooO00;oo`;W70;Nn`03
g]_F^]Jj009c[P8Q90034:8000000088@@8@PP8H``036><Q1244009kk`;F^P;og`03oooF^]Jj009c
[P8Q90030200000000808088H@8@XP03HbaS36<<009Jj`;660;>F@03mkkooooo00Goo`9BZP03DXX@
PQ2200@0008YA@03:FF<LHaa00B<L@03g___ONmm00Coo`;g_P03kggW?>Ll00:DTP8aYP88@@03000@
XQ2R008Hh`8Q10038BB448@@00:440Akk`03e[[ogooO00;oo`;W70;Nn`03g]_F^]Jj009c[P8Q9003
4:8000000088@@8@PP8H``036><Q1244009kk`;F^P;og`03oooF^]Jj009c[P8Q9003020000000080
8088H@8@XP03HbaS36<<009Jj`;660;>F@03mkkooooo00[oo`002Ooo0^Ll00><LIBBU9800YBb0S6V
00<YA@0P02000P000P0P1d881:Dd00?_GOooool00_Nn0^mm00?W?>LLia`00X@`0RUU0P0P00<00244
8@@00R4T0RU50bUU13661iBb0^LL0ooo0_Nn0[gg0U[;0U:Z00=BRTYYBVT00Q22100000<Q98@@Q100
0W__0]Jj00?ogoooool00^LL0]kk0X@@00>4<2UU:FD00QSS100000<080QQ26401Ooo0^Ll00><LIBB
U9800YBb0S6V0RU500<0800000000P0P1d881:Dd00?_GOooool00_Nn0^mm0^Ll00?W78@`Q3000RUU
0P0P00<002448@@00R4T0RU50bUU13661iBb0^LL0ooo0_Nn0[gg0U[;0U:Z00=BRTYYBVT00Q221000
00<Q98@@Q1000W__0]Jj00?ogoooool00^LL0]kk0X@@00>4<2UU:FD00QSS100000<080QQ26402_oo
0009ool2ic`00haaU9:DTP02U;82<JH00bU50200800200020207@PP4YC@00nmMooooo`02mkh2kgd0
0nLliacW7002Q302:FD202000`008@@Q10028B@2:DD3:FD4<HH7U;82ia`3ool2mkh2_OL2F//2DZX0
0e::BVU:J@02488400000b4TQ1244002Nnl2e[X00ooOooooo`02ia`2g_/2Q1000h@`:FDYI@026><4
00000`0P2648H@05ool2ic`00haaU9:DTP02U;82<JH2:DD00`0P000000020207@PP4YC@00nmMoooo
o`02mkh2kgd2ic`00nLLQ324<002:FD202000`008@@Q10028B@2:DD3:FD4<HH7U;82ia`3ool2mkh2
_OL2F//2DZX00e::BVU:J@02488400000b4TQ1244002Nnl2e[X00ooOooooo`02ia`2g_/2Q1000h@`
:FDYI@026><400000`0P2648H@0:ool000Woo`8@XP03JdeS;6</00;6>0;g_P03ooo_GNmM00;W?0:<
L@8aQP0302000000008H``8Hh`8Q10038BB4<8@`00B44003Nnmkcg_?00;FVP;og`;oo`03iab<LHaa
00BDTP8aYP03:DD0800P008000@YA@03S57Nnmkk00;_O@;oo`03mij]MJee009:B@8@PP<0008YI@8a
QPFDTP;Nn`;gWP?oo`C>N@A[C@036><8H@QQ00800088@@8@PP036<<HhaSS00Goo`8@XP03JdeS;6</
00;6>0;g_P;oo`03kegW?>Ll00:<L@8aQP0302000000008H``8Hh`8Q10038BB4<8@`00B4409kk`03
NloFV]JJ00;og`;oo`03iab<LHaa00BDTP8aYP03:DD0800P008000@YA@03S57Nnmkk00;_O@;oo`03
mij]MJee009:B@8@PP<0008YI@8aQPFDTP;Nn`;gWP?oo`C>N@A[C@036><8H@QQ00800088@@8@PP03
6<<HhaSS00[oo`002Ooo0W>^00?FV_oOoml00_oo0^Ll00><LIBBU9800S6V0PQ10P0000<@XQSS6><0
0W>^0W>>0/ii00?g__ooool00_oO0_NN00>]MDY9BTT00T880PQQ0`000PQ10Q220U[[0/HH00?gW_oo
ool00^mM0^Ll0]kk00?Nfg__Nnl00X@@0X@`00<YAASS6><010000P0P00<8HE[;F//00U:Z15::00>e
U^mmkgd01?oo00?g_^mmkgd00ZDD0SWW0PQ10`000PQ114Y900>]MNmmkgd01Ooo0W>^00?FV_oOoml0
0_oo0^Ll0Xaa00>DTS6V<JH00PQ10P0000<@XQSS6><00W>^0W>>0/ii00?g__ooool00_oO0_NN0Zee
00=:BD88@PP00PQQ0`000PQ10Q220U[[0/HH00?gW_ooool00^mM0^Ll0]kk00?Nfg__Nnl00X@@0X@`
00<YAASS6><010000P0P00<8HE[;F//00U:Z15::00>eU^mmkgd01?oo00?g_^mmkgd00ZDD0SWW0PQ1
0`000PQ114Y900>]MNmmkgd02_oo0009ool2Ljh00mJJomoog`02ool2ic`00haaU9:DTP02<JH22442
00000a2R6><Hh`02Ljh2Lhh2cWT00oNnooooo`02oml2mih00jeeBTU:B@02@PP22643000224424882
F^/2aQP00oNNooooo`02ked2ic`2g_/00mkKNnmkk`02Q102Q3000bU56><Hh`04000202000`QQF/]J
b`02DZX4DXX00kFFkgg_O@04ool00oNnkgg_O@02YA@2>NL2244300022444BTT00jeekgg_O@05ool2
Ljh00mJJomoog`02ool2ic`2S7400iBB<JHaYP02244200000a2R6><Hh`02Ljh2Lhh2cWT00oNnoooo
o`02oml2mih2[GD00dY9@PQ220022643000224424882F^/2aQP00oNNooooo`02ked2ic`2g_/00mkK
Nnmkk`02Q102Q3000bU56><Hh`04000202000`QQF/]Jb`02DZX4DXX00kFFkgg_O@04ool00oNnkgg_
O@02YA@2>NL2244300022444BTT00jeekgg_O@0:ool000_oo`03mij]MJee009:B@8@PP030008H@QQ
008@XP9S;09S3003aQSg__Nn00;oo`;og`;>F@03JddHhaSS008000808003264@XQ2R008H``9cSP;>
N@03mkkooooo00;og`;gWP:]M@03BTU22488008ia`88@@8000034:8H`aS3008Q109kc`03eY[W7>LL
00Coo`;g_P03kgg_GNmM00;W70;Nn`;Nf`03e[[FV]JJ00;FVP9[K@=cSP8Q108@PP<0008YI@8aQPBD
TP03g___ONmm00Ooo`03mij]MJee009:B@8@PP800003264@XQ2R009S;09S3003aQSg__Nn00;oo`;o
g`;>F@03JddHhaSS008000808088H@034:8H`aS3009cSP;>N@03mkkooooo00;og`;gWP:]M@03BTU2
2488008ia`88@@8000034:8H`aS3008Q109kc`03eY[W7>LL00Coo`;g_P03kgg_GNmM00;W70;Nn`;N
f`03e[[FV]JJ00;FVP9[K@=cSP8Q108@PP<0008YI@8aQPBDTP03g___ONmm00[oo`002ooo00?gWZee
[GD00TY90Q2200<000QQ26400Q2R0V</0V<<00?66?Nnmkh00_oo0_oO0/iI00=[CASS6><00P000P0P
00<8HA2R4:800QS30W>>0/ii00?g__ooool00_oO0_NN0Zee00=:BD88@PP00SW70PQ10P0000<@XQS3
6<<00R440W_?00?FV^LLia`01?oo0_Nn00?_ONmMked00^LL0]kk0]kK00?F^]JJeYX00]JJ0V]]0g>>
0R440Q220`000RUU0S6619BB00?Nnnmmkgd01ooo00?gWZee[GD00TY90Q220P0000<8HA2R4:800V</
0V<<00?66?Nnmkh00_oo0_oO0/iI00=[CASS6><00P000P0P0PQQ00<@XQS36<<00W>>0/ii00?g__oo
ool00_oO0_NN0Zee00=:BD88@PP00SW70PQ10P0000<@XQS36<<00R440W_?00?FV^LLia`01?oo0_Nn
00?_ONmMked00^LL0]kk0]kK00?F^]JJeYX00]JJ0V]]0g>>0R440Q220`000RUU0S6619BB00?Nnnmm
kgd02_oo000<ool4cWT5cUT2Hb`26<<30002020226424:826><00b44Nnmkk`02e[X2oml00ooomkkg
_P02kgd2YC@2@PP00`QQ000000020004<HH00c6VU;:D/P02U;82ia`3ool2g]/2e[X2Nll00b4T0200
800200020202>NL00jDDYCBU=002ked2oml2ool00ooOmikgWP02ked2ia`00haa<HHaQP0202020002
0203>NL2W?<2ic`3ool2mkh8ool4cWT5cUT2Hb`26<<30002020226424:826><00b44Nnmkk`02e[X2
oml2ool00oNnkgg_O@02YC@2@PP00`QQ000000020004<HH00c6VU;:D/P02U;82ia`3ool2g]/2e[X2
Nll00b4T0200800200020202>NL00jDDYCBU=002ked2oml2ool00ooOmikgWP02ked2ia`00haa<HHa
QP02020200020203>NL2W?<2ic`3ool2mkh:ool000coo`C>N@G>F@9S;08H``<000808088H@8@XP8H
h`038@Akkg__00;F^P;og`03ooog__Nn00;_O@:U=092200326400000008000@aQP03<JJD/YBb00:D
/P;W70?oo`;Nf`;F^P9kc`038B@0800P00800080808ii`03YABU=:Dd00;_G@;og`;oo`03omogW_NN
00;_G@;W7003S74aQS6600808080008080<ii`:Ll`;W?0?oo`;g_PSoo`C>N@G>F@9S;08H``<00080
8088H@8@XP8Hh`038@Akkg__00;F^P;og`;oo`03mkk_ONmm00:U=092200326400000008000@aQP03
<JJD/YBb00:D/P;W70?oo`;Nf`;F^P9kc`038B@0800P00800080808ii`03YABU=:Dd00;_G@;og`;o
o`03omogW_NN00;_G@;W7003S74aQS6600808080008080<ii`:Ll`;W?0?oo`;g_P[oo`002Ooo0[gG
00=BZQ2R4:800P0P0P0000<YABUU:FD00RUU19BB00?NnooOoml00_oo0_Nn1Kgg0/HH0U[[00=Jba2R
4:800P0P0P000QS300<Q124T8B@012U50RUU0c660YBB0^LL0_NN0ooo1=JJ00?>NF]]Jfd00QSS1000
00<080QQ26400Q2R0QSS0R4400=kkg_?Nll00]JJ0_oO00?oonLLia`00Xaa0S660R4T00<080000000
0QSS0R4T0RU500>4<=kKg]/01Ooo0[gG00=BZQ2R4:800P0P0P000RU50bUU19BB00?NnooOoml00_oo
0_Nn1Kgg0/HH0U[[0U[;00<@XP0P02000P000QS300<Q124T8B@012U50RUU0c660YBB0^LL0_NN0ooo
1=JJ00?>NF]]Jfd00QSS100000<080QQ26400Q2R0QSS0R4400=kkg_?Nll00]JJ0_oO00?oonLLia`0
0Xaa0S660R4T00<0800000000QSS0R4T0RU500>4<=kKg]/02_oo0009ool2oml00ooog__Nn`02Q302
S5400bUU0200800200026<<2Jfd00liIg]_Nf`02oml2ool2oml00lHHF^]Jj`024:8200000`Q1488@
PP024:82Jdd2cUT00mJjomoog`02ool2ia`2g_/00mkKe[[F^P02Ljh28B@30002244248826<<00aSS
Ljic[P02eYX2oml2ool00nLlS76<L@02<HH2020200000`0P2648H@02DXX2]KH00oNNooooo`02ool2
cWT5Jfd2Lhh28@@248830005ool2oml00ooog__Nn`02Q302S542:FD00`0P000000026<<2Jfd00liI
g]_Nf`02oml2ool2oml00lHHF^]Jj`024:82000224400a224:8@XP02Jdd2cUT00mJjomoog`02ool2
ia`2g_/00mkKe[[F^P02Ljh28B@30002244248826<<00aSSLjic[P02eYX2oml2ool00nLlS76<L@02
<HH2020200000`0P2648H@02DXX2]KH00oNNooooo`02ool2cWT5Jfd2Lhh28@@24883000:ool000Wo
o`;og`03oooNnmkk00:4<0:<D@03:FD0800P0080008H``9[K@03cUWNfmkK00;og`;oo`;og`03aQQJ
je[[008@XP800003244@PQ22008@XP9[C@;>F@03e[[ogooO00;oo`;W70;Nn`03g]_F^]Jj009c[P8Q
90<00088@@8@PP8H``036>=c[W>^00;FVP;og`;oo`03icb<LHaa008aQP80808000030208H@QQ009B
RP:e]P03mikooooo00;oo`;>N@E[K@9cSP8Q108@PP<000Goo`;og`03oooNnmkk00:4<0:<D@8YI@03
02000000008H``9[K@03cUWNfmkK00;og`;oo`;og`03aQQJje[[008@XP800088@@03488@XQ2R009[
C@;>F@03e[[ogooO00;oo`;W70;Nn`03g]_F^]Jj009c[P8Q90<00088@@8@PP8H``036>=c[W>^00;F
VP;og`;oo`03icb<LHaa008aQP80808000030208H@QQ009BRP:e]P03mikooooo00;oo`;>N@E[K@9c
SP8Q108@PP<000[oo`002Ooo0R4T00<YAHaAS5400]kK0_oO00?ooooOoml00_NN0^mM0^LL00><LC66
<HH00R440Q220`000RU50RUU0c660YBB0^LL0_NN0_oo00?ogliicWT00/ii16]=00<Hh`QQ26400P00
0Q220QS300<Hhg>^Ljh00]JJ0]kk00?ogoooool00_Nn0_NN0^mM00?W7=kkg_/00X@@0RU50P0P00<0
000P02000PQQ0Q2R00<H`b448@@00W_?0]JJ0^LL00?gW_ooool00_oO0_Nn0^mm00?W?=kkg_/01Ooo
0R4T00<YAHaAS5400]kK0_oO0_oo00?ogoNNmih00^mM0^LL00><LC66<HH00R440Q220`000RU50RUU
136600>DT^LLia`00_NN0_oo00?ogliicWT00/ii16]=00<Hh`QQ26400P000Q220QS300<Hhg>^Ljh0
0]JJ0]kk00?ogoooool00_Nn0_NN0^mM00?W7=kkg_/00X@@0RU50P0P00<0000P02000PQQ0Q2R00<H
`b448@@00W_?0]JJ0^LL00?gW_ooool00_oO0_Nn0^mm00?W?=kkg_/02_oo0009ool28B@00bU5S56<
D@02g]/2oml00oooomoog`02mih2ked2ia`00haa<HHaQP028@@248830002:DD2:FD3<HH2U982ia`2
mih2ool00ooOcWW>N@02cWT4Jdd00aSS2648H@02000248826<<00aSSLjic[P02eYX2g_/00ooOoooo
o`02mkh2mih2ked00nLLg__Nn`02Q102:DD202000`000200800226424:800aS38@@Q1002Nll2eYX2
ia`00oNNooooo`02oml2mkh2kgd00nLlg__Nn`05ool28B@00bU5S56<D@02g]/2oml2ool00ooOmikg
WP02ked2ia`00haa<HHaQP028@@248830002:DD2:FD4<HH00iBBiacW7002mih2ool00ooOcWW>N@02
cWT4Jdd00aSS2648H@02000248826<<00aSSLjic[P02eYX2g_/00ooOooooo`02mkh2mih2ked00nLL
g__Nn`02Q102:DD202000`000200800226424:800aS38@@Q1002Nll2eYX2ia`00oNNooooo`02oml2
mkh2kgd00nLlg__Nn`0:ool000Woo`:4<003:FD0800P0080008Q10038BB4<8@`00:440;F^P;og`03
oooogooO00;6609Jj`8@XP<000@YA@03S57Nnmkk00;_O@Coo`?FVP;>N@E[K@8Hh`@0008Q1003NnoF
^]Jj00;og`;oo`03mkk_ONmm00;W?0;W70;Nn`03g]_F^]Jj00;FVP9cSP8Q10<0008080<ii`:U50:U
=0;_G@?oo`;F^P;FVPC>N@=[K@Goo`:4<003:FD0800P0080008Q108Q9003Q32448@@00;F^P;og`03
oooogooO00;6609Jj`8@XP<000@YA@:<D@03g___ONmm00Coo`?FVP;>N@E[K@8Hh`@0008Q1003NnoF
^]Jj00;og`;oo`03mkk_ONmm00;W?0;W70;Nn`03g]_F^]Jj00;FVP9cSP8Q10<0008080<ii`:U50:U
=0;_G@?oo`;F^P;FVPC>N@=[K@[oo`002Ooo0X@`00<YI@0P02000P000R4400<Q98@`Q3000X@@0]Jj
0_oO00?ooooOoml00/HH0U[[0Q2R0`0012U500><DMkkg_/00^mm1?oo0mJJ0/ii1F]]0QSS10000R44
00=kkmJje[X00_oO0_oo00?g_^mmkgd00^Ll0^LL0]kk00?NfmJje[X00]JJ0W>>0R440`000P0P0cWW
0ZDD0ZDd0^mM0ooo0]Jj0]JJ1<ii0f]]1Ooo0X@`00<YI@0P02000P000R440R4T00>4<8@@Q1000]Jj
0_oO00?ooooOoml00/HH0U[[0Q2R0`0012U50XaA00?Nnnmmkgd01?oo0mJJ0/ii1F]]0QSS10000R44
00=kkmJje[X00_oO0_oo00?g_^mmkgd00^Ll0^LL0]kk00?NfmJje[X00]JJ0W>>0R440`000P0P0cWW
0ZDD0ZDd0^mM0ooo0]Jj0]JJ1<ii0f]]2_oo0009ool26><00`QQ0000000200022443@RP2[ED2[GD2
kgd00ooomikgWP02[GD2]IH2BVT00a220000000200020205@PP2>NL2YA@00jDd[EF]E@02ked4ool0
0mJJLjic[P04Ljh28B@300026><28B@00h@@Nnmkk`02Nll2eYX2oml00oooomoog`02mih2[ED2BTT0
0d882648H@02000248800e[[_ONmm`02cUT2e[X2oml00oooomoog`02aQP2F^/26<<00`0P00000005
ool26><00`QQ0000000200022443@RP2[ED2[GD2kgd00ooomikgWP02[GD2]IH2BVT00a2200000002
00020205@PP2>NL2YA@00jDd[EF]E@02ked4ool00mJJLjic[P04Ljh28B@300026><28B@00h@@Nnmk
k`02Nll2eYX2oml00oooomoog`02mih2[ED2BTT00d882648H@02000248800e[[_ONmm`02cUT2e[X2
oml00oooomoog`02aQP2F^/26<<00`0P0000000:ool000Woo`8H``036><Q1244009kk`;F^P03omoo
oooo00;og`C66003F^/H`aS300@0008Q9003:DF<DHaA00:<D@;Nf`?og`;g_P:eUP>e]P9BRP9:J@9:
B@88H@<00088@@9:B@:]M@03kggogooO00;oo`;g_P03mik_GNmM00;W70;Nn`;Nf`03e[[FV]JJ00;F
VPC>N@03cUU[CF]=008Hh`88H@<00088@@8@PP8H``036><Q1244008Q90:4<0:44003g]__GNmM00Go
o`8H``036><Q1244009kk`;F^P;og`03oooogooO00C66003F^/H`aS300@0008Q9003:DF<DHaA00:<
D@;Nf`?og`;g_P:eUP>e]P9BRP9:J@9:B@88H@<00088@@9:B@:]M@03kggogooO00;oo`;g_P03mik_
GNmM00;W70;Nn`;Nf`03e[[FV]JJ00;FVPC>N@03cUU[CF]=008Hh`88H@<00088@@8@PP8H``036><Q
1244008Q90:4<0:44003g]__GNmM00[oo`002Ooo0QS300<Hhb448@@00W__0]Jj00?ogoooool00_oO
1<HH00=JjaS36<<010000R4T00<YAHaAS5400XaA0]kK0ooO0_Nn0[FF0kFf0U::0TYY0TY90PQQ0`00
0PQ10TY90Zee00?_OOoOoml00_oo0_Nn00?gW^mMked00^LL0]kk0]kK00?F^]JJeYX00]JJ1<ii00?>
FF]=Jdd00QSS0PQQ0`000PQ10Q220QS300<Hhb448@@00R4T0X@`0X@@00?NfnmMked01Ooo0QS300<H
hb448@@00W__0]Jj0_oO00?ooooOoml01<HH00=JjaS36<<010000R4T00<YAHaAS5400XaA0]kK0ooO
0_Nn0[FF0kFf0U::0TYY0TY90PQQ0`000PQ10TY90Zee00?_OOoOoml00_oo0_Nn00?gW^mMked00^LL
0]kk0]kK00?F^]JJeYX00]JJ1<ii00?>FF]=Jdd00QSS0PQQ0`000PQ10Q220QS300<Hhb448@@00R4T
0X@`0X@@00?NfnmMked02_oo000<ool2e[X4eYX3cWT6cUT3Hb`26<<2244200000a226<<H``026><2
8B@00bU5Q324<002Q302g]/2ked3ool2mkh2kgd2YA@00d882648H@04000224400a22F^]Jj`02_OL2
mih00oooomoog`02cWT5cUT2aSP2Hb`26<<30002020226424:800aSS8@@Q10028B@4Q1000g__e[[F
^P02ic`4ool00oNn_MNme`08ool2e[X4eYX3cWT6cUT3Hb`26<<2244200000a226<<H``026><28B@2
:DD3Q302g]/2ked3ool2mkh2kgd2YA@00d882648H@04000224400a22F^]Jj`02_OL2mih00oooomoo
g`02cWT5cUT2aSP2Hb`26<<30002020226424:800aSS8@@Q10028B@4Q1000g__e[[F^P02ic`4ool0
0oNn_MNme`0:ool000coo`;F^PCFVP?>N@K>F@=S;08H``88@@800003488H`aS3008Hh`8Q9003:DF4
<8@`00:4<0;Nf`;_G@?oo`;g_P;_O@:U5003@PP8H@QQ00@00088@@03489Jje[[00:mm`;gWP03oooo
gooO00;>N@G>F@;6>09S;08H``<000808088H@8@XP036><Q1244008Q90B44003NnoF^]Jj00;W?0Co
o`03mkjmekgG00Soo`;F^PCFVP?>N@K>F@=S;08H``88@@800003488H`aS3008Hh`8Q908YA@>4<0;N
f`;_G@?oo`;g_P;_O@:U5003@PP8H@QQ00@00088@@03489Jje[[00:mm`;gWP03oooogooO00;>N@G>
F@;6>09S;08H``<000808088H@8@XP036><Q1244008Q90B44003NnoF^]Jj00;W?0Coo`03mkjmekgG
00[oo`002Ooo0U:Z00<@XP0P02000P000P0P1cWW0Ycc00>U5:DdYC@00^mM1?oo00?g_^mmkgd00^Ll
0^LL00?NnmkKg]/00W_?0W__0R4T00<0800000000P0P0PQQ0Q2R00<H`b448@@00W_?0]JJ0_oO00?o
ooNnmkh00^mm0^mM00>D/YcCW=<00SW70PQ10P0000<@XQS36<<00W>>0/ii0_Nn00?ooooOoml00_NN
0^mM00?W?8aaS7400S660P0P0P0000<083W7>LL00SW70Ycc0^Ll2?oo0U:Z00<@XP0P02000P000P0P
1cWW0Ycc00>U5:DdYC@00^mM1?oo00?g_^mmkgd00^Ll0^LL0]kk00?Nfg_?Nll00W__0R4T00<08000
00000P0P0PQQ0Q2R00<H`b448@@00W_?0]JJ0_oO00?oooNnmkh00^mm0^mM00>D/YcCW=<00SW70PQ1
0P0000<@XQS36<<00W>>0/ii0_Nn00?ooooOoml00_NN0^mM00?W?8aaS7400S660P0P0P0000<083W7
>LL00SW70Ycc0^Ll3Ooo0009ool2DZX00a2R0200800200020207>NL2W?<00jDDYCBU=002ked4ool0
0oNnkgg_O@02ic`2ia`00mkkg]_Nf`02Nll2Nnl28B@00`0P00000002020226424:800aS38@@Q1002
Nll2eYX2oml00ooomkkg_P02kgd2ked00iBbW=>Ld`02>LL2244200000a2R6<<H``02Lhh2cWT2mkh0
0oooomoog`02mih2ked00nLlS76<L@02<HH2020200000`0P>LLia`02>LL2W?<2ic`8ool2DZX00a2R
0200800200020207>NL2W?<00jDDYCBU=002ked4ool00oNnkgg_O@02ic`2ia`2g_/00mkKNlmkc`02
Nnl28B@00`0P00000002020226424:800aS38@@Q1002Nll2eYX2oml00ooomkkg_P02kgd2ked00iBb
W=>Ld`02>LL2244200000a2R6<<H``02Lhh2cWT2mkh00oooomoog`02mih2ked00nLlS76<L@02<HH2
020200000`0P>LLia`02>LL2W?<2ic`=ool000Woo`?F^P;FVPC>N@O>F@;6>003Hb`H`aS30088@@@0
0003244@PQ22008H``9[K@03JdeS;6</00AS309Jj`03_OOgW_NN00;oo`;og`;gWP03kgfLlicc008i
i`88@@<00088@@8@PP8H``036><Q1244008Q908YA@:<D@03g]_ogooO00;oo`;og`;gWP03kegW7>LL
00B<L@03U98aYS6V0088@@8000808003264@XQ2R008H``8Q109kc`03eY[W7>LL00Goo`?F^P;FVPC>
N@O>F@;6>003Hb`H`aS30088@@@00003244@PQ22008H``9[K@9[C@03HbaS36<<009S309Jj`03_OOg
W_NN00;oo`;og`;gWP03kgfLlicc008ii`88@@<00088@@8@PP8H``036><Q1244008Q908YA@:<D@03
g]_ogooO00;oo`;og`;gWP03kegW7>LL00B<L@03U98aYS6V0088@@8000808003264@XQ2R008H``8Q
109kc`03eY[W7>LL00[oo`003?oo0]kK0]Jj0g_?0W__0R4T0P0P0P0000<8@A2248800U[;0[gg0_NN
00?ooooOoml00_NN0^mm00>LlcWW>NL00PQ10P000Q2200<@XV]=Jdd00/iI0]Jj0_oO00?ooooOoml0
0_NN0^mM0YcC00<ia`Q1244010000c6V0YBb0YcC0^LL0ooo0_Nn0^mm0^mM00?W7=kkg_/00]kK0]Jj
00=c[W_?Nll00R4T0Q2R0`000PQ10Q220Q2R0QSS00=c[W>>Lhh02?oo0]kK0]Jj17_?00=kkb4T8B@0
0P0P0P0000<8@A2248800U[;0[gg0_NN00?ooooOoml00_NN0^mm0Ycc00<ii`Q124400P000Q2200<@
XV]=Jdd00/iI0]Jj0_oO00?ooooOoml00_NN0^mM0YcC00<ia`Q1244010000c6V0YBb0YcC0^LL0ooo
0_Nn0^mm0^mM00?W7=kkg_/00]kK0]Jj00=c[W_?Nll00R4T0Q2R0`000PQ10Q220Q2R0QSS00=c[W>>
Lhh02_oo000<ool2g]/2e[X3Nll2Nnl28B@2020200000`Q1488@PP02F//2_OL2mih00oooomoog`02
mih2kgd00icc>NLii`022442000248800a2RJde[C@02cUT2e[X2oml00oooomoog`02mih2ked2W=<0
0cW72448@@040003<JH2U;82W=<2ia`3ool2mkh2kgd2ked00nLLg__Nn`02g]/2e[X00g>^Nlmkc`02
8B@24:830002244248824:826><00g>^LhicSP08ool2g]/2e[X4Nll00g__8B@Q9002020200000`Q1
488@PP02F//2_OL2mih00oooomoog`02mih2kgd2W?<00cWW2448@@02000248800a2RJde[C@02cUT2
e[X2oml00oooomoog`02mih2ked2W=<00cW72448@@040003<JH2U;82W=<2ia`3ool2mkh2kgd2ked0
0nLLg__Nn`02g]/2e[X00g>^Nlmkc`028B@24:830002244248824:826><00g>^LhicSP0:ool000Wo
o`9[K@03cUWNfmkK00;og`;oo`03mkk_ONmm00:U50922088H@<0008aQP:D/P;W70?oo`;g_P:mm`03
F//@XQ2R00808080008080<ia`:Ll`;W?0;g_P03oooogooO00;gWP;_G@;W?003S74aQS66008Q908@
XP<00088@@8@PP=Jb`:me`;gWP;oo`;og`03mkk_ONmm00;W?0;W7003Q30YIBUU00808080008H``03
8@@Q924T00@YA@:<D@03g__ogooO00Goo`9[K@03cUWNfmkK00;og`;oo`;g_P03kgfU5:DD00922088
H@<0008aQP:D/P;W70?oo`;g_P:mm`9Jb`034:80800P0080008080<ia`:Ll`;W?0;g_P03oooogooO
00;gWP;_G@;W?003S74aQS66008Q908@XP<00088@@8@PP=Jb`:me`;gWP;oo`;og`03mkk_ONmm00;W
?0;W7003Q30YIBUU00808080008H``038@@Q924T00@YA@:<D@03g__ogooO00[oo`002Ooo0V]]00?>
FMkKg]/00_oO0_oo00?g_^mmkgd00ZDD0T880PQQ0`000S660YBb0^LL0ooo0_Nn0[gg00=Jba2R4:80
0P0P0P000P0P0cW70Ycc0^Ll0_Nn00?ooooOoml00_NN0^mM0^Ll00><LC66<HH00R4T0Q2R0`000PQ1
0Q220e[;0[gG0_NN0_oo0_oO00?g_^mmkgd00^Ll0^LL00>4<2UU:FD00P0P0P000QS300<Q124T8B@0
12U50XaA00?NnooOoml01Ooo0V]]00?>FMkKg]/00_oO0_oo0_Nn00?_OJDDYA@00T880PQQ0`000S66
0YBb0^LL0ooo0_Nn0[gg0U[;00<@XP0P02000P000P0P0cW70Ycc0^Ll0_Nn00?ooooOoml00_NN0^mM
0^Ll00><LC66<HH00R4T0Q2R0`000PQ10Q220e[;0[gG0_NN0_oo0_oO00?g_^mmkgd00^Ll0^LL00>4
<2UU:FD00P0P0P000QS300<Q124T8B@012U50XaA00?NnooOoml02_oo000;ool00mkkg]_Nf`02Nnl2
8B@00`0P0000000202022642DZX00kFf_ONmm`02mih4ool00oNnkgg_O@02ic`2U9800c6V2448@@02
00024:826><00b448B@Q9004Q102e[X00ooOooooo`02oml2mih2[ED3[GD2BTT248800`0002008002
26424:826<<00g>>cWW>N@02g]/2oml2ool00mkkg]_Nf`02Nnl2Q1000bU50200800200020202>NL0
0iccYABU5004YC@2ked:ool00mkkg]_Nf`02Nnl28B@202000`00020080022642DZX00kFf_ONmm`02
mih4ool00oNnkgg_O@02ic`2U982<JH00`Q1000000024:826><00b448B@Q9004Q102e[X00ooOoooo
o`02oml2mih2[ED3[GD2BTT248800`000200800226424:826<<00g>>cWW>N@02g]/2oml2ool00mkk
g]_Nf`02Nnl2Q1000bU50200800200020202>NL00iccYABU5004YC@2ked=ool000_oo`03g__NfmkK
009kk`8Q90030200000000808088H@9BZP03]KJmmkgg00;gWPCoo`03mkk_ONmm00;W?0:DTP03<JH8
@@Q10080008@XP8Hh`038@@Q924T00B440;F^P03omoooooo00;og`;gWP:]E@>]M@9:B@8@PP030000
800P0088H@8@XP8H``03Lhk>NLii00;Nf`;og`;oo`03g__NfmkK009kk`:44003:DD0800P00800080
808ii`03W?>U5:DD00BU=0;_G@[oo`03g__NfmkK009kk`8Q908080030000800P0088H@9BZP03]KJm
mkgg00;gWPCoo`03mkk_ONmm00;W?0:DTP8aYP0324400000008@XP8Hh`038@@Q924T00B440;F^P03
omoooooo00;og`;gWP:]E@>]M@9:B@8@PP030000800P0088H@8@XP8H``03Lhk>NLii00;Nf`;og`;o
o`03g__NfmkK009kk`:44003:DD0800P00800080808ii`03W?>U5:DD00BU=0;_G@goo`002Ooo0_Nn
00>mee:ZDZX00Q220`000PQ10Q220U[[0U[;00>meoNNmih00_oo0_oO0_Nn00>eU[Ff]KH00[Ff0[gG
00=BRQ2248800P000PQ10Q2200<H`f]]Jfd00V]=0/iI0]Jj00?ogoooool00_oO1<HH0e[[0Q2R0`00
0PQ10Q220U[;0[gg00?gW_ooool00_oO0_Nn0^mm00?W?=kkg_/00]kK0mJj0]JJ1<ii0V]=0f]]0QSS
100000<080QQ26401Ooo0_Nn00>mee:ZDZX00Q22100000<8@A2248800U[[0U[;00>meoNNmih00_oo
0_oO0_Nn00>eU[Ff]KH00[Ff0[gG0U::00<@PP0000000PQ10Q2200<H`f]]Jfd00V]=0/iI0]Jj00?o
goooool00_oO1<HH0e[[0Q2R0`000PQ10Q220U[;0[gg00?gW_ooool00_oO0_Nn0^mm00?W?=kkg_/0
0]kK0mJj0]JJ1<ii0V]=0f]]0QSS100000<080QQ26402_oo0009ool24:800aSS8@@Q1002Nnl2e[X0
0nLLooooo`02ool2mkh2kgd00jDd@PQ220022642000248800e[[F/]Jb`02DZX3DXX2BVT2]IH2kgd2
ool00oNNkeg_G@02W=<2W?<2>NL00`Q1000000020002244248800e[[aQS66002mih2ool00nmMiccW
?002U982<HH224400`0002008002>LL2W?<2ic`00oNnooooo`02ked2ia`00mkkQ1244002:DD26<<2
00000`0P>NLii`06>NL3YA@5ool24:800aSS8@@Q1002Nnl2e[X2ia`3ool2mkh2kgd00jDd@PQ22002
2642000248800e[[F/]Jb`02DZX4DXX00dYY]IJeUP02kgd2ool00oNNkeg_G@02W=<2W?<2>NL00`Q1
000000020002244248800e[[aQS66002mih2ool00nmMiccW?002U982<HH224400`0002008002>LL2
W?<2ic`00oNnooooo`02ked2ia`00mkkQ1244002:DD26<<200000`0P>NLii`06>NL3YA@:ool000Wo
o`8@XP036><Q1244009kk`;F^P03iacooooo00;oo`;g_P;_O@03YCA224880088H@80008@PP03F^]J
be[;009BZP=BRP9:J@:eUP;_O@;oo`03mik_GNmM00:Ld`:Ll`8ii`032440000000800088@@8@PP03
F^_66<HH00;gWP;oo`03kegW?>Ll00:DTP8aQP88@@030000800P008ia`:Ll`;W?003mkkooooo00;_
G@;W7003g_^448@@008YA@8H``800003020iicWW00Hii`>U50Goo`8@XP036><Q1244009kk`;F^P;W
70?oo`;g_P;_O@03YCA224880088H@80008@PP03F^]Jbe[;009BZPABRP03BVVeU[FF00;_O@;oo`03
mik_GNmM00:Ld`:Ll`8ii`032440000000800088@@8@PP03F^_66<HH00;gWP;oo`03kegW?>Ll00:D
TP8aQP88@@030000800P008ia`:Ll`;W?003mkkooooo00;_G@;W7003g_^448@@008YA@8H``800003
020iicWW00Hii`>U50[oo`002Ooo0^mM0ooo0_Nn0[gG00=BZU::DXX00TY90T8X0SWW00<aQR4T8B@0
0P0P0P000P0P00<iijDDYA@00^Ll0_Nn00?ooooOoml00/Hh0V<<0QS300<0000P020014880ZDd00?_
GOoOoml00_oo0^LL0Xaa00>DTS6V<JH00PQ10P0000<080QQ26400Q220QS30f]]0/iI0_Nn0_oo0^Ll
00>D/YcCW=<00SW70PQ100<0000P02000PQ10Q220QS300<Hhb4T8B@00RU50X@`0]kK00?ogoooool0
1Ooo0^mM0ooo0_Nn0[gG0U:Z00=BRTY9BTT00T8X0SWW00<aQR4T8B@00P0P0P000P0P00<iijDDYA@0
0^Ll0_Nn0_oo00?oglHhaSP00V<<0QS300<0000P020014880ZDd00?_GOoOoml00_oo0^LL0Xaa00>D
TS6V<JH00PQ10P0000<080QQ26400Q220QS30f]]0/iI0_Nn0_oo0^Ll00>D/YcCW=<00SW70PQ100<0
000P02000PQ10Q220QS300<Hhb4T8B@00RU50X@`0]kK00?ogoooool02_oo0009ool2ked3ool2mkh2
_ML00e:ZDXYBRP02BTT2@RP2>NL00c668B@Q90020202000202000cWWYABU5002ic`2mkh00oooomoo
g`02aSP2H``26<<00`0002008004@PP2YC@00nmMomoog`02ool2ia`2S7400iBB<JHaYP0224420000
0`0P2648H@0248826<<3Jfd2cUT2mkh2ool2ic`00iBbW=>Ld`02>LL224400`000200800224424882
6<<00aSS8B@Q9002:DD2Q302g]/00ooOooooo`05ool2ked3ool2mkh2_ML2DZX00e::BTU:B@02@RP2
>NL00c668B@Q90020202000202000cWWYABU5002ic`2mkh2ool00ooOaSS6>002H``26<<00`000200
8004@PP2YC@00nmMomoog`02ool2ia`2S7400iBB<JHaYP02244200000`0P2648H@0248826<<3Jfd2
cUT2mkh2ool2ic`00iBbW=>Ld`02>LL224400`0002008002244248826<<00aSS8B@Q9002:DD2Q302
g]/00ooOooooo`0:ool000Woo`;og`03aQQJje[[008@XP<0008YA@B4<0;Nf`03kegooooo00;g_P;_
O@;W?003iab<DHaA008YI@8080030000800P00Hia`03W??W?>Ll00;g_P;oo`;_G@03iacNnmkk00:4
40:4<08YI@0302000000008Q90:44003Nnmkcg_?00;FVP;og`;oo`03omogW_NN00;_G@;W70:<L@03
U98aYS6V0088@@800003020aYS6V00@ia`:Ld`03iccooooo00;g_P;_O@:U=003[EF]MJee00Goo`;o
g`03aQQJje[[008@XP@00003:DF4<8@`00:4<0;Nf`03kegooooo00;g_P;_O@;W?003iab<DHaA008Y
I@8080800003020iacW700@ia`03W??W?>Ll00;g_P;oo`;_G@03iacNnmkk00:440:4<08YI@030200
0000008Q90:44003Nnmkcg_?00;FVP;og`;oo`03omogW_NN00;_G@;W70:<L@03U98aYS6V0088@@80
0003020aYS6V00@ia`:Ld`03iccooooo00;g_P;_O@:U=003[EF]MJee00[oo`002Ooo0_oO00?665[[
F^/00Q2R0`000RU518@`0]kK00?_GOooool00_Nn0^mm0^Ll00?W78aAS5400RUU0P0P00<0000P0200
1SW700>LlnLlic`00_Nn0_oo0^mM00?W7=kkg_/00X@@0X@`0RUU00<0800000000R4T0X@@00=kkg_?
Nll00]JJ0_oO0_oo00?ogoNNmih00^mM0^LL0Xaa00>DTS6V<JH00PQ10P0000<0836V<JH013W70YcC
00?W??ooool00_Nn0^mm0ZDd00>]EJee[GD01Ooo0_oO00?665[[F^/00Q2R100000<YAH@`Q3000X@`
0]kK00?_GOooool00_Nn0^mm0^Ll00?W78aAS5400RUU0P0P0P0000<083W7>LL013W700>LlnLlic`0
0_Nn0_oo0^mM00?W7=kkg_/00X@@0X@`0RUU00<0800000000R4T0X@@00=kkg_?Nll00]JJ0_oO0_oo
00?ogoNNmih00^mM0^LL0Xaa00>DTS6V<JH00PQ10P0000<0836V<JH013W70YcC00?W??ooool00_Nn
0^mm0ZDd00>]EJee[GD02_oo0009ool2BTT00`QQ0000000200028B@00bU5:FDYI@02S742g_/2oml0
0ooog__Nn`02g]/2Nll2Nnl00bU50200800200026><00b448B@Q9002Q302g]/2oml00ooomkkg_P02
kgd2YA@2YC@00d88>LLia`02:FD2020200000aS3Jfe[K@02cUT2g]/00ooOooooo`02mkh2kgd2YA@0
0d882648H@04000224400a226<<H``026><2Nll00mJJg__Nn`04ool2mkh00nmmkeg_G@02ia`2g_/2
Q1000h@`:FDYI@05ool2BTT00`QQ0000000200028B@2:DD00bUUS76<L@02g_/2oml00ooog__Nn`02
g]/2Nll2Nnl00bU50200800200026><28@@00b4TQ324<002g]/2oml00ooomkkg_P02kgd2YA@2YC@0
0d88>LLia`02:FD2020200000aS3Jfe[K@02cUT2g]/00ooOooooo`02mkh2kgd2YA@00d882648H@04
000224400a226<<H``026><2Nll00mJJg__Nn`04ool2mkh00nmmkeg_G@02ia`2g_/2Q1000h@`:FDY
I@0:ool000Woo`8080030000800P00A22003YCC_GNmM00;oo`;g_P;_O@03YAA22488008aYP8YA@80
80030008@@Q1009220:U=003kegogooO00;oo`;W70:<D@03S74aQS66008Q90@000030208H@QQ008@
XP8H``9cSP03Jfg>FLiI00;g_P;oo`03omogW_NN00:]E@9:B@9220032640000000800088@@9:J@03
]IK_ONmm00Coo`03eY[>NLii00;>N@;>F@9[C@036><000000080008080922003YCB]EJeE00Goo`80
80030000800P00A220:U=003kegooooo00;g_P;_O@03YAA22488008aYP8YA@8080030008@@Q10092
20:U=0;_G@03omoooooo00;W70:<D@03S74aQS66008Q90@000030208H@QQ008@XP8H``9cSP03Jfg>
FLiI00;g_P;oo`03omogW_NN00:]E@9:B@9220032640000000800088@@9:J@03]IK_ONmm00Coo`03
eY[>NLii00;>N@;>F@9[C@036><000000080008080922003YCB]EJeE00[oo`002Ooo0P0P00<0000P
0200148800>U=>mMked00_oo0_Nn0^mm00>U5488@PP00S6V0RU50P0P00<000Q124400T880ZDd00?_
GOoOoml00_oo0^LL0XaA00><LC66<HH00R4T100000<080QQ26400Q2R0QS30W>>00=[KLiIcUT00_Nn
0_oo00?ogoNNmih00ZeE0TY90T8800<8H@0000000P000PQ10TYY00>eU^mmkgd01?oo00?FV/iicWT0
0/ii0/iI0V]=00<Hh`0000000P000P0P0T8800>U=:eE[ED01Ooo0P0P00<0000P020014880ZDd00?_
GOooool00_Nn0^mm00>U5488@PP00S6V0RU50P0P00<000Q124400T880ZDd0^mM00?ogoooool00^LL
0XaA00><LC66<HH00R4T100000<080QQ26400Q2R0QS30W>>00=[KLiIcUT00_Nn0_oo00?ogoNNmih0
0ZeE0TY90T8800<8H@0000000P000PQ10TYY00>eU^mmkgd01?oo00?FV/iicWT00/ii0/iI0V]=00<H
h`0000000P000P0P0T8800>U=:eE[ED02_oo0009ool2ked00ooOooooo`02ia`3S542S742<HH20202
00000`0P>LLia`02>LL2W=<3W?<2ic`2ool2mkh00nmmkeg_G@02ia`2S542S7400iBB<JHaYP022442
000202000`QQDXYBRP02]KH2kgd3ool2mkh2kgd2YC@00d882648H@02000248826<<00aSS8@@Q1002
Nnl2Nll2eYX00ooOooooo`02ia`2S7400c66020080020002020226400a2RH`aS3002aQP2mkh2ool0
0ooOcUW>F@05ool2ked00ooOooooo`02ia`4S5400haa<HHaQP02020200000`0P>LLia`02>LL2W=<3
W?<2ic`2ool2mkh2kgd00nmMiacW7002S542S7400iBB<JHaYP022442000202000`QQDXYBRP02]KH2
kgd3ool2mkh2kgd2YC@00d882648H@02000248826<<00aSS8@@Q1002Nnl2Nll2eYX00ooOooooo`02
ia`2S7400c66020080020002020226400a2RH`aS3002aQP2mkh2ool00ooOcUW>F@0:ool000Woo`;_
G@03omoooooo00;W70><D@:<L@8aQP8080800003020iacW7008ia`:Ld`>Ll`;W?0;oo`;g_P03kgg_
GNmM00;W70:<D@:<L@03U98aYS6V0088@@8000808003265BRU::00:e]P;_O@?oo`;g_P;_O@:U=003
@PP8H@QQ0080008@PP8H``036><Q1244009kk`9kc`;FVP03omoooooo00;W70:<L@03<HH0800P0080
00808088H@034:9S36<<00;660;g_P;oo`03omo>FLiI00Goo`;_G@03omoooooo00;W70B<D@03S74a
QS66008080800003020iacW7008ia`:Ld`>Ll`;W?0;oo`;g_P;_O@03kegW7>LL00:<D@:<L@03U98a
YS6V0088@@8000808003265BRU::00:e]P;_O@?oo`;g_P;_O@:U=003@PP8H@QQ0080008@PP8H``03
6><Q1244009kk`9kc`;FVP03omoooooo00;W70:<L@03<HH0800P008000808088H@034:9S36<<00;6
60;g_P;oo`03omo>FLiI00[oo`002Ooo0V]=00<Hh`QQ26400P000Q2200=JjlHHaQP00_NN0_oo0^mM
00?W?9BBU9800YBB0YBb0SW700<8@@0000000P0P0PQ100<@PQS36<<00QSS0W_?0W>^00?FV]kkg_/0
0^mm1?oo00?g_^mmkgd00^Ll0^LL0]kK0mJj0W>^0R440`000P0P13WW00>U5:DdYC@00ZeE0^mM0ooo
0_Nn0^mm0ZDD00>U=488@PP00PQQ100000<aQYBBU9800^LL0_NN0_oo00?ogliicWT01Ooo0V]=00<H
h`QQ26400P000Q220U[[00?66?NNmih00_oo0^mM00?W?9BBU9800YBB0YBb0SW700<8@@0000000P0P
0PQ10Q2200<H`aSS6><00W_?0W>^00?FV]kkg_/00^mm1?oo00?g_^mmkgd00^Ll0^LL0]kK0mJj0W>^
0R440`000P0P13WW00>U5:DdYC@00ZeE0^mM0ooo0_Nn0^mm0ZDD00>U=488@PP00PQQ100000<aQYBB
U9800^LL0_NN0_oo00?ogliicWT02_oo0009ool2Jdd00aSS2648H@02000248800e[[aQS66002mih2
ool2ked00nLlU9:DTP02U982U;82>LL00`Q100000002020224400a226<<H``026><2Nll2Ljh00mJJ
g__Nn`02kgd4ool00oNnkgg_O@02ic`2ia`2g]/3e[X2Ljh28@@300020204>NL00jDDYCBU=002[ED2
ked3ool2mkh2kgd2YA@00jDd@PQ22002264400000c66U9:DTP02ia`2mih2ool00ooOcWW>N@05ool2
Jdd00aSS2648H@0200024882F^/00lHHmikgWP02ool2ked00nLlU9:DTP02U982U;82>LL00`Q10000
00020202244248800aS36><Hh`02Nll2Ljh00mJJg__Nn`02kgd4ool00oNnkgg_O@02ic`2ia`2g]/3
e[X2Ljh28@@300020204>NL00jDDYCBU=002[ED2ked3ool2mkh2kgd2YA@00jDd@PQ2200226440000
0c66U9:DTP02ia`2mih2ool00ooOcWW>N@0:ool000Woo`;>N@03cUU[CF]=008Hh`88H@<00088@@9:
B@92:003[GG_GNmM00Coo`;g_P03kgfU5:DD00:U=0922003>LLYIBUU0080808000808003265BRU::
00:e]P:mm`;6>003mkkooooo00;og`;gWP;_G@03iccNnmkk00;Nf`9kk`03:DD0800P00800088@@8@
PP034:8HhaSS008Q108Q90:4<003g]_ogooO00;oo`;og`03aQQJje[[009Jb`8@XP<00088@@92:0:]
E@;_G@Soo`;>N@03cUU[CF]=008Hh`88H@<00088@@9:B@92:003[GG_GNmM00Coo`;g_P03kgfU5:DD
00:U=092208ia`03:FD0800P008000808003265BRU::00:e]P:mm`;6>003mkkooooo00;og`;gWP;_
G@03iccNnmkk00;Nf`9kk`03:DD0800P00800088@@8@PP034:8HhaSS008Q108Q90:4<003g]_ogooO
00;oo`;og`03aQQJje[[009Jb`8@XP<00088@@92:0:]E@;_G@goo`002Ooo0]JJ00=c[R448@@00Q22
0`000R440W_?0]JJ0_oO00?oomkKg]/00]Jj1=JJ00?>NF]]Jfd00V]]0QSS0`000P0P0PQQ0Q2R00<H
hb448@@00R4T0X@@0]kK00?ogoooool00_Nn0^mm0^Ll00?W7=kkg_/018@@00<YAASS6><00P000P0P
0SWW0jDD0^Ll0_Nn0_oo00?ogoNNmih00ZeE0Zee00=:BD88@PP00PQQ0P000PQQ0e::0TYY0[FF0[gG
00?66?NNmih01Ooo0]JJ00=c[R448@@00Q22100000<Q17_?Nll00]JJ0_oO00?oomkKg]/00]Jj1=JJ
00?>NF]]Jfd00V]]0QSS0`000P0P0PQQ0Q2R00<Hhb448@@00R4T0X@@0]kK00?ogoooool00_Nn0^mm
0^Ll00?W7=kkg_/018@@00<YAASS6><00P000P0P0SWW0jDD0^Ll0_Nn0_oo00?ogoNNmih00ZeE0Zee
00=:BD88@PP00PQQ0P000PQQ0e::0TYY0[FF0[gG00?66?NNmih02_oo0009ool2eYX00g>^8@@Q1002
488300028@@2Nll2eYX2oml00ooog]_Nf`02e[X4eYX00liiJfe[K@02Jfd26><30002020226424:80
0aSS8@@Q10028B@2Q102g]/00ooOooooo`02mkh2kgd2ic`00nLLg__Nn`04Q1000bU56><Hh`020002
0202>NL3YA@2ic`2mkh2ool00ooOmikgWP02[ED2[GD00dY9@PQ22002264200022643DXX2BVT2]IH2
_ML00lHHmikgWP05ool2eYX00g>^8@@Q1002488400000b44Nlmkc`02eYX2oml00ooog]_Nf`02e[X4
eYX00liiJfe[K@02Jfd26><30002020226424:800aSS8@@Q10028B@2Q102g]/00ooOooooo`02mkh2
kgd2ic`00nLLg__Nn`04Q1000bU56><Hh`0200020202>NL3YA@2ic`2mkh2ool00ooOmikgWP02[ED2
[GD00dY9@PQ22002264200022643DXX2BVT2]IH2_ML00lHHmikgWP0:ool000_oo`03kegW?>Ll00:D
TP>D/P8ia`88@@8000808003245:JDYY009:J@:eUP;_O@03ooogW_NN00;_G@;W7003g_^4<8@`008Y
A@8Hh`88H@<00088@@8@PP8H``036><Q1244008Q908YA@<YI@:DTP:<L@;Nn`03kggooooo00;oo`;g
_P;_O@03YA@iicWW0088@@80008@PP03H`aJje[[00:mm`;gWP03ooo_ONmm00;W?0;W70:4<003S54Y
IBUU0080808000808003265BRU::00Ooo`03kegW?>Ll00:DTPBD/P03>LL8@@Q1008000808003245:
JDYY009:J@:eUP;_O@03ooogW_NN00;_G@;W70;Nn`03Q30YABU5008Hh`88H@<00088@@8@PP8H``03
6><Q1244008Q908YA@<YI@:DTP:<L@;Nn`03kggooooo00;oo`;g_P;_O@03YA@iicWW0088@@80008@
PP03H`aJje[[00:mm`;gWP03ooo_ONmm00;W?0;W70:4<003S54YIBUU0080808000808003265BRU::
00[oo`002ooo00?_GNLlic`00YBB0iBb0SW70PQ10P000P0P00<8@DYYBVT00TYY0[FF0^mm00?oooNN
mih00^mM0^LL00?Nnh@`Q3000RU50QSS0PQQ0`000PQ10Q220QS300<Hhb448@@00R4T0RU50bUU0YBB
0Xaa0]kk00?_OOooool00_oo0_Nn0^mm00>U53WW>NL00PQ10P000Q2200=S35[[F^/00[gg0_NN00?o
onmmkgd00^Ll0^LL0X@`00><DBUU:FD00P0P0P000P0P00<8HE::DXX01ooo00?_GNLlic`00YBB19Bb
00<ia`Q124400P000P0P00<8@DYYBVT00TYY0[FF0^mm00?oooNNmih00^mM0^LL0]kk00>4<2U5:DD0
0QSS0PQQ0`000PQ10Q220QS300<Hhb448@@00R4T0RU50bUU0YBB0Xaa0]kk00?_OOooool00_oo0_Nn
0^mm00>U53WW>NL00PQ10P000Q2200=S35[[F^/00[gg0_NN00?oonmmkgd00^Ll0^LL0X@`00><DBUU
:FD00P0P0P000P0P00<8HE::DXX02_oo0009ool3BVT2]IH2]KH2_OL00oNNooooo`02oml2cWT7Jdd2
6><300020204@PP00jDdkeg_G@04ool2mkh00nmmYABU5002@PP226430004<HH2<JH3U;84W=<2ia`3
ool2mkh2_OL3DZX248820202000202000`QQ4:8@XP026<<2Lhh00f]]Jde[C@02Jdd2aSP2mkh00ooo
omoog`02mih2[GD3]IH2BVT5ool3BVT2]IH2]KH2_OL2mih00oooomoog`02cWT7Jdd26><300020204
@PP2YC@00nmMooooo`02ool2mkh00nmmYABU5002@PP226430004<HH2<JH3U;84W=<2ia`3ool2mkh2
_OL3DZX248820202000202000`QQ4:8@XP026<<2Lhh00f]]Jde[C@02Jdd2aSP2mkh00oooomoog`02
mih2[GD3]IH2BVT:ool000Woo`=:J@:eUP:e]P:mm`03mikooooo00;og`;>N@M[C@8Hh`<0008080A2
2003YCC_GNmM00Coo`;g_P03kgfU5:DD00922088H@<000@aQP8aYP>D/PBLd`;W70?oo`;g_P:mm`=B
ZP8@PP80808000808003264@XQ2R008H``9cSP03Jfe[CF]=009[C@;6>0;g_P03oooogooO00;gWP:]
M@>eUP9:J@Goo`=:J@:eUP:e]P:mm`;gWP03oooogooO00;>N@M[C@8Hh`<0008080A220:U=003kego
oooo00;oo`;g_P03kgfU5:DD00922088H@<000@aQP8aYP>D/PBLd`;W70?oo`;g_P:mm`=BZP8@PP80
808000808003264@XQ2R008H``9cSP03Jfe[CF]=009[C@;6>0;g_P03oooogooO00;gWP:]M@>eUP9:
J@[oo`00o?oo003lool00?coo`00o?oo003lool00?coo`00\
\>"],
  ImageRangeCache->{{{0, 251}, {125, 0}} -> {-0.0542105, -0.0250054, \
0.00840009, 0.00840009}, {{6.4375, 125.5}, {122, 2.9375}} -> {-5.23374, \
-3.29357, 0.564413, 0.564413}, {{125.5, 244.5}, {122, 2.9375}} -> {-72.4714, \
-3.31211, 0.56471, 0.56471}}],

Cell[BoxData[
    TagBox[
      RowBox[{
      "\[SkeletonIndicator]", "GraphicsArray", "\[SkeletonIndicator]"}],
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"pl", "=", 
        RowBox[{"ListDensityPlot", "[", 
          RowBox[{"data", ",", 
            RowBox[{"Frame", "\[Rule]", "False"}], ",", 
            RowBox[{"Mesh", "\[Rule]", "False"}], ",", 
            RowBox[{"AspectRatio", "\[Rule]", "4"}], ",", 
            RowBox[{"PlotRegion", "\[Rule]", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{
                      RowBox[{"-", "0.02"}], ",", "1.02"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                      RowBox[{"-", "0.02"}], ",", "1.02"}], "}"}]}], "}"}]}], 
            ",", 
            RowBox[{"DisplayFunction", "\[Rule]", "Identity"}]}], "]"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"Show", "[", 
        RowBox[{
          RowBox[{"GraphicsArray", "[", 
            RowBox[{
              RowBox[{"{", 
                RowBox[{"{", 
                  RowBox[{"gr", ",", "gr", ",", "gr", ",", "gr"}], "}"}], 
                "}"}], ",", 
              RowBox[{"BackGround", "\[Rule]", "Blue"}]}], "]"}], ",", 
          RowBox[{"GraphicsSpacing", "\[Rule]", "0"}]}], "]"}], 
      ";"}]}], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.238095 0.0238095 0.238095 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0238095 0.261905 0.97619 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.014881 0.0952381 0.0595238 [
[ 0 0 0 0 ]
[ 1 4 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 4 L
0 4 L
closepath
clip
newpath
% Start of gray image
p
.02381 .09524 translate
.95238 3.80952 scale
64 string
64 64 8 [64 0 0 64 0 0] {
\tcurrentfile
\t1 index
\treadhexstring
\tpop
}  Mimage
00040B4F4D4B49474644A9EBFBFFF9C2C35E1801012886DAEAFEF5EEE7E1882E1F030022
7E7B7875D0F9FFF9C05C170109105CBEF3FFFCCD6B1E0201070F161C
217DD5FAFFFAF2EAE4DF84878A8E310700040C514FB3EFFFFDF5EEE793969A9D3C320700
050D54B7F1FEFEF7EFE8E28A2F06001A1F24807E7BD4FAFEF8F0E996
370900040C1362C3F5FFFCF4B1B34F11000D1464C4CFF8FFFAF3EB9B9FA240372B050126
292C2F3132949494E2F2FFFDF6B75313000B4FB3EFFDF9F1EAE4DE84
2B1C0201070F1668C7F6FFFBF3EC9DA13F350800171D2226292C2F3192E1FDFFF8F0E9E3
8B300700050C141A70CDDAFBFFF9C1C15D5B1606001A706DCAF7FFE8
E28A2F210300060E161C73CFDCFCFCF5EDE6E0872D0600070F161C217CD4E3FDF9C25E17
0700050D151B212582D8FBFDD4D271727375230300060E1567C6F6FF
FBF4B04C463D330800040C141A706D69C8D4FAFFFAF2ACAE4A0F00020A4AAEEDFFF3EB9C
A0A3A6A9ACAEB1B3B5B752130002094846ABECFFF4EC9EA2400C0003
0B4DB1EEFFFDD2CFCE6C1E0D0003313295E2FDFEDBD7D4D2CFCECC6A6A691D02050D141B
71CEF8FFE7E1DCD87A7C7E81291A0101084342A7EAFAFEF7BB571405
00050D151B202582D8FBFFF9C25E180108105A57BAF2FFFCF5EDE6E0DCD87A7C7E280400
063CA1E7FEF7EFA5420D00020911186C6865C5F5FFFCF4ECE6E0DB7F
280501292C8C8B89DCFCFFDFDA7E80290500050D1565C5F5FFFBCA67671C02060E1566C6
F5FFFBCAC9661B0B00030B13191F79D2F9FFFAC5C561190101272A2D
8EDEEEFDFEF8F0A7440D0010176B67C7F6FFFBF4EC9DA13F0B00020A125F5B5855B9F1FF
FCF5EDE6E1DC8082852C1D0D00030A125FC1F4FFEFA5A8AB470E0101
0845AAEBFFFDD4D2CF6E6E1F0200070F161C2126292C2E30323496E2F3FFFDF5EEA14036
0800040C50B4EFFFFDF5B5B7524E11000D53514EB2B9F1FEFEF7EFA4
A7AAAD490F0101272B2D8E8DDEFCFFF9F1A9450E00030A12191E237F7DD5FAFFE3DE832B
0500050D151B2025282B2E30329494E1FDFFDC7F28190101278482D8
FBFFF9C2C25E180700040C514EB3EFFFF2EA9A3A0A00043536373738399CE5F6FFFBF4EC
E5E086892E0600217B78D2F9FFFAC561190101272A8ADCFCFFDFDAD7
78240400060E555350B4EFFEF9F1E9983909001566C6F6FFEBE4DFDAD7D4D1CF6D1F0204
3838399C9EE6FEF8F0A7440D00030A4CB0EEFFFDD271211002012428
2B2E30323396E2F3FFEEA1A442392D0600050D1464C4F5FFFCCC691D02012481D7FBFFF9
C35E1801010810176A66C6F6FFFBCA67671C020107434241A5E9F9FF
E48E3107001D227E7BD4FAFFE4DEDA7D270400063D3DA1A3A6A9ADB2EFFFFDF6EEE7E188
2E0600050D141B202581D8FBFEF6B8BA55511200020911186CCAF7FF
FBC7C66361601801080F5956BAC2F4FFFCCC691D020124817ED6FAFFFAC3C3C35F180101
272B8A8987DBEBFFF5B44F11000209115D5ABCF2FFEEE7E1888C3007
00196ECBF7FFE8E28A8D310700050C514F4D4BAFEDFFFDF6EEE793979A9EA13F0B000333
95E2FDFEDBD7797B260400060E151B2125292C8C8B89DCECFBFFF9F1
EAE38D310700050C141A20242887DBFBFFF9F1EA9939090004353699E4FDFEDAD6D37322
110300074040A4E9FEFED67779250400060E1566C6F6FFEBE4DFDA7D
808285888B3022120002094847ABECFBFFF9C1C1C2C2C25E5C59150500050D146561C2F4
FFECE5909397372C0500050D1464C5F5FFEB9B3A2F0600063EA3E8FE
FEF7EFE8E2DDD97B26160600060E161C7370CCF8FFFBF3EBE58F9296370900161C212629
2C2E908FDFFCFFF8BF5B58544F4A0F010108105A5754514FB3B9F1FE
FEF7EFE8E2DD812A050108444342414140A4E9FEFEF7B9BBBC57531300020911181E76D1
F9FFFAC56219010127848280D7FAFFFAF2EAE4DEDA7D271801081017
6AC8F6FFFBC8651B0101070F1769C8D4FAFFFAF2AC480F00020A4B4947ACECFBFDF5EDE7
E1882E1F0F00020A12181E77D1E0F0FFFDD0CECCCBCA67661B0B0013
62C3F4FFFCF5ED9FA341372B1C0201070F161C74CFDDFCFFDE842B0500050D1465C5F5FF
FCF4B1B3B5511200022C8D8CDDFCFCCC6A1D020124288684827F7D7A
D3E2FDFEDB7F8184872D0600050D5250B4BBF2FFFCCECDCB696868681C0B00030B1260C2
F4FFFCCE6C1E0E01012A898886DAEAFEFEF7EFA4410C00115E5B5855
B8C0F4FFFCCCCBCAC966651B02010743A8ABB0EEFDFFF8F0A8AB470E000F1669C8F6FFFB
F3EC9DA0A4410C00030B12191F7875D0F9FFFAC6C5C5C5615F180108
10171D75D0F9FFDFDB7E280400060D54524F4DB1B7F0FFFDF5EDA13F0B0003333497E3F3
FFEDE6919598390900040B131A6F6C68C7F6FFFBF3B0B24E1102050D
52504D4B4948ACECFFF4ECE590330800181E227ED6FAFFE3DDD9D6D372210300060E1667
C6D2F9FFFAF2EB9B9E3D0B0003343536379AE4F5FFFCF4EDE6919498
9B9F3E330800050D141B716ECBD8E7FEF7BA5614000A12605CBEC8D4E3FDFAC35F180101
08105A575451B5BCC5D1F9FFFAC6C5C5611901070F161C7471CDF8FF
FBF3EBE5DFDBD7D4D170201000022E8F8EDFFCFFDD822A0500050D151B716ECBD8FBFDF6
EEA3A6430D0011186B6864615D5A57BAF2FFFCF5EDE6E0878A2F2103
00063F3FA3A6EAFEF6B6B753130300060E5653B7BEF3FFF2ABAEB0B2B4504B440D000209
4846ABECFFFDF6EEE7E1892E200300070E57BAF2FFEFE8E28A8D9033
0800050D1464C5D0F8FFE6E0DBD7D4D2712103040B131A1F7976D0DFEFFFFDF5EEA1400C
00030B4DB1B7BFF3FFFCF4ED9FA2A5433A0A000435989899E4FDFEDA
7D7F2805010810176AC9F6FFFBF3ECE5903307000438389C9DE6FEFEF7BBBCBD5915010A
11181E23272A2D8E8CDEFCFFDEDAD677240300202481D7FBFFF9F2EA
E48D310700063C3CA0E7FEFEF7BABC5714000A12196DCBF7FFFBC865641A010740A4E9FE
FEF7B9551400020911181E22272A2D2F3133343536379AE4FDFEF8BC
57541300022B2E8F8E8DDEEEFFFDF6EEE793350800171D222684817F7CD5FAFFE3DEDAD6
772414000B12191F2380D7FAFED677240400060E1566635FC1CBF7FF
E5909397372C05010742414040A4A7EAFEF5EDE7E1882E06002226292C2F313295949494
E2FDFEF8BD5956524C10020125817FD6FAFFE2DD82852C1D0201070F
166865C5F5FFECE58F330700181E23278583807E7BD4FAFFE48D909435290501282B8BDD
EDFFF3AF4B1000022E30929291E0F1FFFCCFCE6C6C1E0D000A12191F
78D2F9FFE58F92340800171D7572CEF8FFFBF3AE4A430D00030A1260C1F4FFECE6E0DB7F
81842B1D0201070F58555250B4EFFFFDF5EEA13F0B00020A4A49ADED
FFF3AF4B10000E156663C3F5FFFCCB681C02050D151B72CEF8FFFBF3AE4A433A0A00141A
207AD3E1FDFEF8F0E9E3DED9D6D3D16F7071211000022E309291E0F0
FFFDD0CECCCBCA671C0201070F161D227DD5FAFEF7F0A6430D00033133349797E3FDFEDA
D778240400063EA2A5E9F9FFFAF2EBE48E320700053C3CA0E7FEFEF7
BA561404022A2D2F9190DFFCFFF8BFBFC0C05C591505001B2125292C2E303294E1F2FFFD
D4D1CF6D1F0200070F161C217C79D3F9FFE48E3124040020242886DA
FBFFE086892F06001A6FCCD9FBFFF9C25D17010810176AC9D5FAFFE3DED9D6772403030A
12191E77D1F9FFE58F320700050D53B7F0FFFDD06E6F6F7020100201
252988DBFCFFF9F1EAE38C31231300022B2E303294E1F2FFFCCECC6A6A1D0D0011181E77
D1DFFCFFF8F1E9E3DE832B0500050D151B207BD4E2F3FFFCF4EDE6E0
872D060022268482D8FBFFF9C25E180101282B8BDDEDFFFDD3D0CE6D6D6D1F0200237FD6
FAFEF7EFE8E2DDD9D5D37221030006403FA3A6EAFEFED5D3D0CE6C6D
1E0E0101084645A9ADEDFFF3AFB24D110201074241403FA4A7AAEBFFFDD4747677240400
2024817E7CD4FAFFFAF2AC48410C00125FC0CAD7FAFFFAC35F180700
181E237ED6FAFFFAC3C35F180101272B8A89DCFCFCF5B4B6B7534E480F00020A4BAFEDFC
FFF8F1E9E3DEDAD6D3D1CFCDCB691D0C00030B12191F23278684D9E8
FEFED6D3D1CFCDCCCAC966661B0B00131A2024288785D9E9FEFEF7EFA4420C000209115D
BFF3FFFCCDCBCAC9C8651B0201070F161D222684817FD6E5FEFEF7BC
57140500053C3C3C3CA0A2A4E9FEFEF7EFE8E2DDD97B7D270400060D151B217BD4FAFEF8
F0E9969A3A0A00151B71CEF8FFFBF3EBE58F320700053B3B9FE7FEFE
D8D4D2D0CECCCBCAC9C8651B0A00030B13196E6B6764605DBFF3FFFCF4ED9F3E0B00030A
12191F23272A8ADCFCFFF9F1EAE38C9093350800050C141A207AD3E2
FDFEDBD7797B7D27040209105CBEF3FFFCF4ED9F3E0B0010176AC9D5FAFFFAF2EA9A3A0A
000334359898E4FDFEF8F0E9E2DDD9D67678241500010910171D7673
6FCCD9FBFDF6EEA2400C00033295E2FDFEF8BD59150500053B3B9FE7F7FFFBF3ECE58F32
2516010108105B58BBF2FFFCF5EDE6E0872D06001A2024282B8BDDFC
FFDEDA7D270400060D54B8C0F4FFFDF5EDE792350800171D22268482D8FBFFF9F2ABADB0
4C1002060E151C72CEDCFCFFDFDA7E80290500053CA0A2A5A8EAFFFE
F6B85413000209115C59BCF2FFFCF5B3B5B7B85413000B13196E6BC9D6FAFFFAC3C35F5D
17010108105ABDF3FFFCF5EDE6E0DCD8D4D2D0CE6C6C6C1E0200070F
161C217CD5E3FDFEF8F0A6440D00115C595653514EB2EFFFF2EA9A9D3C0A00030B1260C1
F4FFECE590330800053A9EE6F7FFE8E2DD822A1B02063E3E3D3DA1A4
E9FEFEF7B955514B453C32240400063EA2E8F8FFFAC6631A01074140A5E9F9FFE48E9234
0800040C141A706CCAF7FFE89699390900040B131A1F242886DAFBFF
F9C15D170101288785D9E9FEF6EEE7E1892E0600053A3A3A9EE6F7FFE9E3DD82852C0601
24807E7BD4FAFFFAF2EBE48E91340800043738389CE5FEF8F0A8ABAD
490F0101272A2D8DDEFCFFDED97C7E2804001D222684D9FBFDF6EEA2A5433A2F06001A6F
CCD9FBFDF6EEA2400C00030B12191F78D2E0FDFFF8F0E9E3DE83862C
0601074141A5E9FEF6EEA240362A05010843A8EBFAFFE28A8E31240400060E151C736FCC
F7FFFAF2AC48410C00030B4DB1EEFFFDD2CFCECC6A1D02010742A6AA
EBFBFFE1888B8F3207000438389C9D9FE7FEF8F0E8E28B8E91340800040C50B4EFFEFEF7
F0A6430D0011181E237E7CD4FAFFE38C310700050C1463C4F5FFFBCB
681C0C001260C1F4FFECE5909497380900040B131A1F7976D1DFEFFFFDF5EEE7E1DCD8D5
75230300063F3EA3A5A8EBFFFDF6EFA3A6440D00033193E1F1FFFCCF
CDCB691D0C00020A4A48ACECFFFDF6EEA3A6433A2F0600050C52B6BDC6F6FFFBF4ECE5E0
DB7F2805010810171D222684D9FBFFF9C25D5B1601010846AAEBFFFD
D47422120300217CD4FAFEDAD6D3D1CF6D6D1F0200070F161C212683D8FBFDF6EEE7E1DC
81832B1C02063CA0A3E8F8FFF9F1AAAD49410C000D53504EB2B9C0F4
FFECE6919498380900040B4F4DB1EEFFF2EBE4DF842C1D0C00020911181E23272A2D2F90
90DFF0FFFDF5EEA13F0B0012605DBFF3FFEDE6E1878B2F0700050C52
4F4DB1B7BFF3FFFCCD6A6A6A6A1D0201074241A5E9FEFEF7EFA4420C0003323335979898
99E4FDFEF8BC5854130400060E151B726F6B68C7F6FFFBF3B0B2B450
pop
P
% End of image
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.261905 0.0238095 0.5 0.97619 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.014881 0.0952381 0.0595238 [
[ 0 0 0 0 ]
[ 1 4 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 4 L
0 4 L
closepath
clip
newpath
% Start of gray image
p
.02381 .09524 translate
.95238 3.80952 scale
64 string
64 64 8 [64 0 0 64 0 0] {
\tcurrentfile
\t1 index
\treadhexstring
\tpop
}  Mimage
00040B4F4D4B49474644A9EBFBFFF9C2C35E1801012886DAEAFEF5EEE7E1882E1F030022
7E7B7875D0F9FFF9C05C170109105CBEF3FFFCCD6B1E0201070F161C
217DD5FAFFFAF2EAE4DF84878A8E310700040C514FB3EFFFFDF5EEE793969A9D3C320700
050D54B7F1FEFEF7EFE8E28A2F06001A1F24807E7BD4FAFEF8F0E996
370900040C1362C3F5FFFCF4B1B34F11000D1464C4CFF8FFFAF3EB9B9FA240372B050126
292C2F3132949494E2F2FFFDF6B75313000B4FB3EFFDF9F1EAE4DE84
2B1C0201070F1668C7F6FFFBF3EC9DA13F350800171D2226292C2F3192E1FDFFF8F0E9E3
8B300700050C141A70CDDAFBFFF9C1C15D5B1606001A706DCAF7FFE8
E28A2F210300060E161C73CFDCFCFCF5EDE6E0872D0600070F161C217CD4E3FDF9C25E17
0700050D151B212582D8FBFDD4D271727375230300060E1567C6F6FF
FBF4B04C463D330800040C141A706D69C8D4FAFFFAF2ACAE4A0F00020A4AAEEDFFF3EB9C
A0A3A6A9ACAEB1B3B5B752130002094846ABECFFF4EC9EA2400C0003
0B4DB1EEFFFDD2CFCE6C1E0D0003313295E2FDFEDBD7D4D2CFCECC6A6A691D02050D141B
71CEF8FFE7E1DCD87A7C7E81291A0101084342A7EAFAFEF7BB571405
00050D151B202582D8FBFFF9C25E180108105A57BAF2FFFCF5EDE6E0DCD87A7C7E280400
063CA1E7FEF7EFA5420D00020911186C6865C5F5FFFCF4ECE6E0DB7F
280501292C8C8B89DCFCFFDFDA7E80290500050D1565C5F5FFFBCA67671C02060E1566C6
F5FFFBCAC9661B0B00030B13191F79D2F9FFFAC5C561190101272A2D
8EDEEEFDFEF8F0A7440D0010176B67C7F6FFFBF4EC9DA13F0B00020A125F5B5855B9F1FF
FCF5EDE6E1DC8082852C1D0D00030A125FC1F4FFEFA5A8AB470E0101
0845AAEBFFFDD4D2CF6E6E1F0200070F161C2126292C2E30323496E2F3FFFDF5EEA14036
0800040C50B4EFFFFDF5B5B7524E11000D53514EB2B9F1FEFEF7EFA4
A7AAAD490F0101272B2D8E8DDEFCFFF9F1A9450E00030A12191E237F7DD5FAFFE3DE832B
0500050D151B2025282B2E30329494E1FDFFDC7F28190101278482D8
FBFFF9C2C25E180700040C514EB3EFFFF2EA9A3A0A00043536373738399CE5F6FFFBF4EC
E5E086892E0600217B78D2F9FFFAC561190101272A8ADCFCFFDFDAD7
78240400060E555350B4EFFEF9F1E9983909001566C6F6FFEBE4DFDAD7D4D1CF6D1F0204
3838399C9EE6FEF8F0A7440D00030A4CB0EEFFFDD271211002012428
2B2E30323396E2F3FFEEA1A442392D0600050D1464C4F5FFFCCC691D02012481D7FBFFF9
C35E1801010810176A66C6F6FFFBCA67671C020107434241A5E9F9FF
E48E3107001D227E7BD4FAFFE4DEDA7D270400063D3DA1A3A6A9ADB2EFFFFDF6EEE7E188
2E0600050D141B202581D8FBFEF6B8BA55511200020911186CCAF7FF
FBC7C66361601801080F5956BAC2F4FFFCCC691D020124817ED6FAFFFAC3C3C35F180101
272B8A8987DBEBFFF5B44F11000209115D5ABCF2FFEEE7E1888C3007
00196ECBF7FFE8E28A8D310700050C514F4D4BAFEDFFFDF6EEE793979A9EA13F0B000333
95E2FDFEDBD7797B260400060E151B2125292C8C8B89DCECFBFFF9F1
EAE38D310700050C141A20242887DBFBFFF9F1EA9939090004353699E4FDFEDAD6D37322
110300074040A4E9FEFED67779250400060E1566C6F6FFEBE4DFDA7D
808285888B3022120002094847ABECFBFFF9C1C1C2C2C25E5C59150500050D146561C2F4
FFECE5909397372C0500050D1464C5F5FFEB9B3A2F0600063EA3E8FE
FEF7EFE8E2DDD97B26160600060E161C7370CCF8FFFBF3EBE58F9296370900161C212629
2C2E908FDFFCFFF8BF5B58544F4A0F010108105A5754514FB3B9F1FE
FEF7EFE8E2DD812A050108444342414140A4E9FEFEF7B9BBBC57531300020911181E76D1
F9FFFAC56219010127848280D7FAFFFAF2EAE4DEDA7D271801081017
6AC8F6FFFBC8651B0101070F1769C8D4FAFFFAF2AC480F00020A4B4947ACECFBFDF5EDE7
E1882E1F0F00020A12181E77D1E0F0FFFDD0CECCCBCA67661B0B0013
62C3F4FFFCF5ED9FA341372B1C0201070F161C74CFDDFCFFDE842B0500050D1465C5F5FF
FCF4B1B3B5511200022C8D8CDDFCFCCC6A1D020124288684827F7D7A
D3E2FDFEDB7F8184872D0600050D5250B4BBF2FFFCCECDCB696868681C0B00030B1260C2
F4FFFCCE6C1E0E01012A898886DAEAFEFEF7EFA4410C00115E5B5855
B8C0F4FFFCCCCBCAC966651B02010743A8ABB0EEFDFFF8F0A8AB470E000F1669C8F6FFFB
F3EC9DA0A4410C00030B12191F7875D0F9FFFAC6C5C5C5615F180108
10171D75D0F9FFDFDB7E280400060D54524F4DB1B7F0FFFDF5EDA13F0B0003333497E3F3
FFEDE6919598390900040B131A6F6C68C7F6FFFBF3B0B24E1102050D
52504D4B4948ACECFFF4ECE590330800181E227ED6FAFFE3DDD9D6D372210300060E1667
C6D2F9FFFAF2EB9B9E3D0B0003343536379AE4F5FFFCF4EDE6919498
9B9F3E330800050D141B716ECBD8E7FEF7BA5614000A12605CBEC8D4E3FDFAC35F180101
08105A575451B5BCC5D1F9FFFAC6C5C5611901070F161C7471CDF8FF
FBF3EBE5DFDBD7D4D170201000022E8F8EDFFCFFDD822A0500050D151B716ECBD8FBFDF6
EEA3A6430D0011186B6864615D5A57BAF2FFFCF5EDE6E0878A2F2103
00063F3FA3A6EAFEF6B6B753130300060E5653B7BEF3FFF2ABAEB0B2B4504B440D000209
4846ABECFFFDF6EEE7E1892E200300070E57BAF2FFEFE8E28A8D9033
0800050D1464C5D0F8FFE6E0DBD7D4D2712103040B131A1F7976D0DFEFFFFDF5EEA1400C
00030B4DB1B7BFF3FFFCF4ED9FA2A5433A0A000435989899E4FDFEDA
7D7F2805010810176AC9F6FFFBF3ECE5903307000438389C9DE6FEFEF7BBBCBD5915010A
11181E23272A2D8E8CDEFCFFDEDAD677240300202481D7FBFFF9F2EA
E48D310700063C3CA0E7FEFEF7BABC5714000A12196DCBF7FFFBC865641A010740A4E9FE
FEF7B9551400020911181E22272A2D2F3133343536379AE4FDFEF8BC
57541300022B2E8F8E8DDEEEFFFDF6EEE793350800171D222684817F7CD5FAFFE3DEDAD6
772414000B12191F2380D7FAFED677240400060E1566635FC1CBF7FF
E5909397372C05010742414040A4A7EAFEF5EDE7E1882E06002226292C2F313295949494
E2FDFEF8BD5956524C10020125817FD6FAFFE2DD82852C1D0201070F
166865C5F5FFECE58F330700181E23278583807E7BD4FAFFE48D909435290501282B8BDD
EDFFF3AF4B1000022E30929291E0F1FFFCCFCE6C6C1E0D000A12191F
78D2F9FFE58F92340800171D7572CEF8FFFBF3AE4A430D00030A1260C1F4FFECE6E0DB7F
81842B1D0201070F58555250B4EFFFFDF5EEA13F0B00020A4A49ADED
FFF3AF4B10000E156663C3F5FFFCCB681C02050D151B72CEF8FFFBF3AE4A433A0A00141A
207AD3E1FDFEF8F0E9E3DED9D6D3D16F7071211000022E309291E0F0
FFFDD0CECCCBCA671C0201070F161D227DD5FAFEF7F0A6430D00033133349797E3FDFEDA
D778240400063EA2A5E9F9FFFAF2EBE48E320700053C3CA0E7FEFEF7
BA561404022A2D2F9190DFFCFFF8BFBFC0C05C591505001B2125292C2E303294E1F2FFFD
D4D1CF6D1F0200070F161C217C79D3F9FFE48E3124040020242886DA
FBFFE086892F06001A6FCCD9FBFFF9C25D17010810176AC9D5FAFFE3DED9D6772403030A
12191E77D1F9FFE58F320700050D53B7F0FFFDD06E6F6F7020100201
252988DBFCFFF9F1EAE38C31231300022B2E303294E1F2FFFCCECC6A6A1D0D0011181E77
D1DFFCFFF8F1E9E3DE832B0500050D151B207BD4E2F3FFFCF4EDE6E0
872D060022268482D8FBFFF9C25E180101282B8BDDEDFFFDD3D0CE6D6D6D1F0200237FD6
FAFEF7EFE8E2DDD9D5D37221030006403FA3A6EAFEFED5D3D0CE6C6D
1E0E0101084645A9ADEDFFF3AFB24D110201074241403FA4A7AAEBFFFDD4747677240400
2024817E7CD4FAFFFAF2AC48410C00125FC0CAD7FAFFFAC35F180700
181E237ED6FAFFFAC3C35F180101272B8A89DCFCFCF5B4B6B7534E480F00020A4BAFEDFC
FFF8F1E9E3DEDAD6D3D1CFCDCB691D0C00030B12191F23278684D9E8
FEFED6D3D1CFCDCCCAC966661B0B00131A2024288785D9E9FEFEF7EFA4420C000209115D
BFF3FFFCCDCBCAC9C8651B0201070F161D222684817FD6E5FEFEF7BC
57140500053C3C3C3CA0A2A4E9FEFEF7EFE8E2DDD97B7D270400060D151B217BD4FAFEF8
F0E9969A3A0A00151B71CEF8FFFBF3EBE58F320700053B3B9FE7FEFE
D8D4D2D0CECCCBCAC9C8651B0A00030B13196E6B6764605DBFF3FFFCF4ED9F3E0B00030A
12191F23272A8ADCFCFFF9F1EAE38C9093350800050C141A207AD3E2
FDFEDBD7797B7D27040209105CBEF3FFFCF4ED9F3E0B0010176AC9D5FAFFFAF2EA9A3A0A
000334359898E4FDFEF8F0E9E2DDD9D67678241500010910171D7673
6FCCD9FBFDF6EEA2400C00033295E2FDFEF8BD59150500053B3B9FE7F7FFFBF3ECE58F32
2516010108105B58BBF2FFFCF5EDE6E0872D06001A2024282B8BDDFC
FFDEDA7D270400060D54B8C0F4FFFDF5EDE792350800171D22268482D8FBFFF9F2ABADB0
4C1002060E151C72CEDCFCFFDFDA7E80290500053CA0A2A5A8EAFFFE
F6B85413000209115C59BCF2FFFCF5B3B5B7B85413000B13196E6BC9D6FAFFFAC3C35F5D
17010108105ABDF3FFFCF5EDE6E0DCD8D4D2D0CE6C6C6C1E0200070F
161C217CD5E3FDFEF8F0A6440D00115C595653514EB2EFFFF2EA9A9D3C0A00030B1260C1
F4FFECE590330800053A9EE6F7FFE8E2DD822A1B02063E3E3D3DA1A4
E9FEFEF7B955514B453C32240400063EA2E8F8FFFAC6631A01074140A5E9F9FFE48E9234
0800040C141A706CCAF7FFE89699390900040B131A1F242886DAFBFF
F9C15D170101288785D9E9FEF6EEE7E1892E0600053A3A3A9EE6F7FFE9E3DD82852C0601
24807E7BD4FAFFFAF2EBE48E91340800043738389CE5FEF8F0A8ABAD
490F0101272A2D8DDEFCFFDED97C7E2804001D222684D9FBFDF6EEA2A5433A2F06001A6F
CCD9FBFDF6EEA2400C00030B12191F78D2E0FDFFF8F0E9E3DE83862C
0601074141A5E9FEF6EEA240362A05010843A8EBFAFFE28A8E31240400060E151C736FCC
F7FFFAF2AC48410C00030B4DB1EEFFFDD2CFCECC6A1D02010742A6AA
EBFBFFE1888B8F3207000438389C9D9FE7FEF8F0E8E28B8E91340800040C50B4EFFEFEF7
F0A6430D0011181E237E7CD4FAFFE38C310700050C1463C4F5FFFBCB
681C0C001260C1F4FFECE5909497380900040B131A1F7976D1DFEFFFFDF5EEE7E1DCD8D5
75230300063F3EA3A5A8EBFFFDF6EFA3A6440D00033193E1F1FFFCCF
CDCB691D0C00020A4A48ACECFFFDF6EEA3A6433A2F0600050C52B6BDC6F6FFFBF4ECE5E0
DB7F2805010810171D222684D9FBFFF9C25D5B1601010846AAEBFFFD
D47422120300217CD4FAFEDAD6D3D1CF6D6D1F0200070F161C212683D8FBFDF6EEE7E1DC
81832B1C02063CA0A3E8F8FFF9F1AAAD49410C000D53504EB2B9C0F4
FFECE6919498380900040B4F4DB1EEFFF2EBE4DF842C1D0C00020911181E23272A2D2F90
90DFF0FFFDF5EEA13F0B0012605DBFF3FFEDE6E1878B2F0700050C52
4F4DB1B7BFF3FFFCCD6A6A6A6A1D0201074241A5E9FEFEF7EFA4420C0003323335979898
99E4FDFEF8BC5854130400060E151B726F6B68C7F6FFFBF3B0B2B450
pop
P
% End of image
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0238095 0.738095 0.97619 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.014881 0.0952381 0.0595238 [
[ 0 0 0 0 ]
[ 1 4 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 4 L
0 4 L
closepath
clip
newpath
% Start of gray image
p
.02381 .09524 translate
.95238 3.80952 scale
64 string
64 64 8 [64 0 0 64 0 0] {
\tcurrentfile
\t1 index
\treadhexstring
\tpop
}  Mimage
00040B4F4D4B49474644A9EBFBFFF9C2C35E1801012886DAEAFEF5EEE7E1882E1F030022
7E7B7875D0F9FFF9C05C170109105CBEF3FFFCCD6B1E0201070F161C
217DD5FAFFFAF2EAE4DF84878A8E310700040C514FB3EFFFFDF5EEE793969A9D3C320700
050D54B7F1FEFEF7EFE8E28A2F06001A1F24807E7BD4FAFEF8F0E996
370900040C1362C3F5FFFCF4B1B34F11000D1464C4CFF8FFFAF3EB9B9FA240372B050126
292C2F3132949494E2F2FFFDF6B75313000B4FB3EFFDF9F1EAE4DE84
2B1C0201070F1668C7F6FFFBF3EC9DA13F350800171D2226292C2F3192E1FDFFF8F0E9E3
8B300700050C141A70CDDAFBFFF9C1C15D5B1606001A706DCAF7FFE8
E28A2F210300060E161C73CFDCFCFCF5EDE6E0872D0600070F161C217CD4E3FDF9C25E17
0700050D151B212582D8FBFDD4D271727375230300060E1567C6F6FF
FBF4B04C463D330800040C141A706D69C8D4FAFFFAF2ACAE4A0F00020A4AAEEDFFF3EB9C
A0A3A6A9ACAEB1B3B5B752130002094846ABECFFF4EC9EA2400C0003
0B4DB1EEFFFDD2CFCE6C1E0D0003313295E2FDFEDBD7D4D2CFCECC6A6A691D02050D141B
71CEF8FFE7E1DCD87A7C7E81291A0101084342A7EAFAFEF7BB571405
00050D151B202582D8FBFFF9C25E180108105A57BAF2FFFCF5EDE6E0DCD87A7C7E280400
063CA1E7FEF7EFA5420D00020911186C6865C5F5FFFCF4ECE6E0DB7F
280501292C8C8B89DCFCFFDFDA7E80290500050D1565C5F5FFFBCA67671C02060E1566C6
F5FFFBCAC9661B0B00030B13191F79D2F9FFFAC5C561190101272A2D
8EDEEEFDFEF8F0A7440D0010176B67C7F6FFFBF4EC9DA13F0B00020A125F5B5855B9F1FF
FCF5EDE6E1DC8082852C1D0D00030A125FC1F4FFEFA5A8AB470E0101
0845AAEBFFFDD4D2CF6E6E1F0200070F161C2126292C2E30323496E2F3FFFDF5EEA14036
0800040C50B4EFFFFDF5B5B7524E11000D53514EB2B9F1FEFEF7EFA4
A7AAAD490F0101272B2D8E8DDEFCFFF9F1A9450E00030A12191E237F7DD5FAFFE3DE832B
0500050D151B2025282B2E30329494E1FDFFDC7F28190101278482D8
FBFFF9C2C25E180700040C514EB3EFFFF2EA9A3A0A00043536373738399CE5F6FFFBF4EC
E5E086892E0600217B78D2F9FFFAC561190101272A8ADCFCFFDFDAD7
78240400060E555350B4EFFEF9F1E9983909001566C6F6FFEBE4DFDAD7D4D1CF6D1F0204
3838399C9EE6FEF8F0A7440D00030A4CB0EEFFFDD271211002012428
2B2E30323396E2F3FFEEA1A442392D0600050D1464C4F5FFFCCC691D02012481D7FBFFF9
C35E1801010810176A66C6F6FFFBCA67671C020107434241A5E9F9FF
E48E3107001D227E7BD4FAFFE4DEDA7D270400063D3DA1A3A6A9ADB2EFFFFDF6EEE7E188
2E0600050D141B202581D8FBFEF6B8BA55511200020911186CCAF7FF
FBC7C66361601801080F5956BAC2F4FFFCCC691D020124817ED6FAFFFAC3C3C35F180101
272B8A8987DBEBFFF5B44F11000209115D5ABCF2FFEEE7E1888C3007
00196ECBF7FFE8E28A8D310700050C514F4D4BAFEDFFFDF6EEE793979A9EA13F0B000333
95E2FDFEDBD7797B260400060E151B2125292C8C8B89DCECFBFFF9F1
EAE38D310700050C141A20242887DBFBFFF9F1EA9939090004353699E4FDFEDAD6D37322
110300074040A4E9FEFED67779250400060E1566C6F6FFEBE4DFDA7D
808285888B3022120002094847ABECFBFFF9C1C1C2C2C25E5C59150500050D146561C2F4
FFECE5909397372C0500050D1464C5F5FFEB9B3A2F0600063EA3E8FE
FEF7EFE8E2DDD97B26160600060E161C7370CCF8FFFBF3EBE58F9296370900161C212629
2C2E908FDFFCFFF8BF5B58544F4A0F010108105A5754514FB3B9F1FE
FEF7EFE8E2DD812A050108444342414140A4E9FEFEF7B9BBBC57531300020911181E76D1
F9FFFAC56219010127848280D7FAFFFAF2EAE4DEDA7D271801081017
6AC8F6FFFBC8651B0101070F1769C8D4FAFFFAF2AC480F00020A4B4947ACECFBFDF5EDE7
E1882E1F0F00020A12181E77D1E0F0FFFDD0CECCCBCA67661B0B0013
62C3F4FFFCF5ED9FA341372B1C0201070F161C74CFDDFCFFDE842B0500050D1465C5F5FF
FCF4B1B3B5511200022C8D8CDDFCFCCC6A1D020124288684827F7D7A
D3E2FDFEDB7F8184872D0600050D5250B4BBF2FFFCCECDCB696868681C0B00030B1260C2
F4FFFCCE6C1E0E01012A898886DAEAFEFEF7EFA4410C00115E5B5855
B8C0F4FFFCCCCBCAC966651B02010743A8ABB0EEFDFFF8F0A8AB470E000F1669C8F6FFFB
F3EC9DA0A4410C00030B12191F7875D0F9FFFAC6C5C5C5615F180108
10171D75D0F9FFDFDB7E280400060D54524F4DB1B7F0FFFDF5EDA13F0B0003333497E3F3
FFEDE6919598390900040B131A6F6C68C7F6FFFBF3B0B24E1102050D
52504D4B4948ACECFFF4ECE590330800181E227ED6FAFFE3DDD9D6D372210300060E1667
C6D2F9FFFAF2EB9B9E3D0B0003343536379AE4F5FFFCF4EDE6919498
9B9F3E330800050D141B716ECBD8E7FEF7BA5614000A12605CBEC8D4E3FDFAC35F180101
08105A575451B5BCC5D1F9FFFAC6C5C5611901070F161C7471CDF8FF
FBF3EBE5DFDBD7D4D170201000022E8F8EDFFCFFDD822A0500050D151B716ECBD8FBFDF6
EEA3A6430D0011186B6864615D5A57BAF2FFFCF5EDE6E0878A2F2103
00063F3FA3A6EAFEF6B6B753130300060E5653B7BEF3FFF2ABAEB0B2B4504B440D000209
4846ABECFFFDF6EEE7E1892E200300070E57BAF2FFEFE8E28A8D9033
0800050D1464C5D0F8FFE6E0DBD7D4D2712103040B131A1F7976D0DFEFFFFDF5EEA1400C
00030B4DB1B7BFF3FFFCF4ED9FA2A5433A0A000435989899E4FDFEDA
7D7F2805010810176AC9F6FFFBF3ECE5903307000438389C9DE6FEFEF7BBBCBD5915010A
11181E23272A2D8E8CDEFCFFDEDAD677240300202481D7FBFFF9F2EA
E48D310700063C3CA0E7FEFEF7BABC5714000A12196DCBF7FFFBC865641A010740A4E9FE
FEF7B9551400020911181E22272A2D2F3133343536379AE4FDFEF8BC
57541300022B2E8F8E8DDEEEFFFDF6EEE793350800171D222684817F7CD5FAFFE3DEDAD6
772414000B12191F2380D7FAFED677240400060E1566635FC1CBF7FF
E5909397372C05010742414040A4A7EAFEF5EDE7E1882E06002226292C2F313295949494
E2FDFEF8BD5956524C10020125817FD6FAFFE2DD82852C1D0201070F
166865C5F5FFECE58F330700181E23278583807E7BD4FAFFE48D909435290501282B8BDD
EDFFF3AF4B1000022E30929291E0F1FFFCCFCE6C6C1E0D000A12191F
78D2F9FFE58F92340800171D7572CEF8FFFBF3AE4A430D00030A1260C1F4FFECE6E0DB7F
81842B1D0201070F58555250B4EFFFFDF5EEA13F0B00020A4A49ADED
FFF3AF4B10000E156663C3F5FFFCCB681C02050D151B72CEF8FFFBF3AE4A433A0A00141A
207AD3E1FDFEF8F0E9E3DED9D6D3D16F7071211000022E309291E0F0
FFFDD0CECCCBCA671C0201070F161D227DD5FAFEF7F0A6430D00033133349797E3FDFEDA
D778240400063EA2A5E9F9FFFAF2EBE48E320700053C3CA0E7FEFEF7
BA561404022A2D2F9190DFFCFFF8BFBFC0C05C591505001B2125292C2E303294E1F2FFFD
D4D1CF6D1F0200070F161C217C79D3F9FFE48E3124040020242886DA
FBFFE086892F06001A6FCCD9FBFFF9C25D17010810176AC9D5FAFFE3DED9D6772403030A
12191E77D1F9FFE58F320700050D53B7F0FFFDD06E6F6F7020100201
252988DBFCFFF9F1EAE38C31231300022B2E303294E1F2FFFCCECC6A6A1D0D0011181E77
D1DFFCFFF8F1E9E3DE832B0500050D151B207BD4E2F3FFFCF4EDE6E0
872D060022268482D8FBFFF9C25E180101282B8BDDEDFFFDD3D0CE6D6D6D1F0200237FD6
FAFEF7EFE8E2DDD9D5D37221030006403FA3A6EAFEFED5D3D0CE6C6D
1E0E0101084645A9ADEDFFF3AFB24D110201074241403FA4A7AAEBFFFDD4747677240400
2024817E7CD4FAFFFAF2AC48410C00125FC0CAD7FAFFFAC35F180700
181E237ED6FAFFFAC3C35F180101272B8A89DCFCFCF5B4B6B7534E480F00020A4BAFEDFC
FFF8F1E9E3DEDAD6D3D1CFCDCB691D0C00030B12191F23278684D9E8
FEFED6D3D1CFCDCCCAC966661B0B00131A2024288785D9E9FEFEF7EFA4420C000209115D
BFF3FFFCCDCBCAC9C8651B0201070F161D222684817FD6E5FEFEF7BC
57140500053C3C3C3CA0A2A4E9FEFEF7EFE8E2DDD97B7D270400060D151B217BD4FAFEF8
F0E9969A3A0A00151B71CEF8FFFBF3EBE58F320700053B3B9FE7FEFE
D8D4D2D0CECCCBCAC9C8651B0A00030B13196E6B6764605DBFF3FFFCF4ED9F3E0B00030A
12191F23272A8ADCFCFFF9F1EAE38C9093350800050C141A207AD3E2
FDFEDBD7797B7D27040209105CBEF3FFFCF4ED9F3E0B0010176AC9D5FAFFFAF2EA9A3A0A
000334359898E4FDFEF8F0E9E2DDD9D67678241500010910171D7673
6FCCD9FBFDF6EEA2400C00033295E2FDFEF8BD59150500053B3B9FE7F7FFFBF3ECE58F32
2516010108105B58BBF2FFFCF5EDE6E0872D06001A2024282B8BDDFC
FFDEDA7D270400060D54B8C0F4FFFDF5EDE792350800171D22268482D8FBFFF9F2ABADB0
4C1002060E151C72CEDCFCFFDFDA7E80290500053CA0A2A5A8EAFFFE
F6B85413000209115C59BCF2FFFCF5B3B5B7B85413000B13196E6BC9D6FAFFFAC3C35F5D
17010108105ABDF3FFFCF5EDE6E0DCD8D4D2D0CE6C6C6C1E0200070F
161C217CD5E3FDFEF8F0A6440D00115C595653514EB2EFFFF2EA9A9D3C0A00030B1260C1
F4FFECE590330800053A9EE6F7FFE8E2DD822A1B02063E3E3D3DA1A4
E9FEFEF7B955514B453C32240400063EA2E8F8FFFAC6631A01074140A5E9F9FFE48E9234
0800040C141A706CCAF7FFE89699390900040B131A1F242886DAFBFF
F9C15D170101288785D9E9FEF6EEE7E1892E0600053A3A3A9EE6F7FFE9E3DD82852C0601
24807E7BD4FAFFFAF2EBE48E91340800043738389CE5FEF8F0A8ABAD
490F0101272A2D8DDEFCFFDED97C7E2804001D222684D9FBFDF6EEA2A5433A2F06001A6F
CCD9FBFDF6EEA2400C00030B12191F78D2E0FDFFF8F0E9E3DE83862C
0601074141A5E9FEF6EEA240362A05010843A8EBFAFFE28A8E31240400060E151C736FCC
F7FFFAF2AC48410C00030B4DB1EEFFFDD2CFCECC6A1D02010742A6AA
EBFBFFE1888B8F3207000438389C9D9FE7FEF8F0E8E28B8E91340800040C50B4EFFEFEF7
F0A6430D0011181E237E7CD4FAFFE38C310700050C1463C4F5FFFBCB
681C0C001260C1F4FFECE5909497380900040B131A1F7976D1DFEFFFFDF5EEE7E1DCD8D5
75230300063F3EA3A5A8EBFFFDF6EFA3A6440D00033193E1F1FFFCCF
CDCB691D0C00020A4A48ACECFFFDF6EEA3A6433A2F0600050C52B6BDC6F6FFFBF4ECE5E0
DB7F2805010810171D222684D9FBFFF9C25D5B1601010846AAEBFFFD
D47422120300217CD4FAFEDAD6D3D1CF6D6D1F0200070F161C212683D8FBFDF6EEE7E1DC
81832B1C02063CA0A3E8F8FFF9F1AAAD49410C000D53504EB2B9C0F4
FFECE6919498380900040B4F4DB1EEFFF2EBE4DF842C1D0C00020911181E23272A2D2F90
90DFF0FFFDF5EEA13F0B0012605DBFF3FFEDE6E1878B2F0700050C52
4F4DB1B7BFF3FFFCCD6A6A6A6A1D0201074241A5E9FEFEF7EFA4420C0003323335979898
99E4FDFEF8BC5854130400060E151B726F6B68C7F6FFFBF3B0B2B450
pop
P
% End of image
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.738095 0.0238095 0.97619 0.97619 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.014881 0.0952381 0.0595238 [
[ 0 0 0 0 ]
[ 1 4 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 4 L
0 4 L
closepath
clip
newpath
% Start of gray image
p
.02381 .09524 translate
.95238 3.80952 scale
64 string
64 64 8 [64 0 0 64 0 0] {
\tcurrentfile
\t1 index
\treadhexstring
\tpop
}  Mimage
00040B4F4D4B49474644A9EBFBFFF9C2C35E1801012886DAEAFEF5EEE7E1882E1F030022
7E7B7875D0F9FFF9C05C170109105CBEF3FFFCCD6B1E0201070F161C
217DD5FAFFFAF2EAE4DF84878A8E310700040C514FB3EFFFFDF5EEE793969A9D3C320700
050D54B7F1FEFEF7EFE8E28A2F06001A1F24807E7BD4FAFEF8F0E996
370900040C1362C3F5FFFCF4B1B34F11000D1464C4CFF8FFFAF3EB9B9FA240372B050126
292C2F3132949494E2F2FFFDF6B75313000B4FB3EFFDF9F1EAE4DE84
2B1C0201070F1668C7F6FFFBF3EC9DA13F350800171D2226292C2F3192E1FDFFF8F0E9E3
8B300700050C141A70CDDAFBFFF9C1C15D5B1606001A706DCAF7FFE8
E28A2F210300060E161C73CFDCFCFCF5EDE6E0872D0600070F161C217CD4E3FDF9C25E17
0700050D151B212582D8FBFDD4D271727375230300060E1567C6F6FF
FBF4B04C463D330800040C141A706D69C8D4FAFFFAF2ACAE4A0F00020A4AAEEDFFF3EB9C
A0A3A6A9ACAEB1B3B5B752130002094846ABECFFF4EC9EA2400C0003
0B4DB1EEFFFDD2CFCE6C1E0D0003313295E2FDFEDBD7D4D2CFCECC6A6A691D02050D141B
71CEF8FFE7E1DCD87A7C7E81291A0101084342A7EAFAFEF7BB571405
00050D151B202582D8FBFFF9C25E180108105A57BAF2FFFCF5EDE6E0DCD87A7C7E280400
063CA1E7FEF7EFA5420D00020911186C6865C5F5FFFCF4ECE6E0DB7F
280501292C8C8B89DCFCFFDFDA7E80290500050D1565C5F5FFFBCA67671C02060E1566C6
F5FFFBCAC9661B0B00030B13191F79D2F9FFFAC5C561190101272A2D
8EDEEEFDFEF8F0A7440D0010176B67C7F6FFFBF4EC9DA13F0B00020A125F5B5855B9F1FF
FCF5EDE6E1DC8082852C1D0D00030A125FC1F4FFEFA5A8AB470E0101
0845AAEBFFFDD4D2CF6E6E1F0200070F161C2126292C2E30323496E2F3FFFDF5EEA14036
0800040C50B4EFFFFDF5B5B7524E11000D53514EB2B9F1FEFEF7EFA4
A7AAAD490F0101272B2D8E8DDEFCFFF9F1A9450E00030A12191E237F7DD5FAFFE3DE832B
0500050D151B2025282B2E30329494E1FDFFDC7F28190101278482D8
FBFFF9C2C25E180700040C514EB3EFFFF2EA9A3A0A00043536373738399CE5F6FFFBF4EC
E5E086892E0600217B78D2F9FFFAC561190101272A8ADCFCFFDFDAD7
78240400060E555350B4EFFEF9F1E9983909001566C6F6FFEBE4DFDAD7D4D1CF6D1F0204
3838399C9EE6FEF8F0A7440D00030A4CB0EEFFFDD271211002012428
2B2E30323396E2F3FFEEA1A442392D0600050D1464C4F5FFFCCC691D02012481D7FBFFF9
C35E1801010810176A66C6F6FFFBCA67671C020107434241A5E9F9FF
E48E3107001D227E7BD4FAFFE4DEDA7D270400063D3DA1A3A6A9ADB2EFFFFDF6EEE7E188
2E0600050D141B202581D8FBFEF6B8BA55511200020911186CCAF7FF
FBC7C66361601801080F5956BAC2F4FFFCCC691D020124817ED6FAFFFAC3C3C35F180101
272B8A8987DBEBFFF5B44F11000209115D5ABCF2FFEEE7E1888C3007
00196ECBF7FFE8E28A8D310700050C514F4D4BAFEDFFFDF6EEE793979A9EA13F0B000333
95E2FDFEDBD7797B260400060E151B2125292C8C8B89DCECFBFFF9F1
EAE38D310700050C141A20242887DBFBFFF9F1EA9939090004353699E4FDFEDAD6D37322
110300074040A4E9FEFED67779250400060E1566C6F6FFEBE4DFDA7D
808285888B3022120002094847ABECFBFFF9C1C1C2C2C25E5C59150500050D146561C2F4
FFECE5909397372C0500050D1464C5F5FFEB9B3A2F0600063EA3E8FE
FEF7EFE8E2DDD97B26160600060E161C7370CCF8FFFBF3EBE58F9296370900161C212629
2C2E908FDFFCFFF8BF5B58544F4A0F010108105A5754514FB3B9F1FE
FEF7EFE8E2DD812A050108444342414140A4E9FEFEF7B9BBBC57531300020911181E76D1
F9FFFAC56219010127848280D7FAFFFAF2EAE4DEDA7D271801081017
6AC8F6FFFBC8651B0101070F1769C8D4FAFFFAF2AC480F00020A4B4947ACECFBFDF5EDE7
E1882E1F0F00020A12181E77D1E0F0FFFDD0CECCCBCA67661B0B0013
62C3F4FFFCF5ED9FA341372B1C0201070F161C74CFDDFCFFDE842B0500050D1465C5F5FF
FCF4B1B3B5511200022C8D8CDDFCFCCC6A1D020124288684827F7D7A
D3E2FDFEDB7F8184872D0600050D5250B4BBF2FFFCCECDCB696868681C0B00030B1260C2
F4FFFCCE6C1E0E01012A898886DAEAFEFEF7EFA4410C00115E5B5855
B8C0F4FFFCCCCBCAC966651B02010743A8ABB0EEFDFFF8F0A8AB470E000F1669C8F6FFFB
F3EC9DA0A4410C00030B12191F7875D0F9FFFAC6C5C5C5615F180108
10171D75D0F9FFDFDB7E280400060D54524F4DB1B7F0FFFDF5EDA13F0B0003333497E3F3
FFEDE6919598390900040B131A6F6C68C7F6FFFBF3B0B24E1102050D
52504D4B4948ACECFFF4ECE590330800181E227ED6FAFFE3DDD9D6D372210300060E1667
C6D2F9FFFAF2EB9B9E3D0B0003343536379AE4F5FFFCF4EDE6919498
9B9F3E330800050D141B716ECBD8E7FEF7BA5614000A12605CBEC8D4E3FDFAC35F180101
08105A575451B5BCC5D1F9FFFAC6C5C5611901070F161C7471CDF8FF
FBF3EBE5DFDBD7D4D170201000022E8F8EDFFCFFDD822A0500050D151B716ECBD8FBFDF6
EEA3A6430D0011186B6864615D5A57BAF2FFFCF5EDE6E0878A2F2103
00063F3FA3A6EAFEF6B6B753130300060E5653B7BEF3FFF2ABAEB0B2B4504B440D000209
4846ABECFFFDF6EEE7E1892E200300070E57BAF2FFEFE8E28A8D9033
0800050D1464C5D0F8FFE6E0DBD7D4D2712103040B131A1F7976D0DFEFFFFDF5EEA1400C
00030B4DB1B7BFF3FFFCF4ED9FA2A5433A0A000435989899E4FDFEDA
7D7F2805010810176AC9F6FFFBF3ECE5903307000438389C9DE6FEFEF7BBBCBD5915010A
11181E23272A2D8E8CDEFCFFDEDAD677240300202481D7FBFFF9F2EA
E48D310700063C3CA0E7FEFEF7BABC5714000A12196DCBF7FFFBC865641A010740A4E9FE
FEF7B9551400020911181E22272A2D2F3133343536379AE4FDFEF8BC
57541300022B2E8F8E8DDEEEFFFDF6EEE793350800171D222684817F7CD5FAFFE3DEDAD6
772414000B12191F2380D7FAFED677240400060E1566635FC1CBF7FF
E5909397372C05010742414040A4A7EAFEF5EDE7E1882E06002226292C2F313295949494
E2FDFEF8BD5956524C10020125817FD6FAFFE2DD82852C1D0201070F
166865C5F5FFECE58F330700181E23278583807E7BD4FAFFE48D909435290501282B8BDD
EDFFF3AF4B1000022E30929291E0F1FFFCCFCE6C6C1E0D000A12191F
78D2F9FFE58F92340800171D7572CEF8FFFBF3AE4A430D00030A1260C1F4FFECE6E0DB7F
81842B1D0201070F58555250B4EFFFFDF5EEA13F0B00020A4A49ADED
FFF3AF4B10000E156663C3F5FFFCCB681C02050D151B72CEF8FFFBF3AE4A433A0A00141A
207AD3E1FDFEF8F0E9E3DED9D6D3D16F7071211000022E309291E0F0
FFFDD0CECCCBCA671C0201070F161D227DD5FAFEF7F0A6430D00033133349797E3FDFEDA
D778240400063EA2A5E9F9FFFAF2EBE48E320700053C3CA0E7FEFEF7
BA561404022A2D2F9190DFFCFFF8BFBFC0C05C591505001B2125292C2E303294E1F2FFFD
D4D1CF6D1F0200070F161C217C79D3F9FFE48E3124040020242886DA
FBFFE086892F06001A6FCCD9FBFFF9C25D17010810176AC9D5FAFFE3DED9D6772403030A
12191E77D1F9FFE58F320700050D53B7F0FFFDD06E6F6F7020100201
252988DBFCFFF9F1EAE38C31231300022B2E303294E1F2FFFCCECC6A6A1D0D0011181E77
D1DFFCFFF8F1E9E3DE832B0500050D151B207BD4E2F3FFFCF4EDE6E0
872D060022268482D8FBFFF9C25E180101282B8BDDEDFFFDD3D0CE6D6D6D1F0200237FD6
FAFEF7EFE8E2DDD9D5D37221030006403FA3A6EAFEFED5D3D0CE6C6D
1E0E0101084645A9ADEDFFF3AFB24D110201074241403FA4A7AAEBFFFDD4747677240400
2024817E7CD4FAFFFAF2AC48410C00125FC0CAD7FAFFFAC35F180700
181E237ED6FAFFFAC3C35F180101272B8A89DCFCFCF5B4B6B7534E480F00020A4BAFEDFC
FFF8F1E9E3DEDAD6D3D1CFCDCB691D0C00030B12191F23278684D9E8
FEFED6D3D1CFCDCCCAC966661B0B00131A2024288785D9E9FEFEF7EFA4420C000209115D
BFF3FFFCCDCBCAC9C8651B0201070F161D222684817FD6E5FEFEF7BC
57140500053C3C3C3CA0A2A4E9FEFEF7EFE8E2DDD97B7D270400060D151B217BD4FAFEF8
F0E9969A3A0A00151B71CEF8FFFBF3EBE58F320700053B3B9FE7FEFE
D8D4D2D0CECCCBCAC9C8651B0A00030B13196E6B6764605DBFF3FFFCF4ED9F3E0B00030A
12191F23272A8ADCFCFFF9F1EAE38C9093350800050C141A207AD3E2
FDFEDBD7797B7D27040209105CBEF3FFFCF4ED9F3E0B0010176AC9D5FAFFFAF2EA9A3A0A
000334359898E4FDFEF8F0E9E2DDD9D67678241500010910171D7673
6FCCD9FBFDF6EEA2400C00033295E2FDFEF8BD59150500053B3B9FE7F7FFFBF3ECE58F32
2516010108105B58BBF2FFFCF5EDE6E0872D06001A2024282B8BDDFC
FFDEDA7D270400060D54B8C0F4FFFDF5EDE792350800171D22268482D8FBFFF9F2ABADB0
4C1002060E151C72CEDCFCFFDFDA7E80290500053CA0A2A5A8EAFFFE
F6B85413000209115C59BCF2FFFCF5B3B5B7B85413000B13196E6BC9D6FAFFFAC3C35F5D
17010108105ABDF3FFFCF5EDE6E0DCD8D4D2D0CE6C6C6C1E0200070F
161C217CD5E3FDFEF8F0A6440D00115C595653514EB2EFFFF2EA9A9D3C0A00030B1260C1
F4FFECE590330800053A9EE6F7FFE8E2DD822A1B02063E3E3D3DA1A4
E9FEFEF7B955514B453C32240400063EA2E8F8FFFAC6631A01074140A5E9F9FFE48E9234
0800040C141A706CCAF7FFE89699390900040B131A1F242886DAFBFF
F9C15D170101288785D9E9FEF6EEE7E1892E0600053A3A3A9EE6F7FFE9E3DD82852C0601
24807E7BD4FAFFFAF2EBE48E91340800043738389CE5FEF8F0A8ABAD
490F0101272A2D8DDEFCFFDED97C7E2804001D222684D9FBFDF6EEA2A5433A2F06001A6F
CCD9FBFDF6EEA2400C00030B12191F78D2E0FDFFF8F0E9E3DE83862C
0601074141A5E9FEF6EEA240362A05010843A8EBFAFFE28A8E31240400060E151C736FCC
F7FFFAF2AC48410C00030B4DB1EEFFFDD2CFCECC6A1D02010742A6AA
EBFBFFE1888B8F3207000438389C9D9FE7FEF8F0E8E28B8E91340800040C50B4EFFEFEF7
F0A6430D0011181E237E7CD4FAFFE38C310700050C1463C4F5FFFBCB
681C0C001260C1F4FFECE5909497380900040B131A1F7976D1DFEFFFFDF5EEE7E1DCD8D5
75230300063F3EA3A5A8EBFFFDF6EFA3A6440D00033193E1F1FFFCCF
CDCB691D0C00020A4A48ACECFFFDF6EEA3A6433A2F0600050C52B6BDC6F6FFFBF4ECE5E0
DB7F2805010810171D222684D9FBFFF9C25D5B1601010846AAEBFFFD
D47422120300217CD4FAFEDAD6D3D1CF6D6D1F0200070F161C212683D8FBFDF6EEE7E1DC
81832B1C02063CA0A3E8F8FFF9F1AAAD49410C000D53504EB2B9C0F4
FFECE6919498380900040B4F4DB1EEFFF2EBE4DF842C1D0C00020911181E23272A2D2F90
90DFF0FFFDF5EEA13F0B0012605DBFF3FFEDE6E1878B2F0700050C52
4F4DB1B7BFF3FFFCCD6A6A6A6A1D0201074241A5E9FEFEF7EFA4420C0003323335979898
99E4FDFEF8BC5854130400060E151B726F6B68C7F6FFFBF3B0B2B450
pop
P
% End of image
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{798, 798},
  ImageMargins->{{28, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000<N00037Q000`40n007h00Ooooooooooooo8Ooo
003ooooooooooolQool00?ooooooooooob7oo`00oooooooooooo8Ooo003ooooooooooolQool00?oo
ooooooooob7oo`00oooooooooooo8Ooo003ooooooooooolQool00?ooooooooooob7oo`00oooooooo
oooo8Ooo003ooooooooooolQool00?ooooooooooob7oo`00oooooooooooo8Ooo003ooooooooooolQ
ool00?ooooooooooob7oo`00oooooooooooo8Ooo003ooooooooooolQool00?ooooooooooob7oo`00
oooooooooooo8Ooo003ooooooooooolQool00?ooooooooooob7oo`00oooooooooooo8Ooo003ooooo
oooooolQool00?ooooooooooob7oo`00oooooooooooo8Ooo003ooooooooooolQool00?oooooooooo
ob7oo`00oooooooooooo8Ooo003ooooooooooolQool00?ooooooooooob7oo`00oooooooooooo8Ooo
003ooooooooooolQool00?ooooooooooob7oo`00oooooooooooo8Ooo003ooooooooooolQool00?oo
ooooooooob7oo`00oooooooooooo8Ooo003ooooooooooolQool00?ooooooooooob7oo`005ooo0`00
0`0P0PQ11TYY1TY9248X0jeE0nmM0ooO0ooo0ooO1LHH0e[[0aS31P000RU50h@`0mkK0nmM0ooo0oNn
0^mm0nLl0nLL0haA0bUU0aSS1@000b440g__1W_?0W>^0mJJ0ooO0ooo0ooO0lHH0e[[0Q2R0`000`Q1
0a220e[[0kgg0_NN1_oo0lii0f]=0aSS1@000`0P0`QQ0a2R0aSS2?oo0`000P0P0`Q11TYY1TY9248X
0jeE0nmM0ooO0_oo0ooO1/HH0e[[0aS31@000bU50h@`0mkK0nmM0ooo0_Nn0nmm0nLl0nLL0haA0bUU
0QSS1P000b440g__1G_?0g>^0mJJ0ooO0ooo0ooO0/HH0e[[0a2R0`000`Q10a220e[[0[gg0oNN1_oo
0lii0f]=0QSS1P000`0P0`QQ0a2R0QSS2Ooo0P000`0P0`Q11TYY1DY92D8X0jeE0nmM0_oO0ooo0ooO
1/HH0e[[0QS31P000bU50h@`0mkK0^mM0ooo0oNn0nmm0nLl0nLL0haA0RUU0aSS1P000b440g__1G_?
0g>^0mJJ0ooO0ooo0_oO0lHH0e[[0a2R0`000`Q10Q220e[[0kgg0oNN1_oo0/ii0f]=0aSS1P000`0P
0`QQ0Q2R0aSS2?oo0`000`0P0`Q11DYY1TY92D8X0ZeE0nmM0ooO0ooo0ooO1/HH0U[[0aS31P000bU5
0h@`0]kK0nmM0ooo0oNn0nmm0nLl0^LL0haA0bUU0aSS1P000R440g__1W_?0g>^0mJJ0_oO0ooo0ooO
0lHH0e[[0a2R0`000PQ10a220e[[0kgg0oNN1Ooo0lii0f]=0aSS1P000P0P0`QQ0a2R0aSS6?oo000G
ool3000302022446BVT6BTT8@RP3[ED3ked3oml3ool3oml5aQP3F^/36<<60002:DD3Q303g]/3ked3
ool3mkh2kgd3ic`3ia`3S543:FD36><500038@@3Nnl6Nll2Ljh3eYX3oml3ool3oml3aQP3F^/24:83
000324434883F^/3_OL2mih6ool3cWT3Jdd36><50003020326434:836><8ool3000202032446BVT6
BTT8@RP3[ED3ked3oml2ool3oml6aQP3F^/36<<50003:DD3Q303g]/3ked3ool2mkh3kgd3ic`3ia`3
S543:FD26><600038@@3Nnl5Nll3Ljh3eYX3oml3ool3oml2aQP3F^/34:83000324434883F^/2_OL3
mih6ool3cWT3Jdd26><60003020326434:826><9ool2000302032446BVT5BTT9@RP3[ED3ked2oml3
ool3oml6aQP3F^/26<<60003:DD3Q303g]/2ked3ool3mkh3kgd3ic`3ia`3S542:FD36><600038@@3
Nnl5Nll3Ljh3eYX3oml3ool2oml3aQP3F^/34:83000324424883F^/3_OL3mih6ool2cWT3Jdd36><6
0003020326424:836><8ool3000302032445BVT6BTT9@RP2[ED3ked3oml3ool3oml6aQP2F^/36<<6
0003:DD3Q302g]/3ked3ool3mkh3kgd3ic`2ia`3S543:FD36><600028@@3Nnl6Nll3Ljh3eYX2oml3
ool3oml3aQP3F^/34:83000224434883F^/3_OL3mih5ool3cWT3Jdd36><60002020326434:836><H
ool001Ooo`<000<08088@@I:J@I:B@Q2:0>]E@?_G@?og`?oo`?og`G660=Jj`<H``H0008YA@>4<0?N
f`?_G@?oo`?g_P;_O@?W?0?W70><D@<YI@<Hh`D000<Q10=kk`Ikc`9c[P?FVP?og`?oo`?og`?660=J
j`8@XP<000<8@@<@PP=Jj`>mm`;gWPKoo`?>N@=[C@<Hh`D000<080<8H@<@XP<Hh`Soo`<0008080<8
@@I:J@I:B@Q2:0>]E@?_G@?og`;oo`?og`K660=Jj`<H``D000<YA@>4<0?Nf`?_G@?oo`;g_P?_O@?W
?0?W70><D@<YI@8Hh`H000<Q10=kk`Ekc`=c[P?FVP?og`?oo`?og`;660=Jj`<@XP<000<8@@<@PP=J
j`:mm`?gWPKoo`?>N@=[C@8Hh`H000<080<8H@<@XP8Hh`Woo`8000<080<8@@I:J@E:B@U2:0>]E@?_
G@;og`?oo`?og`K660=Jj`8H``H000<YA@>4<0?Nf`;_G@?oo`?g_P?_O@?W?0?W70><D@8YI@<Hh`H0
00<Q10=kk`Ekc`=c[P?FVP?og`?oo`;og`?660=Jj`<@XP<000<8@@8@PP=Jj`>mm`?gWPKoo`;>N@=[
C@<Hh`H000<080<8H@8@XP<Hh`Soo`<000<080<8@@E:J@I:B@U2:0:]E@?_G@?og`?oo`?og`K6609J
j`<H``H000<YA@>4<0;Nf`?_G@?oo`?g_P?_O@?W?0;W70><D@<YI@<Hh`H0008Q10=kk`Ikc`=c[P?F
VP;og`?oo`?og`?660=Jj`<@XP<00088@@<@PP=Jj`>mm`?gWPGoo`?>N@=[C@<Hh`H0008080<8H@<@
XP<HhaSoo`005ooo0`000`0P0PQ11TYY1TY9248X0jeE0nmM0ooO0ooo0ooO1LHH0e[[0aS31P000RU5
0h@`0mkK0nmM0ooo0oNn0^mm0nLl0nLL0haA0bUU0aSS1@000b440g__1W_?0W>^0mJJ0ooO0ooo0ooO
0lHH0e[[0Q2R0`000`Q10a220e[[0kgg0_NN1_oo0lii0f]=0aSS1@000`0P0`QQ0a2R0aSS2?oo0`00
0P0P0`Q11TYY1TY9248X0jeE0nmM0ooO0_oo0ooO1/HH0e[[0aS31@000bU50h@`0mkK0nmM0ooo0_Nn
0nmm0nLl0nLL0haA0bUU0QSS1P000b440g__1G_?0g>^0mJJ0ooO0ooo0ooO0/HH0e[[0a2R0`000`Q1
0a220e[[0[gg0oNN1_oo0lii0f]=0QSS1P000`0P0`QQ0a2R0QSS2Ooo0P000`0P0`Q11TYY1DY92D8X
0jeE0nmM0_oO0ooo0ooO1/HH0e[[0QS31P000bU50h@`0mkK0^mM0ooo0oNn0nmm0nLl0nLL0haA0RUU
0aSS1P000b440g__1G_?0g>^0mJJ0ooO0ooo0_oO0lHH0e[[0a2R0`000`Q10Q220e[[0kgg0oNN1_oo
0/ii0f]=0aSS1P000`0P0`QQ0Q2R0aSS2?oo0`000`0P0`Q11DYY1TY92D8X0ZeE0nmM0ooO0ooo0ooO
1/HH0U[[0aS31P000bU50h@`0]kK0nmM0ooo0oNn0nmm0nLl0^LL0haA0bUU0aSS1P000R440g__1W_?
0g>^0mJJ0_oO0ooo0ooO0lHH0e[[0a2R0`000PQ10a220e[[0kgg0oNN1Ooo0lii0f]=0aSS1P000P0P
0`QQ0a2R0aSS6?oo000Gool3000302022446BVT6BTT8@RP3[ED3ked3oml3ool3oml5aQP3F^/36<<6
0002:DD3Q303g]/3ked3ool3mkh2kgd3ic`3ia`3S543:FD36><500038@@3Nnl6Nll2Ljh3eYX3oml3
ool3oml3aQP3F^/24:83000324434883F^/3_OL2mih6ool3cWT3Jdd36><50003020326434:836><8
ool3000202032446BVT6BTT8@RP3[ED3ked3oml2ool3oml6aQP3F^/36<<50003:DD3Q303g]/3ked3
ool2mkh3kgd3ic`3ia`3S543:FD26><600038@@3Nnl5Nll3Ljh3eYX3oml3ool3oml2aQP3F^/34:83
000324434883F^/2_OL3mih6ool3cWT3Jdd26><60003020326434:826><9ool2000302032446BVT5
BTT9@RP3[ED3ked2oml3ool3oml6aQP3F^/26<<60003:DD3Q303g]/2ked3ool3mkh3kgd3ic`3ia`3
S542:FD36><600038@@3Nnl5Nll3Ljh3eYX3oml3ool2oml3aQP3F^/34:83000324424883F^/3_OL3
mih6ool2cWT3Jdd36><60003020326424:836><8ool3000302032445BVT6BTT9@RP2[ED3ked3oml3
ool3oml6aQP2F^/36<<60003:DD3Q302g]/3ked3ool3mkh3kgd3ic`2ia`3S543:FD36><600028@@3
Nnl6Nll3Ljh3eYX2oml3ool3oml3aQP3F^/34:83000224434883F^/3_OL3mih5ool3cWT3Jdd36><6
0002020326434:836><Hool001Ooo`<000<08088@@I:J@I:B@Q2:0>]E@?_G@?og`?oo`?og`G660=J
j`<H``H0008YA@>4<0?Nf`?_G@?oo`?g_P;_O@?W?0?W70><D@<YI@<Hh`D000<Q10=kk`Ikc`9c[P?F
VP?og`?oo`?og`?660=Jj`8@XP<000<8@@<@PP=Jj`>mm`;gWPKoo`?>N@=[C@<Hh`D000<080<8H@<@
XP<Hh`Soo`<0008080<8@@I:J@I:B@Q2:0>]E@?_G@?og`;oo`?og`K660=Jj`<H``D000<YA@>4<0?N
f`?_G@?oo`;g_P?_O@?W?0?W70><D@<YI@8Hh`H000<Q10=kk`Ekc`=c[P?FVP?og`?oo`?og`;660=J
j`<@XP<000<8@@<@PP=Jj`:mm`?gWPKoo`?>N@=[C@8Hh`H000<080<8H@<@XP8Hh`Woo`8000<080<8
@@I:J@E:B@U2:0>]E@?_G@;og`?oo`?og`K660=Jj`8H``H000<YA@>4<0?Nf`;_G@?oo`?g_P?_O@?W
?0?W70><D@8YI@<Hh`H000<Q10=kk`Ekc`=c[P?FVP?og`?oo`;og`?660=Jj`<@XP<000<8@@8@PP=J
j`>mm`?gWPKoo`;>N@=[C@<Hh`H000<080<8H@8@XP<Hh`Soo`<000<080<8@@E:J@I:B@U2:0:]E@?_
G@?og`?oo`?og`K6609Jj`<H``H000<YA@>4<0;Nf`?_G@?oo`?g_P?_O@?W?0;W70><D@<YI@<Hh`H0
008Q10=kk`Ikc`=c[P?FVP;og`?oo`?og`?660=Jj`<@XP<00088@@<@PP=Jj`>mm`?gWPGoo`?>N@=[
C@<Hh`H0008080<8H@<@XP<HhaSoo`005ooo0`000`0P0PQ11TYY1TY9248X0jeE0nmM0ooO0ooo0ooO
1LHH0e[[0aS31P000RU50h@`0mkK0nmM0ooo0oNn0^mm0nLl0nLL0haA0bUU0aSS1@000b440g__1W_?
0W>^0mJJ0ooO0ooo0ooO0lHH0e[[0Q2R0`000`Q10a220e[[0kgg0_NN1_oo0lii0f]=0aSS1@000`0P
0`QQ0a2R0aSS2?oo0`000P0P0`Q11TYY1TY9248X0jeE0nmM0ooO0_oo0ooO1/HH0e[[0aS31@000bU5
0h@`0mkK0nmM0ooo0_Nn0nmm0nLl0nLL0haA0bUU0QSS1P000b440g__1G_?0g>^0mJJ0ooO0ooo0ooO
0/HH0e[[0a2R0`000`Q10a220e[[0[gg0oNN1_oo0lii0f]=0QSS1P000`0P0`QQ0a2R0QSS2Ooo0P00
0`0P0`Q11TYY1DY92D8X0jeE0nmM0_oO0ooo0ooO1/HH0e[[0QS31P000bU50h@`0mkK0^mM0ooo0oNn
0nmm0nLl0nLL0haA0RUU0aSS1P000b440g__1G_?0g>^0mJJ0ooO0ooo0_oO0lHH0e[[0a2R0`000`Q1
0Q220e[[0kgg0oNN1_oo0/ii0f]=0aSS1P000`0P0`QQ0Q2R0aSS2?oo0`000`0P0`Q11DYY1TY92D8X
0ZeE0nmM0ooO0ooo0ooO1/HH0U[[0aS31P000bU50h@`0]kK0nmM0ooo0oNn0nmm0nLl0^LL0haA0bUU
0aSS1P000R440g__1W_?0g>^0mJJ0_oO0ooo0ooO0lHH0e[[0a2R0`000PQ10a220e[[0kgg0oNN1Ooo
0lii0f]=0aSS1P000P0P0`QQ0a2R0aSS6?oo000Gool3000302022446BVT6BTT8@RP3[ED3ked3oml3
ool3oml5aQP3F^/36<<60002:DD3Q303g]/3ked3ool3mkh2kgd3ic`3ia`3S543:FD36><500038@@3
Nnl6Nll2Ljh3eYX3oml3ool3oml3aQP3F^/24:83000324434883F^/3_OL2mih6ool3cWT3Jdd36><5
0003020326434:836><8ool3000202032446BVT6BTT8@RP3[ED3ked3oml2ool3oml6aQP3F^/36<<5
0003:DD3Q303g]/3ked3ool2mkh3kgd3ic`3ia`3S543:FD26><600038@@3Nnl5Nll3Ljh3eYX3oml3
ool3oml2aQP3F^/34:83000324434883F^/2_OL3mih6ool3cWT3Jdd26><60003020326434:826><9
ool2000302032446BVT5BTT9@RP3[ED3ked2oml3ool3oml6aQP3F^/26<<60003:DD3Q303g]/2ked3
ool3mkh3kgd3ic`3ia`3S542:FD36><600038@@3Nnl5Nll3Ljh3eYX3oml3ool2oml3aQP3F^/34:83
000324424883F^/3_OL3mih6ool2cWT3Jdd36><60003020326424:836><8ool3000302032445BVT6
BTT9@RP2[ED3ked3oml3ool3oml6aQP2F^/36<<60003:DD3Q302g]/3ked3ool3mkh3kgd3ic`2ia`3
S543:FD36><600028@@3Nnl6Nll3Ljh3eYX2oml3ool3oml3aQP3F^/34:83000224434883F^/3_OL3
mih5ool3cWT3Jdd36><60002020326434:836><Hool001Ooo`<000<08088@@I:J@I:B@Q2:0>]E@?_
G@?og`?oo`?og`G660=Jj`<H``H0008YA@>4<0?Nf`?_G@?oo`?g_P;_O@?W?0?W70><D@<YI@<Hh`D0
00<Q10=kk`Ikc`9c[P?FVP?og`?oo`?og`?660=Jj`8@XP<000<8@@<@PP=Jj`>mm`;gWPKoo`?>N@=[
C@<Hh`D000<080<8H@<@XP<Hh`Soo`<0008080<8@@I:J@I:B@Q2:0>]E@?_G@?og`;oo`?og`K660=J
j`<H``D000<YA@>4<0?Nf`?_G@?oo`;g_P?_O@?W?0?W70><D@<YI@8Hh`H000<Q10=kk`Ekc`=c[P?F
VP?og`?oo`?og`;660=Jj`<@XP<000<8@@<@PP=Jj`:mm`?gWPKoo`?>N@=[C@8Hh`H000<080<8H@<@
XP8Hh`Woo`8000<080<8@@I:J@E:B@U2:0>]E@?_G@;og`?oo`?og`K660=Jj`8H``H000<YA@>4<0?N
f`;_G@?oo`?g_P?_O@?W?0?W70><D@8YI@<Hh`H000<Q10=kk`Ekc`=c[P?FVP?og`?oo`;og`?660=J
j`<@XP<000<8@@8@PP=Jj`>mm`?gWPKoo`;>N@=[C@<Hh`H000<080<8H@8@XP<Hh`Soo`<000<080<8
@@E:J@I:B@U2:0:]E@?_G@?og`?oo`?og`K6609Jj`<H``H000<YA@>4<0;Nf`?_G@?oo`?g_P?_O@?W
?0;W70><D@<YI@<Hh`H0008Q10=kk`Ikc`=c[P?FVP;og`?oo`?og`?660=Jj`<@XP<00088@@<@PP=J
j`>mm`?gWPGoo`?>N@=[C@<Hh`H0008080<8H@<@XP<HhaSoo`005ooo0`000`0P0PQ11TYY1TY9248X
0jeE0nmM0ooO0ooo0ooO1LHH0e[[0aS31P000RU50h@`0mkK0nmM0ooo0oNn0^mm0nLl0nLL0haA0bUU
0aSS1@000b440g__1W_?0W>^0mJJ0ooO0ooo0ooO0lHH0e[[0Q2R0`000`Q10a220e[[0kgg0_NN1_oo
0lii0f]=0aSS1@000`0P0`QQ0a2R0aSS2?oo0`000P0P0`Q11TYY1TY9248X0jeE0nmM0ooO0_oo0ooO
1/HH0e[[0aS31@000bU50h@`0mkK0nmM0ooo0_Nn0nmm0nLl0nLL0haA0bUU0QSS1P000b440g__1G_?
0g>^0mJJ0ooO0ooo0ooO0/HH0e[[0a2R0`000`Q10a220e[[0[gg0oNN1_oo0lii0f]=0QSS1P000`0P
0`QQ0a2R0QSS2Ooo0P000`0P0`Q11TYY1DY92D8X0jeE0nmM0_oO0ooo0ooO1/HH0e[[0QS31P000bU5
0h@`0mkK0^mM0ooo0oNn0nmm0nLl0nLL0haA0RUU0aSS1P000b440g__1G_?0g>^0mJJ0ooO0ooo0_oO
0lHH0e[[0a2R0`000`Q10Q220e[[0kgg0oNN1_oo0/ii0f]=0aSS1P000`0P0`QQ0Q2R0aSS2?oo0`00
0`0P0`Q11DYY1TY92D8X0ZeE0nmM0ooO0ooo0ooO1/HH0U[[0aS31P000bU50h@`0]kK0nmM0ooo0oNn
0nmm0nLl0^LL0haA0bUU0aSS1P000R440g__1W_?0g>^0mJJ0_oO0ooo0ooO0lHH0e[[0a2R0`000PQ1
0a220e[[0kgg0oNN1Ooo0lii0f]=0aSS1P000P0P0`QQ0a2R0aSS6?oo000Gool3000302022446BVT6
BTT8@RP3[ED3ked3oml3ool3oml5aQP3F^/36<<60002:DD3Q303g]/3ked3ool3mkh2kgd3ic`3ia`3
S543:FD36><500038@@3Nnl6Nll2Ljh3eYX3oml3ool3oml3aQP3F^/24:83000324434883F^/3_OL2
mih6ool3cWT3Jdd36><50003020326434:836><8ool3000202032446BVT6BTT8@RP3[ED3ked3oml2
ool3oml6aQP3F^/36<<50003:DD3Q303g]/3ked3ool2mkh3kgd3ic`3ia`3S543:FD26><600038@@3
Nnl5Nll3Ljh3eYX3oml3ool3oml2aQP3F^/34:83000324434883F^/2_OL3mih6ool3cWT3Jdd26><6
0003020326434:826><9ool2000302032446BVT5BTT9@RP3[ED3ked2oml3ool3oml6aQP3F^/26<<6
0003:DD3Q303g]/2ked3ool3mkh3kgd3ic`3ia`3S542:FD36><600038@@3Nnl5Nll3Ljh3eYX3oml3
ool2oml3aQP3F^/34:83000324424883F^/3_OL3mih6ool2cWT3Jdd36><60003020326424:836><8
ool3000302032445BVT6BTT9@RP2[ED3ked3oml3ool3oml6aQP2F^/36<<60003:DD3Q302g]/3ked3
ool3mkh3kgd3ic`2ia`3S543:FD36><600028@@3Nnl6Nll3Ljh3eYX2oml3ool3oml3aQP3F^/34:83
000224434883F^/3_OL3mih5ool3cWT3Jdd36><60002020326434:836><Hool001Ooo`<Q10=kk`;F
^P?og`?oo`?og`?gWP?_G@;W?0?Nn`J4<0><D@><L@<aQP8080<000<080<8H@=BRP=:J@:eUP?_O@Ko
o`?g_P?_O@;W?0>DTP>D/P>Ld`>Ll`<ii`8aQP<080<000<080<8H@=BZP:e]P?gWPKoo`?g_P?_O@?_
G@;W70><D@<YI@<080<000<H``8Hh`<Q90>440=kk`=kc`?F^P;og`?oo`?og`?gWP?_G@>D/PSoo`<Q
109kk`?F^P?og`?oo`?og`?gWP;_G@?W?0?Nn`J4<0><D@:<L@<aQP<080<000<080<8H@9BRP=:J@>e
UP?_O@Koo`?g_P;_O@?W?0>DTP>D/P>Ld`>Ll`8ii`<aQP<080<000<080<8H@9BZP>e]P?gWPKoo`?g
_P;_O@?_G@?W70><D@<YI@<080<0008H``<Hh`<Q90>440=kk`=kc`;F^P?og`?oo`?og`?gWP?_G@:D
/PWoo`8Q10=kk`?F^P?og`?oo`?og`;gWP?_G@?W?0?Nn`J4<0:<D@><L@<aQP<080<000<08088H@=B
RP=:J@>eUP?_O@Goo`?g_P?_O@?W?0>DTP>D/P>Ld`:Ll`<ii`<aQP<080<000<08088H@=BZP>e]P?g
WPKoo`;g_P?_O@?_G@?W70><D@<YI@8080<000<H``<Hh`<Q90>4409kk`=kc`?F^P?og`?oo`?og`?g
WP;_G@>D/PSoo`<Q10=kk`?F^P?og`;oo`?og`?gWP?_G@?W?0?Nn`F4<0><D@><L@<aQP<080<00080
80<8H@=BRP=:J@>eUP?_O@Goo`?g_P?_O@?W?0>DTP:D/P>Ld`>Ll`<ii`<aQP<0808000<080<8H@=B
ZP>e]P?gWPGoo`?g_P?_O@?_G@?W70><D@8YI@<080<000<H``<Hh`<Q90:440=kk`=kc`?F^P?og`?o
o`;og`?gWP?_G@>D/QSoo`005ooo0b440g__0]Jj0ooO0ooo0ooO0oNN0nmM0^Ll0mkk1X@`0haA0haa
0c660P0P0`000`0P0`QQ0e::0dYY0[FF0nmm1_oo0oNn0nmm0^Ll0iBB0iBb0icC0icc0cWW0S660`0P
0`000`0P0`QQ0e:Z0[Ff0oNN1_oo0oNn0nmm0nmM0^LL0haA0bUU0`0P0`000aS30QSS0b4T0h@@0g__
0g_?0mJj0_oO0ooo0ooO0oNN0nmM0iBb2?oo0b440W__0mJj0ooO0ooo0ooO0oNN0^mM0nLl0mkk1X@`
0haA0Xaa0c660`0P0`000`0P0`QQ0U::0dYY0kFF0nmm1_oo0oNn0^mm0nLl0iBB0iBb0icC0icc0SWW
0c660`0P0`000`0P0`QQ0U:Z0kFf0oNN1_oo0oNn0^mm0nmM0nLL0haA0bUU0`0P0`000QS30aSS0b4T
0h@@0g__0g_?0]Jj0ooO0ooo0ooO0oNN0nmM0YBb2Ooo0R440g__0mJj0ooO0ooo0ooO0_NN0nmM0nLl
0mkk1X@`0XaA0haa0c660`0P0`000`0P0PQQ0e::0dYY0kFF0nmm1Ooo0oNn0nmm0nLl0iBB0iBb0icC
0Ycc0cWW0c660`0P0`000`0P0PQQ0e:Z0kFf0oNN1_oo0_Nn0nmm0nmM0nLL0haA0bUU0P0P0`000aS3
0aSS0b4T0h@@0W__0g_?0mJj0ooO0ooo0ooO0oNN0^mM0iBb2?oo0b440g__0mJj0ooO0_oo0ooO0oNN
0nmM0nLl0mkk1H@`0haA0haa0c660`0P0`000P0P0`QQ0e::0dYY0kFF0nmm1Ooo0oNn0nmm0nLl0iBB
0YBb0icC0icc0cWW0c660`0P0P000`0P0`QQ0e:Z0kFf0oNN1Ooo0oNn0nmm0nmM0nLL0haA0RUU0`0P
0`000aS30aSS0b4T0X@@0g__0g_?0mJj0ooO0ooo0_oO0oNN0nmM0iBb6?oo000Gool38@@3Nnl2e[X3
oml3ool3oml3mih3ked2ic`3g_/6Q303S543S743<HH20203000302032643DXX3BVT2]IH3kgd6ool3
mkh3kgd2ic`3U983U;83W=<3W?<3>NL2<HH30203000302032643DZX2]KH3mih6ool3mkh3kgd3ked2
ia`3S543:FD3020300036<<26><38B@3Q103Nnl3Nll3e[X2oml3ool3oml3mih3ked3U;88ool38@@2
Nnl3e[X3oml3ool3oml3mih2ked3ic`3g_/6Q303S542S743<HH30203000302032642DXX3BVT3]IH3
kgd6ool3mkh2kgd3ic`3U983U;83W=<3W?<2>NL3<HH30203000302032642DZX3]KH3mih6ool3mkh2
kgd3ked3ia`3S543:FD3020300026<<36><38B@3Q103Nnl3Nll2e[X3oml3ool3oml3mih3ked2U;89
ool28@@3Nnl3e[X3oml3ool3oml2mih3ked3ic`3g_/6Q302S543S743<HH30203000302022643DXX3
BVT3]IH3kgd5ool3mkh3kgd3ic`3U983U;83W=<2W?<3>NL3<HH30203000302022643DZX3]KH3mih6
ool2mkh3kgd3ked3ia`3S543:FD2020300036<<36><38B@3Q102Nnl3Nll3e[X3oml3ool3oml3mih2
ked3U;88ool38@@3Nnl3e[X3oml2ool3oml3mih3ked3ic`3g_/5Q303S543S743<HH3020300020203
2643DXX3BVT3]IH3kgd5ool3mkh3kgd3ic`3U982U;83W=<3W?<3>NL3<HH30202000302032643DZX3
]KH3mih5ool3mkh3kgd3ked3ia`3S542:FD3020300036<<36><38B@2Q103Nnl3Nll3e[X3oml3ool2
oml3mih3ked3U;8Hool001Ooo`<Q10=kk`;F^P?og`?oo`?og`?gWP?_G@;W?0?Nn`J4<0><D@><L@<a
QP8080<000<080<8H@=BRP=:J@:eUP?_O@Koo`?g_P?_O@;W?0>DTP>D/P>Ld`>Ll`<ii`8aQP<080<0
00<080<8H@=BZP:e]P?gWPKoo`?g_P?_O@?_G@;W70><D@<YI@<080<000<H``8Hh`<Q90>440=kk`=k
c`?F^P;og`?oo`?og`?gWP?_G@>D/PSoo`<Q109kk`?F^P?og`?oo`?og`?gWP;_G@?W?0?Nn`J4<0><
D@:<L@<aQP<080<000<080<8H@9BRP=:J@>eUP?_O@Koo`?g_P;_O@?W?0>DTP>D/P>Ld`>Ll`8ii`<a
QP<080<000<080<8H@9BZP>e]P?gWPKoo`?g_P;_O@?_G@?W70><D@<YI@<080<0008H``<Hh`<Q90>4
40=kk`=kc`;F^P?og`?oo`?og`?gWP?_G@:D/PWoo`8Q10=kk`?F^P?og`?oo`?og`;gWP?_G@?W?0?N
n`J4<0:<D@><L@<aQP<080<000<08088H@=BRP=:J@>eUP?_O@Goo`?g_P?_O@?W?0>DTP>D/P>Ld`:L
l`<ii`<aQP<080<000<08088H@=BZP>e]P?gWPKoo`;g_P?_O@?_G@?W70><D@<YI@8080<000<H``<H
h`<Q90>4409kk`=kc`?F^P?og`?oo`?og`?gWP;_G@>D/PSoo`<Q10=kk`?F^P?og`;oo`?og`?gWP?_
G@?W?0?Nn`F4<0><D@><L@<aQP<080<0008080<8H@=BRP=:J@>eUP?_O@Goo`?g_P?_O@?W?0>DTP:D
/P>Ld`>Ll`<ii`<aQP<0808000<080<8H@=BZP>e]P?gWPGoo`?g_P?_O@?_G@?W70><D@8YI@<080<0
00<H``<Hh`<Q90:440=kk`=kc`?F^P?og`?oo`;og`?gWP?_G@>D/QSoo`005ooo0b440g__0]Jj0ooO
0ooo0ooO0oNN0nmM0^Ll0mkk1X@`0haA0haa0c660P0P0`000`0P0`QQ0e::0dYY0[FF0nmm1_oo0oNn
0nmm0^Ll0iBB0iBb0icC0icc0cWW0S660`0P0`000`0P0`QQ0e:Z0[Ff0oNN1_oo0oNn0nmm0nmM0^LL
0haA0bUU0`0P0`000aS30QSS0b4T0h@@0g__0g_?0mJj0_oO0ooo0ooO0oNN0nmM0iBb2?oo0b440W__
0mJj0ooO0ooo0ooO0oNN0^mM0nLl0mkk1X@`0haA0Xaa0c660`0P0`000`0P0`QQ0U::0dYY0kFF0nmm
1_oo0oNn0^mm0nLl0iBB0iBb0icC0icc0SWW0c660`0P0`000`0P0`QQ0U:Z0kFf0oNN1_oo0oNn0^mm
0nmM0nLL0haA0bUU0`0P0`000QS30aSS0b4T0h@@0g__0g_?0]Jj0ooO0ooo0ooO0oNN0nmM0YBb2Ooo
0R440g__0mJj0ooO0ooo0ooO0_NN0nmM0nLl0mkk1X@`0XaA0haa0c660`0P0`000`0P0PQQ0e::0dYY
0kFF0nmm1Ooo0oNn0nmm0nLl0iBB0iBb0icC0Ycc0cWW0c660`0P0`000`0P0PQQ0e:Z0kFf0oNN1_oo
0_Nn0nmm0nmM0nLL0haA0bUU0P0P0`000aS30aSS0b4T0h@@0W__0g_?0mJj0ooO0ooo0ooO0oNN0^mM
0iBb2?oo0b440g__0mJj0ooO0_oo0ooO0oNN0nmM0nLl0mkk1H@`0haA0haa0c660`0P0`000P0P0`QQ
0e::0dYY0kFF0nmm1Ooo0oNn0nmm0nLl0iBB0YBb0icC0icc0cWW0c660`0P0P000`0P0`QQ0e:Z0kFf
0oNN1Ooo0oNn0nmm0nmM0nLL0haA0RUU0`0P0`000aS30aSS0b4T0X@@0g__0g_?0mJj0ooO0ooo0_oO
0oNN0nmM0iBb6?oo000Gool38@@3Nnl2e[X3oml3ool3oml3mih3ked2ic`3g_/6Q303S543S743<HH2
0203000302032643DXX3BVT2]IH3kgd6ool3mkh3kgd2ic`3U983U;83W=<3W?<3>NL2<HH302030003
02032643DZX2]KH3mih6ool3mkh3kgd3ked2ia`3S543:FD3020300036<<26><38B@3Q103Nnl3Nll3
e[X2oml3ool3oml3mih3ked3U;88ool38@@2Nnl3e[X3oml3ool3oml3mih2ked3ic`3g_/6Q303S542
S743<HH30203000302032642DXX3BVT3]IH3kgd6ool3mkh2kgd3ic`3U983U;83W=<3W?<2>NL3<HH3
0203000302032642DZX3]KH3mih6ool3mkh2kgd3ked3ia`3S543:FD3020300026<<36><38B@3Q103
Nnl3Nll2e[X3oml3ool3oml3mih3ked2U;89ool28@@3Nnl3e[X3oml3ool3oml2mih3ked3ic`3g_/6
Q302S543S743<HH30203000302022643DXX3BVT3]IH3kgd5ool3mkh3kgd3ic`3U983U;83W=<2W?<3
>NL3<HH30203000302022643DZX3]KH3mih6ool2mkh3kgd3ked3ia`3S543:FD2020300036<<36><3
8B@3Q102Nnl3Nll3e[X3oml3ool3oml3mih2ked3U;88ool38@@3Nnl3e[X3oml2ool3oml3mih3ked3
ic`3g_/5Q303S543S743<HH30203000202032643DXX3BVT3]IH3kgd5ool3mkh3kgd3ic`3U982U;83
W=<3W?<3>NL3<HH30202000302032643DZX3]KH3mih5ool3mkh3kgd3ked3ia`3S542:FD302030003
6<<36><38B@2Q103Nnl3Nll3e[X3oml3ool2oml3mih3ked3U;8Hool001Ooo`<Q10=kk`;F^P?og`?o
o`?og`?gWP?_G@;W?0?Nn`J4<0><D@><L@<aQP8080<000<080<8H@=BRP=:J@:eUP?_O@Koo`?g_P?_
O@;W?0>DTP>D/P>Ld`>Ll`<ii`8aQP<080<000<080<8H@=BZP:e]P?gWPKoo`?g_P?_O@?_G@;W70><
D@<YI@<080<000<H``8Hh`<Q90>440=kk`=kc`?F^P;og`?oo`?og`?gWP?_G@>D/PSoo`<Q109kk`?F
^P?og`?oo`?og`?gWP;_G@?W?0?Nn`J4<0><D@:<L@<aQP<080<000<080<8H@9BRP=:J@>eUP?_O@Ko
o`?g_P;_O@?W?0>DTP>D/P>Ld`>Ll`8ii`<aQP<080<000<080<8H@9BZP>e]P?gWPKoo`?g_P;_O@?_
G@?W70><D@<YI@<080<0008H``<Hh`<Q90>440=kk`=kc`;F^P?og`?oo`?og`?gWP?_G@:D/PWoo`8Q
10=kk`?F^P?og`?oo`?og`;gWP?_G@?W?0?Nn`J4<0:<D@><L@<aQP<080<000<08088H@=BRP=:J@>e
UP?_O@Goo`?g_P?_O@?W?0>DTP>D/P>Ld`:Ll`<ii`<aQP<080<000<08088H@=BZP>e]P?gWPKoo`;g
_P?_O@?_G@?W70><D@<YI@8080<000<H``<Hh`<Q90>4409kk`=kc`?F^P?og`?oo`?og`?gWP;_G@>D
/PSoo`<Q10=kk`?F^P?og`;oo`?og`?gWP?_G@?W?0?Nn`F4<0><D@><L@<aQP<080<0008080<8H@=B
RP=:J@>eUP?_O@Goo`?g_P?_O@?W?0>DTP:D/P>Ld`>Ll`<ii`<aQP<0808000<080<8H@=BZP>e]P?g
WPGoo`?g_P?_O@?_G@?W70><D@8YI@<080<000<H``<Hh`<Q90:440=kk`=kc`?F^P?og`?oo`;og`?g
WP?_G@>D/QSoo`005ooo0b440g__0]Jj0ooO0ooo0ooO0oNN0nmM0^Ll0mkk1X@`0haA0haa0c660P0P
0`000`0P0`QQ0e::0dYY0[FF0nmm1_oo0oNn0nmm0^Ll0iBB0iBb0icC0icc0cWW0S660`0P0`000`0P
0`QQ0e:Z0[Ff0oNN1_oo0oNn0nmm0nmM0^LL0haA0bUU0`0P0`000aS30QSS0b4T0h@@0g__0g_?0mJj
0_oO0ooo0ooO0oNN0nmM0iBb2?oo0b440W__0mJj0ooO0ooo0ooO0oNN0^mM0nLl0mkk1X@`0haA0Xaa
0c660`0P0`000`0P0`QQ0U::0dYY0kFF0nmm1_oo0oNn0^mm0nLl0iBB0iBb0icC0icc0SWW0c660`0P
0`000`0P0`QQ0U:Z0kFf0oNN1_oo0oNn0^mm0nmM0nLL0haA0bUU0`0P0`000QS30aSS0b4T0h@@0g__
0g_?0]Jj0ooO0ooo0ooO0oNN0nmM0YBb2Ooo0R440g__0mJj0ooO0ooo0ooO0_NN0nmM0nLl0mkk1X@`
0XaA0haa0c660`0P0`000`0P0PQQ0e::0dYY0kFF0nmm1Ooo0oNn0nmm0nLl0iBB0iBb0icC0Ycc0cWW
0c660`0P0`000`0P0PQQ0e:Z0kFf0oNN1_oo0_Nn0nmm0nmM0nLL0haA0bUU0P0P0`000aS30aSS0b4T
0h@@0W__0g_?0mJj0ooO0ooo0ooO0oNN0^mM0iBb2?oo0b440g__0mJj0ooO0_oo0ooO0oNN0nmM0nLl
0mkk1H@`0haA0haa0c660`0P0`000P0P0`QQ0e::0dYY0kFF0nmm1Ooo0oNn0nmm0nLl0iBB0YBb0icC
0icc0cWW0c660`0P0P000`0P0`QQ0e:Z0kFf0oNN1Ooo0oNn0nmm0nmM0nLL0haA0RUU0`0P0`000aS3
0aSS0b4T0X@@0g__0g_?0mJj0ooO0ooo0_oO0oNN0nmM0iBb6?oo000Gool38@@3Nnl2e[X3oml3ool3
oml3mih3ked2ic`3g_/6Q303S543S743<HH20203000302032643DXX3BVT2]IH3kgd6ool3mkh3kgd2
ic`3U983U;83W=<3W?<3>NL2<HH30203000302032643DZX2]KH3mih6ool3mkh3kgd3ked2ia`3S543
:FD3020300036<<26><38B@3Q103Nnl3Nll3e[X2oml3ool3oml3mih3ked3U;88ool38@@2Nnl3e[X3
oml3ool3oml3mih2ked3ic`3g_/6Q303S542S743<HH30203000302032642DXX3BVT3]IH3kgd6ool3
mkh2kgd3ic`3U983U;83W=<3W?<2>NL3<HH30203000302032642DZX3]KH3mih6ool3mkh2kgd3ked3
ia`3S543:FD3020300026<<36><38B@3Q103Nnl3Nll2e[X3oml3ool3oml3mih3ked2U;89ool28@@3
Nnl3e[X3oml3ool3oml2mih3ked3ic`3g_/6Q302S543S743<HH30203000302022643DXX3BVT3]IH3
kgd5ool3mkh3kgd3ic`3U983U;83W=<2W?<3>NL3<HH30203000302022643DZX3]KH3mih6ool2mkh3
kgd3ked3ia`3S543:FD2020300036<<36><38B@3Q102Nnl3Nll3e[X3oml3ool3oml3mih2ked3U;88
ool38@@3Nnl3e[X3oml2ool3oml3mih3ked3ic`3g_/5Q303S543S743<HH30203000202032643DXX3
BVT3]IH3kgd5ool3mkh3kgd3ic`3U982U;83W=<3W?<3>NL3<HH30202000302032643DZX3]KH3mih5
ool3mkh3kgd3ked3ia`3S542:FD3020300036<<36><38B@2Q103Nnl3Nll3e[X3oml3ool2oml3mih3
ked3U;8Hool001Ooo`<Q10=kk`;F^P?og`?oo`?og`?gWP?_G@;W?0?Nn`J4<0><D@><L@<aQP8080<0
00<080<8H@=BRP=:J@:eUP?_O@Koo`?g_P?_O@;W?0>DTP>D/P>Ld`>Ll`<ii`8aQP<080<000<080<8
H@=BZP:e]P?gWPKoo`?g_P?_O@?_G@;W70><D@<YI@<080<000<H``8Hh`<Q90>440=kk`=kc`?F^P;o
g`?oo`?og`?gWP?_G@>D/PSoo`<Q109kk`?F^P?og`?oo`?og`?gWP;_G@?W?0?Nn`J4<0><D@:<L@<a
QP<080<000<080<8H@9BRP=:J@>eUP?_O@Koo`?g_P;_O@?W?0>DTP>D/P>Ld`>Ll`8ii`<aQP<080<0
00<080<8H@9BZP>e]P?gWPKoo`?g_P;_O@?_G@?W70><D@<YI@<080<0008H``<Hh`<Q90>440=kk`=k
c`;F^P?og`?oo`?og`?gWP?_G@:D/PWoo`8Q10=kk`?F^P?og`?oo`?og`;gWP?_G@?W?0?Nn`J4<0:<
D@><L@<aQP<080<000<08088H@=BRP=:J@>eUP?_O@Goo`?g_P?_O@?W?0>DTP>D/P>Ld`:Ll`<ii`<a
QP<080<000<08088H@=BZP>e]P?gWPKoo`;g_P?_O@?_G@?W70><D@<YI@8080<000<H``<Hh`<Q90>4
409kk`=kc`?F^P?og`?oo`?og`?gWP;_G@>D/PSoo`<Q10=kk`?F^P?og`;oo`?og`?gWP?_G@?W?0?N
n`F4<0><D@><L@<aQP<080<0008080<8H@=BRP=:J@>eUP?_O@Goo`?g_P?_O@?W?0>DTP:D/P>Ld`>L
l`<ii`<aQP<0808000<080<8H@=BZP>e]P?gWPGoo`?g_P?_O@?_G@?W70><D@8YI@<080<000<H``<H
h`<Q90:440=kk`=kc`?F^P?og`?oo`;og`?gWP?_G@>D/QSoo`005ooo0b440g__0]Jj0ooO0ooo0ooO
0oNN0nmM0^Ll0mkk1X@`0haA0haa0c660P0P0`000`0P0`QQ0e::0dYY0[FF0nmm1_oo0oNn0nmm0^Ll
0iBB0iBb0icC0icc0cWW0S660`0P0`000`0P0`QQ0e:Z0[Ff0oNN1_oo0oNn0nmm0nmM0^LL0haA0bUU
0`0P0`000aS30QSS0b4T0h@@0g__0g_?0mJj0_oO0ooo0ooO0oNN0nmM0iBb2?oo0b440W__0mJj0ooO
0ooo0ooO0oNN0^mM0nLl0mkk1X@`0haA0Xaa0c660`0P0`000`0P0`QQ0U::0dYY0kFF0nmm1_oo0oNn
0^mm0nLl0iBB0iBb0icC0icc0SWW0c660`0P0`000`0P0`QQ0U:Z0kFf0oNN1_oo0oNn0^mm0nmM0nLL
0haA0bUU0`0P0`000QS30aSS0b4T0h@@0g__0g_?0]Jj0ooO0ooo0ooO0oNN0nmM0YBb2Ooo0R440g__
0mJj0ooO0ooo0ooO0_NN0nmM0nLl0mkk1X@`0XaA0haa0c660`0P0`000`0P0PQQ0e::0dYY0kFF0nmm
1Ooo0oNn0nmm0nLl0iBB0iBb0icC0Ycc0cWW0c660`0P0`000`0P0PQQ0e:Z0kFf0oNN1_oo0_Nn0nmm
0nmM0nLL0haA0bUU0P0P0`000aS30aSS0b4T0h@@0W__0g_?0mJj0ooO0ooo0ooO0oNN0^mM0iBb2?oo
0b440g__0mJj0ooO0_oo0ooO0oNN0nmM0nLl0mkk1H@`0haA0haa0c660`0P0`000P0P0`QQ0e::0dYY
0kFF0nmm1Ooo0oNn0nmm0nLl0iBB0YBb0icC0icc0cWW0c660`0P0P000`0P0`QQ0e:Z0kFf0oNN1Ooo
0oNn0nmm0nmM0nLL0haA0RUU0`0P0`000aS30aSS0b4T0X@@0g__0g_?0mJj0ooO0ooo0_oO0oNN0nmM
0iBb6?oo000Gool3<JH324420003020326434883H``3aQP2mkh6ool3mkh6]IH3BVT2488300032643
4:83Hb`3aSP2cWT3oml3ool3oml3mih3ked2W=<3W?<3YA@3@PP3<JH3:DD2020300038B@3:DD6:FD5
<HH9U;83ia`3mih5ool3mkh3]KH3DXX3488200032443BVT3]IH3kgd3ool2oml3mih3ked3ic`3g_/3
Q308ool3<JH224430003020326434883H``2aQP3mkh6ool3mkh5]IH3BVT34883000326434:82Hb`3
aSP3cWT3oml3ool3oml3mih2ked3W=<3W?<3YA@3@PP3<JH2:DD3020300038B@3:DD5:FD6<HH9U;82
ia`3mih6ool3mkh3]KH3DXX2488300032443BVT3]IH3kgd2ool3oml3mih3ked3ic`3g_/2Q309ool2
<JH324430003020326434882H``3aQP3mkh6ool3mkh5]IH3BVT34883000326424:83Hb`3aSP3cWT3
oml3ool2oml3mih3ked3W=<3W?<3YA@3@PP2<JH3:DD3020300038B@3:DD5:FD6<HH8U;83ia`3mih6
ool3mkh2]KH3DXX3488300032443BVT2]IH3kgd3ool3oml3mih3ked3ic`2g_/3Q308ool3<JH32443
0003020226434883H``3aQP3mkh5ool3mkh6]IH3BVT34883000226434:83Hb`3aSP3cWT3oml2ool3
oml3mih3ked3W=<3W?<2YA@3@PP3<JH3:DD3020300028B@3:DD6:FD6<HH8U;83ia`3mih6ool2mkh3
]KH3DXX3488300032442BVT3]IH3kgd3ool3oml3mih2ked3ic`3g_/3Q30Hool001Ooo`<aYP<8@@80
00<080<8H@<@PP=S30?660;g_PKoo`?g_PJeUP=:J@8@PP<000<8H@<@XP=S;0?6>0;>N@?og`?oo`?o
g`?gWP?_G@:Ld`>Ll`>U50=220<aYP<YA@8080<000<Q90<YA@HYI@DaQPVD/P?W70?gWPGoo`?g_P>e
]P=BRP<@PP8000<8@@=:J@>eUP?_O@?oo`;og`?gWP?_G@?W?0?Nn`>4<0Soo`<aYP88@@<000<080<8
H@<@PP=S30;660?g_PKoo`?g_PFeUP=:J@<@PP<000<8H@<@XP9S;0?6>0?>N@?og`?oo`?og`?gWP;_
G@>Ld`>Ll`>U50=220<aYP8YA@<080<000<Q90<YA@DYI@HaQPVD/P;W70?gWPKoo`?g_P>e]P=BRP8@
PP<000<8@@=:J@>eUP?_O@;oo`?og`?gWP?_G@?W?0?Nn`:4<0Woo`8aYP<8@@<000<080<8H@<@PP9S
30?660?g_PKoo`?g_PFeUP=:J@<@PP<000<8H@8@XP=S;0?6>0?>N@?og`?oo`;og`?gWP?_G@>Ld`>L
l`>U50=2208aYP<YA@<080<000<Q90<YA@DYI@HaQPRD/P?W70?gWPKoo`?g_P:e]P=BRP<@PP<000<8
@@=:J@:eUP?_O@?oo`?og`?gWP?_G@?W?0;Nn`>4<0Soo`<aYP<8@@<000<08088H@<@PP=S30?660?g
_PGoo`?g_PJeUP=:J@<@PP<00088H@<@XP=S;0?6>0?>N@?og`;oo`?og`?gWP?_G@>Ld`>Ll`:U50=2
20<aYP<YA@<080<0008Q90<YA@HYI@HaQPRD/P?W70?gWPKoo`;g_P>e]P=BRP<@PP<000<8@@9:J@>e
UP?_O@?oo`?og`?gWP;_G@?W?0?Nn`>4<1Soo`005ooo0c6V0`Q10P000`0P0`QQ0a220f<<0lHH0_Nn
1_oo0oNn1[FF0dYY0Q220`000`QQ0a2R0f</0lHh0/ii0ooO0ooo0ooO0oNN0nmM0YcC0icc0jDD0d88
0c6V0bU50P0P0`000b4T0bU51RUU1C662IBb0nLL0oNN1Ooo0oNn0kFf0e::0a220P000`Q10dYY0kFF
0nmm0ooo0_oO0oNN0nmM0nLl0mkk0h@`2?oo0c6V0PQ10`000`0P0`QQ0a220f<<0/HH0oNn1_oo0oNn
1KFF0dYY0a220`000`QQ0a2R0V</0lHh0lii0ooO0ooo0ooO0oNN0^mM0icC0icc0jDD0d880c6V0RU5
0`0P0`000b4T0bU51BUU1S662IBb0^LL0oNN1_oo0oNn0kFf0e::0Q220`000`Q10dYY0kFF0nmm0_oo
0ooO0oNN0nmM0nLl0mkk0X@`2Ooo0S6V0`Q10`000`0P0`QQ0a220V<<0lHH0oNn1_oo0oNn1KFF0dYY
0a220`000`QQ0Q2R0f</0lHh0lii0ooO0ooo0_oO0oNN0nmM0icC0icc0jDD0d880S6V0bU50`0P0`00
0b4T0bU51BUU1S6629Bb0nLL0oNN1_oo0oNn0[Ff0e::0a220`000`Q10dYY0[FF0nmm0ooo0ooO0oNN
0nmM0nLl0]kk0h@`2?oo0c6V0`Q10`000`0P0PQQ0a220f<<0lHH0oNn1Ooo0oNn1[FF0dYY0a220`00
0PQQ0a2R0f</0lHh0lii0ooO0_oo0ooO0oNN0nmM0icC0icc0ZDD0d880c6V0bU50`0P0`000R4T0bU5
1RUU1S6629Bb0nLL0oNN1_oo0_Nn0kFf0e::0a220`000`Q10TYY0kFF0nmm0ooo0ooO0oNN0^mM0nLl
0mkk0h@`6?oo000Gool3<JH324420003020326434883H``3aQP2mkh6ool3mkh6]IH3BVT248830003
26434:83Hb`3aSP2cWT3oml3ool3oml3mih3ked2W=<3W?<3YA@3@PP3<JH3:DD2020300038B@3:DD6
:FD5<HH9U;83ia`3mih5ool3mkh3]KH3DXX3488200032443BVT3]IH3kgd3ool2oml3mih3ked3ic`3
g_/3Q308ool3<JH224430003020326434883H``2aQP3mkh6ool3mkh5]IH3BVT34883000326434:82
Hb`3aSP3cWT3oml3ool3oml3mih2ked3W=<3W?<3YA@3@PP3<JH2:DD3020300038B@3:DD5:FD6<HH9
U;82ia`3mih6ool3mkh3]KH3DXX2488300032443BVT3]IH3kgd2ool3oml3mih3ked3ic`3g_/2Q309
ool2<JH324430003020326434882H``3aQP3mkh6ool3mkh5]IH3BVT34883000326424:83Hb`3aSP3
cWT3oml3ool2oml3mih3ked3W=<3W?<3YA@3@PP2<JH3:DD3020300038B@3:DD5:FD6<HH8U;83ia`3
mih6ool3mkh2]KH3DXX3488300032443BVT2]IH3kgd3ool3oml3mih3ked3ic`2g_/3Q308ool3<JH3
24430003020226434883H``3aQP3mkh5ool3mkh6]IH3BVT34883000226434:83Hb`3aSP3cWT3oml2
ool3oml3mih3ked3W=<3W?<2YA@3@PP3<JH3:DD3020300028B@3:DD6:FD6<HH8U;83ia`3mih6ool2
mkh3]KH3DXX3488300032442BVT3]IH3kgd3ool3oml3mih2ked3ic`3g_/3Q30Hool001Ooo`<aYP<8
@@8000<080<8H@<@PP=S30?660;g_PKoo`?g_PJeUP=:J@8@PP<000<8H@<@XP=S;0?6>0;>N@?og`?o
o`?og`?gWP?_G@:Ld`>Ll`>U50=220<aYP<YA@8080<000<Q90<YA@HYI@DaQPVD/P?W70?gWPGoo`?g
_P>e]P=BRP<@PP8000<8@@=:J@>eUP?_O@?oo`;og`?gWP?_G@?W?0?Nn`>4<0Soo`<aYP88@@<000<0
80<8H@<@PP=S30;660?g_PKoo`?g_PFeUP=:J@<@PP<000<8H@<@XP9S;0?6>0?>N@?og`?oo`?og`?g
WP;_G@>Ld`>Ll`>U50=220<aYP8YA@<080<000<Q90<YA@DYI@HaQPVD/P;W70?gWPKoo`?g_P>e]P=B
RP8@PP<000<8@@=:J@>eUP?_O@;oo`?og`?gWP?_G@?W?0?Nn`:4<0Woo`8aYP<8@@<000<080<8H@<@
PP9S30?660?g_PKoo`?g_PFeUP=:J@<@PP<000<8H@8@XP=S;0?6>0?>N@?og`?oo`;og`?gWP?_G@>L
d`>Ll`>U50=2208aYP<YA@<080<000<Q90<YA@DYI@HaQPRD/P?W70?gWPKoo`?g_P:e]P=BRP<@PP<0
00<8@@=:J@:eUP?_O@?oo`?og`?gWP?_G@?W?0;Nn`>4<0Soo`<aYP<8@@<000<08088H@<@PP=S30?6
60?g_PGoo`?g_PJeUP=:J@<@PP<00088H@<@XP=S;0?6>0?>N@?og`;oo`?og`?gWP?_G@>Ld`>Ll`:U
50=220<aYP<YA@<080<0008Q90<YA@HYI@HaQPRD/P?W70?gWPKoo`;g_P>e]P=BRP<@PP<000<8@@9:
J@>eUP?_O@?oo`?og`?gWP;_G@?W?0?Nn`>4<1Soo`005ooo0c6V0`Q10P000`0P0`QQ0a220f<<0lHH
0_Nn1_oo0oNn1[FF0dYY0Q220`000`QQ0a2R0f</0lHh0/ii0ooO0ooo0ooO0oNN0nmM0YcC0icc0jDD
0d880c6V0bU50P0P0`000b4T0bU51RUU1C662IBb0nLL0oNN1Ooo0oNn0kFf0e::0a220P000`Q10dYY
0kFF0nmm0ooo0_oO0oNN0nmM0nLl0mkk0h@`2?oo0c6V0PQ10`000`0P0`QQ0a220f<<0/HH0oNn1_oo
0oNn1KFF0dYY0a220`000`QQ0a2R0V</0lHh0lii0ooO0ooo0ooO0oNN0^mM0icC0icc0jDD0d880c6V
0RU50`0P0`000b4T0bU51BUU1S662IBb0^LL0oNN1_oo0oNn0kFf0e::0Q220`000`Q10dYY0kFF0nmm
0_oo0ooO0oNN0nmM0nLl0mkk0X@`2Ooo0S6V0`Q10`000`0P0`QQ0a220V<<0lHH0oNn1_oo0oNn1KFF
0dYY0a220`000`QQ0Q2R0f</0lHh0lii0ooO0ooo0_oO0oNN0nmM0icC0icc0jDD0d880S6V0bU50`0P
0`000b4T0bU51BUU1S6629Bb0nLL0oNN1_oo0oNn0[Ff0e::0a220`000`Q10dYY0[FF0nmm0ooo0ooO
0oNN0nmM0nLl0]kk0h@`2?oo0c6V0`Q10`000`0P0PQQ0a220f<<0lHH0oNn1Ooo0oNn1[FF0dYY0a22
0`000PQQ0a2R0f</0lHh0lii0ooO0_oo0ooO0oNN0nmM0icC0icc0ZDD0d880c6V0bU50`0P0`000R4T
0bU51RUU1S6629Bb0nLL0oNN1_oo0_Nn0kFf0e::0a220`000`Q10TYY0kFF0nmm0ooo0ooO0oNN0^mM
0nLl0mkk0h@`6?oo000Gool3<JH324420003020326434883H``3aQP2mkh6ool3mkh6]IH3BVT24883
000326434:83Hb`3aSP2cWT3oml3ool3oml3mih3ked2W=<3W?<3YA@3@PP3<JH3:DD2020300038B@3
:DD6:FD5<HH9U;83ia`3mih5ool3mkh3]KH3DXX3488200032443BVT3]IH3kgd3ool2oml3mih3ked3
ic`3g_/3Q308ool3<JH224430003020326434883H``2aQP3mkh6ool3mkh5]IH3BVT3488300032643
4:82Hb`3aSP3cWT3oml3ool3oml3mih2ked3W=<3W?<3YA@3@PP3<JH2:DD3020300038B@3:DD5:FD6
<HH9U;82ia`3mih6ool3mkh3]KH3DXX2488300032443BVT3]IH3kgd2ool3oml3mih3ked3ic`3g_/2
Q309ool2<JH324430003020326434882H``3aQP3mkh6ool3mkh5]IH3BVT34883000326424:83Hb`3
aSP3cWT3oml3ool2oml3mih3ked3W=<3W?<3YA@3@PP2<JH3:DD3020300038B@3:DD5:FD6<HH8U;83
ia`3mih6ool3mkh2]KH3DXX3488300032443BVT2]IH3kgd3ool3oml3mih3ked3ic`2g_/3Q308ool3
<JH324430003020226434883H``3aQP3mkh5ool3mkh6]IH3BVT34883000226434:83Hb`3aSP3cWT3
oml2ool3oml3mih3ked3W=<3W?<2YA@3@PP3<JH3:DD3020300028B@3:DD6:FD6<HH8U;83ia`3mih6
ool2mkh3]KH3DXX3488300032442BVT3]IH3kgd3ool3oml3mih2ked3ic`3g_/3Q30Hool001Ooo`<a
YP<8@@8000<080<8H@<@PP=S30?660;g_PKoo`?g_PJeUP=:J@8@PP<000<8H@<@XP=S;0?6>0;>N@?o
g`?oo`?og`?gWP?_G@:Ld`>Ll`>U50=220<aYP<YA@8080<000<Q90<YA@HYI@DaQPVD/P?W70?gWPGo
o`?g_P>e]P=BRP<@PP8000<8@@=:J@>eUP?_O@?oo`;og`?gWP?_G@?W?0?Nn`>4<0Soo`<aYP88@@<0
00<080<8H@<@PP=S30;660?g_PKoo`?g_PFeUP=:J@<@PP<000<8H@<@XP9S;0?6>0?>N@?og`?oo`?o
g`?gWP;_G@>Ld`>Ll`>U50=220<aYP8YA@<080<000<Q90<YA@DYI@HaQPVD/P;W70?gWPKoo`?g_P>e
]P=BRP8@PP<000<8@@=:J@>eUP?_O@;oo`?og`?gWP?_G@?W?0?Nn`:4<0Woo`8aYP<8@@<000<080<8
H@<@PP9S30?660?g_PKoo`?g_PFeUP=:J@<@PP<000<8H@8@XP=S;0?6>0?>N@?og`?oo`;og`?gWP?_
G@>Ld`>Ll`>U50=2208aYP<YA@<080<000<Q90<YA@DYI@HaQPRD/P?W70?gWPKoo`?g_P:e]P=BRP<@
PP<000<8@@=:J@:eUP?_O@?oo`?og`?gWP?_G@?W?0;Nn`>4<0Soo`<aYP<8@@<000<08088H@<@PP=S
30?660?g_PGoo`?g_PJeUP=:J@<@PP<00088H@<@XP=S;0?6>0?>N@?og`;oo`?og`?gWP?_G@>Ld`>L
l`:U50=220<aYP<YA@<080<0008Q90<YA@HYI@HaQPRD/P?W70?gWPKoo`;g_P>e]P=BRP<@PP<000<8
@@9:J@>eUP?_O@?oo`?og`?gWP;_G@?W?0?Nn`>4<1Soo`005ooo0c6V0`Q10P000`0P0`QQ0a220f<<
0lHH0_Nn1_oo0oNn1[FF0dYY0Q220`000`QQ0a2R0f</0lHh0/ii0ooO0ooo0ooO0oNN0nmM0YcC0icc
0jDD0d880c6V0bU50P0P0`000b4T0bU51RUU1C662IBb0nLL0oNN1Ooo0oNn0kFf0e::0a220P000`Q1
0dYY0kFF0nmm0ooo0_oO0oNN0nmM0nLl0mkk0h@`2?oo0c6V0PQ10`000`0P0`QQ0a220f<<0/HH0oNn
1_oo0oNn1KFF0dYY0a220`000`QQ0a2R0V</0lHh0lii0ooO0ooo0ooO0oNN0^mM0icC0icc0jDD0d88
0c6V0RU50`0P0`000b4T0bU51BUU1S662IBb0^LL0oNN1_oo0oNn0kFf0e::0Q220`000`Q10dYY0kFF
0nmm0_oo0ooO0oNN0nmM0nLl0mkk0X@`2Ooo0S6V0`Q10`000`0P0`QQ0a220V<<0lHH0oNn1_oo0oNn
1KFF0dYY0a220`000`QQ0Q2R0f</0lHh0lii0ooO0ooo0_oO0oNN0nmM0icC0icc0jDD0d880S6V0bU5
0`0P0`000b4T0bU51BUU1S6629Bb0nLL0oNN1_oo0oNn0[Ff0e::0a220`000`Q10dYY0[FF0nmm0ooo
0ooO0oNN0nmM0nLl0]kk0h@`2?oo0c6V0`Q10`000`0P0PQQ0a220f<<0lHH0oNn1Ooo0oNn1[FF0dYY
0a220`000PQQ0a2R0f</0lHh0lii0ooO0_oo0ooO0oNN0nmM0icC0icc0ZDD0d880c6V0bU50`0P0`00
0R4T0bU51RUU1S6629Bb0nLL0oNN1_oo0_Nn0kFf0e::0a220`000`Q10TYY0kFF0nmm0ooo0ooO0oNN
0^mM0nLl0mkk0h@`6?oo000Gool3<JH324420003020326434883H``3aQP2mkh6ool3mkh6]IH3BVT2
4883000326434:83Hb`3aSP2cWT3oml3ool3oml3mih3ked2W=<3W?<3YA@3@PP3<JH3:DD202030003
8B@3:DD6:FD5<HH9U;83ia`3mih5ool3mkh3]KH3DXX3488200032443BVT3]IH3kgd3ool2oml3mih3
ked3ic`3g_/3Q308ool3<JH224430003020326434883H``2aQP3mkh6ool3mkh5]IH3BVT348830003
26434:82Hb`3aSP3cWT3oml3ool3oml3mih2ked3W=<3W?<3YA@3@PP3<JH2:DD3020300038B@3:DD5
:FD6<HH9U;82ia`3mih6ool3mkh3]KH3DXX2488300032443BVT3]IH3kgd2ool3oml3mih3ked3ic`3
g_/2Q309ool2<JH324430003020326434882H``3aQP3mkh6ool3mkh5]IH3BVT34883000326424:83
Hb`3aSP3cWT3oml3ool2oml3mih3ked3W=<3W?<3YA@3@PP2<JH3:DD3020300038B@3:DD5:FD6<HH8
U;83ia`3mih6ool3mkh2]KH3DXX3488300032443BVT2]IH3kgd3ool3oml3mih3ked3ic`2g_/3Q308
ool3<JH324430003020226434883H``3aQP3mkh5ool3mkh6]IH3BVT34883000226434:83Hb`3aSP3
cWT3oml2ool3oml3mih3ked3W=<3W?<2YA@3@PP3<JH3:DD3020300028B@3:DD6:FD6<HH8U;83ia`3
mih6ool2mkh3]KH3DXX3488300032442BVT3]IH3kgd3ool3oml3mih2ked3ic`3g_/3Q30Hool001Oo
o`<aYP<8@@8000<080<8H@<@PP=S30?660;g_PKoo`?g_PJeUP=:J@8@PP<000<8H@<@XP=S;0?6>0;>
N@?og`?oo`?og`?gWP?_G@:Ld`>Ll`>U50=220<aYP<YA@8080<000<Q90<YA@HYI@DaQPVD/P?W70?g
WPGoo`?g_P>e]P=BRP<@PP8000<8@@=:J@>eUP?_O@?oo`;og`?gWP?_G@?W?0?Nn`>4<0Soo`<aYP88
@@<000<080<8H@<@PP=S30;660?g_PKoo`?g_PFeUP=:J@<@PP<000<8H@<@XP9S;0?6>0?>N@?og`?o
o`?og`?gWP;_G@>Ld`>Ll`>U50=220<aYP8YA@<080<000<Q90<YA@DYI@HaQPVD/P;W70?gWPKoo`?g
_P>e]P=BRP8@PP<000<8@@=:J@>eUP?_O@;oo`?og`?gWP?_G@?W?0?Nn`:4<0Woo`8aYP<8@@<000<0
80<8H@<@PP9S30?660?g_PKoo`?g_PFeUP=:J@<@PP<000<8H@8@XP=S;0?6>0?>N@?og`?oo`;og`?g
WP?_G@>Ld`>Ll`>U50=2208aYP<YA@<080<000<Q90<YA@DYI@HaQPRD/P?W70?gWPKoo`?g_P:e]P=B
RP<@PP<000<8@@=:J@:eUP?_O@?oo`?og`?gWP?_G@?W?0;Nn`>4<0Soo`<aYP<8@@<000<08088H@<@
PP=S30?660?g_PGoo`?g_PJeUP=:J@<@PP<00088H@<@XP=S;0?6>0?>N@?og`;oo`?og`?gWP?_G@>L
d`>Ll`:U50=220<aYP<YA@<080<0008Q90<YA@HYI@HaQPRD/P?W70?gWPKoo`;g_P>e]P=BRP<@PP<0
00<8@@9:J@>eUP?_O@?oo`?og`?gWP;_G@?W?0?Nn`>4<1Soo`005ooo0bU50aSS1@000`0P0`QQ0a2R
0f]=0/Hh0oNn0ooo0ooO0oNN0nmm0icc0ZDD0cWW0c6V0`Q10`000a2R0QSS0b440b4T0bU51RUU0S66
0iBB0nLL1_oo0ooO0_NN0nmM0nLL0haA0c660`0P0P000`0P0`QQ0a2R0aS30g>>0lii0]kK0ooO0ooo
0ooO1/HH0U[[0e[;0a2R0`0P0`000aS30W>>0f]]0liI0oNn0ooo0nmM2?oo0bU50QSS1P000`0P0`QQ
0a2R0V]=0lHh0oNn0ooo0ooO0oNN0^mm0icc0jDD0cWW0c6V0`Q10P000a2R0aSS0b440b4T0bU51BUU
0c660iBB0nLL1_oo0_oO0oNN0nmM0nLL0haA0c660P0P0`000`0P0`QQ0a2R0aS30W>>0lii0mkK0ooO
0ooo0ooO1LHH0e[[0e[;0a2R0`0P0`000QS30g>>0f]]0liI0oNn0ooo0^mM2Ooo0RU50aSS1P000`0P
0`QQ0Q2R0f]=0lHh0oNn0ooo0ooO0_NN0nmm0icc0jDD0cWW0c6V0PQ10`000a2R0aSS0b440b4T0RU5
1RUU0c660iBB0nLL1Ooo0ooO0oNN0nmM0nLL0haA0S660`0P0`000`0P0`QQ0a2R0QS30g>>0lii0mkK
0ooO0ooo0_oO1/HH0e[[0e[;0a2R0P0P0`000aS30g>>0f]]0liI0oNn0_oo0nmM2?oo0bU50aSS1P00
0P0P0`QQ0a2R0f]=0lHh0oNn0_oo0ooO0oNN0nmm0icc0jDD0cWW0S6V0`Q10`000a2R0aSS0b440R4T
0bU51RUU0c660iBB0^LL1_oo0ooO0oNN0nmM0^LL0haA0c660`0P0`000`0P0PQQ0a2R0aS30g>>0lii
0mkK0ooO0_oo0ooO1/HH0e[[0e[;0Q2R0`0P0`000aS30g>>0f]]0/iI0oNn0ooo0nmM6?oo000Gool3
:DD36><50003020326434:83Jdd2aSP3mkh3ool3oml3mih3kgd3W?<2YA@3>NL3<JH3244300034:82
6><38@@38B@3:DD6:FD2<HH3U983ia`6ool3oml2mih3ked3ia`3S543<HH302020003020326434:83
6<<3Lhh3cWT2g]/3oml3ool3oml6aQP2F^/3F//34:83020300036<<2Lhh3Jfd3cUT3mkh3ool3ked8
ool3:DD26><60003020326434:82Jdd3aSP3mkh3ool3oml3mih2kgd3W?<3YA@3>NL3<JH324420003
4:836><38@@38B@3:DD5:FD3<HH3U983ia`6ool2oml3mih3ked3ia`3S543<HH20203000302032643
4:836<<2Lhh3cWT3g]/3oml3ool3oml5aQP3F^/3F//34:83020300026<<3Lhh3Jfd3cUT3mkh3ool2
ked9ool2:DD36><60003020326424:83Jdd3aSP3mkh3ool3oml2mih3kgd3W?<3YA@3>NL3<JH22443
00034:836><38@@38B@2:DD6:FD3<HH3U983ia`5ool3oml3mih3ked3ia`3S542<HH3020300030203
26434:826<<3Lhh3cWT3g]/3oml3ool2oml6aQP3F^/3F//34:82020300036<<3Lhh3Jfd3cUT3mkh2
ool3ked8ool3:DD36><60002020326434:83Jdd3aSP3mkh2ool3oml3mih3kgd3W?<3YA@3>NL2<JH3
244300034:836><38@@28B@3:DD6:FD3<HH3U982ia`6ool3oml3mih3ked2ia`3S543<HH302030003
020226434:836<<3Lhh3cWT3g]/3oml2ool3oml6aQP3F^/3F//24:83020300036<<3Lhh3Jfd2cUT3
mkh3ool3kedHool001Ooo`<YA@<Hh`D000<080<8H@<@XP=[C@;6>0?g_P?oo`?og`?gWP?_O@>Ll`:U
50<ii`<aYP<8@@<000<@XP8Hh`<Q10<Q90<YA@HYI@8aQP>DTP?W70Koo`?og`;gWP?_G@?W70><D@<a
QP<0808000<080<8H@<@XP<H``=cSP?>N@;Nf`?og`?oo`?og`K6609Jj`=Jb`<@XP<080<000<H``9c
SP=[K@?>F@?g_P?oo`?_G@Soo`<YA@8Hh`H000<080<8H@<@XP9[C@?6>0?g_P?oo`?og`?gWP;_O@>L
l`>U50<ii`<aYP<8@@8000<@XP<Hh`<Q10<Q90<YA@DYI@<aQP>DTP?W70Koo`;og`?gWP?_G@?W70><
D@<aQP8080<000<080<8H@<@XP<H``9cSP?>N@?Nf`?og`?oo`?og`G660=Jj`=Jb`<@XP<080<0008H
``=cSP=[K@?>F@?g_P?oo`;_G@Woo`8YA@<Hh`H000<080<8H@8@XP=[C@?6>0?g_P?oo`?og`;gWP?_
O@>Ll`>U50<ii`<aYP88@@<000<@XP<Hh`<Q10<Q908YA@HYI@<aQP>DTP?W70Goo`?og`?gWP?_G@?W
70><D@8aQP<080<000<080<8H@<@XP8H``=cSP?>N@?Nf`?og`?oo`;og`K660=Jj`=Jb`<@XP8080<0
00<H``=cSP=[K@?>F@?g_P;oo`?_G@Soo`<YA@<Hh`H0008080<8H@<@XP=[C@?6>0?g_P;oo`?og`?g
WP?_O@>Ll`>U50<ii`8aYP<8@@<000<@XP<Hh`<Q108Q90<YA@HYI@<aQP>DTP;W70Koo`?og`?gWP?_
G@;W70><D@<aQP<080<000<08088H@<@XP<H``=cSP?>N@?Nf`?og`;oo`?og`K660=Jj`=Jb`8@XP<0
80<000<H``=cSP=[K@;>F@?g_P?oo`?_GASoo`005ooo0bU50aSS1@000`0P0`QQ0a2R0f]=0/Hh0oNn
0ooo0ooO0oNN0nmm0icc0ZDD0cWW0c6V0`Q10`000a2R0QSS0b440b4T0bU51RUU0S660iBB0nLL1_oo
0ooO0_NN0nmM0nLL0haA0c660`0P0P000`0P0`QQ0a2R0aS30g>>0lii0]kK0ooO0ooo0ooO1/HH0U[[
0e[;0a2R0`0P0`000aS30W>>0f]]0liI0oNn0ooo0nmM2?oo0bU50QSS1P000`0P0`QQ0a2R0V]=0lHh
0oNn0ooo0ooO0oNN0^mm0icc0jDD0cWW0c6V0`Q10P000a2R0aSS0b440b4T0bU51BUU0c660iBB0nLL
1_oo0_oO0oNN0nmM0nLL0haA0c660P0P0`000`0P0`QQ0a2R0aS30W>>0lii0mkK0ooO0ooo0ooO1LHH
0e[[0e[;0a2R0`0P0`000QS30g>>0f]]0liI0oNn0ooo0^mM2Ooo0RU50aSS1P000`0P0`QQ0Q2R0f]=
0lHh0oNn0ooo0ooO0_NN0nmm0icc0jDD0cWW0c6V0PQ10`000a2R0aSS0b440b4T0RU51RUU0c660iBB
0nLL1Ooo0ooO0oNN0nmM0nLL0haA0S660`0P0`000`0P0`QQ0a2R0QS30g>>0lii0mkK0ooO0ooo0_oO
1/HH0e[[0e[;0a2R0P0P0`000aS30g>>0f]]0liI0oNn0_oo0nmM2?oo0bU50aSS1P000P0P0`QQ0a2R
0f]=0lHh0oNn0_oo0ooO0oNN0nmm0icc0jDD0cWW0S6V0`Q10`000a2R0aSS0b440R4T0bU51RUU0c66
0iBB0^LL1_oo0ooO0oNN0nmM0^LL0haA0c660`0P0`000`0P0PQQ0a2R0aS30g>>0lii0mkK0ooO0_oo
0ooO1/HH0e[[0e[;0Q2R0`0P0`000aS30g>>0f]]0/iI0oNn0ooo0nmM6?oo000Gool3:DD36><50003
020326434:83Jdd2aSP3mkh3ool3oml3mih3kgd3W?<2YA@3>NL3<JH3244300034:826><38@@38B@3
:DD6:FD2<HH3U983ia`6ool3oml2mih3ked3ia`3S543<HH302020003020326434:836<<3Lhh3cWT2
g]/3oml3ool3oml6aQP2F^/3F//34:83020300036<<2Lhh3Jfd3cUT3mkh3ool3ked8ool3:DD26><6
0003020326434:82Jdd3aSP3mkh3ool3oml3mih2kgd3W?<3YA@3>NL3<JH3244200034:836><38@@3
8B@3:DD5:FD3<HH3U983ia`6ool2oml3mih3ked3ia`3S543<HH202030003020326434:836<<2Lhh3
cWT3g]/3oml3ool3oml5aQP3F^/3F//34:83020300026<<3Lhh3Jfd3cUT3mkh3ool2ked9ool2:DD3
6><60003020326424:83Jdd3aSP3mkh3ool3oml2mih3kgd3W?<3YA@3>NL3<JH2244300034:836><3
8@@38B@2:DD6:FD3<HH3U983ia`5ool3oml3mih3ked3ia`3S542<HH302030003020326434:826<<3
Lhh3cWT3g]/3oml3ool2oml6aQP3F^/3F//34:82020300036<<3Lhh3Jfd3cUT3mkh2ool3ked8ool3
:DD36><60002020326434:83Jdd3aSP3mkh2ool3oml3mih3kgd3W?<3YA@3>NL2<JH3244300034:83
6><38@@28B@3:DD6:FD3<HH3U982ia`6ool3oml3mih3ked2ia`3S543<HH302030003020226434:83
6<<3Lhh3cWT3g]/3oml2ool3oml6aQP3F^/3F//24:83020300036<<3Lhh3Jfd2cUT3mkh3ool3kedH
ool001Ooo`<YA@<Hh`D000<080<8H@<@XP=[C@;6>0?g_P?oo`?og`?gWP?_O@>Ll`:U50<ii`<aYP<8
@@<000<@XP8Hh`<Q10<Q90<YA@HYI@8aQP>DTP?W70Koo`?og`;gWP?_G@?W70><D@<aQP<0808000<0
80<8H@<@XP<H``=cSP?>N@;Nf`?og`?oo`?og`K6609Jj`=Jb`<@XP<080<000<H``9cSP=[K@?>F@?g
_P?oo`?_G@Soo`<YA@8Hh`H000<080<8H@<@XP9[C@?6>0?g_P?oo`?og`?gWP;_O@>Ll`>U50<ii`<a
YP<8@@8000<@XP<Hh`<Q10<Q90<YA@DYI@<aQP>DTP?W70Koo`;og`?gWP?_G@?W70><D@<aQP8080<0
00<080<8H@<@XP<H``9cSP?>N@?Nf`?og`?oo`?og`G660=Jj`=Jb`<@XP<080<0008H``=cSP=[K@?>
F@?g_P?oo`;_G@Woo`8YA@<Hh`H000<080<8H@8@XP=[C@?6>0?g_P?oo`?og`;gWP?_O@>Ll`>U50<i
i`<aYP88@@<000<@XP<Hh`<Q10<Q908YA@HYI@<aQP>DTP?W70Goo`?og`?gWP?_G@?W70><D@8aQP<0
80<000<080<8H@<@XP8H``=cSP?>N@?Nf`?og`?oo`;og`K660=Jj`=Jb`<@XP8080<000<H``=cSP=[
K@?>F@?g_P;oo`?_G@Soo`<YA@<Hh`H0008080<8H@<@XP=[C@?6>0?g_P;oo`?og`?gWP?_O@>Ll`>U
50<ii`8aYP<8@@<000<@XP<Hh`<Q108Q90<YA@HYI@<aQP>DTP;W70Koo`?og`?gWP?_G@;W70><D@<a
QP<080<000<08088H@<@XP<H``=cSP?>N@?Nf`?og`;oo`?og`K660=Jj`=Jb`8@XP<080<000<H``=c
SP=[K@;>F@?g_P?oo`?_GASoo`005ooo0bU50aSS1@000`0P0`QQ0a2R0f]=0/Hh0oNn0ooo0ooO0oNN
0nmm0icc0ZDD0cWW0c6V0`Q10`000a2R0QSS0b440b4T0bU51RUU0S660iBB0nLL1_oo0ooO0_NN0nmM
0nLL0haA0c660`0P0P000`0P0`QQ0a2R0aS30g>>0lii0]kK0ooO0ooo0ooO1/HH0U[[0e[;0a2R0`0P
0`000aS30W>>0f]]0liI0oNn0ooo0nmM2?oo0bU50QSS1P000`0P0`QQ0a2R0V]=0lHh0oNn0ooo0ooO
0oNN0^mm0icc0jDD0cWW0c6V0`Q10P000a2R0aSS0b440b4T0bU51BUU0c660iBB0nLL1_oo0_oO0oNN
0nmM0nLL0haA0c660P0P0`000`0P0`QQ0a2R0aS30W>>0lii0mkK0ooO0ooo0ooO1LHH0e[[0e[;0a2R
0`0P0`000QS30g>>0f]]0liI0oNn0ooo0^mM2Ooo0RU50aSS1P000`0P0`QQ0Q2R0f]=0lHh0oNn0ooo
0ooO0_NN0nmm0icc0jDD0cWW0c6V0PQ10`000a2R0aSS0b440b4T0RU51RUU0c660iBB0nLL1Ooo0ooO
0oNN0nmM0nLL0haA0S660`0P0`000`0P0`QQ0a2R0QS30g>>0lii0mkK0ooO0ooo0_oO1/HH0e[[0e[;
0a2R0P0P0`000aS30g>>0f]]0liI0oNn0_oo0nmM2?oo0bU50aSS1P000P0P0`QQ0a2R0f]=0lHh0oNn
0_oo0ooO0oNN0nmm0icc0jDD0cWW0S6V0`Q10`000a2R0aSS0b440R4T0bU51RUU0c660iBB0^LL1_oo
0ooO0oNN0nmM0^LL0haA0c660`0P0`000`0P0PQQ0a2R0aS30g>>0lii0mkK0ooO0_oo0ooO1/HH0e[[
0e[;0Q2R0`0P0`000aS30g>>0f]]0/iI0oNn0ooo0nmM6?oo000Gool3:DD36><50003020326434:83
Jdd2aSP3mkh3ool3oml3mih3kgd3W?<2YA@3>NL3<JH3244300034:826><38@@38B@3:DD6:FD2<HH3
U983ia`6ool3oml2mih3ked3ia`3S543<HH302020003020326434:836<<3Lhh3cWT2g]/3oml3ool3
oml6aQP2F^/3F//34:83020300036<<2Lhh3Jfd3cUT3mkh3ool3ked8ool3:DD26><6000302032643
4:82Jdd3aSP3mkh3ool3oml3mih2kgd3W?<3YA@3>NL3<JH3244200034:836><38@@38B@3:DD5:FD3
<HH3U983ia`6ool2oml3mih3ked3ia`3S543<HH202030003020326434:836<<2Lhh3cWT3g]/3oml3
ool3oml5aQP3F^/3F//34:83020300026<<3Lhh3Jfd3cUT3mkh3ool2ked9ool2:DD36><600030203
26424:83Jdd3aSP3mkh3ool3oml2mih3kgd3W?<3YA@3>NL3<JH2244300034:836><38@@38B@2:DD6
:FD3<HH3U983ia`5ool3oml3mih3ked3ia`3S542<HH302030003020326434:826<<3Lhh3cWT3g]/3
oml3ool2oml6aQP3F^/3F//34:82020300036<<3Lhh3Jfd3cUT3mkh2ool3ked8ool3:DD36><60002
020326434:83Jdd3aSP3mkh2ool3oml3mih3kgd3W?<3YA@3>NL2<JH3244300034:836><38@@28B@3
:DD6:FD3<HH3U982ia`6ool3oml3mih3ked2ia`3S543<HH302030003020226434:836<<3Lhh3cWT3
g]/3oml2ool3oml6aQP3F^/3F//24:83020300036<<3Lhh3Jfd2cUT3mkh3ool3kedHool001Ooo`<Y
A@<Hh`D000<080<8H@<@XP=[C@;6>0?g_P?oo`?og`?gWP?_O@>Ll`:U50<ii`<aYP<8@@<000<@XP8H
h`<Q10<Q90<YA@HYI@8aQP>DTP?W70Koo`?og`;gWP?_G@?W70><D@<aQP<0808000<080<8H@<@XP<H
``=cSP?>N@;Nf`?og`?oo`?og`K6609Jj`=Jb`<@XP<080<000<H``9cSP=[K@?>F@?g_P?oo`?_G@So
o`<YA@8Hh`H000<080<8H@<@XP9[C@?6>0?g_P?oo`?og`?gWP;_O@>Ll`>U50<ii`<aYP<8@@8000<@
XP<Hh`<Q10<Q90<YA@DYI@<aQP>DTP?W70Koo`;og`?gWP?_G@?W70><D@<aQP8080<000<080<8H@<@
XP<H``9cSP?>N@?Nf`?og`?oo`?og`G660=Jj`=Jb`<@XP<080<0008H``=cSP=[K@?>F@?g_P?oo`;_
G@Woo`8YA@<Hh`H000<080<8H@8@XP=[C@?6>0?g_P?oo`?og`;gWP?_O@>Ll`>U50<ii`<aYP88@@<0
00<@XP<Hh`<Q10<Q908YA@HYI@<aQP>DTP?W70Goo`?og`?gWP?_G@?W70><D@8aQP<080<000<080<8
H@<@XP8H``=cSP?>N@?Nf`?og`?oo`;og`K660=Jj`=Jb`<@XP8080<000<H``=cSP=[K@?>F@?g_P;o
o`?_G@Soo`<YA@<Hh`H0008080<8H@<@XP=[C@?6>0?g_P;oo`?og`?gWP?_O@>Ll`>U50<ii`8aYP<8
@@<000<@XP<Hh`<Q108Q90<YA@HYI@<aQP>DTP;W70Koo`?og`?gWP?_G@;W70><D@<aQP<080<000<0
8088H@<@XP<H``=cSP?>N@?Nf`?og`;oo`?og`K660=Jj`=Jb`8@XP<080<000<H``=cSP=[K@;>F@?g
_P?oo`?_GASoo`005ooo0bU50aSS1@000`0P0`QQ0a2R0f]=0/Hh0oNn0ooo0ooO0oNN0nmm0icc0ZDD
0cWW0c6V0`Q10`000a2R0QSS0b440b4T0bU51RUU0S660iBB0nLL1_oo0ooO0_NN0nmM0nLL0haA0c66
0`0P0P000`0P0`QQ0a2R0aS30g>>0lii0]kK0ooO0ooo0ooO1/HH0U[[0e[;0a2R0`0P0`000aS30W>>
0f]]0liI0oNn0ooo0nmM2?oo0bU50QSS1P000`0P0`QQ0a2R0V]=0lHh0oNn0ooo0ooO0oNN0^mm0icc
0jDD0cWW0c6V0`Q10P000a2R0aSS0b440b4T0bU51BUU0c660iBB0nLL1_oo0_oO0oNN0nmM0nLL0haA
0c660P0P0`000`0P0`QQ0a2R0aS30W>>0lii0mkK0ooO0ooo0ooO1LHH0e[[0e[;0a2R0`0P0`000QS3
0g>>0f]]0liI0oNn0ooo0^mM2Ooo0RU50aSS1P000`0P0`QQ0Q2R0f]=0lHh0oNn0ooo0ooO0_NN0nmm
0icc0jDD0cWW0c6V0PQ10`000a2R0aSS0b440b4T0RU51RUU0c660iBB0nLL1Ooo0ooO0oNN0nmM0nLL
0haA0S660`0P0`000`0P0`QQ0a2R0QS30g>>0lii0mkK0ooO0ooo0_oO1/HH0e[[0e[;0a2R0P0P0`00
0aS30g>>0f]]0liI0oNn0_oo0nmM2?oo0bU50aSS1P000P0P0`QQ0a2R0f]=0lHh0oNn0_oo0ooO0oNN
0nmm0icc0jDD0cWW0S6V0`Q10`000a2R0aSS0b440R4T0bU51RUU0c660iBB0^LL1_oo0ooO0oNN0nmM
0^LL0haA0c660`0P0`000`0P0PQQ0a2R0aS30g>>0lii0mkK0ooO0_oo0ooO1/HH0e[[0e[;0Q2R0`0P
0`000aS30g>>0f]]0/iI0oNn0ooo0nmM6?oo000Gool3:DD36><50003020326434:83Jdd2aSP3mkh3
ool3oml3mih3kgd3W?<2YA@3>NL3<JH3244300034:826><38@@38B@3:DD6:FD2<HH3U983ia`6ool3
oml2mih3ked3ia`3S543<HH302020003020326434:836<<3Lhh3cWT2g]/3oml3ool3oml6aQP2F^/3
F//34:83020300036<<2Lhh3Jfd3cUT3mkh3ool3ked8ool3:DD26><60003020326434:82Jdd3aSP3
mkh3ool3oml3mih2kgd3W?<3YA@3>NL3<JH3244200034:836><38@@38B@3:DD5:FD3<HH3U983ia`6
ool2oml3mih3ked3ia`3S543<HH202030003020326434:836<<2Lhh3cWT3g]/3oml3ool3oml5aQP3
F^/3F//34:83020300026<<3Lhh3Jfd3cUT3mkh3ool2ked9ool2:DD36><60003020326424:83Jdd3
aSP3mkh3ool3oml2mih3kgd3W?<3YA@3>NL3<JH2244300034:836><38@@38B@2:DD6:FD3<HH3U983
ia`5ool3oml3mih3ked3ia`3S542<HH302030003020326434:826<<3Lhh3cWT3g]/3oml3ool2oml6
aQP3F^/3F//34:82020300036<<3Lhh3Jfd3cUT3mkh2ool3ked8ool3:DD36><60002020326434:83
Jdd3aSP3mkh2ool3oml3mih3kgd3W?<3YA@3>NL2<JH3244300034:836><38@@28B@3:DD6:FD3<HH3
U982ia`6ool3oml3mih3ked2ia`3S543<HH302030003020226434:836<<3Lhh3cWT3g]/3oml2ool3
oml6aQP3F^/3F//24:83020300036<<3Lhh3Jfd2cUT3mkh3ool3kedHool001Ooo`<YA@<Hh`D000<0
80<8H@<@XP=[C@;6>0?g_P?oo`?og`?gWP?_O@>Ll`:U50<ii`<aYP<8@@<000<@XP8Hh`<Q10<Q90<Y
A@HYI@8aQP>DTP?W70Koo`?og`;gWP?_G@?W70><D@<aQP<0808000<080<8H@<@XP<H``=cSP?>N@;N
f`?og`?oo`?og`K6609Jj`=Jb`<@XP<080<000<H``9cSP=[K@?>F@?g_P?oo`?_G@Soo`<YA@8Hh`H0
00<080<8H@<@XP9[C@?6>0?g_P?oo`?og`?gWP;_O@>Ll`>U50<ii`<aYP<8@@8000<@XP<Hh`<Q10<Q
90<YA@DYI@<aQP>DTP?W70Koo`;og`?gWP?_G@?W70><D@<aQP8080<000<080<8H@<@XP<H``9cSP?>
N@?Nf`?og`?oo`?og`G660=Jj`=Jb`<@XP<080<0008H``=cSP=[K@?>F@?g_P?oo`;_G@Woo`8YA@<H
h`H000<080<8H@8@XP=[C@?6>0?g_P?oo`?og`;gWP?_O@>Ll`>U50<ii`<aYP88@@<000<@XP<Hh`<Q
10<Q908YA@HYI@<aQP>DTP?W70Goo`?og`?gWP?_G@?W70><D@8aQP<080<000<080<8H@<@XP8H``=c
SP?>N@?Nf`?og`?oo`;og`K660=Jj`=Jb`<@XP8080<000<H``=cSP=[K@?>F@?g_P;oo`?_G@Soo`<Y
A@<Hh`H0008080<8H@<@XP=[C@?6>0?g_P;oo`?og`?gWP?_O@>Ll`>U50<ii`8aYP<8@@<000<@XP<H
h`<Q108Q90<YA@HYI@<aQP>DTP;W70Koo`?og`?gWP?_G@;W70><D@<aQP<080<000<08088H@<@XP<H
``=cSP?>N@?Nf`?og`;oo`?og`K660=Jj`=Jb`8@XP<080<000<H``=cSP=[K@;>F@?g_P?oo`?_GASo
o`005ooo0nLL0haA0RUU0b441P000`0P0`QQ0Q2R0aSS0g>>0lii0mkk1_oo0_Nn0nmm0nLl0nLL0h@`
0bUU0P0P0`000`0P0`QQ0a2R0aSS0R440g__0mJj0nLL0ooo0ooO0/HH0e[[0a2R0`0P0`000`0P0PQQ
0a2R0aS30b440b4T0h@@0mkK0_oO0ooo0mJj0mJJ27>>0g>^0b441P000`0P0PQQ0a2R0f</0lHh0oNn
2ooo0nLL0XaA0bUU0b441P000`0P0PQQ0a2R0aSS0g>>0lii0mkk1Ooo0oNn0nmm0nLl0nLL0X@`0bUU
0`0P0`000`0P0`QQ0a2R0QSS0b440g__0mJj0nLL0ooo0_oO0lHH0e[[0a2R0`0P0`000P0P0`QQ0a2R
0aS30b440b4T0X@@0mkK0ooO0ooo0mJj0mJJ27>>0g>^0b441P000P0P0`QQ0a2R0f</0lHh0oNn2ooo
0^LL0haA0bUU0b441P000P0P0`QQ0a2R0aSS0g>>0lii0]kk1_oo0oNn0nmm0nLl0^LL0h@`0bUU0`0P
0`000`0P0PQQ0a2R0aSS0b440g__0mJj0nLL0_oo0ooO0lHH0e[[0a2R0`0P0P000`0P0`QQ0a2R0aS3
0b440R4T0h@@0mkK0ooO0ooo0mJj0]JJ2G>>0g>^0b441@000`0P0`QQ0a2R0f</0lHh0_Nn2ooo0nLL
0haA0bUU0b441@000`0P0`QQ0a2R0aSS0W>>0lii0mkk1_oo0oNn0nmm0^Ll0nLL0h@`0bUU0`0P0`00
0P0P0`QQ0a2R0aSS0b440g__0]Jj0nLL0ooo0ooO0lHH0e[[0Q2R0`0P0`000`0P0`QQ0a2R0QS30b44
0b4T0h@@0mkK0ooO0ooo0]Jj0mJJ2G>>0g>^0R441P000`0P0`QQ0a2R0V</0lHh0oNn6ooo000Gool3
ia`3S542:FD38@@60003020326424:836><3Lhh3cWT3g_/6ool2mkh3kgd3ic`3ia`3Q303:FD20203
0003020326434:836><28@@3Nnl3e[X3ia`3ool3oml2aQP3F^/34:8302030003020226434:836<<3
8@@38B@3Q103g]/2oml3ool3e[X3eYX8Lhh3Ljh38@@60003020226434:83Hb`3aSP3mkh;ool3ia`2
S543:FD38@@60003020226434:836><3Lhh3cWT3g_/5ool3mkh3kgd3ic`3ia`2Q303:FD302030003
020326434:826><38@@3Nnl3e[X3ia`3ool2oml3aQP3F^/34:8302030002020326434:836<<38@@3
8B@2Q103g]/3oml3ool3e[X3eYX8Lhh3Ljh38@@60002020326434:83Hb`3aSP3mkh;ool2ia`3S543
:FD38@@60002020326434:836><3Lhh3cWT2g_/6ool3mkh3kgd3ic`2ia`3Q303:FD3020300030202
26434:836><38@@3Nnl3e[X3ia`2ool3oml3aQP3F^/34:8302020003020326434:836<<38@@28B@3
Q103g]/3oml3ool3e[X2eYX9Lhh3Ljh38@@50003020326434:83Hb`3aSP2mkh;ool3ia`3S543:FD3
8@@50003020326434:836><2Lhh3cWT3g_/6ool3mkh3kgd2ic`3ia`3Q303:FD30203000202032643
4:836><38@@3Nnl2e[X3ia`3ool3oml3aQP3F^/24:8302030003020326434:826<<38@@38B@3Q103
g]/3oml3ool2e[X3eYX9Lhh3Ljh28@@60003020326434:82Hb`3aSP3mkhKool001Ooo`?W70><D@8Y
I@<Q10H000<080<8H@8@XP<Hh`=cSP?>N@?Nn`Koo`;g_P?_O@?W?0?W70>4<0<YI@8080<000<080<8
H@<@XP<Hh`8Q10=kk`?F^P?W70?oo`?og`;660=Jj`<@XP<080<000<08088H@<@XP<H``<Q10<Q90>4
40?Nf`;og`?oo`?F^P?FVPQcSP=c[P<Q10H000<08088H@<@XP=S;0?6>0?g_P_oo`?W70:<D@<YI@<Q
10H000<08088H@<@XP<Hh`=cSP?>N@?Nn`Goo`?g_P?_O@?W?0?W70:4<0<YI@<080<000<080<8H@<@
XP8Hh`<Q10=kk`?F^P?W70?oo`;og`?660=Jj`<@XP<080<0008080<8H@<@XP<H``<Q10<Q90:440?N
f`?og`?oo`?F^P?FVPQcSP=c[P<Q10H0008080<8H@<@XP=S;0?6>0?g_P_oo`;W70><D@<YI@<Q10H0
008080<8H@<@XP<Hh`=cSP?>N@;Nn`Koo`?g_P?_O@?W?0;W70>4<0<YI@<080<000<08088H@<@XP<H
h`<Q10=kk`?F^P?W70;oo`?og`?660=Jj`<@XP<0808000<080<8H@<@XP<H``<Q108Q90>440?Nf`?o
g`?oo`?F^P;FVPUcSP=c[P<Q10D000<080<8H@<@XP=S;0?6>0;g_P_oo`?W70><D@<YI@<Q10D000<0
80<8H@<@XP<Hh`9cSP?>N@?Nn`Koo`?g_P?_O@;W?0?W70>4<0<YI@<080<0008080<8H@<@XP<Hh`<Q
10=kk`;F^P?W70?oo`?og`?660=Jj`8@XP<080<000<080<8H@<@XP8H``<Q10<Q90>440?Nf`?og`?o
o`;F^P?FVPUcSP=c[P8Q10H000<080<8H@<@XP9S;0?6>0?g_Q_oo`005ooo0nLL0haA0RUU0b441P00
0`0P0`QQ0Q2R0aSS0g>>0lii0mkk1_oo0_Nn0nmm0nLl0nLL0h@`0bUU0P0P0`000`0P0`QQ0a2R0aSS
0R440g__0mJj0nLL0ooo0ooO0/HH0e[[0a2R0`0P0`000`0P0PQQ0a2R0aS30b440b4T0h@@0mkK0_oO
0ooo0mJj0mJJ27>>0g>^0b441P000`0P0PQQ0a2R0f</0lHh0oNn2ooo0nLL0XaA0bUU0b441P000`0P
0PQQ0a2R0aSS0g>>0lii0mkk1Ooo0oNn0nmm0nLl0nLL0X@`0bUU0`0P0`000`0P0`QQ0a2R0QSS0b44
0g__0mJj0nLL0ooo0_oO0lHH0e[[0a2R0`0P0`000P0P0`QQ0a2R0aS30b440b4T0X@@0mkK0ooO0ooo
0mJj0mJJ27>>0g>^0b441P000P0P0`QQ0a2R0f</0lHh0oNn2ooo0^LL0haA0bUU0b441P000P0P0`QQ
0a2R0aSS0g>>0lii0]kk1_oo0oNn0nmm0nLl0^LL0h@`0bUU0`0P0`000`0P0PQQ0a2R0aSS0b440g__
0mJj0nLL0_oo0ooO0lHH0e[[0a2R0`0P0P000`0P0`QQ0a2R0aS30b440R4T0h@@0mkK0ooO0ooo0mJj
0]JJ2G>>0g>^0b441@000`0P0`QQ0a2R0f</0lHh0_Nn2ooo0nLL0haA0bUU0b441@000`0P0`QQ0a2R
0aSS0W>>0lii0mkk1_oo0oNn0nmm0^Ll0nLL0h@`0bUU0`0P0`000P0P0`QQ0a2R0aSS0b440g__0]Jj
0nLL0ooo0ooO0lHH0e[[0Q2R0`0P0`000`0P0`QQ0a2R0QS30b440b4T0h@@0mkK0ooO0ooo0]Jj0mJJ
2G>>0g>^0R441P000`0P0`QQ0a2R0V</0lHh0oNn6ooo000Gool3ia`3S542:FD38@@6000302032642
4:836><3Lhh3cWT3g_/6ool2mkh3kgd3ic`3ia`3Q303:FD202030003020326434:836><28@@3Nnl3
e[X3ia`3ool3oml2aQP3F^/34:8302030003020226434:836<<38@@38B@3Q103g]/2oml3ool3e[X3
eYX8Lhh3Ljh38@@60003020226434:83Hb`3aSP3mkh;ool3ia`2S543:FD38@@60003020226434:83
6><3Lhh3cWT3g_/5ool3mkh3kgd3ic`3ia`2Q303:FD302030003020326434:826><38@@3Nnl3e[X3
ia`3ool2oml3aQP3F^/34:8302030002020326434:836<<38@@38B@2Q103g]/3oml3ool3e[X3eYX8
Lhh3Ljh38@@60002020326434:83Hb`3aSP3mkh;ool2ia`3S543:FD38@@60002020326434:836><3
Lhh3cWT2g_/6ool3mkh3kgd3ic`2ia`3Q303:FD302030003020226434:836><38@@3Nnl3e[X3ia`2
ool3oml3aQP3F^/34:8302020003020326434:836<<38@@28B@3Q103g]/3oml3ool3e[X2eYX9Lhh3
Ljh38@@50003020326434:83Hb`3aSP2mkh;ool3ia`3S543:FD38@@50003020326434:836><2Lhh3
cWT3g_/6ool3mkh3kgd2ic`3ia`3Q303:FD302030002020326434:836><38@@3Nnl2e[X3ia`3ool3
oml3aQP3F^/24:8302030003020326434:826<<38@@38B@3Q103g]/3oml3ool2e[X3eYX9Lhh3Ljh2
8@@60003020326434:82Hb`3aSP3mkhKool001Ooo`?W70><D@8YI@<Q10H000<080<8H@8@XP<Hh`=c
SP?>N@?Nn`Koo`;g_P?_O@?W?0?W70>4<0<YI@8080<000<080<8H@<@XP<Hh`8Q10=kk`?F^P?W70?o
o`?og`;660=Jj`<@XP<080<000<08088H@<@XP<H``<Q10<Q90>440?Nf`;og`?oo`?F^P?FVPQcSP=c
[P<Q10H000<08088H@<@XP=S;0?6>0?g_P_oo`?W70:<D@<YI@<Q10H000<08088H@<@XP<Hh`=cSP?>
N@?Nn`Goo`?g_P?_O@?W?0?W70:4<0<YI@<080<000<080<8H@<@XP8Hh`<Q10=kk`?F^P?W70?oo`;o
g`?660=Jj`<@XP<080<0008080<8H@<@XP<H``<Q10<Q90:440?Nf`?og`?oo`?F^P?FVPQcSP=c[P<Q
10H0008080<8H@<@XP=S;0?6>0?g_P_oo`;W70><D@<YI@<Q10H0008080<8H@<@XP<Hh`=cSP?>N@;N
n`Koo`?g_P?_O@?W?0;W70>4<0<YI@<080<000<08088H@<@XP<Hh`<Q10=kk`?F^P?W70;oo`?og`?6
60=Jj`<@XP<0808000<080<8H@<@XP<H``<Q108Q90>440?Nf`?og`?oo`?F^P;FVPUcSP=c[P<Q10D0
00<080<8H@<@XP=S;0?6>0;g_P_oo`?W70><D@<YI@<Q10D000<080<8H@<@XP<Hh`9cSP?>N@?Nn`Ko
o`?g_P?_O@;W?0?W70>4<0<YI@<080<0008080<8H@<@XP<Hh`<Q10=kk`;F^P?W70?oo`?og`?660=J
j`8@XP<080<000<080<8H@<@XP8H``<Q10<Q90>440?Nf`?og`?oo`;F^P?FVPUcSP=c[P8Q10H000<0
80<8H@<@XP9S;0?6>0?g_Q_oo`005ooo0nLL0haA0RUU0b441P000`0P0`QQ0Q2R0aSS0g>>0lii0mkk
1_oo0_Nn0nmm0nLl0nLL0h@`0bUU0P0P0`000`0P0`QQ0a2R0aSS0R440g__0mJj0nLL0ooo0ooO0/HH
0e[[0a2R0`0P0`000`0P0PQQ0a2R0aS30b440b4T0h@@0mkK0_oO0ooo0mJj0mJJ27>>0g>^0b441P00
0`0P0PQQ0a2R0f</0lHh0oNn2ooo0nLL0XaA0bUU0b441P000`0P0PQQ0a2R0aSS0g>>0lii0mkk1Ooo
0oNn0nmm0nLl0nLL0X@`0bUU0`0P0`000`0P0`QQ0a2R0QSS0b440g__0mJj0nLL0ooo0_oO0lHH0e[[
0a2R0`0P0`000P0P0`QQ0a2R0aS30b440b4T0X@@0mkK0ooO0ooo0mJj0mJJ27>>0g>^0b441P000P0P
0`QQ0a2R0f</0lHh0oNn2ooo0^LL0haA0bUU0b441P000P0P0`QQ0a2R0aSS0g>>0lii0]kk1_oo0oNn
0nmm0nLl0^LL0h@`0bUU0`0P0`000`0P0PQQ0a2R0aSS0b440g__0mJj0nLL0_oo0ooO0lHH0e[[0a2R
0`0P0P000`0P0`QQ0a2R0aS30b440R4T0h@@0mkK0ooO0ooo0mJj0]JJ2G>>0g>^0b441@000`0P0`QQ
0a2R0f</0lHh0_Nn2ooo0nLL0haA0bUU0b441@000`0P0`QQ0a2R0aSS0W>>0lii0mkk1_oo0oNn0nmm
0^Ll0nLL0h@`0bUU0`0P0`000P0P0`QQ0a2R0aSS0b440g__0]Jj0nLL0ooo0ooO0lHH0e[[0Q2R0`0P
0`000`0P0`QQ0a2R0QS30b440b4T0h@@0mkK0ooO0ooo0]Jj0mJJ2G>>0g>^0R441P000`0P0`QQ0a2R
0V</0lHh0oNn6ooo000Gool3ia`3S542:FD38@@60003020326424:836><3Lhh3cWT3g_/6ool2mkh3
kgd3ic`3ia`3Q303:FD202030003020326434:836><28@@3Nnl3e[X3ia`3ool3oml2aQP3F^/34:83
02030003020226434:836<<38@@38B@3Q103g]/2oml3ool3e[X3eYX8Lhh3Ljh38@@6000302022643
4:83Hb`3aSP3mkh;ool3ia`2S543:FD38@@60003020226434:836><3Lhh3cWT3g_/5ool3mkh3kgd3
ic`3ia`2Q303:FD302030003020326434:826><38@@3Nnl3e[X3ia`3ool2oml3aQP3F^/34:830203
0002020326434:836<<38@@38B@2Q103g]/3oml3ool3e[X3eYX8Lhh3Ljh38@@60002020326434:83
Hb`3aSP3mkh;ool2ia`3S543:FD38@@60002020326434:836><3Lhh3cWT2g_/6ool3mkh3kgd3ic`2
ia`3Q303:FD302030003020226434:836><38@@3Nnl3e[X3ia`2ool3oml3aQP3F^/34:8302020003
020326434:836<<38@@28B@3Q103g]/3oml3ool3e[X2eYX9Lhh3Ljh38@@50003020326434:83Hb`3
aSP2mkh;ool3ia`3S543:FD38@@50003020326434:836><2Lhh3cWT3g_/6ool3mkh3kgd2ic`3ia`3
Q303:FD302030002020326434:836><38@@3Nnl2e[X3ia`3ool3oml3aQP3F^/24:83020300030203
26434:826<<38@@38B@3Q103g]/3oml3ool2e[X3eYX9Lhh3Ljh28@@60003020326434:82Hb`3aSP3
mkhKool001Ooo`?W70><D@8YI@<Q10H000<080<8H@8@XP<Hh`=cSP?>N@?Nn`Koo`;g_P?_O@?W?0?W
70>4<0<YI@8080<000<080<8H@<@XP<Hh`8Q10=kk`?F^P?W70?oo`?og`;660=Jj`<@XP<080<000<0
8088H@<@XP<H``<Q10<Q90>440?Nf`;og`?oo`?F^P?FVPQcSP=c[P<Q10H000<08088H@<@XP=S;0?6
>0?g_P_oo`?W70:<D@<YI@<Q10H000<08088H@<@XP<Hh`=cSP?>N@?Nn`Goo`?g_P?_O@?W?0?W70:4
<0<YI@<080<000<080<8H@<@XP8Hh`<Q10=kk`?F^P?W70?oo`;og`?660=Jj`<@XP<080<0008080<8
H@<@XP<H``<Q10<Q90:440?Nf`?og`?oo`?F^P?FVPQcSP=c[P<Q10H0008080<8H@<@XP=S;0?6>0?g
_P_oo`;W70><D@<YI@<Q10H0008080<8H@<@XP<Hh`=cSP?>N@;Nn`Koo`?g_P?_O@?W?0;W70>4<0<Y
I@<080<000<08088H@<@XP<Hh`<Q10=kk`?F^P?W70;oo`?og`?660=Jj`<@XP<0808000<080<8H@<@
XP<H``<Q108Q90>440?Nf`?og`?oo`?F^P;FVPUcSP=c[P<Q10D000<080<8H@<@XP=S;0?6>0;g_P_o
o`?W70><D@<YI@<Q10D000<080<8H@<@XP<Hh`9cSP?>N@?Nn`Koo`?g_P?_O@;W?0?W70>4<0<YI@<0
80<0008080<8H@<@XP<Hh`<Q10=kk`;F^P?W70?oo`?og`?660=Jj`8@XP<080<000<080<8H@<@XP8H
``<Q10<Q90>440?Nf`?og`?oo`;F^P?FVPUcSP=c[P8Q10H000<080<8H@<@XP9S;0?6>0?g_Q_oo`00
5ooo0nLL0haA0RUU0b441P000`0P0`QQ0Q2R0aSS0g>>0lii0mkk1_oo0_Nn0nmm0nLl0nLL0h@`0bUU
0P0P0`000`0P0`QQ0a2R0aSS0R440g__0mJj0nLL0ooo0ooO0/HH0e[[0a2R0`0P0`000`0P0PQQ0a2R
0aS30b440b4T0h@@0mkK0_oO0ooo0mJj0mJJ27>>0g>^0b441P000`0P0PQQ0a2R0f</0lHh0oNn2ooo
0nLL0XaA0bUU0b441P000`0P0PQQ0a2R0aSS0g>>0lii0mkk1Ooo0oNn0nmm0nLl0nLL0X@`0bUU0`0P
0`000`0P0`QQ0a2R0QSS0b440g__0mJj0nLL0ooo0_oO0lHH0e[[0a2R0`0P0`000P0P0`QQ0a2R0aS3
0b440b4T0X@@0mkK0ooO0ooo0mJj0mJJ27>>0g>^0b441P000P0P0`QQ0a2R0f</0lHh0oNn2ooo0^LL
0haA0bUU0b441P000P0P0`QQ0a2R0aSS0g>>0lii0]kk1_oo0oNn0nmm0nLl0^LL0h@`0bUU0`0P0`00
0`0P0PQQ0a2R0aSS0b440g__0mJj0nLL0_oo0ooO0lHH0e[[0a2R0`0P0P000`0P0`QQ0a2R0aS30b44
0R4T0h@@0mkK0ooO0ooo0mJj0]JJ2G>>0g>^0b441@000`0P0`QQ0a2R0f</0lHh0_Nn2ooo0nLL0haA
0bUU0b441@000`0P0`QQ0a2R0aSS0W>>0lii0mkk1_oo0oNn0nmm0^Ll0nLL0h@`0bUU0`0P0`000P0P
0`QQ0a2R0aSS0b440g__0]Jj0nLL0ooo0ooO0lHH0e[[0Q2R0`0P0`000`0P0`QQ0a2R0QS30b440b4T
0h@@0mkK0ooO0ooo0]Jj0mJJ2G>>0g>^0R441P000`0P0`QQ0a2R0V</0lHh0oNn6ooo000Gool3ia`3
S542:FD38@@60003020326424:836><3Lhh3cWT3g_/6ool2mkh3kgd3ic`3ia`3Q303:FD202030003
020326434:836><28@@3Nnl3e[X3ia`3ool3oml2aQP3F^/34:8302030003020226434:836<<38@@3
8B@3Q103g]/2oml3ool3e[X3eYX8Lhh3Ljh38@@60003020226434:83Hb`3aSP3mkh;ool3ia`2S543
:FD38@@60003020226434:836><3Lhh3cWT3g_/5ool3mkh3kgd3ic`3ia`2Q303:FD3020300030203
26434:826><38@@3Nnl3e[X3ia`3ool2oml3aQP3F^/34:8302030002020326434:836<<38@@38B@2
Q103g]/3oml3ool3e[X3eYX8Lhh3Ljh38@@60002020326434:83Hb`3aSP3mkh;ool2ia`3S543:FD3
8@@60002020326434:836><3Lhh3cWT2g_/6ool3mkh3kgd3ic`2ia`3Q303:FD30203000302022643
4:836><38@@3Nnl3e[X3ia`2ool3oml3aQP3F^/34:8302020003020326434:836<<38@@28B@3Q103
g]/3oml3ool3e[X2eYX9Lhh3Ljh38@@50003020326434:83Hb`3aSP2mkh;ool3ia`3S543:FD38@@5
0003020326434:836><2Lhh3cWT3g_/6ool3mkh3kgd2ic`3ia`3Q303:FD302030002020326434:83
6><38@@3Nnl2e[X3ia`3ool3oml3aQP3F^/24:8302030003020326434:826<<38@@38B@3Q103g]/3
oml3ool2e[X3eYX9Lhh3Ljh28@@60003020326434:82Hb`3aSP3mkhKool001Ooo`?og`?g_P:eUP=:
J@=2:0<ii`<aQP<8@@8000<080<8H@<@XP<H``=cSP=[K@9[C@?>F@?F^P?og`?oo`?og`;gWPJ]M@=:
B@<8H@D000<8@@=:B@>]M@?_O@?oo`;gWP?_G@>Ll`JU50>U=0:]E@J]M@JeUPJe]P9BRP<@PPH000<8
@@=:B@92:0>]E@?_O@?oo`?g_P?_O@:Ll`>U50=220<8H@H000Soo`?og`;g_P>eUP=:J@=2:0<ii`<a
QP88@@<000<080<8H@<@XP<H``9cSP=[K@=[C@?>F@?F^P?og`;oo`?og`?gWPJ]M@=:B@<8H@D000<8
@@=:B@>]M@?_O@;oo`?gWP?_G@>Ll`JU50:U=0>]E@J]M@JeUPFe]P=BRP<@PPH000<8@@9:B@=2:0>]
E@?_O@?oo`?g_P;_O@>Ll`>U50=220<8H@D000Woo`;og`?g_P>eUP=:J@=2:0<ii`8aQP<8@@<000<0
80<8H@<@XP8H``=cSP=[K@=[C@?>F@?F^P;og`?oo`?og`?gWPJ]M@9:B@<8H@H000<8@@=:B@>]M@;_
O@?oo`?gWP?_G@>Ll`FU50>U=0>]E@J]M@FeUPJe]P=BRP<@PPD000<8@@=:B@=2:0>]E@?_O@;oo`?g
_P?_O@>Ll`>U50=220<8H@D000Soo`?og`?g_P>eUP=:J@92:0<ii`<aQP<8@@<000<08088H@<@XP<H
``=cSP=[K@=[C@?>F@;F^P?og`?oo`?og`?gWPF]M@=:B@<8H@H000<8@@9:B@>]M@?_O@?oo`?gWP?_
G@:Ll`JU50>U=0>]E@F]M@JeUPJe]P=BRP<@PPD000<8@@=:B@=2:0>]E@;_O@?oo`?g_P?_O@>Ll`>U
509220<8H@H001Soo`005ooo0ooO0oNn0[FF0dYY0d8X0cWW0c660`Q10P000`0P0`QQ0a2R0aS30g>>
0f]]0V]=0liI0mJj0ooO0ooo0ooO0_NN1Zee0dY90`QQ1@000`Q10dY90jee0nmm0ooo0_NN0nmM0icc
1ZDD0jDd0ZeE1Zee1[FF1[Ff0U::0a221P000`Q10dY90T8X0jeE0nmm0ooo0oNn0nmm0Ycc0jDD0d88
0`QQ1P002?oo0ooO0_Nn0kFF0dYY0d8X0cWW0c660PQ10`000`0P0`QQ0a2R0aS30W>>0f]]0f]=0liI
0mJj0ooO0_oo0ooO0oNN1Zee0dY90`QQ1@000`Q10dY90jee0nmm0_oo0oNN0nmM0icc1ZDD0ZDd0jeE
1Zee1[FF1KFf0e::0a221P000`Q10TY90d8X0jeE0nmm0ooo0oNn0^mm0icc0jDD0d880`QQ1@002Ooo
0_oO0oNn0kFF0dYY0d8X0cWW0S660`Q10`000`0P0`QQ0a2R0QS30g>>0f]]0f]=0liI0mJj0_oO0ooo
0ooO0oNN1Zee0TY90`QQ1P000`Q10dY90jee0^mm0ooo0oNN0nmM0icc1JDD0jDd0jeE1Zee1KFF1[Ff
0e::0a221@000`Q10dY90d8X0jeE0nmm0_oo0oNn0nmm0icc0jDD0d880`QQ1@002?oo0ooO0oNn0kFF
0dYY0T8X0cWW0c660`Q10`000`0P0PQQ0a2R0aS30g>>0f]]0f]=0liI0]Jj0ooO0ooo0ooO0oNN1Jee
0dY90`QQ1P000`Q10TY90jee0nmm0ooo0oNN0nmM0Ycc1ZDD0jDd0jeE1Jee1[FF1[Ff0e::0a221@00
0`Q10dY90d8X0jeE0^mm0ooo0oNn0nmm0icc0jDD0T880`QQ1P006?oo000Gool3oml3mkh2]IH3BVT3
@RP3>NL3<HH324420003020326434:836<<3Lhh3Jfd2Jdd3cUT3e[X3oml3ool3oml2mih6[GD3BTT3
264500032443BTT3[GD3kgd3ool2mih3ked3W?<6YA@3YC@2[ED6[GD6]IH6]KH2DXX3488600032443
BTT2@RP3[ED3kgd3ool3mkh3kgd2W?<3YA@3@PP326460008ool3oml2mkh3]IH3BVT3@RP3>NL3<HH2
24430003020326434:836<<2Lhh3Jfd3Jdd3cUT3e[X3oml2ool3oml3mih6[GD3BTT3264500032443
BTT3[GD3kgd2ool3mih3ked3W?<6YA@2YC@3[ED6[GD6]IH5]KH3DXX3488600032442BTT3@RP3[ED3
kgd3ool3mkh2kgd3W?<3YA@3@PP326450009ool2oml3mkh3]IH3BVT3@RP3>NL2<HH3244300030203
26434:826<<3Lhh3Jfd3Jdd3cUT3e[X2oml3ool3oml3mih6[GD2BTT3264600032443BTT3[GD2kgd3
ool3mih3ked3W?<5YA@3YC@3[ED6[GD5]IH6]KH3DXX3488500032443BTT3@RP3[ED3kgd2ool3mkh3
kgd3W?<3YA@3@PP326450008ool3oml3mkh3]IH3BVT2@RP3>NL3<HH324430003020226434:836<<3
Lhh3Jfd3Jdd3cUT2e[X3oml3ool3oml3mih5[GD3BTT3264600032442BTT3[GD3kgd3ool3mih3ked2
W?<6YA@3YC@3[ED5[GD6]IH6]KH3DXX3488500032443BTT3@RP3[ED2kgd3ool3mkh3kgd3W?<3YA@2
@PP32646000Hool001Ooo`?og`?g_P:eUP=:J@=2:0<ii`<aQP<8@@8000<080<8H@<@XP<H``=cSP=[
K@9[C@?>F@?F^P?og`?oo`?og`;gWPJ]M@=:B@<8H@D000<8@@=:B@>]M@?_O@?oo`;gWP?_G@>Ll`JU
50>U=0:]E@J]M@JeUPJe]P9BRP<@PPH000<8@@=:B@92:0>]E@?_O@?oo`?g_P?_O@:Ll`>U50=220<8
H@H000Soo`?og`;g_P>eUP=:J@=2:0<ii`<aQP88@@<000<080<8H@<@XP<H``9cSP=[K@=[C@?>F@?F
^P?og`;oo`?og`?gWPJ]M@=:B@<8H@D000<8@@=:B@>]M@?_O@;oo`?gWP?_G@>Ll`JU50:U=0>]E@J]
M@JeUPFe]P=BRP<@PPH000<8@@9:B@=2:0>]E@?_O@?oo`?g_P;_O@>Ll`>U50=220<8H@D000Woo`;o
g`?g_P>eUP=:J@=2:0<ii`8aQP<8@@<000<080<8H@<@XP8H``=cSP=[K@=[C@?>F@?F^P;og`?oo`?o
g`?gWPJ]M@9:B@<8H@H000<8@@=:B@>]M@;_O@?oo`?gWP?_G@>Ll`FU50>U=0>]E@J]M@FeUPJe]P=B
RP<@PPD000<8@@=:B@=2:0>]E@?_O@;oo`?g_P?_O@>Ll`>U50=220<8H@D000Soo`?og`?g_P>eUP=:
J@92:0<ii`<aQP<8@@<000<08088H@<@XP<H``=cSP=[K@=[C@?>F@;F^P?og`?oo`?og`?gWPF]M@=:
B@<8H@H000<8@@9:B@>]M@?_O@?oo`?gWP?_G@:Ll`JU50>U=0>]E@F]M@JeUPJe]P=BRP<@PPD000<8
@@=:B@=2:0>]E@;_O@?oo`?g_P?_O@>Ll`>U509220<8H@H001Soo`005ooo0ooO0oNn0[FF0dYY0d8X
0cWW0c660`Q10P000`0P0`QQ0a2R0aS30g>>0f]]0V]=0liI0mJj0ooO0ooo0ooO0_NN1Zee0dY90`QQ
1@000`Q10dY90jee0nmm0ooo0_NN0nmM0icc1ZDD0jDd0ZeE1Zee1[FF1[Ff0U::0a221P000`Q10dY9
0T8X0jeE0nmm0ooo0oNn0nmm0Ycc0jDD0d880`QQ1P002?oo0ooO0_Nn0kFF0dYY0d8X0cWW0c660PQ1
0`000`0P0`QQ0a2R0aS30W>>0f]]0f]=0liI0mJj0ooO0_oo0ooO0oNN1Zee0dY90`QQ1@000`Q10dY9
0jee0nmm0_oo0oNN0nmM0icc1ZDD0ZDd0jeE1Zee1[FF1KFf0e::0a221P000`Q10TY90d8X0jeE0nmm
0ooo0oNn0^mm0icc0jDD0d880`QQ1@002Ooo0_oO0oNn0kFF0dYY0d8X0cWW0S660`Q10`000`0P0`QQ
0a2R0QS30g>>0f]]0f]=0liI0mJj0_oO0ooo0ooO0oNN1Zee0TY90`QQ1P000`Q10dY90jee0^mm0ooo
0oNN0nmM0icc1JDD0jDd0jeE1Zee1KFF1[Ff0e::0a221@000`Q10dY90d8X0jeE0nmm0_oo0oNn0nmm
0icc0jDD0d880`QQ1@002?oo0ooO0oNn0kFF0dYY0T8X0cWW0c660`Q10`000`0P0PQQ0a2R0aS30g>>
0f]]0f]=0liI0]Jj0ooO0ooo0ooO0oNN1Jee0dY90`QQ1P000`Q10TY90jee0nmm0ooo0oNN0nmM0Ycc
1ZDD0jDd0jeE1Jee1[FF1[Ff0e::0a221@000`Q10dY90d8X0jeE0^mm0ooo0oNn0nmm0icc0jDD0T88
0`QQ1P006?oo000Gool3oml3mkh2]IH3BVT3@RP3>NL3<HH324420003020326434:836<<3Lhh3Jfd2
Jdd3cUT3e[X3oml3ool3oml2mih6[GD3BTT3264500032443BTT3[GD3kgd3ool2mih3ked3W?<6YA@3
YC@2[ED6[GD6]IH6]KH2DXX3488600032443BTT2@RP3[ED3kgd3ool3mkh3kgd2W?<3YA@3@PP32646
0008ool3oml2mkh3]IH3BVT3@RP3>NL3<HH224430003020326434:836<<2Lhh3Jfd3Jdd3cUT3e[X3
oml2ool3oml3mih6[GD3BTT3264500032443BTT3[GD3kgd2ool3mih3ked3W?<6YA@2YC@3[ED6[GD6
]IH5]KH3DXX3488600032442BTT3@RP3[ED3kgd3ool3mkh2kgd3W?<3YA@3@PP326450009ool2oml3
mkh3]IH3BVT3@RP3>NL2<HH324430003020326434:826<<3Lhh3Jfd3Jdd3cUT3e[X2oml3ool3oml3
mih6[GD2BTT3264600032443BTT3[GD2kgd3ool3mih3ked3W?<5YA@3YC@3[ED6[GD5]IH6]KH3DXX3
488500032443BTT3@RP3[ED3kgd2ool3mkh3kgd3W?<3YA@3@PP326450008ool3oml3mkh3]IH3BVT2
@RP3>NL3<HH324430003020226434:836<<3Lhh3Jfd3Jdd3cUT2e[X3oml3ool3oml3mih5[GD3BTT3
264600032442BTT3[GD3kgd3ool3mih3ked2W?<6YA@3YC@3[ED5[GD6]IH6]KH3DXX3488500032443
BTT3@RP3[ED2kgd3ool3mkh3kgd3W?<3YA@2@PP32646000Hool001Ooo`?og`?g_P:eUP=:J@=2:0<i
i`<aQP<8@@8000<080<8H@<@XP<H``=cSP=[K@9[C@?>F@?F^P?og`?oo`?og`;gWPJ]M@=:B@<8H@D0
00<8@@=:B@>]M@?_O@?oo`;gWP?_G@>Ll`JU50>U=0:]E@J]M@JeUPJe]P9BRP<@PPH000<8@@=:B@92
:0>]E@?_O@?oo`?g_P?_O@:Ll`>U50=220<8H@H000Soo`?og`;g_P>eUP=:J@=2:0<ii`<aQP88@@<0
00<080<8H@<@XP<H``9cSP=[K@=[C@?>F@?F^P?og`;oo`?og`?gWPJ]M@=:B@<8H@D000<8@@=:B@>]
M@?_O@;oo`?gWP?_G@>Ll`JU50:U=0>]E@J]M@JeUPFe]P=BRP<@PPH000<8@@9:B@=2:0>]E@?_O@?o
o`?g_P;_O@>Ll`>U50=220<8H@D000Woo`;og`?g_P>eUP=:J@=2:0<ii`8aQP<8@@<000<080<8H@<@
XP8H``=cSP=[K@=[C@?>F@?F^P;og`?oo`?og`?gWPJ]M@9:B@<8H@H000<8@@=:B@>]M@;_O@?oo`?g
WP?_G@>Ll`FU50>U=0>]E@J]M@FeUPJe]P=BRP<@PPD000<8@@=:B@=2:0>]E@?_O@;oo`?g_P?_O@>L
l`>U50=220<8H@D000Soo`?og`?g_P>eUP=:J@92:0<ii`<aQP<8@@<000<08088H@<@XP<H``=cSP=[
K@=[C@?>F@;F^P?og`?oo`?og`?gWPF]M@=:B@<8H@H000<8@@9:B@>]M@?_O@?oo`?gWP?_G@:Ll`JU
50>U=0>]E@F]M@JeUPJe]P=BRP<@PPD000<8@@=:B@=2:0>]E@;_O@?oo`?g_P?_O@>Ll`>U509220<8
H@H001Soo`005ooo0ooO0oNn0[FF0dYY0d8X0cWW0c660`Q10P000`0P0`QQ0a2R0aS30g>>0f]]0V]=
0liI0mJj0ooO0ooo0ooO0_NN1Zee0dY90`QQ1@000`Q10dY90jee0nmm0ooo0_NN0nmM0icc1ZDD0jDd
0ZeE1Zee1[FF1[Ff0U::0a221P000`Q10dY90T8X0jeE0nmm0ooo0oNn0nmm0Ycc0jDD0d880`QQ1P00
2?oo0ooO0_Nn0kFF0dYY0d8X0cWW0c660PQ10`000`0P0`QQ0a2R0aS30W>>0f]]0f]=0liI0mJj0ooO
0_oo0ooO0oNN1Zee0dY90`QQ1@000`Q10dY90jee0nmm0_oo0oNN0nmM0icc1ZDD0ZDd0jeE1Zee1[FF
1KFf0e::0a221P000`Q10TY90d8X0jeE0nmm0ooo0oNn0^mm0icc0jDD0d880`QQ1@002Ooo0_oO0oNn
0kFF0dYY0d8X0cWW0S660`Q10`000`0P0`QQ0a2R0QS30g>>0f]]0f]=0liI0mJj0_oO0ooo0ooO0oNN
1Zee0TY90`QQ1P000`Q10dY90jee0^mm0ooo0oNN0nmM0icc1JDD0jDd0jeE1Zee1KFF1[Ff0e::0a22
1@000`Q10dY90d8X0jeE0nmm0_oo0oNn0nmm0icc0jDD0d880`QQ1@002?oo0ooO0oNn0kFF0dYY0T8X
0cWW0c660`Q10`000`0P0PQQ0a2R0aS30g>>0f]]0f]=0liI0]Jj0ooO0ooo0ooO0oNN1Jee0dY90`QQ
1P000`Q10TY90jee0nmm0ooo0oNN0nmM0Ycc1ZDD0jDd0jeE1Jee1[FF1[Ff0e::0a221@000`Q10dY9
0d8X0jeE0^mm0ooo0oNn0nmm0icc0jDD0T880`QQ1P006?oo000Gool3oml3mkh2]IH3BVT3@RP3>NL3
<HH324420003020326434:836<<3Lhh3Jfd2Jdd3cUT3e[X3oml3ool3oml2mih6[GD3BTT326450003
2443BTT3[GD3kgd3ool2mih3ked3W?<6YA@3YC@2[ED6[GD6]IH6]KH2DXX3488600032443BTT2@RP3
[ED3kgd3ool3mkh3kgd2W?<3YA@3@PP326460008ool3oml2mkh3]IH3BVT3@RP3>NL3<HH224430003
020326434:836<<2Lhh3Jfd3Jdd3cUT3e[X3oml2ool3oml3mih6[GD3BTT3264500032443BTT3[GD3
kgd2ool3mih3ked3W?<6YA@2YC@3[ED6[GD6]IH5]KH3DXX3488600032442BTT3@RP3[ED3kgd3ool3
mkh2kgd3W?<3YA@3@PP326450009ool2oml3mkh3]IH3BVT3@RP3>NL2<HH324430003020326434:82
6<<3Lhh3Jfd3Jdd3cUT3e[X2oml3ool3oml3mih6[GD2BTT3264600032443BTT3[GD2kgd3ool3mih3
ked3W?<5YA@3YC@3[ED6[GD5]IH6]KH3DXX3488500032443BTT3@RP3[ED3kgd2ool3mkh3kgd3W?<3
YA@3@PP326450008ool3oml3mkh3]IH3BVT2@RP3>NL3<HH324430003020226434:836<<3Lhh3Jfd3
Jdd3cUT2e[X3oml3ool3oml3mih5[GD3BTT3264600032442BTT3[GD3kgd3ool3mih3ked2W?<6YA@3
YC@3[ED5[GD6]IH6]KH3DXX3488500032443BTT3@RP3[ED2kgd3ool3mkh3kgd3W?<3YA@2@PP32646
000Hool001Ooo`?og`?g_P:eUP=:J@=2:0<ii`<aQP<8@@8000<080<8H@<@XP<H``=cSP=[K@9[C@?>
F@?F^P?og`?oo`?og`;gWPJ]M@=:B@<8H@D000<8@@=:B@>]M@?_O@?oo`;gWP?_G@>Ll`JU50>U=0:]
E@J]M@JeUPJe]P9BRP<@PPH000<8@@=:B@92:0>]E@?_O@?oo`?g_P?_O@:Ll`>U50=220<8H@H000So
o`?og`;g_P>eUP=:J@=2:0<ii`<aQP88@@<000<080<8H@<@XP<H``9cSP=[K@=[C@?>F@?F^P?og`;o
o`?og`?gWPJ]M@=:B@<8H@D000<8@@=:B@>]M@?_O@;oo`?gWP?_G@>Ll`JU50:U=0>]E@J]M@JeUPFe
]P=BRP<@PPH000<8@@9:B@=2:0>]E@?_O@?oo`?g_P;_O@>Ll`>U50=220<8H@D000Woo`;og`?g_P>e
UP=:J@=2:0<ii`8aQP<8@@<000<080<8H@<@XP8H``=cSP=[K@=[C@?>F@?F^P;og`?oo`?og`?gWPJ]
M@9:B@<8H@H000<8@@=:B@>]M@;_O@?oo`?gWP?_G@>Ll`FU50>U=0>]E@J]M@FeUPJe]P=BRP<@PPD0
00<8@@=:B@=2:0>]E@?_O@;oo`?g_P?_O@>Ll`>U50=220<8H@D000Soo`?og`?g_P>eUP=:J@92:0<i
i`<aQP<8@@<000<08088H@<@XP<H``=cSP=[K@=[C@?>F@;F^P?og`?oo`?og`?gWPF]M@=:B@<8H@H0
00<8@@9:B@>]M@?_O@?oo`?gWP?_G@:Ll`JU50>U=0>]E@F]M@JeUPJe]P=BRP<@PPD000<8@@=:B@=2
:0>]E@;_O@?oo`?g_P?_O@>Ll`>U509220<8H@H001Soo`005ooo0ooO0oNn0[FF0dYY0d8X0cWW0c66
0`Q10P000`0P0`QQ0a2R0aS30g>>0f]]0V]=0liI0mJj0ooO0ooo0ooO0_NN1Zee0dY90`QQ1@000`Q1
0dY90jee0nmm0ooo0_NN0nmM0icc1ZDD0jDd0ZeE1Zee1[FF1[Ff0U::0a221P000`Q10dY90T8X0jeE
0nmm0ooo0oNn0nmm0Ycc0jDD0d880`QQ1P002?oo0ooO0_Nn0kFF0dYY0d8X0cWW0c660PQ10`000`0P
0`QQ0a2R0aS30W>>0f]]0f]=0liI0mJj0ooO0_oo0ooO0oNN1Zee0dY90`QQ1@000`Q10dY90jee0nmm
0_oo0oNN0nmM0icc1ZDD0ZDd0jeE1Zee1[FF1KFf0e::0a221P000`Q10TY90d8X0jeE0nmm0ooo0oNn
0^mm0icc0jDD0d880`QQ1@002Ooo0_oO0oNn0kFF0dYY0d8X0cWW0S660`Q10`000`0P0`QQ0a2R0QS3
0g>>0f]]0f]=0liI0mJj0_oO0ooo0ooO0oNN1Zee0TY90`QQ1P000`Q10dY90jee0^mm0ooo0oNN0nmM
0icc1JDD0jDd0jeE1Zee1KFF1[Ff0e::0a221@000`Q10dY90d8X0jeE0nmm0_oo0oNn0nmm0icc0jDD
0d880`QQ1@002?oo0ooO0oNn0kFF0dYY0T8X0cWW0c660`Q10`000`0P0PQQ0a2R0aS30g>>0f]]0f]=
0liI0]Jj0ooO0ooo0ooO0oNN1Jee0dY90`QQ1P000`Q10TY90jee0nmm0ooo0oNN0nmM0Ycc1ZDD0jDd
0jeE1Jee1[FF1[Ff0e::0a221@000`Q10dY90d8X0jeE0^mm0ooo0oNn0nmm0icc0jDD0T880`QQ1P00
6?oo000Gool32443BVT2]IH3kgd6ool3eYX5cWT3Jfd36><326460005<HH3U;83ia`6ool3g]/5e[X3
eYX9cWT8Jdd36><30003020226434:836<<3Lhh3cWT3oml2ool3ic`3ia`3g_/3g]/3Nll5Nnl3Q103
:DD36<<600022446@PP3YC@3ked3oml2ool3mkh3_ML3DZX34:830208ool32442BVT3]IH3kgd6ool3
eYX5cWT3Jfd36><326450006<HH3U;83ia`5ool3g]/6e[X3eYX8cWT9Jdd36><30002020326434:83
6<<3Lhh3cWT2oml3ool3ic`3ia`3g_/3g]/2Nll6Nnl3Q103:DD36<<500032446@PP3YC@3ked2oml3
ool3mkh3_ML3DZX34:820209ool22443BVT3]IH3kgd6ool2eYX6cWT3Jfd36><326450006<HH3U;83
ia`5ool3g]/6e[X3eYX8cWT9Jdd36><20003020326434:836<<3Lhh2cWT3oml3ool3ic`3ia`3g_/2
g]/3Nll6Nnl3Q103:DD26<<600032446@PP2YC@3ked3oml3ool3mkh3_ML3DZX24:830208ool32443
BVT3]IH3kgd5ool3eYX6cWT3Jfd26><326460006<HH3U;82ia`6ool3g]/6e[X2eYX9cWT8Jdd36><3
0003020326434:826<<3Lhh3cWT3oml3ool3ic`2ia`3g_/3g]/3Nll6Nnl3Q102:DD36<<600032445
@PP3YC@3ked3oml3ool3mkh2_ML3DZX34:83020Hool001Ooo`<8@@=:J@:eUP?_O@Koo`?FVPG>N@=[
K@<Hh`<8H@H000DaQP>D/P?W70Koo`?Nf`GF^P?FVPW>N@Q[C@<Hh`<000<08088H@<@XP<H``=cSP?>
N@?og`;oo`?W?0?W70?Nn`?Nf`=kc`Ekk`>440<YA@<H``H00088@@I220>U=0?_G@?og`;oo`?g_P>m
e`=BZP<@XP<080Soo`<8@@9:J@>eUP?_O@Koo`?FVPG>N@=[K@<Hh`<8H@D000HaQP>D/P?W70Goo`?N
f`KF^P?FVPS>N@U[C@<Hh`<0008080<8H@<@XP<H``=cSP?>N@;og`?oo`?W?0?W70?Nn`?Nf`9kc`Ik
k`>440<YA@<H``D000<8@@I220>U=0?_G@;og`?oo`?g_P>me`=BZP<@XP8080Woo`88@@=:J@>eUP?_
O@Koo`;FVPK>N@=[K@<Hh`<8H@D000HaQP>D/P?W70Goo`?Nf`KF^P?FVPS>N@U[C@<Hh`8000<080<8
H@<@XP<H``=cSP;>N@?og`?oo`?W?0?W70?Nn`;Nf`=kc`Ikk`>440<YA@8H``H000<8@@I220:U=0?_
G@?og`?oo`?g_P>me`=BZP8@XP<080Soo`<8@@=:J@>eUP?_O@Goo`?FVPK>N@=[K@8Hh`<8H@H000Ha
QP>D/P;W70Koo`?Nf`KF^P;FVPW>N@Q[C@<Hh`<000<080<8H@<@XP8H``=cSP?>N@?og`?oo`?W?0;W
70?Nn`?Nf`=kc`Ikk`>4408YA@<H``H000<8@@E220>U=0?_G@?og`?oo`?g_P:me`=BZP<@XP<081So
o`005ooo0`Q10dYY0[FF0nmm1_oo0mJJ1Lii0f]]0aSS0`QQ1P001C660iBb0nLL1_oo0mkK1MJj0mJJ
2Lii26]=0aSS0`000`0P0PQQ0a2R0aS30g>>0lii0ooO0_oo0nLl0nLL0mkk0mkK0g_?1G__0h@@0bU5
0aS31P000PQ11T880jDd0nmM0ooO0_oo0oNn0kgG0e:Z0a2R0`0P2?oo0`Q10TYY0kFF0nmm1_oo0mJJ
1Lii0f]]0aSS0`QQ1@001S660iBb0nLL1Ooo0mkK1]Jj0mJJ2<ii2F]=0aSS0`000P0P0`QQ0a2R0aS3
0g>>0lii0_oO0ooo0nLl0nLL0mkk0mkK0W_?1W__0h@@0bU50aS31@000`Q11T880jDd0nmM0_oO0ooo
0oNn0kgG0e:Z0a2R0P0P2Ooo0PQ10dYY0kFF0nmm1_oo0]JJ1/ii0f]]0aSS0`QQ1@001S660iBb0nLL
1Ooo0mkK1]Jj0mJJ2<ii2F]=0aSS0P000`0P0`QQ0a2R0aS30g>>0/ii0ooO0ooo0nLl0nLL0mkk0]kK
0g_?1W__0h@@0bU50QS31P000`Q11T880ZDd0nmM0ooO0ooo0oNn0kgG0e:Z0Q2R0`0P2?oo0`Q10dYY
0kFF0nmm1Ooo0mJJ1/ii0f]]0QSS0`QQ1P001S660iBb0^LL1_oo0mkK1]Jj0]JJ2Lii26]=0aSS0`00
0`0P0`QQ0a2R0QS30g>>0lii0ooO0ooo0nLl0^LL0mkk0mkK0g_?1W__0h@@0RU50aS31P000`Q11D88
0jDd0nmM0ooO0ooo0oNn0[gG0e:Z0a2R0`0P6?oo000Gool32443BVT2]IH3kgd6ool3eYX5cWT3Jfd3
6><326460005<HH3U;83ia`6ool3g]/5e[X3eYX9cWT8Jdd36><30003020226434:836<<3Lhh3cWT3
oml2ool3ic`3ia`3g_/3g]/3Nll5Nnl3Q103:DD36<<600022446@PP3YC@3ked3oml2ool3mkh3_ML3
DZX34:830208ool32442BVT3]IH3kgd6ool3eYX5cWT3Jfd36><326450006<HH3U;83ia`5ool3g]/6
e[X3eYX8cWT9Jdd36><30002020326434:836<<3Lhh3cWT2oml3ool3ic`3ia`3g_/3g]/2Nll6Nnl3
Q103:DD36<<500032446@PP3YC@3ked2oml3ool3mkh3_ML3DZX34:820209ool22443BVT3]IH3kgd6
ool2eYX6cWT3Jfd36><326450006<HH3U;83ia`5ool3g]/6e[X3eYX8cWT9Jdd36><2000302032643
4:836<<3Lhh2cWT3oml3ool3ic`3ia`3g_/2g]/3Nll6Nnl3Q103:DD26<<600032446@PP2YC@3ked3
oml3ool3mkh3_ML3DZX24:830208ool32443BVT3]IH3kgd5ool3eYX6cWT3Jfd26><326460006<HH3
U;82ia`6ool3g]/6e[X2eYX9cWT8Jdd36><30003020326434:826<<3Lhh3cWT3oml3ool3ic`2ia`3
g_/3g]/3Nll6Nnl3Q102:DD36<<600032445@PP3YC@3ked3oml3ool3mkh2_ML3DZX34:83020Hool0
01Ooo`<8@@=:J@:eUP?_O@Koo`?FVPG>N@=[K@<Hh`<8H@H000DaQP>D/P?W70Koo`?Nf`GF^P?FVPW>
N@Q[C@<Hh`<000<08088H@<@XP<H``=cSP?>N@?og`;oo`?W?0?W70?Nn`?Nf`=kc`Ekk`>440<YA@<H
``H00088@@I220>U=0?_G@?og`;oo`?g_P>me`=BZP<@XP<080Soo`<8@@9:J@>eUP?_O@Koo`?FVPG>
N@=[K@<Hh`<8H@D000HaQP>D/P?W70Goo`?Nf`KF^P?FVPS>N@U[C@<Hh`<0008080<8H@<@XP<H``=c
SP?>N@;og`?oo`?W?0?W70?Nn`?Nf`9kc`Ikk`>440<YA@<H``D000<8@@I220>U=0?_G@;og`?oo`?g
_P>me`=BZP<@XP8080Woo`88@@=:J@>eUP?_O@Koo`;FVPK>N@=[K@<Hh`<8H@D000HaQP>D/P?W70Go
o`?Nf`KF^P?FVPS>N@U[C@<Hh`8000<080<8H@<@XP<H``=cSP;>N@?og`?oo`?W?0?W70?Nn`;Nf`=k
c`Ikk`>440<YA@8H``H000<8@@I220:U=0?_G@?og`?oo`?g_P>me`=BZP8@XP<080Soo`<8@@=:J@>e
UP?_O@Goo`?FVPK>N@=[K@8Hh`<8H@H000HaQP>D/P;W70Koo`?Nf`KF^P;FVPW>N@Q[C@<Hh`<000<0
80<8H@<@XP8H``=cSP?>N@?og`?oo`?W?0;W70?Nn`?Nf`=kc`Ikk`>4408YA@<H``H000<8@@E220>U
=0?_G@?og`?oo`?g_P:me`=BZP<@XP<081Soo`005ooo0`Q10dYY0[FF0nmm1_oo0mJJ1Lii0f]]0aSS
0`QQ1P001C660iBb0nLL1_oo0mkK1MJj0mJJ2Lii26]=0aSS0`000`0P0PQQ0a2R0aS30g>>0lii0ooO
0_oo0nLl0nLL0mkk0mkK0g_?1G__0h@@0bU50aS31P000PQ11T880jDd0nmM0ooO0_oo0oNn0kgG0e:Z
0a2R0`0P2?oo0`Q10TYY0kFF0nmm1_oo0mJJ1Lii0f]]0aSS0`QQ1@001S660iBb0nLL1Ooo0mkK1]Jj
0mJJ2<ii2F]=0aSS0`000P0P0`QQ0a2R0aS30g>>0lii0_oO0ooo0nLl0nLL0mkk0mkK0W_?1W__0h@@
0bU50aS31@000`Q11T880jDd0nmM0_oO0ooo0oNn0kgG0e:Z0a2R0P0P2Ooo0PQ10dYY0kFF0nmm1_oo
0]JJ1/ii0f]]0aSS0`QQ1@001S660iBb0nLL1Ooo0mkK1]Jj0mJJ2<ii2F]=0aSS0P000`0P0`QQ0a2R
0aS30g>>0/ii0ooO0ooo0nLl0nLL0mkk0]kK0g_?1W__0h@@0bU50QS31P000`Q11T880ZDd0nmM0ooO
0ooo0oNn0kgG0e:Z0Q2R0`0P2?oo0`Q10dYY0kFF0nmm1Ooo0mJJ1/ii0f]]0QSS0`QQ1P001S660iBb
0^LL1_oo0mkK1]Jj0]JJ2Lii26]=0aSS0`000`0P0`QQ0a2R0QS30g>>0lii0ooO0ooo0nLl0^LL0mkk
0mkK0g_?1W__0h@@0RU50aS31P000`Q11D880jDd0nmM0ooO0ooo0oNn0[gG0e:Z0a2R0`0P6?oo000G
ool32443BVT2]IH3kgd6ool3eYX5cWT3Jfd36><326460005<HH3U;83ia`6ool3g]/5e[X3eYX9cWT8
Jdd36><30003020226434:836<<3Lhh3cWT3oml2ool3ic`3ia`3g_/3g]/3Nll5Nnl3Q103:DD36<<6
00022446@PP3YC@3ked3oml2ool3mkh3_ML3DZX34:830208ool32442BVT3]IH3kgd6ool3eYX5cWT3
Jfd36><326450006<HH3U;83ia`5ool3g]/6e[X3eYX8cWT9Jdd36><30002020326434:836<<3Lhh3
cWT2oml3ool3ic`3ia`3g_/3g]/2Nll6Nnl3Q103:DD36<<500032446@PP3YC@3ked2oml3ool3mkh3
_ML3DZX34:820209ool22443BVT3]IH3kgd6ool2eYX6cWT3Jfd36><326450006<HH3U;83ia`5ool3
g]/6e[X3eYX8cWT9Jdd36><20003020326434:836<<3Lhh2cWT3oml3ool3ic`3ia`3g_/2g]/3Nll6
Nnl3Q103:DD26<<600032446@PP2YC@3ked3oml3ool3mkh3_ML3DZX24:830208ool32443BVT3]IH3
kgd5ool3eYX6cWT3Jfd26><326460006<HH3U;82ia`6ool3g]/6e[X2eYX9cWT8Jdd36><300030203
26434:826<<3Lhh3cWT3oml3ool3ic`2ia`3g_/3g]/3Nll6Nnl3Q102:DD36<<600032445@PP3YC@3
ked3oml3ool3mkh2_ML3DZX34:83020Hool001Ooo`<8@@=:J@:eUP?_O@Koo`?FVPG>N@=[K@<Hh`<8
H@H000DaQP>D/P?W70Koo`?Nf`GF^P?FVPW>N@Q[C@<Hh`<000<08088H@<@XP<H``=cSP?>N@?og`;o
o`?W?0?W70?Nn`?Nf`=kc`Ekk`>440<YA@<H``H00088@@I220>U=0?_G@?og`;oo`?g_P>me`=BZP<@
XP<080Soo`<8@@9:J@>eUP?_O@Koo`?FVPG>N@=[K@<Hh`<8H@D000HaQP>D/P?W70Goo`?Nf`KF^P?F
VPS>N@U[C@<Hh`<0008080<8H@<@XP<H``=cSP?>N@;og`?oo`?W?0?W70?Nn`?Nf`9kc`Ikk`>440<Y
A@<H``D000<8@@I220>U=0?_G@;og`?oo`?g_P>me`=BZP<@XP8080Woo`88@@=:J@>eUP?_O@Koo`;F
VPK>N@=[K@<Hh`<8H@D000HaQP>D/P?W70Goo`?Nf`KF^P?FVPS>N@U[C@<Hh`8000<080<8H@<@XP<H
``=cSP;>N@?og`?oo`?W?0?W70?Nn`;Nf`=kc`Ikk`>440<YA@8H``H000<8@@I220:U=0?_G@?og`?o
o`?g_P>me`=BZP8@XP<080Soo`<8@@=:J@>eUP?_O@Goo`?FVPK>N@=[K@8Hh`<8H@H000HaQP>D/P;W
70Koo`?Nf`KF^P;FVPW>N@Q[C@<Hh`<000<080<8H@<@XP8H``=cSP?>N@?og`?oo`?W?0;W70?Nn`?N
f`=kc`Ikk`>4408YA@<H``H000<8@@E220>U=0?_G@?og`?oo`?g_P:me`=BZP<@XP<081Soo`005ooo
0`Q10dYY0[FF0nmm1_oo0mJJ1Lii0f]]0aSS0`QQ1P001C660iBb0nLL1_oo0mkK1MJj0mJJ2Lii26]=
0aSS0`000`0P0PQQ0a2R0aS30g>>0lii0ooO0_oo0nLl0nLL0mkk0mkK0g_?1G__0h@@0bU50aS31P00
0PQ11T880jDd0nmM0ooO0_oo0oNn0kgG0e:Z0a2R0`0P2?oo0`Q10TYY0kFF0nmm1_oo0mJJ1Lii0f]]
0aSS0`QQ1@001S660iBb0nLL1Ooo0mkK1]Jj0mJJ2<ii2F]=0aSS0`000P0P0`QQ0a2R0aS30g>>0lii
0_oO0ooo0nLl0nLL0mkk0mkK0W_?1W__0h@@0bU50aS31@000`Q11T880jDd0nmM0_oO0ooo0oNn0kgG
0e:Z0a2R0P0P2Ooo0PQ10dYY0kFF0nmm1_oo0]JJ1/ii0f]]0aSS0`QQ1@001S660iBb0nLL1Ooo0mkK
1]Jj0mJJ2<ii2F]=0aSS0P000`0P0`QQ0a2R0aS30g>>0/ii0ooO0ooo0nLl0nLL0mkk0]kK0g_?1W__
0h@@0bU50QS31P000`Q11T880ZDd0nmM0ooO0ooo0oNn0kgG0e:Z0Q2R0`0P2?oo0`Q10dYY0kFF0nmm
1Ooo0mJJ1/ii0f]]0QSS0`QQ1P001S660iBb0^LL1_oo0mkK1]Jj0]JJ2Lii26]=0aSS0`000`0P0`QQ
0a2R0QS30g>>0lii0ooO0ooo0nLl0^LL0mkk0mkK0g_?1W__0h@@0RU50aS31P000`Q11D880jDd0nmM
0ooO0ooo0oNn0[gG0e:Z0a2R0`0P6?oo000Gool32443BVT2]IH3kgd6ool3eYX5cWT3Jfd36><32646
0005<HH3U;83ia`6ool3g]/5e[X3eYX9cWT8Jdd36><30003020226434:836<<3Lhh3cWT3oml2ool3
ic`3ia`3g_/3g]/3Nll5Nnl3Q103:DD36<<600022446@PP3YC@3ked3oml2ool3mkh3_ML3DZX34:83
0208ool32442BVT3]IH3kgd6ool3eYX5cWT3Jfd36><326450006<HH3U;83ia`5ool3g]/6e[X3eYX8
cWT9Jdd36><30002020326434:836<<3Lhh3cWT2oml3ool3ic`3ia`3g_/3g]/2Nll6Nnl3Q103:DD3
6<<500032446@PP3YC@3ked2oml3ool3mkh3_ML3DZX34:820209ool22443BVT3]IH3kgd6ool2eYX6
cWT3Jfd36><326450006<HH3U;83ia`5ool3g]/6e[X3eYX8cWT9Jdd36><20003020326434:836<<3
Lhh2cWT3oml3ool3ic`3ia`3g_/2g]/3Nll6Nnl3Q103:DD26<<600032446@PP2YC@3ked3oml3ool3
mkh3_ML3DZX24:830208ool32443BVT3]IH3kgd5ool3eYX6cWT3Jfd26><326460006<HH3U;82ia`6
ool3g]/6e[X2eYX9cWT8Jdd36><30003020326434:826<<3Lhh3cWT3oml3ool3ic`2ia`3g_/3g]/3
Nll6Nnl3Q102:DD36<<600032445@PP3YC@3ked3oml3ool3mkh2_ML3DZX34:83020Hool001Ooo`<8
@@=:J@:eUP?_O@Koo`?FVPG>N@=[K@<Hh`<8H@H000DaQP>D/P?W70Koo`?Nf`GF^P?FVPW>N@Q[C@<H
h`<000<08088H@<@XP<H``=cSP?>N@?og`;oo`?W?0?W70?Nn`?Nf`=kc`Ekk`>440<YA@<H``H00088
@@I220>U=0?_G@?og`;oo`?g_P>me`=BZP<@XP<080Soo`<8@@9:J@>eUP?_O@Koo`?FVPG>N@=[K@<H
h`<8H@D000HaQP>D/P?W70Goo`?Nf`KF^P?FVPS>N@U[C@<Hh`<0008080<8H@<@XP<H``=cSP?>N@;o
g`?oo`?W?0?W70?Nn`?Nf`9kc`Ikk`>440<YA@<H``D000<8@@I220>U=0?_G@;og`?oo`?g_P>me`=B
ZP<@XP8080Woo`88@@=:J@>eUP?_O@Koo`;FVPK>N@=[K@<Hh`<8H@D000HaQP>D/P?W70Goo`?Nf`KF
^P?FVPS>N@U[C@<Hh`8000<080<8H@<@XP<H``=cSP;>N@?og`?oo`?W?0?W70?Nn`;Nf`=kc`Ikk`>4
40<YA@8H``H000<8@@I220:U=0?_G@?og`?oo`?g_P>me`=BZP8@XP<080Soo`<8@@=:J@>eUP?_O@Go
o`?FVPK>N@=[K@8Hh`<8H@H000HaQP>D/P;W70Koo`?Nf`KF^P;FVPW>N@Q[C@<Hh`<000<080<8H@<@
XP8H``=cSP?>N@?og`?oo`?W?0;W70?Nn`?Nf`=kc`Ikk`>4408YA@<H``H000<8@@E220>U=0?_G@?o
g`?oo`?g_P:me`=BZP<@XP<081Soo`005ooo0`Q10dYY0[FF0nmm1_oo0mJJ1Lii0f]]0aSS0`QQ1P00
1C660iBb0nLL1_oo0mkK1MJj0mJJ2Lii26]=0aSS0`000`0P0PQQ0a2R0aS30g>>0lii0ooO0_oo0nLl
0nLL0mkk0mkK0g_?1G__0h@@0bU50aS31P000PQ11T880jDd0nmM0ooO0_oo0oNn0kgG0e:Z0a2R0`0P
2?oo0`Q10TYY0kFF0nmm1_oo0mJJ1Lii0f]]0aSS0`QQ1@001S660iBb0nLL1Ooo0mkK1]Jj0mJJ2<ii
2F]=0aSS0`000P0P0`QQ0a2R0aS30g>>0lii0_oO0ooo0nLl0nLL0mkk0mkK0W_?1W__0h@@0bU50aS3
1@000`Q11T880jDd0nmM0_oO0ooo0oNn0kgG0e:Z0a2R0P0P2Ooo0PQ10dYY0kFF0nmm1_oo0]JJ1/ii
0f]]0aSS0`QQ1@001S660iBb0nLL1Ooo0mkK1]Jj0mJJ2<ii2F]=0aSS0P000`0P0`QQ0a2R0aS30g>>
0/ii0ooO0ooo0nLl0nLL0mkk0]kK0g_?1W__0h@@0bU50QS31P000`Q11T880ZDd0nmM0ooO0ooo0oNn
0kgG0e:Z0Q2R0`0P2?oo0`Q10dYY0kFF0nmm1Ooo0mJJ1/ii0f]]0QSS0`QQ1P001S660iBb0^LL1_oo
0mkK1]Jj0]JJ2Lii26]=0aSS0`000`0P0`QQ0a2R0QS30g>>0lii0ooO0ooo0nLl0^LL0mkk0mkK0g_?
1W__0h@@0RU50aS31P000`Q11D880jDd0nmM0ooO0ooo0oNn0[gG0e:Z0a2R0`0P6?oo000Gool30003
020226434:836<<38@@38B@3Q102g]/3oml3ool3oml3aQP3F^/36<<2000324434883F//3DZX3_ML2
mih6ool3mkh3kgd3ic`2ia`3g_/3g]/3Nll6Nnl2:DD3020300030203>NL3YA@2ic`3ool3mkh3kgd3
YC@3@PP326450003244348836<<3Jfd2Jdd3Hb`3aSP3mkh6ool2mkh3kgd3ic`3ia`3g]/3Nnl8ool3
0002020326434:836<<38@@38B@2Q103g]/3oml3ool3oml3aQP2F^/36<<3000324434883F//2DZX3
_ML3mih6ool3mkh3kgd2ic`3ia`3g_/3g]/3Nll5Nnl3:DD3020300030203>NL2YA@3ic`3ool3mkh3
kgd3YC@2@PP326460003244348836<<2Jfd3Jdd3Hb`3aSP3mkh5ool3mkh3kgd3ic`3ia`3g]/2Nnl9
ool20003020326434:836<<38@@28B@3Q103g]/3oml3ool3oml2aQP3F^/36<<3000324434882F//3
DZX3_ML3mih6ool2mkh3kgd3ic`3ia`3g_/3g]/3Nll5Nnl3:DD3020300030202>NL3YA@3ic`3ool3
mkh3kgd2YC@3@PP326460003244248836<<3Jfd3Jdd3Hb`3aSP2mkh6ool3mkh3kgd3ic`3ia`2g]/3
Nnl8ool30003020326434:826<<38@@38B@3Q103g]/3oml2ool3oml3aQP3F^/36<<3000324424883
F//3DZX3_ML3mih5ool3mkh3kgd3ic`3ia`3g_/2g]/3Nll6Nnl3:DD3020200030203>NL3YA@3ic`3
ool2mkh3kgd3YC@3@PP326460002244348836<<3Jfd3Jdd3Hb`2aSP3mkh6ool3mkh3kgd2ic`3ia`3
g]/3NnlHool001Ooo`<000<08088H@<@XP<H``<Q10<Q90>440;Nf`?og`?oo`?og`?660=Jj`<H``80
00<8@@<@PP=Jb`=BZP>me`;gWPKoo`?g_P?_O@?W?0;W70?Nn`?Nf`=kc`Ikk`8YA@<080<000<080<i
i`>U50;W?0?oo`?g_P?_O@>U=0=220<8H@D000<8@@<@PP<H``=[K@9[C@=S;0?6>0?g_PKoo`;g_P?_
O@?W?0?W70?Nf`=kk`Soo`<0008080<8H@<@XP<H``<Q10<Q90:440?Nf`?og`?oo`?og`?6609Jj`<H
``<000<8@@<@PP=Jb`9BZP>me`?gWPKoo`?g_P?_O@;W?0?W70?Nn`?Nf`=kc`Ekk`<YA@<080<000<0
80<ii`:U50?W?0?oo`?g_P?_O@>U=09220<8H@H000<8@@<@PP<H``9[K@=[C@=S;0?6>0?g_PGoo`?g
_P?_O@?W?0?W70?Nf`9kk`Woo`8000<080<8H@<@XP<H``<Q108Q90>440?Nf`?og`?oo`?og`;660=J
j`<H``<000<8@@<@PP9Jb`=BZP>me`?gWPKoo`;g_P?_O@?W?0?W70?Nn`?Nf`=kc`Ekk`<YA@<080<0
00<0808ii`>U50?W?0?oo`?g_P?_O@:U=0=220<8H@H000<8@@8@PP<H``=[K@=[C@=S;0?6>0;g_PKo
o`?g_P?_O@?W?0?W70;Nf`=kk`Soo`<000<080<8H@<@XP8H``<Q10<Q90>440?Nf`?og`;oo`?og`?6
60=Jj`<H``<000<8@@8@PP=Jb`=BZP>me`?gWPGoo`?g_P?_O@?W?0?W70?Nn`;Nf`=kc`Ikk`<YA@<0
808000<080<ii`>U50?W?0?oo`;g_P?_O@>U=0=220<8H@H00088@@<@PP<H``=[K@=[C@=S;0;6>0?g
_PKoo`?g_P?_O@;W?0?W70?Nf`=kkaSoo`005ooo0`000`0P0PQQ0a2R0aS30b440b4T0h@@0]kK0ooO
0ooo0ooO0lHH0e[[0aS30P000`Q10a220e[;0e:Z0kgG0_NN1_oo0oNn0nmm0nLl0^LL0mkk0mkK0g_?
1W__0RU50`0P0`000`0P0cWW0jDD0^Ll0ooo0oNn0nmm0jDd0d880`QQ1@000`Q10a220aS30f]]0V]=
0f</0lHh0oNn1_oo0_Nn0nmm0nLl0nLL0mkK0g__2?oo0`000P0P0`QQ0a2R0aS30b440b4T0X@@0mkK
0ooO0ooo0ooO0lHH0U[[0aS30`000`Q10a220e[;0U:Z0kgG0oNN1_oo0oNn0nmm0^Ll0nLL0mkk0mkK
0g_?1G__0bU50`0P0`000`0P0cWW0ZDD0nLl0ooo0oNn0nmm0jDd0T880`QQ1P000`Q10a220aS30V]]
0f]=0f</0lHh0oNn1Ooo0oNn0nmm0nLl0nLL0mkK0W__2Ooo0P000`0P0`QQ0a2R0aS30b440R4T0h@@
0mkK0ooO0ooo0ooO0/HH0e[[0aS30`000`Q10a220U[;0e:Z0kgG0oNN1_oo0_Nn0nmm0nLl0nLL0mkk
0mkK0g_?1G__0bU50`0P0`000`0P0SWW0jDD0nLl0ooo0oNn0nmm0ZDd0d880`QQ1P000`Q10Q220aS3
0f]]0f]=0f</0lHh0_Nn1_oo0oNn0nmm0nLl0nLL0]kK0g__2?oo0`000`0P0`QQ0a2R0QS30b440b4T
0h@@0mkK0ooO0_oo0ooO0lHH0e[[0aS30`000`Q10Q220e[;0e:Z0kgG0oNN1Ooo0oNn0nmm0nLl0nLL
0mkk0]kK0g_?1W__0bU50`0P0P000`0P0cWW0jDD0nLl0ooo0_Nn0nmm0jDd0d880`QQ1P000PQ10a22
0aS30f]]0f]=0f</0/Hh0oNn1_oo0oNn0nmm0^Ll0nLL0mkK0g__6?oo000Gool30003020226434:83
6<<38@@38B@3Q102g]/3oml3ool3oml3aQP3F^/36<<2000324434883F//3DZX3_ML2mih6ool3mkh3
kgd3ic`2ia`3g_/3g]/3Nll6Nnl2:DD3020300030203>NL3YA@2ic`3ool3mkh3kgd3YC@3@PP32645
0003244348836<<3Jfd2Jdd3Hb`3aSP3mkh6ool2mkh3kgd3ic`3ia`3g]/3Nnl8ool3000202032643
4:836<<38@@38B@2Q103g]/3oml3ool3oml3aQP2F^/36<<3000324434883F//2DZX3_ML3mih6ool3
mkh3kgd2ic`3ia`3g_/3g]/3Nll5Nnl3:DD3020300030203>NL2YA@3ic`3ool3mkh3kgd3YC@2@PP3
26460003244348836<<2Jfd3Jdd3Hb`3aSP3mkh5ool3mkh3kgd3ic`3ia`3g]/2Nnl9ool200030203
26434:836<<38@@28B@3Q103g]/3oml3ool3oml2aQP3F^/36<<3000324434882F//3DZX3_ML3mih6
ool2mkh3kgd3ic`3ia`3g_/3g]/3Nll5Nnl3:DD3020300030202>NL3YA@3ic`3ool3mkh3kgd2YC@3
@PP326460003244248836<<3Jfd3Jdd3Hb`3aSP2mkh6ool3mkh3kgd3ic`3ia`2g]/3Nnl8ool30003
020326434:826<<38@@38B@3Q103g]/3oml2ool3oml3aQP3F^/36<<3000324424883F//3DZX3_ML3
mih5ool3mkh3kgd3ic`3ia`3g_/2g]/3Nll6Nnl3:DD3020200030203>NL3YA@3ic`3ool2mkh3kgd3
YC@3@PP326460002244348836<<3Jfd3Jdd3Hb`2aSP3mkh6ool3mkh3kgd2ic`3ia`3g]/3NnlHool0
01Ooo`<000<08088H@<@XP<H``<Q10<Q90>440;Nf`?og`?oo`?og`?660=Jj`<H``8000<8@@<@PP=J
b`=BZP>me`;gWPKoo`?g_P?_O@?W?0;W70?Nn`?Nf`=kc`Ikk`8YA@<080<000<080<ii`>U50;W?0?o
o`?g_P?_O@>U=0=220<8H@D000<8@@<@PP<H``=[K@9[C@=S;0?6>0?g_PKoo`;g_P?_O@?W?0?W70?N
f`=kk`Soo`<0008080<8H@<@XP<H``<Q10<Q90:440?Nf`?og`?oo`?og`?6609Jj`<H``<000<8@@<@
PP=Jb`9BZP>me`?gWPKoo`?g_P?_O@;W?0?W70?Nn`?Nf`=kc`Ekk`<YA@<080<000<080<ii`:U50?W
?0?oo`?g_P?_O@>U=09220<8H@H000<8@@<@PP<H``9[K@=[C@=S;0?6>0?g_PGoo`?g_P?_O@?W?0?W
70?Nf`9kk`Woo`8000<080<8H@<@XP<H``<Q108Q90>440?Nf`?og`?oo`?og`;660=Jj`<H``<000<8
@@<@PP9Jb`=BZP>me`?gWPKoo`;g_P?_O@?W?0?W70?Nn`?Nf`=kc`Ekk`<YA@<080<000<0808ii`>U
50?W?0?oo`?g_P?_O@:U=0=220<8H@H000<8@@8@PP<H``=[K@=[C@=S;0?6>0;g_PKoo`?g_P?_O@?W
?0?W70;Nf`=kk`Soo`<000<080<8H@<@XP8H``<Q10<Q90>440?Nf`?og`;oo`?og`?660=Jj`<H``<0
00<8@@8@PP=Jb`=BZP>me`?gWPGoo`?g_P?_O@?W?0?W70?Nn`;Nf`=kc`Ikk`<YA@<0808000<080<i
i`>U50?W?0?oo`;g_P?_O@>U=0=220<8H@H00088@@<@PP<H``=[K@=[C@=S;0;6>0?g_PKoo`?g_P?_
O@;W?0?W70?Nf`=kkaSoo`005ooo0`000`0P0PQQ0a2R0aS30b440b4T0h@@0]kK0ooO0ooo0ooO0lHH
0e[[0aS30P000`Q10a220e[;0e:Z0kgG0_NN1_oo0oNn0nmm0nLl0^LL0mkk0mkK0g_?1W__0RU50`0P
0`000`0P0cWW0jDD0^Ll0ooo0oNn0nmm0jDd0d880`QQ1@000`Q10a220aS30f]]0V]=0f</0lHh0oNn
1_oo0_Nn0nmm0nLl0nLL0mkK0g__2?oo0`000P0P0`QQ0a2R0aS30b440b4T0X@@0mkK0ooO0ooo0ooO
0lHH0U[[0aS30`000`Q10a220e[;0U:Z0kgG0oNN1_oo0oNn0nmm0^Ll0nLL0mkk0mkK0g_?1G__0bU5
0`0P0`000`0P0cWW0ZDD0nLl0ooo0oNn0nmm0jDd0T880`QQ1P000`Q10a220aS30V]]0f]=0f</0lHh
0oNn1Ooo0oNn0nmm0nLl0nLL0mkK0W__2Ooo0P000`0P0`QQ0a2R0aS30b440R4T0h@@0mkK0ooO0ooo
0ooO0/HH0e[[0aS30`000`Q10a220U[;0e:Z0kgG0oNN1_oo0_Nn0nmm0nLl0nLL0mkk0mkK0g_?1G__
0bU50`0P0`000`0P0SWW0jDD0nLl0ooo0oNn0nmm0ZDd0d880`QQ1P000`Q10Q220aS30f]]0f]=0f</
0lHh0_Nn1_oo0oNn0nmm0nLl0nLL0]kK0g__2?oo0`000`0P0`QQ0a2R0QS30b440b4T0h@@0mkK0ooO
0_oo0ooO0lHH0e[[0aS30`000`Q10Q220e[;0e:Z0kgG0oNN1Ooo0oNn0nmm0nLl0nLL0mkk0]kK0g_?
1W__0bU50`0P0P000`0P0cWW0jDD0nLl0ooo0_Nn0nmm0jDd0d880`QQ1P000PQ10a220aS30f]]0f]=
0f</0/Hh0oNn1_oo0oNn0nmm0^Ll0nLL0mkK0g__6?oo000Gool30003020226434:836<<38@@38B@3
Q102g]/3oml3ool3oml3aQP3F^/36<<2000324434883F//3DZX3_ML2mih6ool3mkh3kgd3ic`2ia`3
g_/3g]/3Nll6Nnl2:DD3020300030203>NL3YA@2ic`3ool3mkh3kgd3YC@3@PP32645000324434883
6<<3Jfd2Jdd3Hb`3aSP3mkh6ool2mkh3kgd3ic`3ia`3g]/3Nnl8ool30002020326434:836<<38@@3
8B@2Q103g]/3oml3ool3oml3aQP2F^/36<<3000324434883F//2DZX3_ML3mih6ool3mkh3kgd2ic`3
ia`3g_/3g]/3Nll5Nnl3:DD3020300030203>NL2YA@3ic`3ool3mkh3kgd3YC@2@PP3264600032443
48836<<2Jfd3Jdd3Hb`3aSP3mkh5ool3mkh3kgd3ic`3ia`3g]/2Nnl9ool20003020326434:836<<3
8@@28B@3Q103g]/3oml3ool3oml2aQP3F^/36<<3000324434882F//3DZX3_ML3mih6ool2mkh3kgd3
ic`3ia`3g_/3g]/3Nll5Nnl3:DD3020300030202>NL3YA@3ic`3ool3mkh3kgd2YC@3@PP326460003
244248836<<3Jfd3Jdd3Hb`3aSP2mkh6ool3mkh3kgd3ic`3ia`2g]/3Nnl8ool30003020326434:82
6<<38@@38B@3Q103g]/3oml2ool3oml3aQP3F^/36<<3000324424883F//3DZX3_ML3mih5ool3mkh3
kgd3ic`3ia`3g_/2g]/3Nll6Nnl3:DD3020200030203>NL3YA@3ic`3ool2mkh3kgd3YC@3@PP32646
0002244348836<<3Jfd3Jdd3Hb`2aSP3mkh6ool3mkh3kgd2ic`3ia`3g]/3NnlHool001Ooo`<000<0
8088H@<@XP<H``<Q10<Q90>440;Nf`?og`?oo`?og`?660=Jj`<H``8000<8@@<@PP=Jb`=BZP>me`;g
WPKoo`?g_P?_O@?W?0;W70?Nn`?Nf`=kc`Ikk`8YA@<080<000<080<ii`>U50;W?0?oo`?g_P?_O@>U
=0=220<8H@D000<8@@<@PP<H``=[K@9[C@=S;0?6>0?g_PKoo`;g_P?_O@?W?0?W70?Nf`=kk`Soo`<0
008080<8H@<@XP<H``<Q10<Q90:440?Nf`?og`?oo`?og`?6609Jj`<H``<000<8@@<@PP=Jb`9BZP>m
e`?gWPKoo`?g_P?_O@;W?0?W70?Nn`?Nf`=kc`Ekk`<YA@<080<000<080<ii`:U50?W?0?oo`?g_P?_
O@>U=09220<8H@H000<8@@<@PP<H``9[K@=[C@=S;0?6>0?g_PGoo`?g_P?_O@?W?0?W70?Nf`9kk`Wo
o`8000<080<8H@<@XP<H``<Q108Q90>440?Nf`?og`?oo`?og`;660=Jj`<H``<000<8@@<@PP9Jb`=B
ZP>me`?gWPKoo`;g_P?_O@?W?0?W70?Nn`?Nf`=kc`Ekk`<YA@<080<000<0808ii`>U50?W?0?oo`?g
_P?_O@:U=0=220<8H@H000<8@@8@PP<H``=[K@=[C@=S;0?6>0;g_PKoo`?g_P?_O@?W?0?W70;Nf`=k
k`Soo`<000<080<8H@<@XP8H``<Q10<Q90>440?Nf`?og`;oo`?og`?660=Jj`<H``<000<8@@8@PP=J
b`=BZP>me`?gWPGoo`?g_P?_O@?W?0?W70?Nn`;Nf`=kc`Ikk`<YA@<0808000<080<ii`>U50?W?0?o
o`;g_P?_O@>U=0=220<8H@H00088@@<@PP<H``=[K@=[C@=S;0;6>0?g_PKoo`?g_P?_O@;W?0?W70?N
f`=kkaSoo`005ooo0`000`0P0PQQ0a2R0aS30b440b4T0h@@0]kK0ooO0ooo0ooO0lHH0e[[0aS30P00
0`Q10a220e[;0e:Z0kgG0_NN1_oo0oNn0nmm0nLl0^LL0mkk0mkK0g_?1W__0RU50`0P0`000`0P0cWW
0jDD0^Ll0ooo0oNn0nmm0jDd0d880`QQ1@000`Q10a220aS30f]]0V]=0f</0lHh0oNn1_oo0_Nn0nmm
0nLl0nLL0mkK0g__2?oo0`000P0P0`QQ0a2R0aS30b440b4T0X@@0mkK0ooO0ooo0ooO0lHH0U[[0aS3
0`000`Q10a220e[;0U:Z0kgG0oNN1_oo0oNn0nmm0^Ll0nLL0mkk0mkK0g_?1G__0bU50`0P0`000`0P
0cWW0ZDD0nLl0ooo0oNn0nmm0jDd0T880`QQ1P000`Q10a220aS30V]]0f]=0f</0lHh0oNn1Ooo0oNn
0nmm0nLl0nLL0mkK0W__2Ooo0P000`0P0`QQ0a2R0aS30b440R4T0h@@0mkK0ooO0ooo0ooO0/HH0e[[
0aS30`000`Q10a220U[;0e:Z0kgG0oNN1_oo0_Nn0nmm0nLl0nLL0mkk0mkK0g_?1G__0bU50`0P0`00
0`0P0SWW0jDD0nLl0ooo0oNn0nmm0ZDd0d880`QQ1P000`Q10Q220aS30f]]0f]=0f</0lHh0_Nn1_oo
0oNn0nmm0nLl0nLL0]kK0g__2?oo0`000`0P0`QQ0a2R0QS30b440b4T0h@@0mkK0ooO0_oo0ooO0lHH
0e[[0aS30`000`Q10Q220e[;0e:Z0kgG0oNN1Ooo0oNn0nmm0nLl0nLL0mkk0]kK0g_?1W__0bU50`0P
0P000`0P0cWW0jDD0nLl0ooo0_Nn0nmm0jDd0d880`QQ1P000PQ10a220aS30f]]0f]=0f</0/Hh0oNn
1_oo0oNn0nmm0^Ll0nLL0mkK0g__6?oo000Gool30003020226434:836<<38@@38B@3Q102g]/3oml3
ool3oml3aQP3F^/36<<2000324434883F//3DZX3_ML2mih6ool3mkh3kgd3ic`2ia`3g_/3g]/3Nll6
Nnl2:DD3020300030203>NL3YA@2ic`3ool3mkh3kgd3YC@3@PP326450003244348836<<3Jfd2Jdd3
Hb`3aSP3mkh6ool2mkh3kgd3ic`3ia`3g]/3Nnl8ool30002020326434:836<<38@@38B@2Q103g]/3
oml3ool3oml3aQP2F^/36<<3000324434883F//2DZX3_ML3mih6ool3mkh3kgd2ic`3ia`3g_/3g]/3
Nll5Nnl3:DD3020300030203>NL2YA@3ic`3ool3mkh3kgd3YC@2@PP326460003244348836<<2Jfd3
Jdd3Hb`3aSP3mkh5ool3mkh3kgd3ic`3ia`3g]/2Nnl9ool20003020326434:836<<38@@28B@3Q103
g]/3oml3ool3oml2aQP3F^/36<<3000324434882F//3DZX3_ML3mih6ool2mkh3kgd3ic`3ia`3g_/3
g]/3Nll5Nnl3:DD3020300030202>NL3YA@3ic`3ool3mkh3kgd2YC@3@PP326460003244248836<<3
Jfd3Jdd3Hb`3aSP2mkh6ool3mkh3kgd3ic`3ia`2g]/3Nnl8ool30003020326434:826<<38@@38B@3
Q103g]/3oml2ool3oml3aQP3F^/36<<3000324424883F//3DZX3_ML3mih5ool3mkh3kgd3ic`3ia`3
g_/2g]/3Nll6Nnl3:DD3020200030203>NL3YA@3ic`3ool2mkh3kgd3YC@3@PP32646000224434883
6<<3Jfd3Jdd3Hb`2aSP3mkh6ool3mkh3kgd2ic`3ia`3g]/3NnlHool001Ooo`<000<08088H@<@XP<H
``<Q10<Q90>440;Nf`?og`?oo`?og`?660=Jj`<H``8000<8@@<@PP=Jb`=BZP>me`;gWPKoo`?g_P?_
O@?W?0;W70?Nn`?Nf`=kc`Ikk`8YA@<080<000<080<ii`>U50;W?0?oo`?g_P?_O@>U=0=220<8H@D0
00<8@@<@PP<H``=[K@9[C@=S;0?6>0?g_PKoo`;g_P?_O@?W?0?W70?Nf`=kk`Soo`<0008080<8H@<@
XP<H``<Q10<Q90:440?Nf`?og`?oo`?og`?6609Jj`<H``<000<8@@<@PP=Jb`9BZP>me`?gWPKoo`?g
_P?_O@;W?0?W70?Nn`?Nf`=kc`Ekk`<YA@<080<000<080<ii`:U50?W?0?oo`?g_P?_O@>U=09220<8
H@H000<8@@<@PP<H``9[K@=[C@=S;0?6>0?g_PGoo`?g_P?_O@?W?0?W70?Nf`9kk`Woo`8000<080<8
H@<@XP<H``<Q108Q90>440?Nf`?og`?oo`?og`;660=Jj`<H``<000<8@@<@PP9Jb`=BZP>me`?gWPKo
o`;g_P?_O@?W?0?W70?Nn`?Nf`=kc`Ekk`<YA@<080<000<0808ii`>U50?W?0?oo`?g_P?_O@:U=0=2
20<8H@H000<8@@8@PP<H``=[K@=[C@=S;0?6>0;g_PKoo`?g_P?_O@?W?0?W70;Nf`=kk`Soo`<000<0
80<8H@<@XP8H``<Q10<Q90>440?Nf`?og`;oo`?og`?660=Jj`<H``<000<8@@8@PP=Jb`=BZP>me`?g
WPGoo`?g_P?_O@?W?0?W70?Nn`;Nf`=kc`Ikk`<YA@<0808000<080<ii`>U50?W?0?oo`;g_P?_O@>U
=0=220<8H@H00088@@<@PP<H``=[K@=[C@=S;0;6>0?g_PKoo`?g_P?_O@;W?0?W70?Nf`=kkaSoo`00
5ooo0bU50`0P0P000bU50bUU0haa1XaA0]kk1_oo0mkk0mkK0g__0h@@0RU50`0P0`000`0P0`QQ0a2R
0V</0lHh0oNn0ooo0ooO0liI1F</0aSS0`000`0P0`QQ0Q2R0f</0lHh0oNn0ooo0ooO1LiI0f</0aS3
0`Q11P000PQ10a220aS30aSS0g_?0mJJ0_oO0ooo0ooO1/Hh0f<<0QS31P000b4T0bU50bUU2?oo0bU5
0P0P0`000bU50bUU0haa1HaA0mkk1_oo0mkk0mkK0W__0h@@0bU50`0P0`000`0P0PQQ0a2R0f</0lHh
0oNn0ooo0ooO0/iI1V</0aSS0`000`0P0PQQ0a2R0f</0lHh0oNn0ooo0_oO1/iI0f</0aS30`Q11@00
0`Q10a220aS30aSS0g_?0]JJ0ooO0ooo0ooO1/Hh0V<<0aS31P000b4T0bU50RUU2Ooo0RU50`0P0`00
0bU50bUU0haa1HaA0mkk1_oo0mkk0]kK0g__0h@@0bU50`0P0`000P0P0`QQ0a2R0f</0lHh0oNn0_oo
0ooO0liI1V</0aSS0`000P0P0`QQ0a2R0f</0lHh0oNn0_oo0ooO1/iI0f</0aS30PQ11P000`Q10a22
0aS30QSS0g_?0mJJ0ooO0ooo0ooO1LHh0f<<0aS31P000b4T0RU50bUU2?oo0bU50`0P0`000bU50RUU
0haa1XaA0mkk1Ooo0mkk0mkK0g__0h@@0bU50`0P0P000`0P0`QQ0a2R0f</0lHh0_Nn0ooo0ooO0liI
1V</0QSS0`000`0P0`QQ0a2R0f</0/Hh0oNn0ooo0ooO1/iI0V</0aS30`Q11P000`Q10a220QS30aSS
0g_?0mJJ0ooO0ooo0_oO1/Hh0f<<0aS31@000b4T0bU50bUU6?oo000Gool3:DD302020003:DD3:FD3
S746S542g_/6ool3g_/3g]/3Nnl3Q102:DD302030003020326434:82Hb`3aSP3mkh3ool3oml3cUT5
Hb`36><30003020326424:83Hb`3aSP3mkh3ool3oml5cUT3Hb`36<<324460002244348836<<36><3
Nll3eYX2oml3ool3oml6aSP3H``26<<600038B@3:DD3:FD8ool3:DD202030003:DD3:FD3S745S543
g_/6ool3g_/3g]/2Nnl3Q103:DD302030003020226434:83Hb`3aSP3mkh3ool3oml2cUT6Hb`36><3
0003020226434:83Hb`3aSP3mkh3ool2oml6cUT3Hb`36<<324450003244348836<<36><3Nll2eYX3
oml3ool3oml6aSP2H``36<<600038B@3:DD2:FD9ool2:DD302030003:DD3:FD3S745S543g_/6ool3
g_/2g]/3Nnl3Q103:DD302030002020326434:83Hb`3aSP3mkh2ool3oml3cUT6Hb`36><300020203
26434:83Hb`3aSP3mkh2ool3oml6cUT3Hb`36<<224460003244348836<<26><3Nll3eYX3oml3ool3
oml5aSP3H``36<<600038B@2:DD3:FD8ool3:DD302030003:DD2:FD3S746S543g_/5ool3g_/3g]/3
Nnl3Q103:DD302020003020326434:83Hb`3aSP2mkh3ool3oml3cUT6Hb`26><30003020326434:83
Hb`2aSP3mkh3ool3oml6cUT2Hb`36<<324460003244348826<<36><3Nll3eYX3oml3ool2oml6aSP3
H``36<<500038B@3:DD3:FDHool001Ooo`<YA@<0808000<YA@<YI@><L@J<D@;Nn`Koo`?Nn`?Nf`=k
k`>4408YA@<080<000<080<8H@<@XP9S;0?6>0?g_P?oo`?og`?>F@ES;0<Hh`<000<080<8H@8@XP=S
;0?6>0?g_P?oo`?og`G>F@=S;0<H``<8@@H00088@@<@PP<H``<Hh`=kc`?FVP;og`?oo`?og`K6>0=S
308H``H000<Q90<YA@<YI@Soo`<YA@8080<000<YA@<YI@><L@F<D@?Nn`Koo`?Nn`?Nf`9kk`>440<Y
A@<080<000<08088H@<@XP=S;0?6>0?g_P?oo`?og`;>F@IS;0<Hh`<000<08088H@<@XP=S;0?6>0?g
_P?oo`;og`K>F@=S;0<H``<8@@D000<8@@<@PP<H``<Hh`=kc`;FVP?og`?oo`?og`K6>09S30<H``H0
00<Q90<YA@8YI@Woo`8YA@<080<000<YA@<YI@><L@F<D@?Nn`Koo`?Nn`;Nf`=kk`>440<YA@<080<0
008080<8H@<@XP=S;0?6>0?g_P;oo`?og`?>F@IS;0<Hh`<0008080<8H@<@XP=S;0?6>0?g_P;oo`?o
g`K>F@=S;0<H``88@@H000<8@@<@PP<H``8Hh`=kc`?FVP?og`?oo`?og`G6>0=S30<H``H000<Q908Y
A@<YI@Soo`<YA@<080<000<YA@8YI@><L@J<D@?Nn`Goo`?Nn`?Nf`=kk`>440<YA@<0808000<080<8
H@<@XP=S;0?6>0;g_P?oo`?og`?>F@IS;08Hh`<000<080<8H@<@XP=S;0;6>0?g_P?oo`?og`K>F@9S
;0<H``<8@@H000<8@@<@PP8H``<Hh`=kc`?FVP?og`?oo`;og`K6>0=S30<H``D000<Q90<YA@<YIASo
o`005ooo0bU50`0P0P000bU50bUU0haa1XaA0]kk1_oo0mkk0mkK0g__0h@@0RU50`0P0`000`0P0`QQ
0a2R0V</0lHh0oNn0ooo0ooO0liI1F</0aSS0`000`0P0`QQ0Q2R0f</0lHh0oNn0ooo0ooO1LiI0f</
0aS30`Q11P000PQ10a220aS30aSS0g_?0mJJ0_oO0ooo0ooO1/Hh0f<<0QS31P000b4T0bU50bUU2?oo
0bU50P0P0`000bU50bUU0haa1HaA0mkk1_oo0mkk0mkK0W__0h@@0bU50`0P0`000`0P0PQQ0a2R0f</
0lHh0oNn0ooo0ooO0/iI1V</0aSS0`000`0P0PQQ0a2R0f</0lHh0oNn0ooo0_oO1/iI0f</0aS30`Q1
1@000`Q10a220aS30aSS0g_?0]JJ0ooO0ooo0ooO1/Hh0V<<0aS31P000b4T0bU50RUU2Ooo0RU50`0P
0`000bU50bUU0haa1HaA0mkk1_oo0mkk0]kK0g__0h@@0bU50`0P0`000P0P0`QQ0a2R0f</0lHh0oNn
0_oo0ooO0liI1V</0aSS0`000P0P0`QQ0a2R0f</0lHh0oNn0_oo0ooO1/iI0f</0aS30PQ11P000`Q1
0a220aS30QSS0g_?0mJJ0ooO0ooo0ooO1LHh0f<<0aS31P000b4T0RU50bUU2?oo0bU50`0P0`000bU5
0RUU0haa1XaA0mkk1Ooo0mkk0mkK0g__0h@@0bU50`0P0P000`0P0`QQ0a2R0f</0lHh0_Nn0ooo0ooO
0liI1V</0QSS0`000`0P0`QQ0a2R0f</0/Hh0oNn0ooo0ooO1/iI0V</0aS30`Q11P000`Q10a220QS3
0aSS0g_?0mJJ0ooO0ooo0_oO1/Hh0f<<0aS31@000b4T0bU50bUU6?oo000Gool3:DD302020003:DD3
:FD3S746S542g_/6ool3g_/3g]/3Nnl3Q102:DD302030003020326434:82Hb`3aSP3mkh3ool3oml3
cUT5Hb`36><30003020326424:83Hb`3aSP3mkh3ool3oml5cUT3Hb`36<<324460002244348836<<3
6><3Nll3eYX2oml3ool3oml6aSP3H``26<<600038B@3:DD3:FD8ool3:DD202030003:DD3:FD3S745
S543g_/6ool3g_/3g]/2Nnl3Q103:DD302030003020226434:83Hb`3aSP3mkh3ool3oml2cUT6Hb`3
6><30003020226434:83Hb`3aSP3mkh3ool2oml6cUT3Hb`36<<324450003244348836<<36><3Nll2
eYX3oml3ool3oml6aSP2H``36<<600038B@3:DD2:FD9ool2:DD302030003:DD3:FD3S745S543g_/6
ool3g_/2g]/3Nnl3Q103:DD302030002020326434:83Hb`3aSP3mkh2ool3oml3cUT6Hb`36><30002
020326434:83Hb`3aSP3mkh2ool3oml6cUT3Hb`36<<224460003244348836<<26><3Nll3eYX3oml3
ool3oml5aSP3H``36<<600038B@2:DD3:FD8ool3:DD302030003:DD2:FD3S746S543g_/5ool3g_/3
g]/3Nnl3Q103:DD302020003020326434:83Hb`3aSP2mkh3ool3oml3cUT6Hb`26><3000302032643
4:83Hb`2aSP3mkh3ool3oml6cUT2Hb`36<<324460003244348826<<36><3Nll3eYX3oml3ool2oml6
aSP3H``36<<500038B@3:DD3:FDHool001Ooo`<YA@<0808000<YA@<YI@><L@J<D@;Nn`Koo`?Nn`?N
f`=kk`>4408YA@<080<000<080<8H@<@XP9S;0?6>0?g_P?oo`?og`?>F@ES;0<Hh`<000<080<8H@8@
XP=S;0?6>0?g_P?oo`?og`G>F@=S;0<H``<8@@H00088@@<@PP<H``<Hh`=kc`?FVP;og`?oo`?og`K6
>0=S308H``H000<Q90<YA@<YI@Soo`<YA@8080<000<YA@<YI@><L@F<D@?Nn`Koo`?Nn`?Nf`9kk`>4
40<YA@<080<000<08088H@<@XP=S;0?6>0?g_P?oo`?og`;>F@IS;0<Hh`<000<08088H@<@XP=S;0?6
>0?g_P?oo`;og`K>F@=S;0<H``<8@@D000<8@@<@PP<H``<Hh`=kc`;FVP?og`?oo`?og`K6>09S30<H
``H000<Q90<YA@8YI@Woo`8YA@<080<000<YA@<YI@><L@F<D@?Nn`Koo`?Nn`;Nf`=kk`>440<YA@<0
80<0008080<8H@<@XP=S;0?6>0?g_P;oo`?og`?>F@IS;0<Hh`<0008080<8H@<@XP=S;0?6>0?g_P;o
o`?og`K>F@=S;0<H``88@@H000<8@@<@PP<H``8Hh`=kc`?FVP?og`?oo`?og`G6>0=S30<H``H000<Q
908YA@<YI@Soo`<YA@<080<000<YA@8YI@><L@J<D@?Nn`Goo`?Nn`?Nf`=kk`>440<YA@<0808000<0
80<8H@<@XP=S;0?6>0;g_P?oo`?og`?>F@IS;08Hh`<000<080<8H@<@XP=S;0;6>0?g_P?oo`?og`K>
F@9S;0<H``<8@@H000<8@@<@PP8H``<Hh`=kc`?FVP?og`?oo`;og`K6>0=S30<H``D000<Q90<YA@<Y
IASoo`005ooo0bU50`0P0P000bU50bUU0haa1XaA0]kk1_oo0mkk0mkK0g__0h@@0RU50`0P0`000`0P
0`QQ0a2R0V</0lHh0oNn0ooo0ooO0liI1F</0aSS0`000`0P0`QQ0Q2R0f</0lHh0oNn0ooo0ooO1LiI
0f</0aS30`Q11P000PQ10a220aS30aSS0g_?0mJJ0_oO0ooo0ooO1/Hh0f<<0QS31P000b4T0bU50bUU
2?oo0bU50P0P0`000bU50bUU0haa1HaA0mkk1_oo0mkk0mkK0W__0h@@0bU50`0P0`000`0P0PQQ0a2R
0f</0lHh0oNn0ooo0ooO0/iI1V</0aSS0`000`0P0PQQ0a2R0f</0lHh0oNn0ooo0_oO1/iI0f</0aS3
0`Q11@000`Q10a220aS30aSS0g_?0]JJ0ooO0ooo0ooO1/Hh0V<<0aS31P000b4T0bU50RUU2Ooo0RU5
0`0P0`000bU50bUU0haa1HaA0mkk1_oo0mkk0]kK0g__0h@@0bU50`0P0`000P0P0`QQ0a2R0f</0lHh
0oNn0_oo0ooO0liI1V</0aSS0`000P0P0`QQ0a2R0f</0lHh0oNn0_oo0ooO1/iI0f</0aS30PQ11P00
0`Q10a220aS30QSS0g_?0mJJ0ooO0ooo0ooO1LHh0f<<0aS31P000b4T0RU50bUU2?oo0bU50`0P0`00
0bU50RUU0haa1XaA0mkk1Ooo0mkk0mkK0g__0h@@0bU50`0P0P000`0P0`QQ0a2R0f</0lHh0_Nn0ooo
0ooO0liI1V</0QSS0`000`0P0`QQ0a2R0f</0/Hh0oNn0ooo0ooO1/iI0V</0aS30`Q11P000`Q10a22
0QS30aSS0g_?0mJJ0ooO0ooo0_oO1/Hh0f<<0aS31@000b4T0bU50bUU6?oo000Gool3:DD302020003
:DD3:FD3S746S542g_/6ool3g_/3g]/3Nnl3Q102:DD302030003020326434:82Hb`3aSP3mkh3ool3
oml3cUT5Hb`36><30003020326424:83Hb`3aSP3mkh3ool3oml5cUT3Hb`36<<32446000224434883
6<<36><3Nll3eYX2oml3ool3oml6aSP3H``26<<600038B@3:DD3:FD8ool3:DD202030003:DD3:FD3
S745S543g_/6ool3g_/3g]/2Nnl3Q103:DD302030003020226434:83Hb`3aSP3mkh3ool3oml2cUT6
Hb`36><30003020226434:83Hb`3aSP3mkh3ool2oml6cUT3Hb`36<<324450003244348836<<36><3
Nll2eYX3oml3ool3oml6aSP2H``36<<600038B@3:DD2:FD9ool2:DD302030003:DD3:FD3S745S543
g_/6ool3g_/2g]/3Nnl3Q103:DD302030002020326434:83Hb`3aSP3mkh2ool3oml3cUT6Hb`36><3
0002020326434:83Hb`3aSP3mkh2ool3oml6cUT3Hb`36<<224460003244348836<<26><3Nll3eYX3
oml3ool3oml5aSP3H``36<<600038B@2:DD3:FD8ool3:DD302030003:DD2:FD3S746S543g_/5ool3
g_/3g]/3Nnl3Q103:DD302020003020326434:83Hb`3aSP2mkh3ool3oml3cUT6Hb`26><300030203
26434:83Hb`2aSP3mkh3ool3oml6cUT2Hb`36<<324460003244348826<<36><3Nll3eYX3oml3ool2
oml6aSP3H``36<<500038B@3:DD3:FDHool001Ooo`<YA@<0808000<YA@<YI@><L@J<D@;Nn`Koo`?N
n`?Nf`=kk`>4408YA@<080<000<080<8H@<@XP9S;0?6>0?g_P?oo`?og`?>F@ES;0<Hh`<000<080<8
H@8@XP=S;0?6>0?g_P?oo`?og`G>F@=S;0<H``<8@@H00088@@<@PP<H``<Hh`=kc`?FVP;og`?oo`?o
g`K6>0=S308H``H000<Q90<YA@<YI@Soo`<YA@8080<000<YA@<YI@><L@F<D@?Nn`Koo`?Nn`?Nf`9k
k`>440<YA@<080<000<08088H@<@XP=S;0?6>0?g_P?oo`?og`;>F@IS;0<Hh`<000<08088H@<@XP=S
;0?6>0?g_P?oo`;og`K>F@=S;0<H``<8@@D000<8@@<@PP<H``<Hh`=kc`;FVP?og`?oo`?og`K6>09S
30<H``H000<Q90<YA@8YI@Woo`8YA@<080<000<YA@<YI@><L@F<D@?Nn`Koo`?Nn`;Nf`=kk`>440<Y
A@<080<0008080<8H@<@XP=S;0?6>0?g_P;oo`?og`?>F@IS;0<Hh`<0008080<8H@<@XP=S;0?6>0?g
_P;oo`?og`K>F@=S;0<H``88@@H000<8@@<@PP<H``8Hh`=kc`?FVP?og`?oo`?og`G6>0=S30<H``H0
00<Q908YA@<YI@Soo`<YA@<080<000<YA@8YI@><L@J<D@?Nn`Goo`?Nn`?Nf`=kk`>440<YA@<08080
00<080<8H@<@XP=S;0?6>0;g_P?oo`?og`?>F@IS;08Hh`<000<080<8H@<@XP=S;0;6>0?g_P?oo`?o
g`K>F@9S;0<H``<8@@H000<8@@<@PP8H``<Hh`=kc`?FVP?og`?oo`;og`K6>0=S30<H``D000<Q90<Y
A@<YIASoo`005ooo0bU50`0P0P000bU50bUU0haa1XaA0]kk1_oo0mkk0mkK0g__0h@@0RU50`0P0`00
0`0P0`QQ0a2R0V</0lHh0oNn0ooo0ooO0liI1F</0aSS0`000`0P0`QQ0Q2R0f</0lHh0oNn0ooo0ooO
1LiI0f</0aS30`Q11P000PQ10a220aS30aSS0g_?0mJJ0_oO0ooo0ooO1/Hh0f<<0QS31P000b4T0bU5
0bUU2?oo0bU50P0P0`000bU50bUU0haa1HaA0mkk1_oo0mkk0mkK0W__0h@@0bU50`0P0`000`0P0PQQ
0a2R0f</0lHh0oNn0ooo0ooO0/iI1V</0aSS0`000`0P0PQQ0a2R0f</0lHh0oNn0ooo0_oO1/iI0f</
0aS30`Q11@000`Q10a220aS30aSS0g_?0]JJ0ooO0ooo0ooO1/Hh0V<<0aS31P000b4T0bU50RUU2Ooo
0RU50`0P0`000bU50bUU0haa1HaA0mkk1_oo0mkk0]kK0g__0h@@0bU50`0P0`000P0P0`QQ0a2R0f</
0lHh0oNn0_oo0ooO0liI1V</0aSS0`000P0P0`QQ0a2R0f</0lHh0oNn0_oo0ooO1/iI0f</0aS30PQ1
1P000`Q10a220aS30QSS0g_?0mJJ0ooO0ooo0ooO1LHh0f<<0aS31P000b4T0RU50bUU2?oo0bU50`0P
0`000bU50RUU0haa1XaA0mkk1Ooo0mkk0mkK0g__0h@@0bU50`0P0P000`0P0`QQ0a2R0f</0lHh0_Nn
0ooo0ooO0liI1V</0QSS0`000`0P0`QQ0a2R0f</0/Hh0oNn0ooo0ooO1/iI0V</0aS30`Q11P000`Q1
0a220QS30aSS0g_?0mJJ0ooO0ooo0_oO1/Hh0f<<0aS31@000b4T0bU50bUU6?oo000Gool3:DD30202
0003:DD3:FD3S746S542g_/6ool3g_/3g]/3Nnl3Q102:DD302030003020326434:82Hb`3aSP3mkh3
ool3oml3cUT5Hb`36><30003020326424:83Hb`3aSP3mkh3ool3oml5cUT3Hb`36<<3244600022443
48836<<36><3Nll3eYX2oml3ool3oml6aSP3H``26<<600038B@3:DD3:FD8ool3:DD202030003:DD3
:FD3S745S543g_/6ool3g_/3g]/2Nnl3Q103:DD302030003020226434:83Hb`3aSP3mkh3ool3oml2
cUT6Hb`36><30003020226434:83Hb`3aSP3mkh3ool2oml6cUT3Hb`36<<324450003244348836<<3
6><3Nll2eYX3oml3ool3oml6aSP2H``36<<600038B@3:DD2:FD9ool2:DD302030003:DD3:FD3S745
S543g_/6ool3g_/2g]/3Nnl3Q103:DD302030002020326434:83Hb`3aSP3mkh2ool3oml3cUT6Hb`3
6><30002020326434:83Hb`3aSP3mkh2ool3oml6cUT3Hb`36<<224460003244348836<<26><3Nll3
eYX3oml3ool3oml5aSP3H``36<<600038B@2:DD3:FD8ool3:DD302030003:DD2:FD3S746S543g_/5
ool3g_/3g]/3Nnl3Q103:DD302020003020326434:83Hb`3aSP2mkh3ool3oml3cUT6Hb`26><30003
020326434:83Hb`2aSP3mkh3ool3oml6cUT2Hb`36<<324460003244348826<<36><3Nll3eYX3oml3
ool2oml6aSP3H``36<<500038B@3:DD3:FDHool001Ooo`><L@?Nn`;_O@Koo`?og`?gWP>U=092:0<8
H@<000<@PP<@XP=[C@=S;0;6>0?g_P?oo`?og`?g_P?_O@:Ll`>U50<ii`<8@@H00088@@<@PP=Jj`IJ
b`=BZP:me`?gWPKoo`?g_P?_O@;W?0?W70?Nn`J440>4<0<YI@8Hh`<8H@H000<8@@<@PP9Jj`?660?g
_P?oo`?_O@>U=0F]E@=2:0<8H@H000Soo`><L@;Nn`?_O@Koo`?og`?gWP:U=0=2:0<8H@<000<@PP<@
XP9[C@=S;0?6>0?g_P?oo`?og`;g_P?_O@>Ll`>U50<ii`<8@@D000<8@@<@PP=Jj`IJb`9BZP>me`?g
WPKoo`?g_P;_O@?W?0?W70?Nn`J440:4<0<YI@<Hh`<8H@H000<8@@8@PP=Jj`?660?g_P?oo`?_O@:U
=0J]E@=2:0<8H@D000Woo`:<L@?Nn`?_O@Koo`?og`;gWP>U=0=2:0<8H@<000<@PP8@XP=[C@=S;0?6
>0?g_P?oo`;og`?g_P?_O@>Ll`>U50<ii`88@@H000<8@@<@PP=Jj`EJb`=BZP>me`?gWPKoo`;g_P?_
O@?W?0?W70?Nn`F440>4<0<YI@<Hh`<8H@D000<8@@<@PP=Jj`?660?g_P;oo`?_O@>U=0J]E@=2:0<8
H@D000Soo`><L@?Nn`?_O@Goo`?og`?gWP>U=0=2:0<8H@8000<@PP<@XP=[C@=S;0?6>0?g_P;oo`?o
g`?g_P?_O@>Ll`>U508ii`<8@@H000<8@@<@PP9Jj`IJb`=BZP>me`?gWPGoo`?g_P?_O@?W?0?W70;N
n`J440>4<0<YI@<Hh`<8H@D000<8@@<@PP=Jj`?660;g_P?oo`?_O@>U=0J]E@92:0<8H@H001Soo`00
5ooo0haa0mkk0^mm1_oo0ooO0oNN0jDd0T8X0`QQ0`000a220a2R0f]=0f</0/Hh0oNn0ooo0ooO0oNn
0nmm0Ycc0jDD0cWW0`Q11P000PQ10a220e[[1U[;0e:Z0[gG0oNN1_oo0oNn0nmm0^Ll0nLL0mkk1X@@
0h@`0bUU0QSS0`QQ1P000`Q10a220U[[0lHH0oNn0ooo0nmm0jDd1JeE0d8X0`QQ1P002?oo0haa0]kk
0nmm1_oo0ooO0oNN0ZDd0d8X0`QQ0`000a220a2R0V]=0f</0lHh0oNn0ooo0ooO0_Nn0nmm0icc0jDD
0cWW0`Q11@000`Q10a220e[[1U[;0U:Z0kgG0oNN1_oo0oNn0^mm0nLl0nLL0mkk1X@@0X@`0bUU0aSS
0`QQ1P000`Q10Q220e[[0lHH0oNn0ooo0nmm0ZDd1ZeE0d8X0`QQ1@002Ooo0Xaa0mkk0nmm1_oo0ooO
0_NN0jDd0d8X0`QQ0`000a220Q2R0f]=0f</0lHh0oNn0ooo0_oO0oNn0nmm0icc0jDD0cWW0PQ11P00
0`Q10a220e[[1E[;0e:Z0kgG0oNN1_oo0_Nn0nmm0nLl0nLL0mkk1H@@0h@`0bUU0aSS0`QQ1@000`Q1
0a220e[[0lHH0oNn0_oo0nmm0jDd1ZeE0d8X0`QQ1@002?oo0haa0mkk0nmm1Ooo0ooO0oNN0jDd0d8X
0`QQ0P000a220a2R0f]=0f</0lHh0oNn0_oo0ooO0oNn0nmm0icc0jDD0SWW0`Q11P000`Q10a220U[[
1U[;0e:Z0kgG0oNN1Ooo0oNn0nmm0nLl0nLL0]kk1X@@0h@`0bUU0aSS0`QQ1@000`Q10a220e[[0lHH
0_Nn0ooo0nmm0jDd1ZeE0T8X0`QQ1P006?oo000Gool3S743g_/2kgd6ool3oml3mih3YC@2@RP32643
000348834:83Jdd3Hb`2aSP3mkh3ool3oml3mkh3kgd2W?<3YA@3>NL32446000224434883F^/6F//3
DZX2_ML3mih6ool3mkh3kgd2ic`3ia`3g_/6Q103Q303:FD26><32646000324434882F^/3aQP3mkh3
ool3kgd3YC@5[ED3@RP326460008ool3S742g_/3kgd6ool3oml3mih2YC@3@RP32643000348834:82
Jdd3Hb`3aSP3mkh3ool3oml2mkh3kgd3W?<3YA@3>NL32445000324434883F^/6F//2DZX3_ML3mih6
ool3mkh2kgd3ic`3ia`3g_/6Q102Q303:FD36><32646000324424883F^/3aQP3mkh3ool3kgd2YC@6
[ED3@RP326450009ool2S743g_/3kgd6ool3oml2mih3YC@3@RP32643000348824:83Jdd3Hb`3aSP3
mkh3ool2oml3mkh3kgd3W?<3YA@3>NL22446000324434883F^/5F//3DZX3_ML3mih6ool2mkh3kgd3
ic`3ia`3g_/5Q103Q303:FD36><32645000324434883F^/3aQP3mkh2ool3kgd3YC@6[ED3@RP32645
0008ool3S743g_/3kgd5ool3oml3mih3YC@3@RP32642000348834:83Jdd3Hb`3aSP3mkh2ool3oml3
mkh3kgd3W?<3YA@2>NL32446000324434882F^/6F//3DZX3_ML3mih5ool3mkh3kgd3ic`3ia`2g_/6
Q103Q303:FD36><32645000324434883F^/3aQP2mkh3ool3kgd3YC@6[ED2@RP32646000Hool001Oo
o`><L@?Nn`;_O@Koo`?og`?gWP>U=092:0<8H@<000<@PP<@XP=[C@=S;0;6>0?g_P?oo`?og`?g_P?_
O@:Ll`>U50<ii`<8@@H00088@@<@PP=Jj`IJb`=BZP:me`?gWPKoo`?g_P?_O@;W?0?W70?Nn`J440>4
<0<YI@8Hh`<8H@H000<8@@<@PP9Jj`?660?g_P?oo`?_O@>U=0F]E@=2:0<8H@H000Soo`><L@;Nn`?_
O@Koo`?og`?gWP:U=0=2:0<8H@<000<@PP<@XP9[C@=S;0?6>0?g_P?oo`?og`;g_P?_O@>Ll`>U50<i
i`<8@@D000<8@@<@PP=Jj`IJb`9BZP>me`?gWPKoo`?g_P;_O@?W?0?W70?Nn`J440:4<0<YI@<Hh`<8
H@H000<8@@8@PP=Jj`?660?g_P?oo`?_O@:U=0J]E@=2:0<8H@D000Woo`:<L@?Nn`?_O@Koo`?og`;g
WP>U=0=2:0<8H@<000<@PP8@XP=[C@=S;0?6>0?g_P?oo`;og`?g_P?_O@>Ll`>U50<ii`88@@H000<8
@@<@PP=Jj`EJb`=BZP>me`?gWPKoo`;g_P?_O@?W?0?W70?Nn`F440>4<0<YI@<Hh`<8H@D000<8@@<@
PP=Jj`?660?g_P;oo`?_O@>U=0J]E@=2:0<8H@D000Soo`><L@?Nn`?_O@Goo`?og`?gWP>U=0=2:0<8
H@8000<@PP<@XP=[C@=S;0?6>0?g_P;oo`?og`?g_P?_O@>Ll`>U508ii`<8@@H000<8@@<@PP9Jj`IJ
b`=BZP>me`?gWPGoo`?g_P?_O@?W?0?W70;Nn`J440>4<0<YI@<Hh`<8H@D000<8@@<@PP=Jj`?660;g
_P?oo`?_O@>U=0J]E@92:0<8H@H001Soo`005ooo0haa0mkk0^mm1_oo0ooO0oNN0jDd0T8X0`QQ0`00
0a220a2R0f]=0f</0/Hh0oNn0ooo0ooO0oNn0nmm0Ycc0jDD0cWW0`Q11P000PQ10a220e[[1U[;0e:Z
0[gG0oNN1_oo0oNn0nmm0^Ll0nLL0mkk1X@@0h@`0bUU0QSS0`QQ1P000`Q10a220U[[0lHH0oNn0ooo
0nmm0jDd1JeE0d8X0`QQ1P002?oo0haa0]kk0nmm1_oo0ooO0oNN0ZDd0d8X0`QQ0`000a220a2R0V]=
0f</0lHh0oNn0ooo0ooO0_Nn0nmm0icc0jDD0cWW0`Q11@000`Q10a220e[[1U[;0U:Z0kgG0oNN1_oo
0oNn0^mm0nLl0nLL0mkk1X@@0X@`0bUU0aSS0`QQ1P000`Q10Q220e[[0lHH0oNn0ooo0nmm0ZDd1ZeE
0d8X0`QQ1@002Ooo0Xaa0mkk0nmm1_oo0ooO0_NN0jDd0d8X0`QQ0`000a220Q2R0f]=0f</0lHh0oNn
0ooo0_oO0oNn0nmm0icc0jDD0cWW0PQ11P000`Q10a220e[[1E[;0e:Z0kgG0oNN1_oo0_Nn0nmm0nLl
0nLL0mkk1H@@0h@`0bUU0aSS0`QQ1@000`Q10a220e[[0lHH0oNn0_oo0nmm0jDd1ZeE0d8X0`QQ1@00
2?oo0haa0mkk0nmm1Ooo0ooO0oNN0jDd0d8X0`QQ0P000a220a2R0f]=0f</0lHh0oNn0_oo0ooO0oNn
0nmm0icc0jDD0SWW0`Q11P000`Q10a220U[[1U[;0e:Z0kgG0oNN1Ooo0oNn0nmm0nLl0nLL0]kk1X@@
0h@`0bUU0aSS0`QQ1@000`Q10a220e[[0lHH0_Nn0ooo0nmm0jDd1ZeE0T8X0`QQ1P006?oo000Gool3
S743g_/2kgd6ool3oml3mih3YC@2@RP32643000348834:83Jdd3Hb`2aSP3mkh3ool3oml3mkh3kgd2
W?<3YA@3>NL32446000224434883F^/6F//3DZX2_ML3mih6ool3mkh3kgd2ic`3ia`3g_/6Q103Q303
:FD26><32646000324434882F^/3aQP3mkh3ool3kgd3YC@5[ED3@RP326460008ool3S742g_/3kgd6
ool3oml3mih2YC@3@RP32643000348834:82Jdd3Hb`3aSP3mkh3ool3oml2mkh3kgd3W?<3YA@3>NL3
2445000324434883F^/6F//2DZX3_ML3mih6ool3mkh2kgd3ic`3ia`3g_/6Q102Q303:FD36><32646
000324424883F^/3aQP3mkh3ool3kgd2YC@6[ED3@RP326450009ool2S743g_/3kgd6ool3oml2mih3
YC@3@RP32643000348824:83Jdd3Hb`3aSP3mkh3ool2oml3mkh3kgd3W?<3YA@3>NL2244600032443
4883F^/5F//3DZX3_ML3mih6ool2mkh3kgd3ic`3ia`3g_/5Q103Q303:FD36><32645000324434883
F^/3aQP3mkh2ool3kgd3YC@6[ED3@RP326450008ool3S743g_/3kgd5ool3oml3mih3YC@3@RP32642
000348834:83Jdd3Hb`3aSP3mkh2ool3oml3mkh3kgd3W?<3YA@2>NL32446000324434882F^/6F//3
DZX3_ML3mih5ool3mkh3kgd3ic`3ia`2g_/6Q103Q303:FD36><32645000324434883F^/3aQP2mkh3
ool3kgd3YC@6[ED2@RP32646000Hool001Ooo`><L@?Nn`;_O@Koo`?og`?gWP>U=092:0<8H@<000<@
PP<@XP=[C@=S;0;6>0?g_P?oo`?og`?g_P?_O@:Ll`>U50<ii`<8@@H00088@@<@PP=Jj`IJb`=BZP:m
e`?gWPKoo`?g_P?_O@;W?0?W70?Nn`J440>4<0<YI@8Hh`<8H@H000<8@@<@PP9Jj`?660?g_P?oo`?_
O@>U=0F]E@=2:0<8H@H000Soo`><L@;Nn`?_O@Koo`?og`?gWP:U=0=2:0<8H@<000<@PP<@XP9[C@=S
;0?6>0?g_P?oo`?og`;g_P?_O@>Ll`>U50<ii`<8@@D000<8@@<@PP=Jj`IJb`9BZP>me`?gWPKoo`?g
_P;_O@?W?0?W70?Nn`J440:4<0<YI@<Hh`<8H@H000<8@@8@PP=Jj`?660?g_P?oo`?_O@:U=0J]E@=2
:0<8H@D000Woo`:<L@?Nn`?_O@Koo`?og`;gWP>U=0=2:0<8H@<000<@PP8@XP=[C@=S;0?6>0?g_P?o
o`;og`?g_P?_O@>Ll`>U50<ii`88@@H000<8@@<@PP=Jj`EJb`=BZP>me`?gWPKoo`;g_P?_O@?W?0?W
70?Nn`F440>4<0<YI@<Hh`<8H@D000<8@@<@PP=Jj`?660?g_P;oo`?_O@>U=0J]E@=2:0<8H@D000So
o`><L@?Nn`?_O@Goo`?og`?gWP>U=0=2:0<8H@8000<@PP<@XP=[C@=S;0?6>0?g_P;oo`?og`?g_P?_
O@>Ll`>U508ii`<8@@H000<8@@<@PP9Jj`IJb`=BZP>me`?gWPGoo`?g_P?_O@?W?0?W70;Nn`J440>4
<0<YI@<Hh`<8H@D000<8@@<@PP=Jj`?660;g_P?oo`?_O@>U=0J]E@92:0<8H@H001Soo`005ooo0haa
0mkk0^mm1_oo0ooO0oNN0jDd0T8X0`QQ0`000a220a2R0f]=0f</0/Hh0oNn0ooo0ooO0oNn0nmm0Ycc
0jDD0cWW0`Q11P000PQ10a220e[[1U[;0e:Z0[gG0oNN1_oo0oNn0nmm0^Ll0nLL0mkk1X@@0h@`0bUU
0QSS0`QQ1P000`Q10a220U[[0lHH0oNn0ooo0nmm0jDd1JeE0d8X0`QQ1P002?oo0haa0]kk0nmm1_oo
0ooO0oNN0ZDd0d8X0`QQ0`000a220a2R0V]=0f</0lHh0oNn0ooo0ooO0_Nn0nmm0icc0jDD0cWW0`Q1
1@000`Q10a220e[[1U[;0U:Z0kgG0oNN1_oo0oNn0^mm0nLl0nLL0mkk1X@@0X@`0bUU0aSS0`QQ1P00
0`Q10Q220e[[0lHH0oNn0ooo0nmm0ZDd1ZeE0d8X0`QQ1@002Ooo0Xaa0mkk0nmm1_oo0ooO0_NN0jDd
0d8X0`QQ0`000a220Q2R0f]=0f</0lHh0oNn0ooo0_oO0oNn0nmm0icc0jDD0cWW0PQ11P000`Q10a22
0e[[1E[;0e:Z0kgG0oNN1_oo0_Nn0nmm0nLl0nLL0mkk1H@@0h@`0bUU0aSS0`QQ1@000`Q10a220e[[
0lHH0oNn0_oo0nmm0jDd1ZeE0d8X0`QQ1@002?oo0haa0mkk0nmm1Ooo0ooO0oNN0jDd0d8X0`QQ0P00
0a220a2R0f]=0f</0lHh0oNn0_oo0ooO0oNn0nmm0icc0jDD0SWW0`Q11P000`Q10a220U[[1U[;0e:Z
0kgG0oNN1Ooo0oNn0nmm0nLl0nLL0]kk1X@@0h@`0bUU0aSS0`QQ1@000`Q10a220e[[0lHH0_Nn0ooo
0nmm0jDd1ZeE0T8X0`QQ1P006?oo000Gool3S743g_/2kgd6ool3oml3mih3YC@2@RP3264300034883
4:83Jdd3Hb`2aSP3mkh3ool3oml3mkh3kgd2W?<3YA@3>NL32446000224434883F^/6F//3DZX2_ML3
mih6ool3mkh3kgd2ic`3ia`3g_/6Q103Q303:FD26><32646000324434882F^/3aQP3mkh3ool3kgd3
YC@5[ED3@RP326460008ool3S742g_/3kgd6ool3oml3mih2YC@3@RP32643000348834:82Jdd3Hb`3
aSP3mkh3ool3oml2mkh3kgd3W?<3YA@3>NL32445000324434883F^/6F//2DZX3_ML3mih6ool3mkh2
kgd3ic`3ia`3g_/6Q102Q303:FD36><32646000324424883F^/3aQP3mkh3ool3kgd2YC@6[ED3@RP3
26450009ool2S743g_/3kgd6ool3oml2mih3YC@3@RP32643000348824:83Jdd3Hb`3aSP3mkh3ool2
oml3mkh3kgd3W?<3YA@3>NL22446000324434883F^/5F//3DZX3_ML3mih6ool2mkh3kgd3ic`3ia`3
g_/5Q103Q303:FD36><32645000324434883F^/3aQP3mkh2ool3kgd3YC@6[ED3@RP326450008ool3
S743g_/3kgd5ool3oml3mih3YC@3@RP32642000348834:83Jdd3Hb`3aSP3mkh2ool3oml3mkh3kgd3
W?<3YA@2>NL32446000324434882F^/6F//3DZX3_ML3mih5ool3mkh3kgd3ic`3ia`2g_/6Q103Q303
:FD36><32645000324434883F^/3aQP2mkh3ool3kgd3YC@6[ED2@RP32646000Hool001Ooo`><L@?N
n`;_O@Koo`?og`?gWP>U=092:0<8H@<000<@PP<@XP=[C@=S;0;6>0?g_P?oo`?og`?g_P?_O@:Ll`>U
50<ii`<8@@H00088@@<@PP=Jj`IJb`=BZP:me`?gWPKoo`?g_P?_O@;W?0?W70?Nn`J440>4<0<YI@8H
h`<8H@H000<8@@<@PP9Jj`?660?g_P?oo`?_O@>U=0F]E@=2:0<8H@H000Soo`><L@;Nn`?_O@Koo`?o
g`?gWP:U=0=2:0<8H@<000<@PP<@XP9[C@=S;0?6>0?g_P?oo`?og`;g_P?_O@>Ll`>U50<ii`<8@@D0
00<8@@<@PP=Jj`IJb`9BZP>me`?gWPKoo`?g_P;_O@?W?0?W70?Nn`J440:4<0<YI@<Hh`<8H@H000<8
@@8@PP=Jj`?660?g_P?oo`?_O@:U=0J]E@=2:0<8H@D000Woo`:<L@?Nn`?_O@Koo`?og`;gWP>U=0=2
:0<8H@<000<@PP8@XP=[C@=S;0?6>0?g_P?oo`;og`?g_P?_O@>Ll`>U50<ii`88@@H000<8@@<@PP=J
j`EJb`=BZP>me`?gWPKoo`;g_P?_O@?W?0?W70?Nn`F440>4<0<YI@<Hh`<8H@D000<8@@<@PP=Jj`?6
60?g_P;oo`?_O@>U=0J]E@=2:0<8H@D000Soo`><L@?Nn`?_O@Goo`?og`?gWP>U=0=2:0<8H@8000<@
PP<@XP=[C@=S;0?6>0?g_P;oo`?og`?g_P?_O@>Ll`>U508ii`<8@@H000<8@@<@PP9Jj`IJb`=BZP>m
e`?gWPGoo`?g_P?_O@?W?0?W70;Nn`J440>4<0<YI@<Hh`<8H@D000<8@@<@PP=Jj`?660;g_P?oo`?_
O@>U=0J]E@92:0<8H@H001Soo`005ooo0haa0mkk0^mm1_oo0ooO0oNN0jDd0T8X0`QQ0`000a220a2R
0f]=0f</0/Hh0oNn0ooo0ooO0oNn0nmm0Ycc0jDD0cWW0`Q11P000PQ10a220e[[1U[;0e:Z0[gG0oNN
1_oo0oNn0nmm0^Ll0nLL0mkk1X@@0h@`0bUU0QSS0`QQ1P000`Q10a220U[[0lHH0oNn0ooo0nmm0jDd
1JeE0d8X0`QQ1P002?oo0haa0]kk0nmm1_oo0ooO0oNN0ZDd0d8X0`QQ0`000a220a2R0V]=0f</0lHh
0oNn0ooo0ooO0_Nn0nmm0icc0jDD0cWW0`Q11@000`Q10a220e[[1U[;0U:Z0kgG0oNN1_oo0oNn0^mm
0nLl0nLL0mkk1X@@0X@`0bUU0aSS0`QQ1P000`Q10Q220e[[0lHH0oNn0ooo0nmm0ZDd1ZeE0d8X0`QQ
1@002Ooo0Xaa0mkk0nmm1_oo0ooO0_NN0jDd0d8X0`QQ0`000a220Q2R0f]=0f</0lHh0oNn0ooo0_oO
0oNn0nmm0icc0jDD0cWW0PQ11P000`Q10a220e[[1E[;0e:Z0kgG0oNN1_oo0_Nn0nmm0nLl0nLL0mkk
1H@@0h@`0bUU0aSS0`QQ1@000`Q10a220e[[0lHH0oNn0_oo0nmm0jDd1ZeE0d8X0`QQ1@002?oo0haa
0mkk0nmm1Ooo0ooO0oNN0jDd0d8X0`QQ0P000a220a2R0f]=0f</0lHh0oNn0_oo0ooO0oNn0nmm0icc
0jDD0SWW0`Q11P000`Q10a220U[[1U[;0e:Z0kgG0oNN1Ooo0oNn0nmm0nLl0nLL0]kk1X@@0h@`0bUU
0aSS0`QQ1@000`Q10a220e[[0lHH0_Nn0ooo0nmm0jDd1ZeE0T8X0`QQ1P006?oo000Gool32443@RP2
[ED3ked6ool3e[X3eYX2cWT6Jfd36><60003020226434:836><38@@38B@3:DD5:FD6<HH3<JH3U;82
ia`3mih6ool3mkh3kgd2YA@3@PP3<JH32443000302022643DXX3]KH3kgd6ool3mkh5]KH3DXX3BVT3
488300022646DXX3BVT3]IH3_ML2mih6ool3mkh3kgd3YC@8ool32442@RP3[ED3ked6ool3e[X2eYX3
cWT6Jfd36><50003020326434:836><38@@28B@3:DD6:FD6<HH3<JH2U;83ia`3mih6ool3mkh2kgd3
YA@3@PP3<JH32443000202032643DXX3]KH3kgd5ool3mkh6]KH3DXX3BVT3488200032646DXX3BVT3
]IH2_ML3mih6ool3mkh3kgd2YC@9ool22443@RP3[ED3ked6ool2e[X3eYX3cWT6Jfd36><500030203
26434:836><28@@38B@3:DD6:FD5<HH3<JH3U;83ia`3mih6ool2mkh3kgd3YA@3@PP3<JH324420003
02032643DXX3]KH3kgd5ool3mkh6]KH3DXX2BVT3488300032646DXX2BVT3]IH3_ML3mih6ool3mkh2
kgd3YC@8ool32443@RP3[ED3ked5ool3e[X3eYX3cWT5Jfd36><60003020326434:826><38@@38B@3
:DD6:FD5<HH3<JH3U;83ia`3mih5ool3mkh3kgd3YA@3@PP2<JH32443000302032643DXX2]KH3kgd6
ool3mkh6]KH2DXX3BVT3488300032645DXX3BVT3]IH3_ML3mih5ool3mkh3kgd3YC@Hool001Ooo`<8
@@=2:0:]E@?_G@Koo`?F^P?FVP;>N@I[K@<Hh`H000<08088H@<@XP<Hh`<Q10<Q90<YA@DYI@HaQP<a
YP>D/P;W70?gWPKoo`?g_P?_O@:U50=220<aYP<8@@<000<08088H@=BRP>e]P?_O@Koo`?g_PFe]P=B
RP=:J@<@PP<00088H@IBRP=:J@>eUP>me`;gWPKoo`?g_P?_O@>U=0Soo`<8@@92:0>]E@?_G@Koo`?F
^P;FVP?>N@I[K@<Hh`D000<080<8H@<@XP<Hh`<Q108Q90<YA@HYI@HaQP<aYP:D/P?W70?gWPKoo`?g
_P;_O@>U50=220<aYP<8@@<0008080<8H@=BRP>e]P?_O@Goo`?g_PJe]P=BRP=:J@<@PP8000<8H@IB
RP=:J@>eUP:me`?gWPKoo`?g_P?_O@:U=0Woo`88@@=2:0>]E@?_G@Koo`;F^P?FVP?>N@I[K@<Hh`D0
00<080<8H@<@XP<Hh`8Q10<Q90<YA@HYI@DaQP<aYP>D/P?W70?gWPKoo`;g_P?_O@>U50=220<aYP<8
@@8000<080<8H@=BRP>e]P?_O@Goo`?g_PJe]P=BRP9:J@<@PP<000<8H@IBRP9:J@>eUP>me`?gWPKo
o`?g_P;_O@>U=0Soo`<8@@=2:0>]E@?_G@Goo`?F^P?FVP?>N@E[K@<Hh`H000<080<8H@<@XP8Hh`<Q
10<Q90<YA@HYI@DaQP<aYP>D/P?W70?gWPGoo`?g_P?_O@>U50=2208aYP<8@@<000<080<8H@=BRP:e
]P?_O@Koo`?g_PJe]P9BRP=:J@<@PP<000<8H@EBRP=:J@>eUP>me`?gWPGoo`?g_P?_O@>U=1Soo`00
5ooo0`Q10d8X0ZeE0nmM1_oo0mJj0mJJ0/ii1V]]0aSS1P000`0P0PQQ0a2R0aSS0b440b4T0bU51BUU
1S660c6V0iBb0^LL0oNN1_oo0oNn0nmm0ZDD0d880c6V0`Q10`000`0P0PQQ0e::0kFf0nmm1_oo0oNn
1KFf0e::0dYY0a220`000PQQ1U::0dYY0kFF0kgG0_NN1_oo0oNn0nmm0jDd2?oo0`Q10T8X0jeE0nmM
1_oo0mJj0]JJ0lii1V]]0aSS1@000`0P0`QQ0a2R0aSS0b440R4T0bU51RUU1S660c6V0YBb0nLL0oNN
1_oo0oNn0^mm0jDD0d880c6V0`Q10`000P0P0`QQ0e::0kFf0nmm1Ooo0oNn1[Ff0e::0dYY0a220P00
0`QQ1U::0dYY0kFF0[gG0oNN1_oo0oNn0nmm0ZDd2Ooo0PQ10d8X0jeE0nmM1_oo0]Jj0mJJ0lii1V]]
0aSS1@000`0P0`QQ0a2R0aSS0R440b4T0bU51RUU1C660c6V0iBb0nLL0oNN1_oo0_Nn0nmm0jDD0d88
0c6V0`Q10P000`0P0`QQ0e::0kFf0nmm1Ooo0oNn1[Ff0e::0TYY0a220`000`QQ1U::0TYY0kFF0kgG
0oNN1_oo0oNn0^mm0jDd2?oo0`Q10d8X0jeE0nmM1Ooo0mJj0mJJ0lii1F]]0aSS1P000`0P0`QQ0a2R
0QSS0b440b4T0bU51RUU1C660c6V0iBb0nLL0oNN1Ooo0oNn0nmm0jDD0d880S6V0`Q10`000`0P0`QQ
0e::0[Ff0nmm1_oo0oNn1[Ff0U::0dYY0a220`000`QQ1E::0dYY0kFF0kgG0oNN1Ooo0oNn0nmm0jDd
6?oo000Gool32443@RP2[ED3ked6ool3e[X3eYX2cWT6Jfd36><60003020226434:836><38@@38B@3
:DD5:FD6<HH3<JH3U;82ia`3mih6ool3mkh3kgd2YA@3@PP3<JH32443000302022643DXX3]KH3kgd6
ool3mkh5]KH3DXX3BVT3488300022646DXX3BVT3]IH3_ML2mih6ool3mkh3kgd3YC@8ool32442@RP3
[ED3ked6ool3e[X2eYX3cWT6Jfd36><50003020326434:836><38@@28B@3:DD6:FD6<HH3<JH2U;83
ia`3mih6ool3mkh2kgd3YA@3@PP3<JH32443000202032643DXX3]KH3kgd5ool3mkh6]KH3DXX3BVT3
488200032646DXX3BVT3]IH2_ML3mih6ool3mkh3kgd2YC@9ool22443@RP3[ED3ked6ool2e[X3eYX3
cWT6Jfd36><50003020326434:836><28@@38B@3:DD6:FD5<HH3<JH3U;83ia`3mih6ool2mkh3kgd3
YA@3@PP3<JH32442000302032643DXX3]KH3kgd5ool3mkh6]KH3DXX2BVT3488300032646DXX2BVT3
]IH3_ML3mih6ool3mkh2kgd3YC@8ool32443@RP3[ED3ked5ool3e[X3eYX3cWT5Jfd36><600030203
26434:826><38@@38B@3:DD6:FD5<HH3<JH3U;83ia`3mih5ool3mkh3kgd3YA@3@PP2<JH324430003
02032643DXX2]KH3kgd6ool3mkh6]KH2DXX3BVT3488300032645DXX3BVT3]IH3_ML3mih5ool3mkh3
kgd3YC@Hool001Ooo`<8@@=2:0:]E@?_G@Koo`?F^P?FVP;>N@I[K@<Hh`H000<08088H@<@XP<Hh`<Q
10<Q90<YA@DYI@HaQP<aYP>D/P;W70?gWPKoo`?g_P?_O@:U50=220<aYP<8@@<000<08088H@=BRP>e
]P?_O@Koo`?g_PFe]P=BRP=:J@<@PP<00088H@IBRP=:J@>eUP>me`;gWPKoo`?g_P?_O@>U=0Soo`<8
@@92:0>]E@?_G@Koo`?F^P;FVP?>N@I[K@<Hh`D000<080<8H@<@XP<Hh`<Q108Q90<YA@HYI@HaQP<a
YP:D/P?W70?gWPKoo`?g_P;_O@>U50=220<aYP<8@@<0008080<8H@=BRP>e]P?_O@Goo`?g_PJe]P=B
RP=:J@<@PP8000<8H@IBRP=:J@>eUP:me`?gWPKoo`?g_P?_O@:U=0Woo`88@@=2:0>]E@?_G@Koo`;F
^P?FVP?>N@I[K@<Hh`D000<080<8H@<@XP<Hh`8Q10<Q90<YA@HYI@DaQP<aYP>D/P?W70?gWPKoo`;g
_P?_O@>U50=220<aYP<8@@8000<080<8H@=BRP>e]P?_O@Goo`?g_PJe]P=BRP9:J@<@PP<000<8H@IB
RP9:J@>eUP>me`?gWPKoo`?g_P;_O@>U=0Soo`<8@@=2:0>]E@?_G@Goo`?F^P?FVP?>N@E[K@<Hh`H0
00<080<8H@<@XP8Hh`<Q10<Q90<YA@HYI@DaQP<aYP>D/P?W70?gWPGoo`?g_P?_O@>U50=2208aYP<8
@@<000<080<8H@=BRP:e]P?_O@Koo`?g_PJe]P9BRP=:J@<@PP<000<8H@EBRP=:J@>eUP>me`?gWPGo
o`?g_P?_O@>U=1Soo`005ooo0`Q10d8X0ZeE0nmM1_oo0mJj0mJJ0/ii1V]]0aSS1P000`0P0PQQ0a2R
0aSS0b440b4T0bU51BUU1S660c6V0iBb0^LL0oNN1_oo0oNn0nmm0ZDD0d880c6V0`Q10`000`0P0PQQ
0e::0kFf0nmm1_oo0oNn1KFf0e::0dYY0a220`000PQQ1U::0dYY0kFF0kgG0_NN1_oo0oNn0nmm0jDd
2?oo0`Q10T8X0jeE0nmM1_oo0mJj0]JJ0lii1V]]0aSS1@000`0P0`QQ0a2R0aSS0b440R4T0bU51RUU
1S660c6V0YBb0nLL0oNN1_oo0oNn0^mm0jDD0d880c6V0`Q10`000P0P0`QQ0e::0kFf0nmm1Ooo0oNn
1[Ff0e::0dYY0a220P000`QQ1U::0dYY0kFF0[gG0oNN1_oo0oNn0nmm0ZDd2Ooo0PQ10d8X0jeE0nmM
1_oo0]Jj0mJJ0lii1V]]0aSS1@000`0P0`QQ0a2R0aSS0R440b4T0bU51RUU1C660c6V0iBb0nLL0oNN
1_oo0_Nn0nmm0jDD0d880c6V0`Q10P000`0P0`QQ0e::0kFf0nmm1Ooo0oNn1[Ff0e::0TYY0a220`00
0`QQ1U::0TYY0kFF0kgG0oNN1_oo0oNn0^mm0jDd2?oo0`Q10d8X0jeE0nmM1Ooo0mJj0mJJ0lii1F]]
0aSS1P000`0P0`QQ0a2R0QSS0b440b4T0bU51RUU1C660c6V0iBb0nLL0oNN1Ooo0oNn0nmm0jDD0d88
0S6V0`Q10`000`0P0`QQ0e::0[Ff0nmm1_oo0oNn1[Ff0U::0dYY0a220`000`QQ1E::0dYY0kFF0kgG
0oNN1Ooo0oNn0nmm0jDd6?oo000Gool32443@RP2[ED3ked6ool3e[X3eYX2cWT6Jfd36><600030202
26434:836><38@@38B@3:DD5:FD6<HH3<JH3U;82ia`3mih6ool3mkh3kgd2YA@3@PP3<JH324430003
02022643DXX3]KH3kgd6ool3mkh5]KH3DXX3BVT3488300022646DXX3BVT3]IH3_ML2mih6ool3mkh3
kgd3YC@8ool32442@RP3[ED3ked6ool3e[X2eYX3cWT6Jfd36><50003020326434:836><38@@28B@3
:DD6:FD6<HH3<JH2U;83ia`3mih6ool3mkh2kgd3YA@3@PP3<JH32443000202032643DXX3]KH3kgd5
ool3mkh6]KH3DXX3BVT3488200032646DXX3BVT3]IH2_ML3mih6ool3mkh3kgd2YC@9ool22443@RP3
[ED3ked6ool2e[X3eYX3cWT6Jfd36><50003020326434:836><28@@38B@3:DD6:FD5<HH3<JH3U;83
ia`3mih6ool2mkh3kgd3YA@3@PP3<JH32442000302032643DXX3]KH3kgd5ool3mkh6]KH3DXX2BVT3
488300032646DXX2BVT3]IH3_ML3mih6ool3mkh2kgd3YC@8ool32443@RP3[ED3ked5ool3e[X3eYX3
cWT5Jfd36><60003020326434:826><38@@38B@3:DD6:FD5<HH3<JH3U;83ia`3mih5ool3mkh3kgd3
YA@3@PP2<JH32443000302032643DXX2]KH3kgd6ool3mkh6]KH2DXX3BVT3488300032645DXX3BVT3
]IH3_ML3mih5ool3mkh3kgd3YC@Hool001Ooo`<8@@=2:0:]E@?_G@Koo`?F^P?FVP;>N@I[K@<Hh`H0
00<08088H@<@XP<Hh`<Q10<Q90<YA@DYI@HaQP<aYP>D/P;W70?gWPKoo`?g_P?_O@:U50=220<aYP<8
@@<000<08088H@=BRP>e]P?_O@Koo`?g_PFe]P=BRP=:J@<@PP<00088H@IBRP=:J@>eUP>me`;gWPKo
o`?g_P?_O@>U=0Soo`<8@@92:0>]E@?_G@Koo`?F^P;FVP?>N@I[K@<Hh`D000<080<8H@<@XP<Hh`<Q
108Q90<YA@HYI@HaQP<aYP:D/P?W70?gWPKoo`?g_P;_O@>U50=220<aYP<8@@<0008080<8H@=BRP>e
]P?_O@Goo`?g_PJe]P=BRP=:J@<@PP8000<8H@IBRP=:J@>eUP:me`?gWPKoo`?g_P?_O@:U=0Woo`88
@@=2:0>]E@?_G@Koo`;F^P?FVP?>N@I[K@<Hh`D000<080<8H@<@XP<Hh`8Q10<Q90<YA@HYI@DaQP<a
YP>D/P?W70?gWPKoo`;g_P?_O@>U50=220<aYP<8@@8000<080<8H@=BRP>e]P?_O@Goo`?g_PJe]P=B
RP9:J@<@PP<000<8H@IBRP9:J@>eUP>me`?gWPKoo`?g_P;_O@>U=0Soo`<8@@=2:0>]E@?_G@Goo`?F
^P?FVP?>N@E[K@<Hh`H000<080<8H@<@XP8Hh`<Q10<Q90<YA@HYI@DaQP<aYP>D/P?W70?gWPGoo`?g
_P?_O@>U50=2208aYP<8@@<000<080<8H@=BRP:e]P?_O@Koo`?g_PJe]P9BRP=:J@<@PP<000<8H@EB
RP=:J@>eUP>me`?gWPGoo`?g_P?_O@>U=1Soo`005ooo0`Q10d8X0ZeE0nmM1_oo0mJj0mJJ0/ii1V]]
0aSS1P000`0P0PQQ0a2R0aSS0b440b4T0bU51BUU1S660c6V0iBb0^LL0oNN1_oo0oNn0nmm0ZDD0d88
0c6V0`Q10`000`0P0PQQ0e::0kFf0nmm1_oo0oNn1KFf0e::0dYY0a220`000PQQ1U::0dYY0kFF0kgG
0_NN1_oo0oNn0nmm0jDd2?oo0`Q10T8X0jeE0nmM1_oo0mJj0]JJ0lii1V]]0aSS1@000`0P0`QQ0a2R
0aSS0b440R4T0bU51RUU1S660c6V0YBb0nLL0oNN1_oo0oNn0^mm0jDD0d880c6V0`Q10`000P0P0`QQ
0e::0kFf0nmm1Ooo0oNn1[Ff0e::0dYY0a220P000`QQ1U::0dYY0kFF0[gG0oNN1_oo0oNn0nmm0ZDd
2Ooo0PQ10d8X0jeE0nmM1_oo0]Jj0mJJ0lii1V]]0aSS1@000`0P0`QQ0a2R0aSS0R440b4T0bU51RUU
1C660c6V0iBb0nLL0oNN1_oo0_Nn0nmm0jDD0d880c6V0`Q10P000`0P0`QQ0e::0kFf0nmm1Ooo0oNn
1[Ff0e::0TYY0a220`000`QQ1U::0TYY0kFF0kgG0oNN1_oo0oNn0^mm0jDd2?oo0`Q10d8X0jeE0nmM
1Ooo0mJj0mJJ0lii1F]]0aSS1P000`0P0`QQ0a2R0QSS0b440b4T0bU51RUU1C660c6V0iBb0nLL0oNN
1Ooo0oNn0nmm0jDD0d880S6V0`Q10`000`0P0`QQ0e::0[Ff0nmm1_oo0oNn1[Ff0U::0dYY0a220`00
0`QQ1E::0dYY0kFF0kgG0oNN1Ooo0oNn0nmm0jDd6?oo000Gool32443@RP2[ED3ked6ool3e[X3eYX2
cWT6Jfd36><60003020226434:836><38@@38B@3:DD5:FD6<HH3<JH3U;82ia`3mih6ool3mkh3kgd2
YA@3@PP3<JH32443000302022643DXX3]KH3kgd6ool3mkh5]KH3DXX3BVT3488300022646DXX3BVT3
]IH3_ML2mih6ool3mkh3kgd3YC@8ool32442@RP3[ED3ked6ool3e[X2eYX3cWT6Jfd36><500030203
26434:836><38@@28B@3:DD6:FD6<HH3<JH2U;83ia`3mih6ool3mkh2kgd3YA@3@PP3<JH324430002
02032643DXX3]KH3kgd5ool3mkh6]KH3DXX3BVT3488200032646DXX3BVT3]IH2_ML3mih6ool3mkh3
kgd2YC@9ool22443@RP3[ED3ked6ool2e[X3eYX3cWT6Jfd36><50003020326434:836><28@@38B@3
:DD6:FD5<HH3<JH3U;83ia`3mih6ool2mkh3kgd3YA@3@PP3<JH32442000302032643DXX3]KH3kgd5
ool3mkh6]KH3DXX2BVT3488300032646DXX2BVT3]IH3_ML3mih6ool3mkh2kgd3YC@8ool32443@RP3
[ED3ked5ool3e[X3eYX3cWT5Jfd36><60003020326434:826><38@@38B@3:DD6:FD5<HH3<JH3U;83
ia`3mih5ool3mkh3kgd3YA@3@PP2<JH32443000302032643DXX2]KH3kgd6ool3mkh6]KH2DXX3BVT3
488300032645DXX3BVT3]IH3_ML3mih5ool3mkh3kgd3YC@Hool001Ooo`<8@@=2:0:]E@?_G@Koo`?F
^P?FVP;>N@I[K@<Hh`H000<08088H@<@XP<Hh`<Q10<Q90<YA@DYI@HaQP<aYP>D/P;W70?gWPKoo`?g
_P?_O@:U50=220<aYP<8@@<000<08088H@=BRP>e]P?_O@Koo`?g_PFe]P=BRP=:J@<@PP<00088H@IB
RP=:J@>eUP>me`;gWPKoo`?g_P?_O@>U=0Soo`<8@@92:0>]E@?_G@Koo`?F^P;FVP?>N@I[K@<Hh`D0
00<080<8H@<@XP<Hh`<Q108Q90<YA@HYI@HaQP<aYP:D/P?W70?gWPKoo`?g_P;_O@>U50=220<aYP<8
@@<0008080<8H@=BRP>e]P?_O@Goo`?g_PJe]P=BRP=:J@<@PP8000<8H@IBRP=:J@>eUP:me`?gWPKo
o`?g_P?_O@:U=0Woo`88@@=2:0>]E@?_G@Koo`;F^P?FVP?>N@I[K@<Hh`D000<080<8H@<@XP<Hh`8Q
10<Q90<YA@HYI@DaQP<aYP>D/P?W70?gWPKoo`;g_P?_O@>U50=220<aYP<8@@8000<080<8H@=BRP>e
]P?_O@Goo`?g_PJe]P=BRP9:J@<@PP<000<8H@IBRP9:J@>eUP>me`?gWPKoo`?g_P;_O@>U=0Soo`<8
@@=2:0>]E@?_G@Goo`?F^P?FVP?>N@E[K@<Hh`H000<080<8H@<@XP8Hh`<Q10<Q90<YA@HYI@DaQP<a
YP>D/P?W70?gWPGoo`?g_P?_O@>U50=2208aYP<8@@<000<080<8H@=BRP:e]P?_O@Koo`?g_PJe]P9B
RP=:J@<@PP<000<8H@EBRP=:J@>eUP>me`?gWPGoo`?g_P?_O@>U=1Soo`005ooo0`Q10d8X0ZeE0nmM
1_oo0mJj0mJJ0/ii1V]]0aSS1P000`0P0PQQ0a2R0aSS0b440b4T0bU51BUU1S660c6V0iBb0^LL0oNN
1_oo0oNn0nmm0ZDD0d880c6V0`Q10`000`0P0PQQ0e::0kFf0nmm1_oo0oNn1KFf0e::0dYY0a220`00
0PQQ1U::0dYY0kFF0kgG0_NN1_oo0oNn0nmm0jDd2?oo0`Q10T8X0jeE0nmM1_oo0mJj0]JJ0lii1V]]
0aSS1@000`0P0`QQ0a2R0aSS0b440R4T0bU51RUU1S660c6V0YBb0nLL0oNN1_oo0oNn0^mm0jDD0d88
0c6V0`Q10`000P0P0`QQ0e::0kFf0nmm1Ooo0oNn1[Ff0e::0dYY0a220P000`QQ1U::0dYY0kFF0[gG
0oNN1_oo0oNn0nmm0ZDd2Ooo0PQ10d8X0jeE0nmM1_oo0]Jj0mJJ0lii1V]]0aSS1@000`0P0`QQ0a2R
0aSS0R440b4T0bU51RUU1C660c6V0iBb0nLL0oNN1_oo0_Nn0nmm0jDD0d880c6V0`Q10P000`0P0`QQ
0e::0kFf0nmm1Ooo0oNn1[Ff0e::0TYY0a220`000`QQ1U::0TYY0kFF0kgG0oNN1_oo0oNn0^mm0jDd
2?oo0`Q10d8X0jeE0nmM1Ooo0mJj0mJJ0lii1F]]0aSS1P000`0P0`QQ0a2R0QSS0b440b4T0bU51RUU
1C660c6V0iBb0nLL0oNN1Ooo0oNn0nmm0jDD0d880S6V0`Q10`000`0P0`QQ0e::0[Ff0nmm1_oo0oNn
1[Ff0U::0dYY0a220`000`QQ1E::0dYY0kFF0kgG0oNN1Ooo0oNn0nmm0jDd6?oo000Gool3YC@3[ED2
[GD3BTT3264600038B@2:DD3:FD6S743g_/6ool2oml3mih3[ED3@RP326450003244348836<<36><3
8@@5Nnl3e[X3oml3ool3ia`2g_/3Q103:DD302030003020226434:836<<38@@38B@6:DD2:FD6<HH6
U;83ia`5ool3g_/3Nnl3:DD36<<500038B@3Q303Q103g]/8ool3YC@2[ED3[GD3BTT3264600028B@3
:DD3:FD6S743g_/5ool3oml3mih3[ED3@RP226460003244348836<<36><28@@6Nnl3e[X3oml3ool2
ia`3g_/3Q103:DD302030002020326434:836<<38@@38B@5:DD3:FD6<HH6U;82ia`6ool3g_/3Nnl3
:DD26<<600038B@3Q303Q102g]/9ool2YC@3[ED3[GD3BTT3264500038B@3:DD3:FD6S742g_/6ool3
oml3mih3[ED2@RP326460003244348826<<36><38@@6Nnl3e[X3oml2ool3ia`3g_/3Q103:DD30202
0003020326434:836<<38@@28B@6:DD3:FD6<HH5U;83ia`6ool3g_/2Nnl3:DD36<<600038B@3Q302
Q103g]/8ool3YC@3[ED3[GD3BTT2264600038B@3:DD3:FD5S743g_/6ool3oml3mih2[ED3@RP32646
0003244248836<<36><38@@6Nnl2e[X3oml3ool3ia`3g_/3Q102:DD302030003020326434:826<<3
8@@38B@6:DD3:FD5<HH6U;83ia`6ool2g_/3Nnl3:DD36<<600028B@3Q303Q103g]/Hool001Ooo`>U
=0>]E@:]M@=:B@<8H@H000<Q908YA@<YI@J<L@?Nn`Koo`;og`?gWP>]E@=2:0<8H@D000<8@@<@PP<H
``<Hh`<Q10Ekk`?F^P?og`?oo`?W70;Nn`>440<YA@<080<000<08088H@<@XP<H``<Q10<Q90HYA@8Y
I@HaQPJD/P?W70Goo`?Nn`=kk`<YA@<H``D000<Q90>4<0>440?Nf`Soo`>U=0:]E@>]M@=:B@<8H@H0
008Q90<YA@<YI@J<L@?Nn`Goo`?og`?gWP>]E@=2:088H@H000<8@@<@PP<H``<Hh`8Q10Ikk`?F^P?o
g`?oo`;W70?Nn`>440<YA@<080<0008080<8H@<@XP<H``<Q10<Q90DYA@<YI@HaQPJD/P;W70Koo`?N
n`=kk`<YA@8H``H000<Q90>4<0>440;Nf`Woo`:U=0>]E@>]M@=:B@<8H@D000<Q90<YA@<YI@J<L@;N
n`Koo`?og`?gWP>]E@92:0<8H@H000<8@@<@PP8H``<Hh`<Q10Ikk`?F^P?og`;oo`?W70?Nn`>440<Y
A@<0808000<080<8H@<@XP<H``<Q108Q90HYA@<YI@HaQPFD/P?W70Koo`?Nn`9kk`<YA@<H``H000<Q
90>4<0:440?Nf`Soo`>U=0>]E@>]M@=:B@88H@H000<Q90<YA@<YI@F<L@?Nn`Koo`?og`?gWP:]E@=2
:0<8H@H000<8@@8@PP<H``<Hh`<Q10Ikk`;F^P?og`?oo`?W70?Nn`>4408YA@<080<000<080<8H@<@
XP8H``<Q10<Q90HYA@<YI@DaQPJD/P?W70Koo`;Nn`=kk`<YA@<H``H0008Q90>4<0>440?NfaSoo`00
5ooo0jDd0jeE0Zee0dY90`QQ1P000b4T0RU50bUU1Xaa0mkk1_oo0_oO0oNN0jeE0d8X0`QQ1@000`Q1
0a220aS30aSS0b441G__0mJj0ooO0ooo0nLL0]kk0h@@0bU50`0P0`000`0P0PQQ0a2R0aS30b440b4T
1RU50RUU1S661YBb0nLL1Ooo0mkk0g__0bU50aS31@000b4T0h@`0h@@0mkK2?oo0jDd0ZeE0jee0dY9
0`QQ1P000R4T0bU50bUU1Xaa0mkk1Ooo0ooO0oNN0jeE0d8X0PQQ1P000`Q10a220aS30aSS0R441W__
0mJj0ooO0ooo0^LL0mkk0h@@0bU50`0P0`000P0P0`QQ0a2R0aS30b440b4T1BU50bUU1S661YBb0^LL
1_oo0mkk0g__0bU50QS31P000b4T0h@`0h@@0]kK2Ooo0ZDd0jeE0jee0dY90`QQ1@000b4T0bU50bUU
1Xaa0]kk1_oo0ooO0oNN0jeE0T8X0`QQ1P000`Q10a220QS30aSS0b441W__0mJj0ooO0_oo0nLL0mkk
0h@@0bU50`0P0P000`0P0`QQ0a2R0aS30b440R4T1RU50bUU1S661IBb0nLL1_oo0mkk0W__0bU50aS3
1P000b4T0h@`0X@@0mkK2?oo0jDd0jeE0jee0dY90PQQ1P000b4T0bU50bUU1Haa0mkk1_oo0ooO0oNN
0ZeE0d8X0`QQ1P000`Q10Q220aS30aSS0b441W__0]Jj0ooO0ooo0nLL0mkk0h@@0RU50`0P0`000`0P
0`QQ0a2R0QS30b440b4T1RU50bUU1C661YBb0nLL1_oo0]kk0g__0bU50aS31P000R4T0h@`0h@@0mkK
6?oo000Gool3YC@3[ED2[GD3BTT3264600038B@2:DD3:FD6S743g_/6ool2oml3mih3[ED3@RP32645
0003244348836<<36><38@@5Nnl3e[X3oml3ool3ia`2g_/3Q103:DD302030003020226434:836<<3
8@@38B@6:DD2:FD6<HH6U;83ia`5ool3g_/3Nnl3:DD36<<500038B@3Q303Q103g]/8ool3YC@2[ED3
[GD3BTT3264600028B@3:DD3:FD6S743g_/5ool3oml3mih3[ED3@RP226460003244348836<<36><2
8@@6Nnl3e[X3oml3ool2ia`3g_/3Q103:DD302030002020326434:836<<38@@38B@5:DD3:FD6<HH6
U;82ia`6ool3g_/3Nnl3:DD26<<600038B@3Q303Q102g]/9ool2YC@3[ED3[GD3BTT3264500038B@3
:DD3:FD6S742g_/6ool3oml3mih3[ED2@RP326460003244348826<<36><38@@6Nnl3e[X3oml2ool3
ia`3g_/3Q103:DD302020003020326434:836<<38@@28B@6:DD3:FD6<HH5U;83ia`6ool3g_/2Nnl3
:DD36<<600038B@3Q302Q103g]/8ool3YC@3[ED3[GD3BTT2264600038B@3:DD3:FD5S743g_/6ool3
oml3mih2[ED3@RP326460003244248836<<36><38@@6Nnl2e[X3oml3ool3ia`3g_/3Q102:DD30203
0003020326434:826<<38@@38B@6:DD3:FD5<HH6U;83ia`6ool2g_/3Nnl3:DD36<<600028B@3Q303
Q103g]/Hool001Ooo`>U=0>]E@:]M@=:B@<8H@H000<Q908YA@<YI@J<L@?Nn`Koo`;og`?gWP>]E@=2
:0<8H@D000<8@@<@PP<H``<Hh`<Q10Ekk`?F^P?og`?oo`?W70;Nn`>440<YA@<080<000<08088H@<@
XP<H``<Q10<Q90HYA@8YI@HaQPJD/P?W70Goo`?Nn`=kk`<YA@<H``D000<Q90>4<0>440?Nf`Soo`>U
=0:]E@>]M@=:B@<8H@H0008Q90<YA@<YI@J<L@?Nn`Goo`?og`?gWP>]E@=2:088H@H000<8@@<@PP<H
``<Hh`8Q10Ikk`?F^P?og`?oo`;W70?Nn`>440<YA@<080<0008080<8H@<@XP<H``<Q10<Q90DYA@<Y
I@HaQPJD/P;W70Koo`?Nn`=kk`<YA@8H``H000<Q90>4<0>440;Nf`Woo`:U=0>]E@>]M@=:B@<8H@D0
00<Q90<YA@<YI@J<L@;Nn`Koo`?og`?gWP>]E@92:0<8H@H000<8@@<@PP8H``<Hh`<Q10Ikk`?F^P?o
g`;oo`?W70?Nn`>440<YA@<0808000<080<8H@<@XP<H``<Q108Q90HYA@<YI@HaQPFD/P?W70Koo`?N
n`9kk`<YA@<H``H000<Q90>4<0:440?Nf`Soo`>U=0>]E@>]M@=:B@88H@H000<Q90<YA@<YI@F<L@?N
n`Koo`?og`?gWP:]E@=2:0<8H@H000<8@@8@PP<H``<Hh`<Q10Ikk`;F^P?og`?oo`?W70?Nn`>4408Y
A@<080<000<080<8H@<@XP8H``<Q10<Q90HYA@<YI@DaQPJD/P?W70Koo`;Nn`=kk`<YA@<H``H0008Q
90>4<0>440?NfaSoo`005ooo0jDd0jeE0Zee0dY90`QQ1P000b4T0RU50bUU1Xaa0mkk1_oo0_oO0oNN
0jeE0d8X0`QQ1@000`Q10a220aS30aSS0b441G__0mJj0ooO0ooo0nLL0]kk0h@@0bU50`0P0`000`0P
0PQQ0a2R0aS30b440b4T1RU50RUU1S661YBb0nLL1Ooo0mkk0g__0bU50aS31@000b4T0h@`0h@@0mkK
2?oo0jDd0ZeE0jee0dY90`QQ1P000R4T0bU50bUU1Xaa0mkk1Ooo0ooO0oNN0jeE0d8X0PQQ1P000`Q1
0a220aS30aSS0R441W__0mJj0ooO0ooo0^LL0mkk0h@@0bU50`0P0`000P0P0`QQ0a2R0aS30b440b4T
1BU50bUU1S661YBb0^LL1_oo0mkk0g__0bU50QS31P000b4T0h@`0h@@0]kK2Ooo0ZDd0jeE0jee0dY9
0`QQ1@000b4T0bU50bUU1Xaa0]kk1_oo0ooO0oNN0jeE0T8X0`QQ1P000`Q10a220QS30aSS0b441W__
0mJj0ooO0_oo0nLL0mkk0h@@0bU50`0P0P000`0P0`QQ0a2R0aS30b440R4T1RU50bUU1S661IBb0nLL
1_oo0mkk0W__0bU50aS31P000b4T0h@`0X@@0mkK2?oo0jDd0jeE0jee0dY90PQQ1P000b4T0bU50bUU
1Haa0mkk1_oo0ooO0oNN0ZeE0d8X0`QQ1P000`Q10Q220aS30aSS0b441W__0]Jj0ooO0ooo0nLL0mkk
0h@@0RU50`0P0`000`0P0`QQ0a2R0QS30b440b4T1RU50bUU1C661YBb0nLL1_oo0]kk0g__0bU50aS3
1P000R4T0h@`0h@@0mkK6?oo000Gool3YC@3[ED2[GD3BTT3264600038B@2:DD3:FD6S743g_/6ool2
oml3mih3[ED3@RP326450003244348836<<36><38@@5Nnl3e[X3oml3ool3ia`2g_/3Q103:DD30203
0003020226434:836<<38@@38B@6:DD2:FD6<HH6U;83ia`5ool3g_/3Nnl3:DD36<<500038B@3Q303
Q103g]/8ool3YC@2[ED3[GD3BTT3264600028B@3:DD3:FD6S743g_/5ool3oml3mih3[ED3@RP22646
0003244348836<<36><28@@6Nnl3e[X3oml3ool2ia`3g_/3Q103:DD302030002020326434:836<<3
8@@38B@5:DD3:FD6<HH6U;82ia`6ool3g_/3Nnl3:DD26<<600038B@3Q303Q102g]/9ool2YC@3[ED3
[GD3BTT3264500038B@3:DD3:FD6S742g_/6ool3oml3mih3[ED2@RP326460003244348826<<36><3
8@@6Nnl3e[X3oml2ool3ia`3g_/3Q103:DD302020003020326434:836<<38@@28B@6:DD3:FD6<HH5
U;83ia`6ool3g_/2Nnl3:DD36<<600038B@3Q302Q103g]/8ool3YC@3[ED3[GD3BTT2264600038B@3
:DD3:FD5S743g_/6ool3oml3mih2[ED3@RP326460003244248836<<36><38@@6Nnl2e[X3oml3ool3
ia`3g_/3Q102:DD302030003020326434:826<<38@@38B@6:DD3:FD5<HH6U;83ia`6ool2g_/3Nnl3
:DD36<<600028B@3Q303Q103g]/Hool001Ooo`>U=0>]E@:]M@=:B@<8H@H000<Q908YA@<YI@J<L@?N
n`Koo`;og`?gWP>]E@=2:0<8H@D000<8@@<@PP<H``<Hh`<Q10Ekk`?F^P?og`?oo`?W70;Nn`>440<Y
A@<080<000<08088H@<@XP<H``<Q10<Q90HYA@8YI@HaQPJD/P?W70Goo`?Nn`=kk`<YA@<H``D000<Q
90>4<0>440?Nf`Soo`>U=0:]E@>]M@=:B@<8H@H0008Q90<YA@<YI@J<L@?Nn`Goo`?og`?gWP>]E@=2
:088H@H000<8@@<@PP<H``<Hh`8Q10Ikk`?F^P?og`?oo`;W70?Nn`>440<YA@<080<0008080<8H@<@
XP<H``<Q10<Q90DYA@<YI@HaQPJD/P;W70Koo`?Nn`=kk`<YA@8H``H000<Q90>4<0>440;Nf`Woo`:U
=0>]E@>]M@=:B@<8H@D000<Q90<YA@<YI@J<L@;Nn`Koo`?og`?gWP>]E@92:0<8H@H000<8@@<@PP8H
``<Hh`<Q10Ikk`?F^P?og`;oo`?W70?Nn`>440<YA@<0808000<080<8H@<@XP<H``<Q108Q90HYA@<Y
I@HaQPFD/P?W70Koo`?Nn`9kk`<YA@<H``H000<Q90>4<0:440?Nf`Soo`>U=0>]E@>]M@=:B@88H@H0
00<Q90<YA@<YI@F<L@?Nn`Koo`?og`?gWP:]E@=2:0<8H@H000<8@@8@PP<H``<Hh`<Q10Ikk`;F^P?o
g`?oo`?W70?Nn`>4408YA@<080<000<080<8H@<@XP8H``<Q10<Q90HYA@<YI@DaQPJD/P?W70Koo`;N
n`=kk`<YA@<H``H0008Q90>4<0>440?NfaSoo`005ooo0jDd0jeE0Zee0dY90`QQ1P000b4T0RU50bUU
1Xaa0mkk1_oo0_oO0oNN0jeE0d8X0`QQ1@000`Q10a220aS30aSS0b441G__0mJj0ooO0ooo0nLL0]kk
0h@@0bU50`0P0`000`0P0PQQ0a2R0aS30b440b4T1RU50RUU1S661YBb0nLL1Ooo0mkk0g__0bU50aS3
1@000b4T0h@`0h@@0mkK2?oo0jDd0ZeE0jee0dY90`QQ1P000R4T0bU50bUU1Xaa0mkk1Ooo0ooO0oNN
0jeE0d8X0PQQ1P000`Q10a220aS30aSS0R441W__0mJj0ooO0ooo0^LL0mkk0h@@0bU50`0P0`000P0P
0`QQ0a2R0aS30b440b4T1BU50bUU1S661YBb0^LL1_oo0mkk0g__0bU50QS31P000b4T0h@`0h@@0]kK
2Ooo0ZDd0jeE0jee0dY90`QQ1@000b4T0bU50bUU1Xaa0]kk1_oo0ooO0oNN0jeE0T8X0`QQ1P000`Q1
0a220QS30aSS0b441W__0mJj0ooO0_oo0nLL0mkk0h@@0bU50`0P0P000`0P0`QQ0a2R0aS30b440R4T
1RU50bUU1S661IBb0nLL1_oo0mkk0W__0bU50aS31P000b4T0h@`0X@@0mkK2?oo0jDd0jeE0jee0dY9
0PQQ1P000b4T0bU50bUU1Haa0mkk1_oo0ooO0oNN0ZeE0d8X0`QQ1P000`Q10Q220aS30aSS0b441W__
0]Jj0ooO0ooo0nLL0mkk0h@@0RU50`0P0`000`0P0`QQ0a2R0QS30b440b4T1RU50bUU1C661YBb0nLL
1_oo0]kk0g__0bU50aS31P000R4T0h@`0h@@0mkK6?oo000Gool3YC@3[ED2[GD3BTT3264600038B@2
:DD3:FD6S743g_/6ool2oml3mih3[ED3@RP326450003244348836<<36><38@@5Nnl3e[X3oml3ool3
ia`2g_/3Q103:DD302030003020226434:836<<38@@38B@6:DD2:FD6<HH6U;83ia`5ool3g_/3Nnl3
:DD36<<500038B@3Q303Q103g]/8ool3YC@2[ED3[GD3BTT3264600028B@3:DD3:FD6S743g_/5ool3
oml3mih3[ED3@RP226460003244348836<<36><28@@6Nnl3e[X3oml3ool2ia`3g_/3Q103:DD30203
0002020326434:836<<38@@38B@5:DD3:FD6<HH6U;82ia`6ool3g_/3Nnl3:DD26<<600038B@3Q303
Q102g]/9ool2YC@3[ED3[GD3BTT3264500038B@3:DD3:FD6S742g_/6ool3oml3mih3[ED2@RP32646
0003244348826<<36><38@@6Nnl3e[X3oml2ool3ia`3g_/3Q103:DD302020003020326434:836<<3
8@@28B@6:DD3:FD6<HH5U;83ia`6ool3g_/2Nnl3:DD36<<600038B@3Q302Q103g]/8ool3YC@3[ED3
[GD3BTT2264600038B@3:DD3:FD5S743g_/6ool3oml3mih2[ED3@RP326460003244248836<<36><3
8@@6Nnl2e[X3oml3ool3ia`3g_/3Q102:DD302030003020326434:826<<38@@38B@6:DD3:FD5<HH6
U;83ia`6ool2g_/3Nnl3:DD36<<600028B@3Q303Q103g]/Hool001Ooo`>U=0>]E@:]M@=:B@<8H@H0
00<Q908YA@<YI@J<L@?Nn`Koo`;og`?gWP>]E@=2:0<8H@D000<8@@<@PP<H``<Hh`<Q10Ekk`?F^P?o
g`?oo`?W70;Nn`>440<YA@<080<000<08088H@<@XP<H``<Q10<Q90HYA@8YI@HaQPJD/P?W70Goo`?N
n`=kk`<YA@<H``D000<Q90>4<0>440?Nf`Soo`>U=0:]E@>]M@=:B@<8H@H0008Q90<YA@<YI@J<L@?N
n`Goo`?og`?gWP>]E@=2:088H@H000<8@@<@PP<H``<Hh`8Q10Ikk`?F^P?og`?oo`;W70?Nn`>440<Y
A@<080<0008080<8H@<@XP<H``<Q10<Q90DYA@<YI@HaQPJD/P;W70Koo`?Nn`=kk`<YA@8H``H000<Q
90>4<0>440;Nf`Woo`:U=0>]E@>]M@=:B@<8H@D000<Q90<YA@<YI@J<L@;Nn`Koo`?og`?gWP>]E@92
:0<8H@H000<8@@<@PP8H``<Hh`<Q10Ikk`?F^P?og`;oo`?W70?Nn`>440<YA@<0808000<080<8H@<@
XP<H``<Q108Q90HYA@<YI@HaQPFD/P?W70Koo`?Nn`9kk`<YA@<H``H000<Q90>4<0:440?Nf`Soo`>U
=0>]E@>]M@=:B@88H@H000<Q90<YA@<YI@F<L@?Nn`Koo`?og`?gWP:]E@=2:0<8H@H000<8@@8@PP<H
``<Hh`<Q10Ikk`;F^P?og`?oo`?W70?Nn`>4408YA@<080<000<080<8H@<@XP8H``<Q10<Q90HYA@<Y
I@DaQPJD/P?W70Koo`;Nn`=kk`<YA@<H``H0008Q90>4<0>440?NfaSoo`005ooo0ooO0ooo0_oO1/HH
0e[[0aS30`0P0P000`0P0`QQ0e::0dYY0kFF0nmm0_oo0oNN0nmM0icC0cW70`Q10P000`0P336V1CW7
0icc0nLl0oNn0ooo0_oO0oNn0nmm0nLl0nLL0h@`0XaA0bUU0`0P0`000b441W_?0]JJ0ooO0ooo0ooO
0lHh0f<<0QS31P000b4T0bU50haA0]kk1_oo0mkk0mkK0mJj2?oo0ooO0_oo0ooO1/HH0e[[0aS30P0P
0`000`0P0`QQ0e::0dYY0[FF0nmm0ooo0oNN0nmM0icC0SW70`Q10`000`0P2c6V1SW70icc0nLl0oNn
0_oo0ooO0oNn0nmm0nLl0nLL0X@`0haA0bUU0`0P0`000b441G_?0mJJ0ooO0ooo0ooO0lHh0V<<0aS3
1P000b4T0bU50XaA0mkk1_oo0mkk0mkK0]Jj2Ooo0_oO0ooo0ooO1/HH0e[[0QS30`0P0`000`0P0`QQ
0e::0TYY0kFF0nmm0ooo0oNN0nmM0YcC0cW70`Q10`000`0P2c6V1SW70icc0nLl0_Nn0ooo0ooO0oNn
0nmm0nLl0^LL0h@`0haA0bUU0`0P0`000R441W_?0mJJ0ooO0ooo0_oO0lHh0f<<0aS31P000R4T0bU5
0haA0mkk1_oo0mkk0]kK0mJj2?oo0ooO0ooo0ooO1LHH0e[[0aS30`0P0`000`0P0PQQ0e::0dYY0kFF
0nmm0ooo0oNN0^mM0icC0cW70`Q10`000`0P2c6V1SW70Ycc0nLl0oNn0ooo0ooO0oNn0^mm0nLl0nLL
0h@`0haA0bUU0P0P0`000b441W_?0mJJ0ooO0_oo0ooO0lHh0f<<0aS31@000b4T0bU50haA0mkk1Ooo
0mkk0mkK0mJj6?oo000Gool3oml3ool2oml6aQP3F^/36<<30202000302032643DXX3BVT3]IH3kgd2
ool3mih3ked3W=<3>LL324420003020<<JH5>LL3W?<3ic`3mkh3ool2oml3mkh3kgd3ic`3ia`3Q302
S543:FD3020300038@@6Nll2eYX3oml3ool3oml3aSP3H``26<<600038B@3:DD3S542g_/6ool3g_/3
g]/3e[X8ool3oml2ool3oml6aQP3F^/36<<20203000302032643DXX3BVT2]IH3kgd3ool3mih3ked3
W=<2>LL324430003020;<JH6>LL3W?<3ic`3mkh2ool3oml3mkh3kgd3ic`3ia`2Q303S543:FD30203
00038@@5Nll3eYX3oml3ool3oml3aSP2H``36<<600038B@3:DD2S543g_/6ool3g_/3g]/2e[X9ool2
oml3ool3oml6aQP3F^/26<<30203000302032643DXX2BVT3]IH3kgd3ool3mih3ked2W=<3>LL32443
0003020;<JH6>LL3W?<3ic`2mkh3ool3oml3mkh3kgd3ic`2ia`3Q303S543:FD3020300028@@6Nll3
eYX3oml3ool2oml3aSP3H``36<<600028B@3:DD3S543g_/6ool3g_/2g]/3e[X8ool3oml3ool3oml5
aQP3F^/36<<30203000302022643DXX3BVT3]IH3kgd3ool3mih2ked3W=<3>LL324430003020;<JH6
>LL2W?<3ic`3mkh3ool3oml3mkh2kgd3ic`3ia`3Q303S543:FD2020300038@@6Nll3eYX3oml2ool3
oml3aSP3H``36<<500038B@3:DD3S543g_/5ool3g_/3g]/3e[XHool001Ooo`?og`?oo`;og`K660=J
j`<H``<0808000<080<8H@=BRP=:J@>eUP?_O@;oo`?gWP?_G@>Ld`<ia`<8@@8000<080`aYPDia`>L
l`?W?0?g_P?oo`;og`?g_P?_O@?W?0?W70>4<0:<D@<YI@<080<000<Q10Ikc`;FVP?og`?oo`?og`?6
>0=S308H``H000<Q90<YA@><D@;Nn`Koo`?Nn`?Nf`?F^PSoo`?og`;oo`?og`K660=Jj`<H``8080<0
00<080<8H@=BRP=:J@:eUP?_O@?oo`?gWP?_G@>Ld`8ia`<8@@<000<080/aYPHia`>Ll`?W?0?g_P;o
o`?og`?g_P?_O@?W?0?W70:4<0><D@<YI@<080<000<Q10Ekc`?FVP?og`?oo`?og`?6>09S30<H``H0
00<Q90<YA@:<D@?Nn`Koo`?Nn`?Nf`;F^PWoo`;og`?oo`?og`K660=Jj`8H``<080<000<080<8H@=B
RP9:J@>eUP?_O@?oo`?gWP?_G@:Ld`<ia`<8@@<000<080/aYPHia`>Ll`?W?0;g_P?oo`?og`?g_P?_
O@?W?0;W70>4<0><D@<YI@<080<0008Q10Ikc`?FVP?og`?oo`;og`?6>0=S30<H``H0008Q90<YA@><
D@?Nn`Koo`?Nn`;Nf`?F^PSoo`?og`?oo`?og`G660=Jj`<H``<080<000<08088H@=BRP=:J@>eUP?_
O@?oo`?gWP;_G@>Ld`<ia`<8@@<000<080/aYPHia`:Ll`?W?0?g_P?oo`?og`?g_P;_O@?W?0?W70>4
<0><D@<YI@8080<000<Q10Ikc`?FVP?og`;oo`?og`?6>0=S30<H``D000<Q90<YA@><D@?Nn`Goo`?N
n`?Nf`?F^QSoo`005ooo0ooO0ooo0_oO1/HH0e[[0aS30`0P0P000`0P0`QQ0e::0dYY0kFF0nmm0_oo
0oNN0nmM0icC0cW70`Q10P000`0P336V1CW70icc0nLl0oNn0ooo0_oO0oNn0nmm0nLl0nLL0h@`0XaA
0bUU0`0P0`000b441W_?0]JJ0ooO0ooo0ooO0lHh0f<<0QS31P000b4T0bU50haA0]kk1_oo0mkk0mkK
0mJj2?oo0ooO0_oo0ooO1/HH0e[[0aS30P0P0`000`0P0`QQ0e::0dYY0[FF0nmm0ooo0oNN0nmM0icC
0SW70`Q10`000`0P2c6V1SW70icc0nLl0oNn0_oo0ooO0oNn0nmm0nLl0nLL0X@`0haA0bUU0`0P0`00
0b441G_?0mJJ0ooO0ooo0ooO0lHh0V<<0aS31P000b4T0bU50XaA0mkk1_oo0mkk0mkK0]Jj2Ooo0_oO
0ooo0ooO1/HH0e[[0QS30`0P0`000`0P0`QQ0e::0TYY0kFF0nmm0ooo0oNN0nmM0YcC0cW70`Q10`00
0`0P2c6V1SW70icc0nLl0_Nn0ooo0ooO0oNn0nmm0nLl0^LL0h@`0haA0bUU0`0P0`000R441W_?0mJJ
0ooO0ooo0_oO0lHh0f<<0aS31P000R4T0bU50haA0mkk1_oo0mkk0]kK0mJj2?oo0ooO0ooo0ooO1LHH
0e[[0aS30`0P0`000`0P0PQQ0e::0dYY0kFF0nmm0ooo0oNN0^mM0icC0cW70`Q10`000`0P2c6V1SW7
0Ycc0nLl0oNn0ooo0ooO0oNn0^mm0nLl0nLL0h@`0haA0bUU0P0P0`000b441W_?0mJJ0ooO0_oo0ooO
0lHh0f<<0aS31@000b4T0bU50haA0mkk1Ooo0mkk0mkK0mJj6?oo000Gool3oml3ool2oml6aQP3F^/3
6<<30202000302032643DXX3BVT3]IH3kgd2ool3mih3ked3W=<3>LL324420003020<<JH5>LL3W?<3
ic`3mkh3ool2oml3mkh3kgd3ic`3ia`3Q302S543:FD3020300038@@6Nll2eYX3oml3ool3oml3aSP3
H``26<<600038B@3:DD3S542g_/6ool3g_/3g]/3e[X8ool3oml2ool3oml6aQP3F^/36<<202030003
02032643DXX3BVT2]IH3kgd3ool3mih3ked3W=<2>LL324430003020;<JH6>LL3W?<3ic`3mkh2ool3
oml3mkh3kgd3ic`3ia`2Q303S543:FD3020300038@@5Nll3eYX3oml3ool3oml3aSP2H``36<<60003
8B@3:DD2S543g_/6ool3g_/3g]/2e[X9ool2oml3ool3oml6aQP3F^/26<<30203000302032643DXX2
BVT3]IH3kgd3ool3mih3ked2W=<3>LL324430003020;<JH6>LL3W?<3ic`2mkh3ool3oml3mkh3kgd3
ic`2ia`3Q303S543:FD3020300028@@6Nll3eYX3oml3ool2oml3aSP3H``36<<600028B@3:DD3S543
g_/6ool3g_/2g]/3e[X8ool3oml3ool3oml5aQP3F^/36<<30203000302022643DXX3BVT3]IH3kgd3
ool3mih2ked3W=<3>LL324430003020;<JH6>LL2W?<3ic`3mkh3ool3oml3mkh2kgd3ic`3ia`3Q303
S543:FD2020300038@@6Nll3eYX3oml2ool3oml3aSP3H``36<<500038B@3:DD3S543g_/5ool3g_/3
g]/3e[XHool001Ooo`?og`?oo`;og`K660=Jj`<H``<0808000<080<8H@=BRP=:J@>eUP?_O@;oo`?g
WP?_G@>Ld`<ia`<8@@8000<080`aYPDia`>Ll`?W?0?g_P?oo`;og`?g_P?_O@?W?0?W70>4<0:<D@<Y
I@<080<000<Q10Ikc`;FVP?og`?oo`?og`?6>0=S308H``H000<Q90<YA@><D@;Nn`Koo`?Nn`?Nf`?F
^PSoo`?og`;oo`?og`K660=Jj`<H``8080<000<080<8H@=BRP=:J@:eUP?_O@?oo`?gWP?_G@>Ld`8i
a`<8@@<000<080/aYPHia`>Ll`?W?0?g_P;oo`?og`?g_P?_O@?W?0?W70:4<0><D@<YI@<080<000<Q
10Ekc`?FVP?og`?oo`?og`?6>09S30<H``H000<Q90<YA@:<D@?Nn`Koo`?Nn`?Nf`;F^PWoo`;og`?o
o`?og`K660=Jj`8H``<080<000<080<8H@=BRP9:J@>eUP?_O@?oo`?gWP?_G@:Ld`<ia`<8@@<000<0
80/aYPHia`>Ll`?W?0;g_P?oo`?og`?g_P?_O@?W?0;W70>4<0><D@<YI@<080<0008Q10Ikc`?FVP?o
g`?oo`;og`?6>0=S30<H``H0008Q90<YA@><D@?Nn`Koo`?Nn`;Nf`?F^PSoo`?og`?oo`?og`G660=J
j`<H``<080<000<08088H@=BRP=:J@>eUP?_O@?oo`?gWP;_G@>Ld`<ia`<8@@<000<080/aYPHia`:L
l`?W?0?g_P?oo`?og`?g_P;_O@?W?0?W70>4<0><D@<YI@8080<000<Q10Ikc`?FVP?og`;oo`?og`?6
>0=S30<H``D000<Q90<YA@><D@?Nn`Goo`?Nn`?Nf`?F^QSoo`005ooo0ooO0ooo0_oO1/HH0e[[0aS3
0`0P0P000`0P0`QQ0e::0dYY0kFF0nmm0_oo0oNN0nmM0icC0cW70`Q10P000`0P336V1CW70icc0nLl
0oNn0ooo0_oO0oNn0nmm0nLl0nLL0h@`0XaA0bUU0`0P0`000b441W_?0]JJ0ooO0ooo0ooO0lHh0f<<
0QS31P000b4T0bU50haA0]kk1_oo0mkk0mkK0mJj2?oo0ooO0_oo0ooO1/HH0e[[0aS30P0P0`000`0P
0`QQ0e::0dYY0[FF0nmm0ooo0oNN0nmM0icC0SW70`Q10`000`0P2c6V1SW70icc0nLl0oNn0_oo0ooO
0oNn0nmm0nLl0nLL0X@`0haA0bUU0`0P0`000b441G_?0mJJ0ooO0ooo0ooO0lHh0V<<0aS31P000b4T
0bU50XaA0mkk1_oo0mkk0mkK0]Jj2Ooo0_oO0ooo0ooO1/HH0e[[0QS30`0P0`000`0P0`QQ0e::0TYY
0kFF0nmm0ooo0oNN0nmM0YcC0cW70`Q10`000`0P2c6V1SW70icc0nLl0_Nn0ooo0ooO0oNn0nmm0nLl
0^LL0h@`0haA0bUU0`0P0`000R441W_?0mJJ0ooO0ooo0_oO0lHh0f<<0aS31P000R4T0bU50haA0mkk
1_oo0mkk0]kK0mJj2?oo0ooO0ooo0ooO1LHH0e[[0aS30`0P0`000`0P0PQQ0e::0dYY0kFF0nmm0ooo
0oNN0^mM0icC0cW70`Q10`000`0P2c6V1SW70Ycc0nLl0oNn0ooo0ooO0oNn0^mm0nLl0nLL0h@`0haA
0bUU0P0P0`000b441W_?0mJJ0ooO0_oo0ooO0lHh0f<<0aS31@000b4T0bU50haA0mkk1Ooo0mkk0mkK
0mJj6?oo000Gool3oml3ool2oml6aQP3F^/36<<30202000302032643DXX3BVT3]IH3kgd2ool3mih3
ked3W=<3>LL324420003020<<JH5>LL3W?<3ic`3mkh3ool2oml3mkh3kgd3ic`3ia`3Q302S543:FD3
020300038@@6Nll2eYX3oml3ool3oml3aSP3H``26<<600038B@3:DD3S542g_/6ool3g_/3g]/3e[X8
ool3oml2ool3oml6aQP3F^/36<<20203000302032643DXX3BVT2]IH3kgd3ool3mih3ked3W=<2>LL3
24430003020;<JH6>LL3W?<3ic`3mkh2ool3oml3mkh3kgd3ic`3ia`2Q303S543:FD3020300038@@5
Nll3eYX3oml3ool3oml3aSP2H``36<<600038B@3:DD2S543g_/6ool3g_/3g]/2e[X9ool2oml3ool3
oml6aQP3F^/26<<30203000302032643DXX2BVT3]IH3kgd3ool3mih3ked2W=<3>LL324430003020;
<JH6>LL3W?<3ic`2mkh3ool3oml3mkh3kgd3ic`2ia`3Q303S543:FD3020300028@@6Nll3eYX3oml3
ool2oml3aSP3H``36<<600028B@3:DD3S543g_/6ool3g_/2g]/3e[X8ool3oml3ool3oml5aQP3F^/3
6<<30203000302022643DXX3BVT3]IH3kgd3ool3mih2ked3W=<3>LL324430003020;<JH6>LL2W?<3
ic`3mkh3ool3oml3mkh2kgd3ic`3ia`3Q303S543:FD2020300038@@6Nll3eYX3oml2ool3oml3aSP3
H``36<<500038B@3:DD3S543g_/5ool3g_/3g]/3e[XHool001Ooo`?og`?oo`;og`K660=Jj`<H``<0
808000<080<8H@=BRP=:J@>eUP?_O@;oo`?gWP?_G@>Ld`<ia`<8@@8000<080`aYPDia`>Ll`?W?0?g
_P?oo`;og`?g_P?_O@?W?0?W70>4<0:<D@<YI@<080<000<Q10Ikc`;FVP?og`?oo`?og`?6>0=S308H
``H000<Q90<YA@><D@;Nn`Koo`?Nn`?Nf`?F^PSoo`?og`;oo`?og`K660=Jj`<H``8080<000<080<8
H@=BRP=:J@:eUP?_O@?oo`?gWP?_G@>Ld`8ia`<8@@<000<080/aYPHia`>Ll`?W?0?g_P;oo`?og`?g
_P?_O@?W?0?W70:4<0><D@<YI@<080<000<Q10Ekc`?FVP?og`?oo`?og`?6>09S30<H``H000<Q90<Y
A@:<D@?Nn`Koo`?Nn`?Nf`;F^PWoo`;og`?oo`?og`K660=Jj`8H``<080<000<080<8H@=BRP9:J@>e
UP?_O@?oo`?gWP?_G@:Ld`<ia`<8@@<000<080/aYPHia`>Ll`?W?0;g_P?oo`?og`?g_P?_O@?W?0;W
70>4<0><D@<YI@<080<0008Q10Ikc`?FVP?og`?oo`;og`?6>0=S30<H``H0008Q90<YA@><D@?Nn`Ko
o`?Nn`;Nf`?F^PSoo`?og`?oo`?og`G660=Jj`<H``<080<000<08088H@=BRP=:J@>eUP?_O@?oo`?g
WP;_G@>Ld`<ia`<8@@<000<080/aYPHia`:Ll`?W?0?g_P?oo`?og`?g_P;_O@?W?0?W70>4<0><D@<Y
I@8080<000<Q10Ikc`?FVP?og`;oo`?og`?6>0=S30<H``D000<Q90<YA@><D@?Nn`Goo`?Nn`?Nf`?F
^QSoo`005ooo0ooO0ooo0_oO1/HH0e[[0aS30`0P0P000`0P0`QQ0e::0dYY0kFF0nmm0_oo0oNN0nmM
0icC0cW70`Q10P000`0P336V1CW70icc0nLl0oNn0ooo0_oO0oNn0nmm0nLl0nLL0h@`0XaA0bUU0`0P
0`000b441W_?0]JJ0ooO0ooo0ooO0lHh0f<<0QS31P000b4T0bU50haA0]kk1_oo0mkk0mkK0mJj2?oo
0ooO0_oo0ooO1/HH0e[[0aS30P0P0`000`0P0`QQ0e::0dYY0[FF0nmm0ooo0oNN0nmM0icC0SW70`Q1
0`000`0P2c6V1SW70icc0nLl0oNn0_oo0ooO0oNn0nmm0nLl0nLL0X@`0haA0bUU0`0P0`000b441G_?
0mJJ0ooO0ooo0ooO0lHh0V<<0aS31P000b4T0bU50XaA0mkk1_oo0mkk0mkK0]Jj2Ooo0_oO0ooo0ooO
1/HH0e[[0QS30`0P0`000`0P0`QQ0e::0TYY0kFF0nmm0ooo0oNN0nmM0YcC0cW70`Q10`000`0P2c6V
1SW70icc0nLl0_Nn0ooo0ooO0oNn0nmm0nLl0^LL0h@`0haA0bUU0`0P0`000R441W_?0mJJ0ooO0ooo
0_oO0lHh0f<<0aS31P000R4T0bU50haA0mkk1_oo0mkk0]kK0mJj2?oo0ooO0ooo0ooO1LHH0e[[0aS3
0`0P0`000`0P0PQQ0e::0dYY0kFF0nmm0ooo0oNN0^mM0icC0cW70`Q10`000`0P2c6V1SW70Ycc0nLl
0oNn0ooo0ooO0oNn0^mm0nLl0nLL0h@`0haA0bUU0P0P0`000b441W_?0mJJ0ooO0_oo0ooO0lHh0f<<
0aS31@000b4T0bU50haA0mkk1Ooo0mkk0mkK0mJj6?oo000Gool3oml3ool2oml6aQP3F^/36<<30202
000302032643DXX3BVT3]IH3kgd2ool3mih3ked3W=<3>LL324420003020<<JH5>LL3W?<3ic`3mkh3
ool2oml3mkh3kgd3ic`3ia`3Q302S543:FD3020300038@@6Nll2eYX3oml3ool3oml3aSP3H``26<<6
00038B@3:DD3S542g_/6ool3g_/3g]/3e[X8ool3oml2ool3oml6aQP3F^/36<<20203000302032643
DXX3BVT2]IH3kgd3ool3mih3ked3W=<2>LL324430003020;<JH6>LL3W?<3ic`3mkh2ool3oml3mkh3
kgd3ic`3ia`2Q303S543:FD3020300038@@5Nll3eYX3oml3ool3oml3aSP2H``36<<600038B@3:DD2
S543g_/6ool3g_/3g]/2e[X9ool2oml3ool3oml6aQP3F^/26<<30203000302032643DXX2BVT3]IH3
kgd3ool3mih3ked2W=<3>LL324430003020;<JH6>LL3W?<3ic`2mkh3ool3oml3mkh3kgd3ic`2ia`3
Q303S543:FD3020300028@@6Nll3eYX3oml3ool2oml3aSP3H``36<<600028B@3:DD3S543g_/6ool3
g_/2g]/3e[X8ool3oml3ool3oml5aQP3F^/36<<30203000302022643DXX3BVT3]IH3kgd3ool3mih2
ked3W=<3>LL324430003020;<JH6>LL2W?<3ic`3mkh3ool3oml3mkh2kgd3ic`3ia`3Q303S543:FD2
020300038@@6Nll3eYX3oml2ool3oml3aSP3H``36<<500038B@3:DD3S543g_/5ool3g_/3g]/3e[XH
ool001Ooo`=kc`<Q908080<000<080<8H@=BZPEBRP>e]P?_O@?oo`?og`?gWP?_G@:Ld`<ia`<8@@<0
00<@XP=S;0;6>0?g_P?oo`?_G@?W?0?Nn`;Nf`KF^P?FVP?>N@=[K@8Hh`<000<080Tia`FLl`?W?0?o
o`?og`?gWP>U=092:0<8H@H000<8@@=:J@:eUP?_O@Koo`?FVP=cSP8Q10<@PPH000<Q90<YA@Soo`=k
c`8Q90<080<000<080<8H@=BZPEBRP>e]P?_O@?oo`?og`;gWP?_G@>Ld`<ia`<8@@<0008@XP=S;0?6
>0?g_P?oo`?_G@?W?0;Nn`?Nf`KF^P?FVP?>N@9[K@<Hh`<000<080Pia`JLl`?W?0?oo`?og`;gWP>U
=0=2:0<8H@H000<8@@9:J@>eUP?_O@Koo`?FVP9cSP<Q10<@PPH000<Q908YA@Woo`9kc`<Q90<080<0
00<080<8H@9BZPIBRP>e]P?_O@?oo`;og`?gWP?_G@>Ld`<ia`<8@@8000<@XP=S;0?6>0?g_P?oo`;_
G@?W?0?Nn`?Nf`KF^P?FVP;>N@=[K@<Hh`<000<080Pia`JLl`?W?0?oo`;og`?gWP>U=0=2:0<8H@D0
00<8@@=:J@>eUP?_O@Goo`?FVP=cSP<Q10<@PPH0008Q90<YA@Soo`=kc`<Q90<080<0008080<8H@=B
ZPIBRP>e]P;_O@?oo`?og`?gWP?_G@>Ld`<ia`88@@<000<@XP=S;0?6>0?g_P;oo`?_G@?W?0?Nn`?N
f`GF^P?FVP?>N@=[K@<Hh`<0008080Tia`JLl`;W?0?oo`?og`?gWP>U=0=2:0<8H@D000<8@@=:J@>e
UP?_O@Goo`?FVP=cSP<Q10<@PPD000<Q90<YAASoo`005ooo0g_?0b4T0P0P0`000`0P0`QQ0e:Z1E::
0kFf0nmm0ooo0ooO0oNN0nmM0YcC0cW70`Q10`000a2R0f</0/Hh0oNn0ooo0nmM0nLl0mkk0]kK1]Jj
0mJJ0lii0f]]0QSS0`000`0P2CW71Icc0nLl0ooo0ooO0oNN0jDd0T8X0`QQ1P000`Q10dYY0[FF0nmm
1_oo0mJJ0g>>0R440a221P000b4T0bU52?oo0g_?0R4T0`0P0`000`0P0`QQ0e:Z1E::0kFf0nmm0ooo
0ooO0_NN0nmM0icC0cW70`Q10`000Q2R0f</0lHh0oNn0ooo0nmM0nLl0]kk0mkK1]Jj0mJJ0lii0V]]
0aSS0`000`0P23W71Ycc0nLl0ooo0ooO0_NN0jDd0d8X0`QQ1P000`Q10TYY0kFF0nmm1_oo0mJJ0W>>
0b440a221P000b4T0RU52Ooo0W_?0b4T0`0P0`000`0P0`QQ0U:Z1U::0kFf0nmm0ooo0_oO0oNN0nmM
0icC0cW70`Q10P000a2R0f</0lHh0oNn0ooo0^mM0nLl0mkk0mkK1]Jj0mJJ0/ii0f]]0aSS0`000`0P
23W71Ycc0nLl0ooo0_oO0oNN0jDd0d8X0`QQ1@000`Q10dYY0kFF0nmm1Ooo0mJJ0g>>0b440a221P00
0R4T0bU52?oo0g_?0b4T0`0P0`000P0P0`QQ0e:Z1U::0kFf0^mm0ooo0ooO0oNN0nmM0icC0cW70PQ1
0`000a2R0f</0lHh0oNn0_oo0nmM0nLl0mkk0mkK1MJj0mJJ0lii0f]]0aSS0`000P0P2CW71Ycc0^Ll
0ooo0ooO0oNN0jDd0d8X0`QQ1@000`Q10dYY0kFF0nmm1Ooo0mJJ0g>>0b440a221@000b4T0bU56?oo
000Gool3Nll38B@20203000302032643DZX5DXX3]KH3kgd3ool3oml3mih3ked2W=<3>LL324430003
4:83Hb`2aSP3mkh3ool3ked3ic`3g_/2g]/6e[X3eYX3cWT3Jfd26><300030209>LL5W?<3ic`3ool3
oml3mih3YC@2@RP3264600032443BVT2]IH3kgd6ool3eYX3Lhh28@@3488600038B@3:DD8ool3Nll2
8B@30203000302032643DZX5DXX3]KH3kgd3ool3oml2mih3ked3W=<3>LL3244300024:83Hb`3aSP3
mkh3ool3ked3ic`2g_/3g]/6e[X3eYX3cWT2Jfd36><300030208>LL6W?<3ic`3ool3oml2mih3YC@3
@RP3264600032442BVT3]IH3kgd6ool3eYX2Lhh38@@3488600038B@2:DD9ool2Nll38B@302030003
02032642DZX6DXX3]KH3kgd3ool2oml3mih3ked3W=<3>LL3244200034:83Hb`3aSP3mkh3ool2ked3
ic`3g_/3g]/6e[X3eYX2cWT3Jfd36><300030208>LL6W?<3ic`3ool2oml3mih3YC@3@RP326450003
2443BVT3]IH3kgd5ool3eYX3Lhh38@@3488600028B@3:DD8ool3Nll38B@30203000202032643DZX6
DXX3]KH2kgd3ool3oml3mih3ked3W=<3>LL2244300034:83Hb`3aSP3mkh2ool3ked3ic`3g_/3g]/5
e[X3eYX3cWT3Jfd36><300020209>LL6W?<2ic`3ool3oml3mih3YC@3@RP3264500032443BVT3]IH3
kgd5ool3eYX3Lhh38@@3488500038B@3:DDHool001Ooo`=kc`<Q908080<000<080<8H@=BZPEBRP>e
]P?_O@?oo`?og`?gWP?_G@:Ld`<ia`<8@@<000<@XP=S;0;6>0?g_P?oo`?_G@?W?0?Nn`;Nf`KF^P?F
VP?>N@=[K@8Hh`<000<080Tia`FLl`?W?0?oo`?og`?gWP>U=092:0<8H@H000<8@@=:J@:eUP?_O@Ko
o`?FVP=cSP8Q10<@PPH000<Q90<YA@Soo`=kc`8Q90<080<000<080<8H@=BZPEBRP>e]P?_O@?oo`?o
g`;gWP?_G@>Ld`<ia`<8@@<0008@XP=S;0?6>0?g_P?oo`?_G@?W?0;Nn`?Nf`KF^P?FVP?>N@9[K@<H
h`<000<080Pia`JLl`?W?0?oo`?og`;gWP>U=0=2:0<8H@H000<8@@9:J@>eUP?_O@Koo`?FVP9cSP<Q
10<@PPH000<Q908YA@Woo`9kc`<Q90<080<000<080<8H@9BZPIBRP>e]P?_O@?oo`;og`?gWP?_G@>L
d`<ia`<8@@8000<@XP=S;0?6>0?g_P?oo`;_G@?W?0?Nn`?Nf`KF^P?FVP;>N@=[K@<Hh`<000<080Pi
a`JLl`?W?0?oo`;og`?gWP>U=0=2:0<8H@D000<8@@=:J@>eUP?_O@Goo`?FVP=cSP<Q10<@PPH0008Q
90<YA@Soo`=kc`<Q90<080<0008080<8H@=BZPIBRP>e]P;_O@?oo`?og`?gWP?_G@>Ld`<ia`88@@<0
00<@XP=S;0?6>0?g_P;oo`?_G@?W?0?Nn`?Nf`GF^P?FVP?>N@=[K@<Hh`<0008080Tia`JLl`;W?0?o
o`?og`?gWP>U=0=2:0<8H@D000<8@@=:J@>eUP?_O@Goo`?FVP=cSP<Q10<@PPD000<Q90<YAASoo`00
5ooo0g_?0b4T0P0P0`000`0P0`QQ0e:Z1E::0kFf0nmm0ooo0ooO0oNN0nmM0YcC0cW70`Q10`000a2R
0f</0/Hh0oNn0ooo0nmM0nLl0mkk0]kK1]Jj0mJJ0lii0f]]0QSS0`000`0P2CW71Icc0nLl0ooo0ooO
0oNN0jDd0T8X0`QQ1P000`Q10dYY0[FF0nmm1_oo0mJJ0g>>0R440a221P000b4T0bU52?oo0g_?0R4T
0`0P0`000`0P0`QQ0e:Z1E::0kFf0nmm0ooo0ooO0_NN0nmM0icC0cW70`Q10`000Q2R0f</0lHh0oNn
0ooo0nmM0nLl0]kk0mkK1]Jj0mJJ0lii0V]]0aSS0`000`0P23W71Ycc0nLl0ooo0ooO0_NN0jDd0d8X
0`QQ1P000`Q10TYY0kFF0nmm1_oo0mJJ0W>>0b440a221P000b4T0RU52Ooo0W_?0b4T0`0P0`000`0P
0`QQ0U:Z1U::0kFf0nmm0ooo0_oO0oNN0nmM0icC0cW70`Q10P000a2R0f</0lHh0oNn0ooo0^mM0nLl
0mkk0mkK1]Jj0mJJ0/ii0f]]0aSS0`000`0P23W71Ycc0nLl0ooo0_oO0oNN0jDd0d8X0`QQ1@000`Q1
0dYY0kFF0nmm1Ooo0mJJ0g>>0b440a221P000R4T0bU52?oo0g_?0b4T0`0P0`000P0P0`QQ0e:Z1U::
0kFf0^mm0ooo0ooO0oNN0nmM0icC0cW70PQ10`000a2R0f</0lHh0oNn0_oo0nmM0nLl0mkk0mkK1MJj
0mJJ0lii0f]]0aSS0`000P0P2CW71Ycc0^Ll0ooo0ooO0oNN0jDd0d8X0`QQ1@000`Q10dYY0kFF0nmm
1Ooo0mJJ0g>>0b440a221@000b4T0bU56?oo000Gool3Nll38B@20203000302032643DZX5DXX3]KH3
kgd3ool3oml3mih3ked2W=<3>LL3244300034:83Hb`2aSP3mkh3ool3ked3ic`3g_/2g]/6e[X3eYX3
cWT3Jfd26><300030209>LL5W?<3ic`3ool3oml3mih3YC@2@RP3264600032443BVT2]IH3kgd6ool3
eYX3Lhh28@@3488600038B@3:DD8ool3Nll28B@30203000302032643DZX5DXX3]KH3kgd3ool3oml2
mih3ked3W=<3>LL3244300024:83Hb`3aSP3mkh3ool3ked3ic`2g_/3g]/6e[X3eYX3cWT2Jfd36><3
00030208>LL6W?<3ic`3ool3oml2mih3YC@3@RP3264600032442BVT3]IH3kgd6ool3eYX2Lhh38@@3
488600038B@2:DD9ool2Nll38B@30203000302032642DZX6DXX3]KH3kgd3ool2oml3mih3ked3W=<3
>LL3244200034:83Hb`3aSP3mkh3ool2ked3ic`3g_/3g]/6e[X3eYX2cWT3Jfd36><300030208>LL6
W?<3ic`3ool2oml3mih3YC@3@RP3264500032443BVT3]IH3kgd5ool3eYX3Lhh38@@3488600028B@3
:DD8ool3Nll38B@30203000202032643DZX6DXX3]KH2kgd3ool3oml3mih3ked3W=<3>LL224430003
4:83Hb`3aSP3mkh2ool3ked3ic`3g_/3g]/5e[X3eYX3cWT3Jfd36><300020209>LL6W?<2ic`3ool3
oml3mih3YC@3@RP3264500032443BVT3]IH3kgd5ool3eYX3Lhh38@@3488500038B@3:DDHool001Oo
o`=kc`<Q908080<000<080<8H@=BZPEBRP>e]P?_O@?oo`?og`?gWP?_G@:Ld`<ia`<8@@<000<@XP=S
;0;6>0?g_P?oo`?_G@?W?0?Nn`;Nf`KF^P?FVP?>N@=[K@8Hh`<000<080Tia`FLl`?W?0?oo`?og`?g
WP>U=092:0<8H@H000<8@@=:J@:eUP?_O@Koo`?FVP=cSP8Q10<@PPH000<Q90<YA@Soo`=kc`8Q90<0
80<000<080<8H@=BZPEBRP>e]P?_O@?oo`?og`;gWP?_G@>Ld`<ia`<8@@<0008@XP=S;0?6>0?g_P?o
o`?_G@?W?0;Nn`?Nf`KF^P?FVP?>N@9[K@<Hh`<000<080Pia`JLl`?W?0?oo`?og`;gWP>U=0=2:0<8
H@H000<8@@9:J@>eUP?_O@Koo`?FVP9cSP<Q10<@PPH000<Q908YA@Woo`9kc`<Q90<080<000<080<8
H@9BZPIBRP>e]P?_O@?oo`;og`?gWP?_G@>Ld`<ia`<8@@8000<@XP=S;0?6>0?g_P?oo`;_G@?W?0?N
n`?Nf`KF^P?FVP;>N@=[K@<Hh`<000<080Pia`JLl`?W?0?oo`;og`?gWP>U=0=2:0<8H@D000<8@@=:
J@>eUP?_O@Goo`?FVP=cSP<Q10<@PPH0008Q90<YA@Soo`=kc`<Q90<080<0008080<8H@=BZPIBRP>e
]P;_O@?oo`?og`?gWP?_G@>Ld`<ia`88@@<000<@XP=S;0?6>0?g_P;oo`?_G@?W?0?Nn`?Nf`GF^P?F
VP?>N@=[K@<Hh`<0008080Tia`JLl`;W?0?oo`?og`?gWP>U=0=2:0<8H@D000<8@@=:J@>eUP?_O@Go
o`?FVP=cSP<Q10<@PPD000<Q90<YAASoo`005ooo0g_?0b4T0P0P0`000`0P0`QQ0e:Z1E::0kFf0nmm
0ooo0ooO0oNN0nmM0YcC0cW70`Q10`000a2R0f</0/Hh0oNn0ooo0nmM0nLl0mkk0]kK1]Jj0mJJ0lii
0f]]0QSS0`000`0P2CW71Icc0nLl0ooo0ooO0oNN0jDd0T8X0`QQ1P000`Q10dYY0[FF0nmm1_oo0mJJ
0g>>0R440a221P000b4T0bU52?oo0g_?0R4T0`0P0`000`0P0`QQ0e:Z1E::0kFf0nmm0ooo0ooO0_NN
0nmM0icC0cW70`Q10`000Q2R0f</0lHh0oNn0ooo0nmM0nLl0]kk0mkK1]Jj0mJJ0lii0V]]0aSS0`00
0`0P23W71Ycc0nLl0ooo0ooO0_NN0jDd0d8X0`QQ1P000`Q10TYY0kFF0nmm1_oo0mJJ0W>>0b440a22
1P000b4T0RU52Ooo0W_?0b4T0`0P0`000`0P0`QQ0U:Z1U::0kFf0nmm0ooo0_oO0oNN0nmM0icC0cW7
0`Q10P000a2R0f</0lHh0oNn0ooo0^mM0nLl0mkk0mkK1]Jj0mJJ0/ii0f]]0aSS0`000`0P23W71Ycc
0nLl0ooo0_oO0oNN0jDd0d8X0`QQ1@000`Q10dYY0kFF0nmm1Ooo0mJJ0g>>0b440a221P000R4T0bU5
2?oo0g_?0b4T0`0P0`000P0P0`QQ0e:Z1U::0kFf0^mm0ooo0ooO0oNN0nmM0icC0cW70PQ10`000a2R
0f</0lHh0oNn0_oo0nmM0nLl0mkk0mkK1MJj0mJJ0lii0f]]0aSS0`000P0P2CW71Ycc0^Ll0ooo0ooO
0oNN0jDd0d8X0`QQ1@000`Q10dYY0kFF0nmm1Ooo0mJJ0g>>0b440a221@000b4T0bU56?oo000Gool3
Nll38B@20203000302032643DZX5DXX3]KH3kgd3ool3oml3mih3ked2W=<3>LL3244300034:83Hb`2
aSP3mkh3ool3ked3ic`3g_/2g]/6e[X3eYX3cWT3Jfd26><300030209>LL5W?<3ic`3ool3oml3mih3
YC@2@RP3264600032443BVT2]IH3kgd6ool3eYX3Lhh28@@3488600038B@3:DD8ool3Nll28B@30203
000302032643DZX5DXX3]KH3kgd3ool3oml2mih3ked3W=<3>LL3244300024:83Hb`3aSP3mkh3ool3
ked3ic`2g_/3g]/6e[X3eYX3cWT2Jfd36><300030208>LL6W?<3ic`3ool3oml2mih3YC@3@RP32646
00032442BVT3]IH3kgd6ool3eYX2Lhh38@@3488600038B@2:DD9ool2Nll38B@30203000302032642
DZX6DXX3]KH3kgd3ool2oml3mih3ked3W=<3>LL3244200034:83Hb`3aSP3mkh3ool2ked3ic`3g_/3
g]/6e[X3eYX2cWT3Jfd36><300030208>LL6W?<3ic`3ool2oml3mih3YC@3@RP3264500032443BVT3
]IH3kgd5ool3eYX3Lhh38@@3488600028B@3:DD8ool3Nll38B@30203000202032643DZX6DXX3]KH2
kgd3ool3oml3mih3ked3W=<3>LL2244300034:83Hb`3aSP3mkh2ool3ked3ic`3g_/3g]/5e[X3eYX3
cWT3Jfd36><300020209>LL6W?<2ic`3ool3oml3mih3YC@3@RP3264500032443BVT3]IH3kgd5ool3
eYX3Lhh38@@3488500038B@3:DDHool001Ooo`=kc`<Q908080<000<080<8H@=BZPEBRP>e]P?_O@?o
o`?og`?gWP?_G@:Ld`<ia`<8@@<000<@XP=S;0;6>0?g_P?oo`?_G@?W?0?Nn`;Nf`KF^P?FVP?>N@=[
K@8Hh`<000<080Tia`FLl`?W?0?oo`?og`?gWP>U=092:0<8H@H000<8@@=:J@:eUP?_O@Koo`?FVP=c
SP8Q10<@PPH000<Q90<YA@Soo`=kc`8Q90<080<000<080<8H@=BZPEBRP>e]P?_O@?oo`?og`;gWP?_
G@>Ld`<ia`<8@@<0008@XP=S;0?6>0?g_P?oo`?_G@?W?0;Nn`?Nf`KF^P?FVP?>N@9[K@<Hh`<000<0
80Pia`JLl`?W?0?oo`?og`;gWP>U=0=2:0<8H@H000<8@@9:J@>eUP?_O@Koo`?FVP9cSP<Q10<@PPH0
00<Q908YA@Woo`9kc`<Q90<080<000<080<8H@9BZPIBRP>e]P?_O@?oo`;og`?gWP?_G@>Ld`<ia`<8
@@8000<@XP=S;0?6>0?g_P?oo`;_G@?W?0?Nn`?Nf`KF^P?FVP;>N@=[K@<Hh`<000<080Pia`JLl`?W
?0?oo`;og`?gWP>U=0=2:0<8H@D000<8@@=:J@>eUP?_O@Goo`?FVP=cSP<Q10<@PPH0008Q90<YA@So
o`=kc`<Q90<080<0008080<8H@=BZPIBRP>e]P;_O@?oo`?og`?gWP?_G@>Ld`<ia`88@@<000<@XP=S
;0?6>0?g_P;oo`?_G@?W?0?Nn`?Nf`GF^P?FVP?>N@=[K@<Hh`<0008080Tia`JLl`;W?0?oo`?og`?g
WP>U=0=2:0<8H@D000<8@@=:J@>eUP?_O@Goo`?FVP=cSP<Q10<@PPD000<Q90<YAASoo`005ooo0g_?
0b4T0P0P0`000`0P0`QQ0e:Z1E::0kFf0nmm0ooo0ooO0oNN0nmM0YcC0cW70`Q10`000a2R0f</0/Hh
0oNn0ooo0nmM0nLl0mkk0]kK1]Jj0mJJ0lii0f]]0QSS0`000`0P2CW71Icc0nLl0ooo0ooO0oNN0jDd
0T8X0`QQ1P000`Q10dYY0[FF0nmm1_oo0mJJ0g>>0R440a221P000b4T0bU52?oo0g_?0R4T0`0P0`00
0`0P0`QQ0e:Z1E::0kFf0nmm0ooo0ooO0_NN0nmM0icC0cW70`Q10`000Q2R0f</0lHh0oNn0ooo0nmM
0nLl0]kk0mkK1]Jj0mJJ0lii0V]]0aSS0`000`0P23W71Ycc0nLl0ooo0ooO0_NN0jDd0d8X0`QQ1P00
0`Q10TYY0kFF0nmm1_oo0mJJ0W>>0b440a221P000b4T0RU52Ooo0W_?0b4T0`0P0`000`0P0`QQ0U:Z
1U::0kFf0nmm0ooo0_oO0oNN0nmM0icC0cW70`Q10P000a2R0f</0lHh0oNn0ooo0^mM0nLl0mkk0mkK
1]Jj0mJJ0/ii0f]]0aSS0`000`0P23W71Ycc0nLl0ooo0_oO0oNN0jDd0d8X0`QQ1@000`Q10dYY0kFF
0nmm1Ooo0mJJ0g>>0b440a221P000R4T0bU52?oo0g_?0b4T0`0P0`000P0P0`QQ0e:Z1U::0kFf0^mm
0ooo0ooO0oNN0nmM0icC0cW70PQ10`000a2R0f</0lHh0oNn0_oo0nmM0nLl0mkk0mkK1MJj0mJJ0lii
0f]]0aSS0`000P0P2CW71Ycc0^Ll0ooo0ooO0oNN0jDd0d8X0`QQ1@000`Q10dYY0kFF0nmm1Ooo0mJJ
0g>>0b440a221@000b4T0bU56?oo000Gool3Nll38B@20203000302032643DZX5DXX3]KH3kgd3ool3
oml3mih3ked2W=<3>LL3244300034:83Hb`2aSP3mkh3ool3ked3ic`3g_/2g]/6e[X3eYX3cWT3Jfd2
6><300030209>LL5W?<3ic`3ool3oml3mih3YC@2@RP3264600032443BVT2]IH3kgd6ool3eYX3Lhh2
8@@3488600038B@3:DD8ool3Nll28B@30203000302032643DZX5DXX3]KH3kgd3ool3oml2mih3ked3
W=<3>LL3244300024:83Hb`3aSP3mkh3ool3ked3ic`2g_/3g]/6e[X3eYX3cWT2Jfd36><300030208
>LL6W?<3ic`3ool3oml2mih3YC@3@RP3264600032442BVT3]IH3kgd6ool3eYX2Lhh38@@348860003
8B@2:DD9ool2Nll38B@30203000302032642DZX6DXX3]KH3kgd3ool2oml3mih3ked3W=<3>LL32442
00034:83Hb`3aSP3mkh3ool2ked3ic`3g_/3g]/6e[X3eYX2cWT3Jfd36><300030208>LL6W?<3ic`3
ool2oml3mih3YC@3@RP3264500032443BVT3]IH3kgd5ool3eYX3Lhh38@@3488600028B@3:DD8ool3
Nll38B@30203000202032643DZX6DXX3]KH2kgd3ool3oml3mih3ked3W=<3>LL2244300034:83Hb`3
aSP3mkh2ool3ked3ic`3g_/3g]/5e[X3eYX3cWT3Jfd36><300020209>LL6W?<2ic`3ool3oml3mih3
YC@3@RP3264500032443BVT3]IH3kgd5ool3eYX3Lhh38@@3488500038B@3:DDHool001Ooo`<YA@<Y
I@PaQP>D/P?W70?gWP;oo`?_O@>U50>U=0=220<ia`<YI@8080<000<080<8H@<@XP=S;0;6>0?g_PKo
o`?>N@=[C@8Hh`H000<Q90>440?F^P;og`?oo`?og`?660=Jj`<H``D000<8@@<@PP<@XP=[C@=S;0;6
>0?g_P?oo`?og`?>F@ES;0<Hh`H000<080Q220>U=0?_G@?og`_oo`<YA@8YI@TaQP>D/P?W70;gWP?o
o`?_O@>U50>U=0=2208ia`<YI@<080<000<080<8H@8@XP=S;0?6>0?g_PKoo`?>N@9[C@<Hh`H000<Q
90>440;F^P?og`?oo`?og`?660=Jj`8H``H000<8@@<@PP<@XP9[C@=S;0?6>0?g_P?oo`?og`?>F@ES
;0<Hh`H000<080Q220>U=0?_G@?og`_oo`8YA@<YI@TaQP>D/P;W70?gWP?oo`?_O@>U50>U=09220<i
a`<YI@<080<000<08088H@<@XP=S;0?6>0?g_PGoo`?>N@=[C@<Hh`H000<Q90:440?F^P?og`?oo`?o
g`?6609Jj`<H``H000<8@@<@PP8@XP=[C@=S;0?6>0?g_P?oo`;og`?>F@IS;0<Hh`D000<080U220>U
=0?_G@;og`_oo`<YA@<YI@PaQP>D/P?W70?gWP?oo`?_O@:U50>U=0=220<ia`<YI@<080<0008080<8
H@<@XP=S;0?6>0?g_PGoo`?>N@=[C@<Hh`D000<Q90>440?F^P?og`?oo`;og`?660=Jj`<H``H00088
@@<@PP<@XP=[C@=S;0?6>0?g_P;oo`?og`?>F@IS;0<Hh`D000<080U220:U=0?_G@?oga_oo`005ooo
0bU50bUU23660iBb0nLL0oNN0_oo0nmm0jDD0jDd0d880cW70bUU0P0P0`000`0P0`QQ0a2R0f</0/Hh
0oNn1_oo0lii0f]=0QSS1P000b4T0h@@0mJj0_oO0ooo0ooO0lHH0e[[0aS31@000`Q10a220a2R0f]=
0f</0/Hh0oNn0ooo0ooO0liI1F</0aSS1P000`0P24880jDd0nmM0ooO2ooo0bU50RUU2C660iBb0nLL
0_NN0ooo0nmm0jDD0jDd0d880SW70bUU0`0P0`000`0P0`QQ0Q2R0f</0lHh0oNn1_oo0lii0V]=0aSS
1P000b4T0h@@0]Jj0ooO0ooo0ooO0lHH0e[[0QS31P000`Q10a220a2R0V]=0f</0lHh0oNn0ooo0ooO
0liI1F</0aSS1P000`0P24880jDd0nmM0ooO2ooo0RU50bUU2C660iBb0^LL0oNN0ooo0nmm0jDD0jDd
0T880cW70bUU0`0P0`000`0P0PQQ0a2R0f</0lHh0oNn1Ooo0lii0f]=0aSS1P000b4T0X@@0mJj0ooO
0ooo0ooO0lHH0U[[0aS31P000`Q10a220Q2R0f]=0f</0lHh0oNn0ooo0_oO0liI1V</0aSS1@000`0P
2D880jDd0nmM0_oO2ooo0bU50bUU23660iBb0nLL0oNN0ooo0nmm0ZDD0jDd0d880cW70bUU0`0P0`00
0P0P0`QQ0a2R0f</0lHh0oNn1Ooo0lii0f]=0aSS1@000b4T0h@@0mJj0ooO0ooo0_oO0lHH0e[[0aS3
1P000PQ10a220a2R0f]=0f</0lHh0oNn0_oo0ooO0liI1V</0aSS1@000`0P2D880ZDd0nmM0ooO6ooo
000Gool3:DD3:FD8<HH3U;83ia`3mih2ool3kgd3YA@3YC@3@PP3>LL3:FD202030003020326434:83
Hb`2aSP3mkh6ool3cWT3Jdd26><600038B@3Q103e[X2oml3ool3oml3aQP3F^/36<<5000324434883
4:83Jdd3Hb`2aSP3mkh3ool3oml3cUT5Hb`36><600030208@PP3YC@3ked3oml;ool3:DD2:FD9<HH3
U;83ia`2mih3ool3kgd3YA@3YC@3@PP2>LL3:FD302030003020326424:83Hb`3aSP3mkh6ool3cWT2
Jdd36><600038B@3Q102e[X3oml3ool3oml3aQP3F^/26<<60003244348834:82Jdd3Hb`3aSP3mkh3
ool3oml3cUT5Hb`36><600030208@PP3YC@3ked3oml;ool2:DD3:FD9<HH3U;82ia`3mih3ool3kgd3
YA@3YC@2@PP3>LL3:FD302030003020226434:83Hb`3aSP3mkh5ool3cWT3Jdd36><600038B@2Q103
e[X3oml3ool3oml3aQP2F^/36<<60003244348824:83Jdd3Hb`3aSP3mkh3ool2oml3cUT6Hb`36><5
00030209@PP3YC@3ked2oml;ool3:DD3:FD8<HH3U;83ia`3mih3ool3kgd2YA@3YC@3@PP3>LL3:FD3
02030002020326434:83Hb`3aSP3mkh5ool3cWT3Jdd36><500038B@3Q103e[X3oml3ool2oml3aQP3
F^/36<<60002244348834:83Jdd3Hb`3aSP3mkh2ool3oml3cUT6Hb`36><500030209@PP2YC@3ked3
omlKool001Ooo`<YA@<YI@PaQP>D/P?W70?gWP;oo`?_O@>U50>U=0=220<ia`<YI@8080<000<080<8
H@<@XP=S;0;6>0?g_PKoo`?>N@=[C@8Hh`H000<Q90>440?F^P;og`?oo`?og`?660=Jj`<H``D000<8
@@<@PP<@XP=[C@=S;0;6>0?g_P?oo`?og`?>F@ES;0<Hh`H000<080Q220>U=0?_G@?og`_oo`<YA@8Y
I@TaQP>D/P?W70;gWP?oo`?_O@>U50>U=0=2208ia`<YI@<080<000<080<8H@8@XP=S;0?6>0?g_PKo
o`?>N@9[C@<Hh`H000<Q90>440;F^P?og`?oo`?og`?660=Jj`8H``H000<8@@<@PP<@XP9[C@=S;0?6
>0?g_P?oo`?og`?>F@ES;0<Hh`H000<080Q220>U=0?_G@?og`_oo`8YA@<YI@TaQP>D/P;W70?gWP?o
o`?_O@>U50>U=09220<ia`<YI@<080<000<08088H@<@XP=S;0?6>0?g_PGoo`?>N@=[C@<Hh`H000<Q
90:440?F^P?og`?oo`?og`?6609Jj`<H``H000<8@@<@PP8@XP=[C@=S;0?6>0?g_P?oo`;og`?>F@IS
;0<Hh`D000<080U220>U=0?_G@;og`_oo`<YA@<YI@PaQP>D/P?W70?gWP?oo`?_O@:U50>U=0=220<i
a`<YI@<080<0008080<8H@<@XP=S;0?6>0?g_PGoo`?>N@=[C@<Hh`D000<Q90>440?F^P?og`?oo`;o
g`?660=Jj`<H``H00088@@<@PP<@XP=[C@=S;0?6>0?g_P;oo`?og`?>F@IS;0<Hh`D000<080U220:U
=0?_G@?oga_oo`005ooo0bU50bUU23660iBb0nLL0oNN0_oo0nmm0jDD0jDd0d880cW70bUU0P0P0`00
0`0P0`QQ0a2R0f</0/Hh0oNn1_oo0lii0f]=0QSS1P000b4T0h@@0mJj0_oO0ooo0ooO0lHH0e[[0aS3
1@000`Q10a220a2R0f]=0f</0/Hh0oNn0ooo0ooO0liI1F</0aSS1P000`0P24880jDd0nmM0ooO2ooo
0bU50RUU2C660iBb0nLL0_NN0ooo0nmm0jDD0jDd0d880SW70bUU0`0P0`000`0P0`QQ0Q2R0f</0lHh
0oNn1_oo0lii0V]=0aSS1P000b4T0h@@0]Jj0ooO0ooo0ooO0lHH0e[[0QS31P000`Q10a220a2R0V]=
0f</0lHh0oNn0ooo0ooO0liI1F</0aSS1P000`0P24880jDd0nmM0ooO2ooo0RU50bUU2C660iBb0^LL
0oNN0ooo0nmm0jDD0jDd0T880cW70bUU0`0P0`000`0P0PQQ0a2R0f</0lHh0oNn1Ooo0lii0f]=0aSS
1P000b4T0X@@0mJj0ooO0ooo0ooO0lHH0U[[0aS31P000`Q10a220Q2R0f]=0f</0lHh0oNn0ooo0_oO
0liI1V</0aSS1@000`0P2D880jDd0nmM0_oO2ooo0bU50bUU23660iBb0nLL0oNN0ooo0nmm0ZDD0jDd
0d880cW70bUU0`0P0`000P0P0`QQ0a2R0f</0lHh0oNn1Ooo0lii0f]=0aSS1@000b4T0h@@0mJj0ooO
0ooo0_oO0lHH0e[[0aS31P000PQ10a220a2R0f]=0f</0lHh0oNn0_oo0ooO0liI1V</0aSS1@000`0P
2D880ZDd0nmM0ooO6ooo000Gool3:DD3:FD8<HH3U;83ia`3mih2ool3kgd3YA@3YC@3@PP3>LL3:FD2
02030003020326434:83Hb`2aSP3mkh6ool3cWT3Jdd26><600038B@3Q103e[X2oml3ool3oml3aQP3
F^/36<<50003244348834:83Jdd3Hb`2aSP3mkh3ool3oml3cUT5Hb`36><600030208@PP3YC@3ked3
oml;ool3:DD2:FD9<HH3U;83ia`2mih3ool3kgd3YA@3YC@3@PP2>LL3:FD302030003020326424:83
Hb`3aSP3mkh6ool3cWT2Jdd36><600038B@3Q102e[X3oml3ool3oml3aQP3F^/26<<6000324434883
4:82Jdd3Hb`3aSP3mkh3ool3oml3cUT5Hb`36><600030208@PP3YC@3ked3oml;ool2:DD3:FD9<HH3
U;82ia`3mih3ool3kgd3YA@3YC@2@PP3>LL3:FD302030003020226434:83Hb`3aSP3mkh5ool3cWT3
Jdd36><600038B@2Q103e[X3oml3ool3oml3aQP2F^/36<<60003244348824:83Jdd3Hb`3aSP3mkh3
ool2oml3cUT6Hb`36><500030209@PP3YC@3ked2oml;ool3:DD3:FD8<HH3U;83ia`3mih3ool3kgd2
YA@3YC@3@PP3>LL3:FD302030002020326434:83Hb`3aSP3mkh5ool3cWT3Jdd36><500038B@3Q103
e[X3oml3ool2oml3aQP3F^/36<<60002244348834:83Jdd3Hb`3aSP3mkh2ool3oml3cUT6Hb`36><5
00030209@PP2YC@3ked3omlKool001Ooo`<YA@<YI@PaQP>D/P?W70?gWP;oo`?_O@>U50>U=0=220<i
a`<YI@8080<000<080<8H@<@XP=S;0;6>0?g_PKoo`?>N@=[C@8Hh`H000<Q90>440?F^P;og`?oo`?o
g`?660=Jj`<H``D000<8@@<@PP<@XP=[C@=S;0;6>0?g_P?oo`?og`?>F@ES;0<Hh`H000<080Q220>U
=0?_G@?og`_oo`<YA@8YI@TaQP>D/P?W70;gWP?oo`?_O@>U50>U=0=2208ia`<YI@<080<000<080<8
H@8@XP=S;0?6>0?g_PKoo`?>N@9[C@<Hh`H000<Q90>440;F^P?og`?oo`?og`?660=Jj`8H``H000<8
@@<@PP<@XP9[C@=S;0?6>0?g_P?oo`?og`?>F@ES;0<Hh`H000<080Q220>U=0?_G@?og`_oo`8YA@<Y
I@TaQP>D/P;W70?gWP?oo`?_O@>U50>U=09220<ia`<YI@<080<000<08088H@<@XP=S;0?6>0?g_PGo
o`?>N@=[C@<Hh`H000<Q90:440?F^P?og`?oo`?og`?6609Jj`<H``H000<8@@<@PP8@XP=[C@=S;0?6
>0?g_P?oo`;og`?>F@IS;0<Hh`D000<080U220>U=0?_G@;og`_oo`<YA@<YI@PaQP>D/P?W70?gWP?o
o`?_O@:U50>U=0=220<ia`<YI@<080<0008080<8H@<@XP=S;0?6>0?g_PGoo`?>N@=[C@<Hh`D000<Q
90>440?F^P?og`?oo`;og`?660=Jj`<H``H00088@@<@PP<@XP=[C@=S;0?6>0?g_P;oo`?og`?>F@IS
;0<Hh`D000<080U220:U=0?_G@?oga_oo`005ooo0bU50bUU23660iBb0nLL0oNN0_oo0nmm0jDD0jDd
0d880cW70bUU0P0P0`000`0P0`QQ0a2R0f</0/Hh0oNn1_oo0lii0f]=0QSS1P000b4T0h@@0mJj0_oO
0ooo0ooO0lHH0e[[0aS31@000`Q10a220a2R0f]=0f</0/Hh0oNn0ooo0ooO0liI1F</0aSS1P000`0P
24880jDd0nmM0ooO2ooo0bU50RUU2C660iBb0nLL0_NN0ooo0nmm0jDD0jDd0d880SW70bUU0`0P0`00
0`0P0`QQ0Q2R0f</0lHh0oNn1_oo0lii0V]=0aSS1P000b4T0h@@0]Jj0ooO0ooo0ooO0lHH0e[[0QS3
1P000`Q10a220a2R0V]=0f</0lHh0oNn0ooo0ooO0liI1F</0aSS1P000`0P24880jDd0nmM0ooO2ooo
0RU50bUU2C660iBb0^LL0oNN0ooo0nmm0jDD0jDd0T880cW70bUU0`0P0`000`0P0PQQ0a2R0f</0lHh
0oNn1Ooo0lii0f]=0aSS1P000b4T0X@@0mJj0ooO0ooo0ooO0lHH0U[[0aS31P000`Q10a220Q2R0f]=
0f</0lHh0oNn0ooo0_oO0liI1V</0aSS1@000`0P2D880jDd0nmM0_oO2ooo0bU50bUU23660iBb0nLL
0oNN0ooo0nmm0ZDD0jDd0d880cW70bUU0`0P0`000P0P0`QQ0a2R0f</0lHh0oNn1Ooo0lii0f]=0aSS
1@000b4T0h@@0mJj0ooO0ooo0_oO0lHH0e[[0aS31P000PQ10a220a2R0f]=0f</0lHh0oNn0_oo0ooO
0liI1V</0aSS1@000`0P2D880ZDd0nmM0ooO6ooo000Gool3:DD3:FD8<HH3U;83ia`3mih2ool3kgd3
YA@3YC@3@PP3>LL3:FD202030003020326434:83Hb`2aSP3mkh6ool3cWT3Jdd26><600038B@3Q103
e[X2oml3ool3oml3aQP3F^/36<<50003244348834:83Jdd3Hb`2aSP3mkh3ool3oml3cUT5Hb`36><6
00030208@PP3YC@3ked3oml;ool3:DD2:FD9<HH3U;83ia`2mih3ool3kgd3YA@3YC@3@PP2>LL3:FD3
02030003020326424:83Hb`3aSP3mkh6ool3cWT2Jdd36><600038B@3Q102e[X3oml3ool3oml3aQP3
F^/26<<60003244348834:82Jdd3Hb`3aSP3mkh3ool3oml3cUT5Hb`36><600030208@PP3YC@3ked3
oml;ool2:DD3:FD9<HH3U;82ia`3mih3ool3kgd3YA@3YC@2@PP3>LL3:FD302030003020226434:83
Hb`3aSP3mkh5ool3cWT3Jdd36><600038B@2Q103e[X3oml3ool3oml3aQP2F^/36<<6000324434882
4:83Jdd3Hb`3aSP3mkh3ool2oml3cUT6Hb`36><500030209@PP3YC@3ked2oml;ool3:DD3:FD8<HH3
U;83ia`3mih3ool3kgd2YA@3YC@3@PP3>LL3:FD302030002020326434:83Hb`3aSP3mkh5ool3cWT3
Jdd36><500038B@3Q103e[X3oml3ool2oml3aQP3F^/36<<60002244348834:83Jdd3Hb`3aSP3mkh2
ool3oml3cUT6Hb`36><500030209@PP2YC@3ked3omlKool001Ooo`<YA@<YI@PaQP>D/P?W70?gWP;o
o`?_O@>U50>U=0=220<ia`<YI@8080<000<080<8H@<@XP=S;0;6>0?g_PKoo`?>N@=[C@8Hh`H000<Q
90>440?F^P;og`?oo`?og`?660=Jj`<H``D000<8@@<@PP<@XP=[C@=S;0;6>0?g_P?oo`?og`?>F@ES
;0<Hh`H000<080Q220>U=0?_G@?og`_oo`<YA@8YI@TaQP>D/P?W70;gWP?oo`?_O@>U50>U=0=2208i
a`<YI@<080<000<080<8H@8@XP=S;0?6>0?g_PKoo`?>N@9[C@<Hh`H000<Q90>440;F^P?og`?oo`?o
g`?660=Jj`8H``H000<8@@<@PP<@XP9[C@=S;0?6>0?g_P?oo`?og`?>F@ES;0<Hh`H000<080Q220>U
=0?_G@?og`_oo`8YA@<YI@TaQP>D/P;W70?gWP?oo`?_O@>U50>U=09220<ia`<YI@<080<000<08088
H@<@XP=S;0?6>0?g_PGoo`?>N@=[C@<Hh`H000<Q90:440?F^P?og`?oo`?og`?6609Jj`<H``H000<8
@@<@PP8@XP=[C@=S;0?6>0?g_P?oo`;og`?>F@IS;0<Hh`D000<080U220>U=0?_G@;og`_oo`<YA@<Y
I@PaQP>D/P?W70?gWP?oo`?_O@:U50>U=0=220<ia`<YI@<080<0008080<8H@<@XP=S;0?6>0?g_PGo
o`?>N@=[C@<Hh`D000<Q90>440?F^P?og`?oo`;og`?660=Jj`<H``H00088@@<@PP<@XP=[C@=S;0?6
>0?g_P;oo`?og`?>F@IS;0<Hh`D000<080U220:U=0?_G@?oga_oo`005ooo0bU50bUU23660iBb0nLL
0oNN0_oo0nmm0jDD0jDd0d880cW70bUU0P0P0`000`0P0`QQ0a2R0f</0/Hh0oNn1_oo0lii0f]=0QSS
1P000b4T0h@@0mJj0_oO0ooo0ooO0lHH0e[[0aS31@000`Q10a220a2R0f]=0f</0/Hh0oNn0ooo0ooO
0liI1F</0aSS1P000`0P24880jDd0nmM0ooO2ooo0bU50RUU2C660iBb0nLL0_NN0ooo0nmm0jDD0jDd
0d880SW70bUU0`0P0`000`0P0`QQ0Q2R0f</0lHh0oNn1_oo0lii0V]=0aSS1P000b4T0h@@0]Jj0ooO
0ooo0ooO0lHH0e[[0QS31P000`Q10a220a2R0V]=0f</0lHh0oNn0ooo0ooO0liI1F</0aSS1P000`0P
24880jDd0nmM0ooO2ooo0RU50bUU2C660iBb0^LL0oNN0ooo0nmm0jDD0jDd0T880cW70bUU0`0P0`00
0`0P0PQQ0a2R0f</0lHh0oNn1Ooo0lii0f]=0aSS1P000b4T0X@@0mJj0ooO0ooo0ooO0lHH0U[[0aS3
1P000`Q10a220Q2R0f]=0f</0lHh0oNn0ooo0_oO0liI1V</0aSS1@000`0P2D880jDd0nmM0_oO2ooo
0bU50bUU23660iBb0nLL0oNN0ooo0nmm0ZDD0jDd0d880cW70bUU0`0P0`000P0P0`QQ0a2R0f</0lHh
0oNn1Ooo0lii0f]=0aSS1@000b4T0h@@0mJj0ooO0ooo0_oO0lHH0e[[0aS31P000PQ10a220a2R0f]=
0f</0lHh0oNn0_oo0ooO0liI1V</0aSS1@000`0P2D880ZDd0nmM0ooO6ooo000Gool3ic`3S742<HH3
020300036><38@@3Nnl2Nll3e[X3oml3ool3ic`3g_/3g]/2Nnl38B@3020300030205>NL6YA@3YC@3
[ED3[GD2]IH3kgd6ool3mkh3kgd2ic`3ia`3S543:FD302030002020326434:836<<38@@38B@3Q102
g]/3oml3ool3mkh6_ML2DZX3DXX348860003244248836<<3Jfd3cUT3mkh;ool3ic`2S743<HH30203
00036><38@@2Nnl3Nll3e[X3oml3ool3ic`2g_/3g]/3Nnl38B@3020300020206>NL6YA@3YC@3[ED2
[GD3]IH3kgd6ool3mkh2kgd3ic`3ia`3S543:FD302020003020326434:836<<38@@28B@3Q103g]/3
oml3ool3mkh5_ML3DZX3DXX348860002244348836<<3Jfd3cUT3mkh;ool2ic`3S743<HH302030003
6><28@@3Nnl3Nll3e[X3oml3ool2ic`3g_/3g]/3Nnl38B@3020200030206>NL6YA@2YC@3[ED3[GD3
]IH3kgd6ool2mkh3kgd3ic`3ia`3S543:FD202030003020326434:836<<28@@38B@3Q103g]/3oml3
ool2mkh6_ML3DZX3DXX348850003244348836<<3Jfd3cUT2mkh;ool3ic`3S743<HH3020200036><3
8@@3Nnl3Nll3e[X2oml3ool3ic`3g_/3g]/3Nnl38B@2020300030206>NL5YA@3YC@3[ED3[GD3]IH3
kgd5ool3mkh3kgd3ic`3ia`2S543:FD302030003020326424:836<<38@@38B@3Q103g]/3oml2ool3
mkh6_ML3DZX3DXX248860003244348836<<2Jfd3cUT3mkhKool001Ooo`?W?0><L@8aQP<080<000<H
h`<Q10=kk`9kc`?F^P?og`?oo`?W?0?Nn`?Nf`9kk`<Q90<080<000<080Dii`JU50>U=0>]E@>]M@:e
UP?_O@Koo`?g_P?_O@;W?0?W70><D@<YI@<080<0008080<8H@<@XP<H``<Q10<Q90>440;Nf`?og`?o
o`?g_PJme`9BZP=BRP<@PPH000<8@@8@PP<H``=[K@?>F@?g_P_oo`?W?0:<L@<aQP<080<000<Hh`<Q
109kk`=kc`?F^P?og`?oo`?W?0;Nn`?Nf`=kk`<Q90<080<0008080Hii`JU50>U=0>]E@:]M@>eUP?_
O@Koo`?g_P;_O@?W?0?W70><D@<YI@<0808000<080<8H@<@XP<H``<Q108Q90>440?Nf`?og`?oo`?g
_PFme`=BZP=BRP<@PPH00088@@<@PP<H``=[K@?>F@?g_P_oo`;W?0><L@<aQP<080<000<Hh`8Q10=k
k`=kc`?F^P?og`?oo`;W?0?Nn`?Nf`=kk`<Q90<0808000<080Hii`JU50:U=0>]E@>]M@>eUP?_O@Ko
o`;g_P?_O@?W?0?W70><D@<YI@8080<000<080<8H@<@XP<H``8Q10<Q90>440?Nf`?og`?oo`;g_PJm
e`=BZP=BRP<@PPD000<8@@<@PP<H``=[K@?>F@;g_P_oo`?W?0><L@<aQP<0808000<Hh`<Q10=kk`=k
c`?F^P;og`?oo`?W?0?Nn`?Nf`=kk`<Q908080<000<080Hii`FU50>U=0>]E@>]M@>eUP?_O@Goo`?g
_P?_O@?W?0?W70:<D@<YI@<080<000<080<8H@8@XP<H``<Q10<Q90>440?Nf`?og`;oo`?g_PJme`=B
ZP=BRP8@PPH000<8@@<@PP<H``9[K@?>F@?g_Q_oo`005ooo0nLl0haa0S660`0P0`000aSS0b440g__
0W_?0mJj0ooO0ooo0nLl0mkk0mkK0W__0b4T0`0P0`000`0P1CWW1ZDD0jDd0jeE0jee0[FF0nmm1_oo
0oNn0nmm0^Ll0nLL0haA0bUU0`0P0`000P0P0`QQ0a2R0aS30b440b4T0h@@0]kK0ooO0ooo0oNn1[gG
0U:Z0e::0a221P000`Q10Q220aS30f]]0liI0oNn2ooo0nLl0Xaa0c660`0P0`000aSS0b440W__0g_?
0mJj0ooO0ooo0nLl0]kk0mkK0g__0b4T0`0P0`000P0P1SWW1ZDD0jDd0jeE0Zee0kFF0nmm1_oo0oNn
0^mm0nLl0nLL0haA0bUU0`0P0P000`0P0`QQ0a2R0aS30b440R4T0h@@0mkK0ooO0ooo0oNn1KgG0e:Z
0e::0a221P000PQ10a220aS30f]]0liI0oNn2ooo0^Ll0haa0c660`0P0`000aSS0R440g__0g_?0mJj
0ooO0ooo0^Ll0mkk0mkK0g__0b4T0`0P0P000`0P1SWW1ZDD0ZDd0jeE0jee0kFF0nmm1_oo0_Nn0nmm
0nLl0nLL0haA0bUU0P0P0`000`0P0`QQ0a2R0aS30R440b4T0h@@0mkK0ooO0ooo0_Nn1[gG0e:Z0e::
0a221@000`Q10a220aS30f]]0liI0_Nn2ooo0nLl0haa0c660`0P0P000aSS0b440g__0g_?0mJj0_oO
0ooo0nLl0mkk0mkK0g__0b4T0P0P0`000`0P1SWW1JDD0jDd0jeE0jee0kFF0nmm1Ooo0oNn0nmm0nLl
0nLL0XaA0bUU0`0P0`000`0P0`QQ0Q2R0aS30b440b4T0h@@0mkK0ooO0_oo0oNn1[gG0e:Z0e::0Q22
1P000`Q10a220aS30V]]0liI0oNn6ooo000Gool3ic`3S742<HH3020300036><38@@3Nnl2Nll3e[X3
oml3ool3ic`3g_/3g]/2Nnl38B@3020300030205>NL6YA@3YC@3[ED3[GD2]IH3kgd6ool3mkh3kgd2
ic`3ia`3S543:FD302030002020326434:836<<38@@38B@3Q102g]/3oml3ool3mkh6_ML2DZX3DXX3
48860003244248836<<3Jfd3cUT3mkh;ool3ic`2S743<HH3020300036><38@@2Nnl3Nll3e[X3oml3
ool3ic`2g_/3g]/3Nnl38B@3020300020206>NL6YA@3YC@3[ED2[GD3]IH3kgd6ool3mkh2kgd3ic`3
ia`3S543:FD302020003020326434:836<<38@@28B@3Q103g]/3oml3ool3mkh5_ML3DZX3DXX34886
0002244348836<<3Jfd3cUT3mkh;ool2ic`3S743<HH3020300036><28@@3Nnl3Nll3e[X3oml3ool2
ic`3g_/3g]/3Nnl38B@3020200030206>NL6YA@2YC@3[ED3[GD3]IH3kgd6ool2mkh3kgd3ic`3ia`3
S543:FD202030003020326434:836<<28@@38B@3Q103g]/3oml3ool2mkh6_ML3DZX3DXX348850003
244348836<<3Jfd3cUT2mkh;ool3ic`3S743<HH3020200036><38@@3Nnl3Nll3e[X2oml3ool3ic`3
g_/3g]/3Nnl38B@2020300030206>NL5YA@3YC@3[ED3[GD3]IH3kgd5ool3mkh3kgd3ic`3ia`2S543
:FD302030003020326424:836<<38@@38B@3Q103g]/3oml2ool3mkh6_ML3DZX3DXX2488600032443
48836<<2Jfd3cUT3mkhKool001Ooo`?W?0><L@8aQP<080<000<Hh`<Q10=kk`9kc`?F^P?og`?oo`?W
?0?Nn`?Nf`9kk`<Q90<080<000<080Dii`JU50>U=0>]E@>]M@:eUP?_O@Koo`?g_P?_O@;W?0?W70><
D@<YI@<080<0008080<8H@<@XP<H``<Q10<Q90>440;Nf`?og`?oo`?g_PJme`9BZP=BRP<@PPH000<8
@@8@PP<H``=[K@?>F@?g_P_oo`?W?0:<L@<aQP<080<000<Hh`<Q109kk`=kc`?F^P?og`?oo`?W?0;N
n`?Nf`=kk`<Q90<080<0008080Hii`JU50>U=0>]E@:]M@>eUP?_O@Koo`?g_P;_O@?W?0?W70><D@<Y
I@<0808000<080<8H@<@XP<H``<Q108Q90>440?Nf`?og`?oo`?g_PFme`=BZP=BRP<@PPH00088@@<@
PP<H``=[K@?>F@?g_P_oo`;W?0><L@<aQP<080<000<Hh`8Q10=kk`=kc`?F^P?og`?oo`;W?0?Nn`?N
f`=kk`<Q90<0808000<080Hii`JU50:U=0>]E@>]M@>eUP?_O@Koo`;g_P?_O@?W?0?W70><D@<YI@80
80<000<080<8H@<@XP<H``8Q10<Q90>440?Nf`?og`?oo`;g_PJme`=BZP=BRP<@PPD000<8@@<@PP<H
``=[K@?>F@;g_P_oo`?W?0><L@<aQP<0808000<Hh`<Q10=kk`=kc`?F^P;og`?oo`?W?0?Nn`?Nf`=k
k`<Q908080<000<080Hii`FU50>U=0>]E@>]M@>eUP?_O@Goo`?g_P?_O@?W?0?W70:<D@<YI@<080<0
00<080<8H@8@XP<H``<Q10<Q90>440?Nf`?og`;oo`?g_PJme`=BZP=BRP8@PPH000<8@@<@PP<H``9[
K@?>F@?g_Q_oo`005ooo0nLl0haa0S660`0P0`000aSS0b440g__0W_?0mJj0ooO0ooo0nLl0mkk0mkK
0W__0b4T0`0P0`000`0P1CWW1ZDD0jDd0jeE0jee0[FF0nmm1_oo0oNn0nmm0^Ll0nLL0haA0bUU0`0P
0`000P0P0`QQ0a2R0aS30b440b4T0h@@0]kK0ooO0ooo0oNn1[gG0U:Z0e::0a221P000`Q10Q220aS3
0f]]0liI0oNn2ooo0nLl0Xaa0c660`0P0`000aSS0b440W__0g_?0mJj0ooO0ooo0nLl0]kk0mkK0g__
0b4T0`0P0`000P0P1SWW1ZDD0jDd0jeE0Zee0kFF0nmm1_oo0oNn0^mm0nLl0nLL0haA0bUU0`0P0P00
0`0P0`QQ0a2R0aS30b440R4T0h@@0mkK0ooO0ooo0oNn1KgG0e:Z0e::0a221P000PQ10a220aS30f]]
0liI0oNn2ooo0^Ll0haa0c660`0P0`000aSS0R440g__0g_?0mJj0ooO0ooo0^Ll0mkk0mkK0g__0b4T
0`0P0P000`0P1SWW1ZDD0ZDd0jeE0jee0kFF0nmm1_oo0_Nn0nmm0nLl0nLL0haA0bUU0P0P0`000`0P
0`QQ0a2R0aS30R440b4T0h@@0mkK0ooO0ooo0_Nn1[gG0e:Z0e::0a221@000`Q10a220aS30f]]0liI
0_Nn2ooo0nLl0haa0c660`0P0P000aSS0b440g__0g_?0mJj0_oO0ooo0nLl0mkk0mkK0g__0b4T0P0P
0`000`0P1SWW1JDD0jDd0jeE0jee0kFF0nmm1Ooo0oNn0nmm0nLl0nLL0XaA0bUU0`0P0`000`0P0`QQ
0Q2R0aS30b440b4T0h@@0mkK0ooO0_oo0oNn1[gG0e:Z0e::0Q221P000`Q10a220aS30V]]0liI0oNn
6ooo000Gool3ic`3S742<HH3020300036><38@@3Nnl2Nll3e[X3oml3ool3ic`3g_/3g]/2Nnl38B@3
020300030205>NL6YA@3YC@3[ED3[GD2]IH3kgd6ool3mkh3kgd2ic`3ia`3S543:FD3020300020203
26434:836<<38@@38B@3Q102g]/3oml3ool3mkh6_ML2DZX3DXX348860003244248836<<3Jfd3cUT3
mkh;ool3ic`2S743<HH3020300036><38@@2Nnl3Nll3e[X3oml3ool3ic`2g_/3g]/3Nnl38B@30203
00020206>NL6YA@3YC@3[ED2[GD3]IH3kgd6ool3mkh2kgd3ic`3ia`3S543:FD30202000302032643
4:836<<38@@28B@3Q103g]/3oml3ool3mkh5_ML3DZX3DXX348860002244348836<<3Jfd3cUT3mkh;
ool2ic`3S743<HH3020300036><28@@3Nnl3Nll3e[X3oml3ool2ic`3g_/3g]/3Nnl38B@302020003
0206>NL6YA@2YC@3[ED3[GD3]IH3kgd6ool2mkh3kgd3ic`3ia`3S543:FD202030003020326434:83
6<<28@@38B@3Q103g]/3oml3ool2mkh6_ML3DZX3DXX348850003244348836<<3Jfd3cUT2mkh;ool3
ic`3S743<HH3020200036><38@@3Nnl3Nll3e[X2oml3ool3ic`3g_/3g]/3Nnl38B@2020300030206
>NL5YA@3YC@3[ED3[GD3]IH3kgd5ool3mkh3kgd3ic`3ia`2S543:FD302030003020326424:836<<3
8@@38B@3Q103g]/3oml2ool3mkh6_ML3DZX3DXX248860003244348836<<2Jfd3cUT3mkhKool001Oo
o`?W?0><L@8aQP<080<000<Hh`<Q10=kk`9kc`?F^P?og`?oo`?W?0?Nn`?Nf`9kk`<Q90<080<000<0
80Dii`JU50>U=0>]E@>]M@:eUP?_O@Koo`?g_P?_O@;W?0?W70><D@<YI@<080<0008080<8H@<@XP<H
``<Q10<Q90>440;Nf`?og`?oo`?g_PJme`9BZP=BRP<@PPH000<8@@8@PP<H``=[K@?>F@?g_P_oo`?W
?0:<L@<aQP<080<000<Hh`<Q109kk`=kc`?F^P?og`?oo`?W?0;Nn`?Nf`=kk`<Q90<080<0008080Hi
i`JU50>U=0>]E@:]M@>eUP?_O@Koo`?g_P;_O@?W?0?W70><D@<YI@<0808000<080<8H@<@XP<H``<Q
108Q90>440?Nf`?og`?oo`?g_PFme`=BZP=BRP<@PPH00088@@<@PP<H``=[K@?>F@?g_P_oo`;W?0><
L@<aQP<080<000<Hh`8Q10=kk`=kc`?F^P?og`?oo`;W?0?Nn`?Nf`=kk`<Q90<0808000<080Hii`JU
50:U=0>]E@>]M@>eUP?_O@Koo`;g_P?_O@?W?0?W70><D@<YI@8080<000<080<8H@<@XP<H``8Q10<Q
90>440?Nf`?og`?oo`;g_PJme`=BZP=BRP<@PPD000<8@@<@PP<H``=[K@?>F@;g_P_oo`?W?0><L@<a
QP<0808000<Hh`<Q10=kk`=kc`?F^P;og`?oo`?W?0?Nn`?Nf`=kk`<Q908080<000<080Hii`FU50>U
=0>]E@>]M@>eUP?_O@Goo`?g_P?_O@?W?0?W70:<D@<YI@<080<000<080<8H@8@XP<H``<Q10<Q90>4
40?Nf`?og`;oo`?g_PJme`=BZP=BRP8@PPH000<8@@<@PP<H``9[K@?>F@?g_Q_oo`005ooo0nLl0haa
0S660`0P0`000aSS0b440g__0W_?0mJj0ooO0ooo0nLl0mkk0mkK0W__0b4T0`0P0`000`0P1CWW1ZDD
0jDd0jeE0jee0[FF0nmm1_oo0oNn0nmm0^Ll0nLL0haA0bUU0`0P0`000P0P0`QQ0a2R0aS30b440b4T
0h@@0]kK0ooO0ooo0oNn1[gG0U:Z0e::0a221P000`Q10Q220aS30f]]0liI0oNn2ooo0nLl0Xaa0c66
0`0P0`000aSS0b440W__0g_?0mJj0ooO0ooo0nLl0]kk0mkK0g__0b4T0`0P0`000P0P1SWW1ZDD0jDd
0jeE0Zee0kFF0nmm1_oo0oNn0^mm0nLl0nLL0haA0bUU0`0P0P000`0P0`QQ0a2R0aS30b440R4T0h@@
0mkK0ooO0ooo0oNn1KgG0e:Z0e::0a221P000PQ10a220aS30f]]0liI0oNn2ooo0^Ll0haa0c660`0P
0`000aSS0R440g__0g_?0mJj0ooO0ooo0^Ll0mkk0mkK0g__0b4T0`0P0P000`0P1SWW1ZDD0ZDd0jeE
0jee0kFF0nmm1_oo0_Nn0nmm0nLl0nLL0haA0bUU0P0P0`000`0P0`QQ0a2R0aS30R440b4T0h@@0mkK
0ooO0ooo0_Nn1[gG0e:Z0e::0a221@000`Q10a220aS30f]]0liI0_Nn2ooo0nLl0haa0c660`0P0P00
0aSS0b440g__0g_?0mJj0_oO0ooo0nLl0mkk0mkK0g__0b4T0P0P0`000`0P1SWW1JDD0jDd0jeE0jee
0kFF0nmm1Ooo0oNn0nmm0nLl0nLL0XaA0bUU0`0P0`000`0P0`QQ0Q2R0aS30b440b4T0h@@0mkK0ooO
0_oo0oNn1[gG0e:Z0e::0Q221P000`Q10a220aS30V]]0liI0oNn6ooo000Gool3ic`3S742<HH30203
00036><38@@3Nnl2Nll3e[X3oml3ool3ic`3g_/3g]/2Nnl38B@3020300030205>NL6YA@3YC@3[ED3
[GD2]IH3kgd6ool3mkh3kgd2ic`3ia`3S543:FD302030002020326434:836<<38@@38B@3Q102g]/3
oml3ool3mkh6_ML2DZX3DXX348860003244248836<<3Jfd3cUT3mkh;ool3ic`2S743<HH302030003
6><38@@2Nnl3Nll3e[X3oml3ool3ic`2g_/3g]/3Nnl38B@3020300020206>NL6YA@3YC@3[ED2[GD3
]IH3kgd6ool3mkh2kgd3ic`3ia`3S543:FD302020003020326434:836<<38@@28B@3Q103g]/3oml3
ool3mkh5_ML3DZX3DXX348860002244348836<<3Jfd3cUT3mkh;ool2ic`3S743<HH3020300036><2
8@@3Nnl3Nll3e[X3oml3ool2ic`3g_/3g]/3Nnl38B@3020200030206>NL6YA@2YC@3[ED3[GD3]IH3
kgd6ool2mkh3kgd3ic`3ia`3S543:FD202030003020326434:836<<28@@38B@3Q103g]/3oml3ool2
mkh6_ML3DZX3DXX348850003244348836<<3Jfd3cUT2mkh;ool3ic`3S743<HH3020200036><38@@3
Nnl3Nll3e[X2oml3ool3ic`3g_/3g]/3Nnl38B@2020300030206>NL5YA@3YC@3[ED3[GD3]IH3kgd5
ool3mkh3kgd3ic`3ia`2S543:FD302030003020326424:836<<38@@38B@3Q103g]/3oml2ool3mkh6
_ML3DZX3DXX248860003244348836<<2Jfd3cUT3mkhKool001Ooo`?W?0><L@8aQP<080<000<Hh`<Q
10=kk`9kc`?F^P?og`?oo`?W?0?Nn`?Nf`9kk`<Q90<080<000<080Dii`JU50>U=0>]E@>]M@:eUP?_
O@Koo`?g_P?_O@;W?0?W70><D@<YI@<080<0008080<8H@<@XP<H``<Q10<Q90>440;Nf`?og`?oo`?g
_PJme`9BZP=BRP<@PPH000<8@@8@PP<H``=[K@?>F@?g_P_oo`?W?0:<L@<aQP<080<000<Hh`<Q109k
k`=kc`?F^P?og`?oo`?W?0;Nn`?Nf`=kk`<Q90<080<0008080Hii`JU50>U=0>]E@:]M@>eUP?_O@Ko
o`?g_P;_O@?W?0?W70><D@<YI@<0808000<080<8H@<@XP<H``<Q108Q90>440?Nf`?og`?oo`?g_PFm
e`=BZP=BRP<@PPH00088@@<@PP<H``=[K@?>F@?g_P_oo`;W?0><L@<aQP<080<000<Hh`8Q10=kk`=k
c`?F^P?og`?oo`;W?0?Nn`?Nf`=kk`<Q90<0808000<080Hii`JU50:U=0>]E@>]M@>eUP?_O@Koo`;g
_P?_O@?W?0?W70><D@<YI@8080<000<080<8H@<@XP<H``8Q10<Q90>440?Nf`?og`?oo`;g_PJme`=B
ZP=BRP<@PPD000<8@@<@PP<H``=[K@?>F@;g_P_oo`?W?0><L@<aQP<0808000<Hh`<Q10=kk`=kc`?F
^P;og`?oo`?W?0?Nn`?Nf`=kk`<Q908080<000<080Hii`FU50>U=0>]E@>]M@>eUP?_O@Goo`?g_P?_
O@?W?0?W70:<D@<YI@<080<000<080<8H@8@XP<H``<Q10<Q90>440?Nf`?og`;oo`?g_PJme`=BZP=B
RP8@PPH000<8@@<@PP<H``9[K@?>F@?g_Q_oo`005ooo0ooO1LHh2F<<0aS30`000PQ10`QQ0e[;0e:Z
0kgG0lHH0oNn1Ooo0lii0f]=0aSS1@000b4T0h@@0g__0mJj0ooO0_oo0ooO2LHH0e[[0QS31P000b4T
0bU51HaA0h@`0mkK0nmM0ooo0oNn0kFf0TYY0a221P000`Q10a220U[[0e[;0kgg0oNN0ooo0nmm0^Ll
0nLL0haA0haa0c660`0P2?oo0ooO1LHh2F<<0aS30P000`Q10`QQ0e[;0e:Z0kgG0/HH0oNn1_oo0lii
0f]=0QSS1P000b4T0h@@0g__0mJj0_oO0ooo0ooO2LHH0U[[0aS31P000b4T0bU51HaA0h@`0mkK0nmM
0ooo0_Nn0kFf0dYY0a221P000`Q10Q220e[[0e[;0kgg0oNN0ooo0^mm0nLl0nLL0haA0haa0c660P0P
2Ooo0_oO1/Hh2F<<0QS30`000`Q10`QQ0e[;0e:Z0[gG0lHH0oNn1_oo0lii0V]=0aSS1P000b4T0h@@
0W__0mJj0ooO0ooo0ooO2<HH0e[[0aS31P000b4T0RU51XaA0h@`0mkK0nmM0_oo0oNn0kFf0dYY0a22
1@000`Q10a220e[[0e[;0kgg0_NN0ooo0nmm0nLl0nLL0haA0haa0S660`0P2?oo0ooO1/Hh26<<0aS3
0`000`Q10`QQ0U[;0e:Z0kgG0lHH0oNn1_oo0/ii0f]=0aSS1P000b4T0X@@0g__0mJj0ooO0ooo0ooO
2<HH0e[[0aS31@000b4T0bU51XaA0h@`0]kK0nmM0ooo0oNn0kFf0dYY0a221@000`Q10a220e[[0e[;
0[gg0oNN0ooo0nmm0nLl0nLL0XaA0haa0c660`0P6?oo000Gool3oml5aSP9H``36<<3000224432643
F//3DZX3_ML3aQP3mkh5ool3cWT3Jdd36><500038B@3Q103Nnl3e[X3oml2ool3oml9aQP3F^/26<<6
00038B@3:DD5S543Q303g]/3ked3ool3mkh3]KH2BVT34886000324434882F^/3F//3_OL3mih3ool3
kgd2ic`3ia`3S543S743<HH30208ool3oml5aSP9H``36<<2000324432643F//3DZX3_ML2aQP3mkh6
ool3cWT3Jdd26><600038B@3Q103Nnl3e[X2oml3ool3oml9aQP2F^/36<<600038B@3:DD5S543Q303
g]/3ked3ool2mkh3]KH3BVT34886000324424883F^/3F//3_OL3mih3ool2kgd3ic`3ia`3S543S743
<HH20209ool2oml6aSP9H``26<<3000324432643F//3DZX2_ML3aQP3mkh6ool3cWT2Jdd36><60003
8B@3Q102Nnl3e[X3oml3ool3oml8aQP3F^/36<<600038B@2:DD6S543Q303g]/3ked2ool3mkh3]KH3
BVT34885000324434883F^/3F//3_OL2mih3ool3kgd3ic`3ia`3S543S742<HH30208ool3oml6aSP8
H``36<<3000324432642F//3DZX3_ML3aQP3mkh6ool2cWT3Jdd36><600038B@2Q103Nnl3e[X3oml3
ool3oml8aQP3F^/36<<500038B@3:DD6S543Q302g]/3ked3ool3mkh3]KH3BVT34885000324434883
F^/3F//2_OL3mih3ool3kgd3ic`3ia`2S543S743<HH3020Hool001Ooo`?og`G6>0US30<H``<00088
@@<8H@=Jb`=BZP>me`?660?g_PGoo`?>N@=[C@<Hh`D000<Q90>440=kk`?F^P?og`;oo`?og`W660=J
j`8H``H000<Q90<YA@F<D@>4<0?Nf`?_G@?oo`?g_P>e]P9:J@<@PPH000<8@@<@PP9Jj`=Jb`>mm`?g
WP?oo`?_O@;W?0?W70><D@><L@<aQP<080Soo`?og`G6>0US30<H``8000<8@@<8H@=Jb`=BZP>me`;6
60?g_PKoo`?>N@=[C@8Hh`H000<Q90>440=kk`?F^P;og`?oo`?og`W6609Jj`<H``H000<Q90<YA@F<
D@>4<0?Nf`?_G@?oo`;g_P>e]P=:J@<@PPH000<8@@8@PP=Jj`=Jb`>mm`?gWP?oo`;_O@?W?0?W70><
D@><L@<aQP8080Woo`;og`K6>0US308H``<000<8@@<8H@=Jb`=BZP:me`?660?g_PKoo`?>N@9[C@<H
h`H000<Q90>4409kk`?F^P?og`?oo`?og`S660=Jj`<H``H000<Q908YA@J<D@>4<0?Nf`?_G@;oo`?g
_P>e]P=:J@<@PPD000<8@@<@PP=Jj`=Jb`>mm`;gWP?oo`?_O@?W?0?W70><D@><L@8aQP<080Soo`?o
g`K6>0QS30<H``<000<8@@<8H@9Jb`=BZP>me`?660?g_PKoo`;>N@=[C@<Hh`H000<Q90:440=kk`?F
^P?og`?oo`?og`S660=Jj`<H``D000<Q90<YA@J<D@>4<0;Nf`?_G@?oo`?g_P>e]P=:J@<@PPD000<8
@@<@PP=Jj`=Jb`:mm`?gWP?oo`?_O@?W?0?W70:<D@><L@<aQP<081Soo`005ooo0ooO1LHh2F<<0aS3
0`000PQ10`QQ0e[;0e:Z0kgG0lHH0oNn1Ooo0lii0f]=0aSS1@000b4T0h@@0g__0mJj0ooO0_oo0ooO
2LHH0e[[0QS31P000b4T0bU51HaA0h@`0mkK0nmM0ooo0oNn0kFf0TYY0a221P000`Q10a220U[[0e[;
0kgg0oNN0ooo0nmm0^Ll0nLL0haA0haa0c660`0P2?oo0ooO1LHh2F<<0aS30P000`Q10`QQ0e[;0e:Z
0kgG0/HH0oNn1_oo0lii0f]=0QSS1P000b4T0h@@0g__0mJj0_oO0ooo0ooO2LHH0U[[0aS31P000b4T
0bU51HaA0h@`0mkK0nmM0ooo0_Nn0kFf0dYY0a221P000`Q10Q220e[[0e[;0kgg0oNN0ooo0^mm0nLl
0nLL0haA0haa0c660P0P2Ooo0_oO1/Hh2F<<0QS30`000`Q10`QQ0e[;0e:Z0[gG0lHH0oNn1_oo0lii
0V]=0aSS1P000b4T0h@@0W__0mJj0ooO0ooo0ooO2<HH0e[[0aS31P000b4T0RU51XaA0h@`0mkK0nmM
0_oo0oNn0kFf0dYY0a221@000`Q10a220e[[0e[;0kgg0_NN0ooo0nmm0nLl0nLL0haA0haa0S660`0P
2?oo0ooO1/Hh26<<0aS30`000`Q10`QQ0U[;0e:Z0kgG0lHH0oNn1_oo0/ii0f]=0aSS1P000b4T0X@@
0g__0mJj0ooO0ooo0ooO2<HH0e[[0aS31@000b4T0bU51XaA0h@`0]kK0nmM0ooo0oNn0kFf0dYY0a22
1@000`Q10a220e[[0e[;0[gg0oNN0ooo0nmm0nLl0nLL0XaA0haa0c660`0P6?oo000Gool3oml5aSP9
H``36<<3000224432643F//3DZX3_ML3aQP3mkh5ool3cWT3Jdd36><500038B@3Q103Nnl3e[X3oml2
ool3oml9aQP3F^/26<<600038B@3:DD5S543Q303g]/3ked3ool3mkh3]KH2BVT34886000324434882
F^/3F//3_OL3mih3ool3kgd2ic`3ia`3S543S743<HH30208ool3oml5aSP9H``36<<2000324432643
F//3DZX3_ML2aQP3mkh6ool3cWT3Jdd26><600038B@3Q103Nnl3e[X2oml3ool3oml9aQP2F^/36<<6
00038B@3:DD5S543Q303g]/3ked3ool2mkh3]KH3BVT34886000324424883F^/3F//3_OL3mih3ool2
kgd3ic`3ia`3S543S743<HH20209ool2oml6aSP9H``26<<3000324432643F//3DZX2_ML3aQP3mkh6
ool3cWT2Jdd36><600038B@3Q102Nnl3e[X3oml3ool3oml8aQP3F^/36<<600038B@2:DD6S543Q303
g]/3ked2ool3mkh3]KH3BVT34885000324434883F^/3F//3_OL2mih3ool3kgd3ic`3ia`3S543S742
<HH30208ool3oml6aSP8H``36<<3000324432642F//3DZX3_ML3aQP3mkh6ool2cWT3Jdd36><60003
8B@2Q103Nnl3e[X3oml3ool3oml8aQP3F^/36<<500038B@3:DD6S543Q302g]/3ked3ool3mkh3]KH3
BVT34885000324434883F^/3F//2_OL3mih3ool3kgd3ic`3ia`2S543S743<HH3020Hool001Ooo`?o
g`G6>0US30<H``<00088@@<8H@=Jb`=BZP>me`?660?g_PGoo`?>N@=[C@<Hh`D000<Q90>440=kk`?F
^P?og`;oo`?og`W660=Jj`8H``H000<Q90<YA@F<D@>4<0?Nf`?_G@?oo`?g_P>e]P9:J@<@PPH000<8
@@<@PP9Jj`=Jb`>mm`?gWP?oo`?_O@;W?0?W70><D@><L@<aQP<080Soo`?og`G6>0US30<H``8000<8
@@<8H@=Jb`=BZP>me`;660?g_PKoo`?>N@=[C@8Hh`H000<Q90>440=kk`?F^P;og`?oo`?og`W6609J
j`<H``H000<Q90<YA@F<D@>4<0?Nf`?_G@?oo`;g_P>e]P=:J@<@PPH000<8@@8@PP=Jj`=Jb`>mm`?g
WP?oo`;_O@?W?0?W70><D@><L@<aQP8080Woo`;og`K6>0US308H``<000<8@@<8H@=Jb`=BZP:me`?6
60?g_PKoo`?>N@9[C@<Hh`H000<Q90>4409kk`?F^P?og`?oo`?og`S660=Jj`<H``H000<Q908YA@J<
D@>4<0?Nf`?_G@;oo`?g_P>e]P=:J@<@PPD000<8@@<@PP=Jj`=Jb`>mm`;gWP?oo`?_O@?W?0?W70><
D@><L@8aQP<080Soo`?og`K6>0QS30<H``<000<8@@<8H@9Jb`=BZP>me`?660?g_PKoo`;>N@=[C@<H
h`H000<Q90:440=kk`?F^P?og`?oo`?og`S660=Jj`<H``D000<Q90<YA@J<D@>4<0;Nf`?_G@?oo`?g
_P>e]P=:J@<@PPD000<8@@<@PP=Jj`=Jb`:mm`?gWP?oo`?_O@?W?0?W70:<D@><L@<aQP<081Soo`00
5ooo0ooO1LHh2F<<0aS30`000PQ10`QQ0e[;0e:Z0kgG0lHH0oNn1Ooo0lii0f]=0aSS1@000b4T0h@@
0g__0mJj0ooO0_oo0ooO2LHH0e[[0QS31P000b4T0bU51HaA0h@`0mkK0nmM0ooo0oNn0kFf0TYY0a22
1P000`Q10a220U[[0e[;0kgg0oNN0ooo0nmm0^Ll0nLL0haA0haa0c660`0P2?oo0ooO1LHh2F<<0aS3
0P000`Q10`QQ0e[;0e:Z0kgG0/HH0oNn1_oo0lii0f]=0QSS1P000b4T0h@@0g__0mJj0_oO0ooo0ooO
2LHH0U[[0aS31P000b4T0bU51HaA0h@`0mkK0nmM0ooo0_Nn0kFf0dYY0a221P000`Q10Q220e[[0e[;
0kgg0oNN0ooo0^mm0nLl0nLL0haA0haa0c660P0P2Ooo0_oO1/Hh2F<<0QS30`000`Q10`QQ0e[;0e:Z
0[gG0lHH0oNn1_oo0lii0V]=0aSS1P000b4T0h@@0W__0mJj0ooO0ooo0ooO2<HH0e[[0aS31P000b4T
0RU51XaA0h@`0mkK0nmM0_oo0oNn0kFf0dYY0a221@000`Q10a220e[[0e[;0kgg0_NN0ooo0nmm0nLl
0nLL0haA0haa0S660`0P2?oo0ooO1/Hh26<<0aS30`000`Q10`QQ0U[;0e:Z0kgG0lHH0oNn1_oo0/ii
0f]=0aSS1P000b4T0X@@0g__0mJj0ooO0ooo0ooO2<HH0e[[0aS31@000b4T0bU51XaA0h@`0]kK0nmM
0ooo0oNn0kFf0dYY0a221@000`Q10a220e[[0e[;0[gg0oNN0ooo0nmm0nLl0nLL0XaA0haa0c660`0P
6?oo000Gool3oml5aSP9H``36<<3000224432643F//3DZX3_ML3aQP3mkh5ool3cWT3Jdd36><50003
8B@3Q103Nnl3e[X3oml2ool3oml9aQP3F^/26<<600038B@3:DD5S543Q303g]/3ked3ool3mkh3]KH2
BVT34886000324434882F^/3F//3_OL3mih3ool3kgd2ic`3ia`3S543S743<HH30208ool3oml5aSP9
H``36<<2000324432643F//3DZX3_ML2aQP3mkh6ool3cWT3Jdd26><600038B@3Q103Nnl3e[X2oml3
ool3oml9aQP2F^/36<<600038B@3:DD5S543Q303g]/3ked3ool2mkh3]KH3BVT34886000324424883
F^/3F//3_OL3mih3ool2kgd3ic`3ia`3S543S743<HH20209ool2oml6aSP9H``26<<3000324432643
F//3DZX2_ML3aQP3mkh6ool3cWT2Jdd36><600038B@3Q102Nnl3e[X3oml3ool3oml8aQP3F^/36<<6
00038B@2:DD6S543Q303g]/3ked2ool3mkh3]KH3BVT34885000324434883F^/3F//3_OL2mih3ool3
kgd3ic`3ia`3S543S742<HH30208ool3oml6aSP8H``36<<3000324432642F//3DZX3_ML3aQP3mkh6
ool2cWT3Jdd36><600038B@2Q103Nnl3e[X3oml3ool3oml8aQP3F^/36<<500038B@3:DD6S543Q302
g]/3ked3ool3mkh3]KH3BVT34885000324434883F^/3F//2_OL3mih3ool3kgd3ic`3ia`2S543S743
<HH3020Hool001Ooo`?og`G6>0US30<H``<00088@@<8H@=Jb`=BZP>me`?660?g_PGoo`?>N@=[C@<H
h`D000<Q90>440=kk`?F^P?og`;oo`?og`W660=Jj`8H``H000<Q90<YA@F<D@>4<0?Nf`?_G@?oo`?g
_P>e]P9:J@<@PPH000<8@@<@PP9Jj`=Jb`>mm`?gWP?oo`?_O@;W?0?W70><D@><L@<aQP<080Soo`?o
g`G6>0US30<H``8000<8@@<8H@=Jb`=BZP>me`;660?g_PKoo`?>N@=[C@8Hh`H000<Q90>440=kk`?F
^P;og`?oo`?og`W6609Jj`<H``H000<Q90<YA@F<D@>4<0?Nf`?_G@?oo`;g_P>e]P=:J@<@PPH000<8
@@8@PP=Jj`=Jb`>mm`?gWP?oo`;_O@?W?0?W70><D@><L@<aQP8080Woo`;og`K6>0US308H``<000<8
@@<8H@=Jb`=BZP:me`?660?g_PKoo`?>N@9[C@<Hh`H000<Q90>4409kk`?F^P?og`?oo`?og`S660=J
j`<H``H000<Q908YA@J<D@>4<0?Nf`?_G@;oo`?g_P>e]P=:J@<@PPD000<8@@<@PP=Jj`=Jb`>mm`;g
WP?oo`?_O@?W?0?W70><D@><L@8aQP<080Soo`?og`K6>0QS30<H``<000<8@@<8H@9Jb`=BZP>me`?6
60?g_PKoo`;>N@=[C@<Hh`H000<Q90:440=kk`?F^P?og`?oo`?og`S660=Jj`<H``D000<Q90<YA@J<
D@>4<0;Nf`?_G@?oo`?g_P>e]P=:J@<@PPD000<8@@<@PP=Jj`=Jb`:mm`?gWP?oo`?_O@?W?0?W70:<
D@><L@<aQP<081Soo`005ooo0ooO1LHh2F<<0aS30`000PQ10`QQ0e[;0e:Z0kgG0lHH0oNn1Ooo0lii
0f]=0aSS1@000b4T0h@@0g__0mJj0ooO0_oo0ooO2LHH0e[[0QS31P000b4T0bU51HaA0h@`0mkK0nmM
0ooo0oNn0kFf0TYY0a221P000`Q10a220U[[0e[;0kgg0oNN0ooo0nmm0^Ll0nLL0haA0haa0c660`0P
2?oo0ooO1LHh2F<<0aS30P000`Q10`QQ0e[;0e:Z0kgG0/HH0oNn1_oo0lii0f]=0QSS1P000b4T0h@@
0g__0mJj0_oO0ooo0ooO2LHH0U[[0aS31P000b4T0bU51HaA0h@`0mkK0nmM0ooo0_Nn0kFf0dYY0a22
1P000`Q10Q220e[[0e[;0kgg0oNN0ooo0^mm0nLl0nLL0haA0haa0c660P0P2Ooo0_oO1/Hh2F<<0QS3
0`000`Q10`QQ0e[;0e:Z0[gG0lHH0oNn1_oo0lii0V]=0aSS1P000b4T0h@@0W__0mJj0ooO0ooo0ooO
2<HH0e[[0aS31P000b4T0RU51XaA0h@`0mkK0nmM0_oo0oNn0kFf0dYY0a221@000`Q10a220e[[0e[;
0kgg0_NN0ooo0nmm0nLl0nLL0haA0haa0S660`0P2?oo0ooO1/Hh26<<0aS30`000`Q10`QQ0U[;0e:Z
0kgG0lHH0oNn1_oo0/ii0f]=0aSS1P000b4T0X@@0g__0mJj0ooO0ooo0ooO2<HH0e[[0aS31@000b4T
0bU51XaA0h@`0]kK0nmM0ooo0oNn0kFf0dYY0a221@000`Q10a220e[[0e[;0[gg0oNN0ooo0nmm0nLl
0nLL0XaA0haa0c660`0P6?oo000Gool3oml5aSP9H``36<<3000224432643F//3DZX3_ML3aQP3mkh5
ool3cWT3Jdd36><500038B@3Q103Nnl3e[X3oml2ool3oml9aQP3F^/26<<600038B@3:DD5S543Q303
g]/3ked3ool3mkh3]KH2BVT34886000324434882F^/3F//3_OL3mih3ool3kgd2ic`3ia`3S543S743
<HH30208ool3oml5aSP9H``36<<2000324432643F//3DZX3_ML2aQP3mkh6ool3cWT3Jdd26><60003
8B@3Q103Nnl3e[X2oml3ool3oml9aQP2F^/36<<600038B@3:DD5S543Q303g]/3ked3ool2mkh3]KH3
BVT34886000324424883F^/3F//3_OL3mih3ool2kgd3ic`3ia`3S543S743<HH20209ool2oml6aSP9
H``26<<3000324432643F//3DZX2_ML3aQP3mkh6ool3cWT2Jdd36><600038B@3Q102Nnl3e[X3oml3
ool3oml8aQP3F^/36<<600038B@2:DD6S543Q303g]/3ked2ool3mkh3]KH3BVT34885000324434883
F^/3F//3_OL2mih3ool3kgd3ic`3ia`3S543S742<HH30208ool3oml6aSP8H``36<<3000324432642
F//3DZX3_ML3aQP3mkh6ool2cWT3Jdd36><600038B@2Q103Nnl3e[X3oml3ool3oml8aQP3F^/36<<5
00038B@3:DD6S543Q302g]/3ked3ool3mkh3]KH3BVT34885000324434883F^/3F//2_OL3mih3ool3
kgd3ic`3ia`2S543S743<HH3020Hool001Ooo`<000<H``9[K@?>F@?g_P?oo`?_G@?W70:<D@><L@<a
QP<080<000<080<8H@9BRPI:J@=:B@>]M@?_O@Goo`?g_P?_O@?W?0>DTP:D/P>Ld`>Ll`>U50<ii`<8
@@D000<aQP>D/P?W70Goo`?Nf`?F^PIkc`<Q90<0808000<080<8H@<@XP<H``<Q108Q90<YA@<YI@><
L@J<D@;Nn`?_O@?og`?oo`?og`?gWPSoo`<0008H``=[K@?>F@?g_P?oo`?_G@;W70><D@><L@<aQP<0
80<0008080<8H@=BRPI:J@=:B@:]M@?_O@Koo`?g_P?_O@?W?0:DTP>D/P>Ld`>Ll`>U50<ii`88@@H0
00<aQP>D/P?W70Goo`?Nf`?F^PIkc`8Q90<080<000<080<8H@<@XP<H``8Q10<Q90<YA@<YI@><L@F<
D@?Nn`?_O@?og`?oo`?og`;gWPWoo`8000<H``=[K@?>F@?g_P?oo`;_G@?W70><D@><L@<aQP<08080
00<080<8H@=BRPI:J@9:B@>]M@?_O@Koo`?g_P;_O@?W?0>DTP>D/P>Ld`>Ll`>U508ii`<8@@H000<a
QP>D/P;W70Koo`?Nf`?F^PEkc`<Q90<080<000<080<8H@8@XP<H``<Q10<Q90<YA@<YI@:<L@J<D@?N
n`?_O@?og`?oo`;og`?gWPSoo`<000<H``=[K@?>F@;g_P?oo`?_G@?W70><D@><L@8aQP<080<000<0
80<8H@=BRPE:J@=:B@>]M@?_O@Koo`;g_P?_O@?W?0>DTP>D/P>Ld`:Ll`>U50<ii`<8@@H0008aQP>D
/P?W70Koo`?Nf`;F^PIkc`<Q90<080<000<08088H@<@XP<H``<Q10<Q90<YA@8YI@><L@J<D@?Nn`?_
O@;og`?oo`?og`?gWQSoo`005ooo0`000aS30V]]0liI0oNn0ooo0nmM0nLL0XaA0haa0c660`0P0`00
0`0P0`QQ0U::1TYY0dY90jee0nmm1Ooo0oNn0nmm0nLl0iBB0YBb0icC0icc0jDD0cWW0`Q11@000c66
0iBb0nLL1Ooo0mkK0mJj1W_?0b4T0`0P0P000`0P0`QQ0a2R0aS30b440R4T0bU50bUU0haa1XaA0]kk
0nmm0ooO0ooo0ooO0oNN2?oo0`000QS30f]]0liI0oNn0ooo0nmM0^LL0haA0haa0c660`0P0`000P0P
0`QQ0e::1TYY0dY90Zee0nmm1_oo0oNn0nmm0nLl0YBB0iBb0icC0icc0jDD0cWW0PQ11P000c660iBb
0nLL1Ooo0mkK0mJj1W_?0R4T0`0P0`000`0P0`QQ0a2R0aS30R440b4T0bU50bUU0haa1HaA0mkk0nmm
0ooO0ooo0ooO0_NN2Ooo0P000aS30f]]0liI0oNn0ooo0^mM0nLL0haA0haa0c660`0P0P000`0P0`QQ
0e::1TYY0TY90jee0nmm1_oo0oNn0^mm0nLl0iBB0iBb0icC0icc0jDD0SWW0`Q11P000c660iBb0^LL
1_oo0mkK0mJj1G_?0b4T0`0P0`000`0P0`QQ0Q2R0aS30b440b4T0bU50bUU0Xaa1XaA0mkk0nmm0ooO
0ooo0_oO0oNN2?oo0`000aS30f]]0liI0_Nn0ooo0nmM0nLL0haA0haa0S660`0P0`000`0P0`QQ0e::
1DYY0dY90jee0nmm1_oo0_Nn0nmm0nLl0iBB0iBb0icC0Ycc0jDD0cWW0`Q11P000S660iBb0nLL1_oo
0mkK0]Jj1W_?0b4T0`0P0`000`0P0PQQ0a2R0aS30b440b4T0bU50RUU0haa1XaA0mkk0nmm0_oO0ooo
0ooO0oNN6?oo000Gool300036<<2Jfd3cUT3mkh3ool3ked3ia`2S543S743<HH30203000302032642
DXX6BVT3BTT3[GD3kgd5ool3mkh3kgd3ic`3U982U;83W=<3W?<3YA@3>NL324450003<HH3U;83ia`5
ool3g]/3e[X6Nll38B@302020003020326434:836<<38@@28B@3:DD3:FD3S746S542g_/3kgd3oml3
ool3oml3mih8ool300026<<3Jfd3cUT3mkh3ool3ked2ia`3S543S743<HH30203000202032643DXX6
BVT3BTT2[GD3kgd6ool3mkh3kgd3ic`2U983U;83W=<3W?<3YA@3>NL224460003<HH3U;83ia`5ool3
g]/3e[X6Nll28B@302030003020326434:836<<28@@38B@3:DD3:FD3S745S543g_/3kgd3oml3ool3
oml2mih9ool200036<<3Jfd3cUT3mkh3ool2ked3ia`3S543S743<HH30202000302032643DXX6BVT2
BTT3[GD3kgd6ool3mkh2kgd3ic`3U983U;83W=<3W?<3YA@2>NL324460003<HH3U;82ia`6ool3g]/3
e[X5Nll38B@302030003020326424:836<<38@@38B@3:DD3:FD2S746S543g_/3kgd3oml3ool2oml3
mih8ool300036<<3Jfd3cUT2mkh3ool3ked3ia`3S543S742<HH30203000302032643DXX5BVT3BTT3
[GD3kgd6ool2mkh3kgd3ic`3U983U;83W=<2W?<3YA@3>NL324460002<HH3U;83ia`6ool3g]/2e[X6
Nll38B@302030003020226434:836<<38@@38B@3:DD2:FD3S746S543g_/3kgd2oml3ool3oml3mihH
ool001Ooo`<000<H``9[K@?>F@?g_P?oo`?_G@?W70:<D@><L@<aQP<080<000<080<8H@9BRPI:J@=:
B@>]M@?_O@Goo`?g_P?_O@?W?0>DTP:D/P>Ld`>Ll`>U50<ii`<8@@D000<aQP>D/P?W70Goo`?Nf`?F
^PIkc`<Q90<0808000<080<8H@<@XP<H``<Q108Q90<YA@<YI@><L@J<D@;Nn`?_O@?og`?oo`?og`?g
WPSoo`<0008H``=[K@?>F@?g_P?oo`?_G@;W70><D@><L@<aQP<080<0008080<8H@=BRPI:J@=:B@:]
M@?_O@Koo`?g_P?_O@?W?0:DTP>D/P>Ld`>Ll`>U50<ii`88@@H000<aQP>D/P?W70Goo`?Nf`?F^PIk
c`8Q90<080<000<080<8H@<@XP<H``8Q10<Q90<YA@<YI@><L@F<D@?Nn`?_O@?og`?oo`?og`;gWPWo
o`8000<H``=[K@?>F@?g_P?oo`;_G@?W70><D@><L@<aQP<0808000<080<8H@=BRPI:J@9:B@>]M@?_
O@Koo`?g_P;_O@?W?0>DTP>D/P>Ld`>Ll`>U508ii`<8@@H000<aQP>D/P;W70Koo`?Nf`?F^PEkc`<Q
90<080<000<080<8H@8@XP<H``<Q10<Q90<YA@<YI@:<L@J<D@?Nn`?_O@?og`?oo`;og`?gWPSoo`<0
00<H``=[K@?>F@;g_P?oo`?_G@?W70><D@><L@8aQP<080<000<080<8H@=BRPE:J@=:B@>]M@?_O@Ko
o`;g_P?_O@?W?0>DTP>D/P>Ld`:Ll`>U50<ii`<8@@H0008aQP>D/P?W70Koo`?Nf`;F^PIkc`<Q90<0
80<000<08088H@<@XP<H``<Q10<Q90<YA@8YI@><L@J<D@?Nn`?_O@;og`?oo`?og`?gWQSoo`005ooo
0`000aS30V]]0liI0oNn0ooo0nmM0nLL0XaA0haa0c660`0P0`000`0P0`QQ0U::1TYY0dY90jee0nmm
1Ooo0oNn0nmm0nLl0iBB0YBb0icC0icc0jDD0cWW0`Q11@000c660iBb0nLL1Ooo0mkK0mJj1W_?0b4T
0`0P0P000`0P0`QQ0a2R0aS30b440R4T0bU50bUU0haa1XaA0]kk0nmm0ooO0ooo0ooO0oNN2?oo0`00
0QS30f]]0liI0oNn0ooo0nmM0^LL0haA0haa0c660`0P0`000P0P0`QQ0e::1TYY0dY90Zee0nmm1_oo
0oNn0nmm0nLl0YBB0iBb0icC0icc0jDD0cWW0PQ11P000c660iBb0nLL1Ooo0mkK0mJj1W_?0R4T0`0P
0`000`0P0`QQ0a2R0aS30R440b4T0bU50bUU0haa1HaA0mkk0nmm0ooO0ooo0ooO0_NN2Ooo0P000aS3
0f]]0liI0oNn0ooo0^mM0nLL0haA0haa0c660`0P0P000`0P0`QQ0e::1TYY0TY90jee0nmm1_oo0oNn
0^mm0nLl0iBB0iBb0icC0icc0jDD0SWW0`Q11P000c660iBb0^LL1_oo0mkK0mJj1G_?0b4T0`0P0`00
0`0P0`QQ0Q2R0aS30b440b4T0bU50bUU0Xaa1XaA0mkk0nmm0ooO0ooo0_oO0oNN2?oo0`000aS30f]]
0liI0_Nn0ooo0nmM0nLL0haA0haa0S660`0P0`000`0P0`QQ0e::1DYY0dY90jee0nmm1_oo0_Nn0nmm
0nLl0iBB0iBb0icC0Ycc0jDD0cWW0`Q11P000S660iBb0nLL1_oo0mkK0]Jj1W_?0b4T0`0P0`000`0P
0PQQ0a2R0aS30b440b4T0bU50RUU0haa1XaA0mkk0nmm0_oO0ooo0ooO0oNN6?oo000Gool300036<<2
Jfd3cUT3mkh3ool3ked3ia`2S543S743<HH30203000302032642DXX6BVT3BTT3[GD3kgd5ool3mkh3
kgd3ic`3U982U;83W=<3W?<3YA@3>NL324450003<HH3U;83ia`5ool3g]/3e[X6Nll38B@302020003
020326434:836<<38@@28B@3:DD3:FD3S746S542g_/3kgd3oml3ool3oml3mih8ool300026<<3Jfd3
cUT3mkh3ool3ked2ia`3S543S743<HH30203000202032643DXX6BVT3BTT2[GD3kgd6ool3mkh3kgd3
ic`2U983U;83W=<3W?<3YA@3>NL224460003<HH3U;83ia`5ool3g]/3e[X6Nll28B@3020300030203
26434:836<<28@@38B@3:DD3:FD3S745S543g_/3kgd3oml3ool3oml2mih9ool200036<<3Jfd3cUT3
mkh3ool2ked3ia`3S543S743<HH30202000302032643DXX6BVT2BTT3[GD3kgd6ool3mkh2kgd3ic`3
U983U;83W=<3W?<3YA@2>NL324460003<HH3U;82ia`6ool3g]/3e[X5Nll38B@30203000302032642
4:836<<38@@38B@3:DD3:FD2S746S543g_/3kgd3oml3ool2oml3mih8ool300036<<3Jfd3cUT2mkh3
ool3ked3ia`3S543S742<HH30203000302032643DXX5BVT3BTT3[GD3kgd6ool2mkh3kgd3ic`3U983
U;83W=<2W?<3YA@3>NL324460002<HH3U;83ia`6ool3g]/2e[X6Nll38B@302030003020226434:83
6<<38@@38B@3:DD2:FD3S746S543g_/3kgd2oml3ool3oml3mihHool001Ooo`<000<H``9[K@?>F@?g
_P?oo`?_G@?W70:<D@><L@<aQP<080<000<080<8H@9BRPI:J@=:B@>]M@?_O@Goo`?g_P?_O@?W?0>D
TP:D/P>Ld`>Ll`>U50<ii`<8@@D000<aQP>D/P?W70Goo`?Nf`?F^PIkc`<Q90<0808000<080<8H@<@
XP<H``<Q108Q90<YA@<YI@><L@J<D@;Nn`?_O@?og`?oo`?og`?gWPSoo`<0008H``=[K@?>F@?g_P?o
o`?_G@;W70><D@><L@<aQP<080<0008080<8H@=BRPI:J@=:B@:]M@?_O@Koo`?g_P?_O@?W?0:DTP>D
/P>Ld`>Ll`>U50<ii`88@@H000<aQP>D/P?W70Goo`?Nf`?F^PIkc`8Q90<080<000<080<8H@<@XP<H
``8Q10<Q90<YA@<YI@><L@F<D@?Nn`?_O@?og`?oo`?og`;gWPWoo`8000<H``=[K@?>F@?g_P?oo`;_
G@?W70><D@><L@<aQP<0808000<080<8H@=BRPI:J@9:B@>]M@?_O@Koo`?g_P;_O@?W?0>DTP>D/P>L
d`>Ll`>U508ii`<8@@H000<aQP>D/P;W70Koo`?Nf`?F^PEkc`<Q90<080<000<080<8H@8@XP<H``<Q
10<Q90<YA@<YI@:<L@J<D@?Nn`?_O@?og`?oo`;og`?gWPSoo`<000<H``=[K@?>F@;g_P?oo`?_G@?W
70><D@><L@8aQP<080<000<080<8H@=BRPE:J@=:B@>]M@?_O@Koo`;g_P?_O@?W?0>DTP>D/P>Ld`:L
l`>U50<ii`<8@@H0008aQP>D/P?W70Koo`?Nf`;F^PIkc`<Q90<080<000<08088H@<@XP<H``<Q10<Q
90<YA@8YI@><L@J<D@?Nn`?_O@;og`?oo`?og`?gWQSoo`005ooo0`000aS30V]]0liI0oNn0ooo0nmM
0nLL0XaA0haa0c660`0P0`000`0P0`QQ0U::1TYY0dY90jee0nmm1Ooo0oNn0nmm0nLl0iBB0YBb0icC
0icc0jDD0cWW0`Q11@000c660iBb0nLL1Ooo0mkK0mJj1W_?0b4T0`0P0P000`0P0`QQ0a2R0aS30b44
0R4T0bU50bUU0haa1XaA0]kk0nmm0ooO0ooo0ooO0oNN2?oo0`000QS30f]]0liI0oNn0ooo0nmM0^LL
0haA0haa0c660`0P0`000P0P0`QQ0e::1TYY0dY90Zee0nmm1_oo0oNn0nmm0nLl0YBB0iBb0icC0icc
0jDD0cWW0PQ11P000c660iBb0nLL1Ooo0mkK0mJj1W_?0R4T0`0P0`000`0P0`QQ0a2R0aS30R440b4T
0bU50bUU0haa1HaA0mkk0nmm0ooO0ooo0ooO0_NN2Ooo0P000aS30f]]0liI0oNn0ooo0^mM0nLL0haA
0haa0c660`0P0P000`0P0`QQ0e::1TYY0TY90jee0nmm1_oo0oNn0^mm0nLl0iBB0iBb0icC0icc0jDD
0SWW0`Q11P000c660iBb0^LL1_oo0mkK0mJj1G_?0b4T0`0P0`000`0P0`QQ0Q2R0aS30b440b4T0bU5
0bUU0Xaa1XaA0mkk0nmm0ooO0ooo0_oO0oNN2?oo0`000aS30f]]0liI0_Nn0ooo0nmM0nLL0haA0haa
0S660`0P0`000`0P0`QQ0e::1DYY0dY90jee0nmm1_oo0_Nn0nmm0nLl0iBB0iBb0icC0Ycc0jDD0cWW
0`Q11P000S660iBb0nLL1_oo0mkK0]Jj1W_?0b4T0`0P0`000`0P0PQQ0a2R0aS30b440b4T0bU50RUU
0haa1XaA0mkk0nmm0_oO0ooo0ooO0oNN6?oo000Gool300036<<2Jfd3cUT3mkh3ool3ked3ia`2S543
S743<HH30203000302032642DXX6BVT3BTT3[GD3kgd5ool3mkh3kgd3ic`3U982U;83W=<3W?<3YA@3
>NL324450003<HH3U;83ia`5ool3g]/3e[X6Nll38B@302020003020326434:836<<38@@28B@3:DD3
:FD3S746S542g_/3kgd3oml3ool3oml3mih8ool300026<<3Jfd3cUT3mkh3ool3ked2ia`3S543S743
<HH30203000202032643DXX6BVT3BTT2[GD3kgd6ool3mkh3kgd3ic`2U983U;83W=<3W?<3YA@3>NL2
24460003<HH3U;83ia`5ool3g]/3e[X6Nll28B@302030003020326434:836<<28@@38B@3:DD3:FD3
S745S543g_/3kgd3oml3ool3oml2mih9ool200036<<3Jfd3cUT3mkh3ool2ked3ia`3S543S743<HH3
0202000302032643DXX6BVT2BTT3[GD3kgd6ool3mkh2kgd3ic`3U983U;83W=<3W?<3YA@2>NL32446
0003<HH3U;82ia`6ool3g]/3e[X5Nll38B@302030003020326424:836<<38@@38B@3:DD3:FD2S746
S543g_/3kgd3oml3ool2oml3mih8ool300036<<3Jfd3cUT2mkh3ool3ked3ia`3S543S742<HH30203
000302032643DXX5BVT3BTT3[GD3kgd6ool2mkh3kgd3ic`3U983U;83W=<2W?<3YA@3>NL324460002
<HH3U;83ia`6ool3g]/2e[X6Nll38B@302030003020226434:836<<38@@38B@3:DD2:FD3S746S543
g_/3kgd2oml3ool3oml3mihHool001Ooo`<000<H``9[K@?>F@?g_P?oo`?_G@?W70:<D@><L@<aQP<0
80<000<080<8H@9BRPI:J@=:B@>]M@?_O@Goo`?g_P?_O@?W?0>DTP:D/P>Ld`>Ll`>U50<ii`<8@@D0
00<aQP>D/P?W70Goo`?Nf`?F^PIkc`<Q90<0808000<080<8H@<@XP<H``<Q108Q90<YA@<YI@><L@J<
D@;Nn`?_O@?og`?oo`?og`?gWPSoo`<0008H``=[K@?>F@?g_P?oo`?_G@;W70><D@><L@<aQP<080<0
008080<8H@=BRPI:J@=:B@:]M@?_O@Koo`?g_P?_O@?W?0:DTP>D/P>Ld`>Ll`>U50<ii`88@@H000<a
QP>D/P?W70Goo`?Nf`?F^PIkc`8Q90<080<000<080<8H@<@XP<H``8Q10<Q90<YA@<YI@><L@F<D@?N
n`?_O@?og`?oo`?og`;gWPWoo`8000<H``=[K@?>F@?g_P?oo`;_G@?W70><D@><L@<aQP<0808000<0
80<8H@=BRPI:J@9:B@>]M@?_O@Koo`?g_P;_O@?W?0>DTP>D/P>Ld`>Ll`>U508ii`<8@@H000<aQP>D
/P;W70Koo`?Nf`?F^PEkc`<Q90<080<000<080<8H@8@XP<H``<Q10<Q90<YA@<YI@:<L@J<D@?Nn`?_
O@?og`?oo`;og`?gWPSoo`<000<H``=[K@?>F@;g_P?oo`?_G@?W70><D@><L@8aQP<080<000<080<8
H@=BRPE:J@=:B@>]M@?_O@Koo`;g_P?_O@?W?0>DTP>D/P>Ld`:Ll`>U50<ii`<8@@H0008aQP>D/P?W
70Koo`?Nf`;F^PIkc`<Q90<080<000<08088H@<@XP<H``<Q10<Q90<YA@8YI@><L@J<D@?Nn`?_O@;o
g`?oo`?og`?gWQSoo`005ooo0`000aS30V]]0liI0oNn0ooo0nmM0nLL0XaA0haa0c660`0P0`000`0P
0`QQ0U::1TYY0dY90jee0nmm1Ooo0oNn0nmm0nLl0iBB0YBb0icC0icc0jDD0cWW0`Q11@000c660iBb
0nLL1Ooo0mkK0mJj1W_?0b4T0`0P0P000`0P0`QQ0a2R0aS30b440R4T0bU50bUU0haa1XaA0]kk0nmm
0ooO0ooo0ooO0oNN2?oo0`000QS30f]]0liI0oNn0ooo0nmM0^LL0haA0haa0c660`0P0`000P0P0`QQ
0e::1TYY0dY90Zee0nmm1_oo0oNn0nmm0nLl0YBB0iBb0icC0icc0jDD0cWW0PQ11P000c660iBb0nLL
1Ooo0mkK0mJj1W_?0R4T0`0P0`000`0P0`QQ0a2R0aS30R440b4T0bU50bUU0haa1HaA0mkk0nmm0ooO
0ooo0ooO0_NN2Ooo0P000aS30f]]0liI0oNn0ooo0^mM0nLL0haA0haa0c660`0P0P000`0P0`QQ0e::
1TYY0TY90jee0nmm1_oo0oNn0^mm0nLl0iBB0iBb0icC0icc0jDD0SWW0`Q11P000c660iBb0^LL1_oo
0mkK0mJj1G_?0b4T0`0P0`000`0P0`QQ0Q2R0aS30b440b4T0bU50bUU0Xaa1XaA0mkk0nmm0ooO0ooo
0_oO0oNN2?oo0`000aS30f]]0liI0_Nn0ooo0nmM0nLL0haA0haa0S660`0P0`000`0P0`QQ0e::1DYY
0dY90jee0nmm1_oo0_Nn0nmm0nLl0iBB0iBb0icC0Ycc0jDD0cWW0`Q11P000S660iBb0nLL1_oo0mkK
0]Jj1W_?0b4T0`0P0`000`0P0PQQ0a2R0aS30b440b4T0bU50RUU0haa1XaA0mkk0nmm0_oO0ooo0ooO
0oNN6?oo000Gool300036<<2Jfd3cUT3mkh3ool3ked3ia`2S543S743<HH30203000302032642DXX6
BVT3BTT3[GD3kgd5ool3mkh3kgd3ic`3U982U;83W=<3W?<3YA@3>NL324450003<HH3U;83ia`5ool3
g]/3e[X6Nll38B@302020003020326434:836<<38@@28B@3:DD3:FD3S746S542g_/3kgd3oml3ool3
oml3mih8ool300026<<3Jfd3cUT3mkh3ool3ked2ia`3S543S743<HH30203000202032643DXX6BVT3
BTT2[GD3kgd6ool3mkh3kgd3ic`2U983U;83W=<3W?<3YA@3>NL224460003<HH3U;83ia`5ool3g]/3
e[X6Nll28B@302030003020326434:836<<28@@38B@3:DD3:FD3S745S543g_/3kgd3oml3ool3oml2
mih9ool200036<<3Jfd3cUT3mkh3ool2ked3ia`3S543S743<HH30202000302032643DXX6BVT2BTT3
[GD3kgd6ool3mkh2kgd3ic`3U983U;83W=<3W?<3YA@2>NL324460003<HH3U;82ia`6ool3g]/3e[X5
Nll38B@302030003020326424:836<<38@@38B@3:DD3:FD2S746S543g_/3kgd3oml3ool2oml3mih8
ool300036<<3Jfd3cUT2mkh3ool3ked3ia`3S543S742<HH30203000302032643DXX5BVT3BTT3[GD3
kgd6ool2mkh3kgd3ic`3U983U;83W=<2W?<3YA@3>NL324460002<HH3U;83ia`6ool3g]/2e[X6Nll3
8B@302030003020226434:836<<38@@38B@3:DD2:FD3S746S543g_/3kgd2oml3ool3oml3mihHool0
01Ooo`?_G@?W70:<L@<aQP<080<000<080<8H@8@XP<H``<Q10<Q90<YA@>4<0?Nf`;og`?oo`?og`?g
WP?_G@>Ld`8ia`<8@@<000<080HaYP:Ld`?W?0Koo`?Nf`?F^P;FVP=cSP<Q10<@PPH0008080I220>U
=0?_G@Koo`;F^P=c[P=kc`<Q90<080<0008080<8H@<@XP=S;0?6>0?g_P;oo`?_G@?W?0?Nn`?Nf`=k
k`Soo`?_G@;W70><L@<aQP<080<000<08088H@<@XP<H``<Q10<Q90<YA@:4<0?Nf`?og`?oo`?og`?g
WP;_G@>Ld`<ia`<8@@<000<080DaYP>Ld`?W?0Koo`?Nf`;F^P?FVP=cSP<Q10<@PPD000<080I220>U
=0?_G@Goo`?F^P=c[P=kc`<Q90<0808000<080<8H@<@XP=S;0?6>0;g_P?oo`?_G@?W?0?Nn`?Nf`9k
k`Woo`;_G@?W70><L@<aQP<080<0008080<8H@<@XP<H``<Q10<Q908YA@>4<0?Nf`?og`?oo`?og`;g
WP?_G@>Ld`<ia`<8@@<0008080HaYP>Ld`?W?0Koo`;Nf`?F^P?FVP=cSP<Q10<@PPD000<080I220>U
=0;_G@Koo`?F^P=c[P=kc`8Q90<080<000<080<8H@<@XP9S;0?6>0?g_P?oo`?_G@?W?0?Nn`;Nf`=k
k`Soo`?_G@?W70><L@<aQP8080<000<080<8H@<@XP<H``8Q10<Q90<YA@>4<0?Nf`?og`?oo`;og`?g
WP?_G@>Ld`<ia`<8@@8000<080HaYP>Ld`?W?0Goo`?Nf`?F^P?FVP=cSP8Q10<@PPH000<080E220>U
=0?_G@Koo`?F^P=c[P9kc`<Q90<080<000<080<8H@8@XP=S;0?6>0?g_P?oo`?_G@;W?0?Nn`?Nf`=k
kaSoo`005ooo0nmM0nLL0Xaa0c660`0P0`000`0P0`QQ0Q2R0aS30b440b4T0bU50h@`0mkK0_oO0ooo
0ooO0oNN0nmM0icC0SW70`Q10`000`0P1S6V0YcC0nLl1_oo0mkK0mJj0]JJ0g>>0b440a221P000P0P
1T880jDd0nmM1_oo0]Jj0g>^0g_?0b4T0`0P0`000P0P0`QQ0a2R0f</0lHh0oNn0_oo0nmM0nLl0mkk
0mkK0g__2?oo0nmM0^LL0haa0c660`0P0`000`0P0PQQ0a2R0aS30b440b4T0bU50X@`0mkK0ooO0ooo
0ooO0oNN0^mM0icC0cW70`Q10`000`0P1C6V0icC0nLl1_oo0mkK0]Jj0mJJ0g>>0b440a221@000`0P
1T880jDd0nmM1Ooo0mJj0g>^0g_?0b4T0`0P0P000`0P0`QQ0a2R0f</0lHh0_Nn0ooo0nmM0nLl0mkk
0mkK0W__2Ooo0^mM0nLL0haa0c660`0P0`000P0P0`QQ0a2R0aS30b440b4T0RU50h@`0mkK0ooO0ooo
0ooO0_NN0nmM0icC0cW70`Q10`000P0P1S6V0icC0nLl1_oo0]kK0mJj0mJJ0g>>0b440a221@000`0P
1T880jDd0^mM1_oo0mJj0g>^0g_?0R4T0`0P0`000`0P0`QQ0a2R0V</0lHh0oNn0ooo0nmM0nLl0mkk
0]kK0g__2?oo0nmM0nLL0haa0c660P0P0`000`0P0`QQ0a2R0aS30R440b4T0bU50h@`0mkK0ooO0ooo
0_oO0oNN0nmM0icC0cW70`Q10P000`0P1S6V0icC0nLl1Ooo0mkK0mJj0mJJ0g>>0R440a221P000`0P
1D880jDd0nmM1_oo0mJj0g>^0W_?0b4T0`0P0`000`0P0`QQ0Q2R0f</0lHh0oNn0ooo0nmM0^Ll0mkk
0mkK0g__6?oo000Gool3ked3ia`2S743<HH302030003020326424:836<<38@@38B@3:DD3Q303g]/2
oml3ool3oml3mih3ked3W=<2>LL3244300030206<JH2W=<3ic`6ool3g]/3e[X2eYX3Lhh38@@34886
00020206@PP3YC@3ked6ool2e[X3Ljh3Nll38B@302030002020326434:83Hb`3aSP3mkh2ool3ked3
ic`3g_/3g]/3Nnl8ool3ked2ia`3S743<HH302030003020226434:836<<38@@38B@3:DD2Q303g]/3
oml3ool3oml3mih2ked3W=<3>LL3244300030205<JH3W=<3ic`6ool3g]/2e[X3eYX3Lhh38@@34885
00030206@PP3YC@3ked5ool3e[X3Ljh3Nll38B@302020003020326434:83Hb`3aSP2mkh3ool3ked3
ic`3g_/3g]/2Nnl9ool2ked3ia`3S743<HH302030002020326434:836<<38@@38B@2:DD3Q303g]/3
oml3ool3oml2mih3ked3W=<3>LL3244300020206<JH3W=<3ic`6ool2g]/3e[X3eYX3Lhh38@@34885
00030206@PP3YC@2ked6ool3e[X3Ljh3Nll28B@302030003020326434:82Hb`3aSP3mkh3ool3ked3
ic`3g_/2g]/3Nnl8ool3ked3ia`3S743<HH202030003020326434:836<<28@@38B@3:DD3Q303g]/3
oml3ool2oml3mih3ked3W=<3>LL3244200030206<JH3W=<3ic`5ool3g]/3e[X3eYX3Lhh28@@34886
00030205@PP3YC@3ked6ool3e[X3Ljh2Nll38B@302030003020326424:83Hb`3aSP3mkh3ool3ked2
ic`3g_/3g]/3NnlHool001Ooo`?_G@?W70:<L@<aQP<080<000<080<8H@8@XP<H``<Q10<Q90<YA@>4
<0?Nf`;og`?oo`?og`?gWP?_G@>Ld`8ia`<8@@<000<080HaYP:Ld`?W?0Koo`?Nf`?F^P;FVP=cSP<Q
10<@PPH0008080I220>U=0?_G@Koo`;F^P=c[P=kc`<Q90<080<0008080<8H@<@XP=S;0?6>0?g_P;o
o`?_G@?W?0?Nn`?Nf`=kk`Soo`?_G@;W70><L@<aQP<080<000<08088H@<@XP<H``<Q10<Q90<YA@:4
<0?Nf`?og`?oo`?og`?gWP;_G@>Ld`<ia`<8@@<000<080DaYP>Ld`?W?0Koo`?Nf`;F^P?FVP=cSP<Q
10<@PPD000<080I220>U=0?_G@Goo`?F^P=c[P=kc`<Q90<0808000<080<8H@<@XP=S;0?6>0;g_P?o
o`?_G@?W?0?Nn`?Nf`9kk`Woo`;_G@?W70><L@<aQP<080<0008080<8H@<@XP<H``<Q10<Q908YA@>4
<0?Nf`?og`?oo`?og`;gWP?_G@>Ld`<ia`<8@@<0008080HaYP>Ld`?W?0Koo`;Nf`?F^P?FVP=cSP<Q
10<@PPD000<080I220>U=0;_G@Koo`?F^P=c[P=kc`8Q90<080<000<080<8H@<@XP9S;0?6>0?g_P?o
o`?_G@?W?0?Nn`;Nf`=kk`Soo`?_G@?W70><L@<aQP8080<000<080<8H@<@XP<H``8Q10<Q90<YA@>4
<0?Nf`?og`?oo`;og`?gWP?_G@>Ld`<ia`<8@@8000<080HaYP>Ld`?W?0Goo`?Nf`?F^P?FVP=cSP8Q
10<@PPH000<080E220>U=0?_G@Koo`?F^P=c[P9kc`<Q90<080<000<080<8H@8@XP=S;0?6>0?g_P?o
o`?_G@;W?0?Nn`?Nf`=kkaSoo`005ooo0nmM0nLL0Xaa0c660`0P0`000`0P0`QQ0Q2R0aS30b440b4T
0bU50h@`0mkK0_oO0ooo0ooO0oNN0nmM0icC0SW70`Q10`000`0P1S6V0YcC0nLl1_oo0mkK0mJj0]JJ
0g>>0b440a221P000P0P1T880jDd0nmM1_oo0]Jj0g>^0g_?0b4T0`0P0`000P0P0`QQ0a2R0f</0lHh
0oNn0_oo0nmM0nLl0mkk0mkK0g__2?oo0nmM0^LL0haa0c660`0P0`000`0P0PQQ0a2R0aS30b440b4T
0bU50X@`0mkK0ooO0ooo0ooO0oNN0^mM0icC0cW70`Q10`000`0P1C6V0icC0nLl1_oo0mkK0]Jj0mJJ
0g>>0b440a221@000`0P1T880jDd0nmM1Ooo0mJj0g>^0g_?0b4T0`0P0P000`0P0`QQ0a2R0f</0lHh
0_Nn0ooo0nmM0nLl0mkk0mkK0W__2Ooo0^mM0nLL0haa0c660`0P0`000P0P0`QQ0a2R0aS30b440b4T
0RU50h@`0mkK0ooO0ooo0ooO0_NN0nmM0icC0cW70`Q10`000P0P1S6V0icC0nLl1_oo0]kK0mJj0mJJ
0g>>0b440a221@000`0P1T880jDd0^mM1_oo0mJj0g>^0g_?0R4T0`0P0`000`0P0`QQ0a2R0V</0lHh
0oNn0ooo0nmM0nLl0mkk0]kK0g__2?oo0nmM0nLL0haa0c660P0P0`000`0P0`QQ0a2R0aS30R440b4T
0bU50h@`0mkK0ooO0ooo0_oO0oNN0nmM0icC0cW70`Q10P000`0P1S6V0icC0nLl1Ooo0mkK0mJj0mJJ
0g>>0R440a221P000`0P1D880jDd0nmM1_oo0mJj0g>^0W_?0b4T0`0P0`000`0P0`QQ0Q2R0f</0lHh
0oNn0ooo0nmM0^Ll0mkk0mkK0g__6?oo000Gool3ked3ia`2S743<HH302030003020326424:836<<3
8@@38B@3:DD3Q303g]/2oml3ool3oml3mih3ked3W=<2>LL3244300030206<JH2W=<3ic`6ool3g]/3
e[X2eYX3Lhh38@@3488600020206@PP3YC@3ked6ool2e[X3Ljh3Nll38B@302030002020326434:83
Hb`3aSP3mkh2ool3ked3ic`3g_/3g]/3Nnl8ool3ked2ia`3S743<HH302030003020226434:836<<3
8@@38B@3:DD2Q303g]/3oml3ool3oml3mih2ked3W=<3>LL3244300030205<JH3W=<3ic`6ool3g]/2
e[X3eYX3Lhh38@@3488500030206@PP3YC@3ked5ool3e[X3Ljh3Nll38B@302020003020326434:83
Hb`3aSP2mkh3ool3ked3ic`3g_/3g]/2Nnl9ool2ked3ia`3S743<HH302030002020326434:836<<3
8@@38B@2:DD3Q303g]/3oml3ool3oml2mih3ked3W=<3>LL3244300020206<JH3W=<3ic`6ool2g]/3
e[X3eYX3Lhh38@@3488500030206@PP3YC@2ked6ool3e[X3Ljh3Nll28B@302030003020326434:82
Hb`3aSP3mkh3ool3ked3ic`3g_/2g]/3Nnl8ool3ked3ia`3S743<HH202030003020326434:836<<2
8@@38B@3:DD3Q303g]/3oml3ool2oml3mih3ked3W=<3>LL3244200030206<JH3W=<3ic`5ool3g]/3
e[X3eYX3Lhh28@@3488600030205@PP3YC@3ked6ool3e[X3Ljh2Nll38B@302030003020326424:83
Hb`3aSP3mkh3ool3ked2ic`3g_/3g]/3NnlHool001Ooo`?_G@?W70:<L@<aQP<080<000<080<8H@8@
XP<H``<Q10<Q90<YA@>4<0?Nf`;og`?oo`?og`?gWP?_G@>Ld`8ia`<8@@<000<080HaYP:Ld`?W?0Ko
o`?Nf`?F^P;FVP=cSP<Q10<@PPH0008080I220>U=0?_G@Koo`;F^P=c[P=kc`<Q90<080<0008080<8
H@<@XP=S;0?6>0?g_P;oo`?_G@?W?0?Nn`?Nf`=kk`Soo`?_G@;W70><L@<aQP<080<000<08088H@<@
XP<H``<Q10<Q90<YA@:4<0?Nf`?og`?oo`?og`?gWP;_G@>Ld`<ia`<8@@<000<080DaYP>Ld`?W?0Ko
o`?Nf`;F^P?FVP=cSP<Q10<@PPD000<080I220>U=0?_G@Goo`?F^P=c[P=kc`<Q90<0808000<080<8
H@<@XP=S;0?6>0;g_P?oo`?_G@?W?0?Nn`?Nf`9kk`Woo`;_G@?W70><L@<aQP<080<0008080<8H@<@
XP<H``<Q10<Q908YA@>4<0?Nf`?og`?oo`?og`;gWP?_G@>Ld`<ia`<8@@<0008080HaYP>Ld`?W?0Ko
o`;Nf`?F^P?FVP=cSP<Q10<@PPD000<080I220>U=0;_G@Koo`?F^P=c[P=kc`8Q90<080<000<080<8
H@<@XP9S;0?6>0?g_P?oo`?_G@?W?0?Nn`;Nf`=kk`Soo`?_G@?W70><L@<aQP8080<000<080<8H@<@
XP<H``8Q10<Q90<YA@>4<0?Nf`?og`?oo`;og`?gWP?_G@>Ld`<ia`<8@@8000<080HaYP>Ld`?W?0Go
o`?Nf`?F^P?FVP=cSP8Q10<@PPH000<080E220>U=0?_G@Koo`?F^P=c[P9kc`<Q90<080<000<080<8
H@8@XP=S;0?6>0?g_P?oo`?_G@;W?0?Nn`?Nf`=kkaSoo`005ooo0nmM0nLL0Xaa0c660`0P0`000`0P
0`QQ0Q2R0aS30b440b4T0bU50h@`0mkK0_oO0ooo0ooO0oNN0nmM0icC0SW70`Q10`000`0P1S6V0YcC
0nLl1_oo0mkK0mJj0]JJ0g>>0b440a221P000P0P1T880jDd0nmM1_oo0]Jj0g>^0g_?0b4T0`0P0`00
0P0P0`QQ0a2R0f</0lHh0oNn0_oo0nmM0nLl0mkk0mkK0g__2?oo0nmM0^LL0haa0c660`0P0`000`0P
0PQQ0a2R0aS30b440b4T0bU50X@`0mkK0ooO0ooo0ooO0oNN0^mM0icC0cW70`Q10`000`0P1C6V0icC
0nLl1_oo0mkK0]Jj0mJJ0g>>0b440a221@000`0P1T880jDd0nmM1Ooo0mJj0g>^0g_?0b4T0`0P0P00
0`0P0`QQ0a2R0f</0lHh0_Nn0ooo0nmM0nLl0mkk0mkK0W__2Ooo0^mM0nLL0haa0c660`0P0`000P0P
0`QQ0a2R0aS30b440b4T0RU50h@`0mkK0ooO0ooo0ooO0_NN0nmM0icC0cW70`Q10`000P0P1S6V0icC
0nLl1_oo0]kK0mJj0mJJ0g>>0b440a221@000`0P1T880jDd0^mM1_oo0mJj0g>^0g_?0R4T0`0P0`00
0`0P0`QQ0a2R0V</0lHh0oNn0ooo0nmM0nLl0mkk0]kK0g__2?oo0nmM0nLL0haa0c660P0P0`000`0P
0`QQ0a2R0aS30R440b4T0bU50h@`0mkK0ooO0ooo0_oO0oNN0nmM0icC0cW70`Q10P000`0P1S6V0icC
0nLl1Ooo0mkK0mJj0mJJ0g>>0R440a221P000`0P1D880jDd0nmM1_oo0mJj0g>^0W_?0b4T0`0P0`00
0`0P0`QQ0Q2R0f</0lHh0oNn0ooo0nmM0^Ll0mkk0mkK0g__6?oo000Gool3ked3ia`2S743<HH30203
0003020326424:836<<38@@38B@3:DD3Q303g]/2oml3ool3oml3mih3ked3W=<2>LL3244300030206
<JH2W=<3ic`6ool3g]/3e[X2eYX3Lhh38@@3488600020206@PP3YC@3ked6ool2e[X3Ljh3Nll38B@3
02030002020326434:83Hb`3aSP3mkh2ool3ked3ic`3g_/3g]/3Nnl8ool3ked2ia`3S743<HH30203
0003020226434:836<<38@@38B@3:DD2Q303g]/3oml3ool3oml3mih2ked3W=<3>LL3244300030205
<JH3W=<3ic`6ool3g]/2e[X3eYX3Lhh38@@3488500030206@PP3YC@3ked5ool3e[X3Ljh3Nll38B@3
02020003020326434:83Hb`3aSP2mkh3ool3ked3ic`3g_/3g]/2Nnl9ool2ked3ia`3S743<HH30203
0002020326434:836<<38@@38B@2:DD3Q303g]/3oml3ool3oml2mih3ked3W=<3>LL3244300020206
<JH3W=<3ic`6ool2g]/3e[X3eYX3Lhh38@@3488500030206@PP3YC@2ked6ool3e[X3Ljh3Nll28B@3
02030003020326434:82Hb`3aSP3mkh3ool3ked3ic`3g_/2g]/3Nnl8ool3ked3ia`3S743<HH20203
0003020326434:836<<28@@38B@3:DD3Q303g]/3oml3ool2oml3mih3ked3W=<3>LL3244200030206
<JH3W=<3ic`5ool3g]/3e[X3eYX3Lhh28@@3488600030205@PP3YC@3ked6ool3e[X3Ljh2Nll38B@3
02030003020326424:83Hb`3aSP3mkh3ool3ked2ic`3g_/3g]/3NnlHool001Ooo`?_G@?W70:<L@<a
QP<080<000<080<8H@8@XP<H``<Q10<Q90<YA@>4<0?Nf`;og`?oo`?og`?gWP?_G@>Ld`8ia`<8@@<0
00<080HaYP:Ld`?W?0Koo`?Nf`?F^P;FVP=cSP<Q10<@PPH0008080I220>U=0?_G@Koo`;F^P=c[P=k
c`<Q90<080<0008080<8H@<@XP=S;0?6>0?g_P;oo`?_G@?W?0?Nn`?Nf`=kk`Soo`?_G@;W70><L@<a
QP<080<000<08088H@<@XP<H``<Q10<Q90<YA@:4<0?Nf`?og`?oo`?og`?gWP;_G@>Ld`<ia`<8@@<0
00<080DaYP>Ld`?W?0Koo`?Nf`;F^P?FVP=cSP<Q10<@PPD000<080I220>U=0?_G@Goo`?F^P=c[P=k
c`<Q90<0808000<080<8H@<@XP=S;0?6>0;g_P?oo`?_G@?W?0?Nn`?Nf`9kk`Woo`;_G@?W70><L@<a
QP<080<0008080<8H@<@XP<H``<Q10<Q908YA@>4<0?Nf`?og`?oo`?og`;gWP?_G@>Ld`<ia`<8@@<0
008080HaYP>Ld`?W?0Koo`;Nf`?F^P?FVP=cSP<Q10<@PPD000<080I220>U=0;_G@Koo`?F^P=c[P=k
c`8Q90<080<000<080<8H@<@XP9S;0?6>0?g_P?oo`?_G@?W?0?Nn`;Nf`=kk`Soo`?_G@?W70><L@<a
QP8080<000<080<8H@<@XP<H``8Q10<Q90<YA@>4<0?Nf`?og`?oo`;og`?gWP?_G@>Ld`<ia`<8@@80
00<080HaYP>Ld`?W?0Goo`?Nf`?F^P?FVP=cSP8Q10<@PPH000<080E220>U=0?_G@Koo`?F^P=c[P9k
c`<Q90<080<000<080<8H@8@XP=S;0?6>0?g_P?oo`?_G@;W?0?Nn`?Nf`=kkaSoo`005ooo0nmM0nLL
0Xaa0c660`0P0`000`0P0`QQ0Q2R0aS30b440b4T0bU50h@`0mkK0_oO0ooo0ooO0oNN0nmM0icC0SW7
0`Q10`000`0P1S6V0YcC0nLl1_oo0mkK0mJj0]JJ0g>>0b440a221P000P0P1T880jDd0nmM1_oo0]Jj
0g>^0g_?0b4T0`0P0`000P0P0`QQ0a2R0f</0lHh0oNn0_oo0nmM0nLl0mkk0mkK0g__2?oo0nmM0^LL
0haa0c660`0P0`000`0P0PQQ0a2R0aS30b440b4T0bU50X@`0mkK0ooO0ooo0ooO0oNN0^mM0icC0cW7
0`Q10`000`0P1C6V0icC0nLl1_oo0mkK0]Jj0mJJ0g>>0b440a221@000`0P1T880jDd0nmM1Ooo0mJj
0g>^0g_?0b4T0`0P0P000`0P0`QQ0a2R0f</0lHh0_Nn0ooo0nmM0nLl0mkk0mkK0W__2Ooo0^mM0nLL
0haa0c660`0P0`000P0P0`QQ0a2R0aS30b440b4T0RU50h@`0mkK0ooO0ooo0ooO0_NN0nmM0icC0cW7
0`Q10`000P0P1S6V0icC0nLl1_oo0]kK0mJj0mJJ0g>>0b440a221@000`0P1T880jDd0^mM1_oo0mJj
0g>^0g_?0R4T0`0P0`000`0P0`QQ0a2R0V</0lHh0oNn0ooo0nmM0nLl0mkk0]kK0g__2?oo0nmM0nLL
0haa0c660P0P0`000`0P0`QQ0a2R0aS30R440b4T0bU50h@`0mkK0ooO0ooo0_oO0oNN0nmM0icC0cW7
0`Q10P000`0P1S6V0icC0nLl1Ooo0mkK0mJj0mJJ0g>>0R440a221P000`0P1D880jDd0nmM1_oo0mJj
0g>^0W_?0b4T0`0P0`000`0P0`QQ0Q2R0f</0lHh0oNn0ooo0nmM0^Ll0mkk0mkK0g__6?oo000Gool6
Q102Q306S543<HH38@@3488500032443BTT3@RP3[ED3kgd2oml3ool3oml>aQP6F^/3F//34:820203
0003020326434:83Hb`2H``3aQP3mkh3ool3kgd3ic`5U983U;83<JH3:FD302030002020326434:83
Hb`3aSP3mkh2ool3ked3W=<3>LL3:FD3020200030203>NL3YA@3ked;ool5Q103Q306S543<HH38@@2
488600032443BTT3@RP2[ED3kgd3oml3ool3oml>aQP6F^/3F//24:8302030003020326434:82Hb`3
H``3aQP3mkh3ool3kgd2ic`6U983U;83<JH3:FD202030003020326434:83Hb`3aSP2mkh3ool3ked3
W=<3>LL3:FD2020300030203>NL3YA@3ked;ool5Q103Q306S543<HH28@@3488600032443BTT2@RP3
[ED3kgd3oml3ool3oml>aQP5F^/3F//34:8302030003020326424:83Hb`3H``3aQP3mkh3ool2kgd3
ic`6U983U;83<JH2:FD302030003020326434:82Hb`3aSP3mkh3ool3ked3W=<2>LL3:FD302030003
0203>NL3YA@2ked;ool6Q103Q305S543<HH38@@3488600022443BTT3@RP3[ED3kgd3oml3ool2oml?
aQP5F^/3F//34:8302030002020326434:83Hb`3H``3aQP2mkh3ool3kgd3ic`6U982U;83<JH3:FD3
02030003020326424:83Hb`3aSP3mkh3ool3ked2W=<3>LL3:FD3020300030202>NL3YA@3kedKool0
01Ooo`J440:4<0J<D@<aQP<Q10<@PPD000<8@@=:B@=2:0>]E@?_O@;og`?oo`?og`k660IJj`=Jb`<@
XP8080<000<080<8H@<@XP=S;09S30?660?g_P?oo`?_O@?W?0FDTP>D/P<aYP<YI@<080<0008080<8
H@<@XP=S;0?6>0?g_P;oo`?_G@>Ld`<ia`<YI@<0808000<080<ii`>U50?_G@_oo`F440>4<0J<D@<a
QP<Q108@PPH000<8@@=:B@=2:0:]E@?_O@?og`?oo`?og`k660IJj`=Jb`8@XP<080<000<080<8H@<@
XP9S;0=S30?660?g_P?oo`?_O@;W?0JDTP>D/P<aYP<YI@8080<000<080<8H@<@XP=S;0?6>0;g_P?o
o`?_G@>Ld`<ia`<YI@8080<000<080<ii`>U50?_G@_oo`F440>4<0J<D@<aQP8Q10<@PPH000<8@@=:
B@92:0>]E@?_O@?og`?oo`?og`k660EJj`=Jb`<@XP<080<000<080<8H@8@XP=S;0=S30?660?g_P?o
o`;_O@?W?0JDTP>D/P<aYP8YI@<080<000<080<8H@<@XP9S;0?6>0?g_P?oo`?_G@>Ld`8ia`<YI@<0
80<000<080<ii`>U50;_G@_oo`J440>4<0F<D@<aQP<Q10<@PPH00088@@=:B@=2:0>]E@?_O@?og`?o
o`;og`o660EJj`=Jb`<@XP<080<0008080<8H@<@XP=S;0=S30?660;g_P?oo`?_O@?W?0JDTP:D/P<a
YP<YI@<080<000<080<8H@8@XP=S;0?6>0?g_P?oo`?_G@:Ld`<ia`<YI@<080<000<0808ii`>U50?_
GA_oo`005ooo1X@@0X@`1XaA0c660b440a221@000`Q10dY90d8X0jeE0nmm0_oO0ooo0ooO3/HH1U[[
0e[;0a2R0P0P0`000`0P0`QQ0a2R0f</0V<<0lHH0oNn0ooo0nmm0nLl1IBB0iBb0c6V0bUU0`0P0`00
0P0P0`QQ0a2R0f</0lHh0oNn0_oo0nmM0icC0cW70bUU0`0P0P000`0P0cWW0jDD0nmM2ooo1H@@0h@`
1XaA0c660b440Q221P000`Q10dY90d8X0ZeE0nmm0ooO0ooo0ooO3/HH1U[[0e[;0Q2R0`0P0`000`0P
0`QQ0a2R0V</0f<<0lHH0oNn0ooo0nmm0^Ll1YBB0iBb0c6V0bUU0P0P0`000`0P0`QQ0a2R0f</0lHh
0_Nn0ooo0nmM0icC0cW70bUU0P0P0`000`0P0cWW0jDD0nmM2ooo1H@@0h@`1XaA0c660R440a221P00
0`Q10dY90T8X0jeE0nmm0ooO0ooo0ooO3/HH1E[[0e[;0a2R0`0P0`000`0P0`QQ0Q2R0f</0f<<0lHH
0oNn0ooo0^mm0nLl1YBB0iBb0c6V0RUU0`0P0`000`0P0`QQ0a2R0V</0lHh0oNn0ooo0nmM0icC0SW7
0bUU0`0P0`000`0P0cWW0jDD0^mM2ooo1X@@0h@`1HaA0c660b440a221P000PQ10dY90d8X0jeE0nmm
0ooO0ooo0_oO3lHH1E[[0e[;0a2R0`0P0`000P0P0`QQ0a2R0f</0f<<0lHH0_Nn0ooo0nmm0nLl1YBB
0YBb0c6V0bUU0`0P0`000`0P0`QQ0Q2R0f</0lHh0oNn0ooo0nmM0YcC0cW70bUU0`0P0`000`0P0SWW
0jDD0nmM6ooo000Gool6Q102Q306S543<HH38@@3488500032443BTT3@RP3[ED3kgd2oml3ool3oml>
aQP6F^/3F//34:8202030003020326434:83Hb`2H``3aQP3mkh3ool3kgd3ic`5U983U;83<JH3:FD3
02030002020326434:83Hb`3aSP3mkh2ool3ked3W=<3>LL3:FD3020200030203>NL3YA@3ked;ool5
Q103Q306S543<HH38@@2488600032443BTT3@RP2[ED3kgd3oml3ool3oml>aQP6F^/3F//24:830203
0003020326434:82Hb`3H``3aQP3mkh3ool3kgd2ic`6U983U;83<JH3:FD202030003020326434:83
Hb`3aSP2mkh3ool3ked3W=<3>LL3:FD2020300030203>NL3YA@3ked;ool5Q103Q306S543<HH28@@3
488600032443BTT2@RP3[ED3kgd3oml3ool3oml>aQP5F^/3F//34:8302030003020326424:83Hb`3
H``3aQP3mkh3ool2kgd3ic`6U983U;83<JH2:FD302030003020326434:82Hb`3aSP3mkh3ool3ked3
W=<2>LL3:FD3020300030203>NL3YA@2ked;ool6Q103Q305S543<HH38@@3488600022443BTT3@RP3
[ED3kgd3oml3ool2oml?aQP5F^/3F//34:8302030002020326434:83Hb`3H``3aQP2mkh3ool3kgd3
ic`6U982U;83<JH3:FD302030003020326424:83Hb`3aSP3mkh3ool3ked2W=<3>LL3:FD302030003
0202>NL3YA@3kedKool001Ooo`J440:4<0J<D@<aQP<Q10<@PPD000<8@@=:B@=2:0>]E@?_O@;og`?o
o`?og`k660IJj`=Jb`<@XP8080<000<080<8H@<@XP=S;09S30?660?g_P?oo`?_O@?W?0FDTP>D/P<a
YP<YI@<080<0008080<8H@<@XP=S;0?6>0?g_P;oo`?_G@>Ld`<ia`<YI@<0808000<080<ii`>U50?_
G@_oo`F440>4<0J<D@<aQP<Q108@PPH000<8@@=:B@=2:0:]E@?_O@?og`?oo`?og`k660IJj`=Jb`8@
XP<080<000<080<8H@<@XP9S;0=S30?660?g_P?oo`?_O@;W?0JDTP>D/P<aYP<YI@8080<000<080<8
H@<@XP=S;0?6>0;g_P?oo`?_G@>Ld`<ia`<YI@8080<000<080<ii`>U50?_G@_oo`F440>4<0J<D@<a
QP8Q10<@PPH000<8@@=:B@92:0>]E@?_O@?og`?oo`?og`k660EJj`=Jb`<@XP<080<000<080<8H@8@
XP=S;0=S30?660?g_P?oo`;_O@?W?0JDTP>D/P<aYP8YI@<080<000<080<8H@<@XP9S;0?6>0?g_P?o
o`?_G@>Ld`8ia`<YI@<080<000<080<ii`>U50;_G@_oo`J440>4<0F<D@<aQP<Q10<@PPH00088@@=:
B@=2:0>]E@?_O@?og`?oo`;og`o660EJj`=Jb`<@XP<080<0008080<8H@<@XP=S;0=S30?660;g_P?o
o`?_O@?W?0JDTP:D/P<aYP<YI@<080<000<080<8H@8@XP=S;0?6>0?g_P?oo`?_G@:Ld`<ia`<YI@<0
80<000<0808ii`>U50?_GA_oo`005ooo1X@@0X@`1XaA0c660b440a221@000`Q10dY90d8X0jeE0nmm
0_oO0ooo0ooO3/HH1U[[0e[;0a2R0P0P0`000`0P0`QQ0a2R0f</0V<<0lHH0oNn0ooo0nmm0nLl1IBB
0iBb0c6V0bUU0`0P0`000P0P0`QQ0a2R0f</0lHh0oNn0_oo0nmM0icC0cW70bUU0`0P0P000`0P0cWW
0jDD0nmM2ooo1H@@0h@`1XaA0c660b440Q221P000`Q10dY90d8X0ZeE0nmm0ooO0ooo0ooO3/HH1U[[
0e[;0Q2R0`0P0`000`0P0`QQ0a2R0V</0f<<0lHH0oNn0ooo0nmm0^Ll1YBB0iBb0c6V0bUU0P0P0`00
0`0P0`QQ0a2R0f</0lHh0_Nn0ooo0nmM0icC0cW70bUU0P0P0`000`0P0cWW0jDD0nmM2ooo1H@@0h@`
1XaA0c660R440a221P000`Q10dY90T8X0jeE0nmm0ooO0ooo0ooO3/HH1E[[0e[;0a2R0`0P0`000`0P
0`QQ0Q2R0f</0f<<0lHH0oNn0ooo0^mm0nLl1YBB0iBb0c6V0RUU0`0P0`000`0P0`QQ0a2R0V</0lHh
0oNn0ooo0nmM0icC0SW70bUU0`0P0`000`0P0cWW0jDD0^mM2ooo1X@@0h@`1HaA0c660b440a221P00
0PQ10dY90d8X0jeE0nmm0ooO0ooo0_oO3lHH1E[[0e[;0a2R0`0P0`000P0P0`QQ0a2R0f</0f<<0lHH
0_Nn0ooo0nmm0nLl1YBB0YBb0c6V0bUU0`0P0`000`0P0`QQ0Q2R0f</0lHh0oNn0ooo0nmM0YcC0cW7
0bUU0`0P0`000`0P0SWW0jDD0nmM6ooo000Gool6Q102Q306S543<HH38@@3488500032443BTT3@RP3
[ED3kgd2oml3ool3oml>aQP6F^/3F//34:8202030003020326434:83Hb`2H``3aQP3mkh3ool3kgd3
ic`5U983U;83<JH3:FD302030002020326434:83Hb`3aSP3mkh2ool3ked3W=<3>LL3:FD302020003
0203>NL3YA@3ked;ool5Q103Q306S543<HH38@@2488600032443BTT3@RP2[ED3kgd3oml3ool3oml>
aQP6F^/3F//24:8302030003020326434:82Hb`3H``3aQP3mkh3ool3kgd2ic`6U983U;83<JH3:FD2
02030003020326434:83Hb`3aSP2mkh3ool3ked3W=<3>LL3:FD2020300030203>NL3YA@3ked;ool5
Q103Q306S543<HH28@@3488600032443BTT2@RP3[ED3kgd3oml3ool3oml>aQP5F^/3F//34:830203
0003020326424:83Hb`3H``3aQP3mkh3ool2kgd3ic`6U983U;83<JH2:FD302030003020326434:82
Hb`3aSP3mkh3ool3ked3W=<2>LL3:FD3020300030203>NL3YA@2ked;ool6Q103Q305S543<HH38@@3
488600022443BTT3@RP3[ED3kgd3oml3ool2oml?aQP5F^/3F//34:8302030002020326434:83Hb`3
H``3aQP2mkh3ool3kgd3ic`6U982U;83<JH3:FD302030003020326424:83Hb`3aSP3mkh3ool3ked2
W=<3>LL3:FD3020300030202>NL3YA@3kedKool001Ooo`J440:4<0J<D@<aQP<Q10<@PPD000<8@@=:
B@=2:0>]E@?_O@;og`?oo`?og`k660IJj`=Jb`<@XP8080<000<080<8H@<@XP=S;09S30?660?g_P?o
o`?_O@?W?0FDTP>D/P<aYP<YI@<080<0008080<8H@<@XP=S;0?6>0?g_P;oo`?_G@>Ld`<ia`<YI@<0
808000<080<ii`>U50?_G@_oo`F440>4<0J<D@<aQP<Q108@PPH000<8@@=:B@=2:0:]E@?_O@?og`?o
o`?og`k660IJj`=Jb`8@XP<080<000<080<8H@<@XP9S;0=S30?660?g_P?oo`?_O@;W?0JDTP>D/P<a
YP<YI@8080<000<080<8H@<@XP=S;0?6>0;g_P?oo`?_G@>Ld`<ia`<YI@8080<000<080<ii`>U50?_
G@_oo`F440>4<0J<D@<aQP8Q10<@PPH000<8@@=:B@92:0>]E@?_O@?og`?oo`?og`k660EJj`=Jb`<@
XP<080<000<080<8H@8@XP=S;0=S30?660?g_P?oo`;_O@?W?0JDTP>D/P<aYP8YI@<080<000<080<8
H@<@XP9S;0?6>0?g_P?oo`?_G@>Ld`8ia`<YI@<080<000<080<ii`>U50;_G@_oo`J440>4<0F<D@<a
QP<Q10<@PPH00088@@=:B@=2:0>]E@?_O@?og`?oo`;og`o660EJj`=Jb`<@XP<080<0008080<8H@<@
XP=S;0=S30?660;g_P?oo`?_O@?W?0JDTP:D/P<aYP<YI@<080<000<080<8H@8@XP=S;0?6>0?g_P?o
o`?_G@:Ld`<ia`<YI@<080<000<0808ii`>U50?_GA_oo`005ooo1X@@0X@`1XaA0c660b440a221@00
0`Q10dY90d8X0jeE0nmm0_oO0ooo0ooO3/HH1U[[0e[;0a2R0P0P0`000`0P0`QQ0a2R0f</0V<<0lHH
0oNn0ooo0nmm0nLl1IBB0iBb0c6V0bUU0`0P0`000P0P0`QQ0a2R0f</0lHh0oNn0_oo0nmM0icC0cW7
0bUU0`0P0P000`0P0cWW0jDD0nmM2ooo1H@@0h@`1XaA0c660b440Q221P000`Q10dY90d8X0ZeE0nmm
0ooO0ooo0ooO3/HH1U[[0e[;0Q2R0`0P0`000`0P0`QQ0a2R0V</0f<<0lHH0oNn0ooo0nmm0^Ll1YBB
0iBb0c6V0bUU0P0P0`000`0P0`QQ0a2R0f</0lHh0_Nn0ooo0nmM0icC0cW70bUU0P0P0`000`0P0cWW
0jDD0nmM2ooo1H@@0h@`1XaA0c660R440a221P000`Q10dY90T8X0jeE0nmm0ooO0ooo0ooO3/HH1E[[
0e[;0a2R0`0P0`000`0P0`QQ0Q2R0f</0f<<0lHH0oNn0ooo0^mm0nLl1YBB0iBb0c6V0RUU0`0P0`00
0`0P0`QQ0a2R0V</0lHh0oNn0ooo0nmM0icC0SW70bUU0`0P0`000`0P0cWW0jDD0^mM2ooo1X@@0h@`
1HaA0c660b440a221P000PQ10dY90d8X0jeE0nmm0ooO0ooo0_oO3lHH1E[[0e[;0a2R0`0P0`000P0P
0`QQ0a2R0f</0f<<0lHH0_Nn0ooo0nmm0nLl1YBB0YBb0c6V0bUU0`0P0`000`0P0`QQ0Q2R0f</0lHh
0oNn0ooo0nmM0YcC0cW70bUU0`0P0`000`0P0SWW0jDD0nmM6ooo000Gool6Q102Q306S543<HH38@@3
488500032443BTT3@RP3[ED3kgd2oml3ool3oml>aQP6F^/3F//34:8202030003020326434:83Hb`2
H``3aQP3mkh3ool3kgd3ic`5U983U;83<JH3:FD302030002020326434:83Hb`3aSP3mkh2ool3ked3
W=<3>LL3:FD3020200030203>NL3YA@3ked;ool5Q103Q306S543<HH38@@2488600032443BTT3@RP2
[ED3kgd3oml3ool3oml>aQP6F^/3F//24:8302030003020326434:82Hb`3H``3aQP3mkh3ool3kgd2
ic`6U983U;83<JH3:FD202030003020326434:83Hb`3aSP2mkh3ool3ked3W=<3>LL3:FD202030003
0203>NL3YA@3ked;ool5Q103Q306S543<HH28@@3488600032443BTT2@RP3[ED3kgd3oml3ool3oml>
aQP5F^/3F//34:8302030003020326424:83Hb`3H``3aQP3mkh3ool2kgd3ic`6U983U;83<JH2:FD3
02030003020326434:82Hb`3aSP3mkh3ool3ked3W=<2>LL3:FD3020300030203>NL3YA@2ked;ool6
Q103Q305S543<HH38@@3488600022443BTT3@RP3[ED3kgd3oml3ool2oml?aQP5F^/3F//34:830203
0002020326434:83Hb`3H``3aQP2mkh3ool3kgd3ic`6U982U;83<JH3:FD302030003020326424:83
Hb`3aSP3mkh3ool3ked2W=<3>LL3:FD3020300030202>NL3YA@3kedKool001Ooo`J440:4<0J<D@<a
QP<Q10<@PPD000<8@@=:B@=2:0>]E@?_O@;og`?oo`?og`k660IJj`=Jb`<@XP8080<000<080<8H@<@
XP=S;09S30?660?g_P?oo`?_O@?W?0FDTP>D/P<aYP<YI@<080<0008080<8H@<@XP=S;0?6>0?g_P;o
o`?_G@>Ld`<ia`<YI@<0808000<080<ii`>U50?_G@_oo`F440>4<0J<D@<aQP<Q108@PPH000<8@@=:
B@=2:0:]E@?_O@?og`?oo`?og`k660IJj`=Jb`8@XP<080<000<080<8H@<@XP9S;0=S30?660?g_P?o
o`?_O@;W?0JDTP>D/P<aYP<YI@8080<000<080<8H@<@XP=S;0?6>0;g_P?oo`?_G@>Ld`<ia`<YI@80
80<000<080<ii`>U50?_G@_oo`F440>4<0J<D@<aQP8Q10<@PPH000<8@@=:B@92:0>]E@?_O@?og`?o
o`?og`k660EJj`=Jb`<@XP<080<000<080<8H@8@XP=S;0=S30?660?g_P?oo`;_O@?W?0JDTP>D/P<a
YP8YI@<080<000<080<8H@<@XP9S;0?6>0?g_P?oo`?_G@>Ld`8ia`<YI@<080<000<080<ii`>U50;_
G@_oo`J440>4<0F<D@<aQP<Q10<@PPH00088@@=:B@=2:0>]E@?_O@?og`?oo`;og`o660EJj`=Jb`<@
XP<080<0008080<8H@<@XP=S;0=S30?660;g_P?oo`?_O@?W?0JDTP:D/P<aYP<YI@<080<000<080<8
H@8@XP=S;0?6>0?g_P?oo`?_G@:Ld`<ia`<YI@<080<000<0808ii`>U50?_GA_oo`006_oo0oNn0^mm
0nmM0nLL0mkk0mkK0g_?0R4T0a2R0`0P0`000`0P0`QQ0a2R0QSS1W>>0lii0ooO0ooo0_oO0oNN0nmM
0nLl0haa0iBB0YBb0c6V0`Q10`000a2R0aSS0R440b4T0bU51RUU0iBB0Xaa0mkk1_oo0ooO0kgg1E[;
0e:Z0dYY0dY90`QQ1@000`Q10a220e[;1U:Z0U::0dYY0kFF0kgG0oNN3_oo0_Nn0nmm0nmM0nLL0mkk
0mkK0W_?0b4T0a2R0`0P0`000`0P0PQQ0a2R0aSS1W>>0lii0_oO0ooo0ooO0oNN0nmM0nLl0haa0YBB
0iBb0c6V0`Q10`000a2R0QSS0b440b4T0bU51RUU0YBB0haa0mkk1_oo0ooO0[gg1U[;0e:Z0dYY0dY9
0`QQ1@000`Q10a220e[;1E:Z0e::0dYY0kFF0kgG0oNN3Ooo0oNn0nmm0nmM0nLL0mkk0]kK0g_?0b4T
0a2R0`0P0`000P0P0`QQ0a2R0aSS1W>>0/ii0ooO0ooo0ooO0oNN0nmM0^Ll0haa0iBB0iBb0c6V0`Q1
0`000Q2R0aSS0b440b4T0bU51BUU0iBB0haa0mkk1_oo0_oO0kgg1U[;0e:Z0dYY0TY90`QQ1P000`Q1
0a220U[;1U:Z0e::0dYY0kFF0kgG0_NN3_oo0oNn0nmm0nmM0^LL0mkk0mkK0g_?0b4T0a2R0P0P0`00
0`0P0`QQ0a2R0aSS1G>>0lii0ooO0ooo0ooO0oNN0^mM0nLl0haa0iBB0iBb0c6V0PQ10`000a2R0aSS
0b440b4T0RU51RUU0iBB0haa0mkk1Ooo0ooO0kgg1U[;0e:Z0TYY0dY90`QQ1P000`Q10Q220e[;1U:Z
0e::0dYY0[FF0kgG0oNN6ooo000Jool3mkh2kgd3ked3ia`3g_/3g]/3Nll28B@34:83020300030203
26434:826><6Lhh3cWT3oml3ool2oml3mih3ked3ic`3S743U982U;83<JH3244300034:836><28@@3
8B@3:DD6:FD3U982S743g_/6ool3oml3_OL5F//3DZX3BVT3BTT32645000324434883F//6DZX2DXX3
BVT3]IH3_ML3mih>ool2mkh3kgd3ked3ia`3g_/3g]/2Nll38B@34:8302030003020226434:836><6
Lhh3cWT2oml3ool3oml3mih3ked3ic`3S742U983U;83<JH3244300034:826><38@@38B@3:DD6:FD2
U983S743g_/6ool3oml2_OL6F//3DZX3BVT3BTT32645000324434883F//5DZX3DXX3BVT3]IH3_ML3
mih=ool3mkh3kgd3ked3ia`3g_/2g]/3Nll38B@34:8302030002020326434:836><6Lhh2cWT3oml3
ool3oml3mih3ked2ic`3S743U983U;83<JH3244300024:836><38@@38B@3:DD5:FD3U983S743g_/6
ool2oml3_OL6F//3DZX3BVT2BTT32646000324434882F//6DZX3DXX3BVT3]IH3_ML2mih>ool3mkh3
kgd3ked2ia`3g_/3g]/3Nll38B@34:8202030003020326434:836><5Lhh3cWT3oml3ool3oml3mih2
ked3ic`3S743U983U;83<JH2244300034:836><38@@38B@2:DD6:FD3U983S743g_/5ool3oml3_OL6
F//3DZX2BVT3BTT32646000324424883F//6DZX3DXX3BVT2]IH3_ML3mihKool001[oo`?g_P;_O@?_
G@?W70?Nn`?Nf`=kc`8Q90<@XP<080<000<080<8H@<@XP8Hh`IcSP?>N@?og`?oo`;og`?gWP?_G@?W
?0><L@>DTP:D/P<aYP<8@@<000<@XP<Hh`8Q10<Q90<YA@HYI@>DTP:<L@?Nn`Koo`?og`>mm`EJb`=B
ZP=:J@=:B@<8H@D000<8@@<@PP=Jb`IBZP9BRP=:J@>eUP>me`?gWPkoo`;g_P?_O@?_G@?W70?Nn`?N
f`9kc`<Q90<@XP<080<000<08088H@<@XP<Hh`IcSP?>N@;og`?oo`?og`?gWP?_G@?W?0><L@:DTP>D
/P<aYP<8@@<000<@XP8Hh`<Q10<Q90<YA@HYI@:DTP><L@?Nn`Koo`?og`:mm`IJb`=BZP=:J@=:B@<8
H@D000<8@@<@PP=Jb`EBZP=BRP=:J@>eUP>me`?gWPgoo`?g_P?_O@?_G@?W70?Nn`;Nf`=kc`<Q90<@
XP<080<0008080<8H@<@XP<Hh`IcSP;>N@?og`?oo`?og`?gWP?_G@;W?0><L@>DTP>D/P<aYP<8@@<0
008@XP<Hh`<Q10<Q90<YA@DYI@>DTP><L@?Nn`Koo`;og`>mm`IJb`=BZP=:J@9:B@<8H@H000<8@@<@
PP9Jb`IBZP=BRP=:J@>eUP>me`;gWPkoo`?g_P?_O@?_G@;W70?Nn`?Nf`=kc`<Q90<@XP8080<000<0
80<8H@<@XP<Hh`EcSP?>N@?og`?oo`?og`?gWP;_G@?W?0><L@>DTP>D/P<aYP88@@<000<@XP<Hh`<Q
10<Q908YA@HYI@>DTP><L@?Nn`Goo`?og`>mm`IJb`=BZP9:J@=:B@<8H@H000<8@@8@PP=Jb`IBZP=B
RP=:J@:eUP>me`?gWQ_oo`006_oo0oNn0^mm0nmM0nLL0mkk0mkK0g_?0R4T0a2R0`0P0`000`0P0`QQ
0a2R0QSS1W>>0lii0ooO0ooo0_oO0oNN0nmM0nLl0haa0iBB0YBb0c6V0`Q10`000a2R0aSS0R440b4T
0bU51RUU0iBB0Xaa0mkk1_oo0ooO0kgg1E[;0e:Z0dYY0dY90`QQ1@000`Q10a220e[;1U:Z0U::0dYY
0kFF0kgG0oNN3_oo0_Nn0nmm0nmM0nLL0mkk0mkK0W_?0b4T0a2R0`0P0`000`0P0PQQ0a2R0aSS1W>>
0lii0_oO0ooo0ooO0oNN0nmM0nLl0haa0YBB0iBb0c6V0`Q10`000a2R0QSS0b440b4T0bU51RUU0YBB
0haa0mkk1_oo0ooO0[gg1U[;0e:Z0dYY0dY90`QQ1@000`Q10a220e[;1E:Z0e::0dYY0kFF0kgG0oNN
3Ooo0oNn0nmm0nmM0nLL0mkk0]kK0g_?0b4T0a2R0`0P0`000P0P0`QQ0a2R0aSS1W>>0/ii0ooO0ooo
0ooO0oNN0nmM0^Ll0haa0iBB0iBb0c6V0`Q10`000Q2R0aSS0b440b4T0bU51BUU0iBB0haa0mkk1_oo
0_oO0kgg1U[;0e:Z0dYY0TY90`QQ1P000`Q10a220U[;1U:Z0e::0dYY0kFF0kgG0_NN3_oo0oNn0nmm
0nmM0^LL0mkk0mkK0g_?0b4T0a2R0P0P0`000`0P0`QQ0a2R0aSS1G>>0lii0ooO0ooo0ooO0oNN0^mM
0nLl0haa0iBB0iBb0c6V0PQ10`000a2R0aSS0b440b4T0RU51RUU0iBB0haa0mkk1Ooo0ooO0kgg1U[;
0e:Z0TYY0dY90`QQ1P000`Q10Q220e[;1U:Z0e::0dYY0[FF0kgG0oNN6ooo000Jool3mkh2kgd3ked3
ia`3g_/3g]/3Nll28B@34:8302030003020326434:826><6Lhh3cWT3oml3ool2oml3mih3ked3ic`3
S743U982U;83<JH3244300034:836><28@@38B@3:DD6:FD3U982S743g_/6ool3oml3_OL5F//3DZX3
BVT3BTT32645000324434883F//6DZX2DXX3BVT3]IH3_ML3mih>ool2mkh3kgd3ked3ia`3g_/3g]/2
Nll38B@34:8302030003020226434:836><6Lhh3cWT2oml3ool3oml3mih3ked3ic`3S742U983U;83
<JH3244300034:826><38@@38B@3:DD6:FD2U983S743g_/6ool3oml2_OL6F//3DZX3BVT3BTT32645
000324434883F//5DZX3DXX3BVT3]IH3_ML3mih=ool3mkh3kgd3ked3ia`3g_/2g]/3Nll38B@34:83
02030002020326434:836><6Lhh2cWT3oml3ool3oml3mih3ked2ic`3S743U983U;83<JH324430002
4:836><38@@38B@3:DD5:FD3U983S743g_/6ool2oml3_OL6F//3DZX3BVT2BTT32646000324434882
F//6DZX3DXX3BVT3]IH3_ML2mih>ool3mkh3kgd3ked2ia`3g_/3g]/3Nll38B@34:82020300030203
26434:836><5Lhh3cWT3oml3ool3oml3mih2ked3ic`3S743U983U;83<JH2244300034:836><38@@3
8B@2:DD6:FD3U983S743g_/5ool3oml3_OL6F//3DZX2BVT3BTT32646000324424883F//6DZX3DXX3
BVT2]IH3_ML3mihKool001[oo`?g_P;_O@?_G@?W70?Nn`?Nf`=kc`8Q90<@XP<080<000<080<8H@<@
XP8Hh`IcSP?>N@?og`?oo`;og`?gWP?_G@?W?0><L@>DTP:D/P<aYP<8@@<000<@XP<Hh`8Q10<Q90<Y
A@HYI@>DTP:<L@?Nn`Koo`?og`>mm`EJb`=BZP=:J@=:B@<8H@D000<8@@<@PP=Jb`IBZP9BRP=:J@>e
UP>me`?gWPkoo`;g_P?_O@?_G@?W70?Nn`?Nf`9kc`<Q90<@XP<080<000<08088H@<@XP<Hh`IcSP?>
N@;og`?oo`?og`?gWP?_G@?W?0><L@:DTP>D/P<aYP<8@@<000<@XP8Hh`<Q10<Q90<YA@HYI@:DTP><
L@?Nn`Koo`?og`:mm`IJb`=BZP=:J@=:B@<8H@D000<8@@<@PP=Jb`EBZP=BRP=:J@>eUP>me`?gWPgo
o`?g_P?_O@?_G@?W70?Nn`;Nf`=kc`<Q90<@XP<080<0008080<8H@<@XP<Hh`IcSP;>N@?og`?oo`?o
g`?gWP?_G@;W?0><L@>DTP>D/P<aYP<8@@<0008@XP<Hh`<Q10<Q90<YA@DYI@>DTP><L@?Nn`Koo`;o
g`>mm`IJb`=BZP=:J@9:B@<8H@H000<8@@<@PP9Jb`IBZP=BRP=:J@>eUP>me`;gWPkoo`?g_P?_O@?_
G@;W70?Nn`?Nf`=kc`<Q90<@XP8080<000<080<8H@<@XP<Hh`EcSP?>N@?og`?oo`?og`?gWP;_G@?W
?0><L@>DTP>D/P<aYP88@@<000<@XP<Hh`<Q10<Q908YA@HYI@>DTP><L@?Nn`Goo`?og`>mm`IJb`=B
ZP9:J@=:B@<8H@H000<8@@8@PP=Jb`IBZP=BRP=:J@:eUP>me`?gWQ_oo`006_oo0oNn0^mm0nmM0nLL
0mkk0mkK0g_?0R4T0a2R0`0P0`000`0P0`QQ0a2R0QSS1W>>0lii0ooO0ooo0_oO0oNN0nmM0nLl0haa
0iBB0YBb0c6V0`Q10`000a2R0aSS0R440b4T0bU51RUU0iBB0Xaa0mkk1_oo0ooO0kgg1E[;0e:Z0dYY
0dY90`QQ1@000`Q10a220e[;1U:Z0U::0dYY0kFF0kgG0oNN3_oo0_Nn0nmm0nmM0nLL0mkk0mkK0W_?
0b4T0a2R0`0P0`000`0P0PQQ0a2R0aSS1W>>0lii0_oO0ooo0ooO0oNN0nmM0nLl0haa0YBB0iBb0c6V
0`Q10`000a2R0QSS0b440b4T0bU51RUU0YBB0haa0mkk1_oo0ooO0[gg1U[;0e:Z0dYY0dY90`QQ1@00
0`Q10a220e[;1E:Z0e::0dYY0kFF0kgG0oNN3Ooo0oNn0nmm0nmM0nLL0mkk0]kK0g_?0b4T0a2R0`0P
0`000P0P0`QQ0a2R0aSS1W>>0/ii0ooO0ooo0ooO0oNN0nmM0^Ll0haa0iBB0iBb0c6V0`Q10`000Q2R
0aSS0b440b4T0bU51BUU0iBB0haa0mkk1_oo0_oO0kgg1U[;0e:Z0dYY0TY90`QQ1P000`Q10a220U[;
1U:Z0e::0dYY0kFF0kgG0_NN3_oo0oNn0nmm0nmM0^LL0mkk0mkK0g_?0b4T0a2R0P0P0`000`0P0`QQ
0a2R0aSS1G>>0lii0ooO0ooo0ooO0oNN0^mM0nLl0haa0iBB0iBb0c6V0PQ10`000a2R0aSS0b440b4T
0RU51RUU0iBB0haa0mkk1Ooo0ooO0kgg1U[;0e:Z0TYY0dY90`QQ1P000`Q10Q220e[;1U:Z0e::0dYY
0[FF0kgG0oNN6ooo000Jool3mkh2kgd3ked3ia`3g_/3g]/3Nll28B@34:8302030003020326434:82
6><6Lhh3cWT3oml3ool2oml3mih3ked3ic`3S743U982U;83<JH3244300034:836><28@@38B@3:DD6
:FD3U982S743g_/6ool3oml3_OL5F//3DZX3BVT3BTT32645000324434883F//6DZX2DXX3BVT3]IH3
_ML3mih>ool2mkh3kgd3ked3ia`3g_/3g]/2Nll38B@34:8302030003020226434:836><6Lhh3cWT2
oml3ool3oml3mih3ked3ic`3S742U983U;83<JH3244300034:826><38@@38B@3:DD6:FD2U983S743
g_/6ool3oml2_OL6F//3DZX3BVT3BTT32645000324434883F//5DZX3DXX3BVT3]IH3_ML3mih=ool3
mkh3kgd3ked3ia`3g_/2g]/3Nll38B@34:8302030002020326434:836><6Lhh2cWT3oml3ool3oml3
mih3ked2ic`3S743U983U;83<JH3244300024:836><38@@38B@3:DD5:FD3U983S743g_/6ool2oml3
_OL6F//3DZX3BVT2BTT32646000324434882F//6DZX3DXX3BVT3]IH3_ML2mih>ool3mkh3kgd3ked2
ia`3g_/3g]/3Nll38B@34:8202030003020326434:836><5Lhh3cWT3oml3ool3oml3mih2ked3ic`3
S743U983U;83<JH2244300034:836><38@@38B@2:DD6:FD3U983S743g_/5ool3oml3_OL6F//3DZX2
BVT3BTT32646000324424883F//6DZX3DXX3BVT2]IH3_ML3mihKool001[oo`?g_P;_O@?_G@?W70?N
n`?Nf`=kc`8Q90<@XP<080<000<080<8H@<@XP8Hh`IcSP?>N@?og`?oo`;og`?gWP?_G@?W?0><L@>D
TP:D/P<aYP<8@@<000<@XP<Hh`8Q10<Q90<YA@HYI@>DTP:<L@?Nn`Koo`?og`>mm`EJb`=BZP=:J@=:
B@<8H@D000<8@@<@PP=Jb`IBZP9BRP=:J@>eUP>me`?gWPkoo`;g_P?_O@?_G@?W70?Nn`?Nf`9kc`<Q
90<@XP<080<000<08088H@<@XP<Hh`IcSP?>N@;og`?oo`?og`?gWP?_G@?W?0><L@:DTP>D/P<aYP<8
@@<000<@XP8Hh`<Q10<Q90<YA@HYI@:DTP><L@?Nn`Koo`?og`:mm`IJb`=BZP=:J@=:B@<8H@D000<8
@@<@PP=Jb`EBZP=BRP=:J@>eUP>me`?gWPgoo`?g_P?_O@?_G@?W70?Nn`;Nf`=kc`<Q90<@XP<080<0
008080<8H@<@XP<Hh`IcSP;>N@?og`?oo`?og`?gWP?_G@;W?0><L@>DTP>D/P<aYP<8@@<0008@XP<H
h`<Q10<Q90<YA@DYI@>DTP><L@?Nn`Koo`;og`>mm`IJb`=BZP=:J@9:B@<8H@H000<8@@<@PP9Jb`IB
ZP=BRP=:J@>eUP>me`;gWPkoo`?g_P?_O@?_G@;W70?Nn`?Nf`=kc`<Q90<@XP8080<000<080<8H@<@
XP<Hh`EcSP?>N@?og`?oo`?og`?gWP;_G@?W?0><L@>DTP>D/P<aYP88@@<000<@XP<Hh`<Q10<Q908Y
A@HYI@>DTP><L@?Nn`Goo`?og`>mm`IJb`=BZP9:J@=:B@<8H@H000<8@@8@PP=Jb`IBZP=BRP=:J@:e
UP>me`?gWQ_oo`006_oo0oNn0^mm0nmM0nLL0mkk0mkK0g_?0R4T0a2R0`0P0`000`0P0`QQ0a2R0QSS
1W>>0lii0ooO0ooo0_oO0oNN0nmM0nLl0haa0iBB0YBb0c6V0`Q10`000a2R0aSS0R440b4T0bU51RUU
0iBB0Xaa0mkk1_oo0ooO0kgg1E[;0e:Z0dYY0dY90`QQ1@000`Q10a220e[;1U:Z0U::0dYY0kFF0kgG
0oNN3_oo0_Nn0nmm0nmM0nLL0mkk0mkK0W_?0b4T0a2R0`0P0`000`0P0PQQ0a2R0aSS1W>>0lii0_oO
0ooo0ooO0oNN0nmM0nLl0haa0YBB0iBb0c6V0`Q10`000a2R0QSS0b440b4T0bU51RUU0YBB0haa0mkk
1_oo0ooO0[gg1U[;0e:Z0dYY0dY90`QQ1@000`Q10a220e[;1E:Z0e::0dYY0kFF0kgG0oNN3Ooo0oNn
0nmm0nmM0nLL0mkk0]kK0g_?0b4T0a2R0`0P0`000P0P0`QQ0a2R0aSS1W>>0/ii0ooO0ooo0ooO0oNN
0nmM0^Ll0haa0iBB0iBb0c6V0`Q10`000Q2R0aSS0b440b4T0bU51BUU0iBB0haa0mkk1_oo0_oO0kgg
1U[;0e:Z0dYY0TY90`QQ1P000`Q10a220U[;1U:Z0e::0dYY0kFF0kgG0_NN3_oo0oNn0nmm0nmM0^LL
0mkk0mkK0g_?0b4T0a2R0P0P0`000`0P0`QQ0a2R0aSS1G>>0lii0ooO0ooo0ooO0oNN0^mM0nLl0haa
0iBB0iBb0c6V0PQ10`000a2R0aSS0b440b4T0RU51RUU0iBB0haa0mkk1Ooo0ooO0kgg1U[;0e:Z0TYY
0dY90`QQ1P000`Q10Q220e[;1U:Z0e::0dYY0[FF0kgG0oNN6ooo000Jool3mkh2kgd3ked3ia`3g_/3
g]/3Nll28B@34:8302030003020326434:826><6Lhh3cWT3oml3ool2oml3mih3ked3ic`3S743U982
U;83<JH3244300034:836><28@@38B@3:DD6:FD3U982S743g_/6ool3oml3_OL5F//3DZX3BVT3BTT3
2645000324434883F//6DZX2DXX3BVT3]IH3_ML3mih>ool2mkh3kgd3ked3ia`3g_/3g]/2Nll38B@3
4:8302030003020226434:836><6Lhh3cWT2oml3ool3oml3mih3ked3ic`3S742U983U;83<JH32443
00034:826><38@@38B@3:DD6:FD2U983S743g_/6ool3oml2_OL6F//3DZX3BVT3BTT3264500032443
4883F//5DZX3DXX3BVT3]IH3_ML3mih=ool3mkh3kgd3ked3ia`3g_/2g]/3Nll38B@34:8302030002
020326434:836><6Lhh2cWT3oml3ool3oml3mih3ked2ic`3S743U983U;83<JH3244300024:836><3
8@@38B@3:DD5:FD3U983S743g_/6ool2oml3_OL6F//3DZX3BVT2BTT32646000324434882F//6DZX3
DXX3BVT3]IH3_ML2mih>ool3mkh3kgd3ked2ia`3g_/3g]/3Nll38B@34:8202030003020326434:83
6><5Lhh3cWT3oml3ool3oml3mih2ked3ic`3S743U983U;83<JH2244300034:836><38@@38B@2:DD6
:FD3U983S743g_/5ool3oml3_OL6F//3DZX2BVT3BTT32646000324424883F//6DZX3DXX3BVT2]IH3
_ML3mihKool001[oo`?g_P;_O@?_G@?W70?Nn`>440<YA@8080<000<8@@=2:0i220>U=0?_G@Koo`;g
_PJme`>mm`=BZP=BRP8@PPH000<8@@<@PP<H``8Hh`=c[P?FVP?og`?oo`?og`;6>0=S30<H``H000<Q
90>4<0F440?F^P?og`?oo`?og`;gWP?_G@?W?0?Nn`?Nf`=kk`8Q90<H``<000<8@@<@PP<@XP_oo`;g
_P?_O@?_G@?W70?Nn`>4408YA@<080<000<8@@=2:0i220>U=0?_G@Goo`?g_PJme`>mm`=BZP9BRP<@
PPH000<8@@<@PP8H``<Hh`=c[P?FVP?og`?oo`;og`?6>0=S30<H``H0008Q90>4<0J440?F^P?og`?o
o`;og`?gWP?_G@?W?0?Nn`?Nf`9kk`<Q90<H``<000<8@@<@PP8@XP_oo`?g_P?_O@?_G@?W70?Nn`:4
40<YA@<080<000<8@@=2:0i220>U=0;_G@Koo`?g_PJme`:mm`=BZP=BRP<@PPH000<8@@8@PP<H``<H
h`=c[P?FVP?og`;oo`?og`?6>0=S30<H``D000<Q90>4<0J440?F^P;og`?oo`?og`?gWP?_G@?W?0;N
n`?Nf`=kk`<Q90<H``<000<8@@8@PP<@XP_oo`?g_P?_O@?_G@;W70?Nn`>440<YA@<080<00088@@=2
:0m220:U=0?_G@Koo`?g_PFme`>mm`=BZP=BRP<@PPD000<8@@<@PP<H``<Hh`=c[P;FVP?og`?oo`?o
g`?6>0=S308H``H000<Q90>4<0J440;F^P?og`?oo`?og`?gWP?_G@;W?0?Nn`?Nf`=kk`<Q90<H``80
00<8@@<@PP<@XQSoo`006_oo0oNn0^mm0nmM0nLL0mkk0h@@0bU50P0P0`000`Q10d8X3T880jDd0nmM
1_oo0_Nn1[gG0kgg0e:Z0e::0Q221P000`Q10a220aS30QSS0g>^0mJJ0ooO0ooo0ooO0/Hh0f<<0aS3
1P000b4T0h@`1H@@0mJj0ooO0ooo0ooO0_NN0nmM0nLl0mkk0mkK0g__0R4T0aS30`000`Q10a220a2R
2ooo0_Nn0nmm0nmM0nLL0mkk0h@@0RU50`0P0`000`Q10d8X3T880jDd0nmM1Ooo0oNn1[gG0kgg0e:Z
0U::0a221P000`Q10a220QS30aSS0g>^0mJJ0ooO0ooo0_oO0lHh0f<<0aS31P000R4T0h@`1X@@0mJj
0ooO0ooo0_oO0oNN0nmM0nLl0mkk0mkK0W__0b4T0aS30`000`Q10a220Q2R2ooo0oNn0nmm0nmM0nLL
0mkk0X@@0bU50`0P0`000`Q10d8X3T880jDd0^mM1_oo0oNn1[gG0[gg0e:Z0e::0a221P000`Q10Q22
0aS30aSS0g>^0mJJ0ooO0_oo0ooO0lHh0f<<0aS31@000b4T0h@`1X@@0mJj0_oO0ooo0ooO0oNN0nmM
0nLl0]kk0mkK0g__0b4T0aS30`000`Q10Q220a2R2ooo0oNn0nmm0nmM0^LL0mkk0h@@0bU50`0P0`00
0PQ10d8X3d880ZDd0nmM1_oo0oNn1KgG0kgg0e:Z0e::0a221@000`Q10a220aS30aSS0g>^0]JJ0ooO
0ooo0ooO0lHh0f<<0QS31P000b4T0h@`1X@@0]Jj0ooO0ooo0ooO0oNN0nmM0^Ll0mkk0mkK0g__0b4T
0aS30P000`Q10a220a2R6?oo000Jool3mkh2kgd3ked3ia`3g_/3Q103:DD2020300032443@RP>@PP3
YC@3ked6ool2mkh6_ML3_OL3DZX3DXX248860003244348836<<26><3Ljh3eYX3oml3ool3oml2aSP3
H``36<<600038B@3Q305Q103e[X3oml3ool3oml2mih3ked3ic`3g_/3g]/3Nnl28B@36<<300032443
48834:8;ool2mkh3kgd3ked3ia`3g_/3Q102:DD3020300032443@RP>@PP3YC@3ked5ool3mkh6_ML3
_OL3DZX2DXX348860003244348826<<36><3Ljh3eYX3oml3ool2oml3aSP3H``36<<600028B@3Q306
Q103e[X3oml3ool2oml3mih3ked3ic`3g_/3g]/2Nnl38B@36<<30003244348824:8;ool3mkh3kgd3
ked3ia`3g_/2Q103:DD3020300032443@RP>@PP3YC@2ked6ool3mkh6_ML2_OL3DZX3DXX348860003
244248836<<36><3Ljh3eYX3oml2ool3oml3aSP3H``36<<500038B@3Q306Q103e[X2oml3ool3oml3
mih3ked3ic`2g_/3g]/3Nnl38B@36<<30003244248834:8;ool3mkh3kgd3ked2ia`3g_/3Q103:DD3
020300022443@RP?@PP2YC@3ked6ool3mkh5_ML3_OL3DZX3DXX348850003244348836<<36><3Ljh2
eYX3oml3ool3oml3aSP3H``26<<600038B@3Q306Q102e[X3oml3ool3oml3mih3ked2ic`3g_/3g]/3
Nnl38B@36<<20003244348834:8Hool001[oo`?g_P;_O@?_G@?W70?Nn`>440<YA@8080<000<8@@=2
:0i220>U=0?_G@Koo`;g_PJme`>mm`=BZP=BRP8@PPH000<8@@<@PP<H``8Hh`=c[P?FVP?og`?oo`?o
g`;6>0=S30<H``H000<Q90>4<0F440?F^P?og`?oo`?og`;gWP?_G@?W?0?Nn`?Nf`=kk`8Q90<H``<0
00<8@@<@PP<@XP_oo`;g_P?_O@?_G@?W70?Nn`>4408YA@<080<000<8@@=2:0i220>U=0?_G@Goo`?g
_PJme`>mm`=BZP9BRP<@PPH000<8@@<@PP8H``<Hh`=c[P?FVP?og`?oo`;og`?6>0=S30<H``H0008Q
90>4<0J440?F^P?og`?oo`;og`?gWP?_G@?W?0?Nn`?Nf`9kk`<Q90<H``<000<8@@<@PP8@XP_oo`?g
_P?_O@?_G@?W70?Nn`:440<YA@<080<000<8@@=2:0i220>U=0;_G@Koo`?g_PJme`:mm`=BZP=BRP<@
PPH000<8@@8@PP<H``<Hh`=c[P?FVP?og`;oo`?og`?6>0=S30<H``D000<Q90>4<0J440?F^P;og`?o
o`?og`?gWP?_G@?W?0;Nn`?Nf`=kk`<Q90<H``<000<8@@8@PP<@XP_oo`?g_P?_O@?_G@;W70?Nn`>4
40<YA@<080<00088@@=2:0m220:U=0?_G@Koo`?g_PFme`>mm`=BZP=BRP<@PPD000<8@@<@PP<H``<H
h`=c[P;FVP?og`?oo`?og`?6>0=S308H``H000<Q90>4<0J440;F^P?og`?oo`?og`?gWP?_G@;W?0?N
n`?Nf`=kk`<Q90<H``8000<8@@<@PP<@XQSoo`006_oo0oNn0^mm0nmM0nLL0mkk0h@@0bU50P0P0`00
0`Q10d8X3T880jDd0nmM1_oo0_Nn1[gG0kgg0e:Z0e::0Q221P000`Q10a220aS30QSS0g>^0mJJ0ooO
0ooo0ooO0/Hh0f<<0aS31P000b4T0h@`1H@@0mJj0ooO0ooo0ooO0_NN0nmM0nLl0mkk0mkK0g__0R4T
0aS30`000`Q10a220a2R2ooo0_Nn0nmm0nmM0nLL0mkk0h@@0RU50`0P0`000`Q10d8X3T880jDd0nmM
1Ooo0oNn1[gG0kgg0e:Z0U::0a221P000`Q10a220QS30aSS0g>^0mJJ0ooO0ooo0_oO0lHh0f<<0aS3
1P000R4T0h@`1X@@0mJj0ooO0ooo0_oO0oNN0nmM0nLl0mkk0mkK0W__0b4T0aS30`000`Q10a220Q2R
2ooo0oNn0nmm0nmM0nLL0mkk0X@@0bU50`0P0`000`Q10d8X3T880jDd0^mM1_oo0oNn1[gG0[gg0e:Z
0e::0a221P000`Q10Q220aS30aSS0g>^0mJJ0ooO0_oo0ooO0lHh0f<<0aS31@000b4T0h@`1X@@0mJj
0_oO0ooo0ooO0oNN0nmM0nLl0]kk0mkK0g__0b4T0aS30`000`Q10Q220a2R2ooo0oNn0nmm0nmM0^LL
0mkk0h@@0bU50`0P0`000PQ10d8X3d880ZDd0nmM1_oo0oNn1KgG0kgg0e:Z0e::0a221@000`Q10a22
0aS30aSS0g>^0]JJ0ooO0ooo0ooO0lHh0f<<0QS31P000b4T0h@`1X@@0]Jj0ooO0ooo0ooO0oNN0nmM
0^Ll0mkk0mkK0g__0b4T0aS30P000`Q10a220a2R6?oo000Jool3mkh2kgd3ked3ia`3g_/3Q103:DD2
020300032443@RP>@PP3YC@3ked6ool2mkh6_ML3_OL3DZX3DXX248860003244348836<<26><3Ljh3
eYX3oml3ool3oml2aSP3H``36<<600038B@3Q305Q103e[X3oml3ool3oml2mih3ked3ic`3g_/3g]/3
Nnl28B@36<<30003244348834:8;ool2mkh3kgd3ked3ia`3g_/3Q102:DD3020300032443@RP>@PP3
YC@3ked5ool3mkh6_ML3_OL3DZX2DXX348860003244348826<<36><3Ljh3eYX3oml3ool2oml3aSP3
H``36<<600028B@3Q306Q103e[X3oml3ool2oml3mih3ked3ic`3g_/3g]/2Nnl38B@36<<300032443
48824:8;ool3mkh3kgd3ked3ia`3g_/2Q103:DD3020300032443@RP>@PP3YC@2ked6ool3mkh6_ML2
_OL3DZX3DXX348860003244248836<<36><3Ljh3eYX3oml2ool3oml3aSP3H``36<<500038B@3Q306
Q103e[X2oml3ool3oml3mih3ked3ic`2g_/3g]/3Nnl38B@36<<30003244248834:8;ool3mkh3kgd3
ked2ia`3g_/3Q103:DD3020300022443@RP?@PP2YC@3ked6ool3mkh5_ML3_OL3DZX3DXX348850003
244348836<<36><3Ljh2eYX3oml3ool3oml3aSP3H``26<<600038B@3Q306Q102e[X3oml3ool3oml3
mih3ked2ic`3g_/3g]/3Nnl38B@36<<20003244348834:8Hool001[oo`?g_P;_O@?_G@?W70?Nn`>4
40<YA@8080<000<8@@=2:0i220>U=0?_G@Koo`;g_PJme`>mm`=BZP=BRP8@PPH000<8@@<@PP<H``8H
h`=c[P?FVP?og`?oo`?og`;6>0=S30<H``H000<Q90>4<0F440?F^P?og`?oo`?og`;gWP?_G@?W?0?N
n`?Nf`=kk`8Q90<H``<000<8@@<@PP<@XP_oo`;g_P?_O@?_G@?W70?Nn`>4408YA@<080<000<8@@=2
:0i220>U=0?_G@Goo`?g_PJme`>mm`=BZP9BRP<@PPH000<8@@<@PP8H``<Hh`=c[P?FVP?og`?oo`;o
g`?6>0=S30<H``H0008Q90>4<0J440?F^P?og`?oo`;og`?gWP?_G@?W?0?Nn`?Nf`9kk`<Q90<H``<0
00<8@@<@PP8@XP_oo`?g_P?_O@?_G@?W70?Nn`:440<YA@<080<000<8@@=2:0i220>U=0;_G@Koo`?g
_PJme`:mm`=BZP=BRP<@PPH000<8@@8@PP<H``<Hh`=c[P?FVP?og`;oo`?og`?6>0=S30<H``D000<Q
90>4<0J440?F^P;og`?oo`?og`?gWP?_G@?W?0;Nn`?Nf`=kk`<Q90<H``<000<8@@8@PP<@XP_oo`?g
_P?_O@?_G@;W70?Nn`>440<YA@<080<00088@@=2:0m220:U=0?_G@Koo`?g_PFme`>mm`=BZP=BRP<@
PPD000<8@@<@PP<H``<Hh`=c[P;FVP?og`?oo`?og`?6>0=S308H``H000<Q90>4<0J440;F^P?og`?o
o`?og`?gWP?_G@;W?0?Nn`?Nf`=kk`<Q90<H``8000<8@@<@PP<@XQSoo`006_oo0oNn0^mm0nmM0nLL
0mkk0h@@0bU50P0P0`000`Q10d8X3T880jDd0nmM1_oo0_Nn1[gG0kgg0e:Z0e::0Q221P000`Q10a22
0aS30QSS0g>^0mJJ0ooO0ooo0ooO0/Hh0f<<0aS31P000b4T0h@`1H@@0mJj0ooO0ooo0ooO0_NN0nmM
0nLl0mkk0mkK0g__0R4T0aS30`000`Q10a220a2R2ooo0_Nn0nmm0nmM0nLL0mkk0h@@0RU50`0P0`00
0`Q10d8X3T880jDd0nmM1Ooo0oNn1[gG0kgg0e:Z0U::0a221P000`Q10a220QS30aSS0g>^0mJJ0ooO
0ooo0_oO0lHh0f<<0aS31P000R4T0h@`1X@@0mJj0ooO0ooo0_oO0oNN0nmM0nLl0mkk0mkK0W__0b4T
0aS30`000`Q10a220Q2R2ooo0oNn0nmm0nmM0nLL0mkk0X@@0bU50`0P0`000`Q10d8X3T880jDd0^mM
1_oo0oNn1[gG0[gg0e:Z0e::0a221P000`Q10Q220aS30aSS0g>^0mJJ0ooO0_oo0ooO0lHh0f<<0aS3
1@000b4T0h@`1X@@0mJj0_oO0ooo0ooO0oNN0nmM0nLl0]kk0mkK0g__0b4T0aS30`000`Q10Q220a2R
2ooo0oNn0nmm0nmM0^LL0mkk0h@@0bU50`0P0`000PQ10d8X3d880ZDd0nmM1_oo0oNn1KgG0kgg0e:Z
0e::0a221@000`Q10a220aS30aSS0g>^0]JJ0ooO0ooo0ooO0lHh0f<<0QS31P000b4T0h@`1X@@0]Jj
0ooO0ooo0ooO0oNN0nmM0^Ll0mkk0mkK0g__0b4T0aS30P000`Q10a220a2R6?oo000Jool3mkh2kgd3
ked3ia`3g_/3Q103:DD2020300032443@RP>@PP3YC@3ked6ool2mkh6_ML3_OL3DZX3DXX248860003
244348836<<26><3Ljh3eYX3oml3ool3oml2aSP3H``36<<600038B@3Q305Q103e[X3oml3ool3oml2
mih3ked3ic`3g_/3g]/3Nnl28B@36<<30003244348834:8;ool2mkh3kgd3ked3ia`3g_/3Q102:DD3
020300032443@RP>@PP3YC@3ked5ool3mkh6_ML3_OL3DZX2DXX348860003244348826<<36><3Ljh3
eYX3oml3ool2oml3aSP3H``36<<600028B@3Q306Q103e[X3oml3ool2oml3mih3ked3ic`3g_/3g]/2
Nnl38B@36<<30003244348824:8;ool3mkh3kgd3ked3ia`3g_/2Q103:DD3020300032443@RP>@PP3
YC@2ked6ool3mkh6_ML2_OL3DZX3DXX348860003244248836<<36><3Ljh3eYX3oml2ool3oml3aSP3
H``36<<500038B@3Q306Q103e[X2oml3ool3oml3mih3ked3ic`2g_/3g]/3Nnl38B@36<<300032442
48834:8;ool3mkh3kgd3ked2ia`3g_/3Q103:DD3020300022443@RP?@PP2YC@3ked6ool3mkh5_ML3
_OL3DZX3DXX348850003244348836<<36><3Ljh2eYX3oml3ool3oml3aSP3H``26<<600038B@3Q306
Q102e[X3oml3ool3oml3mih3ked2ic`3g_/3g]/3Nnl38B@36<<20003244348834:8Hool001[oo`?g
_P;_O@?_G@?W70?Nn`>440<YA@8080<000<8@@=2:0i220>U=0?_G@Koo`;g_PJme`>mm`=BZP=BRP8@
PPH000<8@@<@PP<H``8Hh`=c[P?FVP?og`?oo`?og`;6>0=S30<H``H000<Q90>4<0F440?F^P?og`?o
o`?og`;gWP?_G@?W?0?Nn`?Nf`=kk`8Q90<H``<000<8@@<@PP<@XP_oo`;g_P?_O@?_G@?W70?Nn`>4
408YA@<080<000<8@@=2:0i220>U=0?_G@Goo`?g_PJme`>mm`=BZP9BRP<@PPH000<8@@<@PP8H``<H
h`=c[P?FVP?og`?oo`;og`?6>0=S30<H``H0008Q90>4<0J440?F^P?og`?oo`;og`?gWP?_G@?W?0?N
n`?Nf`9kk`<Q90<H``<000<8@@<@PP8@XP_oo`?g_P?_O@?_G@?W70?Nn`:440<YA@<080<000<8@@=2
:0i220>U=0;_G@Koo`?g_PJme`:mm`=BZP=BRP<@PPH000<8@@8@PP<H``<Hh`=c[P?FVP?og`;oo`?o
g`?6>0=S30<H``D000<Q90>4<0J440?F^P;og`?oo`?og`?gWP?_G@?W?0;Nn`?Nf`=kk`<Q90<H``<0
00<8@@8@PP<@XP_oo`?g_P?_O@?_G@;W70?Nn`>440<YA@<080<00088@@=2:0m220:U=0?_G@Koo`?g
_PFme`>mm`=BZP=BRP<@PPD000<8@@<@PP<H``<Hh`=c[P;FVP?og`?oo`?og`?6>0=S308H``H000<Q
90>4<0J440;F^P?og`?oo`?og`?gWP?_G@;W?0?Nn`?Nf`=kk`<Q90<H``8000<8@@<@PP<@XQSoo`00
6_oo0oNn0^mm0nmM0nLL0mkk0h@@0bU50P0P0`000`Q10d8X3T880jDd0nmM1_oo0_Nn1[gG0kgg0e:Z
0e::0Q221P000`Q10a220aS30QSS0g>^0mJJ0ooO0ooo0ooO0/Hh0f<<0aS31P000b4T0h@`1H@@0mJj
0ooO0ooo0ooO0_NN0nmM0nLl0mkk0mkK0g__0R4T0aS30`000`Q10a220a2R2ooo0_Nn0nmm0nmM0nLL
0mkk0h@@0RU50`0P0`000`Q10d8X3T880jDd0nmM1Ooo0oNn1[gG0kgg0e:Z0U::0a221P000`Q10a22
0QS30aSS0g>^0mJJ0ooO0ooo0_oO0lHh0f<<0aS31P000R4T0h@`1X@@0mJj0ooO0ooo0_oO0oNN0nmM
0nLl0mkk0mkK0W__0b4T0aS30`000`Q10a220Q2R2ooo0oNn0nmm0nmM0nLL0mkk0X@@0bU50`0P0`00
0`Q10d8X3T880jDd0^mM1_oo0oNn1[gG0[gg0e:Z0e::0a221P000`Q10Q220aS30aSS0g>^0mJJ0ooO
0_oo0ooO0lHh0f<<0aS31@000b4T0h@`1X@@0mJj0_oO0ooo0ooO0oNN0nmM0nLl0]kk0mkK0g__0b4T
0aS30`000`Q10Q220a2R2ooo0oNn0nmm0nmM0^LL0mkk0h@@0bU50`0P0`000PQ10d8X3d880ZDd0nmM
1_oo0oNn1KgG0kgg0e:Z0e::0a221@000`Q10a220aS30aSS0g>^0]JJ0ooO0ooo0ooO0lHh0f<<0QS3
1P000b4T0h@`1X@@0]Jj0ooO0ooo0ooO0oNN0nmM0^Ll0mkk0mkK0g__0b4T0aS30P000`Q10a220a2R
6?oo000Jool3mkh2kgd3ked3ia`3g_/3Q103:DD2020300032443@RP>@PP3YC@3ked6ool2mkh6_ML3
_OL3DZX3DXX248860003244348836<<26><3Ljh3eYX3oml3ool3oml2aSP3H``36<<600038B@3Q305
Q103e[X3oml3ool3oml2mih3ked3ic`3g_/3g]/3Nnl28B@36<<30003244348834:8;ool2mkh3kgd3
ked3ia`3g_/3Q102:DD3020300032443@RP>@PP3YC@3ked5ool3mkh6_ML3_OL3DZX2DXX348860003
244348826<<36><3Ljh3eYX3oml3ool2oml3aSP3H``36<<600028B@3Q306Q103e[X3oml3ool2oml3
mih3ked3ic`3g_/3g]/2Nnl38B@36<<30003244348824:8;ool3mkh3kgd3ked3ia`3g_/2Q103:DD3
020300032443@RP>@PP3YC@2ked6ool3mkh6_ML2_OL3DZX3DXX348860003244248836<<36><3Ljh3
eYX3oml2ool3oml3aSP3H``36<<500038B@3Q306Q103e[X2oml3ool3oml3mih3ked3ic`2g_/3g]/3
Nnl38B@36<<30003244248834:8;ool3mkh3kgd3ked2ia`3g_/3Q103:DD3020300022443@RP?@PP2
YC@3ked6ool3mkh5_ML3_OL3DZX3DXX348850003244348836<<36><3Ljh2eYX3oml3ool3oml3aSP3
H``26<<600038B@3Q306Q102e[X3oml3ool3oml3mih3ked2ic`3g_/3g]/3Nnl38B@36<<200032443
48834:8Hool001Ooo`=[C@?>F@;g_P?oo`?og`?>F@=S;0<H``D000<080<8H@<@XP=[C@?>F@;F^P?o
g`?oo`?og`?gWP>]M@9:B@<8H@H000<8@@E:B@=2:0>]M@?_O@?og`?oo`;g_P?_O@?W?0?W70><D@<Y
I@8Hh`<8H@H000<8@@<@PP<H``8Hh`=c[P?FVP?W70?gWPGoo`?FVPK>N@K>F@ES;0<H``<8@@<000<@
PPSoo`=[C@;>F@?g_P?oo`?og`?>F@=S;08H``H000<080<8H@<@XP9[C@?>F@?F^P?og`?oo`?og`;g
WP>]M@=:B@<8H@H000<8@@E:B@=2:0>]M@?_O@?og`;oo`?g_P?_O@?W?0?W70><D@8YI@<Hh`<8H@H0
00<8@@8@PP<H``<Hh`=c[P?FVP?W70?gWPGoo`?FVPK>N@G>F@IS;0<H``<8@@<0008@PPWoo`9[C@?>
F@?g_P?oo`?og`?>F@9S;0<H``H000<080<8H@8@XP=[C@?>F@?F^P?og`?oo`;og`?gWP>]M@=:B@<8
H@D000<8@@I:B@=2:0>]M@?_O@;og`?oo`?g_P?_O@?W?0?W70:<D@<YI@<Hh`<8H@H00088@@<@PP<H
``<Hh`=c[P?FVP;W70?gWPKoo`?FVPG>N@K>F@IS;0<H``<8@@8000<@PPSoo`=[C@?>F@?g_P?oo`;o
g`?>F@=S;0<H``H0008080<8H@<@XP=[C@?>F@?F^P?og`;oo`?og`?gWP>]M@=:B@<8H@D000<8@@I:
B@=2:0:]M@?_O@?og`?oo`?g_P?_O@;W?0?W70><D@<YI@<Hh`<8H@D000<8@@<@PP<H``<Hh`=c[P;F
VP?W70?gWPKoo`?FVPG>N@K>F@IS;08H``<8@@<000<@PQSoo`005ooo0f]=0liI0_Nn0ooo0ooO0liI
0f</0aS31@000`0P0`QQ0a2R0f]=0liI0]Jj0ooO0ooo0ooO0oNN0jee0TY90`QQ1P000`Q11DY90d8X
0jee0nmm0ooO0ooo0_Nn0nmm0nLl0nLL0haA0bUU0QSS0`QQ1P000`Q10a220aS30QSS0g>^0mJJ0nLL
0oNN1Ooo0mJJ1/ii1/iI1F</0aS30`Q10`000a222?oo0f]=0/iI0oNn0ooo0ooO0liI0f</0QS31P00
0`0P0`QQ0a2R0V]=0liI0mJj0ooO0ooo0ooO0_NN0jee0dY90`QQ1P000`Q11DY90d8X0jee0nmm0ooO
0_oo0oNn0nmm0nLl0nLL0haA0RUU0aSS0`QQ1P000`Q10Q220aS30aSS0g>^0mJJ0nLL0oNN1Ooo0mJJ
1/ii1LiI1V</0aS30`Q10`000Q222Ooo0V]=0liI0oNn0ooo0ooO0liI0V</0aS31P000`0P0`QQ0Q2R
0f]=0liI0mJj0ooO0ooo0_oO0oNN0jee0dY90`QQ1@000`Q11TY90d8X0jee0nmm0_oO0ooo0oNn0nmm
0nLl0nLL0XaA0bUU0aSS0`QQ1P000PQ10a220aS30aSS0g>^0mJJ0^LL0oNN1_oo0mJJ1Lii1/iI1V</
0aS30`Q10P000a222?oo0f]=0liI0oNn0ooo0_oO0liI0f</0aS31P000P0P0`QQ0a2R0f]=0liI0mJj
0ooO0_oo0ooO0oNN0jee0dY90`QQ1@000`Q11TY90d8X0Zee0nmm0ooO0ooo0oNn0nmm0^Ll0nLL0haA
0bUU0aSS0`QQ1@000`Q10a220aS30aSS0g>^0]JJ0nLL0oNN1_oo0mJJ1Lii1/iI1V</0QS30`Q10`00
0a226?oo000Gool3Jdd3cUT2mkh3ool3oml3cUT3Hb`36<<50003020326434:83Jdd3cUT2e[X3oml3
ool3oml3mih3[GD2BTT3264600032445BTT3@RP3[GD3kgd3oml3ool2mkh3kgd3ic`3ia`3S543:FD2
6><326460003244348836<<26><3Ljh3eYX3ia`3mih5ool3eYX6cWT6cUT5Hb`36<<3244300034888
ool3Jdd2cUT3mkh3ool3oml3cUT3Hb`26<<60003020326434:82Jdd3cUT3e[X3oml3ool3oml2mih3
[GD3BTT3264600032445BTT3@RP3[GD3kgd3oml2ool3mkh3kgd3ic`3ia`3S542:FD36><326460003
244248836<<36><3Ljh3eYX3ia`3mih5ool3eYX6cWT5cUT6Hb`36<<3244300024889ool2Jdd3cUT3
mkh3ool3oml3cUT2Hb`36<<60003020326424:83Jdd3cUT3e[X3oml3ool2oml3mih3[GD3BTT32645
00032446BTT3@RP3[GD3kgd2oml3ool3mkh3kgd3ic`3ia`2S543:FD36><326460002244348836<<3
6><3Ljh3eYX2ia`3mih6ool3eYX5cWT6cUT6Hb`36<<3244200034888ool3Jdd3cUT3mkh3ool2oml3
cUT3Hb`36<<60002020326434:83Jdd3cUT3e[X3oml2ool3oml3mih3[GD3BTT3264500032446BTT3
@RP2[GD3kgd3oml3ool3mkh3kgd2ic`3ia`3S543:FD36><326450003244348836<<36><3Ljh2eYX3
ia`3mih6ool3eYX5cWT6cUT6Hb`26<<324430003488Hool001Ooo`=[C@?>F@;g_P?oo`?og`?>F@=S
;0<H``D000<080<8H@<@XP=[C@?>F@;F^P?og`?oo`?og`?gWP>]M@9:B@<8H@H000<8@@E:B@=2:0>]
M@?_O@?og`?oo`;g_P?_O@?W?0?W70><D@<YI@8Hh`<8H@H000<8@@<@PP<H``8Hh`=c[P?FVP?W70?g
WPGoo`?FVPK>N@K>F@ES;0<H``<8@@<000<@PPSoo`=[C@;>F@?g_P?oo`?og`?>F@=S;08H``H000<0
80<8H@<@XP9[C@?>F@?F^P?og`?oo`?og`;gWP>]M@=:B@<8H@H000<8@@E:B@=2:0>]M@?_O@?og`;o
o`?g_P?_O@?W?0?W70><D@8YI@<Hh`<8H@H000<8@@8@PP<H``<Hh`=c[P?FVP?W70?gWPGoo`?FVPK>
N@G>F@IS;0<H``<8@@<0008@PPWoo`9[C@?>F@?g_P?oo`?og`?>F@9S;0<H``H000<080<8H@8@XP=[
C@?>F@?F^P?og`?oo`;og`?gWP>]M@=:B@<8H@D000<8@@I:B@=2:0>]M@?_O@;og`?oo`?g_P?_O@?W
?0?W70:<D@<YI@<Hh`<8H@H00088@@<@PP<H``<Hh`=c[P?FVP;W70?gWPKoo`?FVPG>N@K>F@IS;0<H
``<8@@8000<@PPSoo`=[C@?>F@?g_P?oo`;og`?>F@=S;0<H``H0008080<8H@<@XP=[C@?>F@?F^P?o
g`;oo`?og`?gWP>]M@=:B@<8H@D000<8@@I:B@=2:0:]M@?_O@?og`?oo`?g_P?_O@;W?0?W70><D@<Y
I@<Hh`<8H@D000<8@@<@PP<H``<Hh`=c[P;FVP?W70?gWPKoo`?FVPG>N@K>F@IS;08H``<8@@<000<@
PQSoo`005ooo0f]=0liI0_Nn0ooo0ooO0liI0f</0aS31@000`0P0`QQ0a2R0f]=0liI0]Jj0ooO0ooo
0ooO0oNN0jee0TY90`QQ1P000`Q11DY90d8X0jee0nmm0ooO0ooo0_Nn0nmm0nLl0nLL0haA0bUU0QSS
0`QQ1P000`Q10a220aS30QSS0g>^0mJJ0nLL0oNN1Ooo0mJJ1/ii1/iI1F</0aS30`Q10`000a222?oo
0f]=0/iI0oNn0ooo0ooO0liI0f</0QS31P000`0P0`QQ0a2R0V]=0liI0mJj0ooO0ooo0ooO0_NN0jee
0dY90`QQ1P000`Q11DY90d8X0jee0nmm0ooO0_oo0oNn0nmm0nLl0nLL0haA0RUU0aSS0`QQ1P000`Q1
0Q220aS30aSS0g>^0mJJ0nLL0oNN1Ooo0mJJ1/ii1LiI1V</0aS30`Q10`000Q222Ooo0V]=0liI0oNn
0ooo0ooO0liI0V</0aS31P000`0P0`QQ0Q2R0f]=0liI0mJj0ooO0ooo0_oO0oNN0jee0dY90`QQ1@00
0`Q11TY90d8X0jee0nmm0_oO0ooo0oNn0nmm0nLl0nLL0XaA0bUU0aSS0`QQ1P000PQ10a220aS30aSS
0g>^0mJJ0^LL0oNN1_oo0mJJ1Lii1/iI1V</0aS30`Q10P000a222?oo0f]=0liI0oNn0ooo0_oO0liI
0f</0aS31P000P0P0`QQ0a2R0f]=0liI0mJj0ooO0_oo0ooO0oNN0jee0dY90`QQ1@000`Q11TY90d8X
0Zee0nmm0ooO0ooo0oNn0nmm0^Ll0nLL0haA0bUU0aSS0`QQ1@000`Q10a220aS30aSS0g>^0]JJ0nLL
0oNN1_oo0mJJ1Lii1/iI1V</0QS30`Q10`000a226?oo000Gool3Jdd3cUT2mkh3ool3oml3cUT3Hb`3
6<<50003020326434:83Jdd3cUT2e[X3oml3ool3oml3mih3[GD2BTT3264600032445BTT3@RP3[GD3
kgd3oml3ool2mkh3kgd3ic`3ia`3S543:FD26><326460003244348836<<26><3Ljh3eYX3ia`3mih5
ool3eYX6cWT6cUT5Hb`36<<3244300034888ool3Jdd2cUT3mkh3ool3oml3cUT3Hb`26<<600030203
26434:82Jdd3cUT3e[X3oml3ool3oml2mih3[GD3BTT3264600032445BTT3@RP3[GD3kgd3oml2ool3
mkh3kgd3ic`3ia`3S542:FD36><326460003244248836<<36><3Ljh3eYX3ia`3mih5ool3eYX6cWT5
cUT6Hb`36<<3244300024889ool2Jdd3cUT3mkh3ool3oml3cUT2Hb`36<<60003020326424:83Jdd3
cUT3e[X3oml3ool2oml3mih3[GD3BTT3264500032446BTT3@RP3[GD3kgd2oml3ool3mkh3kgd3ic`3
ia`2S543:FD36><326460002244348836<<36><3Ljh3eYX2ia`3mih6ool3eYX5cWT6cUT6Hb`36<<3
244200034888ool3Jdd3cUT3mkh3ool2oml3cUT3Hb`36<<60002020326434:83Jdd3cUT3e[X3oml2
ool3oml3mih3[GD3BTT3264500032446BTT3@RP2[GD3kgd3oml3ool3mkh3kgd2ic`3ia`3S543:FD3
6><326450003244348836<<36><3Ljh2eYX3ia`3mih6ool3eYX5cWT6cUT6Hb`26<<324430003488H
ool001Ooo`=[C@?>F@;g_P?oo`?og`?>F@=S;0<H``D000<080<8H@<@XP=[C@?>F@;F^P?og`?oo`?o
g`?gWP>]M@9:B@<8H@H000<8@@E:B@=2:0>]M@?_O@?og`?oo`;g_P?_O@?W?0?W70><D@<YI@8Hh`<8
H@H000<8@@<@PP<H``8Hh`=c[P?FVP?W70?gWPGoo`?FVPK>N@K>F@ES;0<H``<8@@<000<@PPSoo`=[
C@;>F@?g_P?oo`?og`?>F@=S;08H``H000<080<8H@<@XP9[C@?>F@?F^P?og`?oo`?og`;gWP>]M@=:
B@<8H@H000<8@@E:B@=2:0>]M@?_O@?og`;oo`?g_P?_O@?W?0?W70><D@8YI@<Hh`<8H@H000<8@@8@
PP<H``<Hh`=c[P?FVP?W70?gWPGoo`?FVPK>N@G>F@IS;0<H``<8@@<0008@PPWoo`9[C@?>F@?g_P?o
o`?og`?>F@9S;0<H``H000<080<8H@8@XP=[C@?>F@?F^P?og`?oo`;og`?gWP>]M@=:B@<8H@D000<8
@@I:B@=2:0>]M@?_O@;og`?oo`?g_P?_O@?W?0?W70:<D@<YI@<Hh`<8H@H00088@@<@PP<H``<Hh`=c
[P?FVP;W70?gWPKoo`?FVPG>N@K>F@IS;0<H``<8@@8000<@PPSoo`=[C@?>F@?g_P?oo`;og`?>F@=S
;0<H``H0008080<8H@<@XP=[C@?>F@?F^P?og`;oo`?og`?gWP>]M@=:B@<8H@D000<8@@I:B@=2:0:]
M@?_O@?og`?oo`?g_P?_O@;W?0?W70><D@<YI@<Hh`<8H@D000<8@@<@PP<H``<Hh`=c[P;FVP?W70?g
WPKoo`?FVPG>N@K>F@IS;08H``<8@@<000<@PQSoo`005ooo0f]=0liI0_Nn0ooo0ooO0liI0f</0aS3
1@000`0P0`QQ0a2R0f]=0liI0]Jj0ooO0ooo0ooO0oNN0jee0TY90`QQ1P000`Q11DY90d8X0jee0nmm
0ooO0ooo0_Nn0nmm0nLl0nLL0haA0bUU0QSS0`QQ1P000`Q10a220aS30QSS0g>^0mJJ0nLL0oNN1Ooo
0mJJ1/ii1/iI1F</0aS30`Q10`000a222?oo0f]=0/iI0oNn0ooo0ooO0liI0f</0QS31P000`0P0`QQ
0a2R0V]=0liI0mJj0ooO0ooo0ooO0_NN0jee0dY90`QQ1P000`Q11DY90d8X0jee0nmm0ooO0_oo0oNn
0nmm0nLl0nLL0haA0RUU0aSS0`QQ1P000`Q10Q220aS30aSS0g>^0mJJ0nLL0oNN1Ooo0mJJ1/ii1LiI
1V</0aS30`Q10`000Q222Ooo0V]=0liI0oNn0ooo0ooO0liI0V</0aS31P000`0P0`QQ0Q2R0f]=0liI
0mJj0ooO0ooo0_oO0oNN0jee0dY90`QQ1@000`Q11TY90d8X0jee0nmm0_oO0ooo0oNn0nmm0nLl0nLL
0XaA0bUU0aSS0`QQ1P000PQ10a220aS30aSS0g>^0mJJ0^LL0oNN1_oo0mJJ1Lii1/iI1V</0aS30`Q1
0P000a222?oo0f]=0liI0oNn0ooo0_oO0liI0f</0aS31P000P0P0`QQ0a2R0f]=0liI0mJj0ooO0_oo
0ooO0oNN0jee0dY90`QQ1@000`Q11TY90d8X0Zee0nmm0ooO0ooo0oNn0nmm0^Ll0nLL0haA0bUU0aSS
0`QQ1@000`Q10a220aS30aSS0g>^0]JJ0nLL0oNN1_oo0mJJ1Lii1/iI1V</0QS30`Q10`000a226?oo
000Gool3Jdd3cUT2mkh3ool3oml3cUT3Hb`36<<50003020326434:83Jdd3cUT2e[X3oml3ool3oml3
mih3[GD2BTT3264600032445BTT3@RP3[GD3kgd3oml3ool2mkh3kgd3ic`3ia`3S543:FD26><32646
0003244348836<<26><3Ljh3eYX3ia`3mih5ool3eYX6cWT6cUT5Hb`36<<3244300034888ool3Jdd2
cUT3mkh3ool3oml3cUT3Hb`26<<60003020326434:82Jdd3cUT3e[X3oml3ool3oml2mih3[GD3BTT3
264600032445BTT3@RP3[GD3kgd3oml2ool3mkh3kgd3ic`3ia`3S542:FD36><32646000324424883
6<<36><3Ljh3eYX3ia`3mih5ool3eYX6cWT5cUT6Hb`36<<3244300024889ool2Jdd3cUT3mkh3ool3
oml3cUT2Hb`36<<60003020326424:83Jdd3cUT3e[X3oml3ool2oml3mih3[GD3BTT3264500032446
BTT3@RP3[GD3kgd2oml3ool3mkh3kgd3ic`3ia`2S543:FD36><326460002244348836<<36><3Ljh3
eYX2ia`3mih6ool3eYX5cWT6cUT6Hb`36<<3244200034888ool3Jdd3cUT3mkh3ool2oml3cUT3Hb`3
6<<60002020326434:83Jdd3cUT3e[X3oml2ool3oml3mih3[GD3BTT3264500032446BTT3@RP2[GD3
kgd3oml3ool3mkh3kgd2ic`3ia`3S543:FD36><326450003244348836<<36><3Ljh2eYX3ia`3mih6
ool3eYX5cWT6cUT6Hb`26<<324430003488Hool001Ooo`=[C@?>F@;g_P?oo`?og`?>F@=S;0<H``D0
00<080<8H@<@XP=[C@?>F@;F^P?og`?oo`?og`?gWP>]M@9:B@<8H@H000<8@@E:B@=2:0>]M@?_O@?o
g`?oo`;g_P?_O@?W?0?W70><D@<YI@8Hh`<8H@H000<8@@<@PP<H``8Hh`=c[P?FVP?W70?gWPGoo`?F
VPK>N@K>F@ES;0<H``<8@@<000<@PPSoo`=[C@;>F@?g_P?oo`?og`?>F@=S;08H``H000<080<8H@<@
XP9[C@?>F@?F^P?og`?oo`?og`;gWP>]M@=:B@<8H@H000<8@@E:B@=2:0>]M@?_O@?og`;oo`?g_P?_
O@?W?0?W70><D@8YI@<Hh`<8H@H000<8@@8@PP<H``<Hh`=c[P?FVP?W70?gWPGoo`?FVPK>N@G>F@IS
;0<H``<8@@<0008@PPWoo`9[C@?>F@?g_P?oo`?og`?>F@9S;0<H``H000<080<8H@8@XP=[C@?>F@?F
^P?og`?oo`;og`?gWP>]M@=:B@<8H@D000<8@@I:B@=2:0>]M@?_O@;og`?oo`?g_P?_O@?W?0?W70:<
D@<YI@<Hh`<8H@H00088@@<@PP<H``<Hh`=c[P?FVP;W70?gWPKoo`?FVPG>N@K>F@IS;0<H``<8@@80
00<@PPSoo`=[C@?>F@?g_P?oo`;og`?>F@=S;0<H``H0008080<8H@<@XP=[C@?>F@?F^P?og`;oo`?o
g`?gWP>]M@=:B@<8H@D000<8@@I:B@=2:0:]M@?_O@?og`?oo`?g_P?_O@;W?0?W70><D@<YI@<Hh`<8
H@D000<8@@<@PP<H``<Hh`=c[P;FVP?W70?gWPKoo`?FVPG>N@K>F@IS;08H``<8@@<000<@PQSoo`00
5ooo0f]=0liI0_Nn0ooo0ooO0liI0f</0aS31@000`0P0`QQ0a2R0f]=0liI0]Jj0ooO0ooo0ooO0oNN
0jee0TY90`QQ1P000`Q11DY90d8X0jee0nmm0ooO0ooo0_Nn0nmm0nLl0nLL0haA0bUU0QSS0`QQ1P00
0`Q10a220aS30QSS0g>^0mJJ0nLL0oNN1Ooo0mJJ1/ii1/iI1F</0aS30`Q10`000a222?oo0f]=0/iI
0oNn0ooo0ooO0liI0f</0QS31P000`0P0`QQ0a2R0V]=0liI0mJj0ooO0ooo0ooO0_NN0jee0dY90`QQ
1P000`Q11DY90d8X0jee0nmm0ooO0_oo0oNn0nmm0nLl0nLL0haA0RUU0aSS0`QQ1P000`Q10Q220aS3
0aSS0g>^0mJJ0nLL0oNN1Ooo0mJJ1/ii1LiI1V</0aS30`Q10`000Q222Ooo0V]=0liI0oNn0ooo0ooO
0liI0V</0aS31P000`0P0`QQ0Q2R0f]=0liI0mJj0ooO0ooo0_oO0oNN0jee0dY90`QQ1@000`Q11TY9
0d8X0jee0nmm0_oO0ooo0oNn0nmm0nLl0nLL0XaA0bUU0aSS0`QQ1P000PQ10a220aS30aSS0g>^0mJJ
0^LL0oNN1_oo0mJJ1Lii1/iI1V</0aS30`Q10P000a222?oo0f]=0liI0oNn0ooo0_oO0liI0f</0aS3
1P000P0P0`QQ0a2R0f]=0liI0mJj0ooO0_oo0ooO0oNN0jee0dY90`QQ1@000`Q11TY90d8X0Zee0nmm
0ooO0ooo0oNn0nmm0^Ll0nLL0haA0bUU0aSS0`QQ1@000`Q10a220aS30aSS0g>^0]JJ0nLL0oNN1_oo
0mJJ1Lii1/iI1V</0QS30`Q10`000a226?oo000Gool3H``3aQP2mkh6ool3mkh3kgd3W?<2YA@3@PP3
<JH3:DD36><60002020326434:836><3Ljh3cWT2g_/6ool3g_/3Q303:DD202030003020326434:83
Hb`2aSP3mkh6ool3mkh5]IH3]KH3DXX348860003:FD5S743g_/6ool3cWT2Jdd36><600038B@3:DD5
Q303Q106Nnl3Nll8ool3H``2aQP3mkh6ool3mkh3kgd2W?<3YA@3@PP3<JH3:DD36><5000302032643
4:836><2Ljh3cWT3g_/6ool3g_/3Q302:DD302030003020326434:82Hb`3aSP3mkh6ool3mkh5]IH3
]KH3DXX348850003:FD6S743g_/6ool2cWT3Jdd36><600038B@2:DD6Q303Q106Nnl2Nll9ool2H``3
aQP3mkh6ool3mkh2kgd3W?<3YA@3@PP3<JH3:DD26><60003020326434:826><3Ljh3cWT3g_/6ool2
g_/3Q303:DD302030003020326424:83Hb`3aSP3mkh6ool2mkh6]IH3]KH3DXX348850003:FD6S743
g_/5ool3cWT3Jdd36><500038B@3:DD6Q303Q105Nnl3Nll8ool3H``3aQP3mkh5ool3mkh3kgd3W?<3
YA@3@PP2<JH3:DD36><60003020326424:836><3Ljh3cWT3g_/5ool3g_/3Q303:DD3020300020203
26434:83Hb`3aSP3mkh5ool3mkh6]IH3]KH2DXX348860003:FD6S742g_/6ool3cWT3Jdd36><50003
8B@3:DD6Q302Q106Nnl3NllHool001Ooo`=S30?660;g_PKoo`?g_P?_O@>Ll`:U50=220<aYP<YA@<H
h`H0008080<8H@<@XP<Hh`=c[P?>N@;Nn`Koo`?Nn`>4<0<YA@8080<000<080<8H@<@XP=S;0;6>0?g
_PKoo`?g_PFeUP>e]P=BRP<@PPH000<YI@F<L@?Nn`Koo`?>N@9[C@<Hh`H000<Q90<YA@F4<0>440Ik
k`=kc`Soo`=S30;660?g_PKoo`?g_P?_O@:Ll`>U50=220<aYP<YA@<Hh`D000<080<8H@<@XP<Hh`9c
[P?>N@?Nn`Koo`?Nn`>4<08YA@<080<000<080<8H@<@XP9S;0?6>0?g_PKoo`?g_PFeUP>e]P=BRP<@
PPD000<YI@J<L@?Nn`Koo`;>N@=[C@<Hh`H000<Q908YA@J4<0>440Ikk`9kc`Woo`9S30?660?g_PKo
o`?g_P;_O@>Ll`>U50=220<aYP<YA@8Hh`H000<080<8H@<@XP8Hh`=c[P?>N@?Nn`Koo`;Nn`>4<0<Y
A@<080<000<080<8H@8@XP=S;0?6>0?g_PKoo`;g_PJeUP>e]P=BRP<@PPD000<YI@J<L@?Nn`Goo`?>
N@=[C@<Hh`D000<Q90<YA@J4<0>440Ekk`=kc`Soo`=S30?660?g_PGoo`?g_P?_O@>Ll`>U50=2208a
YP<YA@<Hh`H000<080<8H@8@XP<Hh`=c[P?>N@?Nn`Goo`?Nn`>4<0<YA@<080<0008080<8H@<@XP=S
;0?6>0?g_PGoo`?g_PJeUP>e]P9BRP<@PPH000<YI@J<L@;Nn`Koo`?>N@=[C@<Hh`D000<Q90<YA@J4
<0:440Ikk`=kcaSoo`005ooo0f<<0lHH0_Nn1_oo0oNn0nmm0icc0ZDD0d880c6V0bU50aSS1P000P0P
0`QQ0a2R0aSS0g>^0lii0]kk1_oo0mkk0h@`0bU50P0P0`000`0P0`QQ0a2R0f</0/Hh0oNn1_oo0oNn
1KFF0kFf0e::0a221P000bUU1Haa0mkk1_oo0lii0V]=0aSS1P000b4T0bU51H@`0h@@1W__0g_?2?oo
0f<<0/HH0oNn1_oo0oNn0nmm0Ycc0jDD0d880c6V0bU50aSS1@000`0P0`QQ0a2R0aSS0W>^0lii0mkk
1_oo0mkk0h@`0RU50`0P0`000`0P0`QQ0a2R0V</0lHh0oNn1_oo0oNn1KFF0kFf0e::0a221@000bUU
1Xaa0mkk1_oo0/ii0f]=0aSS1P000b4T0RU51X@`0h@@1W__0W_?2Ooo0V<<0lHH0oNn1_oo0oNn0^mm
0icc0jDD0d880c6V0bU50QSS1P000`0P0`QQ0a2R0QSS0g>^0lii0mkk1_oo0]kk0h@`0bU50`0P0`00
0`0P0`QQ0Q2R0f</0lHh0oNn1_oo0_Nn1[FF0kFf0e::0a221@000bUU1Xaa0mkk1Ooo0lii0f]=0aSS
1@000b4T0bU51X@`0h@@1G__0g_?2?oo0f<<0lHH0oNn1Ooo0oNn0nmm0icc0jDD0d880S6V0bU50aSS
1P000`0P0`QQ0Q2R0aSS0g>^0lii0mkk1Ooo0mkk0h@`0bU50`0P0`000P0P0`QQ0a2R0f</0lHh0oNn
1Ooo0oNn1[FF0kFf0U::0a221P000bUU1Xaa0]kk1_oo0lii0f]=0aSS1@000b4T0bU51X@`0X@@1W__
0g_?6?oo000Gool3H``3aQP2mkh6ool3mkh3kgd3W?<2YA@3@PP3<JH3:DD36><60002020326434:83
6><3Ljh3cWT2g_/6ool3g_/3Q303:DD202030003020326434:83Hb`2aSP3mkh6ool3mkh5]IH3]KH3
DXX348860003:FD5S743g_/6ool3cWT2Jdd36><600038B@3:DD5Q303Q106Nnl3Nll8ool3H``2aQP3
mkh6ool3mkh3kgd2W?<3YA@3@PP3<JH3:DD36><50003020326434:836><2Ljh3cWT3g_/6ool3g_/3
Q302:DD302030003020326434:82Hb`3aSP3mkh6ool3mkh5]IH3]KH3DXX348850003:FD6S743g_/6
ool2cWT3Jdd36><600038B@2:DD6Q303Q106Nnl2Nll9ool2H``3aQP3mkh6ool3mkh2kgd3W?<3YA@3
@PP3<JH3:DD26><60003020326434:826><3Ljh3cWT3g_/6ool2g_/3Q303:DD30203000302032642
4:83Hb`3aSP3mkh6ool2mkh6]IH3]KH3DXX348850003:FD6S743g_/5ool3cWT3Jdd36><500038B@3
:DD6Q303Q105Nnl3Nll8ool3H``3aQP3mkh5ool3mkh3kgd3W?<3YA@3@PP2<JH3:DD36><600030203
26424:836><3Ljh3cWT3g_/5ool3g_/3Q303:DD302030002020326434:83Hb`3aSP3mkh5ool3mkh6
]IH3]KH2DXX348860003:FD6S742g_/6ool3cWT3Jdd36><500038B@3:DD6Q302Q106Nnl3NllHool0
01Ooo`=S30?660;g_PKoo`?g_P?_O@>Ll`:U50=220<aYP<YA@<Hh`H0008080<8H@<@XP<Hh`=c[P?>
N@;Nn`Koo`?Nn`>4<0<YA@8080<000<080<8H@<@XP=S;0;6>0?g_PKoo`?g_PFeUP>e]P=BRP<@PPH0
00<YI@F<L@?Nn`Koo`?>N@9[C@<Hh`H000<Q90<YA@F4<0>440Ikk`=kc`Soo`=S30;660?g_PKoo`?g
_P?_O@:Ll`>U50=220<aYP<YA@<Hh`D000<080<8H@<@XP<Hh`9c[P?>N@?Nn`Koo`?Nn`>4<08YA@<0
80<000<080<8H@<@XP9S;0?6>0?g_PKoo`?g_PFeUP>e]P=BRP<@PPD000<YI@J<L@?Nn`Koo`;>N@=[
C@<Hh`H000<Q908YA@J4<0>440Ikk`9kc`Woo`9S30?660?g_PKoo`?g_P;_O@>Ll`>U50=220<aYP<Y
A@8Hh`H000<080<8H@<@XP8Hh`=c[P?>N@?Nn`Koo`;Nn`>4<0<YA@<080<000<080<8H@8@XP=S;0?6
>0?g_PKoo`;g_PJeUP>e]P=BRP<@PPD000<YI@J<L@?Nn`Goo`?>N@=[C@<Hh`D000<Q90<YA@J4<0>4
40Ekk`=kc`Soo`=S30?660?g_PGoo`?g_P?_O@>Ll`>U50=2208aYP<YA@<Hh`H000<080<8H@8@XP<H
h`=c[P?>N@?Nn`Goo`?Nn`>4<0<YA@<080<0008080<8H@<@XP=S;0?6>0?g_PGoo`?g_PJeUP>e]P9B
RP<@PPH000<YI@J<L@;Nn`Koo`?>N@=[C@<Hh`D000<Q90<YA@J4<0:440Ikk`=kcaSoo`005ooo0f<<
0lHH0_Nn1_oo0oNn0nmm0icc0ZDD0d880c6V0bU50aSS1P000P0P0`QQ0a2R0aSS0g>^0lii0]kk1_oo
0mkk0h@`0bU50P0P0`000`0P0`QQ0a2R0f</0/Hh0oNn1_oo0oNn1KFF0kFf0e::0a221P000bUU1Haa
0mkk1_oo0lii0V]=0aSS1P000b4T0bU51H@`0h@@1W__0g_?2?oo0f<<0/HH0oNn1_oo0oNn0nmm0Ycc
0jDD0d880c6V0bU50aSS1@000`0P0`QQ0a2R0aSS0W>^0lii0mkk1_oo0mkk0h@`0RU50`0P0`000`0P
0`QQ0a2R0V</0lHh0oNn1_oo0oNn1KFF0kFf0e::0a221@000bUU1Xaa0mkk1_oo0/ii0f]=0aSS1P00
0b4T0RU51X@`0h@@1W__0W_?2Ooo0V<<0lHH0oNn1_oo0oNn0^mm0icc0jDD0d880c6V0bU50QSS1P00
0`0P0`QQ0a2R0QSS0g>^0lii0mkk1_oo0]kk0h@`0bU50`0P0`000`0P0`QQ0Q2R0f</0lHh0oNn1_oo
0_Nn1[FF0kFf0e::0a221@000bUU1Xaa0mkk1Ooo0lii0f]=0aSS1@000b4T0bU51X@`0h@@1G__0g_?
2?oo0f<<0lHH0oNn1Ooo0oNn0nmm0icc0jDD0d880S6V0bU50aSS1P000`0P0`QQ0Q2R0aSS0g>^0lii
0mkk1Ooo0mkk0h@`0bU50`0P0`000P0P0`QQ0a2R0f</0lHh0oNn1Ooo0oNn1[FF0kFf0U::0a221P00
0bUU1Xaa0]kk1_oo0lii0f]=0aSS1@000b4T0bU51X@`0X@@1W__0g_?6?oo000Gool3H``3aQP2mkh6
ool3mkh3kgd3W?<2YA@3@PP3<JH3:DD36><60002020326434:836><3Ljh3cWT2g_/6ool3g_/3Q303
:DD202030003020326434:83Hb`2aSP3mkh6ool3mkh5]IH3]KH3DXX348860003:FD5S743g_/6ool3
cWT2Jdd36><600038B@3:DD5Q303Q106Nnl3Nll8ool3H``2aQP3mkh6ool3mkh3kgd2W?<3YA@3@PP3
<JH3:DD36><50003020326434:836><2Ljh3cWT3g_/6ool3g_/3Q302:DD302030003020326434:82
Hb`3aSP3mkh6ool3mkh5]IH3]KH3DXX348850003:FD6S743g_/6ool2cWT3Jdd36><600038B@2:DD6
Q303Q106Nnl2Nll9ool2H``3aQP3mkh6ool3mkh2kgd3W?<3YA@3@PP3<JH3:DD26><6000302032643
4:826><3Ljh3cWT3g_/6ool2g_/3Q303:DD302030003020326424:83Hb`3aSP3mkh6ool2mkh6]IH3
]KH3DXX348850003:FD6S743g_/5ool3cWT3Jdd36><500038B@3:DD6Q303Q105Nnl3Nll8ool3H``3
aQP3mkh5ool3mkh3kgd3W?<3YA@3@PP2<JH3:DD36><60003020326424:836><3Ljh3cWT3g_/5ool3
g_/3Q303:DD302030002020326434:83Hb`3aSP3mkh5ool3mkh6]IH3]KH2DXX348860003:FD6S742
g_/6ool3cWT3Jdd36><500038B@3:DD6Q302Q106Nnl3NllHool001Ooo`=S30?660;g_PKoo`?g_P?_
O@>Ll`:U50=220<aYP<YA@<Hh`H0008080<8H@<@XP<Hh`=c[P?>N@;Nn`Koo`?Nn`>4<0<YA@8080<0
00<080<8H@<@XP=S;0;6>0?g_PKoo`?g_PFeUP>e]P=BRP<@PPH000<YI@F<L@?Nn`Koo`?>N@9[C@<H
h`H000<Q90<YA@F4<0>440Ikk`=kc`Soo`=S30;660?g_PKoo`?g_P?_O@:Ll`>U50=220<aYP<YA@<H
h`D000<080<8H@<@XP<Hh`9c[P?>N@?Nn`Koo`?Nn`>4<08YA@<080<000<080<8H@<@XP9S;0?6>0?g
_PKoo`?g_PFeUP>e]P=BRP<@PPD000<YI@J<L@?Nn`Koo`;>N@=[C@<Hh`H000<Q908YA@J4<0>440Ik
k`9kc`Woo`9S30?660?g_PKoo`?g_P;_O@>Ll`>U50=220<aYP<YA@8Hh`H000<080<8H@<@XP8Hh`=c
[P?>N@?Nn`Koo`;Nn`>4<0<YA@<080<000<080<8H@8@XP=S;0?6>0?g_PKoo`;g_PJeUP>e]P=BRP<@
PPD000<YI@J<L@?Nn`Goo`?>N@=[C@<Hh`D000<Q90<YA@J4<0>440Ekk`=kc`Soo`=S30?660?g_PGo
o`?g_P?_O@>Ll`>U50=2208aYP<YA@<Hh`H000<080<8H@8@XP<Hh`=c[P?>N@?Nn`Goo`?Nn`>4<0<Y
A@<080<0008080<8H@<@XP=S;0?6>0?g_PGoo`?g_PJeUP>e]P9BRP<@PPH000<YI@J<L@;Nn`Koo`?>
N@=[C@<Hh`D000<Q90<YA@J4<0:440Ikk`=kcaSoo`005ooo0f<<0lHH0_Nn1_oo0oNn0nmm0icc0ZDD
0d880c6V0bU50aSS1P000P0P0`QQ0a2R0aSS0g>^0lii0]kk1_oo0mkk0h@`0bU50P0P0`000`0P0`QQ
0a2R0f</0/Hh0oNn1_oo0oNn1KFF0kFf0e::0a221P000bUU1Haa0mkk1_oo0lii0V]=0aSS1P000b4T
0bU51H@`0h@@1W__0g_?2?oo0f<<0/HH0oNn1_oo0oNn0nmm0Ycc0jDD0d880c6V0bU50aSS1@000`0P
0`QQ0a2R0aSS0W>^0lii0mkk1_oo0mkk0h@`0RU50`0P0`000`0P0`QQ0a2R0V</0lHh0oNn1_oo0oNn
1KFF0kFf0e::0a221@000bUU1Xaa0mkk1_oo0/ii0f]=0aSS1P000b4T0RU51X@`0h@@1W__0W_?2Ooo
0V<<0lHH0oNn1_oo0oNn0^mm0icc0jDD0d880c6V0bU50QSS1P000`0P0`QQ0a2R0QSS0g>^0lii0mkk
1_oo0]kk0h@`0bU50`0P0`000`0P0`QQ0Q2R0f</0lHh0oNn1_oo0_Nn1[FF0kFf0e::0a221@000bUU
1Xaa0mkk1Ooo0lii0f]=0aSS1@000b4T0bU51X@`0h@@1G__0g_?2?oo0f<<0lHH0oNn1Ooo0oNn0nmm
0icc0jDD0d880S6V0bU50aSS1P000`0P0`QQ0Q2R0aSS0g>^0lii0mkk1Ooo0mkk0h@`0bU50`0P0`00
0P0P0`QQ0a2R0f</0lHh0oNn1Ooo0oNn1[FF0kFf0U::0a221P000bUU1Xaa0]kk1_oo0lii0f]=0aSS
1@000b4T0bU51X@`0X@@1W__0g_?6?oo000Gool3H``3aQP2mkh6ool3mkh3kgd3W?<2YA@3@PP3<JH3
:DD36><60002020326434:836><3Ljh3cWT2g_/6ool3g_/3Q303:DD202030003020326434:83Hb`2
aSP3mkh6ool3mkh5]IH3]KH3DXX348860003:FD5S743g_/6ool3cWT2Jdd36><600038B@3:DD5Q303
Q106Nnl3Nll8ool3H``2aQP3mkh6ool3mkh3kgd2W?<3YA@3@PP3<JH3:DD36><50003020326434:83
6><2Ljh3cWT3g_/6ool3g_/3Q302:DD302030003020326434:82Hb`3aSP3mkh6ool3mkh5]IH3]KH3
DXX348850003:FD6S743g_/6ool2cWT3Jdd36><600038B@2:DD6Q303Q106Nnl2Nll9ool2H``3aQP3
mkh6ool3mkh2kgd3W?<3YA@3@PP3<JH3:DD26><60003020326434:826><3Ljh3cWT3g_/6ool2g_/3
Q303:DD302030003020326424:83Hb`3aSP3mkh6ool2mkh6]IH3]KH3DXX348850003:FD6S743g_/5
ool3cWT3Jdd36><500038B@3:DD6Q303Q105Nnl3Nll8ool3H``3aQP3mkh5ool3mkh3kgd3W?<3YA@3
@PP2<JH3:DD36><60003020326424:836><3Ljh3cWT3g_/5ool3g_/3Q303:DD30203000202032643
4:83Hb`3aSP3mkh5ool3mkh6]IH3]KH2DXX348860003:FD6S742g_/6ool3cWT3Jdd36><500038B@3
:DD6Q302Q106Nnl3NllHool001Ooo`=S30?660;g_PKoo`?g_P?_O@>Ll`:U50=220<aYP<YA@<Hh`H0
008080<8H@<@XP<Hh`=c[P?>N@;Nn`Koo`?Nn`>4<0<YA@8080<000<080<8H@<@XP=S;0;6>0?g_PKo
o`?g_PFeUP>e]P=BRP<@PPH000<YI@F<L@?Nn`Koo`?>N@9[C@<Hh`H000<Q90<YA@F4<0>440Ikk`=k
c`Soo`=S30;660?g_PKoo`?g_P?_O@:Ll`>U50=220<aYP<YA@<Hh`D000<080<8H@<@XP<Hh`9c[P?>
N@?Nn`Koo`?Nn`>4<08YA@<080<000<080<8H@<@XP9S;0?6>0?g_PKoo`?g_PFeUP>e]P=BRP<@PPD0
00<YI@J<L@?Nn`Koo`;>N@=[C@<Hh`H000<Q908YA@J4<0>440Ikk`9kc`Woo`9S30?660?g_PKoo`?g
_P;_O@>Ll`>U50=220<aYP<YA@8Hh`H000<080<8H@<@XP8Hh`=c[P?>N@?Nn`Koo`;Nn`>4<0<YA@<0
80<000<080<8H@8@XP=S;0?6>0?g_PKoo`;g_PJeUP>e]P=BRP<@PPD000<YI@J<L@?Nn`Goo`?>N@=[
C@<Hh`D000<Q90<YA@J4<0>440Ekk`=kc`Soo`=S30?660?g_PGoo`?g_P?_O@>Ll`>U50=2208aYP<Y
A@<Hh`H000<080<8H@8@XP<Hh`=c[P?>N@?Nn`Goo`?Nn`>4<0<YA@<080<0008080<8H@<@XP=S;0?6
>0?g_PGoo`?g_PJeUP>e]P9BRP<@PPH000<YI@J<L@;Nn`Koo`?>N@=[C@<Hh`D000<Q90<YA@J4<0:4
40Ikk`=kcaSoo`005ooo0mJJ0nLL1Ooo0mkK0g__0h@@1H@`0bUU0`0P0`000`0P0`QQ1E::0kFf0kgG
0oNN1_oo1Lii0liI2f]=0aSS0`Q11P000`Q10Q220f<<0lHH0oNn1_oo0/ii0f]]0aSS0`QQ1P000bU5
1HaA0h@`0mkK0nmM1Ooo0oNn0nmm0jDd0d880`QQ0P000a220e[[1U[;0e:Z2?oo0mJJ0^LL1_oo0mkK
0g__0h@@1H@`0bUU0`0P0`000`0P0PQQ1U::0kFf0kgG0oNN1Ooo1/ii0liI2f]=0aSS0`Q11P000PQ1
0a220f<<0lHH0oNn1Ooo0lii0f]]0aSS0`QQ1@000bU51XaA0h@`0mkK0nmM1Ooo0oNn0nmm0jDd0d88
0PQQ0`000a220e[[1U[;0U:Z2Ooo0]JJ0nLL1_oo0mkK0g__0X@@1X@`0bUU0`0P0`000P0P0`QQ1U::
0kFf0kgG0_NN1_oo1/ii0liI2f]=0aSS0`Q11@000`Q10a220f<<0lHH0oNn1Ooo0lii0f]]0aSS0`QQ
1@000bU51XaA0h@`0]kK0nmM1_oo0oNn0nmm0ZDd0d880`QQ0`000a220e[[1E[;0e:Z2?oo0mJJ0nLL
1_oo0]kK0g__0h@@1X@`0bUU0P0P0`000`0P0`QQ1U::0kFf0[gG0oNN1_oo1/ii0/iI36]=0aSS0PQ1
1P000`Q10a220f<<0/HH0oNn1_oo0lii0f]]0QSS0`QQ1P000bU51XaA0X@`0mkK0nmM1_oo0oNn0^mm
0jDd0d880`QQ0`000a220U[[1U[;0e:Z6?oo000Gool3eYX3ia`5ool3g]/3Nnl3Q105Q303:FD30203
000302032645DXX3]KH3_ML3mih6ool5cWT3cUT;Jdd36><32446000324424883H``3aQP3mkh6ool2
cWT3Jfd36><326460003:DD5S543Q303g]/3ked5ool3mkh3kgd3YC@3@PP3264200034883F^/6F//3
DZX8ool3eYX2ia`6ool3g]/3Nnl3Q105Q303:FD30203000302022646DXX3]KH3_ML3mih5ool6cWT3
cUT;Jdd36><32446000224434883H``3aQP3mkh5ool3cWT3Jfd36><326450003:DD6S543Q303g]/3
ked5ool3mkh3kgd3YC@3@PP2264300034883F^/6F//2DZX9ool2eYX3ia`6ool3g]/3Nnl2Q106Q303
:FD30203000202032646DXX3]KH3_ML2mih6ool6cWT3cUT;Jdd36><32445000324434883H``3aQP3
mkh5ool3cWT3Jfd36><326450003:DD6S543Q302g]/3ked6ool3mkh3kgd2YC@3@PP3264300034883
F^/5F//3DZX8ool3eYX3ia`6ool2g]/3Nnl3Q106Q303:FD20203000302032646DXX3]KH2_ML3mih6
ool6cWT2cUT<Jdd36><22446000324434883H``2aQP3mkh6ool3cWT3Jfd26><326460003:DD6S542
Q303g]/3ked6ool3mkh2kgd3YC@3@PP3264300034882F^/6F//3DZXHool001Ooo`?FVP?W70Goo`?N
f`=kk`>440F4<0<YI@<080<000<080<8H@EBRP>e]P>me`?gWPKoo`G>N@?>F@][C@<Hh`<8@@H000<8
@@8@PP=S30?660?g_PKoo`;>N@=[K@<Hh`<8H@H000<YA@F<D@>4<0?Nf`?_G@Goo`?g_P?_O@>U=0=2
20<8H@8000<@PP=Jj`IJb`=BZPSoo`?FVP;W70Koo`?Nf`=kk`>440F4<0<YI@<080<000<08088H@IB
RP>e]P>me`?gWPGoo`K>N@?>F@][C@<Hh`<8@@H00088@@<@PP=S30?660?g_PGoo`?>N@=[K@<Hh`<8
H@D000<YA@J<D@>4<0?Nf`?_G@Goo`?g_P?_O@>U=0=22088H@<000<@PP=Jj`IJb`9BZPWoo`;FVP?W
70Koo`?Nf`=kk`:440J4<0<YI@<080<0008080<8H@IBRP>e]P>me`;gWPKoo`K>N@?>F@][C@<Hh`<8
@@D000<8@@<@PP=S30?660?g_PGoo`?>N@=[K@<Hh`<8H@D000<YA@J<D@>4<0;Nf`?_G@Koo`?g_P?_
O@:U=0=220<8H@<000<@PP=Jj`EJb`=BZPSoo`?FVP?W70Koo`;Nf`=kk`>440J4<0<YI@8080<000<0
80<8H@IBRP>e]P:me`?gWPKoo`K>N@;>F@a[C@<Hh`88@@H000<8@@<@PP=S30;660?g_PKoo`?>N@=[
K@8Hh`<8H@H000<YA@J<D@:4<0?Nf`?_G@Koo`?g_P;_O@>U=0=220<8H@<000<@PP9Jj`IJb`=BZQSo
o`005ooo0mJJ0nLL1Ooo0mkK0g__0h@@1H@`0bUU0`0P0`000`0P0`QQ1E::0kFf0kgG0oNN1_oo1Lii
0liI2f]=0aSS0`Q11P000`Q10Q220f<<0lHH0oNn1_oo0/ii0f]]0aSS0`QQ1P000bU51HaA0h@`0mkK
0nmM1Ooo0oNn0nmm0jDd0d880`QQ0P000a220e[[1U[;0e:Z2?oo0mJJ0^LL1_oo0mkK0g__0h@@1H@`
0bUU0`0P0`000`0P0PQQ1U::0kFf0kgG0oNN1Ooo1/ii0liI2f]=0aSS0`Q11P000PQ10a220f<<0lHH
0oNn1Ooo0lii0f]]0aSS0`QQ1@000bU51XaA0h@`0mkK0nmM1Ooo0oNn0nmm0jDd0d880PQQ0`000a22
0e[[1U[;0U:Z2Ooo0]JJ0nLL1_oo0mkK0g__0X@@1X@`0bUU0`0P0`000P0P0`QQ1U::0kFf0kgG0_NN
1_oo1/ii0liI2f]=0aSS0`Q11@000`Q10a220f<<0lHH0oNn1Ooo0lii0f]]0aSS0`QQ1@000bU51XaA
0h@`0]kK0nmM1_oo0oNn0nmm0ZDd0d880`QQ0`000a220e[[1E[;0e:Z2?oo0mJJ0nLL1_oo0]kK0g__
0h@@1X@`0bUU0P0P0`000`0P0`QQ1U::0kFf0[gG0oNN1_oo1/ii0/iI36]=0aSS0PQ11P000`Q10a22
0f<<0/HH0oNn1_oo0lii0f]]0QSS0`QQ1P000bU51XaA0X@`0mkK0nmM1_oo0oNn0^mm0jDd0d880`QQ
0`000a220U[[1U[;0e:Z6?oo000Gool3eYX3ia`5ool3g]/3Nnl3Q105Q303:FD30203000302032645
DXX3]KH3_ML3mih6ool5cWT3cUT;Jdd36><32446000324424883H``3aQP3mkh6ool2cWT3Jfd36><3
26460003:DD5S543Q303g]/3ked5ool3mkh3kgd3YC@3@PP3264200034883F^/6F//3DZX8ool3eYX2
ia`6ool3g]/3Nnl3Q105Q303:FD30203000302022646DXX3]KH3_ML3mih5ool6cWT3cUT;Jdd36><3
2446000224434883H``3aQP3mkh5ool3cWT3Jfd36><326450003:DD6S543Q303g]/3ked5ool3mkh3
kgd3YC@3@PP2264300034883F^/6F//2DZX9ool2eYX3ia`6ool3g]/3Nnl2Q106Q303:FD302030002
02032646DXX3]KH3_ML2mih6ool6cWT3cUT;Jdd36><32445000324434883H``3aQP3mkh5ool3cWT3
Jfd36><326450003:DD6S543Q302g]/3ked6ool3mkh3kgd2YC@3@PP3264300034883F^/5F//3DZX8
ool3eYX3ia`6ool2g]/3Nnl3Q106Q303:FD20203000302032646DXX3]KH2_ML3mih6ool6cWT2cUT<
Jdd36><22446000324434883H``2aQP3mkh6ool3cWT3Jfd26><326460003:DD6S542Q303g]/3ked6
ool3mkh2kgd3YC@3@PP3264300034882F^/6F//3DZXHool001Ooo`?FVP?W70Goo`?Nf`=kk`>440F4
<0<YI@<080<000<080<8H@EBRP>e]P>me`?gWPKoo`G>N@?>F@][C@<Hh`<8@@H000<8@@8@PP=S30?6
60?g_PKoo`;>N@=[K@<Hh`<8H@H000<YA@F<D@>4<0?Nf`?_G@Goo`?g_P?_O@>U=0=220<8H@8000<@
PP=Jj`IJb`=BZPSoo`?FVP;W70Koo`?Nf`=kk`>440F4<0<YI@<080<000<08088H@IBRP>e]P>me`?g
WPGoo`K>N@?>F@][C@<Hh`<8@@H00088@@<@PP=S30?660?g_PGoo`?>N@=[K@<Hh`<8H@D000<YA@J<
D@>4<0?Nf`?_G@Goo`?g_P?_O@>U=0=22088H@<000<@PP=Jj`IJb`9BZPWoo`;FVP?W70Koo`?Nf`=k
k`:440J4<0<YI@<080<0008080<8H@IBRP>e]P>me`;gWPKoo`K>N@?>F@][C@<Hh`<8@@D000<8@@<@
PP=S30?660?g_PGoo`?>N@=[K@<Hh`<8H@D000<YA@J<D@>4<0;Nf`?_G@Koo`?g_P?_O@:U=0=220<8
H@<000<@PP=Jj`EJb`=BZPSoo`?FVP?W70Koo`;Nf`=kk`>440J4<0<YI@8080<000<080<8H@IBRP>e
]P:me`?gWPKoo`K>N@;>F@a[C@<Hh`88@@H000<8@@<@PP=S30;660?g_PKoo`?>N@=[K@8Hh`<8H@H0
00<YA@J<D@:4<0?Nf`?_G@Koo`?g_P;_O@>U=0=220<8H@<000<@PP9Jj`IJb`=BZQSoo`005ooo0mJJ
0nLL1Ooo0mkK0g__0h@@1H@`0bUU0`0P0`000`0P0`QQ1E::0kFf0kgG0oNN1_oo1Lii0liI2f]=0aSS
0`Q11P000`Q10Q220f<<0lHH0oNn1_oo0/ii0f]]0aSS0`QQ1P000bU51HaA0h@`0mkK0nmM1Ooo0oNn
0nmm0jDd0d880`QQ0P000a220e[[1U[;0e:Z2?oo0mJJ0^LL1_oo0mkK0g__0h@@1H@`0bUU0`0P0`00
0`0P0PQQ1U::0kFf0kgG0oNN1Ooo1/ii0liI2f]=0aSS0`Q11P000PQ10a220f<<0lHH0oNn1Ooo0lii
0f]]0aSS0`QQ1@000bU51XaA0h@`0mkK0nmM1Ooo0oNn0nmm0jDd0d880PQQ0`000a220e[[1U[;0U:Z
2Ooo0]JJ0nLL1_oo0mkK0g__0X@@1X@`0bUU0`0P0`000P0P0`QQ1U::0kFf0kgG0_NN1_oo1/ii0liI
2f]=0aSS0`Q11@000`Q10a220f<<0lHH0oNn1Ooo0lii0f]]0aSS0`QQ1@000bU51XaA0h@`0]kK0nmM
1_oo0oNn0nmm0ZDd0d880`QQ0`000a220e[[1E[;0e:Z2?oo0mJJ0nLL1_oo0]kK0g__0h@@1X@`0bUU
0P0P0`000`0P0`QQ1U::0kFf0[gG0oNN1_oo1/ii0/iI36]=0aSS0PQ11P000`Q10a220f<<0/HH0oNn
1_oo0lii0f]]0QSS0`QQ1P000bU51XaA0X@`0mkK0nmM1_oo0oNn0^mm0jDd0d880`QQ0`000a220U[[
1U[;0e:Z6?oo000Gool3eYX3ia`5ool3g]/3Nnl3Q105Q303:FD30203000302032645DXX3]KH3_ML3
mih6ool5cWT3cUT;Jdd36><32446000324424883H``3aQP3mkh6ool2cWT3Jfd36><326460003:DD5
S543Q303g]/3ked5ool3mkh3kgd3YC@3@PP3264200034883F^/6F//3DZX8ool3eYX2ia`6ool3g]/3
Nnl3Q105Q303:FD30203000302022646DXX3]KH3_ML3mih5ool6cWT3cUT;Jdd36><3244600022443
4883H``3aQP3mkh5ool3cWT3Jfd36><326450003:DD6S543Q303g]/3ked5ool3mkh3kgd3YC@3@PP2
264300034883F^/6F//2DZX9ool2eYX3ia`6ool3g]/3Nnl2Q106Q303:FD30203000202032646DXX3
]KH3_ML2mih6ool6cWT3cUT;Jdd36><32445000324434883H``3aQP3mkh5ool3cWT3Jfd36><32645
0003:DD6S543Q302g]/3ked6ool3mkh3kgd2YC@3@PP3264300034883F^/5F//3DZX8ool3eYX3ia`6
ool2g]/3Nnl3Q106Q303:FD20203000302032646DXX3]KH2_ML3mih6ool6cWT2cUT<Jdd36><22446
000324434883H``2aQP3mkh6ool3cWT3Jfd26><326460003:DD6S542Q303g]/3ked6ool3mkh2kgd3
YC@3@PP3264300034882F^/6F//3DZXHool001Ooo`?FVP?W70Goo`?Nf`=kk`>440F4<0<YI@<080<0
00<080<8H@EBRP>e]P>me`?gWPKoo`G>N@?>F@][C@<Hh`<8@@H000<8@@8@PP=S30?660?g_PKoo`;>
N@=[K@<Hh`<8H@H000<YA@F<D@>4<0?Nf`?_G@Goo`?g_P?_O@>U=0=220<8H@8000<@PP=Jj`IJb`=B
ZPSoo`?FVP;W70Koo`?Nf`=kk`>440F4<0<YI@<080<000<08088H@IBRP>e]P>me`?gWPGoo`K>N@?>
F@][C@<Hh`<8@@H00088@@<@PP=S30?660?g_PGoo`?>N@=[K@<Hh`<8H@D000<YA@J<D@>4<0?Nf`?_
G@Goo`?g_P?_O@>U=0=22088H@<000<@PP=Jj`IJb`9BZPWoo`;FVP?W70Koo`?Nf`=kk`:440J4<0<Y
I@<080<0008080<8H@IBRP>e]P>me`;gWPKoo`K>N@?>F@][C@<Hh`<8@@D000<8@@<@PP=S30?660?g
_PGoo`?>N@=[K@<Hh`<8H@D000<YA@J<D@>4<0;Nf`?_G@Koo`?g_P?_O@:U=0=220<8H@<000<@PP=J
j`EJb`=BZPSoo`?FVP?W70Koo`;Nf`=kk`>440J4<0<YI@8080<000<080<8H@IBRP>e]P:me`?gWPKo
o`K>N@;>F@a[C@<Hh`88@@H000<8@@<@PP=S30;660?g_PKoo`?>N@=[K@8Hh`<8H@H000<YA@J<D@:4
<0?Nf`?_G@Koo`?g_P;_O@>U=0=220<8H@<000<@PP9Jj`IJb`=BZQSoo`005ooo0mJJ0nLL1Ooo0mkK
0g__0h@@1H@`0bUU0`0P0`000`0P0`QQ1E::0kFf0kgG0oNN1_oo1Lii0liI2f]=0aSS0`Q11P000`Q1
0Q220f<<0lHH0oNn1_oo0/ii0f]]0aSS0`QQ1P000bU51HaA0h@`0mkK0nmM1Ooo0oNn0nmm0jDd0d88
0`QQ0P000a220e[[1U[;0e:Z2?oo0mJJ0^LL1_oo0mkK0g__0h@@1H@`0bUU0`0P0`000`0P0PQQ1U::
0kFf0kgG0oNN1Ooo1/ii0liI2f]=0aSS0`Q11P000PQ10a220f<<0lHH0oNn1Ooo0lii0f]]0aSS0`QQ
1@000bU51XaA0h@`0mkK0nmM1Ooo0oNn0nmm0jDd0d880PQQ0`000a220e[[1U[;0U:Z2Ooo0]JJ0nLL
1_oo0mkK0g__0X@@1X@`0bUU0`0P0`000P0P0`QQ1U::0kFf0kgG0_NN1_oo1/ii0liI2f]=0aSS0`Q1
1@000`Q10a220f<<0lHH0oNn1Ooo0lii0f]]0aSS0`QQ1@000bU51XaA0h@`0]kK0nmM1_oo0oNn0nmm
0ZDd0d880`QQ0`000a220e[[1E[;0e:Z2?oo0mJJ0nLL1_oo0]kK0g__0h@@1X@`0bUU0P0P0`000`0P
0`QQ1U::0kFf0[gG0oNN1_oo1/ii0/iI36]=0aSS0PQ11P000`Q10a220f<<0/HH0oNn1_oo0lii0f]]
0QSS0`QQ1P000bU51XaA0X@`0mkK0nmM1_oo0oNn0^mm0jDd0d880`QQ0`000a220U[[1U[;0e:Z6?oo
000Gool3eYX3ia`5ool3g]/3Nnl3Q105Q303:FD30203000302032645DXX3]KH3_ML3mih6ool5cWT3
cUT;Jdd36><32446000324424883H``3aQP3mkh6ool2cWT3Jfd36><326460003:DD5S543Q303g]/3
ked5ool3mkh3kgd3YC@3@PP3264200034883F^/6F//3DZX8ool3eYX2ia`6ool3g]/3Nnl3Q105Q303
:FD30203000302022646DXX3]KH3_ML3mih5ool6cWT3cUT;Jdd36><32446000224434883H``3aQP3
mkh5ool3cWT3Jfd36><326450003:DD6S543Q303g]/3ked5ool3mkh3kgd3YC@3@PP2264300034883
F^/6F//2DZX9ool2eYX3ia`6ool3g]/3Nnl2Q106Q303:FD30203000202032646DXX3]KH3_ML2mih6
ool6cWT3cUT;Jdd36><32445000324434883H``3aQP3mkh5ool3cWT3Jfd36><326450003:DD6S543
Q302g]/3ked6ool3mkh3kgd2YC@3@PP3264300034883F^/5F//3DZX8ool3eYX3ia`6ool2g]/3Nnl3
Q106Q303:FD20203000302032646DXX3]KH2_ML3mih6ool6cWT2cUT<Jdd36><22446000324434883
H``2aQP3mkh6ool3cWT3Jfd26><326460003:DD6S542Q303g]/3ked6ool3mkh2kgd3YC@3@PP32643
00034882F^/6F//3DZXHool001Ooo`?FVP?W70Goo`?Nf`=kk`>440F4<0<YI@<080<000<080<8H@EB
RP>e]P>me`?gWPKoo`G>N@?>F@][C@<Hh`<8@@H000<8@@8@PP=S30?660?g_PKoo`;>N@=[K@<Hh`<8
H@H000<YA@F<D@>4<0?Nf`?_G@Goo`?g_P?_O@>U=0=220<8H@8000<@PP=Jj`IJb`=BZPSoo`?FVP;W
70Koo`?Nf`=kk`>440F4<0<YI@<080<000<08088H@IBRP>e]P>me`?gWPGoo`K>N@?>F@][C@<Hh`<8
@@H00088@@<@PP=S30?660?g_PGoo`?>N@=[K@<Hh`<8H@D000<YA@J<D@>4<0?Nf`?_G@Goo`?g_P?_
O@>U=0=22088H@<000<@PP=Jj`IJb`9BZPWoo`;FVP?W70Koo`?Nf`=kk`:440J4<0<YI@<080<00080
80<8H@IBRP>e]P>me`;gWPKoo`K>N@?>F@][C@<Hh`<8@@D000<8@@<@PP=S30?660?g_PGoo`?>N@=[
K@<Hh`<8H@D000<YA@J<D@>4<0;Nf`?_G@Koo`?g_P?_O@:U=0=220<8H@<000<@PP=Jj`EJb`=BZPSo
o`?FVP?W70Koo`;Nf`=kk`>440J4<0<YI@8080<000<080<8H@IBRP>e]P:me`?gWPKoo`K>N@;>F@a[
C@<Hh`88@@H000<8@@<@PP=S30;660?g_PKoo`?>N@=[K@8Hh`<8H@H000<YA@J<D@:4<0?Nf`?_G@Ko
o`?g_P;_O@>U=0=220<8H@<000<@PP9Jj`IJb`=BZQSoo`005ooo0kgG0lHH0_Nn1_oo0lii2<iI1V</
0aS31P000`0P0T881ZeE0kFF0nmm1Ooo0ooO0oNN1ZeE0d8X0PQQ0`000`QQ0a2R0f]=0liI0_Nn0ooo
0ooO0oNN0nmm0icc0ZDD0jDd0d880`QQ1P000`Q10Q220aS30aSS0g_?0g>^0mJJ0_oO0ooo0ooO2lHh
0f<<0e[[0aS30`000`Q12?oo0kgG0/HH0oNn1_oo0lii2<iI1V</0aS31@000`0P0d881ZeE0kFF0^mm
1_oo0ooO0oNN1ZeE0T8X0`QQ0`000`QQ0a2R0f]=0/iI0oNn0ooo0ooO0oNN0nmm0Ycc0jDD0jDd0d88
0`QQ1@000`Q10a220aS30aSS0g_?0g>^0]JJ0ooO0ooo0ooO2lHh0f<<0e[[0aS30`000PQ12Ooo0[gG
0lHH0oNn1_oo0lii2<iI1V</0aS31@000`0P0d881ZeE0[FF0nmm1_oo0ooO0oNN1JeE0d8X0`QQ0`00
0`QQ0a2R0V]=0liI0oNn0ooo0ooO0oNN0^mm0icc0jDD0jDd0d880`QQ1@000`Q10a220aS30aSS0W_?
0g>^0mJJ0ooO0ooo0ooO2lHh0f<<0e[[0aS30P000`Q12?oo0kgG0lHH0oNn1Ooo0lii2LiI1F</0aS3
1P000`0P0d881JeE0kFF0nmm1_oo0ooO0_NN1ZeE0d8X0`QQ0`000PQQ0a2R0f]=0liI0oNn0ooo0_oO
0oNN0nmm0icc0jDD0jDd0T880`QQ1P000`Q10a220aS30QSS0g_?0g>^0mJJ0ooO0ooo0_oO3<Hh0f<<
0U[[0aS30`000`Q16?oo000Gool3_ML3aQP2mkh6ool3cWT8cUT6Hb`36<<600030202@PP6[ED3]IH3
kgd5ool3oml3mih6[ED3@RP22643000326434:83Jdd3cUT2mkh3ool3oml3mih3kgd3W?<2YA@3YC@3
@PP326460003244248836<<36><3Nll3Ljh3eYX2oml3ool3oml;aSP3H``3F^/36<<300032448ool3
_ML2aQP3mkh6ool3cWT8cUT6Hb`36<<500030203@PP6[ED3]IH2kgd6ool3oml3mih6[ED2@RP32643
000326434:83Jdd2cUT3mkh3ool3oml3mih3kgd2W?<3YA@3YC@3@PP326450003244348836<<36><3
Nll3Ljh2eYX3oml3ool3oml;aSP3H``3F^/36<<300022449ool2_ML3aQP3mkh6ool3cWT8cUT6Hb`3
6<<500030203@PP6[ED2]IH3kgd6ool3oml3mih5[ED3@RP32643000326434:82Jdd3cUT3mkh3ool3
oml3mih2kgd3W?<3YA@3YC@3@PP326450003244348836<<36><2Nll3Ljh3eYX3oml3ool3oml;aSP3
H``3F^/36<<200032448ool3_ML3aQP3mkh5ool3cWT9cUT5Hb`36<<600030203@PP5[ED3]IH3kgd6
ool3oml2mih6[ED3@RP32643000226434:83Jdd3cUT3mkh3ool2oml3mih3kgd3W?<3YA@3YC@2@PP3
26460003244348836<<26><3Nll3Ljh3eYX3oml3ool2oml<aSP3H``2F^/36<<30003244Hool001Oo
o`>me`?660;g_PKoo`?>N@S>F@IS;0<H``H000<0809220J]E@>eUP?_O@Goo`?og`?gWPJ]E@=2:088
H@<000<8H@<@XP=[C@?>F@;g_P?oo`?og`?gWP?_O@>Ll`:U50>U=0=220<8H@H000<8@@8@PP<H``<H
h`=kc`=c[P?FVP;og`?oo`?og`_6>0=S30=Jj`<H``<000<8@@Soo`>me`;660?g_PKoo`?>N@S>F@IS
;0<H``D000<080=220J]E@>eUP;_O@Koo`?og`?gWPJ]E@92:0<8H@<000<8H@<@XP=[C@;>F@?g_P?o
o`?og`?gWP?_O@:Ll`>U50>U=0=220<8H@D000<8@@<@PP<H``<Hh`=kc`=c[P;FVP?og`?oo`?og`_6
>0=S30=Jj`<H``<00088@@Woo`:me`?660?g_PKoo`?>N@S>F@IS;0<H``D000<080=220J]E@:eUP?_
O@Koo`?og`?gWPF]E@=2:0<8H@<000<8H@<@XP9[C@?>F@?g_P?oo`?og`?gWP;_O@>Ll`>U50>U=0=2
20<8H@D000<8@@<@PP<H``<Hh`9kc`=c[P?FVP?og`?oo`?og`_6>0=S30=Jj`<H``8000<8@@Soo`>m
e`?660?g_PGoo`?>N@W>F@ES;0<H``H000<080=220F]E@>eUP?_O@Koo`?og`;gWPJ]E@=2:0<8H@<0
0088H@<@XP=[C@?>F@?g_P?oo`;og`?gWP?_O@>Ll`>U50>U=09220<8H@H000<8@@<@PP<H``8Hh`=k
c`=c[P?FVP?og`?oo`;og`c6>0=S309Jj`<H``<000<8@ASoo`005ooo0kgG0lHH0_Nn1_oo0lii2<iI
1V</0aS31P000`0P0T881ZeE0kFF0nmm1Ooo0ooO0oNN1ZeE0d8X0PQQ0`000`QQ0a2R0f]=0liI0_Nn
0ooo0ooO0oNN0nmm0icc0ZDD0jDd0d880`QQ1P000`Q10Q220aS30aSS0g_?0g>^0mJJ0_oO0ooo0ooO
2lHh0f<<0e[[0aS30`000`Q12?oo0kgG0/HH0oNn1_oo0lii2<iI1V</0aS31@000`0P0d881ZeE0kFF
0^mm1_oo0ooO0oNN1ZeE0T8X0`QQ0`000`QQ0a2R0f]=0/iI0oNn0ooo0ooO0oNN0nmm0Ycc0jDD0jDd
0d880`QQ1@000`Q10a220aS30aSS0g_?0g>^0]JJ0ooO0ooo0ooO2lHh0f<<0e[[0aS30`000PQ12Ooo
0[gG0lHH0oNn1_oo0lii2<iI1V</0aS31@000`0P0d881ZeE0[FF0nmm1_oo0ooO0oNN1JeE0d8X0`QQ
0`000`QQ0a2R0V]=0liI0oNn0ooo0ooO0oNN0^mm0icc0jDD0jDd0d880`QQ1@000`Q10a220aS30aSS
0W_?0g>^0mJJ0ooO0ooo0ooO2lHh0f<<0e[[0aS30P000`Q12?oo0kgG0lHH0oNn1Ooo0lii2LiI1F</
0aS31P000`0P0d881JeE0kFF0nmm1_oo0ooO0_NN1ZeE0d8X0`QQ0`000PQQ0a2R0f]=0liI0oNn0ooo
0_oO0oNN0nmm0icc0jDD0jDd0T880`QQ1P000`Q10a220aS30QSS0g_?0g>^0mJJ0ooO0ooo0_oO3<Hh
0f<<0U[[0aS30`000`Q16?oo000Gool3_ML3aQP2mkh6ool3cWT8cUT6Hb`36<<600030202@PP6[ED3
]IH3kgd5ool3oml3mih6[ED3@RP22643000326434:83Jdd3cUT2mkh3ool3oml3mih3kgd3W?<2YA@3
YC@3@PP326460003244248836<<36><3Nll3Ljh3eYX2oml3ool3oml;aSP3H``3F^/36<<300032448
ool3_ML2aQP3mkh6ool3cWT8cUT6Hb`36<<500030203@PP6[ED3]IH2kgd6ool3oml3mih6[ED2@RP3
2643000326434:83Jdd2cUT3mkh3ool3oml3mih3kgd2W?<3YA@3YC@3@PP326450003244348836<<3
6><3Nll3Ljh2eYX3oml3ool3oml;aSP3H``3F^/36<<300022449ool2_ML3aQP3mkh6ool3cWT8cUT6
Hb`36<<500030203@PP6[ED2]IH3kgd6ool3oml3mih5[ED3@RP32643000326434:82Jdd3cUT3mkh3
ool3oml3mih2kgd3W?<3YA@3YC@3@PP326450003244348836<<36><2Nll3Ljh3eYX3oml3ool3oml;
aSP3H``3F^/36<<200032448ool3_ML3aQP3mkh5ool3cWT9cUT5Hb`36<<600030203@PP5[ED3]IH3
kgd6ool3oml2mih6[ED3@RP32643000226434:83Jdd3cUT3mkh3ool2oml3mih3kgd3W?<3YA@3YC@2
@PP326460003244348836<<26><3Nll3Ljh3eYX3oml3ool2oml<aSP3H``2F^/36<<30003244Hool0
01Ooo`>me`?660;g_PKoo`?>N@S>F@IS;0<H``H000<0809220J]E@>eUP?_O@Goo`?og`?gWPJ]E@=2
:088H@<000<8H@<@XP=[C@?>F@;g_P?oo`?og`?gWP?_O@>Ll`:U50>U=0=220<8H@H000<8@@8@PP<H
``<Hh`=kc`=c[P?FVP;og`?oo`?og`_6>0=S30=Jj`<H``<000<8@@Soo`>me`;660?g_PKoo`?>N@S>
F@IS;0<H``D000<080=220J]E@>eUP;_O@Koo`?og`?gWPJ]E@92:0<8H@<000<8H@<@XP=[C@;>F@?g
_P?oo`?og`?gWP?_O@:Ll`>U50>U=0=220<8H@D000<8@@<@PP<H``<Hh`=kc`=c[P;FVP?og`?oo`?o
g`_6>0=S30=Jj`<H``<00088@@Woo`:me`?660?g_PKoo`?>N@S>F@IS;0<H``D000<080=220J]E@:e
UP?_O@Koo`?og`?gWPF]E@=2:0<8H@<000<8H@<@XP9[C@?>F@?g_P?oo`?og`?gWP;_O@>Ll`>U50>U
=0=220<8H@D000<8@@<@PP<H``<Hh`9kc`=c[P?FVP?og`?oo`?og`_6>0=S30=Jj`<H``8000<8@@So
o`>me`?660?g_PGoo`?>N@W>F@ES;0<H``H000<080=220F]E@>eUP?_O@Koo`?og`;gWPJ]E@=2:0<8
H@<00088H@<@XP=[C@?>F@?g_P?oo`;og`?gWP?_O@>Ll`>U50>U=09220<8H@H000<8@@<@PP<H``8H
h`=kc`=c[P?FVP?og`?oo`;og`c6>0=S309Jj`<H``<000<8@ASoo`005ooo0kgG0lHH0_Nn1_oo0lii
2<iI1V</0aS31P000`0P0T881ZeE0kFF0nmm1Ooo0ooO0oNN1ZeE0d8X0PQQ0`000`QQ0a2R0f]=0liI
0_Nn0ooo0ooO0oNN0nmm0icc0ZDD0jDd0d880`QQ1P000`Q10Q220aS30aSS0g_?0g>^0mJJ0_oO0ooo
0ooO2lHh0f<<0e[[0aS30`000`Q12?oo0kgG0/HH0oNn1_oo0lii2<iI1V</0aS31@000`0P0d881ZeE
0kFF0^mm1_oo0ooO0oNN1ZeE0T8X0`QQ0`000`QQ0a2R0f]=0/iI0oNn0ooo0ooO0oNN0nmm0Ycc0jDD
0jDd0d880`QQ1@000`Q10a220aS30aSS0g_?0g>^0]JJ0ooO0ooo0ooO2lHh0f<<0e[[0aS30`000PQ1
2Ooo0[gG0lHH0oNn1_oo0lii2<iI1V</0aS31@000`0P0d881ZeE0[FF0nmm1_oo0ooO0oNN1JeE0d8X
0`QQ0`000`QQ0a2R0V]=0liI0oNn0ooo0ooO0oNN0^mm0icc0jDD0jDd0d880`QQ1@000`Q10a220aS3
0aSS0W_?0g>^0mJJ0ooO0ooo0ooO2lHh0f<<0e[[0aS30P000`Q12?oo0kgG0lHH0oNn1Ooo0lii2LiI
1F</0aS31P000`0P0d881JeE0kFF0nmm1_oo0ooO0_NN1ZeE0d8X0`QQ0`000PQQ0a2R0f]=0liI0oNn
0ooo0_oO0oNN0nmm0icc0jDD0jDd0T880`QQ1P000`Q10a220aS30QSS0g_?0g>^0mJJ0ooO0ooo0_oO
3<Hh0f<<0U[[0aS30`000`Q16?oo000Gool3_ML3aQP2mkh6ool3cWT8cUT6Hb`36<<600030202@PP6
[ED3]IH3kgd5ool3oml3mih6[ED3@RP22643000326434:83Jdd3cUT2mkh3ool3oml3mih3kgd3W?<2
YA@3YC@3@PP326460003244248836<<36><3Nll3Ljh3eYX2oml3ool3oml;aSP3H``3F^/36<<30003
2448ool3_ML2aQP3mkh6ool3cWT8cUT6Hb`36<<500030203@PP6[ED3]IH2kgd6ool3oml3mih6[ED2
@RP32643000326434:83Jdd2cUT3mkh3ool3oml3mih3kgd2W?<3YA@3YC@3@PP32645000324434883
6<<36><3Nll3Ljh2eYX3oml3ool3oml;aSP3H``3F^/36<<300022449ool2_ML3aQP3mkh6ool3cWT8
cUT6Hb`36<<500030203@PP6[ED2]IH3kgd6ool3oml3mih5[ED3@RP32643000326434:82Jdd3cUT3
mkh3ool3oml3mih2kgd3W?<3YA@3YC@3@PP326450003244348836<<36><2Nll3Ljh3eYX3oml3ool3
oml;aSP3H``3F^/36<<200032448ool3_ML3aQP3mkh5ool3cWT9cUT5Hb`36<<600030203@PP5[ED3
]IH3kgd6ool3oml2mih6[ED3@RP32643000226434:83Jdd3cUT3mkh3ool2oml3mih3kgd3W?<3YA@3
YC@2@PP326460003244348836<<26><3Nll3Ljh3eYX3oml3ool2oml<aSP3H``2F^/36<<30003244H
ool001Ooo`>me`?660;g_PKoo`?>N@S>F@IS;0<H``H000<0809220J]E@>eUP?_O@Goo`?og`?gWPJ]
E@=2:088H@<000<8H@<@XP=[C@?>F@;g_P?oo`?og`?gWP?_O@>Ll`:U50>U=0=220<8H@H000<8@@8@
PP<H``<Hh`=kc`=c[P?FVP;og`?oo`?og`_6>0=S30=Jj`<H``<000<8@@Soo`>me`;660?g_PKoo`?>
N@S>F@IS;0<H``D000<080=220J]E@>eUP;_O@Koo`?og`?gWPJ]E@92:0<8H@<000<8H@<@XP=[C@;>
F@?g_P?oo`?og`?gWP?_O@:Ll`>U50>U=0=220<8H@D000<8@@<@PP<H``<Hh`=kc`=c[P;FVP?og`?o
o`?og`_6>0=S30=Jj`<H``<00088@@Woo`:me`?660?g_PKoo`?>N@S>F@IS;0<H``D000<080=220J]
E@:eUP?_O@Koo`?og`?gWPF]E@=2:0<8H@<000<8H@<@XP9[C@?>F@?g_P?oo`?og`?gWP;_O@>Ll`>U
50>U=0=220<8H@D000<8@@<@PP<H``<Hh`9kc`=c[P?FVP?og`?oo`?og`_6>0=S30=Jj`<H``8000<8
@@Soo`>me`?660?g_PGoo`?>N@W>F@ES;0<H``H000<080=220F]E@>eUP?_O@Koo`?og`;gWPJ]E@=2
:0<8H@<00088H@<@XP=[C@?>F@?g_P?oo`;og`?gWP?_O@>Ll`>U50>U=09220<8H@H000<8@@<@PP<H
``8Hh`=kc`=c[P?FVP?og`?oo`;og`c6>0=S309Jj`<H``<000<8@ASoo`005ooo0kgG0lHH0_Nn1_oo
0lii2<iI1V</0aS31P000`0P0T881ZeE0kFF0nmm1Ooo0ooO0oNN1ZeE0d8X0PQQ0`000`QQ0a2R0f]=
0liI0_Nn0ooo0ooO0oNN0nmm0icc0ZDD0jDd0d880`QQ1P000`Q10Q220aS30aSS0g_?0g>^0mJJ0_oO
0ooo0ooO2lHh0f<<0e[[0aS30`000`Q12?oo0kgG0/HH0oNn1_oo0lii2<iI1V</0aS31@000`0P0d88
1ZeE0kFF0^mm1_oo0ooO0oNN1ZeE0T8X0`QQ0`000`QQ0a2R0f]=0/iI0oNn0ooo0ooO0oNN0nmm0Ycc
0jDD0jDd0d880`QQ1@000`Q10a220aS30aSS0g_?0g>^0]JJ0ooO0ooo0ooO2lHh0f<<0e[[0aS30`00
0PQ12Ooo0[gG0lHH0oNn1_oo0lii2<iI1V</0aS31@000`0P0d881ZeE0[FF0nmm1_oo0ooO0oNN1JeE
0d8X0`QQ0`000`QQ0a2R0V]=0liI0oNn0ooo0ooO0oNN0^mm0icc0jDD0jDd0d880`QQ1@000`Q10a22
0aS30aSS0W_?0g>^0mJJ0ooO0ooo0ooO2lHh0f<<0e[[0aS30P000`Q12?oo0kgG0lHH0oNn1Ooo0lii
2LiI1F</0aS31P000`0P0d881JeE0kFF0nmm1_oo0ooO0_NN1ZeE0d8X0`QQ0`000PQQ0a2R0f]=0liI
0oNn0ooo0_oO0oNN0nmm0icc0jDD0jDd0T880`QQ1P000`Q10a220aS30QSS0g_?0g>^0mJJ0ooO0ooo
0_oO3<Hh0f<<0U[[0aS30`000`Q16?oo000Gool3_ML3aQP2mkh6ool3cWT8cUT6Hb`36<<600030202
@PP6[ED3]IH3kgd5ool3oml3mih6[ED3@RP22643000326434:83Jdd3cUT2mkh3ool3oml3mih3kgd3
W?<2YA@3YC@3@PP326460003244248836<<36><3Nll3Ljh3eYX2oml3ool3oml;aSP3H``3F^/36<<3
00032448ool3_ML2aQP3mkh6ool3cWT8cUT6Hb`36<<500030203@PP6[ED3]IH2kgd6ool3oml3mih6
[ED2@RP32643000326434:83Jdd2cUT3mkh3ool3oml3mih3kgd2W?<3YA@3YC@3@PP3264500032443
48836<<36><3Nll3Ljh2eYX3oml3ool3oml;aSP3H``3F^/36<<300022449ool2_ML3aQP3mkh6ool3
cWT8cUT6Hb`36<<500030203@PP6[ED2]IH3kgd6ool3oml3mih5[ED3@RP32643000326434:82Jdd3
cUT3mkh3ool3oml3mih2kgd3W?<3YA@3YC@3@PP326450003244348836<<36><2Nll3Ljh3eYX3oml3
ool3oml;aSP3H``3F^/36<<200032448ool3_ML3aQP3mkh5ool3cWT9cUT5Hb`36<<600030203@PP5
[ED3]IH3kgd6ool3oml2mih6[ED3@RP32643000226434:83Jdd3cUT3mkh3ool2oml3mih3kgd3W?<3
YA@3YC@2@PP326460003244348836<<26><3Nll3Ljh3eYX3oml3ool2oml<aSP3H``2F^/36<<30003
244Hool001Ooo`<@PP<@XP8Hh`=c[P?FVP?og`?oo`?Nn`;Nf`=kk`<YA@<080<000<080<8H@9BZP=B
RPI:J@>eUP>e]P;gWPKoo`?g_P?_O@>U508ii`<8@@H000<aQP<aYP:D/P?W70?gWP?oo`?_O@?W?0:D
TP>D/P>Ld`<ia`<8@@<000<08088@@<@PP<H``I[K@=[C@;6>0?g_P?oo`?og`?gWPFeUP=:J@<@PP<0
00<080<8H@Soo`<@PP8@XP<Hh`=c[P?FVP?og`?oo`;Nn`?Nf`=kk`<YA@<080<0008080<8H@=BZP=B
RPI:J@:eUP>e]P?gWPKoo`?g_P?_O@:U50<ii`<8@@H000<aQP8aYP>D/P?W70?gWP?oo`?_O@;W?0>D
TP>D/P>Ld`<ia`<8@@8000<080<8@@<@PP<H``I[K@9[C@?6>0?g_P?oo`?og`?gWPFeUP=:J@<@PP<0
00<08088H@Woo`8@PP<@XP<Hh`=c[P?FVP?og`;oo`?Nn`?Nf`=kk`<YA@<0808000<080<8H@=BZP=B
RPE:J@>eUP>e]P?gWPKoo`;g_P?_O@>U50<ii`<8@@H0008aQP<aYP>D/P?W70?gWP?oo`;_O@?W?0>D
TP>D/P>Ld`<ia`88@@<000<080<8@@<@PP<H``E[K@=[C@?6>0?g_P?oo`;og`?gWPJeUP=:J@<@PP<0
008080<8H@Soo`<@PP<@XP<Hh`=c[P;FVP?og`?oo`?Nn`?Nf`=kk`8YA@<080<000<080<8H@=BZP=B
RPE:J@>eUP>e]P?gWPGoo`?g_P?_O@>U50<ii`<8@@D000<aQP<aYP>D/P?W70;gWP?oo`?_O@?W?0>D
TP>D/P:Ld`<ia`<8@@<000<080<8@@<@PP8H``I[K@=[C@?6>0?g_P;oo`?og`?gWPJeUP=:J@8@PP<0
00<080<8HASoo`005ooo0a220a2R0QSS0g>^0mJJ0ooO0ooo0mkk0]kK0g__0bU50`0P0`000`0P0`QQ
0U:Z0e::1TYY0kFF0kFf0_NN1_oo0oNn0nmm0jDD0SWW0`Q11P000c660c6V0YBb0nLL0oNN0ooo0nmm
0nLl0YBB0iBb0icC0cW70`Q10`000`0P0PQ10a220aS31V]]0f]=0/Hh0oNn0ooo0ooO0oNN1KFF0dYY
0a220`000`0P0`QQ2?oo0a220Q2R0aSS0g>^0mJJ0ooO0ooo0]kk0mkK0g__0bU50`0P0`000P0P0`QQ
0e:Z0e::1TYY0[FF0kFf0oNN1_oo0oNn0nmm0ZDD0cWW0`Q11P000c660S6V0iBb0nLL0oNN0ooo0nmm
0^Ll0iBB0iBb0icC0cW70`Q10P000`0P0`Q10a220aS31V]]0V]=0lHh0oNn0ooo0ooO0oNN1KFF0dYY
0a220`000`0P0PQQ2Ooo0Q220a2R0aSS0g>^0mJJ0ooO0_oo0mkk0mkK0g__0bU50`0P0P000`0P0`QQ
0e:Z0e::1DYY0kFF0kFf0oNN1_oo0_Nn0nmm0jDD0cWW0`Q11P000S660c6V0iBb0nLL0oNN0ooo0^mm
0nLl0iBB0iBb0icC0cW70PQ10`000`0P0`Q10a220aS31F]]0f]=0lHh0oNn0ooo0_oO0oNN1[FF0dYY
0a220`000P0P0`QQ2?oo0a220a2R0aSS0g>^0]JJ0ooO0ooo0mkk0mkK0g__0RU50`0P0`000`0P0`QQ
0e:Z0e::1DYY0kFF0kFf0oNN1Ooo0oNn0nmm0jDD0cWW0`Q11@000c660c6V0iBb0nLL0_NN0ooo0nmm
0nLl0iBB0iBb0YcC0cW70`Q10`000`0P0`Q10a220QS31V]]0f]=0lHh0oNn0_oo0ooO0oNN1[FF0dYY
0Q220`000`0P0`QQ6?oo000Gool348834:826><3Ljh3eYX3oml3ool3g_/2g]/3Nnl3:DD302030003
02032642DZX3DXX6BVT3]IH3]KH2mih6ool3mkh3kgd3YA@2>NL324460003<HH3<JH2U;83ia`3mih3
ool3kgd3ic`2U983U;83W=<3>LL3244300030202244348836<<6Jfd3Jdd2aSP3mkh3ool3oml3mih5
]IH3BVT34883000302032648ool348824:836><3Ljh3eYX3oml3ool2g_/3g]/3Nnl3:DD302030002
02032643DZX3DXX6BVT2]IH3]KH3mih6ool3mkh3kgd2YA@3>NL324460003<HH2<JH3U;83ia`3mih3
ool3kgd2ic`3U983U;83W=<3>LL3244200030203244348836<<6Jfd2Jdd3aSP3mkh3ool3oml3mih5
]IH3BVT34883000302022649ool248834:836><3Ljh3eYX3oml2ool3g_/3g]/3Nnl3:DD302020003
02032643DZX3DXX5BVT3]IH3]KH3mih6ool2mkh3kgd3YA@3>NL324460002<HH3<JH3U;83ia`3mih3
ool2kgd3ic`3U983U;83W=<3>LL2244300030203244348836<<5Jfd3Jdd3aSP3mkh3ool2oml3mih6
]IH3BVT34883000202032648ool348834:836><3Ljh2eYX3oml3ool3g_/3g]/3Nnl2:DD302030003
02032643DZX3DXX5BVT3]IH3]KH3mih5ool3mkh3kgd3YA@3>NL324450003<HH3<JH3U;83ia`2mih3
ool3kgd3ic`3U983U;82W=<3>LL3244300030203244348826<<6Jfd3Jdd3aSP3mkh2ool3oml3mih6
]IH3BVT2488300030203264Hool001Ooo`<@PP<@XP8Hh`=c[P?FVP?og`?oo`?Nn`;Nf`=kk`<YA@<0
80<000<080<8H@9BZP=BRPI:J@>eUP>e]P;gWPKoo`?g_P?_O@>U508ii`<8@@H000<aQP<aYP:D/P?W
70?gWP?oo`?_O@?W?0:DTP>D/P>Ld`<ia`<8@@<000<08088@@<@PP<H``I[K@=[C@;6>0?g_P?oo`?o
g`?gWPFeUP=:J@<@PP<000<080<8H@Soo`<@PP8@XP<Hh`=c[P?FVP?og`?oo`;Nn`?Nf`=kk`<YA@<0
80<0008080<8H@=BZP=BRPI:J@:eUP>e]P?gWPKoo`?g_P?_O@:U50<ii`<8@@H000<aQP8aYP>D/P?W
70?gWP?oo`?_O@;W?0>DTP>D/P>Ld`<ia`<8@@8000<080<8@@<@PP<H``I[K@9[C@?6>0?g_P?oo`?o
g`?gWPFeUP=:J@<@PP<000<08088H@Woo`8@PP<@XP<Hh`=c[P?FVP?og`;oo`?Nn`?Nf`=kk`<YA@<0
808000<080<8H@=BZP=BRPE:J@>eUP>e]P?gWPKoo`;g_P?_O@>U50<ii`<8@@H0008aQP<aYP>D/P?W
70?gWP?oo`;_O@?W?0>DTP>D/P>Ld`<ia`88@@<000<080<8@@<@PP<H``E[K@=[C@?6>0?g_P?oo`;o
g`?gWPJeUP=:J@<@PP<0008080<8H@Soo`<@PP<@XP<Hh`=c[P;FVP?og`?oo`?Nn`?Nf`=kk`8YA@<0
80<000<080<8H@=BZP=BRPE:J@>eUP>e]P?gWPGoo`?g_P?_O@>U50<ii`<8@@D000<aQP<aYP>D/P?W
70;gWP?oo`?_O@?W?0>DTP>D/P:Ld`<ia`<8@@<000<080<8@@<@PP8H``I[K@=[C@?6>0?g_P;oo`?o
g`?gWPJeUP=:J@8@PP<000<080<8HASoo`005ooo0a220a2R0QSS0g>^0mJJ0ooO0ooo0mkk0]kK0g__
0bU50`0P0`000`0P0`QQ0U:Z0e::1TYY0kFF0kFf0_NN1_oo0oNn0nmm0jDD0SWW0`Q11P000c660c6V
0YBb0nLL0oNN0ooo0nmm0nLl0YBB0iBb0icC0cW70`Q10`000`0P0PQ10a220aS31V]]0f]=0/Hh0oNn
0ooo0ooO0oNN1KFF0dYY0a220`000`0P0`QQ2?oo0a220Q2R0aSS0g>^0mJJ0ooO0ooo0]kk0mkK0g__
0bU50`0P0`000P0P0`QQ0e:Z0e::1TYY0[FF0kFf0oNN1_oo0oNn0nmm0ZDD0cWW0`Q11P000c660S6V
0iBb0nLL0oNN0ooo0nmm0^Ll0iBB0iBb0icC0cW70`Q10P000`0P0`Q10a220aS31V]]0V]=0lHh0oNn
0ooo0ooO0oNN1KFF0dYY0a220`000`0P0PQQ2Ooo0Q220a2R0aSS0g>^0mJJ0ooO0_oo0mkk0mkK0g__
0bU50`0P0P000`0P0`QQ0e:Z0e::1DYY0kFF0kFf0oNN1_oo0_Nn0nmm0jDD0cWW0`Q11P000S660c6V
0iBb0nLL0oNN0ooo0^mm0nLl0iBB0iBb0icC0cW70PQ10`000`0P0`Q10a220aS31F]]0f]=0lHh0oNn
0ooo0_oO0oNN1[FF0dYY0a220`000P0P0`QQ2?oo0a220a2R0aSS0g>^0]JJ0ooO0ooo0mkk0mkK0g__
0RU50`0P0`000`0P0`QQ0e:Z0e::1DYY0kFF0kFf0oNN1Ooo0oNn0nmm0jDD0cWW0`Q11@000c660c6V
0iBb0nLL0_NN0ooo0nmm0nLl0iBB0iBb0YcC0cW70`Q10`000`0P0`Q10a220QS31V]]0f]=0lHh0oNn
0_oo0ooO0oNN1[FF0dYY0Q220`000`0P0`QQ6?oo000Gool348834:826><3Ljh3eYX3oml3ool3g_/2
g]/3Nnl3:DD30203000302032642DZX3DXX6BVT3]IH3]KH2mih6ool3mkh3kgd3YA@2>NL324460003
<HH3<JH2U;83ia`3mih3ool3kgd3ic`2U983U;83W=<3>LL3244300030202244348836<<6Jfd3Jdd2
aSP3mkh3ool3oml3mih5]IH3BVT34883000302032648ool348824:836><3Ljh3eYX3oml3ool2g_/3
g]/3Nnl3:DD30203000202032643DZX3DXX6BVT2]IH3]KH3mih6ool3mkh3kgd2YA@3>NL324460003
<HH2<JH3U;83ia`3mih3ool3kgd2ic`3U983U;83W=<3>LL3244200030203244348836<<6Jfd2Jdd3
aSP3mkh3ool3oml3mih5]IH3BVT34883000302022649ool248834:836><3Ljh3eYX3oml2ool3g_/3
g]/3Nnl3:DD30202000302032643DZX3DXX5BVT3]IH3]KH3mih6ool2mkh3kgd3YA@3>NL324460002
<HH3<JH3U;83ia`3mih3ool2kgd3ic`3U983U;83W=<3>LL2244300030203244348836<<5Jfd3Jdd3
aSP3mkh3ool2oml3mih6]IH3BVT34883000202032648ool348834:836><3Ljh2eYX3oml3ool3g_/3
g]/3Nnl2:DD30203000302032643DZX3DXX5BVT3]IH3]KH3mih5ool3mkh3kgd3YA@3>NL324450003
<HH3<JH3U;83ia`2mih3ool3kgd3ic`3U983U;82W=<3>LL3244300030203244348826<<6Jfd3Jdd3
aSP3mkh2ool3oml3mih6]IH3BVT2488300030203264Hool001Ooo`<@PP<@XP8Hh`=c[P?FVP?og`?o
o`?Nn`;Nf`=kk`<YA@<080<000<080<8H@9BZP=BRPI:J@>eUP>e]P;gWPKoo`?g_P?_O@>U508ii`<8
@@H000<aQP<aYP:D/P?W70?gWP?oo`?_O@?W?0:DTP>D/P>Ld`<ia`<8@@<000<08088@@<@PP<H``I[
K@=[C@;6>0?g_P?oo`?og`?gWPFeUP=:J@<@PP<000<080<8H@Soo`<@PP8@XP<Hh`=c[P?FVP?og`?o
o`;Nn`?Nf`=kk`<YA@<080<0008080<8H@=BZP=BRPI:J@:eUP>e]P?gWPKoo`?g_P?_O@:U50<ii`<8
@@H000<aQP8aYP>D/P?W70?gWP?oo`?_O@;W?0>DTP>D/P>Ld`<ia`<8@@8000<080<8@@<@PP<H``I[
K@9[C@?6>0?g_P?oo`?og`?gWPFeUP=:J@<@PP<000<08088H@Woo`8@PP<@XP<Hh`=c[P?FVP?og`;o
o`?Nn`?Nf`=kk`<YA@<0808000<080<8H@=BZP=BRPE:J@>eUP>e]P?gWPKoo`;g_P?_O@>U50<ii`<8
@@H0008aQP<aYP>D/P?W70?gWP?oo`;_O@?W?0>DTP>D/P>Ld`<ia`88@@<000<080<8@@<@PP<H``E[
K@=[C@?6>0?g_P?oo`;og`?gWPJeUP=:J@<@PP<0008080<8H@Soo`<@PP<@XP<Hh`=c[P;FVP?og`?o
o`?Nn`?Nf`=kk`8YA@<080<000<080<8H@=BZP=BRPE:J@>eUP>e]P?gWPGoo`?g_P?_O@>U50<ii`<8
@@D000<aQP<aYP>D/P?W70;gWP?oo`?_O@?W?0>DTP>D/P:Ld`<ia`<8@@<000<080<8@@<@PP8H``I[
K@=[C@?6>0?g_P;oo`?og`?gWPJeUP=:J@8@PP<000<080<8HASoo`005ooo0a220a2R0QSS0g>^0mJJ
0ooO0ooo0mkk0]kK0g__0bU50`0P0`000`0P0`QQ0U:Z0e::1TYY0kFF0kFf0_NN1_oo0oNn0nmm0jDD
0SWW0`Q11P000c660c6V0YBb0nLL0oNN0ooo0nmm0nLl0YBB0iBb0icC0cW70`Q10`000`0P0PQ10a22
0aS31V]]0f]=0/Hh0oNn0ooo0ooO0oNN1KFF0dYY0a220`000`0P0`QQ2?oo0a220Q2R0aSS0g>^0mJJ
0ooO0ooo0]kk0mkK0g__0bU50`0P0`000P0P0`QQ0e:Z0e::1TYY0[FF0kFf0oNN1_oo0oNn0nmm0ZDD
0cWW0`Q11P000c660S6V0iBb0nLL0oNN0ooo0nmm0^Ll0iBB0iBb0icC0cW70`Q10P000`0P0`Q10a22
0aS31V]]0V]=0lHh0oNn0ooo0ooO0oNN1KFF0dYY0a220`000`0P0PQQ2Ooo0Q220a2R0aSS0g>^0mJJ
0ooO0_oo0mkk0mkK0g__0bU50`0P0P000`0P0`QQ0e:Z0e::1DYY0kFF0kFf0oNN1_oo0_Nn0nmm0jDD
0cWW0`Q11P000S660c6V0iBb0nLL0oNN0ooo0^mm0nLl0iBB0iBb0icC0cW70PQ10`000`0P0`Q10a22
0aS31F]]0f]=0lHh0oNn0ooo0_oO0oNN1[FF0dYY0a220`000P0P0`QQ2?oo0a220a2R0aSS0g>^0]JJ
0ooO0ooo0mkk0mkK0g__0RU50`0P0`000`0P0`QQ0e:Z0e::1DYY0kFF0kFf0oNN1Ooo0oNn0nmm0jDD
0cWW0`Q11@000c660c6V0iBb0nLL0_NN0ooo0nmm0nLl0iBB0iBb0YcC0cW70`Q10`000`0P0`Q10a22
0QS31V]]0f]=0lHh0oNn0_oo0ooO0oNN1[FF0dYY0Q220`000`0P0`QQ6?oo000Gool348834:826><3
Ljh3eYX3oml3ool3g_/2g]/3Nnl3:DD30203000302032642DZX3DXX6BVT3]IH3]KH2mih6ool3mkh3
kgd3YA@2>NL324460003<HH3<JH2U;83ia`3mih3ool3kgd3ic`2U983U;83W=<3>LL3244300030202
244348836<<6Jfd3Jdd2aSP3mkh3ool3oml3mih5]IH3BVT34883000302032648ool348824:836><3
Ljh3eYX3oml3ool2g_/3g]/3Nnl3:DD30203000202032643DZX3DXX6BVT2]IH3]KH3mih6ool3mkh3
kgd2YA@3>NL324460003<HH2<JH3U;83ia`3mih3ool3kgd2ic`3U983U;83W=<3>LL3244200030203
244348836<<6Jfd2Jdd3aSP3mkh3ool3oml3mih5]IH3BVT34883000302022649ool248834:836><3
Ljh3eYX3oml2ool3g_/3g]/3Nnl3:DD30202000302032643DZX3DXX5BVT3]IH3]KH3mih6ool2mkh3
kgd3YA@3>NL324460002<HH3<JH3U;83ia`3mih3ool2kgd3ic`3U983U;83W=<3>LL2244300030203
244348836<<5Jfd3Jdd3aSP3mkh3ool2oml3mih6]IH3BVT34883000202032648ool348834:836><3
Ljh2eYX3oml3ool3g_/3g]/3Nnl2:DD30203000302032643DZX3DXX5BVT3]IH3]KH3mih5ool3mkh3
kgd3YA@3>NL324450003<HH3<JH3U;83ia`2mih3ool3kgd3ic`3U983U;82W=<3>LL3244300030203
244348826<<6Jfd3Jdd3aSP3mkh2ool3oml3mih6]IH3BVT2488300030203264Hool001Ooo`<@PP<@
XP8Hh`=c[P?FVP?og`?oo`?Nn`;Nf`=kk`<YA@<080<000<080<8H@9BZP=BRPI:J@>eUP>e]P;gWPKo
o`?g_P?_O@>U508ii`<8@@H000<aQP<aYP:D/P?W70?gWP?oo`?_O@?W?0:DTP>D/P>Ld`<ia`<8@@<0
00<08088@@<@PP<H``I[K@=[C@;6>0?g_P?oo`?og`?gWPFeUP=:J@<@PP<000<080<8H@Soo`<@PP8@
XP<Hh`=c[P?FVP?og`?oo`;Nn`?Nf`=kk`<YA@<080<0008080<8H@=BZP=BRPI:J@:eUP>e]P?gWPKo
o`?g_P?_O@:U50<ii`<8@@H000<aQP8aYP>D/P?W70?gWP?oo`?_O@;W?0>DTP>D/P>Ld`<ia`<8@@80
00<080<8@@<@PP<H``I[K@9[C@?6>0?g_P?oo`?og`?gWPFeUP=:J@<@PP<000<08088H@Woo`8@PP<@
XP<Hh`=c[P?FVP?og`;oo`?Nn`?Nf`=kk`<YA@<0808000<080<8H@=BZP=BRPE:J@>eUP>e]P?gWPKo
o`;g_P?_O@>U50<ii`<8@@H0008aQP<aYP>D/P?W70?gWP?oo`;_O@?W?0>DTP>D/P>Ld`<ia`88@@<0
00<080<8@@<@PP<H``E[K@=[C@?6>0?g_P?oo`;og`?gWPJeUP=:J@<@PP<0008080<8H@Soo`<@PP<@
XP<Hh`=c[P;FVP?og`?oo`?Nn`?Nf`=kk`8YA@<080<000<080<8H@=BZP=BRPE:J@>eUP>e]P?gWPGo
o`?g_P?_O@>U50<ii`<8@@D000<aQP<aYP>D/P?W70;gWP?oo`?_O@?W?0>DTP>D/P:Ld`<ia`<8@@<0
00<080<8@@<@PP8H``I[K@=[C@?6>0?g_P;oo`?og`?gWPJeUP=:J@8@PP<000<080<8HASoo`005ooo
0a220a2R0QSS0g>^0mJJ0ooO0ooo0mkk0]kK0g__0bU50`0P0`000`0P0`QQ0U:Z0e::1TYY0kFF0kFf
0_NN1_oo0oNn0nmm0jDD0SWW0`Q11P000c660c6V0YBb0nLL0oNN0ooo0nmm0nLl0YBB0iBb0icC0cW7
0`Q10`000`0P0PQ10a220aS31V]]0f]=0/Hh0oNn0ooo0ooO0oNN1KFF0dYY0a220`000`0P0`QQ2?oo
0a220Q2R0aSS0g>^0mJJ0ooO0ooo0]kk0mkK0g__0bU50`0P0`000P0P0`QQ0e:Z0e::1TYY0[FF0kFf
0oNN1_oo0oNn0nmm0ZDD0cWW0`Q11P000c660S6V0iBb0nLL0oNN0ooo0nmm0^Ll0iBB0iBb0icC0cW7
0`Q10P000`0P0`Q10a220aS31V]]0V]=0lHh0oNn0ooo0ooO0oNN1KFF0dYY0a220`000`0P0PQQ2Ooo
0Q220a2R0aSS0g>^0mJJ0ooO0_oo0mkk0mkK0g__0bU50`0P0P000`0P0`QQ0e:Z0e::1DYY0kFF0kFf
0oNN1_oo0_Nn0nmm0jDD0cWW0`Q11P000S660c6V0iBb0nLL0oNN0ooo0^mm0nLl0iBB0iBb0icC0cW7
0PQ10`000`0P0`Q10a220aS31F]]0f]=0lHh0oNn0ooo0_oO0oNN1[FF0dYY0a220`000P0P0`QQ2?oo
0a220a2R0aSS0g>^0]JJ0ooO0ooo0mkk0mkK0g__0RU50`0P0`000`0P0`QQ0e:Z0e::1DYY0kFF0kFf
0oNN1Ooo0oNn0nmm0jDD0cWW0`Q11@000c660c6V0iBb0nLL0_NN0ooo0nmm0nLl0iBB0iBb0YcC0cW7
0`Q10`000`0P0`Q10a220QS31V]]0f]=0lHh0oNn0_oo0ooO0oNN1[FF0dYY0Q220`000`0P0`QQ6?oo
000Gool6DXX2BVT9BTT3[GD3kgd2ool3mkh3kgd3ic`3U983<HH3244200036<<36><38@@3Nnl3e[X2
oml3ool3ia`3g_/3g]/3e[X2eYX3Lhh38@@60003020226434:83Hb`3aSP3eYX3oml2ool3oml3mih3
ked3W=<3W?<3>NL22446000;<JH3W=<3ic`3mkh6ool2mkh3kgd3ic`3U983U;83W=<8ool5DXX3BVT9
BTT3[GD2kgd3ool3mkh3kgd3ic`3U982<HH3244300036<<36><38@@2Nnl3e[X3oml3ool3ia`3g_/3
g]/2e[X3eYX3Lhh38@@60002020326434:83Hb`3aSP3eYX2oml3ool3oml3mih3ked3W=<2W?<3>NL3
2446000;<JH3W=<3ic`3mkh5ool3mkh3kgd3ic`3U983U;82W=<9ool5DXX3BVT9BTT2[GD3kgd3ool3
mkh3kgd3ic`2U983<HH3244300036<<36><28@@3Nnl3e[X3oml3ool3ia`2g_/3g]/3e[X3eYX3Lhh3
8@@50003020326434:83Hb`3aSP2eYX3oml3ool3oml3mih3ked2W=<3W?<3>NL32446000;<JH3W=<3
ic`2mkh6ool3mkh3kgd3ic`3U982U;83W=<8ool6DXX3BVT8BTT3[GD3kgd3ool3mkh2kgd3ic`3U983
<HH3244300036<<26><38@@3Nnl3e[X3oml3ool2ia`3g_/3g]/3e[X3eYX3Lhh28@@6000302032643
4:82Hb`3aSP3eYX3oml3ool3oml2mih3ked3W=<3W?<3>NL32445000<<JH3W=<2ic`3mkh6ool3mkh3
kgd2ic`3U983U;83W=<Hool001Ooo`IBRP9:J@U:B@>]M@?_O@;oo`?g_P?_O@?W?0>DTP<aQP<8@@80
00<H``<Hh`<Q10=kk`?F^P;og`?oo`?W70?Nn`?Nf`?F^P;FVP=cSP<Q10H000<08088H@<@XP=S;0?6
>0?FVP?og`;oo`?og`?gWP?_G@>Ld`>Ll`<ii`88@@H000/aYP>Ld`?W?0?g_PKoo`;g_P?_O@?W?0>D
TP>D/P>Ld`Soo`EBRP=:J@U:B@>]M@;_O@?oo`?g_P?_O@?W?0>DTP8aQP<8@@<000<H``<Hh`<Q109k
k`?F^P?og`?oo`?W70?Nn`?Nf`;F^P?FVP=cSP<Q10H0008080<8H@<@XP=S;0?6>0?FVP;og`?oo`?o
g`?gWP?_G@>Ld`:Ll`<ii`<8@@H000/aYP>Ld`?W?0?g_PGoo`?g_P?_O@?W?0>DTP>D/P:Ld`Woo`EB
RP=:J@U:B@:]M@?_O@?oo`?g_P?_O@?W?0:DTP<aQP<8@@<000<H``<Hh`8Q10=kk`?F^P?og`?oo`?W
70;Nn`?Nf`?F^P?FVP=cSP<Q10D000<080<8H@<@XP=S;0?6>0;FVP?og`?oo`?og`?gWP?_G@:Ld`>L
l`<ii`<8@@H000/aYP>Ld`?W?0;g_PKoo`?g_P?_O@?W?0>DTP:D/P>Ld`Soo`IBRP=:J@Q:B@>]M@?_
O@?oo`?g_P;_O@?W?0>DTP<aQP<8@@<000<H``8Hh`<Q10=kk`?F^P?og`?oo`;W70?Nn`?Nf`?F^P?F
VP=cSP8Q10H000<080<8H@<@XP9S;0?6>0?FVP?og`?oo`?og`;gWP?_G@>Ld`>Ll`<ii`<8@@D000`a
YP>Ld`;W?0?g_PKoo`?g_P?_O@;W?0>DTP>D/P>LdaSoo`005ooo1U::0TYY2DY90jee0nmm0_oo0oNn
0nmm0nLl0iBB0c660`Q10P000aS30aSS0b440g__0mJj0_oO0ooo0nLL0mkk0mkK0mJj0]JJ0g>>0b44
1P000`0P0PQQ0a2R0f</0lHh0mJJ0ooO0_oo0ooO0oNN0nmM0icC0icc0cWW0PQ11P002c6V0icC0nLl
0oNn1_oo0_Nn0nmm0nLl0iBB0iBb0icC2?oo1E::0dYY2DY90jee0^mm0ooo0oNn0nmm0nLl0iBB0S66
0`Q10`000aS30aSS0b440W__0mJj0ooO0ooo0nLL0mkk0mkK0]Jj0mJJ0g>>0b441P000P0P0`QQ0a2R
0f</0lHh0mJJ0_oO0ooo0ooO0oNN0nmM0icC0Ycc0cWW0`Q11P002c6V0icC0nLl0oNn1Ooo0oNn0nmm
0nLl0iBB0iBb0YcC2Ooo1E::0dYY2DY90Zee0nmm0ooo0oNn0nmm0nLl0YBB0c660`Q10`000aS30aSS
0R440g__0mJj0ooO0ooo0nLL0]kk0mkK0mJj0mJJ0g>>0b441@000`0P0`QQ0a2R0f</0lHh0]JJ0ooO
0ooo0ooO0oNN0nmM0YcC0icc0cWW0`Q11P002c6V0icC0nLl0_Nn1_oo0oNn0nmm0nLl0iBB0YBb0icC
2?oo1U::0dYY24Y90jee0nmm0ooo0oNn0^mm0nLl0iBB0c660`Q10`000aS30QSS0b440g__0mJj0ooO
0ooo0^LL0mkk0mkK0mJj0mJJ0g>>0R441P000`0P0`QQ0a2R0V</0lHh0mJJ0ooO0ooo0ooO0_NN0nmM
0icC0icc0cWW0`Q11@00336V0icC0^Ll0oNn1_oo0oNn0nmm0^Ll0iBB0iBb0icC6?oo000Gool6DXX2
BVT9BTT3[GD3kgd2ool3mkh3kgd3ic`3U983<HH3244200036<<36><38@@3Nnl3e[X2oml3ool3ia`3
g_/3g]/3e[X2eYX3Lhh38@@60003020226434:83Hb`3aSP3eYX3oml2ool3oml3mih3ked3W=<3W?<3
>NL22446000;<JH3W=<3ic`3mkh6ool2mkh3kgd3ic`3U983U;83W=<8ool5DXX3BVT9BTT3[GD2kgd3
ool3mkh3kgd3ic`3U982<HH3244300036<<36><38@@2Nnl3e[X3oml3ool3ia`3g_/3g]/2e[X3eYX3
Lhh38@@60002020326434:83Hb`3aSP3eYX2oml3ool3oml3mih3ked3W=<2W?<3>NL32446000;<JH3
W=<3ic`3mkh5ool3mkh3kgd3ic`3U983U;82W=<9ool5DXX3BVT9BTT2[GD3kgd3ool3mkh3kgd3ic`2
U983<HH3244300036<<36><28@@3Nnl3e[X3oml3ool3ia`2g_/3g]/3e[X3eYX3Lhh38@@500030203
26434:83Hb`3aSP2eYX3oml3ool3oml3mih3ked2W=<3W?<3>NL32446000;<JH3W=<3ic`2mkh6ool3
mkh3kgd3ic`3U982U;83W=<8ool6DXX3BVT8BTT3[GD3kgd3ool3mkh2kgd3ic`3U983<HH324430003
6<<26><38@@3Nnl3e[X3oml3ool2ia`3g_/3g]/3e[X3eYX3Lhh28@@60003020326434:82Hb`3aSP3
eYX3oml3ool3oml2mih3ked3W=<3W?<3>NL32445000<<JH3W=<2ic`3mkh6ool3mkh3kgd2ic`3U983
U;83W=<Hool001Ooo`IBRP9:J@U:B@>]M@?_O@;oo`?g_P?_O@?W?0>DTP<aQP<8@@8000<H``<Hh`<Q
10=kk`?F^P;og`?oo`?W70?Nn`?Nf`?F^P;FVP=cSP<Q10H000<08088H@<@XP=S;0?6>0?FVP?og`;o
o`?og`?gWP?_G@>Ld`>Ll`<ii`88@@H000/aYP>Ld`?W?0?g_PKoo`;g_P?_O@?W?0>DTP>D/P>Ld`So
o`EBRP=:J@U:B@>]M@;_O@?oo`?g_P?_O@?W?0>DTP8aQP<8@@<000<H``<Hh`<Q109kk`?F^P?og`?o
o`?W70?Nn`?Nf`;F^P?FVP=cSP<Q10H0008080<8H@<@XP=S;0?6>0?FVP;og`?oo`?og`?gWP?_G@>L
d`:Ll`<ii`<8@@H000/aYP>Ld`?W?0?g_PGoo`?g_P?_O@?W?0>DTP>D/P:Ld`Woo`EBRP=:J@U:B@:]
M@?_O@?oo`?g_P?_O@?W?0:DTP<aQP<8@@<000<H``<Hh`8Q10=kk`?F^P?og`?oo`?W70;Nn`?Nf`?F
^P?FVP=cSP<Q10D000<080<8H@<@XP=S;0?6>0;FVP?og`?oo`?og`?gWP?_G@:Ld`>Ll`<ii`<8@@H0
00/aYP>Ld`?W?0;g_PKoo`?g_P?_O@?W?0>DTP:D/P>Ld`Soo`IBRP=:J@Q:B@>]M@?_O@?oo`?g_P;_
O@?W?0>DTP<aQP<8@@<000<H``8Hh`<Q10=kk`?F^P?og`?oo`;W70?Nn`?Nf`?F^P?FVP=cSP8Q10H0
00<080<8H@<@XP9S;0?6>0?FVP?og`?oo`?og`;gWP?_G@>Ld`>Ll`<ii`<8@@D000`aYP>Ld`;W?0?g
_PKoo`?g_P?_O@;W?0>DTP>D/P>LdaSoo`005ooo1U::0TYY2DY90jee0nmm0_oo0oNn0nmm0nLl0iBB
0c660`Q10P000aS30aSS0b440g__0mJj0_oO0ooo0nLL0mkk0mkK0mJj0]JJ0g>>0b441P000`0P0PQQ
0a2R0f</0lHh0mJJ0ooO0_oo0ooO0oNN0nmM0icC0icc0cWW0PQ11P002c6V0icC0nLl0oNn1_oo0_Nn
0nmm0nLl0iBB0iBb0icC2?oo1E::0dYY2DY90jee0^mm0ooo0oNn0nmm0nLl0iBB0S660`Q10`000aS3
0aSS0b440W__0mJj0ooO0ooo0nLL0mkk0mkK0]Jj0mJJ0g>>0b441P000P0P0`QQ0a2R0f</0lHh0mJJ
0_oO0ooo0ooO0oNN0nmM0icC0Ycc0cWW0`Q11P002c6V0icC0nLl0oNn1Ooo0oNn0nmm0nLl0iBB0iBb
0YcC2Ooo1E::0dYY2DY90Zee0nmm0ooo0oNn0nmm0nLl0YBB0c660`Q10`000aS30aSS0R440g__0mJj
0ooO0ooo0nLL0]kk0mkK0mJj0mJJ0g>>0b441@000`0P0`QQ0a2R0f</0lHh0]JJ0ooO0ooo0ooO0oNN
0nmM0YcC0icc0cWW0`Q11P002c6V0icC0nLl0_Nn1_oo0oNn0nmm0nLl0iBB0YBb0icC2?oo1U::0dYY
24Y90jee0nmm0ooo0oNn0^mm0nLl0iBB0c660`Q10`000aS30QSS0b440g__0mJj0ooO0ooo0^LL0mkk
0mkK0mJj0mJJ0g>>0R441P000`0P0`QQ0a2R0V</0lHh0mJJ0ooO0ooo0ooO0_NN0nmM0icC0icc0cWW
0`Q11@00336V0icC0^Ll0oNn1_oo0oNn0nmm0^Ll0iBB0iBb0icC6?oo000Gool6DXX2BVT9BTT3[GD3
kgd2ool3mkh3kgd3ic`3U983<HH3244200036<<36><38@@3Nnl3e[X2oml3ool3ia`3g_/3g]/3e[X2
eYX3Lhh38@@60003020226434:83Hb`3aSP3eYX3oml2ool3oml3mih3ked3W=<3W?<3>NL22446000;
<JH3W=<3ic`3mkh6ool2mkh3kgd3ic`3U983U;83W=<8ool5DXX3BVT9BTT3[GD2kgd3ool3mkh3kgd3
ic`3U982<HH3244300036<<36><38@@2Nnl3e[X3oml3ool3ia`3g_/3g]/2e[X3eYX3Lhh38@@60002
020326434:83Hb`3aSP3eYX2oml3ool3oml3mih3ked3W=<2W?<3>NL32446000;<JH3W=<3ic`3mkh5
ool3mkh3kgd3ic`3U983U;82W=<9ool5DXX3BVT9BTT2[GD3kgd3ool3mkh3kgd3ic`2U983<HH32443
00036<<36><28@@3Nnl3e[X3oml3ool3ia`2g_/3g]/3e[X3eYX3Lhh38@@50003020326434:83Hb`3
aSP2eYX3oml3ool3oml3mih3ked2W=<3W?<3>NL32446000;<JH3W=<3ic`2mkh6ool3mkh3kgd3ic`3
U982U;83W=<8ool6DXX3BVT8BTT3[GD3kgd3ool3mkh2kgd3ic`3U983<HH3244300036<<26><38@@3
Nnl3e[X3oml3ool2ia`3g_/3g]/3e[X3eYX3Lhh28@@60003020326434:82Hb`3aSP3eYX3oml3ool3
oml2mih3ked3W=<3W?<3>NL32445000<<JH3W=<2ic`3mkh6ool3mkh3kgd2ic`3U983U;83W=<Hool0
01Ooo`IBRP9:J@U:B@>]M@?_O@;oo`?g_P?_O@?W?0>DTP<aQP<8@@8000<H``<Hh`<Q10=kk`?F^P;o
g`?oo`?W70?Nn`?Nf`?F^P;FVP=cSP<Q10H000<08088H@<@XP=S;0?6>0?FVP?og`;oo`?og`?gWP?_
G@>Ld`>Ll`<ii`88@@H000/aYP>Ld`?W?0?g_PKoo`;g_P?_O@?W?0>DTP>D/P>Ld`Soo`EBRP=:J@U:
B@>]M@;_O@?oo`?g_P?_O@?W?0>DTP8aQP<8@@<000<H``<Hh`<Q109kk`?F^P?og`?oo`?W70?Nn`?N
f`;F^P?FVP=cSP<Q10H0008080<8H@<@XP=S;0?6>0?FVP;og`?oo`?og`?gWP?_G@>Ld`:Ll`<ii`<8
@@H000/aYP>Ld`?W?0?g_PGoo`?g_P?_O@?W?0>DTP>D/P:Ld`Woo`EBRP=:J@U:B@:]M@?_O@?oo`?g
_P?_O@?W?0:DTP<aQP<8@@<000<H``<Hh`8Q10=kk`?F^P?og`?oo`?W70;Nn`?Nf`?F^P?FVP=cSP<Q
10D000<080<8H@<@XP=S;0?6>0;FVP?og`?oo`?og`?gWP?_G@:Ld`>Ll`<ii`<8@@H000/aYP>Ld`?W
?0;g_PKoo`?g_P?_O@?W?0>DTP:D/P>Ld`Soo`IBRP=:J@Q:B@>]M@?_O@?oo`?g_P;_O@?W?0>DTP<a
QP<8@@<000<H``8Hh`<Q10=kk`?F^P?og`?oo`;W70?Nn`?Nf`?F^P?FVP=cSP8Q10H000<080<8H@<@
XP9S;0?6>0?FVP?og`?oo`?og`;gWP?_G@>Ld`>Ll`<ii`<8@@D000`aYP>Ld`;W?0?g_PKoo`?g_P?_
O@;W?0>DTP>D/P>LdaSoo`005ooo1U::0TYY2DY90jee0nmm0_oo0oNn0nmm0nLl0iBB0c660`Q10P00
0aS30aSS0b440g__0mJj0_oO0ooo0nLL0mkk0mkK0mJj0]JJ0g>>0b441P000`0P0PQQ0a2R0f</0lHh
0mJJ0ooO0_oo0ooO0oNN0nmM0icC0icc0cWW0PQ11P002c6V0icC0nLl0oNn1_oo0_Nn0nmm0nLl0iBB
0iBb0icC2?oo1E::0dYY2DY90jee0^mm0ooo0oNn0nmm0nLl0iBB0S660`Q10`000aS30aSS0b440W__
0mJj0ooO0ooo0nLL0mkk0mkK0]Jj0mJJ0g>>0b441P000P0P0`QQ0a2R0f</0lHh0mJJ0_oO0ooo0ooO
0oNN0nmM0icC0Ycc0cWW0`Q11P002c6V0icC0nLl0oNn1Ooo0oNn0nmm0nLl0iBB0iBb0YcC2Ooo1E::
0dYY2DY90Zee0nmm0ooo0oNn0nmm0nLl0YBB0c660`Q10`000aS30aSS0R440g__0mJj0ooO0ooo0nLL
0]kk0mkK0mJj0mJJ0g>>0b441@000`0P0`QQ0a2R0f</0lHh0]JJ0ooO0ooo0ooO0oNN0nmM0YcC0icc
0cWW0`Q11P002c6V0icC0nLl0_Nn1_oo0oNn0nmm0nLl0iBB0YBb0icC2?oo1U::0dYY24Y90jee0nmm
0ooo0oNn0^mm0nLl0iBB0c660`Q10`000aS30QSS0b440g__0mJj0ooO0ooo0^LL0mkk0mkK0mJj0mJJ
0g>>0R441P000`0P0`QQ0a2R0V</0lHh0mJJ0ooO0ooo0ooO0_NN0nmM0icC0icc0cWW0`Q11@00336V
0icC0^Ll0oNn1_oo0oNn0nmm0^Ll0iBB0iBb0icC6?oo000Gool6DXX2BVT9BTT3[GD3kgd2ool3mkh3
kgd3ic`3U983<HH3244200036<<36><38@@3Nnl3e[X2oml3ool3ia`3g_/3g]/3e[X2eYX3Lhh38@@6
0003020226434:83Hb`3aSP3eYX3oml2ool3oml3mih3ked3W=<3W?<3>NL22446000;<JH3W=<3ic`3
mkh6ool2mkh3kgd3ic`3U983U;83W=<8ool5DXX3BVT9BTT3[GD2kgd3ool3mkh3kgd3ic`3U982<HH3
244300036<<36><38@@2Nnl3e[X3oml3ool3ia`3g_/3g]/2e[X3eYX3Lhh38@@60002020326434:83
Hb`3aSP3eYX2oml3ool3oml3mih3ked3W=<2W?<3>NL32446000;<JH3W=<3ic`3mkh5ool3mkh3kgd3
ic`3U983U;82W=<9ool5DXX3BVT9BTT2[GD3kgd3ool3mkh3kgd3ic`2U983<HH3244300036<<36><2
8@@3Nnl3e[X3oml3ool3ia`2g_/3g]/3e[X3eYX3Lhh38@@50003020326434:83Hb`3aSP2eYX3oml3
ool3oml3mih3ked2W=<3W?<3>NL32446000;<JH3W=<3ic`2mkh6ool3mkh3kgd3ic`3U982U;83W=<8
ool6DXX3BVT8BTT3[GD3kgd3ool3mkh2kgd3ic`3U983<HH3244300036<<26><38@@3Nnl3e[X3oml3
ool2ia`3g_/3g]/3e[X3eYX3Lhh28@@60003020326434:82Hb`3aSP3eYX3oml3ool3oml2mih3ked3
W=<3W?<3>NL32445000<<JH3W=<2ic`3mkh6ool3mkh3kgd2ic`3U983U;83W=<Hool001Ooo`IBRP9:
J@U:B@>]M@?_O@;oo`?g_P?_O@?W?0>DTP<aQP<8@@8000<H``<Hh`<Q10=kk`?F^P;og`?oo`?W70?N
n`?Nf`?F^P;FVP=cSP<Q10H000<08088H@<@XP=S;0?6>0?FVP?og`;oo`?og`?gWP?_G@>Ld`>Ll`<i
i`88@@H000/aYP>Ld`?W?0?g_PKoo`;g_P?_O@?W?0>DTP>D/P>Ld`Soo`EBRP=:J@U:B@>]M@;_O@?o
o`?g_P?_O@?W?0>DTP8aQP<8@@<000<H``<Hh`<Q109kk`?F^P?og`?oo`?W70?Nn`?Nf`;F^P?FVP=c
SP<Q10H0008080<8H@<@XP=S;0?6>0?FVP;og`?oo`?og`?gWP?_G@>Ld`:Ll`<ii`<8@@H000/aYP>L
d`?W?0?g_PGoo`?g_P?_O@?W?0>DTP>D/P:Ld`Woo`EBRP=:J@U:B@:]M@?_O@?oo`?g_P?_O@?W?0:D
TP<aQP<8@@<000<H``<Hh`8Q10=kk`?F^P?og`?oo`?W70;Nn`?Nf`?F^P?FVP=cSP<Q10D000<080<8
H@<@XP=S;0?6>0;FVP?og`?oo`?og`?gWP?_G@:Ld`>Ll`<ii`<8@@H000/aYP>Ld`?W?0;g_PKoo`?g
_P?_O@?W?0>DTP:D/P>Ld`Soo`IBRP=:J@Q:B@>]M@?_O@?oo`?g_P;_O@?W?0>DTP<aQP<8@@<000<H
``8Hh`<Q10=kk`?F^P?og`?oo`;W70?Nn`?Nf`?F^P?FVP=cSP8Q10H000<080<8H@<@XP9S;0?6>0?F
VP?og`?oo`?og`;gWP?_G@>Ld`>Ll`<ii`<8@@D000`aYP>Ld`;W?0?g_PKoo`?g_P?_O@;W?0>DTP>D
/P>LdaSoo`005ooo0icC0icc0SWW0c660`Q10`000`0P0`QQ0Q2R0aS30g>>0f]]0liI0mkK0nLl0_oo
0oNn0kgG0e:Z0a2R0`000PQ10a220f<<0e[[0kgg0liI0]Jj0nLL0ooo0ooO0lHH0e[[0QS31P000`Q1
0a220e[;1E:Z0e::0kFf0kgg0lHh0mJJ0_oO0ooo0ooO2LHh0V<<0aS30`000`0P0`QQ0a2R0QSS0g>^
0g>>0lii0ooO2ooo0icC0Ycc0cWW0c660`Q10`000`0P0PQQ0a2R0aS30g>>0f]]0liI0]kK0nLl0ooo
0oNn0kgG0e:Z0Q2R0`000`Q10a220f<<0e[[0kgg0/iI0mJj0nLL0ooo0ooO0lHH0U[[0aS31P000`Q1
0a220U[;1U:Z0e::0kFf0kgg0/Hh0mJJ0ooO0ooo0ooO2<Hh0f<<0aS30`000`0P0`QQ0Q2R0aSS0g>^
0g>>0lii0ooO2ooo0YcC0icc0cWW0c660`Q10`000P0P0`QQ0a2R0aS30g>>0f]]0/iI0mkK0nLl0ooo
0oNn0kgG0U:Z0a2R0`000`Q10a220f<<0U[[0kgg0liI0mJj0nLL0ooo0ooO0/HH0e[[0aS31P000`Q1
0Q220e[;1U:Z0e::0kFf0[gg0lHh0mJJ0ooO0ooo0ooO2<Hh0f<<0aS30`000P0P0`QQ0a2R0aSS0g>^
0g>>0lii0_oO2ooo0icC0icc0cWW0c660PQ10`000`0P0`QQ0a2R0aS30W>>0f]]0liI0mkK0nLl0ooo
0oNn0[gG0e:Z0a2R0`000`Q10a220V<<0e[[0kgg0liI0mJj0nLL0_oo0ooO0lHH0e[[0aS31@000`Q1
0a220e[;1U:Z0U::0kFf0kgg0lHh0mJJ0ooO0ooo0_oO2LHh0f<<0aS30P000`0P0`QQ0a2R0aSS0g>^
0W>>0lii0ooO6ooo000Gool3W=<3W?<2>NL3<HH324430003020326424:836<<3Lhh3Jfd3cUT3g]/3
ic`2ool3mkh3_ML3DZX34:83000224434883H``3F^/3_OL3cUT2e[X3ia`3ool3oml3aQP3F^/26<<6
000324434883F//5DZX3DXX3]KH3_OL3aSP3eYX2oml3ool3oml9aSP2H``36<<30003020326434:82
6><3Ljh3Lhh3cWT3oml;ool3W=<2W?<3>NL3<HH324430003020226434:836<<3Lhh3Jfd3cUT2g]/3
ic`3ool3mkh3_ML3DZX24:83000324434883H``3F^/3_OL2cUT3e[X3ia`3ool3oml3aQP2F^/36<<6
000324434882F//6DZX3DXX3]KH3_OL2aSP3eYX3oml3ool3oml8aSP3H``36<<30003020326424:83
6><3Ljh3Lhh3cWT3oml;ool2W=<3W?<3>NL3<HH324430002020326434:836<<3Lhh3Jfd2cUT3g]/3
ic`3ool3mkh3_ML2DZX34:83000324434883H``2F^/3_OL3cUT3e[X3ia`3ool3oml2aQP3F^/36<<6
000324424883F//6DZX3DXX3]KH2_OL3aSP3eYX3oml3ool3oml8aSP3H``36<<30002020326434:83
6><3Ljh3Lhh3cWT2oml;ool3W=<3W?<3>NL3<HH224430003020326434:836<<2Lhh3Jfd3cUT3g]/3
ic`3ool3mkh2_ML3DZX34:83000324434882H``3F^/3_OL3cUT3e[X3ia`2ool3oml3aQP3F^/36<<5
000324434883F//6DZX2DXX3]KH3_OL3aSP3eYX3oml3ool2oml9aSP3H``36<<20003020326434:83
6><3Ljh2Lhh3cWT3omlKool001Ooo`>Ld`>Ll`8ii`<aQP<8@@<000<080<8H@8@XP<H``=cSP=[K@?>
F@?Nf`?W?0;oo`?g_P>me`=BZP<@XP<00088@@<@PP=S30=Jj`>mm`?>F@;F^P?W70?oo`?og`?660=J
j`8H``H000<8@@<@PP=Jb`EBZP=BRP>e]P>mm`?6>0?FVP;og`?oo`?og`W6>09S30<H``<000<080<8
H@<@XP8Hh`=c[P=cSP?>N@?og`_oo`>Ld`:Ll`<ii`<aQP<8@@<000<08088H@<@XP<H``=cSP=[K@?>
F@;Nf`?W?0?oo`?g_P>me`=BZP8@XP<000<8@@<@PP=S30=Jj`>mm`;>F@?F^P?W70?oo`?og`?6609J
j`<H``H000<8@@<@PP9Jb`IBZP=BRP>e]P>mm`;6>0?FVP?og`?oo`?og`S6>0=S30<H``<000<080<8
H@8@XP<Hh`=c[P=cSP?>N@?og`_oo`:Ld`>Ll`<ii`<aQP<8@@<0008080<8H@<@XP<H``=cSP=[K@;>
F@?Nf`?W?0?oo`?g_P>me`9BZP<@XP<000<8@@<@PP=S309Jj`>mm`?>F@?F^P?W70?oo`?og`;660=J
j`<H``H000<8@@8@PP=Jb`IBZP=BRP>e]P:mm`?6>0?FVP?og`?oo`?og`S6>0=S30<H``<0008080<8
H@<@XP<Hh`=c[P=cSP?>N@;og`_oo`>Ld`>Ll`<ii`<aQP88@@<000<080<8H@<@XP<H``9cSP=[K@?>
F@?Nf`?W?0?oo`?g_P:me`=BZP<@XP<000<8@@<@PP9S30=Jj`>mm`?>F@?F^P?W70;oo`?og`?660=J
j`<H``D000<8@@<@PP=Jb`IBZP9BRP>e]P>mm`?6>0?FVP?og`?oo`;og`W6>0=S30<H``8000<080<8
H@<@XP<Hh`=c[P9cSP?>N@?oga_oo`005ooo0icC0icc0SWW0c660`Q10`000`0P0`QQ0Q2R0aS30g>>
0f]]0liI0mkK0nLl0_oo0oNn0kgG0e:Z0a2R0`000PQ10a220f<<0e[[0kgg0liI0]Jj0nLL0ooo0ooO
0lHH0e[[0QS31P000`Q10a220e[;1E:Z0e::0kFf0kgg0lHh0mJJ0_oO0ooo0ooO2LHh0V<<0aS30`00
0`0P0`QQ0a2R0QSS0g>^0g>>0lii0ooO2ooo0icC0Ycc0cWW0c660`Q10`000`0P0PQQ0a2R0aS30g>>
0f]]0liI0]kK0nLl0ooo0oNn0kgG0e:Z0Q2R0`000`Q10a220f<<0e[[0kgg0/iI0mJj0nLL0ooo0ooO
0lHH0U[[0aS31P000`Q10a220U[;1U:Z0e::0kFf0kgg0/Hh0mJJ0ooO0ooo0ooO2<Hh0f<<0aS30`00
0`0P0`QQ0Q2R0aSS0g>^0g>>0lii0ooO2ooo0YcC0icc0cWW0c660`Q10`000P0P0`QQ0a2R0aS30g>>
0f]]0/iI0mkK0nLl0ooo0oNn0kgG0U:Z0a2R0`000`Q10a220f<<0U[[0kgg0liI0mJj0nLL0ooo0ooO
0/HH0e[[0aS31P000`Q10Q220e[;1U:Z0e::0kFf0[gg0lHh0mJJ0ooO0ooo0ooO2<Hh0f<<0aS30`00
0P0P0`QQ0a2R0aSS0g>^0g>>0lii0_oO2ooo0icC0icc0cWW0c660PQ10`000`0P0`QQ0a2R0aS30W>>
0f]]0liI0mkK0nLl0ooo0oNn0[gG0e:Z0a2R0`000`Q10a220V<<0e[[0kgg0liI0mJj0nLL0_oo0ooO
0lHH0e[[0aS31@000`Q10a220e[;1U:Z0U::0kFf0kgg0lHh0mJJ0ooO0ooo0_oO2LHh0f<<0aS30P00
0`0P0`QQ0a2R0aSS0g>^0W>>0lii0ooO6ooo000Gool3W=<3W?<2>NL3<HH324430003020326424:83
6<<3Lhh3Jfd3cUT3g]/3ic`2ool3mkh3_ML3DZX34:83000224434883H``3F^/3_OL3cUT2e[X3ia`3
ool3oml3aQP3F^/26<<6000324434883F//5DZX3DXX3]KH3_OL3aSP3eYX2oml3ool3oml9aSP2H``3
6<<30003020326434:826><3Ljh3Lhh3cWT3oml;ool3W=<2W?<3>NL3<HH324430003020226434:83
6<<3Lhh3Jfd3cUT2g]/3ic`3ool3mkh3_ML3DZX24:83000324434883H``3F^/3_OL2cUT3e[X3ia`3
ool3oml3aQP2F^/36<<6000324434882F//6DZX3DXX3]KH3_OL2aSP3eYX3oml3ool3oml8aSP3H``3
6<<30003020326424:836><3Ljh3Lhh3cWT3oml;ool2W=<3W?<3>NL3<HH324430002020326434:83
6<<3Lhh3Jfd2cUT3g]/3ic`3ool3mkh3_ML2DZX34:83000324434883H``2F^/3_OL3cUT3e[X3ia`3
ool3oml2aQP3F^/36<<6000324424883F//6DZX3DXX3]KH2_OL3aSP3eYX3oml3ool3oml8aSP3H``3
6<<30002020326434:836><3Ljh3Lhh3cWT2oml;ool3W=<3W?<3>NL3<HH224430003020326434:83
6<<2Lhh3Jfd3cUT3g]/3ic`3ool3mkh2_ML3DZX34:83000324434882H``3F^/3_OL3cUT3e[X3ia`2
ool3oml3aQP3F^/36<<5000324434883F//6DZX2DXX3]KH3_OL3aSP3eYX3oml3ool2oml9aSP3H``3
6<<20003020326434:836><3Ljh2Lhh3cWT3omlKool001Ooo`>Ld`>Ll`8ii`<aQP<8@@<000<080<8
H@8@XP<H``=cSP=[K@?>F@?Nf`?W?0;oo`?g_P>me`=BZP<@XP<00088@@<@PP=S30=Jj`>mm`?>F@;F
^P?W70?oo`?og`?660=Jj`8H``H000<8@@<@PP=Jb`EBZP=BRP>e]P>mm`?6>0?FVP;og`?oo`?og`W6
>09S30<H``<000<080<8H@<@XP8Hh`=c[P=cSP?>N@?og`_oo`>Ld`:Ll`<ii`<aQP<8@@<000<08088
H@<@XP<H``=cSP=[K@?>F@;Nf`?W?0?oo`?g_P>me`=BZP8@XP<000<8@@<@PP=S30=Jj`>mm`;>F@?F
^P?W70?oo`?og`?6609Jj`<H``H000<8@@<@PP9Jb`IBZP=BRP>e]P>mm`;6>0?FVP?og`?oo`?og`S6
>0=S30<H``<000<080<8H@8@XP<Hh`=c[P=cSP?>N@?og`_oo`:Ld`>Ll`<ii`<aQP<8@@<0008080<8
H@<@XP<H``=cSP=[K@;>F@?Nf`?W?0?oo`?g_P>me`9BZP<@XP<000<8@@<@PP=S309Jj`>mm`?>F@?F
^P?W70?oo`?og`;660=Jj`<H``H000<8@@8@PP=Jb`IBZP=BRP>e]P:mm`?6>0?FVP?og`?oo`?og`S6
>0=S30<H``<0008080<8H@<@XP<Hh`=c[P=cSP?>N@;og`_oo`>Ld`>Ll`<ii`<aQP88@@<000<080<8
H@<@XP<H``9cSP=[K@?>F@?Nf`?W?0?oo`?g_P:me`=BZP<@XP<000<8@@<@PP9S30=Jj`>mm`?>F@?F
^P?W70;oo`?og`?660=Jj`<H``D000<8@@<@PP=Jb`IBZP9BRP>e]P>mm`?6>0?FVP?og`?oo`;og`W6
>0=S30<H``8000<080<8H@<@XP<Hh`=c[P9cSP?>N@?oga_oo`005ooo0icC0icc0SWW0c660`Q10`00
0`0P0`QQ0Q2R0aS30g>>0f]]0liI0mkK0nLl0_oo0oNn0kgG0e:Z0a2R0`000PQ10a220f<<0e[[0kgg
0liI0]Jj0nLL0ooo0ooO0lHH0e[[0QS31P000`Q10a220e[;1E:Z0e::0kFf0kgg0lHh0mJJ0_oO0ooo
0ooO2LHh0V<<0aS30`000`0P0`QQ0a2R0QSS0g>^0g>>0lii0ooO2ooo0icC0Ycc0cWW0c660`Q10`00
0`0P0PQQ0a2R0aS30g>>0f]]0liI0]kK0nLl0ooo0oNn0kgG0e:Z0Q2R0`000`Q10a220f<<0e[[0kgg
0/iI0mJj0nLL0ooo0ooO0lHH0U[[0aS31P000`Q10a220U[;1U:Z0e::0kFf0kgg0/Hh0mJJ0ooO0ooo
0ooO2<Hh0f<<0aS30`000`0P0`QQ0Q2R0aSS0g>^0g>>0lii0ooO2ooo0YcC0icc0cWW0c660`Q10`00
0P0P0`QQ0a2R0aS30g>>0f]]0/iI0mkK0nLl0ooo0oNn0kgG0U:Z0a2R0`000`Q10a220f<<0U[[0kgg
0liI0mJj0nLL0ooo0ooO0/HH0e[[0aS31P000`Q10Q220e[;1U:Z0e::0kFf0[gg0lHh0mJJ0ooO0ooo
0ooO2<Hh0f<<0aS30`000P0P0`QQ0a2R0aSS0g>^0g>>0lii0_oO2ooo0icC0icc0cWW0c660PQ10`00
0`0P0`QQ0a2R0aS30W>>0f]]0liI0mkK0nLl0ooo0oNn0[gG0e:Z0a2R0`000`Q10a220V<<0e[[0kgg
0liI0mJj0nLL0_oo0ooO0lHH0e[[0aS31@000`Q10a220e[;1U:Z0U::0kFf0kgg0lHh0mJJ0ooO0ooo
0_oO2LHh0f<<0aS30P000`0P0`QQ0a2R0aSS0g>^0W>>0lii0ooO6ooo000Gool3W=<3W?<2>NL3<HH3
24430003020326424:836<<3Lhh3Jfd3cUT3g]/3ic`2ool3mkh3_ML3DZX34:83000224434883H``3
F^/3_OL3cUT2e[X3ia`3ool3oml3aQP3F^/26<<6000324434883F//5DZX3DXX3]KH3_OL3aSP3eYX2
oml3ool3oml9aSP2H``36<<30003020326434:826><3Ljh3Lhh3cWT3oml;ool3W=<2W?<3>NL3<HH3
24430003020226434:836<<3Lhh3Jfd3cUT2g]/3ic`3ool3mkh3_ML3DZX24:83000324434883H``3
F^/3_OL2cUT3e[X3ia`3ool3oml3aQP2F^/36<<6000324434882F//6DZX3DXX3]KH3_OL2aSP3eYX3
oml3ool3oml8aSP3H``36<<30003020326424:836><3Ljh3Lhh3cWT3oml;ool2W=<3W?<3>NL3<HH3
24430002020326434:836<<3Lhh3Jfd2cUT3g]/3ic`3ool3mkh3_ML2DZX34:83000324434883H``2
F^/3_OL3cUT3e[X3ia`3ool3oml2aQP3F^/36<<6000324424883F//6DZX3DXX3]KH2_OL3aSP3eYX3
oml3ool3oml8aSP3H``36<<30002020326434:836><3Ljh3Lhh3cWT2oml;ool3W=<3W?<3>NL3<HH2
24430003020326434:836<<2Lhh3Jfd3cUT3g]/3ic`3ool3mkh2_ML3DZX34:83000324434882H``3
F^/3_OL3cUT3e[X3ia`2ool3oml3aQP3F^/36<<5000324434883F//6DZX2DXX3]KH3_OL3aSP3eYX3
oml3ool2oml9aSP3H``36<<20003020326434:836><3Ljh2Lhh3cWT3omlKool001Ooo`>Ld`>Ll`8i
i`<aQP<8@@<000<080<8H@8@XP<H``=cSP=[K@?>F@?Nf`?W?0;oo`?g_P>me`=BZP<@XP<00088@@<@
PP=S30=Jj`>mm`?>F@;F^P?W70?oo`?og`?660=Jj`8H``H000<8@@<@PP=Jb`EBZP=BRP>e]P>mm`?6
>0?FVP;og`?oo`?og`W6>09S30<H``<000<080<8H@<@XP8Hh`=c[P=cSP?>N@?og`_oo`>Ld`:Ll`<i
i`<aQP<8@@<000<08088H@<@XP<H``=cSP=[K@?>F@;Nf`?W?0?oo`?g_P>me`=BZP8@XP<000<8@@<@
PP=S30=Jj`>mm`;>F@?F^P?W70?oo`?og`?6609Jj`<H``H000<8@@<@PP9Jb`IBZP=BRP>e]P>mm`;6
>0?FVP?og`?oo`?og`S6>0=S30<H``<000<080<8H@8@XP<Hh`=c[P=cSP?>N@?og`_oo`:Ld`>Ll`<i
i`<aQP<8@@<0008080<8H@<@XP<H``=cSP=[K@;>F@?Nf`?W?0?oo`?g_P>me`9BZP<@XP<000<8@@<@
PP=S309Jj`>mm`?>F@?F^P?W70?oo`?og`;660=Jj`<H``H000<8@@8@PP=Jb`IBZP=BRP>e]P:mm`?6
>0?FVP?og`?oo`?og`S6>0=S30<H``<0008080<8H@<@XP<Hh`=c[P=cSP?>N@;og`_oo`>Ld`>Ll`<i
i`<aQP88@@<000<080<8H@<@XP<H``9cSP=[K@?>F@?Nf`?W?0?oo`?g_P:me`=BZP<@XP<000<8@@<@
PP9S30=Jj`>mm`?>F@?F^P?W70;oo`?og`?660=Jj`<H``D000<8@@<@PP=Jb`IBZP9BRP>e]P>mm`?6
>0?FVP?og`?oo`;og`W6>0=S30<H``8000<080<8H@<@XP<Hh`=c[P9cSP?>N@?oga_oo`005ooo0icC
0icc0SWW0c660`Q10`000`0P0`QQ0Q2R0aS30g>>0f]]0liI0mkK0nLl0_oo0oNn0kgG0e:Z0a2R0`00
0PQ10a220f<<0e[[0kgg0liI0]Jj0nLL0ooo0ooO0lHH0e[[0QS31P000`Q10a220e[;1E:Z0e::0kFf
0kgg0lHh0mJJ0_oO0ooo0ooO2LHh0V<<0aS30`000`0P0`QQ0a2R0QSS0g>^0g>>0lii0ooO2ooo0icC
0Ycc0cWW0c660`Q10`000`0P0PQQ0a2R0aS30g>>0f]]0liI0]kK0nLl0ooo0oNn0kgG0e:Z0Q2R0`00
0`Q10a220f<<0e[[0kgg0/iI0mJj0nLL0ooo0ooO0lHH0U[[0aS31P000`Q10a220U[;1U:Z0e::0kFf
0kgg0/Hh0mJJ0ooO0ooo0ooO2<Hh0f<<0aS30`000`0P0`QQ0Q2R0aSS0g>^0g>>0lii0ooO2ooo0YcC
0icc0cWW0c660`Q10`000P0P0`QQ0a2R0aS30g>>0f]]0/iI0mkK0nLl0ooo0oNn0kgG0U:Z0a2R0`00
0`Q10a220f<<0U[[0kgg0liI0mJj0nLL0ooo0ooO0/HH0e[[0aS31P000`Q10Q220e[;1U:Z0e::0kFf
0[gg0lHh0mJJ0ooO0ooo0ooO2<Hh0f<<0aS30`000P0P0`QQ0a2R0aSS0g>^0g>>0lii0_oO2ooo0icC
0icc0cWW0c660PQ10`000`0P0`QQ0a2R0aS30W>>0f]]0liI0mkK0nLl0ooo0oNn0[gG0e:Z0a2R0`00
0`Q10a220V<<0e[[0kgg0liI0mJj0nLL0_oo0ooO0lHH0e[[0aS31@000`Q10a220e[;1U:Z0U::0kFf
0kgg0lHh0mJJ0ooO0ooo0_oO2LHh0f<<0aS30P000`0P0`QQ0a2R0aSS0g>^0W>>0lii0ooO6ooo000G
ool3W=<3W?<2>NL3<HH324430003020326424:836<<3Lhh3Jfd3cUT3g]/3ic`2ool3mkh3_ML3DZX3
4:83000224434883H``3F^/3_OL3cUT2e[X3ia`3ool3oml3aQP3F^/26<<6000324434883F//5DZX3
DXX3]KH3_OL3aSP3eYX2oml3ool3oml9aSP2H``36<<30003020326434:826><3Ljh3Lhh3cWT3oml;
ool3W=<2W?<3>NL3<HH324430003020226434:836<<3Lhh3Jfd3cUT2g]/3ic`3ool3mkh3_ML3DZX2
4:83000324434883H``3F^/3_OL2cUT3e[X3ia`3ool3oml3aQP2F^/36<<6000324434882F//6DZX3
DXX3]KH3_OL2aSP3eYX3oml3ool3oml8aSP3H``36<<30003020326424:836><3Ljh3Lhh3cWT3oml;
ool2W=<3W?<3>NL3<HH324430002020326434:836<<3Lhh3Jfd2cUT3g]/3ic`3ool3mkh3_ML2DZX3
4:83000324434883H``2F^/3_OL3cUT3e[X3ia`3ool3oml2aQP3F^/36<<6000324424883F//6DZX3
DXX3]KH2_OL3aSP3eYX3oml3ool3oml8aSP3H``36<<30002020326434:836><3Ljh3Lhh3cWT2oml;
ool3W=<3W?<3>NL3<HH224430003020326434:836<<2Lhh3Jfd3cUT3g]/3ic`3ool3mkh2_ML3DZX3
4:83000324434882H``3F^/3_OL3cUT3e[X3ia`2ool3oml3aQP3F^/36<<5000324434883F//6DZX2
DXX3]KH3_OL3aSP3eYX3oml3ool2oml9aSP3H``36<<20003020326434:836><3Ljh2Lhh3cWT3omlK
ool001Ooo`>Ld`>Ll`8ii`<aQP<8@@<000<080<8H@8@XP<H``=cSP=[K@?>F@?Nf`?W?0;oo`?g_P>m
e`=BZP<@XP<00088@@<@PP=S30=Jj`>mm`?>F@;F^P?W70?oo`?og`?660=Jj`8H``H000<8@@<@PP=J
b`EBZP=BRP>e]P>mm`?6>0?FVP;og`?oo`?og`W6>09S30<H``<000<080<8H@<@XP8Hh`=c[P=cSP?>
N@?og`_oo`>Ld`:Ll`<ii`<aQP<8@@<000<08088H@<@XP<H``=cSP=[K@?>F@;Nf`?W?0?oo`?g_P>m
e`=BZP8@XP<000<8@@<@PP=S30=Jj`>mm`;>F@?F^P?W70?oo`?og`?6609Jj`<H``H000<8@@<@PP9J
b`IBZP=BRP>e]P>mm`;6>0?FVP?og`?oo`?og`S6>0=S30<H``<000<080<8H@8@XP<Hh`=c[P=cSP?>
N@?og`_oo`:Ld`>Ll`<ii`<aQP<8@@<0008080<8H@<@XP<H``=cSP=[K@;>F@?Nf`?W?0?oo`?g_P>m
e`9BZP<@XP<000<8@@<@PP=S309Jj`>mm`?>F@?F^P?W70?oo`?og`;660=Jj`<H``H000<8@@8@PP=J
b`IBZP=BRP>e]P:mm`?6>0?FVP?og`?oo`?og`S6>0=S30<H``<0008080<8H@<@XP<Hh`=c[P=cSP?>
N@;og`_oo`>Ld`>Ll`<ii`<aQP88@@<000<080<8H@<@XP<H``9cSP=[K@?>F@?Nf`?W?0?oo`?g_P:m
e`=BZP<@XP<000<8@@<@PP9S30=Jj`>mm`?>F@?F^P?W70;oo`?og`?660=Jj`<H``D000<8@@<@PP=J
b`IBZP9BRP>e]P>mm`?6>0?FVP?og`?oo`;og`W6>0=S30<H``8000<080<8H@<@XP<Hh`=c[P9cSP?>
N@?oga_oo`005ooo0ooO0oNN0^mM0nLl0mkk0mkK1]Jj0]JJ0g>>0b440a221P000bUU1Haa0mkk1_oo
0mkk0X@@0bU50`0P0`000`0P0`QQ0Q2R0aS30g>>0f]]0liI0mkK0_oO0ooo0oNn0nmm0jDD0jDd0T88
0`QQ0`000a220aS31V]=0V</0f<<0e[[0e[;0e:Z0kgG0_NN1_oo0oNn0nmm0nLl0^LL0h@`0haA0bUU
0b440`002?oo0ooO0_NN0nmM0nLl0mkk0mkK1MJj0mJJ0g>>0b440a221@000bUU1Xaa0mkk1Ooo0mkk
0h@@0bU50`0P0`000`0P0PQQ0a2R0aS30g>>0f]]0liI0]kK0ooO0ooo0oNn0nmm0jDD0ZDd0d880`QQ
0`000a220aS31F]=0f</0f<<0e[[0e[;0e:Z0[gG0oNN1_oo0oNn0nmm0^Ll0nLL0h@`0haA0bUU0b44
0P002Ooo0_oO0oNN0nmM0nLl0mkk0mkK1MJj0mJJ0g>>0b440a221@000bUU1Xaa0mkk1Ooo0mkk0h@@
0bU50`0P0P000`0P0`QQ0a2R0aS30g>>0f]]0/iI0mkK0ooO0ooo0oNn0nmm0ZDD0jDd0d880`QQ0`00
0a220QS31V]=0f</0f<<0e[[0U[;0e:Z0kgG0oNN1_oo0_Nn0nmm0nLl0nLL0h@`0haA0bUU0R440`00
2?oo0ooO0oNN0nmM0nLl0]kk0mkK1]Jj0mJJ0g>>0R440a221P000bUU1Xaa0]kk1_oo0mkk0h@@0bU5
0P0P0`000`0P0`QQ0a2R0aS30W>>0f]]0liI0mkK0ooO0ooo0_Nn0nmm0jDD0jDd0d880`QQ0P000a22
0aS31V]=0f</0f<<0U[[0e[;0e:Z0kgG0oNN1Ooo0oNn0nmm0nLl0nLL0h@`0XaA0bUU0b440`006?oo
000Gool3oml3mih2ked3ic`3g_/3g]/6e[X2eYX3Lhh38@@348860003:FD5S743g_/6ool3g_/2Q103
:DD302030003020326424:836<<3Lhh3Jfd3cUT3g]/2oml3ool3mkh3kgd3YA@3YC@2@PP326430003
48836<<6Jdd2Hb`3H``3F^/3F//3DZX3_ML2mih6ool3mkh3kgd3ic`2ia`3Q303S543:FD38@@30008
ool3oml2mih3ked3ic`3g_/3g]/5e[X3eYX3Lhh38@@348850003:FD6S743g_/5ool3g_/3Q103:DD3
02030003020226434:836<<3Lhh3Jfd3cUT2g]/3oml3ool3mkh3kgd3YA@2YC@3@PP3264300034883
6<<5Jdd3Hb`3H``3F^/3F//3DZX2_ML3mih6ool3mkh3kgd2ic`3ia`3Q303S543:FD38@@20009ool2
oml3mih3ked3ic`3g_/3g]/5e[X3eYX3Lhh38@@348850003:FD6S743g_/5ool3g_/3Q103:DD30202
0003020326434:836<<3Lhh3Jfd2cUT3g]/3oml3ool3mkh3kgd2YA@3YC@3@PP32643000348826<<6
Jdd3Hb`3H``3F^/2F//3DZX3_ML3mih6ool2mkh3kgd3ic`3ia`3Q303S543:FD28@@30008ool3oml3
mih3ked3ic`2g_/3g]/6e[X3eYX3Lhh28@@348860003:FD6S742g_/6ool3g_/3Q103:DD202030003
020326434:836<<2Lhh3Jfd3cUT3g]/3oml3ool2mkh3kgd3YA@3YC@3@PP32642000348836<<6Jdd3
Hb`3H``2F^/3F//3DZX3_ML3mih5ool3mkh3kgd3ic`3ia`3Q302S543:FD38@@3000Hool001Ooo`?o
g`?gWP;_G@?W?0?Nn`?Nf`KF^P;FVP=cSP<Q10<@PPH000<YI@F<L@?Nn`Koo`?Nn`:440<YA@<080<0
00<080<8H@8@XP<H``=cSP=[K@?>F@?Nf`;og`?oo`?g_P?_O@>U50>U=09220<8H@<000<@PP<H``I[
C@9S;0=S30=Jj`=Jb`=BZP>me`;gWPKoo`?g_P?_O@?W?0;W70>4<0><D@<YI@<Q10<000Soo`?og`;g
WP?_G@?W?0?Nn`?Nf`GF^P?FVP=cSP<Q10<@PPD000<YI@J<L@?Nn`Goo`?Nn`>440<YA@<080<000<0
8088H@<@XP<H``=cSP=[K@?>F@;Nf`?og`?oo`?g_P?_O@>U50:U=0=220<8H@<000<@PP<H``E[C@=S
;0=S30=Jj`=Jb`=BZP:me`?gWPKoo`?g_P?_O@;W?0?W70>4<0><D@<YI@<Q108000Woo`;og`?gWP?_
G@?W?0?Nn`?Nf`GF^P?FVP=cSP<Q10<@PPD000<YI@J<L@?Nn`Goo`?Nn`>440<YA@<0808000<080<8
H@<@XP<H``=cSP=[K@;>F@?Nf`?og`?oo`?g_P?_O@:U50>U=0=220<8H@<000<@PP8H``I[C@=S;0=S
30=Jj`9Jb`=BZP>me`?gWPKoo`;g_P?_O@?W?0?W70>4<0><D@<YI@8Q10<000Soo`?og`?gWP?_G@?W
?0;Nn`?Nf`KF^P?FVP=cSP8Q10<@PPH000<YI@J<L@;Nn`Koo`?Nn`>440<YA@8080<000<080<8H@<@
XP<H``9cSP=[K@?>F@?Nf`?og`?oo`;g_P?_O@>U50>U=0=220<8H@8000<@PP<H``I[C@=S;0=S309J
j`=Jb`=BZP>me`?gWPGoo`?g_P?_O@?W?0?W70>4<0:<D@<YI@<Q10<001Soo`005ooo0ooO0oNN0^mM
0nLl0mkk0mkK1]Jj0]JJ0g>>0b440a221P000bUU1Haa0mkk1_oo0mkk0X@@0bU50`0P0`000`0P0`QQ
0Q2R0aS30g>>0f]]0liI0mkK0_oO0ooo0oNn0nmm0jDD0jDd0T880`QQ0`000a220aS31V]=0V</0f<<
0e[[0e[;0e:Z0kgG0_NN1_oo0oNn0nmm0nLl0^LL0h@`0haA0bUU0b440`002?oo0ooO0_NN0nmM0nLl
0mkk0mkK1MJj0mJJ0g>>0b440a221@000bUU1Xaa0mkk1Ooo0mkk0h@@0bU50`0P0`000`0P0PQQ0a2R
0aS30g>>0f]]0liI0]kK0ooO0ooo0oNn0nmm0jDD0ZDd0d880`QQ0`000a220aS31F]=0f</0f<<0e[[
0e[;0e:Z0[gG0oNN1_oo0oNn0nmm0^Ll0nLL0h@`0haA0bUU0b440P002Ooo0_oO0oNN0nmM0nLl0mkk
0mkK1MJj0mJJ0g>>0b440a221@000bUU1Xaa0mkk1Ooo0mkk0h@@0bU50`0P0P000`0P0`QQ0a2R0aS3
0g>>0f]]0/iI0mkK0ooO0ooo0oNn0nmm0ZDD0jDd0d880`QQ0`000a220QS31V]=0f</0f<<0e[[0U[;
0e:Z0kgG0oNN1_oo0_Nn0nmm0nLl0nLL0h@`0haA0bUU0R440`002?oo0ooO0oNN0nmM0nLl0]kk0mkK
1]Jj0mJJ0g>>0R440a221P000bUU1Xaa0]kk1_oo0mkk0h@@0bU50P0P0`000`0P0`QQ0a2R0aS30W>>
0f]]0liI0mkK0ooO0ooo0_Nn0nmm0jDD0jDd0d880`QQ0P000a220aS31V]=0f</0f<<0U[[0e[;0e:Z
0kgG0oNN1Ooo0oNn0nmm0nLl0nLL0h@`0XaA0bUU0b440`006?oo000Gool3oml3mih2ked3ic`3g_/3
g]/6e[X2eYX3Lhh38@@348860003:FD5S743g_/6ool3g_/2Q103:DD302030003020326424:836<<3
Lhh3Jfd3cUT3g]/2oml3ool3mkh3kgd3YA@3YC@2@PP32643000348836<<6Jdd2Hb`3H``3F^/3F//3
DZX3_ML2mih6ool3mkh3kgd3ic`2ia`3Q303S543:FD38@@30008ool3oml2mih3ked3ic`3g_/3g]/5
e[X3eYX3Lhh38@@348850003:FD6S743g_/5ool3g_/3Q103:DD302030003020226434:836<<3Lhh3
Jfd3cUT2g]/3oml3ool3mkh3kgd3YA@2YC@3@PP32643000348836<<5Jdd3Hb`3H``3F^/3F//3DZX2
_ML3mih6ool3mkh3kgd2ic`3ia`3Q303S543:FD38@@20009ool2oml3mih3ked3ic`3g_/3g]/5e[X3
eYX3Lhh38@@348850003:FD6S743g_/5ool3g_/3Q103:DD302020003020326434:836<<3Lhh3Jfd2
cUT3g]/3oml3ool3mkh3kgd2YA@3YC@3@PP32643000348826<<6Jdd3Hb`3H``3F^/2F//3DZX3_ML3
mih6ool2mkh3kgd3ic`3ia`3Q303S543:FD28@@30008ool3oml3mih3ked3ic`2g_/3g]/6e[X3eYX3
Lhh28@@348860003:FD6S742g_/6ool3g_/3Q103:DD202030003020326434:836<<2Lhh3Jfd3cUT3
g]/3oml3ool2mkh3kgd3YA@3YC@3@PP32642000348836<<6Jdd3Hb`3H``2F^/3F//3DZX3_ML3mih5
ool3mkh3kgd3ic`3ia`3Q302S543:FD38@@3000Hool001Ooo`?og`?gWP;_G@?W?0?Nn`?Nf`KF^P;F
VP=cSP<Q10<@PPH000<YI@F<L@?Nn`Koo`?Nn`:440<YA@<080<000<080<8H@8@XP<H``=cSP=[K@?>
F@?Nf`;og`?oo`?g_P?_O@>U50>U=09220<8H@<000<@PP<H``I[C@9S;0=S30=Jj`=Jb`=BZP>me`;g
WPKoo`?g_P?_O@?W?0;W70>4<0><D@<YI@<Q10<000Soo`?og`;gWP?_G@?W?0?Nn`?Nf`GF^P?FVP=c
SP<Q10<@PPD000<YI@J<L@?Nn`Goo`?Nn`>440<YA@<080<000<08088H@<@XP<H``=cSP=[K@?>F@;N
f`?og`?oo`?g_P?_O@>U50:U=0=220<8H@<000<@PP<H``E[C@=S;0=S30=Jj`=Jb`=BZP:me`?gWPKo
o`?g_P?_O@;W?0?W70>4<0><D@<YI@<Q108000Woo`;og`?gWP?_G@?W?0?Nn`?Nf`GF^P?FVP=cSP<Q
10<@PPD000<YI@J<L@?Nn`Goo`?Nn`>440<YA@<0808000<080<8H@<@XP<H``=cSP=[K@;>F@?Nf`?o
g`?oo`?g_P?_O@:U50>U=0=220<8H@<000<@PP8H``I[C@=S;0=S30=Jj`9Jb`=BZP>me`?gWPKoo`;g
_P?_O@?W?0?W70>4<0><D@<YI@8Q10<000Soo`?og`?gWP?_G@?W?0;Nn`?Nf`KF^P?FVP=cSP8Q10<@
PPH000<YI@J<L@;Nn`Koo`?Nn`>440<YA@8080<000<080<8H@<@XP<H``9cSP=[K@?>F@?Nf`?og`?o
o`;g_P?_O@>U50>U=0=220<8H@8000<@PP<H``I[C@=S;0=S309Jj`=Jb`=BZP>me`?gWPGoo`?g_P?_
O@?W?0?W70>4<0:<D@<YI@<Q10<001Soo`005ooo0ooO0oNN0^mM0nLl0mkk0mkK1]Jj0]JJ0g>>0b44
0a221P000bUU1Haa0mkk1_oo0mkk0X@@0bU50`0P0`000`0P0`QQ0Q2R0aS30g>>0f]]0liI0mkK0_oO
0ooo0oNn0nmm0jDD0jDd0T880`QQ0`000a220aS31V]=0V</0f<<0e[[0e[;0e:Z0kgG0_NN1_oo0oNn
0nmm0nLl0^LL0h@`0haA0bUU0b440`002?oo0ooO0_NN0nmM0nLl0mkk0mkK1MJj0mJJ0g>>0b440a22
1@000bUU1Xaa0mkk1Ooo0mkk0h@@0bU50`0P0`000`0P0PQQ0a2R0aS30g>>0f]]0liI0]kK0ooO0ooo
0oNn0nmm0jDD0ZDd0d880`QQ0`000a220aS31F]=0f</0f<<0e[[0e[;0e:Z0[gG0oNN1_oo0oNn0nmm
0^Ll0nLL0h@`0haA0bUU0b440P002Ooo0_oO0oNN0nmM0nLl0mkk0mkK1MJj0mJJ0g>>0b440a221@00
0bUU1Xaa0mkk1Ooo0mkk0h@@0bU50`0P0P000`0P0`QQ0a2R0aS30g>>0f]]0/iI0mkK0ooO0ooo0oNn
0nmm0ZDD0jDd0d880`QQ0`000a220QS31V]=0f</0f<<0e[[0U[;0e:Z0kgG0oNN1_oo0_Nn0nmm0nLl
0nLL0h@`0haA0bUU0R440`002?oo0ooO0oNN0nmM0nLl0]kk0mkK1]Jj0mJJ0g>>0R440a221P000bUU
1Xaa0]kk1_oo0mkk0h@@0bU50P0P0`000`0P0`QQ0a2R0aS30W>>0f]]0liI0mkK0ooO0ooo0_Nn0nmm
0jDD0jDd0d880`QQ0P000a220aS31V]=0f</0f<<0U[[0e[;0e:Z0kgG0oNN1Ooo0oNn0nmm0nLl0nLL
0h@`0XaA0bUU0b440`006?oo000Gool3oml3mih2ked3ic`3g_/3g]/6e[X2eYX3Lhh38@@348860003
:FD5S743g_/6ool3g_/2Q103:DD302030003020326424:836<<3Lhh3Jfd3cUT3g]/2oml3ool3mkh3
kgd3YA@3YC@2@PP32643000348836<<6Jdd2Hb`3H``3F^/3F//3DZX3_ML2mih6ool3mkh3kgd3ic`2
ia`3Q303S543:FD38@@30008ool3oml2mih3ked3ic`3g_/3g]/5e[X3eYX3Lhh38@@348850003:FD6
S743g_/5ool3g_/3Q103:DD302030003020226434:836<<3Lhh3Jfd3cUT2g]/3oml3ool3mkh3kgd3
YA@2YC@3@PP32643000348836<<5Jdd3Hb`3H``3F^/3F//3DZX2_ML3mih6ool3mkh3kgd2ic`3ia`3
Q303S543:FD38@@20009ool2oml3mih3ked3ic`3g_/3g]/5e[X3eYX3Lhh38@@348850003:FD6S743
g_/5ool3g_/3Q103:DD302020003020326434:836<<3Lhh3Jfd2cUT3g]/3oml3ool3mkh3kgd2YA@3
YC@3@PP32643000348826<<6Jdd3Hb`3H``3F^/2F//3DZX3_ML3mih6ool2mkh3kgd3ic`3ia`3Q303
S543:FD28@@30008ool3oml3mih3ked3ic`2g_/3g]/6e[X3eYX3Lhh28@@348860003:FD6S742g_/6
ool3g_/3Q103:DD202030003020326434:836<<2Lhh3Jfd3cUT3g]/3oml3ool2mkh3kgd3YA@3YC@3
@PP32642000348836<<6Jdd3Hb`3H``2F^/3F//3DZX3_ML3mih5ool3mkh3kgd3ic`3ia`3Q302S543
:FD38@@3000Hool001Ooo`?og`?gWP;_G@?W?0?Nn`?Nf`KF^P;FVP=cSP<Q10<@PPH000<YI@F<L@?N
n`Koo`?Nn`:440<YA@<080<000<080<8H@8@XP<H``=cSP=[K@?>F@?Nf`;og`?oo`?g_P?_O@>U50>U
=09220<8H@<000<@PP<H``I[C@9S;0=S30=Jj`=Jb`=BZP>me`;gWPKoo`?g_P?_O@?W?0;W70>4<0><
D@<YI@<Q10<000Soo`?og`;gWP?_G@?W?0?Nn`?Nf`GF^P?FVP=cSP<Q10<@PPD000<YI@J<L@?Nn`Go
o`?Nn`>440<YA@<080<000<08088H@<@XP<H``=cSP=[K@?>F@;Nf`?og`?oo`?g_P?_O@>U50:U=0=2
20<8H@<000<@PP<H``E[C@=S;0=S30=Jj`=Jb`=BZP:me`?gWPKoo`?g_P?_O@;W?0?W70>4<0><D@<Y
I@<Q108000Woo`;og`?gWP?_G@?W?0?Nn`?Nf`GF^P?FVP=cSP<Q10<@PPD000<YI@J<L@?Nn`Goo`?N
n`>440<YA@<0808000<080<8H@<@XP<H``=cSP=[K@;>F@?Nf`?og`?oo`?g_P?_O@:U50>U=0=220<8
H@<000<@PP8H``I[C@=S;0=S30=Jj`9Jb`=BZP>me`?gWPKoo`;g_P?_O@?W?0?W70>4<0><D@<YI@8Q
10<000Soo`?og`?gWP?_G@?W?0;Nn`?Nf`KF^P?FVP=cSP8Q10<@PPH000<YI@J<L@;Nn`Koo`?Nn`>4
40<YA@8080<000<080<8H@<@XP<H``9cSP=[K@?>F@?Nf`?og`?oo`;g_P?_O@>U50>U=0=220<8H@80
00<@PP<H``I[C@=S;0=S309Jj`=Jb`=BZP>me`?gWPGoo`?g_P?_O@?W?0?W70>4<0:<D@<YI@<Q10<0
01Soo`005ooo0ooO0oNN0^mM0nLl0mkk0mkK1]Jj0]JJ0g>>0b440a221P000bUU1Haa0mkk1_oo0mkk
0X@@0bU50`0P0`000`0P0`QQ0Q2R0aS30g>>0f]]0liI0mkK0_oO0ooo0oNn0nmm0jDD0jDd0T880`QQ
0`000a220aS31V]=0V</0f<<0e[[0e[;0e:Z0kgG0_NN1_oo0oNn0nmm0nLl0^LL0h@`0haA0bUU0b44
0`002?oo0ooO0_NN0nmM0nLl0mkk0mkK1MJj0mJJ0g>>0b440a221@000bUU1Xaa0mkk1Ooo0mkk0h@@
0bU50`0P0`000`0P0PQQ0a2R0aS30g>>0f]]0liI0]kK0ooO0ooo0oNn0nmm0jDD0ZDd0d880`QQ0`00
0a220aS31F]=0f</0f<<0e[[0e[;0e:Z0[gG0oNN1_oo0oNn0nmm0^Ll0nLL0h@`0haA0bUU0b440P00
2Ooo0_oO0oNN0nmM0nLl0mkk0mkK1MJj0mJJ0g>>0b440a221@000bUU1Xaa0mkk1Ooo0mkk0h@@0bU5
0`0P0P000`0P0`QQ0a2R0aS30g>>0f]]0/iI0mkK0ooO0ooo0oNn0nmm0ZDD0jDd0d880`QQ0`000a22
0QS31V]=0f</0f<<0e[[0U[;0e:Z0kgG0oNN1_oo0_Nn0nmm0nLl0nLL0h@`0haA0bUU0R440`002?oo
0ooO0oNN0nmM0nLl0]kk0mkK1]Jj0mJJ0g>>0R440a221P000bUU1Xaa0]kk1_oo0mkk0h@@0bU50P0P
0`000`0P0`QQ0a2R0aS30W>>0f]]0liI0mkK0ooO0ooo0_Nn0nmm0jDD0jDd0d880`QQ0P000a220aS3
1V]=0f</0f<<0U[[0e[;0e:Z0kgG0oNN1Ooo0oNn0nmm0nLl0nLL0h@`0XaA0bUU0b440`006?oo000G
ool3oml3mih2ked3ic`3g_/3g]/6e[X2eYX3Lhh38@@348860003:FD5S743g_/6ool3g_/2Q103:DD3
02030003020326424:836<<3Lhh3Jfd3cUT3g]/2oml3ool3mkh3kgd3YA@3YC@2@PP3264300034883
6<<6Jdd2Hb`3H``3F^/3F//3DZX3_ML2mih6ool3mkh3kgd3ic`2ia`3Q303S543:FD38@@30008ool3
oml2mih3ked3ic`3g_/3g]/5e[X3eYX3Lhh38@@348850003:FD6S743g_/5ool3g_/3Q103:DD30203
0003020226434:836<<3Lhh3Jfd3cUT2g]/3oml3ool3mkh3kgd3YA@2YC@3@PP32643000348836<<5
Jdd3Hb`3H``3F^/3F//3DZX2_ML3mih6ool3mkh3kgd2ic`3ia`3Q303S543:FD38@@20009ool2oml3
mih3ked3ic`3g_/3g]/5e[X3eYX3Lhh38@@348850003:FD6S743g_/5ool3g_/3Q103:DD302020003
020326434:836<<3Lhh3Jfd2cUT3g]/3oml3ool3mkh3kgd2YA@3YC@3@PP32643000348826<<6Jdd3
Hb`3H``3F^/2F//3DZX3_ML3mih6ool2mkh3kgd3ic`3ia`3Q303S543:FD28@@30008ool3oml3mih3
ked3ic`2g_/3g]/6e[X3eYX3Lhh28@@348860003:FD6S742g_/6ool3g_/3Q103:DD2020300030203
26434:836<<2Lhh3Jfd3cUT3g]/3oml3ool2mkh3kgd3YA@3YC@3@PP32642000348836<<6Jdd3Hb`3
H``2F^/3F//3DZX3_ML3mih5ool3mkh3kgd3ic`3ia`3Q302S543:FD38@@3000Hool001Ooo`<000<0
80Dii`>U50>U=0?_G@?oo`;g_PJe]P=BRP<@PPH0008080<8H@=BZP=BRP>e]P>mm`;gWP?oo`?gWP>]
E@>]M@FeUP>e]P=BRP=:B@=2:0<8H@D000<8@@=:B@=2:0>]E@;_O@Koo`?g_P?_O@?W?0?W70:<D@<Y
I@<Q10H000<08088H@=BZP>me`?gWP?oo`?_O@;_G@?W70><D@><L@>DTP<aQPSoo`<0008080Hii`>U
50>U=0?_G@;oo`?g_PJe]P=BRP<@PPD000<080<8H@=BZP=BRP:e]P>mm`?gWP?oo`?gWP>]E@>]M@Fe
UP>e]P=BRP=:B@=2:088H@H000<8@@=:B@=2:0:]E@?_O@Koo`?g_P?_O@;W?0?W70><D@<YI@<Q10H0
008080<8H@=BZP>me`?gWP?oo`;_O@?_G@?W70><D@><L@>DTP8aQPWoo`8000<080Hii`>U50>U=0;_
G@?oo`?g_PJe]P=BRP8@PPH000<080<8H@=BZP9BRP>e]P>mm`?gWP?oo`?gWP:]E@>]M@JeUP>e]P=B
RP=:B@92:0<8H@H000<8@@=:B@92:0>]E@?_O@Koo`?g_P;_O@?W?0?W70><D@<YI@<Q10D000<080<8
H@=BZP>me`;gWP?oo`?_O@?_G@?W70><D@><L@:DTP<aQPSoo`<000<080Hii`:U50>U=0?_G@?oo`?g
_PFe]P=BRP<@PPH000<080<8H@9BZP=BRP>e]P>mm`?gWP?oo`;gWP>]E@>]M@JeUP>e]P9BRP=:B@=2
:0<8H@H00088@@=:B@=2:0>]E@?_O@Goo`?g_P?_O@?W?0?W70><D@<YI@8Q10H000<080<8H@=BZP:m
e`?gWP?oo`?_O@?_G@?W70:<D@><L@>DTP<aQQSoo`005ooo0`000`0P1CWW0jDD0jDd0nmM0ooo0_Nn
1[Ff0e::0a221P000P0P0`QQ0e:Z0e::0kFf0kgg0_NN0ooo0oNN0jeE0jee1KFF0kFf0e::0dY90d8X
0`QQ1@000`Q10dY90d8X0jeE0^mm1_oo0oNn0nmm0nLl0nLL0XaA0bUU0b441P000`0P0PQQ0e:Z0kgG
0oNN0ooo0nmm0^mM0nLL0haA0haa0iBB0c662?oo0`000P0P1SWW0jDD0jDd0nmM0_oo0oNn1[Ff0e::
0a221@000`0P0`QQ0e:Z0e::0[Ff0kgg0oNN0ooo0oNN0jeE0jee1KFF0kFf0e::0dY90d8X0PQQ1P00
0`Q10dY90d8X0ZeE0nmm1_oo0oNn0nmm0^Ll0nLL0haA0bUU0b441P000P0P0`QQ0e:Z0kgG0oNN0ooo
0^mm0nmM0nLL0haA0haa0iBB0S662Ooo0P000`0P1SWW0jDD0jDd0^mM0ooo0oNn1[Ff0e::0Q221P00
0`0P0`QQ0e:Z0U::0kFf0kgg0oNN0ooo0oNN0ZeE0jee1[FF0kFf0e::0dY90T8X0`QQ1P000`Q10dY9
0T8X0jeE0nmm1_oo0oNn0^mm0nLl0nLL0haA0bUU0b441@000`0P0`QQ0e:Z0kgG0_NN0ooo0nmm0nmM
0nLL0haA0haa0YBB0c662?oo0`000`0P1SWW0ZDD0jDd0nmM0ooo0oNn1KFf0e::0a221P000`0P0`QQ
0U:Z0e::0kFf0kgg0oNN0ooo0_NN0jeE0jee1[FF0kFf0U::0dY90d8X0`QQ1P000PQ10dY90d8X0jeE
0nmm1Ooo0oNn0nmm0nLl0nLL0haA0bUU0R441P000`0P0`QQ0e:Z0[gG0oNN0ooo0nmm0nmM0nLL0XaA
0haa0iBB0c666?oo000Gool300030205>NL3YA@3YC@3ked3ool2mkh6]KH3DXX34886000202032643
DZX3DXX3]KH3_OL2mih3ool3mih3[ED3[GD5]IH3]KH3DXX3BTT3@RP3264500032443BTT3@RP3[ED2
kgd6ool3mkh3kgd3ic`3ia`2S543:FD38@@6000302022643DZX3_ML3mih3ool3kgd2ked3ia`3S543
S743U983<HH8ool300020206>NL3YA@3YC@3ked2ool3mkh6]KH3DXX34885000302032643DZX3DXX2
]KH3_OL3mih3ool3mih3[ED3[GD5]IH3]KH3DXX3BTT3@RP2264600032443BTT3@RP2[ED3kgd6ool3
mkh3kgd2ic`3ia`3S543:FD38@@6000202032643DZX3_ML3mih3ool2kgd3ked3ia`3S543S743U982
<HH9ool200030206>NL3YA@3YC@2ked3ool3mkh6]KH3DXX24886000302032643DZX2DXX3]KH3_OL3
mih3ool3mih2[ED3[GD6]IH3]KH3DXX3BTT2@RP3264600032443BTT2@RP3[ED3kgd6ool3mkh2kgd3
ic`3ia`3S543:FD38@@5000302032643DZX3_ML2mih3ool3kgd3ked3ia`3S543S742U983<HH8ool3
00030206>NL2YA@3YC@3ked3ool3mkh5]KH3DXX34886000302032642DZX3DXX3]KH3_OL3mih3ool2
mih3[ED3[GD6]IH3]KH2DXX3BTT3@RP3264600022443BTT3@RP3[ED3kgd5ool3mkh3kgd3ic`3ia`3
S543:FD28@@6000302032643DZX2_ML3mih3ool3kgd3ked3ia`2S543S743U983<HHHool001Ooo`<0
00<080Dii`>U50>U=0?_G@?oo`;g_PJe]P=BRP<@PPH0008080<8H@=BZP=BRP>e]P>mm`;gWP?oo`?g
WP>]E@>]M@FeUP>e]P=BRP=:B@=2:0<8H@D000<8@@=:B@=2:0>]E@;_O@Koo`?g_P?_O@?W?0?W70:<
D@<YI@<Q10H000<08088H@=BZP>me`?gWP?oo`?_O@;_G@?W70><D@><L@>DTP<aQPSoo`<0008080Hi
i`>U50>U=0?_G@;oo`?g_PJe]P=BRP<@PPD000<080<8H@=BZP=BRP:e]P>mm`?gWP?oo`?gWP>]E@>]
M@FeUP>e]P=BRP=:B@=2:088H@H000<8@@=:B@=2:0:]E@?_O@Koo`?g_P?_O@;W?0?W70><D@<YI@<Q
10H0008080<8H@=BZP>me`?gWP?oo`;_O@?_G@?W70><D@><L@>DTP8aQPWoo`8000<080Hii`>U50>U
=0;_G@?oo`?g_PJe]P=BRP8@PPH000<080<8H@=BZP9BRP>e]P>mm`?gWP?oo`?gWP:]E@>]M@JeUP>e
]P=BRP=:B@92:0<8H@H000<8@@=:B@92:0>]E@?_O@Koo`?g_P;_O@?W?0?W70><D@<YI@<Q10D000<0
80<8H@=BZP>me`;gWP?oo`?_O@?_G@?W70><D@><L@:DTP<aQPSoo`<000<080Hii`:U50>U=0?_G@?o
o`?g_PFe]P=BRP<@PPH000<080<8H@9BZP=BRP>e]P>mm`?gWP?oo`;gWP>]E@>]M@JeUP>e]P9BRP=:
B@=2:0<8H@H00088@@=:B@=2:0>]E@?_O@Goo`?g_P?_O@?W?0?W70><D@<YI@8Q10H000<080<8H@=B
ZP:me`?gWP?oo`?_O@?_G@?W70:<D@><L@>DTP<aQQSoo`005ooo0`000`0P1CWW0jDD0jDd0nmM0ooo
0_Nn1[Ff0e::0a221P000P0P0`QQ0e:Z0e::0kFf0kgg0_NN0ooo0oNN0jeE0jee1KFF0kFf0e::0dY9
0d8X0`QQ1@000`Q10dY90d8X0jeE0^mm1_oo0oNn0nmm0nLl0nLL0XaA0bUU0b441P000`0P0PQQ0e:Z
0kgG0oNN0ooo0nmm0^mM0nLL0haA0haa0iBB0c662?oo0`000P0P1SWW0jDD0jDd0nmM0_oo0oNn1[Ff
0e::0a221@000`0P0`QQ0e:Z0e::0[Ff0kgg0oNN0ooo0oNN0jeE0jee1KFF0kFf0e::0dY90d8X0PQQ
1P000`Q10dY90d8X0ZeE0nmm1_oo0oNn0nmm0^Ll0nLL0haA0bUU0b441P000P0P0`QQ0e:Z0kgG0oNN
0ooo0^mm0nmM0nLL0haA0haa0iBB0S662Ooo0P000`0P1SWW0jDD0jDd0^mM0ooo0oNn1[Ff0e::0Q22
1P000`0P0`QQ0e:Z0U::0kFf0kgg0oNN0ooo0oNN0ZeE0jee1[FF0kFf0e::0dY90T8X0`QQ1P000`Q1
0dY90T8X0jeE0nmm1_oo0oNn0^mm0nLl0nLL0haA0bUU0b441@000`0P0`QQ0e:Z0kgG0_NN0ooo0nmm
0nmM0nLL0haA0haa0YBB0c662?oo0`000`0P1SWW0ZDD0jDd0nmM0ooo0oNn1KFf0e::0a221P000`0P
0`QQ0U:Z0e::0kFf0kgg0oNN0ooo0_NN0jeE0jee1[FF0kFf0U::0dY90d8X0`QQ1P000PQ10dY90d8X
0jeE0nmm1Ooo0oNn0nmm0nLl0nLL0haA0bUU0R441P000`0P0`QQ0e:Z0[gG0oNN0ooo0nmm0nmM0nLL
0XaA0haa0iBB0c666?oo000Gool300030205>NL3YA@3YC@3ked3ool2mkh6]KH3DXX3488600020203
2643DZX3DXX3]KH3_OL2mih3ool3mih3[ED3[GD5]IH3]KH3DXX3BTT3@RP3264500032443BTT3@RP3
[ED2kgd6ool3mkh3kgd3ic`3ia`2S543:FD38@@6000302022643DZX3_ML3mih3ool3kgd2ked3ia`3
S543S743U983<HH8ool300020206>NL3YA@3YC@3ked2ool3mkh6]KH3DXX34885000302032643DZX3
DXX2]KH3_OL3mih3ool3mih3[ED3[GD5]IH3]KH3DXX3BTT3@RP2264600032443BTT3@RP2[ED3kgd6
ool3mkh3kgd2ic`3ia`3S543:FD38@@6000202032643DZX3_ML3mih3ool2kgd3ked3ia`3S543S743
U982<HH9ool200030206>NL3YA@3YC@2ked3ool3mkh6]KH3DXX24886000302032643DZX2DXX3]KH3
_OL3mih3ool3mih2[ED3[GD6]IH3]KH3DXX3BTT2@RP3264600032443BTT2@RP3[ED3kgd6ool3mkh2
kgd3ic`3ia`3S543:FD38@@5000302032643DZX3_ML2mih3ool3kgd3ked3ia`3S543S742U983<HH8
ool300030206>NL2YA@3YC@3ked3ool3mkh5]KH3DXX34886000302032642DZX3DXX3]KH3_OL3mih3
ool2mih3[ED3[GD6]IH3]KH2DXX3BTT3@RP3264600022443BTT3@RP3[ED3kgd5ool3mkh3kgd3ic`3
ia`3S543:FD28@@6000302032643DZX2_ML3mih3ool3kgd3ked3ia`2S543S743U983<HHHool001Oo
o`<000<080Dii`>U50>U=0?_G@?oo`;g_PJe]P=BRP<@PPH0008080<8H@=BZP=BRP>e]P>mm`;gWP?o
o`?gWP>]E@>]M@FeUP>e]P=BRP=:B@=2:0<8H@D000<8@@=:B@=2:0>]E@;_O@Koo`?g_P?_O@?W?0?W
70:<D@<YI@<Q10H000<08088H@=BZP>me`?gWP?oo`?_O@;_G@?W70><D@><L@>DTP<aQPSoo`<00080
80Hii`>U50>U=0?_G@;oo`?g_PJe]P=BRP<@PPD000<080<8H@=BZP=BRP:e]P>mm`?gWP?oo`?gWP>]
E@>]M@FeUP>e]P=BRP=:B@=2:088H@H000<8@@=:B@=2:0:]E@?_O@Koo`?g_P?_O@;W?0?W70><D@<Y
I@<Q10H0008080<8H@=BZP>me`?gWP?oo`;_O@?_G@?W70><D@><L@>DTP8aQPWoo`8000<080Hii`>U
50>U=0;_G@?oo`?g_PJe]P=BRP8@PPH000<080<8H@=BZP9BRP>e]P>mm`?gWP?oo`?gWP:]E@>]M@Je
UP>e]P=BRP=:B@92:0<8H@H000<8@@=:B@92:0>]E@?_O@Koo`?g_P;_O@?W?0?W70><D@<YI@<Q10D0
00<080<8H@=BZP>me`;gWP?oo`?_O@?_G@?W70><D@><L@:DTP<aQPSoo`<000<080Hii`:U50>U=0?_
G@?oo`?g_PFe]P=BRP<@PPH000<080<8H@9BZP=BRP>e]P>mm`?gWP?oo`;gWP>]E@>]M@JeUP>e]P9B
RP=:B@=2:0<8H@H00088@@=:B@=2:0>]E@?_O@Goo`?g_P?_O@?W?0?W70><D@<YI@8Q10H000<080<8
H@=BZP:me`?gWP?oo`?_O@?_G@?W70:<D@><L@>DTP<aQQSoo`005ooo0`000`0P1CWW0jDD0jDd0nmM
0ooo0_Nn1[Ff0e::0a221P000P0P0`QQ0e:Z0e::0kFf0kgg0_NN0ooo0oNN0jeE0jee1KFF0kFf0e::
0dY90d8X0`QQ1@000`Q10dY90d8X0jeE0^mm1_oo0oNn0nmm0nLl0nLL0XaA0bUU0b441P000`0P0PQQ
0e:Z0kgG0oNN0ooo0nmm0^mM0nLL0haA0haa0iBB0c662?oo0`000P0P1SWW0jDD0jDd0nmM0_oo0oNn
1[Ff0e::0a221@000`0P0`QQ0e:Z0e::0[Ff0kgg0oNN0ooo0oNN0jeE0jee1KFF0kFf0e::0dY90d8X
0PQQ1P000`Q10dY90d8X0ZeE0nmm1_oo0oNn0nmm0^Ll0nLL0haA0bUU0b441P000P0P0`QQ0e:Z0kgG
0oNN0ooo0^mm0nmM0nLL0haA0haa0iBB0S662Ooo0P000`0P1SWW0jDD0jDd0^mM0ooo0oNn1[Ff0e::
0Q221P000`0P0`QQ0e:Z0U::0kFf0kgg0oNN0ooo0oNN0ZeE0jee1[FF0kFf0e::0dY90T8X0`QQ1P00
0`Q10dY90T8X0jeE0nmm1_oo0oNn0^mm0nLl0nLL0haA0bUU0b441@000`0P0`QQ0e:Z0kgG0_NN0ooo
0nmm0nmM0nLL0haA0haa0YBB0c662?oo0`000`0P1SWW0ZDD0jDd0nmM0ooo0oNn1KFf0e::0a221P00
0`0P0`QQ0U:Z0e::0kFf0kgg0oNN0ooo0_NN0jeE0jee1[FF0kFf0U::0dY90d8X0`QQ1P000PQ10dY9
0d8X0jeE0nmm1Ooo0oNn0nmm0nLl0nLL0haA0bUU0R441P000`0P0`QQ0e:Z0[gG0oNN0ooo0nmm0nmM
0nLL0XaA0haa0iBB0c666?oo000Gool300030205>NL3YA@3YC@3ked3ool2mkh6]KH3DXX348860002
02032643DZX3DXX3]KH3_OL2mih3ool3mih3[ED3[GD5]IH3]KH3DXX3BTT3@RP3264500032443BTT3
@RP3[ED2kgd6ool3mkh3kgd3ic`3ia`2S543:FD38@@6000302022643DZX3_ML3mih3ool3kgd2ked3
ia`3S543S743U983<HH8ool300020206>NL3YA@3YC@3ked2ool3mkh6]KH3DXX34885000302032643
DZX3DXX2]KH3_OL3mih3ool3mih3[ED3[GD5]IH3]KH3DXX3BTT3@RP2264600032443BTT3@RP2[ED3
kgd6ool3mkh3kgd2ic`3ia`3S543:FD38@@6000202032643DZX3_ML3mih3ool2kgd3ked3ia`3S543
S743U982<HH9ool200030206>NL3YA@3YC@2ked3ool3mkh6]KH3DXX24886000302032643DZX2DXX3
]KH3_OL3mih3ool3mih2[ED3[GD6]IH3]KH3DXX3BTT2@RP3264600032443BTT2@RP3[ED3kgd6ool3
mkh2kgd3ic`3ia`3S543:FD38@@5000302032643DZX3_ML2mih3ool3kgd3ked3ia`3S543S742U983
<HH8ool300030206>NL2YA@3YC@3ked3ool3mkh5]KH3DXX34886000302032642DZX3DXX3]KH3_OL3
mih3ool2mih3[ED3[GD6]IH3]KH2DXX3BTT3@RP3264600022443BTT3@RP3[ED3kgd5ool3mkh3kgd3
ic`3ia`3S543:FD28@@6000302032643DZX2_ML3mih3ool3kgd3ked3ia`2S543S743U983<HHHool0
01Ooo`<000<080Dii`>U50>U=0?_G@?oo`;g_PJe]P=BRP<@PPH0008080<8H@=BZP=BRP>e]P>mm`;g
WP?oo`?gWP>]E@>]M@FeUP>e]P=BRP=:B@=2:0<8H@D000<8@@=:B@=2:0>]E@;_O@Koo`?g_P?_O@?W
?0?W70:<D@<YI@<Q10H000<08088H@=BZP>me`?gWP?oo`?_O@;_G@?W70><D@><L@>DTP<aQPSoo`<0
008080Hii`>U50>U=0?_G@;oo`?g_PJe]P=BRP<@PPD000<080<8H@=BZP=BRP:e]P>mm`?gWP?oo`?g
WP>]E@>]M@FeUP>e]P=BRP=:B@=2:088H@H000<8@@=:B@=2:0:]E@?_O@Koo`?g_P?_O@;W?0?W70><
D@<YI@<Q10H0008080<8H@=BZP>me`?gWP?oo`;_O@?_G@?W70><D@><L@>DTP8aQPWoo`8000<080Hi
i`>U50>U=0;_G@?oo`?g_PJe]P=BRP8@PPH000<080<8H@=BZP9BRP>e]P>mm`?gWP?oo`?gWP:]E@>]
M@JeUP>e]P=BRP=:B@92:0<8H@H000<8@@=:B@92:0>]E@?_O@Koo`?g_P;_O@?W?0?W70><D@<YI@<Q
10D000<080<8H@=BZP>me`;gWP?oo`?_O@?_G@?W70><D@><L@:DTP<aQPSoo`<000<080Hii`:U50>U
=0?_G@?oo`?g_PFe]P=BRP<@PPH000<080<8H@9BZP=BRP>e]P>mm`?gWP?oo`;gWP>]E@>]M@JeUP>e
]P9BRP=:B@=2:0<8H@H00088@@=:B@=2:0>]E@?_O@Goo`?g_P?_O@?W?0?W70><D@<YI@8Q10H000<0
80<8H@=BZP:me`?gWP?oo`?_O@?_G@?W70:<D@><L@>DTP<aQQSoo`005ooo0`000`0P1CWW0jDD0jDd
0nmM0ooo0_Nn1[Ff0e::0a221P000P0P0`QQ0e:Z0e::0kFf0kgg0_NN0ooo0oNN0jeE0jee1KFF0kFf
0e::0dY90d8X0`QQ1@000`Q10dY90d8X0jeE0^mm1_oo0oNn0nmm0nLl0nLL0XaA0bUU0b441P000`0P
0PQQ0e:Z0kgG0oNN0ooo0nmm0^mM0nLL0haA0haa0iBB0c662?oo0`000P0P1SWW0jDD0jDd0nmM0_oo
0oNn1[Ff0e::0a221@000`0P0`QQ0e:Z0e::0[Ff0kgg0oNN0ooo0oNN0jeE0jee1KFF0kFf0e::0dY9
0d8X0PQQ1P000`Q10dY90d8X0ZeE0nmm1_oo0oNn0nmm0^Ll0nLL0haA0bUU0b441P000P0P0`QQ0e:Z
0kgG0oNN0ooo0^mm0nmM0nLL0haA0haa0iBB0S662Ooo0P000`0P1SWW0jDD0jDd0^mM0ooo0oNn1[Ff
0e::0Q221P000`0P0`QQ0e:Z0U::0kFf0kgg0oNN0ooo0oNN0ZeE0jee1[FF0kFf0e::0dY90T8X0`QQ
1P000`Q10dY90T8X0jeE0nmm1_oo0oNn0^mm0nLl0nLL0haA0bUU0b441@000`0P0`QQ0e:Z0kgG0_NN
0ooo0nmm0nmM0nLL0haA0haa0YBB0c662?oo0`000`0P1SWW0ZDD0jDd0nmM0ooo0oNn1KFf0e::0a22
1P000`0P0`QQ0U:Z0e::0kFf0kgg0oNN0ooo0_NN0jeE0jee1[FF0kFf0U::0dY90d8X0`QQ1P000PQ1
0dY90d8X0jeE0nmm1Ooo0oNn0nmm0nLl0nLL0haA0bUU0R441P000`0P0`QQ0e:Z0[gG0oNN0ooo0nmm
0nmM0nLL0XaA0haa0iBB0c666?oo000Gool324430002020326434:83Hb`3aSP3eYX2oml3ool3ic`3
ia`3g]/6e[X2eYX3Lhh38@@300030203244248836<<36><3Nll3Ljh3eYX2g_/3kgd6ool3mkh3kgd2
YA@3@PP3264600032442BVT3]IH3]KH3_OL3mih6ool2mkh3kgd3W?<3YA@3YC@3@PP2>LL324430003
0203<JH8W=<3ic`6ool3g]/8ool324420003020326434:83Hb`3aSP2eYX3oml3ool3ic`3ia`3g]/5
e[X3eYX3Lhh38@@300020203244348836<<36><3Nll3Ljh2eYX3g_/3kgd6ool3mkh2kgd3YA@3@PP3
264600022443BVT3]IH3]KH3_OL3mih5ool3mkh3kgd3W?<3YA@3YC@2@PP3>LL3244300030203<JH8
W=<3ic`6ool2g]/9ool224430003020326434:83Hb`2aSP3eYX3oml3ool3ic`3ia`2g]/6e[X3eYX3
Lhh38@@200030203244348836<<36><2Nll3Ljh3eYX3g_/3kgd6ool2mkh3kgd3YA@3@PP326450003
2443BVT3]IH3]KH3_OL2mih6ool3mkh3kgd3W?<2YA@3YC@3@PP3>LL3244300020203<JH9W=<3ic`5
ool3g]/8ool324430003020326424:83Hb`3aSP3eYX3oml3ool2ic`3ia`3g]/6e[X3eYX3Lhh28@@3
00030203244348836<<26><3Nll3Ljh3eYX3g_/3kgd5ool3mkh3kgd3YA@3@PP2264600032443BVT3
]IH2]KH3_OL3mih6ool3mkh3kgd2W?<3YA@3YC@3@PP3>LL3244200030203<JH9W=<2ic`6ool3g]/H
ool001Ooo`<8@@<0008080<8H@<@XP=S;0?6>0?FVP;og`?oo`?W?0?W70?Nf`KF^P;FVP=cSP<Q10<0
00<080<8@@8@PP<H``<Hh`=kc`=c[P?FVP;Nn`?_O@Koo`?g_P?_O@:U50=220<8H@H000<8@@9:J@>e
UP>e]P>mm`?gWPKoo`;g_P?_O@>Ll`>U50>U=0=2208ia`<8@@<000<080<aYPRLd`?W?0Koo`?Nf`So
o`<8@@8000<080<8H@<@XP=S;0?6>0;FVP?og`?oo`?W?0?W70?Nf`GF^P?FVP=cSP<Q10<0008080<8
@@<@PP<H``<Hh`=kc`=c[P;FVP?Nn`?_O@Koo`?g_P;_O@>U50=220<8H@H00088@@=:J@>eUP>e]P>m
m`?gWPGoo`?g_P?_O@>Ll`>U50>U=09220<ia`<8@@<000<080<aYPRLd`?W?0Koo`;Nf`Woo`88@@<0
00<080<8H@<@XP=S;0;6>0?FVP?og`?oo`?W?0?W70;Nf`KF^P?FVP=cSP<Q108000<080<8@@<@PP<H
``<Hh`9kc`=c[P?FVP?Nn`?_O@Koo`;g_P?_O@>U50=220<8H@D000<8@@=:J@>eUP>e]P>mm`;gWPKo
o`?g_P?_O@>Ll`:U50>U=0=220<ia`<8@@<0008080<aYPVLd`?W?0Goo`?Nf`Soo`<8@@<000<080<8
H@8@XP=S;0?6>0?FVP?og`?oo`;W?0?W70?Nf`KF^P?FVP=cSP8Q10<000<080<8@@<@PP<H``8Hh`=k
c`=c[P?FVP?Nn`?_O@Goo`?g_P?_O@>U50=22088H@H000<8@@=:J@>eUP:e]P>mm`?gWPKoo`?g_P?_
O@:Ll`>U50>U=0=220<ia`<8@@8000<080<aYPVLd`;W?0Koo`?NfaSoo`005ooo0`Q10`000P0P0`QQ
0a2R0f</0lHh0mJJ0_oO0ooo0nLl0nLL0mkK1]Jj0]JJ0g>>0b440`000`0P0`Q10Q220aS30aSS0g_?
0g>^0mJJ0]kk0nmm1_oo0oNn0nmm0ZDD0d880`QQ1P000`Q10TYY0kFF0kFf0kgg0oNN1_oo0_Nn0nmm
0icc0jDD0jDd0d880SW70`Q10`000`0P0c6V29cC0nLl1_oo0mkK2?oo0`Q10P000`0P0`QQ0a2R0f</
0lHh0]JJ0ooO0ooo0nLl0nLL0mkK1MJj0mJJ0g>>0b440`000P0P0`Q10a220aS30aSS0g_?0g>^0]JJ
0mkk0nmm1_oo0oNn0^mm0jDD0d880`QQ1P000PQ10dYY0kFF0kFf0kgg0oNN1Ooo0oNn0nmm0icc0jDD
0jDd0T880cW70`Q10`000`0P0c6V29cC0nLl1_oo0]kK2Ooo0PQ10`000`0P0`QQ0a2R0f</0/Hh0mJJ
0ooO0ooo0nLl0nLL0]kK1]Jj0mJJ0g>>0b440P000`0P0`Q10a220aS30aSS0W_?0g>^0mJJ0mkk0nmm
1_oo0_Nn0nmm0jDD0d880`QQ1@000`Q10dYY0kFF0kFf0kgg0_NN1_oo0oNn0nmm0icc0ZDD0jDd0d88
0cW70`Q10`000P0P0c6V2IcC0nLl1Ooo0mkK2?oo0`Q10`000`0P0`QQ0Q2R0f</0lHh0mJJ0ooO0ooo
0^Ll0nLL0mkK1]Jj0mJJ0g>>0R440`000`0P0`Q10a220aS30QSS0g_?0g>^0mJJ0mkk0nmm1Ooo0oNn
0nmm0jDD0d880PQQ1P000`Q10dYY0kFF0[Ff0kgg0oNN1_oo0oNn0nmm0Ycc0jDD0jDd0d880cW70`Q1
0P000`0P0c6V2IcC0^Ll1_oo0mkK6?oo000Gool324430002020326434:83Hb`3aSP3eYX2oml3ool3
ic`3ia`3g]/6e[X2eYX3Lhh38@@300030203244248836<<36><3Nll3Ljh3eYX2g_/3kgd6ool3mkh3
kgd2YA@3@PP3264600032442BVT3]IH3]KH3_OL3mih6ool2mkh3kgd3W?<3YA@3YC@3@PP2>LL32443
00030203<JH8W=<3ic`6ool3g]/8ool324420003020326434:83Hb`3aSP2eYX3oml3ool3ic`3ia`3
g]/5e[X3eYX3Lhh38@@300020203244348836<<36><3Nll3Ljh2eYX3g_/3kgd6ool3mkh2kgd3YA@3
@PP3264600022443BVT3]IH3]KH3_OL3mih5ool3mkh3kgd3W?<3YA@3YC@2@PP3>LL3244300030203
<JH8W=<3ic`6ool2g]/9ool224430003020326434:83Hb`2aSP3eYX3oml3ool3ic`3ia`2g]/6e[X3
eYX3Lhh38@@200030203244348836<<36><2Nll3Ljh3eYX3g_/3kgd6ool2mkh3kgd3YA@3@PP32645
00032443BVT3]IH3]KH3_OL2mih6ool3mkh3kgd3W?<2YA@3YC@3@PP3>LL3244300020203<JH9W=<3
ic`5ool3g]/8ool324430003020326424:83Hb`3aSP3eYX3oml3ool2ic`3ia`3g]/6e[X3eYX3Lhh2
8@@300030203244348836<<26><3Nll3Ljh3eYX3g_/3kgd5ool3mkh3kgd3YA@3@PP2264600032443
BVT3]IH2]KH3_OL3mih6ool3mkh3kgd2W?<3YA@3YC@3@PP3>LL3244200030203<JH9W=<2ic`6ool3
g]/Hool001Ooo`<8@@<0008080<8H@<@XP=S;0?6>0?FVP;og`?oo`?W?0?W70?Nf`KF^P;FVP=cSP<Q
10<000<080<8@@8@PP<H``<Hh`=kc`=c[P?FVP;Nn`?_O@Koo`?g_P?_O@:U50=220<8H@H000<8@@9:
J@>eUP>e]P>mm`?gWPKoo`;g_P?_O@>Ll`>U50>U=0=2208ia`<8@@<000<080<aYPRLd`?W?0Koo`?N
f`Soo`<8@@8000<080<8H@<@XP=S;0?6>0;FVP?og`?oo`?W?0?W70?Nf`GF^P?FVP=cSP<Q10<00080
80<8@@<@PP<H``<Hh`=kc`=c[P;FVP?Nn`?_O@Koo`?g_P;_O@>U50=220<8H@H00088@@=:J@>eUP>e
]P>mm`?gWPGoo`?g_P?_O@>Ll`>U50>U=09220<ia`<8@@<000<080<aYPRLd`?W?0Koo`;Nf`Woo`88
@@<000<080<8H@<@XP=S;0;6>0?FVP?og`?oo`?W?0?W70;Nf`KF^P?FVP=cSP<Q108000<080<8@@<@
PP<H``<Hh`9kc`=c[P?FVP?Nn`?_O@Koo`;g_P?_O@>U50=220<8H@D000<8@@=:J@>eUP>e]P>mm`;g
WPKoo`?g_P?_O@>Ll`:U50>U=0=220<ia`<8@@<0008080<aYPVLd`?W?0Goo`?Nf`Soo`<8@@<000<0
80<8H@8@XP=S;0?6>0?FVP?og`?oo`;W?0?W70?Nf`KF^P?FVP=cSP8Q10<000<080<8@@<@PP<H``8H
h`=kc`=c[P?FVP?Nn`?_O@Goo`?g_P?_O@>U50=22088H@H000<8@@=:J@>eUP:e]P>mm`?gWPKoo`?g
_P?_O@:Ll`>U50>U=0=220<ia`<8@@8000<080<aYPVLd`;W?0Koo`?NfaSoo`005ooo0`Q10`000P0P
0`QQ0a2R0f</0lHh0mJJ0_oO0ooo0nLl0nLL0mkK1]Jj0]JJ0g>>0b440`000`0P0`Q10Q220aS30aSS
0g_?0g>^0mJJ0]kk0nmm1_oo0oNn0nmm0ZDD0d880`QQ1P000`Q10TYY0kFF0kFf0kgg0oNN1_oo0_Nn
0nmm0icc0jDD0jDd0d880SW70`Q10`000`0P0c6V29cC0nLl1_oo0mkK2?oo0`Q10P000`0P0`QQ0a2R
0f</0lHh0]JJ0ooO0ooo0nLl0nLL0mkK1MJj0mJJ0g>>0b440`000P0P0`Q10a220aS30aSS0g_?0g>^
0]JJ0mkk0nmm1_oo0oNn0^mm0jDD0d880`QQ1P000PQ10dYY0kFF0kFf0kgg0oNN1Ooo0oNn0nmm0icc
0jDD0jDd0T880cW70`Q10`000`0P0c6V29cC0nLl1_oo0]kK2Ooo0PQ10`000`0P0`QQ0a2R0f</0/Hh
0mJJ0ooO0ooo0nLl0nLL0]kK1]Jj0mJJ0g>>0b440P000`0P0`Q10a220aS30aSS0W_?0g>^0mJJ0mkk
0nmm1_oo0_Nn0nmm0jDD0d880`QQ1@000`Q10dYY0kFF0kFf0kgg0_NN1_oo0oNn0nmm0icc0ZDD0jDd
0d880cW70`Q10`000P0P0c6V2IcC0nLl1Ooo0mkK2?oo0`Q10`000`0P0`QQ0Q2R0f</0lHh0mJJ0ooO
0ooo0^Ll0nLL0mkK1]Jj0mJJ0g>>0R440`000`0P0`Q10a220aS30QSS0g_?0g>^0mJJ0mkk0nmm1Ooo
0oNn0nmm0jDD0d880PQQ1P000`Q10dYY0kFF0[Ff0kgg0oNN1_oo0oNn0nmm0Ycc0jDD0jDd0d880cW7
0`Q10P000`0P0c6V2IcC0^Ll1_oo0mkK6?oo000Gool324430002020326434:83Hb`3aSP3eYX2oml3
ool3ic`3ia`3g]/6e[X2eYX3Lhh38@@300030203244248836<<36><3Nll3Ljh3eYX2g_/3kgd6ool3
mkh3kgd2YA@3@PP3264600032442BVT3]IH3]KH3_OL3mih6ool2mkh3kgd3W?<3YA@3YC@3@PP2>LL3
244300030203<JH8W=<3ic`6ool3g]/8ool324420003020326434:83Hb`3aSP2eYX3oml3ool3ic`3
ia`3g]/5e[X3eYX3Lhh38@@300020203244348836<<36><3Nll3Ljh2eYX3g_/3kgd6ool3mkh2kgd3
YA@3@PP3264600022443BVT3]IH3]KH3_OL3mih5ool3mkh3kgd3W?<3YA@3YC@2@PP3>LL324430003
0203<JH8W=<3ic`6ool2g]/9ool224430003020326434:83Hb`2aSP3eYX3oml3ool3ic`3ia`2g]/6
e[X3eYX3Lhh38@@200030203244348836<<36><2Nll3Ljh3eYX3g_/3kgd6ool2mkh3kgd3YA@3@PP3
264500032443BVT3]IH3]KH3_OL2mih6ool3mkh3kgd3W?<2YA@3YC@3@PP3>LL3244300020203<JH9
W=<3ic`5ool3g]/8ool324430003020326424:83Hb`3aSP3eYX3oml3ool2ic`3ia`3g]/6e[X3eYX3
Lhh28@@300030203244348836<<26><3Nll3Ljh3eYX3g_/3kgd5ool3mkh3kgd3YA@3@PP226460003
2443BVT3]IH2]KH3_OL3mih6ool3mkh3kgd2W?<3YA@3YC@3@PP3>LL3244200030203<JH9W=<2ic`6
ool3g]/Hool001Ooo`<8@@<0008080<8H@<@XP=S;0?6>0?FVP;og`?oo`?W?0?W70?Nf`KF^P;FVP=c
SP<Q10<000<080<8@@8@PP<H``<Hh`=kc`=c[P?FVP;Nn`?_O@Koo`?g_P?_O@:U50=220<8H@H000<8
@@9:J@>eUP>e]P>mm`?gWPKoo`;g_P?_O@>Ll`>U50>U=0=2208ia`<8@@<000<080<aYPRLd`?W?0Ko
o`?Nf`Soo`<8@@8000<080<8H@<@XP=S;0?6>0;FVP?og`?oo`?W?0?W70?Nf`GF^P?FVP=cSP<Q10<0
008080<8@@<@PP<H``<Hh`=kc`=c[P;FVP?Nn`?_O@Koo`?g_P;_O@>U50=220<8H@H00088@@=:J@>e
UP>e]P>mm`?gWPGoo`?g_P?_O@>Ll`>U50>U=09220<ia`<8@@<000<080<aYPRLd`?W?0Koo`;Nf`Wo
o`88@@<000<080<8H@<@XP=S;0;6>0?FVP?og`?oo`?W?0?W70;Nf`KF^P?FVP=cSP<Q108000<080<8
@@<@PP<H``<Hh`9kc`=c[P?FVP?Nn`?_O@Koo`;g_P?_O@>U50=220<8H@D000<8@@=:J@>eUP>e]P>m
m`;gWPKoo`?g_P?_O@>Ll`:U50>U=0=220<ia`<8@@<0008080<aYPVLd`?W?0Goo`?Nf`Soo`<8@@<0
00<080<8H@8@XP=S;0?6>0?FVP?og`?oo`;W?0?W70?Nf`KF^P?FVP=cSP8Q10<000<080<8@@<@PP<H
``8Hh`=kc`=c[P?FVP?Nn`?_O@Goo`?g_P?_O@>U50=22088H@H000<8@@=:J@>eUP:e]P>mm`?gWPKo
o`?g_P?_O@:Ll`>U50>U=0=220<ia`<8@@8000<080<aYPVLd`;W?0Koo`?NfaSoo`005ooo0`Q10`00
0P0P0`QQ0a2R0f</0lHh0mJJ0_oO0ooo0nLl0nLL0mkK1]Jj0]JJ0g>>0b440`000`0P0`Q10Q220aS3
0aSS0g_?0g>^0mJJ0]kk0nmm1_oo0oNn0nmm0ZDD0d880`QQ1P000`Q10TYY0kFF0kFf0kgg0oNN1_oo
0_Nn0nmm0icc0jDD0jDd0d880SW70`Q10`000`0P0c6V29cC0nLl1_oo0mkK2?oo0`Q10P000`0P0`QQ
0a2R0f</0lHh0]JJ0ooO0ooo0nLl0nLL0mkK1MJj0mJJ0g>>0b440`000P0P0`Q10a220aS30aSS0g_?
0g>^0]JJ0mkk0nmm1_oo0oNn0^mm0jDD0d880`QQ1P000PQ10dYY0kFF0kFf0kgg0oNN1Ooo0oNn0nmm
0icc0jDD0jDd0T880cW70`Q10`000`0P0c6V29cC0nLl1_oo0]kK2Ooo0PQ10`000`0P0`QQ0a2R0f</
0/Hh0mJJ0ooO0ooo0nLl0nLL0]kK1]Jj0mJJ0g>>0b440P000`0P0`Q10a220aS30aSS0W_?0g>^0mJJ
0mkk0nmm1_oo0_Nn0nmm0jDD0d880`QQ1@000`Q10dYY0kFF0kFf0kgg0_NN1_oo0oNn0nmm0icc0ZDD
0jDd0d880cW70`Q10`000P0P0c6V2IcC0nLl1Ooo0mkK2?oo0`Q10`000`0P0`QQ0Q2R0f</0lHh0mJJ
0ooO0ooo0^Ll0nLL0mkK1]Jj0mJJ0g>>0R440`000`0P0`Q10a220aS30QSS0g_?0g>^0mJJ0mkk0nmm
1Ooo0oNn0nmm0jDD0d880PQQ1P000`Q10dYY0kFF0[Ff0kgg0oNN1_oo0oNn0nmm0Ycc0jDD0jDd0d88
0cW70`Q10P000`0P0c6V2IcC0^Ll1_oo0mkK6?oo000Gool324430002020326434:83Hb`3aSP3eYX2
oml3ool3ic`3ia`3g]/6e[X2eYX3Lhh38@@300030203244248836<<36><3Nll3Ljh3eYX2g_/3kgd6
ool3mkh3kgd2YA@3@PP3264600032442BVT3]IH3]KH3_OL3mih6ool2mkh3kgd3W?<3YA@3YC@3@PP2
>LL3244300030203<JH8W=<3ic`6ool3g]/8ool324420003020326434:83Hb`3aSP2eYX3oml3ool3
ic`3ia`3g]/5e[X3eYX3Lhh38@@300020203244348836<<36><3Nll3Ljh2eYX3g_/3kgd6ool3mkh2
kgd3YA@3@PP3264600022443BVT3]IH3]KH3_OL3mih5ool3mkh3kgd3W?<3YA@3YC@2@PP3>LL32443
00030203<JH8W=<3ic`6ool2g]/9ool224430003020326434:83Hb`2aSP3eYX3oml3ool3ic`3ia`2
g]/6e[X3eYX3Lhh38@@200030203244348836<<36><2Nll3Ljh3eYX3g_/3kgd6ool2mkh3kgd3YA@3
@PP3264500032443BVT3]IH3]KH3_OL2mih6ool3mkh3kgd3W?<2YA@3YC@3@PP3>LL3244300020203
<JH9W=<3ic`5ool3g]/8ool324430003020326424:83Hb`3aSP3eYX3oml3ool2ic`3ia`3g]/6e[X3
eYX3Lhh28@@300030203244348836<<26><3Nll3Ljh3eYX3g_/3kgd5ool3mkh3kgd3YA@3@PP22646
00032443BVT3]IH2]KH3_OL3mih6ool3mkh3kgd2W?<3YA@3YC@3@PP3>LL3244200030203<JH9W=<2
ic`6ool3g]/Hool001Ooo`<8@@<0008080<8H@<@XP=S;0?6>0?FVP;og`?oo`?W?0?W70?Nf`KF^P;F
VP=cSP<Q10<000<080<8@@8@PP<H``<Hh`=kc`=c[P?FVP;Nn`?_O@Koo`?g_P?_O@:U50=220<8H@H0
00<8@@9:J@>eUP>e]P>mm`?gWPKoo`;g_P?_O@>Ll`>U50>U=0=2208ia`<8@@<000<080<aYPRLd`?W
?0Koo`?Nf`Soo`<8@@8000<080<8H@<@XP=S;0?6>0;FVP?og`?oo`?W?0?W70?Nf`GF^P?FVP=cSP<Q
10<0008080<8@@<@PP<H``<Hh`=kc`=c[P;FVP?Nn`?_O@Koo`?g_P;_O@>U50=220<8H@H00088@@=:
J@>eUP>e]P>mm`?gWPGoo`?g_P?_O@>Ll`>U50>U=09220<ia`<8@@<000<080<aYPRLd`?W?0Koo`;N
f`Woo`88@@<000<080<8H@<@XP=S;0;6>0?FVP?og`?oo`?W?0?W70;Nf`KF^P?FVP=cSP<Q108000<0
80<8@@<@PP<H``<Hh`9kc`=c[P?FVP?Nn`?_O@Koo`;g_P?_O@>U50=220<8H@D000<8@@=:J@>eUP>e
]P>mm`;gWPKoo`?g_P?_O@>Ll`:U50>U=0=220<ia`<8@@<0008080<aYPVLd`?W?0Goo`?Nf`Soo`<8
@@<000<080<8H@8@XP=S;0?6>0?FVP?og`?oo`;W?0?W70?Nf`KF^P?FVP=cSP8Q10<000<080<8@@<@
PP<H``8Hh`=kc`=c[P?FVP?Nn`?_O@Goo`?g_P?_O@>U50=22088H@H000<8@@=:J@>eUP:e]P>mm`?g
WPKoo`?g_P?_O@:Ll`>U50>U=0=220<ia`<8@@8000<080<aYPVLd`;W?0Koo`?NfaSoo`005ooo0`Q1
0`000P0P0`QQ0a2R0f</0lHh0mJJ0_oO0ooo0nLl0nLL0mkK1]Jj0]JJ0g>>0b440`000`0P0`Q10Q22
0aS30aSS0g_?0g>^0mJJ0]kk0nmm1_oo0oNn0nmm0ZDD0d880`QQ1P000`Q10TYY0kFF0kFf0kgg0oNN
1_oo0_Nn0nmm0icc0jDD0jDd0d880SW70`Q10`000`0P0c6V29cC0nLl1_oo0mkK2?oo0`Q10P000`0P
0`QQ0a2R0f</0lHh0]JJ0ooO0ooo0nLl0nLL0mkK1MJj0mJJ0g>>0b440`000P0P0`Q10a220aS30aSS
0g_?0g>^0]JJ0mkk0nmm1_oo0oNn0^mm0jDD0d880`QQ1P000PQ10dYY0kFF0kFf0kgg0oNN1Ooo0oNn
0nmm0icc0jDD0jDd0T880cW70`Q10`000`0P0c6V29cC0nLl1_oo0]kK2Ooo0PQ10`000`0P0`QQ0a2R
0f</0/Hh0mJJ0ooO0ooo0nLl0nLL0]kK1]Jj0mJJ0g>>0b440P000`0P0`Q10a220aS30aSS0W_?0g>^
0mJJ0mkk0nmm1_oo0_Nn0nmm0jDD0d880`QQ1@000`Q10dYY0kFF0kFf0kgg0_NN1_oo0oNn0nmm0icc
0ZDD0jDd0d880cW70`Q10`000P0P0c6V2IcC0nLl1Ooo0mkK2?oo0`Q10`000`0P0`QQ0Q2R0f</0lHh
0mJJ0ooO0ooo0^Ll0nLL0mkK1]Jj0mJJ0g>>0R440`000`0P0`Q10a220aS30QSS0g_?0g>^0mJJ0mkk
0nmm1Ooo0oNn0nmm0jDD0d880PQQ1P000`Q10dYY0kFF0[Ff0kgg0oNN1_oo0oNn0nmm0Ycc0jDD0jDd
0d880cW70`Q10P000`0P0c6V2IcC0^Ll1_oo0mkK6?oo000Gool6Nnl2:DD302030003244348834:82
Jdd3cUT3mkh3ool3oml3mih3kgd2ic`3U983<HH3020300030205>LL6W?<3ic`5ool3mkh3_ML6_OL3
F//24:830003244348836<<36><28@@38B@3:DD3:FD6S743g_/5ool3g_/3g]/3e[X3Ljh28B@60003
8@@38B@3Q102e[X3oml3ool3oml3mih3ked8ool5Nnl3:DD302030003244348824:83Jdd3cUT3mkh3
ool3oml2mih3kgd3ic`3U983<HH3020200030206>LL6W?<3ic`5ool3mkh3_ML6_OL2F//34:830003
244348836<<26><38@@38B@3:DD3:FD5S743g_/6ool3g_/3g]/3e[X2Ljh38B@600038@@38B@2Q103
e[X3oml3ool3oml3mih2ked9ool5Nnl3:DD302030003244248834:83Jdd3cUT3mkh3ool2oml3mih3
kgd3ic`3U983<HH2020300030206>LL5W?<3ic`6ool3mkh3_ML5_OL3F//34:830003244348826<<3
6><38@@38B@3:DD3:FD5S743g_/6ool3g_/2g]/3e[X3Ljh38B@600028@@38B@3Q103e[X3oml3ool3
oml2mih3ked8ool6Nnl3:DD302020003244348834:83Jdd3cUT2mkh3ool3oml3mih3kgd3ic`3U982
<HH3020300030206>LL5W?<3ic`6ool3mkh2_ML6_OL3F//34:830002244348836<<36><38@@38B@2
:DD3:FD6S743g_/6ool2g_/3g]/3e[X3Ljh38B@500038@@38B@3Q103e[X3oml2ool3oml3mih3kedH
ool001Ooo`Ikk`8YA@<080<000<8@@<@PP<@XP9[C@?>F@?g_P?oo`?og`?gWP?_O@;W?0>DTP<aQP<0
80<000<080Dia`JLl`?W?0Goo`?g_P>me`Jmm`=Jb`8@XP<000<8@@<@PP<H``<Hh`8Q10<Q90<YA@<Y
I@J<L@?Nn`Goo`?Nn`?Nf`?F^P=c[P8Q90H000<Q10<Q90>440;F^P?og`?oo`?og`?gWP?_G@Soo`Ek
k`<YA@<080<000<8@@<@PP8@XP=[C@?>F@?g_P?oo`?og`;gWP?_O@?W?0>DTP<aQP<0808000<080Hi
a`JLl`?W?0Goo`?g_P>me`Jmm`9Jb`<@XP<000<8@@<@PP<H``8Hh`<Q10<Q90<YA@<YI@F<L@?Nn`Ko
o`?Nn`?Nf`?F^P9c[P<Q90H000<Q10<Q90:440?F^P?og`?oo`?og`?gWP;_G@Woo`Ekk`<YA@<080<0
00<8@@8@PP<@XP=[C@?>F@?g_P?oo`;og`?gWP?_O@?W?0>DTP<aQP8080<000<080Hia`FLl`?W?0Ko
o`?g_P>me`Fmm`=Jb`<@XP<000<8@@<@PP8H``<Hh`<Q10<Q90<YA@<YI@F<L@?Nn`Koo`?Nn`;Nf`?F
^P=c[P<Q90H0008Q10<Q90>440?F^P?og`?oo`?og`;gWP?_G@Soo`Ikk`<YA@<0808000<8@@<@PP<@
XP=[C@?>F@;g_P?oo`?og`?gWP?_O@?W?0>DTP8aQP<080<000<080Hia`FLl`?W?0Koo`?g_P:me`Jm
m`=Jb`<@XP<00088@@<@PP<H``<Hh`<Q10<Q908YA@<YI@J<L@?Nn`Koo`;Nn`?Nf`?F^P=c[P<Q90D0
00<Q10<Q90>440?F^P?og`;oo`?og`?gWP?_GASoo`005ooo1W__0RU50`0P0`000`Q10a220a2R0V]=
0liI0oNn0ooo0ooO0oNN0nmm0^Ll0iBB0c660`0P0`000`0P1CW71Ycc0nLl1Ooo0oNn0kgG1[gg0e[;
0Q2R0`000`Q10a220aS30aSS0R440b4T0bU50bUU1Xaa0mkk1Ooo0mkk0mkK0mJj0g>^0R4T1P000b44
0b4T0h@@0]Jj0ooO0ooo0ooO0oNN0nmM2?oo1G__0bU50`0P0`000`Q10a220Q2R0f]=0liI0oNn0ooo
0ooO0_NN0nmm0nLl0iBB0c660`0P0P000`0P1SW71Ycc0nLl1Ooo0oNn0kgG1[gg0U[;0a2R0`000`Q1
0a220aS30QSS0b440b4T0bU50bUU1Haa0mkk1_oo0mkk0mkK0mJj0W>^0b4T1P000b440b4T0X@@0mJj
0ooO0ooo0ooO0oNN0^mM2Ooo1G__0bU50`0P0`000`Q10Q220a2R0f]=0liI0oNn0ooo0_oO0oNN0nmm
0nLl0iBB0c660P0P0`000`0P1SW71Icc0nLl1_oo0oNn0kgG1Kgg0e[;0a2R0`000`Q10a220QS30aSS
0b440b4T0bU50bUU1Haa0mkk1_oo0mkk0]kK0mJj0g>^0b4T1P000R440b4T0h@@0mJj0ooO0ooo0ooO
0_NN0nmM2?oo1W__0bU50`0P0P000`Q10a220a2R0f]=0liI0_Nn0ooo0ooO0oNN0nmm0nLl0iBB0S66
0`0P0`000`0P1SW71Icc0nLl1_oo0oNn0[gG1[gg0e[;0a2R0`000PQ10a220aS30aSS0b440b4T0RU5
0bUU1Xaa0mkk1_oo0]kk0mkK0mJj0g>^0b4T1@000b440b4T0h@@0mJj0ooO0_oo0ooO0oNN0nmM6?oo
000Gool6Nnl2:DD302030003244348834:82Jdd3cUT3mkh3ool3oml3mih3kgd2ic`3U983<HH30203
00030205>LL6W?<3ic`5ool3mkh3_ML6_OL3F//24:830003244348836<<36><28@@38B@3:DD3:FD6
S743g_/5ool3g_/3g]/3e[X3Ljh28B@600038@@38B@3Q102e[X3oml3ool3oml3mih3ked8ool5Nnl3
:DD302030003244348824:83Jdd3cUT3mkh3ool3oml2mih3kgd3ic`3U983<HH3020200030206>LL6
W?<3ic`5ool3mkh3_ML6_OL2F//34:830003244348836<<26><38@@38B@3:DD3:FD5S743g_/6ool3
g_/3g]/3e[X2Ljh38B@600038@@38B@2Q103e[X3oml3ool3oml3mih2ked9ool5Nnl3:DD302030003
244248834:83Jdd3cUT3mkh3ool2oml3mih3kgd3ic`3U983<HH2020300030206>LL5W?<3ic`6ool3
mkh3_ML5_OL3F//34:830003244348826<<36><38@@38B@3:DD3:FD5S743g_/6ool3g_/2g]/3e[X3
Ljh38B@600028@@38B@3Q103e[X3oml3ool3oml2mih3ked8ool6Nnl3:DD302020003244348834:83
Jdd3cUT2mkh3ool3oml3mih3kgd3ic`3U982<HH3020300030206>LL5W?<3ic`6ool3mkh2_ML6_OL3
F//34:830002244348836<<36><38@@38B@2:DD3:FD6S743g_/6ool2g_/3g]/3e[X3Ljh38B@50003
8@@38B@3Q103e[X3oml2ool3oml3mih3kedHool001Ooo`Ikk`8YA@<080<000<8@@<@PP<@XP9[C@?>
F@?g_P?oo`?og`?gWP?_O@;W?0>DTP<aQP<080<000<080Dia`JLl`?W?0Goo`?g_P>me`Jmm`=Jb`8@
XP<000<8@@<@PP<H``<Hh`8Q10<Q90<YA@<YI@J<L@?Nn`Goo`?Nn`?Nf`?F^P=c[P8Q90H000<Q10<Q
90>440;F^P?og`?oo`?og`?gWP?_G@Soo`Ekk`<YA@<080<000<8@@<@PP8@XP=[C@?>F@?g_P?oo`?o
g`;gWP?_O@?W?0>DTP<aQP<0808000<080Hia`JLl`?W?0Goo`?g_P>me`Jmm`9Jb`<@XP<000<8@@<@
PP<H``8Hh`<Q10<Q90<YA@<YI@F<L@?Nn`Koo`?Nn`?Nf`?F^P9c[P<Q90H000<Q10<Q90:440?F^P?o
g`?oo`?og`?gWP;_G@Woo`Ekk`<YA@<080<000<8@@8@PP<@XP=[C@?>F@?g_P?oo`;og`?gWP?_O@?W
?0>DTP<aQP8080<000<080Hia`FLl`?W?0Koo`?g_P>me`Fmm`=Jb`<@XP<000<8@@<@PP8H``<Hh`<Q
10<Q90<YA@<YI@F<L@?Nn`Koo`?Nn`;Nf`?F^P=c[P<Q90H0008Q10<Q90>440?F^P?og`?oo`?og`;g
WP?_G@Soo`Ikk`<YA@<0808000<8@@<@PP<@XP=[C@?>F@;g_P?oo`?og`?gWP?_O@?W?0>DTP8aQP<0
80<000<080Hia`FLl`?W?0Koo`?g_P:me`Jmm`=Jb`<@XP<00088@@<@PP<H``<Hh`<Q10<Q908YA@<Y
I@J<L@?Nn`Koo`;Nn`?Nf`?F^P=c[P<Q90D000<Q10<Q90>440?F^P?og`;oo`?og`?gWP?_GASoo`00
5ooo1W__0RU50`0P0`000`Q10a220a2R0V]=0liI0oNn0ooo0ooO0oNN0nmm0^Ll0iBB0c660`0P0`00
0`0P1CW71Ycc0nLl1Ooo0oNn0kgG1[gg0e[;0Q2R0`000`Q10a220aS30aSS0R440b4T0bU50bUU1Xaa
0mkk1Ooo0mkk0mkK0mJj0g>^0R4T1P000b440b4T0h@@0]Jj0ooO0ooo0ooO0oNN0nmM2?oo1G__0bU5
0`0P0`000`Q10a220Q2R0f]=0liI0oNn0ooo0ooO0_NN0nmm0nLl0iBB0c660`0P0P000`0P1SW71Ycc
0nLl1Ooo0oNn0kgG1[gg0U[;0a2R0`000`Q10a220aS30QSS0b440b4T0bU50bUU1Haa0mkk1_oo0mkk
0mkK0mJj0W>^0b4T1P000b440b4T0X@@0mJj0ooO0ooo0ooO0oNN0^mM2Ooo1G__0bU50`0P0`000`Q1
0Q220a2R0f]=0liI0oNn0ooo0_oO0oNN0nmm0nLl0iBB0c660P0P0`000`0P1SW71Icc0nLl1_oo0oNn
0kgG1Kgg0e[;0a2R0`000`Q10a220QS30aSS0b440b4T0bU50bUU1Haa0mkk1_oo0mkk0]kK0mJj0g>^
0b4T1P000R440b4T0h@@0mJj0ooO0ooo0ooO0_NN0nmM2?oo1W__0bU50`0P0P000`Q10a220a2R0f]=
0liI0_Nn0ooo0ooO0oNN0nmm0nLl0iBB0S660`0P0`000`0P1SW71Icc0nLl1_oo0oNn0[gG1[gg0e[;
0a2R0`000PQ10a220aS30aSS0b440b4T0RU50bUU1Xaa0mkk1_oo0]kk0mkK0mJj0g>^0b4T1@000b44
0b4T0h@@0mJj0ooO0_oo0ooO0oNN0nmM6?oo000Gool6Nnl2:DD302030003244348834:82Jdd3cUT3
mkh3ool3oml3mih3kgd2ic`3U983<HH3020300030205>LL6W?<3ic`5ool3mkh3_ML6_OL3F//24:83
0003244348836<<36><28@@38B@3:DD3:FD6S743g_/5ool3g_/3g]/3e[X3Ljh28B@600038@@38B@3
Q102e[X3oml3ool3oml3mih3ked8ool5Nnl3:DD302030003244348824:83Jdd3cUT3mkh3ool3oml2
mih3kgd3ic`3U983<HH3020200030206>LL6W?<3ic`5ool3mkh3_ML6_OL2F//34:83000324434883
6<<26><38@@38B@3:DD3:FD5S743g_/6ool3g_/3g]/3e[X2Ljh38B@600038@@38B@2Q103e[X3oml3
ool3oml3mih2ked9ool5Nnl3:DD302030003244248834:83Jdd3cUT3mkh3ool2oml3mih3kgd3ic`3
U983<HH2020300030206>LL5W?<3ic`6ool3mkh3_ML5_OL3F//34:830003244348826<<36><38@@3
8B@3:DD3:FD5S743g_/6ool3g_/2g]/3e[X3Ljh38B@600028@@38B@3Q103e[X3oml3ool3oml2mih3
ked8ool6Nnl3:DD302020003244348834:83Jdd3cUT2mkh3ool3oml3mih3kgd3ic`3U982<HH30203
00030206>LL5W?<3ic`6ool3mkh2_ML6_OL3F//34:830002244348836<<36><38@@38B@2:DD3:FD6
S743g_/6ool2g_/3g]/3e[X3Ljh38B@500038@@38B@3Q103e[X3oml2ool3oml3mih3kedHool001Oo
o`Ikk`8YA@<080<000<8@@<@PP<@XP9[C@?>F@?g_P?oo`?og`?gWP?_O@;W?0>DTP<aQP<080<000<0
80Dia`JLl`?W?0Goo`?g_P>me`Jmm`=Jb`8@XP<000<8@@<@PP<H``<Hh`8Q10<Q90<YA@<YI@J<L@?N
n`Goo`?Nn`?Nf`?F^P=c[P8Q90H000<Q10<Q90>440;F^P?og`?oo`?og`?gWP?_G@Soo`Ekk`<YA@<0
80<000<8@@<@PP8@XP=[C@?>F@?g_P?oo`?og`;gWP?_O@?W?0>DTP<aQP<0808000<080Hia`JLl`?W
?0Goo`?g_P>me`Jmm`9Jb`<@XP<000<8@@<@PP<H``8Hh`<Q10<Q90<YA@<YI@F<L@?Nn`Koo`?Nn`?N
f`?F^P9c[P<Q90H000<Q10<Q90:440?F^P?og`?oo`?og`?gWP;_G@Woo`Ekk`<YA@<080<000<8@@8@
PP<@XP=[C@?>F@?g_P?oo`;og`?gWP?_O@?W?0>DTP<aQP8080<000<080Hia`FLl`?W?0Koo`?g_P>m
e`Fmm`=Jb`<@XP<000<8@@<@PP8H``<Hh`<Q10<Q90<YA@<YI@F<L@?Nn`Koo`?Nn`;Nf`?F^P=c[P<Q
90H0008Q10<Q90>440?F^P?og`?oo`?og`;gWP?_G@Soo`Ikk`<YA@<0808000<8@@<@PP<@XP=[C@?>
F@;g_P?oo`?og`?gWP?_O@?W?0>DTP8aQP<080<000<080Hia`FLl`?W?0Koo`?g_P:me`Jmm`=Jb`<@
XP<00088@@<@PP<H``<Hh`<Q10<Q908YA@<YI@J<L@?Nn`Koo`;Nn`?Nf`?F^P=c[P<Q90D000<Q10<Q
90>440?F^P?og`;oo`?og`?gWP?_GASoo`005ooo1W__0RU50`0P0`000`Q10a220a2R0V]=0liI0oNn
0ooo0ooO0oNN0nmm0^Ll0iBB0c660`0P0`000`0P1CW71Ycc0nLl1Ooo0oNn0kgG1[gg0e[;0Q2R0`00
0`Q10a220aS30aSS0R440b4T0bU50bUU1Xaa0mkk1Ooo0mkk0mkK0mJj0g>^0R4T1P000b440b4T0h@@
0]Jj0ooO0ooo0ooO0oNN0nmM2?oo1G__0bU50`0P0`000`Q10a220Q2R0f]=0liI0oNn0ooo0ooO0_NN
0nmm0nLl0iBB0c660`0P0P000`0P1SW71Ycc0nLl1Ooo0oNn0kgG1[gg0U[;0a2R0`000`Q10a220aS3
0QSS0b440b4T0bU50bUU1Haa0mkk1_oo0mkk0mkK0mJj0W>^0b4T1P000b440b4T0X@@0mJj0ooO0ooo
0ooO0oNN0^mM2Ooo1G__0bU50`0P0`000`Q10Q220a2R0f]=0liI0oNn0ooo0_oO0oNN0nmm0nLl0iBB
0c660P0P0`000`0P1SW71Icc0nLl1_oo0oNn0kgG1Kgg0e[;0a2R0`000`Q10a220QS30aSS0b440b4T
0bU50bUU1Haa0mkk1_oo0mkk0]kK0mJj0g>^0b4T1P000R440b4T0h@@0mJj0ooO0ooo0ooO0_NN0nmM
2?oo1W__0bU50`0P0P000`Q10a220a2R0f]=0liI0_Nn0ooo0ooO0oNN0nmm0nLl0iBB0S660`0P0`00
0`0P1SW71Icc0nLl1_oo0oNn0[gG1[gg0e[;0a2R0`000PQ10a220aS30aSS0b440b4T0RU50bUU1Xaa
0mkk1_oo0]kk0mkK0mJj0g>^0b4T1@000b440b4T0h@@0mJj0ooO0_oo0ooO0oNN0nmM6?oo000Gool6
Nnl2:DD302030003244348834:82Jdd3cUT3mkh3ool3oml3mih3kgd2ic`3U983<HH3020300030205
>LL6W?<3ic`5ool3mkh3_ML6_OL3F//24:830003244348836<<36><28@@38B@3:DD3:FD6S743g_/5
ool3g_/3g]/3e[X3Ljh28B@600038@@38B@3Q102e[X3oml3ool3oml3mih3ked8ool5Nnl3:DD30203
0003244348824:83Jdd3cUT3mkh3ool3oml2mih3kgd3ic`3U983<HH3020200030206>LL6W?<3ic`5
ool3mkh3_ML6_OL2F//34:830003244348836<<26><38@@38B@3:DD3:FD5S743g_/6ool3g_/3g]/3
e[X2Ljh38B@600038@@38B@2Q103e[X3oml3ool3oml3mih2ked9ool5Nnl3:DD30203000324424883
4:83Jdd3cUT3mkh3ool2oml3mih3kgd3ic`3U983<HH2020300030206>LL5W?<3ic`6ool3mkh3_ML5
_OL3F//34:830003244348826<<36><38@@38B@3:DD3:FD5S743g_/6ool3g_/2g]/3e[X3Ljh38B@6
00028@@38B@3Q103e[X3oml3ool3oml2mih3ked8ool6Nnl3:DD302020003244348834:83Jdd3cUT2
mkh3ool3oml3mih3kgd3ic`3U982<HH3020300030206>LL5W?<3ic`6ool3mkh2_ML6_OL3F//34:83
0002244348836<<36><38@@38B@2:DD3:FD6S743g_/6ool2g_/3g]/3e[X3Ljh38B@500038@@38B@3
Q103e[X3oml2ool3oml3mih3kedHool001Ooo`Ikk`8YA@<080<000<8@@<@PP<@XP9[C@?>F@?g_P?o
o`?og`?gWP?_O@;W?0>DTP<aQP<080<000<080Dia`JLl`?W?0Goo`?g_P>me`Jmm`=Jb`8@XP<000<8
@@<@PP<H``<Hh`8Q10<Q90<YA@<YI@J<L@?Nn`Goo`?Nn`?Nf`?F^P=c[P8Q90H000<Q10<Q90>440;F
^P?og`?oo`?og`?gWP?_G@Soo`Ekk`<YA@<080<000<8@@<@PP8@XP=[C@?>F@?g_P?oo`?og`;gWP?_
O@?W?0>DTP<aQP<0808000<080Hia`JLl`?W?0Goo`?g_P>me`Jmm`9Jb`<@XP<000<8@@<@PP<H``8H
h`<Q10<Q90<YA@<YI@F<L@?Nn`Koo`?Nn`?Nf`?F^P9c[P<Q90H000<Q10<Q90:440?F^P?og`?oo`?o
g`?gWP;_G@Woo`Ekk`<YA@<080<000<8@@8@PP<@XP=[C@?>F@?g_P?oo`;og`?gWP?_O@?W?0>DTP<a
QP8080<000<080Hia`FLl`?W?0Koo`?g_P>me`Fmm`=Jb`<@XP<000<8@@<@PP8H``<Hh`<Q10<Q90<Y
A@<YI@F<L@?Nn`Koo`?Nn`;Nf`?F^P=c[P<Q90H0008Q10<Q90>440?F^P?og`?oo`?og`;gWP?_G@So
o`Ikk`<YA@<0808000<8@@<@PP<@XP=[C@?>F@;g_P?oo`?og`?gWP?_O@?W?0>DTP8aQP<080<000<0
80Hia`FLl`?W?0Koo`?g_P:me`Jmm`=Jb`<@XP<00088@@<@PP<H``<Hh`<Q10<Q908YA@<YI@J<L@?N
n`Koo`;Nn`?Nf`?F^P=c[P<Q90D000<Q10<Q90>440?F^P?og`;oo`?og`?gWP?_GASoo`005ooo0nLl
0haa0S660`0P0`000`0P1SWW0ZDD0nLl1_oo0oNn0kgG0kgg0U:Z0a2R0`000`Q10a220aS30V]]0liI
0oNn0ooo0ooO0liI1F</0aS30`000`0P0d880ZDd0nmM1_oo0oNn0kgG0U:Z0a2R1P000`Q10a220aS3
0QSS0b440b4T0bU51RUU1C66336V0YcC0nLl1_oo0ooO0kgg2?oo0nLl0Xaa0c660`0P0`000`0P1CWW
0jDD0nLl1_oo0oNn0[gG0kgg0e:Z0a2R0`000`Q10Q220aS30f]]0liI0oNn0ooo0ooO0/iI1V</0aS3
0`000`0P0T880jDd0nmM1_oo0oNn0[gG0e:Z0a2R1P000`Q10Q220aS30aSS0b440b4T0bU51BUU1S66
2c6V0icC0nLl1_oo0ooO0[gg2Ooo0^Ll0haa0c660`0P0`000`0P1CWW0jDD0nLl1_oo0_Nn0kgG0kgg
0e:Z0a2R0`000PQ10a220aS30f]]0liI0oNn0_oo0ooO0liI1V</0aS30`000P0P0d880jDd0nmM1_oo
0_Nn0kgG0e:Z0a2R1P000PQ10a220aS30aSS0b440b4T0RU51RUU1S662c6V0icC0nLl1_oo0_oO0kgg
2?oo0nLl0haa0c660`0P0P000`0P1SWW0jDD0nLl1Ooo0oNn0kgG0kgg0e:Z0a2R0P000`Q10a220aS3
0f]]0liI0_Nn0ooo0ooO0liI1V</0QS30`000`0P0d880jDd0nmM1Ooo0oNn0kgG0e:Z0a2R1@000`Q1
0a220aS30aSS0b440R4T0bU51RUU1S662c6V0icC0nLl1Ooo0ooO0kgg6?oo000Gool3ic`3S742<HH3
020300030206>NL2YA@3ic`6ool3mkh3_ML3_OL2DZX34:830003244348836<<2Jfd3cUT3mkh3ool3
oml3cUT5Hb`36<<300030203@PP2YC@3ked6ool3mkh3_ML2DZX34:860003244348836<<26><38@@3
8B@3:DD6:FD5<HH<<JH2W=<3ic`6ool3oml3_OL8ool3ic`2S743<HH3020300030205>NL3YA@3ic`6
ool3mkh2_ML3_OL3DZX34:830003244248836<<3Jfd3cUT3mkh3ool3oml2cUT6Hb`36<<300030202
@PP3YC@3ked6ool3mkh2_ML3DZX34:860003244248836<<36><38@@38B@3:DD5:FD6<HH;<JH3W=<3
ic`6ool3oml2_OL9ool2ic`3S743<HH3020300030205>NL3YA@3ic`6ool2mkh3_ML3_OL3DZX34:83
0002244348836<<3Jfd3cUT3mkh2ool3oml3cUT6Hb`36<<300020203@PP3YC@3ked6ool2mkh3_ML3
DZX34:860002244348836<<36><38@@38B@2:DD6:FD6<HH;<JH3W=<3ic`6ool2oml3_OL8ool3ic`3
S743<HH3020200030206>NL3YA@3ic`5ool3mkh3_ML3_OL3DZX34:820003244348836<<3Jfd3cUT2
mkh3ool3oml3cUT6Hb`26<<300030203@PP3YC@3ked5ool3mkh3_ML3DZX34:850003244348836<<3
6><38@@28B@3:DD6:FD6<HH;<JH3W=<3ic`5ool3oml3_OLHool001Ooo`?W?0><L@8aQP<080<000<0
80Hii`:U50?W?0Koo`?g_P>me`>mm`9BZP<@XP<000<8@@<@PP<H``9[K@?>F@?g_P?oo`?og`?>F@ES
;0<H``<000<080=220:U=0?_G@Koo`?g_P>me`9BZP<@XPH000<8@@<@PP<H``8Hh`<Q10<Q90<YA@HY
I@DaQP`aYP:Ld`?W?0Koo`?og`>mm`Soo`?W?0:<L@<aQP<080<000<080Dii`>U50?W?0Koo`?g_P:m
e`>mm`=BZP<@XP<000<8@@8@PP<H``=[K@?>F@?g_P?oo`?og`;>F@IS;0<H``<000<0809220>U=0?_
G@Koo`?g_P:me`=BZP<@XPH000<8@@8@PP<H``<Hh`<Q10<Q90<YA@DYI@HaQP/aYP>Ld`?W?0Koo`?o
g`:mm`Woo`;W?0><L@<aQP<080<000<080Dii`>U50?W?0Koo`;g_P>me`>mm`=BZP<@XP<00088@@<@
PP<H``=[K@?>F@?g_P;oo`?og`?>F@IS;0<H``<0008080=220>U=0?_G@Koo`;g_P>me`=BZP<@XPH0
0088@@<@PP<H``<Hh`<Q10<Q908YA@HYI@HaQP/aYP>Ld`?W?0Koo`;og`>mm`Soo`?W?0><L@<aQP<0
808000<080Hii`>U50?W?0Goo`?g_P>me`>mm`=BZP<@XP8000<8@@<@PP<H``=[K@?>F@;g_P?oo`?o
g`?>F@IS;08H``<000<080=220>U=0?_G@Goo`?g_P>me`=BZP<@XPD000<8@@<@PP<H``<Hh`<Q108Q
90<YA@HYI@HaQP/aYP>Ld`?W?0Goo`?og`>mmaSoo`005ooo0nLl0haa0S660`0P0`000`0P1SWW0ZDD
0nLl1_oo0oNn0kgG0kgg0U:Z0a2R0`000`Q10a220aS30V]]0liI0oNn0ooo0ooO0liI1F</0aS30`00
0`0P0d880ZDd0nmM1_oo0oNn0kgG0U:Z0a2R1P000`Q10a220aS30QSS0b440b4T0bU51RUU1C66336V
0YcC0nLl1_oo0ooO0kgg2?oo0nLl0Xaa0c660`0P0`000`0P1CWW0jDD0nLl1_oo0oNn0[gG0kgg0e:Z
0a2R0`000`Q10Q220aS30f]]0liI0oNn0ooo0ooO0/iI1V</0aS30`000`0P0T880jDd0nmM1_oo0oNn
0[gG0e:Z0a2R1P000`Q10Q220aS30aSS0b440b4T0bU51BUU1S662c6V0icC0nLl1_oo0ooO0[gg2Ooo
0^Ll0haa0c660`0P0`000`0P1CWW0jDD0nLl1_oo0_Nn0kgG0kgg0e:Z0a2R0`000PQ10a220aS30f]]
0liI0oNn0_oo0ooO0liI1V</0aS30`000P0P0d880jDd0nmM1_oo0_Nn0kgG0e:Z0a2R1P000PQ10a22
0aS30aSS0b440b4T0RU51RUU1S662c6V0icC0nLl1_oo0_oO0kgg2?oo0nLl0haa0c660`0P0P000`0P
1SWW0jDD0nLl1Ooo0oNn0kgG0kgg0e:Z0a2R0P000`Q10a220aS30f]]0liI0_Nn0ooo0ooO0liI1V</
0QS30`000`0P0d880jDd0nmM1Ooo0oNn0kgG0e:Z0a2R1@000`Q10a220aS30aSS0b440R4T0bU51RUU
1S662c6V0icC0nLl1Ooo0ooO0kgg6?oo000Gool3ic`3S742<HH3020300030206>NL2YA@3ic`6ool3
mkh3_ML3_OL2DZX34:830003244348836<<2Jfd3cUT3mkh3ool3oml3cUT5Hb`36<<300030203@PP2
YC@3ked6ool3mkh3_ML2DZX34:860003244348836<<26><38@@38B@3:DD6:FD5<HH<<JH2W=<3ic`6
ool3oml3_OL8ool3ic`2S743<HH3020300030205>NL3YA@3ic`6ool3mkh2_ML3_OL3DZX34:830003
244248836<<3Jfd3cUT3mkh3ool3oml2cUT6Hb`36<<300030202@PP3YC@3ked6ool3mkh2_ML3DZX3
4:860003244248836<<36><38@@38B@3:DD5:FD6<HH;<JH3W=<3ic`6ool3oml2_OL9ool2ic`3S743
<HH3020300030205>NL3YA@3ic`6ool2mkh3_ML3_OL3DZX34:830002244348836<<3Jfd3cUT3mkh2
ool3oml3cUT6Hb`36<<300020203@PP3YC@3ked6ool2mkh3_ML3DZX34:860002244348836<<36><3
8@@38B@2:DD6:FD6<HH;<JH3W=<3ic`6ool2oml3_OL8ool3ic`3S743<HH3020200030206>NL3YA@3
ic`5ool3mkh3_ML3_OL3DZX34:820003244348836<<3Jfd3cUT2mkh3ool3oml3cUT6Hb`26<<30003
0203@PP3YC@3ked5ool3mkh3_ML3DZX34:850003244348836<<36><38@@28B@3:DD6:FD6<HH;<JH3
W=<3ic`5ool3oml3_OLHool001Ooo`?W?0><L@8aQP<080<000<080Hii`:U50?W?0Koo`?g_P>me`>m
m`9BZP<@XP<000<8@@<@PP<H``9[K@?>F@?g_P?oo`?og`?>F@ES;0<H``<000<080=220:U=0?_G@Ko
o`?g_P>me`9BZP<@XPH000<8@@<@PP<H``8Hh`<Q10<Q90<YA@HYI@DaQP`aYP:Ld`?W?0Koo`?og`>m
m`Soo`?W?0:<L@<aQP<080<000<080Dii`>U50?W?0Koo`?g_P:me`>mm`=BZP<@XP<000<8@@8@PP<H
``=[K@?>F@?g_P?oo`?og`;>F@IS;0<H``<000<0809220>U=0?_G@Koo`?g_P:me`=BZP<@XPH000<8
@@8@PP<H``<Hh`<Q10<Q90<YA@DYI@HaQP/aYP>Ld`?W?0Koo`?og`:mm`Woo`;W?0><L@<aQP<080<0
00<080Dii`>U50?W?0Koo`;g_P>me`>mm`=BZP<@XP<00088@@<@PP<H``=[K@?>F@?g_P;oo`?og`?>
F@IS;0<H``<0008080=220>U=0?_G@Koo`;g_P>me`=BZP<@XPH00088@@<@PP<H``<Hh`<Q10<Q908Y
A@HYI@HaQP/aYP>Ld`?W?0Koo`;og`>mm`Soo`?W?0><L@<aQP<0808000<080Hii`>U50?W?0Goo`?g
_P>me`>mm`=BZP<@XP8000<8@@<@PP<H``=[K@?>F@;g_P?oo`?og`?>F@IS;08H``<000<080=220>U
=0?_G@Goo`?g_P>me`=BZP<@XPD000<8@@<@PP<H``<Hh`<Q108Q90<YA@HYI@HaQP/aYP>Ld`?W?0Go
o`?og`>mmaSoo`005ooo0nLl0haa0S660`0P0`000`0P1SWW0ZDD0nLl1_oo0oNn0kgG0kgg0U:Z0a2R
0`000`Q10a220aS30V]]0liI0oNn0ooo0ooO0liI1F</0aS30`000`0P0d880ZDd0nmM1_oo0oNn0kgG
0U:Z0a2R1P000`Q10a220aS30QSS0b440b4T0bU51RUU1C66336V0YcC0nLl1_oo0ooO0kgg2?oo0nLl
0Xaa0c660`0P0`000`0P1CWW0jDD0nLl1_oo0oNn0[gG0kgg0e:Z0a2R0`000`Q10Q220aS30f]]0liI
0oNn0ooo0ooO0/iI1V</0aS30`000`0P0T880jDd0nmM1_oo0oNn0[gG0e:Z0a2R1P000`Q10Q220aS3
0aSS0b440b4T0bU51BUU1S662c6V0icC0nLl1_oo0ooO0[gg2Ooo0^Ll0haa0c660`0P0`000`0P1CWW
0jDD0nLl1_oo0_Nn0kgG0kgg0e:Z0a2R0`000PQ10a220aS30f]]0liI0oNn0_oo0ooO0liI1V</0aS3
0`000P0P0d880jDd0nmM1_oo0_Nn0kgG0e:Z0a2R1P000PQ10a220aS30aSS0b440b4T0RU51RUU1S66
2c6V0icC0nLl1_oo0_oO0kgg2?oo0nLl0haa0c660`0P0P000`0P1SWW0jDD0nLl1Ooo0oNn0kgG0kgg
0e:Z0a2R0P000`Q10a220aS30f]]0liI0_Nn0ooo0ooO0liI1V</0QS30`000`0P0d880jDd0nmM1Ooo
0oNn0kgG0e:Z0a2R1@000`Q10a220aS30aSS0b440R4T0bU51RUU1S662c6V0icC0nLl1Ooo0ooO0kgg
6?oo000Gool3ic`3S742<HH3020300030206>NL2YA@3ic`6ool3mkh3_ML3_OL2DZX34:8300032443
48836<<2Jfd3cUT3mkh3ool3oml3cUT5Hb`36<<300030203@PP2YC@3ked6ool3mkh3_ML2DZX34:86
0003244348836<<26><38@@38B@3:DD6:FD5<HH<<JH2W=<3ic`6ool3oml3_OL8ool3ic`2S743<HH3
020300030205>NL3YA@3ic`6ool3mkh2_ML3_OL3DZX34:830003244248836<<3Jfd3cUT3mkh3ool3
oml2cUT6Hb`36<<300030202@PP3YC@3ked6ool3mkh2_ML3DZX34:860003244248836<<36><38@@3
8B@3:DD5:FD6<HH;<JH3W=<3ic`6ool3oml2_OL9ool2ic`3S743<HH3020300030205>NL3YA@3ic`6
ool2mkh3_ML3_OL3DZX34:830002244348836<<3Jfd3cUT3mkh2ool3oml3cUT6Hb`36<<300020203
@PP3YC@3ked6ool2mkh3_ML3DZX34:860002244348836<<36><38@@38B@2:DD6:FD6<HH;<JH3W=<3
ic`6ool2oml3_OL8ool3ic`3S743<HH3020200030206>NL3YA@3ic`5ool3mkh3_ML3_OL3DZX34:82
0003244348836<<3Jfd3cUT2mkh3ool3oml3cUT6Hb`26<<300030203@PP3YC@3ked5ool3mkh3_ML3
DZX34:850003244348836<<36><38@@28B@3:DD6:FD6<HH;<JH3W=<3ic`5ool3oml3_OLHool001Oo
o`?W?0><L@8aQP<080<000<080Hii`:U50?W?0Koo`?g_P>me`>mm`9BZP<@XP<000<8@@<@PP<H``9[
K@?>F@?g_P?oo`?og`?>F@ES;0<H``<000<080=220:U=0?_G@Koo`?g_P>me`9BZP<@XPH000<8@@<@
PP<H``8Hh`<Q10<Q90<YA@HYI@DaQP`aYP:Ld`?W?0Koo`?og`>mm`Soo`?W?0:<L@<aQP<080<000<0
80Dii`>U50?W?0Koo`?g_P:me`>mm`=BZP<@XP<000<8@@8@PP<H``=[K@?>F@?g_P?oo`?og`;>F@IS
;0<H``<000<0809220>U=0?_G@Koo`?g_P:me`=BZP<@XPH000<8@@8@PP<H``<Hh`<Q10<Q90<YA@DY
I@HaQP/aYP>Ld`?W?0Koo`?og`:mm`Woo`;W?0><L@<aQP<080<000<080Dii`>U50?W?0Koo`;g_P>m
e`>mm`=BZP<@XP<00088@@<@PP<H``=[K@?>F@?g_P;oo`?og`?>F@IS;0<H``<0008080=220>U=0?_
G@Koo`;g_P>me`=BZP<@XPH00088@@<@PP<H``<Hh`<Q10<Q908YA@HYI@HaQP/aYP>Ld`?W?0Koo`;o
g`>mm`Soo`?W?0><L@<aQP<0808000<080Hii`>U50?W?0Goo`?g_P>me`>mm`=BZP<@XP8000<8@@<@
PP<H``=[K@?>F@;g_P?oo`?og`?>F@IS;08H``<000<080=220>U=0?_G@Goo`?g_P>me`=BZP<@XPD0
00<8@@<@PP<H``<Hh`<Q108Q90<YA@HYI@HaQP/aYP>Ld`?W?0Goo`?og`>mmaSoo`005ooo0nLl0haa
0S660`0P0`000`0P1SWW0ZDD0nLl1_oo0oNn0kgG0kgg0U:Z0a2R0`000`Q10a220aS30V]]0liI0oNn
0ooo0ooO0liI1F</0aS30`000`0P0d880ZDd0nmM1_oo0oNn0kgG0U:Z0a2R1P000`Q10a220aS30QSS
0b440b4T0bU51RUU1C66336V0YcC0nLl1_oo0ooO0kgg2?oo0nLl0Xaa0c660`0P0`000`0P1CWW0jDD
0nLl1_oo0oNn0[gG0kgg0e:Z0a2R0`000`Q10Q220aS30f]]0liI0oNn0ooo0ooO0/iI1V</0aS30`00
0`0P0T880jDd0nmM1_oo0oNn0[gG0e:Z0a2R1P000`Q10Q220aS30aSS0b440b4T0bU51BUU1S662c6V
0icC0nLl1_oo0ooO0[gg2Ooo0^Ll0haa0c660`0P0`000`0P1CWW0jDD0nLl1_oo0_Nn0kgG0kgg0e:Z
0a2R0`000PQ10a220aS30f]]0liI0oNn0_oo0ooO0liI1V</0aS30`000P0P0d880jDd0nmM1_oo0_Nn
0kgG0e:Z0a2R1P000PQ10a220aS30aSS0b440b4T0RU51RUU1S662c6V0icC0nLl1_oo0_oO0kgg2?oo
0nLl0haa0c660`0P0P000`0P1SWW0jDD0nLl1Ooo0oNn0kgG0kgg0e:Z0a2R0P000`Q10a220aS30f]]
0liI0_Nn0ooo0ooO0liI1V</0QS30`000`0P0d880jDd0nmM1Ooo0oNn0kgG0e:Z0a2R1@000`Q10a22
0aS30aSS0b440R4T0bU51RUU1S662c6V0icC0nLl1Ooo0ooO0kgg6?oo000Gool3ic`3S742<HH30203
00030206>NL2YA@3ic`6ool3mkh3_ML3_OL2DZX34:830003244348836<<2Jfd3cUT3mkh3ool3oml3
cUT5Hb`36<<300030203@PP2YC@3ked6ool3mkh3_ML2DZX34:860003244348836<<26><38@@38B@3
:DD6:FD5<HH<<JH2W=<3ic`6ool3oml3_OL8ool3ic`2S743<HH3020300030205>NL3YA@3ic`6ool3
mkh2_ML3_OL3DZX34:830003244248836<<3Jfd3cUT3mkh3ool3oml2cUT6Hb`36<<300030202@PP3
YC@3ked6ool3mkh2_ML3DZX34:860003244248836<<36><38@@38B@3:DD5:FD6<HH;<JH3W=<3ic`6
ool3oml2_OL9ool2ic`3S743<HH3020300030205>NL3YA@3ic`6ool2mkh3_ML3_OL3DZX34:830002
244348836<<3Jfd3cUT3mkh2ool3oml3cUT6Hb`36<<300020203@PP3YC@3ked6ool2mkh3_ML3DZX3
4:860002244348836<<36><38@@38B@2:DD6:FD6<HH;<JH3W=<3ic`6ool2oml3_OL8ool3ic`3S743
<HH3020200030206>NL3YA@3ic`5ool3mkh3_ML3_OL3DZX34:820003244348836<<3Jfd3cUT2mkh3
ool3oml3cUT6Hb`26<<300030203@PP3YC@3ked5ool3mkh3_ML3DZX34:850003244348836<<36><3
8@@28B@3:DD6:FD6<HH;<JH3W=<3ic`5ool3oml3_OLHool001Ooo`IBZP8@PPH000<YA@<YI@R<L@?N
n`?_O@Koo`?g_P;_O@?W?0>DTP<aYP<8@@<0008@XP<Hh`<Q10<Q90>4<0>440Ekk`?F^P?og`?oo`?W
70;Nn`?Nf`?F^P=c[P<Q90<@XP8000<8@@<@PP<H``<Hh`<Q10>440;F^P?og`?oo`?F^P=c[P<Q9080
80<000<080<8H@<@XP=S;09S30=Jj`?660?>F@?g_P_oo`EBZP<@PPH000<YA@<YI@R<L@?Nn`?_O@Go
o`?g_P?_O@?W?0>DTP<aYP88@@<000<@XP<Hh`<Q10<Q90>4<0:440Ikk`?F^P?og`?oo`;W70?Nn`?N
f`?F^P=c[P<Q908@XP<000<8@@<@PP<H``<Hh`8Q10>440?F^P?og`?oo`?F^P=c[P8Q90<080<000<0
80<8H@<@XP9S;0=S30=Jj`?660?>F@?g_P_oo`EBZP<@PPH000<YA@8YI@V<L@?Nn`?_O@Goo`?g_P?_
O@?W?0>DTP8aYP<8@@<000<@XP<Hh`<Q108Q90>4<0>440Ikk`?F^P?og`;oo`?W70?Nn`?Nf`?F^P=c
[P8Q90<@XP<000<8@@<@PP<H``8Hh`<Q10>440?F^P?og`?oo`;F^P=c[P<Q90<080<000<08088H@<@
XP=S;0=S30=Jj`?660?>F@;g_P_oo`IBZP<@PPD000<YA@<YI@V<L@;Nn`?_O@Koo`?g_P?_O@?W?0:D
TP<aYP<8@@<000<@XP<Hh`8Q10<Q90>4<0>440Ikk`;F^P?og`?oo`?W70?Nn`?Nf`;F^P=c[P<Q90<@
XP<000<8@@8@PP<H``<Hh`<Q10>440?F^P?og`;oo`?F^P=c[P<Q90<080<0008080<8H@<@XP=S;0=S
30=Jj`;660?>F@?g_Q_oo`005ooo1U:Z0Q221P000bU50bUU28aa0mkk0nmm1_oo0oNn0^mm0nLl0iBB
0c6V0`Q10`000Q2R0aSS0b440b4T0h@`0h@@1G__0mJj0ooO0ooo0nLL0]kk0mkK0mJj0g>^0b4T0a2R
0P000`Q10a220aS30aSS0b440h@@0]Jj0ooO0ooo0mJj0g>^0b4T0P0P0`000`0P0`QQ0a2R0f</0V<<
0e[[0lHH0liI0oNn2ooo1E:Z0a221P000bU50bUU28aa0mkk0nmm1Ooo0oNn0nmm0nLl0iBB0c6V0PQ1
0`000a2R0aSS0b440b4T0h@`0X@@1W__0mJj0ooO0ooo0^LL0mkk0mkK0mJj0g>^0b4T0Q2R0`000`Q1
0a220aS30aSS0R440h@@0mJj0ooO0ooo0mJj0g>^0R4T0`0P0`000`0P0`QQ0a2R0V</0f<<0e[[0lHH
0liI0oNn2ooo1E:Z0a221P000bU50RUU2Haa0mkk0nmm1Ooo0oNn0nmm0nLl0iBB0S6V0`Q10`000a2R
0aSS0b440R4T0h@`0h@@1W__0mJj0ooO0_oo0nLL0mkk0mkK0mJj0g>^0R4T0a2R0`000`Q10a220aS3
0QSS0b440h@@0mJj0ooO0ooo0]Jj0g>^0b4T0`0P0`000`0P0PQQ0a2R0f</0f<<0e[[0lHH0liI0_Nn
2ooo1U:Z0a221@000bU50bUU2Haa0]kk0nmm1_oo0oNn0nmm0nLl0YBB0c6V0`Q10`000a2R0aSS0R44
0b4T0h@`0h@@1W__0]Jj0ooO0ooo0nLL0mkk0mkK0]Jj0g>^0b4T0a2R0`000`Q10Q220aS30aSS0b44
0h@@0mJj0ooO0_oo0mJj0g>^0b4T0`0P0`000P0P0`QQ0a2R0f</0f<<0e[[0/HH0liI0oNn6ooo000G
ool6DZX248860003:DD3:FD8S743g_/3kgd6ool3mkh2kgd3ic`3U983<JH3244300024:836><38@@3
8B@3Q303Q105Nnl3e[X3oml3ool3ia`2g_/3g]/3e[X3Ljh38B@34:820003244348836<<36><38@@3
Q102e[X3oml3ool3e[X3Ljh38B@202030003020326434:83Hb`2H``3F^/3aQP3cUT3mkh;ool5DZX3
48860003:DD3:FD8S743g_/3kgd5ool3mkh3kgd3ic`3U983<JH2244300034:836><38@@38B@3Q302
Q106Nnl3e[X3oml3ool2ia`3g_/3g]/3e[X3Ljh38B@24:830003244348836<<36><28@@3Q103e[X3
oml3ool3e[X3Ljh28B@302030003020326434:82Hb`3H``3F^/3aQP3cUT3mkh;ool5DZX348860003
:DD2:FD9S743g_/3kgd5ool3mkh3kgd3ic`3U982<JH3244300034:836><38@@28B@3Q303Q106Nnl3
e[X3oml2ool3ia`3g_/3g]/3e[X3Ljh28B@34:830003244348836<<26><38@@3Q103e[X3oml3ool2
e[X3Ljh38B@302030003020226434:83Hb`3H``3F^/3aQP3cUT2mkh;ool6DZX348850003:DD3:FD9
S742g_/3kgd6ool3mkh3kgd3ic`2U983<JH3244300034:836><28@@38B@3Q303Q106Nnl2e[X3oml3
ool3ia`3g_/3g]/2e[X3Ljh38B@34:830003244248836<<36><38@@3Q103e[X3oml2ool3e[X3Ljh3
8B@302030002020326434:83Hb`3H``3F^/2aQP3cUT3mkhKool001Ooo`IBZP8@PPH000<YA@<YI@R<
L@?Nn`?_O@Koo`?g_P;_O@?W?0>DTP<aYP<8@@<0008@XP<Hh`<Q10<Q90>4<0>440Ekk`?F^P?og`?o
o`?W70;Nn`?Nf`?F^P=c[P<Q90<@XP8000<8@@<@PP<H``<Hh`<Q10>440;F^P?og`?oo`?F^P=c[P<Q
908080<000<080<8H@<@XP=S;09S30=Jj`?660?>F@?g_P_oo`EBZP<@PPH000<YA@<YI@R<L@?Nn`?_
O@Goo`?g_P?_O@?W?0>DTP<aYP88@@<000<@XP<Hh`<Q10<Q90>4<0:440Ikk`?F^P?og`?oo`;W70?N
n`?Nf`?F^P=c[P<Q908@XP<000<8@@<@PP<H``<Hh`8Q10>440?F^P?og`?oo`?F^P=c[P8Q90<080<0
00<080<8H@<@XP9S;0=S30=Jj`?660?>F@?g_P_oo`EBZP<@PPH000<YA@8YI@V<L@?Nn`?_O@Goo`?g
_P?_O@?W?0>DTP8aYP<8@@<000<@XP<Hh`<Q108Q90>4<0>440Ikk`?F^P?og`;oo`?W70?Nn`?Nf`?F
^P=c[P8Q90<@XP<000<8@@<@PP<H``8Hh`<Q10>440?F^P?og`?oo`;F^P=c[P<Q90<080<000<08088
H@<@XP=S;0=S30=Jj`?660?>F@;g_P_oo`IBZP<@PPD000<YA@<YI@V<L@;Nn`?_O@Koo`?g_P?_O@?W
?0:DTP<aYP<8@@<000<@XP<Hh`8Q10<Q90>4<0>440Ikk`;F^P?og`?oo`?W70?Nn`?Nf`;F^P=c[P<Q
90<@XP<000<8@@8@PP<H``<Hh`<Q10>440?F^P?og`;oo`?F^P=c[P<Q90<080<0008080<8H@<@XP=S
;0=S30=Jj`;660?>F@?g_Q_oo`005ooo1U:Z0Q221P000bU50bUU28aa0mkk0nmm1_oo0oNn0^mm0nLl
0iBB0c6V0`Q10`000Q2R0aSS0b440b4T0h@`0h@@1G__0mJj0ooO0ooo0nLL0]kk0mkK0mJj0g>^0b4T
0a2R0P000`Q10a220aS30aSS0b440h@@0]Jj0ooO0ooo0mJj0g>^0b4T0P0P0`000`0P0`QQ0a2R0f</
0V<<0e[[0lHH0liI0oNn2ooo1E:Z0a221P000bU50bUU28aa0mkk0nmm1Ooo0oNn0nmm0nLl0iBB0c6V
0PQ10`000a2R0aSS0b440b4T0h@`0X@@1W__0mJj0ooO0ooo0^LL0mkk0mkK0mJj0g>^0b4T0Q2R0`00
0`Q10a220aS30aSS0R440h@@0mJj0ooO0ooo0mJj0g>^0R4T0`0P0`000`0P0`QQ0a2R0V</0f<<0e[[
0lHH0liI0oNn2ooo1E:Z0a221P000bU50RUU2Haa0mkk0nmm1Ooo0oNn0nmm0nLl0iBB0S6V0`Q10`00
0a2R0aSS0b440R4T0h@`0h@@1W__0mJj0ooO0_oo0nLL0mkk0mkK0mJj0g>^0R4T0a2R0`000`Q10a22
0aS30QSS0b440h@@0mJj0ooO0ooo0]Jj0g>^0b4T0`0P0`000`0P0PQQ0a2R0f</0f<<0e[[0lHH0liI
0_Nn2ooo1U:Z0a221@000bU50bUU2Haa0]kk0nmm1_oo0oNn0nmm0nLl0YBB0c6V0`Q10`000a2R0aSS
0R440b4T0h@`0h@@1W__0]Jj0ooO0ooo0nLL0mkk0mkK0]Jj0g>^0b4T0a2R0`000`Q10Q220aS30aSS
0b440h@@0mJj0ooO0_oo0mJj0g>^0b4T0`0P0`000P0P0`QQ0a2R0f</0f<<0e[[0/HH0liI0oNn6ooo
000Gool6DZX248860003:DD3:FD8S743g_/3kgd6ool3mkh2kgd3ic`3U983<JH3244300024:836><3
8@@38B@3Q303Q105Nnl3e[X3oml3ool3ia`2g_/3g]/3e[X3Ljh38B@34:820003244348836<<36><3
8@@3Q102e[X3oml3ool3e[X3Ljh38B@202030003020326434:83Hb`2H``3F^/3aQP3cUT3mkh;ool5
DZX348860003:DD3:FD8S743g_/3kgd5ool3mkh3kgd3ic`3U983<JH2244300034:836><38@@38B@3
Q302Q106Nnl3e[X3oml3ool2ia`3g_/3g]/3e[X3Ljh38B@24:830003244348836<<36><28@@3Q103
e[X3oml3ool3e[X3Ljh28B@302030003020326434:82Hb`3H``3F^/3aQP3cUT3mkh;ool5DZX34886
0003:DD2:FD9S743g_/3kgd5ool3mkh3kgd3ic`3U982<JH3244300034:836><38@@28B@3Q303Q106
Nnl3e[X3oml2ool3ia`3g_/3g]/3e[X3Ljh28B@34:830003244348836<<26><38@@3Q103e[X3oml3
ool2e[X3Ljh38B@302030003020226434:83Hb`3H``3F^/3aQP3cUT2mkh;ool6DZX348850003:DD3
:FD9S742g_/3kgd6ool3mkh3kgd3ic`2U983<JH3244300034:836><28@@38B@3Q303Q106Nnl2e[X3
oml3ool3ia`3g_/3g]/2e[X3Ljh38B@34:830003244248836<<36><38@@3Q103e[X3oml2ool3e[X3
Ljh38B@302030002020326434:83Hb`3H``3F^/2aQP3cUT3mkhKool001Ooo`IBZP8@PPH000<YA@<Y
I@R<L@?Nn`?_O@Koo`?g_P;_O@?W?0>DTP<aYP<8@@<0008@XP<Hh`<Q10<Q90>4<0>440Ekk`?F^P?o
g`?oo`?W70;Nn`?Nf`?F^P=c[P<Q90<@XP8000<8@@<@PP<H``<Hh`<Q10>440;F^P?og`?oo`?F^P=c
[P<Q908080<000<080<8H@<@XP=S;09S30=Jj`?660?>F@?g_P_oo`EBZP<@PPH000<YA@<YI@R<L@?N
n`?_O@Goo`?g_P?_O@?W?0>DTP<aYP88@@<000<@XP<Hh`<Q10<Q90>4<0:440Ikk`?F^P?og`?oo`;W
70?Nn`?Nf`?F^P=c[P<Q908@XP<000<8@@<@PP<H``<Hh`8Q10>440?F^P?og`?oo`?F^P=c[P8Q90<0
80<000<080<8H@<@XP9S;0=S30=Jj`?660?>F@?g_P_oo`EBZP<@PPH000<YA@8YI@V<L@?Nn`?_O@Go
o`?g_P?_O@?W?0>DTP8aYP<8@@<000<@XP<Hh`<Q108Q90>4<0>440Ikk`?F^P?og`;oo`?W70?Nn`?N
f`?F^P=c[P8Q90<@XP<000<8@@<@PP<H``8Hh`<Q10>440?F^P?og`?oo`;F^P=c[P<Q90<080<000<0
8088H@<@XP=S;0=S30=Jj`?660?>F@;g_P_oo`IBZP<@PPD000<YA@<YI@V<L@;Nn`?_O@Koo`?g_P?_
O@?W?0:DTP<aYP<8@@<000<@XP<Hh`8Q10<Q90>4<0>440Ikk`;F^P?og`?oo`?W70?Nn`?Nf`;F^P=c
[P<Q90<@XP<000<8@@8@PP<H``<Hh`<Q10>440?F^P?og`;oo`?F^P=c[P<Q90<080<0008080<8H@<@
XP=S;0=S30=Jj`;660?>F@?g_Q_oo`005ooo1U:Z0Q221P000bU50bUU28aa0mkk0nmm1_oo0oNn0^mm
0nLl0iBB0c6V0`Q10`000Q2R0aSS0b440b4T0h@`0h@@1G__0mJj0ooO0ooo0nLL0]kk0mkK0mJj0g>^
0b4T0a2R0P000`Q10a220aS30aSS0b440h@@0]Jj0ooO0ooo0mJj0g>^0b4T0P0P0`000`0P0`QQ0a2R
0f</0V<<0e[[0lHH0liI0oNn2ooo1E:Z0a221P000bU50bUU28aa0mkk0nmm1Ooo0oNn0nmm0nLl0iBB
0c6V0PQ10`000a2R0aSS0b440b4T0h@`0X@@1W__0mJj0ooO0ooo0^LL0mkk0mkK0mJj0g>^0b4T0Q2R
0`000`Q10a220aS30aSS0R440h@@0mJj0ooO0ooo0mJj0g>^0R4T0`0P0`000`0P0`QQ0a2R0V</0f<<
0e[[0lHH0liI0oNn2ooo1E:Z0a221P000bU50RUU2Haa0mkk0nmm1Ooo0oNn0nmm0nLl0iBB0S6V0`Q1
0`000a2R0aSS0b440R4T0h@`0h@@1W__0mJj0ooO0_oo0nLL0mkk0mkK0mJj0g>^0R4T0a2R0`000`Q1
0a220aS30QSS0b440h@@0mJj0ooO0ooo0]Jj0g>^0b4T0`0P0`000`0P0PQQ0a2R0f</0f<<0e[[0lHH
0liI0_Nn2ooo1U:Z0a221@000bU50bUU2Haa0]kk0nmm1_oo0oNn0nmm0nLl0YBB0c6V0`Q10`000a2R
0aSS0R440b4T0h@`0h@@1W__0]Jj0ooO0ooo0nLL0mkk0mkK0]Jj0g>^0b4T0a2R0`000`Q10Q220aS3
0aSS0b440h@@0mJj0ooO0_oo0mJj0g>^0b4T0`0P0`000P0P0`QQ0a2R0f</0f<<0e[[0/HH0liI0oNn
6ooo000Gool6DZX248860003:DD3:FD8S743g_/3kgd6ool3mkh2kgd3ic`3U983<JH3244300024:83
6><38@@38B@3Q303Q105Nnl3e[X3oml3ool3ia`2g_/3g]/3e[X3Ljh38B@34:820003244348836<<3
6><38@@3Q102e[X3oml3ool3e[X3Ljh38B@202030003020326434:83Hb`2H``3F^/3aQP3cUT3mkh;
ool5DZX348860003:DD3:FD8S743g_/3kgd5ool3mkh3kgd3ic`3U983<JH2244300034:836><38@@3
8B@3Q302Q106Nnl3e[X3oml3ool2ia`3g_/3g]/3e[X3Ljh38B@24:830003244348836<<36><28@@3
Q103e[X3oml3ool3e[X3Ljh28B@302030003020326434:82Hb`3H``3F^/3aQP3cUT3mkh;ool5DZX3
48860003:DD2:FD9S743g_/3kgd5ool3mkh3kgd3ic`3U982<JH3244300034:836><38@@28B@3Q303
Q106Nnl3e[X3oml2ool3ia`3g_/3g]/3e[X3Ljh28B@34:830003244348836<<26><38@@3Q103e[X3
oml3ool2e[X3Ljh38B@302030003020226434:83Hb`3H``3F^/3aQP3cUT2mkh;ool6DZX348850003
:DD3:FD9S742g_/3kgd6ool3mkh3kgd3ic`2U983<JH3244300034:836><28@@38B@3Q303Q106Nnl2
e[X3oml3ool3ia`3g_/3g]/2e[X3Ljh38B@34:830003244248836<<36><38@@3Q103e[X3oml2ool3
e[X3Ljh38B@302030002020326434:83Hb`3H``3F^/2aQP3cUT3mkhKool001Ooo`IBZP8@PPH000<Y
A@<YI@R<L@?Nn`?_O@Koo`?g_P;_O@?W?0>DTP<aYP<8@@<0008@XP<Hh`<Q10<Q90>4<0>440Ekk`?F
^P?og`?oo`?W70;Nn`?Nf`?F^P=c[P<Q90<@XP8000<8@@<@PP<H``<Hh`<Q10>440;F^P?og`?oo`?F
^P=c[P<Q908080<000<080<8H@<@XP=S;09S30=Jj`?660?>F@?g_P_oo`EBZP<@PPH000<YA@<YI@R<
L@?Nn`?_O@Goo`?g_P?_O@?W?0>DTP<aYP88@@<000<@XP<Hh`<Q10<Q90>4<0:440Ikk`?F^P?og`?o
o`;W70?Nn`?Nf`?F^P=c[P<Q908@XP<000<8@@<@PP<H``<Hh`8Q10>440?F^P?og`?oo`?F^P=c[P8Q
90<080<000<080<8H@<@XP9S;0=S30=Jj`?660?>F@?g_P_oo`EBZP<@PPH000<YA@8YI@V<L@?Nn`?_
O@Goo`?g_P?_O@?W?0>DTP8aYP<8@@<000<@XP<Hh`<Q108Q90>4<0>440Ikk`?F^P?og`;oo`?W70?N
n`?Nf`?F^P=c[P8Q90<@XP<000<8@@<@PP<H``8Hh`<Q10>440?F^P?og`?oo`;F^P=c[P<Q90<080<0
00<08088H@<@XP=S;0=S30=Jj`?660?>F@;g_P_oo`IBZP<@PPD000<YA@<YI@V<L@;Nn`?_O@Koo`?g
_P?_O@?W?0:DTP<aYP<8@@<000<@XP<Hh`8Q10<Q90>4<0>440Ikk`;F^P?og`?oo`?W70?Nn`?Nf`;F
^P=c[P<Q90<@XP<000<8@@8@PP<H``<Hh`<Q10>440?F^P?og`;oo`?F^P=c[P<Q90<080<0008080<8
H@<@XP=S;0=S30=Jj`;660?>F@?g_Q_oo`005ooo1U:Z0Q221P000bU50bUU28aa0mkk0nmm1_oo0oNn
0^mm0nLl0iBB0c6V0`Q10`000Q2R0aSS0b440b4T0h@`0h@@1G__0mJj0ooO0ooo0nLL0]kk0mkK0mJj
0g>^0b4T0a2R0P000`Q10a220aS30aSS0b440h@@0]Jj0ooO0ooo0mJj0g>^0b4T0P0P0`000`0P0`QQ
0a2R0f</0V<<0e[[0lHH0liI0oNn2ooo1E:Z0a221P000bU50bUU28aa0mkk0nmm1Ooo0oNn0nmm0nLl
0iBB0c6V0PQ10`000a2R0aSS0b440b4T0h@`0X@@1W__0mJj0ooO0ooo0^LL0mkk0mkK0mJj0g>^0b4T
0Q2R0`000`Q10a220aS30aSS0R440h@@0mJj0ooO0ooo0mJj0g>^0R4T0`0P0`000`0P0`QQ0a2R0V</
0f<<0e[[0lHH0liI0oNn2ooo1E:Z0a221P000bU50RUU2Haa0mkk0nmm1Ooo0oNn0nmm0nLl0iBB0S6V
0`Q10`000a2R0aSS0b440R4T0h@`0h@@1W__0mJj0ooO0_oo0nLL0mkk0mkK0mJj0g>^0R4T0a2R0`00
0`Q10a220aS30QSS0b440h@@0mJj0ooO0ooo0]Jj0g>^0b4T0`0P0`000`0P0PQQ0a2R0f</0f<<0e[[
0lHH0liI0_Nn2ooo1U:Z0a221@000bU50bUU2Haa0]kk0nmm1_oo0oNn0nmm0nLl0YBB0c6V0`Q10`00
0a2R0aSS0R440b4T0h@`0h@@1W__0]Jj0ooO0ooo0nLL0mkk0mkK0]Jj0g>^0b4T0a2R0`000`Q10Q22
0aS30aSS0b440h@@0mJj0ooO0_oo0mJj0g>^0b4T0`0P0`000P0P0`QQ0a2R0f</0f<<0e[[0/HH0liI
0oNn6ooo000Gool3ic`5U983U;83<JH3:FD302030002020<@PP6YC@2ked3ool3mkh3kgd3ic`3ia`2
S543:FD3020300038@@38B@2:DD6:FD6<HH;U;83ia`6ool2oml3_OL3F//3DZX3DXX3BVT348850003
8B@3Q103Nnl3e[X2oml3ool3ia`3g_/3Q103Q302:FD36><6000302032648ool3ic`5U983U;83<JH3
:FD302020003020<@PP5YC@3ked3ool3mkh3kgd2ic`3ia`3S543:FD3020300038@@28B@3:DD6:FD6
<HH;U;83ia`5ool3oml3_OL3F//3DZX3DXX2BVT3488600038B@3Q103Nnl2e[X3oml3ool3ia`3g_/3
Q102Q303:FD36><6000302022649ool2ic`6U983U;83<JH3:FD202030003020;@PP6YC@3ked3ool3
mkh2kgd3ic`3ia`3S543:FD3020200038@@38B@3:DD6:FD5<HH<U;83ia`5ool3oml3_OL3F//3DZX2
DXX3BVT3488600038B@2Q103Nnl3e[X3oml3ool3ia`2g_/3Q103Q303:FD36><6000202032648ool3
ic`6U983U;82<JH3:FD302030003020;@PP6YC@3ked3ool2mkh3kgd3ic`3ia`3S543:FD202030003
8@@38B@3:DD5:FD6<HH;U;83ia`6ool3oml3_OL2F//3DZX3DXX3BVT3488600028B@3Q103Nnl3e[X3
oml3ool2ia`3g_/3Q103Q303:FD36><500030203264Hool001Ooo`?W?0FDTP>D/P<aYP<YI@<080<0
008080a220JU=0;_G@?oo`?g_P?_O@?W?0?W70:<D@<YI@<080<000<Q10<Q908YA@HYI@HaQP^D/P?W
70Koo`;og`>mm`=Jb`=BZP=BRP=:J@<@PPD000<Q90>440=kk`?F^P;og`?oo`?W70?Nn`>440>4<08Y
I@<Hh`H000<080<8H@Soo`?W?0FDTP>D/P<aYP<YI@<0808000<080a220FU=0?_G@?oo`?g_P?_O@;W
?0?W70><D@<YI@<080<000<Q108Q90<YA@HYI@HaQP^D/P?W70Goo`?og`>mm`=Jb`=BZP=BRP9:J@<@
PPH000<Q90>440=kk`;F^P?og`?oo`?W70?Nn`>440:4<0<YI@<Hh`H000<08088H@Woo`;W?0JDTP>D
/P<aYP<YI@8080<000<080]220JU=0?_G@?oo`?g_P;_O@?W?0?W70><D@<YI@<0808000<Q10<Q90<Y
A@HYI@DaQPbD/P?W70Goo`?og`>mm`=Jb`=BZP9BRP=:J@<@PPH000<Q90:440=kk`?F^P?og`?oo`?W
70;Nn`>440>4<0<YI@<Hh`H0008080<8H@Soo`?W?0JDTP>D/P8aYP<YI@<080<000<080]220JU=0?_
G@?oo`;g_P?_O@?W?0?W70><D@<YI@8080<000<Q10<Q90<YA@DYI@HaQP^D/P?W70Koo`?og`>mm`9J
b`=BZP=BRP=:J@<@PPH0008Q90>440=kk`?F^P?og`?oo`;W70?Nn`>440>4<0<YI@<Hh`D000<080<8
HASoo`005ooo0nLl1IBB0iBb0c6V0bUU0`0P0`000P0P34881ZDd0^mM0ooo0oNn0nmm0nLl0nLL0XaA
0bUU0`0P0`000b440b4T0RU51RUU1S662iBb0nLL1_oo0_oO0kgg0e[;0e:Z0e::0dYY0a221@000b4T
0h@@0g__0mJj0_oO0ooo0nLL0mkk0h@@0h@`0RUU0aSS1P000`0P0`QQ2?oo0nLl1IBB0iBb0c6V0bUU
0`0P0P000`0P34881JDd0nmM0ooo0oNn0nmm0^Ll0nLL0haA0bUU0`0P0`000b440R4T0bU51RUU1S66
2iBb0nLL1Ooo0ooO0kgg0e[;0e:Z0e::0TYY0a221P000b4T0h@@0g__0]Jj0ooO0ooo0nLL0mkk0h@@
0X@`0bUU0aSS1P000`0P0PQQ2Ooo0^Ll1YBB0iBb0c6V0bUU0P0P0`000`0P2d881ZDd0nmM0ooo0oNn
0^mm0nLl0nLL0haA0bUU0`0P0P000b440b4T0bU51RUU1C6639Bb0nLL1Ooo0ooO0kgg0e[;0e:Z0U::
0dYY0a221P000b4T0X@@0g__0mJj0ooO0ooo0nLL0]kk0h@@0h@`0bUU0aSS1P000P0P0`QQ2?oo0nLl
1YBB0iBb0S6V0bUU0`0P0`000`0P2d881ZDd0nmM0ooo0_Nn0nmm0nLl0nLL0haA0bUU0P0P0`000b44
0b4T0bU51BUU1S662iBb0nLL1_oo0ooO0kgg0U[;0e:Z0e::0dYY0a221P000R4T0h@@0g__0mJj0ooO
0ooo0^LL0mkk0h@@0h@`0bUU0aSS1@000`0P0`QQ6?oo000Gool3ic`5U983U;83<JH3:FD302030002
020<@PP6YC@2ked3ool3mkh3kgd3ic`3ia`2S543:FD3020300038@@38B@2:DD6:FD6<HH;U;83ia`6
ool2oml3_OL3F//3DZX3DXX3BVT3488500038B@3Q103Nnl3e[X2oml3ool3ia`3g_/3Q103Q302:FD3
6><6000302032648ool3ic`5U983U;83<JH3:FD302020003020<@PP5YC@3ked3ool3mkh3kgd2ic`3
ia`3S543:FD3020300038@@28B@3:DD6:FD6<HH;U;83ia`5ool3oml3_OL3F//3DZX3DXX2BVT34886
00038B@3Q103Nnl2e[X3oml3ool3ia`3g_/3Q102Q303:FD36><6000302022649ool2ic`6U983U;83
<JH3:FD202030003020;@PP6YC@3ked3ool3mkh2kgd3ic`3ia`3S543:FD3020200038@@38B@3:DD6
:FD5<HH<U;83ia`5ool3oml3_OL3F//3DZX2DXX3BVT3488600038B@2Q103Nnl3e[X3oml3ool3ia`2
g_/3Q103Q303:FD36><6000202032648ool3ic`6U983U;82<JH3:FD302030003020;@PP6YC@3ked3
ool2mkh3kgd3ic`3ia`3S543:FD2020300038@@38B@3:DD5:FD6<HH;U;83ia`6ool3oml3_OL2F//3
DZX3DXX3BVT3488600028B@3Q103Nnl3e[X3oml3ool2ia`3g_/3Q103Q303:FD36><500030203264H
ool001Ooo`?W?0FDTP>D/P<aYP<YI@<080<0008080a220JU=0;_G@?oo`?g_P?_O@?W?0?W70:<D@<Y
I@<080<000<Q10<Q908YA@HYI@HaQP^D/P?W70Koo`;og`>mm`=Jb`=BZP=BRP=:J@<@PPD000<Q90>4
40=kk`?F^P;og`?oo`?W70?Nn`>440>4<08YI@<Hh`H000<080<8H@Soo`?W?0FDTP>D/P<aYP<YI@<0
808000<080a220FU=0?_G@?oo`?g_P?_O@;W?0?W70><D@<YI@<080<000<Q108Q90<YA@HYI@HaQP^D
/P?W70Goo`?og`>mm`=Jb`=BZP=BRP9:J@<@PPH000<Q90>440=kk`;F^P?og`?oo`?W70?Nn`>440:4
<0<YI@<Hh`H000<08088H@Woo`;W?0JDTP>D/P<aYP<YI@8080<000<080]220JU=0?_G@?oo`?g_P;_
O@?W?0?W70><D@<YI@<0808000<Q10<Q90<YA@HYI@DaQPbD/P?W70Goo`?og`>mm`=Jb`=BZP9BRP=:
J@<@PPH000<Q90:440=kk`?F^P?og`?oo`?W70;Nn`>440>4<0<YI@<Hh`H0008080<8H@Soo`?W?0JD
TP>D/P8aYP<YI@<080<000<080]220JU=0?_G@?oo`;g_P?_O@?W?0?W70><D@<YI@8080<000<Q10<Q
90<YA@DYI@HaQP^D/P?W70Koo`?og`>mm`9Jb`=BZP=BRP=:J@<@PPH0008Q90>440=kk`?F^P?og`?o
o`;W70?Nn`>440>4<0<YI@<Hh`D000<080<8HASoo`005ooo0nLl1IBB0iBb0c6V0bUU0`0P0`000P0P
34881ZDd0^mM0ooo0oNn0nmm0nLl0nLL0XaA0bUU0`0P0`000b440b4T0RU51RUU1S662iBb0nLL1_oo
0_oO0kgg0e[;0e:Z0e::0dYY0a221@000b4T0h@@0g__0mJj0_oO0ooo0nLL0mkk0h@@0h@`0RUU0aSS
1P000`0P0`QQ2?oo0nLl1IBB0iBb0c6V0bUU0`0P0P000`0P34881JDd0nmM0ooo0oNn0nmm0^Ll0nLL
0haA0bUU0`0P0`000b440R4T0bU51RUU1S662iBb0nLL1Ooo0ooO0kgg0e[;0e:Z0e::0TYY0a221P00
0b4T0h@@0g__0]Jj0ooO0ooo0nLL0mkk0h@@0X@`0bUU0aSS1P000`0P0PQQ2Ooo0^Ll1YBB0iBb0c6V
0bUU0P0P0`000`0P2d881ZDd0nmM0ooo0oNn0^mm0nLl0nLL0haA0bUU0`0P0P000b440b4T0bU51RUU
1C6639Bb0nLL1Ooo0ooO0kgg0e[;0e:Z0U::0dYY0a221P000b4T0X@@0g__0mJj0ooO0ooo0nLL0]kk
0h@@0h@`0bUU0aSS1P000P0P0`QQ2?oo0nLl1YBB0iBb0S6V0bUU0`0P0`000`0P2d881ZDd0nmM0ooo
0_Nn0nmm0nLl0nLL0haA0bUU0P0P0`000b440b4T0bU51BUU1S662iBb0nLL1_oo0ooO0kgg0U[;0e:Z
0e::0dYY0a221P000R4T0h@@0g__0mJj0ooO0ooo0^LL0mkk0h@@0h@`0bUU0aSS1@000`0P0`QQ6?oo
000Gool3ic`5U983U;83<JH3:FD302030002020<@PP6YC@2ked3ool3mkh3kgd3ic`3ia`2S543:FD3
020300038@@38B@2:DD6:FD6<HH;U;83ia`6ool2oml3_OL3F//3DZX3DXX3BVT3488500038B@3Q103
Nnl3e[X2oml3ool3ia`3g_/3Q103Q302:FD36><6000302032648ool3ic`5U983U;83<JH3:FD30202
0003020<@PP5YC@3ked3ool3mkh3kgd2ic`3ia`3S543:FD3020300038@@28B@3:DD6:FD6<HH;U;83
ia`5ool3oml3_OL3F//3DZX3DXX2BVT3488600038B@3Q103Nnl2e[X3oml3ool3ia`3g_/3Q102Q303
:FD36><6000302022649ool2ic`6U983U;83<JH3:FD202030003020;@PP6YC@3ked3ool3mkh2kgd3
ic`3ia`3S543:FD3020200038@@38B@3:DD6:FD5<HH<U;83ia`5ool3oml3_OL3F//3DZX2DXX3BVT3
488600038B@2Q103Nnl3e[X3oml3ool3ia`2g_/3Q103Q303:FD36><6000202032648ool3ic`6U983
U;82<JH3:FD302030003020;@PP6YC@3ked3ool2mkh3kgd3ic`3ia`3S543:FD2020300038@@38B@3
:DD5:FD6<HH;U;83ia`6ool3oml3_OL2F//3DZX3DXX3BVT3488600028B@3Q103Nnl3e[X3oml3ool2
ia`3g_/3Q103Q303:FD36><500030203264Hool001Ooo`?W?0FDTP>D/P<aYP<YI@<080<0008080a2
20JU=0;_G@?oo`?g_P?_O@?W?0?W70:<D@<YI@<080<000<Q10<Q908YA@HYI@HaQP^D/P?W70Koo`;o
g`>mm`=Jb`=BZP=BRP=:J@<@PPD000<Q90>440=kk`?F^P;og`?oo`?W70?Nn`>440>4<08YI@<Hh`H0
00<080<8H@Soo`?W?0FDTP>D/P<aYP<YI@<0808000<080a220FU=0?_G@?oo`?g_P?_O@;W?0?W70><
D@<YI@<080<000<Q108Q90<YA@HYI@HaQP^D/P?W70Goo`?og`>mm`=Jb`=BZP=BRP9:J@<@PPH000<Q
90>440=kk`;F^P?og`?oo`?W70?Nn`>440:4<0<YI@<Hh`H000<08088H@Woo`;W?0JDTP>D/P<aYP<Y
I@8080<000<080]220JU=0?_G@?oo`?g_P;_O@?W?0?W70><D@<YI@<0808000<Q10<Q90<YA@HYI@Da
QPbD/P?W70Goo`?og`>mm`=Jb`=BZP9BRP=:J@<@PPH000<Q90:440=kk`?F^P?og`?oo`?W70;Nn`>4
40>4<0<YI@<Hh`H0008080<8H@Soo`?W?0JDTP>D/P8aYP<YI@<080<000<080]220JU=0?_G@?oo`;g
_P?_O@?W?0?W70><D@<YI@8080<000<Q10<Q90<YA@DYI@HaQP^D/P?W70Koo`?og`>mm`9Jb`=BZP=B
RP=:J@<@PPH0008Q90>440=kk`?F^P?og`?oo`;W70?Nn`>440>4<0<YI@<Hh`D000<080<8HASoo`00
5ooo0nLl1IBB0iBb0c6V0bUU0`0P0`000P0P34881ZDd0^mM0ooo0oNn0nmm0nLl0nLL0XaA0bUU0`0P
0`000b440b4T0RU51RUU1S662iBb0nLL1_oo0_oO0kgg0e[;0e:Z0e::0dYY0a221@000b4T0h@@0g__
0mJj0_oO0ooo0nLL0mkk0h@@0h@`0RUU0aSS1P000`0P0`QQ2?oo0nLl1IBB0iBb0c6V0bUU0`0P0P00
0`0P34881JDd0nmM0ooo0oNn0nmm0^Ll0nLL0haA0bUU0`0P0`000b440R4T0bU51RUU1S662iBb0nLL
1Ooo0ooO0kgg0e[;0e:Z0e::0TYY0a221P000b4T0h@@0g__0]Jj0ooO0ooo0nLL0mkk0h@@0X@`0bUU
0aSS1P000`0P0PQQ2Ooo0^Ll1YBB0iBb0c6V0bUU0P0P0`000`0P2d881ZDd0nmM0ooo0oNn0^mm0nLl
0nLL0haA0bUU0`0P0P000b440b4T0bU51RUU1C6639Bb0nLL1Ooo0ooO0kgg0e[;0e:Z0U::0dYY0a22
1P000b4T0X@@0g__0mJj0ooO0ooo0nLL0]kk0h@@0h@`0bUU0aSS1P000P0P0`QQ2?oo0nLl1YBB0iBb
0S6V0bUU0`0P0`000`0P2d881ZDd0nmM0ooo0_Nn0nmm0nLl0nLL0haA0bUU0P0P0`000b440b4T0bU5
1BUU1S662iBb0nLL1_oo0ooO0kgg0U[;0e:Z0e::0dYY0a221P000R4T0h@@0g__0mJj0ooO0ooo0^LL
0mkk0h@@0h@`0bUU0aSS1@000`0P0`QQ6?oo000Gool3ic`5U983U;83<JH3:FD302030002020<@PP6
YC@2ked3ool3mkh3kgd3ic`3ia`2S543:FD3020300038@@38B@2:DD6:FD6<HH;U;83ia`6ool2oml3
_OL3F//3DZX3DXX3BVT3488500038B@3Q103Nnl3e[X2oml3ool3ia`3g_/3Q103Q302:FD36><60003
02032648ool3ic`5U983U;83<JH3:FD302020003020<@PP5YC@3ked3ool3mkh3kgd2ic`3ia`3S543
:FD3020300038@@28B@3:DD6:FD6<HH;U;83ia`5ool3oml3_OL3F//3DZX3DXX2BVT3488600038B@3
Q103Nnl2e[X3oml3ool3ia`3g_/3Q102Q303:FD36><6000302022649ool2ic`6U983U;83<JH3:FD2
02030003020;@PP6YC@3ked3ool3mkh2kgd3ic`3ia`3S543:FD3020200038@@38B@3:DD6:FD5<HH<
U;83ia`5ool3oml3_OL3F//3DZX2DXX3BVT3488600038B@2Q103Nnl3e[X3oml3ool3ia`2g_/3Q103
Q303:FD36><6000202032648ool3ic`6U983U;82<JH3:FD302030003020;@PP6YC@3ked3ool2mkh3
kgd3ic`3ia`3S543:FD2020300038@@38B@3:DD5:FD6<HH;U;83ia`6ool3oml3_OL2F//3DZX3DXX3
BVT3488600028B@3Q103Nnl3e[X3oml3ool2ia`3g_/3Q103Q303:FD36><500030203264Hool001Oo
o`?W?0FDTP>D/P<aYP<YI@<080<0008080a220JU=0;_G@?oo`?g_P?_O@?W?0?W70:<D@<YI@<080<0
00<Q10<Q908YA@HYI@HaQP^D/P?W70Koo`;og`>mm`=Jb`=BZP=BRP=:J@<@PPD000<Q90>440=kk`?F
^P;og`?oo`?W70?Nn`>440>4<08YI@<Hh`H000<080<8H@Soo`?W?0FDTP>D/P<aYP<YI@<0808000<0
80a220FU=0?_G@?oo`?g_P?_O@;W?0?W70><D@<YI@<080<000<Q108Q90<YA@HYI@HaQP^D/P?W70Go
o`?og`>mm`=Jb`=BZP=BRP9:J@<@PPH000<Q90>440=kk`;F^P?og`?oo`?W70?Nn`>440:4<0<YI@<H
h`H000<08088H@Woo`;W?0JDTP>D/P<aYP<YI@8080<000<080]220JU=0?_G@?oo`?g_P;_O@?W?0?W
70><D@<YI@<0808000<Q10<Q90<YA@HYI@DaQPbD/P?W70Goo`?og`>mm`=Jb`=BZP9BRP=:J@<@PPH0
00<Q90:440=kk`?F^P?og`?oo`?W70;Nn`>440>4<0<YI@<Hh`H0008080<8H@Soo`?W?0JDTP>D/P8a
YP<YI@<080<000<080]220JU=0?_G@?oo`;g_P?_O@?W?0?W70><D@<YI@8080<000<Q10<Q90<YA@DY
I@HaQP^D/P?W70Koo`?og`>mm`9Jb`=BZP=BRP=:J@<@PPH0008Q90>440=kk`?F^P?og`?oo`;W70?N
n`>440>4<0<YI@<Hh`D000<080<8HASoo`005ooo0nLl1IBB0iBb0c6V0bUU0`0P0`000P0P34881ZDd
0^mM0ooo0oNn0nmm0nLl0nLL0XaA0bUU0`0P0`000b440b4T0RU51RUU1S662iBb0nLL1_oo0_oO0kgg
0e[;0e:Z0e::0dYY0a221@000b4T0h@@0g__0mJj0_oO0ooo0nLL0mkk0h@@0h@`0RUU0aSS1P000`0P
0`QQ2?oo0nLl1IBB0iBb0c6V0bUU0`0P0P000`0P34881JDd0nmM0ooo0oNn0nmm0^Ll0nLL0haA0bUU
0`0P0`000b440R4T0bU51RUU1S662iBb0nLL1Ooo0ooO0kgg0e[;0e:Z0e::0TYY0a221P000b4T0h@@
0g__0]Jj0ooO0ooo0nLL0mkk0h@@0X@`0bUU0aSS1P000`0P0PQQ2Ooo0^Ll1YBB0iBb0c6V0bUU0P0P
0`000`0P2d881ZDd0nmM0ooo0oNn0^mm0nLl0nLL0haA0bUU0`0P0P000b440b4T0bU51RUU1C6639Bb
0nLL1Ooo0ooO0kgg0e[;0e:Z0U::0dYY0a221P000b4T0X@@0g__0mJj0ooO0ooo0nLL0]kk0h@@0h@`
0bUU0aSS1P000P0P0`QQ2?oo0nLl1YBB0iBb0S6V0bUU0`0P0`000`0P2d881ZDd0nmM0ooo0_Nn0nmm
0nLl0nLL0haA0bUU0P0P0`000b440b4T0bU51BUU1S662iBb0nLL1_oo0ooO0kgg0U[;0e:Z0e::0dYY
0a221P000R4T0h@@0g__0mJj0ooO0ooo0^LL0mkk0h@@0h@`0bUU0aSS1@000`0P0`QQ6?oo000Gool3
4:83Jdd2Hb`3aSP3mkh3ool3kgd3ic`2S743<HH3020300036<<36><38@@28B@3Q306Q103Nnl3Nll2
e[X3oml3ool3ic`3S743U982U;83<JH3:DD302030005:DD3S543g_/3kgd3ool3mih2[GD3BTT34886
0003:FD3<HH8U983ia`3mih5ool6cWT6Jfd36><226430003244348836<<36><8ool34:82Jdd3Hb`3
aSP3mkh3ool3kgd2ic`3S743<HH3020300036<<26><38@@38B@3Q306Q102Nnl3Nll3e[X3oml3ool3
ic`3S742U983U;83<JH3:DD302030005:DD3S543g_/3kgd3ool2mih3[GD3BTT348860002:FD3<HH9
U983ia`3mih5ool6cWT6Jfd26><326430003244348836<<26><9ool24:83Jdd3Hb`3aSP3mkh3ool2
kgd3ic`3S743<HH3020300026<<36><38@@38B@3Q305Q103Nnl3Nll3e[X3oml3ool2ic`3S743U983
U;83<JH3:DD302020006:DD3S543g_/3kgd2ool3mih3[GD3BTT348850003:FD3<HH9U982ia`3mih6
ool6cWT5Jfd36><326430003244348826<<36><8ool34:83Jdd3Hb`3aSP2mkh3ool3kgd3ic`3S743
<HH2020300036<<36><38@@38B@3Q305Q103Nnl3Nll3e[X3oml2ool3ic`3S743U983U;83<JH2:DD3
02030006:DD3S542g_/3kgd3ool3mih3[GD3BTT248860003:FD3<HH8U983ia`3mih6ool5cWT6Jfd3
6><326430002244348836<<36><Hool001Ooo`<@XP=[C@9S;0?6>0?g_P?oo`?_O@?W?0:<L@<aQP<0
80<000<H``<Hh`<Q108Q90>4<0J440=kk`=kc`;F^P?og`?oo`?W?0><L@>DTP:D/P<aYP<YA@<080<0
00DYA@><D@?Nn`?_O@?oo`?gWP:]M@=:B@<@PPH000<YI@<aQPRDTP?W70?gWPGoo`K>N@I[K@<Hh`88
H@<000<8@@<@PP<H``<Hh`Soo`<@XP9[C@=S;0?6>0?g_P?oo`?_O@;W?0><L@<aQP<080<000<H``8H
h`<Q10<Q90>4<0J4409kk`=kc`?F^P?og`?oo`?W?0><L@:DTP>D/P<aYP<YA@<080<000DYA@><D@?N
n`?_O@?oo`;gWP>]M@=:B@<@PPH0008YI@<aQPVDTP?W70?gWPGoo`K>N@I[K@8Hh`<8H@<000<8@@<@
PP<H``8Hh`Woo`8@XP=[C@=S;0?6>0?g_P?oo`;_O@?W?0><L@<aQP<080<0008H``<Hh`<Q10<Q90>4
<0F440=kk`=kc`?F^P?og`?oo`;W?0><L@>DTP>D/P<aYP<YA@<0808000HYA@><D@?Nn`?_O@;oo`?g
WP>]M@=:B@<@PPD000<YI@<aQPVDTP;W70?gWPKoo`K>N@E[K@<Hh`<8H@<000<8@@<@PP8H``<Hh`So
o`<@XP=[C@=S;0?6>0;g_P?oo`?_O@?W?0><L@<aQP8080<000<H``<Hh`<Q10<Q90>4<0F440=kk`=k
c`?F^P?og`;oo`?W?0><L@>DTP>D/P<aYP8YA@<080<000HYA@><D@;Nn`?_O@?oo`?gWP>]M@=:B@8@
PPH000<YI@<aQPRDTP?W70?gWPKoo`G>N@I[K@<Hh`<8H@<00088@@<@PP<H``<HhaSoo`005ooo0a2R
0f]=0V</0lHh0oNn0ooo0nmm0nLl0Xaa0c660`0P0`000aS30aSS0b440R4T0h@`1X@@0g__0g_?0]Jj
0ooO0ooo0nLl0haa0iBB0YBb0c6V0bU50`0P0`001BU50haA0mkk0nmm0ooo0oNN0Zee0dY90a221P00
0bUU0c6629BB0nLL0oNN1Ooo1/ii1V]]0aSS0PQQ0`000`Q10a220aS30aSS2?oo0a2R0V]=0f</0lHh
0oNn0ooo0nmm0^Ll0haa0c660`0P0`000aS30QSS0b440b4T0h@`1X@@0W__0g_?0mJj0ooO0ooo0nLl
0haa0YBB0iBb0c6V0bU50`0P0`001BU50haA0mkk0nmm0ooo0_NN0jee0dY90a221P000RUU0c662IBB
0nLL0oNN1Ooo1/ii1V]]0QSS0`QQ0`000`Q10a220aS30QSS2Ooo0Q2R0f]=0f</0lHh0oNn0ooo0^mm
0nLl0haa0c660`0P0`000QS30aSS0b440b4T0h@`1H@@0g__0g_?0mJj0ooO0ooo0^Ll0haa0iBB0iBb
0c6V0bU50`0P0P001RU50haA0mkk0nmm0_oo0oNN0jee0dY90a221@000bUU0c662IBB0^LL0oNN1_oo
1/ii1F]]0aSS0`QQ0`000`Q10a220QS30aSS2?oo0a2R0f]=0f</0lHh0_Nn0ooo0nmm0nLl0haa0c66
0P0P0`000aS30aSS0b440b4T0h@`1H@@0g__0g_?0mJj0ooO0_oo0nLl0haa0iBB0iBb0c6V0RU50`0P
0`001RU50haA0]kk0nmm0ooo0oNN0jee0dY90Q221P000bUU0c6629BB0nLL0oNN1_oo1Lii1V]]0aSS
0`QQ0`000PQ10a220aS30aSS6?oo000Gool34:83Jdd2Hb`3aSP3mkh3ool3kgd3ic`2S743<HH30203
00036<<36><38@@28B@3Q306Q103Nnl3Nll2e[X3oml3ool3ic`3S743U982U;83<JH3:DD302030005
:DD3S543g_/3kgd3ool3mih2[GD3BTT348860003:FD3<HH8U983ia`3mih5ool6cWT6Jfd36><22643
0003244348836<<36><8ool34:82Jdd3Hb`3aSP3mkh3ool3kgd2ic`3S743<HH3020300036<<26><3
8@@38B@3Q306Q102Nnl3Nll3e[X3oml3ool3ic`3S742U983U;83<JH3:DD302030005:DD3S543g_/3
kgd3ool2mih3[GD3BTT348860002:FD3<HH9U983ia`3mih5ool6cWT6Jfd26><32643000324434883
6<<26><9ool24:83Jdd3Hb`3aSP3mkh3ool2kgd3ic`3S743<HH3020300026<<36><38@@38B@3Q305
Q103Nnl3Nll3e[X3oml3ool2ic`3S743U983U;83<JH3:DD302020006:DD3S543g_/3kgd2ool3mih3
[GD3BTT348850003:FD3<HH9U982ia`3mih6ool6cWT5Jfd36><326430003244348826<<36><8ool3
4:83Jdd3Hb`3aSP2mkh3ool3kgd3ic`3S743<HH2020300036<<36><38@@38B@3Q305Q103Nnl3Nll3
e[X3oml2ool3ic`3S743U983U;83<JH2:DD302030006:DD3S542g_/3kgd3ool3mih3[GD3BTT24886
0003:FD3<HH8U983ia`3mih6ool5cWT6Jfd36><326430002244348836<<36><Hool001Ooo`<@XP=[
C@9S;0?6>0?g_P?oo`?_O@?W?0:<L@<aQP<080<000<H``<Hh`<Q108Q90>4<0J440=kk`=kc`;F^P?o
g`?oo`?W?0><L@>DTP:D/P<aYP<YA@<080<000DYA@><D@?Nn`?_O@?oo`?gWP:]M@=:B@<@PPH000<Y
I@<aQPRDTP?W70?gWPGoo`K>N@I[K@<Hh`88H@<000<8@@<@PP<H``<Hh`Soo`<@XP9[C@=S;0?6>0?g
_P?oo`?_O@;W?0><L@<aQP<080<000<H``8Hh`<Q10<Q90>4<0J4409kk`=kc`?F^P?og`?oo`?W?0><
L@:DTP>D/P<aYP<YA@<080<000DYA@><D@?Nn`?_O@?oo`;gWP>]M@=:B@<@PPH0008YI@<aQPVDTP?W
70?gWPGoo`K>N@I[K@8Hh`<8H@<000<8@@<@PP<H``8Hh`Woo`8@XP=[C@=S;0?6>0?g_P?oo`;_O@?W
?0><L@<aQP<080<0008H``<Hh`<Q10<Q90>4<0F440=kk`=kc`?F^P?og`?oo`;W?0><L@>DTP>D/P<a
YP<YA@<0808000HYA@><D@?Nn`?_O@;oo`?gWP>]M@=:B@<@PPD000<YI@<aQPVDTP;W70?gWPKoo`K>
N@E[K@<Hh`<8H@<000<8@@<@PP8H``<Hh`Soo`<@XP=[C@=S;0?6>0;g_P?oo`?_O@?W?0><L@<aQP80
80<000<H``<Hh`<Q10<Q90>4<0F440=kk`=kc`?F^P?og`;oo`?W?0><L@>DTP>D/P<aYP8YA@<080<0
00HYA@><D@;Nn`?_O@?oo`?gWP>]M@=:B@8@PPH000<YI@<aQPRDTP?W70?gWPKoo`G>N@I[K@<Hh`<8
H@<00088@@<@PP<H``<HhaSoo`005ooo0a2R0f]=0V</0lHh0oNn0ooo0nmm0nLl0Xaa0c660`0P0`00
0aS30aSS0b440R4T0h@`1X@@0g__0g_?0]Jj0ooO0ooo0nLl0haa0iBB0YBb0c6V0bU50`0P0`001BU5
0haA0mkk0nmm0ooo0oNN0Zee0dY90a221P000bUU0c6629BB0nLL0oNN1Ooo1/ii1V]]0aSS0PQQ0`00
0`Q10a220aS30aSS2?oo0a2R0V]=0f</0lHh0oNn0ooo0nmm0^Ll0haa0c660`0P0`000aS30QSS0b44
0b4T0h@`1X@@0W__0g_?0mJj0ooO0ooo0nLl0haa0YBB0iBb0c6V0bU50`0P0`001BU50haA0mkk0nmm
0ooo0_NN0jee0dY90a221P000RUU0c662IBB0nLL0oNN1Ooo1/ii1V]]0QSS0`QQ0`000`Q10a220aS3
0QSS2Ooo0Q2R0f]=0f</0lHh0oNn0ooo0^mm0nLl0haa0c660`0P0`000QS30aSS0b440b4T0h@`1H@@
0g__0g_?0mJj0ooO0ooo0^Ll0haa0iBB0iBb0c6V0bU50`0P0P001RU50haA0mkk0nmm0_oo0oNN0jee
0dY90a221@000bUU0c662IBB0^LL0oNN1_oo1/ii1F]]0aSS0`QQ0`000`Q10a220QS30aSS2?oo0a2R
0f]=0f</0lHh0_Nn0ooo0nmm0nLl0haa0c660P0P0`000aS30aSS0b440b4T0h@`1H@@0g__0g_?0mJj
0ooO0_oo0nLl0haa0iBB0iBb0c6V0RU50`0P0`001RU50haA0]kk0nmm0ooo0oNN0jee0dY90Q221P00
0bUU0c6629BB0nLL0oNN1_oo1Lii1V]]0aSS0`QQ0`000PQ10a220aS30aSS6?oo000Gool34:83Jdd2
Hb`3aSP3mkh3ool3kgd3ic`2S743<HH3020300036<<36><38@@28B@3Q306Q103Nnl3Nll2e[X3oml3
ool3ic`3S743U982U;83<JH3:DD302030005:DD3S543g_/3kgd3ool3mih2[GD3BTT348860003:FD3
<HH8U983ia`3mih5ool6cWT6Jfd36><226430003244348836<<36><8ool34:82Jdd3Hb`3aSP3mkh3
ool3kgd2ic`3S743<HH3020300036<<26><38@@38B@3Q306Q102Nnl3Nll3e[X3oml3ool3ic`3S742
U983U;83<JH3:DD302030005:DD3S543g_/3kgd3ool2mih3[GD3BTT348860002:FD3<HH9U983ia`3
mih5ool6cWT6Jfd26><326430003244348836<<26><9ool24:83Jdd3Hb`3aSP3mkh3ool2kgd3ic`3
S743<HH3020300026<<36><38@@38B@3Q305Q103Nnl3Nll3e[X3oml3ool2ic`3S743U983U;83<JH3
:DD302020006:DD3S543g_/3kgd2ool3mih3[GD3BTT348850003:FD3<HH9U982ia`3mih6ool6cWT5
Jfd36><326430003244348826<<36><8ool34:83Jdd3Hb`3aSP2mkh3ool3kgd3ic`3S743<HH20203
00036<<36><38@@38B@3Q305Q103Nnl3Nll3e[X3oml2ool3ic`3S743U983U;83<JH2:DD302030006
:DD3S542g_/3kgd3ool3mih3[GD3BTT248860003:FD3<HH8U983ia`3mih6ool5cWT6Jfd36><32643
0002244348836<<36><Hool001Ooo`<@XP=[C@9S;0?6>0?g_P?oo`?_O@?W?0:<L@<aQP<080<000<H
``<Hh`<Q108Q90>4<0J440=kk`=kc`;F^P?og`?oo`?W?0><L@>DTP:D/P<aYP<YA@<080<000DYA@><
D@?Nn`?_O@?oo`?gWP:]M@=:B@<@PPH000<YI@<aQPRDTP?W70?gWPGoo`K>N@I[K@<Hh`88H@<000<8
@@<@PP<H``<Hh`Soo`<@XP9[C@=S;0?6>0?g_P?oo`?_O@;W?0><L@<aQP<080<000<H``8Hh`<Q10<Q
90>4<0J4409kk`=kc`?F^P?og`?oo`?W?0><L@:DTP>D/P<aYP<YA@<080<000DYA@><D@?Nn`?_O@?o
o`;gWP>]M@=:B@<@PPH0008YI@<aQPVDTP?W70?gWPGoo`K>N@I[K@8Hh`<8H@<000<8@@<@PP<H``8H
h`Woo`8@XP=[C@=S;0?6>0?g_P?oo`;_O@?W?0><L@<aQP<080<0008H``<Hh`<Q10<Q90>4<0F440=k
k`=kc`?F^P?og`?oo`;W?0><L@>DTP>D/P<aYP<YA@<0808000HYA@><D@?Nn`?_O@;oo`?gWP>]M@=:
B@<@PPD000<YI@<aQPVDTP;W70?gWPKoo`K>N@E[K@<Hh`<8H@<000<8@@<@PP8H``<Hh`Soo`<@XP=[
C@=S;0?6>0;g_P?oo`?_O@?W?0><L@<aQP8080<000<H``<Hh`<Q10<Q90>4<0F440=kk`=kc`?F^P?o
g`;oo`?W?0><L@>DTP>D/P<aYP8YA@<080<000HYA@><D@;Nn`?_O@?oo`?gWP>]M@=:B@8@PPH000<Y
I@<aQPRDTP?W70?gWPKoo`G>N@I[K@<Hh`<8H@<00088@@<@PP<H``<HhaSoo`005ooo0a2R0f]=0V</
0lHh0oNn0ooo0nmm0nLl0Xaa0c660`0P0`000aS30aSS0b440R4T0h@`1X@@0g__0g_?0]Jj0ooO0ooo
0nLl0haa0iBB0YBb0c6V0bU50`0P0`001BU50haA0mkk0nmm0ooo0oNN0Zee0dY90a221P000bUU0c66
29BB0nLL0oNN1Ooo1/ii1V]]0aSS0PQQ0`000`Q10a220aS30aSS2?oo0a2R0V]=0f</0lHh0oNn0ooo
0nmm0^Ll0haa0c660`0P0`000aS30QSS0b440b4T0h@`1X@@0W__0g_?0mJj0ooO0ooo0nLl0haa0YBB
0iBb0c6V0bU50`0P0`001BU50haA0mkk0nmm0ooo0_NN0jee0dY90a221P000RUU0c662IBB0nLL0oNN
1Ooo1/ii1V]]0QSS0`QQ0`000`Q10a220aS30QSS2Ooo0Q2R0f]=0f</0lHh0oNn0ooo0^mm0nLl0haa
0c660`0P0`000QS30aSS0b440b4T0h@`1H@@0g__0g_?0mJj0ooO0ooo0^Ll0haa0iBB0iBb0c6V0bU5
0`0P0P001RU50haA0mkk0nmm0_oo0oNN0jee0dY90a221@000bUU0c662IBB0^LL0oNN1_oo1/ii1F]]
0aSS0`QQ0`000`Q10a220QS30aSS2?oo0a2R0f]=0f</0lHh0_Nn0ooo0nmm0nLl0haa0c660P0P0`00
0aS30aSS0b440b4T0h@`1H@@0g__0g_?0mJj0ooO0_oo0nLl0haa0iBB0iBb0c6V0RU50`0P0`001RU5
0haA0]kk0nmm0ooo0oNN0jee0dY90Q221P000bUU0c6629BB0nLL0oNN1_oo1Lii1V]]0aSS0`QQ0`00
0PQ10a220aS30aSS6?oo000Gool34:83Jdd2Hb`3aSP3mkh3ool3kgd3ic`2S743<HH3020300036<<3
6><38@@28B@3Q306Q103Nnl3Nll2e[X3oml3ool3ic`3S743U982U;83<JH3:DD302030005:DD3S543
g_/3kgd3ool3mih2[GD3BTT348860003:FD3<HH8U983ia`3mih5ool6cWT6Jfd36><2264300032443
48836<<36><8ool34:82Jdd3Hb`3aSP3mkh3ool3kgd2ic`3S743<HH3020300036<<26><38@@38B@3
Q306Q102Nnl3Nll3e[X3oml3ool3ic`3S742U983U;83<JH3:DD302030005:DD3S543g_/3kgd3ool2
mih3[GD3BTT348860002:FD3<HH9U983ia`3mih5ool6cWT6Jfd26><326430003244348836<<26><9
ool24:83Jdd3Hb`3aSP3mkh3ool2kgd3ic`3S743<HH3020300026<<36><38@@38B@3Q305Q103Nnl3
Nll3e[X3oml3ool2ic`3S743U983U;83<JH3:DD302020006:DD3S543g_/3kgd2ool3mih3[GD3BTT3
48850003:FD3<HH9U982ia`3mih6ool6cWT5Jfd36><326430003244348826<<36><8ool34:83Jdd3
Hb`3aSP2mkh3ool3kgd3ic`3S743<HH2020300036<<36><38@@38B@3Q305Q103Nnl3Nll3e[X3oml2
ool3ic`3S743U983U;83<JH2:DD302030006:DD3S542g_/3kgd3ool3mih3[GD3BTT248860003:FD3
<HH8U983ia`3mih6ool5cWT6Jfd36><326430002244348836<<36><Hool001Ooo`<@XP=[C@9S;0?6
>0?g_P?oo`?_O@?W?0:<L@<aQP<080<000<H``<Hh`<Q108Q90>4<0J440=kk`=kc`;F^P?og`?oo`?W
?0><L@>DTP:D/P<aYP<YA@<080<000DYA@><D@?Nn`?_O@?oo`?gWP:]M@=:B@<@PPH000<YI@<aQPRD
TP?W70?gWPGoo`K>N@I[K@<Hh`88H@<000<8@@<@PP<H``<Hh`Soo`<@XP9[C@=S;0?6>0?g_P?oo`?_
O@;W?0><L@<aQP<080<000<H``8Hh`<Q10<Q90>4<0J4409kk`=kc`?F^P?og`?oo`?W?0><L@:DTP>D
/P<aYP<YA@<080<000DYA@><D@?Nn`?_O@?oo`;gWP>]M@=:B@<@PPH0008YI@<aQPVDTP?W70?gWPGo
o`K>N@I[K@8Hh`<8H@<000<8@@<@PP<H``8Hh`Woo`8@XP=[C@=S;0?6>0?g_P?oo`;_O@?W?0><L@<a
QP<080<0008H``<Hh`<Q10<Q90>4<0F440=kk`=kc`?F^P?og`?oo`;W?0><L@>DTP>D/P<aYP<YA@<0
808000HYA@><D@?Nn`?_O@;oo`?gWP>]M@=:B@<@PPD000<YI@<aQPVDTP;W70?gWPKoo`K>N@E[K@<H
h`<8H@<000<8@@<@PP8H``<Hh`Soo`<@XP=[C@=S;0?6>0;g_P?oo`?_O@?W?0><L@<aQP8080<000<H
``<Hh`<Q10<Q90>4<0F440=kk`=kc`?F^P?og`;oo`?W?0><L@>DTP>D/P<aYP8YA@<080<000HYA@><
D@;Nn`?_O@?oo`?gWP>]M@=:B@8@PPH000<YI@<aQPRDTP?W70?gWPKoo`G>N@I[K@<Hh`<8H@<00088
@@<@PP<H``<HhaSoo`005ooo0g_?0mJJ0_oO0ooo0nLl0haa0iBB0c6V0PQ10`000a2R0aSS0g>^0g>>
0lii0_oO0ooo0ooO0oNN0jee0dY90T880`QQ1P000`Q10a220V<<0lHH0oNn0ooo0nmm0nLl0^LL0mkK
0g__0h@@0h@`0bU50QSS1P000`0P0`QQ0e[;0e:Z1E::0kFf0nmm1_oo0_Nn0nmm0jDD0cWW0`Q11@00
0`Q11TY90jee0nmm2?oo0g_?0]JJ0ooO0ooo0nLl0haa0iBB0S6V0`Q10`000a2R0aSS0g>^0W>>0lii
0ooO0ooo0ooO0oNN0Zee0dY90d880`QQ1P000`Q10Q220f<<0lHH0oNn0ooo0nmm0^Ll0nLL0mkK0g__
0h@@0h@`0RU50aSS1P000`0P0`QQ0U[;0e:Z1U::0kFf0nmm1Ooo0oNn0nmm0jDD0cWW0`Q11@000`Q1
1TY90jee0^mm2Ooo0W_?0mJJ0ooO0ooo0nLl0haa0YBB0c6V0`Q10`000a2R0aSS0W>^0g>>0lii0ooO
0ooo0ooO0_NN0jee0dY90d880`QQ1@000`Q10a220f<<0lHH0oNn0ooo0^mm0nLl0nLL0mkK0g__0h@@
0X@`0bU50aSS1P000`0P0PQQ0e[;0e:Z1U::0kFf0^mm1_oo0oNn0nmm0jDD0SWW0`Q11P000`Q11TY9
0Zee0nmm2?oo0g_?0mJJ0ooO0ooo0^Ll0haa0iBB0c6V0`Q10`000Q2R0aSS0g>^0g>>0lii0ooO0ooo
0_oO0oNN0jee0dY90d880`QQ1@000`Q10a220f<<0lHH0_Nn0ooo0nmm0nLl0nLL0mkK0W__0h@@0h@`
0bU50aSS1@000`0P0`QQ0e[;0e:Z1U::0[Ff0nmm1_oo0oNn0nmm0ZDD0cWW0`Q11P000`Q11DY90jee
0nmm6?oo000Gool3Nll3eYX2oml3ool3ic`3S743U983<JH2244300034:836><3Ljh3Lhh3cWT2oml3
ool3oml3mih3[GD3BTT2@PP32646000324434882H``3aQP3mkh3ool3kgd3ic`2ia`3g]/3Nnl3Q103
Q303:DD26><6000302032643F//3DZX5DXX3]KH3kgd6ool2mkh3kgd3YA@3>NL3244500032446BTT3
[GD3kgd8ool3Nll2eYX3oml3ool3ic`3S743U982<JH3244300034:836><3Ljh2Lhh3cWT3oml3ool3
oml3mih2[GD3BTT3@PP32646000324424883H``3aQP3mkh3ool3kgd2ic`3ia`3g]/3Nnl3Q103Q302
:DD36><6000302032642F//3DZX6DXX3]KH3kgd5ool3mkh3kgd3YA@3>NL3244500032446BTT3[GD2
kgd9ool2Nll3eYX3oml3ool3ic`3S742U983<JH3244300034:836><2Ljh3Lhh3cWT3oml3ool3oml2
mih3[GD3BTT3@PP32645000324434883H``3aQP3mkh3ool2kgd3ic`3ia`3g]/3Nnl3Q102Q303:DD3
6><6000302022643F//3DZX6DXX3]KH2kgd6ool3mkh3kgd3YA@2>NL3244600032446BTT2[GD3kgd8
ool3Nll3eYX3oml3ool2ic`3S743U983<JH3244300024:836><3Ljh3Lhh3cWT3oml3ool2oml3mih3
[GD3BTT3@PP32645000324434883H``3aQP2mkh3ool3kgd3ic`3ia`3g]/2Nnl3Q103Q303:DD36><5
000302032643F//3DZX6DXX2]KH3kgd6ool3mkh3kgd2YA@3>NL3244600032445BTT3[GD3kgdHool0
01Ooo`=kc`?FVP;og`?oo`?W?0><L@>DTP<aYP88@@<000<@XP<Hh`=c[P=cSP?>N@;og`?oo`?og`?g
WP>]M@=:B@9220<8H@H000<8@@<@PP9S30?660?g_P?oo`?_O@?W?0;W70?Nf`=kk`>440>4<0<YA@8H
h`H000<080<8H@=Jb`=BZPEBRP>e]P?_O@Koo`;g_P?_O@>U50<ii`<8@@D000<8@@I:B@>]M@?_O@So
o`=kc`;FVP?og`?oo`?W?0><L@>DTP8aYP<8@@<000<@XP<Hh`=c[P9cSP?>N@?og`?oo`?og`?gWP:]
M@=:B@=220<8H@H000<8@@8@PP=S30?660?g_P?oo`?_O@;W?0?W70?Nf`=kk`>440>4<08YA@<Hh`H0
00<080<8H@9Jb`=BZPIBRP>e]P?_O@Goo`?g_P?_O@>U50<ii`<8@@D000<8@@I:B@>]M@;_O@Woo`9k
c`?FVP?og`?oo`?W?0><L@:DTP<aYP<8@@<000<@XP<Hh`9c[P=cSP?>N@?og`?oo`?og`;gWP>]M@=:
B@=220<8H@D000<8@@<@PP=S30?660?g_P?oo`;_O@?W?0?W70?Nf`=kk`>440:4<0<YA@<Hh`H000<0
8088H@=Jb`=BZPIBRP>e]P;_O@Koo`?g_P?_O@>U508ii`<8@@H000<8@@I:B@:]M@?_O@Soo`=kc`?F
VP?og`?oo`;W?0><L@>DTP<aYP<8@@<0008@XP<Hh`=c[P=cSP?>N@?og`?oo`;og`?gWP>]M@=:B@=2
20<8H@D000<8@@<@PP=S30?660;g_P?oo`?_O@?W?0?W70?Nf`9kk`>440>4<0<YA@<Hh`D000<080<8
H@=Jb`=BZPIBRP:e]P?_O@Koo`?g_P?_O@:U50<ii`<8@@H000<8@@E:B@>]M@?_OASoo`005ooo0g_?
0mJJ0_oO0ooo0nLl0haa0iBB0c6V0PQ10`000a2R0aSS0g>^0g>>0lii0_oO0ooo0ooO0oNN0jee0dY9
0T880`QQ1P000`Q10a220V<<0lHH0oNn0ooo0nmm0nLl0^LL0mkK0g__0h@@0h@`0bU50QSS1P000`0P
0`QQ0e[;0e:Z1E::0kFf0nmm1_oo0_Nn0nmm0jDD0cWW0`Q11@000`Q11TY90jee0nmm2?oo0g_?0]JJ
0ooO0ooo0nLl0haa0iBB0S6V0`Q10`000a2R0aSS0g>^0W>>0lii0ooO0ooo0ooO0oNN0Zee0dY90d88
0`QQ1P000`Q10Q220f<<0lHH0oNn0ooo0nmm0^Ll0nLL0mkK0g__0h@@0h@`0RU50aSS1P000`0P0`QQ
0U[;0e:Z1U::0kFf0nmm1Ooo0oNn0nmm0jDD0cWW0`Q11@000`Q11TY90jee0^mm2Ooo0W_?0mJJ0ooO
0ooo0nLl0haa0YBB0c6V0`Q10`000a2R0aSS0W>^0g>>0lii0ooO0ooo0ooO0_NN0jee0dY90d880`QQ
1@000`Q10a220f<<0lHH0oNn0ooo0^mm0nLl0nLL0mkK0g__0h@@0X@`0bU50aSS1P000`0P0PQQ0e[;
0e:Z1U::0kFf0^mm1_oo0oNn0nmm0jDD0SWW0`Q11P000`Q11TY90Zee0nmm2?oo0g_?0mJJ0ooO0ooo
0^Ll0haa0iBB0c6V0`Q10`000Q2R0aSS0g>^0g>>0lii0ooO0ooo0_oO0oNN0jee0dY90d880`QQ1@00
0`Q10a220f<<0lHH0_Nn0ooo0nmm0nLl0nLL0mkK0W__0h@@0h@`0bU50aSS1@000`0P0`QQ0e[;0e:Z
1U::0[Ff0nmm1_oo0oNn0nmm0ZDD0cWW0`Q11P000`Q11DY90jee0nmm6?oo000Gool3Nll3eYX2oml3
ool3ic`3S743U983<JH2244300034:836><3Ljh3Lhh3cWT2oml3ool3oml3mih3[GD3BTT2@PP32646
000324434882H``3aQP3mkh3ool3kgd3ic`2ia`3g]/3Nnl3Q103Q303:DD26><6000302032643F//3
DZX5DXX3]KH3kgd6ool2mkh3kgd3YA@3>NL3244500032446BTT3[GD3kgd8ool3Nll2eYX3oml3ool3
ic`3S743U982<JH3244300034:836><3Ljh2Lhh3cWT3oml3ool3oml3mih2[GD3BTT3@PP326460003
24424883H``3aQP3mkh3ool3kgd2ic`3ia`3g]/3Nnl3Q103Q302:DD36><6000302032642F//3DZX6
DXX3]KH3kgd5ool3mkh3kgd3YA@3>NL3244500032446BTT3[GD2kgd9ool2Nll3eYX3oml3ool3ic`3
S742U983<JH3244300034:836><2Ljh3Lhh3cWT3oml3ool3oml2mih3[GD3BTT3@PP3264500032443
4883H``3aQP3mkh3ool2kgd3ic`3ia`3g]/3Nnl3Q102Q303:DD36><6000302022643F//3DZX6DXX3
]KH2kgd6ool3mkh3kgd3YA@2>NL3244600032446BTT2[GD3kgd8ool3Nll3eYX3oml3ool2ic`3S743
U983<JH3244300024:836><3Ljh3Lhh3cWT3oml3ool2oml3mih3[GD3BTT3@PP32645000324434883
H``3aQP2mkh3ool3kgd3ic`3ia`3g]/2Nnl3Q103Q303:DD36><5000302032643F//3DZX6DXX2]KH3
kgd6ool3mkh3kgd2YA@3>NL3244600032445BTT3[GD3kgdHool001Ooo`=kc`?FVP;og`?oo`?W?0><
L@>DTP<aYP88@@<000<@XP<Hh`=c[P=cSP?>N@;og`?oo`?og`?gWP>]M@=:B@9220<8H@H000<8@@<@
PP9S30?660?g_P?oo`?_O@?W?0;W70?Nf`=kk`>440>4<0<YA@8Hh`H000<080<8H@=Jb`=BZPEBRP>e
]P?_O@Koo`;g_P?_O@>U50<ii`<8@@D000<8@@I:B@>]M@?_O@Soo`=kc`;FVP?og`?oo`?W?0><L@>D
TP8aYP<8@@<000<@XP<Hh`=c[P9cSP?>N@?og`?oo`?og`?gWP:]M@=:B@=220<8H@H000<8@@8@PP=S
30?660?g_P?oo`?_O@;W?0?W70?Nf`=kk`>440>4<08YA@<Hh`H000<080<8H@9Jb`=BZPIBRP>e]P?_
O@Goo`?g_P?_O@>U50<ii`<8@@D000<8@@I:B@>]M@;_O@Woo`9kc`?FVP?og`?oo`?W?0><L@:DTP<a
YP<8@@<000<@XP<Hh`9c[P=cSP?>N@?og`?oo`?og`;gWP>]M@=:B@=220<8H@D000<8@@<@PP=S30?6
60?g_P?oo`;_O@?W?0?W70?Nf`=kk`>440:4<0<YA@<Hh`H000<08088H@=Jb`=BZPIBRP>e]P;_O@Ko
o`?g_P?_O@>U508ii`<8@@H000<8@@I:B@:]M@?_O@Soo`=kc`?FVP?og`?oo`;W?0><L@>DTP<aYP<8
@@<0008@XP<Hh`=c[P=cSP?>N@?og`?oo`;og`?gWP>]M@=:B@=220<8H@D000<8@@<@PP=S30?660;g
_P?oo`?_O@?W?0?W70?Nf`9kk`>440>4<0<YA@<Hh`D000<080<8H@=Jb`=BZPIBRP:e]P?_O@Koo`?g
_P?_O@:U50<ii`<8@@H000<8@@E:B@>]M@?_OASoo`005ooo0g_?0mJJ0_oO0ooo0nLl0haa0iBB0c6V
0PQ10`000a2R0aSS0g>^0g>>0lii0_oO0ooo0ooO0oNN0jee0dY90T880`QQ1P000`Q10a220V<<0lHH
0oNn0ooo0nmm0nLl0^LL0mkK0g__0h@@0h@`0bU50QSS1P000`0P0`QQ0e[;0e:Z1E::0kFf0nmm1_oo
0_Nn0nmm0jDD0cWW0`Q11@000`Q11TY90jee0nmm2?oo0g_?0]JJ0ooO0ooo0nLl0haa0iBB0S6V0`Q1
0`000a2R0aSS0g>^0W>>0lii0ooO0ooo0ooO0oNN0Zee0dY90d880`QQ1P000`Q10Q220f<<0lHH0oNn
0ooo0nmm0^Ll0nLL0mkK0g__0h@@0h@`0RU50aSS1P000`0P0`QQ0U[;0e:Z1U::0kFf0nmm1Ooo0oNn
0nmm0jDD0cWW0`Q11@000`Q11TY90jee0^mm2Ooo0W_?0mJJ0ooO0ooo0nLl0haa0YBB0c6V0`Q10`00
0a2R0aSS0W>^0g>>0lii0ooO0ooo0ooO0_NN0jee0dY90d880`QQ1@000`Q10a220f<<0lHH0oNn0ooo
0^mm0nLl0nLL0mkK0g__0h@@0X@`0bU50aSS1P000`0P0PQQ0e[;0e:Z1U::0kFf0^mm1_oo0oNn0nmm
0jDD0SWW0`Q11P000`Q11TY90Zee0nmm2?oo0g_?0mJJ0ooO0ooo0^Ll0haa0iBB0c6V0`Q10`000Q2R
0aSS0g>^0g>>0lii0ooO0ooo0_oO0oNN0jee0dY90d880`QQ1@000`Q10a220f<<0lHH0_Nn0ooo0nmm
0nLl0nLL0mkK0W__0h@@0h@`0bU50aSS1@000`0P0`QQ0e[;0e:Z1U::0[Ff0nmm1_oo0oNn0nmm0ZDD
0cWW0`Q11P000`Q11DY90jee0nmm6?oo000Gool3Nll3eYX2oml3ool3ic`3S743U983<JH224430003
4:836><3Ljh3Lhh3cWT2oml3ool3oml3mih3[GD3BTT2@PP32646000324434882H``3aQP3mkh3ool3
kgd3ic`2ia`3g]/3Nnl3Q103Q303:DD26><6000302032643F//3DZX5DXX3]KH3kgd6ool2mkh3kgd3
YA@3>NL3244500032446BTT3[GD3kgd8ool3Nll2eYX3oml3ool3ic`3S743U982<JH3244300034:83
6><3Ljh2Lhh3cWT3oml3ool3oml3mih2[GD3BTT3@PP32646000324424883H``3aQP3mkh3ool3kgd2
ic`3ia`3g]/3Nnl3Q103Q302:DD36><6000302032642F//3DZX6DXX3]KH3kgd5ool3mkh3kgd3YA@3
>NL3244500032446BTT3[GD2kgd9ool2Nll3eYX3oml3ool3ic`3S742U983<JH3244300034:836><2
Ljh3Lhh3cWT3oml3ool3oml2mih3[GD3BTT3@PP32645000324434883H``3aQP3mkh3ool2kgd3ic`3
ia`3g]/3Nnl3Q102Q303:DD36><6000302022643F//3DZX6DXX3]KH2kgd6ool3mkh3kgd3YA@2>NL3
244600032446BTT2[GD3kgd8ool3Nll3eYX3oml3ool2ic`3S743U983<JH3244300024:836><3Ljh3
Lhh3cWT3oml3ool2oml3mih3[GD3BTT3@PP32645000324434883H``3aQP2mkh3ool3kgd3ic`3ia`3
g]/2Nnl3Q103Q303:DD36><5000302032643F//3DZX6DXX2]KH3kgd6ool3mkh3kgd2YA@3>NL32446
00032445BTT3[GD3kgdHool001Ooo`=kc`?FVP;og`?oo`?W?0><L@>DTP<aYP88@@<000<@XP<Hh`=c
[P=cSP?>N@;og`?oo`?og`?gWP>]M@=:B@9220<8H@H000<8@@<@PP9S30?660?g_P?oo`?_O@?W?0;W
70?Nf`=kk`>440>4<0<YA@8Hh`H000<080<8H@=Jb`=BZPEBRP>e]P?_O@Koo`;g_P?_O@>U50<ii`<8
@@D000<8@@I:B@>]M@?_O@Soo`=kc`;FVP?og`?oo`?W?0><L@>DTP8aYP<8@@<000<@XP<Hh`=c[P9c
SP?>N@?og`?oo`?og`?gWP:]M@=:B@=220<8H@H000<8@@8@PP=S30?660?g_P?oo`?_O@;W?0?W70?N
f`=kk`>440>4<08YA@<Hh`H000<080<8H@9Jb`=BZPIBRP>e]P?_O@Goo`?g_P?_O@>U50<ii`<8@@D0
00<8@@I:B@>]M@;_O@Woo`9kc`?FVP?og`?oo`?W?0><L@:DTP<aYP<8@@<000<@XP<Hh`9c[P=cSP?>
N@?og`?oo`?og`;gWP>]M@=:B@=220<8H@D000<8@@<@PP=S30?660?g_P?oo`;_O@?W?0?W70?Nf`=k
k`>440:4<0<YA@<Hh`H000<08088H@=Jb`=BZPIBRP>e]P;_O@Koo`?g_P?_O@>U508ii`<8@@H000<8
@@I:B@:]M@?_O@Soo`=kc`?FVP?og`?oo`;W?0><L@>DTP<aYP<8@@<0008@XP<Hh`=c[P=cSP?>N@?o
g`?oo`;og`?gWP>]M@=:B@=220<8H@D000<8@@<@PP=S30?660;g_P?oo`?_O@?W?0?W70?Nf`9kk`>4
40>4<0<YA@<Hh`D000<080<8H@=Jb`=BZPIBRP:e]P?_O@Koo`?g_P?_O@:U50<ii`<8@@H000<8@@E:
B@>]M@?_OASoo`005ooo0g_?0mJJ0_oO0ooo0nLl0haa0iBB0c6V0PQ10`000a2R0aSS0g>^0g>>0lii
0_oO0ooo0ooO0oNN0jee0dY90T880`QQ1P000`Q10a220V<<0lHH0oNn0ooo0nmm0nLl0^LL0mkK0g__
0h@@0h@`0bU50QSS1P000`0P0`QQ0e[;0e:Z1E::0kFf0nmm1_oo0_Nn0nmm0jDD0cWW0`Q11@000`Q1
1TY90jee0nmm2?oo0g_?0]JJ0ooO0ooo0nLl0haa0iBB0S6V0`Q10`000a2R0aSS0g>^0W>>0lii0ooO
0ooo0ooO0oNN0Zee0dY90d880`QQ1P000`Q10Q220f<<0lHH0oNn0ooo0nmm0^Ll0nLL0mkK0g__0h@@
0h@`0RU50aSS1P000`0P0`QQ0U[;0e:Z1U::0kFf0nmm1Ooo0oNn0nmm0jDD0cWW0`Q11@000`Q11TY9
0jee0^mm2Ooo0W_?0mJJ0ooO0ooo0nLl0haa0YBB0c6V0`Q10`000a2R0aSS0W>^0g>>0lii0ooO0ooo
0ooO0_NN0jee0dY90d880`QQ1@000`Q10a220f<<0lHH0oNn0ooo0^mm0nLl0nLL0mkK0g__0h@@0X@`
0bU50aSS1P000`0P0PQQ0e[;0e:Z1U::0kFf0^mm1_oo0oNn0nmm0jDD0SWW0`Q11P000`Q11TY90Zee
0nmm2?oo0g_?0mJJ0ooO0ooo0^Ll0haa0iBB0c6V0`Q10`000Q2R0aSS0g>^0g>>0lii0ooO0ooo0_oO
0oNN0jee0dY90d880`QQ1@000`Q10a220f<<0lHH0_Nn0ooo0nmm0nLl0nLL0mkK0W__0h@@0h@`0bU5
0aSS1@000`0P0`QQ0e[;0e:Z1U::0[Ff0nmm1_oo0oNn0nmm0ZDD0cWW0`Q11P000`Q11DY90jee0nmm
6?oo000Gool3Nll3eYX2oml3ool3ic`3S743U983<JH2244300034:836><3Ljh3Lhh3cWT2oml3ool3
oml3mih3[GD3BTT2@PP32646000324434882H``3aQP3mkh3ool3kgd3ic`2ia`3g]/3Nnl3Q103Q303
:DD26><6000302032643F//3DZX5DXX3]KH3kgd6ool2mkh3kgd3YA@3>NL3244500032446BTT3[GD3
kgd8ool3Nll2eYX3oml3ool3ic`3S743U982<JH3244300034:836><3Ljh2Lhh3cWT3oml3ool3oml3
mih2[GD3BTT3@PP32646000324424883H``3aQP3mkh3ool3kgd2ic`3ia`3g]/3Nnl3Q103Q302:DD3
6><6000302032642F//3DZX6DXX3]KH3kgd5ool3mkh3kgd3YA@3>NL3244500032446BTT3[GD2kgd9
ool2Nll3eYX3oml3ool3ic`3S742U983<JH3244300034:836><2Ljh3Lhh3cWT3oml3ool3oml2mih3
[GD3BTT3@PP32645000324434883H``3aQP3mkh3ool2kgd3ic`3ia`3g]/3Nnl3Q102Q303:DD36><6
000302022643F//3DZX6DXX3]KH2kgd6ool3mkh3kgd3YA@2>NL3244600032446BTT2[GD3kgd8ool3
Nll3eYX3oml3ool2ic`3S743U983<JH3244300024:836><3Ljh3Lhh3cWT3oml3ool2oml3mih3[GD3
BTT3@PP32645000324434883H``3aQP2mkh3ool3kgd3ic`3ia`3g]/2Nnl3Q103Q303:DD36><50003
02032643F//3DZX6DXX2]KH3kgd6ool3mkh3kgd2YA@3>NL3244600032445BTT3[GD3kgdHool001[o
o`?gWP:]M@=:B@<@PP<000<8H@<@XP9S;0=S30?660?g_PKoo`?>F@9[C@<Hh`<000<080<8H@<@XP8H
``=cSP?>N@?og`?oo`?og`;gWP>]M@=:B@=220<ia`<8@@8000<@XP<H``<Q10=kc`?FVP;W70Koo`?o
g`?gWP?_G@?W70;Nn`?Nf`?F^PKFVP=[K@EcSP<Q10<@PPH0008YI@<aQPJDTP?W70?gWP_oo`;gWP>]
M@=:B@<@PP<000<8H@8@XP=S;0=S30?660?g_PGoo`?>F@=[C@<Hh`<000<08088H@<@XP<H``=cSP?>
N@?og`?oo`;og`?gWP>]M@=:B@=220<ia`88@@<000<@XP<H``<Q10=kc`;FVP?W70Koo`?og`?gWP;_
G@?W70?Nn`?Nf`?F^PKFVP9[K@IcSP<Q10<@PPD000<YI@<aQPJDTP?W70;gWP_oo`?gWP>]M@=:B@<@
PP<00088H@<@XP=S;0=S30?660?g_PGoo`?>F@=[C@<Hh`<0008080<8H@<@XP<H``=cSP?>N@;og`?o
o`?og`?gWP>]M@=:B@=2208ia`<8@@<000<@XP<H``<Q109kc`?FVP?W70Koo`?og`;gWP?_G@?W70?N
n`?Nf`?F^PGFVP=[K@IcSP<Q108@PPH000<YI@<aQPJDTP;W70?gWP_oo`?gWP>]M@=:B@8@PP<000<8
H@<@XP=S;0=S30;660?g_PKoo`?>F@=[C@<Hh`8000<080<8H@<@XP<H``=cSP;>N@?og`?oo`?og`?g
WP>]M@9:B@=220<ia`<8@@<000<@XP8H``<Q10=kc`?FVP?W70Goo`?og`?gWP?_G@?W70?Nn`?Nf`;F
^PKFVP=[K@IcSP8Q10<@PPH000<YI@<aQPFDTP?W70?gWQSoo`006_oo0oNN0Zee0dY90a220`000`QQ
0a2R0V</0f<<0lHH0oNn1_oo0liI0V]=0aSS0`000`0P0`QQ0a2R0QS30g>>0lii0ooO0ooo0ooO0_NN
0jee0dY90d880cW70`Q10P000a2R0aS30b440g_?0mJJ0^LL1_oo0ooO0oNN0nmM0nLL0]kk0mkK0mJj
1]JJ0f]]1G>>0b440a221P000RUU0c661YBB0nLL0oNN2ooo0_NN0jee0dY90a220`000`QQ0Q2R0f</
0f<<0lHH0oNn1Ooo0liI0f]=0aSS0`000`0P0PQQ0a2R0aS30g>>0lii0ooO0ooo0_oO0oNN0jee0dY9
0d880cW70PQ10`000a2R0aS30b440g_?0]JJ0nLL1_oo0ooO0oNN0^mM0nLL0mkk0mkK0mJj1]JJ0V]]
1W>>0b440a221@000bUU0c661YBB0nLL0_NN2ooo0oNN0jee0dY90a220`000PQQ0a2R0f</0f<<0lHH
0oNn1Ooo0liI0f]=0aSS0`000P0P0`QQ0a2R0aS30g>>0lii0_oO0ooo0ooO0oNN0jee0dY90d880SW7
0`Q10`000a2R0aS30b440W_?0mJJ0nLL1_oo0ooO0_NN0nmM0nLL0mkk0mkK0mJj1MJJ0f]]1W>>0b44
0Q221P000bUU0c661YBB0^LL0oNN2ooo0oNN0jee0dY90Q220`000`QQ0a2R0f</0f<<0/HH0oNn1_oo
0liI0f]=0aSS0P000`0P0`QQ0a2R0aS30g>>0/ii0ooO0ooo0ooO0oNN0jee0TY90d880cW70`Q10`00
0a2R0QS30b440g_?0mJJ0nLL1Ooo0ooO0oNN0nmM0nLL0mkk0mkK0]Jj1]JJ0f]]1W>>0R440a221P00
0bUU0c661IBB0nLL0oNN6?oo000Jool3mih2[GD3BTT34883000326434:82Hb`3H``3aQP3mkh6ool3
cUT2Jdd36><30003020326434:826<<3Lhh3cWT3oml3ool3oml2mih3[GD3BTT3@PP3>LL324420003
4:836<<38@@3Nll3eYX2ia`6ool3oml3mih3ked3ia`2g_/3g]/3e[X6eYX3Jfd5Lhh38@@348860002
:FD3<HH6U983ia`3mih;ool2mih3[GD3BTT34883000326424:83Hb`3H``3aQP3mkh5ool3cUT3Jdd3
6><30003020226434:836<<3Lhh3cWT3oml3ool2oml3mih3[GD3BTT3@PP3>LL2244300034:836<<3
8@@3Nll2eYX3ia`6ool3oml3mih2ked3ia`3g_/3g]/3e[X6eYX2Jfd6Lhh38@@348850003:FD3<HH6
U983ia`2mih;ool3mih3[GD3BTT34883000226434:83Hb`3H``3aQP3mkh5ool3cUT3Jdd36><30002
020326434:836<<3Lhh3cWT2oml3ool3oml3mih3[GD3BTT3@PP2>LL3244300034:836<<38@@2Nll3
eYX3ia`6ool3oml2mih3ked3ia`3g_/3g]/3e[X5eYX3Jfd6Lhh38@@248860003:FD3<HH6U982ia`3
mih;ool3mih3[GD3BTT24883000326434:83Hb`3H``2aQP3mkh6ool3cUT3Jdd36><2000302032643
4:836<<3Lhh2cWT3oml3ool3oml3mih3[GD2BTT3@PP3>LL3244300034:826<<38@@3Nll3eYX3ia`5
ool3oml3mih3ked3ia`3g_/3g]/2e[X6eYX3Jfd6Lhh28@@348860003:FD3<HH5U983ia`3mihHool0
01[oo`?gWP:]M@=:B@<@PP<000<8H@<@XP9S;0=S30?660?g_PKoo`?>F@9[C@<Hh`<000<080<8H@<@
XP8H``=cSP?>N@?og`?oo`?og`;gWP>]M@=:B@=220<ia`<8@@8000<@XP<H``<Q10=kc`?FVP;W70Ko
o`?og`?gWP?_G@?W70;Nn`?Nf`?F^PKFVP=[K@EcSP<Q10<@PPH0008YI@<aQPJDTP?W70?gWP_oo`;g
WP>]M@=:B@<@PP<000<8H@8@XP=S;0=S30?660?g_PGoo`?>F@=[C@<Hh`<000<08088H@<@XP<H``=c
SP?>N@?og`?oo`;og`?gWP>]M@=:B@=220<ia`88@@<000<@XP<H``<Q10=kc`;FVP?W70Koo`?og`?g
WP;_G@?W70?Nn`?Nf`?F^PKFVP9[K@IcSP<Q10<@PPD000<YI@<aQPJDTP?W70;gWP_oo`?gWP>]M@=:
B@<@PP<00088H@<@XP=S;0=S30?660?g_PGoo`?>F@=[C@<Hh`<0008080<8H@<@XP<H``=cSP?>N@;o
g`?oo`?og`?gWP>]M@=:B@=2208ia`<8@@<000<@XP<H``<Q109kc`?FVP?W70Koo`?og`;gWP?_G@?W
70?Nn`?Nf`?F^PGFVP=[K@IcSP<Q108@PPH000<YI@<aQPJDTP;W70?gWP_oo`?gWP>]M@=:B@8@PP<0
00<8H@<@XP=S;0=S30;660?g_PKoo`?>F@=[C@<Hh`8000<080<8H@<@XP<H``=cSP;>N@?og`?oo`?o
g`?gWP>]M@9:B@=220<ia`<8@@<000<@XP8H``<Q10=kc`?FVP?W70Goo`?og`?gWP?_G@?W70?Nn`?N
f`;F^PKFVP=[K@IcSP8Q10<@PPH000<YI@<aQPFDTP?W70?gWQSoo`006_oo0oNN0Zee0dY90a220`00
0`QQ0a2R0V</0f<<0lHH0oNn1_oo0liI0V]=0aSS0`000`0P0`QQ0a2R0QS30g>>0lii0ooO0ooo0ooO
0_NN0jee0dY90d880cW70`Q10P000a2R0aS30b440g_?0mJJ0^LL1_oo0ooO0oNN0nmM0nLL0]kk0mkK
0mJj1]JJ0f]]1G>>0b440a221P000RUU0c661YBB0nLL0oNN2ooo0_NN0jee0dY90a220`000`QQ0Q2R
0f</0f<<0lHH0oNn1Ooo0liI0f]=0aSS0`000`0P0PQQ0a2R0aS30g>>0lii0ooO0ooo0_oO0oNN0jee
0dY90d880cW70PQ10`000a2R0aS30b440g_?0]JJ0nLL1_oo0ooO0oNN0^mM0nLL0mkk0mkK0mJj1]JJ
0V]]1W>>0b440a221@000bUU0c661YBB0nLL0_NN2ooo0oNN0jee0dY90a220`000PQQ0a2R0f</0f<<
0lHH0oNn1Ooo0liI0f]=0aSS0`000P0P0`QQ0a2R0aS30g>>0lii0_oO0ooo0ooO0oNN0jee0dY90d88
0SW70`Q10`000a2R0aS30b440W_?0mJJ0nLL1_oo0ooO0_NN0nmM0nLL0mkk0mkK0mJj1MJJ0f]]1W>>
0b440Q221P000bUU0c661YBB0^LL0oNN2ooo0oNN0jee0dY90Q220`000`QQ0a2R0f</0f<<0/HH0oNn
1_oo0liI0f]=0aSS0P000`0P0`QQ0a2R0aS30g>>0/ii0ooO0ooo0ooO0oNN0jee0TY90d880cW70`Q1
0`000a2R0QS30b440g_?0mJJ0nLL1Ooo0ooO0oNN0nmM0nLL0mkk0mkK0]Jj1]JJ0f]]1W>>0R440a22
1P000bUU0c661IBB0nLL0oNN6?oo000Jool3mih2[GD3BTT34883000326434:82Hb`3H``3aQP3mkh6
ool3cUT2Jdd36><30003020326434:826<<3Lhh3cWT3oml3ool3oml2mih3[GD3BTT3@PP3>LL32442
00034:836<<38@@3Nll3eYX2ia`6ool3oml3mih3ked3ia`2g_/3g]/3e[X6eYX3Jfd5Lhh38@@34886
0002:FD3<HH6U983ia`3mih;ool2mih3[GD3BTT34883000326424:83Hb`3H``3aQP3mkh5ool3cUT3
Jdd36><30003020226434:836<<3Lhh3cWT3oml3ool2oml3mih3[GD3BTT3@PP3>LL2244300034:83
6<<38@@3Nll2eYX3ia`6ool3oml3mih2ked3ia`3g_/3g]/3e[X6eYX2Jfd6Lhh38@@348850003:FD3
<HH6U983ia`2mih;ool3mih3[GD3BTT34883000226434:83Hb`3H``3aQP3mkh5ool3cUT3Jdd36><3
0002020326434:836<<3Lhh3cWT2oml3ool3oml3mih3[GD3BTT3@PP2>LL3244300034:836<<38@@2
Nll3eYX3ia`6ool3oml2mih3ked3ia`3g_/3g]/3e[X5eYX3Jfd6Lhh38@@248860003:FD3<HH6U982
ia`3mih;ool3mih3[GD3BTT24883000326434:83Hb`3H``2aQP3mkh6ool3cUT3Jdd36><200030203
26434:836<<3Lhh2cWT3oml3ool3oml3mih3[GD2BTT3@PP3>LL3244300034:826<<38@@3Nll3eYX3
ia`5ool3oml3mih3ked3ia`3g_/3g]/2e[X6eYX3Jfd6Lhh28@@348860003:FD3<HH5U983ia`3mihH
ool001[oo`?gWP:]M@=:B@<@PP<000<8H@<@XP9S;0=S30?660?g_PKoo`?>F@9[C@<Hh`<000<080<8
H@<@XP8H``=cSP?>N@?og`?oo`?og`;gWP>]M@=:B@=220<ia`<8@@8000<@XP<H``<Q10=kc`?FVP;W
70Koo`?og`?gWP?_G@?W70;Nn`?Nf`?F^PKFVP=[K@EcSP<Q10<@PPH0008YI@<aQPJDTP?W70?gWP_o
o`;gWP>]M@=:B@<@PP<000<8H@8@XP=S;0=S30?660?g_PGoo`?>F@=[C@<Hh`<000<08088H@<@XP<H
``=cSP?>N@?og`?oo`;og`?gWP>]M@=:B@=220<ia`88@@<000<@XP<H``<Q10=kc`;FVP?W70Koo`?o
g`?gWP;_G@?W70?Nn`?Nf`?F^PKFVP9[K@IcSP<Q10<@PPD000<YI@<aQPJDTP?W70;gWP_oo`?gWP>]
M@=:B@<@PP<00088H@<@XP=S;0=S30?660?g_PGoo`?>F@=[C@<Hh`<0008080<8H@<@XP<H``=cSP?>
N@;og`?oo`?og`?gWP>]M@=:B@=2208ia`<8@@<000<@XP<H``<Q109kc`?FVP?W70Koo`?og`;gWP?_
G@?W70?Nn`?Nf`?F^PGFVP=[K@IcSP<Q108@PPH000<YI@<aQPJDTP;W70?gWP_oo`?gWP>]M@=:B@8@
PP<000<8H@<@XP=S;0=S30;660?g_PKoo`?>F@=[C@<Hh`8000<080<8H@<@XP<H``=cSP;>N@?og`?o
o`?og`?gWP>]M@9:B@=220<ia`<8@@<000<@XP8H``<Q10=kc`?FVP?W70Goo`?og`?gWP?_G@?W70?N
n`?Nf`;F^PKFVP=[K@IcSP8Q10<@PPH000<YI@<aQPFDTP?W70?gWQSoo`006_oo0oNN0Zee0dY90a22
0`000`QQ0a2R0V</0f<<0lHH0oNn1_oo0liI0V]=0aSS0`000`0P0`QQ0a2R0QS30g>>0lii0ooO0ooo
0ooO0_NN0jee0dY90d880cW70`Q10P000a2R0aS30b440g_?0mJJ0^LL1_oo0ooO0oNN0nmM0nLL0]kk
0mkK0mJj1]JJ0f]]1G>>0b440a221P000RUU0c661YBB0nLL0oNN2ooo0_NN0jee0dY90a220`000`QQ
0Q2R0f</0f<<0lHH0oNn1Ooo0liI0f]=0aSS0`000`0P0PQQ0a2R0aS30g>>0lii0ooO0ooo0_oO0oNN
0jee0dY90d880cW70PQ10`000a2R0aS30b440g_?0]JJ0nLL1_oo0ooO0oNN0^mM0nLL0mkk0mkK0mJj
1]JJ0V]]1W>>0b440a221@000bUU0c661YBB0nLL0_NN2ooo0oNN0jee0dY90a220`000PQQ0a2R0f</
0f<<0lHH0oNn1Ooo0liI0f]=0aSS0`000P0P0`QQ0a2R0aS30g>>0lii0_oO0ooo0ooO0oNN0jee0dY9
0d880SW70`Q10`000a2R0aS30b440W_?0mJJ0nLL1_oo0ooO0_NN0nmM0nLL0mkk0mkK0mJj1MJJ0f]]
1W>>0b440Q221P000bUU0c661YBB0^LL0oNN2ooo0oNN0jee0dY90Q220`000`QQ0a2R0f</0f<<0/HH
0oNn1_oo0liI0f]=0aSS0P000`0P0`QQ0a2R0aS30g>>0/ii0ooO0ooo0ooO0oNN0jee0TY90d880cW7
0`Q10`000a2R0QS30b440g_?0mJJ0nLL1Ooo0ooO0oNN0nmM0nLL0mkk0mkK0]Jj1]JJ0f]]1W>>0R44
0a221P000bUU0c661IBB0nLL0oNN6?oo000Jool3mih2[GD3BTT34883000326434:82Hb`3H``3aQP3
mkh6ool3cUT2Jdd36><30003020326434:826<<3Lhh3cWT3oml3ool3oml2mih3[GD3BTT3@PP3>LL3
244200034:836<<38@@3Nll3eYX2ia`6ool3oml3mih3ked3ia`2g_/3g]/3e[X6eYX3Jfd5Lhh38@@3
48860002:FD3<HH6U983ia`3mih;ool2mih3[GD3BTT34883000326424:83Hb`3H``3aQP3mkh5ool3
cUT3Jdd36><30003020226434:836<<3Lhh3cWT3oml3ool2oml3mih3[GD3BTT3@PP3>LL224430003
4:836<<38@@3Nll2eYX3ia`6ool3oml3mih2ked3ia`3g_/3g]/3e[X6eYX2Jfd6Lhh38@@348850003
:FD3<HH6U983ia`2mih;ool3mih3[GD3BTT34883000226434:83Hb`3H``3aQP3mkh5ool3cUT3Jdd3
6><30002020326434:836<<3Lhh3cWT2oml3ool3oml3mih3[GD3BTT3@PP2>LL3244300034:836<<3
8@@2Nll3eYX3ia`6ool3oml2mih3ked3ia`3g_/3g]/3e[X5eYX3Jfd6Lhh38@@248860003:FD3<HH6
U982ia`3mih;ool3mih3[GD3BTT24883000326434:83Hb`3H``2aQP3mkh6ool3cUT3Jdd36><20003
020326434:836<<3Lhh2cWT3oml3ool3oml3mih3[GD2BTT3@PP3>LL3244300034:826<<38@@3Nll3
eYX3ia`5ool3oml3mih3ked3ia`3g_/3g]/2e[X6eYX3Jfd6Lhh28@@348860003:FD3<HH5U983ia`3
mihHool001[oo`?gWP:]M@=:B@<@PP<000<8H@<@XP9S;0=S30?660?g_PKoo`?>F@9[C@<Hh`<000<0
80<8H@<@XP8H``=cSP?>N@?og`?oo`?og`;gWP>]M@=:B@=220<ia`<8@@8000<@XP<H``<Q10=kc`?F
VP;W70Koo`?og`?gWP?_G@?W70;Nn`?Nf`?F^PKFVP=[K@EcSP<Q10<@PPH0008YI@<aQPJDTP?W70?g
WP_oo`;gWP>]M@=:B@<@PP<000<8H@8@XP=S;0=S30?660?g_PGoo`?>F@=[C@<Hh`<000<08088H@<@
XP<H``=cSP?>N@?og`?oo`;og`?gWP>]M@=:B@=220<ia`88@@<000<@XP<H``<Q10=kc`;FVP?W70Ko
o`?og`?gWP;_G@?W70?Nn`?Nf`?F^PKFVP9[K@IcSP<Q10<@PPD000<YI@<aQPJDTP?W70;gWP_oo`?g
WP>]M@=:B@<@PP<00088H@<@XP=S;0=S30?660?g_PGoo`?>F@=[C@<Hh`<0008080<8H@<@XP<H``=c
SP?>N@;og`?oo`?og`?gWP>]M@=:B@=2208ia`<8@@<000<@XP<H``<Q109kc`?FVP?W70Koo`?og`;g
WP?_G@?W70?Nn`?Nf`?F^PGFVP=[K@IcSP<Q108@PPH000<YI@<aQPJDTP;W70?gWP_oo`?gWP>]M@=:
B@8@PP<000<8H@<@XP=S;0=S30;660?g_PKoo`?>F@=[C@<Hh`8000<080<8H@<@XP<H``=cSP;>N@?o
g`?oo`?og`?gWP>]M@9:B@=220<ia`<8@@<000<@XP8H``<Q10=kc`?FVP?W70Goo`?og`?gWP?_G@?W
70?Nn`?Nf`;F^PKFVP=[K@IcSP8Q10<@PPH000<YI@<aQPFDTP?W70?gWQSoo`006_oo0oNN0Zee0dY9
0a220`000`QQ0a2R0V</0f<<0lHH0oNn1_oo0liI0V]=0aSS0`000`0P0`QQ0a2R0QS30g>>0lii0ooO
0ooo0ooO0_NN0jee0dY90d880cW70`Q10P000a2R0aS30b440g_?0mJJ0^LL1_oo0ooO0oNN0nmM0nLL
0]kk0mkK0mJj1]JJ0f]]1G>>0b440a221P000RUU0c661YBB0nLL0oNN2ooo0_NN0jee0dY90a220`00
0`QQ0Q2R0f</0f<<0lHH0oNn1Ooo0liI0f]=0aSS0`000`0P0PQQ0a2R0aS30g>>0lii0ooO0ooo0_oO
0oNN0jee0dY90d880cW70PQ10`000a2R0aS30b440g_?0]JJ0nLL1_oo0ooO0oNN0^mM0nLL0mkk0mkK
0mJj1]JJ0V]]1W>>0b440a221@000bUU0c661YBB0nLL0_NN2ooo0oNN0jee0dY90a220`000PQQ0a2R
0f</0f<<0lHH0oNn1Ooo0liI0f]=0aSS0`000P0P0`QQ0a2R0aS30g>>0lii0_oO0ooo0ooO0oNN0jee
0dY90d880SW70`Q10`000a2R0aS30b440W_?0mJJ0nLL1_oo0ooO0_NN0nmM0nLL0mkk0mkK0mJj1MJJ
0f]]1W>>0b440Q221P000bUU0c661YBB0^LL0oNN2ooo0oNN0jee0dY90Q220`000`QQ0a2R0f</0f<<
0/HH0oNn1_oo0liI0f]=0aSS0P000`0P0`QQ0a2R0aS30g>>0/ii0ooO0ooo0ooO0oNN0jee0TY90d88
0cW70`Q10`000a2R0QS30b440g_?0mJJ0nLL1Ooo0ooO0oNN0nmM0nLL0mkk0mkK0]Jj1]JJ0f]]1W>>
0R440a221P000bUU0c661IBB0nLL0oNN6?oo000Jool3mih2[GD3BTT34883000326434:82Hb`3H``3
aQP3mkh6ool3cUT2Jdd36><30003020326434:826<<3Lhh3cWT3oml3ool3oml2mih3[GD3BTT3@PP3
>LL3244200034:836<<38@@3Nll3eYX2ia`6ool3oml3mih3ked3ia`2g_/3g]/3e[X6eYX3Jfd5Lhh3
8@@348860002:FD3<HH6U983ia`3mih;ool2mih3[GD3BTT34883000326424:83Hb`3H``3aQP3mkh5
ool3cUT3Jdd36><30003020226434:836<<3Lhh3cWT3oml3ool2oml3mih3[GD3BTT3@PP3>LL22443
00034:836<<38@@3Nll2eYX3ia`6ool3oml3mih2ked3ia`3g_/3g]/3e[X6eYX2Jfd6Lhh38@@34885
0003:FD3<HH6U983ia`2mih;ool3mih3[GD3BTT34883000226434:83Hb`3H``3aQP3mkh5ool3cUT3
Jdd36><30002020326434:836<<3Lhh3cWT2oml3ool3oml3mih3[GD3BTT3@PP2>LL3244300034:83
6<<38@@2Nll3eYX3ia`6ool3oml2mih3ked3ia`3g_/3g]/3e[X5eYX3Jfd6Lhh38@@248860003:FD3
<HH6U982ia`3mih;ool3mih3[GD3BTT24883000326434:83Hb`3H``2aQP3mkh6ool3cUT3Jdd36><2
0003020326434:836<<3Lhh2cWT3oml3ool3oml3mih3[GD2BTT3@PP3>LL3244300034:826<<38@@3
Nll3eYX3ia`5ool3oml3mih3ked3ia`3g_/3g]/2e[X6eYX3Jfd6Lhh28@@348860003:FD3<HH5U983
ia`3mihHool001goo`;FVPK>N@K>F@=S;08Hh`H000<080<8H@<@XP<Hh`8Q10=kk`?F^P?og`?oo`?g
_P;gWP>U=0=220<8H@H000DaQP<aYPJD/P?W70Goo`?Nf`?F^P=kc`<Q908080<000<080<ii`>U50>U
=0?_G@;og`?oo`?og`?gWP?_G@?W?0:<L@<aQP<080<000<080Dii`>U50?W?0Koo`?g_Pgoo`?FVPK>
N@K>F@9S;0<Hh`H000<080<8H@8@XP<Hh`<Q10=kk`?F^P?og`;oo`?g_P?gWP>U=0=220<8H@D000Ha
QP<aYPJD/P;W70Koo`?Nf`?F^P=kc`8Q90<080<000<080<ii`>U50:U=0?_G@?og`?oo`?og`?gWP?_
G@;W?0><L@<aQP<080<000<080Dii`>U50?W?0Koo`;g_Pkoo`?FVPK>N@G>F@=S;0<Hh`H000<08088
H@<@XP<Hh`<Q10=kk`?F^P;og`?oo`?g_P?gWP>U=0=22088H@H000HaQP<aYPFD/P?W70Koo`?Nf`?F
^P9kc`<Q90<080<000<080<ii`:U50>U=0?_G@?og`?oo`?og`;gWP?_G@?W?0><L@<aQP<0808000<0
80Hii`>U50?W?0Goo`?g_Pkoo`?FVPG>N@K>F@=S;0<Hh`D000<080<8H@<@XP<Hh`<Q10=kk`;F^P?o
g`?oo`?g_P?gWP>U=09220<8H@H000HaQP8aYPJD/P?W70Koo`;Nf`?F^P=kc`<Q90<080<0008080<i
i`>U50>U=0?_G@?og`?oo`;og`?gWP?_G@?W?0><L@<aQP8080<000<080Hii`>U50;W?0Koo`?g_QSo
o`007Ooo0]JJ1/ii1/iI0f</0QSS1P000`0P0`QQ0a2R0aSS0R440g__0mJj0ooO0ooo0oNn0_NN0jDd
0d880`QQ1P001C660c6V1YBb0nLL1Ooo0mkK0mJj0g_?0b4T0P0P0`000`0P0cWW0jDD0jDd0nmM0_oO
0ooo0ooO0oNN0nmM0nLl0Xaa0c660`0P0`000`0P1CWW0jDD0nLl1_oo0oNn3Ooo0mJJ1/ii1/iI0V</
0aSS1P000`0P0`QQ0Q2R0aSS0b440g__0mJj0ooO0_oo0oNn0oNN0jDd0d880`QQ1@001S660c6V1YBb
0^LL1_oo0mkK0mJj0g_?0R4T0`0P0`000`0P0cWW0jDD0ZDd0nmM0ooO0ooo0ooO0oNN0nmM0^Ll0haa
0c660`0P0`000`0P1CWW0jDD0nLl1_oo0_Nn3_oo0mJJ1/ii1LiI0f</0aSS1P000`0P0PQQ0a2R0aSS
0b440g__0mJj0_oO0ooo0oNn0oNN0jDd0d880PQQ1P001S660c6V1IBb0nLL1_oo0mkK0mJj0W_?0b4T
0`0P0`000`0P0cWW0ZDD0jDd0nmM0ooO0ooo0ooO0_NN0nmM0nLl0haa0c660`0P0P000`0P1SWW0jDD
0nLl1Ooo0oNn3_oo0mJJ1Lii1/iI0f</0aSS1@000`0P0`QQ0a2R0aSS0b440g__0]Jj0ooO0ooo0oNn
0oNN0jDd0T880`QQ1P001S660S6V1YBb0nLL1_oo0]kK0mJj0g_?0b4T0`0P0`000P0P0cWW0jDD0jDd
0nmM0ooO0ooo0_oO0oNN0nmM0nLl0haa0c660P0P0`000`0P1SWW0jDD0^Ll1_oo0oNn6?oo000Mool2
eYX6cWT6cUT3Hb`26><60003020326434:836><28@@3Nnl3e[X3oml3ool3mkh2mih3YC@3@PP32646
0005<HH3<JH6U;83ia`5ool3g]/3e[X3Nll38B@2020300030203>NL3YA@3YC@3ked2oml3ool3oml3
mih3ked3ic`2S743<HH3020300030205>NL3YA@3ic`6ool3mkh=ool3eYX6cWT6cUT2Hb`36><60003
020326424:836><38@@3Nnl3e[X3oml2ool3mkh3mih3YC@3@PP326450006<HH3<JH6U;82ia`6ool3
g]/3e[X3Nll28B@3020300030203>NL3YA@2YC@3ked3oml3ool3oml3mih3ked2ic`3S743<HH30203
00030205>NL3YA@3ic`6ool2mkh>ool3eYX6cWT5cUT3Hb`36><60003020226434:836><38@@3Nnl3
e[X2oml3ool3mkh3mih3YC@3@PP226460006<HH3<JH5U;83ia`6ool3g]/3e[X2Nll38B@302030003
0203>NL2YA@3YC@3ked3oml3ool3oml2mih3ked3ic`3S743<HH3020200030206>NL3YA@3ic`5ool3
mkh>ool3eYX5cWT6cUT3Hb`36><50003020326434:836><38@@3Nnl2e[X3oml3ool3mkh3mih3YC@2
@PP326460006<HH2<JH6U;83ia`6ool2g]/3e[X3Nll38B@3020300020203>NL3YA@3YC@3ked3oml3
ool2oml3mih3ked3ic`3S743<HH2020300030206>NL3YA@2ic`6ool3mkhHool001goo`;FVPK>N@K>
F@=S;08Hh`H000<080<8H@<@XP<Hh`8Q10=kk`?F^P?og`?oo`?g_P;gWP>U=0=220<8H@H000DaQP<a
YPJD/P?W70Goo`?Nf`?F^P=kc`<Q908080<000<080<ii`>U50>U=0?_G@;og`?oo`?og`?gWP?_G@?W
?0:<L@<aQP<080<000<080Dii`>U50?W?0Koo`?g_Pgoo`?FVPK>N@K>F@9S;0<Hh`H000<080<8H@8@
XP<Hh`<Q10=kk`?F^P?og`;oo`?g_P?gWP>U=0=220<8H@D000HaQP<aYPJD/P;W70Koo`?Nf`?F^P=k
c`8Q90<080<000<080<ii`>U50:U=0?_G@?og`?oo`?og`?gWP?_G@;W?0><L@<aQP<080<000<080Di
i`>U50?W?0Koo`;g_Pkoo`?FVPK>N@G>F@=S;0<Hh`H000<08088H@<@XP<Hh`<Q10=kk`?F^P;og`?o
o`?g_P?gWP>U=0=22088H@H000HaQP<aYPFD/P?W70Koo`?Nf`?F^P9kc`<Q90<080<000<080<ii`:U
50>U=0?_G@?og`?oo`?og`;gWP?_G@?W?0><L@<aQP<0808000<080Hii`>U50?W?0Goo`?g_Pkoo`?F
VPG>N@K>F@=S;0<Hh`D000<080<8H@<@XP<Hh`<Q10=kk`;F^P?og`?oo`?g_P?gWP>U=09220<8H@H0
00HaQP8aYPJD/P?W70Koo`;Nf`?F^P=kc`<Q90<080<0008080<ii`>U50>U=0?_G@?og`?oo`;og`?g
WP?_G@?W?0><L@<aQP8080<000<080Hii`>U50;W?0Koo`?g_QSoo`007Ooo0]JJ1/ii1/iI0f</0QSS
1P000`0P0`QQ0a2R0aSS0R440g__0mJj0ooO0ooo0oNn0_NN0jDd0d880`QQ1P001C660c6V1YBb0nLL
1Ooo0mkK0mJj0g_?0b4T0P0P0`000`0P0cWW0jDD0jDd0nmM0_oO0ooo0ooO0oNN0nmM0nLl0Xaa0c66
0`0P0`000`0P1CWW0jDD0nLl1_oo0oNn3Ooo0mJJ1/ii1/iI0V</0aSS1P000`0P0`QQ0Q2R0aSS0b44
0g__0mJj0ooO0_oo0oNn0oNN0jDd0d880`QQ1@001S660c6V1YBb0^LL1_oo0mkK0mJj0g_?0R4T0`0P
0`000`0P0cWW0jDD0ZDd0nmM0ooO0ooo0ooO0oNN0nmM0^Ll0haa0c660`0P0`000`0P1CWW0jDD0nLl
1_oo0_Nn3_oo0mJJ1/ii1LiI0f</0aSS1P000`0P0PQQ0a2R0aSS0b440g__0mJj0_oO0ooo0oNn0oNN
0jDd0d880PQQ1P001S660c6V1IBb0nLL1_oo0mkK0mJj0W_?0b4T0`0P0`000`0P0cWW0ZDD0jDd0nmM
0ooO0ooo0ooO0_NN0nmM0nLl0haa0c660`0P0P000`0P1SWW0jDD0nLl1Ooo0oNn3_oo0mJJ1Lii1/iI
0f</0aSS1@000`0P0`QQ0a2R0aSS0b440g__0]Jj0ooO0ooo0oNn0oNN0jDd0T880`QQ1P001S660S6V
1YBb0nLL1_oo0]kK0mJj0g_?0b4T0`0P0`000P0P0cWW0jDD0jDd0nmM0ooO0ooo0_oO0oNN0nmM0nLl
0haa0c660P0P0`000`0P1SWW0jDD0^Ll1_oo0oNn6?oo000Mool2eYX6cWT6cUT3Hb`26><600030203
26434:836><28@@3Nnl3e[X3oml3ool3mkh2mih3YC@3@PP326460005<HH3<JH6U;83ia`5ool3g]/3
e[X3Nll38B@2020300030203>NL3YA@3YC@3ked2oml3ool3oml3mih3ked3ic`2S743<HH302030003
0205>NL3YA@3ic`6ool3mkh=ool3eYX6cWT6cUT2Hb`36><60003020326424:836><38@@3Nnl3e[X3
oml2ool3mkh3mih3YC@3@PP326450006<HH3<JH6U;82ia`6ool3g]/3e[X3Nll28B@3020300030203
>NL3YA@2YC@3ked3oml3ool3oml3mih3ked2ic`3S743<HH3020300030205>NL3YA@3ic`6ool2mkh>
ool3eYX6cWT5cUT3Hb`36><60003020226434:836><38@@3Nnl3e[X2oml3ool3mkh3mih3YC@3@PP2
26460006<HH3<JH5U;83ia`6ool3g]/3e[X2Nll38B@3020300030203>NL2YA@3YC@3ked3oml3ool3
oml2mih3ked3ic`3S743<HH3020200030206>NL3YA@3ic`5ool3mkh>ool3eYX5cWT6cUT3Hb`36><5
0003020326434:836><38@@3Nnl2e[X3oml3ool3mkh3mih3YC@2@PP326460006<HH2<JH6U;83ia`6
ool2g]/3e[X3Nll38B@3020300020203>NL3YA@3YC@3ked3oml3ool2oml3mih3ked3ic`3S743<HH2
020300030206>NL3YA@2ic`6ool3mkhHool001goo`;FVPK>N@K>F@=S;08Hh`H000<080<8H@<@XP<H
h`8Q10=kk`?F^P?og`?oo`?g_P;gWP>U=0=220<8H@H000DaQP<aYPJD/P?W70Goo`?Nf`?F^P=kc`<Q
908080<000<080<ii`>U50>U=0?_G@;og`?oo`?og`?gWP?_G@?W?0:<L@<aQP<080<000<080Dii`>U
50?W?0Koo`?g_Pgoo`?FVPK>N@K>F@9S;0<Hh`H000<080<8H@8@XP<Hh`<Q10=kk`?F^P?og`;oo`?g
_P?gWP>U=0=220<8H@D000HaQP<aYPJD/P;W70Koo`?Nf`?F^P=kc`8Q90<080<000<080<ii`>U50:U
=0?_G@?og`?oo`?og`?gWP?_G@;W?0><L@<aQP<080<000<080Dii`>U50?W?0Koo`;g_Pkoo`?FVPK>
N@G>F@=S;0<Hh`H000<08088H@<@XP<Hh`<Q10=kk`?F^P;og`?oo`?g_P?gWP>U=0=22088H@H000Ha
QP<aYPFD/P?W70Koo`?Nf`?F^P9kc`<Q90<080<000<080<ii`:U50>U=0?_G@?og`?oo`?og`;gWP?_
G@?W?0><L@<aQP<0808000<080Hii`>U50?W?0Goo`?g_Pkoo`?FVPG>N@K>F@=S;0<Hh`D000<080<8
H@<@XP<Hh`<Q10=kk`;F^P?og`?oo`?g_P?gWP>U=09220<8H@H000HaQP8aYPJD/P?W70Koo`;Nf`?F
^P=kc`<Q90<080<0008080<ii`>U50>U=0?_G@?og`?oo`;og`?gWP?_G@?W?0><L@<aQP8080<000<0
80Hii`>U50;W?0Koo`?g_QSoo`007Ooo0]JJ1/ii1/iI0f</0QSS1P000`0P0`QQ0a2R0aSS0R440g__
0mJj0ooO0ooo0oNn0_NN0jDd0d880`QQ1P001C660c6V1YBb0nLL1Ooo0mkK0mJj0g_?0b4T0P0P0`00
0`0P0cWW0jDD0jDd0nmM0_oO0ooo0ooO0oNN0nmM0nLl0Xaa0c660`0P0`000`0P1CWW0jDD0nLl1_oo
0oNn3Ooo0mJJ1/ii1/iI0V</0aSS1P000`0P0`QQ0Q2R0aSS0b440g__0mJj0ooO0_oo0oNn0oNN0jDd
0d880`QQ1@001S660c6V1YBb0^LL1_oo0mkK0mJj0g_?0R4T0`0P0`000`0P0cWW0jDD0ZDd0nmM0ooO
0ooo0ooO0oNN0nmM0^Ll0haa0c660`0P0`000`0P1CWW0jDD0nLl1_oo0_Nn3_oo0mJJ1/ii1LiI0f</
0aSS1P000`0P0PQQ0a2R0aSS0b440g__0mJj0_oO0ooo0oNn0oNN0jDd0d880PQQ1P001S660c6V1IBb
0nLL1_oo0mkK0mJj0W_?0b4T0`0P0`000`0P0cWW0ZDD0jDd0nmM0ooO0ooo0ooO0_NN0nmM0nLl0haa
0c660`0P0P000`0P1SWW0jDD0nLl1Ooo0oNn3_oo0mJJ1Lii1/iI0f</0aSS1@000`0P0`QQ0a2R0aSS
0b440g__0]Jj0ooO0ooo0oNn0oNN0jDd0T880`QQ1P001S660S6V1YBb0nLL1_oo0]kK0mJj0g_?0b4T
0`0P0`000P0P0cWW0jDD0jDd0nmM0ooO0ooo0_oO0oNN0nmM0nLl0haa0c660P0P0`000`0P1SWW0jDD
0^Ll1_oo0oNn6?oo000Mool2eYX6cWT6cUT3Hb`26><60003020326434:836><28@@3Nnl3e[X3oml3
ool3mkh2mih3YC@3@PP326460005<HH3<JH6U;83ia`5ool3g]/3e[X3Nll38B@2020300030203>NL3
YA@3YC@3ked2oml3ool3oml3mih3ked3ic`2S743<HH3020300030205>NL3YA@3ic`6ool3mkh=ool3
eYX6cWT6cUT2Hb`36><60003020326424:836><38@@3Nnl3e[X3oml2ool3mkh3mih3YC@3@PP32645
0006<HH3<JH6U;82ia`6ool3g]/3e[X3Nll28B@3020300030203>NL3YA@2YC@3ked3oml3ool3oml3
mih3ked2ic`3S743<HH3020300030205>NL3YA@3ic`6ool2mkh>ool3eYX6cWT5cUT3Hb`36><60003
020226434:836><38@@3Nnl3e[X2oml3ool3mkh3mih3YC@3@PP226460006<HH3<JH5U;83ia`6ool3
g]/3e[X2Nll38B@3020300030203>NL2YA@3YC@3ked3oml3ool3oml2mih3ked3ic`3S743<HH30202
00030206>NL3YA@3ic`5ool3mkh>ool3eYX5cWT6cUT3Hb`36><50003020326434:836><38@@3Nnl2
e[X3oml3ool3mkh3mih3YC@2@PP326460006<HH2<JH6U;83ia`6ool2g]/3e[X3Nll38B@302030002
0203>NL3YA@3YC@3ked3oml3ool2oml3mih3ked3ic`3S743<HH2020300030206>NL3YA@2ic`6ool3
mkhHool001goo`;FVPK>N@K>F@=S;08Hh`H000<080<8H@<@XP<Hh`8Q10=kk`?F^P?og`?oo`?g_P;g
WP>U=0=220<8H@H000DaQP<aYPJD/P?W70Goo`?Nf`?F^P=kc`<Q908080<000<080<ii`>U50>U=0?_
G@;og`?oo`?og`?gWP?_G@?W?0:<L@<aQP<080<000<080Dii`>U50?W?0Koo`?g_Pgoo`?FVPK>N@K>
F@9S;0<Hh`H000<080<8H@8@XP<Hh`<Q10=kk`?F^P?og`;oo`?g_P?gWP>U=0=220<8H@D000HaQP<a
YPJD/P;W70Koo`?Nf`?F^P=kc`8Q90<080<000<080<ii`>U50:U=0?_G@?og`?oo`?og`?gWP?_G@;W
?0><L@<aQP<080<000<080Dii`>U50?W?0Koo`;g_Pkoo`?FVPK>N@G>F@=S;0<Hh`H000<08088H@<@
XP<Hh`<Q10=kk`?F^P;og`?oo`?g_P?gWP>U=0=22088H@H000HaQP<aYPFD/P?W70Koo`?Nf`?F^P9k
c`<Q90<080<000<080<ii`:U50>U=0?_G@?og`?oo`?og`;gWP?_G@?W?0><L@<aQP<0808000<080Hi
i`>U50?W?0Goo`?g_Pkoo`?FVPG>N@K>F@=S;0<Hh`D000<080<8H@<@XP<Hh`<Q10=kk`;F^P?og`?o
o`?g_P?gWP>U=09220<8H@H000HaQP8aYPJD/P?W70Koo`;Nf`?F^P=kc`<Q90<080<0008080<ii`>U
50>U=0?_G@?og`?oo`;og`?gWP?_G@?W?0><L@<aQP8080<000<080Hii`>U50;W?0Koo`?g_QSoo`00
7Ooo0]JJ1/ii1/iI0f</0QSS1P000`0P0`QQ0a2R0aSS0R440g__0mJj0ooO0ooo0oNn0_NN0jDd0d88
0`QQ1P001C660c6V1YBb0nLL1Ooo0mkK0mJj0g_?0b4T0P0P0`000`0P0cWW0jDD0jDd0nmM0_oO0ooo
0ooO0oNN0nmM0nLl0Xaa0c660`0P0`000`0P1CWW0jDD0nLl1_oo0oNn3Ooo0mJJ1/ii1/iI0V</0aSS
1P000`0P0`QQ0Q2R0aSS0b440g__0mJj0ooO0_oo0oNn0oNN0jDd0d880`QQ1@001S660c6V1YBb0^LL
1_oo0mkK0mJj0g_?0R4T0`0P0`000`0P0cWW0jDD0ZDd0nmM0ooO0ooo0ooO0oNN0nmM0^Ll0haa0c66
0`0P0`000`0P1CWW0jDD0nLl1_oo0_Nn3_oo0mJJ1/ii1LiI0f</0aSS1P000`0P0PQQ0a2R0aSS0b44
0g__0mJj0_oO0ooo0oNn0oNN0jDd0d880PQQ1P001S660c6V1IBb0nLL1_oo0mkK0mJj0W_?0b4T0`0P
0`000`0P0cWW0ZDD0jDd0nmM0ooO0ooo0ooO0_NN0nmM0nLl0haa0c660`0P0P000`0P1SWW0jDD0nLl
1Ooo0oNn3_oo0mJJ1Lii1/iI0f</0aSS1@000`0P0`QQ0a2R0aSS0b440g__0]Jj0ooO0ooo0oNn0oNN
0jDd0T880`QQ1P001S660S6V1YBb0nLL1_oo0]kK0mJj0g_?0b4T0`0P0`000P0P0cWW0jDD0jDd0nmM
0ooO0ooo0_oO0oNN0nmM0nLl0haa0c660P0P0`000`0P1SWW0jDD0^Ll1_oo0oNn6?oo000Gool3_ML3
DZX24:8302030003:DD6:FD5U983g_/6ool3oml5_OL6aQP3F^/3F//34:82020300036<<38@@38B@3
:DD5:FD6<HH3U;83ia`2mih6ool3e[X3eYX3cWT2Jfd36><60003020326434:826><38@@3Nnl3Nll3
eYX3oml2ool3ic`3S743<HH38B@3020200038@@38B@3:DD3Q303g]/8ool3_ML2DZX34:8302030003
:DD5:FD6U983g_/6ool2oml6_OL6aQP3F^/2F//34:83020300036<<38@@38B@2:DD6:FD6<HH3U;82
ia`3mih6ool3e[X3eYX2cWT3Jfd36><60003020226434:836><38@@3Nnl3Nll3eYX2oml3ool3ic`3
S743<HH38B@2020300038@@38B@3:DD3Q302g]/9ool2_ML3DZX34:8302030003:DD5:FD6U983g_/5
ool3oml6_OL6aQP2F^/3F//34:83020300036<<28@@38B@3:DD6:FD6<HH2U;83ia`3mih6ool3e[X2
eYX3cWT3Jfd36><60002020326434:836><38@@3Nnl2Nll3eYX3oml3ool3ic`3S742<HH38B@30203
00038@@38B@3:DD2Q303g]/8ool3_ML3DZX34:8302020003:DD6:FD6U982g_/6ool3oml6_OL5aQP3
F^/3F//34:83020300026<<38@@38B@3:DD6:FD5<HH3U;83ia`3mih5ool3e[X3eYX3cWT3Jfd36><5
0003020326434:836><38@@2Nnl3Nll3eYX3oml3ool3ic`2S743<HH38B@3020300038@@28B@3:DD3
Q303g]/Hool001Ooo`>me`=BZP8@XP<080<000<YA@HYI@FDTP?Nn`Koo`?og`Fmm`K660=Jj`=Jb`<@
XP8080<000<H``<Q10<Q90<YA@DYI@HaQP>D/P?W70;gWPKoo`?F^P?FVP?>N@9[K@<Hh`H000<080<8
H@<@XP8Hh`<Q10=kk`=kc`?FVP?og`;oo`?W?0><L@<aQP<Q90<0808000<Q10<Q90<YA@>4<0?Nf`So
o`>me`9BZP<@XP<080<000<YA@DYI@JDTP?Nn`Koo`;og`Jmm`K660=Jj`9Jb`<@XP<080<000<H``<Q
10<Q908YA@HYI@HaQP>D/P;W70?gWPKoo`?F^P?FVP;>N@=[K@<Hh`H000<08088H@<@XP<Hh`<Q10=k
k`=kc`?FVP;og`?oo`?W?0><L@<aQP<Q908080<000<Q10<Q90<YA@>4<0;Nf`Woo`:me`=BZP<@XP<0
80<000<YA@DYI@JDTP?Nn`Goo`?og`Jmm`K6609Jj`=Jb`<@XP<080<000<H``8Q10<Q90<YA@HYI@Ha
QP:D/P?W70?gWPKoo`?F^P;FVP?>N@=[K@<Hh`H0008080<8H@<@XP<Hh`<Q10=kk`9kc`?FVP?og`?o
o`?W?0><L@8aQP<Q90<080<000<Q10<Q90<YA@:4<0?Nf`Soo`>me`=BZP<@XP<0808000<YA@HYI@JD
TP;Nn`Koo`?og`Jmm`G660=Jj`=Jb`<@XP<080<0008H``<Q10<Q90<YA@HYI@DaQP>D/P?W70?gWPGo
o`?F^P?FVP?>N@=[K@<Hh`D000<080<8H@<@XP<Hh`<Q109kk`=kc`?FVP?og`?oo`?W?0:<L@<aQP<Q
90<080<000<Q108Q90<YA@>4<0?NfaSoo`005ooo0kgG0e:Z0Q2R0`0P0`000bU51RUU1IBB0mkk1_oo
0ooO1Kgg1/HH0e[[0e[;0a2R0P0P0`000aS30b440b4T0bU51BUU1S660iBb0nLL0_NN1_oo0mJj0mJJ
0lii0V]]0aSS1P000`0P0`QQ0a2R0QSS0b440g__0g_?0mJJ0ooO0_oo0nLl0haa0c660b4T0`0P0P00
0b440b4T0bU50h@`0mkK2?oo0kgG0U:Z0a2R0`0P0`000bU51BUU1YBB0mkk1_oo0_oO1[gg1/HH0e[[
0U[;0a2R0`0P0`000aS30b440b4T0RU51RUU1S660iBb0^LL0oNN1_oo0mJj0mJJ0/ii0f]]0aSS1P00
0`0P0PQQ0a2R0aSS0b440g__0g_?0mJJ0_oO0ooo0nLl0haa0c660b4T0P0P0`000b440b4T0bU50h@`
0]kK2Ooo0[gG0e:Z0a2R0`0P0`000bU51BUU1YBB0mkk1Ooo0ooO1[gg1/HH0U[[0e[;0a2R0`0P0`00
0aS30R440b4T0bU51RUU1S660YBb0nLL0oNN1_oo0mJj0]JJ0lii0f]]0aSS1P000P0P0`QQ0a2R0aSS
0b440g__0W_?0mJJ0ooO0ooo0nLl0haa0S660b4T0`0P0`000b440b4T0bU50X@`0mkK2?oo0kgG0e:Z
0a2R0`0P0P000bU51RUU1YBB0]kk1_oo0ooO1[gg1LHH0e[[0e[;0a2R0`0P0`000QS30b440b4T0bU5
1RUU1C660iBb0nLL0oNN1Ooo0mJj0mJJ0lii0f]]0aSS1@000`0P0`QQ0a2R0aSS0b440W__0g_?0mJJ
0ooO0ooo0nLl0Xaa0c660b4T0`0P0`000b440R4T0bU50h@`0mkK6?oo000Gool3_ML3DZX24:830203
0003:DD6:FD5U983g_/6ool3oml5_OL6aQP3F^/3F//34:82020300036<<38@@38B@3:DD5:FD6<HH3
U;83ia`2mih6ool3e[X3eYX3cWT2Jfd36><60003020326434:826><38@@3Nnl3Nll3eYX3oml2ool3
ic`3S743<HH38B@3020200038@@38B@3:DD3Q303g]/8ool3_ML2DZX34:8302030003:DD5:FD6U983
g_/6ool2oml6_OL6aQP3F^/2F//34:83020300036<<38@@38B@2:DD6:FD6<HH3U;82ia`3mih6ool3
e[X3eYX2cWT3Jfd36><60003020226434:836><38@@3Nnl3Nll3eYX2oml3ool3ic`3S743<HH38B@2
020300038@@38B@3:DD3Q302g]/9ool2_ML3DZX34:8302030003:DD5:FD6U983g_/5ool3oml6_OL6
aQP2F^/3F//34:83020300036<<28@@38B@3:DD6:FD6<HH2U;83ia`3mih6ool3e[X2eYX3cWT3Jfd3
6><60002020326434:836><38@@3Nnl2Nll3eYX3oml3ool3ic`3S742<HH38B@3020300038@@38B@3
:DD2Q303g]/8ool3_ML3DZX34:8302020003:DD6:FD6U982g_/6ool3oml6_OL5aQP3F^/3F//34:83
020300026<<38@@38B@3:DD6:FD5<HH3U;83ia`3mih5ool3e[X3eYX3cWT3Jfd36><5000302032643
4:836><38@@2Nnl3Nll3eYX3oml3ool3ic`2S743<HH38B@3020300038@@28B@3:DD3Q303g]/Hool0
01Ooo`>me`=BZP8@XP<080<000<YA@HYI@FDTP?Nn`Koo`?og`Fmm`K660=Jj`=Jb`<@XP8080<000<H
``<Q10<Q90<YA@DYI@HaQP>D/P?W70;gWPKoo`?F^P?FVP?>N@9[K@<Hh`H000<080<8H@<@XP8Hh`<Q
10=kk`=kc`?FVP?og`;oo`?W?0><L@<aQP<Q90<0808000<Q10<Q90<YA@>4<0?Nf`Soo`>me`9BZP<@
XP<080<000<YA@DYI@JDTP?Nn`Koo`;og`Jmm`K660=Jj`9Jb`<@XP<080<000<H``<Q10<Q908YA@HY
I@HaQP>D/P;W70?gWPKoo`?F^P?FVP;>N@=[K@<Hh`H000<08088H@<@XP<Hh`<Q10=kk`=kc`?FVP;o
g`?oo`?W?0><L@<aQP<Q908080<000<Q10<Q90<YA@>4<0;Nf`Woo`:me`=BZP<@XP<080<000<YA@DY
I@JDTP?Nn`Goo`?og`Jmm`K6609Jj`=Jb`<@XP<080<000<H``8Q10<Q90<YA@HYI@HaQP:D/P?W70?g
WPKoo`?F^P;FVP?>N@=[K@<Hh`H0008080<8H@<@XP<Hh`<Q10=kk`9kc`?FVP?og`?oo`?W?0><L@8a
QP<Q90<080<000<Q10<Q90<YA@:4<0?Nf`Soo`>me`=BZP<@XP<0808000<YA@HYI@JDTP;Nn`Koo`?o
g`Jmm`G660=Jj`=Jb`<@XP<080<0008H``<Q10<Q90<YA@HYI@DaQP>D/P?W70?gWPGoo`?F^P?FVP?>
N@=[K@<Hh`D000<080<8H@<@XP<Hh`<Q109kk`=kc`?FVP?og`?oo`?W?0:<L@<aQP<Q90<080<000<Q
108Q90<YA@>4<0?NfaSoo`005ooo0kgG0e:Z0Q2R0`0P0`000bU51RUU1IBB0mkk1_oo0ooO1Kgg1/HH
0e[[0e[;0a2R0P0P0`000aS30b440b4T0bU51BUU1S660iBb0nLL0_NN1_oo0mJj0mJJ0lii0V]]0aSS
1P000`0P0`QQ0a2R0QSS0b440g__0g_?0mJJ0ooO0_oo0nLl0haa0c660b4T0`0P0P000b440b4T0bU5
0h@`0mkK2?oo0kgG0U:Z0a2R0`0P0`000bU51BUU1YBB0mkk1_oo0_oO1[gg1/HH0e[[0U[;0a2R0`0P
0`000aS30b440b4T0RU51RUU1S660iBb0^LL0oNN1_oo0mJj0mJJ0/ii0f]]0aSS1P000`0P0PQQ0a2R
0aSS0b440g__0g_?0mJJ0_oO0ooo0nLl0haa0c660b4T0P0P0`000b440b4T0bU50h@`0]kK2Ooo0[gG
0e:Z0a2R0`0P0`000bU51BUU1YBB0mkk1Ooo0ooO1[gg1/HH0U[[0e[;0a2R0`0P0`000aS30R440b4T
0bU51RUU1S660YBb0nLL0oNN1_oo0mJj0]JJ0lii0f]]0aSS1P000P0P0`QQ0a2R0aSS0b440g__0W_?
0mJJ0ooO0ooo0nLl0haa0S660b4T0`0P0`000b440b4T0bU50X@`0mkK2?oo0kgG0e:Z0a2R0`0P0P00
0bU51RUU1YBB0]kk1_oo0ooO1[gg1LHH0e[[0e[;0a2R0`0P0`000QS30b440b4T0bU51RUU1C660iBb
0nLL0oNN1Ooo0mJj0mJJ0lii0f]]0aSS1@000`0P0`QQ0a2R0aSS0b440W__0g_?0mJJ0ooO0ooo0nLl
0Xaa0c660b4T0`0P0`000b440R4T0bU50h@`0mkK6?oo000Gool3_ML3DZX24:8302030003:DD6:FD5
U983g_/6ool3oml5_OL6aQP3F^/3F//34:82020300036<<38@@38B@3:DD5:FD6<HH3U;83ia`2mih6
ool3e[X3eYX3cWT2Jfd36><60003020326434:826><38@@3Nnl3Nll3eYX3oml2ool3ic`3S743<HH3
8B@3020200038@@38B@3:DD3Q303g]/8ool3_ML2DZX34:8302030003:DD5:FD6U983g_/6ool2oml6
_OL6aQP3F^/2F//34:83020300036<<38@@38B@2:DD6:FD6<HH3U;82ia`3mih6ool3e[X3eYX2cWT3
Jfd36><60003020226434:836><38@@3Nnl3Nll3eYX2oml3ool3ic`3S743<HH38B@2020300038@@3
8B@3:DD3Q302g]/9ool2_ML3DZX34:8302030003:DD5:FD6U983g_/5ool3oml6_OL6aQP2F^/3F//3
4:83020300036<<28@@38B@3:DD6:FD6<HH2U;83ia`3mih6ool3e[X2eYX3cWT3Jfd36><600020203
26434:836><38@@3Nnl2Nll3eYX3oml3ool3ic`3S742<HH38B@3020300038@@38B@3:DD2Q303g]/8
ool3_ML3DZX34:8302020003:DD6:FD6U982g_/6ool3oml6_OL5aQP3F^/3F//34:83020300026<<3
8@@38B@3:DD6:FD5<HH3U;83ia`3mih5ool3e[X3eYX3cWT3Jfd36><50003020326434:836><38@@2
Nnl3Nll3eYX3oml3ool3ic`2S743<HH38B@3020300038@@28B@3:DD3Q303g]/Hool001Ooo`>me`=B
ZP8@XP<080<000<YA@HYI@FDTP?Nn`Koo`?og`Fmm`K660=Jj`=Jb`<@XP8080<000<H``<Q10<Q90<Y
A@DYI@HaQP>D/P?W70;gWPKoo`?F^P?FVP?>N@9[K@<Hh`H000<080<8H@<@XP8Hh`<Q10=kk`=kc`?F
VP?og`;oo`?W?0><L@<aQP<Q90<0808000<Q10<Q90<YA@>4<0?Nf`Soo`>me`9BZP<@XP<080<000<Y
A@DYI@JDTP?Nn`Koo`;og`Jmm`K660=Jj`9Jb`<@XP<080<000<H``<Q10<Q908YA@HYI@HaQP>D/P;W
70?gWPKoo`?F^P?FVP;>N@=[K@<Hh`H000<08088H@<@XP<Hh`<Q10=kk`=kc`?FVP;og`?oo`?W?0><
L@<aQP<Q908080<000<Q10<Q90<YA@>4<0;Nf`Woo`:me`=BZP<@XP<080<000<YA@DYI@JDTP?Nn`Go
o`?og`Jmm`K6609Jj`=Jb`<@XP<080<000<H``8Q10<Q90<YA@HYI@HaQP:D/P?W70?gWPKoo`?F^P;F
VP?>N@=[K@<Hh`H0008080<8H@<@XP<Hh`<Q10=kk`9kc`?FVP?og`?oo`?W?0><L@8aQP<Q90<080<0
00<Q10<Q90<YA@:4<0?Nf`Soo`>me`=BZP<@XP<0808000<YA@HYI@JDTP;Nn`Koo`?og`Jmm`G660=J
j`=Jb`<@XP<080<0008H``<Q10<Q90<YA@HYI@DaQP>D/P?W70?gWPGoo`?F^P?FVP?>N@=[K@<Hh`D0
00<080<8H@<@XP<Hh`<Q109kk`=kc`?FVP?og`?oo`?W?0:<L@<aQP<Q90<080<000<Q108Q90<YA@>4
<0?NfaSoo`005ooo0kgG0e:Z0Q2R0`0P0`000bU51RUU1IBB0mkk1_oo0ooO1Kgg1/HH0e[[0e[;0a2R
0P0P0`000aS30b440b4T0bU51BUU1S660iBb0nLL0_NN1_oo0mJj0mJJ0lii0V]]0aSS1P000`0P0`QQ
0a2R0QSS0b440g__0g_?0mJJ0ooO0_oo0nLl0haa0c660b4T0`0P0P000b440b4T0bU50h@`0mkK2?oo
0kgG0U:Z0a2R0`0P0`000bU51BUU1YBB0mkk1_oo0_oO1[gg1/HH0e[[0U[;0a2R0`0P0`000aS30b44
0b4T0RU51RUU1S660iBb0^LL0oNN1_oo0mJj0mJJ0/ii0f]]0aSS1P000`0P0PQQ0a2R0aSS0b440g__
0g_?0mJJ0_oO0ooo0nLl0haa0c660b4T0P0P0`000b440b4T0bU50h@`0]kK2Ooo0[gG0e:Z0a2R0`0P
0`000bU51BUU1YBB0mkk1Ooo0ooO1[gg1/HH0U[[0e[;0a2R0`0P0`000aS30R440b4T0bU51RUU1S66
0YBb0nLL0oNN1_oo0mJj0]JJ0lii0f]]0aSS1P000P0P0`QQ0a2R0aSS0b440g__0W_?0mJJ0ooO0ooo
0nLl0haa0S660b4T0`0P0`000b440b4T0bU50X@`0mkK2?oo0kgG0e:Z0a2R0`0P0P000bU51RUU1YBB
0]kk1_oo0ooO1[gg1LHH0e[[0e[;0a2R0`0P0`000QS30b440b4T0bU51RUU1C660iBb0nLL0oNN1Ooo
0mJj0mJJ0lii0f]]0aSS1@000`0P0`QQ0a2R0aSS0b440W__0g_?0mJJ0ooO0ooo0nLl0Xaa0c660b4T
0`0P0`000b440R4T0bU50h@`0mkK6?oo000Gool3_ML3DZX24:8302030003:DD6:FD5U983g_/6ool3
oml5_OL6aQP3F^/3F//34:82020300036<<38@@38B@3:DD5:FD6<HH3U;83ia`2mih6ool3e[X3eYX3
cWT2Jfd36><60003020326434:826><38@@3Nnl3Nll3eYX3oml2ool3ic`3S743<HH38B@302020003
8@@38B@3:DD3Q303g]/8ool3_ML2DZX34:8302030003:DD5:FD6U983g_/6ool2oml6_OL6aQP3F^/2
F//34:83020300036<<38@@38B@2:DD6:FD6<HH3U;82ia`3mih6ool3e[X3eYX2cWT3Jfd36><60003
020226434:836><38@@3Nnl3Nll3eYX2oml3ool3ic`3S743<HH38B@2020300038@@38B@3:DD3Q302
g]/9ool2_ML3DZX34:8302030003:DD5:FD6U983g_/5ool3oml6_OL6aQP2F^/3F//34:8302030003
6<<28@@38B@3:DD6:FD6<HH2U;83ia`3mih6ool3e[X2eYX3cWT3Jfd36><60002020326434:836><3
8@@3Nnl2Nll3eYX3oml3ool3ic`3S742<HH38B@3020300038@@38B@3:DD2Q303g]/8ool3_ML3DZX3
4:8302020003:DD6:FD6U982g_/6ool3oml6_OL5aQP3F^/3F//34:83020300026<<38@@38B@3:DD6
:FD5<HH3U;83ia`3mih5ool3e[X3eYX3cWT3Jfd36><50003020326434:836><38@@2Nnl3Nll3eYX3
oml3ool3ic`2S743<HH38B@3020300038@@28B@3:DD3Q303g]/Hool001Ooo`>me`=BZP8@XP<080<0
00<YA@HYI@FDTP?Nn`Koo`?og`Fmm`K660=Jj`=Jb`<@XP8080<000<H``<Q10<Q90<YA@DYI@HaQP>D
/P?W70;gWPKoo`?F^P?FVP?>N@9[K@<Hh`H000<080<8H@<@XP8Hh`<Q10=kk`=kc`?FVP?og`;oo`?W
?0><L@<aQP<Q90<0808000<Q10<Q90<YA@>4<0?Nf`Soo`>me`9BZP<@XP<080<000<YA@DYI@JDTP?N
n`Koo`;og`Jmm`K660=Jj`9Jb`<@XP<080<000<H``<Q10<Q908YA@HYI@HaQP>D/P;W70?gWPKoo`?F
^P?FVP;>N@=[K@<Hh`H000<08088H@<@XP<Hh`<Q10=kk`=kc`?FVP;og`?oo`?W?0><L@<aQP<Q9080
80<000<Q10<Q90<YA@>4<0;Nf`Woo`:me`=BZP<@XP<080<000<YA@DYI@JDTP?Nn`Goo`?og`Jmm`K6
609Jj`=Jb`<@XP<080<000<H``8Q10<Q90<YA@HYI@HaQP:D/P?W70?gWPKoo`?F^P;FVP?>N@=[K@<H
h`H0008080<8H@<@XP<Hh`<Q10=kk`9kc`?FVP?og`?oo`?W?0><L@8aQP<Q90<080<000<Q10<Q90<Y
A@:4<0?Nf`Soo`>me`=BZP<@XP<0808000<YA@HYI@JDTP;Nn`Koo`?og`Jmm`G660=Jj`=Jb`<@XP<0
80<0008H``<Q10<Q90<YA@HYI@DaQP>D/P?W70?gWPGoo`?F^P?FVP?>N@=[K@<Hh`D000<080<8H@<@
XP<Hh`<Q109kk`=kc`?FVP?og`?oo`?W?0:<L@<aQP<Q90<080<000<Q108Q90<YA@>4<0?NfaSoo`00
5ooo0ooO0ooo0^LL0h@`0haA0bUU0`0P0`000QS30f]]0lii0mkK0ooO0ooo0ooO0/HH0e[[0a2R0`00
0`Q10a220Q2R0f]=0liI0mJj0ooO0ooo0^LL0mkk0mkK0mJj0g>^0b4T1@000`Q10a220aS30aSS0W>^
0mJJ0ooO0ooo0nLl0haa0c660P0P0`000`0P0`QQ0e::0kFf0_NN1_oo0mJJ26]]0g>>0b440a221P00
2?oo0ooO0_oo0nLL0h@`0haA0bUU0`0P0P000aS30f]]0lii0mkK0ooO0_oo0ooO0lHH0e[[0a2R0`00
0PQ10a220a2R0f]=0liI0mJj0ooO0_oo0nLL0mkk0mkK0mJj0g>^0R4T1P000`Q10a220aS30QSS0g>^
0mJJ0ooO0ooo0nLl0Xaa0c660`0P0`000`0P0`QQ0e::0[Ff0oNN1_oo0mJJ26]]0g>>0b440a221@00
2Ooo0_oO0ooo0nLL0h@`0haA0bUU0P0P0`000aS30f]]0lii0mkK0_oO0ooo0ooO0lHH0e[[0a2R0P00
0`Q10a220a2R0f]=0liI0]Jj0ooO0ooo0nLL0mkk0mkK0mJj0W>^0b4T1P000`Q10a220QS30aSS0g>^
0mJJ0ooO0ooo0^Ll0haa0c660`0P0`000`0P0PQQ0e::0kFf0oNN1_oo0]JJ2F]]0g>>0b440a221@00
2?oo0ooO0ooo0nLL0h@`0XaA0bUU0`0P0`000aS30f]]0/ii0mkK0ooO0ooo0ooO0lHH0e[[0Q2R0`00
0`Q10a220a2R0f]=0/iI0mJj0ooO0ooo0nLL0mkk0]kK0mJj0g>^0b4T1P000PQ10a220aS30aSS0g>^
0mJJ0_oO0ooo0nLl0haa0c660`0P0`000P0P0`QQ0e::0kFf0oNN1Ooo0mJJ2F]]0g>>0R440a221P00
6?oo000Gool3oml3ool2ia`3Q303S543:FD3020300026<<3Jfd3cWT3g]/3oml3ool3oml2aQP3F^/3
4:830003244348824:83Jdd3cUT3e[X3oml3ool2ia`3g_/3g]/3e[X3Ljh38B@50003244348836<<3
6><2Ljh3eYX3oml3ool3ic`3S743<HH20203000302032643DXX3]KH2mih6ool3eYX8Jfd3Lhh38@@3
48860008ool3oml2ool3ia`3Q303S543:FD3020200036<<3Jfd3cWT3g]/3oml2ool3oml3aQP3F^/3
4:830002244348834:83Jdd3cUT3e[X3oml2ool3ia`3g_/3g]/3e[X3Ljh28B@60003244348836<<2
6><3Ljh3eYX3oml3ool3ic`2S743<HH30203000302032643DXX2]KH3mih6ool3eYX8Jfd3Lhh38@@3
48850009ool2oml3ool3ia`3Q303S543:FD2020300036<<3Jfd3cWT3g]/2oml3ool3oml3aQP3F^/3
4:820003244348834:83Jdd3cUT2e[X3oml3ool3ia`3g_/3g]/3e[X2Ljh38B@60003244348826<<3
6><3Ljh3eYX3oml3ool2ic`3S743<HH30203000302022643DXX3]KH3mih6ool2eYX9Jfd3Lhh38@@3
48850008ool3oml3ool3ia`3Q302S543:FD3020300036<<3Jfd2cWT3g]/3oml3ool3oml3aQP3F^/2
4:830003244348834:83Jdd2cUT3e[X3oml3ool3ia`3g_/2g]/3e[X3Ljh38B@60002244348836<<3
6><3Ljh3eYX2oml3ool3ic`3S743<HH30203000202032643DXX3]KH3mih5ool3eYX9Jfd3Lhh28@@3
4886000Hool001Ooo`?og`?oo`;W70>4<0><D@<YI@<080<0008H``=[K@?>N@?Nf`?og`?oo`?og`;6
60=Jj`<@XP<000<8@@<@PP8@XP=[C@?>F@?F^P?og`?oo`;W70?Nn`?Nf`?F^P=c[P<Q90D000<8@@<@
PP<H``<Hh`9c[P?FVP?og`?oo`?W?0><L@<aQP8080<000<080<8H@=BRP>e]P;gWPKoo`?FVPQ[K@=c
SP<Q10<@PPH000Soo`?og`;oo`?W70>4<0><D@<YI@<0808000<H``=[K@?>N@?Nf`?og`;oo`?og`?6
60=Jj`<@XP<00088@@<@PP<@XP=[C@?>F@?F^P?og`;oo`?W70?Nn`?Nf`?F^P=c[P8Q90H000<8@@<@
PP<H``8Hh`=c[P?FVP?og`?oo`?W?0:<L@<aQP<080<000<080<8H@=BRP:e]P?gWPKoo`?FVPQ[K@=c
SP<Q10<@PPD000Woo`;og`?oo`?W70>4<0><D@<YI@8080<000<H``=[K@?>N@?Nf`;og`?oo`?og`?6
60=Jj`<@XP8000<8@@<@PP<@XP=[C@?>F@;F^P?og`?oo`?W70?Nn`?Nf`?F^P9c[P<Q90H000<8@@<@
PP8H``<Hh`=c[P?FVP?og`?oo`;W?0><L@<aQP<080<000<08088H@=BRP>e]P?gWPKoo`;FVPU[K@=c
SP<Q10<@PPD000Soo`?og`?oo`?W70>4<0:<D@<YI@<080<000<H``=[K@;>N@?Nf`?og`?oo`?og`?6
60=Jj`8@XP<000<8@@<@PP<@XP=[C@;>F@?F^P?og`?oo`?W70?Nn`;Nf`?F^P=c[P<Q90H00088@@<@
PP<H``<Hh`=c[P?FVP;og`?oo`?W?0><L@<aQP<080<0008080<8H@=BRP>e]P?gWPGoo`?FVPU[K@=c
SP8Q10<@PPH001Soo`005ooo0ooO0ooo0^LL0h@`0haA0bUU0`0P0`000QS30f]]0lii0mkK0ooO0ooo
0ooO0/HH0e[[0a2R0`000`Q10a220Q2R0f]=0liI0mJj0ooO0ooo0^LL0mkk0mkK0mJj0g>^0b4T1@00
0`Q10a220aS30aSS0W>^0mJJ0ooO0ooo0nLl0haa0c660P0P0`000`0P0`QQ0e::0kFf0_NN1_oo0mJJ
26]]0g>>0b440a221P002?oo0ooO0_oo0nLL0h@`0haA0bUU0`0P0P000aS30f]]0lii0mkK0ooO0_oo
0ooO0lHH0e[[0a2R0`000PQ10a220a2R0f]=0liI0mJj0ooO0_oo0nLL0mkk0mkK0mJj0g>^0R4T1P00
0`Q10a220aS30QSS0g>^0mJJ0ooO0ooo0nLl0Xaa0c660`0P0`000`0P0`QQ0e::0[Ff0oNN1_oo0mJJ
26]]0g>>0b440a221@002Ooo0_oO0ooo0nLL0h@`0haA0bUU0P0P0`000aS30f]]0lii0mkK0_oO0ooo
0ooO0lHH0e[[0a2R0P000`Q10a220a2R0f]=0liI0]Jj0ooO0ooo0nLL0mkk0mkK0mJj0W>^0b4T1P00
0`Q10a220QS30aSS0g>^0mJJ0ooO0ooo0^Ll0haa0c660`0P0`000`0P0PQQ0e::0kFf0oNN1_oo0]JJ
2F]]0g>>0b440a221@002?oo0ooO0ooo0nLL0h@`0XaA0bUU0`0P0`000aS30f]]0/ii0mkK0ooO0ooo
0ooO0lHH0e[[0Q2R0`000`Q10a220a2R0f]=0/iI0mJj0ooO0ooo0nLL0mkk0]kK0mJj0g>^0b4T1P00
0PQ10a220aS30aSS0g>^0mJJ0_oO0ooo0nLl0haa0c660`0P0`000P0P0`QQ0e::0kFf0oNN1Ooo0mJJ
2F]]0g>>0R440a221P006?oo000Gool3oml3ool2ia`3Q303S543:FD3020300026<<3Jfd3cWT3g]/3
oml3ool3oml2aQP3F^/34:830003244348824:83Jdd3cUT3e[X3oml3ool2ia`3g_/3g]/3e[X3Ljh3
8B@50003244348836<<36><2Ljh3eYX3oml3ool3ic`3S743<HH20203000302032643DXX3]KH2mih6
ool3eYX8Jfd3Lhh38@@348860008ool3oml2ool3ia`3Q303S543:FD3020200036<<3Jfd3cWT3g]/3
oml2ool3oml3aQP3F^/34:830002244348834:83Jdd3cUT3e[X3oml2ool3ia`3g_/3g]/3e[X3Ljh2
8B@60003244348836<<26><3Ljh3eYX3oml3ool3ic`2S743<HH30203000302032643DXX2]KH3mih6
ool3eYX8Jfd3Lhh38@@348850009ool2oml3ool3ia`3Q303S543:FD2020300036<<3Jfd3cWT3g]/2
oml3ool3oml3aQP3F^/34:820003244348834:83Jdd3cUT2e[X3oml3ool3ia`3g_/3g]/3e[X2Ljh3
8B@60003244348826<<36><3Ljh3eYX3oml3ool2ic`3S743<HH30203000302022643DXX3]KH3mih6
ool2eYX9Jfd3Lhh38@@348850008ool3oml3ool3ia`3Q302S543:FD3020300036<<3Jfd2cWT3g]/3
oml3ool3oml3aQP3F^/24:830003244348834:83Jdd2cUT3e[X3oml3ool3ia`3g_/2g]/3e[X3Ljh3
8B@60002244348836<<36><3Ljh3eYX2oml3ool3ic`3S743<HH30203000202032643DXX3]KH3mih5
ool3eYX9Jfd3Lhh28@@34886000Hool001Ooo`?og`?oo`;W70>4<0><D@<YI@<080<0008H``=[K@?>
N@?Nf`?og`?oo`?og`;660=Jj`<@XP<000<8@@<@PP8@XP=[C@?>F@?F^P?og`?oo`;W70?Nn`?Nf`?F
^P=c[P<Q90D000<8@@<@PP<H``<Hh`9c[P?FVP?og`?oo`?W?0><L@<aQP8080<000<080<8H@=BRP>e
]P;gWPKoo`?FVPQ[K@=cSP<Q10<@PPH000Soo`?og`;oo`?W70>4<0><D@<YI@<0808000<H``=[K@?>
N@?Nf`?og`;oo`?og`?660=Jj`<@XP<00088@@<@PP<@XP=[C@?>F@?F^P?og`;oo`?W70?Nn`?Nf`?F
^P=c[P8Q90H000<8@@<@PP<H``8Hh`=c[P?FVP?og`?oo`?W?0:<L@<aQP<080<000<080<8H@=BRP:e
]P?gWPKoo`?FVPQ[K@=cSP<Q10<@PPD000Woo`;og`?oo`?W70>4<0><D@<YI@8080<000<H``=[K@?>
N@?Nf`;og`?oo`?og`?660=Jj`<@XP8000<8@@<@PP<@XP=[C@?>F@;F^P?og`?oo`?W70?Nn`?Nf`?F
^P9c[P<Q90H000<8@@<@PP8H``<Hh`=c[P?FVP?og`?oo`;W?0><L@<aQP<080<000<08088H@=BRP>e
]P?gWPKoo`;FVPU[K@=cSP<Q10<@PPD000Soo`?og`?oo`?W70>4<0:<D@<YI@<080<000<H``=[K@;>
N@?Nf`?og`?oo`?og`?660=Jj`8@XP<000<8@@<@PP<@XP=[C@;>F@?F^P?og`?oo`?W70?Nn`;Nf`?F
^P=c[P<Q90H00088@@<@PP<H``<Hh`=c[P?FVP;og`?oo`?W?0><L@<aQP<080<0008080<8H@=BRP>e
]P?gWPGoo`?FVPU[K@=cSP8Q10<@PPH001Soo`005ooo0ooO0ooo0^LL0h@`0haA0bUU0`0P0`000QS3
0f]]0lii0mkK0ooO0ooo0ooO0/HH0e[[0a2R0`000`Q10a220Q2R0f]=0liI0mJj0ooO0ooo0^LL0mkk
0mkK0mJj0g>^0b4T1@000`Q10a220aS30aSS0W>^0mJJ0ooO0ooo0nLl0haa0c660P0P0`000`0P0`QQ
0e::0kFf0_NN1_oo0mJJ26]]0g>>0b440a221P002?oo0ooO0_oo0nLL0h@`0haA0bUU0`0P0P000aS3
0f]]0lii0mkK0ooO0_oo0ooO0lHH0e[[0a2R0`000PQ10a220a2R0f]=0liI0mJj0ooO0_oo0nLL0mkk
0mkK0mJj0g>^0R4T1P000`Q10a220aS30QSS0g>^0mJJ0ooO0ooo0nLl0Xaa0c660`0P0`000`0P0`QQ
0e::0[Ff0oNN1_oo0mJJ26]]0g>>0b440a221@002Ooo0_oO0ooo0nLL0h@`0haA0bUU0P0P0`000aS3
0f]]0lii0mkK0_oO0ooo0ooO0lHH0e[[0a2R0P000`Q10a220a2R0f]=0liI0]Jj0ooO0ooo0nLL0mkk
0mkK0mJj0W>^0b4T1P000`Q10a220QS30aSS0g>^0mJJ0ooO0ooo0^Ll0haa0c660`0P0`000`0P0PQQ
0e::0kFf0oNN1_oo0]JJ2F]]0g>>0b440a221@002?oo0ooO0ooo0nLL0h@`0XaA0bUU0`0P0`000aS3
0f]]0/ii0mkK0ooO0ooo0ooO0lHH0e[[0Q2R0`000`Q10a220a2R0f]=0/iI0mJj0ooO0ooo0nLL0mkk
0]kK0mJj0g>^0b4T1P000PQ10a220aS30aSS0g>^0mJJ0_oO0ooo0nLl0haa0c660`0P0`000P0P0`QQ
0e::0kFf0oNN1Ooo0mJJ2F]]0g>>0R440a221P006?oo000Gool3oml3ool2ia`3Q303S543:FD30203
00026<<3Jfd3cWT3g]/3oml3ool3oml2aQP3F^/34:830003244348824:83Jdd3cUT3e[X3oml3ool2
ia`3g_/3g]/3e[X3Ljh38B@50003244348836<<36><2Ljh3eYX3oml3ool3ic`3S743<HH202030003
02032643DXX3]KH2mih6ool3eYX8Jfd3Lhh38@@348860008ool3oml2ool3ia`3Q303S543:FD30202
00036<<3Jfd3cWT3g]/3oml2ool3oml3aQP3F^/34:830002244348834:83Jdd3cUT3e[X3oml2ool3
ia`3g_/3g]/3e[X3Ljh28B@60003244348836<<26><3Ljh3eYX3oml3ool3ic`2S743<HH302030003
02032643DXX2]KH3mih6ool3eYX8Jfd3Lhh38@@348850009ool2oml3ool3ia`3Q303S543:FD20203
00036<<3Jfd3cWT3g]/2oml3ool3oml3aQP3F^/34:820003244348834:83Jdd3cUT2e[X3oml3ool3
ia`3g_/3g]/3e[X2Ljh38B@60003244348826<<36><3Ljh3eYX3oml3ool2ic`3S743<HH302030003
02022643DXX3]KH3mih6ool2eYX9Jfd3Lhh38@@348850008ool3oml3ool3ia`3Q302S543:FD30203
00036<<3Jfd2cWT3g]/3oml3ool3oml3aQP3F^/24:830003244348834:83Jdd2cUT3e[X3oml3ool3
ia`3g_/2g]/3e[X3Ljh38B@60002244348836<<36><3Ljh3eYX2oml3ool3ic`3S743<HH302030002
02032643DXX3]KH3mih5ool3eYX9Jfd3Lhh28@@34886000Hool001Ooo`?og`?oo`;W70>4<0><D@<Y
I@<080<0008H``=[K@?>N@?Nf`?og`?oo`?og`;660=Jj`<@XP<000<8@@<@PP8@XP=[C@?>F@?F^P?o
g`?oo`;W70?Nn`?Nf`?F^P=c[P<Q90D000<8@@<@PP<H``<Hh`9c[P?FVP?og`?oo`?W?0><L@<aQP80
80<000<080<8H@=BRP>e]P;gWPKoo`?FVPQ[K@=cSP<Q10<@PPH000Soo`?og`;oo`?W70>4<0><D@<Y
I@<0808000<H``=[K@?>N@?Nf`?og`;oo`?og`?660=Jj`<@XP<00088@@<@PP<@XP=[C@?>F@?F^P?o
g`;oo`?W70?Nn`?Nf`?F^P=c[P8Q90H000<8@@<@PP<H``8Hh`=c[P?FVP?og`?oo`?W?0:<L@<aQP<0
80<000<080<8H@=BRP:e]P?gWPKoo`?FVPQ[K@=cSP<Q10<@PPD000Woo`;og`?oo`?W70>4<0><D@<Y
I@8080<000<H``=[K@?>N@?Nf`;og`?oo`?og`?660=Jj`<@XP8000<8@@<@PP<@XP=[C@?>F@;F^P?o
g`?oo`?W70?Nn`?Nf`?F^P9c[P<Q90H000<8@@<@PP8H``<Hh`=c[P?FVP?og`?oo`;W?0><L@<aQP<0
80<000<08088H@=BRP>e]P?gWPKoo`;FVPU[K@=cSP<Q10<@PPD000Soo`?og`?oo`?W70>4<0:<D@<Y
I@<080<000<H``=[K@;>N@?Nf`?og`?oo`?og`?660=Jj`8@XP<000<8@@<@PP<@XP=[C@;>F@?F^P?o
g`?oo`?W70?Nn`;Nf`?F^P=c[P<Q90H00088@@<@PP<H``<Hh`=c[P?FVP;og`?oo`?W?0><L@<aQP<0
80<0008080<8H@=BRP>e]P?gWPGoo`?FVPU[K@=cSP8Q10<@PPH001Soo`005ooo0ooO0ooo0^LL0h@`
0haA0bUU0`0P0`000QS30f]]0lii0mkK0ooO0ooo0ooO0/HH0e[[0a2R0`000`Q10a220Q2R0f]=0liI
0mJj0ooO0ooo0^LL0mkk0mkK0mJj0g>^0b4T1@000`Q10a220aS30aSS0W>^0mJJ0ooO0ooo0nLl0haa
0c660P0P0`000`0P0`QQ0e::0kFf0_NN1_oo0mJJ26]]0g>>0b440a221P002?oo0ooO0_oo0nLL0h@`
0haA0bUU0`0P0P000aS30f]]0lii0mkK0ooO0_oo0ooO0lHH0e[[0a2R0`000PQ10a220a2R0f]=0liI
0mJj0ooO0_oo0nLL0mkk0mkK0mJj0g>^0R4T1P000`Q10a220aS30QSS0g>^0mJJ0ooO0ooo0nLl0Xaa
0c660`0P0`000`0P0`QQ0e::0[Ff0oNN1_oo0mJJ26]]0g>>0b440a221@002Ooo0_oO0ooo0nLL0h@`
0haA0bUU0P0P0`000aS30f]]0lii0mkK0_oO0ooo0ooO0lHH0e[[0a2R0P000`Q10a220a2R0f]=0liI
0]Jj0ooO0ooo0nLL0mkk0mkK0mJj0W>^0b4T1P000`Q10a220QS30aSS0g>^0mJJ0ooO0ooo0^Ll0haa
0c660`0P0`000`0P0PQQ0e::0kFf0oNN1_oo0]JJ2F]]0g>>0b440a221@002?oo0ooO0ooo0nLL0h@`
0XaA0bUU0`0P0`000aS30f]]0/ii0mkK0ooO0ooo0ooO0lHH0e[[0Q2R0`000`Q10a220a2R0f]=0/iI
0mJj0ooO0ooo0nLL0mkk0]kK0mJj0g>^0b4T1P000PQ10a220aS30aSS0g>^0mJJ0_oO0ooo0nLl0haa
0c660`0P0`000P0P0`QQ0e::0kFf0oNN1Ooo0mJJ2F]]0g>>0R440a221P006?oo000Gool3oml3ool2
ia`3Q303S543:FD3020300026<<3Jfd3cWT3g]/3oml3ool3oml2aQP3F^/34:830003244348824:83
Jdd3cUT3e[X3oml3ool2ia`3g_/3g]/3e[X3Ljh38B@50003244348836<<36><2Ljh3eYX3oml3ool3
ic`3S743<HH20203000302032643DXX3]KH2mih6ool3eYX8Jfd3Lhh38@@348860008ool3oml2ool3
ia`3Q303S543:FD3020200036<<3Jfd3cWT3g]/3oml2ool3oml3aQP3F^/34:830002244348834:83
Jdd3cUT3e[X3oml2ool3ia`3g_/3g]/3e[X3Ljh28B@60003244348836<<26><3Ljh3eYX3oml3ool3
ic`2S743<HH30203000302032643DXX2]KH3mih6ool3eYX8Jfd3Lhh38@@348850009ool2oml3ool3
ia`3Q303S543:FD2020300036<<3Jfd3cWT3g]/2oml3ool3oml3aQP3F^/34:820003244348834:83
Jdd3cUT2e[X3oml3ool3ia`3g_/3g]/3e[X2Ljh38B@60003244348826<<36><3Ljh3eYX3oml3ool2
ic`3S743<HH30203000302022643DXX3]KH3mih6ool2eYX9Jfd3Lhh38@@348850008ool3oml3ool3
ia`3Q302S543:FD3020300036<<3Jfd2cWT3g]/3oml3ool3oml3aQP3F^/24:830003244348834:83
Jdd2cUT3e[X3oml3ool3ia`3g_/2g]/3e[X3Ljh38B@60002244348836<<36><3Ljh3eYX2oml3ool3
ic`3S743<HH30203000202032643DXX3]KH3mih5ool3eYX9Jfd3Lhh28@@34886000Hool001Ooo`<Q
90<YA@:<D@?Nf`Koo`?og`?gWP;_G@?W70><L@<aQP<Q10<@PPD000<YA@<YI@HaQP>D/P;W70?gWPKo
o`K>N@E[C@<Hh`<8H@<000<@PP8H``<Hh`=c[P?FVP?Nn`Goo`?og`?gWP?_G@?W70?Nn`>4408YA@<0
80<000<080<8H@<@XP8H``<Q10=kc`?F^P?W70?gWPGoo`?g_P?_O@?W?0?W70Soo`<Q908YA@><D@?N
f`Koo`?og`;gWP?_G@?W70><L@<aQP<Q108@PPH000<YA@<YI@DaQP>D/P?W70?gWPKoo`G>N@I[C@<H
h`<8H@<0008@PP<H``<Hh`=c[P?FVP?Nn`Goo`?og`?gWP?_G@?W70;Nn`>440<YA@<080<000<080<8
H@8@XP<H``<Q10=kc`?F^P?W70;gWPKoo`?g_P?_O@?W?0;W70Woo`8Q90<YA@><D@?Nf`Koo`;og`?g
WP?_G@?W70><L@<aQP8Q10<@PPH000<YA@<YI@DaQP>D/P?W70?gWPGoo`K>N@I[C@<Hh`<8H@8000<@
PP<H``<Hh`=c[P?FVP;Nn`Koo`?og`?gWP?_G@;W70?Nn`>440<YA@<080<0008080<8H@<@XP<H``<Q
10=kc`;F^P?W70?gWPKoo`?g_P?_O@;W?0?W70Soo`<Q90<YA@><D@?Nf`Goo`?og`?gWP?_G@?W70:<
L@<aQP<Q10<@PPH000<YA@8YI@HaQP>D/P?W70?gWPGoo`K>N@I[C@8Hh`<8H@<000<@PP<H``<Hh`9c
[P?FVP?Nn`Koo`?og`;gWP?_G@?W70?Nn`>440<YA@<0808000<080<8H@<@XP<H``<Q109kc`?F^P?W
70?gWPKoo`;g_P?_O@?W?0?W71Soo`005ooo0b4T0bU50XaA0mkK1_oo0ooO0oNN0^mM0nLL0haa0c66
0b440a221@000bU50bUU1S660iBb0^LL0oNN1_oo1/ii1F]=0aSS0`QQ0`000a220QS30aSS0g>^0mJJ
0mkk1Ooo0ooO0oNN0nmM0nLL0mkk0h@@0RU50`0P0`000`0P0`QQ0a2R0QS30b440g_?0mJj0nLL0oNN
1Ooo0oNn0nmm0nLl0nLL2?oo0b4T0RU50haA0mkK1_oo0ooO0_NN0nmM0nLL0haa0c660b440Q221P00
0bU50bUU1C660iBb0nLL0oNN1_oo1Lii1V]=0aSS0`QQ0`000Q220aS30aSS0g>^0mJJ0mkk1Ooo0ooO
0oNN0nmM0nLL0]kk0h@@0bU50`0P0`000`0P0`QQ0Q2R0aS30b440g_?0mJj0nLL0_NN1_oo0oNn0nmm
0nLl0^LL2Ooo0R4T0bU50haA0mkK1_oo0_oO0oNN0nmM0nLL0haa0c660R440a221P000bU50bUU1C66
0iBb0nLL0oNN1Ooo1/ii1V]=0aSS0`QQ0P000a220aS30aSS0g>^0mJJ0]kk1_oo0ooO0oNN0nmM0^LL
0mkk0h@@0bU50`0P0`000P0P0`QQ0a2R0aS30b440g_?0]Jj0nLL0oNN1_oo0oNn0nmm0^Ll0nLL2?oo
0b4T0bU50haA0mkK1Ooo0ooO0oNN0nmM0nLL0Xaa0c660b440a221P000bU50RUU1S660iBb0nLL0oNN
1Ooo1/ii1V]=0QSS0`QQ0`000a220aS30aSS0W>^0mJJ0mkk1_oo0ooO0_NN0nmM0nLL0mkk0h@@0bU5
0`0P0P000`0P0`QQ0a2R0aS30b440W_?0mJj0nLL0oNN1_oo0_Nn0nmm0nLl0nLL6?oo000Gool38B@3
:DD2S543g]/6ool3oml3mih2ked3ia`3S743<HH38@@348850003:DD3:FD6<HH3U;82ia`3mih6ool6
cWT5Jdd36><32643000348826<<36><3Ljh3eYX3g_/5ool3oml3mih3ked3ia`3g_/3Q102:DD30203
0003020326434:826<<38@@3Nll3e[X3ia`3mih5ool3mkh3kgd3ic`3ia`8ool38B@2:DD3S543g]/6
ool3oml2mih3ked3ia`3S743<HH38@@248860003:DD3:FD5<HH3U;83ia`3mih6ool5cWT6Jdd36><3
2643000248836<<36><3Ljh3eYX3g_/5ool3oml3mih3ked3ia`2g_/3Q103:DD30203000302032642
4:836<<38@@3Nll3e[X3ia`2mih6ool3mkh3kgd3ic`2ia`9ool28B@3:DD3S543g]/6ool2oml3mih3
ked3ia`3S743<HH28@@348860003:DD3:FD5<HH3U;83ia`3mih5ool6cWT6Jdd36><3264200034883
6<<36><3Ljh3eYX2g_/6ool3oml3mih3ked2ia`3g_/3Q103:DD302030002020326434:836<<38@@3
Nll2e[X3ia`3mih6ool3mkh3kgd2ic`3ia`8ool38B@3:DD3S543g]/5ool3oml3mih3ked3ia`2S743
<HH38@@348860003:DD2:FD6<HH3U;83ia`3mih5ool6cWT6Jdd26><32643000348836<<36><2Ljh3
eYX3g_/6ool3oml2mih3ked3ia`3g_/3Q103:DD302020003020326434:836<<38@@2Nll3e[X3ia`3
mih6ool2mkh3kgd3ic`3ia`Hool001Ooo`<Q90<YA@:<D@?Nf`Koo`?og`?gWP;_G@?W70><L@<aQP<Q
10<@PPD000<YA@<YI@HaQP>D/P;W70?gWPKoo`K>N@E[C@<Hh`<8H@<000<@PP8H``<Hh`=c[P?FVP?N
n`Goo`?og`?gWP?_G@?W70?Nn`>4408YA@<080<000<080<8H@<@XP8H``<Q10=kc`?F^P?W70?gWPGo
o`?g_P?_O@?W?0?W70Soo`<Q908YA@><D@?Nf`Koo`?og`;gWP?_G@?W70><L@<aQP<Q108@PPH000<Y
A@<YI@DaQP>D/P?W70?gWPKoo`G>N@I[C@<Hh`<8H@<0008@PP<H``<Hh`=c[P?FVP?Nn`Goo`?og`?g
WP?_G@?W70;Nn`>440<YA@<080<000<080<8H@8@XP<H``<Q10=kc`?F^P?W70;gWPKoo`?g_P?_O@?W
?0;W70Woo`8Q90<YA@><D@?Nf`Koo`;og`?gWP?_G@?W70><L@<aQP8Q10<@PPH000<YA@<YI@DaQP>D
/P?W70?gWPGoo`K>N@I[C@<Hh`<8H@8000<@PP<H``<Hh`=c[P?FVP;Nn`Koo`?og`?gWP?_G@;W70?N
n`>440<YA@<080<0008080<8H@<@XP<H``<Q10=kc`;F^P?W70?gWPKoo`?g_P?_O@;W?0?W70Soo`<Q
90<YA@><D@?Nf`Goo`?og`?gWP?_G@?W70:<L@<aQP<Q10<@PPH000<YA@8YI@HaQP>D/P?W70?gWPGo
o`K>N@I[C@8Hh`<8H@<000<@PP<H``<Hh`9c[P?FVP?Nn`Koo`?og`;gWP?_G@?W70?Nn`>440<YA@<0
808000<080<8H@<@XP<H``<Q109kc`?F^P?W70?gWPKoo`;g_P?_O@?W?0?W71Soo`005ooo0b4T0bU5
0XaA0mkK1_oo0ooO0oNN0^mM0nLL0haa0c660b440a221@000bU50bUU1S660iBb0^LL0oNN1_oo1/ii
1F]=0aSS0`QQ0`000a220QS30aSS0g>^0mJJ0mkk1Ooo0ooO0oNN0nmM0nLL0mkk0h@@0RU50`0P0`00
0`0P0`QQ0a2R0QS30b440g_?0mJj0nLL0oNN1Ooo0oNn0nmm0nLl0nLL2?oo0b4T0RU50haA0mkK1_oo
0ooO0_NN0nmM0nLL0haa0c660b440Q221P000bU50bUU1C660iBb0nLL0oNN1_oo1Lii1V]=0aSS0`QQ
0`000Q220aS30aSS0g>^0mJJ0mkk1Ooo0ooO0oNN0nmM0nLL0]kk0h@@0bU50`0P0`000`0P0`QQ0Q2R
0aS30b440g_?0mJj0nLL0_NN1_oo0oNn0nmm0nLl0^LL2Ooo0R4T0bU50haA0mkK1_oo0_oO0oNN0nmM
0nLL0haa0c660R440a221P000bU50bUU1C660iBb0nLL0oNN1Ooo1/ii1V]=0aSS0`QQ0P000a220aS3
0aSS0g>^0mJJ0]kk1_oo0ooO0oNN0nmM0^LL0mkk0h@@0bU50`0P0`000P0P0`QQ0a2R0aS30b440g_?
0]Jj0nLL0oNN1_oo0oNn0nmm0^Ll0nLL2?oo0b4T0bU50haA0mkK1Ooo0ooO0oNN0nmM0nLL0Xaa0c66
0b440a221P000bU50RUU1S660iBb0nLL0oNN1Ooo1/ii1V]=0QSS0`QQ0`000a220aS30aSS0W>^0mJJ
0mkk1_oo0ooO0_NN0nmM0nLL0mkk0h@@0bU50`0P0P000`0P0`QQ0a2R0aS30b440W_?0mJj0nLL0oNN
1_oo0_Nn0nmm0nLl0nLL6?oo000Gool38B@3:DD2S543g]/6ool3oml3mih2ked3ia`3S743<HH38@@3
48850003:DD3:FD6<HH3U;82ia`3mih6ool6cWT5Jdd36><32643000348826<<36><3Ljh3eYX3g_/5
ool3oml3mih3ked3ia`3g_/3Q102:DD302030003020326434:826<<38@@3Nll3e[X3ia`3mih5ool3
mkh3kgd3ic`3ia`8ool38B@2:DD3S543g]/6ool3oml2mih3ked3ia`3S743<HH38@@248860003:DD3
:FD5<HH3U;83ia`3mih6ool5cWT6Jdd36><32643000248836<<36><3Ljh3eYX3g_/5ool3oml3mih3
ked3ia`2g_/3Q103:DD302030003020326424:836<<38@@3Nll3e[X3ia`2mih6ool3mkh3kgd3ic`2
ia`9ool28B@3:DD3S543g]/6ool2oml3mih3ked3ia`3S743<HH28@@348860003:DD3:FD5<HH3U;83
ia`3mih5ool6cWT6Jdd36><32642000348836<<36><3Ljh3eYX2g_/6ool3oml3mih3ked2ia`3g_/3
Q103:DD302030002020326434:836<<38@@3Nll2e[X3ia`3mih6ool3mkh3kgd2ic`3ia`8ool38B@3
:DD3S543g]/5ool3oml3mih3ked3ia`2S743<HH38@@348860003:DD2:FD6<HH3U;83ia`3mih5ool6
cWT6Jdd26><32643000348836<<36><2Ljh3eYX3g_/6ool3oml2mih3ked3ia`3g_/3Q103:DD30202
0003020326434:836<<38@@2Nll3e[X3ia`3mih6ool2mkh3kgd3ic`3ia`Hool001Ooo`<Q90<YA@:<
D@?Nf`Koo`?og`?gWP;_G@?W70><L@<aQP<Q10<@PPD000<YA@<YI@HaQP>D/P;W70?gWPKoo`K>N@E[
C@<Hh`<8H@<000<@PP8H``<Hh`=c[P?FVP?Nn`Goo`?og`?gWP?_G@?W70?Nn`>4408YA@<080<000<0
80<8H@<@XP8H``<Q10=kc`?F^P?W70?gWPGoo`?g_P?_O@?W?0?W70Soo`<Q908YA@><D@?Nf`Koo`?o
g`;gWP?_G@?W70><L@<aQP<Q108@PPH000<YA@<YI@DaQP>D/P?W70?gWPKoo`G>N@I[C@<Hh`<8H@<0
008@PP<H``<Hh`=c[P?FVP?Nn`Goo`?og`?gWP?_G@?W70;Nn`>440<YA@<080<000<080<8H@8@XP<H
``<Q10=kc`?F^P?W70;gWPKoo`?g_P?_O@?W?0;W70Woo`8Q90<YA@><D@?Nf`Koo`;og`?gWP?_G@?W
70><L@<aQP8Q10<@PPH000<YA@<YI@DaQP>D/P?W70?gWPGoo`K>N@I[C@<Hh`<8H@8000<@PP<H``<H
h`=c[P?FVP;Nn`Koo`?og`?gWP?_G@;W70?Nn`>440<YA@<080<0008080<8H@<@XP<H``<Q10=kc`;F
^P?W70?gWPKoo`?g_P?_O@;W?0?W70Soo`<Q90<YA@><D@?Nf`Goo`?og`?gWP?_G@?W70:<L@<aQP<Q
10<@PPH000<YA@8YI@HaQP>D/P?W70?gWPGoo`K>N@I[C@8Hh`<8H@<000<@PP<H``<Hh`9c[P?FVP?N
n`Koo`?og`;gWP?_G@?W70?Nn`>440<YA@<0808000<080<8H@<@XP<H``<Q109kc`?F^P?W70?gWPKo
o`;g_P?_O@?W?0?W71Soo`005ooo0b4T0bU50XaA0mkK1_oo0ooO0oNN0^mM0nLL0haa0c660b440a22
1@000bU50bUU1S660iBb0^LL0oNN1_oo1/ii1F]=0aSS0`QQ0`000a220QS30aSS0g>^0mJJ0mkk1Ooo
0ooO0oNN0nmM0nLL0mkk0h@@0RU50`0P0`000`0P0`QQ0a2R0QS30b440g_?0mJj0nLL0oNN1Ooo0oNn
0nmm0nLl0nLL2?oo0b4T0RU50haA0mkK1_oo0ooO0_NN0nmM0nLL0haa0c660b440Q221P000bU50bUU
1C660iBb0nLL0oNN1_oo1Lii1V]=0aSS0`QQ0`000Q220aS30aSS0g>^0mJJ0mkk1Ooo0ooO0oNN0nmM
0nLL0]kk0h@@0bU50`0P0`000`0P0`QQ0Q2R0aS30b440g_?0mJj0nLL0_NN1_oo0oNn0nmm0nLl0^LL
2Ooo0R4T0bU50haA0mkK1_oo0_oO0oNN0nmM0nLL0haa0c660R440a221P000bU50bUU1C660iBb0nLL
0oNN1Ooo1/ii1V]=0aSS0`QQ0P000a220aS30aSS0g>^0mJJ0]kk1_oo0ooO0oNN0nmM0^LL0mkk0h@@
0bU50`0P0`000P0P0`QQ0a2R0aS30b440g_?0]Jj0nLL0oNN1_oo0oNn0nmm0^Ll0nLL2?oo0b4T0bU5
0haA0mkK1Ooo0ooO0oNN0nmM0nLL0Xaa0c660b440a221P000bU50RUU1S660iBb0nLL0oNN1Ooo1/ii
1V]=0QSS0`QQ0`000a220aS30aSS0W>^0mJJ0mkk1_oo0ooO0_NN0nmM0nLL0mkk0h@@0bU50`0P0P00
0`0P0`QQ0a2R0aS30b440W_?0mJj0nLL0oNN1_oo0_Nn0nmm0nLl0nLL6?oo000Gool38B@3:DD2S543
g]/6ool3oml3mih2ked3ia`3S743<HH38@@348850003:DD3:FD6<HH3U;82ia`3mih6ool6cWT5Jdd3
6><32643000348826<<36><3Ljh3eYX3g_/5ool3oml3mih3ked3ia`3g_/3Q102:DD3020300030203
26434:826<<38@@3Nll3e[X3ia`3mih5ool3mkh3kgd3ic`3ia`8ool38B@2:DD3S543g]/6ool3oml2
mih3ked3ia`3S743<HH38@@248860003:DD3:FD5<HH3U;83ia`3mih6ool5cWT6Jdd36><326430002
48836<<36><3Ljh3eYX3g_/5ool3oml3mih3ked3ia`2g_/3Q103:DD302030003020326424:836<<3
8@@3Nll3e[X3ia`2mih6ool3mkh3kgd3ic`2ia`9ool28B@3:DD3S543g]/6ool2oml3mih3ked3ia`3
S743<HH28@@348860003:DD3:FD5<HH3U;83ia`3mih5ool6cWT6Jdd36><32642000348836<<36><3
Ljh3eYX2g_/6ool3oml3mih3ked2ia`3g_/3Q103:DD302030002020326434:836<<38@@3Nll2e[X3
ia`3mih6ool3mkh3kgd2ic`3ia`8ool38B@3:DD3S543g]/5ool3oml3mih3ked3ia`2S743<HH38@@3
48860003:DD2:FD6<HH3U;83ia`3mih5ool6cWT6Jdd26><32643000348836<<36><2Ljh3eYX3g_/6
ool3oml2mih3ked3ia`3g_/3Q103:DD302020003020326434:836<<38@@2Nll3e[X3ia`3mih6ool2
mkh3kgd3ic`3ia`Hool001Ooo`<Q90<YA@:<D@?Nf`Koo`?og`?gWP;_G@?W70><L@<aQP<Q10<@PPD0
00<YA@<YI@HaQP>D/P;W70?gWPKoo`K>N@E[C@<Hh`<8H@<000<@PP8H``<Hh`=c[P?FVP?Nn`Goo`?o
g`?gWP?_G@?W70?Nn`>4408YA@<080<000<080<8H@<@XP8H``<Q10=kc`?F^P?W70?gWPGoo`?g_P?_
O@?W?0?W70Soo`<Q908YA@><D@?Nf`Koo`?og`;gWP?_G@?W70><L@<aQP<Q108@PPH000<YA@<YI@Da
QP>D/P?W70?gWPKoo`G>N@I[C@<Hh`<8H@<0008@PP<H``<Hh`=c[P?FVP?Nn`Goo`?og`?gWP?_G@?W
70;Nn`>440<YA@<080<000<080<8H@8@XP<H``<Q10=kc`?F^P?W70;gWPKoo`?g_P?_O@?W?0;W70Wo
o`8Q90<YA@><D@?Nf`Koo`;og`?gWP?_G@?W70><L@<aQP8Q10<@PPH000<YA@<YI@DaQP>D/P?W70?g
WPGoo`K>N@I[C@<Hh`<8H@8000<@PP<H``<Hh`=c[P?FVP;Nn`Koo`?og`?gWP?_G@;W70?Nn`>440<Y
A@<080<0008080<8H@<@XP<H``<Q10=kc`;F^P?W70?gWPKoo`?g_P?_O@;W?0?W70Soo`<Q90<YA@><
D@?Nf`Goo`?og`?gWP?_G@?W70:<L@<aQP<Q10<@PPH000<YA@8YI@HaQP>D/P?W70?gWPGoo`K>N@I[
C@8Hh`<8H@<000<@PP<H``<Hh`9c[P?FVP?Nn`Koo`?og`;gWP?_G@?W70?Nn`>440<YA@<0808000<0
80<8H@<@XP<H``<Q109kc`?F^P?W70?gWPKoo`;g_P?_O@?W?0?W71Soo`005ooo0b4T0bU50XaA0mkK
1_oo0ooO0oNN0^mM0nLL0haa0c660b440a221@000bU50bUU1S660iBb0^LL0oNN1_oo1/ii1F]=0aSS
0`QQ0`000a220QS30aSS0g>^0mJJ0mkk1Ooo0ooO0oNN0nmM0nLL0mkk0h@@0RU50`0P0`000`0P0`QQ
0a2R0QS30b440g_?0mJj0nLL0oNN1Ooo0oNn0nmm0nLl0nLL2?oo0b4T0RU50haA0mkK1_oo0ooO0_NN
0nmM0nLL0haa0c660b440Q221P000bU50bUU1C660iBb0nLL0oNN1_oo1Lii1V]=0aSS0`QQ0`000Q22
0aS30aSS0g>^0mJJ0mkk1Ooo0ooO0oNN0nmM0nLL0]kk0h@@0bU50`0P0`000`0P0`QQ0Q2R0aS30b44
0g_?0mJj0nLL0_NN1_oo0oNn0nmm0nLl0^LL2Ooo0R4T0bU50haA0mkK1_oo0_oO0oNN0nmM0nLL0haa
0c660R440a221P000bU50bUU1C660iBb0nLL0oNN1Ooo1/ii1V]=0aSS0`QQ0P000a220aS30aSS0g>^
0mJJ0]kk1_oo0ooO0oNN0nmM0^LL0mkk0h@@0bU50`0P0`000P0P0`QQ0a2R0aS30b440g_?0]Jj0nLL
0oNN1_oo0oNn0nmm0^Ll0nLL2?oo0b4T0bU50haA0mkK1Ooo0ooO0oNN0nmM0nLL0Xaa0c660b440a22
1P000bU50RUU1S660iBb0nLL0oNN1Ooo1/ii1V]=0QSS0`QQ0`000a220aS30aSS0W>^0mJJ0mkk1_oo
0ooO0_NN0nmM0nLL0mkk0h@@0bU50`0P0P000`0P0`QQ0a2R0aS30b440W_?0mJj0nLL0oNN1_oo0_Nn
0nmm0nLl0nLL6?oo000Gool38B@3:DD2S543g]/6ool3oml3mih2ked3ia`3S743<HH38@@348850003
:DD3:FD6<HH3U;82ia`3mih6ool6cWT5Jdd36><32643000348826<<36><3Ljh3eYX3g_/5ool3oml3
mih3ked3ia`3g_/3Q102:DD302030003020326434:826<<38@@3Nll3e[X3ia`3mih5ool3mkh3kgd3
ic`3ia`8ool38B@2:DD3S543g]/6ool3oml2mih3ked3ia`3S743<HH38@@248860003:DD3:FD5<HH3
U;83ia`3mih6ool5cWT6Jdd36><32643000248836<<36><3Ljh3eYX3g_/5ool3oml3mih3ked3ia`2
g_/3Q103:DD302030003020326424:836<<38@@3Nll3e[X3ia`2mih6ool3mkh3kgd3ic`2ia`9ool2
8B@3:DD3S543g]/6ool2oml3mih3ked3ia`3S743<HH28@@348860003:DD3:FD5<HH3U;83ia`3mih5
ool6cWT6Jdd36><32642000348836<<36><3Ljh3eYX2g_/6ool3oml3mih3ked2ia`3g_/3Q103:DD3
02030002020326434:836<<38@@3Nll2e[X3ia`3mih6ool3mkh3kgd2ic`3ia`8ool38B@3:DD3S543
g]/5ool3oml3mih3ked3ia`2S743<HH38@@348860003:DD2:FD6<HH3U;83ia`3mih5ool6cWT6Jdd2
6><32643000348836<<36><2Ljh3eYX3g_/6ool3oml2mih3ked3ia`3g_/3Q103:DD3020200030203
26434:836<<38@@2Nll3e[X3ia`3mih6ool2mkh3kgd3ic`3ia`Hool001Ooo`>4<0<YI@8080<000<Q
10<Q90>4<0>440;Nf`?og`?oo`?og`?660=Jj`<H``D000HYA@><D@?Nn`;_O@Koo`KFVP?>N@Q[K@<H
h`H0008Q10=kk`?F^P?og`?oo`?g_P;_O@?_G@?W70?Nn`?Nf`?F^P?FVP9cSP<Q10H000<080=2208i
i`>U50>U=0?_G@Koo`;F^PKFVP?>N@I[K@Soo`>4<08YI@<080<000<Q10<Q90>4<0:440?Nf`?og`?o
o`?og`?6609Jj`<H``H000HYA@:<D@?Nn`?_O@Koo`KFVP;>N@U[K@<Hh`D000<Q10=kk`?F^P?og`?o
o`;g_P?_O@?_G@?W70?Nn`?Nf`;F^P?FVP=cSP<Q10H000<0809220<ii`>U50>U=0?_G@Goo`?F^PKF
VP?>N@E[K@Woo`:4<0<YI@<080<000<Q10<Q90:4<0>440?Nf`?og`?oo`?og`;660=Jj`<H``H000DY
A@><D@?Nn`?_O@Koo`GFVP?>N@U[K@<Hh`D000<Q10=kk`?F^P?og`;oo`?g_P?_O@?_G@?W70?Nn`;N
f`?F^P?FVP=cSP<Q10D000<080=220<ii`>U50>U=0;_G@Koo`?F^PKFVP?>N@E[K@Soo`>4<0<YI@<0
80<0008Q10<Q90>4<0>440?Nf`?og`;oo`?og`?660=Jj`<H``H000DYA@><D@?Nn`?_O@Goo`KFVP?>
N@Q[K@<Hh`H000<Q10=kk`;F^P?og`?oo`?g_P?_O@?_G@;W70?Nn`?Nf`?F^P?FVP=cSP<Q10D000<0
80=220<ii`>U50:U=0?_G@Koo`?F^PGFVP?>N@I[KASoo`005ooo0h@`0bUU0P0P0`000b440b4T0h@`
0h@@0]kK0ooO0ooo0ooO0lHH0e[[0aS31@001RU50haA0mkk0^mm1_oo1]JJ0lii26]]0aSS1P000R44
0g__0mJj0ooO0ooo0oNn0^mm0nmM0nLL0mkk0mkK0mJj0mJJ0W>>0b441P000`0P0d880SWW0jDD0jDd
0nmM1_oo0]Jj1]JJ0lii1V]]2?oo0h@`0RUU0`0P0`000b440b4T0h@`0X@@0mkK0ooO0ooo0ooO0lHH
0U[[0aS31P001RU50XaA0mkk0nmm1_oo1]JJ0/ii2F]]0aSS1@000b440g__0mJj0ooO0ooo0_Nn0nmm
0nmM0nLL0mkk0mkK0]Jj0mJJ0g>>0b441P000`0P0T880cWW0jDD0jDd0nmM1Ooo0mJj1]JJ0lii1F]]
2Ooo0X@`0bUU0`0P0`000b440b4T0X@`0h@@0mkK0ooO0ooo0ooO0/HH0e[[0aS31P001BU50haA0mkk
0nmm1_oo1MJJ0lii2F]]0aSS1@000b440g__0mJj0ooO0_oo0oNn0nmm0nmM0nLL0mkk0]kK0mJj0mJJ
0g>>0b441@000`0P0d880cWW0jDD0jDd0^mM1_oo0mJj1]JJ0lii1F]]2?oo0h@`0bUU0`0P0`000R44
0b4T0h@`0h@@0mkK0ooO0_oo0ooO0lHH0e[[0aS31P001BU50haA0mkk0nmm1Ooo1]JJ0lii26]]0aSS
1P000b440g__0]Jj0ooO0ooo0oNn0nmm0nmM0^LL0mkk0mkK0mJj0mJJ0g>>0b441@000`0P0d880cWW
0jDD0ZDd0nmM1_oo0mJj1MJJ0lii1V]]6?oo000Gool3Q303:FD2020300038@@38B@3Q303Q102g]/3
oml3ool3oml3aQP3F^/36<<50006:DD3S543g_/2kgd6ool6eYX3cWT8Jfd36><600028@@3Nnl3e[X3
oml3ool3mkh2kgd3ked3ia`3g_/3g]/3e[X3eYX2Lhh38@@600030203@PP2>NL3YA@3YC@3ked6ool2
e[X6eYX3cWT6Jfd8ool3Q302:FD3020300038@@38B@3Q302Q103g]/3oml3ool3oml3aQP2F^/36<<6
0006:DD2S543g_/3kgd6ool6eYX2cWT9Jfd36><500038@@3Nnl3e[X3oml3ool2mkh3kgd3ked3ia`3
g_/3g]/2e[X3eYX3Lhh38@@600030202@PP3>NL3YA@3YC@3ked5ool3e[X6eYX3cWT5Jfd9ool2Q303
:FD3020300038@@38B@2Q303Q103g]/3oml3ool3oml2aQP3F^/36<<60005:DD3S543g_/3kgd6ool5
eYX3cWT9Jfd36><500038@@3Nnl3e[X3oml2ool3mkh3kgd3ked3ia`3g_/2g]/3e[X3eYX3Lhh38@@5
00030203@PP3>NL3YA@3YC@2ked6ool3e[X6eYX3cWT5Jfd8ool3Q303:FD3020300028@@38B@3Q303
Q103g]/3oml2ool3oml3aQP3F^/36<<60005:DD3S543g_/3kgd5ool6eYX3cWT8Jfd36><600038@@3
Nnl2e[X3oml3ool3mkh3kgd3ked2ia`3g_/3g]/3e[X3eYX3Lhh38@@500030203@PP3>NL3YA@2YC@3
ked6ool3e[X5eYX3cWT6JfdHool001Ooo`>4<0<YI@8080<000<Q10<Q90>4<0>440;Nf`?og`?oo`?o
g`?660=Jj`<H``D000HYA@><D@?Nn`;_O@Koo`KFVP?>N@Q[K@<Hh`H0008Q10=kk`?F^P?og`?oo`?g
_P;_O@?_G@?W70?Nn`?Nf`?F^P?FVP9cSP<Q10H000<080=2208ii`>U50>U=0?_G@Koo`;F^PKFVP?>
N@I[K@Soo`>4<08YI@<080<000<Q10<Q90>4<0:440?Nf`?og`?oo`?og`?6609Jj`<H``H000HYA@:<
D@?Nn`?_O@Koo`KFVP;>N@U[K@<Hh`D000<Q10=kk`?F^P?og`?oo`;g_P?_O@?_G@?W70?Nn`?Nf`;F
^P?FVP=cSP<Q10H000<0809220<ii`>U50>U=0?_G@Goo`?F^PKFVP?>N@E[K@Woo`:4<0<YI@<080<0
00<Q10<Q90:4<0>440?Nf`?og`?oo`?og`;660=Jj`<H``H000DYA@><D@?Nn`?_O@Koo`GFVP?>N@U[
K@<Hh`D000<Q10=kk`?F^P?og`;oo`?g_P?_O@?_G@?W70?Nn`;Nf`?F^P?FVP=cSP<Q10D000<080=2
20<ii`>U50>U=0;_G@Koo`?F^PKFVP?>N@E[K@Soo`>4<0<YI@<080<0008Q10<Q90>4<0>440?Nf`?o
g`;oo`?og`?660=Jj`<H``H000DYA@><D@?Nn`?_O@Goo`KFVP?>N@Q[K@<Hh`H000<Q10=kk`;F^P?o
g`?oo`?g_P?_O@?_G@;W70?Nn`?Nf`?F^P?FVP=cSP<Q10D000<080=220<ii`>U50:U=0?_G@Koo`?F
^PGFVP?>N@I[KASoo`005ooo0h@`0bUU0P0P0`000b440b4T0h@`0h@@0]kK0ooO0ooo0ooO0lHH0e[[
0aS31@001RU50haA0mkk0^mm1_oo1]JJ0lii26]]0aSS1P000R440g__0mJj0ooO0ooo0oNn0^mm0nmM
0nLL0mkk0mkK0mJj0mJJ0W>>0b441P000`0P0d880SWW0jDD0jDd0nmM1_oo0]Jj1]JJ0lii1V]]2?oo
0h@`0RUU0`0P0`000b440b4T0h@`0X@@0mkK0ooO0ooo0ooO0lHH0U[[0aS31P001RU50XaA0mkk0nmm
1_oo1]JJ0/ii2F]]0aSS1@000b440g__0mJj0ooO0ooo0_Nn0nmm0nmM0nLL0mkk0mkK0]Jj0mJJ0g>>
0b441P000`0P0T880cWW0jDD0jDd0nmM1Ooo0mJj1]JJ0lii1F]]2Ooo0X@`0bUU0`0P0`000b440b4T
0X@`0h@@0mkK0ooO0ooo0ooO0/HH0e[[0aS31P001BU50haA0mkk0nmm1_oo1MJJ0lii2F]]0aSS1@00
0b440g__0mJj0ooO0_oo0oNn0nmm0nmM0nLL0mkk0]kK0mJj0mJJ0g>>0b441@000`0P0d880cWW0jDD
0jDd0^mM1_oo0mJj1]JJ0lii1F]]2?oo0h@`0bUU0`0P0`000R440b4T0h@`0h@@0mkK0ooO0_oo0ooO
0lHH0e[[0aS31P001BU50haA0mkk0nmm1Ooo1]JJ0lii26]]0aSS1P000b440g__0]Jj0ooO0ooo0oNn
0nmm0nmM0^LL0mkk0mkK0mJj0mJJ0g>>0b441@000`0P0d880cWW0jDD0ZDd0nmM1_oo0mJj1MJJ0lii
1V]]6?oo000Gool3Q303:FD2020300038@@38B@3Q303Q102g]/3oml3ool3oml3aQP3F^/36<<50006
:DD3S543g_/2kgd6ool6eYX3cWT8Jfd36><600028@@3Nnl3e[X3oml3ool3mkh2kgd3ked3ia`3g_/3
g]/3e[X3eYX2Lhh38@@600030203@PP2>NL3YA@3YC@3ked6ool2e[X6eYX3cWT6Jfd8ool3Q302:FD3
020300038@@38B@3Q302Q103g]/3oml3ool3oml3aQP2F^/36<<60006:DD2S543g_/3kgd6ool6eYX2
cWT9Jfd36><500038@@3Nnl3e[X3oml3ool2mkh3kgd3ked3ia`3g_/3g]/2e[X3eYX3Lhh38@@60003
0202@PP3>NL3YA@3YC@3ked5ool3e[X6eYX3cWT5Jfd9ool2Q303:FD3020300038@@38B@2Q303Q103
g]/3oml3ool3oml2aQP3F^/36<<60005:DD3S543g_/3kgd6ool5eYX3cWT9Jfd36><500038@@3Nnl3
e[X3oml2ool3mkh3kgd3ked3ia`3g_/2g]/3e[X3eYX3Lhh38@@500030203@PP3>NL3YA@3YC@2ked6
ool3e[X6eYX3cWT5Jfd8ool3Q303:FD3020300028@@38B@3Q303Q103g]/3oml2ool3oml3aQP3F^/3
6<<60005:DD3S543g_/3kgd5ool6eYX3cWT8Jfd36><600038@@3Nnl2e[X3oml3ool3mkh3kgd3ked2
ia`3g_/3g]/3e[X3eYX3Lhh38@@500030203@PP3>NL3YA@2YC@3ked6ool3e[X5eYX3cWT6JfdHool0
01Ooo`>4<0<YI@8080<000<Q10<Q90>4<0>440;Nf`?og`?oo`?og`?660=Jj`<H``D000HYA@><D@?N
n`;_O@Koo`KFVP?>N@Q[K@<Hh`H0008Q10=kk`?F^P?og`?oo`?g_P;_O@?_G@?W70?Nn`?Nf`?F^P?F
VP9cSP<Q10H000<080=2208ii`>U50>U=0?_G@Koo`;F^PKFVP?>N@I[K@Soo`>4<08YI@<080<000<Q
10<Q90>4<0:440?Nf`?og`?oo`?og`?6609Jj`<H``H000HYA@:<D@?Nn`?_O@Koo`KFVP;>N@U[K@<H
h`D000<Q10=kk`?F^P?og`?oo`;g_P?_O@?_G@?W70?Nn`?Nf`;F^P?FVP=cSP<Q10H000<0809220<i
i`>U50>U=0?_G@Goo`?F^PKFVP?>N@E[K@Woo`:4<0<YI@<080<000<Q10<Q90:4<0>440?Nf`?og`?o
o`?og`;660=Jj`<H``H000DYA@><D@?Nn`?_O@Koo`GFVP?>N@U[K@<Hh`D000<Q10=kk`?F^P?og`;o
o`?g_P?_O@?_G@?W70?Nn`;Nf`?F^P?FVP=cSP<Q10D000<080=220<ii`>U50>U=0;_G@Koo`?F^PKF
VP?>N@E[K@Soo`>4<0<YI@<080<0008Q10<Q90>4<0>440?Nf`?og`;oo`?og`?660=Jj`<H``H000DY
A@><D@?Nn`?_O@Goo`KFVP?>N@Q[K@<Hh`H000<Q10=kk`;F^P?og`?oo`?g_P?_O@?_G@;W70?Nn`?N
f`?F^P?FVP=cSP<Q10D000<080=220<ii`>U50:U=0?_G@Koo`?F^PGFVP?>N@I[KASoo`005ooo0h@`
0bUU0P0P0`000b440b4T0h@`0h@@0]kK0ooO0ooo0ooO0lHH0e[[0aS31@001RU50haA0mkk0^mm1_oo
1]JJ0lii26]]0aSS1P000R440g__0mJj0ooO0ooo0oNn0^mm0nmM0nLL0mkk0mkK0mJj0mJJ0W>>0b44
1P000`0P0d880SWW0jDD0jDd0nmM1_oo0]Jj1]JJ0lii1V]]2?oo0h@`0RUU0`0P0`000b440b4T0h@`
0X@@0mkK0ooO0ooo0ooO0lHH0U[[0aS31P001RU50XaA0mkk0nmm1_oo1]JJ0/ii2F]]0aSS1@000b44
0g__0mJj0ooO0ooo0_Nn0nmm0nmM0nLL0mkk0mkK0]Jj0mJJ0g>>0b441P000`0P0T880cWW0jDD0jDd
0nmM1Ooo0mJj1]JJ0lii1F]]2Ooo0X@`0bUU0`0P0`000b440b4T0X@`0h@@0mkK0ooO0ooo0ooO0/HH
0e[[0aS31P001BU50haA0mkk0nmm1_oo1MJJ0lii2F]]0aSS1@000b440g__0mJj0ooO0_oo0oNn0nmm
0nmM0nLL0mkk0]kK0mJj0mJJ0g>>0b441@000`0P0d880cWW0jDD0jDd0^mM1_oo0mJj1]JJ0lii1F]]
2?oo0h@`0bUU0`0P0`000R440b4T0h@`0h@@0mkK0ooO0_oo0ooO0lHH0e[[0aS31P001BU50haA0mkk
0nmm1Ooo1]JJ0lii26]]0aSS1P000b440g__0]Jj0ooO0ooo0oNn0nmm0nmM0^LL0mkk0mkK0mJj0mJJ
0g>>0b441@000`0P0d880cWW0jDD0ZDd0nmM1_oo0mJj1MJJ0lii1V]]6?oo000Gool3Q303:FD20203
00038@@38B@3Q303Q102g]/3oml3ool3oml3aQP3F^/36<<50006:DD3S543g_/2kgd6ool6eYX3cWT8
Jfd36><600028@@3Nnl3e[X3oml3ool3mkh2kgd3ked3ia`3g_/3g]/3e[X3eYX2Lhh38@@600030203
@PP2>NL3YA@3YC@3ked6ool2e[X6eYX3cWT6Jfd8ool3Q302:FD3020300038@@38B@3Q302Q103g]/3
oml3ool3oml3aQP2F^/36<<60006:DD2S543g_/3kgd6ool6eYX2cWT9Jfd36><500038@@3Nnl3e[X3
oml3ool2mkh3kgd3ked3ia`3g_/3g]/2e[X3eYX3Lhh38@@600030202@PP3>NL3YA@3YC@3ked5ool3
e[X6eYX3cWT5Jfd9ool2Q303:FD3020300038@@38B@2Q303Q103g]/3oml3ool3oml2aQP3F^/36<<6
0005:DD3S543g_/3kgd6ool5eYX3cWT9Jfd36><500038@@3Nnl3e[X3oml2ool3mkh3kgd3ked3ia`3
g_/2g]/3e[X3eYX3Lhh38@@500030203@PP3>NL3YA@3YC@2ked6ool3e[X6eYX3cWT5Jfd8ool3Q303
:FD3020300028@@38B@3Q303Q103g]/3oml2ool3oml3aQP3F^/36<<60005:DD3S543g_/3kgd5ool6
eYX3cWT8Jfd36><600038@@3Nnl2e[X3oml3ool3mkh3kgd3ked2ia`3g_/3g]/3e[X3eYX3Lhh38@@5
00030203@PP3>NL3YA@2YC@3ked6ool3e[X5eYX3cWT6JfdHool001Ooo`>4<0<YI@8080<000<Q10<Q
90>4<0>440;Nf`?og`?oo`?og`?660=Jj`<H``D000HYA@><D@?Nn`;_O@Koo`KFVP?>N@Q[K@<Hh`H0
008Q10=kk`?F^P?og`?oo`?g_P;_O@?_G@?W70?Nn`?Nf`?F^P?FVP9cSP<Q10H000<080=2208ii`>U
50>U=0?_G@Koo`;F^PKFVP?>N@I[K@Soo`>4<08YI@<080<000<Q10<Q90>4<0:440?Nf`?og`?oo`?o
g`?6609Jj`<H``H000HYA@:<D@?Nn`?_O@Koo`KFVP;>N@U[K@<Hh`D000<Q10=kk`?F^P?og`?oo`;g
_P?_O@?_G@?W70?Nn`?Nf`;F^P?FVP=cSP<Q10H000<0809220<ii`>U50>U=0?_G@Goo`?F^PKFVP?>
N@E[K@Woo`:4<0<YI@<080<000<Q10<Q90:4<0>440?Nf`?og`?oo`?og`;660=Jj`<H``H000DYA@><
D@?Nn`?_O@Koo`GFVP?>N@U[K@<Hh`D000<Q10=kk`?F^P?og`;oo`?g_P?_O@?_G@?W70?Nn`;Nf`?F
^P?FVP=cSP<Q10D000<080=220<ii`>U50>U=0;_G@Koo`?F^PKFVP?>N@E[K@Soo`>4<0<YI@<080<0
008Q10<Q90>4<0>440?Nf`?og`;oo`?og`?660=Jj`<H``H000DYA@><D@?Nn`?_O@Goo`KFVP?>N@Q[
K@<Hh`H000<Q10=kk`;F^P?og`?oo`?g_P?_O@?_G@;W70?Nn`?Nf`?F^P?FVP=cSP<Q10D000<080=2
20<ii`>U50:U=0?_G@Koo`?F^PGFVP?>N@I[KASoo`005ooo0h@`0bUU0P0P0`000b440b4T0h@`0h@@
0]kK0ooO0ooo0ooO0lHH0e[[0aS31@001RU50haA0mkk0^mm1_oo1]JJ0lii26]]0aSS1P000R440g__
0mJj0ooO0ooo0oNn0^mm0nmM0nLL0mkk0mkK0mJj0mJJ0W>>0b441P000`0P0d880SWW0jDD0jDd0nmM
1_oo0]Jj1]JJ0lii1V]]2?oo0h@`0RUU0`0P0`000b440b4T0h@`0X@@0mkK0ooO0ooo0ooO0lHH0U[[
0aS31P001RU50XaA0mkk0nmm1_oo1]JJ0/ii2F]]0aSS1@000b440g__0mJj0ooO0ooo0_Nn0nmm0nmM
0nLL0mkk0mkK0]Jj0mJJ0g>>0b441P000`0P0T880cWW0jDD0jDd0nmM1Ooo0mJj1]JJ0lii1F]]2Ooo
0X@`0bUU0`0P0`000b440b4T0X@`0h@@0mkK0ooO0ooo0ooO0/HH0e[[0aS31P001BU50haA0mkk0nmm
1_oo1MJJ0lii2F]]0aSS1@000b440g__0mJj0ooO0_oo0oNn0nmm0nmM0nLL0mkk0]kK0mJj0mJJ0g>>
0b441@000`0P0d880cWW0jDD0jDd0^mM1_oo0mJj1]JJ0lii1F]]2?oo0h@`0bUU0`0P0`000R440b4T
0h@`0h@@0mkK0ooO0_oo0ooO0lHH0e[[0aS31P001BU50haA0mkk0nmm1Ooo1]JJ0lii26]]0aSS1P00
0b440g__0]Jj0ooO0ooo0oNn0nmm0nmM0^LL0mkk0mkK0mJj0mJJ0g>>0b441@000`0P0d880cWW0jDD
0ZDd0nmM1_oo0mJj1MJJ0lii1V]]6?oo000Gool36><3264500032446@RP3[ED2[GD3kgd3ool3mih3
[GD3]IH3BVT2488600030208@PP3>NL6YC@3[ED3ked5ool3e[X9Ljh28B@3020300038@@38B@3Q105
Nnl3e[X3oml3ool3oml3mih2[GD3BTT3@PP3264300034882F^/3aQP3cUT3e[X3oml3ool2oml3aQP3
F^/36<<302030008ool36><2264600032446@RP2[ED3[GD3kgd3ool3mih3[GD2]IH3BVT348860003
0208@PP3>NL6YC@3[ED2ked6ool3e[X8Ljh38B@3020300038@@38B@2Q106Nnl3e[X3oml3ool2oml3
mih3[GD3BTT3@PP3264300024883F^/3aQP3cUT3e[X3oml2ool3oml3aQP3F^/36<<302020009ool2
6><3264600032445@RP3[ED3[GD3kgd3ool3mih2[GD3]IH3BVT3488600020209@PP3>NL5YC@3[ED3
ked6ool3e[X8Ljh38B@3020300038@@28B@3Q106Nnl3e[X3oml2ool3oml3mih3[GD3BTT3@PP22643
00034883F^/3aQP3cUT2e[X3oml3ool3oml3aQP3F^/36<<202030008ool36><3264600022446@RP3
[ED3[GD3kgd2ool3mih3[GD3]IH3BVT3488500030209@PP3>NL5YC@3[ED3ked6ool2e[X9Ljh38B@3
020200038@@38B@3Q106Nnl2e[X3oml3ool3oml3mih3[GD3BTT2@PP3264300034883F^/3aQP2cUT3
e[X3oml3ool3oml3aQP2F^/36<<30203000Hool001Ooo`<Hh`<8H@D000<8@@I2:0>]E@:]M@?_O@?o
o`?gWP>]M@>eUP=:J@8@PPH000<080Q220<ii`JU=0>]E@?_G@Goo`?F^PUc[P8Q90<080<000<Q10<Q
90>440Ekk`?F^P?og`?oo`?og`?gWP:]M@=:B@=220<8H@<000<@PP9Jj`?660?>F@?F^P?og`?oo`;o
g`?660=Jj`<H``<080<000Soo`<Hh`88H@H000<8@@I2:0:]E@>]M@?_O@?oo`?gWP>]M@:eUP=:J@<@
PPH000<080Q220<ii`JU=0>]E@;_G@Koo`?F^PQc[P<Q90<080<000<Q10<Q90:440Ikk`?F^P?og`?o
o`;og`?gWP>]M@=:B@=220<8H@<0008@PP=Jj`?660?>F@?F^P?og`;oo`?og`?660=Jj`<H``<08080
00Woo`8Hh`<8H@H000<8@@E2:0>]E@>]M@?_O@?oo`?gWP:]M@>eUP=:J@<@PPH0008080U220<ii`FU
=0>]E@?_G@Koo`?F^PQc[P<Q90<080<000<Q108Q90>440Ikk`?F^P?og`;oo`?og`?gWP>]M@=:B@=2
2088H@<000<@PP=Jj`?660?>F@;F^P?og`?oo`?og`?660=Jj`<H``8080<000Soo`<Hh`<8H@H00088
@@I2:0>]E@>]M@?_O@;oo`?gWP>]M@>eUP=:J@<@PPD000<080U220<ii`FU=0>]E@?_G@Koo`;F^PUc
[P<Q90<0808000<Q10<Q90>440Ikk`;F^P?og`?oo`?og`?gWP>]M@=:B@9220<8H@<000<@PP=Jj`?6
60;>F@?F^P?og`?oo`?og`?6609Jj`<H``<080<001Soo`005ooo0aSS0`QQ1@000`Q11T8X0jeE0Zee
0nmm0ooo0oNN0jee0kFF0dYY0Q221P000`0P24880cWW1ZDd0jeE0nmM1Ooo0mJj2G>^0R4T0`0P0`00
0b440b4T0h@@1G__0mJj0ooO0ooo0ooO0oNN0Zee0dY90d880`QQ0`000a220U[[0lHH0liI0mJj0ooO
0ooo0_oO0lHH0e[[0aS30`0P0`002?oo0aSS0PQQ1P000`Q11T8X0ZeE0jee0nmm0ooo0oNN0jee0[FF
0dYY0a221P000`0P24880cWW1ZDd0jeE0^mM1_oo0mJj27>^0b4T0`0P0`000b440b4T0X@@1W__0mJj
0ooO0ooo0_oO0oNN0jee0dY90d880`QQ0`000Q220e[[0lHH0liI0mJj0ooO0_oo0ooO0lHH0e[[0aS3
0`0P0P002Ooo0QSS0`QQ1P000`Q11D8X0jeE0jee0nmm0ooo0oNN0Zee0kFF0dYY0a221P000P0P2D88
0cWW1JDd0jeE0nmM1_oo0mJj27>^0b4T0`0P0`000b440R4T0h@@1W__0mJj0ooO0_oo0ooO0oNN0jee
0dY90d880PQQ0`000a220e[[0lHH0liI0]Jj0ooO0ooo0ooO0lHH0e[[0aS30P0P0`002?oo0aSS0`QQ
1P000PQ11T8X0jeE0jee0nmm0_oo0oNN0jee0kFF0dYY0a221@000`0P2D880cWW1JDd0jeE0nmM1_oo
0]Jj2G>^0b4T0`0P0P000b440b4T0h@@1W__0]Jj0ooO0ooo0ooO0oNN0jee0dY90T880`QQ0`000a22
0e[[0lHH0/iI0mJj0ooO0ooo0ooO0lHH0U[[0aS30`0P0`006?oo000Gool36><3264500032446@RP3
[ED2[GD3kgd3ool3mih3[GD3]IH3BVT2488600030208@PP3>NL6YC@3[ED3ked5ool3e[X9Ljh28B@3
020300038@@38B@3Q105Nnl3e[X3oml3ool3oml3mih2[GD3BTT3@PP3264300034882F^/3aQP3cUT3
e[X3oml3ool2oml3aQP3F^/36<<302030008ool36><2264600032446@RP2[ED3[GD3kgd3ool3mih3
[GD2]IH3BVT3488600030208@PP3>NL6YC@3[ED2ked6ool3e[X8Ljh38B@3020300038@@38B@2Q106
Nnl3e[X3oml3ool2oml3mih3[GD3BTT3@PP3264300024883F^/3aQP3cUT3e[X3oml2ool3oml3aQP3
F^/36<<302020009ool26><3264600032445@RP3[ED3[GD3kgd3ool3mih2[GD3]IH3BVT348860002
0209@PP3>NL5YC@3[ED3ked6ool3e[X8Ljh38B@3020300038@@28B@3Q106Nnl3e[X3oml2ool3oml3
mih3[GD3BTT3@PP2264300034883F^/3aQP3cUT2e[X3oml3ool3oml3aQP3F^/36<<202030008ool3
6><3264600022446@RP3[ED3[GD3kgd2ool3mih3[GD3]IH3BVT3488500030209@PP3>NL5YC@3[ED3
ked6ool2e[X9Ljh38B@3020200038@@38B@3Q106Nnl2e[X3oml3ool3oml3mih3[GD3BTT2@PP32643
00034883F^/3aQP2cUT3e[X3oml3ool3oml3aQP2F^/36<<30203000Hool001Ooo`<Hh`<8H@D000<8
@@I2:0>]E@:]M@?_O@?oo`?gWP>]M@>eUP=:J@8@PPH000<080Q220<ii`JU=0>]E@?_G@Goo`?F^PUc
[P8Q90<080<000<Q10<Q90>440Ekk`?F^P?og`?oo`?og`?gWP:]M@=:B@=220<8H@<000<@PP9Jj`?6
60?>F@?F^P?og`?oo`;og`?660=Jj`<H``<080<000Soo`<Hh`88H@H000<8@@I2:0:]E@>]M@?_O@?o
o`?gWP>]M@:eUP=:J@<@PPH000<080Q220<ii`JU=0>]E@;_G@Koo`?F^PQc[P<Q90<080<000<Q10<Q
90:440Ikk`?F^P?og`?oo`;og`?gWP>]M@=:B@=220<8H@<0008@PP=Jj`?660?>F@?F^P?og`;oo`?o
g`?660=Jj`<H``<0808000Woo`8Hh`<8H@H000<8@@E2:0>]E@>]M@?_O@?oo`?gWP:]M@>eUP=:J@<@
PPH0008080U220<ii`FU=0>]E@?_G@Koo`?F^PQc[P<Q90<080<000<Q108Q90>440Ikk`?F^P?og`;o
o`?og`?gWP>]M@=:B@=22088H@<000<@PP=Jj`?660?>F@;F^P?og`?oo`?og`?660=Jj`<H``8080<0
00Soo`<Hh`<8H@H00088@@I2:0>]E@>]M@?_O@;oo`?gWP>]M@>eUP=:J@<@PPD000<080U220<ii`FU
=0>]E@?_G@Koo`;F^PUc[P<Q90<0808000<Q10<Q90>440Ikk`;F^P?og`?oo`?og`?gWP>]M@=:B@92
20<8H@<000<@PP=Jj`?660;>F@?F^P?og`?oo`?og`?6609Jj`<H``<080<001Soo`005ooo0aSS0`QQ
1@000`Q11T8X0jeE0Zee0nmm0ooo0oNN0jee0kFF0dYY0Q221P000`0P24880cWW1ZDd0jeE0nmM1Ooo
0mJj2G>^0R4T0`0P0`000b440b4T0h@@1G__0mJj0ooO0ooo0ooO0oNN0Zee0dY90d880`QQ0`000a22
0U[[0lHH0liI0mJj0ooO0ooo0_oO0lHH0e[[0aS30`0P0`002?oo0aSS0PQQ1P000`Q11T8X0ZeE0jee
0nmm0ooo0oNN0jee0[FF0dYY0a221P000`0P24880cWW1ZDd0jeE0^mM1_oo0mJj27>^0b4T0`0P0`00
0b440b4T0X@@1W__0mJj0ooO0ooo0_oO0oNN0jee0dY90d880`QQ0`000Q220e[[0lHH0liI0mJj0ooO
0_oo0ooO0lHH0e[[0aS30`0P0P002Ooo0QSS0`QQ1P000`Q11D8X0jeE0jee0nmm0ooo0oNN0Zee0kFF
0dYY0a221P000P0P2D880cWW1JDd0jeE0nmM1_oo0mJj27>^0b4T0`0P0`000b440R4T0h@@1W__0mJj
0ooO0_oo0ooO0oNN0jee0dY90d880PQQ0`000a220e[[0lHH0liI0]Jj0ooO0ooo0ooO0lHH0e[[0aS3
0P0P0`002?oo0aSS0`QQ1P000PQ11T8X0jeE0jee0nmm0_oo0oNN0jee0kFF0dYY0a221@000`0P2D88
0cWW1JDd0jeE0nmM1_oo0]Jj2G>^0b4T0`0P0P000b440b4T0h@@1W__0]Jj0ooO0ooo0ooO0oNN0jee
0dY90T880`QQ0`000a220e[[0lHH0/iI0mJj0ooO0ooo0ooO0lHH0U[[0aS30`0P0`006?oo000Gool3
6><3264500032446@RP3[ED2[GD3kgd3ool3mih3[GD3]IH3BVT2488600030208@PP3>NL6YC@3[ED3
ked5ool3e[X9Ljh28B@3020300038@@38B@3Q105Nnl3e[X3oml3ool3oml3mih2[GD3BTT3@PP32643
00034882F^/3aQP3cUT3e[X3oml3ool2oml3aQP3F^/36<<302030008ool36><2264600032446@RP2
[ED3[GD3kgd3ool3mih3[GD2]IH3BVT3488600030208@PP3>NL6YC@3[ED2ked6ool3e[X8Ljh38B@3
020300038@@38B@2Q106Nnl3e[X3oml3ool2oml3mih3[GD3BTT3@PP3264300024883F^/3aQP3cUT3
e[X3oml2ool3oml3aQP3F^/36<<302020009ool26><3264600032445@RP3[ED3[GD3kgd3ool3mih2
[GD3]IH3BVT3488600020209@PP3>NL5YC@3[ED3ked6ool3e[X8Ljh38B@3020300038@@28B@3Q106
Nnl3e[X3oml2ool3oml3mih3[GD3BTT3@PP2264300034883F^/3aQP3cUT2e[X3oml3ool3oml3aQP3
F^/36<<202030008ool36><3264600022446@RP3[ED3[GD3kgd2ool3mih3[GD3]IH3BVT348850003
0209@PP3>NL5YC@3[ED3ked6ool2e[X9Ljh38B@3020200038@@38B@3Q106Nnl2e[X3oml3ool3oml3
mih3[GD3BTT2@PP3264300034883F^/3aQP2cUT3e[X3oml3ool3oml3aQP2F^/36<<30203000Hool0
01Ooo`<Hh`<8H@D000<8@@I2:0>]E@:]M@?_O@?oo`?gWP>]M@>eUP=:J@8@PPH000<080Q220<ii`JU
=0>]E@?_G@Goo`?F^PUc[P8Q90<080<000<Q10<Q90>440Ekk`?F^P?og`?oo`?og`?gWP:]M@=:B@=2
20<8H@<000<@PP9Jj`?660?>F@?F^P?og`?oo`;og`?660=Jj`<H``<080<000Soo`<Hh`88H@H000<8
@@I2:0:]E@>]M@?_O@?oo`?gWP>]M@:eUP=:J@<@PPH000<080Q220<ii`JU=0>]E@;_G@Koo`?F^PQc
[P<Q90<080<000<Q10<Q90:440Ikk`?F^P?og`?oo`;og`?gWP>]M@=:B@=220<8H@<0008@PP=Jj`?6
60?>F@?F^P?og`;oo`?og`?660=Jj`<H``<0808000Woo`8Hh`<8H@H000<8@@E2:0>]E@>]M@?_O@?o
o`?gWP:]M@>eUP=:J@<@PPH0008080U220<ii`FU=0>]E@?_G@Koo`?F^PQc[P<Q90<080<000<Q108Q
90>440Ikk`?F^P?og`;oo`?og`?gWP>]M@=:B@=22088H@<000<@PP=Jj`?660?>F@;F^P?og`?oo`?o
g`?660=Jj`<H``8080<000Soo`<Hh`<8H@H00088@@I2:0>]E@>]M@?_O@;oo`?gWP>]M@>eUP=:J@<@
PPD000<080U220<ii`FU=0>]E@?_G@Koo`;F^PUc[P<Q90<0808000<Q10<Q90>440Ikk`;F^P?og`?o
o`?og`?gWP>]M@=:B@9220<8H@<000<@PP=Jj`?660;>F@?F^P?og`?oo`?og`?6609Jj`<H``<080<0
01Soo`005ooo0aSS0`QQ1@000`Q11T8X0jeE0Zee0nmm0ooo0oNN0jee0kFF0dYY0Q221P000`0P2488
0cWW1ZDd0jeE0nmM1Ooo0mJj2G>^0R4T0`0P0`000b440b4T0h@@1G__0mJj0ooO0ooo0ooO0oNN0Zee
0dY90d880`QQ0`000a220U[[0lHH0liI0mJj0ooO0ooo0_oO0lHH0e[[0aS30`0P0`002?oo0aSS0PQQ
1P000`Q11T8X0ZeE0jee0nmm0ooo0oNN0jee0[FF0dYY0a221P000`0P24880cWW1ZDd0jeE0^mM1_oo
0mJj27>^0b4T0`0P0`000b440b4T0X@@1W__0mJj0ooO0ooo0_oO0oNN0jee0dY90d880`QQ0`000Q22
0e[[0lHH0liI0mJj0ooO0_oo0ooO0lHH0e[[0aS30`0P0P002Ooo0QSS0`QQ1P000`Q11D8X0jeE0jee
0nmm0ooo0oNN0Zee0kFF0dYY0a221P000P0P2D880cWW1JDd0jeE0nmM1_oo0mJj27>^0b4T0`0P0`00
0b440R4T0h@@1W__0mJj0ooO0_oo0ooO0oNN0jee0dY90d880PQQ0`000a220e[[0lHH0liI0]Jj0ooO
0ooo0ooO0lHH0e[[0aS30P0P0`002?oo0aSS0`QQ1P000PQ11T8X0jeE0jee0nmm0_oo0oNN0jee0kFF
0dYY0a221@000`0P2D880cWW1JDd0jeE0nmM1_oo0]Jj2G>^0b4T0`0P0P000b440b4T0h@@1W__0]Jj
0ooO0ooo0ooO0oNN0jee0dY90T880`QQ0`000a220e[[0lHH0/iI0mJj0ooO0ooo0ooO0lHH0U[[0aS3
0`0P0`006?oo000Gool36><3264500032446@RP3[ED2[GD3kgd3ool3mih3[GD3]IH3BVT248860003
0208@PP3>NL6YC@3[ED3ked5ool3e[X9Ljh28B@3020300038@@38B@3Q105Nnl3e[X3oml3ool3oml3
mih2[GD3BTT3@PP3264300034882F^/3aQP3cUT3e[X3oml3ool2oml3aQP3F^/36<<302030008ool3
6><2264600032446@RP2[ED3[GD3kgd3ool3mih3[GD2]IH3BVT3488600030208@PP3>NL6YC@3[ED2
ked6ool3e[X8Ljh38B@3020300038@@38B@2Q106Nnl3e[X3oml3ool2oml3mih3[GD3BTT3@PP32643
00024883F^/3aQP3cUT3e[X3oml2ool3oml3aQP3F^/36<<302020009ool26><3264600032445@RP3
[ED3[GD3kgd3ool3mih2[GD3]IH3BVT3488600020209@PP3>NL5YC@3[ED3ked6ool3e[X8Ljh38B@3
020300038@@28B@3Q106Nnl3e[X3oml2ool3oml3mih3[GD3BTT3@PP2264300034883F^/3aQP3cUT2
e[X3oml3ool3oml3aQP3F^/36<<202030008ool36><3264600022446@RP3[ED3[GD3kgd2ool3mih3
[GD3]IH3BVT3488500030209@PP3>NL5YC@3[ED3ked6ool2e[X9Ljh38B@3020200038@@38B@3Q106
Nnl2e[X3oml3ool3oml3mih3[GD3BTT2@PP3264300034883F^/3aQP2cUT3e[X3oml3ool3oml3aQP2
F^/36<<30203000Hool001Ooo`<Hh`<8H@D000<8@@I2:0>]E@:]M@?_O@?oo`?gWP>]M@>eUP=:J@8@
PPH000<080Q220<ii`JU=0>]E@?_G@Goo`?F^PUc[P8Q90<080<000<Q10<Q90>440Ekk`?F^P?og`?o
o`?og`?gWP:]M@=:B@=220<8H@<000<@PP9Jj`?660?>F@?F^P?og`?oo`;og`?660=Jj`<H``<080<0
00Soo`<Hh`88H@H000<8@@I2:0:]E@>]M@?_O@?oo`?gWP>]M@:eUP=:J@<@PPH000<080Q220<ii`JU
=0>]E@;_G@Koo`?F^PQc[P<Q90<080<000<Q10<Q90:440Ikk`?F^P?og`?oo`;og`?gWP>]M@=:B@=2
20<8H@<0008@PP=Jj`?660?>F@?F^P?og`;oo`?og`?660=Jj`<H``<0808000Woo`8Hh`<8H@H000<8
@@E2:0>]E@>]M@?_O@?oo`?gWP:]M@>eUP=:J@<@PPH0008080U220<ii`FU=0>]E@?_G@Koo`?F^PQc
[P<Q90<080<000<Q108Q90>440Ikk`?F^P?og`;oo`?og`?gWP>]M@=:B@=22088H@<000<@PP=Jj`?6
60?>F@;F^P?og`?oo`?og`?660=Jj`<H``8080<000Soo`<Hh`<8H@H00088@@I2:0>]E@>]M@?_O@;o
o`?gWP>]M@>eUP=:J@<@PPD000<080U220<ii`FU=0>]E@?_G@Koo`;F^PUc[P<Q90<0808000<Q10<Q
90>440Ikk`;F^P?og`?oo`?og`?gWP>]M@=:B@9220<8H@<000<@PP=Jj`?660;>F@?F^P?og`?oo`?o
g`?6609Jj`<H``<080<001Soo`005ooo0aS30aSS0R440g__0mJj0ooO0ooo0ooO1LHH0e[[0aS31P00
0b4T0RU51XaA0mkk1_oo0_Nn2KFf0e::0dYY0TY90`QQ1P000`Q10dY90Zee0nmm1_oo0ooO0oNN0^mM
0nLL0mkk0mkK0mJj1]JJ1Lii0liI0f]=0aSS0`QQ1@000`Q10a220aS30aSS0R440b4T1X@`0mkK0nmM
2?oo0aS30QSS0b440g__0mJj0ooO0ooo0_oO1/HH0e[[0aS31@000b4T0bU51XaA0mkk1Ooo0oNn2KFf
0e::0TYY0dY90`QQ1P000`Q10TY90jee0nmm1_oo0ooO0_NN0nmM0nLL0mkk0mkK0mJj1MJJ1/ii0liI
0f]=0aSS0PQQ1P000`Q10a220aS30QSS0b440b4T1X@`0mkK0^mM2Ooo0QS30aSS0b440g__0mJj0ooO
0_oo0ooO1/HH0e[[0aS31@000b4T0bU51XaA0]kk1_oo0oNn2;Ff0e::0dYY0dY90`QQ1P000PQ10dY9
0jee0nmm1_oo0_oO0oNN0nmM0nLL0mkk0mkK0]Jj1]JJ1/ii0liI0V]=0aSS0`QQ1P000`Q10Q220aS3
0aSS0b440b4T1X@`0]kK0nmM2?oo0aS30aSS0b440g__0]Jj0ooO0ooo0ooO1/HH0U[[0aS31P000b4T
0bU51HaA0mkk1_oo0oNn2;Ff0e::0dYY0dY90`QQ1@000`Q10dY90jee0nmm1Ooo0ooO0oNN0nmM0nLL
0]kk0mkK0mJj1]JJ1/ii0/iI0f]=0aSS0`QQ1P000PQ10a220aS30aSS0b440b4T1H@`0mkK0nmM6?oo
000Gool36<<36><28@@3Nnl3e[X3oml3ool3oml5aQP3F^/36<<600038B@2:DD6S543g_/6ool2mkh9
]KH3DXX3BVT2BTT3264600032443BTT2[GD3kgd6ool3oml3mih2ked3ia`3g_/3g]/3e[X6eYX5cWT3
cUT3Jdd36><326450003244348836<<36><28@@38B@6Q303g]/3ked8ool36<<26><38@@3Nnl3e[X3
oml3ool2oml6aQP3F^/36<<500038B@3:DD6S543g_/5ool3mkh9]KH3DXX2BVT3BTT3264600032442
BTT3[GD3kgd6ool3oml2mih3ked3ia`3g_/3g]/3e[X5eYX6cWT3cUT3Jdd36><22646000324434883
6<<26><38@@38B@6Q303g]/2ked9ool26<<36><38@@3Nnl3e[X3oml2ool3oml6aQP3F^/36<<50003
8B@3:DD6S542g_/6ool3mkh8]KH3DXX3BVT3BTT3264600022443BTT3[GD3kgd6ool2oml3mih3ked3
ia`3g_/3g]/2e[X6eYX6cWT3cUT2Jdd36><326460003244248836<<36><38@@38B@6Q302g]/3ked8
ool36<<36><38@@3Nnl2e[X3oml3ool3oml6aQP2F^/36<<600038B@3:DD5S543g_/6ool3mkh8]KH3
DXX3BVT3BTT3264500032443BTT3[GD3kgd5ool3oml3mih3ked3ia`2g_/3g]/3e[X6eYX6cWT2cUT3
Jdd36><326460002244348836<<36><38@@38B@5Q303g]/3kedHool001Ooo`<H``<Hh`8Q10=kk`?F
^P?og`?oo`?og`G660=Jj`<H``H000<Q908YA@J<D@?Nn`Koo`;g_PVe]P=BRP=:J@9:B@<8H@H000<8
@@=:B@:]M@?_O@Koo`?og`?gWP;_G@?W70?Nn`?Nf`?F^PKFVPG>N@?>F@=[C@<Hh`<8H@D000<8@@<@
PP<H``<Hh`8Q10<Q90J4<0?Nf`?_G@Soo`<H``8Hh`<Q10=kk`?F^P?og`?oo`;og`K660=Jj`<H``D0
00<Q90<YA@J<D@?Nn`Goo`?g_PVe]P=BRP9:J@=:B@<8H@H000<8@@9:B@>]M@?_O@Koo`?og`;gWP?_
G@?W70?Nn`?Nf`?F^PGFVPK>N@?>F@=[C@<Hh`88H@H000<8@@<@PP<H``8Hh`<Q10<Q90J4<0?Nf`;_
G@Woo`8H``<Hh`<Q10=kk`?F^P?og`;oo`?og`K660=Jj`<H``D000<Q90<YA@J<D@;Nn`Koo`?g_PRe
]P=BRP=:J@=:B@<8H@H00088@@=:B@>]M@?_O@Koo`;og`?gWP?_G@?W70?Nn`?Nf`;F^PKFVPK>N@?>
F@9[C@<Hh`<8H@H000<8@@8@PP<H``<Hh`<Q10<Q90J4<0;Nf`?_G@Soo`<H``<Hh`<Q10=kk`;F^P?o
g`?oo`?og`K6609Jj`<H``H000<Q90<YA@F<D@?Nn`Koo`?g_PRe]P=BRP=:J@=:B@<8H@D000<8@@=:
B@>]M@?_O@Goo`?og`?gWP?_G@?W70;Nn`?Nf`?F^PKFVPK>N@;>F@=[C@<Hh`<8H@H00088@@<@PP<H
``<Hh`<Q10<Q90F4<0?Nf`?_GASoo`005ooo0aS30aSS0R440g__0mJj0ooO0ooo0ooO1LHH0e[[0aS3
1P000b4T0RU51XaA0mkk1_oo0_Nn2KFf0e::0dYY0TY90`QQ1P000`Q10dY90Zee0nmm1_oo0ooO0oNN
0^mM0nLL0mkk0mkK0mJj1]JJ1Lii0liI0f]=0aSS0`QQ1@000`Q10a220aS30aSS0R440b4T1X@`0mkK
0nmM2?oo0aS30QSS0b440g__0mJj0ooO0ooo0_oO1/HH0e[[0aS31@000b4T0bU51XaA0mkk1Ooo0oNn
2KFf0e::0TYY0dY90`QQ1P000`Q10TY90jee0nmm1_oo0ooO0_NN0nmM0nLL0mkk0mkK0mJj1MJJ1/ii
0liI0f]=0aSS0PQQ1P000`Q10a220aS30QSS0b440b4T1X@`0mkK0^mM2Ooo0QS30aSS0b440g__0mJj
0ooO0_oo0ooO1/HH0e[[0aS31@000b4T0bU51XaA0]kk1_oo0oNn2;Ff0e::0dYY0dY90`QQ1P000PQ1
0dY90jee0nmm1_oo0_oO0oNN0nmM0nLL0mkk0mkK0]Jj1]JJ1/ii0liI0V]=0aSS0`QQ1P000`Q10Q22
0aS30aSS0b440b4T1X@`0]kK0nmM2?oo0aS30aSS0b440g__0]Jj0ooO0ooo0ooO1/HH0U[[0aS31P00
0b4T0bU51HaA0mkk1_oo0oNn2;Ff0e::0dYY0dY90`QQ1@000`Q10dY90jee0nmm1Ooo0ooO0oNN0nmM
0nLL0]kk0mkK0mJj1]JJ1/ii0/iI0f]=0aSS0`QQ1P000PQ10a220aS30aSS0b440b4T1H@`0mkK0nmM
6?oo000Gool36<<36><28@@3Nnl3e[X3oml3ool3oml5aQP3F^/36<<600038B@2:DD6S543g_/6ool2
mkh9]KH3DXX3BVT2BTT3264600032443BTT2[GD3kgd6ool3oml3mih2ked3ia`3g_/3g]/3e[X6eYX5
cWT3cUT3Jdd36><326450003244348836<<36><28@@38B@6Q303g]/3ked8ool36<<26><38@@3Nnl3
e[X3oml3ool2oml6aQP3F^/36<<500038B@3:DD6S543g_/5ool3mkh9]KH3DXX2BVT3BTT326460003
2442BTT3[GD3kgd6ool3oml2mih3ked3ia`3g_/3g]/3e[X5eYX6cWT3cUT3Jdd36><2264600032443
48836<<26><38@@38B@6Q303g]/2ked9ool26<<36><38@@3Nnl3e[X3oml2ool3oml6aQP3F^/36<<5
00038B@3:DD6S542g_/6ool3mkh8]KH3DXX3BVT3BTT3264600022443BTT3[GD3kgd6ool2oml3mih3
ked3ia`3g_/3g]/2e[X6eYX6cWT3cUT2Jdd36><326460003244248836<<36><38@@38B@6Q302g]/3
ked8ool36<<36><38@@3Nnl2e[X3oml3ool3oml6aQP2F^/36<<600038B@3:DD5S543g_/6ool3mkh8
]KH3DXX3BVT3BTT3264500032443BTT3[GD3kgd5ool3oml3mih3ked3ia`2g_/3g]/3e[X6eYX6cWT2
cUT3Jdd36><326460002244348836<<36><38@@38B@5Q303g]/3kedHool001Ooo`<H``<Hh`8Q10=k
k`?F^P?og`?oo`?og`G660=Jj`<H``H000<Q908YA@J<D@?Nn`Koo`;g_PVe]P=BRP=:J@9:B@<8H@H0
00<8@@=:B@:]M@?_O@Koo`?og`?gWP;_G@?W70?Nn`?Nf`?F^PKFVPG>N@?>F@=[C@<Hh`<8H@D000<8
@@<@PP<H``<Hh`8Q10<Q90J4<0?Nf`?_G@Soo`<H``8Hh`<Q10=kk`?F^P?og`?oo`;og`K660=Jj`<H
``D000<Q90<YA@J<D@?Nn`Goo`?g_PVe]P=BRP9:J@=:B@<8H@H000<8@@9:B@>]M@?_O@Koo`?og`;g
WP?_G@?W70?Nn`?Nf`?F^PGFVPK>N@?>F@=[C@<Hh`88H@H000<8@@<@PP<H``8Hh`<Q10<Q90J4<0?N
f`;_G@Woo`8H``<Hh`<Q10=kk`?F^P?og`;oo`?og`K660=Jj`<H``D000<Q90<YA@J<D@;Nn`Koo`?g
_PRe]P=BRP=:J@=:B@<8H@H00088@@=:B@>]M@?_O@Koo`;og`?gWP?_G@?W70?Nn`?Nf`;F^PKFVPK>
N@?>F@9[C@<Hh`<8H@H000<8@@8@PP<H``<Hh`<Q10<Q90J4<0;Nf`?_G@Soo`<H``<Hh`<Q10=kk`;F
^P?og`?oo`?og`K6609Jj`<H``H000<Q90<YA@F<D@?Nn`Koo`?g_PRe]P=BRP=:J@=:B@<8H@D000<8
@@=:B@>]M@?_O@Goo`?og`?gWP?_G@?W70;Nn`?Nf`?F^PKFVPK>N@;>F@=[C@<Hh`<8H@H00088@@<@
PP<H``<Hh`<Q10<Q90F4<0?Nf`?_GASoo`005ooo0aS30aSS0R440g__0mJj0ooO0ooo0ooO1LHH0e[[
0aS31P000b4T0RU51XaA0mkk1_oo0_Nn2KFf0e::0dYY0TY90`QQ1P000`Q10dY90Zee0nmm1_oo0ooO
0oNN0^mM0nLL0mkk0mkK0mJj1]JJ1Lii0liI0f]=0aSS0`QQ1@000`Q10a220aS30aSS0R440b4T1X@`
0mkK0nmM2?oo0aS30QSS0b440g__0mJj0ooO0ooo0_oO1/HH0e[[0aS31@000b4T0bU51XaA0mkk1Ooo
0oNn2KFf0e::0TYY0dY90`QQ1P000`Q10TY90jee0nmm1_oo0ooO0_NN0nmM0nLL0mkk0mkK0mJj1MJJ
1/ii0liI0f]=0aSS0PQQ1P000`Q10a220aS30QSS0b440b4T1X@`0mkK0^mM2Ooo0QS30aSS0b440g__
0mJj0ooO0_oo0ooO1/HH0e[[0aS31@000b4T0bU51XaA0]kk1_oo0oNn2;Ff0e::0dYY0dY90`QQ1P00
0PQ10dY90jee0nmm1_oo0_oO0oNN0nmM0nLL0mkk0mkK0]Jj1]JJ1/ii0liI0V]=0aSS0`QQ1P000`Q1
0Q220aS30aSS0b440b4T1X@`0]kK0nmM2?oo0aS30aSS0b440g__0]Jj0ooO0ooo0ooO1/HH0U[[0aS3
1P000b4T0bU51HaA0mkk1_oo0oNn2;Ff0e::0dYY0dY90`QQ1@000`Q10dY90jee0nmm1Ooo0ooO0oNN
0nmM0nLL0]kk0mkK0mJj1]JJ1/ii0/iI0f]=0aSS0`QQ1P000PQ10a220aS30aSS0b440b4T1H@`0mkK
0nmM6?oo000Gool36<<36><28@@3Nnl3e[X3oml3ool3oml5aQP3F^/36<<600038B@2:DD6S543g_/6
ool2mkh9]KH3DXX3BVT2BTT3264600032443BTT2[GD3kgd6ool3oml3mih2ked3ia`3g_/3g]/3e[X6
eYX5cWT3cUT3Jdd36><326450003244348836<<36><28@@38B@6Q303g]/3ked8ool36<<26><38@@3
Nnl3e[X3oml3ool2oml6aQP3F^/36<<500038B@3:DD6S543g_/5ool3mkh9]KH3DXX2BVT3BTT32646
00032442BTT3[GD3kgd6ool3oml2mih3ked3ia`3g_/3g]/3e[X5eYX6cWT3cUT3Jdd36><226460003
244348836<<26><38@@38B@6Q303g]/2ked9ool26<<36><38@@3Nnl3e[X3oml2ool3oml6aQP3F^/3
6<<500038B@3:DD6S542g_/6ool3mkh8]KH3DXX3BVT3BTT3264600022443BTT3[GD3kgd6ool2oml3
mih3ked3ia`3g_/3g]/2e[X6eYX6cWT3cUT2Jdd36><326460003244248836<<36><38@@38B@6Q302
g]/3ked8ool36<<36><38@@3Nnl2e[X3oml3ool3oml6aQP2F^/36<<600038B@3:DD5S543g_/6ool3
mkh8]KH3DXX3BVT3BTT3264500032443BTT3[GD3kgd5ool3oml3mih3ked3ia`2g_/3g]/3e[X6eYX6
cWT2cUT3Jdd36><326460002244348836<<36><38@@38B@5Q303g]/3kedHool001Ooo`<H``<Hh`8Q
10=kk`?F^P?og`?oo`?og`G660=Jj`<H``H000<Q908YA@J<D@?Nn`Koo`;g_PVe]P=BRP=:J@9:B@<8
H@H000<8@@=:B@:]M@?_O@Koo`?og`?gWP;_G@?W70?Nn`?Nf`?F^PKFVPG>N@?>F@=[C@<Hh`<8H@D0
00<8@@<@PP<H``<Hh`8Q10<Q90J4<0?Nf`?_G@Soo`<H``8Hh`<Q10=kk`?F^P?og`?oo`;og`K660=J
j`<H``D000<Q90<YA@J<D@?Nn`Goo`?g_PVe]P=BRP9:J@=:B@<8H@H000<8@@9:B@>]M@?_O@Koo`?o
g`;gWP?_G@?W70?Nn`?Nf`?F^PGFVPK>N@?>F@=[C@<Hh`88H@H000<8@@<@PP<H``8Hh`<Q10<Q90J4
<0?Nf`;_G@Woo`8H``<Hh`<Q10=kk`?F^P?og`;oo`?og`K660=Jj`<H``D000<Q90<YA@J<D@;Nn`Ko
o`?g_PRe]P=BRP=:J@=:B@<8H@H00088@@=:B@>]M@?_O@Koo`;og`?gWP?_G@?W70?Nn`?Nf`;F^PKF
VPK>N@?>F@9[C@<Hh`<8H@H000<8@@8@PP<H``<Hh`<Q10<Q90J4<0;Nf`?_G@Soo`<H``<Hh`<Q10=k
k`;F^P?og`?oo`?og`K6609Jj`<H``H000<Q90<YA@F<D@?Nn`Koo`?g_PRe]P=BRP=:J@=:B@<8H@D0
00<8@@=:B@>]M@?_O@Goo`?og`?gWP?_G@?W70;Nn`?Nf`?F^PKFVPK>N@;>F@=[C@<Hh`<8H@H00088
@@<@PP<H``<Hh`<Q10<Q90F4<0?Nf`?_GASoo`005ooo0aS30aSS0R440g__0mJj0ooO0ooo0ooO1LHH
0e[[0aS31P000b4T0RU51XaA0mkk1_oo0_Nn2KFf0e::0dYY0TY90`QQ1P000`Q10dY90Zee0nmm1_oo
0ooO0oNN0^mM0nLL0mkk0mkK0mJj1]JJ1Lii0liI0f]=0aSS0`QQ1@000`Q10a220aS30aSS0R440b4T
1X@`0mkK0nmM2?oo0aS30QSS0b440g__0mJj0ooO0ooo0_oO1/HH0e[[0aS31@000b4T0bU51XaA0mkk
1Ooo0oNn2KFf0e::0TYY0dY90`QQ1P000`Q10TY90jee0nmm1_oo0ooO0_NN0nmM0nLL0mkk0mkK0mJj
1MJJ1/ii0liI0f]=0aSS0PQQ1P000`Q10a220aS30QSS0b440b4T1X@`0mkK0^mM2Ooo0QS30aSS0b44
0g__0mJj0ooO0_oo0ooO1/HH0e[[0aS31@000b4T0bU51XaA0]kk1_oo0oNn2;Ff0e::0dYY0dY90`QQ
1P000PQ10dY90jee0nmm1_oo0_oO0oNN0nmM0nLL0mkk0mkK0]Jj1]JJ1/ii0liI0V]=0aSS0`QQ1P00
0`Q10Q220aS30aSS0b440b4T1X@`0]kK0nmM2?oo0aS30aSS0b440g__0]Jj0ooO0ooo0ooO1/HH0U[[
0aS31P000b4T0bU51HaA0mkk1_oo0oNn2;Ff0e::0dYY0dY90`QQ1@000`Q10dY90jee0nmm1Ooo0ooO
0oNN0nmM0nLL0]kk0mkK0mJj1]JJ1/ii0/iI0f]=0aSS0`QQ1P000PQ10a220aS30aSS0b440b4T1H@`
0mkK0nmM6?oo000Gool36<<36><28@@3Nnl3e[X3oml3ool3oml5aQP3F^/36<<600038B@2:DD6S543
g_/6ool2mkh9]KH3DXX3BVT2BTT3264600032443BTT2[GD3kgd6ool3oml3mih2ked3ia`3g_/3g]/3
e[X6eYX5cWT3cUT3Jdd36><326450003244348836<<36><28@@38B@6Q303g]/3ked8ool36<<26><3
8@@3Nnl3e[X3oml3ool2oml6aQP3F^/36<<500038B@3:DD6S543g_/5ool3mkh9]KH3DXX2BVT3BTT3
264600032442BTT3[GD3kgd6ool3oml2mih3ked3ia`3g_/3g]/3e[X5eYX6cWT3cUT3Jdd36><22646
0003244348836<<26><38@@38B@6Q303g]/2ked9ool26<<36><38@@3Nnl3e[X3oml2ool3oml6aQP3
F^/36<<500038B@3:DD6S542g_/6ool3mkh8]KH3DXX3BVT3BTT3264600022443BTT3[GD3kgd6ool2
oml3mih3ked3ia`3g_/3g]/2e[X6eYX6cWT3cUT2Jdd36><326460003244248836<<36><38@@38B@6
Q302g]/3ked8ool36<<36><38@@3Nnl2e[X3oml3ool3oml6aQP2F^/36<<600038B@3:DD5S543g_/6
ool3mkh8]KH3DXX3BVT3BTT3264500032443BTT3[GD3kgd5ool3oml3mih3ked3ia`2g_/3g]/3e[X6
eYX6cWT2cUT3Jdd36><326460002244348836<<36><38@@38B@5Q303g]/3kedHool001goo`;F^PKF
VPW>N@G>F@IS;0<H``<8@@<0008@PP<H``<Q10<Q90<YA@F4<0?Nf`?_G@Koo`?g_P;_O@>U=0=220<8
H@H00088@@<@PP=Jj`>mm`?gWPGoo`?>N@c>F@=S;08H``H000<080<8H@<@XP8Hh`<Q10<Q90>4<0>4
40=kk`;F^P?W?0Koo`?g_P>mm`goo`?F^PKFVPS>N@K>F@IS;0<H``88@@<000<@PP<H``<Q10<Q908Y
A@J4<0?Nf`?_G@Koo`;g_P?_O@>U=0=220<8H@D000<8@@<@PP=Jj`>mm`?gWPGoo`?>N@_>F@=S;0<H
``H000<080<8H@8@XP<Hh`<Q10<Q90>4<0>4409kk`?F^P?W?0Koo`?g_P:mm`koo`?F^PKFVPS>N@K>
F@IS;08H``<8@@<000<@PP<H``<Q108Q90<YA@J4<0?Nf`?_G@Goo`?g_P?_O@>U=0=220<8H@D000<8
@@<@PP=Jj`>mm`;gWPKoo`?>N@_>F@=S;0<H``H0008080<8H@<@XP<Hh`<Q10<Q90:4<0>440=kk`?F
^P?W?0Koo`;g_P>mm`koo`?F^PGFVPW>N@K>F@ES;0<H``<8@@<000<@PP<H``8Q10<Q90<YA@J4<0?N
f`;_G@Koo`?g_P?_O@>U=09220<8H@H000<8@@<@PP9Jj`>mm`?gWPKoo`?>N@_>F@=S;0<H``D000<0
80<8H@<@XP<Hh`<Q108Q90>4<0>440=kk`?F^P?W?0Goo`?g_P>mmaSoo`007Ooo0]Jj1]JJ2Lii1LiI
1V</0aS30`Q10`000Q220aS30b440b4T0bU51H@`0mkK0nmM1_oo0oNn0^mm0jDd0d880`QQ1P000PQ1
0a220e[[0kgg0oNN1Ooo0lii3<iI0f</0QS31P000`0P0`QQ0a2R0QSS0b440b4T0h@`0h@@0g__0]Jj
0nLl1_oo0oNn0kgg3Ooo0mJj1]JJ2<ii1/iI1V</0aS30PQ10`000a220aS30b440b4T0RU51X@`0mkK
0nmM1_oo0_Nn0nmm0jDd0d880`QQ1@000`Q10a220e[[0kgg0oNN1Ooo0lii2liI0f</0aS31P000`0P
0`QQ0Q2R0aSS0b440b4T0h@`0h@@0W__0mJj0nLl1_oo0oNn0[gg3_oo0mJj1]JJ2<ii1/iI1V</0QS3
0`Q10`000a220aS30b440R4T0bU51X@`0mkK0nmM1Ooo0oNn0nmm0jDd0d880`QQ1@000`Q10a220e[[
0kgg0_NN1_oo0lii2liI0f</0aS31P000P0P0`QQ0a2R0aSS0b440b4T0X@`0h@@0g__0mJj0nLl1_oo
0_Nn0kgg3_oo0mJj1MJJ2Lii1/iI1F</0aS30`Q10`000a220aS30R440b4T0bU51X@`0mkK0^mM1_oo
0oNn0nmm0jDd0T880`QQ1P000`Q10a220U[[0kgg0oNN1_oo0lii2liI0f</0aS31@000`0P0`QQ0a2R
0aSS0b440R4T0h@`0h@@0g__0mJj0nLl1Ooo0oNn0kgg6?oo000Mool2e[X6eYX9cWT5cUT6Hb`36<<3
2443000248836<<38@@38B@3:DD5Q303g]/3ked6ool3mkh2kgd3YC@3@PP32646000224434883F^/3
_OL3mih5ool3cWT<cUT3Hb`26<<60003020326434:826><38@@38B@3Q303Q103Nnl2e[X3ic`6ool3
mkh3_OL=ool3e[X6eYX8cWT6cUT6Hb`36<<22443000348836<<38@@38B@2:DD6Q303g]/3ked6ool2
mkh3kgd3YC@3@PP32645000324434883F^/3_OL3mih5ool3cWT;cUT3Hb`36<<60003020326424:83
6><38@@38B@3Q303Q102Nnl3e[X3ic`6ool3mkh2_OL>ool3e[X6eYX8cWT6cUT6Hb`26<<324430003
48836<<38@@28B@3:DD6Q303g]/3ked5ool3mkh3kgd3YC@3@PP32645000324434883F^/3_OL2mih6
ool3cWT;cUT3Hb`36<<60002020326434:836><38@@38B@2Q303Q103Nnl3e[X3ic`6ool2mkh3_OL>
ool3e[X5eYX9cWT6cUT5Hb`36<<32443000348836<<28@@38B@3:DD6Q303g]/2ked6ool3mkh3kgd3
YC@2@PP32646000324434882F^/3_OL3mih6ool3cWT;cUT3Hb`36<<50003020326434:836><38@@2
8B@3Q303Q103Nnl3e[X3ic`5ool3mkh3_OLHool001goo`;F^PKFVPW>N@G>F@IS;0<H``<8@@<0008@
PP<H``<Q10<Q90<YA@F4<0?Nf`?_G@Koo`?g_P;_O@>U=0=220<8H@H00088@@<@PP=Jj`>mm`?gWPGo
o`?>N@c>F@=S;08H``H000<080<8H@<@XP8Hh`<Q10<Q90>4<0>440=kk`;F^P?W?0Koo`?g_P>mm`go
o`?F^PKFVPS>N@K>F@IS;0<H``88@@<000<@PP<H``<Q10<Q908YA@J4<0?Nf`?_G@Koo`;g_P?_O@>U
=0=220<8H@D000<8@@<@PP=Jj`>mm`?gWPGoo`?>N@_>F@=S;0<H``H000<080<8H@8@XP<Hh`<Q10<Q
90>4<0>4409kk`?F^P?W?0Koo`?g_P:mm`koo`?F^PKFVPS>N@K>F@IS;08H``<8@@<000<@PP<H``<Q
108Q90<YA@J4<0?Nf`?_G@Goo`?g_P?_O@>U=0=220<8H@D000<8@@<@PP=Jj`>mm`;gWPKoo`?>N@_>
F@=S;0<H``H0008080<8H@<@XP<Hh`<Q10<Q90:4<0>440=kk`?F^P?W?0Koo`;g_P>mm`koo`?F^PGF
VPW>N@K>F@ES;0<H``<8@@<000<@PP<H``8Q10<Q90<YA@J4<0?Nf`;_G@Koo`?g_P?_O@>U=09220<8
H@H000<8@@<@PP9Jj`>mm`?gWPKoo`?>N@_>F@=S;0<H``D000<080<8H@<@XP<Hh`<Q108Q90>4<0>4
40=kk`?F^P?W?0Goo`?g_P>mmaSoo`007Ooo0]Jj1]JJ2Lii1LiI1V</0aS30`Q10`000Q220aS30b44
0b4T0bU51H@`0mkK0nmM1_oo0oNn0^mm0jDd0d880`QQ1P000PQ10a220e[[0kgg0oNN1Ooo0lii3<iI
0f</0QS31P000`0P0`QQ0a2R0QSS0b440b4T0h@`0h@@0g__0]Jj0nLl1_oo0oNn0kgg3Ooo0mJj1]JJ
2<ii1/iI1V</0aS30PQ10`000a220aS30b440b4T0RU51X@`0mkK0nmM1_oo0_Nn0nmm0jDd0d880`QQ
1@000`Q10a220e[[0kgg0oNN1Ooo0lii2liI0f</0aS31P000`0P0`QQ0Q2R0aSS0b440b4T0h@`0h@@
0W__0mJj0nLl1_oo0oNn0[gg3_oo0mJj1]JJ2<ii1/iI1V</0QS30`Q10`000a220aS30b440R4T0bU5
1X@`0mkK0nmM1Ooo0oNn0nmm0jDd0d880`QQ1@000`Q10a220e[[0kgg0_NN1_oo0lii2liI0f</0aS3
1P000P0P0`QQ0a2R0aSS0b440b4T0X@`0h@@0g__0mJj0nLl1_oo0_Nn0kgg3_oo0mJj1MJJ2Lii1/iI
1F</0aS30`Q10`000a220aS30R440b4T0bU51X@`0mkK0^mM1_oo0oNn0nmm0jDd0T880`QQ1P000`Q1
0a220U[[0kgg0oNN1_oo0lii2liI0f</0aS31@000`0P0`QQ0a2R0aSS0b440R4T0h@`0h@@0g__0mJj
0nLl1Ooo0oNn0kgg6?oo000Mool2e[X6eYX9cWT5cUT6Hb`36<<32443000248836<<38@@38B@3:DD5
Q303g]/3ked6ool3mkh2kgd3YC@3@PP32646000224434883F^/3_OL3mih5ool3cWT<cUT3Hb`26<<6
0003020326434:826><38@@38B@3Q303Q103Nnl2e[X3ic`6ool3mkh3_OL=ool3e[X6eYX8cWT6cUT6
Hb`36<<22443000348836<<38@@38B@2:DD6Q303g]/3ked6ool2mkh3kgd3YC@3@PP3264500032443
4883F^/3_OL3mih5ool3cWT;cUT3Hb`36<<60003020326424:836><38@@38B@3Q303Q102Nnl3e[X3
ic`6ool3mkh2_OL>ool3e[X6eYX8cWT6cUT6Hb`26<<32443000348836<<38@@28B@3:DD6Q303g]/3
ked5ool3mkh3kgd3YC@3@PP32645000324434883F^/3_OL2mih6ool3cWT;cUT3Hb`36<<600020203
26434:836><38@@38B@2Q303Q103Nnl3e[X3ic`6ool2mkh3_OL>ool3e[X5eYX9cWT6cUT5Hb`36<<3
2443000348836<<28@@38B@3:DD6Q303g]/2ked6ool3mkh3kgd3YC@2@PP32646000324434882F^/3
_OL3mih6ool3cWT;cUT3Hb`36<<50003020326434:836><38@@28B@3Q303Q103Nnl3e[X3ic`5ool3
mkh3_OLHool001goo`;F^PKFVPW>N@G>F@IS;0<H``<8@@<0008@PP<H``<Q10<Q90<YA@F4<0?Nf`?_
G@Koo`?g_P;_O@>U=0=220<8H@H00088@@<@PP=Jj`>mm`?gWPGoo`?>N@c>F@=S;08H``H000<080<8
H@<@XP8Hh`<Q10<Q90>4<0>440=kk`;F^P?W?0Koo`?g_P>mm`goo`?F^PKFVPS>N@K>F@IS;0<H``88
@@<000<@PP<H``<Q10<Q908YA@J4<0?Nf`?_G@Koo`;g_P?_O@>U=0=220<8H@D000<8@@<@PP=Jj`>m
m`?gWPGoo`?>N@_>F@=S;0<H``H000<080<8H@8@XP<Hh`<Q10<Q90>4<0>4409kk`?F^P?W?0Koo`?g
_P:mm`koo`?F^PKFVPS>N@K>F@IS;08H``<8@@<000<@PP<H``<Q108Q90<YA@J4<0?Nf`?_G@Goo`?g
_P?_O@>U=0=220<8H@D000<8@@<@PP=Jj`>mm`;gWPKoo`?>N@_>F@=S;0<H``H0008080<8H@<@XP<H
h`<Q10<Q90:4<0>440=kk`?F^P?W?0Koo`;g_P>mm`koo`?F^PGFVPW>N@K>F@ES;0<H``<8@@<000<@
PP<H``8Q10<Q90<YA@J4<0?Nf`;_G@Koo`?g_P?_O@>U=09220<8H@H000<8@@<@PP9Jj`>mm`?gWPKo
o`?>N@_>F@=S;0<H``D000<080<8H@<@XP<Hh`<Q108Q90>4<0>440=kk`?F^P?W?0Goo`?g_P>mmaSo
o`007Ooo0]Jj1]JJ2Lii1LiI1V</0aS30`Q10`000Q220aS30b440b4T0bU51H@`0mkK0nmM1_oo0oNn
0^mm0jDd0d880`QQ1P000PQ10a220e[[0kgg0oNN1Ooo0lii3<iI0f</0QS31P000`0P0`QQ0a2R0QSS
0b440b4T0h@`0h@@0g__0]Jj0nLl1_oo0oNn0kgg3Ooo0mJj1]JJ2<ii1/iI1V</0aS30PQ10`000a22
0aS30b440b4T0RU51X@`0mkK0nmM1_oo0_Nn0nmm0jDd0d880`QQ1@000`Q10a220e[[0kgg0oNN1Ooo
0lii2liI0f</0aS31P000`0P0`QQ0Q2R0aSS0b440b4T0h@`0h@@0W__0mJj0nLl1_oo0oNn0[gg3_oo
0mJj1]JJ2<ii1/iI1V</0QS30`Q10`000a220aS30b440R4T0bU51X@`0mkK0nmM1Ooo0oNn0nmm0jDd
0d880`QQ1@000`Q10a220e[[0kgg0_NN1_oo0lii2liI0f</0aS31P000P0P0`QQ0a2R0aSS0b440b4T
0X@`0h@@0g__0mJj0nLl1_oo0_Nn0kgg3_oo0mJj1MJJ2Lii1/iI1F</0aS30`Q10`000a220aS30R44
0b4T0bU51X@`0mkK0^mM1_oo0oNn0nmm0jDd0T880`QQ1P000`Q10a220U[[0kgg0oNN1_oo0lii2liI
0f</0aS31@000`0P0`QQ0a2R0aSS0b440R4T0h@`0h@@0g__0mJj0nLl1Ooo0oNn0kgg6?oo000Mool2
e[X6eYX9cWT5cUT6Hb`36<<32443000248836<<38@@38B@3:DD5Q303g]/3ked6ool3mkh2kgd3YC@3
@PP32646000224434883F^/3_OL3mih5ool3cWT<cUT3Hb`26<<60003020326434:826><38@@38B@3
Q303Q103Nnl2e[X3ic`6ool3mkh3_OL=ool3e[X6eYX8cWT6cUT6Hb`36<<22443000348836<<38@@3
8B@2:DD6Q303g]/3ked6ool2mkh3kgd3YC@3@PP32645000324434883F^/3_OL3mih5ool3cWT;cUT3
Hb`36<<60003020326424:836><38@@38B@3Q303Q102Nnl3e[X3ic`6ool3mkh2_OL>ool3e[X6eYX8
cWT6cUT6Hb`26<<32443000348836<<38@@28B@3:DD6Q303g]/3ked5ool3mkh3kgd3YC@3@PP32645
000324434883F^/3_OL2mih6ool3cWT;cUT3Hb`36<<60002020326434:836><38@@38B@2Q303Q103
Nnl3e[X3ic`6ool2mkh3_OL>ool3e[X5eYX9cWT6cUT5Hb`36<<32443000348836<<28@@38B@3:DD6
Q303g]/2ked6ool3mkh3kgd3YC@2@PP32646000324434882F^/3_OL3mih6ool3cWT;cUT3Hb`36<<5
0003020326434:836><38@@28B@3Q303Q103Nnl3e[X3ic`5ool3mkh3_OLHool001goo`;F^PKFVPW>
N@G>F@IS;0<H``<8@@<0008@PP<H``<Q10<Q90<YA@F4<0?Nf`?_G@Koo`?g_P;_O@>U=0=220<8H@H0
0088@@<@PP=Jj`>mm`?gWPGoo`?>N@c>F@=S;08H``H000<080<8H@<@XP8Hh`<Q10<Q90>4<0>440=k
k`;F^P?W?0Koo`?g_P>mm`goo`?F^PKFVPS>N@K>F@IS;0<H``88@@<000<@PP<H``<Q10<Q908YA@J4
<0?Nf`?_G@Koo`;g_P?_O@>U=0=220<8H@D000<8@@<@PP=Jj`>mm`?gWPGoo`?>N@_>F@=S;0<H``H0
00<080<8H@8@XP<Hh`<Q10<Q90>4<0>4409kk`?F^P?W?0Koo`?g_P:mm`koo`?F^PKFVPS>N@K>F@IS
;08H``<8@@<000<@PP<H``<Q108Q90<YA@J4<0?Nf`?_G@Goo`?g_P?_O@>U=0=220<8H@D000<8@@<@
PP=Jj`>mm`;gWPKoo`?>N@_>F@=S;0<H``H0008080<8H@<@XP<Hh`<Q10<Q90:4<0>440=kk`?F^P?W
?0Koo`;g_P>mm`koo`?F^PGFVPW>N@K>F@ES;0<H``<8@@<000<@PP<H``8Q10<Q90<YA@J4<0?Nf`;_
G@Koo`?g_P?_O@>U=09220<8H@H000<8@@<@PP9Jj`>mm`?gWPKoo`?>N@_>F@=S;0<H``D000<080<8
H@<@XP<Hh`<Q108Q90>4<0>440=kk`?F^P?W?0Goo`?g_P>mmaSoo`007Ooo0]Jj1]JJ2Lii1LiI1V</
0aS30`Q10`000Q220aS30b440b4T0bU51H@`0mkK0nmM1_oo0oNn0^mm0jDd0d880`QQ1P000PQ10a22
0e[[0kgg0oNN1Ooo0lii3<iI0f</0QS31P000`0P0`QQ0a2R0QSS0b440b4T0h@`0h@@0g__0]Jj0nLl
1_oo0oNn0kgg3Ooo0mJj1]JJ2<ii1/iI1V</0aS30PQ10`000a220aS30b440b4T0RU51X@`0mkK0nmM
1_oo0_Nn0nmm0jDd0d880`QQ1@000`Q10a220e[[0kgg0oNN1Ooo0lii2liI0f</0aS31P000`0P0`QQ
0Q2R0aSS0b440b4T0h@`0h@@0W__0mJj0nLl1_oo0oNn0[gg3_oo0mJj1]JJ2<ii1/iI1V</0QS30`Q1
0`000a220aS30b440R4T0bU51X@`0mkK0nmM1Ooo0oNn0nmm0jDd0d880`QQ1@000`Q10a220e[[0kgg
0_NN1_oo0lii2liI0f</0aS31P000P0P0`QQ0a2R0aSS0b440b4T0X@`0h@@0g__0mJj0nLl1_oo0_Nn
0kgg3_oo0mJj1MJJ2Lii1/iI1F</0aS30`Q10`000a220aS30R440b4T0bU51X@`0mkK0^mM1_oo0oNn
0nmm0jDd0T880`QQ1P000`Q10a220U[[0kgg0oNN1_oo0lii2liI0f</0aS31@000`0P0`QQ0a2R0aSS
0b440R4T0h@`0h@@0g__0mJj0nLl1Ooo0oNn0kgg6?oo000Mool2e[X6eYX9cWT5cUT6Hb`36<<32443
000248836<<38@@38B@3:DD5Q303g]/3ked6ool3mkh2kgd3YC@3@PP32646000224434883F^/3_OL3
mih5ool3cWT<cUT3Hb`26<<60003020326434:826><38@@38B@3Q303Q103Nnl2e[X3ic`6ool3mkh3
_OL=ool3e[X6eYX8cWT6cUT6Hb`36<<22443000348836<<38@@38B@2:DD6Q303g]/3ked6ool2mkh3
kgd3YC@3@PP32645000324434883F^/3_OL3mih5ool3cWT;cUT3Hb`36<<60003020326424:836><3
8@@38B@3Q303Q102Nnl3e[X3ic`6ool3mkh2_OL>ool3e[X6eYX8cWT6cUT6Hb`26<<3244300034883
6<<38@@28B@3:DD6Q303g]/3ked5ool3mkh3kgd3YC@3@PP32645000324434883F^/3_OL2mih6ool3
cWT;cUT3Hb`36<<60002020326434:836><38@@38B@2Q303Q103Nnl3e[X3ic`6ool2mkh3_OL>ool3
e[X5eYX9cWT6cUT5Hb`36<<32443000348836<<28@@38B@3:DD6Q303g]/2ked6ool3mkh3kgd3YC@2
@PP32646000324434882F^/3_OL3mih6ool3cWT;cUT3Hb`36<<50003020326434:836><38@@28B@3
Q303Q103Nnl3e[X3ic`5ool3mkh3_OLHool001Ooo`=BZP<@XP8080<000<080/ii`JU50>U=0?_G@Ko
o`;g_P?_O@?_G@?W70?Nn`?Nf`9kc`=kk`<Q90<080<000<08088H@<@XP<H``<Q10=kc`?F^P;og`?o
o`?og`?gWP?_G@>D/P:Ld`<ia`<8@@<000<@XP<H``=cSP;>N@?og`?oo`?og`?gWP?_G@;W?0><L@<a
QP<080<000<080Dia`>Ll`?W?0koo`=BZP8@XP<080<000<080/ii`JU50>U=0?_G@Goo`?g_P?_O@?_
G@?W70;Nn`?Nf`=kc`=kk`<Q90<080<0008080<8H@<@XP<H``<Q10=kc`;F^P?og`?oo`?og`?gWP?_
G@:D/P>Ld`<ia`<8@@<000<@XP8H``=cSP?>N@?og`?oo`?og`?gWP;_G@?W?0><L@<aQP<080<00080
80Hia`>Ll`?W?0koo`9BZP<@XP<080<000<080/ii`JU50>U=0;_G@Koo`?g_P?_O@?_G@;W70?Nn`?N
f`=kc`=kk`<Q908080<000<080<8H@<@XP<H``<Q109kc`?F^P?og`?oo`?og`?gWP;_G@>D/P>Ld`<i
a`<8@@<0008@XP<H``=cSP?>N@?og`?oo`;og`?gWP?_G@?W?0><L@<aQP8080<000<080Hia`>Ll`?W
?0goo`=BZP<@XP<080<0008080`ii`FU50>U=0?_G@Koo`?g_P?_O@;_G@?W70?Nn`?Nf`=kc`=kk`8Q
90<080<000<080<8H@<@XP8H``<Q10=kc`?F^P?og`?oo`;og`?gWP?_G@>D/P>Ld`<ia`88@@<000<@
XP<H``=cSP?>N@?og`;oo`?og`?gWP?_G@?W?0><L@8aQP<080<000<080Hia`:Ll`?W?1koo`005ooo
0e:Z0a2R0P0P0`000`0P2cWW1ZDD0jDd0nmM1_oo0_Nn0nmm0nmM0nLL0mkk0mkK0W_?0g__0b4T0`0P
0`000`0P0PQQ0a2R0aS30b440g_?0mJj0_oO0ooo0ooO0oNN0nmM0iBb0YcC0cW70`Q10`000a2R0aS3
0g>>0/ii0ooO0ooo0ooO0oNN0nmM0^Ll0haa0c660`0P0`000`0P1CW70icc0nLl3_oo0e:Z0Q2R0`0P
0`000`0P2cWW1ZDD0jDd0nmM1Ooo0oNn0nmm0nmM0nLL0]kk0mkK0g_?0g__0b4T0`0P0`000P0P0`QQ
0a2R0aS30b440g_?0]Jj0ooO0ooo0ooO0oNN0nmM0YBb0icC0cW70`Q10`000a2R0QS30g>>0lii0ooO
0ooo0ooO0oNN0^mM0nLl0haa0c660`0P0`000P0P1SW70icc0nLl3_oo0U:Z0a2R0`0P0`000`0P2cWW
1ZDD0jDd0^mM1_oo0oNn0nmm0nmM0^LL0mkk0mkK0g_?0g__0b4T0P0P0`000`0P0`QQ0a2R0aS30b44
0W_?0mJj0ooO0ooo0ooO0oNN0^mM0iBb0icC0cW70`Q10`000Q2R0aS30g>>0lii0ooO0ooo0_oO0oNN
0nmM0nLl0haa0c660P0P0`000`0P1SW70icc0nLl3Ooo0e:Z0a2R0`0P0`000P0P33WW1JDD0jDd0nmM
1_oo0oNn0nmm0^mM0nLL0mkk0mkK0g_?0g__0R4T0`0P0`000`0P0`QQ0a2R0QS30b440g_?0mJj0ooO
0ooo0_oO0oNN0nmM0iBb0icC0cW70PQ10`000a2R0aS30g>>0lii0ooO0_oo0ooO0oNN0nmM0nLl0haa
0S660`0P0`000`0P1SW70Ycc0nLl7_oo000Gool3DZX34:8202030003020;>NL6YA@3YC@3ked6ool2
mkh3kgd3ked3ia`3g_/3g]/2Nll3Nnl38B@302030003020226434:836<<38@@3Nll3e[X2oml3ool3
oml3mih3ked3U;82W=<3>LL3244300034:836<<3Lhh2cWT3oml3ool3oml3mih3ked2ic`3S743<HH3
020300030205>LL3W?<3ic`>ool3DZX24:8302030003020;>NL6YA@3YC@3ked5ool3mkh3kgd3ked3
ia`2g_/3g]/3Nll3Nnl38B@302030002020326434:836<<38@@3Nll2e[X3oml3ool3oml3mih3ked2
U;83W=<3>LL3244300034:826<<3Lhh3cWT3oml3ool3oml3mih2ked3ic`3S743<HH3020300020206
>LL3W?<3ic`>ool2DZX34:8302030003020;>NL6YA@3YC@2ked6ool3mkh3kgd3ked2ia`3g_/3g]/3
Nll3Nnl38B@202030003020326434:836<<38@@2Nll3e[X3oml3ool3oml3mih2ked3U;83W=<3>LL3
244300024:836<<3Lhh3cWT3oml3ool2oml3mih3ked3ic`3S743<HH2020300030206>LL3W?<3ic`=
ool3DZX34:8302030002020<>NL5YA@3YC@3ked6ool3mkh3kgd2ked3ia`3g_/3g]/3Nll3Nnl28B@3
02030003020326434:826<<38@@3Nll3e[X3oml3ool2oml3mih3ked3U;83W=<3>LL2244300034:83
6<<3Lhh3cWT3oml2ool3oml3mih3ked3ic`3S742<HH3020300030206>LL2W?<3ic`Nool001Ooo`=B
ZP<@XP8080<000<080/ii`JU50>U=0?_G@Koo`;g_P?_O@?_G@?W70?Nn`?Nf`9kc`=kk`<Q90<080<0
00<08088H@<@XP<H``<Q10=kc`?F^P;og`?oo`?og`?gWP?_G@>D/P:Ld`<ia`<8@@<000<@XP<H``=c
SP;>N@?og`?oo`?og`?gWP?_G@;W?0><L@<aQP<080<000<080Dia`>Ll`?W?0koo`=BZP8@XP<080<0
00<080/ii`JU50>U=0?_G@Goo`?g_P?_O@?_G@?W70;Nn`?Nf`=kc`=kk`<Q90<080<0008080<8H@<@
XP<H``<Q10=kc`;F^P?og`?oo`?og`?gWP?_G@:D/P>Ld`<ia`<8@@<000<@XP8H``=cSP?>N@?og`?o
o`?og`?gWP;_G@?W?0><L@<aQP<080<0008080Hia`>Ll`?W?0koo`9BZP<@XP<080<000<080/ii`JU
50>U=0;_G@Koo`?g_P?_O@?_G@;W70?Nn`?Nf`=kc`=kk`<Q908080<000<080<8H@<@XP<H``<Q109k
c`?F^P?og`?oo`?og`?gWP;_G@>D/P>Ld`<ia`<8@@<0008@XP<H``=cSP?>N@?og`?oo`;og`?gWP?_
G@?W?0><L@<aQP8080<000<080Hia`>Ll`?W?0goo`=BZP<@XP<080<0008080`ii`FU50>U=0?_G@Ko
o`?g_P?_O@;_G@?W70?Nn`?Nf`=kc`=kk`8Q90<080<000<080<8H@<@XP8H``<Q10=kc`?F^P?og`?o
o`;og`?gWP?_G@>D/P>Ld`<ia`88@@<000<@XP<H``=cSP?>N@?og`;oo`?og`?gWP?_G@?W?0><L@8a
QP<080<000<080Hia`:Ll`?W?1koo`005ooo0e:Z0a2R0P0P0`000`0P2cWW1ZDD0jDd0nmM1_oo0_Nn
0nmm0nmM0nLL0mkk0mkK0W_?0g__0b4T0`0P0`000`0P0PQQ0a2R0aS30b440g_?0mJj0_oO0ooo0ooO
0oNN0nmM0iBb0YcC0cW70`Q10`000a2R0aS30g>>0/ii0ooO0ooo0ooO0oNN0nmM0^Ll0haa0c660`0P
0`000`0P1CW70icc0nLl3_oo0e:Z0Q2R0`0P0`000`0P2cWW1ZDD0jDd0nmM1Ooo0oNn0nmm0nmM0nLL
0]kk0mkK0g_?0g__0b4T0`0P0`000P0P0`QQ0a2R0aS30b440g_?0]Jj0ooO0ooo0ooO0oNN0nmM0YBb
0icC0cW70`Q10`000a2R0QS30g>>0lii0ooO0ooo0ooO0oNN0^mM0nLl0haa0c660`0P0`000P0P1SW7
0icc0nLl3_oo0U:Z0a2R0`0P0`000`0P2cWW1ZDD0jDd0^mM1_oo0oNn0nmm0nmM0^LL0mkk0mkK0g_?
0g__0b4T0P0P0`000`0P0`QQ0a2R0aS30b440W_?0mJj0ooO0ooo0ooO0oNN0^mM0iBb0icC0cW70`Q1
0`000Q2R0aS30g>>0lii0ooO0ooo0_oO0oNN0nmM0nLl0haa0c660P0P0`000`0P1SW70icc0nLl3Ooo
0e:Z0a2R0`0P0`000P0P33WW1JDD0jDd0nmM1_oo0oNn0nmm0^mM0nLL0mkk0mkK0g_?0g__0R4T0`0P
0`000`0P0`QQ0a2R0QS30b440g_?0mJj0ooO0ooo0_oO0oNN0nmM0iBb0icC0cW70PQ10`000a2R0aS3
0g>>0lii0ooO0_oo0ooO0oNN0nmM0nLl0haa0S660`0P0`000`0P1SW70Ycc0nLl7_oo000Gool3DZX3
4:8202030003020;>NL6YA@3YC@3ked6ool2mkh3kgd3ked3ia`3g_/3g]/2Nll3Nnl38B@302030003
020226434:836<<38@@3Nll3e[X2oml3ool3oml3mih3ked3U;82W=<3>LL3244300034:836<<3Lhh2
cWT3oml3ool3oml3mih3ked2ic`3S743<HH3020300030205>LL3W?<3ic`>ool3DZX24:8302030003
020;>NL6YA@3YC@3ked5ool3mkh3kgd3ked3ia`2g_/3g]/3Nll3Nnl38B@302030002020326434:83
6<<38@@3Nll2e[X3oml3ool3oml3mih3ked2U;83W=<3>LL3244300034:826<<3Lhh3cWT3oml3ool3
oml3mih2ked3ic`3S743<HH3020300020206>LL3W?<3ic`>ool2DZX34:8302030003020;>NL6YA@3
YC@2ked6ool3mkh3kgd3ked2ia`3g_/3g]/3Nll3Nnl38B@202030003020326434:836<<38@@2Nll3
e[X3oml3ool3oml3mih2ked3U;83W=<3>LL3244300024:836<<3Lhh3cWT3oml3ool2oml3mih3ked3
ic`3S743<HH2020300030206>LL3W?<3ic`=ool3DZX34:8302030002020<>NL5YA@3YC@3ked6ool3
mkh3kgd2ked3ia`3g_/3g]/3Nll3Nnl28B@302030003020326434:826<<38@@3Nll3e[X3oml3ool2
oml3mih3ked3U;83W=<3>LL2244300034:836<<3Lhh3cWT3oml2ool3oml3mih3ked3ic`3S742<HH3
020300030206>LL2W?<3ic`Nool001Ooo`=BZP<@XP8080<000<080/ii`JU50>U=0?_G@Koo`;g_P?_
O@?_G@?W70?Nn`?Nf`9kc`=kk`<Q90<080<000<08088H@<@XP<H``<Q10=kc`?F^P;og`?oo`?og`?g
WP?_G@>D/P:Ld`<ia`<8@@<000<@XP<H``=cSP;>N@?og`?oo`?og`?gWP?_G@;W?0><L@<aQP<080<0
00<080Dia`>Ll`?W?0koo`=BZP8@XP<080<000<080/ii`JU50>U=0?_G@Goo`?g_P?_O@?_G@?W70;N
n`?Nf`=kc`=kk`<Q90<080<0008080<8H@<@XP<H``<Q10=kc`;F^P?og`?oo`?og`?gWP?_G@:D/P>L
d`<ia`<8@@<000<@XP8H``=cSP?>N@?og`?oo`?og`?gWP;_G@?W?0><L@<aQP<080<0008080Hia`>L
l`?W?0koo`9BZP<@XP<080<000<080/ii`JU50>U=0;_G@Koo`?g_P?_O@?_G@;W70?Nn`?Nf`=kc`=k
k`<Q908080<000<080<8H@<@XP<H``<Q109kc`?F^P?og`?oo`?og`?gWP;_G@>D/P>Ld`<ia`<8@@<0
008@XP<H``=cSP?>N@?og`?oo`;og`?gWP?_G@?W?0><L@<aQP8080<000<080Hia`>Ll`?W?0goo`=B
ZP<@XP<080<0008080`ii`FU50>U=0?_G@Koo`?g_P?_O@;_G@?W70?Nn`?Nf`=kc`=kk`8Q90<080<0
00<080<8H@<@XP8H``<Q10=kc`?F^P?og`?oo`;og`?gWP?_G@>D/P>Ld`<ia`88@@<000<@XP<H``=c
SP?>N@?og`;oo`?og`?gWP?_G@?W?0><L@8aQP<080<000<080Hia`:Ll`?W?1koo`005ooo0e:Z0a2R
0P0P0`000`0P2cWW1ZDD0jDd0nmM1_oo0_Nn0nmm0nmM0nLL0mkk0mkK0W_?0g__0b4T0`0P0`000`0P
0PQQ0a2R0aS30b440g_?0mJj0_oO0ooo0ooO0oNN0nmM0iBb0YcC0cW70`Q10`000a2R0aS30g>>0/ii
0ooO0ooo0ooO0oNN0nmM0^Ll0haa0c660`0P0`000`0P1CW70icc0nLl3_oo0e:Z0Q2R0`0P0`000`0P
2cWW1ZDD0jDd0nmM1Ooo0oNn0nmm0nmM0nLL0]kk0mkK0g_?0g__0b4T0`0P0`000P0P0`QQ0a2R0aS3
0b440g_?0]Jj0ooO0ooo0ooO0oNN0nmM0YBb0icC0cW70`Q10`000a2R0QS30g>>0lii0ooO0ooo0ooO
0oNN0^mM0nLl0haa0c660`0P0`000P0P1SW70icc0nLl3_oo0U:Z0a2R0`0P0`000`0P2cWW1ZDD0jDd
0^mM1_oo0oNn0nmm0nmM0^LL0mkk0mkK0g_?0g__0b4T0P0P0`000`0P0`QQ0a2R0aS30b440W_?0mJj
0ooO0ooo0ooO0oNN0^mM0iBb0icC0cW70`Q10`000Q2R0aS30g>>0lii0ooO0ooo0_oO0oNN0nmM0nLl
0haa0c660P0P0`000`0P1SW70icc0nLl3Ooo0e:Z0a2R0`0P0`000P0P33WW1JDD0jDd0nmM1_oo0oNn
0nmm0^mM0nLL0mkk0mkK0g_?0g__0R4T0`0P0`000`0P0`QQ0a2R0QS30b440g_?0mJj0ooO0ooo0_oO
0oNN0nmM0iBb0icC0cW70PQ10`000a2R0aS30g>>0lii0ooO0_oo0ooO0oNN0nmM0nLl0haa0S660`0P
0`000`0P1SW70Ycc0nLl7_oo000Gool3DZX34:8202030003020;>NL6YA@3YC@3ked6ool2mkh3kgd3
ked3ia`3g_/3g]/2Nll3Nnl38B@302030003020226434:836<<38@@3Nll3e[X2oml3ool3oml3mih3
ked3U;82W=<3>LL3244300034:836<<3Lhh2cWT3oml3ool3oml3mih3ked2ic`3S743<HH302030003
0205>LL3W?<3ic`>ool3DZX24:8302030003020;>NL6YA@3YC@3ked5ool3mkh3kgd3ked3ia`2g_/3
g]/3Nll3Nnl38B@302030002020326434:836<<38@@3Nll2e[X3oml3ool3oml3mih3ked2U;83W=<3
>LL3244300034:826<<3Lhh3cWT3oml3ool3oml3mih2ked3ic`3S743<HH3020300020206>LL3W?<3
ic`>ool2DZX34:8302030003020;>NL6YA@3YC@2ked6ool3mkh3kgd3ked2ia`3g_/3g]/3Nll3Nnl3
8B@202030003020326434:836<<38@@2Nll3e[X3oml3ool3oml3mih2ked3U;83W=<3>LL324430002
4:836<<3Lhh3cWT3oml3ool2oml3mih3ked3ic`3S743<HH2020300030206>LL3W?<3ic`=ool3DZX3
4:8302030002020<>NL5YA@3YC@3ked6ool3mkh3kgd2ked3ia`3g_/3g]/3Nll3Nnl28B@302030003
020326434:826<<38@@3Nll3e[X3oml3ool2oml3mih3ked3U;83W=<3>LL2244300034:836<<3Lhh3
cWT3oml2ool3oml3mih3ked3ic`3S742<HH3020300030206>LL2W?<3ic`Nool001Ooo`=BZP<@XP80
80<000<080/ii`JU50>U=0?_G@Koo`;g_P?_O@?_G@?W70?Nn`?Nf`9kc`=kk`<Q90<080<000<08088
H@<@XP<H``<Q10=kc`?F^P;og`?oo`?og`?gWP?_G@>D/P:Ld`<ia`<8@@<000<@XP<H``=cSP;>N@?o
g`?oo`?og`?gWP?_G@;W?0><L@<aQP<080<000<080Dia`>Ll`?W?0koo`=BZP8@XP<080<000<080/i
i`JU50>U=0?_G@Goo`?g_P?_O@?_G@?W70;Nn`?Nf`=kc`=kk`<Q90<080<0008080<8H@<@XP<H``<Q
10=kc`;F^P?og`?oo`?og`?gWP?_G@:D/P>Ld`<ia`<8@@<000<@XP8H``=cSP?>N@?og`?oo`?og`?g
WP;_G@?W?0><L@<aQP<080<0008080Hia`>Ll`?W?0koo`9BZP<@XP<080<000<080/ii`JU50>U=0;_
G@Koo`?g_P?_O@?_G@;W70?Nn`?Nf`=kc`=kk`<Q908080<000<080<8H@<@XP<H``<Q109kc`?F^P?o
g`?oo`?og`?gWP;_G@>D/P>Ld`<ia`<8@@<0008@XP<H``=cSP?>N@?og`?oo`;og`?gWP?_G@?W?0><
L@<aQP8080<000<080Hia`>Ll`?W?0goo`=BZP<@XP<080<0008080`ii`FU50>U=0?_G@Koo`?g_P?_
O@;_G@?W70?Nn`?Nf`=kc`=kk`8Q90<080<000<080<8H@<@XP8H``<Q10=kc`?F^P?og`?oo`;og`?g
WP?_G@>D/P>Ld`<ia`88@@<000<@XP<H``=cSP?>N@?og`;oo`?og`?gWP?_G@?W?0><L@8aQP<080<0
00<080Hia`:Ll`?W?1koo`005ooo0e:Z0a2R0P0P0`000`0P2cWW1ZDD0jDd0nmM1_oo0_Nn0nmm0nmM
0nLL0mkk0mkK0W_?0g__0b4T0`0P0`000`0P0PQQ0a2R0aS30b440g_?0mJj0_oO0ooo0ooO0oNN0nmM
0iBb0YcC0cW70`Q10`000a2R0aS30g>>0/ii0ooO0ooo0ooO0oNN0nmM0^Ll0haa0c660`0P0`000`0P
1CW70icc0nLl3_oo0e:Z0Q2R0`0P0`000`0P2cWW1ZDD0jDd0nmM1Ooo0oNn0nmm0nmM0nLL0]kk0mkK
0g_?0g__0b4T0`0P0`000P0P0`QQ0a2R0aS30b440g_?0]Jj0ooO0ooo0ooO0oNN0nmM0YBb0icC0cW7
0`Q10`000a2R0QS30g>>0lii0ooO0ooo0ooO0oNN0^mM0nLl0haa0c660`0P0`000P0P1SW70icc0nLl
3_oo0U:Z0a2R0`0P0`000`0P2cWW1ZDD0jDd0^mM1_oo0oNn0nmm0nmM0^LL0mkk0mkK0g_?0g__0b4T
0P0P0`000`0P0`QQ0a2R0aS30b440W_?0mJj0ooO0ooo0ooO0oNN0^mM0iBb0icC0cW70`Q10`000Q2R
0aS30g>>0lii0ooO0ooo0_oO0oNN0nmM0nLl0haa0c660P0P0`000`0P1SW70icc0nLl3Ooo0e:Z0a2R
0`0P0`000P0P33WW1JDD0jDd0nmM1_oo0oNn0nmm0^mM0nLL0mkk0mkK0g_?0g__0R4T0`0P0`000`0P
0`QQ0a2R0QS30b440g_?0mJj0ooO0ooo0_oO0oNN0nmM0iBb0icC0cW70PQ10`000a2R0aS30g>>0lii
0ooO0_oo0ooO0oNN0nmM0nLl0haa0S660`0P0`000`0P1SW70Ycc0nLl7_oo000Gool3g]/3e[X5eYX6
cWT;cUT3Hb`36<<324460002244348836<<3Jfd3Jdd5Hb`3H``3F^/3_OL3mih5ool3mkh3kgd3W?<3
>NL324450003244348836<<36><28@@38B@3:DD3S543g_/6ool2oml3mih3ked3ia`3S745U983<JH3
24430003020326424:836<<38@@3Nll3eYX3ia`8ool3g]/2e[X6eYX6cWT;cUT3Hb`36<<324450003
244348836<<3Jfd2Jdd6Hb`3H``3F^/3_OL3mih5ool3mkh3kgd3W?<3>NL224460003244348836<<2
6><38@@38B@3:DD3S543g_/5ool3oml3mih3ked3ia`3S745U983<JH324430003020226434:836<<3
8@@3Nll3eYX2ia`9ool2g]/3e[X6eYX6cWT;cUT3Hb`36<<224460003244348836<<2Jfd3Jdd6Hb`3
H``3F^/2_OL3mih6ool3mkh3kgd3W?<2>NL324460003244348826<<36><38@@38B@3:DD3S542g_/6
ool3oml3mih3ked2ia`3S746U983<JH324420003020326434:836<<38@@3Nll2eYX3ia`8ool3g]/3
e[X6eYX5cWT<cUT2Hb`36<<324460003244348826<<3Jfd3Jdd6Hb`3H``2F^/3_OL3mih6ool3mkh2
kgd3W?<3>NL324460002244348836<<36><38@@38B@2:DD3S543g_/6ool3oml3mih2ked3ia`3S746
U983<JH224430003020326434:836<<28@@3Nll3eYX3ia`Hool001Ooo`?Nf`?F^PGFVPK>N@_>F@=S
;0<H``<8@@H00088@@<@PP<H``=[K@=[C@ES;0=S30=Jj`>mm`?gWPGoo`?g_P?_O@>Ll`<ii`<8@@D0
00<8@@<@PP<H``<Hh`8Q10<Q90<YA@><D@?Nn`Koo`;og`?gWP?_G@?W70><L@FDTP<aYP<8@@<000<0
80<8H@8@XP<H``<Q10=kc`?FVP?W70Soo`?Nf`;F^PKFVPK>N@_>F@=S;0<H``<8@@D000<8@@<@PP<H
``=[K@9[C@IS;0=S30=Jj`>mm`?gWPGoo`?g_P?_O@>Ll`<ii`88@@H000<8@@<@PP<H``8Hh`<Q10<Q
90<YA@><D@?Nn`Goo`?og`?gWP?_G@?W70><L@FDTP<aYP<8@@<000<08088H@<@XP<H``<Q10=kc`?F
VP;W70Woo`;Nf`?F^PKFVPK>N@_>F@=S;0<H``88@@H000<8@@<@PP<H``9[K@=[C@IS;0=S30=Jj`:m
m`?gWPKoo`?g_P?_O@>Ll`8ii`<8@@H000<8@@<@PP8H``<Hh`<Q10<Q90<YA@><D@;Nn`Koo`?og`?g
WP?_G@;W70><L@JDTP<aYP<8@@8000<080<8H@<@XP<H``<Q10=kc`;FVP?W70Soo`?Nf`?F^PKFVPG>
N@c>F@9S;0<H``<8@@H000<8@@<@PP8H``=[K@=[C@IS;0=S309Jj`>mm`?gWPKoo`?g_P;_O@>Ll`<i
i`<8@@H00088@@<@PP<H``<Hh`<Q10<Q908YA@><D@?Nn`Koo`?og`?gWP;_G@?W70><L@JDTP<aYP88
@@<000<080<8H@<@XP<H``8Q10=kc`?FVP?W71Soo`005ooo0mkK0mJj1MJJ1/ii2liI0f</0aS30`Q1
1P000PQ10a220aS30f]]0f]=1F</0f<<0e[[0kgg0oNN1Ooo0oNn0nmm0icc0cWW0`Q11@000`Q10a22
0aS30aSS0R440b4T0bU50haA0mkk1_oo0_oO0oNN0nmM0nLL0haa1IBB0c6V0`Q10`000`0P0`QQ0Q2R
0aS30b440g_?0mJJ0nLL2?oo0mkK0]Jj1]JJ1/ii2liI0f</0aS30`Q11@000`Q10a220aS30f]]0V]=
1V</0f<<0e[[0kgg0oNN1Ooo0oNn0nmm0icc0cWW0PQ11P000`Q10a220aS30QSS0b440b4T0bU50haA
0mkk1Ooo0ooO0oNN0nmM0nLL0haa1IBB0c6V0`Q10`000`0P0PQQ0a2R0aS30b440g_?0mJJ0^LL2Ooo
0]kK0mJj1]JJ1/ii2liI0f</0aS30PQ11P000`Q10a220aS30V]]0f]=1V</0f<<0e[[0[gg0oNN1_oo
0oNn0nmm0icc0SWW0`Q11P000`Q10a220QS30aSS0b440b4T0bU50haA0]kk1_oo0ooO0oNN0nmM0^LL
0haa1YBB0c6V0`Q10P000`0P0`QQ0a2R0aS30b440g_?0]JJ0nLL2?oo0mkK0mJj1]JJ1Lii3<iI0V</
0aS30`Q11P000`Q10a220QS30f]]0f]=1V</0f<<0U[[0kgg0oNN1_oo0oNn0^mm0icc0cWW0`Q11P00
0PQ10a220aS30aSS0b440b4T0RU50haA0mkk1_oo0ooO0oNN0^mM0nLL0haa1YBB0c6V0PQ10`000`0P
0`QQ0a2R0aS30R440g_?0mJJ0nLL6?oo000Gool3g]/3e[X5eYX6cWT;cUT3Hb`36<<3244600022443
48836<<3Jfd3Jdd5Hb`3H``3F^/3_OL3mih5ool3mkh3kgd3W?<3>NL324450003244348836<<36><2
8@@38B@3:DD3S543g_/6ool2oml3mih3ked3ia`3S745U983<JH324430003020326424:836<<38@@3
Nll3eYX3ia`8ool3g]/2e[X6eYX6cWT;cUT3Hb`36<<324450003244348836<<3Jfd2Jdd6Hb`3H``3
F^/3_OL3mih5ool3mkh3kgd3W?<3>NL224460003244348836<<26><38@@38B@3:DD3S543g_/5ool3
oml3mih3ked3ia`3S745U983<JH324430003020226434:836<<38@@3Nll3eYX2ia`9ool2g]/3e[X6
eYX6cWT;cUT3Hb`36<<224460003244348836<<2Jfd3Jdd6Hb`3H``3F^/2_OL3mih6ool3mkh3kgd3
W?<2>NL324460003244348826<<36><38@@38B@3:DD3S542g_/6ool3oml3mih3ked2ia`3S746U983
<JH324420003020326434:836<<38@@3Nll2eYX3ia`8ool3g]/3e[X6eYX5cWT<cUT2Hb`36<<32446
0003244348826<<3Jfd3Jdd6Hb`3H``2F^/3_OL3mih6ool3mkh2kgd3W?<3>NL32446000224434883
6<<36><38@@38B@2:DD3S543g_/6ool3oml3mih2ked3ia`3S746U983<JH224430003020326434:83
6<<28@@3Nll3eYX3ia`Hool001Ooo`?Nf`?F^PGFVPK>N@_>F@=S;0<H``<8@@H00088@@<@PP<H``=[
K@=[C@ES;0=S30=Jj`>mm`?gWPGoo`?g_P?_O@>Ll`<ii`<8@@D000<8@@<@PP<H``<Hh`8Q10<Q90<Y
A@><D@?Nn`Koo`;og`?gWP?_G@?W70><L@FDTP<aYP<8@@<000<080<8H@8@XP<H``<Q10=kc`?FVP?W
70Soo`?Nf`;F^PKFVPK>N@_>F@=S;0<H``<8@@D000<8@@<@PP<H``=[K@9[C@IS;0=S30=Jj`>mm`?g
WPGoo`?g_P?_O@>Ll`<ii`88@@H000<8@@<@PP<H``8Hh`<Q10<Q90<YA@><D@?Nn`Goo`?og`?gWP?_
G@?W70><L@FDTP<aYP<8@@<000<08088H@<@XP<H``<Q10=kc`?FVP;W70Woo`;Nf`?F^PKFVPK>N@_>
F@=S;0<H``88@@H000<8@@<@PP<H``9[K@=[C@IS;0=S30=Jj`:mm`?gWPKoo`?g_P?_O@>Ll`8ii`<8
@@H000<8@@<@PP8H``<Hh`<Q10<Q90<YA@><D@;Nn`Koo`?og`?gWP?_G@;W70><L@JDTP<aYP<8@@80
00<080<8H@<@XP<H``<Q10=kc`;FVP?W70Soo`?Nf`?F^PKFVPG>N@c>F@9S;0<H``<8@@H000<8@@<@
PP8H``=[K@=[C@IS;0=S309Jj`>mm`?gWPKoo`?g_P;_O@>Ll`<ii`<8@@H00088@@<@PP<H``<Hh`<Q
10<Q908YA@><D@?Nn`Koo`?og`?gWP;_G@?W70><L@JDTP<aYP88@@<000<080<8H@<@XP<H``8Q10=k
c`?FVP?W71Soo`005ooo0mkK0mJj1MJJ1/ii2liI0f</0aS30`Q11P000PQ10a220aS30f]]0f]=1F</
0f<<0e[[0kgg0oNN1Ooo0oNn0nmm0icc0cWW0`Q11@000`Q10a220aS30aSS0R440b4T0bU50haA0mkk
1_oo0_oO0oNN0nmM0nLL0haa1IBB0c6V0`Q10`000`0P0`QQ0Q2R0aS30b440g_?0mJJ0nLL2?oo0mkK
0]Jj1]JJ1/ii2liI0f</0aS30`Q11@000`Q10a220aS30f]]0V]=1V</0f<<0e[[0kgg0oNN1Ooo0oNn
0nmm0icc0cWW0PQ11P000`Q10a220aS30QSS0b440b4T0bU50haA0mkk1Ooo0ooO0oNN0nmM0nLL0haa
1IBB0c6V0`Q10`000`0P0PQQ0a2R0aS30b440g_?0mJJ0^LL2Ooo0]kK0mJj1]JJ1/ii2liI0f</0aS3
0PQ11P000`Q10a220aS30V]]0f]=1V</0f<<0e[[0[gg0oNN1_oo0oNn0nmm0icc0SWW0`Q11P000`Q1
0a220QS30aSS0b440b4T0bU50haA0]kk1_oo0ooO0oNN0nmM0^LL0haa1YBB0c6V0`Q10P000`0P0`QQ
0a2R0aS30b440g_?0]JJ0nLL2?oo0mkK0mJj1]JJ1Lii3<iI0V</0aS30`Q11P000`Q10a220QS30f]]
0f]=1V</0f<<0U[[0kgg0oNN1_oo0oNn0^mm0icc0cWW0`Q11P000PQ10a220aS30aSS0b440b4T0RU5
0haA0mkk1_oo0ooO0oNN0^mM0nLL0haa1YBB0c6V0PQ10`000`0P0`QQ0a2R0aS30R440g_?0mJJ0nLL
6?oo000Gool3g]/3e[X5eYX6cWT;cUT3Hb`36<<324460002244348836<<3Jfd3Jdd5Hb`3H``3F^/3
_OL3mih5ool3mkh3kgd3W?<3>NL324450003244348836<<36><28@@38B@3:DD3S543g_/6ool2oml3
mih3ked3ia`3S745U983<JH324430003020326424:836<<38@@3Nll3eYX3ia`8ool3g]/2e[X6eYX6
cWT;cUT3Hb`36<<324450003244348836<<3Jfd2Jdd6Hb`3H``3F^/3_OL3mih5ool3mkh3kgd3W?<3
>NL224460003244348836<<26><38@@38B@3:DD3S543g_/5ool3oml3mih3ked3ia`3S745U983<JH3
24430003020226434:836<<38@@3Nll3eYX2ia`9ool2g]/3e[X6eYX6cWT;cUT3Hb`36<<224460003
244348836<<2Jfd3Jdd6Hb`3H``3F^/2_OL3mih6ool3mkh3kgd3W?<2>NL324460003244348826<<3
6><38@@38B@3:DD3S542g_/6ool3oml3mih3ked2ia`3S746U983<JH324420003020326434:836<<3
8@@3Nll2eYX3ia`8ool3g]/3e[X6eYX5cWT<cUT2Hb`36<<324460003244348826<<3Jfd3Jdd6Hb`3
H``2F^/3_OL3mih6ool3mkh2kgd3W?<3>NL324460002244348836<<36><38@@38B@2:DD3S543g_/6
ool3oml3mih2ked3ia`3S746U983<JH224430003020326434:836<<28@@3Nll3eYX3ia`Hool001Oo
o`?Nf`?F^PGFVPK>N@_>F@=S;0<H``<8@@H00088@@<@PP<H``=[K@=[C@ES;0=S30=Jj`>mm`?gWPGo
o`?g_P?_O@>Ll`<ii`<8@@D000<8@@<@PP<H``<Hh`8Q10<Q90<YA@><D@?Nn`Koo`;og`?gWP?_G@?W
70><L@FDTP<aYP<8@@<000<080<8H@8@XP<H``<Q10=kc`?FVP?W70Soo`?Nf`;F^PKFVPK>N@_>F@=S
;0<H``<8@@D000<8@@<@PP<H``=[K@9[C@IS;0=S30=Jj`>mm`?gWPGoo`?g_P?_O@>Ll`<ii`88@@H0
00<8@@<@PP<H``8Hh`<Q10<Q90<YA@><D@?Nn`Goo`?og`?gWP?_G@?W70><L@FDTP<aYP<8@@<000<0
8088H@<@XP<H``<Q10=kc`?FVP;W70Woo`;Nf`?F^PKFVPK>N@_>F@=S;0<H``88@@H000<8@@<@PP<H
``9[K@=[C@IS;0=S30=Jj`:mm`?gWPKoo`?g_P?_O@>Ll`8ii`<8@@H000<8@@<@PP8H``<Hh`<Q10<Q
90<YA@><D@;Nn`Koo`?og`?gWP?_G@;W70><L@JDTP<aYP<8@@8000<080<8H@<@XP<H``<Q10=kc`;F
VP?W70Soo`?Nf`?F^PKFVPG>N@c>F@9S;0<H``<8@@H000<8@@<@PP8H``=[K@=[C@IS;0=S309Jj`>m
m`?gWPKoo`?g_P;_O@>Ll`<ii`<8@@H00088@@<@PP<H``<Hh`<Q10<Q908YA@><D@?Nn`Koo`?og`?g
WP;_G@?W70><L@JDTP<aYP88@@<000<080<8H@<@XP<H``8Q10=kc`?FVP?W71Soo`005ooo0mkK0mJj
1MJJ1/ii2liI0f</0aS30`Q11P000PQ10a220aS30f]]0f]=1F</0f<<0e[[0kgg0oNN1Ooo0oNn0nmm
0icc0cWW0`Q11@000`Q10a220aS30aSS0R440b4T0bU50haA0mkk1_oo0_oO0oNN0nmM0nLL0haa1IBB
0c6V0`Q10`000`0P0`QQ0Q2R0aS30b440g_?0mJJ0nLL2?oo0mkK0]Jj1]JJ1/ii2liI0f</0aS30`Q1
1@000`Q10a220aS30f]]0V]=1V</0f<<0e[[0kgg0oNN1Ooo0oNn0nmm0icc0cWW0PQ11P000`Q10a22
0aS30QSS0b440b4T0bU50haA0mkk1Ooo0ooO0oNN0nmM0nLL0haa1IBB0c6V0`Q10`000`0P0PQQ0a2R
0aS30b440g_?0mJJ0^LL2Ooo0]kK0mJj1]JJ1/ii2liI0f</0aS30PQ11P000`Q10a220aS30V]]0f]=
1V</0f<<0e[[0[gg0oNN1_oo0oNn0nmm0icc0SWW0`Q11P000`Q10a220QS30aSS0b440b4T0bU50haA
0]kk1_oo0ooO0oNN0nmM0^LL0haa1YBB0c6V0`Q10P000`0P0`QQ0a2R0aS30b440g_?0]JJ0nLL2?oo
0mkK0mJj1]JJ1Lii3<iI0V</0aS30`Q11P000`Q10a220QS30f]]0f]=1V</0f<<0U[[0kgg0oNN1_oo
0oNn0^mm0icc0cWW0`Q11P000PQ10a220aS30aSS0b440b4T0RU50haA0mkk1_oo0ooO0oNN0^mM0nLL
0haa1YBB0c6V0PQ10`000`0P0`QQ0a2R0aS30R440g_?0mJJ0nLL6?oo000Gool3g]/3e[X5eYX6cWT;
cUT3Hb`36<<324460002244348836<<3Jfd3Jdd5Hb`3H``3F^/3_OL3mih5ool3mkh3kgd3W?<3>NL3
24450003244348836<<36><28@@38B@3:DD3S543g_/6ool2oml3mih3ked3ia`3S745U983<JH32443
0003020326424:836<<38@@3Nll3eYX3ia`8ool3g]/2e[X6eYX6cWT;cUT3Hb`36<<3244500032443
48836<<3Jfd2Jdd6Hb`3H``3F^/3_OL3mih5ool3mkh3kgd3W?<3>NL224460003244348836<<26><3
8@@38B@3:DD3S543g_/5ool3oml3mih3ked3ia`3S745U983<JH324430003020226434:836<<38@@3
Nll3eYX2ia`9ool2g]/3e[X6eYX6cWT;cUT3Hb`36<<224460003244348836<<2Jfd3Jdd6Hb`3H``3
F^/2_OL3mih6ool3mkh3kgd3W?<2>NL324460003244348826<<36><38@@38B@3:DD3S542g_/6ool3
oml3mih3ked2ia`3S746U983<JH324420003020326434:836<<38@@3Nll2eYX3ia`8ool3g]/3e[X6
eYX5cWT<cUT2Hb`36<<324460003244348826<<3Jfd3Jdd6Hb`3H``2F^/3_OL3mih6ool3mkh2kgd3
W?<3>NL324460002244348836<<36><38@@38B@2:DD3S543g_/6ool3oml3mih2ked3ia`3S746U983
<JH224430003020326434:836<<28@@3Nll3eYX3ia`Hool001Ooo`?Nf`?F^PGFVPK>N@_>F@=S;0<H
``<8@@H00088@@<@PP<H``=[K@=[C@ES;0=S30=Jj`>mm`?gWPGoo`?g_P?_O@>Ll`<ii`<8@@D000<8
@@<@PP<H``<Hh`8Q10<Q90<YA@><D@?Nn`Koo`;og`?gWP?_G@?W70><L@FDTP<aYP<8@@<000<080<8
H@8@XP<H``<Q10=kc`?FVP?W70Soo`?Nf`;F^PKFVPK>N@_>F@=S;0<H``<8@@D000<8@@<@PP<H``=[
K@9[C@IS;0=S30=Jj`>mm`?gWPGoo`?g_P?_O@>Ll`<ii`88@@H000<8@@<@PP<H``8Hh`<Q10<Q90<Y
A@><D@?Nn`Goo`?og`?gWP?_G@?W70><L@FDTP<aYP<8@@<000<08088H@<@XP<H``<Q10=kc`?FVP;W
70Woo`;Nf`?F^PKFVPK>N@_>F@=S;0<H``88@@H000<8@@<@PP<H``9[K@=[C@IS;0=S30=Jj`:mm`?g
WPKoo`?g_P?_O@>Ll`8ii`<8@@H000<8@@<@PP8H``<Hh`<Q10<Q90<YA@><D@;Nn`Koo`?og`?gWP?_
G@;W70><L@JDTP<aYP<8@@8000<080<8H@<@XP<H``<Q10=kc`;FVP?W70Soo`?Nf`?F^PKFVPG>N@c>
F@9S;0<H``<8@@H000<8@@<@PP8H``=[K@=[C@IS;0=S309Jj`>mm`?gWPKoo`?g_P;_O@>Ll`<ii`<8
@@H00088@@<@PP<H``<Hh`<Q10<Q908YA@><D@?Nn`Koo`?og`?gWP;_G@?W70><L@JDTP<aYP88@@<0
00<080<8H@<@XP<H``8Q10=kc`?FVP?W71Soo`007Ooo0]kK0mJj1W_?0g__0b4T0P0P0`000`Q10a22
0e[[0kgg0oNN1Ooo0oNn0nmm0icc0cWW0PQ10`000a220a2R0f]=0liI0]Jj0ooO0ooo0ooO0oNN0nmM
0YcC0cW70`Q11P001C6V1YcC0nLl1_oo0ooO0_NN0nmM0nLL0mkk0mkK0mJj0W>^0g_?0b4T0a2R1P00
0PQ10a220a2R0aSS0g>^0g>>3Ooo0mkK0mJj1W_?0g__0R4T0`0P0`000`Q10a220e[[0[gg0oNN1_oo
0oNn0nmm0Ycc0cWW0`Q10`000a220a2R0f]=0/iI0mJj0ooO0ooo0ooO0oNN0^mM0icC0cW70`Q11P00
1C6V1YcC0nLl1Ooo0ooO0oNN0nmM0nLL0mkk0mkK0]Jj0g>^0g_?0b4T0a2R1@000`Q10a220a2R0aSS
0g>^0W>>3_oo0mkK0mJj1W_?0W__0b4T0`0P0`000`Q10a220U[[0kgg0oNN1_oo0oNn0^mm0icc0cWW
0`Q10`000a220Q2R0f]=0liI0mJj0ooO0ooo0ooO0_NN0nmM0icC0cW70`Q11@001S6V1YcC0nLl1Ooo
0ooO0oNN0nmM0nLL0]kk0mkK0mJj0g>^0g_?0b4T0Q2R1P000`Q10a220a2R0aSS0W>^0g>>3_oo0mkK
0mJj1G_?0g__0b4T0`0P0`000PQ10a220e[[0kgg0oNN1_oo0_Nn0nmm0icc0cWW0`Q10`000Q220a2R
0f]=0liI0mJj0ooO0_oo0ooO0oNN0nmM0icC0cW70PQ11P001S6V1IcC0nLl1_oo0ooO0oNN0nmM0^LL
0mkk0mkK0mJj0g>^0g_?0R4T0a2R1P000`Q10a220Q2R0aSS0g>^0g>>6?oo000Mool2g]/3e[X6Nll3
Nnl38B@20203000324434883F^/3_OL3mih5ool3mkh3kgd3W?<3>NL22443000348834:83Jdd3cUT2
e[X3oml3ool3oml3mih3ked2W=<3>LL324460005<JH6W=<3ic`6ool3oml2mih3ked3ia`3g_/3g]/3
e[X2Ljh3Nll38B@34:860002244348834:836><3Ljh3Lhh=ool3g]/3e[X6Nll3Nnl28B@302030003
24434883F^/2_OL3mih6ool3mkh3kgd2W?<3>NL32443000348834:83Jdd2cUT3e[X3oml3ool3oml3
mih2ked3W=<3>LL324460005<JH6W=<3ic`5ool3oml3mih3ked3ia`3g_/3g]/2e[X3Ljh3Nll38B@3
4:850003244348834:836><3Ljh2Lhh>ool3g]/3e[X6Nll2Nnl38B@30203000324434882F^/3_OL3
mih6ool3mkh2kgd3W?<3>NL32443000348824:83Jdd3cUT3e[X3oml3ool3oml2mih3ked3W=<3>LL3
24450006<JH6W=<3ic`5ool3oml3mih3ked3ia`2g_/3g]/3e[X3Ljh3Nll38B@24:86000324434883
4:836><2Ljh3Lhh>ool3g]/3e[X5Nll3Nnl38B@30203000224434883F^/3_OL3mih6ool2mkh3kgd3
W?<3>NL32443000248834:83Jdd3cUT3e[X3oml2ool3oml3mih3ked3W=<3>LL224460006<JH5W=<3
ic`6ool3oml3mih3ked2ia`3g_/3g]/3e[X3Ljh3Nll28B@34:860003244348824:836><3Ljh3LhhH
ool001goo`;Nf`?F^PIkc`=kk`<Q908080<000<8@@<@PP=Jj`>mm`?gWPGoo`?g_P?_O@>Ll`<ii`88
@@<000<@PP<@XP=[C@?>F@;F^P?og`?oo`?og`?gWP?_G@:Ld`<ia`<8@@H000DaYPJLd`?W?0Koo`?o
g`;gWP?_G@?W70?Nn`?Nf`?F^P9c[P=kc`<Q90<@XPH00088@@<@PP<@XP<Hh`=c[P=cSPgoo`?Nf`?F
^PIkc`=kk`8Q90<080<000<8@@<@PP=Jj`:mm`?gWPKoo`?g_P?_O@:Ll`<ii`<8@@<000<@PP<@XP=[
C@;>F@?F^P?og`?oo`?og`?gWP;_G@>Ld`<ia`<8@@H000DaYPJLd`?W?0Goo`?og`?gWP?_G@?W70?N
n`?Nf`;F^P=c[P=kc`<Q90<@XPD000<8@@<@PP<@XP<Hh`=c[P9cSPkoo`?Nf`?F^PIkc`9kk`<Q90<0
80<000<8@@<@PP9Jj`>mm`?gWPKoo`?g_P;_O@>Ll`<ii`<8@@<000<@PP8@XP=[C@?>F@?F^P?og`?o
o`?og`;gWP?_G@>Ld`<ia`<8@@D000HaYPJLd`?W?0Goo`?og`?gWP?_G@?W70;Nn`?Nf`?F^P=c[P=k
c`<Q908@XPH000<8@@<@PP<@XP<Hh`9c[P=cSPkoo`?Nf`?F^PEkc`=kk`<Q90<080<00088@@<@PP=J
j`>mm`?gWPKoo`;g_P?_O@>Ll`<ii`<8@@<0008@PP<@XP=[C@?>F@?F^P?og`;oo`?og`?gWP?_G@>L
d`<ia`88@@H000HaYPFLd`?W?0Koo`?og`?gWP?_G@;W70?Nn`?Nf`?F^P=c[P=kc`8Q90<@XPH000<8
@@<@PP8@XP<Hh`=c[P=cSQSoo`007Ooo0]kK0mJj1W_?0g__0b4T0P0P0`000`Q10a220e[[0kgg0oNN
1Ooo0oNn0nmm0icc0cWW0PQ10`000a220a2R0f]=0liI0]Jj0ooO0ooo0ooO0oNN0nmM0YcC0cW70`Q1
1P001C6V1YcC0nLl1_oo0ooO0_NN0nmM0nLL0mkk0mkK0mJj0W>^0g_?0b4T0a2R1P000PQ10a220a2R
0aSS0g>^0g>>3Ooo0mkK0mJj1W_?0g__0R4T0`0P0`000`Q10a220e[[0[gg0oNN1_oo0oNn0nmm0Ycc
0cWW0`Q10`000a220a2R0f]=0/iI0mJj0ooO0ooo0ooO0oNN0^mM0icC0cW70`Q11P001C6V1YcC0nLl
1Ooo0ooO0oNN0nmM0nLL0mkk0mkK0]Jj0g>^0g_?0b4T0a2R1@000`Q10a220a2R0aSS0g>^0W>>3_oo
0mkK0mJj1W_?0W__0b4T0`0P0`000`Q10a220U[[0kgg0oNN1_oo0oNn0^mm0icc0cWW0`Q10`000a22
0Q2R0f]=0liI0mJj0ooO0ooo0ooO0_NN0nmM0icC0cW70`Q11@001S6V1YcC0nLl1Ooo0ooO0oNN0nmM
0nLL0]kk0mkK0mJj0g>^0g_?0b4T0Q2R1P000`Q10a220a2R0aSS0W>^0g>>3_oo0mkK0mJj1G_?0g__
0b4T0`0P0`000PQ10a220e[[0kgg0oNN1_oo0_Nn0nmm0icc0cWW0`Q10`000Q220a2R0f]=0liI0mJj
0ooO0_oo0ooO0oNN0nmM0icC0cW70PQ11P001S6V1IcC0nLl1_oo0ooO0oNN0nmM0^LL0mkk0mkK0mJj
0g>^0g_?0R4T0a2R1P000`Q10a220Q2R0aSS0g>^0g>>6?oo000Mool2g]/3e[X6Nll3Nnl38B@20203
000324434883F^/3_OL3mih5ool3mkh3kgd3W?<3>NL22443000348834:83Jdd3cUT2e[X3oml3ool3
oml3mih3ked2W=<3>LL324460005<JH6W=<3ic`6ool3oml2mih3ked3ia`3g_/3g]/3e[X2Ljh3Nll3
8B@34:860002244348834:836><3Ljh3Lhh=ool3g]/3e[X6Nll3Nnl28B@30203000324434883F^/2
_OL3mih6ool3mkh3kgd2W?<3>NL32443000348834:83Jdd2cUT3e[X3oml3ool3oml3mih2ked3W=<3
>LL324460005<JH6W=<3ic`5ool3oml3mih3ked3ia`3g_/3g]/2e[X3Ljh3Nll38B@34:8500032443
48834:836><3Ljh2Lhh>ool3g]/3e[X6Nll2Nnl38B@30203000324434882F^/3_OL3mih6ool3mkh2
kgd3W?<3>NL32443000348824:83Jdd3cUT3e[X3oml3ool3oml2mih3ked3W=<3>LL324450006<JH6
W=<3ic`5ool3oml3mih3ked3ia`2g_/3g]/3e[X3Ljh3Nll38B@24:860003244348834:836><2Ljh3
Lhh>ool3g]/3e[X5Nll3Nnl38B@30203000224434883F^/3_OL3mih6ool2mkh3kgd3W?<3>NL32443
000248834:83Jdd3cUT3e[X3oml2ool3oml3mih3ked3W=<3>LL224460006<JH5W=<3ic`6ool3oml3
mih3ked2ia`3g_/3g]/3e[X3Ljh3Nll28B@34:860003244348824:836><3Ljh3LhhHool001goo`;N
f`?F^PIkc`=kk`<Q908080<000<8@@<@PP=Jj`>mm`?gWPGoo`?g_P?_O@>Ll`<ii`88@@<000<@PP<@
XP=[C@?>F@;F^P?og`?oo`?og`?gWP?_G@:Ld`<ia`<8@@H000DaYPJLd`?W?0Koo`?og`;gWP?_G@?W
70?Nn`?Nf`?F^P9c[P=kc`<Q90<@XPH00088@@<@PP<@XP<Hh`=c[P=cSPgoo`?Nf`?F^PIkc`=kk`8Q
90<080<000<8@@<@PP=Jj`:mm`?gWPKoo`?g_P?_O@:Ll`<ii`<8@@<000<@PP<@XP=[C@;>F@?F^P?o
g`?oo`?og`?gWP;_G@>Ld`<ia`<8@@H000DaYPJLd`?W?0Goo`?og`?gWP?_G@?W70?Nn`?Nf`;F^P=c
[P=kc`<Q90<@XPD000<8@@<@PP<@XP<Hh`=c[P9cSPkoo`?Nf`?F^PIkc`9kk`<Q90<080<000<8@@<@
PP9Jj`>mm`?gWPKoo`?g_P;_O@>Ll`<ii`<8@@<000<@PP8@XP=[C@?>F@?F^P?og`?oo`?og`;gWP?_
G@>Ld`<ia`<8@@D000HaYPJLd`?W?0Goo`?og`?gWP?_G@?W70;Nn`?Nf`?F^P=c[P=kc`<Q908@XPH0
00<8@@<@PP<@XP<Hh`9c[P=cSPkoo`?Nf`?F^PEkc`=kk`<Q90<080<00088@@<@PP=Jj`>mm`?gWPKo
o`;g_P?_O@>Ll`<ii`<8@@<0008@PP<@XP=[C@?>F@?F^P?og`;oo`?og`?gWP?_G@>Ld`<ia`88@@H0
00HaYPFLd`?W?0Koo`?og`?gWP?_G@;W70?Nn`?Nf`?F^P=c[P=kc`8Q90<@XPH000<8@@<@PP8@XP<H
h`=c[P=cSQSoo`007Ooo0]kK0mJj1W_?0g__0b4T0P0P0`000`Q10a220e[[0kgg0oNN1Ooo0oNn0nmm
0icc0cWW0PQ10`000a220a2R0f]=0liI0]Jj0ooO0ooo0ooO0oNN0nmM0YcC0cW70`Q11P001C6V1YcC
0nLl1_oo0ooO0_NN0nmM0nLL0mkk0mkK0mJj0W>^0g_?0b4T0a2R1P000PQ10a220a2R0aSS0g>^0g>>
3Ooo0mkK0mJj1W_?0g__0R4T0`0P0`000`Q10a220e[[0[gg0oNN1_oo0oNn0nmm0Ycc0cWW0`Q10`00
0a220a2R0f]=0/iI0mJj0ooO0ooo0ooO0oNN0^mM0icC0cW70`Q11P001C6V1YcC0nLl1Ooo0ooO0oNN
0nmM0nLL0mkk0mkK0]Jj0g>^0g_?0b4T0a2R1@000`Q10a220a2R0aSS0g>^0W>>3_oo0mkK0mJj1W_?
0W__0b4T0`0P0`000`Q10a220U[[0kgg0oNN1_oo0oNn0^mm0icc0cWW0`Q10`000a220Q2R0f]=0liI
0mJj0ooO0ooo0ooO0_NN0nmM0icC0cW70`Q11@001S6V1YcC0nLl1Ooo0ooO0oNN0nmM0nLL0]kk0mkK
0mJj0g>^0g_?0b4T0Q2R1P000`Q10a220a2R0aSS0W>^0g>>3_oo0mkK0mJj1G_?0g__0b4T0`0P0`00
0PQ10a220e[[0kgg0oNN1_oo0_Nn0nmm0icc0cWW0`Q10`000Q220a2R0f]=0liI0mJj0ooO0_oo0ooO
0oNN0nmM0icC0cW70PQ11P001S6V1IcC0nLl1_oo0ooO0oNN0nmM0^LL0mkk0mkK0mJj0g>^0g_?0R4T
0a2R1P000`Q10a220Q2R0aSS0g>^0g>>6?oo000Mool2g]/3e[X6Nll3Nnl38B@20203000324434883
F^/3_OL3mih5ool3mkh3kgd3W?<3>NL22443000348834:83Jdd3cUT2e[X3oml3ool3oml3mih3ked2
W=<3>LL324460005<JH6W=<3ic`6ool3oml2mih3ked3ia`3g_/3g]/3e[X2Ljh3Nll38B@34:860002
244348834:836><3Ljh3Lhh=ool3g]/3e[X6Nll3Nnl28B@30203000324434883F^/2_OL3mih6ool3
mkh3kgd2W?<3>NL32443000348834:83Jdd2cUT3e[X3oml3ool3oml3mih2ked3W=<3>LL324460005
<JH6W=<3ic`5ool3oml3mih3ked3ia`3g_/3g]/2e[X3Ljh3Nll38B@34:850003244348834:836><3
Ljh2Lhh>ool3g]/3e[X6Nll2Nnl38B@30203000324434882F^/3_OL3mih6ool3mkh2kgd3W?<3>NL3
2443000348824:83Jdd3cUT3e[X3oml3ool3oml2mih3ked3W=<3>LL324450006<JH6W=<3ic`5ool3
oml3mih3ked3ia`2g_/3g]/3e[X3Ljh3Nll38B@24:860003244348834:836><2Ljh3Lhh>ool3g]/3
e[X5Nll3Nnl38B@30203000224434883F^/3_OL3mih6ool2mkh3kgd3W?<3>NL32443000248834:83
Jdd3cUT3e[X3oml2ool3oml3mih3ked3W=<3>LL224460006<JH5W=<3ic`6ool3oml3mih3ked2ia`3
g_/3g]/3e[X3Ljh3Nll28B@34:860003244348824:836><3Ljh3LhhHool001goo`;Nf`?F^PIkc`=k
k`<Q908080<000<8@@<@PP=Jj`>mm`?gWPGoo`?g_P?_O@>Ll`<ii`88@@<000<@PP<@XP=[C@?>F@;F
^P?og`?oo`?og`?gWP?_G@:Ld`<ia`<8@@H000DaYPJLd`?W?0Koo`?og`;gWP?_G@?W70?Nn`?Nf`?F
^P9c[P=kc`<Q90<@XPH00088@@<@PP<@XP<Hh`=c[P=cSPgoo`?Nf`?F^PIkc`=kk`8Q90<080<000<8
@@<@PP=Jj`:mm`?gWPKoo`?g_P?_O@:Ll`<ii`<8@@<000<@PP<@XP=[C@;>F@?F^P?og`?oo`?og`?g
WP;_G@>Ld`<ia`<8@@H000DaYPJLd`?W?0Goo`?og`?gWP?_G@?W70?Nn`?Nf`;F^P=c[P=kc`<Q90<@
XPD000<8@@<@PP<@XP<Hh`=c[P9cSPkoo`?Nf`?F^PIkc`9kk`<Q90<080<000<8@@<@PP9Jj`>mm`?g
WPKoo`?g_P;_O@>Ll`<ii`<8@@<000<@PP8@XP=[C@?>F@?F^P?og`?oo`?og`;gWP?_G@>Ld`<ia`<8
@@D000HaYPJLd`?W?0Goo`?og`?gWP?_G@?W70;Nn`?Nf`?F^P=c[P=kc`<Q908@XPH000<8@@<@PP<@
XP<Hh`9c[P=cSPkoo`?Nf`?F^PEkc`=kk`<Q90<080<00088@@<@PP=Jj`>mm`?gWPKoo`;g_P?_O@>L
l`<ii`<8@@<0008@PP<@XP=[C@?>F@?F^P?og`;oo`?og`?gWP?_G@>Ld`<ia`88@@H000HaYPFLd`?W
?0Koo`?og`?gWP?_G@;W70?Nn`?Nf`?F^P=c[P=kc`8Q90<@XPH000<8@@<@PP8@XP<Hh`=c[P=cSQSo
o`007Ooo0]kK0mJj1W_?0g__0b4T0P0P0`000`Q10a220e[[0kgg0oNN1Ooo0oNn0nmm0icc0cWW0PQ1
0`000a220a2R0f]=0liI0]Jj0ooO0ooo0ooO0oNN0nmM0YcC0cW70`Q11P001C6V1YcC0nLl1_oo0ooO
0_NN0nmM0nLL0mkk0mkK0mJj0W>^0g_?0b4T0a2R1P000PQ10a220a2R0aSS0g>^0g>>3Ooo0mkK0mJj
1W_?0g__0R4T0`0P0`000`Q10a220e[[0[gg0oNN1_oo0oNn0nmm0Ycc0cWW0`Q10`000a220a2R0f]=
0/iI0mJj0ooO0ooo0ooO0oNN0^mM0icC0cW70`Q11P001C6V1YcC0nLl1Ooo0ooO0oNN0nmM0nLL0mkk
0mkK0]Jj0g>^0g_?0b4T0a2R1@000`Q10a220a2R0aSS0g>^0W>>3_oo0mkK0mJj1W_?0W__0b4T0`0P
0`000`Q10a220U[[0kgg0oNN1_oo0oNn0^mm0icc0cWW0`Q10`000a220Q2R0f]=0liI0mJj0ooO0ooo
0ooO0_NN0nmM0icC0cW70`Q11@001S6V1YcC0nLl1Ooo0ooO0oNN0nmM0nLL0]kk0mkK0mJj0g>^0g_?
0b4T0Q2R1P000`Q10a220a2R0aSS0W>^0g>>3_oo0mkK0mJj1G_?0g__0b4T0`0P0`000PQ10a220e[[
0kgg0oNN1_oo0_Nn0nmm0icc0cWW0`Q10`000Q220a2R0f]=0liI0mJj0ooO0_oo0ooO0oNN0nmM0icC
0cW70PQ11P001S6V1IcC0nLl1_oo0ooO0oNN0nmM0^LL0mkk0mkK0mJj0g>^0g_?0R4T0a2R1P000`Q1
0a220Q2R0aSS0g>^0g>>6?oo000Mool2g]/3e[X6Nll3Nnl38B@20203000324434883F^/3_OL3mih5
ool3mkh3kgd3W?<3>NL22443000348834:83Jdd3cUT2e[X3oml3ool3oml3mih3ked2W=<3>LL32446
0005<JH6W=<3ic`6ool3oml2mih3ked3ia`3g_/3g]/3e[X2Ljh3Nll38B@34:860002244348834:83
6><3Ljh3Lhh=ool3g]/3e[X6Nll3Nnl28B@30203000324434883F^/2_OL3mih6ool3mkh3kgd2W?<3
>NL32443000348834:83Jdd2cUT3e[X3oml3ool3oml3mih2ked3W=<3>LL324460005<JH6W=<3ic`5
ool3oml3mih3ked3ia`3g_/3g]/2e[X3Ljh3Nll38B@34:850003244348834:836><3Ljh2Lhh>ool3
g]/3e[X6Nll2Nnl38B@30203000324434882F^/3_OL3mih6ool3mkh2kgd3W?<3>NL3244300034882
4:83Jdd3cUT3e[X3oml3ool3oml2mih3ked3W=<3>LL324450006<JH6W=<3ic`5ool3oml3mih3ked3
ia`2g_/3g]/3e[X3Ljh3Nll38B@24:860003244348834:836><2Ljh3Lhh>ool3g]/3e[X5Nll3Nnl3
8B@30203000224434883F^/3_OL3mih6ool2mkh3kgd3W?<3>NL32443000248834:83Jdd3cUT3e[X3
oml2ool3oml3mih3ked3W=<3>LL224460006<JH5W=<3ic`6ool3oml3mih3ked2ia`3g_/3g]/3e[X3
Ljh3Nll28B@34:860003244348824:836><3Ljh3LhhHool001goo`;Nf`?F^PIkc`=kk`<Q908080<0
00<8@@<@PP=Jj`>mm`?gWPGoo`?g_P?_O@>Ll`<ii`88@@<000<@PP<@XP=[C@?>F@;F^P?og`?oo`?o
g`?gWP?_G@:Ld`<ia`<8@@H000DaYPJLd`?W?0Koo`?og`;gWP?_G@?W70?Nn`?Nf`?F^P9c[P=kc`<Q
90<@XPH00088@@<@PP<@XP<Hh`=c[P=cSPgoo`?Nf`?F^PIkc`=kk`8Q90<080<000<8@@<@PP=Jj`:m
m`?gWPKoo`?g_P?_O@:Ll`<ii`<8@@<000<@PP<@XP=[C@;>F@?F^P?og`?oo`?og`?gWP;_G@>Ld`<i
a`<8@@H000DaYPJLd`?W?0Goo`?og`?gWP?_G@?W70?Nn`?Nf`;F^P=c[P=kc`<Q90<@XPD000<8@@<@
PP<@XP<Hh`=c[P9cSPkoo`?Nf`?F^PIkc`9kk`<Q90<080<000<8@@<@PP9Jj`>mm`?gWPKoo`?g_P;_
O@>Ll`<ii`<8@@<000<@PP8@XP=[C@?>F@?F^P?og`?oo`?og`;gWP?_G@>Ld`<ia`<8@@D000HaYPJL
d`?W?0Goo`?og`?gWP?_G@?W70;Nn`?Nf`?F^P=c[P=kc`<Q908@XPH000<8@@<@PP<@XP<Hh`9c[P=c
SPkoo`?Nf`?F^PEkc`=kk`<Q90<080<00088@@<@PP=Jj`>mm`?gWPKoo`;g_P?_O@>Ll`<ii`<8@@<0
008@PP<@XP=[C@?>F@?F^P?og`;oo`?og`?gWP?_G@>Ld`<ia`88@@H000HaYPFLd`?W?0Koo`?og`?g
WP?_G@;W70?Nn`?Nf`?F^P=c[P=kc`8Q90<@XPH000<8@@<@PP8@XP<Hh`=c[P=cSQSoo`005ooo0f]]
0lii0]kK0ooO0ooo0oNn0nmm0jDD0T880`QQ1P000c660iBb0nLL1Ooo0ooO0kgg0e[;0a2R0P0P0`00
0`0P1SW70icc0^Ll0oNn0ooo0ooO0oNN0nmm0^Ll0haa0c660b4T0a2R1@000`Q10a221U[;0kgG0oNN
1Ooo0oNn0nmm0nLl0nLL0X@`0bUU0`0P0`000aS30b440R4T1RU50haA0mkk2ooo0f]]0/ii0mkK0ooO
0ooo0oNn0nmm0ZDD0d880`QQ1P000c660YBb0nLL1_oo0ooO0kgg0U[;0a2R0`0P0`000`0P1SW70Ycc
0nLl0oNn0ooo0ooO0oNN0^mm0nLl0haa0c660b4T0a2R1@000`Q10a221U[;0[gG0oNN1_oo0oNn0nmm
0nLl0^LL0h@`0bUU0`0P0`000aS30R440b4T1RU50haA0mkk2ooo0V]]0lii0mkK0ooO0ooo0oNn0^mm
0jDD0d880`QQ1P000S660iBb0nLL1_oo0ooO0[gg0e[;0a2R0`0P0`000`0P1CW70icc0nLl0oNn0ooo
0ooO0_NN0nmm0nLl0haa0c660b4T0Q2R1P000`Q10a221E[;0kgG0oNN1_oo0oNn0^mm0nLl0nLL0h@`
0bUU0`0P0P000aS30b440b4T1RU50haA0]kk2ooo0f]]0lii0mkK0ooO0_oo0oNn0nmm0jDD0d880`QQ
1@000c660iBb0nLL1_oo0_oO0kgg0e[;0a2R0`0P0`000P0P1SW70icc0nLl0oNn0_oo0ooO0oNN0nmm
0nLl0haa0S660b4T0a2R1P000`Q10Q221U[;0kgG0oNN1_oo0_Nn0nmm0nLl0nLL0h@`0bUU0P0P0`00
0aS30b440b4T1BU50haA0mkk6ooo000Gool3Jfd3cWT2g]/3oml3ool3mkh3kgd3YA@2@PP326460003
<HH3U;83ia`5ool3oml3_OL3F//34:82020300030206>LL3W?<2ic`3mkh3ool3oml3mih3kgd2ic`3
S743<HH38B@34:85000324434886F//3_ML3mih5ool3mkh3kgd3ic`3ia`2Q303:FD3020300036<<3
8@@28B@6:DD3S543g_/;ool3Jfd2cWT3g]/3oml3ool3mkh3kgd2YA@3@PP326460003<HH2U;83ia`6
ool3oml3_OL2F//34:83020300030206>LL2W?<3ic`3mkh3ool3oml3mih2kgd3ic`3S743<HH38B@3
4:85000324434886F//2_ML3mih6ool3mkh3kgd3ic`2ia`3Q303:FD3020300036<<28@@38B@6:DD3
S543g_/;ool2Jfd3cWT3g]/3oml3ool3mkh2kgd3YA@3@PP326460002<HH3U;83ia`6ool3oml2_OL3
F//34:83020300030205>LL3W?<3ic`3mkh3ool3oml2mih3kgd3ic`3S743<HH38B@24:8600032443
4885F//3_ML3mih6ool3mkh2kgd3ic`3ia`3Q303:FD3020200036<<38@@38B@6:DD3S542g_/;ool3
Jfd3cWT3g]/3oml2ool3mkh3kgd3YA@3@PP326450003<HH3U;83ia`6ool2oml3_OL3F//34:830203
00020206>LL3W?<3ic`3mkh2ool3oml3mih3kgd3ic`3S742<HH38B@34:86000324424886F//3_ML3
mih6ool2mkh3kgd3ic`3ia`3Q303:FD2020300036<<38@@38B@5:DD3S543g_/Kool001Ooo`=[K@?>
N@;Nf`?og`?oo`?g_P?_O@>U509220<8H@H000<aQP>D/P?W70Goo`?og`>mm`=Jb`<@XP8080<000<0
80Hia`>Ll`;W?0?g_P?oo`?og`?gWP?_O@;W?0><L@<aQP<Q90<@XPD000<8@@<@PPIJb`>me`?gWPGo
o`?g_P?_O@?W?0?W70:4<0<YI@<080<000<H``<Q108Q90HYA@><D@?Nn`_oo`=[K@;>N@?Nf`?og`?o
o`?g_P?_O@:U50=220<8H@H000<aQP:D/P?W70Koo`?og`>mm`9Jb`<@XP<080<000<080Hia`:Ll`?W
?0?g_P?oo`?og`?gWP;_O@?W?0><L@<aQP<Q90<@XPD000<8@@<@PPIJb`:me`?gWPKoo`?g_P?_O@?W
?0;W70>4<0<YI@<080<000<H``8Q10<Q90HYA@><D@?Nn`_oo`9[K@?>N@?Nf`?og`?oo`?g_P;_O@>U
50=220<8H@H0008aQP>D/P?W70Koo`?og`:mm`=Jb`<@XP<080<000<080Dia`>Ll`?W?0?g_P?oo`?o
g`;gWP?_O@?W?0><L@<aQP<Q908@XPH000<8@@<@PPEJb`>me`?gWPKoo`?g_P;_O@?W?0?W70>4<0<Y
I@<0808000<H``<Q10<Q90HYA@><D@;Nn`_oo`=[K@?>N@?Nf`?og`;oo`?g_P?_O@>U50=220<8H@D0
00<aQP>D/P?W70Koo`;og`>mm`=Jb`<@XP<080<0008080Hia`>Ll`?W?0?g_P;oo`?og`?gWP?_O@?W
?0><L@8aQP<Q90<@XPH000<8@@8@PPIJb`>me`?gWPKoo`;g_P?_O@?W?0?W70>4<0<YI@8080<000<H
``<Q10<Q90DYA@><D@?Nna_oo`005ooo0f]]0lii0]kK0ooO0ooo0oNn0nmm0jDD0T880`QQ1P000c66
0iBb0nLL1Ooo0ooO0kgg0e[;0a2R0P0P0`000`0P1SW70icc0^Ll0oNn0ooo0ooO0oNN0nmm0^Ll0haa
0c660b4T0a2R1@000`Q10a221U[;0kgG0oNN1Ooo0oNn0nmm0nLl0nLL0X@`0bUU0`0P0`000aS30b44
0R4T1RU50haA0mkk2ooo0f]]0/ii0mkK0ooO0ooo0oNn0nmm0ZDD0d880`QQ1P000c660YBb0nLL1_oo
0ooO0kgg0U[;0a2R0`0P0`000`0P1SW70Ycc0nLl0oNn0ooo0ooO0oNN0^mm0nLl0haa0c660b4T0a2R
1@000`Q10a221U[;0[gG0oNN1_oo0oNn0nmm0nLl0^LL0h@`0bUU0`0P0`000aS30R440b4T1RU50haA
0mkk2ooo0V]]0lii0mkK0ooO0ooo0oNn0^mm0jDD0d880`QQ1P000S660iBb0nLL1_oo0ooO0[gg0e[;
0a2R0`0P0`000`0P1CW70icc0nLl0oNn0ooo0ooO0_NN0nmm0nLl0haa0c660b4T0Q2R1P000`Q10a22
1E[;0kgG0oNN1_oo0oNn0^mm0nLl0nLL0h@`0bUU0`0P0P000aS30b440b4T1RU50haA0]kk2ooo0f]]
0lii0mkK0ooO0_oo0oNn0nmm0jDD0d880`QQ1@000c660iBb0nLL1_oo0_oO0kgg0e[;0a2R0`0P0`00
0P0P1SW70icc0nLl0oNn0_oo0ooO0oNN0nmm0nLl0haa0S660b4T0a2R1P000`Q10Q221U[;0kgG0oNN
1_oo0_Nn0nmm0nLl0nLL0h@`0bUU0P0P0`000aS30b440b4T1BU50haA0mkk6ooo000Gool3Jfd3cWT2
g]/3oml3ool3mkh3kgd3YA@2@PP326460003<HH3U;83ia`5ool3oml3_OL3F//34:82020300030206
>LL3W?<2ic`3mkh3ool3oml3mih3kgd2ic`3S743<HH38B@34:85000324434886F//3_ML3mih5ool3
mkh3kgd3ic`3ia`2Q303:FD3020300036<<38@@28B@6:DD3S543g_/;ool3Jfd2cWT3g]/3oml3ool3
mkh3kgd2YA@3@PP326460003<HH2U;83ia`6ool3oml3_OL2F//34:83020300030206>LL2W?<3ic`3
mkh3ool3oml3mih2kgd3ic`3S743<HH38B@34:85000324434886F//2_ML3mih6ool3mkh3kgd3ic`2
ia`3Q303:FD3020300036<<28@@38B@6:DD3S543g_/;ool2Jfd3cWT3g]/3oml3ool3mkh2kgd3YA@3
@PP326460002<HH3U;83ia`6ool3oml2_OL3F//34:83020300030205>LL3W?<3ic`3mkh3ool3oml2
mih3kgd3ic`3S743<HH38B@24:86000324434885F//3_ML3mih6ool3mkh2kgd3ic`3ia`3Q303:FD3
020200036<<38@@38B@6:DD3S542g_/;ool3Jfd3cWT3g]/3oml2ool3mkh3kgd3YA@3@PP326450003
<HH3U;83ia`6ool2oml3_OL3F//34:83020300020206>LL3W?<3ic`3mkh2ool3oml3mih3kgd3ic`3
S742<HH38B@34:86000324424886F//3_ML3mih6ool2mkh3kgd3ic`3ia`3Q303:FD2020300036<<3
8@@38B@5:DD3S543g_/Kool001Ooo`=[K@?>N@;Nf`?og`?oo`?g_P?_O@>U509220<8H@H000<aQP>D
/P?W70Goo`?og`>mm`=Jb`<@XP8080<000<080Hia`>Ll`;W?0?g_P?oo`?og`?gWP?_O@;W?0><L@<a
QP<Q90<@XPD000<8@@<@PPIJb`>me`?gWPGoo`?g_P?_O@?W?0?W70:4<0<YI@<080<000<H``<Q108Q
90HYA@><D@?Nn`_oo`=[K@;>N@?Nf`?og`?oo`?g_P?_O@:U50=220<8H@H000<aQP:D/P?W70Koo`?o
g`>mm`9Jb`<@XP<080<000<080Hia`:Ll`?W?0?g_P?oo`?og`?gWP;_O@?W?0><L@<aQP<Q90<@XPD0
00<8@@<@PPIJb`:me`?gWPKoo`?g_P?_O@?W?0;W70>4<0<YI@<080<000<H``8Q10<Q90HYA@><D@?N
n`_oo`9[K@?>N@?Nf`?og`?oo`?g_P;_O@>U50=220<8H@H0008aQP>D/P?W70Koo`?og`:mm`=Jb`<@
XP<080<000<080Dia`>Ll`?W?0?g_P?oo`?og`;gWP?_O@?W?0><L@<aQP<Q908@XPH000<8@@<@PPEJ
b`>me`?gWPKoo`?g_P;_O@?W?0?W70>4<0<YI@<0808000<H``<Q10<Q90HYA@><D@;Nn`_oo`=[K@?>
N@?Nf`?og`;oo`?g_P?_O@>U50=220<8H@D000<aQP>D/P?W70Koo`;og`>mm`=Jb`<@XP<080<00080
80Hia`>Ll`?W?0?g_P;oo`?og`?gWP?_O@?W?0><L@8aQP<Q90<@XPH000<8@@8@PPIJb`>me`?gWPKo
o`;g_P?_O@?W?0?W70>4<0<YI@8080<000<H``<Q10<Q90DYA@><D@?Nna_oo`005ooo0f]]0lii0]kK
0ooO0ooo0oNn0nmm0jDD0T880`QQ1P000c660iBb0nLL1Ooo0ooO0kgg0e[;0a2R0P0P0`000`0P1SW7
0icc0^Ll0oNn0ooo0ooO0oNN0nmm0^Ll0haa0c660b4T0a2R1@000`Q10a221U[;0kgG0oNN1Ooo0oNn
0nmm0nLl0nLL0X@`0bUU0`0P0`000aS30b440R4T1RU50haA0mkk2ooo0f]]0/ii0mkK0ooO0ooo0oNn
0nmm0ZDD0d880`QQ1P000c660YBb0nLL1_oo0ooO0kgg0U[;0a2R0`0P0`000`0P1SW70Ycc0nLl0oNn
0ooo0ooO0oNN0^mm0nLl0haa0c660b4T0a2R1@000`Q10a221U[;0[gG0oNN1_oo0oNn0nmm0nLl0^LL
0h@`0bUU0`0P0`000aS30R440b4T1RU50haA0mkk2ooo0V]]0lii0mkK0ooO0ooo0oNn0^mm0jDD0d88
0`QQ1P000S660iBb0nLL1_oo0ooO0[gg0e[;0a2R0`0P0`000`0P1CW70icc0nLl0oNn0ooo0ooO0_NN
0nmm0nLl0haa0c660b4T0Q2R1P000`Q10a221E[;0kgG0oNN1_oo0oNn0^mm0nLl0nLL0h@`0bUU0`0P
0P000aS30b440b4T1RU50haA0]kk2ooo0f]]0lii0mkK0ooO0_oo0oNn0nmm0jDD0d880`QQ1@000c66
0iBb0nLL1_oo0_oO0kgg0e[;0a2R0`0P0`000P0P1SW70icc0nLl0oNn0_oo0ooO0oNN0nmm0nLl0haa
0S660b4T0a2R1P000`Q10Q221U[;0kgG0oNN1_oo0_Nn0nmm0nLl0nLL0h@`0bUU0P0P0`000aS30b44
0b4T1BU50haA0mkk6ooo000Gool3Jfd3cWT2g]/3oml3ool3mkh3kgd3YA@2@PP326460003<HH3U;83
ia`5ool3oml3_OL3F//34:82020300030206>LL3W?<2ic`3mkh3ool3oml3mih3kgd2ic`3S743<HH3
8B@34:85000324434886F//3_ML3mih5ool3mkh3kgd3ic`3ia`2Q303:FD3020300036<<38@@28B@6
:DD3S543g_/;ool3Jfd2cWT3g]/3oml3ool3mkh3kgd2YA@3@PP326460003<HH2U;83ia`6ool3oml3
_OL2F//34:83020300030206>LL2W?<3ic`3mkh3ool3oml3mih2kgd3ic`3S743<HH38B@34:850003
24434886F//2_ML3mih6ool3mkh3kgd3ic`2ia`3Q303:FD3020300036<<28@@38B@6:DD3S543g_/;
ool2Jfd3cWT3g]/3oml3ool3mkh2kgd3YA@3@PP326460002<HH3U;83ia`6ool3oml2_OL3F//34:83
020300030205>LL3W?<3ic`3mkh3ool3oml2mih3kgd3ic`3S743<HH38B@24:86000324434885F//3
_ML3mih6ool3mkh2kgd3ic`3ia`3Q303:FD3020200036<<38@@38B@6:DD3S542g_/;ool3Jfd3cWT3
g]/3oml2ool3mkh3kgd3YA@3@PP326450003<HH3U;83ia`6ool2oml3_OL3F//34:83020300020206
>LL3W?<3ic`3mkh2ool3oml3mih3kgd3ic`3S742<HH38B@34:86000324424886F//3_ML3mih6ool2
mkh3kgd3ic`3ia`3Q303:FD2020300036<<38@@38B@5:DD3S543g_/Kool001Ooo`=[K@?>N@;Nf`?o
g`?oo`?g_P?_O@>U509220<8H@H000<aQP>D/P?W70Goo`?og`>mm`=Jb`<@XP8080<000<080Hia`>L
l`;W?0?g_P?oo`?og`?gWP?_O@;W?0><L@<aQP<Q90<@XPD000<8@@<@PPIJb`>me`?gWPGoo`?g_P?_
O@?W?0?W70:4<0<YI@<080<000<H``<Q108Q90HYA@><D@?Nn`_oo`=[K@;>N@?Nf`?og`?oo`?g_P?_
O@:U50=220<8H@H000<aQP:D/P?W70Koo`?og`>mm`9Jb`<@XP<080<000<080Hia`:Ll`?W?0?g_P?o
o`?og`?gWP;_O@?W?0><L@<aQP<Q90<@XPD000<8@@<@PPIJb`:me`?gWPKoo`?g_P?_O@?W?0;W70>4
<0<YI@<080<000<H``8Q10<Q90HYA@><D@?Nn`_oo`9[K@?>N@?Nf`?og`?oo`?g_P;_O@>U50=220<8
H@H0008aQP>D/P?W70Koo`?og`:mm`=Jb`<@XP<080<000<080Dia`>Ll`?W?0?g_P?oo`?og`;gWP?_
O@?W?0><L@<aQP<Q908@XPH000<8@@<@PPEJb`>me`?gWPKoo`?g_P;_O@?W?0?W70>4<0<YI@<08080
00<H``<Q10<Q90HYA@><D@;Nn`_oo`=[K@?>N@?Nf`?og`;oo`?g_P?_O@>U50=220<8H@D000<aQP>D
/P?W70Koo`;og`>mm`=Jb`<@XP<080<0008080Hia`>Ll`?W?0?g_P;oo`?og`?gWP?_O@?W?0><L@8a
QP<Q90<@XPH000<8@@8@PPIJb`>me`?gWPKoo`;g_P?_O@?W?0?W70>4<0<YI@8080<000<H``<Q10<Q
90DYA@><D@?Nna_oo`005ooo0f]]0lii0]kK0ooO0ooo0oNn0nmm0jDD0T880`QQ1P000c660iBb0nLL
1Ooo0ooO0kgg0e[;0a2R0P0P0`000`0P1SW70icc0^Ll0oNn0ooo0ooO0oNN0nmm0^Ll0haa0c660b4T
0a2R1@000`Q10a221U[;0kgG0oNN1Ooo0oNn0nmm0nLl0nLL0X@`0bUU0`0P0`000aS30b440R4T1RU5
0haA0mkk2ooo0f]]0/ii0mkK0ooO0ooo0oNn0nmm0ZDD0d880`QQ1P000c660YBb0nLL1_oo0ooO0kgg
0U[;0a2R0`0P0`000`0P1SW70Ycc0nLl0oNn0ooo0ooO0oNN0^mm0nLl0haa0c660b4T0a2R1@000`Q1
0a221U[;0[gG0oNN1_oo0oNn0nmm0nLl0^LL0h@`0bUU0`0P0`000aS30R440b4T1RU50haA0mkk2ooo
0V]]0lii0mkK0ooO0ooo0oNn0^mm0jDD0d880`QQ1P000S660iBb0nLL1_oo0ooO0[gg0e[;0a2R0`0P
0`000`0P1CW70icc0nLl0oNn0ooo0ooO0_NN0nmm0nLl0haa0c660b4T0Q2R1P000`Q10a221E[;0kgG
0oNN1_oo0oNn0^mm0nLl0nLL0h@`0bUU0`0P0P000aS30b440b4T1RU50haA0]kk2ooo0f]]0lii0mkK
0ooO0_oo0oNn0nmm0jDD0d880`QQ1@000c660iBb0nLL1_oo0_oO0kgg0e[;0a2R0`0P0`000P0P1SW7
0icc0nLl0oNn0_oo0ooO0oNN0nmm0nLl0haa0S660b4T0a2R1P000`Q10Q221U[;0kgG0oNN1_oo0_Nn
0nmm0nLl0nLL0h@`0bUU0P0P0`000aS30b440b4T1BU50haA0mkk6ooo000Gool3Jfd3cWT2g]/3oml3
ool3mkh3kgd3YA@2@PP326460003<HH3U;83ia`5ool3oml3_OL3F//34:82020300030206>LL3W?<2
ic`3mkh3ool3oml3mih3kgd2ic`3S743<HH38B@34:85000324434886F//3_ML3mih5ool3mkh3kgd3
ic`3ia`2Q303:FD3020300036<<38@@28B@6:DD3S543g_/;ool3Jfd2cWT3g]/3oml3ool3mkh3kgd2
YA@3@PP326460003<HH2U;83ia`6ool3oml3_OL2F//34:83020300030206>LL2W?<3ic`3mkh3ool3
oml3mih2kgd3ic`3S743<HH38B@34:85000324434886F//2_ML3mih6ool3mkh3kgd3ic`2ia`3Q303
:FD3020300036<<28@@38B@6:DD3S543g_/;ool2Jfd3cWT3g]/3oml3ool3mkh2kgd3YA@3@PP32646
0002<HH3U;83ia`6ool3oml2_OL3F//34:83020300030205>LL3W?<3ic`3mkh3ool3oml2mih3kgd3
ic`3S743<HH38B@24:86000324434885F//3_ML3mih6ool3mkh2kgd3ic`3ia`3Q303:FD302020003
6<<38@@38B@6:DD3S542g_/;ool3Jfd3cWT3g]/3oml2ool3mkh3kgd3YA@3@PP326450003<HH3U;83
ia`6ool2oml3_OL3F//34:83020300020206>LL3W?<3ic`3mkh2ool3oml3mih3kgd3ic`3S742<HH3
8B@34:86000324424886F//3_ML3mih6ool2mkh3kgd3ic`3ia`3Q303:FD2020300036<<38@@38B@5
:DD3S543g_/Kool001[oo`?Nn`;Nf`=kk`<Q90<080<000<08088H@=BZP>me`?660?g_PKoo`;g_P?_
O@?W?0>DTP<aYP<8@@8000<@XP<Hh`<Q10<Q90>4<0:440?Nf`?og`?oo`?og`?gWP:]E@>]M@>eUP=:
J@<@PP<0008080<8H@<@XP<Hh`=cSP?>N@?Nn`Goo`?Nn`?Nf`=kk`>4408YA@<080<000<080<ii`FU
50>U=0>]E@?_GA7oo`;Nn`?Nf`=kk`<Q90<080<0008080<8H@=BZP>me`?660?g_PGoo`?g_P?_O@?W
?0>DTP8aYP<8@@<000<@XP<Hh`<Q10<Q90:4<0>440?Nf`?og`?oo`?og`;gWP>]E@>]M@>eUP=:J@<@
PP8000<080<8H@<@XP<Hh`=cSP;>N@?Nn`Koo`?Nn`?Nf`=kk`:440<YA@<080<000<080<ii`FU50>U
=0>]E@?_GA3oo`?Nn`?Nf`=kk`<Q90<0808000<080<8H@=BZP>me`?660;g_PKoo`?g_P?_O@?W?0:D
TP<aYP<8@@<000<@XP<Hh`8Q10<Q90>4<0>440?Nf`?og`?oo`;og`?gWP>]E@>]M@>eUP=:J@8@PP<0
00<080<8H@<@XP<Hh`9cSP?>N@?Nn`Koo`?Nn`;Nf`=kk`>440<YA@<080<0008080<ii`JU50>U=0>]
E@?_GA3oo`?Nn`?Nf`=kk`8Q90<080<000<080<8H@=BZP:me`?660?g_PKoo`?g_P?_O@;W?0>DTP<a
YP<8@@<000<@XP8Hh`<Q10<Q90>4<0>440?Nf`;og`?oo`?og`?gWP>]E@>]M@:eUP=:J@<@PP<000<0
80<8H@8@XP<Hh`=cSP?>N@?Nn`Koo`;Nn`?Nf`=kk`>440<YA@<0808000<080<ii`JU50>U=0:]E@?_
GAkoo`006_oo0mkk0]kK0g__0b4T0`0P0`000`0P0PQQ0e:Z0kgG0lHH0oNn1_oo0_Nn0nmm0nLl0iBB
0c6V0`Q10P000a2R0aSS0b440b4T0h@`0X@@0mkK0ooO0ooo0ooO0oNN0ZeE0jee0kFF0dYY0a220`00
0P0P0`QQ0a2R0aSS0g>>0lii0mkk1Ooo0mkk0mkK0g__0h@@0RU50`0P0`000`0P0cWW1JDD0jDd0jeE
0nmM4Ooo0]kk0mkK0g__0b4T0`0P0`000P0P0`QQ0e:Z0kgG0lHH0oNn1Ooo0oNn0nmm0nLl0iBB0S6V
0`Q10`000a2R0aSS0b440b4T0X@`0h@@0mkK0ooO0ooo0ooO0_NN0jeE0jee0kFF0dYY0a220P000`0P
0`QQ0a2R0aSS0g>>0/ii0mkk1_oo0mkk0mkK0g__0X@@0bU50`0P0`000`0P0cWW1JDD0jDd0jeE0nmM
4?oo0mkk0mkK0g__0b4T0`0P0P000`0P0`QQ0e:Z0kgG0lHH0_Nn1_oo0oNn0nmm0nLl0YBB0c6V0`Q1
0`000a2R0aSS0R440b4T0h@`0h@@0mkK0ooO0ooo0_oO0oNN0jeE0jee0kFF0dYY0Q220`000`0P0`QQ
0a2R0aSS0W>>0lii0mkk1_oo0mkk0]kK0g__0h@@0bU50`0P0`000P0P0cWW1ZDD0jDd0jeE0nmM4?oo
0mkk0mkK0g__0R4T0`0P0`000`0P0`QQ0e:Z0[gG0lHH0oNn1_oo0oNn0nmm0^Ll0iBB0c6V0`Q10`00
0a2R0QSS0b440b4T0h@`0h@@0mkK0_oO0ooo0ooO0oNN0jeE0jee0[FF0dYY0a220`000`0P0`QQ0Q2R
0aSS0g>>0lii0mkk1_oo0]kk0mkK0g__0h@@0bU50`0P0P000`0P0cWW1ZDD0jDd0ZeE0nmM7_oo000J
ool3g_/2g]/3Nnl38B@30203000302022643DZX3_ML3aQP3mkh6ool2mkh3kgd3ic`3U983<JH32442
00034:836><38@@38B@3Q302Q103g]/3oml3ool3oml3mih2[ED3[GD3]IH3BVT34883000202032643
4:836><3Lhh3cWT3g_/5ool3g_/3g]/3Nnl3Q102:DD3020300030203>NL5YA@3YC@3[ED3kedAool2
g_/3g]/3Nnl38B@30203000202032643DZX3_ML3aQP3mkh5ool3mkh3kgd3ic`3U982<JH324430003
4:836><38@@38B@2Q303Q103g]/3oml3ool3oml2mih3[ED3[GD3]IH3BVT348820003020326434:83
6><3Lhh2cWT3g_/6ool3g_/3g]/3Nnl2Q103:DD3020300030203>NL5YA@3YC@3[ED3ked@ool3g_/3
g]/3Nnl38B@30202000302032643DZX3_ML3aQP2mkh6ool3mkh3kgd3ic`2U983<JH3244300034:83
6><28@@38B@3Q303Q103g]/3oml3ool2oml3mih3[ED3[GD3]IH3BVT248830003020326434:836><2
Lhh3cWT3g_/6ool3g_/2g]/3Nnl3Q103:DD3020300020203>NL6YA@3YC@3[ED3ked@ool3g_/3g]/3
Nnl28B@30203000302032643DZX2_ML3aQP3mkh6ool3mkh3kgd2ic`3U983<JH3244300034:826><3
8@@38B@3Q303Q103g]/2oml3ool3oml3mih3[ED3[GD2]IH3BVT348830003020326424:836><3Lhh3
cWT3g_/6ool2g_/3g]/3Nnl3Q103:DD3020200030203>NL6YA@3YC@2[ED3kedNool001[oo`?Nn`;N
f`=kk`<Q90<080<000<08088H@=BZP>me`?660?g_PKoo`;g_P?_O@?W?0>DTP<aYP<8@@8000<@XP<H
h`<Q10<Q90>4<0:440?Nf`?og`?oo`?og`?gWP:]E@>]M@>eUP=:J@<@PP<0008080<8H@<@XP<Hh`=c
SP?>N@?Nn`Goo`?Nn`?Nf`=kk`>4408YA@<080<000<080<ii`FU50>U=0>]E@?_GA7oo`;Nn`?Nf`=k
k`<Q90<080<0008080<8H@=BZP>me`?660?g_PGoo`?g_P?_O@?W?0>DTP8aYP<8@@<000<@XP<Hh`<Q
10<Q90:4<0>440?Nf`?og`?oo`?og`;gWP>]E@>]M@>eUP=:J@<@PP8000<080<8H@<@XP<Hh`=cSP;>
N@?Nn`Koo`?Nn`?Nf`=kk`:440<YA@<080<000<080<ii`FU50>U=0>]E@?_GA3oo`?Nn`?Nf`=kk`<Q
90<0808000<080<8H@=BZP>me`?660;g_PKoo`?g_P?_O@?W?0:DTP<aYP<8@@<000<@XP<Hh`8Q10<Q
90>4<0>440?Nf`?og`?oo`;og`?gWP>]E@>]M@>eUP=:J@8@PP<000<080<8H@<@XP<Hh`9cSP?>N@?N
n`Koo`?Nn`;Nf`=kk`>440<YA@<080<0008080<ii`JU50>U=0>]E@?_GA3oo`?Nn`?Nf`=kk`8Q90<0
80<000<080<8H@=BZP:me`?660?g_PKoo`?g_P?_O@;W?0>DTP<aYP<8@@<000<@XP8Hh`<Q10<Q90>4
<0>440?Nf`;og`?oo`?og`?gWP>]E@>]M@:eUP=:J@<@PP<000<080<8H@8@XP<Hh`=cSP?>N@?Nn`Ko
o`;Nn`?Nf`=kk`>440<YA@<0808000<080<ii`JU50>U=0:]E@?_GAkoo`006_oo0mkk0]kK0g__0b4T
0`0P0`000`0P0PQQ0e:Z0kgG0lHH0oNn1_oo0_Nn0nmm0nLl0iBB0c6V0`Q10P000a2R0aSS0b440b4T
0h@`0X@@0mkK0ooO0ooo0ooO0oNN0ZeE0jee0kFF0dYY0a220`000P0P0`QQ0a2R0aSS0g>>0lii0mkk
1Ooo0mkk0mkK0g__0h@@0RU50`0P0`000`0P0cWW1JDD0jDd0jeE0nmM4Ooo0]kk0mkK0g__0b4T0`0P
0`000P0P0`QQ0e:Z0kgG0lHH0oNn1Ooo0oNn0nmm0nLl0iBB0S6V0`Q10`000a2R0aSS0b440b4T0X@`
0h@@0mkK0ooO0ooo0ooO0_NN0jeE0jee0kFF0dYY0a220P000`0P0`QQ0a2R0aSS0g>>0/ii0mkk1_oo
0mkk0mkK0g__0X@@0bU50`0P0`000`0P0cWW1JDD0jDd0jeE0nmM4?oo0mkk0mkK0g__0b4T0`0P0P00
0`0P0`QQ0e:Z0kgG0lHH0_Nn1_oo0oNn0nmm0nLl0YBB0c6V0`Q10`000a2R0aSS0R440b4T0h@`0h@@
0mkK0ooO0ooo0_oO0oNN0jeE0jee0kFF0dYY0Q220`000`0P0`QQ0a2R0aSS0W>>0lii0mkk1_oo0mkk
0]kK0g__0h@@0bU50`0P0`000P0P0cWW1ZDD0jDd0jeE0nmM4?oo0mkk0mkK0g__0R4T0`0P0`000`0P
0`QQ0e:Z0[gG0lHH0oNn1_oo0oNn0nmm0^Ll0iBB0c6V0`Q10`000a2R0QSS0b440b4T0h@`0h@@0mkK
0_oO0ooo0ooO0oNN0jeE0jee0[FF0dYY0a220`000`0P0`QQ0Q2R0aSS0g>>0lii0mkk1_oo0]kk0mkK
0g__0h@@0bU50`0P0P000`0P0cWW1ZDD0jDd0ZeE0nmM7_oo000Jool3g_/2g]/3Nnl38B@302030003
02022643DZX3_ML3aQP3mkh6ool2mkh3kgd3ic`3U983<JH3244200034:836><38@@38B@3Q302Q103
g]/3oml3ool3oml3mih2[ED3[GD3]IH3BVT348830002020326434:836><3Lhh3cWT3g_/5ool3g_/3
g]/3Nnl3Q102:DD3020300030203>NL5YA@3YC@3[ED3kedAool2g_/3g]/3Nnl38B@3020300020203
2643DZX3_ML3aQP3mkh5ool3mkh3kgd3ic`3U982<JH3244300034:836><38@@38B@2Q303Q103g]/3
oml3ool3oml2mih3[ED3[GD3]IH3BVT348820003020326434:836><3Lhh2cWT3g_/6ool3g_/3g]/3
Nnl2Q103:DD3020300030203>NL5YA@3YC@3[ED3ked@ool3g_/3g]/3Nnl38B@30202000302032643
DZX3_ML3aQP2mkh6ool3mkh3kgd3ic`2U983<JH3244300034:836><28@@38B@3Q303Q103g]/3oml3
ool2oml3mih3[ED3[GD3]IH3BVT248830003020326434:836><2Lhh3cWT3g_/6ool3g_/2g]/3Nnl3
Q103:DD3020300020203>NL6YA@3YC@3[ED3ked@ool3g_/3g]/3Nnl28B@30203000302032643DZX2
_ML3aQP3mkh6ool3mkh3kgd2ic`3U983<JH3244300034:826><38@@38B@3Q303Q103g]/2oml3ool3
oml3mih3[ED3[GD2]IH3BVT348830003020326424:836><3Lhh3cWT3g_/6ool2g_/3g]/3Nnl3Q103
:DD3020200030203>NL6YA@3YC@2[ED3kedNool001[oo`?Nn`;Nf`=kk`<Q90<080<000<08088H@=B
ZP>me`?660?g_PKoo`;g_P?_O@?W?0>DTP<aYP<8@@8000<@XP<Hh`<Q10<Q90>4<0:440?Nf`?og`?o
o`?og`?gWP:]E@>]M@>eUP=:J@<@PP<0008080<8H@<@XP<Hh`=cSP?>N@?Nn`Goo`?Nn`?Nf`=kk`>4
408YA@<080<000<080<ii`FU50>U=0>]E@?_GA7oo`;Nn`?Nf`=kk`<Q90<080<0008080<8H@=BZP>m
e`?660?g_PGoo`?g_P?_O@?W?0>DTP8aYP<8@@<000<@XP<Hh`<Q10<Q90:4<0>440?Nf`?og`?oo`?o
g`;gWP>]E@>]M@>eUP=:J@<@PP8000<080<8H@<@XP<Hh`=cSP;>N@?Nn`Koo`?Nn`?Nf`=kk`:440<Y
A@<080<000<080<ii`FU50>U=0>]E@?_GA3oo`?Nn`?Nf`=kk`<Q90<0808000<080<8H@=BZP>me`?6
60;g_PKoo`?g_P?_O@?W?0:DTP<aYP<8@@<000<@XP<Hh`8Q10<Q90>4<0>440?Nf`?og`?oo`;og`?g
WP>]E@>]M@>eUP=:J@8@PP<000<080<8H@<@XP<Hh`9cSP?>N@?Nn`Koo`?Nn`;Nf`=kk`>440<YA@<0
80<0008080<ii`JU50>U=0>]E@?_GA3oo`?Nn`?Nf`=kk`8Q90<080<000<080<8H@=BZP:me`?660?g
_PKoo`?g_P?_O@;W?0>DTP<aYP<8@@<000<@XP8Hh`<Q10<Q90>4<0>440?Nf`;og`?oo`?og`?gWP>]
E@>]M@:eUP=:J@<@PP<000<080<8H@8@XP<Hh`=cSP?>N@?Nn`Koo`;Nn`?Nf`=kk`>440<YA@<08080
00<080<ii`JU50>U=0:]E@?_GAkoo`006_oo0mkk0]kK0g__0b4T0`0P0`000`0P0PQQ0e:Z0kgG0lHH
0oNn1_oo0_Nn0nmm0nLl0iBB0c6V0`Q10P000a2R0aSS0b440b4T0h@`0X@@0mkK0ooO0ooo0ooO0oNN
0ZeE0jee0kFF0dYY0a220`000P0P0`QQ0a2R0aSS0g>>0lii0mkk1Ooo0mkk0mkK0g__0h@@0RU50`0P
0`000`0P0cWW1JDD0jDd0jeE0nmM4Ooo0]kk0mkK0g__0b4T0`0P0`000P0P0`QQ0e:Z0kgG0lHH0oNn
1Ooo0oNn0nmm0nLl0iBB0S6V0`Q10`000a2R0aSS0b440b4T0X@`0h@@0mkK0ooO0ooo0ooO0_NN0jeE
0jee0kFF0dYY0a220P000`0P0`QQ0a2R0aSS0g>>0/ii0mkk1_oo0mkk0mkK0g__0X@@0bU50`0P0`00
0`0P0cWW1JDD0jDd0jeE0nmM4?oo0mkk0mkK0g__0b4T0`0P0P000`0P0`QQ0e:Z0kgG0lHH0_Nn1_oo
0oNn0nmm0nLl0YBB0c6V0`Q10`000a2R0aSS0R440b4T0h@`0h@@0mkK0ooO0ooo0_oO0oNN0jeE0jee
0kFF0dYY0Q220`000`0P0`QQ0a2R0aSS0W>>0lii0mkk1_oo0mkk0]kK0g__0h@@0bU50`0P0`000P0P
0cWW1ZDD0jDd0jeE0nmM4?oo0mkk0mkK0g__0R4T0`0P0`000`0P0`QQ0e:Z0[gG0lHH0oNn1_oo0oNn
0nmm0^Ll0iBB0c6V0`Q10`000a2R0QSS0b440b4T0h@`0h@@0mkK0_oO0ooo0ooO0oNN0jeE0jee0[FF
0dYY0a220`000`0P0`QQ0Q2R0aSS0g>>0lii0mkk1_oo0]kk0mkK0g__0h@@0bU50`0P0P000`0P0cWW
1ZDD0jDd0ZeE0nmM7_oo000Jool3g_/2g]/3Nnl38B@30203000302022643DZX3_ML3aQP3mkh6ool2
mkh3kgd3ic`3U983<JH3244200034:836><38@@38B@3Q302Q103g]/3oml3ool3oml3mih2[ED3[GD3
]IH3BVT348830002020326434:836><3Lhh3cWT3g_/5ool3g_/3g]/3Nnl3Q102:DD3020300030203
>NL5YA@3YC@3[ED3kedAool2g_/3g]/3Nnl38B@30203000202032643DZX3_ML3aQP3mkh5ool3mkh3
kgd3ic`3U982<JH3244300034:836><38@@38B@2Q303Q103g]/3oml3ool3oml2mih3[ED3[GD3]IH3
BVT348820003020326434:836><3Lhh2cWT3g_/6ool3g_/3g]/3Nnl2Q103:DD3020300030203>NL5
YA@3YC@3[ED3ked@ool3g_/3g]/3Nnl38B@30202000302032643DZX3_ML3aQP2mkh6ool3mkh3kgd3
ic`2U983<JH3244300034:836><28@@38B@3Q303Q103g]/3oml3ool2oml3mih3[ED3[GD3]IH3BVT2
48830003020326434:836><2Lhh3cWT3g_/6ool3g_/2g]/3Nnl3Q103:DD3020300020203>NL6YA@3
YC@3[ED3ked@ool3g_/3g]/3Nnl28B@30203000302032643DZX2_ML3aQP3mkh6ool3mkh3kgd2ic`3
U983<JH3244300034:826><38@@38B@3Q303Q103g]/2oml3ool3oml3mih3[ED3[GD2]IH3BVT34883
0003020326424:836><3Lhh3cWT3g_/6ool2g_/3g]/3Nnl3Q103:DD3020200030203>NL6YA@3YC@2
[ED3kedNool001[oo`?Nn`;Nf`=kk`<Q90<080<000<08088H@=BZP>me`?660?g_PKoo`;g_P?_O@?W
?0>DTP<aYP<8@@8000<@XP<Hh`<Q10<Q90>4<0:440?Nf`?og`?oo`?og`?gWP:]E@>]M@>eUP=:J@<@
PP<0008080<8H@<@XP<Hh`=cSP?>N@?Nn`Goo`?Nn`?Nf`=kk`>4408YA@<080<000<080<ii`FU50>U
=0>]E@?_GA7oo`;Nn`?Nf`=kk`<Q90<080<0008080<8H@=BZP>me`?660?g_PGoo`?g_P?_O@?W?0>D
TP8aYP<8@@<000<@XP<Hh`<Q10<Q90:4<0>440?Nf`?og`?oo`?og`;gWP>]E@>]M@>eUP=:J@<@PP80
00<080<8H@<@XP<Hh`=cSP;>N@?Nn`Koo`?Nn`?Nf`=kk`:440<YA@<080<000<080<ii`FU50>U=0>]
E@?_GA3oo`?Nn`?Nf`=kk`<Q90<0808000<080<8H@=BZP>me`?660;g_PKoo`?g_P?_O@?W?0:DTP<a
YP<8@@<000<@XP<Hh`8Q10<Q90>4<0>440?Nf`?og`?oo`;og`?gWP>]E@>]M@>eUP=:J@8@PP<000<0
80<8H@<@XP<Hh`9cSP?>N@?Nn`Koo`?Nn`;Nf`=kk`>440<YA@<080<0008080<ii`JU50>U=0>]E@?_
GA3oo`?Nn`?Nf`=kk`8Q90<080<000<080<8H@=BZP:me`?660?g_PKoo`?g_P?_O@;W?0>DTP<aYP<8
@@<000<@XP8Hh`<Q10<Q90>4<0>440?Nf`;og`?oo`?og`?gWP>]E@>]M@:eUP=:J@<@PP<000<080<8
H@8@XP<Hh`=cSP?>N@?Nn`Koo`;Nn`?Nf`=kk`>440<YA@<0808000<080<ii`JU50>U=0:]E@?_GAko
o`006_oo0mkk0]kK0g__0b4T0`0P0`000`0P0PQQ0e:Z0kgG0lHH0oNn1_oo0_Nn0nmm0nLl0iBB0c6V
0`Q10P000a2R0aSS0b440b4T0h@`0X@@0mkK0ooO0ooo0ooO0oNN0ZeE0jee0kFF0dYY0a220`000P0P
0`QQ0a2R0aSS0g>>0lii0mkk1Ooo0mkk0mkK0g__0h@@0RU50`0P0`000`0P0cWW1JDD0jDd0jeE0nmM
4Ooo0]kk0mkK0g__0b4T0`0P0`000P0P0`QQ0e:Z0kgG0lHH0oNn1Ooo0oNn0nmm0nLl0iBB0S6V0`Q1
0`000a2R0aSS0b440b4T0X@`0h@@0mkK0ooO0ooo0ooO0_NN0jeE0jee0kFF0dYY0a220P000`0P0`QQ
0a2R0aSS0g>>0/ii0mkk1_oo0mkk0mkK0g__0X@@0bU50`0P0`000`0P0cWW1JDD0jDd0jeE0nmM4?oo
0mkk0mkK0g__0b4T0`0P0P000`0P0`QQ0e:Z0kgG0lHH0_Nn1_oo0oNn0nmm0nLl0YBB0c6V0`Q10`00
0a2R0aSS0R440b4T0h@`0h@@0mkK0ooO0ooo0_oO0oNN0jeE0jee0kFF0dYY0Q220`000`0P0`QQ0a2R
0aSS0W>>0lii0mkk1_oo0mkk0]kK0g__0h@@0bU50`0P0`000P0P0cWW1ZDD0jDd0jeE0nmM4?oo0mkk
0mkK0g__0R4T0`0P0`000`0P0`QQ0e:Z0[gG0lHH0oNn1_oo0oNn0nmm0^Ll0iBB0c6V0`Q10`000a2R
0QSS0b440b4T0h@`0h@@0mkK0_oO0ooo0ooO0oNN0jeE0jee0[FF0dYY0a220`000`0P0`QQ0Q2R0aSS
0g>>0lii0mkk1_oo0]kk0mkK0g__0h@@0bU50`0P0P000`0P0cWW1ZDD0jDd0ZeE0nmM7_oo000Gool3
mkh3_ML2DZX34886000324434882F^/3F//3_OL3mih6ool3mkh2]IH6]KH3_ML3DZX3488200032443
48836<<3Jfd3Jdd2cUT3e[X3oml3ool3oml5aQP6F^/34:86000224434883F//3_OL3mih6ool2mkh3
kgd3ic`3ia`3g_/3g]/2e[X6eYX3cWT8Jfd36><6000302032648ool3mkh2_ML3DZX3488600032442
4883F^/3F//3_OL3mih5ool3mkh3]IH6]KH3_ML2DZX348830003244348836<<3Jfd2Jdd3cUT3e[X3
oml3ool3oml5aQP6F^/34:85000324434883F//3_OL3mih5ool3mkh3kgd3ic`3ia`3g_/2g]/3e[X6
eYX3cWT8Jfd36><6000302022649ool2mkh3_ML3DZX34886000224434883F^/3F//3_OL3mih5ool3
mkh3]IH6]KH2_ML3DZX348830003244348826<<3Jfd3Jdd3cUT3e[X3oml3ool2oml6aQP6F^/34:85
000324434883F//3_OL2mih6ool3mkh3kgd3ic`2ia`3g_/3g]/3e[X6eYX2cWT9Jfd36><600020203
2648ool3mkh3_ML3DZX34885000324434883F^/3F//2_OL3mih6ool3mkh3]IH5]KH3_ML3DZX34883
0003244248836<<3Jfd3Jdd3cUT3e[X2oml3ool3oml6aQP5F^/34:86000324434882F//3_OL3mih6
ool3mkh3kgd2ic`3ia`3g_/3g]/3e[X5eYX3cWT9Jfd36><500030203264Hool001Ooo`?g_P>me`9B
ZP<@PPH000<8@@<@PP9Jj`=Jb`>mm`?gWPKoo`?g_P:eUPJe]P>me`=BZP<@PP8000<8@@<@PP<H``=[
K@=[C@;>F@?F^P?og`?oo`?og`G660IJj`<@XPH00088@@<@PP=Jb`>mm`?gWPKoo`;g_P?_O@?W?0?W
70?Nn`?Nf`;F^PKFVP?>N@Q[K@<Hh`H000<080<8H@Soo`?g_P:me`=BZP<@PPH000<8@@8@PP=Jj`=J
b`>mm`?gWPGoo`?g_P>eUPJe]P>me`9BZP<@PP<000<8@@<@PP<H``=[K@9[C@?>F@?F^P?og`?oo`?o
g`G660IJj`<@XPD000<8@@<@PP=Jb`>mm`?gWPGoo`?g_P?_O@?W?0?W70?Nn`;Nf`?F^PKFVP?>N@Q[
K@<Hh`H000<08088H@Woo`;g_P>me`=BZP<@PPH00088@@<@PP=Jj`=Jb`>mm`?gWPGoo`?g_P>eUPJe
]P:me`=BZP<@PP<000<8@@<@PP8H``=[K@=[C@?>F@?F^P?og`?oo`;og`K660IJj`<@XPD000<8@@<@
PP=Jb`>mm`;gWPKoo`?g_P?_O@?W?0;W70?Nn`?Nf`?F^PKFVP;>N@U[K@<Hh`H0008080<8H@Soo`?g
_P>me`=BZP<@PPD000<8@@<@PP=Jj`=Jb`:mm`?gWPKoo`?g_P>eUPFe]P>me`=BZP<@PP<000<8@@8@
PP<H``=[K@=[C@?>F@?F^P;og`?oo`?og`K660EJj`<@XPH000<8@@<@PP9Jb`>mm`?gWPKoo`?g_P?_
O@;W?0?W70?Nn`?Nf`?F^PGFVP?>N@U[K@<Hh`D000<080<8HASoo`005ooo0oNn0kgG0U:Z0a221P00
0`Q10a220U[[0e[;0kgg0oNN1_oo0oNn0[FF1[Ff0kgG0e:Z0a220P000`Q10a220aS30f]]0f]=0/iI
0mJj0ooO0ooo0ooO1LHH1U[[0a2R1P000PQ10a220e[;0kgg0oNN1_oo0_Nn0nmm0nLl0nLL0mkk0mkK
0]Jj1]JJ0lii26]]0aSS1P000`0P0`QQ2?oo0oNn0[gG0e:Z0a221P000`Q10Q220e[[0e[;0kgg0oNN
1Ooo0oNn0kFF1[Ff0kgG0U:Z0a220`000`Q10a220aS30f]]0V]=0liI0mJj0ooO0ooo0ooO1LHH1U[[
0a2R1@000`Q10a220e[;0kgg0oNN1Ooo0oNn0nmm0nLl0nLL0mkk0]kK0mJj1]JJ0lii26]]0aSS1P00
0`0P0PQQ2Ooo0_Nn0kgG0e:Z0a221P000PQ10a220e[[0e[;0kgg0oNN1Ooo0oNn0kFF1[Ff0[gG0e:Z
0a220`000`Q10a220QS30f]]0f]=0liI0mJj0ooO0ooo0_oO1/HH1U[[0a2R1@000`Q10a220e[;0kgg
0_NN1_oo0oNn0nmm0nLl0^LL0mkk0mkK0mJj1]JJ0/ii2F]]0aSS1P000P0P0`QQ2?oo0oNn0kgG0e:Z
0a221@000`Q10a220e[[0e[;0[gg0oNN1_oo0oNn0kFF1KFf0kgG0e:Z0a220`000`Q10Q220aS30f]]
0f]=0liI0mJj0_oO0ooo0ooO1/HH1E[[0a2R1P000`Q10a220U[;0kgg0oNN1_oo0oNn0nmm0^Ll0nLL
0mkk0mkK0mJj1MJJ0lii2F]]0aSS1@000`0P0`QQ6?oo000Gool3mkh3_ML2DZX34886000324434882
F^/3F//3_OL3mih6ool3mkh2]IH6]KH3_ML3DZX348820003244348836<<3Jfd3Jdd2cUT3e[X3oml3
ool3oml5aQP6F^/34:86000224434883F//3_OL3mih6ool2mkh3kgd3ic`3ia`3g_/3g]/2e[X6eYX3
cWT8Jfd36><6000302032648ool3mkh2_ML3DZX34886000324424883F^/3F//3_OL3mih5ool3mkh3
]IH6]KH3_ML2DZX348830003244348836<<3Jfd2Jdd3cUT3e[X3oml3ool3oml5aQP6F^/34:850003
24434883F//3_OL3mih5ool3mkh3kgd3ic`3ia`3g_/2g]/3e[X6eYX3cWT8Jfd36><6000302022649
ool2mkh3_ML3DZX34886000224434883F^/3F//3_OL3mih5ool3mkh3]IH6]KH2_ML3DZX348830003
244348826<<3Jfd3Jdd3cUT3e[X3oml3ool2oml6aQP6F^/34:85000324434883F//3_OL2mih6ool3
mkh3kgd3ic`2ia`3g_/3g]/3e[X6eYX2cWT9Jfd36><6000202032648ool3mkh3_ML3DZX348850003
24434883F^/3F//2_OL3mih6ool3mkh3]IH5]KH3_ML3DZX348830003244248836<<3Jfd3Jdd3cUT3
e[X2oml3ool3oml6aQP5F^/34:86000324434882F//3_OL3mih6ool3mkh3kgd2ic`3ia`3g_/3g]/3
e[X5eYX3cWT9Jfd36><500030203264Hool001Ooo`?g_P>me`9BZP<@PPH000<8@@<@PP9Jj`=Jb`>m
m`?gWPKoo`?g_P:eUPJe]P>me`=BZP<@PP8000<8@@<@PP<H``=[K@=[C@;>F@?F^P?og`?oo`?og`G6
60IJj`<@XPH00088@@<@PP=Jb`>mm`?gWPKoo`;g_P?_O@?W?0?W70?Nn`?Nf`;F^PKFVP?>N@Q[K@<H
h`H000<080<8H@Soo`?g_P:me`=BZP<@PPH000<8@@8@PP=Jj`=Jb`>mm`?gWPGoo`?g_P>eUPJe]P>m
e`9BZP<@PP<000<8@@<@PP<H``=[K@9[C@?>F@?F^P?og`?oo`?og`G660IJj`<@XPD000<8@@<@PP=J
b`>mm`?gWPGoo`?g_P?_O@?W?0?W70?Nn`;Nf`?F^PKFVP?>N@Q[K@<Hh`H000<08088H@Woo`;g_P>m
e`=BZP<@PPH00088@@<@PP=Jj`=Jb`>mm`?gWPGoo`?g_P>eUPJe]P:me`=BZP<@PP<000<8@@<@PP8H
``=[K@=[C@?>F@?F^P?og`?oo`;og`K660IJj`<@XPD000<8@@<@PP=Jb`>mm`;gWPKoo`?g_P?_O@?W
?0;W70?Nn`?Nf`?F^PKFVP;>N@U[K@<Hh`H0008080<8H@Soo`?g_P>me`=BZP<@PPD000<8@@<@PP=J
j`=Jb`:mm`?gWPKoo`?g_P>eUPFe]P>me`=BZP<@PP<000<8@@8@PP<H``=[K@=[C@?>F@?F^P;og`?o
o`?og`K660EJj`<@XPH000<8@@<@PP9Jb`>mm`?gWPKoo`?g_P?_O@;W?0?W70?Nn`?Nf`?F^PGFVP?>
N@U[K@<Hh`D000<080<8HASoo`005ooo0oNn0kgG0U:Z0a221P000`Q10a220U[[0e[;0kgg0oNN1_oo
0oNn0[FF1[Ff0kgG0e:Z0a220P000`Q10a220aS30f]]0f]=0/iI0mJj0ooO0ooo0ooO1LHH1U[[0a2R
1P000PQ10a220e[;0kgg0oNN1_oo0_Nn0nmm0nLl0nLL0mkk0mkK0]Jj1]JJ0lii26]]0aSS1P000`0P
0`QQ2?oo0oNn0[gG0e:Z0a221P000`Q10Q220e[[0e[;0kgg0oNN1Ooo0oNn0kFF1[Ff0kgG0U:Z0a22
0`000`Q10a220aS30f]]0V]=0liI0mJj0ooO0ooo0ooO1LHH1U[[0a2R1@000`Q10a220e[;0kgg0oNN
1Ooo0oNn0nmm0nLl0nLL0mkk0]kK0mJj1]JJ0lii26]]0aSS1P000`0P0PQQ2Ooo0_Nn0kgG0e:Z0a22
1P000PQ10a220e[[0e[;0kgg0oNN1Ooo0oNn0kFF1[Ff0[gG0e:Z0a220`000`Q10a220QS30f]]0f]=
0liI0mJj0ooO0ooo0_oO1/HH1U[[0a2R1@000`Q10a220e[;0kgg0_NN1_oo0oNn0nmm0nLl0^LL0mkk
0mkK0mJj1]JJ0/ii2F]]0aSS1P000P0P0`QQ2?oo0oNn0kgG0e:Z0a221@000`Q10a220e[[0e[;0[gg
0oNN1_oo0oNn0kFF1KFf0kgG0e:Z0a220`000`Q10Q220aS30f]]0f]=0liI0mJj0_oO0ooo0ooO1/HH
1E[[0a2R1P000`Q10a220U[;0kgg0oNN1_oo0oNn0nmm0^Ll0nLL0mkk0mkK0mJj1MJJ0lii2F]]0aSS
1@000`0P0`QQ6?oo000Gool3mkh3_ML2DZX34886000324434882F^/3F//3_OL3mih6ool3mkh2]IH6
]KH3_ML3DZX348820003244348836<<3Jfd3Jdd2cUT3e[X3oml3ool3oml5aQP6F^/34:8600022443
4883F//3_OL3mih6ool2mkh3kgd3ic`3ia`3g_/3g]/2e[X6eYX3cWT8Jfd36><6000302032648ool3
mkh2_ML3DZX34886000324424883F^/3F//3_OL3mih5ool3mkh3]IH6]KH3_ML2DZX3488300032443
48836<<3Jfd2Jdd3cUT3e[X3oml3ool3oml5aQP6F^/34:85000324434883F//3_OL3mih5ool3mkh3
kgd3ic`3ia`3g_/2g]/3e[X6eYX3cWT8Jfd36><6000302022649ool2mkh3_ML3DZX3488600022443
4883F^/3F//3_OL3mih5ool3mkh3]IH6]KH2_ML3DZX348830003244348826<<3Jfd3Jdd3cUT3e[X3
oml3ool2oml6aQP6F^/34:85000324434883F//3_OL2mih6ool3mkh3kgd3ic`2ia`3g_/3g]/3e[X6
eYX2cWT9Jfd36><6000202032648ool3mkh3_ML3DZX34885000324434883F^/3F//2_OL3mih6ool3
mkh3]IH5]KH3_ML3DZX348830003244248836<<3Jfd3Jdd3cUT3e[X2oml3ool3oml6aQP5F^/34:86
000324434882F//3_OL3mih6ool3mkh3kgd2ic`3ia`3g_/3g]/3e[X5eYX3cWT9Jfd36><500030203
264Hool001Ooo`?g_P>me`9BZP<@PPH000<8@@<@PP9Jj`=Jb`>mm`?gWPKoo`?g_P:eUPJe]P>me`=B
ZP<@PP8000<8@@<@PP<H``=[K@=[C@;>F@?F^P?og`?oo`?og`G660IJj`<@XPH00088@@<@PP=Jb`>m
m`?gWPKoo`;g_P?_O@?W?0?W70?Nn`?Nf`;F^PKFVP?>N@Q[K@<Hh`H000<080<8H@Soo`?g_P:me`=B
ZP<@PPH000<8@@8@PP=Jj`=Jb`>mm`?gWPGoo`?g_P>eUPJe]P>me`9BZP<@PP<000<8@@<@PP<H``=[
K@9[C@?>F@?F^P?og`?oo`?og`G660IJj`<@XPD000<8@@<@PP=Jb`>mm`?gWPGoo`?g_P?_O@?W?0?W
70?Nn`;Nf`?F^PKFVP?>N@Q[K@<Hh`H000<08088H@Woo`;g_P>me`=BZP<@PPH00088@@<@PP=Jj`=J
b`>mm`?gWPGoo`?g_P>eUPJe]P:me`=BZP<@PP<000<8@@<@PP8H``=[K@=[C@?>F@?F^P?og`?oo`;o
g`K660IJj`<@XPD000<8@@<@PP=Jb`>mm`;gWPKoo`?g_P?_O@?W?0;W70?Nn`?Nf`?F^PKFVP;>N@U[
K@<Hh`H0008080<8H@Soo`?g_P>me`=BZP<@PPD000<8@@<@PP=Jj`=Jb`:mm`?gWPKoo`?g_P>eUPFe
]P>me`=BZP<@PP<000<8@@8@PP<H``=[K@=[C@?>F@?F^P;og`?oo`?og`K660EJj`<@XPH000<8@@<@
PP9Jb`>mm`?gWPKoo`?g_P?_O@;W?0?W70?Nn`?Nf`?F^PGFVP?>N@U[K@<Hh`D000<080<8HASoo`00
5ooo0oNn0kgG0U:Z0a221P000`Q10a220U[[0e[;0kgg0oNN1_oo0oNn0[FF1[Ff0kgG0e:Z0a220P00
0`Q10a220aS30f]]0f]=0/iI0mJj0ooO0ooo0ooO1LHH1U[[0a2R1P000PQ10a220e[;0kgg0oNN1_oo
0_Nn0nmm0nLl0nLL0mkk0mkK0]Jj1]JJ0lii26]]0aSS1P000`0P0`QQ2?oo0oNn0[gG0e:Z0a221P00
0`Q10Q220e[[0e[;0kgg0oNN1Ooo0oNn0kFF1[Ff0kgG0U:Z0a220`000`Q10a220aS30f]]0V]=0liI
0mJj0ooO0ooo0ooO1LHH1U[[0a2R1@000`Q10a220e[;0kgg0oNN1Ooo0oNn0nmm0nLl0nLL0mkk0]kK
0mJj1]JJ0lii26]]0aSS1P000`0P0PQQ2Ooo0_Nn0kgG0e:Z0a221P000PQ10a220e[[0e[;0kgg0oNN
1Ooo0oNn0kFF1[Ff0[gG0e:Z0a220`000`Q10a220QS30f]]0f]=0liI0mJj0ooO0ooo0_oO1/HH1U[[
0a2R1@000`Q10a220e[;0kgg0_NN1_oo0oNn0nmm0nLl0^LL0mkk0mkK0mJj1]JJ0/ii2F]]0aSS1P00
0P0P0`QQ2?oo0oNn0kgG0e:Z0a221@000`Q10a220e[[0e[;0[gg0oNN1_oo0oNn0kFF1KFf0kgG0e:Z
0a220`000`Q10Q220aS30f]]0f]=0liI0mJj0_oO0ooo0ooO1/HH1E[[0a2R1P000`Q10a220U[;0kgg
0oNN1_oo0oNn0nmm0^Ll0nLL0mkk0mkK0mJj1MJJ0lii2F]]0aSS1@000`0P0`QQ6?oo000Gool3mkh3
_ML2DZX34886000324434882F^/3F//3_OL3mih6ool3mkh2]IH6]KH3_ML3DZX34882000324434883
6<<3Jfd3Jdd2cUT3e[X3oml3ool3oml5aQP6F^/34:86000224434883F//3_OL3mih6ool2mkh3kgd3
ic`3ia`3g_/3g]/2e[X6eYX3cWT8Jfd36><6000302032648ool3mkh2_ML3DZX34886000324424883
F^/3F//3_OL3mih5ool3mkh3]IH6]KH3_ML2DZX348830003244348836<<3Jfd2Jdd3cUT3e[X3oml3
ool3oml5aQP6F^/34:85000324434883F//3_OL3mih5ool3mkh3kgd3ic`3ia`3g_/2g]/3e[X6eYX3
cWT8Jfd36><6000302022649ool2mkh3_ML3DZX34886000224434883F^/3F//3_OL3mih5ool3mkh3
]IH6]KH2_ML3DZX348830003244348826<<3Jfd3Jdd3cUT3e[X3oml3ool2oml6aQP6F^/34:850003
24434883F//3_OL2mih6ool3mkh3kgd3ic`2ia`3g_/3g]/3e[X6eYX2cWT9Jfd36><6000202032648
ool3mkh3_ML3DZX34885000324434883F^/3F//2_OL3mih6ool3mkh3]IH5]KH3_ML3DZX348830003
244248836<<3Jfd3Jdd3cUT3e[X2oml3ool3oml6aQP5F^/34:86000324434882F//3_OL3mih6ool3
mkh3kgd2ic`3ia`3g_/3g]/3e[X5eYX3cWT9Jfd36><500030203264Hool001Ooo`?g_P>me`9BZP<@
PPH000<8@@<@PP9Jj`=Jb`>mm`?gWPKoo`?g_P:eUPJe]P>me`=BZP<@PP8000<8@@<@PP<H``=[K@=[
C@;>F@?F^P?og`?oo`?og`G660IJj`<@XPH00088@@<@PP=Jb`>mm`?gWPKoo`;g_P?_O@?W?0?W70?N
n`?Nf`;F^PKFVP?>N@Q[K@<Hh`H000<080<8H@Soo`?g_P:me`=BZP<@PPH000<8@@8@PP=Jj`=Jb`>m
m`?gWPGoo`?g_P>eUPJe]P>me`9BZP<@PP<000<8@@<@PP<H``=[K@9[C@?>F@?F^P?og`?oo`?og`G6
60IJj`<@XPD000<8@@<@PP=Jb`>mm`?gWPGoo`?g_P?_O@?W?0?W70?Nn`;Nf`?F^PKFVP?>N@Q[K@<H
h`H000<08088H@Woo`;g_P>me`=BZP<@PPH00088@@<@PP=Jj`=Jb`>mm`?gWPGoo`?g_P>eUPJe]P:m
e`=BZP<@PP<000<8@@<@PP8H``=[K@=[C@?>F@?F^P?og`?oo`;og`K660IJj`<@XPD000<8@@<@PP=J
b`>mm`;gWPKoo`?g_P?_O@?W?0;W70?Nn`?Nf`?F^PKFVP;>N@U[K@<Hh`H0008080<8H@Soo`?g_P>m
e`=BZP<@PPD000<8@@<@PP=Jj`=Jb`:mm`?gWPKoo`?g_P>eUPFe]P>me`=BZP<@PP<000<8@@8@PP<H
``=[K@=[C@?>F@?F^P;og`?oo`?og`K660EJj`<@XPH000<8@@<@PP9Jb`>mm`?gWPKoo`?g_P?_O@;W
?0?W70?Nn`?Nf`?F^PGFVP?>N@U[K@<Hh`D000<080<8HASoo`005ooo0a2R0aSS0R440g__0mJj0nLL
1_oo0_oO0oNN0jDd0d8X0`QQ0`000a220U[[0e[;0e:Z1U::0dYY0[FF0nmm0ooo0oNN0nmM0icC0Ycc
0cWW0`Q11P000`Q10Q220f<<0lHH0oNn0ooo0nmm0^Ll0iBB0c660`Q10`000`0P0cW70Ycc0nLl0oNn
0ooo0nmM0nLL0]kk0h@@0bU50aS30`000`0P2cWW0jDD0jDd2?oo0a2R0QSS0b440g__0mJj0nLL1Ooo
0ooO0oNN0jDd0d8X0`QQ0P000a220e[[0e[;0e:Z1E::0dYY0kFF0nmm0ooo0oNN0nmM0YcC0icc0cWW
0`Q11P000PQ10a220f<<0lHH0oNn0ooo0^mm0nLl0iBB0c660`Q10`000P0P0cW70icc0nLl0oNn0ooo
0nmM0^LL0mkk0h@@0bU50aS30`000P0P33WW0jDD0ZDd2Ooo0Q2R0aSS0b440g__0mJj0nLL1Ooo0ooO
0oNN0jDd0d8X0PQQ0`000a220e[[0e[;0e:Z1E::0dYY0kFF0nmm0ooo0_NN0nmM0icC0icc0cWW0`Q1
1@000`Q10a220f<<0lHH0oNn0_oo0nmm0nLl0iBB0c660`Q10P000`0P0cW70icc0nLl0oNn0_oo0nmM
0nLL0mkk0h@@0bU50QS30`000`0P33WW0ZDD0jDd2?oo0a2R0aSS0b440g__0]Jj0nLL1_oo0ooO0oNN
0ZDd0d8X0`QQ0`000a220e[[0e[;0U:Z1U::0dYY0kFF0nmm0_oo0oNN0nmM0icC0icc0cWW0PQ11P00
0`Q10a220f<<0/HH0oNn0ooo0nmm0nLl0iBB0S660`Q10`000`0P0cW70icc0nLl0_Nn0ooo0nmM0nLL
0mkk0h@@0RU50aS30`000`0P2cWW0jDD0jDd6?oo000Gool34:836><28@@3Nnl3e[X3ia`6ool2oml3
mih3YC@3@RP3264300034882F^/3F//3DZX6DXX3BVT2]IH3kgd3ool3mih3ked3W=<2W?<3>NL32446
000324424883H``3aQP3mkh3ool3kgd2ic`3U983<HH3244300030203>LL2W?<3ic`3mkh3ool3ked3
ia`2g_/3Q103:DD36<<30003020;>NL3YA@3YC@8ool34:826><38@@3Nnl3e[X3ia`5ool3oml3mih3
YC@3@RP3264200034883F^/3F//3DZX5DXX3BVT3]IH3kgd3ool3mih3ked2W=<3W?<3>NL324460002
24434883H``3aQP3mkh3ool2kgd3ic`3U983<HH3244300020203>LL3W?<3ic`3mkh3ool3ked2ia`3
g_/3Q103:DD36<<30002020<>NL3YA@2YC@9ool24:836><38@@3Nnl3e[X3ia`5ool3oml3mih3YC@3
@RP2264300034883F^/3F//3DZX5DXX3BVT3]IH3kgd3ool2mih3ked3W=<3W?<3>NL3244500032443
4883H``3aQP3mkh2ool3kgd3ic`3U983<HH3244200030203>LL3W?<3ic`3mkh2ool3ked3ia`3g_/3
Q103:DD26<<30003020<>NL2YA@3YC@8ool34:836><38@@3Nnl2e[X3ia`6ool3oml3mih2YC@3@RP3
264300034883F^/3F//2DZX6DXX3BVT3]IH3kgd2ool3mih3ked3W=<3W?<3>NL22446000324434883
H``2aQP3mkh3ool3kgd3ic`3U982<HH3244300030203>LL3W?<3ic`2mkh3ool3ked3ia`3g_/3Q102
:DD36<<30003020;>NL3YA@3YC@Hool001Ooo`<@XP<Hh`8Q10=kk`?F^P?W70Koo`;og`?gWP>U=0=2
:0<8H@<000<@PP9Jj`=Jb`=BZPIBRP=:J@:eUP?_O@?oo`?gWP?_G@>Ld`:Ll`<ii`<8@@H000<8@@8@
PP=S30?660?g_P?oo`?_O@;W?0>DTP<aQP<8@@<000<080<ia`:Ll`?W?0?g_P?oo`?_G@?W70;Nn`>4
40<YA@<H``<000<080/ii`>U50>U=0Soo`<@XP8Hh`<Q10=kk`?F^P?W70Goo`?og`?gWP>U=0=2:0<8
H@8000<@PP=Jj`=Jb`=BZPEBRP=:J@>eUP?_O@?oo`?gWP?_G@:Ld`>Ll`<ii`<8@@H00088@@<@PP=S
30?660?g_P?oo`;_O@?W?0>DTP<aQP<8@@<0008080<ia`>Ll`?W?0?g_P?oo`?_G@;W70?Nn`>440<Y
A@<H``<0008080`ii`>U50:U=0Woo`8@XP<Hh`<Q10=kk`?F^P?W70Goo`?og`?gWP>U=0=2:088H@<0
00<@PP=Jj`=Jb`=BZPEBRP=:J@>eUP?_O@?oo`;gWP?_G@>Ld`>Ll`<ii`<8@@D000<8@@<@PP=S30?6
60?g_P;oo`?_O@?W?0>DTP<aQP<8@@8000<080<ia`>Ll`?W?0?g_P;oo`?_G@?W70?Nn`>440<YA@8H
``<000<080`ii`:U50>U=0Soo`<@XP<Hh`<Q10=kk`;F^P?W70Koo`?og`?gWP:U=0=2:0<8H@<000<@
PP=Jj`=Jb`9BZPIBRP=:J@>eUP?_O@;oo`?gWP?_G@>Ld`>Ll`<ii`88@@H000<8@@<@PP=S30;660?g
_P?oo`?_O@?W?0>DTP8aQP<8@@<000<080<ia`>Ll`?W?0;g_P?oo`?_G@?W70?Nn`>4408YA@<H``<0
00<080/ii`>U50>U=1Soo`005ooo0a2R0aSS0R440g__0mJj0nLL1_oo0_oO0oNN0jDd0d8X0`QQ0`00
0a220U[[0e[;0e:Z1U::0dYY0[FF0nmm0ooo0oNN0nmM0icC0Ycc0cWW0`Q11P000`Q10Q220f<<0lHH
0oNn0ooo0nmm0^Ll0iBB0c660`Q10`000`0P0cW70Ycc0nLl0oNn0ooo0nmM0nLL0]kk0h@@0bU50aS3
0`000`0P2cWW0jDD0jDd2?oo0a2R0QSS0b440g__0mJj0nLL1Ooo0ooO0oNN0jDd0d8X0`QQ0P000a22
0e[[0e[;0e:Z1E::0dYY0kFF0nmm0ooo0oNN0nmM0YcC0icc0cWW0`Q11P000PQ10a220f<<0lHH0oNn
0ooo0^mm0nLl0iBB0c660`Q10`000P0P0cW70icc0nLl0oNn0ooo0nmM0^LL0mkk0h@@0bU50aS30`00
0P0P33WW0jDD0ZDd2Ooo0Q2R0aSS0b440g__0mJj0nLL1Ooo0ooO0oNN0jDd0d8X0PQQ0`000a220e[[
0e[;0e:Z1E::0dYY0kFF0nmm0ooo0_NN0nmM0icC0icc0cWW0`Q11@000`Q10a220f<<0lHH0oNn0_oo
0nmm0nLl0iBB0c660`Q10P000`0P0cW70icc0nLl0oNn0_oo0nmM0nLL0mkk0h@@0bU50QS30`000`0P
33WW0ZDD0jDd2?oo0a2R0aSS0b440g__0]Jj0nLL1_oo0ooO0oNN0ZDd0d8X0`QQ0`000a220e[[0e[;
0U:Z1U::0dYY0kFF0nmm0_oo0oNN0nmM0icC0icc0cWW0PQ11P000`Q10a220f<<0/HH0oNn0ooo0nmm
0nLl0iBB0S660`Q10`000`0P0cW70icc0nLl0_Nn0ooo0nmM0nLL0mkk0h@@0RU50aS30`000`0P2cWW
0jDD0jDd6?oo000Gool34:836><28@@3Nnl3e[X3ia`6ool2oml3mih3YC@3@RP3264300034882F^/3
F//3DZX6DXX3BVT2]IH3kgd3ool3mih3ked3W=<2W?<3>NL32446000324424883H``3aQP3mkh3ool3
kgd2ic`3U983<HH3244300030203>LL2W?<3ic`3mkh3ool3ked3ia`2g_/3Q103:DD36<<30003020;
>NL3YA@3YC@8ool34:826><38@@3Nnl3e[X3ia`5ool3oml3mih3YC@3@RP3264200034883F^/3F//3
DZX5DXX3BVT3]IH3kgd3ool3mih3ked2W=<3W?<3>NL32446000224434883H``3aQP3mkh3ool2kgd3
ic`3U983<HH3244300020203>LL3W?<3ic`3mkh3ool3ked2ia`3g_/3Q103:DD36<<30002020<>NL3
YA@2YC@9ool24:836><38@@3Nnl3e[X3ia`5ool3oml3mih3YC@3@RP2264300034883F^/3F//3DZX5
DXX3BVT3]IH3kgd3ool2mih3ked3W=<3W?<3>NL32445000324434883H``3aQP3mkh2ool3kgd3ic`3
U983<HH3244200030203>LL3W?<3ic`3mkh2ool3ked3ia`3g_/3Q103:DD26<<30003020<>NL2YA@3
YC@8ool34:836><38@@3Nnl2e[X3ia`6ool3oml3mih2YC@3@RP3264300034883F^/3F//2DZX6DXX3
BVT3]IH3kgd2ool3mih3ked3W=<3W?<3>NL22446000324434883H``2aQP3mkh3ool3kgd3ic`3U982
<HH3244300030203>LL3W?<3ic`2mkh3ool3ked3ia`3g_/3Q102:DD36<<30003020;>NL3YA@3YC@H
ool001Ooo`<@XP<Hh`8Q10=kk`?F^P?W70Koo`;og`?gWP>U=0=2:0<8H@<000<@PP9Jj`=Jb`=BZPIB
RP=:J@:eUP?_O@?oo`?gWP?_G@>Ld`:Ll`<ii`<8@@H000<8@@8@PP=S30?660?g_P?oo`?_O@;W?0>D
TP<aQP<8@@<000<080<ia`:Ll`?W?0?g_P?oo`?_G@?W70;Nn`>440<YA@<H``<000<080/ii`>U50>U
=0Soo`<@XP8Hh`<Q10=kk`?F^P?W70Goo`?og`?gWP>U=0=2:0<8H@8000<@PP=Jj`=Jb`=BZPEBRP=:
J@>eUP?_O@?oo`?gWP?_G@:Ld`>Ll`<ii`<8@@H00088@@<@PP=S30?660?g_P?oo`;_O@?W?0>DTP<a
QP<8@@<0008080<ia`>Ll`?W?0?g_P?oo`?_G@;W70?Nn`>440<YA@<H``<0008080`ii`>U50:U=0Wo
o`8@XP<Hh`<Q10=kk`?F^P?W70Goo`?og`?gWP>U=0=2:088H@<000<@PP=Jj`=Jb`=BZPEBRP=:J@>e
UP?_O@?oo`;gWP?_G@>Ld`>Ll`<ii`<8@@D000<8@@<@PP=S30?660?g_P;oo`?_O@?W?0>DTP<aQP<8
@@8000<080<ia`>Ll`?W?0?g_P;oo`?_G@?W70?Nn`>440<YA@8H``<000<080`ii`:U50>U=0Soo`<@
XP<Hh`<Q10=kk`;F^P?W70Koo`?og`?gWP:U=0=2:0<8H@<000<@PP=Jj`=Jb`9BZPIBRP=:J@>eUP?_
O@;oo`?gWP?_G@>Ld`>Ll`<ii`88@@H000<8@@<@PP=S30;660?g_P?oo`?_O@?W?0>DTP8aQP<8@@<0
00<080<ia`>Ll`?W?0;g_P?oo`?_G@?W70?Nn`>4408YA@<H``<000<080/ii`>U50>U=1Soo`005ooo
0a2R0aSS0R440g__0mJj0nLL1_oo0_oO0oNN0jDd0d8X0`QQ0`000a220U[[0e[;0e:Z1U::0dYY0[FF
0nmm0ooo0oNN0nmM0icC0Ycc0cWW0`Q11P000`Q10Q220f<<0lHH0oNn0ooo0nmm0^Ll0iBB0c660`Q1
0`000`0P0cW70Ycc0nLl0oNn0ooo0nmM0nLL0]kk0h@@0bU50aS30`000`0P2cWW0jDD0jDd2?oo0a2R
0QSS0b440g__0mJj0nLL1Ooo0ooO0oNN0jDd0d8X0`QQ0P000a220e[[0e[;0e:Z1E::0dYY0kFF0nmm
0ooo0oNN0nmM0YcC0icc0cWW0`Q11P000PQ10a220f<<0lHH0oNn0ooo0^mm0nLl0iBB0c660`Q10`00
0P0P0cW70icc0nLl0oNn0ooo0nmM0^LL0mkk0h@@0bU50aS30`000P0P33WW0jDD0ZDd2Ooo0Q2R0aSS
0b440g__0mJj0nLL1Ooo0ooO0oNN0jDd0d8X0PQQ0`000a220e[[0e[;0e:Z1E::0dYY0kFF0nmm0ooo
0_NN0nmM0icC0icc0cWW0`Q11@000`Q10a220f<<0lHH0oNn0_oo0nmm0nLl0iBB0c660`Q10P000`0P
0cW70icc0nLl0oNn0_oo0nmM0nLL0mkk0h@@0bU50QS30`000`0P33WW0ZDD0jDd2?oo0a2R0aSS0b44
0g__0]Jj0nLL1_oo0ooO0oNN0ZDd0d8X0`QQ0`000a220e[[0e[;0U:Z1U::0dYY0kFF0nmm0_oo0oNN
0nmM0icC0icc0cWW0PQ11P000`Q10a220f<<0/HH0oNn0ooo0nmm0nLl0iBB0S660`Q10`000`0P0cW7
0icc0nLl0_Nn0ooo0nmM0nLL0mkk0h@@0RU50aS30`000`0P2cWW0jDD0jDd6?oo000Gool34:836><2
8@@3Nnl3e[X3ia`6ool2oml3mih3YC@3@RP3264300034882F^/3F//3DZX6DXX3BVT2]IH3kgd3ool3
mih3ked3W=<2W?<3>NL32446000324424883H``3aQP3mkh3ool3kgd2ic`3U983<HH3244300030203
>LL2W?<3ic`3mkh3ool3ked3ia`2g_/3Q103:DD36<<30003020;>NL3YA@3YC@8ool34:826><38@@3
Nnl3e[X3ia`5ool3oml3mih3YC@3@RP3264200034883F^/3F//3DZX5DXX3BVT3]IH3kgd3ool3mih3
ked2W=<3W?<3>NL32446000224434883H``3aQP3mkh3ool2kgd3ic`3U983<HH3244300020203>LL3
W?<3ic`3mkh3ool3ked2ia`3g_/3Q103:DD36<<30002020<>NL3YA@2YC@9ool24:836><38@@3Nnl3
e[X3ia`5ool3oml3mih3YC@3@RP2264300034883F^/3F//3DZX5DXX3BVT3]IH3kgd3ool2mih3ked3
W=<3W?<3>NL32445000324434883H``3aQP3mkh2ool3kgd3ic`3U983<HH3244200030203>LL3W?<3
ic`3mkh2ool3ked3ia`3g_/3Q103:DD26<<30003020<>NL2YA@3YC@8ool34:836><38@@3Nnl2e[X3
ia`6ool3oml3mih2YC@3@RP3264300034883F^/3F//2DZX6DXX3BVT3]IH3kgd2ool3mih3ked3W=<3
W?<3>NL22446000324434883H``2aQP3mkh3ool3kgd3ic`3U982<HH3244300030203>LL3W?<3ic`2
mkh3ool3ked3ia`3g_/3Q102:DD36<<30003020;>NL3YA@3YC@Hool001Ooo`<@XP<Hh`8Q10=kk`?F
^P?W70Koo`;og`?gWP>U=0=2:0<8H@<000<@PP9Jj`=Jb`=BZPIBRP=:J@:eUP?_O@?oo`?gWP?_G@>L
d`:Ll`<ii`<8@@H000<8@@8@PP=S30?660?g_P?oo`?_O@;W?0>DTP<aQP<8@@<000<080<ia`:Ll`?W
?0?g_P?oo`?_G@?W70;Nn`>440<YA@<H``<000<080/ii`>U50>U=0Soo`<@XP8Hh`<Q10=kk`?F^P?W
70Goo`?og`?gWP>U=0=2:0<8H@8000<@PP=Jj`=Jb`=BZPEBRP=:J@>eUP?_O@?oo`?gWP?_G@:Ld`>L
l`<ii`<8@@H00088@@<@PP=S30?660?g_P?oo`;_O@?W?0>DTP<aQP<8@@<0008080<ia`>Ll`?W?0?g
_P?oo`?_G@;W70?Nn`>440<YA@<H``<0008080`ii`>U50:U=0Woo`8@XP<Hh`<Q10=kk`?F^P?W70Go
o`?og`?gWP>U=0=2:088H@<000<@PP=Jj`=Jb`=BZPEBRP=:J@>eUP?_O@?oo`;gWP?_G@>Ld`>Ll`<i
i`<8@@D000<8@@<@PP=S30?660?g_P;oo`?_O@?W?0>DTP<aQP<8@@8000<080<ia`>Ll`?W?0?g_P;o
o`?_G@?W70?Nn`>440<YA@8H``<000<080`ii`:U50>U=0Soo`<@XP<Hh`<Q10=kk`;F^P?W70Koo`?o
g`?gWP:U=0=2:0<8H@<000<@PP=Jj`=Jb`9BZPIBRP=:J@>eUP?_O@;oo`?gWP?_G@>Ld`>Ll`<ii`88
@@H000<8@@<@PP=S30;660?g_P?oo`?_O@?W?0>DTP8aQP<8@@<000<080<ia`>Ll`?W?0;g_P?oo`?_
G@?W70?Nn`>4408YA@<H``<000<080/ii`>U50>U=1Soo`005ooo0a2R0aSS0R440g__0mJj0nLL1_oo
0_oO0oNN0jDd0d8X0`QQ0`000a220U[[0e[;0e:Z1U::0dYY0[FF0nmm0ooo0oNN0nmM0icC0Ycc0cWW
0`Q11P000`Q10Q220f<<0lHH0oNn0ooo0nmm0^Ll0iBB0c660`Q10`000`0P0cW70Ycc0nLl0oNn0ooo
0nmM0nLL0]kk0h@@0bU50aS30`000`0P2cWW0jDD0jDd2?oo0a2R0QSS0b440g__0mJj0nLL1Ooo0ooO
0oNN0jDd0d8X0`QQ0P000a220e[[0e[;0e:Z1E::0dYY0kFF0nmm0ooo0oNN0nmM0YcC0icc0cWW0`Q1
1P000PQ10a220f<<0lHH0oNn0ooo0^mm0nLl0iBB0c660`Q10`000P0P0cW70icc0nLl0oNn0ooo0nmM
0^LL0mkk0h@@0bU50aS30`000P0P33WW0jDD0ZDd2Ooo0Q2R0aSS0b440g__0mJj0nLL1Ooo0ooO0oNN
0jDd0d8X0PQQ0`000a220e[[0e[;0e:Z1E::0dYY0kFF0nmm0ooo0_NN0nmM0icC0icc0cWW0`Q11@00
0`Q10a220f<<0lHH0oNn0_oo0nmm0nLl0iBB0c660`Q10P000`0P0cW70icc0nLl0oNn0_oo0nmM0nLL
0mkk0h@@0bU50QS30`000`0P33WW0ZDD0jDd2?oo0a2R0aSS0b440g__0]Jj0nLL1_oo0ooO0oNN0ZDd
0d8X0`QQ0`000a220e[[0e[;0U:Z1U::0dYY0kFF0nmm0_oo0oNN0nmM0icC0icc0cWW0PQ11P000`Q1
0a220f<<0/HH0oNn0ooo0nmm0nLl0iBB0S660`Q10`000`0P0cW70icc0nLl0_Nn0ooo0nmM0nLL0mkk
0h@@0RU50aS30`000`0P2cWW0jDD0jDd6?oo000Gool34:836><28@@3Nnl3e[X3ia`6ool2oml3mih3
YC@3@RP3264300034882F^/3F//3DZX6DXX3BVT2]IH3kgd3ool3mih3ked3W=<2W?<3>NL324460003
24424883H``3aQP3mkh3ool3kgd2ic`3U983<HH3244300030203>LL2W?<3ic`3mkh3ool3ked3ia`2
g_/3Q103:DD36<<30003020;>NL3YA@3YC@8ool34:826><38@@3Nnl3e[X3ia`5ool3oml3mih3YC@3
@RP3264200034883F^/3F//3DZX5DXX3BVT3]IH3kgd3ool3mih3ked2W=<3W?<3>NL3244600022443
4883H``3aQP3mkh3ool2kgd3ic`3U983<HH3244300020203>LL3W?<3ic`3mkh3ool3ked2ia`3g_/3
Q103:DD36<<30002020<>NL3YA@2YC@9ool24:836><38@@3Nnl3e[X3ia`5ool3oml3mih3YC@3@RP2
264300034883F^/3F//3DZX5DXX3BVT3]IH3kgd3ool2mih3ked3W=<3W?<3>NL32445000324434883
H``3aQP3mkh2ool3kgd3ic`3U983<HH3244200030203>LL3W?<3ic`3mkh2ool3ked3ia`3g_/3Q103
:DD26<<30003020<>NL2YA@3YC@8ool34:836><38@@3Nnl2e[X3ia`6ool3oml3mih2YC@3@RP32643
00034883F^/3F//2DZX6DXX3BVT3]IH3kgd2ool3mih3ked3W=<3W?<3>NL22446000324434883H``2
aQP3mkh3ool3kgd3ic`3U982<HH3244300030203>LL3W?<3ic`2mkh3ool3ked3ia`3g_/3Q102:DD3
6<<30003020;>NL3YA@3YC@Hool001Ooo`<@XP<Hh`8Q10=kk`?F^P?W70Koo`;og`?gWP>U=0=2:0<8
H@<000<@PP9Jj`=Jb`=BZPIBRP=:J@:eUP?_O@?oo`?gWP?_G@>Ld`:Ll`<ii`<8@@H000<8@@8@PP=S
30?660?g_P?oo`?_O@;W?0>DTP<aQP<8@@<000<080<ia`:Ll`?W?0?g_P?oo`?_G@?W70;Nn`>440<Y
A@<H``<000<080/ii`>U50>U=0Soo`<@XP8Hh`<Q10=kk`?F^P?W70Goo`?og`?gWP>U=0=2:0<8H@80
00<@PP=Jj`=Jb`=BZPEBRP=:J@>eUP?_O@?oo`?gWP?_G@:Ld`>Ll`<ii`<8@@H00088@@<@PP=S30?6
60?g_P?oo`;_O@?W?0>DTP<aQP<8@@<0008080<ia`>Ll`?W?0?g_P?oo`?_G@;W70?Nn`>440<YA@<H
``<0008080`ii`>U50:U=0Woo`8@XP<Hh`<Q10=kk`?F^P?W70Goo`?og`?gWP>U=0=2:088H@<000<@
PP=Jj`=Jb`=BZPEBRP=:J@>eUP?_O@?oo`;gWP?_G@>Ld`>Ll`<ii`<8@@D000<8@@<@PP=S30?660?g
_P;oo`?_O@?W?0>DTP<aQP<8@@8000<080<ia`>Ll`?W?0?g_P;oo`?_G@?W70?Nn`>440<YA@8H``<0
00<080`ii`:U50>U=0Soo`<@XP<Hh`<Q10=kk`;F^P?W70Koo`?og`?gWP:U=0=2:0<8H@<000<@PP=J
j`=Jb`9BZPIBRP=:J@>eUP?_O@;oo`?gWP?_G@>Ld`>Ll`<ii`88@@H000<8@@<@PP=S30;660?g_P?o
o`?_O@?W?0>DTP8aQP<8@@<000<080<ia`>Ll`?W?0;g_P?oo`?_G@?W70?Nn`>4408YA@<H``<000<0
80/ii`>U50>U=1Soo`005ooo0nmM1Ooo0oNn0kgG0e:Z0e::0dY90T8X0cWW0c660b4T0`0P0`000`0P
0SWW0jDD0nmM0ooO0ooo0ooO0/Hh0f<<0aS30`000`0P1D880jDd0nmM0ooO0ooo0nLl0Xaa0iBB0c6V
0`Q10`000`0P0PQQ0a2R0aS30g>>0f]]0liI0oNn0_oo0nmM0iBb0icC0cW70`Q10P000`0P0`Q10a22
0aS30aSS0R4T0bU50h@`0mkK0ooO2ooo0nmM1Ooo0oNn0kgG0e:Z0e::0TY90d8X0cWW0c660b4T0`0P
0P000`0P0cWW0jDD0nmM0ooO0_oo0ooO0lHh0f<<0aS30`000`0P1D880jDd0nmM0ooO0ooo0^Ll0haa
0iBB0c6V0`Q10`000P0P0`QQ0a2R0aS30g>>0f]]0/iI0oNn0ooo0nmM0iBb0icC0cW70PQ10`000`0P
0`Q10a220aS30QSS0b4T0bU50h@`0mkK0ooO2ooo0^mM1_oo0oNn0kgG0e:Z0U::0dY90d8X0cWW0c66
0b4T0P0P0`000`0P0cWW0jDD0nmM0_oO0ooo0ooO0lHh0f<<0aS30P000`0P1T880jDd0nmM0ooO0_oo
0nLl0haa0iBB0c6V0`Q10P000`0P0`QQ0a2R0aS30g>>0V]]0liI0oNn0ooo0nmM0iBb0YcC0cW70`Q1
0`000`0P0`Q10Q220aS30aSS0b4T0bU50h@`0mkK0_oO2ooo0nmM1_oo0oNn0[gG0e:Z0e::0dY90d8X
0cWW0S660b4T0`0P0`000`0P0cWW0jDD0^mM0ooO0ooo0ooO0lHh0f<<0QS30`000`0P1T880jDd0^mM
0ooO0ooo0nLl0haa0iBB0S6V0`Q10`000`0P0`QQ0a2R0QS30g>>0f]]0liI0oNn0ooo0nmM0YBb0icC
0cW70`Q10`000`0P0PQ10a220aS30aSS0b4T0bU50X@`0mkK0ooO6ooo000Gool3ked5ool3mkh3_ML3
DZX3DXX3BTT2@RP3>NL3<HH38B@3020300030202>NL3YA@3ked3oml3ool3oml2aSP3H``36<<30003
0205@PP3YC@3ked3oml3ool3ic`2S743U983<JH324430003020226434:836<<3Lhh3Jfd3cUT3mkh2
ool3ked3U;83W=<3>LL3244200030203244348836<<36><28B@3:DD3Q303g]/3oml;ool3ked5ool3
mkh3_ML3DZX3DXX2BTT3@RP3>NL3<HH38B@3020200030203>NL3YA@3ked3oml2ool3oml3aSP3H``3
6<<300030205@PP3YC@3ked3oml3ool2ic`3S743U983<JH324430002020326434:836<<3Lhh3Jfd2
cUT3mkh3ool3ked3U;83W=<3>LL2244300030203244348836<<26><38B@3:DD3Q303g]/3oml;ool2
ked6ool3mkh3_ML3DZX2DXX3BTT3@RP3>NL3<HH38B@2020300030203>NL3YA@3ked2oml3ool3oml3
aSP3H``36<<200030206@PP3YC@3ked3oml2ool3ic`3S743U983<JH324420003020326434:836<<3
Lhh2Jfd3cUT3mkh3ool3ked3U;82W=<3>LL3244300030203244248836<<36><38B@3:DD3Q303g]/2
oml;ool3ked6ool3mkh2_ML3DZX3DXX3BTT3@RP3>NL2<HH38B@3020300030203>NL3YA@2ked3oml3
ool3oml3aSP3H``26<<300030206@PP3YC@2ked3oml3ool3ic`3S743U982<JH32443000302032643
4:826<<3Lhh3Jfd3cUT3mkh3ool3ked2U;83W=<3>LL3244300030202244348836<<36><38B@3:DD2
Q303g]/3omlKool001Ooo`?_G@Goo`?g_P>me`=BZP=BRP=:B@92:0<ii`<aQP<Q90<080<000<0808i
i`>U50?_G@?og`?oo`?og`;6>0=S30<H``<000<080E220>U=0?_G@?og`?oo`?W?0:<L@>DTP<aYP<8
@@<000<08088H@<@XP<H``=cSP=[K@?>F@?g_P;oo`?_G@>D/P>Ld`<ia`<8@@8000<080<8@@<@PP<H
``<Hh`8Q90<YA@>4<0?Nf`?og`_oo`?_G@Goo`?g_P>me`=BZP=BRP9:B@=2:0<ii`<aQP<Q90<08080
00<080<ii`>U50?_G@?og`;oo`?og`?6>0=S30<H``<000<080E220>U=0?_G@?og`?oo`;W?0><L@>D
TP<aYP<8@@<0008080<8H@<@XP<H``=cSP=[K@;>F@?g_P?oo`?_G@>D/P>Ld`<ia`88@@<000<080<8
@@<@PP<H``8Hh`<Q90<YA@>4<0?Nf`?og`_oo`;_G@Koo`?g_P>me`=BZP9BRP=:B@=2:0<ii`<aQP<Q
908080<000<080<ii`>U50?_G@;og`?oo`?og`?6>0=S30<H``8000<080I220>U=0?_G@?og`;oo`?W
?0><L@>DTP<aYP<8@@8000<080<8H@<@XP<H``=cSP9[K@?>F@?g_P?oo`?_G@>D/P:Ld`<ia`<8@@<0
00<080<8@@8@PP<H``<Hh`<Q90<YA@>4<0?Nf`;og`_oo`?_G@Koo`?g_P:me`=BZP=BRP=:B@=2:0<i
i`8aQP<Q90<080<000<080<ii`>U50;_G@?og`?oo`?og`?6>0=S308H``<000<080I220>U=0;_G@?o
g`?oo`?W?0><L@>DTP8aYP<8@@<000<080<8H@<@XP8H``=cSP=[K@?>F@?g_P?oo`?_G@:D/P>Ld`<i
a`<8@@<000<08088@@<@PP<H``<Hh`<Q90<YA@:4<0?Nf`?oga_oo`005ooo0nmM1Ooo0oNn0kgG0e:Z
0e::0dY90T8X0cWW0c660b4T0`0P0`000`0P0SWW0jDD0nmM0ooO0ooo0ooO0/Hh0f<<0aS30`000`0P
1D880jDd0nmM0ooO0ooo0nLl0Xaa0iBB0c6V0`Q10`000`0P0PQQ0a2R0aS30g>>0f]]0liI0oNn0_oo
0nmM0iBb0icC0cW70`Q10P000`0P0`Q10a220aS30aSS0R4T0bU50h@`0mkK0ooO2ooo0nmM1Ooo0oNn
0kgG0e:Z0e::0TY90d8X0cWW0c660b4T0`0P0P000`0P0cWW0jDD0nmM0ooO0_oo0ooO0lHh0f<<0aS3
0`000`0P1D880jDd0nmM0ooO0ooo0^Ll0haa0iBB0c6V0`Q10`000P0P0`QQ0a2R0aS30g>>0f]]0/iI
0oNn0ooo0nmM0iBb0icC0cW70PQ10`000`0P0`Q10a220aS30QSS0b4T0bU50h@`0mkK0ooO2ooo0^mM
1_oo0oNn0kgG0e:Z0U::0dY90d8X0cWW0c660b4T0P0P0`000`0P0cWW0jDD0nmM0_oO0ooo0ooO0lHh
0f<<0aS30P000`0P1T880jDd0nmM0ooO0_oo0nLl0haa0iBB0c6V0`Q10P000`0P0`QQ0a2R0aS30g>>
0V]]0liI0oNn0ooo0nmM0iBb0YcC0cW70`Q10`000`0P0`Q10Q220aS30aSS0b4T0bU50h@`0mkK0_oO
2ooo0nmM1_oo0oNn0[gG0e:Z0e::0dY90d8X0cWW0S660b4T0`0P0`000`0P0cWW0jDD0^mM0ooO0ooo
0ooO0lHh0f<<0QS30`000`0P1T880jDd0^mM0ooO0ooo0nLl0haa0iBB0S6V0`Q10`000`0P0`QQ0a2R
0QS30g>>0f]]0liI0oNn0ooo0nmM0YBb0icC0cW70`Q10`000`0P0PQ10a220aS30aSS0b4T0bU50X@`
0mkK0ooO6ooo000Gool3ked5ool3mkh3_ML3DZX3DXX3BTT2@RP3>NL3<HH38B@3020300030202>NL3
YA@3ked3oml3ool3oml2aSP3H``36<<300030205@PP3YC@3ked3oml3ool3ic`2S743U983<JH32443
0003020226434:836<<3Lhh3Jfd3cUT3mkh2ool3ked3U;83W=<3>LL3244200030203244348836<<3
6><28B@3:DD3Q303g]/3oml;ool3ked5ool3mkh3_ML3DZX3DXX2BTT3@RP3>NL3<HH38B@302020003
0203>NL3YA@3ked3oml2ool3oml3aSP3H``36<<300030205@PP3YC@3ked3oml3ool2ic`3S743U983
<JH324430002020326434:836<<3Lhh3Jfd2cUT3mkh3ool3ked3U;83W=<3>LL22443000302032443
48836<<26><38B@3:DD3Q303g]/3oml;ool2ked6ool3mkh3_ML3DZX2DXX3BTT3@RP3>NL3<HH38B@2
020300030203>NL3YA@3ked2oml3ool3oml3aSP3H``36<<200030206@PP3YC@3ked3oml2ool3ic`3
S743U983<JH324420003020326434:836<<3Lhh2Jfd3cUT3mkh3ool3ked3U;82W=<3>LL324430003
0203244248836<<36><38B@3:DD3Q303g]/2oml;ool3ked6ool3mkh2_ML3DZX3DXX3BTT3@RP3>NL2
<HH38B@3020300030203>NL3YA@2ked3oml3ool3oml3aSP3H``26<<300030206@PP3YC@2ked3oml3
ool3ic`3S743U982<JH324430003020326434:826<<3Lhh3Jfd3cUT3mkh3ool3ked2U;83W=<3>LL3
244300030202244348836<<36><38B@3:DD2Q303g]/3omlKool001Ooo`?_G@Goo`?g_P>me`=BZP=B
RP=:B@92:0<ii`<aQP<Q90<080<000<0808ii`>U50?_G@?og`?oo`?og`;6>0=S30<H``<000<080E2
20>U=0?_G@?og`?oo`?W?0:<L@>DTP<aYP<8@@<000<08088H@<@XP<H``=cSP=[K@?>F@?g_P;oo`?_
G@>D/P>Ld`<ia`<8@@8000<080<8@@<@PP<H``<Hh`8Q90<YA@>4<0?Nf`?og`_oo`?_G@Goo`?g_P>m
e`=BZP=BRP9:B@=2:0<ii`<aQP<Q90<0808000<080<ii`>U50?_G@?og`;oo`?og`?6>0=S30<H``<0
00<080E220>U=0?_G@?og`?oo`;W?0><L@>DTP<aYP<8@@<0008080<8H@<@XP<H``=cSP=[K@;>F@?g
_P?oo`?_G@>D/P>Ld`<ia`88@@<000<080<8@@<@PP<H``8Hh`<Q90<YA@>4<0?Nf`?og`_oo`;_G@Ko
o`?g_P>me`=BZP9BRP=:B@=2:0<ii`<aQP<Q908080<000<080<ii`>U50?_G@;og`?oo`?og`?6>0=S
30<H``8000<080I220>U=0?_G@?og`;oo`?W?0><L@>DTP<aYP<8@@8000<080<8H@<@XP<H``=cSP9[
K@?>F@?g_P?oo`?_G@>D/P:Ld`<ia`<8@@<000<080<8@@8@PP<H``<Hh`<Q90<YA@>4<0?Nf`;og`_o
o`?_G@Koo`?g_P:me`=BZP=BRP=:B@=2:0<ii`8aQP<Q90<080<000<080<ii`>U50;_G@?og`?oo`?o
g`?6>0=S308H``<000<080I220>U=0;_G@?og`?oo`?W?0><L@>DTP8aYP<8@@<000<080<8H@<@XP8H
``=cSP=[K@?>F@?g_P?oo`?_G@:D/P>Ld`<ia`<8@@<000<08088@@<@PP<H``<Hh`<Q90<YA@:4<0?N
f`?oga_oo`005ooo0nmM1Ooo0oNn0kgG0e:Z0e::0dY90T8X0cWW0c660b4T0`0P0`000`0P0SWW0jDD
0nmM0ooO0ooo0ooO0/Hh0f<<0aS30`000`0P1D880jDd0nmM0ooO0ooo0nLl0Xaa0iBB0c6V0`Q10`00
0`0P0PQQ0a2R0aS30g>>0f]]0liI0oNn0_oo0nmM0iBb0icC0cW70`Q10P000`0P0`Q10a220aS30aSS
0R4T0bU50h@`0mkK0ooO2ooo0nmM1Ooo0oNn0kgG0e:Z0e::0TY90d8X0cWW0c660b4T0`0P0P000`0P
0cWW0jDD0nmM0ooO0_oo0ooO0lHh0f<<0aS30`000`0P1D880jDd0nmM0ooO0ooo0^Ll0haa0iBB0c6V
0`Q10`000P0P0`QQ0a2R0aS30g>>0f]]0/iI0oNn0ooo0nmM0iBb0icC0cW70PQ10`000`0P0`Q10a22
0aS30QSS0b4T0bU50h@`0mkK0ooO2ooo0^mM1_oo0oNn0kgG0e:Z0U::0dY90d8X0cWW0c660b4T0P0P
0`000`0P0cWW0jDD0nmM0_oO0ooo0ooO0lHh0f<<0aS30P000`0P1T880jDd0nmM0ooO0_oo0nLl0haa
0iBB0c6V0`Q10P000`0P0`QQ0a2R0aS30g>>0V]]0liI0oNn0ooo0nmM0iBb0YcC0cW70`Q10`000`0P
0`Q10Q220aS30aSS0b4T0bU50h@`0mkK0_oO2ooo0nmM1_oo0oNn0[gG0e:Z0e::0dY90d8X0cWW0S66
0b4T0`0P0`000`0P0cWW0jDD0^mM0ooO0ooo0ooO0lHh0f<<0QS30`000`0P1T880jDd0^mM0ooO0ooo
0nLl0haa0iBB0S6V0`Q10`000`0P0`QQ0a2R0QS30g>>0f]]0liI0oNn0ooo0nmM0YBb0icC0cW70`Q1
0`000`0P0PQ10a220aS30aSS0b4T0bU50X@`0mkK0ooO6ooo000Gool3ked5ool3mkh3_ML3DZX3DXX3
BTT2@RP3>NL3<HH38B@3020300030202>NL3YA@3ked3oml3ool3oml2aSP3H``36<<300030205@PP3
YC@3ked3oml3ool3ic`2S743U983<JH324430003020226434:836<<3Lhh3Jfd3cUT3mkh2ool3ked3
U;83W=<3>LL3244200030203244348836<<36><28B@3:DD3Q303g]/3oml;ool3ked5ool3mkh3_ML3
DZX3DXX2BTT3@RP3>NL3<HH38B@3020200030203>NL3YA@3ked3oml2ool3oml3aSP3H``36<<30003
0205@PP3YC@3ked3oml3ool2ic`3S743U983<JH324430002020326434:836<<3Lhh3Jfd2cUT3mkh3
ool3ked3U;83W=<3>LL2244300030203244348836<<26><38B@3:DD3Q303g]/3oml;ool2ked6ool3
mkh3_ML3DZX2DXX3BTT3@RP3>NL3<HH38B@2020300030203>NL3YA@3ked2oml3ool3oml3aSP3H``3
6<<200030206@PP3YC@3ked3oml2ool3ic`3S743U983<JH324420003020326434:836<<3Lhh2Jfd3
cUT3mkh3ool3ked3U;82W=<3>LL3244300030203244248836<<36><38B@3:DD3Q303g]/2oml;ool3
ked6ool3mkh2_ML3DZX3DXX3BTT3@RP3>NL2<HH38B@3020300030203>NL3YA@2ked3oml3ool3oml3
aSP3H``26<<300030206@PP3YC@2ked3oml3ool3ic`3S743U982<JH324430003020326434:826<<3
Lhh3Jfd3cUT3mkh3ool3ked2U;83W=<3>LL3244300030202244348836<<36><38B@3:DD2Q303g]/3
omlKool001Ooo`?_G@Goo`?g_P>me`=BZP=BRP=:B@92:0<ii`<aQP<Q90<080<000<0808ii`>U50?_
G@?og`?oo`?og`;6>0=S30<H``<000<080E220>U=0?_G@?og`?oo`?W?0:<L@>DTP<aYP<8@@<000<0
8088H@<@XP<H``=cSP=[K@?>F@?g_P;oo`?_G@>D/P>Ld`<ia`<8@@8000<080<8@@<@PP<H``<Hh`8Q
90<YA@>4<0?Nf`?og`_oo`?_G@Goo`?g_P>me`=BZP=BRP9:B@=2:0<ii`<aQP<Q90<0808000<080<i
i`>U50?_G@?og`;oo`?og`?6>0=S30<H``<000<080E220>U=0?_G@?og`?oo`;W?0><L@>DTP<aYP<8
@@<0008080<8H@<@XP<H``=cSP=[K@;>F@?g_P?oo`?_G@>D/P>Ld`<ia`88@@<000<080<8@@<@PP<H
``8Hh`<Q90<YA@>4<0?Nf`?og`_oo`;_G@Koo`?g_P>me`=BZP9BRP=:B@=2:0<ii`<aQP<Q908080<0
00<080<ii`>U50?_G@;og`?oo`?og`?6>0=S30<H``8000<080I220>U=0?_G@?og`;oo`?W?0><L@>D
TP<aYP<8@@8000<080<8H@<@XP<H``=cSP9[K@?>F@?g_P?oo`?_G@>D/P:Ld`<ia`<8@@<000<080<8
@@8@PP<H``<Hh`<Q90<YA@>4<0?Nf`;og`_oo`?_G@Koo`?g_P:me`=BZP=BRP=:B@=2:0<ii`8aQP<Q
90<080<000<080<ii`>U50;_G@?og`?oo`?og`?6>0=S308H``<000<080I220>U=0;_G@?og`?oo`?W
?0><L@>DTP8aYP<8@@<000<080<8H@<@XP8H``=cSP=[K@?>F@?g_P?oo`?_G@:D/P>Ld`<ia`<8@@<0
00<08088@@<@PP<H``<Hh`<Q90<YA@:4<0?Nf`?oga_oo`005ooo0nmM1Ooo0oNn0kgG0e:Z0e::0dY9
0T8X0cWW0c660b4T0`0P0`000`0P0SWW0jDD0nmM0ooO0ooo0ooO0/Hh0f<<0aS30`000`0P1D880jDd
0nmM0ooO0ooo0nLl0Xaa0iBB0c6V0`Q10`000`0P0PQQ0a2R0aS30g>>0f]]0liI0oNn0_oo0nmM0iBb
0icC0cW70`Q10P000`0P0`Q10a220aS30aSS0R4T0bU50h@`0mkK0ooO2ooo0nmM1Ooo0oNn0kgG0e:Z
0e::0TY90d8X0cWW0c660b4T0`0P0P000`0P0cWW0jDD0nmM0ooO0_oo0ooO0lHh0f<<0aS30`000`0P
1D880jDd0nmM0ooO0ooo0^Ll0haa0iBB0c6V0`Q10`000P0P0`QQ0a2R0aS30g>>0f]]0/iI0oNn0ooo
0nmM0iBb0icC0cW70PQ10`000`0P0`Q10a220aS30QSS0b4T0bU50h@`0mkK0ooO2ooo0^mM1_oo0oNn
0kgG0e:Z0U::0dY90d8X0cWW0c660b4T0P0P0`000`0P0cWW0jDD0nmM0_oO0ooo0ooO0lHh0f<<0aS3
0P000`0P1T880jDd0nmM0ooO0_oo0nLl0haa0iBB0c6V0`Q10P000`0P0`QQ0a2R0aS30g>>0V]]0liI
0oNn0ooo0nmM0iBb0YcC0cW70`Q10`000`0P0`Q10Q220aS30aSS0b4T0bU50h@`0mkK0_oO2ooo0nmM
1_oo0oNn0[gG0e:Z0e::0dY90d8X0cWW0S660b4T0`0P0`000`0P0cWW0jDD0^mM0ooO0ooo0ooO0lHh
0f<<0QS30`000`0P1T880jDd0^mM0ooO0ooo0nLl0haa0iBB0S6V0`Q10`000`0P0`QQ0a2R0QS30g>>
0f]]0liI0oNn0ooo0nmM0YBb0icC0cW70`Q10`000`0P0PQ10a220aS30aSS0b4T0bU50X@`0mkK0ooO
6ooo000Gool3ked5ool3mkh3_ML3DZX3DXX3BTT2@RP3>NL3<HH38B@3020300030202>NL3YA@3ked3
oml3ool3oml2aSP3H``36<<300030205@PP3YC@3ked3oml3ool3ic`2S743U983<JH3244300030202
26434:836<<3Lhh3Jfd3cUT3mkh2ool3ked3U;83W=<3>LL3244200030203244348836<<36><28B@3
:DD3Q303g]/3oml;ool3ked5ool3mkh3_ML3DZX3DXX2BTT3@RP3>NL3<HH38B@3020200030203>NL3
YA@3ked3oml2ool3oml3aSP3H``36<<300030205@PP3YC@3ked3oml3ool2ic`3S743U983<JH32443
0002020326434:836<<3Lhh3Jfd2cUT3mkh3ool3ked3U;83W=<3>LL2244300030203244348836<<2
6><38B@3:DD3Q303g]/3oml;ool2ked6ool3mkh3_ML3DZX2DXX3BTT3@RP3>NL3<HH38B@202030003
0203>NL3YA@3ked2oml3ool3oml3aSP3H``36<<200030206@PP3YC@3ked3oml2ool3ic`3S743U983
<JH324420003020326434:836<<3Lhh2Jfd3cUT3mkh3ool3ked3U;82W=<3>LL32443000302032442
48836<<36><38B@3:DD3Q303g]/2oml;ool3ked6ool3mkh2_ML3DZX3DXX3BTT3@RP3>NL2<HH38B@3
020300030203>NL3YA@2ked3oml3ool3oml3aSP3H``26<<300030206@PP3YC@2ked3oml3ool3ic`3
S743U982<JH324430003020326434:826<<3Lhh3Jfd3cUT3mkh3ool3ked2U;83W=<3>LL324430003
0202244348836<<36><38B@3:DD2Q303g]/3omlKool001Ooo`?og`?6609Jj`<@XPH000<YA@F4<0?N
f`?_G@?oo`?g_P?_O@?W?0;W70><D@<YI@<080<000<080Pia`>Ll`?W?0?g_P;oo`?_G@?W70?Nn`>4
40>4<08YI@<080<000<Q90>440=kk`9kc`?F^P?og`?oo`?og`?gWP?_G@;W?0><L@>DTP<aYP<8@@<0
008080<aYPHia`>Ll`?W?0;oo`?og`?gWPJ]E@>]M@Soo`?og`;660=Jj`<@XPH000<YA@F4<0?Nf`?_
G@?oo`?g_P;_O@?W?0?W70><D@<YI@<0808000<080Tia`>Ll`?W?0;g_P?oo`?_G@?W70?Nn`>440:4
<0<YI@<080<000<Q90>4409kk`=kc`?F^P?og`?oo`?og`;gWP?_G@?W?0><L@>DTP<aYP<8@@8000<0
80<aYPHia`>Ll`;W?0?oo`?og`?gWPJ]E@:]M@Woo`;og`?660=Jj`<@XPH0008YA@J4<0?Nf`?_G@?o
o`;g_P?_O@?W?0?W70><D@<YI@8080<000<080Tia`:Ll`?W?0?g_P?oo`?_G@?W70?Nn`:440>4<0<Y
I@<080<000<Q90:440=kk`=kc`?F^P?og`?oo`;og`?gWP?_G@?W?0><L@>DTP8aYP<8@@<000<080<a
YPDia`>Ll`?W?0?oo`?og`?gWPF]E@>]M@Soo`?og`?660=Jj`<@XPD000<YA@J4<0?Nf`;_G@?oo`?g
_P?_O@?W?0?W70><D@8YI@<080<000<080Pia`>Ll`?W?0?g_P?oo`?_G@;W70?Nn`>440>4<0<YI@<0
808000<Q90>440=kk`=kc`?F^P;og`?oo`?og`?gWP?_G@?W?0><L@:DTP<aYP<8@@<000<080<aYPDi
a`>Ll`?W?0?oo`?og`;gWPJ]E@>]MASoo`005ooo0ooO0lHH0U[[0a2R1P000bU51H@`0mkK0nmM0ooo
0oNn0nmm0nLl0^LL0haA0bUU0`0P0`000`0P23W70icc0nLl0oNn0_oo0nmM0nLL0mkk0h@@0h@`0RUU
0`0P0`000b4T0h@@0g__0W_?0mJj0ooO0ooo0ooO0oNN0nmM0^Ll0haa0iBB0c6V0`Q10`000P0P0c6V
1SW70icc0nLl0_oo0ooO0oNN1ZeE0jee2?oo0ooO0/HH0e[[0a2R1P000bU51H@`0mkK0nmM0ooo0oNn
0^mm0nLl0nLL0haA0bUU0`0P0P000`0P2CW70icc0nLl0_Nn0ooo0nmM0nLL0mkk0h@@0X@`0bUU0`0P
0`000b4T0h@@0W__0g_?0mJj0ooO0ooo0ooO0_NN0nmM0nLl0haa0iBB0c6V0`Q10P000`0P0c6V1SW7
0icc0^Ll0ooo0ooO0oNN1ZeE0Zee2Ooo0_oO0lHH0e[[0a2R1P000RU51X@`0mkK0nmM0ooo0_Nn0nmm
0nLl0nLL0haA0bUU0P0P0`000`0P2CW70Ycc0nLl0oNn0ooo0nmM0nLL0mkk0X@@0h@`0bUU0`0P0`00
0b4T0X@@0g__0g_?0mJj0ooO0ooo0_oO0oNN0nmM0nLl0haa0iBB0S6V0`Q10`000`0P0c6V1CW70icc
0nLl0ooo0ooO0oNN1JeE0jee2?oo0ooO0lHH0e[[0a2R1@000bU51X@`0mkK0^mM0ooo0oNn0nmm0nLl
0nLL0haA0RUU0`0P0`000`0P23W70icc0nLl0oNn0ooo0nmM0^LL0mkk0h@@0h@`0bUU0`0P0P000b4T
0h@@0g__0g_?0mJj0_oO0ooo0ooO0oNN0nmM0nLl0haa0YBB0c6V0`Q10`000`0P0c6V1CW70icc0nLl
0ooo0ooO0_NN1ZeE0jee6?oo000Gool3oml3aQP2F^/34:860003:DD5Q303g]/3ked3ool3mkh3kgd3
ic`2ia`3S543:FD3020300030208>LL3W?<3ic`3mkh2ool3ked3ia`3g_/3Q103Q302:FD302030003
8B@3Q103Nnl2Nll3e[X3oml3ool3oml3mih3ked2ic`3S743U983<JH3244300020203<JH6>LL3W?<3
ic`2ool3oml3mih6[ED3[GD8ool3oml2aQP3F^/34:860003:DD5Q303g]/3ked3ool3mkh2kgd3ic`3
ia`3S543:FD3020200030209>LL3W?<3ic`2mkh3ool3ked3ia`3g_/3Q102Q303:FD3020300038B@3
Q102Nnl3Nll3e[X3oml3ool3oml2mih3ked3ic`3S743U983<JH3244200030203<JH6>LL3W?<2ic`3
ool3oml3mih6[ED2[GD9ool2oml3aQP3F^/34:860002:DD6Q303g]/3ked3ool2mkh3kgd3ic`3ia`3
S543:FD2020300030209>LL2W?<3ic`3mkh3ool3ked3ia`3g_/2Q103Q303:FD3020300038B@2Q103
Nnl3Nll3e[X3oml3ool2oml3mih3ked3ic`3S743U982<JH3244300030203<JH5>LL3W?<3ic`3ool3
oml3mih5[ED3[GD8ool3oml3aQP3F^/34:850003:DD6Q303g]/2ked3ool3mkh3kgd3ic`3ia`3S542
:FD3020300030208>LL3W?<3ic`3mkh3ool3ked2ia`3g_/3Q103Q303:FD3020200038B@3Q103Nnl3
Nll3e[X2oml3ool3oml3mih3ked3ic`3S742U983<JH3244300030203<JH5>LL3W?<3ic`3ool3oml2
mih6[ED3[GDHool001Ooo`?og`?6609Jj`<@XPH000<YA@F4<0?Nf`?_G@?oo`?g_P?_O@?W?0;W70><
D@<YI@<080<000<080Pia`>Ll`?W?0?g_P;oo`?_G@?W70?Nn`>440>4<08YI@<080<000<Q90>440=k
k`9kc`?F^P?og`?oo`?og`?gWP?_G@;W?0><L@>DTP<aYP<8@@<0008080<aYPHia`>Ll`?W?0;oo`?o
g`?gWPJ]E@>]M@Soo`?og`;660=Jj`<@XPH000<YA@F4<0?Nf`?_G@?oo`?g_P;_O@?W?0?W70><D@<Y
I@<0808000<080Tia`>Ll`?W?0;g_P?oo`?_G@?W70?Nn`>440:4<0<YI@<080<000<Q90>4409kk`=k
c`?F^P?og`?oo`?og`;gWP?_G@?W?0><L@>DTP<aYP<8@@8000<080<aYPHia`>Ll`;W?0?oo`?og`?g
WPJ]E@:]M@Woo`;og`?660=Jj`<@XPH0008YA@J4<0?Nf`?_G@?oo`;g_P?_O@?W?0?W70><D@<YI@80
80<000<080Tia`:Ll`?W?0?g_P?oo`?_G@?W70?Nn`:440>4<0<YI@<080<000<Q90:440=kk`=kc`?F
^P?og`?oo`;og`?gWP?_G@?W?0><L@>DTP8aYP<8@@<000<080<aYPDia`>Ll`?W?0?oo`?og`?gWPF]
E@>]M@Soo`?og`?660=Jj`<@XPD000<YA@J4<0?Nf`;_G@?oo`?g_P?_O@?W?0?W70><D@8YI@<080<0
00<080Pia`>Ll`?W?0?g_P?oo`?_G@;W70?Nn`>440>4<0<YI@<0808000<Q90>440=kk`=kc`?F^P;o
g`?oo`?og`?gWP?_G@?W?0><L@:DTP<aYP<8@@<000<080<aYPDia`>Ll`?W?0?oo`?og`;gWPJ]E@>]
MASoo`005ooo0ooO0lHH0U[[0a2R1P000bU51H@`0mkK0nmM0ooo0oNn0nmm0nLl0^LL0haA0bUU0`0P
0`000`0P23W70icc0nLl0oNn0_oo0nmM0nLL0mkk0h@@0h@`0RUU0`0P0`000b4T0h@@0g__0W_?0mJj
0ooO0ooo0ooO0oNN0nmM0^Ll0haa0iBB0c6V0`Q10`000P0P0c6V1SW70icc0nLl0_oo0ooO0oNN1ZeE
0jee2?oo0ooO0/HH0e[[0a2R1P000bU51H@`0mkK0nmM0ooo0oNn0^mm0nLl0nLL0haA0bUU0`0P0P00
0`0P2CW70icc0nLl0_Nn0ooo0nmM0nLL0mkk0h@@0X@`0bUU0`0P0`000b4T0h@@0W__0g_?0mJj0ooO
0ooo0ooO0_NN0nmM0nLl0haa0iBB0c6V0`Q10P000`0P0c6V1SW70icc0^Ll0ooo0ooO0oNN1ZeE0Zee
2Ooo0_oO0lHH0e[[0a2R1P000RU51X@`0mkK0nmM0ooo0_Nn0nmm0nLl0nLL0haA0bUU0P0P0`000`0P
2CW70Ycc0nLl0oNn0ooo0nmM0nLL0mkk0X@@0h@`0bUU0`0P0`000b4T0X@@0g__0g_?0mJj0ooO0ooo
0_oO0oNN0nmM0nLl0haa0iBB0S6V0`Q10`000`0P0c6V1CW70icc0nLl0ooo0ooO0oNN1JeE0jee2?oo
0ooO0lHH0e[[0a2R1@000bU51X@`0mkK0^mM0ooo0oNn0nmm0nLl0nLL0haA0RUU0`0P0`000`0P23W7
0icc0nLl0oNn0ooo0nmM0^LL0mkk0h@@0h@`0bUU0`0P0P000b4T0h@@0g__0g_?0mJj0_oO0ooo0ooO
0oNN0nmM0nLl0haa0YBB0c6V0`Q10`000`0P0c6V1CW70icc0nLl0ooo0ooO0_NN1ZeE0jee6?oo000G
ool3oml3aQP2F^/34:860003:DD5Q303g]/3ked3ool3mkh3kgd3ic`2ia`3S543:FD3020300030208
>LL3W?<3ic`3mkh2ool3ked3ia`3g_/3Q103Q302:FD3020300038B@3Q103Nnl2Nll3e[X3oml3ool3
oml3mih3ked2ic`3S743U983<JH3244300020203<JH6>LL3W?<3ic`2ool3oml3mih6[ED3[GD8ool3
oml2aQP3F^/34:860003:DD5Q303g]/3ked3ool3mkh2kgd3ic`3ia`3S543:FD3020200030209>LL3
W?<3ic`2mkh3ool3ked3ia`3g_/3Q102Q303:FD3020300038B@3Q102Nnl3Nll3e[X3oml3ool3oml2
mih3ked3ic`3S743U983<JH3244200030203<JH6>LL3W?<2ic`3ool3oml3mih6[ED2[GD9ool2oml3
aQP3F^/34:860002:DD6Q303g]/3ked3ool2mkh3kgd3ic`3ia`3S543:FD2020300030209>LL2W?<3
ic`3mkh3ool3ked3ia`3g_/2Q103Q303:FD3020300038B@2Q103Nnl3Nll3e[X3oml3ool2oml3mih3
ked3ic`3S743U982<JH3244300030203<JH5>LL3W?<3ic`3ool3oml3mih5[ED3[GD8ool3oml3aQP3
F^/34:850003:DD6Q303g]/2ked3ool3mkh3kgd3ic`3ia`3S542:FD3020300030208>LL3W?<3ic`3
mkh3ool3ked2ia`3g_/3Q103Q303:FD3020200038B@3Q103Nnl3Nll3e[X2oml3ool3oml3mih3ked3
ic`3S742U983<JH3244300030203<JH5>LL3W?<3ic`3ool3oml2mih6[ED3[GDHool001Ooo`?og`?6
609Jj`<@XPH000<YA@F4<0?Nf`?_G@?oo`?g_P?_O@?W?0;W70><D@<YI@<080<000<080Pia`>Ll`?W
?0?g_P;oo`?_G@?W70?Nn`>440>4<08YI@<080<000<Q90>440=kk`9kc`?F^P?og`?oo`?og`?gWP?_
G@;W?0><L@>DTP<aYP<8@@<0008080<aYPHia`>Ll`?W?0;oo`?og`?gWPJ]E@>]M@Soo`?og`;660=J
j`<@XPH000<YA@F4<0?Nf`?_G@?oo`?g_P;_O@?W?0?W70><D@<YI@<0808000<080Tia`>Ll`?W?0;g
_P?oo`?_G@?W70?Nn`>440:4<0<YI@<080<000<Q90>4409kk`=kc`?F^P?og`?oo`?og`;gWP?_G@?W
?0><L@>DTP<aYP<8@@8000<080<aYPHia`>Ll`;W?0?oo`?og`?gWPJ]E@:]M@Woo`;og`?660=Jj`<@
XPH0008YA@J4<0?Nf`?_G@?oo`;g_P?_O@?W?0?W70><D@<YI@8080<000<080Tia`:Ll`?W?0?g_P?o
o`?_G@?W70?Nn`:440>4<0<YI@<080<000<Q90:440=kk`=kc`?F^P?og`?oo`;og`?gWP?_G@?W?0><
L@>DTP8aYP<8@@<000<080<aYPDia`>Ll`?W?0?oo`?og`?gWPF]E@>]M@Soo`?og`?660=Jj`<@XPD0
00<YA@J4<0?Nf`;_G@?oo`?g_P?_O@?W?0?W70><D@8YI@<080<000<080Pia`>Ll`?W?0?g_P?oo`?_
G@;W70?Nn`>440>4<0<YI@<0808000<Q90>440=kk`=kc`?F^P;og`?oo`?og`?gWP?_G@?W?0><L@:D
TP<aYP<8@@<000<080<aYPDia`>Ll`?W?0?oo`?og`;gWPJ]E@>]MASoo`005ooo0ooO0lHH0U[[0a2R
1P000bU51H@`0mkK0nmM0ooo0oNn0nmm0nLl0^LL0haA0bUU0`0P0`000`0P23W70icc0nLl0oNn0_oo
0nmM0nLL0mkk0h@@0h@`0RUU0`0P0`000b4T0h@@0g__0W_?0mJj0ooO0ooo0ooO0oNN0nmM0^Ll0haa
0iBB0c6V0`Q10`000P0P0c6V1SW70icc0nLl0_oo0ooO0oNN1ZeE0jee2?oo0ooO0/HH0e[[0a2R1P00
0bU51H@`0mkK0nmM0ooo0oNn0^mm0nLl0nLL0haA0bUU0`0P0P000`0P2CW70icc0nLl0_Nn0ooo0nmM
0nLL0mkk0h@@0X@`0bUU0`0P0`000b4T0h@@0W__0g_?0mJj0ooO0ooo0ooO0_NN0nmM0nLl0haa0iBB
0c6V0`Q10P000`0P0c6V1SW70icc0^Ll0ooo0ooO0oNN1ZeE0Zee2Ooo0_oO0lHH0e[[0a2R1P000RU5
1X@`0mkK0nmM0ooo0_Nn0nmm0nLl0nLL0haA0bUU0P0P0`000`0P2CW70Ycc0nLl0oNn0ooo0nmM0nLL
0mkk0X@@0h@`0bUU0`0P0`000b4T0X@@0g__0g_?0mJj0ooO0ooo0_oO0oNN0nmM0nLl0haa0iBB0S6V
0`Q10`000`0P0c6V1CW70icc0nLl0ooo0ooO0oNN1JeE0jee2?oo0ooO0lHH0e[[0a2R1@000bU51X@`
0mkK0^mM0ooo0oNn0nmm0nLl0nLL0haA0RUU0`0P0`000`0P23W70icc0nLl0oNn0ooo0nmM0^LL0mkk
0h@@0h@`0bUU0`0P0P000b4T0h@@0g__0g_?0mJj0_oO0ooo0ooO0oNN0nmM0nLl0haa0YBB0c6V0`Q1
0`000`0P0c6V1CW70icc0nLl0ooo0ooO0_NN1ZeE0jee6?oo000Gool3oml3aQP2F^/34:860003:DD5
Q303g]/3ked3ool3mkh3kgd3ic`2ia`3S543:FD3020300030208>LL3W?<3ic`3mkh2ool3ked3ia`3
g_/3Q103Q302:FD3020300038B@3Q103Nnl2Nll3e[X3oml3ool3oml3mih3ked2ic`3S743U983<JH3
244300020203<JH6>LL3W?<3ic`2ool3oml3mih6[ED3[GD8ool3oml2aQP3F^/34:860003:DD5Q303
g]/3ked3ool3mkh2kgd3ic`3ia`3S543:FD3020200030209>LL3W?<3ic`2mkh3ool3ked3ia`3g_/3
Q102Q303:FD3020300038B@3Q102Nnl3Nll3e[X3oml3ool3oml2mih3ked3ic`3S743U983<JH32442
00030203<JH6>LL3W?<2ic`3ool3oml3mih6[ED2[GD9ool2oml3aQP3F^/34:860002:DD6Q303g]/3
ked3ool2mkh3kgd3ic`3ia`3S543:FD2020300030209>LL2W?<3ic`3mkh3ool3ked3ia`3g_/2Q103
Q303:FD3020300038B@2Q103Nnl3Nll3e[X3oml3ool2oml3mih3ked3ic`3S743U982<JH324430003
0203<JH5>LL3W?<3ic`3ool3oml3mih5[ED3[GD8ool3oml3aQP3F^/34:850003:DD6Q303g]/2ked3
ool3mkh3kgd3ic`3ia`3S542:FD3020300030208>LL3W?<3ic`3mkh3ool3ked2ia`3g_/3Q103Q303
:FD3020200038B@3Q103Nnl3Nll3e[X2oml3ool3oml3mih3ked3ic`3S742U983<JH3244300030203
<JH5>LL3W?<3ic`3ool3oml2mih6[ED3[GDHool001Ooo`?og`?6609Jj`<@XPH000<YA@F4<0?Nf`?_
G@?oo`?g_P?_O@?W?0;W70><D@<YI@<080<000<080Pia`>Ll`?W?0?g_P;oo`?_G@?W70?Nn`>440>4
<08YI@<080<000<Q90>440=kk`9kc`?F^P?og`?oo`?og`?gWP?_G@;W?0><L@>DTP<aYP<8@@<00080
80<aYPHia`>Ll`?W?0;oo`?og`?gWPJ]E@>]M@Soo`?og`;660=Jj`<@XPH000<YA@F4<0?Nf`?_G@?o
o`?g_P;_O@?W?0?W70><D@<YI@<0808000<080Tia`>Ll`?W?0;g_P?oo`?_G@?W70?Nn`>440:4<0<Y
I@<080<000<Q90>4409kk`=kc`?F^P?og`?oo`?og`;gWP?_G@?W?0><L@>DTP<aYP<8@@8000<080<a
YPHia`>Ll`;W?0?oo`?og`?gWPJ]E@:]M@Woo`;og`?660=Jj`<@XPH0008YA@J4<0?Nf`?_G@?oo`;g
_P?_O@?W?0?W70><D@<YI@8080<000<080Tia`:Ll`?W?0?g_P?oo`?_G@?W70?Nn`:440>4<0<YI@<0
80<000<Q90:440=kk`=kc`?F^P?og`?oo`;og`?gWP?_G@?W?0><L@>DTP8aYP<8@@<000<080<aYPDi
a`>Ll`?W?0?oo`?og`?gWPF]E@>]M@Soo`?og`?660=Jj`<@XPD000<YA@J4<0?Nf`;_G@?oo`?g_P?_
O@?W?0?W70><D@8YI@<080<000<080Pia`>Ll`?W?0?g_P?oo`?_G@;W70?Nn`>440>4<0<YI@<08080
00<Q90>440=kk`=kc`?F^P;og`?oo`?og`?gWP?_G@?W?0><L@:DTP<aYP<8@@<000<080<aYPDia`>L
l`?W?0?oo`?og`;gWPJ]E@>]MASoo`005ooo0ooO0lHH0U[[0a2R1P000bU51H@`0mkK0nmM0ooo0oNn
0nmm0nLl0^LL0haA0bUU0`0P0`000`0P23W70icc0nLl0oNn0_oo0nmM0nLL0mkk0h@@0h@`0RUU0`0P
0`000b4T0h@@0g__0W_?0mJj0ooO0ooo0ooO0oNN0nmM0^Ll0haa0iBB0c6V0`Q10`000P0P0c6V1SW7
0icc0nLl0_oo0ooO0oNN1ZeE0jee2?oo0ooO0/HH0e[[0a2R1P000bU51H@`0mkK0nmM0ooo0oNn0^mm
0nLl0nLL0haA0bUU0`0P0P000`0P2CW70icc0nLl0_Nn0ooo0nmM0nLL0mkk0h@@0X@`0bUU0`0P0`00
0b4T0h@@0W__0g_?0mJj0ooO0ooo0ooO0_NN0nmM0nLl0haa0iBB0c6V0`Q10P000`0P0c6V1SW70icc
0^Ll0ooo0ooO0oNN1ZeE0Zee2Ooo0_oO0lHH0e[[0a2R1P000RU51X@`0mkK0nmM0ooo0_Nn0nmm0nLl
0nLL0haA0bUU0P0P0`000`0P2CW70Ycc0nLl0oNn0ooo0nmM0nLL0mkk0X@@0h@`0bUU0`0P0`000b4T
0X@@0g__0g_?0mJj0ooO0ooo0_oO0oNN0nmM0nLl0haa0iBB0S6V0`Q10`000`0P0c6V1CW70icc0nLl
0ooo0ooO0oNN1JeE0jee2?oo0ooO0lHH0e[[0a2R1@000bU51X@`0mkK0^mM0ooo0oNn0nmm0nLl0nLL
0haA0RUU0`0P0`000`0P23W70icc0nLl0oNn0ooo0nmM0^LL0mkk0h@@0h@`0bUU0`0P0P000b4T0h@@
0g__0g_?0mJj0_oO0ooo0ooO0oNN0nmM0nLl0haa0YBB0c6V0`Q10`000`0P0c6V1CW70icc0nLl0ooo
0ooO0_NN1ZeE0jee6?oo000Gool3BTT3264500038B@3:DD3:FD3S742g_/6ool3g_/3g]/6Nnl2:DD3
020300036><38@@38B@2Q303g]/3oml3ool3mkh3kgd2YA@3YC@3@PP3>LL3:FD3020200036<<3Jfd3
cWT3g]/3oml2ool3mkh3kgd3YA@3@PP326450003244348836<<36><3Nll2eYX3ia`6ool3oml3mih2
ked3ia`3g_/3Q103Q303:FD8ool3BTT2264600038B@3:DD3:FD2S743g_/6ool3g_/3g]/5Nnl3:DD3
020300036><28@@38B@3Q303g]/3oml3ool3mkh2kgd3YA@3YC@3@PP3>LL3:FD2020300036<<3Jfd3
cWT3g]/2oml3ool3mkh3kgd3YA@3@PP226460003244348836<<36><2Nll3eYX3ia`6ool3oml2mih3
ked3ia`3g_/3Q103Q302:FD9ool2BTT3264600038B@3:DD2:FD3S743g_/6ool3g_/2g]/6Nnl3:DD3
020300026><38@@38B@3Q303g]/3oml2ool3mkh3kgd3YA@3YC@3@PP3>LL2:FD3020300036<<3Jfd3
cWT2g]/3oml3ool3mkh3kgd3YA@2@PP326460003244348826<<36><3Nll3eYX3ia`5ool3oml3mih3
ked3ia`3g_/3Q102Q303:FD8ool3BTT3264600028B@3:DD3:FD3S743g_/5ool3g_/3g]/6Nnl3:DD3
020200036><38@@38B@3Q303g]/2oml3ool3mkh3kgd3YA@3YC@2@PP3>LL3:FD3020300036<<2Jfd3
cWT3g]/3oml3ool3mkh2kgd3YA@3@PP326460003244248836<<36><3Nll3eYX3ia`5ool3oml3mih3
ked3ia`2g_/3Q103Q303:FDHool001Ooo`=:B@<8H@D000<Q90<YA@<YI@><L@;Nn`Koo`?Nn`?Nf`Ik
k`8YA@<080<000<Hh`<Q10<Q90:4<0?Nf`?og`?oo`?g_P?_O@:U50>U=0=220<ia`<YI@<0808000<H
``=[K@?>N@?Nf`?og`;oo`?g_P?_O@>U50=220<8H@D000<8@@<@PP<H``<Hh`=kc`;FVP?W70Koo`?o
g`?gWP;_G@?W70?Nn`>440>4<0<YI@Soo`=:B@88H@H000<Q90<YA@<YI@:<L@?Nn`Koo`?Nn`?Nf`Ek
k`<YA@<080<000<Hh`8Q10<Q90>4<0?Nf`?og`?oo`?g_P;_O@>U50>U=0=220<ia`<YI@8080<000<H
``=[K@?>N@?Nf`;og`?oo`?g_P?_O@>U50=22088H@H000<8@@<@PP<H``<Hh`9kc`?FVP?W70Koo`?o
g`;gWP?_G@?W70?Nn`>440>4<08YI@Woo`9:B@<8H@H000<Q90<YA@8YI@><L@?Nn`Koo`?Nn`;Nf`Ik
k`<YA@<080<0008Hh`<Q10<Q90>4<0?Nf`?og`;oo`?g_P?_O@>U50>U=0=220<ia`8YI@<080<000<H
``=[K@?>N@;Nf`?og`?oo`?g_P?_O@>U509220<8H@H000<8@@<@PP8H``<Hh`=kc`?FVP?W70Goo`?o
g`?gWP?_G@?W70?Nn`>440:4<0<YI@Soo`=:B@<8H@H0008Q90<YA@<YI@><L@?Nn`Goo`?Nn`?Nf`Ik
k`<YA@<0808000<Hh`<Q10<Q90>4<0?Nf`;og`?oo`?g_P?_O@>U50>U=09220<ia`<YI@<080<000<H
``9[K@?>N@?Nf`?og`?oo`?g_P;_O@>U50=220<8H@H000<8@@8@PP<H``<Hh`=kc`?FVP?W70Goo`?o
g`?gWP?_G@?W70;Nn`>440>4<0<YIASoo`005ooo0dY90`QQ1@000b4T0bU50bUU0haa0]kk1_oo0mkk
0mkK1W__0RU50`0P0`000aSS0b440b4T0X@`0mkK0ooO0ooo0oNn0nmm0ZDD0jDd0d880cW70bUU0`0P
0P000aS30f]]0lii0mkK0ooO0_oo0oNn0nmm0jDD0d880`QQ1@000`Q10a220aS30aSS0g_?0]JJ0nLL
1_oo0ooO0oNN0^mM0nLL0mkk0h@@0h@`0bUU2?oo0dY90PQQ1P000b4T0bU50bUU0Xaa0mkk1_oo0mkk
0mkK1G__0bU50`0P0`000aSS0R440b4T0h@`0mkK0ooO0ooo0oNn0^mm0jDD0jDd0d880cW70bUU0P0P
0`000aS30f]]0lii0mkK0_oO0ooo0oNn0nmm0jDD0d880PQQ1P000`Q10a220aS30aSS0W_?0mJJ0nLL
1_oo0ooO0_NN0nmM0nLL0mkk0h@@0h@`0RUU2Ooo0TY90`QQ1P000b4T0bU50RUU0haa0mkk1_oo0mkk
0]kK1W__0bU50`0P0`000QSS0b440b4T0h@`0mkK0ooO0_oo0oNn0nmm0jDD0jDd0d880cW70RUU0`0P
0`000aS30f]]0lii0]kK0ooO0ooo0oNn0nmm0jDD0T880`QQ1P000`Q10a220QS30aSS0g_?0mJJ0nLL
1Ooo0ooO0oNN0nmM0nLL0mkk0h@@0X@`0bUU2?oo0dY90`QQ1P000R4T0bU50bUU0haa0mkk1Ooo0mkk
0mkK1W__0bU50`0P0P000aSS0b440b4T0h@`0mkK0_oO0ooo0oNn0nmm0jDD0jDd0T880cW70bUU0`0P
0`000aS30V]]0lii0mkK0ooO0ooo0oNn0^mm0jDD0d880`QQ1P000`Q10Q220aS30aSS0g_?0mJJ0nLL
1Ooo0ooO0oNN0nmM0nLL0]kk0h@@0h@`0bUU6?oo000Gool3BTT3264500038B@3:DD3:FD3S742g_/6
ool3g_/3g]/6Nnl2:DD3020300036><38@@38B@2Q303g]/3oml3ool3mkh3kgd2YA@3YC@3@PP3>LL3
:FD3020200036<<3Jfd3cWT3g]/3oml2ool3mkh3kgd3YA@3@PP326450003244348836<<36><3Nll2
eYX3ia`6ool3oml3mih2ked3ia`3g_/3Q103Q303:FD8ool3BTT2264600038B@3:DD3:FD2S743g_/6
ool3g_/3g]/5Nnl3:DD3020300036><28@@38B@3Q303g]/3oml3ool3mkh2kgd3YA@3YC@3@PP3>LL3
:FD2020300036<<3Jfd3cWT3g]/2oml3ool3mkh3kgd3YA@3@PP226460003244348836<<36><2Nll3
eYX3ia`6ool3oml2mih3ked3ia`3g_/3Q103Q302:FD9ool2BTT3264600038B@3:DD2:FD3S743g_/6
ool3g_/2g]/6Nnl3:DD3020300026><38@@38B@3Q303g]/3oml2ool3mkh3kgd3YA@3YC@3@PP3>LL2
:FD3020300036<<3Jfd3cWT2g]/3oml3ool3mkh3kgd3YA@2@PP326460003244348826<<36><3Nll3
eYX3ia`5ool3oml3mih3ked3ia`3g_/3Q102Q303:FD8ool3BTT3264600028B@3:DD3:FD3S743g_/5
ool3g_/3g]/6Nnl3:DD3020200036><38@@38B@3Q303g]/2oml3ool3mkh3kgd3YA@3YC@2@PP3>LL3
:FD3020300036<<2Jfd3cWT3g]/3oml3ool3mkh2kgd3YA@3@PP326460003244248836<<36><3Nll3
eYX3ia`5ool3oml3mih3ked3ia`2g_/3Q103Q303:FDHool001Ooo`=:B@<8H@D000<Q90<YA@<YI@><
L@;Nn`Koo`?Nn`?Nf`Ikk`8YA@<080<000<Hh`<Q10<Q90:4<0?Nf`?og`?oo`?g_P?_O@:U50>U=0=2
20<ia`<YI@<0808000<H``=[K@?>N@?Nf`?og`;oo`?g_P?_O@>U50=220<8H@D000<8@@<@PP<H``<H
h`=kc`;FVP?W70Koo`?og`?gWP;_G@?W70?Nn`>440>4<0<YI@Soo`=:B@88H@H000<Q90<YA@<YI@:<
L@?Nn`Koo`?Nn`?Nf`Ekk`<YA@<080<000<Hh`8Q10<Q90>4<0?Nf`?og`?oo`?g_P;_O@>U50>U=0=2
20<ia`<YI@8080<000<H``=[K@?>N@?Nf`;og`?oo`?g_P?_O@>U50=22088H@H000<8@@<@PP<H``<H
h`9kc`?FVP?W70Koo`?og`;gWP?_G@?W70?Nn`>440>4<08YI@Woo`9:B@<8H@H000<Q90<YA@8YI@><
L@?Nn`Koo`?Nn`;Nf`Ikk`<YA@<080<0008Hh`<Q10<Q90>4<0?Nf`?og`;oo`?g_P?_O@>U50>U=0=2
20<ia`8YI@<080<000<H``=[K@?>N@;Nf`?og`?oo`?g_P?_O@>U509220<8H@H000<8@@<@PP8H``<H
h`=kc`?FVP?W70Goo`?og`?gWP?_G@?W70?Nn`>440:4<0<YI@Soo`=:B@<8H@H0008Q90<YA@<YI@><
L@?Nn`Goo`?Nn`?Nf`Ikk`<YA@<0808000<Hh`<Q10<Q90>4<0?Nf`;og`?oo`?g_P?_O@>U50>U=092
20<ia`<YI@<080<000<H``9[K@?>N@?Nf`?og`?oo`?g_P;_O@>U50=220<8H@H000<8@@8@PP<H``<H
h`=kc`?FVP?W70Goo`?og`?gWP?_G@?W70;Nn`>440>4<0<YIASoo`005ooo0dY90`QQ1@000b4T0bU5
0bUU0haa0]kk1_oo0mkk0mkK1W__0RU50`0P0`000aSS0b440b4T0X@`0mkK0ooO0ooo0oNn0nmm0ZDD
0jDd0d880cW70bUU0`0P0P000aS30f]]0lii0mkK0ooO0_oo0oNn0nmm0jDD0d880`QQ1@000`Q10a22
0aS30aSS0g_?0]JJ0nLL1_oo0ooO0oNN0^mM0nLL0mkk0h@@0h@`0bUU2?oo0dY90PQQ1P000b4T0bU5
0bUU0Xaa0mkk1_oo0mkk0mkK1G__0bU50`0P0`000aSS0R440b4T0h@`0mkK0ooO0ooo0oNn0^mm0jDD
0jDd0d880cW70bUU0P0P0`000aS30f]]0lii0mkK0_oO0ooo0oNn0nmm0jDD0d880PQQ1P000`Q10a22
0aS30aSS0W_?0mJJ0nLL1_oo0ooO0_NN0nmM0nLL0mkk0h@@0h@`0RUU2Ooo0TY90`QQ1P000b4T0bU5
0RUU0haa0mkk1_oo0mkk0]kK1W__0bU50`0P0`000QSS0b440b4T0h@`0mkK0ooO0_oo0oNn0nmm0jDD
0jDd0d880cW70RUU0`0P0`000aS30f]]0lii0]kK0ooO0ooo0oNn0nmm0jDD0T880`QQ1P000`Q10a22
0QS30aSS0g_?0mJJ0nLL1Ooo0ooO0oNN0nmM0nLL0mkk0h@@0X@`0bUU2?oo0dY90`QQ1P000R4T0bU5
0bUU0haa0mkk1Ooo0mkk0mkK1W__0bU50`0P0P000aSS0b440b4T0h@`0mkK0_oO0ooo0oNn0nmm0jDD
0jDd0T880cW70bUU0`0P0`000aS30V]]0lii0mkK0ooO0ooo0oNn0^mm0jDD0d880`QQ1P000`Q10Q22
0aS30aSS0g_?0mJJ0nLL1Ooo0ooO0oNN0nmM0nLL0]kk0h@@0h@`0bUU6?oo000Gool3BTT326450003
8B@3:DD3:FD3S742g_/6ool3g_/3g]/6Nnl2:DD3020300036><38@@38B@2Q303g]/3oml3ool3mkh3
kgd2YA@3YC@3@PP3>LL3:FD3020200036<<3Jfd3cWT3g]/3oml2ool3mkh3kgd3YA@3@PP326450003
244348836<<36><3Nll2eYX3ia`6ool3oml3mih2ked3ia`3g_/3Q103Q303:FD8ool3BTT226460003
8B@3:DD3:FD2S743g_/6ool3g_/3g]/5Nnl3:DD3020300036><28@@38B@3Q303g]/3oml3ool3mkh2
kgd3YA@3YC@3@PP3>LL3:FD2020300036<<3Jfd3cWT3g]/2oml3ool3mkh3kgd3YA@3@PP226460003
244348836<<36><2Nll3eYX3ia`6ool3oml2mih3ked3ia`3g_/3Q103Q302:FD9ool2BTT326460003
8B@3:DD2:FD3S743g_/6ool3g_/2g]/6Nnl3:DD3020300026><38@@38B@3Q303g]/3oml2ool3mkh3
kgd3YA@3YC@3@PP3>LL2:FD3020300036<<3Jfd3cWT2g]/3oml3ool3mkh3kgd3YA@2@PP326460003
244348826<<36><3Nll3eYX3ia`5ool3oml3mih3ked3ia`3g_/3Q102Q303:FD8ool3BTT326460002
8B@3:DD3:FD3S743g_/5ool3g_/3g]/6Nnl3:DD3020200036><38@@38B@3Q303g]/2oml3ool3mkh3
kgd3YA@3YC@2@PP3>LL3:FD3020300036<<2Jfd3cWT3g]/3oml3ool3mkh2kgd3YA@3@PP326460003
244248836<<36><3Nll3eYX3ia`5ool3oml3mih3ked3ia`2g_/3Q103Q303:FDHool001Ooo`=:B@<8
H@D000<Q90<YA@<YI@><L@;Nn`Koo`?Nn`?Nf`Ikk`8YA@<080<000<Hh`<Q10<Q90:4<0?Nf`?og`?o
o`?g_P?_O@:U50>U=0=220<ia`<YI@<0808000<H``=[K@?>N@?Nf`?og`;oo`?g_P?_O@>U50=220<8
H@D000<8@@<@PP<H``<Hh`=kc`;FVP?W70Koo`?og`?gWP;_G@?W70?Nn`>440>4<0<YI@Soo`=:B@88
H@H000<Q90<YA@<YI@:<L@?Nn`Koo`?Nn`?Nf`Ekk`<YA@<080<000<Hh`8Q10<Q90>4<0?Nf`?og`?o
o`?g_P;_O@>U50>U=0=220<ia`<YI@8080<000<H``=[K@?>N@?Nf`;og`?oo`?g_P?_O@>U50=22088
H@H000<8@@<@PP<H``<Hh`9kc`?FVP?W70Koo`?og`;gWP?_G@?W70?Nn`>440>4<08YI@Woo`9:B@<8
H@H000<Q90<YA@8YI@><L@?Nn`Koo`?Nn`;Nf`Ikk`<YA@<080<0008Hh`<Q10<Q90>4<0?Nf`?og`;o
o`?g_P?_O@>U50>U=0=220<ia`8YI@<080<000<H``=[K@?>N@;Nf`?og`?oo`?g_P?_O@>U509220<8
H@H000<8@@<@PP8H``<Hh`=kc`?FVP?W70Goo`?og`?gWP?_G@?W70?Nn`>440:4<0<YI@Soo`=:B@<8
H@H0008Q90<YA@<YI@><L@?Nn`Goo`?Nn`?Nf`Ikk`<YA@<0808000<Hh`<Q10<Q90>4<0?Nf`;og`?o
o`?g_P?_O@>U50>U=09220<ia`<YI@<080<000<H``9[K@?>N@?Nf`?og`?oo`?g_P;_O@>U50=220<8
H@H000<8@@8@PP<H``<Hh`=kc`?FVP?W70Goo`?og`?gWP?_G@?W70;Nn`>440>4<0<YIASoo`005ooo
0dY90`QQ1@000b4T0bU50bUU0haa0]kk1_oo0mkk0mkK1W__0RU50`0P0`000aSS0b440b4T0X@`0mkK
0ooO0ooo0oNn0nmm0ZDD0jDd0d880cW70bUU0`0P0P000aS30f]]0lii0mkK0ooO0_oo0oNn0nmm0jDD
0d880`QQ1@000`Q10a220aS30aSS0g_?0]JJ0nLL1_oo0ooO0oNN0^mM0nLL0mkk0h@@0h@`0bUU2?oo
0dY90PQQ1P000b4T0bU50bUU0Xaa0mkk1_oo0mkk0mkK1G__0bU50`0P0`000aSS0R440b4T0h@`0mkK
0ooO0ooo0oNn0^mm0jDD0jDd0d880cW70bUU0P0P0`000aS30f]]0lii0mkK0_oO0ooo0oNn0nmm0jDD
0d880PQQ1P000`Q10a220aS30aSS0W_?0mJJ0nLL1_oo0ooO0_NN0nmM0nLL0mkk0h@@0h@`0RUU2Ooo
0TY90`QQ1P000b4T0bU50RUU0haa0mkk1_oo0mkk0]kK1W__0bU50`0P0`000QSS0b440b4T0h@`0mkK
0ooO0_oo0oNn0nmm0jDD0jDd0d880cW70RUU0`0P0`000aS30f]]0lii0]kK0ooO0ooo0oNn0nmm0jDD
0T880`QQ1P000`Q10a220QS30aSS0g_?0mJJ0nLL1Ooo0ooO0oNN0nmM0nLL0mkk0h@@0X@`0bUU2?oo
0dY90`QQ1P000R4T0bU50bUU0haa0mkk1Ooo0mkk0mkK1W__0bU50`0P0P000aSS0b440b4T0h@`0mkK
0_oO0ooo0oNn0nmm0jDD0jDd0T880cW70bUU0`0P0`000aS30V]]0lii0mkK0ooO0ooo0oNn0^mm0jDD
0d880`QQ1P000`Q10Q220aS30aSS0g_?0mJJ0nLL1Ooo0ooO0oNN0nmM0nLL0]kk0h@@0h@`0bUU6?oo
000Gool3BTT3264500038B@3:DD3:FD3S742g_/6ool3g_/3g]/6Nnl2:DD3020300036><38@@38B@2
Q303g]/3oml3ool3mkh3kgd2YA@3YC@3@PP3>LL3:FD3020200036<<3Jfd3cWT3g]/3oml2ool3mkh3
kgd3YA@3@PP326450003244348836<<36><3Nll2eYX3ia`6ool3oml3mih2ked3ia`3g_/3Q103Q303
:FD8ool3BTT2264600038B@3:DD3:FD2S743g_/6ool3g_/3g]/5Nnl3:DD3020300036><28@@38B@3
Q303g]/3oml3ool3mkh2kgd3YA@3YC@3@PP3>LL3:FD2020300036<<3Jfd3cWT3g]/2oml3ool3mkh3
kgd3YA@3@PP226460003244348836<<36><2Nll3eYX3ia`6ool3oml2mih3ked3ia`3g_/3Q103Q302
:FD9ool2BTT3264600038B@3:DD2:FD3S743g_/6ool3g_/2g]/6Nnl3:DD3020300026><38@@38B@3
Q303g]/3oml2ool3mkh3kgd3YA@3YC@3@PP3>LL2:FD3020300036<<3Jfd3cWT2g]/3oml3ool3mkh3
kgd3YA@2@PP326460003244348826<<36><3Nll3eYX3ia`5ool3oml3mih3ked3ia`3g_/3Q102Q303
:FD8ool3BTT3264600028B@3:DD3:FD3S743g_/5ool3g_/3g]/6Nnl3:DD3020200036><38@@38B@3
Q303g]/2oml3ool3mkh3kgd3YA@3YC@2@PP3>LL3:FD3020300036<<2Jfd3cWT3g]/3oml3ool3mkh2
kgd3YA@3@PP326460003244248836<<36><3Nll3eYX3ia`5ool3oml3mih3ked3ia`2g_/3Q103Q303
:FDHool001Ooo`=:B@<8H@D000<Q90<YA@<YI@><L@;Nn`Koo`?Nn`?Nf`Ikk`8YA@<080<000<Hh`<Q
10<Q90:4<0?Nf`?og`?oo`?g_P?_O@:U50>U=0=220<ia`<YI@<0808000<H``=[K@?>N@?Nf`?og`;o
o`?g_P?_O@>U50=220<8H@D000<8@@<@PP<H``<Hh`=kc`;FVP?W70Koo`?og`?gWP;_G@?W70?Nn`>4
40>4<0<YI@Soo`=:B@88H@H000<Q90<YA@<YI@:<L@?Nn`Koo`?Nn`?Nf`Ekk`<YA@<080<000<Hh`8Q
10<Q90>4<0?Nf`?og`?oo`?g_P;_O@>U50>U=0=220<ia`<YI@8080<000<H``=[K@?>N@?Nf`;og`?o
o`?g_P?_O@>U50=22088H@H000<8@@<@PP<H``<Hh`9kc`?FVP?W70Koo`?og`;gWP?_G@?W70?Nn`>4
40>4<08YI@Woo`9:B@<8H@H000<Q90<YA@8YI@><L@?Nn`Koo`?Nn`;Nf`Ikk`<YA@<080<0008Hh`<Q
10<Q90>4<0?Nf`?og`;oo`?g_P?_O@>U50>U=0=220<ia`8YI@<080<000<H``=[K@?>N@;Nf`?og`?o
o`?g_P?_O@>U509220<8H@H000<8@@<@PP8H``<Hh`=kc`?FVP?W70Goo`?og`?gWP?_G@?W70?Nn`>4
40:4<0<YI@Soo`=:B@<8H@H0008Q90<YA@<YI@><L@?Nn`Goo`?Nn`?Nf`Ikk`<YA@<0808000<Hh`<Q
10<Q90>4<0?Nf`;og`?oo`?g_P?_O@>U50>U=09220<ia`<YI@<080<000<H``9[K@?>N@?Nf`?og`?o
o`?g_P;_O@>U50=220<8H@H000<8@@8@PP<H``<Hh`=kc`?FVP?W70Goo`?og`?gWP?_G@?W70;Nn`>4
40>4<0<YIASoo`005ooo0dY90`QQ1@000b4T0bU50bUU0haa0]kk1_oo0mkk0mkK1W__0RU50`0P0`00
0aSS0b440b4T0X@`0mkK0ooO0ooo0oNn0nmm0ZDD0jDd0d880cW70bUU0`0P0P000aS30f]]0lii0mkK
0ooO0_oo0oNn0nmm0jDD0d880`QQ1@000`Q10a220aS30aSS0g_?0]JJ0nLL1_oo0ooO0oNN0^mM0nLL
0mkk0h@@0h@`0bUU2?oo0dY90PQQ1P000b4T0bU50bUU0Xaa0mkk1_oo0mkk0mkK1G__0bU50`0P0`00
0aSS0R440b4T0h@`0mkK0ooO0ooo0oNn0^mm0jDD0jDd0d880cW70bUU0P0P0`000aS30f]]0lii0mkK
0_oO0ooo0oNn0nmm0jDD0d880PQQ1P000`Q10a220aS30aSS0W_?0mJJ0nLL1_oo0ooO0_NN0nmM0nLL
0mkk0h@@0h@`0RUU2Ooo0TY90`QQ1P000b4T0bU50RUU0haa0mkk1_oo0mkk0]kK1W__0bU50`0P0`00
0QSS0b440b4T0h@`0mkK0ooO0_oo0oNn0nmm0jDD0jDd0d880cW70RUU0`0P0`000aS30f]]0lii0]kK
0ooO0ooo0oNn0nmm0jDD0T880`QQ1P000`Q10a220QS30aSS0g_?0mJJ0nLL1Ooo0ooO0oNN0nmM0nLL
0mkk0h@@0X@`0bUU2?oo0dY90`QQ1P000R4T0bU50bUU0haa0mkk1Ooo0mkk0mkK1W__0bU50`0P0P00
0aSS0b440b4T0h@`0mkK0_oO0ooo0oNn0nmm0jDD0jDd0T880cW70bUU0`0P0`000aS30V]]0lii0mkK
0ooO0ooo0oNn0^mm0jDD0d880`QQ1P000`Q10Q220aS30aSS0g_?0mJJ0nLL1Ooo0ooO0oNN0nmM0nLL
0]kk0h@@0h@`0bUU6?oo000Gool3020300020206@PP3YC@3ked3ool2mkh3kgd3YA@3@PP3<JH3:DD3
020200032443@PP3[ED3ked3oml2ool3ia`3S543S743<HH38B@202030003020326434:836><2Lhh3
Jfd3cWT3mkh3ool3oml2mih3[GD3BTT3@PP3264600022443BVT3]IH3kgd6ool2eYX9cWT3Jdd36><5
00030203@PP3YC@3[ED8ool3020200030206@PP3YC@3ked2ool3mkh3kgd3YA@3@PP3<JH2:DD30203
00032443@PP3[ED2ked3oml3ool3ia`3S543S743<HH28B@302030003020326434:826><3Lhh3Jfd3
cWT3mkh3ool2oml3mih3[GD3BTT3@PP3264500032443BVT3]IH3kgd5ool3eYX9cWT3Jdd26><60003
0203@PP3YC@2[ED9ool2020300030206@PP3YC@2ked3ool3mkh3kgd3YA@3@PP2<JH3:DD302030003
2443@PP2[ED3ked3oml3ool3ia`3S542S743<HH38B@302030003020326424:836><3Lhh3Jfd3cWT3
mkh2ool3oml3mih3[GD3BTT3@PP2264600032443BVT3]IH2kgd6ool3eYX8cWT3Jdd36><600030203
@PP2YC@3[ED8ool3020300030205@PP3YC@3ked3ool3mkh3kgd2YA@3@PP3<JH3:DD3020300032442
@PP3[ED3ked3oml3ool3ia`2S543S743<HH38B@302030002020326434:836><3Lhh3Jfd2cWT3mkh3
ool3oml3mih3[GD2BTT3@PP3264600032443BVT2]IH3kgd6ool3eYX8cWT3Jdd36><600020203@PP3
YC@3[EDHool001Ooo`<080<0008080I220>U=0?_G@?oo`;g_P?_O@>U50=220<aYP<YA@<0808000<8
@@=220>]E@?_G@?og`;oo`?W70><D@><L@<aQP<Q908080<000<080<8H@<@XP<Hh`9cSP=[K@?>N@?g
_P?oo`?og`;gWP>]M@=:B@=220<8H@H00088@@=:J@>eUP?_O@Koo`;FVPW>N@=[C@<Hh`D000<080=2
20>U=0>]E@Soo`<0808000<080I220>U=0?_G@;oo`?g_P?_O@>U50=220<aYP8YA@<080<000<8@@=2
20>]E@;_G@?og`?oo`?W70><D@><L@<aQP8Q90<080<000<080<8H@<@XP8Hh`=cSP=[K@?>N@?g_P?o
o`;og`?gWP>]M@=:B@=220<8H@D000<8@@=:J@>eUP?_O@Goo`?FVPW>N@=[C@8Hh`H000<080=220>U
=0:]E@Woo`8080<000<080I220>U=0;_G@?oo`?g_P?_O@>U50=2208aYP<YA@<080<000<8@@=220:]
E@?_G@?og`?oo`?W70><D@:<L@<aQP<Q90<080<000<080<8H@8@XP<Hh`=cSP=[K@?>N@?g_P;oo`?o
g`?gWP>]M@=:B@=22088H@H000<8@@=:J@>eUP;_O@Koo`?FVPS>N@=[C@<Hh`H000<080=220:U=0>]
E@Soo`<080<000<080E220>U=0?_G@?oo`?g_P?_O@:U50=220<aYP<YA@<080<000<8@@9220>]E@?_
G@?og`?oo`?W70:<D@><L@<aQP<Q90<080<0008080<8H@<@XP<Hh`=cSP=[K@;>N@?g_P?oo`?og`?g
WP>]M@9:B@=220<8H@H000<8@@=:J@:eUP?_O@Koo`?FVPS>N@=[C@<Hh`H0008080=220>U=0>]EASo
o`005ooo0`0P0`000P0P1T880jDd0nmM0ooo0_Nn0nmm0jDD0d880c6V0bU50`0P0P000`Q10d880jeE
0nmM0ooO0_oo0nLL0haA0haa0c660b4T0P0P0`000`0P0`QQ0a2R0aSS0W>>0f]]0lii0oNn0ooo0ooO
0_NN0jee0dY90d880`QQ1P000PQ10dYY0kFF0nmm1_oo0]JJ2Lii0f]=0aSS1@000`0P0d880jDd0jeE
2?oo0`0P0P000`0P1T880jDd0nmM0_oo0oNn0nmm0jDD0d880c6V0RU50`0P0`000`Q10d880jeE0^mM
0ooO0ooo0nLL0haA0haa0c660R4T0`0P0`000`0P0`QQ0a2R0QSS0g>>0f]]0lii0oNn0ooo0_oO0oNN
0jee0dY90d880`QQ1@000`Q10dYY0kFF0nmm1Ooo0mJJ2Lii0f]=0QSS1P000`0P0d880jDd0ZeE2Ooo
0P0P0`000`0P1T880jDd0^mM0ooo0oNn0nmm0jDD0d880S6V0bU50`0P0`000`Q10d880ZeE0nmM0ooO
0ooo0nLL0haA0Xaa0c660b4T0`0P0`000`0P0`QQ0Q2R0aSS0g>>0f]]0lii0oNn0_oo0ooO0oNN0jee
0dY90d880PQQ1P000`Q10dYY0kFF0^mm1_oo0mJJ2<ii0f]=0aSS1P000`0P0d880ZDd0jeE2?oo0`0P
0`000`0P1D880jDd0nmM0ooo0oNn0nmm0ZDD0d880c6V0bU50`0P0`000`Q10T880jeE0nmM0ooO0ooo
0nLL0XaA0haa0c660b4T0`0P0`000P0P0`QQ0a2R0aSS0g>>0f]]0/ii0oNn0ooo0ooO0oNN0jee0TY9
0d880`QQ1P000`Q10dYY0[FF0nmm1_oo0mJJ2<ii0f]=0aSS1P000P0P0d880jDd0jeE6?oo000Gool3
020300020206@PP3YC@3ked3ool2mkh3kgd3YA@3@PP3<JH3:DD3020200032443@PP3[ED3ked3oml2
ool3ia`3S543S743<HH38B@202030003020326434:836><2Lhh3Jfd3cWT3mkh3ool3oml2mih3[GD3
BTT3@PP3264600022443BVT3]IH3kgd6ool2eYX9cWT3Jdd36><500030203@PP3YC@3[ED8ool30202
00030206@PP3YC@3ked2ool3mkh3kgd3YA@3@PP3<JH2:DD3020300032443@PP3[ED2ked3oml3ool3
ia`3S543S743<HH28B@302030003020326434:826><3Lhh3Jfd3cWT3mkh3ool2oml3mih3[GD3BTT3
@PP3264500032443BVT3]IH3kgd5ool3eYX9cWT3Jdd26><600030203@PP3YC@2[ED9ool202030003
0206@PP3YC@2ked3ool3mkh3kgd3YA@3@PP2<JH3:DD3020300032443@PP2[ED3ked3oml3ool3ia`3
S542S743<HH38B@302030003020326424:836><3Lhh3Jfd3cWT3mkh2ool3oml3mih3[GD3BTT3@PP2
264600032443BVT3]IH2kgd6ool3eYX8cWT3Jdd36><600030203@PP2YC@3[ED8ool3020300030205
@PP3YC@3ked3ool3mkh3kgd2YA@3@PP3<JH3:DD3020300032442@PP3[ED3ked3oml3ool3ia`2S543
S743<HH38B@302030002020326434:836><3Lhh3Jfd2cWT3mkh3ool3oml3mih3[GD2BTT3@PP32646
00032443BVT2]IH3kgd6ool3eYX8cWT3Jdd36><600020203@PP3YC@3[EDHool001Ooo`<080<00080
80I220>U=0?_G@?oo`;g_P?_O@>U50=220<aYP<YA@<0808000<8@@=220>]E@?_G@?og`;oo`?W70><
D@><L@<aQP<Q908080<000<080<8H@<@XP<Hh`9cSP=[K@?>N@?g_P?oo`?og`;gWP>]M@=:B@=220<8
H@H00088@@=:J@>eUP?_O@Koo`;FVPW>N@=[C@<Hh`D000<080=220>U=0>]E@Soo`<0808000<080I2
20>U=0?_G@;oo`?g_P?_O@>U50=220<aYP8YA@<080<000<8@@=220>]E@;_G@?og`?oo`?W70><D@><
L@<aQP8Q90<080<000<080<8H@<@XP8Hh`=cSP=[K@?>N@?g_P?oo`;og`?gWP>]M@=:B@=220<8H@D0
00<8@@=:J@>eUP?_O@Goo`?FVPW>N@=[C@8Hh`H000<080=220>U=0:]E@Woo`8080<000<080I220>U
=0;_G@?oo`?g_P?_O@>U50=2208aYP<YA@<080<000<8@@=220:]E@?_G@?og`?oo`?W70><D@:<L@<a
QP<Q90<080<000<080<8H@8@XP<Hh`=cSP=[K@?>N@?g_P;oo`?og`?gWP>]M@=:B@=22088H@H000<8
@@=:J@>eUP;_O@Koo`?FVPS>N@=[C@<Hh`H000<080=220:U=0>]E@Soo`<080<000<080E220>U=0?_
G@?oo`?g_P?_O@:U50=220<aYP<YA@<080<000<8@@9220>]E@?_G@?og`?oo`?W70:<D@><L@<aQP<Q
90<080<0008080<8H@<@XP<Hh`=cSP=[K@;>N@?g_P?oo`?og`?gWP>]M@9:B@=220<8H@H000<8@@=:
J@:eUP?_O@Koo`?FVPS>N@=[C@<Hh`H0008080=220>U=0>]EASoo`005ooo0`0P0`000P0P1T880jDd
0nmM0ooo0_Nn0nmm0jDD0d880c6V0bU50`0P0P000`Q10d880jeE0nmM0ooO0_oo0nLL0haA0haa0c66
0b4T0P0P0`000`0P0`QQ0a2R0aSS0W>>0f]]0lii0oNn0ooo0ooO0_NN0jee0dY90d880`QQ1P000PQ1
0dYY0kFF0nmm1_oo0]JJ2Lii0f]=0aSS1@000`0P0d880jDd0jeE2?oo0`0P0P000`0P1T880jDd0nmM
0_oo0oNn0nmm0jDD0d880c6V0RU50`0P0`000`Q10d880jeE0^mM0ooO0ooo0nLL0haA0haa0c660R4T
0`0P0`000`0P0`QQ0a2R0QSS0g>>0f]]0lii0oNn0ooo0_oO0oNN0jee0dY90d880`QQ1@000`Q10dYY
0kFF0nmm1Ooo0mJJ2Lii0f]=0QSS1P000`0P0d880jDd0ZeE2Ooo0P0P0`000`0P1T880jDd0^mM0ooo
0oNn0nmm0jDD0d880S6V0bU50`0P0`000`Q10d880ZeE0nmM0ooO0ooo0nLL0haA0Xaa0c660b4T0`0P
0`000`0P0`QQ0Q2R0aSS0g>>0f]]0lii0oNn0_oo0ooO0oNN0jee0dY90d880PQQ1P000`Q10dYY0kFF
0^mm1_oo0mJJ2<ii0f]=0aSS1P000`0P0d880ZDd0jeE2?oo0`0P0`000`0P1D880jDd0nmM0ooo0oNn
0nmm0ZDD0d880c6V0bU50`0P0`000`Q10T880jeE0nmM0ooO0ooo0nLL0XaA0haa0c660b4T0`0P0`00
0P0P0`QQ0a2R0aSS0g>>0f]]0/ii0oNn0ooo0ooO0oNN0jee0TY90d880`QQ1P000`Q10dYY0[FF0nmm
1_oo0mJJ2<ii0f]=0aSS1P000P0P0d880jDd0jeE6?oo000Gool3020300020206@PP3YC@3ked3ool2
mkh3kgd3YA@3@PP3<JH3:DD3020200032443@PP3[ED3ked3oml2ool3ia`3S543S743<HH38B@20203
0003020326434:836><2Lhh3Jfd3cWT3mkh3ool3oml2mih3[GD3BTT3@PP3264600022443BVT3]IH3
kgd6ool2eYX9cWT3Jdd36><500030203@PP3YC@3[ED8ool3020200030206@PP3YC@3ked2ool3mkh3
kgd3YA@3@PP3<JH2:DD3020300032443@PP3[ED2ked3oml3ool3ia`3S543S743<HH28B@302030003
020326434:826><3Lhh3Jfd3cWT3mkh3ool2oml3mih3[GD3BTT3@PP3264500032443BVT3]IH3kgd5
ool3eYX9cWT3Jdd26><600030203@PP3YC@2[ED9ool2020300030206@PP3YC@2ked3ool3mkh3kgd3
YA@3@PP2<JH3:DD3020300032443@PP2[ED3ked3oml3ool3ia`3S542S743<HH38B@3020300030203
26424:836><3Lhh3Jfd3cWT3mkh2ool3oml3mih3[GD3BTT3@PP2264600032443BVT3]IH2kgd6ool3
eYX8cWT3Jdd36><600030203@PP2YC@3[ED8ool3020300030205@PP3YC@3ked3ool3mkh3kgd2YA@3
@PP3<JH3:DD3020300032442@PP3[ED3ked3oml3ool3ia`2S543S743<HH38B@30203000202032643
4:836><3Lhh3Jfd2cWT3mkh3ool3oml3mih3[GD2BTT3@PP3264600032443BVT2]IH3kgd6ool3eYX8
cWT3Jdd36><600020203@PP3YC@3[EDHool001Ooo`<080<0008080I220>U=0?_G@?oo`;g_P?_O@>U
50=220<aYP<YA@<0808000<8@@=220>]E@?_G@?og`;oo`?W70><D@><L@<aQP<Q908080<000<080<8
H@<@XP<Hh`9cSP=[K@?>N@?g_P?oo`?og`;gWP>]M@=:B@=220<8H@H00088@@=:J@>eUP?_O@Koo`;F
VPW>N@=[C@<Hh`D000<080=220>U=0>]E@Soo`<0808000<080I220>U=0?_G@;oo`?g_P?_O@>U50=2
20<aYP8YA@<080<000<8@@=220>]E@;_G@?og`?oo`?W70><D@><L@<aQP8Q90<080<000<080<8H@<@
XP8Hh`=cSP=[K@?>N@?g_P?oo`;og`?gWP>]M@=:B@=220<8H@D000<8@@=:J@>eUP?_O@Goo`?FVPW>
N@=[C@8Hh`H000<080=220>U=0:]E@Woo`8080<000<080I220>U=0;_G@?oo`?g_P?_O@>U50=2208a
YP<YA@<080<000<8@@=220:]E@?_G@?og`?oo`?W70><D@:<L@<aQP<Q90<080<000<080<8H@8@XP<H
h`=cSP=[K@?>N@?g_P;oo`?og`?gWP>]M@=:B@=22088H@H000<8@@=:J@>eUP;_O@Koo`?FVPS>N@=[
C@<Hh`H000<080=220:U=0>]E@Soo`<080<000<080E220>U=0?_G@?oo`?g_P?_O@:U50=220<aYP<Y
A@<080<000<8@@9220>]E@?_G@?og`?oo`?W70:<D@><L@<aQP<Q90<080<0008080<8H@<@XP<Hh`=c
SP=[K@;>N@?g_P?oo`?og`?gWP>]M@9:B@=220<8H@H000<8@@=:J@:eUP?_O@Koo`?FVPS>N@=[C@<H
h`H0008080=220>U=0>]EASoo`005ooo0`0P0`000P0P1T880jDd0nmM0ooo0_Nn0nmm0jDD0d880c6V
0bU50`0P0P000`Q10d880jeE0nmM0ooO0_oo0nLL0haA0haa0c660b4T0P0P0`000`0P0`QQ0a2R0aSS
0W>>0f]]0lii0oNn0ooo0ooO0_NN0jee0dY90d880`QQ1P000PQ10dYY0kFF0nmm1_oo0]JJ2Lii0f]=
0aSS1@000`0P0d880jDd0jeE2?oo0`0P0P000`0P1T880jDd0nmM0_oo0oNn0nmm0jDD0d880c6V0RU5
0`0P0`000`Q10d880jeE0^mM0ooO0ooo0nLL0haA0haa0c660R4T0`0P0`000`0P0`QQ0a2R0QSS0g>>
0f]]0lii0oNn0ooo0_oO0oNN0jee0dY90d880`QQ1@000`Q10dYY0kFF0nmm1Ooo0mJJ2Lii0f]=0QSS
1P000`0P0d880jDd0ZeE2Ooo0P0P0`000`0P1T880jDd0^mM0ooo0oNn0nmm0jDD0d880S6V0bU50`0P
0`000`Q10d880ZeE0nmM0ooO0ooo0nLL0haA0Xaa0c660b4T0`0P0`000`0P0`QQ0Q2R0aSS0g>>0f]]
0lii0oNn0_oo0ooO0oNN0jee0dY90d880PQQ1P000`Q10dYY0kFF0^mm1_oo0mJJ2<ii0f]=0aSS1P00
0`0P0d880ZDd0jeE2?oo0`0P0`000`0P1D880jDd0nmM0ooo0oNn0nmm0ZDD0d880c6V0bU50`0P0`00
0`Q10T880jeE0nmM0ooO0ooo0nLL0XaA0haa0c660b4T0`0P0`000P0P0`QQ0a2R0aSS0g>>0f]]0/ii
0oNn0ooo0ooO0oNN0jee0TY90d880`QQ1P000`Q10dYY0[FF0nmm1_oo0mJJ2<ii0f]=0aSS1P000P0P
0d880jDd0jeE6?oo000Gool3020300020206@PP3YC@3ked3ool2mkh3kgd3YA@3@PP3<JH3:DD30202
00032443@PP3[ED3ked3oml2ool3ia`3S543S743<HH38B@202030003020326434:836><2Lhh3Jfd3
cWT3mkh3ool3oml2mih3[GD3BTT3@PP3264600022443BVT3]IH3kgd6ool2eYX9cWT3Jdd36><50003
0203@PP3YC@3[ED8ool3020200030206@PP3YC@3ked2ool3mkh3kgd3YA@3@PP3<JH2:DD302030003
2443@PP3[ED2ked3oml3ool3ia`3S543S743<HH28B@302030003020326434:826><3Lhh3Jfd3cWT3
mkh3ool2oml3mih3[GD3BTT3@PP3264500032443BVT3]IH3kgd5ool3eYX9cWT3Jdd26><600030203
@PP3YC@2[ED9ool2020300030206@PP3YC@2ked3ool3mkh3kgd3YA@3@PP2<JH3:DD3020300032443
@PP2[ED3ked3oml3ool3ia`3S542S743<HH38B@302030003020326424:836><3Lhh3Jfd3cWT3mkh2
ool3oml3mih3[GD3BTT3@PP2264600032443BVT3]IH2kgd6ool3eYX8cWT3Jdd36><600030203@PP2
YC@3[ED8ool3020300030205@PP3YC@3ked3ool3mkh3kgd2YA@3@PP3<JH3:DD3020300032442@PP3
[ED3ked3oml3ool3ia`2S543S743<HH38B@302030002020326434:836><3Lhh3Jfd2cWT3mkh3ool3
oml3mih3[GD2BTT3@PP3264600032443BVT2]IH3kgd6ool3eYX8cWT3Jdd36><600020203@PP3YC@3
[EDHool001Ooo`<080<0008080I220>U=0?_G@?oo`;g_P?_O@>U50=220<aYP<YA@<0808000<8@@=2
20>]E@?_G@?og`;oo`?W70><D@><L@<aQP<Q908080<000<080<8H@<@XP<Hh`9cSP=[K@?>N@?g_P?o
o`?og`;gWP>]M@=:B@=220<8H@H00088@@=:J@>eUP?_O@Koo`;FVPW>N@=[C@<Hh`D000<080=220>U
=0>]E@Soo`<0808000<080I220>U=0?_G@;oo`?g_P?_O@>U50=220<aYP8YA@<080<000<8@@=220>]
E@;_G@?og`?oo`?W70><D@><L@<aQP8Q90<080<000<080<8H@<@XP8Hh`=cSP=[K@?>N@?g_P?oo`;o
g`?gWP>]M@=:B@=220<8H@D000<8@@=:J@>eUP?_O@Goo`?FVPW>N@=[C@8Hh`H000<080=220>U=0:]
E@Woo`8080<000<080I220>U=0;_G@?oo`?g_P?_O@>U50=2208aYP<YA@<080<000<8@@=220:]E@?_
G@?og`?oo`?W70><D@:<L@<aQP<Q90<080<000<080<8H@8@XP<Hh`=cSP=[K@?>N@?g_P;oo`?og`?g
WP>]M@=:B@=22088H@H000<8@@=:J@>eUP;_O@Koo`?FVPS>N@=[C@<Hh`H000<080=220:U=0>]E@So
o`<080<000<080E220>U=0?_G@?oo`?g_P?_O@:U50=220<aYP<YA@<080<000<8@@9220>]E@?_G@?o
g`?oo`?W70:<D@><L@<aQP<Q90<080<0008080<8H@<@XP<Hh`=cSP=[K@;>N@?g_P?oo`?og`?gWP>]
M@9:B@=220<8H@H000<8@@=:J@:eUP?_O@Koo`?FVPS>N@=[C@<Hh`H0008080=220>U=0>]EASoo`00
5ooo0nmM0ooO0_oo0nLL1XaA0haa0c660P0P0`000`0P1SW729cc0nLl0ooo0ooO0oNN0nmM0^LL0haA
0haa0iBB0c6V0`Q10P000`0P0`QQ0e::0kFf0nmm1Ooo0oNn0oNN0jDd0d880PQQ0`000a220aS30aSS
0b441G__0mJj0ooO0ooo0nLL0haa0S660`0P0`000`0P0`QQ0a2R0V<<0lHh0oNn0ooo0ooO0liI2?oo
0nmM0_oO0ooo0nLL1XaA0haa0S660`0P0`000`0P1SW729cc0nLl0ooo0ooO0_NN0nmM0nLL0haA0haa
0iBB0c6V0PQ10`000`0P0`QQ0e::0kFf0^mm1_oo0oNn0oNN0jDd0T880`QQ0`000a220aS30aSS0R44
1W__0mJj0ooO0ooo0nLL0Xaa0c660`0P0`000`0P0`QQ0Q2R0f<<0lHh0oNn0ooo0ooO0/iI2Ooo0^mM
0ooO0ooo0nLL1XaA0Xaa0c660`0P0`000`0P1CW72Icc0nLl0ooo0_oO0oNN0nmM0nLL0haA0haa0YBB
0c6V0`Q10`000`0P0`QQ0e::0[Ff0nmm1_oo0oNn0oNN0ZDd0d880`QQ0`000a220aS30QSS0b441W__
0mJj0ooO0_oo0nLL0haa0c660`0P0`000P0P0`QQ0a2R0f<<0lHh0oNn0ooo0_oO0liI2?oo0nmM0ooO
0ooo0nLL1HaA0haa0c660`0P0`000P0P1SW72Icc0nLl0_oo0ooO0oNN0nmM0nLL0haA0Xaa0iBB0c6V
0`Q10`000`0P0PQQ0e::0kFf0nmm1_oo0_Nn0oNN0jDd0d880`QQ0`000Q220aS30aSS0b441W__0mJj
0_oO0ooo0nLL0haa0c660`0P0P000`0P0`QQ0a2R0f<<0lHh0_Nn0ooo0ooO0liI6?oo000Gool3ked3
oml2ool3ia`6S543S743<HH2020300030206>LL8W?<3ic`3ool3oml3mih3ked2ia`3S543S743U983
<JH32442000302032643DXX3]KH3kgd5ool3mkh3mih3YC@3@PP22643000348836<<36><38@@5Nnl3
e[X3oml3ool3ia`3S742<HH302030003020326434:82H``3aSP3mkh3ool3oml3cUT8ool3ked2oml3
ool3ia`6S543S742<HH3020300030206>LL8W?<3ic`3ool3oml2mih3ked3ia`3S543S743U983<JH2
2443000302032643DXX3]KH2kgd6ool3mkh3mih3YC@2@PP32643000348836<<36><28@@6Nnl3e[X3
oml3ool3ia`2S743<HH302030003020326424:83H``3aSP3mkh3ool3oml2cUT9ool2ked3oml3ool3
ia`6S542S743<HH3020300030205>LL9W?<3ic`3ool2oml3mih3ked3ia`3S543S742U983<JH32443
000302032643DXX2]KH3kgd6ool3mkh3mih2YC@3@PP32643000348836<<26><38@@6Nnl3e[X3oml2
ool3ia`3S743<HH302030002020326434:83H``3aSP3mkh3ool2oml3cUT8ool3ked3oml3ool3ia`5
S543S743<HH3020300020206>LL9W?<3ic`2ool3oml3mih3ked3ia`3S542S743U983<JH324430003
02022643DXX3]KH3kgd6ool2mkh3mih3YC@3@PP32643000248836<<36><38@@6Nnl3e[X2oml3ool3
ia`3S743<HH302020003020326434:83H``3aSP2mkh3ool3oml3cUTHool001Ooo`?_G@?og`;oo`?W
70J<D@><L@<aQP8080<000<080Hia`RLl`?W?0?oo`?og`?gWP?_G@;W70><D@><L@>DTP<aYP<8@@80
00<080<8H@=BRP>e]P?_O@Goo`?g_P?gWP>U=0=22088H@<000<@PP<H``<Hh`<Q10Ekk`?F^P?og`?o
o`?W70><L@8aQP<080<000<080<8H@<@XP9S30?6>0?g_P?oo`?og`?>F@Soo`?_G@;og`?oo`?W70J<
D@><L@8aQP<080<000<080Hia`RLl`?W?0?oo`?og`;gWP?_G@?W70><D@><L@>DTP<aYP88@@<000<0
80<8H@=BRP>e]P;_O@Koo`?g_P?gWP>U=09220<8H@<000<@PP<H``<Hh`8Q10Ikk`?F^P?og`?oo`?W
70:<L@<aQP<080<000<080<8H@8@XP=S30?6>0?g_P?oo`?og`;>F@Woo`;_G@?og`?oo`?W70J<D@:<
L@<aQP<080<000<080Dia`VLl`?W?0?oo`;og`?gWP?_G@?W70><D@><L@:DTP<aYP<8@@<000<080<8
H@=BRP:e]P?_O@Koo`?g_P?gWP:U=0=220<8H@<000<@PP<H``8Hh`<Q10Ikk`?F^P?og`;oo`?W70><
L@<aQP<080<0008080<8H@<@XP=S30?6>0?g_P?oo`;og`?>F@Soo`?_G@?og`?oo`?W70F<D@><L@<a
QP<080<0008080Hia`VLl`?W?0;oo`?og`?gWP?_G@?W70><D@:<L@>DTP<aYP<8@@<000<08088H@=B
RP>e]P?_O@Koo`;g_P?gWP>U=0=220<8H@<0008@PP<H``<Hh`<Q10Ikk`?F^P;og`?oo`?W70><L@<a
QP<0808000<080<8H@<@XP=S30?6>0;g_P?oo`?og`?>FASoo`005ooo0nmM0ooO0_oo0nLL1XaA0haa
0c660P0P0`000`0P1SW729cc0nLl0ooo0ooO0oNN0nmM0^LL0haA0haa0iBB0c6V0`Q10P000`0P0`QQ
0e::0kFf0nmm1Ooo0oNn0oNN0jDd0d880PQQ0`000a220aS30aSS0b441G__0mJj0ooO0ooo0nLL0haa
0S660`0P0`000`0P0`QQ0a2R0V<<0lHh0oNn0ooo0ooO0liI2?oo0nmM0_oO0ooo0nLL1XaA0haa0S66
0`0P0`000`0P1SW729cc0nLl0ooo0ooO0_NN0nmM0nLL0haA0haa0iBB0c6V0PQ10`000`0P0`QQ0e::
0kFf0^mm1_oo0oNn0oNN0jDd0T880`QQ0`000a220aS30aSS0R441W__0mJj0ooO0ooo0nLL0Xaa0c66
0`0P0`000`0P0`QQ0Q2R0f<<0lHh0oNn0ooo0ooO0/iI2Ooo0^mM0ooO0ooo0nLL1XaA0Xaa0c660`0P
0`000`0P1CW72Icc0nLl0ooo0_oO0oNN0nmM0nLL0haA0haa0YBB0c6V0`Q10`000`0P0`QQ0e::0[Ff
0nmm1_oo0oNn0oNN0ZDd0d880`QQ0`000a220aS30QSS0b441W__0mJj0ooO0_oo0nLL0haa0c660`0P
0`000P0P0`QQ0a2R0f<<0lHh0oNn0ooo0_oO0liI2?oo0nmM0ooO0ooo0nLL1HaA0haa0c660`0P0`00
0P0P1SW72Icc0nLl0_oo0ooO0oNN0nmM0nLL0haA0Xaa0iBB0c6V0`Q10`000`0P0PQQ0e::0kFf0nmm
1_oo0_Nn0oNN0jDd0d880`QQ0`000Q220aS30aSS0b441W__0mJj0_oO0ooo0nLL0haa0c660`0P0P00
0`0P0`QQ0a2R0f<<0lHh0_Nn0ooo0ooO0liI6?oo000Gool3ked3oml2ool3ia`6S543S743<HH20203
00030206>LL8W?<3ic`3ool3oml3mih3ked2ia`3S543S743U983<JH32442000302032643DXX3]KH3
kgd5ool3mkh3mih3YC@3@PP22643000348836<<36><38@@5Nnl3e[X3oml3ool3ia`3S742<HH30203
0003020326434:82H``3aSP3mkh3ool3oml3cUT8ool3ked2oml3ool3ia`6S543S742<HH302030003
0206>LL8W?<3ic`3ool3oml2mih3ked3ia`3S543S743U983<JH22443000302032643DXX3]KH2kgd6
ool3mkh3mih3YC@2@PP32643000348836<<36><28@@6Nnl3e[X3oml3ool3ia`2S743<HH302030003
020326424:83H``3aSP3mkh3ool3oml2cUT9ool2ked3oml3ool3ia`6S542S743<HH3020300030205
>LL9W?<3ic`3ool2oml3mih3ked3ia`3S543S742U983<JH32443000302032643DXX2]KH3kgd6ool3
mkh3mih2YC@3@PP32643000348836<<26><38@@6Nnl3e[X3oml2ool3ia`3S743<HH3020300020203
26434:83H``3aSP3mkh3ool2oml3cUT8ool3ked3oml3ool3ia`5S543S743<HH3020300020206>LL9
W?<3ic`2ool3oml3mih3ked3ia`3S542S743U983<JH32443000302022643DXX3]KH3kgd6ool2mkh3
mih3YC@3@PP32643000248836<<36><38@@6Nnl3e[X2oml3ool3ia`3S743<HH30202000302032643
4:83H``3aSP2mkh3ool3oml3cUTHool001Ooo`?_G@?og`;oo`?W70J<D@><L@<aQP8080<000<080Hi
a`RLl`?W?0?oo`?og`?gWP?_G@;W70><D@><L@>DTP<aYP<8@@8000<080<8H@=BRP>e]P?_O@Goo`?g
_P?gWP>U=0=22088H@<000<@PP<H``<Hh`<Q10Ekk`?F^P?og`?oo`?W70><L@8aQP<080<000<080<8
H@<@XP9S30?6>0?g_P?oo`?og`?>F@Soo`?_G@;og`?oo`?W70J<D@><L@8aQP<080<000<080Hia`RL
l`?W?0?oo`?og`;gWP?_G@?W70><D@><L@>DTP<aYP88@@<000<080<8H@=BRP>e]P;_O@Koo`?g_P?g
WP>U=09220<8H@<000<@PP<H``<Hh`8Q10Ikk`?F^P?og`?oo`?W70:<L@<aQP<080<000<080<8H@8@
XP=S30?6>0?g_P?oo`?og`;>F@Woo`;_G@?og`?oo`?W70J<D@:<L@<aQP<080<000<080Dia`VLl`?W
?0?oo`;og`?gWP?_G@?W70><D@><L@:DTP<aYP<8@@<000<080<8H@=BRP:e]P?_O@Koo`?g_P?gWP:U
=0=220<8H@<000<@PP<H``8Hh`<Q10Ikk`?F^P?og`;oo`?W70><L@<aQP<080<0008080<8H@<@XP=S
30?6>0?g_P?oo`;og`?>F@Soo`?_G@?og`?oo`?W70F<D@><L@<aQP<080<0008080Hia`VLl`?W?0;o
o`?og`?gWP?_G@?W70><D@:<L@>DTP<aYP<8@@<000<08088H@=BRP>e]P?_O@Koo`;g_P?gWP>U=0=2
20<8H@<0008@PP<H``<Hh`<Q10Ikk`?F^P;og`?oo`?W70><L@<aQP<0808000<080<8H@<@XP=S30?6
>0;g_P?oo`?og`?>FASoo`005ooo0nmM0ooO0_oo0nLL1XaA0haa0c660P0P0`000`0P1SW729cc0nLl
0ooo0ooO0oNN0nmM0^LL0haA0haa0iBB0c6V0`Q10P000`0P0`QQ0e::0kFf0nmm1Ooo0oNn0oNN0jDd
0d880PQQ0`000a220aS30aSS0b441G__0mJj0ooO0ooo0nLL0haa0S660`0P0`000`0P0`QQ0a2R0V<<
0lHh0oNn0ooo0ooO0liI2?oo0nmM0_oO0ooo0nLL1XaA0haa0S660`0P0`000`0P1SW729cc0nLl0ooo
0ooO0_NN0nmM0nLL0haA0haa0iBB0c6V0PQ10`000`0P0`QQ0e::0kFf0^mm1_oo0oNn0oNN0jDd0T88
0`QQ0`000a220aS30aSS0R441W__0mJj0ooO0ooo0nLL0Xaa0c660`0P0`000`0P0`QQ0Q2R0f<<0lHh
0oNn0ooo0ooO0/iI2Ooo0^mM0ooO0ooo0nLL1XaA0Xaa0c660`0P0`000`0P1CW72Icc0nLl0ooo0_oO
0oNN0nmM0nLL0haA0haa0YBB0c6V0`Q10`000`0P0`QQ0e::0[Ff0nmm1_oo0oNn0oNN0ZDd0d880`QQ
0`000a220aS30QSS0b441W__0mJj0ooO0_oo0nLL0haa0c660`0P0`000P0P0`QQ0a2R0f<<0lHh0oNn
0ooo0_oO0liI2?oo0nmM0ooO0ooo0nLL1HaA0haa0c660`0P0`000P0P1SW72Icc0nLl0_oo0ooO0oNN
0nmM0nLL0haA0Xaa0iBB0c6V0`Q10`000`0P0PQQ0e::0kFf0nmm1_oo0_Nn0oNN0jDd0d880`QQ0`00
0Q220aS30aSS0b441W__0mJj0_oO0ooo0nLL0haa0c660`0P0P000`0P0`QQ0a2R0f<<0lHh0_Nn0ooo
0ooO0liI6?oo000Gool3ked3oml2ool3ia`6S543S743<HH2020300030206>LL8W?<3ic`3ool3oml3
mih3ked2ia`3S543S743U983<JH32442000302032643DXX3]KH3kgd5ool3mkh3mih3YC@3@PP22643
000348836<<36><38@@5Nnl3e[X3oml3ool3ia`3S742<HH302030003020326434:82H``3aSP3mkh3
ool3oml3cUT8ool3ked2oml3ool3ia`6S543S742<HH3020300030206>LL8W?<3ic`3ool3oml2mih3
ked3ia`3S543S743U983<JH22443000302032643DXX3]KH2kgd6ool3mkh3mih3YC@2@PP326430003
48836<<36><28@@6Nnl3e[X3oml3ool3ia`2S743<HH302030003020326424:83H``3aSP3mkh3ool3
oml2cUT9ool2ked3oml3ool3ia`6S542S743<HH3020300030205>LL9W?<3ic`3ool2oml3mih3ked3
ia`3S543S742U983<JH32443000302032643DXX2]KH3kgd6ool3mkh3mih2YC@3@PP3264300034883
6<<26><38@@6Nnl3e[X3oml2ool3ia`3S743<HH302030002020326434:83H``3aSP3mkh3ool2oml3
cUT8ool3ked3oml3ool3ia`5S543S743<HH3020300020206>LL9W?<3ic`2ool3oml3mih3ked3ia`3
S542S743U983<JH32443000302022643DXX3]KH3kgd6ool2mkh3mih3YC@3@PP32643000248836<<3
6><38@@6Nnl3e[X2oml3ool3ia`3S743<HH302020003020326434:83H``3aSP2mkh3ool3oml3cUTH
ool001Ooo`?_G@?og`;oo`?W70J<D@><L@<aQP8080<000<080Hia`RLl`?W?0?oo`?og`?gWP?_G@;W
70><D@><L@>DTP<aYP<8@@8000<080<8H@=BRP>e]P?_O@Goo`?g_P?gWP>U=0=22088H@<000<@PP<H
``<Hh`<Q10Ekk`?F^P?og`?oo`?W70><L@8aQP<080<000<080<8H@<@XP9S30?6>0?g_P?oo`?og`?>
F@Soo`?_G@;og`?oo`?W70J<D@><L@8aQP<080<000<080Hia`RLl`?W?0?oo`?og`;gWP?_G@?W70><
D@><L@>DTP<aYP88@@<000<080<8H@=BRP>e]P;_O@Koo`?g_P?gWP>U=09220<8H@<000<@PP<H``<H
h`8Q10Ikk`?F^P?og`?oo`?W70:<L@<aQP<080<000<080<8H@8@XP=S30?6>0?g_P?oo`?og`;>F@Wo
o`;_G@?og`?oo`?W70J<D@:<L@<aQP<080<000<080Dia`VLl`?W?0?oo`;og`?gWP?_G@?W70><D@><
L@:DTP<aYP<8@@<000<080<8H@=BRP:e]P?_O@Koo`?g_P?gWP:U=0=220<8H@<000<@PP<H``8Hh`<Q
10Ikk`?F^P?og`;oo`?W70><L@<aQP<080<0008080<8H@<@XP=S30?6>0?g_P?oo`;og`?>F@Soo`?_
G@?og`?oo`?W70F<D@><L@<aQP<080<0008080Hia`VLl`?W?0;oo`?og`?gWP?_G@?W70><D@:<L@>D
TP<aYP<8@@<000<08088H@=BRP>e]P?_O@Koo`;g_P?gWP>U=0=220<8H@<0008@PP<H``<Hh`<Q10Ik
k`?F^P;og`?oo`?W70><L@<aQP<0808000<080<8H@<@XP=S30?6>0;g_P?oo`?og`?>FASoo`005ooo
0nmM0ooO0_oo0nLL1XaA0haa0c660P0P0`000`0P1SW729cc0nLl0ooo0ooO0oNN0nmM0^LL0haA0haa
0iBB0c6V0`Q10P000`0P0`QQ0e::0kFf0nmm1Ooo0oNn0oNN0jDd0d880PQQ0`000a220aS30aSS0b44
1G__0mJj0ooO0ooo0nLL0haa0S660`0P0`000`0P0`QQ0a2R0V<<0lHh0oNn0ooo0ooO0liI2?oo0nmM
0_oO0ooo0nLL1XaA0haa0S660`0P0`000`0P1SW729cc0nLl0ooo0ooO0_NN0nmM0nLL0haA0haa0iBB
0c6V0PQ10`000`0P0`QQ0e::0kFf0^mm1_oo0oNn0oNN0jDd0T880`QQ0`000a220aS30aSS0R441W__
0mJj0ooO0ooo0nLL0Xaa0c660`0P0`000`0P0`QQ0Q2R0f<<0lHh0oNn0ooo0ooO0/iI2Ooo0^mM0ooO
0ooo0nLL1XaA0Xaa0c660`0P0`000`0P1CW72Icc0nLl0ooo0_oO0oNN0nmM0nLL0haA0haa0YBB0c6V
0`Q10`000`0P0`QQ0e::0[Ff0nmm1_oo0oNn0oNN0ZDd0d880`QQ0`000a220aS30QSS0b441W__0mJj
0ooO0_oo0nLL0haa0c660`0P0`000P0P0`QQ0a2R0f<<0lHh0oNn0ooo0_oO0liI2?oo0nmM0ooO0ooo
0nLL1HaA0haa0c660`0P0`000P0P1SW72Icc0nLl0_oo0ooO0oNN0nmM0nLL0haA0Xaa0iBB0c6V0`Q1
0`000`0P0PQQ0e::0kFf0nmm1_oo0_Nn0oNN0jDd0d880`QQ0`000Q220aS30aSS0b441W__0mJj0_oO
0ooo0nLL0haa0c660`0P0P000`0P0`QQ0a2R0f<<0lHh0_Nn0ooo0ooO0liI6?oo000Gool3ked3oml2
ool3ia`6S543S743<HH2020300030206>LL8W?<3ic`3ool3oml3mih3ked2ia`3S543S743U983<JH3
2442000302032643DXX3]KH3kgd5ool3mkh3mih3YC@3@PP22643000348836<<36><38@@5Nnl3e[X3
oml3ool3ia`3S742<HH302030003020326434:82H``3aSP3mkh3ool3oml3cUT8ool3ked2oml3ool3
ia`6S543S742<HH3020300030206>LL8W?<3ic`3ool3oml2mih3ked3ia`3S543S743U983<JH22443
000302032643DXX3]KH2kgd6ool3mkh3mih3YC@2@PP32643000348836<<36><28@@6Nnl3e[X3oml3
ool3ia`2S743<HH302030003020326424:83H``3aSP3mkh3ool3oml2cUT9ool2ked3oml3ool3ia`6
S542S743<HH3020300030205>LL9W?<3ic`3ool2oml3mih3ked3ia`3S543S742U983<JH324430003
02032643DXX2]KH3kgd6ool3mkh3mih2YC@3@PP32643000348836<<26><38@@6Nnl3e[X3oml2ool3
ia`3S743<HH302030002020326434:83H``3aSP3mkh3ool2oml3cUT8ool3ked3oml3ool3ia`5S543
S743<HH3020300020206>LL9W?<3ic`2ool3oml3mih3ked3ia`3S542S743U983<JH3244300030202
2643DXX3]KH3kgd6ool2mkh3mih3YC@3@PP32643000248836<<36><38@@6Nnl3e[X2oml3ool3ia`3
S743<HH302020003020326434:83H``3aSP2mkh3ool3oml3cUTHool001Ooo`=[C@<Hh`88H@<000<@
PP=S30?660?g_P;oo`?_O@?W?0>DTPJD/P<ia`88@@<000<080<8@@<@PP<H``8Hh`=kc`=c[P?FVP?N
n`?_O@Goo`?g_P?_O@?W?0?W70;Nn`?Nf`?F^P=c[P<Q10D000<080Hii`>U50>U=0>]E@;_G@Koo`?g
_P?_O@>U50:U=0=2:0<8H@H000<aQP:DTP?W70?gWPKoo`?>N@Soo`=[C@8Hh`<8H@<000<@PP=S30?6
60;g_P?oo`?_O@?W?0>DTPFD/P<ia`<8@@<000<080<8@@8@PP<H``<Hh`=kc`=c[P?FVP?Nn`;_O@Ko
o`?g_P?_O@?W?0;W70?Nn`?Nf`?F^P=c[P<Q10D000<080Hii`>U50:U=0>]E@?_G@Koo`?g_P?_O@:U
50>U=0=2:0<8H@H0008aQP>DTP?W70?gWPKoo`;>N@Woo`9[C@<Hh`<8H@<000<@PP=S30;660?g_P?o
o`?_O@?W?0>DTPFD/P<ia`<8@@<000<08088@@<@PP<H``<Hh`=kc`=c[P;FVP?Nn`?_O@Koo`?g_P?_
O@;W?0?W70?Nn`?Nf`?F^P=c[P8Q10H000<080Hii`:U50>U=0>]E@?_G@Koo`;g_P?_O@>U50>U=0=2
:0<8H@D000<aQP>DTP?W70?gWPGoo`?>N@Soo`=[C@<Hh`<8H@<0008@PP=S30?660?g_P?oo`?_O@;W
?0>DTPJD/P<ia`<8@@<0008080<8@@<@PP<H``<Hh`=kc`9c[P?FVP?Nn`?_O@Koo`;g_P?_O@?W?0?W
70?Nn`?Nf`;F^P=c[P<Q10H000<080Dii`>U50>U=0>]E@?_G@Goo`?g_P?_O@>U50>U=0=2:088H@H0
00<aQP>DTP?W70;gWPKoo`?>NASoo`005ooo0f]=0aSS0PQQ0`000a220f<<0lHH0oNn0_oo0nmm0nLl
0iBB1YBb0cW70PQ10`000`0P0`Q10a220aS30QSS0g_?0g>^0mJJ0mkk0nmm1Ooo0oNn0nmm0nLl0nLL
0]kk0mkK0mJj0g>^0b441@000`0P1SWW0jDD0jDd0jeE0^mM1_oo0oNn0nmm0jDD0ZDd0d8X0`QQ1P00
0c660YBB0nLL0oNN1_oo0lii2?oo0f]=0QSS0`QQ0`000a220f<<0lHH0_Nn0ooo0nmm0nLl0iBB1IBb
0cW70`Q10`000`0P0`Q10Q220aS30aSS0g_?0g>^0mJJ0mkk0^mm1_oo0oNn0nmm0nLl0^LL0mkk0mkK
0mJj0g>^0b441@000`0P1SWW0jDD0ZDd0jeE0nmM1_oo0oNn0nmm0ZDD0jDd0d8X0`QQ1P000S660iBB
0nLL0oNN1_oo0/ii2Ooo0V]=0aSS0`QQ0`000a220f<<0/HH0oNn0ooo0nmm0nLl0iBB1IBb0cW70`Q1
0`000`0P0PQ10a220aS30aSS0g_?0g>^0]JJ0mkk0nmm1_oo0oNn0nmm0^Ll0nLL0mkk0mkK0mJj0g>^
0R441P000`0P1SWW0ZDD0jDd0jeE0nmM1_oo0_Nn0nmm0jDD0jDd0d8X0`QQ1@000c660iBB0nLL0oNN
1Ooo0lii2?oo0f]=0aSS0`QQ0`000Q220f<<0lHH0oNn0ooo0nmm0^Ll0iBB1YBb0cW70`Q10`000P0P
0`Q10a220aS30aSS0g_?0W>^0mJJ0mkk0nmm1_oo0_Nn0nmm0nLl0nLL0mkk0mkK0]Jj0g>^0b441P00
0`0P1CWW0jDD0jDd0jeE0nmM1Ooo0oNn0nmm0jDD0jDd0d8X0PQQ1P000c660iBB0nLL0_NN1_oo0lii
6?oo000Gool3Jdd36><2264300034883H``3aQP3mkh2ool3kgd3ic`3U986U;83>LL2244300030203
244348836<<26><3Nll3Ljh3eYX3g_/3kgd5ool3mkh3kgd3ic`3ia`2g_/3g]/3e[X3Ljh38@@50003
0206>NL3YA@3YC@3[ED2ked6ool3mkh3kgd3YA@2YC@3@RP326460003<HH2U983ia`3mih6ool3cWT8
ool3Jdd26><3264300034883H``3aQP2mkh3ool3kgd3ic`3U985U;83>LL324430003020324424883
6<<36><3Nll3Ljh3eYX3g_/2kgd6ool3mkh3kgd3ic`2ia`3g_/3g]/3e[X3Ljh38@@500030206>NL3
YA@2YC@3[ED3ked6ool3mkh3kgd2YA@3YC@3@RP326460002<HH3U983ia`3mih6ool2cWT9ool2Jdd3
6><3264300034883H``2aQP3mkh3ool3kgd3ic`3U985U;83>LL3244300030202244348836<<36><3
Nll3Ljh2eYX3g_/3kgd6ool3mkh3kgd2ic`3ia`3g_/3g]/3e[X3Ljh28@@600030206>NL2YA@3YC@3
[ED3ked6ool2mkh3kgd3YA@3YC@3@RP326450003<HH3U983ia`3mih5ool3cWT8ool3Jdd36><32643
00024883H``3aQP3mkh3ool3kgd2ic`3U986U;83>LL3244300020203244348836<<36><3Nll2Ljh3
eYX3g_/3kgd6ool2mkh3kgd3ic`3ia`3g_/3g]/2e[X3Ljh38@@600030205>NL3YA@3YC@3[ED3ked5
ool3mkh3kgd3YA@3YC@3@RP226460003<HH3U983ia`2mih6ool3cWTHool001Ooo`=[C@<Hh`88H@<0
00<@PP=S30?660?g_P;oo`?_O@?W?0>DTPJD/P<ia`88@@<000<080<8@@<@PP<H``8Hh`=kc`=c[P?F
VP?Nn`?_O@Goo`?g_P?_O@?W?0?W70;Nn`?Nf`?F^P=c[P<Q10D000<080Hii`>U50>U=0>]E@;_G@Ko
o`?g_P?_O@>U50:U=0=2:0<8H@H000<aQP:DTP?W70?gWPKoo`?>N@Soo`=[C@8Hh`<8H@<000<@PP=S
30?660;g_P?oo`?_O@?W?0>DTPFD/P<ia`<8@@<000<080<8@@8@PP<H``<Hh`=kc`=c[P?FVP?Nn`;_
O@Koo`?g_P?_O@?W?0;W70?Nn`?Nf`?F^P=c[P<Q10D000<080Hii`>U50:U=0>]E@?_G@Koo`?g_P?_
O@:U50>U=0=2:0<8H@H0008aQP>DTP?W70?gWPKoo`;>N@Woo`9[C@<Hh`<8H@<000<@PP=S30;660?g
_P?oo`?_O@?W?0>DTPFD/P<ia`<8@@<000<08088@@<@PP<H``<Hh`=kc`=c[P;FVP?Nn`?_O@Koo`?g
_P?_O@;W?0?W70?Nn`?Nf`?F^P=c[P8Q10H000<080Hii`:U50>U=0>]E@?_G@Koo`;g_P?_O@>U50>U
=0=2:0<8H@D000<aQP>DTP?W70?gWPGoo`?>N@Soo`=[C@<Hh`<8H@<0008@PP=S30?660?g_P?oo`?_
O@;W?0>DTPJD/P<ia`<8@@<0008080<8@@<@PP<H``<Hh`=kc`9c[P?FVP?Nn`?_O@Koo`;g_P?_O@?W
?0?W70?Nn`?Nf`;F^P=c[P<Q10H000<080Dii`>U50>U=0>]E@?_G@Goo`?g_P?_O@>U50>U=0=2:088
H@H000<aQP>DTP?W70;gWPKoo`?>NASoo`005ooo0f]=0aSS0PQQ0`000a220f<<0lHH0oNn0_oo0nmm
0nLl0iBB1YBb0cW70PQ10`000`0P0`Q10a220aS30QSS0g_?0g>^0mJJ0mkk0nmm1Ooo0oNn0nmm0nLl
0nLL0]kk0mkK0mJj0g>^0b441@000`0P1SWW0jDD0jDd0jeE0^mM1_oo0oNn0nmm0jDD0ZDd0d8X0`QQ
1P000c660YBB0nLL0oNN1_oo0lii2?oo0f]=0QSS0`QQ0`000a220f<<0lHH0_Nn0ooo0nmm0nLl0iBB
1IBb0cW70`Q10`000`0P0`Q10Q220aS30aSS0g_?0g>^0mJJ0mkk0^mm1_oo0oNn0nmm0nLl0^LL0mkk
0mkK0mJj0g>^0b441@000`0P1SWW0jDD0ZDd0jeE0nmM1_oo0oNn0nmm0ZDD0jDd0d8X0`QQ1P000S66
0iBB0nLL0oNN1_oo0/ii2Ooo0V]=0aSS0`QQ0`000a220f<<0/HH0oNn0ooo0nmm0nLl0iBB1IBb0cW7
0`Q10`000`0P0PQ10a220aS30aSS0g_?0g>^0]JJ0mkk0nmm1_oo0oNn0nmm0^Ll0nLL0mkk0mkK0mJj
0g>^0R441P000`0P1SWW0ZDD0jDd0jeE0nmM1_oo0_Nn0nmm0jDD0jDd0d8X0`QQ1@000c660iBB0nLL
0oNN1Ooo0lii2?oo0f]=0aSS0`QQ0`000Q220f<<0lHH0oNn0ooo0nmm0^Ll0iBB1YBb0cW70`Q10`00
0P0P0`Q10a220aS30aSS0g_?0W>^0mJJ0mkk0nmm1_oo0_Nn0nmm0nLl0nLL0mkk0mkK0]Jj0g>^0b44
1P000`0P1CWW0jDD0jDd0jeE0nmM1Ooo0oNn0nmm0jDD0jDd0d8X0PQQ1P000c660iBB0nLL0_NN1_oo
0lii6?oo000Gool3Jdd36><2264300034883H``3aQP3mkh2ool3kgd3ic`3U986U;83>LL224430003
0203244348836<<26><3Nll3Ljh3eYX3g_/3kgd5ool3mkh3kgd3ic`3ia`2g_/3g]/3e[X3Ljh38@@5
00030206>NL3YA@3YC@3[ED2ked6ool3mkh3kgd3YA@2YC@3@RP326460003<HH2U983ia`3mih6ool3
cWT8ool3Jdd26><3264300034883H``3aQP2mkh3ool3kgd3ic`3U985U;83>LL32443000302032442
48836<<36><3Nll3Ljh3eYX3g_/2kgd6ool3mkh3kgd3ic`2ia`3g_/3g]/3e[X3Ljh38@@500030206
>NL3YA@2YC@3[ED3ked6ool3mkh3kgd2YA@3YC@3@RP326460002<HH3U983ia`3mih6ool2cWT9ool2
Jdd36><3264300034883H``2aQP3mkh3ool3kgd3ic`3U985U;83>LL3244300030202244348836<<3
6><3Nll3Ljh2eYX3g_/3kgd6ool3mkh3kgd2ic`3ia`3g_/3g]/3e[X3Ljh28@@600030206>NL2YA@3
YC@3[ED3ked6ool2mkh3kgd3YA@3YC@3@RP326450003<HH3U983ia`3mih5ool3cWT8ool3Jdd36><3
264300024883H``3aQP3mkh3ool3kgd2ic`3U986U;83>LL3244300020203244348836<<36><3Nll2
Ljh3eYX3g_/3kgd6ool2mkh3kgd3ic`3ia`3g_/3g]/2e[X3Ljh38@@600030205>NL3YA@3YC@3[ED3
ked5ool3mkh3kgd3YA@3YC@3@RP226460003<HH3U983ia`2mih6ool3cWTHool001Ooo`=[C@<Hh`88
H@<000<@PP=S30?660?g_P;oo`?_O@?W?0>DTPJD/P<ia`88@@<000<080<8@@<@PP<H``8Hh`=kc`=c
[P?FVP?Nn`?_O@Goo`?g_P?_O@?W?0?W70;Nn`?Nf`?F^P=c[P<Q10D000<080Hii`>U50>U=0>]E@;_
G@Koo`?g_P?_O@>U50:U=0=2:0<8H@H000<aQP:DTP?W70?gWPKoo`?>N@Soo`=[C@8Hh`<8H@<000<@
PP=S30?660;g_P?oo`?_O@?W?0>DTPFD/P<ia`<8@@<000<080<8@@8@PP<H``<Hh`=kc`=c[P?FVP?N
n`;_O@Koo`?g_P?_O@?W?0;W70?Nn`?Nf`?F^P=c[P<Q10D000<080Hii`>U50:U=0>]E@?_G@Koo`?g
_P?_O@:U50>U=0=2:0<8H@H0008aQP>DTP?W70?gWPKoo`;>N@Woo`9[C@<Hh`<8H@<000<@PP=S30;6
60?g_P?oo`?_O@?W?0>DTPFD/P<ia`<8@@<000<08088@@<@PP<H``<Hh`=kc`=c[P;FVP?Nn`?_O@Ko
o`?g_P?_O@;W?0?W70?Nn`?Nf`?F^P=c[P8Q10H000<080Hii`:U50>U=0>]E@?_G@Koo`;g_P?_O@>U
50>U=0=2:0<8H@D000<aQP>DTP?W70?gWPGoo`?>N@Soo`=[C@<Hh`<8H@<0008@PP=S30?660?g_P?o
o`?_O@;W?0>DTPJD/P<ia`<8@@<0008080<8@@<@PP<H``<Hh`=kc`9c[P?FVP?Nn`?_O@Koo`;g_P?_
O@?W?0?W70?Nn`?Nf`;F^P=c[P<Q10H000<080Dii`>U50>U=0>]E@?_G@Goo`?g_P?_O@>U50>U=0=2
:088H@H000<aQP>DTP?W70;gWPKoo`?>NASoo`005ooo0f]=0aSS0PQQ0`000a220f<<0lHH0oNn0_oo
0nmm0nLl0iBB1YBb0cW70PQ10`000`0P0`Q10a220aS30QSS0g_?0g>^0mJJ0mkk0nmm1Ooo0oNn0nmm
0nLl0nLL0]kk0mkK0mJj0g>^0b441@000`0P1SWW0jDD0jDd0jeE0^mM1_oo0oNn0nmm0jDD0ZDd0d8X
0`QQ1P000c660YBB0nLL0oNN1_oo0lii2?oo0f]=0QSS0`QQ0`000a220f<<0lHH0_Nn0ooo0nmm0nLl
0iBB1IBb0cW70`Q10`000`0P0`Q10Q220aS30aSS0g_?0g>^0mJJ0mkk0^mm1_oo0oNn0nmm0nLl0^LL
0mkk0mkK0mJj0g>^0b441@000`0P1SWW0jDD0ZDd0jeE0nmM1_oo0oNn0nmm0ZDD0jDd0d8X0`QQ1P00
0S660iBB0nLL0oNN1_oo0/ii2Ooo0V]=0aSS0`QQ0`000a220f<<0/HH0oNn0ooo0nmm0nLl0iBB1IBb
0cW70`Q10`000`0P0PQ10a220aS30aSS0g_?0g>^0]JJ0mkk0nmm1_oo0oNn0nmm0^Ll0nLL0mkk0mkK
0mJj0g>^0R441P000`0P1SWW0ZDD0jDd0jeE0nmM1_oo0_Nn0nmm0jDD0jDd0d8X0`QQ1@000c660iBB
0nLL0oNN1Ooo0lii2?oo0f]=0aSS0`QQ0`000Q220f<<0lHH0oNn0ooo0nmm0^Ll0iBB1YBb0cW70`Q1
0`000P0P0`Q10a220aS30aSS0g_?0W>^0mJJ0mkk0nmm1_oo0_Nn0nmm0nLl0nLL0mkk0mkK0]Jj0g>^
0b441P000`0P1CWW0jDD0jDd0jeE0nmM1Ooo0oNn0nmm0jDD0jDd0d8X0PQQ1P000c660iBB0nLL0_NN
1_oo0lii6?oo000Gool3Jdd36><2264300034883H``3aQP3mkh2ool3kgd3ic`3U986U;83>LL22443
00030203244348836<<26><3Nll3Ljh3eYX3g_/3kgd5ool3mkh3kgd3ic`3ia`2g_/3g]/3e[X3Ljh3
8@@500030206>NL3YA@3YC@3[ED2ked6ool3mkh3kgd3YA@2YC@3@RP326460003<HH2U983ia`3mih6
ool3cWT8ool3Jdd26><3264300034883H``3aQP2mkh3ool3kgd3ic`3U985U;83>LL3244300030203
244248836<<36><3Nll3Ljh3eYX3g_/2kgd6ool3mkh3kgd3ic`2ia`3g_/3g]/3e[X3Ljh38@@50003
0206>NL3YA@2YC@3[ED3ked6ool3mkh3kgd2YA@3YC@3@RP326460002<HH3U983ia`3mih6ool2cWT9
ool2Jdd36><3264300034883H``2aQP3mkh3ool3kgd3ic`3U985U;83>LL324430003020224434883
6<<36><3Nll3Ljh2eYX3g_/3kgd6ool3mkh3kgd2ic`3ia`3g_/3g]/3e[X3Ljh28@@600030206>NL2
YA@3YC@3[ED3ked6ool2mkh3kgd3YA@3YC@3@RP326450003<HH3U983ia`3mih5ool3cWT8ool3Jdd3
6><3264300024883H``3aQP3mkh3ool3kgd2ic`3U986U;83>LL3244300020203244348836<<36><3
Nll2Ljh3eYX3g_/3kgd6ool2mkh3kgd3ic`3ia`3g_/3g]/2e[X3Ljh38@@600030205>NL3YA@3YC@3
[ED3ked5ool3mkh3kgd3YA@3YC@3@RP226460003<HH3U983ia`2mih6ool3cWTHool001Ooo`=[C@<H
h`88H@<000<@PP=S30?660?g_P;oo`?_O@?W?0>DTPJD/P<ia`88@@<000<080<8@@<@PP<H``8Hh`=k
c`=c[P?FVP?Nn`?_O@Goo`?g_P?_O@?W?0?W70;Nn`?Nf`?F^P=c[P<Q10D000<080Hii`>U50>U=0>]
E@;_G@Koo`?g_P?_O@>U50:U=0=2:0<8H@H000<aQP:DTP?W70?gWPKoo`?>N@Soo`=[C@8Hh`<8H@<0
00<@PP=S30?660;g_P?oo`?_O@?W?0>DTPFD/P<ia`<8@@<000<080<8@@8@PP<H``<Hh`=kc`=c[P?F
VP?Nn`;_O@Koo`?g_P?_O@?W?0;W70?Nn`?Nf`?F^P=c[P<Q10D000<080Hii`>U50:U=0>]E@?_G@Ko
o`?g_P?_O@:U50>U=0=2:0<8H@H0008aQP>DTP?W70?gWPKoo`;>N@Woo`9[C@<Hh`<8H@<000<@PP=S
30;660?g_P?oo`?_O@?W?0>DTPFD/P<ia`<8@@<000<08088@@<@PP<H``<Hh`=kc`=c[P;FVP?Nn`?_
O@Koo`?g_P?_O@;W?0?W70?Nn`?Nf`?F^P=c[P8Q10H000<080Hii`:U50>U=0>]E@?_G@Koo`;g_P?_
O@>U50>U=0=2:0<8H@D000<aQP>DTP?W70?gWPGoo`?>N@Soo`=[C@<Hh`<8H@<0008@PP=S30?660?g
_P?oo`?_O@;W?0>DTPJD/P<ia`<8@@<0008080<8@@<@PP<H``<Hh`=kc`9c[P?FVP?Nn`?_O@Koo`;g
_P?_O@?W?0?W70?Nn`?Nf`;F^P=c[P<Q10H000<080Dii`>U50>U=0>]E@?_G@Goo`?g_P?_O@>U50>U
=0=2:088H@H000<aQP>DTP?W70;gWPKoo`?>NASoo`005ooo0f]=0aSS0PQQ0`000a220f<<0lHH0oNn
0_oo0nmm0nLl0iBB1YBb0cW70PQ10`000`0P0`Q10a220aS30QSS0g_?0g>^0mJJ0mkk0nmm1Ooo0oNn
0nmm0nLl0nLL0]kk0mkK0mJj0g>^0b441@000`0P1SWW0jDD0jDd0jeE0^mM1_oo0oNn0nmm0jDD0ZDd
0d8X0`QQ1P000c660YBB0nLL0oNN1_oo0lii2?oo0f]=0QSS0`QQ0`000a220f<<0lHH0_Nn0ooo0nmm
0nLl0iBB1IBb0cW70`Q10`000`0P0`Q10Q220aS30aSS0g_?0g>^0mJJ0mkk0^mm1_oo0oNn0nmm0nLl
0^LL0mkk0mkK0mJj0g>^0b441@000`0P1SWW0jDD0ZDd0jeE0nmM1_oo0oNn0nmm0ZDD0jDd0d8X0`QQ
1P000S660iBB0nLL0oNN1_oo0/ii2Ooo0V]=0aSS0`QQ0`000a220f<<0/HH0oNn0ooo0nmm0nLl0iBB
1IBb0cW70`Q10`000`0P0PQ10a220aS30aSS0g_?0g>^0]JJ0mkk0nmm1_oo0oNn0nmm0^Ll0nLL0mkk
0mkK0mJj0g>^0R441P000`0P1SWW0ZDD0jDd0jeE0nmM1_oo0_Nn0nmm0jDD0jDd0d8X0`QQ1@000c66
0iBB0nLL0oNN1Ooo0lii2?oo0f]=0aSS0`QQ0`000Q220f<<0lHH0oNn0ooo0nmm0^Ll0iBB1YBb0cW7
0`Q10`000P0P0`Q10a220aS30aSS0g_?0W>^0mJJ0mkk0nmm1_oo0_Nn0nmm0nLl0nLL0mkk0mkK0]Jj
0g>^0b441P000`0P1CWW0jDD0jDd0jeE0nmM1Ooo0oNn0nmm0jDD0jDd0d8X0PQQ1P000c660iBB0nLL
0_NN1_oo0lii6?oo000Gool3cWT3cUT2Jdd36><3264600032445BTT3[GD3kgd6ool3mkh2kgd3YA@3
YC@3@PP3>LL3:FD20203000302032643DXX3]KH2_OL3aSP3mkh3ool3oml3mkh2kgd3ic`3ia`3g]/3
Nnl3:DD202030003244348834:836><38@@28B@3Q303g]/3oml3ool3oml2aQP3F^/3F//34:860002
2443@RP3[ED3ked>ool3cWT2cUT3Jdd36><3264600022446BTT3[GD3kgd5ool3mkh3kgd3YA@3YC@3
@PP2>LL3:FD30203000302032643DXX2]KH3_OL3aSP3mkh3ool3oml2mkh3kgd3ic`3ia`3g]/3Nnl2
:DD302030003244348834:826><38@@38B@3Q303g]/3oml3ool2oml3aQP3F^/3F//34:8500032443
@RP3[ED3ked>ool2cWT3cUT3Jdd36><3264500032446BTT3[GD3kgd5ool3mkh3kgd3YA@3YC@2@PP3
>LL3:FD30203000302022643DXX3]KH3_OL3aSP3mkh3ool2oml3mkh3kgd3ic`3ia`3g]/2Nnl3:DD3
02030003244348824:836><38@@38B@3Q303g]/2oml3ool3oml3aQP3F^/3F//24:8600032443@RP3
[ED3ked=ool3cWT3cUT3Jdd36><2264600032446BTT2[GD3kgd6ool3mkh3kgd3YA@2YC@3@PP3>LL3
:FD30203000202032643DXX3]KH3_OL3aSP2mkh3ool3oml3mkh3kgd3ic`2ia`3g]/3Nnl3:DD30203
0002244348834:836><38@@38B@3Q302g]/3oml3ool3oml3aQP3F^/2F//34:8600032443@RP2[ED3
kedNool001Ooo`?>N@?>F@9[C@<Hh`<8H@H000<8@@E:B@>]M@?_O@Koo`?g_P;_O@>U50>U=0=220<i
a`<YI@8080<000<080<8H@=BRP>e]P:mm`?6>0?g_P?oo`?og`?g_P;_O@?W?0?W70?Nf`=kk`<YA@80
80<000<8@@<@PP<@XP<Hh`<Q108Q90>4<0?Nf`?og`?oo`?og`;660=Jj`=Jb`<@XPH00088@@=2:0>]
E@?_G@koo`?>N@;>F@=[C@<Hh`<8H@H00088@@I:B@>]M@?_O@Goo`?g_P?_O@>U50>U=0=2208ia`<Y
I@<080<000<080<8H@=BRP:e]P>mm`?6>0?g_P?oo`?og`;g_P?_O@?W?0?W70?Nf`=kk`8YA@<080<0
00<8@@<@PP<@XP8Hh`<Q10<Q90>4<0?Nf`?og`?oo`;og`?660=Jj`=Jb`<@XPD000<8@@=2:0>]E@?_
G@koo`;>N@?>F@=[C@<Hh`<8H@D000<8@@I:B@>]M@?_O@Goo`?g_P?_O@>U50>U=09220<ia`<YI@<0
80<000<08088H@=BRP>e]P>mm`?6>0?g_P?oo`;og`?g_P?_O@?W?0?W70?Nf`9kk`<YA@<080<000<8
@@<@PP8@XP<Hh`<Q10<Q90>4<0?Nf`;og`?oo`?og`?660=Jj`=Jb`8@XPH000<8@@=2:0>]E@?_G@go
o`?>N@?>F@=[C@<Hh`88H@H000<8@@I:B@:]M@?_O@Koo`?g_P?_O@>U50:U=0=220<ia`<YI@<080<0
008080<8H@=BRP>e]P>mm`?6>0;g_P?oo`?og`?g_P?_O@?W?0;W70?Nf`=kk`<YA@<080<00088@@<@
PP<@XP<Hh`<Q10<Q90>4<0;Nf`?og`?oo`?og`?660=Jj`9Jb`<@XPH000<8@@=2:0:]E@?_GAkoo`00
5ooo0lii0liI0V]=0aSS0`QQ1P000`Q11DY90jee0nmm1_oo0oNn0^mm0jDD0jDd0d880cW70bUU0P0P
0`000`0P0`QQ0e::0kFf0[gg0lHh0oNn0ooo0ooO0oNn0^mm0nLl0nLL0mkK0g__0bU50P0P0`000`Q1
0a220a2R0aSS0b440R4T0h@`0mkK0ooO0ooo0ooO0/HH0e[[0e[;0a2R1P000PQ10d8X0jeE0nmM3_oo
0lii0/iI0f]=0aSS0`QQ1P000PQ11TY90jee0nmm1Ooo0oNn0nmm0jDD0jDd0d880SW70bUU0`0P0`00
0`0P0`QQ0e::0[Ff0kgg0lHh0oNn0ooo0ooO0_Nn0nmm0nLl0nLL0mkK0g__0RU50`0P0`000`Q10a22
0a2R0QSS0b440b4T0h@`0mkK0ooO0ooo0_oO0lHH0e[[0e[;0a2R1@000`Q10d8X0jeE0nmM3_oo0/ii
0liI0f]=0aSS0`QQ1@000`Q11TY90jee0nmm1Ooo0oNn0nmm0jDD0jDd0T880cW70bUU0`0P0`000`0P
0PQQ0e::0kFf0kgg0lHh0oNn0ooo0_oO0oNn0nmm0nLl0nLL0mkK0W__0bU50`0P0`000`Q10a220Q2R
0aSS0b440b4T0h@`0mkK0_oO0ooo0ooO0lHH0e[[0e[;0Q2R1P000`Q10d8X0jeE0nmM3Ooo0lii0liI
0f]=0aSS0PQQ1P000`Q11TY90Zee0nmm1_oo0oNn0nmm0jDD0ZDd0d880cW70bUU0`0P0`000P0P0`QQ
0e::0kFf0kgg0lHh0_Nn0ooo0ooO0oNn0nmm0nLl0^LL0mkK0g__0bU50`0P0`000PQ10a220a2R0aSS
0b440b4T0h@`0]kK0ooO0ooo0ooO0lHH0e[[0U[;0a2R1P000`Q10d8X0ZeE0nmM7_oo000Gool3cWT3
cUT2Jdd36><3264600032445BTT3[GD3kgd6ool3mkh2kgd3YA@3YC@3@PP3>LL3:FD2020300030203
2643DXX3]KH2_OL3aSP3mkh3ool3oml3mkh2kgd3ic`3ia`3g]/3Nnl3:DD202030003244348834:83
6><38@@28B@3Q303g]/3oml3ool3oml2aQP3F^/3F//34:8600022443@RP3[ED3ked>ool3cWT2cUT3
Jdd36><3264600022446BTT3[GD3kgd5ool3mkh3kgd3YA@3YC@3@PP2>LL3:FD30203000302032643
DXX2]KH3_OL3aSP3mkh3ool3oml2mkh3kgd3ic`3ia`3g]/3Nnl2:DD302030003244348834:826><3
8@@38B@3Q303g]/3oml3ool2oml3aQP3F^/3F//34:8500032443@RP3[ED3ked>ool2cWT3cUT3Jdd3
6><3264500032446BTT3[GD3kgd5ool3mkh3kgd3YA@3YC@2@PP3>LL3:FD30203000302022643DXX3
]KH3_OL3aSP3mkh3ool2oml3mkh3kgd3ic`3ia`3g]/2Nnl3:DD302030003244348824:836><38@@3
8B@3Q303g]/2oml3ool3oml3aQP3F^/3F//24:8600032443@RP3[ED3ked=ool3cWT3cUT3Jdd36><2
264600032446BTT2[GD3kgd6ool3mkh3kgd3YA@2YC@3@PP3>LL3:FD30203000202032643DXX3]KH3
_OL3aSP2mkh3ool3oml3mkh3kgd3ic`2ia`3g]/3Nnl3:DD302030002244348834:836><38@@38B@3
Q302g]/3oml3ool3oml3aQP3F^/2F//34:8600032443@RP2[ED3kedNool001Ooo`?>N@?>F@9[C@<H
h`<8H@H000<8@@E:B@>]M@?_O@Koo`?g_P;_O@>U50>U=0=220<ia`<YI@8080<000<080<8H@=BRP>e
]P:mm`?6>0?g_P?oo`?og`?g_P;_O@?W?0?W70?Nf`=kk`<YA@8080<000<8@@<@PP<@XP<Hh`<Q108Q
90>4<0?Nf`?og`?oo`?og`;660=Jj`=Jb`<@XPH00088@@=2:0>]E@?_G@koo`?>N@;>F@=[C@<Hh`<8
H@H00088@@I:B@>]M@?_O@Goo`?g_P?_O@>U50>U=0=2208ia`<YI@<080<000<080<8H@=BRP:e]P>m
m`?6>0?g_P?oo`?og`;g_P?_O@?W?0?W70?Nf`=kk`8YA@<080<000<8@@<@PP<@XP8Hh`<Q10<Q90>4
<0?Nf`?og`?oo`;og`?660=Jj`=Jb`<@XPD000<8@@=2:0>]E@?_G@koo`;>N@?>F@=[C@<Hh`<8H@D0
00<8@@I:B@>]M@?_O@Goo`?g_P?_O@>U50>U=09220<ia`<YI@<080<000<08088H@=BRP>e]P>mm`?6
>0?g_P?oo`;og`?g_P?_O@?W?0?W70?Nf`9kk`<YA@<080<000<8@@<@PP8@XP<Hh`<Q10<Q90>4<0?N
f`;og`?oo`?og`?660=Jj`=Jb`8@XPH000<8@@=2:0>]E@?_G@goo`?>N@?>F@=[C@<Hh`88H@H000<8
@@I:B@:]M@?_O@Koo`?g_P?_O@>U50:U=0=220<ia`<YI@<080<0008080<8H@=BRP>e]P>mm`?6>0;g
_P?oo`?og`?g_P?_O@?W?0;W70?Nf`=kk`<YA@<080<00088@@<@PP<@XP<Hh`<Q10<Q90>4<0;Nf`?o
g`?oo`?og`?660=Jj`9Jb`<@XPH000<8@@=2:0:]E@?_GAkoo`005ooo0lii0liI0V]=0aSS0`QQ1P00
0`Q11DY90jee0nmm1_oo0oNn0^mm0jDD0jDd0d880cW70bUU0P0P0`000`0P0`QQ0e::0kFf0[gg0lHh
0oNn0ooo0ooO0oNn0^mm0nLl0nLL0mkK0g__0bU50P0P0`000`Q10a220a2R0aSS0b440R4T0h@`0mkK
0ooO0ooo0ooO0/HH0e[[0e[;0a2R1P000PQ10d8X0jeE0nmM3_oo0lii0/iI0f]=0aSS0`QQ1P000PQ1
1TY90jee0nmm1Ooo0oNn0nmm0jDD0jDd0d880SW70bUU0`0P0`000`0P0`QQ0e::0[Ff0kgg0lHh0oNn
0ooo0ooO0_Nn0nmm0nLl0nLL0mkK0g__0RU50`0P0`000`Q10a220a2R0QSS0b440b4T0h@`0mkK0ooO
0ooo0_oO0lHH0e[[0e[;0a2R1@000`Q10d8X0jeE0nmM3_oo0/ii0liI0f]=0aSS0`QQ1@000`Q11TY9
0jee0nmm1Ooo0oNn0nmm0jDD0jDd0T880cW70bUU0`0P0`000`0P0PQQ0e::0kFf0kgg0lHh0oNn0ooo
0_oO0oNn0nmm0nLl0nLL0mkK0W__0bU50`0P0`000`Q10a220Q2R0aSS0b440b4T0h@`0mkK0_oO0ooo
0ooO0lHH0e[[0e[;0Q2R1P000`Q10d8X0jeE0nmM3Ooo0lii0liI0f]=0aSS0PQQ1P000`Q11TY90Zee
0nmm1_oo0oNn0nmm0jDD0ZDd0d880cW70bUU0`0P0`000P0P0`QQ0e::0kFf0kgg0lHh0_Nn0ooo0ooO
0oNn0nmm0nLl0^LL0mkK0g__0bU50`0P0`000PQ10a220a2R0aSS0b440b4T0h@`0]kK0ooO0ooo0ooO
0lHH0e[[0U[;0a2R1P000`Q10d8X0ZeE0nmM7_oo000Gool3cWT3cUT2Jdd36><3264600032445BTT3
[GD3kgd6ool3mkh2kgd3YA@3YC@3@PP3>LL3:FD20203000302032643DXX3]KH2_OL3aSP3mkh3ool3
oml3mkh2kgd3ic`3ia`3g]/3Nnl3:DD202030003244348834:836><38@@28B@3Q303g]/3oml3ool3
oml2aQP3F^/3F//34:8600022443@RP3[ED3ked>ool3cWT2cUT3Jdd36><3264600022446BTT3[GD3
kgd5ool3mkh3kgd3YA@3YC@3@PP2>LL3:FD30203000302032643DXX2]KH3_OL3aSP3mkh3ool3oml2
mkh3kgd3ic`3ia`3g]/3Nnl2:DD302030003244348834:826><38@@38B@3Q303g]/3oml3ool2oml3
aQP3F^/3F//34:8500032443@RP3[ED3ked>ool2cWT3cUT3Jdd36><3264500032446BTT3[GD3kgd5
ool3mkh3kgd3YA@3YC@2@PP3>LL3:FD30203000302022643DXX3]KH3_OL3aSP3mkh3ool2oml3mkh3
kgd3ic`3ia`3g]/2Nnl3:DD302030003244348824:836><38@@38B@3Q303g]/2oml3ool3oml3aQP3
F^/3F//24:8600032443@RP3[ED3ked=ool3cWT3cUT3Jdd36><2264600032446BTT2[GD3kgd6ool3
mkh3kgd3YA@2YC@3@PP3>LL3:FD30203000202032643DXX3]KH3_OL3aSP2mkh3ool3oml3mkh3kgd3
ic`2ia`3g]/3Nnl3:DD302030002244348834:836><38@@38B@3Q302g]/3oml3ool3oml3aQP3F^/2
F//34:8600032443@RP2[ED3kedNool001Ooo`?>N@?>F@9[C@<Hh`<8H@H000<8@@E:B@>]M@?_O@Ko
o`?g_P;_O@>U50>U=0=220<ia`<YI@8080<000<080<8H@=BRP>e]P:mm`?6>0?g_P?oo`?og`?g_P;_
O@?W?0?W70?Nf`=kk`<YA@8080<000<8@@<@PP<@XP<Hh`<Q108Q90>4<0?Nf`?og`?oo`?og`;660=J
j`=Jb`<@XPH00088@@=2:0>]E@?_G@koo`?>N@;>F@=[C@<Hh`<8H@H00088@@I:B@>]M@?_O@Goo`?g
_P?_O@>U50>U=0=2208ia`<YI@<080<000<080<8H@=BRP:e]P>mm`?6>0?g_P?oo`?og`;g_P?_O@?W
?0?W70?Nf`=kk`8YA@<080<000<8@@<@PP<@XP8Hh`<Q10<Q90>4<0?Nf`?og`?oo`;og`?660=Jj`=J
b`<@XPD000<8@@=2:0>]E@?_G@koo`;>N@?>F@=[C@<Hh`<8H@D000<8@@I:B@>]M@?_O@Goo`?g_P?_
O@>U50>U=09220<ia`<YI@<080<000<08088H@=BRP>e]P>mm`?6>0?g_P?oo`;og`?g_P?_O@?W?0?W
70?Nf`9kk`<YA@<080<000<8@@<@PP8@XP<Hh`<Q10<Q90>4<0?Nf`;og`?oo`?og`?660=Jj`=Jb`8@
XPH000<8@@=2:0>]E@?_G@goo`?>N@?>F@=[C@<Hh`88H@H000<8@@I:B@:]M@?_O@Koo`?g_P?_O@>U
50:U=0=220<ia`<YI@<080<0008080<8H@=BRP>e]P>mm`?6>0;g_P?oo`?og`?g_P?_O@?W?0;W70?N
f`=kk`<YA@<080<00088@@<@PP<@XP<Hh`<Q10<Q90>4<0;Nf`?og`?oo`?og`?660=Jj`9Jb`<@XPH0
00<8@@=2:0:]E@?_GAkoo`005ooo0lii0liI0V]=0aSS0`QQ1P000`Q11DY90jee0nmm1_oo0oNn0^mm
0jDD0jDd0d880cW70bUU0P0P0`000`0P0`QQ0e::0kFf0[gg0lHh0oNn0ooo0ooO0oNn0^mm0nLl0nLL
0mkK0g__0bU50P0P0`000`Q10a220a2R0aSS0b440R4T0h@`0mkK0ooO0ooo0ooO0/HH0e[[0e[;0a2R
1P000PQ10d8X0jeE0nmM3_oo0lii0/iI0f]=0aSS0`QQ1P000PQ11TY90jee0nmm1Ooo0oNn0nmm0jDD
0jDd0d880SW70bUU0`0P0`000`0P0`QQ0e::0[Ff0kgg0lHh0oNn0ooo0ooO0_Nn0nmm0nLl0nLL0mkK
0g__0RU50`0P0`000`Q10a220a2R0QSS0b440b4T0h@`0mkK0ooO0ooo0_oO0lHH0e[[0e[;0a2R1@00
0`Q10d8X0jeE0nmM3_oo0/ii0liI0f]=0aSS0`QQ1@000`Q11TY90jee0nmm1Ooo0oNn0nmm0jDD0jDd
0T880cW70bUU0`0P0`000`0P0PQQ0e::0kFf0kgg0lHh0oNn0ooo0_oO0oNn0nmm0nLl0nLL0mkK0W__
0bU50`0P0`000`Q10a220Q2R0aSS0b440b4T0h@`0mkK0_oO0ooo0ooO0lHH0e[[0e[;0Q2R1P000`Q1
0d8X0jeE0nmM3Ooo0lii0liI0f]=0aSS0PQQ1P000`Q11TY90Zee0nmm1_oo0oNn0nmm0jDD0ZDd0d88
0cW70bUU0`0P0`000P0P0`QQ0e::0kFf0kgg0lHh0_Nn0ooo0ooO0oNn0nmm0nLl0^LL0mkK0g__0bU5
0`0P0`000PQ10a220a2R0aSS0b440b4T0h@`0]kK0ooO0ooo0ooO0lHH0e[[0U[;0a2R1P000`Q10d8X
0ZeE0nmM7_oo000Gool3cWT3cUT2Jdd36><3264600032445BTT3[GD3kgd6ool3mkh2kgd3YA@3YC@3
@PP3>LL3:FD20203000302032643DXX3]KH2_OL3aSP3mkh3ool3oml3mkh2kgd3ic`3ia`3g]/3Nnl3
:DD202030003244348834:836><38@@28B@3Q303g]/3oml3ool3oml2aQP3F^/3F//34:8600022443
@RP3[ED3ked>ool3cWT2cUT3Jdd36><3264600022446BTT3[GD3kgd5ool3mkh3kgd3YA@3YC@3@PP2
>LL3:FD30203000302032643DXX2]KH3_OL3aSP3mkh3ool3oml2mkh3kgd3ic`3ia`3g]/3Nnl2:DD3
02030003244348834:826><38@@38B@3Q303g]/3oml3ool2oml3aQP3F^/3F//34:8500032443@RP3
[ED3ked>ool2cWT3cUT3Jdd36><3264500032446BTT3[GD3kgd5ool3mkh3kgd3YA@3YC@2@PP3>LL3
:FD30203000302022643DXX3]KH3_OL3aSP3mkh3ool2oml3mkh3kgd3ic`3ia`3g]/2Nnl3:DD30203
0003244348824:836><38@@38B@3Q303g]/2oml3ool3oml3aQP3F^/3F//24:8600032443@RP3[ED3
ked=ool3cWT3cUT3Jdd36><2264600032446BTT2[GD3kgd6ool3mkh3kgd3YA@2YC@3@PP3>LL3:FD3
0203000202032643DXX3]KH3_OL3aSP2mkh3ool3oml3mkh3kgd3ic`2ia`3g]/3Nnl3:DD302030002
244348834:836><38@@38B@3Q302g]/3oml3ool3oml3aQP3F^/2F//34:8600032443@RP2[ED3kedN
ool001Ooo`?>N@?>F@9[C@<Hh`<8H@H000<8@@E:B@>]M@?_O@Koo`?g_P;_O@>U50>U=0=220<ia`<Y
I@8080<000<080<8H@=BRP>e]P:mm`?6>0?g_P?oo`?og`?g_P;_O@?W?0?W70?Nf`=kk`<YA@8080<0
00<8@@<@PP<@XP<Hh`<Q108Q90>4<0?Nf`?og`?oo`?og`;660=Jj`=Jb`<@XPH00088@@=2:0>]E@?_
G@koo`?>N@;>F@=[C@<Hh`<8H@H00088@@I:B@>]M@?_O@Goo`?g_P?_O@>U50>U=0=2208ia`<YI@<0
80<000<080<8H@=BRP:e]P>mm`?6>0?g_P?oo`?og`;g_P?_O@?W?0?W70?Nf`=kk`8YA@<080<000<8
@@<@PP<@XP8Hh`<Q10<Q90>4<0?Nf`?og`?oo`;og`?660=Jj`=Jb`<@XPD000<8@@=2:0>]E@?_G@ko
o`;>N@?>F@=[C@<Hh`<8H@D000<8@@I:B@>]M@?_O@Goo`?g_P?_O@>U50>U=09220<ia`<YI@<080<0
00<08088H@=BRP>e]P>mm`?6>0?g_P?oo`;og`?g_P?_O@?W?0?W70?Nf`9kk`<YA@<080<000<8@@<@
PP8@XP<Hh`<Q10<Q90>4<0?Nf`;og`?oo`?og`?660=Jj`=Jb`8@XPH000<8@@=2:0>]E@?_G@goo`?>
N@?>F@=[C@<Hh`88H@H000<8@@I:B@:]M@?_O@Koo`?g_P?_O@>U50:U=0=220<ia`<YI@<080<00080
80<8H@=BRP>e]P>mm`?6>0;g_P?oo`?og`?g_P?_O@?W?0;W70?Nf`=kk`<YA@<080<00088@@<@PP<@
XP<Hh`<Q10<Q90>4<0;Nf`?og`?oo`?og`?660=Jj`9Jb`<@XPH000<8@@=2:0:]E@?_GAkoo`005ooo
0lii0liI0V]=0aSS0`QQ1P000`Q11DY90jee0nmm1_oo0oNn0^mm0jDD0jDd0d880cW70bUU0P0P0`00
0`0P0`QQ0e::0kFf0[gg0lHh0oNn0ooo0ooO0oNn0^mm0nLl0nLL0mkK0g__0bU50P0P0`000`Q10a22
0a2R0aSS0b440R4T0h@`0mkK0ooO0ooo0ooO0/HH0e[[0e[;0a2R1P000PQ10d8X0jeE0nmM3_oo0lii
0/iI0f]=0aSS0`QQ1P000PQ11TY90jee0nmm1Ooo0oNn0nmm0jDD0jDd0d880SW70bUU0`0P0`000`0P
0`QQ0e::0[Ff0kgg0lHh0oNn0ooo0ooO0_Nn0nmm0nLl0nLL0mkK0g__0RU50`0P0`000`Q10a220a2R
0QSS0b440b4T0h@`0mkK0ooO0ooo0_oO0lHH0e[[0e[;0a2R1@000`Q10d8X0jeE0nmM3_oo0/ii0liI
0f]=0aSS0`QQ1@000`Q11TY90jee0nmm1Ooo0oNn0nmm0jDD0jDd0T880cW70bUU0`0P0`000`0P0PQQ
0e::0kFf0kgg0lHh0oNn0ooo0_oO0oNn0nmm0nLl0nLL0mkK0W__0bU50`0P0`000`Q10a220Q2R0aSS
0b440b4T0h@`0mkK0_oO0ooo0ooO0lHH0e[[0e[;0Q2R1P000`Q10d8X0jeE0nmM3Ooo0lii0liI0f]=
0aSS0PQQ1P000`Q11TY90Zee0nmm1_oo0oNn0nmm0jDD0ZDd0d880cW70bUU0`0P0`000P0P0`QQ0e::
0kFf0kgg0lHh0_Nn0ooo0ooO0oNn0nmm0nLl0^LL0mkK0g__0bU50`0P0`000PQ10a220a2R0aSS0b44
0b4T0h@`0]kK0ooO0ooo0ooO0lHH0e[[0U[;0a2R1P000`Q10d8X0ZeE0nmM7_oo000Gool3e[X3Ljh2
8@@3488600038@@3Nnl2e[X3oml3ool3g]/3e[X6eYX2cWT6Jfd36><60002020326434:836><38@@3
8B@2Q103g]/3oml3ool3mkh3kgd2ic`3ia`3g_/6Q103:DD26><300030203>NL6YA@3ked2oml3ool3
oml3mih3[ED3[GD2BTT3@PP3264300032645DXX3BVT3]IH3_ML3aQP3mkh8ool3e[X2Ljh38@@34886
00038@@2Nnl3e[X3oml3ool3g]/3e[X5eYX3cWT6Jfd36><50003020326434:836><38@@28B@3Q103
g]/3oml3ool3mkh2kgd3ic`3ia`3g_/6Q102:DD36><300030203>NL5YA@3ked3oml3ool3oml3mih3
[ED2[GD3BTT3@PP3264300032645DXX3BVT3]IH3_ML3aQP2mkh9ool2e[X3Ljh38@@3488600028@@3
Nnl3e[X3oml3ool3g]/2e[X6eYX3cWT6Jfd26><60003020326434:826><38@@38B@3Q103g]/3oml3
ool2mkh3kgd3ic`3ia`3g_/5Q103:DD36><300030203>NL5YA@3ked3oml3ool3oml2mih3[ED3[GD3
BTT3@PP3264200032646DXX3BVT3]IH3_ML2aQP3mkh8ool3e[X3Ljh38@@3488500038@@3Nnl3e[X3
oml2ool3g]/3e[X6eYX3cWT5Jfd36><60003020326424:836><38@@38B@3Q103g]/2oml3ool3mkh3
kgd3ic`3ia`2g_/6Q103:DD36><300020203>NL6YA@3ked3oml3ool2oml3mih3[ED3[GD3BTT3@PP2
264300032646DXX3BVT2]IH3_ML3aQP3mkhHool001Ooo`?F^P=c[P8Q10<@PPH000<Q10=kk`;F^P?o
g`?oo`?Nf`?F^PKFVP;>N@I[K@<Hh`H0008080<8H@<@XP<Hh`<Q10<Q90:440?Nf`?og`?oo`?g_P?_
O@;W?0?W70?Nn`J440<YA@8Hh`<000<080<ii`JU50?_G@;og`?oo`?og`?gWP>]E@>]M@9:B@=220<8
H@<000<8H@EBRP=:J@>eUP>me`?660?g_PSoo`?F^P9c[P<Q10<@PPH000<Q109kk`?F^P?og`?oo`?N
f`?F^PGFVP?>N@I[K@<Hh`D000<080<8H@<@XP<Hh`<Q108Q90>440?Nf`?og`?oo`?g_P;_O@?W?0?W
70?Nn`J4408YA@<Hh`<000<080<ii`FU50?_G@?og`?oo`?og`?gWP>]E@:]M@=:B@=220<8H@<000<8
H@EBRP=:J@>eUP>me`?660;g_PWoo`;F^P=c[P<Q10<@PPH0008Q10=kk`?F^P?og`?oo`?Nf`;F^PKF
VP?>N@I[K@8Hh`H000<080<8H@<@XP8Hh`<Q10<Q90>440?Nf`?og`?oo`;g_P?_O@?W?0?W70?Nn`F4
40<YA@<Hh`<000<080<ii`FU50?_G@?og`?oo`?og`;gWP>]E@>]M@=:B@=220<8H@8000<8H@IBRP=:
J@>eUP>me`;660?g_PSoo`?F^P=c[P<Q10<@PPD000<Q10=kk`?F^P?og`;oo`?Nf`?F^PKFVP?>N@E[
K@<Hh`H000<080<8H@8@XP<Hh`<Q10<Q90>440?Nf`;og`?oo`?g_P?_O@?W?0?W70;Nn`J440<YA@<H
h`<0008080<ii`JU50?_G@?og`?oo`;og`?gWP>]E@>]M@=:B@=22088H@<000<8H@IBRP=:J@:eUP>m
e`?660?g_QSoo`005ooo0mJj0g>^0R440a221P000b440g__0]Jj0ooO0ooo0mkK0mJj1]JJ0/ii1V]]
0aSS1P000P0P0`QQ0a2R0aSS0b440b4T0X@@0mkK0ooO0ooo0oNn0nmm0^Ll0nLL0mkk1X@@0bU50QSS
0`000`0P0cWW1ZDD0nmM0_oO0ooo0ooO0oNN0jeE0jee0TY90d880`QQ0`000`QQ1E::0dYY0kFF0kgG
0lHH0oNn2?oo0mJj0W>^0b440a221P000b440W__0mJj0ooO0ooo0mkK0mJj1MJJ0lii1V]]0aSS1@00
0`0P0`QQ0a2R0aSS0b440R4T0h@@0mkK0ooO0ooo0oNn0^mm0nLl0nLL0mkk1X@@0RU50aSS0`000`0P
0cWW1JDD0nmM0ooO0ooo0ooO0oNN0jeE0Zee0dY90d880`QQ0`000`QQ1E::0dYY0kFF0kgG0lHH0_Nn
2Ooo0]Jj0g>^0b440a221P000R440g__0mJj0ooO0ooo0mkK0]Jj1]JJ0lii1V]]0QSS1P000`0P0`QQ
0a2R0QSS0b440b4T0h@@0mkK0ooO0ooo0_Nn0nmm0nLl0nLL0mkk1H@@0bU50aSS0`000`0P0cWW1JDD
0nmM0ooO0ooo0ooO0_NN0jeE0jee0dY90d880`QQ0P000`QQ1U::0dYY0kFF0kgG0/HH0oNn2?oo0mJj
0g>^0b440a221@000b440g__0mJj0ooO0_oo0mkK0mJj1]JJ0lii1F]]0aSS1P000`0P0`QQ0Q2R0aSS
0b440b4T0h@@0mkK0_oO0ooo0oNn0nmm0nLl0nLL0]kk1X@@0bU50aSS0`000P0P0cWW1ZDD0nmM0ooO
0ooo0_oO0oNN0jeE0jee0dY90d880PQQ0`000`QQ1U::0dYY0[FF0kgG0lHH0oNn6?oo000Gool3e[X3
Ljh28@@3488600038@@3Nnl2e[X3oml3ool3g]/3e[X6eYX2cWT6Jfd36><60002020326434:836><3
8@@38B@2Q103g]/3oml3ool3mkh3kgd2ic`3ia`3g_/6Q103:DD26><300030203>NL6YA@3ked2oml3
ool3oml3mih3[ED3[GD2BTT3@PP3264300032645DXX3BVT3]IH3_ML3aQP3mkh8ool3e[X2Ljh38@@3
488600038@@2Nnl3e[X3oml3ool3g]/3e[X5eYX3cWT6Jfd36><50003020326434:836><38@@28B@3
Q103g]/3oml3ool3mkh2kgd3ic`3ia`3g_/6Q102:DD36><300030203>NL5YA@3ked3oml3ool3oml3
mih3[ED2[GD3BTT3@PP3264300032645DXX3BVT3]IH3_ML3aQP2mkh9ool2e[X3Ljh38@@348860002
8@@3Nnl3e[X3oml3ool3g]/2e[X6eYX3cWT6Jfd26><60003020326434:826><38@@38B@3Q103g]/3
oml3ool2mkh3kgd3ic`3ia`3g_/5Q103:DD36><300030203>NL5YA@3ked3oml3ool3oml2mih3[ED3
[GD3BTT3@PP3264200032646DXX3BVT3]IH3_ML2aQP3mkh8ool3e[X3Ljh38@@3488500038@@3Nnl3
e[X3oml2ool3g]/3e[X6eYX3cWT5Jfd36><60003020326424:836><38@@38B@3Q103g]/2oml3ool3
mkh3kgd3ic`3ia`2g_/6Q103:DD36><300020203>NL6YA@3ked3oml3ool2oml3mih3[ED3[GD3BTT3
@PP2264300032646DXX3BVT2]IH3_ML3aQP3mkhHool001Ooo`?F^P=c[P8Q10<@PPH000<Q10=kk`;F
^P?og`?oo`?Nf`?F^PKFVP;>N@I[K@<Hh`H0008080<8H@<@XP<Hh`<Q10<Q90:440?Nf`?og`?oo`?g
_P?_O@;W?0?W70?Nn`J440<YA@8Hh`<000<080<ii`JU50?_G@;og`?oo`?og`?gWP>]E@>]M@9:B@=2
20<8H@<000<8H@EBRP=:J@>eUP>me`?660?g_PSoo`?F^P9c[P<Q10<@PPH000<Q109kk`?F^P?og`?o
o`?Nf`?F^PGFVP?>N@I[K@<Hh`D000<080<8H@<@XP<Hh`<Q108Q90>440?Nf`?og`?oo`?g_P;_O@?W
?0?W70?Nn`J4408YA@<Hh`<000<080<ii`FU50?_G@?og`?oo`?og`?gWP>]E@:]M@=:B@=220<8H@<0
00<8H@EBRP=:J@>eUP>me`?660;g_PWoo`;F^P=c[P<Q10<@PPH0008Q10=kk`?F^P?og`?oo`?Nf`;F
^PKFVP?>N@I[K@8Hh`H000<080<8H@<@XP8Hh`<Q10<Q90>440?Nf`?og`?oo`;g_P?_O@?W?0?W70?N
n`F440<YA@<Hh`<000<080<ii`FU50?_G@?og`?oo`?og`;gWP>]E@>]M@=:B@=220<8H@8000<8H@IB
RP=:J@>eUP>me`;660?g_PSoo`?F^P=c[P<Q10<@PPD000<Q10=kk`?F^P?og`;oo`?Nf`?F^PKFVP?>
N@E[K@<Hh`H000<080<8H@8@XP<Hh`<Q10<Q90>440?Nf`;og`?oo`?g_P?_O@?W?0?W70;Nn`J440<Y
A@<Hh`<0008080<ii`JU50?_G@?og`?oo`;og`?gWP>]E@>]M@=:B@=22088H@<000<8H@IBRP=:J@:e
UP>me`?660?g_QSoo`005ooo0mJj0g>^0R440a221P000b440g__0]Jj0ooO0ooo0mkK0mJj1]JJ0/ii
1V]]0aSS1P000P0P0`QQ0a2R0aSS0b440b4T0X@@0mkK0ooO0ooo0oNn0nmm0^Ll0nLL0mkk1X@@0bU5
0QSS0`000`0P0cWW1ZDD0nmM0_oO0ooo0ooO0oNN0jeE0jee0TY90d880`QQ0`000`QQ1E::0dYY0kFF
0kgG0lHH0oNn2?oo0mJj0W>^0b440a221P000b440W__0mJj0ooO0ooo0mkK0mJj1MJJ0lii1V]]0aSS
1@000`0P0`QQ0a2R0aSS0b440R4T0h@@0mkK0ooO0ooo0oNn0^mm0nLl0nLL0mkk1X@@0RU50aSS0`00
0`0P0cWW1JDD0nmM0ooO0ooo0ooO0oNN0jeE0Zee0dY90d880`QQ0`000`QQ1E::0dYY0kFF0kgG0lHH
0_Nn2Ooo0]Jj0g>^0b440a221P000R440g__0mJj0ooO0ooo0mkK0]Jj1]JJ0lii1V]]0QSS1P000`0P
0`QQ0a2R0QSS0b440b4T0h@@0mkK0ooO0ooo0_Nn0nmm0nLl0nLL0mkk1H@@0bU50aSS0`000`0P0cWW
1JDD0nmM0ooO0ooo0ooO0_NN0jeE0jee0dY90d880`QQ0P000`QQ1U::0dYY0kFF0kgG0/HH0oNn2?oo
0mJj0g>^0b440a221@000b440g__0mJj0ooO0_oo0mkK0mJj1]JJ0lii1F]]0aSS1P000`0P0`QQ0Q2R
0aSS0b440b4T0h@@0mkK0_oO0ooo0oNn0nmm0nLl0nLL0]kk1X@@0bU50aSS0`000P0P0cWW1ZDD0nmM
0ooO0ooo0_oO0oNN0jeE0jee0dY90d880PQQ0`000`QQ1U::0dYY0[FF0kgG0lHH0oNn6?oo000Gool3
e[X3Ljh28@@3488600038@@3Nnl2e[X3oml3ool3g]/3e[X6eYX2cWT6Jfd36><60002020326434:83
6><38@@38B@2Q103g]/3oml3ool3mkh3kgd2ic`3ia`3g_/6Q103:DD26><300030203>NL6YA@3ked2
oml3ool3oml3mih3[ED3[GD2BTT3@PP3264300032645DXX3BVT3]IH3_ML3aQP3mkh8ool3e[X2Ljh3
8@@3488600038@@2Nnl3e[X3oml3ool3g]/3e[X5eYX3cWT6Jfd36><50003020326434:836><38@@2
8B@3Q103g]/3oml3ool3mkh2kgd3ic`3ia`3g_/6Q102:DD36><300030203>NL5YA@3ked3oml3ool3
oml3mih3[ED2[GD3BTT3@PP3264300032645DXX3BVT3]IH3_ML3aQP2mkh9ool2e[X3Ljh38@@34886
00028@@3Nnl3e[X3oml3ool3g]/2e[X6eYX3cWT6Jfd26><60003020326434:826><38@@38B@3Q103
g]/3oml3ool2mkh3kgd3ic`3ia`3g_/5Q103:DD36><300030203>NL5YA@3ked3oml3ool3oml2mih3
[ED3[GD3BTT3@PP3264200032646DXX3BVT3]IH3_ML2aQP3mkh8ool3e[X3Ljh38@@3488500038@@3
Nnl3e[X3oml2ool3g]/3e[X6eYX3cWT5Jfd36><60003020326424:836><38@@38B@3Q103g]/2oml3
ool3mkh3kgd3ic`3ia`2g_/6Q103:DD36><300020203>NL6YA@3ked3oml3ool2oml3mih3[ED3[GD3
BTT3@PP2264300032646DXX3BVT2]IH3_ML3aQP3mkhHool001Ooo`?F^P=c[P8Q10<@PPH000<Q10=k
k`;F^P?og`?oo`?Nf`?F^PKFVP;>N@I[K@<Hh`H0008080<8H@<@XP<Hh`<Q10<Q90:440?Nf`?og`?o
o`?g_P?_O@;W?0?W70?Nn`J440<YA@8Hh`<000<080<ii`JU50?_G@;og`?oo`?og`?gWP>]E@>]M@9:
B@=220<8H@<000<8H@EBRP=:J@>eUP>me`?660?g_PSoo`?F^P9c[P<Q10<@PPH000<Q109kk`?F^P?o
g`?oo`?Nf`?F^PGFVP?>N@I[K@<Hh`D000<080<8H@<@XP<Hh`<Q108Q90>440?Nf`?og`?oo`?g_P;_
O@?W?0?W70?Nn`J4408YA@<Hh`<000<080<ii`FU50?_G@?og`?oo`?og`?gWP>]E@:]M@=:B@=220<8
H@<000<8H@EBRP=:J@>eUP>me`?660;g_PWoo`;F^P=c[P<Q10<@PPH0008Q10=kk`?F^P?og`?oo`?N
f`;F^PKFVP?>N@I[K@8Hh`H000<080<8H@<@XP8Hh`<Q10<Q90>440?Nf`?og`?oo`;g_P?_O@?W?0?W
70?Nn`F440<YA@<Hh`<000<080<ii`FU50?_G@?og`?oo`?og`;gWP>]E@>]M@=:B@=220<8H@8000<8
H@IBRP=:J@>eUP>me`;660?g_PSoo`?F^P=c[P<Q10<@PPD000<Q10=kk`?F^P?og`;oo`?Nf`?F^PKF
VP?>N@E[K@<Hh`H000<080<8H@8@XP<Hh`<Q10<Q90>440?Nf`;og`?oo`?g_P?_O@?W?0?W70;Nn`J4
40<YA@<Hh`<0008080<ii`JU50?_G@?og`?oo`;og`?gWP>]E@>]M@=:B@=22088H@<000<8H@IBRP=:
J@:eUP>me`?660?g_QSoo`005ooo0mJj0g>^0R440a221P000b440g__0]Jj0ooO0ooo0mkK0mJj1]JJ
0/ii1V]]0aSS1P000P0P0`QQ0a2R0aSS0b440b4T0X@@0mkK0ooO0ooo0oNn0nmm0^Ll0nLL0mkk1X@@
0bU50QSS0`000`0P0cWW1ZDD0nmM0_oO0ooo0ooO0oNN0jeE0jee0TY90d880`QQ0`000`QQ1E::0dYY
0kFF0kgG0lHH0oNn2?oo0mJj0W>^0b440a221P000b440W__0mJj0ooO0ooo0mkK0mJj1MJJ0lii1V]]
0aSS1@000`0P0`QQ0a2R0aSS0b440R4T0h@@0mkK0ooO0ooo0oNn0^mm0nLl0nLL0mkk1X@@0RU50aSS
0`000`0P0cWW1JDD0nmM0ooO0ooo0ooO0oNN0jeE0Zee0dY90d880`QQ0`000`QQ1E::0dYY0kFF0kgG
0lHH0_Nn2Ooo0]Jj0g>^0b440a221P000R440g__0mJj0ooO0ooo0mkK0]Jj1]JJ0lii1V]]0QSS1P00
0`0P0`QQ0a2R0QSS0b440b4T0h@@0mkK0ooO0ooo0_Nn0nmm0nLl0nLL0mkk1H@@0bU50aSS0`000`0P
0cWW1JDD0nmM0ooO0ooo0ooO0_NN0jeE0jee0dY90d880`QQ0P000`QQ1U::0dYY0kFF0kgG0/HH0oNn
2?oo0mJj0g>^0b440a221@000b440g__0mJj0ooO0_oo0mkK0mJj1]JJ0lii1F]]0aSS1P000`0P0`QQ
0Q2R0aSS0b440b4T0h@@0mkK0_oO0ooo0oNn0nmm0nLl0nLL0]kk1X@@0bU50aSS0`000P0P0cWW1ZDD
0nmM0ooO0ooo0_oO0oNN0jeE0jee0dY90d880PQQ0`000`QQ1U::0dYY0[FF0kgG0lHH0oNn6?oo000G
ool3e[X3Ljh28@@3488600038@@3Nnl2e[X3oml3ool3g]/3e[X6eYX2cWT6Jfd36><6000202032643
4:836><38@@38B@2Q103g]/3oml3ool3mkh3kgd2ic`3ia`3g_/6Q103:DD26><300030203>NL6YA@3
ked2oml3ool3oml3mih3[ED3[GD2BTT3@PP3264300032645DXX3BVT3]IH3_ML3aQP3mkh8ool3e[X2
Ljh38@@3488600038@@2Nnl3e[X3oml3ool3g]/3e[X5eYX3cWT6Jfd36><50003020326434:836><3
8@@28B@3Q103g]/3oml3ool3mkh2kgd3ic`3ia`3g_/6Q102:DD36><300030203>NL5YA@3ked3oml3
ool3oml3mih3[ED2[GD3BTT3@PP3264300032645DXX3BVT3]IH3_ML3aQP2mkh9ool2e[X3Ljh38@@3
488600028@@3Nnl3e[X3oml3ool3g]/2e[X6eYX3cWT6Jfd26><60003020326434:826><38@@38B@3
Q103g]/3oml3ool2mkh3kgd3ic`3ia`3g_/5Q103:DD36><300030203>NL5YA@3ked3oml3ool3oml2
mih3[ED3[GD3BTT3@PP3264200032646DXX3BVT3]IH3_ML2aQP3mkh8ool3e[X3Ljh38@@348850003
8@@3Nnl3e[X3oml2ool3g]/3e[X6eYX3cWT5Jfd36><60003020326424:836><38@@38B@3Q103g]/2
oml3ool3mkh3kgd3ic`3ia`2g_/6Q103:DD36><300020203>NL6YA@3ked3oml3ool2oml3mih3[ED3
[GD3BTT3@PP2264300032646DXX3BVT2]IH3_ML3aQP3mkhHool001Ooo`?F^P=c[P8Q10<@PPH000<Q
10=kk`;F^P?og`?oo`?Nf`?F^PKFVP;>N@I[K@<Hh`H0008080<8H@<@XP<Hh`<Q10<Q90:440?Nf`?o
g`?oo`?g_P?_O@;W?0?W70?Nn`J440<YA@8Hh`<000<080<ii`JU50?_G@;og`?oo`?og`?gWP>]E@>]
M@9:B@=220<8H@<000<8H@EBRP=:J@>eUP>me`?660?g_PSoo`?F^P9c[P<Q10<@PPH000<Q109kk`?F
^P?og`?oo`?Nf`?F^PGFVP?>N@I[K@<Hh`D000<080<8H@<@XP<Hh`<Q108Q90>440?Nf`?og`?oo`?g
_P;_O@?W?0?W70?Nn`J4408YA@<Hh`<000<080<ii`FU50?_G@?og`?oo`?og`?gWP>]E@:]M@=:B@=2
20<8H@<000<8H@EBRP=:J@>eUP>me`?660;g_PWoo`;F^P=c[P<Q10<@PPH0008Q10=kk`?F^P?og`?o
o`?Nf`;F^PKFVP?>N@I[K@8Hh`H000<080<8H@<@XP8Hh`<Q10<Q90>440?Nf`?og`?oo`;g_P?_O@?W
?0?W70?Nn`F440<YA@<Hh`<000<080<ii`FU50?_G@?og`?oo`?og`;gWP>]E@>]M@=:B@=220<8H@80
00<8H@IBRP=:J@>eUP>me`;660?g_PSoo`?F^P=c[P<Q10<@PPD000<Q10=kk`?F^P?og`;oo`?Nf`?F
^PKFVP?>N@E[K@<Hh`H000<080<8H@8@XP<Hh`<Q10<Q90>440?Nf`;og`?oo`?g_P?_O@?W?0?W70;N
n`J440<YA@<Hh`<0008080<ii`JU50?_G@?og`?oo`;og`?gWP>]E@>]M@=:B@=22088H@<000<8H@IB
RP=:J@:eUP>me`?660?g_QSoo`006_oo0nmm0^Ll0iBB0iBb0icC0cW70`Q10P000`0P0`Q11TYY0kFF
0nmm0_oo0oNN0nmM0nLl0mkk0h@`0RUU0aSS0`QQ1P000`Q10Q220aS30aSS0b440b4T0bU51BUU1YBB
0mkk0oNN1Ooo0oNn0nmm0jDD0cWW0`Q10P000a220f<<0e[[0kgg0oNN0_oo0nmm0nLl0nLL0h@`0haA
0RUU0`0P0`000`0P0`QQ0e::2ooo0^mm0nLl0iBB0iBb0icC0cW70PQ10`000`0P0`Q11TYY0[FF0nmm
0ooo0oNN0nmM0nLl0]kk0h@`0bUU0aSS0`QQ1P000PQ10a220aS30aSS0b440b4T0RU51RUU1YBB0mkk
0_NN1_oo0oNn0nmm0jDD0SWW0`Q10`000a220f<<0e[[0kgg0_NN0ooo0nmm0nLl0nLL0h@`0XaA0bUU
0`0P0`000`0P0`QQ0U::2ooo0nmm0nLl0iBB0iBb0icC0SW70`Q10`000`0P0`Q11DYY0kFF0nmm0ooo
0oNN0nmM0^Ll0mkk0h@`0bUU0aSS0`QQ1@000`Q10a220aS30aSS0b440R4T0bU51RUU1YBB0]kk0oNN
1_oo0oNn0nmm0ZDD0cWW0`Q10`000a220f<<0U[[0kgg0oNN0ooo0nmm0nLl0^LL0h@`0haA0bUU0`0P
0`000`0P0PQQ0e::2ooo0nmm0nLl0iBB0YBb0icC0cW70`Q10`000`0P0PQ11TYY0kFF0nmm0ooo0oNN
0^mM0nLl0mkk0h@`0bUU0aSS0PQQ1P000`Q10a220aS30QSS0b440b4T0bU51RUU1IBB0mkk0oNN1_oo
0_Nn0nmm0jDD0cWW0`Q10`000a220V<<0e[[0kgg0oNN0ooo0nmm0^Ll0nLL0h@`0haA0bUU0`0P0P00
0`0P0`QQ0e::6?oo000Jool3kgd2ic`3U983U;83W=<3>LL32442000302032446BVT3]IH3kgd2ool3
mih3ked3ic`3g_/3Q302:FD36><326460003244248836<<36><38@@38B@3:DD5:FD6U983g_/3mih5
ool3mkh3kgd3YA@3>NL3244200034883H``3F^/3_OL3mih2ool3kgd3ic`3ia`3Q303S542:FD30203
000302032643DXX;ool2kgd3ic`3U983U;83W=<3>LL22443000302032446BVT2]IH3kgd3ool3mih3
ked3ic`2g_/3Q303:FD36><326460002244348836<<36><38@@38B@2:DD6:FD6U983g_/2mih6ool3
mkh3kgd3YA@2>NL3244300034883H``3F^/3_OL2mih3ool3kgd3ic`3ia`3Q302S543:FD302030003
02032642DXX;ool3kgd3ic`3U983U;83W=<2>LL32443000302032445BVT3]IH3kgd3ool3mih3ked2
ic`3g_/3Q303:FD36><326450003244348836<<36><38@@28B@3:DD6:FD6U982g_/3mih6ool3mkh3
kgd2YA@3>NL3244300034883H``2F^/3_OL3mih3ool3kgd3ic`2ia`3Q303S543:FD3020300030202
2643DXX;ool3kgd3ic`3U982U;83W=<3>LL32443000302022446BVT3]IH3kgd3ool3mih2ked3ic`3
g_/3Q303:FD36><226460003244348836<<26><38@@38B@3:DD6:FD5U983g_/3mih6ool2mkh3kgd3
YA@3>NL3244300034882H``3F^/3_OL3mih3ool3kgd2ic`3ia`3Q303S543:FD30202000302032643
DXXHool001[oo`?_O@;W?0>DTP>D/P>Ld`<ia`<8@@8000<080<8@@I:J@>eUP?_O@;oo`?gWP?_G@?W
?0?Nn`>4<08YI@<Hh`<8H@H000<8@@8@PP<H``<Hh`<Q10<Q90<YA@DYI@JDTP?Nn`?gWPGoo`?g_P?_
O@>U50<ii`<8@@8000<@PP=S30=Jj`>mm`?gWP;oo`?_O@?W?0?W70>4<0><D@8YI@<080<000<080<8
H@=BRP_oo`;_O@?W?0>DTP>D/P>Ld`<ia`88@@<000<080<8@@I:J@:eUP?_O@?oo`?gWP?_G@?W?0;N
n`>4<0<YI@<Hh`<8H@H00088@@<@PP<H``<Hh`<Q10<Q908YA@HYI@JDTP?Nn`;gWPKoo`?g_P?_O@>U
508ii`<8@@<000<@PP=S30=Jj`>mm`;gWP?oo`?_O@?W?0?W70>4<0:<D@<YI@<080<000<080<8H@9B
RP_oo`?_O@?W?0>DTP>D/P>Ld`8ia`<8@@<000<080<8@@E:J@>eUP?_O@?oo`?gWP?_G@;W?0?Nn`>4
<0<YI@<Hh`<8H@D000<8@@<@PP<H``<Hh`<Q108Q90<YA@HYI@JDTP;Nn`?gWPKoo`?g_P?_O@:U50<i
i`<8@@<000<@PP=S309Jj`>mm`?gWP?oo`?_O@?W?0;W70>4<0><D@<YI@<080<000<08088H@=BRP_o
o`?_O@?W?0>DTP:D/P>Ld`<ia`<8@@<000<08088@@I:J@>eUP?_O@?oo`?gWP;_G@?W?0?Nn`>4<0<Y
I@<Hh`88H@H000<8@@<@PP<H``8Hh`<Q10<Q90<YA@HYI@FDTP?Nn`?gWPKoo`;g_P?_O@>U50<ii`<8
@@<000<@PP9S30=Jj`>mm`?gWP?oo`?_O@;W?0?W70>4<0><D@<YI@<0808000<080<8H@=BRQSoo`00
6_oo0nmm0^Ll0iBB0iBb0icC0cW70`Q10P000`0P0`Q11TYY0kFF0nmm0_oo0oNN0nmM0nLl0mkk0h@`
0RUU0aSS0`QQ1P000`Q10Q220aS30aSS0b440b4T0bU51BUU1YBB0mkk0oNN1Ooo0oNn0nmm0jDD0cWW
0`Q10P000a220f<<0e[[0kgg0oNN0_oo0nmm0nLl0nLL0h@`0haA0RUU0`0P0`000`0P0`QQ0e::2ooo
0^mm0nLl0iBB0iBb0icC0cW70PQ10`000`0P0`Q11TYY0[FF0nmm0ooo0oNN0nmM0nLl0]kk0h@`0bUU
0aSS0`QQ1P000PQ10a220aS30aSS0b440b4T0RU51RUU1YBB0mkk0_NN1_oo0oNn0nmm0jDD0SWW0`Q1
0`000a220f<<0e[[0kgg0_NN0ooo0nmm0nLl0nLL0h@`0XaA0bUU0`0P0`000`0P0`QQ0U::2ooo0nmm
0nLl0iBB0iBb0icC0SW70`Q10`000`0P0`Q11DYY0kFF0nmm0ooo0oNN0nmM0^Ll0mkk0h@`0bUU0aSS
0`QQ1@000`Q10a220aS30aSS0b440R4T0bU51RUU1YBB0]kk0oNN1_oo0oNn0nmm0ZDD0cWW0`Q10`00
0a220f<<0U[[0kgg0oNN0ooo0nmm0nLl0^LL0h@`0haA0bUU0`0P0`000`0P0PQQ0e::2ooo0nmm0nLl
0iBB0YBb0icC0cW70`Q10`000`0P0PQ11TYY0kFF0nmm0ooo0oNN0^mM0nLl0mkk0h@`0bUU0aSS0PQQ
1P000`Q10a220aS30QSS0b440b4T0bU51RUU1IBB0mkk0oNN1_oo0_Nn0nmm0jDD0cWW0`Q10`000a22
0V<<0e[[0kgg0oNN0ooo0nmm0^Ll0nLL0h@`0haA0bUU0`0P0P000`0P0`QQ0e::6?oo000Jool3kgd2
ic`3U983U;83W=<3>LL32442000302032446BVT3]IH3kgd2ool3mih3ked3ic`3g_/3Q302:FD36><3
26460003244248836<<36><38@@38B@3:DD5:FD6U983g_/3mih5ool3mkh3kgd3YA@3>NL324420003
4883H``3F^/3_OL3mih2ool3kgd3ic`3ia`3Q303S542:FD30203000302032643DXX;ool2kgd3ic`3
U983U;83W=<3>LL22443000302032446BVT2]IH3kgd3ool3mih3ked3ic`2g_/3Q303:FD36><32646
0002244348836<<36><38@@38B@2:DD6:FD6U983g_/2mih6ool3mkh3kgd3YA@2>NL3244300034883
H``3F^/3_OL2mih3ool3kgd3ic`3ia`3Q302S543:FD30203000302032642DXX;ool3kgd3ic`3U983
U;83W=<2>LL32443000302032445BVT3]IH3kgd3ool3mih3ked2ic`3g_/3Q303:FD36><326450003
244348836<<36><38@@28B@3:DD6:FD6U982g_/3mih6ool3mkh3kgd2YA@3>NL3244300034883H``2
F^/3_OL3mih3ool3kgd3ic`2ia`3Q303S543:FD30203000302022643DXX;ool3kgd3ic`3U982U;83
W=<3>LL32443000302022446BVT3]IH3kgd3ool3mih2ked3ic`3g_/3Q303:FD36><2264600032443
48836<<26><38@@38B@3:DD6:FD5U983g_/3mih6ool2mkh3kgd3YA@3>NL3244300034882H``3F^/3
_OL3mih3ool3kgd2ic`3ia`3Q303S543:FD30202000302032643DXXHool001[oo`?_O@;W?0>DTP>D
/P>Ld`<ia`<8@@8000<080<8@@I:J@>eUP?_O@;oo`?gWP?_G@?W?0?Nn`>4<08YI@<Hh`<8H@H000<8
@@8@PP<H``<Hh`<Q10<Q90<YA@DYI@JDTP?Nn`?gWPGoo`?g_P?_O@>U50<ii`<8@@8000<@PP=S30=J
j`>mm`?gWP;oo`?_O@?W?0?W70>4<0><D@8YI@<080<000<080<8H@=BRP_oo`;_O@?W?0>DTP>D/P>L
d`<ia`88@@<000<080<8@@I:J@:eUP?_O@?oo`?gWP?_G@?W?0;Nn`>4<0<YI@<Hh`<8H@H00088@@<@
PP<H``<Hh`<Q10<Q908YA@HYI@JDTP?Nn`;gWPKoo`?g_P?_O@>U508ii`<8@@<000<@PP=S30=Jj`>m
m`;gWP?oo`?_O@?W?0?W70>4<0:<D@<YI@<080<000<080<8H@9BRP_oo`?_O@?W?0>DTP>D/P>Ld`8i
a`<8@@<000<080<8@@E:J@>eUP?_O@?oo`?gWP?_G@;W?0?Nn`>4<0<YI@<Hh`<8H@D000<8@@<@PP<H
``<Hh`<Q108Q90<YA@HYI@JDTP;Nn`?gWPKoo`?g_P?_O@:U50<ii`<8@@<000<@PP=S309Jj`>mm`?g
WP?oo`?_O@?W?0;W70>4<0><D@<YI@<080<000<08088H@=BRP_oo`?_O@?W?0>DTP:D/P>Ld`<ia`<8
@@<000<08088@@I:J@>eUP?_O@?oo`?gWP;_G@?W?0?Nn`>4<0<YI@<Hh`88H@H000<8@@<@PP<H``8H
h`<Q10<Q90<YA@HYI@FDTP?Nn`?gWPKoo`;g_P?_O@>U50<ii`<8@@<000<@PP9S30=Jj`>mm`?gWP?o
o`?_O@;W?0?W70>4<0><D@<YI@<0808000<080<8H@=BRQSoo`006_oo0nmm0^Ll0iBB0iBb0icC0cW7
0`Q10P000`0P0`Q11TYY0kFF0nmm0_oo0oNN0nmM0nLl0mkk0h@`0RUU0aSS0`QQ1P000`Q10Q220aS3
0aSS0b440b4T0bU51BUU1YBB0mkk0oNN1Ooo0oNn0nmm0jDD0cWW0`Q10P000a220f<<0e[[0kgg0oNN
0_oo0nmm0nLl0nLL0h@`0haA0RUU0`0P0`000`0P0`QQ0e::2ooo0^mm0nLl0iBB0iBb0icC0cW70PQ1
0`000`0P0`Q11TYY0[FF0nmm0ooo0oNN0nmM0nLl0]kk0h@`0bUU0aSS0`QQ1P000PQ10a220aS30aSS
0b440b4T0RU51RUU1YBB0mkk0_NN1_oo0oNn0nmm0jDD0SWW0`Q10`000a220f<<0e[[0kgg0_NN0ooo
0nmm0nLl0nLL0h@`0XaA0bUU0`0P0`000`0P0`QQ0U::2ooo0nmm0nLl0iBB0iBb0icC0SW70`Q10`00
0`0P0`Q11DYY0kFF0nmm0ooo0oNN0nmM0^Ll0mkk0h@`0bUU0aSS0`QQ1@000`Q10a220aS30aSS0b44
0R4T0bU51RUU1YBB0]kk0oNN1_oo0oNn0nmm0ZDD0cWW0`Q10`000a220f<<0U[[0kgg0oNN0ooo0nmm
0nLl0^LL0h@`0haA0bUU0`0P0`000`0P0PQQ0e::2ooo0nmm0nLl0iBB0YBb0icC0cW70`Q10`000`0P
0PQ11TYY0kFF0nmm0ooo0oNN0^mM0nLl0mkk0h@`0bUU0aSS0PQQ1P000`Q10a220aS30QSS0b440b4T
0bU51RUU1IBB0mkk0oNN1_oo0_Nn0nmm0jDD0cWW0`Q10`000a220V<<0e[[0kgg0oNN0ooo0nmm0^Ll
0nLL0h@`0haA0bUU0`0P0P000`0P0`QQ0e::6?oo000Jool3kgd2ic`3U983U;83W=<3>LL324420003
02032446BVT3]IH3kgd2ool3mih3ked3ic`3g_/3Q302:FD36><326460003244248836<<36><38@@3
8B@3:DD5:FD6U983g_/3mih5ool3mkh3kgd3YA@3>NL3244200034883H``3F^/3_OL3mih2ool3kgd3
ic`3ia`3Q303S542:FD30203000302032643DXX;ool2kgd3ic`3U983U;83W=<3>LL2244300030203
2446BVT2]IH3kgd3ool3mih3ked3ic`2g_/3Q303:FD36><326460002244348836<<36><38@@38B@2
:DD6:FD6U983g_/2mih6ool3mkh3kgd3YA@2>NL3244300034883H``3F^/3_OL2mih3ool3kgd3ic`3
ia`3Q302S543:FD30203000302032642DXX;ool3kgd3ic`3U983U;83W=<2>LL32443000302032445
BVT3]IH3kgd3ool3mih3ked2ic`3g_/3Q303:FD36><326450003244348836<<36><38@@28B@3:DD6
:FD6U982g_/3mih6ool3mkh3kgd2YA@3>NL3244300034883H``2F^/3_OL3mih3ool3kgd3ic`2ia`3
Q303S543:FD30203000302022643DXX;ool3kgd3ic`3U982U;83W=<3>LL32443000302022446BVT3
]IH3kgd3ool3mih2ked3ic`3g_/3Q303:FD36><226460003244348836<<26><38@@38B@3:DD6:FD5
U983g_/3mih6ool2mkh3kgd3YA@3>NL3244300034882H``3F^/3_OL3mih3ool3kgd2ic`3ia`3Q303
S543:FD30202000302032643DXXHool001[oo`?_O@;W?0>DTP>D/P>Ld`<ia`<8@@8000<080<8@@I:
J@>eUP?_O@;oo`?gWP?_G@?W?0?Nn`>4<08YI@<Hh`<8H@H000<8@@8@PP<H``<Hh`<Q10<Q90<YA@DY
I@JDTP?Nn`?gWPGoo`?g_P?_O@>U50<ii`<8@@8000<@PP=S30=Jj`>mm`?gWP;oo`?_O@?W?0?W70>4
<0><D@8YI@<080<000<080<8H@=BRP_oo`;_O@?W?0>DTP>D/P>Ld`<ia`88@@<000<080<8@@I:J@:e
UP?_O@?oo`?gWP?_G@?W?0;Nn`>4<0<YI@<Hh`<8H@H00088@@<@PP<H``<Hh`<Q10<Q908YA@HYI@JD
TP?Nn`;gWPKoo`?g_P?_O@>U508ii`<8@@<000<@PP=S30=Jj`>mm`;gWP?oo`?_O@?W?0?W70>4<0:<
D@<YI@<080<000<080<8H@9BRP_oo`?_O@?W?0>DTP>D/P>Ld`8ia`<8@@<000<080<8@@E:J@>eUP?_
O@?oo`?gWP?_G@;W?0?Nn`>4<0<YI@<Hh`<8H@D000<8@@<@PP<H``<Hh`<Q108Q90<YA@HYI@JDTP;N
n`?gWPKoo`?g_P?_O@:U50<ii`<8@@<000<@PP=S309Jj`>mm`?gWP?oo`?_O@?W?0;W70>4<0><D@<Y
I@<080<000<08088H@=BRP_oo`?_O@?W?0>DTP:D/P>Ld`<ia`<8@@<000<08088@@I:J@>eUP?_O@?o
o`?gWP;_G@?W?0?Nn`>4<0<YI@<Hh`88H@H000<8@@<@PP<H``8Hh`<Q10<Q90<YA@HYI@FDTP?Nn`?g
WPKoo`;g_P?_O@>U50<ii`<8@@<000<@PP9S30=Jj`>mm`?gWP?oo`?_O@;W?0?W70>4<0><D@<YI@<0
808000<080<8H@=BRQSoo`006_oo0nmm0^Ll0iBB0iBb0icC0cW70`Q10P000`0P0`Q11TYY0kFF0nmm
0_oo0oNN0nmM0nLl0mkk0h@`0RUU0aSS0`QQ1P000`Q10Q220aS30aSS0b440b4T0bU51BUU1YBB0mkk
0oNN1Ooo0oNn0nmm0jDD0cWW0`Q10P000a220f<<0e[[0kgg0oNN0_oo0nmm0nLl0nLL0h@`0haA0RUU
0`0P0`000`0P0`QQ0e::2ooo0^mm0nLl0iBB0iBb0icC0cW70PQ10`000`0P0`Q11TYY0[FF0nmm0ooo
0oNN0nmM0nLl0]kk0h@`0bUU0aSS0`QQ1P000PQ10a220aS30aSS0b440b4T0RU51RUU1YBB0mkk0_NN
1_oo0oNn0nmm0jDD0SWW0`Q10`000a220f<<0e[[0kgg0_NN0ooo0nmm0nLl0nLL0h@`0XaA0bUU0`0P
0`000`0P0`QQ0U::2ooo0nmm0nLl0iBB0iBb0icC0SW70`Q10`000`0P0`Q11DYY0kFF0nmm0ooo0oNN
0nmM0^Ll0mkk0h@`0bUU0aSS0`QQ1@000`Q10a220aS30aSS0b440R4T0bU51RUU1YBB0]kk0oNN1_oo
0oNn0nmm0ZDD0cWW0`Q10`000a220f<<0U[[0kgg0oNN0ooo0nmm0nLl0^LL0h@`0haA0bUU0`0P0`00
0`0P0PQQ0e::2ooo0nmm0nLl0iBB0YBb0icC0cW70`Q10`000`0P0PQ11TYY0kFF0nmm0ooo0oNN0^mM
0nLl0mkk0h@`0bUU0aSS0PQQ1P000`Q10a220aS30QSS0b440b4T0bU51RUU1IBB0mkk0oNN1_oo0_Nn
0nmm0jDD0cWW0`Q10`000a220V<<0e[[0kgg0oNN0ooo0nmm0^Ll0nLL0h@`0haA0bUU0`0P0P000`0P
0`QQ0e::6?oo000Jool3kgd2ic`3U983U;83W=<3>LL32442000302032446BVT3]IH3kgd2ool3mih3
ked3ic`3g_/3Q302:FD36><326460003244248836<<36><38@@38B@3:DD5:FD6U983g_/3mih5ool3
mkh3kgd3YA@3>NL3244200034883H``3F^/3_OL3mih2ool3kgd3ic`3ia`3Q303S542:FD302030003
02032643DXX;ool2kgd3ic`3U983U;83W=<3>LL22443000302032446BVT2]IH3kgd3ool3mih3ked3
ic`2g_/3Q303:FD36><326460002244348836<<36><38@@38B@2:DD6:FD6U983g_/2mih6ool3mkh3
kgd3YA@2>NL3244300034883H``3F^/3_OL2mih3ool3kgd3ic`3ia`3Q302S543:FD3020300030203
2642DXX;ool3kgd3ic`3U983U;83W=<2>LL32443000302032445BVT3]IH3kgd3ool3mih3ked2ic`3
g_/3Q303:FD36><326450003244348836<<36><38@@28B@3:DD6:FD6U982g_/3mih6ool3mkh3kgd2
YA@3>NL3244300034883H``2F^/3_OL3mih3ool3kgd3ic`2ia`3Q303S543:FD30203000302022643
DXX;ool3kgd3ic`3U982U;83W=<3>LL32443000302022446BVT3]IH3kgd3ool3mih2ked3ic`3g_/3
Q303:FD36><226460003244348836<<26><38@@38B@3:DD6:FD5U983g_/3mih6ool2mkh3kgd3YA@3
>NL3244300034882H``3F^/3_OL3mih3ool3kgd2ic`3ia`3Q303S543:FD30202000302032643DXXH
ool001Ooo`I:J@:eUP>e]P>mm`?gWPKoo`;>N@a[C@<Hh`D000<080I220>U=0?_G@Goo`?g_P?_O@>U
=0=22088H@H000HaQP<aYP:D/PVLd`?W?0Goo`?og`>mm`=Jb`=BZP<@PP<0808000<080<8H@<@XP<H
``=cSP9[K@I[C@?6>0?g_P?oo`;og`?gWPJeUP>e]P=BRPSoo`E:J@>eUP>e]P>mm`?gWPGoo`?>N@a[
C@8Hh`H000<080I220:U=0?_G@Koo`?g_P?_O@>U=09220<8H@H000HaQP8aYP>D/PVLd`?W?0Goo`?o
g`>mm`=Jb`=BZP8@PP<080<000<080<8H@<@XP<H``9cSP=[K@I[C@?6>0?g_P;oo`?og`?gWPJeUP>e
]P9BRPWoo`E:J@>eUP>e]P>mm`?gWPGoo`?>N@][C@<Hh`H000<080E220>U=0?_G@Koo`?g_P;_O@>U
=0=220<8H@H000DaQP<aYP>D/PVLd`;W?0Koo`?og`>mm`=Jb`9BZP<@PP<080<000<080<8H@8@XP<H
``=cSP=[K@I[C@;6>0?g_P?oo`?og`?gWPJeUP:e]P=BRPSoo`I:J@>eUP>e]P:mm`?gWPKoo`?>N@][
C@<Hh`H000<080E220>U=0?_G@Koo`;g_P?_O@>U=0=220<8H@D000HaQP<aYP>D/PRLd`?W?0Koo`?o
g`:mm`=Jb`=BZP<@PP<080<000<08088H@<@XP<H``=cSP=[K@E[C@?6>0?g_P?oo`?og`?gWPFeUP>e
]P=BRQSoo`005ooo1TYY0[FF0kFf0kgg0oNN1_oo0/ii36]=0aSS1@000`0P1T880jDd0nmM1Ooo0oNn
0nmm0jDd0d880PQQ1P001S660c6V0YBb2IcC0nLl1Ooo0ooO0kgg0e[;0e:Z0a220`0P0P000`0P0`QQ
0a2R0aS30g>>0V]]1V]=0lHh0oNn0ooo0_oO0oNN1[FF0kFf0e::2?oo1DYY0kFF0kFf0kgg0oNN1Ooo
0lii36]=0QSS1P000`0P1T880ZDd0nmM1_oo0oNn0nmm0jDd0T880`QQ1P001S660S6V0iBb2IcC0nLl
1Ooo0ooO0kgg0e[;0e:Z0Q220`0P0`000`0P0`QQ0a2R0aS30W>>0f]]1V]=0lHh0oNn0_oo0ooO0oNN
1[FF0kFf0U::2Ooo1DYY0kFF0kFf0kgg0oNN1Ooo0lii2f]=0aSS1P000`0P1D880jDd0nmM1_oo0oNn
0^mm0jDd0d880`QQ1P001C660c6V0iBb2IcC0^Ll1_oo0ooO0kgg0e[;0U:Z0a220`0P0`000`0P0`QQ
0Q2R0aS30g>>0f]]1V]=0/Hh0oNn0ooo0ooO0oNN1[FF0[Ff0e::2?oo1TYY0kFF0kFf0[gg0oNN1_oo
0lii2f]=0aSS1P000`0P1D880jDd0nmM1_oo0_Nn0nmm0jDd0d880`QQ1@001S660c6V0iBb29cC0nLl
1_oo0ooO0[gg0e[;0e:Z0a220`0P0`000`0P0PQQ0a2R0aS30g>>0f]]1F]=0lHh0oNn0ooo0ooO0oNN
1KFF0kFf0e::6?oo000Gool6BVT2]IH3]KH3_OL3mih6ool2cWT<Jdd36><500030206@PP3YC@3ked5
ool3mkh3kgd3YC@3@PP226460006<HH3<JH2U;89W=<3ic`5ool3oml3_OL3F//3DZX3488302020003
020326434:836<<3Lhh2Jfd6Jdd3aSP3mkh3ool2oml3mih6]IH3]KH3DXX8ool5BVT3]IH3]KH3_OL3
mih5ool3cWT<Jdd26><600030206@PP2YC@3ked6ool3mkh3kgd3YC@2@PP326460006<HH2<JH3U;89
W=<3ic`5ool3oml3_OL3F//3DZX2488302030003020326434:836<<2Lhh3Jfd6Jdd3aSP3mkh2ool3
oml3mih6]IH3]KH2DXX9ool5BVT3]IH3]KH3_OL3mih5ool3cWT;Jdd36><600030205@PP3YC@3ked6
ool3mkh2kgd3YC@3@PP326460005<HH3<JH3U;89W=<2ic`6ool3oml3_OL3F//2DZX3488302030003
020326424:836<<3Lhh3Jfd6Jdd2aSP3mkh3ool3oml3mih6]IH2]KH3DXX8ool6BVT3]IH3]KH2_OL3
mih6ool3cWT;Jdd36><600030205@PP3YC@3ked6ool2mkh3kgd3YC@3@PP326450006<HH3<JH3U;88
W=<3ic`6ool3oml2_OL3F//3DZX3488302030003020226434:836<<3Lhh3Jfd5Jdd3aSP3mkh3ool3
oml3mih5]IH3]KH3DXXHool001Ooo`I:J@:eUP>e]P>mm`?gWPKoo`;>N@a[C@<Hh`D000<080I220>U
=0?_G@Goo`?g_P?_O@>U=0=22088H@H000HaQP<aYP:D/PVLd`?W?0Goo`?og`>mm`=Jb`=BZP<@PP<0
808000<080<8H@<@XP<H``=cSP9[K@I[C@?6>0?g_P?oo`;og`?gWPJeUP>e]P=BRPSoo`E:J@>eUP>e
]P>mm`?gWPGoo`?>N@a[C@8Hh`H000<080I220:U=0?_G@Koo`?g_P?_O@>U=09220<8H@H000HaQP8a
YP>D/PVLd`?W?0Goo`?og`>mm`=Jb`=BZP8@PP<080<000<080<8H@<@XP<H``9cSP=[K@I[C@?6>0?g
_P;oo`?og`?gWPJeUP>e]P9BRPWoo`E:J@>eUP>e]P>mm`?gWPGoo`?>N@][C@<Hh`H000<080E220>U
=0?_G@Koo`?g_P;_O@>U=0=220<8H@H000DaQP<aYP>D/PVLd`;W?0Koo`?og`>mm`=Jb`9BZP<@PP<0
80<000<080<8H@8@XP<H``=cSP=[K@I[C@;6>0?g_P?oo`?og`?gWPJeUP:e]P=BRPSoo`I:J@>eUP>e
]P:mm`?gWPKoo`?>N@][C@<Hh`H000<080E220>U=0?_G@Koo`;g_P?_O@>U=0=220<8H@D000HaQP<a
YP>D/PRLd`?W?0Koo`?og`:mm`=Jb`=BZP<@PP<080<000<08088H@<@XP<H``=cSP=[K@E[C@?6>0?g
_P?oo`?og`?gWPFeUP>e]P=BRQSoo`005ooo1TYY0[FF0kFf0kgg0oNN1_oo0/ii36]=0aSS1@000`0P
1T880jDd0nmM1Ooo0oNn0nmm0jDd0d880PQQ1P001S660c6V0YBb2IcC0nLl1Ooo0ooO0kgg0e[;0e:Z
0a220`0P0P000`0P0`QQ0a2R0aS30g>>0V]]1V]=0lHh0oNn0ooo0_oO0oNN1[FF0kFf0e::2?oo1DYY
0kFF0kFf0kgg0oNN1Ooo0lii36]=0QSS1P000`0P1T880ZDd0nmM1_oo0oNn0nmm0jDd0T880`QQ1P00
1S660S6V0iBb2IcC0nLl1Ooo0ooO0kgg0e[;0e:Z0Q220`0P0`000`0P0`QQ0a2R0aS30W>>0f]]1V]=
0lHh0oNn0_oo0ooO0oNN1[FF0kFf0U::2Ooo1DYY0kFF0kFf0kgg0oNN1Ooo0lii2f]=0aSS1P000`0P
1D880jDd0nmM1_oo0oNn0^mm0jDd0d880`QQ1P001C660c6V0iBb2IcC0^Ll1_oo0ooO0kgg0e[;0U:Z
0a220`0P0`000`0P0`QQ0Q2R0aS30g>>0f]]1V]=0/Hh0oNn0ooo0ooO0oNN1[FF0[Ff0e::2?oo1TYY
0kFF0kFf0[gg0oNN1_oo0lii2f]=0aSS1P000`0P1D880jDd0nmM1_oo0_Nn0nmm0jDd0d880`QQ1@00
1S660c6V0iBb29cC0nLl1_oo0ooO0[gg0e[;0e:Z0a220`0P0`000`0P0PQQ0a2R0aS30g>>0f]]1F]=
0lHh0oNn0ooo0ooO0oNN1KFF0kFf0e::6?oo000Gool6BVT2]IH3]KH3_OL3mih6ool2cWT<Jdd36><5
00030206@PP3YC@3ked5ool3mkh3kgd3YC@3@PP226460006<HH3<JH2U;89W=<3ic`5ool3oml3_OL3
F//3DZX3488302020003020326434:836<<3Lhh2Jfd6Jdd3aSP3mkh3ool2oml3mih6]IH3]KH3DXX8
ool5BVT3]IH3]KH3_OL3mih5ool3cWT<Jdd26><600030206@PP2YC@3ked6ool3mkh3kgd3YC@2@PP3
26460006<HH2<JH3U;89W=<3ic`5ool3oml3_OL3F//3DZX2488302030003020326434:836<<2Lhh3
Jfd6Jdd3aSP3mkh2ool3oml3mih6]IH3]KH2DXX9ool5BVT3]IH3]KH3_OL3mih5ool3cWT;Jdd36><6
00030205@PP3YC@3ked6ool3mkh2kgd3YC@3@PP326460005<HH3<JH3U;89W=<2ic`6ool3oml3_OL3
F//2DZX3488302030003020326424:836<<3Lhh3Jfd6Jdd2aSP3mkh3ool3oml3mih6]IH2]KH3DXX8
ool6BVT3]IH3]KH2_OL3mih6ool3cWT;Jdd36><600030205@PP3YC@3ked6ool2mkh3kgd3YC@3@PP3
26450006<HH3<JH3U;88W=<3ic`6ool3oml2_OL3F//3DZX3488302030003020226434:836<<3Lhh3
Jfd5Jdd3aSP3mkh3ool3oml3mih5]IH3]KH3DXXHool001Ooo`I:J@:eUP>e]P>mm`?gWPKoo`;>N@a[
C@<Hh`D000<080I220>U=0?_G@Goo`?g_P?_O@>U=0=22088H@H000HaQP<aYP:D/PVLd`?W?0Goo`?o
g`>mm`=Jb`=BZP<@PP<0808000<080<8H@<@XP<H``=cSP9[K@I[C@?6>0?g_P?oo`;og`?gWPJeUP>e
]P=BRPSoo`E:J@>eUP>e]P>mm`?gWPGoo`?>N@a[C@8Hh`H000<080I220:U=0?_G@Koo`?g_P?_O@>U
=09220<8H@H000HaQP8aYP>D/PVLd`?W?0Goo`?og`>mm`=Jb`=BZP8@PP<080<000<080<8H@<@XP<H
``9cSP=[K@I[C@?6>0?g_P;oo`?og`?gWPJeUP>e]P9BRPWoo`E:J@>eUP>e]P>mm`?gWPGoo`?>N@][
C@<Hh`H000<080E220>U=0?_G@Koo`?g_P;_O@>U=0=220<8H@H000DaQP<aYP>D/PVLd`;W?0Koo`?o
g`>mm`=Jb`9BZP<@PP<080<000<080<8H@8@XP<H``=cSP=[K@I[C@;6>0?g_P?oo`?og`?gWPJeUP:e
]P=BRPSoo`I:J@>eUP>e]P:mm`?gWPKoo`?>N@][C@<Hh`H000<080E220>U=0?_G@Koo`;g_P?_O@>U
=0=220<8H@D000HaQP<aYP>D/PRLd`?W?0Koo`?og`:mm`=Jb`=BZP<@PP<080<000<08088H@<@XP<H
``=cSP=[K@E[C@?6>0?g_P?oo`?og`?gWPFeUP>e]P=BRQSoo`005ooo1TYY0[FF0kFf0kgg0oNN1_oo
0/ii36]=0aSS1@000`0P1T880jDd0nmM1Ooo0oNn0nmm0jDd0d880PQQ1P001S660c6V0YBb2IcC0nLl
1Ooo0ooO0kgg0e[;0e:Z0a220`0P0P000`0P0`QQ0a2R0aS30g>>0V]]1V]=0lHh0oNn0ooo0_oO0oNN
1[FF0kFf0e::2?oo1DYY0kFF0kFf0kgg0oNN1Ooo0lii36]=0QSS1P000`0P1T880ZDd0nmM1_oo0oNn
0nmm0jDd0T880`QQ1P001S660S6V0iBb2IcC0nLl1Ooo0ooO0kgg0e[;0e:Z0Q220`0P0`000`0P0`QQ
0a2R0aS30W>>0f]]1V]=0lHh0oNn0_oo0ooO0oNN1[FF0kFf0U::2Ooo1DYY0kFF0kFf0kgg0oNN1Ooo
0lii2f]=0aSS1P000`0P1D880jDd0nmM1_oo0oNn0^mm0jDd0d880`QQ1P001C660c6V0iBb2IcC0^Ll
1_oo0ooO0kgg0e[;0U:Z0a220`0P0`000`0P0`QQ0Q2R0aS30g>>0f]]1V]=0/Hh0oNn0ooo0ooO0oNN
1[FF0[Ff0e::2?oo1TYY0kFF0kFf0[gg0oNN1_oo0lii2f]=0aSS1P000`0P1D880jDd0nmM1_oo0_Nn
0nmm0jDd0d880`QQ1@001S660c6V0iBb29cC0nLl1_oo0ooO0[gg0e[;0e:Z0a220`0P0`000`0P0PQQ
0a2R0aS30g>>0f]]1F]=0lHh0oNn0ooo0ooO0oNN1KFF0kFf0e::6?oo000Gool6BVT2]IH3]KH3_OL3
mih6ool2cWT<Jdd36><500030206@PP3YC@3ked5ool3mkh3kgd3YC@3@PP226460006<HH3<JH2U;89
W=<3ic`5ool3oml3_OL3F//3DZX3488302020003020326434:836<<3Lhh2Jfd6Jdd3aSP3mkh3ool2
oml3mih6]IH3]KH3DXX8ool5BVT3]IH3]KH3_OL3mih5ool3cWT<Jdd26><600030206@PP2YC@3ked6
ool3mkh3kgd3YC@2@PP326460006<HH2<JH3U;89W=<3ic`5ool3oml3_OL3F//3DZX2488302030003
020326434:836<<2Lhh3Jfd6Jdd3aSP3mkh2ool3oml3mih6]IH3]KH2DXX9ool5BVT3]IH3]KH3_OL3
mih5ool3cWT;Jdd36><600030205@PP3YC@3ked6ool3mkh2kgd3YC@3@PP326460005<HH3<JH3U;89
W=<2ic`6ool3oml3_OL3F//2DZX3488302030003020326424:836<<3Lhh3Jfd6Jdd2aSP3mkh3ool3
oml3mih6]IH2]KH3DXX8ool6BVT3]IH3]KH2_OL3mih6ool3cWT;Jdd36><600030205@PP3YC@3ked6
ool2mkh3kgd3YC@3@PP326450006<HH3<JH3U;88W=<3ic`6ool3oml2_OL3F//3DZX3488302030003
020226434:836<<3Lhh3Jfd5Jdd3aSP3mkh3ool3oml3mih5]IH3]KH3DXXHool001Ooo`I:J@:eUP>e
]P>mm`?gWPKoo`;>N@a[C@<Hh`D000<080I220>U=0?_G@Goo`?g_P?_O@>U=0=22088H@H000HaQP<a
YP:D/PVLd`?W?0Goo`?og`>mm`=Jb`=BZP<@PP<0808000<080<8H@<@XP<H``=cSP9[K@I[C@?6>0?g
_P?oo`;og`?gWPJeUP>e]P=BRPSoo`E:J@>eUP>e]P>mm`?gWPGoo`?>N@a[C@8Hh`H000<080I220:U
=0?_G@Koo`?g_P?_O@>U=09220<8H@H000HaQP8aYP>D/PVLd`?W?0Goo`?og`>mm`=Jb`=BZP8@PP<0
80<000<080<8H@<@XP<H``9cSP=[K@I[C@?6>0?g_P;oo`?og`?gWPJeUP>e]P9BRPWoo`E:J@>eUP>e
]P>mm`?gWPGoo`?>N@][C@<Hh`H000<080E220>U=0?_G@Koo`?g_P;_O@>U=0=220<8H@H000DaQP<a
YP>D/PVLd`;W?0Koo`?og`>mm`=Jb`9BZP<@PP<080<000<080<8H@8@XP<H``=cSP=[K@I[C@;6>0?g
_P?oo`?og`?gWPJeUP:e]P=BRPSoo`I:J@>eUP>e]P:mm`?gWPKoo`?>N@][C@<Hh`H000<080E220>U
=0?_G@Koo`;g_P?_O@>U=0=220<8H@D000HaQP<aYP>D/PRLd`?W?0Koo`?og`:mm`=Jb`=BZP<@PP<0
80<000<08088H@<@XP<H``=cSP=[K@E[C@?6>0?g_P?oo`?og`?gWPFeUP>e]P=BRQSoo`005ooo1TYY
0[FF0kFf0kgg0oNN1_oo0/ii36]=0aSS1@000`0P1T880jDd0nmM1Ooo0oNn0nmm0jDd0d880PQQ1P00
1S660c6V0YBb2IcC0nLl1Ooo0ooO0kgg0e[;0e:Z0a220`0P0P000`0P0`QQ0a2R0aS30g>>0V]]1V]=
0lHh0oNn0ooo0_oO0oNN1[FF0kFf0e::2?oo1DYY0kFF0kFf0kgg0oNN1Ooo0lii36]=0QSS1P000`0P
1T880ZDd0nmM1_oo0oNn0nmm0jDd0T880`QQ1P001S660S6V0iBb2IcC0nLl1Ooo0ooO0kgg0e[;0e:Z
0Q220`0P0`000`0P0`QQ0a2R0aS30W>>0f]]1V]=0lHh0oNn0_oo0ooO0oNN1[FF0kFf0U::2Ooo1DYY
0kFF0kFf0kgg0oNN1Ooo0lii2f]=0aSS1P000`0P1D880jDd0nmM1_oo0oNn0^mm0jDd0d880`QQ1P00
1C660c6V0iBb2IcC0^Ll1_oo0ooO0kgg0e[;0U:Z0a220`0P0`000`0P0`QQ0Q2R0aS30g>>0f]]1V]=
0/Hh0oNn0ooo0ooO0oNN1[FF0[Ff0e::2?oo1TYY0kFF0kFf0[gg0oNN1_oo0lii2f]=0aSS1P000`0P
1D880jDd0nmM1_oo0_Nn0nmm0jDd0d880`QQ1@001S660c6V0iBb29cC0nLl1_oo0ooO0[gg0e[;0e:Z
0a220`0P0`000`0P0PQQ0a2R0aS30g>>0f]]1F]=0lHh0oNn0ooo0ooO0oNN1KFF0kFf0e::6?oo003o
oooooooooolQool00?ooooooooooob7oo`00oooooooooooo8Ooo003ooooooooooolQool00?oooooo
ooooob7oo`00oooooooooooo8Ooo003ooooooooooolQool00?ooooooooooob7oo`00oooooooooooo
8Ooo003ooooooooooolQool00?ooooooooooob7oo`00oooooooooooo8Ooo003ooooooooooolQool0
0?ooooooooooob7oo`00oooooooooooo8Ooo003ooooooooooolQool00?ooooooooooob7oo`00oooo
oooooooo8Ooo003ooooooooooolQool00?ooooooooooob7oo`00oooooooooooo8Ooo003ooooooooo
oolQool00?ooooooooooob7oo`00oooooooooooo8Ooo003ooooooooooolQool00?ooooooooooob7o
o`00oooooooooooo8Ooo003ooooooooooolQool00?ooooooooooob7oo`00oooooooooooo8Ooo003o
oooooooooolQool00?ooooooooooob7oo`00oooooooooooo8Ooo003ooooooooooolQool00?oooooo
ooooob7oo`00oooooooooooo8Ooo003ooooooooooolQool00?ooooooooooob7oo`00\
\>"],
  ImageRangeCache->{{{0, 797}, {797, 0}} -> {-0.100021, -0.100021, \
0.00526982, 0.00526982}, {{18.9375, 208.688}, {778, 18.9375}} -> {-8.30709, \
-3.28533, 0.354153, 0.0885384}, {{208.688, 398.5}, {778, 18.9375}} -> \
{-75.5098, -3.28243, 0.354123, 0.0885312}, {{398.5, 588.25}, {778, 18.9375}} -> \
{-142.73, -3.28533, 0.354153, 0.0885384}, {{588.25, 778}, {778, 18.9375}} -> \
{-209.931, -3.28533, 0.354153, 0.0885384}}]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
WindowSize->{1012, 740},
WindowMargins->{{0, Automatic}, {Automatic, 0}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 320, 7, 59, "Input"],

Cell[CellGroupData[{
Cell[2062, 60, 67, 1, 27, "Input"],
Cell[2132, 63, 62, 0, 23, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2231, 68, 68, 1, 27, "Input"],
Cell[2302, 71, 199, 5, 27, "Output"]
}, Open  ]],
Cell[2516, 79, 539, 14, 27, "Input"],

Cell[CellGroupData[{
Cell[3080, 97, 52, 1, 27, "Input"],
Cell[3135, 100, 267, 3, 39, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3439, 108, 108, 2, 27, "Input"],
Cell[3550, 112, 46, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3633, 117, 52, 1, 27, "Input"],
Cell[3688, 120, 293, 3, 39, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4018, 128, 109, 2, 27, "Input"],
Cell[4130, 132, 149, 4, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4316, 141, 62, 1, 27, "Input"],
Cell[4381, 144, 74921, 996, 296, 9079, 178, "GraphicsData", "PostScript", \
"Graphics"],
Cell[79305, 1142, 149, 4, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[79491, 1151, 185, 5, 27, "Input"],
Cell[79679, 1158, 79479, 1054, 332, 9114, 180, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[159195, 2217, 290, 8, 27, "Input"],
Cell[159488, 2227, 83491, 1180, 134, 18408, 372, "GraphicsData", \
"PostScript", "Graphics"],
Cell[242982, 3409, 161, 5, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[243180, 3419, 1245, 31, 59, "Input"],
Cell[244428, 3452, 706834, 8991, 806, 36248, 708, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

