(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     93481,       2678]*)
(*NotebookOutlinePosition[     94566,       2711]*)
(*  CellTagsIndexPosition[     94522,       2707]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    \(\($TextStyle = {FontSize \[Rule] 8};\)\)], "Input"],

Cell[BoxData[
    \(<< Miscellaneous`Units`\)], "Input"],

Cell[BoxData[
    \(imgSize = 
      Convert[60  Milli\ Meter, PrintersPoint]/PrintersPoint; \)], "Input"],

Cell[CellGroupData[{

Cell[TextData[{
  "Plot of ",
  Cell[BoxData[
      \(TraditionalForm\`f\)]],
  " on ",
  Cell[BoxData[
      \(TraditionalForm\`\(\([\)\(0, 1\)\(]\)\)\[Times]\(\([\)\(0, 
        1\)\(]\)\)\)]],
  ":"
}], "Subsection"],

Cell[BoxData[
    \(f[x_, y_] := 
      If[x \[GreaterEqual] 0 && x < 1 && y \[GreaterEqual] 4  x - 3 && 
          y \[LessEqual] 1, \(y - 1\)\/\(2 \((x - 1)\)\) - 1, 1]; \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Plot3D[f[x, y], {x, 0, 1}, {y, 0, 1}, Shading \[Rule] False, 
        PlotPoints \[Rule] 30, AxesLabel \[Rule] {"\<x\>", "\<y\>", "\<\>"}, 
        ViewPoint -> {\(-2.391\), \ \(-1.883\), \ 1.479}, 
        ImageSize \[Rule] imgSize, 
        Ticks \[Rule] {{1}, {0, 1}, {\(-1\), 0, 1}}];\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .69293 
%%ImageSize: 170.717 118.294 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% SurfaceGraphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
5.14996e-17 1.02277 -0.10921 1.02277 [
[.98806 .30333 0 -5.47388 ]
[.98806 .30333 8.75 2.77612 ]
[.87169 .14335 0 -5.69632 ]
[.87169 .14335 8.75 2.55368 ]
[.58014 -0.01278 -4.44316 -8.25 ]
[.58014 -0.01278 4.30684 0 ]
[.02764 .23999 -3.92138 -8.25 ]
[.02764 .23999 4.82862 0 ]
[.28252 .06102 -4.18148 -8.25 ]
[.28252 .06102 4.63102 0 ]
[.01432 .25269 -14 -6.21005 ]
[.01432 .25269 0 2.03995 ]
[.00188 .371 -8.75 -6.00957 ]
[.00188 .371 0 2.24043 ]
[-0.01118 .49544 -8.75 -5.8008 ]
[-0.01118 .49544 0 2.4492 ]
[ 0 0 0 0 ]
[ 1 .69293 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.58034 0 m
.97591 .3073 L
s
.97591 .3073 m
.96984 .30929 L
s
gsave
.98806 .30333 -61 -9.47388 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
gsave
.87169 .14335 -61 -9.69632 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
67.750 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.58034 0 m
.02633 .25271 L
s
.58034 0 m
.58044 .00639 L
s
gsave
.58014 -0.01278 -65.4432 -12.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.02633 .25271 m
.02567 .25907 L
s
gsave
.02764 .23999 -64.9214 -12.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
gsave
.28252 .06102 -65.1815 -12.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.062 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(y) show
67.812 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02633 .25271 m
0 .50662 L
s
.02573 .25845 m
.03144 .26134 L
s
gsave
.01432 .25269 -75 -10.2101 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
68.250 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.01351 .37631 m
.01933 .37897 L
s
gsave
.00188 .371 -69.75 -10.0096 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.00066 .50025 m
.00658 .50266 L
s
gsave
-0.01118 .49544 -69.75 -9.8008 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.58034 0 m
.58486 .29035 L
s
.58486 .29035 m
0 .50662 L
s
0 .50662 m
.02633 .25271 L
s
.02633 .25271 m
.58034 0 L
s
.97591 .3073 m
.46366 .47481 L
s
.46366 .47481 m
.46154 .69293 L
s
.46154 .69293 m
1 .55274 L
s
1 .55274 m
.97591 .3073 L
s
.58034 0 m
.58486 .29035 L
s
.58486 .29035 m
1 .55274 L
s
1 .55274 m
.97591 .3073 L
s
.97591 .3073 m
.58034 0 L
s
.02633 .25271 m
.46366 .47481 L
s
.46366 .47481 m
.46154 .69293 L
s
.46154 .69293 m
0 .50662 L
s
0 .50662 m
.02633 .25271 L
s
0 0 m
1 0 L
1 .69293 L
0 .69293 L
closepath
clip
newpath
.5 Mabswid
1 g
.46596 .51913 .45104 .47343 .46159 .68751 .47759 .68332 Metetra
1 g
.45344 .48725 .43832 .467 .45104 .47343 .46596 .51913 Metetra
1 g
.44065 .47228 .42544 .46049 .43832 .467 .45344 .48725 Metetra
1 g
.42768 .46143 .41241 .45391 .42544 .46049 .44065 .47228 Metetra
1 g
.41453 .45219 .39922 .44724 .41241 .45391 .42768 .46143 Metetra
1 g
.40122 .4437 .38586 .44049 .39922 .44724 .41453 .45219 Metetra
1 g
.38773 .43561 .37234 .43365 .38586 .44049 .40122 .4437 Metetra
1 g
.37407 .42772 .35865 .42673 .37234 .43365 .38773 .43561 Metetra
1 g
.36025 .41995 .34479 .41973 .35865 .42673 .37407 .42772 Metetra
1 g
.34624 .41223 .33075 .41263 .34479 .41973 .36025 .41995 Metetra
1 g
.33205 .40452 .31654 .40545 .33075 .41263 .34624 .41223 Metetra
1 g
.31768 .39679 .30214 .39817 .31654 .40545 .33205 .40452 Metetra
1 g
.30313 .38902 .28756 .3908 .30214 .39817 .31768 .39679 Metetra
1 g
.28838 .3812 .27278 .38333 .28756 .3908 .30313 .38902 Metetra
1 g
.27344 .37332 .25782 .37577 .27278 .38333 .28838 .3812 Metetra
1 g
.25831 .36537 .24266 .3681 .25782 .37577 .27344 .37332 Metetra
1 g
.24297 .35734 .22729 .36034 .24266 .3681 .25831 .36537 Metetra
1 g
.22742 .34923 .21173 .35247 .22729 .36034 .24297 .35734 Metetra
1 g
.21167 .34103 .19595 .34449 .21173 .35247 .22742 .34923 Metetra
1 g
.1957 .33273 .17996 .33641 .19595 .34449 .21167 .34103 Metetra
1 g
.17952 .32433 .16376 .32822 .17996 .33641 .1957 .33273 Metetra
1 g
.16311 .31583 .14733 .31992 .16376 .32822 .17952 .32433 Metetra
1 g
.14647 .30722 .13068 .3115 .14733 .31992 .16311 .31583 Metetra
1 g
.12961 .2985 .11379 .30296 .13068 .3115 .14647 .30722 Metetra
1 g
.1125 .28967 .09667 .29431 .11379 .30296 .12961 .2985 Metetra
1 g
.09516 .28072 .07931 .28554 .09667 .29431 .1125 .28967 Metetra
1 g
.07756 .27165 .0617 .27664 .07931 .28554 .09516 .28072 Metetra
1 g
.05972 .26246 .04385 .26761 .0617 .27664 .07756 .27165 Metetra
1 g
.04161 .25314 .02573 .25845 .04385 .26761 .05972 .26246 Metetra
1 g
.48134 .56624 .46596 .51913 .47759 .68332 .49375 .67908 Metetra
1 g
.46887 .50791 .45344 .48725 .46596 .51913 .48134 .56624 Metetra
1 g
.45611 .48425 .44065 .47228 .45344 .48725 .46887 .50791 Metetra
1 g
.44317 .46907 .42768 .46143 .44065 .47228 .45611 .48425 Metetra
1 g
.43006 .45721 .41453 .45219 .42768 .46143 .44317 .46907 Metetra
1 g
.41677 .44696 .40122 .4437 .41453 .45219 .43006 .45721 Metetra
1 g
.40332 .43758 .38773 .43561 .40122 .4437 .41677 .44696 Metetra
1 g
.38969 .42873 .37407 .42772 .38773 .43561 .40332 .43758 Metetra
1 g
.37589 .42018 .36025 .41995 .37407 .42772 .38969 .42873 Metetra
1 g
.36192 .41182 .34624 .41223 .36025 .41995 .37589 .42018 Metetra
1 g
.34776 .40358 .33205 .40452 .34624 .41223 .36192 .41182 Metetra
1 g
.33342 .39539 .31768 .39679 .33205 .40452 .34776 .40358 Metetra
1 g
.31889 .38722 .30313 .38902 .31768 .39679 .33342 .39539 Metetra
1 g
.30417 .37905 .28838 .3812 .30313 .38902 .31889 .38722 Metetra
1 g
.28925 .37085 .27344 .37332 .28838 .3812 .30417 .37905 Metetra
1 g
.27414 .36261 .25831 .36537 .27344 .37332 .28925 .37085 Metetra
1 g
.25883 .35432 .24297 .35734 .25831 .36537 .27414 .36261 Metetra
1 g
.24331 .34595 .22742 .34923 .24297 .35734 .25883 .35432 Metetra
1 g
.22758 .33752 .21167 .34103 .22742 .34923 .24331 .34595 Metetra
1 g
.21163 .329 .1957 .33273 .21167 .34103 .22758 .33752 Metetra
1 g
.19547 .32039 .17952 .32433 .1957 .33273 .21163 .329 Metetra
1 g
.17908 .31169 .16311 .31583 .17952 .32433 .19547 .32039 Metetra
1 g
.16246 .30289 .14647 .30722 .16311 .31583 .17908 .31169 Metetra
1 g
.14561 .29399 .12961 .2985 .14647 .30722 .16246 .30289 Metetra
1 g
.12852 .28498 .1125 .28967 .12961 .2985 .14561 .29399 Metetra
1 g
.11119 .27585 .09516 .28072 .1125 .28967 .12852 .28498 Metetra
1 g
.09361 .26661 .07756 .27165 .09516 .28072 .11119 .27585 Metetra
1 g
.07578 .25725 .05972 .26246 .07756 .27165 .09361 .26661 Metetra
1 g
.05769 .24776 .04161 .25314 .05972 .26246 .07578 .25725 Metetra
1 g
.49721 .61482 .48134 .56624 .49375 .67908 .51006 .67481 Metetra
1 g
.48461 .52899 .46887 .50791 .48134 .56624 .49721 .61482 Metetra
1 g
.47183 .49644 .45611 .48425 .46887 .50791 .48461 .52899 Metetra
1 g
.4589 .47683 .44317 .46907 .45611 .48425 .47183 .49644 Metetra
1 g
.4458 .4623 .43006 .45721 .44317 .46907 .4589 .47683 Metetra
1 g
.43254 .45026 .41677 .44696 .43006 .45721 .4458 .4623 Metetra
1 g
.41911 .43959 .40332 .43758 .41677 .44696 .43254 .45026 Metetra
1 g
.40551 .42974 .38969 .42873 .40332 .43758 .41911 .43959 Metetra
1 g
.39174 .42041 .37589 .42018 .38969 .42873 .40551 .42974 Metetra
1 g
.37779 .41141 .36192 .41182 .37589 .42018 .39174 .42041 Metetra
1 g
.36365 .40263 .34776 .40358 .36192 .41182 .37779 .41141 Metetra
1 g
.34934 .39398 .33342 .39539 .34776 .40358 .36365 .40263 Metetra
1 g
.33484 .38541 .31889 .38722 .33342 .39539 .34934 .39398 Metetra
1 g
.32014 .37688 .30417 .37905 .31889 .38722 .33484 .38541 Metetra
1 g
.30526 .36835 .28925 .37085 .30417 .37905 .32014 .37688 Metetra
1 g
.29017 .35982 .27414 .36261 .28925 .37085 .30526 .36835 Metetra
1 g
.27488 .35125 .25883 .35432 .27414 .36261 .29017 .35982 Metetra
1 g
.25938 .34264 .24331 .34595 .25883 .35432 .27488 .35125 Metetra
1 g
.24367 .33397 .22758 .33752 .24331 .34595 .25938 .34264 Metetra
1 g
.22775 .32523 .21163 .329 .22758 .33752 .24367 .33397 Metetra
1 g
.21161 .31641 .19547 .32039 .21163 .329 .22775 .32523 Metetra
1 g
.19524 .30751 .17908 .31169 .19547 .32039 .21161 .31641 Metetra
1 g
.17864 .29851 .16246 .30289 .17908 .31169 .19524 .30751 Metetra
1 g
.16181 .28942 .14561 .29399 .16246 .30289 .17864 .29851 Metetra
1 g
.14474 .28023 .12852 .28498 .14561 .29399 .16181 .28942 Metetra
1 g
.12743 .27092 .11119 .27585 .12852 .28498 .14474 .28023 Metetra
1 g
.10986 .26151 .09361 .26661 .11119 .27585 .12743 .27092 Metetra
1 g
.09204 .25197 .07578 .25725 .09361 .26661 .10986 .26151 Metetra
1 g
.07396 .24232 .05769 .24776 .07578 .25725 .09204 .25197 Metetra
1 g
.51357 .66495 .49721 .61482 .51006 .67481 .52654 .67049 Metetra
1 g
.50067 .5505 .48461 .52899 .49721 .61482 .51357 .66495 Metetra
1 g
.48782 .50882 .47183 .49644 .48461 .52899 .50067 .5505 Metetra
1 g
.47487 .4847 .4589 .47683 .47183 .49644 .48782 .50882 Metetra
1 g
.46177 .46747 .4458 .4623 .4589 .47683 .47487 .4847 Metetra
1 g
.44852 .4536 .43254 .45026 .4458 .4623 .46177 .46747 Metetra
1 g
.43511 .44162 .41911 .43959 .43254 .45026 .44852 .4536 Metetra
1 g
.42153 .43077 .40551 .42974 .41911 .43959 .43511 .44162 Metetra
1 g
.40778 .42065 .39174 .42041 .40551 .42974 .42153 .43077 Metetra
1 g
.39385 .411 .37779 .41141 .39174 .42041 .40778 .42065 Metetra
1 g
.37975 .40167 .36365 .40263 .37779 .41141 .39385 .411 Metetra
1 g
.36546 .39255 .34934 .39398 .36365 .40263 .37975 .40167 Metetra
1 g
.35098 .38357 .33484 .38541 .34934 .39398 .36546 .39255 Metetra
1 g
.33631 .37467 .32014 .37688 .33484 .38541 .35098 .38357 Metetra
1 g
.32145 .36582 .30526 .36835 .32014 .37688 .33631 .37467 Metetra
1 g
.30639 .35699 .29017 .35982 .30526 .36835 .32145 .36582 Metetra
1 g
.29112 .34815 .27488 .35125 .29017 .35982 .30639 .35699 Metetra
1 g
.27565 .33928 .25938 .34264 .27488 .35125 .29112 .34815 Metetra
1 g
.25996 .33037 .24367 .33397 .25938 .34264 .27565 .33928 Metetra
1 g
.24406 .32141 .22775 .32523 .24367 .33397 .25996 .33037 Metetra
1 g
.22794 .31238 .21161 .31641 .22775 .32523 .24406 .32141 Metetra
1 g
.2116 .30327 .19524 .30751 .21161 .31641 .22794 .31238 Metetra
1 g
.19502 .29408 .17864 .29851 .19524 .30751 .2116 .30327 Metetra
1 g
.17821 .2848 .16181 .28942 .17864 .29851 .19502 .29408 Metetra
1 g
.16116 .27542 .14474 .28023 .16181 .28942 .17821 .2848 Metetra
1 g
.14386 .26593 .12743 .27092 .14474 .28023 .16116 .27542 Metetra
1 g
.12631 .25634 .10986 .26151 .12743 .27092 .14386 .26593 Metetra
1 g
.10851 .24663 .09204 .25197 .10986 .26151 .12631 .25634 Metetra
1 g
.09044 .2368 .07396 .24232 .09204 .25197 .10851 .24663 Metetra
1 g
.53026 .66053 .51357 .66495 .52654 .67049 .54318 .66613 Metetra
1 g
.51707 .57246 .50067 .5505 .51357 .66495 .53026 .66053 Metetra
1 g
.50409 .52142 .48782 .50882 .50067 .5505 .51707 .57246 Metetra
1 g
.49108 .4927 .47487 .4847 .48782 .50882 .50409 .52142 Metetra
1 g
.47797 .47271 .46177 .46747 .47487 .4847 .49108 .4927 Metetra
1 g
.46472 .45699 .44852 .4536 .46177 .46747 .47797 .47271 Metetra
1 g
.45132 .44368 .43511 .44162 .44852 .4536 .46472 .45699 Metetra
1 g
.43776 .43181 .42153 .43077 .43511 .44162 .45132 .44368 Metetra
1 g
.42403 .42088 .40778 .42065 .42153 .43077 .43776 .43181 Metetra
1 g
.41012 .41058 .39385 .411 .40778 .42065 .42403 .42088 Metetra
1 g
.39604 .40069 .37975 .40167 .39385 .411 .41012 .41058 Metetra
1 g
.38177 .3911 .36546 .39255 .37975 .40167 .39604 .40069 Metetra
1 g
.36732 .3817 .35098 .38357 .36546 .39255 .38177 .3911 Metetra
1 g
.35268 .37244 .33631 .37467 .35098 .38357 .36732 .3817 Metetra
1 g
.33784 .36326 .32145 .36582 .33631 .37467 .35268 .37244 Metetra
1 g
.3228 .35413 .30639 .35699 .32145 .36582 .33784 .36326 Metetra
1 g
.30756 .34501 .29112 .34815 .30639 .35699 .3228 .35413 Metetra
1 g
.29211 .33589 .27565 .33928 .29112 .34815 .30756 .34501 Metetra
1 g
.27645 .32673 .25996 .33037 .27565 .33928 .29211 .33589 Metetra
1 g
.26057 .31754 .24406 .32141 .25996 .33037 .27645 .32673 Metetra
1 g
.24448 .30829 .22794 .31238 .24406 .32141 .26057 .31754 Metetra
1 g
.22815 .29898 .2116 .30327 .22794 .31238 .24448 .30829 Metetra
1 g
.2116 .28959 .19502 .29408 .2116 .30327 .22815 .29898 Metetra
1 g
.1948 .28012 .17821 .2848 .19502 .29408 .2116 .28959 Metetra
1 g
.17777 .27055 .16116 .27542 .17821 .2848 .1948 .28012 Metetra
1 g
.16049 .26088 .14386 .26593 .16116 .27542 .17777 .27055 Metetra
1 g
.14296 .25111 .12631 .25634 .14386 .26593 .16049 .26088 Metetra
1 g
.12518 .24122 .10851 .24663 .12631 .25634 .14296 .25111 Metetra
1 g
.10713 .23122 .09044 .2368 .10851 .24663 .12518 .24122 Metetra
1 g
.54711 .65607 .53026 .66053 .54318 .66613 .56 .66173 Metetra
1 g
.53381 .59488 .51707 .57246 .53026 .66053 .54711 .65607 Metetra
1 g
.52063 .53424 .50409 .52142 .51707 .57246 .53381 .59488 Metetra
1 g
.50755 .50082 .49108 .4927 .50409 .52142 .52063 .53424 Metetra
1 g
.4944 .47802 .47797 .47271 .49108 .4927 .50755 .50082 Metetra
1 g
.48115 .46043 .46472 .45699 .47797 .47271 .4944 .47802 Metetra
1 g
.46775 .44576 .45132 .44368 .46472 .45699 .48115 .46043 Metetra
1 g
.45419 .43287 .43776 .43181 .45132 .44368 .46775 .44576 Metetra
1 g
.44048 .42112 .42403 .42088 .43776 .43181 .45419 .43287 Metetra
1 g
.42659 .41015 .41012 .41058 .42403 .42088 .44048 .42112 Metetra
1 g
.41253 .3997 .39604 .40069 .41012 .41058 .42659 .41015 Metetra
1 g
.39829 .38963 .38177 .3911 .39604 .40069 .41253 .3997 Metetra
1 g
.38386 .37982 .36732 .3817 .38177 .3911 .39829 .38963 Metetra
1 g
.36924 .37018 .35268 .37244 .36732 .3817 .38386 .37982 Metetra
1 g
.35443 .36067 .33784 .36326 .35268 .37244 .36924 .37018 Metetra
1 g
.33942 .35123 .3228 .35413 .33784 .36326 .35443 .36067 Metetra
1 g
.3242 .34183 .30756 .34501 .3228 .35413 .33942 .35123 Metetra
1 g
.30878 .33245 .29211 .33589 .30756 .34501 .3242 .34183 Metetra
1 g
.29314 .32305 .27645 .32673 .29211 .33589 .30878 .33245 Metetra
1 g
.27729 .31363 .26057 .31754 .27645 .32673 .29314 .32305 Metetra
1 g
.26121 .30416 .24448 .30829 .26057 .31754 .27729 .31363 Metetra
1 g
.24491 .29464 .22815 .29898 .24448 .30829 .26121 .30416 Metetra
1 g
.22838 .28505 .2116 .28959 .22815 .29898 .24491 .29464 Metetra
1 g
.21161 .27538 .1948 .28012 .2116 .28959 .22838 .28505 Metetra
1 g
.1946 .26562 .17777 .27055 .1948 .28012 .21161 .27538 Metetra
1 g
.17734 .25577 .16049 .26088 .17777 .27055 .1946 .26562 Metetra
1 g
.15983 .24581 .14296 .25111 .16049 .26088 .17734 .25577 Metetra
1 g
.14206 .23575 .12518 .24122 .14296 .25111 .15983 .24581 Metetra
1 g
.12402 .22557 .10713 .23122 .12518 .24122 .14206 .23575 Metetra
1 g
.56413 .65156 .54711 .65607 .56 .66173 .57698 .65728 Metetra
1 g
.55091 .61777 .53381 .59488 .54711 .65607 .56413 .65156 Metetra
1 g
.53746 .54728 .52063 .53424 .53381 .59488 .55091 .61777 Metetra
1 g
.52427 .50906 .50755 .50082 .52063 .53424 .53746 .54728 Metetra
1 g
.51108 .48341 .4944 .47802 .50755 .50082 .52427 .50906 Metetra
1 g
.4978 .46392 .48115 .46043 .4944 .47802 .51108 .48341 Metetra
1 g
.48439 .44787 .46775 .44576 .48115 .46043 .4978 .46392 Metetra
1 g
.47085 .43394 .45419 .43287 .46775 .44576 .48439 .44787 Metetra
1 g
.45714 .42137 .44048 .42112 .45419 .43287 .47085 .43394 Metetra
1 g
.44327 .40972 .42659 .41015 .44048 .42112 .45714 .42137 Metetra
1 g
.42923 .39871 .41253 .3997 .42659 .41015 .44327 .40972 Metetra
1 g
.41501 .38815 .39829 .38963 .41253 .3997 .42923 .39871 Metetra
1 g
.4006 .37791 .38386 .37982 .39829 .38963 .41501 .38815 Metetra
1 g
.38601 .3679 .36924 .37018 .38386 .37982 .4006 .37791 Metetra
1 g
.37122 .35805 .35443 .36067 .36924 .37018 .38601 .3679 Metetra
1 g
.35623 .3483 .33942 .35123 .35443 .36067 .37122 .35805 Metetra
1 g
.34104 .33862 .3242 .34183 .33942 .35123 .35623 .3483 Metetra
1 g
.32564 .32897 .30878 .33245 .3242 .34183 .34104 .33862 Metetra
1 g
.31003 .31933 .29314 .32305 .30878 .33245 .32564 .32897 Metetra
1 g
.29421 .30967 .27729 .31363 .29314 .32305 .31003 .31933 Metetra
1 g
.27815 .29998 .26121 .30416 .27729 .31363 .29421 .30967 Metetra
1 g
.26188 .29024 .24491 .29464 .26121 .30416 .27815 .29998 Metetra
1 g
.24537 .28045 .22838 .28505 .24491 .29464 .26188 .29024 Metetra
1 g
.22862 .27058 .21161 .27538 .22838 .28505 .24537 .28045 Metetra
1 g
.21163 .26063 .1946 .26562 .21161 .27538 .22862 .27058 Metetra
1 g
.19439 .25059 .17734 .25577 .1946 .26562 .21163 .26063 Metetra
1 g
.1769 .24045 .15983 .24581 .17734 .25577 .19439 .25059 Metetra
1 g
.15915 .2302 .14206 .23575 .15983 .24581 .1769 .24045 Metetra
1 g
.14113 .21985 .12402 .22557 .14206 .23575 .15915 .2302 Metetra
1 g
.58133 .64701 .56413 .65156 .57698 .65728 .59413 .65278 Metetra
1 g
.56837 .64116 .55091 .61777 .56413 .65156 .58133 .64701 Metetra
1 g
.55459 .56055 .53746 .54728 .55091 .61777 .56837 .64116 Metetra
1 g
.54126 .51744 .52427 .50906 .53746 .54728 .55459 .56055 Metetra
1 g
.52799 .48888 .51108 .48341 .52427 .50906 .54126 .51744 Metetra
1 g
.51468 .46745 .4978 .46392 .51108 .48341 .52799 .48888 Metetra
1 g
.50127 .45002 .48439 .44787 .4978 .46392 .51468 .46745 Metetra
1 g
.48772 .43502 .47085 .43394 .48439 .44787 .50127 .45002 Metetra
1 g
.47402 .42161 .45714 .42137 .47085 .43394 .48772 .43502 Metetra
1 g
.46017 .40928 .44327 .40972 .45714 .42137 .47402 .42161 Metetra
1 g
.44614 .3977 .42923 .39871 .44327 .40972 .46017 .40928 Metetra
1 g
.43194 .38664 .41501 .38815 .42923 .39871 .44614 .3977 Metetra
1 g
.41756 .37598 .4006 .37791 .41501 .38815 .43194 .38664 Metetra
1 g
.40299 .36559 .38601 .3679 .4006 .37791 .41756 .37598 Metetra
1 g
.38822 .35539 .37122 .35805 .38601 .3679 .40299 .36559 Metetra
1 g
.37326 .34533 .35623 .3483 .37122 .35805 .38822 .35539 Metetra
1 g
.35809 .33536 .34104 .33862 .35623 .3483 .37326 .34533 Metetra
1 g
.34272 .32545 .32564 .32897 .34104 .33862 .35809 .33536 Metetra
1 g
.32714 .31555 .31003 .31933 .32564 .32897 .34272 .32545 Metetra
1 g
.31133 .30566 .29421 .30967 .31003 .31933 .32714 .31555 Metetra
1 g
.29531 .29574 .27815 .29998 .29421 .30967 .31133 .30566 Metetra
1 g
.27905 .28579 .26188 .29024 .27815 .29998 .29531 .29574 Metetra
1 g
.26257 .27579 .24537 .28045 .26188 .29024 .27905 .28579 Metetra
1 g
.24584 .26572 .22862 .27058 .24537 .28045 .26257 .27579 Metetra
1 g
.22888 .25557 .21163 .26063 .22862 .27058 .24584 .26572 Metetra
1 g
.21166 .24534 .19439 .25059 .21163 .26063 .22888 .25557 Metetra
1 g
.19419 .23502 .1769 .24045 .19439 .25059 .21166 .24534 Metetra
1 g
.17646 .22459 .15915 .2302 .1769 .24045 .19419 .23502 Metetra
1 g
.15846 .21405 .14113 .21985 .15915 .2302 .17646 .22459 Metetra
1 g
.59871 .64241 .58133 .64701 .59413 .65278 .61146 .64824 Metetra
1 g
.58579 .6365 .56837 .64116 .58133 .64701 .59871 .64241 Metetra
1 g
.57202 .57406 .55459 .56055 .56837 .64116 .58579 .6365 Metetra
1 g
.55851 .52595 .54126 .51744 .55459 .56055 .57202 .57406 Metetra
1 g
.54516 .49443 .52799 .48888 .54126 .51744 .55851 .52595 Metetra
1 g
.5318 .47104 .51468 .46745 .52799 .48888 .54516 .49443 Metetra
1 g
.51837 .45219 .50127 .45002 .51468 .46745 .5318 .47104 Metetra
1 g
.50481 .43612 .48772 .43502 .50127 .45002 .51837 .45219 Metetra
1 g
.49112 .42186 .47402 .42161 .48772 .43502 .50481 .43612 Metetra
1 g
.47728 .40884 .46017 .40928 .47402 .42161 .49112 .42186 Metetra
1 g
.46327 .39667 .44614 .3977 .46017 .40928 .47728 .40884 Metetra
1 g
.44908 .38512 .43194 .38664 .44614 .3977 .46327 .39667 Metetra
1 g
.43472 .37402 .41756 .37598 .43194 .38664 .44908 .38512 Metetra
1 g
.42017 .36324 .40299 .36559 .41756 .37598 .43472 .37402 Metetra
1 g
.40543 .3527 .38822 .35539 .40299 .36559 .42017 .36324 Metetra
1 g
.3905 .34233 .37326 .34533 .38822 .35539 .40543 .3527 Metetra
1 g
.37536 .33207 .35809 .33536 .37326 .34533 .3905 .34233 Metetra
1 g
.36001 .32188 .34272 .32545 .35809 .33536 .37536 .33207 Metetra
1 g
.34445 .31173 .32714 .31555 .34272 .32545 .36001 .32188 Metetra
1 g
.32867 .3016 .31133 .30566 .32714 .31555 .34445 .31173 Metetra
1 g
.31267 .29146 .29531 .29574 .31133 .30566 .32867 .3016 Metetra
1 g
.29644 .28129 .27905 .28579 .29531 .29574 .31267 .29146 Metetra
1 g
.27998 .27107 .26257 .27579 .27905 .28579 .29644 .28129 Metetra
1 g
.26328 .2608 .24584 .26572 .26257 .27579 .27998 .27107 Metetra
1 g
.24634 .25046 .22888 .25557 .24584 .26572 .26328 .2608 Metetra
1 g
.22915 .24003 .21166 .24534 .22888 .25557 .24634 .25046 Metetra
1 g
.2117 .22952 .19419 .23502 .21166 .24534 .22915 .24003 Metetra
1 g
.19399 .2189 .17646 .22459 .19419 .23502 .2117 .22952 Metetra
1 g
.17601 .20818 .15846 .21405 .17646 .22459 .19399 .2189 Metetra
1 g
.61626 .63776 .59871 .64241 .61146 .64824 .62896 .64365 Metetra
1 g
.6034 .63179 .58579 .6365 .59871 .64241 .61626 .63776 Metetra
1 g
.58977 .5878 .57202 .57406 .58579 .6365 .6034 .63179 Metetra
1 g
.57604 .53459 .55851 .52595 .57202 .57406 .58977 .5878 Metetra
1 g
.56258 .50007 .54516 .49443 .55851 .52595 .57604 .53459 Metetra
1 g
.54916 .47467 .5318 .47104 .54516 .49443 .56258 .50007 Metetra
1 g
.5357 .45439 .51837 .45219 .5318 .47104 .54916 .47467 Metetra
1 g
.52214 .43723 .50481 .43612 .51837 .45219 .5357 .45439 Metetra
1 g
.50844 .42211 .49112 .42186 .50481 .43612 .52214 .43723 Metetra
1 g
.49461 .40839 .47728 .40884 .49112 .42186 .50844 .42211 Metetra
1 g
.48061 .39563 .46327 .39667 .47728 .40884 .49461 .40839 Metetra
1 g
.46645 .38358 .44908 .38512 .46327 .39667 .48061 .39563 Metetra
1 g
.4521 .37204 .43472 .37402 .44908 .38512 .46645 .38358 Metetra
1 g
.43758 .36087 .42017 .36324 .43472 .37402 .4521 .37204 Metetra
1 g
.42286 .34998 .40543 .3527 .42017 .36324 .43758 .36087 Metetra
1 g
.40795 .33928 .3905 .34233 .40543 .3527 .42286 .34998 Metetra
1 g
.39283 .32873 .37536 .33207 .3905 .34233 .40795 .33928 Metetra
1 g
.37751 .31827 .36001 .32188 .37536 .33207 .39283 .32873 Metetra
1 g
.36198 .30787 .34445 .31173 .36001 .32188 .37751 .31827 Metetra
1 g
.34623 .29749 .32867 .3016 .34445 .31173 .36198 .30787 Metetra
1 g
.33026 .28712 .31267 .29146 .32867 .3016 .34623 .29749 Metetra
1 g
.31406 .27673 .29644 .28129 .31267 .29146 .33026 .28712 Metetra
1 g
.29762 .2663 .27998 .27107 .29644 .28129 .31406 .27673 Metetra
1 g
.28095 .25582 .26328 .2608 .27998 .27107 .29762 .2663 Metetra
1 g
.26403 .24528 .24634 .25046 .26328 .2608 .28095 .25582 Metetra
1 g
.24686 .23465 .22915 .24003 .24634 .25046 .26403 .24528 Metetra
1 g
.22943 .22395 .2117 .22952 .22915 .24003 .24686 .23465 Metetra
1 g
.21175 .21314 .19399 .2189 .2117 .22952 .22943 .22395 Metetra
1 g
.19379 .20223 .17601 .20818 .19399 .2189 .21175 .21314 Metetra
1 g
.634 .63307 .61626 .63776 .62896 .64365 .64665 .63902 Metetra
1 g
.62119 .62703 .6034 .63179 .61626 .63776 .634 .63307 Metetra
1 g
.60783 .6018 .58977 .5878 .6034 .63179 .62119 .62703 Metetra
1 g
.59385 .54337 .57604 .53459 .58977 .5878 .60783 .6018 Metetra
1 g
.58026 .50578 .56258 .50007 .57604 .53459 .59385 .54337 Metetra
1 g
.56678 .47836 .54916 .47467 .56258 .50007 .58026 .50578 Metetra
1 g
.55327 .45662 .5357 .45439 .54916 .47467 .56678 .47836 Metetra
1 g
.53969 .43836 .52214 .43723 .5357 .45439 .55327 .45662 Metetra
1 g
.52599 .42237 .50844 .42211 .52214 .43723 .53969 .43836 Metetra
1 g
.51216 .40793 .49461 .40839 .50844 .42211 .52599 .42237 Metetra
1 g
.49818 .39458 .48061 .39563 .49461 .40839 .51216 .40793 Metetra
1 g
.48403 .38202 .46645 .38358 .48061 .39563 .49818 .39458 Metetra
1 g
.4697 .37003 .4521 .37204 .46645 .38358 .48403 .38202 Metetra
1 g
.4552 .35847 .43758 .36087 .4521 .37204 .4697 .37003 Metetra
1 g
.44051 .34722 .42286 .34998 .43758 .36087 .4552 .35847 Metetra
1 g
.42562 .3362 .40795 .33928 .42286 .34998 .44051 .34722 Metetra
1 g
.41053 .32535 .39283 .32873 .40795 .33928 .42562 .3362 Metetra
1 g
.39524 .31461 .37751 .31827 .39283 .32873 .41053 .32535 Metetra
1 g
.37973 .30395 .36198 .30787 .37751 .31827 .39524 .31461 Metetra
1 g
.36401 .29333 .34623 .29749 .36198 .30787 .37973 .30395 Metetra
1 g
.34806 .28272 .33026 .28712 .34623 .29749 .36401 .29333 Metetra
1 g
.33189 .27211 .31406 .27673 .33026 .28712 .34806 .28272 Metetra
1 g
.31548 .26146 .29762 .2663 .31406 .27673 .33189 .27211 Metetra
1 g
.29883 .25077 .28095 .25582 .29762 .2663 .31548 .26146 Metetra
1 g
.28194 .24003 .26403 .24528 .28095 .25582 .29883 .25077 Metetra
1 g
.2648 .22921 .24686 .23465 .26403 .24528 .28194 .24003 Metetra
1 g
.2474 .2183 .22943 .22395 .24686 .23465 .2648 .22921 Metetra
1 g
.22974 .2073 .21175 .21314 .22943 .22395 .2474 .2183 Metetra
1 g
.2118 .1962 .19379 .20223 .21175 .21314 .22974 .2073 Metetra
1 g
.65192 .62832 .634 .63307 .64665 .63902 .66452 .63434 Metetra
1 g
.63916 .62223 .62119 .62703 .634 .63307 .65192 .62832 Metetra
1 g
.62622 .61605 .60783 .6018 .62119 .62703 .63916 .62223 Metetra
1 g
.61195 .5523 .59385 .54337 .60783 .6018 .62622 .61605 Metetra
1 g
.59821 .51159 .58026 .50578 .59385 .54337 .61195 .5523 Metetra
1 g
.58464 .4821 .56678 .47836 .58026 .50578 .59821 .51159 Metetra
1 g
.57109 .45888 .55327 .45662 .56678 .47836 .58464 .4821 Metetra
1 g
.55748 .4395 .53969 .43836 .55327 .45662 .57109 .45888 Metetra
1 g
.54378 .42263 .52599 .42237 .53969 .43836 .55748 .4395 Metetra
1 g
.52995 .40747 .51216 .40793 .52599 .42237 .54378 .42263 Metetra
1 g
.51597 .39352 .49818 .39458 .51216 .40793 .52995 .40747 Metetra
1 g
.50183 .38044 .48403 .38202 .49818 .39458 .51597 .39352 Metetra
1 g
.48753 .368 .4697 .37003 .48403 .38202 .50183 .38044 Metetra
1 g
.47305 .35604 .4552 .35847 .4697 .37003 .48753 .368 Metetra
1 g
.45838 .34443 .44051 .34722 .4552 .35847 .47305 .35604 Metetra
1 g
.44351 .33308 .42562 .3362 .44051 .34722 .45838 .34443 Metetra
1 g
.42845 .32193 .41053 .32535 .42562 .3362 .44351 .33308 Metetra
1 g
.41319 .31091 .39524 .31461 .41053 .32535 .42845 .32193 Metetra
1 g
.39771 .29998 .37973 .30395 .39524 .31461 .41319 .31091 Metetra
1 g
.38201 .28911 .36401 .29333 .37973 .30395 .39771 .29998 Metetra
1 g
.36609 .27827 .34806 .28272 .36401 .29333 .38201 .28911 Metetra
1 g
.34995 .26743 .33189 .27211 .34806 .28272 .36609 .27827 Metetra
1 g
.33357 .25656 .31548 .26146 .33189 .27211 .34995 .26743 Metetra
1 g
.31695 .24566 .29883 .25077 .31548 .26146 .33357 .25656 Metetra
1 g
.30008 .23471 .28194 .24003 .29883 .25077 .31695 .24566 Metetra
1 g
.28297 .22369 .2648 .22921 .28194 .24003 .30008 .23471 Metetra
1 g
.26559 .21259 .2474 .2183 .2648 .22921 .28297 .22369 Metetra
1 g
.24796 .20139 .22974 .2073 .2474 .2183 .26559 .21259 Metetra
1 g
.23005 .1901 .2118 .1962 .22974 .2073 .24796 .20139 Metetra
1 g
.67003 .62353 .65192 .62832 .66452 .63434 .68258 .62961 Metetra
1 g
.65732 .61737 .63916 .62223 .65192 .62832 .67003 .62353 Metetra
1 g
.64444 .61112 .62622 .61605 .63916 .62223 .65732 .61737 Metetra
1 g
.63035 .56137 .61195 .5523 .62622 .61605 .64444 .61112 Metetra
1 g
.61643 .51748 .59821 .51159 .61195 .5523 .63035 .56137 Metetra
1 g
.60276 .48589 .58464 .4821 .59821 .51159 .61643 .51748 Metetra
1 g
.58915 .46117 .57109 .45888 .58464 .4821 .60276 .48589 Metetra
1 g
.57552 .44066 .55748 .4395 .57109 .45888 .58915 .46117 Metetra
1 g
.5618 .42289 .54378 .42263 .55748 .4395 .57552 .44066 Metetra
1 g
.54796 .407 .52995 .40747 .54378 .42263 .5618 .42289 Metetra
1 g
.53399 .39244 .51597 .39352 .52995 .40747 .54796 .407 Metetra
1 g
.51987 .37884 .50183 .38044 .51597 .39352 .53399 .39244 Metetra
1 g
.50558 .36594 .48753 .368 .50183 .38044 .51987 .37884 Metetra
1 g
.49112 .35358 .47305 .35604 .48753 .368 .50558 .36594 Metetra
1 g
.47647 .3416 .45838 .34443 .47305 .35604 .49112 .35358 Metetra
1 g
.46164 .32992 .44351 .33308 .45838 .34443 .47647 .3416 Metetra
1 g
.4466 .31846 .42845 .32193 .44351 .33308 .46164 .32992 Metetra
1 g
.43136 .30716 .41319 .31091 .42845 .32193 .4466 .31846 Metetra
1 g
.41591 .29597 .39771 .29998 .41319 .31091 .43136 .30716 Metetra
1 g
.40025 .28484 .38201 .28911 .39771 .29998 .41591 .29597 Metetra
1 g
.38436 .27376 .36609 .27827 .38201 .28911 .40025 .28484 Metetra
1 g
.36824 .26269 .34995 .26743 .36609 .27827 .38436 .27376 Metetra
1 g
.35189 .2516 .33357 .25656 .34995 .26743 .36824 .26269 Metetra
1 g
.3353 .24049 .31695 .24566 .33357 .25656 .35189 .2516 Metetra
1 g
.31846 .22933 .30008 .23471 .31695 .24566 .3353 .24049 Metetra
1 g
.30138 .2181 .28297 .22369 .30008 .23471 .31846 .22933 Metetra
1 g
.28403 .2068 .26559 .21259 .28297 .22369 .30138 .2181 Metetra
1 g
.26642 .1954 .24796 .20139 .26559 .21259 .28403 .2068 Metetra
1 g
.24854 .18391 .23005 .1901 .24796 .20139 .26642 .1954 Metetra
1 g
.68834 .61868 .67003 .62353 .68258 .62961 .70082 .62483 Metetra
1 g
.67568 .61246 .65732 .61737 .67003 .62353 .68834 .61868 Metetra
1 g
.66286 .60615 .64444 .61112 .65732 .61737 .67568 .61246 Metetra
1 g
.64905 .57059 .63035 .56137 .64444 .61112 .66286 .60615 Metetra
1 g
.63493 .52346 .61643 .51748 .63035 .56137 .64905 .57059 Metetra
1 g
.62115 .48974 .60276 .48589 .61643 .51748 .63493 .52346 Metetra
1 g
.60747 .46349 .58915 .46117 .60276 .48589 .62115 .48974 Metetra
1 g
.5938 .44183 .57552 .44066 .58915 .46117 .60747 .46349 Metetra
1 g
.58006 .42316 .5618 .42289 .57552 .44066 .5938 .44183 Metetra
1 g
.56622 .40653 .54796 .407 .5618 .42289 .58006 .42316 Metetra
1 g
.55225 .39135 .53399 .39244 .54796 .407 .56622 .40653 Metetra
1 g
.53814 .37722 .51987 .37884 .53399 .39244 .55225 .39135 Metetra
1 g
.52387 .36386 .50558 .36594 .51987 .37884 .53814 .37722 Metetra
1 g
.50943 .35108 .49112 .35358 .50558 .36594 .52387 .36386 Metetra
1 g
.4948 .33874 .47647 .3416 .49112 .35358 .50943 .35108 Metetra
1 g
.47999 .32672 .46164 .32992 .47647 .3416 .4948 .33874 Metetra
1 g
.46498 .31495 .4466 .31846 .46164 .32992 .47999 .32672 Metetra
1 g
.44977 .30336 .43136 .30716 .4466 .31846 .46498 .31495 Metetra
1 g
.43435 .2919 .41591 .29597 .43136 .30716 .44977 .30336 Metetra
1 g
.41871 .28052 .40025 .28484 .41591 .29597 .43435 .2919 Metetra
1 g
.40286 .26919 .38436 .27376 .40025 .28484 .41871 .28052 Metetra
1 g
.38677 .25789 .36824 .26269 .38436 .27376 .40286 .26919 Metetra
1 g
.37045 .24658 .35189 .2516 .36824 .26269 .38677 .25789 Metetra
1 g
.35389 .23525 .3353 .24049 .35189 .2516 .37045 .24658 Metetra
1 g
.33708 .22387 .31846 .22933 .3353 .24049 .35389 .23525 Metetra
1 g
.32002 .21244 .30138 .2181 .31846 .22933 .33708 .22387 Metetra
1 g
.30271 .20093 .28403 .2068 .30138 .2181 .32002 .21244 Metetra
1 g
.28513 .18934 .26642 .1954 .28403 .2068 .30271 .20093 Metetra
1 g
.26727 .17765 .24854 .18391 .26642 .1954 .28513 .18934 Metetra
1 g
.70683 .61379 .68834 .61868 .70082 .62483 .71926 .62 Metetra
1 g
.69424 .6075 .67568 .61246 .68834 .61868 .70683 .61379 Metetra
1 g
.68147 .60112 .66286 .60615 .67568 .61246 .69424 .6075 Metetra
1 g
.66806 .57997 .64905 .57059 .66286 .60615 .68147 .60112 Metetra
1 g
.65372 .52954 .63493 .52346 .64905 .57059 .66806 .57997 Metetra
1 g
.6398 .49364 .62115 .48974 .63493 .52346 .65372 .52954 Metetra
1 g
.62605 .46585 .60747 .46349 .62115 .48974 .6398 .49364 Metetra
1 g
.61233 .44302 .5938 .44183 .60747 .46349 .62605 .46585 Metetra
1 g
.59857 .42343 .58006 .42316 .5938 .44183 .61233 .44302 Metetra
1 g
.58472 .40605 .56622 .40653 .58006 .42316 .59857 .42343 Metetra
1 g
.57076 .39024 .55225 .39135 .56622 .40653 .58472 .40605 Metetra
1 g
.55665 .37557 .53814 .37722 .55225 .39135 .57076 .39024 Metetra
1 g
.5424 .36175 .52387 .36386 .53814 .37722 .55665 .37557 Metetra
1 g
.52797 .34855 .50943 .35108 .52387 .36386 .5424 .36175 Metetra
1 g
.51337 .33584 .4948 .33874 .50943 .35108 .52797 .34855 Metetra
1 g
.49858 .32348 .47999 .32672 .4948 .33874 .51337 .33584 Metetra
1 g
.4836 .3114 .46498 .31495 .47999 .32672 .49858 .32348 Metetra
1 g
.46842 .29952 .44977 .30336 .46498 .31495 .4836 .3114 Metetra
1 g
.45303 .28778 .43435 .2919 .44977 .30336 .46842 .29952 Metetra
1 g
.43742 .27614 .41871 .28052 .43435 .2919 .45303 .28778 Metetra
1 g
.42159 .26457 .40286 .26919 .41871 .28052 .43742 .27614 Metetra
1 g
.40554 .25303 .38677 .25789 .40286 .26919 .42159 .26457 Metetra
1 g
.38925 .24149 .37045 .24658 .38677 .25789 .40554 .25303 Metetra
1 g
.37272 .22993 .35389 .23525 .37045 .24658 .38925 .24149 Metetra
1 g
.35595 .21834 .33708 .22387 .35389 .23525 .37272 .22993 Metetra
1 g
.33892 .2067 .32002 .21244 .33708 .22387 .35595 .21834 Metetra
1 g
.32163 .19498 .30271 .20093 .32002 .21244 .33892 .2067 Metetra
1 g
.30408 .18319 .28513 .18934 .30271 .20093 .32163 .19498 Metetra
1 g
.28626 .17129 .26727 .17765 .28513 .18934 .30408 .18319 Metetra
1 g
.72552 .60884 .70683 .61379 .71926 .62 .73789 .61511 Metetra
1 g
.71299 .60248 .69424 .6075 .70683 .61379 .72552 .60884 Metetra
1 g
.70028 .59603 .68147 .60112 .69424 .6075 .71299 .60248 Metetra
1 g
.6874 .5895 .66806 .57997 .68147 .60112 .70028 .59603 Metetra
1 g
.6728 .53571 .65372 .52954 .66806 .57997 .6874 .5895 Metetra
1 g
.65873 .49761 .6398 .49364 .65372 .52954 .6728 .53571 Metetra
1 g
.64489 .46824 .62605 .46585 .6398 .49364 .65873 .49761 Metetra
1 g
.63112 .44423 .61233 .44302 .62605 .46585 .64489 .46824 Metetra
1 g
.61733 .4237 .59857 .42343 .61233 .44302 .63112 .44423 Metetra
1 g
.60347 .40557 .58472 .40605 .59857 .42343 .61733 .4237 Metetra
1 g
.5895 .38912 .57076 .39024 .58472 .40605 .60347 .40557 Metetra
1 g
.57541 .37391 .55665 .37557 .57076 .39024 .5895 .38912 Metetra
1 g
.56116 .35961 .5424 .36175 .55665 .37557 .57541 .37391 Metetra
1 g
.54676 .34599 .52797 .34855 .5424 .36175 .56116 .35961 Metetra
1 g
.53218 .3329 .51337 .33584 .52797 .34855 .54676 .34599 Metetra
1 g
.51741 .3202 .49858 .32348 .51337 .33584 .53218 .3329 Metetra
1 g
.50246 .3078 .4836 .3114 .49858 .32348 .51741 .3202 Metetra
1 g
.48731 .29562 .46842 .29952 .4836 .3114 .50246 .3078 Metetra
1 g
.47194 .28361 .45303 .28778 .46842 .29952 .48731 .29562 Metetra
1 g
.45637 .27171 .43742 .27614 .45303 .28778 .47194 .28361 Metetra
1 g
.44057 .25988 .42159 .26457 .43742 .27614 .45637 .27171 Metetra
1 g
.42455 .2481 .40554 .25303 .42159 .26457 .44057 .25988 Metetra
1 g
.4083 .23633 .38925 .24149 .40554 .25303 .42455 .2481 Metetra
1 g
.3918 .22455 .37272 .22993 .38925 .24149 .4083 .23633 Metetra
1 g
.37506 .21274 .35595 .21834 .37272 .22993 .3918 .22455 Metetra
1 g
.35806 .20088 .33892 .2067 .35595 .21834 .37506 .21274 Metetra
1 g
.34081 .18896 .32163 .19498 .33892 .2067 .35806 .20088 Metetra
1 g
.32329 .17695 .30408 .18319 .32163 .19498 .34081 .18896 Metetra
1 g
.3055 .16486 .28626 .17129 .30408 .18319 .32329 .17695 Metetra
1 g
.74442 .60384 .72552 .60884 .73789 .61511 .75672 .61018 Metetra
1 g
.73194 .59741 .71299 .60248 .72552 .60884 .74442 .60384 Metetra
1 g
.7193 .59089 .70028 .59603 .71299 .60248 .73194 .59741 Metetra
1 g
.70647 .58429 .6874 .5895 .70028 .59603 .7193 .59089 Metetra
1 g
.69218 .54198 .6728 .53571 .6874 .5895 .70647 .58429 Metetra
1 g
.67795 .50163 .65873 .49761 .6728 .53571 .69218 .54198 Metetra
1 g
.66401 .47067 .64489 .46824 .65873 .49761 .67795 .50163 Metetra
1 g
.65017 .44545 .63112 .44423 .64489 .46824 .66401 .47067 Metetra
1 g
.63635 .42398 .61733 .4237 .63112 .44423 .65017 .44545 Metetra
1 g
.62247 .40508 .60347 .40557 .61733 .4237 .63635 .42398 Metetra
1 g
.6085 .38799 .5895 .38912 .60347 .40557 .62247 .40508 Metetra
1 g
.59441 .37222 .57541 .37391 .5895 .38912 .6085 .38799 Metetra
1 g
.58018 .35744 .56116 .35961 .57541 .37391 .59441 .37222 Metetra
1 g
.56579 .3434 .54676 .34599 .56116 .35961 .58018 .35744 Metetra
1 g
.55123 .32992 .53218 .3329 .54676 .34599 .56579 .3434 Metetra
1 g
.53649 .31687 .51741 .3202 .53218 .3329 .55123 .32992 Metetra
1 g
.52156 .30415 .50246 .3078 .51741 .3202 .53649 .31687 Metetra
1 g
.50644 .29167 .48731 .29562 .50246 .3078 .52156 .30415 Metetra
1 g
.49111 .27938 .47194 .28361 .48731 .29562 .50644 .29167 Metetra
1 g
.47557 .26721 .45637 .27171 .47194 .28361 .49111 .27938 Metetra
1 g
.4598 .25513 .44057 .25988 .45637 .27171 .47557 .26721 Metetra
1 g
.44382 .24311 .42455 .2481 .44057 .25988 .4598 .25513 Metetra
1 g
.42759 .23111 .4083 .23633 .42455 .2481 .44382 .24311 Metetra
1 g
.41113 .2191 .3918 .22455 .4083 .23633 .42759 .23111 Metetra
1 g
.39442 .20707 .37506 .21274 .3918 .22455 .41113 .2191 Metetra
1 g
.37746 .19499 .35806 .20088 .37506 .21274 .39442 .20707 Metetra
1 g
.36024 .18285 .34081 .18896 .35806 .20088 .37746 .19499 Metetra
1 g
.34276 .17064 .32329 .17695 .34081 .18896 .36024 .18285 Metetra
1 g
.325 .15833 .3055 .16486 .32329 .17695 .34276 .17064 Metetra
1 g
.76351 .59878 .74442 .60384 .75672 .61018 .77576 .60519 Metetra
1 g
.7511 .59229 .73194 .59741 .74442 .60384 .76351 .59878 Metetra
1 g
.73852 .5857 .7193 .59089 .73194 .59741 .7511 .59229 Metetra
1 g
.72576 .57902 .70647 .58429 .7193 .59089 .73852 .5857 Metetra
1 g
.71186 .54834 .69218 .54198 .70647 .58429 .72576 .57902 Metetra
1 g
.69745 .50571 .67795 .50163 .69218 .54198 .71186 .54834 Metetra
1 g
.6834 .47313 .66401 .47067 .67795 .50163 .69745 .50571 Metetra
1 g
.6695 .44669 .65017 .44545 .66401 .47067 .6834 .47313 Metetra
1 g
.65563 .42426 .63635 .42398 .65017 .44545 .6695 .44669 Metetra
1 g
.64173 .40458 .62247 .40508 .63635 .42398 .65563 .42426 Metetra
1 g
.62775 .38684 .6085 .38799 .62247 .40508 .64173 .40458 Metetra
1 g
.61366 .37051 .59441 .37222 .6085 .38799 .62775 .38684 Metetra
1 g
.59944 .35524 .58018 .35744 .59441 .37222 .61366 .37051 Metetra
1 g
.58507 .34077 .56579 .3434 .58018 .35744 .59944 .35524 Metetra
1 g
.57053 .32691 .55123 .32992 .56579 .3434 .58507 .34077 Metetra
1 g
.55582 .3135 .53649 .31687 .55123 .32992 .57053 .32691 Metetra
1 g
.54092 .30045 .52156 .30415 .53649 .31687 .55582 .3135 Metetra
1 g
.52583 .28767 .50644 .29167 .52156 .30415 .54092 .30045 Metetra
1 g
.51053 .27509 .49111 .27938 .50644 .29167 .52583 .28767 Metetra
1 g
.49502 .26266 .47557 .26721 .49111 .27938 .51053 .27509 Metetra
1 g
.47929 .25032 .4598 .25513 .47557 .26721 .49502 .26266 Metetra
1 g
.46334 .23805 .44382 .24311 .4598 .25513 .47929 .25032 Metetra
1 g
.44715 .22581 .42759 .23111 .44382 .24311 .46334 .23805 Metetra
1 g
.43072 .21357 .41113 .2191 .42759 .23111 .44715 .22581 Metetra
1 g
.41405 .20132 .39442 .20707 .41113 .2191 .43072 .21357 Metetra
1 g
.39713 .18902 .37746 .19499 .39442 .20707 .41405 .20132 Metetra
1 g
.37994 .17667 .36024 .18285 .37746 .19499 .39713 .18902 Metetra
1 g
.36249 .16424 .34276 .17064 .36024 .18285 .37994 .17667 Metetra
1 g
.34476 .15172 .325 .15833 .34276 .17064 .36249 .16424 Metetra
1 g
.78282 .59367 .76351 .59878 .77576 .60519 .79499 .60015 Metetra
1 g
.77047 .58711 .7511 .59229 .76351 .59878 .78282 .59367 Metetra
1 g
.75796 .58044 .73852 .5857 .7511 .59229 .77047 .58711 Metetra
1 g
.74526 .57369 .72576 .57902 .73852 .5857 .75796 .58044 Metetra
1 g
.73186 .55481 .71186 .54834 .72576 .57902 .74526 .57369 Metetra
1 g
.71725 .50985 .69745 .50571 .71186 .54834 .73186 .55481 Metetra
1 g
.70307 .47563 .6834 .47313 .69745 .50571 .71725 .50985 Metetra
1 g
.68909 .44795 .6695 .44669 .6834 .47313 .70307 .47563 Metetra
1 g
.67518 .42455 .65563 .42426 .6695 .44669 .68909 .44795 Metetra
1 g
.66125 .40407 .64173 .40458 .65563 .42426 .67518 .42455 Metetra
1 g
.64727 .38567 .62775 .38684 .64173 .40458 .66125 .40407 Metetra
1 g
.63318 .36878 .61366 .37051 .62775 .38684 .64727 .38567 Metetra
1 g
.61897 .35302 .59944 .35524 .61366 .37051 .63318 .36878 Metetra
1 g
.60461 .33811 .58507 .34077 .59944 .35524 .61897 .35302 Metetra
1 g
.59009 .32385 .57053 .32691 .58507 .34077 .60461 .33811 Metetra
1 g
.5754 .31009 .55582 .3135 .57053 .32691 .59009 .32385 Metetra
1 g
.56053 .29671 .54092 .30045 .55582 .3135 .5754 .31009 Metetra
1 g
.54547 .28362 .52583 .28767 .54092 .30045 .56053 .29671 Metetra
1 g
.5302 .27075 .51053 .27509 .52583 .28767 .54547 .28362 Metetra
1 g
.51473 .25805 .49502 .26266 .51053 .27509 .5302 .27075 Metetra
1 g
.49903 .24545 .47929 .25032 .49502 .26266 .51473 .25805 Metetra
1 g
.48311 .23293 .46334 .23805 .47929 .25032 .49903 .24545 Metetra
1 g
.46696 .22045 .44715 .22581 .46334 .23805 .48311 .23293 Metetra
1 g
.45058 .20797 .43072 .21357 .44715 .22581 .46696 .22045 Metetra
1 g
.43394 .19549 .41405 .20132 .43072 .21357 .45058 .20797 Metetra
1 g
.41705 .18297 .39713 .18902 .41405 .20132 .43394 .19549 Metetra
1 g
.39991 .17039 .37994 .17667 .39713 .18902 .41705 .18297 Metetra
1 g
.38249 .15775 .36249 .16424 .37994 .17667 .39991 .17039 Metetra
1 g
.3648 .14502 .34476 .15172 .36249 .16424 .38249 .15775 Metetra
1 g
.80233 .58851 .78282 .59367 .79499 .60015 .81444 .59506 Metetra
1 g
.79005 .58187 .77047 .58711 .78282 .59367 .80233 .58851 Metetra
1 g
.77761 .57513 .75796 .58044 .77047 .58711 .79005 .58187 Metetra
1 g
.76498 .56831 .74526 .57369 .75796 .58044 .77761 .57513 Metetra
1 g
.75218 .56138 .73186 .55481 .74526 .57369 .76498 .56831 Metetra
1 g
.73735 .51406 .71725 .50985 .73186 .55481 .75218 .56138 Metetra
1 g
.72303 .47816 .70307 .47563 .71725 .50985 .73735 .51406 Metetra
1 g
.70897 .44923 .68909 .44795 .70307 .47563 .72303 .47816 Metetra
1 g
.695 .42484 .67518 .42455 .68909 .44795 .70897 .44923 Metetra
1 g
.68105 .40356 .66125 .40407 .67518 .42455 .695 .42484 Metetra
1 g
.66705 .38449 .64727 .38567 .66125 .40407 .68105 .40356 Metetra
1 g
.65296 .36702 .63318 .36878 .64727 .38567 .66705 .38449 Metetra
1 g
.63875 .35076 .61897 .35302 .63318 .36878 .65296 .36702 Metetra
1 g
.62441 .33541 .60461 .33811 .61897 .35302 .63875 .35076 Metetra
1 g
.60991 .32075 .59009 .32385 .60461 .33811 .62441 .33541 Metetra
1 g
.59525 .30663 .5754 .31009 .59009 .32385 .60991 .32075 Metetra
1 g
.58041 .29292 .56053 .29671 .5754 .31009 .59525 .30663 Metetra
1 g
.56537 .27952 .54547 .28362 .56053 .29671 .58041 .29292 Metetra
1 g
.55014 .26636 .5302 .27075 .54547 .28362 .56537 .27952 Metetra
1 g
.5347 .25337 .51473 .25805 .5302 .27075 .55014 .26636 Metetra
1 g
.51904 .24051 .49903 .24545 .51473 .25805 .5347 .25337 Metetra
1 g
.50316 .22774 .48311 .23293 .49903 .24545 .51904 .24051 Metetra
1 g
.48705 .21501 .46696 .22045 .48311 .23293 .50316 .22774 Metetra
1 g
.4707 .2023 .45058 .20797 .46696 .22045 .48705 .21501 Metetra
1 g
.4541 .18958 .43394 .19549 .45058 .20797 .4707 .2023 Metetra
1 g
.43725 .17683 .41705 .18297 .43394 .19549 .4541 .18958 Metetra
1 g
.42015 .16404 .39991 .17039 .41705 .18297 .43725 .17683 Metetra
1 g
.40277 .15117 .38249 .15775 .39991 .17039 .42015 .16404 Metetra
1 g
.38512 .13822 .3648 .14502 .38249 .15775 .40277 .15117 Metetra
1 g
.82206 .58329 .80233 .58851 .81444 .59506 .8341 .58991 Metetra
1 g
.80985 .57657 .79005 .58187 .80233 .58851 .82206 .58329 Metetra
1 g
.79747 .56976 .77761 .57513 .79005 .58187 .80985 .57657 Metetra
1 g
.78492 .56286 .76498 .56831 .77761 .57513 .79747 .56976 Metetra
1 g
.77219 .55585 .75218 .56138 .76498 .56831 .78492 .56286 Metetra
1 g
.75775 .51833 .73735 .51406 .75218 .56138 .77219 .55585 Metetra
1 g
.74329 .48073 .72303 .47816 .73735 .51406 .75775 .51833 Metetra
1 g
.72913 .45052 .70897 .44923 .72303 .47816 .74329 .48073 Metetra
1 g
.7151 .42513 .695 .42484 .70897 .44923 .72913 .45052 Metetra
1 g
.70112 .40304 .68105 .40356 .695 .42484 .7151 .42513 Metetra
1 g
.6871 .38329 .66705 .38449 .68105 .40356 .70112 .40304 Metetra
1 g
.673 .36524 .65296 .36702 .66705 .38449 .6871 .38329 Metetra
1 g
.6588 .34848 .63875 .35076 .65296 .36702 .673 .36524 Metetra
1 g
.64448 .33268 .62441 .33541 .63875 .35076 .6588 .34848 Metetra
1 g
.63 .31762 .60991 .32075 .62441 .33541 .64448 .33268 Metetra
1 g
.61536 .30312 .59525 .30663 .60991 .32075 .63 .31762 Metetra
1 g
.60055 .28907 .58041 .29292 .59525 .30663 .61536 .30312 Metetra
1 g
.58554 .27536 .56537 .27952 .58041 .29292 .60055 .28907 Metetra
1 g
.57034 .2619 .55014 .26636 .56537 .27952 .58554 .27536 Metetra
1 g
.55494 .24863 .5347 .25337 .55014 .26636 .57034 .2619 Metetra
1 g
.53932 .23551 .51904 .24051 .5347 .25337 .55494 .24863 Metetra
1 g
.52348 .22247 .50316 .22774 .51904 .24051 .53932 .23551 Metetra
1 g
.5074 .2095 .48705 .21501 .50316 .22774 .52348 .22247 Metetra
1 g
.49109 .19655 .4707 .2023 .48705 .21501 .5074 .2095 Metetra
1 g
.47454 .18359 .4541 .18958 .4707 .2023 .49109 .19655 Metetra
1 g
.45773 .17062 .43725 .17683 .4541 .18958 .47454 .18359 Metetra
1 g
.44066 .15759 .42015 .16404 .43725 .17683 .45773 .17062 Metetra
1 g
.42333 .1445 .40277 .15117 .42015 .16404 .44066 .15759 Metetra
1 g
.40572 .13133 .38512 .13822 .40277 .15117 .42333 .1445 Metetra
1 g
.842 .57801 .82206 .58329 .8341 .58991 .85397 .5847 Metetra
1 g
.82987 .57122 .80985 .57657 .82206 .58329 .842 .57801 Metetra
1 g
.81756 .56433 .79747 .56976 .80985 .57657 .82987 .57122 Metetra
1 g
.80508 .55735 .78492 .56286 .79747 .56976 .81756 .56433 Metetra
1 g
.79242 .55027 .77219 .55585 .78492 .56286 .80508 .55735 Metetra
1 g
.77847 .52267 .75775 .51833 .77219 .55585 .79242 .55027 Metetra
1 g
.76385 .48334 .74329 .48073 .75775 .51833 .77847 .52267 Metetra
1 g
.74958 .45184 .72913 .45052 .74329 .48073 .76385 .48334 Metetra
1 g
.73549 .42543 .7151 .42513 .72913 .45052 .74958 .45184 Metetra
1 g
.72146 .40251 .70112 .40304 .7151 .42513 .73549 .42543 Metetra
1 g
.70742 .38207 .6871 .38329 .70112 .40304 .72146 .40251 Metetra
1 g
.69332 .36344 .673 .36524 .6871 .38329 .70742 .38207 Metetra
1 g
.67913 .34616 .6588 .34848 .673 .36524 .69332 .36344 Metetra
1 g
.66482 .32991 .64448 .33268 .6588 .34848 .67913 .34616 Metetra
1 g
.65036 .31443 .63 .31762 .64448 .33268 .66482 .32991 Metetra
1 g
.63574 .29957 .61536 .30312 .63 .31762 .65036 .31443 Metetra
1 g
.62096 .28517 .60055 .28907 .61536 .30312 .63574 .29957 Metetra
1 g
.60599 .27114 .58554 .27536 .60055 .28907 .62096 .28517 Metetra
1 g
.59082 .25738 .57034 .2619 .58554 .27536 .60599 .27114 Metetra
1 g
.57545 .24383 .55494 .24863 .57034 .2619 .59082 .25738 Metetra
1 g
.55987 .23043 .53932 .23551 .55494 .24863 .57545 .24383 Metetra
1 g
.54407 .21714 .52348 .22247 .53932 .23551 .55987 .23043 Metetra
1 g
.52804 .20391 .5074 .2095 .52348 .22247 .54407 .21714 Metetra
1 g
.51177 .19072 .49109 .19655 .5074 .2095 .52804 .20391 Metetra
1 g
.49526 .17752 .47454 .18359 .49109 .19655 .51177 .19072 Metetra
1 g
.47849 .16431 .45773 .17062 .47454 .18359 .49526 .17752 Metetra
1 g
.46147 .15106 .44066 .15759 .45773 .17062 .47849 .16431 Metetra
1 g
.44418 .13774 .42333 .1445 .44066 .15759 .46147 .15106 Metetra
1 g
.42661 .12434 .40572 .13133 .42333 .1445 .44418 .13774 Metetra
1 g
.86217 .57267 .842 .57801 .85397 .5847 .87406 .57944 Metetra
1 g
.85011 .5658 .82987 .57122 .842 .57801 .86217 .57267 Metetra
1 g
.83788 .55884 .81756 .56433 .82987 .57122 .85011 .5658 Metetra
1 g
.82547 .55178 .80508 .55735 .81756 .56433 .83788 .55884 Metetra
1 g
.81289 .54462 .79242 .55027 .80508 .55735 .82547 .55178 Metetra
1 g
.79952 .52708 .77847 .52267 .79242 .55027 .81289 .54462 Metetra
1 g
.78471 .48599 .76385 .48334 .77847 .52267 .79952 .52708 Metetra
1 g
.77033 .45317 .74958 .45184 .76385 .48334 .78471 .48599 Metetra
1 g
.75617 .42573 .73549 .42543 .74958 .45184 .77033 .45317 Metetra
1 g
.7421 .40198 .72146 .40251 .73549 .42543 .75617 .42573 Metetra
1 g
.72803 .38084 .70742 .38207 .72146 .40251 .7421 .40198 Metetra
1 g
.71393 .36161 .69332 .36344 .70742 .38207 .72803 .38084 Metetra
1 g
.69974 .34381 .67913 .34616 .69332 .36344 .71393 .36161 Metetra
1 g
.68543 .3271 .66482 .32991 .67913 .34616 .69974 .34381 Metetra
1 g
.67099 .31121 .65036 .31443 .66482 .32991 .68543 .3271 Metetra
1 g
.6564 .29597 .63574 .29957 .65036 .31443 .67099 .31121 Metetra
1 g
.64164 .28122 .62096 .28517 .63574 .29957 .6564 .29597 Metetra
1 g
.62671 .26686 .60599 .27114 .62096 .28517 .64164 .28122 Metetra
1 g
.61158 .2528 .59082 .25738 .60599 .27114 .62671 .26686 Metetra
1 g
.59625 .23896 .57545 .24383 .59082 .25738 .61158 .2528 Metetra
1 g
.5807 .22529 .55987 .23043 .57545 .24383 .59625 .23896 Metetra
1 g
.56494 .21173 .54407 .21714 .55987 .23043 .5807 .22529 Metetra
1 g
.54895 .19825 .52804 .20391 .54407 .21714 .56494 .21173 Metetra
1 g
.53273 .1848 .51177 .19072 .52804 .20391 .54895 .19825 Metetra
1 g
.51626 .17137 .49526 .17752 .51177 .19072 .53273 .1848 Metetra
1 g
.49954 .15792 .47849 .16431 .49526 .17752 .51626 .17137 Metetra
1 g
.48256 .14443 .46147 .15106 .47849 .16431 .49954 .15792 Metetra
1 g
.46531 .13088 .44418 .13774 .46147 .15106 .48256 .14443 Metetra
1 g
.44779 .11725 .42661 .12434 .44418 .13774 .46531 .13088 Metetra
1 g
.88256 .56727 .86217 .57267 .87406 .57944 .89437 .57411 Metetra
1 g
.87058 .56033 .85011 .5658 .86217 .57267 .88256 .56727 Metetra
1 g
.85842 .55329 .83788 .55884 .85011 .5658 .87058 .56033 Metetra
1 g
.8461 .54615 .82547 .55178 .83788 .55884 .85842 .55329 Metetra
1 g
.83359 .5389 .81289 .54462 .82547 .55178 .8461 .54615 Metetra
1 g
.8209 .53155 .79952 .52708 .81289 .54462 .83359 .5389 Metetra
1 g
.8059 .48868 .78471 .48599 .79952 .52708 .8209 .53155 Metetra
1 g
.79139 .45452 .77033 .45317 .78471 .48599 .8059 .48868 Metetra
1 g
.77715 .42604 .75617 .42573 .77033 .45317 .79139 .45452 Metetra
1 g
.76302 .40143 .7421 .40198 .75617 .42573 .77715 .42604 Metetra
1 g
.74893 .37959 .72803 .38084 .7421 .40198 .76302 .40143 Metetra
1 g
.73481 .35976 .71393 .36161 .72803 .38084 .74893 .37959 Metetra
1 g
.72062 .34143 .69974 .34381 .71393 .36161 .73481 .35976 Metetra
1 g
.70633 .32425 .68543 .3271 .69974 .34381 .72062 .34143 Metetra
1 g
.69191 .30794 .67099 .31121 .68543 .3271 .70633 .32425 Metetra
1 g
.67734 .29232 .6564 .29597 .67099 .31121 .69191 .30794 Metetra
1 g
.66262 .27722 .64164 .28122 .6564 .29597 .67734 .29232 Metetra
1 g
.64771 .26253 .62671 .26686 .64164 .28122 .66262 .27722 Metetra
1 g
.63262 .24816 .61158 .2528 .62671 .26686 .64771 .26253 Metetra
1 g
.61732 .23403 .59625 .23896 .61158 .2528 .63262 .24816 Metetra
1 g
.60182 .22007 .5807 .22529 .59625 .23896 .61732 .23403 Metetra
1 g
.58611 .20625 .56494 .21173 .5807 .22529 .60182 .22007 Metetra
1 g
.57016 .1925 .54895 .19825 .56494 .21173 .58611 .20625 Metetra
1 g
.55398 .17881 .53273 .1848 .54895 .19825 .57016 .1925 Metetra
1 g
.53756 .16513 .51626 .17137 .53273 .1848 .55398 .17881 Metetra
1 g
.52089 .15144 .49954 .15792 .51626 .17137 .53756 .16513 Metetra
1 g
.50395 .13771 .48256 .14443 .49954 .15792 .52089 .15144 Metetra
1 g
.48675 .12393 .46531 .13088 .48256 .14443 .50395 .13771 Metetra
1 g
.46928 .11006 .44779 .11725 .46531 .13088 .48675 .12393 Metetra
1 g
.90318 .56181 .88256 .56727 .89437 .57411 .91491 .56873 Metetra
1 g
.89128 .55479 .87058 .56033 .88256 .56727 .90318 .56181 Metetra
1 g
.8792 .54767 .85842 .55329 .87058 .56033 .89128 .55479 Metetra
1 g
.86695 .54045 .8461 .54615 .85842 .55329 .8792 .54767 Metetra
1 g
.85453 .53312 .83359 .5389 .8461 .54615 .86695 .54045 Metetra
1 g
.84192 .52568 .8209 .53155 .83359 .5389 .85453 .53312 Metetra
1 g
.8274 .49141 .8059 .48868 .8209 .53155 .84192 .52568 Metetra
1 g
.81276 .45589 .79139 .45452 .8059 .48868 .8274 .49141 Metetra
1 g
.79843 .42635 .77715 .42604 .79139 .45452 .81276 .45589 Metetra
1 g
.78425 .40088 .76302 .40143 .77715 .42604 .79843 .42635 Metetra
1 g
.77013 .37832 .74893 .37959 .76302 .40143 .78425 .40088 Metetra
1 g
.75599 .35788 .73481 .35976 .74893 .37959 .77013 .37832 Metetra
1 g
.7418 .33902 .72062 .34143 .73481 .35976 .75599 .35788 Metetra
1 g
.72752 .32136 .70633 .32425 .72062 .34143 .7418 .33902 Metetra
1 g
.71312 .30463 .69191 .30794 .70633 .32425 .72752 .32136 Metetra
1 g
.69858 .28862 .67734 .29232 .69191 .30794 .71312 .30463 Metetra
1 g
.68388 .27316 .66262 .27722 .67734 .29232 .69858 .28862 Metetra
1 g
.669 .25814 .64771 .26253 .66262 .27722 .68388 .27316 Metetra
1 g
.65395 .24345 .63262 .24816 .64771 .26253 .669 .25814 Metetra
1 g
.63869 .22903 .61732 .23403 .63262 .24816 .65395 .24345 Metetra
1 g
.62324 .21479 .60182 .22007 .61732 .23403 .63869 .22903 Metetra
1 g
.60756 .20069 .58611 .20625 .60182 .22007 .62324 .21479 Metetra
1 g
.59166 .18668 .57016 .1925 .58611 .20625 .60756 .20069 Metetra
1 g
.57553 .17273 .55398 .17881 .57016 .1925 .59166 .18668 Metetra
1 g
.55916 .1588 .53756 .16513 .55398 .17881 .57553 .17273 Metetra
1 g
.54253 .14486 .52089 .15144 .53756 .16513 .55916 .1588 Metetra
1 g
.52565 .13089 .50395 .13771 .52089 .15144 .54253 .14486 Metetra
1 g
.5085 .11687 .48675 .12393 .50395 .13771 .52565 .13089 Metetra
1 g
.49107 .10277 .46928 .11006 .48675 .12393 .5085 .11687 Metetra
1 g
.92403 .55629 .90318 .56181 .91491 .56873 .93568 .56329 Metetra
1 g
.91221 .5492 .89128 .55479 .90318 .56181 .92403 .55629 Metetra
1 g
.90022 .54199 .8792 .54767 .89128 .55479 .91221 .5492 Metetra
1 g
.88805 .53469 .86695 .54045 .8792 .54767 .90022 .54199 Metetra
1 g
.87571 .52727 .85453 .53312 .86695 .54045 .88805 .53469 Metetra
1 g
.86318 .51975 .84192 .52568 .85453 .53312 .87571 .52727 Metetra
1 g
.84924 .49418 .8274 .49141 .84192 .52568 .86318 .51975 Metetra
1 g
.83445 .45729 .81276 .45589 .8274 .49141 .84924 .49418 Metetra
1 g
.82002 .42666 .79843 .42635 .81276 .45589 .83445 .45729 Metetra
1 g
.80578 .40033 .78425 .40088 .79843 .42635 .82002 .42666 Metetra
1 g
.79162 .37704 .77013 .37832 .78425 .40088 .80578 .40033 Metetra
1 g
.77747 .35597 .75599 .35788 .77013 .37832 .79162 .37704 Metetra
1 g
.76328 .33657 .7418 .33902 .75599 .35788 .77747 .35597 Metetra
1 g
.749 .31843 .72752 .32136 .7418 .33902 .76328 .33657 Metetra
1 g
.73462 .30127 .71312 .30463 .72752 .32136 .749 .31843 Metetra
1 g
.7201 .28486 .69858 .28862 .71312 .30463 .73462 .30127 Metetra
1 g
.70543 .26904 .68388 .27316 .69858 .28862 .7201 .28486 Metetra
1 g
.69059 .25369 .669 .25814 .68388 .27316 .70543 .26904 Metetra
1 g
.67557 .23868 .65395 .24345 .669 .25814 .69059 .25369 Metetra
1 g
.66036 .22395 .63869 .22903 .65395 .24345 .67557 .23868 Metetra
1 g
.64495 .20943 .62324 .21479 .63869 .22903 .66036 .22395 Metetra
1 g
.62932 .19505 .60756 .20069 .62324 .21479 .64495 .20943 Metetra
1 g
.61347 .18078 .59166 .18668 .60756 .20069 .62932 .19505 Metetra
1 g
.59738 .16657 .57553 .17273 .59166 .18668 .61347 .18078 Metetra
1 g
.58106 .15238 .55916 .1588 .57553 .17273 .59738 .16657 Metetra
1 g
.56448 .1382 .54253 .14486 .55916 .1588 .58106 .15238 Metetra
1 g
.54765 .12398 .52565 .13089 .54253 .14486 .56448 .1382 Metetra
1 g
.53055 .10972 .5085 .11687 .52565 .13089 .54765 .12398 Metetra
1 g
.51318 .09538 .49107 .10277 .5085 .11687 .53055 .10972 Metetra
1 g
.94511 .55071 .92403 .55629 .93568 .56329 .95668 .55779 Metetra
1 g
.93338 .54353 .91221 .5492 .92403 .55629 .94511 .55071 Metetra
1 g
.92148 .53625 .90022 .54199 .91221 .5492 .93338 .54353 Metetra
1 g
.9094 .52886 .88805 .53469 .90022 .54199 .92148 .53625 Metetra
1 g
.89714 .52136 .87571 .52727 .88805 .53469 .9094 .52886 Metetra
1 g
.8847 .51375 .86318 .51975 .87571 .52727 .89714 .52136 Metetra
1 g
.87141 .49699 .84924 .49418 .86318 .51975 .8847 .51375 Metetra
1 g
.85646 .4587 .83445 .45729 .84924 .49418 .87141 .49699 Metetra
1 g
.84193 .42698 .82002 .42666 .83445 .45729 .85646 .4587 Metetra
1 g
.82762 .39976 .80578 .40033 .82002 .42666 .84193 .42698 Metetra
1 g
.81343 .37573 .79162 .37704 .80578 .40033 .82762 .39976 Metetra
1 g
.79926 .35404 .77747 .35597 .79162 .37704 .81343 .37573 Metetra
1 g
.78506 .33409 .76328 .33657 .77747 .35597 .79926 .35404 Metetra
1 g
.77079 .31546 .749 .31843 .76328 .33657 .78506 .33409 Metetra
1 g
.75642 .29786 .73462 .30127 .749 .31843 .77079 .31546 Metetra
1 g
.74193 .28106 .7201 .28486 .73462 .30127 .75642 .29786 Metetra
1 g
.72728 .26487 .70543 .26904 .7201 .28486 .74193 .28106 Metetra
1 g
.71248 .24917 .69059 .25369 .70543 .26904 .72728 .26487 Metetra
1 g
.6975 .23384 .67557 .23868 .69059 .25369 .71248 .24917 Metetra
1 g
.68233 .21881 .66036 .22395 .67557 .23868 .6975 .23384 Metetra
1 g
.66696 .20399 .64495 .20943 .66036 .22395 .68233 .21881 Metetra
1 g
.65138 .18934 .62932 .19505 .64495 .20943 .66696 .20399 Metetra
1 g
.63558 .17479 .61347 .18078 .62932 .19505 .65138 .18934 Metetra
1 g
.61955 .16032 .59738 .16657 .61347 .18078 .63558 .17479 Metetra
1 g
.60327 .14587 .58106 .15238 .59738 .16657 .61955 .16032 Metetra
1 g
.58675 .13144 .56448 .1382 .58106 .15238 .60327 .14587 Metetra
1 g
.56997 .11697 .54765 .12398 .56448 .1382 .58675 .13144 Metetra
1 g
.55293 .10246 .53055 .10972 .54765 .12398 .56997 .11697 Metetra
1 g
.53561 .08787 .51318 .09538 .53055 .10972 .55293 .10246 Metetra
1 g
.96644 .54507 .94511 .55071 .95668 .55779 .97792 .55222 Metetra
1 g
.95479 .53781 .93338 .54353 .94511 .55071 .96644 .54507 Metetra
1 g
.94298 .53044 .92148 .53625 .93338 .54353 .95479 .53781 Metetra
1 g
.93099 .52296 .9094 .52886 .92148 .53625 .94298 .53044 Metetra
1 g
.91882 .51537 .89714 .52136 .9094 .52886 .93099 .52296 Metetra
1 g
.90647 .50767 .8847 .51375 .89714 .52136 .91882 .51537 Metetra
1 g
.89393 .49985 .87141 .49699 .8847 .51375 .90647 .50767 Metetra
1 g
.87881 .46013 .85646 .4587 .87141 .49699 .89393 .49985 Metetra
1 g
.86416 .42731 .84193 .42698 .85646 .4587 .87881 .46013 Metetra
1 g
.84979 .39919 .82762 .39976 .84193 .42698 .86416 .42731 Metetra
1 g
.83554 .37441 .81343 .37573 .82762 .39976 .84979 .39919 Metetra
1 g
.82135 .35208 .79926 .35404 .81343 .37573 .83554 .37441 Metetra
1 g
.80715 .33157 .78506 .33409 .79926 .35404 .82135 .35208 Metetra
1 g
.79288 .31245 .77079 .31546 .78506 .33409 .80715 .33157 Metetra
1 g
.77853 .29441 .75642 .29786 .77079 .31546 .79288 .31245 Metetra
1 g
.76406 .2772 .74193 .28106 .75642 .29786 .77853 .29441 Metetra
1 g
.74945 .26064 .72728 .26487 .74193 .28106 .76406 .2772 Metetra
1 g
.73468 .24459 .71248 .24917 .72728 .26487 .74945 .26064 Metetra
1 g
.71974 .22894 .6975 .23384 .71248 .24917 .73468 .24459 Metetra
1 g
.70461 .21359 .68233 .21881 .6975 .23384 .71974 .22894 Metetra
1 g
.68929 .19848 .66696 .20399 .68233 .21881 .70461 .21359 Metetra
1 g
.67376 .18354 .65138 .18934 .66696 .20399 .68929 .19848 Metetra
1 g
.65801 .16872 .63558 .17479 .65138 .18934 .67376 .18354 Metetra
1 g
.64203 .15398 .61955 .16032 .63558 .17479 .65801 .16872 Metetra
1 g
.62581 .13927 .60327 .14587 .61955 .16032 .64203 .15398 Metetra
1 g
.60934 .12458 .58675 .13144 .60327 .14587 .62581 .13927 Metetra
1 g
.59262 .10986 .56997 .11697 .58675 .13144 .60934 .12458 Metetra
1 g
.57563 .09509 .55293 .10246 .56997 .11697 .59262 .10986 Metetra
1 g
.55837 .08026 .53561 .08787 .55293 .10246 .57563 .09509 Metetra
1 g
.98801 .53936 .96644 .54507 .97792 .55222 .9994 .5466 Metetra
1 g
.97646 .53201 .95479 .53781 .96644 .54507 .98801 .53936 Metetra
1 g
.96473 .52456 .94298 .53044 .95479 .53781 .97646 .53201 Metetra
1 g
.95283 .51699 .93099 .52296 .94298 .53044 .96473 .52456 Metetra
1 g
.94075 .50932 .91882 .51537 .93099 .52296 .95283 .51699 Metetra
1 g
.9285 .50152 .90647 .50767 .91882 .51537 .94075 .50932 Metetra
1 g
.91605 .49361 .89393 .49985 .90647 .50767 .9285 .50152 Metetra
1 g
.9015 .46159 .87881 .46013 .89393 .49985 .91605 .49361 Metetra
1 g
.88673 .42764 .86416 .42731 .87881 .46013 .9015 .46159 Metetra
1 g
.87227 .39861 .84979 .39919 .86416 .42731 .88673 .42764 Metetra
1 g
.85798 .37307 .83554 .37441 .84979 .39919 .87227 .39861 Metetra
1 g
.84376 .35009 .82135 .35208 .83554 .37441 .85798 .37307 Metetra
1 g
.82955 .32902 .80715 .33157 .82135 .35208 .84376 .35009 Metetra
1 g
.81529 .3094 .79288 .31245 .80715 .33157 .82955 .32902 Metetra
1 g
.80095 .29091 .77853 .29441 .79288 .31245 .81529 .3094 Metetra
1 g
.7865 .27329 .76406 .2772 .77853 .29441 .80095 .29091 Metetra
1 g
.77192 .25635 .74945 .26064 .76406 .2772 .7865 .27329 Metetra
1 g
.75719 .23995 .73468 .24459 .74945 .26064 .77192 .25635 Metetra
1 g
.74229 .22396 .71974 .22894 .73468 .24459 .75719 .23995 Metetra
1 g
.72721 .2083 .70461 .21359 .71974 .22894 .74229 .22396 Metetra
1 g
.71194 .19289 .68929 .19848 .70461 .21359 .72721 .2083 Metetra
1 g
.69645 .17766 .67376 .18354 .68929 .19848 .71194 .19289 Metetra
1 g
.68075 .16256 .65801 .16872 .67376 .18354 .69645 .17766 Metetra
1 g
.66483 .14754 .64203 .15398 .65801 .16872 .68075 .16256 Metetra
1 g
.64867 .13257 .62581 .13927 .64203 .15398 .66483 .14754 Metetra
1 g
.63226 .11762 .60934 .12458 .62581 .13927 .64867 .13257 Metetra
1 g
.6156 .10264 .59262 .10986 .60934 .12458 .63226 .11762 Metetra
1 g
.59867 .08762 .57563 .09509 .59262 .10986 .6156 .10264 Metetra
1 g
.58147 .07253 .55837 .08026 .57563 .09509 .59867 .08762 Metetra
0 g
.25 Mabswid
.58034 0 m
.58486 .29035 L
s
.58486 .29035 m
0 .50662 L
s
0 .50662 m
.02633 .25271 L
s
.02633 .25271 m
.58034 0 L
s
.58034 0 m
.58486 .29035 L
s
.58486 .29035 m
1 .55274 L
s
1 .55274 m
.97591 .3073 L
s
.97591 .3073 m
.58034 0 L
s
.58034 0 m
.97591 .3073 L
s
.97591 .3073 m
.96984 .30929 L
s
gsave
.98806 .30333 -61 -9.47388 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
gsave
.87169 .14335 -61 -9.69632 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
67.750 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02633 .25271 m
0 .50662 L
s
.02573 .25845 m
.03144 .26134 L
s
gsave
.01432 .25269 -75 -10.2101 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
68.250 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.01351 .37631 m
.01933 .37897 L
s
gsave
.00188 .371 -69.75 -10.0096 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.00066 .50025 m
.00658 .50266 L
s
gsave
-0.01118 .49544 -69.75 -9.8008 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{170.688, 118.25},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002Z0000MQ000`40n007h00OZ_oo002Zool00:[o
o`00Z_oo002Zool006;oo`03003ooooo04Goo`00HOoo00<00?oo0000A_oo001Qool00`00ool00016
ool0067oo`03003oo`0004Koo`00HOoo00<00?oo0000A_oo001Rool00`00ooooo`15ool00:[oo`00
H_oo0P00A_oo001Pool200000ooo00000015ool003Coo`8002Soo`8000?oo`04003oo`000013ool0
03Koo`03003ooooo02?oo`8000Goo`05003oooooool00012ool003Koo`03003ooooo027oo`8000Oo
o`03003ooooo00;oo`03003ooooo03ooo`00=Ooo00<00?oo00007ooo0`002Ooo00<00?ooool00ooo
0P00?ooo000eool00`00ool0000Mool2000<ool00`00ooooo`05ool00`00ooooo`0lool003Coo`80
0003ool00?oo01[oo`8000koo`03003ooooo00Koo`03003ooooo03_oo`00DOoo0P004?oo00<00?oo
ool01ooo0P00>ooo001>ool3000Bool00`00ooooo`09ool00`00ooooo`0hool004coo`8001Goo`03
003ooooo00[oo`03003ooooo03Ooo`00B_oo0P005_oo0P003Ooo00<00?ooool0=_oo0018ool2000D
ool400001?oo000000003?oo0P00=_oo0016ool2000Cool30003ool00`00ool00003000=ool00`00
ooooo`0cool004?oo`<0017oo`@000;oo`8000;oo`<000?oo`03003ooooo00_oo`03003ooooo03;o
o`00@Ooo0P004Ooo0`000ooo00<00?ooool010000_oo0P000_oo0P003Ooo0P00<_oo000oool2000@
ool30002ool20002ool30003ool00`00ooooo`040002ool2000=ool00`00ooooo`0_ool003goo`80
00ooo`<000;oo`8000;oo`<000;oo`8000;oo`@000;oo`03003ooooo00<000goo`03003ooooo02ko
o`00>ooo0P003_oo0`000_oo0P000_oo0`000_oo0P000_oo0`000_oo0P000ooo0P000ooo00<00?oo
ool02ooo0P00;_oo000hool3000=ool30002ool00`00ooooo`040002ool00`00ooooo`040002ool0
1P00oooooooo003oo`800003ool00?oo00;oo`03003ooooo00goo`03003ooooo01;oo`04003ooooo
000Eool003Koo`8000koo`8000;oo`03003ooooo00<000?oo`03003ooooo00<000?oo`05003ooooo
ool00002ool20004ool00`00ooooo`02000?ool00`00ooooo`0Bool2000Fool003Coo`8000koo`<0
00?oo`<000;oo`8000;oo`<000;oo`05003oooooool00002ool500001?oo003ooooo10000_oo0P00
3_oo0P004_oo0P005_oo000bool2000=ool30003ool30002ool20002ool30002ool01@00oooooooo
00000_oo0`000ooo00<00?oo00000`000ooo00<00?ooool00`003ooo00<00?ooool03_oo00@00?oo
ool001Goo`00<?oo0P003?oo0`000ooo0`000_oo0P000_oo0`000_oo0P000_oo00<00?ooool00`00
0_oo0P000_oo0`000_oo0P000_oo0`000ooo00<00?ooool03Ooo00<00?ooool09_oo000]ool3000;
ool30003ool30002ool20002ool30002ool00`00ooooo`070002ool00`00ooooo`040002ool00`00
ooooo`040002ool20002ool2000?ool00`00ooooo`0Uool002_oo`8000_oo`<000?oo`<000;oo`80
00;oo`<000;oo`03003ooooo00<000?oo`04003ooooo0002ool30003ool00`00ooooo`030003ool0
0`00ooooo`040002ool00`00ooooo`0=ool2000Uool002Woo`8000Soo`D000?oo`<000;oo`8000;o
o`<000;oo`03003ooooo00<000;oo`8000;oo`H000;oo`8000;oo`@00003ool0000000;oo`<000?o
o`03003ooooo0080013oo`03003ooooo02;oo`009ooo0P001ooo0`000_oo00<00?ooool00`000_oo
0P000_oo0`000_oo00<00?ooool00`000_oo0P000_oo0`000_oo0P0000?oo`0000000_oo0`000_oo
0P000_oo0`000_oo0P000_oo0`000_oo00<00?ooool03_oo00<00?ooool08Ooo000Tool30006ool3
0002ool200001?oo000000000_oo0P000_oo0`000_oo00<00?ooool00`000_oo0P000_oo0`000_oo
00<00?ooool01`000_oo00<00?ooool010000_oo00<00?ooool010000_oo00D00?ooooooo`00013o
o`80027oo`008_oo0P001_oo0`000_oo0P000_oo0P000_oo0P000_oo0`000_oo00<00?ooool00`00
0_oo0P000_oo0`000_oo00<00?ooool00`000ooo00@00?ooool000;oo`<00004ool00?oo0002ool3
0003ool01000ooooo`000_oo0`004Ooo00<00?ooool07_oo000Pool20006ool20002ool20002ool3
0002ool00`00ooooo`030002ool00`00ooooo`030002ool20002ool30002ool00`00ooooo`030002
ool20002ool60002ool300001?oo000000000_oo0P000_oo1P000ooo00<00?ooool03ooo00<00?oo
ool07Ooo000?ool3000<ool20005ool30002ool00`00ooooo`030002ool00`00ooooo`030002ool2
00001?oo000000000_oo0P000_oo0`000_oo00<00?ooool00`000_oo0P000_oo0`000_oo00<00?oo
ool00P000_oo0`000_oo00<00?ooool010000_oo00<00?ooool00P000_oo0P004Ooo0P007Ooo000@
ool00`00ooooo`09ool20004ool30002ool200001?oo000000000_oo0P0000Coo`00000000;oo`80
00;oo`8000;oo`8000;oo`<000;oo`03003ooooo00<000;oo`8000;oo`<000;oo`03003ooooo00L0
0003ool0000000;oo`<000?oo`04003ooooo0002ool40002ool00`00ooooo`0@ool00`00ooooo`0J
ool0013oo`03003ooooo00Koo`<000Coo`8000;oo`8000;oo`8000?oo`D000?oo`H000;oo`H000;o
o`03003ooooo00<000;oo`8000;oo`<000;oo`03003ooooo00<000;oo`8000;oo`03003oo`0000<0
00;oo`8000;oo`H000?oo`03003ooooo008001;oo`03003ooooo01Woo`004?oo00<00?ooool01?oo
0P001?oo0`000_oo1P000_oo0`000_oo0P0000Coo`00000000;oo`800004ool000000002ool20002
ool50002ool20002ool30002ool00`00ooooo`030002ool20002ool60002ool00`00ooooo`040002
ool00`00ooooo`020002ool30002ool00`00ooooo`0@ool00`00ooooo`0Hool000Soo`<000Coo`80
00Coo`800003ool0000000<000?oo`8000;oo`8000;oo`8000;oo`8000;oo`8000;oo`8000;oo`80
00;oo`8000;oo`<000;oo`03003ooooo00H000;oo`03003ooooo00<000;oo`8000;oo`<000;oo`04
003ooooo0002ool30003ool01000ooooo`000_oo10000_oo00D00?ooooooo`0001;oo`8001Soo`00
0ooo0`000ooo00<00?ooool01?oo00<00?ooool00P0000?oo`0000000_oo0P0000Coo`00000000;o
o`03003ooooo00<000;oo`03003ooooo00<000;oo`03003ooooo00<000;oo`03003ooooo00<000;o
o`03003ooooo00<000;oo`03003ooooo00H000;oo`8000;oo`<000;oo`03003ooooo00H000;oo`80
00;oo`H000?oo`04003ooooo0002ool3000Cool00`00ooooo`0Eool000Woo`03003ooooo00Goo`D0
00;oo`03003ooooo008000;oo`800004ool000000003ool50003ool50002ool00`00ooooo`030002
ool00`00ooooo`030002ool200001?oo000000000_oo0P000_oo1P000_oo00<00?ooool00`000_oo
0P0000?oo`0000000_oo0`000_oo00<00?ooool00P000_oo1P000ooo00<00?ooool04Ooo00<00?oo
ool05?oo0009ool00`00ooooo`03ool40003ool50002ool60002ool30002ool00`00ooooo`030002
ool00`00ooooo`050003ool50002ool20002ool20002ool20002ool30002ool01000ooooo`000_oo
0`000_oo00<00?ooool00P0000?oo`0000000P000_oo00@00?ooool000;oo`@000;oo`04003ooooo
0002ool3000Cool2000Dool000Soo`8000Goo`8000;oo`<000;oo`03003ooooo008000;oo`8000;o
o`8000;oo`800004ool000000002ool00`00ooooo`030002ool00`00ooooo`030002ool00`00oooo
o`060002ool00`00ooooo`030002ool00`00ooooo`060002ool00`00ooooo`060003ool00`00oooo
o`060003ool01000ooooo`000_oo0`000ooo00<00?ooool04_oo00<00?ooool04Ooo0009ool00`00
ooooo`03ool00`00ool0000200001?oo00000?oo0`000_oo0P0000Coo`00000000;oo`03003ooooo
008000;oo`800004ool000000002ool200001?oo000000000_oo00<00?ooool00`000_oo00<00?oo
ool01P000_oo00<00?ooool00`000_oo00@00?ooool000;oo`<000;oo`D000;oo`<000;oo`03003o
oooo008000;oo`H000;oo`05003oooooool0000Eool00`00ooooo`0@ool000ooo`03003ooooo00;o
o`D000;oo`D000?oo`D000;oo`D000?oo`D000?oo`D000;oo`800004ool000000002ool200000ooo
000000040002ool00`00ooooo`060002ool20002ool60002ool01000ooooo`000_oo10000_oo00@0
0?ooool000?oo`03003ooooo008001Goo`80013oo`003ooo00<00?ooool01?oo00<00?ooool00P00
0_oo0P0000Coo`00000000;oo`03003ooooo008000;oo`800004ool000000002ool00`00ooooo`03
0002ool00`00ooooo`050002ool20002ool20002ool20002ool50002ool20002ool600000ooo0000
0002ool00`00ooooo`060003ool01000ooooo`000_oo1`000_oo00<00?ooool05?oo00<00?ooool0
3Ooo000>ool00`00ooooo`06ool20002ool50003ool50002ool50003ool50002ool200001?oo0000
00000_oo00<00?ooool01P000_oo00<00?ooool00`000_oo00@00?oo000000;oo`<000;oo`03003o
oooo00T000;oo`03003ooooo008000;oo`H000;oo`05003oooooool00002ool00`00ooooo`0Eool0
0`00ooooo`05ool30004ool000koo`03003ooooo00Soo`<00004ool00000ool30002ool00`00oooo
o`020002ool200001?oo000000000_oo00<00?ooool01@000_oo0P0000Coo`00000000;oo`03003o
oooo00H000;oo`03003ooooo00H000;oo`03003ooooo00T000;oo`03003ooooo00L000;oo`04003o
oooo0002ool00`00ooooo`06000Gool20006ool00`00ooooo`03ool000koo`03003ooooo00_oo`@0
00?oo`D000;oo`D000;oo`800004ool000000002ool00`00ooooo`050002ool200001?oo00000000
0_oo00<00?ooool01P000_oo00@00?ooool000;oo`@00005ool00?ooool00002ool60002ool01@00
oooooooo00000_oo00<00?ooool01P000ooo00@00?ooool001Soo`03003ooooo00?oo`03003ooooo
00?oo`003_oo00<00?ooool03Ooo00<00?oo00000P000_oo00<00?ooool00P000_oo0P0000?oo`00
00000`000ooo1@000_oo00<00?ooool01@000_oo0P0000Coo`00000000;oo`800004ool00?ooool9
0002ool600000ooo00000002ool01@00oooooooo00000_oo1P000_oo00<00?ooool00P000_oo00<0
0?ooool00P005ooo0P001?oo00<00?ooool00ooo000>ool00`00ooooo`0>ool20002ool50002ool5
0002ool200001?oo000000000_oo00<00?ooool01@000_oo00<00?ooool01@000_oo0P000_oo1@00
0_oo2@000_oo00@00?ooool000;oo`800003ool0000000D000;oo`04003ooooo0002ool00`00oooo
o`070002ool00`00ooooo`0Aool300000ooo003oo`02ool20005ool000koo`03003ooooo013oo`80
00;oo`03003ooooo008000;oo`800003ool0000000<000?oo`D000;oo`03003ooooo00D000;oo`03
003ooooo00H000;oo`03003ooooo00D000;oo`800005ool00?ooool00002ool700000ooo00000002
ool01000ooooo`000_oo1P000ooo00@00?ooool000?oo`03003ooooo00goo`<000Coo`03003ooooo
00;oo`03003ooooo00?oo`003_oo00<00?ooool04_oo1@000_oo1@000_oo0P0000Coo`00000000;o
o`03003oo`0000D000;oo`03003ooooo00D000;oo`03003ooooo00H000;oo`04003oo`000002ool8
0002ool200000ooo0000000;0002ool00`00ooooo`020002ool01000ooooo`000_oo0`002ooo0`00
1ooo00<00?ooool02?oo000>ool00`00ooooo`0Dool50002ool200000ooo000000030002ool50002
ool200000ooo000000040002ool00`00ooooo`080002ool00`00ooooo`060002ool01@00ool00000
ool00P000_oo1`0000Goo`00ooooo`0000;oo`04003ooooo0002ool:0002ool00`00ooooo`05ool4
000:ool00`00ooooo`08ool000koo`03003ooooo01Koo`800003ool0000000<000;oo`D000;oo`80
0003ool0000000<000;oo`800003ool0000000@000;oo`@00003ool0000000@000;oo`04003ooooo
0002ool90002ool01@00ooooo`00ool00P000_oo00<00?ooool01P000ooo00@00?ooool000;oo`05
003oooooool00003ool3000>ool00`00ooooo`08ool000koo`03003ooooo01Soo`04003oooooool4
0002ool200000ooo000000030002ool200000ooo000000030002ool200000ooo000000060002ool0
1000ooooo`000_oo1P000_oo00@00?ooool000;oo`04003ooooo0002ool90002ool01000ooooo`00
0ooo00@00?ooool000;oo`04003oooooool4000Aool00`00ooooo`08ool000Ooo`03003ooooo00?o
o`03003ooooo01[oo`<000;oo`03003oo`0000@000;oo`800003ool0000000<000;oo`03003ooooo
00H00005ool00?ooool00002ool80002ool01000ooooo`000_oo00<00?ooool02@000_oo00<00?oo
ool00P0000Goo`00ooooo`0000;oo`03003ooooo00d001Coo`03003ooooo00Ooo`001_oo00<00?oo
00001?oo00<00?ooool07Ooo10000ooo1`000_oo2`000_oo20000_oo00H00?oo00000?oo0002ool9
0002ool01000ooooo`000_oo00@00?ooool000;oo`03003oo`0000T000;oo`05003oooooool00002
ool01@00oooooooo00004ooo00<00?ooool01ooo0006ool00`00ool00004ool00`00ooooo`0Oool5
0002ool00`00ool000040002ool200000ooo000000060002ool01P00ool00000ool000;oo`P000;o
o`04003ooooo0002ool01000ooooo`000_oo3`000_oo00@00?ooool000?oo`04003ooooo0002ool0
1@00oooooooo00004ooo00<00?ooool01ooo0006ool00`00ool00004ool00`00ooooo`0Qool70002
ool200000ooo000000060002ool00`00ool0000:0002ool01@00ooooo`00ool00P0000?oo`000000
2P000_oo00@00?ooool000;oo`04003ooooo0002ool01000ooooo`000ooo00@00?ooool000;oo`T0
01;oo`03003ooooo00Ooo`001_oo00<00?oo00001?oo0P009?oo0P0000?oo`00000020000_oo1`00
0_oo0P0000Koo`00ooooo`00ool;0002ool01000ooooo`000_oo00@00?ooool000;oo`04003ooooo
0002ool00`00ooooo`0@00000ooo003oo`02ool01000ooooo`004_oo00<00?ooool01ooo0007ool0
0`00ooooo`03ool00`00ooooo`0Uool00`00ooooo`0:0002ool00`00ool0000<0002ool200001Ooo
003ooooo00000_oo00<00?oo00000_oo4P000_oo00<00?ooool010000ooo00@00?ooool000;oo`04
003ooooo0003ool00`00ooooo`0?ool00`00ooooo`07ool000goo`03003ooooo02Koo`D000;oo`T0
00;oo`800007ool00?ooool00?oo00000_oo40000_oo00@00?ooool000;oo`04003ooooo0002ool0
1000ooooo`000_oo00@00?ooool000;oo`05003oooooool00002ool01000ooooo`000ooo00@00?oo
ool0017oo`03003ooooo00Ooo`003Ooo00<00?ooool09Ooo20000_oo00<00?oo00004@000_oo00H0
0?ooool00?oo0002ool01@00ooooo`00ool00P0000Goo`00ooooo`0000;oo`04003ooooo0002ool0
0`00ooooo`0L000@ool00`00ooooo`07ool000goo`03003ooooo02?oo`8000Goo`L000;oo`06003o
oooo003oo`000_oo00<00?oo00000_oo900000Goo`00ooooo`0000;oo`04003oooooool200001Ooo
003ooooo00000_oo00D00?ooooooo`0000;oo`03003ooooo00koo`03003ooooo00Ooo`003?oo00<0
0?ooool08Ooo0`002Ooo50000_oo00<00?oo00000_oo00H00?ooool00?oo0002ool01000ooooo`00
0_oo00<00?oo00000_oo00@00?ooool000;oo`04003ooooo0002ool01000ooooo`000_oo00D00?oo
ool00?oo00<000;oo`04003ooooo0003ool01000ooooo`003ooo00<00?ooool01ooo000<ool00`00
ooooo`0Nool3000>oolU0002ool00`00ool00002ool01000ooooo`000_oo00@00?ooool000;oo`04
003ooooo0002ool01@00oooooooo00000_oo00@00?ooool000;oo`05003oooooool00002ool00`00
ooooo`0=ool00`00ooooo`07ool000coo`03003ooooo01coo`8001?oo`T00004ool00?oo0002ool0
0`00ool00002ool01P00ool00000ool000;oo`03003oo`0000;ooc4000koo`03003ooooo00Ooo`00
3?oo00<00?ooool06Ooo0`006?oo5`000_oo00<00?oo00000_oo00@00?ooool000;oo`03003oo`00
00;oo`04003ooooo0002ool01P00ooooo`00ool000;oo`05003oooooool00002ool01@00ooooo`00
ool00P000ooo00@00?ooool000;oo`03003ooooo00goo`03003ooooo00Koo`003?oo00<00?ooool0
5_oo0`007Ooo2P000_oo00<00?oo00000_oo00<00?ooool03`000_oo00<00?oo00000_oo00@00?oo
ool000;oo`04003ooooo0002ool01000ooooo`000ooo00D00?ooool00?oo008000;oo`05003ooooo
ool00002ool00`00ooooo`0<ool00`00ooooo`06ool000coo`03003ooooo01?oo`<002;oo`H00003
ool0000000L000;oo`03003oo`0000;oo`03003oo`0000;oo`04003oo`00oolB0002ool01@00oooo
oooo00000_oo00@00?ooool000;oo`8000;oo`04003ooooo0002ool00`00ooooo`0<ool00`00oooo
o`06ool000coo`03003ooooo017oo`8002Ooo`P000;oo`03003oo`0000T000;oo`03003oo`0000;o
o`04003ooooo0002ool01@00ool00?oo00000_oo00D00?ooool00?oo01000003ool00000008000?o
o`04003ooooo000=ool00`00ooooo`06ool000coo`03003ooooo00koo`<002_oo`/000;oo`05003o
oooo003oo`0:0002ool01P00ooooo`00ool000;oo`04003ooooo0002ool01000ooooo`000_oo00@0
0?ooool000;oo`05003ooooo003oo`0<000=ool00`00ooooo`06ool000coo`03003ooooo00_oo`<0
033oo`800004ool000000002ool700001Ooo003ooooo00000_oo0P0000?oo`000000200000Goo`00
ooooo`0000;oo`04003ooooo0002ool01@00oooooooo00000_oo00H00?ooool00?oo0003ool20000
0ooo003oo`02ool00`00ooooo`0:ool00`00ooooo`06ool000coo`03003ooooo00Woo`8003Coo`<0
0003ool0000000800004ool00?ooool70002ool01@00ool00?oo00000_oo00D00?ooool00?oo00P0
0005ool00?ooool00002ool01000ooooo`000_oo00@00?ooool000;oo`04003oooooool40002ool0
0`00ooooo`0:ool00`00ooooo`06ool000Coo`<000Coo`03003ooooo00Ooo`<003Ooo`05003oo`00
003oo`040002ool00`00ooooo`0200000ooo000000040002ool01000ooooo`000_oo00<00?oo0000
0_oo00@00?oo003oo`P000?oo`06003ooooo003oo`000_oo00D00?ooooooo`0000;oo`05003ooooo
ool0000;ool00`00ooooo`06ool000Goo`03003ooooo00?oo`03003ooooo00Coo`<003[oo`800004
ool000000002ool700001?oo003oo`000_oo1@000_oo00@00?ooool000;oo`03003oo`0000;oo`04
003ooooo0002ool00`00ool0000800001Ooo003ooooo00000_oo00<00?ooool00`0000?oo`00ool0
2_oo00<00?ooool01_oo0005ool00`00ooooo`03ool00`00ooooo`02ool2000mool400000ooo0000
000200001Ooo003oo`00ool00`000_oo00<00?ooool00P0000?oo`000000100000Coo`00ool000;o
o`03003oo`0000;oo`07003oooooool00?oo00000_oo00D00?ooool00?oo00H000;oo`05003ooooo
003oo`03000:ool00`00ooooo`06ool000Goo`03003ooooo00?oo`03003oo`00008003ooo`04003o
o`00ool300001?oo000000000_oo00<00?oo000010000_oo00D00?oo003oo`0000;oo`03003oo`00
00H000;oo`04003ooooo0002ool01000ooooo`000_oo00H00?ooool00?oo0003ool800001?oo0000
00002Ooo00<00?ooool01_oo0004ool20005ool20012ool00`00ool0000500001_oo00000000ool0
00;oo`800005ool00000003oo`020002ool01P00ooooo`00ool000;oo`03003oo`0000<000;oo`04
003ooooo0002ool01000ooooo`000_oo00@00?ooool000;oo`05003oooooool00002ool300000ooo
00000008ool00`00ooooo`06ool000Goo`03003ooooo00Goo`80043oo`03003ooooo00800003ool0
000000;oo`D00007ool00?oo003oo`00ool00P0000Coo`00ool000;oo`04003ooooo0002ool01000
ool00?oo1P0000Coo`00ool000;oo`04003ooooo0002ool01@00oooooooo00000_oo0`000_oo1@00
2?oo00<00?ooool01Ooo000?ool3000mool00`00ooooo`0300002?oo00000?oo003oo`00ool20000
0ooo00000002ool00`00ool0000300001?oo003oo`000_oo00@00?ooool000;oo`03003oo`0000;o
o`03003oo`0000800007ool00?ooool00?oo00000ooo00<00?oo00000`0000?oo`0000000P000_oo
00<00?ooool00P001_oo00<00?ooool01Ooo000Bool2000kool00`00ooooo`0300000ooo00000004
00000ooo003oo`0200001?oo003oo`000_oo0P0000Soo`0000000?oo003oo`000_oo00@00?ooool0
00;oo`07003ooooo003oo`00ool01P0000?oo`00ool00`000_oo0`000_oo1`000_oo0P001?oo00<0
0?ooool01Ooo000Dool3000iool00`00ool0000200000ooo00000002ool20002ool00`00ool00002
00002_oo003ooooo003oo`00ool00?oo0`0000Ooo`00ooooo`00ool00002ool01000ooooo`000_oo
00<00?oo00000ooo10000_oo0`000_oo0`000_oo00<00?ooool0100000Coo`00000000;oo`03003o
oooo00Goo`005ooo0P00=ooo00<00?oo0000100000?oo`00ool00`0000Coo`00ooooo`D00004ool0
0?oo0002ool01000ool00?oo1P0000Coo`00ool000;oo`04003ooooo0002ool01000ooooo`000_oo
0`000_oo0`000_oo1P000_oo0`000_oo0P0000?oo`00ool01_oo000Iool3000dool00`00ool00002
00002_oo00000000ool00?oo003oo`000_oo0P000_oo0P0000?oo`0000000_oo00H00?ooool00?oo
0002ool00`00ool0000200001?oo003oo`000_oo00@00?ooool000;oo`<000;oo`<000;oo`<000;o
o`03003ooooo00<000;oo`<00004ool000000007ool001coo`8003;oo`03003oo`00008000;oo`80
00;oo`D00007ool00?oo003oo`00ool00P0000Coo`00ool000;oo`03003oo`0000?oo`04003oo`00
ool300001_oo003ooooo003oo`<000;oo`<000;oo`<000;oo`H000;oo`<000;oo`D000Ooo`007_oo
0`00;ooo00@00?oo003oo`800003ool0000000;oo`8000;oo`07003oo`00ool00?oo00000_oo0`00
00Goo`00ooooo`0000;oo`04003ooooo0002ool00`00ooooo`070002ool30002ool30002ool30002
ool60002ool60009ool0027oo`8002goo`04003oo`00ool200002Ooo00000000ool00?oo003oo`05
0002ool01000ool00?oo100000Goo`00ooooo`0000;oo`04003ooooo0002ool00`00ooooo`060002
ool30002ool300000ooo0000000200001?oo003ooooo1P003Ooo000Sool3000Zool01000ool00?oo
0P0000[oo`00ool00?oo003oo`00ool000;oo`8000;oo`07003ooooo003oo`00ool00P0000Coo`00
ool000;oo`06003oooooool00?oo0`000_oo1P000_oo0`0000Coo`00000000;oo`P0017oo`009_oo
0P00:?oo00@00?oo003oo`800003ool00?oo00800005ool00000ool00002ool300002_oo003ooooo
003oo`00ool00?oo0P0000?oo`00ool00_oo00<00?oo00000P000_oo0`000_oo1P0000Coo`000000
00;oo`L001Goo`00:?oo0`009Ooo00@00?oo003oo`8000;oo`800004ool000000002ool01`00ool0
0?oo003oo`0000;oo`03003oo`0000;oo`03003ooooo00<00004ool000000002ool30002ool30000
0ooo000000040002ool6000Iool002_oo`8002?oo`04003oo`00ool20002ool20002ool20002ool0
0`00ooooo`0500001ooo003ooooo003oo`0000;oo`04003oo`000002ool30002ool300001?oo0000
00000_oo20007Ooo000]ool3000Pool00`00ool00002ool200001Ooo003oo`00ool00P000_oo00X0
0?ooool00?oo003oo`00ool000;oo`05003ooooo003oo`060002ool30002ool20002ool300001?oo
000000008Ooo000`ool2000Nool01@00ooooo`00ool00P0000Goo`00ool00?oo00<00008ool00?oo
ool00?oo003oo`800004ool00?ooool40002ool60002ool300000ooo00000005000Tool003;oo`<0
01_oo`05003ooooo003oo`0200001?oo003oo`000_oo0P0000Ooo`00ooooo`00ool00002ool30000
0ooo00000002ool30002ool60002ool5000Xool003Goo`8001Woo`05003ooooo003oo`0200001?oo
003oo`000_oo0P0000Ooo`00ooooo`00ool00002ool01000ool000000_oo0P000_oo0`000_oo1`00
;?oo000gool3000Fool01@00ooooo`00ool0100000Coo`00ooooo`<00008ool00?ooool00?oo003o
o`X000;oo`H0033oo`00>_oo0P005?oo00L00?ooool00?oo003oo`0200001_oo003ooooo003oo`<0
00;oo`@000;oo`<000;oo`L003Coo`00??oo0`004_oo01000?oo003oo`00ool00?oo003oo`00ool0
0?oo003oo`@000;oo`<000;oo`H003Soo`00?ooo0P004?oo00H00?oo003oo`00ool300002?oo003o
oooo003oo`00ool<000lool0047oo`<000goo`03003oo`0000;oo`@00004ool00?ooool40002ool7
000oool004Coo`8000_oo`03003oo`0000;oo`800003ool0000000@000;oo`H004?oo`00A_oo0`00
2?oo00<00?oo00000_oo00@00?oo000000;oo`L004Ooo`00BOoo0P001_oo00<00?oo00000_oo00@0
0?oo003oo`D004_oo`00Booo0`000ooo00@00?oo003oo`H004ooo`00C_oo0P0000?oo`0000001000
Dooo001@ool3001Gool00:[oo`00\
\>"],
  ImageRangeCache->{{{0, 169.688}, {117.25, 0}} -> {-0.0767156, 0.0326984, \
0.00647943, 0.00647943}}]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
ScreenStyleEnvironment->"Working",
WindowSize->{1012, 740},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"PrintingMargins"->{{84.875, 54}, {72, 72}},
"PaperSize"->{597.562, 842.375},
"PaperOrientation"->"Portrait",
"PrintCellBrackets"->False,
"PrintRegistrationMarks"->True,
"PrintMultipleHorizontalPages"->False,
"PostScriptOutputFile":>FrontEnd`FileName[{$RootDirectory, "home", "felix", \
"tmp"}, "qqq.ps", CharacterEncoding -> "iso8859-1"],
"Magnification"->1}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 71, 1, 27, "Input"],
Cell[1828, 54, 56, 1, 27, "Input"],
Cell[1887, 57, 106, 2, 27, "Input"],

Cell[CellGroupData[{
Cell[2018, 63, 219, 9, 38, "Subsection"],
Cell[2240, 74, 185, 3, 46, "Input"],

Cell[CellGroupData[{
Cell[2450, 81, 325, 5, 43, "Input"],
Cell[2778, 88, 90675, 2586, 127, 72318, 2356, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

