(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     14375,        496]*)
(*NotebookOutlinePosition[     15003,        518]*)
(*  CellTagsIndexPosition[     14959,        514]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    \($TextStyle = {FontSize \[Rule] 8}; \)], "Input"],

Cell[BoxData[
    \(<< Miscellaneous`Units`\)], "Input"],

Cell[BoxData[
    \(imgSize = 
      Convert[60  Milli\ Meter, PrintersPoint]/PrintersPoint; \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Plot[1/12, {x, 0, 1/3}, PlotRange \[Rule] {{0, 0.5}, {0, 0.5}}, 
        ImageSize \[Rule] imgSize, 
        Ticks \[Rule] {{{0.00001, "\<0\>"}, {1/3, "\<1/3\>"}}, {1/12}}, 
        AxesLabel \[Rule] {"\<s\>", "\<v'\>"}];\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
%%ImageSize: 170.717 105.509 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 2 0 1.23607 [
[2e-05 -0.0125 -4.375 -8.25 ]
[2e-05 -0.0125 4.375 0 ]
[.66667 -0.0125 -9.125 -8.25 ]
[.66667 -0.0125 9.125 0 ]
[1.025 0 0 -4.125 ]
[1.025 0 8.75 4.125 ]
[-0.0125 .10301 -18.375 -8.34375 ]
[-0.0125 .10301 0 8.34375 ]
[0 .64303 -6.75 0 ]
[0 .64303 6.75 8.25 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
2e-05 0 m
2e-05 .00625 L
s
gsave
2e-05 -0.0125 -65.375 -12.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
67.750 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.66667 0 m
.66667 .00625 L
s
gsave
.66667 -0.0125 -70.125 -12.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
67.750 10.000 moveto
(\\220) show
72.500 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
77.250 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
s
gsave
1.025 0 -61 -8.125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
67.750 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .10301 m
.00625 .10301 L
s
gsave
-0.0125 .10301 -79.375 -12.3438 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 24.6875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def
67.812 9.938 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
64.438 14.750 moveto
(\\200) show
66.000 14.750 moveto
(\\200) show
67.562 14.750 moveto
(\\200) show
69.125 14.750 moveto
(\\200) show
70.688 14.750 moveto
(\\200) show
72.250 14.750 moveto
(\\200) show
73.812 14.750 moveto
(\\200) show
74.500 14.750 moveto
(\\200) show
65.438 19.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
1.000 setlinewidth
grestore
0 0 m
0 .61803 L
s
gsave
0 .64303 -67.75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(v) show
67.750 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(') show
72.500 10.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
0 .10301 m
.02704 .10301 L
.05654 .10301 L
.08424 .10301 L
.11088 .10301 L
.13924 .10301 L
.16653 .10301 L
.19554 .10301 L
.22349 .10301 L
.25038 .10301 L
.27899 .10301 L
.30653 .10301 L
.33302 .10301 L
.36122 .10301 L
.38836 .10301 L
.41722 .10301 L
.44501 .10301 L
.47175 .10301 L
.5002 .10301 L
.52759 .10301 L
.5567 .10301 L
.58475 .10301 L
.61173 .10301 L
.64043 .10301 L
.66667 .10301 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{170.688, 105.5},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002Z0000JA000`40n007h00OZ_oo002Zool006go
o`03003ooooo03[oo`005Ooo00<00?ooool0DOoo0`0000?oo`00ool01?oo00<00?ooool0=?oo000D
ool00`00ool0001Cool01@00oooooooo00000ooo00<00?oo0000=Ooo000Dool00`00ool0001Cool0
1@00oooooooo00001Ooo00<00?ooool0<ooo000Dool00`00ool0001Cool01@00oooooooo00001?oo
0P00=Ooo000Dool00`00ool0001Bool20004ool01P00ooooo`00ool003Goo`005Ooo00<00?ooool0
D_oo00<00?ooool01_oo00<00?ooool0=?oo002Rool20006ool001GoohL000Soo`03003ooooo00?o
o`005Ooo00<00?ooool0Eooo00<00?ooool0<?oo0P001_oo000Eool00`00ooooo`2;ool20005ool0
01Goo`03003ooooo09;oo`005Ooo00<00?ooool0T_oo000Eool00`00ooooo`2Bool001Goo`03003o
oooo09;oo`001ooo0`000_oo0`001_oo00<00?ooool0T_oo0008ool01@00oooooooo00002?oo00<0
0?ooool0T_oo0008ool00`00ooooo`02ool00`00ooooo`05ool00`00ooooo`2Bool000Soo`03003o
oooo00?oo`03003ooooo00Coo`03003ooooo09;oo`001ooo0P000ooo00<00?oo00001_oo00<00?oo
ool0T_oo0008ool00`00ooooo`02ool00`00ooooo`05ool00`00ooooo`2Bool000Goo``000Coo`03
003ooooo09;oo`005OooF`00>_oo000Eool00`00ooooo`2Bool001Goo`03003ooooo09;oo`002Ooo
0`002Ooo00<00?ooool0T_oo000:ool00`00ooooo`08ool00`00ooooo`2Bool000[oo`03003ooooo
00Soo`03003ooooo09;oo`002_oo00<00?ooool02?oo00<00?ooool0T_oo0009ool2000:ool00`00
ooooo`2Bool000[oo`03003ooooo00Soo`03003ooooo09;oo`005Ooo00<00?ooool0T_oo000Eool0
0`00ooooo`2Bool001Goo`03003ooooo09;oo`005Ooo00<00?ooool0T_oo000Eool00`00ooooo`2B
ool001Goo`03003ooooo09;oo`005Ooo00<00?ooool0T_oo000Eool00`00ooooo`2Bool001Goo`03
003ooooo09;oo`005Ooo00<00?ooool0T_oo000Eool00`00ooooo`2Bool001Goo`03003ooooo09;o
o`005Ooo00<00?ooool0T_oo000Eool00`00ooooo`2Bool001Goo`03003ooooo09;oo`005Ooo00<0
0?ooool0T_oo000Eool00`00ooooo`2Bool001Goo`03003ooooo09;oo`005Ooo00<00?ooool0T_oo
000Eool00`00ooooo`2Bool001Goo`03003ooooo09;oo`005Ooo00<00?ooool0T_oo000Eool00`00
ooooo`2Bool001Goo`03003ooooo09;oo`005Ooo00<00?ooool0T_oo000Eool00`00ooooo`2Bool0
01Goo`03003ooooo09;oo`005Ooo00<00?ooool0T_oo000Eool00`00ooooo`2Bool001Goo`03003o
oooo09;oo`005Ooo00<00?ooool0T_oo000Eool00`00ooooo`2Bool001Goo`03003ooooo09;oo`00
5Ooo00<00?ooool0T_oo000Eool00`00ooooo`2Bool001Goo`03003ooooo09;oo`005Ooo00<00?oo
ool0T_oo000Eool00`00ooooo`2Bool001Goo`03003ooooo09;oo`005Ooo00<00?ooool0T_oo000E
ool00`00ooooo`2Bool001Goo`03003ooooo09;oo`005Ooo00<00?ooool0T_oo000Eool00`00oooo
o`2Bool001Goo`03003ooooo09;oo`005Ooo00<00?ooool0T_oo000Eool00`00ooooo`2Bool001Go
o`03003ooooo09;oo`005Ooo00<00?ooool0T_oo000Eool00`00ooooo`2Bool001Goo`03003ooooo
09;oo`005Ooo00<00?ooool0T_oo000Eool00`00ooooo`2Bool001Goo`03003ooooo09;oo`005Ooo
00<00?ooool0T_oo000Eool00`00ooooo`2Bool001Goo`03003ooooo09;oo`005Ooo00<00?ooool0
T_oo000Eool00`00ooooo`2Bool001Goo`03003ooooo09;oo`005Ooo00<00?ooool0T_oo002Zool0
0:[oo`00Z_oo002Zool00:[oo`004ooo00<00?ooool0U?oo000Bool00`00ool0002Eool001;oo`03
003oo`0009Goo`004Ooo0P0000?oo`00ool0U?oo000Gool00`00ooooo`2@ool001Ooo`03003ooooo
093oo`00\
\>"],
  ImageRangeCache->{{{0, 169.688}, {104.5, 0}} -> {-0.0808122, -0.0598347, \
0.00372464, 0.00602658}}]
}, Open  ]]
},
FrontEndVersion->"5.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
WindowSize->{1012, 740},
WindowMargins->{{0, Automatic}, {Automatic, 0}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 68, 1, 27, "Input"],
Cell[1825, 54, 56, 1, 27, "Input"],
Cell[1884, 57, 106, 2, 27, "Input"],

Cell[CellGroupData[{
Cell[2015, 63, 258, 4, 43, "Input"],
Cell[2276, 69, 12083, 424, 114, 9056, 383, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

