(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     95960,       2139]*)
(*NotebookOutlinePosition[     96624,       2163]*)
(*  CellTagsIndexPosition[     96580,       2159]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    \(\($TextStyle = {FontSize \[Rule] 8};\)\)], "Input"],

Cell[BoxData[
    \(<< Miscellaneous`Units`\)], "Input"],

Cell[BoxData[
    \(\(imgSize = 
        Convert[60  Milli\ Meter, PrintersPoint]/PrintersPoint;\)\)], "Input"],

Cell[BoxData[
    \(\(vptotal[p0_, p1_, \[Beta]20_] := \[IndentingNewLine]If[
          p0 \[Equal] p1 \[Or] p0 \[Equal] 0 \[Or] p0 \[Equal] 1 \[Or] 
            p1 \[Equal] 0 \[Or] 
            p1 \[Equal] 
              1, \(-1\), \[IndentingNewLine]\(-\((\((1 - p\_0)\)\ \((1 - 
                          p\_1)\)\ \((\((\(-1\) + p\_0)\)\^3\ \((\(-1\) + \
\[Beta]2\_0)\)\ \[Beta]2\_0 - \((\(-1\) + p\_1)\)\^3\ \((\(-1\) + \
\[Beta]2\_0)\)\ \[Beta]2\_0 + \((\(-1\) + p\_0)\)\^2\ \((1 - 
                                p\_1)\)\ \((\(-2\) + Log[1 - p\_0] - 
                                Log[1 - p\_1] + 
                                3\ \((\(-3\) + 2\ Log[1 - p\_0] - 
                                      2\ Log[
                                        1 - p\_1])\)\ \((\(-1\) + \
\[Beta]2\_0)\)\ \[Beta]2\_0)\) + \((1 - 
                                p\_0)\)\ \((\(-1\) + p\_1)\)\^2\ \((2 + 
                                Log[1 - p\_0] - Log[1 - p\_1] + 
                                3\ \((3 + 2\ Log[1 - p\_0] - 
                                      2\ Log[
                                        1 - p\_1])\)\ \((\(-1\) + \
\[Beta]2\_0)\)\ \[Beta]2\_0)\))\))\)\)/\((\((\(-p\_0\) + p\_1)\)\^3\ \
\((\(-2\) + p\_0 + 
                        p\_1)\))\) + \((p\_0\ p\_1\ \((\(-p\_0\%3\)\ \
\((\(-1\) + \[Beta]2\_0)\)\ \[Beta]2\_0 + 
                        p\_1\%3\ \((\(-1\) + \[Beta]2\_0)\)\ \[Beta]2\_0 + 
                        p\_0\%2\ p\_1\ \((\(-2\) + Log[p\_0] - Log[p\_1] + 
                              3\ \((\(-3\) + 2\ Log[p\_0] - 
                                    2\ Log[
                                        p\_1])\)\ \((\(-1\) + \[Beta]2\_0)\)\ \
\[Beta]2\_0)\) + p\_0\ p\_1\%2\ \((2 + Log[p\_0] - Log[p\_1] + 
                              3\ \((3 + 2\ Log[p\_0] - 
                                    2\ Log[
                                        p\_1])\)\ \((\(-1\) + \[Beta]2\_0)\)\ \
\[Beta]2\_0)\))\))\)/\((\((p\_0 - p\_1)\)\^3\ \((p\_0 + 
                        p\_1)\))\) /. {\[Beta]2\_0 \[Rule] \[Beta]20, 
              p\_0 \[Rule] p0, p\_1 \[Rule] p1}];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(sptotal[p0_, p1_, \[Beta]20_] := 
        If[p0 \[Equal] p1 \[Or] p0 \[Equal] 0 \[Or] p0 \[Equal] 1 \[Or] 
            p1 \[Equal] 0 \[Or] p1 \[Equal] 1, \(-1\), 
          1\/12\ \((\((\(-1\) + p\_1)\)\ \((\(-3\) + 
                          2\ \[Beta]2\_0)\) - \((\(-1\) + p\_0)\)\ \((1 + 
                          2\ \[Beta]2\_0)\) + 
                    4\ \((\(-2\) + 
                          p\_1\ \((\(-2\) + \[Beta]2\_0)\)\ \((\(-1\) + \
\[Beta]2\_0)\) + \[Beta]2\_0\ \((2\ \((\(-1\) + \@\(\((\(-1\) + p\_0)\)\ \
\((\(-1\) + p\_1)\)\))\)\ \((\(-1\) + \[Beta]2\_0)\) + 
                                p\_0\ \((1 + \[Beta]2\_0)\))\))\) + \
\(1\/\((\(-p\_0\) + p\_1)\)\^3\) \((6\ \((\(-\((\(-1\) + p\_1)\)\^4\)\ \
\((\(-1\) + \[Beta]2\_0)\)\^2 + \((\(-1\) + p\_0)\)\^4\ \[Beta]2\_0\%2 + 
                              4\ \((\(-1\) + 
                                    p\_0)\)\ \((\(-1\) + p\_1)\)\^3\ \
\((\(-1\) + \[Beta]2\_0)\)\ \((\(-1\) + 2\ \[Beta]2\_0)\) - 
                              4\ \((\(-1\) + p\_0)\)\^3\ \((\(-1\) + 
                                    p\_1)\)\ \[Beta]2\_0\ \((\(-1\) + 
                                    2\ \[Beta]2\_0)\) + \((\(-1\) + \
p\_0)\)\^2\ \((\(-1\) + p\_1)\)\^2\ \((\(-3\) + 2\ Log[1 - p\_0] - 
                                    2\ Log[
                                        1 - p\_1] + \[Beta]2\_0\ \((6 + 
                                        Log[1\/\((\(-1\) + p\_0)\)\^12] + 
                                        Log[\((\(-1\) + p\_1)\)\^12] + 
                                        12\ Log[\(\(-1\) + p\_0\)\/\(\(-1\) + \
p\_1\)]\ \[Beta]2\_0)\))\))\))\))\) + 
              1\/12\ \((p\_1\ \((3 - 2\ \[Beta]2\_0)\) + 
                    p\_0\ \((1 + 2\ \[Beta]2\_0)\) + 
                    4\ \((\(-p\_1\)\ \((\(-2\) + \[Beta]2\_0)\)\ \((\(-1\) + \
\[Beta]2\_0)\) + \[Beta]2\_0\ \((2\ \@\(p\_0\ p\_1\)\ \((\(-1\) + \
\[Beta]2\_0)\) - 
                                p\_0\ \((1 + \[Beta]2\_0)\))\))\) + \(1\/\((p\
\_0 - p\_1)\)\^3\) \((6\ \((\(-p\_1\%4\)\ \((\(-1\) + \[Beta]2\_0)\)\^2 + 
                              4\ p\_0\%3\ p\_1\ \((1 - 
                                    2\ \[Beta]2\_0)\)\ \[Beta]2\_0 + 
                              p\_0\%4\ \[Beta]2\_0\%2 + 
                              4\ p\_0\ p\_1\%3\ \((\(-1\) + \[Beta]2\_0)\)\ \
\((\(-1\) + 2\ \[Beta]2\_0)\) + 
                              p\_0\%2\ p\_1\%2\ \((\(-3\) + 2\ Log[p\_0] - 
                                    2\ Log[p\_1] + 
                                    6\ \[Beta]2\_0\ \((1 - 2\ Log[p\_0] + 
                                        2\ Log[p\_1] + 
                                        2\ Log[
                                        p\_0\/p\_1]\ \[Beta]2\_0)\))\))\))\))\
\) /. {\[Beta]2\_0 \[Rule] \[Beta]20, p\_0 \[Rule] p0, 
              p\_1 \[Rule] p1}];\)\)], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(sptotal\\)\\\" is similar to existing symbol \
\\\"\\!\\(vptotal\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Density plot stuff", "Subsection"],

Cell[CellGroupData[{

Cell["Grid creation functions", "Subsubsection"],

Cell[BoxData[{
    \(\(gridWidth[
          grid_] := \(Dimensions[grid, 
            2]\)\[LeftDoubleBracket]2\[RightDoubleBracket];\)\), "\
\[IndentingNewLine]", 
    \(\(gridHeight[
          grid_] := \(Dimensions[grid, 
            2]\)\[LeftDoubleBracket]1\[RightDoubleBracket];\)\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(gridI[y_, grid_] := 
        Ceiling[Min[y/gridHeight[grid]*1000, 1] (*QQQ*) *
            gridHeight[grid]];\)\), "\[IndentingNewLine]", 
    \(\(gridJ[x_, grid_] := 
        Ceiling[Min[x/gridWidth[grid]*1000, 1] (*QQQ*) *
            gridWidth[grid]];\)\)}], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(gridI\\)\\\" is similar to existing symbol \
\\\"\\!\\(grid\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"spell"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(gridJ\\)\\\" is similar to existing symbols \
\\!\\({grid, gridI}\\). \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell[BoxData[
    \(appendInGrid[i_, j_, a_, grid_] := 
      ReplacePart[grid, 
        ReplacePart[grid\[LeftDoubleBracket]i\[RightDoubleBracket], 
          Append[\(grid\[LeftDoubleBracket]
                i\[RightDoubleBracket]\)\[LeftDoubleBracket]
              j\[RightDoubleBracket], a], j], i]\)], "Input"],

Cell[BoxData[
    \(\(insertIntoGrid[p0_, p1_, \[Beta]20_, grid_] := 
        With[{vp = vptotal[p0, p1, \[Beta]20], 
            sp = sptotal[p0, p1, \[Beta]20]}, \[IndentingNewLine]If[
            vp > 0 && sp > 0, 
            appendInGrid[gridI[vp, grid], 
              gridJ[sp, grid], {p0, p1, \[Beta]20}, grid], 
            grid]];\)\)], "Input"],

Cell[BoxData[
    \(fillGridVarP0[\[Beta]20_, p1_, {p0_, p0Max_, p0\[CapitalDelta]_}, 
        grid_] := If[p0 \[LessEqual] p0Max, 
        fillGridVarP0[\[Beta]20, 
          p1, {p0 + p0\[CapitalDelta], p0Max, p0\[CapitalDelta]}, 
          insertIntoGrid[p0, p1, \[Beta]20, grid]], grid]\)], "Input"],

Cell[BoxData[
    \(fillGridVarP1P0[\[Beta]20_, {p1_, p1Max_, p1\[CapitalDelta]_}, {p0_, 
          p0Max_, p0\[CapitalDelta]_}, grid_] := 
      If[p1 \[LessEqual] p1Max, 
        fillGridVarP1P0[\[Beta]20, {p1 + p1\[CapitalDelta], p1Max, 
            p1\[CapitalDelta]}, {p0, p0Max, p0\[CapitalDelta]}, 
          fillGridVarP0[\[Beta]20, 
            p1, {p0, Min[p1, p0Max], p0\[CapitalDelta]}, grid]], 
        grid]\)], "Input"],

Cell[BoxData[
    \(fillGridVar\[Beta]20P1P0[{\[Beta]20_, \[Beta]20Max_, \[Beta]20\
\[CapitalDelta]_}, p1VarData_, p0VarData_, grid_] := 
      If[\[Beta]20 \[LessEqual] \[Beta]20Max, 
        fillGridVar\[Beta]20P1P0[{\[Beta]20 + \[Beta]20\[CapitalDelta], \
\[Beta]20Max, \[Beta]20\[CapitalDelta]}, p1VarData, p0VarData, 
          fillGridVarP1P0[\[Beta]20, p1VarData, p0VarData, grid]], 
        grid]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Grid evaluation functions", "Subsubsection"],

Cell[BoxData[{
    \(\(countCellEntriesInRow[row_] := 
        Length /@ row;\)\), "\[IndentingNewLine]", 
    \(\(countCellEntries[grid_] := 
        countCellEntriesInRow /@ grid;\)\)}], "Input"],

Cell[BoxData[{
    \(\(markCellEntriesInRow[row_] := \(If[Length[#] > 0, 0, 1] &\) /@ 
          row;\)\), "\[IndentingNewLine]", 
    \(\(markCellEntries[grid_] := markCellEntriesInRow /@ grid;\)\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(leftMostNonEmptyCell[row_, default_] := 
        If[Length[row] > 0, 
          If[Length[First[row]] > 0, First[row], 
            leftMostNonEmptyCell[Rest[row], default]], 
          default];\)\), "\[IndentingNewLine]", 
    \(\(leftMostNonEmptyCells[grid_, default_] := 
        Map[leftMostNonEmptyCell[#, default] &, grid];\)\)}], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(leftMostNonEmptyCells\\)\\\" is similar to \
existing symbol \\\"\\!\\(leftMostNonEmptyCell\\)\\\". \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], \
"Message"]
}, Open  ]],

Cell[BoxData[
    \(\(averageP0P1\[Beta]20[list_] := 
        Apply[Plus, list]/Length[list];\)\)], "Input"],

Cell[BoxData[
    \(\(P0P1\[Beta]20ToPq\[CapitalDelta]P\[Beta]20[{p0_, 
            p1_, \[Beta]20_}] := {\((p0 + p1)\)/2, 
          p1 - p0, \[Beta]20};\)\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Run", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(Table[{}, {100}, {200}];\)\), "\[IndentingNewLine]", 
    \(Timing[\(tmp1 = 
          fillGridVar\[Beta]20P1P0[{0, 1, 0.01}, {0, 1, 0.01}, {0, 1, 
              0.01}, %];\)]\)}], "Input"],

Cell[BoxData[
    \($Aborted\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(ListDensityPlot[markCellEntries[tmp1], Mesh \[Rule] False, 
        Frame \[Rule] False, Axes \[Rule] True, 
        Ticks \[Rule] {{0, {10*100/12, \*"\"\<\!\(1\/12\)\>\""}}, {0, {10*100/
                    12, \*"\"\<\!\(1\/12\)\>\""}}}, 
        AspectRatio \[Rule] 1/1.5, AxesLabel \[Rule] {"\<s\>", "\<v'\>"}, 
        ImageSize \[Rule] imgSize];\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .66667 
%%ImageSize: 170.717 113.811 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% DensityGraphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0192308 0.00480769 0.0128205 0.00641026 [
[.01923 -0.0125 -4.375 -8.25 ]
[.01923 -0.0125 4.375 0 ]
[.41987 -0.0125 -9.1875 -16.6875 ]
[.41987 -0.0125 9.1875 0 ]
[1.025 0 0 -4.125 ]
[1.025 0 8.75 4.125 ]
[-0.0125 .01282 -8.75 -4.125 ]
[-0.0125 .01282 0 4.125 ]
[-0.0125 .54701 -18.375 -8.34375 ]
[-0.0125 .54701 0 8.34375 ]
[0 .69167 -6.75 0 ]
[0 .69167 6.75 8.25 ]
[ 0 0 0 0 ]
[ 1 .66667 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.01923 0 m
.01923 .00625 L
s
gsave
.01923 -0.0125 -65.375 -12.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.41987 0 m
.41987 .00625 L
s
gsave
.41987 -0.0125 -70.1875 -20.6875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 24.6875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 14.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
67.812 9.938 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
64.438 14.750 moveto
(\\200) show
66.000 14.750 moveto
(\\200) show
67.562 14.750 moveto
(\\200) show
69.125 14.750 moveto
(\\200) show
70.688 14.750 moveto
(\\200) show
72.250 14.750 moveto
(\\200) show
73.812 14.750 moveto
(\\200) show
74.500 14.750 moveto
(\\200) show
65.438 19.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
77.375 14.750 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
s
gsave
1.025 0 -61 -8.125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
67.750 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .01282 m
.00625 .01282 L
s
gsave
-0.0125 .01282 -69.75 -8.125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
0 .54701 m
.00625 .54701 L
s
gsave
-0.0125 .54701 -79.375 -12.3438 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 24.6875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 14.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
67.812 9.938 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
64.438 14.750 moveto
(\\200) show
66.000 14.750 moveto
(\\200) show
67.562 14.750 moveto
(\\200) show
69.125 14.750 moveto
(\\200) show
70.688 14.750 moveto
(\\200) show
72.250 14.750 moveto
(\\200) show
73.812 14.750 moveto
(\\200) show
74.500 14.750 moveto
(\\200) show
65.438 19.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
77.375 14.750 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
0 .66667 L
s
gsave
0 .69167 -67.75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(v) show
67.750 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(') show
72.500 10.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .66667 L
0 .66667 L
closepath
clip
newpath
% Start of gray image
p
.01923 .01282 translate
.96154 .64103 scale
200 string
200 100 8 [200 0 0 100 0 0] {
\tcurrentfile
\t1 index
\treadhexstring
\tpop
}  Mimage
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFF00FFFFFF00FFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFF00FFFF00FFFFFF00FFFF00FFFFFF00FFFF
0000FFFF0000FFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFF00FFFF00FFFF00FF00
FFFF00FFFFFF00FFFF00FF0000FF00FFFFFF00FFFF00FFFF0000FFFF0000FFFF0000FFFF
0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
00FF00FF00FF00FF00FF00FF00FF00FFFF00FF00FFFF00FFFFFFFFFFFFFFFF00FFFF00FF
FF00FFFF00FFFFFF00FF0000FF0000FFFF0000FFFF00FFFF0000FFFF0000FFFF0000FFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000000000000000FF000000FF0000FF00
FFFFFFFFFFFFFFFFFFFFFFFF00FFFF00FF00FFFF00FF00FFFF00FFFF00FF00FFFF00FFFF
0000FF0000FF0000FFFF0000FF0000FFFF0000FFFF0000FF0000FFFFFF0000FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF00FF0000
FF00FF00FFFF00FF00FF00FFFFFFFF0000FF0000FF0000FF0000FF00FFFF00FF0000FF00
FF00FF0000FF0000FF000000FF0000FFFF0000FFFF0000FFFF0000FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000000000000000000FF0000FFFFFFFFFFFFFFFF
FF0000000000FF0000000000FF0000FFFFFFFFFF0000FF0000FF0000FF0000FF0000FF00
FF00000000FF000000FF0000FF000000FF000000FF000000FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000FF00000000000000
00FFFFFFFFFFFF000000FF000000FF000000FF000000000000000000FF0000FF00FF0000
0000FF0000FF000000FF000000FF000000FF000000FFFF00FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF0000000000000000000000000000FFFFFFFFFFFFFF000000000000
000000FF00FF00FF0000FF00000000FF0000FF0000FF0000FF0000FF0000000000000000
00FF00000000FF000000000000FF00000000FFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000000000000FF00FF0000FFFFFFFFFF00
FF00000000FF00FF00FFFF00000000FF0000FF00FFFF0000FF0000FF000000000000FF00
000000000000000000000000000000FFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF0000000000000000000000FFFFFFFFFFFF0000000000000000000000FFFF
FF00FF00000000FF0000FF00000000000000FF0000FF000000000000FF00000000000000
000000000000FF00000000FFFF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF000000000000000000000000FFFFFFFF0000000000000000
FF00FF00000000FF0000FF00FF000000000000000000FF0000FF0000FF00000000000000
0000000000000000FFFF000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF00000000000000000000FFFFFFFF0000000000000000000000FF00FF0000000000
0000FFFF000000000000FF0000000000000000FF00000000000000000000000000000000
00000000FF0000FF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFF0000000000000000000000FFFFFF000000000000000000FF0000000000
00000000000000000000000000000000000000000000FF00000000000000000000000000
00000000000000FFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FF00000000000000FFFFFF0000000000000000000000FFFF000000000000FF00FF0000FF
00000000000000000000000000000000FF00000000000000000000000000000000000000
00000000FFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF000000000000000000FFFFFF000000000000000000FF000000FF00000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
00FF00FF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000
00000000FFFF00000000000000000000FFFF000000000000000000000000000000FF0000
000000000000000000000000000000000000000000FF000000000000FF0000000000FFFF
0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000
0000000000000000FFFF0000000000000000FF00000000000000FF000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000FF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000
0000000000000000000000FF0000000000000000FF000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000FFFF00
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000000
000000000000000000000000FFFF00000000000000FF0000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000FFFFFF00FFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000000000
0000000000000000000000000000FF000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000FF0000FF00FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000000000
000000000000000000000000000000FF0000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000FF000000FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000FF00FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000FFFF00FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000FFFF00FFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000FF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000FF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000FF0000FF00FF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000FF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000FF00FFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000FF0000FF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000FF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
00FF00FF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
00FF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000FF00FF00
FF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000FF00FF00
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000FF00FFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000FF00FF00FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000FF00FF00FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000FF00FF00FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFF0000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000FF00FF00FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFF0000000000000000000000000000000000000000000000
00000000000000000000000000000000000000FF000000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000FF00FF00FFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF000000000000000000000000000000000000000000000000
000000000000000000000000000000000000FF00FF0000FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFF00000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFF00000000000000000000000000000000000000000000000000
0000000000000000000000000000000000FF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFF0000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFF0000000000000000000000000000000000000000000000000000
00000000000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFF0000000000000000000000000000000000000000000000000000
00000000000000000000000000FF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF000000000000000000000000000000000000000000000000000000
00000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF000000000000000000000000000000000000000000000000000000
000000000000000000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFF00000000000000000000000000000000000000000000000000000000
000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFF00000000000000000000000000000000000000000000000000000000
0000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFF0000000000000000000000000000000000000000000000000000000000
00000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFF0000000000000000000000000000000000000000000000000000000000
00000000FF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFF0000000000000000000000000000000000000000000000000000000000
000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF000000000000000000000000000000000000000000000000000000000000
0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF000000000000000000000000000000000000000000000000000000000000
00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF00000000000000000000000000000000000000000000000000000000FFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFF00000000000000000000000000000000000000000000000000000000FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFF000000000000000000000000000000000000000000000000000000FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFF00000000000000000000000000000000000000000000000000FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFF00000000000000000000000000000000000000000000000000FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFF00000000000000000000000000000000000000000000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFF000000000000000000000000000000000000000000FFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF0000000000000000000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF00000000000000000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF0000000000000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFF00000000000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFF000000000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFF00000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FF000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FF0000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FF000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FF00000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
00000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
0000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
pop
P
% End of image
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{170.688, 113.812},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002Z0000LA000`40n007h00OZ_oo002Zool004_o
o`<000;oo`<005Ooo`00C?oo00D00?ooooooo`0005Woo`00C?oo00<00?ooool00_oo00<00?ooool0
E_oo001<ool00`00ooooo`03ool00`00ooooo`1Eool004_oo`8000?oo`03003oo`0005Ooo`00C?oo
00<00?ooool00_oo00<00?ooool0E_oo0019ool<001Eool00:[oo`00Z_oo000Lool00`00ooooo`0^
ool3001Jool001_oo`03003oo`00033oo`03003ooooo05Woo`006ooo00<00?oo0000<?oo00<00?oo
ool0FOoo000Kool00`00ool0000`ool00`00ooooo`1Iool001_oo`03003oo`0002ooo`8005_oo`00
7?oo00<00?ooool0;ooo00<00?ooool0FOoo002Mool2000;ool001[oogh000Ooo`03003ooooo00So
o`005?oo00<00?ooool00ooo00<00?oo0000<Ooo00<00?ooool0C?oo0P002ooo000Cool00`00ool0
0004ool20022ool2000:ool001?oo`03003oo`0000Coo`03003ooooo04coo`07003oo`00ool00?oo
00000ooo0P0000?oo`00ool0<_oo000Cool00`00ool00004ool00`00ooooo`0iool01@00ool00?oo
00000_oo00H00?ooooooo`00ool40003ool00`00ool00002ool01000ool00?oo0P00=Ooo000Cool0
0`00ool00004ool00`00ooooo`0[ool30003ool300001Ooo00000?oo00001_oo00D00?oo003oo`00
00?oo`09003oo`00ool00?oo003oo`0000;oo`03003oo`0003Soo`005?oo00<00?ooool00ooo00<0
0?ooool08?oo1@0000?oo`0000000`001ooo00D00?oo00000?oo00800005ool00?ooool00003ool5
00001ooo003oo`00ool00?oo00<000;oo`03003ooooo03Soo`006_oo00<00?ooool07_oo1P0000?o
o`00ool01Ooo1P0000?oo`00ool00_oo00@00?oo003oo`@00003ool0000000@00005ool00?oo003o
o`04000nool001[oo`03003ooooo02Coo`800003ool0000000<000?oo`800003ool00?oo01800003
ool0000000800003ool00?oo03ooo`006_oo00<00?ooool06ooo20001?oo1`000_oo00D00?oo0000
0?oo00@00003ool00?oo00D00004ool00000ool70011ool001[oo`03003ooooo01Woo`H000Coo`L0
00?oo`800003ool00?oo01800003ool0000000;oo`03003ooooo047oo`006_oo00<00?ooool07?oo
20000_oo1@000_oo0P0000Coo`00ooooo`D00003ool00?oo00/00003ool0000004Coo`006_oo00<0
0?ooool05ooo1P000_oo1`000_oo100000?oo`0000000P0000?oo`0000000P0000?oo`0000002P00
00?oo`00ool0Aooo000Jool00`00ooooo`0Iool70002ool500000ooo0000000>00000ooo0000000:
00000ooo003oo`15ool001[oo`03003ooooo01Ooo`D000;oo`P00003ool0000001P000;oo`03003o
oooo04Ooo`006_oo00<00?ooool05?oo100000?oo`000000100000?oo`0000001`0000?oo`000000
4`000_oo00<00?ooool0BOoo000Jool00`00ooooo`0Dool600000ooo0000000300000ooo0000000M
001=ool001[oo`03003ooooo01?oo`h00003ool0000001/00003ool00?oo04_oo`006_oo00<00?oo
ool04_oo:P0000?oo`00ool0C_oo000Jool00`00ooooo`0Aool=00000ooo0000000I00000ooo003o
o`1@ool001[oo`03003ooooo017oobX005;oo`006_oo00<00?ooool04?oo:@00E?oo000Jool00`00
ooooo`0?oolY001Eool001[oo`03003ooooo00koobL00003ool00?oo05Goo`006_oo00<00?ooool0
3_oo:000Eooo000Jool00`00ooooo`0=oolS00001Ooo003ooooo0000F?oo000Jool00`00ooooo`0=
oolU001Kool001[oo`03003ooooo00coobD00003ool00?oo05Woo`006_oo00<00?ooool02ooo9@00
00?oo`00ool0F_oo000Jool00`00ooooo`0;oolT001Nool001[oo`03003ooooo00[oob@005ooo`00
6_oo00<00?ooool02_oo8`00H?oo000Jool00`00ooooo`0:oolR001Qool001[oo`03003ooooo00Wo
oal00003ool0000006;oo`006_oo00<00?ooool02?oo800000?oo`00ool0H_oo000Jool00`00oooo
o`08oolQ001Tool001[oo`03003ooooo00Sooad00003ool0000006Goo`006_oo00<00?ooool01ooo
7`00Iooo000Jool00`00ooooo`07oolL00000ooo003oo`1Wool001[oo`03003ooooo00Oooa`006[o
o`006_oo00<00?ooool01_oo6`00K?oo000Jool00`00ooooo`06oolI00000ooo003oo`1[ool001[o
o`03003ooooo00Gooa/006goo`006_oo00<00?ooool01Ooo6P00K_oo000Jool00`00ooooo`05oolH
001`ool001[oo`03003ooooo00GooaL0077oo`006_oo00<00?ooool01?oo5`00L_oo000Jool00`00
ooooo`04oolF001cool001[oo`03003ooooo00CooaD007Coo`006_oo00<00?ooool01?oo4`00M_oo
000Jool00`00ooooo`03oolC001gool001[oo`03003ooooo00?ooa<007Ooo`006_oo00<00?ooool0
0_oo4@00N_oo000Jool00`00ooooo`02oolA001jool001[oo`03003ooooo00;ooa0007_oo`006_oo
00<00?ooool00_oo3@00O_oo000Jool00`00ooooo`02ool<001oool001[oo`04003oooooool<0020
ool001[oo`04003oooooool<0020ool001[oo`04003oooooool90023ool001[oo`04003oooooool9
0023ool001[oo`04003oooooool70025ool000coo`<000;oo`<000Koo`03003ooooo00L008Koo`00
3Ooo00D00?ooooooo`0000Soo`03003ooooo00D008Soo`003Ooo00<00?ooool00_oo00<00?ooool0
1Ooo00<00?ooool01000ROoo000=ool00`00ooooo`03ool00`00ooooo`04ool00`00ool000040029
ool000coo`8000?oo`03003oo`0000Koo`03003oo`00008008_oo`003Ooo00<00?ooool00_oo00<0
0?ooool01Ooo00@00?oo000008coo`002_oo30001?oo0`00SOoo000Jool00`00ooooo`2=ool001[o
o`03003ooooo08goo`006_oo00<00?ooool0SOoo000>ool30009ool00`00ooooo`2=ool000ooo`03
003ooooo00Soo`03003ooooo08goo`003ooo00<00?ooool02?oo00<00?ooool0SOoo000?ool00`00
ooooo`08ool00`00ooooo`2=ool000koo`8000[oo`03003ooooo08goo`003ooo00<00?ooool02?oo
00<00?ooool0SOoo000Jool00`00ooooo`2=ool001[oo`03003ooooo08goo`006_oo00<00?ooool0
SOoo000Jool00`00ooooo`2=ool001[oo`03003ooooo08goo`006_oo00<00?ooool0SOoo002Zool0
0:[oo`00Z_oo002Zool00:[oo`005ooo00<00?ooool0T?oo000Fool00`00ool0002Aool001Koo`03
003oo`00097oo`005Ooo0P0000?oo`00ool0T?oo000Lool00`00ooooo`2;ool001coo`03003ooooo
08_oo`00\
\>"],
  ImageRangeCache->{{{0, 169.688}, {112.812, 0}} -> {-48.1378, -24.8114, \
1.66679, 1.25009}}]
}, Open  ]],

Cell[BoxData[
    \(\(tmp3 = leftMostNonEmptyCells[tmp1, {{0, 0, 0}}];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(tmp4 = 
        P0P1\[Beta]20ToPq\[CapitalDelta]P\[Beta]20 /@ \(averageP0P1\[Beta]20 /@ 
            tmp3\);\)\)], "Input"],

Cell[BoxData[
    \({{0.5000000000000003`, 0.9800000000000006`, 
        0.5000000000000003`}, {0.5000000000000003`, 0.9800000000000006`, 
        0.5000000000000003`}, {0.5000000000000003`, 0.9800000000000006`, 
        0.5000000000000002`}, {0.5000000000000003`, 0.9800000000000006`, 
        0.5000000000000002`}, {0.5000000000000003`, 0.9800000000000006`, 
        0.5000000000000002`}, {0.5000000000000003`, 0.9700000000000006`, 
        0.5000000000000002`}, {0.5000000000000002`, 0.9700000000000005`, 
        0.5000000000000002`}, {0.5000000000000003`, 0.9600000000000006`, 
        0.5000000000000002`}, {0.5000000000000002`, 0.9600000000000005`, 
        0.5000000000000002`}, {0.5000000000000003`, 0.9500000000000006`, 
        0.5000000000000002`}, {0.5000000000000002`, 0.9500000000000005`, 
        0.5000000000000002`}, {0.5000000000000003`, 0.9400000000000006`, 
        0.5000000000000002`}, {0.5000000000000003`, 0.9400000000000006`, 
        0.5000000000000002`}, {0.5000000000000003`, 0.9300000000000007`, 
        0.5000000000000002`}, {0.5000000000000003`, 0.9300000000000006`, 
        0.5000000000000002`}, {0.5000000000000004`, 0.9200000000000008`, 
        0.5000000000000003`}, {0.5000000000000003`, 0.9200000000000007`, 
        0.5000000000000002`}, {0.5000000000000002`, 0.9100000000000005`, 
        0.5000000000000002`}, {0.5000000000000004`, 0.9100000000000008`, 
        0.5000000000000003`}, {0.5000000000000003`, 0.9000000000000006`, 
        0.5000000000000002`}, {0.5000000000000003`, 0.9000000000000006`, 
        0.5000000000000002`}, {0.5000000000000003`, 0.8900000000000006`, 
        0.5000000000000001`}, {0.5000000000000002`, 0.8800000000000006`, 
        0.5000000000000002`}, {0.5000000000000003`, 0.8800000000000006`, 
        0.5000000000000002`}, {0.5000000000000002`, 0.8700000000000004`, 
        0.5000000000000003`}, {0.5000000000000002`, 0.8700000000000004`, 
        0.5000000000000001`}, {0.5000000000000002`, 0.8600000000000004`, 
        0.5000000000000001`}, {0.5000000000000003`, 0.8500000000000008`, 
        0.5000000000000002`}, {0.5000000000000002`, 0.8500000000000005`, 
        0.5000000000000002`}, {0.5000000000000002`, 0.8400000000000005`, 
        0.5000000000000002`}, {0.5000000000000003`, 0.8300000000000007`, 
        0.5000000000000002`}, {0.5000000000000002`, 0.8300000000000004`, 
        0.5000000000000001`}, {0.5000000000000002`, 0.8200000000000004`, 
        0.5000000000000002`}, {0.5000000000000002`, 0.8100000000000005`, 
        0.5000000000000001`}, {0.5000000000000004`, 0.807272727272728`, 
        0.5`}, {0.5000000000000002`, 0.8000000000000005`, 
        0.5000000000000002`}, {0.5000000000000002`, 0.7900000000000005`, 
        0.5000000000000002`}, {0.5000000000000002`, 0.7800000000000006`, 
        0.5000000000000002`}, {0.5000000000000003`, 0.7766153846153853`, 
        0.5000000000000003`}, {0.5000000000000002`, 0.7700000000000005`, 
        0.5000000000000001`}, {0.5000000000000002`, 0.7600000000000006`, 
        0.5000000000000001`}, {0.5000000000000003`, 0.7500000000000007`, 
        0.5000000000000002`}, {0.5000000000000002`, 0.7400000000000005`, 
        0.5000000000000002`}, {0.5000000000000003`, 0.7359493670886081`, 
        0.5000000000000002`}, {0.5000000000000003`, 0.7300000000000009`, 
        0.5000000000000001`}, {0.5000000000000001`, 0.718556701030928`, 
        0.5000000000000008`}, {0.5000000000000002`, 0.7100000000000004`, 
        0.5000000000000001`}, {0.5000000000000002`, 0.6996330275229362`, 
        0.5000000000000006`}, {0.5000000000000002`, 0.6900000000000005`, 
        0.5000000000000002`}, {0.5000000000000001`, 0.6790909090909094`, 
        0.5000000000000004`}, {0.5000000000000003`, 0.6700000000000007`, 
        0.5000000000000001`}, {0.5000000000000002`, 0.6628301886792456`, 
        0.5000000000000006`}, {0.5000000000000008`, 0.6508056872037931`, 
        0.5`}, {0.5000000000000003`, 0.642954545454546`, 
        0.5000000000000006`}, {0.5000000000000006`, 0.6312217194570146`, 
        0.5000000000000002`}, {0.5000000000000003`, 0.6200000000000004`, 
        0.5000000000000001`}, {0.5000000000000003`, 0.6097695852534568`, 
        0.5000000000000002`}, {0.5000000000000002`, 0.6000000000000004`, 
        0.5`}, {0.5000000000000003`, 0.5884126984126989`, 
        0.5000000000000004`}, {0.5000000000000002`, 0.573831775700935`, 
        0.5000000000000001`}, {0.5000000000000002`, 0.5664705882352943`, 
        0.5`}, {0.5000000000000002`, 0.5525691699604747`, 
        0.5000000000000007`}, {0.5`, 0.5368576709796671`, 
        0.5`}, {0.5000000000000003`, 0.5276000000000005`, 
        0.5000000000000007`}, {0.49999999999999994`, 0.5119261213720313`, 
        0.5`}, {0.5`, 0.49463476070529006`, 
        0.49999999999999956`}, {0.5000000000000003`, 0.48640000000000033`, 
        0.5000000000000011`}, {0.4999999999999999`, 0.46812603648424544`, 
        0.5000000000000001`}, {0.49999999999999944`, 0.4477632898696078`, 
        0.4999999999999969`}, {0.5000000000000002`, 0.44`, 
        0.500000000000001`}, {0.4999999999999998`, 0.41919463087248304`, 
        0.5000000000000012`}, {0.5`, 0.39697783747481546`, 
        0.4999999999999975`}, {0.5000000000000002`, 0.3880203045685281`, 
        0.5000000000000004`}, {0.5000000000000001`, 0.3641334569045415`, 
        0.4999999999999999`}, {0.5`, 0.33740139211136777`, 
        0.499999999999994`}, {0.5000000000000002`, 0.32962962962962983`, 
        0.5000000000000003`}, {0.4999999999999998`, 0.3003647898493255`, 
        0.4999999999999922`}, {0.5000000000000004`, 0.2683210820346962`, 
        0.49999999999997663`}, {0.49999999999999917`, 0.23599795987759442`, 
        0.4999999999999946`}, {0.4999999999999999`, 0.21439906651108448`, 
        0.4999999999999978`}, {0.4999999999999994`, 0.17804976671850736`, 
        0.5000000000000142`}, {0.4999999999999998`, 0.1358264000993341`, 
        0.5000000000000089`}, {0.5`, 0.08175954592362444`, 
        0.5000000000000276`}, {0.5000000000000003`, 0.030065889508364696`, 
        0.4999999999999987`}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 
        0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 
        0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 
        0}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(tmp4out = 
        Map[ToString[
              NumberForm[#, {5, 5}, 
                NumberPadding \[Rule] {"\<\>", "\<0\>"}]] &, 
          tmp4, {2}];\)\)], "Input"],

Cell[BoxData[
    \({{"0.50000", "0.98000", "0.50000"}, {"0.50000", "0.98000", 
        "0.50000"}, {"0.50000", "0.98000", "0.50000"}, {"0.50000", "0.98000", 
        "0.50000"}, {"0.50000", "0.98000", "0.50000"}, {"0.50000", "0.97000", 
        "0.50000"}, {"0.50000", "0.97000", "0.50000"}, {"0.50000", "0.96000", 
        "0.50000"}, {"0.50000", "0.96000", "0.50000"}, {"0.50000", "0.95000", 
        "0.50000"}, {"0.50000", "0.95000", "0.50000"}, {"0.50000", "0.94000", 
        "0.50000"}, {"0.50000", "0.94000", "0.50000"}, {"0.50000", "0.93000", 
        "0.50000"}, {"0.50000", "0.93000", "0.50000"}, {"0.50000", "0.92000", 
        "0.50000"}, {"0.50000", "0.92000", "0.50000"}, {"0.50000", "0.91000", 
        "0.50000"}, {"0.50000", "0.91000", "0.50000"}, {"0.50000", "0.90000", 
        "0.50000"}, {"0.50000", "0.90000", "0.50000"}, {"0.50000", "0.89000", 
        "0.50000"}, {"0.50000", "0.88000", "0.50000"}, {"0.50000", "0.88000", 
        "0.50000"}, {"0.50000", "0.87000", "0.50000"}, {"0.50000", "0.87000", 
        "0.50000"}, {"0.50000", "0.86000", "0.50000"}, {"0.50000", "0.85000", 
        "0.50000"}, {"0.50000", "0.85000", "0.50000"}, {"0.50000", "0.84000", 
        "0.50000"}, {"0.50000", "0.83000", "0.50000"}, {"0.50000", "0.83000", 
        "0.50000"}, {"0.50000", "0.82000", "0.50000"}, {"0.50000", "0.81000", 
        "0.50000"}, {"0.50000", "0.80727", "0.50000"}, {"0.50000", "0.80000", 
        "0.50000"}, {"0.50000", "0.79000", "0.50000"}, {"0.50000", "0.78000", 
        "0.50000"}, {"0.50000", "0.77662", "0.50000"}, {"0.50000", "0.77000", 
        "0.50000"}, {"0.50000", "0.76000", "0.50000"}, {"0.50000", "0.75000", 
        "0.50000"}, {"0.50000", "0.74000", "0.50000"}, {"0.50000", "0.73595", 
        "0.50000"}, {"0.50000", "0.73000", "0.50000"}, {"0.50000", "0.71856", 
        "0.50000"}, {"0.50000", "0.71000", "0.50000"}, {"0.50000", "0.69963", 
        "0.50000"}, {"0.50000", "0.69000", "0.50000"}, {"0.50000", "0.67909", 
        "0.50000"}, {"0.50000", "0.67000", "0.50000"}, {"0.50000", "0.66283", 
        "0.50000"}, {"0.50000", "0.65081", "0.50000"}, {"0.50000", "0.64295", 
        "0.50000"}, {"0.50000", "0.63122", "0.50000"}, {"0.50000", "0.62000", 
        "0.50000"}, {"0.50000", "0.60977", "0.50000"}, {"0.50000", "0.60000", 
        "0.50000"}, {"0.50000", "0.58841", "0.50000"}, {"0.50000", "0.57383", 
        "0.50000"}, {"0.50000", "0.56647", "0.50000"}, {"0.50000", "0.55257", 
        "0.50000"}, {"0.50000", "0.53686", "0.50000"}, {"0.50000", "0.52760", 
        "0.50000"}, {"0.50000", "0.51193", "0.50000"}, {"0.50000", "0.49463", 
        "0.50000"}, {"0.50000", "0.48640", "0.50000"}, {"0.50000", "0.46813", 
        "0.50000"}, {"0.50000", "0.44776", "0.50000"}, {"0.50000", "0.44000", 
        "0.50000"}, {"0.50000", "0.41919", "0.50000"}, {"0.50000", "0.39698", 
        "0.50000"}, {"0.50000", "0.38802", "0.50000"}, {"0.50000", "0.36413", 
        "0.50000"}, {"0.50000", "0.33740", "0.50000"}, {"0.50000", "0.32963", 
        "0.50000"}, {"0.50000", "0.30036", "0.50000"}, {"0.50000", "0.26832", 
        "0.50000"}, {"0.50000", "0.23600", "0.50000"}, {"0.50000", "0.21440", 
        "0.50000"}, {"0.50000", "0.17805", "0.50000"}, {"0.50000", "0.13583", 
        "0.50000"}, {"0.50000", "0.08176", "0.50000"}, {"0.50000", "0.03007", 
        "0.50000"}, {"0.00000", "0.00000", "0.00000"}, {"0.00000", "0.00000", 
        "0.00000"}, {"0.00000", "0.00000", "0.00000"}, {"0.00000", "0.00000", 
        "0.00000"}, {"0.00000", "0.00000", "0.00000"}, {"0.00000", "0.00000", 
        "0.00000"}, {"0.00000", "0.00000", "0.00000"}, {"0.00000", "0.00000", 
        "0.00000"}, {"0.00000", "0.00000", "0.00000"}, {"0.00000", "0.00000", 
        "0.00000"}, {"0.00000", "0.00000", "0.00000"}, {"0.00000", "0.00000", 
        "0.00000"}, {"0.00000", "0.00000", "0.00000"}, {"0.00000", "0.00000", 
        "0.00000"}, {"0.00000", "0.00000", "0.00000"}, {"0.00000", "0.00000", 
        "0.00000"}}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(Export["\</Net/hubble/Users/felix/tmp/tmp4.dat\>", 
        tmp4out, "\<Table\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(optPlot = 
        ParametricPlot[{sptotal[1\/2 - \(1\/2\) \[CapitalDelta]p, 
              1\/2 + \(1\/2\) \[CapitalDelta]p, 1\/2], 
            vptotal[1\/2 - \(1\/2\) \[CapitalDelta]p, 
              1\/2 + \(1\/2\) \[CapitalDelta]p, 1\/2]}, {\[CapitalDelta]p, 0, 
            1}, DisplayFunction \[Rule] Identity];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Show[optPlot, PlotRange \[Rule] {{0, 1.5\/10}, {0, 1\/10}}, 
        DisplayFunction \[Rule] $DisplayFunction, AspectRatio \[Rule] 1/1.5, 
        Ticks \[Rule] {{{0.001, 
                0}, {1\/12, \*"\"\<\!\(1\/12\)\>\""}}, {{0.001, 
                0}, {1\/12, \*"\"\<\!\(1\/12\)\>\""}}}, 
        AxesLabel \[Rule] {"\<s\>", "\<v'\>"}, 
        ImageSize \[Rule] imgSize];\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .66667 
%%ImageSize: 170.717 113.811 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-2.95987e-17 6.66667 -7.39968e-18 6.66667 [
[.00667 -0.0125 -4.375 -8.25 ]
[.00667 -0.0125 4.375 0 ]
[.55556 -0.0125 -9.1875 -16.6875 ]
[.55556 -0.0125 9.1875 0 ]
[1.025 0 0 -4.125 ]
[1.025 0 8.75 4.125 ]
[-0.0125 .00667 -8.75 -4.125 ]
[-0.0125 .00667 0 4.125 ]
[-0.0125 .55556 -18.375 -8.34375 ]
[-0.0125 .55556 0 8.34375 ]
[0 .69167 -6.75 0 ]
[0 .69167 6.75 8.25 ]
[ 0 0 0 0 ]
[ 1 .66667 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00667 0 m
.00667 .00625 L
s
gsave
.00667 -0.0125 -65.375 -12.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.55556 0 m
.55556 .00625 L
s
gsave
.55556 -0.0125 -70.1875 -20.6875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 24.6875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 14.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
67.812 9.938 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
64.438 14.750 moveto
(\\200) show
66.000 14.750 moveto
(\\200) show
67.562 14.750 moveto
(\\200) show
69.125 14.750 moveto
(\\200) show
70.688 14.750 moveto
(\\200) show
72.250 14.750 moveto
(\\200) show
73.812 14.750 moveto
(\\200) show
74.500 14.750 moveto
(\\200) show
65.438 19.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
77.375 14.750 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
s
gsave
1.025 0 -61 -8.125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
67.750 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .00667 m
.00625 .00667 L
s
gsave
-0.0125 .00667 -69.75 -8.125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
0 .55556 m
.00625 .55556 L
s
gsave
-0.0125 .55556 -79.375 -12.3438 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 24.6875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 14.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
67.812 9.938 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
64.438 14.750 moveto
(\\200) show
66.000 14.750 moveto
(\\200) show
67.562 14.750 moveto
(\\200) show
69.125 14.750 moveto
(\\200) show
70.688 14.750 moveto
(\\200) show
72.250 14.750 moveto
(\\200) show
73.812 14.750 moveto
(\\200) show
74.500 14.750 moveto
(\\200) show
65.438 19.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
77.375 14.750 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
0 .66667 L
s
gsave
0 .69167 -67.75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 16.25 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(v) show
67.750 10.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(') show
72.500 10.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .66667 L
0 .66667 L
closepath
clip
newpath
.5 Mabswid
0 .55555 m
0 .55555 L
0 .55555 L
0 .55554 L
1e-05 .55552 L
4e-05 .55538 L
.00018 .55482 L
.0008 .55236 L
.0018 .5484 L
.00316 .5431 L
.00505 .53583 L
.00733 .52723 L
.00998 .51744 L
.01335 .50536 L
.01717 .49207 L
.02193 .4761 L
.02729 .45887 L
.03327 .44052 L
.04066 .419 L
.04895 .39624 L
.0593 .36973 L
.0711 .34178 L
.08458 .31248 L
.10186 .27852 L
.12233 .2428 L
.14694 .20533 L
.18108 .16158 L
.22678 .115 L
.261 .08733 L
.30458 .05934 L
.3318 .04534 L
.36917 .02987 L
.38873 .02331 L
.41462 .01607 L
.43308 .01185 L
.45408 .00792 L
.46688 .00595 L
.48127 .0041 L
.50103 .00215 L
.55523 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{170.688, 113.812},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002Z0000LA000`40n007h00OZ_oo002Zool005co
o`<000;oo`<004Koo`00GOoo00D00?ooooooo`0004Soo`00GOoo00<00?ooool00_oo00<00?ooool0
AOoo001Mool00`00ooooo`03ool00`00ooooo`14ool005coo`8000?oo`03003oo`0004Koo`00GOoo
00<00?ooool00_oo00<00?ooool0AOoo001Jool<0014ool00:[oo`00Z_oo000Jool00`00ooooo`11
ool30019ool001Woo`03003oo`0004?oo`03003ooooo04Soo`006Ooo00<00?oo0000@ooo00<00?oo
ool0B?oo000Iool00`00ool00013ool00`00ooooo`18ool001Woo`03003oo`0004;oo`8004[oo`00
6_oo00<00?ooool0@_oo00<00?ooool0B?oo002Mool2000;ool001Coo`03003ooooo00?oogh000Oo
o`03003ooooo00Soo`004ooo00<00?oo00001?oo0P00<ooo1P002_oo00<00?ooool0>ooo0P002ooo
000Cool00`00ool00004ool00`00ooooo`0_ool3001?ool2000:ool001?oo`03003oo`0000Coo`03
003ooooo02coo`<005koo`004ooo00<00?oo00001?oo00<00?ooool0:_oo0P00HOoo000Dool00`00
ooooo`03ool00`00ooooo`0Xool2001Sool001[oo`03003ooooo02Goo`<006Goo`006_oo00<00?oo
ool08ooo0P00J?oo000Jool00`00ooooo`0Rool00`00ooooo`1Xool001[oo`03003ooooo023oo`80
06_oo`006_oo00<00?ooool07ooo00<00?ooool0Jooo000Jool00`00ooooo`0Nool00`00ooooo`1/
ool001[oo`03003ooooo01coo`8006ooo`006_oo00<00?ooool06_oo0P00LOoo000Jool00`00oooo
o`0Iool00`00ooooo`1aool001[oo`03003ooooo01Soo`03003ooooo07;oo`006_oo00<00?ooool0
5ooo00<00?ooool0Looo000Jool00`00ooooo`0Gool00`00ooooo`1cool001[oo`03003ooooo01Ko
o`03003ooooo07Coo`006_oo00<00?ooool05Ooo00<00?ooool0MOoo000Jool00`00ooooo`0Dool0
0`00ooooo`1fool001[oo`03003ooooo01?oo`03003ooooo07Ooo`006_oo00<00?ooool04_oo00<0
0?ooool0N?oo000Jool00`00ooooo`0Bool00`00ooooo`1hool001[oo`03003ooooo017oo`03003o
oooo07Woo`006_oo00<00?ooool04?oo00<00?ooool0N_oo000Jool00`00ooooo`0?ool00`00oooo
o`1kool001[oo`03003ooooo00koo`03003ooooo07coo`006_oo00<00?ooool03_oo00<00?ooool0
O?oo000Jool00`00ooooo`0=ool00`00ooooo`1mool001[oo`03003ooooo00coo`03003ooooo07ko
o`006_oo00<00?ooool03?oo00<00?ooool0O_oo000Jool00`00ooooo`0;ool00`00ooooo`1oool0
01[oo`03003ooooo00_oo`03003ooooo07ooo`006_oo00<00?ooool02_oo00<00?ooool0P?oo000J
ool00`00ooooo`0:ool00`00ooooo`20ool001[oo`03003ooooo00[oo`03003ooooo083oo`006_oo
00<00?ooool02Ooo00<00?ooool0POoo000Jool00`00ooooo`09ool00`00ooooo`21ool001[oo`03
003ooooo00Soo`03003ooooo08;oo`006_oo00<00?ooool02?oo00<00?ooool0P_oo000Jool00`00
ooooo`07ool00`00ooooo`23ool001[oo`03003ooooo00Ooo`03003ooooo08?oo`006_oo00<00?oo
ool01_oo00<00?ooool0Q?oo000Jool00`00ooooo`05ool00`00ooooo`25ool001[oo`03003ooooo
00Goo`03003ooooo08Goo`006_oo00<00?ooool01?oo00<00?ooool0Q_oo000Jool00`00ooooo`04
ool00`00ooooo`26ool001[oo`03003ooooo00?oo`03003ooooo08Ooo`006_oo00<00?ooool00ooo
00<00?ooool0Qooo000Jool00`00ooooo`03ool00`00ooooo`27ool001[oo`03003ooooo00;oo`03
003ooooo08Soo`006_oo00<00?ooool00_oo00<00?ooool0R?oo000Jool00`00ooooo`02ool00`00
ooooo`28ool001[oo`05003oooooool0002;ool001[oo`05003oooooool0002;ool001[oo`05003o
ooooool0002;ool001[oo`04003ooooo002<ool001[oo`04003ooooo002<ool001[oo`04003ooooo
002<ool001[oo`04003ooooo002<ool001[oo`03003oo`0008goo`006_oo00<00?oo0000SOoo000<
ool30002ool30006ool00`00ool0002=ool000goo`05003oooooool00008ool00`00ool0002=ool0
00goo`03003ooooo00;oo`03003ooooo00Goo`8008koo`003Ooo00<00?ooool00ooo00<00?ooool0
1?oo0P00S_oo000<ool20003ool00`00ool00006ool2002>ool000goo`03003ooooo00;oo`03003o
oooo00Goo`03003ooooo08goo`002_oo30001?oo0P00S_oo000Jool00`00ooooo`2=ool001[oo`03
003ooooo08goo`006_oo00<00?ooool0SOoo000>ool30009ool00`00ooooo`2=ool000ooo`03003o
oooo00Soo`03003ooooo08goo`003ooo00<00?ooool02?oo00<00?ooool0SOoo000?ool00`00oooo
o`08ool00`00ooooo`2=ool000koo`8000[oo`03003ooooo08goo`003ooo00<00?ooool02?oo00<0
0?ooool0SOoo000Jool00`00ooooo`2=ool001[oo`03003ooooo08goo`006_oo00<00?ooool0SOoo
000Jool00`00ooooo`2=ool001[oo`03003ooooo08goo`00Z_oo002Zool00:[oo`00Z_oo002Zool0
01Ooo`03003ooooo093oo`005_oo00<00?oo0000TOoo000Fool00`00ool0002Aool001Goo`800003
ool00?oo093oo`007?oo00<00?ooool0Rooo000Lool00`00ooooo`2;ool00001\
\>"],
  ImageRangeCache->{{{0, 169.688}, {112.812, 0}} -> {-0.0318301, -0.021934, \
0.00120201, 0.00120201}}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
Evaluator->"psi",
WindowSize->{1012, 740},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
Magnification->1
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 71, 1, 27, "Input"],
Cell[1828, 54, 56, 1, 27, "Input"],
Cell[1887, 57, 111, 2, 27, "Input"],
Cell[2001, 61, 2121, 35, 163, "Input"],

Cell[CellGroupData[{
Cell[4147, 100, 2873, 46, 389, "Input"],
Cell[7023, 148, 362, 5, 20, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7422, 158, 40, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[7487, 162, 48, 0, 28, "Subsubsection"],
Cell[7538, 164, 300, 7, 43, "Input"],

Cell[CellGroupData[{
Cell[7863, 175, 293, 6, 43, "Input"],
Cell[8159, 183, 357, 5, 20, "Message"],
Cell[8519, 190, 357, 5, 20, "Message"]
}, Open  ]],
Cell[8891, 198, 316, 6, 27, "Input"],
Cell[9210, 206, 355, 7, 43, "Input"],
Cell[9568, 215, 303, 5, 43, "Input"],
Cell[9874, 222, 434, 8, 59, "Input"],
Cell[10311, 232, 417, 7, 59, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10765, 244, 50, 0, 28, "Subsubsection"],
Cell[10818, 246, 197, 4, 43, "Input"],
Cell[11018, 252, 210, 3, 43, "Input"],

Cell[CellGroupData[{
Cell[11253, 259, 369, 7, 59, "Input"],
Cell[11625, 268, 391, 6, 20, "Message"]
}, Open  ]],
Cell[12031, 277, 108, 2, 27, "Input"],
Cell[12142, 281, 169, 3, 27, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12348, 289, 28, 0, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[12401, 293, 212, 4, 43, "Input"],
Cell[12616, 299, 42, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12695, 305, 388, 6, 64, "Input"],
Cell[13086, 313, 56068, 1107, 122, 51265, 1044, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]],
Cell[69169, 1423, 85, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[69279, 1428, 145, 3, 27, "Input"],
Cell[69427, 1433, 6286, 88, 251, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[75750, 1526, 190, 5, 27, "Input"],
Cell[75943, 1533, 3984, 51, 411, "Output"]
}, Open  ]],
Cell[79942, 1587, 119, 2, 27, "Input"],
Cell[80064, 1591, 355, 6, 64, "Input"],

Cell[CellGroupData[{
Cell[80444, 1601, 414, 7, 80, "Input"],
Cell[80861, 1610, 15059, 524, 122, 11082, 472, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

