(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    154637,       3778]*)
(*NotebookOutlinePosition[    155275,       3801]*)
(*  CellTagsIndexPosition[    155231,       3797]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"longdoubl", "*", 
          RowBox[{"10", "^", "Isc2"}]}], "=", 
        RowBox[{"{", 
          RowBox[{"0.429094", ",", "0.00317847", ",", 
            RowBox[{"7.16949", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "05"}]}]}], ",", 
            RowBox[{"2.73644", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "06"}]}]}], ",", 
            RowBox[{"1.48489", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "07"}]}]}], ",", 
            RowBox[{"1.05229", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "08"}]}]}], ",", 
            RowBox[{"9.26012", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "10"}]}]}], ",", 
            RowBox[{"9.78712", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "11"}]}]}], ",", 
            RowBox[{"1.21328", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "11"}]}]}], ",", 
            RowBox[{"1.73326", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "12"}]}]}], ",", 
            RowBox[{"2.81469", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "13"}]}]}], ",", 
            RowBox[{"5.13987", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "14"}]}]}], ",", 
            RowBox[{"1.04617", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "14"}]}]}], ",", 
            RowBox[{"2.35623", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "15"}]}]}], ",", 
            RowBox[{"5.83654", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "16"}]}]}], ",", 
            RowBox[{"1.58187", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "16"}]}]}], ",", 
            RowBox[{"4.67027", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "17"}]}]}], ",", 
            RowBox[{"1.4963", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "17"}]}]}], ",", 
            RowBox[{"5.1852", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "18"}]}]}], ",", 
            RowBox[{"1.9379", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "18"}]}]}], ",", 
            RowBox[{"7.79157", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "19"}]}]}], ",", 
            RowBox[{"3.36268", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "19"}]}]}], ",", 
            RowBox[{"1.55479", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "19"}]}]}], ",", 
            RowBox[{"7.6885", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"4.06022", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"2.28679", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"1.37207", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"8.76144", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"5.94913", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"4.29241", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"3.28899", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"2.67504", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"2.3086", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"2.11351", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"2.05224", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"2.11351", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"2.3086", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"2.67504", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"3.28899", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"4.29241", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"5.94913", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"8.76144", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"1.37207", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"2.28679", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"4.06022", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"7.6885", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"1.55479", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "19"}]}]}], ",", 
            RowBox[{"3.36268", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "19"}]}]}], ",", 
            RowBox[{"7.79157", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "19"}]}]}], ",", 
            RowBox[{"1.9379", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "18"}]}]}], ",", 
            RowBox[{"5.1852", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "18"}]}]}], ",", 
            RowBox[{"1.4963", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "17"}]}]}], ",", 
            RowBox[{"4.67027", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "17"}]}]}], ",", 
            RowBox[{"1.58187", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "16"}]}]}], ",", 
            RowBox[{"5.83654", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "16"}]}]}], ",", 
            RowBox[{"2.35623", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "15"}]}]}], ",", 
            RowBox[{"1.04617", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "14"}]}]}], ",", 
            RowBox[{"5.13987", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "14"}]}]}], ",", 
            RowBox[{"2.81469", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "13"}]}]}], ",", 
            RowBox[{"1.73326", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "12"}]}]}], ",", 
            RowBox[{"1.21328", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "11"}]}]}], ",", 
            RowBox[{"9.78712", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "11"}]}]}], ",", 
            RowBox[{"9.26012", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "10"}]}]}], ",", 
            RowBox[{"1.05229", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "08"}]}]}], ",", 
            RowBox[{"1.48489", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "07"}]}]}], ",", 
            RowBox[{"2.73644", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "06"}]}]}], ",", 
            RowBox[{"7.16949", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "05"}]}]}], ",", "0.00317847", ",", "0.429094"}],
           "}"}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"mpfIsc2", "=", 
        RowBox[{"{", 
          RowBox[{"0.429094", ",", "0.00317847", ",", 
            RowBox[{"7.16949", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "05"}]}]}], ",", 
            RowBox[{"2.73644", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "06"}]}]}], ",", 
            RowBox[{"1.48489", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "07"}]}]}], ",", 
            RowBox[{"1.05229", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "08"}]}]}], ",", 
            RowBox[{"9.26012", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "10"}]}]}], ",", 
            RowBox[{"9.78712", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "11"}]}]}], ",", 
            RowBox[{"1.21328", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "11"}]}]}], ",", 
            RowBox[{"1.73326", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "12"}]}]}], ",", 
            RowBox[{"2.81469", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "13"}]}]}], ",", 
            RowBox[{"5.13987", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "14"}]}]}], ",", 
            RowBox[{"1.04617", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "14"}]}]}], ",", 
            RowBox[{"2.35623", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "15"}]}]}], ",", 
            RowBox[{"5.83654", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "16"}]}]}], ",", 
            RowBox[{"1.58187", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "16"}]}]}], ",", 
            RowBox[{"4.67027", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "17"}]}]}], ",", 
            RowBox[{"1.4963", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "17"}]}]}], ",", 
            RowBox[{"5.1852", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "18"}]}]}], ",", 
            RowBox[{"1.9379", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "18"}]}]}], ",", 
            RowBox[{"7.79157", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "19"}]}]}], ",", 
            RowBox[{"3.36268", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "19"}]}]}], ",", 
            RowBox[{"1.55479", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "19"}]}]}], ",", 
            RowBox[{"7.6885", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"4.06022", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"2.28679", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"1.37207", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"8.76144", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"5.94913", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"4.29241", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"3.28899", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"2.67504", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"2.3086", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"2.11351", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"2.05224", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"2.11351", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"2.3086", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"2.67504", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"3.28899", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"4.29241", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"5.94913", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"8.76144", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"1.37207", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"2.28679", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"4.06022", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"7.6885", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"1.55479", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "19"}]}]}], ",", 
            RowBox[{"3.36268", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "19"}]}]}], ",", 
            RowBox[{"7.79157", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "19"}]}]}], ",", 
            RowBox[{"1.9379", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "18"}]}]}], ",", 
            RowBox[{"5.1852", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "18"}]}]}], ",", 
            RowBox[{"1.4963", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "17"}]}]}], ",", 
            RowBox[{"4.67027", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "17"}]}]}], ",", 
            RowBox[{"1.58187", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "16"}]}]}], ",", 
            RowBox[{"5.83654", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "16"}]}]}], ",", 
            RowBox[{"2.35623", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "15"}]}]}], ",", 
            RowBox[{"1.04617", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "14"}]}]}], ",", 
            RowBox[{"5.13987", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "14"}]}]}], ",", 
            RowBox[{"2.81469", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "13"}]}]}], ",", 
            RowBox[{"1.73326", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "12"}]}]}], ",", 
            RowBox[{"1.21328", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "11"}]}]}], ",", 
            RowBox[{"9.78712", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "11"}]}]}], ",", 
            RowBox[{"9.26012", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "10"}]}]}], ",", 
            RowBox[{"1.05229", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "08"}]}]}], ",", 
            RowBox[{"1.48489", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "07"}]}]}], ",", 
            RowBox[{"2.73644", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "06"}]}]}], ",", 
            RowBox[{"7.16949", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "05"}]}]}], ",", "0.00317847", ",", "0.429094"}],
           "}"}]}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"longdoubl", "*", 
        RowBox[{"10", "^", "Isc2"}]}], "-", "mpfIsc2"}]], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
      "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", 
        "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
        ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", 
        "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
        ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", 
        "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
        ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", 
        "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
        ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", 
        "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
        ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", 
        "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
        ",", "0.`", ",", "0.`"}], "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"longdoubl", "*", "10"}], "^=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"8.86379", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "220"}]}], "I"}], ",", 
            RowBox[{"8.86379", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "220"}]}], "I"}], ",", 
            RowBox[{"8.86379", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "220"}]}], "I"}], ",", 
            RowBox[{"8.86379", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "220"}]}], "I"}], ",", 
            RowBox[{"1.61834", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "210"}]}], "I"}], ",", 
            RowBox[{"1.61834", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "210"}]}], "I"}], ",", 
            RowBox[{"1.61834", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "210"}]}], "I"}], ",", 
            RowBox[{"1.61834", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "210"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"1.03951", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "180"}]}], "I"}], ",", 
            RowBox[{"1.03951", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "180"}]}], "I"}], ",", 
            RowBox[{"1.03951", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "180"}]}], "I"}], ",", 
            RowBox[{"1.03951", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "180"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.81233"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "190"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.81233"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "190"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.81233"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "190"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.81233"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "190"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"6.54914", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "160"}]}], "I"}], ",", 
            RowBox[{"6.54914", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "160"}]}], "I"}], ",", 
            RowBox[{"6.54914", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "160"}]}], "I"}], ",", 
            RowBox[{"6.54914", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "6.60654"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "6.60654"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "6.60654"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "6.60654"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "160"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.00386"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.00386"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.00386"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.00386"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "120"}]}], "I"}], ",", 
            RowBox[{"1.17389", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "120"}]}], "I"}], ",", 
            RowBox[{"1.17389", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "120"}]}], "I"}], ",", 
            RowBox[{"1.17389", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "120"}]}], "I"}], ",", 
            RowBox[{"1.17389", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "120"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"3.97202", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "100"}]}], "I"}], ",", 
            RowBox[{"3.97202", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "100"}]}], "I"}], ",", 
            RowBox[{"3.97202", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "100"}]}], "I"}], ",", 
            RowBox[{"3.97202", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "100"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "4.70159"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "100"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "4.70159"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "100"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "4.70159"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "100"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "4.70159"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "100"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.0393"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "080"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.0393"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "080"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.0393"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "080"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.0393"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "080"}]}], "I"}], ",", 
            RowBox[{"9.40306", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "080"}]}], "I"}], ",", 
            RowBox[{"9.40306", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "080"}]}], "I"}], ",", 
            RowBox[{"9.40306", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "080"}]}], "I"}], ",", 
            RowBox[{"9.40306", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "080"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"1.00468", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "050"}]}], "I"}], ",", 
            RowBox[{"1.00468", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "050"}]}], "I"}], ",", 
            RowBox[{"1.00468", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "050"}]}], "I"}], ",", 
            RowBox[{"1.00468", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "050"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.15246"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "050"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.15246"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "050"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.15246"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "050"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.15246"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "050"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "0.0008538150"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "0.0008538150"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "0.0008538150"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "0.0008538150"}], "I"}], ",", 
            RowBox[{"0.0009591490", "I"}], ",", 
            RowBox[{"0.0009591490", "I"}], ",", 
            RowBox[{"0.0009591490", "I"}], ",", 
            RowBox[{"0.0009591490", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"0.05243570", "I"}], ",", 
            RowBox[{"0.05243570", "I"}], ",", 
            RowBox[{"0.05243570", "I"}], ",", 
            RowBox[{"0.05243570", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "0.05772770"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "0.05772770"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "0.05772770"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "0.05772770"}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.426810"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.426810"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.426810"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.426810"}], "I"}], ",", 
            RowBox[{"2.621770", "I"}], ",", 
            RowBox[{"2.621770", "I"}], ",", 
            RowBox[{"2.621770", "I"}], ",", 
            RowBox[{"2.621770", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"87.26420", "I"}], ",", 
            RowBox[{"87.26420", "I"}], ",", 
            RowBox[{"87.26420", "I"}], ",", 
            RowBox[{"87.26420", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "92.63150"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "92.63150"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "92.63150"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "92.63150"}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2494.630"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2494.630"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2494.630"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2494.630"}], "I"}], ",", 
            RowBox[{"2604.820", "I"}], ",", 
            RowBox[{"2604.820", "I"}], ",", 
            RowBox[{"2604.820", "I"}], ",", 
            RowBox[{"2604.820", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"57716.10", "I"}], ",", 
            RowBox[{"57716.10", "I"}], ",", 
            RowBox[{"57716.10", "I"}], ",", 
            RowBox[{"57716.10", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "59334.40"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "59334.40"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "59334.40"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "59334.40"}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.09618"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "060"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.09618"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "060"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.09618"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "060"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.09618"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "060"}]}], "I"}], ",", 
            RowBox[{"1.11028", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "060"}]}], "I"}], ",", 
            RowBox[{"1.11028", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "060"}]}], "I"}], ",", 
            RowBox[{"1.11028", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "060"}]}], "I"}], ",", 
            RowBox[{"1.11028", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "060"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"1.72897", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "070"}]}], "I"}], ",", 
            RowBox[{"1.72897", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "070"}]}], "I"}], ",", 
            RowBox[{"1.72897", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "070"}]}], "I"}], ",", 
            RowBox[{"1.72897", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "070"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.72633"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "070"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.72633"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "070"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.72633"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "070"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.72633"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "070"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.28666"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "080"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.28666"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "080"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.28666"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "080"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.28666"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "080"}]}], "I"}], ",", 
            RowBox[{"2.25176", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "080"}]}], "I"}], ",", 
            RowBox[{"2.25176", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "080"}]}], "I"}], ",", 
            RowBox[{"2.25176", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "080"}]}], "I"}], ",", 
            RowBox[{"2.25176", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "080"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"2.55663", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "090"}]}], "I"}], ",", 
            RowBox[{"2.55663", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "090"}]}], "I"}], ",", 
            RowBox[{"2.55663", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "090"}]}], "I"}], ",", 
            RowBox[{"2.55663", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "090"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.48393"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "090"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.48393"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "090"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.48393"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "090"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.48393"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "090"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.43347"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "100"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.43347"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "100"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.43347"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "100"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.43347"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "100"}]}], "I"}], ",", 
            RowBox[{"2.33346", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "100"}]}], "I"}], ",", 
            RowBox[{"2.33346", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "100"}]}], "I"}], ",", 
            RowBox[{"2.33346", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "100"}]}], "I"}], ",", 
            RowBox[{"2.33346", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "100"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"1.98387", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "110"}]}], "I"}], ",", 
            RowBox[{"1.98387", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "110"}]}], "I"}], ",", 
            RowBox[{"1.98387", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "110"}]}], "I"}], ",", 
            RowBox[{"1.98387", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "110"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.87818"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "110"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.87818"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "110"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.87818"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "110"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.87818"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "110"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.39263"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.39263"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.39263"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.39263"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"1.30213", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"1.30213", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"1.30213", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"1.30213", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"8.45705", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"8.45705", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"8.45705", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"8.45705", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "7.81245"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "7.81245"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "7.81245"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "7.81245"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "4.46117"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "130"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "4.46117"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "130"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "4.46117"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "130"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "4.46117"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "130"}]}], "I"}], ",", 
            RowBox[{"4.07308", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "130"}]}], "I"}], ",", 
            RowBox[{"4.07308", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "130"}]}], "I"}], ",", 
            RowBox[{"4.07308", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "130"}]}], "I"}], ",", 
            RowBox[{"4.07308", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "130"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"2.05162", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"2.05162", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"2.05162", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"2.05162", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.85203"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.85203"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.85203"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.85203"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.25188"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.25188"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.25188"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.25188"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"7.36807", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"7.36807", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"7.36807", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"7.36807", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"2.91093", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"2.91093", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"2.91093", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"2.91093", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.57199"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.57199"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.57199"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.57199"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "9.02809"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "9.02809"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "9.02809"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "9.02809"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"7.89702", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"7.89702", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"7.89702", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"7.89702", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"2.467", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"2.467", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"2.467", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"2.467", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.1373"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.1373"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.1373"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.1373"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "5.95033"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "5.95033"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "5.95033"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "5.95033"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"5.10825", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"5.10825", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"5.10825", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"5.10825", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"1.26876", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"1.26876", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"1.26876", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"1.26876", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.07983"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.07983"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.07983"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.07983"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.39465"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.39465"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.39465"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.39465"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"2.02146", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"2.02146", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"2.02146", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"2.02146", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"4.00469", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"4.00469", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"4.00469", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"4.00469", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "3.35462"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "3.35462"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "3.35462"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "3.35462"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "5.93877"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "5.93877"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "5.93877"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "5.93877"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"4.93884", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"4.93884", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"4.93884", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"4.93884", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"7.81373", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"7.81373", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"7.81373", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"7.81373", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "6.45407"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "6.45407"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "6.45407"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "6.45407"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "9.124"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "9.124"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "9.124"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "9.124"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"7.48843", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"7.48843", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"7.48843", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"7.48843", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"9.45593", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"9.45593", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"9.45593", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"9.45593", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "7.71453"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "7.71453"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "7.71453"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "7.71453"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"mpfajj", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"8.86379", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "220"}]}], "I"}], ",", 
            RowBox[{"8.86379", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "220"}]}], "I"}], ",", 
            RowBox[{"8.86379", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "220"}]}], "I"}], ",", 
            RowBox[{"8.86379", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "220"}]}], "I"}], ",", 
            RowBox[{"1.61834", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "210"}]}], "I"}], ",", 
            RowBox[{"1.61834", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "210"}]}], "I"}], ",", 
            RowBox[{"1.61834", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "210"}]}], "I"}], ",", 
            RowBox[{"1.61834", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "210"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"1.03951", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "180"}]}], "I"}], ",", 
            RowBox[{"1.03951", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "180"}]}], "I"}], ",", 
            RowBox[{"1.03951", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "180"}]}], "I"}], ",", 
            RowBox[{"1.03951", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "180"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.81233"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "190"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.81233"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "190"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.81233"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "190"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.81233"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "190"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"6.54914", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "160"}]}], "I"}], ",", 
            RowBox[{"6.54914", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "160"}]}], "I"}], ",", 
            RowBox[{"6.54914", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "160"}]}], "I"}], ",", 
            RowBox[{"6.54914", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "6.60654"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "6.60654"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "6.60654"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "6.60654"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "160"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.00386"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.00386"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.00386"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.00386"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "120"}]}], "I"}], ",", 
            RowBox[{"1.17389", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "120"}]}], "I"}], ",", 
            RowBox[{"1.17389", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "120"}]}], "I"}], ",", 
            RowBox[{"1.17389", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "120"}]}], "I"}], ",", 
            RowBox[{"1.17389", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "120"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"3.97202", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "100"}]}], "I"}], ",", 
            RowBox[{"3.97202", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "100"}]}], "I"}], ",", 
            RowBox[{"3.97202", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "100"}]}], "I"}], ",", 
            RowBox[{"3.97202", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "100"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "4.70159"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "100"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "4.70159"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "100"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "4.70159"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "100"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "4.70159"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "100"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.0393"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "080"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.0393"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "080"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.0393"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "080"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.0393"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "080"}]}], "I"}], ",", 
            RowBox[{"9.40306", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "080"}]}], "I"}], ",", 
            RowBox[{"9.40306", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "080"}]}], "I"}], ",", 
            RowBox[{"9.40306", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "080"}]}], "I"}], ",", 
            RowBox[{"9.40306", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "080"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"1.00468", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "050"}]}], "I"}], ",", 
            RowBox[{"1.00468", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "050"}]}], "I"}], ",", 
            RowBox[{"1.00468", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "050"}]}], "I"}], ",", 
            RowBox[{"1.00468", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "050"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.15246"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "050"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.15246"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "050"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.15246"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "050"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.15246"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "050"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "0.0008538150"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "0.0008538150"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "0.0008538150"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "0.0008538150"}], "I"}], ",", 
            RowBox[{"0.0009591490", "I"}], ",", 
            RowBox[{"0.0009591490", "I"}], ",", 
            RowBox[{"0.0009591490", "I"}], ",", 
            RowBox[{"0.0009591490", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"0.05243570", "I"}], ",", 
            RowBox[{"0.05243570", "I"}], ",", 
            RowBox[{"0.05243570", "I"}], ",", 
            RowBox[{"0.05243570", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "0.05772770"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "0.05772770"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "0.05772770"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "0.05772770"}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.426810"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.426810"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.426810"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.426810"}], "I"}], ",", 
            RowBox[{"2.621770", "I"}], ",", 
            RowBox[{"2.621770", "I"}], ",", 
            RowBox[{"2.621770", "I"}], ",", 
            RowBox[{"2.621770", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"87.26420", "I"}], ",", 
            RowBox[{"87.26420", "I"}], ",", 
            RowBox[{"87.26420", "I"}], ",", 
            RowBox[{"87.26420", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "92.63150"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "92.63150"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "92.63150"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "92.63150"}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2494.630"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2494.630"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2494.630"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2494.630"}], "I"}], ",", 
            RowBox[{"2604.820", "I"}], ",", 
            RowBox[{"2604.820", "I"}], ",", 
            RowBox[{"2604.820", "I"}], ",", 
            RowBox[{"2604.820", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"57716.10", "I"}], ",", 
            RowBox[{"57716.10", "I"}], ",", 
            RowBox[{"57716.10", "I"}], ",", 
            RowBox[{"57716.10", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "59334.40"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "59334.40"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "59334.40"}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "59334.40"}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.09618"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "060"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.09618"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "060"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.09618"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "060"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.09618"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "060"}]}], "I"}], ",", 
            RowBox[{"1.11028", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "060"}]}], "I"}], ",", 
            RowBox[{"1.11028", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "060"}]}], "I"}], ",", 
            RowBox[{"1.11028", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "060"}]}], "I"}], ",", 
            RowBox[{"1.11028", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "060"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"1.72897", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "070"}]}], "I"}], ",", 
            RowBox[{"1.72897", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "070"}]}], "I"}], ",", 
            RowBox[{"1.72897", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "070"}]}], "I"}], ",", 
            RowBox[{"1.72897", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "070"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.72633"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "070"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.72633"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "070"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.72633"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "070"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.72633"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "070"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.28666"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "080"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.28666"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "080"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.28666"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "080"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.28666"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "080"}]}], "I"}], ",", 
            RowBox[{"2.25176", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "080"}]}], "I"}], ",", 
            RowBox[{"2.25176", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "080"}]}], "I"}], ",", 
            RowBox[{"2.25176", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "080"}]}], "I"}], ",", 
            RowBox[{"2.25176", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "080"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"2.55663", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "090"}]}], "I"}], ",", 
            RowBox[{"2.55663", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "090"}]}], "I"}], ",", 
            RowBox[{"2.55663", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "090"}]}], "I"}], ",", 
            RowBox[{"2.55663", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "090"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.48393"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "090"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.48393"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "090"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.48393"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "090"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.48393"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "090"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.43347"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "100"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.43347"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "100"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.43347"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "100"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.43347"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "100"}]}], "I"}], ",", 
            RowBox[{"2.33346", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "100"}]}], "I"}], ",", 
            RowBox[{"2.33346", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "100"}]}], "I"}], ",", 
            RowBox[{"2.33346", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "100"}]}], "I"}], ",", 
            RowBox[{"2.33346", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "100"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"1.98387", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "110"}]}], "I"}], ",", 
            RowBox[{"1.98387", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "110"}]}], "I"}], ",", 
            RowBox[{"1.98387", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "110"}]}], "I"}], ",", 
            RowBox[{"1.98387", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "110"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.87818"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "110"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.87818"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "110"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.87818"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "110"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.87818"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "110"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.39263"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.39263"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.39263"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.39263"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"1.30213", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"1.30213", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"1.30213", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"1.30213", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"8.45705", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"8.45705", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"8.45705", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"8.45705", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "7.81245"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "7.81245"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "7.81245"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "7.81245"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "120"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "4.46117"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "130"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "4.46117"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "130"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "4.46117"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "130"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "4.46117"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "130"}]}], "I"}], ",", 
            RowBox[{"4.07308", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "130"}]}], "I"}], ",", 
            RowBox[{"4.07308", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "130"}]}], "I"}], ",", 
            RowBox[{"4.07308", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "130"}]}], "I"}], ",", 
            RowBox[{"4.07308", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "130"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"2.05162", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"2.05162", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"2.05162", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"2.05162", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.85203"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.85203"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.85203"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.85203"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.25188"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.25188"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.25188"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "8.25188"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"7.36807", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"7.36807", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"7.36807", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"7.36807", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "140"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"2.91093", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"2.91093", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"2.91093", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"2.91093", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.57199"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.57199"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.57199"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.57199"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "9.02809"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "9.02809"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "9.02809"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "9.02809"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"7.89702", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"7.89702", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"7.89702", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"7.89702", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "150"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"2.467", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"2.467", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"2.467", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"2.467", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.1373"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.1373"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.1373"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.1373"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "5.95033"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "5.95033"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "5.95033"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "5.95033"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"5.10825", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"5.10825", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"5.10825", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"5.10825", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "160"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"1.26876", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"1.26876", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"1.26876", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"1.26876", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.07983"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.07983"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.07983"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "1.07983"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.39465"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.39465"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.39465"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "2.39465"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"2.02146", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"2.02146", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"2.02146", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"2.02146", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"4.00469", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"4.00469", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"4.00469", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"4.00469", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "3.35462"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "3.35462"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "3.35462"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "3.35462"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "5.93877"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "5.93877"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "5.93877"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "5.93877"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"4.93884", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"4.93884", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"4.93884", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"4.93884", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"7.81373", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"7.81373", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"7.81373", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"7.81373", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "6.45407"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "6.45407"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "6.45407"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "6.45407"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{
              RowBox[{"-", "9.124"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "9.124"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "9.124"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "9.124"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"7.48843", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"7.48843", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"7.48843", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"7.48843", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"00", "I"}], ",", 
            RowBox[{"9.45593", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"9.45593", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"9.45593", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{"9.45593", "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "7.71453"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "7.71453"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "7.71453"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}], ",", 
            RowBox[{
              RowBox[{"-", "7.71453"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"+", "170"}]}], "I"}]}], "}"}]}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"longdoubl", "*", 
      RowBox[{"10", "^", 
        RowBox[{"-", "mpfajj"}]}]}]], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", "0", ",", "0", ",", "0", 
        ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}], ",", 
        RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"tmpqqq2A", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"3.80339", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "22"}]}]}], ",", 
            RowBox[{"3.30404", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"4.6954", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "2.74701"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "18"}]}]}], ",", 
            RowBox[{"5.89802", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "17"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "8.45965"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "16"}]}]}], ",", 
            RowBox[{"9.30347", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "15"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "8.35639"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "14"}]}]}], ",", 
            RowBox[{"6.36191", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "13"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "4.20629"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "12"}]}]}], ",", 
            RowBox[{"2.45621", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "11"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "1.28221"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "10"}]}]}], ",", 
            RowBox[{"6.03807", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "10"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "2.58284"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "09"}]}]}], ",", 
            RowBox[{"1.00912", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "08"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "3.61719"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "08"}]}]}], ",", 
            RowBox[{"1.19401", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "07"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "3.6412"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "07"}]}]}], ",", 
            RowBox[{"1.02868", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "06"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "2.69878"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "06"}]}]}], ",", 
            RowBox[{"6.58937", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "06"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "1.50015"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "05"}]}]}], ",", 
            RowBox[{"3.18984", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "05"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "6.34446"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "05"}]}]}], ",", "0.00011819", ",", 
            RowBox[{"-", "0.000206453"}], ",", "0.00033849", ",", 
            RowBox[{"-", "0.000521334"}], ",", "0.000754804", ",", 
            RowBox[{"-", "0.00102788"}], ",", "0.00131714", ",", 
            RowBox[{"-", "0.00158865"}], ",", "0.00180388", ",", 
            RowBox[{"-", "0.00192836"}], ",", "0.00194059", ",", 
            RowBox[{"-", "0.00183797"}], ",", "0.0016377", ",", 
            RowBox[{"-", "0.00137207"}], ",", "0.00108003", ",", 
            RowBox[{"-", "0.000797948"}], ",", "0.000552638", ",", 
            RowBox[{"-", "0.000358195"}], ",", "0.000216817", ",", 
            RowBox[{"-", "0.000122228"}], ",", 
            RowBox[{"6.39391", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "05"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "3.08819"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "05"}]}]}], ",", 
            RowBox[{"1.36727", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "05"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "5.48797"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "06"}]}]}], ",", 
            RowBox[{"1.95995", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "06"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "6.0036"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "07"}]}]}], ",", 
            RowBox[{"1.43751", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "07"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "1.74963"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "08"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "6.44515"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "09"}]}]}], ",", 
            RowBox[{"6.06903", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "09"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "2.97525"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "09"}]}]}], ",", 
            RowBox[{"1.12768", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "09"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "3.58966"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "10"}]}]}], ",", 
            RowBox[{"9.87256", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "11"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "2.36939"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "11"}]}]}], ",", 
            RowBox[{"4.96818", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "12"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "9.06214"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "13"}]}]}], ",", 
            RowBox[{"1.42516", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "13"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "1.90609"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "14"}]}]}], ",", 
            RowBox[{"2.12576", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "15"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "1.92133"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "16"}]}]}], ",", 
            RowBox[{"1.34918", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "17"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "6.94174"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "19"}]}]}], ",", 
            RowBox[{"2.6153", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"1.7044", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "22"}]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmpqqq2B", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"3.8034", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "22"}]}]}], ",", 
            RowBox[{"3.30405", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "21"}]}]}], ",", 
            RowBox[{"4.6954", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "2.747"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "18"}]}]}], ",", 
            RowBox[{"5.89801", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "17"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "8.45967"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "16"}]}]}], ",", 
            RowBox[{"9.30346", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "15"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "8.35639"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "14"}]}]}], ",", 
            RowBox[{"6.36192", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "13"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "4.20629"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "12"}]}]}], ",", 
            RowBox[{"2.45622", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "11"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "1.28221"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "10"}]}]}], ",", 
            RowBox[{"6.03809", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "10"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "2.58285"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "09"}]}]}], ",", 
            RowBox[{"1.00912", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "08"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "3.6172"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "08"}]}]}], ",", 
            RowBox[{"1.19402", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "07"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "3.6412"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "07"}]}]}], ",", 
            RowBox[{"1.02868", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "06"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "2.69878"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "06"}]}]}], ",", 
            RowBox[{"6.58937", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "06"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "1.50015"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "05"}]}]}], ",", 
            RowBox[{"3.18984", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "05"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "6.34446"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "05"}]}]}], ",", "0.00011819", ",", 
            RowBox[{"-", "0.000206453"}], ",", "0.00033849", ",", 
            RowBox[{"-", "0.000521335"}], ",", "0.000754802", ",", 
            RowBox[{"-", "0.00102788"}], ",", "0.00131714", ",", 
            RowBox[{"-", "0.00158864"}], ",", "0.00180388", ",", 
            RowBox[{"-", "0.00192837"}], ",", "0.00194058", ",", 
            RowBox[{"-", "0.00183797"}], ",", "0.0016377", ",", 
            RowBox[{"-", "0.00137207"}], ",", "0.00108003", ",", 
            RowBox[{"-", "0.00079795"}], ",", "0.000552638", ",", 
            RowBox[{"-", "0.000358195"}], ",", "0.000216816", ",", 
            RowBox[{"-", "0.000122228"}], ",", 
            RowBox[{"6.39391", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "05"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "3.08819"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "05"}]}]}], ",", 
            RowBox[{"1.36727", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "05"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "5.48796"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "06"}]}]}], ",", 
            RowBox[{"1.95995", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "06"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "6.00359"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "07"}]}]}], ",", 
            RowBox[{"1.43751", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "07"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "1.74962"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "08"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "6.44516"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "09"}]}]}], ",", 
            RowBox[{"6.06903", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "09"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "2.97525"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "09"}]}]}], ",", 
            RowBox[{"1.12768", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "09"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "3.58967"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "10"}]}]}], ",", 
            RowBox[{"9.87256", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "11"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "2.36939"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "11"}]}]}], ",", 
            RowBox[{"4.9682", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "12"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "9.06216"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "13"}]}]}], ",", 
            RowBox[{"1.42516", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "13"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "1.90609"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "14"}]}]}], ",", 
            RowBox[{"2.12577", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "15"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "1.92133"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "16"}]}]}], ",", 
            RowBox[{"1.34918", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "17"}]}]}], ",", 
            RowBox[{
              RowBox[{"-", "6.94174"}], "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "19"}]}]}], ",", 
            RowBox[{"2.6153", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "20"}]}]}], ",", 
            RowBox[{"1.7044", "*", 
              RowBox[{"10", "^", 
                RowBox[{"-", "22"}]}]}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{"Plus", "@@", "tmpqqq2A"}], "\[IndentingNewLine]", 
    RowBox[{"Plus", "@@", "tmpqqq2B"}]}], "Input"],

Cell[BoxData["1.4955226018431467`*^-8"], "Output"],

Cell[BoxData[
    RowBox[{"-", "1.032792862748372`*^-9"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"(", 
        RowBox[{"tmpqqq2B", "-", "tmpqqq2A"}], ")"}], "/", 
      "tmpqqq2A"}]], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
      "2.629233394350125`*^-6", ",", "3.0265977409817923`*^-6", ",", "0.`", 
        ",", 
        RowBox[{"-", "3.6403216588674656`*^-6"}], ",", 
        RowBox[{"-", "1.6954842471595863`*^-6"}], ",", "2.3641640018643`*^-6",
         ",", 
        RowBox[{"-", "1.0748677645389334`*^-6"}], ",", "0.`", ",", 
        "1.5718549931882408`*^-6", ",", "0.`", ",", "4.0713131206031`*^-6", 
        ",", "0.`", ",", "3.312316684001936`*^-6", ",", 
        "3.871707113053457`*^-6", ",", "0.`", ",", "2.7645769231200834`*^-6", 
        ",", "8.375139236699307`*^-6", ",", "0.`", ",", "0.`", ",", "0.`", 
        ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", 
        "0.`", ",", "0.`", ",", "1.9181561149200806`*^-6", ",", 
        RowBox[{"-", "2.6496944902669974`*^-6"}], ",", "0.`", ",", "0.`", ",",
         
        RowBox[{"-", "6.294652692500307`*^-6"}], ",", "0.`", ",", 
        "5.185753697411589`*^-6", ",", 
        RowBox[{"-", "5.153072003956246`*^-6"}], ",", "0.`", ",", "0.`", ",", 
        "0.`", ",", "0.`", ",", "2.5064289902638645`*^-6", ",", "0.`", ",", 
        "0.`", ",", 
        RowBox[{"-", "4.6121844690026385`*^-6"}], ",", "0.`", ",", "0.`", ",",
         "0.`", ",", "0.`", ",", 
        RowBox[{"-", "1.8221673950487136`*^-6"}], ",", "0.`", ",", 
        RowBox[{"-", "1.665667266176502`*^-6"}], ",", "0.`", ",", 
        RowBox[{"-", "5.71549413297611`*^-6"}], ",", "1.551554269470686`*^-6",
         ",", "0.`", ",", "0.`", ",", "0.`", ",", "2.7857791545956404`*^-6", 
        ",", "0.`", ",", "0.`", ",", "4.025619039615351`*^-6", ",", 
        "2.2069842224295685`*^-6", ",", "0.`", ",", "0.`", ",", 
        "4.704199909760151`*^-6", ",", "0.`", ",", "0.`", ",", "0.`", ",", 
        "0.`", ",", "0.`"}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{"tmpqqq2Orig", "=", 
      RowBox[{"{", 
        RowBox[{
          RowBox[{"3.80339", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "22"}]}]}], ",", 
          RowBox[{"3.30404", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "21"}]}]}], ",", 
          RowBox[{"4.6954", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "20"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "2.74701"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "18"}]}]}], ",", 
          RowBox[{"5.89802", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "17"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "8.45965"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "16"}]}]}], ",", 
          RowBox[{"9.30347", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "15"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "8.35639"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "14"}]}]}], ",", 
          RowBox[{"6.36191", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "13"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "4.20629"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "12"}]}]}], ",", 
          RowBox[{"2.45621", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "11"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "1.28221"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "10"}]}]}], ",", 
          RowBox[{"6.03807", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "10"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "2.58284"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "09"}]}]}], ",", 
          RowBox[{"1.00912", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "08"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "3.61719"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "08"}]}]}], ",", 
          RowBox[{"1.19401", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "07"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "3.6412"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "07"}]}]}], ",", 
          RowBox[{"1.02868", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "06"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "2.69878"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "06"}]}]}], ",", 
          RowBox[{"6.58937", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "06"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "1.50015"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "05"}]}]}], ",", 
          RowBox[{"3.18984", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "05"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "6.34446"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "05"}]}]}], ",", "0.00011819", ",", 
          RowBox[{"-", "0.000206453"}], ",", "0.00033849", ",", 
          RowBox[{"-", "0.000521334"}], ",", "0.000754804", ",", 
          RowBox[{"-", "0.00102788"}], ",", "0.00131714", ",", 
          RowBox[{"-", "0.00158865"}], ",", "0.00180388", ",", 
          RowBox[{"-", "0.00192836"}], ",", "0.00194059", ",", 
          RowBox[{"-", "0.00183797"}], ",", "0.0016377", ",", 
          RowBox[{"-", "0.00137207"}], ",", "0.00108003", ",", 
          RowBox[{"-", "0.000797948"}], ",", "0.000552638", ",", 
          RowBox[{"-", "0.000358195"}], ",", "0.000216817", ",", 
          RowBox[{"-", "0.000122228"}], ",", 
          RowBox[{"6.39391", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "05"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "3.08819"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "05"}]}]}], ",", 
          RowBox[{"1.36727", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "05"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "5.48797"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "06"}]}]}], ",", 
          RowBox[{"1.95995", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "06"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "6.0036"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "07"}]}]}], ",", 
          RowBox[{"1.43751", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "07"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "1.74963"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "08"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "6.44515"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "09"}]}]}], ",", 
          RowBox[{"6.06903", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "09"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "2.97525"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "09"}]}]}], ",", 
          RowBox[{"1.12768", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "09"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "3.58966"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "10"}]}]}], ",", 
          RowBox[{"9.87256", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "11"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "2.36939"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "11"}]}]}], ",", 
          RowBox[{"4.96818", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "12"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "9.06214"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "13"}]}]}], ",", 
          RowBox[{"1.42516", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "13"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "1.90609"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "14"}]}]}], ",", 
          RowBox[{"2.12576", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "15"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "1.92133"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "16"}]}]}], ",", 
          RowBox[{"1.34918", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "17"}]}]}], ",", 
          RowBox[{
            RowBox[{"-", "6.94174"}], "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "19"}]}]}], ",", 
          RowBox[{"2.6153", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "20"}]}]}], ",", 
          RowBox[{"1.7044", "*", 
            RowBox[{"10", "^", 
              RowBox[{"-", "22"}]}]}]}], "}"}]}], "\[IndentingNewLine]", 
    RowBox[{"Plus", "@@", "tmpqqq2Orig"}]}], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
      "3.80339`*^-22", ",", "3.30404`*^-21", ",", "4.6954000000000003`*^-20", 
        ",", 
        RowBox[{"-", "2.74701`*^-18"}], ",", "5.89802`*^-17", ",", 
        RowBox[{"-", "8.45965`*^-16"}], ",", "9.30347`*^-15", ",", 
        RowBox[{"-", "8.356389999999999`*^-14"}], ",", "6.36191`*^-13", ",", 
        RowBox[{"-", "4.20629`*^-12"}], ",", "2.45621`*^-11", ",", 
        RowBox[{"-", "1.28221`*^-10"}], ",", "6.03807`*^-10", ",", 
        RowBox[{"-", "2.58284`*^-9"}], ",", "1.00912`*^-8", ",", 
        RowBox[{"-", "3.6171899999999996`*^-8"}], ",", "1.19401`*^-7", ",", 
        RowBox[{"-", "3.6412`*^-7"}], ",", "1.02868`*^-6", ",", 
        RowBox[{"-", "2.69878`*^-6"}], ",", "6.5893699999999996`*^-6", ",", 
        RowBox[{"-", "0.0000150015`"}], ",", "0.0000318984`", ",", 
        RowBox[{"-", "0.0000634446`"}], ",", "0.00011819`", ",", 
        RowBox[{"-", "0.000206453`"}], ",", "0.00033849`", ",", 
        RowBox[{"-", "0.000521334`"}], ",", "0.000754804`", ",", 
        RowBox[{"-", "0.00102788`"}], ",", "0.00131714`", ",", 
        RowBox[{"-", "0.00158865`"}], ",", "0.00180388`", ",", 
        RowBox[{"-", "0.00192836`"}], ",", "0.00194059`", ",", 
        RowBox[{"-", "0.00183797`"}], ",", "0.0016377`", ",", 
        RowBox[{"-", "0.00137207`"}], ",", "0.00108003`", ",", 
        RowBox[{"-", "0.000797948`"}], ",", "0.000552638`", ",", 
        RowBox[{"-", "0.000358195`"}], ",", "0.000216817`", ",", 
        RowBox[{"-", "0.000122228`"}], ",", "0.0000639391`", ",", 
        RowBox[{"-", "0.0000308819`"}], ",", "0.0000136727`", ",", 
        RowBox[{"-", "5.487969999999999`*^-6"}], ",", "1.95995`*^-6", ",", 
        RowBox[{"-", "6.0036`*^-7"}], ",", "1.43751`*^-7", ",", 
        RowBox[{"-", "1.74963`*^-8"}], ",", 
        RowBox[{"-", "6.44515`*^-9"}], ",", "6.06903`*^-9", ",", 
        RowBox[{"-", "2.97525`*^-9"}], ",", "1.12768`*^-9", ",", 
        RowBox[{"-", "3.5896599999999997`*^-10"}], ",", "9.87256`*^-11", ",", 
        
        RowBox[{"-", "2.36939`*^-11"}], ",", "4.96818`*^-12", ",", 
        RowBox[{"-", "9.062139999999999`*^-13"}], ",", "1.42516`*^-13", ",", 
        RowBox[{"-", "1.9060900000000002`*^-14"}], ",", "2.12576`*^-15", ",", 
        
        RowBox[{"-", "1.92133`*^-16"}], ",", "1.3491800000000001`*^-17", ",", 
        
        RowBox[{"-", "6.94174`*^-19"}], ",", "2.6153`*^-20", ",", 
        "1.7044`*^-22"}], "}"}]], "Output"],

Cell[BoxData["1.4955226018431467`*^-8"], "Output"]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
WindowSize->{1012, 740},
WindowMargins->{{0, Automatic}, {Automatic, 0}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 15795, 402, 331, "Input"],

Cell[CellGroupData[{
Cell[17537, 455, 126, 3, 27, "Input"],
Cell[17666, 460, 1003, 15, 43, "Output"]
}, Open  ]],
Cell[18684, 478, 91562, 2314, 1899, "Input"],

Cell[CellGroupData[{
Cell[110271, 2796, 117, 3, 27, "Input"],
Cell[110391, 2801, 17926, 316, 315, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[128354, 3122, 14650, 372, 395, "Input"],
Cell[143007, 3496, 50, 0, 29, "Output"],
Cell[143060, 3498, 69, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[143166, 3504, 136, 4, 27, "Input"],
Cell[143305, 3510, 1818, 31, 101, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[145160, 3546, 6941, 184, 187, "Input"],
Cell[152104, 3732, 2464, 41, 167, "Output"],
Cell[154571, 3775, 50, 0, 29, "Output"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

