(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     76860,       2088]*)
(*NotebookOutlinePosition[     77518,       2112]*)
(*  CellTagsIndexPosition[     77474,       2108]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["\<\
This file contains some auxiliary calculations that were used to \
calculate some testing data.\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"adj", "[", "x_", "]"}], ":=", 
        RowBox[{"Transpose", "[", 
          RowBox[{"Conjugate", "[", "x", "]"}], "]"}]}], ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"terseForm", "[", "x_", "]"}], ":=", 
      RowBox[{"NumberForm", "[", 
        RowBox[{
          RowBox[{"MatrixForm", "[", 
            RowBox[{"Chop", "[", "x", "]"}], "]"}], ",", "2"}], "]"}], " ", 
      RowBox[{"(*", 
        RowBox[{
        "Nice", " ", "and", " ", "short", " ", "display", " ", "of", " ", 
          "matrices"}], "*)"}]}]], "Input"],

Cell[CellGroupData[{

Cell["Test 1", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"mm", "=", 
        RowBox[{"{", 
          RowBox[{"{", 
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{"0", ",", "1"}], "}"}]}], "}"}], "}"}]}], ";", 
      RowBox[{"\[Phi]", "=", 
        RowBox[{"\[Pi]", "/", "4"}]}], ";", 
      RowBox[{"u", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                RowBox[{"Cos", "[", "\[Phi]", "]"}], ",", 
                RowBox[{"I", " ", 
                  RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"I", " ", 
                  RowBox[{"Sin", "[", "\[Phi]", "]"}]}], ",", 
                RowBox[{"Cos", "[", "\[Phi]", "]"}]}], "}"}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{"u", "//", "MatrixForm"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"m", "=", 
        RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{"u", "//", "N"}]}], "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {
              FractionBox["1", 
                SqrtBox["2"]], 
              FractionBox["\[ImaginaryI]", 
                SqrtBox["2"]]},
            {
              FractionBox["\[ImaginaryI]", 
                SqrtBox["2"]], 
              FractionBox["1", 
                SqrtBox["2"]]}
            }], "\[NoBreak]", ")"}],
      (MatrixForm[ #]&)]], "Output"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"{", 
          RowBox[{"0.7071067811865476`", ",", 
            RowBox[{
              RowBox[{"0.`", "\[InvisibleSpace]"}], "+", 
              RowBox[{"0.7071067811865476`", " ", "\[ImaginaryI]"}]}]}], 
          "}"}], ",", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              RowBox[{"0.`", "\[InvisibleSpace]"}], "+", 
              RowBox[{"0.7071067811865476`", " ", "\[ImaginaryI]"}]}], ",", 
            "0.7071067811865476`"}], "}"}]}], "}"}]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test 2", "Subsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"isc2", "[", 
          RowBox[{"n_", ",", "m_"}], "]"}], ":=", 
        RowBox[{
          FractionBox["2", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{"n", "+", "m"}], ")"}], "!"}]], 
          RowBox[{"Gamma", "[", 
            RowBox[{"n", "+", 
              FractionBox["1", "2"]}], "]"}], 
          RowBox[{"Gamma", "[", 
            RowBox[{"m", "+", 
              FractionBox["1", "2"]}], "]"}]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"Table", "[", 
        RowBox[{
          RowBox[{"isc2", "[", 
            RowBox[{"q", ",", 
              RowBox[{"n0", "-", "q"}]}], "]"}], ",", 
          RowBox[{"{", 
            RowBox[{"n0", ",", "0", ",", "4"}], "}"}], ",", 
          RowBox[{"{", 
            RowBox[{"q", ",", "0", ",", "n0"}], "}"}]}], "]"}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{"NumberForm", "[", 
      RowBox[{
        RowBox[{"TableForm", "[", 
          RowBox[{"N", "[", "%", "]"}], "]"}], ",", "4"}], "]"}]}], "Input"],

Cell[BoxData[
    TagBox[
      InterpretationBox[GridBox[{
            {
              InterpretationBox["\<\"6.283\"\>",
                6.2831853071795862,
                
                AutoDelete->
                  True], "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
            {
              InterpretationBox["\<\"3.142\"\>",
                3.1415926535897931,
                AutoDelete->True], 
              InterpretationBox["\<\"3.142\"\>",
                3.1415926535897931,
                AutoDelete->True], "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
            {
              InterpretationBox["\<\"2.356\"\>",
                2.3561944901923448,
                AutoDelete->True], 
              InterpretationBox["\<\"0.7854\"\>",
                0.78539816339744828,
                AutoDelete->True], 
              InterpretationBox["\<\"2.356\"\>",
                2.3561944901923448,
                AutoDelete->True], "\<\"\"\>", "\<\"\"\>"},
            {
              InterpretationBox["\<\"1.963\"\>",
                1.9634954084936207,
                AutoDelete->True], 
              InterpretationBox["\<\"0.3927\"\>",
                0.39269908169872414,
                AutoDelete->True], 
              InterpretationBox["\<\"0.3927\"\>",
                0.39269908169872414,
                AutoDelete->True], 
              InterpretationBox["\<\"1.963\"\>",
                1.9634954084936207,
                AutoDelete->True], "\<\"\"\>"},
            {
              InterpretationBox["\<\"1.718\"\>",
                1.7180584824319181,
                AutoDelete->True], 
              InterpretationBox["\<\"0.2454\"\>",
                0.24543692606170259,
                AutoDelete->True], 
              InterpretationBox["\<\"0.1473\"\>",
                0.14726215563702155,
                AutoDelete->True], 
              InterpretationBox["\<\"0.2454\"\>",
                0.24543692606170259,
                AutoDelete->True], 
              InterpretationBox["\<\"1.718\"\>",
                1.7180584824319181,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        TableForm[ {{6.2831853071795862}, {3.1415926535897931, 
          3.1415926535897931}, {2.3561944901923448, 0.78539816339744828, 
          2.3561944901923448}, {1.9634954084936207, 0.39269908169872414, 
          0.39269908169872414, 1.9634954084936207}, {1.7180584824319181, 
          0.24543692606170259, 0.14726215563702155, 0.24543692606170259, 
          1.7180584824319181}}]],
      (NumberForm[ #, 4]&)]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"isc2it0", "[", "m_", "]"}], ":=", 
      RowBox[{"If", "[", 
        RowBox[{
          RowBox[{"m", "\[LessEqual]", "0"}], ",", 
          RowBox[{"2", "\[Pi]"}], ",", 
          RowBox[{
            FractionBox[
              RowBox[{
                RowBox[{"2", 
                  RowBox[{"(", 
                    RowBox[{"m", "-", "1"}], ")"}]}], "+", "1"}], 
              RowBox[{
                RowBox[{"2", 
                  RowBox[{"(", 
                    RowBox[{"m", "-", "1"}], ")"}]}], "+", "2"}]], 
            RowBox[{"isc2it0", "[", 
              RowBox[{"m", "-", "1"}], "]"}]}]}], 
        "]"}]}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"isc2it", "[", 
        RowBox[{"n_", ",", "m_"}], "]"}], ":=", 
      RowBox[{"If", "[", 
        RowBox[{
          RowBox[{"n", "\[LessEqual]", "0"}], ",", 
          RowBox[{"isc2", "[", 
            RowBox[{"0", ",", "m"}], "]"}], ",", 
          RowBox[{
            FractionBox[
              RowBox[{
                RowBox[{"2", 
                  RowBox[{"(", 
                    RowBox[{"n", "-", "1"}], ")"}]}], "+", "1"}], 
              RowBox[{
                RowBox[{"2", 
                  RowBox[{"(", 
                    RowBox[{"m", "+", "1"}], ")"}]}], "-", "1"}]], 
            RowBox[{"isc2it", "[", 
              RowBox[{
                RowBox[{"n", "-", "1"}], ",", 
                RowBox[{"m", "+", "1"}]}], "]"}]}]}], 
        "]"}]}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"isc2itN", "[", 
        RowBox[{"n_", ",", "m_"}], "]"}], ":=", 
      RowBox[{"If", "[", 
        RowBox[{
          RowBox[{"n", "\[LessEqual]", "0"}], ",", 
          RowBox[{"isc2", "[", 
            RowBox[{"0", ",", "m"}], "]"}], ",", 
          RowBox[{
            RowBox[{"N", "[", 
              FractionBox[
                RowBox[{
                  RowBox[{"2.0", 
                    RowBox[{"(", 
                      RowBox[{"n", "-", "1."}], ")"}]}], "+", "1.0"}], 
                RowBox[{
                  RowBox[{"2.0", 
                    RowBox[{"(", 
                      RowBox[{"m", "+", "1."}], ")"}]}], "-", "1.0"}]], "]"}],
             
            RowBox[{"isc2itN", "[", 
              RowBox[{
                RowBox[{"n", "-", "1"}], ",", 
                RowBox[{"m", "+", "1"}]}], "]"}]}]}], "]"}]}]}], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"General", "::", "\<\"spell1\"\>"}], 
      RowBox[{
      ":", " "}], "\<\"Possible spelling error: new symbol name \
\\\"\\!\\(isc2itN\\)\\\" is similar to existing symbol \
\\\"\\!\\(isc2it\\)\\\".\"\>"}]], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"nn0", "=", "99"}], ";", 
      RowBox[{"q", "=", "49"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"isc2", "[", 
          RowBox[{"q", ",", 
            RowBox[{"nn0", "-", "q"}]}], "]"}], "//", "N"}], "//", 
      "CForm"}]}], "Input"],

Cell["7.969470115145116e-31", "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test 3", "Subsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"a", "[", 
        RowBox[{"nn_", ",", "j_", ",", "k_", ",", "n_"}], "]"}], ":=", 
      RowBox[{"Block", "[", 
        RowBox[{
          RowBox[{"{", 
            RowBox[{"mmnn", "=", 
              RowBox[{"mm", "\[LeftDoubleBracket]", 
                RowBox[{
                  RowBox[{
                  "m", "\[LeftDoubleBracket]", "nn", 
                    "\[RightDoubleBracket]"}], "+", "1"}], 
                "\[RightDoubleBracket]"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
            RowBox[{
              RowBox[{"nn", "\[LessEqual]", "1"}], ",", 
              RowBox[{
                SubsuperscriptBox["\[Sum]", 
                  RowBox[{"p", "=", "0"}], "1"], 
                RowBox[{
                  RowBox[{"mmnn", "\[LeftDoubleBracket]", 
                    RowBox[{
                      RowBox[{"j", "+", "1"}], ",", 
                      RowBox[{"p", "+", "1"}]}], "\[RightDoubleBracket]"}], 
                  RowBox[{"Conjugate", "[", 
                    RowBox[{"mmnn", "\[LeftDoubleBracket]", 
                      RowBox[{
                        RowBox[{"k", "+", "1"}], ",", 
                        RowBox[{"p", "+", "1"}]}], "\[RightDoubleBracket]"}], 
                    "]"}]}]}], ",", "\[IndentingNewLine]", 
              RowBox[{
                SubsuperscriptBox["\[Sum]", 
                  RowBox[{"p", "=", "0"}], "1"], 
                RowBox[{
                  SubsuperscriptBox["\[Sum]", 
                    RowBox[{"q", "=", "0"}], "1"], 
                  RowBox[{"(", "\[IndentingNewLine]", 
                    RowBox[{
                      RowBox[{"If", "[", 
                        RowBox[{
                          RowBox[{"n", "\[GreaterEqual]", "2"}], ",", 
                          RowBox[{
                            RowBox[{"mmnn", "\[LeftDoubleBracket]", 
                              RowBox[{
                                RowBox[{"j", "+", "1"}], ",", 
                                RowBox[{"p", "+", "1"}]}], 
                              "\[RightDoubleBracket]"}], 
                            RowBox[{"Conjugate", "[", 
                              RowBox[{"mmnn", "\[LeftDoubleBracket]", 
                                RowBox[{
                                  RowBox[{"k", "+", "1"}], ",", 
                                  RowBox[{"q", "+", "1"}]}], 
                                "\[RightDoubleBracket]"}], "]"}], 
                            RowBox[{"a", "[", 
                              RowBox[{
                                RowBox[{"nn", "-", "1"}], ",", "p", ",", "q", 
                                ",", 
                                RowBox[{"n", "-", "2"}]}], "]"}]}], ",", 
                          "0"}], "]"}], "\[IndentingNewLine]", "+", 
                      RowBox[{"If", "[", 
                        RowBox[{
                          RowBox[{
                            RowBox[{"n", "\[GreaterEqual]", "1"}], "\[And]", 
                            RowBox[{"n", "\[LessEqual]", 
                              RowBox[{
                                RowBox[{"2", 
                                  RowBox[{"(", 
                                    RowBox[{"nn", "-", "1"}], ")"}]}], "-", 
                                "1"}]}]}], ",", 
                          RowBox[{"I", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  RowBox[{"mmnn", "\[LeftDoubleBracket]", 
                                    RowBox[{
                                      RowBox[{"j", "+", "1"}], ",", 
                                      RowBox[{"1", "-", "p", "+", "1"}]}], 
                                    "\[RightDoubleBracket]"}], 
                                  RowBox[{"Conjugate", "[", 
                                    RowBox[{"mmnn", "\[LeftDoubleBracket]", 
                                      RowBox[{
                                        RowBox[{"k", "+", "1"}], ",", 
                                        RowBox[{"q", "+", "1"}]}], 
                                      "\[RightDoubleBracket]"}], "]"}]}], "-",
                                 
                                RowBox[{
                                  RowBox[{"mmnn", "\[LeftDoubleBracket]", 
                                    RowBox[{
                                      RowBox[{"j", "+", "1"}], ",", 
                                      RowBox[{"p", "+", "1"}]}], 
                                    "\[RightDoubleBracket]"}], 
                                  RowBox[{"Conjugate", "[", 
                                    RowBox[{"mmnn", "\[LeftDoubleBracket]", 
                                      RowBox[{
                                        RowBox[{"k", "+", "1"}], ",", 
                                        RowBox[{"1", "-", "q", "+", "1"}]}], 
                                      "\[RightDoubleBracket]"}], "]"}]}]}], 
                              ")"}], 
                            RowBox[{"a", "[", 
                              RowBox[{
                                RowBox[{"nn", "-", "1"}], ",", "p", ",", "q", 
                                ",", 
                                RowBox[{"n", "-", "1"}]}], "]"}]}], ",", 
                          "0"}], "]"}], "\[IndentingNewLine]", "+", 
                      RowBox[{"If", "[", 
                        RowBox[{
                          RowBox[{"n", "\[LessEqual]", 
                            RowBox[{
                              RowBox[{"2", 
                                RowBox[{"(", 
                                  RowBox[{"nn", "-", "1"}], ")"}]}], "-", 
                              "2"}]}], ",", 
                          RowBox[{
                            RowBox[{"mmnn", "\[LeftDoubleBracket]", 
                              RowBox[{
                                RowBox[{"j", "+", "1"}], ",", 
                                RowBox[{"1", "-", "p", "+", "1"}]}], 
                              "\[RightDoubleBracket]"}], 
                            RowBox[{"Conjugate", "[", 
                              RowBox[{"mmnn", "\[LeftDoubleBracket]", 
                                RowBox[{
                                  RowBox[{"k", "+", "1"}], ",", 
                                  RowBox[{"1", "-", "q", "+", "1"}]}], 
                                "\[RightDoubleBracket]"}], "]"}], 
                            RowBox[{"a", "[", 
                              RowBox[{
                                RowBox[{"nn", "-", "1"}], ",", "p", ",", "q", 
                                ",", "n"}], "]"}]}], ",", "0"}], "]"}]}], 
                    ")"}]}]}]}], "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"aExpectedForm", "[", "x_", "]"}], ":=", 
        RowBox[{"CForm", "[", 
          RowBox[{"Flatten", "[", "x", "]"}], "]"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell["Test 3-1", "Subsubsection"],

Cell[BoxData[{
    RowBox[{
      RowBox[{"maxnn", "=", "4"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"mm", "=", 
        RowBox[{"{", 
          RowBox[{"{", 
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{"0", ",", "1"}], "}"}]}], "}"}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"m", "=", 
        RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
      ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{"Table", "[", 
      RowBox[{
        RowBox[{"a", "[", 
          RowBox[{"nn", ",", "j", ",", "k", ",", "n"}], "]"}], ",", 
        RowBox[{"{", 
          RowBox[{"nn", ",", "1", ",", "maxnn"}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{"n", ",", "0", ",", 
            RowBox[{"nn", "-", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{"j", ",", "0", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{"k", ",", "0", ",", "1"}], "}"}]}], 
      "]"}], "\[IndentingNewLine]", 
    RowBox[{"%", "//", "aExpectedForm"}]}], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"{", 
          RowBox[{"{", 
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{"0", ",", "1"}], "}"}]}], "}"}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", "2"}], "}"}]}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"3", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", "3"}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}], "}"}]}], 
      "}"}]], "Output"],

Cell["\<\
List(1,0,0,1,1,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,2,0,0,2,1,0,0,1,0,0,0,\
0,3,0,0,3,0,0,0,0)\
\>", "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test 3-2", "Subsubsection"],

Cell[BoxData[{
    RowBox[{
      RowBox[{"maxnn", "=", "4"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"mm", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{
                    SqrtBox["0.3"], ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", 
                    SqrtBox["0.7"]}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{
                    SqrtBox["0.7"], ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", 
                    SqrtBox["0.3"]}], "}"}]}], "}"}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"m", "=", 
        RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], 
      ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"Table", "[", 
        RowBox[{
          RowBox[{"a", "[", 
            RowBox[{"nn", ",", "j", ",", "k", ",", "n"}], "]"}], ",", 
          RowBox[{"{", 
            RowBox[{"nn", ",", "1", ",", "maxnn"}], "}"}], ",", 
          RowBox[{"{", 
            RowBox[{"n", ",", "0", ",", 
              RowBox[{"nn", "-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
            RowBox[{"j", ",", "0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
            RowBox[{"k", ",", "0", ",", "1"}], "}"}]}], "]"}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{"%", "//", "aExpectedForm"}]}], "Input"],

Cell["\<\
List(0.29999999999999993,0,0,0.7000000000000001,0.49000000000000005,\
0,0,0.08999999999999997,0,Complex(0,0.18330302779823365),
   Complex(0,-0.18330302779823365),0,0.026999999999999986,0,0,0.\
3430000000000001,0,Complex(0,-0.26730302779823367),
   Complex(0,0.26730302779823367),0,0.31998181667894016,0,0,-0.\
046624238917527164,0.1029,0,0,0.01889999999999999,0,
   Complex(0,0.26730302779823367),Complex(0,-0.26730302779823367),0,-0.\
16626908835419832,0,0,0.8383115105927853,0,
   Complex(0,-0.3289872716752582),Complex(0,0.3289872716752582),0)\
\>", \
"Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test 3-3", "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"maxnn", "=", "4"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"(*", 
        RowBox[{
        "Construction", " ", "of", " ", "a", " ", "non", " ", "minimal", " ", 
          "set", " ", "of", " ", "measurment", " ", "operators", " ", "that", 
          " ", "are", " ", "not", " ", "diagonal", " ", "in", " ", "the", " ",
           
          RowBox[{"{", 
            RowBox[{
              RowBox[{"|", 
                RowBox[{"0", ">"}]}], ",", 
              RowBox[{"|", 
                RowBox[{"1", ">"}]}]}], "}"}], " ", "basis", " ", "and", " ", 
          "non", " ", 
          RowBox[{"normal", ":"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
        RowBox[{"tmpU", "=", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{
                    RowBox[{"Cos", "[", "\[Theta]", "]"}], ",", 
                    RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{
                    RowBox[{"-", 
                      RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
                    RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "}"}]}], "}"}], "/.",
             
            RowBox[{"\[Theta]", "\[Rule]", "0.37"}]}]}], ";"}], " ", 
      RowBox[{"(*", " ", 
        RowBox[{"Arbitrary", " ", "U"}], " ", "*)"}]}], "\[IndentingNewLine]",
   
    RowBox[{
      RowBox[{
        RowBox[{"tmpW", "=", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{
                    RowBox[{"Cos", "[", "\[Theta]", "]"}], ",", 
                    RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{
                    RowBox[{"-", 
                      RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
                    RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "}"}]}], "}"}], "/.",
             
            RowBox[{"\[Theta]", "\[Rule]", "1.2"}]}]}], ";"}], " ", 
      RowBox[{"(*", " ", 
        RowBox[{"Arbitrary", " ", "basis", " ", "\"\<converter\>\""}], " ", 
        "*)"}]}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmpM1", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{
                    RowBox[{
                      SqrtBox["0.2"], "+", 
                      RowBox[{
                        SqrtBox["0.1"], "I"}]}], ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", 
                    RowBox[{
                      SqrtBox["0.3"], "+", 
                      RowBox[{
                        SqrtBox["0.2"], "I"}]}]}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{
                    RowBox[{
                      SqrtBox["0.1"], "+", 
                      RowBox[{
                        SqrtBox["0.4"], "I"}]}], ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", 
                    SqrtBox["0.4"]}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{
                    RowBox[{
                      SqrtBox["0.2"], "I"}], ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", 
                    RowBox[{
                      SqrtBox["0.05"], "+", 
                      RowBox[{
                        SqrtBox["0.05"], "I"}]}]}], "}"}]}], "}"}]}], "}"}]}],
       ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmpM2", "=", 
        RowBox[{"Map", "[", 
          RowBox[{
            RowBox[{
              RowBox[{"#", ".", "tmpU"}], "&"}], ",", "tmpM1"}], "]"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmpM3", "=", 
        RowBox[{"Map", "[", 
          RowBox[{
            RowBox[{
              RowBox[{
                RowBox[{"adj", "[", "tmpW", "]"}], ".", "#", ".", "tmpW"}], 
              "&"}], ",", "tmpM2"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{
          RowBox[{
            RowBox[{"adj", "[", 
              RowBox[{
              "tmpM3", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}],
               "]"}], ".", 
            RowBox[{
            "tmpM3", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}],
           "+", 
          RowBox[{
            RowBox[{"adj", "[", 
              RowBox[{
              "tmpM3", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
               "]"}], ".", 
            RowBox[{
            "tmpM3", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}],
           "+", 
          RowBox[{
            RowBox[{"adj", "[", 
              RowBox[{
              "tmpM3", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}],
               "]"}], ".", 
            RowBox[{
            "tmpM3", "\[LeftDoubleBracket]", "3", 
              "\[RightDoubleBracket]"}]}]}], "//", "terseForm"}], " ", 
      RowBox[{"(*", " ", 
        RowBox[{"Completeness", " ", "check"}], " ", 
        "*)"}]}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"Map", "[", 
        RowBox[{
          RowBox[{
            RowBox[{"terseForm", "[", 
              RowBox[{
                RowBox[{
                  RowBox[{"adj", "[", 
                    RowBox[{
                    "tmpM3", "\[LeftDoubleBracket]", "#", 
                      "\[RightDoubleBracket]"}], "]"}], ".", 
                  RowBox[{
                  "tmpM3", "\[LeftDoubleBracket]", "#", 
                    "\[RightDoubleBracket]"}]}], "-", 
                RowBox[{
                  RowBox[{
                  "tmpM3", "\[LeftDoubleBracket]", "#", 
                    "\[RightDoubleBracket]"}], ".", 
                  RowBox[{"adj", "[", 
                    RowBox[{
                    "tmpM3", "\[LeftDoubleBracket]", "#", 
                      "\[RightDoubleBracket]"}], "]"}]}]}], "]"}], "&"}], ",",
           
          RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], "]"}], 
      RowBox[{"(*", " ", 
        RowBox[{"Non", " ", "normality", " ", "test"}], " ", 
        "*)"}]}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"mm", "=", "tmpM3"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{"Map", "[", 
      RowBox[{"terseForm", ",", "mm"}], "]"}]}], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"General", "::", "\<\"spell1\"\>"}], 
      RowBox[{
      ":", " "}], "\<\"Possible spelling error: new symbol name \
\\\"\\!\\(tmpW\\)\\\" is similar to existing symbol \
\\\"\\!\\(tmpU\\)\\\".\"\>"}]], "Message"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\"1.\"\>",
                  1.0,
                  AutoDelete->True], 
                InterpretationBox["\<\"0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\"0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\"1.\"\>",
                  0.99999999999999989,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        (MatrixForm[ #]&)],
      (NumberForm[ #, 2]&)]], "Output"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    InterpretationBox["\<\"0.026\"\>",
                      0.026260501618629362,
                      AutoDelete->True], 
                    InterpretationBox["\<\"0.067\"\>",
                      0.067387052763466404,
                      AutoDelete->True]},
                  {
                    InterpretationBox["\<\"0.067\"\>",
                      0.067387052763466404,
                      AutoDelete->True], 
                    InterpretationBox["\<\"-0.026\"\>",
                      -0.026260501618629362,
                      AutoDelete->True]}
                  }], "\[NoBreak]", ")"}],
            (MatrixForm[ #]&)],
          (NumberForm[ #, 2]&)], ",", 
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    InterpretationBox["\<\"-0.013\"\>",
                      -0.013130250809314681,
                      AutoDelete->True], 
                    InterpretationBox["\<\"-0.034\"\>",
                      -0.033693526381733195,
                      AutoDelete->True]},
                  {
                    InterpretationBox["\<\"-0.034\"\>",
                      -0.033693526381733195,
                      AutoDelete->True], 
                    InterpretationBox["\<\"0.013\"\>",
                      0.013130250809314681,
                      AutoDelete->True]}
                  }], "\[NoBreak]", ")"}],
            (MatrixForm[ #]&)],
          (NumberForm[ #, 2]&)], ",", 
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    InterpretationBox["\<\"-0.013\"\>",
                      -0.013130250809314709,
                      AutoDelete->True], 
                    InterpretationBox["\<\"-0.034\"\>",
                      -0.033693526381733195,
                      AutoDelete->True]},
                  {
                    InterpretationBox["\<\"-0.034\"\>",
                      -0.033693526381733195,
                      AutoDelete->True], 
                    InterpretationBox["\<\"0.013\"\>",
                      0.013130250809314709,
                      AutoDelete->True]}
                  }], "\[NoBreak]", ")"}],
            (MatrixForm[ #]&)],
          (NumberForm[ #, 2]&)]}], "}"}]], "Output"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    RowBox[{
                      InterpretationBox["\<\"0.51\"\>",
                        0.51062771578785471,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.42\"\>",
                          0.41691166777458855,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}], 
                    RowBox[{
                      InterpretationBox["\<\"0.16\"\>",
                        0.16164473899988241,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.11\"\>",
                          0.11425562152679138,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}]},
                  {
                    RowBox[{
                      InterpretationBox["\<\"-0.2\"\>",
                        -0.19813952774662302,
                        AutoDelete->True], "-", 
                      RowBox[{
                        InterpretationBox["\<\"0.16\"\>",
                          0.16181655619802346,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}], 
                    RowBox[{
                      InterpretationBox["\<\"0.42\"\>",
                        0.41697846679089179,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.29\"\>",
                          0.29486559033422266,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}]}
                  }], "\[NoBreak]", ")"}],
            (MatrixForm[ #]&)],
          (NumberForm[ #, 2]&)], ",", 
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    RowBox[{
                      InterpretationBox["\<\"0.59\"\>",
                        0.58956433824159116,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.00018\"\>",
                          0.00018249830643637743,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}], 
                    RowBox[{
                      InterpretationBox["\<\"0.11\"\>",
                        0.11411813355002595,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.23\"\>",
                          0.22917509372992317,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}]},
                  {
                    RowBox[{
                      InterpretationBox["\<\"-0.23\"\>",
                        -0.2289403870724554,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.00047\"\>",
                          0.0004694133149356004,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}], 
                    RowBox[{
                      InterpretationBox["\<\"0.29\"\>",
                        0.29491904285062281,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.59\"\>",
                          0.58947308908837293,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}]}
                  }], "\[NoBreak]", ")"}],
            (MatrixForm[ #]&)],
          (NumberForm[ #, 2]&)], ",", 
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    RowBox[{
                      InterpretationBox["\<\"0.21\"\>",
                        0.20841020931068516,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.21\"\>",
                          0.20853925510072138,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}], 
                    RowBox[{
                      InterpretationBox["\<\"-0.00017\"\>",
                        -0.00016596266908511118,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.16\"\>",
                          0.16188530018640618,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}]},
                  {
                    RowBox[{
                      InterpretationBox["\<\"-0.081\"\>",
                        -0.081025631427745645,
                        AutoDelete->True], "-", 
                      RowBox[{
                        InterpretationBox["\<\"0.081\"\>",
                          0.080693706089575434,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}], 
                    RowBox[{
                      InterpretationBox["\<\"0.000065\"\>",
                        6.4522895018113581*^-05,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.42\"\>",
                          0.41688494151638844,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}]}
                  }], "\[NoBreak]", ")"}],
            (MatrixForm[ #]&)],
          (NumberForm[ #, 2]&)]}], "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{
      RowBox[{"m", "=", 
        RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "0", ",", "1"}], "}"}]}], 
      ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"Table", "[", 
        RowBox[{
          RowBox[{"a", "[", 
            RowBox[{"nn", ",", "j", ",", "k", ",", "n"}], "]"}], ",", 
          RowBox[{"{", 
            RowBox[{"nn", ",", "1", ",", "maxnn"}], "}"}], ",", 
          RowBox[{"{", 
            RowBox[{"n", ",", "0", ",", 
              RowBox[{"nn", "-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
            RowBox[{"j", ",", "0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
            RowBox[{"k", ",", "0", ",", "1"}], "}"}]}], "]"}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{"%", "//", "aExpectedForm"}]}], "Input"],

Cell["\<\
List(Complex(0.4131303142229378,0.),Complex(0.03377315902755754,1.\
4474099002681484e-17),
   Complex(0.03377315902755754,-1.4474099002681484e-17),Complex(0.\
48686968577706224,0.),
   Complex(0.05542523137881421,-4.336808689942018e-19),Complex(0.\
013962497266955363,-0.0033831836806572833),
   Complex(0.013962497266955358,0.003383183680657284),Complex(0.\
07589318361158269,-2.168404344971009e-19),
   Complex(0.004980823044179201,0.),Complex(0.005437494917197222,0.\
007373937155412444),
   Complex(0.0054374949171972255,-0.007373937155412444),Complex(-0.\
004980823044179204,0.),
   Complex(0.038725483787603834,1.5178830414797062e-18),Complex(-0.\
0032782892601158275,0.0016817220440947572),
   Complex(-0.003278289260115825,-0.0016817220440947574),Complex(0.\
015844227353539027,-1.0842021724855044e-19),
   Complex(-0.0034658564798619447,-1.734723475976807e-18),Complex(0.\
0044613850830433595,0.005204334674197678),
   Complex(0.0044613850830433595,-0.005204334674197671),Complex(0.\
001114689370063154,6.505213034913027e-19),
   Complex(0.08240980075622012,8.673617379884035e-19),Complex(-0.\
005004768900063371,-0.002904238702087317),
   Complex(-0.00500476890006337,0.002904238702087316),Complex(0.\
030165632338587073,0.),
   Complex(0.00714968639712729,-3.2526065174565133e-19),Complex(0.\
0034151786645528264,0.0009822580120803055),
   Complex(0.0034151786645528264,-0.0009822580120803057),Complex(0.\
01855022286941175,9.215718466126788e-19),
   Complex(-0.005878699795220079,1.0842021724855044e-18),Complex(-0.\
009380804950285763,-0.007405271755125103),
   Complex(-0.009380804950285766,0.0074052717551251),Complex(0.\
004256014155337184,-1.734723475976807e-18),
   Complex(0.03468265202784297,1.5178830414797062e-18),Complex(0.\
005598400498817116,0.005149242407666943),
   Complex(0.005598400498817121,-0.005149242407666942),Complex(0.\
040958621797094044,4.336808689942018e-19),
   Complex(-0.01947398912537008,4.336808689942018e-19),Complex(-0.\
01567714975255359,-0.015091260521075909),
   Complex(-0.015677149752553597,0.015091260521075907),Complex(0.\
01907702963070273,-2.168404344971009e-18))\
\>", "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{"mm", "//", 
      RowBox[{
        RowBox[{"NumberForm", "[", 
          RowBox[{"#", ",", "2"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
    RowBox[{"%", "//", "aExpectedForm"}]}], "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"{", 
        RowBox[{
          RowBox[{"{", 
            RowBox[{
              RowBox[{"{", 
                RowBox[{
                  RowBox[{
                    InterpretationBox["\<\"0.51\"\>",
                      0.51062771578785471,
                      AutoDelete->True], "+", 
                    RowBox[{
                      InterpretationBox["\<\"0.42\"\>",
                        0.41691166777458855,
                        AutoDelete->True], " ", "\[ImaginaryI]"}]}], ",", 
                  RowBox[{
                    InterpretationBox["\<\"0.16\"\>",
                      0.16164473899988241,
                      AutoDelete->True], "+", 
                    RowBox[{
                      InterpretationBox["\<\"0.11\"\>",
                        0.11425562152679138,
                        AutoDelete->True], " ", "\[ImaginaryI]"}]}]}], "}"}], 
              ",", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{
                    InterpretationBox["\<\"-0.2\"\>",
                      -0.19813952774662302,
                      AutoDelete->True], "-", 
                    RowBox[{
                      InterpretationBox["\<\"0.16\"\>",
                        0.16181655619802346,
                        AutoDelete->True], " ", "\[ImaginaryI]"}]}], ",", 
                  RowBox[{
                    InterpretationBox["\<\"0.42\"\>",
                      0.41697846679089179,
                      AutoDelete->True], "+", 
                    RowBox[{
                      InterpretationBox["\<\"0.29\"\>",
                        0.29486559033422266,
                        AutoDelete->True], " ", "\[ImaginaryI]"}]}]}], 
                "}"}]}], "}"}], ",", 
          RowBox[{"{", 
            RowBox[{
              RowBox[{"{", 
                RowBox[{
                  RowBox[{
                    InterpretationBox["\<\"0.59\"\>",
                      0.58956433824159116,
                      AutoDelete->True], "+", 
                    RowBox[{
                      InterpretationBox["\<\"0.00018\"\>",
                        0.00018249830643637743,
                        AutoDelete->True], " ", "\[ImaginaryI]"}]}], ",", 
                  RowBox[{
                    InterpretationBox["\<\"0.11\"\>",
                      0.11411813355002595,
                      AutoDelete->True], "+", 
                    RowBox[{
                      InterpretationBox["\<\"0.23\"\>",
                        0.22917509372992317,
                        AutoDelete->True], " ", "\[ImaginaryI]"}]}]}], "}"}], 
              ",", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{
                    InterpretationBox["\<\"-0.23\"\>",
                      -0.2289403870724554,
                      AutoDelete->True], "+", 
                    RowBox[{
                      InterpretationBox["\<\"0.00047\"\>",
                        0.0004694133149356004,
                        AutoDelete->True], " ", "\[ImaginaryI]"}]}], ",", 
                  RowBox[{
                    InterpretationBox["\<\"0.29\"\>",
                      0.29491904285062281,
                      AutoDelete->True], "+", 
                    RowBox[{
                      InterpretationBox["\<\"0.59\"\>",
                        0.58947308908837293,
                        AutoDelete->True], " ", "\[ImaginaryI]"}]}]}], 
                "}"}]}], "}"}], ",", 
          RowBox[{"{", 
            RowBox[{
              RowBox[{"{", 
                RowBox[{
                  RowBox[{
                    InterpretationBox["\<\"0.21\"\>",
                      0.20841020931068516,
                      AutoDelete->True], "+", 
                    RowBox[{
                      InterpretationBox["\<\"0.21\"\>",
                        0.20853925510072138,
                        AutoDelete->True], " ", "\[ImaginaryI]"}]}], ",", 
                  RowBox[{
                    InterpretationBox["\<\"-0.00017\"\>",
                      -0.00016596266908511118,
                      AutoDelete->True], "+", 
                    RowBox[{
                      InterpretationBox["\<\"0.16\"\>",
                        0.16188530018640618,
                        AutoDelete->True], " ", "\[ImaginaryI]"}]}]}], "}"}], 
              ",", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{
                    InterpretationBox["\<\"-0.081\"\>",
                      -0.081025631427745645,
                      AutoDelete->True], "-", 
                    RowBox[{
                      InterpretationBox["\<\"0.081\"\>",
                        0.080693706089575434,
                        AutoDelete->True], " ", "\[ImaginaryI]"}]}], ",", 
                  RowBox[{
                    InterpretationBox["\<\"0.000065\"\>",
                      6.4522895018113581*^-05,
                      AutoDelete->True], "+", 
                    RowBox[{
                      InterpretationBox["\<\"0.42\"\>",
                        0.41688494151638844,
                        AutoDelete->True], " ", "\[ImaginaryI]"}]}]}], 
                "}"}]}], "}"}]}], "}"}],
      (NumberForm[ #, 2]&)]], "Output"],

Cell["\<\
List(Complex(0.5106277157878547,0.41691166777458855),Complex(0.\
1616447389998824,0.11425562152679138),
   Complex(-0.19813952774662302,-0.16181655619802346),Complex(0.\
4169784667908918,0.29486559033422266),
   Complex(0.5895643382415912,0.00018249830643637743),Complex(0.\
11411813355002595,0.22917509372992317),
   Complex(-0.2289403870724554,0.0004694133149356004),Complex(0.\
2949190428506228,0.5894730890883729),
   Complex(0.20841020931068516,0.20853925510072138),Complex(-0.\
00016596266908511118,0.16188530018640618),
   Complex(-0.08102563142774565,-0.08069370608957543),Complex(0.\
00006452289501811358,0.41688494151638844))\
\>", "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test 4", "Subsection"],

Cell[CellGroupData[{

Cell[TextData[{
  "Function for calculating ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          OverscriptBox[
            OverscriptBox["E", "~"], "_"], "(", 
          OverscriptBox["m", "\[RightVector]"], ")"}], TraditionalForm]]],
  " (called eetb here) directly"
}], "Subsubsection"],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{"mmm", "=", 
          RowBox[{"M", "(", 
            RowBox[{
              OverscriptBox["m", "\[RightVector]"], ",", "\[CurlyPhi]"}], 
            ")"}]}], TraditionalForm]]],
  ", ",
  Cell[BoxData[
      FormBox[
        RowBox[{"mm", "=", 
          RowBox[{"{", 
            RowBox[{
              SubscriptBox["M", "0"], ",", 
              SubscriptBox["M", "1"], ",", "\[Ellipsis]"}], "}"}]}], 
        TraditionalForm]]],
  ", ",
  Cell[BoxData[
      FormBox[
        RowBox[{"ee", "=", 
          RowBox[{"E", "(", 
            RowBox[{
              OverscriptBox["m", "\[RightVector]"], ",", "\[CurlyPhi]"}], 
            ")"}]}], TraditionalForm]]],
  ", ",
  Cell[BoxData[
      FormBox[
        RowBox[{"eet", "=", 
          RowBox[{
            OverscriptBox["E", "~"], "(", 
            RowBox[{
              OverscriptBox["m", "\[RightVector]"], ",", "\[CurlyPhi]"}], 
            ")"}]}], TraditionalForm]]],
  ", ",
  Cell[BoxData[
      FormBox[
        RowBox[{"nn", "=", "N"}], TraditionalForm]]],
  "."
}], "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{"u", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                RowBox[{"Cos", "[", "\[CurlyPhi]", "]"}], ",", 
                RowBox[{"I", " ", 
                  RowBox[{"Sin", "[", "\[CurlyPhi]", "]"}]}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"I", " ", 
                  RowBox[{"Sin", "[", "\[CurlyPhi]", "]"}]}], ",", 
                RowBox[{"Cos", "[", "\[CurlyPhi]", "]"}]}], "}"}]}], "}"}]}], 
      ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"mmmDirect", "[", "nn_", "]"}], ":=", 
      RowBox[{"If", "[", 
        RowBox[{
          RowBox[{"nn", "\[LessEqual]", "1"}], ",", 
          RowBox[{"mm", "\[LeftDoubleBracket]", 
            RowBox[{
              RowBox[{
              "m", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
              "+", "1"}], "\[RightDoubleBracket]"}], ",", 
          RowBox[{
            RowBox[{"mm", "\[LeftDoubleBracket]", 
              RowBox[{
                RowBox[{
                "m", "\[LeftDoubleBracket]", "nn", "\[RightDoubleBracket]"}], 
                "+", "1"}], "\[RightDoubleBracket]"}], ".", "u", ".", 
            RowBox[{"mmmDirect", "[", 
              RowBox[{"nn", "-", "1"}], "]"}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eeDirect", "[", "nn_", "]"}], ":=", 
      RowBox[{"ComplexExpand", "[", 
        RowBox[{
          RowBox[{
            RowBox[{"adj", "[", 
              RowBox[{"mmmDirect", "[", "nn", "]"}], "]"}], ".", 
            RowBox[{"mmmDirect", "[", "nn", "]"}]}], ",", 
          RowBox[{"\[CurlyPhi]", "\[GreaterEqual]", "0"}]}], "]"}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eetDirect", "[", "nn_", "]"}], ":=", 
      RowBox[{"ComplexExpand", "[", 
        RowBox[{
          RowBox[{
            RowBox[{"mmmDirect", "[", "nn", "]"}], ".", 
            RowBox[{"adj", "[", 
              RowBox[{"mmmDirect", "[", "nn", "]"}], "]"}]}], ",", 
          RowBox[{"\[CurlyPhi]", "\[GreaterEqual]", "0"}]}], "]"}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eetbDirect", "[", "nn_", "]"}], ":=", 
      RowBox[{
        RowBox[{"1", "/", 
          RowBox[{"(", 
            RowBox[{"2", "\[Pi]"}], ")"}]}], " ", "*", " ", 
        RowBox[{"Integrate", "[", 
          RowBox[{
            RowBox[{"eetDirect", "[", "nn", "]"}], ",", 
            RowBox[{"{", 
              RowBox[{"\[CurlyPhi]", ",", "0", ",", 
                RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}]}]}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Function for calculating the guess", "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"guess", "[", "nn_", "]"}], ":=", 
        RowBox[{
          RowBox[{
            RowBox[{"eetbDirect", "[", "nn", "]"}], "\[LeftDoubleBracket]", 
            RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}], "/", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                RowBox[{"eetbDirect", "[", "nn", "]"}], 
                "\[LeftDoubleBracket]", 
                RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "+", 
              RowBox[{
                RowBox[{"eetbDirect", "[", "nn", "]"}], 
                "\[LeftDoubleBracket]", 
                RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]}], 
            ")"}]}]}], ";"}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test 4-1", "Subsubsection"],

Cell[BoxData[{
    RowBox[{
      RowBox[{"mm", "=", 
        RowBox[{"{", 
          RowBox[{"{", 
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{"0", ",", "1"}], "}"}]}], "}"}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"m", "=", 
        RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
      ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"Table", "[", 
          RowBox[{
            RowBox[{"2", "\[Pi]", " ", 
              RowBox[{
                RowBox[{"eetbDirect", "[", "nn", "]"}], 
                "\[LeftDoubleBracket]", 
                RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], ",", 
            RowBox[{"{", 
              RowBox[{"nn", ",", "1", ",", "4"}], "}"}]}], "]"}], "//", "N"}],
       "//", "Chop"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"Table", "[", 
          RowBox[{
            RowBox[{"2", "\[Pi]", " ", 
              RowBox[{
                RowBox[{"eetbDirect", "[", "nn", "]"}], 
                "\[LeftDoubleBracket]", 
                RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]}], ",", 
            RowBox[{"{", 
              RowBox[{"nn", ",", "1", ",", "4"}], "}"}]}], "]"}], "//", "N"}],
       "//", "Chop"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"Table", "[", 
          RowBox[{
            RowBox[{"guess", "[", "nn", "]"}], ",", 
            RowBox[{"{", 
              RowBox[{"nn", ",", "1", ",", "4"}], "}"}]}], "]"}], "//", "N"}],
       "//", "Chop"}]}], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
      "6.283185307179586`", ",", "6.283185307179586`", ",", 
        "6.283185307179586`", ",", "6.283185307179586`"}], "}"}]], "Output"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
      "6.283185307179586`", ",", "6.283185307179586`", ",", 
        "6.283185307179586`", ",", "6.283185307179586`"}], "}"}]], "Output"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"0.5`", ",", "0.5`", ",", "0.5`", ",", "0.5`"}], 
      "}"}]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test 4-2", "Subsubsection"],

Cell[BoxData[{
    RowBox[{
      RowBox[{"mm", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{
                    SqrtBox["0.3"], ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", 
                    SqrtBox["0.7"]}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{
                    SqrtBox["0.7"], ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", 
                    SqrtBox["0.3"]}], "}"}]}], "}"}]}], "}"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"m", "=", 
        RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], 
      ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{
        RowBox[{"Table", "[", 
          RowBox[{
            RowBox[{"2", "\[Pi]", " ", 
              RowBox[{
                RowBox[{"eetbDirect", "[", "nn", "]"}], 
                "\[LeftDoubleBracket]", 
                RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], ",", 
            RowBox[{"{", 
              RowBox[{"nn", ",", "1", ",", "4"}], "}"}]}], "]"}], "//", "N"}],
       "//", "Chop"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"Table", "[", 
          RowBox[{
            RowBox[{"2", "\[Pi]", " ", 
              RowBox[{
                RowBox[{"eetbDirect", "[", "nn", "]"}], 
                "\[LeftDoubleBracket]", 
                RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]}], ",", 
            RowBox[{"{", 
              RowBox[{"nn", ",", "1", ",", "4"}], "}"}]}], "]"}], "//", "N"}],
       "//", "Chop"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"Table", "[", 
          RowBox[{
            RowBox[{"guess", "[", "nn", "]"}], ",", 
            RowBox[{"{", 
              RowBox[{"nn", ",", "1", ",", "4"}], "}"}]}], "]"}], "//", "N"}],
       "//", "Chop"}]}], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
      "1.8849555921538754`", ",", "2.199114857512855`", ",", 
        "0.4633706352575295`", ",", "0.24866705533450736`"}], "}"}]], "Output"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
      "4.39822971502571`", ",", "0.9424777960769377`", ",", 
        "1.1179167085786192`", ",", "0.5266780115714534`"}], "}"}]], "Output"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
      "0.7000000000000001`", ",", "0.29999999999999993`", ",", 
        "0.7069662025287521`", ",", "0.6792820823290703`"}], "}"}]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test 4-3", "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"maxnn", "=", "4"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"(*", 
        RowBox[{
        "Construction", " ", "of", " ", "a", " ", "non", " ", "minimal", " ", 
          "set", " ", "of", " ", "measurment", " ", "operators", " ", "that", 
          " ", "are", " ", "not", " ", "diagonal", " ", "in", " ", "the", " ",
           
          RowBox[{"{", 
            RowBox[{
              RowBox[{"|", 
                RowBox[{"0", ">"}]}], ",", 
              RowBox[{"|", 
                RowBox[{"1", ">"}]}]}], "}"}], " ", "basis", " ", "and", " ", 
          "non", " ", 
          RowBox[{"normal", ":"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
        RowBox[{"tmpU", "=", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{
                    RowBox[{"Cos", "[", "\[Theta]", "]"}], ",", 
                    RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{
                    RowBox[{"-", 
                      RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
                    RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "}"}]}], "}"}], "/.",
             
            RowBox[{"\[Theta]", "\[Rule]", "0.37"}]}]}], ";"}], " ", 
      RowBox[{"(*", " ", 
        RowBox[{"Arbitrary", " ", "U"}], " ", "*)"}]}], "\[IndentingNewLine]",
   
    RowBox[{
      RowBox[{
        RowBox[{"tmpW", "=", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{
                    RowBox[{"Cos", "[", "\[Theta]", "]"}], ",", 
                    RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{
                    RowBox[{"-", 
                      RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
                    RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "}"}]}], "}"}], "/.",
             
            RowBox[{"\[Theta]", "\[Rule]", "1.2"}]}]}], ";"}], " ", 
      RowBox[{"(*", " ", 
        RowBox[{"Arbitrary", " ", "basis", " ", "\"\<converter\>\""}], " ", 
        "*)"}]}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmpM1", "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{
                    RowBox[{
                      SqrtBox["0.2"], "+", 
                      RowBox[{
                        SqrtBox["0.1"], "I"}]}], ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", 
                    RowBox[{
                      SqrtBox["0.3"], "+", 
                      RowBox[{
                        SqrtBox["0.2"], "I"}]}]}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{
                    RowBox[{
                      SqrtBox["0.1"], "+", 
                      RowBox[{
                        SqrtBox["0.4"], "I"}]}], ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", 
                    SqrtBox["0.4"]}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{
                    RowBox[{
                      SqrtBox["0.2"], "I"}], ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"0", ",", 
                    RowBox[{
                      SqrtBox["0.05"], "+", 
                      RowBox[{
                        SqrtBox["0.05"], "I"}]}]}], "}"}]}], "}"}]}], "}"}]}],
       ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmpM2", "=", 
        RowBox[{"Map", "[", 
          RowBox[{
            RowBox[{
              RowBox[{"#", ".", "tmpU"}], "&"}], ",", "tmpM1"}], "]"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"tmpM3", "=", 
        RowBox[{"Map", "[", 
          RowBox[{
            RowBox[{
              RowBox[{
                RowBox[{"adj", "[", "tmpW", "]"}], ".", "#", ".", "tmpW"}], 
              "&"}], ",", "tmpM2"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{
          RowBox[{
            RowBox[{"adj", "[", 
              RowBox[{
              "tmpM3", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}],
               "]"}], ".", 
            RowBox[{
            "tmpM3", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}],
           "+", 
          RowBox[{
            RowBox[{"adj", "[", 
              RowBox[{
              "tmpM3", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
               "]"}], ".", 
            RowBox[{
            "tmpM3", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}],
           "+", 
          RowBox[{
            RowBox[{"adj", "[", 
              RowBox[{
              "tmpM3", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}],
               "]"}], ".", 
            RowBox[{
            "tmpM3", "\[LeftDoubleBracket]", "3", 
              "\[RightDoubleBracket]"}]}]}], "//", "terseForm"}], " ", 
      RowBox[{"(*", " ", 
        RowBox[{"Completeness", " ", "check"}], " ", 
        "*)"}]}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"Map", "[", 
        RowBox[{
          RowBox[{
            RowBox[{"terseForm", "[", 
              RowBox[{
                RowBox[{
                  RowBox[{"adj", "[", 
                    RowBox[{
                    "tmpM3", "\[LeftDoubleBracket]", "#", 
                      "\[RightDoubleBracket]"}], "]"}], ".", 
                  RowBox[{
                  "tmpM3", "\[LeftDoubleBracket]", "#", 
                    "\[RightDoubleBracket]"}]}], "-", 
                RowBox[{
                  RowBox[{
                  "tmpM3", "\[LeftDoubleBracket]", "#", 
                    "\[RightDoubleBracket]"}], ".", 
                  RowBox[{"adj", "[", 
                    RowBox[{
                    "tmpM3", "\[LeftDoubleBracket]", "#", 
                      "\[RightDoubleBracket]"}], "]"}]}]}], "]"}], "&"}], ",",
           
          RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], "]"}], 
      RowBox[{"(*", " ", 
        RowBox[{"Non", " ", "normality", " ", "test"}], " ", 
        "*)"}]}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"mm", "=", "tmpM3"}], ";"}], "\[IndentingNewLine]", 
    RowBox[{"Map", "[", 
      RowBox[{"terseForm", ",", "mm"}], "]"}]}], "Input"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\"1.\"\>",
                  1.0,
                  AutoDelete->True], 
                InterpretationBox["\<\"0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\"0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\"1.\"\>",
                  0.99999999999999989,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        (MatrixForm[ #]&)],
      (NumberForm[ #, 2]&)]], "Output"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    InterpretationBox["\<\"0.026\"\>",
                      0.026260501618629362,
                      AutoDelete->True], 
                    InterpretationBox["\<\"0.067\"\>",
                      0.067387052763466404,
                      AutoDelete->True]},
                  {
                    InterpretationBox["\<\"0.067\"\>",
                      0.067387052763466404,
                      AutoDelete->True], 
                    InterpretationBox["\<\"-0.026\"\>",
                      -0.026260501618629362,
                      AutoDelete->True]}
                  }], "\[NoBreak]", ")"}],
            (MatrixForm[ #]&)],
          (NumberForm[ #, 2]&)], ",", 
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    InterpretationBox["\<\"-0.013\"\>",
                      -0.013130250809314681,
                      AutoDelete->True], 
                    InterpretationBox["\<\"-0.034\"\>",
                      -0.033693526381733195,
                      AutoDelete->True]},
                  {
                    InterpretationBox["\<\"-0.034\"\>",
                      -0.033693526381733195,
                      AutoDelete->True], 
                    InterpretationBox["\<\"0.013\"\>",
                      0.013130250809314681,
                      AutoDelete->True]}
                  }], "\[NoBreak]", ")"}],
            (MatrixForm[ #]&)],
          (NumberForm[ #, 2]&)], ",", 
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    InterpretationBox["\<\"-0.013\"\>",
                      -0.013130250809314709,
                      AutoDelete->True], 
                    InterpretationBox["\<\"-0.034\"\>",
                      -0.033693526381733195,
                      AutoDelete->True]},
                  {
                    InterpretationBox["\<\"-0.034\"\>",
                      -0.033693526381733195,
                      AutoDelete->True], 
                    InterpretationBox["\<\"0.013\"\>",
                      0.013130250809314709,
                      AutoDelete->True]}
                  }], "\[NoBreak]", ")"}],
            (MatrixForm[ #]&)],
          (NumberForm[ #, 2]&)]}], "}"}]], "Output"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    RowBox[{
                      InterpretationBox["\<\"0.51\"\>",
                        0.51062771578785471,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.42\"\>",
                          0.41691166777458855,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}], 
                    RowBox[{
                      InterpretationBox["\<\"0.16\"\>",
                        0.16164473899988241,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.11\"\>",
                          0.11425562152679138,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}]},
                  {
                    RowBox[{
                      InterpretationBox["\<\"-0.2\"\>",
                        -0.19813952774662302,
                        AutoDelete->True], "-", 
                      RowBox[{
                        InterpretationBox["\<\"0.16\"\>",
                          0.16181655619802346,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}], 
                    RowBox[{
                      InterpretationBox["\<\"0.42\"\>",
                        0.41697846679089179,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.29\"\>",
                          0.29486559033422266,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}]}
                  }], "\[NoBreak]", ")"}],
            (MatrixForm[ #]&)],
          (NumberForm[ #, 2]&)], ",", 
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    RowBox[{
                      InterpretationBox["\<\"0.59\"\>",
                        0.58956433824159116,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.00018\"\>",
                          0.00018249830643637743,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}], 
                    RowBox[{
                      InterpretationBox["\<\"0.11\"\>",
                        0.11411813355002595,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.23\"\>",
                          0.22917509372992317,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}]},
                  {
                    RowBox[{
                      InterpretationBox["\<\"-0.23\"\>",
                        -0.2289403870724554,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.00047\"\>",
                          0.0004694133149356004,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}], 
                    RowBox[{
                      InterpretationBox["\<\"0.29\"\>",
                        0.29491904285062281,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.59\"\>",
                          0.58947308908837293,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}]}
                  }], "\[NoBreak]", ")"}],
            (MatrixForm[ #]&)],
          (NumberForm[ #, 2]&)], ",", 
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    RowBox[{
                      InterpretationBox["\<\"0.21\"\>",
                        0.20841020931068516,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.21\"\>",
                          0.20853925510072138,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}], 
                    RowBox[{
                      InterpretationBox["\<\"-0.00017\"\>",
                        -0.00016596266908511118,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.16\"\>",
                          0.16188530018640618,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}]},
                  {
                    RowBox[{
                      InterpretationBox["\<\"-0.081\"\>",
                        -0.081025631427745645,
                        AutoDelete->True], "-", 
                      RowBox[{
                        InterpretationBox["\<\"0.081\"\>",
                          0.080693706089575434,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}], 
                    RowBox[{
                      InterpretationBox["\<\"0.000065\"\>",
                        6.4522895018113581*^-05,
                        AutoDelete->True], "+", 
                      RowBox[{
                        InterpretationBox["\<\"0.42\"\>",
                          0.41688494151638844,
                          AutoDelete->True], " ", "\[ImaginaryI]"}]}]}
                  }], "\[NoBreak]", ")"}],
            (MatrixForm[ #]&)],
          (NumberForm[ #, 2]&)]}], "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{
      RowBox[{"m", "=", 
        RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "0", ",", "1"}], "}"}]}], 
      ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"Table", "[", 
        RowBox[{
          RowBox[{"2", "\[Pi]", " ", 
            RowBox[{
              RowBox[{"eetbDirect", "[", "nn", "]"}], "\[LeftDoubleBracket]", 
              
              RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], ",", 
          RowBox[{"{", 
            RowBox[{"nn", ",", "1", ",", "4"}], "}"}]}], "]"}], "//", 
      "Chop"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"Table", "[", 
        RowBox[{
          RowBox[{"2", "\[Pi]", " ", 
            RowBox[{
              RowBox[{"eetbDirect", "[", "nn", "]"}], "\[LeftDoubleBracket]", 
              
              RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]}], ",", 
          RowBox[{"{", 
            RowBox[{"nn", ",", "1", ",", "4"}], "}"}]}], "]"}], "//", 
      "Chop"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        RowBox[{"Table", "[", 
          RowBox[{
            RowBox[{"guess", "[", "nn", "]"}], ",", 
            RowBox[{"{", 
              RowBox[{"nn", ",", "1", ",", "4"}], "}"}]}], "]"}], "//", "N"}],
       "//", "Chop"}]}], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
      "2.5957743202760484`", ",", "0.33418145814053796`", ",", 
        "0.22952240233355853`", ",", "0.07220659170673693`"}], 
      "}"}]], "Output"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
      "3.0590924561855797`", ",", "0.5140823549040302`", ",", 
        "0.10949945378214063`", ",", "0.07955442546747125`"}], 
      "}"}]], "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
Evaluator->"Local",
WindowSize->{1012, 740},
WindowMargins->{{0, Automatic}, {Automatic, 0}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 119, 3, 32, "Text"],
Cell[1839, 54, 198, 5, 27, "Input"],
Cell[2040, 61, 401, 10, 27, "Input"],

Cell[CellGroupData[{
Cell[2466, 75, 28, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[2519, 79, 1182, 32, 75, "Input"],
Cell[3704, 113, 449, 14, 78, "Output"],
Cell[4156, 129, 552, 14, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[4757, 149, 28, 0, 45, "Subsection"],
Cell[4788, 151, 515, 15, 45, "Input"],

Cell[CellGroupData[{
Cell[5328, 170, 561, 15, 43, "Input"],
Cell[5892, 187, 2687, 66, 112, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8616, 258, 2389, 66, 121, "Input"],
Cell[11008, 326, 261, 6, 22, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11306, 337, 313, 9, 43, "Input"],
Cell[11622, 348, 39, 0, 40, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[11710, 354, 28, 0, 45, "Subsection"],
Cell[11741, 356, 6813, 130, 163, "Input"],
Cell[18557, 488, 202, 5, 27, "Input"],

Cell[CellGroupData[{
Cell[18784, 497, 33, 0, 42, "Subsubsection"],
Cell[18820, 499, 562, 17, 59, "Input"],

Cell[CellGroupData[{
Cell[19407, 520, 598, 15, 43, "Input"],
Cell[20008, 537, 2534, 70, 43, "Output"],
Cell[22545, 609, 113, 3, 40, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[22707, 618, 33, 0, 42, "Subsubsection"],
Cell[22743, 620, 953, 28, 73, "Input"],

Cell[CellGroupData[{
Cell[23721, 652, 644, 16, 43, "Input"],
Cell[24368, 670, 575, 11, 100, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[24992, 687, 33, 0, 42, "Subsubsection"],
Cell[25028, 689, 78, 2, 27, "Input"],

Cell[CellGroupData[{
Cell[25131, 695, 6538, 173, 185, "Input"],
Cell[31672, 870, 256, 6, 22, "Message"],
Cell[31931, 878, 666, 20, 58, "Output"],
Cell[32600, 900, 2474, 62, 45, "Output"],
Cell[35077, 964, 5447, 122, 45, "Output"]
}, Open  ]],
Cell[40539, 1089, 161, 5, 27, "Input"],

Cell[CellGroupData[{
Cell[40725, 1098, 644, 16, 43, "Input"],
Cell[41372, 1116, 2145, 41, 325, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[43554, 1162, 218, 5, 43, "Input"],
Cell[43775, 1169, 5282, 124, 56, "Output"],
Cell[49060, 1295, 661, 13, 115, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[49782, 1315, 28, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[49835, 1319, 297, 9, 47, "Subsubsection"],
Cell[50135, 1330, 1106, 39, 33, "Text"],
Cell[51244, 1371, 571, 15, 27, "Input"],
Cell[51818, 1388, 780, 18, 27, "Input"],
Cell[52601, 1408, 389, 9, 27, "Input"],
Cell[52993, 1419, 390, 9, 27, "Input"],
Cell[53386, 1430, 469, 12, 27, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[53892, 1447, 59, 0, 42, "Subsubsection"],
Cell[53954, 1449, 747, 18, 27, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[54738, 1472, 33, 0, 42, "Subsubsection"],
Cell[54774, 1474, 483, 15, 43, "Input"],

Cell[CellGroupData[{
Cell[55282, 1493, 1218, 32, 59, "Input"],
Cell[56503, 1527, 184, 4, 27, "Output"],
Cell[56690, 1533, 184, 4, 27, "Output"],
Cell[56877, 1539, 119, 3, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[57045, 1548, 33, 0, 42, "Subsubsection"],
Cell[57081, 1550, 874, 26, 55, "Input"],

Cell[CellGroupData[{
Cell[57980, 1580, 1218, 32, 59, "Input"],
Cell[59201, 1614, 188, 4, 27, "Output"],
Cell[59392, 1620, 186, 4, 27, "Output"],
Cell[59581, 1626, 189, 4, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[59819, 1636, 33, 0, 42, "Subsubsection"],
Cell[59855, 1638, 78, 2, 27, "Input"],

Cell[CellGroupData[{
Cell[59958, 1644, 6538, 173, 185, "Input"],
Cell[66499, 1819, 666, 20, 58, "Output"],
Cell[67168, 1841, 2474, 62, 45, "Output"],
Cell[69645, 1905, 5447, 122, 45, "Output"]
}, Open  ]],
Cell[75107, 2030, 161, 5, 27, "Input"],

Cell[CellGroupData[{
Cell[75293, 2039, 1126, 30, 59, "Input"],
Cell[76422, 2071, 198, 5, 27, "Output"],
Cell[76623, 2078, 197, 5, 27, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

